/*===========================================================================*/
/*   (Cfa/closure.scm)                                                       */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/closure.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_svarz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
	}              *BgL_svarz00_bglt;

	typedef struct BgL_scnstz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_nodez00;
		obj_t BgL_classz00;
		obj_t BgL_locz00;
	}               *BgL_scnstz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
		obj_t BgL_dupz00;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_internzd2sfunzf2cinfoz20_bgl
	{
		bool_t BgL_polymorphiczf3zf3;
		struct BgL_approxz00_bgl *BgL_approxz00;
		long BgL_stampz00;
	}                               *BgL_internzd2sfunzf2cinfoz20_bglt;

	typedef struct BgL_svarzf2cinfozf2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		bool_t BgL_clozd2envzf3z21;
		long BgL_stampz00;
	}                      *BgL_svarzf2cinfozf2_bglt;

	typedef struct BgL_makezd2procedurezd2appz00_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_valueszd2approxzd2;
		long BgL_lostzd2stampzd2;
		bool_t BgL_xzd2tzf3z21;
		bool_t BgL_xz00;
		bool_t BgL_tz00;
		struct BgL_variablez00_bgl *BgL_ownerz00;
		obj_t BgL_stackzd2stampzd2;
	}                                *BgL_makezd2procedurezd2appz00_bglt;


	extern obj_t BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_approxz00_bglt,
		obj_t);
	static bool_t BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00();
	extern obj_t BGl_setzd2lengthzd2zzcfa_setz00(obj_t);
	static obj_t BGl_z62getzd2procedurezd2listz62zzcfa_closurez00(obj_t);
	static bool_t BGl_mergezd2appzd2typesz12z12zzcfa_closurez00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(BgL_nodez00_bglt);
	static obj_t BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00(obj_t);
	static obj_t BGl_objectzd2initzd2zzcfa_closurez00();
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2funcallz12zc0zzcfa_closurez00(BgL_nodez00_bglt);
	extern obj_t BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00(obj_t,
		BgL_approxz00_bglt);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_closurez00();
	extern BgL_typez00_bglt
		BGl_getzd2bigloozd2typez00zztype_cachez00(BgL_typez00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_typezd2closuresz12zc0zzcfa_closurez00();
	BGL_EXPORTED_DECL obj_t
		BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00();
	extern obj_t
		BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t
		BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(BgL_nodez00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_getzd2procedurezd2listz00zzcfa_closurez00();
	static bool_t BGl_showze70ze7zzcfa_closurez00(obj_t, obj_t);
	static obj_t BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BUNSPEC;
	extern obj_t BGl_lightzd2typez12zc0zzcfa_ltypez00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_stopzd2closurezd2cachez00zzcfa_closurez00();
	static obj_t BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00(obj_t,
		obj_t);
	static obj_t BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00(obj_t);
	static obj_t BGl_z62addzd2funcallz12za2zzcfa_closurez00(obj_t, obj_t);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	static obj_t BGl_gczd2rootszd2initz00zzcfa_closurez00();
	static obj_t BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00(obj_t, obj_t);
	static bool_t BGl_lightzd2funcallz12zc0zzcfa_closurez00();
	extern obj_t BGl_makezd2procedurezd2appz00zzcfa_info2z00;
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	static obj_t BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BUNSPEC;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern BgL_typez00_bglt
		BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00(BgL_typez00_bglt);
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	static obj_t BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_closurez00 = BUNSPEC;
	extern obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(BgL_nodez00_bglt);
	static obj_t BGl_toplevelzd2initzd2zzcfa_closurez00();
	extern obj_t BGl_setzd2ze3listz31zzcfa_setz00(obj_t);
	static obj_t BGl_genericzd2initzd2zzcfa_closurez00();
	static obj_t BGl_showzd2Xzd2Tz00zzcfa_closurez00(obj_t);
	static obj_t BGl_z62typezd2closuresz12za2zzcfa_closurez00(obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	static obj_t BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t
		BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(BgL_approxz00_bglt);
	static obj_t BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 = BUNSPEC;
	static bool_t BGl_Xz12z12zzcfa_closurez00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00(obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzcfa_closurez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_ltypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	static obj_t BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 = BUNSPEC;
	static bool_t BGl_lightzd2accessz12zc0zzcfa_closurez00();
	static obj_t BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_cnstzd2initzd2zzcfa_closurez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_closurez00();
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_closurez00();
	extern obj_t BGl_scnstz00zzast_varz00;
	static obj_t BGl_startzd2closurezd2cachez00zzcfa_closurez00();
	static obj_t BGl_za2funcallzd2listza2zd2zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31663ze3ze5zzcfa_closurez00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31647ze3ze5zzcfa_closurez00(obj_t,
		obj_t);
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	static obj_t BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00(obj_t,
		obj_t);
	extern obj_t BGl_za2procedurezd2elza2zd2zztype_cachez00;
	static bool_t BGl_mergezd2appzd2returnzd2typesz12zc0zzcfa_closurez00(obj_t,
		BgL_approxz00_bglt);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t __cnst[20];


	   
		 
		DEFINE_STRING(BGl_string2194z00zzcfa_closurez00,
		BgL_bgl_string2194za700za7za7c2204za7, "   . Light closures", 19);
	      DEFINE_STRING(BGl_string2197z00zzcfa_closurez00,
		BgL_bgl_string2197za700za7za7c2205za7, ": ", 2);
	      DEFINE_STRING(BGl_string2198z00zzcfa_closurez00,
		BgL_bgl_string2198za700za7za7c2206za7, "      ", 6);
	      DEFINE_STRING(BGl_string2199z00zzcfa_closurez00,
		BgL_bgl_string2199za700za7za7c2207za7, "        ", 8);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_addzd2makezd2procedurez12zd2envzc0zzcfa_closurez00,
		BgL_bgl_za762addza7d2makeza7d22208za7,
		BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2funcallz12zd2envz12zzcfa_closurez00,
		BgL_bgl_za762addza7d2funcall2209z00,
		BGl_z62addzd2funcallz12za2zzcfa_closurez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2200z00zzcfa_closurez00,
		BgL_bgl_string2200za700za7za7c2210za7, "cfa_closure", 11);
	      DEFINE_STRING(BGl_string2201z00zzcfa_closurez00,
		BgL_bgl_string2201za700za7za7c2211za7,
		"make-l-procedure make-el-procedure procedure-el-set! procedure-el-ref procedure-l-set! procedure-l-ref procedure-set! foreign procedure-ref T X nothing-to-do slfun selfun done ok \077\077? light elight static ",
		203);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2195z00zzcfa_closurez00,
		BgL_bgl_za762za7c3za704anonymo2212za7,
		BGl_z62zc3z04anonymousza31647ze3ze5zzcfa_closurez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2196z00zzcfa_closurez00,
		BgL_bgl_za762za7c3za704anonymo2213za7,
		BGl_z62zc3z04anonymousza31663ze3ze5zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_addzd2procedurezd2refz12zd2envzc0zzcfa_closurez00,
		BgL_bgl_za762addza7d2procedu2214z00,
		BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2procedurezd2listzd2envzd2zzcfa_closurez00,
		BgL_bgl_za762getza7d2procedu2215z00,
		BGl_z62getzd2procedurezd2listz62zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_typezd2closuresz12zd2envz12zzcfa_closurez00,
		BgL_bgl_za762typeza7d2closur2216z00,
		BGl_z62typezd2closuresz12za2zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_closurezd2optimiza7ationzf3zd2envz54zzcfa_closurez00,
		BgL_bgl_za762closureza7d2opt2217z00,
		BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_stopzd2closurezd2cachezd2envzd2zzcfa_closurez00,
		BgL_bgl_za762stopza7d2closur2218z00,
		BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_closurezd2optimiza7ationz12zd2envzb5zzcfa_closurez00,
		BgL_bgl_za762closureza7d2opt2219z00,
		BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_approxzd2procedurezd2elzf3zd2envz21zzcfa_closurez00,
		BgL_bgl_za762approxza7d2proc2220z00,
		BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00));
		     ADD_ROOT((void
				*) (&BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00));
		     ADD_ROOT((void *) (&BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00));
		     ADD_ROOT((void *) (&BGl_za2procedurezd2refza2zd2zzcfa_closurez00));
		     ADD_ROOT((void *) (&BGl_za2funcallzd2listza2zd2zzcfa_closurez00));
		     ADD_ROOT((void *) (&BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00));
		   
			 ADD_ROOT((void *) (&BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcfa_closurez00(long
		BgL_checksumz00_4155, char *BgL_fromz00_4156)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_closurez00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_closurez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcfa_closurez00();
					BGl_libraryzd2moduleszd2initz00zzcfa_closurez00();
					BGl_cnstzd2initzd2zzcfa_closurez00();
					BGl_importedzd2moduleszd2initz00zzcfa_closurez00();
					return BGl_toplevelzd2initzd2zzcfa_closurez00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "cfa_closure");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"cfa_closure");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			{	/* Cfa/closure.scm 25 */
				obj_t BgL_cportz00_4143;

				{	/* Cfa/closure.scm 25 */
					obj_t BgL_stringz00_4151;

					BgL_stringz00_4151 = BGl_string2201z00zzcfa_closurez00;
					{	/* Cfa/closure.scm 25 */
						obj_t BgL_startz00_4152;

						BgL_startz00_4152 = BINT(((long) 0));
						{	/* Cfa/closure.scm 25 */
							obj_t BgL_endz00_4153;

							BgL_endz00_4153 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_4151)));
							{	/* Cfa/closure.scm 25 */

								BgL_cportz00_4143 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_4151, BgL_startz00_4152, BgL_endz00_4153);
				}}}}
				{
					long BgL_iz00_4144;

					BgL_iz00_4144 = ((long) 19);
				BgL_loopz00_4145:
					if ((BgL_iz00_4144 == ((long) -1)))
						{	/* Cfa/closure.scm 25 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/closure.scm 25 */
							{	/* Cfa/closure.scm 25 */
								obj_t BgL_arg2203z00_4147;

								{	/* Cfa/closure.scm 25 */

									{	/* Cfa/closure.scm 25 */
										obj_t BgL_locationz00_4149;

										BgL_locationz00_4149 = BBOOL(((bool_t) 0));
										{	/* Cfa/closure.scm 25 */

											BgL_arg2203z00_4147 =
												BGl_readz00zz__readerz00(BgL_cportz00_4143,
												BgL_locationz00_4149);
										}
									}
								}
								{	/* Cfa/closure.scm 25 */
									int BgL_tmpz00_4180;

									BgL_tmpz00_4180 = (int) (BgL_iz00_4144);
									CNST_TABLE_SET(BgL_tmpz00_4180, BgL_arg2203z00_4147);
							}}
							{	/* Cfa/closure.scm 25 */
								int BgL_auxz00_4150;

								BgL_auxz00_4150 = (int) ((BgL_iz00_4144 - ((long) 1)));
								{
									long BgL_iz00_4185;

									BgL_iz00_4185 = (long) (BgL_auxz00_4150);
									BgL_iz00_4144 = BgL_iz00_4185;
									goto BgL_loopz00_4145;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			BGl_za2funcallzd2listza2zd2zzcfa_closurez00 = BNIL;
			BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 = BNIL;
			BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 = BNIL;
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BFALSE;
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BFALSE, BUNSPEC);
		}

	}



/* closure-optimization? */
	BGL_EXPORTED_DEF obj_t BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 55 */
			{	/* Cfa/closure.scm 56 */
				long BgL_n1z00_3816;

				BgL_n1z00_3816 = (long) CINT(BGl_za2optimza2z00zzengine_paramz00);
				return BBOOL((BgL_n1z00_3816 >= ((long) 2)));
		}}

	}



/* &closure-optimization? */
	obj_t BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00(obj_t
		BgL_envz00_4123)
	{
		{	/* Cfa/closure.scm 55 */
			return BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00();
		}

	}



/* closure-optimization! */
	BGL_EXPORTED_DEF obj_t
		BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(obj_t BgL_globalsz00_3)
	{
		{	/* Cfa/closure.scm 61 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 62 */
					{	/* Cfa/closure.scm 63 */
						obj_t BgL_list1559z00_2814;

						{	/* Cfa/closure.scm 63 */
							obj_t BgL_arg1560z00_2815;

							BgL_arg1560z00_2815 =
								MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
							BgL_list1559z00_2814 =
								MAKE_YOUNG_PAIR(BGl_string2194z00zzcfa_closurez00,
								BgL_arg1560z00_2815);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list1559z00_2814);
					}
					BGl_startzd2closurezd2cachez00zzcfa_closurez00();
					{
						obj_t BgL_l1514z00_2817;

						BgL_l1514z00_2817 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
					BgL_zc3z04anonymousza31561ze3z87_2818:
						if (PAIRP(BgL_l1514z00_2817))
							{	/* Cfa/closure.scm 72 */
								{	/* Cfa/closure.scm 74 */
									obj_t BgL_appz00_2820;

									BgL_appz00_2820 = CAR(BgL_l1514z00_2817);
									{	/* Cfa/closure.scm 75 */
										BgL_variablez00_bglt BgL_funz00_2822;

										{
											BgL_varz00_bglt BgL_auxz00_4204;

											{	/* Cfa/closure.scm 75 */
												obj_t BgL_pairz00_3819;

												BgL_pairz00_3819 =
													(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt)
																((BgL_appz00_bglt) BgL_appz00_2820))))->
													BgL_argsz00);
												BgL_auxz00_4204 =
													((BgL_varz00_bglt) CAR(BgL_pairz00_3819));
											}
											BgL_funz00_2822 =
												(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4204))->
												BgL_variablez00);
										}
										{	/* Cfa/closure.scm 75 */
											obj_t BgL_cloz00_2823;

											BgL_cloz00_2823 =
												(((BgL_funz00_bglt) COBJECT(
														((BgL_funz00_bglt)
															((BgL_sfunz00_bglt)
																(((BgL_variablez00_bglt) COBJECT(
																			((BgL_variablez00_bglt)
																				((BgL_globalz00_bglt)
																					BgL_funz00_2822))))->
																	BgL_valuez00)))))->BgL_thezd2closurezd2);
											{	/* Cfa/closure.scm 76 */
												bool_t BgL_lostzf3zf3_2824;

												{	/* Cfa/closure.scm 77 */
													long BgL_arg1600z00_2848;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4217;

														{
															obj_t BgL_auxz00_4218;

															{	/* Cfa/closure.scm 77 */
																BgL_objectz00_bglt BgL_tmpz00_4219;

																BgL_tmpz00_4219 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_appz00_2820));
																BgL_auxz00_4218 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4219);
															}
															BgL_auxz00_4217 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_4218);
														}
														BgL_arg1600z00_2848 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																COBJECT(BgL_auxz00_4217))->BgL_lostzd2stampzd2);
													}
													BgL_lostzf3zf3_2824 =
														(BgL_arg1600z00_2848 > ((long) -1));
												}
												{	/* Cfa/closure.scm 77 */
													obj_t BgL_siza7eza7_2825;

													{	/* Cfa/closure.scm 78 */
														obj_t BgL_arg1598z00_2846;

														{	/* Cfa/closure.scm 78 */
															obj_t BgL_pairz00_3825;

															BgL_pairz00_3825 =
																(((BgL_appz00_bglt) COBJECT(
																		((BgL_appz00_bglt)
																			((BgL_appz00_bglt) BgL_appz00_2820))))->
																BgL_argsz00);
															BgL_arg1598z00_2846 =
																CAR(CDR(CDR(BgL_pairz00_3825)));
														}
														BgL_siza7eza7_2825 =
															BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(
															((BgL_nodez00_bglt) BgL_arg1598z00_2846));
													}
													{	/* Cfa/closure.scm 78 */

														{	/* Cfa/closure.scm 80 */
															bool_t BgL_test2225z00_4234;

															if (BgL_lostzf3zf3_2824)
																{	/* Cfa/closure.scm 80 */
																	BgL_test2225z00_4234 = ((bool_t) 1);
																}
															else
																{	/* Cfa/closure.scm 81 */
																	bool_t BgL_test2227z00_4236;

																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4237;
																		{
																			obj_t BgL_auxz00_4238;

																			{	/* Cfa/closure.scm 81 */
																				BgL_objectz00_bglt BgL_tmpz00_4239;

																				BgL_tmpz00_4239 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2820));
																				BgL_auxz00_4238 =
																					BGL_OBJECT_WIDENING(BgL_tmpz00_4239);
																			}
																			BgL_auxz00_4237 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4238);
																		}
																		BgL_test2227z00_4236 =
																			(((BgL_makezd2procedurezd2appz00_bglt)
																				COBJECT(BgL_auxz00_4237))->
																			BgL_xzd2tzf3z21);
																	}
																	if (BgL_test2227z00_4236)
																		{	/* Cfa/closure.scm 81 */
																			if (
																				((((BgL_funz00_bglt) COBJECT(
																								((BgL_funz00_bglt)
																									((BgL_sfunz00_bglt)
																										(((BgL_variablez00_bglt)
																												COBJECT((
																														(BgL_variablez00_bglt)
																														((BgL_globalz00_bglt) BgL_funz00_2822))))->BgL_valuez00)))))->BgL_arityz00) < ((long) 0)))
																				{	/* Cfa/closure.scm 82 */
																					BgL_test2225z00_4234 = ((bool_t) 1);
																				}
																			else
																				{	/* Cfa/closure.scm 82 */
																					if (INTEGERP(BgL_siza7eza7_2825))
																						{	/* Cfa/closure.scm 83 */
																							if (BGl_isazf3zf3zz__objectz00
																								(BgL_cloz00_2823,
																									BGl_globalz00zzast_varz00))
																								{	/* Cfa/closure.scm 84 */
																									if (
																										((((BgL_globalz00_bglt)
																													COBJECT((
																															(BgL_globalz00_bglt)
																															BgL_cloz00_2823)))->
																												BgL_importz00) ==
																											CNST_TABLE_REF(((long)
																													0))))
																										{	/* Cfa/closure.scm 85 */
																											BgL_test2225z00_4234 =
																												((bool_t) 0);
																										}
																									else
																										{	/* Cfa/closure.scm 85 */
																											BgL_test2225z00_4234 =
																												((bool_t) 1);
																										}
																								}
																							else
																								{	/* Cfa/closure.scm 84 */
																									BgL_test2225z00_4234 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Cfa/closure.scm 83 */
																							BgL_test2225z00_4234 =
																								((bool_t) 1);
																						}
																				}
																		}
																	else
																		{	/* Cfa/closure.scm 81 */
																			BgL_test2225z00_4234 = ((bool_t) 1);
																		}
																}
															if (BgL_test2225z00_4234)
																{	/* Cfa/closure.scm 80 */
																	BNIL;
																}
															else
																{	/* Cfa/closure.scm 80 */
																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4262;
																		{
																			obj_t BgL_auxz00_4263;

																			{	/* Cfa/closure.scm 102 */
																				BgL_objectz00_bglt BgL_tmpz00_4264;

																				BgL_tmpz00_4264 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2820));
																				BgL_auxz00_4263 =
																					BGL_OBJECT_WIDENING(BgL_tmpz00_4264);
																			}
																			BgL_auxz00_4262 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4263);
																		}
																		((((BgL_makezd2procedurezd2appz00_bglt)
																					COBJECT(BgL_auxz00_4262))->BgL_xz00) =
																			((bool_t) ((bool_t) 1)), BUNSPEC);
																	}
																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4270;
																		{
																			obj_t BgL_auxz00_4271;

																			{	/* Cfa/closure.scm 103 */
																				BgL_objectz00_bglt BgL_tmpz00_4272;

																				BgL_tmpz00_4272 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2820));
																				BgL_auxz00_4271 =
																					BGL_OBJECT_WIDENING(BgL_tmpz00_4272);
																			}
																			BgL_auxz00_4270 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4271);
																		}
																		((((BgL_makezd2procedurezd2appz00_bglt)
																					COBJECT(BgL_auxz00_4270))->BgL_tz00) =
																			((bool_t) ((bool_t) 1)), BUNSPEC);
																	}
																}
														}
													}
												}
											}
										}
									}
								}
								{
									obj_t BgL_l1514z00_4278;

									BgL_l1514z00_4278 = CDR(BgL_l1514z00_2817);
									BgL_l1514z00_2817 = BgL_l1514z00_4278;
									goto BgL_zc3z04anonymousza31561ze3z87_2818;
								}
							}
						else
							{	/* Cfa/closure.scm 72 */
								((bool_t) 1);
							}
					}
					BGl_Xz12z12zzcfa_closurez00
						(BGl_za2funcallzd2listza2zd2zzcfa_closurez00);
					BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00
						(BGl_za2funcallzd2listza2zd2zzcfa_closurez00);
					{
						obj_t BgL_l1516z00_2855;

						BgL_l1516z00_2855 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
					BgL_zc3z04anonymousza31613ze3z87_2856:
						if (PAIRP(BgL_l1516z00_2855))
							{	/* Cfa/closure.scm 110 */
								{	/* Cfa/closure.scm 111 */
									obj_t BgL_allocz00_2858;

									BgL_allocz00_2858 = CAR(BgL_l1516z00_2855);
									{	/* Cfa/closure.scm 112 */
										BgL_valuez00_bglt BgL_fz00_2860;

										{
											BgL_variablez00_bglt BgL_auxz00_4285;

											{
												BgL_varz00_bglt BgL_auxz00_4286;

												{	/* Cfa/closure.scm 112 */
													obj_t BgL_pairz00_3840;

													BgL_pairz00_3840 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt)
																	((BgL_appz00_bglt) BgL_allocz00_2858))))->
														BgL_argsz00);
													BgL_auxz00_4286 =
														((BgL_varz00_bglt) CAR(BgL_pairz00_3840));
												}
												BgL_auxz00_4285 =
													(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4286))->
													BgL_variablez00);
											}
											BgL_fz00_2860 =
												(((BgL_variablez00_bglt) COBJECT(BgL_auxz00_4285))->
												BgL_valuez00);
										}
										{	/* Cfa/closure.scm 114 */
											bool_t BgL_test2233z00_4294;

											{
												BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4295;

												{
													obj_t BgL_auxz00_4296;

													{	/* Cfa/closure.scm 114 */
														BgL_objectz00_bglt BgL_tmpz00_4297;

														BgL_tmpz00_4297 =
															((BgL_objectz00_bglt)
															((BgL_appz00_bglt) BgL_allocz00_2858));
														BgL_auxz00_4296 =
															BGL_OBJECT_WIDENING(BgL_tmpz00_4297);
													}
													BgL_auxz00_4295 =
														((BgL_makezd2procedurezd2appz00_bglt)
														BgL_auxz00_4296);
												}
												BgL_test2233z00_4294 =
													(((BgL_makezd2procedurezd2appz00_bglt)
														COBJECT(BgL_auxz00_4295))->BgL_xz00);
											}
											if (BgL_test2233z00_4294)
												{	/* Cfa/closure.scm 114 */
													obj_t BgL_vz00_3845;

													BgL_vz00_3845 = CNST_TABLE_REF(((long) 1));
													((((BgL_sfunz00_bglt) COBJECT(
																	((BgL_sfunz00_bglt) BgL_fz00_2860)))->
															BgL_strengthz00) =
														((obj_t) BgL_vz00_3845), BUNSPEC);
												}
											else
												{	/* Cfa/closure.scm 115 */
													bool_t BgL_test2234z00_4306;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4307;

														{
															obj_t BgL_auxz00_4308;

															{	/* Cfa/closure.scm 115 */
																BgL_objectz00_bglt BgL_tmpz00_4309;

																BgL_tmpz00_4309 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_allocz00_2858));
																BgL_auxz00_4308 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4309);
															}
															BgL_auxz00_4307 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_4308);
														}
														BgL_test2234z00_4306 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																COBJECT(BgL_auxz00_4307))->BgL_tz00);
													}
													if (BgL_test2234z00_4306)
														{	/* Cfa/closure.scm 115 */
															obj_t BgL_vz00_3848;

															BgL_vz00_3848 = CNST_TABLE_REF(((long) 2));
															((((BgL_sfunz00_bglt) COBJECT(
																			((BgL_sfunz00_bglt) BgL_fz00_2860)))->
																	BgL_strengthz00) =
																((obj_t) BgL_vz00_3848), BUNSPEC);
														}
													else
														{	/* Cfa/closure.scm 116 */
															obj_t BgL_vz00_3850;

															BgL_vz00_3850 = CNST_TABLE_REF(((long) 3));
															((((BgL_sfunz00_bglt) COBJECT(
																			((BgL_sfunz00_bglt) BgL_fz00_2860)))->
																	BgL_strengthz00) =
																((obj_t) BgL_vz00_3850), BUNSPEC);
								}}}}}
								{
									obj_t BgL_l1516z00_4321;

									BgL_l1516z00_4321 = CDR(BgL_l1516z00_2855);
									BgL_l1516z00_2855 = BgL_l1516z00_4321;
									goto BgL_zc3z04anonymousza31613ze3z87_2856;
								}
							}
						else
							{	/* Cfa/closure.scm 110 */
								((bool_t) 1);
							}
					}
					BGl_showzd2Xzd2Tz00zzcfa_closurez00
						(BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00);
					BGl_lightzd2funcallz12zc0zzcfa_closurez00();
					BGl_lightzd2accessz12zc0zzcfa_closurez00();
					BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00();
					return BGl_lightzd2typez12zc0zzcfa_ltypez00(BgL_globalsz00_3);
				}
			else
				{	/* Cfa/closure.scm 62 */
					return BFALSE;
				}
		}

	}



/* &closure-optimization! */
	obj_t BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00(obj_t
		BgL_envz00_4124, obj_t BgL_globalsz00_4125)
	{
		{	/* Cfa/closure.scm 61 */
			return
				BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(BgL_globalsz00_4125);
		}

	}



/* X! */
	bool_t BGl_Xz12z12zzcfa_closurez00(obj_t BgL_funcallzd2listzd2_4)
	{
		{	/* Cfa/closure.scm 132 */
			{
				obj_t BgL_l1518z00_2869;

				BgL_l1518z00_2869 = BgL_funcallzd2listzd2_4;
			BgL_zc3z04anonymousza31644ze3z87_2870:
				if (PAIRP(BgL_l1518z00_2869))
					{	/* Cfa/closure.scm 134 */
						{	/* Cfa/closure.scm 135 */
							BgL_funcallz00_bglt BgL_appz00_2872;

							BgL_appz00_2872 = ((BgL_funcallz00_bglt) CAR(BgL_l1518z00_2869));
							{	/* Cfa/closure.scm 136 */
								BgL_nodez00_bglt BgL_funz00_2873;

								BgL_funz00_2873 =
									(((BgL_funcallz00_bglt) COBJECT(BgL_appz00_2872))->
									BgL_funz00);
								{	/* Cfa/closure.scm 136 */
									BgL_approxz00_bglt BgL_approxz00_2874;

									BgL_approxz00_2874 =
										BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2873);
									{	/* Cfa/closure.scm 137 */
										obj_t BgL_allocz00_2875;

										BgL_allocz00_2875 =
											(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_2874))->
											BgL_allocsz00);
										{	/* Cfa/closure.scm 138 */
											BgL_typez00_bglt BgL_typez00_2876;

											BgL_typez00_2876 =
												(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_2874))->
												BgL_typez00);
											{	/* Cfa/closure.scm 139 */
												bool_t BgL_topzf3zf3_2877;

												BgL_topzf3zf3_2877 =
													(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_2874))->
													BgL_topzf3zf3);
												{	/* Cfa/closure.scm 140 */

													if (BgL_topzf3zf3_2877)
														{	/* Cfa/closure.scm 142 */
															BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00
																(BGl_proc2195z00zzcfa_closurez00,
																BgL_approxz00_2874);
														}
													else
														{	/* Cfa/closure.scm 153 */
															bool_t BgL_test2237z00_4340;

															{	/* Cfa/closure.scm 153 */
																obj_t BgL_arg1672z00_2898;

																BgL_arg1672z00_2898 =
																	BGl_setzd2lengthzd2zzcfa_setz00
																	(BgL_allocz00_2875);
																BgL_test2237z00_4340 =
																	((long) CINT(BgL_arg1672z00_2898) ==
																	((long) 0));
															}
															if (BgL_test2237z00_4340)
																{	/* Cfa/closure.scm 153 */
																	CNST_TABLE_REF(((long) 4));
																}
															else
																{	/* Cfa/closure.scm 156 */
																	bool_t BgL_test2238z00_4345;

																	{	/* Cfa/closure.scm 156 */
																		bool_t BgL_test2239z00_4346;

																		{	/* Cfa/closure.scm 156 */
																			obj_t BgL_arg1666z00_2897;

																			BgL_arg1666z00_2897 =
																				BGl_setzd2lengthzd2zzcfa_setz00
																				(BgL_allocz00_2875);
																			BgL_test2239z00_4346 =
																				((long) CINT(BgL_arg1666z00_2897) ==
																				((long) 1));
																		}
																		if (BgL_test2239z00_4346)
																			{	/* Cfa/closure.scm 157 */
																				obj_t BgL__ortest_1163z00_2896;

																				BgL__ortest_1163z00_2896 =
																					BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
																				if (CBOOL(BgL__ortest_1163z00_2896))
																					{	/* Cfa/closure.scm 157 */
																						BgL_test2238z00_4345 =
																							CBOOL(BgL__ortest_1163z00_2896);
																					}
																				else
																					{	/* Cfa/closure.scm 157 */
																						BgL_test2238z00_4345 =
																							(
																							((obj_t) BgL_typez00_2876) ==
																							BGl_za2procedureza2z00zztype_cachez00);
																					}
																			}
																		else
																			{	/* Cfa/closure.scm 156 */
																				BgL_test2238z00_4345 = ((bool_t) 0);
																			}
																	}
																	if (BgL_test2238z00_4345)
																		{	/* Cfa/closure.scm 156 */
																			CNST_TABLE_REF(((long) 4));
																		}
																	else
																		{	/* Cfa/closure.scm 156 */
																			BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00
																				(BGl_proc2196z00zzcfa_closurez00,
																				BgL_approxz00_2874);
																		}
																}
														}
												}
											}
										}
									}
								}
							}
						}
						{
							obj_t BgL_l1518z00_4357;

							BgL_l1518z00_4357 = CDR(BgL_l1518z00_2869);
							BgL_l1518z00_2869 = BgL_l1518z00_4357;
							goto BgL_zc3z04anonymousza31644ze3z87_2870;
						}
					}
				else
					{	/* Cfa/closure.scm 134 */
						return ((bool_t) 1);
					}
			}
		}

	}



/* &<@anonymous:1647> */
	obj_t BGl_z62zc3z04anonymousza31647ze3ze5zzcfa_closurez00(obj_t
		BgL_envz00_4128, obj_t BgL_allocz00_4129)
	{
		{	/* Cfa/closure.scm 145 */
			if (BGl_isazf3zf3zz__objectz00(BgL_allocz00_4129,
					BGl_makezd2procedurezd2appz00zzcfa_info2z00))
				{	/* Cfa/closure.scm 146 */
					{
						BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4361;

						{
							obj_t BgL_auxz00_4362;

							{	/* Cfa/closure.scm 150 */
								BgL_objectz00_bglt BgL_tmpz00_4363;

								BgL_tmpz00_4363 =
									((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_allocz00_4129));
								BgL_auxz00_4362 = BGL_OBJECT_WIDENING(BgL_tmpz00_4363);
							}
							BgL_auxz00_4361 =
								((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4362);
						}
						((((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4361))->
								BgL_tz00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					}
					{
						BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4369;

						{
							obj_t BgL_auxz00_4370;

							{	/* Cfa/closure.scm 151 */
								BgL_objectz00_bglt BgL_tmpz00_4371;

								BgL_tmpz00_4371 =
									((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_allocz00_4129));
								BgL_auxz00_4370 = BGL_OBJECT_WIDENING(BgL_tmpz00_4371);
							}
							BgL_auxz00_4369 =
								((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4370);
						}
						return
							((((BgL_makezd2procedurezd2appz00_bglt)
									COBJECT(BgL_auxz00_4369))->BgL_xz00) =
							((bool_t) ((bool_t) 0)), BUNSPEC);
					}
				}
			else
				{	/* Cfa/closure.scm 146 */
					return BFALSE;
				}
		}

	}



/* &<@anonymous:1663> */
	obj_t BGl_z62zc3z04anonymousza31663ze3ze5zzcfa_closurez00(obj_t
		BgL_envz00_4130, obj_t BgL_allocz00_4131)
	{
		{	/* Cfa/closure.scm 164 */
			if (BGl_isazf3zf3zz__objectz00(BgL_allocz00_4131,
					BGl_makezd2procedurezd2appz00zzcfa_info2z00))
				{	/* Cfa/closure.scm 165 */
					{
						BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4379;

						{
							obj_t BgL_auxz00_4380;

							{	/* Cfa/closure.scm 169 */
								BgL_objectz00_bglt BgL_tmpz00_4381;

								BgL_tmpz00_4381 =
									((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_allocz00_4131));
								BgL_auxz00_4380 = BGL_OBJECT_WIDENING(BgL_tmpz00_4381);
							}
							BgL_auxz00_4379 =
								((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4380);
						}
						return
							((((BgL_makezd2procedurezd2appz00_bglt)
									COBJECT(BgL_auxz00_4379))->BgL_xz00) =
							((bool_t) ((bool_t) 0)), BUNSPEC);
					}
				}
			else
				{	/* Cfa/closure.scm 165 */
					return BFALSE;
				}
		}

	}



/* T-fix-point! */
	obj_t BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00(obj_t BgL_funcallzd2listzd2_5)
	{
		{	/* Cfa/closure.scm 182 */
			{
				bool_t BgL_continuezf3zf3_2902;

				BgL_continuezf3zf3_2902 = ((bool_t) 1);
			BgL_zc3z04anonymousza31674ze3z87_2903:
				if (BgL_continuezf3zf3_2902)
					{	/* Cfa/closure.scm 187 */
						bool_t BgL_continuezf3zf3_2904;

						BgL_continuezf3zf3_2904 = ((bool_t) 0);
						{
							obj_t BgL_l1522z00_2906;

							BgL_l1522z00_2906 = BgL_funcallzd2listzd2_5;
						BgL_zc3z04anonymousza31675ze3z87_2907:
							if (PAIRP(BgL_l1522z00_2906))
								{	/* Cfa/closure.scm 188 */
									{	/* Cfa/closure.scm 190 */
										obj_t BgL_appz00_2909;

										BgL_appz00_2909 = CAR(BgL_l1522z00_2906);
										{	/* Cfa/closure.scm 191 */
											BgL_nodez00_bglt BgL_funz00_2910;

											BgL_funz00_2910 =
												(((BgL_funcallz00_bglt) COBJECT(
														((BgL_funcallz00_bglt) BgL_appz00_2909)))->
												BgL_funz00);
											{	/* Cfa/closure.scm 191 */
												BgL_approxz00_bglt BgL_approxz00_2911;

												BgL_approxz00_2911 =
													BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2910);
												{	/* Cfa/closure.scm 192 */
													obj_t BgL_allocz00_2912;

													BgL_allocz00_2912 =
														BGl_setzd2ze3listz31zzcfa_setz00(
														(((BgL_approxz00_bglt)
																COBJECT(BgL_approxz00_2911))->BgL_allocsz00));
													{	/* Cfa/closure.scm 193 */
														BgL_typez00_bglt BgL_typez00_2913;

														BgL_typez00_2913 =
															(((BgL_approxz00_bglt)
																COBJECT(BgL_approxz00_2911))->BgL_typez00);
														{	/* Cfa/closure.scm 194 */
															bool_t BgL_tzd2initzf3z21_2914;

															{	/* Cfa/closure.scm 195 */
																bool_t BgL__ortest_1164z00_2938;

																BgL__ortest_1164z00_2938 =
																	(((BgL_approxz00_bglt)
																		COBJECT(BgL_approxz00_2911))->
																	BgL_topzf3zf3);
																if (BgL__ortest_1164z00_2938)
																	{	/* Cfa/closure.scm 195 */
																		BgL_tzd2initzf3z21_2914 =
																			BgL__ortest_1164z00_2938;
																	}
																else
																	{	/* Cfa/closure.scm 196 */
																		bool_t BgL_test2246z00_4399;

																		if (
																			(((obj_t) BgL_typez00_2913) ==
																				BGl_za2procedureza2z00zztype_cachez00))
																			{	/* Cfa/closure.scm 196 */
																				BgL_test2246z00_4399 = ((bool_t) 1);
																			}
																		else
																			{	/* Cfa/closure.scm 196 */
																				BgL_test2246z00_4399 =
																					CBOOL
																					(BGl_za2unsafezd2typeza2zd2zzengine_paramz00);
																			}
																		if (BgL_test2246z00_4399)
																			{	/* Cfa/closure.scm 196 */
																				BgL_tzd2initzf3z21_2914 = ((bool_t) 0);
																			}
																		else
																			{	/* Cfa/closure.scm 196 */
																				BgL_tzd2initzf3z21_2914 = ((bool_t) 1);
																			}
																	}
															}
															{	/* Cfa/closure.scm 195 */

																{
																	bool_t BgL_onezd2nonzd2tzf3zf3_2916;
																	obj_t BgL_allocsz00_2917;

																	BgL_onezd2nonzd2tzf3zf3_2916 =
																		BgL_tzd2initzf3z21_2914;
																	BgL_allocsz00_2917 = BgL_allocz00_2912;
																BgL_zc3z04anonymousza31677ze3z87_2918:
																	if (NULLP(BgL_allocsz00_2917))
																		{	/* Cfa/closure.scm 204 */
																			CNST_TABLE_REF(((long) 5));
																		}
																	else
																		{	/* Cfa/closure.scm 204 */
																			if (BgL_onezd2nonzd2tzf3zf3_2916)
																				{
																					obj_t BgL_l1520z00_2921;

																					{	/* Cfa/closure.scm 207 */
																						bool_t BgL_tmpz00_4408;

																						BgL_l1520z00_2921 =
																							BgL_allocz00_2912;
																					BgL_zc3z04anonymousza31679ze3z87_2922:
																						if (PAIRP
																							(BgL_l1520z00_2921))
																							{	/* Cfa/closure.scm 207 */
																								{	/* Cfa/closure.scm 209 */
																									obj_t BgL_allocz00_2924;

																									BgL_allocz00_2924 =
																										CAR(BgL_l1520z00_2921);
																									if (BGl_isazf3zf3zz__objectz00
																										(BgL_allocz00_2924,
																											BGl_makezd2procedurezd2appz00zzcfa_info2z00))
																										{	/* Cfa/closure.scm 211 */
																											bool_t
																												BgL_test2252z00_4414;
																											{
																												BgL_makezd2procedurezd2appz00_bglt
																													BgL_auxz00_4415;
																												{
																													obj_t BgL_auxz00_4416;

																													{	/* Cfa/closure.scm 211 */
																														BgL_objectz00_bglt
																															BgL_tmpz00_4417;
																														BgL_tmpz00_4417 =
																															(
																															(BgL_objectz00_bglt)
																															((BgL_appz00_bglt)
																																BgL_allocz00_2924));
																														BgL_auxz00_4416 =
																															BGL_OBJECT_WIDENING
																															(BgL_tmpz00_4417);
																													}
																													BgL_auxz00_4415 =
																														(
																														(BgL_makezd2procedurezd2appz00_bglt)
																														BgL_auxz00_4416);
																												}
																												BgL_test2252z00_4414 =
																													(((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4415))->BgL_tz00);
																											}
																											if (BgL_test2252z00_4414)
																												{	/* Cfa/closure.scm 211 */
																													{
																														BgL_makezd2procedurezd2appz00_bglt
																															BgL_auxz00_4423;
																														{
																															obj_t
																																BgL_auxz00_4424;
																															{	/* Cfa/closure.scm 212 */
																																BgL_objectz00_bglt
																																	BgL_tmpz00_4425;
																																BgL_tmpz00_4425
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	((BgL_appz00_bglt) BgL_allocz00_2924));
																																BgL_auxz00_4424
																																	=
																																	BGL_OBJECT_WIDENING
																																	(BgL_tmpz00_4425);
																															}
																															BgL_auxz00_4423 =
																																(
																																(BgL_makezd2procedurezd2appz00_bglt)
																																BgL_auxz00_4424);
																														}
																														((((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4423))->BgL_tz00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													}
																													BgL_continuezf3zf3_2904
																														= ((bool_t) 1);
																												}
																											else
																												{	/* Cfa/closure.scm 211 */
																													BFALSE;
																												}
																										}
																									else
																										{	/* Cfa/closure.scm 209 */
																											BFALSE;
																										}
																								}
																								{
																									obj_t BgL_l1520z00_4431;

																									BgL_l1520z00_4431 =
																										CDR(BgL_l1520z00_2921);
																									BgL_l1520z00_2921 =
																										BgL_l1520z00_4431;
																									goto
																										BgL_zc3z04anonymousza31679ze3z87_2922;
																								}
																							}
																						else
																							{	/* Cfa/closure.scm 207 */
																								BgL_tmpz00_4408 = ((bool_t) 1);
																							}
																						BBOOL(BgL_tmpz00_4408);
																					}
																				}
																			else
																				{	/* Cfa/closure.scm 215 */
																					bool_t BgL_test2253z00_4434;

																					{	/* Cfa/closure.scm 215 */
																						obj_t BgL_arg1695z00_2936;

																						BgL_arg1695z00_2936 =
																							CAR(((obj_t) BgL_allocsz00_2917));
																						BgL_test2253z00_4434 =
																							BGl_isazf3zf3zz__objectz00
																							(BgL_arg1695z00_2936,
																							BGl_makezd2procedurezd2appz00zzcfa_info2z00);
																					}
																					if (BgL_test2253z00_4434)
																						{	/* Cfa/closure.scm 216 */
																							BgL_appz00_bglt BgL_i1166z00_2932;

																							BgL_i1166z00_2932 =
																								((BgL_appz00_bglt)
																								CAR(
																									((obj_t)
																										BgL_allocsz00_2917)));
																							{	/* Cfa/closure.scm 217 */
																								bool_t BgL_test2254z00_4441;

																								{
																									BgL_makezd2procedurezd2appz00_bglt
																										BgL_auxz00_4442;
																									{
																										obj_t BgL_auxz00_4443;

																										{	/* Cfa/closure.scm 217 */
																											BgL_objectz00_bglt
																												BgL_tmpz00_4444;
																											BgL_tmpz00_4444 =
																												((BgL_objectz00_bglt)
																												BgL_i1166z00_2932);
																											BgL_auxz00_4443 =
																												BGL_OBJECT_WIDENING
																												(BgL_tmpz00_4444);
																										}
																										BgL_auxz00_4442 =
																											(
																											(BgL_makezd2procedurezd2appz00_bglt)
																											BgL_auxz00_4443);
																									}
																									BgL_test2254z00_4441 =
																										(((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4442))->BgL_tz00);
																								}
																								if (BgL_test2254z00_4441)
																									{	/* Cfa/closure.scm 218 */
																										obj_t BgL_arg1690z00_2934;

																										BgL_arg1690z00_2934 =
																											CDR(
																											((obj_t)
																												BgL_allocsz00_2917));
																										{
																											obj_t BgL_allocsz00_4451;

																											BgL_allocsz00_4451 =
																												BgL_arg1690z00_2934;
																											BgL_allocsz00_2917 =
																												BgL_allocsz00_4451;
																											goto
																												BgL_zc3z04anonymousza31677ze3z87_2918;
																										}
																									}
																								else
																									{
																										bool_t
																											BgL_onezd2nonzd2tzf3zf3_4452;
																										BgL_onezd2nonzd2tzf3zf3_4452
																											= ((bool_t) 1);
																										BgL_onezd2nonzd2tzf3zf3_2916
																											=
																											BgL_onezd2nonzd2tzf3zf3_4452;
																										goto
																											BgL_zc3z04anonymousza31677ze3z87_2918;
																									}
																							}
																						}
																					else
																						{	/* Cfa/closure.scm 215 */
																							if (CBOOL
																								(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
																								{	/* Cfa/closure.scm 222 */
																									obj_t BgL_arg1691z00_2935;

																									BgL_arg1691z00_2935 =
																										CDR(
																										((obj_t)
																											BgL_allocsz00_2917));
																									{
																										obj_t BgL_allocsz00_4457;

																										BgL_allocsz00_4457 =
																											BgL_arg1691z00_2935;
																										BgL_allocsz00_2917 =
																											BgL_allocsz00_4457;
																										goto
																											BgL_zc3z04anonymousza31677ze3z87_2918;
																									}
																								}
																							else
																								{
																									bool_t
																										BgL_onezd2nonzd2tzf3zf3_4458;
																									BgL_onezd2nonzd2tzf3zf3_4458 =
																										((bool_t) 1);
																									BgL_onezd2nonzd2tzf3zf3_2916 =
																										BgL_onezd2nonzd2tzf3zf3_4458;
																									goto
																										BgL_zc3z04anonymousza31677ze3z87_2918;
																								}
																						}
																				}
																		}
																}
															}
														}
													}
												}
											}
										}
									}
									{
										obj_t BgL_l1522z00_4459;

										BgL_l1522z00_4459 = CDR(BgL_l1522z00_2906);
										BgL_l1522z00_2906 = BgL_l1522z00_4459;
										goto BgL_zc3z04anonymousza31675ze3z87_2907;
									}
								}
							else
								{	/* Cfa/closure.scm 188 */
									((bool_t) 1);
								}
						}
						{
							bool_t BgL_continuezf3zf3_4461;

							BgL_continuezf3zf3_4461 = BgL_continuezf3zf3_2904;
							BgL_continuezf3zf3_2902 = BgL_continuezf3zf3_4461;
							goto BgL_zc3z04anonymousza31674ze3z87_2903;
						}
					}
				else
					{	/* Cfa/closure.scm 185 */
						return BUNSPEC;
					}
			}
		}

	}



/* light-make-procedure! */
	bool_t BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 251 */
			{
				obj_t BgL_appz00_2991;
				obj_t BgL_appz00_2961;

				{
					obj_t BgL_l1524z00_2952;

					BgL_l1524z00_2952 =
						BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
				BgL_zc3z04anonymousza31711ze3z87_2953:
					if (PAIRP(BgL_l1524z00_2952))
						{	/* Cfa/closure.scm 293 */
							{	/* Cfa/closure.scm 294 */
								obj_t BgL_appz00_2955;

								BgL_appz00_2955 = CAR(BgL_l1524z00_2952);
								{	/* Cfa/closure.scm 296 */
									bool_t BgL_test2257z00_4465;

									{
										BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4466;

										{
											obj_t BgL_auxz00_4467;

											{	/* Cfa/closure.scm 296 */
												BgL_objectz00_bglt BgL_tmpz00_4468;

												BgL_tmpz00_4468 =
													((BgL_objectz00_bglt)
													((BgL_appz00_bglt) BgL_appz00_2955));
												BgL_auxz00_4467 = BGL_OBJECT_WIDENING(BgL_tmpz00_4468);
											}
											BgL_auxz00_4466 =
												((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4467);
										}
										BgL_test2257z00_4465 =
											(((BgL_makezd2procedurezd2appz00_bglt)
												COBJECT(BgL_auxz00_4466))->BgL_xz00);
									}
									if (BgL_test2257z00_4465)
										{	/* Cfa/closure.scm 296 */
											BgL_appz00_2961 = BgL_appz00_2955;
											{	/* Cfa/closure.scm 255 */
												obj_t BgL_siza7eza7_2964;

												{	/* Cfa/closure.scm 255 */
													obj_t BgL_arg1753z00_2988;

													{	/* Cfa/closure.scm 255 */
														obj_t BgL_pairz00_3884;

														BgL_pairz00_3884 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt)
																		((BgL_appz00_bglt) BgL_appz00_2961))))->
															BgL_argsz00);
														BgL_arg1753z00_2988 =
															CAR(CDR(CDR(BgL_pairz00_3884)));
													}
													BgL_siza7eza7_2964 =
														BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(
														((BgL_nodez00_bglt) BgL_arg1753z00_2988));
												}
												{	/* Cfa/closure.scm 255 */
													BgL_variablez00_bglt BgL_ffunz00_2965;

													{
														BgL_varz00_bglt BgL_auxz00_4482;

														{	/* Cfa/closure.scm 256 */
															obj_t BgL_pairz00_3890;

															BgL_pairz00_3890 =
																(((BgL_appz00_bglt) COBJECT(
																		((BgL_appz00_bglt)
																			((BgL_appz00_bglt) BgL_appz00_2961))))->
																BgL_argsz00);
															BgL_auxz00_4482 =
																((BgL_varz00_bglt) CAR(BgL_pairz00_3890));
														}
														BgL_ffunz00_2965 =
															(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4482))->
															BgL_variablez00);
													}
													{	/* Cfa/closure.scm 256 */
														BgL_valuez00_bglt BgL_sfunz00_2966;

														BgL_sfunz00_2966 =
															(((BgL_variablez00_bglt)
																COBJECT(BgL_ffunz00_2965))->BgL_valuez00);
														{	/* Cfa/closure.scm 257 */

															if (
																((long) CINT(BgL_siza7eza7_2964) < ((long) 1)))
																{	/* Cfa/closure.scm 259 */
																	{	/* Cfa/closure.scm 260 */
																		bool_t BgL_test2259z00_4493;

																		if (BGl_isazf3zf3zz__objectz00(
																				((obj_t) BgL_ffunz00_2965),
																				BGl_globalz00zzast_varz00))
																			{	/* Cfa/closure.scm 261 */
																				bool_t BgL_test2261z00_4497;

																				{	/* Cfa/closure.scm 261 */
																					obj_t BgL_arg1739z00_2981;

																					BgL_arg1739z00_2981 =
																						(((BgL_funz00_bglt) COBJECT(
																								((BgL_funz00_bglt)
																									((BgL_sfunz00_bglt)
																										BgL_sfunz00_2966))))->
																						BgL_thezd2closurezd2);
																					BgL_test2261z00_4497 =
																						BGl_isazf3zf3zz__objectz00
																						(BgL_arg1739z00_2981,
																						BGl_globalz00zzast_varz00);
																				}
																				if (BgL_test2261z00_4497)
																					{	/* Cfa/closure.scm 262 */
																						BgL_valuez00_bglt
																							BgL_arg1736z00_2979;
																						BgL_arg1736z00_2979 =
																							(((BgL_variablez00_bglt)
																								COBJECT(((BgL_variablez00_bglt)
																										((BgL_globalz00_bglt) ((
																													(BgL_funz00_bglt)
																													COBJECT((
																															(BgL_funz00_bglt)
																															((BgL_sfunz00_bglt) BgL_sfunz00_2966))))->BgL_thezd2closurezd2)))))->BgL_valuez00);
																						BgL_test2259z00_4493 =
																							BGl_isazf3zf3zz__objectz00((
																								(obj_t) BgL_arg1736z00_2979),
																							BGl_scnstz00zzast_varz00);
																					}
																				else
																					{	/* Cfa/closure.scm 261 */
																						BgL_test2259z00_4493 = ((bool_t) 0);
																					}
																			}
																		else
																			{	/* Cfa/closure.scm 260 */
																				BgL_test2259z00_4493 = ((bool_t) 0);
																			}
																		if (BgL_test2259z00_4493)
																			{	/* Cfa/closure.scm 263 */
																				BgL_valuez00_bglt BgL_arg1734z00_2975;

																				BgL_arg1734z00_2975 =
																					(((BgL_variablez00_bglt) COBJECT(
																							((BgL_variablez00_bglt)
																								((BgL_globalz00_bglt)
																									(((BgL_funz00_bglt) COBJECT(
																												((BgL_funz00_bglt)
																													((BgL_sfunz00_bglt)
																														BgL_sfunz00_2966))))->
																										BgL_thezd2closurezd2)))))->
																					BgL_valuez00);
																				{	/* Cfa/closure.scm 263 */
																					obj_t BgL_vz00_3900;

																					BgL_vz00_3900 =
																						CNST_TABLE_REF(((long) 6));
																					((((BgL_scnstz00_bglt) COBJECT(
																									((BgL_scnstz00_bglt)
																										BgL_arg1734z00_2975)))->
																							BgL_classz00) =
																						((obj_t) BgL_vz00_3900), BUNSPEC);
																			}}
																		else
																			{	/* Cfa/closure.scm 260 */
																				BFALSE;
																			}
																	}
																	{	/* Cfa/closure.scm 265 */
																		BgL_varz00_bglt BgL_arg1740z00_2982;

																		BgL_arg1740z00_2982 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2961))))->BgL_funz00);
																		{	/* Cfa/closure.scm 265 */
																			BgL_variablez00_bglt BgL_vz00_3902;

																			BgL_vz00_3902 =
																				((BgL_variablez00_bglt)
																				BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_arg1740z00_2982))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) BgL_vz00_3902),
																				BUNSPEC);
																		}
																	}
																	{	/* Cfa/closure.scm 266 */
																		BgL_varz00_bglt BgL_arg1741z00_2983;

																		BgL_arg1741z00_2983 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2961))))->BgL_funz00);
																		{	/* Cfa/closure.scm 266 */
																			BgL_typez00_bglt BgL_vz00_3904;

																			BgL_vz00_3904 =
																				((BgL_typez00_bglt)
																				BGl_za2procedurezd2elza2zd2zztype_cachez00);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_arg1741z00_2983)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) BgL_vz00_3904),
																				BUNSPEC);
																		}
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2961))))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2procedurezd2elza2zd2zztype_cachez00)),
																		BUNSPEC);
																}
															else
																{	/* Cfa/closure.scm 259 */
																	{	/* Cfa/closure.scm 269 */
																		BgL_varz00_bglt BgL_arg1744z00_2984;

																		BgL_arg1744z00_2984 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2961))))->BgL_funz00);
																		{	/* Cfa/closure.scm 269 */
																			BgL_variablez00_bglt BgL_vz00_3906;

																			BgL_vz00_3906 =
																				((BgL_variablez00_bglt)
																				BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_arg1744z00_2984))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) BgL_vz00_3906),
																				BUNSPEC);
																		}
																	}
																	{	/* Cfa/closure.scm 270 */
																		BgL_varz00_bglt BgL_arg1746z00_2985;

																		BgL_arg1746z00_2985 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2961))))->BgL_funz00);
																		{	/* Cfa/closure.scm 270 */
																			BgL_typez00_bglt BgL_vz00_3908;

																			BgL_vz00_3908 =
																				((BgL_typez00_bglt)
																				BGl_za2procedurezd2elza2zd2zztype_cachez00);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_arg1746z00_2985)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) BgL_vz00_3908),
																				BUNSPEC);
																		}
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2961))))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2procedurezd2elza2zd2zztype_cachez00)),
																		BUNSPEC);
																}
														}
													}
												}
											}
											{
												obj_t BgL_auxz00_4549;

												{	/* Cfa/closure.scm 272 */
													obj_t BgL_pairz00_3909;

													BgL_pairz00_3909 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt)
																	((BgL_appz00_bglt) BgL_appz00_2961))))->
														BgL_argsz00);
													{	/* Cfa/closure.scm 272 */
														obj_t BgL_pairz00_3912;

														BgL_pairz00_3912 = CDR(BgL_pairz00_3909);
														BgL_auxz00_4549 = CDR(BgL_pairz00_3912);
													}
												}
												((((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt)
																	((BgL_appz00_bglt) BgL_appz00_2961))))->
														BgL_argsz00) = ((obj_t) BgL_auxz00_4549), BUNSPEC);
											}
											BgL_appz00_2961;
										}
									else
										{	/* Cfa/closure.scm 297 */
											bool_t BgL_test2262z00_4558;

											{
												BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4559;

												{
													obj_t BgL_auxz00_4560;

													{	/* Cfa/closure.scm 297 */
														BgL_objectz00_bglt BgL_tmpz00_4561;

														BgL_tmpz00_4561 =
															((BgL_objectz00_bglt)
															((BgL_appz00_bglt) BgL_appz00_2955));
														BgL_auxz00_4560 =
															BGL_OBJECT_WIDENING(BgL_tmpz00_4561);
													}
													BgL_auxz00_4559 =
														((BgL_makezd2procedurezd2appz00_bglt)
														BgL_auxz00_4560);
												}
												BgL_test2262z00_4558 =
													(((BgL_makezd2procedurezd2appz00_bglt)
														COBJECT(BgL_auxz00_4559))->BgL_tz00);
											}
											if (BgL_test2262z00_4558)
												{	/* Cfa/closure.scm 297 */
													BgL_appz00_2991 = BgL_appz00_2955;
													{	/* Cfa/closure.scm 277 */
														obj_t BgL_siza7eza7_2994;

														{	/* Cfa/closure.scm 277 */
															obj_t BgL_arg1813z00_3018;

															{	/* Cfa/closure.scm 277 */
																obj_t BgL_pairz00_3913;

																BgL_pairz00_3913 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt)
																				((BgL_appz00_bglt) BgL_appz00_2991))))->
																	BgL_argsz00);
																BgL_arg1813z00_3018 =
																	CAR(CDR(CDR(BgL_pairz00_3913)));
															}
															BgL_siza7eza7_2994 =
																BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(
																((BgL_nodez00_bglt) BgL_arg1813z00_3018));
														}
														{	/* Cfa/closure.scm 277 */
															BgL_variablez00_bglt BgL_ffunz00_2995;

															{
																BgL_varz00_bglt BgL_auxz00_4575;

																{	/* Cfa/closure.scm 278 */
																	obj_t BgL_pairz00_3919;

																	BgL_pairz00_3919 =
																		(((BgL_appz00_bglt) COBJECT(
																				((BgL_appz00_bglt)
																					((BgL_appz00_bglt)
																						BgL_appz00_2991))))->BgL_argsz00);
																	BgL_auxz00_4575 =
																		((BgL_varz00_bglt) CAR(BgL_pairz00_3919));
																}
																BgL_ffunz00_2995 =
																	(((BgL_varz00_bglt)
																		COBJECT(BgL_auxz00_4575))->BgL_variablez00);
															}
															{	/* Cfa/closure.scm 278 */
																BgL_valuez00_bglt BgL_sfunz00_2996;

																BgL_sfunz00_2996 =
																	(((BgL_variablez00_bglt)
																		COBJECT(BgL_ffunz00_2995))->BgL_valuez00);
																{	/* Cfa/closure.scm 279 */

																	{	/* Cfa/closure.scm 280 */
																		bool_t BgL_test2263z00_4583;

																		if (BGl_isazf3zf3zz__objectz00(
																				((obj_t) BgL_ffunz00_2995),
																				BGl_globalz00zzast_varz00))
																			{	/* Cfa/closure.scm 281 */
																				bool_t BgL_test2265z00_4587;

																				{	/* Cfa/closure.scm 281 */
																					obj_t BgL_arg1802z00_3010;

																					BgL_arg1802z00_3010 =
																						(((BgL_funz00_bglt) COBJECT(
																								((BgL_funz00_bglt)
																									((BgL_sfunz00_bglt)
																										BgL_sfunz00_2996))))->
																						BgL_thezd2closurezd2);
																					BgL_test2265z00_4587 =
																						BGl_isazf3zf3zz__objectz00
																						(BgL_arg1802z00_3010,
																						BGl_globalz00zzast_varz00);
																				}
																				if (BgL_test2265z00_4587)
																					{	/* Cfa/closure.scm 282 */
																						BgL_valuez00_bglt
																							BgL_arg1799z00_3008;
																						BgL_arg1799z00_3008 =
																							(((BgL_variablez00_bglt)
																								COBJECT(((BgL_variablez00_bglt)
																										((BgL_globalz00_bglt) ((
																													(BgL_funz00_bglt)
																													COBJECT((
																															(BgL_funz00_bglt)
																															((BgL_sfunz00_bglt) BgL_sfunz00_2996))))->BgL_thezd2closurezd2)))))->BgL_valuez00);
																						BgL_test2263z00_4583 =
																							BGl_isazf3zf3zz__objectz00((
																								(obj_t) BgL_arg1799z00_3008),
																							BGl_scnstz00zzast_varz00);
																					}
																				else
																					{	/* Cfa/closure.scm 281 */
																						BgL_test2263z00_4583 = ((bool_t) 0);
																					}
																			}
																		else
																			{	/* Cfa/closure.scm 280 */
																				BgL_test2263z00_4583 = ((bool_t) 0);
																			}
																		if (BgL_test2263z00_4583)
																			{	/* Cfa/closure.scm 283 */
																				BgL_valuez00_bglt BgL_arg1789z00_3004;

																				BgL_arg1789z00_3004 =
																					(((BgL_variablez00_bglt) COBJECT(
																							((BgL_variablez00_bglt)
																								((BgL_globalz00_bglt)
																									(((BgL_funz00_bglt) COBJECT(
																												((BgL_funz00_bglt)
																													((BgL_sfunz00_bglt)
																														BgL_sfunz00_2996))))->
																										BgL_thezd2closurezd2)))))->
																					BgL_valuez00);
																				{	/* Cfa/closure.scm 283 */
																					obj_t BgL_vz00_3928;

																					BgL_vz00_3928 =
																						CNST_TABLE_REF(((long) 7));
																					((((BgL_scnstz00_bglt) COBJECT(
																									((BgL_scnstz00_bglt)
																										BgL_arg1789z00_3004)))->
																							BgL_classz00) =
																						((obj_t) BgL_vz00_3928), BUNSPEC);
																			}}
																		else
																			{	/* Cfa/closure.scm 280 */
																				BFALSE;
																			}
																	}
																	{	/* Cfa/closure.scm 285 */
																		BgL_varz00_bglt BgL_arg1804z00_3011;

																		BgL_arg1804z00_3011 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2991))))->BgL_funz00);
																		{	/* Cfa/closure.scm 285 */
																			BgL_variablez00_bglt BgL_vz00_3930;

																			BgL_vz00_3930 =
																				((BgL_variablez00_bglt)
																				BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_arg1804z00_3011))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) BgL_vz00_3930),
																				BUNSPEC);
																		}
																	}
																	{	/* Cfa/closure.scm 287 */
																		BgL_varz00_bglt BgL_arg1806z00_3012;

																		BgL_arg1806z00_3012 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2991))))->BgL_funz00);
																		{	/* Cfa/closure.scm 287 */
																			BgL_typez00_bglt BgL_vz00_3932;

																			BgL_vz00_3932 =
																				((BgL_typez00_bglt)
																				BGl_za2procedureza2z00zztype_cachez00);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_arg1806z00_3012)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) BgL_vz00_3932),
																				BUNSPEC);
																		}
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2991))))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2procedureza2z00zztype_cachez00)),
																		BUNSPEC);
																	{	/* Cfa/closure.scm 289 */
																		obj_t BgL_arg1808z00_3013;
																		obj_t BgL_arg1809z00_3014;

																		BgL_arg1808z00_3013 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2991))))->BgL_argsz00);
																		{	/* Cfa/closure.scm 289 */
																			obj_t BgL_pairz00_3933;

																			BgL_pairz00_3933 =
																				(((BgL_appz00_bglt) COBJECT(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2991))))->
																				BgL_argsz00);
																			BgL_arg1809z00_3014 =
																				CDR(CDR(BgL_pairz00_3933));
																		}
																		{	/* Cfa/closure.scm 289 */
																			obj_t BgL_tmpz00_4632;

																			BgL_tmpz00_4632 =
																				((obj_t) BgL_arg1808z00_3013);
																			SET_CDR(BgL_tmpz00_4632,
																				BgL_arg1809z00_3014);
																		}
																	}
																	BgL_appz00_2991;
																}
															}
														}
													}
												}
											else
												{	/* Cfa/closure.scm 297 */
													BFALSE;
												}
										}
								}
							}
							{
								obj_t BgL_l1524z00_4635;

								BgL_l1524z00_4635 = CDR(BgL_l1524z00_2952);
								BgL_l1524z00_2952 = BgL_l1524z00_4635;
								goto BgL_zc3z04anonymousza31711ze3z87_2953;
							}
						}
					else
						{	/* Cfa/closure.scm 293 */
							return ((bool_t) 1);
						}
				}
			}
		}

	}



/* light-funcall! */
	bool_t BGl_lightzd2funcallz12zc0zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 303 */
			{
				obj_t BgL_l1531z00_3023;

				BgL_l1531z00_3023 = BGl_za2funcallzd2listza2zd2zzcfa_closurez00;
			BgL_zc3z04anonymousza31816ze3z87_3024:
				if (PAIRP(BgL_l1531z00_3023))
					{	/* Cfa/closure.scm 307 */
						{	/* Cfa/closure.scm 308 */
							BgL_funcallz00_bglt BgL_appz00_3026;

							BgL_appz00_3026 = ((BgL_funcallz00_bglt) CAR(BgL_l1531z00_3023));
							{	/* Cfa/closure.scm 309 */
								BgL_nodez00_bglt BgL_funz00_3027;

								BgL_funz00_3027 =
									(((BgL_funcallz00_bglt) COBJECT(BgL_appz00_3026))->
									BgL_funz00);
								{	/* Cfa/closure.scm 309 */
									BgL_approxz00_bglt BgL_approxz00_3028;

									BgL_approxz00_3028 =
										BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_3027);
									{	/* Cfa/closure.scm 310 */
										obj_t BgL_alloczd2listzd2_3029;

										BgL_alloczd2listzd2_3029 =
											BGl_setzd2ze3listz31zzcfa_setz00(
											(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_3028))->
												BgL_allocsz00));
										{	/* Cfa/closure.scm 311 */

											{	/* Cfa/closure.scm 312 */
												bool_t BgL_test2267z00_4645;

												if (PAIRP(BgL_alloczd2listzd2_3029))
													{	/* Cfa/closure.scm 313 */
														bool_t BgL_test2269z00_4648;

														{	/* Cfa/closure.scm 313 */
															obj_t BgL_arg1850z00_3074;

															BgL_arg1850z00_3074 =
																CAR(BgL_alloczd2listzd2_3029);
															BgL_test2269z00_4648 =
																BGl_isazf3zf3zz__objectz00(BgL_arg1850z00_3074,
																BGl_makezd2procedurezd2appz00zzcfa_info2z00);
														}
														if (BgL_test2269z00_4648)
															{	/* Cfa/closure.scm 313 */
																BgL_test2267z00_4645 = ((bool_t) 0);
															}
														else
															{	/* Cfa/closure.scm 313 */
																BgL_test2267z00_4645 = ((bool_t) 1);
															}
													}
												else
													{	/* Cfa/closure.scm 312 */
														BgL_test2267z00_4645 = ((bool_t) 1);
													}
												if (BgL_test2267z00_4645)
													{	/* Cfa/closure.scm 312 */
														CNST_TABLE_REF(((long) 8));
													}
												else
													{	/* Cfa/closure.scm 317 */
														BgL_appz00_bglt BgL_allocz00_3035;

														BgL_allocz00_3035 =
															((BgL_appz00_bglt)
															CAR(((obj_t) BgL_alloczd2listzd2_3029)));
														{	/* Cfa/closure.scm 320 */
															bool_t BgL_test2270z00_4655;

															{
																BgL_makezd2procedurezd2appz00_bglt
																	BgL_auxz00_4656;
																{
																	obj_t BgL_auxz00_4657;

																	{	/* Cfa/closure.scm 320 */
																		BgL_objectz00_bglt BgL_tmpz00_4658;

																		BgL_tmpz00_4658 =
																			((BgL_objectz00_bglt)
																			((BgL_appz00_bglt) BgL_allocz00_3035));
																		BgL_auxz00_4657 =
																			BGL_OBJECT_WIDENING(BgL_tmpz00_4658);
																	}
																	BgL_auxz00_4656 =
																		((BgL_makezd2procedurezd2appz00_bglt)
																		BgL_auxz00_4657);
																}
																BgL_test2270z00_4655 =
																	(((BgL_makezd2procedurezd2appz00_bglt)
																		COBJECT(BgL_auxz00_4656))->BgL_xz00);
															}
															if (BgL_test2270z00_4655)
																{	/* Cfa/closure.scm 320 */
																	{	/* Cfa/closure.scm 325 */
																		BgL_varz00_bglt BgL_arg1824z00_3038;

																		{	/* Cfa/closure.scm 325 */
																			BgL_nodez00_bglt
																				BgL_duplicated1174z00_3039;
																			BgL_varz00_bglt BgL_new1172z00_3040;

																			{	/* Cfa/closure.scm 325 */
																				obj_t BgL_pairz00_3948;

																				BgL_pairz00_3948 =
																					(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								((BgL_appz00_bglt)
																									BgL_allocz00_3035))))->
																					BgL_argsz00);
																				BgL_duplicated1174z00_3039 =
																					((BgL_nodez00_bglt)
																					CAR(BgL_pairz00_3948));
																			}
																			{	/* Cfa/closure.scm 326 */
																				BgL_varz00_bglt BgL_new1176z00_3050;

																				BgL_new1176z00_3050 =
																					((BgL_varz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_varz00_bgl))));
																				{	/* Cfa/closure.scm 326 */
																					long BgL_arg1833z00_3051;

																					BgL_arg1833z00_3051 =
																						BGL_CLASS_INDEX
																						(BGl_varz00zzast_nodez00);
																					BGL_OBJECT_CLASS_NUM_SET((
																							(BgL_objectz00_bglt)
																							BgL_new1176z00_3050),
																						BgL_arg1833z00_3051);
																				}
																				BgL_new1172z00_3040 =
																					BgL_new1176z00_3050;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1172z00_3040)))->
																					BgL_locz00) =
																				((obj_t) (((BgL_nodez00_bglt)
																							COBJECT
																							(BgL_duplicated1174z00_3039))->
																						BgL_locz00)), BUNSPEC);
																			{
																				BgL_typez00_bglt BgL_auxz00_4676;

																				{	/* Cfa/closure.scm 327 */
																					obj_t BgL_arg1825z00_3041;
																					BgL_typez00_bglt BgL_arg1826z00_3042;

																					{	/* Cfa/closure.scm 327 */
																						BgL_approxz00_bglt
																							BgL_arg1827z00_3043;
																						obj_t BgL_arg1828z00_3044;

																						{
																							BgL_makezd2procedurezd2appz00_bglt
																								BgL_auxz00_4678;
																							{
																								obj_t BgL_auxz00_4679;

																								{	/* Cfa/closure.scm 327 */
																									BgL_objectz00_bglt
																										BgL_tmpz00_4680;
																									BgL_tmpz00_4680 =
																										((BgL_objectz00_bglt) (
																											(BgL_appz00_bglt)
																											BgL_allocz00_3035));
																									BgL_auxz00_4679 =
																										BGL_OBJECT_WIDENING
																										(BgL_tmpz00_4680);
																								}
																								BgL_auxz00_4678 =
																									(
																									(BgL_makezd2procedurezd2appz00_bglt)
																									BgL_auxz00_4679);
																							}
																							BgL_arg1827z00_3043 =
																								(((BgL_makezd2procedurezd2appz00_bglt) COBJECT(BgL_auxz00_4678))->BgL_approxz00);
																						}
																						{	/* Cfa/closure.scm 327 */
																							obj_t BgL_pairz00_3953;

																							BgL_pairz00_3953 =
																								(((BgL_appz00_bglt) COBJECT(
																										((BgL_appz00_bglt)
																											((BgL_appz00_bglt)
																												BgL_allocz00_3035))))->
																								BgL_argsz00);
																							BgL_arg1828z00_3044 =
																								CAR(BgL_pairz00_3953);
																						}
																						BgL_arg1825z00_3041 =
																							BGl_getzd2approxzd2typez00zzcfa_typez00
																							(BgL_arg1827z00_3043,
																							BgL_arg1828z00_3044);
																					}
																					{
																						BgL_nodez00_bglt BgL_auxz00_4691;

																						{
																							BgL_varz00_bglt BgL_auxz00_4692;

																							{	/* Cfa/closure.scm 328 */
																								obj_t BgL_pairz00_3954;

																								BgL_pairz00_3954 =
																									(((BgL_appz00_bglt) COBJECT(
																											((BgL_appz00_bglt)
																												((BgL_appz00_bglt)
																													BgL_allocz00_3035))))->
																									BgL_argsz00);
																								BgL_auxz00_4692 =
																									((BgL_varz00_bglt)
																									CAR(BgL_pairz00_3954));
																							}
																							BgL_auxz00_4691 =
																								((BgL_nodez00_bglt)
																								BgL_auxz00_4692);
																						}
																						BgL_arg1826z00_3042 =
																							(((BgL_nodez00_bglt)
																								COBJECT(BgL_auxz00_4691))->
																							BgL_typez00);
																					}
																					BgL_auxz00_4676 =
																						BGl_strictzd2nodezd2typez00zzast_nodez00
																						(((BgL_typez00_bglt)
																							BgL_arg1825z00_3041),
																						BgL_arg1826z00_3042);
																				}
																				((((BgL_nodez00_bglt) COBJECT(
																								((BgL_nodez00_bglt)
																									BgL_new1172z00_3040)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) BgL_auxz00_4676),
																					BUNSPEC);
																			}
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_new1172z00_3040))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) ((
																							(BgL_varz00_bglt)
																							COBJECT(((BgL_varz00_bglt)
																									BgL_duplicated1174z00_3039)))->
																						BgL_variablez00)), BUNSPEC);
																			BgL_arg1824z00_3038 = BgL_new1172z00_3040;
																		}
																		((((BgL_funcallz00_bglt)
																					COBJECT(BgL_appz00_3026))->
																				BgL_funz00) =
																			((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
																					BgL_arg1824z00_3038)), BUNSPEC);
																	}
																	{	/* Cfa/closure.scm 329 */
																		obj_t BgL_arg1834z00_3052;

																		{	/* Cfa/closure.scm 329 */
																			obj_t BgL_arg1835z00_3053;

																			{	/* Cfa/closure.scm 329 */
																				obj_t BgL_pairz00_3958;

																				BgL_pairz00_3958 =
																					(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								((BgL_appz00_bglt)
																									BgL_allocz00_3035))))->
																					BgL_argsz00);
																				BgL_arg1835z00_3053 =
																					CAR(BgL_pairz00_3958);
																			}
																			{	/* Cfa/closure.scm 329 */
																				obj_t BgL_list1836z00_3054;

																				BgL_list1836z00_3054 =
																					MAKE_YOUNG_PAIR(BgL_arg1835z00_3053,
																					BNIL);
																				BgL_arg1834z00_3052 =
																					BgL_list1836z00_3054;
																		}}
																		((((BgL_funcallz00_bglt)
																					COBJECT(BgL_appz00_3026))->
																				BgL_functionsz00) =
																			((obj_t) BgL_arg1834z00_3052), BUNSPEC);
																	}
																	{	/* Cfa/closure.scm 330 */
																		obj_t BgL_vz00_3962;

																		BgL_vz00_3962 = CNST_TABLE_REF(((long) 1));
																		((((BgL_funcallz00_bglt)
																					COBJECT(BgL_appz00_3026))->
																				BgL_strengthz00) =
																			((obj_t) BgL_vz00_3962), BUNSPEC);
																}}
															else
																{	/* Cfa/closure.scm 331 */
																	bool_t BgL_test2271z00_4716;

																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4717;
																		{
																			obj_t BgL_auxz00_4718;

																			{	/* Cfa/closure.scm 331 */
																				BgL_objectz00_bglt BgL_tmpz00_4719;

																				BgL_tmpz00_4719 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt)
																						BgL_allocz00_3035));
																				BgL_auxz00_4718 =
																					BGL_OBJECT_WIDENING(BgL_tmpz00_4719);
																			}
																			BgL_auxz00_4717 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4718);
																		}
																		BgL_test2271z00_4716 =
																			(((BgL_makezd2procedurezd2appz00_bglt)
																				COBJECT(BgL_auxz00_4717))->BgL_tz00);
																	}
																	if (BgL_test2271z00_4716)
																		{	/* Cfa/closure.scm 331 */
																			{	/* Cfa/closure.scm 334 */
																				obj_t BgL_fz00_3057;

																				if (NULLP(BgL_alloczd2listzd2_3029))
																					{	/* Cfa/closure.scm 334 */
																						BgL_fz00_3057 = BNIL;
																					}
																				else
																					{	/* Cfa/closure.scm 334 */
																						obj_t BgL_head1528z00_3060;

																						BgL_head1528z00_3060 =
																							MAKE_YOUNG_PAIR(BNIL, BNIL);
																						{
																							obj_t BgL_l1526z00_3062;
																							obj_t BgL_tail1529z00_3063;

																							BgL_l1526z00_3062 =
																								BgL_alloczd2listzd2_3029;
																							BgL_tail1529z00_3063 =
																								BgL_head1528z00_3060;
																						BgL_zc3z04anonymousza31840ze3z87_3064:
																							if (NULLP
																								(BgL_l1526z00_3062))
																								{	/* Cfa/closure.scm 334 */
																									BgL_fz00_3057 =
																										CDR(BgL_head1528z00_3060);
																								}
																							else
																								{	/* Cfa/closure.scm 334 */
																									obj_t BgL_newtail1530z00_3066;

																									{	/* Cfa/closure.scm 334 */
																										obj_t BgL_arg1845z00_3068;

																										{	/* Cfa/closure.scm 335 */
																											obj_t BgL_pairz00_3967;

																											BgL_pairz00_3967 =
																												(((BgL_appz00_bglt)
																													COBJECT((
																															(BgL_appz00_bglt)
																															((BgL_appz00_bglt)
																																CAR(((obj_t)
																																		BgL_l1526z00_3062))))))->
																												BgL_argsz00);
																											BgL_arg1845z00_3068 =
																												CAR(BgL_pairz00_3967);
																										}
																										BgL_newtail1530z00_3066 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1845z00_3068,
																											BNIL);
																									}
																									SET_CDR(BgL_tail1529z00_3063,
																										BgL_newtail1530z00_3066);
																									{	/* Cfa/closure.scm 334 */
																										obj_t BgL_arg1843z00_3067;

																										BgL_arg1843z00_3067 =
																											CDR(
																											((obj_t)
																												BgL_l1526z00_3062));
																										{
																											obj_t
																												BgL_tail1529z00_4742;
																											obj_t BgL_l1526z00_4741;

																											BgL_l1526z00_4741 =
																												BgL_arg1843z00_3067;
																											BgL_tail1529z00_4742 =
																												BgL_newtail1530z00_3066;
																											BgL_tail1529z00_3063 =
																												BgL_tail1529z00_4742;
																											BgL_l1526z00_3062 =
																												BgL_l1526z00_4741;
																											goto
																												BgL_zc3z04anonymousza31840ze3z87_3064;
																										}
																									}
																								}
																						}
																					}
																				((((BgL_funcallz00_bglt)
																							COBJECT(BgL_appz00_3026))->
																						BgL_functionsz00) =
																					((obj_t) BgL_fz00_3057), BUNSPEC);
																				{	/* Cfa/closure.scm 338 */
																					obj_t BgL_vz00_3972;

																					BgL_vz00_3972 =
																						CNST_TABLE_REF(((long) 2));
																					((((BgL_funcallz00_bglt)
																								COBJECT(BgL_appz00_3026))->
																							BgL_strengthz00) =
																						((obj_t) BgL_vz00_3972), BUNSPEC);
																		}}}
																	else
																		{	/* Cfa/closure.scm 331 */
																			CNST_TABLE_REF(((long) 8));
						}}}}}}}}}}
						{
							obj_t BgL_l1531z00_4747;

							BgL_l1531z00_4747 = CDR(BgL_l1531z00_3023);
							BgL_l1531z00_3023 = BgL_l1531z00_4747;
							goto BgL_zc3z04anonymousza31816ze3z87_3024;
						}
					}
				else
					{	/* Cfa/closure.scm 307 */
						((bool_t) 1);
					}
			}
			if (CBOOL
				(BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00))
				{	/* Cfa/closure.scm 343 */
					{	/* Cfa/closure.scm 349 */
						obj_t BgL_funcallzd2lzd2_3078;

						{	/* Cfa/closure.scm 349 */
							obj_t BgL_hook1537z00_3102;

							BgL_hook1537z00_3102 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							{
								obj_t BgL_l1534z00_3104;
								obj_t BgL_h1535z00_3105;

								BgL_l1534z00_3104 = BGl_za2funcallzd2listza2zd2zzcfa_closurez00;
								BgL_h1535z00_3105 = BgL_hook1537z00_3102;
							BgL_zc3z04anonymousza31865ze3z87_3106:
								if (NULLP(BgL_l1534z00_3104))
									{	/* Cfa/closure.scm 349 */
										BgL_funcallzd2lzd2_3078 = CDR(BgL_hook1537z00_3102);
									}
								else
									{	/* Cfa/closure.scm 349 */
										if (
											((((BgL_funcallz00_bglt) COBJECT(
															((BgL_funcallz00_bglt)
																CAR(
																	((obj_t) BgL_l1534z00_3104)))))->
													BgL_strengthz00) == CNST_TABLE_REF(((long) 2))))
											{	/* Cfa/closure.scm 349 */
												obj_t BgL_nh1536z00_3111;

												{	/* Cfa/closure.scm 349 */
													obj_t BgL_arg1872z00_3113;

													BgL_arg1872z00_3113 =
														CAR(((obj_t) BgL_l1534z00_3104));
													BgL_nh1536z00_3111 =
														MAKE_YOUNG_PAIR(BgL_arg1872z00_3113, BNIL);
												}
												SET_CDR(BgL_h1535z00_3105, BgL_nh1536z00_3111);
												{	/* Cfa/closure.scm 349 */
													obj_t BgL_arg1871z00_3112;

													BgL_arg1871z00_3112 =
														CDR(((obj_t) BgL_l1534z00_3104));
													{
														obj_t BgL_h1535z00_4769;
														obj_t BgL_l1534z00_4768;

														BgL_l1534z00_4768 = BgL_arg1871z00_3112;
														BgL_h1535z00_4769 = BgL_nh1536z00_3111;
														BgL_h1535z00_3105 = BgL_h1535z00_4769;
														BgL_l1534z00_3104 = BgL_l1534z00_4768;
														goto BgL_zc3z04anonymousza31865ze3z87_3106;
													}
												}
											}
										else
											{	/* Cfa/closure.scm 349 */
												obj_t BgL_arg1873z00_3114;

												BgL_arg1873z00_3114 = CDR(((obj_t) BgL_l1534z00_3104));
												{
													obj_t BgL_l1534z00_4772;

													BgL_l1534z00_4772 = BgL_arg1873z00_3114;
													BgL_l1534z00_3104 = BgL_l1534z00_4772;
													goto BgL_zc3z04anonymousza31865ze3z87_3106;
												}
											}
									}
							}
						}
						{

						BgL_zc3z04anonymousza31855ze3z87_3080:
							{	/* Cfa/closure.scm 353 */
								bool_t BgL_contz00_3081;

								BgL_contz00_3081 = ((bool_t) 0);
								{
									obj_t BgL_l1538z00_3083;

									BgL_l1538z00_3083 = BgL_funcallzd2lzd2_3078;
								BgL_zc3z04anonymousza31856ze3z87_3084:
									if (PAIRP(BgL_l1538z00_3083))
										{	/* Cfa/closure.scm 354 */
											{	/* Cfa/closure.scm 355 */
												BgL_funcallz00_bglt BgL_appz00_3086;

												BgL_appz00_3086 =
													((BgL_funcallz00_bglt) CAR(BgL_l1538z00_3083));
												{	/* Cfa/closure.scm 355 */
													BgL_nodez00_bglt BgL_funz00_3087;

													BgL_funz00_3087 =
														(((BgL_funcallz00_bglt) COBJECT(BgL_appz00_3086))->
														BgL_funz00);
													{	/* Cfa/closure.scm 355 */
														BgL_approxz00_bglt BgL_approxz00_3088;

														BgL_approxz00_3088 =
															BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_3087);
														{	/* Cfa/closure.scm 356 */
															obj_t BgL_appsz00_3089;

															BgL_appsz00_3089 =
																BGl_setzd2ze3listz31zzcfa_setz00(
																(((BgL_approxz00_bglt)
																		COBJECT(BgL_approxz00_3088))->
																	BgL_allocsz00));
															{	/* Cfa/closure.scm 357 */

																if (PAIRP(BgL_appsz00_3089))
																	{	/* Cfa/closure.scm 358 */
																		{	/* Cfa/closure.scm 359 */
																			bool_t BgL_test2279z00_4783;

																			{	/* Cfa/closure.scm 359 */
																				obj_t BgL_tmpz00_4784;

																				BgL_tmpz00_4784 = CDR(BgL_appsz00_3089);
																				BgL_test2279z00_4783 =
																					PAIRP(BgL_tmpz00_4784);
																			}
																			if (BgL_test2279z00_4783)
																				{	/* Cfa/closure.scm 361 */
																					bool_t BgL__ortest_1177z00_3093;

																					BgL__ortest_1177z00_3093 =
																						BGl_mergezd2appzd2typesz12z12zzcfa_closurez00
																						(BgL_appsz00_3089);
																					if (BgL__ortest_1177z00_3093)
																						{	/* Cfa/closure.scm 361 */
																							BgL_contz00_3081 =
																								BgL__ortest_1177z00_3093;
																						}
																					else
																						{	/* Cfa/closure.scm 361 */
																							BgL_contz00_3081 =
																								BgL_contz00_3081;
																						}
																				}
																			else
																				{	/* Cfa/closure.scm 359 */
																					BFALSE;
																				}
																		}
																		{	/* Cfa/closure.scm 362 */
																			bool_t BgL_mz00_3095;

																			{	/* Cfa/closure.scm 363 */
																				BgL_approxz00_bglt BgL_arg1862z00_3097;

																				BgL_arg1862z00_3097 =
																					BGl_cfaz12z12zzcfa_cfaz00(
																					((BgL_nodez00_bglt) BgL_appz00_3086));
																				BgL_mz00_3095 =
																					BGl_mergezd2appzd2returnzd2typesz12zc0zzcfa_closurez00
																					(BgL_appsz00_3089,
																					BgL_arg1862z00_3097);
																			}
																			{	/* Cfa/closure.scm 364 */
																				bool_t BgL__ortest_1178z00_3096;

																				BgL__ortest_1178z00_3096 =
																					BgL_contz00_3081;
																				if (BgL__ortest_1178z00_3096)
																					{	/* Cfa/closure.scm 364 */
																						BgL_contz00_3081 =
																							BgL__ortest_1178z00_3096;
																					}
																				else
																					{	/* Cfa/closure.scm 364 */
																						BgL_contz00_3081 = BgL_mz00_3095;
																					}
																			}
																		}
																	}
																else
																	{	/* Cfa/closure.scm 358 */
																		BFALSE;
																	}
															}
														}
													}
												}
											}
											{
												obj_t BgL_l1538z00_4793;

												BgL_l1538z00_4793 = CDR(BgL_l1538z00_3083);
												BgL_l1538z00_3083 = BgL_l1538z00_4793;
												goto BgL_zc3z04anonymousza31856ze3z87_3084;
											}
										}
									else
										{	/* Cfa/closure.scm 354 */
											((bool_t) 1);
										}
								}
								if (BgL_contz00_3081)
									{	/* Cfa/closure.scm 366 */
										goto BgL_zc3z04anonymousza31855ze3z87_3080;
									}
								else
									{	/* Cfa/closure.scm 366 */
										return ((bool_t) 0);
									}
							}
						}
					}
				}
			else
				{	/* Cfa/closure.scm 343 */
					return ((bool_t) 0);
				}
		}

	}



/* merge-app-return-types! */
	bool_t BGl_mergezd2appzd2returnzd2typesz12zc0zzcfa_closurez00(obj_t
		BgL_appsz00_8, BgL_approxz00_bglt BgL_approxz00_9)
	{
		{	/* Cfa/closure.scm 372 */
			{	/* Cfa/closure.scm 373 */
				obj_t BgL_app0z00_3118;

				BgL_app0z00_3118 = CAR(BgL_appsz00_8);
				{	/* Cfa/closure.scm 373 */
					BgL_variablez00_bglt BgL_f0z00_3119;

					{
						BgL_varz00_bglt BgL_auxz00_4797;

						{	/* Cfa/closure.scm 374 */
							obj_t BgL_pairz00_3988;

							BgL_pairz00_3988 =
								(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt)
											((BgL_appz00_bglt) BgL_app0z00_3118))))->BgL_argsz00);
							BgL_auxz00_4797 = ((BgL_varz00_bglt) CAR(BgL_pairz00_3988));
						}
						BgL_f0z00_3119 =
							(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4797))->BgL_variablez00);
					}
					{	/* Cfa/closure.scm 374 */
						BgL_approxz00_bglt BgL_r0z00_3120;

						{	/* Cfa/closure.scm 375 */
							BgL_sfunz00_bglt BgL_oz00_3991;

							BgL_oz00_3991 =
								((BgL_sfunz00_bglt)
								(((BgL_variablez00_bglt) COBJECT(BgL_f0z00_3119))->
									BgL_valuez00));
							{
								BgL_internzd2sfunzf2cinfoz20_bglt BgL_auxz00_4806;

								{
									obj_t BgL_auxz00_4807;

									{	/* Cfa/closure.scm 375 */
										BgL_objectz00_bglt BgL_tmpz00_4808;

										BgL_tmpz00_4808 = ((BgL_objectz00_bglt) BgL_oz00_3991);
										BgL_auxz00_4807 = BGL_OBJECT_WIDENING(BgL_tmpz00_4808);
									}
									BgL_auxz00_4806 =
										((BgL_internzd2sfunzf2cinfoz20_bglt) BgL_auxz00_4807);
								}
								BgL_r0z00_3120 =
									(((BgL_internzd2sfunzf2cinfoz20_bglt)
										COBJECT(BgL_auxz00_4806))->BgL_approxz00);
							}
						}
						{	/* Cfa/closure.scm 375 */
							BgL_typez00_bglt BgL_rt0z00_3121;

							BgL_rt0z00_3121 =
								(((BgL_approxz00_bglt) COBJECT(BgL_r0z00_3120))->BgL_typez00);
							{	/* Cfa/closure.scm 376 */
								BgL_typez00_bglt BgL_brt0z00_3122;

								BgL_brt0z00_3122 =
									BGl_getzd2bigloozd2typez00zztype_cachez00(BgL_rt0z00_3121);
								{	/* Cfa/closure.scm 377 */
									BgL_typez00_bglt BgL_atz00_3123;

									BgL_atz00_3123 =
										(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_9))->
										BgL_typez00);
									{	/* Cfa/closure.scm 378 */

										{	/* Cfa/closure.scm 379 */
											bool_t BgL_test2283z00_4816;

											if (
												(((obj_t) BgL_rt0z00_3121) == ((obj_t) BgL_atz00_3123)))
												{	/* Cfa/closure.scm 379 */
													BgL_test2283z00_4816 = ((bool_t) 1);
												}
											else
												{	/* Cfa/closure.scm 379 */
													if (BGl_bigloozd2typezf3z21zztype_typez00
														(BgL_rt0z00_3121))
														{	/* Cfa/closure.scm 379 */
															BgL_test2283z00_4816 =
																BGl_bigloozd2typezf3z21zztype_typez00
																(BgL_atz00_3123);
														}
													else
														{	/* Cfa/closure.scm 379 */
															BgL_test2283z00_4816 = ((bool_t) 0);
														}
												}
											if (BgL_test2283z00_4816)
												{	/* Cfa/closure.scm 379 */
													return ((bool_t) 0);
												}
											else
												{	/* Cfa/closure.scm 379 */
													((((BgL_approxz00_bglt) COBJECT(BgL_approxz00_9))->
															BgL_typez00) =
														((BgL_typez00_bglt) (((BgL_approxz00_bglt)
																	COBJECT(BgL_r0z00_3120))->BgL_typez00)),
														BUNSPEC);
													return ((bool_t) 1);
												}
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* merge-app-types! */
	bool_t BGl_mergezd2appzd2typesz12z12zzcfa_closurez00(obj_t BgL_apps0z00_10)
	{
		{	/* Cfa/closure.scm 386 */
			{
				BgL_appz00_bglt BgL_app0z00_3146;
				BgL_appz00_bglt BgL_app1z00_3147;

				{	/* Cfa/closure.scm 455 */
					obj_t BgL_g1184z00_3134;

					BgL_g1184z00_3134 = CDR(((obj_t) BgL_apps0z00_10));
					{
						obj_t BgL_appsz00_3136;
						bool_t BgL_contz00_3137;

						BgL_appsz00_3136 = BgL_g1184z00_3134;
						BgL_contz00_3137 = ((bool_t) 0);
					BgL_zc3z04anonymousza31886ze3z87_3138:
						if (NULLP(BgL_appsz00_3136))
							{	/* Cfa/closure.scm 457 */
								return BgL_contz00_3137;
							}
						else
							{	/* Cfa/closure.scm 459 */
								obj_t BgL_arg1888z00_3140;
								bool_t BgL_arg1889z00_3141;

								BgL_arg1888z00_3140 = CDR(((obj_t) BgL_appsz00_3136));
								{	/* Cfa/closure.scm 459 */
									bool_t BgL__ortest_1185z00_3142;

									{	/* Cfa/closure.scm 459 */
										obj_t BgL_arg1890z00_3143;
										obj_t BgL_arg1891z00_3144;

										BgL_arg1890z00_3143 = CAR(((obj_t) BgL_apps0z00_10));
										BgL_arg1891z00_3144 = CAR(((obj_t) BgL_appsz00_3136));
										BgL_app0z00_3146 = ((BgL_appz00_bglt) BgL_arg1890z00_3143);
										BgL_app1z00_3147 = ((BgL_appz00_bglt) BgL_arg1891z00_3144);
										{	/* Cfa/closure.scm 389 */
											BgL_variablez00_bglt BgL_f0z00_3149;

											{
												BgL_varz00_bglt BgL_auxz00_4836;

												{	/* Cfa/closure.scm 389 */
													obj_t BgL_pairz00_3999;

													BgL_pairz00_3999 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt) BgL_app0z00_3146)))->
														BgL_argsz00);
													BgL_auxz00_4836 =
														((BgL_varz00_bglt) CAR(BgL_pairz00_3999));
												}
												BgL_f0z00_3149 =
													(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4836))->
													BgL_variablez00);
											}
											{	/* Cfa/closure.scm 389 */
												BgL_variablez00_bglt BgL_f1z00_3150;

												{
													BgL_varz00_bglt BgL_auxz00_4842;

													{	/* Cfa/closure.scm 390 */
														obj_t BgL_pairz00_4002;

														BgL_pairz00_4002 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_app1z00_3147)))->
															BgL_argsz00);
														BgL_auxz00_4842 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_4002));
													}
													BgL_f1z00_3150 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4842))->
														BgL_variablez00);
												}
												{	/* Cfa/closure.scm 390 */

													{	/* Cfa/closure.scm 392 */
														BgL_approxz00_bglt BgL_r0z00_3151;

														{	/* Cfa/closure.scm 392 */
															BgL_sfunz00_bglt BgL_oz00_4005;

															BgL_oz00_4005 =
																((BgL_sfunz00_bglt)
																(((BgL_variablez00_bglt)
																		COBJECT(BgL_f0z00_3149))->BgL_valuez00));
															{
																BgL_internzd2sfunzf2cinfoz20_bglt
																	BgL_auxz00_4850;
																{
																	obj_t BgL_auxz00_4851;

																	{	/* Cfa/closure.scm 392 */
																		BgL_objectz00_bglt BgL_tmpz00_4852;

																		BgL_tmpz00_4852 =
																			((BgL_objectz00_bglt) BgL_oz00_4005);
																		BgL_auxz00_4851 =
																			BGL_OBJECT_WIDENING(BgL_tmpz00_4852);
																	}
																	BgL_auxz00_4850 =
																		((BgL_internzd2sfunzf2cinfoz20_bglt)
																		BgL_auxz00_4851);
																}
																BgL_r0z00_3151 =
																	(((BgL_internzd2sfunzf2cinfoz20_bglt)
																		COBJECT(BgL_auxz00_4850))->BgL_approxz00);
															}
														}
														{	/* Cfa/closure.scm 392 */
															BgL_approxz00_bglt BgL_r1z00_3152;

															{	/* Cfa/closure.scm 393 */
																BgL_sfunz00_bglt BgL_oz00_4008;

																BgL_oz00_4008 =
																	((BgL_sfunz00_bglt)
																	(((BgL_variablez00_bglt)
																			COBJECT(BgL_f1z00_3150))->BgL_valuez00));
																{
																	BgL_internzd2sfunzf2cinfoz20_bglt
																		BgL_auxz00_4859;
																	{
																		obj_t BgL_auxz00_4860;

																		{	/* Cfa/closure.scm 393 */
																			BgL_objectz00_bglt BgL_tmpz00_4861;

																			BgL_tmpz00_4861 =
																				((BgL_objectz00_bglt) BgL_oz00_4008);
																			BgL_auxz00_4860 =
																				BGL_OBJECT_WIDENING(BgL_tmpz00_4861);
																		}
																		BgL_auxz00_4859 =
																			((BgL_internzd2sfunzf2cinfoz20_bglt)
																			BgL_auxz00_4860);
																	}
																	BgL_r1z00_3152 =
																		(((BgL_internzd2sfunzf2cinfoz20_bglt)
																			COBJECT(BgL_auxz00_4859))->BgL_approxz00);
																}
															}
															{	/* Cfa/closure.scm 393 */
																BgL_typez00_bglt BgL_rt0z00_3153;

																BgL_rt0z00_3153 =
																	(((BgL_approxz00_bglt)
																		COBJECT(BgL_r0z00_3151))->BgL_typez00);
																{	/* Cfa/closure.scm 394 */
																	BgL_typez00_bglt BgL_rt1z00_3154;

																	BgL_rt1z00_3154 =
																		(((BgL_approxz00_bglt)
																			COBJECT(BgL_r1z00_3152))->BgL_typez00);
																	{	/* Cfa/closure.scm 395 */
																		BgL_typez00_bglt BgL_brt0z00_3155;

																		BgL_brt0z00_3155 =
																			BGl_getzd2bigloozd2typez00zztype_cachez00
																			(BgL_rt0z00_3153);
																		{	/* Cfa/closure.scm 396 */
																			BgL_typez00_bglt BgL_brt1z00_3156;

																			BgL_brt1z00_3156 =
																				BGl_getzd2bigloozd2typez00zztype_cachez00
																				(BgL_rt1z00_3154);
																			{	/* Cfa/closure.scm 397 */

																				{	/* Cfa/closure.scm 398 */
																					bool_t BgL_test2287z00_4870;

																					if (
																						(((obj_t) BgL_rt0z00_3153) ==
																							((obj_t) BgL_rt1z00_3154)))
																						{	/* Cfa/closure.scm 398 */
																							BgL_test2287z00_4870 =
																								((bool_t) 1);
																						}
																					else
																						{	/* Cfa/closure.scm 398 */
																							if (BGl_bigloozd2typezf3z21zztype_typez00(BgL_rt0z00_3153))
																								{	/* Cfa/closure.scm 399 */
																									BgL_test2287z00_4870 =
																										BGl_bigloozd2typezf3z21zztype_typez00
																										(BgL_rt1z00_3154);
																								}
																							else
																								{	/* Cfa/closure.scm 399 */
																									BgL_test2287z00_4870 =
																										((bool_t) 0);
																								}
																						}
																					if (BgL_test2287z00_4870)
																						{	/* Cfa/closure.scm 398 */
																							BFALSE;
																						}
																					else
																						{	/* Cfa/closure.scm 398 */
																							if (
																								(((obj_t) BgL_rt0z00_3153) ==
																									((obj_t) BgL_brt0z00_3155)))
																								{	/* Cfa/closure.scm 400 */
																									BFALSE;
																								}
																							else
																								{	/* Cfa/closure.scm 400 */
																									((((BgL_approxz00_bglt)
																												COBJECT
																												(BgL_r0z00_3151))->
																											BgL_typez00) =
																										((BgL_typez00_bglt)
																											BgL_brt0z00_3155),
																										BUNSPEC);
																								}
																							if (
																								(((obj_t) BgL_rt1z00_3154) ==
																									((obj_t) BgL_brt1z00_3156)))
																								{	/* Cfa/closure.scm 402 */
																									BFALSE;
																								}
																							else
																								{	/* Cfa/closure.scm 402 */
																									((((BgL_approxz00_bglt)
																												COBJECT
																												(BgL_r1z00_3152))->
																											BgL_typez00) =
																										((BgL_typez00_bglt)
																											BgL_brt1z00_3156),
																										BUNSPEC);
																								}
																						}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
													{	/* Cfa/closure.scm 404 */
														obj_t BgL_g1181z00_3166;
														obj_t BgL_g1182z00_3167;

														{	/* Cfa/closure.scm 404 */
															obj_t BgL_pairz00_4018;

															BgL_pairz00_4018 =
																(((BgL_sfunz00_bglt) COBJECT(
																		((BgL_sfunz00_bglt)
																			(((BgL_variablez00_bglt)
																					COBJECT(BgL_f0z00_3149))->
																				BgL_valuez00))))->BgL_argsz00);
															BgL_g1181z00_3166 = CDR(BgL_pairz00_4018);
														}
														{	/* Cfa/closure.scm 405 */
															obj_t BgL_pairz00_4021;

															BgL_pairz00_4021 =
																(((BgL_sfunz00_bglt) COBJECT(
																		((BgL_sfunz00_bglt)
																			(((BgL_variablez00_bglt)
																					COBJECT(BgL_f1z00_3150))->
																				BgL_valuez00))))->BgL_argsz00);
															BgL_g1182z00_3167 = CDR(BgL_pairz00_4021);
														}
														{
															obj_t BgL_a0z00_3169;
															obj_t BgL_a1z00_3170;
															bool_t BgL_contz00_3171;

															BgL_a0z00_3169 = BgL_g1181z00_3166;
															BgL_a1z00_3170 = BgL_g1182z00_3167;
															BgL_contz00_3171 = ((bool_t) 0);
														BgL_zc3z04anonymousza31901ze3z87_3172:
															{	/* Cfa/closure.scm 407 */
																bool_t BgL_test2292z00_4896;

																if (PAIRP(BgL_a0z00_3169))
																	{	/* Cfa/closure.scm 407 */
																		BgL_test2292z00_4896 =
																			PAIRP(BgL_a1z00_3170);
																	}
																else
																	{	/* Cfa/closure.scm 407 */
																		BgL_test2292z00_4896 = ((bool_t) 0);
																	}
																if (BgL_test2292z00_4896)
																	{	/* Cfa/closure.scm 408 */
																		BgL_approxz00_bglt BgL_p0z00_3175;

																		{	/* Cfa/closure.scm 408 */
																			BgL_svarz00_bglt BgL_oz00_4024;

																			BgL_oz00_4024 =
																				((BgL_svarz00_bglt)
																				(((BgL_variablez00_bglt) COBJECT(
																							((BgL_variablez00_bglt)
																								CAR(BgL_a0z00_3169))))->
																					BgL_valuez00));
																			{
																				BgL_svarzf2cinfozf2_bglt
																					BgL_auxz00_4904;
																				{
																					obj_t BgL_auxz00_4905;

																					{	/* Cfa/closure.scm 408 */
																						BgL_objectz00_bglt BgL_tmpz00_4906;

																						BgL_tmpz00_4906 =
																							((BgL_objectz00_bglt)
																							BgL_oz00_4024);
																						BgL_auxz00_4905 =
																							BGL_OBJECT_WIDENING
																							(BgL_tmpz00_4906);
																					}
																					BgL_auxz00_4904 =
																						((BgL_svarzf2cinfozf2_bglt)
																						BgL_auxz00_4905);
																				}
																				BgL_p0z00_3175 =
																					(((BgL_svarzf2cinfozf2_bglt)
																						COBJECT(BgL_auxz00_4904))->
																					BgL_approxz00);
																			}
																		}
																		{	/* Cfa/closure.scm 408 */
																			BgL_approxz00_bglt BgL_p1z00_3176;

																			{	/* Cfa/closure.scm 409 */
																				BgL_svarz00_bglt BgL_oz00_4028;

																				BgL_oz00_4028 =
																					((BgL_svarz00_bglt)
																					(((BgL_variablez00_bglt) COBJECT(
																								((BgL_variablez00_bglt)
																									CAR(BgL_a1z00_3170))))->
																						BgL_valuez00));
																				{
																					BgL_svarzf2cinfozf2_bglt
																						BgL_auxz00_4915;
																					{
																						obj_t BgL_auxz00_4916;

																						{	/* Cfa/closure.scm 409 */
																							BgL_objectz00_bglt
																								BgL_tmpz00_4917;
																							BgL_tmpz00_4917 =
																								((BgL_objectz00_bglt)
																								BgL_oz00_4028);
																							BgL_auxz00_4916 =
																								BGL_OBJECT_WIDENING
																								(BgL_tmpz00_4917);
																						}
																						BgL_auxz00_4915 =
																							((BgL_svarzf2cinfozf2_bglt)
																							BgL_auxz00_4916);
																					}
																					BgL_p1z00_3176 =
																						(((BgL_svarzf2cinfozf2_bglt)
																							COBJECT(BgL_auxz00_4915))->
																						BgL_approxz00);
																				}
																			}
																			{	/* Cfa/closure.scm 409 */
																				BgL_typez00_bglt BgL_t0z00_3177;

																				BgL_t0z00_3177 =
																					(((BgL_approxz00_bglt)
																						COBJECT(BgL_p0z00_3175))->
																					BgL_typez00);
																				{	/* Cfa/closure.scm 410 */
																					BgL_typez00_bglt BgL_t1z00_3178;

																					BgL_t1z00_3178 =
																						(((BgL_approxz00_bglt)
																							COBJECT(BgL_p1z00_3176))->
																						BgL_typez00);
																					{	/* Cfa/closure.scm 411 */

																						{	/* Cfa/closure.scm 412 */
																							bool_t BgL_test2294z00_4924;

																							if (
																								(((obj_t) BgL_t0z00_3177) ==
																									((obj_t) BgL_t1z00_3178)))
																								{	/* Cfa/closure.scm 412 */
																									BgL_test2294z00_4924 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Cfa/closure.scm 412 */
																									if (BGl_bigloozd2typezf3z21zztype_typez00(BgL_t0z00_3177))
																										{	/* Cfa/closure.scm 412 */
																											BgL_test2294z00_4924 =
																												BGl_bigloozd2typezf3z21zztype_typez00
																												(BgL_t1z00_3178);
																										}
																									else
																										{	/* Cfa/closure.scm 412 */
																											BgL_test2294z00_4924 =
																												((bool_t) 0);
																										}
																								}
																							if (BgL_test2294z00_4924)
																								{
																									obj_t BgL_a1z00_4934;
																									obj_t BgL_a0z00_4932;

																									BgL_a0z00_4932 =
																										CDR(BgL_a0z00_3169);
																									BgL_a1z00_4934 =
																										CDR(BgL_a1z00_3170);
																									BgL_a1z00_3170 =
																										BgL_a1z00_4934;
																									BgL_a0z00_3169 =
																										BgL_a0z00_4932;
																									goto
																										BgL_zc3z04anonymousza31901ze3z87_3172;
																								}
																							else
																								{	/* Cfa/closure.scm 435 */
																									BgL_typez00_bglt
																										BgL_bt0z00_3184;
																									BgL_typez00_bglt
																										BgL_bt1z00_3185;
																									bool_t BgL_contz00_3186;

																									BgL_bt0z00_3184 =
																										BGl_getzd2bigloozd2typez00zztype_cachez00
																										(BgL_t0z00_3177);
																									BgL_bt1z00_3185 =
																										BGl_getzd2bigloozd2typez00zztype_cachez00
																										(BgL_t1z00_3178);
																									BgL_contz00_3186 =
																										((bool_t) 0);
																									if ((((obj_t) ((
																														(BgL_variablez00_bglt)
																														COBJECT((
																																(BgL_variablez00_bglt)
																																CAR
																																(BgL_a0z00_3169))))->
																													BgL_typez00)) ==
																											((obj_t)
																												BgL_bt0z00_3184)))
																										{	/* Cfa/closure.scm 438 */
																											BFALSE;
																										}
																									else
																										{	/* Cfa/closure.scm 438 */
																											{	/* Cfa/closure.scm 440 */
																												obj_t
																													BgL_arg1912z00_3190;
																												BgL_arg1912z00_3190 =
																													CAR(BgL_a0z00_3169);
																												((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt) BgL_arg1912z00_3190)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_bt0z00_3184), BUNSPEC);
																											}
																											((((BgL_approxz00_bglt)
																														COBJECT
																														(BgL_p0z00_3175))->
																													BgL_typez00) =
																												((BgL_typez00_bglt)
																													BgL_bt0z00_3184),
																												BUNSPEC);
																											BgL_contz00_3186 =
																												((bool_t) 1);
																										}
																									if (
																										(((obj_t)
																												(((BgL_variablez00_bglt)
																														COBJECT((
																																(BgL_variablez00_bglt)
																																CAR
																																(BgL_a1z00_3170))))->
																													BgL_typez00)) ==
																											((obj_t)
																												BgL_bt1z00_3185)))
																										{	/* Cfa/closure.scm 444 */
																											BFALSE;
																										}
																									else
																										{	/* Cfa/closure.scm 444 */
																											{	/* Cfa/closure.scm 446 */
																												obj_t
																													BgL_arg1919z00_3196;
																												BgL_arg1919z00_3196 =
																													CAR(BgL_a1z00_3170);
																												((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt) BgL_arg1919z00_3196)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_bt1z00_3185), BUNSPEC);
																											}
																											((((BgL_approxz00_bglt)
																														COBJECT
																														(BgL_p1z00_3176))->
																													BgL_typez00) =
																												((BgL_typez00_bglt)
																													BgL_bt1z00_3185),
																												BUNSPEC);
																											BgL_contz00_3186 =
																												((bool_t) 1);
																										}
																									{	/* Cfa/closure.scm 452 */
																										obj_t BgL_arg1922z00_3199;
																										obj_t BgL_arg1923z00_3200;

																										BgL_arg1922z00_3199 =
																											CDR(BgL_a0z00_3169);
																										BgL_arg1923z00_3200 =
																											CDR(BgL_a1z00_3170);
																										{
																											bool_t BgL_contz00_4964;
																											obj_t BgL_a1z00_4963;
																											obj_t BgL_a0z00_4962;

																											BgL_a0z00_4962 =
																												BgL_arg1922z00_3199;
																											BgL_a1z00_4963 =
																												BgL_arg1923z00_3200;
																											BgL_contz00_4964 =
																												BgL_contz00_3186;
																											BgL_contz00_3171 =
																												BgL_contz00_4964;
																											BgL_a1z00_3170 =
																												BgL_a1z00_4963;
																											BgL_a0z00_3169 =
																												BgL_a0z00_4962;
																											goto
																												BgL_zc3z04anonymousza31901ze3z87_3172;
																										}
																									}
																								}
																						}
																					}
																				}
																			}
																		}
																	}
																else
																	{	/* Cfa/closure.scm 407 */
																		BgL__ortest_1185z00_3142 = BgL_contz00_3171;
																	}
															}
														}
													}
												}
											}
										}
									}
									if (BgL__ortest_1185z00_3142)
										{	/* Cfa/closure.scm 459 */
											BgL_arg1889z00_3141 = BgL__ortest_1185z00_3142;
										}
									else
										{	/* Cfa/closure.scm 459 */
											BgL_arg1889z00_3141 = BgL_contz00_3137;
										}
								}
								{
									bool_t BgL_contz00_4969;
									obj_t BgL_appsz00_4968;

									BgL_appsz00_4968 = BgL_arg1888z00_3140;
									BgL_contz00_4969 = BgL_arg1889z00_3141;
									BgL_contz00_3137 = BgL_contz00_4969;
									BgL_appsz00_3136 = BgL_appsz00_4968;
									goto BgL_zc3z04anonymousza31886ze3z87_3138;
								}
							}
					}
				}
			}
		}

	}



/* type-closures! */
	BGL_EXPORTED_DEF obj_t BGl_typezd2closuresz12zc0zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 464 */
			{
				BgL_appz00_bglt BgL_appz00_3227;

				if (CBOOL
					(BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00))
					{	/* Cfa/closure.scm 491 */
						obj_t BgL_g1545z00_3219;

						BgL_g1545z00_3219 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
						{
							obj_t BgL_l1543z00_3221;

							{	/* Cfa/closure.scm 491 */
								bool_t BgL_tmpz00_4972;

								BgL_l1543z00_3221 = BgL_g1545z00_3219;
							BgL_zc3z04anonymousza31938ze3z87_3222:
								if (PAIRP(BgL_l1543z00_3221))
									{	/* Cfa/closure.scm 491 */
										{	/* Cfa/closure.scm 491 */
											obj_t BgL_arg1940z00_3224;

											BgL_arg1940z00_3224 = CAR(BgL_l1543z00_3221);
											BgL_appz00_3227 = ((BgL_appz00_bglt) BgL_arg1940z00_3224);
											{	/* Cfa/closure.scm 475 */
												bool_t BgL_test2302z00_4976;

												{	/* Cfa/closure.scm 475 */
													bool_t BgL_test2303z00_4977;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4978;

														{
															obj_t BgL_auxz00_4979;

															{	/* Cfa/closure.scm 475 */
																BgL_objectz00_bglt BgL_tmpz00_4980;

																BgL_tmpz00_4980 =
																	((BgL_objectz00_bglt) BgL_appz00_3227);
																BgL_auxz00_4979 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4980);
															}
															BgL_auxz00_4978 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_4979);
														}
														BgL_test2303z00_4977 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																COBJECT(BgL_auxz00_4978))->BgL_xz00);
													}
													if (BgL_test2303z00_4977)
														{	/* Cfa/closure.scm 475 */
															BgL_test2302z00_4976 = ((bool_t) 1);
														}
													else
														{
															BgL_makezd2procedurezd2appz00_bglt
																BgL_auxz00_4985;
															{
																obj_t BgL_auxz00_4986;

																{	/* Cfa/closure.scm 475 */
																	BgL_objectz00_bglt BgL_tmpz00_4987;

																	BgL_tmpz00_4987 =
																		((BgL_objectz00_bglt) BgL_appz00_3227);
																	BgL_auxz00_4986 =
																		BGL_OBJECT_WIDENING(BgL_tmpz00_4987);
																}
																BgL_auxz00_4985 =
																	((BgL_makezd2procedurezd2appz00_bglt)
																	BgL_auxz00_4986);
															}
															BgL_test2302z00_4976 =
																(((BgL_makezd2procedurezd2appz00_bglt)
																	COBJECT(BgL_auxz00_4985))->BgL_tz00);
														}
												}
												if (BgL_test2302z00_4976)
													{	/* Cfa/closure.scm 475 */
														((bool_t) 0);
													}
												else
													{	/* Cfa/closure.scm 477 */
														BgL_variablez00_bglt BgL_varz00_3232;

														{
															BgL_varz00_bglt BgL_auxz00_4992;

															{	/* Cfa/closure.scm 477 */
																obj_t BgL_pairz00_4056;

																BgL_pairz00_4056 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt) BgL_appz00_3227)))->
																	BgL_argsz00);
																BgL_auxz00_4992 =
																	((BgL_varz00_bglt) CAR(BgL_pairz00_4056));
															}
															BgL_varz00_3232 =
																(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4992))->
																BgL_variablez00);
														}
														{	/* Cfa/closure.scm 477 */
															BgL_valuez00_bglt BgL_sfunz00_3233;

															BgL_sfunz00_3233 =
																(((BgL_variablez00_bglt)
																	COBJECT(BgL_varz00_3232))->BgL_valuez00);
															{	/* Cfa/closure.scm 478 */

																((((BgL_variablez00_bglt)
																			COBJECT(BgL_varz00_3232))->BgL_typez00) =
																	((BgL_typez00_bglt)
																		BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00
																		((((BgL_variablez00_bglt)
																					COBJECT(BgL_varz00_3232))->
																				BgL_typez00))), BUNSPEC);
																{	/* Cfa/closure.scm 481 */
																	obj_t BgL_g1542z00_3236;

																	{	/* Cfa/closure.scm 488 */
																		obj_t BgL_pairz00_4063;

																		BgL_pairz00_4063 =
																			(((BgL_sfunz00_bglt) COBJECT(
																					((BgL_sfunz00_bglt)
																						BgL_sfunz00_3233)))->BgL_argsz00);
																		BgL_g1542z00_3236 = CDR(BgL_pairz00_4063);
																	}
																	{
																		obj_t BgL_l1540z00_3238;

																		BgL_l1540z00_3238 = BgL_g1542z00_3236;
																	BgL_zc3z04anonymousza31947ze3z87_3239:
																		if (PAIRP(BgL_l1540z00_3238))
																			{	/* Cfa/closure.scm 488 */
																				{	/* Cfa/closure.scm 482 */
																					obj_t BgL_az00_3241;

																					BgL_az00_3241 =
																						CAR(BgL_l1540z00_3238);
																					{	/* Cfa/closure.scm 482 */
																						BgL_approxz00_bglt BgL_pz00_3242;

																						{	/* Cfa/closure.scm 482 */
																							BgL_svarz00_bglt BgL_oz00_4066;

																							BgL_oz00_4066 =
																								((BgL_svarz00_bglt)
																								(((BgL_variablez00_bglt)
																										COBJECT((
																												(BgL_variablez00_bglt)
																												BgL_az00_3241)))->
																									BgL_valuez00));
																							{
																								BgL_svarzf2cinfozf2_bglt
																									BgL_auxz00_5011;
																								{
																									obj_t BgL_auxz00_5012;

																									{	/* Cfa/closure.scm 482 */
																										BgL_objectz00_bglt
																											BgL_tmpz00_5013;
																										BgL_tmpz00_5013 =
																											((BgL_objectz00_bglt)
																											BgL_oz00_4066);
																										BgL_auxz00_5012 =
																											BGL_OBJECT_WIDENING
																											(BgL_tmpz00_5013);
																									}
																									BgL_auxz00_5011 =
																										((BgL_svarzf2cinfozf2_bglt)
																										BgL_auxz00_5012);
																								}
																								BgL_pz00_3242 =
																									(((BgL_svarzf2cinfozf2_bglt)
																										COBJECT(BgL_auxz00_5011))->
																									BgL_approxz00);
																							}
																						}
																						{	/* Cfa/closure.scm 482 */
																							BgL_typez00_bglt BgL_tz00_3243;

																							BgL_tz00_3243 =
																								(((BgL_approxz00_bglt)
																									COBJECT(BgL_pz00_3242))->
																								BgL_typez00);
																							{	/* Cfa/closure.scm 483 */

																								{	/* Cfa/closure.scm 487 */
																									BgL_typez00_bglt
																										BgL_arg1949z00_3244;
																									BgL_arg1949z00_3244 =
																										BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00
																										(BgL_tz00_3243);
																									((((BgL_variablez00_bglt)
																												COBJECT((
																														(BgL_variablez00_bglt)
																														BgL_az00_3241)))->
																											BgL_typez00) =
																										((BgL_typez00_bglt)
																											BgL_arg1949z00_3244),
																										BUNSPEC);
																								}
																							}
																						}
																					}
																				}
																				{
																					obj_t BgL_l1540z00_5022;

																					BgL_l1540z00_5022 =
																						CDR(BgL_l1540z00_3238);
																					BgL_l1540z00_3238 = BgL_l1540z00_5022;
																					goto
																						BgL_zc3z04anonymousza31947ze3z87_3239;
																				}
																			}
																		else
																			{	/* Cfa/closure.scm 488 */
																				((bool_t) 1);
																			}
																	}
																}
															}
														}
													}
											}
										}
										{
											obj_t BgL_l1543z00_5025;

											BgL_l1543z00_5025 = CDR(BgL_l1543z00_3221);
											BgL_l1543z00_3221 = BgL_l1543z00_5025;
											goto BgL_zc3z04anonymousza31938ze3z87_3222;
										}
									}
								else
									{	/* Cfa/closure.scm 491 */
										BgL_tmpz00_4972 = ((bool_t) 1);
									}
								return BBOOL(BgL_tmpz00_4972);
							}
						}
					}
				else
					{	/* Cfa/closure.scm 490 */
						return BFALSE;
					}
			}
		}

	}



/* &type-closures! */
	obj_t BGl_z62typezd2closuresz12za2zzcfa_closurez00(obj_t BgL_envz00_4132)
	{
		{	/* Cfa/closure.scm 464 */
			return BGl_typezd2closuresz12zc0zzcfa_closurez00();
		}

	}



/* light-access! */
	bool_t BGl_lightzd2accessz12zc0zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 496 */
			{
				obj_t BgL_l1546z00_3254;

				BgL_l1546z00_3254 = BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00;
			BgL_zc3z04anonymousza31956ze3z87_3255:
				if (PAIRP(BgL_l1546z00_3254))
					{	/* Cfa/closure.scm 497 */
						{	/* Cfa/closure.scm 499 */
							obj_t BgL_appz00_3257;

							BgL_appz00_3257 = CAR(BgL_l1546z00_3254);
							{	/* Cfa/closure.scm 499 */
								BgL_approxz00_bglt BgL_approxz00_3259;

								{	/* Cfa/closure.scm 500 */
									obj_t BgL_arg1969z00_3278;

									{	/* Cfa/closure.scm 500 */
										obj_t BgL_pairz00_4078;

										BgL_pairz00_4078 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_appz00_3257)))->BgL_argsz00);
										BgL_arg1969z00_3278 = CAR(BgL_pairz00_4078);
									}
									BgL_approxz00_3259 =
										BGl_cfaz12z12zzcfa_cfaz00(
										((BgL_nodez00_bglt) BgL_arg1969z00_3278));
								}
								{	/* Cfa/closure.scm 500 */
									obj_t BgL_alloczd2listzd2_3260;

									BgL_alloczd2listzd2_3260 =
										BGl_setzd2ze3listz31zzcfa_setz00(
										(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_3259))->
											BgL_allocsz00));
									{	/* Cfa/closure.scm 501 */
										BgL_varz00_bglt BgL_funz00_3261;

										BgL_funz00_3261 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_appz00_3257)))->BgL_funz00);
										{	/* Cfa/closure.scm 502 */
											BgL_variablez00_bglt BgL_vfunz00_3262;

											BgL_vfunz00_3262 =
												(((BgL_varz00_bglt) COBJECT(BgL_funz00_3261))->
												BgL_variablez00);
											{	/* Cfa/closure.scm 503 */

												{	/* Cfa/closure.scm 504 */
													bool_t BgL_test2306z00_5042;

													if (PAIRP(BgL_alloczd2listzd2_3260))
														{	/* Cfa/closure.scm 505 */
															bool_t BgL_test2308z00_5045;

															{	/* Cfa/closure.scm 505 */
																obj_t BgL_arg1967z00_3276;

																BgL_arg1967z00_3276 =
																	CAR(BgL_alloczd2listzd2_3260);
																BgL_test2308z00_5045 =
																	BGl_isazf3zf3zz__objectz00
																	(BgL_arg1967z00_3276,
																	BGl_makezd2procedurezd2appz00zzcfa_info2z00);
															}
															if (BgL_test2308z00_5045)
																{	/* Cfa/closure.scm 505 */
																	BgL_test2306z00_5042 = ((bool_t) 0);
																}
															else
																{	/* Cfa/closure.scm 505 */
																	BgL_test2306z00_5042 = ((bool_t) 1);
																}
														}
													else
														{	/* Cfa/closure.scm 504 */
															BgL_test2306z00_5042 = ((bool_t) 1);
														}
													if (BgL_test2306z00_5042)
														{	/* Cfa/closure.scm 504 */
															CNST_TABLE_REF(((long) 8));
														}
													else
														{	/* Cfa/closure.scm 507 */
															BgL_appz00_bglt BgL_allocz00_3268;

															BgL_allocz00_3268 =
																((BgL_appz00_bglt)
																CAR(((obj_t) BgL_alloczd2listzd2_3260)));
															{	/* Cfa/closure.scm 510 */
																bool_t BgL_test2309z00_5052;

																{
																	BgL_makezd2procedurezd2appz00_bglt
																		BgL_auxz00_5053;
																	{
																		obj_t BgL_auxz00_5054;

																		{	/* Cfa/closure.scm 510 */
																			BgL_objectz00_bglt BgL_tmpz00_5055;

																			BgL_tmpz00_5055 =
																				((BgL_objectz00_bglt)
																				((BgL_appz00_bglt) BgL_allocz00_3268));
																			BgL_auxz00_5054 =
																				BGL_OBJECT_WIDENING(BgL_tmpz00_5055);
																		}
																		BgL_auxz00_5053 =
																			((BgL_makezd2procedurezd2appz00_bglt)
																			BgL_auxz00_5054);
																	}
																	BgL_test2309z00_5052 =
																		(((BgL_makezd2procedurezd2appz00_bglt)
																			COBJECT(BgL_auxz00_5053))->BgL_xz00);
																}
																if (BgL_test2309z00_5052)
																	{	/* Cfa/closure.scm 510 */
																		if (
																			(((obj_t) BgL_vfunz00_3262) ==
																				BGl_za2procedurezd2refza2zd2zzcfa_closurez00))
																			{	/* Cfa/closure.scm 512 */
																				BgL_variablez00_bglt BgL_vz00_4086;

																				BgL_vz00_4086 =
																					((BgL_variablez00_bglt)
																					BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							COBJECT(BgL_funz00_3261))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_4086), BUNSPEC);
																			}
																		else
																			{	/* Cfa/closure.scm 513 */
																				BgL_variablez00_bglt BgL_vz00_4088;

																				BgL_vz00_4088 =
																					((BgL_variablez00_bglt)
																					BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							COBJECT(BgL_funz00_3261))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_4088), BUNSPEC);
																			}
																	}
																else
																	{	/* Cfa/closure.scm 514 */
																		bool_t BgL_test2311z00_5068;

																		{
																			BgL_makezd2procedurezd2appz00_bglt
																				BgL_auxz00_5069;
																			{
																				obj_t BgL_auxz00_5070;

																				{	/* Cfa/closure.scm 514 */
																					BgL_objectz00_bglt BgL_tmpz00_5071;

																					BgL_tmpz00_5071 =
																						((BgL_objectz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_allocz00_3268));
																					BgL_auxz00_5070 =
																						BGL_OBJECT_WIDENING
																						(BgL_tmpz00_5071);
																				}
																				BgL_auxz00_5069 =
																					((BgL_makezd2procedurezd2appz00_bglt)
																					BgL_auxz00_5070);
																			}
																			BgL_test2311z00_5068 =
																				(((BgL_makezd2procedurezd2appz00_bglt)
																					COBJECT(BgL_auxz00_5069))->BgL_tz00);
																		}
																		if (BgL_test2311z00_5068)
																			{	/* Cfa/closure.scm 514 */
																				if (
																					(((obj_t) BgL_vfunz00_3262) ==
																						BGl_za2procedurezd2refza2zd2zzcfa_closurez00))
																					{	/* Cfa/closure.scm 516 */
																						BgL_variablez00_bglt BgL_vz00_4091;

																						BgL_vz00_4091 =
																							((BgL_variablez00_bglt)
																							BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00);
																						((((BgL_varz00_bglt)
																									COBJECT(BgL_funz00_3261))->
																								BgL_variablez00) =
																							((BgL_variablez00_bglt)
																								BgL_vz00_4091), BUNSPEC);
																					}
																				else
																					{	/* Cfa/closure.scm 517 */
																						BgL_variablez00_bglt BgL_vz00_4093;

																						BgL_vz00_4093 =
																							((BgL_variablez00_bglt)
																							BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00);
																						((((BgL_varz00_bglt)
																									COBJECT(BgL_funz00_3261))->
																								BgL_variablez00) =
																							((BgL_variablez00_bglt)
																								BgL_vz00_4093), BUNSPEC);
																					}
																			}
																		else
																			{	/* Cfa/closure.scm 514 */
																				BFALSE;
																			}
																	}
															}
														}
												}
											}
										}
									}
								}
							}
						}
						{
							obj_t BgL_l1546z00_5084;

							BgL_l1546z00_5084 = CDR(BgL_l1546z00_3254);
							BgL_l1546z00_3254 = BgL_l1546z00_5084;
							goto BgL_zc3z04anonymousza31956ze3z87_3255;
						}
					}
				else
					{	/* Cfa/closure.scm 497 */
						return ((bool_t) 1);
					}
			}
		}

	}



/* show-X-T */
	obj_t BGl_showzd2Xzd2Tz00zzcfa_closurez00(obj_t BgL_allocsz00_11)
	{
		{	/* Cfa/closure.scm 523 */
			{
				obj_t BgL_xpz00_3286;
				obj_t BgL_tpz00_3287;
				obj_t BgL_allocsz00_3288;

				BgL_xpz00_3286 = BNIL;
				BgL_tpz00_3287 = BNIL;
				BgL_allocsz00_3288 = BgL_allocsz00_11;
			BgL_zc3z04anonymousza31972ze3z87_3289:
				if (NULLP(BgL_allocsz00_3288))
					{	/* Cfa/closure.scm 534 */
						BGl_showze70ze7zzcfa_closurez00(CNST_TABLE_REF(((long) 9)),
							BgL_xpz00_3286);
						BGl_showze70ze7zzcfa_closurez00(CNST_TABLE_REF(((long) 10)),
							BgL_tpz00_3287);
						return BUNSPEC;
					}
				else
					{	/* Cfa/closure.scm 539 */
						BgL_appz00_bglt BgL_i1191z00_3291;

						BgL_i1191z00_3291 =
							((BgL_appz00_bglt) CAR(((obj_t) BgL_allocsz00_3288)));
						{	/* Cfa/closure.scm 541 */
							bool_t BgL_test2314z00_5095;

							{
								BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_5096;

								{
									obj_t BgL_auxz00_5097;

									{	/* Cfa/closure.scm 541 */
										BgL_objectz00_bglt BgL_tmpz00_5098;

										BgL_tmpz00_5098 = ((BgL_objectz00_bglt) BgL_i1191z00_3291);
										BgL_auxz00_5097 = BGL_OBJECT_WIDENING(BgL_tmpz00_5098);
									}
									BgL_auxz00_5096 =
										((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_5097);
								}
								BgL_test2314z00_5095 =
									(((BgL_makezd2procedurezd2appz00_bglt)
										COBJECT(BgL_auxz00_5096))->BgL_xz00);
							}
							if (BgL_test2314z00_5095)
								{	/* Cfa/closure.scm 542 */
									obj_t BgL_arg1975z00_3293;
									obj_t BgL_arg1976z00_3294;

									{	/* Cfa/closure.scm 542 */
										BgL_variablez00_bglt BgL_arg1977z00_3295;

										{
											BgL_varz00_bglt BgL_auxz00_5103;

											{	/* Cfa/closure.scm 542 */
												obj_t BgL_pairz00_4101;

												BgL_pairz00_4101 =
													(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt) BgL_i1191z00_3291)))->
													BgL_argsz00);
												BgL_auxz00_5103 =
													((BgL_varz00_bglt) CAR(BgL_pairz00_4101));
											}
											BgL_arg1977z00_3295 =
												(((BgL_varz00_bglt) COBJECT(BgL_auxz00_5103))->
												BgL_variablez00);
										}
										BgL_arg1975z00_3293 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg1977z00_3295), BgL_xpz00_3286);
									}
									BgL_arg1976z00_3294 = CDR(((obj_t) BgL_allocsz00_3288));
									{
										obj_t BgL_allocsz00_5114;
										obj_t BgL_xpz00_5113;

										BgL_xpz00_5113 = BgL_arg1975z00_3293;
										BgL_allocsz00_5114 = BgL_arg1976z00_3294;
										BgL_allocsz00_3288 = BgL_allocsz00_5114;
										BgL_xpz00_3286 = BgL_xpz00_5113;
										goto BgL_zc3z04anonymousza31972ze3z87_3289;
									}
								}
							else
								{	/* Cfa/closure.scm 543 */
									bool_t BgL_test2315z00_5115;

									{
										BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_5116;

										{
											obj_t BgL_auxz00_5117;

											{	/* Cfa/closure.scm 543 */
												BgL_objectz00_bglt BgL_tmpz00_5118;

												BgL_tmpz00_5118 =
													((BgL_objectz00_bglt) BgL_i1191z00_3291);
												BgL_auxz00_5117 = BGL_OBJECT_WIDENING(BgL_tmpz00_5118);
											}
											BgL_auxz00_5116 =
												((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_5117);
										}
										BgL_test2315z00_5115 =
											(((BgL_makezd2procedurezd2appz00_bglt)
												COBJECT(BgL_auxz00_5116))->BgL_tz00);
									}
									if (BgL_test2315z00_5115)
										{	/* Cfa/closure.scm 544 */
											obj_t BgL_arg1981z00_3299;
											obj_t BgL_arg1982z00_3300;

											{	/* Cfa/closure.scm 544 */
												BgL_variablez00_bglt BgL_arg1984z00_3301;

												{
													BgL_varz00_bglt BgL_auxz00_5123;

													{	/* Cfa/closure.scm 544 */
														obj_t BgL_pairz00_4105;

														BgL_pairz00_4105 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_i1191z00_3291)))->
															BgL_argsz00);
														BgL_auxz00_5123 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_4105));
													}
													BgL_arg1984z00_3301 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_5123))->
														BgL_variablez00);
												}
												BgL_arg1981z00_3299 =
													MAKE_YOUNG_PAIR(
													((obj_t) BgL_arg1984z00_3301), BgL_tpz00_3287);
											}
											BgL_arg1982z00_3300 = CDR(((obj_t) BgL_allocsz00_3288));
											{
												obj_t BgL_allocsz00_5134;
												obj_t BgL_tpz00_5133;

												BgL_tpz00_5133 = BgL_arg1981z00_3299;
												BgL_allocsz00_5134 = BgL_arg1982z00_3300;
												BgL_allocsz00_3288 = BgL_allocsz00_5134;
												BgL_tpz00_3287 = BgL_tpz00_5133;
												goto BgL_zc3z04anonymousza31972ze3z87_3289;
											}
										}
									else
										{	/* Cfa/closure.scm 546 */
											obj_t BgL_arg1987z00_3304;

											BgL_arg1987z00_3304 = CDR(((obj_t) BgL_allocsz00_3288));
											{
												obj_t BgL_allocsz00_5137;

												BgL_allocsz00_5137 = BgL_arg1987z00_3304;
												BgL_allocsz00_3288 = BgL_allocsz00_5137;
												goto BgL_zc3z04anonymousza31972ze3z87_3289;
											}
										}
								}
						}
					}
			}
		}

	}



/* show~0 */
	bool_t BGl_showze70ze7zzcfa_closurez00(obj_t BgL_propz00_3306,
		obj_t BgL_lz00_3307)
	{
		{	/* Cfa/closure.scm 530 */
			if (NULLP(BgL_lz00_3307))
				{	/* Cfa/closure.scm 525 */
					return ((bool_t) 0);
				}
			else
				{	/* Cfa/closure.scm 525 */
					{	/* Cfa/closure.scm 527 */
						obj_t BgL_arg1990z00_3310;

						BgL_arg1990z00_3310 =
							BGl_shapez00zztools_shapez00(CAR(BgL_lz00_3307));
						{	/* Cfa/closure.scm 527 */
							obj_t BgL_list1991z00_3311;

							{	/* Cfa/closure.scm 527 */
								obj_t BgL_arg1992z00_3312;

								{	/* Cfa/closure.scm 527 */
									obj_t BgL_arg1993z00_3313;

									{	/* Cfa/closure.scm 527 */
										obj_t BgL_arg1994z00_3314;

										{	/* Cfa/closure.scm 527 */
											obj_t BgL_arg1995z00_3315;

											BgL_arg1995z00_3315 =
												MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
											BgL_arg1994z00_3314 =
												MAKE_YOUNG_PAIR(BgL_arg1990z00_3310,
												BgL_arg1995z00_3315);
										}
										BgL_arg1993z00_3313 =
											MAKE_YOUNG_PAIR(BGl_string2197z00zzcfa_closurez00,
											BgL_arg1994z00_3314);
									}
									BgL_arg1992z00_3312 =
										MAKE_YOUNG_PAIR(BgL_propz00_3306, BgL_arg1993z00_3313);
								}
								BgL_list1991z00_3311 =
									MAKE_YOUNG_PAIR(BGl_string2198z00zzcfa_closurez00,
									BgL_arg1992z00_3312);
							}
							BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
								BgL_list1991z00_3311);
					}}
					{	/* Cfa/closure.scm 528 */
						obj_t BgL_g1550z00_3317;

						BgL_g1550z00_3317 = CDR(BgL_lz00_3307);
						{
							obj_t BgL_l1548z00_3319;

							BgL_l1548z00_3319 = BgL_g1550z00_3317;
						BgL_zc3z04anonymousza31997ze3z87_3320:
							if (PAIRP(BgL_l1548z00_3319))
								{	/* Cfa/closure.scm 530 */
									{	/* Cfa/closure.scm 529 */
										obj_t BgL_xz00_3322;

										BgL_xz00_3322 = CAR(BgL_l1548z00_3319);
										{	/* Cfa/closure.scm 529 */
											obj_t BgL_arg1999z00_3323;

											BgL_arg1999z00_3323 =
												BGl_shapez00zztools_shapez00(BgL_xz00_3322);
											{	/* Cfa/closure.scm 529 */
												obj_t BgL_list2000z00_3324;

												{	/* Cfa/closure.scm 529 */
													obj_t BgL_arg2001z00_3325;

													{	/* Cfa/closure.scm 529 */
														obj_t BgL_arg2002z00_3326;

														BgL_arg2002z00_3326 =
															MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)),
															BNIL);
														BgL_arg2001z00_3325 =
															MAKE_YOUNG_PAIR(BgL_arg1999z00_3323,
															BgL_arg2002z00_3326);
													}
													BgL_list2000z00_3324 =
														MAKE_YOUNG_PAIR(BGl_string2199z00zzcfa_closurez00,
														BgL_arg2001z00_3325);
												}
												BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
													BgL_list2000z00_3324);
									}}}
									{
										obj_t BgL_l1548z00_5161;

										BgL_l1548z00_5161 = CDR(BgL_l1548z00_3319);
										BgL_l1548z00_3319 = BgL_l1548z00_5161;
										goto BgL_zc3z04anonymousza31997ze3z87_3320;
									}
								}
							else
								{	/* Cfa/closure.scm 530 */
									return ((bool_t) 1);
								}
						}
					}
				}
		}

	}



/* get-procedure-list */
	BGL_EXPORTED_DEF obj_t BGl_getzd2procedurezd2listz00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 558 */
			return BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
		}

	}



/* &get-procedure-list */
	obj_t BGl_z62getzd2procedurezd2listz62zzcfa_closurez00(obj_t BgL_envz00_4133)
	{
		{	/* Cfa/closure.scm 558 */
			return BGl_getzd2procedurezd2listz00zzcfa_closurez00();
		}

	}



/* add-funcall! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2funcallz12zc0zzcfa_closurez00(BgL_nodez00_bglt BgL_astz00_12)
	{
		{	/* Cfa/closure.scm 564 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 565 */
					return (BGl_za2funcallzd2listza2zd2zzcfa_closurez00 =
						MAKE_YOUNG_PAIR(
							((obj_t) BgL_astz00_12),
							BGl_za2funcallzd2listza2zd2zzcfa_closurez00), BUNSPEC);
				}
			else
				{	/* Cfa/closure.scm 565 */
					return BFALSE;
				}
		}

	}



/* &add-funcall! */
	obj_t BGl_z62addzd2funcallz12za2zzcfa_closurez00(obj_t BgL_envz00_4134,
		obj_t BgL_astz00_4135)
	{
		{	/* Cfa/closure.scm 564 */
			return
				BGl_addzd2funcallz12zc0zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_4135));
		}

	}



/* add-make-procedure! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(BgL_nodez00_bglt
		BgL_astz00_13)
	{
		{	/* Cfa/closure.scm 571 */
			return (BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 =
				MAKE_YOUNG_PAIR(
					((obj_t) BgL_astz00_13),
					BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00), BUNSPEC);
		}

	}



/* &add-make-procedure! */
	obj_t BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00(obj_t
		BgL_envz00_4136, obj_t BgL_astz00_4137)
	{
		{	/* Cfa/closure.scm 571 */
			return
				BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_4137));
		}

	}



/* add-procedure-ref! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(BgL_nodez00_bglt
		BgL_astz00_14)
	{
		{	/* Cfa/closure.scm 577 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 578 */
					return (BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 =
						MAKE_YOUNG_PAIR(
							((obj_t) BgL_astz00_14),
							BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00), BUNSPEC);
				}
			else
				{	/* Cfa/closure.scm 578 */
					return BFALSE;
				}
		}

	}



/* &add-procedure-ref! */
	obj_t BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00(obj_t
		BgL_envz00_4138, obj_t BgL_astz00_4139)
	{
		{	/* Cfa/closure.scm 577 */
			return
				BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_4139));
		}

	}



/* approx-procedure-el? */
	BGL_EXPORTED_DEF bool_t
		BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(BgL_approxz00_bglt
		BgL_approxz00_15)
	{
		{	/* Cfa/closure.scm 584 */
			{	/* Cfa/closure.scm 585 */
				BgL_typez00_bglt BgL_typez00_3332;
				obj_t BgL_alloczd2listzd2_3333;

				BgL_typez00_3332 =
					(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_15))->BgL_typez00);
				BgL_alloczd2listzd2_3333 =
					BGl_setzd2ze3listz31zzcfa_setz00(
					(((BgL_approxz00_bglt) COBJECT(BgL_approxz00_15))->BgL_allocsz00));
				if (
					(((obj_t) BgL_typez00_3332) == BGl_za2procedureza2z00zztype_cachez00))
					{	/* Cfa/closure.scm 587 */
						if (PAIRP(BgL_alloczd2listzd2_3333))
							{	/* Cfa/closure.scm 588 */
								if (NULLP(CDR(BgL_alloczd2listzd2_3333)))
									{	/* Cfa/closure.scm 590 */
										bool_t BgL_test2323z00_5193;

										{	/* Cfa/closure.scm 590 */
											obj_t BgL_arg2007z00_3339;

											BgL_arg2007z00_3339 = CAR(BgL_alloczd2listzd2_3333);
											BgL_test2323z00_5193 =
												BGl_isazf3zf3zz__objectz00(BgL_arg2007z00_3339,
												BGl_makezd2procedurezd2appz00zzcfa_info2z00);
										}
										if (BgL_test2323z00_5193)
											{	/* Cfa/closure.scm 591 */
												BgL_appz00_bglt BgL_oz00_4116;

												BgL_oz00_4116 =
													((BgL_appz00_bglt) CAR(BgL_alloczd2listzd2_3333));
												{
													BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_5198;

													{
														obj_t BgL_auxz00_5199;

														{	/* Cfa/closure.scm 591 */
															BgL_objectz00_bglt BgL_tmpz00_5200;

															BgL_tmpz00_5200 =
																((BgL_objectz00_bglt) BgL_oz00_4116);
															BgL_auxz00_5199 =
																BGL_OBJECT_WIDENING(BgL_tmpz00_5200);
														}
														BgL_auxz00_5198 =
															((BgL_makezd2procedurezd2appz00_bglt)
															BgL_auxz00_5199);
													}
													return
														(((BgL_makezd2procedurezd2appz00_bglt)
															COBJECT(BgL_auxz00_5198))->BgL_xz00);
												}
											}
										else
											{	/* Cfa/closure.scm 590 */
												return ((bool_t) 0);
											}
									}
								else
									{	/* Cfa/closure.scm 589 */
										return ((bool_t) 0);
									}
							}
						else
							{	/* Cfa/closure.scm 588 */
								return ((bool_t) 0);
							}
					}
				else
					{	/* Cfa/closure.scm 587 */
						return ((bool_t) 0);
					}
			}
		}

	}



/* &approx-procedure-el? */
	obj_t BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00(obj_t
		BgL_envz00_4140, obj_t BgL_approxz00_4141)
	{
		{	/* Cfa/closure.scm 584 */
			return
				BBOOL(BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(
					((BgL_approxz00_bglt) BgL_approxz00_4141)));
		}

	}



/* start-closure-cache */
	obj_t BGl_startzd2closurezd2cachez00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 608 */
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 11)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 13)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 14)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 15)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 16)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 17)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 18)),
				CNST_TABLE_REF(((long) 12)));
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 19)),
					CNST_TABLE_REF(((long) 12))), BUNSPEC);
		}

	}



/* stop-closure-cache */
	BGL_EXPORTED_DEF obj_t BGl_stopzd2closurezd2cachez00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 621 */
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BFALSE;
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BFALSE, BUNSPEC);
		}

	}



/* &stop-closure-cache */
	obj_t BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00(obj_t BgL_envz00_4142)
	{
		{	/* Cfa/closure.scm 621 */
			return BGl_stopzd2closurezd2cachez00zzcfa_closurez00();
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_closurez00()
	{
		{	/* Cfa/closure.scm 25 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 3788352),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 400853817),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 468997863),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_setz00(((long) 21528182),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_ltypez00(((long) 315872512),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_typez00(((long) 93933605),
				BSTRING_TO_STRING(BGl_string2200z00zzcfa_closurez00));
		}

	}

#ifdef __cplusplus
}
#endif
