/*===========================================================================*/
/*   (Dataflow/walk.scm)                                                     */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Dataflow/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
		obj_t BgL_valzd2noescapezd2;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_instanceofz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_classz00;
	}                    *BgL_instanceofz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_stackablez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_localzf2valuezf2_bgl
	{
		int BgL_stampz00;
		struct BgL_nodez00_bgl *BgL_nodez00;
	}                       *BgL_localzf2valuezf2_bglt;


	extern obj_t BGl_setqz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzdataflow_walkz00 = BUNSPEC;
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_za2pairzd2nilza2zd2zztype_cachez00;
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2appzd2l1378za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_z62zc3z04anonymousza31598ze3ze5zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t
		BGl_z62dataflowzd2nodez12zd2setzd2e1396za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2nodez12zd2exter1382z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2funca1380z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzdataflow_walkz00();
	extern obj_t BGl_za2boolza2z00zztype_cachez00;
	static obj_t BGl_z62dataflowzd2nodez12zd2setq1384z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2boxzd2r1404za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_z62dataflowzd2nodez12zd2sync1374z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2fail1388z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_z62dataflowzd2nodez12zd2var1368z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2condi1386z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_abortzf3zf3zzdataflow_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_appendzd221011zd2zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzdataflow_walkz00();
	static obj_t
		BGl_z62dataflowzd2nodez12zd2boxzd2s1406za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static obj_t BGl_z62abortzf3zd2letzd2fun1434z91zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez121365za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_bglt,
		bool_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern obj_t BGl_za2pairza2z00zztype_cachez00;
	static obj_t BGl_z62dataflowzd2nodez12zd2app1376z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2letzd2f1392za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62abortzf31423z91zzdataflow_walkz00(obj_t, obj_t);
	static long BGl_letzd2varzd2stampz00zzdataflow_walkz00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2letzd2v1394za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2envzd2ap1410zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2envzd2in1412zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62dataflowzd2nodez12zd2jumpzd21398za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2makezd21400za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzdataflow_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_spreadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62abortzf3z91zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	static obj_t BGl_z62dataflowzd2testzd2env1407z62zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2closu1370z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62abortzf3zd2app1438z43zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00();
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzdataflow_walkz00();
	static obj_t BGl_gczd2rootszd2initz00zzdataflow_walkz00();
	static obj_t BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	static obj_t BGl_z62dataflowzd2testzd2envzd2co1414zb0zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_z62dataflowzd2testzd2falsezd21419zb0zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	extern obj_t BGl_instanceofz00zzast_nodez00;
	static obj_t BGl_z62abortzf3zd2letzd2var1432z91zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62abortzf3zd2sequence1428z43zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2falsezd21422zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1614z62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1615z62zzdataflow_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62abortzf3zd2funcall1440z43zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	extern obj_t BGl_valuez00zzast_varz00;
	static obj_t BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(BgL_nodez00_bglt,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2seque1372z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62lambda1635z62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1636z62zzdataflow_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_localzf2valuezf2zzdataflow_walkz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62abortzf3zd2conditional1436z43zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	static obj_t BGl_z62dataflowzd2testzd2envzd2le1418zb0zzdataflow_walkz00(obj_t,
		obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_isazd2ofzd2zztype_miscz00(BgL_nodez00_bglt);
	static obj_t BGl_z62abortzf3zd2appzd2ly1442z91zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2switc1390z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62abortzf3zd2fail1426z43zzdataflow_walkz00(obj_t, obj_t);
	static BgL_localz00_bglt BGl_z62lambda1583z62zzdataflow_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_localz00_bglt BGl_z62lambda1586z62zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_z62dataflowzd2testzd2envzd2va1416zb0zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static BgL_localz00_bglt BGl_z62lambda1599z62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62abortzf3zd2sync1430z43zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31853ze3ze5zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t __cnst[12];


	   
		 
		DEFINE_STRING(BGl_string2216z00zzdataflow_walkz00,
		BgL_bgl_string2216za700za7za7d2285za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2217z00zzdataflow_walkz00,
		BgL_bgl_string2217za700za7za7d2286za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2218z00zzdataflow_walkz00,
		BgL_bgl_string2218za700za7za7d2287za7, " error", 6);
	      DEFINE_STRING(BGl_string2219z00zzdataflow_walkz00,
		BgL_bgl_string2219za700za7za7d2288za7, "s", 1);
	      DEFINE_STRING(BGl_string2220z00zzdataflow_walkz00,
		BgL_bgl_string2220za700za7za7d2289za7, "", 0);
	      DEFINE_STRING(BGl_string2221z00zzdataflow_walkz00,
		BgL_bgl_string2221za700za7za7d2290za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string2222z00zzdataflow_walkz00,
		BgL_bgl_string2222za700za7za7d2291za7, "failure during postlude hook", 28);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2223z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1615za7622292z00, BGl_z62lambda1615z62zzdataflow_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2224z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1614za7622293z00, BGl_z62lambda1614z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2225z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1636za7622294z00, BGl_z62lambda1636z62zzdataflow_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2232z00zzdataflow_walkz00,
		BgL_bgl_string2232za700za7za7d2295za7, "dataflow-node!1365", 18);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2226z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1635za7622296z00, BGl_z62lambda1635z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2227z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1599za7622297z00, BGl_z62lambda1599z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2234z00zzdataflow_walkz00,
		BgL_bgl_string2234za700za7za7d2298za7, "dataflow-test-env1407", 21);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2228z00zzdataflow_walkz00,
		BgL_bgl_za762za7c3za704anonymo2299za7,
		BGl_z62zc3z04anonymousza31598ze3ze5zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2229z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1586za7622300z00, BGl_z62lambda1586z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2236z00zzdataflow_walkz00,
		BgL_bgl_string2236za700za7za7d2301za7, "dataflow-test-false-1419", 24);
	      DEFINE_STRING(BGl_string2238z00zzdataflow_walkz00,
		BgL_bgl_string2238za700za7za7d2302za7, "abort?1423", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2230z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1583za7622303z00, BGl_z62lambda1583z62zzdataflow_walkz00,
		0L, BUNSPEC, 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2231z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2304z00,
		BGl_z62dataflowzd2nodez121365za2zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2233z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2305z00,
		BGl_z62dataflowzd2testzd2env1407z62zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2240z00zzdataflow_walkz00,
		BgL_bgl_string2240za700za7za7d2306za7, "dataflow-node!", 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2235z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2307z00,
		BGl_z62dataflowzd2testzd2falsezd21419zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2237z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f31423za72308za7,
		BGl_z62abortzf31423z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2239z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2309z00,
		BGl_z62dataflowzd2nodez12zd2var1368z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2241z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2310z00,
		BGl_z62dataflowzd2nodez12zd2closu1370z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2242z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2311z00,
		BGl_z62dataflowzd2nodez12zd2seque1372z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2243z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2312z00,
		BGl_z62dataflowzd2nodez12zd2sync1374z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2244z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2313z00,
		BGl_z62dataflowzd2nodez12zd2app1376z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2245z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2314z00,
		BGl_z62dataflowzd2nodez12zd2appzd2l1378za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2246z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2315z00,
		BGl_z62dataflowzd2nodez12zd2funca1380z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2247z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2316z00,
		BGl_z62dataflowzd2nodez12zd2exter1382z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2248z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2317z00,
		BGl_z62dataflowzd2nodez12zd2setq1384z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2249z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2318z00,
		BGl_z62dataflowzd2nodez12zd2condi1386z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_dataflowzd2walkz12zd2envz12zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2wa2319z00,
		BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_GENERIC(BGl_abortzf3zd2envz21zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za791za7za72320za7,
		BGl_z62abortzf3z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2250z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2321z00,
		BGl_z62dataflowzd2nodez12zd2fail1388z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2251z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2322z00,
		BGl_z62dataflowzd2nodez12zd2switc1390z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2252z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2323z00,
		BGl_z62dataflowzd2nodez12zd2letzd2f1392za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2253z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2324z00,
		BGl_z62dataflowzd2nodez12zd2letzd2v1394za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STRING(BGl_string2260z00zzdataflow_walkz00,
		BgL_bgl_string2260za700za7za7d2325za7, "dataflow-test-env", 17);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2254z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2326z00,
		BGl_z62dataflowzd2nodez12zd2setzd2e1396za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2255z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2327z00,
		BGl_z62dataflowzd2nodez12zd2jumpzd21398za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2256z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2328z00,
		BGl_z62dataflowzd2nodez12zd2makezd21400za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2257z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2329z00,
		BGl_z62dataflowzd2nodez12zd2boxzd2r1404za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2258z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2330z00,
		BGl_z62dataflowzd2nodez12zd2boxzd2s1406za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2259z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2331z00,
		BGl_z62dataflowzd2testzd2envzd2ap1410zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2266z00zzdataflow_walkz00,
		BgL_bgl_string2266za700za7za7d2332za7, "dataflow-test-false-env", 23);
	      DEFINE_STRING(BGl_string2268z00zzdataflow_walkz00,
		BgL_bgl_string2268za700za7za7d2333za7, "abort?", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2261z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2334z00,
		BGl_z62dataflowzd2testzd2envzd2in1412zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2262z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2335z00,
		BGl_z62dataflowzd2testzd2envzd2co1414zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2263z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2336z00,
		BGl_z62dataflowzd2testzd2envzd2va1416zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2264z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2337z00,
		BGl_z62dataflowzd2testzd2envzd2le1418zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2265z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2338z00,
		BGl_z62dataflowzd2testzd2falsezd21422zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2267z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2fa2339za7,
		BGl_z62abortzf3zd2fail1426z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2269z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2se2340za7,
		BGl_z62abortzf3zd2sequence1428z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2277z00zzdataflow_walkz00,
		BgL_bgl_string2277za700za7za7d2341za7, "dataflow_walk", 13);
	      DEFINE_STRING(BGl_string2278z00zzdataflow_walkz00,
		BgL_bgl_string2278za700za7za7d2342za7,
		"read _ dataflow_walk local/value node int stamp $epair? $pair? foreign $null? pass-started ",
		91);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2270z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2sy2343za7,
		BGl_z62abortzf3zd2sync1430z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2271z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2le2344za7,
		BGl_z62abortzf3zd2letzd2var1432z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2272z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2le2345za7,
		BGl_z62abortzf3zd2letzd2fun1434z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2273z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2co2346za7,
		BGl_z62abortzf3zd2conditional1436z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2274z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2ap2347za7,
		BGl_z62abortzf3zd2app1438z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2275z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2fu2348za7,
		BGl_z62abortzf3zd2funcall1440z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2276z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2ap2349za7,
		BGl_z62abortzf3zd2appzd2ly1442z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2350z00,
		BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2351z00,
		BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2352z00,
		BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzdataflow_walkz00));
		     ADD_ROOT((void *) (&BGl_za2z42epairzf3za2zb1zzdataflow_walkz00));
		     ADD_ROOT((void *) (&BGl_za2z42pairzf3za2zb1zzdataflow_walkz00));
		     ADD_ROOT((void *) (&BGl_za2z42nullzf3za2zb1zzdataflow_walkz00));
		     ADD_ROOT((void *) (&BGl_localzf2valuezf2zzdataflow_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzdataflow_walkz00(long
		BgL_checksumz00_3665, char *BgL_fromz00_3666)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzdataflow_walkz00))
				{
					BGl_requirezd2initializa7ationz75zzdataflow_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzdataflow_walkz00();
					BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00();
					BGl_cnstzd2initzd2zzdataflow_walkz00();
					BGl_importedzd2moduleszd2initz00zzdataflow_walkz00();
					BGl_objectzd2initzd2zzdataflow_walkz00();
					BGl_genericzd2initzd2zzdataflow_walkz00();
					BGl_methodzd2initzd2zzdataflow_walkz00();
					return BGl_toplevelzd2initzd2zzdataflow_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"dataflow_walk");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			{	/* Dataflow/walk.scm 17 */
				obj_t BgL_cportz00_3385;

				{	/* Dataflow/walk.scm 17 */
					obj_t BgL_stringz00_3393;

					BgL_stringz00_3393 = BGl_string2278z00zzdataflow_walkz00;
					{	/* Dataflow/walk.scm 17 */
						obj_t BgL_startz00_3394;

						BgL_startz00_3394 = BINT(((long) 0));
						{	/* Dataflow/walk.scm 17 */
							obj_t BgL_endz00_3395;

							BgL_endz00_3395 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_3393)));
							{	/* Dataflow/walk.scm 17 */

								BgL_cportz00_3385 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_3393, BgL_startz00_3394, BgL_endz00_3395);
				}}}}
				{
					long BgL_iz00_3386;

					BgL_iz00_3386 = ((long) 11);
				BgL_loopz00_3387:
					if ((BgL_iz00_3386 == ((long) -1)))
						{	/* Dataflow/walk.scm 17 */
							return BUNSPEC;
						}
					else
						{	/* Dataflow/walk.scm 17 */
							{	/* Dataflow/walk.scm 17 */
								obj_t BgL_arg2280z00_3389;

								{	/* Dataflow/walk.scm 17 */

									{	/* Dataflow/walk.scm 17 */
										obj_t BgL_locationz00_3391;

										BgL_locationz00_3391 = BBOOL(((bool_t) 0));
										{	/* Dataflow/walk.scm 17 */

											BgL_arg2280z00_3389 =
												BGl_readz00zz__readerz00(BgL_cportz00_3385,
												BgL_locationz00_3391);
										}
									}
								}
								{	/* Dataflow/walk.scm 17 */
									int BgL_tmpz00_3699;

									BgL_tmpz00_3699 = (int) (BgL_iz00_3386);
									CNST_TABLE_SET(BgL_tmpz00_3699, BgL_arg2280z00_3389);
							}}
							{	/* Dataflow/walk.scm 17 */
								int BgL_auxz00_3392;

								BgL_auxz00_3392 = (int) ((BgL_iz00_3386 - ((long) 1)));
								{
									long BgL_iz00_3704;

									BgL_iz00_3704 = (long) (BgL_auxz00_3392);
									BgL_iz00_3386 = BgL_iz00_3704;
									goto BgL_loopz00_3387;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_letzd2varzd2stampz00zzdataflow_walkz00 = ((long) 0);
			return BUNSPEC;
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zzdataflow_walkz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_1801;

				BgL_headz00_1801 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_1802;
					obj_t BgL_tailz00_1803;

					BgL_prevz00_1802 = BgL_headz00_1801;
					BgL_tailz00_1803 = BgL_l1z00_1;
				BgL_loopz00_1804:
					if (PAIRP(BgL_tailz00_1803))
						{
							obj_t BgL_newzd2prevzd2_1806;

							BgL_newzd2prevzd2_1806 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_1803), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_1802, BgL_newzd2prevzd2_1806);
							{
								obj_t BgL_tailz00_3714;
								obj_t BgL_prevz00_3713;

								BgL_prevz00_3713 = BgL_newzd2prevzd2_1806;
								BgL_tailz00_3714 = CDR(BgL_tailz00_1803);
								BgL_tailz00_1803 = BgL_tailz00_3714;
								BgL_prevz00_1802 = BgL_prevz00_3713;
								goto BgL_loopz00_1804;
							}
						}
					else
						{
							BNIL;
						}
					return CDR(BgL_headz00_1801);
				}
			}
		}

	}



/* dataflow-walk! */
	BGL_EXPORTED_DEF obj_t BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(obj_t
		BgL_globalsz00_56, obj_t BgL_namez00_57)
	{
		{	/* Dataflow/walk.scm 45 */
			{	/* Dataflow/walk.scm 46 */
				obj_t BgL_list1485z00_1815;

				{	/* Dataflow/walk.scm 46 */
					obj_t BgL_arg1500z00_1816;

					{	/* Dataflow/walk.scm 46 */
						obj_t BgL_arg1502z00_1817;

						BgL_arg1502z00_1817 =
							MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
						BgL_arg1500z00_1816 =
							MAKE_YOUNG_PAIR(BgL_namez00_57, BgL_arg1502z00_1817);
					}
					BgL_list1485z00_1815 =
						MAKE_YOUNG_PAIR(BGl_string2216z00zzdataflow_walkz00,
						BgL_arg1500z00_1816);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1485z00_1815);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 = BgL_namez00_57;
			{	/* Dataflow/walk.scm 46 */
				obj_t BgL_g1137z00_1818;

				BgL_g1137z00_1818 = BNIL;
				{
					obj_t BgL_hooksz00_1821;
					obj_t BgL_hnamesz00_1822;

					BgL_hooksz00_1821 = BgL_g1137z00_1818;
					BgL_hnamesz00_1822 = BNIL;
				BgL_zc3z04anonymousza31503ze3z87_1823:
					if (NULLP(BgL_hooksz00_1821))
						{	/* Dataflow/walk.scm 46 */
							CNST_TABLE_REF(((long) 0));
						}
					else
						{	/* Dataflow/walk.scm 46 */
							bool_t BgL_test2357z00_3727;

							{	/* Dataflow/walk.scm 46 */
								obj_t BgL_fun1527z00_1830;

								BgL_fun1527z00_1830 = CAR(((obj_t) BgL_hooksz00_1821));
								BgL_test2357z00_3727 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1527z00_1830)
									(BgL_fun1527z00_1830, BEOA));
							}
							if (BgL_test2357z00_3727)
								{	/* Dataflow/walk.scm 46 */
									obj_t BgL_arg1520z00_1827;
									obj_t BgL_arg1521z00_1828;

									BgL_arg1520z00_1827 = CDR(((obj_t) BgL_hooksz00_1821));
									BgL_arg1521z00_1828 = CDR(((obj_t) BgL_hnamesz00_1822));
									{
										obj_t BgL_hnamesz00_3739;
										obj_t BgL_hooksz00_3738;

										BgL_hooksz00_3738 = BgL_arg1520z00_1827;
										BgL_hnamesz00_3739 = BgL_arg1521z00_1828;
										BgL_hnamesz00_1822 = BgL_hnamesz00_3739;
										BgL_hooksz00_1821 = BgL_hooksz00_3738;
										goto BgL_zc3z04anonymousza31503ze3z87_1823;
									}
								}
							else
								{	/* Dataflow/walk.scm 46 */
									obj_t BgL_arg1526z00_1829;

									BgL_arg1526z00_1829 = CAR(((obj_t) BgL_hnamesz00_1822));
									BGl_internalzd2errorzd2zztools_errorz00(BgL_namez00_57,
										BGl_string2217z00zzdataflow_walkz00, BgL_arg1526z00_1829);
								}
						}
				}
			}
			BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 1)),
				CNST_TABLE_REF(((long) 2)));
			BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 3)),
				CNST_TABLE_REF(((long) 2)));
			BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 4)),
				CNST_TABLE_REF(((long) 2)));
			{
				obj_t BgL_l1321z00_1834;

				BgL_l1321z00_1834 = BgL_globalsz00_56;
			BgL_zc3z04anonymousza31529ze3z87_1835:
				if (PAIRP(BgL_l1321z00_1834))
					{	/* Dataflow/walk.scm 50 */
						{	/* Dataflow/walk.scm 50 */
							obj_t BgL_arg1532z00_1837;

							BgL_arg1532z00_1837 = CAR(BgL_l1321z00_1834);
							{	/* Dataflow/walk.scm 64 */
								obj_t BgL_arg1560z00_2832;

								BgL_arg1560z00_2832 =
									(((BgL_sfunz00_bglt) COBJECT(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																((BgL_globalz00_bglt) BgL_arg1532z00_1837))))->
													BgL_valuez00))))->BgL_bodyz00);
								BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(((BgL_nodez00_bglt)
										BgL_arg1560z00_2832), BNIL);
							}
						}
						{
							obj_t BgL_l1321z00_3762;

							BgL_l1321z00_3762 = CDR(BgL_l1321z00_1834);
							BgL_l1321z00_1834 = BgL_l1321z00_3762;
							goto BgL_zc3z04anonymousza31529ze3z87_1835;
						}
					}
				else
					{	/* Dataflow/walk.scm 50 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Dataflow/walk.scm 51 */
					{	/* Dataflow/walk.scm 51 */
						obj_t BgL_port1323z00_1842;

						{	/* Dataflow/walk.scm 51 */
							obj_t BgL_tmpz00_3767;

							BgL_tmpz00_3767 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_port1323z00_1842 =
								BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_3767);
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1323z00_1842);
						bgl_display_string(BGl_string2218z00zzdataflow_walkz00,
							BgL_port1323z00_1842);
						{	/* Dataflow/walk.scm 51 */
							obj_t BgL_arg1540z00_1843;

							{	/* Dataflow/walk.scm 51 */
								bool_t BgL_test2360z00_3772;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Dataflow/walk.scm 51 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Dataflow/walk.scm 51 */
												BgL_test2360z00_3772 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Dataflow/walk.scm 51 */
												BgL_test2360z00_3772 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Dataflow/walk.scm 51 */
										BgL_test2360z00_3772 = ((bool_t) 0);
									}
								if (BgL_test2360z00_3772)
									{	/* Dataflow/walk.scm 51 */
										BgL_arg1540z00_1843 = BGl_string2219z00zzdataflow_walkz00;
									}
								else
									{	/* Dataflow/walk.scm 51 */
										BgL_arg1540z00_1843 = BGl_string2220z00zzdataflow_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1540z00_1843, BgL_port1323z00_1842);
						}
						bgl_display_string(BGl_string2221z00zzdataflow_walkz00,
							BgL_port1323z00_1842);
						bgl_display_char(((unsigned char) 10), BgL_port1323z00_1842);
					}
					{	/* Dataflow/walk.scm 51 */
						obj_t BgL_list1544z00_1849;

						BgL_list1544z00_1849 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1544z00_1849);
					}
				}
			else
				{	/* Dataflow/walk.scm 51 */
					obj_t BgL_g1139z00_1850;

					BgL_g1139z00_1850 = BNIL;
					{
						obj_t BgL_hooksz00_1853;
						obj_t BgL_hnamesz00_1854;

						BgL_hooksz00_1853 = BgL_g1139z00_1850;
						BgL_hnamesz00_1854 = BNIL;
					BgL_zc3z04anonymousza31545ze3z87_1855:
						if (NULLP(BgL_hooksz00_1853))
							{	/* Dataflow/walk.scm 51 */
								return BgL_globalsz00_56;
							}
						else
							{	/* Dataflow/walk.scm 51 */
								bool_t BgL_test2364z00_3789;

								{	/* Dataflow/walk.scm 51 */
									obj_t BgL_fun1558z00_1862;

									BgL_fun1558z00_1862 = CAR(((obj_t) BgL_hooksz00_1853));
									BgL_test2364z00_3789 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1558z00_1862)
										(BgL_fun1558z00_1862, BEOA));
								}
								if (BgL_test2364z00_3789)
									{	/* Dataflow/walk.scm 51 */
										obj_t BgL_arg1551z00_1859;
										obj_t BgL_arg1555z00_1860;

										BgL_arg1551z00_1859 = CDR(((obj_t) BgL_hooksz00_1853));
										BgL_arg1555z00_1860 = CDR(((obj_t) BgL_hnamesz00_1854));
										{
											obj_t BgL_hnamesz00_3801;
											obj_t BgL_hooksz00_3800;

											BgL_hooksz00_3800 = BgL_arg1551z00_1859;
											BgL_hnamesz00_3801 = BgL_arg1555z00_1860;
											BgL_hnamesz00_1854 = BgL_hnamesz00_3801;
											BgL_hooksz00_1853 = BgL_hooksz00_3800;
											goto BgL_zc3z04anonymousza31545ze3z87_1855;
										}
									}
								else
									{	/* Dataflow/walk.scm 51 */
										obj_t BgL_arg1557z00_1861;

										BgL_arg1557z00_1861 = CAR(((obj_t) BgL_hnamesz00_1854));
										return
											BGl_internalzd2errorzd2zztools_errorz00
											(BGl_za2currentzd2passza2zd2zzengine_passz00,
											BGl_string2222z00zzdataflow_walkz00, BgL_arg1557z00_1861);
									}
							}
					}
				}
		}

	}



/* &dataflow-walk! */
	obj_t BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00(obj_t BgL_envz00_3196,
		obj_t BgL_globalsz00_3197, obj_t BgL_namez00_3198)
	{
		{	/* Dataflow/walk.scm 45 */
			return
				BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(BgL_globalsz00_3197,
				BgL_namez00_3198);
		}

	}



/* dataflow-node*! */
	obj_t BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(obj_t BgL_nodeza2za2_99,
		obj_t BgL_envz00_100)
	{
		{	/* Dataflow/walk.scm 307 */
			{
				obj_t BgL_l1345z00_1868;

				BgL_l1345z00_1868 = BgL_nodeza2za2_99;
			BgL_zc3z04anonymousza31562ze3z87_1869:
				if (PAIRP(BgL_l1345z00_1868))
					{	/* Dataflow/walk.scm 308 */
						{	/* Dataflow/walk.scm 308 */
							obj_t BgL_nz00_1871;

							BgL_nz00_1871 = CAR(BgL_l1345z00_1868);
							BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
								((BgL_nodez00_bglt) BgL_nz00_1871), BgL_envz00_100);
						}
						{
							obj_t BgL_l1345z00_3811;

							BgL_l1345z00_3811 = CDR(BgL_l1345z00_1868);
							BgL_l1345z00_1868 = BgL_l1345z00_3811;
							goto BgL_zc3z04anonymousza31562ze3z87_1869;
						}
					}
				else
					{	/* Dataflow/walk.scm 308 */
						((bool_t) 1);
					}
			}
			return BgL_envz00_100;
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			{	/* Dataflow/walk.scm 37 */
				obj_t BgL_arg1580z00_1878;
				obj_t BgL_arg1582z00_1879;

				{	/* Dataflow/walk.scm 37 */
					obj_t BgL_v1363z00_1914;

					BgL_v1363z00_1914 = create_vector(((long) 2));
					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_arg1605z00_1915;

						BgL_arg1605z00_1915 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									5)), BGl_proc2224z00zzdataflow_walkz00,
							BGl_proc2223z00zzdataflow_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 6)));
						VECTOR_SET(BgL_v1363z00_1914, ((long) 0), BgL_arg1605z00_1915);
					}
					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_arg1616z00_1925;

						BgL_arg1616z00_1925 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									7)), BGl_proc2226z00zzdataflow_walkz00,
							BGl_proc2225z00zzdataflow_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_nodez00zzast_nodez00);
						VECTOR_SET(BgL_v1363z00_1914, ((long) 1), BgL_arg1616z00_1925);
					}
					BgL_arg1580z00_1878 = BgL_v1363z00_1914;
				}
				{	/* Dataflow/walk.scm 37 */
					obj_t BgL_v1364z00_1935;

					BgL_v1364z00_1935 = create_vector(((long) 0));
					BgL_arg1582z00_1879 = BgL_v1364z00_1935;
				}
				return (BGl_localzf2valuezf2zzdataflow_walkz00 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 8)),
						CNST_TABLE_REF(((long) 9)), BGl_localz00zzast_varz00,
						((long) 51723), BGl_proc2230z00zzdataflow_walkz00,
						BGl_proc2229z00zzdataflow_walkz00, BFALSE,
						BGl_proc2228z00zzdataflow_walkz00,
						BGl_proc2227z00zzdataflow_walkz00, BgL_arg1580z00_1878,
						BgL_arg1582z00_1879), BUNSPEC);
		}}

	}



/* &lambda1599 */
	BgL_localz00_bglt BGl_z62lambda1599z62zzdataflow_walkz00(obj_t
		BgL_envz00_3207, obj_t BgL_o1124z00_3208)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				long BgL_arg1600z00_3398;

				{	/* Dataflow/walk.scm 37 */
					obj_t BgL_arg1603z00_3399;

					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_arg1604z00_3400;

						{	/* Dataflow/walk.scm 37 */
							long BgL_arg1794z00_3401;

							{	/* Dataflow/walk.scm 37 */
								long BgL_arg1795z00_3402;

								BgL_arg1795z00_3402 =
									BGL_OBJECT_CLASS_NUM(
									((BgL_objectz00_bglt)
										((BgL_localz00_bglt) BgL_o1124z00_3208)));
								BgL_arg1794z00_3401 = (BgL_arg1795z00_3402 - OBJECT_TYPE);
							}
							BgL_arg1604z00_3400 =
								VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
								BgL_arg1794z00_3401);
						}
						BgL_arg1603z00_3399 =
							BGl_classzd2superzd2zz__objectz00(BgL_arg1604z00_3400);
					}
					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_tmpz00_3831;

						BgL_tmpz00_3831 = ((obj_t) BgL_arg1603z00_3399);
						BgL_arg1600z00_3398 = BGL_CLASS_INDEX(BgL_tmpz00_3831);
				}}
				BGL_OBJECT_CLASS_NUM_SET(
					((BgL_objectz00_bglt)
						((BgL_localz00_bglt) BgL_o1124z00_3208)), BgL_arg1600z00_3398);
			}
			{	/* Dataflow/walk.scm 37 */
				BgL_objectz00_bglt BgL_tmpz00_3837;

				BgL_tmpz00_3837 =
					((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1124z00_3208));
				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3837, BFALSE);
			}
			((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1124z00_3208));
			return ((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1124z00_3208));
		}

	}



/* &<@anonymous:1598> */
	obj_t BGl_z62zc3z04anonymousza31598ze3ze5zzdataflow_walkz00(obj_t
		BgL_envz00_3209, obj_t BgL_new1123z00_3210)
	{
		{	/* Dataflow/walk.scm 37 */
			{
				BgL_localz00_bglt BgL_auxz00_3845;

				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1123z00_3210))))->BgL_idz00) =
					((obj_t) CNST_TABLE_REF(((long) 10))), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1123z00_3210))))->BgL_namez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_3853;

					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_classz00_3404;

						BgL_classz00_3404 = BGl_typez00zztype_typez00;
						{	/* Dataflow/walk.scm 37 */
							obj_t BgL__ortest_1110z00_3405;

							BgL__ortest_1110z00_3405 = BGL_CLASS_NIL(BgL_classz00_3404);
							if (CBOOL(BgL__ortest_1110z00_3405))
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3853 =
										((BgL_typez00_bglt) BgL__ortest_1110z00_3405);
								}
							else
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3853 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3404));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1123z00_3210))))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_3853), BUNSPEC);
				}
				{
					BgL_valuez00_bglt BgL_auxz00_3863;

					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_classz00_3406;

						BgL_classz00_3406 = BGl_valuez00zzast_varz00;
						{	/* Dataflow/walk.scm 37 */
							obj_t BgL__ortest_1110z00_3407;

							BgL__ortest_1110z00_3407 = BGL_CLASS_NIL(BgL_classz00_3406);
							if (CBOOL(BgL__ortest_1110z00_3407))
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3863 =
										((BgL_valuez00_bglt) BgL__ortest_1110z00_3407);
								}
							else
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3863 =
										((BgL_valuez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3406));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1123z00_3210))))->
							BgL_valuez00) = ((BgL_valuez00_bglt) BgL_auxz00_3863), BUNSPEC);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1123z00_3210))))->BgL_accessz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1123z00_3210))))->BgL_fastzd2alphazd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1123z00_3210))))->BgL_removablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1123z00_3210))))->BgL_occurrencez00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1123z00_3210))))->BgL_occurrencewz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1123z00_3210))))->BgL_userzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) ((BgL_localz00_bglt)
										BgL_new1123z00_3210))))->BgL_keyz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) ((BgL_localz00_bglt)
										BgL_new1123z00_3210))))->BgL_valzd2noescapezd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_3897;

					{
						obj_t BgL_auxz00_3898;

						{	/* Dataflow/walk.scm 37 */
							BgL_objectz00_bglt BgL_tmpz00_3899;

							BgL_tmpz00_3899 =
								((BgL_objectz00_bglt)
								((BgL_localz00_bglt) BgL_new1123z00_3210));
							BgL_auxz00_3898 = BGL_OBJECT_WIDENING(BgL_tmpz00_3899);
						}
						BgL_auxz00_3897 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3898);
					}
					((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_3897))->
							BgL_stampz00) = ((int) (int) (((long) 0))), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3913;
					BgL_localzf2valuezf2_bglt BgL_auxz00_3906;

					{	/* Dataflow/walk.scm 37 */
						obj_t BgL_classz00_3408;

						BgL_classz00_3408 = BGl_nodez00zzast_nodez00;
						{	/* Dataflow/walk.scm 37 */
							obj_t BgL__ortest_1110z00_3409;

							BgL__ortest_1110z00_3409 = BGL_CLASS_NIL(BgL_classz00_3408);
							if (CBOOL(BgL__ortest_1110z00_3409))
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3913 =
										((BgL_nodez00_bglt) BgL__ortest_1110z00_3409);
								}
							else
								{	/* Dataflow/walk.scm 37 */
									BgL_auxz00_3913 =
										((BgL_nodez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3408));
								}
						}
					}
					{
						obj_t BgL_auxz00_3907;

						{	/* Dataflow/walk.scm 37 */
							BgL_objectz00_bglt BgL_tmpz00_3908;

							BgL_tmpz00_3908 =
								((BgL_objectz00_bglt)
								((BgL_localz00_bglt) BgL_new1123z00_3210));
							BgL_auxz00_3907 = BGL_OBJECT_WIDENING(BgL_tmpz00_3908);
						}
						BgL_auxz00_3906 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3907);
					}
					((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_3906))->
							BgL_nodez00) = ((BgL_nodez00_bglt) BgL_auxz00_3913), BUNSPEC);
				}
				BgL_auxz00_3845 = ((BgL_localz00_bglt) BgL_new1123z00_3210);
				return ((obj_t) BgL_auxz00_3845);
			}
		}

	}



/* &lambda1586 */
	BgL_localz00_bglt BGl_z62lambda1586z62zzdataflow_walkz00(obj_t
		BgL_envz00_3211, obj_t BgL_o1120z00_3212)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				BgL_localzf2valuezf2_bglt BgL_wide1122z00_3411;

				BgL_wide1122z00_3411 =
					((BgL_localzf2valuezf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_localzf2valuezf2_bgl))));
				{	/* Dataflow/walk.scm 37 */
					obj_t BgL_auxz00_3928;
					BgL_objectz00_bglt BgL_tmpz00_3924;

					BgL_auxz00_3928 = ((obj_t) BgL_wide1122z00_3411);
					BgL_tmpz00_3924 =
						((BgL_objectz00_bglt)
						((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1120z00_3212)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3924, BgL_auxz00_3928);
				}
				((BgL_objectz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1120z00_3212)));
				{	/* Dataflow/walk.scm 37 */
					long BgL_arg1597z00_3412;

					BgL_arg1597z00_3412 =
						BGL_CLASS_INDEX(BGl_localzf2valuezf2zzdataflow_walkz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_localz00_bglt)
								((BgL_localz00_bglt) BgL_o1120z00_3212))), BgL_arg1597z00_3412);
				}
				return
					((BgL_localz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1120z00_3212)));
			}
		}

	}



/* &lambda1583 */
	BgL_localz00_bglt BGl_z62lambda1583z62zzdataflow_walkz00(obj_t
		BgL_envz00_3213, obj_t BgL_id1106z00_3214, obj_t BgL_name1107z00_3215,
		obj_t BgL_type1108z00_3216, obj_t BgL_value1109z00_3217,
		obj_t BgL_access1110z00_3218, obj_t BgL_fastzd2alpha1111zd2_3219,
		obj_t BgL_removable1112z00_3220, obj_t BgL_occurrence1113z00_3221,
		obj_t BgL_occurrencew1114z00_3222, obj_t BgL_userzf31115zf3_3223,
		obj_t BgL_key1116z00_3224, obj_t BgL_valzd2noescape1117zd2_3225,
		obj_t BgL_stamp1118z00_3226, obj_t BgL_node1119z00_3227)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				long BgL_occurrence1113z00_3416;
				long BgL_occurrencew1114z00_3417;
				bool_t BgL_userzf31115zf3_3418;
				long BgL_key1116z00_3419;
				int BgL_stamp1118z00_3420;

				BgL_occurrence1113z00_3416 = (long) CINT(BgL_occurrence1113z00_3221);
				BgL_occurrencew1114z00_3417 = (long) CINT(BgL_occurrencew1114z00_3222);
				BgL_userzf31115zf3_3418 = CBOOL(BgL_userzf31115zf3_3223);
				BgL_key1116z00_3419 = (long) CINT(BgL_key1116z00_3224);
				BgL_stamp1118z00_3420 = CINT(BgL_stamp1118z00_3226);
				{	/* Dataflow/walk.scm 37 */
					BgL_localz00_bglt BgL_new1192z00_3422;

					{	/* Dataflow/walk.scm 37 */
						BgL_localz00_bglt BgL_tmp1190z00_3423;
						BgL_localzf2valuezf2_bglt BgL_wide1191z00_3424;

						{
							BgL_localz00_bglt BgL_auxz00_3947;

							{	/* Dataflow/walk.scm 37 */
								BgL_localz00_bglt BgL_new1189z00_3425;

								BgL_new1189z00_3425 =
									((BgL_localz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_localz00_bgl))));
								{	/* Dataflow/walk.scm 37 */
									long BgL_arg1585z00_3426;

									BgL_arg1585z00_3426 =
										BGL_CLASS_INDEX(BGl_localz00zzast_varz00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1189z00_3425),
										BgL_arg1585z00_3426);
								}
								{	/* Dataflow/walk.scm 37 */
									BgL_objectz00_bglt BgL_tmpz00_3952;

									BgL_tmpz00_3952 = ((BgL_objectz00_bglt) BgL_new1189z00_3425);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3952, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1189z00_3425);
								BgL_auxz00_3947 = BgL_new1189z00_3425;
							}
							BgL_tmp1190z00_3423 = ((BgL_localz00_bglt) BgL_auxz00_3947);
						}
						BgL_wide1191z00_3424 =
							((BgL_localzf2valuezf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_localzf2valuezf2_bgl))));
						{	/* Dataflow/walk.scm 37 */
							obj_t BgL_auxz00_3960;
							BgL_objectz00_bglt BgL_tmpz00_3958;

							BgL_auxz00_3960 = ((obj_t) BgL_wide1191z00_3424);
							BgL_tmpz00_3958 = ((BgL_objectz00_bglt) BgL_tmp1190z00_3423);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3958, BgL_auxz00_3960);
						}
						((BgL_objectz00_bglt) BgL_tmp1190z00_3423);
						{	/* Dataflow/walk.scm 37 */
							long BgL_arg1584z00_3427;

							BgL_arg1584z00_3427 =
								BGL_CLASS_INDEX(BGl_localzf2valuezf2zzdataflow_walkz00);
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_tmp1190z00_3423),
								BgL_arg1584z00_3427);
						}
						BgL_new1192z00_3422 = ((BgL_localz00_bglt) BgL_tmp1190z00_3423);
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_new1192z00_3422)))->BgL_idz00) =
						((obj_t) ((obj_t) BgL_id1106z00_3214)), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_namez00) =
						((obj_t) BgL_name1107z00_3215), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_type1108z00_3216)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_valuez00) =
						((BgL_valuez00_bglt) ((BgL_valuez00_bglt) BgL_value1109z00_3217)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_accessz00) =
						((obj_t) BgL_access1110z00_3218), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_fastzd2alphazd2) =
						((obj_t) BgL_fastzd2alpha1111zd2_3219), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_removablez00) =
						((obj_t) BgL_removable1112z00_3220), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_occurrencez00) =
						((long) BgL_occurrence1113z00_3416), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_occurrencewz00) =
						((long) BgL_occurrencew1114z00_3417), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1192z00_3422)))->BgL_userzf3zf3) =
						((bool_t) BgL_userzf31115zf3_3418), BUNSPEC);
					((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
										BgL_new1192z00_3422)))->BgL_keyz00) =
						((long) BgL_key1116z00_3419), BUNSPEC);
					((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
										BgL_new1192z00_3422)))->BgL_valzd2noescapezd2) =
						((obj_t) BgL_valzd2noescape1117zd2_3225), BUNSPEC);
					{
						BgL_localzf2valuezf2_bglt BgL_auxz00_3995;

						{
							obj_t BgL_auxz00_3996;

							{	/* Dataflow/walk.scm 37 */
								BgL_objectz00_bglt BgL_tmpz00_3997;

								BgL_tmpz00_3997 = ((BgL_objectz00_bglt) BgL_new1192z00_3422);
								BgL_auxz00_3996 = BGL_OBJECT_WIDENING(BgL_tmpz00_3997);
							}
							BgL_auxz00_3995 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3996);
						}
						((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_3995))->
								BgL_stampz00) = ((int) BgL_stamp1118z00_3420), BUNSPEC);
					}
					{
						BgL_localzf2valuezf2_bglt BgL_auxz00_4002;

						{
							obj_t BgL_auxz00_4003;

							{	/* Dataflow/walk.scm 37 */
								BgL_objectz00_bglt BgL_tmpz00_4004;

								BgL_tmpz00_4004 = ((BgL_objectz00_bglt) BgL_new1192z00_3422);
								BgL_auxz00_4003 = BGL_OBJECT_WIDENING(BgL_tmpz00_4004);
							}
							BgL_auxz00_4002 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4003);
						}
						((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4002))->
								BgL_nodez00) =
							((BgL_nodez00_bglt) ((BgL_nodez00_bglt) BgL_node1119z00_3227)),
							BUNSPEC);
					}
					return BgL_new1192z00_3422;
				}
			}
		}

	}



/* &lambda1636 */
	obj_t BGl_z62lambda1636z62zzdataflow_walkz00(obj_t BgL_envz00_3228,
		obj_t BgL_oz00_3229, obj_t BgL_vz00_3230)
	{
		{	/* Dataflow/walk.scm 37 */
			{
				BgL_localzf2valuezf2_bglt BgL_auxz00_4010;

				{
					obj_t BgL_auxz00_4011;

					{	/* Dataflow/walk.scm 37 */
						BgL_objectz00_bglt BgL_tmpz00_4012;

						BgL_tmpz00_4012 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3229));
						BgL_auxz00_4011 = BGL_OBJECT_WIDENING(BgL_tmpz00_4012);
					}
					BgL_auxz00_4010 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4011);
				}
				return
					((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4010))->
						BgL_nodez00) =
					((BgL_nodez00_bglt) ((BgL_nodez00_bglt) BgL_vz00_3230)), BUNSPEC);
			}
		}

	}



/* &lambda1635 */
	BgL_nodez00_bglt BGl_z62lambda1635z62zzdataflow_walkz00(obj_t BgL_envz00_3231,
		obj_t BgL_oz00_3232)
	{
		{	/* Dataflow/walk.scm 37 */
			{
				BgL_localzf2valuezf2_bglt BgL_auxz00_4019;

				{
					obj_t BgL_auxz00_4020;

					{	/* Dataflow/walk.scm 37 */
						BgL_objectz00_bglt BgL_tmpz00_4021;

						BgL_tmpz00_4021 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3232));
						BgL_auxz00_4020 = BGL_OBJECT_WIDENING(BgL_tmpz00_4021);
					}
					BgL_auxz00_4019 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4020);
				}
				return
					(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4019))->BgL_nodez00);
			}
		}

	}



/* &lambda1615 */
	obj_t BGl_z62lambda1615z62zzdataflow_walkz00(obj_t BgL_envz00_3233,
		obj_t BgL_oz00_3234, obj_t BgL_vz00_3235)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				int BgL_vz00_3432;

				BgL_vz00_3432 = CINT(BgL_vz00_3235);
				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_4028;

					{
						obj_t BgL_auxz00_4029;

						{	/* Dataflow/walk.scm 37 */
							BgL_objectz00_bglt BgL_tmpz00_4030;

							BgL_tmpz00_4030 =
								((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3234));
							BgL_auxz00_4029 = BGL_OBJECT_WIDENING(BgL_tmpz00_4030);
						}
						BgL_auxz00_4028 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4029);
					}
					return
						((((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4028))->
							BgL_stampz00) = ((int) BgL_vz00_3432), BUNSPEC);
		}}}

	}



/* &lambda1614 */
	obj_t BGl_z62lambda1614z62zzdataflow_walkz00(obj_t BgL_envz00_3236,
		obj_t BgL_oz00_3237)
	{
		{	/* Dataflow/walk.scm 37 */
			{	/* Dataflow/walk.scm 37 */
				int BgL_tmpz00_4036;

				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_4037;

					{
						obj_t BgL_auxz00_4038;

						{	/* Dataflow/walk.scm 37 */
							BgL_objectz00_bglt BgL_tmpz00_4039;

							BgL_tmpz00_4039 =
								((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3237));
							BgL_auxz00_4038 = BGL_OBJECT_WIDENING(BgL_tmpz00_4039);
						}
						BgL_auxz00_4037 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_4038);
					}
					BgL_tmpz00_4036 =
						(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4037))->
						BgL_stampz00);
				}
				return BINT(BgL_tmpz00_4036);
			}
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_proc2231z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2232z00zzdataflow_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_proc2233z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2234z00zzdataflow_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
				BGl_proc2235z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2236z00zzdataflow_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00,
				BGl_proc2237z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2238z00zzdataflow_walkz00);
		}

	}



/* &abort?1423 */
	obj_t BGl_z62abortzf31423z91zzdataflow_walkz00(obj_t BgL_envz00_3242,
		obj_t BgL_nodez00_3243)
	{
		{	/* Dataflow/walk.scm 428 */
			return BBOOL(((bool_t) 0));
		}

	}



/* &dataflow-test-false-1419 */
	obj_t BGl_z62dataflowzd2testzd2falsezd21419zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3244, obj_t BgL_nodez00_3245)
	{
		{	/* Dataflow/walk.scm 400 */
			return BNIL;
		}

	}



/* &dataflow-test-env1407 */
	obj_t BGl_z62dataflowzd2testzd2env1407z62zzdataflow_walkz00(obj_t
		BgL_envz00_3246, obj_t BgL_nodez00_3247)
	{
		{	/* Dataflow/walk.scm 314 */
			return BNIL;
		}

	}



/* &dataflow-node!1365 */
	obj_t BGl_z62dataflowzd2nodez121365za2zzdataflow_walkz00(obj_t
		BgL_envz00_3248, obj_t BgL_nodez00_3249, obj_t BgL_envz00_3250)
	{
		{	/* Dataflow/walk.scm 69 */
			return ((obj_t) BgL_envz00_3250);
		}

	}



/* dataflow-node! */
	obj_t BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_59, obj_t BgL_envz00_60)
	{
		{	/* Dataflow/walk.scm 69 */
			{	/* Dataflow/walk.scm 69 */
				obj_t BgL_method1366z00_1957;

				{	/* Dataflow/walk.scm 69 */
					obj_t BgL_res2194z00_2927;

					{	/* Dataflow/walk.scm 69 */
						long BgL_objzd2classzd2numz00_2898;

						BgL_objzd2classzd2numz00_2898 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_59));
						{	/* Dataflow/walk.scm 69 */
							obj_t BgL_arg1791z00_2899;

							BgL_arg1791z00_2899 =
								PROCEDURE_REF(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 69 */
								int BgL_offsetz00_2902;

								BgL_offsetz00_2902 = (int) (BgL_objzd2classzd2numz00_2898);
								{	/* Dataflow/walk.scm 69 */
									long BgL_offsetz00_2903;

									BgL_offsetz00_2903 =
										((long) (BgL_offsetz00_2902) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 69 */
										long BgL_modz00_2904;

										BgL_modz00_2904 =
											(BgL_offsetz00_2903 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Dataflow/walk.scm 69 */
											long BgL_restz00_2906;

											BgL_restz00_2906 =
												(BgL_offsetz00_2903 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Dataflow/walk.scm 69 */

												{	/* Dataflow/walk.scm 69 */
													obj_t BgL_bucketz00_2908;

													BgL_bucketz00_2908 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2899), BgL_modz00_2904);
													BgL_res2194z00_2927 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2908), BgL_restz00_2906);
					}}}}}}}}
					BgL_method1366z00_1957 = BgL_res2194z00_2927;
				}
				return
					PROCEDURE_ENTRY(BgL_method1366z00_1957) (BgL_method1366z00_1957,
					((obj_t) BgL_nodez00_59), BgL_envz00_60, BEOA);
			}
		}

	}



/* &dataflow-node! */
	obj_t BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00(obj_t BgL_envz00_3251,
		obj_t BgL_nodez00_3252, obj_t BgL_envz00_3253)
	{
		{	/* Dataflow/walk.scm 69 */
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3252), BgL_envz00_3253);
		}

	}



/* dataflow-test-env */
	obj_t BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_101)
	{
		{	/* Dataflow/walk.scm 314 */
			{	/* Dataflow/walk.scm 314 */
				obj_t BgL_method1408z00_1958;

				{	/* Dataflow/walk.scm 314 */
					obj_t BgL_res2199z00_2958;

					{	/* Dataflow/walk.scm 314 */
						long BgL_objzd2classzd2numz00_2929;

						BgL_objzd2classzd2numz00_2929 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_101));
						{	/* Dataflow/walk.scm 314 */
							obj_t BgL_arg1791z00_2930;

							BgL_arg1791z00_2930 =
								PROCEDURE_REF
								(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 314 */
								int BgL_offsetz00_2933;

								BgL_offsetz00_2933 = (int) (BgL_objzd2classzd2numz00_2929);
								{	/* Dataflow/walk.scm 314 */
									long BgL_offsetz00_2934;

									BgL_offsetz00_2934 =
										((long) (BgL_offsetz00_2933) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 314 */
										long BgL_modz00_2935;

										BgL_modz00_2935 =
											(BgL_offsetz00_2934 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Dataflow/walk.scm 314 */
											long BgL_restz00_2937;

											BgL_restz00_2937 =
												(BgL_offsetz00_2934 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Dataflow/walk.scm 314 */

												{	/* Dataflow/walk.scm 314 */
													obj_t BgL_bucketz00_2939;

													BgL_bucketz00_2939 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2930), BgL_modz00_2935);
													BgL_res2199z00_2958 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2939), BgL_restz00_2937);
					}}}}}}}}
					BgL_method1408z00_1958 = BgL_res2199z00_2958;
				}
				return
					PROCEDURE_ENTRY(BgL_method1408z00_1958) (BgL_method1408z00_1958,
					((obj_t) BgL_nodez00_101), BEOA);
			}
		}

	}



/* &dataflow-test-env */
	obj_t BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00(obj_t BgL_envz00_3254,
		obj_t BgL_nodez00_3255)
	{
		{	/* Dataflow/walk.scm 314 */
			return
				BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3255));
		}

	}



/* dataflow-test-false-env */
	obj_t BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_107)
	{
		{	/* Dataflow/walk.scm 400 */
			{	/* Dataflow/walk.scm 400 */
				obj_t BgL_method1420z00_1959;

				{	/* Dataflow/walk.scm 400 */
					obj_t BgL_res2204z00_2989;

					{	/* Dataflow/walk.scm 400 */
						long BgL_objzd2classzd2numz00_2960;

						BgL_objzd2classzd2numz00_2960 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_107));
						{	/* Dataflow/walk.scm 400 */
							obj_t BgL_arg1791z00_2961;

							BgL_arg1791z00_2961 =
								PROCEDURE_REF
								(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 400 */
								int BgL_offsetz00_2964;

								BgL_offsetz00_2964 = (int) (BgL_objzd2classzd2numz00_2960);
								{	/* Dataflow/walk.scm 400 */
									long BgL_offsetz00_2965;

									BgL_offsetz00_2965 =
										((long) (BgL_offsetz00_2964) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 400 */
										long BgL_modz00_2966;

										BgL_modz00_2966 =
											(BgL_offsetz00_2965 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Dataflow/walk.scm 400 */
											long BgL_restz00_2968;

											BgL_restz00_2968 =
												(BgL_offsetz00_2965 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Dataflow/walk.scm 400 */

												{	/* Dataflow/walk.scm 400 */
													obj_t BgL_bucketz00_2970;

													BgL_bucketz00_2970 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2961), BgL_modz00_2966);
													BgL_res2204z00_2989 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2970), BgL_restz00_2968);
					}}}}}}}}
					BgL_method1420z00_1959 = BgL_res2204z00_2989;
				}
				return
					PROCEDURE_ENTRY(BgL_method1420z00_1959) (BgL_method1420z00_1959,
					((obj_t) BgL_nodez00_107), BEOA);
			}
		}

	}



/* &dataflow-test-false-env */
	obj_t BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00(obj_t
		BgL_envz00_3256, obj_t BgL_nodez00_3257)
	{
		{	/* Dataflow/walk.scm 400 */
			return
				BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3257));
		}

	}



/* abort? */
	obj_t BGl_abortzf3zf3zzdataflow_walkz00(BgL_nodez00_bglt BgL_nodez00_109)
	{
		{	/* Dataflow/walk.scm 428 */
			{	/* Dataflow/walk.scm 428 */
				obj_t BgL_method1424z00_1960;

				{	/* Dataflow/walk.scm 428 */
					obj_t BgL_res2209z00_3020;

					{	/* Dataflow/walk.scm 428 */
						long BgL_objzd2classzd2numz00_2991;

						BgL_objzd2classzd2numz00_2991 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_109));
						{	/* Dataflow/walk.scm 428 */
							obj_t BgL_arg1791z00_2992;

							BgL_arg1791z00_2992 =
								PROCEDURE_REF(BGl_abortzf3zd2envz21zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 428 */
								int BgL_offsetz00_2995;

								BgL_offsetz00_2995 = (int) (BgL_objzd2classzd2numz00_2991);
								{	/* Dataflow/walk.scm 428 */
									long BgL_offsetz00_2996;

									BgL_offsetz00_2996 =
										((long) (BgL_offsetz00_2995) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 428 */
										long BgL_modz00_2997;

										BgL_modz00_2997 =
											(BgL_offsetz00_2996 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Dataflow/walk.scm 428 */
											long BgL_restz00_2999;

											BgL_restz00_2999 =
												(BgL_offsetz00_2996 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Dataflow/walk.scm 428 */

												{	/* Dataflow/walk.scm 428 */
													obj_t BgL_bucketz00_3001;

													BgL_bucketz00_3001 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2992), BgL_modz00_2997);
													BgL_res2209z00_3020 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_3001), BgL_restz00_2999);
					}}}}}}}}
					BgL_method1424z00_1960 = BgL_res2209z00_3020;
				}
				return
					PROCEDURE_ENTRY(BgL_method1424z00_1960) (BgL_method1424z00_1960,
					((obj_t) BgL_nodez00_109), BEOA);
			}
		}

	}



/* &abort? */
	obj_t BGl_z62abortzf3z91zzdataflow_walkz00(obj_t BgL_envz00_3258,
		obj_t BgL_nodez00_3259)
	{
		{	/* Dataflow/walk.scm 428 */
			return
				BGl_abortzf3zf3zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3259));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_varz00zzast_nodez00, BGl_proc2239z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_closurez00zzast_nodez00, BGl_proc2241z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2242z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2243z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2244z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2245z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2246z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc2247z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2248z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2249z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc2250z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_switchz00zzast_nodez00, BGl_proc2251z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2252z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2253z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2254z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2255z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2256z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2257z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2258z00zzdataflow_walkz00,
				BGl_string2240z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2259z00zzdataflow_walkz00,
				BGl_string2260z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_instanceofz00zzast_nodez00, BGl_proc2261z00zzdataflow_walkz00,
				BGl_string2260z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2262z00zzdataflow_walkz00,
				BGl_string2260z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_varz00zzast_nodez00, BGl_proc2263z00zzdataflow_walkz00,
				BGl_string2260z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2264z00zzdataflow_walkz00,
				BGl_string2260z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2265z00zzdataflow_walkz00,
				BGl_string2266z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc2267z00zzdataflow_walkz00, BGl_string2268z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc2269z00zzdataflow_walkz00, BGl_string2268z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc2270z00zzdataflow_walkz00, BGl_string2268z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc2271z00zzdataflow_walkz00, BGl_string2268z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc2272z00zzdataflow_walkz00, BGl_string2268z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2273z00zzdataflow_walkz00,
				BGl_string2268z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2274z00zzdataflow_walkz00, BGl_string2268z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc2275z00zzdataflow_walkz00, BGl_string2268z00zzdataflow_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc2276z00zzdataflow_walkz00, BGl_string2268z00zzdataflow_walkz00);
		}

	}



/* &abort?-app-ly1442 */
	obj_t BGl_z62abortzf3zd2appzd2ly1442z91zzdataflow_walkz00(obj_t
		BgL_envz00_3295, obj_t BgL_nodez00_3296)
	{
		{	/* Dataflow/walk.scm 489 */
			{	/* Dataflow/walk.scm 491 */
				obj_t BgL__ortest_1188z00_3440;

				BgL__ortest_1188z00_3440 =
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_3296)))->BgL_funz00));
				if (CBOOL(BgL__ortest_1188z00_3440))
					{	/* Dataflow/walk.scm 491 */
						return BgL__ortest_1188z00_3440;
					}
				else
					{	/* Dataflow/walk.scm 491 */
						return
							BGl_abortzf3zf3zzdataflow_walkz00(
							(((BgL_appzd2lyzd2_bglt) COBJECT(
										((BgL_appzd2lyzd2_bglt) BgL_nodez00_3296)))->BgL_argz00));
					}
			}
		}

	}



/* &abort?-funcall1440 */
	obj_t BGl_z62abortzf3zd2funcall1440z43zzdataflow_walkz00(obj_t
		BgL_envz00_3297, obj_t BgL_nodez00_3298)
	{
		{	/* Dataflow/walk.scm 482 */
			{	/* Dataflow/walk.scm 484 */
				obj_t BgL__ortest_1186z00_3442;

				BgL__ortest_1186z00_3442 =
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_3298)))->BgL_funz00));
				if (CBOOL(BgL__ortest_1186z00_3442))
					{	/* Dataflow/walk.scm 484 */
						return BgL__ortest_1186z00_3442;
					}
				else
					{	/* Dataflow/walk.scm 484 */
						obj_t BgL_g1361z00_3443;

						BgL_g1361z00_3443 =
							(((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nodez00_3298)))->BgL_argsz00);
						{
							obj_t BgL_l1359z00_3445;

							BgL_l1359z00_3445 = BgL_g1361z00_3443;
						BgL_zc3z04anonymousza32110ze3z87_3444:
							if (NULLP(BgL_l1359z00_3445))
								{	/* Dataflow/walk.scm 484 */
									return BFALSE;
								}
							else
								{	/* Dataflow/walk.scm 484 */
									obj_t BgL__ortest_1362z00_3446;

									{	/* Dataflow/walk.scm 484 */
										obj_t BgL_arg2113z00_3447;

										BgL_arg2113z00_3447 = CAR(((obj_t) BgL_l1359z00_3445));
										BgL__ortest_1362z00_3446 =
											BGl_abortzf3zf3zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg2113z00_3447));
									}
									if (CBOOL(BgL__ortest_1362z00_3446))
										{	/* Dataflow/walk.scm 484 */
											return BgL__ortest_1362z00_3446;
										}
									else
										{	/* Dataflow/walk.scm 484 */
											obj_t BgL_arg2112z00_3448;

											BgL_arg2112z00_3448 = CDR(((obj_t) BgL_l1359z00_3445));
											{
												obj_t BgL_l1359z00_4240;

												BgL_l1359z00_4240 = BgL_arg2112z00_3448;
												BgL_l1359z00_3445 = BgL_l1359z00_4240;
												goto BgL_zc3z04anonymousza32110ze3z87_3444;
											}
										}
								}
						}
					}
			}
		}

	}



/* &abort?-app1438 */
	obj_t BGl_z62abortzf3zd2app1438z43zzdataflow_walkz00(obj_t BgL_envz00_3299,
		obj_t BgL_nodez00_3300)
	{
		{	/* Dataflow/walk.scm 475 */
			{	/* Dataflow/walk.scm 477 */
				obj_t BgL__ortest_1184z00_3450;

				{	/* Dataflow/walk.scm 477 */
					BgL_varz00_bglt BgL_arg2109z00_3451;

					BgL_arg2109z00_3451 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3300)))->BgL_funz00);
					BgL__ortest_1184z00_3450 =
						BGl_abortzf3zf3zzdataflow_walkz00(
						((BgL_nodez00_bglt) BgL_arg2109z00_3451));
				}
				if (CBOOL(BgL__ortest_1184z00_3450))
					{	/* Dataflow/walk.scm 477 */
						return BgL__ortest_1184z00_3450;
					}
				else
					{	/* Dataflow/walk.scm 477 */
						obj_t BgL_g1357z00_3452;

						BgL_g1357z00_3452 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nodez00_3300)))->BgL_argsz00);
						{
							obj_t BgL_l1355z00_3454;

							BgL_l1355z00_3454 = BgL_g1357z00_3452;
						BgL_zc3z04anonymousza32105ze3z87_3453:
							if (NULLP(BgL_l1355z00_3454))
								{	/* Dataflow/walk.scm 477 */
									return BFALSE;
								}
							else
								{	/* Dataflow/walk.scm 477 */
									obj_t BgL__ortest_1358z00_3455;

									{	/* Dataflow/walk.scm 477 */
										obj_t BgL_arg2108z00_3456;

										BgL_arg2108z00_3456 = CAR(((obj_t) BgL_l1355z00_3454));
										BgL__ortest_1358z00_3455 =
											BGl_abortzf3zf3zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg2108z00_3456));
									}
									if (CBOOL(BgL__ortest_1358z00_3455))
										{	/* Dataflow/walk.scm 477 */
											return BgL__ortest_1358z00_3455;
										}
									else
										{	/* Dataflow/walk.scm 477 */
											obj_t BgL_arg2107z00_3457;

											BgL_arg2107z00_3457 = CDR(((obj_t) BgL_l1355z00_3454));
											{
												obj_t BgL_l1355z00_4259;

												BgL_l1355z00_4259 = BgL_arg2107z00_3457;
												BgL_l1355z00_3454 = BgL_l1355z00_4259;
												goto BgL_zc3z04anonymousza32105ze3z87_3453;
											}
										}
								}
						}
					}
			}
		}

	}



/* &abort?-conditional1436 */
	obj_t BGl_z62abortzf3zd2conditional1436z43zzdataflow_walkz00(obj_t
		BgL_envz00_3301, obj_t BgL_nodez00_3302)
	{
		{	/* Dataflow/walk.scm 468 */
			{	/* Dataflow/walk.scm 470 */
				obj_t BgL__ortest_1181z00_3459;

				BgL__ortest_1181z00_3459 =
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_3302)))->BgL_testz00));
				if (CBOOL(BgL__ortest_1181z00_3459))
					{	/* Dataflow/walk.scm 470 */
						return BgL__ortest_1181z00_3459;
					}
				else
					{	/* Dataflow/walk.scm 470 */
						obj_t BgL__andtest_1182z00_3460;

						BgL__andtest_1182z00_3460 =
							BGl_abortzf3zf3zzdataflow_walkz00(
							(((BgL_conditionalz00_bglt) COBJECT(
										((BgL_conditionalz00_bglt) BgL_nodez00_3302)))->
								BgL_truez00));
						if (CBOOL(BgL__andtest_1182z00_3460))
							{	/* Dataflow/walk.scm 470 */
								return
									BGl_abortzf3zf3zzdataflow_walkz00(
									(((BgL_conditionalz00_bglt) COBJECT(
												((BgL_conditionalz00_bglt) BgL_nodez00_3302)))->
										BgL_falsez00));
							}
						else
							{	/* Dataflow/walk.scm 470 */
								return BFALSE;
							}
					}
			}
		}

	}



/* &abort?-let-fun1434 */
	obj_t BGl_z62abortzf3zd2letzd2fun1434z91zzdataflow_walkz00(obj_t
		BgL_envz00_3303, obj_t BgL_nodez00_3304)
	{
		{	/* Dataflow/walk.scm 461 */
			return
				BGl_abortzf3zf3zzdataflow_walkz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3304)))->BgL_bodyz00));
		}

	}



/* &abort?-let-var1432 */
	obj_t BGl_z62abortzf3zd2letzd2var1432z91zzdataflow_walkz00(obj_t
		BgL_envz00_3305, obj_t BgL_nodez00_3306)
	{
		{	/* Dataflow/walk.scm 454 */
			{	/* Dataflow/walk.scm 456 */
				obj_t BgL__ortest_1178z00_3463;

				{	/* Dataflow/walk.scm 456 */
					obj_t BgL_g1353z00_3464;

					BgL_g1353z00_3464 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_3306)))->BgL_bindingsz00);
					{
						obj_t BgL_l1351z00_3466;

						BgL_l1351z00_3466 = BgL_g1353z00_3464;
					BgL_zc3z04anonymousza32096ze3z87_3465:
						if (NULLP(BgL_l1351z00_3466))
							{	/* Dataflow/walk.scm 456 */
								BgL__ortest_1178z00_3463 = BFALSE;
							}
						else
							{	/* Dataflow/walk.scm 456 */
								obj_t BgL__ortest_1354z00_3467;

								{	/* Dataflow/walk.scm 456 */
									obj_t BgL_bz00_3468;

									BgL_bz00_3468 = CAR(((obj_t) BgL_l1351z00_3466));
									{	/* Dataflow/walk.scm 456 */
										obj_t BgL_arg2099z00_3469;

										BgL_arg2099z00_3469 = CDR(((obj_t) BgL_bz00_3468));
										BgL__ortest_1354z00_3467 =
											BGl_abortzf3zf3zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg2099z00_3469));
									}
								}
								if (CBOOL(BgL__ortest_1354z00_3467))
									{	/* Dataflow/walk.scm 456 */
										BgL__ortest_1178z00_3463 = BgL__ortest_1354z00_3467;
									}
								else
									{	/* Dataflow/walk.scm 456 */
										obj_t BgL_arg2098z00_3470;

										BgL_arg2098z00_3470 = CDR(((obj_t) BgL_l1351z00_3466));
										{
											obj_t BgL_l1351z00_4290;

											BgL_l1351z00_4290 = BgL_arg2098z00_3470;
											BgL_l1351z00_3466 = BgL_l1351z00_4290;
											goto BgL_zc3z04anonymousza32096ze3z87_3465;
										}
									}
							}
					}
				}
				if (CBOOL(BgL__ortest_1178z00_3463))
					{	/* Dataflow/walk.scm 456 */
						return BgL__ortest_1178z00_3463;
					}
				else
					{	/* Dataflow/walk.scm 456 */
						return
							BGl_abortzf3zf3zzdataflow_walkz00(
							(((BgL_letzd2varzd2_bglt) COBJECT(
										((BgL_letzd2varzd2_bglt) BgL_nodez00_3306)))->BgL_bodyz00));
					}
			}
		}

	}



/* &abort?-sync1430 */
	obj_t BGl_z62abortzf3zd2sync1430z43zzdataflow_walkz00(obj_t BgL_envz00_3307,
		obj_t BgL_nodez00_3308)
	{
		{	/* Dataflow/walk.scm 446 */
			{	/* Dataflow/walk.scm 447 */
				obj_t BgL__ortest_1175z00_3472;

				BgL__ortest_1175z00_3472 =
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_3308)))->BgL_mutexz00));
				if (CBOOL(BgL__ortest_1175z00_3472))
					{	/* Dataflow/walk.scm 447 */
						return BgL__ortest_1175z00_3472;
					}
				else
					{	/* Dataflow/walk.scm 448 */
						obj_t BgL__ortest_1176z00_3473;

						BgL__ortest_1176z00_3473 =
							BGl_abortzf3zf3zzdataflow_walkz00(
							(((BgL_syncz00_bglt) COBJECT(
										((BgL_syncz00_bglt) BgL_nodez00_3308)))->BgL_prelockz00));
						if (CBOOL(BgL__ortest_1176z00_3473))
							{	/* Dataflow/walk.scm 448 */
								return BgL__ortest_1176z00_3473;
							}
						else
							{	/* Dataflow/walk.scm 448 */
								return
									BGl_abortzf3zf3zzdataflow_walkz00(
									(((BgL_syncz00_bglt) COBJECT(
												((BgL_syncz00_bglt) BgL_nodez00_3308)))->BgL_bodyz00));
							}
					}
			}
		}

	}



/* &abort?-sequence1428 */
	obj_t BGl_z62abortzf3zd2sequence1428z43zzdataflow_walkz00(obj_t
		BgL_envz00_3309, obj_t BgL_nodez00_3310)
	{
		{	/* Dataflow/walk.scm 440 */
			{	/* Dataflow/walk.scm 441 */
				obj_t BgL_g1349z00_3475;

				BgL_g1349z00_3475 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_3310)))->BgL_nodesz00);
				{
					obj_t BgL_l1347z00_3477;

					BgL_l1347z00_3477 = BgL_g1349z00_3475;
				BgL_zc3z04anonymousza32088ze3z87_3476:
					if (NULLP(BgL_l1347z00_3477))
						{	/* Dataflow/walk.scm 441 */
							return BFALSE;
						}
					else
						{	/* Dataflow/walk.scm 441 */
							obj_t BgL__ortest_1350z00_3478;

							{	/* Dataflow/walk.scm 441 */
								obj_t BgL_arg2091z00_3479;

								BgL_arg2091z00_3479 = CAR(((obj_t) BgL_l1347z00_3477));
								BgL__ortest_1350z00_3478 =
									BGl_abortzf3zf3zzdataflow_walkz00(
									((BgL_nodez00_bglt) BgL_arg2091z00_3479));
							}
							if (CBOOL(BgL__ortest_1350z00_3478))
								{	/* Dataflow/walk.scm 441 */
									return BgL__ortest_1350z00_3478;
								}
							else
								{	/* Dataflow/walk.scm 441 */
									obj_t BgL_arg2090z00_3480;

									BgL_arg2090z00_3480 = CDR(((obj_t) BgL_l1347z00_3477));
									{
										obj_t BgL_l1347z00_4321;

										BgL_l1347z00_4321 = BgL_arg2090z00_3480;
										BgL_l1347z00_3477 = BgL_l1347z00_4321;
										goto BgL_zc3z04anonymousza32088ze3z87_3476;
									}
								}
						}
				}
			}
		}

	}



/* &abort?-fail1426 */
	obj_t BGl_z62abortzf3zd2fail1426z43zzdataflow_walkz00(obj_t BgL_envz00_3311,
		obj_t BgL_nodez00_3312)
	{
		{	/* Dataflow/walk.scm 434 */
			return BBOOL(((bool_t) 1));
		}

	}



/* &dataflow-test-false-1422 */
	obj_t BGl_z62dataflowzd2testzd2falsezd21422zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3313, obj_t BgL_nodez00_3314)
	{
		{	/* Dataflow/walk.scm 406 */
			{	/* Dataflow/walk.scm 408 */
				BgL_variablez00_bglt BgL_fz00_3483;

				BgL_fz00_3483 =
					(((BgL_varz00_bglt) COBJECT(
							(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt) BgL_nodez00_3314)))->BgL_funz00)))->
					BgL_variablez00);
				{	/* Dataflow/walk.scm 409 */

					{	/* Dataflow/walk.scm 410 */
						bool_t BgL_test2385z00_4326;

						{	/* Dataflow/walk.scm 410 */
							bool_t BgL_test2386z00_4327;

							{	/* Dataflow/walk.scm 410 */
								obj_t BgL_tmpz00_4328;

								BgL_tmpz00_4328 =
									(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nodez00_3314)))->BgL_argsz00);
								BgL_test2386z00_4327 = PAIRP(BgL_tmpz00_4328);
							}
							if (BgL_test2386z00_4327)
								{	/* Dataflow/walk.scm 410 */
									if (NULLP(CDR(
												(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt) BgL_nodez00_3314)))->
													BgL_argsz00))))
										{	/* Dataflow/walk.scm 411 */
											bool_t BgL_test2388z00_4337;

											{	/* Dataflow/walk.scm 411 */
												obj_t BgL_arg2081z00_3484;

												BgL_arg2081z00_3484 =
													CAR(
													(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt) BgL_nodez00_3314)))->
														BgL_argsz00));
												BgL_test2388z00_4337 =
													BGl_isazf3zf3zz__objectz00(BgL_arg2081z00_3484,
													BGl_varz00zzast_nodez00);
											}
											if (BgL_test2388z00_4337)
												{	/* Dataflow/walk.scm 412 */
													BgL_typez00_bglt BgL_arg2077z00_3485;

													{
														BgL_variablez00_bglt BgL_auxz00_4342;

														{
															BgL_varz00_bglt BgL_auxz00_4343;

															{	/* Dataflow/walk.scm 412 */
																obj_t BgL_pairz00_3486;

																BgL_pairz00_3486 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt) BgL_nodez00_3314)))->
																	BgL_argsz00);
																BgL_auxz00_4343 =
																	((BgL_varz00_bglt) CAR(BgL_pairz00_3486));
															}
															BgL_auxz00_4342 =
																(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4343))->
																BgL_variablez00);
														}
														BgL_arg2077z00_3485 =
															(((BgL_variablez00_bglt)
																COBJECT(BgL_auxz00_4342))->BgL_typez00);
													}
													BgL_test2385z00_4326 =
														(
														((obj_t) BgL_arg2077z00_3485) ==
														BGl_za2pairzd2nilza2zd2zztype_cachez00);
												}
											else
												{	/* Dataflow/walk.scm 411 */
													BgL_test2385z00_4326 = ((bool_t) 0);
												}
										}
									else
										{	/* Dataflow/walk.scm 410 */
											BgL_test2385z00_4326 = ((bool_t) 0);
										}
								}
							else
								{	/* Dataflow/walk.scm 410 */
									BgL_test2385z00_4326 = ((bool_t) 0);
								}
						}
						if (BgL_test2385z00_4326)
							{	/* Dataflow/walk.scm 410 */
								if (
									(((obj_t) BgL_fz00_3483) ==
										BGl_za2z42nullzf3za2zb1zzdataflow_walkz00))
									{	/* Dataflow/walk.scm 415 */
										obj_t BgL_arg2065z00_3487;

										{	/* Dataflow/walk.scm 415 */
											BgL_variablez00_bglt BgL_arg2067z00_3488;

											{
												BgL_varz00_bglt BgL_auxz00_4355;

												{	/* Dataflow/walk.scm 415 */
													obj_t BgL_pairz00_3489;

													BgL_pairz00_3489 =
														(((BgL_appz00_bglt) COBJECT(
																((BgL_appz00_bglt) BgL_nodez00_3314)))->
														BgL_argsz00);
													BgL_auxz00_4355 =
														((BgL_varz00_bglt) CAR(BgL_pairz00_3489));
												}
												BgL_arg2067z00_3488 =
													(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4355))->
													BgL_variablez00);
											}
											BgL_arg2065z00_3487 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg2067z00_3488),
												BGl_za2pairza2z00zztype_cachez00);
										}
										{	/* Dataflow/walk.scm 415 */
											obj_t BgL_list2066z00_3490;

											BgL_list2066z00_3490 =
												MAKE_YOUNG_PAIR(BgL_arg2065z00_3487, BNIL);
											return BgL_list2066z00_3490;
										}
									}
								else
									{	/* Dataflow/walk.scm 416 */
										bool_t BgL_test2390z00_4364;

										if (
											(((obj_t) BgL_fz00_3483) ==
												BGl_za2z42pairzf3za2zb1zzdataflow_walkz00))
											{	/* Dataflow/walk.scm 416 */
												BgL_test2390z00_4364 = ((bool_t) 1);
											}
										else
											{	/* Dataflow/walk.scm 416 */
												BgL_test2390z00_4364 =
													(
													((obj_t) BgL_fz00_3483) ==
													BGl_za2z42epairzf3za2zb1zzdataflow_walkz00);
											}
										if (BgL_test2390z00_4364)
											{	/* Dataflow/walk.scm 417 */
												obj_t BgL_arg2072z00_3491;

												{	/* Dataflow/walk.scm 417 */
													BgL_variablez00_bglt BgL_arg2074z00_3492;

													{
														BgL_varz00_bglt BgL_auxz00_4370;

														{	/* Dataflow/walk.scm 417 */
															obj_t BgL_pairz00_3493;

															BgL_pairz00_3493 =
																(((BgL_appz00_bglt) COBJECT(
																		((BgL_appz00_bglt) BgL_nodez00_3314)))->
																BgL_argsz00);
															BgL_auxz00_4370 =
																((BgL_varz00_bglt) CAR(BgL_pairz00_3493));
														}
														BgL_arg2074z00_3492 =
															(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4370))->
															BgL_variablez00);
													}
													BgL_arg2072z00_3491 =
														MAKE_YOUNG_PAIR(
														((obj_t) BgL_arg2074z00_3492),
														BGl_za2bnilza2z00zztype_cachez00);
												}
												{	/* Dataflow/walk.scm 417 */
													obj_t BgL_list2073z00_3494;

													BgL_list2073z00_3494 =
														MAKE_YOUNG_PAIR(BgL_arg2072z00_3491, BNIL);
													return BgL_list2073z00_3494;
												}
											}
										else
											{	/* Dataflow/walk.scm 416 */
												return BNIL;
											}
									}
							}
						else
							{	/* Dataflow/walk.scm 410 */
								return BNIL;
							}
					}
				}
			}
		}

	}



/* &dataflow-test-env-le1418 */
	obj_t BGl_z62dataflowzd2testzd2envzd2le1418zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3315, obj_t BgL_nodez00_3316)
	{
		{	/* Dataflow/walk.scm 378 */
			{	/* Dataflow/walk.scm 380 */
				bool_t BgL_test2392z00_4379;

				{	/* Dataflow/walk.scm 380 */
					bool_t BgL_test2393z00_4380;

					{	/* Dataflow/walk.scm 380 */
						obj_t BgL_tmpz00_4381;

						BgL_tmpz00_4381 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nodez00_3316)))->
							BgL_bindingsz00);
						BgL_test2393z00_4380 = PAIRP(BgL_tmpz00_4381);
					}
					if (BgL_test2393z00_4380)
						{	/* Dataflow/walk.scm 380 */
							BgL_test2392z00_4379 =
								NULLP(CDR(
									(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_nodez00_3316)))->
										BgL_bindingsz00)));
						}
					else
						{	/* Dataflow/walk.scm 380 */
							BgL_test2392z00_4379 = ((bool_t) 0);
						}
				}
				if (BgL_test2392z00_4379)
					{	/* Dataflow/walk.scm 382 */
						bool_t BgL_test2394z00_4389;

						{	/* Dataflow/walk.scm 382 */
							obj_t BgL_arg2038z00_3496;

							{	/* Dataflow/walk.scm 382 */
								obj_t BgL_pairz00_3497;

								BgL_pairz00_3497 =
									(((BgL_letzd2varzd2_bglt) COBJECT(
											((BgL_letzd2varzd2_bglt) BgL_nodez00_3316)))->
									BgL_bindingsz00);
								BgL_arg2038z00_3496 = CDR(CAR(BgL_pairz00_3497));
							}
							BgL_test2394z00_4389 =
								BGl_isazf3zf3zz__objectz00(BgL_arg2038z00_3496,
								BGl_varz00zzast_nodez00);
						}
						if (BgL_test2394z00_4389)
							{	/* Dataflow/walk.scm 383 */
								obj_t BgL_envz00_3498;

								BgL_envz00_3498 =
									BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
									(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_nodez00_3316)))->
										BgL_bodyz00));
								{	/* Dataflow/walk.scm 384 */
									bool_t BgL_test2395z00_4398;

									if (NULLP(BgL_envz00_3498))
										{	/* Dataflow/walk.scm 384 */
											BgL_test2395z00_4398 = ((bool_t) 0);
										}
									else
										{	/* Dataflow/walk.scm 384 */
											if (NULLP(CDR(BgL_envz00_3498)))
												{	/* Dataflow/walk.scm 386 */
													obj_t BgL_tmpz00_4404;

													{	/* Dataflow/walk.scm 386 */
														obj_t BgL_pairz00_3499;

														BgL_pairz00_3499 =
															(((BgL_letzd2varzd2_bglt) COBJECT(
																	((BgL_letzd2varzd2_bglt) BgL_nodez00_3316)))->
															BgL_bindingsz00);
														BgL_tmpz00_4404 = CAR(CAR(BgL_pairz00_3499));
													}
													BgL_test2395z00_4398 =
														(CAR(CAR(BgL_envz00_3498)) == BgL_tmpz00_4404);
												}
											else
												{	/* Dataflow/walk.scm 385 */
													BgL_test2395z00_4398 = ((bool_t) 0);
												}
										}
									if (BgL_test2395z00_4398)
										{	/* Dataflow/walk.scm 387 */
											obj_t BgL_arg1995z00_3500;

											{	/* Dataflow/walk.scm 387 */
												BgL_variablez00_bglt BgL_arg1997z00_3501;
												obj_t BgL_arg1998z00_3502;

												{
													BgL_varz00_bglt BgL_auxz00_4412;

													{
														obj_t BgL_auxz00_4413;

														{	/* Dataflow/walk.scm 387 */
															obj_t BgL_pairz00_3503;

															BgL_pairz00_3503 =
																(((BgL_letzd2varzd2_bglt) COBJECT(
																		((BgL_letzd2varzd2_bglt)
																			BgL_nodez00_3316)))->BgL_bindingsz00);
															{	/* Dataflow/walk.scm 387 */
																obj_t BgL_pairz00_3504;

																BgL_pairz00_3504 = CAR(BgL_pairz00_3503);
																BgL_auxz00_4413 = CDR(BgL_pairz00_3504);
															}
														}
														BgL_auxz00_4412 =
															((BgL_varz00_bglt) BgL_auxz00_4413);
													}
													BgL_arg1997z00_3501 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4412))->
														BgL_variablez00);
												}
												BgL_arg1998z00_3502 = CDR(CAR(BgL_envz00_3498));
												BgL_arg1995z00_3500 =
													MAKE_YOUNG_PAIR(
													((obj_t) BgL_arg1997z00_3501), BgL_arg1998z00_3502);
											}
											{	/* Dataflow/walk.scm 387 */
												obj_t BgL_list1996z00_3505;

												BgL_list1996z00_3505 =
													MAKE_YOUNG_PAIR(BgL_arg1995z00_3500, BNIL);
												return BgL_list1996z00_3505;
											}
										}
									else
										{	/* Dataflow/walk.scm 384 */
											return BNIL;
										}
								}
							}
						else
							{	/* Dataflow/walk.scm 389 */
								bool_t BgL_test2398z00_4425;

								{	/* Dataflow/walk.scm 389 */
									bool_t BgL_test2399z00_4426;

									{	/* Dataflow/walk.scm 389 */
										BgL_nodez00_bglt BgL_arg2037z00_3506;

										BgL_arg2037z00_3506 =
											(((BgL_letzd2varzd2_bglt) COBJECT(
													((BgL_letzd2varzd2_bglt) BgL_nodez00_3316)))->
											BgL_bodyz00);
										BgL_test2399z00_4426 =
											BGl_isazf3zf3zz__objectz00(((obj_t) BgL_arg2037z00_3506),
											BGl_varz00zzast_nodez00);
									}
									if (BgL_test2399z00_4426)
										{	/* Dataflow/walk.scm 390 */
											bool_t BgL_test2400z00_4431;

											{	/* Dataflow/walk.scm 390 */
												obj_t BgL_tmpz00_4432;

												{	/* Dataflow/walk.scm 390 */
													obj_t BgL_pairz00_3507;

													BgL_pairz00_3507 =
														(((BgL_letzd2varzd2_bglt) COBJECT(
																((BgL_letzd2varzd2_bglt) BgL_nodez00_3316)))->
														BgL_bindingsz00);
													BgL_tmpz00_4432 = CAR(CAR(BgL_pairz00_3507));
												}
												BgL_test2400z00_4431 =
													(
													((obj_t)
														(((BgL_varz00_bglt) COBJECT(
																	((BgL_varz00_bglt)
																		(((BgL_letzd2varzd2_bglt) COBJECT(
																					((BgL_letzd2varzd2_bglt)
																						BgL_nodez00_3316)))->
																			BgL_bodyz00))))->BgL_variablez00)) ==
													BgL_tmpz00_4432);
											}
											if (BgL_test2400z00_4431)
												{	/* Dataflow/walk.scm 391 */
													BgL_typez00_bglt BgL_arg2028z00_3508;

													{
														BgL_variablez00_bglt BgL_auxz00_4443;

														{
															obj_t BgL_auxz00_4444;

															{	/* Dataflow/walk.scm 391 */
																obj_t BgL_pairz00_3509;

																BgL_pairz00_3509 =
																	(((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				BgL_nodez00_3316)))->BgL_bindingsz00);
																{	/* Dataflow/walk.scm 391 */
																	obj_t BgL_pairz00_3510;

																	BgL_pairz00_3510 = CAR(BgL_pairz00_3509);
																	BgL_auxz00_4444 = CAR(BgL_pairz00_3510);
																}
															}
															BgL_auxz00_4443 =
																((BgL_variablez00_bglt) BgL_auxz00_4444);
														}
														BgL_arg2028z00_3508 =
															(((BgL_variablez00_bglt)
																COBJECT(BgL_auxz00_4443))->BgL_typez00);
													}
													BgL_test2398z00_4425 =
														(
														((obj_t) BgL_arg2028z00_3508) ==
														BGl_za2boolza2z00zztype_cachez00);
												}
											else
												{	/* Dataflow/walk.scm 390 */
													BgL_test2398z00_4425 = ((bool_t) 0);
												}
										}
									else
										{	/* Dataflow/walk.scm 389 */
											BgL_test2398z00_4425 = ((bool_t) 0);
										}
								}
								if (BgL_test2398z00_4425)
									{	/* Dataflow/walk.scm 392 */
										obj_t BgL_arg2025z00_3511;

										{	/* Dataflow/walk.scm 392 */
											obj_t BgL_pairz00_3512;

											BgL_pairz00_3512 =
												(((BgL_letzd2varzd2_bglt) COBJECT(
														((BgL_letzd2varzd2_bglt) BgL_nodez00_3316)))->
												BgL_bindingsz00);
											BgL_arg2025z00_3511 = CDR(CAR(BgL_pairz00_3512));
										}
										return
											BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg2025z00_3511));
									}
								else
									{	/* Dataflow/walk.scm 389 */
										return BNIL;
									}
							}
					}
				else
					{	/* Dataflow/walk.scm 380 */
						return BNIL;
					}
			}
		}

	}



/* &dataflow-test-env-va1416 */
	obj_t BGl_z62dataflowzd2testzd2envzd2va1416zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3317, obj_t BgL_nodez00_3318)
	{
		{	/* Dataflow/walk.scm 361 */
			{	/* Dataflow/walk.scm 363 */
				bool_t BgL_test2401z00_4459;

				{	/* Dataflow/walk.scm 363 */
					BgL_variablez00_bglt BgL_arg1976z00_3514;

					BgL_arg1976z00_3514 =
						(((BgL_varz00_bglt) COBJECT(
								((BgL_varz00_bglt) BgL_nodez00_3318)))->BgL_variablez00);
					BgL_test2401z00_4459 =
						BGl_isazf3zf3zz__objectz00(
						((obj_t) BgL_arg1976z00_3514),
						BGl_localzf2valuezf2zzdataflow_walkz00);
				}
				if (BgL_test2401z00_4459)
					{	/* Dataflow/walk.scm 364 */
						BgL_nodez00_bglt BgL_arg1974z00_3515;

						{	/* Dataflow/walk.scm 364 */
							BgL_localz00_bglt BgL_oz00_3516;

							BgL_oz00_3516 =
								((BgL_localz00_bglt)
								(((BgL_varz00_bglt) COBJECT(
											((BgL_varz00_bglt) BgL_nodez00_3318)))->BgL_variablez00));
							{
								BgL_localzf2valuezf2_bglt BgL_auxz00_4467;

								{
									obj_t BgL_auxz00_4468;

									{	/* Dataflow/walk.scm 364 */
										BgL_objectz00_bglt BgL_tmpz00_4469;

										BgL_tmpz00_4469 = ((BgL_objectz00_bglt) BgL_oz00_3516);
										BgL_auxz00_4468 = BGL_OBJECT_WIDENING(BgL_tmpz00_4469);
									}
									BgL_auxz00_4467 =
										((BgL_localzf2valuezf2_bglt) BgL_auxz00_4468);
								}
								BgL_arg1974z00_3515 =
									(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4467))->
									BgL_nodez00);
							}
						}
						return
							BGl_dataflowzd2testzd2envz00zzdataflow_walkz00
							(BgL_arg1974z00_3515);
					}
				else
					{	/* Dataflow/walk.scm 363 */
						return BNIL;
					}
			}
		}

	}



/* &dataflow-test-env-co1414 */
	obj_t BGl_z62dataflowzd2testzd2envzd2co1414zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3319, obj_t BgL_nodez00_3320)
	{
		{	/* Dataflow/walk.scm 352 */
			{	/* Dataflow/walk.scm 354 */
				bool_t BgL_test2402z00_4475;

				{	/* Dataflow/walk.scm 354 */
					bool_t BgL_test2403z00_4476;

					{	/* Dataflow/walk.scm 354 */
						BgL_nodez00_bglt BgL_arg1971z00_3518;

						BgL_arg1971z00_3518 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_3320)))->BgL_falsez00);
						BgL_test2403z00_4476 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_arg1971z00_3518), BGl_atomz00zzast_nodez00);
					}
					if (BgL_test2403z00_4476)
						{	/* Dataflow/walk.scm 354 */
							BgL_test2402z00_4475 =
								(
								(((BgL_atomz00_bglt) COBJECT(
											((BgL_atomz00_bglt)
												(((BgL_conditionalz00_bglt) COBJECT(
															((BgL_conditionalz00_bglt) BgL_nodez00_3320)))->
													BgL_falsez00))))->BgL_valuez00) == BFALSE);
						}
					else
						{	/* Dataflow/walk.scm 354 */
							BgL_test2402z00_4475 = ((bool_t) 0);
						}
				}
				if (BgL_test2402z00_4475)
					{	/* Dataflow/walk.scm 354 */
						return
							BGl_appendzd221011zd2zzdataflow_walkz00
							(BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
										(BgL_conditionalz00_bglt) COBJECT(((BgL_conditionalz00_bglt)
												BgL_nodez00_3320)))->BgL_testz00)),
							BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
										(BgL_conditionalz00_bglt) COBJECT(((BgL_conditionalz00_bglt)
												BgL_nodez00_3320)))->BgL_truez00)));
					}
				else
					{	/* Dataflow/walk.scm 354 */
						return BNIL;
					}
			}
		}

	}



/* &dataflow-test-env-in1412 */
	obj_t BGl_z62dataflowzd2testzd2envzd2in1412zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3321, obj_t BgL_nodez00_3322)
	{
		{	/* Dataflow/walk.scm 343 */
			{	/* Dataflow/walk.scm 345 */
				bool_t BgL_test2404z00_4493;

				{	/* Dataflow/walk.scm 345 */
					obj_t BgL_arg1957z00_3520;

					{	/* Dataflow/walk.scm 345 */
						obj_t BgL_pairz00_3521;

						BgL_pairz00_3521 =
							(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt)
										((BgL_instanceofz00_bglt) BgL_nodez00_3322))))->
							BgL_exprza2za2);
						BgL_arg1957z00_3520 = CAR(BgL_pairz00_3521);
					}
					BgL_test2404z00_4493 =
						BGl_isazf3zf3zz__objectz00(BgL_arg1957z00_3520,
						BGl_varz00zzast_nodez00);
				}
				if (BgL_test2404z00_4493)
					{	/* Dataflow/walk.scm 346 */
						obj_t BgL_arg1951z00_3522;

						{	/* Dataflow/walk.scm 346 */
							BgL_variablez00_bglt BgL_arg1953z00_3523;
							BgL_typez00_bglt BgL_arg1954z00_3524;

							{
								BgL_varz00_bglt BgL_auxz00_4499;

								{	/* Dataflow/walk.scm 346 */
									obj_t BgL_pairz00_3525;

									BgL_pairz00_3525 =
										(((BgL_externz00_bglt) COBJECT(
												((BgL_externz00_bglt)
													((BgL_instanceofz00_bglt) BgL_nodez00_3322))))->
										BgL_exprza2za2);
									BgL_auxz00_4499 = ((BgL_varz00_bglt) CAR(BgL_pairz00_3525));
								}
								BgL_arg1953z00_3523 =
									(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4499))->
									BgL_variablez00);
							}
							BgL_arg1954z00_3524 =
								(((BgL_instanceofz00_bglt) COBJECT(
										((BgL_instanceofz00_bglt) BgL_nodez00_3322)))->
								BgL_classz00);
							BgL_arg1951z00_3522 =
								MAKE_YOUNG_PAIR(((obj_t) BgL_arg1953z00_3523),
								((obj_t) BgL_arg1954z00_3524));
						}
						{	/* Dataflow/walk.scm 346 */
							obj_t BgL_list1952z00_3526;

							BgL_list1952z00_3526 = MAKE_YOUNG_PAIR(BgL_arg1951z00_3522, BNIL);
							return BgL_list1952z00_3526;
						}
					}
				else
					{	/* Dataflow/walk.scm 345 */
						return BNIL;
					}
			}
		}

	}



/* &dataflow-test-env-ap1410 */
	obj_t BGl_z62dataflowzd2testzd2envzd2ap1410zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3323, obj_t BgL_nodez00_3324)
	{
		{	/* Dataflow/walk.scm 320 */
			{	/* Dataflow/walk.scm 322 */
				BgL_variablez00_bglt BgL_fz00_3528;

				BgL_fz00_3528 =
					(((BgL_varz00_bglt) COBJECT(
							(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt) BgL_nodez00_3324)))->BgL_funz00)))->
					BgL_variablez00);
				{	/* Dataflow/walk.scm 322 */
					BgL_valuez00_bglt BgL_funvz00_3529;

					BgL_funvz00_3529 =
						(((BgL_variablez00_bglt) COBJECT(BgL_fz00_3528))->BgL_valuez00);
					{	/* Dataflow/walk.scm 323 */

						{	/* Dataflow/walk.scm 325 */
							obj_t BgL_g1168z00_3530;

							BgL_g1168z00_3530 =
								BGl_isazd2ofzd2zztype_miscz00(
								((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3324)));
							if (CBOOL(BgL_g1168z00_3530))
								{	/* Dataflow/walk.scm 328 */
									bool_t BgL_test2406z00_4521;

									{	/* Dataflow/walk.scm 328 */
										obj_t BgL_arg1907z00_3531;

										BgL_arg1907z00_3531 =
											CAR(
											(((BgL_appz00_bglt) COBJECT(
														((BgL_appz00_bglt) BgL_nodez00_3324)))->
												BgL_argsz00));
										BgL_test2406z00_4521 =
											BGl_isazf3zf3zz__objectz00(BgL_arg1907z00_3531,
											BGl_varz00zzast_nodez00);
									}
									if (BgL_test2406z00_4521)
										{	/* Dataflow/walk.scm 329 */
											obj_t BgL_arg1901z00_3532;

											{	/* Dataflow/walk.scm 329 */
												BgL_variablez00_bglt BgL_arg1903z00_3533;

												{
													BgL_varz00_bglt BgL_auxz00_4526;

													{	/* Dataflow/walk.scm 329 */
														obj_t BgL_pairz00_3534;

														BgL_pairz00_3534 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_3324)))->
															BgL_argsz00);
														BgL_auxz00_4526 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_3534));
													}
													BgL_arg1903z00_3533 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4526))->
														BgL_variablez00);
												}
												BgL_arg1901z00_3532 =
													MAKE_YOUNG_PAIR(
													((obj_t) BgL_arg1903z00_3533), BgL_g1168z00_3530);
											}
											{	/* Dataflow/walk.scm 329 */
												obj_t BgL_list1902z00_3535;

												BgL_list1902z00_3535 =
													MAKE_YOUNG_PAIR(BgL_arg1901z00_3532, BNIL);
												return BgL_list1902z00_3535;
											}
										}
									else
										{	/* Dataflow/walk.scm 328 */
											return BNIL;
										}
								}
							else
								{	/* Dataflow/walk.scm 331 */
									bool_t BgL_test2407z00_4535;

									if (BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_funvz00_3529), BGl_funz00zzast_varz00))
										{	/* Dataflow/walk.scm 331 */
											if (CBOOL(
													(((BgL_funz00_bglt) COBJECT(
																((BgL_funz00_bglt) BgL_funvz00_3529)))->
														BgL_predicatezd2ofzd2)))
												{	/* Dataflow/walk.scm 333 */
													bool_t BgL_test2410z00_4543;

													{	/* Dataflow/walk.scm 333 */
														obj_t BgL_tmpz00_4544;

														BgL_tmpz00_4544 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_3324)))->
															BgL_argsz00);
														BgL_test2410z00_4543 = PAIRP(BgL_tmpz00_4544);
													}
													if (BgL_test2410z00_4543)
														{	/* Dataflow/walk.scm 333 */
															if (NULLP(CDR(
																		(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						BgL_nodez00_3324)))->BgL_argsz00))))
																{	/* Dataflow/walk.scm 334 */
																	bool_t BgL_test2412z00_4553;

																	{	/* Dataflow/walk.scm 334 */
																		obj_t BgL_arg1942z00_3536;

																		BgL_arg1942z00_3536 =
																			CAR(
																			(((BgL_appz00_bglt) COBJECT(
																						((BgL_appz00_bglt)
																							BgL_nodez00_3324)))->
																				BgL_argsz00));
																		BgL_test2412z00_4553 =
																			BGl_isazf3zf3zz__objectz00
																			(BgL_arg1942z00_3536,
																			BGl_varz00zzast_nodez00);
																	}
																	if (BgL_test2412z00_4553)
																		{	/* Dataflow/walk.scm 335 */
																			BgL_typez00_bglt BgL_arg1938z00_3537;

																			{
																				BgL_variablez00_bglt BgL_auxz00_4558;

																				{
																					BgL_varz00_bglt BgL_auxz00_4559;

																					{	/* Dataflow/walk.scm 335 */
																						obj_t BgL_pairz00_3538;

																						BgL_pairz00_3538 =
																							(((BgL_appz00_bglt) COBJECT(
																									((BgL_appz00_bglt)
																										BgL_nodez00_3324)))->
																							BgL_argsz00);
																						BgL_auxz00_4559 =
																							((BgL_varz00_bglt)
																							CAR(BgL_pairz00_3538));
																					}
																					BgL_auxz00_4558 =
																						(((BgL_varz00_bglt)
																							COBJECT(BgL_auxz00_4559))->
																						BgL_variablez00);
																				}
																				BgL_arg1938z00_3537 =
																					(((BgL_variablez00_bglt)
																						COBJECT(BgL_auxz00_4558))->
																					BgL_typez00);
																			}
																			BgL_test2407z00_4535 =
																				BGl_bigloozd2typezf3z21zztype_typez00
																				(BgL_arg1938z00_3537);
																		}
																	else
																		{	/* Dataflow/walk.scm 334 */
																			BgL_test2407z00_4535 = ((bool_t) 0);
																		}
																}
															else
																{	/* Dataflow/walk.scm 333 */
																	BgL_test2407z00_4535 = ((bool_t) 0);
																}
														}
													else
														{	/* Dataflow/walk.scm 333 */
															BgL_test2407z00_4535 = ((bool_t) 0);
														}
												}
											else
												{	/* Dataflow/walk.scm 332 */
													BgL_test2407z00_4535 = ((bool_t) 0);
												}
										}
									else
										{	/* Dataflow/walk.scm 331 */
											BgL_test2407z00_4535 = ((bool_t) 0);
										}
									if (BgL_test2407z00_4535)
										{	/* Dataflow/walk.scm 336 */
											obj_t BgL_arg1932z00_3539;

											{	/* Dataflow/walk.scm 336 */
												BgL_variablez00_bglt BgL_arg1934z00_3540;
												obj_t BgL_arg1935z00_3541;

												{
													BgL_varz00_bglt BgL_auxz00_4567;

													{	/* Dataflow/walk.scm 336 */
														obj_t BgL_pairz00_3542;

														BgL_pairz00_3542 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_3324)))->
															BgL_argsz00);
														BgL_auxz00_4567 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_3542));
													}
													BgL_arg1934z00_3540 =
														(((BgL_varz00_bglt) COBJECT(BgL_auxz00_4567))->
														BgL_variablez00);
												}
												BgL_arg1935z00_3541 =
													(((BgL_funz00_bglt) COBJECT(
															((BgL_funz00_bglt) BgL_funvz00_3529)))->
													BgL_predicatezd2ofzd2);
												BgL_arg1932z00_3539 =
													MAKE_YOUNG_PAIR(((obj_t) BgL_arg1934z00_3540),
													BgL_arg1935z00_3541);
											}
											{	/* Dataflow/walk.scm 336 */
												obj_t BgL_list1933z00_3543;

												BgL_list1933z00_3543 =
													MAKE_YOUNG_PAIR(BgL_arg1932z00_3539, BNIL);
												return BgL_list1933z00_3543;
											}
										}
									else
										{	/* Dataflow/walk.scm 331 */
											return BNIL;
										}
								}
						}
					}
				}
			}
		}

	}



/* &dataflow-node!-box-s1406 */
	obj_t BGl_z62dataflowzd2nodez12zd2boxzd2s1406za2zzdataflow_walkz00(obj_t
		BgL_envz00_3325, obj_t BgL_nodez00_3326, obj_t BgL_envz00_3327)
	{
		{	/* Dataflow/walk.scm 300 */
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_3326)))->BgL_valuez00),
				BgL_envz00_3327);
		}

	}



/* &dataflow-node!-box-r1404 */
	obj_t BGl_z62dataflowzd2nodez12zd2boxzd2r1404za2zzdataflow_walkz00(obj_t
		BgL_envz00_3328, obj_t BgL_nodez00_3329, obj_t BgL_envz00_3330)
	{
		{	/* Dataflow/walk.scm 293 */
			return ((obj_t) BgL_envz00_3330);
		}

	}



/* &dataflow-node!-make-1400 */
	obj_t BGl_z62dataflowzd2nodez12zd2makezd21400za2zzdataflow_walkz00(obj_t
		BgL_envz00_3331, obj_t BgL_nodez00_3332, obj_t BgL_envz00_3333)
	{
		{	/* Dataflow/walk.scm 287 */
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_3332)))->BgL_valuez00),
				BgL_envz00_3333);
		}

	}



/* &dataflow-node!-jump-1398 */
	obj_t BGl_z62dataflowzd2nodez12zd2jumpzd21398za2zzdataflow_walkz00(obj_t
		BgL_envz00_3334, obj_t BgL_nodez00_3335, obj_t BgL_envz00_3336)
	{
		{	/* Dataflow/walk.scm 278 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3335)))->BgL_exitz00),
				BgL_envz00_3336);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_jumpzd2exzd2itz00_bglt)
						COBJECT(((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3335)))->
					BgL_valuez00), BgL_envz00_3336);
			return BNIL;
		}

	}



/* &dataflow-node!-set-e1396 */
	obj_t BGl_z62dataflowzd2nodez12zd2setzd2e1396za2zzdataflow_walkz00(obj_t
		BgL_envz00_3337, obj_t BgL_nodez00_3338, obj_t BgL_envz00_3339)
	{
		{	/* Dataflow/walk.scm 270 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3338)))->BgL_bodyz00),
				BgL_envz00_3339);
			return BNIL;
		}

	}



/* &dataflow-node!-let-v1394 */
	obj_t BGl_z62dataflowzd2nodez12zd2letzd2v1394za2zzdataflow_walkz00(obj_t
		BgL_envz00_3340, obj_t BgL_nodez00_3341, obj_t BgL_envz00_3342)
	{
		{	/* Dataflow/walk.scm 238 */
			BGl_letzd2varzd2stampz00zzdataflow_walkz00 =
				(((long) 1) + BGl_letzd2varzd2stampz00zzdataflow_walkz00);
			{	/* Dataflow/walk.scm 241 */
				long BgL_stampz00_3551;

				BgL_stampz00_3551 = BGl_letzd2varzd2stampz00zzdataflow_walkz00;
				{	/* Dataflow/walk.scm 241 */
					obj_t BgL_envz00_3552;

					{
						obj_t BgL_bindingsz00_3554;
						obj_t BgL_envz00_3555;

						BgL_bindingsz00_3554 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nodez00_3341)))->
							BgL_bindingsz00);
						BgL_envz00_3555 = BgL_envz00_3342;
					BgL_loopz00_3553:
						if (NULLP(BgL_bindingsz00_3554))
							{	/* Dataflow/walk.scm 244 */
								BgL_envz00_3552 = BgL_envz00_3555;
							}
						else
							{	/* Dataflow/walk.scm 246 */
								obj_t BgL_nodez00_3556;

								{	/* Dataflow/walk.scm 246 */
									obj_t BgL_pairz00_3557;

									BgL_pairz00_3557 = CAR(((obj_t) BgL_bindingsz00_3554));
									BgL_nodez00_3556 = CDR(BgL_pairz00_3557);
								}
								{	/* Dataflow/walk.scm 246 */
									obj_t BgL_envz00_3558;

									BgL_envz00_3558 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										((BgL_nodez00_bglt) BgL_nodez00_3556), BgL_envz00_3555);
									{	/* Dataflow/walk.scm 247 */

										{	/* Dataflow/walk.scm 248 */
											obj_t BgL_lz00_3559;

											{	/* Dataflow/walk.scm 248 */
												obj_t BgL_pairz00_3560;

												BgL_pairz00_3560 = CAR(((obj_t) BgL_bindingsz00_3554));
												BgL_lz00_3559 = CAR(BgL_pairz00_3560);
											}
											if (
												((((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt) BgL_lz00_3559)))->
														BgL_accessz00) == CNST_TABLE_REF(((long) 11))))
												{	/* Dataflow/walk.scm 249 */
													{	/* Dataflow/walk.scm 250 */
														BgL_localzf2valuezf2_bglt BgL_wide1159z00_3561;

														BgL_wide1159z00_3561 =
															((BgL_localzf2valuezf2_bglt)
															BOBJECT(GC_MALLOC(sizeof(struct
																		BgL_localzf2valuezf2_bgl))));
														{	/* Dataflow/walk.scm 250 */
															obj_t BgL_auxz00_4615;
															BgL_objectz00_bglt BgL_tmpz00_4611;

															BgL_auxz00_4615 = ((obj_t) BgL_wide1159z00_3561);
															BgL_tmpz00_4611 =
																((BgL_objectz00_bglt)
																((BgL_localz00_bglt)
																	((BgL_localz00_bglt) BgL_lz00_3559)));
															BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4611,
																BgL_auxz00_4615);
														}
														((BgL_objectz00_bglt)
															((BgL_localz00_bglt)
																((BgL_localz00_bglt) BgL_lz00_3559)));
														{	/* Dataflow/walk.scm 250 */
															long BgL_arg1888z00_3562;

															BgL_arg1888z00_3562 =
																BGL_CLASS_INDEX
																(BGl_localzf2valuezf2zzdataflow_walkz00);
															BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt) (
																		(BgL_localz00_bglt) ((BgL_localz00_bglt)
																			BgL_lz00_3559))), BgL_arg1888z00_3562);
														}
														((BgL_localz00_bglt)
															((BgL_localz00_bglt)
																((BgL_localz00_bglt) BgL_lz00_3559)));
													}
													{
														BgL_localzf2valuezf2_bglt BgL_auxz00_4629;

														{
															obj_t BgL_auxz00_4630;

															{	/* Dataflow/walk.scm 251 */
																BgL_objectz00_bglt BgL_tmpz00_4631;

																BgL_tmpz00_4631 =
																	((BgL_objectz00_bglt)
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_lz00_3559)));
																BgL_auxz00_4630 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4631);
															}
															BgL_auxz00_4629 =
																((BgL_localzf2valuezf2_bglt) BgL_auxz00_4630);
														}
														((((BgL_localzf2valuezf2_bglt)
																	COBJECT(BgL_auxz00_4629))->BgL_stampz00) =
															((int) (int) (BgL_stampz00_3551)), BUNSPEC);
													}
													{
														BgL_localzf2valuezf2_bglt BgL_auxz00_4639;

														{
															obj_t BgL_auxz00_4640;

															{	/* Dataflow/walk.scm 252 */
																BgL_objectz00_bglt BgL_tmpz00_4641;

																BgL_tmpz00_4641 =
																	((BgL_objectz00_bglt)
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_lz00_3559)));
																BgL_auxz00_4640 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4641);
															}
															BgL_auxz00_4639 =
																((BgL_localzf2valuezf2_bglt) BgL_auxz00_4640);
														}
														((((BgL_localzf2valuezf2_bglt)
																	COBJECT(BgL_auxz00_4639))->BgL_nodez00) =
															((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
																	BgL_nodez00_3556)), BUNSPEC);
													}
													((obj_t)
														((BgL_localz00_bglt)
															((BgL_localz00_bglt) BgL_lz00_3559)));
												}
											else
												{	/* Dataflow/walk.scm 249 */
													BFALSE;
												}
										}
										{	/* Dataflow/walk.scm 253 */
											obj_t BgL_arg1890z00_3563;

											BgL_arg1890z00_3563 = CDR(((obj_t) BgL_bindingsz00_3554));
											{
												obj_t BgL_envz00_4655;
												obj_t BgL_bindingsz00_4654;

												BgL_bindingsz00_4654 = BgL_arg1890z00_3563;
												BgL_envz00_4655 = BgL_envz00_3558;
												BgL_envz00_3555 = BgL_envz00_4655;
												BgL_bindingsz00_3554 = BgL_bindingsz00_4654;
												goto BgL_loopz00_3553;
											}
										}
									}
								}
							}
					}
					{	/* Dataflow/walk.scm 242 */

						{	/* Dataflow/walk.scm 254 */
							obj_t BgL_arg1851z00_3564;

							BgL_arg1851z00_3564 =
								BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
								(((BgL_letzd2varzd2_bglt) COBJECT(
											((BgL_letzd2varzd2_bglt) BgL_nodez00_3341)))->
									BgL_bodyz00), BgL_envz00_3552);
							{	/* Dataflow/walk.scm 256 */
								obj_t BgL_zc3z04anonymousza31853ze3z87_3565;

								BgL_zc3z04anonymousza31853ze3z87_3565 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31853ze3ze5zzdataflow_walkz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31853ze3z87_3565,
									(int) (((long) 0)), BINT(BgL_stampz00_3551));
								{	/* Dataflow/walk.scm 254 */
									obj_t BgL_list1852z00_3566;

									BgL_list1852z00_3566 =
										MAKE_YOUNG_PAIR(BgL_arg1851z00_3564, BNIL);
									return
										BGl_filterzd2mapzd2zz__r4_control_features_6_9z00
										(BgL_zc3z04anonymousza31853ze3z87_3565,
										BgL_list1852z00_3566);
								}
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1853> */
	obj_t BGl_z62zc3z04anonymousza31853ze3ze5zzdataflow_walkz00(obj_t
		BgL_envz00_3343, obj_t BgL_bz00_3345)
	{
		{	/* Dataflow/walk.scm 254 */
			{	/* Dataflow/walk.scm 256 */
				long BgL_stampz00_3344;

				BgL_stampz00_3344 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_3343, (int) (((long) 0))));
				{	/* Dataflow/walk.scm 256 */
					bool_t BgL_test2415z00_4672;

					{	/* Dataflow/walk.scm 256 */
						bool_t BgL_test2416z00_4673;

						{	/* Dataflow/walk.scm 256 */
							obj_t BgL_arg1879z00_3567;

							BgL_arg1879z00_3567 = CAR(((obj_t) BgL_bz00_3345));
							BgL_test2416z00_4673 =
								BGl_isazf3zf3zz__objectz00(BgL_arg1879z00_3567,
								BGl_localzf2valuezf2zzdataflow_walkz00);
						}
						if (BgL_test2416z00_4673)
							{	/* Dataflow/walk.scm 257 */
								int BgL_arg1877z00_3568;

								{	/* Dataflow/walk.scm 257 */
									BgL_localz00_bglt BgL_oz00_3569;

									BgL_oz00_3569 =
										((BgL_localz00_bglt) CAR(((obj_t) BgL_bz00_3345)));
									{
										BgL_localzf2valuezf2_bglt BgL_auxz00_4680;

										{
											obj_t BgL_auxz00_4681;

											{	/* Dataflow/walk.scm 257 */
												BgL_objectz00_bglt BgL_tmpz00_4682;

												BgL_tmpz00_4682 = ((BgL_objectz00_bglt) BgL_oz00_3569);
												BgL_auxz00_4681 = BGL_OBJECT_WIDENING(BgL_tmpz00_4682);
											}
											BgL_auxz00_4680 =
												((BgL_localzf2valuezf2_bglt) BgL_auxz00_4681);
										}
										BgL_arg1877z00_3568 =
											(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4680))->
											BgL_stampz00);
								}}
								BgL_test2415z00_4672 =
									((long) (BgL_arg1877z00_3568) < BgL_stampz00_3344);
							}
						else
							{	/* Dataflow/walk.scm 256 */
								BgL_test2415z00_4672 = ((bool_t) 1);
							}
					}
					if (BgL_test2415z00_4672)
						{	/* Dataflow/walk.scm 256 */
							return BgL_bz00_3345;
						}
					else
						{	/* Dataflow/walk.scm 259 */
							bool_t BgL_test2417z00_4689;

							{	/* Dataflow/walk.scm 259 */
								BgL_nodez00_bglt BgL_arg1873z00_3570;

								{	/* Dataflow/walk.scm 259 */
									BgL_localz00_bglt BgL_oz00_3571;

									BgL_oz00_3571 =
										((BgL_localz00_bglt) CAR(((obj_t) BgL_bz00_3345)));
									{
										BgL_localzf2valuezf2_bglt BgL_auxz00_4693;

										{
											obj_t BgL_auxz00_4694;

											{	/* Dataflow/walk.scm 259 */
												BgL_objectz00_bglt BgL_tmpz00_4695;

												BgL_tmpz00_4695 = ((BgL_objectz00_bglt) BgL_oz00_3571);
												BgL_auxz00_4694 = BGL_OBJECT_WIDENING(BgL_tmpz00_4695);
											}
											BgL_auxz00_4693 =
												((BgL_localzf2valuezf2_bglt) BgL_auxz00_4694);
										}
										BgL_arg1873z00_3570 =
											(((BgL_localzf2valuezf2_bglt) COBJECT(BgL_auxz00_4693))->
											BgL_nodez00);
									}
								}
								BgL_test2417z00_4689 =
									BGl_isazf3zf3zz__objectz00(
									((obj_t) BgL_arg1873z00_3570), BGl_varz00zzast_nodez00);
							}
							if (BgL_test2417z00_4689)
								{	/* Dataflow/walk.scm 260 */
									BgL_variablez00_bglt BgL_vz00_3572;

									{	/* Dataflow/walk.scm 260 */
										BgL_nodez00_bglt BgL_arg1871z00_3573;

										{	/* Dataflow/walk.scm 260 */
											BgL_localz00_bglt BgL_oz00_3574;

											BgL_oz00_3574 =
												((BgL_localz00_bglt) CAR(((obj_t) BgL_bz00_3345)));
											{
												BgL_localzf2valuezf2_bglt BgL_auxz00_4705;

												{
													obj_t BgL_auxz00_4706;

													{	/* Dataflow/walk.scm 260 */
														BgL_objectz00_bglt BgL_tmpz00_4707;

														BgL_tmpz00_4707 =
															((BgL_objectz00_bglt) BgL_oz00_3574);
														BgL_auxz00_4706 =
															BGL_OBJECT_WIDENING(BgL_tmpz00_4707);
													}
													BgL_auxz00_4705 =
														((BgL_localzf2valuezf2_bglt) BgL_auxz00_4706);
												}
												BgL_arg1871z00_3573 =
													(((BgL_localzf2valuezf2_bglt)
														COBJECT(BgL_auxz00_4705))->BgL_nodez00);
											}
										}
										BgL_vz00_3572 =
											(((BgL_varz00_bglt) COBJECT(
													((BgL_varz00_bglt) BgL_arg1871z00_3573)))->
											BgL_variablez00);
									}
									if (
										((((BgL_variablez00_bglt) COBJECT(BgL_vz00_3572))->
												BgL_accessz00) == CNST_TABLE_REF(((long) 11))))
										{	/* Dataflow/walk.scm 262 */
											obj_t BgL_arg1867z00_3575;

											BgL_arg1867z00_3575 = CDR(((obj_t) BgL_bz00_3345));
											return
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_vz00_3572), BgL_arg1867z00_3575);
										}
									else
										{	/* Dataflow/walk.scm 261 */
											return BFALSE;
										}
								}
							else
								{	/* Dataflow/walk.scm 259 */
									return BFALSE;
								}
						}
				}
			}
		}

	}



/* &dataflow-node!-let-f1392 */
	obj_t BGl_z62dataflowzd2nodez12zd2letzd2f1392za2zzdataflow_walkz00(obj_t
		BgL_envz00_3346, obj_t BgL_nodez00_3347, obj_t BgL_envz00_3348)
	{
		{	/* Dataflow/walk.scm 223 */
			{	/* Dataflow/walk.scm 225 */
				obj_t BgL_g1344z00_3577;

				BgL_g1344z00_3577 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3347)))->BgL_localsz00);
				{
					obj_t BgL_l1342z00_3579;

					BgL_l1342z00_3579 = BgL_g1344z00_3577;
				BgL_zc3z04anonymousza31839ze3z87_3578:
					if (PAIRP(BgL_l1342z00_3579))
						{	/* Dataflow/walk.scm 225 */
							{	/* Dataflow/walk.scm 226 */
								obj_t BgL_localz00_3580;

								BgL_localz00_3580 = CAR(BgL_l1342z00_3579);
								{	/* Dataflow/walk.scm 226 */
									obj_t BgL_arg1841z00_3581;

									BgL_arg1841z00_3581 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt)
																	((BgL_localz00_bglt) BgL_localz00_3580))))->
														BgL_valuez00))))->BgL_bodyz00);
									BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((
											(BgL_nodez00_bglt) BgL_arg1841z00_3581), BNIL);
								}
							}
							{
								obj_t BgL_l1342z00_4734;

								BgL_l1342z00_4734 = CDR(BgL_l1342z00_3579);
								BgL_l1342z00_3579 = BgL_l1342z00_4734;
								goto BgL_zc3z04anonymousza31839ze3z87_3578;
							}
						}
					else
						{	/* Dataflow/walk.scm 225 */
							((bool_t) 1);
						}
				}
			}
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3347)))->BgL_bodyz00),
				BgL_envz00_3348);
		}

	}



/* &dataflow-node!-switc1390 */
	obj_t BGl_z62dataflowzd2nodez12zd2switc1390z70zzdataflow_walkz00(obj_t
		BgL_envz00_3349, obj_t BgL_nodez00_3350, obj_t BgL_envz00_3351)
	{
		{	/* Dataflow/walk.scm 212 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_3350)))->BgL_testz00),
				BgL_envz00_3351);
			{	/* Dataflow/walk.scm 215 */
				obj_t BgL_g1341z00_3583;

				BgL_g1341z00_3583 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_3350)))->BgL_clausesz00);
				{
					obj_t BgL_l1339z00_3585;

					BgL_l1339z00_3585 = BgL_g1341z00_3583;
				BgL_zc3z04anonymousza31835ze3z87_3584:
					if (PAIRP(BgL_l1339z00_3585))
						{	/* Dataflow/walk.scm 215 */
							{	/* Dataflow/walk.scm 216 */
								obj_t BgL_clausez00_3586;

								BgL_clausez00_3586 = CAR(BgL_l1339z00_3585);
								{	/* Dataflow/walk.scm 216 */
									obj_t BgL_arg1837z00_3587;

									BgL_arg1837z00_3587 = CDR(((obj_t) BgL_clausez00_3586));
									BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										((BgL_nodez00_bglt) BgL_arg1837z00_3587), BgL_envz00_3351);
								}
							}
							{
								obj_t BgL_l1339z00_4751;

								BgL_l1339z00_4751 = CDR(BgL_l1339z00_3585);
								BgL_l1339z00_3585 = BgL_l1339z00_4751;
								goto BgL_zc3z04anonymousza31835ze3z87_3584;
							}
						}
					else
						{	/* Dataflow/walk.scm 215 */
							((bool_t) 1);
						}
				}
			}
			return BgL_envz00_3351;
		}

	}



/* &dataflow-node!-fail1388 */
	obj_t BGl_z62dataflowzd2nodez12zd2fail1388z70zzdataflow_walkz00(obj_t
		BgL_envz00_3352, obj_t BgL_nodez00_3353, obj_t BgL_envz00_3354)
	{
		{	/* Dataflow/walk.scm 202 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_3353)))->BgL_procz00),
				BgL_envz00_3354);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_failz00_bglt)
						COBJECT(((BgL_failz00_bglt) BgL_nodez00_3353)))->BgL_msgz00),
				BgL_envz00_3354);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_failz00_bglt)
						COBJECT(((BgL_failz00_bglt) BgL_nodez00_3353)))->BgL_objz00),
				BgL_envz00_3354);
			return BgL_envz00_3354;
		}

	}



/* &dataflow-node!-condi1386 */
	obj_t BGl_z62dataflowzd2nodez12zd2condi1386z70zzdataflow_walkz00(obj_t
		BgL_envz00_3355, obj_t BgL_nodez00_3356, obj_t BgL_envz00_3357)
	{
		{	/* Dataflow/walk.scm 179 */
			{
				obj_t BgL_env1z00_3591;
				obj_t BgL_env2z00_3592;

				{	/* Dataflow/walk.scm 190 */
					obj_t BgL_tenvz00_3603;

					BgL_tenvz00_3603 =
						BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
						(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_3356)))->BgL_testz00),
						BgL_envz00_3357);
					{	/* Dataflow/walk.scm 190 */
						obj_t BgL_truezd2envzd2_3604;

						BgL_truezd2envzd2_3604 =
							BGl_appendzd221011zd2zzdataflow_walkz00
							(BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
										(BgL_conditionalz00_bglt) COBJECT(((BgL_conditionalz00_bglt)
												BgL_nodez00_3356)))->BgL_testz00)), BgL_tenvz00_3603);
						{	/* Dataflow/walk.scm 191 */
							obj_t BgL_falsezd2envzd2_3605;

							BgL_falsezd2envzd2_3605 =
								BGl_appendzd221011zd2zzdataflow_walkz00
								(BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(((
											(BgL_conditionalz00_bglt)
											COBJECT(((BgL_conditionalz00_bglt) BgL_nodez00_3356)))->
										BgL_testz00)), BgL_tenvz00_3603);
							{	/* Dataflow/walk.scm 192 */

								{	/* Dataflow/walk.scm 193 */
									obj_t BgL_tenvz00_3606;
									obj_t BgL_fenvz00_3607;

									BgL_tenvz00_3606 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										(((BgL_conditionalz00_bglt) COBJECT(
													((BgL_conditionalz00_bglt) BgL_nodez00_3356)))->
											BgL_falsez00), BgL_falsezd2envzd2_3605);
									BgL_fenvz00_3607 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(((
												(BgL_conditionalz00_bglt)
												COBJECT(((BgL_conditionalz00_bglt) BgL_nodez00_3356)))->
											BgL_truez00), BgL_truezd2envzd2_3604);
									{	/* Dataflow/walk.scm 195 */
										bool_t BgL_test2421z00_4779;

										{	/* Dataflow/walk.scm 195 */
											BgL_nodez00_bglt BgL_arg1812z00_3608;

											BgL_arg1812z00_3608 =
												(((BgL_conditionalz00_bglt) COBJECT(
														((BgL_conditionalz00_bglt) BgL_nodez00_3356)))->
												BgL_falsez00);
											BgL_test2421z00_4779 =
												CBOOL(BGl_abortzf3zf3zzdataflow_walkz00
												(BgL_arg1812z00_3608));
										}
										if (BgL_test2421z00_4779)
											{	/* Dataflow/walk.scm 195 */
												return BgL_tenvz00_3606;
											}
										else
											{	/* Dataflow/walk.scm 195 */
												BgL_env1z00_3591 = BgL_tenvz00_3606;
												BgL_env2z00_3592 = BgL_fenvz00_3607;
												{	/* Dataflow/walk.scm 182 */
													obj_t BgL_hook1338z00_3593;

													BgL_hook1338z00_3593 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
													{
														obj_t BgL_l1335z00_3595;
														obj_t BgL_h1336z00_3596;

														BgL_l1335z00_3595 = BgL_env1z00_3591;
														BgL_h1336z00_3596 = BgL_hook1338z00_3593;
													BgL_zc3z04anonymousza31823ze3z87_3594:
														if (NULLP(BgL_l1335z00_3595))
															{	/* Dataflow/walk.scm 182 */
																return CDR(BgL_hook1338z00_3593);
															}
														else
															{	/* Dataflow/walk.scm 182 */
																bool_t BgL_test2423z00_4788;

																{	/* Dataflow/walk.scm 183 */
																	obj_t BgL_cz00_3597;

																	BgL_cz00_3597 =
																		CAR(((obj_t) BgL_l1335z00_3595));
																	{	/* Dataflow/walk.scm 184 */
																		obj_t BgL_c2z00_3598;

																		BgL_c2z00_3598 =
																			BGl_assqz00zz__r4_pairs_and_lists_6_3z00
																			(CAR(((obj_t) BgL_cz00_3597)),
																			BgL_env2z00_3592);
																		{	/* Dataflow/walk.scm 185 */

																			if (PAIRP(BgL_c2z00_3598))
																				{	/* Dataflow/walk.scm 186 */
																					BgL_test2423z00_4788 =
																						(CDR(BgL_c2z00_3598) ==
																						CDR(((obj_t) BgL_cz00_3597)));
																				}
																			else
																				{	/* Dataflow/walk.scm 186 */
																					BgL_test2423z00_4788 = ((bool_t) 0);
																				}
																		}
																	}
																}
																if (BgL_test2423z00_4788)
																	{	/* Dataflow/walk.scm 182 */
																		obj_t BgL_nh1337z00_3599;

																		{	/* Dataflow/walk.scm 182 */
																			obj_t BgL_arg1828z00_3600;

																			BgL_arg1828z00_3600 =
																				CAR(((obj_t) BgL_l1335z00_3595));
																			BgL_nh1337z00_3599 =
																				MAKE_YOUNG_PAIR(BgL_arg1828z00_3600,
																				BNIL);
																		}
																		SET_CDR(BgL_h1336z00_3596,
																			BgL_nh1337z00_3599);
																		{	/* Dataflow/walk.scm 182 */
																			obj_t BgL_arg1827z00_3601;

																			BgL_arg1827z00_3601 =
																				CDR(((obj_t) BgL_l1335z00_3595));
																			{
																				obj_t BgL_h1336z00_4807;
																				obj_t BgL_l1335z00_4806;

																				BgL_l1335z00_4806 = BgL_arg1827z00_3601;
																				BgL_h1336z00_4807 = BgL_nh1337z00_3599;
																				BgL_h1336z00_3596 = BgL_h1336z00_4807;
																				BgL_l1335z00_3595 = BgL_l1335z00_4806;
																				goto
																					BgL_zc3z04anonymousza31823ze3z87_3594;
																			}
																		}
																	}
																else
																	{	/* Dataflow/walk.scm 182 */
																		obj_t BgL_arg1829z00_3602;

																		BgL_arg1829z00_3602 =
																			CDR(((obj_t) BgL_l1335z00_3595));
																		{
																			obj_t BgL_l1335z00_4810;

																			BgL_l1335z00_4810 = BgL_arg1829z00_3602;
																			BgL_l1335z00_3595 = BgL_l1335z00_4810;
																			goto
																				BgL_zc3z04anonymousza31823ze3z87_3594;
																		}
																	}
															}
													}
												}
											}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* &dataflow-node!-setq1384 */
	obj_t BGl_z62dataflowzd2nodez12zd2setq1384z70zzdataflow_walkz00(obj_t
		BgL_envz00_3358, obj_t BgL_nodez00_3359, obj_t BgL_envz00_3360)
	{
		{	/* Dataflow/walk.scm 159 */
			{
				BgL_variablez00_bglt BgL_variablez00_3611;
				obj_t BgL_envz00_3612;

				{	/* Dataflow/walk.scm 167 */
					obj_t BgL_nenvz00_3622;

					BgL_nenvz00_3622 =
						BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
						(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nodez00_3359)))->BgL_valuez00),
						BgL_envz00_3360);
					{	/* Dataflow/walk.scm 168 */
						BgL_varz00_bglt BgL_i1150z00_3623;

						BgL_i1150z00_3623 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nodez00_3359)))->BgL_varz00);
						{	/* Dataflow/walk.scm 169 */
							bool_t BgL_test2425z00_4816;

							{	/* Dataflow/walk.scm 169 */
								BgL_variablez00_bglt BgL_arg1774z00_3624;

								BgL_arg1774z00_3624 =
									(((BgL_varz00_bglt) COBJECT(BgL_i1150z00_3623))->
									BgL_variablez00);
								BgL_test2425z00_4816 =
									BGl_isazf3zf3zz__objectz00(((obj_t) BgL_arg1774z00_3624),
									BGl_globalz00zzast_varz00);
							}
							if (BgL_test2425z00_4816)
								{	/* Dataflow/walk.scm 169 */
									BgL_variablez00_3611 =
										(((BgL_varz00_bglt) COBJECT(BgL_i1150z00_3623))->
										BgL_variablez00);
									BgL_envz00_3612 = BgL_nenvz00_3622;
								BgL_removezd2variablezd2fromzd2envzd2_3610:
									{	/* Dataflow/walk.scm 162 */
										obj_t BgL_hook1333z00_3613;

										BgL_hook1333z00_3613 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
										{
											obj_t BgL_l1330z00_3615;
											obj_t BgL_h1331z00_3616;

											BgL_l1330z00_3615 = BgL_envz00_3612;
											BgL_h1331z00_3616 = BgL_hook1333z00_3613;
										BgL_zc3z04anonymousza31788ze3z87_3614:
											if (NULLP(BgL_l1330z00_3615))
												{	/* Dataflow/walk.scm 162 */
													return CDR(BgL_hook1333z00_3613);
												}
											else
												{	/* Dataflow/walk.scm 162 */
													bool_t BgL_test2427z00_4824;

													{	/* Dataflow/walk.scm 163 */
														bool_t BgL_test2428z00_4825;

														{	/* Dataflow/walk.scm 163 */
															obj_t BgL_tmpz00_4826;

															{	/* Dataflow/walk.scm 163 */
																obj_t BgL_pairz00_3617;

																BgL_pairz00_3617 =
																	CAR(((obj_t) BgL_l1330z00_3615));
																BgL_tmpz00_4826 = CAR(BgL_pairz00_3617);
															}
															BgL_test2428z00_4825 =
																(BgL_tmpz00_4826 ==
																((obj_t) BgL_variablez00_3611));
														}
														if (BgL_test2428z00_4825)
															{	/* Dataflow/walk.scm 163 */
																BgL_test2427z00_4824 = ((bool_t) 0);
															}
														else
															{	/* Dataflow/walk.scm 163 */
																BgL_test2427z00_4824 = ((bool_t) 1);
															}
													}
													if (BgL_test2427z00_4824)
														{	/* Dataflow/walk.scm 162 */
															obj_t BgL_nh1332z00_3618;

															{	/* Dataflow/walk.scm 162 */
																obj_t BgL_arg1806z00_3619;

																BgL_arg1806z00_3619 =
																	CAR(((obj_t) BgL_l1330z00_3615));
																BgL_nh1332z00_3618 =
																	MAKE_YOUNG_PAIR(BgL_arg1806z00_3619, BNIL);
															}
															SET_CDR(BgL_h1331z00_3616, BgL_nh1332z00_3618);
															{	/* Dataflow/walk.scm 162 */
																obj_t BgL_arg1804z00_3620;

																BgL_arg1804z00_3620 =
																	CDR(((obj_t) BgL_l1330z00_3615));
																{
																	obj_t BgL_h1331z00_4839;
																	obj_t BgL_l1330z00_4838;

																	BgL_l1330z00_4838 = BgL_arg1804z00_3620;
																	BgL_h1331z00_4839 = BgL_nh1332z00_3618;
																	BgL_h1331z00_3616 = BgL_h1331z00_4839;
																	BgL_l1330z00_3615 = BgL_l1330z00_4838;
																	goto BgL_zc3z04anonymousza31788ze3z87_3614;
																}
															}
														}
													else
														{	/* Dataflow/walk.scm 162 */
															obj_t BgL_arg1808z00_3621;

															BgL_arg1808z00_3621 =
																CDR(((obj_t) BgL_l1330z00_3615));
															{
																obj_t BgL_l1330z00_4842;

																BgL_l1330z00_4842 = BgL_arg1808z00_3621;
																BgL_l1330z00_3615 = BgL_l1330z00_4842;
																goto BgL_zc3z04anonymousza31788ze3z87_3614;
															}
														}
												}
										}
									}
								}
							else
								{	/* Dataflow/walk.scm 171 */
									BgL_typez00_bglt BgL_typz00_3625;

									BgL_typz00_3625 =
										BGl_getzd2typezd2zztype_typeofz00(
										(((BgL_setqz00_bglt) COBJECT(
													((BgL_setqz00_bglt) BgL_nodez00_3359)))->
											BgL_valuez00), ((bool_t) 1));
									{	/* Dataflow/walk.scm 172 */
										bool_t BgL_test2429z00_4847;

										if (
											(((obj_t) BgL_typz00_3625) ==
												BGl_za2_za2z00zztype_cachez00))
											{	/* Dataflow/walk.scm 172 */
												BgL_test2429z00_4847 = ((bool_t) 1);
											}
										else
											{	/* Dataflow/walk.scm 172 */
												BgL_test2429z00_4847 =
													(
													((obj_t) BgL_typz00_3625) ==
													BGl_za2objza2z00zztype_cachez00);
											}
										if (BgL_test2429z00_4847)
											{
												obj_t BgL_envz00_4855;
												BgL_variablez00_bglt BgL_variablez00_4853;

												BgL_variablez00_4853 =
													(((BgL_varz00_bglt) COBJECT(BgL_i1150z00_3623))->
													BgL_variablez00);
												BgL_envz00_4855 = BgL_nenvz00_3622;
												BgL_envz00_3612 = BgL_envz00_4855;
												BgL_variablez00_3611 = BgL_variablez00_4853;
												goto BgL_removezd2variablezd2fromzd2envzd2_3610;
											}
										else
											{	/* Dataflow/walk.scm 174 */
												obj_t BgL_arg1759z00_3626;

												{	/* Dataflow/walk.scm 174 */
													BgL_variablez00_bglt BgL_arg1760z00_3627;

													BgL_arg1760z00_3627 =
														(((BgL_varz00_bglt) COBJECT(BgL_i1150z00_3623))->
														BgL_variablez00);
													BgL_arg1759z00_3626 =
														MAKE_YOUNG_PAIR(((obj_t) BgL_arg1760z00_3627),
														((obj_t) BgL_typz00_3625));
												}
												return
													MAKE_YOUNG_PAIR(BgL_arg1759z00_3626,
													BgL_nenvz00_3622);
											}
									}
								}
						}
					}
				}
			}
		}

	}



/* &dataflow-node!-exter1382 */
	obj_t BGl_z62dataflowzd2nodez12zd2exter1382z70zzdataflow_walkz00(obj_t
		BgL_envz00_3361, obj_t BgL_nodez00_3362, obj_t BgL_envz00_3363)
	{
		{	/* Dataflow/walk.scm 152 */
			{	/* Dataflow/walk.scm 153 */
				obj_t BgL_res2282z00_3629;

				BgL_res2282z00_3629 =
					BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(
					(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt) BgL_nodez00_3362)))->BgL_exprza2za2),
					BgL_envz00_3363);
				return BgL_res2282z00_3629;
			}
		}

	}



/* &dataflow-node!-funca1380 */
	obj_t BGl_z62dataflowzd2nodez12zd2funca1380z70zzdataflow_walkz00(obj_t
		BgL_envz00_3364, obj_t BgL_nodez00_3365, obj_t BgL_envz00_3366)
	{
		{	/* Dataflow/walk.scm 144 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_3365)))->BgL_funz00),
				BgL_envz00_3366);
			return
				BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00((((BgL_funcallz00_bglt)
						COBJECT(((BgL_funcallz00_bglt) BgL_nodez00_3365)))->BgL_argsz00),
				BgL_envz00_3366);
		}

	}



/* &dataflow-node!-app-l1378 */
	obj_t BGl_z62dataflowzd2nodez12zd2appzd2l1378za2zzdataflow_walkz00(obj_t
		BgL_envz00_3367, obj_t BgL_nodez00_3368, obj_t BgL_envz00_3369)
	{
		{	/* Dataflow/walk.scm 136 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_3368)))->BgL_funz00),
				BgL_envz00_3369);
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_appzd2lyzd2_bglt)
						COBJECT(((BgL_appzd2lyzd2_bglt) BgL_nodez00_3368)))->BgL_argz00),
				BgL_envz00_3369);
		}

	}



/* &dataflow-node!-app1376 */
	obj_t BGl_z62dataflowzd2nodez12zd2app1376z70zzdataflow_walkz00(obj_t
		BgL_envz00_3370, obj_t BgL_nodez00_3371, obj_t BgL_envz00_3372)
	{
		{	/* Dataflow/walk.scm 120 */
			{	/* Dataflow/walk.scm 122 */
				obj_t BgL_aenvz00_3633;

				BgL_aenvz00_3633 =
					BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(
					(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3371)))->BgL_argsz00),
					BgL_envz00_3372);
				{	/* Dataflow/walk.scm 123 */
					bool_t BgL_test2431z00_4879;

					{	/* Dataflow/walk.scm 123 */
						BgL_variablez00_bglt BgL_arg1734z00_3634;

						BgL_arg1734z00_3634 =
							(((BgL_varz00_bglt) COBJECT(
									(((BgL_appz00_bglt) COBJECT(
												((BgL_appz00_bglt) BgL_nodez00_3371)))->BgL_funz00)))->
							BgL_variablez00);
						BgL_test2431z00_4879 =
							BGl_isazf3zf3zz__objectz00(((obj_t) BgL_arg1734z00_3634),
							BGl_localz00zzast_varz00);
					}
					if (BgL_test2431z00_4879)
						{	/* Dataflow/walk.scm 127 */
							obj_t BgL_hook1328z00_3635;

							BgL_hook1328z00_3635 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							{
								obj_t BgL_l1325z00_3637;
								obj_t BgL_h1326z00_3638;

								BgL_l1325z00_3637 = BgL_aenvz00_3633;
								BgL_h1326z00_3638 = BgL_hook1328z00_3635;
							BgL_zc3z04anonymousza31719ze3z87_3636:
								if (NULLP(BgL_l1325z00_3637))
									{	/* Dataflow/walk.scm 127 */
										return CDR(BgL_hook1328z00_3635);
									}
								else
									{	/* Dataflow/walk.scm 127 */
										bool_t BgL_test2433z00_4889;

										{	/* Dataflow/walk.scm 128 */
											obj_t BgL_vz00_3639;

											{	/* Dataflow/walk.scm 128 */
												obj_t BgL_pairz00_3640;

												BgL_pairz00_3640 = CAR(((obj_t) BgL_l1325z00_3637));
												BgL_vz00_3639 = CAR(BgL_pairz00_3640);
											}
											{	/* Dataflow/walk.scm 129 */
												bool_t BgL__ortest_1146z00_3641;

												BgL__ortest_1146z00_3641 =
													BGl_isazf3zf3zz__objectz00(BgL_vz00_3639,
													BGl_globalz00zzast_varz00);
												if (BgL__ortest_1146z00_3641)
													{	/* Dataflow/walk.scm 129 */
														BgL_test2433z00_4889 = BgL__ortest_1146z00_3641;
													}
												else
													{	/* Dataflow/walk.scm 129 */
														BgL_test2433z00_4889 =
															(
															(((BgL_variablez00_bglt) COBJECT(
																		((BgL_variablez00_bglt) BgL_vz00_3639)))->
																BgL_accessz00) == CNST_TABLE_REF(((long) 11)));
										}}}
										if (BgL_test2433z00_4889)
											{	/* Dataflow/walk.scm 127 */
												obj_t BgL_nh1327z00_3642;

												{	/* Dataflow/walk.scm 127 */
													obj_t BgL_arg1725z00_3643;

													BgL_arg1725z00_3643 =
														CAR(((obj_t) BgL_l1325z00_3637));
													BgL_nh1327z00_3642 =
														MAKE_YOUNG_PAIR(BgL_arg1725z00_3643, BNIL);
												}
												SET_CDR(BgL_h1326z00_3638, BgL_nh1327z00_3642);
												{	/* Dataflow/walk.scm 127 */
													obj_t BgL_arg1724z00_3644;

													BgL_arg1724z00_3644 =
														CDR(((obj_t) BgL_l1325z00_3637));
													{
														obj_t BgL_h1326z00_4906;
														obj_t BgL_l1325z00_4905;

														BgL_l1325z00_4905 = BgL_arg1724z00_3644;
														BgL_h1326z00_4906 = BgL_nh1327z00_3642;
														BgL_h1326z00_3638 = BgL_h1326z00_4906;
														BgL_l1325z00_3637 = BgL_l1325z00_4905;
														goto BgL_zc3z04anonymousza31719ze3z87_3636;
													}
												}
											}
										else
											{	/* Dataflow/walk.scm 127 */
												obj_t BgL_arg1732z00_3645;

												BgL_arg1732z00_3645 = CDR(((obj_t) BgL_l1325z00_3637));
												{
													obj_t BgL_l1325z00_4909;

													BgL_l1325z00_4909 = BgL_arg1732z00_3645;
													BgL_l1325z00_3637 = BgL_l1325z00_4909;
													goto BgL_zc3z04anonymousza31719ze3z87_3636;
												}
											}
									}
							}
						}
					else
						{	/* Dataflow/walk.scm 123 */
							return BgL_aenvz00_3633;
						}
				}
			}
		}

	}



/* &dataflow-node!-sync1374 */
	obj_t BGl_z62dataflowzd2nodez12zd2sync1374z70zzdataflow_walkz00(obj_t
		BgL_envz00_3373, obj_t BgL_nodez00_3374, obj_t BgL_envz00_3375)
	{
		{	/* Dataflow/walk.scm 111 */
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_3374)))->BgL_mutexz00),
				BgL_envz00_3375);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_syncz00_bglt)
						COBJECT(((BgL_syncz00_bglt) BgL_nodez00_3374)))->BgL_prelockz00),
				BgL_envz00_3375);
			BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_syncz00_bglt)
						COBJECT(((BgL_syncz00_bglt) BgL_nodez00_3374)))->BgL_bodyz00),
				BgL_envz00_3375);
			return BgL_envz00_3375;
		}

	}



/* &dataflow-node!-seque1372 */
	obj_t BGl_z62dataflowzd2nodez12zd2seque1372z70zzdataflow_walkz00(obj_t
		BgL_envz00_3376, obj_t BgL_nodez00_3377, obj_t BgL_envz00_3378)
	{
		{	/* Dataflow/walk.scm 101 */
			{	/* Dataflow/walk.scm 102 */
				obj_t BgL_res2283z00_3655;

				{	/* Dataflow/walk.scm 102 */
					obj_t BgL_g1144z00_3648;

					BgL_g1144z00_3648 =
						(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_3377)))->BgL_nodesz00);
					{
						obj_t BgL_nodeza2za2_3650;
						obj_t BgL_envz00_3651;

						BgL_nodeza2za2_3650 = BgL_g1144z00_3648;
						BgL_envz00_3651 = BgL_envz00_3378;
					BgL_loopz00_3649:
						if (NULLP(BgL_nodeza2za2_3650))
							{	/* Dataflow/walk.scm 104 */
								BgL_res2283z00_3655 = BgL_envz00_3651;
							}
						else
							{	/* Dataflow/walk.scm 106 */
								obj_t BgL_arg1690z00_3652;
								obj_t BgL_arg1691z00_3653;

								BgL_arg1690z00_3652 = CDR(((obj_t) BgL_nodeza2za2_3650));
								{	/* Dataflow/walk.scm 106 */
									obj_t BgL_arg1695z00_3654;

									BgL_arg1695z00_3654 = CAR(((obj_t) BgL_nodeza2za2_3650));
									BgL_arg1691z00_3653 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										((BgL_nodez00_bglt) BgL_arg1695z00_3654), BgL_envz00_3651);
								}
								{
									obj_t BgL_envz00_4930;
									obj_t BgL_nodeza2za2_4929;

									BgL_nodeza2za2_4929 = BgL_arg1690z00_3652;
									BgL_envz00_4930 = BgL_arg1691z00_3653;
									BgL_envz00_3651 = BgL_envz00_4930;
									BgL_nodeza2za2_3650 = BgL_nodeza2za2_4929;
									goto BgL_loopz00_3649;
								}
							}
					}
				}
				return BgL_res2283z00_3655;
			}
		}

	}



/* &dataflow-node!-closu1370 */
	obj_t BGl_z62dataflowzd2nodez12zd2closu1370z70zzdataflow_walkz00(obj_t
		BgL_envz00_3379, obj_t BgL_nodez00_3380, obj_t BgL_envz00_3381)
	{
		{	/* Dataflow/walk.scm 95 */
			return ((obj_t) BgL_envz00_3381);
		}

	}



/* &dataflow-node!-var1368 */
	obj_t BGl_z62dataflowzd2nodez12zd2var1368z70zzdataflow_walkz00(obj_t
		BgL_envz00_3382, obj_t BgL_nodez00_3383, obj_t BgL_envz00_3384)
	{
		{	/* Dataflow/walk.scm 81 */
			{	/* Dataflow/walk.scm 83 */
				BgL_variablez00_bglt BgL_i1142z00_3659;

				BgL_i1142z00_3659 =
					(((BgL_varz00_bglt) COBJECT(
							((BgL_varz00_bglt) BgL_nodez00_3383)))->BgL_variablez00);
				{	/* Dataflow/walk.scm 84 */
					bool_t BgL_test2436z00_4934;

					if (BGl_bigloozd2typezf3z21zztype_typez00(
							(((BgL_variablez00_bglt) COBJECT(BgL_i1142z00_3659))->
								BgL_typez00)))
						{	/* Dataflow/walk.scm 85 */
							bool_t BgL__ortest_1143z00_3660;

							{	/* Dataflow/walk.scm 85 */
								bool_t BgL_test2438z00_4938;

								{	/* Dataflow/walk.scm 85 */
									BgL_typez00_bglt BgL_arg1685z00_3661;

									BgL_arg1685z00_3661 =
										(((BgL_variablez00_bglt) COBJECT(BgL_i1142z00_3659))->
										BgL_typez00);
									BgL_test2438z00_4938 =
										BGl_isazf3zf3zz__objectz00(((obj_t) BgL_arg1685z00_3661),
										BGl_tclassz00zzobject_classz00);
								}
								if (BgL_test2438z00_4938)
									{	/* Dataflow/walk.scm 85 */
										BgL__ortest_1143z00_3660 = ((bool_t) 0);
									}
								else
									{	/* Dataflow/walk.scm 85 */
										BgL__ortest_1143z00_3660 = ((bool_t) 1);
									}
							}
							if (BgL__ortest_1143z00_3660)
								{	/* Dataflow/walk.scm 85 */
									BgL_test2436z00_4934 = BgL__ortest_1143z00_3660;
								}
							else
								{	/* Dataflow/walk.scm 85 */
									BgL_typez00_bglt BgL_arg1679z00_3662;
									BgL_typez00_bglt BgL_arg1682z00_3663;

									BgL_arg1679z00_3662 =
										(((BgL_variablez00_bglt) COBJECT(BgL_i1142z00_3659))->
										BgL_typez00);
									BgL_arg1682z00_3663 =
										(((BgL_nodez00_bglt)
											COBJECT(((BgL_nodez00_bglt) ((BgL_varz00_bglt)
														BgL_nodez00_3383))))->BgL_typez00);
									BgL_test2436z00_4934 =
										BGl_typezd2subclasszf3z21zzobject_classz00
										(BgL_arg1679z00_3662, BgL_arg1682z00_3663);
								}
						}
					else
						{	/* Dataflow/walk.scm 84 */
							BgL_test2436z00_4934 = ((bool_t) 0);
						}
					if (BgL_test2436z00_4934)
						{	/* Dataflow/walk.scm 86 */
							obj_t BgL_bz00_3664;

							BgL_bz00_3664 =
								BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
								((obj_t)
									(((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_nodez00_3383)))->
										BgL_variablez00)), BgL_envz00_3384);
							if (PAIRP(BgL_bz00_3664))
								{	/* Dataflow/walk.scm 87 */
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt)
														((BgL_varz00_bglt) BgL_nodez00_3383))))->
											BgL_typez00) =
										((BgL_typez00_bglt) ((BgL_typez00_bglt)
												CDR(BgL_bz00_3664))), BUNSPEC);
								}
							else
								{	/* Dataflow/walk.scm 87 */
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt)
														((BgL_varz00_bglt) BgL_nodez00_3383))))->
											BgL_typez00) =
										((BgL_typez00_bglt) (((BgL_variablez00_bglt)
													COBJECT((((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt)
																		BgL_nodez00_3383)))->BgL_variablez00)))->
												BgL_typez00)), BUNSPEC);
								}
						}
					else
						{	/* Dataflow/walk.scm 84 */
							BFALSE;
						}
				}
			}
			return BgL_envz00_3384;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzdataflow_walkz00()
	{
		{	/* Dataflow/walk.scm 17 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(((long) 271385047),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_spreadz00(((long) 348216764),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374368),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string2277z00zzdataflow_walkz00));
		}

	}

#ifdef __cplusplus
}
#endif
