/*===========================================================================*/
/*   (Effect/cgraph.scm)                                                     */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Effect/cgraph.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
		obj_t BgL_valzd2noescapezd2;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_stackablez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_localzf2fromzf2_bgl
	{
		obj_t BgL_fromz00;
	}                      *BgL_localzf2fromzf2_bglt;

	typedef struct BgL_globalzf2fromzf2_bgl
	{
		obj_t BgL_fromz00;
	}                       *BgL_globalzf2fromzf2_bglt;


	static obj_t
		BGl_z62callzd2graphz12zd2setzd2exzd2i1348z70zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2aliasz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t BGl_z62globalzf2fromzd2modulez42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2occurrencez42zzeffect_cgraphz00(obj_t,
		obj_t);
	static obj_t BGl_z62localzf2fromzd2accessz42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62callzd2graphz12zd2conditio1338z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t
		BGl_z62callzd2graphz12zd2boxzd2setz121356zb0zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2fastzd2alphazd2setz12z50zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2evalzf3zd2setz12z13zzeffect_cgraphz00
		(BgL_globalz00_bglt, bool_t);
	BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	static BgL_typez00_bglt
		BGl_z62globalzf2fromzd2typez42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2occurrencezd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62callzd2graphz12zd2makezd2box1352za2zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62callzd2graphz12zd2appzd2ly1328za2zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzeffect_cgraphz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2fromz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2removablez20zzeffect_cgraphz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2modulezd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	static obj_t BGl_z62getzd2varzf2allz42zzeffect_cgraphz00(obj_t);
	BGL_EXPORTED_DECL BgL_valuez00_bglt
		BGl_localzf2fromzd2valuez20zzeffect_cgraphz00(BgL_localz00_bglt);
	static obj_t
		BGl_z62globalzf2fromzd2pragmazd2setz12z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL bool_t
		BGl_localzf2fromzd2userzf3zd3zzeffect_cgraphz00(BgL_localz00_bglt);
	static obj_t BGl_z62globalzf2fromzd2initz42zzeffect_cgraphz00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62globalzf2fromzd2importz42zzeffect_cgraphz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2jvmzd2typezd2namez20zzeffect_cgraphz00
		(BgL_globalz00_bglt);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62localzf2fromzd2removablezd2setz12z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(BgL_variablez00_bglt);
	static obj_t BGl_z62callzd2graphz12zd2funcall1330z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	static obj_t
		BGl_z62globalzf2fromzd2userzf3zd2setz12z71zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62localzf2fromzd2occurrencewz42zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00();
	static obj_t
		BGl_z62callzd2graphz12zd2jumpzd2exzd21350z70zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62resetzd2effectzd2tablesz12z70zzeffect_cgraphz00(obj_t);
	static obj_t BGl_toplevelzd2initzd2zzeffect_cgraphz00();
	static obj_t
		BGl_z62callzd2graphz12zd2letzd2var1346za2zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2pragmaz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t
		BGl_z62globalzf2fromzd2jvmzd2typezd2namezd2setz12z82zzeffect_cgraphz00
		(obj_t, obj_t, obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2accesszd2setz12z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2accessz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t BGl_z62globalzf2fromzf3z63zzeffect_cgraphz00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_z62callzd2graphz12za2zzeffect_cgraphz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2removablez42zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00();
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2accesszd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt,
		obj_t);
	static obj_t BGl_z62callzd2graphz12zd2extern1332z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_z62globalzf2fromzd2srczd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62callzd2graphz12zd2switch1342z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t
		BGl_z62callzd2graphz12zd2boxzd2ref1354za2zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_z62savezd2callz12zd2globalzf2fr1362z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2removablezd2setz12ze0zzeffect_cgraphz00
		(BgL_localz00_bglt, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_z62globalzf2fromzd2fromz42zzeffect_cgraphz00(obj_t, obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2aliaszd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	static obj_t BGl_z62globalzf2fromzd2fastzd2alphaz90zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL bool_t
		BGl_globalzf2fromzd2evalzf3zd3zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t BGl_z62callzd2graphz12zd2sequence1322z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2removablezd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt, obj_t);
	static BgL_valuez00_bglt
		BGl_z62localzf2fromzd2valuez42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62localzf2fromzd2userzf3zb1zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL long
		BGl_globalzf2fromzd2occurrencewz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2srczd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	static bool_t BGl_callzd2graphza2z12z62zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62localzf2fromzd2keyz42zzeffect_cgraphz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_localzf2fromzf3z01zzeffect_cgraphz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62localzf2fromzd2namezd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62savezd2callz12zd2localzf2fro1366z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2removablezd2setz12z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zzeffect_cgraphz00();
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2jvmzd2typezd2namezd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt, obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2evalzf3zd2setz12z71zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2srcz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t BGl_z62globalzf2fromzd2srcz42zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2valuezd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt,
		BgL_valuez00_bglt);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62callzd2graphz12zd2app1326z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62savezd2callz12zd2local1364z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2aliasz42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2idz42zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2namezd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt,
		obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2occurrencewzd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL long
		BGl_localzf2fromzd2occurrencez20zzeffect_cgraphz00(BgL_localz00_bglt);
	static obj_t BGl_z62localzf2fromzd2idz42zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2importzd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	BGL_EXPORTED_DECL BgL_valuez00_bglt
		BGl_globalzf2fromzd2valuez20zzeffect_cgraphz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL bool_t
		BGl_globalzf2fromzd2userzf3zd3zzeffect_cgraphz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2modulez20zzeffect_cgraphz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL bool_t
		BGl_globalzf2fromzd2evaluablezf3zd3zzeffect_cgraphz00(BgL_globalz00_bglt);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_makezd2globalzf2fromz20zzeffect_cgraphz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, long,
		bool_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL long
		BGl_localzf2fromzd2keyz20zzeffect_cgraphz00(BgL_localz00_bglt);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62localzf2fromzd2valuezd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2namezd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2namez20zzeffect_cgraphz00(BgL_localz00_bglt);
	static obj_t BGl_z62localzf2fromzd2namez42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62localzf2fromzd2accesszd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2userzf3zd2setz12z13zzeffect_cgraphz00(BgL_localz00_bglt,
		bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2importz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t BGl_z62localzf2fromzd2occurrencez42zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2occurrencewzd2setz12ze0zzeffect_cgraphz00
		(BgL_localz00_bglt, long);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2fastzd2alphazd2setz12z32zzeffect_cgraphz00
		(BgL_localz00_bglt, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2occurrencezd2setz12ze0zzeffect_cgraphz00
		(BgL_localz00_bglt, long);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t
		BGl_z62globalzf2fromzd2modulezd2setz12z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62globalzf2fromzd2aliaszd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31541ze3ze5zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2idz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t BGl_z62callzd2graphz121319za2zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62localzf2fromzf3z63zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2pragmazd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static BgL_localz00_bglt
		BGl_z62localzf2fromzd2nilz42zzeffect_cgraphz00(obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t
		BGl_z62localzf2fromzd2fastzd2alphazd2setz12z50zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2namezd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62localzf2fromzd2occurrencezd2setz12z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2evaluablezf3zd2setz12z13zzeffect_cgraphz00
		(BgL_globalz00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2accessz20zzeffect_cgraphz00(BgL_localz00_bglt);
	static obj_t BGl_z62globalzf2fromzd2evalzf3zb1zzeffect_cgraphz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2libraryzd2setz12z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2valuezd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		BgL_valuez00_bglt);
	static obj_t
		BGl_z62localzf2fromzd2userzf3zd2setz12z71zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2fastzd2alphazf2zzeffect_cgraphz00(BgL_localz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2namez20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static BgL_globalz00_bglt
		BGl_z62makezd2globalzf2fromz42zzeffect_cgraphz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2accesszd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_localzf2fromzf2zzeffect_cgraphz00 = BUNSPEC;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_savezd2callz12zc0zzeffect_cgraphz00(BgL_variablez00_bglt,
		BgL_variablez00_bglt);
	static obj_t BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00();
	static obj_t BGl_z62localzf2fromzd2typezd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_typez00_bglt
		BGl_localzf2fromzd2typez20zzeffect_cgraphz00(BgL_localz00_bglt);
	static BgL_typez00_bglt BGl_z62localzf2fromzd2typez42zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL long
		BGl_globalzf2fromzd2occurrencez20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00();
	static obj_t BGl_z62localzf2fromzd2fromzd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2initzd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzeffect_cgraphz00();
	static obj_t BGl_z62globalzf2fromzd2pragmaz42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1604z62zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1605z62zzeffect_cgraphz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_globalzf2fromzf3z01zzeffect_cgraphz00(obj_t);
	static BgL_localz00_bglt BGl_z62lambda1528z62zzeffect_cgraphz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2typezd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_z62globalzf2fromzd2accessz42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2libraryz42zzeffect_cgraphz00(obj_t,
		obj_t);
	static obj_t BGl_z62savezd2callz12za2zzeffect_cgraphz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00();
	static obj_t BGl_z62callzd2graphz12zd2cast1334z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2fromzd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt,
		obj_t);
	static BgL_globalz00_bglt
		BGl_z62globalzf2fromzd2nilz42zzeffect_cgraphz00(obj_t);
	static BgL_localz00_bglt BGl_z62lambda1533z62zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t
		BGl_z62callzd2graphz12zd2letzd2fun1344za2zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62globalzf2fromzd2evaluablezf3zb1zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2fastzd2alphazd2setz12z32zzeffect_cgraphz00
		(BgL_globalz00_bglt, obj_t);
	BGL_EXPORTED_DECL BgL_localz00_bglt
		BGl_localzf2fromzd2nilz20zzeffect_cgraphz00();
	static obj_t BGl_z62localzf2fromzd2fastzd2alphaz90zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2occurrencezd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt, long);
	static obj_t BGl_z62savezd2callz12zd2global1360z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2occurrencewz42zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2idz20zzeffect_cgraphz00(BgL_localz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(BgL_variablez00_bglt);
	static BgL_localz00_bglt BGl_z62lambda1542z62zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62funzd2callzd2graphz12z70zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62callzd2graphz12zd2setq1336z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2userzf3zd2setz12z13zzeffect_cgraphz00
		(BgL_globalz00_bglt, bool_t);
	static obj_t
		BGl_z62localzf2fromzd2occurrencewzd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_EXPORTED_DECL long
		BGl_localzf2fromzd2occurrencewz20zzeffect_cgraphz00(BgL_localz00_bglt);
	extern obj_t BGl_valuez00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2varzf2allz20zzeffect_cgraphz00();
	static BgL_valuez00_bglt
		BGl_z62globalzf2fromzd2valuez42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2userzf3zb1zzeffect_cgraphz00(obj_t,
		obj_t);
	static obj_t BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl_z62globalzf2fromzd2initzd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62callzd2graphz12zd2sync1324z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62lambda1558z62zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1559z62zzeffect_cgraphz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2typezd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		BgL_typez00_bglt);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_typez00_bglt
		BGl_globalzf2fromzd2typez20zzeffect_cgraphz00(BgL_globalz00_bglt);
	extern obj_t BGl_variablez00zzast_varz00;
	static obj_t BGl_z62globalzf2fromzd2namez42zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2fromzd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt,
		obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	static obj_t BGl_z62callzd2graphz12zd2fail1340z70zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62getzd2varzf2sidezd2effectz90zzeffect_cgraphz00(obj_t);
	static obj_t BGl_z62savezd2callz121357za2zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2fromz20zzeffect_cgraphz00(BgL_localz00_bglt);
	static obj_t
		BGl_z62globalzf2fromzd2evaluablezf3zd2setz12z71zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31583ze3ze5zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_globalzf2fromzf2zzeffect_cgraphz00 = BUNSPEC;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t BGl_z62localzf2fromzd2fromz42zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2initz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static BgL_globalz00_bglt BGl_z62lambda1572z62zzeffect_cgraphz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_localz00_bglt
		BGl_makezd2localzf2fromz20zzeffect_cgraphz00(obj_t, obj_t, BgL_typez00_bglt,
		BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, long, bool_t, long, obj_t);
	static obj_t BGl_z62localzf2fromzd2removablez42zzeffect_cgraphz00(obj_t,
		obj_t);
	static BgL_localz00_bglt
		BGl_z62makezd2localzf2fromz42zzeffect_cgraphz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_globalz00_bglt BGl_z62lambda1580z62zzeffect_cgraphz00(obj_t,
		obj_t);
	static BgL_globalz00_bglt BGl_z62lambda1584z62zzeffect_cgraphz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2importzd2setz12z82zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_nodez00_bglt,
		BgL_variablez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2fastzd2alphazf2zzeffect_cgraphz00(BgL_globalz00_bglt);
	extern obj_t BGl_funcallz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2libraryzd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t
		BGl_localzf2fromzd2removablez20zzeffect_cgraphz00(BgL_localz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2occurrencewzd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt, long);
	static obj_t BGl_z62globalzf2fromzd2valuezd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2typezd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62globalzf2fromzd2jvmzd2typezd2namez42zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_z62globalzf2fromzd2fromzd2setz12z82zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_globalzf2fromzd2libraryz20zzeffect_cgraphz00(BgL_globalz00_bglt);
	static obj_t __cnst[10];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_funzd2callzd2graphz12zd2envzc0zzeffect_cgraphz00,
		BgL_bgl_za762funza7d2callza7d21920za7,
		BGl_z62funzd2callzd2graphz12z70zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2accesszd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71921za7,
		BGl_z62localzf2fromzd2accesszd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2valuezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71922za7,
		BGl_z62localzf2fromzd2valuez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_globalzf2fromzf3zd2envzd3zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1923z00,
		BGl_z62globalzf2fromzf3z63zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2namezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71924za7,
		BGl_z62localzf2fromzd2namezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2fastzd2alphazd2envz20zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71925za7,
		BGl_z62localzf2fromzd2fastzd2alphaz90zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2occurrencewzd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71926za7,
		BGl_z62localzf2fromzd2occurrencewzd2setz12z82zzeffect_cgraphz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2importzd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1927z00,
		BGl_z62globalzf2fromzd2importzd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2occurrencewzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71928za7,
		BGl_z62localzf2fromzd2occurrencewz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2valuezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1929z00,
		BGl_z62globalzf2fromzd2valuez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2modulezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1930z00,
		BGl_z62globalzf2fromzd2modulezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2fastzd2alphazd2envz20zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1931z00,
		BGl_z62globalzf2fromzd2fastzd2alphaz90zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2userzf3zd2envz01zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71932za7,
		BGl_z62localzf2fromzd2userzf3zb1zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2typezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1933z00,
		BGl_z62globalzf2fromzd2typez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1934z00,
		BGl_z62globalzf2fromzd2nilz42zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2evalzf3zd2envz01zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1935z00,
		BGl_z62globalzf2fromzd2evalzf3zb1zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2accesszd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71936za7,
		BGl_z62localzf2fromzd2accessz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2removablezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1937z00,
		BGl_z62globalzf2fromzd2removablezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2pragmazd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1938z00,
		BGl_z62globalzf2fromzd2pragmaz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2fastzd2alphazd2setz12zd2envze0zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1939z00,
		BGl_z62globalzf2fromzd2fastzd2alphazd2setz12z50zzeffect_cgraphz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2evalzf3zd2setz12zd2envzc1zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1940z00,
		BGl_z62globalzf2fromzd2evalzf3zd2setz12z71zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2occurrencezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1941z00,
		BGl_z62globalzf2fromzd2occurrencezd2setz12z82zzeffect_cgraphz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2accesszd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1942z00,
		BGl_z62globalzf2fromzd2accesszd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2fastzd2alphazd2setz12zd2envze0zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71943za7,
		BGl_z62localzf2fromzd2fastzd2alphazd2setz12z50zzeffect_cgraphz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2typezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71944za7,
		BGl_z62localzf2fromzd2typez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2occurrencezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71945za7,
		BGl_z62localzf2fromzd2occurrencezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2userzf3zd2envz01zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1946z00,
		BGl_z62globalzf2fromzd2userzf3zb1zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2modulezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1947z00,
		BGl_z62globalzf2fromzd2modulez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2idzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1948z00,
		BGl_z62globalzf2fromzd2idz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2occurrencewzd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1949z00,
		BGl_z62globalzf2fromzd2occurrencewzd2setz12z82zzeffect_cgraphz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2globalzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762makeza7d2global1950z00,
		BGl_z62makezd2globalzf2fromz42zzeffect_cgraphz00, 0L, BUNSPEC, 21);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2aliaszd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1951z00,
		BGl_z62globalzf2fromzd2aliasz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2occurrencewzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1952z00,
		BGl_z62globalzf2fromzd2occurrencewz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1900z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71953za7,
		BGl_z62callzd2graphz12zd2setq1336z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1901z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71954za7,
		BGl_z62callzd2graphz12zd2conditio1338z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1902z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71955za7,
		BGl_z62callzd2graphz12zd2fail1340z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1903z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71956za7,
		BGl_z62callzd2graphz12zd2switch1342z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1904z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71957za7,
		BGl_z62callzd2graphz12zd2letzd2fun1344za2zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1905z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71958za7,
		BGl_z62callzd2graphz12zd2letzd2var1346za2zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STRING(BGl_string1912z00zzeffect_cgraphz00,
		BgL_bgl_string1912za700za7za7e1959za7, "save-call!", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1906z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71960za7,
		BGl_z62callzd2graphz12zd2setzd2exzd2i1348z70zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1907z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71961za7,
		BGl_z62callzd2graphz12zd2jumpzd2exzd21350z70zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1908z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71962za7,
		BGl_z62callzd2graphz12zd2makezd2box1352za2zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1909z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71963za7,
		BGl_z62callzd2graphz12zd2boxzd2ref1354za2zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STRING(BGl_string1916z00zzeffect_cgraphz00,
		BgL_bgl_string1916za700za7za7e1964za7, "effect_cgraph", 13);
	      DEFINE_STRING(BGl_string1917z00zzeffect_cgraphz00,
		BgL_bgl_string1917za700za7za7e1965za7,
		"import done save-call!1357 _ global/from effect_cgraph local/from obj from nothing ",
		83);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71966za7,
		BGl_z62callzd2graphz12za2zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1910z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza71967za7,
		BGl_z62callzd2graphz12zd2boxzd2setz121356zb0zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1911z00zzeffect_cgraphz00,
		BgL_bgl_za762saveza7d2callza711968za7,
		BGl_z62savezd2callz12zd2global1360z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1913z00zzeffect_cgraphz00,
		BgL_bgl_za762saveza7d2callza711969za7,
		BGl_z62savezd2callz12zd2globalzf2fr1362z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1914z00zzeffect_cgraphz00,
		BgL_bgl_za762saveza7d2callza711970za7,
		BGl_z62savezd2callz12zd2local1364z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1915z00zzeffect_cgraphz00,
		BgL_bgl_za762saveza7d2callza711971za7,
		BGl_z62savezd2callz12zd2localzf2fro1366z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2typezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1972z00,
		BGl_z62globalzf2fromzd2typezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2srczd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1973z00,
		BGl_z62globalzf2fromzd2srcz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2jvmzd2typezd2namezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1974z00,
		BGl_z62globalzf2fromzd2jvmzd2typezd2namez42zzeffect_cgraphz00, 0L, BUNSPEC,
		1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2removablezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71975za7,
		BGl_z62localzf2fromzd2removablezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2initzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1976z00,
		BGl_z62globalzf2fromzd2initz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71977za7,
		BGl_z62localzf2fromzd2nilz42zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2accesszd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1978z00,
		BGl_z62globalzf2fromzd2accessz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2varzf2allzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762getza7d2varza7f2a1979za7,
		BGl_z62getzd2varzf2allz42zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2initzd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1980z00,
		BGl_z62globalzf2fromzd2initzd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2evaluablezf3zd2envz01zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from1981z00,
		BGl_z62globalzf2fromzd2evaluablezf3zb1zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1874z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1559za7621982z00, BGl_z62lambda1559z62zzeffect_cgraphz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1875z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1558za7621983z00, BGl_z62lambda1558z62zzeffect_cgraphz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1876z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1542za7621984z00, BGl_z62lambda1542z62zzeffect_cgraphz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1877z00zzeffect_cgraphz00,
		BgL_bgl_za762za7c3za704anonymo1985za7,
		BGl_z62zc3z04anonymousza31541ze3ze5zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1878z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1533za7621986z00, BGl_z62lambda1533z62zzeffect_cgraphz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1879z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1528za7621987z00, BGl_z62lambda1528z62zzeffect_cgraphz00,
		0L, BUNSPEC, 13);
	      DEFINE_STRING(BGl_string1886z00zzeffect_cgraphz00,
		BgL_bgl_string1886za700za7za7e1988za7, "", 0);
	      DEFINE_STRING(BGl_string1888z00zzeffect_cgraphz00,
		BgL_bgl_string1888za700za7za7e1989za7, "call-graph!1319", 15);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1880z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1605za7621990z00, BGl_z62lambda1605z62zzeffect_cgraphz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1881z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1604za7621991z00, BGl_z62lambda1604z62zzeffect_cgraphz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1882z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1584za7621992z00, BGl_z62lambda1584z62zzeffect_cgraphz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1883z00zzeffect_cgraphz00,
		BgL_bgl_za762za7c3za704anonymo1993za7,
		BGl_z62zc3z04anonymousza31583ze3ze5zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2valuezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza71994za7,
		BGl_z62localzf2fromzd2valuezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1890z00zzeffect_cgraphz00,
		BgL_bgl_string1890za700za7za7e1995za7, "save-call!1357", 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1884z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1580za7621996z00, BGl_z62lambda1580z62zzeffect_cgraphz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1891z00zzeffect_cgraphz00,
		BgL_bgl_string1891za700za7za7e1997za7, "No method for this object", 25);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1885z00zzeffect_cgraphz00,
		BgL_bgl_za762lambda1572za7621998z00, BGl_z62lambda1572z62zzeffect_cgraphz00,
		0L, BUNSPEC, 21);
	      DEFINE_STRING(BGl_string1893z00zzeffect_cgraphz00,
		BgL_bgl_string1893za700za7za7e1999za7, "call-graph!", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1887z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza72000za7,
		BGl_z62callzd2graphz121319za2zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2typezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72001za7,
		BGl_z62localzf2fromzd2typezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1889z00zzeffect_cgraphz00,
		BgL_bgl_za762saveza7d2callza712002za7,
		BGl_z62savezd2callz121357za2zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2varzf2sidezd2effectzd2envz20zzeffect_cgraphz00,
		BgL_bgl_za762getza7d2varza7f2s2003za7,
		BGl_z62getzd2varzf2sidezd2effectz90zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1892z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza72004za7,
		BGl_z62callzd2graphz12zd2sequence1322z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1894z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza72005za7,
		BGl_z62callzd2graphz12zd2sync1324z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1895z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza72006za7,
		BGl_z62callzd2graphz12zd2app1326z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1896z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza72007za7,
		BGl_z62callzd2graphz12zd2appzd2ly1328za2zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1897z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza72008za7,
		BGl_z62callzd2graphz12zd2funcall1330z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1898z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza72009za7,
		BGl_z62callzd2graphz12zd2extern1332z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2valuezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2010z00,
		BGl_z62globalzf2fromzd2valuezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1899z00zzeffect_cgraphz00,
		BgL_bgl_za762callza7d2graphza72011za7,
		BGl_z62callzd2graphz12zd2cast1334z70zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2srczd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2012z00,
		BGl_z62globalzf2fromzd2srczd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2013z00,
		BGl_z62globalzf2fromzd2fromz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2fromzd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2014z00,
		BGl_z62globalzf2fromzd2fromzd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2libraryzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2015z00,
		BGl_z62globalzf2fromzd2libraryz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72016za7,
		BGl_z62localzf2fromzd2fromz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2idzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72017za7,
		BGl_z62localzf2fromzd2idz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
		BgL_bgl_za762saveza7d2callza712018za7,
		BGl_z62savezd2callz12za2zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2removablezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2019z00,
		BGl_z62globalzf2fromzd2removablez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2aliaszd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2020z00,
		BGl_z62globalzf2fromzd2aliaszd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2fromzd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72021za7,
		BGl_z62localzf2fromzd2fromzd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2userzf3zd2setz12zd2envzc1zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72022za7,
		BGl_z62localzf2fromzd2userzf3zd2setz12z71zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2namezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2023z00,
		BGl_z62globalzf2fromzd2namez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2occurrencezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72024za7,
		BGl_z62localzf2fromzd2occurrencez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2userzf3zd2setz12zd2envzc1zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2025z00,
		BGl_z62globalzf2fromzd2userzf3zd2setz12z71zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_resetzd2effectzd2tablesz12zd2envzc0zzeffect_cgraphz00,
		BgL_bgl_za762resetza7d2effec2026z00,
		BGl_z62resetzd2effectzd2tablesz12z70zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2occurrencezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2027z00,
		BGl_z62globalzf2fromzd2occurrencez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_localzf2fromzf3zd2envzd3zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72028za7,
		BGl_z62localzf2fromzf3z63zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2libraryzd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2029z00,
		BGl_z62globalzf2fromzd2libraryzd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2pragmazd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2030z00,
		BGl_z62globalzf2fromzd2pragmazd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2removablezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72031za7,
		BGl_z62localzf2fromzd2removablez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2keyzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72032za7,
		BGl_z62localzf2fromzd2keyz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2jvmzd2typezd2namezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2033z00,
		BGl_z62globalzf2fromzd2jvmzd2typezd2namezd2setz12z82zzeffect_cgraphz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2namezd2setz12zd2envz32zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2034z00,
		BGl_z62globalzf2fromzd2namezd2setz12z82zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2namezd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762localza7f2fromza72035za7,
		BGl_z62localzf2fromzd2namez42zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2evaluablezf3zd2setz12zd2envzc1zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2036z00,
		BGl_z62globalzf2fromzd2evaluablezf3zd2setz12z71zzeffect_cgraphz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2localzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762makeza7d2localza72037za7,
		BGl_z62makezd2localzf2fromz42zzeffect_cgraphz00, 0L, BUNSPEC, 12);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2importzd2envzf2zzeffect_cgraphz00,
		BgL_bgl_za762globalza7f2from2038z00,
		BGl_z62globalzf2fromzd2importz42zzeffect_cgraphz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzeffect_cgraphz00));
		     ADD_ROOT((void
				*) (&BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00));
		     ADD_ROOT((void *) (&BGl_localzf2fromzf2zzeffect_cgraphz00));
		     ADD_ROOT((void *) (&BGl_za2varzf2allza2zf2zzeffect_cgraphz00));
		     ADD_ROOT((void *) (&BGl_globalzf2fromzf2zzeffect_cgraphz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long
		BgL_checksumz00_2817, char *BgL_fromz00_2818)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzeffect_cgraphz00))
				{
					BGl_requirezd2initializa7ationz75zzeffect_cgraphz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzeffect_cgraphz00();
					BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00();
					BGl_cnstzd2initzd2zzeffect_cgraphz00();
					BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00();
					BGl_objectzd2initzd2zzeffect_cgraphz00();
					BGl_genericzd2initzd2zzeffect_cgraphz00();
					BGl_methodzd2initzd2zzeffect_cgraphz00();
					return BGl_toplevelzd2initzd2zzeffect_cgraphz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"effect_cgraph");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 15 */
			{	/* Effect/cgraph.scm 15 */
				obj_t BgL_cportz00_2654;

				{	/* Effect/cgraph.scm 15 */
					obj_t BgL_stringz00_2662;

					BgL_stringz00_2662 = BGl_string1917z00zzeffect_cgraphz00;
					{	/* Effect/cgraph.scm 15 */
						obj_t BgL_startz00_2663;

						BgL_startz00_2663 = BINT(((long) 0));
						{	/* Effect/cgraph.scm 15 */
							obj_t BgL_endz00_2664;

							BgL_endz00_2664 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2662)));
							{	/* Effect/cgraph.scm 15 */

								BgL_cportz00_2654 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2662, BgL_startz00_2663, BgL_endz00_2664);
				}}}}
				{
					long BgL_iz00_2655;

					BgL_iz00_2655 = ((long) 9);
				BgL_loopz00_2656:
					if ((BgL_iz00_2655 == ((long) -1)))
						{	/* Effect/cgraph.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Effect/cgraph.scm 15 */
							{	/* Effect/cgraph.scm 15 */
								obj_t BgL_arg1919z00_2658;

								{	/* Effect/cgraph.scm 15 */

									{	/* Effect/cgraph.scm 15 */
										obj_t BgL_locationz00_2660;

										BgL_locationz00_2660 = BBOOL(((bool_t) 0));
										{	/* Effect/cgraph.scm 15 */

											BgL_arg1919z00_2658 =
												BGl_readz00zz__readerz00(BgL_cportz00_2654,
												BgL_locationz00_2660);
										}
									}
								}
								{	/* Effect/cgraph.scm 15 */
									int BgL_tmpz00_2848;

									BgL_tmpz00_2848 = (int) (BgL_iz00_2655);
									CNST_TABLE_SET(BgL_tmpz00_2848, BgL_arg1919z00_2658);
							}}
							{	/* Effect/cgraph.scm 15 */
								int BgL_auxz00_2661;

								BgL_auxz00_2661 = (int) ((BgL_iz00_2655 - ((long) 1)));
								{
									long BgL_iz00_2853;

									BgL_iz00_2853 = (long) (BgL_auxz00_2661);
									BgL_iz00_2655 = BgL_iz00_2853;
									goto BgL_loopz00_2656;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 15 */
			BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BNIL;
			return (BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BNIL, BUNSPEC);
		}

	}



/* make-local/from */
	BGL_EXPORTED_DEF BgL_localz00_bglt
		BGl_makezd2localzf2fromz20zzeffect_cgraphz00(obj_t BgL_id1163z00_3,
		obj_t BgL_name1164z00_4, BgL_typez00_bglt BgL_type1165z00_5,
		BgL_valuez00_bglt BgL_value1166z00_6, obj_t BgL_access1167z00_7,
		obj_t BgL_fastzd2alpha1168zd2_8, obj_t BgL_removable1169z00_9,
		long BgL_occurrence1170z00_10, long BgL_occurrencew1171z00_11,
		bool_t BgL_userzf31172zf3_12, long BgL_key1173z00_13,
		obj_t BgL_from1174z00_14)
	{
		{	/* Effect/cgraph.sch 91 */
			{	/* Effect/cgraph.sch 91 */
				BgL_localz00_bglt BgL_new1156z00_2666;

				{	/* Effect/cgraph.sch 91 */
					BgL_localz00_bglt BgL_tmp1154z00_2667;
					BgL_localzf2fromzf2_bglt BgL_wide1155z00_2668;

					{
						BgL_localz00_bglt BgL_auxz00_2856;

						{	/* Effect/cgraph.sch 91 */
							BgL_localz00_bglt BgL_new1153z00_2669;

							BgL_new1153z00_2669 =
								((BgL_localz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_localz00_bgl))));
							{	/* Effect/cgraph.sch 91 */
								long BgL_arg1435z00_2670;

								BgL_arg1435z00_2670 = BGL_CLASS_INDEX(BGl_localz00zzast_varz00);
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1153z00_2669),
									BgL_arg1435z00_2670);
							}
							{	/* Effect/cgraph.sch 91 */
								BgL_objectz00_bglt BgL_tmpz00_2861;

								BgL_tmpz00_2861 = ((BgL_objectz00_bglt) BgL_new1153z00_2669);
								BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2861, BFALSE);
							}
							((BgL_objectz00_bglt) BgL_new1153z00_2669);
							BgL_auxz00_2856 = BgL_new1153z00_2669;
						}
						BgL_tmp1154z00_2667 = ((BgL_localz00_bglt) BgL_auxz00_2856);
					}
					BgL_wide1155z00_2668 =
						((BgL_localzf2fromzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_localzf2fromzf2_bgl))));
					{	/* Effect/cgraph.sch 91 */
						obj_t BgL_auxz00_2869;
						BgL_objectz00_bglt BgL_tmpz00_2867;

						BgL_auxz00_2869 = ((obj_t) BgL_wide1155z00_2668);
						BgL_tmpz00_2867 = ((BgL_objectz00_bglt) BgL_tmp1154z00_2667);
						BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2867, BgL_auxz00_2869);
					}
					((BgL_objectz00_bglt) BgL_tmp1154z00_2667);
					{	/* Effect/cgraph.sch 91 */
						long BgL_arg1409z00_2671;

						BgL_arg1409z00_2671 =
							BGL_CLASS_INDEX(BGl_localzf2fromzf2zzeffect_cgraphz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_tmp1154z00_2667), BgL_arg1409z00_2671);
					}
					BgL_new1156z00_2666 = ((BgL_localz00_bglt) BgL_tmp1154z00_2667);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt) BgL_new1156z00_2666)))->BgL_idz00) =
					((obj_t) BgL_id1163z00_3), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_namez00) =
					((obj_t) BgL_name1164z00_4), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_typez00) =
					((BgL_typez00_bglt) BgL_type1165z00_5), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_valuez00) =
					((BgL_valuez00_bglt) BgL_value1166z00_6), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_accessz00) =
					((obj_t) BgL_access1167z00_7), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_fastzd2alphazd2) =
					((obj_t) BgL_fastzd2alpha1168zd2_8), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_removablez00) =
					((obj_t) BgL_removable1169z00_9), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_occurrencez00) =
					((long) BgL_occurrence1170z00_10), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_occurrencewz00) =
					((long) BgL_occurrencew1171z00_11), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1156z00_2666)))->BgL_userzf3zf3) =
					((bool_t) BgL_userzf31172zf3_12), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
									BgL_new1156z00_2666)))->BgL_keyz00) =
					((long) BgL_key1173z00_13), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
									BgL_new1156z00_2666)))->BgL_valzd2noescapezd2) =
					((obj_t) BTRUE), BUNSPEC);
				{
					BgL_localzf2fromzf2_bglt BgL_auxz00_2901;

					{
						obj_t BgL_auxz00_2902;

						{	/* Effect/cgraph.sch 91 */
							BgL_objectz00_bglt BgL_tmpz00_2903;

							BgL_tmpz00_2903 = ((BgL_objectz00_bglt) BgL_new1156z00_2666);
							BgL_auxz00_2902 = BGL_OBJECT_WIDENING(BgL_tmpz00_2903);
						}
						BgL_auxz00_2901 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_2902);
					}
					((((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_2901))->
							BgL_fromz00) = ((obj_t) BgL_from1174z00_14), BUNSPEC);
				}
				return BgL_new1156z00_2666;
			}
		}

	}



/* &make-local/from */
	BgL_localz00_bglt BGl_z62makezd2localzf2fromz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2280, obj_t BgL_id1163z00_2281, obj_t BgL_name1164z00_2282,
		obj_t BgL_type1165z00_2283, obj_t BgL_value1166z00_2284,
		obj_t BgL_access1167z00_2285, obj_t BgL_fastzd2alpha1168zd2_2286,
		obj_t BgL_removable1169z00_2287, obj_t BgL_occurrence1170z00_2288,
		obj_t BgL_occurrencew1171z00_2289, obj_t BgL_userzf31172zf3_2290,
		obj_t BgL_key1173z00_2291, obj_t BgL_from1174z00_2292)
	{
		{	/* Effect/cgraph.sch 91 */
			return
				BGl_makezd2localzf2fromz20zzeffect_cgraphz00(BgL_id1163z00_2281,
				BgL_name1164z00_2282, ((BgL_typez00_bglt) BgL_type1165z00_2283),
				((BgL_valuez00_bglt) BgL_value1166z00_2284), BgL_access1167z00_2285,
				BgL_fastzd2alpha1168zd2_2286, BgL_removable1169z00_2287,
				(long) CINT(BgL_occurrence1170z00_2288),
				(long) CINT(BgL_occurrencew1171z00_2289),
				CBOOL(BgL_userzf31172zf3_2290), (long) CINT(BgL_key1173z00_2291),
				BgL_from1174z00_2292);
		}

	}



/* local/from? */
	BGL_EXPORTED_DEF bool_t BGl_localzf2fromzf3z01zzeffect_cgraphz00(obj_t
		BgL_objz00_15)
	{
		{	/* Effect/cgraph.sch 92 */
			return
				BGl_isazf3zf3zz__objectz00(BgL_objz00_15,
				BGl_localzf2fromzf2zzeffect_cgraphz00);
		}

	}



/* &local/from? */
	obj_t BGl_z62localzf2fromzf3z63zzeffect_cgraphz00(obj_t BgL_envz00_2293,
		obj_t BgL_objz00_2294)
	{
		{	/* Effect/cgraph.sch 92 */
			return BBOOL(BGl_localzf2fromzf3z01zzeffect_cgraphz00(BgL_objz00_2294));
		}

	}



/* local/from-nil */
	BGL_EXPORTED_DEF BgL_localz00_bglt
		BGl_localzf2fromzd2nilz20zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.sch 93 */
			{	/* Effect/cgraph.sch 93 */
				obj_t BgL_classz00_2074;

				BgL_classz00_2074 = BGl_localzf2fromzf2zzeffect_cgraphz00;
				{	/* Effect/cgraph.sch 93 */
					obj_t BgL__ortest_1110z00_2075;

					BgL__ortest_1110z00_2075 = BGL_CLASS_NIL(BgL_classz00_2074);
					if (CBOOL(BgL__ortest_1110z00_2075))
						{	/* Effect/cgraph.sch 93 */
							return ((BgL_localz00_bglt) BgL__ortest_1110z00_2075);
						}
					else
						{	/* Effect/cgraph.sch 93 */
							return
								((BgL_localz00_bglt)
								BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2074));
						}
				}
			}
		}

	}



/* &local/from-nil */
	BgL_localz00_bglt BGl_z62localzf2fromzd2nilz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2295)
	{
		{	/* Effect/cgraph.sch 93 */
			return BGl_localzf2fromzd2nilz20zzeffect_cgraphz00();
		}

	}



/* local/from-from */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2fromz20zzeffect_cgraphz00(BgL_localz00_bglt BgL_oz00_16)
	{
		{	/* Effect/cgraph.sch 94 */
			{
				BgL_localzf2fromzf2_bglt BgL_auxz00_2925;

				{
					obj_t BgL_auxz00_2926;

					{	/* Effect/cgraph.sch 94 */
						BgL_objectz00_bglt BgL_tmpz00_2927;

						BgL_tmpz00_2927 = ((BgL_objectz00_bglt) BgL_oz00_16);
						BgL_auxz00_2926 = BGL_OBJECT_WIDENING(BgL_tmpz00_2927);
					}
					BgL_auxz00_2925 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_2926);
				}
				return
					(((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_2925))->BgL_fromz00);
			}
		}

	}



/* &local/from-from */
	obj_t BGl_z62localzf2fromzd2fromz42zzeffect_cgraphz00(obj_t BgL_envz00_2296,
		obj_t BgL_oz00_2297)
	{
		{	/* Effect/cgraph.sch 94 */
			return
				BGl_localzf2fromzd2fromz20zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2297));
		}

	}



/* local/from-from-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2fromzd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_17, obj_t BgL_vz00_18)
	{
		{	/* Effect/cgraph.sch 95 */
			{
				BgL_localzf2fromzf2_bglt BgL_auxz00_2934;

				{
					obj_t BgL_auxz00_2935;

					{	/* Effect/cgraph.sch 95 */
						BgL_objectz00_bglt BgL_tmpz00_2936;

						BgL_tmpz00_2936 = ((BgL_objectz00_bglt) BgL_oz00_17);
						BgL_auxz00_2935 = BGL_OBJECT_WIDENING(BgL_tmpz00_2936);
					}
					BgL_auxz00_2934 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_2935);
				}
				return
					((((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_2934))->
						BgL_fromz00) = ((obj_t) BgL_vz00_18), BUNSPEC);
			}
		}

	}



/* &local/from-from-set! */
	obj_t BGl_z62localzf2fromzd2fromzd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2298, obj_t BgL_oz00_2299, obj_t BgL_vz00_2300)
	{
		{	/* Effect/cgraph.sch 95 */
			return
				BGl_localzf2fromzd2fromzd2setz12ze0zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2299), BgL_vz00_2300);
		}

	}



/* local/from-key */
	BGL_EXPORTED_DEF long
		BGl_localzf2fromzd2keyz20zzeffect_cgraphz00(BgL_localz00_bglt BgL_oz00_19)
	{
		{	/* Effect/cgraph.sch 96 */
			return
				(((BgL_localz00_bglt) COBJECT(
						((BgL_localz00_bglt) BgL_oz00_19)))->BgL_keyz00);
		}

	}



/* &local/from-key */
	obj_t BGl_z62localzf2fromzd2keyz42zzeffect_cgraphz00(obj_t BgL_envz00_2301,
		obj_t BgL_oz00_2302)
	{
		{	/* Effect/cgraph.sch 96 */
			return
				BINT(BGl_localzf2fromzd2keyz20zzeffect_cgraphz00(
					((BgL_localz00_bglt) BgL_oz00_2302)));
		}

	}



/* local/from-user? */
	BGL_EXPORTED_DEF bool_t
		BGl_localzf2fromzd2userzf3zd3zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_22)
	{
		{	/* Effect/cgraph.sch 98 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_22)))->BgL_userzf3zf3);
		}

	}



/* &local/from-user? */
	obj_t BGl_z62localzf2fromzd2userzf3zb1zzeffect_cgraphz00(obj_t
		BgL_envz00_2303, obj_t BgL_oz00_2304)
	{
		{	/* Effect/cgraph.sch 98 */
			return
				BBOOL(BGl_localzf2fromzd2userzf3zd3zzeffect_cgraphz00(
					((BgL_localz00_bglt) BgL_oz00_2304)));
		}

	}



/* local/from-user?-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2userzf3zd2setz12z13zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_23, bool_t BgL_vz00_24)
	{
		{	/* Effect/cgraph.sch 99 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_23)))->BgL_userzf3zf3) =
				((bool_t) BgL_vz00_24), BUNSPEC);
		}

	}



/* &local/from-user?-set! */
	obj_t BGl_z62localzf2fromzd2userzf3zd2setz12z71zzeffect_cgraphz00(obj_t
		BgL_envz00_2305, obj_t BgL_oz00_2306, obj_t BgL_vz00_2307)
	{
		{	/* Effect/cgraph.sch 99 */
			return
				BGl_localzf2fromzd2userzf3zd2setz12z13zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2306), CBOOL(BgL_vz00_2307));
		}

	}



/* local/from-occurrencew */
	BGL_EXPORTED_DEF long
		BGl_localzf2fromzd2occurrencewz20zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_25)
	{
		{	/* Effect/cgraph.sch 100 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_25)))->BgL_occurrencewz00);
		}

	}



/* &local/from-occurrencew */
	obj_t BGl_z62localzf2fromzd2occurrencewz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2308, obj_t BgL_oz00_2309)
	{
		{	/* Effect/cgraph.sch 100 */
			return
				BINT(BGl_localzf2fromzd2occurrencewz20zzeffect_cgraphz00(
					((BgL_localz00_bglt) BgL_oz00_2309)));
		}

	}



/* local/from-occurrencew-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2occurrencewzd2setz12ze0zzeffect_cgraphz00
		(BgL_localz00_bglt BgL_oz00_26, long BgL_vz00_27)
	{
		{	/* Effect/cgraph.sch 101 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_26)))->BgL_occurrencewz00) =
				((long) BgL_vz00_27), BUNSPEC);
		}

	}



/* &local/from-occurrencew-set! */
	obj_t BGl_z62localzf2fromzd2occurrencewzd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2310, obj_t BgL_oz00_2311, obj_t BgL_vz00_2312)
	{
		{	/* Effect/cgraph.sch 101 */
			return
				BGl_localzf2fromzd2occurrencewzd2setz12ze0zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2311), (long) CINT(BgL_vz00_2312));
		}

	}



/* local/from-occurrence */
	BGL_EXPORTED_DEF long
		BGl_localzf2fromzd2occurrencez20zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_28)
	{
		{	/* Effect/cgraph.sch 102 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_28)))->BgL_occurrencez00);
		}

	}



/* &local/from-occurrence */
	obj_t BGl_z62localzf2fromzd2occurrencez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2313, obj_t BgL_oz00_2314)
	{
		{	/* Effect/cgraph.sch 102 */
			return
				BINT(BGl_localzf2fromzd2occurrencez20zzeffect_cgraphz00(
					((BgL_localz00_bglt) BgL_oz00_2314)));
		}

	}



/* local/from-occurrence-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2occurrencezd2setz12ze0zzeffect_cgraphz00
		(BgL_localz00_bglt BgL_oz00_29, long BgL_vz00_30)
	{
		{	/* Effect/cgraph.sch 103 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_29)))->BgL_occurrencez00) =
				((long) BgL_vz00_30), BUNSPEC);
		}

	}



/* &local/from-occurrence-set! */
	obj_t BGl_z62localzf2fromzd2occurrencezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2315, obj_t BgL_oz00_2316, obj_t BgL_vz00_2317)
	{
		{	/* Effect/cgraph.sch 103 */
			return
				BGl_localzf2fromzd2occurrencezd2setz12ze0zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2316), (long) CINT(BgL_vz00_2317));
		}

	}



/* local/from-removable */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2removablez20zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_31)
	{
		{	/* Effect/cgraph.sch 104 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_31)))->BgL_removablez00);
		}

	}



/* &local/from-removable */
	obj_t BGl_z62localzf2fromzd2removablez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2318, obj_t BgL_oz00_2319)
	{
		{	/* Effect/cgraph.sch 104 */
			return
				BGl_localzf2fromzd2removablez20zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2319));
		}

	}



/* local/from-removable-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2removablezd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_32, obj_t BgL_vz00_33)
	{
		{	/* Effect/cgraph.sch 105 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_32)))->BgL_removablez00) =
				((obj_t) BgL_vz00_33), BUNSPEC);
		}

	}



/* &local/from-removable-set! */
	obj_t BGl_z62localzf2fromzd2removablezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2320, obj_t BgL_oz00_2321, obj_t BgL_vz00_2322)
	{
		{	/* Effect/cgraph.sch 105 */
			return
				BGl_localzf2fromzd2removablezd2setz12ze0zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2321), BgL_vz00_2322);
		}

	}



/* local/from-fast-alpha */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2fastzd2alphazf2zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_34)
	{
		{	/* Effect/cgraph.sch 106 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_34)))->BgL_fastzd2alphazd2);
		}

	}



/* &local/from-fast-alpha */
	obj_t BGl_z62localzf2fromzd2fastzd2alphaz90zzeffect_cgraphz00(obj_t
		BgL_envz00_2323, obj_t BgL_oz00_2324)
	{
		{	/* Effect/cgraph.sch 106 */
			return
				BGl_localzf2fromzd2fastzd2alphazf2zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2324));
		}

	}



/* local/from-fast-alpha-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2fastzd2alphazd2setz12z32zzeffect_cgraphz00
		(BgL_localz00_bglt BgL_oz00_35, obj_t BgL_vz00_36)
	{
		{	/* Effect/cgraph.sch 107 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_35)))->BgL_fastzd2alphazd2) =
				((obj_t) BgL_vz00_36), BUNSPEC);
		}

	}



/* &local/from-fast-alpha-set! */
	obj_t BGl_z62localzf2fromzd2fastzd2alphazd2setz12z50zzeffect_cgraphz00(obj_t
		BgL_envz00_2325, obj_t BgL_oz00_2326, obj_t BgL_vz00_2327)
	{
		{	/* Effect/cgraph.sch 107 */
			return
				BGl_localzf2fromzd2fastzd2alphazd2setz12z32zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2326), BgL_vz00_2327);
		}

	}



/* local/from-access */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2accessz20zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_37)
	{
		{	/* Effect/cgraph.sch 108 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_37)))->BgL_accessz00);
		}

	}



/* &local/from-access */
	obj_t BGl_z62localzf2fromzd2accessz42zzeffect_cgraphz00(obj_t BgL_envz00_2328,
		obj_t BgL_oz00_2329)
	{
		{	/* Effect/cgraph.sch 108 */
			return
				BGl_localzf2fromzd2accessz20zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2329));
		}

	}



/* local/from-access-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2accesszd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_38, obj_t BgL_vz00_39)
	{
		{	/* Effect/cgraph.sch 109 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_38)))->BgL_accessz00) =
				((obj_t) BgL_vz00_39), BUNSPEC);
		}

	}



/* &local/from-access-set! */
	obj_t BGl_z62localzf2fromzd2accesszd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2330, obj_t BgL_oz00_2331, obj_t BgL_vz00_2332)
	{
		{	/* Effect/cgraph.sch 109 */
			return
				BGl_localzf2fromzd2accesszd2setz12ze0zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2331), BgL_vz00_2332);
		}

	}



/* local/from-value */
	BGL_EXPORTED_DEF BgL_valuez00_bglt
		BGl_localzf2fromzd2valuez20zzeffect_cgraphz00(BgL_localz00_bglt BgL_oz00_40)
	{
		{	/* Effect/cgraph.sch 110 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_40)))->BgL_valuez00);
		}

	}



/* &local/from-value */
	BgL_valuez00_bglt BGl_z62localzf2fromzd2valuez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2333, obj_t BgL_oz00_2334)
	{
		{	/* Effect/cgraph.sch 110 */
			return
				BGl_localzf2fromzd2valuez20zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2334));
		}

	}



/* local/from-value-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2valuezd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_41, BgL_valuez00_bglt BgL_vz00_42)
	{
		{	/* Effect/cgraph.sch 111 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_41)))->BgL_valuez00) =
				((BgL_valuez00_bglt) BgL_vz00_42), BUNSPEC);
		}

	}



/* &local/from-value-set! */
	obj_t BGl_z62localzf2fromzd2valuezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2335, obj_t BgL_oz00_2336, obj_t BgL_vz00_2337)
	{
		{	/* Effect/cgraph.sch 111 */
			return
				BGl_localzf2fromzd2valuezd2setz12ze0zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2336),
				((BgL_valuez00_bglt) BgL_vz00_2337));
		}

	}



/* local/from-type */
	BGL_EXPORTED_DEF BgL_typez00_bglt
		BGl_localzf2fromzd2typez20zzeffect_cgraphz00(BgL_localz00_bglt BgL_oz00_43)
	{
		{	/* Effect/cgraph.sch 112 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_43)))->BgL_typez00);
		}

	}



/* &local/from-type */
	BgL_typez00_bglt BGl_z62localzf2fromzd2typez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2338, obj_t BgL_oz00_2339)
	{
		{	/* Effect/cgraph.sch 112 */
			return
				BGl_localzf2fromzd2typez20zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2339));
		}

	}



/* local/from-type-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2typezd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_44, BgL_typez00_bglt BgL_vz00_45)
	{
		{	/* Effect/cgraph.sch 113 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_44)))->BgL_typez00) =
				((BgL_typez00_bglt) BgL_vz00_45), BUNSPEC);
		}

	}



/* &local/from-type-set! */
	obj_t BGl_z62localzf2fromzd2typezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2340, obj_t BgL_oz00_2341, obj_t BgL_vz00_2342)
	{
		{	/* Effect/cgraph.sch 113 */
			return
				BGl_localzf2fromzd2typezd2setz12ze0zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2341),
				((BgL_typez00_bglt) BgL_vz00_2342));
		}

	}



/* local/from-name */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2namez20zzeffect_cgraphz00(BgL_localz00_bglt BgL_oz00_46)
	{
		{	/* Effect/cgraph.sch 114 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_46)))->BgL_namez00);
		}

	}



/* &local/from-name */
	obj_t BGl_z62localzf2fromzd2namez42zzeffect_cgraphz00(obj_t BgL_envz00_2343,
		obj_t BgL_oz00_2344)
	{
		{	/* Effect/cgraph.sch 114 */
			return
				BGl_localzf2fromzd2namez20zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2344));
		}

	}



/* local/from-name-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2namezd2setz12ze0zzeffect_cgraphz00(BgL_localz00_bglt
		BgL_oz00_47, obj_t BgL_vz00_48)
	{
		{	/* Effect/cgraph.sch 115 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_47)))->BgL_namez00) =
				((obj_t) BgL_vz00_48), BUNSPEC);
		}

	}



/* &local/from-name-set! */
	obj_t BGl_z62localzf2fromzd2namezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2345, obj_t BgL_oz00_2346, obj_t BgL_vz00_2347)
	{
		{	/* Effect/cgraph.sch 115 */
			return
				BGl_localzf2fromzd2namezd2setz12ze0zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2346), BgL_vz00_2347);
		}

	}



/* local/from-id */
	BGL_EXPORTED_DEF obj_t
		BGl_localzf2fromzd2idz20zzeffect_cgraphz00(BgL_localz00_bglt BgL_oz00_49)
	{
		{	/* Effect/cgraph.sch 116 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_49)))->BgL_idz00);
		}

	}



/* &local/from-id */
	obj_t BGl_z62localzf2fromzd2idz42zzeffect_cgraphz00(obj_t BgL_envz00_2348,
		obj_t BgL_oz00_2349)
	{
		{	/* Effect/cgraph.sch 116 */
			return
				BGl_localzf2fromzd2idz20zzeffect_cgraphz00(
				((BgL_localz00_bglt) BgL_oz00_2349));
		}

	}



/* make-global/from */
	BGL_EXPORTED_DEF BgL_globalz00_bglt
		BGl_makezd2globalzf2fromz20zzeffect_cgraphz00(obj_t BgL_id1141z00_52,
		obj_t BgL_name1142z00_53, BgL_typez00_bglt BgL_type1143z00_54,
		BgL_valuez00_bglt BgL_value1144z00_55, obj_t BgL_access1145z00_56,
		obj_t BgL_fastzd2alpha1146zd2_57, obj_t BgL_removable1147z00_58,
		long BgL_occurrence1148z00_59, long BgL_occurrencew1149z00_60,
		bool_t BgL_userzf31150zf3_61, obj_t BgL_module1151z00_62,
		obj_t BgL_import1152z00_63, bool_t BgL_evaluablezf31153zf3_64,
		bool_t BgL_evalzf31154zf3_65, obj_t BgL_library1155z00_66,
		obj_t BgL_pragma1156z00_67, obj_t BgL_src1157z00_68,
		obj_t BgL_jvmzd2typezd2name1158z00_69, obj_t BgL_init1159z00_70,
		obj_t BgL_alias1160z00_71, obj_t BgL_from1161z00_72)
	{
		{	/* Effect/cgraph.sch 120 */
			{	/* Effect/cgraph.sch 120 */
				BgL_globalz00_bglt BgL_new1160z00_2672;

				{	/* Effect/cgraph.sch 120 */
					BgL_globalz00_bglt BgL_tmp1158z00_2673;
					BgL_globalzf2fromzf2_bglt BgL_wide1159z00_2674;

					{
						BgL_globalz00_bglt BgL_auxz00_3032;

						{	/* Effect/cgraph.sch 120 */
							BgL_globalz00_bglt BgL_new1157z00_2675;

							BgL_new1157z00_2675 =
								((BgL_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_globalz00_bgl))));
							{	/* Effect/cgraph.sch 120 */
								long BgL_arg1445z00_2676;

								BgL_arg1445z00_2676 =
									BGL_CLASS_INDEX(BGl_globalz00zzast_varz00);
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1157z00_2675),
									BgL_arg1445z00_2676);
							}
							{	/* Effect/cgraph.sch 120 */
								BgL_objectz00_bglt BgL_tmpz00_3037;

								BgL_tmpz00_3037 = ((BgL_objectz00_bglt) BgL_new1157z00_2675);
								BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3037, BFALSE);
							}
							((BgL_objectz00_bglt) BgL_new1157z00_2675);
							BgL_auxz00_3032 = BgL_new1157z00_2675;
						}
						BgL_tmp1158z00_2673 = ((BgL_globalz00_bglt) BgL_auxz00_3032);
					}
					BgL_wide1159z00_2674 =
						((BgL_globalzf2fromzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_globalzf2fromzf2_bgl))));
					{	/* Effect/cgraph.sch 120 */
						obj_t BgL_auxz00_3045;
						BgL_objectz00_bglt BgL_tmpz00_3043;

						BgL_auxz00_3045 = ((obj_t) BgL_wide1159z00_2674);
						BgL_tmpz00_3043 = ((BgL_objectz00_bglt) BgL_tmp1158z00_2673);
						BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3043, BgL_auxz00_3045);
					}
					((BgL_objectz00_bglt) BgL_tmp1158z00_2673);
					{	/* Effect/cgraph.sch 120 */
						long BgL_arg1436z00_2677;

						BgL_arg1436z00_2677 =
							BGL_CLASS_INDEX(BGl_globalzf2fromzf2zzeffect_cgraphz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_tmp1158z00_2673), BgL_arg1436z00_2677);
					}
					BgL_new1160z00_2672 = ((BgL_globalz00_bglt) BgL_tmp1158z00_2673);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt) BgL_new1160z00_2672)))->BgL_idz00) =
					((obj_t) BgL_id1141z00_52), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_namez00) =
					((obj_t) BgL_name1142z00_53), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_typez00) =
					((BgL_typez00_bglt) BgL_type1143z00_54), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_valuez00) =
					((BgL_valuez00_bglt) BgL_value1144z00_55), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_accessz00) =
					((obj_t) BgL_access1145z00_56), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_fastzd2alphazd2) =
					((obj_t) BgL_fastzd2alpha1146zd2_57), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_removablez00) =
					((obj_t) BgL_removable1147z00_58), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_occurrencez00) =
					((long) BgL_occurrence1148z00_59), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_occurrencewz00) =
					((long) BgL_occurrencew1149z00_60), BUNSPEC);
				((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
									BgL_new1160z00_2672)))->BgL_userzf3zf3) =
					((bool_t) BgL_userzf31150zf3_61), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_modulez00) =
					((obj_t) BgL_module1151z00_62), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_importz00) =
					((obj_t) BgL_import1152z00_63), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_evaluablezf3zf3) =
					((bool_t) BgL_evaluablezf31153zf3_64), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_evalzf3zf3) =
					((bool_t) BgL_evalzf31154zf3_65), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_libraryz00) =
					((obj_t) BgL_library1155z00_66), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_pragmaz00) =
					((obj_t) BgL_pragma1156z00_67), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_srcz00) =
					((obj_t) BgL_src1157z00_68), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_jvmzd2typezd2namez00) =
					((obj_t) BgL_jvmzd2typezd2name1158z00_69), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_initz00) =
					((obj_t) BgL_init1159z00_70), BUNSPEC);
				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
									BgL_new1160z00_2672)))->BgL_aliasz00) =
					((obj_t) BgL_alias1160z00_71), BUNSPEC);
				{
					BgL_globalzf2fromzf2_bglt BgL_auxz00_3093;

					{
						obj_t BgL_auxz00_3094;

						{	/* Effect/cgraph.sch 120 */
							BgL_objectz00_bglt BgL_tmpz00_3095;

							BgL_tmpz00_3095 = ((BgL_objectz00_bglt) BgL_new1160z00_2672);
							BgL_auxz00_3094 = BGL_OBJECT_WIDENING(BgL_tmpz00_3095);
						}
						BgL_auxz00_3093 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3094);
					}
					((((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3093))->
							BgL_fromz00) = ((obj_t) BgL_from1161z00_72), BUNSPEC);
				}
				return BgL_new1160z00_2672;
			}
		}

	}



/* &make-global/from */
	BgL_globalz00_bglt BGl_z62makezd2globalzf2fromz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2350, obj_t BgL_id1141z00_2351, obj_t BgL_name1142z00_2352,
		obj_t BgL_type1143z00_2353, obj_t BgL_value1144z00_2354,
		obj_t BgL_access1145z00_2355, obj_t BgL_fastzd2alpha1146zd2_2356,
		obj_t BgL_removable1147z00_2357, obj_t BgL_occurrence1148z00_2358,
		obj_t BgL_occurrencew1149z00_2359, obj_t BgL_userzf31150zf3_2360,
		obj_t BgL_module1151z00_2361, obj_t BgL_import1152z00_2362,
		obj_t BgL_evaluablezf31153zf3_2363, obj_t BgL_evalzf31154zf3_2364,
		obj_t BgL_library1155z00_2365, obj_t BgL_pragma1156z00_2366,
		obj_t BgL_src1157z00_2367, obj_t BgL_jvmzd2typezd2name1158z00_2368,
		obj_t BgL_init1159z00_2369, obj_t BgL_alias1160z00_2370,
		obj_t BgL_from1161z00_2371)
	{
		{	/* Effect/cgraph.sch 120 */
			return
				BGl_makezd2globalzf2fromz20zzeffect_cgraphz00(BgL_id1141z00_2351,
				BgL_name1142z00_2352, ((BgL_typez00_bglt) BgL_type1143z00_2353),
				((BgL_valuez00_bglt) BgL_value1144z00_2354), BgL_access1145z00_2355,
				BgL_fastzd2alpha1146zd2_2356, BgL_removable1147z00_2357,
				(long) CINT(BgL_occurrence1148z00_2358),
				(long) CINT(BgL_occurrencew1149z00_2359),
				CBOOL(BgL_userzf31150zf3_2360), BgL_module1151z00_2361,
				BgL_import1152z00_2362, CBOOL(BgL_evaluablezf31153zf3_2363),
				CBOOL(BgL_evalzf31154zf3_2364), BgL_library1155z00_2365,
				BgL_pragma1156z00_2366, BgL_src1157z00_2367,
				BgL_jvmzd2typezd2name1158z00_2368, BgL_init1159z00_2369,
				BgL_alias1160z00_2370, BgL_from1161z00_2371);
		}

	}



/* global/from? */
	BGL_EXPORTED_DEF bool_t BGl_globalzf2fromzf3z01zzeffect_cgraphz00(obj_t
		BgL_objz00_73)
	{
		{	/* Effect/cgraph.sch 121 */
			return
				BGl_isazf3zf3zz__objectz00(BgL_objz00_73,
				BGl_globalzf2fromzf2zzeffect_cgraphz00);
		}

	}



/* &global/from? */
	obj_t BGl_z62globalzf2fromzf3z63zzeffect_cgraphz00(obj_t BgL_envz00_2372,
		obj_t BgL_objz00_2373)
	{
		{	/* Effect/cgraph.sch 121 */
			return BBOOL(BGl_globalzf2fromzf3z01zzeffect_cgraphz00(BgL_objz00_2373));
		}

	}



/* global/from-nil */
	BGL_EXPORTED_DEF BgL_globalz00_bglt
		BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.sch 122 */
			{	/* Effect/cgraph.sch 122 */
				obj_t BgL_classz00_2093;

				BgL_classz00_2093 = BGl_globalzf2fromzf2zzeffect_cgraphz00;
				{	/* Effect/cgraph.sch 122 */
					obj_t BgL__ortest_1110z00_2094;

					BgL__ortest_1110z00_2094 = BGL_CLASS_NIL(BgL_classz00_2093);
					if (CBOOL(BgL__ortest_1110z00_2094))
						{	/* Effect/cgraph.sch 122 */
							return ((BgL_globalz00_bglt) BgL__ortest_1110z00_2094);
						}
					else
						{	/* Effect/cgraph.sch 122 */
							return
								((BgL_globalz00_bglt)
								BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2093));
						}
				}
			}
		}

	}



/* &global/from-nil */
	BgL_globalz00_bglt BGl_z62globalzf2fromzd2nilz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2374)
	{
		{	/* Effect/cgraph.sch 122 */
			return BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00();
		}

	}



/* global/from-from */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2fromz20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_74)
	{
		{	/* Effect/cgraph.sch 123 */
			{
				BgL_globalzf2fromzf2_bglt BgL_auxz00_3118;

				{
					obj_t BgL_auxz00_3119;

					{	/* Effect/cgraph.sch 123 */
						BgL_objectz00_bglt BgL_tmpz00_3120;

						BgL_tmpz00_3120 = ((BgL_objectz00_bglt) BgL_oz00_74);
						BgL_auxz00_3119 = BGL_OBJECT_WIDENING(BgL_tmpz00_3120);
					}
					BgL_auxz00_3118 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3119);
				}
				return
					(((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3118))->BgL_fromz00);
			}
		}

	}



/* &global/from-from */
	obj_t BGl_z62globalzf2fromzd2fromz42zzeffect_cgraphz00(obj_t BgL_envz00_2375,
		obj_t BgL_oz00_2376)
	{
		{	/* Effect/cgraph.sch 123 */
			return
				BGl_globalzf2fromzd2fromz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2376));
		}

	}



/* global/from-from-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2fromzd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_75, obj_t BgL_vz00_76)
	{
		{	/* Effect/cgraph.sch 124 */
			{
				BgL_globalzf2fromzf2_bglt BgL_auxz00_3127;

				{
					obj_t BgL_auxz00_3128;

					{	/* Effect/cgraph.sch 124 */
						BgL_objectz00_bglt BgL_tmpz00_3129;

						BgL_tmpz00_3129 = ((BgL_objectz00_bglt) BgL_oz00_75);
						BgL_auxz00_3128 = BGL_OBJECT_WIDENING(BgL_tmpz00_3129);
					}
					BgL_auxz00_3127 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3128);
				}
				return
					((((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3127))->
						BgL_fromz00) = ((obj_t) BgL_vz00_76), BUNSPEC);
			}
		}

	}



/* &global/from-from-set! */
	obj_t BGl_z62globalzf2fromzd2fromzd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2377, obj_t BgL_oz00_2378, obj_t BgL_vz00_2379)
	{
		{	/* Effect/cgraph.sch 124 */
			return
				BGl_globalzf2fromzd2fromzd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2378), BgL_vz00_2379);
		}

	}



/* global/from-alias */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2aliasz20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_77)
	{
		{	/* Effect/cgraph.sch 125 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_77)))->BgL_aliasz00);
		}

	}



/* &global/from-alias */
	obj_t BGl_z62globalzf2fromzd2aliasz42zzeffect_cgraphz00(obj_t BgL_envz00_2380,
		obj_t BgL_oz00_2381)
	{
		{	/* Effect/cgraph.sch 125 */
			return
				BGl_globalzf2fromzd2aliasz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2381));
		}

	}



/* global/from-alias-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2aliaszd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_78, obj_t BgL_vz00_79)
	{
		{	/* Effect/cgraph.sch 126 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_78)))->BgL_aliasz00) =
				((obj_t) BgL_vz00_79), BUNSPEC);
		}

	}



/* &global/from-alias-set! */
	obj_t BGl_z62globalzf2fromzd2aliaszd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2382, obj_t BgL_oz00_2383, obj_t BgL_vz00_2384)
	{
		{	/* Effect/cgraph.sch 126 */
			return
				BGl_globalzf2fromzd2aliaszd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2383), BgL_vz00_2384);
		}

	}



/* global/from-init */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2initz20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_80)
	{
		{	/* Effect/cgraph.sch 127 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_80)))->BgL_initz00);
		}

	}



/* &global/from-init */
	obj_t BGl_z62globalzf2fromzd2initz42zzeffect_cgraphz00(obj_t BgL_envz00_2385,
		obj_t BgL_oz00_2386)
	{
		{	/* Effect/cgraph.sch 127 */
			return
				BGl_globalzf2fromzd2initz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2386));
		}

	}



/* global/from-init-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2initzd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_81, obj_t BgL_vz00_82)
	{
		{	/* Effect/cgraph.sch 128 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_81)))->BgL_initz00) =
				((obj_t) BgL_vz00_82), BUNSPEC);
		}

	}



/* &global/from-init-set! */
	obj_t BGl_z62globalzf2fromzd2initzd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2387, obj_t BgL_oz00_2388, obj_t BgL_vz00_2389)
	{
		{	/* Effect/cgraph.sch 128 */
			return
				BGl_globalzf2fromzd2initzd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2388), BgL_vz00_2389);
		}

	}



/* global/from-jvm-type-name */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2jvmzd2typezd2namez20zzeffect_cgraphz00
		(BgL_globalz00_bglt BgL_oz00_83)
	{
		{	/* Effect/cgraph.sch 129 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_83)))->BgL_jvmzd2typezd2namez00);
		}

	}



/* &global/from-jvm-type-name */
	obj_t BGl_z62globalzf2fromzd2jvmzd2typezd2namez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2390, obj_t BgL_oz00_2391)
	{
		{	/* Effect/cgraph.sch 129 */
			return
				BGl_globalzf2fromzd2jvmzd2typezd2namez20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2391));
		}

	}



/* global/from-jvm-type-name-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2jvmzd2typezd2namezd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt BgL_oz00_84, obj_t BgL_vz00_85)
	{
		{	/* Effect/cgraph.sch 130 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_84)))->BgL_jvmzd2typezd2namez00) =
				((obj_t) BgL_vz00_85), BUNSPEC);
		}

	}



/* &global/from-jvm-type-name-set! */
	obj_t
		BGl_z62globalzf2fromzd2jvmzd2typezd2namezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2392, obj_t BgL_oz00_2393, obj_t BgL_vz00_2394)
	{
		{	/* Effect/cgraph.sch 130 */
			return
				BGl_globalzf2fromzd2jvmzd2typezd2namezd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2393), BgL_vz00_2394);
		}

	}



/* global/from-src */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2srcz20zzeffect_cgraphz00(BgL_globalz00_bglt BgL_oz00_86)
	{
		{	/* Effect/cgraph.sch 131 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_86)))->BgL_srcz00);
		}

	}



/* &global/from-src */
	obj_t BGl_z62globalzf2fromzd2srcz42zzeffect_cgraphz00(obj_t BgL_envz00_2395,
		obj_t BgL_oz00_2396)
	{
		{	/* Effect/cgraph.sch 131 */
			return
				BGl_globalzf2fromzd2srcz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2396));
		}

	}



/* global/from-src-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2srczd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_87, obj_t BgL_vz00_88)
	{
		{	/* Effect/cgraph.sch 132 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_87)))->BgL_srcz00) =
				((obj_t) BgL_vz00_88), BUNSPEC);
		}

	}



/* &global/from-src-set! */
	obj_t BGl_z62globalzf2fromzd2srczd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2397, obj_t BgL_oz00_2398, obj_t BgL_vz00_2399)
	{
		{	/* Effect/cgraph.sch 132 */
			return
				BGl_globalzf2fromzd2srczd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2398), BgL_vz00_2399);
		}

	}



/* global/from-pragma */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2pragmaz20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_89)
	{
		{	/* Effect/cgraph.sch 133 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_89)))->BgL_pragmaz00);
		}

	}



/* &global/from-pragma */
	obj_t BGl_z62globalzf2fromzd2pragmaz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2400, obj_t BgL_oz00_2401)
	{
		{	/* Effect/cgraph.sch 133 */
			return
				BGl_globalzf2fromzd2pragmaz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2401));
		}

	}



/* global/from-pragma-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2pragmazd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_90, obj_t BgL_vz00_91)
	{
		{	/* Effect/cgraph.sch 134 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_90)))->BgL_pragmaz00) =
				((obj_t) BgL_vz00_91), BUNSPEC);
		}

	}



/* &global/from-pragma-set! */
	obj_t BGl_z62globalzf2fromzd2pragmazd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2402, obj_t BgL_oz00_2403, obj_t BgL_vz00_2404)
	{
		{	/* Effect/cgraph.sch 134 */
			return
				BGl_globalzf2fromzd2pragmazd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2403), BgL_vz00_2404);
		}

	}



/* global/from-library */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2libraryz20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_92)
	{
		{	/* Effect/cgraph.sch 135 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_92)))->BgL_libraryz00);
		}

	}



/* &global/from-library */
	obj_t BGl_z62globalzf2fromzd2libraryz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2405, obj_t BgL_oz00_2406)
	{
		{	/* Effect/cgraph.sch 135 */
			return
				BGl_globalzf2fromzd2libraryz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2406));
		}

	}



/* global/from-library-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2libraryzd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_93, obj_t BgL_vz00_94)
	{
		{	/* Effect/cgraph.sch 136 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_93)))->BgL_libraryz00) =
				((obj_t) BgL_vz00_94), BUNSPEC);
		}

	}



/* &global/from-library-set! */
	obj_t BGl_z62globalzf2fromzd2libraryzd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2407, obj_t BgL_oz00_2408, obj_t BgL_vz00_2409)
	{
		{	/* Effect/cgraph.sch 136 */
			return
				BGl_globalzf2fromzd2libraryzd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2408), BgL_vz00_2409);
		}

	}



/* global/from-eval? */
	BGL_EXPORTED_DEF bool_t
		BGl_globalzf2fromzd2evalzf3zd3zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_95)
	{
		{	/* Effect/cgraph.sch 137 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_95)))->BgL_evalzf3zf3);
		}

	}



/* &global/from-eval? */
	obj_t BGl_z62globalzf2fromzd2evalzf3zb1zzeffect_cgraphz00(obj_t
		BgL_envz00_2410, obj_t BgL_oz00_2411)
	{
		{	/* Effect/cgraph.sch 137 */
			return
				BBOOL(BGl_globalzf2fromzd2evalzf3zd3zzeffect_cgraphz00(
					((BgL_globalz00_bglt) BgL_oz00_2411)));
		}

	}



/* global/from-eval?-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2evalzf3zd2setz12z13zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_96, bool_t BgL_vz00_97)
	{
		{	/* Effect/cgraph.sch 138 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_96)))->BgL_evalzf3zf3) =
				((bool_t) BgL_vz00_97), BUNSPEC);
		}

	}



/* &global/from-eval?-set! */
	obj_t BGl_z62globalzf2fromzd2evalzf3zd2setz12z71zzeffect_cgraphz00(obj_t
		BgL_envz00_2412, obj_t BgL_oz00_2413, obj_t BgL_vz00_2414)
	{
		{	/* Effect/cgraph.sch 138 */
			return
				BGl_globalzf2fromzd2evalzf3zd2setz12z13zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2413), CBOOL(BgL_vz00_2414));
		}

	}



/* global/from-evaluable? */
	BGL_EXPORTED_DEF bool_t
		BGl_globalzf2fromzd2evaluablezf3zd3zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_98)
	{
		{	/* Effect/cgraph.sch 139 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_98)))->BgL_evaluablezf3zf3);
		}

	}



/* &global/from-evaluable? */
	obj_t BGl_z62globalzf2fromzd2evaluablezf3zb1zzeffect_cgraphz00(obj_t
		BgL_envz00_2415, obj_t BgL_oz00_2416)
	{
		{	/* Effect/cgraph.sch 139 */
			return
				BBOOL(BGl_globalzf2fromzd2evaluablezf3zd3zzeffect_cgraphz00(
					((BgL_globalz00_bglt) BgL_oz00_2416)));
		}

	}



/* global/from-evaluable?-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2evaluablezf3zd2setz12z13zzeffect_cgraphz00
		(BgL_globalz00_bglt BgL_oz00_99, bool_t BgL_vz00_100)
	{
		{	/* Effect/cgraph.sch 140 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_99)))->BgL_evaluablezf3zf3) =
				((bool_t) BgL_vz00_100), BUNSPEC);
		}

	}



/* &global/from-evaluable?-set! */
	obj_t BGl_z62globalzf2fromzd2evaluablezf3zd2setz12z71zzeffect_cgraphz00(obj_t
		BgL_envz00_2417, obj_t BgL_oz00_2418, obj_t BgL_vz00_2419)
	{
		{	/* Effect/cgraph.sch 140 */
			return
				BGl_globalzf2fromzd2evaluablezf3zd2setz12z13zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2418), CBOOL(BgL_vz00_2419));
		}

	}



/* global/from-import */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2importz20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_101)
	{
		{	/* Effect/cgraph.sch 141 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_101)))->BgL_importz00);
		}

	}



/* &global/from-import */
	obj_t BGl_z62globalzf2fromzd2importz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2420, obj_t BgL_oz00_2421)
	{
		{	/* Effect/cgraph.sch 141 */
			return
				BGl_globalzf2fromzd2importz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2421));
		}

	}



/* global/from-import-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2importzd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_102, obj_t BgL_vz00_103)
	{
		{	/* Effect/cgraph.sch 142 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_102)))->BgL_importz00) =
				((obj_t) BgL_vz00_103), BUNSPEC);
		}

	}



/* &global/from-import-set! */
	obj_t BGl_z62globalzf2fromzd2importzd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2422, obj_t BgL_oz00_2423, obj_t BgL_vz00_2424)
	{
		{	/* Effect/cgraph.sch 142 */
			return
				BGl_globalzf2fromzd2importzd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2423), BgL_vz00_2424);
		}

	}



/* global/from-module */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2modulez20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_104)
	{
		{	/* Effect/cgraph.sch 143 */
			return
				(((BgL_globalz00_bglt) COBJECT(
						((BgL_globalz00_bglt) BgL_oz00_104)))->BgL_modulez00);
		}

	}



/* &global/from-module */
	obj_t BGl_z62globalzf2fromzd2modulez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2425, obj_t BgL_oz00_2426)
	{
		{	/* Effect/cgraph.sch 143 */
			return
				BGl_globalzf2fromzd2modulez20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2426));
		}

	}



/* global/from-module-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2modulezd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_105, obj_t BgL_vz00_106)
	{
		{	/* Effect/cgraph.sch 144 */
			return
				((((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_oz00_105)))->BgL_modulez00) =
				((obj_t) BgL_vz00_106), BUNSPEC);
		}

	}



/* &global/from-module-set! */
	obj_t BGl_z62globalzf2fromzd2modulezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2427, obj_t BgL_oz00_2428, obj_t BgL_vz00_2429)
	{
		{	/* Effect/cgraph.sch 144 */
			return
				BGl_globalzf2fromzd2modulezd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2428), BgL_vz00_2429);
		}

	}



/* global/from-user? */
	BGL_EXPORTED_DEF bool_t
		BGl_globalzf2fromzd2userzf3zd3zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_107)
	{
		{	/* Effect/cgraph.sch 145 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_107)))->BgL_userzf3zf3);
		}

	}



/* &global/from-user? */
	obj_t BGl_z62globalzf2fromzd2userzf3zb1zzeffect_cgraphz00(obj_t
		BgL_envz00_2430, obj_t BgL_oz00_2431)
	{
		{	/* Effect/cgraph.sch 145 */
			return
				BBOOL(BGl_globalzf2fromzd2userzf3zd3zzeffect_cgraphz00(
					((BgL_globalz00_bglt) BgL_oz00_2431)));
		}

	}



/* global/from-user?-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2userzf3zd2setz12z13zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_108, bool_t BgL_vz00_109)
	{
		{	/* Effect/cgraph.sch 146 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_108)))->BgL_userzf3zf3) =
				((bool_t) BgL_vz00_109), BUNSPEC);
		}

	}



/* &global/from-user?-set! */
	obj_t BGl_z62globalzf2fromzd2userzf3zd2setz12z71zzeffect_cgraphz00(obj_t
		BgL_envz00_2432, obj_t BgL_oz00_2433, obj_t BgL_vz00_2434)
	{
		{	/* Effect/cgraph.sch 146 */
			return
				BGl_globalzf2fromzd2userzf3zd2setz12z13zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2433), CBOOL(BgL_vz00_2434));
		}

	}



/* global/from-occurrencew */
	BGL_EXPORTED_DEF long
		BGl_globalzf2fromzd2occurrencewz20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_110)
	{
		{	/* Effect/cgraph.sch 147 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_110)))->BgL_occurrencewz00);
		}

	}



/* &global/from-occurrencew */
	obj_t BGl_z62globalzf2fromzd2occurrencewz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2435, obj_t BgL_oz00_2436)
	{
		{	/* Effect/cgraph.sch 147 */
			return
				BINT(BGl_globalzf2fromzd2occurrencewz20zzeffect_cgraphz00(
					((BgL_globalz00_bglt) BgL_oz00_2436)));
		}

	}



/* global/from-occurrencew-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2occurrencewzd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt BgL_oz00_111, long BgL_vz00_112)
	{
		{	/* Effect/cgraph.sch 148 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_111)))->BgL_occurrencewz00) =
				((long) BgL_vz00_112), BUNSPEC);
		}

	}



/* &global/from-occurrencew-set! */
	obj_t BGl_z62globalzf2fromzd2occurrencewzd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2437, obj_t BgL_oz00_2438, obj_t BgL_vz00_2439)
	{
		{	/* Effect/cgraph.sch 148 */
			return
				BGl_globalzf2fromzd2occurrencewzd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2438), (long) CINT(BgL_vz00_2439));
		}

	}



/* global/from-occurrence */
	BGL_EXPORTED_DEF long
		BGl_globalzf2fromzd2occurrencez20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_113)
	{
		{	/* Effect/cgraph.sch 149 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_113)))->BgL_occurrencez00);
		}

	}



/* &global/from-occurrence */
	obj_t BGl_z62globalzf2fromzd2occurrencez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2440, obj_t BgL_oz00_2441)
	{
		{	/* Effect/cgraph.sch 149 */
			return
				BINT(BGl_globalzf2fromzd2occurrencez20zzeffect_cgraphz00(
					((BgL_globalz00_bglt) BgL_oz00_2441)));
		}

	}



/* global/from-occurrence-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2occurrencezd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt BgL_oz00_114, long BgL_vz00_115)
	{
		{	/* Effect/cgraph.sch 150 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_114)))->BgL_occurrencez00) =
				((long) BgL_vz00_115), BUNSPEC);
		}

	}



/* &global/from-occurrence-set! */
	obj_t BGl_z62globalzf2fromzd2occurrencezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2442, obj_t BgL_oz00_2443, obj_t BgL_vz00_2444)
	{
		{	/* Effect/cgraph.sch 150 */
			return
				BGl_globalzf2fromzd2occurrencezd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2443), (long) CINT(BgL_vz00_2444));
		}

	}



/* global/from-removable */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2removablez20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_116)
	{
		{	/* Effect/cgraph.sch 151 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_116)))->BgL_removablez00);
		}

	}



/* &global/from-removable */
	obj_t BGl_z62globalzf2fromzd2removablez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2445, obj_t BgL_oz00_2446)
	{
		{	/* Effect/cgraph.sch 151 */
			return
				BGl_globalzf2fromzd2removablez20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2446));
		}

	}



/* global/from-removable-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2removablezd2setz12ze0zzeffect_cgraphz00
		(BgL_globalz00_bglt BgL_oz00_117, obj_t BgL_vz00_118)
	{
		{	/* Effect/cgraph.sch 152 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_117)))->BgL_removablez00) =
				((obj_t) BgL_vz00_118), BUNSPEC);
		}

	}



/* &global/from-removable-set! */
	obj_t BGl_z62globalzf2fromzd2removablezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2447, obj_t BgL_oz00_2448, obj_t BgL_vz00_2449)
	{
		{	/* Effect/cgraph.sch 152 */
			return
				BGl_globalzf2fromzd2removablezd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2448), BgL_vz00_2449);
		}

	}



/* global/from-fast-alpha */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2fastzd2alphazf2zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_119)
	{
		{	/* Effect/cgraph.sch 153 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_119)))->BgL_fastzd2alphazd2);
		}

	}



/* &global/from-fast-alpha */
	obj_t BGl_z62globalzf2fromzd2fastzd2alphaz90zzeffect_cgraphz00(obj_t
		BgL_envz00_2450, obj_t BgL_oz00_2451)
	{
		{	/* Effect/cgraph.sch 153 */
			return
				BGl_globalzf2fromzd2fastzd2alphazf2zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2451));
		}

	}



/* global/from-fast-alpha-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2fastzd2alphazd2setz12z32zzeffect_cgraphz00
		(BgL_globalz00_bglt BgL_oz00_120, obj_t BgL_vz00_121)
	{
		{	/* Effect/cgraph.sch 154 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_120)))->BgL_fastzd2alphazd2) =
				((obj_t) BgL_vz00_121), BUNSPEC);
		}

	}



/* &global/from-fast-alpha-set! */
	obj_t BGl_z62globalzf2fromzd2fastzd2alphazd2setz12z50zzeffect_cgraphz00(obj_t
		BgL_envz00_2452, obj_t BgL_oz00_2453, obj_t BgL_vz00_2454)
	{
		{	/* Effect/cgraph.sch 154 */
			return
				BGl_globalzf2fromzd2fastzd2alphazd2setz12z32zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2453), BgL_vz00_2454);
		}

	}



/* global/from-access */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2accessz20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_122)
	{
		{	/* Effect/cgraph.sch 155 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_122)))->BgL_accessz00);
		}

	}



/* &global/from-access */
	obj_t BGl_z62globalzf2fromzd2accessz42zzeffect_cgraphz00(obj_t
		BgL_envz00_2455, obj_t BgL_oz00_2456)
	{
		{	/* Effect/cgraph.sch 155 */
			return
				BGl_globalzf2fromzd2accessz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2456));
		}

	}



/* global/from-access-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2accesszd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_123, obj_t BgL_vz00_124)
	{
		{	/* Effect/cgraph.sch 156 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_123)))->BgL_accessz00) =
				((obj_t) BgL_vz00_124), BUNSPEC);
		}

	}



/* &global/from-access-set! */
	obj_t BGl_z62globalzf2fromzd2accesszd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2457, obj_t BgL_oz00_2458, obj_t BgL_vz00_2459)
	{
		{	/* Effect/cgraph.sch 156 */
			return
				BGl_globalzf2fromzd2accesszd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2458), BgL_vz00_2459);
		}

	}



/* global/from-value */
	BGL_EXPORTED_DEF BgL_valuez00_bglt
		BGl_globalzf2fromzd2valuez20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_125)
	{
		{	/* Effect/cgraph.sch 157 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_125)))->BgL_valuez00);
		}

	}



/* &global/from-value */
	BgL_valuez00_bglt BGl_z62globalzf2fromzd2valuez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2460, obj_t BgL_oz00_2461)
	{
		{	/* Effect/cgraph.sch 157 */
			return
				BGl_globalzf2fromzd2valuez20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2461));
		}

	}



/* global/from-value-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2valuezd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_126, BgL_valuez00_bglt BgL_vz00_127)
	{
		{	/* Effect/cgraph.sch 158 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_126)))->BgL_valuez00) =
				((BgL_valuez00_bglt) BgL_vz00_127), BUNSPEC);
		}

	}



/* &global/from-value-set! */
	obj_t BGl_z62globalzf2fromzd2valuezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2462, obj_t BgL_oz00_2463, obj_t BgL_vz00_2464)
	{
		{	/* Effect/cgraph.sch 158 */
			return
				BGl_globalzf2fromzd2valuezd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2463),
				((BgL_valuez00_bglt) BgL_vz00_2464));
		}

	}



/* global/from-type */
	BGL_EXPORTED_DEF BgL_typez00_bglt
		BGl_globalzf2fromzd2typez20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_128)
	{
		{	/* Effect/cgraph.sch 159 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_128)))->BgL_typez00);
		}

	}



/* &global/from-type */
	BgL_typez00_bglt BGl_z62globalzf2fromzd2typez42zzeffect_cgraphz00(obj_t
		BgL_envz00_2465, obj_t BgL_oz00_2466)
	{
		{	/* Effect/cgraph.sch 159 */
			return
				BGl_globalzf2fromzd2typez20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2466));
		}

	}



/* global/from-type-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2typezd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_129, BgL_typez00_bglt BgL_vz00_130)
	{
		{	/* Effect/cgraph.sch 160 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_129)))->BgL_typez00) =
				((BgL_typez00_bglt) BgL_vz00_130), BUNSPEC);
		}

	}



/* &global/from-type-set! */
	obj_t BGl_z62globalzf2fromzd2typezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2467, obj_t BgL_oz00_2468, obj_t BgL_vz00_2469)
	{
		{	/* Effect/cgraph.sch 160 */
			return
				BGl_globalzf2fromzd2typezd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2468),
				((BgL_typez00_bglt) BgL_vz00_2469));
		}

	}



/* global/from-name */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2namez20zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_131)
	{
		{	/* Effect/cgraph.sch 161 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_131)))->BgL_namez00);
		}

	}



/* &global/from-name */
	obj_t BGl_z62globalzf2fromzd2namez42zzeffect_cgraphz00(obj_t BgL_envz00_2470,
		obj_t BgL_oz00_2471)
	{
		{	/* Effect/cgraph.sch 161 */
			return
				BGl_globalzf2fromzd2namez20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2471));
		}

	}



/* global/from-name-set! */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2namezd2setz12ze0zzeffect_cgraphz00(BgL_globalz00_bglt
		BgL_oz00_132, obj_t BgL_vz00_133)
	{
		{	/* Effect/cgraph.sch 162 */
			return
				((((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_oz00_132)))->BgL_namez00) =
				((obj_t) BgL_vz00_133), BUNSPEC);
		}

	}



/* &global/from-name-set! */
	obj_t BGl_z62globalzf2fromzd2namezd2setz12z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2472, obj_t BgL_oz00_2473, obj_t BgL_vz00_2474)
	{
		{	/* Effect/cgraph.sch 162 */
			return
				BGl_globalzf2fromzd2namezd2setz12ze0zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2473), BgL_vz00_2474);
		}

	}



/* global/from-id */
	BGL_EXPORTED_DEF obj_t
		BGl_globalzf2fromzd2idz20zzeffect_cgraphz00(BgL_globalz00_bglt BgL_oz00_134)
	{
		{	/* Effect/cgraph.sch 163 */
			return
				(((BgL_variablez00_bglt) COBJECT(
						((BgL_variablez00_bglt) BgL_oz00_134)))->BgL_idz00);
		}

	}



/* &global/from-id */
	obj_t BGl_z62globalzf2fromzd2idz42zzeffect_cgraphz00(obj_t BgL_envz00_2475,
		obj_t BgL_oz00_2476)
	{
		{	/* Effect/cgraph.sch 163 */
			return
				BGl_globalzf2fromzd2idz20zzeffect_cgraphz00(
				((BgL_globalz00_bglt) BgL_oz00_2476));
		}

	}



/* fun-call-graph! */
	BGL_EXPORTED_DEF obj_t
		BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_variablez00_137)
	{
		{	/* Effect/cgraph.scm 31 */
			BGl_za2varzf2allza2zf2zzeffect_cgraphz00 =
				MAKE_YOUNG_PAIR(
				((obj_t) BgL_variablez00_137),
				BGl_za2varzf2allza2zf2zzeffect_cgraphz00);
			{	/* Effect/cgraph.scm 33 */
				obj_t BgL_arg1446z00_1538;

				BgL_arg1446z00_1538 =
					(((BgL_sfunz00_bglt) COBJECT(
							((BgL_sfunz00_bglt)
								(((BgL_variablez00_bglt) COBJECT(BgL_variablez00_137))->
									BgL_valuez00))))->BgL_bodyz00);
				return BGl_callzd2graphz12zc0zzeffect_cgraphz00(((BgL_nodez00_bglt)
						BgL_arg1446z00_1538), BgL_variablez00_137);
			}
		}

	}



/* &fun-call-graph! */
	obj_t BGl_z62funzd2callzd2graphz12z70zzeffect_cgraphz00(obj_t BgL_envz00_2477,
		obj_t BgL_variablez00_2478)
	{
		{	/* Effect/cgraph.scm 31 */
			return
				BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(
				((BgL_variablez00_bglt) BgL_variablez00_2478));
		}

	}



/* call-graph*! */
	bool_t BGl_callzd2graphza2z12z62zzeffect_cgraphz00(obj_t BgL_nodeza2za2_176,
		obj_t BgL_ownerz00_177)
	{
		{	/* Effect/cgraph.scm 205 */
			{
				obj_t BgL_l1313z00_1541;

				BgL_l1313z00_1541 = BgL_nodeza2za2_176;
			BgL_zc3z04anonymousza31452ze3z87_1542:
				if (PAIRP(BgL_l1313z00_1541))
					{	/* Effect/cgraph.scm 206 */
						{	/* Effect/cgraph.scm 206 */
							obj_t BgL_nodez00_1544;

							BgL_nodez00_1544 = CAR(BgL_l1313z00_1541);
							BGl_callzd2graphz12zc0zzeffect_cgraphz00(
								((BgL_nodez00_bglt) BgL_nodez00_1544),
								((BgL_variablez00_bglt) BgL_ownerz00_177));
						}
						{
							obj_t BgL_l1313z00_3319;

							BgL_l1313z00_3319 = CDR(BgL_l1313z00_1541);
							BgL_l1313z00_1541 = BgL_l1313z00_3319;
							goto BgL_zc3z04anonymousza31452ze3z87_1542;
						}
					}
				else
					{	/* Effect/cgraph.scm 206 */
						return ((bool_t) 1);
					}
			}
		}

	}



/* get-var/side-effect */
	BGL_EXPORTED_DEF obj_t BGl_getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 250 */
			return BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00;
		}

	}



/* &get-var/side-effect */
	obj_t BGl_z62getzd2varzf2sidezd2effectz90zzeffect_cgraphz00(obj_t
		BgL_envz00_2479)
	{
		{	/* Effect/cgraph.scm 250 */
			return BGl_getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00();
		}

	}



/* get-var/all */
	BGL_EXPORTED_DEF obj_t BGl_getzd2varzf2allz20zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 261 */
			return BGl_za2varzf2allza2zf2zzeffect_cgraphz00;
		}

	}



/* &get-var/all */
	obj_t BGl_z62getzd2varzf2allz42zzeffect_cgraphz00(obj_t BgL_envz00_2480)
	{
		{	/* Effect/cgraph.scm 261 */
			return BGl_getzd2varzf2allz20zzeffect_cgraphz00();
		}

	}



/* reset-effect-tables! */
	BGL_EXPORTED_DEF obj_t BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 272 */
			BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BNIL;
			return (BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BNIL, BUNSPEC);
		}

	}



/* &reset-effect-tables! */
	obj_t BGl_z62resetzd2effectzd2tablesz12z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2481)
	{
		{	/* Effect/cgraph.scm 272 */
			return BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00();
		}

	}



/* mark-side-effect! */
	obj_t BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_vz00_188)
	{
		{	/* Effect/cgraph.scm 279 */
			{	/* Effect/cgraph.scm 282 */
				BgL_valuez00_bglt BgL_funz00_1547;

				BgL_funz00_1547 =
					(((BgL_variablez00_bglt) COBJECT(BgL_vz00_188))->BgL_valuez00);
				if (CBOOL(
						(((BgL_funz00_bglt) COBJECT(
									((BgL_funz00_bglt) BgL_funz00_1547)))->BgL_sidezd2effectzd2)))
					{	/* Effect/cgraph.scm 284 */
						if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
									((obj_t) BgL_vz00_188),
									BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00)))
							{	/* Effect/cgraph.scm 287 */
								return CNST_TABLE_REF(((long) 0));
							}
						else
							{	/* Effect/cgraph.scm 287 */
								return (BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 =
									MAKE_YOUNG_PAIR(
										((obj_t) BgL_vz00_188),
										BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00),
									BUNSPEC);
							}
					}
				else
					{	/* Effect/cgraph.scm 284 */
						BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 =
							MAKE_YOUNG_PAIR(
							((obj_t) BgL_vz00_188),
							BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00);
						return ((((BgL_funz00_bglt) COBJECT(((BgL_funz00_bglt)
											BgL_funz00_1547)))->BgL_sidezd2effectzd2) =
							((obj_t) BTRUE), BUNSPEC);
					}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 15 */
			{	/* Effect/cgraph.scm 21 */
				obj_t BgL_arg1526z00_1554;
				obj_t BgL_arg1527z00_1555;

				{	/* Effect/cgraph.scm 21 */
					obj_t BgL_v1315z00_1589;

					BgL_v1315z00_1589 = create_vector(((long) 1));
					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_arg1551z00_1590;

						BgL_arg1551z00_1590 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									1)), BGl_proc1875z00zzeffect_cgraphz00,
							BGl_proc1874z00zzeffect_cgraphz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 2)));
						VECTOR_SET(BgL_v1315z00_1589, ((long) 0), BgL_arg1551z00_1590);
					}
					BgL_arg1526z00_1554 = BgL_v1315z00_1589;
				}
				{	/* Effect/cgraph.scm 21 */
					obj_t BgL_v1316z00_1600;

					BgL_v1316z00_1600 = create_vector(((long) 0));
					BgL_arg1527z00_1555 = BgL_v1316z00_1600;
				}
				BGl_localzf2fromzf2zzeffect_cgraphz00 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 3)),
					CNST_TABLE_REF(((long) 4)), BGl_localz00zzast_varz00, ((long) 19676),
					BGl_proc1879z00zzeffect_cgraphz00, BGl_proc1878z00zzeffect_cgraphz00,
					BFALSE, BGl_proc1877z00zzeffect_cgraphz00,
					BGl_proc1876z00zzeffect_cgraphz00, BgL_arg1526z00_1554,
					BgL_arg1527z00_1555);
			}
			{	/* Effect/cgraph.scm 22 */
				obj_t BgL_arg1569z00_1609;
				obj_t BgL_arg1571z00_1610;

				{	/* Effect/cgraph.scm 22 */
					obj_t BgL_v1317z00_1652;

					BgL_v1317z00_1652 = create_vector(((long) 1));
					{	/* Effect/cgraph.scm 22 */
						obj_t BgL_arg1599z00_1653;

						BgL_arg1599z00_1653 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									1)), BGl_proc1881z00zzeffect_cgraphz00,
							BGl_proc1880z00zzeffect_cgraphz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 2)));
						VECTOR_SET(BgL_v1317z00_1652, ((long) 0), BgL_arg1599z00_1653);
					}
					BgL_arg1569z00_1609 = BgL_v1317z00_1652;
				}
				{	/* Effect/cgraph.scm 22 */
					obj_t BgL_v1318z00_1663;

					BgL_v1318z00_1663 = create_vector(((long) 0));
					BgL_arg1571z00_1610 = BgL_v1318z00_1663;
				}
				return (BGl_globalzf2fromzf2zzeffect_cgraphz00 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 5)),
						CNST_TABLE_REF(((long) 4)), BGl_globalz00zzast_varz00,
						((long) 6288), BGl_proc1885z00zzeffect_cgraphz00,
						BGl_proc1884z00zzeffect_cgraphz00, BFALSE,
						BGl_proc1883z00zzeffect_cgraphz00,
						BGl_proc1882z00zzeffect_cgraphz00, BgL_arg1569z00_1609,
						BgL_arg1571z00_1610), BUNSPEC);
		}}

	}



/* &lambda1584 */
	BgL_globalz00_bglt BGl_z62lambda1584z62zzeffect_cgraphz00(obj_t
		BgL_envz00_2494, obj_t BgL_o1145z00_2495)
	{
		{	/* Effect/cgraph.scm 22 */
			{	/* Effect/cgraph.scm 22 */
				long BgL_arg1585z00_2679;

				{	/* Effect/cgraph.scm 22 */
					obj_t BgL_arg1597z00_2680;

					{	/* Effect/cgraph.scm 22 */
						obj_t BgL_arg1598z00_2681;

						{	/* Effect/cgraph.scm 22 */
							long BgL_arg1794z00_2682;

							{	/* Effect/cgraph.scm 22 */
								long BgL_arg1795z00_2683;

								BgL_arg1795z00_2683 =
									BGL_OBJECT_CLASS_NUM(
									((BgL_objectz00_bglt)
										((BgL_globalz00_bglt) BgL_o1145z00_2495)));
								BgL_arg1794z00_2682 = (BgL_arg1795z00_2683 - OBJECT_TYPE);
							}
							BgL_arg1598z00_2681 =
								VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
								BgL_arg1794z00_2682);
						}
						BgL_arg1597z00_2680 =
							BGl_classzd2superzd2zz__objectz00(BgL_arg1598z00_2681);
					}
					{	/* Effect/cgraph.scm 22 */
						obj_t BgL_tmpz00_3364;

						BgL_tmpz00_3364 = ((obj_t) BgL_arg1597z00_2680);
						BgL_arg1585z00_2679 = BGL_CLASS_INDEX(BgL_tmpz00_3364);
				}}
				BGL_OBJECT_CLASS_NUM_SET(
					((BgL_objectz00_bglt)
						((BgL_globalz00_bglt) BgL_o1145z00_2495)), BgL_arg1585z00_2679);
			}
			{	/* Effect/cgraph.scm 22 */
				BgL_objectz00_bglt BgL_tmpz00_3370;

				BgL_tmpz00_3370 =
					((BgL_objectz00_bglt) ((BgL_globalz00_bglt) BgL_o1145z00_2495));
				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3370, BFALSE);
			}
			((BgL_objectz00_bglt) ((BgL_globalz00_bglt) BgL_o1145z00_2495));
			return ((BgL_globalz00_bglt) ((BgL_globalz00_bglt) BgL_o1145z00_2495));
		}

	}



/* &<@anonymous:1583> */
	obj_t BGl_z62zc3z04anonymousza31583ze3ze5zzeffect_cgraphz00(obj_t
		BgL_envz00_2496, obj_t BgL_new1144z00_2497)
	{
		{	/* Effect/cgraph.scm 22 */
			{
				BgL_globalz00_bglt BgL_auxz00_3378;

				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_globalz00_bglt) BgL_new1144z00_2497))))->BgL_idz00) =
					((obj_t) CNST_TABLE_REF(((long) 6))), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_namez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_3386;

					{	/* Effect/cgraph.scm 22 */
						obj_t BgL_classz00_2685;

						BgL_classz00_2685 = BGl_typez00zztype_typez00;
						{	/* Effect/cgraph.scm 22 */
							obj_t BgL__ortest_1110z00_2686;

							BgL__ortest_1110z00_2686 = BGL_CLASS_NIL(BgL_classz00_2685);
							if (CBOOL(BgL__ortest_1110z00_2686))
								{	/* Effect/cgraph.scm 22 */
									BgL_auxz00_3386 =
										((BgL_typez00_bglt) BgL__ortest_1110z00_2686);
								}
							else
								{	/* Effect/cgraph.scm 22 */
									BgL_auxz00_3386 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2685));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_globalz00_bglt) BgL_new1144z00_2497))))->
							BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_3386), BUNSPEC);
				}
				{
					BgL_valuez00_bglt BgL_auxz00_3396;

					{	/* Effect/cgraph.scm 22 */
						obj_t BgL_classz00_2687;

						BgL_classz00_2687 = BGl_valuez00zzast_varz00;
						{	/* Effect/cgraph.scm 22 */
							obj_t BgL__ortest_1110z00_2688;

							BgL__ortest_1110z00_2688 = BGL_CLASS_NIL(BgL_classz00_2687);
							if (CBOOL(BgL__ortest_1110z00_2688))
								{	/* Effect/cgraph.scm 22 */
									BgL_auxz00_3396 =
										((BgL_valuez00_bglt) BgL__ortest_1110z00_2688);
								}
							else
								{	/* Effect/cgraph.scm 22 */
									BgL_auxz00_3396 =
										((BgL_valuez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2687));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_globalz00_bglt) BgL_new1144z00_2497))))->
							BgL_valuez00) = ((BgL_valuez00_bglt) BgL_auxz00_3396), BUNSPEC);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_globalz00_bglt) BgL_new1144z00_2497))))->
						BgL_accessz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_fastzd2alphazd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_removablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_occurrencez00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_occurrencewz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_userzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_modulez00) =
					((obj_t) CNST_TABLE_REF(((long) 6))), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_importz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_evaluablezf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_evalzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_libraryz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_pragmaz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_srcz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_jvmzd2typezd2namez00) =
					((obj_t) BGl_string1886z00zzeffect_cgraphz00), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_initz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1144z00_2497))))->BgL_aliasz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_globalzf2fromzf2_bglt BgL_auxz00_3455;

					{
						obj_t BgL_auxz00_3456;

						{	/* Effect/cgraph.scm 22 */
							BgL_objectz00_bglt BgL_tmpz00_3457;

							BgL_tmpz00_3457 =
								((BgL_objectz00_bglt)
								((BgL_globalz00_bglt) BgL_new1144z00_2497));
							BgL_auxz00_3456 = BGL_OBJECT_WIDENING(BgL_tmpz00_3457);
						}
						BgL_auxz00_3455 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3456);
					}
					((((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3455))->
							BgL_fromz00) = ((obj_t) BUNSPEC), BUNSPEC);
				}
				BgL_auxz00_3378 = ((BgL_globalz00_bglt) BgL_new1144z00_2497);
				return ((obj_t) BgL_auxz00_3378);
			}
		}

	}



/* &lambda1580 */
	BgL_globalz00_bglt BGl_z62lambda1580z62zzeffect_cgraphz00(obj_t
		BgL_envz00_2498, obj_t BgL_o1141z00_2499)
	{
		{	/* Effect/cgraph.scm 22 */
			{	/* Effect/cgraph.scm 22 */
				BgL_globalzf2fromzf2_bglt BgL_wide1143z00_2690;

				BgL_wide1143z00_2690 =
					((BgL_globalzf2fromzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_globalzf2fromzf2_bgl))));
				{	/* Effect/cgraph.scm 22 */
					obj_t BgL_auxz00_3470;
					BgL_objectz00_bglt BgL_tmpz00_3466;

					BgL_auxz00_3470 = ((obj_t) BgL_wide1143z00_2690);
					BgL_tmpz00_3466 =
						((BgL_objectz00_bglt)
						((BgL_globalz00_bglt) ((BgL_globalz00_bglt) BgL_o1141z00_2499)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3466, BgL_auxz00_3470);
				}
				((BgL_objectz00_bglt)
					((BgL_globalz00_bglt) ((BgL_globalz00_bglt) BgL_o1141z00_2499)));
				{	/* Effect/cgraph.scm 22 */
					long BgL_arg1582z00_2691;

					BgL_arg1582z00_2691 =
						BGL_CLASS_INDEX(BGl_globalzf2fromzf2zzeffect_cgraphz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_globalz00_bglt)
								((BgL_globalz00_bglt) BgL_o1141z00_2499))),
						BgL_arg1582z00_2691);
				}
				return
					((BgL_globalz00_bglt)
					((BgL_globalz00_bglt) ((BgL_globalz00_bglt) BgL_o1141z00_2499)));
			}
		}

	}



/* &lambda1572 */
	BgL_globalz00_bglt BGl_z62lambda1572z62zzeffect_cgraphz00(obj_t
		BgL_envz00_2500, obj_t BgL_id1120z00_2501, obj_t BgL_name1121z00_2502,
		obj_t BgL_type1122z00_2503, obj_t BgL_value1123z00_2504,
		obj_t BgL_access1124z00_2505, obj_t BgL_fastzd2alpha1125zd2_2506,
		obj_t BgL_removable1126z00_2507, obj_t BgL_occurrence1127z00_2508,
		obj_t BgL_occurrencew1128z00_2509, obj_t BgL_userzf31129zf3_2510,
		obj_t BgL_module1130z00_2511, obj_t BgL_import1131z00_2512,
		obj_t BgL_evaluablezf31132zf3_2513, obj_t BgL_evalzf31133zf3_2514,
		obj_t BgL_library1134z00_2515, obj_t BgL_pragma1135z00_2516,
		obj_t BgL_src1136z00_2517, obj_t BgL_jvmzd2typezd2name1137z00_2518,
		obj_t BgL_init1138z00_2519, obj_t BgL_alias1139z00_2520,
		obj_t BgL_from1140z00_2521)
	{
		{	/* Effect/cgraph.scm 22 */
			{	/* Effect/cgraph.scm 22 */
				long BgL_occurrence1127z00_2695;
				long BgL_occurrencew1128z00_2696;
				bool_t BgL_userzf31129zf3_2697;
				bool_t BgL_evaluablezf31132zf3_2699;
				bool_t BgL_evalzf31133zf3_2700;

				BgL_occurrence1127z00_2695 = (long) CINT(BgL_occurrence1127z00_2508);
				BgL_occurrencew1128z00_2696 = (long) CINT(BgL_occurrencew1128z00_2509);
				BgL_userzf31129zf3_2697 = CBOOL(BgL_userzf31129zf3_2510);
				BgL_evaluablezf31132zf3_2699 = CBOOL(BgL_evaluablezf31132zf3_2513);
				BgL_evalzf31133zf3_2700 = CBOOL(BgL_evalzf31133zf3_2514);
				{	/* Effect/cgraph.scm 22 */
					BgL_globalz00_bglt BgL_new1195z00_2702;

					{	/* Effect/cgraph.scm 22 */
						BgL_globalz00_bglt BgL_tmp1193z00_2703;
						BgL_globalzf2fromzf2_bglt BgL_wide1194z00_2704;

						{
							BgL_globalz00_bglt BgL_auxz00_3489;

							{	/* Effect/cgraph.scm 22 */
								BgL_globalz00_bglt BgL_new1192z00_2705;

								BgL_new1192z00_2705 =
									((BgL_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_globalz00_bgl))));
								{	/* Effect/cgraph.scm 22 */
									long BgL_arg1579z00_2706;

									BgL_arg1579z00_2706 =
										BGL_CLASS_INDEX(BGl_globalz00zzast_varz00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1192z00_2705),
										BgL_arg1579z00_2706);
								}
								{	/* Effect/cgraph.scm 22 */
									BgL_objectz00_bglt BgL_tmpz00_3494;

									BgL_tmpz00_3494 = ((BgL_objectz00_bglt) BgL_new1192z00_2705);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3494, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1192z00_2705);
								BgL_auxz00_3489 = BgL_new1192z00_2705;
							}
							BgL_tmp1193z00_2703 = ((BgL_globalz00_bglt) BgL_auxz00_3489);
						}
						BgL_wide1194z00_2704 =
							((BgL_globalzf2fromzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_globalzf2fromzf2_bgl))));
						{	/* Effect/cgraph.scm 22 */
							obj_t BgL_auxz00_3502;
							BgL_objectz00_bglt BgL_tmpz00_3500;

							BgL_auxz00_3502 = ((obj_t) BgL_wide1194z00_2704);
							BgL_tmpz00_3500 = ((BgL_objectz00_bglt) BgL_tmp1193z00_2703);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3500, BgL_auxz00_3502);
						}
						((BgL_objectz00_bglt) BgL_tmp1193z00_2703);
						{	/* Effect/cgraph.scm 22 */
							long BgL_arg1573z00_2707;

							BgL_arg1573z00_2707 =
								BGL_CLASS_INDEX(BGl_globalzf2fromzf2zzeffect_cgraphz00);
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_tmp1193z00_2703),
								BgL_arg1573z00_2707);
						}
						BgL_new1195z00_2702 = ((BgL_globalz00_bglt) BgL_tmp1193z00_2703);
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_new1195z00_2702)))->BgL_idz00) =
						((obj_t) ((obj_t) BgL_id1120z00_2501)), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_namez00) =
						((obj_t) BgL_name1121z00_2502), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_type1122z00_2503)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_valuez00) =
						((BgL_valuez00_bglt) ((BgL_valuez00_bglt) BgL_value1123z00_2504)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_accessz00) =
						((obj_t) BgL_access1124z00_2505), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_fastzd2alphazd2) =
						((obj_t) BgL_fastzd2alpha1125zd2_2506), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_removablez00) =
						((obj_t) BgL_removable1126z00_2507), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_occurrencez00) =
						((long) BgL_occurrence1127z00_2695), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_occurrencewz00) =
						((long) BgL_occurrencew1128z00_2696), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1195z00_2702)))->BgL_userzf3zf3) =
						((bool_t) BgL_userzf31129zf3_2697), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_modulez00) =
						((obj_t) ((obj_t) BgL_module1130z00_2511)), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_importz00) =
						((obj_t) BgL_import1131z00_2512), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_evaluablezf3zf3) =
						((bool_t) BgL_evaluablezf31132zf3_2699), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_evalzf3zf3) =
						((bool_t) BgL_evalzf31133zf3_2700), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_libraryz00) =
						((obj_t) BgL_library1134z00_2515), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_pragmaz00) =
						((obj_t) BgL_pragma1135z00_2516), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_srcz00) =
						((obj_t) BgL_src1136z00_2517), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_jvmzd2typezd2namez00) =
						((obj_t) ((obj_t) BgL_jvmzd2typezd2name1137z00_2518)), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_initz00) =
						((obj_t) BgL_init1138z00_2519), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1195z00_2702)))->BgL_aliasz00) =
						((obj_t) BgL_alias1139z00_2520), BUNSPEC);
					{
						BgL_globalzf2fromzf2_bglt BgL_auxz00_3555;

						{
							obj_t BgL_auxz00_3556;

							{	/* Effect/cgraph.scm 22 */
								BgL_objectz00_bglt BgL_tmpz00_3557;

								BgL_tmpz00_3557 = ((BgL_objectz00_bglt) BgL_new1195z00_2702);
								BgL_auxz00_3556 = BGL_OBJECT_WIDENING(BgL_tmpz00_3557);
							}
							BgL_auxz00_3555 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3556);
						}
						((((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3555))->
								BgL_fromz00) = ((obj_t) BgL_from1140z00_2521), BUNSPEC);
					}
					return BgL_new1195z00_2702;
				}
			}
		}

	}



/* &lambda1605 */
	obj_t BGl_z62lambda1605z62zzeffect_cgraphz00(obj_t BgL_envz00_2522,
		obj_t BgL_oz00_2523, obj_t BgL_vz00_2524)
	{
		{	/* Effect/cgraph.scm 22 */
			{
				BgL_globalzf2fromzf2_bglt BgL_auxz00_3562;

				{
					obj_t BgL_auxz00_3563;

					{	/* Effect/cgraph.scm 22 */
						BgL_objectz00_bglt BgL_tmpz00_3564;

						BgL_tmpz00_3564 =
							((BgL_objectz00_bglt) ((BgL_globalz00_bglt) BgL_oz00_2523));
						BgL_auxz00_3563 = BGL_OBJECT_WIDENING(BgL_tmpz00_3564);
					}
					BgL_auxz00_3562 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3563);
				}
				return
					((((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3562))->
						BgL_fromz00) = ((obj_t) BgL_vz00_2524), BUNSPEC);
			}
		}

	}



/* &lambda1604 */
	obj_t BGl_z62lambda1604z62zzeffect_cgraphz00(obj_t BgL_envz00_2525,
		obj_t BgL_oz00_2526)
	{
		{	/* Effect/cgraph.scm 22 */
			{
				BgL_globalzf2fromzf2_bglt BgL_auxz00_3570;

				{
					obj_t BgL_auxz00_3571;

					{	/* Effect/cgraph.scm 22 */
						BgL_objectz00_bglt BgL_tmpz00_3572;

						BgL_tmpz00_3572 =
							((BgL_objectz00_bglt) ((BgL_globalz00_bglt) BgL_oz00_2526));
						BgL_auxz00_3571 = BGL_OBJECT_WIDENING(BgL_tmpz00_3572);
					}
					BgL_auxz00_3570 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3571);
				}
				return
					(((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3570))->BgL_fromz00);
			}
		}

	}



/* &lambda1542 */
	BgL_localz00_bglt BGl_z62lambda1542z62zzeffect_cgraphz00(obj_t
		BgL_envz00_2527, obj_t BgL_o1118z00_2528)
	{
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				long BgL_arg1543z00_2711;

				{	/* Effect/cgraph.scm 21 */
					obj_t BgL_arg1546z00_2712;

					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_arg1547z00_2713;

						{	/* Effect/cgraph.scm 21 */
							long BgL_arg1794z00_2714;

							{	/* Effect/cgraph.scm 21 */
								long BgL_arg1795z00_2715;

								BgL_arg1795z00_2715 =
									BGL_OBJECT_CLASS_NUM(
									((BgL_objectz00_bglt)
										((BgL_localz00_bglt) BgL_o1118z00_2528)));
								BgL_arg1794z00_2714 = (BgL_arg1795z00_2715 - OBJECT_TYPE);
							}
							BgL_arg1547z00_2713 =
								VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
								BgL_arg1794z00_2714);
						}
						BgL_arg1546z00_2712 =
							BGl_classzd2superzd2zz__objectz00(BgL_arg1547z00_2713);
					}
					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_tmpz00_3584;

						BgL_tmpz00_3584 = ((obj_t) BgL_arg1546z00_2712);
						BgL_arg1543z00_2711 = BGL_CLASS_INDEX(BgL_tmpz00_3584);
				}}
				BGL_OBJECT_CLASS_NUM_SET(
					((BgL_objectz00_bglt)
						((BgL_localz00_bglt) BgL_o1118z00_2528)), BgL_arg1543z00_2711);
			}
			{	/* Effect/cgraph.scm 21 */
				BgL_objectz00_bglt BgL_tmpz00_3590;

				BgL_tmpz00_3590 =
					((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1118z00_2528));
				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3590, BFALSE);
			}
			((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1118z00_2528));
			return ((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1118z00_2528));
		}

	}



/* &<@anonymous:1541> */
	obj_t BGl_z62zc3z04anonymousza31541ze3ze5zzeffect_cgraphz00(obj_t
		BgL_envz00_2529, obj_t BgL_new1117z00_2530)
	{
		{	/* Effect/cgraph.scm 21 */
			{
				BgL_localz00_bglt BgL_auxz00_3598;

				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1117z00_2530))))->BgL_idz00) =
					((obj_t) CNST_TABLE_REF(((long) 6))), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1117z00_2530))))->BgL_namez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_3606;

					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_classz00_2717;

						BgL_classz00_2717 = BGl_typez00zztype_typez00;
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL__ortest_1110z00_2718;

							BgL__ortest_1110z00_2718 = BGL_CLASS_NIL(BgL_classz00_2717);
							if (CBOOL(BgL__ortest_1110z00_2718))
								{	/* Effect/cgraph.scm 21 */
									BgL_auxz00_3606 =
										((BgL_typez00_bglt) BgL__ortest_1110z00_2718);
								}
							else
								{	/* Effect/cgraph.scm 21 */
									BgL_auxz00_3606 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2717));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1117z00_2530))))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_3606), BUNSPEC);
				}
				{
					BgL_valuez00_bglt BgL_auxz00_3616;

					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_classz00_2719;

						BgL_classz00_2719 = BGl_valuez00zzast_varz00;
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL__ortest_1110z00_2720;

							BgL__ortest_1110z00_2720 = BGL_CLASS_NIL(BgL_classz00_2719);
							if (CBOOL(BgL__ortest_1110z00_2720))
								{	/* Effect/cgraph.scm 21 */
									BgL_auxz00_3616 =
										((BgL_valuez00_bglt) BgL__ortest_1110z00_2720);
								}
							else
								{	/* Effect/cgraph.scm 21 */
									BgL_auxz00_3616 =
										((BgL_valuez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2719));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1117z00_2530))))->
							BgL_valuez00) = ((BgL_valuez00_bglt) BgL_auxz00_3616), BUNSPEC);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1117z00_2530))))->BgL_accessz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1117z00_2530))))->BgL_fastzd2alphazd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1117z00_2530))))->BgL_removablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1117z00_2530))))->BgL_occurrencez00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1117z00_2530))))->BgL_occurrencewz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1117z00_2530))))->BgL_userzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) ((BgL_localz00_bglt)
										BgL_new1117z00_2530))))->BgL_keyz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) ((BgL_localz00_bglt)
										BgL_new1117z00_2530))))->BgL_valzd2noescapezd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_localzf2fromzf2_bglt BgL_auxz00_3650;

					{
						obj_t BgL_auxz00_3651;

						{	/* Effect/cgraph.scm 21 */
							BgL_objectz00_bglt BgL_tmpz00_3652;

							BgL_tmpz00_3652 =
								((BgL_objectz00_bglt)
								((BgL_localz00_bglt) BgL_new1117z00_2530));
							BgL_auxz00_3651 = BGL_OBJECT_WIDENING(BgL_tmpz00_3652);
						}
						BgL_auxz00_3650 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_3651);
					}
					((((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_3650))->
							BgL_fromz00) = ((obj_t) BUNSPEC), BUNSPEC);
				}
				BgL_auxz00_3598 = ((BgL_localz00_bglt) BgL_new1117z00_2530);
				return ((obj_t) BgL_auxz00_3598);
			}
		}

	}



/* &lambda1533 */
	BgL_localz00_bglt BGl_z62lambda1533z62zzeffect_cgraphz00(obj_t
		BgL_envz00_2531, obj_t BgL_o1114z00_2532)
	{
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_localzf2fromzf2_bglt BgL_wide1116z00_2722;

				BgL_wide1116z00_2722 =
					((BgL_localzf2fromzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_localzf2fromzf2_bgl))));
				{	/* Effect/cgraph.scm 21 */
					obj_t BgL_auxz00_3665;
					BgL_objectz00_bglt BgL_tmpz00_3661;

					BgL_auxz00_3665 = ((obj_t) BgL_wide1116z00_2722);
					BgL_tmpz00_3661 =
						((BgL_objectz00_bglt)
						((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1114z00_2532)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3661, BgL_auxz00_3665);
				}
				((BgL_objectz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1114z00_2532)));
				{	/* Effect/cgraph.scm 21 */
					long BgL_arg1540z00_2723;

					BgL_arg1540z00_2723 =
						BGL_CLASS_INDEX(BGl_localzf2fromzf2zzeffect_cgraphz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_localz00_bglt)
								((BgL_localz00_bglt) BgL_o1114z00_2532))), BgL_arg1540z00_2723);
				}
				return
					((BgL_localz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1114z00_2532)));
			}
		}

	}



/* &lambda1528 */
	BgL_localz00_bglt BGl_z62lambda1528z62zzeffect_cgraphz00(obj_t
		BgL_envz00_2533, obj_t BgL_id1101z00_2534, obj_t BgL_name1102z00_2535,
		obj_t BgL_type1103z00_2536, obj_t BgL_value1104z00_2537,
		obj_t BgL_access1105z00_2538, obj_t BgL_fastzd2alpha1106zd2_2539,
		obj_t BgL_removable1107z00_2540, obj_t BgL_occurrence1108z00_2541,
		obj_t BgL_occurrencew1109z00_2542, obj_t BgL_userzf31110zf3_2543,
		obj_t BgL_key1111z00_2544, obj_t BgL_valzd2noescape1112zd2_2545,
		obj_t BgL_from1113z00_2546)
	{
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				long BgL_occurrence1108z00_2727;
				long BgL_occurrencew1109z00_2728;
				bool_t BgL_userzf31110zf3_2729;
				long BgL_key1111z00_2730;

				BgL_occurrence1108z00_2727 = (long) CINT(BgL_occurrence1108z00_2541);
				BgL_occurrencew1109z00_2728 = (long) CINT(BgL_occurrencew1109z00_2542);
				BgL_userzf31110zf3_2729 = CBOOL(BgL_userzf31110zf3_2543);
				BgL_key1111z00_2730 = (long) CINT(BgL_key1111z00_2544);
				{	/* Effect/cgraph.scm 21 */
					BgL_localz00_bglt BgL_new1190z00_2731;

					{	/* Effect/cgraph.scm 21 */
						BgL_localz00_bglt BgL_tmp1188z00_2732;
						BgL_localzf2fromzf2_bglt BgL_wide1189z00_2733;

						{
							BgL_localz00_bglt BgL_auxz00_3683;

							{	/* Effect/cgraph.scm 21 */
								BgL_localz00_bglt BgL_new1187z00_2734;

								BgL_new1187z00_2734 =
									((BgL_localz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_localz00_bgl))));
								{	/* Effect/cgraph.scm 21 */
									long BgL_arg1532z00_2735;

									BgL_arg1532z00_2735 =
										BGL_CLASS_INDEX(BGl_localz00zzast_varz00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1187z00_2734),
										BgL_arg1532z00_2735);
								}
								{	/* Effect/cgraph.scm 21 */
									BgL_objectz00_bglt BgL_tmpz00_3688;

									BgL_tmpz00_3688 = ((BgL_objectz00_bglt) BgL_new1187z00_2734);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3688, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1187z00_2734);
								BgL_auxz00_3683 = BgL_new1187z00_2734;
							}
							BgL_tmp1188z00_2732 = ((BgL_localz00_bglt) BgL_auxz00_3683);
						}
						BgL_wide1189z00_2733 =
							((BgL_localzf2fromzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_localzf2fromzf2_bgl))));
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_auxz00_3696;
							BgL_objectz00_bglt BgL_tmpz00_3694;

							BgL_auxz00_3696 = ((obj_t) BgL_wide1189z00_2733);
							BgL_tmpz00_3694 = ((BgL_objectz00_bglt) BgL_tmp1188z00_2732);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3694, BgL_auxz00_3696);
						}
						((BgL_objectz00_bglt) BgL_tmp1188z00_2732);
						{	/* Effect/cgraph.scm 21 */
							long BgL_arg1529z00_2736;

							BgL_arg1529z00_2736 =
								BGL_CLASS_INDEX(BGl_localzf2fromzf2zzeffect_cgraphz00);
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_tmp1188z00_2732),
								BgL_arg1529z00_2736);
						}
						BgL_new1190z00_2731 = ((BgL_localz00_bglt) BgL_tmp1188z00_2732);
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_new1190z00_2731)))->BgL_idz00) =
						((obj_t) ((obj_t) BgL_id1101z00_2534)), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_namez00) =
						((obj_t) BgL_name1102z00_2535), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_type1103z00_2536)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_valuez00) =
						((BgL_valuez00_bglt) ((BgL_valuez00_bglt) BgL_value1104z00_2537)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_accessz00) =
						((obj_t) BgL_access1105z00_2538), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_fastzd2alphazd2) =
						((obj_t) BgL_fastzd2alpha1106zd2_2539), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_removablez00) =
						((obj_t) BgL_removable1107z00_2540), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_occurrencez00) =
						((long) BgL_occurrence1108z00_2727), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_occurrencewz00) =
						((long) BgL_occurrencew1109z00_2728), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1190z00_2731)))->BgL_userzf3zf3) =
						((bool_t) BgL_userzf31110zf3_2729), BUNSPEC);
					((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
										BgL_new1190z00_2731)))->BgL_keyz00) =
						((long) BgL_key1111z00_2730), BUNSPEC);
					((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
										BgL_new1190z00_2731)))->BgL_valzd2noescapezd2) =
						((obj_t) BgL_valzd2noescape1112zd2_2545), BUNSPEC);
					{
						BgL_localzf2fromzf2_bglt BgL_auxz00_3731;

						{
							obj_t BgL_auxz00_3732;

							{	/* Effect/cgraph.scm 21 */
								BgL_objectz00_bglt BgL_tmpz00_3733;

								BgL_tmpz00_3733 = ((BgL_objectz00_bglt) BgL_new1190z00_2731);
								BgL_auxz00_3732 = BGL_OBJECT_WIDENING(BgL_tmpz00_3733);
							}
							BgL_auxz00_3731 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_3732);
						}
						((((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_3731))->
								BgL_fromz00) = ((obj_t) BgL_from1113z00_2546), BUNSPEC);
					}
					return BgL_new1190z00_2731;
				}
			}
		}

	}



/* &lambda1559 */
	obj_t BGl_z62lambda1559z62zzeffect_cgraphz00(obj_t BgL_envz00_2547,
		obj_t BgL_oz00_2548, obj_t BgL_vz00_2549)
	{
		{	/* Effect/cgraph.scm 21 */
			{
				BgL_localzf2fromzf2_bglt BgL_auxz00_3738;

				{
					obj_t BgL_auxz00_3739;

					{	/* Effect/cgraph.scm 21 */
						BgL_objectz00_bglt BgL_tmpz00_3740;

						BgL_tmpz00_3740 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_2548));
						BgL_auxz00_3739 = BGL_OBJECT_WIDENING(BgL_tmpz00_3740);
					}
					BgL_auxz00_3738 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_3739);
				}
				return
					((((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_3738))->
						BgL_fromz00) = ((obj_t) BgL_vz00_2549), BUNSPEC);
			}
		}

	}



/* &lambda1558 */
	obj_t BGl_z62lambda1558z62zzeffect_cgraphz00(obj_t BgL_envz00_2550,
		obj_t BgL_oz00_2551)
	{
		{	/* Effect/cgraph.scm 21 */
			{
				BgL_localzf2fromzf2_bglt BgL_auxz00_3746;

				{
					obj_t BgL_auxz00_3747;

					{	/* Effect/cgraph.scm 21 */
						BgL_objectz00_bglt BgL_tmpz00_3748;

						BgL_tmpz00_3748 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_2551));
						BgL_auxz00_3747 = BGL_OBJECT_WIDENING(BgL_tmpz00_3748);
					}
					BgL_auxz00_3746 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_3747);
				}
				return
					(((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_3746))->BgL_fromz00);
			}
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_proc1887z00zzeffect_cgraphz00, BGl_nodez00zzast_nodez00,
				BGl_string1888z00zzeffect_cgraphz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_proc1889z00zzeffect_cgraphz00, BGl_variablez00zzast_varz00,
				BGl_string1890z00zzeffect_cgraphz00);
		}

	}



/* &save-call!1357 */
	obj_t BGl_z62savezd2callz121357za2zzeffect_cgraphz00(obj_t BgL_envz00_2554,
		obj_t BgL_calleez00_2555, obj_t BgL_ownerz00_2556)
	{
		{	/* Effect/cgraph.scm 211 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 7)),
				BGl_string1891z00zzeffect_cgraphz00,
				((obj_t) ((BgL_variablez00_bglt) BgL_calleez00_2555)));
		}

	}



/* &call-graph!1319 */
	obj_t BGl_z62callzd2graphz121319za2zzeffect_cgraphz00(obj_t BgL_envz00_2557,
		obj_t BgL_nodez00_2558, obj_t BgL_ownerz00_2559)
	{
		{	/* Effect/cgraph.scm 38 */
			return CNST_TABLE_REF(((long) 8));
		}

	}



/* call-graph! */
	obj_t BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_nodez00_bglt
		BgL_nodez00_138, BgL_variablez00_bglt BgL_ownerz00_139)
	{
		{	/* Effect/cgraph.scm 38 */
			{	/* Effect/cgraph.scm 38 */
				obj_t BgL_method1320z00_1678;

				{	/* Effect/cgraph.scm 38 */
					obj_t BgL_res1868z00_2206;

					{	/* Effect/cgraph.scm 38 */
						long BgL_objzd2classzd2numz00_2177;

						BgL_objzd2classzd2numz00_2177 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_138));
						{	/* Effect/cgraph.scm 38 */
							obj_t BgL_arg1791z00_2178;

							BgL_arg1791z00_2178 =
								PROCEDURE_REF(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
								(int) (((long) 1)));
							{	/* Effect/cgraph.scm 38 */
								int BgL_offsetz00_2181;

								BgL_offsetz00_2181 = (int) (BgL_objzd2classzd2numz00_2177);
								{	/* Effect/cgraph.scm 38 */
									long BgL_offsetz00_2182;

									BgL_offsetz00_2182 =
										((long) (BgL_offsetz00_2181) - OBJECT_TYPE);
									{	/* Effect/cgraph.scm 38 */
										long BgL_modz00_2183;

										BgL_modz00_2183 =
											(BgL_offsetz00_2182 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Effect/cgraph.scm 38 */
											long BgL_restz00_2185;

											BgL_restz00_2185 =
												(BgL_offsetz00_2182 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Effect/cgraph.scm 38 */

												{	/* Effect/cgraph.scm 38 */
													obj_t BgL_bucketz00_2187;

													BgL_bucketz00_2187 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2178), BgL_modz00_2183);
													BgL_res1868z00_2206 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2187), BgL_restz00_2185);
					}}}}}}}}
					BgL_method1320z00_1678 = BgL_res1868z00_2206;
				}
				return
					PROCEDURE_ENTRY(BgL_method1320z00_1678) (BgL_method1320z00_1678,
					((obj_t) BgL_nodez00_138), ((obj_t) BgL_ownerz00_139), BEOA);
			}
		}

	}



/* &call-graph! */
	obj_t BGl_z62callzd2graphz12za2zzeffect_cgraphz00(obj_t BgL_envz00_2560,
		obj_t BgL_nodez00_2561, obj_t BgL_ownerz00_2562)
	{
		{	/* Effect/cgraph.scm 38 */
			return
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(
				((BgL_nodez00_bglt) BgL_nodez00_2561),
				((BgL_variablez00_bglt) BgL_ownerz00_2562));
		}

	}



/* save-call! */
	obj_t BGl_savezd2callz12zc0zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_calleez00_178, BgL_variablez00_bglt BgL_ownerz00_179)
	{
		{	/* Effect/cgraph.scm 211 */
			{	/* Effect/cgraph.scm 211 */
				obj_t BgL_method1358z00_1679;

				{	/* Effect/cgraph.scm 211 */
					obj_t BgL_res1873z00_2237;

					{	/* Effect/cgraph.scm 211 */
						long BgL_objzd2classzd2numz00_2208;

						BgL_objzd2classzd2numz00_2208 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_calleez00_178));
						{	/* Effect/cgraph.scm 211 */
							obj_t BgL_arg1791z00_2209;

							BgL_arg1791z00_2209 =
								PROCEDURE_REF(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
								(int) (((long) 1)));
							{	/* Effect/cgraph.scm 211 */
								int BgL_offsetz00_2212;

								BgL_offsetz00_2212 = (int) (BgL_objzd2classzd2numz00_2208);
								{	/* Effect/cgraph.scm 211 */
									long BgL_offsetz00_2213;

									BgL_offsetz00_2213 =
										((long) (BgL_offsetz00_2212) - OBJECT_TYPE);
									{	/* Effect/cgraph.scm 211 */
										long BgL_modz00_2214;

										BgL_modz00_2214 =
											(BgL_offsetz00_2213 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Effect/cgraph.scm 211 */
											long BgL_restz00_2216;

											BgL_restz00_2216 =
												(BgL_offsetz00_2213 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Effect/cgraph.scm 211 */

												{	/* Effect/cgraph.scm 211 */
													obj_t BgL_bucketz00_2218;

													BgL_bucketz00_2218 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2209), BgL_modz00_2214);
													BgL_res1873z00_2237 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2218), BgL_restz00_2216);
					}}}}}}}}
					BgL_method1358z00_1679 = BgL_res1873z00_2237;
				}
				return
					PROCEDURE_ENTRY(BgL_method1358z00_1679) (BgL_method1358z00_1679,
					((obj_t) BgL_calleez00_178), ((obj_t) BgL_ownerz00_179), BEOA);
			}
		}

	}



/* &save-call! */
	obj_t BGl_z62savezd2callz12za2zzeffect_cgraphz00(obj_t BgL_envz00_2563,
		obj_t BgL_calleez00_2564, obj_t BgL_ownerz00_2565)
	{
		{	/* Effect/cgraph.scm 211 */
			return
				BGl_savezd2callz12zc0zzeffect_cgraphz00(
				((BgL_variablez00_bglt) BgL_calleez00_2564),
				((BgL_variablez00_bglt) BgL_ownerz00_2565));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_sequencez00zzast_nodez00, BGl_proc1892z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_syncz00zzast_nodez00, BGl_proc1894z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_appz00zzast_nodez00, BGl_proc1895z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc1896z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_funcallz00zzast_nodez00, BGl_proc1897z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_externz00zzast_nodez00, BGl_proc1898z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_castz00zzast_nodez00, BGl_proc1899z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_setqz00zzast_nodez00, BGl_proc1900z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc1901z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_failz00zzast_nodez00, BGl_proc1902z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_switchz00zzast_nodez00, BGl_proc1903z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc1904z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc1905z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc1906z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc1907z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc1908z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc1909z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc1910z00zzeffect_cgraphz00,
				BGl_string1893z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_globalz00zzast_varz00, BGl_proc1911z00zzeffect_cgraphz00,
				BGl_string1912z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_globalzf2fromzf2zzeffect_cgraphz00,
				BGl_proc1913z00zzeffect_cgraphz00, BGl_string1912z00zzeffect_cgraphz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_localz00zzast_varz00, BGl_proc1914z00zzeffect_cgraphz00,
				BGl_string1912z00zzeffect_cgraphz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_localzf2fromzf2zzeffect_cgraphz00,
				BGl_proc1915z00zzeffect_cgraphz00, BGl_string1912z00zzeffect_cgraphz00);
		}

	}



/* &save-call!-local/fro1366 */
	obj_t BGl_z62savezd2callz12zd2localzf2fro1366z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2588, obj_t BgL_calleez00_2589, obj_t BgL_ownerz00_2590)
	{
		{	/* Effect/cgraph.scm 242 */
			{	/* Effect/cgraph.scm 244 */
				bool_t BgL_test2050z00_3853;

				{	/* Effect/cgraph.scm 244 */
					obj_t BgL_arg1786z00_2744;

					{
						BgL_localzf2fromzf2_bglt BgL_auxz00_3854;

						{
							obj_t BgL_auxz00_3855;

							{	/* Effect/cgraph.scm 244 */
								BgL_objectz00_bglt BgL_tmpz00_3856;

								BgL_tmpz00_3856 =
									((BgL_objectz00_bglt)
									((BgL_localz00_bglt) BgL_calleez00_2589));
								BgL_auxz00_3855 = BGL_OBJECT_WIDENING(BgL_tmpz00_3856);
							}
							BgL_auxz00_3854 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_3855);
						}
						BgL_arg1786z00_2744 =
							(((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_3854))->
							BgL_fromz00);
					}
					BgL_test2050z00_3853 =
						CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_ownerz00_2590,
							BgL_arg1786z00_2744));
				}
				if (BgL_test2050z00_3853)
					{	/* Effect/cgraph.scm 244 */
						return BFALSE;
					}
				else
					{
						obj_t BgL_auxz00_3871;
						BgL_localzf2fromzf2_bglt BgL_auxz00_3864;

						{	/* Effect/cgraph.scm 245 */
							obj_t BgL_arg1774z00_2745;

							{
								BgL_localzf2fromzf2_bglt BgL_auxz00_3872;

								{
									obj_t BgL_auxz00_3873;

									{	/* Effect/cgraph.scm 245 */
										BgL_objectz00_bglt BgL_tmpz00_3874;

										BgL_tmpz00_3874 =
											((BgL_objectz00_bglt)
											((BgL_localz00_bglt) BgL_calleez00_2589));
										BgL_auxz00_3873 = BGL_OBJECT_WIDENING(BgL_tmpz00_3874);
									}
									BgL_auxz00_3872 =
										((BgL_localzf2fromzf2_bglt) BgL_auxz00_3873);
								}
								BgL_arg1774z00_2745 =
									(((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_3872))->
									BgL_fromz00);
							}
							BgL_auxz00_3871 =
								MAKE_YOUNG_PAIR(BgL_ownerz00_2590, BgL_arg1774z00_2745);
						}
						{
							obj_t BgL_auxz00_3865;

							{	/* Effect/cgraph.scm 245 */
								BgL_objectz00_bglt BgL_tmpz00_3866;

								BgL_tmpz00_3866 =
									((BgL_objectz00_bglt)
									((BgL_localz00_bglt) BgL_calleez00_2589));
								BgL_auxz00_3865 = BGL_OBJECT_WIDENING(BgL_tmpz00_3866);
							}
							BgL_auxz00_3864 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_3865);
						}
						return
							((((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_3864))->
								BgL_fromz00) = ((obj_t) BgL_auxz00_3871), BUNSPEC);
					}
			}
		}

	}



/* &save-call!-local1364 */
	obj_t BGl_z62savezd2callz12zd2local1364z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2591, obj_t BgL_calleez00_2592, obj_t BgL_ownerz00_2593)
	{
		{	/* Effect/cgraph.scm 236 */
			{	/* Effect/cgraph.scm 237 */
				BgL_localz00_bglt BgL_arg1759z00_2747;

				{	/* Effect/cgraph.scm 237 */
					BgL_localzf2fromzf2_bglt BgL_wide1184z00_2748;

					BgL_wide1184z00_2748 =
						((BgL_localzf2fromzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_localzf2fromzf2_bgl))));
					{	/* Effect/cgraph.scm 237 */
						obj_t BgL_auxz00_3887;
						BgL_objectz00_bglt BgL_tmpz00_3883;

						BgL_auxz00_3887 = ((obj_t) BgL_wide1184z00_2748);
						BgL_tmpz00_3883 =
							((BgL_objectz00_bglt)
							((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_calleez00_2592)));
						BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3883, BgL_auxz00_3887);
					}
					((BgL_objectz00_bglt)
						((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_calleez00_2592)));
					{	/* Effect/cgraph.scm 237 */
						long BgL_arg1760z00_2749;

						BgL_arg1760z00_2749 =
							BGL_CLASS_INDEX(BGl_localzf2fromzf2zzeffect_cgraphz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt)
								((BgL_localz00_bglt)
									((BgL_localz00_bglt) BgL_calleez00_2592))),
							BgL_arg1760z00_2749);
					}
					((BgL_localz00_bglt)
						((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_calleez00_2592)));
				}
				{
					BgL_localzf2fromzf2_bglt BgL_auxz00_3901;

					{
						obj_t BgL_auxz00_3902;

						{	/* Effect/cgraph.scm 237 */
							BgL_objectz00_bglt BgL_tmpz00_3903;

							BgL_tmpz00_3903 =
								((BgL_objectz00_bglt)
								((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_calleez00_2592)));
							BgL_auxz00_3902 = BGL_OBJECT_WIDENING(BgL_tmpz00_3903);
						}
						BgL_auxz00_3901 = ((BgL_localzf2fromzf2_bglt) BgL_auxz00_3902);
					}
					((((BgL_localzf2fromzf2_bglt) COBJECT(BgL_auxz00_3901))->
							BgL_fromz00) = ((obj_t) BNIL), BUNSPEC);
				}
				BgL_arg1759z00_2747 =
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_calleez00_2592));
				return
					BGl_savezd2callz12zc0zzeffect_cgraphz00(
					((BgL_variablez00_bglt) BgL_arg1759z00_2747),
					((BgL_variablez00_bglt) BgL_ownerz00_2593));
			}
		}

	}



/* &save-call!-global/fr1362 */
	obj_t BGl_z62savezd2callz12zd2globalzf2fr1362z82zzeffect_cgraphz00(obj_t
		BgL_envz00_2594, obj_t BgL_calleez00_2595, obj_t BgL_ownerz00_2596)
	{
		{	/* Effect/cgraph.scm 228 */
			{	/* Effect/cgraph.scm 230 */
				bool_t BgL_test2051z00_3915;

				{	/* Effect/cgraph.scm 230 */
					obj_t BgL_arg1755z00_2751;

					{
						BgL_globalzf2fromzf2_bglt BgL_auxz00_3916;

						{
							obj_t BgL_auxz00_3917;

							{	/* Effect/cgraph.scm 230 */
								BgL_objectz00_bglt BgL_tmpz00_3918;

								BgL_tmpz00_3918 =
									((BgL_objectz00_bglt)
									((BgL_globalz00_bglt) BgL_calleez00_2595));
								BgL_auxz00_3917 = BGL_OBJECT_WIDENING(BgL_tmpz00_3918);
							}
							BgL_auxz00_3916 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3917);
						}
						BgL_arg1755z00_2751 =
							(((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3916))->
							BgL_fromz00);
					}
					BgL_test2051z00_3915 =
						CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_ownerz00_2596,
							BgL_arg1755z00_2751));
				}
				if (BgL_test2051z00_3915)
					{	/* Effect/cgraph.scm 230 */
						return BFALSE;
					}
				else
					{
						obj_t BgL_auxz00_3933;
						BgL_globalzf2fromzf2_bglt BgL_auxz00_3926;

						{	/* Effect/cgraph.scm 231 */
							obj_t BgL_arg1753z00_2752;

							{
								BgL_globalzf2fromzf2_bglt BgL_auxz00_3934;

								{
									obj_t BgL_auxz00_3935;

									{	/* Effect/cgraph.scm 231 */
										BgL_objectz00_bglt BgL_tmpz00_3936;

										BgL_tmpz00_3936 =
											((BgL_objectz00_bglt)
											((BgL_globalz00_bglt) BgL_calleez00_2595));
										BgL_auxz00_3935 = BGL_OBJECT_WIDENING(BgL_tmpz00_3936);
									}
									BgL_auxz00_3934 =
										((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3935);
								}
								BgL_arg1753z00_2752 =
									(((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3934))->
									BgL_fromz00);
							}
							BgL_auxz00_3933 =
								MAKE_YOUNG_PAIR(BgL_ownerz00_2596, BgL_arg1753z00_2752);
						}
						{
							obj_t BgL_auxz00_3927;

							{	/* Effect/cgraph.scm 231 */
								BgL_objectz00_bglt BgL_tmpz00_3928;

								BgL_tmpz00_3928 =
									((BgL_objectz00_bglt)
									((BgL_globalz00_bglt) BgL_calleez00_2595));
								BgL_auxz00_3927 = BGL_OBJECT_WIDENING(BgL_tmpz00_3928);
							}
							BgL_auxz00_3926 = ((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3927);
						}
						return
							((((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3926))->
								BgL_fromz00) = ((obj_t) BgL_auxz00_3933), BUNSPEC);
					}
			}
		}

	}



/* &save-call!-global1360 */
	obj_t BGl_z62savezd2callz12zd2global1360z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2597, obj_t BgL_calleez00_2598, obj_t BgL_ownerz00_2599)
	{
		{	/* Effect/cgraph.scm 216 */
			{	/* Effect/cgraph.scm 217 */
				BgL_valuez00_bglt BgL_funz00_2754;

				BgL_funz00_2754 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt)
								((BgL_globalz00_bglt) BgL_calleez00_2598))))->BgL_valuez00);
				{	/* Effect/cgraph.scm 218 */
					bool_t BgL_test2052z00_3947;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_2754), BGl_cfunz00zzast_varz00))
						{	/* Effect/cgraph.scm 218 */
							BgL_test2052z00_3947 = ((bool_t) 1);
						}
					else
						{	/* Effect/cgraph.scm 218 */
							if (BGl_isazf3zf3zz__objectz00(
									((obj_t) BgL_funz00_2754), BGl_sfunz00zzast_varz00))
								{	/* Effect/cgraph.scm 219 */
									BgL_test2052z00_3947 =
										(
										(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_calleez00_2598)))->
											BgL_importz00) == CNST_TABLE_REF(((long) 9)));
								}
							else
								{	/* Effect/cgraph.scm 219 */
									BgL_test2052z00_3947 = ((bool_t) 0);
								}
						}
					if (BgL_test2052z00_3947)
						{	/* Effect/cgraph.scm 218 */
							if (CBOOL(
									(((BgL_funz00_bglt) COBJECT(
												((BgL_funz00_bglt) BgL_funz00_2754)))->
										BgL_sidezd2effectzd2)))
								{	/* Effect/cgraph.scm 221 */
									return
										BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
										((BgL_variablez00_bglt) BgL_ownerz00_2599));
								}
							else
								{	/* Effect/cgraph.scm 221 */
									return BFALSE;
								}
						}
					else
						{	/* Effect/cgraph.scm 223 */
							BgL_globalz00_bglt BgL_arg1744z00_2755;

							{	/* Effect/cgraph.scm 223 */
								BgL_globalzf2fromzf2_bglt BgL_wide1178z00_2756;

								BgL_wide1178z00_2756 =
									((BgL_globalzf2fromzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_globalzf2fromzf2_bgl))));
								{	/* Effect/cgraph.scm 223 */
									obj_t BgL_auxz00_3969;
									BgL_objectz00_bglt BgL_tmpz00_3965;

									BgL_auxz00_3969 = ((obj_t) BgL_wide1178z00_2756);
									BgL_tmpz00_3965 =
										((BgL_objectz00_bglt)
										((BgL_globalz00_bglt)
											((BgL_globalz00_bglt) BgL_calleez00_2598)));
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3965, BgL_auxz00_3969);
								}
								((BgL_objectz00_bglt)
									((BgL_globalz00_bglt)
										((BgL_globalz00_bglt) BgL_calleez00_2598)));
								{	/* Effect/cgraph.scm 223 */
									long BgL_arg1746z00_2757;

									BgL_arg1746z00_2757 =
										BGL_CLASS_INDEX(BGl_globalzf2fromzf2zzeffect_cgraphz00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt)
											((BgL_globalz00_bglt)
												((BgL_globalz00_bglt) BgL_calleez00_2598))),
										BgL_arg1746z00_2757);
								}
								((BgL_globalz00_bglt)
									((BgL_globalz00_bglt)
										((BgL_globalz00_bglt) BgL_calleez00_2598)));
							}
							{
								BgL_globalzf2fromzf2_bglt BgL_auxz00_3983;

								{
									obj_t BgL_auxz00_3984;

									{	/* Effect/cgraph.scm 223 */
										BgL_objectz00_bglt BgL_tmpz00_3985;

										BgL_tmpz00_3985 =
											((BgL_objectz00_bglt)
											((BgL_globalz00_bglt)
												((BgL_globalz00_bglt) BgL_calleez00_2598)));
										BgL_auxz00_3984 = BGL_OBJECT_WIDENING(BgL_tmpz00_3985);
									}
									BgL_auxz00_3983 =
										((BgL_globalzf2fromzf2_bglt) BgL_auxz00_3984);
								}
								((((BgL_globalzf2fromzf2_bglt) COBJECT(BgL_auxz00_3983))->
										BgL_fromz00) = ((obj_t) BNIL), BUNSPEC);
							}
							BgL_arg1744z00_2755 =
								((BgL_globalz00_bglt)
								((BgL_globalz00_bglt) BgL_calleez00_2598));
							return
								BGl_savezd2callz12zc0zzeffect_cgraphz00(
								((BgL_variablez00_bglt) BgL_arg1744z00_2755),
								((BgL_variablez00_bglt) BgL_ownerz00_2599));
						}
				}
			}
		}

	}



/* &call-graph!-box-set!1356 */
	obj_t BGl_z62callzd2graphz12zd2boxzd2setz121356zb0zzeffect_cgraphz00(obj_t
		BgL_envz00_2600, obj_t BgL_nodez00_2601, obj_t BgL_ownerz00_2602)
	{
		{	/* Effect/cgraph.scm 196 */
			BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
				((BgL_variablez00_bglt) BgL_ownerz00_2602));
			{	/* Effect/cgraph.scm 199 */
				BgL_varz00_bglt BgL_arg1736z00_2759;

				BgL_arg1736z00_2759 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2601)))->BgL_varz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(
					((BgL_nodez00_bglt) BgL_arg1736z00_2759),
					((BgL_variablez00_bglt) BgL_ownerz00_2602));
			}
			{	/* Effect/cgraph.scm 200 */
				BgL_nodez00_bglt BgL_arg1737z00_2760;

				BgL_arg1737z00_2760 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2601)))->BgL_valuez00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1737z00_2760,
					((BgL_variablez00_bglt) BgL_ownerz00_2602));
			}
		}

	}



/* &call-graph!-box-ref1354 */
	obj_t BGl_z62callzd2graphz12zd2boxzd2ref1354za2zzeffect_cgraphz00(obj_t
		BgL_envz00_2603, obj_t BgL_nodez00_2604, obj_t BgL_ownerz00_2605)
	{
		{	/* Effect/cgraph.scm 188 */
			{	/* Effect/cgraph.scm 189 */
				BgL_varz00_bglt BgL_arg1735z00_2762;

				BgL_arg1735z00_2762 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nodez00_2604)))->BgL_varz00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(
					((BgL_nodez00_bglt) BgL_arg1735z00_2762),
					((BgL_variablez00_bglt) BgL_ownerz00_2605));
			}
		}

	}



/* &call-graph!-make-box1352 */
	obj_t BGl_z62callzd2graphz12zd2makezd2box1352za2zzeffect_cgraphz00(obj_t
		BgL_envz00_2606, obj_t BgL_nodez00_2607, obj_t BgL_ownerz00_2608)
	{
		{	/* Effect/cgraph.scm 182 */
			{	/* Effect/cgraph.scm 183 */
				BgL_nodez00_bglt BgL_arg1734z00_2764;

				BgL_arg1734z00_2764 =
					(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2607)))->BgL_valuez00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1734z00_2764,
					((BgL_variablez00_bglt) BgL_ownerz00_2608));
			}
		}

	}



/* &call-graph!-jump-ex-1350 */
	obj_t BGl_z62callzd2graphz12zd2jumpzd2exzd21350z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2609, obj_t BgL_nodez00_2610, obj_t BgL_ownerz00_2611)
	{
		{	/* Effect/cgraph.scm 173 */
			BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
				((BgL_variablez00_bglt) BgL_ownerz00_2611));
			{	/* Effect/cgraph.scm 176 */
				BgL_nodez00_bglt BgL_arg1732z00_2766;

				BgL_arg1732z00_2766 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2610)))->BgL_exitz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1732z00_2766,
					((BgL_variablez00_bglt) BgL_ownerz00_2611));
			}
			{	/* Effect/cgraph.scm 177 */
				BgL_nodez00_bglt BgL_arg1733z00_2767;

				BgL_arg1733z00_2767 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2610)))->BgL_valuez00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1733z00_2767,
					((BgL_variablez00_bglt) BgL_ownerz00_2611));
			}
		}

	}



/* &call-graph!-set-ex-i1348 */
	obj_t BGl_z62callzd2graphz12zd2setzd2exzd2i1348z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2612, obj_t BgL_nodez00_2613, obj_t BgL_ownerz00_2614)
	{
		{	/* Effect/cgraph.scm 165 */
			BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
				((BgL_variablez00_bglt) BgL_ownerz00_2614));
			{	/* Effect/cgraph.scm 168 */
				BgL_nodez00_bglt BgL_arg1725z00_2769;

				BgL_arg1725z00_2769 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2613)))->BgL_bodyz00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1725z00_2769,
					((BgL_variablez00_bglt) BgL_ownerz00_2614));
			}
		}

	}



/* &call-graph!-let-var1346 */
	obj_t BGl_z62callzd2graphz12zd2letzd2var1346za2zzeffect_cgraphz00(obj_t
		BgL_envz00_2615, obj_t BgL_nodez00_2616, obj_t BgL_ownerz00_2617)
	{
		{	/* Effect/cgraph.scm 155 */
			{	/* Effect/cgraph.scm 156 */
				bool_t BgL_tmpz00_4033;

				{	/* Effect/cgraph.scm 157 */
					BgL_nodez00_bglt BgL_arg1718z00_2771;

					BgL_arg1718z00_2771 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2616)))->BgL_bodyz00);
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1718z00_2771,
						((BgL_variablez00_bglt) BgL_ownerz00_2617));
				}
				{	/* Effect/cgraph.scm 158 */
					obj_t BgL_g1312z00_2772;

					BgL_g1312z00_2772 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2616)))->BgL_bindingsz00);
					{
						obj_t BgL_l1310z00_2774;

						BgL_l1310z00_2774 = BgL_g1312z00_2772;
					BgL_zc3z04anonymousza31719ze3z87_2773:
						if (PAIRP(BgL_l1310z00_2774))
							{	/* Effect/cgraph.scm 158 */
								{	/* Effect/cgraph.scm 159 */
									obj_t BgL_bindingz00_2775;

									BgL_bindingz00_2775 = CAR(BgL_l1310z00_2774);
									{	/* Effect/cgraph.scm 159 */
										obj_t BgL_arg1722z00_2776;

										BgL_arg1722z00_2776 = CDR(((obj_t) BgL_bindingz00_2775));
										BGl_callzd2graphz12zc0zzeffect_cgraphz00(
											((BgL_nodez00_bglt) BgL_arg1722z00_2776),
											((BgL_variablez00_bglt) BgL_ownerz00_2617));
									}
								}
								{
									obj_t BgL_l1310z00_4048;

									BgL_l1310z00_4048 = CDR(BgL_l1310z00_2774);
									BgL_l1310z00_2774 = BgL_l1310z00_4048;
									goto BgL_zc3z04anonymousza31719ze3z87_2773;
								}
							}
						else
							{	/* Effect/cgraph.scm 158 */
								BgL_tmpz00_4033 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_4033);
			}
		}

	}



/* &call-graph!-let-fun1344 */
	obj_t BGl_z62callzd2graphz12zd2letzd2fun1344za2zzeffect_cgraphz00(obj_t
		BgL_envz00_2618, obj_t BgL_nodez00_2619, obj_t BgL_ownerz00_2620)
	{
		{	/* Effect/cgraph.scm 145 */
			{	/* Effect/cgraph.scm 147 */
				obj_t BgL_g1309z00_2778;

				BgL_g1309z00_2778 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2619)))->BgL_localsz00);
				{
					obj_t BgL_l1307z00_2780;

					BgL_l1307z00_2780 = BgL_g1309z00_2778;
				BgL_zc3z04anonymousza31705ze3z87_2779:
					if (PAIRP(BgL_l1307z00_2780))
						{	/* Effect/cgraph.scm 147 */
							{	/* Effect/cgraph.scm 148 */
								obj_t BgL_localz00_2781;

								BgL_localz00_2781 = CAR(BgL_l1307z00_2780);
								BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(
									((BgL_variablez00_bglt) BgL_localz00_2781));
							}
							{
								obj_t BgL_l1307z00_4058;

								BgL_l1307z00_4058 = CDR(BgL_l1307z00_2780);
								BgL_l1307z00_2780 = BgL_l1307z00_4058;
								goto BgL_zc3z04anonymousza31705ze3z87_2779;
							}
						}
					else
						{	/* Effect/cgraph.scm 147 */
							((bool_t) 1);
						}
				}
			}
			{	/* Effect/cgraph.scm 150 */
				BgL_nodez00_bglt BgL_arg1717z00_2782;

				BgL_arg1717z00_2782 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2619)))->BgL_bodyz00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1717z00_2782,
					((BgL_variablez00_bglt) BgL_ownerz00_2620));
			}
		}

	}



/* &call-graph!-switch1342 */
	obj_t BGl_z62callzd2graphz12zd2switch1342z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2621, obj_t BgL_nodez00_2622, obj_t BgL_ownerz00_2623)
	{
		{	/* Effect/cgraph.scm 135 */
			{	/* Effect/cgraph.scm 136 */
				bool_t BgL_tmpz00_4064;

				{	/* Effect/cgraph.scm 137 */
					BgL_nodez00_bglt BgL_arg1697z00_2784;

					BgL_arg1697z00_2784 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2622)))->BgL_testz00);
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1697z00_2784,
						((BgL_variablez00_bglt) BgL_ownerz00_2623));
				}
				{	/* Effect/cgraph.scm 138 */
					obj_t BgL_g1306z00_2785;

					BgL_g1306z00_2785 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2622)))->BgL_clausesz00);
					{
						obj_t BgL_l1304z00_2787;

						BgL_l1304z00_2787 = BgL_g1306z00_2785;
					BgL_zc3z04anonymousza31698ze3z87_2786:
						if (PAIRP(BgL_l1304z00_2787))
							{	/* Effect/cgraph.scm 138 */
								{	/* Effect/cgraph.scm 139 */
									obj_t BgL_clausez00_2788;

									BgL_clausez00_2788 = CAR(BgL_l1304z00_2787);
									{	/* Effect/cgraph.scm 139 */
										obj_t BgL_arg1702z00_2789;

										BgL_arg1702z00_2789 = CDR(((obj_t) BgL_clausez00_2788));
										BGl_callzd2graphz12zc0zzeffect_cgraphz00(
											((BgL_nodez00_bglt) BgL_arg1702z00_2789),
											((BgL_variablez00_bglt) BgL_ownerz00_2623));
									}
								}
								{
									obj_t BgL_l1304z00_4079;

									BgL_l1304z00_4079 = CDR(BgL_l1304z00_2787);
									BgL_l1304z00_2787 = BgL_l1304z00_4079;
									goto BgL_zc3z04anonymousza31698ze3z87_2786;
								}
							}
						else
							{	/* Effect/cgraph.scm 138 */
								BgL_tmpz00_4064 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_4064);
			}
		}

	}



/* &call-graph!-fail1340 */
	obj_t BGl_z62callzd2graphz12zd2fail1340z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2624, obj_t BgL_nodez00_2625, obj_t BgL_ownerz00_2626)
	{
		{	/* Effect/cgraph.scm 125 */
			BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
				((BgL_variablez00_bglt) BgL_ownerz00_2626));
			{	/* Effect/cgraph.scm 128 */
				BgL_nodez00_bglt BgL_arg1691z00_2791;

				BgL_arg1691z00_2791 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2625)))->BgL_procz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1691z00_2791,
					((BgL_variablez00_bglt) BgL_ownerz00_2626));
			}
			{	/* Effect/cgraph.scm 129 */
				BgL_nodez00_bglt BgL_arg1695z00_2792;

				BgL_arg1695z00_2792 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2625)))->BgL_msgz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1695z00_2792,
					((BgL_variablez00_bglt) BgL_ownerz00_2626));
			}
			{	/* Effect/cgraph.scm 130 */
				BgL_nodez00_bglt BgL_arg1696z00_2793;

				BgL_arg1696z00_2793 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2625)))->BgL_objz00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1696z00_2793,
					((BgL_variablez00_bglt) BgL_ownerz00_2626));
			}
		}

	}



/* &call-graph!-conditio1338 */
	obj_t BGl_z62callzd2graphz12zd2conditio1338z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2627, obj_t BgL_nodez00_2628, obj_t BgL_ownerz00_2629)
	{
		{	/* Effect/cgraph.scm 116 */
			{	/* Effect/cgraph.scm 118 */
				BgL_nodez00_bglt BgL_arg1685z00_2795;

				BgL_arg1685z00_2795 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2628)))->BgL_testz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1685z00_2795,
					((BgL_variablez00_bglt) BgL_ownerz00_2629));
			}
			{	/* Effect/cgraph.scm 119 */
				BgL_nodez00_bglt BgL_arg1686z00_2796;

				BgL_arg1686z00_2796 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2628)))->BgL_truez00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1686z00_2796,
					((BgL_variablez00_bglt) BgL_ownerz00_2629));
			}
			{	/* Effect/cgraph.scm 120 */
				BgL_nodez00_bglt BgL_arg1690z00_2797;

				BgL_arg1690z00_2797 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2628)))->BgL_falsez00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1690z00_2797,
					((BgL_variablez00_bglt) BgL_ownerz00_2629));
			}
		}

	}



/* &call-graph!-setq1336 */
	obj_t BGl_z62callzd2graphz12zd2setq1336z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2630, obj_t BgL_nodez00_2631, obj_t BgL_ownerz00_2632)
	{
		{	/* Effect/cgraph.scm 106 */
			{	/* Effect/cgraph.scm 108 */
				bool_t BgL_test2059z00_4108;

				if (BGl_isazf3zf3zz__objectz00(BgL_ownerz00_2632,
						BGl_localz00zzast_varz00))
					{	/* Effect/cgraph.scm 108 */
						BgL_test2059z00_4108 = ((bool_t) 1);
					}
				else
					{	/* Effect/cgraph.scm 108 */
						BgL_variablez00_bglt BgL_arg1675z00_2799;

						BgL_arg1675z00_2799 =
							(((BgL_varz00_bglt) COBJECT(
									(((BgL_setqz00_bglt) COBJECT(
												((BgL_setqz00_bglt) BgL_nodez00_2631)))->BgL_varz00)))->
							BgL_variablez00);
						BgL_test2059z00_4108 =
							BGl_isazf3zf3zz__objectz00(((obj_t) BgL_arg1675z00_2799),
							BGl_globalz00zzast_varz00);
					}
				if (BgL_test2059z00_4108)
					{	/* Effect/cgraph.scm 108 */
						BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
							((BgL_variablez00_bglt) BgL_ownerz00_2632));
					}
				else
					{	/* Effect/cgraph.scm 108 */
						BFALSE;
					}
			}
			{	/* Effect/cgraph.scm 110 */
				BgL_varz00_bglt BgL_arg1679z00_2800;

				BgL_arg1679z00_2800 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2631)))->BgL_varz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(
					((BgL_nodez00_bglt) BgL_arg1679z00_2800),
					((BgL_variablez00_bglt) BgL_ownerz00_2632));
			}
			{	/* Effect/cgraph.scm 111 */
				BgL_nodez00_bglt BgL_arg1682z00_2801;

				BgL_arg1682z00_2801 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2631)))->BgL_valuez00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1682z00_2801,
					((BgL_variablez00_bglt) BgL_ownerz00_2632));
			}
		}

	}



/* &call-graph!-cast1334 */
	obj_t BGl_z62callzd2graphz12zd2cast1334z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2633, obj_t BgL_nodez00_2634, obj_t BgL_ownerz00_2635)
	{
		{	/* Effect/cgraph.scm 95 */
			{	/* Effect/cgraph.scm 97 */
				BgL_nodez00_bglt BgL_arg1662z00_2803;

				BgL_arg1662z00_2803 =
					(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nodez00_2634)))->BgL_argz00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1662z00_2803,
					((BgL_variablez00_bglt) BgL_ownerz00_2635));
			}
		}

	}



/* &call-graph!-extern1332 */
	obj_t BGl_z62callzd2graphz12zd2extern1332z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2636, obj_t BgL_nodez00_2637, obj_t BgL_ownerz00_2638)
	{
		{	/* Effect/cgraph.scm 86 */
			{	/* Effect/cgraph.scm 87 */
				bool_t BgL_tmpz00_4131;

				if (CBOOL(
						(((BgL_nodezf2effectzf2_bglt) COBJECT(
									((BgL_nodezf2effectzf2_bglt)
										((BgL_externz00_bglt) BgL_nodez00_2637))))->
							BgL_sidezd2effectzd2)))
					{	/* Effect/cgraph.scm 88 */
						BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
							((BgL_variablez00_bglt) BgL_ownerz00_2638));
					}
				else
					{	/* Effect/cgraph.scm 88 */
						BFALSE;
					}
				BgL_tmpz00_4131 =
					BGl_callzd2graphza2z12z62zzeffect_cgraphz00(
					(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt) BgL_nodez00_2637)))->BgL_exprza2za2),
					BgL_ownerz00_2638);
				return BBOOL(BgL_tmpz00_4131);
			}
		}

	}



/* &call-graph!-funcall1330 */
	obj_t BGl_z62callzd2graphz12zd2funcall1330z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2639, obj_t BgL_nodez00_2640, obj_t BgL_ownerz00_2641)
	{
		{	/* Effect/cgraph.scm 77 */
			{	/* Effect/cgraph.scm 78 */
				bool_t BgL_tmpz00_4143;

				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					((BgL_variablez00_bglt) BgL_ownerz00_2641));
				{	/* Effect/cgraph.scm 80 */
					BgL_nodez00_bglt BgL_arg1649z00_2806;

					BgL_arg1649z00_2806 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2640)))->BgL_funz00);
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1649z00_2806,
						((BgL_variablez00_bglt) BgL_ownerz00_2641));
				}
				BgL_tmpz00_4143 =
					BGl_callzd2graphza2z12z62zzeffect_cgraphz00(
					(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2640)))->BgL_argsz00),
					BgL_ownerz00_2641);
				return BBOOL(BgL_tmpz00_4143);
			}
		}

	}



/* &call-graph!-app-ly1328 */
	obj_t BGl_z62callzd2graphz12zd2appzd2ly1328za2zzeffect_cgraphz00(obj_t
		BgL_envz00_2642, obj_t BgL_nodez00_2643, obj_t BgL_ownerz00_2644)
	{
		{	/* Effect/cgraph.scm 68 */
			BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
				((BgL_variablez00_bglt) BgL_ownerz00_2644));
			{	/* Effect/cgraph.scm 71 */
				BgL_nodez00_bglt BgL_arg1645z00_2808;

				BgL_arg1645z00_2808 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2643)))->BgL_funz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1645z00_2808,
					((BgL_variablez00_bglt) BgL_ownerz00_2644));
			}
			{	/* Effect/cgraph.scm 72 */
				BgL_nodez00_bglt BgL_arg1646z00_2809;

				BgL_arg1646z00_2809 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2643)))->BgL_argz00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1646z00_2809,
					((BgL_variablez00_bglt) BgL_ownerz00_2644));
			}
		}

	}



/* &call-graph!-app1326 */
	obj_t BGl_z62callzd2graphz12zd2app1326z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2645, obj_t BgL_nodez00_2646, obj_t BgL_ownerz00_2647)
	{
		{	/* Effect/cgraph.scm 58 */
			{	/* Effect/cgraph.scm 59 */
				bool_t BgL_tmpz00_4164;

				{	/* Effect/cgraph.scm 62 */
					BgL_variablez00_bglt BgL_arg1634z00_2811;

					BgL_arg1634z00_2811 =
						(((BgL_varz00_bglt) COBJECT(
								(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nodez00_2646)))->BgL_funz00)))->
						BgL_variablez00);
					BGl_savezd2callz12zc0zzeffect_cgraphz00(BgL_arg1634z00_2811,
						((BgL_variablez00_bglt) BgL_ownerz00_2647));
				}
				BgL_tmpz00_4164 =
					BGl_callzd2graphza2z12z62zzeffect_cgraphz00(
					(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_2646)))->BgL_argsz00),
					BgL_ownerz00_2647);
				return BBOOL(BgL_tmpz00_4164);
			}
		}

	}



/* &call-graph!-sync1324 */
	obj_t BGl_z62callzd2graphz12zd2sync1324z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2648, obj_t BgL_nodez00_2649, obj_t BgL_ownerz00_2650)
	{
		{	/* Effect/cgraph.scm 50 */
			{	/* Effect/cgraph.scm 51 */
				BgL_nodez00_bglt BgL_arg1615z00_2813;

				BgL_arg1615z00_2813 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2649)))->BgL_mutexz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1615z00_2813,
					((BgL_variablez00_bglt) BgL_ownerz00_2650));
			}
			{	/* Effect/cgraph.scm 52 */
				BgL_nodez00_bglt BgL_arg1616z00_2814;

				BgL_arg1616z00_2814 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2649)))->BgL_prelockz00);
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1616z00_2814,
					((BgL_variablez00_bglt) BgL_ownerz00_2650));
			}
			{	/* Effect/cgraph.scm 53 */
				BgL_nodez00_bglt BgL_arg1633z00_2815;

				BgL_arg1633z00_2815 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2649)))->BgL_bodyz00);
				return
					BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_arg1633z00_2815,
					((BgL_variablez00_bglt) BgL_ownerz00_2650));
			}
		}

	}



/* &call-graph!-sequence1322 */
	obj_t BGl_z62callzd2graphz12zd2sequence1322z70zzeffect_cgraphz00(obj_t
		BgL_envz00_2651, obj_t BgL_nodez00_2652, obj_t BgL_ownerz00_2653)
	{
		{	/* Effect/cgraph.scm 44 */
			return
				BBOOL(BGl_callzd2graphza2z12z62zzeffect_cgraphz00(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_2652)))->BgL_nodesz00),
					BgL_ownerz00_2653));
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00()
	{
		{	/* Effect/cgraph.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1916z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1916z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string1916z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string1916z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1916z00zzeffect_cgraphz00));
			return
				BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1916z00zzeffect_cgraphz00));
		}

	}

#ifdef __cplusplus
}
#endif
