/*===========================================================================*/
/*   (Stackable/walk.scm)                                                    */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Stackable/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
		obj_t BgL_valzd2noescapezd2;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_stackablez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_appzf2depthzf2_bgl
	{
		long BgL_depthz00;
	}                     *BgL_appzf2depthzf2_bglt;

	typedef struct BgL_localzf2depthzf2_bgl
	{
		long BgL_depthz00;
		obj_t BgL_ownerz00;
	}                       *BgL_localzf2depthzf2_bglt;


	static obj_t BGl_z62lambda1765z62zzstackable_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1766z62zzstackable_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62escapez12z70zzstackable_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static BgL_appz00_bglt BGl_z62lambda1698z62zzstackable_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t
		BGl_z62depthzd2letzd2setzd2exzd2it1513z62zzstackable_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzstackable_walkz00 = BUNSPEC;
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_funz00zzast_varz00;
	static obj_t BGl_z62stackablezd2conditiona1465zb0zzstackable_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	static obj_t
		BGl_globalzd2depthzd2letz12z12zzstackable_walkz00(BgL_variablez00_bglt);
	static obj_t BGl_z62stackablezd2app1471zb0zzstackable_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_za2optimzd2stackablezf3za2z21zzengine_paramz00;
	static obj_t BGl_z62nodezd2escape1491zb0zzstackable_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	static obj_t BGl_toplevelzd2initzd2zzstackable_walkz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_nodezd2escapezd2zzstackable_walkz00(BgL_nodez00_bglt, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62stackablezd2letzd2fun1469z62zzstackable_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_localzf2depthzf2zzstackable_walkz00 = BUNSPEC;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zzstackable_walkz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl_varzd2stackablezd2zzstackable_walkz00(BgL_variablez00_bglt,
		obj_t);
	static obj_t BGl_z62stackablezd2sequence1475zb0zzstackable_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62stackablez62zzstackable_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzstackable_walkz00();
	static obj_t BGl_appzf2depthzf2zzstackable_walkz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_za2keyzd2shapezf3za2z21zzengine_paramz00;
	static obj_t
		BGl_globalzd2liftzd2letz12z12zzstackable_walkz00(BgL_variablez00_bglt);
	extern obj_t BGl_typez00zztype_typez00;
	static BgL_nodez00_bglt BGl_z62liftzd2letz12za2zzstackable_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62shapezd2localzf2depth1453z42zzstackable_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_z62initzd2stackablezb0zzstackable_walkz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_stackablez00zzstackable_walkz00(BgL_nodez00_bglt, bool_t,
		long, obj_t);
	static obj_t BGl_z62initzd2stackablezd2app1517z62zzstackable_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzstackable_walkz00();
	static BgL_nodez00_bglt
		BGl_liftzd2letz12zc0zzstackable_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static obj_t BGl_z62escapez121476z70zzstackable_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62nodezd2escapezb0zzstackable_walkz00(obj_t, obj_t, obj_t);
	static obj_t
		BGl_z62nodezd2ze3sexpzd2appzf2depth1455z73zzstackable_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62liftzd2letz12zd2letzd2var1500za2zzstackable_walkz00(obj_t, obj_t);
	static obj_t BGl_z62depthzd2letzd2letzd2fun1509zb0zzstackable_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_initzd2stackablezd2zzstackable_walkz00(BgL_nodez00_bglt);
	static bool_t BGl_liftablezf3ze70z14zzstackable_walkz00(obj_t);
	static obj_t BGl_escapez12z12zzstackable_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_append2(obj_t, obj_t);
	static obj_t BGl_z62stackable1456z62zzstackable_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62stackablezd2letzd2var1467z62zzstackable_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_walk0z00zzast_walkz00(BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_walk1z00zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t);
	extern obj_t BGl_walk2z00zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t);
	extern obj_t BGl_walk3z00zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62escapez12zd2closure1490za2zzstackable_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62stackablezd2funcall1473zb0zzstackable_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzstackable_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_occurz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	static obj_t BGl_z62escapez12zd2local1481za2zzstackable_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62depthzd2letzd2var1505z62zzstackable_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62depthzd2let1501zb0zzstackable_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31705ze3ze5zzstackable_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_tprintz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62stackablezd2closure1461zb0zzstackable_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzstackable_walkz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzstackable_walkz00();
	static obj_t BGl_z62initzd2stackable1514zb0zzstackable_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzstackable_walkz00();
	static obj_t BGl_gczd2rootszd2initz00zzstackable_walkz00();
	static obj_t BGl_zc3z04anonymousza32043ze3ze70z60zzstackable_walkz00(obj_t);
	static obj_t BGl_z62liftzd2letz121497za2zzstackable_walkz00(obj_t, obj_t);
	static obj_t
		BGl_z62nodezd2escapezd2makezd2box1496zb0zzstackable_walkz00(obj_t, obj_t,
		obj_t);
	extern BgL_nodez00_bglt BGl_walk0z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_stackablezd2walkz12zc0zzstackable_walkz00(obj_t);
	static obj_t BGl_z62stackablezd2walkz12za2zzstackable_walkz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_walk1z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t);
	static obj_t BGl_z62escapez12zd2global1479za2zzstackable_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62depthzd2letzb0zzstackable_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62depthzd2letzd2app1511z62zzstackable_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31742ze3ze5zzstackable_walkz00(obj_t,
		obj_t);
	static BgL_appz00_bglt BGl_z62lambda1703z62zzstackable_walkz00(obj_t, obj_t);
	static BgL_appz00_bglt BGl_z62lambda1706z62zzstackable_walkz00(obj_t, obj_t);
	static obj_t BGl_z62escapez12zd2node1483za2zzstackable_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	extern obj_t BGl_valuez00zzast_varz00;
	static obj_t BGl_z62depthzd2letzd2letzd2var1507zb0zzstackable_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62initzd2stackablezd2closu1521z62zzstackable_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1722z62zzstackable_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1723z62zzstackable_walkz00(obj_t, obj_t, obj_t);
	static obj_t
		BGl_callzd2nextzd2methodze70ze7zzstackable_walkz00(BgL_localz00_bglt);
	static obj_t BGl_depthzd2letzd2zzstackable_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t);
	static obj_t BGl_z62nodezd2escapezd2app1494z62zzstackable_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_localz00_bglt BGl_z62lambda1736z62zzstackable_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62stackablezd2var1459zb0zzstackable_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t
		BGl_z62initzd2stackablezd2makezd21519zb0zzstackable_walkz00(obj_t, obj_t);
	static obj_t BGl_z62stackablezd2setq1463zb0zzstackable_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static BgL_localz00_bglt BGl_z62lambda1740z62zzstackable_walkz00(obj_t,
		obj_t);
	static BgL_localz00_bglt BGl_z62lambda1743z62zzstackable_walkz00(obj_t,
		obj_t);
	static bool_t BGl_importzf3zf3zzstackable_walkz00(BgL_variablez00_bglt);
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_z62escapez12zd2app1486za2zzstackable_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62lambda1756z62zzstackable_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1757z62zzstackable_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62escapez12zd2makezd2box1488z70zzstackable_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t __cnst[10];


	   
		 
		DEFINE_STRING(BGl_string2306z00zzstackable_walkz00,
		BgL_bgl_string2306za700za7za7s2338za7, "escape!", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2300z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2l2339z00,
		BGl_z62stackablezd2letzd2var1467z62zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2301z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2l2340z00,
		BGl_z62stackablezd2letzd2fun1469z62zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2302z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2a2341z00,
		BGl_z62stackablezd2app1471zb0zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2303z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2f2342z00,
		BGl_z62stackablezd2funcall1473zb0zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2304z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2s2343z00,
		BGl_z62stackablezd2sequence1475zb0zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2305z00zzstackable_walkz00,
		BgL_bgl_za762escapeza712za7d2g2344za7,
		BGl_z62escapez12zd2global1479za2zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2312z00zzstackable_walkz00,
		BgL_bgl_string2312za700za7za7s2345za7, "escape!::node", 13);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2307z00zzstackable_walkz00,
		BgL_bgl_za762escapeza712za7d2l2346za7,
		BGl_z62escapez12zd2local1481za2zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2314z00zzstackable_walkz00,
		BgL_bgl_string2314za700za7za7s2347za7, "node-escape", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2308z00zzstackable_walkz00,
		BgL_bgl_za762escapeza712za7d2n2348za7,
		BGl_z62escapez12zd2node1483za2zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2309z00zzstackable_walkz00,
		BgL_bgl_za762escapeza712za7d2a2349za7,
		BGl_z62escapez12zd2app1486za2zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2317z00zzstackable_walkz00,
		BgL_bgl_string2317za700za7za7s2350za7, "lift-let!::node", 15);
	      DEFINE_STRING(BGl_string2319z00zzstackable_walkz00,
		BgL_bgl_string2319za700za7za7s2351za7, "depth-let", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2310z00zzstackable_walkz00,
		BgL_bgl_za762escapeza712za7d2m2352za7,
		BGl_z62escapez12zd2makezd2box1488z70zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2311z00zzstackable_walkz00,
		BgL_bgl_za762escapeza712za7d2c2353za7,
		BGl_z62escapez12zd2closure1490za2zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2313z00zzstackable_walkz00,
		BgL_bgl_za762nodeza7d2escape2354z00,
		BGl_z62nodezd2escapezd2app1494z62zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2315z00zzstackable_walkz00,
		BgL_bgl_za762nodeza7d2escape2355z00,
		BGl_z62nodezd2escapezd2makezd2box1496zb0zzstackable_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2316z00zzstackable_walkz00,
		BgL_bgl_za762liftza7d2letza7122356za7,
		BGl_z62liftzd2letz12zd2letzd2var1500za2zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2318z00zzstackable_walkz00,
		BgL_bgl_za762depthza7d2letza7d2357za7,
		BGl_z62depthzd2letzd2var1505z62zzstackable_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2325z00zzstackable_walkz00,
		BgL_bgl_string2325za700za7za7s2358za7, "init-stackable", 14);
	      DEFINE_STRING(BGl_string2328z00zzstackable_walkz00,
		BgL_bgl_string2328za700za7za7s2359za7, "\n", 1);
	      DEFINE_STRING(BGl_string2329z00zzstackable_walkz00,
		BgL_bgl_string2329za700za7za7s2360za7, " ", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2320z00zzstackable_walkz00,
		BgL_bgl_za762depthza7d2letza7d2361za7,
		BGl_z62depthzd2letzd2letzd2var1507zb0zzstackable_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2321z00zzstackable_walkz00,
		BgL_bgl_za762depthza7d2letza7d2362za7,
		BGl_z62depthzd2letzd2letzd2fun1509zb0zzstackable_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2322z00zzstackable_walkz00,
		BgL_bgl_za762depthza7d2letza7d2363za7,
		BGl_z62depthzd2letzd2app1511z62zzstackable_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2323z00zzstackable_walkz00,
		BgL_bgl_za762depthza7d2letza7d2364za7,
		BGl_z62depthzd2letzd2setzd2exzd2it1513z62zzstackable_walkz00, 0L, BUNSPEC,
		3);
	      DEFINE_STRING(BGl_string2330z00zzstackable_walkz00,
		BgL_bgl_string2330za700za7za7s2365za7, "<-", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2324z00zzstackable_walkz00,
		BgL_bgl_za762initza7d2stacka2366z00,
		BGl_z62initzd2stackablezd2app1517z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2331z00zzstackable_walkz00,
		BgL_bgl_string2331za700za7za7s2367za7, "      lifting binding ", 22);
	      DEFINE_STRING(BGl_string2332z00zzstackable_walkz00,
		BgL_bgl_string2332za700za7za7s2368za7, "[~a]", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2326z00zzstackable_walkz00,
		BgL_bgl_za762initza7d2stacka2369z00,
		BGl_z62initzd2stackablezd2makezd21519zb0zzstackable_walkz00, 0L, BUNSPEC,
		1);
	      DEFINE_STRING(BGl_string2333z00zzstackable_walkz00,
		BgL_bgl_string2333za700za7za7s2370za7, "[~a]~a", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2327z00zzstackable_walkz00,
		BgL_bgl_za762initza7d2stacka2371z00,
		BGl_z62initzd2stackablezd2closu1521z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2334z00zzstackable_walkz00,
		BgL_bgl_string2334za700za7za7s2372za7, "stackable_walk", 14);
	      DEFINE_STRING(BGl_string2253z00zzstackable_walkz00,
		BgL_bgl_string2253za700za7za7s2373za7, "Stackable", 9);
	      DEFINE_STRING(BGl_string2335z00zzstackable_walkz00,
		BgL_bgl_string2335za700za7za7s2374za7,
		"* _ local/depth obj owner stackable_walk app/depth long depth pass-started ",
		75);
	      DEFINE_STRING(BGl_string2254z00zzstackable_walkz00,
		BgL_bgl_string2254za700za7za7s2375za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2255z00zzstackable_walkz00,
		BgL_bgl_string2255za700za7za7s2376za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2256z00zzstackable_walkz00,
		BgL_bgl_string2256za700za7za7s2377za7, " error", 6);
	      DEFINE_STRING(BGl_string2257z00zzstackable_walkz00,
		BgL_bgl_string2257za700za7za7s2378za7, "s", 1);
	      DEFINE_STRING(BGl_string2258z00zzstackable_walkz00,
		BgL_bgl_string2258za700za7za7s2379za7, "", 0);
	      DEFINE_STRING(BGl_string2259z00zzstackable_walkz00,
		BgL_bgl_string2259za700za7za7s2380za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string2260z00zzstackable_walkz00,
		BgL_bgl_string2260za700za7za7s2381za7, "failure during postlude hook", 28);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2261z00zzstackable_walkz00,
		BgL_bgl_za762lambda1723za7622382z00,
		BGl_z62lambda1723z62zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2262z00zzstackable_walkz00,
		BgL_bgl_za762lambda1722za7622383z00,
		BGl_z62lambda1722z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2263z00zzstackable_walkz00,
		BgL_bgl_za762lambda1706za7622384z00,
		BGl_z62lambda1706z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2264z00zzstackable_walkz00,
		BgL_bgl_za762za7c3za704anonymo2385za7,
		BGl_z62zc3z04anonymousza31705ze3ze5zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2265z00zzstackable_walkz00,
		BgL_bgl_za762lambda1703za7622386z00,
		BGl_z62lambda1703z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2266z00zzstackable_walkz00,
		BgL_bgl_za762lambda1698za7622387z00,
		BGl_z62lambda1698z62zzstackable_walkz00, 0L, BUNSPEC, 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2267z00zzstackable_walkz00,
		BgL_bgl_za762lambda1757za7622388z00,
		BGl_z62lambda1757z62zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2268z00zzstackable_walkz00,
		BgL_bgl_za762lambda1756za7622389z00,
		BGl_z62lambda1756z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2269z00zzstackable_walkz00,
		BgL_bgl_za762lambda1766za7622390z00,
		BGl_z62lambda1766z62zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2276z00zzstackable_walkz00,
		BgL_bgl_string2276za700za7za7s2391za7, "stackable1456", 13);
	      DEFINE_STRING(BGl_string2278z00zzstackable_walkz00,
		BgL_bgl_string2278za700za7za7s2392za7, "escape!1476", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2270z00zzstackable_walkz00,
		BgL_bgl_za762lambda1765za7622393z00,
		BGl_z62lambda1765z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2271z00zzstackable_walkz00,
		BgL_bgl_za762lambda1743za7622394z00,
		BGl_z62lambda1743z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2272z00zzstackable_walkz00,
		BgL_bgl_za762za7c3za704anonymo2395za7,
		BGl_z62zc3z04anonymousza31742ze3ze5zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2273z00zzstackable_walkz00,
		BgL_bgl_za762lambda1740za7622396z00,
		BGl_z62lambda1740z62zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2280z00zzstackable_walkz00,
		BgL_bgl_string2280za700za7za7s2397za7, "node-escape1491", 15);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2274z00zzstackable_walkz00,
		BgL_bgl_za762lambda1736za7622398z00,
		BGl_z62lambda1736z62zzstackable_walkz00, 0L, BUNSPEC, 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2275z00zzstackable_walkz00,
		BgL_bgl_za762stackable14562399za7,
		BGl_z62stackable1456z62zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2282z00zzstackable_walkz00,
		BgL_bgl_string2282za700za7za7s2400za7, "lift-let!1497", 13);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2277z00zzstackable_walkz00,
		BgL_bgl_za762escapeza71214762401z00,
		BGl_z62escapez121476z70zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2284z00zzstackable_walkz00,
		BgL_bgl_string2284za700za7za7s2402za7, "depth-let1501", 13);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2279z00zzstackable_walkz00,
		BgL_bgl_za762nodeza7d2escape2403z00,
		BGl_z62nodezd2escape1491zb0zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2286z00zzstackable_walkz00,
		BgL_bgl_string2286za700za7za7s2404za7, "init-stackable1514", 18);
	      DEFINE_STRING(BGl_string2287z00zzstackable_walkz00,
		BgL_bgl_string2287za700za7za7s2405za7, "ESCAPE! should not be here ", 27);
	      DEFINE_STRING(BGl_string2288z00zzstackable_walkz00,
		BgL_bgl_string2288za700za7za7s2406za7, ":", 1);
	      DEFINE_STRING(BGl_string2289z00zzstackable_walkz00,
		BgL_bgl_string2289za700za7za7s2407za7, ",", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2281z00zzstackable_walkz00,
		BgL_bgl_za762liftza7d2letza7122408za7,
		BGl_z62liftzd2letz121497za2zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2283z00zzstackable_walkz00,
		BgL_bgl_za762depthza7d2let152409z00,
		BGl_z62depthzd2let1501zb0zzstackable_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2290z00zzstackable_walkz00,
		BgL_bgl_string2290za700za7za7s2410za7, "Stackable/walk.scm", 18);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2285z00zzstackable_walkz00,
		BgL_bgl_za762initza7d2stacka2411z00,
		BGl_z62initzd2stackable1514zb0zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2292z00zzstackable_walkz00,
		BgL_bgl_string2292za700za7za7s2412za7, "shape", 5);
	      DEFINE_STRING(BGl_string2294z00zzstackable_walkz00,
		BgL_bgl_string2294za700za7za7s2413za7, "node->sexp", 10);
	      DEFINE_STRING(BGl_string2296z00zzstackable_walkz00,
		BgL_bgl_string2296za700za7za7s2414za7, "stackable", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2291z00zzstackable_walkz00,
		BgL_bgl_za762shapeza7d2local2415z00,
		BGl_z62shapezd2localzf2depth1453z42zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2293z00zzstackable_walkz00,
		BgL_bgl_za762nodeza7d2za7e3sex2416za7,
		BGl_z62nodezd2ze3sexpzd2appzf2depth1455z73zzstackable_walkz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2295z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2v2417z00,
		BGl_z62stackablezd2var1459zb0zzstackable_walkz00, 0L, BUNSPEC, 4);
	extern obj_t BGl_shapezd2envzd2zztools_shapez00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2297z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2c2418z00,
		BGl_z62stackablezd2closure1461zb0zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2298z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2s2419z00,
		BGl_z62stackablezd2setq1463zb0zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2299z00zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2c2420z00,
		BGl_z62stackablezd2conditiona1465zb0zzstackable_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_GENERIC(BGl_stackablezd2envzd2zzstackable_walkz00,
		BgL_bgl_za762stackableza762za72421za7,
		BGl_z62stackablez62zzstackable_walkz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_stackablezd2walkz12zd2envz12zzstackable_walkz00,
		BgL_bgl_za762stackableza7d2w2422z00,
		BGl_z62stackablezd2walkz12za2zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_liftzd2letz12zd2envz12zzstackable_walkz00,
		BgL_bgl_za762liftza7d2letza7122423za7,
		BGl_z62liftzd2letz12za2zzstackable_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_nodezd2escapezd2envz00zzstackable_walkz00,
		BgL_bgl_za762nodeza7d2escape2424z00,
		BGl_z62nodezd2escapezb0zzstackable_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_GENERIC(BGl_depthzd2letzd2envz00zzstackable_walkz00,
		BgL_bgl_za762depthza7d2letza7b2425za7,
		BGl_z62depthzd2letzb0zzstackable_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_GENERIC(BGl_escapez12zd2envzc0zzstackable_walkz00,
		BgL_bgl_za762escapeza712za770za72426z00,
		BGl_z62escapez12z70zzstackable_walkz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_initzd2stackablezd2envz00zzstackable_walkz00,
		BgL_bgl_za762initza7d2stacka2427z00,
		BGl_z62initzd2stackablezb0zzstackable_walkz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_nodezd2ze3sexpzd2envze3zzast_dumpz00;

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzstackable_walkz00));
		     ADD_ROOT((void *) (&BGl_localzf2depthzf2zzstackable_walkz00));
		     ADD_ROOT((void *) (&BGl_appzf2depthzf2zzstackable_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzstackable_walkz00(long
		BgL_checksumz00_4100, char *BgL_fromz00_4101)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzstackable_walkz00))
				{
					BGl_requirezd2initializa7ationz75zzstackable_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzstackable_walkz00();
					BGl_libraryzd2moduleszd2initz00zzstackable_walkz00();
					BGl_cnstzd2initzd2zzstackable_walkz00();
					BGl_importedzd2moduleszd2initz00zzstackable_walkz00();
					BGl_objectzd2initzd2zzstackable_walkz00();
					BGl_genericzd2initzd2zzstackable_walkz00();
					BGl_methodzd2initzd2zzstackable_walkz00();
					return BGl_toplevelzd2initzd2zzstackable_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzstackable_walkz00()
	{
		{	/* Stackable/walk.scm 16 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "stackable_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"stackable_walk");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0),
				"stackable_walk");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzstackable_walkz00()
	{
		{	/* Stackable/walk.scm 16 */
			{	/* Stackable/walk.scm 16 */
				obj_t BgL_cportz00_3820;

				{	/* Stackable/walk.scm 16 */
					obj_t BgL_stringz00_3828;

					BgL_stringz00_3828 = BGl_string2335z00zzstackable_walkz00;
					{	/* Stackable/walk.scm 16 */
						obj_t BgL_startz00_3829;

						BgL_startz00_3829 = BINT(((long) 0));
						{	/* Stackable/walk.scm 16 */
							obj_t BgL_endz00_3830;

							BgL_endz00_3830 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_3828)));
							{	/* Stackable/walk.scm 16 */

								BgL_cportz00_3820 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_3828, BgL_startz00_3829, BgL_endz00_3830);
				}}}}
				{
					long BgL_iz00_3821;

					BgL_iz00_3821 = ((long) 9);
				BgL_loopz00_3822:
					if ((BgL_iz00_3821 == ((long) -1)))
						{	/* Stackable/walk.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Stackable/walk.scm 16 */
							{	/* Stackable/walk.scm 16 */
								obj_t BgL_arg2337z00_3824;

								{	/* Stackable/walk.scm 16 */

									{	/* Stackable/walk.scm 16 */
										obj_t BgL_locationz00_3826;

										BgL_locationz00_3826 = BBOOL(((bool_t) 0));
										{	/* Stackable/walk.scm 16 */

											BgL_arg2337z00_3824 =
												BGl_readz00zz__readerz00(BgL_cportz00_3820,
												BgL_locationz00_3826);
										}
									}
								}
								{	/* Stackable/walk.scm 16 */
									int BgL_tmpz00_4135;

									BgL_tmpz00_4135 = (int) (BgL_iz00_3821);
									CNST_TABLE_SET(BgL_tmpz00_4135, BgL_arg2337z00_3824);
							}}
							{	/* Stackable/walk.scm 16 */
								int BgL_auxz00_3827;

								BgL_auxz00_3827 = (int) ((BgL_iz00_3821 - ((long) 1)));
								{
									long BgL_iz00_4140;

									BgL_iz00_4140 = (long) (BgL_auxz00_3827);
									BgL_iz00_3821 = BgL_iz00_4140;
									goto BgL_loopz00_3822;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzstackable_walkz00()
	{
		{	/* Stackable/walk.scm 16 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzstackable_walkz00()
	{
		{	/* Stackable/walk.scm 16 */
			return BUNSPEC;
		}

	}



/* stackable-walk! */
	BGL_EXPORTED_DEF obj_t BGl_stackablezd2walkz12zc0zzstackable_walkz00(obj_t
		BgL_globalsz00_19)
	{
		{	/* Stackable/walk.scm 68 */
			if (CBOOL(BGl_za2optimzd2stackablezf3za2z21zzengine_paramz00))
				{	/* Stackable/walk.scm 69 */
					{	/* Stackable/walk.scm 71 */
						obj_t BgL_list1543z00_1693;

						{	/* Stackable/walk.scm 71 */
							obj_t BgL_arg1546z00_1694;

							{	/* Stackable/walk.scm 71 */
								obj_t BgL_arg1547z00_1695;

								BgL_arg1547z00_1695 =
									MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
								BgL_arg1546z00_1694 =
									MAKE_YOUNG_PAIR(BGl_string2253z00zzstackable_walkz00,
									BgL_arg1547z00_1695);
							}
							BgL_list1543z00_1693 =
								MAKE_YOUNG_PAIR(BGl_string2254z00zzstackable_walkz00,
								BgL_arg1546z00_1694);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list1543z00_1693);
					}
					BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 =
						BINT(((long) 0));
					BGl_za2currentzd2passza2zd2zzengine_passz00 =
						BGl_string2253z00zzstackable_walkz00;
					{	/* Stackable/walk.scm 71 */
						obj_t BgL_g1163z00_1696;

						BgL_g1163z00_1696 = BNIL;
						{
							obj_t BgL_hooksz00_1699;
							obj_t BgL_hnamesz00_1700;

							BgL_hooksz00_1699 = BgL_g1163z00_1696;
							BgL_hnamesz00_1700 = BNIL;
						BgL_zc3z04anonymousza31548ze3z87_1701:
							if (NULLP(BgL_hooksz00_1699))
								{	/* Stackable/walk.scm 71 */
									CNST_TABLE_REF(((long) 0));
								}
							else
								{	/* Stackable/walk.scm 71 */
									bool_t BgL_test2432z00_4155;

									{	/* Stackable/walk.scm 71 */
										obj_t BgL_fun1559z00_1708;

										BgL_fun1559z00_1708 = CAR(((obj_t) BgL_hooksz00_1699));
										BgL_test2432z00_4155 =
											CBOOL(PROCEDURE_ENTRY(BgL_fun1559z00_1708)
											(BgL_fun1559z00_1708, BEOA));
									}
									if (BgL_test2432z00_4155)
										{	/* Stackable/walk.scm 71 */
											obj_t BgL_arg1555z00_1705;
											obj_t BgL_arg1557z00_1706;

											BgL_arg1555z00_1705 = CDR(((obj_t) BgL_hooksz00_1699));
											BgL_arg1557z00_1706 = CDR(((obj_t) BgL_hnamesz00_1700));
											{
												obj_t BgL_hnamesz00_4167;
												obj_t BgL_hooksz00_4166;

												BgL_hooksz00_4166 = BgL_arg1555z00_1705;
												BgL_hnamesz00_4167 = BgL_arg1557z00_1706;
												BgL_hnamesz00_1700 = BgL_hnamesz00_4167;
												BgL_hooksz00_1699 = BgL_hooksz00_4166;
												goto BgL_zc3z04anonymousza31548ze3z87_1701;
											}
										}
									else
										{	/* Stackable/walk.scm 71 */
											obj_t BgL_arg1558z00_1707;

											BgL_arg1558z00_1707 = CAR(((obj_t) BgL_hnamesz00_1700));
											BGl_internalzd2errorzd2zztools_errorz00
												(BGl_string2253z00zzstackable_walkz00,
												BGl_string2255z00zzstackable_walkz00,
												BgL_arg1558z00_1707);
										}
								}
						}
					}
					{
						obj_t BgL_l1390z00_1712;

						BgL_l1390z00_1712 = BgL_globalsz00_19;
					BgL_zc3z04anonymousza31561ze3z87_1713:
						if (PAIRP(BgL_l1390z00_1712))
							{	/* Stackable/walk.scm 72 */
								{	/* Stackable/walk.scm 72 */
									obj_t BgL_arg1563z00_1715;

									BgL_arg1563z00_1715 = CAR(BgL_l1390z00_1712);
									BGl_globalzd2liftzd2letz12z12zzstackable_walkz00(
										((BgL_variablez00_bglt) BgL_arg1563z00_1715));
								}
								{
									obj_t BgL_l1390z00_4176;

									BgL_l1390z00_4176 = CDR(BgL_l1390z00_1712);
									BgL_l1390z00_1712 = BgL_l1390z00_4176;
									goto BgL_zc3z04anonymousza31561ze3z87_1713;
								}
							}
						else
							{	/* Stackable/walk.scm 72 */
								((bool_t) 1);
							}
					}
					{
						obj_t BgL_l1392z00_1719;

						BgL_l1392z00_1719 = BgL_globalsz00_19;
					BgL_zc3z04anonymousza31569ze3z87_1720:
						if (PAIRP(BgL_l1392z00_1719))
							{	/* Stackable/walk.scm 73 */
								{	/* Stackable/walk.scm 73 */
									obj_t BgL_arg1571z00_1722;

									BgL_arg1571z00_1722 = CAR(BgL_l1392z00_1719);
									BGl_globalzd2depthzd2letz12z12zzstackable_walkz00(
										((BgL_variablez00_bglt) BgL_arg1571z00_1722));
								}
								{
									obj_t BgL_l1392z00_4183;

									BgL_l1392z00_4183 = CDR(BgL_l1392z00_1719);
									BgL_l1392z00_1719 = BgL_l1392z00_4183;
									goto BgL_zc3z04anonymousza31569ze3z87_1720;
								}
							}
						else
							{	/* Stackable/walk.scm 73 */
								((bool_t) 1);
							}
					}
					{
						obj_t BgL_l1394z00_1726;

						BgL_l1394z00_1726 = BgL_globalsz00_19;
					BgL_zc3z04anonymousza31574ze3z87_1727:
						if (PAIRP(BgL_l1394z00_1726))
							{	/* Stackable/walk.scm 74 */
								{	/* Stackable/walk.scm 74 */
									obj_t BgL_arg1579z00_1729;

									BgL_arg1579z00_1729 = CAR(BgL_l1394z00_1726);
									{	/* Stackable/walk.scm 528 */
										BgL_sfunz00_bglt BgL_i1254z00_3135;

										BgL_i1254z00_3135 =
											((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt) BgL_arg1579z00_1729)))->
												BgL_valuez00));
										{	/* Stackable/walk.scm 529 */
											obj_t BgL_arg1685z00_3136;

											BgL_arg1685z00_3136 =
												(((BgL_sfunz00_bglt) COBJECT(BgL_i1254z00_3135))->
												BgL_bodyz00);
											BGl_initzd2stackablezd2zzstackable_walkz00((
													(BgL_nodez00_bglt) BgL_arg1685z00_3136));
										}
									}
								}
								{
									obj_t BgL_l1394z00_4194;

									BgL_l1394z00_4194 = CDR(BgL_l1394z00_1726);
									BgL_l1394z00_1726 = BgL_l1394z00_4194;
									goto BgL_zc3z04anonymousza31574ze3z87_1727;
								}
							}
						else
							{	/* Stackable/walk.scm 74 */
								((bool_t) 1);
							}
					}
					{	/* Stackable/walk.scm 75 */
						obj_t BgL_g1165z00_1732;

						BgL_g1165z00_1732 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
						{
							obj_t BgL_ctxz00_1734;

							BgL_ctxz00_1734 = BgL_g1165z00_1732;
						BgL_zc3z04anonymousza31581ze3z87_1735:
							if (CBOOL(CAR(BgL_ctxz00_1734)))
								{	/* Stackable/walk.scm 76 */
									((bool_t) 0);
								}
							else
								{	/* Stackable/walk.scm 76 */
									SET_CAR(BgL_ctxz00_1734, BTRUE);
									SET_CDR(BgL_ctxz00_1734, BNIL);
									{
										obj_t BgL_l1396z00_1738;

										BgL_l1396z00_1738 = BgL_globalsz00_19;
									BgL_zc3z04anonymousza31583ze3z87_1739:
										if (PAIRP(BgL_l1396z00_1738))
											{	/* Stackable/walk.scm 79 */
												{	/* Stackable/walk.scm 79 */
													obj_t BgL_gz00_1741;

													BgL_gz00_1741 = CAR(BgL_l1396z00_1738);
													BGl_varzd2stackablezd2zzstackable_walkz00(
														((BgL_variablez00_bglt) BgL_gz00_1741),
														BgL_ctxz00_1734);
												}
												{
													obj_t BgL_l1396z00_4207;

													BgL_l1396z00_4207 = CDR(BgL_l1396z00_1738);
													BgL_l1396z00_1738 = BgL_l1396z00_4207;
													goto BgL_zc3z04anonymousza31583ze3z87_1739;
												}
											}
										else
											{	/* Stackable/walk.scm 79 */
												((bool_t) 1);
											}
									}
									{

										goto BgL_zc3z04anonymousza31581ze3z87_1735;
									}
								}
						}
					}
					if (
						((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
							((long) 0)))
						{	/* Stackable/walk.scm 81 */
							{	/* Stackable/walk.scm 81 */
								obj_t BgL_port1398z00_1747;

								{	/* Stackable/walk.scm 81 */
									obj_t BgL_tmpz00_4212;

									BgL_tmpz00_4212 = BGL_CURRENT_DYNAMIC_ENV();
									BgL_port1398z00_1747 =
										BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_4212);
								}
								bgl_display_obj
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
									BgL_port1398z00_1747);
								bgl_display_string(BGl_string2256z00zzstackable_walkz00,
									BgL_port1398z00_1747);
								{	/* Stackable/walk.scm 81 */
									obj_t BgL_arg1599z00_1748;

									{	/* Stackable/walk.scm 81 */
										bool_t BgL_test2439z00_4217;

										if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Stackable/walk.scm 81 */
												if (INTEGERP
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
													{	/* Stackable/walk.scm 81 */
														BgL_test2439z00_4217 =
															(
															(long)
															CINT
															(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
															> ((long) 1));
													}
												else
													{	/* Stackable/walk.scm 81 */
														BgL_test2439z00_4217 =
															BGl_2ze3ze3zz__r4_numbers_6_5z00
															(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
															BINT(((long) 1)));
											}}
										else
											{	/* Stackable/walk.scm 81 */
												BgL_test2439z00_4217 = ((bool_t) 0);
											}
										if (BgL_test2439z00_4217)
											{	/* Stackable/walk.scm 81 */
												BgL_arg1599z00_1748 =
													BGl_string2257z00zzstackable_walkz00;
											}
										else
											{	/* Stackable/walk.scm 81 */
												BgL_arg1599z00_1748 =
													BGl_string2258z00zzstackable_walkz00;
											}
									}
									bgl_display_obj(BgL_arg1599z00_1748, BgL_port1398z00_1747);
								}
								bgl_display_string(BGl_string2259z00zzstackable_walkz00,
									BgL_port1398z00_1747);
								bgl_display_char(((unsigned char) 10), BgL_port1398z00_1747);
							}
							{	/* Stackable/walk.scm 81 */
								obj_t BgL_list1604z00_1754;

								BgL_list1604z00_1754 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
								return BGl_exitz00zz__errorz00(BgL_list1604z00_1754);
							}
						}
					else
						{	/* Stackable/walk.scm 81 */
							obj_t BgL_g1168z00_1755;

							BgL_g1168z00_1755 = BNIL;
							{
								obj_t BgL_hooksz00_1758;
								obj_t BgL_hnamesz00_1759;

								BgL_hooksz00_1758 = BgL_g1168z00_1755;
								BgL_hnamesz00_1759 = BNIL;
							BgL_zc3z04anonymousza31605ze3z87_1760:
								if (NULLP(BgL_hooksz00_1758))
									{	/* Stackable/walk.scm 81 */
										return BgL_globalsz00_19;
									}
								else
									{	/* Stackable/walk.scm 81 */
										bool_t BgL_test2443z00_4234;

										{	/* Stackable/walk.scm 81 */
											obj_t BgL_fun1615z00_1767;

											BgL_fun1615z00_1767 = CAR(((obj_t) BgL_hooksz00_1758));
											BgL_test2443z00_4234 =
												CBOOL(PROCEDURE_ENTRY(BgL_fun1615z00_1767)
												(BgL_fun1615z00_1767, BEOA));
										}
										if (BgL_test2443z00_4234)
											{	/* Stackable/walk.scm 81 */
												obj_t BgL_arg1612z00_1764;
												obj_t BgL_arg1613z00_1765;

												BgL_arg1612z00_1764 = CDR(((obj_t) BgL_hooksz00_1758));
												BgL_arg1613z00_1765 = CDR(((obj_t) BgL_hnamesz00_1759));
												{
													obj_t BgL_hnamesz00_4246;
													obj_t BgL_hooksz00_4245;

													BgL_hooksz00_4245 = BgL_arg1612z00_1764;
													BgL_hnamesz00_4246 = BgL_arg1613z00_1765;
													BgL_hnamesz00_1759 = BgL_hnamesz00_4246;
													BgL_hooksz00_1758 = BgL_hooksz00_4245;
													goto BgL_zc3z04anonymousza31605ze3z87_1760;
												}
											}
										else
											{	/* Stackable/walk.scm 81 */
												obj_t BgL_arg1614z00_1766;

												BgL_arg1614z00_1766 = CAR(((obj_t) BgL_hnamesz00_1759));
												return
													BGl_internalzd2errorzd2zztools_errorz00
													(BGl_za2currentzd2passza2zd2zzengine_passz00,
													BGl_string2260z00zzstackable_walkz00,
													BgL_arg1614z00_1766);
											}
									}
							}
						}
				}
			else
				{	/* Stackable/walk.scm 69 */
					return BgL_globalsz00_19;
				}
		}

	}



/* &stackable-walk! */
	obj_t BGl_z62stackablezd2walkz12za2zzstackable_walkz00(obj_t BgL_envz00_3574,
		obj_t BgL_globalsz00_3575)
	{
		{	/* Stackable/walk.scm 68 */
			return BGl_stackablezd2walkz12zc0zzstackable_walkz00(BgL_globalsz00_3575);
		}

	}



/* import? */
	bool_t BGl_importzf3zf3zzstackable_walkz00(BgL_variablez00_bglt BgL_varz00_20)
	{
		{	/* Stackable/walk.scm 87 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_varz00_20), BGl_globalz00zzast_varz00))
				{	/* Stackable/walk.scm 88 */
					bool_t BgL_test2445z00_4254;

					{	/* Stackable/walk.scm 88 */
						obj_t BgL_arg1638z00_1773;

						BgL_arg1638z00_1773 =
							(((BgL_globalz00_bglt) COBJECT(
									((BgL_globalz00_bglt) BgL_varz00_20)))->BgL_modulez00);
						BgL_test2445z00_4254 =
							(BgL_arg1638z00_1773 == BGl_za2moduleza2z00zzmodule_modulez00);
					}
					if (BgL_test2445z00_4254)
						{	/* Stackable/walk.scm 88 */
							return ((bool_t) 0);
						}
					else
						{	/* Stackable/walk.scm 88 */
							return ((bool_t) 1);
						}
				}
			else
				{	/* Stackable/walk.scm 88 */
					return ((bool_t) 0);
				}
		}

	}



/* var-stackable */
	obj_t BGl_varzd2stackablezd2zzstackable_walkz00(BgL_variablez00_bglt
		BgL_varz00_21, obj_t BgL_ctxz00_22)
	{
		{	/* Stackable/walk.scm 93 */
			{	/* Stackable/walk.scm 94 */
				bool_t BgL_test2446z00_4258;

				if (BGl_importzf3zf3zzstackable_walkz00(BgL_varz00_21))
					{	/* Stackable/walk.scm 94 */
						BgL_test2446z00_4258 = ((bool_t) 0);
					}
				else
					{	/* Stackable/walk.scm 94 */
						if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
									((obj_t) BgL_varz00_21), CDR(BgL_ctxz00_22))))
							{	/* Stackable/walk.scm 94 */
								BgL_test2446z00_4258 = ((bool_t) 0);
							}
						else
							{	/* Stackable/walk.scm 94 */
								BgL_test2446z00_4258 = ((bool_t) 1);
							}
					}
				if (BgL_test2446z00_4258)
					{	/* Stackable/walk.scm 94 */
						{	/* Stackable/walk.scm 96 */
							obj_t BgL_arg1649z00_1779;

							{	/* Stackable/walk.scm 96 */
								obj_t BgL_arg1655z00_1780;

								BgL_arg1655z00_1780 = CDR(BgL_ctxz00_22);
								BgL_arg1649z00_1779 =
									MAKE_YOUNG_PAIR(((obj_t) BgL_varz00_21), BgL_arg1655z00_1780);
							}
							SET_CDR(BgL_ctxz00_22, BgL_arg1649z00_1779);
						}
						{	/* Stackable/walk.scm 98 */
							BgL_sfunz00_bglt BgL_i1172z00_1782;

							BgL_i1172z00_1782 =
								((BgL_sfunz00_bglt)
								(((BgL_variablez00_bglt) COBJECT(BgL_varz00_21))->
									BgL_valuez00));
							{	/* Stackable/walk.scm 99 */
								bool_t BgL_test2449z00_4272;

								{	/* Stackable/walk.scm 99 */
									obj_t BgL_arg1666z00_1790;

									BgL_arg1666z00_1790 =
										(((BgL_sfunz00_bglt) COBJECT(BgL_i1172z00_1782))->
										BgL_bodyz00);
									BgL_test2449z00_4272 =
										BGl_isazf3zf3zz__objectz00(BgL_arg1666z00_1790,
										BGl_nodez00zzast_nodez00);
								}
								if (BgL_test2449z00_4272)
									{	/* Stackable/walk.scm 99 */
										if (BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_varz00_21), BGl_globalz00zzast_varz00))
											{	/* Stackable/walk.scm 101 */
												obj_t BgL_arg1662z00_1786;

												BgL_arg1662z00_1786 =
													(((BgL_sfunz00_bglt) COBJECT(BgL_i1172z00_1782))->
													BgL_bodyz00);
												return
													BGl_stackablez00zzstackable_walkz00((
														(BgL_nodez00_bglt) BgL_arg1662z00_1786),
													((bool_t) 1), ((long) 0), BgL_ctxz00_22);
											}
										else
											{	/* Stackable/walk.scm 103 */
												obj_t BgL_arg1663z00_1788;
												long BgL_arg1664z00_1789;

												BgL_arg1663z00_1788 =
													(((BgL_sfunz00_bglt) COBJECT(BgL_i1172z00_1782))->
													BgL_bodyz00);
												{
													BgL_localzf2depthzf2_bglt BgL_auxz00_4282;

													{
														obj_t BgL_auxz00_4283;

														{	/* Stackable/walk.scm 103 */
															BgL_objectz00_bglt BgL_tmpz00_4284;

															BgL_tmpz00_4284 =
																((BgL_objectz00_bglt)
																((BgL_localz00_bglt) BgL_varz00_21));
															BgL_auxz00_4283 =
																BGL_OBJECT_WIDENING(BgL_tmpz00_4284);
														}
														BgL_auxz00_4282 =
															((BgL_localzf2depthzf2_bglt) BgL_auxz00_4283);
													}
													BgL_arg1664z00_1789 =
														(((BgL_localzf2depthzf2_bglt)
															COBJECT(BgL_auxz00_4282))->BgL_depthz00);
												}
												return
													BGl_stackablez00zzstackable_walkz00(
													((BgL_nodez00_bglt) BgL_arg1663z00_1788),
													((bool_t) 1), BgL_arg1664z00_1789, BgL_ctxz00_22);
											}
									}
								else
									{	/* Stackable/walk.scm 99 */
										return BFALSE;
									}
							}
						}
					}
				else
					{	/* Stackable/walk.scm 94 */
						return BFALSE;
					}
			}
		}

	}



/* global-lift-let! */
	obj_t BGl_globalzd2liftzd2letz12z12zzstackable_walkz00(BgL_variablez00_bglt
		BgL_varz00_83)
	{
		{	/* Stackable/walk.scm 378 */
			{	/* Stackable/walk.scm 380 */
				BgL_sfunz00_bglt BgL_i1203z00_1795;

				BgL_i1203z00_1795 =
					((BgL_sfunz00_bglt)
					(((BgL_variablez00_bglt) COBJECT(BgL_varz00_83))->BgL_valuez00));
				{
					obj_t BgL_auxz00_4294;

					{	/* Stackable/walk.scm 381 */
						obj_t BgL_arg1673z00_1796;

						BgL_arg1673z00_1796 =
							(((BgL_sfunz00_bglt) COBJECT(BgL_i1203z00_1795))->BgL_bodyz00);
						BgL_auxz00_4294 =
							((obj_t)
							BGl_liftzd2letz12zc0zzstackable_walkz00(
								((BgL_nodez00_bglt) BgL_arg1673z00_1796)));
					}
					return
						((((BgL_sfunz00_bglt) COBJECT(BgL_i1203z00_1795))->BgL_bodyz00) =
						((obj_t) BgL_auxz00_4294), BUNSPEC);
				}
			}
		}

	}



/* global-depth-let! */
	obj_t BGl_globalzd2depthzd2letz12z12zzstackable_walkz00(BgL_variablez00_bglt
		BgL_varz00_86)
	{
		{	/* Stackable/walk.scm 441 */
			{	/* Stackable/walk.scm 443 */
				BgL_sfunz00_bglt BgL_i1219z00_1798;

				BgL_i1219z00_1798 =
					((BgL_sfunz00_bglt)
					(((BgL_variablez00_bglt) COBJECT(BgL_varz00_86))->BgL_valuez00));
				{	/* Stackable/walk.scm 444 */
					obj_t BgL_g1438z00_1799;

					BgL_g1438z00_1799 =
						(((BgL_sfunz00_bglt) COBJECT(BgL_i1219z00_1798))->BgL_argsz00);
					{
						obj_t BgL_l1436z00_1801;

						BgL_l1436z00_1801 = BgL_g1438z00_1799;
					BgL_zc3z04anonymousza31674ze3z87_1802:
						if (PAIRP(BgL_l1436z00_1801))
							{	/* Stackable/walk.scm 444 */
								{	/* Stackable/walk.scm 445 */
									obj_t BgL_az00_1804;

									BgL_az00_1804 = CAR(BgL_l1436z00_1801);
									{	/* Stackable/walk.scm 445 */
										BgL_localzf2depthzf2_bglt BgL_wide1222z00_1807;

										BgL_wide1222z00_1807 =
											((BgL_localzf2depthzf2_bglt)
											BOBJECT(GC_MALLOC(sizeof(struct
														BgL_localzf2depthzf2_bgl))));
										{	/* Stackable/walk.scm 445 */
											obj_t BgL_auxz00_4311;
											BgL_objectz00_bglt BgL_tmpz00_4307;

											BgL_auxz00_4311 = ((obj_t) BgL_wide1222z00_1807);
											BgL_tmpz00_4307 =
												((BgL_objectz00_bglt)
												((BgL_localz00_bglt)
													((BgL_localz00_bglt) BgL_az00_1804)));
											BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4307, BgL_auxz00_4311);
										}
										((BgL_objectz00_bglt)
											((BgL_localz00_bglt)
												((BgL_localz00_bglt) BgL_az00_1804)));
										{	/* Stackable/walk.scm 445 */
											long BgL_arg1676z00_1808;

											BgL_arg1676z00_1808 =
												BGL_CLASS_INDEX
												(BGl_localzf2depthzf2zzstackable_walkz00);
											BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt) (
														(BgL_localz00_bglt) ((BgL_localz00_bglt)
															BgL_az00_1804))), BgL_arg1676z00_1808);
										}
										((BgL_localz00_bglt)
											((BgL_localz00_bglt)
												((BgL_localz00_bglt) BgL_az00_1804)));
									}
									{
										BgL_localzf2depthzf2_bglt BgL_auxz00_4325;

										{
											obj_t BgL_auxz00_4326;

											{	/* Stackable/walk.scm 447 */
												BgL_objectz00_bglt BgL_tmpz00_4327;

												BgL_tmpz00_4327 =
													((BgL_objectz00_bglt)
													((BgL_localz00_bglt)
														((BgL_localz00_bglt) BgL_az00_1804)));
												BgL_auxz00_4326 = BGL_OBJECT_WIDENING(BgL_tmpz00_4327);
											}
											BgL_auxz00_4325 =
												((BgL_localzf2depthzf2_bglt) BgL_auxz00_4326);
										}
										((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4325))->
												BgL_depthz00) = ((long) ((long) 0)), BUNSPEC);
									}
									{
										BgL_localzf2depthzf2_bglt BgL_auxz00_4334;

										{
											obj_t BgL_auxz00_4335;

											{	/* Stackable/walk.scm 446 */
												BgL_objectz00_bglt BgL_tmpz00_4336;

												BgL_tmpz00_4336 =
													((BgL_objectz00_bglt)
													((BgL_localz00_bglt)
														((BgL_localz00_bglt) BgL_az00_1804)));
												BgL_auxz00_4335 = BGL_OBJECT_WIDENING(BgL_tmpz00_4336);
											}
											BgL_auxz00_4334 =
												((BgL_localzf2depthzf2_bglt) BgL_auxz00_4335);
										}
										((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4334))->
												BgL_ownerz00) =
											((obj_t) ((obj_t) BgL_varz00_86)), BUNSPEC);
									}
									((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_az00_1804));
								}
								{
									obj_t BgL_l1436z00_4346;

									BgL_l1436z00_4346 = CDR(BgL_l1436z00_1801);
									BgL_l1436z00_1801 = BgL_l1436z00_4346;
									goto BgL_zc3z04anonymousza31674ze3z87_1802;
								}
							}
						else
							{	/* Stackable/walk.scm 444 */
								((bool_t) 1);
							}
					}
				}
				{	/* Stackable/walk.scm 449 */
					obj_t BgL_arg1682z00_1812;

					BgL_arg1682z00_1812 =
						(((BgL_sfunz00_bglt) COBJECT(BgL_i1219z00_1798))->BgL_bodyz00);
					return
						BGl_depthzd2letzd2zzstackable_walkz00(
						((BgL_nodez00_bglt) BgL_arg1682z00_1812),
						BINT(((long) 0)), ((obj_t) BgL_varz00_86));
		}}}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzstackable_walkz00()
	{
		{	/* Stackable/walk.scm 16 */
			{	/* Stackable/walk.scm 38 */
				obj_t BgL_arg1696z00_1820;
				obj_t BgL_arg1697z00_1821;

				{	/* Stackable/walk.scm 38 */
					obj_t BgL_v1448z00_1850;

					BgL_v1448z00_1850 = create_vector(((long) 1));
					{	/* Stackable/walk.scm 38 */
						obj_t BgL_arg1719z00_1851;

						BgL_arg1719z00_1851 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									1)), BGl_proc2262z00zzstackable_walkz00,
							BGl_proc2261z00zzstackable_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 2)));
						VECTOR_SET(BgL_v1448z00_1850, ((long) 0), BgL_arg1719z00_1851);
					}
					BgL_arg1696z00_1820 = BgL_v1448z00_1850;
				}
				{	/* Stackable/walk.scm 38 */
					obj_t BgL_v1449z00_1861;

					BgL_v1449z00_1861 = create_vector(((long) 0));
					BgL_arg1697z00_1821 = BgL_v1449z00_1861;
				}
				BGl_appzf2depthzf2zzstackable_walkz00 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 3)),
					CNST_TABLE_REF(((long) 4)), BGl_appz00zzast_nodez00, ((long) 17275),
					BGl_proc2266z00zzstackable_walkz00,
					BGl_proc2265z00zzstackable_walkz00, BFALSE,
					BGl_proc2264z00zzstackable_walkz00,
					BGl_proc2263z00zzstackable_walkz00, BgL_arg1696z00_1820,
					BgL_arg1697z00_1821);
			}
			{	/* Stackable/walk.scm 40 */
				obj_t BgL_arg1734z00_1870;
				obj_t BgL_arg1735z00_1871;

				{	/* Stackable/walk.scm 40 */
					obj_t BgL_v1450z00_1906;

					BgL_v1450z00_1906 = create_vector(((long) 2));
					{	/* Stackable/walk.scm 40 */
						obj_t BgL_arg1751z00_1907;

						BgL_arg1751z00_1907 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									1)), BGl_proc2268z00zzstackable_walkz00,
							BGl_proc2267z00zzstackable_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 2)));
						VECTOR_SET(BgL_v1450z00_1906, ((long) 0), BgL_arg1751z00_1907);
					}
					{	/* Stackable/walk.scm 40 */
						obj_t BgL_arg1759z00_1917;

						BgL_arg1759z00_1917 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									5)), BGl_proc2270z00zzstackable_walkz00,
							BGl_proc2269z00zzstackable_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 6)));
						VECTOR_SET(BgL_v1450z00_1906, ((long) 1), BgL_arg1759z00_1917);
					}
					BgL_arg1734z00_1870 = BgL_v1450z00_1906;
				}
				{	/* Stackable/walk.scm 40 */
					obj_t BgL_v1451z00_1927;

					BgL_v1451z00_1927 = create_vector(((long) 0));
					BgL_arg1735z00_1871 = BgL_v1451z00_1927;
				}
				return (BGl_localzf2depthzf2zzstackable_walkz00 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 7)),
						CNST_TABLE_REF(((long) 4)), BGl_localz00zzast_varz00, ((long) 2096),
						BGl_proc2274z00zzstackable_walkz00,
						BGl_proc2273z00zzstackable_walkz00, BFALSE,
						BGl_proc2272z00zzstackable_walkz00,
						BGl_proc2271z00zzstackable_walkz00, BgL_arg1734z00_1870,
						BgL_arg1735z00_1871), BUNSPEC);
		}}

	}



/* &lambda1743 */
	BgL_localz00_bglt BGl_z62lambda1743z62zzstackable_walkz00(obj_t
		BgL_envz00_3590, obj_t BgL_o1137z00_3591)
	{
		{	/* Stackable/walk.scm 40 */
			{	/* Stackable/walk.scm 40 */
				long BgL_arg1744z00_3833;

				{	/* Stackable/walk.scm 40 */
					obj_t BgL_arg1746z00_3834;

					{	/* Stackable/walk.scm 40 */
						obj_t BgL_arg1747z00_3835;

						{	/* Stackable/walk.scm 40 */
							long BgL_arg1794z00_3836;

							{	/* Stackable/walk.scm 40 */
								long BgL_arg1795z00_3837;

								BgL_arg1795z00_3837 =
									BGL_OBJECT_CLASS_NUM(
									((BgL_objectz00_bglt)
										((BgL_localz00_bglt) BgL_o1137z00_3591)));
								BgL_arg1794z00_3836 = (BgL_arg1795z00_3837 - OBJECT_TYPE);
							}
							BgL_arg1747z00_3835 =
								VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
								BgL_arg1794z00_3836);
						}
						BgL_arg1746z00_3834 =
							BGl_classzd2superzd2zz__objectz00(BgL_arg1747z00_3835);
					}
					{	/* Stackable/walk.scm 40 */
						obj_t BgL_tmpz00_4381;

						BgL_tmpz00_4381 = ((obj_t) BgL_arg1746z00_3834);
						BgL_arg1744z00_3833 = BGL_CLASS_INDEX(BgL_tmpz00_4381);
				}}
				BGL_OBJECT_CLASS_NUM_SET(
					((BgL_objectz00_bglt)
						((BgL_localz00_bglt) BgL_o1137z00_3591)), BgL_arg1744z00_3833);
			}
			{	/* Stackable/walk.scm 40 */
				BgL_objectz00_bglt BgL_tmpz00_4387;

				BgL_tmpz00_4387 =
					((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1137z00_3591));
				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4387, BFALSE);
			}
			((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1137z00_3591));
			return ((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1137z00_3591));
		}

	}



/* &<@anonymous:1742> */
	obj_t BGl_z62zc3z04anonymousza31742ze3ze5zzstackable_walkz00(obj_t
		BgL_envz00_3592, obj_t BgL_new1136z00_3593)
	{
		{	/* Stackable/walk.scm 40 */
			{
				BgL_localz00_bglt BgL_auxz00_4395;

				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1136z00_3593))))->BgL_idz00) =
					((obj_t) CNST_TABLE_REF(((long) 8))), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1136z00_3593))))->BgL_namez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_4403;

					{	/* Stackable/walk.scm 40 */
						obj_t BgL_classz00_3839;

						BgL_classz00_3839 = BGl_typez00zztype_typez00;
						{	/* Stackable/walk.scm 40 */
							obj_t BgL__ortest_1110z00_3840;

							BgL__ortest_1110z00_3840 = BGL_CLASS_NIL(BgL_classz00_3839);
							if (CBOOL(BgL__ortest_1110z00_3840))
								{	/* Stackable/walk.scm 40 */
									BgL_auxz00_4403 =
										((BgL_typez00_bglt) BgL__ortest_1110z00_3840);
								}
							else
								{	/* Stackable/walk.scm 40 */
									BgL_auxz00_4403 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3839));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1136z00_3593))))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_4403), BUNSPEC);
				}
				{
					BgL_valuez00_bglt BgL_auxz00_4413;

					{	/* Stackable/walk.scm 40 */
						obj_t BgL_classz00_3841;

						BgL_classz00_3841 = BGl_valuez00zzast_varz00;
						{	/* Stackable/walk.scm 40 */
							obj_t BgL__ortest_1110z00_3842;

							BgL__ortest_1110z00_3842 = BGL_CLASS_NIL(BgL_classz00_3841);
							if (CBOOL(BgL__ortest_1110z00_3842))
								{	/* Stackable/walk.scm 40 */
									BgL_auxz00_4413 =
										((BgL_valuez00_bglt) BgL__ortest_1110z00_3842);
								}
							else
								{	/* Stackable/walk.scm 40 */
									BgL_auxz00_4413 =
										((BgL_valuez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3841));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1136z00_3593))))->
							BgL_valuez00) = ((BgL_valuez00_bglt) BgL_auxz00_4413), BUNSPEC);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1136z00_3593))))->BgL_accessz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1136z00_3593))))->BgL_fastzd2alphazd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1136z00_3593))))->BgL_removablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1136z00_3593))))->BgL_occurrencez00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1136z00_3593))))->BgL_occurrencewz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1136z00_3593))))->BgL_userzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) ((BgL_localz00_bglt)
										BgL_new1136z00_3593))))->BgL_keyz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) ((BgL_localz00_bglt)
										BgL_new1136z00_3593))))->BgL_valzd2noescapezd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_localzf2depthzf2_bglt BgL_auxz00_4447;

					{
						obj_t BgL_auxz00_4448;

						{	/* Stackable/walk.scm 40 */
							BgL_objectz00_bglt BgL_tmpz00_4449;

							BgL_tmpz00_4449 =
								((BgL_objectz00_bglt)
								((BgL_localz00_bglt) BgL_new1136z00_3593));
							BgL_auxz00_4448 = BGL_OBJECT_WIDENING(BgL_tmpz00_4449);
						}
						BgL_auxz00_4447 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_4448);
					}
					((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4447))->
							BgL_depthz00) = ((long) ((long) 0)), BUNSPEC);
				}
				{
					BgL_localzf2depthzf2_bglt BgL_auxz00_4455;

					{
						obj_t BgL_auxz00_4456;

						{	/* Stackable/walk.scm 40 */
							BgL_objectz00_bglt BgL_tmpz00_4457;

							BgL_tmpz00_4457 =
								((BgL_objectz00_bglt)
								((BgL_localz00_bglt) BgL_new1136z00_3593));
							BgL_auxz00_4456 = BGL_OBJECT_WIDENING(BgL_tmpz00_4457);
						}
						BgL_auxz00_4455 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_4456);
					}
					((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4455))->
							BgL_ownerz00) = ((obj_t) BUNSPEC), BUNSPEC);
				}
				BgL_auxz00_4395 = ((BgL_localz00_bglt) BgL_new1136z00_3593);
				return ((obj_t) BgL_auxz00_4395);
			}
		}

	}



/* &lambda1740 */
	BgL_localz00_bglt BGl_z62lambda1740z62zzstackable_walkz00(obj_t
		BgL_envz00_3594, obj_t BgL_o1133z00_3595)
	{
		{	/* Stackable/walk.scm 40 */
			{	/* Stackable/walk.scm 40 */
				BgL_localzf2depthzf2_bglt BgL_wide1135z00_3844;

				BgL_wide1135z00_3844 =
					((BgL_localzf2depthzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_localzf2depthzf2_bgl))));
				{	/* Stackable/walk.scm 40 */
					obj_t BgL_auxz00_4470;
					BgL_objectz00_bglt BgL_tmpz00_4466;

					BgL_auxz00_4470 = ((obj_t) BgL_wide1135z00_3844);
					BgL_tmpz00_4466 =
						((BgL_objectz00_bglt)
						((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1133z00_3595)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4466, BgL_auxz00_4470);
				}
				((BgL_objectz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1133z00_3595)));
				{	/* Stackable/walk.scm 40 */
					long BgL_arg1741z00_3845;

					BgL_arg1741z00_3845 =
						BGL_CLASS_INDEX(BGl_localzf2depthzf2zzstackable_walkz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_localz00_bglt)
								((BgL_localz00_bglt) BgL_o1133z00_3595))), BgL_arg1741z00_3845);
				}
				return
					((BgL_localz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1133z00_3595)));
			}
		}

	}



/* &lambda1736 */
	BgL_localz00_bglt BGl_z62lambda1736z62zzstackable_walkz00(obj_t
		BgL_envz00_3596, obj_t BgL_id1119z00_3597, obj_t BgL_name1120z00_3598,
		obj_t BgL_type1121z00_3599, obj_t BgL_value1122z00_3600,
		obj_t BgL_access1123z00_3601, obj_t BgL_fastzd2alpha1124zd2_3602,
		obj_t BgL_removable1125z00_3603, obj_t BgL_occurrence1126z00_3604,
		obj_t BgL_occurrencew1127z00_3605, obj_t BgL_userzf31128zf3_3606,
		obj_t BgL_key1129z00_3607, obj_t BgL_valzd2noescape1130zd2_3608,
		obj_t BgL_depth1131z00_3609, obj_t BgL_owner1132z00_3610)
	{
		{	/* Stackable/walk.scm 40 */
			{	/* Stackable/walk.scm 40 */
				long BgL_occurrence1126z00_3849;
				long BgL_occurrencew1127z00_3850;
				bool_t BgL_userzf31128zf3_3851;
				long BgL_key1129z00_3852;
				long BgL_depth1131z00_3853;

				BgL_occurrence1126z00_3849 = (long) CINT(BgL_occurrence1126z00_3604);
				BgL_occurrencew1127z00_3850 = (long) CINT(BgL_occurrencew1127z00_3605);
				BgL_userzf31128zf3_3851 = CBOOL(BgL_userzf31128zf3_3606);
				BgL_key1129z00_3852 = (long) CINT(BgL_key1129z00_3607);
				BgL_depth1131z00_3853 = (long) CINT(BgL_depth1131z00_3609);
				{	/* Stackable/walk.scm 40 */
					BgL_localz00_bglt BgL_new1266z00_3854;

					{	/* Stackable/walk.scm 40 */
						BgL_localz00_bglt BgL_tmp1264z00_3855;
						BgL_localzf2depthzf2_bglt BgL_wide1265z00_3856;

						{
							BgL_localz00_bglt BgL_auxz00_4489;

							{	/* Stackable/walk.scm 40 */
								BgL_localz00_bglt BgL_new1263z00_3857;

								BgL_new1263z00_3857 =
									((BgL_localz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_localz00_bgl))));
								{	/* Stackable/walk.scm 40 */
									long BgL_arg1739z00_3858;

									BgL_arg1739z00_3858 =
										BGL_CLASS_INDEX(BGl_localz00zzast_varz00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1263z00_3857),
										BgL_arg1739z00_3858);
								}
								{	/* Stackable/walk.scm 40 */
									BgL_objectz00_bglt BgL_tmpz00_4494;

									BgL_tmpz00_4494 = ((BgL_objectz00_bglt) BgL_new1263z00_3857);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4494, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1263z00_3857);
								BgL_auxz00_4489 = BgL_new1263z00_3857;
							}
							BgL_tmp1264z00_3855 = ((BgL_localz00_bglt) BgL_auxz00_4489);
						}
						BgL_wide1265z00_3856 =
							((BgL_localzf2depthzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_localzf2depthzf2_bgl))));
						{	/* Stackable/walk.scm 40 */
							obj_t BgL_auxz00_4502;
							BgL_objectz00_bglt BgL_tmpz00_4500;

							BgL_auxz00_4502 = ((obj_t) BgL_wide1265z00_3856);
							BgL_tmpz00_4500 = ((BgL_objectz00_bglt) BgL_tmp1264z00_3855);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4500, BgL_auxz00_4502);
						}
						((BgL_objectz00_bglt) BgL_tmp1264z00_3855);
						{	/* Stackable/walk.scm 40 */
							long BgL_arg1737z00_3859;

							BgL_arg1737z00_3859 =
								BGL_CLASS_INDEX(BGl_localzf2depthzf2zzstackable_walkz00);
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_tmp1264z00_3855),
								BgL_arg1737z00_3859);
						}
						BgL_new1266z00_3854 = ((BgL_localz00_bglt) BgL_tmp1264z00_3855);
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_new1266z00_3854)))->BgL_idz00) =
						((obj_t) ((obj_t) BgL_id1119z00_3597)), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_namez00) =
						((obj_t) BgL_name1120z00_3598), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_type1121z00_3599)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_valuez00) =
						((BgL_valuez00_bglt) ((BgL_valuez00_bglt) BgL_value1122z00_3600)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_accessz00) =
						((obj_t) BgL_access1123z00_3601), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_fastzd2alphazd2) =
						((obj_t) BgL_fastzd2alpha1124zd2_3602), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_removablez00) =
						((obj_t) BgL_removable1125z00_3603), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_occurrencez00) =
						((long) BgL_occurrence1126z00_3849), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_occurrencewz00) =
						((long) BgL_occurrencew1127z00_3850), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1266z00_3854)))->BgL_userzf3zf3) =
						((bool_t) BgL_userzf31128zf3_3851), BUNSPEC);
					((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
										BgL_new1266z00_3854)))->BgL_keyz00) =
						((long) BgL_key1129z00_3852), BUNSPEC);
					((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
										BgL_new1266z00_3854)))->BgL_valzd2noescapezd2) =
						((obj_t) BgL_valzd2noescape1130zd2_3608), BUNSPEC);
					{
						BgL_localzf2depthzf2_bglt BgL_auxz00_4537;

						{
							obj_t BgL_auxz00_4538;

							{	/* Stackable/walk.scm 40 */
								BgL_objectz00_bglt BgL_tmpz00_4539;

								BgL_tmpz00_4539 = ((BgL_objectz00_bglt) BgL_new1266z00_3854);
								BgL_auxz00_4538 = BGL_OBJECT_WIDENING(BgL_tmpz00_4539);
							}
							BgL_auxz00_4537 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_4538);
						}
						((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4537))->
								BgL_depthz00) = ((long) BgL_depth1131z00_3853), BUNSPEC);
					}
					{
						BgL_localzf2depthzf2_bglt BgL_auxz00_4544;

						{
							obj_t BgL_auxz00_4545;

							{	/* Stackable/walk.scm 40 */
								BgL_objectz00_bglt BgL_tmpz00_4546;

								BgL_tmpz00_4546 = ((BgL_objectz00_bglt) BgL_new1266z00_3854);
								BgL_auxz00_4545 = BGL_OBJECT_WIDENING(BgL_tmpz00_4546);
							}
							BgL_auxz00_4544 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_4545);
						}
						((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4544))->
								BgL_ownerz00) = ((obj_t) BgL_owner1132z00_3610), BUNSPEC);
					}
					return BgL_new1266z00_3854;
				}
			}
		}

	}



/* &lambda1766 */
	obj_t BGl_z62lambda1766z62zzstackable_walkz00(obj_t BgL_envz00_3611,
		obj_t BgL_oz00_3612, obj_t BgL_vz00_3613)
	{
		{	/* Stackable/walk.scm 40 */
			{
				BgL_localzf2depthzf2_bglt BgL_auxz00_4551;

				{
					obj_t BgL_auxz00_4552;

					{	/* Stackable/walk.scm 40 */
						BgL_objectz00_bglt BgL_tmpz00_4553;

						BgL_tmpz00_4553 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3612));
						BgL_auxz00_4552 = BGL_OBJECT_WIDENING(BgL_tmpz00_4553);
					}
					BgL_auxz00_4551 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_4552);
				}
				return
					((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4551))->
						BgL_ownerz00) = ((obj_t) BgL_vz00_3613), BUNSPEC);
			}
		}

	}



/* &lambda1765 */
	obj_t BGl_z62lambda1765z62zzstackable_walkz00(obj_t BgL_envz00_3614,
		obj_t BgL_oz00_3615)
	{
		{	/* Stackable/walk.scm 40 */
			{
				BgL_localzf2depthzf2_bglt BgL_auxz00_4559;

				{
					obj_t BgL_auxz00_4560;

					{	/* Stackable/walk.scm 40 */
						BgL_objectz00_bglt BgL_tmpz00_4561;

						BgL_tmpz00_4561 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3615));
						BgL_auxz00_4560 = BGL_OBJECT_WIDENING(BgL_tmpz00_4561);
					}
					BgL_auxz00_4559 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_4560);
				}
				return
					(((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4559))->
					BgL_ownerz00);
			}
		}

	}



/* &lambda1757 */
	obj_t BGl_z62lambda1757z62zzstackable_walkz00(obj_t BgL_envz00_3616,
		obj_t BgL_oz00_3617, obj_t BgL_vz00_3618)
	{
		{	/* Stackable/walk.scm 40 */
			{	/* Stackable/walk.scm 40 */
				long BgL_vz00_3863;

				BgL_vz00_3863 = (long) CINT(BgL_vz00_3618);
				{
					BgL_localzf2depthzf2_bglt BgL_auxz00_4568;

					{
						obj_t BgL_auxz00_4569;

						{	/* Stackable/walk.scm 40 */
							BgL_objectz00_bglt BgL_tmpz00_4570;

							BgL_tmpz00_4570 =
								((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3617));
							BgL_auxz00_4569 = BGL_OBJECT_WIDENING(BgL_tmpz00_4570);
						}
						BgL_auxz00_4568 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_4569);
					}
					return
						((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4568))->
							BgL_depthz00) = ((long) BgL_vz00_3863), BUNSPEC);
		}}}

	}



/* &lambda1756 */
	obj_t BGl_z62lambda1756z62zzstackable_walkz00(obj_t BgL_envz00_3619,
		obj_t BgL_oz00_3620)
	{
		{	/* Stackable/walk.scm 40 */
			{	/* Stackable/walk.scm 40 */
				long BgL_tmpz00_4576;

				{
					BgL_localzf2depthzf2_bglt BgL_auxz00_4577;

					{
						obj_t BgL_auxz00_4578;

						{	/* Stackable/walk.scm 40 */
							BgL_objectz00_bglt BgL_tmpz00_4579;

							BgL_tmpz00_4579 =
								((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_oz00_3620));
							BgL_auxz00_4578 = BGL_OBJECT_WIDENING(BgL_tmpz00_4579);
						}
						BgL_auxz00_4577 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_4578);
					}
					BgL_tmpz00_4576 =
						(((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_4577))->
						BgL_depthz00);
				}
				return BINT(BgL_tmpz00_4576);
			}
		}

	}



/* &lambda1706 */
	BgL_appz00_bglt BGl_z62lambda1706z62zzstackable_walkz00(obj_t BgL_envz00_3621,
		obj_t BgL_o1117z00_3622)
	{
		{	/* Stackable/walk.scm 38 */
			{	/* Stackable/walk.scm 38 */
				long BgL_arg1710z00_3866;

				{	/* Stackable/walk.scm 38 */
					obj_t BgL_arg1717z00_3867;

					{	/* Stackable/walk.scm 38 */
						obj_t BgL_arg1718z00_3868;

						{	/* Stackable/walk.scm 38 */
							long BgL_arg1794z00_3869;

							{	/* Stackable/walk.scm 38 */
								long BgL_arg1795z00_3870;

								BgL_arg1795z00_3870 =
									BGL_OBJECT_CLASS_NUM(
									((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_o1117z00_3622)));
								BgL_arg1794z00_3869 = (BgL_arg1795z00_3870 - OBJECT_TYPE);
							}
							BgL_arg1718z00_3868 =
								VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
								BgL_arg1794z00_3869);
						}
						BgL_arg1717z00_3867 =
							BGl_classzd2superzd2zz__objectz00(BgL_arg1718z00_3868);
					}
					{	/* Stackable/walk.scm 38 */
						obj_t BgL_tmpz00_4592;

						BgL_tmpz00_4592 = ((obj_t) BgL_arg1717z00_3867);
						BgL_arg1710z00_3866 = BGL_CLASS_INDEX(BgL_tmpz00_4592);
				}}
				BGL_OBJECT_CLASS_NUM_SET(
					((BgL_objectz00_bglt)
						((BgL_appz00_bglt) BgL_o1117z00_3622)), BgL_arg1710z00_3866);
			}
			{	/* Stackable/walk.scm 38 */
				BgL_objectz00_bglt BgL_tmpz00_4598;

				BgL_tmpz00_4598 =
					((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_o1117z00_3622));
				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4598, BFALSE);
			}
			((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_o1117z00_3622));
			return ((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_o1117z00_3622));
		}

	}



/* &<@anonymous:1705> */
	obj_t BGl_z62zc3z04anonymousza31705ze3ze5zzstackable_walkz00(obj_t
		BgL_envz00_3623, obj_t BgL_new1116z00_3624)
	{
		{	/* Stackable/walk.scm 38 */
			{
				BgL_appz00_bglt BgL_auxz00_4606;

				((((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_appz00_bglt) BgL_new1116z00_3624))))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_4610;

					{	/* Stackable/walk.scm 38 */
						obj_t BgL_classz00_3872;

						BgL_classz00_3872 = BGl_typez00zztype_typez00;
						{	/* Stackable/walk.scm 38 */
							obj_t BgL__ortest_1110z00_3873;

							BgL__ortest_1110z00_3873 = BGL_CLASS_NIL(BgL_classz00_3872);
							if (CBOOL(BgL__ortest_1110z00_3873))
								{	/* Stackable/walk.scm 38 */
									BgL_auxz00_4610 =
										((BgL_typez00_bglt) BgL__ortest_1110z00_3873);
								}
							else
								{	/* Stackable/walk.scm 38 */
									BgL_auxz00_4610 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3872));
								}
						}
					}
					((((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_appz00_bglt) BgL_new1116z00_3624))))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_4610), BUNSPEC);
				}
				((((BgL_nodezf2effectzf2_bglt) COBJECT(
								((BgL_nodezf2effectzf2_bglt)
									((BgL_appz00_bglt) BgL_new1116z00_3624))))->
						BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_nodezf2effectzf2_bglt)
							COBJECT(((BgL_nodezf2effectzf2_bglt) ((BgL_appz00_bglt)
										BgL_new1116z00_3624))))->BgL_keyz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_varz00_bglt BgL_auxz00_4626;

					{	/* Stackable/walk.scm 38 */
						obj_t BgL_classz00_3874;

						BgL_classz00_3874 = BGl_varz00zzast_nodez00;
						{	/* Stackable/walk.scm 38 */
							obj_t BgL__ortest_1110z00_3875;

							BgL__ortest_1110z00_3875 = BGL_CLASS_NIL(BgL_classz00_3874);
							if (CBOOL(BgL__ortest_1110z00_3875))
								{	/* Stackable/walk.scm 38 */
									BgL_auxz00_4626 =
										((BgL_varz00_bglt) BgL__ortest_1110z00_3875);
								}
							else
								{	/* Stackable/walk.scm 38 */
									BgL_auxz00_4626 =
										((BgL_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3874));
								}
						}
					}
					((((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt)
										((BgL_appz00_bglt) BgL_new1116z00_3624))))->BgL_funz00) =
						((BgL_varz00_bglt) BgL_auxz00_4626), BUNSPEC);
				}
				((((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt)
									((BgL_appz00_bglt) BgL_new1116z00_3624))))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt) ((BgL_appz00_bglt)
										BgL_new1116z00_3624))))->BgL_stackablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_appzf2depthzf2_bglt BgL_auxz00_4642;

					{
						obj_t BgL_auxz00_4643;

						{	/* Stackable/walk.scm 38 */
							BgL_objectz00_bglt BgL_tmpz00_4644;

							BgL_tmpz00_4644 =
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_new1116z00_3624));
							BgL_auxz00_4643 = BGL_OBJECT_WIDENING(BgL_tmpz00_4644);
						}
						BgL_auxz00_4642 = ((BgL_appzf2depthzf2_bglt) BgL_auxz00_4643);
					}
					((((BgL_appzf2depthzf2_bglt) COBJECT(BgL_auxz00_4642))->
							BgL_depthz00) = ((long) ((long) 0)), BUNSPEC);
				}
				BgL_auxz00_4606 = ((BgL_appz00_bglt) BgL_new1116z00_3624);
				return ((obj_t) BgL_auxz00_4606);
			}
		}

	}



/* &lambda1703 */
	BgL_appz00_bglt BGl_z62lambda1703z62zzstackable_walkz00(obj_t BgL_envz00_3625,
		obj_t BgL_o1113z00_3626)
	{
		{	/* Stackable/walk.scm 38 */
			{	/* Stackable/walk.scm 38 */
				BgL_appzf2depthzf2_bglt BgL_wide1115z00_3877;

				BgL_wide1115z00_3877 =
					((BgL_appzf2depthzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_appzf2depthzf2_bgl))));
				{	/* Stackable/walk.scm 38 */
					obj_t BgL_auxz00_4657;
					BgL_objectz00_bglt BgL_tmpz00_4653;

					BgL_auxz00_4657 = ((obj_t) BgL_wide1115z00_3877);
					BgL_tmpz00_4653 =
						((BgL_objectz00_bglt)
						((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_o1113z00_3626)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4653, BgL_auxz00_4657);
				}
				((BgL_objectz00_bglt)
					((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_o1113z00_3626)));
				{	/* Stackable/walk.scm 38 */
					long BgL_arg1704z00_3878;

					BgL_arg1704z00_3878 =
						BGL_CLASS_INDEX(BGl_appzf2depthzf2zzstackable_walkz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_appz00_bglt)
								((BgL_appz00_bglt) BgL_o1113z00_3626))), BgL_arg1704z00_3878);
				}
				return
					((BgL_appz00_bglt)
					((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_o1113z00_3626)));
			}
		}

	}



/* &lambda1698 */
	BgL_appz00_bglt BGl_z62lambda1698z62zzstackable_walkz00(obj_t BgL_envz00_3627,
		obj_t BgL_loc1105z00_3628, obj_t BgL_type1106z00_3629,
		obj_t BgL_sidezd2effect1107zd2_3630, obj_t BgL_key1108z00_3631,
		obj_t BgL_fun1109z00_3632, obj_t BgL_args1110z00_3633,
		obj_t BgL_stackable1111z00_3634, obj_t BgL_depth1112z00_3635)
	{
		{	/* Stackable/walk.scm 38 */
			{	/* Stackable/walk.scm 38 */
				long BgL_depth1112z00_3881;

				BgL_depth1112z00_3881 = (long) CINT(BgL_depth1112z00_3635);
				{	/* Stackable/walk.scm 38 */
					BgL_appz00_bglt BgL_new1261z00_3882;

					{	/* Stackable/walk.scm 38 */
						BgL_appz00_bglt BgL_tmp1259z00_3883;
						BgL_appzf2depthzf2_bglt BgL_wide1260z00_3884;

						{
							BgL_appz00_bglt BgL_auxz00_4672;

							{	/* Stackable/walk.scm 38 */
								BgL_appz00_bglt BgL_new1258z00_3885;

								BgL_new1258z00_3885 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Stackable/walk.scm 38 */
									long BgL_arg1702z00_3886;

									BgL_arg1702z00_3886 =
										BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1258z00_3885),
										BgL_arg1702z00_3886);
								}
								{	/* Stackable/walk.scm 38 */
									BgL_objectz00_bglt BgL_tmpz00_4677;

									BgL_tmpz00_4677 = ((BgL_objectz00_bglt) BgL_new1258z00_3885);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4677, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1258z00_3885);
								BgL_auxz00_4672 = BgL_new1258z00_3885;
							}
							BgL_tmp1259z00_3883 = ((BgL_appz00_bglt) BgL_auxz00_4672);
						}
						BgL_wide1260z00_3884 =
							((BgL_appzf2depthzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_appzf2depthzf2_bgl))));
						{	/* Stackable/walk.scm 38 */
							obj_t BgL_auxz00_4685;
							BgL_objectz00_bglt BgL_tmpz00_4683;

							BgL_auxz00_4685 = ((obj_t) BgL_wide1260z00_3884);
							BgL_tmpz00_4683 = ((BgL_objectz00_bglt) BgL_tmp1259z00_3883);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4683, BgL_auxz00_4685);
						}
						((BgL_objectz00_bglt) BgL_tmp1259z00_3883);
						{	/* Stackable/walk.scm 38 */
							long BgL_arg1699z00_3887;

							BgL_arg1699z00_3887 =
								BGL_CLASS_INDEX(BGl_appzf2depthzf2zzstackable_walkz00);
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_tmp1259z00_3883),
								BgL_arg1699z00_3887);
						}
						BgL_new1261z00_3882 = ((BgL_appz00_bglt) BgL_tmp1259z00_3883);
					}
					((((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt) BgL_new1261z00_3882)))->BgL_locz00) =
						((obj_t) BgL_loc1105z00_3628), BUNSPEC);
					((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
										BgL_new1261z00_3882)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_type1106z00_3629)),
						BUNSPEC);
					((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
										BgL_new1261z00_3882)))->BgL_sidezd2effectzd2) =
						((obj_t) BgL_sidezd2effect1107zd2_3630), BUNSPEC);
					((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
										BgL_new1261z00_3882)))->BgL_keyz00) =
						((obj_t) BgL_key1108z00_3631), BUNSPEC);
					((((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt)
										BgL_new1261z00_3882)))->BgL_funz00) =
						((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_fun1109z00_3632)),
						BUNSPEC);
					((((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt)
										BgL_new1261z00_3882)))->BgL_argsz00) =
						((obj_t) BgL_args1110z00_3633), BUNSPEC);
					((((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt)
										BgL_new1261z00_3882)))->BgL_stackablez00) =
						((obj_t) BgL_stackable1111z00_3634), BUNSPEC);
					{
						BgL_appzf2depthzf2_bglt BgL_auxz00_4709;

						{
							obj_t BgL_auxz00_4710;

							{	/* Stackable/walk.scm 38 */
								BgL_objectz00_bglt BgL_tmpz00_4711;

								BgL_tmpz00_4711 = ((BgL_objectz00_bglt) BgL_new1261z00_3882);
								BgL_auxz00_4710 = BGL_OBJECT_WIDENING(BgL_tmpz00_4711);
							}
							BgL_auxz00_4709 = ((BgL_appzf2depthzf2_bglt) BgL_auxz00_4710);
						}
						((((BgL_appzf2depthzf2_bglt) COBJECT(BgL_auxz00_4709))->
								BgL_depthz00) = ((long) BgL_depth1112z00_3881), BUNSPEC);
					}
					return BgL_new1261z00_3882;
				}
			}
		}

	}



/* &lambda1723 */
	obj_t BGl_z62lambda1723z62zzstackable_walkz00(obj_t BgL_envz00_3636,
		obj_t BgL_oz00_3637, obj_t BgL_vz00_3638)
	{
		{	/* Stackable/walk.scm 38 */
			{	/* Stackable/walk.scm 38 */
				long BgL_vz00_3889;

				BgL_vz00_3889 = (long) CINT(BgL_vz00_3638);
				{
					BgL_appzf2depthzf2_bglt BgL_auxz00_4717;

					{
						obj_t BgL_auxz00_4718;

						{	/* Stackable/walk.scm 38 */
							BgL_objectz00_bglt BgL_tmpz00_4719;

							BgL_tmpz00_4719 =
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_oz00_3637));
							BgL_auxz00_4718 = BGL_OBJECT_WIDENING(BgL_tmpz00_4719);
						}
						BgL_auxz00_4717 = ((BgL_appzf2depthzf2_bglt) BgL_auxz00_4718);
					}
					return
						((((BgL_appzf2depthzf2_bglt) COBJECT(BgL_auxz00_4717))->
							BgL_depthz00) = ((long) BgL_vz00_3889), BUNSPEC);
		}}}

	}



/* &lambda1722 */
	obj_t BGl_z62lambda1722z62zzstackable_walkz00(obj_t BgL_envz00_3639,
		obj_t BgL_oz00_3640)
	{
		{	/* Stackable/walk.scm 38 */
			{	/* Stackable/walk.scm 38 */
				long BgL_tmpz00_4725;

				{
					BgL_appzf2depthzf2_bglt BgL_auxz00_4726;

					{
						obj_t BgL_auxz00_4727;

						{	/* Stackable/walk.scm 38 */
							BgL_objectz00_bglt BgL_tmpz00_4728;

							BgL_tmpz00_4728 =
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_oz00_3640));
							BgL_auxz00_4727 = BGL_OBJECT_WIDENING(BgL_tmpz00_4728);
						}
						BgL_auxz00_4726 = ((BgL_appzf2depthzf2_bglt) BgL_auxz00_4727);
					}
					BgL_tmpz00_4725 =
						(((BgL_appzf2depthzf2_bglt) COBJECT(BgL_auxz00_4726))->
						BgL_depthz00);
				}
				return BINT(BgL_tmpz00_4725);
			}
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzstackable_walkz00()
	{
		{	/* Stackable/walk.scm 16 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00,
				BGl_proc2275z00zzstackable_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2276z00zzstackable_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_escapez12zd2envzc0zzstackable_walkz00,
				BGl_proc2277z00zzstackable_walkz00, BFALSE,
				BGl_string2278z00zzstackable_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_nodezd2escapezd2envz00zzstackable_walkz00,
				BGl_proc2279z00zzstackable_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2280z00zzstackable_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_liftzd2letz12zd2envz12zzstackable_walkz00,
				BGl_proc2281z00zzstackable_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2282z00zzstackable_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_depthzd2letzd2envz00zzstackable_walkz00,
				BGl_proc2283z00zzstackable_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2284z00zzstackable_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_initzd2stackablezd2envz00zzstackable_walkz00,
				BGl_proc2285z00zzstackable_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2286z00zzstackable_walkz00);
		}

	}



/* &init-stackable1514 */
	obj_t BGl_z62initzd2stackable1514zb0zzstackable_walkz00(obj_t BgL_envz00_3663,
		obj_t BgL_nodez00_3664)
	{
		{	/* Stackable/walk.scm 534 */
			return
				BGl_walk0z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3664),
				BGl_initzd2stackablezd2envz00zzstackable_walkz00);
		}

	}



/* &depth-let1501 */
	obj_t BGl_z62depthzd2let1501zb0zzstackable_walkz00(obj_t BgL_envz00_3665,
		obj_t BgL_nodez00_3666, obj_t BgL_depthz00_3667, obj_t BgL_funz00_3668)
	{
		{	/* Stackable/walk.scm 454 */
			{

				return
					BGl_walk2z00zzast_walkz00(
					((BgL_nodez00_bglt) BgL_nodez00_3666),
					BGl_depthzd2letzd2envz00zzstackable_walkz00, BgL_depthz00_3667,
					BgL_funz00_3668);
			}
		}

	}



/* &lift-let!1497 */
	obj_t BGl_z62liftzd2letz121497za2zzstackable_walkz00(obj_t BgL_envz00_3669,
		obj_t BgL_nodez00_3670)
	{
		{	/* Stackable/walk.scm 386 */
			return
				((obj_t)
				BGl_walk0z12z12zzast_walkz00(
					((BgL_nodez00_bglt) BgL_nodez00_3670),
					BGl_liftzd2letz12zd2envz12zzstackable_walkz00));
		}

	}



/* &node-escape1491 */
	obj_t BGl_z62nodezd2escape1491zb0zzstackable_walkz00(obj_t BgL_envz00_3671,
		obj_t BgL_nodez00_3672, obj_t BgL_ctxz00_3673)
	{
		{	/* Stackable/walk.scm 354 */
			{

				return
					BGl_walk1z00zzast_walkz00(
					((BgL_nodez00_bglt) BgL_nodez00_3672),
					BGl_nodezd2escapezd2envz00zzstackable_walkz00, BgL_ctxz00_3673);
			}
		}

	}



/* &escape!1476 */
	obj_t BGl_z62escapez121476z70zzstackable_walkz00(obj_t BgL_envz00_3674,
		obj_t BgL_nodez00_3675, obj_t BgL_ctxz00_3676)
	{
		{	/* Stackable/walk.scm 295 */
			{	/* Stackable/walk.scm 296 */
				obj_t BgL_arg1787z00_3898;
				obj_t BgL_arg1789z00_3899;

				{	/* Stackable/walk.scm 296 */
					obj_t BgL_tmpz00_4750;

					BgL_tmpz00_4750 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_arg1787z00_3898 = BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_4750);
				}
				BgL_arg1789z00_3899 = BGl_shapez00zztools_shapez00(BgL_nodez00_3675);
				{	/* Stackable/walk.scm 296 */
					obj_t BgL_list1790z00_3900;

					{	/* Stackable/walk.scm 296 */
						obj_t BgL_arg1798z00_3901;

						{	/* Stackable/walk.scm 296 */
							obj_t BgL_arg1799z00_3902;

							{	/* Stackable/walk.scm 296 */
								obj_t BgL_arg1801z00_3903;

								{	/* Stackable/walk.scm 296 */
									obj_t BgL_arg1802z00_3904;

									{	/* Stackable/walk.scm 296 */
										obj_t BgL_arg1804z00_3905;

										BgL_arg1804z00_3905 =
											MAKE_YOUNG_PAIR(BgL_arg1789z00_3899, BNIL);
										BgL_arg1802z00_3904 =
											MAKE_YOUNG_PAIR(BGl_string2287z00zzstackable_walkz00,
											BgL_arg1804z00_3905);
									}
									BgL_arg1801z00_3903 =
										MAKE_YOUNG_PAIR(BGl_string2288z00zzstackable_walkz00,
										BgL_arg1802z00_3904);
								}
								BgL_arg1799z00_3902 =
									MAKE_YOUNG_PAIR(BINT(((long) 296)), BgL_arg1801z00_3903);
							}
							BgL_arg1798z00_3901 =
								MAKE_YOUNG_PAIR(BGl_string2289z00zzstackable_walkz00,
								BgL_arg1799z00_3902);
						}
						BgL_list1790z00_3900 =
							MAKE_YOUNG_PAIR(BGl_string2290z00zzstackable_walkz00,
							BgL_arg1798z00_3901);
					}
					BGl_tprintz00zz__r4_output_6_10_3z00(BgL_arg1787z00_3898,
						BgL_list1790z00_3900);
			}}
			return BUNSPEC;
		}

	}



/* &stackable1456 */
	obj_t BGl_z62stackable1456z62zzstackable_walkz00(obj_t BgL_envz00_3677,
		obj_t BgL_nodez00_3678, obj_t BgL_escpz00_3679, obj_t BgL_depthz00_3680,
		obj_t BgL_ctxz00_3681)
	{
		{	/* Stackable/walk.scm 113 */
			{	/* Stackable/walk.scm 113 */
				bool_t BgL_escpz00_3907;
				long BgL_depthz00_3908;

				BgL_escpz00_3907 = CBOOL(BgL_escpz00_3679);
				BgL_depthz00_3908 = (long) CINT(BgL_depthz00_3680);
				{

					BgL_escpz00_3907 = ((bool_t) 1);
					return
						BGl_walk3z00zzast_walkz00(
						((BgL_nodez00_bglt) BgL_nodez00_3678),
						BGl_stackablezd2envzd2zzstackable_walkz00, BBOOL(BgL_escpz00_3907),
						BINT(BgL_depthz00_3908), ((obj_t) BgL_ctxz00_3681));
				}
			}
		}

	}



/* stackable */
	obj_t BGl_stackablez00zzstackable_walkz00(BgL_nodez00_bglt BgL_nodez00_23,
		bool_t BgL_escpz00_24, long BgL_depthz00_25, obj_t BgL_ctxz00_26)
	{
		{	/* Stackable/walk.scm 113 */
			{	/* Stackable/walk.scm 113 */
				obj_t BgL_method1457z00_2038;

				{	/* Stackable/walk.scm 113 */
					obj_t BgL_res2224z00_3280;

					{	/* Stackable/walk.scm 113 */
						long BgL_objzd2classzd2numz00_3251;

						BgL_objzd2classzd2numz00_3251 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_23));
						{	/* Stackable/walk.scm 113 */
							obj_t BgL_arg1791z00_3252;

							BgL_arg1791z00_3252 =
								PROCEDURE_REF(BGl_stackablezd2envzd2zzstackable_walkz00,
								(int) (((long) 1)));
							{	/* Stackable/walk.scm 113 */
								int BgL_offsetz00_3255;

								BgL_offsetz00_3255 = (int) (BgL_objzd2classzd2numz00_3251);
								{	/* Stackable/walk.scm 113 */
									long BgL_offsetz00_3256;

									BgL_offsetz00_3256 =
										((long) (BgL_offsetz00_3255) - OBJECT_TYPE);
									{	/* Stackable/walk.scm 113 */
										long BgL_modz00_3257;

										BgL_modz00_3257 =
											(BgL_offsetz00_3256 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Stackable/walk.scm 113 */
											long BgL_restz00_3259;

											BgL_restz00_3259 =
												(BgL_offsetz00_3256 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Stackable/walk.scm 113 */

												{	/* Stackable/walk.scm 113 */
													obj_t BgL_bucketz00_3261;

													BgL_bucketz00_3261 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_3252), BgL_modz00_3257);
													BgL_res2224z00_3280 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_3261), BgL_restz00_3259);
					}}}}}}}}
					BgL_method1457z00_2038 = BgL_res2224z00_3280;
				}
				return
					PROCEDURE_ENTRY(BgL_method1457z00_2038) (BgL_method1457z00_2038,
					((obj_t) BgL_nodez00_23),
					BBOOL(BgL_escpz00_24), BINT(BgL_depthz00_25), BgL_ctxz00_26, BEOA);
			}
		}

	}



/* &stackable */
	obj_t BGl_z62stackablez62zzstackable_walkz00(obj_t BgL_envz00_3658,
		obj_t BgL_nodez00_3659, obj_t BgL_escpz00_3660, obj_t BgL_depthz00_3661,
		obj_t BgL_ctxz00_3662)
	{
		{	/* Stackable/walk.scm 113 */
			return
				BGl_stackablez00zzstackable_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3659),
				CBOOL(BgL_escpz00_3660),
				(long) CINT(BgL_depthz00_3661), BgL_ctxz00_3662);
		}

	}



/* escape! */
	obj_t BGl_escapez12z12zzstackable_walkz00(obj_t BgL_nodez00_63,
		obj_t BgL_ctxz00_64)
	{
		{	/* Stackable/walk.scm 295 */
			if (BGL_OBJECTP(BgL_nodez00_63))
				{	/* Stackable/walk.scm 295 */
					obj_t BgL_method1477z00_2040;

					{	/* Stackable/walk.scm 295 */
						obj_t BgL_res2229z00_3311;

						{	/* Stackable/walk.scm 295 */
							long BgL_objzd2classzd2numz00_3282;

							BgL_objzd2classzd2numz00_3282 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_63));
							{	/* Stackable/walk.scm 295 */
								obj_t BgL_arg1791z00_3283;

								BgL_arg1791z00_3283 =
									PROCEDURE_REF(BGl_escapez12zd2envzc0zzstackable_walkz00,
									(int) (((long) 1)));
								{	/* Stackable/walk.scm 295 */
									int BgL_offsetz00_3286;

									BgL_offsetz00_3286 = (int) (BgL_objzd2classzd2numz00_3282);
									{	/* Stackable/walk.scm 295 */
										long BgL_offsetz00_3287;

										BgL_offsetz00_3287 =
											((long) (BgL_offsetz00_3286) - OBJECT_TYPE);
										{	/* Stackable/walk.scm 295 */
											long BgL_modz00_3288;

											BgL_modz00_3288 =
												(BgL_offsetz00_3287 >>
												(int) ((long) ((int) (((long) 4)))));
											{	/* Stackable/walk.scm 295 */
												long BgL_restz00_3290;

												BgL_restz00_3290 =
													(BgL_offsetz00_3287 &
													(long) (
														(int) (
															((long) (
																	(int) (
																		(((long) 1) <<
																			(int) (
																				(long) (
																					(int) (((long) 4))))))) -
																((long) 1)))));
												{	/* Stackable/walk.scm 295 */

													{	/* Stackable/walk.scm 295 */
														obj_t BgL_bucketz00_3292;

														BgL_bucketz00_3292 =
															VECTOR_REF(
															((obj_t) BgL_arg1791z00_3283), BgL_modz00_3288);
														BgL_res2229z00_3311 =
															VECTOR_REF(
															((obj_t) BgL_bucketz00_3292), BgL_restz00_3290);
						}}}}}}}}
						BgL_method1477z00_2040 = BgL_res2229z00_3311;
					}
					return
						PROCEDURE_ENTRY(BgL_method1477z00_2040) (BgL_method1477z00_2040,
						BgL_nodez00_63, BgL_ctxz00_64, BEOA);
				}
			else
				{	/* Stackable/walk.scm 295 */
					obj_t BgL_fun1824z00_2041;

					BgL_fun1824z00_2041 =
						PROCEDURE_REF(BGl_escapez12zd2envzc0zzstackable_walkz00,
						(int) (((long) 0)));
					return
						PROCEDURE_ENTRY(BgL_fun1824z00_2041) (BgL_fun1824z00_2041,
						BgL_nodez00_63, BgL_ctxz00_64, BEOA);
				}
		}

	}



/* &escape! */
	obj_t BGl_z62escapez12z70zzstackable_walkz00(obj_t BgL_envz00_3682,
		obj_t BgL_nodez00_3683, obj_t BgL_ctxz00_3684)
	{
		{	/* Stackable/walk.scm 295 */
			return
				BGl_escapez12z12zzstackable_walkz00(BgL_nodez00_3683, BgL_ctxz00_3684);
		}

	}



/* node-escape */
	obj_t BGl_nodezd2escapezd2zzstackable_walkz00(BgL_nodez00_bglt BgL_nodez00_77,
		obj_t BgL_ctxz00_78)
	{
		{	/* Stackable/walk.scm 354 */
			{	/* Stackable/walk.scm 354 */
				obj_t BgL_method1492z00_2042;

				{	/* Stackable/walk.scm 354 */
					obj_t BgL_res2235z00_3343;

					{	/* Stackable/walk.scm 354 */
						long BgL_objzd2classzd2numz00_3314;

						BgL_objzd2classzd2numz00_3314 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_77));
						{	/* Stackable/walk.scm 354 */
							obj_t BgL_arg1791z00_3315;

							BgL_arg1791z00_3315 =
								PROCEDURE_REF(BGl_nodezd2escapezd2envz00zzstackable_walkz00,
								(int) (((long) 1)));
							{	/* Stackable/walk.scm 354 */
								int BgL_offsetz00_3318;

								BgL_offsetz00_3318 = (int) (BgL_objzd2classzd2numz00_3314);
								{	/* Stackable/walk.scm 354 */
									long BgL_offsetz00_3319;

									BgL_offsetz00_3319 =
										((long) (BgL_offsetz00_3318) - OBJECT_TYPE);
									{	/* Stackable/walk.scm 354 */
										long BgL_modz00_3320;

										BgL_modz00_3320 =
											(BgL_offsetz00_3319 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Stackable/walk.scm 354 */
											long BgL_restz00_3322;

											BgL_restz00_3322 =
												(BgL_offsetz00_3319 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Stackable/walk.scm 354 */

												{	/* Stackable/walk.scm 354 */
													obj_t BgL_bucketz00_3324;

													BgL_bucketz00_3324 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_3315), BgL_modz00_3320);
													BgL_res2235z00_3343 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_3324), BgL_restz00_3322);
					}}}}}}}}
					BgL_method1492z00_2042 = BgL_res2235z00_3343;
				}
				return
					PROCEDURE_ENTRY(BgL_method1492z00_2042) (BgL_method1492z00_2042,
					((obj_t) BgL_nodez00_77), BgL_ctxz00_78, BEOA);
			}
		}

	}



/* &node-escape */
	obj_t BGl_z62nodezd2escapezb0zzstackable_walkz00(obj_t BgL_envz00_3653,
		obj_t BgL_nodez00_3654, obj_t BgL_ctxz00_3655)
	{
		{	/* Stackable/walk.scm 354 */
			return
				BGl_nodezd2escapezd2zzstackable_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3654), BgL_ctxz00_3655);
		}

	}



/* lift-let! */
	BgL_nodez00_bglt BGl_liftzd2letz12zc0zzstackable_walkz00(BgL_nodez00_bglt
		BgL_nodez00_84)
	{
		{	/* Stackable/walk.scm 386 */
			{	/* Stackable/walk.scm 386 */
				obj_t BgL_method1498z00_2043;

				{	/* Stackable/walk.scm 386 */
					obj_t BgL_res2240z00_3374;

					{	/* Stackable/walk.scm 386 */
						long BgL_objzd2classzd2numz00_3345;

						BgL_objzd2classzd2numz00_3345 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_84));
						{	/* Stackable/walk.scm 386 */
							obj_t BgL_arg1791z00_3346;

							BgL_arg1791z00_3346 =
								PROCEDURE_REF(BGl_liftzd2letz12zd2envz12zzstackable_walkz00,
								(int) (((long) 1)));
							{	/* Stackable/walk.scm 386 */
								int BgL_offsetz00_3349;

								BgL_offsetz00_3349 = (int) (BgL_objzd2classzd2numz00_3345);
								{	/* Stackable/walk.scm 386 */
									long BgL_offsetz00_3350;

									BgL_offsetz00_3350 =
										((long) (BgL_offsetz00_3349) - OBJECT_TYPE);
									{	/* Stackable/walk.scm 386 */
										long BgL_modz00_3351;

										BgL_modz00_3351 =
											(BgL_offsetz00_3350 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Stackable/walk.scm 386 */
											long BgL_restz00_3353;

											BgL_restz00_3353 =
												(BgL_offsetz00_3350 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Stackable/walk.scm 386 */

												{	/* Stackable/walk.scm 386 */
													obj_t BgL_bucketz00_3355;

													BgL_bucketz00_3355 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_3346), BgL_modz00_3351);
													BgL_res2240z00_3374 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_3355), BgL_restz00_3353);
					}}}}}}}}
					BgL_method1498z00_2043 = BgL_res2240z00_3374;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1498z00_2043) (BgL_method1498z00_2043,
						((obj_t) BgL_nodez00_84), BEOA));
			}
		}

	}



/* &lift-let! */
	BgL_nodez00_bglt BGl_z62liftzd2letz12za2zzstackable_walkz00(obj_t
		BgL_envz00_3650, obj_t BgL_nodez00_3651)
	{
		{	/* Stackable/walk.scm 386 */
			return
				BGl_liftzd2letz12zc0zzstackable_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3651));
		}

	}



/* depth-let */
	obj_t BGl_depthzd2letzd2zzstackable_walkz00(BgL_nodez00_bglt BgL_nodez00_87,
		obj_t BgL_depthz00_88, obj_t BgL_funz00_89)
	{
		{	/* Stackable/walk.scm 454 */
			{	/* Stackable/walk.scm 454 */
				obj_t BgL_method1503z00_2044;

				{	/* Stackable/walk.scm 454 */
					obj_t BgL_res2245z00_3405;

					{	/* Stackable/walk.scm 454 */
						long BgL_objzd2classzd2numz00_3376;

						BgL_objzd2classzd2numz00_3376 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_87));
						{	/* Stackable/walk.scm 454 */
							obj_t BgL_arg1791z00_3377;

							BgL_arg1791z00_3377 =
								PROCEDURE_REF(BGl_depthzd2letzd2envz00zzstackable_walkz00,
								(int) (((long) 1)));
							{	/* Stackable/walk.scm 454 */
								int BgL_offsetz00_3380;

								BgL_offsetz00_3380 = (int) (BgL_objzd2classzd2numz00_3376);
								{	/* Stackable/walk.scm 454 */
									long BgL_offsetz00_3381;

									BgL_offsetz00_3381 =
										((long) (BgL_offsetz00_3380) - OBJECT_TYPE);
									{	/* Stackable/walk.scm 454 */
										long BgL_modz00_3382;

										BgL_modz00_3382 =
											(BgL_offsetz00_3381 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Stackable/walk.scm 454 */
											long BgL_restz00_3384;

											BgL_restz00_3384 =
												(BgL_offsetz00_3381 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Stackable/walk.scm 454 */

												{	/* Stackable/walk.scm 454 */
													obj_t BgL_bucketz00_3386;

													BgL_bucketz00_3386 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_3377), BgL_modz00_3382);
													BgL_res2245z00_3405 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_3386), BgL_restz00_3384);
					}}}}}}}}
					BgL_method1503z00_2044 = BgL_res2245z00_3405;
				}
				return
					PROCEDURE_ENTRY(BgL_method1503z00_2044) (BgL_method1503z00_2044,
					((obj_t) BgL_nodez00_87), BgL_depthz00_88, BgL_funz00_89, BEOA);
			}
		}

	}



/* &depth-let */
	obj_t BGl_z62depthzd2letzb0zzstackable_walkz00(obj_t BgL_envz00_3645,
		obj_t BgL_nodez00_3646, obj_t BgL_depthz00_3647, obj_t BgL_funz00_3648)
	{
		{	/* Stackable/walk.scm 454 */
			return
				BGl_depthzd2letzd2zzstackable_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3646), BgL_depthz00_3647,
				BgL_funz00_3648);
		}

	}



/* init-stackable */
	obj_t BGl_initzd2stackablezd2zzstackable_walkz00(BgL_nodez00_bglt
		BgL_nodez00_106)
	{
		{	/* Stackable/walk.scm 534 */
			{	/* Stackable/walk.scm 534 */
				obj_t BgL_method1515z00_2045;

				{	/* Stackable/walk.scm 534 */
					obj_t BgL_res2250z00_3436;

					{	/* Stackable/walk.scm 534 */
						long BgL_objzd2classzd2numz00_3407;

						BgL_objzd2classzd2numz00_3407 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_106));
						{	/* Stackable/walk.scm 534 */
							obj_t BgL_arg1791z00_3408;

							BgL_arg1791z00_3408 =
								PROCEDURE_REF(BGl_initzd2stackablezd2envz00zzstackable_walkz00,
								(int) (((long) 1)));
							{	/* Stackable/walk.scm 534 */
								int BgL_offsetz00_3411;

								BgL_offsetz00_3411 = (int) (BgL_objzd2classzd2numz00_3407);
								{	/* Stackable/walk.scm 534 */
									long BgL_offsetz00_3412;

									BgL_offsetz00_3412 =
										((long) (BgL_offsetz00_3411) - OBJECT_TYPE);
									{	/* Stackable/walk.scm 534 */
										long BgL_modz00_3413;

										BgL_modz00_3413 =
											(BgL_offsetz00_3412 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Stackable/walk.scm 534 */
											long BgL_restz00_3415;

											BgL_restz00_3415 =
												(BgL_offsetz00_3412 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Stackable/walk.scm 534 */

												{	/* Stackable/walk.scm 534 */
													obj_t BgL_bucketz00_3417;

													BgL_bucketz00_3417 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_3408), BgL_modz00_3413);
													BgL_res2250z00_3436 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_3417), BgL_restz00_3415);
					}}}}}}}}
					BgL_method1515z00_2045 = BgL_res2250z00_3436;
				}
				return
					PROCEDURE_ENTRY(BgL_method1515z00_2045) (BgL_method1515z00_2045,
					((obj_t) BgL_nodez00_106), BEOA);
			}
		}

	}



/* &init-stackable */
	obj_t BGl_z62initzd2stackablezb0zzstackable_walkz00(obj_t BgL_envz00_3642,
		obj_t BgL_nodez00_3643)
	{
		{	/* Stackable/walk.scm 534 */
			return
				BGl_initzd2stackablezd2zzstackable_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3643));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzstackable_walkz00()
	{
		{	/* Stackable/walk.scm 16 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shapezd2envzd2zztools_shapez00,
				BGl_localzf2depthzf2zzstackable_walkz00,
				BGl_proc2291z00zzstackable_walkz00,
				BGl_string2292z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_nodezd2ze3sexpzd2envze3zzast_dumpz00,
				BGl_appzf2depthzf2zzstackable_walkz00,
				BGl_proc2293z00zzstackable_walkz00,
				BGl_string2294z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00, BGl_varz00zzast_nodez00,
				BGl_proc2295z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00, BGl_closurez00zzast_nodez00,
				BGl_proc2297z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc2298z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2299z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2300z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2301z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2302z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc2303z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_stackablezd2envzd2zzstackable_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2304z00zzstackable_walkz00,
				BGl_string2296z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_escapez12zd2envzc0zzstackable_walkz00, BGl_globalz00zzast_varz00,
				BGl_proc2305z00zzstackable_walkz00,
				BGl_string2306z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_escapez12zd2envzc0zzstackable_walkz00, BGl_localz00zzast_varz00,
				BGl_proc2307z00zzstackable_walkz00,
				BGl_string2306z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_escapez12zd2envzc0zzstackable_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc2308z00zzstackable_walkz00,
				BGl_string2306z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_escapez12zd2envzc0zzstackable_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2309z00zzstackable_walkz00,
				BGl_string2306z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_escapez12zd2envzc0zzstackable_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2310z00zzstackable_walkz00,
				BGl_string2306z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_escapez12zd2envzc0zzstackable_walkz00, BGl_closurez00zzast_nodez00,
				BGl_proc2311z00zzstackable_walkz00,
				BGl_string2312z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_nodezd2escapezd2envz00zzstackable_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2313z00zzstackable_walkz00,
				BGl_string2314z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_nodezd2escapezd2envz00zzstackable_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2315z00zzstackable_walkz00,
				BGl_string2314z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_liftzd2letz12zd2envz12zzstackable_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2316z00zzstackable_walkz00,
				BGl_string2317z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_depthzd2letzd2envz00zzstackable_walkz00, BGl_varz00zzast_nodez00,
				BGl_proc2318z00zzstackable_walkz00,
				BGl_string2319z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_depthzd2letzd2envz00zzstackable_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2320z00zzstackable_walkz00,
				BGl_string2319z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_depthzd2letzd2envz00zzstackable_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2321z00zzstackable_walkz00,
				BGl_string2319z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_depthzd2letzd2envz00zzstackable_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2322z00zzstackable_walkz00,
				BGl_string2319z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_depthzd2letzd2envz00zzstackable_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2323z00zzstackable_walkz00,
				BGl_string2319z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_initzd2stackablezd2envz00zzstackable_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2324z00zzstackable_walkz00,
				BGl_string2325z00zzstackable_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_initzd2stackablezd2envz00zzstackable_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2326z00zzstackable_walkz00,
				BGl_string2325z00zzstackable_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_initzd2stackablezd2envz00zzstackable_walkz00,
				BGl_closurez00zzast_nodez00, BGl_proc2327z00zzstackable_walkz00,
				BGl_string2325z00zzstackable_walkz00);
		}

	}



/* &init-stackable-closu1521 */
	obj_t BGl_z62initzd2stackablezd2closu1521z62zzstackable_walkz00(obj_t
		BgL_envz00_3717, obj_t BgL_nodez00_3718)
	{
		{	/* Stackable/walk.scm 556 */
			BGl_walk0z00zzast_walkz00(
				((BgL_nodez00_bglt)
					((BgL_closurez00_bglt) BgL_nodez00_3718)),
				BGl_initzd2stackablezd2envz00zzstackable_walkz00);
			{	/* Stackable/walk.scm 558 */
				BgL_variablez00_bglt BgL_vz00_3912;

				BgL_vz00_3912 =
					(((BgL_varz00_bglt) COBJECT(
							((BgL_varz00_bglt)
								((BgL_closurez00_bglt) BgL_nodez00_3718))))->BgL_variablez00);
				{	/* Stackable/walk.scm 558 */
					BgL_valuez00_bglt BgL_fz00_3913;

					BgL_fz00_3913 =
						(((BgL_variablez00_bglt) COBJECT(BgL_vz00_3912))->BgL_valuez00);
					{	/* Stackable/walk.scm 559 */

						return
							((((BgL_sfunz00_bglt) COBJECT(
										((BgL_sfunz00_bglt) BgL_fz00_3913)))->BgL_stackablez00) =
							((obj_t) BTRUE), BUNSPEC);
					}
				}
			}
		}

	}



/* &init-stackable-make-1519 */
	obj_t BGl_z62initzd2stackablezd2makezd21519zb0zzstackable_walkz00(obj_t
		BgL_envz00_3719, obj_t BgL_nodez00_3720)
	{
		{	/* Stackable/walk.scm 548 */
			BGl_walk0z00zzast_walkz00(
				((BgL_nodez00_bglt)
					((BgL_makezd2boxzd2_bglt) BgL_nodez00_3720)),
				BGl_initzd2stackablezd2envz00zzstackable_walkz00);
			return ((((BgL_makezd2boxzd2_bglt) COBJECT(((BgL_makezd2boxzd2_bglt)
								BgL_nodez00_3720)))->BgL_stackablez00) =
				((obj_t) BTRUE), BUNSPEC);
		}

	}



/* &init-stackable-app1517 */
	obj_t BGl_z62initzd2stackablezd2app1517z62zzstackable_walkz00(obj_t
		BgL_envz00_3721, obj_t BgL_nodez00_3722)
	{
		{	/* Stackable/walk.scm 540 */
			BGl_walk0z00zzast_walkz00(
				((BgL_nodez00_bglt)
					((BgL_appz00_bglt) BgL_nodez00_3722)),
				BGl_initzd2stackablezd2envz00zzstackable_walkz00);
			return ((((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt)
								BgL_nodez00_3722)))->BgL_stackablez00) =
				((obj_t) BTRUE), BUNSPEC);
		}

	}



/* &depth-let-set-ex-it1513 */
	obj_t BGl_z62depthzd2letzd2setzd2exzd2it1513z62zzstackable_walkz00(obj_t
		BgL_envz00_3723, obj_t BgL_nodez00_3724, obj_t BgL_depthz00_3725,
		obj_t BgL_funz00_3726)
	{
		{	/* Stackable/walk.scm 512 */
			{

				BGl_walk2z00zzast_walkz00(
					((BgL_nodez00_bglt)
						((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3724)),
					BGl_depthzd2letzd2envz00zzstackable_walkz00, BgL_depthz00_3725,
					BgL_funz00_3726);
				{	/* Stackable/walk.scm 515 */
					BgL_varz00_bglt BgL_i1247z00_3918;

					BgL_i1247z00_3918 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3724)))->BgL_varz00);
					{	/* Stackable/walk.scm 516 */
						BgL_localz00_bglt BgL_i1248z00_3919;

						BgL_i1248z00_3919 =
							((BgL_localz00_bglt)
							(((BgL_varz00_bglt) COBJECT(BgL_i1247z00_3918))->
								BgL_variablez00));
						((((BgL_localz00_bglt) COBJECT(BgL_i1248z00_3919))->
								BgL_valzd2noescapezd2) = ((obj_t) BFALSE), BUNSPEC);
					}
					{	/* Stackable/walk.scm 518 */
						BgL_localz00_bglt BgL_tmp1249z00_3920;

						BgL_tmp1249z00_3920 =
							((BgL_localz00_bglt)
							(((BgL_varz00_bglt) COBJECT(BgL_i1247z00_3918))->
								BgL_variablez00));
						{	/* Stackable/walk.scm 518 */
							BgL_localzf2depthzf2_bglt BgL_wide1251z00_3921;

							BgL_wide1251z00_3921 =
								((BgL_localzf2depthzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_localzf2depthzf2_bgl))));
							{	/* Stackable/walk.scm 518 */
								obj_t BgL_auxz00_5041;
								BgL_objectz00_bglt BgL_tmpz00_5038;

								BgL_auxz00_5041 = ((obj_t) BgL_wide1251z00_3921);
								BgL_tmpz00_5038 =
									((BgL_objectz00_bglt)
									((BgL_localz00_bglt) BgL_tmp1249z00_3920));
								BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5038, BgL_auxz00_5041);
							}
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_tmp1249z00_3920));
							{	/* Stackable/walk.scm 518 */
								long BgL_arg2137z00_3922;

								BgL_arg2137z00_3922 =
									BGL_CLASS_INDEX(BGl_localzf2depthzf2zzstackable_walkz00);
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt)
										((BgL_localz00_bglt) BgL_tmp1249z00_3920)),
									BgL_arg2137z00_3922);
							}
							((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_tmp1249z00_3920));
						}
						{
							BgL_localzf2depthzf2_bglt BgL_auxz00_5052;

							{
								obj_t BgL_auxz00_5053;

								{	/* Stackable/walk.scm 520 */
									BgL_objectz00_bglt BgL_tmpz00_5054;

									BgL_tmpz00_5054 =
										((BgL_objectz00_bglt)
										((BgL_localz00_bglt) BgL_tmp1249z00_3920));
									BgL_auxz00_5053 = BGL_OBJECT_WIDENING(BgL_tmpz00_5054);
								}
								BgL_auxz00_5052 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_5053);
							}
							((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5052))->
									BgL_depthz00) =
								((long) ((long) CINT(BgL_depthz00_3725) + ((long) 1))),
								BUNSPEC);
						}
						{
							BgL_localzf2depthzf2_bglt BgL_auxz00_5062;

							{
								obj_t BgL_auxz00_5063;

								{	/* Stackable/walk.scm 519 */
									BgL_objectz00_bglt BgL_tmpz00_5064;

									BgL_tmpz00_5064 =
										((BgL_objectz00_bglt)
										((BgL_localz00_bglt) BgL_tmp1249z00_3920));
									BgL_auxz00_5063 = BGL_OBJECT_WIDENING(BgL_tmpz00_5064);
								}
								BgL_auxz00_5062 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_5063);
							}
							((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5062))->
									BgL_ownerz00) = ((obj_t) BgL_funz00_3726), BUNSPEC);
						}
						((BgL_localz00_bglt) BgL_tmp1249z00_3920);
				}}
				{	/* Stackable/walk.scm 521 */
					BgL_nodez00_bglt BgL_arg2138z00_3923;
					long BgL_arg2141z00_3924;

					BgL_arg2138z00_3923 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3724)))->BgL_bodyz00);
					BgL_arg2141z00_3924 = ((long) CINT(BgL_depthz00_3725) + ((long) 1));
					return
						BGl_depthzd2letzd2zzstackable_walkz00(BgL_arg2138z00_3923,
						BINT(BgL_arg2141z00_3924), BgL_funz00_3726);
				}
			}
		}

	}



/* &depth-let-app1511 */
	obj_t BGl_z62depthzd2letzd2app1511z62zzstackable_walkz00(obj_t
		BgL_envz00_3727, obj_t BgL_nodez00_3728, obj_t BgL_depthz00_3729,
		obj_t BgL_funz00_3730)
	{
		{	/* Stackable/walk.scm 505 */
			{
				BgL_appz00_bglt BgL_auxz00_5077;

				{

					BGl_walk2z00zzast_walkz00(
						((BgL_nodez00_bglt)
							((BgL_appz00_bglt) BgL_nodez00_3728)),
						BGl_depthzd2letzd2envz00zzstackable_walkz00, BgL_depthz00_3729,
						BgL_funz00_3730);
					{	/* Stackable/walk.scm 507 */
						BgL_appzf2depthzf2_bglt BgL_wide1244z00_3927;

						BgL_wide1244z00_3927 =
							((BgL_appzf2depthzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_appzf2depthzf2_bgl))));
						{	/* Stackable/walk.scm 507 */
							obj_t BgL_auxz00_5086;
							BgL_objectz00_bglt BgL_tmpz00_5082;

							BgL_auxz00_5086 = ((obj_t) BgL_wide1244z00_3927);
							BgL_tmpz00_5082 =
								((BgL_objectz00_bglt)
								((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3728)));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5082, BgL_auxz00_5086);
						}
						((BgL_objectz00_bglt)
							((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3728)));
						{	/* Stackable/walk.scm 507 */
							long BgL_arg2133z00_3928;

							BgL_arg2133z00_3928 =
								BGL_CLASS_INDEX(BGl_appzf2depthzf2zzstackable_walkz00);
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_appz00_bglt)
										((BgL_appz00_bglt) BgL_nodez00_3728))),
								BgL_arg2133z00_3928);
						}
						((BgL_appz00_bglt)
							((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3728)));
					}
					{
						BgL_appzf2depthzf2_bglt BgL_auxz00_5100;

						{
							obj_t BgL_auxz00_5101;

							{	/* Stackable/walk.scm 507 */
								BgL_objectz00_bglt BgL_tmpz00_5102;

								BgL_tmpz00_5102 =
									((BgL_objectz00_bglt)
									((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3728)));
								BgL_auxz00_5101 = BGL_OBJECT_WIDENING(BgL_tmpz00_5102);
							}
							BgL_auxz00_5100 = ((BgL_appzf2depthzf2_bglt) BgL_auxz00_5101);
						}
						((((BgL_appzf2depthzf2_bglt) COBJECT(BgL_auxz00_5100))->
								BgL_depthz00) =
							((long) (long) CINT(BgL_depthz00_3729)), BUNSPEC);
					}
					BgL_auxz00_5077 =
						((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3728));
				}
				return ((obj_t) BgL_auxz00_5077);
			}
		}

	}



/* &depth-let-let-fun1509 */
	obj_t BGl_z62depthzd2letzd2letzd2fun1509zb0zzstackable_walkz00(obj_t
		BgL_envz00_3731, obj_t BgL_nodez00_3732, obj_t BgL_depthz00_3733,
		obj_t BgL_funz00_3734)
	{
		{	/* Stackable/walk.scm 484 */
			{	/* Stackable/walk.scm 485 */
				long BgL_depthz00_3930;

				BgL_depthz00_3930 = ((long) CINT(BgL_depthz00_3733) + ((long) 1));
				{	/* Stackable/walk.scm 487 */
					obj_t BgL_g1447z00_3931;

					BgL_g1447z00_3931 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_3732)))->BgL_localsz00);
					{
						obj_t BgL_l1445z00_3933;

						BgL_l1445z00_3933 = BgL_g1447z00_3931;
					BgL_zc3z04anonymousza32118ze3z87_3932:
						if (PAIRP(BgL_l1445z00_3933))
							{	/* Stackable/walk.scm 487 */
								{	/* Stackable/walk.scm 488 */
									obj_t BgL_localz00_3934;

									BgL_localz00_3934 = CAR(BgL_l1445z00_3933);
									{	/* Stackable/walk.scm 489 */
										BgL_localzf2depthzf2_bglt BgL_wide1235z00_3935;

										BgL_wide1235z00_3935 =
											((BgL_localzf2depthzf2_bglt)
											BOBJECT(GC_MALLOC(sizeof(struct
														BgL_localzf2depthzf2_bgl))));
										{	/* Stackable/walk.scm 489 */
											obj_t BgL_auxz00_5125;
											BgL_objectz00_bglt BgL_tmpz00_5121;

											BgL_auxz00_5125 = ((obj_t) BgL_wide1235z00_3935);
											BgL_tmpz00_5121 =
												((BgL_objectz00_bglt)
												((BgL_localz00_bglt)
													((BgL_localz00_bglt) BgL_localz00_3934)));
											BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5121, BgL_auxz00_5125);
										}
										((BgL_objectz00_bglt)
											((BgL_localz00_bglt)
												((BgL_localz00_bglt) BgL_localz00_3934)));
										{	/* Stackable/walk.scm 489 */
											long BgL_arg2120z00_3936;

											BgL_arg2120z00_3936 =
												BGL_CLASS_INDEX
												(BGl_localzf2depthzf2zzstackable_walkz00);
											BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt) (
														(BgL_localz00_bglt) ((BgL_localz00_bglt)
															BgL_localz00_3934))), BgL_arg2120z00_3936);
										}
										((BgL_localz00_bglt)
											((BgL_localz00_bglt)
												((BgL_localz00_bglt) BgL_localz00_3934)));
									}
									{
										BgL_localzf2depthzf2_bglt BgL_auxz00_5139;

										{
											obj_t BgL_auxz00_5140;

											{	/* Stackable/walk.scm 491 */
												BgL_objectz00_bglt BgL_tmpz00_5141;

												BgL_tmpz00_5141 =
													((BgL_objectz00_bglt)
													((BgL_localz00_bglt)
														((BgL_localz00_bglt) BgL_localz00_3934)));
												BgL_auxz00_5140 = BGL_OBJECT_WIDENING(BgL_tmpz00_5141);
											}
											BgL_auxz00_5139 =
												((BgL_localzf2depthzf2_bglt) BgL_auxz00_5140);
										}
										((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5139))->
												BgL_depthz00) = ((long) BgL_depthz00_3930), BUNSPEC);
									}
									{
										BgL_localzf2depthzf2_bglt BgL_auxz00_5148;

										{
											obj_t BgL_auxz00_5149;

											{	/* Stackable/walk.scm 490 */
												BgL_objectz00_bglt BgL_tmpz00_5150;

												BgL_tmpz00_5150 =
													((BgL_objectz00_bglt)
													((BgL_localz00_bglt)
														((BgL_localz00_bglt) BgL_localz00_3934)));
												BgL_auxz00_5149 = BGL_OBJECT_WIDENING(BgL_tmpz00_5150);
											}
											BgL_auxz00_5148 =
												((BgL_localzf2depthzf2_bglt) BgL_auxz00_5149);
										}
										((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5148))->
												BgL_ownerz00) = ((obj_t) BgL_funz00_3734), BUNSPEC);
									}
									((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_localz00_3934));
									{	/* Stackable/walk.scm 492 */
										BgL_sfunz00_bglt BgL_i1237z00_3937;

										BgL_i1237z00_3937 =
											((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt) BgL_localz00_3934))))->
												BgL_valuez00));
										{	/* Stackable/walk.scm 493 */
											obj_t BgL_g1444z00_3938;

											BgL_g1444z00_3938 =
												(((BgL_sfunz00_bglt) COBJECT(BgL_i1237z00_3937))->
												BgL_argsz00);
											{
												obj_t BgL_l1442z00_3940;

												BgL_l1442z00_3940 = BgL_g1444z00_3938;
											BgL_zc3z04anonymousza32121ze3z87_3939:
												if (PAIRP(BgL_l1442z00_3940))
													{	/* Stackable/walk.scm 493 */
														{	/* Stackable/walk.scm 494 */
															obj_t BgL_az00_3941;

															BgL_az00_3941 = CAR(BgL_l1442z00_3940);
															{	/* Stackable/walk.scm 494 */
																BgL_localzf2depthzf2_bglt BgL_wide1240z00_3942;

																BgL_wide1240z00_3942 =
																	((BgL_localzf2depthzf2_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_localzf2depthzf2_bgl))));
																{	/* Stackable/walk.scm 494 */
																	obj_t BgL_auxz00_5172;
																	BgL_objectz00_bglt BgL_tmpz00_5168;

																	BgL_auxz00_5172 =
																		((obj_t) BgL_wide1240z00_3942);
																	BgL_tmpz00_5168 =
																		((BgL_objectz00_bglt)
																		((BgL_localz00_bglt)
																			((BgL_localz00_bglt) BgL_az00_3941)));
																	BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5168,
																		BgL_auxz00_5172);
																}
																((BgL_objectz00_bglt)
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_az00_3941)));
																{	/* Stackable/walk.scm 494 */
																	long BgL_arg2123z00_3943;

																	BgL_arg2123z00_3943 =
																		BGL_CLASS_INDEX
																		(BGl_localzf2depthzf2zzstackable_walkz00);
																	BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt)
																			((BgL_localz00_bglt) ((BgL_localz00_bglt)
																					BgL_az00_3941))),
																		BgL_arg2123z00_3943);
																}
																((BgL_localz00_bglt)
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_az00_3941)));
															}
															{
																BgL_localzf2depthzf2_bglt BgL_auxz00_5186;

																{
																	obj_t BgL_auxz00_5187;

																	{	/* Stackable/walk.scm 496 */
																		BgL_objectz00_bglt BgL_tmpz00_5188;

																		BgL_tmpz00_5188 =
																			((BgL_objectz00_bglt)
																			((BgL_localz00_bglt)
																				((BgL_localz00_bglt) BgL_az00_3941)));
																		BgL_auxz00_5187 =
																			BGL_OBJECT_WIDENING(BgL_tmpz00_5188);
																	}
																	BgL_auxz00_5186 =
																		((BgL_localzf2depthzf2_bglt)
																		BgL_auxz00_5187);
																}
																((((BgL_localzf2depthzf2_bglt)
																			COBJECT(BgL_auxz00_5186))->BgL_depthz00) =
																	((long) (BgL_depthz00_3930 + ((long) 1))),
																	BUNSPEC);
															}
															{
																BgL_localzf2depthzf2_bglt BgL_auxz00_5196;

																{
																	obj_t BgL_auxz00_5197;

																	{	/* Stackable/walk.scm 495 */
																		BgL_objectz00_bglt BgL_tmpz00_5198;

																		BgL_tmpz00_5198 =
																			((BgL_objectz00_bglt)
																			((BgL_localz00_bglt)
																				((BgL_localz00_bglt) BgL_az00_3941)));
																		BgL_auxz00_5197 =
																			BGL_OBJECT_WIDENING(BgL_tmpz00_5198);
																	}
																	BgL_auxz00_5196 =
																		((BgL_localzf2depthzf2_bglt)
																		BgL_auxz00_5197);
																}
																((((BgL_localzf2depthzf2_bglt)
																			COBJECT(BgL_auxz00_5196))->BgL_ownerz00) =
																	((obj_t) BgL_localz00_3934), BUNSPEC);
															}
															((BgL_localz00_bglt)
																((BgL_localz00_bglt) BgL_az00_3941));
														}
														{
															obj_t BgL_l1442z00_5207;

															BgL_l1442z00_5207 = CDR(BgL_l1442z00_3940);
															BgL_l1442z00_3940 = BgL_l1442z00_5207;
															goto BgL_zc3z04anonymousza32121ze3z87_3939;
														}
													}
												else
													{	/* Stackable/walk.scm 493 */
														((bool_t) 1);
													}
											}
										}
										{	/* Stackable/walk.scm 498 */
											obj_t BgL_arg2126z00_3944;
											long BgL_arg2127z00_3945;

											BgL_arg2126z00_3944 =
												(((BgL_sfunz00_bglt) COBJECT(BgL_i1237z00_3937))->
												BgL_bodyz00);
											BgL_arg2127z00_3945 = (BgL_depthz00_3930 + ((long) 1));
											BGl_depthzd2letzd2zzstackable_walkz00(
												((BgL_nodez00_bglt) BgL_arg2126z00_3944),
												BINT(BgL_arg2127z00_3945), BgL_localz00_3934);
								}}}
								{
									obj_t BgL_l1445z00_5214;

									BgL_l1445z00_5214 = CDR(BgL_l1445z00_3933);
									BgL_l1445z00_3933 = BgL_l1445z00_5214;
									goto BgL_zc3z04anonymousza32118ze3z87_3932;
								}
							}
						else
							{	/* Stackable/walk.scm 487 */
								((bool_t) 1);
							}
					}
				}
				return
					BGl_depthzd2letzd2zzstackable_walkz00(
					(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_3732)))->BgL_bodyz00),
					BINT(BgL_depthz00_3930), BgL_funz00_3734);
			}
		}

	}



/* &depth-let-let-var1507 */
	obj_t BGl_z62depthzd2letzd2letzd2var1507zb0zzstackable_walkz00(obj_t
		BgL_envz00_3735, obj_t BgL_nodez00_3736, obj_t BgL_depthz00_3737,
		obj_t BgL_funz00_3738)
	{
		{	/* Stackable/walk.scm 470 */
			{	/* Stackable/walk.scm 471 */
				long BgL_depthz00_3947;

				BgL_depthz00_3947 = ((long) CINT(BgL_depthz00_3737) + ((long) 1));
				{	/* Stackable/walk.scm 473 */
					obj_t BgL_g1441z00_3948;

					BgL_g1441z00_3948 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_3736)))->BgL_bindingsz00);
					{
						obj_t BgL_l1439z00_3950;

						BgL_l1439z00_3950 = BgL_g1441z00_3948;
					BgL_zc3z04anonymousza32108ze3z87_3949:
						if (PAIRP(BgL_l1439z00_3950))
							{	/* Stackable/walk.scm 473 */
								{	/* Stackable/walk.scm 476 */
									obj_t BgL_bindingz00_3951;

									BgL_bindingz00_3951 = CAR(BgL_l1439z00_3950);
									{	/* Stackable/walk.scm 474 */
										BgL_localz00_bglt BgL_tmp1227z00_3952;

										BgL_tmp1227z00_3952 =
											((BgL_localz00_bglt) CAR(((obj_t) BgL_bindingz00_3951)));
										{	/* Stackable/walk.scm 474 */
											BgL_localzf2depthzf2_bglt BgL_wide1229z00_3953;

											BgL_wide1229z00_3953 =
												((BgL_localzf2depthzf2_bglt)
												BOBJECT(GC_MALLOC(sizeof(struct
															BgL_localzf2depthzf2_bgl))));
											{	/* Stackable/walk.scm 474 */
												obj_t BgL_auxz00_5234;
												BgL_objectz00_bglt BgL_tmpz00_5231;

												BgL_auxz00_5234 = ((obj_t) BgL_wide1229z00_3953);
												BgL_tmpz00_5231 =
													((BgL_objectz00_bglt)
													((BgL_localz00_bglt) BgL_tmp1227z00_3952));
												BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5231,
													BgL_auxz00_5234);
											}
											((BgL_objectz00_bglt)
												((BgL_localz00_bglt) BgL_tmp1227z00_3952));
											{	/* Stackable/walk.scm 474 */
												long BgL_arg2110z00_3954;

												BgL_arg2110z00_3954 =
													BGL_CLASS_INDEX
													(BGl_localzf2depthzf2zzstackable_walkz00);
												BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt) (
															(BgL_localz00_bglt) BgL_tmp1227z00_3952)),
													BgL_arg2110z00_3954);
											}
											((BgL_localz00_bglt)
												((BgL_localz00_bglt) BgL_tmp1227z00_3952));
										}
										{
											BgL_localzf2depthzf2_bglt BgL_auxz00_5245;

											{
												obj_t BgL_auxz00_5246;

												{	/* Stackable/walk.scm 476 */
													BgL_objectz00_bglt BgL_tmpz00_5247;

													BgL_tmpz00_5247 =
														((BgL_objectz00_bglt)
														((BgL_localz00_bglt) BgL_tmp1227z00_3952));
													BgL_auxz00_5246 =
														BGL_OBJECT_WIDENING(BgL_tmpz00_5247);
												}
												BgL_auxz00_5245 =
													((BgL_localzf2depthzf2_bglt) BgL_auxz00_5246);
											}
											((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5245))->
													BgL_depthz00) = ((long) BgL_depthz00_3947), BUNSPEC);
										}
										{
											BgL_localzf2depthzf2_bglt BgL_auxz00_5253;

											{
												obj_t BgL_auxz00_5254;

												{	/* Stackable/walk.scm 475 */
													BgL_objectz00_bglt BgL_tmpz00_5255;

													BgL_tmpz00_5255 =
														((BgL_objectz00_bglt)
														((BgL_localz00_bglt) BgL_tmp1227z00_3952));
													BgL_auxz00_5254 =
														BGL_OBJECT_WIDENING(BgL_tmpz00_5255);
												}
												BgL_auxz00_5253 =
													((BgL_localzf2depthzf2_bglt) BgL_auxz00_5254);
											}
											((((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5253))->
													BgL_ownerz00) = ((obj_t) BgL_funz00_3738), BUNSPEC);
										}
										((BgL_localz00_bglt) BgL_tmp1227z00_3952);
									}
									{	/* Stackable/walk.scm 477 */
										obj_t BgL_arg2112z00_3955;

										BgL_arg2112z00_3955 = CDR(((obj_t) BgL_bindingz00_3951));
										BGl_depthzd2letzd2zzstackable_walkz00(
											((BgL_nodez00_bglt) BgL_arg2112z00_3955),
											BINT(BgL_depthz00_3947), BgL_funz00_3738);
								}}
								{
									obj_t BgL_l1439z00_5267;

									BgL_l1439z00_5267 = CDR(BgL_l1439z00_3950);
									BgL_l1439z00_3950 = BgL_l1439z00_5267;
									goto BgL_zc3z04anonymousza32108ze3z87_3949;
								}
							}
						else
							{	/* Stackable/walk.scm 473 */
								((bool_t) 1);
							}
					}
				}
				return
					BGl_depthzd2letzd2zzstackable_walkz00(
					(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_3736)))->BgL_bodyz00),
					BINT(BgL_depthz00_3947), BgL_funz00_3738);
			}
		}

	}



/* &depth-let-var1505 */
	obj_t BGl_z62depthzd2letzd2var1505z62zzstackable_walkz00(obj_t
		BgL_envz00_3739, obj_t BgL_nodez00_3740, obj_t BgL_depthz00_3741,
		obj_t BgL_funz00_3742)
	{
		{	/* Stackable/walk.scm 460 */
			{	/* Stackable/walk.scm 462 */
				bool_t BgL_test2460z00_5273;

				{	/* Stackable/walk.scm 462 */
					BgL_variablez00_bglt BgL_arg2104z00_3957;

					BgL_arg2104z00_3957 =
						(((BgL_varz00_bglt) COBJECT(
								((BgL_varz00_bglt) BgL_nodez00_3740)))->BgL_variablez00);
					BgL_test2460z00_5273 =
						BGl_isazf3zf3zz__objectz00(
						((obj_t) BgL_arg2104z00_3957),
						BGl_localzf2depthzf2zzstackable_walkz00);
				}
				if (BgL_test2460z00_5273)
					{	/* Stackable/walk.scm 463 */
						BgL_localz00_bglt BgL_i1225z00_3958;

						BgL_i1225z00_3958 =
							((BgL_localz00_bglt)
							(((BgL_varz00_bglt) COBJECT(
										((BgL_varz00_bglt) BgL_nodez00_3740)))->BgL_variablez00));
						{	/* Stackable/walk.scm 464 */
							bool_t BgL_test2461z00_5281;

							{	/* Stackable/walk.scm 464 */
								obj_t BgL_arg2103z00_3959;

								{
									BgL_localzf2depthzf2_bglt BgL_auxz00_5282;

									{
										obj_t BgL_auxz00_5283;

										{	/* Stackable/walk.scm 464 */
											BgL_objectz00_bglt BgL_tmpz00_5284;

											BgL_tmpz00_5284 =
												((BgL_objectz00_bglt) BgL_i1225z00_3958);
											BgL_auxz00_5283 = BGL_OBJECT_WIDENING(BgL_tmpz00_5284);
										}
										BgL_auxz00_5282 =
											((BgL_localzf2depthzf2_bglt) BgL_auxz00_5283);
									}
									BgL_arg2103z00_3959 =
										(((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5282))->
										BgL_ownerz00);
								}
								BgL_test2461z00_5281 = (BgL_arg2103z00_3959 == BgL_funz00_3742);
							}
							if (BgL_test2461z00_5281)
								{	/* Stackable/walk.scm 464 */
									return BFALSE;
								}
							else
								{	/* Stackable/walk.scm 464 */
									return
										((((BgL_localz00_bglt) COBJECT(
													((BgL_localz00_bglt) BgL_i1225z00_3958)))->
											BgL_valzd2noescapezd2) = ((obj_t) BFALSE), BUNSPEC);
								}
						}
					}
				else
					{	/* Stackable/walk.scm 462 */
						return BFALSE;
					}
			}
		}

	}



/* &lift-let!-let-var1500 */
	BgL_nodez00_bglt
		BGl_z62liftzd2letz12zd2letzd2var1500za2zzstackable_walkz00(obj_t
		BgL_envz00_3743, obj_t BgL_nodez00_3744)
	{
		{	/* Stackable/walk.scm 392 */
			{	/* Stackable/walk.scm 428 */
				obj_t BgL_lbindingsz00_3961;

				BgL_lbindingsz00_3961 =
					BGl_zc3z04anonymousza32043ze3ze70z60zzstackable_walkz00(
					(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_3744)))->BgL_bindingsz00));
				if (PAIRP(BgL_lbindingsz00_3961))
					{	/* Stackable/walk.scm 431 */
						BgL_letzd2varzd2_bglt BgL_arg2041z00_3962;

						{	/* Stackable/walk.scm 431 */
							BgL_letzd2varzd2_bglt BgL_new1211z00_3963;

							{	/* Stackable/walk.scm 431 */
								BgL_letzd2varzd2_bglt BgL_new1217z00_3964;

								BgL_new1217z00_3964 =
									((BgL_letzd2varzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_letzd2varzd2_bgl))));
								{	/* Stackable/walk.scm 431 */
									long BgL_arg2042z00_3965;

									BgL_arg2042z00_3965 =
										BGL_CLASS_INDEX(BGl_letzd2varzd2zzast_nodez00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1217z00_3964),
										BgL_arg2042z00_3965);
								}
								{	/* Stackable/walk.scm 431 */
									BgL_objectz00_bglt BgL_tmpz00_5301;

									BgL_tmpz00_5301 = ((BgL_objectz00_bglt) BgL_new1217z00_3964);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_5301, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1217z00_3964);
								BgL_new1211z00_3963 = BgL_new1217z00_3964;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1211z00_3963)))->BgL_locz00) =
								((obj_t) (((BgL_nodez00_bglt)
											COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt)
														BgL_nodez00_3744))))->BgL_locz00)), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1211z00_3963)))->BgL_typez00) =
								((BgL_typez00_bglt) (((BgL_nodez00_bglt)
											COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt)
														BgL_nodez00_3744))))->BgL_typez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1211z00_3963)))->BgL_sidezd2effectzd2) =
								((obj_t) (((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt) ((BgL_nodez00_bglt) (
															(BgL_letzd2varzd2_bglt) BgL_nodez00_3744)))))->
										BgL_sidezd2effectzd2)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1211z00_3963)))->BgL_keyz00) =
								((obj_t) (((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt) ((BgL_nodez00_bglt) (
															(BgL_letzd2varzd2_bglt) BgL_nodez00_3744)))))->
										BgL_keyz00)), BUNSPEC);
							((((BgL_letzd2varzd2_bglt) COBJECT(BgL_new1211z00_3963))->
									BgL_bindingsz00) = ((obj_t) BgL_lbindingsz00_3961), BUNSPEC);
							((((BgL_letzd2varzd2_bglt) COBJECT(BgL_new1211z00_3963))->
									BgL_bodyz00) =
								((BgL_nodez00_bglt) ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt)
											BgL_nodez00_3744))), BUNSPEC);
							((((BgL_letzd2varzd2_bglt) COBJECT(BgL_new1211z00_3963))->
									BgL_removablezf3zf3) =
								((bool_t) (((BgL_letzd2varzd2_bglt)
											COBJECT(((BgL_letzd2varzd2_bglt) ((BgL_nodez00_bglt) (
															(BgL_letzd2varzd2_bglt) BgL_nodez00_3744)))))->
										BgL_removablezf3zf3)), BUNSPEC);
							BgL_arg2041z00_3962 = BgL_new1211z00_3963;
						}
						return
							BGl_liftzd2letz12zc0zzstackable_walkz00(
							((BgL_nodez00_bglt) BgL_arg2041z00_3962));
					}
				else
					{	/* Stackable/walk.scm 429 */
						return
							BGl_walk0z12z12zzast_walkz00(
							((BgL_nodez00_bglt)
								((BgL_letzd2varzd2_bglt) BgL_nodez00_3744)),
							BGl_liftzd2letz12zd2envz12zzstackable_walkz00);
					}
			}
		}

	}



/* liftable?~0 */
	bool_t BGl_liftablezf3ze70z14zzstackable_walkz00(obj_t BgL_nodez00_2649)
	{
		{	/* Stackable/walk.scm 414 */
		BGl_liftablezf3ze70z14zzstackable_walkz00:
			if (BGl_isazf3zf3zz__objectz00(BgL_nodez00_2649,
					BGl_letzd2varzd2zzast_nodez00))
				{	/* Stackable/walk.scm 402 */
					bool_t BgL_test2464z00_5343;

					{	/* Stackable/walk.scm 402 */
						obj_t BgL_tmpz00_5344;

						BgL_tmpz00_5344 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nodez00_2649)))->
							BgL_bindingsz00);
						BgL_test2464z00_5343 = PAIRP(BgL_tmpz00_5344);
					}
					if (BgL_test2464z00_5343)
						{	/* Stackable/walk.scm 403 */
							bool_t BgL_test2465z00_5348;

							{	/* Stackable/walk.scm 403 */
								obj_t BgL_tmpz00_5349;

								{	/* Stackable/walk.scm 403 */
									obj_t BgL_pairz00_3501;

									BgL_pairz00_3501 =
										(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_nodez00_2649)))->
										BgL_bindingsz00);
									BgL_tmpz00_5349 = CDR(BgL_pairz00_3501);
								}
								BgL_test2465z00_5348 = NULLP(BgL_tmpz00_5349);
							}
							if (BgL_test2465z00_5348)
								{	/* Stackable/walk.scm 404 */
									bool_t BgL_test2466z00_5354;

									{	/* Stackable/walk.scm 404 */
										obj_t BgL_arg2056z00_2657;

										{	/* Stackable/walk.scm 404 */
											obj_t BgL_pairz00_3502;

											BgL_pairz00_3502 =
												(((BgL_letzd2varzd2_bglt) COBJECT(
														((BgL_letzd2varzd2_bglt) BgL_nodez00_2649)))->
												BgL_bindingsz00);
											BgL_arg2056z00_2657 = CDR(CAR(BgL_pairz00_3502));
										}
										BgL_test2466z00_5354 =
											BGl_liftablezf3ze70z14zzstackable_walkz00
											(BgL_arg2056z00_2657);
									}
									if (BgL_test2466z00_5354)
										{	/* Stackable/walk.scm 405 */
											BgL_nodez00_bglt BgL_arg2055z00_2656;

											BgL_arg2055z00_2656 =
												(((BgL_letzd2varzd2_bglt) COBJECT(
														((BgL_letzd2varzd2_bglt) BgL_nodez00_2649)))->
												BgL_bodyz00);
											{
												obj_t BgL_nodez00_5362;

												BgL_nodez00_5362 = ((obj_t) BgL_arg2055z00_2656);
												BgL_nodez00_2649 = BgL_nodez00_5362;
												goto BGl_liftablezf3ze70z14zzstackable_walkz00;
											}
										}
									else
										{	/* Stackable/walk.scm 404 */
											return ((bool_t) 0);
										}
								}
							else
								{	/* Stackable/walk.scm 403 */
									return ((bool_t) 0);
								}
						}
					else
						{	/* Stackable/walk.scm 402 */
							return ((bool_t) 0);
						}
				}
			else
				{	/* Stackable/walk.scm 400 */
					if (BGl_isazf3zf3zz__objectz00(BgL_nodez00_2649,
							BGl_varz00zzast_nodez00))
						{	/* Stackable/walk.scm 407 */
							BgL_variablez00_bglt BgL_arg2064z00_2663;

							BgL_arg2064z00_2663 =
								(((BgL_varz00_bglt) COBJECT(
										((BgL_varz00_bglt) BgL_nodez00_2649)))->BgL_variablez00);
							return
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg2064z00_2663), BGl_localz00zzast_varz00);
						}
					else
						{	/* Stackable/walk.scm 406 */
							if (BGl_isazf3zf3zz__objectz00(BgL_nodez00_2649,
									BGl_appz00zzast_nodez00))
								{	/* Stackable/walk.scm 410 */
									BgL_variablez00_bglt BgL_vz00_2666;

									BgL_vz00_2666 =
										(((BgL_varz00_bglt) COBJECT(
												(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt) BgL_nodez00_2649)))->
													BgL_funz00)))->BgL_variablez00);
									if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_vz00_2666),
											BGl_globalz00zzast_varz00))
										{	/* Stackable/walk.scm 412 */
											obj_t BgL_tmpz00_5378;

											BgL_tmpz00_5378 =
												(((BgL_funz00_bglt) COBJECT(
														((BgL_funz00_bglt)
															(((BgL_variablez00_bglt) COBJECT(
																		((BgL_variablez00_bglt)
																			((BgL_globalz00_bglt) BgL_vz00_2666))))->
																BgL_valuez00))))->BgL_stackzd2allocatorzd2);
											return PAIRP(BgL_tmpz00_5378);
										}
									else
										{	/* Stackable/walk.scm 411 */
											return ((bool_t) 0);
										}
								}
							else
								{	/* Stackable/walk.scm 408 */
									return
										BGl_isazf3zf3zz__objectz00(BgL_nodez00_2649,
										BGl_makezd2boxzd2zzast_nodez00);
								}
						}
				}
		}

	}



/* <@anonymous:2043>~0 */
	obj_t BGl_zc3z04anonymousza32043ze3ze70z60zzstackable_walkz00(obj_t
		BgL_l1434z00_2636)
	{
		{	/* Stackable/walk.scm 428 */
			{
				obj_t BgL_bindingz00_2671;

				if (NULLP(BgL_l1434z00_2636))
					{	/* Stackable/walk.scm 428 */
						return BNIL;
					}
				else
					{	/* Stackable/walk.scm 428 */
						obj_t BgL_arg2045z00_2639;
						obj_t BgL_arg2046z00_2640;

						{	/* Stackable/walk.scm 428 */
							obj_t BgL_arg2047z00_2641;

							BgL_arg2047z00_2641 = CAR(((obj_t) BgL_l1434z00_2636));
							BgL_bindingz00_2671 = BgL_arg2047z00_2641;
							{	/* Stackable/walk.scm 417 */
								bool_t BgL_test2471z00_5390;

								{	/* Stackable/walk.scm 417 */
									bool_t BgL_test2472z00_5391;

									{	/* Stackable/walk.scm 417 */
										obj_t BgL_arg2097z00_2707;

										BgL_arg2097z00_2707 = CDR(((obj_t) BgL_bindingz00_2671));
										BgL_test2472z00_5391 =
											BGl_isazf3zf3zz__objectz00(BgL_arg2097z00_2707,
											BGl_letzd2varzd2zzast_nodez00);
									}
									if (BgL_test2472z00_5391)
										{	/* Stackable/walk.scm 417 */
											obj_t BgL_arg2096z00_2706;

											BgL_arg2096z00_2706 = CDR(((obj_t) BgL_bindingz00_2671));
											BgL_test2471z00_5390 =
												BGl_liftablezf3ze70z14zzstackable_walkz00
												(BgL_arg2096z00_2706);
										}
									else
										{	/* Stackable/walk.scm 417 */
											BgL_test2471z00_5390 = ((bool_t) 0);
										}
								}
								if (BgL_test2471z00_5390)
									{	/* Stackable/walk.scm 418 */
										BgL_letzd2varzd2_bglt BgL_i1209z00_2678;

										BgL_i1209z00_2678 =
											((BgL_letzd2varzd2_bglt)
											CDR(((obj_t) BgL_bindingz00_2671)));
										{	/* Stackable/walk.scm 420 */
											obj_t BgL_arg2077z00_2679;
											obj_t BgL_arg2078z00_2680;
											obj_t BgL_arg2079z00_2681;

											BgL_arg2077z00_2679 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															CAR(((obj_t) BgL_bindingz00_2671)))))->BgL_idz00);
											{	/* Stackable/walk.scm 421 */
												obj_t BgL_l1428z00_2690;

												BgL_l1428z00_2690 =
													(((BgL_letzd2varzd2_bglt)
														COBJECT(BgL_i1209z00_2678))->BgL_bindingsz00);
												if (NULLP(BgL_l1428z00_2690))
													{	/* Stackable/walk.scm 421 */
														BgL_arg2078z00_2680 = BNIL;
													}
												else
													{	/* Stackable/walk.scm 421 */
														obj_t BgL_head1430z00_2692;

														BgL_head1430z00_2692 = MAKE_YOUNG_PAIR(BNIL, BNIL);
														{
															obj_t BgL_l1428z00_2694;
															obj_t BgL_tail1431z00_2695;

															BgL_l1428z00_2694 = BgL_l1428z00_2690;
															BgL_tail1431z00_2695 = BgL_head1430z00_2692;
														BgL_zc3z04anonymousza32090ze3z87_2696:
															if (NULLP(BgL_l1428z00_2694))
																{	/* Stackable/walk.scm 421 */
																	BgL_arg2078z00_2680 =
																		CDR(BgL_head1430z00_2692);
																}
															else
																{	/* Stackable/walk.scm 421 */
																	obj_t BgL_newtail1432z00_2698;

																	{	/* Stackable/walk.scm 421 */
																		obj_t BgL_arg2093z00_2700;

																		{
																			BgL_variablez00_bglt BgL_auxz00_5412;

																			{	/* Stackable/walk.scm 421 */
																				obj_t BgL_pairz00_3517;

																				BgL_pairz00_3517 =
																					CAR(((obj_t) BgL_l1428z00_2694));
																				BgL_auxz00_5412 =
																					((BgL_variablez00_bglt)
																					CAR(BgL_pairz00_3517));
																			}
																			BgL_arg2093z00_2700 =
																				(((BgL_variablez00_bglt)
																					COBJECT(BgL_auxz00_5412))->BgL_idz00);
																		}
																		BgL_newtail1432z00_2698 =
																			MAKE_YOUNG_PAIR(BgL_arg2093z00_2700,
																			BNIL);
																	}
																	SET_CDR(BgL_tail1431z00_2695,
																		BgL_newtail1432z00_2698);
																	{	/* Stackable/walk.scm 421 */
																		obj_t BgL_arg2092z00_2699;

																		BgL_arg2092z00_2699 =
																			CDR(((obj_t) BgL_l1428z00_2694));
																		{
																			obj_t BgL_tail1431z00_5423;
																			obj_t BgL_l1428z00_5422;

																			BgL_l1428z00_5422 = BgL_arg2092z00_2699;
																			BgL_tail1431z00_5423 =
																				BgL_newtail1432z00_2698;
																			BgL_tail1431z00_2695 =
																				BgL_tail1431z00_5423;
																			BgL_l1428z00_2694 = BgL_l1428z00_5422;
																			goto
																				BgL_zc3z04anonymousza32090ze3z87_2696;
																		}
																	}
																}
														}
													}
											}
											BgL_arg2079z00_2681 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt) BgL_i1209z00_2678)))->
												BgL_locz00);
											{	/* Stackable/walk.scm 419 */
												obj_t BgL_list2080z00_2682;

												{	/* Stackable/walk.scm 419 */
													obj_t BgL_arg2081z00_2683;

													{	/* Stackable/walk.scm 419 */
														obj_t BgL_arg2083z00_2684;

														{	/* Stackable/walk.scm 419 */
															obj_t BgL_arg2084z00_2685;

															{	/* Stackable/walk.scm 419 */
																obj_t BgL_arg2085z00_2686;

																{	/* Stackable/walk.scm 419 */
																	obj_t BgL_arg2086z00_2687;

																	{	/* Stackable/walk.scm 419 */
																		obj_t BgL_arg2087z00_2688;

																		BgL_arg2087z00_2688 =
																			MAKE_YOUNG_PAIR
																			(BGl_string2328z00zzstackable_walkz00,
																			BNIL);
																		BgL_arg2086z00_2687 =
																			MAKE_YOUNG_PAIR(BgL_arg2079z00_2681,
																			BgL_arg2087z00_2688);
																	}
																	BgL_arg2085z00_2686 =
																		MAKE_YOUNG_PAIR
																		(BGl_string2329z00zzstackable_walkz00,
																		BgL_arg2086z00_2687);
																}
																BgL_arg2084z00_2685 =
																	MAKE_YOUNG_PAIR(BgL_arg2078z00_2680,
																	BgL_arg2085z00_2686);
															}
															BgL_arg2083z00_2684 =
																MAKE_YOUNG_PAIR
																(BGl_string2330z00zzstackable_walkz00,
																BgL_arg2084z00_2685);
														}
														BgL_arg2081z00_2683 =
															MAKE_YOUNG_PAIR(BgL_arg2077z00_2679,
															BgL_arg2083z00_2684);
													}
													BgL_list2080z00_2682 =
														MAKE_YOUNG_PAIR
														(BGl_string2331z00zzstackable_walkz00,
														BgL_arg2081z00_2683);
												}
												BGl_verbosez00zztools_speekz00(BINT(((long) 3)),
													BgL_list2080z00_2682);
										}}
										{	/* Stackable/walk.scm 423 */
											BgL_nodez00_bglt BgL_arg2095z00_2704;

											BgL_arg2095z00_2704 =
												(((BgL_letzd2varzd2_bglt) COBJECT(BgL_i1209z00_2678))->
												BgL_bodyz00);
											{	/* Stackable/walk.scm 423 */
												obj_t BgL_auxz00_5438;
												obj_t BgL_tmpz00_5436;

												BgL_auxz00_5438 = ((obj_t) BgL_arg2095z00_2704);
												BgL_tmpz00_5436 = ((obj_t) BgL_bindingz00_2671);
												SET_CDR(BgL_tmpz00_5436, BgL_auxz00_5438);
										}}
										BgL_arg2045z00_2639 =
											(((BgL_letzd2varzd2_bglt) COBJECT(BgL_i1209z00_2678))->
											BgL_bindingsz00);
									}
								else
									{	/* Stackable/walk.scm 417 */
										BgL_arg2045z00_2639 = BNIL;
									}
							}
						}
						{	/* Stackable/walk.scm 428 */
							obj_t BgL_arg2048z00_2642;

							BgL_arg2048z00_2642 = CDR(((obj_t) BgL_l1434z00_2636));
							BgL_arg2046z00_2640 =
								BGl_zc3z04anonymousza32043ze3ze70z60zzstackable_walkz00
								(BgL_arg2048z00_2642);
						}
						return bgl_append2(BgL_arg2045z00_2639, BgL_arg2046z00_2640);
					}
			}
		}

	}



/* &node-escape-make-box1496 */
	obj_t BGl_z62nodezd2escapezd2makezd2box1496zb0zzstackable_walkz00(obj_t
		BgL_envz00_3745, obj_t BgL_nodez00_3746, obj_t BgL_ctxz00_3747)
	{
		{	/* Stackable/walk.scm 366 */
			return
				BGl_escapez12z12zzstackable_walkz00(
				((obj_t) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_3746)), BgL_ctxz00_3747);
		}

	}



/* &node-escape-app1494 */
	obj_t BGl_z62nodezd2escapezd2app1494z62zzstackable_walkz00(obj_t
		BgL_envz00_3748, obj_t BgL_nodez00_3749, obj_t BgL_ctxz00_3750)
	{
		{	/* Stackable/walk.scm 360 */
			return
				BGl_escapez12z12zzstackable_walkz00(
				((obj_t) ((BgL_appz00_bglt) BgL_nodez00_3749)), BgL_ctxz00_3750);
		}

	}



/* &escape!-closure1490 */
	obj_t BGl_z62escapez12zd2closure1490za2zzstackable_walkz00(obj_t
		BgL_envz00_3751, obj_t BgL_nodez00_3752, obj_t BgL_ctxz00_3753)
	{
		{	/* Stackable/walk.scm 342 */
			{

				BGl_walk1z12z12zzast_walkz00(
					((BgL_nodez00_bglt)
						((BgL_closurez00_bglt) BgL_nodez00_3752)),
					BGl_escapez12zd2envzc0zzstackable_walkz00, BgL_ctxz00_3753);
				{	/* Stackable/walk.scm 344 */
					BgL_variablez00_bglt BgL_vz00_3970;

					BgL_vz00_3970 =
						(((BgL_varz00_bglt) COBJECT(
								((BgL_varz00_bglt)
									((BgL_closurez00_bglt) BgL_nodez00_3752))))->BgL_variablez00);
					{	/* Stackable/walk.scm 344 */
						BgL_valuez00_bglt BgL_fz00_3971;

						BgL_fz00_3971 =
							(((BgL_variablez00_bglt) COBJECT(BgL_vz00_3970))->BgL_valuez00);
						{	/* Stackable/walk.scm 345 */

							if (CBOOL(
									(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_fz00_3971)))->
										BgL_stackablez00)))
								{	/* Stackable/walk.scm 347 */
									{	/* Stackable/walk.scm 348 */
										obj_t BgL_tmpz00_5463;

										BgL_tmpz00_5463 = ((obj_t) BgL_ctxz00_3753);
										SET_CAR(BgL_tmpz00_5463, BFALSE);
									}
									return
										((((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_fz00_3971)))->
											BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
								}
							else
								{	/* Stackable/walk.scm 347 */
									return BFALSE;
								}
						}
					}
				}
			}
		}

	}



/* &escape!-make-box1488 */
	obj_t BGl_z62escapez12zd2makezd2box1488z70zzstackable_walkz00(obj_t
		BgL_envz00_3754, obj_t BgL_nodez00_3755, obj_t BgL_ctxz00_3756)
	{
		{	/* Stackable/walk.scm 332 */
			if (CBOOL(
					(((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nodez00_3755)))->
						BgL_stackablez00)))
				{	/* Stackable/walk.scm 334 */
					{	/* Stackable/walk.scm 335 */
						obj_t BgL_tmpz00_5472;

						BgL_tmpz00_5472 = ((obj_t) BgL_ctxz00_3756);
						SET_CAR(BgL_tmpz00_5472, BFALSE);
					}
					((((BgL_makezd2boxzd2_bglt) COBJECT(
									((BgL_makezd2boxzd2_bglt) BgL_nodez00_3755)))->
							BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
					{	/* Stackable/walk.scm 337 */
						BgL_nodez00_bglt BgL_arg2028z00_3973;

						BgL_arg2028z00_3973 =
							(((BgL_makezd2boxzd2_bglt) COBJECT(
									((BgL_makezd2boxzd2_bglt) BgL_nodez00_3755)))->BgL_valuez00);
						return
							BGl_escapez12z12zzstackable_walkz00(
							((obj_t) BgL_arg2028z00_3973), BgL_ctxz00_3756);
					}
				}
			else
				{	/* Stackable/walk.scm 334 */
					return BFALSE;
				}
		}

	}



/* &escape!-app1486 */
	obj_t BGl_z62escapez12zd2app1486za2zzstackable_walkz00(obj_t BgL_envz00_3757,
		obj_t BgL_nodez00_3758, obj_t BgL_ctxz00_3759)
	{
		{	/* Stackable/walk.scm 323 */
			if (CBOOL(
					(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3758)))->BgL_stackablez00)))
				{	/* Stackable/walk.scm 325 */
					{	/* Stackable/walk.scm 326 */
						obj_t BgL_tmpz00_5485;

						BgL_tmpz00_5485 = ((obj_t) BgL_ctxz00_3759);
						SET_CAR(BgL_tmpz00_5485, BFALSE);
					}
					return
						((((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nodez00_3758)))->BgL_stackablez00) =
						((obj_t) BFALSE), BUNSPEC);
				}
			else
				{	/* Stackable/walk.scm 325 */
					return BFALSE;
				}
		}

	}



/* &escape!-node1483 */
	obj_t BGl_z62escapez12zd2node1483za2zzstackable_walkz00(obj_t BgL_envz00_3760,
		obj_t BgL_nodez00_3761, obj_t BgL_ctxz00_3762)
	{
		{	/* Stackable/walk.scm 317 */
			return
				BGl_nodezd2escapezd2zzstackable_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3761), BgL_ctxz00_3762);
		}

	}



/* &escape!-local1481 */
	obj_t BGl_z62escapez12zd2local1481za2zzstackable_walkz00(obj_t
		BgL_envz00_3763, obj_t BgL_varz00_3764, obj_t BgL_ctxz00_3765)
	{
		{	/* Stackable/walk.scm 308 */
			if (
				((((BgL_localz00_bglt) COBJECT(
								((BgL_localz00_bglt) BgL_varz00_3764)))->
						BgL_valzd2noescapezd2) == BTRUE))
				{	/* Stackable/walk.scm 310 */
					{	/* Stackable/walk.scm 311 */
						obj_t BgL_tmpz00_5496;

						BgL_tmpz00_5496 = ((obj_t) BgL_ctxz00_3765);
						SET_CAR(BgL_tmpz00_5496, BFALSE);
					}
					return
						((((BgL_localz00_bglt) COBJECT(
									((BgL_localz00_bglt) BgL_varz00_3764)))->
							BgL_valzd2noescapezd2) = ((obj_t) BFALSE), BUNSPEC);
				}
			else
				{	/* Stackable/walk.scm 310 */
					return BFALSE;
				}
		}

	}



/* &escape!-global1479 */
	obj_t BGl_z62escapez12zd2global1479za2zzstackable_walkz00(obj_t
		BgL_envz00_3766, obj_t BgL_varz00_3767, obj_t BgL_ctxz00_3768)
	{
		{	/* Stackable/walk.scm 302 */
			return BUNSPEC;
		}

	}



/* &stackable-sequence1475 */
	obj_t BGl_z62stackablezd2sequence1475zb0zzstackable_walkz00(obj_t
		BgL_envz00_3769, obj_t BgL_nodez00_3770, obj_t BgL_escpz00_3771,
		obj_t BgL_depthz00_3772, obj_t BgL_ctxz00_3773)
	{
		{	/* Stackable/walk.scm 279 */
			if (NULLP(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_3770)))->BgL_nodesz00)))
				{	/* Stackable/walk.scm 281 */
					return BFALSE;
				}
			else
				{
					obj_t BgL_nodesz00_3981;

					BgL_nodesz00_3981 =
						(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_3770)))->BgL_nodesz00);
				BgL_loopz00_3980:
					if (NULLP(CDR(((obj_t) BgL_nodesz00_3981))))
						{	/* Stackable/walk.scm 284 */
							obj_t BgL_arg2013z00_3982;

							BgL_arg2013z00_3982 = CAR(((obj_t) BgL_nodesz00_3981));
							return
								BGl_stackablez00zzstackable_walkz00(
								((BgL_nodez00_bglt) BgL_arg2013z00_3982),
								CBOOL(BgL_escpz00_3771),
								(long) CINT(BgL_depthz00_3772), ((obj_t) BgL_ctxz00_3773));
						}
					else
						{	/* Stackable/walk.scm 283 */
							{	/* Stackable/walk.scm 286 */
								obj_t BgL_arg2014z00_3983;

								BgL_arg2014z00_3983 = CAR(((obj_t) BgL_nodesz00_3981));
								BGl_stackablez00zzstackable_walkz00(
									((BgL_nodez00_bglt) BgL_arg2014z00_3983), ((bool_t) 0),
									((long) 100000), ((obj_t) BgL_ctxz00_3773));
							}
							{	/* Stackable/walk.scm 287 */
								obj_t BgL_arg2017z00_3984;

								BgL_arg2017z00_3984 = CDR(((obj_t) BgL_nodesz00_3981));
								{
									obj_t BgL_nodesz00_5523;

									BgL_nodesz00_5523 = BgL_arg2017z00_3984;
									BgL_nodesz00_3981 = BgL_nodesz00_5523;
									goto BgL_loopz00_3980;
								}
							}
						}
				}
		}

	}



/* &stackable-funcall1473 */
	obj_t BGl_z62stackablezd2funcall1473zb0zzstackable_walkz00(obj_t
		BgL_envz00_3774, obj_t BgL_nodez00_3775, obj_t BgL_escpz00_3776,
		obj_t BgL_depthz00_3777, obj_t BgL_ctxz00_3778)
	{
		{	/* Stackable/walk.scm 272 */
			{	/* Stackable/walk.scm 272 */
				obj_t BgL_escpz00_3986;

				BgL_escpz00_3986 = BgL_escpz00_3776;
				{

					BgL_escpz00_3986 = BTRUE;
					return
						BGl_walk3z00zzast_walkz00(
						((BgL_nodez00_bglt)
							((BgL_funcallz00_bglt) BgL_nodez00_3775)),
						BGl_stackablezd2envzd2zzstackable_walkz00, BgL_escpz00_3986,
						BgL_depthz00_3777, ((obj_t) BgL_ctxz00_3778));
				}
			}
		}

	}



/* &stackable-app1471 */
	obj_t BGl_z62stackablezd2app1471zb0zzstackable_walkz00(obj_t BgL_envz00_3779,
		obj_t BgL_nodez00_3780, obj_t BgL_escpz00_3781, obj_t BgL_depthz00_3782,
		obj_t BgL_ctxz00_3783)
	{
		{	/* Stackable/walk.scm 189 */
			{	/* Stackable/walk.scm 189 */
				bool_t BgL_tmpz00_5530;

				{
					obj_t BgL_argsz00_3992;

					{	/* Stackable/walk.scm 226 */
						bool_t BgL_test2481z00_5531;

						if (CBOOL(BgL_escpz00_3781))
							{	/* Stackable/walk.scm 226 */
								BgL_test2481z00_5531 = ((bool_t) 1);
							}
						else
							{	/* Stackable/walk.scm 226 */
								long BgL_arg1911z00_3998;

								{
									BgL_appzf2depthzf2_bglt BgL_auxz00_5534;

									{
										obj_t BgL_auxz00_5535;

										{	/* Stackable/walk.scm 226 */
											BgL_objectz00_bglt BgL_tmpz00_5536;

											BgL_tmpz00_5536 =
												((BgL_objectz00_bglt)
												((BgL_appz00_bglt)
													((BgL_appz00_bglt) BgL_nodez00_3780)));
											BgL_auxz00_5535 = BGL_OBJECT_WIDENING(BgL_tmpz00_5536);
										}
										BgL_auxz00_5534 =
											((BgL_appzf2depthzf2_bglt) BgL_auxz00_5535);
									}
									BgL_arg1911z00_3998 =
										(((BgL_appzf2depthzf2_bglt) COBJECT(BgL_auxz00_5534))->
										BgL_depthz00);
								}
								BgL_test2481z00_5531 =
									((long) CINT(BgL_depthz00_3782) < BgL_arg1911z00_3998);
							}
						if (BgL_test2481z00_5531)
							{	/* Stackable/walk.scm 226 */
								BGl_escapez12z12zzstackable_walkz00(
									((obj_t)
										((BgL_appz00_bglt) BgL_nodez00_3780)),
									((obj_t) BgL_ctxz00_3783));
							}
						else
							{	/* Stackable/walk.scm 226 */
								BFALSE;
							}
					}
					{	/* Stackable/walk.scm 231 */
						BgL_variablez00_bglt BgL_vz00_3999;

						BgL_vz00_3999 =
							(((BgL_varz00_bglt) COBJECT(
									(((BgL_appz00_bglt) COBJECT(
												((BgL_appz00_bglt) BgL_nodez00_3780)))->BgL_funz00)))->
							BgL_variablez00);
						{	/* Stackable/walk.scm 231 */
							BgL_valuez00_bglt BgL_fz00_4000;

							BgL_fz00_4000 =
								(((BgL_variablez00_bglt) COBJECT(BgL_vz00_3999))->BgL_valuez00);
							{	/* Stackable/walk.scm 232 */

								if (BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_vz00_3999), BGl_localz00zzast_varz00))
									{	/* Stackable/walk.scm 236 */
										obj_t BgL_g1410z00_4001;

										BgL_g1410z00_4001 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_nodez00_3780)))->BgL_argsz00);
										{
											obj_t BgL_l1408z00_4003;

											BgL_l1408z00_4003 = BgL_g1410z00_4001;
										BgL_zc3z04anonymousza31913ze3z87_4002:
											if (PAIRP(BgL_l1408z00_4003))
												{	/* Stackable/walk.scm 236 */
													{	/* Stackable/walk.scm 236 */
														obj_t BgL_az00_4004;

														BgL_az00_4004 = CAR(BgL_l1408z00_4003);
														BGl_stackablez00zzstackable_walkz00(
															((BgL_nodez00_bglt) BgL_az00_4004), ((bool_t) 1),
															((long) 100000), ((obj_t) BgL_ctxz00_3783));
													}
													{
														obj_t BgL_l1408z00_5564;

														BgL_l1408z00_5564 = CDR(BgL_l1408z00_4003);
														BgL_l1408z00_4003 = BgL_l1408z00_5564;
														goto BgL_zc3z04anonymousza31913ze3z87_4002;
													}
												}
											else
												{	/* Stackable/walk.scm 236 */
													BgL_tmpz00_5530 = ((bool_t) 1);
												}
										}
									}
								else
									{	/* Stackable/walk.scm 237 */
										bool_t BgL_test2485z00_5566;

										if (BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_fz00_4000), BGl_sfunz00zzast_varz00))
											{	/* Stackable/walk.scm 237 */
												if (BGl_importzf3zf3zzstackable_walkz00(BgL_vz00_3999))
													{	/* Stackable/walk.scm 237 */
														BgL_test2485z00_5566 = ((bool_t) 0);
													}
												else
													{	/* Stackable/walk.scm 237 */
														BgL_test2485z00_5566 = ((bool_t) 1);
													}
											}
										else
											{	/* Stackable/walk.scm 237 */
												BgL_test2485z00_5566 = ((bool_t) 0);
											}
										if (BgL_test2485z00_5566)
											{	/* Stackable/walk.scm 237 */
												BGl_varzd2stackablezd2zzstackable_walkz00(BgL_vz00_3999,
													((obj_t) BgL_ctxz00_3783));
												{	/* Stackable/walk.scm 240 */
													obj_t BgL_g1414z00_4005;
													obj_t BgL_g1415z00_4006;

													BgL_g1414z00_4005 =
														(((BgL_sfunz00_bglt) COBJECT(
																((BgL_sfunz00_bglt) BgL_fz00_4000)))->
														BgL_argsz00);
													BgL_g1415z00_4006 =
														(((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt)
																	BgL_nodez00_3780)))->BgL_argsz00);
													{
														obj_t BgL_ll1411z00_4008;
														obj_t BgL_ll1412z00_4009;

														BgL_ll1411z00_4008 = BgL_g1414z00_4005;
														BgL_ll1412z00_4009 = BgL_g1415z00_4006;
													BgL_zc3z04anonymousza31921ze3z87_4007:
														if (NULLP(BgL_ll1411z00_4008))
															{	/* Stackable/walk.scm 240 */
																BgL_tmpz00_5530 = ((bool_t) 1);
															}
														else
															{	/* Stackable/walk.scm 240 */
																{	/* Stackable/walk.scm 241 */
																	obj_t BgL_pz00_4010;
																	obj_t BgL_az00_4011;

																	BgL_pz00_4010 =
																		CAR(((obj_t) BgL_ll1411z00_4008));
																	BgL_az00_4011 =
																		CAR(((obj_t) BgL_ll1412z00_4009));
																	if (BGl_isazf3zf3zz__objectz00(BgL_pz00_4010,
																			BGl_localz00zzast_varz00))
																		{	/* Stackable/walk.scm 243 */
																			bool_t BgL_arg1926z00_4012;

																			if (CBOOL(
																					(((BgL_localz00_bglt) COBJECT(
																								((BgL_localz00_bglt)
																									BgL_pz00_4010)))->
																						BgL_valzd2noescapezd2)))
																				{	/* Stackable/walk.scm 243 */
																					BgL_arg1926z00_4012 = ((bool_t) 0);
																				}
																			else
																				{	/* Stackable/walk.scm 243 */
																					BgL_arg1926z00_4012 = ((bool_t) 1);
																				}
																			BGl_stackablez00zzstackable_walkz00(
																				((BgL_nodez00_bglt) BgL_az00_4011),
																				BgL_arg1926z00_4012, ((long) 100000),
																				((obj_t) BgL_ctxz00_3783));
																		}
																	else
																		{	/* Stackable/walk.scm 241 */
																			BFALSE;
																		}
																}
																{	/* Stackable/walk.scm 240 */
																	obj_t BgL_arg1929z00_4013;
																	obj_t BgL_arg1930z00_4014;

																	BgL_arg1929z00_4013 =
																		CDR(((obj_t) BgL_ll1411z00_4008));
																	BgL_arg1930z00_4014 =
																		CDR(((obj_t) BgL_ll1412z00_4009));
																	{
																		obj_t BgL_ll1412z00_5598;
																		obj_t BgL_ll1411z00_5597;

																		BgL_ll1411z00_5597 = BgL_arg1929z00_4013;
																		BgL_ll1412z00_5598 = BgL_arg1930z00_4014;
																		BgL_ll1412z00_4009 = BgL_ll1412z00_5598;
																		BgL_ll1411z00_4008 = BgL_ll1411z00_5597;
																		goto BgL_zc3z04anonymousza31921ze3z87_4007;
																	}
																}
															}
													}
												}
											}
										else
											{	/* Stackable/walk.scm 237 */
												if (BGl_isazf3zf3zz__objectz00(
														((obj_t) BgL_fz00_4000), BGl_funz00zzast_varz00))
													{	/* Stackable/walk.scm 245 */
														if (
															((((BgL_funz00_bglt) COBJECT(
																			((BgL_funz00_bglt) BgL_fz00_4000)))->
																	BgL_argszd2noescapezd2) ==
																CNST_TABLE_REF(((long) 9))))
															{	/* Stackable/walk.scm 249 */
																obj_t BgL_g1418z00_4015;

																BgL_g1418z00_4015 =
																	(((BgL_appz00_bglt) COBJECT(
																			((BgL_appz00_bglt) BgL_nodez00_3780)))->
																	BgL_argsz00);
																{
																	obj_t BgL_l1416z00_4017;

																	BgL_l1416z00_4017 = BgL_g1418z00_4015;
																BgL_zc3z04anonymousza31934ze3z87_4016:
																	if (PAIRP(BgL_l1416z00_4017))
																		{	/* Stackable/walk.scm 249 */
																			{	/* Stackable/walk.scm 249 */
																				obj_t BgL_az00_4018;

																				BgL_az00_4018 = CAR(BgL_l1416z00_4017);
																				BGl_stackablez00zzstackable_walkz00(
																					((BgL_nodez00_bglt) BgL_az00_4018),
																					((bool_t) 0), ((long) 100000),
																					((obj_t) BgL_ctxz00_3783));
																			}
																			{
																				obj_t BgL_l1416z00_5615;

																				BgL_l1416z00_5615 =
																					CDR(BgL_l1416z00_4017);
																				BgL_l1416z00_4017 = BgL_l1416z00_5615;
																				goto
																					BgL_zc3z04anonymousza31934ze3z87_4016;
																			}
																		}
																	else
																		{	/* Stackable/walk.scm 249 */
																			BgL_tmpz00_5530 = ((bool_t) 1);
																		}
																}
															}
														else
															{	/* Stackable/walk.scm 250 */
																bool_t BgL_test2494z00_5617;

																if (
																	((((BgL_funz00_bglt) COBJECT(
																					((BgL_funz00_bglt) BgL_fz00_4000)))->
																			BgL_argszd2retescapezd2) ==
																		CNST_TABLE_REF(((long) 9))))
																	{	/* Stackable/walk.scm 250 */
																		if (CBOOL(
																				(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								BgL_nodez00_3780)))->
																					BgL_stackablez00)))
																			{	/* Stackable/walk.scm 250 */
																				BgL_argsz00_3992 =
																					(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								BgL_nodez00_3780)))->
																					BgL_argsz00);
																				{
																					obj_t BgL_l1405z00_3994;

																					BgL_l1405z00_3994 = BgL_argsz00_3992;
																				BgL_zc3z04anonymousza31991ze3z87_3993:
																					if (NULLP(BgL_l1405z00_3994))
																						{	/* Stackable/walk.scm 207 */
																							BgL_test2494z00_5617 =
																								((bool_t) 1);
																						}
																					else
																						{	/* Stackable/walk.scm 209 */
																							obj_t BgL_nvz00_3995;

																							{	/* Stackable/walk.scm 209 */
																								obj_t BgL_az00_3996;

																								BgL_az00_3996 =
																									CAR(
																									((obj_t) BgL_l1405z00_3994));
																								if (BGl_isazf3zf3zz__objectz00
																									(BgL_az00_3996,
																										BGl_appz00zzast_nodez00))
																									{	/* Stackable/walk.scm 209 */
																										BgL_nvz00_3995 =
																											(((BgL_appz00_bglt)
																												COBJECT((
																														(BgL_appz00_bglt)
																														BgL_az00_3996)))->
																											BgL_stackablez00);
																									}
																								else
																									{	/* Stackable/walk.scm 209 */
																										if (BGl_isazf3zf3zz__objectz00(BgL_az00_3996, BGl_makezd2boxzd2zzast_nodez00))
																											{	/* Stackable/walk.scm 211 */
																												BgL_nvz00_3995 =
																													(((BgL_makezd2boxzd2_bglt) COBJECT(((BgL_makezd2boxzd2_bglt) BgL_az00_3996)))->BgL_stackablez00);
																											}
																										else
																											{	/* Stackable/walk.scm 211 */
																												if (BGl_isazf3zf3zz__objectz00(BgL_az00_3996, BGl_varz00zzast_nodez00))
																													{	/* Stackable/walk.scm 215 */
																														bool_t
																															BgL_test2501z00_5641;
																														{	/* Stackable/walk.scm 215 */
																															BgL_variablez00_bglt
																																BgL_arg1999z00_3997;
																															BgL_arg1999z00_3997
																																=
																																(((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_az00_3996)))->BgL_variablez00);
																															BgL_test2501z00_5641
																																=
																																BGl_isazf3zf3zz__objectz00
																																(((obj_t)
																																	BgL_arg1999z00_3997),
																																BGl_localz00zzast_varz00);
																														}
																														if (BgL_test2501z00_5641)
																															{	/* Stackable/walk.scm 215 */
																																BgL_nvz00_3995 =
																																	(((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) (((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_az00_3996)))->BgL_variablez00))))->BgL_valzd2noescapezd2);
																															}
																														else
																															{	/* Stackable/walk.scm 215 */
																																BgL_nvz00_3995 =
																																	BFALSE;
																															}
																													}
																												else
																													{	/* Stackable/walk.scm 213 */
																														if (BGl_isazf3zf3zz__objectz00(BgL_az00_3996, BGl_atomz00zzast_nodez00))
																															{	/* Stackable/walk.scm 218 */
																																BgL_nvz00_3995 =
																																	BTRUE;
																															}
																														else
																															{	/* Stackable/walk.scm 218 */
																																BgL_nvz00_3995 =
																																	BBOOL
																																	(BGl_isazf3zf3zz__objectz00
																																	(BgL_az00_3996,
																																		BGl_kwotez00zzast_nodez00));
																															}
																													}
																											}
																									}
																							}
																							if (CBOOL(BgL_nvz00_3995))
																								{
																									obj_t BgL_l1405z00_5656;

																									BgL_l1405z00_5656 =
																										CDR(
																										((obj_t)
																											BgL_l1405z00_3994));
																									BgL_l1405z00_3994 =
																										BgL_l1405z00_5656;
																									goto
																										BgL_zc3z04anonymousza31991ze3z87_3993;
																								}
																							else
																								{	/* Stackable/walk.scm 207 */
																									BgL_test2494z00_5617 =
																										((bool_t) 0);
																								}
																						}
																				}
																			}
																		else
																			{	/* Stackable/walk.scm 250 */
																				BgL_test2494z00_5617 = ((bool_t) 0);
																			}
																	}
																else
																	{	/* Stackable/walk.scm 250 */
																		BgL_test2494z00_5617 = ((bool_t) 0);
																	}
																if (BgL_test2494z00_5617)
																	{	/* Stackable/walk.scm 251 */
																		obj_t BgL_g1421z00_4019;

																		BgL_g1421z00_4019 =
																			(((BgL_appz00_bglt) COBJECT(
																					((BgL_appz00_bglt)
																						BgL_nodez00_3780)))->BgL_argsz00);
																		{
																			obj_t BgL_l1419z00_4021;

																			BgL_l1419z00_4021 = BgL_g1421z00_4019;
																		BgL_zc3z04anonymousza31944ze3z87_4020:
																			if (PAIRP(BgL_l1419z00_4021))
																				{	/* Stackable/walk.scm 251 */
																					{	/* Stackable/walk.scm 251 */
																						obj_t BgL_az00_4022;

																						BgL_az00_4022 =
																							CAR(BgL_l1419z00_4021);
																						BGl_stackablez00zzstackable_walkz00(
																							((BgL_nodez00_bglt)
																								BgL_az00_4022), ((bool_t) 0),
																							(long) CINT(BgL_depthz00_3782),
																							((obj_t) BgL_ctxz00_3783));
																					}
																					{
																						obj_t BgL_l1419z00_5670;

																						BgL_l1419z00_5670 =
																							CDR(BgL_l1419z00_4021);
																						BgL_l1419z00_4021 =
																							BgL_l1419z00_5670;
																						goto
																							BgL_zc3z04anonymousza31944ze3z87_4020;
																					}
																				}
																			else
																				{	/* Stackable/walk.scm 251 */
																					BgL_tmpz00_5530 = ((bool_t) 1);
																				}
																		}
																	}
																else
																	{	/* Stackable/walk.scm 252 */
																		bool_t BgL_test2505z00_5672;

																		{	/* Stackable/walk.scm 252 */
																			bool_t BgL_test2506z00_5673;

																			{	/* Stackable/walk.scm 252 */
																				obj_t BgL_tmpz00_5674;

																				BgL_tmpz00_5674 =
																					(((BgL_funz00_bglt) COBJECT(
																							((BgL_funz00_bglt)
																								BgL_fz00_4000)))->
																					BgL_argszd2noescapezd2);
																				BgL_test2506z00_5673 =
																					PAIRP(BgL_tmpz00_5674);
																			}
																			if (BgL_test2506z00_5673)
																				{	/* Stackable/walk.scm 252 */
																					BgL_test2505z00_5672 = ((bool_t) 1);
																				}
																			else
																				{	/* Stackable/walk.scm 252 */
																					obj_t BgL_tmpz00_5678;

																					BgL_tmpz00_5678 =
																						(((BgL_funz00_bglt) COBJECT(
																								((BgL_funz00_bglt)
																									BgL_fz00_4000)))->
																						BgL_argszd2retescapezd2);
																					BgL_test2505z00_5672 =
																						PAIRP(BgL_tmpz00_5678);
																				}
																		}
																		if (BgL_test2505z00_5672)
																			{
																				long BgL_iz00_4024;
																				obj_t BgL_argsz00_4025;

																				BgL_iz00_4024 = ((long) 0);
																				BgL_argsz00_4025 =
																					(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								BgL_nodez00_3780)))->
																					BgL_argsz00);
																			BgL_loopz00_4023:
																				if (PAIRP(BgL_argsz00_4025))
																					{	/* Stackable/walk.scm 255 */
																						if (CBOOL
																							(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
																								(BINT(BgL_iz00_4024),
																									(((BgL_funz00_bglt)
																											COBJECT(((BgL_funz00_bglt)
																													BgL_fz00_4000)))->
																										BgL_argszd2noescapezd2))))
																							{	/* Stackable/walk.scm 258 */
																								obj_t BgL_arg1958z00_4026;

																								BgL_arg1958z00_4026 =
																									CAR(BgL_argsz00_4025);
																								BGl_stackablez00zzstackable_walkz00
																									(((BgL_nodez00_bglt)
																										BgL_arg1958z00_4026),
																									((bool_t) 0), ((long) 100000),
																									((obj_t) BgL_ctxz00_3783));
																							}
																						else
																							{	/* Stackable/walk.scm 259 */
																								bool_t BgL_test2509z00_5694;

																								if (CBOOL
																									(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
																										(BINT(BgL_iz00_4024),
																											(((BgL_funz00_bglt)
																													COBJECT((
																															(BgL_funz00_bglt)
																															BgL_fz00_4000)))->
																												BgL_argszd2retescapezd2))))
																									{	/* Stackable/walk.scm 259 */
																										BgL_test2509z00_5694 =
																											CBOOL(
																											(((BgL_appz00_bglt)
																													COBJECT((
																															(BgL_appz00_bglt)
																															BgL_nodez00_3780)))->
																												BgL_stackablez00));
																									}
																								else
																									{	/* Stackable/walk.scm 259 */
																										BgL_test2509z00_5694 =
																											((bool_t) 0);
																									}
																								if (BgL_test2509z00_5694)
																									{	/* Stackable/walk.scm 260 */
																										obj_t BgL_arg1964z00_4027;
																										bool_t BgL_arg1965z00_4028;

																										BgL_arg1964z00_4027 =
																											CAR(BgL_argsz00_4025);
																										if (CBOOL(
																												(((BgL_appz00_bglt)
																														COBJECT((
																																(BgL_appz00_bglt)
																																BgL_nodez00_3780)))->
																													BgL_stackablez00)))
																											{	/* Stackable/walk.scm 260 */
																												BgL_arg1965z00_4028 =
																													((bool_t) 0);
																											}
																										else
																											{	/* Stackable/walk.scm 260 */
																												BgL_arg1965z00_4028 =
																													((bool_t) 1);
																											}
																										BGl_stackablez00zzstackable_walkz00
																											(((BgL_nodez00_bglt)
																												BgL_arg1964z00_4027),
																											BgL_arg1965z00_4028,
																											(long)
																											CINT(BgL_depthz00_3782),
																											((obj_t)
																												BgL_ctxz00_3783));
																									}
																								else
																									{	/* Stackable/walk.scm 262 */
																										obj_t BgL_arg1967z00_4029;

																										BgL_arg1967z00_4029 =
																											CAR(BgL_argsz00_4025);
																										BGl_stackablez00zzstackable_walkz00
																											(((BgL_nodez00_bglt)
																												BgL_arg1967z00_4029),
																											((bool_t) 1),
																											(long)
																											CINT(BgL_depthz00_3782),
																											((obj_t)
																												BgL_ctxz00_3783));
																							}}
																						{
																							obj_t BgL_argsz00_5720;
																							long BgL_iz00_5718;

																							BgL_iz00_5718 =
																								(BgL_iz00_4024 + ((long) 1));
																							BgL_argsz00_5720 =
																								CDR(BgL_argsz00_4025);
																							BgL_argsz00_4025 =
																								BgL_argsz00_5720;
																							BgL_iz00_4024 = BgL_iz00_5718;
																							goto BgL_loopz00_4023;
																						}
																					}
																				else
																					{	/* Stackable/walk.scm 255 */
																						BgL_tmpz00_5530 = ((bool_t) 0);
																					}
																			}
																		else
																			{	/* Stackable/walk.scm 265 */
																				obj_t BgL_g1424z00_4030;

																				BgL_g1424z00_4030 =
																					(((BgL_appz00_bglt) COBJECT(
																							((BgL_appz00_bglt)
																								BgL_nodez00_3780)))->
																					BgL_argsz00);
																				{
																					obj_t BgL_l1422z00_4032;

																					BgL_l1422z00_4032 = BgL_g1424z00_4030;
																				BgL_zc3z04anonymousza31972ze3z87_4031:
																					if (PAIRP(BgL_l1422z00_4032))
																						{	/* Stackable/walk.scm 265 */
																							{	/* Stackable/walk.scm 265 */
																								obj_t BgL_az00_4033;

																								BgL_az00_4033 =
																									CAR(BgL_l1422z00_4032);
																								BGl_stackablez00zzstackable_walkz00
																									(((BgL_nodez00_bglt)
																										BgL_az00_4033),
																									((bool_t) 1), ((long) 100000),
																									((obj_t) BgL_ctxz00_3783));
																							}
																							{
																								obj_t BgL_l1422z00_5732;

																								BgL_l1422z00_5732 =
																									CDR(BgL_l1422z00_4032);
																								BgL_l1422z00_4032 =
																									BgL_l1422z00_5732;
																								goto
																									BgL_zc3z04anonymousza31972ze3z87_4031;
																							}
																						}
																					else
																						{	/* Stackable/walk.scm 265 */
																							BgL_tmpz00_5530 = ((bool_t) 1);
																						}
																				}
																			}
																	}
															}
													}
												else
													{	/* Stackable/walk.scm 267 */
														obj_t BgL_g1427z00_4034;

														BgL_g1427z00_4034 =
															(((BgL_appz00_bglt) COBJECT(
																	((BgL_appz00_bglt) BgL_nodez00_3780)))->
															BgL_argsz00);
														{
															obj_t BgL_l1425z00_4036;

															BgL_l1425z00_4036 = BgL_g1427z00_4034;
														BgL_zc3z04anonymousza31982ze3z87_4035:
															if (PAIRP(BgL_l1425z00_4036))
																{	/* Stackable/walk.scm 267 */
																	{	/* Stackable/walk.scm 267 */
																		obj_t BgL_az00_4037;

																		BgL_az00_4037 = CAR(BgL_l1425z00_4036);
																		BGl_stackablez00zzstackable_walkz00(
																			((BgL_nodez00_bglt) BgL_az00_4037),
																			((bool_t) 1), ((long) 100000),
																			((obj_t) BgL_ctxz00_3783));
																	}
																	{
																		obj_t BgL_l1425z00_5742;

																		BgL_l1425z00_5742 = CDR(BgL_l1425z00_4036);
																		BgL_l1425z00_4036 = BgL_l1425z00_5742;
																		goto BgL_zc3z04anonymousza31982ze3z87_4035;
																	}
																}
															else
																{	/* Stackable/walk.scm 267 */
																	BgL_tmpz00_5530 = ((bool_t) 1);
																}
														}
													}
											}
									}
							}
						}
					}
				}
				return BBOOL(BgL_tmpz00_5530);
			}
		}

	}



/* &stackable-let-fun1469 */
	obj_t BGl_z62stackablezd2letzd2fun1469z62zzstackable_walkz00(obj_t
		BgL_envz00_3784, obj_t BgL_nodez00_3785, obj_t BgL_escpz00_3786,
		obj_t BgL_depthz00_3787, obj_t BgL_ctxz00_3788)
	{
		{	/* Stackable/walk.scm 177 */
			{	/* Stackable/walk.scm 179 */
				obj_t BgL_g1404z00_4040;

				BgL_g1404z00_4040 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3785)))->BgL_localsz00);
				{
					obj_t BgL_l1402z00_4042;

					BgL_l1402z00_4042 = BgL_g1404z00_4040;
				BgL_zc3z04anonymousza31900ze3z87_4041:
					if (PAIRP(BgL_l1402z00_4042))
						{	/* Stackable/walk.scm 179 */
							{	/* Stackable/walk.scm 180 */
								obj_t BgL_localz00_4043;

								BgL_localz00_4043 = CAR(BgL_l1402z00_4042);
								{	/* Stackable/walk.scm 181 */
									BgL_sfunz00_bglt BgL_i1187z00_4044;

									BgL_i1187z00_4044 =
										((BgL_sfunz00_bglt)
										(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt)
														((BgL_localz00_bglt) BgL_localz00_4043))))->
											BgL_valuez00));
									{	/* Stackable/walk.scm 182 */
										obj_t BgL_arg1902z00_4045;
										long BgL_arg1903z00_4046;

										BgL_arg1902z00_4045 =
											(((BgL_sfunz00_bglt) COBJECT(BgL_i1187z00_4044))->
											BgL_bodyz00);
										{
											BgL_localzf2depthzf2_bglt BgL_auxz00_5755;

											{
												obj_t BgL_auxz00_5756;

												{	/* Stackable/walk.scm 182 */
													BgL_objectz00_bglt BgL_tmpz00_5757;

													BgL_tmpz00_5757 =
														((BgL_objectz00_bglt)
														((BgL_localz00_bglt) BgL_localz00_4043));
													BgL_auxz00_5756 =
														BGL_OBJECT_WIDENING(BgL_tmpz00_5757);
												}
												BgL_auxz00_5755 =
													((BgL_localzf2depthzf2_bglt) BgL_auxz00_5756);
											}
											BgL_arg1903z00_4046 =
												(((BgL_localzf2depthzf2_bglt)
													COBJECT(BgL_auxz00_5755))->BgL_depthz00);
										}
										BGl_stackablez00zzstackable_walkz00(
											((BgL_nodez00_bglt) BgL_arg1902z00_4045), ((bool_t) 0),
											BgL_arg1903z00_4046, ((obj_t) BgL_ctxz00_3788));
							}}}
							{
								obj_t BgL_l1402z00_5766;

								BgL_l1402z00_5766 = CDR(BgL_l1402z00_4042);
								BgL_l1402z00_4042 = BgL_l1402z00_5766;
								goto BgL_zc3z04anonymousza31900ze3z87_4041;
							}
						}
					else
						{	/* Stackable/walk.scm 179 */
							((bool_t) 1);
						}
				}
			}
			return
				BGl_stackablez00zzstackable_walkz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3785)))->BgL_bodyz00),
				CBOOL(BgL_escpz00_3786),
				(long) CINT(BgL_depthz00_3787), ((obj_t) BgL_ctxz00_3788));
		}

	}



/* &stackable-let-var1467 */
	obj_t BGl_z62stackablezd2letzd2var1467z62zzstackable_walkz00(obj_t
		BgL_envz00_3789, obj_t BgL_nodez00_3790, obj_t BgL_escpz00_3791,
		obj_t BgL_depthz00_3792, obj_t BgL_ctxz00_3793)
	{
		{	/* Stackable/walk.scm 164 */
			{	/* Stackable/walk.scm 166 */
				obj_t BgL_g1401z00_4049;

				BgL_g1401z00_4049 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_3790)))->BgL_bindingsz00);
				{
					obj_t BgL_l1399z00_4051;

					BgL_l1399z00_4051 = BgL_g1401z00_4049;
				BgL_zc3z04anonymousza31890ze3z87_4050:
					if (PAIRP(BgL_l1399z00_4051))
						{	/* Stackable/walk.scm 166 */
							{	/* Stackable/walk.scm 167 */
								obj_t BgL_bindz00_4052;

								BgL_bindz00_4052 = CAR(BgL_l1399z00_4051);
								{	/* Stackable/walk.scm 167 */
									obj_t BgL_varz00_4053;
									obj_t BgL_valz00_4054;

									BgL_varz00_4053 = CAR(((obj_t) BgL_bindz00_4052));
									BgL_valz00_4054 = CDR(((obj_t) BgL_bindz00_4052));
									{	/* Stackable/walk.scm 170 */
										bool_t BgL_arg1892z00_4055;
										long BgL_arg1893z00_4056;

										if (CBOOL(
												(((BgL_localz00_bglt) COBJECT(
															((BgL_localz00_bglt)
																((BgL_localz00_bglt) BgL_varz00_4053))))->
													BgL_valzd2noescapezd2)))
											{	/* Stackable/walk.scm 170 */
												BgL_arg1892z00_4055 = ((bool_t) 0);
											}
										else
											{	/* Stackable/walk.scm 170 */
												BgL_arg1892z00_4055 = ((bool_t) 1);
											}
										{
											BgL_localzf2depthzf2_bglt BgL_auxz00_5788;

											{
												obj_t BgL_auxz00_5789;

												{	/* Stackable/walk.scm 170 */
													BgL_objectz00_bglt BgL_tmpz00_5790;

													BgL_tmpz00_5790 =
														((BgL_objectz00_bglt)
														((BgL_localz00_bglt) BgL_varz00_4053));
													BgL_auxz00_5789 =
														BGL_OBJECT_WIDENING(BgL_tmpz00_5790);
												}
												BgL_auxz00_5788 =
													((BgL_localzf2depthzf2_bglt) BgL_auxz00_5789);
											}
											BgL_arg1893z00_4056 =
												(((BgL_localzf2depthzf2_bglt)
													COBJECT(BgL_auxz00_5788))->BgL_depthz00);
										}
										BGl_stackablez00zzstackable_walkz00(
											((BgL_nodez00_bglt) BgL_valz00_4054), BgL_arg1892z00_4055,
											BgL_arg1893z00_4056, ((obj_t) BgL_ctxz00_3793));
									}
								}
							}
							{
								obj_t BgL_l1399z00_5799;

								BgL_l1399z00_5799 = CDR(BgL_l1399z00_4051);
								BgL_l1399z00_4051 = BgL_l1399z00_5799;
								goto BgL_zc3z04anonymousza31890ze3z87_4050;
							}
						}
					else
						{	/* Stackable/walk.scm 166 */
							((bool_t) 1);
						}
				}
			}
			return
				BGl_stackablez00zzstackable_walkz00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_3790)))->BgL_bodyz00),
				CBOOL(BgL_escpz00_3791),
				(long) CINT(BgL_depthz00_3792), ((obj_t) BgL_ctxz00_3793));
		}

	}



/* &stackable-conditiona1465 */
	obj_t BGl_z62stackablezd2conditiona1465zb0zzstackable_walkz00(obj_t
		BgL_envz00_3794, obj_t BgL_nodez00_3795, obj_t BgL_escpz00_3796,
		obj_t BgL_depthz00_3797, obj_t BgL_ctxz00_3798)
	{
		{	/* Stackable/walk.scm 155 */
			BGl_stackablez00zzstackable_walkz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_3795)))->BgL_testz00),
				((bool_t) 0), (long) CINT(BgL_depthz00_3797),
				((obj_t) BgL_ctxz00_3798));
			BGl_stackablez00zzstackable_walkz00((((BgL_conditionalz00_bglt)
						COBJECT(((BgL_conditionalz00_bglt) BgL_nodez00_3795)))->
					BgL_truez00), CBOOL(BgL_escpz00_3796), (long) CINT(BgL_depthz00_3797),
				((obj_t) BgL_ctxz00_3798));
			return BGl_stackablez00zzstackable_walkz00((((BgL_conditionalz00_bglt)
						COBJECT(((BgL_conditionalz00_bglt) BgL_nodez00_3795)))->
					BgL_falsez00), CBOOL(BgL_escpz00_3796),
				(long) CINT(BgL_depthz00_3797), ((obj_t) BgL_ctxz00_3798));
		}

	}



/* &stackable-setq1463 */
	obj_t BGl_z62stackablezd2setq1463zb0zzstackable_walkz00(obj_t BgL_envz00_3799,
		obj_t BgL_nodez00_3800, obj_t BgL_escpz00_3801, obj_t BgL_depthz00_3802,
		obj_t BgL_ctxz00_3803)
	{
		{	/* Stackable/walk.scm 144 */
			{	/* Stackable/walk.scm 146 */
				BgL_varz00_bglt BgL_i1180z00_4061;

				BgL_i1180z00_4061 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_3800)))->BgL_varz00);
				{	/* Stackable/walk.scm 147 */
					bool_t BgL_test2517z00_5826;

					{	/* Stackable/walk.scm 147 */
						BgL_variablez00_bglt BgL_arg1878z00_4062;

						BgL_arg1878z00_4062 =
							(((BgL_varz00_bglt) COBJECT(BgL_i1180z00_4061))->BgL_variablez00);
						BgL_test2517z00_5826 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_arg1878z00_4062), BGl_globalz00zzast_varz00);
					}
					if (BgL_test2517z00_5826)
						{	/* Stackable/walk.scm 147 */
							return
								BGl_stackablez00zzstackable_walkz00(
								(((BgL_setqz00_bglt) COBJECT(
											((BgL_setqz00_bglt) BgL_nodez00_3800)))->BgL_valuez00),
								((bool_t) 1), ((long) -1), ((obj_t) BgL_ctxz00_3803));
						}
					else
						{	/* Stackable/walk.scm 149 */
							BgL_localz00_bglt BgL_i1181z00_4063;

							BgL_i1181z00_4063 =
								((BgL_localz00_bglt)
								(((BgL_varz00_bglt) COBJECT(BgL_i1180z00_4061))->
									BgL_variablez00));
							{	/* Stackable/walk.scm 150 */
								BgL_nodez00_bglt BgL_arg1876z00_4064;
								long BgL_arg1877z00_4065;

								BgL_arg1876z00_4064 =
									(((BgL_setqz00_bglt) COBJECT(
											((BgL_setqz00_bglt) BgL_nodez00_3800)))->BgL_valuez00);
								{
									BgL_localzf2depthzf2_bglt BgL_auxz00_5838;

									{
										obj_t BgL_auxz00_5839;

										{	/* Stackable/walk.scm 150 */
											BgL_objectz00_bglt BgL_tmpz00_5840;

											BgL_tmpz00_5840 =
												((BgL_objectz00_bglt) BgL_i1181z00_4063);
											BgL_auxz00_5839 = BGL_OBJECT_WIDENING(BgL_tmpz00_5840);
										}
										BgL_auxz00_5838 =
											((BgL_localzf2depthzf2_bglt) BgL_auxz00_5839);
									}
									BgL_arg1877z00_4065 =
										(((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5838))->
										BgL_depthz00);
								}
								return
									BGl_stackablez00zzstackable_walkz00(BgL_arg1876z00_4064,
									CBOOL(BgL_escpz00_3801), BgL_arg1877z00_4065,
									((obj_t) BgL_ctxz00_3803));
							}
						}
				}
			}
		}

	}



/* &stackable-closure1461 */
	obj_t BGl_z62stackablezd2closure1461zb0zzstackable_walkz00(obj_t
		BgL_envz00_3804, obj_t BgL_nodez00_3805, obj_t BgL_escpz00_3806,
		obj_t BgL_depthz00_3807, obj_t BgL_ctxz00_3808)
	{
		{	/* Stackable/walk.scm 130 */
			{

				{	/* Stackable/walk.scm 130 */
					obj_t BgL_nextzd2method1460zd2_4069;

					BgL_nextzd2method1460zd2_4069 =
						BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
						((BgL_objectz00_bglt)
							((BgL_closurez00_bglt) BgL_nodez00_3805)),
						BGl_stackablezd2envzd2zzstackable_walkz00,
						BGl_closurez00zzast_nodez00);
					PROCEDURE_ENTRY(BgL_nextzd2method1460zd2_4069)
						(BgL_nextzd2method1460zd2_4069,
						((obj_t) ((BgL_closurez00_bglt) BgL_nodez00_3805)),
						BgL_escpz00_3806, BgL_depthz00_3807, ((obj_t) BgL_ctxz00_3808),
						BEOA);
				}
				{	/* Stackable/walk.scm 132 */
					BgL_variablez00_bglt BgL_vz00_4070;

					BgL_vz00_4070 =
						(((BgL_varz00_bglt) COBJECT(
								((BgL_varz00_bglt)
									((BgL_closurez00_bglt) BgL_nodez00_3805))))->BgL_variablez00);
					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_vz00_4070), BGl_localz00zzast_varz00))
						{	/* Stackable/walk.scm 134 */
							BgL_valuez00_bglt BgL_fz00_4071;

							BgL_fz00_4071 =
								(((BgL_variablez00_bglt) COBJECT(BgL_vz00_4070))->BgL_valuez00);
							{	/* Stackable/walk.scm 137 */
								bool_t BgL_test2519z00_5868;

								if (CBOOL(
										(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_fz00_4071)))->
											BgL_stackablez00)))
									{	/* Stackable/walk.scm 137 */
										if (CBOOL(BgL_escpz00_3806))
											{	/* Stackable/walk.scm 137 */
												BgL_test2519z00_5868 = CBOOL(BgL_escpz00_3806);
											}
										else
											{	/* Stackable/walk.scm 137 */
												if (CBOOL(
														(((BgL_localz00_bglt) COBJECT(
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_vz00_4070))))->
															BgL_valzd2noescapezd2)))
													{	/* Stackable/walk.scm 137 */
														BgL_test2519z00_5868 = ((bool_t) 0);
													}
												else
													{	/* Stackable/walk.scm 137 */
														BgL_test2519z00_5868 = ((bool_t) 1);
													}
											}
									}
								else
									{	/* Stackable/walk.scm 137 */
										BgL_test2519z00_5868 = ((bool_t) 0);
									}
								if (BgL_test2519z00_5868)
									{	/* Stackable/walk.scm 137 */
										{	/* Stackable/walk.scm 138 */
											obj_t BgL_tmpz00_5881;

											BgL_tmpz00_5881 = ((obj_t) BgL_ctxz00_3808);
											SET_CAR(BgL_tmpz00_5881, BFALSE);
										}
										return
											((((BgL_sfunz00_bglt) COBJECT(
														((BgL_sfunz00_bglt) BgL_fz00_4071)))->
												BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
									}
								else
									{	/* Stackable/walk.scm 137 */
										return BFALSE;
									}
							}
						}
					else
						{	/* Stackable/walk.scm 133 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &stackable-var1459 */
	obj_t BGl_z62stackablezd2var1459zb0zzstackable_walkz00(obj_t BgL_envz00_3809,
		obj_t BgL_nodez00_3810, obj_t BgL_escpz00_3811, obj_t BgL_depthz00_3812,
		obj_t BgL_ctxz00_3813)
	{
		{	/* Stackable/walk.scm 120 */
			{	/* Stackable/walk.scm 122 */
				bool_t BgL_test2523z00_5886;

				{	/* Stackable/walk.scm 122 */
					BgL_variablez00_bglt BgL_arg1858z00_4074;

					BgL_arg1858z00_4074 =
						(((BgL_varz00_bglt) COBJECT(
								((BgL_varz00_bglt) BgL_nodez00_3810)))->BgL_variablez00);
					BgL_test2523z00_5886 =
						BGl_isazf3zf3zz__objectz00(
						((obj_t) BgL_arg1858z00_4074), BGl_localz00zzast_varz00);
				}
				if (BgL_test2523z00_5886)
					{	/* Stackable/walk.scm 123 */
						BgL_localz00_bglt BgL_i1175z00_4075;

						BgL_i1175z00_4075 =
							((BgL_localz00_bglt)
							(((BgL_varz00_bglt) COBJECT(
										((BgL_varz00_bglt) BgL_nodez00_3810)))->BgL_variablez00));
						{	/* Stackable/walk.scm 124 */
							bool_t BgL_test2524z00_5894;

							if (CBOOL(BgL_escpz00_3811))
								{	/* Stackable/walk.scm 124 */
									BgL_test2524z00_5894 = ((bool_t) 1);
								}
							else
								{	/* Stackable/walk.scm 124 */
									long BgL_arg1857z00_4076;

									{
										BgL_localzf2depthzf2_bglt BgL_auxz00_5897;

										{
											obj_t BgL_auxz00_5898;

											{	/* Stackable/walk.scm 124 */
												BgL_objectz00_bglt BgL_tmpz00_5899;

												BgL_tmpz00_5899 =
													((BgL_objectz00_bglt) BgL_i1175z00_4075);
												BgL_auxz00_5898 = BGL_OBJECT_WIDENING(BgL_tmpz00_5899);
											}
											BgL_auxz00_5897 =
												((BgL_localzf2depthzf2_bglt) BgL_auxz00_5898);
										}
										BgL_arg1857z00_4076 =
											(((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5897))->
											BgL_depthz00);
									}
									BgL_test2524z00_5894 =
										((long) CINT(BgL_depthz00_3812) < BgL_arg1857z00_4076);
								}
							if (BgL_test2524z00_5894)
								{	/* Stackable/walk.scm 125 */
									BgL_variablez00_bglt BgL_arg1856z00_4077;

									BgL_arg1856z00_4077 =
										(((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_nodez00_3810)))->
										BgL_variablez00);
									return BGl_escapez12z12zzstackable_walkz00(((obj_t)
											BgL_arg1856z00_4077), ((obj_t) BgL_ctxz00_3813));
								}
							else
								{	/* Stackable/walk.scm 124 */
									return BFALSE;
								}
						}
					}
				else
					{	/* Stackable/walk.scm 122 */
						return BFALSE;
					}
			}
		}

	}



/* &node->sexp-app/depth1455 */
	obj_t BGl_z62nodezd2ze3sexpzd2appzf2depth1455z73zzstackable_walkz00(obj_t
		BgL_envz00_3814, obj_t BgL_nodez00_3815)
	{
		{	/* Stackable/walk.scm 57 */
			{

				{	/* Stackable/walk.scm 59 */
					obj_t BgL_nz00_4081;

					{	/* Stackable/walk.scm 57 */
						obj_t BgL_nextzd2method1454zd2_4080;

						BgL_nextzd2method1454zd2_4080 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							((BgL_objectz00_bglt)
								((BgL_appz00_bglt) BgL_nodez00_3815)),
							BGl_nodezd2ze3sexpzd2envze3zzast_dumpz00,
							BGl_appzf2depthzf2zzstackable_walkz00);
						BgL_nz00_4081 =
							PROCEDURE_ENTRY(BgL_nextzd2method1454zd2_4080)
							(BgL_nextzd2method1454zd2_4080,
							((obj_t) ((BgL_appz00_bglt) BgL_nodez00_3815)), BEOA);
					}
					{	/* Stackable/walk.scm 60 */
						bool_t BgL_test2526z00_5920;

						{	/* Stackable/walk.scm 60 */
							bool_t BgL_test2527z00_5921;

							{	/* Stackable/walk.scm 60 */
								obj_t BgL_tmpz00_5922;

								BgL_tmpz00_5922 = CAR(((obj_t) BgL_nz00_4081));
								BgL_test2527z00_5921 = SYMBOLP(BgL_tmpz00_5922);
							}
							if (BgL_test2527z00_5921)
								{	/* Stackable/walk.scm 60 */
									BgL_test2526z00_5920 =
										CBOOL(BGl_za2keyzd2shapezf3za2z21zzengine_paramz00);
								}
							else
								{	/* Stackable/walk.scm 60 */
									BgL_test2526z00_5920 = ((bool_t) 0);
								}
						}
						if (BgL_test2526z00_5920)
							{	/* Stackable/walk.scm 61 */
								obj_t BgL_arg1834z00_4082;
								obj_t BgL_arg1835z00_4083;

								{	/* Stackable/walk.scm 61 */
									obj_t BgL_arg1837z00_4084;

									{	/* Stackable/walk.scm 61 */
										obj_t BgL_arg1838z00_4085;
										obj_t BgL_arg1839z00_4086;

										{	/* Stackable/walk.scm 61 */
											obj_t BgL_arg1841z00_4087;

											{	/* Stackable/walk.scm 61 */
												obj_t BgL_arg1843z00_4088;

												{	/* Stackable/walk.scm 61 */
													long BgL_arg1845z00_4089;

													{
														BgL_appzf2depthzf2_bglt BgL_auxz00_5927;

														{
															obj_t BgL_auxz00_5928;

															{	/* Stackable/walk.scm 61 */
																BgL_objectz00_bglt BgL_tmpz00_5929;

																BgL_tmpz00_5929 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_nodez00_3815));
																BgL_auxz00_5928 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_5929);
															}
															BgL_auxz00_5927 =
																((BgL_appzf2depthzf2_bglt) BgL_auxz00_5928);
														}
														BgL_arg1845z00_4089 =
															(((BgL_appzf2depthzf2_bglt)
																COBJECT(BgL_auxz00_5927))->BgL_depthz00);
													}
													{	/* Stackable/walk.scm 61 */
														obj_t BgL_list1846z00_4090;

														BgL_list1846z00_4090 =
															MAKE_YOUNG_PAIR(BINT(BgL_arg1845z00_4089), BNIL);
														BgL_arg1843z00_4088 =
															BGl_formatz00zz__r4_output_6_10_3z00
															(BGl_string2332z00zzstackable_walkz00,
															BgL_list1846z00_4090);
												}}
												BgL_arg1841z00_4087 =
													bstring_to_symbol(BgL_arg1843z00_4088);
											}
											{	/* Stackable/walk.scm 61 */
												obj_t BgL_arg1447z00_4091;

												BgL_arg1447z00_4091 =
													SYMBOL_TO_STRING(BgL_arg1841z00_4087);
												BgL_arg1838z00_4085 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1447z00_4091);
										}}
										{	/* Stackable/walk.scm 61 */
											obj_t BgL_arg1849z00_4092;

											BgL_arg1849z00_4092 = CAR(((obj_t) BgL_nz00_4081));
											{	/* Stackable/walk.scm 61 */
												obj_t BgL_arg1447z00_4093;

												BgL_arg1447z00_4093 =
													SYMBOL_TO_STRING(((obj_t) BgL_arg1849z00_4092));
												BgL_arg1839z00_4086 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1447z00_4093);
										}}
										BgL_arg1837z00_4084 =
											string_append(BgL_arg1838z00_4085, BgL_arg1839z00_4086);
									}
									BgL_arg1834z00_4082 = bstring_to_symbol(BgL_arg1837z00_4084);
								}
								BgL_arg1835z00_4083 = CDR(((obj_t) BgL_nz00_4081));
								return
									MAKE_YOUNG_PAIR(BgL_arg1834z00_4082, BgL_arg1835z00_4083);
							}
						else
							{	/* Stackable/walk.scm 60 */
								return BgL_nz00_4081;
							}
					}
				}
			}
		}

	}



/* &shape-local/depth1453 */
	obj_t BGl_z62shapezd2localzf2depth1453z42zzstackable_walkz00(obj_t
		BgL_envz00_3816, obj_t BgL_varz00_3817)
	{
		{	/* Stackable/walk.scm 48 */
			if (CBOOL(BGl_za2keyzd2shapezf3za2z21zzengine_paramz00))
				{	/* Stackable/walk.scm 51 */
					obj_t BgL_arg1825z00_4095;

					{	/* Stackable/walk.scm 51 */
						long BgL_arg1826z00_4096;
						obj_t BgL_arg1827z00_4097;

						{
							BgL_localzf2depthzf2_bglt BgL_auxz00_5953;

							{
								obj_t BgL_auxz00_5954;

								{	/* Stackable/walk.scm 51 */
									BgL_objectz00_bglt BgL_tmpz00_5955;

									BgL_tmpz00_5955 =
										((BgL_objectz00_bglt)
										((BgL_localz00_bglt) BgL_varz00_3817));
									BgL_auxz00_5954 = BGL_OBJECT_WIDENING(BgL_tmpz00_5955);
								}
								BgL_auxz00_5953 = ((BgL_localzf2depthzf2_bglt) BgL_auxz00_5954);
							}
							BgL_arg1826z00_4096 =
								(((BgL_localzf2depthzf2_bglt) COBJECT(BgL_auxz00_5953))->
								BgL_depthz00);
						}
						BgL_arg1827z00_4097 =
							BGl_callzd2nextzd2methodze70ze7zzstackable_walkz00(
							((BgL_localz00_bglt) BgL_varz00_3817));
						{	/* Stackable/walk.scm 51 */
							obj_t BgL_list1828z00_4098;

							{	/* Stackable/walk.scm 51 */
								obj_t BgL_arg1829z00_4099;

								BgL_arg1829z00_4099 =
									MAKE_YOUNG_PAIR(BgL_arg1827z00_4097, BNIL);
								BgL_list1828z00_4098 =
									MAKE_YOUNG_PAIR(BINT(BgL_arg1826z00_4096),
									BgL_arg1829z00_4099);
							}
							BgL_arg1825z00_4095 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string2333z00zzstackable_walkz00, BgL_list1828z00_4098);
					}}
					return bstring_to_symbol(BgL_arg1825z00_4095);
				}
			else
				{	/* Stackable/walk.scm 50 */
					return
						BGl_callzd2nextzd2methodze70ze7zzstackable_walkz00(
						((BgL_localz00_bglt) BgL_varz00_3817));
				}
		}

	}



/* call-next-method~0 */
	obj_t BGl_callzd2nextzd2methodze70ze7zzstackable_walkz00(BgL_localz00_bglt
		BgL_varz00_3818)
	{
		{	/* Stackable/walk.scm 48 */
			{	/* Stackable/walk.scm 48 */
				obj_t BgL_nextzd2method1452zd2_2055;

				BgL_nextzd2method1452zd2_2055 =
					BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
					((BgL_objectz00_bglt) BgL_varz00_3818),
					BGl_shapezd2envzd2zztools_shapez00,
					BGl_localzf2depthzf2zzstackable_walkz00);
				return
					PROCEDURE_ENTRY(BgL_nextzd2method1452zd2_2055)
					(BgL_nextzd2method1452zd2_2055, ((obj_t) BgL_varz00_3818), BEOA);
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzstackable_walkz00()
	{
		{	/* Stackable/walk.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzast_walkz00(((long) 343174225),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzast_occurz00(((long) 282085879),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string2334z00zzstackable_walkz00));
		}

	}

#ifdef __cplusplus
}
#endif
