/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Trace/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_stackablez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_z62findzd2lastzd2nodezd2appzd2l1321z62zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2nodez62zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2setzd2e1340z62zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zztrace_walkz00 = BUNSPEC;
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern bool_t BGl_isloopzf3zf3zztrace_isloopz00(BgL_letzd2funzd2_bglt);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2exter1325zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2funca1323zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2sequence1346z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static bool_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t);
	static obj_t BGl_toplevelzd2initzd2zztrace_walkz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zztrace_walkz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	static obj_t BGl_z62findzd2lastzd2nodezd2condi1329zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_objectzd2initzd2zztrace_walkz00();
	extern obj_t BGl_castz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	static bool_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62tracezd2nodezd2app1350z62zztrace_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zztrace_walkz00();
	static obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2condition1362z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static obj_t BGl_z62findzd2lastzd2nodezd2letzd2f1338z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2letzd2v1336z62zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2app1319zb0zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2letzd2fun1368zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2jumpzd21342z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt,
		obj_t, obj_t);
	static obj_t BGl_z62tracezd2walkz12za2zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_pragmaz00zzast_nodez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_z62findzd2lastzd2node1312z62zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62tracezd2nodezb0zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2appzd2ly1352zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_fqnameze70ze7zztrace_walkz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztrace_isloopz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1374z62zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2setq1327zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2sync1317zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zztrace_walkz00();
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2extern1356z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setzd2exzd2it1372z62zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00();
	static obj_t BGl_z62findzd2lastzd2nodezd2fail1331zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t);
	static obj_t BGl_gczd2rootszd2initz00zztrace_walkz00();
	static obj_t BGl_z62findzd2lastzd2nodezd2seque1315zb0zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2switch1366z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21384zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21386zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21388zb0zztrace_walkz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62tracezd2node1343zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2funcall1354z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	static obj_t BGl_z62findzd2lastzd2nodezd2switc1334zb0zztrace_walkz00(obj_t,
		obj_t);
	extern bool_t BGl_userzd2symbolzf3z21zzast_identz00(obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2letzd2var1370zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2cast1358z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2makezd2box1376zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2ref1378zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2setz121380za2zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62toplevelzd2tracezd2node1381z62zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setq1360z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2sync1348z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2fail1364z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t __cnst[21];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2113z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2153za7,
		BGl_z62findzd2lastzd2nodezd2sync1317zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2114z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2154za7,
		BGl_z62findzd2lastzd2nodezd2app1319zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2115z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2155za7,
		BGl_z62findzd2lastzd2nodezd2appzd2l1321z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2116z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2156za7,
		BGl_z62findzd2lastzd2nodezd2funca1323zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2117z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2157za7,
		BGl_z62findzd2lastzd2nodezd2exter1325zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2118z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2158za7,
		BGl_z62findzd2lastzd2nodezd2setq1327zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2119z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2159za7,
		BGl_z62findzd2lastzd2nodezd2condi1329zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2127z00zztrace_walkz00,
		BgL_bgl_string2127za700za7za7t2160za7, "trace-node", 10);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2161z00,
		BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2120z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2162za7,
		BGl_z62findzd2lastzd2nodezd2fail1331zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2121z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2163za7,
		BGl_z62findzd2lastzd2nodezd2switc1334zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2122z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2164za7,
		BGl_z62findzd2lastzd2nodezd2letzd2v1336z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2123z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2165za7,
		BGl_z62findzd2lastzd2nodezd2letzd2f1338z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2124z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2166za7,
		BGl_z62findzd2lastzd2nodezd2setzd2e1340z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2125z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2167za7,
		BGl_z62findzd2lastzd2nodezd2jumpzd21342z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2126z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72168za7,
		BGl_z62tracezd2nodezd2sequence1346z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2128z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72169za7,
		BGl_z62tracezd2nodezd2sync1348z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2129z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72170za7,
		BGl_z62tracezd2nodezd2app1350z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2130z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72171za7,
		BGl_z62tracezd2nodezd2appzd2ly1352zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2131z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72172za7,
		BGl_z62tracezd2nodezd2funcall1354z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2132z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72173za7,
		BGl_z62tracezd2nodezd2extern1356z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2133z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72174za7,
		BGl_z62tracezd2nodezd2cast1358z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2134z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72175za7,
		BGl_z62tracezd2nodezd2setq1360z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2135z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72176za7,
		BGl_z62tracezd2nodezd2condition1362z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2136z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72177za7,
		BGl_z62tracezd2nodezd2fail1364z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2137z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72178za7,
		BGl_z62tracezd2nodezd2switch1366z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2138z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72179za7,
		BGl_z62tracezd2nodezd2letzd2fun1368zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2139z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72180za7,
		BGl_z62tracezd2nodezd2letzd2var1370zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2146z00zztrace_walkz00,
		BgL_bgl_string2146za700za7za7t2181za7, "toplevel-trace-node", 19);
	      DEFINE_STRING(BGl_string2149z00zztrace_walkz00,
		BgL_bgl_string2149za700za7za7t2182za7, "trace_walk", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2140z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72183za7,
		BGl_z62tracezd2nodezd2setzd2exzd2it1372z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2141z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72184za7,
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1374z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2142z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72185za7,
		BGl_z62tracezd2nodezd2makezd2box1376zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2143z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72186za7,
		BGl_z62tracezd2nodezd2boxzd2ref1378zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2150z00zztrace_walkz00,
		BgL_bgl_string2150za700za7za7t2187za7,
		"|:| value let $env-pop-trace $env-push-trace current-dynamic-env dynamic-env quote at location env loc name aux generic-init method-init no-trace @ imported-modules-init toplevel-init pass-started ",
		197);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2144z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72188za7,
		BGl_z62tracezd2nodezd2boxzd2setz121380za2zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2145z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2189z00,
		BGl_z62toplevelzd2tracezd2nodezd21384zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2147z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2190z00,
		BGl_z62toplevelzd2tracezd2nodezd21386zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2148z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2191z00,
		BGl_z62toplevelzd2tracezd2nodezd21388zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2095z00zztrace_walkz00,
		BgL_bgl_string2095za700za7za7t2192za7, "Trace", 5);
	      DEFINE_STRING(BGl_string2096z00zztrace_walkz00,
		BgL_bgl_string2096za700za7za7t2193za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2097z00zztrace_walkz00,
		BgL_bgl_string2097za700za7za7t2194za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2098z00zztrace_walkz00,
		BgL_bgl_string2098za700za7za7t2195za7, " error", 6);
	      DEFINE_STRING(BGl_string2099z00zztrace_walkz00,
		BgL_bgl_string2099za700za7za7t2196za7, "s", 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_tracezd2nodezd2envz00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72197za7,
		BGl_z62tracezd2nodezb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_tracezd2walkz12zd2envz12zztrace_walkz00,
		BgL_bgl_za762traceza7d2walkza72198za7,
		BGl_z62tracezd2walkz12za2zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2199za7,
		BGl_z62findzd2lastzd2nodez62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2100z00zztrace_walkz00,
		BgL_bgl_string2100za700za7za7t2200za7, "", 0);
	      DEFINE_STRING(BGl_string2101z00zztrace_walkz00,
		BgL_bgl_string2101za700za7za7t2201za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string2102z00zztrace_walkz00,
		BgL_bgl_string2102za700za7za7t2202za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string2103z00zztrace_walkz00,
		BgL_bgl_string2103za700za7za7t2203za7, "%toplevel@", 10);
	      DEFINE_STRING(BGl_string2104z00zztrace_walkz00,
		BgL_bgl_string2104za700za7za7t2204za7, "%import@", 8);
	      DEFINE_STRING(BGl_string2106z00zztrace_walkz00,
		BgL_bgl_string2106za700za7za7t2205za7, "find-last-node1312", 18);
	      DEFINE_STRING(BGl_string2108z00zztrace_walkz00,
		BgL_bgl_string2108za700za7za7t2206za7, "trace-node1343", 14);
	      DEFINE_STRING(BGl_string2110z00zztrace_walkz00,
		BgL_bgl_string2110za700za7za7t2207za7, "toplevel-trace-node1381", 23);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2105z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2208za7,
		BGl_z62findzd2lastzd2node1312z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2112z00zztrace_walkz00,
		BgL_bgl_string2112za700za7za7t2209za7, "find-last-node", 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2107z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2node12210z00,
		BGl_z62tracezd2node1343zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2109z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2211z00,
		BGl_z62toplevelzd2tracezd2node1381z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2111z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2212za7,
		BGl_z62findzd2lastzd2nodezd2seque1315zb0zztrace_walkz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zztrace_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long
		BgL_checksumz00_2919, char *BgL_fromz00_2920)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zztrace_walkz00))
				{
					BGl_requirezd2initializa7ationz75zztrace_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zztrace_walkz00();
					BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
					BGl_cnstzd2initzd2zztrace_walkz00();
					BGl_importedzd2moduleszd2initz00zztrace_walkz00();
					BGl_genericzd2initzd2zztrace_walkz00();
					BGl_methodzd2initzd2zztrace_walkz00();
					return BGl_toplevelzd2initzd2zztrace_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "trace_walk");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			{	/* Trace/walk.scm 15 */
				obj_t BgL_cportz00_2807;

				{	/* Trace/walk.scm 15 */
					obj_t BgL_stringz00_2815;

					BgL_stringz00_2815 = BGl_string2150z00zztrace_walkz00;
					{	/* Trace/walk.scm 15 */
						obj_t BgL_startz00_2816;

						BgL_startz00_2816 = BINT(((long) 0));
						{	/* Trace/walk.scm 15 */
							obj_t BgL_endz00_2817;

							BgL_endz00_2817 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2815)));
							{	/* Trace/walk.scm 15 */

								BgL_cportz00_2807 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2815, BgL_startz00_2816, BgL_endz00_2817);
				}}}}
				{
					long BgL_iz00_2808;

					BgL_iz00_2808 = ((long) 20);
				BgL_loopz00_2809:
					if ((BgL_iz00_2808 == ((long) -1)))
						{	/* Trace/walk.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Trace/walk.scm 15 */
							{	/* Trace/walk.scm 15 */
								obj_t BgL_arg2152z00_2811;

								{	/* Trace/walk.scm 15 */

									{	/* Trace/walk.scm 15 */
										obj_t BgL_locationz00_2813;

										BgL_locationz00_2813 = BBOOL(((bool_t) 0));
										{	/* Trace/walk.scm 15 */

											BgL_arg2152z00_2811 =
												BGl_readz00zz__readerz00(BgL_cportz00_2807,
												BgL_locationz00_2813);
										}
									}
								}
								{	/* Trace/walk.scm 15 */
									int BgL_tmpz00_2954;

									BgL_tmpz00_2954 = (int) (BgL_iz00_2808);
									CNST_TABLE_SET(BgL_tmpz00_2954, BgL_arg2152z00_2811);
							}}
							{	/* Trace/walk.scm 15 */
								int BgL_auxz00_2814;

								BgL_auxz00_2814 = (int) ((BgL_iz00_2808 - ((long) 1)));
								{
									long BgL_iz00_2959;

									BgL_iz00_2959 = (long) (BgL_auxz00_2814);
									BgL_iz00_2808 = BgL_iz00_2959;
									goto BgL_loopz00_2809;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}

	}



/* trace-walk! */
	BGL_EXPORTED_DEF obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t
		BgL_globalsz00_17)
	{
		{	/* Trace/walk.scm 39 */
			{	/* Trace/walk.scm 40 */
				obj_t BgL_list1452z00_1554;

				{	/* Trace/walk.scm 40 */
					obj_t BgL_arg1484z00_1555;

					{	/* Trace/walk.scm 40 */
						obj_t BgL_arg1500z00_1556;

						BgL_arg1500z00_1556 =
							MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
						BgL_arg1484z00_1555 =
							MAKE_YOUNG_PAIR(BGl_string2095z00zztrace_walkz00,
							BgL_arg1500z00_1556);
					}
					BgL_list1452z00_1554 =
						MAKE_YOUNG_PAIR(BGl_string2096z00zztrace_walkz00,
						BgL_arg1484z00_1555);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1452z00_1554);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string2095z00zztrace_walkz00;
			{	/* Trace/walk.scm 40 */
				obj_t BgL_g1106z00_1557;

				BgL_g1106z00_1557 = BNIL;
				{
					obj_t BgL_hooksz00_1560;
					obj_t BgL_hnamesz00_1561;

					BgL_hooksz00_1560 = BgL_g1106z00_1557;
					BgL_hnamesz00_1561 = BNIL;
				BgL_zc3z04anonymousza31501ze3z87_1562:
					if (NULLP(BgL_hooksz00_1560))
						{	/* Trace/walk.scm 40 */
							CNST_TABLE_REF(((long) 0));
						}
					else
						{	/* Trace/walk.scm 40 */
							bool_t BgL_test2216z00_2972;

							{	/* Trace/walk.scm 40 */
								obj_t BgL_fun1527z00_1569;

								BgL_fun1527z00_1569 = CAR(((obj_t) BgL_hooksz00_1560));
								BgL_test2216z00_2972 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1527z00_1569)
									(BgL_fun1527z00_1569, BEOA));
							}
							if (BgL_test2216z00_2972)
								{	/* Trace/walk.scm 40 */
									obj_t BgL_arg1520z00_1566;
									obj_t BgL_arg1521z00_1567;

									BgL_arg1520z00_1566 = CDR(((obj_t) BgL_hooksz00_1560));
									BgL_arg1521z00_1567 = CDR(((obj_t) BgL_hnamesz00_1561));
									{
										obj_t BgL_hnamesz00_2984;
										obj_t BgL_hooksz00_2983;

										BgL_hooksz00_2983 = BgL_arg1520z00_1566;
										BgL_hnamesz00_2984 = BgL_arg1521z00_1567;
										BgL_hnamesz00_1561 = BgL_hnamesz00_2984;
										BgL_hooksz00_1560 = BgL_hooksz00_2983;
										goto BgL_zc3z04anonymousza31501ze3z87_1562;
									}
								}
							else
								{	/* Trace/walk.scm 40 */
									obj_t BgL_arg1526z00_1568;

									BgL_arg1526z00_1568 = CAR(((obj_t) BgL_hnamesz00_1561));
									BGl_internalzd2errorzd2zztools_errorz00
										(BGl_string2095z00zztrace_walkz00,
										BGl_string2097z00zztrace_walkz00, BgL_arg1526z00_1568);
								}
						}
				}
			}
			{	/* Trace/walk.scm 46 */
				obj_t BgL_idz00_1572;

				BgL_idz00_1572 = CNST_TABLE_REF(((long) 1));
				{	/* Trace/walk.scm 46 */
					obj_t BgL_gloz00_1573;

					{	/* Trace/walk.scm 47 */
						obj_t BgL_list1533z00_1577;

						BgL_list1533z00_1577 =
							MAKE_YOUNG_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL);
						BgL_gloz00_1573 =
							BGl_findzd2globalzd2zzast_envz00(BgL_idz00_1572,
							BgL_list1533z00_1577);
					}
					{	/* Trace/walk.scm 47 */

						if (BGl_isazf3zf3zz__objectz00(BgL_gloz00_1573,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 49 */
								BgL_sfunz00_bglt BgL_i1108z00_1575;

								BgL_i1108z00_1575 =
									((BgL_sfunz00_bglt)
									(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_gloz00_1573))))->
										BgL_valuez00));
								{
									obj_t BgL_auxz00_2997;

									{	/* Trace/walk.scm 50 */
										obj_t BgL_arg1532z00_1576;

										BgL_arg1532z00_1576 =
											(((BgL_sfunz00_bglt) COBJECT(BgL_i1108z00_1575))->
											BgL_bodyz00);
										BgL_auxz00_2997 =
											((obj_t)
											BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((
													(BgL_nodez00_bglt) BgL_arg1532z00_1576)));
									}
									((((BgL_sfunz00_bglt) COBJECT(BgL_i1108z00_1575))->
											BgL_bodyz00) = ((obj_t) BgL_auxz00_2997), BUNSPEC);
								}
							}
						else
							{	/* Trace/walk.scm 48 */
								BFALSE;
							}
					}
				}
			}
			{
				obj_t BgL_l1300z00_1579;

				BgL_l1300z00_1579 = BgL_globalsz00_17;
			BgL_zc3z04anonymousza31534ze3z87_1580:
				if (PAIRP(BgL_l1300z00_1579))
					{	/* Trace/walk.scm 52 */
						{	/* Trace/walk.scm 52 */
							obj_t BgL_vz00_1582;

							BgL_vz00_1582 = CAR(BgL_l1300z00_1579);
							BGl_tracezd2funz12zc0zztrace_walkz00(BgL_vz00_1582, BNIL,
								BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00);
						}
						{
							obj_t BgL_l1300z00_3007;

							BgL_l1300z00_3007 = CDR(BgL_l1300z00_1579);
							BgL_l1300z00_1579 = BgL_l1300z00_3007;
							goto BgL_zc3z04anonymousza31534ze3z87_1580;
						}
					}
				else
					{	/* Trace/walk.scm 52 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Trace/walk.scm 53 */
					{	/* Trace/walk.scm 53 */
						obj_t BgL_port1302z00_1587;

						{	/* Trace/walk.scm 53 */
							obj_t BgL_tmpz00_3012;

							BgL_tmpz00_3012 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_port1302z00_1587 =
								BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_3012);
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1302z00_1587);
						bgl_display_string(BGl_string2098z00zztrace_walkz00,
							BgL_port1302z00_1587);
						{	/* Trace/walk.scm 53 */
							obj_t BgL_arg1542z00_1588;

							{	/* Trace/walk.scm 53 */
								bool_t BgL_test2220z00_3017;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Trace/walk.scm 53 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Trace/walk.scm 53 */
												BgL_test2220z00_3017 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Trace/walk.scm 53 */
												BgL_test2220z00_3017 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Trace/walk.scm 53 */
										BgL_test2220z00_3017 = ((bool_t) 0);
									}
								if (BgL_test2220z00_3017)
									{	/* Trace/walk.scm 53 */
										BgL_arg1542z00_1588 = BGl_string2099z00zztrace_walkz00;
									}
								else
									{	/* Trace/walk.scm 53 */
										BgL_arg1542z00_1588 = BGl_string2100z00zztrace_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1542z00_1588, BgL_port1302z00_1587);
						}
						bgl_display_string(BGl_string2101z00zztrace_walkz00,
							BgL_port1302z00_1587);
						bgl_display_char(((unsigned char) 10), BgL_port1302z00_1587);
					}
					{	/* Trace/walk.scm 53 */
						obj_t BgL_list1546z00_1594;

						BgL_list1546z00_1594 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1546z00_1594);
					}
				}
			else
				{	/* Trace/walk.scm 53 */
					obj_t BgL_g1109z00_1595;

					BgL_g1109z00_1595 = BNIL;
					{
						obj_t BgL_hooksz00_1598;
						obj_t BgL_hnamesz00_1599;

						BgL_hooksz00_1598 = BgL_g1109z00_1595;
						BgL_hnamesz00_1599 = BNIL;
					BgL_zc3z04anonymousza31547ze3z87_1600:
						if (NULLP(BgL_hooksz00_1598))
							{	/* Trace/walk.scm 53 */
								return BgL_globalsz00_17;
							}
						else
							{	/* Trace/walk.scm 53 */
								bool_t BgL_test2224z00_3034;

								{	/* Trace/walk.scm 53 */
									obj_t BgL_fun1558z00_1607;

									BgL_fun1558z00_1607 = CAR(((obj_t) BgL_hooksz00_1598));
									BgL_test2224z00_3034 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1558z00_1607)
										(BgL_fun1558z00_1607, BEOA));
								}
								if (BgL_test2224z00_3034)
									{	/* Trace/walk.scm 53 */
										obj_t BgL_arg1551z00_1604;
										obj_t BgL_arg1555z00_1605;

										BgL_arg1551z00_1604 = CDR(((obj_t) BgL_hooksz00_1598));
										BgL_arg1555z00_1605 = CDR(((obj_t) BgL_hnamesz00_1599));
										{
											obj_t BgL_hnamesz00_3046;
											obj_t BgL_hooksz00_3045;

											BgL_hooksz00_3045 = BgL_arg1551z00_1604;
											BgL_hnamesz00_3046 = BgL_arg1555z00_1605;
											BgL_hnamesz00_1599 = BgL_hnamesz00_3046;
											BgL_hooksz00_1598 = BgL_hooksz00_3045;
											goto BgL_zc3z04anonymousza31547ze3z87_1600;
										}
									}
								else
									{	/* Trace/walk.scm 53 */
										obj_t BgL_arg1557z00_1606;

										BgL_arg1557z00_1606 = CAR(((obj_t) BgL_hnamesz00_1599));
										return
											BGl_internalzd2errorzd2zztools_errorz00
											(BGl_za2currentzd2passza2zd2zzengine_passz00,
											BGl_string2102z00zztrace_walkz00, BgL_arg1557z00_1606);
									}
							}
					}
				}
		}

	}



/* &trace-walk! */
	obj_t BGl_z62tracezd2walkz12za2zztrace_walkz00(obj_t BgL_envz00_2644,
		obj_t BgL_globalsz00_2645)
	{
		{	/* Trace/walk.scm 39 */
			return BGl_tracezd2walkz12zc0zztrace_walkz00(BgL_globalsz00_2645);
		}

	}



/* trace-id */
	obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t BgL_vz00_18)
	{
		{	/* Trace/walk.scm 64 */
			{	/* Trace/walk.scm 66 */
				bool_t BgL_test2225z00_3051;

				if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18, BGl_globalz00zzast_varz00))
					{	/* Trace/walk.scm 66 */
						BgL_test2225z00_3051 =
							(
							(((BgL_variablez00_bglt) COBJECT(
										((BgL_variablez00_bglt)
											((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00) ==
							CNST_TABLE_REF(((long) 1)));
					}
				else
					{	/* Trace/walk.scm 66 */
						BgL_test2225z00_3051 = ((bool_t) 0);
					}
				if (BgL_test2225z00_3051)
					{	/* Trace/walk.scm 67 */
						obj_t BgL_arg1563z00_1613;

						{	/* Trace/walk.scm 67 */
							obj_t BgL_arg1568z00_1614;
							obj_t BgL_arg1569z00_1615;

							{	/* Trace/walk.scm 67 */
								obj_t BgL_arg1571z00_1616;

								BgL_arg1571z00_1616 =
									bstring_to_symbol(BGl_string2103z00zztrace_walkz00);
								{	/* Trace/walk.scm 67 */
									obj_t BgL_arg1447z00_2407;

									BgL_arg1447z00_2407 = SYMBOL_TO_STRING(BgL_arg1571z00_1616);
									BgL_arg1568z00_1614 =
										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
										(BgL_arg1447z00_2407);
								}
							}
							{	/* Trace/walk.scm 67 */
								obj_t BgL_arg1573z00_1617;

								BgL_arg1573z00_1617 =
									(((BgL_globalz00_bglt) COBJECT(
											((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
								{	/* Trace/walk.scm 67 */
									obj_t BgL_arg1447z00_2410;

									BgL_arg1447z00_2410 = SYMBOL_TO_STRING(BgL_arg1573z00_1617);
									BgL_arg1569z00_1615 =
										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
										(BgL_arg1447z00_2410);
								}
							}
							BgL_arg1563z00_1613 =
								string_append(BgL_arg1568z00_1614, BgL_arg1569z00_1615);
						}
						return bstring_to_symbol(BgL_arg1563z00_1613);
					}
				else
					{	/* Trace/walk.scm 68 */
						bool_t BgL_test2227z00_3068;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 68 */
								BgL_test2227z00_3068 =
									(
									(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00) ==
									CNST_TABLE_REF(((long) 2)));
							}
						else
							{	/* Trace/walk.scm 68 */
								BgL_test2227z00_3068 = ((bool_t) 0);
							}
						if (BgL_test2227z00_3068)
							{	/* Trace/walk.scm 69 */
								obj_t BgL_arg1582z00_1621;

								{	/* Trace/walk.scm 69 */
									obj_t BgL_arg1583z00_1622;
									obj_t BgL_arg1584z00_1623;

									{	/* Trace/walk.scm 69 */
										obj_t BgL_arg1585z00_1624;

										BgL_arg1585z00_1624 =
											bstring_to_symbol(BGl_string2104z00zztrace_walkz00);
										{	/* Trace/walk.scm 69 */
											obj_t BgL_arg1447z00_2415;

											BgL_arg1447z00_2415 =
												SYMBOL_TO_STRING(BgL_arg1585z00_1624);
											BgL_arg1583z00_1622 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1447z00_2415);
										}
									}
									{	/* Trace/walk.scm 69 */
										obj_t BgL_arg1597z00_1625;

										BgL_arg1597z00_1625 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
										{	/* Trace/walk.scm 69 */
											obj_t BgL_arg1447z00_2418;

											BgL_arg1447z00_2418 =
												SYMBOL_TO_STRING(BgL_arg1597z00_1625);
											BgL_arg1584z00_1623 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1447z00_2418);
										}
									}
									BgL_arg1582z00_1621 =
										string_append(BgL_arg1583z00_1622, BgL_arg1584z00_1623);
								}
								return bstring_to_symbol(BgL_arg1582z00_1621);
							}
						else
							{	/* Trace/walk.scm 68 */
								if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18,
										BGl_globalz00zzast_varz00))
									{	/* Trace/walk.scm 71 */
										obj_t BgL_arg1599z00_1627;
										obj_t BgL_arg1600z00_1628;

										BgL_arg1599z00_1627 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt)
														((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00);
										BgL_arg1600z00_1628 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
										{	/* Trace/walk.scm 71 */
											obj_t BgL_list1601z00_1629;

											{	/* Trace/walk.scm 71 */
												obj_t BgL_arg1603z00_1630;

												{	/* Trace/walk.scm 71 */
													obj_t BgL_arg1604z00_1631;

													BgL_arg1604z00_1631 =
														MAKE_YOUNG_PAIR(BgL_arg1600z00_1628, BNIL);
													BgL_arg1603z00_1630 =
														MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
														BgL_arg1604z00_1631);
												}
												BgL_list1601z00_1629 =
													MAKE_YOUNG_PAIR(BgL_arg1599z00_1627,
													BgL_arg1603z00_1630);
											}
											return
												BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
												(BgL_list1601z00_1629);
										}
									}
								else
									{	/* Trace/walk.scm 70 */
										return
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_vz00_18)))->BgL_idz00);
									}
							}
					}
			}
		}

	}



/* trace-fun! */
	obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t BgL_varz00_19,
		obj_t BgL_stackz00_20, obj_t BgL_levelz00_21)
	{
		{	/* Trace/walk.scm 81 */
			{	/* Trace/walk.scm 82 */
				BgL_valuez00_bglt BgL_funz00_1636;

				BgL_funz00_1636 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_varz00_19)))->BgL_valuez00);
				{	/* Trace/walk.scm 82 */
					obj_t BgL_bodyz00_1637;

					BgL_bodyz00_1637 =
						(((BgL_sfunz00_bglt) COBJECT(
								((BgL_sfunz00_bglt) BgL_funz00_1636)))->BgL_bodyz00);
					{	/* Trace/walk.scm 83 */
						obj_t BgL_llocz00_1638;

						if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 85 */
								obj_t BgL_arg1699z00_1685;

								BgL_arg1699z00_1685 =
									BGl_findzd2lastzd2sexpz00zztrace_walkz00(
									(((BgL_globalz00_bglt) COBJECT(
												((BgL_globalz00_bglt) BgL_varz00_19)))->BgL_srcz00));
								BgL_llocz00_1638 =
									BGl_findzd2locationzd2zztools_locationz00
									(BgL_arg1699z00_1685);
							}
						else
							{	/* Trace/walk.scm 86 */
								obj_t BgL_arg1704z00_1687;

								BgL_arg1704z00_1687 =
									BGl_findzd2lastzd2nodez00zztrace_walkz00(
									((BgL_nodez00_bglt) BgL_bodyz00_1637));
								BgL_llocz00_1638 =
									(((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_arg1704z00_1687)))->BgL_locz00);
							}
						{	/* Trace/walk.scm 84 */

							{	/* Trace/walk.scm 87 */
								bool_t BgL_test2231z00_3113;

								if (CBOOL(
										(((BgL_funz00_bglt) COBJECT(
													((BgL_funz00_bglt) BgL_funz00_1636)))->
											BgL_predicatezd2ofzd2)))
									{	/* Trace/walk.scm 87 */
										BgL_test2231z00_3113 = ((bool_t) 0);
									}
								else
									{	/* Trace/walk.scm 87 */
										if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(CNST_TABLE_REF(((long) 4)),
													(((BgL_sfunz00_bglt) COBJECT(((BgL_sfunz00_bglt)
																	BgL_funz00_1636)))->BgL_propertyz00))))
											{	/* Trace/walk.scm 88 */
												BgL_test2231z00_3113 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 89 */
												obj_t BgL_arg1695z00_1682;

												BgL_arg1695z00_1682 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_varz00_19)))->
													BgL_idz00);
												BgL_test2231z00_3113 =
													BGl_userzd2symbolzf3z21zzast_identz00
													(BgL_arg1695z00_1682);
											}
									}
								if (BgL_test2231z00_3113)
									{	/* Trace/walk.scm 87 */
										BGl_enterzd2functionzd2zztools_errorz00
											(BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_19));
										{	/* Trace/walk.scm 91 */
											obj_t BgL_bdz00_1646;

											{	/* Trace/walk.scm 91 */
												bool_t BgL_test2234z00_3129;

												if (((long) CINT(BgL_levelz00_21) > ((long) 1)))
													{	/* Trace/walk.scm 91 */
														BgL_test2234z00_3129 = ((bool_t) 1);
													}
												else
													{	/* Trace/walk.scm 91 */
														if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
																BGl_globalz00zzast_varz00))
															{	/* Trace/walk.scm 93 */
																bool_t BgL__ortest_1112z00_1675;

																BgL__ortest_1112z00_1675 =
																	(
																	(((BgL_variablez00_bglt) COBJECT(
																				((BgL_variablez00_bglt)
																					((BgL_globalz00_bglt)
																						BgL_varz00_19))))->BgL_idz00) ==
																	CNST_TABLE_REF(((long) 1)));
																if (BgL__ortest_1112z00_1675)
																	{	/* Trace/walk.scm 93 */
																		BgL_test2234z00_3129 =
																			BgL__ortest_1112z00_1675;
																	}
																else
																	{	/* Trace/walk.scm 94 */
																		bool_t BgL__ortest_1113z00_1676;

																		BgL__ortest_1113z00_1676 =
																			(
																			(((BgL_variablez00_bglt) COBJECT(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_varz00_19))))->BgL_idz00) ==
																			CNST_TABLE_REF(((long) 5)));
																		if (BgL__ortest_1113z00_1676)
																			{	/* Trace/walk.scm 94 */
																				BgL_test2234z00_3129 =
																					BgL__ortest_1113z00_1676;
																			}
																		else
																			{	/* Trace/walk.scm 94 */
																				BgL_test2234z00_3129 =
																					(
																					(((BgL_variablez00_bglt) COBJECT(
																								((BgL_variablez00_bglt)
																									((BgL_globalz00_bglt)
																										BgL_varz00_19))))->
																						BgL_idz00) ==
																					CNST_TABLE_REF(((long) 6)));
															}}}
														else
															{	/* Trace/walk.scm 92 */
																BgL_test2234z00_3129 = ((bool_t) 0);
															}
													}
												if (BgL_test2234z00_3129)
													{	/* Trace/walk.scm 103 */
														bool_t BgL_test2239z00_3152;

														if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
																BGl_localz00zzast_varz00))
															{	/* Trace/walk.scm 103 */
																BgL_test2239z00_3152 = ((bool_t) 1);
															}
														else
															{	/* Trace/walk.scm 103 */
																if (
																	((((BgL_variablez00_bglt) COBJECT(
																					((BgL_variablez00_bglt)
																						((BgL_globalz00_bglt)
																							BgL_varz00_19))))->BgL_idz00) ==
																		CNST_TABLE_REF(((long) 5))))
																	{	/* Trace/walk.scm 104 */
																		BgL_test2239z00_3152 = ((bool_t) 1);
																	}
																else
																	{	/* Trace/walk.scm 104 */
																		BgL_test2239z00_3152 =
																			(
																			(((BgL_variablez00_bglt) COBJECT(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_varz00_19))))->BgL_idz00) ==
																			CNST_TABLE_REF(((long) 6)));
															}}
														if (BgL_test2239z00_3152)
															{	/* Trace/walk.scm 106 */
																long BgL_arg1675z00_1666;

																BgL_arg1675z00_1666 =
																	((long) CINT(BgL_levelz00_21) - ((long) 1));
																BgL_bdz00_1646 =
																	((obj_t)
																	BGl_tracezd2nodezd2zztrace_walkz00(
																		((BgL_nodez00_bglt) BgL_bodyz00_1637),
																		BgL_stackz00_20,
																		BINT(BgL_arg1675z00_1666)));
															}
														else
															{	/* Trace/walk.scm 107 */
																obj_t BgL_arg1676z00_1667;
																long BgL_arg1679z00_1668;

																BgL_arg1676z00_1667 =
																	MAKE_YOUNG_PAIR(BgL_varz00_19,
																	BgL_stackz00_20);
																BgL_arg1679z00_1668 =
																	((long) CINT(BgL_levelz00_21) - ((long) 1));
																BgL_bdz00_1646 =
																	((obj_t)
																	BGl_tracezd2nodezd2zztrace_walkz00((
																			(BgL_nodez00_bglt) BgL_bodyz00_1637),
																		BgL_arg1676z00_1667,
																		BINT(BgL_arg1679z00_1668)));
													}}
												else
													{	/* Trace/walk.scm 91 */
														BgL_bdz00_1646 = BgL_bodyz00_1637;
													}
											}
											{	/* Trace/walk.scm 91 */
												BgL_typez00_bglt BgL_tz00_1647;

												{	/* Trace/walk.scm 109 */
													BgL_typez00_bglt BgL_arg1643z00_1650;
													BgL_typez00_bglt BgL_arg1645z00_1651;

													BgL_arg1643z00_1650 =
														(((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt) BgL_bodyz00_1637)))->
														BgL_typez00);
													BgL_arg1645z00_1651 =
														(((BgL_variablez00_bglt)
															COBJECT(((BgL_variablez00_bglt) BgL_varz00_19)))->
														BgL_typez00);
													BgL_tz00_1647 =
														BGl_strictzd2nodezd2typez00zzast_nodez00
														(BgL_arg1643z00_1650, BgL_arg1645z00_1651);
												}
												{	/* Trace/walk.scm 109 */
													obj_t BgL_idz00_1648;

													BgL_idz00_1648 =
														BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_19);
													{	/* Trace/walk.scm 110 */
														BgL_letzd2varzd2_bglt BgL_nbodyz00_1649;

														BgL_nbodyz00_1649 =
															BGl_makezd2tracedzd2nodez00zztrace_walkz00(
															((BgL_nodez00_bglt) BgL_bdz00_1646),
															BgL_tz00_1647, BgL_idz00_1648, BgL_llocz00_1638,
															BgL_stackz00_20);
														{	/* Trace/walk.scm 111 */

															((((BgL_sfunz00_bglt) COBJECT(
																			((BgL_sfunz00_bglt) BgL_funz00_1636)))->
																	BgL_bodyz00) =
																((obj_t) ((obj_t) BgL_nbodyz00_1649)), BUNSPEC);
															return BGl_leavezd2functionzd2zztools_errorz00();
														}
													}
												}
											}
										}
									}
								else
									{	/* Trace/walk.scm 87 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}

	}



/* find-last-sexp */
	obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t BgL_sexpz00_22)
	{
		{	/* Trace/walk.scm 122 */
			{
				obj_t BgL_sexpz00_1689;
				obj_t BgL_resz00_1690;

				BgL_sexpz00_1689 = BgL_sexpz00_22;
				BgL_resz00_1690 = BgL_sexpz00_22;
			BgL_zc3z04anonymousza31705ze3z87_1691:
				if (PAIRP(BgL_sexpz00_1689))
					{	/* Trace/walk.scm 128 */
						bool_t BgL_test2243z00_3193;

						{	/* Trace/walk.scm 128 */
							obj_t BgL_tmpz00_3194;

							BgL_tmpz00_3194 = CDR(BgL_sexpz00_1689);
							BgL_test2243z00_3193 = PAIRP(BgL_tmpz00_3194);
						}
						if (BgL_test2243z00_3193)
							{
								obj_t BgL_resz00_3199;
								obj_t BgL_sexpz00_3197;

								BgL_sexpz00_3197 =
									BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00
									(BgL_sexpz00_1689);
								BgL_resz00_3199 = BgL_sexpz00_1689;
								BgL_resz00_1690 = BgL_resz00_3199;
								BgL_sexpz00_1689 = BgL_sexpz00_3197;
								goto BgL_zc3z04anonymousza31705ze3z87_1691;
							}
						else
							{
								obj_t BgL_resz00_3202;
								obj_t BgL_sexpz00_3200;

								BgL_sexpz00_3200 = CAR(BgL_sexpz00_1689);
								BgL_resz00_3202 = BgL_sexpz00_1689;
								BgL_resz00_1690 = BgL_resz00_3202;
								BgL_sexpz00_1689 = BgL_sexpz00_3200;
								goto BgL_zc3z04anonymousza31705ze3z87_1691;
							}
					}
				else
					{	/* Trace/walk.scm 126 */
						return BgL_resz00_1690;
					}
			}
		}

	}



/* make-traced-node */
	BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt BgL_nodez00_38,
		BgL_typez00_bglt BgL_typez00_39, obj_t BgL_symbolz00_40,
		obj_t BgL_llocz00_41, obj_t BgL_stackz00_42)
	{
		{	/* Trace/walk.scm 245 */
			{	/* Trace/walk.scm 252 */
				obj_t BgL_locz00_1700;

				BgL_locz00_1700 =
					(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_38))->BgL_locz00);
				{	/* Trace/walk.scm 252 */
					obj_t BgL_auxz00_1701;

					BgL_auxz00_1701 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 7))));
					{	/* Trace/walk.scm 253 */
						obj_t BgL_tauxz00_1702;

						BgL_tauxz00_1702 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_auxz00_1701,
							(((BgL_typez00_bglt) COBJECT(BgL_typez00_39))->BgL_idz00));
						{	/* Trace/walk.scm 254 */
							obj_t BgL_tmp1z00_1703;

							BgL_tmp1z00_1703 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											8))));
							{	/* Trace/walk.scm 255 */
								obj_t BgL_tmp2z00_1704;

								BgL_tmp2z00_1704 =
									BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
									(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												9))));
								{	/* Trace/walk.scm 256 */
									obj_t BgL_tmp3z00_1705;

									BgL_tmp3z00_1705 =
										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
										(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
													10))));
									{	/* Trace/walk.scm 257 */
										obj_t BgL_symz00_1706;

										{	/* Trace/walk.scm 258 */
											bool_t BgL_test2244z00_3218;

											if (PAIRP(BgL_stackz00_42))
												{	/* Trace/walk.scm 258 */
													obj_t BgL_arg1823z00_1757;

													BgL_arg1823z00_1757 = CAR(BgL_stackz00_42);
													BgL_test2244z00_3218 =
														BGl_isazf3zf3zz__objectz00(BgL_arg1823z00_1757,
														BGl_variablez00zzast_varz00);
												}
											else
												{	/* Trace/walk.scm 258 */
													BgL_test2244z00_3218 = ((bool_t) 0);
												}
											if (BgL_test2244z00_3218)
												{	/* Trace/walk.scm 258 */
													BgL_symz00_1706 =
														BGl_fqnameze70ze7zztrace_walkz00(BgL_symbolz00_40,
														BgL_stackz00_42);
												}
											else
												{	/* Trace/walk.scm 258 */
													BgL_symz00_1706 = BgL_symbolz00_40;
												}
										}
										{	/* Trace/walk.scm 258 */
											obj_t BgL_lz00_1707;

											{	/* Trace/walk.scm 262 */
												bool_t BgL_test2246z00_3224;

												if (STRUCTP(BgL_locz00_1700))
													{	/* Trace/walk.scm 262 */
														BgL_test2246z00_3224 =
															(STRUCT_KEY(BgL_locz00_1700) ==
															CNST_TABLE_REF(((long) 11)));
													}
												else
													{	/* Trace/walk.scm 262 */
														BgL_test2246z00_3224 = ((bool_t) 0);
													}
												if (BgL_test2246z00_3224)
													{	/* Trace/walk.scm 263 */
														obj_t BgL_arg1815z00_1749;

														{	/* Trace/walk.scm 263 */
															obj_t BgL_arg1816z00_1750;
															obj_t BgL_arg1817z00_1751;

															BgL_arg1816z00_1750 =
																BGl_locationzd2fullzd2fnamez00zztools_locationz00
																(BgL_locz00_1700);
															BgL_arg1817z00_1751 =
																MAKE_YOUNG_PAIR(STRUCT_REF(BgL_locz00_1700,
																	(int) (((long) 1))), BNIL);
															BgL_arg1815z00_1749 =
																MAKE_YOUNG_PAIR(BgL_arg1816z00_1750,
																BgL_arg1817z00_1751);
														}
														BgL_lz00_1707 =
															MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
															BgL_arg1815z00_1749);
													}
												else
													{	/* Trace/walk.scm 262 */
														BgL_lz00_1707 = BFALSE;
													}
											}
											{	/* Trace/walk.scm 262 */
												obj_t BgL_expz00_1708;

												{	/* Trace/walk.scm 264 */
													obj_t BgL_arg1722z00_1712;

													{	/* Trace/walk.scm 264 */
														obj_t BgL_arg1724z00_1713;
														obj_t BgL_arg1725z00_1714;

														{	/* Trace/walk.scm 264 */
															obj_t BgL_arg1732z00_1715;
															obj_t BgL_arg1733z00_1716;

															{	/* Trace/walk.scm 264 */
																obj_t BgL_arg1734z00_1717;

																{	/* Trace/walk.scm 264 */
																	obj_t BgL_arg1735z00_1718;

																	{	/* Trace/walk.scm 264 */
																		obj_t BgL_arg1736z00_1719;

																		BgL_arg1736z00_1719 =
																			MAKE_YOUNG_PAIR(BgL_symz00_1706, BNIL);
																		BgL_arg1735z00_1718 =
																			MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																					13)), BgL_arg1736z00_1719);
																	}
																	BgL_arg1734z00_1717 =
																		MAKE_YOUNG_PAIR(BgL_arg1735z00_1718, BNIL);
																}
																BgL_arg1732z00_1715 =
																	MAKE_YOUNG_PAIR(BgL_tmp1z00_1703,
																	BgL_arg1734z00_1717);
															}
															{	/* Trace/walk.scm 265 */
																obj_t BgL_arg1737z00_1720;
																obj_t BgL_arg1739z00_1721;

																{	/* Trace/walk.scm 265 */
																	obj_t BgL_arg1740z00_1722;

																	{	/* Trace/walk.scm 265 */
																		obj_t BgL_arg1741z00_1723;

																		{	/* Trace/walk.scm 265 */
																			obj_t BgL_arg1744z00_1724;

																			BgL_arg1744z00_1724 =
																				MAKE_YOUNG_PAIR(BgL_lz00_1707, BNIL);
																			BgL_arg1741z00_1723 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						13)), BgL_arg1744z00_1724);
																		}
																		BgL_arg1740z00_1722 =
																			MAKE_YOUNG_PAIR(BgL_arg1741z00_1723,
																			BNIL);
																	}
																	BgL_arg1737z00_1720 =
																		MAKE_YOUNG_PAIR(BgL_tmp2z00_1704,
																		BgL_arg1740z00_1722);
																}
																{	/* Trace/walk.scm 266 */
																	obj_t BgL_arg1746z00_1725;

																	{	/* Trace/walk.scm 266 */
																		obj_t BgL_arg1747z00_1726;
																		obj_t BgL_arg1751z00_1727;

																		BgL_arg1747z00_1726 =
																			BGl_makezd2typedzd2identz00zzast_identz00
																			(BgL_tmp3z00_1705,
																			CNST_TABLE_REF(((long) 14)));
																		{	/* Trace/walk.scm 266 */
																			obj_t BgL_arg1753z00_1728;

																			BgL_arg1753z00_1728 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						15)), BNIL);
																			BgL_arg1751z00_1727 =
																				MAKE_YOUNG_PAIR(BgL_arg1753z00_1728,
																				BNIL);
																		}
																		BgL_arg1746z00_1725 =
																			MAKE_YOUNG_PAIR(BgL_arg1747z00_1726,
																			BgL_arg1751z00_1727);
																	}
																	BgL_arg1739z00_1721 =
																		MAKE_YOUNG_PAIR(BgL_arg1746z00_1725, BNIL);
																}
																BgL_arg1733z00_1716 =
																	MAKE_YOUNG_PAIR(BgL_arg1737z00_1720,
																	BgL_arg1739z00_1721);
															}
															BgL_arg1724z00_1713 =
																MAKE_YOUNG_PAIR(BgL_arg1732z00_1715,
																BgL_arg1733z00_1716);
														}
														{	/* Trace/walk.scm 268 */
															obj_t BgL_arg1755z00_1729;

															{	/* Trace/walk.scm 268 */
																obj_t BgL_arg1759z00_1730;

																{	/* Trace/walk.scm 268 */
																	obj_t BgL_arg1760z00_1731;

																	{	/* Trace/walk.scm 268 */
																		obj_t BgL_arg1764z00_1732;
																		obj_t BgL_arg1774z00_1733;

																		{	/* Trace/walk.scm 268 */
																			obj_t BgL_arg1786z00_1734;

																			{	/* Trace/walk.scm 268 */
																				obj_t BgL_arg1787z00_1735;

																				{	/* Trace/walk.scm 268 */
																					obj_t BgL_arg1789z00_1736;

																					BgL_arg1789z00_1736 =
																						MAKE_YOUNG_PAIR(BgL_tmp2z00_1704,
																						BNIL);
																					BgL_arg1787z00_1735 =
																						MAKE_YOUNG_PAIR(BgL_tmp1z00_1703,
																						BgL_arg1789z00_1736);
																				}
																				BgL_arg1786z00_1734 =
																					MAKE_YOUNG_PAIR(BgL_tmp3z00_1705,
																					BgL_arg1787z00_1735);
																			}
																			BgL_arg1764z00_1732 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						16)), BgL_arg1786z00_1734);
																		}
																		{	/* Trace/walk.scm 269 */
																			obj_t BgL_arg1798z00_1737;

																			{	/* Trace/walk.scm 269 */
																				obj_t BgL_arg1799z00_1738;

																				{	/* Trace/walk.scm 269 */
																					obj_t BgL_arg1801z00_1739;
																					obj_t BgL_arg1802z00_1740;

																					{	/* Trace/walk.scm 269 */
																						obj_t BgL_arg1804z00_1741;

																						{	/* Trace/walk.scm 269 */
																							obj_t BgL_arg1806z00_1742;

																							BgL_arg1806z00_1742 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_nodez00_38), BNIL);
																							BgL_arg1804z00_1741 =
																								MAKE_YOUNG_PAIR
																								(BgL_tauxz00_1702,
																								BgL_arg1806z00_1742);
																						}
																						BgL_arg1801z00_1739 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1804z00_1741, BNIL);
																					}
																					{	/* Trace/walk.scm 270 */
																						obj_t BgL_arg1808z00_1743;
																						obj_t BgL_arg1809z00_1744;

																						{	/* Trace/walk.scm 270 */
																							bool_t BgL_test2248z00_3265;

																							if (STRUCTP(BgL_llocz00_41))
																								{	/* Trace/walk.scm 270 */
																									BgL_test2248z00_3265 =
																										(STRUCT_KEY(BgL_llocz00_41)
																										==
																										CNST_TABLE_REF(((long)
																												11)));
																								}
																							else
																								{	/* Trace/walk.scm 270 */
																									BgL_test2248z00_3265 =
																										((bool_t) 0);
																								}
																							if (BgL_test2248z00_3265)
																								{	/* Trace/walk.scm 272 */
																									obj_t BgL_arg1811z00_1746;

																									{	/* Trace/walk.scm 272 */
																										obj_t BgL_res2078z00_2457;

																										BgL_res2078z00_2457 =
																											MAKE_YOUNG_EPAIR
																											(BgL_tmp3z00_1705, BNIL,
																											BgL_llocz00_41);
																										BgL_arg1811z00_1746 =
																											BgL_res2078z00_2457;
																									}
																									{	/* Trace/walk.scm 271 */
																										obj_t BgL_res2079z00_2459;

																										{	/* Trace/walk.scm 271 */
																											obj_t BgL_obj1z00_2458;

																											BgL_obj1z00_2458 =
																												CNST_TABLE_REF(((long)
																													17));
																											BgL_res2079z00_2459 =
																												MAKE_YOUNG_EPAIR
																												(BgL_obj1z00_2458,
																												BgL_arg1811z00_1746,
																												BgL_llocz00_41);
																										}
																										BgL_arg1808z00_1743 =
																											BgL_res2079z00_2459;
																								}}
																							else
																								{	/* Trace/walk.scm 274 */
																									obj_t BgL_arg1812z00_1747;

																									BgL_arg1812z00_1747 =
																										MAKE_YOUNG_PAIR
																										(BgL_tmp3z00_1705, BNIL);
																									BgL_arg1808z00_1743 =
																										MAKE_YOUNG_PAIR
																										(CNST_TABLE_REF(((long)
																												17)),
																										BgL_arg1812z00_1747);
																						}}
																						BgL_arg1809z00_1744 =
																							MAKE_YOUNG_PAIR(BgL_auxz00_1701,
																							BNIL);
																						BgL_arg1802z00_1740 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1808z00_1743,
																							BgL_arg1809z00_1744);
																					}
																					BgL_arg1799z00_1738 =
																						MAKE_YOUNG_PAIR(BgL_arg1801z00_1739,
																						BgL_arg1802z00_1740);
																				}
																				BgL_arg1798z00_1737 =
																					MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																							18)), BgL_arg1799z00_1738);
																			}
																			BgL_arg1774z00_1733 =
																				MAKE_YOUNG_PAIR(BgL_arg1798z00_1737,
																				BNIL);
																		}
																		BgL_arg1760z00_1731 =
																			MAKE_YOUNG_PAIR(BgL_arg1764z00_1732,
																			BgL_arg1774z00_1733);
																	}
																	BgL_arg1759z00_1730 =
																		MAKE_YOUNG_PAIR(BNIL, BgL_arg1760z00_1731);
																}
																BgL_arg1755z00_1729 =
																	MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 18)),
																	BgL_arg1759z00_1730);
															}
															BgL_arg1725z00_1714 =
																MAKE_YOUNG_PAIR(BgL_arg1755z00_1729, BNIL);
														}
														BgL_arg1722z00_1712 =
															MAKE_YOUNG_PAIR(BgL_arg1724z00_1713,
															BgL_arg1725z00_1714);
													}
													BgL_expz00_1708 =
														MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 18)),
														BgL_arg1722z00_1712);
												}
												{	/* Trace/walk.scm 264 */
													BgL_nodez00_bglt BgL_nnodez00_1709;

													BgL_nnodez00_1709 =
														BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_1708,
														BNIL, BgL_locz00_1700, CNST_TABLE_REF(((long) 19)));
													{	/* Trace/walk.scm 276 */

														{	/* Trace/walk.scm 277 */
															bool_t BgL_arg1720z00_1710;

															{	/* Trace/walk.scm 277 */
																obj_t BgL_arg1721z00_1711;

																BgL_arg1721z00_1711 =
																	BGl_thezd2backendzd2zzbackend_backendz00();
																BgL_arg1720z00_1710 =
																	(((BgL_backendz00_bglt) COBJECT(
																			((BgL_backendz00_bglt)
																				BgL_arg1721z00_1711)))->
																	BgL_removezd2emptyzd2letz00);
															}
															((((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				BgL_nnodez00_1709)))->
																	BgL_removablezf3zf3) =
																((bool_t) BgL_arg1720z00_1710), BUNSPEC);
														}
														return ((BgL_letzd2varzd2_bglt) BgL_nnodez00_1709);
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* fqname~0 */
	obj_t BGl_fqnameze70ze7zztrace_walkz00(obj_t BgL_symz00_1763,
		obj_t BgL_stackz00_1764)
	{
		{	/* Trace/walk.scm 250 */
			if (NULLP(BgL_stackz00_1764))
				{	/* Trace/walk.scm 248 */
					return BgL_symz00_1763;
				}
			else
				{	/* Trace/walk.scm 250 */
					obj_t BgL_arg1831z00_1767;

					{	/* Trace/walk.scm 250 */
						obj_t BgL_arg1835z00_1771;
						obj_t BgL_arg1837z00_1772;

						{	/* Trace/walk.scm 250 */
							obj_t BgL_arg1838z00_1773;

							BgL_arg1838z00_1773 = CAR(((obj_t) BgL_stackz00_1764));
							BgL_arg1835z00_1771 =
								BGl_tracezd2idzd2zztrace_walkz00(BgL_arg1838z00_1773);
						}
						BgL_arg1837z00_1772 = CDR(((obj_t) BgL_stackz00_1764));
						BgL_arg1831z00_1767 =
							BGl_fqnameze70ze7zztrace_walkz00(BgL_arg1835z00_1771,
							BgL_arg1837z00_1772);
					}
					{	/* Trace/walk.scm 250 */
						obj_t BgL_list1832z00_1768;

						{	/* Trace/walk.scm 250 */
							obj_t BgL_arg1833z00_1769;

							{	/* Trace/walk.scm 250 */
								obj_t BgL_arg1834z00_1770;

								BgL_arg1834z00_1770 =
									MAKE_YOUNG_PAIR(BgL_arg1831z00_1767, BNIL);
								BgL_arg1833z00_1769 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 20)),
									BgL_arg1834z00_1770);
							}
							BgL_list1832z00_1768 =
								MAKE_YOUNG_PAIR(BgL_symz00_1763, BgL_arg1833z00_1769);
						}
						return
							BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list1832z00_1768);
					}
				}
		}

	}



/* trace-node*! */
	bool_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t BgL_nodeza2za2_100,
		obj_t BgL_stackz00_101, obj_t BgL_levelz00_102)
	{
		{	/* Trace/walk.scm 449 */
		BGl_tracezd2nodeza2z12z62zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_100))
				{	/* Trace/walk.scm 450 */
					return ((bool_t) 0);
				}
			else
				{	/* Trace/walk.scm 450 */
					{	/* Trace/walk.scm 451 */
						BgL_nodez00_bglt BgL_arg1841z00_1776;

						{	/* Trace/walk.scm 451 */
							obj_t BgL_arg1843z00_1777;

							BgL_arg1843z00_1777 = CAR(((obj_t) BgL_nodeza2za2_100));
							BgL_arg1841z00_1776 =
								BGl_tracezd2nodezd2zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1843z00_1777), BgL_stackz00_101,
								BgL_levelz00_102);
						}
						{	/* Trace/walk.scm 451 */
							obj_t BgL_auxz00_3320;
							obj_t BgL_tmpz00_3318;

							BgL_auxz00_3320 = ((obj_t) BgL_arg1841z00_1776);
							BgL_tmpz00_3318 = ((obj_t) BgL_nodeza2za2_100);
							SET_CAR(BgL_tmpz00_3318, BgL_auxz00_3320);
						}
					}
					{	/* Trace/walk.scm 452 */
						obj_t BgL_arg1845z00_1778;

						BgL_arg1845z00_1778 = CDR(((obj_t) BgL_nodeza2za2_100));
						{
							obj_t BgL_nodeza2za2_3325;

							BgL_nodeza2za2_3325 = BgL_arg1845z00_1778;
							BgL_nodeza2za2_100 = BgL_nodeza2za2_3325;
							goto BGl_tracezd2nodeza2z12z62zztrace_walkz00;
						}
					}
				}
		}

	}



/* toplevel-trace-node*! */
	bool_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t
		BgL_nodeza2za2_107)
	{
		{	/* Trace/walk.scm 500 */
		BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_107))
				{	/* Trace/walk.scm 501 */
					return ((bool_t) 0);
				}
			else
				{	/* Trace/walk.scm 501 */
					{	/* Trace/walk.scm 502 */
						BgL_nodez00_bglt BgL_arg1849z00_1780;

						{	/* Trace/walk.scm 502 */
							obj_t BgL_arg1850z00_1781;

							BgL_arg1850z00_1781 = CAR(((obj_t) BgL_nodeza2za2_107));
							BgL_arg1849z00_1780 =
								BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1850z00_1781));
						}
						{	/* Trace/walk.scm 502 */
							obj_t BgL_auxz00_3334;
							obj_t BgL_tmpz00_3332;

							BgL_auxz00_3334 = ((obj_t) BgL_arg1849z00_1780);
							BgL_tmpz00_3332 = ((obj_t) BgL_nodeza2za2_107);
							SET_CAR(BgL_tmpz00_3332, BgL_auxz00_3334);
						}
					}
					{	/* Trace/walk.scm 503 */
						obj_t BgL_arg1851z00_1782;

						BgL_arg1851z00_1782 = CDR(((obj_t) BgL_nodeza2za2_107));
						{
							obj_t BgL_nodeza2za2_3339;

							BgL_nodeza2za2_3339 = BgL_arg1851z00_1782;
							BgL_nodeza2za2_107 = BgL_nodeza2za2_3339;
							goto BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00;
						}
					}
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_proc2105z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2106z00zztrace_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_proc2107z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2108z00zztrace_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_proc2109z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2110z00zztrace_walkz00);
		}

	}



/* &toplevel-trace-node1381 */
	obj_t BGl_z62toplevelzd2tracezd2node1381z62zztrace_walkz00(obj_t
		BgL_envz00_2649, obj_t BgL_nodez00_2650)
	{
		{	/* Trace/walk.scm 457 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2650));
		}

	}



/* &trace-node1343 */
	obj_t BGl_z62tracezd2node1343zb0zztrace_walkz00(obj_t BgL_envz00_2651,
		obj_t BgL_nodez00_2652, obj_t BgL_stackz00_2653, obj_t BgL_levelz00_2654)
	{
		{	/* Trace/walk.scm 283 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2652));
		}

	}



/* &find-last-node1312 */
	obj_t BGl_z62findzd2lastzd2node1312z62zztrace_walkz00(obj_t BgL_envz00_2655,
		obj_t BgL_nodez00_2656)
	{
		{	/* Trace/walk.scm 139 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2656));
		}

	}



/* find-last-node */
	obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_23)
	{
		{	/* Trace/walk.scm 139 */
			{	/* Trace/walk.scm 139 */
				obj_t BgL_method1313z00_1797;

				{	/* Trace/walk.scm 139 */
					obj_t BgL_res2084z00_2500;

					{	/* Trace/walk.scm 139 */
						long BgL_objzd2classzd2numz00_2471;

						BgL_objzd2classzd2numz00_2471 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_23));
						{	/* Trace/walk.scm 139 */
							obj_t BgL_arg1791z00_2472;

							BgL_arg1791z00_2472 =
								PROCEDURE_REF(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 139 */
								int BgL_offsetz00_2475;

								BgL_offsetz00_2475 = (int) (BgL_objzd2classzd2numz00_2471);
								{	/* Trace/walk.scm 139 */
									long BgL_offsetz00_2476;

									BgL_offsetz00_2476 =
										((long) (BgL_offsetz00_2475) - OBJECT_TYPE);
									{	/* Trace/walk.scm 139 */
										long BgL_modz00_2477;

										BgL_modz00_2477 =
											(BgL_offsetz00_2476 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Trace/walk.scm 139 */
											long BgL_restz00_2479;

											BgL_restz00_2479 =
												(BgL_offsetz00_2476 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Trace/walk.scm 139 */

												{	/* Trace/walk.scm 139 */
													obj_t BgL_bucketz00_2481;

													BgL_bucketz00_2481 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2472), BgL_modz00_2477);
													BgL_res2084z00_2500 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2481), BgL_restz00_2479);
					}}}}}}}}
					BgL_method1313z00_1797 = BgL_res2084z00_2500;
				}
				return
					PROCEDURE_ENTRY(BgL_method1313z00_1797) (BgL_method1313z00_1797,
					((obj_t) BgL_nodez00_23), BEOA);
			}
		}

	}



/* &find-last-node */
	obj_t BGl_z62findzd2lastzd2nodez62zztrace_walkz00(obj_t BgL_envz00_2657,
		obj_t BgL_nodez00_2658)
	{
		{	/* Trace/walk.scm 139 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2658));
		}

	}



/* trace-node */
	BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_43, obj_t BgL_stackz00_44, obj_t BgL_levelz00_45)
	{
		{	/* Trace/walk.scm 283 */
			{	/* Trace/walk.scm 283 */
				obj_t BgL_method1344z00_1798;

				{	/* Trace/walk.scm 283 */
					obj_t BgL_res2089z00_2531;

					{	/* Trace/walk.scm 283 */
						long BgL_objzd2classzd2numz00_2502;

						BgL_objzd2classzd2numz00_2502 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_43));
						{	/* Trace/walk.scm 283 */
							obj_t BgL_arg1791z00_2503;

							BgL_arg1791z00_2503 =
								PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 283 */
								int BgL_offsetz00_2506;

								BgL_offsetz00_2506 = (int) (BgL_objzd2classzd2numz00_2502);
								{	/* Trace/walk.scm 283 */
									long BgL_offsetz00_2507;

									BgL_offsetz00_2507 =
										((long) (BgL_offsetz00_2506) - OBJECT_TYPE);
									{	/* Trace/walk.scm 283 */
										long BgL_modz00_2508;

										BgL_modz00_2508 =
											(BgL_offsetz00_2507 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Trace/walk.scm 283 */
											long BgL_restz00_2510;

											BgL_restz00_2510 =
												(BgL_offsetz00_2507 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Trace/walk.scm 283 */

												{	/* Trace/walk.scm 283 */
													obj_t BgL_bucketz00_2512;

													BgL_bucketz00_2512 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2503), BgL_modz00_2508);
													BgL_res2089z00_2531 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2512), BgL_restz00_2510);
					}}}}}}}}
					BgL_method1344z00_1798 = BgL_res2089z00_2531;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1344z00_1798) (BgL_method1344z00_1798,
						((obj_t) BgL_nodez00_43), BgL_stackz00_44, BgL_levelz00_45, BEOA));
			}
		}

	}



/* &trace-node */
	BgL_nodez00_bglt BGl_z62tracezd2nodezb0zztrace_walkz00(obj_t BgL_envz00_2659,
		obj_t BgL_nodez00_2660, obj_t BgL_stackz00_2661, obj_t BgL_levelz00_2662)
	{
		{	/* Trace/walk.scm 283 */
			return
				BGl_tracezd2nodezd2zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2660), BgL_stackz00_2661,
				BgL_levelz00_2662);
		}

	}



/* toplevel-trace-node */
	BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_103)
	{
		{	/* Trace/walk.scm 457 */
			{	/* Trace/walk.scm 457 */
				obj_t BgL_method1382z00_1799;

				{	/* Trace/walk.scm 457 */
					obj_t BgL_res2094z00_2562;

					{	/* Trace/walk.scm 457 */
						long BgL_objzd2classzd2numz00_2533;

						BgL_objzd2classzd2numz00_2533 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_103));
						{	/* Trace/walk.scm 457 */
							obj_t BgL_arg1791z00_2534;

							BgL_arg1791z00_2534 =
								PROCEDURE_REF
								(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 457 */
								int BgL_offsetz00_2537;

								BgL_offsetz00_2537 = (int) (BgL_objzd2classzd2numz00_2533);
								{	/* Trace/walk.scm 457 */
									long BgL_offsetz00_2538;

									BgL_offsetz00_2538 =
										((long) (BgL_offsetz00_2537) - OBJECT_TYPE);
									{	/* Trace/walk.scm 457 */
										long BgL_modz00_2539;

										BgL_modz00_2539 =
											(BgL_offsetz00_2538 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Trace/walk.scm 457 */
											long BgL_restz00_2541;

											BgL_restz00_2541 =
												(BgL_offsetz00_2538 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Trace/walk.scm 457 */

												{	/* Trace/walk.scm 457 */
													obj_t BgL_bucketz00_2543;

													BgL_bucketz00_2543 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2534), BgL_modz00_2539);
													BgL_res2094z00_2562 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2543), BgL_restz00_2541);
					}}}}}}}}
					BgL_method1382z00_1799 = BgL_res2094z00_2562;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1382z00_1799) (BgL_method1382z00_1799,
						((obj_t) BgL_nodez00_103), BEOA));
			}
		}

	}



/* &toplevel-trace-node */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00(obj_t
		BgL_envz00_2663, obj_t BgL_nodez00_2664)
	{
		{	/* Trace/walk.scm 457 */
			return
				BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2664));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2111z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2113z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2114z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2115z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2116z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc2117z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2118z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2119z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc2120z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_switchz00zzast_nodez00, BGl_proc2121z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2122z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2123z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2124z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2125z00zztrace_walkz00,
				BGl_string2112z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc2126z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc2128z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2129z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc2130z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc2131z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc2132z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc2133z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc2134z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2135z00zztrace_walkz00,
				BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc2136z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc2137z00zztrace_walkz00, BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2138z00zztrace_walkz00,
				BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2139z00zztrace_walkz00,
				BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2140z00zztrace_walkz00,
				BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2141z00zztrace_walkz00,
				BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2142z00zztrace_walkz00,
				BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2143z00zztrace_walkz00,
				BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2144z00zztrace_walkz00,
				BGl_string2127z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2145z00zztrace_walkz00,
				BGl_string2146z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2147z00zztrace_walkz00,
				BGl_string2146z00zztrace_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2148z00zztrace_walkz00,
				BGl_string2146z00zztrace_walkz00);
		}

	}



/* &toplevel-trace-node-1388 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21388zb0zztrace_walkz00(obj_t
		BgL_envz00_2700, obj_t BgL_nodez00_2701)
	{
		{	/* Trace/walk.scm 484 */
			{	/* Trace/walk.scm 486 */
				BgL_varz00_bglt BgL_i1132z00_2823;

				BgL_i1132z00_2823 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2701)))->BgL_varz00);
				{	/* Trace/walk.scm 487 */
					bool_t BgL_test2253z00_3486;

					{	/* Trace/walk.scm 487 */
						bool_t BgL_test2254z00_3487;

						{	/* Trace/walk.scm 487 */
							BgL_variablez00_bglt BgL_arg2005z00_2824;

							BgL_arg2005z00_2824 =
								(((BgL_varz00_bglt) COBJECT(BgL_i1132z00_2823))->
								BgL_variablez00);
							BgL_test2254z00_3487 =
								BGl_isazf3zf3zz__objectz00(((obj_t) BgL_arg2005z00_2824),
								BGl_globalz00zzast_varz00);
						}
						if (BgL_test2254z00_3487)
							{	/* Trace/walk.scm 488 */
								bool_t BgL_test2255z00_3491;

								{	/* Trace/walk.scm 488 */
									bool_t BgL_test2256z00_3492;

									{	/* Trace/walk.scm 488 */
										BgL_nodez00_bglt BgL_arg2004z00_2825;

										BgL_arg2004z00_2825 =
											(((BgL_setqz00_bglt) COBJECT(
													((BgL_setqz00_bglt) BgL_nodez00_2701)))->
											BgL_valuez00);
										BgL_test2256z00_3492 =
											BGl_isazf3zf3zz__objectz00(((obj_t) BgL_arg2004z00_2825),
											BGl_atomz00zzast_nodez00);
									}
									if (BgL_test2256z00_3492)
										{	/* Trace/walk.scm 488 */
											BgL_test2255z00_3491 = ((bool_t) 1);
										}
									else
										{	/* Trace/walk.scm 489 */
											bool_t BgL_test2257z00_3497;

											{	/* Trace/walk.scm 489 */
												BgL_nodez00_bglt BgL_arg2003z00_2826;

												BgL_arg2003z00_2826 =
													(((BgL_setqz00_bglt) COBJECT(
															((BgL_setqz00_bglt) BgL_nodez00_2701)))->
													BgL_valuez00);
												BgL_test2257z00_3497 =
													BGl_isazf3zf3zz__objectz00(((obj_t)
														BgL_arg2003z00_2826), BGl_varz00zzast_nodez00);
											}
											if (BgL_test2257z00_3497)
												{	/* Trace/walk.scm 489 */
													BgL_test2255z00_3491 = ((bool_t) 1);
												}
											else
												{	/* Trace/walk.scm 490 */
													bool_t BgL_test2258z00_3502;

													{	/* Trace/walk.scm 490 */
														BgL_nodez00_bglt BgL_arg2002z00_2827;

														BgL_arg2002z00_2827 =
															(((BgL_setqz00_bglt) COBJECT(
																	((BgL_setqz00_bglt) BgL_nodez00_2701)))->
															BgL_valuez00);
														BgL_test2258z00_3502 =
															BGl_isazf3zf3zz__objectz00(((obj_t)
																BgL_arg2002z00_2827),
															BGl_kwotez00zzast_nodez00);
													}
													if (BgL_test2258z00_3502)
														{	/* Trace/walk.scm 490 */
															BgL_test2255z00_3491 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 491 */
															BgL_nodez00_bglt BgL_arg2001z00_2828;

															BgL_arg2001z00_2828 =
																(((BgL_setqz00_bglt) COBJECT(
																		((BgL_setqz00_bglt) BgL_nodez00_2701)))->
																BgL_valuez00);
															BgL_test2255z00_3491 =
																BGl_isazf3zf3zz__objectz00(((obj_t)
																	BgL_arg2001z00_2828),
																BGl_pragmaz00zzast_nodez00);
														}
												}
										}
								}
								if (BgL_test2255z00_3491)
									{	/* Trace/walk.scm 488 */
										BgL_test2253z00_3486 = ((bool_t) 0);
									}
								else
									{	/* Trace/walk.scm 488 */
										BgL_test2253z00_3486 = ((bool_t) 1);
									}
							}
						else
							{	/* Trace/walk.scm 487 */
								BgL_test2253z00_3486 = ((bool_t) 0);
							}
					}
					if (BgL_test2253z00_3486)
						{	/* Trace/walk.scm 492 */
							BgL_typez00_bglt BgL_tz00_2829;

							{	/* Trace/walk.scm 492 */
								BgL_typez00_bglt BgL_arg1997z00_2830;
								BgL_typez00_bglt BgL_arg1998z00_2831;

								BgL_arg1997z00_2830 =
									(((BgL_nodez00_bglt) COBJECT(
											(((BgL_setqz00_bglt) COBJECT(
														((BgL_setqz00_bglt) BgL_nodez00_2701)))->
												BgL_valuez00)))->BgL_typez00);
								BgL_arg1998z00_2831 =
									(((BgL_variablez00_bglt)
										COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt) ((
															(BgL_varz00_bglt) COBJECT(BgL_i1132z00_2823))->
														BgL_variablez00)))))->BgL_typez00);
								BgL_tz00_2829 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_arg1997z00_2830,
									BgL_arg1998z00_2831);
							}
							{	/* Trace/walk.scm 492 */
								BgL_letzd2varzd2_bglt BgL_tracez00_2832;

								{	/* Trace/walk.scm 493 */
									BgL_nodez00_bglt BgL_arg1993z00_2833;
									obj_t BgL_arg1994z00_2834;
									obj_t BgL_arg1995z00_2835;

									BgL_arg1993z00_2833 =
										(((BgL_setqz00_bglt) COBJECT(
												((BgL_setqz00_bglt) BgL_nodez00_2701)))->BgL_valuez00);
									{	/* Trace/walk.scm 493 */
										BgL_variablez00_bglt BgL_arg1996z00_2836;

										BgL_arg1996z00_2836 =
											(((BgL_varz00_bglt) COBJECT(BgL_i1132z00_2823))->
											BgL_variablez00);
										BgL_arg1994z00_2834 =
											BGl_tracezd2idzd2zztrace_walkz00(((obj_t)
												BgL_arg1996z00_2836));
									}
									BgL_arg1995z00_2835 =
										(((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt)
													((BgL_setqz00_bglt) BgL_nodez00_2701))))->BgL_locz00);
									BgL_tracez00_2832 =
										BGl_makezd2tracedzd2nodez00zztrace_walkz00
										(BgL_arg1993z00_2833, BgL_tz00_2829, BgL_arg1994z00_2834,
										BgL_arg1995z00_2835, BNIL);
								}
								{	/* Trace/walk.scm 493 */

									((((BgL_setqz00_bglt) COBJECT(
													((BgL_setqz00_bglt) BgL_nodez00_2701)))->
											BgL_valuez00) =
										((BgL_nodez00_bglt) ((BgL_nodez00_bglt) BgL_tracez00_2832)),
										BUNSPEC);
								}
							}
						}
					else
						{	/* Trace/walk.scm 487 */
							BFALSE;
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nodez00_2701));
		}

	}



/* &toplevel-trace-node-1386 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21386zb0zztrace_walkz00(obj_t
		BgL_envz00_2702, obj_t BgL_nodez00_2703)
	{
		{	/* Trace/walk.scm 470 */
			((((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2703)))->BgL_mutexz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2703)))->
							BgL_mutexz00))), BUNSPEC);
			((((BgL_syncz00_bglt) COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2703)))->
					BgL_prelockz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2703)))->
							BgL_prelockz00))), BUNSPEC);
			((((BgL_syncz00_bglt) COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2703)))->
					BgL_bodyz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2703)))->BgL_bodyz00))),
				BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nodez00_2703));
		}

	}



/* &toplevel-trace-node-1384 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21384zb0zztrace_walkz00(obj_t
		BgL_envz00_2704, obj_t BgL_nodez00_2705)
	{
		{	/* Trace/walk.scm 463 */
			BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2705)))->BgL_nodesz00));
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nodez00_2705));
		}

	}



/* &trace-node-box-set!1380 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2setz121380za2zztrace_walkz00(obj_t
		BgL_envz00_2706, obj_t BgL_nodez00_2707, obj_t BgL_stackz00_2708,
		obj_t BgL_levelz00_2709)
	{
		{	/* Trace/walk.scm 440 */
			{
				BgL_varz00_bglt BgL_auxz00_3555;

				{	/* Trace/walk.scm 442 */
					BgL_varz00_bglt BgL_arg1964z00_2840;

					BgL_arg1964z00_2840 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2707)))->BgL_varz00);
					BgL_auxz00_3555 =
						((BgL_varz00_bglt)
						BGl_tracezd2nodezd2zztrace_walkz00(
							((BgL_nodez00_bglt) BgL_arg1964z00_2840), BgL_stackz00_2708,
							BgL_levelz00_2709));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2707)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_3555), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3563;

				{	/* Trace/walk.scm 443 */
					BgL_nodez00_bglt BgL_arg1965z00_2841;

					BgL_arg1965z00_2841 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2707)))->BgL_valuez00);
					BgL_auxz00_3563 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1965z00_2841,
						BgL_stackz00_2708, BgL_levelz00_2709);
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2707)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3563), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2707));
		}

	}



/* &trace-node-box-ref1378 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2boxzd2ref1378zb0zztrace_walkz00(obj_t
		BgL_envz00_2710, obj_t BgL_nodez00_2711, obj_t BgL_stackz00_2712,
		obj_t BgL_levelz00_2713)
	{
		{	/* Trace/walk.scm 433 */
			{	/* Trace/walk.scm 434 */
				BgL_nodez00_bglt BgL_arg1962z00_2843;

				{	/* Trace/walk.scm 434 */
					BgL_varz00_bglt BgL_arg1963z00_2844;

					BgL_arg1963z00_2844 =
						(((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2711)))->BgL_varz00);
					BgL_arg1962z00_2843 =
						BGl_tracezd2nodezd2zztrace_walkz00(
						((BgL_nodez00_bglt) BgL_arg1963z00_2844), BgL_stackz00_2712,
						BgL_levelz00_2713);
				}
				((((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2711)))->BgL_varz00) =
					((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_arg1962z00_2843)), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2711));
		}

	}



/* &trace-node-make-box1376 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2makezd2box1376zb0zztrace_walkz00(obj_t
		BgL_envz00_2714, obj_t BgL_nodez00_2715, obj_t BgL_stackz00_2716,
		obj_t BgL_levelz00_2717)
	{
		{	/* Trace/walk.scm 426 */
			((((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2715)))->BgL_valuez00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_makezd2boxzd2_bglt)
								COBJECT(((BgL_makezd2boxzd2_bglt) BgL_nodez00_2715)))->
							BgL_valuez00), BgL_stackz00_2716, BgL_levelz00_2717)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2715));
		}

	}



/* &trace-node-jump-ex-i1374 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1374z62zztrace_walkz00(obj_t
		BgL_envz00_2718, obj_t BgL_nodez00_2719, obj_t BgL_stackz00_2720,
		obj_t BgL_levelz00_2721)
	{
		{	/* Trace/walk.scm 417 */
			{
				BgL_nodez00_bglt BgL_auxz00_3587;

				{	/* Trace/walk.scm 419 */
					BgL_nodez00_bglt BgL_arg1958z00_2847;

					BgL_arg1958z00_2847 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2719)))->BgL_exitz00);
					BgL_auxz00_3587 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1958z00_2847,
						BgL_stackz00_2720, BgL_levelz00_2721);
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2719)))->
						BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3587), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3593;

				{	/* Trace/walk.scm 420 */
					BgL_nodez00_bglt BgL_arg1959z00_2848;

					BgL_arg1959z00_2848 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2719)))->
						BgL_valuez00);
					BgL_auxz00_3593 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1959z00_2848,
						BgL_stackz00_2720, BgL_levelz00_2721);
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2719)))->
						BgL_valuez00) = ((BgL_nodez00_bglt) BgL_auxz00_3593), BUNSPEC);
			}
			return
				((BgL_nodez00_bglt) ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2719));
		}

	}



/* &trace-node-set-ex-it1372 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setzd2exzd2it1372z62zztrace_walkz00(obj_t
		BgL_envz00_2722, obj_t BgL_nodez00_2723, obj_t BgL_stackz00_2724,
		obj_t BgL_levelz00_2725)
	{
		{	/* Trace/walk.scm 410 */
			((((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2723)))->BgL_bodyz00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_setzd2exzd2itz00_bglt)
								COBJECT(((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2723)))->
							BgL_bodyz00), BgL_stackz00_2724, BgL_levelz00_2725)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt)
					BgL_nodez00_2723));
		}

	}



/* &trace-node-let-var1370 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2letzd2var1370zb0zztrace_walkz00(obj_t
		BgL_envz00_2726, obj_t BgL_nodez00_2727, obj_t BgL_stackz00_2728,
		obj_t BgL_levelz00_2729)
	{
		{	/* Trace/walk.scm 399 */
			{	/* Trace/walk.scm 401 */
				obj_t BgL_g1311z00_2851;

				BgL_g1311z00_2851 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2727)))->BgL_bindingsz00);
				{
					obj_t BgL_l1309z00_2853;

					BgL_l1309z00_2853 = BgL_g1311z00_2851;
				BgL_zc3z04anonymousza31949ze3z87_2852:
					if (PAIRP(BgL_l1309z00_2853))
						{	/* Trace/walk.scm 401 */
							{	/* Trace/walk.scm 402 */
								obj_t BgL_bindingz00_2854;

								BgL_bindingz00_2854 = CAR(BgL_l1309z00_2853);
								{	/* Trace/walk.scm 402 */
									BgL_nodez00_bglt BgL_arg1951z00_2855;

									{	/* Trace/walk.scm 402 */
										obj_t BgL_arg1953z00_2856;

										BgL_arg1953z00_2856 = CDR(((obj_t) BgL_bindingz00_2854));
										BgL_arg1951z00_2855 =
											BGl_tracezd2nodezd2zztrace_walkz00(
											((BgL_nodez00_bglt) BgL_arg1953z00_2856),
											BgL_stackz00_2728, BgL_levelz00_2729);
									}
									{	/* Trace/walk.scm 402 */
										obj_t BgL_auxz00_3619;
										obj_t BgL_tmpz00_3617;

										BgL_auxz00_3619 = ((obj_t) BgL_arg1951z00_2855);
										BgL_tmpz00_3617 = ((obj_t) BgL_bindingz00_2854);
										SET_CDR(BgL_tmpz00_3617, BgL_auxz00_3619);
									}
								}
							}
							{
								obj_t BgL_l1309z00_3622;

								BgL_l1309z00_3622 = CDR(BgL_l1309z00_2853);
								BgL_l1309z00_2853 = BgL_l1309z00_3622;
								goto BgL_zc3z04anonymousza31949ze3z87_2852;
							}
						}
					else
						{	/* Trace/walk.scm 401 */
							((bool_t) 1);
						}
				}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3624;

				{	/* Trace/walk.scm 404 */
					BgL_nodez00_bglt BgL_arg1955z00_2857;

					BgL_arg1955z00_2857 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2727)))->BgL_bodyz00);
					BgL_auxz00_3624 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1955z00_2857,
						BgL_stackz00_2728, BgL_levelz00_2729);
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2727)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3624), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nodez00_2727));
		}

	}



/* &trace-node-let-fun1368 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2letzd2fun1368zb0zztrace_walkz00(obj_t
		BgL_envz00_2730, obj_t BgL_nodez00_2731, obj_t BgL_stackz00_2732,
		obj_t BgL_levelz00_2733)
	{
		{	/* Trace/walk.scm 383 */
			if (BGl_isloopzf3zf3zztrace_isloopz00(
					((BgL_letzd2funzd2_bglt) BgL_nodez00_2731)))
				{	/* Trace/walk.scm 384 */
					{	/* Trace/walk.scm 386 */
						obj_t BgL_varz00_2859;

						BgL_varz00_2859 =
							CAR(
							(((BgL_letzd2funzd2_bglt) COBJECT(
										((BgL_letzd2funzd2_bglt) BgL_nodez00_2731)))->
								BgL_localsz00));
						{	/* Trace/walk.scm 386 */
							BgL_typez00_bglt BgL_tz00_2860;

							{	/* Trace/walk.scm 387 */
								BgL_typez00_bglt BgL_arg1941z00_2861;
								BgL_typez00_bglt BgL_arg1942z00_2862;

								BgL_arg1941z00_2861 =
									(((BgL_nodez00_bglt) COBJECT(
											(((BgL_letzd2funzd2_bglt) COBJECT(
														((BgL_letzd2funzd2_bglt) BgL_nodez00_2731)))->
												BgL_bodyz00)))->BgL_typez00);
								BgL_arg1942z00_2862 =
									(((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
												BgL_varz00_2859)))->BgL_typez00);
								BgL_tz00_2860 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_arg1941z00_2861,
									BgL_arg1942z00_2862);
							}
							{	/* Trace/walk.scm 387 */
								obj_t BgL_idz00_2863;

								BgL_idz00_2863 =
									BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_2859);
								{	/* Trace/walk.scm 388 */

									{
										BgL_nodez00_bglt BgL_auxz00_3645;

										{	/* Trace/walk.scm 389 */
											BgL_nodez00_bglt BgL_arg1939z00_2864;
											obj_t BgL_arg1940z00_2865;

											BgL_arg1939z00_2864 =
												(((BgL_letzd2funzd2_bglt) COBJECT(
														((BgL_letzd2funzd2_bglt) BgL_nodez00_2731)))->
												BgL_bodyz00);
											BgL_arg1940z00_2865 =
												(((BgL_nodez00_bglt)
													COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt)
																BgL_nodez00_2731))))->BgL_locz00);
											BgL_auxz00_3645 =
												((BgL_nodez00_bglt)
												BGl_makezd2tracedzd2nodez00zztrace_walkz00
												(BgL_arg1939z00_2864, BgL_tz00_2860, BgL_idz00_2863,
													BgL_arg1940z00_2865, BNIL));
										}
										((((BgL_letzd2funzd2_bglt) COBJECT(
														((BgL_letzd2funzd2_bglt) BgL_nodez00_2731)))->
												BgL_bodyz00) =
											((BgL_nodez00_bglt) BgL_auxz00_3645), BUNSPEC);
									}
								}
							}
						}
					}
					return
						((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nodez00_2731));
				}
			else
				{	/* Trace/walk.scm 384 */
					{	/* Trace/walk.scm 392 */
						obj_t BgL_g1308z00_2866;

						BgL_g1308z00_2866 =
							(((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nodez00_2731)))->BgL_localsz00);
						{
							obj_t BgL_l1306z00_2868;

							BgL_l1306z00_2868 = BgL_g1308z00_2866;
						BgL_zc3z04anonymousza31945ze3z87_2867:
							if (PAIRP(BgL_l1306z00_2868))
								{	/* Trace/walk.scm 392 */
									BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l1306z00_2868),
										BgL_stackz00_2732, BgL_levelz00_2733);
									{
										obj_t BgL_l1306z00_3663;

										BgL_l1306z00_3663 = CDR(BgL_l1306z00_2868);
										BgL_l1306z00_2868 = BgL_l1306z00_3663;
										goto BgL_zc3z04anonymousza31945ze3z87_2867;
									}
								}
							else
								{	/* Trace/walk.scm 392 */
									((bool_t) 1);
								}
						}
					}
					{
						BgL_nodez00_bglt BgL_auxz00_3665;

						{	/* Trace/walk.scm 393 */
							BgL_nodez00_bglt BgL_arg1948z00_2869;

							BgL_arg1948z00_2869 =
								(((BgL_letzd2funzd2_bglt) COBJECT(
										((BgL_letzd2funzd2_bglt) BgL_nodez00_2731)))->BgL_bodyz00);
							BgL_auxz00_3665 =
								BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1948z00_2869,
								BgL_stackz00_2732, BgL_levelz00_2733);
						}
						((((BgL_letzd2funzd2_bglt) COBJECT(
										((BgL_letzd2funzd2_bglt) BgL_nodez00_2731)))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_auxz00_3665), BUNSPEC);
					}
					return
						((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nodez00_2731));
				}
		}

	}



/* &trace-node-switch1366 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2switch1366z62zztrace_walkz00(obj_t
		BgL_envz00_2734, obj_t BgL_nodez00_2735, obj_t BgL_stackz00_2736,
		obj_t BgL_levelz00_2737)
	{
		{	/* Trace/walk.scm 372 */
			{
				BgL_nodez00_bglt BgL_auxz00_3673;

				{	/* Trace/walk.scm 374 */
					BgL_nodez00_bglt BgL_arg1932z00_2871;

					BgL_arg1932z00_2871 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2735)))->BgL_testz00);
					BgL_auxz00_3673 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1932z00_2871,
						BgL_stackz00_2736, BgL_levelz00_2737);
				}
				((((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2735)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3673), BUNSPEC);
			}
			{	/* Trace/walk.scm 375 */
				obj_t BgL_g1305z00_2872;

				BgL_g1305z00_2872 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2735)))->BgL_clausesz00);
				{
					obj_t BgL_l1303z00_2874;

					BgL_l1303z00_2874 = BgL_g1305z00_2872;
				BgL_zc3z04anonymousza31933ze3z87_2873:
					if (PAIRP(BgL_l1303z00_2874))
						{	/* Trace/walk.scm 375 */
							{	/* Trace/walk.scm 376 */
								obj_t BgL_clausez00_2875;

								BgL_clausez00_2875 = CAR(BgL_l1303z00_2874);
								{	/* Trace/walk.scm 376 */
									BgL_nodez00_bglt BgL_arg1935z00_2876;

									{	/* Trace/walk.scm 376 */
										obj_t BgL_arg1936z00_2877;

										BgL_arg1936z00_2877 = CDR(((obj_t) BgL_clausez00_2875));
										BgL_arg1935z00_2876 =
											BGl_tracezd2nodezd2zztrace_walkz00(
											((BgL_nodez00_bglt) BgL_arg1936z00_2877),
											BgL_stackz00_2736, BgL_levelz00_2737);
									}
									{	/* Trace/walk.scm 376 */
										obj_t BgL_auxz00_3690;
										obj_t BgL_tmpz00_3688;

										BgL_auxz00_3690 = ((obj_t) BgL_arg1935z00_2876);
										BgL_tmpz00_3688 = ((obj_t) BgL_clausez00_2875);
										SET_CDR(BgL_tmpz00_3688, BgL_auxz00_3690);
									}
								}
							}
							{
								obj_t BgL_l1303z00_3693;

								BgL_l1303z00_3693 = CDR(BgL_l1303z00_2874);
								BgL_l1303z00_2874 = BgL_l1303z00_3693;
								goto BgL_zc3z04anonymousza31933ze3z87_2873;
							}
						}
					else
						{	/* Trace/walk.scm 375 */
							((bool_t) 1);
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nodez00_2735));
		}

	}



/* &trace-node-fail1364 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2fail1364z62zztrace_walkz00(obj_t
		BgL_envz00_2738, obj_t BgL_nodez00_2739, obj_t BgL_stackz00_2740,
		obj_t BgL_levelz00_2741)
	{
		{	/* Trace/walk.scm 362 */
			{
				BgL_nodez00_bglt BgL_auxz00_3697;

				{	/* Trace/walk.scm 364 */
					BgL_nodez00_bglt BgL_arg1929z00_2879;

					BgL_arg1929z00_2879 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2739)))->BgL_procz00);
					BgL_auxz00_3697 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1929z00_2879,
						BgL_stackz00_2740, BgL_levelz00_2741);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2739)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3697), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3703;

				{	/* Trace/walk.scm 365 */
					BgL_nodez00_bglt BgL_arg1930z00_2880;

					BgL_arg1930z00_2880 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2739)))->BgL_msgz00);
					BgL_auxz00_3703 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1930z00_2880,
						BgL_stackz00_2740, BgL_levelz00_2741);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2739)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3703), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3709;

				{	/* Trace/walk.scm 366 */
					BgL_nodez00_bglt BgL_arg1931z00_2881;

					BgL_arg1931z00_2881 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2739)))->BgL_objz00);
					BgL_auxz00_3709 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1931z00_2881,
						BgL_stackz00_2740, BgL_levelz00_2741);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2739)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3709), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_failz00_bglt) BgL_nodez00_2739));
		}

	}



/* &trace-node-condition1362 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2condition1362z62zztrace_walkz00(obj_t
		BgL_envz00_2742, obj_t BgL_nodez00_2743, obj_t BgL_stackz00_2744,
		obj_t BgL_levelz00_2745)
	{
		{	/* Trace/walk.scm 352 */
			{
				BgL_nodez00_bglt BgL_auxz00_3717;

				{	/* Trace/walk.scm 354 */
					BgL_nodez00_bglt BgL_arg1926z00_2883;

					BgL_arg1926z00_2883 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2743)))->BgL_testz00);
					BgL_auxz00_3717 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1926z00_2883,
						BgL_stackz00_2744, BgL_levelz00_2745);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2743)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3717), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3723;

				{	/* Trace/walk.scm 355 */
					BgL_nodez00_bglt BgL_arg1927z00_2884;

					BgL_arg1927z00_2884 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2743)))->BgL_truez00);
					BgL_auxz00_3723 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1927z00_2884,
						BgL_stackz00_2744, BgL_levelz00_2745);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2743)))->BgL_truez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3723), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3729;

				{	/* Trace/walk.scm 356 */
					BgL_nodez00_bglt BgL_arg1928z00_2885;

					BgL_arg1928z00_2885 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2743)))->BgL_falsez00);
					BgL_auxz00_3729 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1928z00_2885,
						BgL_stackz00_2744, BgL_levelz00_2745);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2743)))->BgL_falsez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3729), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt) BgL_nodez00_2743));
		}

	}



/* &trace-node-setq1360 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2setq1360z62zztrace_walkz00(obj_t
		BgL_envz00_2746, obj_t BgL_nodez00_2747, obj_t BgL_stackz00_2748,
		obj_t BgL_levelz00_2749)
	{
		{	/* Trace/walk.scm 345 */
			((((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2747)))->BgL_valuez00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_setqz00_bglt)
								COBJECT(((BgL_setqz00_bglt) BgL_nodez00_2747)))->BgL_valuez00),
						BgL_stackz00_2748, BgL_levelz00_2749)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nodez00_2747));
		}

	}



/* &trace-node-cast1358 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2cast1358z62zztrace_walkz00(obj_t
		BgL_envz00_2750, obj_t BgL_nodez00_2751, obj_t BgL_stackz00_2752,
		obj_t BgL_levelz00_2753)
	{
		{	/* Trace/walk.scm 338 */
			((((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nodez00_2751)))->BgL_argz00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_castz00_bglt)
								COBJECT(((BgL_castz00_bglt) BgL_nodez00_2751)))->BgL_argz00),
						BgL_stackz00_2752, BgL_levelz00_2753)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_castz00_bglt) BgL_nodez00_2751));
		}

	}



/* &trace-node-extern1356 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2extern1356z62zztrace_walkz00(obj_t
		BgL_envz00_2754, obj_t BgL_nodez00_2755, obj_t BgL_stackz00_2756,
		obj_t BgL_levelz00_2757)
	{
		{	/* Trace/walk.scm 331 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nodez00_2755)))->BgL_exprza2za2),
				BgL_stackz00_2756, BgL_levelz00_2757);
			return ((BgL_nodez00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2755));
		}

	}



/* &trace-node-funcall1354 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2funcall1354z62zztrace_walkz00(obj_t
		BgL_envz00_2758, obj_t BgL_nodez00_2759, obj_t BgL_stackz00_2760,
		obj_t BgL_levelz00_2761)
	{
		{	/* Trace/walk.scm 322 */
			{
				BgL_nodez00_bglt BgL_auxz00_3756;

				{	/* Trace/walk.scm 324 */
					BgL_nodez00_bglt BgL_arg1917z00_2890;

					BgL_arg1917z00_2890 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2759)))->BgL_funz00);
					BgL_auxz00_3756 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1917z00_2890,
						BgL_stackz00_2760, BgL_levelz00_2761);
				}
				((((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2759)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3756), BUNSPEC);
			}
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_2759)))->BgL_argsz00),
				BgL_stackz00_2760, BgL_levelz00_2761);
			return ((BgL_nodez00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2759));
		}

	}



/* &trace-node-app-ly1352 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2appzd2ly1352zb0zztrace_walkz00(obj_t
		BgL_envz00_2762, obj_t BgL_nodez00_2763, obj_t BgL_stackz00_2764,
		obj_t BgL_levelz00_2765)
	{
		{	/* Trace/walk.scm 313 */
			{
				BgL_nodez00_bglt BgL_auxz00_3767;

				{	/* Trace/walk.scm 315 */
					BgL_nodez00_bglt BgL_arg1914z00_2892;

					BgL_arg1914z00_2892 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2763)))->BgL_funz00);
					BgL_auxz00_3767 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1914z00_2892,
						BgL_stackz00_2764, BgL_levelz00_2765);
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2763)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3767), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3773;

				{	/* Trace/walk.scm 316 */
					BgL_nodez00_bglt BgL_arg1915z00_2893;

					BgL_arg1915z00_2893 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2763)))->BgL_argz00);
					BgL_auxz00_3773 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1915z00_2893,
						BgL_stackz00_2764, BgL_levelz00_2765);
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2763)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3773), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2763));
		}

	}



/* &trace-node-app1350 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2app1350z62zztrace_walkz00(obj_t
		BgL_envz00_2766, obj_t BgL_nodez00_2767, obj_t BgL_stackz00_2768,
		obj_t BgL_levelz00_2769)
	{
		{	/* Trace/walk.scm 306 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2767)))->BgL_argsz00),
				BgL_stackz00_2768, BgL_levelz00_2769);
			return ((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2767));
		}

	}



/* &trace-node-sync1348 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2sync1348z62zztrace_walkz00(obj_t
		BgL_envz00_2770, obj_t BgL_nodez00_2771, obj_t BgL_stackz00_2772,
		obj_t BgL_levelz00_2773)
	{
		{	/* Trace/walk.scm 296 */
			{
				BgL_nodez00_bglt BgL_auxz00_3786;

				{	/* Trace/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg1910z00_2896;

					BgL_arg1910z00_2896 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2771)))->BgL_mutexz00);
					BgL_auxz00_3786 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1910z00_2896,
						BgL_stackz00_2772, BgL_levelz00_2773);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2771)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3786), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3792;

				{	/* Trace/walk.scm 299 */
					BgL_nodez00_bglt BgL_arg1911z00_2897;

					BgL_arg1911z00_2897 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2771)))->BgL_prelockz00);
					BgL_auxz00_3792 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1911z00_2897,
						BgL_stackz00_2772, BgL_levelz00_2773);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2771)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3792), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3798;

				{	/* Trace/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg1912z00_2898;

					BgL_arg1912z00_2898 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2771)))->BgL_bodyz00);
					BgL_auxz00_3798 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1912z00_2898,
						BgL_stackz00_2772, BgL_levelz00_2773);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2771)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3798), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nodez00_2771));
		}

	}



/* &trace-node-sequence1346 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2sequence1346z62zztrace_walkz00(obj_t
		BgL_envz00_2774, obj_t BgL_nodez00_2775, obj_t BgL_stackz00_2776,
		obj_t BgL_levelz00_2777)
	{
		{	/* Trace/walk.scm 289 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2775)))->BgL_nodesz00),
				BgL_stackz00_2776, BgL_levelz00_2777);
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nodez00_2775));
		}

	}



/* &find-last-node-jump-1342 */
	obj_t BGl_z62findzd2lastzd2nodezd2jumpzd21342z62zztrace_walkz00(obj_t
		BgL_envz00_2778, obj_t BgL_nodez00_2779)
	{
		{	/* Trace/walk.scm 239 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2779)))->BgL_valuez00));
		}

	}



/* &find-last-node-set-e1340 */
	obj_t BGl_z62findzd2lastzd2nodezd2setzd2e1340z62zztrace_walkz00(obj_t
		BgL_envz00_2780, obj_t BgL_nodez00_2781)
	{
		{	/* Trace/walk.scm 233 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2781)))->BgL_bodyz00));
		}

	}



/* &find-last-node-let-f1338 */
	obj_t BGl_z62findzd2lastzd2nodezd2letzd2f1338z62zztrace_walkz00(obj_t
		BgL_envz00_2782, obj_t BgL_nodez00_2783)
	{
		{	/* Trace/walk.scm 227 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2783)))->BgL_bodyz00));
		}

	}



/* &find-last-node-let-v1336 */
	obj_t BGl_z62findzd2lastzd2nodezd2letzd2v1336z62zztrace_walkz00(obj_t
		BgL_envz00_2784, obj_t BgL_nodez00_2785)
	{
		{	/* Trace/walk.scm 221 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2785)))->BgL_bodyz00));
		}

	}



/* &find-last-node-switc1334 */
	obj_t BGl_z62findzd2lastzd2nodezd2switc1334zb0zztrace_walkz00(obj_t
		BgL_envz00_2786, obj_t BgL_nodez00_2787)
	{
		{	/* Trace/walk.scm 212 */
			{	/* Trace/walk.scm 214 */
				bool_t BgL_test2263z00_3823;

				{	/* Trace/walk.scm 214 */
					obj_t BgL_tmpz00_3824;

					BgL_tmpz00_3824 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2787)))->BgL_clausesz00);
					BgL_test2263z00_3823 = PAIRP(BgL_tmpz00_3824);
				}
				if (BgL_test2263z00_3823)
					{	/* Trace/walk.scm 215 */
						obj_t BgL_arg1899z00_2905;

						BgL_arg1899z00_2905 =
							CDR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_switchz00_bglt) COBJECT(
											((BgL_switchz00_bglt) BgL_nodez00_2787)))->
									BgL_clausesz00)));
						return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
								BgL_arg1899z00_2905));
					}
				else
					{	/* Trace/walk.scm 214 */
						return
							BGl_findzd2lastzd2sexpz00zztrace_walkz00(
							((obj_t)
								(((BgL_switchz00_bglt) COBJECT(
											((BgL_switchz00_bglt) BgL_nodez00_2787)))->BgL_testz00)));
					}
			}
		}

	}



/* &find-last-node-fail1331 */
	obj_t BGl_z62findzd2lastzd2nodezd2fail1331zb0zztrace_walkz00(obj_t
		BgL_envz00_2788, obj_t BgL_nodez00_2789)
	{
		{	/* Trace/walk.scm 206 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2789)))->BgL_objz00));
		}

	}



/* &find-last-node-condi1329 */
	obj_t BGl_z62findzd2lastzd2nodezd2condi1329zb0zztrace_walkz00(obj_t
		BgL_envz00_2790, obj_t BgL_nodez00_2791)
	{
		{	/* Trace/walk.scm 200 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2791)))->BgL_falsez00));
		}

	}



/* &find-last-node-setq1327 */
	obj_t BGl_z62findzd2lastzd2nodezd2setq1327zb0zztrace_walkz00(obj_t
		BgL_envz00_2792, obj_t BgL_nodez00_2793)
	{
		{	/* Trace/walk.scm 194 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2793)))->BgL_valuez00));
		}

	}



/* &find-last-node-exter1325 */
	obj_t BGl_z62findzd2lastzd2nodezd2exter1325zb0zztrace_walkz00(obj_t
		BgL_envz00_2794, obj_t BgL_nodez00_2795)
	{
		{	/* Trace/walk.scm 185 */
			if (NULLP(
					(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt) BgL_nodez00_2795)))->BgL_exprza2za2)))
				{	/* Trace/walk.scm 187 */
					return ((obj_t) ((BgL_externz00_bglt) BgL_nodez00_2795));
				}
			else
				{	/* Trace/walk.scm 188 */
					obj_t BgL_arg1888z00_2910;

					BgL_arg1888z00_2910 =
						CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
							(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt) BgL_nodez00_2795)))->
								BgL_exprza2za2)));
					return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
							BgL_arg1888z00_2910));
				}
		}

	}



/* &find-last-node-funca1323 */
	obj_t BGl_z62findzd2lastzd2nodezd2funca1323zb0zztrace_walkz00(obj_t
		BgL_envz00_2796, obj_t BgL_nodez00_2797)
	{
		{	/* Trace/walk.scm 176 */
			{	/* Trace/walk.scm 178 */
				bool_t BgL_test2265z00_3859;

				{	/* Trace/walk.scm 178 */
					obj_t BgL_tmpz00_3860;

					BgL_tmpz00_3860 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2797)))->BgL_argsz00);
					BgL_test2265z00_3859 = PAIRP(BgL_tmpz00_3860);
				}
				if (BgL_test2265z00_3859)
					{	/* Trace/walk.scm 179 */
						obj_t BgL_arg1878z00_2912;

						BgL_arg1878z00_2912 =
							CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_funcallz00_bglt) COBJECT(
											((BgL_funcallz00_bglt) BgL_nodez00_2797)))->
									BgL_argsz00)));
						return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
								BgL_arg1878z00_2912));
					}
				else
					{	/* Trace/walk.scm 178 */
						return
							BGl_findzd2lastzd2nodez00zztrace_walkz00(
							(((BgL_funcallz00_bglt) COBJECT(
										((BgL_funcallz00_bglt) BgL_nodez00_2797)))->BgL_funz00));
					}
			}
		}

	}



/* &find-last-node-app-l1321 */
	obj_t BGl_z62findzd2lastzd2nodezd2appzd2l1321z62zztrace_walkz00(obj_t
		BgL_envz00_2798, obj_t BgL_nodez00_2799)
	{
		{	/* Trace/walk.scm 170 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2799)))->BgL_argz00));
		}

	}



/* &find-last-node-app1319 */
	obj_t BGl_z62findzd2lastzd2nodezd2app1319zb0zztrace_walkz00(obj_t
		BgL_envz00_2800, obj_t BgL_nodez00_2801)
	{
		{	/* Trace/walk.scm 161 */
			{	/* Trace/walk.scm 163 */
				bool_t BgL_test2266z00_3876;

				{	/* Trace/walk.scm 163 */
					obj_t BgL_tmpz00_3877;

					BgL_tmpz00_3877 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_2801)))->BgL_argsz00);
					BgL_test2266z00_3876 = PAIRP(BgL_tmpz00_3877);
				}
				if (BgL_test2266z00_3876)
					{	/* Trace/walk.scm 164 */
						obj_t BgL_arg1867z00_2915;

						BgL_arg1867z00_2915 =
							CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nodez00_2801)))->BgL_argsz00)));
						return
							BGl_findzd2lastzd2nodez00zztrace_walkz00(
							((BgL_nodez00_bglt) BgL_arg1867z00_2915));
					}
				else
					{	/* Trace/walk.scm 163 */
						return ((obj_t) ((BgL_appz00_bglt) BgL_nodez00_2801));
					}
			}
		}

	}



/* &find-last-node-sync1317 */
	obj_t BGl_z62findzd2lastzd2nodezd2sync1317zb0zztrace_walkz00(obj_t
		BgL_envz00_2802, obj_t BgL_nodez00_2803)
	{
		{	/* Trace/walk.scm 154 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2803)))->BgL_bodyz00));
		}

	}



/* &find-last-node-seque1315 */
	obj_t BGl_z62findzd2lastzd2nodezd2seque1315zb0zztrace_walkz00(obj_t
		BgL_envz00_2804, obj_t BgL_nodez00_2805)
	{
		{	/* Trace/walk.scm 145 */
			if (NULLP(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_2805)))->BgL_nodesz00)))
				{	/* Trace/walk.scm 147 */
					return ((obj_t) ((BgL_sequencez00_bglt) BgL_nodez00_2805));
				}
			else
				{	/* Trace/walk.scm 148 */
					obj_t BgL_arg1859z00_2918;

					BgL_arg1859z00_2918 =
						CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
							(((BgL_sequencez00_bglt) COBJECT(
										((BgL_sequencez00_bglt) BgL_nodez00_2805)))->
								BgL_nodesz00)));
					return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
							BgL_arg1859z00_2918));
				}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00()
	{
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 163122759),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztrace_isloopz00(((long) 332486922),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2149z00zztrace_walkz00));
		}

	}

#ifdef __cplusplus
}
#endif
