/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_comp.scm -o objs/obj_p/Eval/evaluate_comp.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static obj_t BGl_symbol4340z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4342z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4262z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4344z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32010ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol4346z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62compzd2ev_trap1389zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long, obj_t, obj_t);
static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza32842ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32818ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31919ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol4270z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4272z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4274z00zz__evaluate_compz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
static obj_t BGl_symbol4277z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32924ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32908ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33378ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol4280z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4282z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4284z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4286z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4288z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32933ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_prog21409zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32771ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32836ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32755ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32747ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32739ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt, obj_t);
static obj_t BGl_symbol4290z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4292z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4294z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4377z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4296z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4298z00zz__evaluate_compz00 = BUNSPEC;
extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32691ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33574ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32683ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32675ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32667ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32659ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32103ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol4385z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62compzd2ev_defglobal1399zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32870ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32854ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31955ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32765ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31939ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32031ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol4396z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62compzd2ev_setglobal1397zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
static obj_t BGl_symbol4398z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32960ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32774ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33649ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33585ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza32848ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_cadrerrvz00zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31876ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31787ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32759ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33399ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_or1405zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_zc3z04exitza33086ze3ze70z60zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32881ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32695ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32687ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32768ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32679ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t bgl_reverse_bang(obj_t);
static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
static obj_t BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32131ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
static obj_t BGl_z62run4201z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4203z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4205z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4207z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4209z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t bstring_to_symbol(obj_t);
static obj_t BGl_z62zc3z04anonymousza33693ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
extern obj_t make_vector(long, obj_t);
static obj_t BGl_z62compzd2ev_goto1427zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4211z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4213z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4215z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_let1411zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4217z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33113ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4219z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
extern obj_t BGl_evmodulezd2namezd2zz__evmodulez00(obj_t);
static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
static long BGl_correctz00zz__evaluate_compz00(obj_t, long);
static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32965ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31985ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32868ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31896ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31969ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62run4221z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4223z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
static obj_t BGl_z62run4225z62zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza33300ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4227z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4229z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33009ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32699ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4231z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62run4233z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4235z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62run4237z62zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4239z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32975ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32959ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31987ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33599ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4241z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4243z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4163z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4245z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4165z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33221ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4247z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33043ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33124ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4167z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32071ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4169z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
static obj_t BGl_reset_profilez00zz__evaluate_compz00();
static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_synchroniza7e1423z17zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4171z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
static obj_t BGl_z62run4173z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33311ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4175z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4177z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4179z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32985ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_labels1425zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4181z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4183z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4185z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4187z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32073ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32227ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4200z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4189z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4202z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4204z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4206z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4208z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t, obj_t, obj_t);
static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t);
static obj_t BGl_z62run4191z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run4193z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_app1429zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4195z62zz__evaluate_compz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
static obj_t BGl_z62run4197z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4210z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run4199z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_var1391zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4212z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4214z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4216z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4218z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_zc3z04exitza33070ze3ze70z60zz__evaluate_compz00(obj_t, obj_t, obj_t, long, obj_t);
static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32342ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4220z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
static obj_t BGl_z62main4222z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4224z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4226z62zz__evaluate_compz00(obj_t, obj_t);
extern bool_t bigloo_string_lt(obj_t, obj_t);
static obj_t BGl_z62main4228z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32988ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33080ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32157ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4230z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main4232z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main4234z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main4236z62zz__evaluate_compz00(obj_t);
static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
static obj_t BGl_z62main4238z62zz__evaluate_compz00(obj_t);
extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32077ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4240z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4242z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4162z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4244z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4164z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_and1407zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4246z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4166z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4168z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_checkzd2stackzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
static obj_t BGl_z62compzd2ev_bindzd2exit1417z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33260ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern int bgl_debug();
extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long, long);
static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32264ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4170z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
static obj_t BGl_z62main4172z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4174z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
static obj_t BGl_z62main4176z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_global1395zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4178z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t create_struct(obj_t, int);
static obj_t BGl_z62zc3z04anonymousza31811ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_get_profilez00zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza32192ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32338ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4180z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62main4182z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
static obj_t BGl_z62main4184z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4186z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4188z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
extern long bgl_list_length(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza32711ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza32703ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33343ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33092ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32436ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33076ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main4190z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4192z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_abs1431zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main4194z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4196z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main4198z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_letrec1415zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_withzd2handler1421z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33611ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33425ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33409ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza33239ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33069ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33434ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_if1403zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static bool_t BGl_cadrzf3zf3zz__evaluate_compz00(obj_t);
extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33354ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_letza21413z12zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31921ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32731ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33533ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32723ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33363ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32715ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32707ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33185ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_litt1401zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62comp1386z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32651ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33194ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00(obj_t);
static obj_t BGl_profzd2initzd2zz__evaluate_compz00();
static obj_t BGl_symbol4300z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4302z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4304z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4306z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62compzd2ev_setlocal1393zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol4308z00zz__evaluate_compz00 = BUNSPEC;
extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32830ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33292ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32482ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33446ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_unwindzd2prote1419z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol4310z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4312z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4314z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4316z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4318z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
static obj_t BGl_symbol4400z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4320z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4402z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4322z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4324z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4326z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4328z00zz__evaluate_compz00 = BUNSPEC;
extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t, obj_t, obj_t);
extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32913ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32751ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32743ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31925ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32735ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33456ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32727ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32719ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33278ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol4330z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4332z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4252z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4334z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4254z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4336z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4256z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol4338z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32671ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32663ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33546ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32655ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32388ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32299ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t *__cnst;


extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_bgl_za762za7c3lexintza7a1za74406z00, BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_compilezd2envzd2zz__evaluate_compz00, BgL_bgl_za762compileza762za7za7_4407z00, BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
DEFINE_STRING( BGl_string4301z00zz__evaluate_compz00, BgL_bgl_string4301za700za7za7_4408za7, "+fx", 3 );
DEFINE_STRING( BGl_string4303z00zz__evaluate_compz00, BgL_bgl_string4303za700za7za7_4409za7, "fixnum", 6 );
DEFINE_STRING( BGl_string4305z00zz__evaluate_compz00, BgL_bgl_string4305za700za7za7_4410za7, "-fx", 3 );
DEFINE_STRING( BGl_string4307z00zz__evaluate_compz00, BgL_bgl_string4307za700za7za7_4411za7, "*fx", 3 );
DEFINE_STRING( BGl_string4309z00zz__evaluate_compz00, BgL_bgl_string4309za700za7za7_4412za7, "/fx", 3 );
DEFINE_STRING( BGl_string4311z00zz__evaluate_compz00, BgL_bgl_string4311za700za7za7_4413za7, "<fx", 3 );
DEFINE_STRING( BGl_string4313z00zz__evaluate_compz00, BgL_bgl_string4313za700za7za7_4414za7, ">fx", 3 );
DEFINE_STRING( BGl_string4315z00zz__evaluate_compz00, BgL_bgl_string4315za700za7za7_4415za7, "<=fx", 4 );
extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
DEFINE_STRING( BGl_string4317z00zz__evaluate_compz00, BgL_bgl_string4317za700za7za7_4416za7, ">=fx", 4 );
DEFINE_STRING( BGl_string4319z00zz__evaluate_compz00, BgL_bgl_string4319za700za7za7_4417za7, "=fx", 3 );
extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string4401z00zz__evaluate_compz00, BgL_bgl_string4401za700za7za7_4418za7, "get_profile", 11 );
DEFINE_STRING( BGl_string4321z00zz__evaluate_compz00, BgL_bgl_string4321za700za7za7_4419za7, "+fl", 3 );
extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string4403z00zz__evaluate_compz00, BgL_bgl_string4403za700za7za7_4420za7, "reset_stack", 11 );
DEFINE_STRING( BGl_string4404z00zz__evaluate_compz00, BgL_bgl_string4404za700za7za7_4421za7, "internal error: unknown command", 31 );
DEFINE_STRING( BGl_string4323z00zz__evaluate_compz00, BgL_bgl_string4323za700za7za7_4422za7, "flonum", 6 );
DEFINE_STRING( BGl_string4405z00zz__evaluate_compz00, BgL_bgl_string4405za700za7za7_4423za7, "__evaluate_comp", 15 );
DEFINE_STRING( BGl_string4325z00zz__evaluate_compz00, BgL_bgl_string4325za700za7za7_4424za7, "-fl", 3 );
DEFINE_STRING( BGl_string4327z00zz__evaluate_compz00, BgL_bgl_string4327za700za7za7_4425za7, "*fl", 3 );
DEFINE_STRING( BGl_string4329z00zz__evaluate_compz00, BgL_bgl_string4329za700za7za7_4426za7, "/fl", 3 );
extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string4331z00zz__evaluate_compz00, BgL_bgl_string4331za700za7za7_4427za7, "<fl", 3 );
DEFINE_STRING( BGl_string4333z00zz__evaluate_compz00, BgL_bgl_string4333za700za7za7_4428za7, ">fl", 3 );
DEFINE_STRING( BGl_string4253z00zz__evaluate_compz00, BgL_bgl_string4253za700za7za7_4429za7, "all", 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_findzd2statezd2envz00zz__evaluate_compz00, BgL_bgl_za762findza7d2stateza74430za7, BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string4335z00zz__evaluate_compz00, BgL_bgl_string4335za700za7za7_4431za7, "<=fl", 4 );
DEFINE_STRING( BGl_string4255z00zz__evaluate_compz00, BgL_bgl_string4255za700za7za7_4432za7, "label-tag", 9 );
DEFINE_STRING( BGl_string4337z00zz__evaluate_compz00, BgL_bgl_string4337za700za7za7_4433za7, ">=fl", 4 );
DEFINE_STRING( BGl_string4257z00zz__evaluate_compz00, BgL_bgl_string4257za700za7za7_4434za7, "bounce", 6 );
DEFINE_STRING( BGl_string4339z00zz__evaluate_compz00, BgL_bgl_string4339za700za7za7_4435za7, "=fl", 3 );
DEFINE_STRING( BGl_string4258z00zz__evaluate_compz00, BgL_bgl_string4258za700za7za7_4436za7, "non non non", 11 );
DEFINE_STRING( BGl_string4259z00zz__evaluate_compz00, BgL_bgl_string4259za700za7za7_4437za7, " in ", 4 );
DEFINE_STRING( BGl_string4341z00zz__evaluate_compz00, BgL_bgl_string4341za700za7za7_4438za7, "car", 3 );
DEFINE_STRING( BGl_string4260z00zz__evaluate_compz00, BgL_bgl_string4260za700za7za7_4439za7, "eval", 4 );
DEFINE_STRING( BGl_string4261z00zz__evaluate_compz00, BgL_bgl_string4261za700za7za7_4440za7, "internal error: not found", 25 );
DEFINE_STRING( BGl_string4343z00zz__evaluate_compz00, BgL_bgl_string4343za700za7za7_4441za7, "pair", 4 );
DEFINE_STRING( BGl_string4263z00zz__evaluate_compz00, BgL_bgl_string4263za700za7za7_4442za7, "at", 2 );
DEFINE_STRING( BGl_string4345z00zz__evaluate_compz00, BgL_bgl_string4345za700za7za7_4443za7, "cdr", 3 );
DEFINE_STRING( BGl_string4264z00zz__evaluate_compz00, BgL_bgl_string4264za700za7za7_4444za7, "", 0 );
DEFINE_STRING( BGl_string4265z00zz__evaluate_compz00, BgL_bgl_string4265za700za7za7_4445za7, "/builddir/build/BUILD/bigloo-4.4b/runtime/Eval/evaluate_comp.scm", 64 );
DEFINE_STRING( BGl_string4347z00zz__evaluate_compz00, BgL_bgl_string4347za700za7za7_4446za7, "cadr", 4 );
DEFINE_STRING( BGl_string4266z00zz__evaluate_compz00, BgL_bgl_string4266za700za7za7_4447za7, "&compile", 8 );
DEFINE_STRING( BGl_string4267z00zz__evaluate_compz00, BgL_bgl_string4267za700za7za7_4448za7, "ev_expr", 7 );
DEFINE_STRING( BGl_string4349z00zz__evaluate_compz00, BgL_bgl_string4349za700za7za7_4449za7, "comp1386", 8 );
DEFINE_STRING( BGl_string4268z00zz__evaluate_compz00, BgL_bgl_string4268za700za7za7_4450za7, "expecting ~a, got ~a", 20 );
DEFINE_STRING( BGl_string4269z00zz__evaluate_compz00, BgL_bgl_string4269za700za7za7_4451za7, "wrong number of argument", 24 );
DEFINE_STRING( BGl_string4350z00zz__evaluate_compz00, BgL_bgl_string4350za700za7za7_4452za7, "internal error: not defined for", 31 );
DEFINE_STRING( BGl_string4351z00zz__evaluate_compz00, BgL_bgl_string4351za700za7za7_4453za7, "&comp", 5 );
DEFINE_STRING( BGl_string4271z00zz__evaluate_compz00, BgL_bgl_string4271za700za7za7_4454za7, "mcell", 5 );
DEFINE_STRING( BGl_string4353z00zz__evaluate_compz00, BgL_bgl_string4353za700za7za7_4455za7, "comp", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4348z00zz__evaluate_compz00, BgL_bgl_za762comp1386za762za7za74456z00, BGl_z62comp1386z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4273z00zz__evaluate_compz00, BgL_bgl_string4273za700za7za7_4457za7, "internal", 8 );
DEFINE_STRING( BGl_string4275z00zz__evaluate_compz00, BgL_bgl_string4275za700za7za7_4458za7, "impossible", 10 );
DEFINE_STRING( BGl_string4276z00zz__evaluate_compz00, BgL_bgl_string4276za700za7za7_4459za7, "procedure", 9 );
extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
DEFINE_STRING( BGl_string4278z00zz__evaluate_compz00, BgL_bgl_string4278za700za7za7_4460za7, "user", 4 );
DEFINE_STRING( BGl_string4279z00zz__evaluate_compz00, BgL_bgl_string4279za700za7za7_4461za7, "invalid byte code", 17 );
extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4352z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_tra4462z00, BGl_z62compzd2ev_trap1389zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4354z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_var4463z00, BGl_z62compzd2ev_var1391zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4355z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_set4464z00, BGl_z62compzd2ev_setlocal1393zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4356z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_glo4465z00, BGl_z62compzd2ev_global1395zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4281z00zz__evaluate_compz00, BgL_bgl_string4281za700za7za7_4466za7, "+", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4357z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_set4467z00, BGl_z62compzd2ev_setglobal1397zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4358z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_def4468z00, BGl_z62compzd2ev_defglobal1399zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4283z00zz__evaluate_compz00, BgL_bgl_string4283za700za7za7_4469za7, "number", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4359z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_lit4470z00, BGl_z62compzd2ev_litt1401zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4285z00zz__evaluate_compz00, BgL_bgl_string4285za700za7za7_4471za7, "-", 1 );
DEFINE_STRING( BGl_string4287z00zz__evaluate_compz00, BgL_bgl_string4287za700za7za7_4472za7, "*", 1 );
DEFINE_STRING( BGl_string4289z00zz__evaluate_compz00, BgL_bgl_string4289za700za7za7_4473za7, "/", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4360z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_if14474z00, BGl_z62compzd2ev_if1403zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4361z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_or14475z00, BGl_z62compzd2ev_or1405zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4362z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_and4476z00, BGl_z62compzd2ev_and1407zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4363z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_pro4477z00, BGl_z62compzd2ev_prog21409zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4364z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let4478z00, BGl_z62compzd2ev_let1411zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4365z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let4479z00, BGl_z62compzd2ev_letza21413z12zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4366z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let4480z00, BGl_z62compzd2ev_letrec1415zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4291z00zz__evaluate_compz00, BgL_bgl_string4291za700za7za7_4481za7, "<", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4367z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_bin4482z00, BGl_z62compzd2ev_bindzd2exit1417z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4368z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_unw4483z00, BGl_z62compzd2ev_unwindzd2prote1419z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4293z00zz__evaluate_compz00, BgL_bgl_string4293za700za7za7_4484za7, ">", 1 );
DEFINE_STRING( BGl_string4375z00zz__evaluate_compz00, BgL_bgl_string4375za700za7za7_4485za7, "internal error", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4369z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_wit4486z00, BGl_z62compzd2ev_withzd2handler1421z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4376z00zz__evaluate_compz00, BgL_bgl_string4376za700za7za7_4487za7, "must be dead code", 17 );
DEFINE_STRING( BGl_string4295z00zz__evaluate_compz00, BgL_bgl_string4295za700za7za7_4488za7, "<=", 2 );
DEFINE_STRING( BGl_string4378z00zz__evaluate_compz00, BgL_bgl_string4378za700za7za7_4489za7, "notyet", 6 );
DEFINE_STRING( BGl_string4297z00zz__evaluate_compz00, BgL_bgl_string4297za700za7za7_4490za7, ">=", 2 );
DEFINE_STRING( BGl_string4379z00zz__evaluate_compz00, BgL_bgl_string4379za700za7za7_4491za7, "synchronize", 11 );
DEFINE_STRING( BGl_string4299z00zz__evaluate_compz00, BgL_bgl_string4299za700za7za7_4492za7, "=", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4370z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_syn4493z00, BGl_z62compzd2ev_synchroniza7e1423z17zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4371z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_lab4494z00, BGl_z62compzd2ev_labels1425zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4372z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_got4495z00, BGl_z62compzd2ev_goto1427zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4373z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_app4496z00, BGl_z62compzd2ev_app1429zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4380z00zz__evaluate_compz00, BgL_bgl_string4380za700za7za7_4497za7, "mutex", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4374z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_abs4498z00, BGl_z62compzd2ev_abs1431zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string4381z00zz__evaluate_compz00, BgL_bgl_string4381za700za7za7_4499za7, "set!", 4 );
DEFINE_STRING( BGl_string4382z00zz__evaluate_compz00, BgL_bgl_string4382za700za7za7_4500za7, "read-only variable", 18 );
DEFINE_STRING( BGl_string4383z00zz__evaluate_compz00, BgL_bgl_string4383za700za7za7_4501za7, "\nRedefinition of compiled variable -- ", 38 );
DEFINE_STRING( BGl_string4384z00zz__evaluate_compz00, BgL_bgl_string4384za700za7za7_4502za7, "Unbound variable", 16 );
DEFINE_STRING( BGl_string4386z00zz__evaluate_compz00, BgL_bgl_string4386za700za7za7_4503za7, "@", 1 );
DEFINE_STRING( BGl_string4387z00zz__evaluate_compz00, BgL_bgl_string4387za700za7za7_4504za7, "Uninitialized variable", 22 );
extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4388z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo4505za7, BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4389z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo4506za7, BGl_z62zc3z04anonymousza32830ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string4397z00zz__evaluate_compz00, BgL_bgl_string4397za700za7za7_4507za7, "get_sp", 6 );
DEFINE_STRING( BGl_string4399z00zz__evaluate_compz00, BgL_bgl_string4399za700za7za7_4508za7, "reset_profile", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4390z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo4509za7, BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4391z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo4510za7, BGl_z62zc3z04anonymousza32836ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4392z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo4511za7, BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4393z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo4512za7, BGl_z62zc3z04anonymousza32842ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4394z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo4513za7, BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc4395z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo4514za7, BGl_z62zc3z04anonymousza32848ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
DEFINE_STATIC_BGL_GENERIC( BGl_compzd2envzd2zz__evaluate_compz00, BgL_bgl_za762compza762za7za7__ev4515z00, BGl_z62compz62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol4340z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4342z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4262z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4344z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4346z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4270z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4272z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4274z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4277z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4280z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4282z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4284z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4286z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4288z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4290z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4292z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4294z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4377z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4296z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4298z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4385z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4396z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4398z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4300z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4302z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4304z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4306z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4308z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4310z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4312z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4314z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4316z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4318z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4400z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4320z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4402z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4322z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4324z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4326z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4328z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4330z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4332z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4252z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4334z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4254z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4336z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4256z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol4338z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_comp.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "(\"append-21010\" \"BGl_appendzd221010zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"reset_profile\" \"Eval/evaluate_comp.scm\" 3738) \"BGl_reset_profilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"o->s~0\" \"Eval/evaluate_comp.scm\" 3991) \"BGl_ozd2ze3sze70zd6zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<lexint\" \"Eval/evaluate_comp.scm\" 3822) \"BGl_z62zc3lexintza1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"get_profile\" \"Eval/evaluate_comp.scm\" 4130) \"BGl_get_profilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~1\" \"Eval/evaluate_comp.scm\" 4155) \"BGl_recze71ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"index\" \"Eval/evaluate_comp.scm\" 4323) \"BGl_indexz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"_index\" \"Eval/evaluate_comp.scm\" 4474) \"BGl__indexz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"lname\" \"Eval/evaluate_comp.scm\" 5060) \"BGl_lnamez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"loc-type-error\" \"Eval/evaluate_comp.scm\" 5157) \"BGl_loczd2typezd2errorz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-state\" \"Eval/evaluate_comp.scm\" 5415) \"BGl_makezd2statezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"find-state\" \"Eval/evaluate_comp.scm\" 5531) \"BGl_findzd2statezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&find-state\" \"Eval/evaluate_comp.scm\" 5531) \"BGl_z62findzd2statezb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"compile\" \"Eval/evaluate_comp.scm\" 6974) \"BGl_compilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&compile\" \"Eval/evaluate_comp.scm\" 6974) \"BGl_z62compilez62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"global-fun-value\" \"Eval/evaluate_comp.scm\" 8623) \"BGl_globalzd2funzd2valuez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"catch-goto-trampoline\" \"Eval/evaluate_comp.scm\" 17544) \"BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-boxes-args-on-sp\" \"Eval/evaluate_comp.scm\" 18918) \"BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"sub-stk\" \"Eval/evaluate_comp.scm\" 19526) \"BGl_subzd2stkzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"catch-trampoline\" \"Eval/evaluate_comp.scm\" 20027) \"BGl_catchzd2trampolinezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"check-stack\" \"Eval/evaluate_comp.scm\" 20362) \"BGl_checkzd2stackzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-with-push\" \"Eval/evaluate_comp.scm\" 20432) \"BGl_compzd2withzd2pushz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~0\" \"Eval/evaluate_comp.scm\" 20677) \"BGl_recze70ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"subr-call-with-push\" \"Eval/evaluate_comp.scm\" 20840) \"BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-args-on-sp\" \"Eval/evaluate_comp.scm\" 21077) \"BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-nargs-on-sp\" \"Eval/evaluate_comp.scm\" 21237) \"BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"need-shift\" \"Eval/evaluate_comp.scm\" 23383) \"BGl_needzd2shiftzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-old-call\" \"Eval/evaluate_comp.scm\" 23648) \"BGl_compzd2oldzd2callz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1787>\" \"Eval/evaluate_comp.scm\" 24088) \"BGl_z62zc3z04anonymousza31787ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1811>\" \"Eval/evaluate_comp.scm\" 24088) \"BGl_z62zc3z04anonymousza31811ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1834>\" \"Eval/evaluate_comp.scm\" 24429) \"BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1854>\" \"Eval/evaluate_comp.scm\" 24429) \"BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1876>\" \"Eval/evaluate_comp.scm\" 23861) \"BGl_z62zc3z04anonymousza31876ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1896>\" \"Eval/evaluate_comp.scm\" 23861) \"BGl_z62zc3z04anonymousza31896ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call0\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call0zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1919>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31919ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1921>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31921ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1925>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31925ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1939>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31939ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1955>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31955ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1969>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31969ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call1\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call1zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1985>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31985ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1987>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31987ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1991>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2010>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32010ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2031>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32031ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2050>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32050ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call2\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call2zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2071>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32071ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2073>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32073ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2077>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32077ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2103>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32103ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2131>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32131ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2157>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32157ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call3\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call3zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2186>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2188>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32188ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2192>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32192ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2227>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32227ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2264>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32264ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2299>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32299ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call4\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call4zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2336>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32336ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2338>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32338ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2342>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32342ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2388>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32388ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2436>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32436ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2482>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32482ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"is-constant-fun?\" \"Eval/evaluate_comp.scm\" 28599) \"BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"compile-float-arith\" \"Eval/evaluate_comp.scm\" 29243) \"BGl_compilezd2floatzd2arithz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"eval-float-arith\" \"Eval/evaluate_comp.scm\" 30631) \"BGl_evalzd2floatzd2arithz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"E~0\" \"Eval/evaluate_comp.scm\" 31463) \"BGl_Eze70ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"arith-expression\" \"Eval/evaluate_comp.scm\" 31480) \"BGl_arithzd2expressionzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2651>\" \"Eval/evaluate_comp.scm\" 31744) \"BGl_z62zc3z04anonymousza32651ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"inline-call\" \"Eval/evaluate_comp.scm\" 32671) \"BGl_inlinezd2callzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2655>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32655ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2659>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32659ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2663>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32663ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2667>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32667ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2671>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32671ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2675>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32675ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2679>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32679ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2683>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32683ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2687>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32687ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2691>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32691ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2695>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32695ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2699>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32699ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2703>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32703ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2707>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32707ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2711>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32711ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2715>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32715ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2719>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32719ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2723>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32723ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2727>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32727ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2731>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32731ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2735>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32735ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2739>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32739ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2743>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32743ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2747>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32747ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2751>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32751ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2755>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32755ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2759>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32759ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2763>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2765>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32765ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2768>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32768ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2771>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32771ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2774>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32774ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"cadr?\" \"Eval/evaluate_comp.scm\" 33248) \"BGl_cadrzf3zf3zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"cadrerrv\" \"Eval/evaluate_comp.scm\" 33304) \"BGl_cadrerrvz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"correct\" \"Eval/evaluate_comp.scm\" 34318) \"BGl_correctz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"bind-frame\" \"Eval/evaluate_comp.scm\" 34404) \"BGl_bindzd2framezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-boxes\" \"Eval/evaluate_comp.scm\" 38731) \"BGl_makezd2boxeszd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"free-collect\" \"Eval/evaluate_comp.scm\" 38987) \"BGl_freezd2collectzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"free-restore\" \"Eval/evaluate_comp.scm\" 39257) \"BGl_freezd2restorezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp1386\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_z62comp1386z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_compz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_z62compz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_abs1431\" \"Eval/evaluate_comp.scm\" 38257) \"BGl_z62compzd2ev_abs1431zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3574>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33574ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62mainz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62runz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3585>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33585ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4162\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4162z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4163\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4163z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3599>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33599ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4164\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4164z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4165\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4165z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3611>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33611ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4166\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4166z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4167\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4167z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3523>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4168\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4168z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4169\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4169z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3533>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33533ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4170\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4170z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4171\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4171z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3546>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33546ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4172\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4172z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4173\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4173z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3557>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4174\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4174z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4175\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4175z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3472>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4176\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4176z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4177\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4177z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3482>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4178\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4178z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4179\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4179z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3495>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4180\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4180z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4181\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4181z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3506>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4182\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4182z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4183\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4183z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3425>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33425ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4184\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4184z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4185\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4185z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3434>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33434ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4186\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4186z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4187\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4187z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3446>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33446ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4188\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4188z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4189\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4189z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3456>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33456ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4190\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4190z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4191\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4191z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3378>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33378ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4192\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4192z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4193\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4193z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3387>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4194\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4194z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4195\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4195z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3399>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33399ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4196\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4196z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4197\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4197z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3409>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33409ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4198\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4198z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4199\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4199z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3335>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4200\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4200z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4201\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4201z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3343>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33343ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4202\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4202z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4203\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4203z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3354>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33354ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4204\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4204z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4205\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4205z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3363>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33363ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4206\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4206z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4207\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4207z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3292>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33292ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4208\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4208z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4209\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4209z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3300>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33300ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4210\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4210z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4211\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4211z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3311>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33311ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4212\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4212z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4213\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4213z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3320>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4214\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4214z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4215\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4215z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3253>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4216\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4216z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4217\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4217z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3260>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33260ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4218\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4218z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4219\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4219z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3270>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4220\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4220z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4221\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4221z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3278>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33278ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4222\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4222z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4223\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4223z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3214>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4224\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4224z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4225\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4225z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3221>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33221ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4226\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4226z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4227\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4227z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3231>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4228\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4228z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4229\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4229z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3239>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33239ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4230\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4230z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4231\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4231z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3179>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4232\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4232z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4233\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4233z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3185>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33185ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4234\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4234z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4235\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4235z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3194>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33194ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4236\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4236z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4237\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4237z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3201>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4238\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4238z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4239\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4239z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3629>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4240\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4240z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4241\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4241z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3649>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33649ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4242\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4242z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4243\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4243z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3672>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4244\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4244z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4245\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4245z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3693>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33693ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main4246\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main4246z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run4247\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run4247z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_app1429\" \"Eval/evaluate_comp.scm\" 33872) \"BGl_z62compzd2ev_app1429zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_goto1427\" \"Eval/evaluate_comp.scm\" 17884) \"BGl_z62compzd2ev_goto1427zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3118>\" \"Eval/evaluate_comp.scm\" 18509) \"BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3124>\" \"Eval/evaluate_comp.scm\" 18790) \"BGl_z62zc3z04anonymousza33124ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_labels1425\" \"Eval/evaluate_comp.scm\" 16809) \"BGl_z62compzd2ev_labels1425zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3113>\" \"Eval/evaluate_comp.scm\" 17482) \"BGl_z62zc3z04anonymousza33113ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_synchronize1423\" \"Eval/evaluate_comp.scm\" 16182) \"BGl_z62compzd2ev_synchroniza7e1423z17zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3092>\" \"Eval/evaluate_comp.scm\" 16392) \"BGl_z62zc3z04anonymousza33092ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_with-handler1421\" \"Eval/evaluate_comp.scm\" 15840) \"BGl_z62compzd2ev_withzd2handler1421z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3080>\" \"Eval/evaluate_comp.scm\" 16005) \"BGl_z62zc3z04anonymousza33080ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"<@exit:3086>~0\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_zc3z04exitza33086ze3ze70z60zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3088>\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3089>\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_unwind-prote1419\" \"Eval/evaluate_comp.scm\" 15532) \"BGl_z62compzd2ev_unwindzd2prote1419z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3076>\" \"Eval/evaluate_comp.scm\" 15683) \"BGl_z62zc3z04anonymousza33076ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3077>\" \"Eval/evaluate_comp.scm\" 15752) \"BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_bind-exit1417\" \"Eval/evaluate_comp.scm\" 15077) \"BGl_z62compzd2ev_bindzd2exit1417z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3069>\" \"Eval/evaluate_comp.scm\" 15316) \"BGl_z62zc3z04anonymousza33069ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"<@exit:3070>~0\" \"Eval/evaluate_comp.scm\" 15383) \"BGl_zc3z04exitza33070ze3ze70z60zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&exit\" \"Eval/evaluate_comp.scm\" 15383) \"BGl_z62exitz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_letrec1415\" \"Eval/evaluate_comp.scm\" 14024) \"BGl_z62compzd2ev_letrec1415zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3030>\" \"Eval/evaluate_comp.scm\" 14306) \"BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3043>\" \"Eval/evaluate_comp.scm\" 14662) \"BGl_z62zc3z04anonymousza33043ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_let*1413\" \"Eval/evaluate_comp.scm\" 13529) \"BGl_z62compzd2ev_letza21413z12zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3009>\" \"Eval/evaluate_comp.scm\" 13764) \"BGl_z62zc3z04anonymousza33009ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_let1411\" \"Eval/evaluate_comp.scm\" 12849) \"BGl_z62compzd2ev_let1411zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2988>\" \"Eval/evaluate_comp.scm\" 13176) \"BGl_z62zc3z04anonymousza32988ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_prog21409\" \"Eval/evaluate_comp.scm\" 12655) \"BGl_z62compzd2ev_prog21409zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2985>\" \"Eval/evaluate_comp.scm\" 12785) \"BGl_z62zc3z04anonymousza32985ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_and1407\" \"Eval/evaluate_comp.scm\" 12369) \"BGl_z62compzd2ev_and1407zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2975>\" \"Eval/evaluate_comp.scm\" 12500) \"BGl_z62zc3z04anonymousza32975ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_or1405\" \"Eval/evaluate_comp.scm\" 12111) \"BGl_z62compzd2ev_or1405zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2965>\" \"Eval/evaluate_comp.scm\" 12240) \"BGl_z62zc3z04anonymousza32965ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_if1403\" \"Eval/evaluate_comp.scm\" 11907) \"BGl_z62compzd2ev_if1403zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2960>\" \"Eval/evaluate_comp.scm\" 12044) \"BGl_z62zc3z04anonymousza32960ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_litt1401\" \"Eval/evaluate_comp.scm\" 11788) \"BGl_z62compzd2ev_litt1401zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2959>\" \"Eval/evaluate_comp.scm\" 11867) \"BGl_z62zc3z04anonymousza32959ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_defglobal1399\" \"Eval/evaluate_comp.scm\" 10831) \"BGl_z62compzd2ev_defglobal1399zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2933>\" \"Eval/evaluate_comp.scm\" 10957) \"BGl_z62zc3z04anonymousza32933ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_setglobal1397\" \"Eval/evaluate_comp.scm\" 9970) \"BGl_z62compzd2ev_setglobal1397zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2908>\" \"Eval/evaluate_comp.scm\" 10180) \"BGl_z62zc3z04anonymousza32908ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2913>\" \"Eval/evaluate_comp.scm\" 10353) \"BGl_z62zc3z04anonymousza32913ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2924>\" \"Eval/evaluate_comp.scm\" 10613) \"BGl_z62zc3z04anonymousza32924ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_global1395\" \"Eval/evaluate_comp.scm\" 8830) \"BGl_z62compzd2ev_global1395zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2868>\" \"Eval/evaluate_comp.scm\" 9018) \"BGl_z62zc3z04anonymousza32868ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2870>\" \"Eval/evaluate_comp.scm\" 9111) \"BGl_z62zc3z04anonymousza32870ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2881>\" \"Eval/evaluate_comp.scm\" 9364) \"BGl_z62zc3z04anonymousza32881ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_setlocal1393\" \"Eval/evaluate_comp.scm\" 8242) \"BGl_z62compzd2ev_setlocal1393zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2857>\" \"Eval/evaluate_comp.scm\" 8418) \"BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2861>\" \"Eval/evaluate_comp.scm\" 8525) \"BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_var1391\" \"Eval/evaluate_comp.scm\" 8097) \"BGl_z62compzd2ev_var1391zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2845>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2848>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32848ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2839>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2842>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32842ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2833>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2836>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32836ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2827>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2830>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32830ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2851>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2854>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32854ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_trap1389\" \"Eval/evaluate_comp.scm\" 7340) \"BGl_z62compzd2ev_trap1389zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2818>\" \"Eval/evaluate_comp.scm\" 7442) \"BGl_z62zc3z04anonymousza32818ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long BgL_checksumz00_14070, char * BgL_fromz00_14071)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_compz00(); 
BGl_cnstzd2initzd2zz__evaluate_compz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_compz00(); 
BGl_genericzd2initzd2zz__evaluate_compz00(); 
BGl_methodzd2initzd2zz__evaluate_compz00(); 
BGl_toplevelzd2initzd2zz__evaluate_compz00(); 
return 
BGl_profzd2initzd2zz__evaluate_compz00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_symbol4252z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4253z00zz__evaluate_compz00); 
BGl_symbol4254z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4255z00zz__evaluate_compz00); 
BGl_symbol4256z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4257z00zz__evaluate_compz00); 
BGl_symbol4262z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4263z00zz__evaluate_compz00); 
BGl_symbol4270z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4271z00zz__evaluate_compz00); 
BGl_symbol4272z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4273z00zz__evaluate_compz00); 
BGl_symbol4274z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4275z00zz__evaluate_compz00); 
BGl_symbol4277z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4278z00zz__evaluate_compz00); 
BGl_symbol4280z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4281z00zz__evaluate_compz00); 
BGl_symbol4282z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4283z00zz__evaluate_compz00); 
BGl_symbol4284z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4285z00zz__evaluate_compz00); 
BGl_symbol4286z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4287z00zz__evaluate_compz00); 
BGl_symbol4288z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4289z00zz__evaluate_compz00); 
BGl_symbol4290z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4291z00zz__evaluate_compz00); 
BGl_symbol4292z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4293z00zz__evaluate_compz00); 
BGl_symbol4294z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4295z00zz__evaluate_compz00); 
BGl_symbol4296z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4297z00zz__evaluate_compz00); 
BGl_symbol4298z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4299z00zz__evaluate_compz00); 
BGl_symbol4300z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4301z00zz__evaluate_compz00); 
BGl_symbol4302z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4303z00zz__evaluate_compz00); 
BGl_symbol4304z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4305z00zz__evaluate_compz00); 
BGl_symbol4306z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4307z00zz__evaluate_compz00); 
BGl_symbol4308z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4309z00zz__evaluate_compz00); 
BGl_symbol4310z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4311z00zz__evaluate_compz00); 
BGl_symbol4312z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4313z00zz__evaluate_compz00); 
BGl_symbol4314z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4315z00zz__evaluate_compz00); 
BGl_symbol4316z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4317z00zz__evaluate_compz00); 
BGl_symbol4318z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4319z00zz__evaluate_compz00); 
BGl_symbol4320z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4321z00zz__evaluate_compz00); 
BGl_symbol4322z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4323z00zz__evaluate_compz00); 
BGl_symbol4324z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4325z00zz__evaluate_compz00); 
BGl_symbol4326z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4327z00zz__evaluate_compz00); 
BGl_symbol4328z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4329z00zz__evaluate_compz00); 
BGl_symbol4330z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4331z00zz__evaluate_compz00); 
BGl_symbol4332z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4333z00zz__evaluate_compz00); 
BGl_symbol4334z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4335z00zz__evaluate_compz00); 
BGl_symbol4336z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4337z00zz__evaluate_compz00); 
BGl_symbol4338z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4339z00zz__evaluate_compz00); 
BGl_symbol4340z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4341z00zz__evaluate_compz00); 
BGl_symbol4342z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4343z00zz__evaluate_compz00); 
BGl_symbol4344z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4345z00zz__evaluate_compz00); 
BGl_symbol4346z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4347z00zz__evaluate_compz00); 
BGl_symbol4377z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4378z00zz__evaluate_compz00); 
BGl_symbol4385z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4386z00zz__evaluate_compz00); 
BGl_symbol4396z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4397z00zz__evaluate_compz00); 
BGl_symbol4398z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4399z00zz__evaluate_compz00); 
BGl_symbol4400z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4401z00zz__evaluate_compz00); 
return ( 
BGl_symbol4402z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string4403z00zz__evaluate_compz00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
write_bprof_table();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
{ /* Eval/evaluate_comp.scm 114 */
BGL_LONGLONG_T BgL_arg1498z00_1354;
BgL_arg1498z00_1354 = 
LONG_TO_LLONG(((long)0)); 
{ /* Eval/evaluate_comp.scm 114 */
obj_t BgL_list1499z00_1355;
{ /* Eval/evaluate_comp.scm 114 */
obj_t BgL_arg1501z00_1356;
BgL_arg1501z00_1356 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1498z00_1354), BNIL); 
BgL_list1499z00_1355 = 
MAKE_YOUNG_PAIR(BGl_symbol4252z00zz__evaluate_compz00, BgL_arg1501z00_1356); } 
BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BgL_list1499z00_1355; } } 
BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long)8192); 
BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = 
create_struct(BGl_symbol4254z00zz__evaluate_compz00, 
(int)(((long)0))); 
BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = 
create_struct(BGl_symbol4256z00zz__evaluate_compz00, 
(int)(((long)0))); 
return BUNSPEC;} 

}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__evaluate_compz00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_1357;
BgL_headz00_1357 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_1358;obj_t BgL_tailz00_1359;
BgL_prevz00_1358 = BgL_headz00_1357; 
BgL_tailz00_1359 = BgL_l1z00_1; 
BgL_loopz00_1360:
if(
PAIRP(BgL_tailz00_1359))
{ 
obj_t BgL_newzd2prevzd2_1362;
BgL_newzd2prevzd2_1362 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_1359), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_1358, BgL_newzd2prevzd2_1362); 
{ 
obj_t BgL_tailz00_14147;obj_t BgL_prevz00_14146;
BgL_prevz00_14146 = BgL_newzd2prevzd2_1362; 
BgL_tailz00_14147 = 
CDR(BgL_tailz00_1359); 
BgL_tailz00_1359 = BgL_tailz00_14147; 
BgL_prevz00_1358 = BgL_prevz00_14146; 
goto BgL_loopz00_1360;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_1357);} } } 

}



/* reset_profile */
obj_t BGl_reset_profilez00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 132 */
{ /* Eval/evaluate_comp.scm 133 */
BGL_LONGLONG_T BgL_arg1520z00_1385;
BgL_arg1520z00_1385 = 
LONG_TO_LLONG(((long)0)); 
{ /* Eval/evaluate_comp.scm 133 */
obj_t BgL_list1521z00_1386;
{ /* Eval/evaluate_comp.scm 133 */
obj_t BgL_arg1522z00_1387;
BgL_arg1522z00_1387 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1520z00_1385), BNIL); 
BgL_list1521z00_1386 = 
MAKE_YOUNG_PAIR(BGl_symbol4252z00zz__evaluate_compz00, BgL_arg1522z00_1387); } 
return ( 
BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BgL_list1521z00_1386, BUNSPEC) ;} } } 

}



/* o->s~0 */
obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1396)
{
{ /* Eval/evaluate_comp.scm 141 */
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1396))
{ /* Ieee/fixnum.scm 983 */

return 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
(long)CINT(BgL_vz00_1396), ((long)10));}  else 
{ /* Eval/evaluate_comp.scm 138 */
if(
SYMBOLP(BgL_vz00_1396))
{ /* Eval/evaluate_comp.scm 139 */
obj_t BgL_arg3867z00_6437;
BgL_arg3867z00_6437 = 
SYMBOL_TO_STRING(BgL_vz00_1396); 
return 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg3867z00_6437);}  else 
{ /* Eval/evaluate_comp.scm 139 */
if(
STRINGP(BgL_vz00_1396))
{ /* Eval/evaluate_comp.scm 140 */
return BgL_vz00_1396;}  else 
{ /* Eval/evaluate_comp.scm 140 */
return BGl_string4258z00zz__evaluate_compz00;} } } } 

}



/* &<lexint */
obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_9658, obj_t BgL_t1z00_9659, obj_t BgL_t2z00_9660)
{
{ /* Eval/evaluate_comp.scm 135 */
{ /* Eval/evaluate_comp.scm 138 */
bool_t BgL_tmpz00_14164;
{ /* Eval/evaluate_comp.scm 142 */
obj_t BgL_v1z00_11650;obj_t BgL_v2z00_11651;
BgL_v1z00_11650 = 
CAR(
((obj_t)BgL_t1z00_9659)); 
BgL_v2z00_11651 = 
CAR(
((obj_t)BgL_t2z00_9660)); 
{ /* Eval/evaluate_comp.scm 143 */
bool_t BgL_test4521z00_14169;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_11650))
{ /* Eval/evaluate_comp.scm 143 */
BgL_test4521z00_14169 = 
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v2z00_11651)
; }  else 
{ /* Eval/evaluate_comp.scm 143 */
BgL_test4521z00_14169 = ((bool_t)0)
; } 
if(BgL_test4521z00_14169)
{ /* Eval/evaluate_comp.scm 143 */
BgL_tmpz00_14164 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_11650, BgL_v2z00_11651)
; }  else 
{ /* Eval/evaluate_comp.scm 143 */
BgL_tmpz00_14164 = 
bigloo_string_lt(
BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v1z00_11650), 
BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_11651))
; } } } 
return 
BBOOL(BgL_tmpz00_14164);} } 

}



/* get_profile */
obj_t BGl_get_profilez00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 147 */
BGl_recze71ze7zz__evaluate_compz00(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00); 
return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;} 

}



/* rec~1 */
bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1405)
{
{ /* Eval/evaluate_comp.scm 148 */
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_arg1534z00_1407;obj_t BgL_arg1535z00_1408;
BgL_arg1534z00_1407 = 
CDR(
((obj_t)BgL_tz00_1405)); 
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_arg1536z00_1409;
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_pairz00_6446;
BgL_pairz00_6446 = 
CDR(
((obj_t)BgL_tz00_1405)); 
BgL_arg1536z00_1409 = 
CDR(BgL_pairz00_6446); } 
BgL_arg1535z00_1408 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1536z00_1409); } 
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_tmpz00_14185;
BgL_tmpz00_14185 = 
((obj_t)BgL_arg1534z00_1407); 
SET_CDR(BgL_tmpz00_14185, BgL_arg1535z00_1408); } } 
{ /* Eval/evaluate_comp.scm 150 */
obj_t BgL_g1288z00_1410;
{ /* Eval/evaluate_comp.scm 150 */
obj_t BgL_pairz00_6451;
BgL_pairz00_6451 = 
CDR(
((obj_t)BgL_tz00_1405)); 
BgL_g1288z00_1410 = 
CDR(BgL_pairz00_6451); } 
{ 
obj_t BgL_l1286z00_1412;
BgL_l1286z00_1412 = BgL_g1288z00_1410; 
BgL_zc3z04anonymousza31537ze3z87_1413:
if(
PAIRP(BgL_l1286z00_1412))
{ /* Eval/evaluate_comp.scm 150 */
BGl_recze71ze7zz__evaluate_compz00(
CAR(BgL_l1286z00_1412)); 
{ 
obj_t BgL_l1286z00_14195;
BgL_l1286z00_14195 = 
CDR(BgL_l1286z00_1412); 
BgL_l1286z00_1412 = BgL_l1286z00_14195; 
goto BgL_zc3z04anonymousza31537ze3z87_1413;} }  else 
{ /* Eval/evaluate_comp.scm 150 */
return ((bool_t)1);} } } } 

}



/* index */
obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
{
{ /* Eval/evaluate_comp.scm 156 */
{ 
obj_t BgL_lz00_1420;long BgL_nz00_1421;
BgL_lz00_1420 = BgL_lz00_7; 
BgL_nz00_1421 = ((long)0); 
BgL_zc3z04anonymousza31540ze3z87_1422:
if(
NULLP(BgL_lz00_1420))
{ /* Eval/evaluate_comp.scm 158 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 158 */
if(
(BgL_xz00_6==
CAR(
((obj_t)BgL_lz00_1420))))
{ /* Eval/evaluate_comp.scm 159 */
return 
BINT(BgL_nz00_1421);}  else 
{ 
long BgL_nz00_14207;obj_t BgL_lz00_14204;
BgL_lz00_14204 = 
CDR(
((obj_t)BgL_lz00_1420)); 
BgL_nz00_14207 = 
(BgL_nz00_1421+((long)1)); 
BgL_nz00_1421 = BgL_nz00_14207; 
BgL_lz00_1420 = BgL_lz00_14204; 
goto BgL_zc3z04anonymousza31540ze3z87_1422;} } } } 

}



/* _index */
obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
{
{ /* Eval/evaluate_comp.scm 163 */
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL__ortest_1077z00_1430;
BgL__ortest_1077z00_1430 = 
BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9); 
if(
CBOOL(BgL__ortest_1077z00_1430))
{ /* Eval/evaluate_comp.scm 164 */
return BgL__ortest_1077z00_1430;}  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1549z00_1431;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1550z00_1432;
if(
NULLP(BgL_lz00_9))
{ /* Eval/evaluate_comp.scm 164 */
BgL_arg1550z00_1432 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_head1291z00_1438;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1563z00_1450;
BgL_arg1563z00_1450 = 
BGl_lnamez00zz__evaluate_compz00(
CAR(
((obj_t)BgL_lz00_9))); 
BgL_head1291z00_1438 = 
MAKE_YOUNG_PAIR(BgL_arg1563z00_1450, BNIL); } 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_g1294z00_1439;
BgL_g1294z00_1439 = 
CDR(
((obj_t)BgL_lz00_9)); 
{ 
obj_t BgL_l1289z00_1441;obj_t BgL_tail1292z00_1442;
BgL_l1289z00_1441 = BgL_g1294z00_1439; 
BgL_tail1292z00_1442 = BgL_head1291z00_1438; 
BgL_zc3z04anonymousza31556ze3z87_1443:
if(
NULLP(BgL_l1289z00_1441))
{ /* Eval/evaluate_comp.scm 164 */
BgL_arg1550z00_1432 = BgL_head1291z00_1438; }  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_newtail1293z00_1445;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1559z00_1447;
BgL_arg1559z00_1447 = 
BGl_lnamez00zz__evaluate_compz00(
CAR(
((obj_t)BgL_l1289z00_1441))); 
BgL_newtail1293z00_1445 = 
MAKE_YOUNG_PAIR(BgL_arg1559z00_1447, BNIL); } 
SET_CDR(BgL_tail1292z00_1442, BgL_newtail1293z00_1445); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1558z00_1446;
BgL_arg1558z00_1446 = 
CDR(
((obj_t)BgL_l1289z00_1441)); 
{ 
obj_t BgL_tail1292z00_14230;obj_t BgL_l1289z00_14229;
BgL_l1289z00_14229 = BgL_arg1558z00_1446; 
BgL_tail1292z00_14230 = BgL_newtail1293z00_1445; 
BgL_tail1292z00_1442 = BgL_tail1292z00_14230; 
BgL_l1289z00_1441 = BgL_l1289z00_14229; 
goto BgL_zc3z04anonymousza31556ze3z87_1443;} } } } } } 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_list1551z00_1433;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1553z00_1434;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1554z00_1435;
BgL_arg1554z00_1435 = 
MAKE_YOUNG_PAIR(BgL_arg1550z00_1432, BNIL); 
BgL_arg1553z00_1434 = 
MAKE_YOUNG_PAIR(BGl_string4259z00zz__evaluate_compz00, BgL_arg1554z00_1435); } 
BgL_list1551z00_1433 = 
MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1553z00_1434); } 
BgL_arg1549z00_1431 = BgL_list1551z00_1433; } } 
return 
BGl_errorz00zz__errorz00(BGl_string4260z00zz__evaluate_compz00, BGl_string4261z00zz__evaluate_compz00, BgL_arg1549z00_1431);} } } 

}



/* lname */
obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
{
{ /* Eval/evaluate_comp.scm 188 */
if(
BGl_isazf3zf3zz__objectz00(BgL_vz00_16, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 189 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_16)))->BgL_namez00);}  else 
{ /* Eval/evaluate_comp.scm 189 */
return BgL_vz00_16;} } 

}



/* loc-type-error */
obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17, obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
{
{ /* Eval/evaluate_comp.scm 193 */
{ 
obj_t BgL_fnamez00_1471;obj_t BgL_locz00_1472;
if(
PAIRP(BgL_locz00_20))
{ /* Eval/evaluate_comp.scm 194 */
obj_t BgL_cdrzd2194zd2_1477;
BgL_cdrzd2194zd2_1477 = 
CDR(BgL_locz00_20); 
if(
(
CAR(BgL_locz00_20)==BGl_symbol4262z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 194 */
if(
PAIRP(BgL_cdrzd2194zd2_1477))
{ /* Eval/evaluate_comp.scm 194 */
obj_t BgL_cdrzd2198zd2_1481;
BgL_cdrzd2198zd2_1481 = 
CDR(BgL_cdrzd2194zd2_1477); 
if(
PAIRP(BgL_cdrzd2198zd2_1481))
{ /* Eval/evaluate_comp.scm 194 */
if(
NULLP(
CDR(BgL_cdrzd2198zd2_1481)))
{ /* Eval/evaluate_comp.scm 194 */
BgL_fnamez00_1471 = 
CAR(BgL_cdrzd2194zd2_1477); 
BgL_locz00_1472 = 
CAR(BgL_cdrzd2198zd2_1481); 
return 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19, BgL_fnamez00_1471, BgL_locz00_1472);}  else 
{ /* Eval/evaluate_comp.scm 194 */
BgL_tagzd2187zd2_1474:
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1474;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1474;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1474;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1474;} } } 

}



/* make-state */
obj_t BGl_makezd2statezd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 206 */
{ /* Eval/evaluate_comp.scm 207 */
obj_t BgL_stkz00_1499;
BgL_stkz00_1499 = 
make_vector(((long)8192), BGl_string4264z00zz__evaluate_compz00); 
VECTOR_SET(BgL_stkz00_1499,((long)0),
BINT(((long)2))); 
return BgL_stkz00_1499;} } 

}



/* find-state */
BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 211 */
{ /* Eval/evaluate_comp.scm 212 */
obj_t BgL_sz00_1500;
{ /* Eval/evaluate_comp.scm 212 */
obj_t BgL_tmpz00_14260;
BgL_tmpz00_14260 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_sz00_1500 = 
BGL_ENV_EVSTATE(BgL_tmpz00_14260); } 
if(
VECTORP(BgL_sz00_1500))
{ /* Eval/evaluate_comp.scm 213 */
return BgL_sz00_1500;}  else 
{ /* Eval/evaluate_comp.scm 214 */
obj_t BgL_statez00_1502;
BgL_statez00_1502 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 215 */
obj_t BgL_tmpz00_14266;
BgL_tmpz00_14266 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_tmpz00_14266, BgL_statez00_1502); } 
return BgL_statez00_1502;} } } 

}



/* &find-state */
obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_9661)
{
{ /* Eval/evaluate_comp.scm 211 */
return 
BGl_findzd2statezd2zz__evaluate_compz00();} 

}



/* compile */
BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_34)
{
{ /* Eval/evaluate_comp.scm 273 */
return 
BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);} 

}



/* &compile */
obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_9662, obj_t BgL_ez00_9663)
{
{ /* Eval/evaluate_comp.scm 273 */
{ /* Eval/evaluate_comp.scm 274 */
BgL_ev_exprz00_bglt BgL_auxz00_14271;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_9663, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 274 */
BgL_auxz00_14271 = 
((BgL_ev_exprz00_bglt)BgL_ez00_9663)
; }  else 
{ 
obj_t BgL_auxz00_14275;
BgL_auxz00_14275 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string4265z00zz__evaluate_compz00, 
BINT(((long)7006)), BGl_string4266z00zz__evaluate_compz00, BGl_string4267z00zz__evaluate_compz00, BgL_ez00_9663); 
FAILURE(BgL_auxz00_14275,BFALSE,BFALSE);} 
return 
BGl_compilez00zz__evaluate_compz00(BgL_auxz00_14271);} } 

}



/* global-fun-value */
obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_43)
{
{ /* Eval/evaluate_comp.scm 332 */
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 335 */
obj_t BgL_gz00_1558;
{ /* Eval/evaluate_comp.scm 335 */
obj_t BgL_arg1645z00_1559;obj_t BgL_arg1646z00_1560;
BgL_arg1645z00_1559 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_ez00_43)))->BgL_modz00); 
BgL_arg1646z00_1560 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_ez00_43)))->BgL_namez00); 
BgL_gz00_1558 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg1645z00_1559, BgL_arg1646z00_1560); } 
if(
CBOOL(BgL_gz00_1558))
{ /* Eval/evaluate_comp.scm 336 */
return 
VECTOR_REF(
((obj_t)BgL_gz00_1558),((long)2));}  else 
{ /* Eval/evaluate_comp.scm 336 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 333 */
return BFALSE;} } 

}



/* catch-goto-trampoline */
obj_t BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(obj_t BgL_fz00_78, obj_t BgL_sz00_79)
{
{ /* Eval/evaluate_comp.scm 593 */
{ 
obj_t BgL_fz00_1570;
BgL_fz00_1570 = BgL_fz00_78; 
BgL_zc3z04anonymousza31655ze3z87_1571:
{ /* Eval/evaluate_comp.scm 597 */
obj_t BgL_rz00_1572;
BgL_rz00_1572 = 
PROCEDURE_ENTRY(BgL_fz00_1570)(BgL_fz00_1570, BgL_sz00_79, BEOA); 
{ /* Eval/evaluate_comp.scm 599 */
bool_t BgL_test4539z00_14296;
if(
PROCEDUREP(BgL_rz00_1572))
{ /* Eval/evaluate_comp.scm 599 */
obj_t BgL_arg1661z00_1577;
BgL_arg1661z00_1577 = 
PROCEDURE_ATTR(BgL_rz00_1572); 
if(
STRUCTP(BgL_arg1661z00_1577))
{ /* Eval/evaluate_comp.scm 569 */
BgL_test4539z00_14296 = 
(
STRUCT_KEY(BgL_arg1661z00_1577)==BGl_symbol4254z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 569 */
BgL_test4539z00_14296 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate_comp.scm 599 */
BgL_test4539z00_14296 = ((bool_t)0)
; } 
if(BgL_test4539z00_14296)
{ 
obj_t BgL_fz00_14304;
BgL_fz00_14304 = BgL_rz00_1572; 
BgL_fz00_1570 = BgL_fz00_14304; 
goto BgL_zc3z04anonymousza31655ze3z87_1571;}  else 
{ /* Eval/evaluate_comp.scm 599 */
return BgL_rz00_1572;} } } } } 

}



/* push-boxes-args-on-sp */
obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85, obj_t BgL_locz00_86)
{
{ /* Eval/evaluate_comp.scm 623 */
{ 
obj_t BgL_lz00_1580;obj_t BgL_bsz00_1581;long BgL_spz00_1582;
BgL_lz00_1580 = BgL_argsz00_83; 
BgL_bsz00_1581 = BgL_boxesz00_84; 
BgL_spz00_1582 = BgL_spz00_85; 
BgL_zc3z04anonymousza31662ze3z87_1583:
if(
NULLP(BgL_lz00_1580))
{ /* Eval/evaluate_comp.scm 625 */
if(
NULLP(BgL_bsz00_1581))
{ /* Eval/evaluate_comp.scm 626 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 629 */
obj_t BgL_arg1667z00_1586;
{ /* Eval/evaluate_comp.scm 629 */
long BgL_arg1669z00_1587;long BgL_arg1670z00_1588;
BgL_arg1669z00_1587 = 
bgl_list_length(BgL_boxesz00_84); 
BgL_arg1670z00_1588 = 
bgl_list_length(BgL_argsz00_83); 
{ /* Eval/evaluate_comp.scm 628 */
obj_t BgL_list1671z00_1589;
{ /* Eval/evaluate_comp.scm 628 */
obj_t BgL_arg1674z00_1590;
BgL_arg1674z00_1590 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1670z00_1588), BNIL); 
BgL_list1671z00_1589 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1669z00_1587), BgL_arg1674z00_1590); } 
BgL_arg1667z00_1586 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string4268z00zz__evaluate_compz00, BgL_list1671z00_1589); } } 
return 
BGl_everrorz00zz__everrorz00(BgL_locz00_86, BGl_string4260z00zz__evaluate_compz00, BGl_string4269z00zz__evaluate_compz00, BgL_arg1667z00_1586);} }  else 
{ /* Eval/evaluate_comp.scm 625 */
if(
NULLP(BgL_bsz00_1581))
{ /* Eval/evaluate_comp.scm 633 */
obj_t BgL_arg1677z00_1592;
{ /* Eval/evaluate_comp.scm 633 */
long BgL_arg1678z00_1593;long BgL_arg1680z00_1594;
BgL_arg1678z00_1593 = 
bgl_list_length(BgL_boxesz00_84); 
BgL_arg1680z00_1594 = 
bgl_list_length(BgL_argsz00_83); 
{ /* Eval/evaluate_comp.scm 632 */
obj_t BgL_list1681z00_1595;
{ /* Eval/evaluate_comp.scm 632 */
obj_t BgL_arg1683z00_1596;
BgL_arg1683z00_1596 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1680z00_1594), BNIL); 
BgL_list1681z00_1595 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1678z00_1593), BgL_arg1683z00_1596); } 
BgL_arg1677z00_1592 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string4268z00zz__evaluate_compz00, BgL_list1681z00_1595); } } 
return 
BGl_everrorz00zz__everrorz00(BgL_locz00_86, BGl_string4260z00zz__evaluate_compz00, BGl_string4269z00zz__evaluate_compz00, BgL_arg1677z00_1592);}  else 
{ /* Eval/evaluate_comp.scm 630 */
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_arg1684z00_1597;
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_vz00_1598;
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_fun1686z00_1600;
BgL_fun1686z00_1600 = 
CAR(
((obj_t)BgL_lz00_1580)); 
BgL_vz00_1598 = 
PROCEDURE_ENTRY(BgL_fun1686z00_1600)(BgL_fun1686z00_1600, BgL_sz00_82, BEOA); } 
if(
CBOOL(
CAR(
((obj_t)BgL_bsz00_1581))))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_6488;
BgL_newz00_6488 = 
create_struct(BGl_symbol4270z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_14339;
BgL_tmpz00_14339 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_6488, BgL_tmpz00_14339, BgL_vz00_1598); } 
BgL_arg1684z00_1597 = BgL_newz00_6488; }  else 
{ /* Eval/evaluate_comp.scm 637 */
BgL_arg1684z00_1597 = BgL_vz00_1598; } } 
VECTOR_SET(
((obj_t)BgL_sz00_82),BgL_spz00_1582,BgL_arg1684z00_1597); } 
{ /* Eval/evaluate_comp.scm 640 */
obj_t BgL_arg1687z00_1601;obj_t BgL_arg1688z00_1602;long BgL_arg1689z00_1603;
BgL_arg1687z00_1601 = 
CDR(
((obj_t)BgL_lz00_1580)); 
BgL_arg1688z00_1602 = 
CDR(
((obj_t)BgL_bsz00_1581)); 
BgL_arg1689z00_1603 = 
(BgL_spz00_1582+((long)1)); 
{ 
long BgL_spz00_14351;obj_t BgL_bsz00_14350;obj_t BgL_lz00_14349;
BgL_lz00_14349 = BgL_arg1687z00_1601; 
BgL_bsz00_14350 = BgL_arg1688z00_1602; 
BgL_spz00_14351 = BgL_arg1689z00_1603; 
BgL_spz00_1582 = BgL_spz00_14351; 
BgL_bsz00_1581 = BgL_bsz00_14350; 
BgL_lz00_1580 = BgL_lz00_14349; 
goto BgL_zc3z04anonymousza31662ze3z87_1583;} } } } } } 

}



/* sub-stk */
obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88, obj_t BgL_l2z00_89)
{
{ /* Eval/evaluate_comp.scm 645 */
BGl_subzd2stkzd2zz__evaluate_compz00:
if(
NULLP(BgL_l1z00_88))
{ /* Eval/evaluate_comp.scm 646 */
return BgL_l2z00_89;}  else 
{ /* Eval/evaluate_comp.scm 646 */
if(
(
CAR(
((obj_t)BgL_l1z00_88))==
CAR(
((obj_t)BgL_l2z00_89))))
{ /* Eval/evaluate_comp.scm 649 */
obj_t BgL_arg1694z00_1609;obj_t BgL_arg1695z00_1610;
BgL_arg1694z00_1609 = 
CDR(
((obj_t)BgL_l1z00_88)); 
BgL_arg1695z00_1610 = 
CDR(
((obj_t)BgL_l2z00_89)); 
{ 
obj_t BgL_l2z00_14365;obj_t BgL_l1z00_14364;
BgL_l1z00_14364 = BgL_arg1694z00_1609; 
BgL_l2z00_14365 = BgL_arg1695z00_1610; 
BgL_l2z00_89 = BgL_l2z00_14365; 
BgL_l1z00_88 = BgL_l1z00_14364; 
goto BGl_subzd2stkzd2zz__evaluate_compz00;} }  else 
{ /* Eval/evaluate_comp.scm 647 */
return 
BGl_errorz00zz__errorz00(BGl_string4260z00zz__evaluate_compz00, BGl_symbol4272z00zz__evaluate_compz00, BGl_symbol4274z00zz__evaluate_compz00);} } } 

}



/* catch-trampoline */
obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93, obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
{
{ /* Eval/evaluate_comp.scm 669 */
{ /* Eval/evaluate_comp.scm 670 */
obj_t BgL_savedzd2bpzd2_1621;
BgL_savedzd2bpzd2_1621 = 
VECTOR_REF(
((obj_t)BgL_sz00_94),((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_94),((long)0),BgL_bpz00_95); 
{ 
obj_t BgL_fz00_1623;
BgL_fz00_1623 = BgL_fz00_93; 
BgL_zc3z04anonymousza31706ze3z87_1624:
{ /* Eval/evaluate_comp.scm 673 */
obj_t BgL_rz00_1625;
BgL_rz00_1625 = 
PROCEDURE_ENTRY(BgL_fz00_1623)(BgL_fz00_1623, BgL_sz00_94, BEOA); 
{ /* Eval/evaluate_comp.scm 674 */
bool_t BgL_test4548z00_14375;
if(
PROCEDUREP(BgL_rz00_1625))
{ /* Eval/evaluate_comp.scm 674 */
obj_t BgL_arg1710z00_1630;
BgL_arg1710z00_1630 = 
PROCEDURE_ATTR(BgL_rz00_1625); 
if(
STRUCTP(BgL_arg1710z00_1630))
{ /* Eval/evaluate_comp.scm 654 */
BgL_test4548z00_14375 = 
(
STRUCT_KEY(BgL_arg1710z00_1630)==BGl_symbol4256z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 654 */
BgL_test4548z00_14375 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate_comp.scm 674 */
BgL_test4548z00_14375 = ((bool_t)0)
; } 
if(BgL_test4548z00_14375)
{ 
obj_t BgL_fz00_14383;
BgL_fz00_14383 = BgL_rz00_1625; 
BgL_fz00_1623 = BgL_fz00_14383; 
goto BgL_zc3z04anonymousza31706ze3z87_1624;}  else 
{ /* Eval/evaluate_comp.scm 674 */
VECTOR_SET(
((obj_t)BgL_sz00_94),((long)0),BgL_savedzd2bpzd2_1621); 
return BgL_rz00_1625;} } } } } } 

}



/* check-stack */
bool_t BGl_checkzd2stackzd2zz__evaluate_compz00(obj_t BgL_sz00_114, obj_t BgL_bpz00_115, obj_t BgL_nz00_116)
{
{ /* Eval/evaluate_comp.scm 685 */
return 
(
(
(long)CINT(BgL_bpz00_115)+
(long)CINT(BgL_nz00_116))<
VECTOR_LENGTH(
((obj_t)BgL_sz00_114)));} 

}



/* comp-with-push */
obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117, obj_t BgL_stkz00_118)
{
{ /* Eval/evaluate_comp.scm 688 */
if(
NULLP(BgL_eza2za2_117))
{ /* Eval/evaluate_comp.scm 690 */
return BNIL;}  else 
{ /* Eval/evaluate_comp.scm 692 */
obj_t BgL_arg1726z00_1648;obj_t BgL_arg1727z00_1649;
{ /* Eval/evaluate_comp.scm 692 */
obj_t BgL_arg1728z00_1650;
BgL_arg1728z00_1650 = 
CAR(
((obj_t)BgL_eza2za2_117)); 
BgL_arg1726z00_1648 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg1728z00_1650), BgL_stkz00_118); } 
{ /* Eval/evaluate_comp.scm 693 */
obj_t BgL_arg1729z00_1651;obj_t BgL_arg1730z00_1652;
BgL_arg1729z00_1651 = 
CDR(
((obj_t)BgL_eza2za2_117)); 
{ /* Eval/evaluate_comp.scm 693 */
obj_t BgL_arg1731z00_1653;
BgL_arg1731z00_1653 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
BgL_arg1730z00_1652 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_118, BgL_arg1731z00_1653); } 
BgL_arg1727z00_1649 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1729z00_1651, BgL_arg1730z00_1652); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1726z00_1648, BgL_arg1727z00_1649);} } 

}



/* rec~0 */
obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_11635, obj_t BgL_lz00_1655, long BgL_iz00_1656)
{
{ /* Eval/evaluate_comp.scm 696 */
if(
NULLP(BgL_lz00_1655))
{ /* Eval/evaluate_comp.scm 697 */
return BNIL;}  else 
{ /* Eval/evaluate_comp.scm 697 */
if(
(BgL_iz00_1656==((long)0)))
{ /* Eval/evaluate_comp.scm 698 */
return 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1655, BgL_stkz00_11635);}  else 
{ /* Eval/evaluate_comp.scm 699 */
obj_t BgL_arg1735z00_1660;obj_t BgL_arg1736z00_1661;
{ /* Eval/evaluate_comp.scm 699 */
obj_t BgL_arg1737z00_1662;
BgL_arg1737z00_1662 = 
CAR(
((obj_t)BgL_lz00_1655)); 
BgL_arg1735z00_1660 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg1737z00_1662), BgL_stkz00_11635); } 
{ /* Eval/evaluate_comp.scm 700 */
obj_t BgL_arg1738z00_1663;long BgL_arg1739z00_1664;
BgL_arg1738z00_1663 = 
CDR(
((obj_t)BgL_lz00_1655)); 
BgL_arg1739z00_1664 = 
(BgL_iz00_1656-((long)1)); 
BgL_arg1736z00_1661 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_11635, BgL_arg1738z00_1663, BgL_arg1739z00_1664); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1735z00_1660, BgL_arg1736z00_1661);} } } 

}



/* subr-call-with-push */
obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122, obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125, obj_t BgL_siza7eza7_126)
{
{ /* Eval/evaluate_comp.scm 702 */
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_argsz00_1666;
if(
NULLP(BgL_argsz00_124))
{ /* Eval/evaluate_comp.scm 704 */
BgL_argsz00_1666 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_head1340z00_1671;
BgL_head1340z00_1671 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1338z00_1673;obj_t BgL_tail1341z00_1674;
BgL_l1338z00_1673 = BgL_argsz00_124; 
BgL_tail1341z00_1674 = BgL_head1340z00_1671; 
BgL_zc3z04anonymousza31742ze3z87_1675:
if(
NULLP(BgL_l1338z00_1673))
{ /* Eval/evaluate_comp.scm 704 */
BgL_argsz00_1666 = 
CDR(BgL_head1340z00_1671); }  else 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_newtail1342z00_1677;
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_arg1745z00_1679;
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_az00_1680;
BgL_az00_1680 = 
CAR(
((obj_t)BgL_l1338z00_1673)); 
BgL_arg1745z00_1679 = 
PROCEDURE_ENTRY(BgL_az00_1680)(BgL_az00_1680, BgL_sz00_122, BEOA); } 
BgL_newtail1342z00_1677 = 
MAKE_YOUNG_PAIR(BgL_arg1745z00_1679, BNIL); } 
SET_CDR(BgL_tail1341z00_1674, BgL_newtail1342z00_1677); 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_arg1744z00_1678;
BgL_arg1744z00_1678 = 
CDR(
((obj_t)BgL_l1338z00_1673)); 
{ 
obj_t BgL_tail1341z00_14435;obj_t BgL_l1338z00_14434;
BgL_l1338z00_14434 = BgL_arg1744z00_1678; 
BgL_tail1341z00_14435 = BgL_newtail1342z00_1677; 
BgL_tail1341z00_1674 = BgL_tail1341z00_14435; 
BgL_l1338z00_1673 = BgL_l1338z00_14434; 
goto BgL_zc3z04anonymousza31742ze3z87_1675;} } } } } 
{ /* Eval/evaluate_comp.scm 705 */
long BgL_arg1740z00_1667;
BgL_arg1740z00_1667 = 
(
(long)CINT(BgL_bpz00_125)+
(long)CINT(BgL_siza7eza7_126)); 
VECTOR_SET(
((obj_t)BgL_sz00_122),((long)0),
BINT(BgL_arg1740z00_1667)); } 
{ /* Eval/evaluate_comp.scm 706 */
obj_t BgL_za2za2resza2za2z00_1668;
BgL_za2za2resza2za2z00_1668 = 
apply(BgL_fz00_123, BgL_argsz00_1666); 
VECTOR_SET(
((obj_t)BgL_sz00_122),((long)0),BgL_bpz00_125); 
return BgL_za2za2resza2za2z00_1668;} } } 

}



/* push-args-on-sp */
bool_t BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(obj_t BgL_sz00_127, obj_t BgL_argsz00_128, obj_t BgL_spz00_129)
{
{ /* Eval/evaluate_comp.scm 709 */
{ 
obj_t BgL_lz00_1683;obj_t BgL_spz00_1684;
BgL_lz00_1683 = BgL_argsz00_128; 
BgL_spz00_1684 = BgL_spz00_129; 
BgL_zc3z04anonymousza31746ze3z87_1685:
if(
NULLP(BgL_lz00_1683))
{ /* Eval/evaluate_comp.scm 711 */
return ((bool_t)0);}  else 
{ /* Eval/evaluate_comp.scm 711 */
{ /* Eval/evaluate_comp.scm 712 */
obj_t BgL_arg1748z00_1687;
{ /* Eval/evaluate_comp.scm 712 */
obj_t BgL_fun1749z00_1688;
BgL_fun1749z00_1688 = 
CAR(
((obj_t)BgL_lz00_1683)); 
BgL_arg1748z00_1687 = 
PROCEDURE_ENTRY(BgL_fun1749z00_1688)(BgL_fun1749z00_1688, BgL_sz00_127, BEOA); } 
{ /* Eval/evaluate_comp.scm 712 */
long BgL_kz00_6550;
BgL_kz00_6550 = 
(long)CINT(BgL_spz00_1684); 
VECTOR_SET(
((obj_t)BgL_sz00_127),BgL_kz00_6550,BgL_arg1748z00_1687); } } 
{ /* Eval/evaluate_comp.scm 713 */
obj_t BgL_arg1750z00_1689;long BgL_arg1751z00_1690;
BgL_arg1750z00_1689 = 
CDR(
((obj_t)BgL_lz00_1683)); 
BgL_arg1751z00_1690 = 
(
(long)CINT(BgL_spz00_1684)+((long)1)); 
{ 
obj_t BgL_spz00_14462;obj_t BgL_lz00_14461;
BgL_lz00_14461 = BgL_arg1750z00_1689; 
BgL_spz00_14462 = 
BINT(BgL_arg1751z00_1690); 
BgL_spz00_1684 = BgL_spz00_14462; 
BgL_lz00_1683 = BgL_lz00_14461; 
goto BgL_zc3z04anonymousza31746ze3z87_1685;} } } } } 

}



/* push-nargs-on-sp */
obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132, obj_t BgL_spz00_133)
{
{ /* Eval/evaluate_comp.scm 715 */
{ /* Eval/evaluate_comp.scm 716 */
long BgL_g1146z00_1692;
BgL_g1146z00_1692 = 
(((long)-1)-
(long)CINT(BgL_arityz00_130)); 
{ 
obj_t BgL_lz00_1694;obj_t BgL_spz00_1695;long BgL_nz00_1696;
BgL_lz00_1694 = BgL_argsz00_132; 
BgL_spz00_1695 = BgL_spz00_133; 
BgL_nz00_1696 = BgL_g1146z00_1692; 
BgL_zc3z04anonymousza31752ze3z87_1697:
if(
(BgL_nz00_1696==((long)0)))
{ 
obj_t BgL_lz00_1701;obj_t BgL_rz00_1702;
BgL_lz00_1701 = BgL_lz00_1694; 
BgL_rz00_1702 = BNIL; 
BgL_zc3z04anonymousza31754ze3z87_1703:
if(
NULLP(BgL_lz00_1701))
{ /* Eval/evaluate_comp.scm 720 */
obj_t BgL_arg1756z00_1705;
BgL_arg1756z00_1705 = 
bgl_reverse_bang(BgL_rz00_1702); 
{ /* Eval/evaluate_comp.scm 720 */
long BgL_kz00_6556;
BgL_kz00_6556 = 
(long)CINT(BgL_spz00_1695); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_131),BgL_kz00_6556,BgL_arg1756z00_1705);} }  else 
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_arg1757z00_1706;obj_t BgL_arg1758z00_1707;
BgL_arg1757z00_1706 = 
CDR(
((obj_t)BgL_lz00_1701)); 
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_arg1759z00_1708;
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_fun1760z00_1709;
BgL_fun1760z00_1709 = 
CAR(
((obj_t)BgL_lz00_1701)); 
BgL_arg1759z00_1708 = 
PROCEDURE_ENTRY(BgL_fun1760z00_1709)(BgL_fun1760z00_1709, BgL_sz00_131, BEOA); } 
BgL_arg1758z00_1707 = 
MAKE_YOUNG_PAIR(BgL_arg1759z00_1708, BgL_rz00_1702); } 
{ 
obj_t BgL_rz00_14484;obj_t BgL_lz00_14483;
BgL_lz00_14483 = BgL_arg1757z00_1706; 
BgL_rz00_14484 = BgL_arg1758z00_1707; 
BgL_rz00_1702 = BgL_rz00_14484; 
BgL_lz00_1701 = BgL_lz00_14483; 
goto BgL_zc3z04anonymousza31754ze3z87_1703;} } }  else 
{ /* Eval/evaluate_comp.scm 717 */
{ /* Eval/evaluate_comp.scm 722 */
obj_t BgL_arg1762z00_1711;
{ /* Eval/evaluate_comp.scm 722 */
obj_t BgL_fun1763z00_1712;
BgL_fun1763z00_1712 = 
CAR(
((obj_t)BgL_lz00_1694)); 
BgL_arg1762z00_1711 = 
PROCEDURE_ENTRY(BgL_fun1763z00_1712)(BgL_fun1763z00_1712, BgL_sz00_131, BEOA); } 
{ /* Eval/evaluate_comp.scm 722 */
long BgL_kz00_6561;
BgL_kz00_6561 = 
(long)CINT(BgL_spz00_1695); 
VECTOR_SET(
((obj_t)BgL_sz00_131),BgL_kz00_6561,BgL_arg1762z00_1711); } } 
{ /* Eval/evaluate_comp.scm 723 */
obj_t BgL_arg1764z00_1713;long BgL_arg1765z00_1714;long BgL_arg1766z00_1715;
BgL_arg1764z00_1713 = 
CDR(
((obj_t)BgL_lz00_1694)); 
BgL_arg1765z00_1714 = 
(
(long)CINT(BgL_spz00_1695)+((long)1)); 
BgL_arg1766z00_1715 = 
(BgL_nz00_1696-((long)1)); 
{ 
long BgL_nz00_14502;obj_t BgL_spz00_14500;obj_t BgL_lz00_14499;
BgL_lz00_14499 = BgL_arg1764z00_1713; 
BgL_spz00_14500 = 
BINT(BgL_arg1765z00_1714); 
BgL_nz00_14502 = BgL_arg1766z00_1715; 
BgL_nz00_1696 = BgL_nz00_14502; 
BgL_spz00_1695 = BgL_spz00_14500; 
BgL_lz00_1694 = BgL_lz00_14499; 
goto BgL_zc3z04anonymousza31752ze3z87_1697;} } } } } } 

}



/* need-shift */
bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134, obj_t BgL_stkz00_135)
{
{ /* Eval/evaluate_comp.scm 766 */
{ 
obj_t BgL_lz00_1718;obj_t BgL_stkz00_1719;
BgL_lz00_1718 = BgL_argsz00_134; 
BgL_stkz00_1719 = BgL_stkz00_135; 
BgL_zc3z04anonymousza31767ze3z87_1720:
{ /* Eval/evaluate_comp.scm 770 */
bool_t BgL_test4559z00_14503;
if(
NULLP(BgL_lz00_1718))
{ /* Eval/evaluate_comp.scm 770 */
BgL_test4559z00_14503 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 770 */
BgL_test4559z00_14503 = 
NULLP(BgL_stkz00_1719)
; } 
if(BgL_test4559z00_14503)
{ /* Eval/evaluate_comp.scm 770 */
return ((bool_t)0);}  else 
{ /* Eval/evaluate_comp.scm 772 */
bool_t BgL_test4561z00_14507;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_g1345z00_1737;
BgL_g1345z00_1737 = 
CDR(
((obj_t)BgL_lz00_1718)); 
{ 
obj_t BgL_l1343z00_1739;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_tmpz00_14510;
BgL_l1343z00_1739 = BgL_g1345z00_1737; 
BgL_zc3z04anonymousza31778ze3z87_1740:
if(
NULLP(BgL_l1343z00_1739))
{ /* Eval/evaluate_comp.scm 772 */
BgL_tmpz00_14510 = BFALSE
; }  else 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL__ortest_1346z00_1742;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_ez00_1744;
BgL_ez00_1744 = 
CAR(
((obj_t)BgL_l1343z00_1739)); 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_arg1780z00_1745;obj_t BgL_arg1781z00_1746;
BgL_arg1780z00_1745 = 
CAR(
((obj_t)BgL_stkz00_1719)); 
BgL_arg1781z00_1746 = 
BGl_usez00zz__evaluate_usez00(
((BgL_ev_exprz00_bglt)BgL_ez00_1744), BNIL); 
BgL__ortest_1346z00_1742 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1780z00_1745, BgL_arg1781z00_1746); } } 
if(
CBOOL(BgL__ortest_1346z00_1742))
{ /* Eval/evaluate_comp.scm 772 */
BgL_tmpz00_14510 = BgL__ortest_1346z00_1742
; }  else 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_arg1779z00_1743;
BgL_arg1779z00_1743 = 
CDR(
((obj_t)BgL_l1343z00_1739)); 
{ 
obj_t BgL_l1343z00_14524;
BgL_l1343z00_14524 = BgL_arg1779z00_1743; 
BgL_l1343z00_1739 = BgL_l1343z00_14524; 
goto BgL_zc3z04anonymousza31778ze3z87_1740;} } } 
BgL_test4561z00_14507 = 
CBOOL(BgL_tmpz00_14510); } } } 
if(BgL_test4561z00_14507)
{ /* Eval/evaluate_comp.scm 772 */
return ((bool_t)1);}  else 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_arg1776z00_1735;obj_t BgL_arg1777z00_1736;
BgL_arg1776z00_1735 = 
CDR(
((obj_t)BgL_lz00_1718)); 
BgL_arg1777z00_1736 = 
CDR(
((obj_t)BgL_stkz00_1719)); 
{ 
obj_t BgL_stkz00_14531;obj_t BgL_lz00_14530;
BgL_lz00_14530 = BgL_arg1776z00_1735; 
BgL_stkz00_14531 = BgL_arg1777z00_1736; 
BgL_stkz00_1719 = BgL_stkz00_14531; 
BgL_lz00_1718 = BgL_lz00_14530; 
goto BgL_zc3z04anonymousza31767ze3z87_1720;} } } } } } 

}



/* comp-old-call */
obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt BgL_ez00_136, obj_t BgL_stkz00_137)
{
{ /* Eval/evaluate_comp.scm 776 */
{ /* Eval/evaluate_comp.scm 778 */
long BgL_siza7eza7_1751;long BgL_nbargsz00_1752;obj_t BgL_fz00_1753;obj_t BgL_symbzd2funzd2_1754;
BgL_siza7eza7_1751 = 
bgl_list_length(BgL_stkz00_137); 
BgL_nbargsz00_1752 = 
bgl_list_length(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00)); 
BgL_fz00_1753 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_funz00), BgL_stkz00_137); 
BgL_symbzd2funzd2_1754 = 
BGl_uncompilez00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_funz00)); 
if(
CBOOL(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_tailzf3zf3)))
{ /* Eval/evaluate_comp.scm 780 */
if(
BGl_needzd2shiftzd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137))
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test4566z00_14545;
{ /* Eval/evaluate_comp.scm 787 */
int BgL_arg1831z00_1833;
BgL_arg1831z00_1833 = 
bgl_debug(); 
BgL_test4566z00_14545 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1831z00_1833), 
BINT(((long)0))); } 
if(BgL_test4566z00_14545)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_argsz00_1760;
BgL_argsz00_1760 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_zc3z04anonymousza31787ze3z87_9664;
BgL_zc3z04anonymousza31787ze3z87_9664 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31787ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31787ze3z87_9664, 
(int)(((long)0)), BgL_fz00_1753); 
PROCEDURE_SET(BgL_zc3z04anonymousza31787ze3z87_9664, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31787ze3z87_9664, 
(int)(((long)2)), BgL_symbzd2funzd2_1754); 
PROCEDURE_SET(BgL_zc3z04anonymousza31787ze3z87_9664, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1752)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31787ze3z87_9664, 
(int)(((long)4)), BgL_argsz00_1760); 
PROCEDURE_SET(BgL_zc3z04anonymousza31787ze3z87_9664, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1751)); 
return BgL_zc3z04anonymousza31787ze3z87_9664;} }  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_argsz00_1798;
BgL_argsz00_1798 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_zc3z04anonymousza31811ze3z87_9665;
BgL_zc3z04anonymousza31811ze3z87_9665 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31811ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_9665, 
(int)(((long)0)), BgL_fz00_1753); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_9665, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_9665, 
(int)(((long)2)), BgL_symbzd2funzd2_1754); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_9665, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1752)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_9665, 
(int)(((long)4)), BgL_argsz00_1798); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_9665, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1751)); 
return BgL_zc3z04anonymousza31811ze3z87_9665;} } }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test4567z00_14590;
{ /* Eval/evaluate_comp.scm 795 */
int BgL_arg1872z00_1903;
BgL_arg1872z00_1903 = 
bgl_debug(); 
BgL_test4567z00_14590 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1872z00_1903), 
BINT(((long)0))); } 
if(BgL_test4567z00_14590)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_argsz00_1836;
BgL_argsz00_1836 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137, 
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_siza7eza7_1751); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_zc3z04anonymousza31834ze3z87_9666;
BgL_zc3z04anonymousza31834ze3z87_9666 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_9666, 
(int)(((long)0)), BgL_fz00_1753); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_9666, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_9666, 
(int)(((long)2)), BgL_symbzd2funzd2_1754); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_9666, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1752)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_9666, 
(int)(((long)4)), BgL_argsz00_1836); 
return BgL_zc3z04anonymousza31834ze3z87_9666;} }  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_argsz00_1871;
BgL_argsz00_1871 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137, 
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_siza7eza7_1751); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_zc3z04anonymousza31854ze3z87_9667;
BgL_zc3z04anonymousza31854ze3z87_9667 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_9667, 
(int)(((long)0)), BgL_fz00_1753); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_9667, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_9667, 
(int)(((long)2)), BgL_symbzd2funzd2_1754); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_9667, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1752)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_9667, 
(int)(((long)4)), BgL_argsz00_1871); 
return BgL_zc3z04anonymousza31854ze3z87_9667;} } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test4568z00_14629;
{ /* Eval/evaluate_comp.scm 781 */
int BgL_arg1913z00_1974;
BgL_arg1913z00_1974 = 
bgl_debug(); 
BgL_test4568z00_14629 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1913z00_1974), 
BINT(((long)0))); } 
if(BgL_test4568z00_14629)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_argsz00_1907;
BgL_argsz00_1907 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_zc3z04anonymousza31876ze3z87_9668;
BgL_zc3z04anonymousza31876ze3z87_9668 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31876ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31876ze3z87_9668, 
(int)(((long)0)), BgL_fz00_1753); 
PROCEDURE_SET(BgL_zc3z04anonymousza31876ze3z87_9668, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31876ze3z87_9668, 
(int)(((long)2)), BgL_symbzd2funzd2_1754); 
PROCEDURE_SET(BgL_zc3z04anonymousza31876ze3z87_9668, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1752)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31876ze3z87_9668, 
(int)(((long)4)), BgL_argsz00_1907); 
PROCEDURE_SET(BgL_zc3z04anonymousza31876ze3z87_9668, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1751)); 
return BgL_zc3z04anonymousza31876ze3z87_9668;} }  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_argsz00_1942;
BgL_argsz00_1942 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_zc3z04anonymousza31896ze3z87_9669;
BgL_zc3z04anonymousza31896ze3z87_9669 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31896ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31896ze3z87_9669, 
(int)(((long)0)), BgL_fz00_1753); 
PROCEDURE_SET(BgL_zc3z04anonymousza31896ze3z87_9669, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31896ze3z87_9669, 
(int)(((long)2)), BgL_symbzd2funzd2_1754); 
PROCEDURE_SET(BgL_zc3z04anonymousza31896ze3z87_9669, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1752)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31896ze3z87_9669, 
(int)(((long)4)), BgL_argsz00_1942); 
PROCEDURE_SET(BgL_zc3z04anonymousza31896ze3z87_9669, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1751)); 
return BgL_zc3z04anonymousza31896ze3z87_9669;} } } } } 

}



/* &<@anonymous:1787> */
obj_t BGl_z62zc3z04anonymousza31787ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9670, obj_t BgL_sz00_9677)
{
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_9671;BgL_ev_appz00_bglt BgL_i1154z00_9672;obj_t BgL_symbzd2funzd2_9673;long BgL_nbargsz00_9674;obj_t BgL_argsz00_9675;long BgL_siza7eza7_9676;
BgL_fz00_9671 = 
PROCEDURE_REF(BgL_envz00_9670, 
(int)(((long)0))); 
BgL_i1154z00_9672 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_9670, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_9673 = 
PROCEDURE_REF(BgL_envz00_9670, 
(int)(((long)2))); 
BgL_nbargsz00_9674 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9670, 
(int)(((long)3)))); 
BgL_argsz00_9675 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_9670, 
(int)(((long)4)))); 
BgL_siza7eza7_9676 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9670, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_bpz00_11656;
BgL_bpz00_11656 = 
VECTOR_REF(
((obj_t)BgL_sz00_9677),((long)0)); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_11657;
BgL_fz00_11657 = 
PROCEDURE_ENTRY(BgL_fz00_9671)(BgL_fz00_9671, BgL_sz00_9677, BEOA); 
if(
PROCEDUREP(BgL_fz00_11657))
{ /* Eval/evaluate_comp.scm 787 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9672))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11657); } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ufz00_11658;
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_14700;
BgL_tmpz00_14700 = 
((obj_t)BgL_fz00_11657); 
BgL_ufz00_11658 = 
PROCEDURE_ATTR(BgL_tmpz00_14700); } 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test4572z00_14703;
if(
STRUCTP(BgL_ufz00_11658))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4572z00_14703 = 
(
STRUCT_KEY(BgL_ufz00_11658)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4572z00_14703 = ((bool_t)0)
; } 
if(BgL_test4572z00_14703)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_arityz00_11659;obj_t BgL_runz00_11660;obj_t BgL_sfz00_11661;
BgL_arityz00_11659 = 
STRUCT_REF(BgL_ufz00_11658, 
(int)(((long)0))); 
BgL_runz00_11660 = 
STRUCT_REF(BgL_ufz00_11658, 
(int)(((long)1))); 
BgL_sfz00_11661 = 
STRUCT_REF(BgL_ufz00_11658, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_spz00_11662;
BgL_spz00_11662 = 
(
(long)CINT(BgL_bpz00_11656)+BgL_siza7eza7_9676); 
if(
(
(long)CINT(BgL_arityz00_11659)==BgL_nbargsz00_9674))
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_9677, BgL_argsz00_9675, 
BINT(BgL_spz00_11662)); 
{ /* Eval/evaluate_comp.scm 791 */
long BgL_arg1792z00_11663;
BgL_arg1792z00_11663 = 
(BgL_spz00_11662+BgL_nbargsz00_9674); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_9677, 
(long)CINT(BgL_bpz00_11656), BgL_sz00_9677, 
BINT(BgL_spz00_11662), 
BINT(BgL_arg1792z00_11663)); } }  else 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test4575z00_14726;
if(
(
(long)CINT(BgL_arityz00_11659)>=((long)0)))
{ /* Eval/evaluate_comp.scm 787 */
BgL_test4575z00_14726 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BgL_test4575z00_14726 = 
(
(long)CINT(BgL_arityz00_11659)<
(((long)-1)-BgL_nbargsz00_9674))
; } 
if(BgL_test4575z00_14726)
{ /* Eval/evaluate_comp.scm 787 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9672))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_11658, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_9674), 
CINT(BgL_arityz00_11659)); }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_11659, BgL_sz00_9677, BgL_argsz00_9675, 
BINT(BgL_spz00_11662)); 
{ /* Eval/evaluate_comp.scm 793 */
long BgL_arg1798z00_11664;
BgL_arg1798z00_11664 = 
(BgL_spz00_11662+
(((long)0)-
(long)CINT(BgL_arityz00_11659))); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_9677, 
(long)CINT(BgL_bpz00_11656), BgL_sz00_9677, 
BINT(BgL_spz00_11662), 
BINT(BgL_arg1798z00_11664)); } } } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_z12denvz12_11665;
BgL_z12denvz12_11665 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_14749;
BgL_tmpz00_14749 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9672))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_11665, BgL_tmpz00_14749); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9677, BgL_bpz00_11656, BgL_sfz00_11661))
{ /* Eval/evaluate_comp.scm 787 */
return BgL_runz00_11660;}  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_nsz00_11666;
BgL_nsz00_11666 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_arg1803z00_11667;
BgL_arg1803z00_11667 = 
(
(long)CINT(BgL_bpz00_11656)+BgL_nbargsz00_9674); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11666, ((long)2), BgL_sz00_9677, BgL_bpz00_11656, 
BINT(BgL_arg1803z00_11667)); } 
VECTOR_SET(BgL_nsz00_11666,((long)1),BgL_sz00_9677); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11665, BgL_nsz00_11666); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ez00_11668;
BgL_ez00_11668 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11668, BgL_sz00_9677); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_____rz00_11669;
BgL_____rz00_11669 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11660, BgL_nsz00_11666, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11668); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11665, BgL_sz00_9677); 
return BgL_____rz00_11669;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 787 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11657, 
(int)(BgL_nbargsz00_9674)))
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_auxz00_14772;obj_t BgL_tmpz00_14770;
BgL_auxz00_14772 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9672))->BgL_locz00); 
BgL_tmpz00_14770 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_14770, BgL_auxz00_14772); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_9677, BgL_fz00_11657, BgL_argsz00_9675, BgL_bpz00_11656, 
BINT(BgL_siza7eza7_9676));}  else 
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9672))->BgL_locz00), BgL_symbzd2funzd2_9673, 
(int)(BgL_nbargsz00_9674), 
PROCEDURE_ARITY(BgL_fz00_11657));} } } } } } } } 

}



/* &<@anonymous:1811> */
obj_t BGl_z62zc3z04anonymousza31811ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9678, obj_t BgL_sz00_9685)
{
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_9679;BgL_ev_appz00_bglt BgL_i1154z00_9680;obj_t BgL_symbzd2funzd2_9681;long BgL_nbargsz00_9682;obj_t BgL_argsz00_9683;long BgL_siza7eza7_9684;
BgL_fz00_9679 = 
PROCEDURE_REF(BgL_envz00_9678, 
(int)(((long)0))); 
BgL_i1154z00_9680 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_9678, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_9681 = 
PROCEDURE_REF(BgL_envz00_9678, 
(int)(((long)2))); 
BgL_nbargsz00_9682 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9678, 
(int)(((long)3)))); 
BgL_argsz00_9683 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_9678, 
(int)(((long)4)))); 
BgL_siza7eza7_9684 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9678, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_bpz00_11670;
BgL_bpz00_11670 = 
VECTOR_REF(
((obj_t)BgL_sz00_9685),((long)0)); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_11671;
BgL_fz00_11671 = 
PROCEDURE_ENTRY(BgL_fz00_9679)(BgL_fz00_9679, BgL_sz00_9685, BEOA); 
if(
PROCEDUREP(BgL_fz00_11671))
{ /* Eval/evaluate_comp.scm 787 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9680))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11671); } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ufz00_11672;
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_14807;
BgL_tmpz00_14807 = 
((obj_t)BgL_fz00_11671); 
BgL_ufz00_11672 = 
PROCEDURE_ATTR(BgL_tmpz00_14807); } 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test4580z00_14810;
if(
STRUCTP(BgL_ufz00_11672))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4580z00_14810 = 
(
STRUCT_KEY(BgL_ufz00_11672)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4580z00_14810 = ((bool_t)0)
; } 
if(BgL_test4580z00_14810)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_arityz00_11673;obj_t BgL_runz00_11674;obj_t BgL_sfz00_11675;
BgL_arityz00_11673 = 
STRUCT_REF(BgL_ufz00_11672, 
(int)(((long)0))); 
BgL_runz00_11674 = 
STRUCT_REF(BgL_ufz00_11672, 
(int)(((long)1))); 
BgL_sfz00_11675 = 
STRUCT_REF(BgL_ufz00_11672, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_spz00_11676;
BgL_spz00_11676 = 
(
(long)CINT(BgL_bpz00_11670)+BgL_siza7eza7_9684); 
if(
(
(long)CINT(BgL_arityz00_11673)==BgL_nbargsz00_9682))
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_9685, BgL_argsz00_9683, 
BINT(BgL_spz00_11676)); 
{ /* Eval/evaluate_comp.scm 791 */
long BgL_arg1816z00_11677;
BgL_arg1816z00_11677 = 
(BgL_spz00_11676+BgL_nbargsz00_9682); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_9685, 
(long)CINT(BgL_bpz00_11670), BgL_sz00_9685, 
BINT(BgL_spz00_11676), 
BINT(BgL_arg1816z00_11677)); } }  else 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test4583z00_14833;
if(
(
(long)CINT(BgL_arityz00_11673)>=((long)0)))
{ /* Eval/evaluate_comp.scm 787 */
BgL_test4583z00_14833 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BgL_test4583z00_14833 = 
(
(long)CINT(BgL_arityz00_11673)<
(((long)-1)-BgL_nbargsz00_9682))
; } 
if(BgL_test4583z00_14833)
{ /* Eval/evaluate_comp.scm 787 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9680))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_11672, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_9682), 
CINT(BgL_arityz00_11673)); }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_11673, BgL_sz00_9685, BgL_argsz00_9683, 
BINT(BgL_spz00_11676)); 
{ /* Eval/evaluate_comp.scm 793 */
long BgL_arg1822z00_11678;
BgL_arg1822z00_11678 = 
(BgL_spz00_11676+
(((long)0)-
(long)CINT(BgL_arityz00_11673))); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_9685, 
(long)CINT(BgL_bpz00_11670), BgL_sz00_9685, 
BINT(BgL_spz00_11676), 
BINT(BgL_arg1822z00_11678)); } } } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_z12denvz12_11679;
BgL_z12denvz12_11679 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9685, BgL_bpz00_11670, BgL_sfz00_11675))
{ /* Eval/evaluate_comp.scm 787 */
return BgL_runz00_11674;}  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_nsz00_11680;
BgL_nsz00_11680 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_arg1826z00_11681;
BgL_arg1826z00_11681 = 
(
(long)CINT(BgL_bpz00_11670)+BgL_nbargsz00_9682); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11680, ((long)2), BgL_sz00_9685, BgL_bpz00_11670, 
BINT(BgL_arg1826z00_11681)); } 
VECTOR_SET(BgL_nsz00_11680,((long)1),BgL_sz00_9685); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11679, BgL_nsz00_11680); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ez00_11682;
BgL_ez00_11682 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11682, BgL_sz00_9685); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_____rz00_11683;
BgL_____rz00_11683 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11674, BgL_nsz00_11680, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11682); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11679, BgL_sz00_9685); 
return BgL_____rz00_11683;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 787 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11671, 
(int)(BgL_nbargsz00_9682)))
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_9685, BgL_fz00_11671, BgL_argsz00_9683, BgL_bpz00_11670, 
BINT(BgL_siza7eza7_9684));}  else 
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9680))->BgL_locz00), BgL_symbzd2funzd2_9681, 
(int)(BgL_nbargsz00_9682), 
PROCEDURE_ARITY(BgL_fz00_11671));} } } } } } } } 

}



/* &<@anonymous:1834> */
obj_t BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9686, obj_t BgL_sz00_9692)
{
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_9687;BgL_ev_appz00_bglt BgL_i1154z00_9688;obj_t BgL_symbzd2funzd2_9689;long BgL_nbargsz00_9690;obj_t BgL_argsz00_9691;
BgL_fz00_9687 = 
PROCEDURE_REF(BgL_envz00_9686, 
(int)(((long)0))); 
BgL_i1154z00_9688 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_9686, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_9689 = 
PROCEDURE_REF(BgL_envz00_9686, 
(int)(((long)2))); 
BgL_nbargsz00_9690 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9686, 
(int)(((long)3)))); 
BgL_argsz00_9691 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_9686, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_bpz00_11684;
BgL_bpz00_11684 = 
VECTOR_REF(
((obj_t)BgL_sz00_9692),((long)0)); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_11685;
BgL_fz00_11685 = 
PROCEDURE_ENTRY(BgL_fz00_9687)(BgL_fz00_9687, BgL_sz00_9692, BEOA); 
if(
PROCEDUREP(BgL_fz00_11685))
{ /* Eval/evaluate_comp.scm 795 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9688))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11685); } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ufz00_11686;
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_14903;
BgL_tmpz00_14903 = 
((obj_t)BgL_fz00_11685); 
BgL_ufz00_11686 = 
PROCEDURE_ATTR(BgL_tmpz00_14903); } 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test4588z00_14906;
if(
STRUCTP(BgL_ufz00_11686))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4588z00_14906 = 
(
STRUCT_KEY(BgL_ufz00_11686)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4588z00_14906 = ((bool_t)0)
; } 
if(BgL_test4588z00_14906)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_arityz00_11687;obj_t BgL_runz00_11688;obj_t BgL_sfz00_11689;
BgL_arityz00_11687 = 
STRUCT_REF(BgL_ufz00_11686, 
(int)(((long)0))); 
BgL_runz00_11688 = 
STRUCT_REF(BgL_ufz00_11686, 
(int)(((long)1))); 
BgL_sfz00_11689 = 
STRUCT_REF(BgL_ufz00_11686, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_11687)==BgL_nbargsz00_9690))
{ /* Eval/evaluate_comp.scm 795 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_9692, BgL_argsz00_9691, BgL_bpz00_11684)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test4591z00_14922;
if(
(
(long)CINT(BgL_arityz00_11687)>=((long)0)))
{ /* Eval/evaluate_comp.scm 795 */
BgL_test4591z00_14922 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BgL_test4591z00_14922 = 
(
(long)CINT(BgL_arityz00_11687)<
(((long)-1)-BgL_nbargsz00_9690))
; } 
if(BgL_test4591z00_14922)
{ /* Eval/evaluate_comp.scm 795 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9688))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_11686, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_9690), 
CINT(BgL_arityz00_11687)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_11687, BgL_sz00_9692, BgL_argsz00_9691, BgL_bpz00_11684); } } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_z12denvz12_11690;
BgL_z12denvz12_11690 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_14937;
BgL_tmpz00_14937 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9688))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_11690, BgL_tmpz00_14937); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9692, BgL_bpz00_11684, BgL_sfz00_11689))
{ /* Eval/evaluate_comp.scm 795 */
return BgL_runz00_11688;}  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_nsz00_11691;
BgL_nsz00_11691 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 795 */
long BgL_arg1847z00_11692;
BgL_arg1847z00_11692 = 
(
(long)CINT(BgL_bpz00_11684)+BgL_nbargsz00_9690); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11691, ((long)2), BgL_sz00_9692, BgL_bpz00_11684, 
BINT(BgL_arg1847z00_11692)); } 
VECTOR_SET(BgL_nsz00_11691,((long)1),BgL_sz00_9692); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11690, BgL_nsz00_11691); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ez00_11693;
BgL_ez00_11693 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11693, BgL_sz00_9692); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_____rz00_11694;
BgL_____rz00_11694 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11688, BgL_nsz00_11691, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11693); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11690, BgL_sz00_9692); 
return BgL_____rz00_11694;} } } } }  else 
{ /* Eval/evaluate_comp.scm 795 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11685, 
(int)(BgL_nbargsz00_9690)))
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_auxz00_14960;obj_t BgL_tmpz00_14958;
BgL_auxz00_14960 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9688))->BgL_locz00); 
BgL_tmpz00_14958 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_14958, BgL_auxz00_14960); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_9692, BgL_fz00_11685, BgL_argsz00_9691, BgL_bpz00_11684, 
BINT(BgL_nbargsz00_9690));}  else 
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9688))->BgL_locz00), BgL_symbzd2funzd2_9689, 
(int)(BgL_nbargsz00_9690), 
PROCEDURE_ARITY(BgL_fz00_11685));} } } } } } } } 

}



/* &<@anonymous:1854> */
obj_t BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9693, obj_t BgL_sz00_9699)
{
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_9694;BgL_ev_appz00_bglt BgL_i1154z00_9695;obj_t BgL_symbzd2funzd2_9696;long BgL_nbargsz00_9697;obj_t BgL_argsz00_9698;
BgL_fz00_9694 = 
PROCEDURE_REF(BgL_envz00_9693, 
(int)(((long)0))); 
BgL_i1154z00_9695 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_9693, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_9696 = 
PROCEDURE_REF(BgL_envz00_9693, 
(int)(((long)2))); 
BgL_nbargsz00_9697 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9693, 
(int)(((long)3)))); 
BgL_argsz00_9698 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_9693, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_bpz00_11695;
BgL_bpz00_11695 = 
VECTOR_REF(
((obj_t)BgL_sz00_9699),((long)0)); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_11696;
BgL_fz00_11696 = 
PROCEDURE_ENTRY(BgL_fz00_9694)(BgL_fz00_9694, BgL_sz00_9699, BEOA); 
if(
PROCEDUREP(BgL_fz00_11696))
{ /* Eval/evaluate_comp.scm 795 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9695))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11696); } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ufz00_11697;
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_14992;
BgL_tmpz00_14992 = 
((obj_t)BgL_fz00_11696); 
BgL_ufz00_11697 = 
PROCEDURE_ATTR(BgL_tmpz00_14992); } 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test4596z00_14995;
if(
STRUCTP(BgL_ufz00_11697))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4596z00_14995 = 
(
STRUCT_KEY(BgL_ufz00_11697)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4596z00_14995 = ((bool_t)0)
; } 
if(BgL_test4596z00_14995)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_arityz00_11698;obj_t BgL_runz00_11699;obj_t BgL_sfz00_11700;
BgL_arityz00_11698 = 
STRUCT_REF(BgL_ufz00_11697, 
(int)(((long)0))); 
BgL_runz00_11699 = 
STRUCT_REF(BgL_ufz00_11697, 
(int)(((long)1))); 
BgL_sfz00_11700 = 
STRUCT_REF(BgL_ufz00_11697, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_11698)==BgL_nbargsz00_9697))
{ /* Eval/evaluate_comp.scm 795 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_9699, BgL_argsz00_9698, BgL_bpz00_11695)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test4599z00_15011;
if(
(
(long)CINT(BgL_arityz00_11698)>=((long)0)))
{ /* Eval/evaluate_comp.scm 795 */
BgL_test4599z00_15011 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BgL_test4599z00_15011 = 
(
(long)CINT(BgL_arityz00_11698)<
(((long)-1)-BgL_nbargsz00_9697))
; } 
if(BgL_test4599z00_15011)
{ /* Eval/evaluate_comp.scm 795 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9695))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_11697, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_9697), 
CINT(BgL_arityz00_11698)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_11698, BgL_sz00_9699, BgL_argsz00_9698, BgL_bpz00_11695); } } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_z12denvz12_11701;
BgL_z12denvz12_11701 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9699, BgL_bpz00_11695, BgL_sfz00_11700))
{ /* Eval/evaluate_comp.scm 795 */
return BgL_runz00_11699;}  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_nsz00_11702;
BgL_nsz00_11702 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 795 */
long BgL_arg1867z00_11703;
BgL_arg1867z00_11703 = 
(
(long)CINT(BgL_bpz00_11695)+BgL_nbargsz00_9697); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11702, ((long)2), BgL_sz00_9699, BgL_bpz00_11695, 
BINT(BgL_arg1867z00_11703)); } 
VECTOR_SET(BgL_nsz00_11702,((long)1),BgL_sz00_9699); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11701, BgL_nsz00_11702); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ez00_11704;
BgL_ez00_11704 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11704, BgL_sz00_9699); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_____rz00_11705;
BgL_____rz00_11705 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11699, BgL_nsz00_11702, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11704); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11701, BgL_sz00_9699); 
return BgL_____rz00_11705;} } } } }  else 
{ /* Eval/evaluate_comp.scm 795 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11696, 
(int)(BgL_nbargsz00_9697)))
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_9699, BgL_fz00_11696, BgL_argsz00_9698, BgL_bpz00_11695, 
BINT(BgL_nbargsz00_9697));}  else 
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9695))->BgL_locz00), BgL_symbzd2funzd2_9696, 
(int)(BgL_nbargsz00_9697), 
PROCEDURE_ARITY(BgL_fz00_11696));} } } } } } } } 

}



/* &<@anonymous:1876> */
obj_t BGl_z62zc3z04anonymousza31876ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9700, obj_t BgL_sz00_9707)
{
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_9701;BgL_ev_appz00_bglt BgL_i1154z00_9702;obj_t BgL_symbzd2funzd2_9703;long BgL_nbargsz00_9704;obj_t BgL_argsz00_9705;long BgL_siza7eza7_9706;
BgL_fz00_9701 = 
PROCEDURE_REF(BgL_envz00_9700, 
(int)(((long)0))); 
BgL_i1154z00_9702 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_9700, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_9703 = 
PROCEDURE_REF(BgL_envz00_9700, 
(int)(((long)2))); 
BgL_nbargsz00_9704 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9700, 
(int)(((long)3)))); 
BgL_argsz00_9705 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_9700, 
(int)(((long)4)))); 
BgL_siza7eza7_9706 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9700, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_bpz00_11706;
BgL_bpz00_11706 = 
VECTOR_REF(
((obj_t)BgL_sz00_9707),((long)0)); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_11707;
BgL_fz00_11707 = 
PROCEDURE_ENTRY(BgL_fz00_9701)(BgL_fz00_9701, BgL_sz00_9707, BEOA); 
if(
PROCEDUREP(BgL_fz00_11707))
{ /* Eval/evaluate_comp.scm 781 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9702))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11707); } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ufz00_11708;
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_15076;
BgL_tmpz00_15076 = 
((obj_t)BgL_fz00_11707); 
BgL_ufz00_11708 = 
PROCEDURE_ATTR(BgL_tmpz00_15076); } 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test4604z00_15079;
if(
STRUCTP(BgL_ufz00_11708))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4604z00_15079 = 
(
STRUCT_KEY(BgL_ufz00_11708)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4604z00_15079 = ((bool_t)0)
; } 
if(BgL_test4604z00_15079)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_arityz00_11709;obj_t BgL_runz00_11710;obj_t BgL_sfz00_11711;
BgL_arityz00_11709 = 
STRUCT_REF(BgL_ufz00_11708, 
(int)(((long)0))); 
BgL_runz00_11710 = 
STRUCT_REF(BgL_ufz00_11708, 
(int)(((long)1))); 
BgL_sfz00_11711 = 
STRUCT_REF(BgL_ufz00_11708, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_spz00_11712;
BgL_spz00_11712 = 
(
(long)CINT(BgL_bpz00_11706)+BgL_siza7eza7_9706); 
if(
(
(long)CINT(BgL_arityz00_11709)==BgL_nbargsz00_9704))
{ /* Eval/evaluate_comp.scm 781 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_9707, BgL_argsz00_9705, 
BINT(BgL_spz00_11712))); }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test4607z00_15098;
if(
(
(long)CINT(BgL_arityz00_11709)>=((long)0)))
{ /* Eval/evaluate_comp.scm 781 */
BgL_test4607z00_15098 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BgL_test4607z00_15098 = 
(
(long)CINT(BgL_arityz00_11709)<
(((long)-1)-BgL_nbargsz00_9704))
; } 
if(BgL_test4607z00_15098)
{ /* Eval/evaluate_comp.scm 781 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9702))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_11708, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_9704), 
CINT(BgL_arityz00_11709)); }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_11709, BgL_sz00_9707, BgL_argsz00_9705, 
BINT(BgL_spz00_11712)); } } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_z12denvz12_11713;
BgL_z12denvz12_11713 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_15114;
BgL_tmpz00_15114 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9702))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_11713, BgL_tmpz00_15114); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9707, 
BINT(BgL_spz00_11712), BgL_sfz00_11711))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11710, BgL_sz00_9707, 
BINT(BgL_spz00_11712));}  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_nsz00_11714;
BgL_nsz00_11714 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_arg1889z00_11715;
BgL_arg1889z00_11715 = 
(BgL_spz00_11712+BgL_nbargsz00_9704); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11714, ((long)2), BgL_sz00_9707, 
BINT(BgL_spz00_11712), 
BINT(BgL_arg1889z00_11715)); } 
VECTOR_SET(BgL_nsz00_11714,((long)1),BgL_sz00_9707); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11713, BgL_nsz00_11714); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ez00_11716;
BgL_ez00_11716 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11716, BgL_sz00_9707); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_____rz00_11717;
BgL_____rz00_11717 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11710, BgL_nsz00_11714, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11716); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11713, BgL_sz00_9707); 
return BgL_____rz00_11717;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11707, 
(int)(BgL_nbargsz00_9704)))
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_auxz00_15140;obj_t BgL_tmpz00_15138;
BgL_auxz00_15140 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9702))->BgL_locz00); 
BgL_tmpz00_15138 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15138, BgL_auxz00_15140); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_9707, BgL_fz00_11707, BgL_argsz00_9705, BgL_bpz00_11706, 
BINT(BgL_siza7eza7_9706));}  else 
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9702))->BgL_locz00), BgL_symbzd2funzd2_9703, 
(int)(BgL_nbargsz00_9704), 
PROCEDURE_ARITY(BgL_fz00_11707));} } } } } } } } 

}



/* &<@anonymous:1896> */
obj_t BGl_z62zc3z04anonymousza31896ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9708, obj_t BgL_sz00_9715)
{
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_9709;BgL_ev_appz00_bglt BgL_i1154z00_9710;obj_t BgL_symbzd2funzd2_9711;long BgL_nbargsz00_9712;obj_t BgL_argsz00_9713;long BgL_siza7eza7_9714;
BgL_fz00_9709 = 
PROCEDURE_REF(BgL_envz00_9708, 
(int)(((long)0))); 
BgL_i1154z00_9710 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_9708, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_9711 = 
PROCEDURE_REF(BgL_envz00_9708, 
(int)(((long)2))); 
BgL_nbargsz00_9712 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9708, 
(int)(((long)3)))); 
BgL_argsz00_9713 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_9708, 
(int)(((long)4)))); 
BgL_siza7eza7_9714 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9708, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_bpz00_11718;
BgL_bpz00_11718 = 
VECTOR_REF(
((obj_t)BgL_sz00_9715),((long)0)); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_11719;
BgL_fz00_11719 = 
PROCEDURE_ENTRY(BgL_fz00_9709)(BgL_fz00_9709, BgL_sz00_9715, BEOA); 
if(
PROCEDUREP(BgL_fz00_11719))
{ /* Eval/evaluate_comp.scm 781 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9710))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11719); } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ufz00_11720;
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_15175;
BgL_tmpz00_15175 = 
((obj_t)BgL_fz00_11719); 
BgL_ufz00_11720 = 
PROCEDURE_ATTR(BgL_tmpz00_15175); } 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test4612z00_15178;
if(
STRUCTP(BgL_ufz00_11720))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4612z00_15178 = 
(
STRUCT_KEY(BgL_ufz00_11720)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4612z00_15178 = ((bool_t)0)
; } 
if(BgL_test4612z00_15178)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_arityz00_11721;obj_t BgL_runz00_11722;obj_t BgL_sfz00_11723;
BgL_arityz00_11721 = 
STRUCT_REF(BgL_ufz00_11720, 
(int)(((long)0))); 
BgL_runz00_11722 = 
STRUCT_REF(BgL_ufz00_11720, 
(int)(((long)1))); 
BgL_sfz00_11723 = 
STRUCT_REF(BgL_ufz00_11720, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_spz00_11724;
BgL_spz00_11724 = 
(
(long)CINT(BgL_bpz00_11718)+BgL_siza7eza7_9714); 
if(
(
(long)CINT(BgL_arityz00_11721)==BgL_nbargsz00_9712))
{ /* Eval/evaluate_comp.scm 781 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_9715, BgL_argsz00_9713, 
BINT(BgL_spz00_11724))); }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test4615z00_15197;
if(
(
(long)CINT(BgL_arityz00_11721)>=((long)0)))
{ /* Eval/evaluate_comp.scm 781 */
BgL_test4615z00_15197 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BgL_test4615z00_15197 = 
(
(long)CINT(BgL_arityz00_11721)<
(((long)-1)-BgL_nbargsz00_9712))
; } 
if(BgL_test4615z00_15197)
{ /* Eval/evaluate_comp.scm 781 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9710))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_11720, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_9712), 
CINT(BgL_arityz00_11721)); }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_11721, BgL_sz00_9715, BgL_argsz00_9713, 
BINT(BgL_spz00_11724)); } } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_z12denvz12_11725;
BgL_z12denvz12_11725 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9715, 
BINT(BgL_spz00_11724), BgL_sfz00_11723))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11722, BgL_sz00_9715, 
BINT(BgL_spz00_11724));}  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_nsz00_11726;
BgL_nsz00_11726 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_arg1908z00_11727;
BgL_arg1908z00_11727 = 
(BgL_spz00_11724+BgL_nbargsz00_9712); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11726, ((long)2), BgL_sz00_9715, 
BINT(BgL_spz00_11724), 
BINT(BgL_arg1908z00_11727)); } 
VECTOR_SET(BgL_nsz00_11726,((long)1),BgL_sz00_9715); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11725, BgL_nsz00_11726); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ez00_11728;
BgL_ez00_11728 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11728, BgL_sz00_9715); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_____rz00_11729;
BgL_____rz00_11729 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11722, BgL_nsz00_11726, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11728); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11725, BgL_sz00_9715); 
return BgL_____rz00_11729;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11719, 
(int)(BgL_nbargsz00_9712)))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_9715, BgL_fz00_11719, BgL_argsz00_9713, BgL_bpz00_11718, 
BINT(BgL_siza7eza7_9714));}  else 
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1154z00_9710))->BgL_locz00), BgL_symbzd2funzd2_9711, 
(int)(BgL_nbargsz00_9712), 
PROCEDURE_ARITY(BgL_fz00_11719));} } } } } } } } 

}



/* comp-call0 */
obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138, BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140, obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143, long BgL_siza7eza7_144)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_1978;
BgL_cfunz00_1978 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139, ((long)0), BgL_locz00_138, BgL_symbzd2funzd2_140); 
if(
CBOOL(BgL_cfunz00_1978))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4620z00_15243;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1922z00_1992;
BgL_arg1922z00_1992 = 
bgl_debug(); 
BgL_test4620z00_15243 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1922z00_1992), 
BINT(((long)0))); } 
if(BgL_test4620z00_15243)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31919ze3z87_9716;
BgL_zc3z04anonymousza31919ze3z87_9716 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31919ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31919ze3z87_9716, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_144)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31919ze3z87_9716, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31919ze3z87_9716, 
(int)(((long)2)), BgL_cfunz00_1978); 
return BgL_zc3z04anonymousza31919ze3z87_9716;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31921ze3z87_9717;
BgL_zc3z04anonymousza31921ze3z87_9717 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31921ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31921ze3z87_9717, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_144)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31921ze3z87_9717, 
(int)(((long)1)), BgL_cfunz00_1978); 
return BgL_zc3z04anonymousza31921ze3z87_9717;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_142))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4622z00_15268;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1952z00_2056;
BgL_arg1952z00_2056 = 
bgl_debug(); 
BgL_test4622z00_15268 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1952z00_2056), 
BINT(((long)0))); } 
if(BgL_test4622z00_15268)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31925ze3z87_9718;
BgL_zc3z04anonymousza31925ze3z87_9718 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31925ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31925ze3z87_9718, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31925ze3z87_9718, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31925ze3z87_9718, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31925ze3z87_9718, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31925ze3z87_9718;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31939ze3z87_9719;
BgL_zc3z04anonymousza31939ze3z87_9719 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31939ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31939ze3z87_9719, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31939ze3z87_9719, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31939ze3z87_9719, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31939ze3z87_9719, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31939ze3z87_9719;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4623z00_15297;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1982z00_2120;
BgL_arg1982z00_2120 = 
bgl_debug(); 
BgL_test4623z00_15297 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1982z00_2120), 
BINT(((long)0))); } 
if(BgL_test4623z00_15297)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31955ze3z87_9720;
BgL_zc3z04anonymousza31955ze3z87_9720 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31955ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31955ze3z87_9720, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31955ze3z87_9720, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31955ze3z87_9720, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31955ze3z87_9720, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31955ze3z87_9720;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31969ze3z87_9721;
BgL_zc3z04anonymousza31969ze3z87_9721 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31969ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31969ze3z87_9721, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31969ze3z87_9721, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31969ze3z87_9721, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31969ze3z87_9721, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31969ze3z87_9721;} } } } } 

}



/* &<@anonymous:1919> */
obj_t BGl_z62zc3z04anonymousza31919ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9722, obj_t BgL_sz00_9726)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_siza7eza7_9723;obj_t BgL_locz00_9724;obj_t BgL_cfunz00_9725;
BgL_siza7eza7_9723 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9722, 
(int)(((long)0)))); 
BgL_locz00_9724 = 
PROCEDURE_REF(BgL_envz00_9722, 
(int)(((long)1))); 
BgL_cfunz00_9725 = 
PROCEDURE_REF(BgL_envz00_9722, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11730;
BgL_bpz00_11730 = 
VECTOR_REF(
((obj_t)BgL_sz00_9726),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */

{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11731;
BgL_nbpz00_11731 = 
(
(long)CINT(BgL_bpz00_11730)+BgL_siza7eza7_9723); 
VECTOR_SET(
((obj_t)BgL_sz00_9726),((long)0),
BINT(BgL_nbpz00_11731)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15340;
BgL_tmpz00_15340 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15340, BgL_locz00_9724); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11732;
BgL_rz00_11732 = 
PROCEDURE_ENTRY(BgL_cfunz00_9725)(BgL_cfunz00_9725, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9726),((long)0),BgL_bpz00_11730); 
return BgL_rz00_11732;} } } } } } 

}



/* &<@anonymous:1921> */
obj_t BGl_z62zc3z04anonymousza31921ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9727, obj_t BgL_sz00_9730)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_siza7eza7_9728;obj_t BgL_cfunz00_9729;
BgL_siza7eza7_9728 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9727, 
(int)(((long)0)))); 
BgL_cfunz00_9729 = 
PROCEDURE_REF(BgL_envz00_9727, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11733;
BgL_bpz00_11733 = 
VECTOR_REF(
((obj_t)BgL_sz00_9730),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */

{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11734;
BgL_nbpz00_11734 = 
(
(long)CINT(BgL_bpz00_11733)+BgL_siza7eza7_9728); 
VECTOR_SET(
((obj_t)BgL_sz00_9730),((long)0),
BINT(BgL_nbpz00_11734)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11735;
BgL_rz00_11735 = 
PROCEDURE_ENTRY(BgL_cfunz00_9729)(BgL_cfunz00_9729, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9730),((long)0),BgL_bpz00_11733); 
return BgL_rz00_11735;} } } } } } 

}



/* &<@anonymous:1925> */
obj_t BGl_z62zc3z04anonymousza31925ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9731, obj_t BgL_sz00_9736)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9732;obj_t BgL_locz00_9733;obj_t BgL_symbzd2funzd2_9734;long BgL_siza7eza7_9735;
BgL_funz00_9732 = 
PROCEDURE_REF(BgL_envz00_9731, 
(int)(((long)0))); 
BgL_locz00_9733 = 
PROCEDURE_REF(BgL_envz00_9731, 
(int)(((long)1))); 
BgL_symbzd2funzd2_9734 = 
PROCEDURE_REF(BgL_envz00_9731, 
(int)(((long)2))); 
BgL_siza7eza7_9735 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9731, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11736;
BgL_bpz00_11736 = 
VECTOR_REF(
((obj_t)BgL_sz00_9736),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11737;
BgL_fz00_11737 = 
PROCEDURE_ENTRY(BgL_funz00_9732)(BgL_funz00_9732, BgL_sz00_9736, BEOA); 
if(
PROCEDUREP(BgL_fz00_11737))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9733, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11737); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11738;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15383;
BgL_tmpz00_15383 = 
((obj_t)BgL_fz00_11737); 
BgL_ufz00_11738 = 
PROCEDURE_ATTR(BgL_tmpz00_15383); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4625z00_15386;
if(
STRUCTP(BgL_ufz00_11738))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4625z00_15386 = 
(
STRUCT_KEY(BgL_ufz00_11738)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4625z00_15386 = ((bool_t)0)
; } 
if(BgL_test4625z00_15386)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11739;obj_t BgL_runz00_11740;obj_t BgL_sfz00_11741;
BgL_arityz00_11739 = 
STRUCT_REF(BgL_ufz00_11738, 
(int)(((long)0))); 
BgL_runz00_11740 = 
STRUCT_REF(BgL_ufz00_11738, 
(int)(((long)1))); 
BgL_sfz00_11741 = 
STRUCT_REF(BgL_ufz00_11738, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_11739)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_11739))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11739)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1930z00_11744;obj_t BgL_arg1931z00_11745;
BgL_arg1930z00_11744 = 
(
(long)CINT(BgL_bpz00_11736)+((long)0)); 
BgL_arg1931z00_11745 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9736),BgL_arg1930z00_11744,BgL_arg1931z00_11745); } break;
default: 
BgL_case_else1170z00_11742:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1933z00_11743;
BgL_arg1933z00_11743 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11738), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9733, BgL_arg1933z00_11743, 
(int)(((long)0)), 
CINT(BgL_arityz00_11739)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1170z00_11742;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11746;
BgL_z12denvz12_11746 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_11746, BgL_locz00_9733); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9736, BgL_bpz00_11736, BgL_sfz00_11741))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_11740;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11747;
BgL_nsz00_11747 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1935z00_11748;
BgL_arg1935z00_11748 = 
(
(long)CINT(BgL_bpz00_11736)+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11747, ((long)2), BgL_sz00_9736, BgL_bpz00_11736, 
BINT(BgL_arg1935z00_11748)); } 
VECTOR_SET(BgL_nsz00_11747,((long)1),BgL_sz00_9736); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11746, BgL_nsz00_11747); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11749;
BgL_ez00_11749 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11749, BgL_sz00_9736); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11750;
BgL_____rz00_11750 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11740, BgL_nsz00_11747, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11749); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11746, BgL_sz00_9736); 
return BgL_____rz00_11750;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11737, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11751;
BgL_nbpz00_11751 = 
(
(long)CINT(BgL_bpz00_11736)+BgL_siza7eza7_9735); 
VECTOR_SET(
((obj_t)BgL_sz00_9736),((long)0),
BINT(BgL_nbpz00_11751)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15439;
BgL_tmpz00_15439 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15439, BgL_locz00_9733); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11752;
BgL_rz00_11752 = 
PROCEDURE_ENTRY(BgL_fz00_11737)(BgL_fz00_11737, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9736),((long)0),BgL_bpz00_11736); 
return BgL_rz00_11752;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9733, BgL_symbzd2funzd2_9734, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_11737));} } } } } } } } 

}



/* &<@anonymous:1939> */
obj_t BGl_z62zc3z04anonymousza31939ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9737, obj_t BgL_sz00_9742)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9738;obj_t BgL_locz00_9739;obj_t BgL_symbzd2funzd2_9740;long BgL_siza7eza7_9741;
BgL_funz00_9738 = 
PROCEDURE_REF(BgL_envz00_9737, 
(int)(((long)0))); 
BgL_locz00_9739 = 
PROCEDURE_REF(BgL_envz00_9737, 
(int)(((long)1))); 
BgL_symbzd2funzd2_9740 = 
PROCEDURE_REF(BgL_envz00_9737, 
(int)(((long)2))); 
BgL_siza7eza7_9741 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9737, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11753;
BgL_bpz00_11753 = 
VECTOR_REF(
((obj_t)BgL_sz00_9742),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11754;
BgL_fz00_11754 = 
PROCEDURE_ENTRY(BgL_funz00_9738)(BgL_funz00_9738, BgL_sz00_9742, BEOA); 
if(
PROCEDUREP(BgL_fz00_11754))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9739, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11754); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11755;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15468;
BgL_tmpz00_15468 = 
((obj_t)BgL_fz00_11754); 
BgL_ufz00_11755 = 
PROCEDURE_ATTR(BgL_tmpz00_15468); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4632z00_15471;
if(
STRUCTP(BgL_ufz00_11755))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4632z00_15471 = 
(
STRUCT_KEY(BgL_ufz00_11755)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4632z00_15471 = ((bool_t)0)
; } 
if(BgL_test4632z00_15471)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11756;obj_t BgL_runz00_11757;obj_t BgL_sfz00_11758;
BgL_arityz00_11756 = 
STRUCT_REF(BgL_ufz00_11755, 
(int)(((long)0))); 
BgL_runz00_11757 = 
STRUCT_REF(BgL_ufz00_11755, 
(int)(((long)1))); 
BgL_sfz00_11758 = 
STRUCT_REF(BgL_ufz00_11755, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_11756)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_11756))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11756)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1944z00_11761;obj_t BgL_arg1945z00_11762;
BgL_arg1944z00_11761 = 
(
(long)CINT(BgL_bpz00_11753)+((long)0)); 
BgL_arg1945z00_11762 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9742),BgL_arg1944z00_11761,BgL_arg1945z00_11762); } break;
default: 
BgL_case_else1172z00_11759:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1947z00_11760;
BgL_arg1947z00_11760 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11755), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9739, BgL_arg1947z00_11760, 
(int)(((long)0)), 
CINT(BgL_arityz00_11756)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1172z00_11759;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11763;
BgL_z12denvz12_11763 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9742, BgL_bpz00_11753, BgL_sfz00_11758))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_11757;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11764;
BgL_nsz00_11764 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1949z00_11765;
BgL_arg1949z00_11765 = 
(
(long)CINT(BgL_bpz00_11753)+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11764, ((long)2), BgL_sz00_9742, BgL_bpz00_11753, 
BINT(BgL_arg1949z00_11765)); } 
VECTOR_SET(BgL_nsz00_11764,((long)1),BgL_sz00_9742); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11763, BgL_nsz00_11764); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11766;
BgL_ez00_11766 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11766, BgL_sz00_9742); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11767;
BgL_____rz00_11767 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11757, BgL_nsz00_11764, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11766); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11763, BgL_sz00_9742); 
return BgL_____rz00_11767;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11754, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11768;
BgL_nbpz00_11768 = 
(
(long)CINT(BgL_bpz00_11753)+BgL_siza7eza7_9741); 
VECTOR_SET(
((obj_t)BgL_sz00_9742),((long)0),
BINT(BgL_nbpz00_11768)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11769;
BgL_rz00_11769 = 
PROCEDURE_ENTRY(BgL_fz00_11754)(BgL_fz00_11754, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9742),((long)0),BgL_bpz00_11753); 
return BgL_rz00_11769;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9739, BgL_symbzd2funzd2_9740, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_11754));} } } } } } } } 

}



/* &<@anonymous:1955> */
obj_t BGl_z62zc3z04anonymousza31955ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9743, obj_t BgL_sz00_9748)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9744;obj_t BgL_locz00_9745;obj_t BgL_symbzd2funzd2_9746;long BgL_siza7eza7_9747;
BgL_funz00_9744 = 
PROCEDURE_REF(BgL_envz00_9743, 
(int)(((long)0))); 
BgL_locz00_9745 = 
PROCEDURE_REF(BgL_envz00_9743, 
(int)(((long)1))); 
BgL_symbzd2funzd2_9746 = 
PROCEDURE_REF(BgL_envz00_9743, 
(int)(((long)2))); 
BgL_siza7eza7_9747 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9743, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11770;
BgL_bpz00_11770 = 
VECTOR_REF(
((obj_t)BgL_sz00_9748),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11771;
BgL_fz00_11771 = 
PROCEDURE_ENTRY(BgL_funz00_9744)(BgL_funz00_9744, BgL_sz00_9748, BEOA); 
if(
PROCEDUREP(BgL_fz00_11771))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9745, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11771); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11772;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15549;
BgL_tmpz00_15549 = 
((obj_t)BgL_fz00_11771); 
BgL_ufz00_11772 = 
PROCEDURE_ATTR(BgL_tmpz00_15549); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4639z00_15552;
if(
STRUCTP(BgL_ufz00_11772))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4639z00_15552 = 
(
STRUCT_KEY(BgL_ufz00_11772)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4639z00_15552 = ((bool_t)0)
; } 
if(BgL_test4639z00_15552)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11773;obj_t BgL_runz00_11774;obj_t BgL_sfz00_11775;
BgL_arityz00_11773 = 
STRUCT_REF(BgL_ufz00_11772, 
(int)(((long)0))); 
BgL_runz00_11774 = 
STRUCT_REF(BgL_ufz00_11772, 
(int)(((long)1))); 
BgL_sfz00_11775 = 
STRUCT_REF(BgL_ufz00_11772, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_11776;
BgL_spz00_11776 = 
(
(long)CINT(BgL_bpz00_11770)+BgL_siza7eza7_9747); 
if(
(
(long)CINT(BgL_arityz00_11773)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_11773))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11773)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1960z00_11779;obj_t BgL_arg1961z00_11780;
BgL_arg1960z00_11779 = 
(BgL_spz00_11776+((long)0)); 
BgL_arg1961z00_11780 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9748),BgL_arg1960z00_11779,BgL_arg1961z00_11780); } break;
default: 
BgL_case_else1174z00_11777:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1963z00_11778;
BgL_arg1963z00_11778 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11772), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9745, BgL_arg1963z00_11778, 
(int)(((long)0)), 
CINT(BgL_arityz00_11773)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1174z00_11777;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11781;
BgL_z12denvz12_11781 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_11781, BgL_locz00_9745); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9748, 
BINT(BgL_spz00_11776), BgL_sfz00_11775))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11774, BgL_sz00_9748, 
BINT(BgL_spz00_11776));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11782;
BgL_nsz00_11782 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1965z00_11783;
BgL_arg1965z00_11783 = 
(BgL_spz00_11776+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11782, ((long)2), BgL_sz00_9748, 
BINT(BgL_spz00_11776), 
BINT(BgL_arg1965z00_11783)); } 
VECTOR_SET(BgL_nsz00_11782,((long)1),BgL_sz00_9748); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11781, BgL_nsz00_11782); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11784;
BgL_ez00_11784 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11784, BgL_sz00_9748); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11785;
BgL_____rz00_11785 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11774, BgL_nsz00_11782, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11784); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11781, BgL_sz00_9748); 
return BgL_____rz00_11785;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11771, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11786;
BgL_nbpz00_11786 = 
(
(long)CINT(BgL_bpz00_11770)+BgL_siza7eza7_9747); 
VECTOR_SET(
((obj_t)BgL_sz00_9748),((long)0),
BINT(BgL_nbpz00_11786)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15609;
BgL_tmpz00_15609 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15609, BgL_locz00_9745); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11787;
BgL_rz00_11787 = 
PROCEDURE_ENTRY(BgL_fz00_11771)(BgL_fz00_11771, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9748),((long)0),BgL_bpz00_11770); 
return BgL_rz00_11787;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9745, BgL_symbzd2funzd2_9746, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_11771));} } } } } } } } 

}



/* &<@anonymous:1969> */
obj_t BGl_z62zc3z04anonymousza31969ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9749, obj_t BgL_sz00_9754)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9750;obj_t BgL_locz00_9751;obj_t BgL_symbzd2funzd2_9752;long BgL_siza7eza7_9753;
BgL_funz00_9750 = 
PROCEDURE_REF(BgL_envz00_9749, 
(int)(((long)0))); 
BgL_locz00_9751 = 
PROCEDURE_REF(BgL_envz00_9749, 
(int)(((long)1))); 
BgL_symbzd2funzd2_9752 = 
PROCEDURE_REF(BgL_envz00_9749, 
(int)(((long)2))); 
BgL_siza7eza7_9753 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9749, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11788;
BgL_bpz00_11788 = 
VECTOR_REF(
((obj_t)BgL_sz00_9754),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11789;
BgL_fz00_11789 = 
PROCEDURE_ENTRY(BgL_funz00_9750)(BgL_funz00_9750, BgL_sz00_9754, BEOA); 
if(
PROCEDUREP(BgL_fz00_11789))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9751, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11789); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11790;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15638;
BgL_tmpz00_15638 = 
((obj_t)BgL_fz00_11789); 
BgL_ufz00_11790 = 
PROCEDURE_ATTR(BgL_tmpz00_15638); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4646z00_15641;
if(
STRUCTP(BgL_ufz00_11790))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4646z00_15641 = 
(
STRUCT_KEY(BgL_ufz00_11790)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4646z00_15641 = ((bool_t)0)
; } 
if(BgL_test4646z00_15641)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11791;obj_t BgL_runz00_11792;obj_t BgL_sfz00_11793;
BgL_arityz00_11791 = 
STRUCT_REF(BgL_ufz00_11790, 
(int)(((long)0))); 
BgL_runz00_11792 = 
STRUCT_REF(BgL_ufz00_11790, 
(int)(((long)1))); 
BgL_sfz00_11793 = 
STRUCT_REF(BgL_ufz00_11790, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_11794;
BgL_spz00_11794 = 
(
(long)CINT(BgL_bpz00_11788)+BgL_siza7eza7_9753); 
if(
(
(long)CINT(BgL_arityz00_11791)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_11791))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11791)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1974z00_11797;obj_t BgL_arg1975z00_11798;
BgL_arg1974z00_11797 = 
(BgL_spz00_11794+((long)0)); 
BgL_arg1975z00_11798 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9754),BgL_arg1974z00_11797,BgL_arg1975z00_11798); } break;
default: 
BgL_case_else1176z00_11795:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1977z00_11796;
BgL_arg1977z00_11796 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11790), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9751, BgL_arg1977z00_11796, 
(int)(((long)0)), 
CINT(BgL_arityz00_11791)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1176z00_11795;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11799;
BgL_z12denvz12_11799 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9754, 
BINT(BgL_spz00_11794), BgL_sfz00_11793))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11792, BgL_sz00_9754, 
BINT(BgL_spz00_11794));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11800;
BgL_nsz00_11800 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1979z00_11801;
BgL_arg1979z00_11801 = 
(BgL_spz00_11794+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11800, ((long)2), BgL_sz00_9754, 
BINT(BgL_spz00_11794), 
BINT(BgL_arg1979z00_11801)); } 
VECTOR_SET(BgL_nsz00_11800,((long)1),BgL_sz00_9754); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11799, BgL_nsz00_11800); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11802;
BgL_ez00_11802 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11802, BgL_sz00_9754); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11803;
BgL_____rz00_11803 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11792, BgL_nsz00_11800, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11802); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11799, BgL_sz00_9754); 
return BgL_____rz00_11803;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11789, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11804;
BgL_nbpz00_11804 = 
(
(long)CINT(BgL_bpz00_11788)+BgL_siza7eza7_9753); 
VECTOR_SET(
((obj_t)BgL_sz00_9754),((long)0),
BINT(BgL_nbpz00_11804)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11805;
BgL_rz00_11805 = 
PROCEDURE_ENTRY(BgL_fz00_11789)(BgL_fz00_11789, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9754),((long)0),BgL_bpz00_11788); 
return BgL_rz00_11805;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9751, BgL_symbzd2funzd2_9752, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_11789));} } } } } } } } 

}



/* comp-call1 */
obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145, BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147, obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150, long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2121;
BgL_cfunz00_2121 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146, ((long)1), BgL_locz00_145, BgL_symbzd2funzd2_147); 
if(
CBOOL(BgL_cfunz00_2121))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4653z00_15708;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1988z00_2137;
BgL_arg1988z00_2137 = 
bgl_debug(); 
BgL_test4653z00_15708 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1988z00_2137), 
BINT(((long)0))); } 
if(BgL_test4653z00_15708)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31985ze3z87_9755;
BgL_zc3z04anonymousza31985ze3z87_9755 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31985ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31985ze3z87_9755, 
(int)(((long)0)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31985ze3z87_9755, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_151)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31985ze3z87_9755, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza31985ze3z87_9755, 
(int)(((long)3)), BgL_cfunz00_2121); 
return BgL_zc3z04anonymousza31985ze3z87_9755;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31987ze3z87_9756;
BgL_zc3z04anonymousza31987ze3z87_9756 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31987ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31987ze3z87_9756, 
(int)(((long)0)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31987ze3z87_9756, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_151)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31987ze3z87_9756, 
(int)(((long)2)), BgL_cfunz00_2121); 
return BgL_zc3z04anonymousza31987ze3z87_9756;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_149))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4655z00_15737;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2028z00_2213;
BgL_arg2028z00_2213 = 
bgl_debug(); 
BgL_test4655z00_15737 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2028z00_2213), 
BINT(((long)0))); } 
if(BgL_test4655z00_15737)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31991ze3z87_9757;
BgL_zc3z04anonymousza31991ze3z87_9757 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_9757, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_9757, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_9757, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_9757, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_9757, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza31991ze3z87_9757;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32010ze3z87_9758;
BgL_zc3z04anonymousza32010ze3z87_9758 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32010ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32010ze3z87_9758, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza32010ze3z87_9758, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza32010ze3z87_9758, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza32010ze3z87_9758, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza32010ze3z87_9758, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza32010ze3z87_9758;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4656z00_15770;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2068z00_2289;
BgL_arg2068z00_2289 = 
bgl_debug(); 
BgL_test4656z00_15770 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2068z00_2289), 
BINT(((long)0))); } 
if(BgL_test4656z00_15770)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32031ze3z87_9759;
BgL_zc3z04anonymousza32031ze3z87_9759 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32031ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32031ze3z87_9759, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza32031ze3z87_9759, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza32031ze3z87_9759, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza32031ze3z87_9759, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza32031ze3z87_9759, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza32031ze3z87_9759;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32050ze3z87_9760;
BgL_zc3z04anonymousza32050ze3z87_9760 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32050ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32050ze3z87_9760, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza32050ze3z87_9760, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza32050ze3z87_9760, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza32050ze3z87_9760, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza32050ze3z87_9760, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza32050ze3z87_9760;} } } } } 

}



/* &<@anonymous:1985> */
obj_t BGl_z62zc3z04anonymousza31985ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9761, obj_t BgL_sz00_9766)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_9762;long BgL_siza7eza7_9763;obj_t BgL_locz00_9764;obj_t BgL_cfunz00_9765;
BgL_a1z00_9762 = 
PROCEDURE_REF(BgL_envz00_9761, 
(int)(((long)0))); 
BgL_siza7eza7_9763 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9761, 
(int)(((long)1)))); 
BgL_locz00_9764 = 
PROCEDURE_REF(BgL_envz00_9761, 
(int)(((long)2))); 
BgL_cfunz00_9765 = 
PROCEDURE_REF(BgL_envz00_9761, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11806;
BgL_bpz00_11806 = 
VECTOR_REF(
((obj_t)BgL_sz00_9766),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_11807;
BgL_a1z00_11807 = 
PROCEDURE_ENTRY(BgL_a1z00_9762)(BgL_a1z00_9762, BgL_sz00_9766, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11808;
BgL_nbpz00_11808 = 
(
(long)CINT(BgL_bpz00_11806)+BgL_siza7eza7_9763); 
VECTOR_SET(
((obj_t)BgL_sz00_9766),((long)0),
BINT(BgL_nbpz00_11808)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15823;
BgL_tmpz00_15823 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15823, BgL_locz00_9764); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11809;
BgL_rz00_11809 = 
PROCEDURE_ENTRY(BgL_cfunz00_9765)(BgL_cfunz00_9765, BgL_a1z00_11807, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9766),((long)0),BgL_bpz00_11806); 
return BgL_rz00_11809;} } } } } } 

}



/* &<@anonymous:1987> */
obj_t BGl_z62zc3z04anonymousza31987ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9767, obj_t BgL_sz00_9771)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_9768;long BgL_siza7eza7_9769;obj_t BgL_cfunz00_9770;
BgL_a1z00_9768 = 
PROCEDURE_REF(BgL_envz00_9767, 
(int)(((long)0))); 
BgL_siza7eza7_9769 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9767, 
(int)(((long)1)))); 
BgL_cfunz00_9770 = 
PROCEDURE_REF(BgL_envz00_9767, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11810;
BgL_bpz00_11810 = 
VECTOR_REF(
((obj_t)BgL_sz00_9771),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_11811;
BgL_a1z00_11811 = 
PROCEDURE_ENTRY(BgL_a1z00_9768)(BgL_a1z00_9768, BgL_sz00_9771, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11812;
BgL_nbpz00_11812 = 
(
(long)CINT(BgL_bpz00_11810)+BgL_siza7eza7_9769); 
VECTOR_SET(
((obj_t)BgL_sz00_9771),((long)0),
BINT(BgL_nbpz00_11812)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11813;
BgL_rz00_11813 = 
PROCEDURE_ENTRY(BgL_cfunz00_9770)(BgL_cfunz00_9770, BgL_a1z00_11811, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9771),((long)0),BgL_bpz00_11810); 
return BgL_rz00_11813;} } } } } } 

}



/* &<@anonymous:1991> */
obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9772, obj_t BgL_sz00_9778)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9773;obj_t BgL_a1z00_9774;obj_t BgL_locz00_9775;obj_t BgL_symbzd2funzd2_9776;long BgL_siza7eza7_9777;
BgL_funz00_9773 = 
PROCEDURE_REF(BgL_envz00_9772, 
(int)(((long)0))); 
BgL_a1z00_9774 = 
PROCEDURE_REF(BgL_envz00_9772, 
(int)(((long)1))); 
BgL_locz00_9775 = 
PROCEDURE_REF(BgL_envz00_9772, 
(int)(((long)2))); 
BgL_symbzd2funzd2_9776 = 
PROCEDURE_REF(BgL_envz00_9772, 
(int)(((long)3))); 
BgL_siza7eza7_9777 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9772, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11814;
BgL_bpz00_11814 = 
VECTOR_REF(
((obj_t)BgL_sz00_9778),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11815;obj_t BgL_a1z00_11816;
BgL_fz00_11815 = 
PROCEDURE_ENTRY(BgL_funz00_9773)(BgL_funz00_9773, BgL_sz00_9778, BEOA); 
BgL_a1z00_11816 = 
PROCEDURE_ENTRY(BgL_a1z00_9774)(BgL_a1z00_9774, BgL_sz00_9778, BEOA); 
if(
PROCEDUREP(BgL_fz00_11815))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9775, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11815); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11817;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15880;
BgL_tmpz00_15880 = 
((obj_t)BgL_fz00_11815); 
BgL_ufz00_11817 = 
PROCEDURE_ATTR(BgL_tmpz00_15880); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4658z00_15883;
if(
STRUCTP(BgL_ufz00_11817))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4658z00_15883 = 
(
STRUCT_KEY(BgL_ufz00_11817)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4658z00_15883 = ((bool_t)0)
; } 
if(BgL_test4658z00_15883)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11818;obj_t BgL_runz00_11819;obj_t BgL_sfz00_11820;
BgL_arityz00_11818 = 
STRUCT_REF(BgL_ufz00_11817, 
(int)(((long)0))); 
BgL_runz00_11819 = 
STRUCT_REF(BgL_ufz00_11817, 
(int)(((long)1))); 
BgL_sfz00_11820 = 
STRUCT_REF(BgL_ufz00_11817, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_11818)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1995z00_11821;
BgL_arg1995z00_11821 = 
(
(long)CINT(BgL_bpz00_11814)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9778),BgL_arg1995z00_11821,BgL_a1z00_11816); }  else 
{ 

if(
INTEGERP(BgL_arityz00_11818))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11818)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1997z00_11824;obj_t BgL_arg1998z00_11825;
BgL_arg1997z00_11824 = 
(
(long)CINT(BgL_bpz00_11814)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list1999z00_11826;
BgL_list1999z00_11826 = 
MAKE_YOUNG_PAIR(BgL_a1z00_11816, BNIL); 
BgL_arg1998z00_11825 = BgL_list1999z00_11826; } 
VECTOR_SET(
((obj_t)BgL_sz00_9778),BgL_arg1997z00_11824,BgL_arg1998z00_11825); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2000z00_11827;
BgL_arg2000z00_11827 = 
(
(long)CINT(BgL_bpz00_11814)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9778),BgL_arg2000z00_11827,BgL_a1z00_11816); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2001z00_11828;obj_t BgL_arg2002z00_11829;
BgL_arg2001z00_11828 = 
(
(long)CINT(BgL_bpz00_11814)+((long)1)); 
BgL_arg2002z00_11829 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9778),BgL_arg2001z00_11828,BgL_arg2002z00_11829); } break;
default: 
BgL_case_else1178z00_11822:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2004z00_11823;
BgL_arg2004z00_11823 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11817), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9775, BgL_arg2004z00_11823, 
(int)(((long)1)), 
CINT(BgL_arityz00_11818)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1178z00_11822;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11830;
BgL_z12denvz12_11830 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_11830, BgL_locz00_9775); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9778, BgL_bpz00_11814, BgL_sfz00_11820))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_11819;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11831;
BgL_nsz00_11831 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2006z00_11832;
BgL_arg2006z00_11832 = 
(
(long)CINT(BgL_bpz00_11814)+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11831, ((long)2), BgL_sz00_9778, BgL_bpz00_11814, 
BINT(BgL_arg2006z00_11832)); } 
VECTOR_SET(BgL_nsz00_11831,((long)1),BgL_sz00_9778); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11830, BgL_nsz00_11831); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11833;
BgL_ez00_11833 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11833, BgL_sz00_9778); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11834;
BgL_____rz00_11834 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11819, BgL_nsz00_11831, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11833); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11830, BgL_sz00_9778); 
return BgL_____rz00_11834;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11815, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11835;
BgL_nbpz00_11835 = 
(
(long)CINT(BgL_bpz00_11814)+BgL_siza7eza7_9777); 
VECTOR_SET(
((obj_t)BgL_sz00_9778),((long)0),
BINT(BgL_nbpz00_11835)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15949;
BgL_tmpz00_15949 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15949, BgL_locz00_9775); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11836;
BgL_rz00_11836 = 
PROCEDURE_ENTRY(BgL_fz00_11815)(BgL_fz00_11815, BgL_a1z00_11816, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9778),((long)0),BgL_bpz00_11814); 
return BgL_rz00_11836;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9775, BgL_symbzd2funzd2_9776, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_11815));} } } } } } } } 

}



/* &<@anonymous:2010> */
obj_t BGl_z62zc3z04anonymousza32010ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9779, obj_t BgL_sz00_9785)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9780;obj_t BgL_a1z00_9781;obj_t BgL_locz00_9782;obj_t BgL_symbzd2funzd2_9783;long BgL_siza7eza7_9784;
BgL_funz00_9780 = 
PROCEDURE_REF(BgL_envz00_9779, 
(int)(((long)0))); 
BgL_a1z00_9781 = 
PROCEDURE_REF(BgL_envz00_9779, 
(int)(((long)1))); 
BgL_locz00_9782 = 
PROCEDURE_REF(BgL_envz00_9779, 
(int)(((long)2))); 
BgL_symbzd2funzd2_9783 = 
PROCEDURE_REF(BgL_envz00_9779, 
(int)(((long)3))); 
BgL_siza7eza7_9784 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9779, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11837;
BgL_bpz00_11837 = 
VECTOR_REF(
((obj_t)BgL_sz00_9785),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11838;obj_t BgL_a1z00_11839;
BgL_fz00_11838 = 
PROCEDURE_ENTRY(BgL_funz00_9780)(BgL_funz00_9780, BgL_sz00_9785, BEOA); 
BgL_a1z00_11839 = 
PROCEDURE_ENTRY(BgL_a1z00_9781)(BgL_a1z00_9781, BgL_sz00_9785, BEOA); 
if(
PROCEDUREP(BgL_fz00_11838))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9782, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11838); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11840;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_15985;
BgL_tmpz00_15985 = 
((obj_t)BgL_fz00_11838); 
BgL_ufz00_11840 = 
PROCEDURE_ATTR(BgL_tmpz00_15985); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4665z00_15988;
if(
STRUCTP(BgL_ufz00_11840))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4665z00_15988 = 
(
STRUCT_KEY(BgL_ufz00_11840)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4665z00_15988 = ((bool_t)0)
; } 
if(BgL_test4665z00_15988)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11841;obj_t BgL_runz00_11842;obj_t BgL_sfz00_11843;
BgL_arityz00_11841 = 
STRUCT_REF(BgL_ufz00_11840, 
(int)(((long)0))); 
BgL_runz00_11842 = 
STRUCT_REF(BgL_ufz00_11840, 
(int)(((long)1))); 
BgL_sfz00_11843 = 
STRUCT_REF(BgL_ufz00_11840, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_11841)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2014z00_11844;
BgL_arg2014z00_11844 = 
(
(long)CINT(BgL_bpz00_11837)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9785),BgL_arg2014z00_11844,BgL_a1z00_11839); }  else 
{ 

if(
INTEGERP(BgL_arityz00_11841))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11841)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2016z00_11847;obj_t BgL_arg2017z00_11848;
BgL_arg2016z00_11847 = 
(
(long)CINT(BgL_bpz00_11837)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2018z00_11849;
BgL_list2018z00_11849 = 
MAKE_YOUNG_PAIR(BgL_a1z00_11839, BNIL); 
BgL_arg2017z00_11848 = BgL_list2018z00_11849; } 
VECTOR_SET(
((obj_t)BgL_sz00_9785),BgL_arg2016z00_11847,BgL_arg2017z00_11848); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2019z00_11850;
BgL_arg2019z00_11850 = 
(
(long)CINT(BgL_bpz00_11837)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9785),BgL_arg2019z00_11850,BgL_a1z00_11839); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2020z00_11851;obj_t BgL_arg2021z00_11852;
BgL_arg2020z00_11851 = 
(
(long)CINT(BgL_bpz00_11837)+((long)1)); 
BgL_arg2021z00_11852 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9785),BgL_arg2020z00_11851,BgL_arg2021z00_11852); } break;
default: 
BgL_case_else1180z00_11845:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2023z00_11846;
BgL_arg2023z00_11846 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11840), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9782, BgL_arg2023z00_11846, 
(int)(((long)1)), 
CINT(BgL_arityz00_11841)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1180z00_11845;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11853;
BgL_z12denvz12_11853 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9785, BgL_bpz00_11837, BgL_sfz00_11843))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_11842;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11854;
BgL_nsz00_11854 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2025z00_11855;
BgL_arg2025z00_11855 = 
(
(long)CINT(BgL_bpz00_11837)+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11854, ((long)2), BgL_sz00_9785, BgL_bpz00_11837, 
BINT(BgL_arg2025z00_11855)); } 
VECTOR_SET(BgL_nsz00_11854,((long)1),BgL_sz00_9785); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11853, BgL_nsz00_11854); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11856;
BgL_ez00_11856 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11856, BgL_sz00_9785); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11857;
BgL_____rz00_11857 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11842, BgL_nsz00_11854, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11856); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11853, BgL_sz00_9785); 
return BgL_____rz00_11857;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11838, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11858;
BgL_nbpz00_11858 = 
(
(long)CINT(BgL_bpz00_11837)+BgL_siza7eza7_9784); 
VECTOR_SET(
((obj_t)BgL_sz00_9785),((long)0),
BINT(BgL_nbpz00_11858)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11859;
BgL_rz00_11859 = 
PROCEDURE_ENTRY(BgL_fz00_11838)(BgL_fz00_11838, BgL_a1z00_11839, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9785),((long)0),BgL_bpz00_11837); 
return BgL_rz00_11859;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9782, BgL_symbzd2funzd2_9783, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_11838));} } } } } } } } 

}



/* &<@anonymous:2031> */
obj_t BGl_z62zc3z04anonymousza32031ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9786, obj_t BgL_sz00_9792)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9787;obj_t BgL_a1z00_9788;obj_t BgL_locz00_9789;obj_t BgL_symbzd2funzd2_9790;long BgL_siza7eza7_9791;
BgL_funz00_9787 = 
PROCEDURE_REF(BgL_envz00_9786, 
(int)(((long)0))); 
BgL_a1z00_9788 = 
PROCEDURE_REF(BgL_envz00_9786, 
(int)(((long)1))); 
BgL_locz00_9789 = 
PROCEDURE_REF(BgL_envz00_9786, 
(int)(((long)2))); 
BgL_symbzd2funzd2_9790 = 
PROCEDURE_REF(BgL_envz00_9786, 
(int)(((long)3))); 
BgL_siza7eza7_9791 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9786, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11860;
BgL_bpz00_11860 = 
VECTOR_REF(
((obj_t)BgL_sz00_9792),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11861;obj_t BgL_a1z00_11862;
BgL_fz00_11861 = 
PROCEDURE_ENTRY(BgL_funz00_9787)(BgL_funz00_9787, BgL_sz00_9792, BEOA); 
BgL_a1z00_11862 = 
PROCEDURE_ENTRY(BgL_a1z00_9788)(BgL_a1z00_9788, BgL_sz00_9792, BEOA); 
if(
PROCEDUREP(BgL_fz00_11861))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9789, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11861); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11863;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16086;
BgL_tmpz00_16086 = 
((obj_t)BgL_fz00_11861); 
BgL_ufz00_11863 = 
PROCEDURE_ATTR(BgL_tmpz00_16086); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4672z00_16089;
if(
STRUCTP(BgL_ufz00_11863))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4672z00_16089 = 
(
STRUCT_KEY(BgL_ufz00_11863)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4672z00_16089 = ((bool_t)0)
; } 
if(BgL_test4672z00_16089)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11864;obj_t BgL_runz00_11865;obj_t BgL_sfz00_11866;
BgL_arityz00_11864 = 
STRUCT_REF(BgL_ufz00_11863, 
(int)(((long)0))); 
BgL_runz00_11865 = 
STRUCT_REF(BgL_ufz00_11863, 
(int)(((long)1))); 
BgL_sfz00_11866 = 
STRUCT_REF(BgL_ufz00_11863, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_11867;
BgL_spz00_11867 = 
(
(long)CINT(BgL_bpz00_11860)+BgL_siza7eza7_9791); 
if(
(
(long)CINT(BgL_arityz00_11864)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2035z00_11868;
BgL_arg2035z00_11868 = 
(BgL_spz00_11867+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9792),BgL_arg2035z00_11868,BgL_a1z00_11862); }  else 
{ 

if(
INTEGERP(BgL_arityz00_11864))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11864)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2037z00_11871;obj_t BgL_arg2038z00_11872;
BgL_arg2037z00_11871 = 
(BgL_spz00_11867+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2039z00_11873;
BgL_list2039z00_11873 = 
MAKE_YOUNG_PAIR(BgL_a1z00_11862, BNIL); 
BgL_arg2038z00_11872 = BgL_list2039z00_11873; } 
VECTOR_SET(
((obj_t)BgL_sz00_9792),BgL_arg2037z00_11871,BgL_arg2038z00_11872); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2040z00_11874;
BgL_arg2040z00_11874 = 
(BgL_spz00_11867+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9792),BgL_arg2040z00_11874,BgL_a1z00_11862); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2041z00_11875;obj_t BgL_arg2042z00_11876;
BgL_arg2041z00_11875 = 
(BgL_spz00_11867+((long)1)); 
BgL_arg2042z00_11876 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9792),BgL_arg2041z00_11875,BgL_arg2042z00_11876); } break;
default: 
BgL_case_else1182z00_11869:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2044z00_11870;
BgL_arg2044z00_11870 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11863), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9789, BgL_arg2044z00_11870, 
(int)(((long)1)), 
CINT(BgL_arityz00_11864)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1182z00_11869;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11877;
BgL_z12denvz12_11877 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_11877, BgL_locz00_9789); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9792, 
BINT(BgL_spz00_11867), BgL_sfz00_11866))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11865, BgL_sz00_9792, 
BINT(BgL_spz00_11867));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11878;
BgL_nsz00_11878 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2046z00_11879;
BgL_arg2046z00_11879 = 
(BgL_spz00_11867+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11878, ((long)2), BgL_sz00_9792, 
BINT(BgL_spz00_11867), 
BINT(BgL_arg2046z00_11879)); } 
VECTOR_SET(BgL_nsz00_11878,((long)1),BgL_sz00_9792); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11877, BgL_nsz00_11878); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11880;
BgL_ez00_11880 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11880, BgL_sz00_9792); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11881;
BgL_____rz00_11881 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11865, BgL_nsz00_11878, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11880); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11877, BgL_sz00_9792); 
return BgL_____rz00_11881;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11861, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11882;
BgL_nbpz00_11882 = 
(
(long)CINT(BgL_bpz00_11860)+BgL_siza7eza7_9791); 
VECTOR_SET(
((obj_t)BgL_sz00_9792),((long)0),
BINT(BgL_nbpz00_11882)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16156;
BgL_tmpz00_16156 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16156, BgL_locz00_9789); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11883;
BgL_rz00_11883 = 
PROCEDURE_ENTRY(BgL_fz00_11861)(BgL_fz00_11861, BgL_a1z00_11862, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9792),((long)0),BgL_bpz00_11860); 
return BgL_rz00_11883;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9789, BgL_symbzd2funzd2_9790, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_11861));} } } } } } } } 

}



/* &<@anonymous:2050> */
obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9793, obj_t BgL_sz00_9799)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9794;obj_t BgL_a1z00_9795;obj_t BgL_locz00_9796;obj_t BgL_symbzd2funzd2_9797;long BgL_siza7eza7_9798;
BgL_funz00_9794 = 
PROCEDURE_REF(BgL_envz00_9793, 
(int)(((long)0))); 
BgL_a1z00_9795 = 
PROCEDURE_REF(BgL_envz00_9793, 
(int)(((long)1))); 
BgL_locz00_9796 = 
PROCEDURE_REF(BgL_envz00_9793, 
(int)(((long)2))); 
BgL_symbzd2funzd2_9797 = 
PROCEDURE_REF(BgL_envz00_9793, 
(int)(((long)3))); 
BgL_siza7eza7_9798 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9793, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11884;
BgL_bpz00_11884 = 
VECTOR_REF(
((obj_t)BgL_sz00_9799),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11885;obj_t BgL_a1z00_11886;
BgL_fz00_11885 = 
PROCEDURE_ENTRY(BgL_funz00_9794)(BgL_funz00_9794, BgL_sz00_9799, BEOA); 
BgL_a1z00_11886 = 
PROCEDURE_ENTRY(BgL_a1z00_9795)(BgL_a1z00_9795, BgL_sz00_9799, BEOA); 
if(
PROCEDUREP(BgL_fz00_11885))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9796, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11885); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11887;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16192;
BgL_tmpz00_16192 = 
((obj_t)BgL_fz00_11885); 
BgL_ufz00_11887 = 
PROCEDURE_ATTR(BgL_tmpz00_16192); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4679z00_16195;
if(
STRUCTP(BgL_ufz00_11887))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4679z00_16195 = 
(
STRUCT_KEY(BgL_ufz00_11887)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4679z00_16195 = ((bool_t)0)
; } 
if(BgL_test4679z00_16195)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11888;obj_t BgL_runz00_11889;obj_t BgL_sfz00_11890;
BgL_arityz00_11888 = 
STRUCT_REF(BgL_ufz00_11887, 
(int)(((long)0))); 
BgL_runz00_11889 = 
STRUCT_REF(BgL_ufz00_11887, 
(int)(((long)1))); 
BgL_sfz00_11890 = 
STRUCT_REF(BgL_ufz00_11887, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_11891;
BgL_spz00_11891 = 
(
(long)CINT(BgL_bpz00_11884)+BgL_siza7eza7_9798); 
if(
(
(long)CINT(BgL_arityz00_11888)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2054z00_11892;
BgL_arg2054z00_11892 = 
(BgL_spz00_11891+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9799),BgL_arg2054z00_11892,BgL_a1z00_11886); }  else 
{ 

if(
INTEGERP(BgL_arityz00_11888))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11888)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2056z00_11895;obj_t BgL_arg2057z00_11896;
BgL_arg2056z00_11895 = 
(BgL_spz00_11891+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2058z00_11897;
BgL_list2058z00_11897 = 
MAKE_YOUNG_PAIR(BgL_a1z00_11886, BNIL); 
BgL_arg2057z00_11896 = BgL_list2058z00_11897; } 
VECTOR_SET(
((obj_t)BgL_sz00_9799),BgL_arg2056z00_11895,BgL_arg2057z00_11896); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2059z00_11898;
BgL_arg2059z00_11898 = 
(BgL_spz00_11891+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9799),BgL_arg2059z00_11898,BgL_a1z00_11886); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2060z00_11899;obj_t BgL_arg2061z00_11900;
BgL_arg2060z00_11899 = 
(BgL_spz00_11891+((long)1)); 
BgL_arg2061z00_11900 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9799),BgL_arg2060z00_11899,BgL_arg2061z00_11900); } break;
default: 
BgL_case_else1184z00_11893:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2063z00_11894;
BgL_arg2063z00_11894 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11887), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9796, BgL_arg2063z00_11894, 
(int)(((long)1)), 
CINT(BgL_arityz00_11888)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1184z00_11893;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11901;
BgL_z12denvz12_11901 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9799, 
BINT(BgL_spz00_11891), BgL_sfz00_11890))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11889, BgL_sz00_9799, 
BINT(BgL_spz00_11891));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11902;
BgL_nsz00_11902 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2065z00_11903;
BgL_arg2065z00_11903 = 
(BgL_spz00_11891+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11902, ((long)2), BgL_sz00_9799, 
BINT(BgL_spz00_11891), 
BINT(BgL_arg2065z00_11903)); } 
VECTOR_SET(BgL_nsz00_11902,((long)1),BgL_sz00_9799); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11901, BgL_nsz00_11902); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11904;
BgL_ez00_11904 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11904, BgL_sz00_9799); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11905;
BgL_____rz00_11905 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11889, BgL_nsz00_11902, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11904); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11901, BgL_sz00_9799); 
return BgL_____rz00_11905;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11885, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11906;
BgL_nbpz00_11906 = 
(
(long)CINT(BgL_bpz00_11884)+BgL_siza7eza7_9798); 
VECTOR_SET(
((obj_t)BgL_sz00_9799),((long)0),
BINT(BgL_nbpz00_11906)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11907;
BgL_rz00_11907 = 
PROCEDURE_ENTRY(BgL_fz00_11885)(BgL_fz00_11885, BgL_a1z00_11886, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9799),((long)0),BgL_bpz00_11884); 
return BgL_rz00_11907;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9796, BgL_symbzd2funzd2_9797, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_11885));} } } } } } } } 

}



/* comp-call2 */
obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153, BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155, obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158, long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2290;
BgL_cfunz00_2290 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154, ((long)2), BgL_locz00_153, BgL_symbzd2funzd2_155); 
if(
CBOOL(BgL_cfunz00_2290))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4686z00_16273;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2074z00_2308;
BgL_arg2074z00_2308 = 
bgl_debug(); 
BgL_test4686z00_16273 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2074z00_2308), 
BINT(((long)0))); } 
if(BgL_test4686z00_16273)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32071ze3z87_9800;
BgL_zc3z04anonymousza32071ze3z87_9800 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32071ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32071ze3z87_9800, 
(int)(((long)0)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32071ze3z87_9800, 
(int)(((long)1)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32071ze3z87_9800, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_159)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32071ze3z87_9800, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32071ze3z87_9800, 
(int)(((long)4)), BgL_cfunz00_2290); 
return BgL_zc3z04anonymousza32071ze3z87_9800;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32073ze3z87_9801;
BgL_zc3z04anonymousza32073ze3z87_9801 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32073ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32073ze3z87_9801, 
(int)(((long)0)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32073ze3z87_9801, 
(int)(((long)1)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32073ze3z87_9801, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_159)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32073ze3z87_9801, 
(int)(((long)3)), BgL_cfunz00_2290); 
return BgL_zc3z04anonymousza32073ze3z87_9801;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_157))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4688z00_16306;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2128z00_2400;
BgL_arg2128z00_2400 = 
bgl_debug(); 
BgL_test4688z00_16306 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2128z00_2400), 
BINT(((long)0))); } 
if(BgL_test4688z00_16306)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32077ze3z87_9802;
BgL_zc3z04anonymousza32077ze3z87_9802 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32077ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32077ze3z87_9802, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32077ze3z87_9802, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32077ze3z87_9802, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32077ze3z87_9802, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32077ze3z87_9802, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32077ze3z87_9802, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32077ze3z87_9802;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32103ze3z87_9803;
BgL_zc3z04anonymousza32103ze3z87_9803 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32103ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32103ze3z87_9803, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32103ze3z87_9803, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32103ze3z87_9803, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32103ze3z87_9803, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32103ze3z87_9803, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32103ze3z87_9803, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32103ze3z87_9803;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4689z00_16343;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2183z00_2492;
BgL_arg2183z00_2492 = 
bgl_debug(); 
BgL_test4689z00_16343 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2183z00_2492), 
BINT(((long)0))); } 
if(BgL_test4689z00_16343)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32131ze3z87_9804;
BgL_zc3z04anonymousza32131ze3z87_9804 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32131ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32131ze3z87_9804, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32131ze3z87_9804, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32131ze3z87_9804, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32131ze3z87_9804, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32131ze3z87_9804, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32131ze3z87_9804, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32131ze3z87_9804;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32157ze3z87_9805;
BgL_zc3z04anonymousza32157ze3z87_9805 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32157ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32157ze3z87_9805, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32157ze3z87_9805, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32157ze3z87_9805, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32157ze3z87_9805, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32157ze3z87_9805, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32157ze3z87_9805, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32157ze3z87_9805;} } } } } 

}



/* &<@anonymous:2071> */
obj_t BGl_z62zc3z04anonymousza32071ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9806, obj_t BgL_sz00_9812)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_9807;obj_t BgL_a2z00_9808;long BgL_siza7eza7_9809;obj_t BgL_locz00_9810;obj_t BgL_cfunz00_9811;
BgL_a1z00_9807 = 
PROCEDURE_REF(BgL_envz00_9806, 
(int)(((long)0))); 
BgL_a2z00_9808 = 
PROCEDURE_REF(BgL_envz00_9806, 
(int)(((long)1))); 
BgL_siza7eza7_9809 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9806, 
(int)(((long)2)))); 
BgL_locz00_9810 = 
PROCEDURE_REF(BgL_envz00_9806, 
(int)(((long)3))); 
BgL_cfunz00_9811 = 
PROCEDURE_REF(BgL_envz00_9806, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11908;
BgL_bpz00_11908 = 
VECTOR_REF(
((obj_t)BgL_sz00_9812),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_11909;obj_t BgL_a2z00_11910;
BgL_a1z00_11909 = 
PROCEDURE_ENTRY(BgL_a1z00_9807)(BgL_a1z00_9807, BgL_sz00_9812, BEOA); 
BgL_a2z00_11910 = 
PROCEDURE_ENTRY(BgL_a2z00_9808)(BgL_a2z00_9808, BgL_sz00_9812, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11911;
BgL_nbpz00_11911 = 
(
(long)CINT(BgL_bpz00_11908)+BgL_siza7eza7_9809); 
VECTOR_SET(
((obj_t)BgL_sz00_9812),((long)0),
BINT(BgL_nbpz00_11911)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16406;
BgL_tmpz00_16406 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16406, BgL_locz00_9810); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11912;
BgL_rz00_11912 = 
PROCEDURE_ENTRY(BgL_cfunz00_9811)(BgL_cfunz00_9811, BgL_a1z00_11909, BgL_a2z00_11910, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9812),((long)0),BgL_bpz00_11908); 
return BgL_rz00_11912;} } } } } } 

}



/* &<@anonymous:2073> */
obj_t BGl_z62zc3z04anonymousza32073ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9813, obj_t BgL_sz00_9818)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_9814;obj_t BgL_a2z00_9815;long BgL_siza7eza7_9816;obj_t BgL_cfunz00_9817;
BgL_a1z00_9814 = 
PROCEDURE_REF(BgL_envz00_9813, 
(int)(((long)0))); 
BgL_a2z00_9815 = 
PROCEDURE_REF(BgL_envz00_9813, 
(int)(((long)1))); 
BgL_siza7eza7_9816 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9813, 
(int)(((long)2)))); 
BgL_cfunz00_9817 = 
PROCEDURE_REF(BgL_envz00_9813, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11913;
BgL_bpz00_11913 = 
VECTOR_REF(
((obj_t)BgL_sz00_9818),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_11914;obj_t BgL_a2z00_11915;
BgL_a1z00_11914 = 
PROCEDURE_ENTRY(BgL_a1z00_9814)(BgL_a1z00_9814, BgL_sz00_9818, BEOA); 
BgL_a2z00_11915 = 
PROCEDURE_ENTRY(BgL_a2z00_9815)(BgL_a2z00_9815, BgL_sz00_9818, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11916;
BgL_nbpz00_11916 = 
(
(long)CINT(BgL_bpz00_11913)+BgL_siza7eza7_9816); 
VECTOR_SET(
((obj_t)BgL_sz00_9818),((long)0),
BINT(BgL_nbpz00_11916)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11917;
BgL_rz00_11917 = 
PROCEDURE_ENTRY(BgL_cfunz00_9817)(BgL_cfunz00_9817, BgL_a1z00_11914, BgL_a2z00_11915, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9818),((long)0),BgL_bpz00_11913); 
return BgL_rz00_11917;} } } } } } 

}



/* &<@anonymous:2077> */
obj_t BGl_z62zc3z04anonymousza32077ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9819, obj_t BgL_sz00_9826)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9820;obj_t BgL_a1z00_9821;obj_t BgL_a2z00_9822;obj_t BgL_locz00_9823;obj_t BgL_symbzd2funzd2_9824;long BgL_siza7eza7_9825;
BgL_funz00_9820 = 
PROCEDURE_REF(BgL_envz00_9819, 
(int)(((long)0))); 
BgL_a1z00_9821 = 
PROCEDURE_REF(BgL_envz00_9819, 
(int)(((long)1))); 
BgL_a2z00_9822 = 
PROCEDURE_REF(BgL_envz00_9819, 
(int)(((long)2))); 
BgL_locz00_9823 = 
PROCEDURE_REF(BgL_envz00_9819, 
(int)(((long)3))); 
BgL_symbzd2funzd2_9824 = 
PROCEDURE_REF(BgL_envz00_9819, 
(int)(((long)4))); 
BgL_siza7eza7_9825 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9819, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11918;
BgL_bpz00_11918 = 
VECTOR_REF(
((obj_t)BgL_sz00_9826),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11919;obj_t BgL_a1z00_11920;obj_t BgL_a2z00_11921;
BgL_fz00_11919 = 
PROCEDURE_ENTRY(BgL_funz00_9820)(BgL_funz00_9820, BgL_sz00_9826, BEOA); 
BgL_a1z00_11920 = 
PROCEDURE_ENTRY(BgL_a1z00_9821)(BgL_a1z00_9821, BgL_sz00_9826, BEOA); 
BgL_a2z00_11921 = 
PROCEDURE_ENTRY(BgL_a2z00_9822)(BgL_a2z00_9822, BgL_sz00_9826, BEOA); 
if(
PROCEDUREP(BgL_fz00_11919))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9823, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11919); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11922;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16477;
BgL_tmpz00_16477 = 
((obj_t)BgL_fz00_11919); 
BgL_ufz00_11922 = 
PROCEDURE_ATTR(BgL_tmpz00_16477); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4691z00_16480;
if(
STRUCTP(BgL_ufz00_11922))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4691z00_16480 = 
(
STRUCT_KEY(BgL_ufz00_11922)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4691z00_16480 = ((bool_t)0)
; } 
if(BgL_test4691z00_16480)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11923;obj_t BgL_runz00_11924;obj_t BgL_sfz00_11925;
BgL_arityz00_11923 = 
STRUCT_REF(BgL_ufz00_11922, 
(int)(((long)0))); 
BgL_runz00_11924 = 
STRUCT_REF(BgL_ufz00_11922, 
(int)(((long)1))); 
BgL_sfz00_11925 = 
STRUCT_REF(BgL_ufz00_11922, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_11923)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2081z00_11926;
BgL_arg2081z00_11926 = 
(
(long)CINT(BgL_bpz00_11918)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9826),BgL_arg2081z00_11926,BgL_a1z00_11920); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2082z00_11927;
BgL_arg2082z00_11927 = 
(
(long)CINT(BgL_bpz00_11918)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9826),BgL_arg2082z00_11927,BgL_a2z00_11921); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_11923))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11923)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2084z00_11930;obj_t BgL_arg2085z00_11931;
BgL_arg2084z00_11930 = 
(
(long)CINT(BgL_bpz00_11918)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2086z00_11932;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2087z00_11933;
BgL_arg2087z00_11933 = 
MAKE_YOUNG_PAIR(BgL_a2z00_11921, BNIL); 
BgL_list2086z00_11932 = 
MAKE_YOUNG_PAIR(BgL_a1z00_11920, BgL_arg2087z00_11933); } 
BgL_arg2085z00_11931 = BgL_list2086z00_11932; } 
VECTOR_SET(
((obj_t)BgL_sz00_9826),BgL_arg2084z00_11930,BgL_arg2085z00_11931); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2088z00_11934;
BgL_arg2088z00_11934 = 
(
(long)CINT(BgL_bpz00_11918)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9826),BgL_arg2088z00_11934,BgL_a1z00_11920); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2089z00_11935;obj_t BgL_arg2090z00_11936;
BgL_arg2089z00_11935 = 
(
(long)CINT(BgL_bpz00_11918)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2091z00_11937;
BgL_list2091z00_11937 = 
MAKE_YOUNG_PAIR(BgL_a2z00_11921, BNIL); 
BgL_arg2090z00_11936 = BgL_list2091z00_11937; } 
VECTOR_SET(
((obj_t)BgL_sz00_9826),BgL_arg2089z00_11935,BgL_arg2090z00_11936); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2092z00_11938;
BgL_arg2092z00_11938 = 
(
(long)CINT(BgL_bpz00_11918)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9826),BgL_arg2092z00_11938,BgL_a1z00_11920); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2093z00_11939;
BgL_arg2093z00_11939 = 
(
(long)CINT(BgL_bpz00_11918)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9826),BgL_arg2093z00_11939,BgL_a2z00_11921); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2094z00_11940;obj_t BgL_arg2095z00_11941;
BgL_arg2094z00_11940 = 
(
(long)CINT(BgL_bpz00_11918)+((long)2)); 
BgL_arg2095z00_11941 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9826),BgL_arg2094z00_11940,BgL_arg2095z00_11941); } break;
default: 
BgL_case_else1186z00_11928:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2097z00_11929;
BgL_arg2097z00_11929 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11922), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9823, BgL_arg2097z00_11929, 
(int)(((long)2)), 
CINT(BgL_arityz00_11923)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1186z00_11928;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11942;
BgL_z12denvz12_11942 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_11942, BgL_locz00_9823); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9826, BgL_bpz00_11918, BgL_sfz00_11925))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_11924;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11943;
BgL_nsz00_11943 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2099z00_11944;
BgL_arg2099z00_11944 = 
(
(long)CINT(BgL_bpz00_11918)+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11943, ((long)2), BgL_sz00_9826, BgL_bpz00_11918, 
BINT(BgL_arg2099z00_11944)); } 
VECTOR_SET(BgL_nsz00_11943,((long)1),BgL_sz00_9826); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11942, BgL_nsz00_11943); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11945;
BgL_ez00_11945 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11945, BgL_sz00_9826); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11946;
BgL_____rz00_11946 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11924, BgL_nsz00_11943, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11945); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11942, BgL_sz00_9826); 
return BgL_____rz00_11946;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11919, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11947;
BgL_nbpz00_11947 = 
(
(long)CINT(BgL_bpz00_11918)+BgL_siza7eza7_9825); 
VECTOR_SET(
((obj_t)BgL_sz00_9826),((long)0),
BINT(BgL_nbpz00_11947)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16564;
BgL_tmpz00_16564 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16564, BgL_locz00_9823); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11948;
BgL_rz00_11948 = 
PROCEDURE_ENTRY(BgL_fz00_11919)(BgL_fz00_11919, BgL_a1z00_11920, BgL_a2z00_11921, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9826),((long)0),BgL_bpz00_11918); 
return BgL_rz00_11948;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9823, BgL_symbzd2funzd2_9824, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_11919));} } } } } } } } 

}



/* &<@anonymous:2103> */
obj_t BGl_z62zc3z04anonymousza32103ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9827, obj_t BgL_sz00_9834)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9828;obj_t BgL_a1z00_9829;obj_t BgL_a2z00_9830;obj_t BgL_locz00_9831;obj_t BgL_symbzd2funzd2_9832;long BgL_siza7eza7_9833;
BgL_funz00_9828 = 
PROCEDURE_REF(BgL_envz00_9827, 
(int)(((long)0))); 
BgL_a1z00_9829 = 
PROCEDURE_REF(BgL_envz00_9827, 
(int)(((long)1))); 
BgL_a2z00_9830 = 
PROCEDURE_REF(BgL_envz00_9827, 
(int)(((long)2))); 
BgL_locz00_9831 = 
PROCEDURE_REF(BgL_envz00_9827, 
(int)(((long)3))); 
BgL_symbzd2funzd2_9832 = 
PROCEDURE_REF(BgL_envz00_9827, 
(int)(((long)4))); 
BgL_siza7eza7_9833 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9827, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11949;
BgL_bpz00_11949 = 
VECTOR_REF(
((obj_t)BgL_sz00_9834),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11950;obj_t BgL_a1z00_11951;obj_t BgL_a2z00_11952;
BgL_fz00_11950 = 
PROCEDURE_ENTRY(BgL_funz00_9828)(BgL_funz00_9828, BgL_sz00_9834, BEOA); 
BgL_a1z00_11951 = 
PROCEDURE_ENTRY(BgL_a1z00_9829)(BgL_a1z00_9829, BgL_sz00_9834, BEOA); 
BgL_a2z00_11952 = 
PROCEDURE_ENTRY(BgL_a2z00_9830)(BgL_a2z00_9830, BgL_sz00_9834, BEOA); 
if(
PROCEDUREP(BgL_fz00_11950))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9831, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11950); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11953;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16607;
BgL_tmpz00_16607 = 
((obj_t)BgL_fz00_11950); 
BgL_ufz00_11953 = 
PROCEDURE_ATTR(BgL_tmpz00_16607); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4698z00_16610;
if(
STRUCTP(BgL_ufz00_11953))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4698z00_16610 = 
(
STRUCT_KEY(BgL_ufz00_11953)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4698z00_16610 = ((bool_t)0)
; } 
if(BgL_test4698z00_16610)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11954;obj_t BgL_runz00_11955;obj_t BgL_sfz00_11956;
BgL_arityz00_11954 = 
STRUCT_REF(BgL_ufz00_11953, 
(int)(((long)0))); 
BgL_runz00_11955 = 
STRUCT_REF(BgL_ufz00_11953, 
(int)(((long)1))); 
BgL_sfz00_11956 = 
STRUCT_REF(BgL_ufz00_11953, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_11954)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2107z00_11957;
BgL_arg2107z00_11957 = 
(
(long)CINT(BgL_bpz00_11949)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9834),BgL_arg2107z00_11957,BgL_a1z00_11951); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2108z00_11958;
BgL_arg2108z00_11958 = 
(
(long)CINT(BgL_bpz00_11949)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9834),BgL_arg2108z00_11958,BgL_a2z00_11952); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_11954))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11954)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2110z00_11961;obj_t BgL_arg2111z00_11962;
BgL_arg2110z00_11961 = 
(
(long)CINT(BgL_bpz00_11949)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2112z00_11963;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2113z00_11964;
BgL_arg2113z00_11964 = 
MAKE_YOUNG_PAIR(BgL_a2z00_11952, BNIL); 
BgL_list2112z00_11963 = 
MAKE_YOUNG_PAIR(BgL_a1z00_11951, BgL_arg2113z00_11964); } 
BgL_arg2111z00_11962 = BgL_list2112z00_11963; } 
VECTOR_SET(
((obj_t)BgL_sz00_9834),BgL_arg2110z00_11961,BgL_arg2111z00_11962); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2114z00_11965;
BgL_arg2114z00_11965 = 
(
(long)CINT(BgL_bpz00_11949)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9834),BgL_arg2114z00_11965,BgL_a1z00_11951); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2115z00_11966;obj_t BgL_arg2116z00_11967;
BgL_arg2115z00_11966 = 
(
(long)CINT(BgL_bpz00_11949)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2117z00_11968;
BgL_list2117z00_11968 = 
MAKE_YOUNG_PAIR(BgL_a2z00_11952, BNIL); 
BgL_arg2116z00_11967 = BgL_list2117z00_11968; } 
VECTOR_SET(
((obj_t)BgL_sz00_9834),BgL_arg2115z00_11966,BgL_arg2116z00_11967); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2118z00_11969;
BgL_arg2118z00_11969 = 
(
(long)CINT(BgL_bpz00_11949)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9834),BgL_arg2118z00_11969,BgL_a1z00_11951); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2119z00_11970;
BgL_arg2119z00_11970 = 
(
(long)CINT(BgL_bpz00_11949)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9834),BgL_arg2119z00_11970,BgL_a2z00_11952); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2120z00_11971;obj_t BgL_arg2121z00_11972;
BgL_arg2120z00_11971 = 
(
(long)CINT(BgL_bpz00_11949)+((long)2)); 
BgL_arg2121z00_11972 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9834),BgL_arg2120z00_11971,BgL_arg2121z00_11972); } break;
default: 
BgL_case_else1188z00_11959:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2123z00_11960;
BgL_arg2123z00_11960 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11953), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9831, BgL_arg2123z00_11960, 
(int)(((long)2)), 
CINT(BgL_arityz00_11954)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1188z00_11959;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_11973;
BgL_z12denvz12_11973 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9834, BgL_bpz00_11949, BgL_sfz00_11956))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_11955;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_11974;
BgL_nsz00_11974 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2125z00_11975;
BgL_arg2125z00_11975 = 
(
(long)CINT(BgL_bpz00_11949)+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_11974, ((long)2), BgL_sz00_9834, BgL_bpz00_11949, 
BINT(BgL_arg2125z00_11975)); } 
VECTOR_SET(BgL_nsz00_11974,((long)1),BgL_sz00_9834); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11973, BgL_nsz00_11974); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_11976;
BgL_ez00_11976 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_11976, BgL_sz00_9834); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_11977;
BgL_____rz00_11977 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11955, BgL_nsz00_11974, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_11976); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_11973, BgL_sz00_9834); 
return BgL_____rz00_11977;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11950, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_11978;
BgL_nbpz00_11978 = 
(
(long)CINT(BgL_bpz00_11949)+BgL_siza7eza7_9833); 
VECTOR_SET(
((obj_t)BgL_sz00_9834),((long)0),
BINT(BgL_nbpz00_11978)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_11979;
BgL_rz00_11979 = 
PROCEDURE_ENTRY(BgL_fz00_11950)(BgL_fz00_11950, BgL_a1z00_11951, BgL_a2z00_11952, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9834),((long)0),BgL_bpz00_11949); 
return BgL_rz00_11979;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9831, BgL_symbzd2funzd2_9832, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_11950));} } } } } } } } 

}



/* &<@anonymous:2131> */
obj_t BGl_z62zc3z04anonymousza32131ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9835, obj_t BgL_sz00_9842)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9836;obj_t BgL_a1z00_9837;obj_t BgL_a2z00_9838;obj_t BgL_locz00_9839;obj_t BgL_symbzd2funzd2_9840;long BgL_siza7eza7_9841;
BgL_funz00_9836 = 
PROCEDURE_REF(BgL_envz00_9835, 
(int)(((long)0))); 
BgL_a1z00_9837 = 
PROCEDURE_REF(BgL_envz00_9835, 
(int)(((long)1))); 
BgL_a2z00_9838 = 
PROCEDURE_REF(BgL_envz00_9835, 
(int)(((long)2))); 
BgL_locz00_9839 = 
PROCEDURE_REF(BgL_envz00_9835, 
(int)(((long)3))); 
BgL_symbzd2funzd2_9840 = 
PROCEDURE_REF(BgL_envz00_9835, 
(int)(((long)4))); 
BgL_siza7eza7_9841 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9835, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_11980;
BgL_bpz00_11980 = 
VECTOR_REF(
((obj_t)BgL_sz00_9842),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_11981;obj_t BgL_a1z00_11982;obj_t BgL_a2z00_11983;
BgL_fz00_11981 = 
PROCEDURE_ENTRY(BgL_funz00_9836)(BgL_funz00_9836, BgL_sz00_9842, BEOA); 
BgL_a1z00_11982 = 
PROCEDURE_ENTRY(BgL_a1z00_9837)(BgL_a1z00_9837, BgL_sz00_9842, BEOA); 
BgL_a2z00_11983 = 
PROCEDURE_ENTRY(BgL_a2z00_9838)(BgL_a2z00_9838, BgL_sz00_9842, BEOA); 
if(
PROCEDUREP(BgL_fz00_11981))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9839, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_11981); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_11984;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16733;
BgL_tmpz00_16733 = 
((obj_t)BgL_fz00_11981); 
BgL_ufz00_11984 = 
PROCEDURE_ATTR(BgL_tmpz00_16733); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4705z00_16736;
if(
STRUCTP(BgL_ufz00_11984))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4705z00_16736 = 
(
STRUCT_KEY(BgL_ufz00_11984)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4705z00_16736 = ((bool_t)0)
; } 
if(BgL_test4705z00_16736)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_11985;obj_t BgL_runz00_11986;obj_t BgL_sfz00_11987;
BgL_arityz00_11985 = 
STRUCT_REF(BgL_ufz00_11984, 
(int)(((long)0))); 
BgL_runz00_11986 = 
STRUCT_REF(BgL_ufz00_11984, 
(int)(((long)1))); 
BgL_sfz00_11987 = 
STRUCT_REF(BgL_ufz00_11984, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_11988;
BgL_spz00_11988 = 
(
(long)CINT(BgL_bpz00_11980)+BgL_siza7eza7_9841); 
if(
(
(long)CINT(BgL_arityz00_11985)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2135z00_11989;
BgL_arg2135z00_11989 = 
(BgL_spz00_11988+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9842),BgL_arg2135z00_11989,BgL_a1z00_11982); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2136z00_11990;
BgL_arg2136z00_11990 = 
(BgL_spz00_11988+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9842),BgL_arg2136z00_11990,BgL_a2z00_11983); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_11985))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_11985)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2138z00_11993;obj_t BgL_arg2139z00_11994;
BgL_arg2138z00_11993 = 
(BgL_spz00_11988+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2140z00_11995;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2141z00_11996;
BgL_arg2141z00_11996 = 
MAKE_YOUNG_PAIR(BgL_a2z00_11983, BNIL); 
BgL_list2140z00_11995 = 
MAKE_YOUNG_PAIR(BgL_a1z00_11982, BgL_arg2141z00_11996); } 
BgL_arg2139z00_11994 = BgL_list2140z00_11995; } 
VECTOR_SET(
((obj_t)BgL_sz00_9842),BgL_arg2138z00_11993,BgL_arg2139z00_11994); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2142z00_11997;
BgL_arg2142z00_11997 = 
(BgL_spz00_11988+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9842),BgL_arg2142z00_11997,BgL_a1z00_11982); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2143z00_11998;obj_t BgL_arg2144z00_11999;
BgL_arg2143z00_11998 = 
(BgL_spz00_11988+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2145z00_12000;
BgL_list2145z00_12000 = 
MAKE_YOUNG_PAIR(BgL_a2z00_11983, BNIL); 
BgL_arg2144z00_11999 = BgL_list2145z00_12000; } 
VECTOR_SET(
((obj_t)BgL_sz00_9842),BgL_arg2143z00_11998,BgL_arg2144z00_11999); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2146z00_12001;
BgL_arg2146z00_12001 = 
(BgL_spz00_11988+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9842),BgL_arg2146z00_12001,BgL_a1z00_11982); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2147z00_12002;
BgL_arg2147z00_12002 = 
(BgL_spz00_11988+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9842),BgL_arg2147z00_12002,BgL_a2z00_11983); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2148z00_12003;obj_t BgL_arg2149z00_12004;
BgL_arg2148z00_12003 = 
(BgL_spz00_11988+((long)2)); 
BgL_arg2149z00_12004 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9842),BgL_arg2148z00_12003,BgL_arg2149z00_12004); } break;
default: 
BgL_case_else1190z00_11991:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2151z00_11992;
BgL_arg2151z00_11992 = 
STRUCT_REF(
((obj_t)BgL_ufz00_11984), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9839, BgL_arg2151z00_11992, 
(int)(((long)2)), 
CINT(BgL_arityz00_11985)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1190z00_11991;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12005;
BgL_z12denvz12_12005 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12005, BgL_locz00_9839); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9842, 
BINT(BgL_spz00_11988), BgL_sfz00_11987))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11986, BgL_sz00_9842, 
BINT(BgL_spz00_11988));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12006;
BgL_nsz00_12006 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2153z00_12007;
BgL_arg2153z00_12007 = 
(BgL_spz00_11988+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12006, ((long)2), BgL_sz00_9842, 
BINT(BgL_spz00_11988), 
BINT(BgL_arg2153z00_12007)); } 
VECTOR_SET(BgL_nsz00_12006,((long)1),BgL_sz00_9842); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12005, BgL_nsz00_12006); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12008;
BgL_ez00_12008 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12008, BgL_sz00_9842); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12009;
BgL_____rz00_12009 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11986, BgL_nsz00_12006, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12008); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12005, BgL_sz00_9842); 
return BgL_____rz00_12009;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_11981, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12010;
BgL_nbpz00_12010 = 
(
(long)CINT(BgL_bpz00_11980)+BgL_siza7eza7_9841); 
VECTOR_SET(
((obj_t)BgL_sz00_9842),((long)0),
BINT(BgL_nbpz00_12010)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16817;
BgL_tmpz00_16817 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16817, BgL_locz00_9839); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12011;
BgL_rz00_12011 = 
PROCEDURE_ENTRY(BgL_fz00_11981)(BgL_fz00_11981, BgL_a1z00_11982, BgL_a2z00_11983, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9842),((long)0),BgL_bpz00_11980); 
return BgL_rz00_12011;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9839, BgL_symbzd2funzd2_9840, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_11981));} } } } } } } } 

}



/* &<@anonymous:2157> */
obj_t BGl_z62zc3z04anonymousza32157ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9843, obj_t BgL_sz00_9850)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9844;obj_t BgL_a1z00_9845;obj_t BgL_a2z00_9846;obj_t BgL_locz00_9847;obj_t BgL_symbzd2funzd2_9848;long BgL_siza7eza7_9849;
BgL_funz00_9844 = 
PROCEDURE_REF(BgL_envz00_9843, 
(int)(((long)0))); 
BgL_a1z00_9845 = 
PROCEDURE_REF(BgL_envz00_9843, 
(int)(((long)1))); 
BgL_a2z00_9846 = 
PROCEDURE_REF(BgL_envz00_9843, 
(int)(((long)2))); 
BgL_locz00_9847 = 
PROCEDURE_REF(BgL_envz00_9843, 
(int)(((long)3))); 
BgL_symbzd2funzd2_9848 = 
PROCEDURE_REF(BgL_envz00_9843, 
(int)(((long)4))); 
BgL_siza7eza7_9849 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9843, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12012;
BgL_bpz00_12012 = 
VECTOR_REF(
((obj_t)BgL_sz00_9850),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12013;obj_t BgL_a1z00_12014;obj_t BgL_a2z00_12015;
BgL_fz00_12013 = 
PROCEDURE_ENTRY(BgL_funz00_9844)(BgL_funz00_9844, BgL_sz00_9850, BEOA); 
BgL_a1z00_12014 = 
PROCEDURE_ENTRY(BgL_a1z00_9845)(BgL_a1z00_9845, BgL_sz00_9850, BEOA); 
BgL_a2z00_12015 = 
PROCEDURE_ENTRY(BgL_a2z00_9846)(BgL_a2z00_9846, BgL_sz00_9850, BEOA); 
if(
PROCEDUREP(BgL_fz00_12013))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9847, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12013); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12016;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16860;
BgL_tmpz00_16860 = 
((obj_t)BgL_fz00_12013); 
BgL_ufz00_12016 = 
PROCEDURE_ATTR(BgL_tmpz00_16860); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4712z00_16863;
if(
STRUCTP(BgL_ufz00_12016))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4712z00_16863 = 
(
STRUCT_KEY(BgL_ufz00_12016)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4712z00_16863 = ((bool_t)0)
; } 
if(BgL_test4712z00_16863)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12017;obj_t BgL_runz00_12018;obj_t BgL_sfz00_12019;
BgL_arityz00_12017 = 
STRUCT_REF(BgL_ufz00_12016, 
(int)(((long)0))); 
BgL_runz00_12018 = 
STRUCT_REF(BgL_ufz00_12016, 
(int)(((long)1))); 
BgL_sfz00_12019 = 
STRUCT_REF(BgL_ufz00_12016, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12020;
BgL_spz00_12020 = 
(
(long)CINT(BgL_bpz00_12012)+BgL_siza7eza7_9849); 
if(
(
(long)CINT(BgL_arityz00_12017)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2161z00_12021;
BgL_arg2161z00_12021 = 
(BgL_spz00_12020+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9850),BgL_arg2161z00_12021,BgL_a1z00_12014); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2162z00_12022;
BgL_arg2162z00_12022 = 
(BgL_spz00_12020+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9850),BgL_arg2162z00_12022,BgL_a2z00_12015); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12017))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12017)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2164z00_12025;obj_t BgL_arg2165z00_12026;
BgL_arg2164z00_12025 = 
(BgL_spz00_12020+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2166z00_12027;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2167z00_12028;
BgL_arg2167z00_12028 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12015, BNIL); 
BgL_list2166z00_12027 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12014, BgL_arg2167z00_12028); } 
BgL_arg2165z00_12026 = BgL_list2166z00_12027; } 
VECTOR_SET(
((obj_t)BgL_sz00_9850),BgL_arg2164z00_12025,BgL_arg2165z00_12026); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2168z00_12029;
BgL_arg2168z00_12029 = 
(BgL_spz00_12020+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9850),BgL_arg2168z00_12029,BgL_a1z00_12014); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2169z00_12030;obj_t BgL_arg2170z00_12031;
BgL_arg2169z00_12030 = 
(BgL_spz00_12020+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2171z00_12032;
BgL_list2171z00_12032 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12015, BNIL); 
BgL_arg2170z00_12031 = BgL_list2171z00_12032; } 
VECTOR_SET(
((obj_t)BgL_sz00_9850),BgL_arg2169z00_12030,BgL_arg2170z00_12031); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2172z00_12033;
BgL_arg2172z00_12033 = 
(BgL_spz00_12020+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9850),BgL_arg2172z00_12033,BgL_a1z00_12014); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2173z00_12034;
BgL_arg2173z00_12034 = 
(BgL_spz00_12020+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9850),BgL_arg2173z00_12034,BgL_a2z00_12015); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2174z00_12035;obj_t BgL_arg2175z00_12036;
BgL_arg2174z00_12035 = 
(BgL_spz00_12020+((long)2)); 
BgL_arg2175z00_12036 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9850),BgL_arg2174z00_12035,BgL_arg2175z00_12036); } break;
default: 
BgL_case_else1192z00_12023:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2178z00_12024;
BgL_arg2178z00_12024 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12016), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9847, BgL_arg2178z00_12024, 
(int)(((long)2)), 
CINT(BgL_arityz00_12017)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1192z00_12023;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12037;
BgL_z12denvz12_12037 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9850, 
BINT(BgL_spz00_12020), BgL_sfz00_12019))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12018, BgL_sz00_9850, 
BINT(BgL_spz00_12020));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12038;
BgL_nsz00_12038 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2180z00_12039;
BgL_arg2180z00_12039 = 
(BgL_spz00_12020+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12038, ((long)2), BgL_sz00_9850, 
BINT(BgL_spz00_12020), 
BINT(BgL_arg2180z00_12039)); } 
VECTOR_SET(BgL_nsz00_12038,((long)1),BgL_sz00_9850); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12037, BgL_nsz00_12038); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12040;
BgL_ez00_12040 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12040, BgL_sz00_9850); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12041;
BgL_____rz00_12041 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12018, BgL_nsz00_12038, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12040); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12037, BgL_sz00_9850); 
return BgL_____rz00_12041;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12013, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12042;
BgL_nbpz00_12042 = 
(
(long)CINT(BgL_bpz00_12012)+BgL_siza7eza7_9849); 
VECTOR_SET(
((obj_t)BgL_sz00_9850),((long)0),
BINT(BgL_nbpz00_12042)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12043;
BgL_rz00_12043 = 
PROCEDURE_ENTRY(BgL_fz00_12013)(BgL_fz00_12013, BgL_a1z00_12014, BgL_a2z00_12015, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9850),((long)0),BgL_bpz00_12012); 
return BgL_rz00_12043;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9847, BgL_symbzd2funzd2_9848, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12013));} } } } } } } } 

}



/* comp-call3 */
obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162, BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164, obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167, long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170, obj_t BgL_a3z00_171)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2493;
BgL_cfunz00_2493 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163, ((long)3), BgL_locz00_162, BgL_symbzd2funzd2_164); 
if(
CBOOL(BgL_cfunz00_2493))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4719z00_16956;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2189z00_2513;
BgL_arg2189z00_2513 = 
bgl_debug(); 
BgL_test4719z00_16956 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2189z00_2513), 
BINT(((long)0))); } 
if(BgL_test4719z00_16956)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32186ze3z87_9851;
BgL_zc3z04anonymousza32186ze3z87_9851 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_9851, 
(int)(((long)0)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_9851, 
(int)(((long)1)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_9851, 
(int)(((long)2)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_9851, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_168)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_9851, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_9851, 
(int)(((long)5)), BgL_cfunz00_2493); 
return BgL_zc3z04anonymousza32186ze3z87_9851;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32188ze3z87_9852;
BgL_zc3z04anonymousza32188ze3z87_9852 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32188ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32188ze3z87_9852, 
(int)(((long)0)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32188ze3z87_9852, 
(int)(((long)1)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32188ze3z87_9852, 
(int)(((long)2)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32188ze3z87_9852, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_168)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32188ze3z87_9852, 
(int)(((long)4)), BgL_cfunz00_2493); 
return BgL_zc3z04anonymousza32188ze3z87_9852;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_166))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4721z00_16993;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2261z00_2625;
BgL_arg2261z00_2625 = 
bgl_debug(); 
BgL_test4721z00_16993 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2261z00_2625), 
BINT(((long)0))); } 
if(BgL_test4721z00_16993)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32192ze3z87_9853;
BgL_zc3z04anonymousza32192ze3z87_9853 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32192ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32192ze3z87_9853, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32192ze3z87_9853, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32192ze3z87_9853, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32192ze3z87_9853, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32192ze3z87_9853, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32192ze3z87_9853, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32192ze3z87_9853, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32192ze3z87_9853;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32227ze3z87_9854;
BgL_zc3z04anonymousza32227ze3z87_9854 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32227ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32227ze3z87_9854, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32227ze3z87_9854, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32227ze3z87_9854, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32227ze3z87_9854, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32227ze3z87_9854, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32227ze3z87_9854, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32227ze3z87_9854, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32227ze3z87_9854;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4722z00_17034;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2333z00_2737;
BgL_arg2333z00_2737 = 
bgl_debug(); 
BgL_test4722z00_17034 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2333z00_2737), 
BINT(((long)0))); } 
if(BgL_test4722z00_17034)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32264ze3z87_9855;
BgL_zc3z04anonymousza32264ze3z87_9855 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32264ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32264ze3z87_9855, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32264ze3z87_9855, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32264ze3z87_9855, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32264ze3z87_9855, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32264ze3z87_9855, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32264ze3z87_9855, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32264ze3z87_9855, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32264ze3z87_9855;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32299ze3z87_9856;
BgL_zc3z04anonymousza32299ze3z87_9856 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32299ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32299ze3z87_9856, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32299ze3z87_9856, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32299ze3z87_9856, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32299ze3z87_9856, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32299ze3z87_9856, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32299ze3z87_9856, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32299ze3z87_9856, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32299ze3z87_9856;} } } } } 

}



/* &<@anonymous:2186> */
obj_t BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9857, obj_t BgL_sz00_9864)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_9858;obj_t BgL_a2z00_9859;obj_t BgL_a3z00_9860;long BgL_siza7eza7_9861;obj_t BgL_locz00_9862;obj_t BgL_cfunz00_9863;
BgL_a1z00_9858 = 
PROCEDURE_REF(BgL_envz00_9857, 
(int)(((long)0))); 
BgL_a2z00_9859 = 
PROCEDURE_REF(BgL_envz00_9857, 
(int)(((long)1))); 
BgL_a3z00_9860 = 
PROCEDURE_REF(BgL_envz00_9857, 
(int)(((long)2))); 
BgL_siza7eza7_9861 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9857, 
(int)(((long)3)))); 
BgL_locz00_9862 = 
PROCEDURE_REF(BgL_envz00_9857, 
(int)(((long)4))); 
BgL_cfunz00_9863 = 
PROCEDURE_REF(BgL_envz00_9857, 
(int)(((long)5))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12044;
BgL_bpz00_12044 = 
VECTOR_REF(
((obj_t)BgL_sz00_9864),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12045;obj_t BgL_a2z00_12046;obj_t BgL_a3z00_12047;
BgL_a1z00_12045 = 
PROCEDURE_ENTRY(BgL_a1z00_9858)(BgL_a1z00_9858, BgL_sz00_9864, BEOA); 
BgL_a2z00_12046 = 
PROCEDURE_ENTRY(BgL_a2z00_9859)(BgL_a2z00_9859, BgL_sz00_9864, BEOA); 
BgL_a3z00_12047 = 
PROCEDURE_ENTRY(BgL_a3z00_9860)(BgL_a3z00_9860, BgL_sz00_9864, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12048;
BgL_nbpz00_12048 = 
(
(long)CINT(BgL_bpz00_12044)+BgL_siza7eza7_9861); 
VECTOR_SET(
((obj_t)BgL_sz00_9864),((long)0),
BINT(BgL_nbpz00_12048)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17107;
BgL_tmpz00_17107 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17107, BgL_locz00_9862); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12049;
BgL_rz00_12049 = 
PROCEDURE_ENTRY(BgL_cfunz00_9863)(BgL_cfunz00_9863, BgL_a1z00_12045, BgL_a2z00_12046, BgL_a3z00_12047, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9864),((long)0),BgL_bpz00_12044); 
return BgL_rz00_12049;} } } } } } 

}



/* &<@anonymous:2188> */
obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9865, obj_t BgL_sz00_9871)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_9866;obj_t BgL_a2z00_9867;obj_t BgL_a3z00_9868;long BgL_siza7eza7_9869;obj_t BgL_cfunz00_9870;
BgL_a1z00_9866 = 
PROCEDURE_REF(BgL_envz00_9865, 
(int)(((long)0))); 
BgL_a2z00_9867 = 
PROCEDURE_REF(BgL_envz00_9865, 
(int)(((long)1))); 
BgL_a3z00_9868 = 
PROCEDURE_REF(BgL_envz00_9865, 
(int)(((long)2))); 
BgL_siza7eza7_9869 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9865, 
(int)(((long)3)))); 
BgL_cfunz00_9870 = 
PROCEDURE_REF(BgL_envz00_9865, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12050;
BgL_bpz00_12050 = 
VECTOR_REF(
((obj_t)BgL_sz00_9871),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12051;obj_t BgL_a2z00_12052;obj_t BgL_a3z00_12053;
BgL_a1z00_12051 = 
PROCEDURE_ENTRY(BgL_a1z00_9866)(BgL_a1z00_9866, BgL_sz00_9871, BEOA); 
BgL_a2z00_12052 = 
PROCEDURE_ENTRY(BgL_a2z00_9867)(BgL_a2z00_9867, BgL_sz00_9871, BEOA); 
BgL_a3z00_12053 = 
PROCEDURE_ENTRY(BgL_a3z00_9868)(BgL_a3z00_9868, BgL_sz00_9871, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12054;
BgL_nbpz00_12054 = 
(
(long)CINT(BgL_bpz00_12050)+BgL_siza7eza7_9869); 
VECTOR_SET(
((obj_t)BgL_sz00_9871),((long)0),
BINT(BgL_nbpz00_12054)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12055;
BgL_rz00_12055 = 
PROCEDURE_ENTRY(BgL_cfunz00_9870)(BgL_cfunz00_9870, BgL_a1z00_12051, BgL_a2z00_12052, BgL_a3z00_12053, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9871),((long)0),BgL_bpz00_12050); 
return BgL_rz00_12055;} } } } } } 

}



/* &<@anonymous:2192> */
obj_t BGl_z62zc3z04anonymousza32192ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9872, obj_t BgL_sz00_9880)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9873;obj_t BgL_a1z00_9874;obj_t BgL_a2z00_9875;obj_t BgL_a3z00_9876;obj_t BgL_locz00_9877;obj_t BgL_symbzd2funzd2_9878;long BgL_siza7eza7_9879;
BgL_funz00_9873 = 
PROCEDURE_REF(BgL_envz00_9872, 
(int)(((long)0))); 
BgL_a1z00_9874 = 
PROCEDURE_REF(BgL_envz00_9872, 
(int)(((long)1))); 
BgL_a2z00_9875 = 
PROCEDURE_REF(BgL_envz00_9872, 
(int)(((long)2))); 
BgL_a3z00_9876 = 
PROCEDURE_REF(BgL_envz00_9872, 
(int)(((long)3))); 
BgL_locz00_9877 = 
PROCEDURE_REF(BgL_envz00_9872, 
(int)(((long)4))); 
BgL_symbzd2funzd2_9878 = 
PROCEDURE_REF(BgL_envz00_9872, 
(int)(((long)5))); 
BgL_siza7eza7_9879 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9872, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12056;
BgL_bpz00_12056 = 
VECTOR_REF(
((obj_t)BgL_sz00_9880),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12057;obj_t BgL_a1z00_12058;obj_t BgL_a2z00_12059;obj_t BgL_a3z00_12060;
BgL_fz00_12057 = 
PROCEDURE_ENTRY(BgL_funz00_9873)(BgL_funz00_9873, BgL_sz00_9880, BEOA); 
BgL_a1z00_12058 = 
PROCEDURE_ENTRY(BgL_a1z00_9874)(BgL_a1z00_9874, BgL_sz00_9880, BEOA); 
BgL_a2z00_12059 = 
PROCEDURE_ENTRY(BgL_a2z00_9875)(BgL_a2z00_9875, BgL_sz00_9880, BEOA); 
BgL_a3z00_12060 = 
PROCEDURE_ENTRY(BgL_a3z00_9876)(BgL_a3z00_9876, BgL_sz00_9880, BEOA); 
if(
PROCEDUREP(BgL_fz00_12057))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9877, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12057); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12061;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17192;
BgL_tmpz00_17192 = 
((obj_t)BgL_fz00_12057); 
BgL_ufz00_12061 = 
PROCEDURE_ATTR(BgL_tmpz00_17192); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4724z00_17195;
if(
STRUCTP(BgL_ufz00_12061))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4724z00_17195 = 
(
STRUCT_KEY(BgL_ufz00_12061)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4724z00_17195 = ((bool_t)0)
; } 
if(BgL_test4724z00_17195)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12062;obj_t BgL_runz00_12063;obj_t BgL_sfz00_12064;
BgL_arityz00_12062 = 
STRUCT_REF(BgL_ufz00_12061, 
(int)(((long)0))); 
BgL_runz00_12063 = 
STRUCT_REF(BgL_ufz00_12061, 
(int)(((long)1))); 
BgL_sfz00_12064 = 
STRUCT_REF(BgL_ufz00_12061, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12062)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2196z00_12065;
BgL_arg2196z00_12065 = 
(
(long)CINT(BgL_bpz00_12056)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2196z00_12065,BgL_a1z00_12058); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2197z00_12066;
BgL_arg2197z00_12066 = 
(
(long)CINT(BgL_bpz00_12056)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2197z00_12066,BgL_a2z00_12059); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2198z00_12067;
BgL_arg2198z00_12067 = 
(
(long)CINT(BgL_bpz00_12056)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2198z00_12067,BgL_a3z00_12060); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12062))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12062)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2200z00_12070;obj_t BgL_arg2201z00_12071;
BgL_arg2200z00_12070 = 
(
(long)CINT(BgL_bpz00_12056)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2202z00_12072;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2203z00_12073;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2204z00_12074;
BgL_arg2204z00_12074 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12060, BNIL); 
BgL_arg2203z00_12073 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12059, BgL_arg2204z00_12074); } 
BgL_list2202z00_12072 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12058, BgL_arg2203z00_12073); } 
BgL_arg2201z00_12071 = BgL_list2202z00_12072; } 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2200z00_12070,BgL_arg2201z00_12071); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2205z00_12075;
BgL_arg2205z00_12075 = 
(
(long)CINT(BgL_bpz00_12056)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2205z00_12075,BgL_a1z00_12058); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2206z00_12076;obj_t BgL_arg2207z00_12077;
BgL_arg2206z00_12076 = 
(
(long)CINT(BgL_bpz00_12056)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2208z00_12078;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2209z00_12079;
BgL_arg2209z00_12079 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12060, BNIL); 
BgL_list2208z00_12078 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12059, BgL_arg2209z00_12079); } 
BgL_arg2207z00_12077 = BgL_list2208z00_12078; } 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2206z00_12076,BgL_arg2207z00_12077); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2210z00_12080;
BgL_arg2210z00_12080 = 
(
(long)CINT(BgL_bpz00_12056)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2210z00_12080,BgL_a1z00_12058); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2211z00_12081;
BgL_arg2211z00_12081 = 
(
(long)CINT(BgL_bpz00_12056)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2211z00_12081,BgL_a2z00_12059); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2212z00_12082;obj_t BgL_arg2213z00_12083;
BgL_arg2212z00_12082 = 
(
(long)CINT(BgL_bpz00_12056)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2214z00_12084;
BgL_list2214z00_12084 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12060, BNIL); 
BgL_arg2213z00_12083 = BgL_list2214z00_12084; } 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2212z00_12082,BgL_arg2213z00_12083); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2215z00_12085;
BgL_arg2215z00_12085 = 
(
(long)CINT(BgL_bpz00_12056)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2215z00_12085,BgL_a1z00_12058); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2216z00_12086;
BgL_arg2216z00_12086 = 
(
(long)CINT(BgL_bpz00_12056)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2216z00_12086,BgL_a2z00_12059); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2217z00_12087;
BgL_arg2217z00_12087 = 
(
(long)CINT(BgL_bpz00_12056)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2217z00_12087,BgL_a3z00_12060); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2218z00_12088;obj_t BgL_arg2219z00_12089;
BgL_arg2218z00_12088 = 
(
(long)CINT(BgL_bpz00_12056)+((long)3)); 
BgL_arg2219z00_12089 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9880),BgL_arg2218z00_12088,BgL_arg2219z00_12089); } break;
default: 
BgL_case_else1194z00_12068:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2221z00_12069;
BgL_arg2221z00_12069 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12061), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9877, BgL_arg2221z00_12069, 
(int)(((long)3)), 
CINT(BgL_arityz00_12062)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1194z00_12068;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12090;
BgL_z12denvz12_12090 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12090, BgL_locz00_9877); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9880, BgL_bpz00_12056, BgL_sfz00_12064))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12063;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12091;
BgL_nsz00_12091 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2223z00_12092;
BgL_arg2223z00_12092 = 
(
(long)CINT(BgL_bpz00_12056)+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12091, ((long)2), BgL_sz00_9880, BgL_bpz00_12056, 
BINT(BgL_arg2223z00_12092)); } 
VECTOR_SET(BgL_nsz00_12091,((long)1),BgL_sz00_9880); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12090, BgL_nsz00_12091); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12093;
BgL_ez00_12093 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12093, BgL_sz00_9880); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12094;
BgL_____rz00_12094 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12063, BgL_nsz00_12091, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12093); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12090, BgL_sz00_9880); 
return BgL_____rz00_12094;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12057, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12095;
BgL_nbpz00_12095 = 
(
(long)CINT(BgL_bpz00_12056)+BgL_siza7eza7_9879); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),((long)0),
BINT(BgL_nbpz00_12095)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17302;
BgL_tmpz00_17302 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17302, BgL_locz00_9877); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12096;
BgL_rz00_12096 = 
PROCEDURE_ENTRY(BgL_fz00_12057)(BgL_fz00_12057, BgL_a1z00_12058, BgL_a2z00_12059, BgL_a3z00_12060, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9880),((long)0),BgL_bpz00_12056); 
return BgL_rz00_12096;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9877, BgL_symbzd2funzd2_9878, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_12057));} } } } } } } } 

}



/* &<@anonymous:2227> */
obj_t BGl_z62zc3z04anonymousza32227ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9881, obj_t BgL_sz00_9889)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9882;obj_t BgL_a1z00_9883;obj_t BgL_a2z00_9884;obj_t BgL_a3z00_9885;obj_t BgL_locz00_9886;obj_t BgL_symbzd2funzd2_9887;long BgL_siza7eza7_9888;
BgL_funz00_9882 = 
PROCEDURE_REF(BgL_envz00_9881, 
(int)(((long)0))); 
BgL_a1z00_9883 = 
PROCEDURE_REF(BgL_envz00_9881, 
(int)(((long)1))); 
BgL_a2z00_9884 = 
PROCEDURE_REF(BgL_envz00_9881, 
(int)(((long)2))); 
BgL_a3z00_9885 = 
PROCEDURE_REF(BgL_envz00_9881, 
(int)(((long)3))); 
BgL_locz00_9886 = 
PROCEDURE_REF(BgL_envz00_9881, 
(int)(((long)4))); 
BgL_symbzd2funzd2_9887 = 
PROCEDURE_REF(BgL_envz00_9881, 
(int)(((long)5))); 
BgL_siza7eza7_9888 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9881, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12097;
BgL_bpz00_12097 = 
VECTOR_REF(
((obj_t)BgL_sz00_9889),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12098;obj_t BgL_a1z00_12099;obj_t BgL_a2z00_12100;obj_t BgL_a3z00_12101;
BgL_fz00_12098 = 
PROCEDURE_ENTRY(BgL_funz00_9882)(BgL_funz00_9882, BgL_sz00_9889, BEOA); 
BgL_a1z00_12099 = 
PROCEDURE_ENTRY(BgL_a1z00_9883)(BgL_a1z00_9883, BgL_sz00_9889, BEOA); 
BgL_a2z00_12100 = 
PROCEDURE_ENTRY(BgL_a2z00_9884)(BgL_a2z00_9884, BgL_sz00_9889, BEOA); 
BgL_a3z00_12101 = 
PROCEDURE_ENTRY(BgL_a3z00_9885)(BgL_a3z00_9885, BgL_sz00_9889, BEOA); 
if(
PROCEDUREP(BgL_fz00_12098))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9886, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12098); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12102;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17352;
BgL_tmpz00_17352 = 
((obj_t)BgL_fz00_12098); 
BgL_ufz00_12102 = 
PROCEDURE_ATTR(BgL_tmpz00_17352); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4731z00_17355;
if(
STRUCTP(BgL_ufz00_12102))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4731z00_17355 = 
(
STRUCT_KEY(BgL_ufz00_12102)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4731z00_17355 = ((bool_t)0)
; } 
if(BgL_test4731z00_17355)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12103;obj_t BgL_runz00_12104;obj_t BgL_sfz00_12105;
BgL_arityz00_12103 = 
STRUCT_REF(BgL_ufz00_12102, 
(int)(((long)0))); 
BgL_runz00_12104 = 
STRUCT_REF(BgL_ufz00_12102, 
(int)(((long)1))); 
BgL_sfz00_12105 = 
STRUCT_REF(BgL_ufz00_12102, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12103)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2231z00_12106;
BgL_arg2231z00_12106 = 
(
(long)CINT(BgL_bpz00_12097)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2231z00_12106,BgL_a1z00_12099); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2232z00_12107;
BgL_arg2232z00_12107 = 
(
(long)CINT(BgL_bpz00_12097)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2232z00_12107,BgL_a2z00_12100); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2233z00_12108;
BgL_arg2233z00_12108 = 
(
(long)CINT(BgL_bpz00_12097)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2233z00_12108,BgL_a3z00_12101); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12103))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12103)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2235z00_12111;obj_t BgL_arg2236z00_12112;
BgL_arg2235z00_12111 = 
(
(long)CINT(BgL_bpz00_12097)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2237z00_12113;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2238z00_12114;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2239z00_12115;
BgL_arg2239z00_12115 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12101, BNIL); 
BgL_arg2238z00_12114 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12100, BgL_arg2239z00_12115); } 
BgL_list2237z00_12113 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12099, BgL_arg2238z00_12114); } 
BgL_arg2236z00_12112 = BgL_list2237z00_12113; } 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2235z00_12111,BgL_arg2236z00_12112); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2240z00_12116;
BgL_arg2240z00_12116 = 
(
(long)CINT(BgL_bpz00_12097)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2240z00_12116,BgL_a1z00_12099); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2241z00_12117;obj_t BgL_arg2242z00_12118;
BgL_arg2241z00_12117 = 
(
(long)CINT(BgL_bpz00_12097)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2243z00_12119;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2244z00_12120;
BgL_arg2244z00_12120 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12101, BNIL); 
BgL_list2243z00_12119 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12100, BgL_arg2244z00_12120); } 
BgL_arg2242z00_12118 = BgL_list2243z00_12119; } 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2241z00_12117,BgL_arg2242z00_12118); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2245z00_12121;
BgL_arg2245z00_12121 = 
(
(long)CINT(BgL_bpz00_12097)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2245z00_12121,BgL_a1z00_12099); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2246z00_12122;
BgL_arg2246z00_12122 = 
(
(long)CINT(BgL_bpz00_12097)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2246z00_12122,BgL_a2z00_12100); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2247z00_12123;obj_t BgL_arg2248z00_12124;
BgL_arg2247z00_12123 = 
(
(long)CINT(BgL_bpz00_12097)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2249z00_12125;
BgL_list2249z00_12125 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12101, BNIL); 
BgL_arg2248z00_12124 = BgL_list2249z00_12125; } 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2247z00_12123,BgL_arg2248z00_12124); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2250z00_12126;
BgL_arg2250z00_12126 = 
(
(long)CINT(BgL_bpz00_12097)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2250z00_12126,BgL_a1z00_12099); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2251z00_12127;
BgL_arg2251z00_12127 = 
(
(long)CINT(BgL_bpz00_12097)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2251z00_12127,BgL_a2z00_12100); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2252z00_12128;
BgL_arg2252z00_12128 = 
(
(long)CINT(BgL_bpz00_12097)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2252z00_12128,BgL_a3z00_12101); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2253z00_12129;obj_t BgL_arg2254z00_12130;
BgL_arg2253z00_12129 = 
(
(long)CINT(BgL_bpz00_12097)+((long)3)); 
BgL_arg2254z00_12130 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9889),BgL_arg2253z00_12129,BgL_arg2254z00_12130); } break;
default: 
BgL_case_else1196z00_12109:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2256z00_12110;
BgL_arg2256z00_12110 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12102), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9886, BgL_arg2256z00_12110, 
(int)(((long)3)), 
CINT(BgL_arityz00_12103)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1196z00_12109;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12131;
BgL_z12denvz12_12131 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9889, BgL_bpz00_12097, BgL_sfz00_12105))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12104;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12132;
BgL_nsz00_12132 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2258z00_12133;
BgL_arg2258z00_12133 = 
(
(long)CINT(BgL_bpz00_12097)+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12132, ((long)2), BgL_sz00_9889, BgL_bpz00_12097, 
BINT(BgL_arg2258z00_12133)); } 
VECTOR_SET(BgL_nsz00_12132,((long)1),BgL_sz00_9889); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12131, BgL_nsz00_12132); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12134;
BgL_ez00_12134 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12134, BgL_sz00_9889); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12135;
BgL_____rz00_12135 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12104, BgL_nsz00_12132, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12134); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12131, BgL_sz00_9889); 
return BgL_____rz00_12135;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12098, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12136;
BgL_nbpz00_12136 = 
(
(long)CINT(BgL_bpz00_12097)+BgL_siza7eza7_9888); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),((long)0),
BINT(BgL_nbpz00_12136)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12137;
BgL_rz00_12137 = 
PROCEDURE_ENTRY(BgL_fz00_12098)(BgL_fz00_12098, BgL_a1z00_12099, BgL_a2z00_12100, BgL_a3z00_12101, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9889),((long)0),BgL_bpz00_12097); 
return BgL_rz00_12137;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9886, BgL_symbzd2funzd2_9887, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_12098));} } } } } } } } 

}



/* &<@anonymous:2264> */
obj_t BGl_z62zc3z04anonymousza32264ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9890, obj_t BgL_sz00_9898)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9891;obj_t BgL_a1z00_9892;obj_t BgL_a2z00_9893;obj_t BgL_a3z00_9894;obj_t BgL_locz00_9895;obj_t BgL_symbzd2funzd2_9896;long BgL_siza7eza7_9897;
BgL_funz00_9891 = 
PROCEDURE_REF(BgL_envz00_9890, 
(int)(((long)0))); 
BgL_a1z00_9892 = 
PROCEDURE_REF(BgL_envz00_9890, 
(int)(((long)1))); 
BgL_a2z00_9893 = 
PROCEDURE_REF(BgL_envz00_9890, 
(int)(((long)2))); 
BgL_a3z00_9894 = 
PROCEDURE_REF(BgL_envz00_9890, 
(int)(((long)3))); 
BgL_locz00_9895 = 
PROCEDURE_REF(BgL_envz00_9890, 
(int)(((long)4))); 
BgL_symbzd2funzd2_9896 = 
PROCEDURE_REF(BgL_envz00_9890, 
(int)(((long)5))); 
BgL_siza7eza7_9897 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9890, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12138;
BgL_bpz00_12138 = 
VECTOR_REF(
((obj_t)BgL_sz00_9898),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12139;obj_t BgL_a1z00_12140;obj_t BgL_a2z00_12141;obj_t BgL_a3z00_12142;
BgL_fz00_12139 = 
PROCEDURE_ENTRY(BgL_funz00_9891)(BgL_funz00_9891, BgL_sz00_9898, BEOA); 
BgL_a1z00_12140 = 
PROCEDURE_ENTRY(BgL_a1z00_9892)(BgL_a1z00_9892, BgL_sz00_9898, BEOA); 
BgL_a2z00_12141 = 
PROCEDURE_ENTRY(BgL_a2z00_9893)(BgL_a2z00_9893, BgL_sz00_9898, BEOA); 
BgL_a3z00_12142 = 
PROCEDURE_ENTRY(BgL_a3z00_9894)(BgL_a3z00_9894, BgL_sz00_9898, BEOA); 
if(
PROCEDUREP(BgL_fz00_12139))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9895, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12139); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12143;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17508;
BgL_tmpz00_17508 = 
((obj_t)BgL_fz00_12139); 
BgL_ufz00_12143 = 
PROCEDURE_ATTR(BgL_tmpz00_17508); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4738z00_17511;
if(
STRUCTP(BgL_ufz00_12143))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4738z00_17511 = 
(
STRUCT_KEY(BgL_ufz00_12143)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4738z00_17511 = ((bool_t)0)
; } 
if(BgL_test4738z00_17511)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12144;obj_t BgL_runz00_12145;obj_t BgL_sfz00_12146;
BgL_arityz00_12144 = 
STRUCT_REF(BgL_ufz00_12143, 
(int)(((long)0))); 
BgL_runz00_12145 = 
STRUCT_REF(BgL_ufz00_12143, 
(int)(((long)1))); 
BgL_sfz00_12146 = 
STRUCT_REF(BgL_ufz00_12143, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12147;
BgL_spz00_12147 = 
(
(long)CINT(BgL_bpz00_12138)+BgL_siza7eza7_9897); 
if(
(
(long)CINT(BgL_arityz00_12144)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2268z00_12148;
BgL_arg2268z00_12148 = 
(BgL_spz00_12147+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2268z00_12148,BgL_a1z00_12140); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2269z00_12149;
BgL_arg2269z00_12149 = 
(BgL_spz00_12147+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2269z00_12149,BgL_a2z00_12141); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2270z00_12150;
BgL_arg2270z00_12150 = 
(BgL_spz00_12147+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2270z00_12150,BgL_a3z00_12142); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12144))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12144)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2272z00_12153;obj_t BgL_arg2273z00_12154;
BgL_arg2272z00_12153 = 
(BgL_spz00_12147+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2274z00_12155;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2275z00_12156;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2276z00_12157;
BgL_arg2276z00_12157 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12142, BNIL); 
BgL_arg2275z00_12156 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12141, BgL_arg2276z00_12157); } 
BgL_list2274z00_12155 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12140, BgL_arg2275z00_12156); } 
BgL_arg2273z00_12154 = BgL_list2274z00_12155; } 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2272z00_12153,BgL_arg2273z00_12154); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2277z00_12158;
BgL_arg2277z00_12158 = 
(BgL_spz00_12147+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2277z00_12158,BgL_a1z00_12140); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2278z00_12159;obj_t BgL_arg2279z00_12160;
BgL_arg2278z00_12159 = 
(BgL_spz00_12147+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2280z00_12161;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2281z00_12162;
BgL_arg2281z00_12162 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12142, BNIL); 
BgL_list2280z00_12161 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12141, BgL_arg2281z00_12162); } 
BgL_arg2279z00_12160 = BgL_list2280z00_12161; } 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2278z00_12159,BgL_arg2279z00_12160); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2282z00_12163;
BgL_arg2282z00_12163 = 
(BgL_spz00_12147+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2282z00_12163,BgL_a1z00_12140); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2283z00_12164;
BgL_arg2283z00_12164 = 
(BgL_spz00_12147+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2283z00_12164,BgL_a2z00_12141); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2284z00_12165;obj_t BgL_arg2285z00_12166;
BgL_arg2284z00_12165 = 
(BgL_spz00_12147+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2286z00_12167;
BgL_list2286z00_12167 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12142, BNIL); 
BgL_arg2285z00_12166 = BgL_list2286z00_12167; } 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2284z00_12165,BgL_arg2285z00_12166); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2287z00_12168;
BgL_arg2287z00_12168 = 
(BgL_spz00_12147+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2287z00_12168,BgL_a1z00_12140); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2288z00_12169;
BgL_arg2288z00_12169 = 
(BgL_spz00_12147+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2288z00_12169,BgL_a2z00_12141); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2289z00_12170;
BgL_arg2289z00_12170 = 
(BgL_spz00_12147+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2289z00_12170,BgL_a3z00_12142); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2290z00_12171;obj_t BgL_arg2291z00_12172;
BgL_arg2290z00_12171 = 
(BgL_spz00_12147+((long)3)); 
BgL_arg2291z00_12172 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9898),BgL_arg2290z00_12171,BgL_arg2291z00_12172); } break;
default: 
BgL_case_else1198z00_12151:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2293z00_12152;
BgL_arg2293z00_12152 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12143), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9895, BgL_arg2293z00_12152, 
(int)(((long)3)), 
CINT(BgL_arityz00_12144)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1198z00_12151;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12173;
BgL_z12denvz12_12173 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12173, BgL_locz00_9895); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9898, 
BINT(BgL_spz00_12147), BgL_sfz00_12146))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12145, BgL_sz00_9898, 
BINT(BgL_spz00_12147));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12174;
BgL_nsz00_12174 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2295z00_12175;
BgL_arg2295z00_12175 = 
(BgL_spz00_12147+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12174, ((long)2), BgL_sz00_9898, 
BINT(BgL_spz00_12147), 
BINT(BgL_arg2295z00_12175)); } 
VECTOR_SET(BgL_nsz00_12174,((long)1),BgL_sz00_9898); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12173, BgL_nsz00_12174); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12176;
BgL_ez00_12176 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12176, BgL_sz00_9898); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12177;
BgL_____rz00_12177 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12145, BgL_nsz00_12174, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12176); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12173, BgL_sz00_9898); 
return BgL_____rz00_12177;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12139, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12178;
BgL_nbpz00_12178 = 
(
(long)CINT(BgL_bpz00_12138)+BgL_siza7eza7_9897); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),((long)0),
BINT(BgL_nbpz00_12178)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17610;
BgL_tmpz00_17610 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17610, BgL_locz00_9895); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12179;
BgL_rz00_12179 = 
PROCEDURE_ENTRY(BgL_fz00_12139)(BgL_fz00_12139, BgL_a1z00_12140, BgL_a2z00_12141, BgL_a3z00_12142, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9898),((long)0),BgL_bpz00_12138); 
return BgL_rz00_12179;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9895, BgL_symbzd2funzd2_9896, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_12139));} } } } } } } } 

}



/* &<@anonymous:2299> */
obj_t BGl_z62zc3z04anonymousza32299ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9899, obj_t BgL_sz00_9907)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9900;obj_t BgL_a1z00_9901;obj_t BgL_a2z00_9902;obj_t BgL_a3z00_9903;obj_t BgL_locz00_9904;obj_t BgL_symbzd2funzd2_9905;long BgL_siza7eza7_9906;
BgL_funz00_9900 = 
PROCEDURE_REF(BgL_envz00_9899, 
(int)(((long)0))); 
BgL_a1z00_9901 = 
PROCEDURE_REF(BgL_envz00_9899, 
(int)(((long)1))); 
BgL_a2z00_9902 = 
PROCEDURE_REF(BgL_envz00_9899, 
(int)(((long)2))); 
BgL_a3z00_9903 = 
PROCEDURE_REF(BgL_envz00_9899, 
(int)(((long)3))); 
BgL_locz00_9904 = 
PROCEDURE_REF(BgL_envz00_9899, 
(int)(((long)4))); 
BgL_symbzd2funzd2_9905 = 
PROCEDURE_REF(BgL_envz00_9899, 
(int)(((long)5))); 
BgL_siza7eza7_9906 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9899, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12180;
BgL_bpz00_12180 = 
VECTOR_REF(
((obj_t)BgL_sz00_9907),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12181;obj_t BgL_a1z00_12182;obj_t BgL_a2z00_12183;obj_t BgL_a3z00_12184;
BgL_fz00_12181 = 
PROCEDURE_ENTRY(BgL_funz00_9900)(BgL_funz00_9900, BgL_sz00_9907, BEOA); 
BgL_a1z00_12182 = 
PROCEDURE_ENTRY(BgL_a1z00_9901)(BgL_a1z00_9901, BgL_sz00_9907, BEOA); 
BgL_a2z00_12183 = 
PROCEDURE_ENTRY(BgL_a2z00_9902)(BgL_a2z00_9902, BgL_sz00_9907, BEOA); 
BgL_a3z00_12184 = 
PROCEDURE_ENTRY(BgL_a3z00_9903)(BgL_a3z00_9903, BgL_sz00_9907, BEOA); 
if(
PROCEDUREP(BgL_fz00_12181))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9904, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12181); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12185;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17660;
BgL_tmpz00_17660 = 
((obj_t)BgL_fz00_12181); 
BgL_ufz00_12185 = 
PROCEDURE_ATTR(BgL_tmpz00_17660); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4745z00_17663;
if(
STRUCTP(BgL_ufz00_12185))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4745z00_17663 = 
(
STRUCT_KEY(BgL_ufz00_12185)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4745z00_17663 = ((bool_t)0)
; } 
if(BgL_test4745z00_17663)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12186;obj_t BgL_runz00_12187;obj_t BgL_sfz00_12188;
BgL_arityz00_12186 = 
STRUCT_REF(BgL_ufz00_12185, 
(int)(((long)0))); 
BgL_runz00_12187 = 
STRUCT_REF(BgL_ufz00_12185, 
(int)(((long)1))); 
BgL_sfz00_12188 = 
STRUCT_REF(BgL_ufz00_12185, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12189;
BgL_spz00_12189 = 
(
(long)CINT(BgL_bpz00_12180)+BgL_siza7eza7_9906); 
if(
(
(long)CINT(BgL_arityz00_12186)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2303z00_12190;
BgL_arg2303z00_12190 = 
(BgL_spz00_12189+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2303z00_12190,BgL_a1z00_12182); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2304z00_12191;
BgL_arg2304z00_12191 = 
(BgL_spz00_12189+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2304z00_12191,BgL_a2z00_12183); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2305z00_12192;
BgL_arg2305z00_12192 = 
(BgL_spz00_12189+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2305z00_12192,BgL_a3z00_12184); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12186))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12186)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2307z00_12195;obj_t BgL_arg2308z00_12196;
BgL_arg2307z00_12195 = 
(BgL_spz00_12189+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2309z00_12197;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2310z00_12198;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2311z00_12199;
BgL_arg2311z00_12199 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12184, BNIL); 
BgL_arg2310z00_12198 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12183, BgL_arg2311z00_12199); } 
BgL_list2309z00_12197 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12182, BgL_arg2310z00_12198); } 
BgL_arg2308z00_12196 = BgL_list2309z00_12197; } 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2307z00_12195,BgL_arg2308z00_12196); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2312z00_12200;
BgL_arg2312z00_12200 = 
(BgL_spz00_12189+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2312z00_12200,BgL_a1z00_12182); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2313z00_12201;obj_t BgL_arg2314z00_12202;
BgL_arg2313z00_12201 = 
(BgL_spz00_12189+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2315z00_12203;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2316z00_12204;
BgL_arg2316z00_12204 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12184, BNIL); 
BgL_list2315z00_12203 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12183, BgL_arg2316z00_12204); } 
BgL_arg2314z00_12202 = BgL_list2315z00_12203; } 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2313z00_12201,BgL_arg2314z00_12202); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2317z00_12205;
BgL_arg2317z00_12205 = 
(BgL_spz00_12189+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2317z00_12205,BgL_a1z00_12182); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2318z00_12206;
BgL_arg2318z00_12206 = 
(BgL_spz00_12189+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2318z00_12206,BgL_a2z00_12183); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2319z00_12207;obj_t BgL_arg2320z00_12208;
BgL_arg2319z00_12207 = 
(BgL_spz00_12189+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2321z00_12209;
BgL_list2321z00_12209 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12184, BNIL); 
BgL_arg2320z00_12208 = BgL_list2321z00_12209; } 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2319z00_12207,BgL_arg2320z00_12208); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2322z00_12210;
BgL_arg2322z00_12210 = 
(BgL_spz00_12189+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2322z00_12210,BgL_a1z00_12182); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2323z00_12211;
BgL_arg2323z00_12211 = 
(BgL_spz00_12189+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2323z00_12211,BgL_a2z00_12183); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2324z00_12212;
BgL_arg2324z00_12212 = 
(BgL_spz00_12189+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2324z00_12212,BgL_a3z00_12184); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2325z00_12213;obj_t BgL_arg2326z00_12214;
BgL_arg2325z00_12213 = 
(BgL_spz00_12189+((long)3)); 
BgL_arg2326z00_12214 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9907),BgL_arg2325z00_12213,BgL_arg2326z00_12214); } break;
default: 
BgL_case_else1200z00_12193:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2328z00_12194;
BgL_arg2328z00_12194 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12185), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9904, BgL_arg2328z00_12194, 
(int)(((long)3)), 
CINT(BgL_arityz00_12186)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1200z00_12193;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12215;
BgL_z12denvz12_12215 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9907, 
BINT(BgL_spz00_12189), BgL_sfz00_12188))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12187, BgL_sz00_9907, 
BINT(BgL_spz00_12189));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12216;
BgL_nsz00_12216 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2330z00_12217;
BgL_arg2330z00_12217 = 
(BgL_spz00_12189+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12216, ((long)2), BgL_sz00_9907, 
BINT(BgL_spz00_12189), 
BINT(BgL_arg2330z00_12217)); } 
VECTOR_SET(BgL_nsz00_12216,((long)1),BgL_sz00_9907); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12215, BgL_nsz00_12216); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12218;
BgL_ez00_12218 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12218, BgL_sz00_9907); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12219;
BgL_____rz00_12219 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12187, BgL_nsz00_12216, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12218); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12215, BgL_sz00_9907); 
return BgL_____rz00_12219;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12181, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12220;
BgL_nbpz00_12220 = 
(
(long)CINT(BgL_bpz00_12180)+BgL_siza7eza7_9906); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),((long)0),
BINT(BgL_nbpz00_12220)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12221;
BgL_rz00_12221 = 
PROCEDURE_ENTRY(BgL_fz00_12181)(BgL_fz00_12181, BgL_a1z00_12182, BgL_a2z00_12183, BgL_a3z00_12184, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9907),((long)0),BgL_bpz00_12180); 
return BgL_rz00_12221;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9904, BgL_symbzd2funzd2_9905, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_12181));} } } } } } } } 

}



/* comp-call4 */
obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172, BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174, obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177, long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180, obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2738;
BgL_cfunz00_2738 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173, ((long)4), BgL_locz00_172, BgL_symbzd2funzd2_174); 
if(
CBOOL(BgL_cfunz00_2738))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4752z00_17775;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2339z00_2760;
BgL_arg2339z00_2760 = 
bgl_debug(); 
BgL_test4752z00_17775 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2339z00_2760), 
BINT(((long)0))); } 
if(BgL_test4752z00_17775)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32336ze3z87_9908;
BgL_zc3z04anonymousza32336ze3z87_9908 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32336ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_9908, 
(int)(((long)0)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_9908, 
(int)(((long)1)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_9908, 
(int)(((long)2)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_9908, 
(int)(((long)3)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_9908, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_178)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_9908, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_9908, 
(int)(((long)6)), BgL_cfunz00_2738); 
return BgL_zc3z04anonymousza32336ze3z87_9908;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32338ze3z87_9909;
BgL_zc3z04anonymousza32338ze3z87_9909 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32338ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32338ze3z87_9909, 
(int)(((long)0)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32338ze3z87_9909, 
(int)(((long)1)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32338ze3z87_9909, 
(int)(((long)2)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32338ze3z87_9909, 
(int)(((long)3)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32338ze3z87_9909, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_178)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32338ze3z87_9909, 
(int)(((long)5)), BgL_cfunz00_2738); 
return BgL_zc3z04anonymousza32338ze3z87_9909;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_176))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4754z00_17816;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2433z00_2896;
BgL_arg2433z00_2896 = 
bgl_debug(); 
BgL_test4754z00_17816 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2433z00_2896), 
BINT(((long)0))); } 
if(BgL_test4754z00_17816)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32342ze3z87_9910;
BgL_zc3z04anonymousza32342ze3z87_9910 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32342ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32342ze3z87_9910, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32342ze3z87_9910, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32342ze3z87_9910, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32342ze3z87_9910, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32342ze3z87_9910, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32342ze3z87_9910, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32342ze3z87_9910, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32342ze3z87_9910, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32342ze3z87_9910;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32388ze3z87_9911;
BgL_zc3z04anonymousza32388ze3z87_9911 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32388ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32388ze3z87_9911, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32388ze3z87_9911, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32388ze3z87_9911, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32388ze3z87_9911, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32388ze3z87_9911, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32388ze3z87_9911, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32388ze3z87_9911, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32388ze3z87_9911, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32388ze3z87_9911;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4755z00_17861;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2527z00_3032;
BgL_arg2527z00_3032 = 
bgl_debug(); 
BgL_test4755z00_17861 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2527z00_3032), 
BINT(((long)0))); } 
if(BgL_test4755z00_17861)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32436ze3z87_9912;
BgL_zc3z04anonymousza32436ze3z87_9912 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32436ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32436ze3z87_9912, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32436ze3z87_9912, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32436ze3z87_9912, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32436ze3z87_9912, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32436ze3z87_9912, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32436ze3z87_9912, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32436ze3z87_9912, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32436ze3z87_9912, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32436ze3z87_9912;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32482ze3z87_9913;
BgL_zc3z04anonymousza32482ze3z87_9913 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32482ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_9913, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_9913, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_9913, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_9913, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_9913, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_9913, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_9913, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32482ze3z87_9913, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32482ze3z87_9913;} } } } } 

}



/* &<@anonymous:2336> */
obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9914, obj_t BgL_sz00_9922)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_9915;obj_t BgL_a2z00_9916;obj_t BgL_a3z00_9917;obj_t BgL_a4z00_9918;long BgL_siza7eza7_9919;obj_t BgL_locz00_9920;obj_t BgL_cfunz00_9921;
BgL_a1z00_9915 = 
PROCEDURE_REF(BgL_envz00_9914, 
(int)(((long)0))); 
BgL_a2z00_9916 = 
PROCEDURE_REF(BgL_envz00_9914, 
(int)(((long)1))); 
BgL_a3z00_9917 = 
PROCEDURE_REF(BgL_envz00_9914, 
(int)(((long)2))); 
BgL_a4z00_9918 = 
PROCEDURE_REF(BgL_envz00_9914, 
(int)(((long)3))); 
BgL_siza7eza7_9919 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9914, 
(int)(((long)4)))); 
BgL_locz00_9920 = 
PROCEDURE_REF(BgL_envz00_9914, 
(int)(((long)5))); 
BgL_cfunz00_9921 = 
PROCEDURE_REF(BgL_envz00_9914, 
(int)(((long)6))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12222;
BgL_bpz00_12222 = 
VECTOR_REF(
((obj_t)BgL_sz00_9922),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12223;obj_t BgL_a2z00_12224;obj_t BgL_a3z00_12225;obj_t BgL_a4z00_12226;
BgL_a1z00_12223 = 
PROCEDURE_ENTRY(BgL_a1z00_9915)(BgL_a1z00_9915, BgL_sz00_9922, BEOA); 
BgL_a2z00_12224 = 
PROCEDURE_ENTRY(BgL_a2z00_9916)(BgL_a2z00_9916, BgL_sz00_9922, BEOA); 
BgL_a3z00_12225 = 
PROCEDURE_ENTRY(BgL_a3z00_9917)(BgL_a3z00_9917, BgL_sz00_9922, BEOA); 
BgL_a4z00_12226 = 
PROCEDURE_ENTRY(BgL_a4z00_9918)(BgL_a4z00_9918, BgL_sz00_9922, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12227;
BgL_nbpz00_12227 = 
(
(long)CINT(BgL_bpz00_12222)+BgL_siza7eza7_9919); 
VECTOR_SET(
((obj_t)BgL_sz00_9922),((long)0),
BINT(BgL_nbpz00_12227)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17944;
BgL_tmpz00_17944 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17944, BgL_locz00_9920); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12228;
BgL_rz00_12228 = 
PROCEDURE_ENTRY(BgL_cfunz00_9921)(BgL_cfunz00_9921, BgL_a1z00_12223, BgL_a2z00_12224, BgL_a3z00_12225, BgL_a4z00_12226, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9922),((long)0),BgL_bpz00_12222); 
return BgL_rz00_12228;} } } } } } 

}



/* &<@anonymous:2338> */
obj_t BGl_z62zc3z04anonymousza32338ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9923, obj_t BgL_sz00_9930)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_9924;obj_t BgL_a2z00_9925;obj_t BgL_a3z00_9926;obj_t BgL_a4z00_9927;long BgL_siza7eza7_9928;obj_t BgL_cfunz00_9929;
BgL_a1z00_9924 = 
PROCEDURE_REF(BgL_envz00_9923, 
(int)(((long)0))); 
BgL_a2z00_9925 = 
PROCEDURE_REF(BgL_envz00_9923, 
(int)(((long)1))); 
BgL_a3z00_9926 = 
PROCEDURE_REF(BgL_envz00_9923, 
(int)(((long)2))); 
BgL_a4z00_9927 = 
PROCEDURE_REF(BgL_envz00_9923, 
(int)(((long)3))); 
BgL_siza7eza7_9928 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9923, 
(int)(((long)4)))); 
BgL_cfunz00_9929 = 
PROCEDURE_REF(BgL_envz00_9923, 
(int)(((long)5))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12229;
BgL_bpz00_12229 = 
VECTOR_REF(
((obj_t)BgL_sz00_9930),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12230;obj_t BgL_a2z00_12231;obj_t BgL_a3z00_12232;obj_t BgL_a4z00_12233;
BgL_a1z00_12230 = 
PROCEDURE_ENTRY(BgL_a1z00_9924)(BgL_a1z00_9924, BgL_sz00_9930, BEOA); 
BgL_a2z00_12231 = 
PROCEDURE_ENTRY(BgL_a2z00_9925)(BgL_a2z00_9925, BgL_sz00_9930, BEOA); 
BgL_a3z00_12232 = 
PROCEDURE_ENTRY(BgL_a3z00_9926)(BgL_a3z00_9926, BgL_sz00_9930, BEOA); 
BgL_a4z00_12233 = 
PROCEDURE_ENTRY(BgL_a4z00_9927)(BgL_a4z00_9927, BgL_sz00_9930, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12234;
BgL_nbpz00_12234 = 
(
(long)CINT(BgL_bpz00_12229)+BgL_siza7eza7_9928); 
VECTOR_SET(
((obj_t)BgL_sz00_9930),((long)0),
BINT(BgL_nbpz00_12234)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12235;
BgL_rz00_12235 = 
PROCEDURE_ENTRY(BgL_cfunz00_9929)(BgL_cfunz00_9929, BgL_a1z00_12230, BgL_a2z00_12231, BgL_a3z00_12232, BgL_a4z00_12233, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9930),((long)0),BgL_bpz00_12229); 
return BgL_rz00_12235;} } } } } } 

}



/* &<@anonymous:2342> */
obj_t BGl_z62zc3z04anonymousza32342ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9931, obj_t BgL_sz00_9940)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9932;obj_t BgL_a1z00_9933;obj_t BgL_a2z00_9934;obj_t BgL_a3z00_9935;obj_t BgL_a4z00_9936;obj_t BgL_locz00_9937;obj_t BgL_symbzd2funzd2_9938;long BgL_siza7eza7_9939;
BgL_funz00_9932 = 
PROCEDURE_REF(BgL_envz00_9931, 
(int)(((long)0))); 
BgL_a1z00_9933 = 
PROCEDURE_REF(BgL_envz00_9931, 
(int)(((long)1))); 
BgL_a2z00_9934 = 
PROCEDURE_REF(BgL_envz00_9931, 
(int)(((long)2))); 
BgL_a3z00_9935 = 
PROCEDURE_REF(BgL_envz00_9931, 
(int)(((long)3))); 
BgL_a4z00_9936 = 
PROCEDURE_REF(BgL_envz00_9931, 
(int)(((long)4))); 
BgL_locz00_9937 = 
PROCEDURE_REF(BgL_envz00_9931, 
(int)(((long)5))); 
BgL_symbzd2funzd2_9938 = 
PROCEDURE_REF(BgL_envz00_9931, 
(int)(((long)6))); 
BgL_siza7eza7_9939 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9931, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12236;
BgL_bpz00_12236 = 
VECTOR_REF(
((obj_t)BgL_sz00_9940),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12237;obj_t BgL_a1z00_12238;obj_t BgL_a2z00_12239;obj_t BgL_a3z00_12240;obj_t BgL_a4z00_12241;
BgL_fz00_12237 = 
PROCEDURE_ENTRY(BgL_funz00_9932)(BgL_funz00_9932, BgL_sz00_9940, BEOA); 
BgL_a1z00_12238 = 
PROCEDURE_ENTRY(BgL_a1z00_9933)(BgL_a1z00_9933, BgL_sz00_9940, BEOA); 
BgL_a2z00_12239 = 
PROCEDURE_ENTRY(BgL_a2z00_9934)(BgL_a2z00_9934, BgL_sz00_9940, BEOA); 
BgL_a3z00_12240 = 
PROCEDURE_ENTRY(BgL_a3z00_9935)(BgL_a3z00_9935, BgL_sz00_9940, BEOA); 
BgL_a4z00_12241 = 
PROCEDURE_ENTRY(BgL_a4z00_9936)(BgL_a4z00_9936, BgL_sz00_9940, BEOA); 
if(
PROCEDUREP(BgL_fz00_12237))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9937, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12237); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12242;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18043;
BgL_tmpz00_18043 = 
((obj_t)BgL_fz00_12237); 
BgL_ufz00_12242 = 
PROCEDURE_ATTR(BgL_tmpz00_18043); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4757z00_18046;
if(
STRUCTP(BgL_ufz00_12242))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4757z00_18046 = 
(
STRUCT_KEY(BgL_ufz00_12242)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4757z00_18046 = ((bool_t)0)
; } 
if(BgL_test4757z00_18046)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12243;obj_t BgL_runz00_12244;obj_t BgL_sfz00_12245;
BgL_arityz00_12243 = 
STRUCT_REF(BgL_ufz00_12242, 
(int)(((long)0))); 
BgL_runz00_12244 = 
STRUCT_REF(BgL_ufz00_12242, 
(int)(((long)1))); 
BgL_sfz00_12245 = 
STRUCT_REF(BgL_ufz00_12242, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12243)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2346z00_12246;
BgL_arg2346z00_12246 = 
(
(long)CINT(BgL_bpz00_12236)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2346z00_12246,BgL_a1z00_12238); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2347z00_12247;
BgL_arg2347z00_12247 = 
(
(long)CINT(BgL_bpz00_12236)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2347z00_12247,BgL_a2z00_12239); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2348z00_12248;
BgL_arg2348z00_12248 = 
(
(long)CINT(BgL_bpz00_12236)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2348z00_12248,BgL_a3z00_12240); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2349z00_12249;
BgL_arg2349z00_12249 = 
(
(long)CINT(BgL_bpz00_12236)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2349z00_12249,BgL_a4z00_12241); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12243))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12243)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2351z00_12252;obj_t BgL_arg2352z00_12253;
BgL_arg2351z00_12252 = 
(
(long)CINT(BgL_bpz00_12236)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2353z00_12254;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2354z00_12255;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2355z00_12256;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2356z00_12257;
BgL_arg2356z00_12257 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12241, BNIL); 
BgL_arg2355z00_12256 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12240, BgL_arg2356z00_12257); } 
BgL_arg2354z00_12255 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12239, BgL_arg2355z00_12256); } 
BgL_list2353z00_12254 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12238, BgL_arg2354z00_12255); } 
BgL_arg2352z00_12253 = BgL_list2353z00_12254; } 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2351z00_12252,BgL_arg2352z00_12253); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2357z00_12258;
BgL_arg2357z00_12258 = 
(
(long)CINT(BgL_bpz00_12236)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2357z00_12258,BgL_a1z00_12238); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2358z00_12259;obj_t BgL_arg2359z00_12260;
BgL_arg2358z00_12259 = 
(
(long)CINT(BgL_bpz00_12236)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2360z00_12261;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2361z00_12262;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2362z00_12263;
BgL_arg2362z00_12263 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12241, BNIL); 
BgL_arg2361z00_12262 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12240, BgL_arg2362z00_12263); } 
BgL_list2360z00_12261 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12239, BgL_arg2361z00_12262); } 
BgL_arg2359z00_12260 = BgL_list2360z00_12261; } 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2358z00_12259,BgL_arg2359z00_12260); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2363z00_12264;
BgL_arg2363z00_12264 = 
(
(long)CINT(BgL_bpz00_12236)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2363z00_12264,BgL_a1z00_12238); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2364z00_12265;
BgL_arg2364z00_12265 = 
(
(long)CINT(BgL_bpz00_12236)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2364z00_12265,BgL_a2z00_12239); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2365z00_12266;obj_t BgL_arg2366z00_12267;
BgL_arg2365z00_12266 = 
(
(long)CINT(BgL_bpz00_12236)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2367z00_12268;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2368z00_12269;
BgL_arg2368z00_12269 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12241, BNIL); 
BgL_list2367z00_12268 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12240, BgL_arg2368z00_12269); } 
BgL_arg2366z00_12267 = BgL_list2367z00_12268; } 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2365z00_12266,BgL_arg2366z00_12267); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2369z00_12270;
BgL_arg2369z00_12270 = 
(
(long)CINT(BgL_bpz00_12236)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2369z00_12270,BgL_a1z00_12238); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2370z00_12271;
BgL_arg2370z00_12271 = 
(
(long)CINT(BgL_bpz00_12236)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2370z00_12271,BgL_a2z00_12239); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2371z00_12272;
BgL_arg2371z00_12272 = 
(
(long)CINT(BgL_bpz00_12236)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2371z00_12272,BgL_a3z00_12240); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2372z00_12273;obj_t BgL_arg2373z00_12274;
BgL_arg2372z00_12273 = 
(
(long)CINT(BgL_bpz00_12236)+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2374z00_12275;
BgL_list2374z00_12275 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12241, BNIL); 
BgL_arg2373z00_12274 = BgL_list2374z00_12275; } 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2372z00_12273,BgL_arg2373z00_12274); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2375z00_12276;
BgL_arg2375z00_12276 = 
(
(long)CINT(BgL_bpz00_12236)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2375z00_12276,BgL_a1z00_12238); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2376z00_12277;
BgL_arg2376z00_12277 = 
(
(long)CINT(BgL_bpz00_12236)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2376z00_12277,BgL_a2z00_12239); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2377z00_12278;
BgL_arg2377z00_12278 = 
(
(long)CINT(BgL_bpz00_12236)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2377z00_12278,BgL_a3z00_12240); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2378z00_12279;
BgL_arg2378z00_12279 = 
(
(long)CINT(BgL_bpz00_12236)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2378z00_12279,BgL_a4z00_12241); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2379z00_12280;obj_t BgL_arg2380z00_12281;
BgL_arg2379z00_12280 = 
(
(long)CINT(BgL_bpz00_12236)+((long)4)); 
BgL_arg2380z00_12281 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9940),BgL_arg2379z00_12280,BgL_arg2380z00_12281); } break;
default: 
BgL_case_else1202z00_12250:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2382z00_12251;
BgL_arg2382z00_12251 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12242), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9937, BgL_arg2382z00_12251, 
(int)(((long)4)), 
CINT(BgL_arityz00_12243)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1202z00_12250;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12282;
BgL_z12denvz12_12282 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12282, BgL_locz00_9937); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9940, BgL_bpz00_12236, BgL_sfz00_12245))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12244;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12283;
BgL_nsz00_12283 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2384z00_12284;
BgL_arg2384z00_12284 = 
(
(long)CINT(BgL_bpz00_12236)+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12283, ((long)2), BgL_sz00_9940, BgL_bpz00_12236, 
BINT(BgL_arg2384z00_12284)); } 
VECTOR_SET(BgL_nsz00_12283,((long)1),BgL_sz00_9940); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12282, BgL_nsz00_12283); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12285;
BgL_ez00_12285 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12285, BgL_sz00_9940); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12286;
BgL_____rz00_12286 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12244, BgL_nsz00_12283, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12285); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12282, BgL_sz00_9940); 
return BgL_____rz00_12286;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12237, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12287;
BgL_nbpz00_12287 = 
(
(long)CINT(BgL_bpz00_12236)+BgL_siza7eza7_9939); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),((long)0),
BINT(BgL_nbpz00_12287)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18181;
BgL_tmpz00_18181 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18181, BgL_locz00_9937); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12288;
BgL_rz00_12288 = 
PROCEDURE_ENTRY(BgL_fz00_12237)(BgL_fz00_12237, BgL_a1z00_12238, BgL_a2z00_12239, BgL_a3z00_12240, BgL_a4z00_12241, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9940),((long)0),BgL_bpz00_12236); 
return BgL_rz00_12288;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9937, BgL_symbzd2funzd2_9938, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_12237));} } } } } } } } 

}



/* &<@anonymous:2388> */
obj_t BGl_z62zc3z04anonymousza32388ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9941, obj_t BgL_sz00_9950)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9942;obj_t BgL_a1z00_9943;obj_t BgL_a2z00_9944;obj_t BgL_a3z00_9945;obj_t BgL_a4z00_9946;obj_t BgL_locz00_9947;obj_t BgL_symbzd2funzd2_9948;long BgL_siza7eza7_9949;
BgL_funz00_9942 = 
PROCEDURE_REF(BgL_envz00_9941, 
(int)(((long)0))); 
BgL_a1z00_9943 = 
PROCEDURE_REF(BgL_envz00_9941, 
(int)(((long)1))); 
BgL_a2z00_9944 = 
PROCEDURE_REF(BgL_envz00_9941, 
(int)(((long)2))); 
BgL_a3z00_9945 = 
PROCEDURE_REF(BgL_envz00_9941, 
(int)(((long)3))); 
BgL_a4z00_9946 = 
PROCEDURE_REF(BgL_envz00_9941, 
(int)(((long)4))); 
BgL_locz00_9947 = 
PROCEDURE_REF(BgL_envz00_9941, 
(int)(((long)5))); 
BgL_symbzd2funzd2_9948 = 
PROCEDURE_REF(BgL_envz00_9941, 
(int)(((long)6))); 
BgL_siza7eza7_9949 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9941, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12289;
BgL_bpz00_12289 = 
VECTOR_REF(
((obj_t)BgL_sz00_9950),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12290;obj_t BgL_a1z00_12291;obj_t BgL_a2z00_12292;obj_t BgL_a3z00_12293;obj_t BgL_a4z00_12294;
BgL_fz00_12290 = 
PROCEDURE_ENTRY(BgL_funz00_9942)(BgL_funz00_9942, BgL_sz00_9950, BEOA); 
BgL_a1z00_12291 = 
PROCEDURE_ENTRY(BgL_a1z00_9943)(BgL_a1z00_9943, BgL_sz00_9950, BEOA); 
BgL_a2z00_12292 = 
PROCEDURE_ENTRY(BgL_a2z00_9944)(BgL_a2z00_9944, BgL_sz00_9950, BEOA); 
BgL_a3z00_12293 = 
PROCEDURE_ENTRY(BgL_a3z00_9945)(BgL_a3z00_9945, BgL_sz00_9950, BEOA); 
BgL_a4z00_12294 = 
PROCEDURE_ENTRY(BgL_a4z00_9946)(BgL_a4z00_9946, BgL_sz00_9950, BEOA); 
if(
PROCEDUREP(BgL_fz00_12290))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9947, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12290); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12295;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18238;
BgL_tmpz00_18238 = 
((obj_t)BgL_fz00_12290); 
BgL_ufz00_12295 = 
PROCEDURE_ATTR(BgL_tmpz00_18238); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4764z00_18241;
if(
STRUCTP(BgL_ufz00_12295))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4764z00_18241 = 
(
STRUCT_KEY(BgL_ufz00_12295)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4764z00_18241 = ((bool_t)0)
; } 
if(BgL_test4764z00_18241)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12296;obj_t BgL_runz00_12297;obj_t BgL_sfz00_12298;
BgL_arityz00_12296 = 
STRUCT_REF(BgL_ufz00_12295, 
(int)(((long)0))); 
BgL_runz00_12297 = 
STRUCT_REF(BgL_ufz00_12295, 
(int)(((long)1))); 
BgL_sfz00_12298 = 
STRUCT_REF(BgL_ufz00_12295, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12296)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2392z00_12299;
BgL_arg2392z00_12299 = 
(
(long)CINT(BgL_bpz00_12289)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2392z00_12299,BgL_a1z00_12291); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2393z00_12300;
BgL_arg2393z00_12300 = 
(
(long)CINT(BgL_bpz00_12289)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2393z00_12300,BgL_a2z00_12292); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2394z00_12301;
BgL_arg2394z00_12301 = 
(
(long)CINT(BgL_bpz00_12289)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2394z00_12301,BgL_a3z00_12293); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2395z00_12302;
BgL_arg2395z00_12302 = 
(
(long)CINT(BgL_bpz00_12289)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2395z00_12302,BgL_a4z00_12294); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12296))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12296)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2397z00_12305;obj_t BgL_arg2398z00_12306;
BgL_arg2397z00_12305 = 
(
(long)CINT(BgL_bpz00_12289)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2399z00_12307;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2400z00_12308;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2401z00_12309;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2402z00_12310;
BgL_arg2402z00_12310 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12294, BNIL); 
BgL_arg2401z00_12309 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12293, BgL_arg2402z00_12310); } 
BgL_arg2400z00_12308 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12292, BgL_arg2401z00_12309); } 
BgL_list2399z00_12307 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12291, BgL_arg2400z00_12308); } 
BgL_arg2398z00_12306 = BgL_list2399z00_12307; } 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2397z00_12305,BgL_arg2398z00_12306); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2403z00_12311;
BgL_arg2403z00_12311 = 
(
(long)CINT(BgL_bpz00_12289)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2403z00_12311,BgL_a1z00_12291); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2404z00_12312;obj_t BgL_arg2405z00_12313;
BgL_arg2404z00_12312 = 
(
(long)CINT(BgL_bpz00_12289)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2406z00_12314;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2407z00_12315;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2408z00_12316;
BgL_arg2408z00_12316 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12294, BNIL); 
BgL_arg2407z00_12315 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12293, BgL_arg2408z00_12316); } 
BgL_list2406z00_12314 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12292, BgL_arg2407z00_12315); } 
BgL_arg2405z00_12313 = BgL_list2406z00_12314; } 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2404z00_12312,BgL_arg2405z00_12313); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2409z00_12317;
BgL_arg2409z00_12317 = 
(
(long)CINT(BgL_bpz00_12289)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2409z00_12317,BgL_a1z00_12291); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2410z00_12318;
BgL_arg2410z00_12318 = 
(
(long)CINT(BgL_bpz00_12289)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2410z00_12318,BgL_a2z00_12292); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2411z00_12319;obj_t BgL_arg2412z00_12320;
BgL_arg2411z00_12319 = 
(
(long)CINT(BgL_bpz00_12289)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2413z00_12321;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2414z00_12322;
BgL_arg2414z00_12322 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12294, BNIL); 
BgL_list2413z00_12321 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12293, BgL_arg2414z00_12322); } 
BgL_arg2412z00_12320 = BgL_list2413z00_12321; } 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2411z00_12319,BgL_arg2412z00_12320); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2415z00_12323;
BgL_arg2415z00_12323 = 
(
(long)CINT(BgL_bpz00_12289)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2415z00_12323,BgL_a1z00_12291); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2416z00_12324;
BgL_arg2416z00_12324 = 
(
(long)CINT(BgL_bpz00_12289)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2416z00_12324,BgL_a2z00_12292); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2417z00_12325;
BgL_arg2417z00_12325 = 
(
(long)CINT(BgL_bpz00_12289)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2417z00_12325,BgL_a3z00_12293); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2418z00_12326;obj_t BgL_arg2419z00_12327;
BgL_arg2418z00_12326 = 
(
(long)CINT(BgL_bpz00_12289)+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2420z00_12328;
BgL_list2420z00_12328 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12294, BNIL); 
BgL_arg2419z00_12327 = BgL_list2420z00_12328; } 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2418z00_12326,BgL_arg2419z00_12327); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2421z00_12329;
BgL_arg2421z00_12329 = 
(
(long)CINT(BgL_bpz00_12289)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2421z00_12329,BgL_a1z00_12291); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2422z00_12330;
BgL_arg2422z00_12330 = 
(
(long)CINT(BgL_bpz00_12289)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2422z00_12330,BgL_a2z00_12292); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2423z00_12331;
BgL_arg2423z00_12331 = 
(
(long)CINT(BgL_bpz00_12289)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2423z00_12331,BgL_a3z00_12293); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2424z00_12332;
BgL_arg2424z00_12332 = 
(
(long)CINT(BgL_bpz00_12289)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2424z00_12332,BgL_a4z00_12294); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2425z00_12333;obj_t BgL_arg2426z00_12334;
BgL_arg2425z00_12333 = 
(
(long)CINT(BgL_bpz00_12289)+((long)4)); 
BgL_arg2426z00_12334 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9950),BgL_arg2425z00_12333,BgL_arg2426z00_12334); } break;
default: 
BgL_case_else1204z00_12303:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2428z00_12304;
BgL_arg2428z00_12304 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12295), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9947, BgL_arg2428z00_12304, 
(int)(((long)4)), 
CINT(BgL_arityz00_12296)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1204z00_12303;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12335;
BgL_z12denvz12_12335 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9950, BgL_bpz00_12289, BgL_sfz00_12298))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12297;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12336;
BgL_nsz00_12336 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2430z00_12337;
BgL_arg2430z00_12337 = 
(
(long)CINT(BgL_bpz00_12289)+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12336, ((long)2), BgL_sz00_9950, BgL_bpz00_12289, 
BINT(BgL_arg2430z00_12337)); } 
VECTOR_SET(BgL_nsz00_12336,((long)1),BgL_sz00_9950); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12335, BgL_nsz00_12336); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12338;
BgL_ez00_12338 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12338, BgL_sz00_9950); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12339;
BgL_____rz00_12339 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12297, BgL_nsz00_12336, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12338); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12335, BgL_sz00_9950); 
return BgL_____rz00_12339;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12290, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12340;
BgL_nbpz00_12340 = 
(
(long)CINT(BgL_bpz00_12289)+BgL_siza7eza7_9949); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),((long)0),
BINT(BgL_nbpz00_12340)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12341;
BgL_rz00_12341 = 
PROCEDURE_ENTRY(BgL_fz00_12290)(BgL_fz00_12290, BgL_a1z00_12291, BgL_a2z00_12292, BgL_a3z00_12293, BgL_a4z00_12294, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9950),((long)0),BgL_bpz00_12289); 
return BgL_rz00_12341;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9947, BgL_symbzd2funzd2_9948, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_12290));} } } } } } } } 

}



/* &<@anonymous:2436> */
obj_t BGl_z62zc3z04anonymousza32436ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9951, obj_t BgL_sz00_9960)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9952;obj_t BgL_a1z00_9953;obj_t BgL_a2z00_9954;obj_t BgL_a3z00_9955;obj_t BgL_a4z00_9956;obj_t BgL_locz00_9957;obj_t BgL_symbzd2funzd2_9958;long BgL_siza7eza7_9959;
BgL_funz00_9952 = 
PROCEDURE_REF(BgL_envz00_9951, 
(int)(((long)0))); 
BgL_a1z00_9953 = 
PROCEDURE_REF(BgL_envz00_9951, 
(int)(((long)1))); 
BgL_a2z00_9954 = 
PROCEDURE_REF(BgL_envz00_9951, 
(int)(((long)2))); 
BgL_a3z00_9955 = 
PROCEDURE_REF(BgL_envz00_9951, 
(int)(((long)3))); 
BgL_a4z00_9956 = 
PROCEDURE_REF(BgL_envz00_9951, 
(int)(((long)4))); 
BgL_locz00_9957 = 
PROCEDURE_REF(BgL_envz00_9951, 
(int)(((long)5))); 
BgL_symbzd2funzd2_9958 = 
PROCEDURE_REF(BgL_envz00_9951, 
(int)(((long)6))); 
BgL_siza7eza7_9959 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9951, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12342;
BgL_bpz00_12342 = 
VECTOR_REF(
((obj_t)BgL_sz00_9960),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12343;obj_t BgL_a1z00_12344;obj_t BgL_a2z00_12345;obj_t BgL_a3z00_12346;obj_t BgL_a4z00_12347;
BgL_fz00_12343 = 
PROCEDURE_ENTRY(BgL_funz00_9952)(BgL_funz00_9952, BgL_sz00_9960, BEOA); 
BgL_a1z00_12344 = 
PROCEDURE_ENTRY(BgL_a1z00_9953)(BgL_a1z00_9953, BgL_sz00_9960, BEOA); 
BgL_a2z00_12345 = 
PROCEDURE_ENTRY(BgL_a2z00_9954)(BgL_a2z00_9954, BgL_sz00_9960, BEOA); 
BgL_a3z00_12346 = 
PROCEDURE_ENTRY(BgL_a3z00_9955)(BgL_a3z00_9955, BgL_sz00_9960, BEOA); 
BgL_a4z00_12347 = 
PROCEDURE_ENTRY(BgL_a4z00_9956)(BgL_a4z00_9956, BgL_sz00_9960, BEOA); 
if(
PROCEDUREP(BgL_fz00_12343))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9957, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12343); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12348;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18429;
BgL_tmpz00_18429 = 
((obj_t)BgL_fz00_12343); 
BgL_ufz00_12348 = 
PROCEDURE_ATTR(BgL_tmpz00_18429); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4771z00_18432;
if(
STRUCTP(BgL_ufz00_12348))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4771z00_18432 = 
(
STRUCT_KEY(BgL_ufz00_12348)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4771z00_18432 = ((bool_t)0)
; } 
if(BgL_test4771z00_18432)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12349;obj_t BgL_runz00_12350;obj_t BgL_sfz00_12351;
BgL_arityz00_12349 = 
STRUCT_REF(BgL_ufz00_12348, 
(int)(((long)0))); 
BgL_runz00_12350 = 
STRUCT_REF(BgL_ufz00_12348, 
(int)(((long)1))); 
BgL_sfz00_12351 = 
STRUCT_REF(BgL_ufz00_12348, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12352;
BgL_spz00_12352 = 
(
(long)CINT(BgL_bpz00_12342)+BgL_siza7eza7_9959); 
if(
(
(long)CINT(BgL_arityz00_12349)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2440z00_12353;
BgL_arg2440z00_12353 = 
(BgL_spz00_12352+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2440z00_12353,BgL_a1z00_12344); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2441z00_12354;
BgL_arg2441z00_12354 = 
(BgL_spz00_12352+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2441z00_12354,BgL_a2z00_12345); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2442z00_12355;
BgL_arg2442z00_12355 = 
(BgL_spz00_12352+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2442z00_12355,BgL_a3z00_12346); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2443z00_12356;
BgL_arg2443z00_12356 = 
(BgL_spz00_12352+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2443z00_12356,BgL_a4z00_12347); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12349))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12349)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2445z00_12359;obj_t BgL_arg2446z00_12360;
BgL_arg2445z00_12359 = 
(BgL_spz00_12352+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2447z00_12361;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2448z00_12362;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2449z00_12363;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2450z00_12364;
BgL_arg2450z00_12364 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12347, BNIL); 
BgL_arg2449z00_12363 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12346, BgL_arg2450z00_12364); } 
BgL_arg2448z00_12362 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12345, BgL_arg2449z00_12363); } 
BgL_list2447z00_12361 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12344, BgL_arg2448z00_12362); } 
BgL_arg2446z00_12360 = BgL_list2447z00_12361; } 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2445z00_12359,BgL_arg2446z00_12360); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2451z00_12365;
BgL_arg2451z00_12365 = 
(BgL_spz00_12352+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2451z00_12365,BgL_a1z00_12344); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2452z00_12366;obj_t BgL_arg2453z00_12367;
BgL_arg2452z00_12366 = 
(BgL_spz00_12352+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2454z00_12368;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2455z00_12369;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2456z00_12370;
BgL_arg2456z00_12370 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12347, BNIL); 
BgL_arg2455z00_12369 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12346, BgL_arg2456z00_12370); } 
BgL_list2454z00_12368 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12345, BgL_arg2455z00_12369); } 
BgL_arg2453z00_12367 = BgL_list2454z00_12368; } 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2452z00_12366,BgL_arg2453z00_12367); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2457z00_12371;
BgL_arg2457z00_12371 = 
(BgL_spz00_12352+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2457z00_12371,BgL_a1z00_12344); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2458z00_12372;
BgL_arg2458z00_12372 = 
(BgL_spz00_12352+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2458z00_12372,BgL_a2z00_12345); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2459z00_12373;obj_t BgL_arg2460z00_12374;
BgL_arg2459z00_12373 = 
(BgL_spz00_12352+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2461z00_12375;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2462z00_12376;
BgL_arg2462z00_12376 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12347, BNIL); 
BgL_list2461z00_12375 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12346, BgL_arg2462z00_12376); } 
BgL_arg2460z00_12374 = BgL_list2461z00_12375; } 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2459z00_12373,BgL_arg2460z00_12374); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2463z00_12377;
BgL_arg2463z00_12377 = 
(BgL_spz00_12352+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2463z00_12377,BgL_a1z00_12344); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2464z00_12378;
BgL_arg2464z00_12378 = 
(BgL_spz00_12352+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2464z00_12378,BgL_a2z00_12345); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2465z00_12379;
BgL_arg2465z00_12379 = 
(BgL_spz00_12352+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2465z00_12379,BgL_a3z00_12346); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2466z00_12380;obj_t BgL_arg2467z00_12381;
BgL_arg2466z00_12380 = 
(BgL_spz00_12352+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2468z00_12382;
BgL_list2468z00_12382 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12347, BNIL); 
BgL_arg2467z00_12381 = BgL_list2468z00_12382; } 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2466z00_12380,BgL_arg2467z00_12381); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2469z00_12383;
BgL_arg2469z00_12383 = 
(BgL_spz00_12352+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2469z00_12383,BgL_a1z00_12344); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2470z00_12384;
BgL_arg2470z00_12384 = 
(BgL_spz00_12352+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2470z00_12384,BgL_a2z00_12345); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2471z00_12385;
BgL_arg2471z00_12385 = 
(BgL_spz00_12352+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2471z00_12385,BgL_a3z00_12346); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2472z00_12386;
BgL_arg2472z00_12386 = 
(BgL_spz00_12352+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2472z00_12386,BgL_a4z00_12347); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2473z00_12387;obj_t BgL_arg2474z00_12388;
BgL_arg2473z00_12387 = 
(BgL_spz00_12352+((long)4)); 
BgL_arg2474z00_12388 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9960),BgL_arg2473z00_12387,BgL_arg2474z00_12388); } break;
default: 
BgL_case_else1206z00_12357:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2476z00_12358;
BgL_arg2476z00_12358 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12348), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9957, BgL_arg2476z00_12358, 
(int)(((long)4)), 
CINT(BgL_arityz00_12349)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1206z00_12357;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12389;
BgL_z12denvz12_12389 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12389, BgL_locz00_9957); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9960, 
BINT(BgL_spz00_12352), BgL_sfz00_12351))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12350, BgL_sz00_9960, 
BINT(BgL_spz00_12352));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12390;
BgL_nsz00_12390 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2478z00_12391;
BgL_arg2478z00_12391 = 
(BgL_spz00_12352+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12390, ((long)2), BgL_sz00_9960, 
BINT(BgL_spz00_12352), 
BINT(BgL_arg2478z00_12391)); } 
VECTOR_SET(BgL_nsz00_12390,((long)1),BgL_sz00_9960); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12389, BgL_nsz00_12390); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12392;
BgL_ez00_12392 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12392, BgL_sz00_9960); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12393;
BgL_____rz00_12393 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12350, BgL_nsz00_12390, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12392); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12389, BgL_sz00_9960); 
return BgL_____rz00_12393;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12343, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12394;
BgL_nbpz00_12394 = 
(
(long)CINT(BgL_bpz00_12342)+BgL_siza7eza7_9959); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),((long)0),
BINT(BgL_nbpz00_12394)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18553;
BgL_tmpz00_18553 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18553, BgL_locz00_9957); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12395;
BgL_rz00_12395 = 
PROCEDURE_ENTRY(BgL_fz00_12343)(BgL_fz00_12343, BgL_a1z00_12344, BgL_a2z00_12345, BgL_a3z00_12346, BgL_a4z00_12347, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9960),((long)0),BgL_bpz00_12342); 
return BgL_rz00_12395;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9957, BgL_symbzd2funzd2_9958, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_12343));} } } } } } } } 

}



/* &<@anonymous:2482> */
obj_t BGl_z62zc3z04anonymousza32482ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9961, obj_t BgL_sz00_9970)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_9962;obj_t BgL_a1z00_9963;obj_t BgL_a2z00_9964;obj_t BgL_a3z00_9965;obj_t BgL_a4z00_9966;obj_t BgL_locz00_9967;obj_t BgL_symbzd2funzd2_9968;long BgL_siza7eza7_9969;
BgL_funz00_9962 = 
PROCEDURE_REF(BgL_envz00_9961, 
(int)(((long)0))); 
BgL_a1z00_9963 = 
PROCEDURE_REF(BgL_envz00_9961, 
(int)(((long)1))); 
BgL_a2z00_9964 = 
PROCEDURE_REF(BgL_envz00_9961, 
(int)(((long)2))); 
BgL_a3z00_9965 = 
PROCEDURE_REF(BgL_envz00_9961, 
(int)(((long)3))); 
BgL_a4z00_9966 = 
PROCEDURE_REF(BgL_envz00_9961, 
(int)(((long)4))); 
BgL_locz00_9967 = 
PROCEDURE_REF(BgL_envz00_9961, 
(int)(((long)5))); 
BgL_symbzd2funzd2_9968 = 
PROCEDURE_REF(BgL_envz00_9961, 
(int)(((long)6))); 
BgL_siza7eza7_9969 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_9961, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12396;
BgL_bpz00_12396 = 
VECTOR_REF(
((obj_t)BgL_sz00_9970),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12397;obj_t BgL_a1z00_12398;obj_t BgL_a2z00_12399;obj_t BgL_a3z00_12400;obj_t BgL_a4z00_12401;
BgL_fz00_12397 = 
PROCEDURE_ENTRY(BgL_funz00_9962)(BgL_funz00_9962, BgL_sz00_9970, BEOA); 
BgL_a1z00_12398 = 
PROCEDURE_ENTRY(BgL_a1z00_9963)(BgL_a1z00_9963, BgL_sz00_9970, BEOA); 
BgL_a2z00_12399 = 
PROCEDURE_ENTRY(BgL_a2z00_9964)(BgL_a2z00_9964, BgL_sz00_9970, BEOA); 
BgL_a3z00_12400 = 
PROCEDURE_ENTRY(BgL_a3z00_9965)(BgL_a3z00_9965, BgL_sz00_9970, BEOA); 
BgL_a4z00_12401 = 
PROCEDURE_ENTRY(BgL_a4z00_9966)(BgL_a4z00_9966, BgL_sz00_9970, BEOA); 
if(
PROCEDUREP(BgL_fz00_12397))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_9967, BGl_string4260z00zz__evaluate_compz00, BGl_string4276z00zz__evaluate_compz00, BgL_fz00_12397); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12402;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18610;
BgL_tmpz00_18610 = 
((obj_t)BgL_fz00_12397); 
BgL_ufz00_12402 = 
PROCEDURE_ATTR(BgL_tmpz00_18610); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test4778z00_18613;
if(
STRUCTP(BgL_ufz00_12402))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4778z00_18613 = 
(
STRUCT_KEY(BgL_ufz00_12402)==BGl_symbol4277z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test4778z00_18613 = ((bool_t)0)
; } 
if(BgL_test4778z00_18613)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12403;obj_t BgL_runz00_12404;obj_t BgL_sfz00_12405;
BgL_arityz00_12403 = 
STRUCT_REF(BgL_ufz00_12402, 
(int)(((long)0))); 
BgL_runz00_12404 = 
STRUCT_REF(BgL_ufz00_12402, 
(int)(((long)1))); 
BgL_sfz00_12405 = 
STRUCT_REF(BgL_ufz00_12402, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12406;
BgL_spz00_12406 = 
(
(long)CINT(BgL_bpz00_12396)+BgL_siza7eza7_9969); 
if(
(
(long)CINT(BgL_arityz00_12403)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2486z00_12407;
BgL_arg2486z00_12407 = 
(BgL_spz00_12406+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2486z00_12407,BgL_a1z00_12398); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2487z00_12408;
BgL_arg2487z00_12408 = 
(BgL_spz00_12406+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2487z00_12408,BgL_a2z00_12399); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2488z00_12409;
BgL_arg2488z00_12409 = 
(BgL_spz00_12406+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2488z00_12409,BgL_a3z00_12400); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2489z00_12410;
BgL_arg2489z00_12410 = 
(BgL_spz00_12406+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2489z00_12410,BgL_a4z00_12401); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12403))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12403)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2491z00_12413;obj_t BgL_arg2492z00_12414;
BgL_arg2491z00_12413 = 
(BgL_spz00_12406+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2493z00_12415;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2494z00_12416;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2495z00_12417;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2496z00_12418;
BgL_arg2496z00_12418 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12401, BNIL); 
BgL_arg2495z00_12417 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12400, BgL_arg2496z00_12418); } 
BgL_arg2494z00_12416 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12399, BgL_arg2495z00_12417); } 
BgL_list2493z00_12415 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12398, BgL_arg2494z00_12416); } 
BgL_arg2492z00_12414 = BgL_list2493z00_12415; } 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2491z00_12413,BgL_arg2492z00_12414); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2497z00_12419;
BgL_arg2497z00_12419 = 
(BgL_spz00_12406+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2497z00_12419,BgL_a1z00_12398); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2498z00_12420;obj_t BgL_arg2499z00_12421;
BgL_arg2498z00_12420 = 
(BgL_spz00_12406+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2500z00_12422;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2501z00_12423;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2502z00_12424;
BgL_arg2502z00_12424 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12401, BNIL); 
BgL_arg2501z00_12423 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12400, BgL_arg2502z00_12424); } 
BgL_list2500z00_12422 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12399, BgL_arg2501z00_12423); } 
BgL_arg2499z00_12421 = BgL_list2500z00_12422; } 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2498z00_12420,BgL_arg2499z00_12421); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2503z00_12425;
BgL_arg2503z00_12425 = 
(BgL_spz00_12406+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2503z00_12425,BgL_a1z00_12398); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2504z00_12426;
BgL_arg2504z00_12426 = 
(BgL_spz00_12406+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2504z00_12426,BgL_a2z00_12399); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2505z00_12427;obj_t BgL_arg2506z00_12428;
BgL_arg2505z00_12427 = 
(BgL_spz00_12406+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2507z00_12429;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2508z00_12430;
BgL_arg2508z00_12430 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12401, BNIL); 
BgL_list2507z00_12429 = 
MAKE_YOUNG_PAIR(BgL_a3z00_12400, BgL_arg2508z00_12430); } 
BgL_arg2506z00_12428 = BgL_list2507z00_12429; } 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2505z00_12427,BgL_arg2506z00_12428); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2509z00_12431;
BgL_arg2509z00_12431 = 
(BgL_spz00_12406+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2509z00_12431,BgL_a1z00_12398); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2510z00_12432;
BgL_arg2510z00_12432 = 
(BgL_spz00_12406+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2510z00_12432,BgL_a2z00_12399); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2511z00_12433;
BgL_arg2511z00_12433 = 
(BgL_spz00_12406+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2511z00_12433,BgL_a3z00_12400); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2512z00_12434;obj_t BgL_arg2513z00_12435;
BgL_arg2512z00_12434 = 
(BgL_spz00_12406+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2514z00_12436;
BgL_list2514z00_12436 = 
MAKE_YOUNG_PAIR(BgL_a4z00_12401, BNIL); 
BgL_arg2513z00_12435 = BgL_list2514z00_12436; } 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2512z00_12434,BgL_arg2513z00_12435); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2515z00_12437;
BgL_arg2515z00_12437 = 
(BgL_spz00_12406+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2515z00_12437,BgL_a1z00_12398); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2516z00_12438;
BgL_arg2516z00_12438 = 
(BgL_spz00_12406+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2516z00_12438,BgL_a2z00_12399); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2517z00_12439;
BgL_arg2517z00_12439 = 
(BgL_spz00_12406+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2517z00_12439,BgL_a3z00_12400); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2518z00_12440;
BgL_arg2518z00_12440 = 
(BgL_spz00_12406+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2518z00_12440,BgL_a4z00_12401); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2519z00_12441;obj_t BgL_arg2520z00_12442;
BgL_arg2519z00_12441 = 
(BgL_spz00_12406+((long)4)); 
BgL_arg2520z00_12442 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_9970),BgL_arg2519z00_12441,BgL_arg2520z00_12442); } break;
default: 
BgL_case_else1208z00_12411:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2522z00_12412;
BgL_arg2522z00_12412 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12402), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9967, BgL_arg2522z00_12412, 
(int)(((long)4)), 
CINT(BgL_arityz00_12403)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1208z00_12411;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12443;
BgL_z12denvz12_12443 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_9970, 
BINT(BgL_spz00_12406), BgL_sfz00_12405))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12404, BgL_sz00_9970, 
BINT(BgL_spz00_12406));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12444;
BgL_nsz00_12444 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2524z00_12445;
BgL_arg2524z00_12445 = 
(BgL_spz00_12406+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12444, ((long)2), BgL_sz00_9970, 
BINT(BgL_spz00_12406), 
BINT(BgL_arg2524z00_12445)); } 
VECTOR_SET(BgL_nsz00_12444,((long)1),BgL_sz00_9970); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12443, BgL_nsz00_12444); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12446;
BgL_ez00_12446 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12446, BgL_sz00_9970); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12447;
BgL_____rz00_12447 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12404, BgL_nsz00_12444, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12446); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12443, BgL_sz00_9970); 
return BgL_____rz00_12447;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12397, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12448;
BgL_nbpz00_12448 = 
(
(long)CINT(BgL_bpz00_12396)+BgL_siza7eza7_9969); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),((long)0),
BINT(BgL_nbpz00_12448)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12449;
BgL_rz00_12449 = 
PROCEDURE_ENTRY(BgL_fz00_12397)(BgL_fz00_12397, BgL_a1z00_12398, BgL_a2z00_12399, BgL_a3z00_12400, BgL_a4z00_12401, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_9970),((long)0),BgL_bpz00_12396); 
return BgL_rz00_12449;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_9967, BgL_symbzd2funzd2_9968, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_12397));} } } } } } } } 

}



/* is-constant-fun? */
obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185, obj_t BgL_symbzd2funzd2_186)
{
{ /* Eval/evaluate_comp.scm 899 */
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 903 */
obj_t BgL_gz00_3035;
{ /* Eval/evaluate_comp.scm 903 */
obj_t BgL_arg2534z00_3043;obj_t BgL_arg2535z00_3044;
BgL_arg2534z00_3043 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_funz00_183)))->BgL_modz00); 
BgL_arg2535z00_3044 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_funz00_183)))->BgL_namez00); 
BgL_gz00_3035 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2534z00_3043, BgL_arg2535z00_3044); } 
if(
CBOOL(BgL_gz00_3035))
{ /* Eval/evaluate_comp.scm 905 */
bool_t BgL_test4786z00_18755;
{ /* Eval/evaluate_comp.scm 905 */
int BgL_arg2533z00_3042;
{ /* Eval/evaluate_comp.scm 905 */
int BgL_res4118z00_7739;
BgL_res4118z00_7739 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_3035),((long)0))); 
BgL_arg2533z00_3042 = BgL_res4118z00_7739; } 
BgL_test4786z00_18755 = 
(
(long)(BgL_arg2533z00_3042)==((long)0)); } 
if(BgL_test4786z00_18755)
{ /* Eval/evaluate_comp.scm 906 */
obj_t BgL_valz00_3038;
BgL_valz00_3038 = 
VECTOR_REF(
((obj_t)BgL_gz00_3035),((long)2)); 
{ /* Eval/evaluate_comp.scm 907 */
bool_t BgL_test4787z00_18763;
if(
PROCEDUREP(BgL_valz00_3038))
{ /* Eval/evaluate_comp.scm 907 */
BgL_test4787z00_18763 = 
PROCEDURE_CORRECT_ARITYP(BgL_valz00_3038, 
(int)(BgL_nbargsz00_184))
; }  else 
{ /* Eval/evaluate_comp.scm 907 */
BgL_test4787z00_18763 = ((bool_t)0)
; } 
if(BgL_test4787z00_18763)
{ /* Eval/evaluate_comp.scm 907 */
return BgL_valz00_3038;}  else 
{ /* Eval/evaluate_comp.scm 907 */
return BFALSE;} } }  else 
{ /* Eval/evaluate_comp.scm 905 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 904 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 910 */
bool_t BgL_test4789z00_18768;
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 911 */
obj_t BgL_tmpz00_18772;
BgL_tmpz00_18772 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_test4789z00_18768 = 
PROCEDUREP(BgL_tmpz00_18772); }  else 
{ /* Eval/evaluate_comp.scm 910 */
BgL_test4789z00_18768 = ((bool_t)0)
; } 
if(BgL_test4789z00_18768)
{ /* Eval/evaluate_comp.scm 913 */
bool_t BgL_test4791z00_18776;
{ /* Eval/evaluate_comp.scm 913 */
obj_t BgL_arg2543z00_3054;
BgL_arg2543z00_3054 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_test4791z00_18776 = 
PROCEDURE_CORRECT_ARITYP(BgL_arg2543z00_3054, 
(int)(BgL_nbargsz00_184)); } 
if(BgL_test4791z00_18776)
{ /* Eval/evaluate_comp.scm 913 */
return 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00);}  else 
{ /* Eval/evaluate_comp.scm 915 */
int BgL_arg2541z00_3052;
{ /* Eval/evaluate_comp.scm 915 */
obj_t BgL_arg2542z00_3053;
BgL_arg2542z00_3053 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_arg2541z00_3052 = 
PROCEDURE_ARITY(BgL_arg2542z00_3053); } 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185, BgL_symbzd2funzd2_186, 
(int)(BgL_nbargsz00_184), BgL_arg2541z00_3052);} }  else 
{ /* Eval/evaluate_comp.scm 910 */
return BFALSE;} } } 

}



/* compile-float-arith */
obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_exprz00_187, obj_t BgL_stkz00_188)
{
{ /* Eval/evaluate_comp.scm 918 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_littz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 922 */
if(
INTEGERP(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00)))
{ /* Eval/evaluate_comp.scm 924 */
obj_t BgL_v1347z00_3063;
BgL_v1347z00_3063 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1347z00_3063,((long)0),
BINT(((long)1))); 
{ /* Eval/evaluate_comp.scm 924 */
double BgL_arg2548z00_3064;
BgL_arg2548z00_3064 = 
(double)(
(long)CINT(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00))); 
VECTOR_SET(BgL_v1347z00_3063,((long)1),
DOUBLE_TO_REAL(BgL_arg2548z00_3064)); } 
return BgL_v1347z00_3063;}  else 
{ /* Eval/evaluate_comp.scm 925 */
bool_t BgL_test4794z00_18803;
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_tmpz00_18804;
BgL_tmpz00_18804 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00); 
BgL_test4794z00_18803 = 
REALP(BgL_tmpz00_18804); } 
if(BgL_test4794z00_18803)
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_v1348z00_3068;
BgL_v1348z00_3068 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1348z00_3068,((long)0),
BINT(((long)1))); 
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_arg2552z00_3069;
BgL_arg2552z00_3069 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00); 
VECTOR_SET(BgL_v1348z00_3068,((long)1),BgL_arg2552z00_3069); } 
return BgL_v1348z00_3068;}  else 
{ /* Eval/evaluate_comp.scm 926 */
obj_t BgL_v1349z00_3070;
BgL_v1349z00_3070 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1349z00_3070,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 926 */
obj_t BgL_arg2553z00_3071;
BgL_arg2553z00_3071 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_littz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1349z00_3070,((long)1),BgL_arg2553z00_3071); } 
return BgL_v1349z00_3070;} } }  else 
{ /* Eval/evaluate_comp.scm 922 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 927 */
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_exprz00_187)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 930 */
obj_t BgL_v1350z00_3077;
BgL_v1350z00_3077 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1350z00_3077,((long)0),
BINT(((long)3))); 
VECTOR_SET(BgL_v1350z00_3077,((long)1),
BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187, BgL_stkz00_188)); 
return BgL_v1350z00_3077;}  else 
{ /* Eval/evaluate_comp.scm 931 */
obj_t BgL_v1351z00_3079;
BgL_v1351z00_3079 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1351z00_3079,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1351z00_3079,((long)1),
BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187, BgL_stkz00_188)); 
return BgL_v1351z00_3079;} }  else 
{ /* Eval/evaluate_comp.scm 927 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 934 */
obj_t BgL_gz00_3083;
{ /* Eval/evaluate_comp.scm 934 */
obj_t BgL_arg2565z00_3091;obj_t BgL_arg2566z00_3092;
BgL_arg2565z00_3091 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_exprz00_187)))->BgL_modz00); 
BgL_arg2566z00_3092 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_exprz00_187)))->BgL_namez00); 
BgL_gz00_3083 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2565z00_3091, BgL_arg2566z00_3092); } 
if(
CBOOL(BgL_gz00_3083))
{ /* Eval/evaluate_comp.scm 936 */
bool_t BgL_test4799z00_18846;
{ /* Eval/evaluate_comp.scm 936 */
int BgL_arg2563z00_3088;
{ /* Eval/evaluate_comp.scm 936 */
int BgL_res4119z00_7756;
BgL_res4119z00_7756 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_3083),((long)0))); 
BgL_arg2563z00_3088 = BgL_res4119z00_7756; } 
BgL_test4799z00_18846 = 
(
BINT(BgL_arg2563z00_3088)==
BINT(((long)1))); } 
if(BgL_test4799z00_18846)
{ /* Eval/evaluate_comp.scm 937 */
obj_t BgL_v1352z00_3086;
BgL_v1352z00_3086 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1352z00_3086,((long)0),
BINT(((long)4))); 
VECTOR_SET(BgL_v1352z00_3086,((long)1),BgL_gz00_3083); 
return BgL_v1352z00_3086;}  else 
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_v1353z00_3087;
BgL_v1353z00_3087 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1353z00_3087,((long)0),
BINT(((long)5))); 
VECTOR_SET(BgL_v1353z00_3087,((long)1),BgL_gz00_3083); 
return BgL_v1353z00_3087;} }  else 
{ /* Eval/evaluate_comp.scm 939 */
obj_t BgL_v1354z00_3089;
BgL_v1354z00_3089 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1354z00_3089,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 939 */
obj_t BgL_arg2564z00_3090;
BgL_arg2564z00_3090 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_globalz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1354z00_3089,((long)1),BgL_arg2564z00_3090); } 
return BgL_v1354z00_3089;} }  else 
{ /* Eval/evaluate_comp.scm 932 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_appz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_fvalz00_3095;
{ /* Eval/evaluate_comp.scm 942 */
BgL_ev_exprz00_bglt BgL_arg2608z00_3143;
BgL_arg2608z00_3143 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_funz00); 
BgL_fvalz00_3095 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_arg2608z00_3143); } 
if(
(BgL_fvalz00_3095==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_v1355z00_3097;
BgL_v1355z00_3097 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1355z00_3097,((long)0),
BINT(((long)6))); 
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2569z00_3098;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2570z00_3099;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_pairz00_7764;
BgL_pairz00_7764 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2570z00_3099 = 
CAR(BgL_pairz00_7764); } 
BgL_arg2569z00_3098 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2570z00_3099, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1355z00_3097,((long)1),BgL_arg2569z00_3098); } 
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2572z00_3101;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2573z00_3102;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_pairz00_7766;
BgL_pairz00_7766 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2573z00_3102 = 
CAR(
CDR(BgL_pairz00_7766)); } 
BgL_arg2572z00_3101 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2573z00_3102, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1355z00_3097,((long)2),BgL_arg2572z00_3101); } 
return BgL_v1355z00_3097;}  else 
{ /* Eval/evaluate_comp.scm 944 */
if(
(BgL_fvalz00_3095==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_v1356z00_3105;
BgL_v1356z00_3105 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1356z00_3105,((long)0),
BINT(((long)7))); 
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2576z00_3106;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2577z00_3107;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_pairz00_7772;
BgL_pairz00_7772 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2577z00_3107 = 
CAR(BgL_pairz00_7772); } 
BgL_arg2576z00_3106 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2577z00_3107, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1356z00_3105,((long)1),BgL_arg2576z00_3106); } 
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2579z00_3109;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2580z00_3110;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_pairz00_7774;
BgL_pairz00_7774 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2580z00_3110 = 
CAR(
CDR(BgL_pairz00_7774)); } 
BgL_arg2579z00_3109 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2580z00_3110, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1356z00_3105,((long)2),BgL_arg2579z00_3109); } 
return BgL_v1356z00_3105;}  else 
{ /* Eval/evaluate_comp.scm 946 */
if(
(BgL_fvalz00_3095==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_v1357z00_3113;
BgL_v1357z00_3113 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1357z00_3113,((long)0),
BINT(((long)8))); 
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2583z00_3114;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2584z00_3115;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_pairz00_7780;
BgL_pairz00_7780 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2584z00_3115 = 
CAR(BgL_pairz00_7780); } 
BgL_arg2583z00_3114 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2584z00_3115, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1357z00_3113,((long)1),BgL_arg2583z00_3114); } 
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2586z00_3117;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2587z00_3118;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_pairz00_7782;
BgL_pairz00_7782 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2587z00_3118 = 
CAR(
CDR(BgL_pairz00_7782)); } 
BgL_arg2586z00_3117 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2587z00_3118, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1357z00_3113,((long)2),BgL_arg2586z00_3117); } 
return BgL_v1357z00_3113;}  else 
{ /* Eval/evaluate_comp.scm 948 */
if(
(BgL_fvalz00_3095==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_v1358z00_3121;
BgL_v1358z00_3121 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1358z00_3121,((long)0),
BINT(((long)9))); 
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2590z00_3122;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2591z00_3123;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_pairz00_7788;
BgL_pairz00_7788 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2591z00_3123 = 
CAR(BgL_pairz00_7788); } 
BgL_arg2590z00_3122 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2591z00_3123, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1358z00_3121,((long)1),BgL_arg2590z00_3122); } 
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2593z00_3125;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2594z00_3126;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_pairz00_7790;
BgL_pairz00_7790 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2594z00_3126 = 
CAR(
CDR(BgL_pairz00_7790)); } 
BgL_arg2593z00_3125 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2594z00_3126, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1358z00_3121,((long)2),BgL_arg2593z00_3125); } 
return BgL_v1358z00_3121;}  else 
{ /* Eval/evaluate_comp.scm 950 */
if(
(BgL_fvalz00_3095==BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_v1359z00_3129;
BgL_v1359z00_3129 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1359z00_3129,((long)0),
BINT(((long)10))); 
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_arg2597z00_3130;
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_arg2598z00_3131;
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_pairz00_7796;
BgL_pairz00_7796 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2598z00_3131 = 
CAR(BgL_pairz00_7796); } 
BgL_arg2597z00_3130 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2598z00_3131), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1359z00_3129,((long)1),BgL_arg2597z00_3130); } 
return BgL_v1359z00_3129;}  else 
{ /* Eval/evaluate_comp.scm 952 */
if(
(BgL_fvalz00_3095==BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_v1360z00_3134;
BgL_v1360z00_3134 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1360z00_3134,((long)0),
BINT(((long)11))); 
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2601z00_3135;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2602z00_3136;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_pairz00_7799;
BgL_pairz00_7799 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2602z00_3136 = 
CAR(BgL_pairz00_7799); } 
BgL_arg2601z00_3135 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2602z00_3136), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1360z00_3134,((long)1),BgL_arg2601z00_3135); } 
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2604z00_3138;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2605z00_3139;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_pairz00_7801;
BgL_pairz00_7801 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2605z00_3139 = 
CAR(
CDR(BgL_pairz00_7801)); } 
BgL_arg2604z00_3138 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2605z00_3139), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1360z00_3134,((long)2),BgL_arg2604z00_3138); } 
return BgL_v1360z00_3134;}  else 
{ /* Eval/evaluate_comp.scm 957 */
obj_t BgL_v1361z00_3141;
BgL_v1361z00_3141 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1361z00_3141,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 957 */
obj_t BgL_arg2607z00_3142;
BgL_arg2607z00_3142 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_appz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1361z00_3141,((long)1),BgL_arg2607z00_3142); } 
return BgL_v1361z00_3141;} } } } } } }  else 
{ /* Eval/evaluate_comp.scm 958 */
obj_t BgL_v1362z00_3144;
BgL_v1362z00_3144 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1362z00_3144,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 958 */
obj_t BgL_arg2609z00_3145;
BgL_arg2609z00_3145 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_exprz00_187), BgL_stkz00_188); 
VECTOR_SET(BgL_v1362z00_3144,((long)1),BgL_arg2609z00_3145); } 
return BgL_v1362z00_3144;} } } } } 

}



/* eval-float-arith */
double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189, obj_t BgL_sz00_190)
{
{ /* Eval/evaluate_comp.scm 960 */
return 
REAL_TO_DOUBLE(
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190, BgL_bcz00_189));} 

}



/* E~0 */
obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_11633, obj_t BgL_bcz00_3150)
{
{ /* Eval/evaluate_comp.scm 975 */
{ 

{ /* Eval/evaluate_comp.scm 962 */
obj_t BgL_aux1218z00_3153;
BgL_aux1218z00_3153 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)0)); 
if(
INTEGERP(BgL_aux1218z00_3153))
{ /* Eval/evaluate_comp.scm 962 */
switch( 
(long)CINT(BgL_aux1218z00_3153)) { case ((long)0) : 

{ /* Eval/evaluate_comp.scm 963 */
obj_t BgL_fun2613z00_3155;
BgL_fun2613z00_3155 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
return 
PROCEDURE_ENTRY(BgL_fun2613z00_3155)(BgL_fun2613z00_3155, BgL_sz00_11633, BEOA);} break;case ((long)1) : 

return 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1));break;case ((long)2) : 

{ /* Eval/evaluate_comp.scm 965 */
long BgL_arg2614z00_3156;
{ /* Eval/evaluate_comp.scm 965 */
obj_t BgL_arg2615z00_3157;obj_t BgL_arg2616z00_3158;
BgL_arg2615z00_3157 = 
VECTOR_REF(
((obj_t)BgL_sz00_11633),((long)0)); 
BgL_arg2616z00_3158 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2614z00_3156 = 
(
(long)CINT(BgL_arg2615z00_3157)+
(long)CINT(BgL_arg2616z00_3158)); } 
return 
VECTOR_REF(
((obj_t)BgL_sz00_11633),BgL_arg2614z00_3156);} break;case ((long)3) : 

{ /* Eval/evaluate_comp.scm 966 */
obj_t BgL_arg2617z00_3159;
{ /* Eval/evaluate_comp.scm 966 */
long BgL_arg2618z00_3160;
{ /* Eval/evaluate_comp.scm 966 */
obj_t BgL_arg2619z00_3161;obj_t BgL_arg2620z00_3162;
BgL_arg2619z00_3161 = 
VECTOR_REF(
((obj_t)BgL_sz00_11633),((long)0)); 
BgL_arg2620z00_3162 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2618z00_3160 = 
(
(long)CINT(BgL_arg2619z00_3161)+
(long)CINT(BgL_arg2620z00_3162)); } 
BgL_arg2617z00_3159 = 
VECTOR_REF(
((obj_t)BgL_sz00_11633),BgL_arg2618z00_3160); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2617z00_3159), 
(int)(((long)0)));} break;case ((long)4) : 

{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_arg2621z00_3163;
{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_arg2622z00_3164;
BgL_arg2622z00_3164 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2621z00_3163 = 
VECTOR_REF(
((obj_t)BgL_arg2622z00_3164),((long)2)); } 
return 
__EVMEANING_ADDRESS_REF(BgL_arg2621z00_3163);} break;case ((long)5) : 

{ /* Eval/evaluate_comp.scm 968 */
obj_t BgL_arg2623z00_3165;
BgL_arg2623z00_3165 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
return 
VECTOR_REF(
((obj_t)BgL_arg2623z00_3165),((long)2));} break;case ((long)6) : 

{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2624z00_3166;obj_t BgL_arg2625z00_3167;
{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2626z00_3168;
BgL_arg2626z00_3168 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2624z00_3166 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_11633, BgL_arg2626z00_3168); } 
{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2627z00_3169;
BgL_arg2627z00_3169 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)2)); 
BgL_arg2625z00_3167 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_11633, BgL_arg2627z00_3169); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2624z00_3166)+
REAL_TO_DOUBLE(BgL_arg2625z00_3167)));} break;case ((long)7) : 

{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2628z00_3170;obj_t BgL_arg2629z00_3171;
{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2630z00_3172;
BgL_arg2630z00_3172 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2628z00_3170 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_11633, BgL_arg2630z00_3172); } 
{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2631z00_3173;
BgL_arg2631z00_3173 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)2)); 
BgL_arg2629z00_3171 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_11633, BgL_arg2631z00_3173); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2628z00_3170)-
REAL_TO_DOUBLE(BgL_arg2629z00_3171)));} break;case ((long)8) : 

{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2632z00_3174;obj_t BgL_arg2633z00_3175;
{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2634z00_3176;
BgL_arg2634z00_3176 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2632z00_3174 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_11633, BgL_arg2634z00_3176); } 
{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2635z00_3177;
BgL_arg2635z00_3177 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)2)); 
BgL_arg2633z00_3175 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_11633, BgL_arg2635z00_3177); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2632z00_3174)*
REAL_TO_DOUBLE(BgL_arg2633z00_3175)));} break;case ((long)9) : 

{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2636z00_3178;obj_t BgL_arg2637z00_3179;
{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2638z00_3180;
BgL_arg2638z00_3180 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2636z00_3178 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_11633, BgL_arg2638z00_3180); } 
{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2639z00_3181;
BgL_arg2639z00_3181 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)2)); 
BgL_arg2637z00_3179 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_11633, BgL_arg2639z00_3181); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2636z00_3178)/
REAL_TO_DOUBLE(BgL_arg2637z00_3179)));} break;case ((long)10) : 

{ /* Eval/evaluate_comp.scm 973 */
obj_t BgL_arg2640z00_3182;
{ /* Eval/evaluate_comp.scm 973 */
obj_t BgL_fun2641z00_3183;
BgL_fun2641z00_3183 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2640z00_3182 = 
PROCEDURE_ENTRY(BgL_fun2641z00_3183)(BgL_fun2641z00_3183, BgL_sz00_11633, BEOA); } 
return 
DOUBLE_TO_REAL(
(double)(
(long)CINT(BgL_arg2640z00_3182)));} break;case ((long)11) : 

{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_arg2642z00_3184;obj_t BgL_arg2643z00_3185;
{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_fun2644z00_3186;
BgL_fun2644z00_3186 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)1)); 
BgL_arg2642z00_3184 = 
PROCEDURE_ENTRY(BgL_fun2644z00_3186)(BgL_fun2644z00_3186, BgL_sz00_11633, BEOA); } 
{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_fun2645z00_3187;
BgL_fun2645z00_3187 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)2)); 
BgL_arg2643z00_3185 = 
PROCEDURE_ENTRY(BgL_fun2645z00_3187)(BgL_fun2645z00_3187, BgL_sz00_11633, BEOA); } 
{ /* Eval/evaluate_comp.scm 974 */
double BgL_tmpz00_19084;
{ /* Eval/evaluate_comp.scm 974 */
long BgL_tmpz00_19085;
BgL_tmpz00_19085 = 
(long)CINT(BgL_arg2643z00_3185); 
BgL_tmpz00_19084 = 
BGL_F64VREF(BgL_arg2642z00_3184, BgL_tmpz00_19085); } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_19084);} } break;
default: 
BgL_case_else1217z00_3152:
{ /* Eval/evaluate_comp.scm 975 */
obj_t BgL_arg2646z00_3188;
BgL_arg2646z00_3188 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3150),((long)0)); 
return 
BGl_errorz00zz__errorz00(BGl_string4260z00zz__evaluate_compz00, BGl_string4279z00zz__evaluate_compz00, BgL_arg2646z00_3188);} } }  else 
{ /* Eval/evaluate_comp.scm 962 */
goto BgL_case_else1217z00_3152;} } } } 

}



/* arith-expression */
obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt BgL_exprz00_191, obj_t BgL_stkz00_192)
{
{ /* Eval/evaluate_comp.scm 978 */
{ /* Eval/evaluate_comp.scm 980 */
obj_t BgL_fvalz00_3191;
BgL_fvalz00_3191 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_exprz00_191))->BgL_funz00)); 
{ /* Eval/evaluate_comp.scm 981 */
bool_t BgL_test4808z00_19096;
if(
(BgL_fvalz00_3191==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test4808z00_19096 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
if(
(BgL_fvalz00_3191==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test4808z00_19096 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
if(
(BgL_fvalz00_3191==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test4808z00_19096 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
BgL_test4808z00_19096 = 
(BgL_fvalz00_3191==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00)
; } } } 
if(BgL_test4808z00_19096)
{ /* Eval/evaluate_comp.scm 982 */
obj_t BgL_bcz00_3196;
BgL_bcz00_3196 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
((obj_t)BgL_exprz00_191), BgL_stkz00_192); 
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_zc3z04anonymousza32651ze3z87_9988;
BgL_zc3z04anonymousza32651ze3z87_9988 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32651ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32651ze3z87_9988, 
(int)(((long)0)), BgL_bcz00_3196); 
return BgL_zc3z04anonymousza32651ze3z87_9988;} }  else 
{ /* Eval/evaluate_comp.scm 981 */
return BFALSE;} } } } 

}



/* &<@anonymous:2651> */
obj_t BGl_z62zc3z04anonymousza32651ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_9989, obj_t BgL_sz00_9991)
{
{ /* Eval/evaluate_comp.scm 983 */
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_bcz00_9990;
BgL_bcz00_9990 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_9989, 
(int)(((long)0)))); 
{ /* Eval/evaluate_comp.scm 983 */
double BgL_tmpz00_19114;
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_bpz00_12450;
BgL_bpz00_12450 = 
VECTOR_REF(
((obj_t)BgL_sz00_9991),((long)0)); 
BgL_tmpz00_19114 = 
BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_9990, BgL_sz00_9991); } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_19114);} } } 

}



/* inline-call */
obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193, BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195, obj_t BgL_stkz00_196)
{
{ /* Eval/evaluate_comp.scm 1012 */
{ /* Eval/evaluate_comp.scm 1013 */
obj_t BgL_valz00_3204;
BgL_valz00_3204 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194); 
if(
CBOOL(BgL_valz00_3204))
{ /* Eval/evaluate_comp.scm 1015 */
long BgL_nz00_3205;
BgL_nz00_3205 = 
bgl_list_length(BgL_argsz00_195); 
{ /* Eval/evaluate_comp.scm 1016 */
obj_t BgL__ortest_1224z00_3206;
if(
(BgL_nz00_3205==((long)1)))
{ /* Eval/evaluate_comp.scm 1017 */
obj_t BgL_a1z00_3497;
BgL_a1z00_3497 = 
CAR(
((obj_t)BgL_argsz00_195)); 
if(
(BgL_valz00_3204==BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3499;
BgL_a1z00_3499 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3497), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32768ze3z87_10021;
BgL_zc3z04anonymousza32768ze3z87_10021 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32768ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32768ze3z87_10021, 
(int)(((long)0)), BgL_a1z00_3499); 
PROCEDURE_SET(BgL_zc3z04anonymousza32768ze3z87_10021, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1224z00_3206 = BgL_zc3z04anonymousza32768ze3z87_10021; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
if(
(BgL_valz00_3204==BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3506;
BgL_a1z00_3506 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3497), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32771ze3z87_10022;
BgL_zc3z04anonymousza32771ze3z87_10022 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32771ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32771ze3z87_10022, 
(int)(((long)0)), BgL_a1z00_3506); 
PROCEDURE_SET(BgL_zc3z04anonymousza32771ze3z87_10022, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1224z00_3206 = BgL_zc3z04anonymousza32771ze3z87_10022; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
if(
(BgL_valz00_3204==BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3513;
BgL_a1z00_3513 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3497), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32774ze3z87_10023;
BgL_zc3z04anonymousza32774ze3z87_10023 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32774ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32774ze3z87_10023, 
(int)(((long)0)), BgL_a1z00_3513); 
PROCEDURE_SET(BgL_zc3z04anonymousza32774ze3z87_10023, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1224z00_3206 = BgL_zc3z04anonymousza32774ze3z87_10023; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BgL__ortest_1224z00_3206 = BFALSE; } } } }  else 
{ /* Eval/evaluate_comp.scm 1016 */
BgL__ortest_1224z00_3206 = BFALSE; } 
if(
CBOOL(BgL__ortest_1224z00_3206))
{ /* Eval/evaluate_comp.scm 1016 */
return BgL__ortest_1224z00_3206;}  else 
{ /* Eval/evaluate_comp.scm 1016 */
if(
(BgL_nz00_3205==((long)2)))
{ /* Eval/evaluate_comp.scm 1020 */
obj_t BgL_a1z00_3208;obj_t BgL_a2z00_3209;
BgL_a1z00_3208 = 
CAR(
((obj_t)BgL_argsz00_195)); 
{ /* Eval/evaluate_comp.scm 1020 */
obj_t BgL_pairz00_7870;
BgL_pairz00_7870 = 
CDR(
((obj_t)BgL_argsz00_195)); 
BgL_a2z00_3209 = 
CAR(BgL_pairz00_7870); } 
if(
(BgL_valz00_3204==BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3211;obj_t BgL_a2z00_3212;
BgL_a1z00_3211 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3212 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32655ze3z87_9992;
BgL_zc3z04anonymousza32655ze3z87_9992 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32655ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32655ze3z87_9992, 
(int)(((long)0)), BgL_a1z00_3211); 
PROCEDURE_SET(BgL_zc3z04anonymousza32655ze3z87_9992, 
(int)(((long)1)), BgL_a2z00_3212); 
PROCEDURE_SET(BgL_zc3z04anonymousza32655ze3z87_9992, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32655ze3z87_9992;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3221;obj_t BgL_a2z00_3222;
BgL_a1z00_3221 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3222 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32659ze3z87_9993;
BgL_zc3z04anonymousza32659ze3z87_9993 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32659ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32659ze3z87_9993, 
(int)(((long)0)), BgL_a1z00_3221); 
PROCEDURE_SET(BgL_zc3z04anonymousza32659ze3z87_9993, 
(int)(((long)1)), BgL_a2z00_3222); 
PROCEDURE_SET(BgL_zc3z04anonymousza32659ze3z87_9993, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32659ze3z87_9993;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_za2zd2envz70zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3231;obj_t BgL_a2z00_3232;
BgL_a1z00_3231 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3232 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32663ze3z87_9994;
BgL_zc3z04anonymousza32663ze3z87_9994 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32663ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32663ze3z87_9994, 
(int)(((long)0)), BgL_a1z00_3231); 
PROCEDURE_SET(BgL_zc3z04anonymousza32663ze3z87_9994, 
(int)(((long)1)), BgL_a2z00_3232); 
PROCEDURE_SET(BgL_zc3z04anonymousza32663ze3z87_9994, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32663ze3z87_9994;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3241;obj_t BgL_a2z00_3242;
BgL_a1z00_3241 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3242 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32667ze3z87_9995;
BgL_zc3z04anonymousza32667ze3z87_9995 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32667ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32667ze3z87_9995, 
(int)(((long)0)), BgL_a1z00_3241); 
PROCEDURE_SET(BgL_zc3z04anonymousza32667ze3z87_9995, 
(int)(((long)1)), BgL_a2z00_3242); 
PROCEDURE_SET(BgL_zc3z04anonymousza32667ze3z87_9995, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32667ze3z87_9995;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3251;obj_t BgL_a2z00_3252;
BgL_a1z00_3251 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3252 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32671ze3z87_9996;
BgL_zc3z04anonymousza32671ze3z87_9996 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32671ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32671ze3z87_9996, 
(int)(((long)0)), BgL_a1z00_3251); 
PROCEDURE_SET(BgL_zc3z04anonymousza32671ze3z87_9996, 
(int)(((long)1)), BgL_a2z00_3252); 
PROCEDURE_SET(BgL_zc3z04anonymousza32671ze3z87_9996, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32671ze3z87_9996;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3261;obj_t BgL_a2z00_3262;
BgL_a1z00_3261 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3262 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32675ze3z87_9997;
BgL_zc3z04anonymousza32675ze3z87_9997 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32675ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32675ze3z87_9997, 
(int)(((long)0)), BgL_a1z00_3261); 
PROCEDURE_SET(BgL_zc3z04anonymousza32675ze3z87_9997, 
(int)(((long)1)), BgL_a2z00_3262); 
PROCEDURE_SET(BgL_zc3z04anonymousza32675ze3z87_9997, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32675ze3z87_9997;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3271;obj_t BgL_a2z00_3272;
BgL_a1z00_3271 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3272 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32679ze3z87_9998;
BgL_zc3z04anonymousza32679ze3z87_9998 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32679ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32679ze3z87_9998, 
(int)(((long)0)), BgL_a1z00_3271); 
PROCEDURE_SET(BgL_zc3z04anonymousza32679ze3z87_9998, 
(int)(((long)1)), BgL_a2z00_3272); 
PROCEDURE_SET(BgL_zc3z04anonymousza32679ze3z87_9998, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32679ze3z87_9998;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3281;obj_t BgL_a2z00_3282;
BgL_a1z00_3281 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3282 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32683ze3z87_9999;
BgL_zc3z04anonymousza32683ze3z87_9999 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32683ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32683ze3z87_9999, 
(int)(((long)0)), BgL_a1z00_3281); 
PROCEDURE_SET(BgL_zc3z04anonymousza32683ze3z87_9999, 
(int)(((long)1)), BgL_a2z00_3282); 
PROCEDURE_SET(BgL_zc3z04anonymousza32683ze3z87_9999, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32683ze3z87_9999;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3291;obj_t BgL_a2z00_3292;
BgL_a1z00_3291 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3292 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32687ze3z87_10000;
BgL_zc3z04anonymousza32687ze3z87_10000 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32687ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32687ze3z87_10000, 
(int)(((long)0)), BgL_a1z00_3291); 
PROCEDURE_SET(BgL_zc3z04anonymousza32687ze3z87_10000, 
(int)(((long)1)), BgL_a2z00_3292); 
PROCEDURE_SET(BgL_zc3z04anonymousza32687ze3z87_10000, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32687ze3z87_10000;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3301;obj_t BgL_a2z00_3302;
BgL_a1z00_3301 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3302 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32691ze3z87_10001;
BgL_zc3z04anonymousza32691ze3z87_10001 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32691ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32691ze3z87_10001, 
(int)(((long)0)), BgL_a1z00_3301); 
PROCEDURE_SET(BgL_zc3z04anonymousza32691ze3z87_10001, 
(int)(((long)1)), BgL_a2z00_3302); 
PROCEDURE_SET(BgL_zc3z04anonymousza32691ze3z87_10001, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32691ze3z87_10001;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3311;obj_t BgL_a2z00_3312;
BgL_a1z00_3311 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3312 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32695ze3z87_10002;
BgL_zc3z04anonymousza32695ze3z87_10002 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32695ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32695ze3z87_10002, 
(int)(((long)0)), BgL_a1z00_3311); 
PROCEDURE_SET(BgL_zc3z04anonymousza32695ze3z87_10002, 
(int)(((long)1)), BgL_a2z00_3312); 
PROCEDURE_SET(BgL_zc3z04anonymousza32695ze3z87_10002, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32695ze3z87_10002;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3321;obj_t BgL_a2z00_3322;
BgL_a1z00_3321 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3322 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32699ze3z87_10003;
BgL_zc3z04anonymousza32699ze3z87_10003 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32699ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32699ze3z87_10003, 
(int)(((long)0)), BgL_a1z00_3321); 
PROCEDURE_SET(BgL_zc3z04anonymousza32699ze3z87_10003, 
(int)(((long)1)), BgL_a2z00_3322); 
PROCEDURE_SET(BgL_zc3z04anonymousza32699ze3z87_10003, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32699ze3z87_10003;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3331;obj_t BgL_a2z00_3332;
BgL_a1z00_3331 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3332 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32703ze3z87_10004;
BgL_zc3z04anonymousza32703ze3z87_10004 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32703ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32703ze3z87_10004, 
(int)(((long)0)), BgL_a1z00_3331); 
PROCEDURE_SET(BgL_zc3z04anonymousza32703ze3z87_10004, 
(int)(((long)1)), BgL_a2z00_3332); 
PROCEDURE_SET(BgL_zc3z04anonymousza32703ze3z87_10004, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32703ze3z87_10004;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3341;obj_t BgL_a2z00_3342;
BgL_a1z00_3341 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3342 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32707ze3z87_10005;
BgL_zc3z04anonymousza32707ze3z87_10005 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32707ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32707ze3z87_10005, 
(int)(((long)0)), BgL_a1z00_3341); 
PROCEDURE_SET(BgL_zc3z04anonymousza32707ze3z87_10005, 
(int)(((long)1)), BgL_a2z00_3342); 
PROCEDURE_SET(BgL_zc3z04anonymousza32707ze3z87_10005, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32707ze3z87_10005;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3351;obj_t BgL_a2z00_3352;
BgL_a1z00_3351 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3352 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32711ze3z87_10006;
BgL_zc3z04anonymousza32711ze3z87_10006 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32711ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32711ze3z87_10006, 
(int)(((long)0)), BgL_a1z00_3351); 
PROCEDURE_SET(BgL_zc3z04anonymousza32711ze3z87_10006, 
(int)(((long)1)), BgL_a2z00_3352); 
PROCEDURE_SET(BgL_zc3z04anonymousza32711ze3z87_10006, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32711ze3z87_10006;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3361;obj_t BgL_a2z00_3362;
BgL_a1z00_3361 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3362 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32715ze3z87_10007;
BgL_zc3z04anonymousza32715ze3z87_10007 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32715ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32715ze3z87_10007, 
(int)(((long)0)), BgL_a1z00_3361); 
PROCEDURE_SET(BgL_zc3z04anonymousza32715ze3z87_10007, 
(int)(((long)1)), BgL_a2z00_3362); 
PROCEDURE_SET(BgL_zc3z04anonymousza32715ze3z87_10007, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32715ze3z87_10007;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3371;obj_t BgL_a2z00_3372;
BgL_a1z00_3371 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3372 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32719ze3z87_10008;
BgL_zc3z04anonymousza32719ze3z87_10008 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32719ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32719ze3z87_10008, 
(int)(((long)0)), BgL_a1z00_3371); 
PROCEDURE_SET(BgL_zc3z04anonymousza32719ze3z87_10008, 
(int)(((long)1)), BgL_a2z00_3372); 
PROCEDURE_SET(BgL_zc3z04anonymousza32719ze3z87_10008, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32719ze3z87_10008;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3381;obj_t BgL_a2z00_3382;
BgL_a1z00_3381 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3382 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32723ze3z87_10009;
BgL_zc3z04anonymousza32723ze3z87_10009 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32723ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32723ze3z87_10009, 
(int)(((long)0)), BgL_a1z00_3381); 
PROCEDURE_SET(BgL_zc3z04anonymousza32723ze3z87_10009, 
(int)(((long)1)), BgL_a2z00_3382); 
PROCEDURE_SET(BgL_zc3z04anonymousza32723ze3z87_10009, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32723ze3z87_10009;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3391;obj_t BgL_a2z00_3392;
BgL_a1z00_3391 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3392 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32727ze3z87_10010;
BgL_zc3z04anonymousza32727ze3z87_10010 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32727ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32727ze3z87_10010, 
(int)(((long)0)), BgL_a1z00_3391); 
PROCEDURE_SET(BgL_zc3z04anonymousza32727ze3z87_10010, 
(int)(((long)1)), BgL_a2z00_3392); 
PROCEDURE_SET(BgL_zc3z04anonymousza32727ze3z87_10010, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32727ze3z87_10010;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3401;obj_t BgL_a2z00_3402;
BgL_a1z00_3401 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3402 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32731ze3z87_10011;
BgL_zc3z04anonymousza32731ze3z87_10011 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32731ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32731ze3z87_10011, 
(int)(((long)0)), BgL_a1z00_3401); 
PROCEDURE_SET(BgL_zc3z04anonymousza32731ze3z87_10011, 
(int)(((long)1)), BgL_a2z00_3402); 
PROCEDURE_SET(BgL_zc3z04anonymousza32731ze3z87_10011, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32731ze3z87_10011;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3411;obj_t BgL_a2z00_3412;
BgL_a1z00_3411 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3412 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32735ze3z87_10012;
BgL_zc3z04anonymousza32735ze3z87_10012 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32735ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32735ze3z87_10012, 
(int)(((long)0)), BgL_a1z00_3411); 
PROCEDURE_SET(BgL_zc3z04anonymousza32735ze3z87_10012, 
(int)(((long)1)), BgL_a2z00_3412); 
PROCEDURE_SET(BgL_zc3z04anonymousza32735ze3z87_10012, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32735ze3z87_10012;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3421;obj_t BgL_a2z00_3422;
BgL_a1z00_3421 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3422 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32739ze3z87_10013;
BgL_zc3z04anonymousza32739ze3z87_10013 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32739ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32739ze3z87_10013, 
(int)(((long)0)), BgL_a1z00_3421); 
PROCEDURE_SET(BgL_zc3z04anonymousza32739ze3z87_10013, 
(int)(((long)1)), BgL_a2z00_3422); 
PROCEDURE_SET(BgL_zc3z04anonymousza32739ze3z87_10013, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32739ze3z87_10013;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3431;obj_t BgL_a2z00_3432;
BgL_a1z00_3431 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3432 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32743ze3z87_10014;
BgL_zc3z04anonymousza32743ze3z87_10014 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32743ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32743ze3z87_10014, 
(int)(((long)0)), BgL_a1z00_3431); 
PROCEDURE_SET(BgL_zc3z04anonymousza32743ze3z87_10014, 
(int)(((long)1)), BgL_a2z00_3432); 
PROCEDURE_SET(BgL_zc3z04anonymousza32743ze3z87_10014, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32743ze3z87_10014;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3441;obj_t BgL_a2z00_3442;
BgL_a1z00_3441 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3442 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32747ze3z87_10015;
BgL_zc3z04anonymousza32747ze3z87_10015 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32747ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32747ze3z87_10015, 
(int)(((long)0)), BgL_a1z00_3441); 
PROCEDURE_SET(BgL_zc3z04anonymousza32747ze3z87_10015, 
(int)(((long)1)), BgL_a2z00_3442); 
PROCEDURE_SET(BgL_zc3z04anonymousza32747ze3z87_10015, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32747ze3z87_10015;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3451;obj_t BgL_a2z00_3452;
BgL_a1z00_3451 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3452 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32751ze3z87_10016;
BgL_zc3z04anonymousza32751ze3z87_10016 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32751ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32751ze3z87_10016, 
(int)(((long)0)), BgL_a1z00_3451); 
PROCEDURE_SET(BgL_zc3z04anonymousza32751ze3z87_10016, 
(int)(((long)1)), BgL_a2z00_3452); 
PROCEDURE_SET(BgL_zc3z04anonymousza32751ze3z87_10016, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32751ze3z87_10016;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3461;obj_t BgL_a2z00_3462;
BgL_a1z00_3461 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3462 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32755ze3z87_10017;
BgL_zc3z04anonymousza32755ze3z87_10017 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32755ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32755ze3z87_10017, 
(int)(((long)0)), BgL_a1z00_3461); 
PROCEDURE_SET(BgL_zc3z04anonymousza32755ze3z87_10017, 
(int)(((long)1)), BgL_a2z00_3462); 
PROCEDURE_SET(BgL_zc3z04anonymousza32755ze3z87_10017, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32755ze3z87_10017;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3471;obj_t BgL_a2z00_3472;
BgL_a1z00_3471 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3472 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32759ze3z87_10018;
BgL_zc3z04anonymousza32759ze3z87_10018 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32759ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32759ze3z87_10018, 
(int)(((long)0)), BgL_a1z00_3471); 
PROCEDURE_SET(BgL_zc3z04anonymousza32759ze3z87_10018, 
(int)(((long)1)), BgL_a2z00_3472); 
PROCEDURE_SET(BgL_zc3z04anonymousza32759ze3z87_10018, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32759ze3z87_10018;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3481;obj_t BgL_a2z00_3482;
BgL_a1z00_3481 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3482 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32763ze3z87_10019;
BgL_zc3z04anonymousza32763ze3z87_10019 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32763ze3z87_10019, 
(int)(((long)0)), BgL_a1z00_3481); 
PROCEDURE_SET(BgL_zc3z04anonymousza32763ze3z87_10019, 
(int)(((long)1)), BgL_a2z00_3482); 
return BgL_zc3z04anonymousza32763ze3z87_10019;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3204==BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3489;obj_t BgL_a2z00_3490;
BgL_a1z00_3489 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3208), BgL_stkz00_196); 
BgL_a2z00_3490 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3209), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32765ze3z87_10020;
BgL_zc3z04anonymousza32765ze3z87_10020 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32765ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32765ze3z87_10020, 
(int)(((long)0)), BgL_a1z00_3489); 
PROCEDURE_SET(BgL_zc3z04anonymousza32765ze3z87_10020, 
(int)(((long)1)), BgL_a2z00_3490); 
return BgL_zc3z04anonymousza32765ze3z87_10020;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
return BFALSE;} } } } } } } } } } } } } } } } } } } } } } } } } } } } } }  else 
{ /* Eval/evaluate_comp.scm 1019 */
return BFALSE;} } } }  else 
{ /* Eval/evaluate_comp.scm 1014 */
return BFALSE;} } } 

}



/* &<@anonymous:2655> */
obj_t BGl_z62zc3z04anonymousza32655ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10024, obj_t BgL_sz00_10028)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10025;obj_t BgL_a2z00_10026;obj_t BgL_locz00_10027;
BgL_a1z00_10025 = 
PROCEDURE_REF(BgL_envz00_10024, 
(int)(((long)0))); 
BgL_a2z00_10026 = 
PROCEDURE_REF(BgL_envz00_10024, 
(int)(((long)1))); 
BgL_locz00_10027 = 
PROCEDURE_REF(BgL_envz00_10024, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12451;
BgL_bpz00_12451 = 
VECTOR_REF(
((obj_t)BgL_sz00_10028),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12452;obj_t BgL_a2z00_12453;
BgL_a1z00_12452 = 
PROCEDURE_ENTRY(BgL_a1z00_10025)(BgL_a1z00_10025, BgL_sz00_10028, BEOA); 
BgL_a2z00_12453 = 
PROCEDURE_ENTRY(BgL_a2z00_10026)(BgL_a2z00_10026, BgL_sz00_10028, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12452))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4280z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12452, BgL_locz00_10027); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12453))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4280z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12453, BgL_locz00_10027); } 
return 
BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_12452, BgL_a2z00_12453);} } } } 

}



/* &<@anonymous:2659> */
obj_t BGl_z62zc3z04anonymousza32659ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10029, obj_t BgL_sz00_10033)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10030;obj_t BgL_a2z00_10031;obj_t BgL_locz00_10032;
BgL_a1z00_10030 = 
PROCEDURE_REF(BgL_envz00_10029, 
(int)(((long)0))); 
BgL_a2z00_10031 = 
PROCEDURE_REF(BgL_envz00_10029, 
(int)(((long)1))); 
BgL_locz00_10032 = 
PROCEDURE_REF(BgL_envz00_10029, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12454;
BgL_bpz00_12454 = 
VECTOR_REF(
((obj_t)BgL_sz00_10033),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12455;obj_t BgL_a2z00_12456;
BgL_a1z00_12455 = 
PROCEDURE_ENTRY(BgL_a1z00_10030)(BgL_a1z00_10030, BgL_sz00_10033, BEOA); 
BgL_a2z00_12456 = 
PROCEDURE_ENTRY(BgL_a2z00_10031)(BgL_a2z00_10031, BgL_sz00_10033, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12455))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4284z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12455, BgL_locz00_10032); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12456))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4284z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12456, BgL_locz00_10032); } 
return 
BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_12455, BgL_a2z00_12456);} } } } 

}



/* &<@anonymous:2663> */
obj_t BGl_z62zc3z04anonymousza32663ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10034, obj_t BgL_sz00_10038)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10035;obj_t BgL_a2z00_10036;obj_t BgL_locz00_10037;
BgL_a1z00_10035 = 
PROCEDURE_REF(BgL_envz00_10034, 
(int)(((long)0))); 
BgL_a2z00_10036 = 
PROCEDURE_REF(BgL_envz00_10034, 
(int)(((long)1))); 
BgL_locz00_10037 = 
PROCEDURE_REF(BgL_envz00_10034, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12457;
BgL_bpz00_12457 = 
VECTOR_REF(
((obj_t)BgL_sz00_10038),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12458;obj_t BgL_a2z00_12459;
BgL_a1z00_12458 = 
PROCEDURE_ENTRY(BgL_a1z00_10035)(BgL_a1z00_10035, BgL_sz00_10038, BEOA); 
BgL_a2z00_12459 = 
PROCEDURE_ENTRY(BgL_a2z00_10036)(BgL_a2z00_10036, BgL_sz00_10038, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12458))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4286z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12458, BgL_locz00_10037); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12459))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4286z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12459, BgL_locz00_10037); } 
return 
BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_12458, BgL_a2z00_12459);} } } } 

}



/* &<@anonymous:2667> */
obj_t BGl_z62zc3z04anonymousza32667ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10039, obj_t BgL_sz00_10043)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10040;obj_t BgL_a2z00_10041;obj_t BgL_locz00_10042;
BgL_a1z00_10040 = 
PROCEDURE_REF(BgL_envz00_10039, 
(int)(((long)0))); 
BgL_a2z00_10041 = 
PROCEDURE_REF(BgL_envz00_10039, 
(int)(((long)1))); 
BgL_locz00_10042 = 
PROCEDURE_REF(BgL_envz00_10039, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12460;
BgL_bpz00_12460 = 
VECTOR_REF(
((obj_t)BgL_sz00_10043),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12461;obj_t BgL_a2z00_12462;
BgL_a1z00_12461 = 
PROCEDURE_ENTRY(BgL_a1z00_10040)(BgL_a1z00_10040, BgL_sz00_10043, BEOA); 
BgL_a2z00_12462 = 
PROCEDURE_ENTRY(BgL_a2z00_10041)(BgL_a2z00_10041, BgL_sz00_10043, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12461))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4288z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12461, BgL_locz00_10042); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12462))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4288z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12462, BgL_locz00_10042); } 
return 
BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_12461, BgL_a2z00_12462);} } } } 

}



/* &<@anonymous:2671> */
obj_t BGl_z62zc3z04anonymousza32671ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10044, obj_t BgL_sz00_10048)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10045;obj_t BgL_a2z00_10046;obj_t BgL_locz00_10047;
BgL_a1z00_10045 = 
PROCEDURE_REF(BgL_envz00_10044, 
(int)(((long)0))); 
BgL_a2z00_10046 = 
PROCEDURE_REF(BgL_envz00_10044, 
(int)(((long)1))); 
BgL_locz00_10047 = 
PROCEDURE_REF(BgL_envz00_10044, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_19698;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12463;
BgL_bpz00_12463 = 
VECTOR_REF(
((obj_t)BgL_sz00_10048),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12464;obj_t BgL_a2z00_12465;
BgL_a1z00_12464 = 
PROCEDURE_ENTRY(BgL_a1z00_10045)(BgL_a1z00_10045, BgL_sz00_10048, BEOA); 
BgL_a2z00_12465 = 
PROCEDURE_ENTRY(BgL_a2z00_10046)(BgL_a2z00_10046, BgL_sz00_10048, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12464))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4290z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12464, BgL_locz00_10047); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12465))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4290z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12465, BgL_locz00_10047); } 
BgL_tmpz00_19698 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_12464, BgL_a2z00_12465); } } 
return 
BBOOL(BgL_tmpz00_19698);} } } 

}



/* &<@anonymous:2675> */
obj_t BGl_z62zc3z04anonymousza32675ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10049, obj_t BgL_sz00_10053)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10050;obj_t BgL_a2z00_10051;obj_t BgL_locz00_10052;
BgL_a1z00_10050 = 
PROCEDURE_REF(BgL_envz00_10049, 
(int)(((long)0))); 
BgL_a2z00_10051 = 
PROCEDURE_REF(BgL_envz00_10049, 
(int)(((long)1))); 
BgL_locz00_10052 = 
PROCEDURE_REF(BgL_envz00_10049, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_19723;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12466;
BgL_bpz00_12466 = 
VECTOR_REF(
((obj_t)BgL_sz00_10053),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12467;obj_t BgL_a2z00_12468;
BgL_a1z00_12467 = 
PROCEDURE_ENTRY(BgL_a1z00_10050)(BgL_a1z00_10050, BgL_sz00_10053, BEOA); 
BgL_a2z00_12468 = 
PROCEDURE_ENTRY(BgL_a2z00_10051)(BgL_a2z00_10051, BgL_sz00_10053, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12467))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4292z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12467, BgL_locz00_10052); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12468))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4292z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12468, BgL_locz00_10052); } 
BgL_tmpz00_19723 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_12467, BgL_a2z00_12468); } } 
return 
BBOOL(BgL_tmpz00_19723);} } } 

}



/* &<@anonymous:2679> */
obj_t BGl_z62zc3z04anonymousza32679ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10054, obj_t BgL_sz00_10058)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10055;obj_t BgL_a2z00_10056;obj_t BgL_locz00_10057;
BgL_a1z00_10055 = 
PROCEDURE_REF(BgL_envz00_10054, 
(int)(((long)0))); 
BgL_a2z00_10056 = 
PROCEDURE_REF(BgL_envz00_10054, 
(int)(((long)1))); 
BgL_locz00_10057 = 
PROCEDURE_REF(BgL_envz00_10054, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_19748;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12469;
BgL_bpz00_12469 = 
VECTOR_REF(
((obj_t)BgL_sz00_10058),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12470;obj_t BgL_a2z00_12471;
BgL_a1z00_12470 = 
PROCEDURE_ENTRY(BgL_a1z00_10055)(BgL_a1z00_10055, BgL_sz00_10058, BEOA); 
BgL_a2z00_12471 = 
PROCEDURE_ENTRY(BgL_a2z00_10056)(BgL_a2z00_10056, BgL_sz00_10058, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12470))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4294z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12470, BgL_locz00_10057); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12471))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4294z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12471, BgL_locz00_10057); } 
BgL_tmpz00_19748 = 
BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_12470, BgL_a2z00_12471); } } 
return 
BBOOL(BgL_tmpz00_19748);} } } 

}



/* &<@anonymous:2683> */
obj_t BGl_z62zc3z04anonymousza32683ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10059, obj_t BgL_sz00_10063)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10060;obj_t BgL_a2z00_10061;obj_t BgL_locz00_10062;
BgL_a1z00_10060 = 
PROCEDURE_REF(BgL_envz00_10059, 
(int)(((long)0))); 
BgL_a2z00_10061 = 
PROCEDURE_REF(BgL_envz00_10059, 
(int)(((long)1))); 
BgL_locz00_10062 = 
PROCEDURE_REF(BgL_envz00_10059, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_19773;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12472;
BgL_bpz00_12472 = 
VECTOR_REF(
((obj_t)BgL_sz00_10063),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12473;obj_t BgL_a2z00_12474;
BgL_a1z00_12473 = 
PROCEDURE_ENTRY(BgL_a1z00_10060)(BgL_a1z00_10060, BgL_sz00_10063, BEOA); 
BgL_a2z00_12474 = 
PROCEDURE_ENTRY(BgL_a2z00_10061)(BgL_a2z00_10061, BgL_sz00_10063, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12473))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4296z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12473, BgL_locz00_10062); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12474))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4296z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12474, BgL_locz00_10062); } 
BgL_tmpz00_19773 = 
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_12473, BgL_a2z00_12474); } } 
return 
BBOOL(BgL_tmpz00_19773);} } } 

}



/* &<@anonymous:2687> */
obj_t BGl_z62zc3z04anonymousza32687ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10064, obj_t BgL_sz00_10068)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10065;obj_t BgL_a2z00_10066;obj_t BgL_locz00_10067;
BgL_a1z00_10065 = 
PROCEDURE_REF(BgL_envz00_10064, 
(int)(((long)0))); 
BgL_a2z00_10066 = 
PROCEDURE_REF(BgL_envz00_10064, 
(int)(((long)1))); 
BgL_locz00_10067 = 
PROCEDURE_REF(BgL_envz00_10064, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_19798;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12475;
BgL_bpz00_12475 = 
VECTOR_REF(
((obj_t)BgL_sz00_10068),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12476;obj_t BgL_a2z00_12477;
BgL_a1z00_12476 = 
PROCEDURE_ENTRY(BgL_a1z00_10065)(BgL_a1z00_10065, BgL_sz00_10068, BEOA); 
BgL_a2z00_12477 = 
PROCEDURE_ENTRY(BgL_a2z00_10066)(BgL_a2z00_10066, BgL_sz00_10068, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_12476))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4298z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a1z00_12476, BgL_locz00_10067); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_12477))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4298z00zz__evaluate_compz00, BGl_symbol4282z00zz__evaluate_compz00, BgL_a2z00_12477, BgL_locz00_10067); } 
BgL_tmpz00_19798 = 
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_12476, BgL_a2z00_12477); } } 
return 
BBOOL(BgL_tmpz00_19798);} } } 

}



/* &<@anonymous:2691> */
obj_t BGl_z62zc3z04anonymousza32691ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10069, obj_t BgL_sz00_10073)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10070;obj_t BgL_a2z00_10071;obj_t BgL_locz00_10072;
BgL_a1z00_10070 = 
PROCEDURE_REF(BgL_envz00_10069, 
(int)(((long)0))); 
BgL_a2z00_10071 = 
PROCEDURE_REF(BgL_envz00_10069, 
(int)(((long)1))); 
BgL_locz00_10072 = 
PROCEDURE_REF(BgL_envz00_10069, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_19823;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12478;
BgL_bpz00_12478 = 
VECTOR_REF(
((obj_t)BgL_sz00_10073),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12479;obj_t BgL_a2z00_12480;
BgL_a1z00_12479 = 
PROCEDURE_ENTRY(BgL_a1z00_10070)(BgL_a1z00_10070, BgL_sz00_10073, BEOA); 
BgL_a2z00_12480 = 
PROCEDURE_ENTRY(BgL_a2z00_10071)(BgL_a2z00_10071, BgL_sz00_10073, BEOA); 
if(
INTEGERP(BgL_a1z00_12479))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4300z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12479, BgL_locz00_10072); } 
if(
INTEGERP(BgL_a2z00_12480))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4300z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12480, BgL_locz00_10072); } 
BgL_tmpz00_19823 = 
(
(long)CINT(BgL_a1z00_12479)+
(long)CINT(BgL_a2z00_12480)); } } 
return 
BINT(BgL_tmpz00_19823);} } } 

}



/* &<@anonymous:2695> */
obj_t BGl_z62zc3z04anonymousza32695ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10074, obj_t BgL_sz00_10078)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10075;obj_t BgL_a2z00_10076;obj_t BgL_locz00_10077;
BgL_a1z00_10075 = 
PROCEDURE_REF(BgL_envz00_10074, 
(int)(((long)0))); 
BgL_a2z00_10076 = 
PROCEDURE_REF(BgL_envz00_10074, 
(int)(((long)1))); 
BgL_locz00_10077 = 
PROCEDURE_REF(BgL_envz00_10074, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_19850;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12481;
BgL_bpz00_12481 = 
VECTOR_REF(
((obj_t)BgL_sz00_10078),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12482;obj_t BgL_a2z00_12483;
BgL_a1z00_12482 = 
PROCEDURE_ENTRY(BgL_a1z00_10075)(BgL_a1z00_10075, BgL_sz00_10078, BEOA); 
BgL_a2z00_12483 = 
PROCEDURE_ENTRY(BgL_a2z00_10076)(BgL_a2z00_10076, BgL_sz00_10078, BEOA); 
if(
INTEGERP(BgL_a1z00_12482))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4304z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12482, BgL_locz00_10077); } 
if(
INTEGERP(BgL_a2z00_12483))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4304z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12483, BgL_locz00_10077); } 
BgL_tmpz00_19850 = 
(
(long)CINT(BgL_a1z00_12482)-
(long)CINT(BgL_a2z00_12483)); } } 
return 
BINT(BgL_tmpz00_19850);} } } 

}



/* &<@anonymous:2699> */
obj_t BGl_z62zc3z04anonymousza32699ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10079, obj_t BgL_sz00_10083)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10080;obj_t BgL_a2z00_10081;obj_t BgL_locz00_10082;
BgL_a1z00_10080 = 
PROCEDURE_REF(BgL_envz00_10079, 
(int)(((long)0))); 
BgL_a2z00_10081 = 
PROCEDURE_REF(BgL_envz00_10079, 
(int)(((long)1))); 
BgL_locz00_10082 = 
PROCEDURE_REF(BgL_envz00_10079, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_19877;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12484;
BgL_bpz00_12484 = 
VECTOR_REF(
((obj_t)BgL_sz00_10083),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12485;obj_t BgL_a2z00_12486;
BgL_a1z00_12485 = 
PROCEDURE_ENTRY(BgL_a1z00_10080)(BgL_a1z00_10080, BgL_sz00_10083, BEOA); 
BgL_a2z00_12486 = 
PROCEDURE_ENTRY(BgL_a2z00_10081)(BgL_a2z00_10081, BgL_sz00_10083, BEOA); 
if(
INTEGERP(BgL_a1z00_12485))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4306z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12485, BgL_locz00_10082); } 
if(
INTEGERP(BgL_a2z00_12486))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4306z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12486, BgL_locz00_10082); } 
BgL_tmpz00_19877 = 
(
(long)CINT(BgL_a1z00_12485)*
(long)CINT(BgL_a2z00_12486)); } } 
return 
BINT(BgL_tmpz00_19877);} } } 

}



/* &<@anonymous:2703> */
obj_t BGl_z62zc3z04anonymousza32703ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10084, obj_t BgL_sz00_10088)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10085;obj_t BgL_a2z00_10086;obj_t BgL_locz00_10087;
BgL_a1z00_10085 = 
PROCEDURE_REF(BgL_envz00_10084, 
(int)(((long)0))); 
BgL_a2z00_10086 = 
PROCEDURE_REF(BgL_envz00_10084, 
(int)(((long)1))); 
BgL_locz00_10087 = 
PROCEDURE_REF(BgL_envz00_10084, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_19904;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12487;
BgL_bpz00_12487 = 
VECTOR_REF(
((obj_t)BgL_sz00_10088),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12488;obj_t BgL_a2z00_12489;
BgL_a1z00_12488 = 
PROCEDURE_ENTRY(BgL_a1z00_10085)(BgL_a1z00_10085, BgL_sz00_10088, BEOA); 
BgL_a2z00_12489 = 
PROCEDURE_ENTRY(BgL_a2z00_10086)(BgL_a2z00_10086, BgL_sz00_10088, BEOA); 
if(
INTEGERP(BgL_a1z00_12488))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4308z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12488, BgL_locz00_10087); } 
if(
INTEGERP(BgL_a2z00_12489))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4308z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12489, BgL_locz00_10087); } 
BgL_tmpz00_19904 = 
(
(long)CINT(BgL_a1z00_12488)/
(long)CINT(BgL_a2z00_12489)); } } 
return 
BINT(BgL_tmpz00_19904);} } } 

}



/* &<@anonymous:2707> */
obj_t BGl_z62zc3z04anonymousza32707ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10089, obj_t BgL_sz00_10093)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10090;obj_t BgL_a2z00_10091;obj_t BgL_locz00_10092;
BgL_a1z00_10090 = 
PROCEDURE_REF(BgL_envz00_10089, 
(int)(((long)0))); 
BgL_a2z00_10091 = 
PROCEDURE_REF(BgL_envz00_10089, 
(int)(((long)1))); 
BgL_locz00_10092 = 
PROCEDURE_REF(BgL_envz00_10089, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_19931;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12490;
BgL_bpz00_12490 = 
VECTOR_REF(
((obj_t)BgL_sz00_10093),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12491;obj_t BgL_a2z00_12492;
BgL_a1z00_12491 = 
PROCEDURE_ENTRY(BgL_a1z00_10090)(BgL_a1z00_10090, BgL_sz00_10093, BEOA); 
BgL_a2z00_12492 = 
PROCEDURE_ENTRY(BgL_a2z00_10091)(BgL_a2z00_10091, BgL_sz00_10093, BEOA); 
if(
INTEGERP(BgL_a1z00_12491))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4310z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12491, BgL_locz00_10092); } 
if(
INTEGERP(BgL_a2z00_12492))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4310z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12492, BgL_locz00_10092); } 
BgL_tmpz00_19931 = 
(
(long)CINT(BgL_a1z00_12491)<
(long)CINT(BgL_a2z00_12492)); } } 
return 
BBOOL(BgL_tmpz00_19931);} } } 

}



/* &<@anonymous:2711> */
obj_t BGl_z62zc3z04anonymousza32711ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10094, obj_t BgL_sz00_10098)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10095;obj_t BgL_a2z00_10096;obj_t BgL_locz00_10097;
BgL_a1z00_10095 = 
PROCEDURE_REF(BgL_envz00_10094, 
(int)(((long)0))); 
BgL_a2z00_10096 = 
PROCEDURE_REF(BgL_envz00_10094, 
(int)(((long)1))); 
BgL_locz00_10097 = 
PROCEDURE_REF(BgL_envz00_10094, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_19958;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12493;
BgL_bpz00_12493 = 
VECTOR_REF(
((obj_t)BgL_sz00_10098),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12494;obj_t BgL_a2z00_12495;
BgL_a1z00_12494 = 
PROCEDURE_ENTRY(BgL_a1z00_10095)(BgL_a1z00_10095, BgL_sz00_10098, BEOA); 
BgL_a2z00_12495 = 
PROCEDURE_ENTRY(BgL_a2z00_10096)(BgL_a2z00_10096, BgL_sz00_10098, BEOA); 
if(
INTEGERP(BgL_a1z00_12494))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4312z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12494, BgL_locz00_10097); } 
if(
INTEGERP(BgL_a2z00_12495))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4312z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12495, BgL_locz00_10097); } 
BgL_tmpz00_19958 = 
(
(long)CINT(BgL_a1z00_12494)>
(long)CINT(BgL_a2z00_12495)); } } 
return 
BBOOL(BgL_tmpz00_19958);} } } 

}



/* &<@anonymous:2715> */
obj_t BGl_z62zc3z04anonymousza32715ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10099, obj_t BgL_sz00_10103)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10100;obj_t BgL_a2z00_10101;obj_t BgL_locz00_10102;
BgL_a1z00_10100 = 
PROCEDURE_REF(BgL_envz00_10099, 
(int)(((long)0))); 
BgL_a2z00_10101 = 
PROCEDURE_REF(BgL_envz00_10099, 
(int)(((long)1))); 
BgL_locz00_10102 = 
PROCEDURE_REF(BgL_envz00_10099, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_19985;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12496;
BgL_bpz00_12496 = 
VECTOR_REF(
((obj_t)BgL_sz00_10103),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12497;obj_t BgL_a2z00_12498;
BgL_a1z00_12497 = 
PROCEDURE_ENTRY(BgL_a1z00_10100)(BgL_a1z00_10100, BgL_sz00_10103, BEOA); 
BgL_a2z00_12498 = 
PROCEDURE_ENTRY(BgL_a2z00_10101)(BgL_a2z00_10101, BgL_sz00_10103, BEOA); 
if(
INTEGERP(BgL_a1z00_12497))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4314z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12497, BgL_locz00_10102); } 
if(
INTEGERP(BgL_a2z00_12498))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4314z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12498, BgL_locz00_10102); } 
BgL_tmpz00_19985 = 
(
(long)CINT(BgL_a1z00_12497)<=
(long)CINT(BgL_a2z00_12498)); } } 
return 
BBOOL(BgL_tmpz00_19985);} } } 

}



/* &<@anonymous:2719> */
obj_t BGl_z62zc3z04anonymousza32719ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10104, obj_t BgL_sz00_10108)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10105;obj_t BgL_a2z00_10106;obj_t BgL_locz00_10107;
BgL_a1z00_10105 = 
PROCEDURE_REF(BgL_envz00_10104, 
(int)(((long)0))); 
BgL_a2z00_10106 = 
PROCEDURE_REF(BgL_envz00_10104, 
(int)(((long)1))); 
BgL_locz00_10107 = 
PROCEDURE_REF(BgL_envz00_10104, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20012;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12499;
BgL_bpz00_12499 = 
VECTOR_REF(
((obj_t)BgL_sz00_10108),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12500;obj_t BgL_a2z00_12501;
BgL_a1z00_12500 = 
PROCEDURE_ENTRY(BgL_a1z00_10105)(BgL_a1z00_10105, BgL_sz00_10108, BEOA); 
BgL_a2z00_12501 = 
PROCEDURE_ENTRY(BgL_a2z00_10106)(BgL_a2z00_10106, BgL_sz00_10108, BEOA); 
if(
INTEGERP(BgL_a1z00_12500))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4316z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12500, BgL_locz00_10107); } 
if(
INTEGERP(BgL_a2z00_12501))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4316z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12501, BgL_locz00_10107); } 
BgL_tmpz00_20012 = 
(
(long)CINT(BgL_a1z00_12500)>=
(long)CINT(BgL_a2z00_12501)); } } 
return 
BBOOL(BgL_tmpz00_20012);} } } 

}



/* &<@anonymous:2723> */
obj_t BGl_z62zc3z04anonymousza32723ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10109, obj_t BgL_sz00_10113)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10110;obj_t BgL_a2z00_10111;obj_t BgL_locz00_10112;
BgL_a1z00_10110 = 
PROCEDURE_REF(BgL_envz00_10109, 
(int)(((long)0))); 
BgL_a2z00_10111 = 
PROCEDURE_REF(BgL_envz00_10109, 
(int)(((long)1))); 
BgL_locz00_10112 = 
PROCEDURE_REF(BgL_envz00_10109, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20039;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12502;
BgL_bpz00_12502 = 
VECTOR_REF(
((obj_t)BgL_sz00_10113),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12503;obj_t BgL_a2z00_12504;
BgL_a1z00_12503 = 
PROCEDURE_ENTRY(BgL_a1z00_10110)(BgL_a1z00_10110, BgL_sz00_10113, BEOA); 
BgL_a2z00_12504 = 
PROCEDURE_ENTRY(BgL_a2z00_10111)(BgL_a2z00_10111, BgL_sz00_10113, BEOA); 
if(
INTEGERP(BgL_a1z00_12503))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4318z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a1z00_12503, BgL_locz00_10112); } 
if(
INTEGERP(BgL_a2z00_12504))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4318z00zz__evaluate_compz00, BGl_symbol4302z00zz__evaluate_compz00, BgL_a2z00_12504, BgL_locz00_10112); } 
BgL_tmpz00_20039 = 
(
(long)CINT(BgL_a1z00_12503)==
(long)CINT(BgL_a2z00_12504)); } } 
return 
BBOOL(BgL_tmpz00_20039);} } } 

}



/* &<@anonymous:2727> */
obj_t BGl_z62zc3z04anonymousza32727ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10114, obj_t BgL_sz00_10118)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10115;obj_t BgL_a2z00_10116;obj_t BgL_locz00_10117;
BgL_a1z00_10115 = 
PROCEDURE_REF(BgL_envz00_10114, 
(int)(((long)0))); 
BgL_a2z00_10116 = 
PROCEDURE_REF(BgL_envz00_10114, 
(int)(((long)1))); 
BgL_locz00_10117 = 
PROCEDURE_REF(BgL_envz00_10114, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_20066;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12505;
BgL_bpz00_12505 = 
VECTOR_REF(
((obj_t)BgL_sz00_10118),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12506;obj_t BgL_a2z00_12507;
BgL_a1z00_12506 = 
PROCEDURE_ENTRY(BgL_a1z00_10115)(BgL_a1z00_10115, BgL_sz00_10118, BEOA); 
BgL_a2z00_12507 = 
PROCEDURE_ENTRY(BgL_a2z00_10116)(BgL_a2z00_10116, BgL_sz00_10118, BEOA); 
if(
REALP(BgL_a1z00_12506))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4320z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12506, BgL_locz00_10117); } 
if(
REALP(BgL_a2z00_12507))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4320z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12507, BgL_locz00_10117); } 
BgL_tmpz00_20066 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12506)+
REAL_TO_DOUBLE(BgL_a2z00_12507)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20066);} } } 

}



/* &<@anonymous:2731> */
obj_t BGl_z62zc3z04anonymousza32731ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10119, obj_t BgL_sz00_10123)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10120;obj_t BgL_a2z00_10121;obj_t BgL_locz00_10122;
BgL_a1z00_10120 = 
PROCEDURE_REF(BgL_envz00_10119, 
(int)(((long)0))); 
BgL_a2z00_10121 = 
PROCEDURE_REF(BgL_envz00_10119, 
(int)(((long)1))); 
BgL_locz00_10122 = 
PROCEDURE_REF(BgL_envz00_10119, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_20093;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12508;
BgL_bpz00_12508 = 
VECTOR_REF(
((obj_t)BgL_sz00_10123),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12509;obj_t BgL_a2z00_12510;
BgL_a1z00_12509 = 
PROCEDURE_ENTRY(BgL_a1z00_10120)(BgL_a1z00_10120, BgL_sz00_10123, BEOA); 
BgL_a2z00_12510 = 
PROCEDURE_ENTRY(BgL_a2z00_10121)(BgL_a2z00_10121, BgL_sz00_10123, BEOA); 
if(
REALP(BgL_a1z00_12509))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4324z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12509, BgL_locz00_10122); } 
if(
REALP(BgL_a2z00_12510))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4324z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12510, BgL_locz00_10122); } 
BgL_tmpz00_20093 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12509)-
REAL_TO_DOUBLE(BgL_a2z00_12510)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20093);} } } 

}



/* &<@anonymous:2735> */
obj_t BGl_z62zc3z04anonymousza32735ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10124, obj_t BgL_sz00_10128)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10125;obj_t BgL_a2z00_10126;obj_t BgL_locz00_10127;
BgL_a1z00_10125 = 
PROCEDURE_REF(BgL_envz00_10124, 
(int)(((long)0))); 
BgL_a2z00_10126 = 
PROCEDURE_REF(BgL_envz00_10124, 
(int)(((long)1))); 
BgL_locz00_10127 = 
PROCEDURE_REF(BgL_envz00_10124, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_20120;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12511;
BgL_bpz00_12511 = 
VECTOR_REF(
((obj_t)BgL_sz00_10128),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12512;obj_t BgL_a2z00_12513;
BgL_a1z00_12512 = 
PROCEDURE_ENTRY(BgL_a1z00_10125)(BgL_a1z00_10125, BgL_sz00_10128, BEOA); 
BgL_a2z00_12513 = 
PROCEDURE_ENTRY(BgL_a2z00_10126)(BgL_a2z00_10126, BgL_sz00_10128, BEOA); 
if(
REALP(BgL_a1z00_12512))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4326z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12512, BgL_locz00_10127); } 
if(
REALP(BgL_a2z00_12513))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4326z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12513, BgL_locz00_10127); } 
BgL_tmpz00_20120 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12512)*
REAL_TO_DOUBLE(BgL_a2z00_12513)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20120);} } } 

}



/* &<@anonymous:2739> */
obj_t BGl_z62zc3z04anonymousza32739ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10129, obj_t BgL_sz00_10133)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10130;obj_t BgL_a2z00_10131;obj_t BgL_locz00_10132;
BgL_a1z00_10130 = 
PROCEDURE_REF(BgL_envz00_10129, 
(int)(((long)0))); 
BgL_a2z00_10131 = 
PROCEDURE_REF(BgL_envz00_10129, 
(int)(((long)1))); 
BgL_locz00_10132 = 
PROCEDURE_REF(BgL_envz00_10129, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_20147;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12514;
BgL_bpz00_12514 = 
VECTOR_REF(
((obj_t)BgL_sz00_10133),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12515;obj_t BgL_a2z00_12516;
BgL_a1z00_12515 = 
PROCEDURE_ENTRY(BgL_a1z00_10130)(BgL_a1z00_10130, BgL_sz00_10133, BEOA); 
BgL_a2z00_12516 = 
PROCEDURE_ENTRY(BgL_a2z00_10131)(BgL_a2z00_10131, BgL_sz00_10133, BEOA); 
if(
REALP(BgL_a1z00_12515))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4328z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12515, BgL_locz00_10132); } 
if(
REALP(BgL_a2z00_12516))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4328z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12516, BgL_locz00_10132); } 
BgL_tmpz00_20147 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12515)/
REAL_TO_DOUBLE(BgL_a2z00_12516)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20147);} } } 

}



/* &<@anonymous:2743> */
obj_t BGl_z62zc3z04anonymousza32743ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10134, obj_t BgL_sz00_10138)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10135;obj_t BgL_a2z00_10136;obj_t BgL_locz00_10137;
BgL_a1z00_10135 = 
PROCEDURE_REF(BgL_envz00_10134, 
(int)(((long)0))); 
BgL_a2z00_10136 = 
PROCEDURE_REF(BgL_envz00_10134, 
(int)(((long)1))); 
BgL_locz00_10137 = 
PROCEDURE_REF(BgL_envz00_10134, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20174;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12517;
BgL_bpz00_12517 = 
VECTOR_REF(
((obj_t)BgL_sz00_10138),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12518;obj_t BgL_a2z00_12519;
BgL_a1z00_12518 = 
PROCEDURE_ENTRY(BgL_a1z00_10135)(BgL_a1z00_10135, BgL_sz00_10138, BEOA); 
BgL_a2z00_12519 = 
PROCEDURE_ENTRY(BgL_a2z00_10136)(BgL_a2z00_10136, BgL_sz00_10138, BEOA); 
if(
REALP(BgL_a1z00_12518))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4330z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12518, BgL_locz00_10137); } 
if(
REALP(BgL_a2z00_12519))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4330z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12519, BgL_locz00_10137); } 
BgL_tmpz00_20174 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12518)<
REAL_TO_DOUBLE(BgL_a2z00_12519)); } } 
return 
BBOOL(BgL_tmpz00_20174);} } } 

}



/* &<@anonymous:2747> */
obj_t BGl_z62zc3z04anonymousza32747ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10139, obj_t BgL_sz00_10143)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10140;obj_t BgL_a2z00_10141;obj_t BgL_locz00_10142;
BgL_a1z00_10140 = 
PROCEDURE_REF(BgL_envz00_10139, 
(int)(((long)0))); 
BgL_a2z00_10141 = 
PROCEDURE_REF(BgL_envz00_10139, 
(int)(((long)1))); 
BgL_locz00_10142 = 
PROCEDURE_REF(BgL_envz00_10139, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20201;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12520;
BgL_bpz00_12520 = 
VECTOR_REF(
((obj_t)BgL_sz00_10143),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12521;obj_t BgL_a2z00_12522;
BgL_a1z00_12521 = 
PROCEDURE_ENTRY(BgL_a1z00_10140)(BgL_a1z00_10140, BgL_sz00_10143, BEOA); 
BgL_a2z00_12522 = 
PROCEDURE_ENTRY(BgL_a2z00_10141)(BgL_a2z00_10141, BgL_sz00_10143, BEOA); 
if(
REALP(BgL_a1z00_12521))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4332z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12521, BgL_locz00_10142); } 
if(
REALP(BgL_a2z00_12522))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4332z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12522, BgL_locz00_10142); } 
BgL_tmpz00_20201 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12521)>
REAL_TO_DOUBLE(BgL_a2z00_12522)); } } 
return 
BBOOL(BgL_tmpz00_20201);} } } 

}



/* &<@anonymous:2751> */
obj_t BGl_z62zc3z04anonymousza32751ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10144, obj_t BgL_sz00_10148)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10145;obj_t BgL_a2z00_10146;obj_t BgL_locz00_10147;
BgL_a1z00_10145 = 
PROCEDURE_REF(BgL_envz00_10144, 
(int)(((long)0))); 
BgL_a2z00_10146 = 
PROCEDURE_REF(BgL_envz00_10144, 
(int)(((long)1))); 
BgL_locz00_10147 = 
PROCEDURE_REF(BgL_envz00_10144, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20228;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12523;
BgL_bpz00_12523 = 
VECTOR_REF(
((obj_t)BgL_sz00_10148),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12524;obj_t BgL_a2z00_12525;
BgL_a1z00_12524 = 
PROCEDURE_ENTRY(BgL_a1z00_10145)(BgL_a1z00_10145, BgL_sz00_10148, BEOA); 
BgL_a2z00_12525 = 
PROCEDURE_ENTRY(BgL_a2z00_10146)(BgL_a2z00_10146, BgL_sz00_10148, BEOA); 
if(
REALP(BgL_a1z00_12524))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4334z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12524, BgL_locz00_10147); } 
if(
REALP(BgL_a2z00_12525))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4334z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12525, BgL_locz00_10147); } 
BgL_tmpz00_20228 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12524)<=
REAL_TO_DOUBLE(BgL_a2z00_12525)); } } 
return 
BBOOL(BgL_tmpz00_20228);} } } 

}



/* &<@anonymous:2755> */
obj_t BGl_z62zc3z04anonymousza32755ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10149, obj_t BgL_sz00_10153)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10150;obj_t BgL_a2z00_10151;obj_t BgL_locz00_10152;
BgL_a1z00_10150 = 
PROCEDURE_REF(BgL_envz00_10149, 
(int)(((long)0))); 
BgL_a2z00_10151 = 
PROCEDURE_REF(BgL_envz00_10149, 
(int)(((long)1))); 
BgL_locz00_10152 = 
PROCEDURE_REF(BgL_envz00_10149, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20255;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12526;
BgL_bpz00_12526 = 
VECTOR_REF(
((obj_t)BgL_sz00_10153),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12527;obj_t BgL_a2z00_12528;
BgL_a1z00_12527 = 
PROCEDURE_ENTRY(BgL_a1z00_10150)(BgL_a1z00_10150, BgL_sz00_10153, BEOA); 
BgL_a2z00_12528 = 
PROCEDURE_ENTRY(BgL_a2z00_10151)(BgL_a2z00_10151, BgL_sz00_10153, BEOA); 
if(
REALP(BgL_a1z00_12527))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4336z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12527, BgL_locz00_10152); } 
if(
REALP(BgL_a2z00_12528))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4336z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12528, BgL_locz00_10152); } 
BgL_tmpz00_20255 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12527)>=
REAL_TO_DOUBLE(BgL_a2z00_12528)); } } 
return 
BBOOL(BgL_tmpz00_20255);} } } 

}



/* &<@anonymous:2759> */
obj_t BGl_z62zc3z04anonymousza32759ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10154, obj_t BgL_sz00_10158)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10155;obj_t BgL_a2z00_10156;obj_t BgL_locz00_10157;
BgL_a1z00_10155 = 
PROCEDURE_REF(BgL_envz00_10154, 
(int)(((long)0))); 
BgL_a2z00_10156 = 
PROCEDURE_REF(BgL_envz00_10154, 
(int)(((long)1))); 
BgL_locz00_10157 = 
PROCEDURE_REF(BgL_envz00_10154, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20282;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12529;
BgL_bpz00_12529 = 
VECTOR_REF(
((obj_t)BgL_sz00_10158),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12530;obj_t BgL_a2z00_12531;
BgL_a1z00_12530 = 
PROCEDURE_ENTRY(BgL_a1z00_10155)(BgL_a1z00_10155, BgL_sz00_10158, BEOA); 
BgL_a2z00_12531 = 
PROCEDURE_ENTRY(BgL_a2z00_10156)(BgL_a2z00_10156, BgL_sz00_10158, BEOA); 
if(
REALP(BgL_a1z00_12530))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4338z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a1z00_12530, BgL_locz00_10157); } 
if(
REALP(BgL_a2z00_12531))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4338z00zz__evaluate_compz00, BGl_symbol4322z00zz__evaluate_compz00, BgL_a2z00_12531, BgL_locz00_10157); } 
BgL_tmpz00_20282 = 
(
REAL_TO_DOUBLE(BgL_a1z00_12530)==
REAL_TO_DOUBLE(BgL_a2z00_12531)); } } 
return 
BBOOL(BgL_tmpz00_20282);} } } 

}



/* &<@anonymous:2763> */
obj_t BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10159, obj_t BgL_sz00_10162)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10160;obj_t BgL_a2z00_10161;
BgL_a1z00_10160 = 
PROCEDURE_REF(BgL_envz00_10159, 
(int)(((long)0))); 
BgL_a2z00_10161 = 
PROCEDURE_REF(BgL_envz00_10159, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20307;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12532;
BgL_bpz00_12532 = 
VECTOR_REF(
((obj_t)BgL_sz00_10162),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12533;obj_t BgL_a2z00_12534;
BgL_a1z00_12533 = 
PROCEDURE_ENTRY(BgL_a1z00_10160)(BgL_a1z00_10160, BgL_sz00_10162, BEOA); 
BgL_a2z00_12534 = 
PROCEDURE_ENTRY(BgL_a2z00_10161)(BgL_a2z00_10161, BgL_sz00_10162, BEOA); 
BgL_tmpz00_20307 = 
(BgL_a1z00_12533==BgL_a2z00_12534); } } 
return 
BBOOL(BgL_tmpz00_20307);} } } 

}



/* &<@anonymous:2765> */
obj_t BGl_z62zc3z04anonymousza32765ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10163, obj_t BgL_sz00_10166)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_10164;obj_t BgL_a2z00_10165;
BgL_a1z00_10164 = 
PROCEDURE_REF(BgL_envz00_10163, 
(int)(((long)0))); 
BgL_a2z00_10165 = 
PROCEDURE_REF(BgL_envz00_10163, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_12535;
BgL_bpz00_12535 = 
VECTOR_REF(
((obj_t)BgL_sz00_10166),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_12536;obj_t BgL_a2z00_12537;
BgL_a1z00_12536 = 
PROCEDURE_ENTRY(BgL_a1z00_10164)(BgL_a1z00_10164, BgL_sz00_10166, BEOA); 
BgL_a2z00_12537 = 
PROCEDURE_ENTRY(BgL_a2z00_10165)(BgL_a2z00_10165, BgL_sz00_10166, BEOA); 
return 
MAKE_YOUNG_PAIR(BgL_a1z00_12536, BgL_a2z00_12537);} } } } 

}



/* &<@anonymous:2768> */
obj_t BGl_z62zc3z04anonymousza32768ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10167, obj_t BgL_sz00_10170)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_10168;obj_t BgL_locz00_10169;
BgL_a1z00_10168 = 
PROCEDURE_REF(BgL_envz00_10167, 
(int)(((long)0))); 
BgL_locz00_10169 = 
PROCEDURE_REF(BgL_envz00_10167, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_12538;
BgL_bpz00_12538 = 
VECTOR_REF(
((obj_t)BgL_sz00_10170),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_12539;
BgL_a1z00_12539 = 
PROCEDURE_ENTRY(BgL_a1z00_10168)(BgL_a1z00_10168, BgL_sz00_10170, BEOA); 
if(
PAIRP(BgL_a1z00_12539))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4340z00zz__evaluate_compz00, BGl_symbol4342z00zz__evaluate_compz00, BgL_a1z00_12539, BgL_locz00_10169); } 
return 
CAR(
((obj_t)BgL_a1z00_12539));} } } } 

}



/* &<@anonymous:2771> */
obj_t BGl_z62zc3z04anonymousza32771ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10171, obj_t BgL_sz00_10174)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_10172;obj_t BgL_locz00_10173;
BgL_a1z00_10172 = 
PROCEDURE_REF(BgL_envz00_10171, 
(int)(((long)0))); 
BgL_locz00_10173 = 
PROCEDURE_REF(BgL_envz00_10171, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_12540;
BgL_bpz00_12540 = 
VECTOR_REF(
((obj_t)BgL_sz00_10174),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_12541;
BgL_a1z00_12541 = 
PROCEDURE_ENTRY(BgL_a1z00_10172)(BgL_a1z00_10172, BgL_sz00_10174, BEOA); 
if(
PAIRP(BgL_a1z00_12541))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4344z00zz__evaluate_compz00, BGl_symbol4342z00zz__evaluate_compz00, BgL_a1z00_12541, BgL_locz00_10173); } 
return 
CDR(
((obj_t)BgL_a1z00_12541));} } } } 

}



/* &<@anonymous:2774> */
obj_t BGl_z62zc3z04anonymousza32774ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10175, obj_t BgL_sz00_10178)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_10176;obj_t BgL_locz00_10177;
BgL_a1z00_10176 = 
PROCEDURE_REF(BgL_envz00_10175, 
(int)(((long)0))); 
BgL_locz00_10177 = 
PROCEDURE_REF(BgL_envz00_10175, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_12542;
BgL_bpz00_12542 = 
VECTOR_REF(
((obj_t)BgL_sz00_10178),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_12543;
BgL_a1z00_12543 = 
PROCEDURE_ENTRY(BgL_a1z00_10176)(BgL_a1z00_10176, BgL_sz00_10178, BEOA); 
if(
BGl_cadrzf3zf3zz__evaluate_compz00(BgL_a1z00_12543))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_arg2776z00_12544;
BgL_arg2776z00_12544 = 
BGl_cadrerrvz00zz__evaluate_compz00(BgL_a1z00_12543); 
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol4346z00zz__evaluate_compz00, BGl_symbol4342z00zz__evaluate_compz00, BgL_arg2776z00_12544, BgL_locz00_10177); } 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_pairz00_12545;
BgL_pairz00_12545 = 
CDR(
((obj_t)BgL_a1z00_12543)); 
return 
CAR(BgL_pairz00_12545);} } } } } 

}



/* cadr? */
bool_t BGl_cadrzf3zf3zz__evaluate_compz00(obj_t BgL_lz00_197)
{
{ /* Eval/evaluate_comp.scm 1026 */
if(
PAIRP(BgL_lz00_197))
{ /* Eval/evaluate_comp.scm 1027 */
obj_t BgL_tmpz00_20384;
BgL_tmpz00_20384 = 
CDR(BgL_lz00_197); 
return 
PAIRP(BgL_tmpz00_20384);}  else 
{ /* Eval/evaluate_comp.scm 1027 */
return ((bool_t)0);} } 

}



/* cadrerrv */
obj_t BGl_cadrerrvz00zz__evaluate_compz00(obj_t BgL_vz00_198)
{
{ /* Eval/evaluate_comp.scm 1029 */
if(
PAIRP(BgL_vz00_198))
{ /* Eval/evaluate_comp.scm 1030 */
return 
CDR(BgL_vz00_198);}  else 
{ /* Eval/evaluate_comp.scm 1030 */
return BgL_vz00_198;} } 

}



/* correct */
long BGl_correctz00zz__evaluate_compz00(obj_t BgL_nz00_201, long BgL_donez00_202)
{
{ /* Eval/evaluate_comp.scm 1058 */
if(
(
(long)CINT(BgL_nz00_201)<((long)0)))
{ /* Eval/evaluate_comp.scm 1059 */
return 
(
(long)CINT(BgL_nz00_201)+BgL_donez00_202);}  else 
{ /* Eval/evaluate_comp.scm 1059 */
return 
(
(long)CINT(BgL_nz00_201)-BgL_donez00_202);} } 

}



/* bind-frame */
obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203, obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206, obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
{
{ /* Eval/evaluate_comp.scm 1063 */
if(
(BgL_arityz00_206<((long)0)))
{ /* Eval/evaluate_comp.scm 1065 */
long BgL_g1234z00_3525;
BgL_g1234z00_3525 = 
(((long)-1)-BgL_arityz00_206); 
{ 
long BgL_rz00_3527;long BgL_spz00_3528;obj_t BgL_lz00_3529;
BgL_rz00_3527 = BgL_g1234z00_3525; 
BgL_spz00_3528 = BgL_spz00_205; 
BgL_lz00_3529 = BgL_valsz00_207; 
BgL_zc3z04anonymousza32781ze3z87_3530:
if(
(BgL_rz00_3527==((long)0)))
{ /* Eval/evaluate_comp.scm 1067 */
return 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3528,BgL_lz00_3529);}  else 
{ /* Eval/evaluate_comp.scm 1067 */
if(
PAIRP(BgL_lz00_3529))
{ /* Eval/evaluate_comp.scm 1069 */
{ /* Eval/evaluate_comp.scm 1072 */
obj_t BgL_arg2784z00_3533;
BgL_arg2784z00_3533 = 
CAR(BgL_lz00_3529); 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3528,BgL_arg2784z00_3533); } 
{ 
obj_t BgL_lz00_20413;long BgL_spz00_20411;long BgL_rz00_20409;
BgL_rz00_20409 = 
(BgL_rz00_3527-((long)1)); 
BgL_spz00_20411 = 
(BgL_spz00_3528+((long)1)); 
BgL_lz00_20413 = 
CDR(BgL_lz00_3529); 
BgL_lz00_3529 = BgL_lz00_20413; 
BgL_spz00_3528 = BgL_spz00_20411; 
BgL_rz00_3527 = BgL_rz00_20409; 
goto BgL_zc3z04anonymousza32781ze3z87_3530;} }  else 
{ /* Eval/evaluate_comp.scm 1070 */
long BgL_arg2788z00_3537;
BgL_arg2788z00_3537 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2788z00_3537));} } } }  else 
{ 
long BgL_rz00_3540;long BgL_spz00_3541;obj_t BgL_lz00_3542;
BgL_rz00_3540 = BgL_arityz00_206; 
BgL_spz00_3541 = BgL_spz00_205; 
BgL_lz00_3542 = BgL_valsz00_207; 
BgL_zc3z04anonymousza32789ze3z87_3543:
if(
(BgL_rz00_3540==((long)0)))
{ /* Eval/evaluate_comp.scm 1076 */
if(
NULLP(BgL_lz00_3542))
{ /* Eval/evaluate_comp.scm 1077 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 1078 */
long BgL_arg2792z00_3546;
BgL_arg2792z00_3546 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2792z00_3546));} }  else 
{ /* Eval/evaluate_comp.scm 1076 */
if(
PAIRP(BgL_lz00_3542))
{ /* Eval/evaluate_comp.scm 1079 */
{ /* Eval/evaluate_comp.scm 1082 */
obj_t BgL_arg2794z00_3548;
BgL_arg2794z00_3548 = 
CAR(BgL_lz00_3542); 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3541,BgL_arg2794z00_3548); } 
{ 
obj_t BgL_lz00_20436;long BgL_spz00_20434;long BgL_rz00_20432;
BgL_rz00_20432 = 
(BgL_rz00_3540-((long)1)); 
BgL_spz00_20434 = 
(BgL_spz00_3541+((long)1)); 
BgL_lz00_20436 = 
CDR(BgL_lz00_3542); 
BgL_lz00_3542 = BgL_lz00_20436; 
BgL_spz00_3541 = BgL_spz00_20434; 
BgL_rz00_3540 = BgL_rz00_20432; 
goto BgL_zc3z04anonymousza32789ze3z87_3543;} }  else 
{ /* Eval/evaluate_comp.scm 1080 */
long BgL_arg2798z00_3552;
BgL_arg2798z00_3552 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2798z00_3552));} } } } 

}



/* make-boxes */
bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211, obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
{
{ /* Eval/evaluate_comp.scm 1177 */
{ 
long BgL_iz00_3556;
BgL_iz00_3556 = ((long)0); 
BgL_zc3z04anonymousza32799ze3z87_3557:
{ /* Eval/evaluate_comp.scm 1180 */
long BgL_spz00_3558;
{ /* Eval/evaluate_comp.scm 1180 */
obj_t BgL_arg2803z00_3563;
BgL_arg2803z00_3563 = 
VECTOR_REF(
((obj_t)BgL_ibza2za2_212),BgL_iz00_3556); 
BgL_spz00_3558 = 
(
(long)CINT(BgL_bpz00_213)+
(long)CINT(BgL_arg2803z00_3563)); } 
{ /* Eval/evaluate_comp.scm 1181 */
obj_t BgL_arg2800z00_3559;
{ /* Eval/evaluate_comp.scm 1181 */
obj_t BgL_arg2801z00_3560;
BgL_arg2801z00_3560 = 
VECTOR_REF(
((obj_t)BgL_sz00_211),BgL_spz00_3558); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_7968;
BgL_newz00_7968 = 
create_struct(BGl_symbol4270z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_20451;
BgL_tmpz00_20451 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_7968, BgL_tmpz00_20451, BgL_arg2801z00_3560); } 
BgL_arg2800z00_3559 = BgL_newz00_7968; } } 
VECTOR_SET(
((obj_t)BgL_sz00_211),BgL_spz00_3558,BgL_arg2800z00_3559); } 
{ /* Eval/evaluate_comp.scm 1182 */
long BgL_niz00_3561;
BgL_niz00_3561 = 
(BgL_iz00_3556+((long)1)); 
if(
(BgL_niz00_3561<
VECTOR_LENGTH(
((obj_t)BgL_ibza2za2_212))))
{ 
long BgL_iz00_20461;
BgL_iz00_20461 = BgL_niz00_3561; 
BgL_iz00_3556 = BgL_iz00_20461; 
goto BgL_zc3z04anonymousza32799ze3z87_3557;}  else 
{ /* Eval/evaluate_comp.scm 1183 */
return ((bool_t)0);} } } } } 

}



/* free-collect */
obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214, obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
{
{ /* Eval/evaluate_comp.scm 1185 */
{ /* Eval/evaluate_comp.scm 1186 */
obj_t BgL_rz00_3566;
BgL_rz00_3566 = 
make_vector(
VECTOR_LENGTH(
((obj_t)BgL_iza2za2_216)), BUNSPEC); 
{ /* Eval/evaluate_comp.scm 1186 */

{ 
long BgL_iz00_3568;
BgL_iz00_3568 = ((long)0); 
BgL_zc3z04anonymousza32804ze3z87_3569:
if(
(BgL_iz00_3568>=
VECTOR_LENGTH(
((obj_t)BgL_iza2za2_216))))
{ /* Eval/evaluate_comp.scm 1188 */
return BgL_rz00_3566;}  else 
{ /* Eval/evaluate_comp.scm 1188 */
{ /* Eval/evaluate_comp.scm 1191 */
obj_t BgL_arg2806z00_3571;
{ /* Eval/evaluate_comp.scm 1191 */
long BgL_arg2807z00_3572;
{ /* Eval/evaluate_comp.scm 1191 */
obj_t BgL_arg2808z00_3573;
BgL_arg2808z00_3573 = 
VECTOR_REF(
((obj_t)BgL_iza2za2_216),BgL_iz00_3568); 
BgL_arg2807z00_3572 = 
(
(long)CINT(BgL_bpz00_215)+
(long)CINT(BgL_arg2808z00_3573)); } 
BgL_arg2806z00_3571 = 
VECTOR_REF(
((obj_t)BgL_sz00_214),BgL_arg2807z00_3572); } 
VECTOR_SET(BgL_rz00_3566,BgL_iz00_3568,BgL_arg2806z00_3571); } 
{ 
long BgL_iz00_20477;
BgL_iz00_20477 = 
(BgL_iz00_3568+((long)1)); 
BgL_iz00_3568 = BgL_iz00_20477; 
goto BgL_zc3z04anonymousza32804ze3z87_3569;} } } } } } 

}



/* free-restore */
bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217, obj_t BgL_valza2za2_218, long BgL_spz00_219)
{
{ /* Eval/evaluate_comp.scm 1194 */
{ /* Eval/evaluate_comp.scm 1195 */
long BgL_stopz00_3577;
BgL_stopz00_3577 = 
(BgL_spz00_219+
VECTOR_LENGTH(
((obj_t)BgL_valza2za2_218))); 
{ 
long BgL_iz00_3579;long BgL_spz00_3580;
BgL_iz00_3579 = ((long)0); 
BgL_spz00_3580 = BgL_spz00_219; 
BgL_zc3z04anonymousza32811ze3z87_3581:
if(
(BgL_spz00_3580<BgL_stopz00_3577))
{ /* Eval/evaluate_comp.scm 1197 */
{ /* Eval/evaluate_comp.scm 1198 */
obj_t BgL_arg2813z00_3583;
BgL_arg2813z00_3583 = 
VECTOR_REF(
((obj_t)BgL_valza2za2_218),BgL_iz00_3579); 
VECTOR_SET(
((obj_t)BgL_sz00_217),BgL_spz00_3580,BgL_arg2813z00_3583); } 
{ 
long BgL_spz00_20490;long BgL_iz00_20488;
BgL_iz00_20488 = 
(BgL_iz00_3579+((long)1)); 
BgL_spz00_20490 = 
(BgL_spz00_3580+((long)1)); 
BgL_spz00_3580 = BgL_spz00_20490; 
BgL_iz00_3579 = BgL_iz00_20488; 
goto BgL_zc3z04anonymousza32811ze3z87_3581;} }  else 
{ /* Eval/evaluate_comp.scm 1197 */
return ((bool_t)0);} } } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_proc4348z00zz__evaluate_compz00, BGl_ev_exprz00zz__evaluate_typesz00, BGl_string4349z00zz__evaluate_compz00);} 

}



/* &comp1386 */
obj_t BGl_z62comp1386z62zz__evaluate_compz00(obj_t BgL_envz00_10264, obj_t BgL_ez00_10265, obj_t BgL_stkz00_10266)
{
{ /* Eval/evaluate_comp.scm 276 */
return 
BGl_errorz00zz__errorz00(BGl_string4260z00zz__evaluate_compz00, BGl_string4350z00zz__evaluate_compz00, 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_ez00_10265)));} 

}



/* comp */
obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35, obj_t BgL_stkz00_36)
{
{ /* Eval/evaluate_comp.scm 276 */
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_method1387z00_3593;
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_res4125z00_8029;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_objzd2classzd2numz00_8000;
BgL_objzd2classzd2numz00_8000 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_ez00_35)); 
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_arg4012z00_8001;
BgL_arg4012z00_8001 = 
PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 276 */
int BgL_offsetz00_8004;
BgL_offsetz00_8004 = 
(int)(BgL_objzd2classzd2numz00_8000); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_offsetz00_8005;
BgL_offsetz00_8005 = 
(
(long)(BgL_offsetz00_8004)-OBJECT_TYPE); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_modz00_8006;
BgL_modz00_8006 = 
(BgL_offsetz00_8005 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_restz00_8008;
BgL_restz00_8008 = 
(BgL_offsetz00_8005 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Eval/evaluate_comp.scm 276 */

{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_bucketz00_8010;
BgL_bucketz00_8010 = 
VECTOR_REF(
((obj_t)BgL_arg4012z00_8001),BgL_modz00_8006); 
BgL_res4125z00_8029 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_8010),BgL_restz00_8008); } } } } } } } } 
BgL_method1387z00_3593 = BgL_res4125z00_8029; } 
return 
PROCEDURE_ENTRY(BgL_method1387z00_3593)(BgL_method1387z00_3593, 
((obj_t)BgL_ez00_35), BgL_stkz00_36, BEOA);} } 

}



/* &comp */
obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_10267, obj_t BgL_ez00_10268, obj_t BgL_stkz00_10269)
{
{ /* Eval/evaluate_comp.scm 276 */
{ /* Eval/evaluate_comp.scm 276 */
BgL_ev_exprz00_bglt BgL_auxz00_20527;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_10268, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 276 */
BgL_auxz00_20527 = 
((BgL_ev_exprz00_bglt)BgL_ez00_10268)
; }  else 
{ 
obj_t BgL_auxz00_20531;
BgL_auxz00_20531 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string4265z00zz__evaluate_compz00, 
BINT(((long)7022)), BGl_string4351z00zz__evaluate_compz00, BGl_string4267z00zz__evaluate_compz00, BgL_ez00_10268); 
FAILURE(BgL_auxz00_20531,BFALSE,BFALSE);} 
return 
BGl_compz00zz__evaluate_compz00(BgL_auxz00_20527, BgL_stkz00_10269);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_trapz00zz__evaluate_typesz00, BGl_proc4352z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_varz00zz__evaluate_typesz00, BGl_proc4354z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_setlocalz00zz__evaluate_typesz00, BGl_proc4355z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_globalz00zz__evaluate_typesz00, BGl_proc4356z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_setglobalz00zz__evaluate_typesz00, BGl_proc4357z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_defglobalz00zz__evaluate_typesz00, BGl_proc4358z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_littz00zz__evaluate_typesz00, BGl_proc4359z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc4360z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_orz00zz__evaluate_typesz00, BGl_proc4361z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_andz00zz__evaluate_typesz00, BGl_proc4362z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_prog2z00zz__evaluate_typesz00, BGl_proc4363z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letz00zz__evaluate_typesz00, BGl_proc4364z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letza2za2zz__evaluate_typesz00, BGl_proc4365z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letrecz00zz__evaluate_typesz00, BGl_proc4366z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_bindzd2exitzd2zz__evaluate_typesz00, BGl_proc4367z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00, BGl_proc4368z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_withzd2handlerzd2zz__evaluate_typesz00, BGl_proc4369z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_synchroniza7eza7zz__evaluate_typesz00, BGl_proc4370z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_labelsz00zz__evaluate_typesz00, BGl_proc4371z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_gotoz00zz__evaluate_typesz00, BGl_proc4372z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_appz00zz__evaluate_typesz00, BGl_proc4373z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_absz00zz__evaluate_typesz00, BGl_proc4374z00zz__evaluate_compz00, BGl_string4353z00zz__evaluate_compz00);} 

}



/* &comp-ev_abs1431 */
obj_t BGl_z62compzd2ev_abs1431zb0zz__evaluate_compz00(obj_t BgL_envz00_10464, obj_t BgL_ez00_10465, obj_t BgL_stkz00_10466)
{
{ /* Eval/evaluate_comp.scm 1165 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12548;obj_t BgL_iboxesz00_12549;long BgL_siza7eza7_12550;long BgL_siza7ezd2framez75_12551;obj_t BgL_nstkz00_12552;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3717z00_12553;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_l1363z00_12554;
BgL_l1363z00_12554 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_freez00); 
if(
NULLP(BgL_l1363z00_12554))
{ /* Eval/evaluate_comp.scm 1167 */
BgL_arg3717z00_12553 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_head1365z00_12555;
BgL_head1365z00_12555 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1363z00_12557;obj_t BgL_tail1366z00_12558;
BgL_l1363z00_12557 = BgL_l1363z00_12554; 
BgL_tail1366z00_12558 = BgL_head1365z00_12555; 
BgL_zc3z04anonymousza33719ze3z87_12556:
if(
NULLP(BgL_l1363z00_12557))
{ /* Eval/evaluate_comp.scm 1167 */
BgL_arg3717z00_12553 = 
CDR(BgL_head1365z00_12555); }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_newtail1367z00_12559;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3722z00_12560;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_vz00_12561;
BgL_vz00_12561 = 
CAR(
((obj_t)BgL_l1363z00_12557)); 
BgL_arg3722z00_12560 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_12561, BgL_stkz00_10466); } 
BgL_newtail1367z00_12559 = 
MAKE_YOUNG_PAIR(BgL_arg3722z00_12560, BNIL); } 
SET_CDR(BgL_tail1366z00_12558, BgL_newtail1367z00_12559); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3721z00_12562;
BgL_arg3721z00_12562 = 
CDR(
((obj_t)BgL_l1363z00_12557)); 
{ 
obj_t BgL_tail1366z00_20574;obj_t BgL_l1363z00_20573;
BgL_l1363z00_20573 = BgL_arg3721z00_12562; 
BgL_tail1366z00_20574 = BgL_newtail1367z00_12559; 
BgL_tail1366z00_12558 = BgL_tail1366z00_20574; 
BgL_l1363z00_12557 = BgL_l1363z00_20573; 
goto BgL_zc3z04anonymousza33719ze3z87_12556;} } } } } } 
BgL_ifreesz00_12548 = 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3717z00_12553); } 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3723z00_12563;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_l1368z00_12564;
BgL_l1368z00_12564 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_boxesz00); 
if(
NULLP(BgL_l1368z00_12564))
{ /* Eval/evaluate_comp.scm 1168 */
BgL_arg3723z00_12563 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_head1370z00_12565;
BgL_head1370z00_12565 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1368z00_12567;obj_t BgL_tail1371z00_12568;
BgL_l1368z00_12567 = BgL_l1368z00_12564; 
BgL_tail1371z00_12568 = BgL_head1370z00_12565; 
BgL_zc3z04anonymousza33725ze3z87_12566:
if(
NULLP(BgL_l1368z00_12567))
{ /* Eval/evaluate_comp.scm 1168 */
BgL_arg3723z00_12563 = 
CDR(BgL_head1370z00_12565); }  else 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_newtail1372z00_12569;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3728z00_12570;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_vz00_12571;
BgL_vz00_12571 = 
CAR(
((obj_t)BgL_l1368z00_12567)); 
BgL_arg3728z00_12570 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_12571, 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_varsz00)); } 
BgL_newtail1372z00_12569 = 
MAKE_YOUNG_PAIR(BgL_arg3728z00_12570, BNIL); } 
SET_CDR(BgL_tail1371z00_12568, BgL_newtail1372z00_12569); 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3727z00_12572;
BgL_arg3727z00_12572 = 
CDR(
((obj_t)BgL_l1368z00_12567)); 
{ 
obj_t BgL_tail1371z00_20594;obj_t BgL_l1368z00_20593;
BgL_l1368z00_20593 = BgL_arg3727z00_12572; 
BgL_tail1371z00_20594 = BgL_newtail1372z00_12569; 
BgL_tail1371z00_12568 = BgL_tail1371z00_20594; 
BgL_l1368z00_12567 = BgL_l1368z00_20593; 
goto BgL_zc3z04anonymousza33725ze3z87_12566;} } } } } } 
BgL_iboxesz00_12549 = 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3723z00_12563); } 
BgL_siza7eza7_12550 = 
bgl_list_length(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_varsz00)); 
BgL_siza7ezd2framez75_12551 = 
(
(long)(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_siza7eza7))+
bgl_list_length(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_freez00))); 
BgL_nstkz00_12552 = 
BGl_appendzd221010zd2zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_varsz00), 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_freez00)); 
{ /* Eval/evaluate_comp.scm 1172 */
obj_t BgL_bodyz00_12573;
BgL_bodyz00_12573 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_bodyz00), BgL_nstkz00_12552); 
{ 

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_aux1246z00_12579;
BgL_aux1246z00_12579 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_10465)))->BgL_arityz00); 
if(
INTEGERP(BgL_aux1246z00_12579))
{ /* Eval/evaluate_comp.scm 1174 */
switch( 
(long)CINT(BgL_aux1246z00_12579)) { case ((long)0) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33179ze3z87_12580;
BgL_zc3z04anonymousza33179ze3z87_12580 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33179ze3z87_12580, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33179ze3z87_12580, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33179ze3z87_12580, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33179ze3z87_12580;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33185ze3z87_12581;
BgL_zc3z04anonymousza33185ze3z87_12581 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33185ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33185ze3z87_12581, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33185ze3z87_12581, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33185ze3z87_12581, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33185ze3z87_12581, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33185ze3z87_12581;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33194ze3z87_12582;
BgL_zc3z04anonymousza33194ze3z87_12582 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33194ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_12582, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_12582, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_12582, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_12582, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_12582, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33194ze3z87_12582;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33201ze3z87_12583;
BgL_zc3z04anonymousza33201ze3z87_12583 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_12583, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_12583, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_12583, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_12583, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_12583, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_12583, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33201ze3z87_12583;} } break;case ((long)-1) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33214ze3z87_12584;
BgL_zc3z04anonymousza33214ze3z87_12584 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33214ze3z87_12584, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33214ze3z87_12584, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33214ze3z87_12584, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33214ze3z87_12584;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33221ze3z87_12585;
BgL_zc3z04anonymousza33221ze3z87_12585 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33221ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33221ze3z87_12585, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33221ze3z87_12585, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33221ze3z87_12585, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33221ze3z87_12585, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33221ze3z87_12585;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33231ze3z87_12586;
BgL_zc3z04anonymousza33231ze3z87_12586 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_12586, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_12586, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_12586, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_12586, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_12586, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33231ze3z87_12586;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33239ze3z87_12587;
BgL_zc3z04anonymousza33239ze3z87_12587 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33239ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_12587, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_12587, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_12587, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_12587, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_12587, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_12587, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33239ze3z87_12587;} } break;case ((long)1) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33253ze3z87_12588;
BgL_zc3z04anonymousza33253ze3z87_12588 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_12588, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_12588, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_12588, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33253ze3z87_12588;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33260ze3z87_12589;
BgL_zc3z04anonymousza33260ze3z87_12589 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33260ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33260ze3z87_12589, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33260ze3z87_12589, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33260ze3z87_12589, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33260ze3z87_12589, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33260ze3z87_12589;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33270ze3z87_12590;
BgL_zc3z04anonymousza33270ze3z87_12590 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_12590, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_12590, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_12590, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_12590, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_12590, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33270ze3z87_12590;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33278ze3z87_12591;
BgL_zc3z04anonymousza33278ze3z87_12591 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33278ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_12591, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_12591, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_12591, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_12591, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_12591, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_12591, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33278ze3z87_12591;} } break;case ((long)-2) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33292ze3z87_12592;
BgL_zc3z04anonymousza33292ze3z87_12592 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33292ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33292ze3z87_12592, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33292ze3z87_12592, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33292ze3z87_12592, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33292ze3z87_12592;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33300ze3z87_12593;
BgL_zc3z04anonymousza33300ze3z87_12593 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33300ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33300ze3z87_12593, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33300ze3z87_12593, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33300ze3z87_12593, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33300ze3z87_12593, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33300ze3z87_12593;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33311ze3z87_12594;
BgL_zc3z04anonymousza33311ze3z87_12594 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33311ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_12594, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_12594, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_12594, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_12594, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_12594, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33311ze3z87_12594;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33320ze3z87_12595;
BgL_zc3z04anonymousza33320ze3z87_12595 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_12595, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_12595, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_12595, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_12595, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_12595, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_12595, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33320ze3z87_12595;} } break;case ((long)2) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33335ze3z87_12596;
BgL_zc3z04anonymousza33335ze3z87_12596 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33335ze3z87_12596, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33335ze3z87_12596, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33335ze3z87_12596, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33335ze3z87_12596;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33343ze3z87_12597;
BgL_zc3z04anonymousza33343ze3z87_12597 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33343ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33343ze3z87_12597, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33343ze3z87_12597, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33343ze3z87_12597, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33343ze3z87_12597, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33343ze3z87_12597;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33354ze3z87_12598;
BgL_zc3z04anonymousza33354ze3z87_12598 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33354ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_12598, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_12598, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_12598, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_12598, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_12598, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33354ze3z87_12598;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33363ze3z87_12599;
BgL_zc3z04anonymousza33363ze3z87_12599 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33363ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_12599, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_12599, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_12599, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_12599, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_12599, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_12599, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33363ze3z87_12599;} } break;case ((long)-3) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33378ze3z87_12600;
BgL_zc3z04anonymousza33378ze3z87_12600 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33378ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33378ze3z87_12600, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33378ze3z87_12600, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33378ze3z87_12600, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33378ze3z87_12600;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33387ze3z87_12601;
BgL_zc3z04anonymousza33387ze3z87_12601 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_12601, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_12601, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_12601, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_12601, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33387ze3z87_12601;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33399ze3z87_12602;
BgL_zc3z04anonymousza33399ze3z87_12602 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33399ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_12602, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_12602, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_12602, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_12602, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_12602, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33399ze3z87_12602;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33409ze3z87_12603;
BgL_zc3z04anonymousza33409ze3z87_12603 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33409ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_12603, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_12603, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_12603, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_12603, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_12603, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_12603, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33409ze3z87_12603;} } break;case ((long)3) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33425ze3z87_12604;
BgL_zc3z04anonymousza33425ze3z87_12604 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33425ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33425ze3z87_12604, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33425ze3z87_12604, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33425ze3z87_12604, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33425ze3z87_12604;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33434ze3z87_12605;
BgL_zc3z04anonymousza33434ze3z87_12605 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33434ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33434ze3z87_12605, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33434ze3z87_12605, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33434ze3z87_12605, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33434ze3z87_12605, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33434ze3z87_12605;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33446ze3z87_12606;
BgL_zc3z04anonymousza33446ze3z87_12606 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33446ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_12606, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_12606, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_12606, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_12606, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_12606, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33446ze3z87_12606;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33456ze3z87_12607;
BgL_zc3z04anonymousza33456ze3z87_12607 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33456ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_12607, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_12607, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_12607, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_12607, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_12607, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_12607, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33456ze3z87_12607;} } break;case ((long)-4) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33472ze3z87_12608;
BgL_zc3z04anonymousza33472ze3z87_12608 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_12608, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_12608, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_12608, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33472ze3z87_12608;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33482ze3z87_12609;
BgL_zc3z04anonymousza33482ze3z87_12609 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33482ze3z87_12609, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33482ze3z87_12609, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33482ze3z87_12609, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33482ze3z87_12609, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33482ze3z87_12609;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33495ze3z87_12610;
BgL_zc3z04anonymousza33495ze3z87_12610 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_12610, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_12610, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_12610, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_12610, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_12610, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33495ze3z87_12610;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33506ze3z87_12611;
BgL_zc3z04anonymousza33506ze3z87_12611 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_12611, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_12611, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_12611, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_12611, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_12611, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_12611, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33506ze3z87_12611;} } break;case ((long)4) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33523ze3z87_12612;
BgL_zc3z04anonymousza33523ze3z87_12612 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_12612, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_12612, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_12612, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33523ze3z87_12612;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33533ze3z87_12613;
BgL_zc3z04anonymousza33533ze3z87_12613 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33533ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33533ze3z87_12613, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33533ze3z87_12613, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33533ze3z87_12613, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33533ze3z87_12613, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33533ze3z87_12613;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33546ze3z87_12614;
BgL_zc3z04anonymousza33546ze3z87_12614 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33546ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_12614, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_12614, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_12614, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_12614, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_12614, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33546ze3z87_12614;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33557ze3z87_12615;
BgL_zc3z04anonymousza33557ze3z87_12615 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_12615, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_12615, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_12615, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_12615, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_12615, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_12615, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33557ze3z87_12615;} } break;case ((long)-5) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33574ze3z87_12616;
BgL_zc3z04anonymousza33574ze3z87_12616 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33574ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33574ze3z87_12616, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33574ze3z87_12616, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33574ze3z87_12616, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33574ze3z87_12616;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33585ze3z87_12617;
BgL_zc3z04anonymousza33585ze3z87_12617 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33585ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33585ze3z87_12617, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33585ze3z87_12617, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33585ze3z87_12617, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33585ze3z87_12617, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33585ze3z87_12617;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33599ze3z87_12618;
BgL_zc3z04anonymousza33599ze3z87_12618 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33599ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_12618, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_12618, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_12618, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_12618, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_12618, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33599ze3z87_12618;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33611ze3z87_12619;
BgL_zc3z04anonymousza33611ze3z87_12619 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33611ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_12619, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_12619, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_12619, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_12619, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_12619, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_12619, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33611ze3z87_12619;} } break;
default: 
BgL_case_else1245z00_12574:
if(
(
VECTOR_LENGTH(BgL_ifreesz00_12548)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33629ze3z87_12575;
BgL_zc3z04anonymousza33629ze3z87_12575 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33629ze3z87_12575, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33629ze3z87_12575, 
(int)(((long)1)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33629ze3z87_12575, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33629ze3z87_12575;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33649ze3z87_12576;
BgL_zc3z04anonymousza33649ze3z87_12576 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33649ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33649ze3z87_12576, 
(int)(((long)0)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33649ze3z87_12576, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33649ze3z87_12576, 
(int)(((long)2)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33649ze3z87_12576, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33649ze3z87_12576;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_12549)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33672ze3z87_12577;
BgL_zc3z04anonymousza33672ze3z87_12577 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_12577, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_12577, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_12577, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_12577, 
(int)(((long)3)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_12577, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33672ze3z87_12577;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33693ze3z87_12578;
BgL_zc3z04anonymousza33693ze3z87_12578 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33693ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_12578, 
(int)(((long)0)), BgL_ifreesz00_12548); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_12578, 
(int)(((long)1)), BgL_iboxesz00_12549); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_12578, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_12550)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_12578, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_10465))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_12578, 
(int)(((long)4)), BgL_bodyz00_12573); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_12578, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12551)); 
return BgL_zc3z04anonymousza33693ze3z87_12578;} } } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
goto BgL_case_else1245z00_12574;} } } } } } 

}



/* &<@anonymous:3574> */
obj_t BGl_z62zc3z04anonymousza33574ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10467, obj_t BgL_sz00_10471)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10468;obj_t BgL_bodyz00_10469;long BgL_siza7ezd2framez75_10470;
BgL_i1244z00_10468 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10467, 
(int)(((long)0)))); 
BgL_bodyz00_10469 = 
PROCEDURE_REF(BgL_envz00_10467, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_10470 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10467, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12620;
BgL_bpz00_12620 = 
VECTOR_REF(
((obj_t)BgL_sz00_10471),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12621;
BgL_runz00_12621 = 
MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_12621, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10468)); 
PROCEDURE_SET(BgL_runz00_12621, 
(int)(((long)1)), BgL_bodyz00_10469); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12622;
BgL_mainz00_12622 = 
MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_12622, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10468)); 
PROCEDURE_SET(BgL_mainz00_12622, 
(int)(((long)1)), BgL_bodyz00_10469); 
PROCEDURE_SET(BgL_mainz00_12622, 
(int)(((long)2)), BgL_runz00_12621); 
PROCEDURE_SET(BgL_mainz00_12622, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_10470)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12623;
BgL_objz00_12623 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12621, BgL_objz00_12623); BgL_objz00_12623; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3575z00_12624;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3576z00_12625;
BgL_arg3576z00_12625 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10468))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12626;
BgL_newz00_12626 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21436;
BgL_tmpz00_21436 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12626, BgL_tmpz00_21436, BgL_arg3576z00_12625); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21441;int BgL_tmpz00_21439;
BgL_auxz00_21441 = 
BINT(BgL_siza7ezd2framez75_10470); 
BgL_tmpz00_21439 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12626, BgL_tmpz00_21439, BgL_auxz00_21441); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21444;
BgL_tmpz00_21444 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12626, BgL_tmpz00_21444, BgL_runz00_12621); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21449;int BgL_tmpz00_21447;
BgL_auxz00_21449 = 
BINT(((long)-5)); 
BgL_tmpz00_21447 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12626, BgL_tmpz00_21447, BgL_auxz00_21449); } 
BgL_arg3575z00_12624 = BgL_newz00_12626; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12622, BgL_arg3575z00_12624); BgL_arg3575z00_12624; } 
return BgL_mainz00_12622;} } } } } } 

}



/* &main */
obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_10472, obj_t BgL_az00_10477, obj_t BgL_bz00_10478, obj_t BgL_cz00_10479, obj_t BgL_dz00_10480, obj_t BgL_lastz00_10481)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10475;long BgL_siza7ezd2framez75_10476;
BgL_runz00_10475 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10472, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_10476 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10472, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12627;
BgL_sz00_12627 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12628;
BgL_bpz00_12628 = 
VECTOR_REF(
((obj_t)BgL_sz00_12627),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12627, BgL_bpz00_12628, 
BINT(BgL_siza7ezd2framez75_10476)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3579z00_12629;
BgL_arg3579z00_12629 = 
(
(long)CINT(BgL_bpz00_12628)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12627),BgL_arg3579z00_12629,BgL_az00_10477); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3580z00_12630;
BgL_arg3580z00_12630 = 
(
(long)CINT(BgL_bpz00_12628)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12627),BgL_arg3580z00_12630,BgL_bz00_10478); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3581z00_12631;
BgL_arg3581z00_12631 = 
(
(long)CINT(BgL_bpz00_12628)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12627),BgL_arg3581z00_12631,BgL_cz00_10479); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3582z00_12632;
BgL_arg3582z00_12632 = 
(
(long)CINT(BgL_bpz00_12628)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12627),BgL_arg3582z00_12632,BgL_dz00_10480); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3583z00_12633;
BgL_arg3583z00_12633 = 
(
(long)CINT(BgL_bpz00_12628)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_12627),BgL_arg3583z00_12633,BgL_lastz00_10481); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12634;
BgL_ez00_12634 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12634, BgL_bpz00_12628); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12635;
BgL_accz00_12635 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10475, BgL_sz00_12627, BgL_bpz00_12628); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12634); 
VECTOR_SET(
((obj_t)BgL_sz00_12627),((long)0),BgL_bpz00_12628); 
return BgL_accz00_12635;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12636;
BgL_nsz00_12636 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12636,((long)1),BgL_sz00_12627); 
VECTOR_SET(BgL_nsz00_12636,((long)2),BgL_az00_10477); 
VECTOR_SET(BgL_nsz00_12636,((long)3),BgL_bz00_10478); 
VECTOR_SET(BgL_nsz00_12636,((long)4),BgL_cz00_10479); 
VECTOR_SET(BgL_nsz00_12636,((long)5),BgL_dz00_10480); 
VECTOR_SET(BgL_nsz00_12636,((long)6),BgL_lastz00_10481); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12637;
BgL_z12denvz12_12637 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12637, BgL_nsz00_12636); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12638;
BgL_ez00_12638 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12638, BgL_sz00_12627); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12639;
BgL_____rz00_12639 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10475, BgL_nsz00_12636, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12638); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12637, BgL_sz00_12627); 
return BgL_____rz00_12639;} } } } } } } } 

}



/* &run */
obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_10482, obj_t BgL_sz00_10485)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10483;obj_t BgL_bodyz00_10484;
BgL_i1244z00_10483 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10482, 
(int)(((long)0)))); 
BgL_bodyz00_10484 = 
PROCEDURE_REF(BgL_envz00_10482, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12640;
BgL_bpz00_12640 = 
VECTOR_REF(
((obj_t)BgL_sz00_10485),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12641;obj_t BgL_wherez00_12642;obj_t BgL_locz00_12643;
BgL_z12denvz12_12641 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12642 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10483))->BgL_wherez00); 
BgL_locz00_12643 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10483))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12641, BgL_wherez00_12642, BgL_locz00_12643); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_12644;
BgL_za2za2resza2za2z00_12644 = 
PROCEDURE_ENTRY(BgL_bodyz00_10484)(BgL_bodyz00_10484, BgL_sz00_10485, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12641); 
return BgL_za2za2resza2za2z00_12644;} } } } } } 

}



/* &<@anonymous:3585> */
obj_t BGl_z62zc3z04anonymousza33585ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10486, obj_t BgL_sz00_10491)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10487;BgL_ev_absz00_bglt BgL_i1244z00_10488;obj_t BgL_bodyz00_10489;long BgL_siza7ezd2framez75_10490;
BgL_iboxesz00_10487 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10486, 
(int)(((long)0)))); 
BgL_i1244z00_10488 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10486, 
(int)(((long)1)))); 
BgL_bodyz00_10489 = 
PROCEDURE_REF(BgL_envz00_10486, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_10490 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10486, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12645;
BgL_bpz00_12645 = 
VECTOR_REF(
((obj_t)BgL_sz00_10491),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12646;
BgL_runz00_12646 = 
MAKE_FX_PROCEDURE(BGl_z62run4163z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_12646, 
(int)(((long)0)), BgL_iboxesz00_10487); 
PROCEDURE_SET(BgL_runz00_12646, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10488)); 
PROCEDURE_SET(BgL_runz00_12646, 
(int)(((long)2)), BgL_bodyz00_10489); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12647;
BgL_mainz00_12647 = 
MAKE_VA_PROCEDURE(BGl_z62main4162z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_12647, 
(int)(((long)0)), BgL_iboxesz00_10487); 
PROCEDURE_SET(BgL_mainz00_12647, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10488)); 
PROCEDURE_SET(BgL_mainz00_12647, 
(int)(((long)2)), BgL_bodyz00_10489); 
PROCEDURE_SET(BgL_mainz00_12647, 
(int)(((long)3)), BgL_runz00_12646); 
PROCEDURE_SET(BgL_mainz00_12647, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_10490)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12648;
BgL_objz00_12648 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12646, BgL_objz00_12648); BgL_objz00_12648; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3586z00_12649;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3587z00_12650;
BgL_arg3587z00_12650 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10488))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12651;
BgL_newz00_12651 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21564;
BgL_tmpz00_21564 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12651, BgL_tmpz00_21564, BgL_arg3587z00_12650); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21569;int BgL_tmpz00_21567;
BgL_auxz00_21569 = 
BINT(BgL_siza7ezd2framez75_10490); 
BgL_tmpz00_21567 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12651, BgL_tmpz00_21567, BgL_auxz00_21569); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21572;
BgL_tmpz00_21572 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12651, BgL_tmpz00_21572, BgL_runz00_12646); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21577;int BgL_tmpz00_21575;
BgL_auxz00_21577 = 
BINT(((long)-5)); 
BgL_tmpz00_21575 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12651, BgL_tmpz00_21575, BgL_auxz00_21577); } 
BgL_arg3586z00_12649 = BgL_newz00_12651; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12647, BgL_arg3586z00_12649); BgL_arg3586z00_12649; } 
return BgL_mainz00_12647;} } } } } } 

}



/* &main4162 */
obj_t BGl_z62main4162z62zz__evaluate_compz00(obj_t BgL_envz00_10492, obj_t BgL_az00_10498, obj_t BgL_bz00_10499, obj_t BgL_cz00_10500, obj_t BgL_dz00_10501, obj_t BgL_lastz00_10502)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10496;long BgL_siza7ezd2framez75_10497;
BgL_runz00_10496 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10492, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_10497 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10492, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12652;
BgL_sz00_12652 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12653;
BgL_bpz00_12653 = 
VECTOR_REF(
((obj_t)BgL_sz00_12652),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12652, BgL_bpz00_12653, 
BINT(BgL_siza7ezd2framez75_10497)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3590z00_12654;
BgL_arg3590z00_12654 = 
(
(long)CINT(BgL_bpz00_12653)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12652),BgL_arg3590z00_12654,BgL_az00_10498); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3591z00_12655;
BgL_arg3591z00_12655 = 
(
(long)CINT(BgL_bpz00_12653)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12652),BgL_arg3591z00_12655,BgL_bz00_10499); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3592z00_12656;
BgL_arg3592z00_12656 = 
(
(long)CINT(BgL_bpz00_12653)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12652),BgL_arg3592z00_12656,BgL_cz00_10500); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3593z00_12657;
BgL_arg3593z00_12657 = 
(
(long)CINT(BgL_bpz00_12653)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12652),BgL_arg3593z00_12657,BgL_dz00_10501); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3594z00_12658;
BgL_arg3594z00_12658 = 
(
(long)CINT(BgL_bpz00_12653)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_12652),BgL_arg3594z00_12658,BgL_lastz00_10502); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12659;
BgL_ez00_12659 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12659, BgL_bpz00_12653); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12660;
BgL_accz00_12660 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10496, BgL_sz00_12652, BgL_bpz00_12653); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12659); 
VECTOR_SET(
((obj_t)BgL_sz00_12652),((long)0),BgL_bpz00_12653); 
return BgL_accz00_12660;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12661;
BgL_nsz00_12661 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12661,((long)1),BgL_sz00_12652); 
VECTOR_SET(BgL_nsz00_12661,((long)2),BgL_az00_10498); 
VECTOR_SET(BgL_nsz00_12661,((long)3),BgL_bz00_10499); 
VECTOR_SET(BgL_nsz00_12661,((long)4),BgL_cz00_10500); 
VECTOR_SET(BgL_nsz00_12661,((long)5),BgL_dz00_10501); 
VECTOR_SET(BgL_nsz00_12661,((long)6),BgL_lastz00_10502); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12662;
BgL_z12denvz12_12662 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12662, BgL_nsz00_12661); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12663;
BgL_ez00_12663 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12663, BgL_sz00_12652); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12664;
BgL_____rz00_12664 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10496, BgL_nsz00_12661, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12663); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12662, BgL_sz00_12652); 
return BgL_____rz00_12664;} } } } } } } } 

}



/* &run4163 */
obj_t BGl_z62run4163z62zz__evaluate_compz00(obj_t BgL_envz00_10503, obj_t BgL_sz00_10507)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10504;BgL_ev_absz00_bglt BgL_i1244z00_10505;obj_t BgL_bodyz00_10506;
BgL_iboxesz00_10504 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10503, 
(int)(((long)0)))); 
BgL_i1244z00_10505 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10503, 
(int)(((long)1)))); 
BgL_bodyz00_10506 = 
PROCEDURE_REF(BgL_envz00_10503, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12665;
BgL_bpz00_12665 = 
VECTOR_REF(
((obj_t)BgL_sz00_10507),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10507, BgL_iboxesz00_10504, BgL_bpz00_12665); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12666;obj_t BgL_wherez00_12667;obj_t BgL_locz00_12668;
BgL_z12denvz12_12666 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12667 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10505))->BgL_wherez00); 
BgL_locz00_12668 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10505))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12666, BgL_wherez00_12667, BgL_locz00_12668); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_12669;
BgL_za2za2resza2za2z00_12669 = 
PROCEDURE_ENTRY(BgL_bodyz00_10506)(BgL_bodyz00_10506, BgL_sz00_10507, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12666); 
return BgL_za2za2resza2za2z00_12669;} } } } } } 

}



/* &<@anonymous:3599> */
obj_t BGl_z62zc3z04anonymousza33599ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10508, obj_t BgL_sz00_10514)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10509;long BgL_siza7eza7_10510;BgL_ev_absz00_bglt BgL_i1244z00_10511;obj_t BgL_bodyz00_10512;long BgL_siza7ezd2framez75_10513;
BgL_ifreesz00_10509 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10508, 
(int)(((long)0)))); 
BgL_siza7eza7_10510 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10508, 
(int)(((long)1)))); 
BgL_i1244z00_10511 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10508, 
(int)(((long)2)))); 
BgL_bodyz00_10512 = 
PROCEDURE_REF(BgL_envz00_10508, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_10513 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10508, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12670;
BgL_bpz00_12670 = 
VECTOR_REF(
((obj_t)BgL_sz00_10514),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_12671;
BgL_valza2za2_12671 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10514, BgL_bpz00_12670, BgL_ifreesz00_10509); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12672;
BgL_runz00_12672 = 
MAKE_FX_PROCEDURE(BGl_z62run4165z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_12672, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10510)); 
PROCEDURE_SET(BgL_runz00_12672, 
(int)(((long)1)), BgL_valza2za2_12671); 
PROCEDURE_SET(BgL_runz00_12672, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10511)); 
PROCEDURE_SET(BgL_runz00_12672, 
(int)(((long)3)), BgL_bodyz00_10512); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12673;
BgL_mainz00_12673 = 
MAKE_VA_PROCEDURE(BGl_z62main4164z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_12673, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10510)); 
PROCEDURE_SET(BgL_mainz00_12673, 
(int)(((long)1)), BgL_valza2za2_12671); 
PROCEDURE_SET(BgL_mainz00_12673, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10511)); 
PROCEDURE_SET(BgL_mainz00_12673, 
(int)(((long)3)), BgL_bodyz00_10512); 
PROCEDURE_SET(BgL_mainz00_12673, 
(int)(((long)4)), BgL_runz00_12672); 
PROCEDURE_SET(BgL_mainz00_12673, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_10513)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12674;
BgL_objz00_12674 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12672, BgL_objz00_12674); BgL_objz00_12674; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3600z00_12675;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3601z00_12676;
BgL_arg3601z00_12676 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10511))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12677;
BgL_newz00_12677 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21706;
BgL_tmpz00_21706 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12677, BgL_tmpz00_21706, BgL_arg3601z00_12676); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21711;int BgL_tmpz00_21709;
BgL_auxz00_21711 = 
BINT(BgL_siza7ezd2framez75_10513); 
BgL_tmpz00_21709 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12677, BgL_tmpz00_21709, BgL_auxz00_21711); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21714;
BgL_tmpz00_21714 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12677, BgL_tmpz00_21714, BgL_runz00_12672); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21719;int BgL_tmpz00_21717;
BgL_auxz00_21719 = 
BINT(((long)-5)); 
BgL_tmpz00_21717 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12677, BgL_tmpz00_21717, BgL_auxz00_21719); } 
BgL_arg3600z00_12675 = BgL_newz00_12677; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12673, BgL_arg3600z00_12675); BgL_arg3600z00_12675; } 
return BgL_mainz00_12673;} } } } } } 

}



/* &main4164 */
obj_t BGl_z62main4164z62zz__evaluate_compz00(obj_t BgL_envz00_10515, obj_t BgL_az00_10522, obj_t BgL_bz00_10523, obj_t BgL_cz00_10524, obj_t BgL_dz00_10525, obj_t BgL_lastz00_10526)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10520;long BgL_siza7ezd2framez75_10521;
BgL_runz00_10520 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10515, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_10521 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10515, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12678;
BgL_sz00_12678 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12679;
BgL_bpz00_12679 = 
VECTOR_REF(
((obj_t)BgL_sz00_12678),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12678, BgL_bpz00_12679, 
BINT(BgL_siza7ezd2framez75_10521)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3604z00_12680;
BgL_arg3604z00_12680 = 
(
(long)CINT(BgL_bpz00_12679)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12678),BgL_arg3604z00_12680,BgL_az00_10522); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3605z00_12681;
BgL_arg3605z00_12681 = 
(
(long)CINT(BgL_bpz00_12679)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12678),BgL_arg3605z00_12681,BgL_bz00_10523); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3606z00_12682;
BgL_arg3606z00_12682 = 
(
(long)CINT(BgL_bpz00_12679)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12678),BgL_arg3606z00_12682,BgL_cz00_10524); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3607z00_12683;
BgL_arg3607z00_12683 = 
(
(long)CINT(BgL_bpz00_12679)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12678),BgL_arg3607z00_12683,BgL_dz00_10525); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3608z00_12684;
BgL_arg3608z00_12684 = 
(
(long)CINT(BgL_bpz00_12679)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_12678),BgL_arg3608z00_12684,BgL_lastz00_10526); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12685;
BgL_ez00_12685 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12685, BgL_bpz00_12679); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12686;
BgL_accz00_12686 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10520, BgL_sz00_12678, BgL_bpz00_12679); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12685); 
VECTOR_SET(
((obj_t)BgL_sz00_12678),((long)0),BgL_bpz00_12679); 
return BgL_accz00_12686;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12687;
BgL_nsz00_12687 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12687,((long)1),BgL_sz00_12678); 
VECTOR_SET(BgL_nsz00_12687,((long)2),BgL_az00_10522); 
VECTOR_SET(BgL_nsz00_12687,((long)3),BgL_bz00_10523); 
VECTOR_SET(BgL_nsz00_12687,((long)4),BgL_cz00_10524); 
VECTOR_SET(BgL_nsz00_12687,((long)5),BgL_dz00_10525); 
VECTOR_SET(BgL_nsz00_12687,((long)6),BgL_lastz00_10526); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12688;
BgL_z12denvz12_12688 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12688, BgL_nsz00_12687); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12689;
BgL_ez00_12689 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12689, BgL_sz00_12678); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12690;
BgL_____rz00_12690 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10520, BgL_nsz00_12687, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12689); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12688, BgL_sz00_12678); 
return BgL_____rz00_12690;} } } } } } } } 

}



/* &run4165 */
obj_t BGl_z62run4165z62zz__evaluate_compz00(obj_t BgL_envz00_10527, obj_t BgL_sz00_10532)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_10528;obj_t BgL_valza2za2_10529;BgL_ev_absz00_bglt BgL_i1244z00_10530;obj_t BgL_bodyz00_10531;
BgL_siza7eza7_10528 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10527, 
(int)(((long)0)))); 
BgL_valza2za2_10529 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10527, 
(int)(((long)1)))); 
BgL_i1244z00_10530 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10527, 
(int)(((long)2)))); 
BgL_bodyz00_10531 = 
PROCEDURE_REF(BgL_envz00_10527, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12691;
BgL_bpz00_12691 = 
VECTOR_REF(
((obj_t)BgL_sz00_10532),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10532, BgL_valza2za2_10529, 
(
(long)CINT(BgL_bpz00_12691)+BgL_siza7eza7_10528)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_12692;obj_t BgL_wherez00_12693;obj_t BgL_locz00_12694;
BgL_z12denvz12_12692 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12693 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10530))->BgL_wherez00); 
BgL_locz00_12694 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10530))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12692, BgL_wherez00_12693, BgL_locz00_12694); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_12695;
BgL_za2za2resza2za2z00_12695 = 
PROCEDURE_ENTRY(BgL_bodyz00_10531)(BgL_bodyz00_10531, BgL_sz00_10532, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12692); 
return BgL_za2za2resza2za2z00_12695;} } } } } } 

}



/* &<@anonymous:3611> */
obj_t BGl_z62zc3z04anonymousza33611ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10533, obj_t BgL_sz00_10540)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10534;obj_t BgL_iboxesz00_10535;long BgL_siza7eza7_10536;BgL_ev_absz00_bglt BgL_i1244z00_10537;obj_t BgL_bodyz00_10538;long BgL_siza7ezd2framez75_10539;
BgL_ifreesz00_10534 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10533, 
(int)(((long)0)))); 
BgL_iboxesz00_10535 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10533, 
(int)(((long)1)))); 
BgL_siza7eza7_10536 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10533, 
(int)(((long)2)))); 
BgL_i1244z00_10537 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10533, 
(int)(((long)3)))); 
BgL_bodyz00_10538 = 
PROCEDURE_REF(BgL_envz00_10533, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_10539 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10533, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12696;
BgL_bpz00_12696 = 
VECTOR_REF(
((obj_t)BgL_sz00_10540),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_12697;
BgL_valza2za2_12697 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10540, BgL_bpz00_12696, BgL_ifreesz00_10534); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12698;
BgL_runz00_12698 = 
MAKE_FX_PROCEDURE(BGl_z62run4167z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_12698, 
(int)(((long)0)), BgL_iboxesz00_10535); 
PROCEDURE_SET(BgL_runz00_12698, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10536)); 
PROCEDURE_SET(BgL_runz00_12698, 
(int)(((long)2)), BgL_valza2za2_12697); 
PROCEDURE_SET(BgL_runz00_12698, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10537)); 
PROCEDURE_SET(BgL_runz00_12698, 
(int)(((long)4)), BgL_bodyz00_10538); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12699;
BgL_mainz00_12699 = 
MAKE_VA_PROCEDURE(BGl_z62main4166z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_12699, 
(int)(((long)0)), BgL_iboxesz00_10535); 
PROCEDURE_SET(BgL_mainz00_12699, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10536)); 
PROCEDURE_SET(BgL_mainz00_12699, 
(int)(((long)2)), BgL_valza2za2_12697); 
PROCEDURE_SET(BgL_mainz00_12699, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10537)); 
PROCEDURE_SET(BgL_mainz00_12699, 
(int)(((long)4)), BgL_bodyz00_10538); 
PROCEDURE_SET(BgL_mainz00_12699, 
(int)(((long)5)), BgL_runz00_12698); 
PROCEDURE_SET(BgL_mainz00_12699, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_10539)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12700;
BgL_objz00_12700 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12698, BgL_objz00_12700); BgL_objz00_12700; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3612z00_12701;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3613z00_12702;
BgL_arg3613z00_12702 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10537))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12703;
BgL_newz00_12703 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21860;
BgL_tmpz00_21860 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12703, BgL_tmpz00_21860, BgL_arg3613z00_12702); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21865;int BgL_tmpz00_21863;
BgL_auxz00_21865 = 
BINT(BgL_siza7ezd2framez75_10539); 
BgL_tmpz00_21863 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12703, BgL_tmpz00_21863, BgL_auxz00_21865); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21868;
BgL_tmpz00_21868 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12703, BgL_tmpz00_21868, BgL_runz00_12698); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21873;int BgL_tmpz00_21871;
BgL_auxz00_21873 = 
BINT(((long)-5)); 
BgL_tmpz00_21871 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12703, BgL_tmpz00_21871, BgL_auxz00_21873); } 
BgL_arg3612z00_12701 = BgL_newz00_12703; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12699, BgL_arg3612z00_12701); BgL_arg3612z00_12701; } 
return BgL_mainz00_12699;} } } } } } 

}



/* &main4166 */
obj_t BGl_z62main4166z62zz__evaluate_compz00(obj_t BgL_envz00_10541, obj_t BgL_az00_10549, obj_t BgL_bz00_10550, obj_t BgL_cz00_10551, obj_t BgL_dz00_10552, obj_t BgL_lastz00_10553)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10547;long BgL_siza7ezd2framez75_10548;
BgL_runz00_10547 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10541, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_10548 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10541, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12704;
BgL_sz00_12704 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12705;
BgL_bpz00_12705 = 
VECTOR_REF(
((obj_t)BgL_sz00_12704),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12704, BgL_bpz00_12705, 
BINT(BgL_siza7ezd2framez75_10548)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3616z00_12706;
BgL_arg3616z00_12706 = 
(
(long)CINT(BgL_bpz00_12705)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12704),BgL_arg3616z00_12706,BgL_az00_10549); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3617z00_12707;
BgL_arg3617z00_12707 = 
(
(long)CINT(BgL_bpz00_12705)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12704),BgL_arg3617z00_12707,BgL_bz00_10550); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3618z00_12708;
BgL_arg3618z00_12708 = 
(
(long)CINT(BgL_bpz00_12705)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12704),BgL_arg3618z00_12708,BgL_cz00_10551); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3619z00_12709;
BgL_arg3619z00_12709 = 
(
(long)CINT(BgL_bpz00_12705)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12704),BgL_arg3619z00_12709,BgL_dz00_10552); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3620z00_12710;
BgL_arg3620z00_12710 = 
(
(long)CINT(BgL_bpz00_12705)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_12704),BgL_arg3620z00_12710,BgL_lastz00_10553); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12711;
BgL_ez00_12711 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12711, BgL_bpz00_12705); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12712;
BgL_accz00_12712 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10547, BgL_sz00_12704, BgL_bpz00_12705); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12711); 
VECTOR_SET(
((obj_t)BgL_sz00_12704),((long)0),BgL_bpz00_12705); 
return BgL_accz00_12712;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12713;
BgL_nsz00_12713 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12713,((long)1),BgL_sz00_12704); 
VECTOR_SET(BgL_nsz00_12713,((long)2),BgL_az00_10549); 
VECTOR_SET(BgL_nsz00_12713,((long)3),BgL_bz00_10550); 
VECTOR_SET(BgL_nsz00_12713,((long)4),BgL_cz00_10551); 
VECTOR_SET(BgL_nsz00_12713,((long)5),BgL_dz00_10552); 
VECTOR_SET(BgL_nsz00_12713,((long)6),BgL_lastz00_10553); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12714;
BgL_z12denvz12_12714 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12714, BgL_nsz00_12713); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12715;
BgL_ez00_12715 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12715, BgL_sz00_12704); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12716;
BgL_____rz00_12716 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10547, BgL_nsz00_12713, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12715); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12714, BgL_sz00_12704); 
return BgL_____rz00_12716;} } } } } } } } 

}



/* &run4167 */
obj_t BGl_z62run4167z62zz__evaluate_compz00(obj_t BgL_envz00_10554, obj_t BgL_sz00_10560)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10555;long BgL_siza7eza7_10556;obj_t BgL_valza2za2_10557;BgL_ev_absz00_bglt BgL_i1244z00_10558;obj_t BgL_bodyz00_10559;
BgL_iboxesz00_10555 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10554, 
(int)(((long)0)))); 
BgL_siza7eza7_10556 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10554, 
(int)(((long)1)))); 
BgL_valza2za2_10557 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10554, 
(int)(((long)2)))); 
BgL_i1244z00_10558 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10554, 
(int)(((long)3)))); 
BgL_bodyz00_10559 = 
PROCEDURE_REF(BgL_envz00_10554, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12717;
BgL_bpz00_12717 = 
VECTOR_REF(
((obj_t)BgL_sz00_10560),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10560, BgL_iboxesz00_10555, BgL_bpz00_12717); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10560, BgL_valza2za2_10557, 
(
(long)CINT(BgL_bpz00_12717)+BgL_siza7eza7_10556)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_12718;obj_t BgL_wherez00_12719;obj_t BgL_locz00_12720;
BgL_z12denvz12_12718 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12719 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10558))->BgL_wherez00); 
BgL_locz00_12720 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10558))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12718, BgL_wherez00_12719, BgL_locz00_12720); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_12721;
BgL_za2za2resza2za2z00_12721 = 
PROCEDURE_ENTRY(BgL_bodyz00_10559)(BgL_bodyz00_10559, BgL_sz00_10560, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12718); 
return BgL_za2za2resza2za2z00_12721;} } } } } } 

}



/* &<@anonymous:3523> */
obj_t BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10561, obj_t BgL_sz00_10565)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10562;obj_t BgL_bodyz00_10563;long BgL_siza7ezd2framez75_10564;
BgL_i1244z00_10562 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10561, 
(int)(((long)0)))); 
BgL_bodyz00_10563 = 
PROCEDURE_REF(BgL_envz00_10561, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_10564 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10561, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12722;
BgL_bpz00_12722 = 
VECTOR_REF(
((obj_t)BgL_sz00_10565),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12723;
BgL_runz00_12723 = 
MAKE_FX_PROCEDURE(BGl_z62run4169z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_12723, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10562)); 
PROCEDURE_SET(BgL_runz00_12723, 
(int)(((long)1)), BgL_bodyz00_10563); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12724;
BgL_mainz00_12724 = 
MAKE_FX_PROCEDURE(BGl_z62main4168z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_12724, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10562)); 
PROCEDURE_SET(BgL_mainz00_12724, 
(int)(((long)1)), BgL_bodyz00_10563); 
PROCEDURE_SET(BgL_mainz00_12724, 
(int)(((long)2)), BgL_runz00_12723); 
PROCEDURE_SET(BgL_mainz00_12724, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_10564)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12725;
BgL_objz00_12725 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12723, BgL_objz00_12725); BgL_objz00_12725; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3524z00_12726;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3525z00_12727;
BgL_arg3525z00_12727 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10562))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12728;
BgL_newz00_12728 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_21994;
BgL_tmpz00_21994 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12728, BgL_tmpz00_21994, BgL_arg3525z00_12727); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_21999;int BgL_tmpz00_21997;
BgL_auxz00_21999 = 
BINT(BgL_siza7ezd2framez75_10564); 
BgL_tmpz00_21997 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12728, BgL_tmpz00_21997, BgL_auxz00_21999); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22002;
BgL_tmpz00_22002 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12728, BgL_tmpz00_22002, BgL_runz00_12723); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22007;int BgL_tmpz00_22005;
BgL_auxz00_22007 = 
BINT(((long)4)); 
BgL_tmpz00_22005 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12728, BgL_tmpz00_22005, BgL_auxz00_22007); } 
BgL_arg3524z00_12726 = BgL_newz00_12728; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12724, BgL_arg3524z00_12726); BgL_arg3524z00_12726; } 
return BgL_mainz00_12724;} } } } } } 

}



/* &main4168 */
obj_t BGl_z62main4168z62zz__evaluate_compz00(obj_t BgL_envz00_10566, obj_t BgL_az00_10571, obj_t BgL_bz00_10572, obj_t BgL_cz00_10573, obj_t BgL_dz00_10574)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10569;long BgL_siza7ezd2framez75_10570;
BgL_runz00_10569 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10566, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_10570 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10566, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12729;
BgL_sz00_12729 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12730;
BgL_bpz00_12730 = 
VECTOR_REF(
((obj_t)BgL_sz00_12729),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12729, BgL_bpz00_12730, 
BINT(BgL_siza7ezd2framez75_10570)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3528z00_12731;
BgL_arg3528z00_12731 = 
(
(long)CINT(BgL_bpz00_12730)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12729),BgL_arg3528z00_12731,BgL_az00_10571); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3529z00_12732;
BgL_arg3529z00_12732 = 
(
(long)CINT(BgL_bpz00_12730)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12729),BgL_arg3529z00_12732,BgL_bz00_10572); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3530z00_12733;
BgL_arg3530z00_12733 = 
(
(long)CINT(BgL_bpz00_12730)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12729),BgL_arg3530z00_12733,BgL_cz00_10573); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3531z00_12734;
BgL_arg3531z00_12734 = 
(
(long)CINT(BgL_bpz00_12730)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12729),BgL_arg3531z00_12734,BgL_dz00_10574); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12735;
BgL_ez00_12735 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12735, BgL_bpz00_12730); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12736;
BgL_accz00_12736 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10569, BgL_sz00_12729, BgL_bpz00_12730); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12735); 
VECTOR_SET(
((obj_t)BgL_sz00_12729),((long)0),BgL_bpz00_12730); 
return BgL_accz00_12736;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12737;
BgL_nsz00_12737 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12737,((long)1),BgL_sz00_12729); 
VECTOR_SET(BgL_nsz00_12737,((long)2),BgL_az00_10571); 
VECTOR_SET(BgL_nsz00_12737,((long)3),BgL_bz00_10572); 
VECTOR_SET(BgL_nsz00_12737,((long)4),BgL_cz00_10573); 
VECTOR_SET(BgL_nsz00_12737,((long)5),BgL_dz00_10574); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12738;
BgL_z12denvz12_12738 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12738, BgL_nsz00_12737); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12739;
BgL_ez00_12739 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12739, BgL_sz00_12729); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12740;
BgL_____rz00_12740 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10569, BgL_nsz00_12737, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12739); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12738, BgL_sz00_12729); 
return BgL_____rz00_12740;} } } } } } } } 

}



/* &run4169 */
obj_t BGl_z62run4169z62zz__evaluate_compz00(obj_t BgL_envz00_10575, obj_t BgL_sz00_10578)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10576;obj_t BgL_bodyz00_10577;
BgL_i1244z00_10576 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10575, 
(int)(((long)0)))); 
BgL_bodyz00_10577 = 
PROCEDURE_REF(BgL_envz00_10575, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12741;
BgL_bpz00_12741 = 
VECTOR_REF(
((obj_t)BgL_sz00_10578),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12742;obj_t BgL_wherez00_12743;obj_t BgL_locz00_12744;
BgL_z12denvz12_12742 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12743 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10576))->BgL_wherez00); 
BgL_locz00_12744 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10576))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12742, BgL_wherez00_12743, BgL_locz00_12744); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_12745;
BgL_za2za2resza2za2z00_12745 = 
PROCEDURE_ENTRY(BgL_bodyz00_10577)(BgL_bodyz00_10577, BgL_sz00_10578, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12742); 
return BgL_za2za2resza2za2z00_12745;} } } } } } 

}



/* &<@anonymous:3533> */
obj_t BGl_z62zc3z04anonymousza33533ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10579, obj_t BgL_sz00_10584)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10580;BgL_ev_absz00_bglt BgL_i1244z00_10581;obj_t BgL_bodyz00_10582;long BgL_siza7ezd2framez75_10583;
BgL_iboxesz00_10580 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10579, 
(int)(((long)0)))); 
BgL_i1244z00_10581 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10579, 
(int)(((long)1)))); 
BgL_bodyz00_10582 = 
PROCEDURE_REF(BgL_envz00_10579, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_10583 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10579, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12746;
BgL_bpz00_12746 = 
VECTOR_REF(
((obj_t)BgL_sz00_10584),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12747;
BgL_runz00_12747 = 
MAKE_FX_PROCEDURE(BGl_z62run4171z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_12747, 
(int)(((long)0)), BgL_iboxesz00_10580); 
PROCEDURE_SET(BgL_runz00_12747, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10581)); 
PROCEDURE_SET(BgL_runz00_12747, 
(int)(((long)2)), BgL_bodyz00_10582); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12748;
BgL_mainz00_12748 = 
MAKE_FX_PROCEDURE(BGl_z62main4170z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_12748, 
(int)(((long)0)), BgL_iboxesz00_10580); 
PROCEDURE_SET(BgL_mainz00_12748, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10581)); 
PROCEDURE_SET(BgL_mainz00_12748, 
(int)(((long)2)), BgL_bodyz00_10582); 
PROCEDURE_SET(BgL_mainz00_12748, 
(int)(((long)3)), BgL_runz00_12747); 
PROCEDURE_SET(BgL_mainz00_12748, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_10583)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12749;
BgL_objz00_12749 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12747, BgL_objz00_12749); BgL_objz00_12749; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3534z00_12750;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3535z00_12751;
BgL_arg3535z00_12751 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10581))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12752;
BgL_newz00_12752 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22117;
BgL_tmpz00_22117 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12752, BgL_tmpz00_22117, BgL_arg3535z00_12751); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22122;int BgL_tmpz00_22120;
BgL_auxz00_22122 = 
BINT(BgL_siza7ezd2framez75_10583); 
BgL_tmpz00_22120 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12752, BgL_tmpz00_22120, BgL_auxz00_22122); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22125;
BgL_tmpz00_22125 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12752, BgL_tmpz00_22125, BgL_runz00_12747); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22130;int BgL_tmpz00_22128;
BgL_auxz00_22130 = 
BINT(((long)4)); 
BgL_tmpz00_22128 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12752, BgL_tmpz00_22128, BgL_auxz00_22130); } 
BgL_arg3534z00_12750 = BgL_newz00_12752; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12748, BgL_arg3534z00_12750); BgL_arg3534z00_12750; } 
return BgL_mainz00_12748;} } } } } } 

}



/* &main4170 */
obj_t BGl_z62main4170z62zz__evaluate_compz00(obj_t BgL_envz00_10585, obj_t BgL_az00_10591, obj_t BgL_bz00_10592, obj_t BgL_cz00_10593, obj_t BgL_dz00_10594)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10589;long BgL_siza7ezd2framez75_10590;
BgL_runz00_10589 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10585, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_10590 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10585, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12753;
BgL_sz00_12753 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12754;
BgL_bpz00_12754 = 
VECTOR_REF(
((obj_t)BgL_sz00_12753),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12753, BgL_bpz00_12754, 
BINT(BgL_siza7ezd2framez75_10590)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3538z00_12755;
BgL_arg3538z00_12755 = 
(
(long)CINT(BgL_bpz00_12754)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12753),BgL_arg3538z00_12755,BgL_az00_10591); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3539z00_12756;
BgL_arg3539z00_12756 = 
(
(long)CINT(BgL_bpz00_12754)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12753),BgL_arg3539z00_12756,BgL_bz00_10592); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3540z00_12757;
BgL_arg3540z00_12757 = 
(
(long)CINT(BgL_bpz00_12754)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12753),BgL_arg3540z00_12757,BgL_cz00_10593); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3541z00_12758;
BgL_arg3541z00_12758 = 
(
(long)CINT(BgL_bpz00_12754)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12753),BgL_arg3541z00_12758,BgL_dz00_10594); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12759;
BgL_ez00_12759 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12759, BgL_bpz00_12754); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12760;
BgL_accz00_12760 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10589, BgL_sz00_12753, BgL_bpz00_12754); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12759); 
VECTOR_SET(
((obj_t)BgL_sz00_12753),((long)0),BgL_bpz00_12754); 
return BgL_accz00_12760;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12761;
BgL_nsz00_12761 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12761,((long)1),BgL_sz00_12753); 
VECTOR_SET(BgL_nsz00_12761,((long)2),BgL_az00_10591); 
VECTOR_SET(BgL_nsz00_12761,((long)3),BgL_bz00_10592); 
VECTOR_SET(BgL_nsz00_12761,((long)4),BgL_cz00_10593); 
VECTOR_SET(BgL_nsz00_12761,((long)5),BgL_dz00_10594); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12762;
BgL_z12denvz12_12762 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12762, BgL_nsz00_12761); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12763;
BgL_ez00_12763 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12763, BgL_sz00_12753); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12764;
BgL_____rz00_12764 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10589, BgL_nsz00_12761, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12763); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12762, BgL_sz00_12753); 
return BgL_____rz00_12764;} } } } } } } } 

}



/* &run4171 */
obj_t BGl_z62run4171z62zz__evaluate_compz00(obj_t BgL_envz00_10595, obj_t BgL_sz00_10599)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10596;BgL_ev_absz00_bglt BgL_i1244z00_10597;obj_t BgL_bodyz00_10598;
BgL_iboxesz00_10596 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10595, 
(int)(((long)0)))); 
BgL_i1244z00_10597 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10595, 
(int)(((long)1)))); 
BgL_bodyz00_10598 = 
PROCEDURE_REF(BgL_envz00_10595, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12765;
BgL_bpz00_12765 = 
VECTOR_REF(
((obj_t)BgL_sz00_10599),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10599, BgL_iboxesz00_10596, BgL_bpz00_12765); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12766;obj_t BgL_wherez00_12767;obj_t BgL_locz00_12768;
BgL_z12denvz12_12766 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12767 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10597))->BgL_wherez00); 
BgL_locz00_12768 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10597))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12766, BgL_wherez00_12767, BgL_locz00_12768); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_12769;
BgL_za2za2resza2za2z00_12769 = 
PROCEDURE_ENTRY(BgL_bodyz00_10598)(BgL_bodyz00_10598, BgL_sz00_10599, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12766); 
return BgL_za2za2resza2za2z00_12769;} } } } } } 

}



/* &<@anonymous:3546> */
obj_t BGl_z62zc3z04anonymousza33546ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10600, obj_t BgL_sz00_10606)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10601;long BgL_siza7eza7_10602;BgL_ev_absz00_bglt BgL_i1244z00_10603;obj_t BgL_bodyz00_10604;long BgL_siza7ezd2framez75_10605;
BgL_ifreesz00_10601 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10600, 
(int)(((long)0)))); 
BgL_siza7eza7_10602 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10600, 
(int)(((long)1)))); 
BgL_i1244z00_10603 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10600, 
(int)(((long)2)))); 
BgL_bodyz00_10604 = 
PROCEDURE_REF(BgL_envz00_10600, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_10605 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10600, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12770;
BgL_bpz00_12770 = 
VECTOR_REF(
((obj_t)BgL_sz00_10606),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_12771;
BgL_valza2za2_12771 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10606, BgL_bpz00_12770, BgL_ifreesz00_10601); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12772;
BgL_runz00_12772 = 
MAKE_FX_PROCEDURE(BGl_z62run4173z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_12772, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10602)); 
PROCEDURE_SET(BgL_runz00_12772, 
(int)(((long)1)), BgL_valza2za2_12771); 
PROCEDURE_SET(BgL_runz00_12772, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10603)); 
PROCEDURE_SET(BgL_runz00_12772, 
(int)(((long)3)), BgL_bodyz00_10604); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12773;
BgL_mainz00_12773 = 
MAKE_FX_PROCEDURE(BGl_z62main4172z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_12773, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10602)); 
PROCEDURE_SET(BgL_mainz00_12773, 
(int)(((long)1)), BgL_valza2za2_12771); 
PROCEDURE_SET(BgL_mainz00_12773, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10603)); 
PROCEDURE_SET(BgL_mainz00_12773, 
(int)(((long)3)), BgL_bodyz00_10604); 
PROCEDURE_SET(BgL_mainz00_12773, 
(int)(((long)4)), BgL_runz00_12772); 
PROCEDURE_SET(BgL_mainz00_12773, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_10605)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12774;
BgL_objz00_12774 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12772, BgL_objz00_12774); BgL_objz00_12774; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3547z00_12775;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3548z00_12776;
BgL_arg3548z00_12776 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10603))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12777;
BgL_newz00_12777 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22254;
BgL_tmpz00_22254 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12777, BgL_tmpz00_22254, BgL_arg3548z00_12776); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22259;int BgL_tmpz00_22257;
BgL_auxz00_22259 = 
BINT(BgL_siza7ezd2framez75_10605); 
BgL_tmpz00_22257 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12777, BgL_tmpz00_22257, BgL_auxz00_22259); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22262;
BgL_tmpz00_22262 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12777, BgL_tmpz00_22262, BgL_runz00_12772); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22267;int BgL_tmpz00_22265;
BgL_auxz00_22267 = 
BINT(((long)4)); 
BgL_tmpz00_22265 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12777, BgL_tmpz00_22265, BgL_auxz00_22267); } 
BgL_arg3547z00_12775 = BgL_newz00_12777; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12773, BgL_arg3547z00_12775); BgL_arg3547z00_12775; } 
return BgL_mainz00_12773;} } } } } } 

}



/* &main4172 */
obj_t BGl_z62main4172z62zz__evaluate_compz00(obj_t BgL_envz00_10607, obj_t BgL_az00_10614, obj_t BgL_bz00_10615, obj_t BgL_cz00_10616, obj_t BgL_dz00_10617)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10612;long BgL_siza7ezd2framez75_10613;
BgL_runz00_10612 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10607, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_10613 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10607, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12778;
BgL_sz00_12778 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12779;
BgL_bpz00_12779 = 
VECTOR_REF(
((obj_t)BgL_sz00_12778),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12778, BgL_bpz00_12779, 
BINT(BgL_siza7ezd2framez75_10613)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3551z00_12780;
BgL_arg3551z00_12780 = 
(
(long)CINT(BgL_bpz00_12779)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12778),BgL_arg3551z00_12780,BgL_az00_10614); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3552z00_12781;
BgL_arg3552z00_12781 = 
(
(long)CINT(BgL_bpz00_12779)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12778),BgL_arg3552z00_12781,BgL_bz00_10615); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3553z00_12782;
BgL_arg3553z00_12782 = 
(
(long)CINT(BgL_bpz00_12779)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12778),BgL_arg3553z00_12782,BgL_cz00_10616); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3554z00_12783;
BgL_arg3554z00_12783 = 
(
(long)CINT(BgL_bpz00_12779)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12778),BgL_arg3554z00_12783,BgL_dz00_10617); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12784;
BgL_ez00_12784 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12784, BgL_bpz00_12779); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12785;
BgL_accz00_12785 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10612, BgL_sz00_12778, BgL_bpz00_12779); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12784); 
VECTOR_SET(
((obj_t)BgL_sz00_12778),((long)0),BgL_bpz00_12779); 
return BgL_accz00_12785;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12786;
BgL_nsz00_12786 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12786,((long)1),BgL_sz00_12778); 
VECTOR_SET(BgL_nsz00_12786,((long)2),BgL_az00_10614); 
VECTOR_SET(BgL_nsz00_12786,((long)3),BgL_bz00_10615); 
VECTOR_SET(BgL_nsz00_12786,((long)4),BgL_cz00_10616); 
VECTOR_SET(BgL_nsz00_12786,((long)5),BgL_dz00_10617); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12787;
BgL_z12denvz12_12787 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12787, BgL_nsz00_12786); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12788;
BgL_ez00_12788 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12788, BgL_sz00_12778); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12789;
BgL_____rz00_12789 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10612, BgL_nsz00_12786, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12788); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12787, BgL_sz00_12778); 
return BgL_____rz00_12789;} } } } } } } } 

}



/* &run4173 */
obj_t BGl_z62run4173z62zz__evaluate_compz00(obj_t BgL_envz00_10618, obj_t BgL_sz00_10623)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_10619;obj_t BgL_valza2za2_10620;BgL_ev_absz00_bglt BgL_i1244z00_10621;obj_t BgL_bodyz00_10622;
BgL_siza7eza7_10619 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10618, 
(int)(((long)0)))); 
BgL_valza2za2_10620 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10618, 
(int)(((long)1)))); 
BgL_i1244z00_10621 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10618, 
(int)(((long)2)))); 
BgL_bodyz00_10622 = 
PROCEDURE_REF(BgL_envz00_10618, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12790;
BgL_bpz00_12790 = 
VECTOR_REF(
((obj_t)BgL_sz00_10623),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10623, BgL_valza2za2_10620, 
(
(long)CINT(BgL_bpz00_12790)+BgL_siza7eza7_10619)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_12791;obj_t BgL_wherez00_12792;obj_t BgL_locz00_12793;
BgL_z12denvz12_12791 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12792 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10621))->BgL_wherez00); 
BgL_locz00_12793 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10621))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12791, BgL_wherez00_12792, BgL_locz00_12793); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_12794;
BgL_za2za2resza2za2z00_12794 = 
PROCEDURE_ENTRY(BgL_bodyz00_10622)(BgL_bodyz00_10622, BgL_sz00_10623, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12791); 
return BgL_za2za2resza2za2z00_12794;} } } } } } 

}



/* &<@anonymous:3557> */
obj_t BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10624, obj_t BgL_sz00_10631)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10625;obj_t BgL_iboxesz00_10626;long BgL_siza7eza7_10627;BgL_ev_absz00_bglt BgL_i1244z00_10628;obj_t BgL_bodyz00_10629;long BgL_siza7ezd2framez75_10630;
BgL_ifreesz00_10625 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10624, 
(int)(((long)0)))); 
BgL_iboxesz00_10626 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10624, 
(int)(((long)1)))); 
BgL_siza7eza7_10627 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10624, 
(int)(((long)2)))); 
BgL_i1244z00_10628 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10624, 
(int)(((long)3)))); 
BgL_bodyz00_10629 = 
PROCEDURE_REF(BgL_envz00_10624, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_10630 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10624, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12795;
BgL_bpz00_12795 = 
VECTOR_REF(
((obj_t)BgL_sz00_10631),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_12796;
BgL_valza2za2_12796 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10631, BgL_bpz00_12795, BgL_ifreesz00_10625); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12797;
BgL_runz00_12797 = 
MAKE_FX_PROCEDURE(BGl_z62run4175z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_12797, 
(int)(((long)0)), BgL_iboxesz00_10626); 
PROCEDURE_SET(BgL_runz00_12797, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10627)); 
PROCEDURE_SET(BgL_runz00_12797, 
(int)(((long)2)), BgL_valza2za2_12796); 
PROCEDURE_SET(BgL_runz00_12797, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10628)); 
PROCEDURE_SET(BgL_runz00_12797, 
(int)(((long)4)), BgL_bodyz00_10629); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12798;
BgL_mainz00_12798 = 
MAKE_FX_PROCEDURE(BGl_z62main4174z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_12798, 
(int)(((long)0)), BgL_iboxesz00_10626); 
PROCEDURE_SET(BgL_mainz00_12798, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10627)); 
PROCEDURE_SET(BgL_mainz00_12798, 
(int)(((long)2)), BgL_valza2za2_12796); 
PROCEDURE_SET(BgL_mainz00_12798, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10628)); 
PROCEDURE_SET(BgL_mainz00_12798, 
(int)(((long)4)), BgL_bodyz00_10629); 
PROCEDURE_SET(BgL_mainz00_12798, 
(int)(((long)5)), BgL_runz00_12797); 
PROCEDURE_SET(BgL_mainz00_12798, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_10630)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12799;
BgL_objz00_12799 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12797, BgL_objz00_12799); BgL_objz00_12799; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3558z00_12800;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3559z00_12801;
BgL_arg3559z00_12801 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10628))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12802;
BgL_newz00_12802 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22403;
BgL_tmpz00_22403 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12802, BgL_tmpz00_22403, BgL_arg3559z00_12801); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22408;int BgL_tmpz00_22406;
BgL_auxz00_22408 = 
BINT(BgL_siza7ezd2framez75_10630); 
BgL_tmpz00_22406 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12802, BgL_tmpz00_22406, BgL_auxz00_22408); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22411;
BgL_tmpz00_22411 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12802, BgL_tmpz00_22411, BgL_runz00_12797); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22416;int BgL_tmpz00_22414;
BgL_auxz00_22416 = 
BINT(((long)4)); 
BgL_tmpz00_22414 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12802, BgL_tmpz00_22414, BgL_auxz00_22416); } 
BgL_arg3558z00_12800 = BgL_newz00_12802; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12798, BgL_arg3558z00_12800); BgL_arg3558z00_12800; } 
return BgL_mainz00_12798;} } } } } } 

}



/* &main4174 */
obj_t BGl_z62main4174z62zz__evaluate_compz00(obj_t BgL_envz00_10632, obj_t BgL_az00_10640, obj_t BgL_bz00_10641, obj_t BgL_cz00_10642, obj_t BgL_dz00_10643)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10638;long BgL_siza7ezd2framez75_10639;
BgL_runz00_10638 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10632, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_10639 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10632, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12803;
BgL_sz00_12803 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12804;
BgL_bpz00_12804 = 
VECTOR_REF(
((obj_t)BgL_sz00_12803),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12803, BgL_bpz00_12804, 
BINT(BgL_siza7ezd2framez75_10639)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3562z00_12805;
BgL_arg3562z00_12805 = 
(
(long)CINT(BgL_bpz00_12804)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12803),BgL_arg3562z00_12805,BgL_az00_10640); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3563z00_12806;
BgL_arg3563z00_12806 = 
(
(long)CINT(BgL_bpz00_12804)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12803),BgL_arg3563z00_12806,BgL_bz00_10641); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3564z00_12807;
BgL_arg3564z00_12807 = 
(
(long)CINT(BgL_bpz00_12804)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12803),BgL_arg3564z00_12807,BgL_cz00_10642); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3565z00_12808;
BgL_arg3565z00_12808 = 
(
(long)CINT(BgL_bpz00_12804)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12803),BgL_arg3565z00_12808,BgL_dz00_10643); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12809;
BgL_ez00_12809 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12809, BgL_bpz00_12804); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12810;
BgL_accz00_12810 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10638, BgL_sz00_12803, BgL_bpz00_12804); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12809); 
VECTOR_SET(
((obj_t)BgL_sz00_12803),((long)0),BgL_bpz00_12804); 
return BgL_accz00_12810;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12811;
BgL_nsz00_12811 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12811,((long)1),BgL_sz00_12803); 
VECTOR_SET(BgL_nsz00_12811,((long)2),BgL_az00_10640); 
VECTOR_SET(BgL_nsz00_12811,((long)3),BgL_bz00_10641); 
VECTOR_SET(BgL_nsz00_12811,((long)4),BgL_cz00_10642); 
VECTOR_SET(BgL_nsz00_12811,((long)5),BgL_dz00_10643); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12812;
BgL_z12denvz12_12812 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12812, BgL_nsz00_12811); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12813;
BgL_ez00_12813 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12813, BgL_sz00_12803); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12814;
BgL_____rz00_12814 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10638, BgL_nsz00_12811, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12813); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12812, BgL_sz00_12803); 
return BgL_____rz00_12814;} } } } } } } } 

}



/* &run4175 */
obj_t BGl_z62run4175z62zz__evaluate_compz00(obj_t BgL_envz00_10644, obj_t BgL_sz00_10650)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10645;long BgL_siza7eza7_10646;obj_t BgL_valza2za2_10647;BgL_ev_absz00_bglt BgL_i1244z00_10648;obj_t BgL_bodyz00_10649;
BgL_iboxesz00_10645 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)0)))); 
BgL_siza7eza7_10646 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)1)))); 
BgL_valza2za2_10647 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)2)))); 
BgL_i1244z00_10648 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)3)))); 
BgL_bodyz00_10649 = 
PROCEDURE_REF(BgL_envz00_10644, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12815;
BgL_bpz00_12815 = 
VECTOR_REF(
((obj_t)BgL_sz00_10650),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10650, BgL_iboxesz00_10645, BgL_bpz00_12815); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10650, BgL_valza2za2_10647, 
(
(long)CINT(BgL_bpz00_12815)+BgL_siza7eza7_10646)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_12816;obj_t BgL_wherez00_12817;obj_t BgL_locz00_12818;
BgL_z12denvz12_12816 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12817 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10648))->BgL_wherez00); 
BgL_locz00_12818 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10648))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12816, BgL_wherez00_12817, BgL_locz00_12818); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_12819;
BgL_za2za2resza2za2z00_12819 = 
PROCEDURE_ENTRY(BgL_bodyz00_10649)(BgL_bodyz00_10649, BgL_sz00_10650, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12816); 
return BgL_za2za2resza2za2z00_12819;} } } } } } 

}



/* &<@anonymous:3472> */
obj_t BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10651, obj_t BgL_sz00_10655)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10652;obj_t BgL_bodyz00_10653;long BgL_siza7ezd2framez75_10654;
BgL_i1244z00_10652 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10651, 
(int)(((long)0)))); 
BgL_bodyz00_10653 = 
PROCEDURE_REF(BgL_envz00_10651, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_10654 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10651, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12820;
BgL_bpz00_12820 = 
VECTOR_REF(
((obj_t)BgL_sz00_10655),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12821;
BgL_runz00_12821 = 
MAKE_FX_PROCEDURE(BGl_z62run4177z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_12821, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10652)); 
PROCEDURE_SET(BgL_runz00_12821, 
(int)(((long)1)), BgL_bodyz00_10653); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12822;
BgL_mainz00_12822 = 
MAKE_VA_PROCEDURE(BGl_z62main4176z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_12822, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10652)); 
PROCEDURE_SET(BgL_mainz00_12822, 
(int)(((long)1)), BgL_bodyz00_10653); 
PROCEDURE_SET(BgL_mainz00_12822, 
(int)(((long)2)), BgL_runz00_12821); 
PROCEDURE_SET(BgL_mainz00_12822, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_10654)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12823;
BgL_objz00_12823 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12821, BgL_objz00_12823); BgL_objz00_12823; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3473z00_12824;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3474z00_12825;
BgL_arg3474z00_12825 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10652))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12826;
BgL_newz00_12826 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22532;
BgL_tmpz00_22532 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12826, BgL_tmpz00_22532, BgL_arg3474z00_12825); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22537;int BgL_tmpz00_22535;
BgL_auxz00_22537 = 
BINT(BgL_siza7ezd2framez75_10654); 
BgL_tmpz00_22535 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12826, BgL_tmpz00_22535, BgL_auxz00_22537); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22540;
BgL_tmpz00_22540 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12826, BgL_tmpz00_22540, BgL_runz00_12821); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22545;int BgL_tmpz00_22543;
BgL_auxz00_22545 = 
BINT(((long)-4)); 
BgL_tmpz00_22543 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12826, BgL_tmpz00_22543, BgL_auxz00_22545); } 
BgL_arg3473z00_12824 = BgL_newz00_12826; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12822, BgL_arg3473z00_12824); BgL_arg3473z00_12824; } 
return BgL_mainz00_12822;} } } } } } 

}



/* &main4176 */
obj_t BGl_z62main4176z62zz__evaluate_compz00(obj_t BgL_envz00_10656, obj_t BgL_bz00_10661, obj_t BgL_cz00_10662, obj_t BgL_dz00_10663, obj_t BgL_lastz00_10664)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10659;long BgL_siza7ezd2framez75_10660;
BgL_runz00_10659 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10656, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_10660 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10656, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12827;
BgL_sz00_12827 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12828;
BgL_bpz00_12828 = 
VECTOR_REF(
((obj_t)BgL_sz00_12827),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12827, BgL_bpz00_12828, 
BINT(BgL_siza7ezd2framez75_10660)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3477z00_12829;
BgL_arg3477z00_12829 = 
(
(long)CINT(BgL_bpz00_12828)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12827),BgL_arg3477z00_12829,BgL_bz00_10661); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3478z00_12830;
BgL_arg3478z00_12830 = 
(
(long)CINT(BgL_bpz00_12828)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12827),BgL_arg3478z00_12830,BgL_cz00_10662); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3479z00_12831;
BgL_arg3479z00_12831 = 
(
(long)CINT(BgL_bpz00_12828)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12827),BgL_arg3479z00_12831,BgL_dz00_10663); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3480z00_12832;
BgL_arg3480z00_12832 = 
(
(long)CINT(BgL_bpz00_12828)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12827),BgL_arg3480z00_12832,BgL_lastz00_10664); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12833;
BgL_ez00_12833 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12833, BgL_bpz00_12828); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12834;
BgL_accz00_12834 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10659, BgL_sz00_12827, BgL_bpz00_12828); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12833); 
VECTOR_SET(
((obj_t)BgL_sz00_12827),((long)0),BgL_bpz00_12828); 
return BgL_accz00_12834;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12835;
BgL_nsz00_12835 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12835,((long)1),BgL_sz00_12827); 
VECTOR_SET(BgL_nsz00_12835,((long)2),BgL_bz00_10661); 
VECTOR_SET(BgL_nsz00_12835,((long)3),BgL_cz00_10662); 
VECTOR_SET(BgL_nsz00_12835,((long)4),BgL_dz00_10663); 
VECTOR_SET(BgL_nsz00_12835,((long)5),BgL_lastz00_10664); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12836;
BgL_z12denvz12_12836 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12836, BgL_nsz00_12835); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12837;
BgL_ez00_12837 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12837, BgL_sz00_12827); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12838;
BgL_____rz00_12838 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10659, BgL_nsz00_12835, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12837); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12836, BgL_sz00_12827); 
return BgL_____rz00_12838;} } } } } } } } 

}



/* &run4177 */
obj_t BGl_z62run4177z62zz__evaluate_compz00(obj_t BgL_envz00_10665, obj_t BgL_sz00_10668)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10666;obj_t BgL_bodyz00_10667;
BgL_i1244z00_10666 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10665, 
(int)(((long)0)))); 
BgL_bodyz00_10667 = 
PROCEDURE_REF(BgL_envz00_10665, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12839;
BgL_bpz00_12839 = 
VECTOR_REF(
((obj_t)BgL_sz00_10668),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12840;obj_t BgL_wherez00_12841;obj_t BgL_locz00_12842;
BgL_z12denvz12_12840 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12841 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10666))->BgL_wherez00); 
BgL_locz00_12842 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10666))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12840, BgL_wherez00_12841, BgL_locz00_12842); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_12843;
BgL_za2za2resza2za2z00_12843 = 
PROCEDURE_ENTRY(BgL_bodyz00_10667)(BgL_bodyz00_10667, BgL_sz00_10668, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12840); 
return BgL_za2za2resza2za2z00_12843;} } } } } } 

}



/* &<@anonymous:3482> */
obj_t BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10669, obj_t BgL_sz00_10674)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10670;BgL_ev_absz00_bglt BgL_i1244z00_10671;obj_t BgL_bodyz00_10672;long BgL_siza7ezd2framez75_10673;
BgL_iboxesz00_10670 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10669, 
(int)(((long)0)))); 
BgL_i1244z00_10671 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10669, 
(int)(((long)1)))); 
BgL_bodyz00_10672 = 
PROCEDURE_REF(BgL_envz00_10669, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_10673 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10669, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12844;
BgL_bpz00_12844 = 
VECTOR_REF(
((obj_t)BgL_sz00_10674),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12845;
BgL_runz00_12845 = 
MAKE_FX_PROCEDURE(BGl_z62run4179z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_12845, 
(int)(((long)0)), BgL_iboxesz00_10670); 
PROCEDURE_SET(BgL_runz00_12845, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10671)); 
PROCEDURE_SET(BgL_runz00_12845, 
(int)(((long)2)), BgL_bodyz00_10672); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12846;
BgL_mainz00_12846 = 
MAKE_VA_PROCEDURE(BGl_z62main4178z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_12846, 
(int)(((long)0)), BgL_iboxesz00_10670); 
PROCEDURE_SET(BgL_mainz00_12846, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10671)); 
PROCEDURE_SET(BgL_mainz00_12846, 
(int)(((long)2)), BgL_bodyz00_10672); 
PROCEDURE_SET(BgL_mainz00_12846, 
(int)(((long)3)), BgL_runz00_12845); 
PROCEDURE_SET(BgL_mainz00_12846, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_10673)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12847;
BgL_objz00_12847 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12845, BgL_objz00_12847); BgL_objz00_12847; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3483z00_12848;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3484z00_12849;
BgL_arg3484z00_12849 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10671))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12850;
BgL_newz00_12850 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22655;
BgL_tmpz00_22655 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12850, BgL_tmpz00_22655, BgL_arg3484z00_12849); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22660;int BgL_tmpz00_22658;
BgL_auxz00_22660 = 
BINT(BgL_siza7ezd2framez75_10673); 
BgL_tmpz00_22658 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12850, BgL_tmpz00_22658, BgL_auxz00_22660); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22663;
BgL_tmpz00_22663 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12850, BgL_tmpz00_22663, BgL_runz00_12845); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22668;int BgL_tmpz00_22666;
BgL_auxz00_22668 = 
BINT(((long)-4)); 
BgL_tmpz00_22666 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12850, BgL_tmpz00_22666, BgL_auxz00_22668); } 
BgL_arg3483z00_12848 = BgL_newz00_12850; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12846, BgL_arg3483z00_12848); BgL_arg3483z00_12848; } 
return BgL_mainz00_12846;} } } } } } 

}



/* &main4178 */
obj_t BGl_z62main4178z62zz__evaluate_compz00(obj_t BgL_envz00_10675, obj_t BgL_bz00_10681, obj_t BgL_cz00_10682, obj_t BgL_dz00_10683, obj_t BgL_lastz00_10684)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10679;long BgL_siza7ezd2framez75_10680;
BgL_runz00_10679 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10675, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_10680 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10675, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12851;
BgL_sz00_12851 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12852;
BgL_bpz00_12852 = 
VECTOR_REF(
((obj_t)BgL_sz00_12851),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12851, BgL_bpz00_12852, 
BINT(BgL_siza7ezd2framez75_10680)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3487z00_12853;
BgL_arg3487z00_12853 = 
(
(long)CINT(BgL_bpz00_12852)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12851),BgL_arg3487z00_12853,BgL_bz00_10681); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3488z00_12854;
BgL_arg3488z00_12854 = 
(
(long)CINT(BgL_bpz00_12852)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12851),BgL_arg3488z00_12854,BgL_cz00_10682); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3489z00_12855;
BgL_arg3489z00_12855 = 
(
(long)CINT(BgL_bpz00_12852)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12851),BgL_arg3489z00_12855,BgL_dz00_10683); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3490z00_12856;
BgL_arg3490z00_12856 = 
(
(long)CINT(BgL_bpz00_12852)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12851),BgL_arg3490z00_12856,BgL_lastz00_10684); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12857;
BgL_ez00_12857 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12857, BgL_bpz00_12852); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12858;
BgL_accz00_12858 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10679, BgL_sz00_12851, BgL_bpz00_12852); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12857); 
VECTOR_SET(
((obj_t)BgL_sz00_12851),((long)0),BgL_bpz00_12852); 
return BgL_accz00_12858;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12859;
BgL_nsz00_12859 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12859,((long)1),BgL_sz00_12851); 
VECTOR_SET(BgL_nsz00_12859,((long)2),BgL_bz00_10681); 
VECTOR_SET(BgL_nsz00_12859,((long)3),BgL_cz00_10682); 
VECTOR_SET(BgL_nsz00_12859,((long)4),BgL_dz00_10683); 
VECTOR_SET(BgL_nsz00_12859,((long)5),BgL_lastz00_10684); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12860;
BgL_z12denvz12_12860 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12860, BgL_nsz00_12859); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12861;
BgL_ez00_12861 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12861, BgL_sz00_12851); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12862;
BgL_____rz00_12862 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10679, BgL_nsz00_12859, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12861); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12860, BgL_sz00_12851); 
return BgL_____rz00_12862;} } } } } } } } 

}



/* &run4179 */
obj_t BGl_z62run4179z62zz__evaluate_compz00(obj_t BgL_envz00_10685, obj_t BgL_sz00_10689)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10686;BgL_ev_absz00_bglt BgL_i1244z00_10687;obj_t BgL_bodyz00_10688;
BgL_iboxesz00_10686 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10685, 
(int)(((long)0)))); 
BgL_i1244z00_10687 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10685, 
(int)(((long)1)))); 
BgL_bodyz00_10688 = 
PROCEDURE_REF(BgL_envz00_10685, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12863;
BgL_bpz00_12863 = 
VECTOR_REF(
((obj_t)BgL_sz00_10689),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10689, BgL_iboxesz00_10686, BgL_bpz00_12863); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12864;obj_t BgL_wherez00_12865;obj_t BgL_locz00_12866;
BgL_z12denvz12_12864 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12865 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10687))->BgL_wherez00); 
BgL_locz00_12866 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10687))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12864, BgL_wherez00_12865, BgL_locz00_12866); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_12867;
BgL_za2za2resza2za2z00_12867 = 
PROCEDURE_ENTRY(BgL_bodyz00_10688)(BgL_bodyz00_10688, BgL_sz00_10689, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12864); 
return BgL_za2za2resza2za2z00_12867;} } } } } } 

}



/* &<@anonymous:3495> */
obj_t BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10690, obj_t BgL_sz00_10696)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10691;long BgL_siza7eza7_10692;BgL_ev_absz00_bglt BgL_i1244z00_10693;obj_t BgL_bodyz00_10694;long BgL_siza7ezd2framez75_10695;
BgL_ifreesz00_10691 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)0)))); 
BgL_siza7eza7_10692 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)1)))); 
BgL_i1244z00_10693 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)2)))); 
BgL_bodyz00_10694 = 
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_10695 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12868;
BgL_bpz00_12868 = 
VECTOR_REF(
((obj_t)BgL_sz00_10696),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_12869;
BgL_valza2za2_12869 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10696, BgL_bpz00_12868, BgL_ifreesz00_10691); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12870;
BgL_runz00_12870 = 
MAKE_FX_PROCEDURE(BGl_z62run4181z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_12870, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10692)); 
PROCEDURE_SET(BgL_runz00_12870, 
(int)(((long)1)), BgL_valza2za2_12869); 
PROCEDURE_SET(BgL_runz00_12870, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10693)); 
PROCEDURE_SET(BgL_runz00_12870, 
(int)(((long)3)), BgL_bodyz00_10694); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12871;
BgL_mainz00_12871 = 
MAKE_VA_PROCEDURE(BGl_z62main4180z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_12871, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10692)); 
PROCEDURE_SET(BgL_mainz00_12871, 
(int)(((long)1)), BgL_valza2za2_12869); 
PROCEDURE_SET(BgL_mainz00_12871, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10693)); 
PROCEDURE_SET(BgL_mainz00_12871, 
(int)(((long)3)), BgL_bodyz00_10694); 
PROCEDURE_SET(BgL_mainz00_12871, 
(int)(((long)4)), BgL_runz00_12870); 
PROCEDURE_SET(BgL_mainz00_12871, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_10695)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12872;
BgL_objz00_12872 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12870, BgL_objz00_12872); BgL_objz00_12872; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3496z00_12873;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3497z00_12874;
BgL_arg3497z00_12874 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10693))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12875;
BgL_newz00_12875 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22792;
BgL_tmpz00_22792 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12875, BgL_tmpz00_22792, BgL_arg3497z00_12874); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22797;int BgL_tmpz00_22795;
BgL_auxz00_22797 = 
BINT(BgL_siza7ezd2framez75_10695); 
BgL_tmpz00_22795 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12875, BgL_tmpz00_22795, BgL_auxz00_22797); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22800;
BgL_tmpz00_22800 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12875, BgL_tmpz00_22800, BgL_runz00_12870); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22805;int BgL_tmpz00_22803;
BgL_auxz00_22805 = 
BINT(((long)-4)); 
BgL_tmpz00_22803 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12875, BgL_tmpz00_22803, BgL_auxz00_22805); } 
BgL_arg3496z00_12873 = BgL_newz00_12875; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12871, BgL_arg3496z00_12873); BgL_arg3496z00_12873; } 
return BgL_mainz00_12871;} } } } } } 

}



/* &main4180 */
obj_t BGl_z62main4180z62zz__evaluate_compz00(obj_t BgL_envz00_10697, obj_t BgL_bz00_10704, obj_t BgL_cz00_10705, obj_t BgL_dz00_10706, obj_t BgL_lastz00_10707)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10702;long BgL_siza7ezd2framez75_10703;
BgL_runz00_10702 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10697, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_10703 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10697, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12876;
BgL_sz00_12876 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12877;
BgL_bpz00_12877 = 
VECTOR_REF(
((obj_t)BgL_sz00_12876),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12876, BgL_bpz00_12877, 
BINT(BgL_siza7ezd2framez75_10703)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3500z00_12878;
BgL_arg3500z00_12878 = 
(
(long)CINT(BgL_bpz00_12877)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12876),BgL_arg3500z00_12878,BgL_bz00_10704); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3501z00_12879;
BgL_arg3501z00_12879 = 
(
(long)CINT(BgL_bpz00_12877)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12876),BgL_arg3501z00_12879,BgL_cz00_10705); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3502z00_12880;
BgL_arg3502z00_12880 = 
(
(long)CINT(BgL_bpz00_12877)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12876),BgL_arg3502z00_12880,BgL_dz00_10706); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3503z00_12881;
BgL_arg3503z00_12881 = 
(
(long)CINT(BgL_bpz00_12877)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12876),BgL_arg3503z00_12881,BgL_lastz00_10707); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12882;
BgL_ez00_12882 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12882, BgL_bpz00_12877); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12883;
BgL_accz00_12883 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10702, BgL_sz00_12876, BgL_bpz00_12877); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12882); 
VECTOR_SET(
((obj_t)BgL_sz00_12876),((long)0),BgL_bpz00_12877); 
return BgL_accz00_12883;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12884;
BgL_nsz00_12884 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12884,((long)1),BgL_sz00_12876); 
VECTOR_SET(BgL_nsz00_12884,((long)2),BgL_bz00_10704); 
VECTOR_SET(BgL_nsz00_12884,((long)3),BgL_cz00_10705); 
VECTOR_SET(BgL_nsz00_12884,((long)4),BgL_dz00_10706); 
VECTOR_SET(BgL_nsz00_12884,((long)5),BgL_lastz00_10707); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12885;
BgL_z12denvz12_12885 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12885, BgL_nsz00_12884); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12886;
BgL_ez00_12886 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12886, BgL_sz00_12876); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12887;
BgL_____rz00_12887 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10702, BgL_nsz00_12884, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12886); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12885, BgL_sz00_12876); 
return BgL_____rz00_12887;} } } } } } } } 

}



/* &run4181 */
obj_t BGl_z62run4181z62zz__evaluate_compz00(obj_t BgL_envz00_10708, obj_t BgL_sz00_10713)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_10709;obj_t BgL_valza2za2_10710;BgL_ev_absz00_bglt BgL_i1244z00_10711;obj_t BgL_bodyz00_10712;
BgL_siza7eza7_10709 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10708, 
(int)(((long)0)))); 
BgL_valza2za2_10710 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10708, 
(int)(((long)1)))); 
BgL_i1244z00_10711 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10708, 
(int)(((long)2)))); 
BgL_bodyz00_10712 = 
PROCEDURE_REF(BgL_envz00_10708, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12888;
BgL_bpz00_12888 = 
VECTOR_REF(
((obj_t)BgL_sz00_10713),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10713, BgL_valza2za2_10710, 
(
(long)CINT(BgL_bpz00_12888)+BgL_siza7eza7_10709)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_12889;obj_t BgL_wherez00_12890;obj_t BgL_locz00_12891;
BgL_z12denvz12_12889 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12890 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10711))->BgL_wherez00); 
BgL_locz00_12891 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10711))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12889, BgL_wherez00_12890, BgL_locz00_12891); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_12892;
BgL_za2za2resza2za2z00_12892 = 
PROCEDURE_ENTRY(BgL_bodyz00_10712)(BgL_bodyz00_10712, BgL_sz00_10713, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12889); 
return BgL_za2za2resza2za2z00_12892;} } } } } } 

}



/* &<@anonymous:3506> */
obj_t BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10714, obj_t BgL_sz00_10721)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10715;obj_t BgL_iboxesz00_10716;long BgL_siza7eza7_10717;BgL_ev_absz00_bglt BgL_i1244z00_10718;obj_t BgL_bodyz00_10719;long BgL_siza7ezd2framez75_10720;
BgL_ifreesz00_10715 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10714, 
(int)(((long)0)))); 
BgL_iboxesz00_10716 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10714, 
(int)(((long)1)))); 
BgL_siza7eza7_10717 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10714, 
(int)(((long)2)))); 
BgL_i1244z00_10718 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10714, 
(int)(((long)3)))); 
BgL_bodyz00_10719 = 
PROCEDURE_REF(BgL_envz00_10714, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_10720 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10714, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12893;
BgL_bpz00_12893 = 
VECTOR_REF(
((obj_t)BgL_sz00_10721),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_12894;
BgL_valza2za2_12894 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10721, BgL_bpz00_12893, BgL_ifreesz00_10715); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12895;
BgL_runz00_12895 = 
MAKE_FX_PROCEDURE(BGl_z62run4183z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_12895, 
(int)(((long)0)), BgL_iboxesz00_10716); 
PROCEDURE_SET(BgL_runz00_12895, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10717)); 
PROCEDURE_SET(BgL_runz00_12895, 
(int)(((long)2)), BgL_valza2za2_12894); 
PROCEDURE_SET(BgL_runz00_12895, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10718)); 
PROCEDURE_SET(BgL_runz00_12895, 
(int)(((long)4)), BgL_bodyz00_10719); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12896;
BgL_mainz00_12896 = 
MAKE_VA_PROCEDURE(BGl_z62main4182z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_12896, 
(int)(((long)0)), BgL_iboxesz00_10716); 
PROCEDURE_SET(BgL_mainz00_12896, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10717)); 
PROCEDURE_SET(BgL_mainz00_12896, 
(int)(((long)2)), BgL_valza2za2_12894); 
PROCEDURE_SET(BgL_mainz00_12896, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10718)); 
PROCEDURE_SET(BgL_mainz00_12896, 
(int)(((long)4)), BgL_bodyz00_10719); 
PROCEDURE_SET(BgL_mainz00_12896, 
(int)(((long)5)), BgL_runz00_12895); 
PROCEDURE_SET(BgL_mainz00_12896, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_10720)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12897;
BgL_objz00_12897 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12895, BgL_objz00_12897); BgL_objz00_12897; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3507z00_12898;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3508z00_12899;
BgL_arg3508z00_12899 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10718))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12900;
BgL_newz00_12900 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22941;
BgL_tmpz00_22941 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12900, BgL_tmpz00_22941, BgL_arg3508z00_12899); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22946;int BgL_tmpz00_22944;
BgL_auxz00_22946 = 
BINT(BgL_siza7ezd2framez75_10720); 
BgL_tmpz00_22944 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12900, BgL_tmpz00_22944, BgL_auxz00_22946); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22949;
BgL_tmpz00_22949 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12900, BgL_tmpz00_22949, BgL_runz00_12895); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22954;int BgL_tmpz00_22952;
BgL_auxz00_22954 = 
BINT(((long)-4)); 
BgL_tmpz00_22952 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12900, BgL_tmpz00_22952, BgL_auxz00_22954); } 
BgL_arg3507z00_12898 = BgL_newz00_12900; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12896, BgL_arg3507z00_12898); BgL_arg3507z00_12898; } 
return BgL_mainz00_12896;} } } } } } 

}



/* &main4182 */
obj_t BGl_z62main4182z62zz__evaluate_compz00(obj_t BgL_envz00_10722, obj_t BgL_bz00_10730, obj_t BgL_cz00_10731, obj_t BgL_dz00_10732, obj_t BgL_lastz00_10733)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10728;long BgL_siza7ezd2framez75_10729;
BgL_runz00_10728 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10722, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_10729 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10722, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12901;
BgL_sz00_12901 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12902;
BgL_bpz00_12902 = 
VECTOR_REF(
((obj_t)BgL_sz00_12901),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12901, BgL_bpz00_12902, 
BINT(BgL_siza7ezd2framez75_10729)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3511z00_12903;
BgL_arg3511z00_12903 = 
(
(long)CINT(BgL_bpz00_12902)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12901),BgL_arg3511z00_12903,BgL_bz00_10730); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3512z00_12904;
BgL_arg3512z00_12904 = 
(
(long)CINT(BgL_bpz00_12902)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12901),BgL_arg3512z00_12904,BgL_cz00_10731); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3513z00_12905;
BgL_arg3513z00_12905 = 
(
(long)CINT(BgL_bpz00_12902)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12901),BgL_arg3513z00_12905,BgL_dz00_10732); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3514z00_12906;
BgL_arg3514z00_12906 = 
(
(long)CINT(BgL_bpz00_12902)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_12901),BgL_arg3514z00_12906,BgL_lastz00_10733); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12907;
BgL_ez00_12907 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12907, BgL_bpz00_12902); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12908;
BgL_accz00_12908 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10728, BgL_sz00_12901, BgL_bpz00_12902); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12907); 
VECTOR_SET(
((obj_t)BgL_sz00_12901),((long)0),BgL_bpz00_12902); 
return BgL_accz00_12908;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12909;
BgL_nsz00_12909 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12909,((long)1),BgL_sz00_12901); 
VECTOR_SET(BgL_nsz00_12909,((long)2),BgL_bz00_10730); 
VECTOR_SET(BgL_nsz00_12909,((long)3),BgL_cz00_10731); 
VECTOR_SET(BgL_nsz00_12909,((long)4),BgL_dz00_10732); 
VECTOR_SET(BgL_nsz00_12909,((long)5),BgL_lastz00_10733); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12910;
BgL_z12denvz12_12910 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12910, BgL_nsz00_12909); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12911;
BgL_ez00_12911 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12911, BgL_sz00_12901); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12912;
BgL_____rz00_12912 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10728, BgL_nsz00_12909, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12911); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12910, BgL_sz00_12901); 
return BgL_____rz00_12912;} } } } } } } } 

}



/* &run4183 */
obj_t BGl_z62run4183z62zz__evaluate_compz00(obj_t BgL_envz00_10734, obj_t BgL_sz00_10740)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10735;long BgL_siza7eza7_10736;obj_t BgL_valza2za2_10737;BgL_ev_absz00_bglt BgL_i1244z00_10738;obj_t BgL_bodyz00_10739;
BgL_iboxesz00_10735 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10734, 
(int)(((long)0)))); 
BgL_siza7eza7_10736 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10734, 
(int)(((long)1)))); 
BgL_valza2za2_10737 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10734, 
(int)(((long)2)))); 
BgL_i1244z00_10738 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10734, 
(int)(((long)3)))); 
BgL_bodyz00_10739 = 
PROCEDURE_REF(BgL_envz00_10734, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12913;
BgL_bpz00_12913 = 
VECTOR_REF(
((obj_t)BgL_sz00_10740),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10740, BgL_iboxesz00_10735, BgL_bpz00_12913); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10740, BgL_valza2za2_10737, 
(
(long)CINT(BgL_bpz00_12913)+BgL_siza7eza7_10736)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_12914;obj_t BgL_wherez00_12915;obj_t BgL_locz00_12916;
BgL_z12denvz12_12914 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12915 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10738))->BgL_wherez00); 
BgL_locz00_12916 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10738))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12914, BgL_wherez00_12915, BgL_locz00_12916); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_12917;
BgL_za2za2resza2za2z00_12917 = 
PROCEDURE_ENTRY(BgL_bodyz00_10739)(BgL_bodyz00_10739, BgL_sz00_10740, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12914); 
return BgL_za2za2resza2za2z00_12917;} } } } } } 

}



/* &<@anonymous:3425> */
obj_t BGl_z62zc3z04anonymousza33425ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10741, obj_t BgL_sz00_10745)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10742;obj_t BgL_bodyz00_10743;long BgL_siza7ezd2framez75_10744;
BgL_i1244z00_10742 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10741, 
(int)(((long)0)))); 
BgL_bodyz00_10743 = 
PROCEDURE_REF(BgL_envz00_10741, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_10744 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10741, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12918;
BgL_bpz00_12918 = 
VECTOR_REF(
((obj_t)BgL_sz00_10745),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12919;
BgL_runz00_12919 = 
MAKE_FX_PROCEDURE(BGl_z62run4185z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_12919, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10742)); 
PROCEDURE_SET(BgL_runz00_12919, 
(int)(((long)1)), BgL_bodyz00_10743); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12920;
BgL_mainz00_12920 = 
MAKE_FX_PROCEDURE(BGl_z62main4184z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_12920, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10742)); 
PROCEDURE_SET(BgL_mainz00_12920, 
(int)(((long)1)), BgL_bodyz00_10743); 
PROCEDURE_SET(BgL_mainz00_12920, 
(int)(((long)2)), BgL_runz00_12919); 
PROCEDURE_SET(BgL_mainz00_12920, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_10744)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12921;
BgL_objz00_12921 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12919, BgL_objz00_12921); BgL_objz00_12921; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3426z00_12922;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3427z00_12923;
BgL_arg3427z00_12923 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10742))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12924;
BgL_newz00_12924 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23070;
BgL_tmpz00_23070 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12924, BgL_tmpz00_23070, BgL_arg3427z00_12923); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23075;int BgL_tmpz00_23073;
BgL_auxz00_23075 = 
BINT(BgL_siza7ezd2framez75_10744); 
BgL_tmpz00_23073 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12924, BgL_tmpz00_23073, BgL_auxz00_23075); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23078;
BgL_tmpz00_23078 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12924, BgL_tmpz00_23078, BgL_runz00_12919); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23083;int BgL_tmpz00_23081;
BgL_auxz00_23083 = 
BINT(((long)3)); 
BgL_tmpz00_23081 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12924, BgL_tmpz00_23081, BgL_auxz00_23083); } 
BgL_arg3426z00_12922 = BgL_newz00_12924; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12920, BgL_arg3426z00_12922); BgL_arg3426z00_12922; } 
return BgL_mainz00_12920;} } } } } } 

}



/* &main4184 */
obj_t BGl_z62main4184z62zz__evaluate_compz00(obj_t BgL_envz00_10746, obj_t BgL_bz00_10751, obj_t BgL_cz00_10752, obj_t BgL_dz00_10753)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10749;long BgL_siza7ezd2framez75_10750;
BgL_runz00_10749 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10746, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_10750 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10746, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12925;
BgL_sz00_12925 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12926;
BgL_bpz00_12926 = 
VECTOR_REF(
((obj_t)BgL_sz00_12925),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12925, BgL_bpz00_12926, 
BINT(BgL_siza7ezd2framez75_10750)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3430z00_12927;
BgL_arg3430z00_12927 = 
(
(long)CINT(BgL_bpz00_12926)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12925),BgL_arg3430z00_12927,BgL_bz00_10751); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3431z00_12928;
BgL_arg3431z00_12928 = 
(
(long)CINT(BgL_bpz00_12926)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12925),BgL_arg3431z00_12928,BgL_cz00_10752); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3432z00_12929;
BgL_arg3432z00_12929 = 
(
(long)CINT(BgL_bpz00_12926)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12925),BgL_arg3432z00_12929,BgL_dz00_10753); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12930;
BgL_ez00_12930 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12930, BgL_bpz00_12926); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12931;
BgL_accz00_12931 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10749, BgL_sz00_12925, BgL_bpz00_12926); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12930); 
VECTOR_SET(
((obj_t)BgL_sz00_12925),((long)0),BgL_bpz00_12926); 
return BgL_accz00_12931;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12932;
BgL_nsz00_12932 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12932,((long)1),BgL_sz00_12925); 
VECTOR_SET(BgL_nsz00_12932,((long)2),BgL_bz00_10751); 
VECTOR_SET(BgL_nsz00_12932,((long)3),BgL_cz00_10752); 
VECTOR_SET(BgL_nsz00_12932,((long)4),BgL_dz00_10753); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12933;
BgL_z12denvz12_12933 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12933, BgL_nsz00_12932); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12934;
BgL_ez00_12934 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12934, BgL_sz00_12925); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12935;
BgL_____rz00_12935 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10749, BgL_nsz00_12932, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12934); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12933, BgL_sz00_12925); 
return BgL_____rz00_12935;} } } } } } } } 

}



/* &run4185 */
obj_t BGl_z62run4185z62zz__evaluate_compz00(obj_t BgL_envz00_10754, obj_t BgL_sz00_10757)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10755;obj_t BgL_bodyz00_10756;
BgL_i1244z00_10755 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10754, 
(int)(((long)0)))); 
BgL_bodyz00_10756 = 
PROCEDURE_REF(BgL_envz00_10754, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12936;
BgL_bpz00_12936 = 
VECTOR_REF(
((obj_t)BgL_sz00_10757),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12937;obj_t BgL_wherez00_12938;obj_t BgL_locz00_12939;
BgL_z12denvz12_12937 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12938 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10755))->BgL_wherez00); 
BgL_locz00_12939 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10755))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12937, BgL_wherez00_12938, BgL_locz00_12939); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_12940;
BgL_za2za2resza2za2z00_12940 = 
PROCEDURE_ENTRY(BgL_bodyz00_10756)(BgL_bodyz00_10756, BgL_sz00_10757, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12937); 
return BgL_za2za2resza2za2z00_12940;} } } } } } 

}



/* &<@anonymous:3434> */
obj_t BGl_z62zc3z04anonymousza33434ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10758, obj_t BgL_sz00_10763)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10759;BgL_ev_absz00_bglt BgL_i1244z00_10760;obj_t BgL_bodyz00_10761;long BgL_siza7ezd2framez75_10762;
BgL_iboxesz00_10759 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)0)))); 
BgL_i1244z00_10760 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)1)))); 
BgL_bodyz00_10761 = 
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_10762 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12941;
BgL_bpz00_12941 = 
VECTOR_REF(
((obj_t)BgL_sz00_10763),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12942;
BgL_runz00_12942 = 
MAKE_FX_PROCEDURE(BGl_z62run4187z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_12942, 
(int)(((long)0)), BgL_iboxesz00_10759); 
PROCEDURE_SET(BgL_runz00_12942, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10760)); 
PROCEDURE_SET(BgL_runz00_12942, 
(int)(((long)2)), BgL_bodyz00_10761); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12943;
BgL_mainz00_12943 = 
MAKE_FX_PROCEDURE(BGl_z62main4186z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_12943, 
(int)(((long)0)), BgL_iboxesz00_10759); 
PROCEDURE_SET(BgL_mainz00_12943, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10760)); 
PROCEDURE_SET(BgL_mainz00_12943, 
(int)(((long)2)), BgL_bodyz00_10761); 
PROCEDURE_SET(BgL_mainz00_12943, 
(int)(((long)3)), BgL_runz00_12942); 
PROCEDURE_SET(BgL_mainz00_12943, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_10762)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12944;
BgL_objz00_12944 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12942, BgL_objz00_12944); BgL_objz00_12944; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3435z00_12945;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3436z00_12946;
BgL_arg3436z00_12946 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10760))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12947;
BgL_newz00_12947 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23188;
BgL_tmpz00_23188 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12947, BgL_tmpz00_23188, BgL_arg3436z00_12946); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23193;int BgL_tmpz00_23191;
BgL_auxz00_23193 = 
BINT(BgL_siza7ezd2framez75_10762); 
BgL_tmpz00_23191 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12947, BgL_tmpz00_23191, BgL_auxz00_23193); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23196;
BgL_tmpz00_23196 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12947, BgL_tmpz00_23196, BgL_runz00_12942); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23201;int BgL_tmpz00_23199;
BgL_auxz00_23201 = 
BINT(((long)3)); 
BgL_tmpz00_23199 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12947, BgL_tmpz00_23199, BgL_auxz00_23201); } 
BgL_arg3435z00_12945 = BgL_newz00_12947; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12943, BgL_arg3435z00_12945); BgL_arg3435z00_12945; } 
return BgL_mainz00_12943;} } } } } } 

}



/* &main4186 */
obj_t BGl_z62main4186z62zz__evaluate_compz00(obj_t BgL_envz00_10764, obj_t BgL_bz00_10770, obj_t BgL_cz00_10771, obj_t BgL_dz00_10772)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10768;long BgL_siza7ezd2framez75_10769;
BgL_runz00_10768 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10764, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_10769 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10764, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12948;
BgL_sz00_12948 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12949;
BgL_bpz00_12949 = 
VECTOR_REF(
((obj_t)BgL_sz00_12948),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12948, BgL_bpz00_12949, 
BINT(BgL_siza7ezd2framez75_10769)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3439z00_12950;
BgL_arg3439z00_12950 = 
(
(long)CINT(BgL_bpz00_12949)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12948),BgL_arg3439z00_12950,BgL_bz00_10770); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3440z00_12951;
BgL_arg3440z00_12951 = 
(
(long)CINT(BgL_bpz00_12949)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12948),BgL_arg3440z00_12951,BgL_cz00_10771); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3441z00_12952;
BgL_arg3441z00_12952 = 
(
(long)CINT(BgL_bpz00_12949)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12948),BgL_arg3441z00_12952,BgL_dz00_10772); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12953;
BgL_ez00_12953 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12953, BgL_bpz00_12949); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12954;
BgL_accz00_12954 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10768, BgL_sz00_12948, BgL_bpz00_12949); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12953); 
VECTOR_SET(
((obj_t)BgL_sz00_12948),((long)0),BgL_bpz00_12949); 
return BgL_accz00_12954;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12955;
BgL_nsz00_12955 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12955,((long)1),BgL_sz00_12948); 
VECTOR_SET(BgL_nsz00_12955,((long)2),BgL_bz00_10770); 
VECTOR_SET(BgL_nsz00_12955,((long)3),BgL_cz00_10771); 
VECTOR_SET(BgL_nsz00_12955,((long)4),BgL_dz00_10772); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12956;
BgL_z12denvz12_12956 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12956, BgL_nsz00_12955); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12957;
BgL_ez00_12957 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12957, BgL_sz00_12948); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12958;
BgL_____rz00_12958 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10768, BgL_nsz00_12955, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12957); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12956, BgL_sz00_12948); 
return BgL_____rz00_12958;} } } } } } } } 

}



/* &run4187 */
obj_t BGl_z62run4187z62zz__evaluate_compz00(obj_t BgL_envz00_10773, obj_t BgL_sz00_10777)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10774;BgL_ev_absz00_bglt BgL_i1244z00_10775;obj_t BgL_bodyz00_10776;
BgL_iboxesz00_10774 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10773, 
(int)(((long)0)))); 
BgL_i1244z00_10775 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10773, 
(int)(((long)1)))); 
BgL_bodyz00_10776 = 
PROCEDURE_REF(BgL_envz00_10773, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12959;
BgL_bpz00_12959 = 
VECTOR_REF(
((obj_t)BgL_sz00_10777),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10777, BgL_iboxesz00_10774, BgL_bpz00_12959); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12960;obj_t BgL_wherez00_12961;obj_t BgL_locz00_12962;
BgL_z12denvz12_12960 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12961 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10775))->BgL_wherez00); 
BgL_locz00_12962 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10775))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12960, BgL_wherez00_12961, BgL_locz00_12962); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_12963;
BgL_za2za2resza2za2z00_12963 = 
PROCEDURE_ENTRY(BgL_bodyz00_10776)(BgL_bodyz00_10776, BgL_sz00_10777, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12960); 
return BgL_za2za2resza2za2z00_12963;} } } } } } 

}



/* &<@anonymous:3446> */
obj_t BGl_z62zc3z04anonymousza33446ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10778, obj_t BgL_sz00_10784)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10779;long BgL_siza7eza7_10780;BgL_ev_absz00_bglt BgL_i1244z00_10781;obj_t BgL_bodyz00_10782;long BgL_siza7ezd2framez75_10783;
BgL_ifreesz00_10779 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10778, 
(int)(((long)0)))); 
BgL_siza7eza7_10780 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10778, 
(int)(((long)1)))); 
BgL_i1244z00_10781 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10778, 
(int)(((long)2)))); 
BgL_bodyz00_10782 = 
PROCEDURE_REF(BgL_envz00_10778, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_10783 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10778, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12964;
BgL_bpz00_12964 = 
VECTOR_REF(
((obj_t)BgL_sz00_10784),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_12965;
BgL_valza2za2_12965 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10784, BgL_bpz00_12964, BgL_ifreesz00_10779); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12966;
BgL_runz00_12966 = 
MAKE_FX_PROCEDURE(BGl_z62run4189z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_12966, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10780)); 
PROCEDURE_SET(BgL_runz00_12966, 
(int)(((long)1)), BgL_valza2za2_12965); 
PROCEDURE_SET(BgL_runz00_12966, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10781)); 
PROCEDURE_SET(BgL_runz00_12966, 
(int)(((long)3)), BgL_bodyz00_10782); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12967;
BgL_mainz00_12967 = 
MAKE_FX_PROCEDURE(BGl_z62main4188z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_12967, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10780)); 
PROCEDURE_SET(BgL_mainz00_12967, 
(int)(((long)1)), BgL_valza2za2_12965); 
PROCEDURE_SET(BgL_mainz00_12967, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10781)); 
PROCEDURE_SET(BgL_mainz00_12967, 
(int)(((long)3)), BgL_bodyz00_10782); 
PROCEDURE_SET(BgL_mainz00_12967, 
(int)(((long)4)), BgL_runz00_12966); 
PROCEDURE_SET(BgL_mainz00_12967, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_10783)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12968;
BgL_objz00_12968 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12966, BgL_objz00_12968); BgL_objz00_12968; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3447z00_12969;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3448z00_12970;
BgL_arg3448z00_12970 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10781))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12971;
BgL_newz00_12971 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23320;
BgL_tmpz00_23320 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12971, BgL_tmpz00_23320, BgL_arg3448z00_12970); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23325;int BgL_tmpz00_23323;
BgL_auxz00_23325 = 
BINT(BgL_siza7ezd2framez75_10783); 
BgL_tmpz00_23323 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12971, BgL_tmpz00_23323, BgL_auxz00_23325); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23328;
BgL_tmpz00_23328 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12971, BgL_tmpz00_23328, BgL_runz00_12966); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23333;int BgL_tmpz00_23331;
BgL_auxz00_23333 = 
BINT(((long)3)); 
BgL_tmpz00_23331 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12971, BgL_tmpz00_23331, BgL_auxz00_23333); } 
BgL_arg3447z00_12969 = BgL_newz00_12971; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12967, BgL_arg3447z00_12969); BgL_arg3447z00_12969; } 
return BgL_mainz00_12967;} } } } } } 

}



/* &main4188 */
obj_t BGl_z62main4188z62zz__evaluate_compz00(obj_t BgL_envz00_10785, obj_t BgL_bz00_10792, obj_t BgL_cz00_10793, obj_t BgL_dz00_10794)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10790;long BgL_siza7ezd2framez75_10791;
BgL_runz00_10790 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10785, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_10791 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10785, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12972;
BgL_sz00_12972 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12973;
BgL_bpz00_12973 = 
VECTOR_REF(
((obj_t)BgL_sz00_12972),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12972, BgL_bpz00_12973, 
BINT(BgL_siza7ezd2framez75_10791)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3451z00_12974;
BgL_arg3451z00_12974 = 
(
(long)CINT(BgL_bpz00_12973)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12972),BgL_arg3451z00_12974,BgL_bz00_10792); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3452z00_12975;
BgL_arg3452z00_12975 = 
(
(long)CINT(BgL_bpz00_12973)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12972),BgL_arg3452z00_12975,BgL_cz00_10793); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3453z00_12976;
BgL_arg3453z00_12976 = 
(
(long)CINT(BgL_bpz00_12973)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12972),BgL_arg3453z00_12976,BgL_dz00_10794); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12977;
BgL_ez00_12977 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12977, BgL_bpz00_12973); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_12978;
BgL_accz00_12978 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10790, BgL_sz00_12972, BgL_bpz00_12973); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12977); 
VECTOR_SET(
((obj_t)BgL_sz00_12972),((long)0),BgL_bpz00_12973); 
return BgL_accz00_12978;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_12979;
BgL_nsz00_12979 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_12979,((long)1),BgL_sz00_12972); 
VECTOR_SET(BgL_nsz00_12979,((long)2),BgL_bz00_10792); 
VECTOR_SET(BgL_nsz00_12979,((long)3),BgL_cz00_10793); 
VECTOR_SET(BgL_nsz00_12979,((long)4),BgL_dz00_10794); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_12980;
BgL_z12denvz12_12980 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12980, BgL_nsz00_12979); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_12981;
BgL_ez00_12981 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12981, BgL_sz00_12972); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_12982;
BgL_____rz00_12982 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10790, BgL_nsz00_12979, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12981); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12980, BgL_sz00_12972); 
return BgL_____rz00_12982;} } } } } } } } 

}



/* &run4189 */
obj_t BGl_z62run4189z62zz__evaluate_compz00(obj_t BgL_envz00_10795, obj_t BgL_sz00_10800)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_10796;obj_t BgL_valza2za2_10797;BgL_ev_absz00_bglt BgL_i1244z00_10798;obj_t BgL_bodyz00_10799;
BgL_siza7eza7_10796 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10795, 
(int)(((long)0)))); 
BgL_valza2za2_10797 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10795, 
(int)(((long)1)))); 
BgL_i1244z00_10798 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10795, 
(int)(((long)2)))); 
BgL_bodyz00_10799 = 
PROCEDURE_REF(BgL_envz00_10795, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12983;
BgL_bpz00_12983 = 
VECTOR_REF(
((obj_t)BgL_sz00_10800),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10800, BgL_valza2za2_10797, 
(
(long)CINT(BgL_bpz00_12983)+BgL_siza7eza7_10796)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_12984;obj_t BgL_wherez00_12985;obj_t BgL_locz00_12986;
BgL_z12denvz12_12984 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_12985 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10798))->BgL_wherez00); 
BgL_locz00_12986 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10798))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_12984, BgL_wherez00_12985, BgL_locz00_12986); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_12987;
BgL_za2za2resza2za2z00_12987 = 
PROCEDURE_ENTRY(BgL_bodyz00_10799)(BgL_bodyz00_10799, BgL_sz00_10800, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_12984); 
return BgL_za2za2resza2za2z00_12987;} } } } } } 

}



/* &<@anonymous:3456> */
obj_t BGl_z62zc3z04anonymousza33456ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10801, obj_t BgL_sz00_10808)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10802;obj_t BgL_iboxesz00_10803;long BgL_siza7eza7_10804;BgL_ev_absz00_bglt BgL_i1244z00_10805;obj_t BgL_bodyz00_10806;long BgL_siza7ezd2framez75_10807;
BgL_ifreesz00_10802 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)0)))); 
BgL_iboxesz00_10803 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)1)))); 
BgL_siza7eza7_10804 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)2)))); 
BgL_i1244z00_10805 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)3)))); 
BgL_bodyz00_10806 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_10807 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12988;
BgL_bpz00_12988 = 
VECTOR_REF(
((obj_t)BgL_sz00_10808),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_12989;
BgL_valza2za2_12989 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10808, BgL_bpz00_12988, BgL_ifreesz00_10802); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12990;
BgL_runz00_12990 = 
MAKE_FX_PROCEDURE(BGl_z62run4191z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_12990, 
(int)(((long)0)), BgL_iboxesz00_10803); 
PROCEDURE_SET(BgL_runz00_12990, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10804)); 
PROCEDURE_SET(BgL_runz00_12990, 
(int)(((long)2)), BgL_valza2za2_12989); 
PROCEDURE_SET(BgL_runz00_12990, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10805)); 
PROCEDURE_SET(BgL_runz00_12990, 
(int)(((long)4)), BgL_bodyz00_10806); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_12991;
BgL_mainz00_12991 = 
MAKE_FX_PROCEDURE(BGl_z62main4190z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_12991, 
(int)(((long)0)), BgL_iboxesz00_10803); 
PROCEDURE_SET(BgL_mainz00_12991, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10804)); 
PROCEDURE_SET(BgL_mainz00_12991, 
(int)(((long)2)), BgL_valza2za2_12989); 
PROCEDURE_SET(BgL_mainz00_12991, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10805)); 
PROCEDURE_SET(BgL_mainz00_12991, 
(int)(((long)4)), BgL_bodyz00_10806); 
PROCEDURE_SET(BgL_mainz00_12991, 
(int)(((long)5)), BgL_runz00_12990); 
PROCEDURE_SET(BgL_mainz00_12991, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_10807)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_12992;
BgL_objz00_12992 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_12990, BgL_objz00_12992); BgL_objz00_12992; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3457z00_12993;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3458z00_12994;
BgL_arg3458z00_12994 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10805))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_12995;
BgL_newz00_12995 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23464;
BgL_tmpz00_23464 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_12995, BgL_tmpz00_23464, BgL_arg3458z00_12994); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23469;int BgL_tmpz00_23467;
BgL_auxz00_23469 = 
BINT(BgL_siza7ezd2framez75_10807); 
BgL_tmpz00_23467 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_12995, BgL_tmpz00_23467, BgL_auxz00_23469); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23472;
BgL_tmpz00_23472 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_12995, BgL_tmpz00_23472, BgL_runz00_12990); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23477;int BgL_tmpz00_23475;
BgL_auxz00_23477 = 
BINT(((long)3)); 
BgL_tmpz00_23475 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_12995, BgL_tmpz00_23475, BgL_auxz00_23477); } 
BgL_arg3457z00_12993 = BgL_newz00_12995; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_12991, BgL_arg3457z00_12993); BgL_arg3457z00_12993; } 
return BgL_mainz00_12991;} } } } } } 

}



/* &main4190 */
obj_t BGl_z62main4190z62zz__evaluate_compz00(obj_t BgL_envz00_10809, obj_t BgL_bz00_10817, obj_t BgL_cz00_10818, obj_t BgL_dz00_10819)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10815;long BgL_siza7ezd2framez75_10816;
BgL_runz00_10815 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_10816 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_12996;
BgL_sz00_12996 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_12997;
BgL_bpz00_12997 = 
VECTOR_REF(
((obj_t)BgL_sz00_12996),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_12996, BgL_bpz00_12997, 
BINT(BgL_siza7ezd2framez75_10816)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3461z00_12998;
BgL_arg3461z00_12998 = 
(
(long)CINT(BgL_bpz00_12997)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_12996),BgL_arg3461z00_12998,BgL_bz00_10817); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3462z00_12999;
BgL_arg3462z00_12999 = 
(
(long)CINT(BgL_bpz00_12997)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_12996),BgL_arg3462z00_12999,BgL_cz00_10818); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3463z00_13000;
BgL_arg3463z00_13000 = 
(
(long)CINT(BgL_bpz00_12997)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_12996),BgL_arg3463z00_13000,BgL_dz00_10819); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13001;
BgL_ez00_13001 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13001, BgL_bpz00_12997); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13002;
BgL_accz00_13002 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10815, BgL_sz00_12996, BgL_bpz00_12997); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13001); 
VECTOR_SET(
((obj_t)BgL_sz00_12996),((long)0),BgL_bpz00_12997); 
return BgL_accz00_13002;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13003;
BgL_nsz00_13003 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13003,((long)1),BgL_sz00_12996); 
VECTOR_SET(BgL_nsz00_13003,((long)2),BgL_bz00_10817); 
VECTOR_SET(BgL_nsz00_13003,((long)3),BgL_cz00_10818); 
VECTOR_SET(BgL_nsz00_13003,((long)4),BgL_dz00_10819); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13004;
BgL_z12denvz12_13004 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13004, BgL_nsz00_13003); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13005;
BgL_ez00_13005 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13005, BgL_sz00_12996); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13006;
BgL_____rz00_13006 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10815, BgL_nsz00_13003, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13005); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13004, BgL_sz00_12996); 
return BgL_____rz00_13006;} } } } } } } } 

}



/* &run4191 */
obj_t BGl_z62run4191z62zz__evaluate_compz00(obj_t BgL_envz00_10820, obj_t BgL_sz00_10826)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10821;long BgL_siza7eza7_10822;obj_t BgL_valza2za2_10823;BgL_ev_absz00_bglt BgL_i1244z00_10824;obj_t BgL_bodyz00_10825;
BgL_iboxesz00_10821 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10820, 
(int)(((long)0)))); 
BgL_siza7eza7_10822 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10820, 
(int)(((long)1)))); 
BgL_valza2za2_10823 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10820, 
(int)(((long)2)))); 
BgL_i1244z00_10824 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10820, 
(int)(((long)3)))); 
BgL_bodyz00_10825 = 
PROCEDURE_REF(BgL_envz00_10820, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13007;
BgL_bpz00_13007 = 
VECTOR_REF(
((obj_t)BgL_sz00_10826),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10826, BgL_iboxesz00_10821, BgL_bpz00_13007); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10826, BgL_valza2za2_10823, 
(
(long)CINT(BgL_bpz00_13007)+BgL_siza7eza7_10822)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13008;obj_t BgL_wherez00_13009;obj_t BgL_locz00_13010;
BgL_z12denvz12_13008 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13009 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10824))->BgL_wherez00); 
BgL_locz00_13010 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10824))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13008, BgL_wherez00_13009, BgL_locz00_13010); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13011;
BgL_za2za2resza2za2z00_13011 = 
PROCEDURE_ENTRY(BgL_bodyz00_10825)(BgL_bodyz00_10825, BgL_sz00_10826, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13008); 
return BgL_za2za2resza2za2z00_13011;} } } } } } 

}



/* &<@anonymous:3378> */
obj_t BGl_z62zc3z04anonymousza33378ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10827, obj_t BgL_sz00_10831)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10828;obj_t BgL_bodyz00_10829;long BgL_siza7ezd2framez75_10830;
BgL_i1244z00_10828 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10827, 
(int)(((long)0)))); 
BgL_bodyz00_10829 = 
PROCEDURE_REF(BgL_envz00_10827, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_10830 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10827, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13012;
BgL_bpz00_13012 = 
VECTOR_REF(
((obj_t)BgL_sz00_10831),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13013;
BgL_runz00_13013 = 
MAKE_FX_PROCEDURE(BGl_z62run4193z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13013, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10828)); 
PROCEDURE_SET(BgL_runz00_13013, 
(int)(((long)1)), BgL_bodyz00_10829); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13014;
BgL_mainz00_13014 = 
MAKE_VA_PROCEDURE(BGl_z62main4192z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13014, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10828)); 
PROCEDURE_SET(BgL_mainz00_13014, 
(int)(((long)1)), BgL_bodyz00_10829); 
PROCEDURE_SET(BgL_mainz00_13014, 
(int)(((long)2)), BgL_runz00_13013); 
PROCEDURE_SET(BgL_mainz00_13014, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_10830)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13015;
BgL_objz00_13015 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13013, BgL_objz00_13015); BgL_objz00_13015; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3379z00_13016;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3380z00_13017;
BgL_arg3380z00_13017 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10828))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13018;
BgL_newz00_13018 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23588;
BgL_tmpz00_23588 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13018, BgL_tmpz00_23588, BgL_arg3380z00_13017); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23593;int BgL_tmpz00_23591;
BgL_auxz00_23593 = 
BINT(BgL_siza7ezd2framez75_10830); 
BgL_tmpz00_23591 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13018, BgL_tmpz00_23591, BgL_auxz00_23593); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23596;
BgL_tmpz00_23596 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13018, BgL_tmpz00_23596, BgL_runz00_13013); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23601;int BgL_tmpz00_23599;
BgL_auxz00_23601 = 
BINT(((long)-3)); 
BgL_tmpz00_23599 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13018, BgL_tmpz00_23599, BgL_auxz00_23601); } 
BgL_arg3379z00_13016 = BgL_newz00_13018; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13014, BgL_arg3379z00_13016); BgL_arg3379z00_13016; } 
return BgL_mainz00_13014;} } } } } } 

}



/* &main4192 */
obj_t BGl_z62main4192z62zz__evaluate_compz00(obj_t BgL_envz00_10832, obj_t BgL_cz00_10837, obj_t BgL_dz00_10838, obj_t BgL_lastz00_10839)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10835;long BgL_siza7ezd2framez75_10836;
BgL_runz00_10835 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10832, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_10836 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10832, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13019;
BgL_sz00_13019 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13020;
BgL_bpz00_13020 = 
VECTOR_REF(
((obj_t)BgL_sz00_13019),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13019, BgL_bpz00_13020, 
BINT(BgL_siza7ezd2framez75_10836)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3383z00_13021;
BgL_arg3383z00_13021 = 
(
(long)CINT(BgL_bpz00_13020)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13019),BgL_arg3383z00_13021,BgL_cz00_10837); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3384z00_13022;
BgL_arg3384z00_13022 = 
(
(long)CINT(BgL_bpz00_13020)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13019),BgL_arg3384z00_13022,BgL_dz00_10838); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3385z00_13023;
BgL_arg3385z00_13023 = 
(
(long)CINT(BgL_bpz00_13020)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13019),BgL_arg3385z00_13023,BgL_lastz00_10839); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13024;
BgL_ez00_13024 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13024, BgL_bpz00_13020); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13025;
BgL_accz00_13025 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10835, BgL_sz00_13019, BgL_bpz00_13020); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13024); 
VECTOR_SET(
((obj_t)BgL_sz00_13019),((long)0),BgL_bpz00_13020); 
return BgL_accz00_13025;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13026;
BgL_nsz00_13026 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13026,((long)1),BgL_sz00_13019); 
VECTOR_SET(BgL_nsz00_13026,((long)2),BgL_cz00_10837); 
VECTOR_SET(BgL_nsz00_13026,((long)3),BgL_dz00_10838); 
VECTOR_SET(BgL_nsz00_13026,((long)4),BgL_lastz00_10839); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13027;
BgL_z12denvz12_13027 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13027, BgL_nsz00_13026); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13028;
BgL_ez00_13028 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13028, BgL_sz00_13019); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13029;
BgL_____rz00_13029 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10835, BgL_nsz00_13026, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13028); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13027, BgL_sz00_13019); 
return BgL_____rz00_13029;} } } } } } } } 

}



/* &run4193 */
obj_t BGl_z62run4193z62zz__evaluate_compz00(obj_t BgL_envz00_10840, obj_t BgL_sz00_10843)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10841;obj_t BgL_bodyz00_10842;
BgL_i1244z00_10841 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10840, 
(int)(((long)0)))); 
BgL_bodyz00_10842 = 
PROCEDURE_REF(BgL_envz00_10840, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13030;
BgL_bpz00_13030 = 
VECTOR_REF(
((obj_t)BgL_sz00_10843),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13031;obj_t BgL_wherez00_13032;obj_t BgL_locz00_13033;
BgL_z12denvz12_13031 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13032 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10841))->BgL_wherez00); 
BgL_locz00_13033 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10841))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13031, BgL_wherez00_13032, BgL_locz00_13033); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13034;
BgL_za2za2resza2za2z00_13034 = 
PROCEDURE_ENTRY(BgL_bodyz00_10842)(BgL_bodyz00_10842, BgL_sz00_10843, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13031); 
return BgL_za2za2resza2za2z00_13034;} } } } } } 

}



/* &<@anonymous:3387> */
obj_t BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10844, obj_t BgL_sz00_10849)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10845;BgL_ev_absz00_bglt BgL_i1244z00_10846;obj_t BgL_bodyz00_10847;long BgL_siza7ezd2framez75_10848;
BgL_iboxesz00_10845 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10844, 
(int)(((long)0)))); 
BgL_i1244z00_10846 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10844, 
(int)(((long)1)))); 
BgL_bodyz00_10847 = 
PROCEDURE_REF(BgL_envz00_10844, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_10848 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10844, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13035;
BgL_bpz00_13035 = 
VECTOR_REF(
((obj_t)BgL_sz00_10849),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13036;
BgL_runz00_13036 = 
MAKE_FX_PROCEDURE(BGl_z62run4195z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13036, 
(int)(((long)0)), BgL_iboxesz00_10845); 
PROCEDURE_SET(BgL_runz00_13036, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10846)); 
PROCEDURE_SET(BgL_runz00_13036, 
(int)(((long)2)), BgL_bodyz00_10847); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13037;
BgL_mainz00_13037 = 
MAKE_VA_PROCEDURE(BGl_z62main4194z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13037, 
(int)(((long)0)), BgL_iboxesz00_10845); 
PROCEDURE_SET(BgL_mainz00_13037, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10846)); 
PROCEDURE_SET(BgL_mainz00_13037, 
(int)(((long)2)), BgL_bodyz00_10847); 
PROCEDURE_SET(BgL_mainz00_13037, 
(int)(((long)3)), BgL_runz00_13036); 
PROCEDURE_SET(BgL_mainz00_13037, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_10848)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13038;
BgL_objz00_13038 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13036, BgL_objz00_13038); BgL_objz00_13038; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3388z00_13039;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3389z00_13040;
BgL_arg3389z00_13040 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10846))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13041;
BgL_newz00_13041 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23706;
BgL_tmpz00_23706 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13041, BgL_tmpz00_23706, BgL_arg3389z00_13040); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23711;int BgL_tmpz00_23709;
BgL_auxz00_23711 = 
BINT(BgL_siza7ezd2framez75_10848); 
BgL_tmpz00_23709 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13041, BgL_tmpz00_23709, BgL_auxz00_23711); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23714;
BgL_tmpz00_23714 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13041, BgL_tmpz00_23714, BgL_runz00_13036); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23719;int BgL_tmpz00_23717;
BgL_auxz00_23719 = 
BINT(((long)-3)); 
BgL_tmpz00_23717 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13041, BgL_tmpz00_23717, BgL_auxz00_23719); } 
BgL_arg3388z00_13039 = BgL_newz00_13041; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13037, BgL_arg3388z00_13039); BgL_arg3388z00_13039; } 
return BgL_mainz00_13037;} } } } } } 

}



/* &main4194 */
obj_t BGl_z62main4194z62zz__evaluate_compz00(obj_t BgL_envz00_10850, obj_t BgL_cz00_10856, obj_t BgL_dz00_10857, obj_t BgL_lastz00_10858)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10854;long BgL_siza7ezd2framez75_10855;
BgL_runz00_10854 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10850, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_10855 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10850, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13042;
BgL_sz00_13042 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13043;
BgL_bpz00_13043 = 
VECTOR_REF(
((obj_t)BgL_sz00_13042),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13042, BgL_bpz00_13043, 
BINT(BgL_siza7ezd2framez75_10855)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3392z00_13044;
BgL_arg3392z00_13044 = 
(
(long)CINT(BgL_bpz00_13043)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13042),BgL_arg3392z00_13044,BgL_cz00_10856); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3393z00_13045;
BgL_arg3393z00_13045 = 
(
(long)CINT(BgL_bpz00_13043)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13042),BgL_arg3393z00_13045,BgL_dz00_10857); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3394z00_13046;
BgL_arg3394z00_13046 = 
(
(long)CINT(BgL_bpz00_13043)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13042),BgL_arg3394z00_13046,BgL_lastz00_10858); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13047;
BgL_ez00_13047 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13047, BgL_bpz00_13043); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13048;
BgL_accz00_13048 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10854, BgL_sz00_13042, BgL_bpz00_13043); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13047); 
VECTOR_SET(
((obj_t)BgL_sz00_13042),((long)0),BgL_bpz00_13043); 
return BgL_accz00_13048;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13049;
BgL_nsz00_13049 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13049,((long)1),BgL_sz00_13042); 
VECTOR_SET(BgL_nsz00_13049,((long)2),BgL_cz00_10856); 
VECTOR_SET(BgL_nsz00_13049,((long)3),BgL_dz00_10857); 
VECTOR_SET(BgL_nsz00_13049,((long)4),BgL_lastz00_10858); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13050;
BgL_z12denvz12_13050 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13050, BgL_nsz00_13049); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13051;
BgL_ez00_13051 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13051, BgL_sz00_13042); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13052;
BgL_____rz00_13052 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10854, BgL_nsz00_13049, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13051); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13050, BgL_sz00_13042); 
return BgL_____rz00_13052;} } } } } } } } 

}



/* &run4195 */
obj_t BGl_z62run4195z62zz__evaluate_compz00(obj_t BgL_envz00_10859, obj_t BgL_sz00_10863)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10860;BgL_ev_absz00_bglt BgL_i1244z00_10861;obj_t BgL_bodyz00_10862;
BgL_iboxesz00_10860 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10859, 
(int)(((long)0)))); 
BgL_i1244z00_10861 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10859, 
(int)(((long)1)))); 
BgL_bodyz00_10862 = 
PROCEDURE_REF(BgL_envz00_10859, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13053;
BgL_bpz00_13053 = 
VECTOR_REF(
((obj_t)BgL_sz00_10863),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10863, BgL_iboxesz00_10860, BgL_bpz00_13053); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13054;obj_t BgL_wherez00_13055;obj_t BgL_locz00_13056;
BgL_z12denvz12_13054 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13055 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10861))->BgL_wherez00); 
BgL_locz00_13056 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10861))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13054, BgL_wherez00_13055, BgL_locz00_13056); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13057;
BgL_za2za2resza2za2z00_13057 = 
PROCEDURE_ENTRY(BgL_bodyz00_10862)(BgL_bodyz00_10862, BgL_sz00_10863, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13054); 
return BgL_za2za2resza2za2z00_13057;} } } } } } 

}



/* &<@anonymous:3399> */
obj_t BGl_z62zc3z04anonymousza33399ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10864, obj_t BgL_sz00_10870)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10865;long BgL_siza7eza7_10866;BgL_ev_absz00_bglt BgL_i1244z00_10867;obj_t BgL_bodyz00_10868;long BgL_siza7ezd2framez75_10869;
BgL_ifreesz00_10865 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)0)))); 
BgL_siza7eza7_10866 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)1)))); 
BgL_i1244z00_10867 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)2)))); 
BgL_bodyz00_10868 = 
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_10869 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10864, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13058;
BgL_bpz00_13058 = 
VECTOR_REF(
((obj_t)BgL_sz00_10870),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13059;
BgL_valza2za2_13059 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10870, BgL_bpz00_13058, BgL_ifreesz00_10865); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13060;
BgL_runz00_13060 = 
MAKE_FX_PROCEDURE(BGl_z62run4197z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13060, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10866)); 
PROCEDURE_SET(BgL_runz00_13060, 
(int)(((long)1)), BgL_valza2za2_13059); 
PROCEDURE_SET(BgL_runz00_13060, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10867)); 
PROCEDURE_SET(BgL_runz00_13060, 
(int)(((long)3)), BgL_bodyz00_10868); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13061;
BgL_mainz00_13061 = 
MAKE_VA_PROCEDURE(BGl_z62main4196z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13061, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10866)); 
PROCEDURE_SET(BgL_mainz00_13061, 
(int)(((long)1)), BgL_valza2za2_13059); 
PROCEDURE_SET(BgL_mainz00_13061, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10867)); 
PROCEDURE_SET(BgL_mainz00_13061, 
(int)(((long)3)), BgL_bodyz00_10868); 
PROCEDURE_SET(BgL_mainz00_13061, 
(int)(((long)4)), BgL_runz00_13060); 
PROCEDURE_SET(BgL_mainz00_13061, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_10869)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13062;
BgL_objz00_13062 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13060, BgL_objz00_13062); BgL_objz00_13062; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3400z00_13063;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3401z00_13064;
BgL_arg3401z00_13064 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10867))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13065;
BgL_newz00_13065 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23838;
BgL_tmpz00_23838 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13065, BgL_tmpz00_23838, BgL_arg3401z00_13064); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23843;int BgL_tmpz00_23841;
BgL_auxz00_23843 = 
BINT(BgL_siza7ezd2framez75_10869); 
BgL_tmpz00_23841 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13065, BgL_tmpz00_23841, BgL_auxz00_23843); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23846;
BgL_tmpz00_23846 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13065, BgL_tmpz00_23846, BgL_runz00_13060); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23851;int BgL_tmpz00_23849;
BgL_auxz00_23851 = 
BINT(((long)-3)); 
BgL_tmpz00_23849 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13065, BgL_tmpz00_23849, BgL_auxz00_23851); } 
BgL_arg3400z00_13063 = BgL_newz00_13065; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13061, BgL_arg3400z00_13063); BgL_arg3400z00_13063; } 
return BgL_mainz00_13061;} } } } } } 

}



/* &main4196 */
obj_t BGl_z62main4196z62zz__evaluate_compz00(obj_t BgL_envz00_10871, obj_t BgL_cz00_10878, obj_t BgL_dz00_10879, obj_t BgL_lastz00_10880)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10876;long BgL_siza7ezd2framez75_10877;
BgL_runz00_10876 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10871, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_10877 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10871, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13066;
BgL_sz00_13066 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13067;
BgL_bpz00_13067 = 
VECTOR_REF(
((obj_t)BgL_sz00_13066),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13066, BgL_bpz00_13067, 
BINT(BgL_siza7ezd2framez75_10877)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3404z00_13068;
BgL_arg3404z00_13068 = 
(
(long)CINT(BgL_bpz00_13067)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13066),BgL_arg3404z00_13068,BgL_cz00_10878); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3405z00_13069;
BgL_arg3405z00_13069 = 
(
(long)CINT(BgL_bpz00_13067)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13066),BgL_arg3405z00_13069,BgL_dz00_10879); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3406z00_13070;
BgL_arg3406z00_13070 = 
(
(long)CINT(BgL_bpz00_13067)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13066),BgL_arg3406z00_13070,BgL_lastz00_10880); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13071;
BgL_ez00_13071 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13071, BgL_bpz00_13067); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13072;
BgL_accz00_13072 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10876, BgL_sz00_13066, BgL_bpz00_13067); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13071); 
VECTOR_SET(
((obj_t)BgL_sz00_13066),((long)0),BgL_bpz00_13067); 
return BgL_accz00_13072;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13073;
BgL_nsz00_13073 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13073,((long)1),BgL_sz00_13066); 
VECTOR_SET(BgL_nsz00_13073,((long)2),BgL_cz00_10878); 
VECTOR_SET(BgL_nsz00_13073,((long)3),BgL_dz00_10879); 
VECTOR_SET(BgL_nsz00_13073,((long)4),BgL_lastz00_10880); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13074;
BgL_z12denvz12_13074 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13074, BgL_nsz00_13073); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13075;
BgL_ez00_13075 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13075, BgL_sz00_13066); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13076;
BgL_____rz00_13076 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10876, BgL_nsz00_13073, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13075); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13074, BgL_sz00_13066); 
return BgL_____rz00_13076;} } } } } } } } 

}



/* &run4197 */
obj_t BGl_z62run4197z62zz__evaluate_compz00(obj_t BgL_envz00_10881, obj_t BgL_sz00_10886)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_10882;obj_t BgL_valza2za2_10883;BgL_ev_absz00_bglt BgL_i1244z00_10884;obj_t BgL_bodyz00_10885;
BgL_siza7eza7_10882 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)0)))); 
BgL_valza2za2_10883 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)1)))); 
BgL_i1244z00_10884 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)2)))); 
BgL_bodyz00_10885 = 
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13077;
BgL_bpz00_13077 = 
VECTOR_REF(
((obj_t)BgL_sz00_10886),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10886, BgL_valza2za2_10883, 
(
(long)CINT(BgL_bpz00_13077)+BgL_siza7eza7_10882)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13078;obj_t BgL_wherez00_13079;obj_t BgL_locz00_13080;
BgL_z12denvz12_13078 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13079 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10884))->BgL_wherez00); 
BgL_locz00_13080 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10884))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13078, BgL_wherez00_13079, BgL_locz00_13080); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13081;
BgL_za2za2resza2za2z00_13081 = 
PROCEDURE_ENTRY(BgL_bodyz00_10885)(BgL_bodyz00_10885, BgL_sz00_10886, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13078); 
return BgL_za2za2resza2za2z00_13081;} } } } } } 

}



/* &<@anonymous:3409> */
obj_t BGl_z62zc3z04anonymousza33409ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10887, obj_t BgL_sz00_10894)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10888;obj_t BgL_iboxesz00_10889;long BgL_siza7eza7_10890;BgL_ev_absz00_bglt BgL_i1244z00_10891;obj_t BgL_bodyz00_10892;long BgL_siza7ezd2framez75_10893;
BgL_ifreesz00_10888 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10887, 
(int)(((long)0)))); 
BgL_iboxesz00_10889 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10887, 
(int)(((long)1)))); 
BgL_siza7eza7_10890 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10887, 
(int)(((long)2)))); 
BgL_i1244z00_10891 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10887, 
(int)(((long)3)))); 
BgL_bodyz00_10892 = 
PROCEDURE_REF(BgL_envz00_10887, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_10893 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10887, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13082;
BgL_bpz00_13082 = 
VECTOR_REF(
((obj_t)BgL_sz00_10894),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13083;
BgL_valza2za2_13083 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10894, BgL_bpz00_13082, BgL_ifreesz00_10888); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13084;
BgL_runz00_13084 = 
MAKE_FX_PROCEDURE(BGl_z62run4199z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13084, 
(int)(((long)0)), BgL_iboxesz00_10889); 
PROCEDURE_SET(BgL_runz00_13084, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10890)); 
PROCEDURE_SET(BgL_runz00_13084, 
(int)(((long)2)), BgL_valza2za2_13083); 
PROCEDURE_SET(BgL_runz00_13084, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10891)); 
PROCEDURE_SET(BgL_runz00_13084, 
(int)(((long)4)), BgL_bodyz00_10892); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13085;
BgL_mainz00_13085 = 
MAKE_VA_PROCEDURE(BGl_z62main4198z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13085, 
(int)(((long)0)), BgL_iboxesz00_10889); 
PROCEDURE_SET(BgL_mainz00_13085, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10890)); 
PROCEDURE_SET(BgL_mainz00_13085, 
(int)(((long)2)), BgL_valza2za2_13083); 
PROCEDURE_SET(BgL_mainz00_13085, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10891)); 
PROCEDURE_SET(BgL_mainz00_13085, 
(int)(((long)4)), BgL_bodyz00_10892); 
PROCEDURE_SET(BgL_mainz00_13085, 
(int)(((long)5)), BgL_runz00_13084); 
PROCEDURE_SET(BgL_mainz00_13085, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_10893)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13086;
BgL_objz00_13086 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13084, BgL_objz00_13086); BgL_objz00_13086; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3410z00_13087;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3411z00_13088;
BgL_arg3411z00_13088 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10891))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13089;
BgL_newz00_13089 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23982;
BgL_tmpz00_23982 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13089, BgL_tmpz00_23982, BgL_arg3411z00_13088); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23987;int BgL_tmpz00_23985;
BgL_auxz00_23987 = 
BINT(BgL_siza7ezd2framez75_10893); 
BgL_tmpz00_23985 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13089, BgL_tmpz00_23985, BgL_auxz00_23987); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23990;
BgL_tmpz00_23990 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13089, BgL_tmpz00_23990, BgL_runz00_13084); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23995;int BgL_tmpz00_23993;
BgL_auxz00_23995 = 
BINT(((long)-3)); 
BgL_tmpz00_23993 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13089, BgL_tmpz00_23993, BgL_auxz00_23995); } 
BgL_arg3410z00_13087 = BgL_newz00_13089; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13085, BgL_arg3410z00_13087); BgL_arg3410z00_13087; } 
return BgL_mainz00_13085;} } } } } } 

}



/* &main4198 */
obj_t BGl_z62main4198z62zz__evaluate_compz00(obj_t BgL_envz00_10895, obj_t BgL_cz00_10903, obj_t BgL_dz00_10904, obj_t BgL_lastz00_10905)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10901;long BgL_siza7ezd2framez75_10902;
BgL_runz00_10901 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10895, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_10902 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10895, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13090;
BgL_sz00_13090 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13091;
BgL_bpz00_13091 = 
VECTOR_REF(
((obj_t)BgL_sz00_13090),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13090, BgL_bpz00_13091, 
BINT(BgL_siza7ezd2framez75_10902)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3414z00_13092;
BgL_arg3414z00_13092 = 
(
(long)CINT(BgL_bpz00_13091)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13090),BgL_arg3414z00_13092,BgL_cz00_10903); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3415z00_13093;
BgL_arg3415z00_13093 = 
(
(long)CINT(BgL_bpz00_13091)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13090),BgL_arg3415z00_13093,BgL_dz00_10904); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3416z00_13094;
BgL_arg3416z00_13094 = 
(
(long)CINT(BgL_bpz00_13091)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13090),BgL_arg3416z00_13094,BgL_lastz00_10905); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13095;
BgL_ez00_13095 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13095, BgL_bpz00_13091); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13096;
BgL_accz00_13096 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10901, BgL_sz00_13090, BgL_bpz00_13091); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13095); 
VECTOR_SET(
((obj_t)BgL_sz00_13090),((long)0),BgL_bpz00_13091); 
return BgL_accz00_13096;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13097;
BgL_nsz00_13097 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13097,((long)1),BgL_sz00_13090); 
VECTOR_SET(BgL_nsz00_13097,((long)2),BgL_cz00_10903); 
VECTOR_SET(BgL_nsz00_13097,((long)3),BgL_dz00_10904); 
VECTOR_SET(BgL_nsz00_13097,((long)4),BgL_lastz00_10905); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13098;
BgL_z12denvz12_13098 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13098, BgL_nsz00_13097); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13099;
BgL_ez00_13099 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13099, BgL_sz00_13090); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13100;
BgL_____rz00_13100 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10901, BgL_nsz00_13097, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13099); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13098, BgL_sz00_13090); 
return BgL_____rz00_13100;} } } } } } } } 

}



/* &run4199 */
obj_t BGl_z62run4199z62zz__evaluate_compz00(obj_t BgL_envz00_10906, obj_t BgL_sz00_10912)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10907;long BgL_siza7eza7_10908;obj_t BgL_valza2za2_10909;BgL_ev_absz00_bglt BgL_i1244z00_10910;obj_t BgL_bodyz00_10911;
BgL_iboxesz00_10907 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10906, 
(int)(((long)0)))); 
BgL_siza7eza7_10908 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10906, 
(int)(((long)1)))); 
BgL_valza2za2_10909 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10906, 
(int)(((long)2)))); 
BgL_i1244z00_10910 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10906, 
(int)(((long)3)))); 
BgL_bodyz00_10911 = 
PROCEDURE_REF(BgL_envz00_10906, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13101;
BgL_bpz00_13101 = 
VECTOR_REF(
((obj_t)BgL_sz00_10912),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10912, BgL_iboxesz00_10907, BgL_bpz00_13101); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10912, BgL_valza2za2_10909, 
(
(long)CINT(BgL_bpz00_13101)+BgL_siza7eza7_10908)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13102;obj_t BgL_wherez00_13103;obj_t BgL_locz00_13104;
BgL_z12denvz12_13102 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13103 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10910))->BgL_wherez00); 
BgL_locz00_13104 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10910))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13102, BgL_wherez00_13103, BgL_locz00_13104); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13105;
BgL_za2za2resza2za2z00_13105 = 
PROCEDURE_ENTRY(BgL_bodyz00_10911)(BgL_bodyz00_10911, BgL_sz00_10912, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13102); 
return BgL_za2za2resza2za2z00_13105;} } } } } } 

}



/* &<@anonymous:3335> */
obj_t BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10913, obj_t BgL_sz00_10917)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10914;obj_t BgL_bodyz00_10915;long BgL_siza7ezd2framez75_10916;
BgL_i1244z00_10914 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)0)))); 
BgL_bodyz00_10915 = 
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_10916 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13106;
BgL_bpz00_13106 = 
VECTOR_REF(
((obj_t)BgL_sz00_10917),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13107;
BgL_runz00_13107 = 
MAKE_FX_PROCEDURE(BGl_z62run4201z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13107, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10914)); 
PROCEDURE_SET(BgL_runz00_13107, 
(int)(((long)1)), BgL_bodyz00_10915); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13108;
BgL_mainz00_13108 = 
MAKE_FX_PROCEDURE(BGl_z62main4200z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13108, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10914)); 
PROCEDURE_SET(BgL_mainz00_13108, 
(int)(((long)1)), BgL_bodyz00_10915); 
PROCEDURE_SET(BgL_mainz00_13108, 
(int)(((long)2)), BgL_runz00_13107); 
PROCEDURE_SET(BgL_mainz00_13108, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_10916)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13109;
BgL_objz00_13109 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13107, BgL_objz00_13109); BgL_objz00_13109; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3336z00_13110;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3337z00_13111;
BgL_arg3337z00_13111 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10914))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13112;
BgL_newz00_13112 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24106;
BgL_tmpz00_24106 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13112, BgL_tmpz00_24106, BgL_arg3337z00_13111); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24111;int BgL_tmpz00_24109;
BgL_auxz00_24111 = 
BINT(BgL_siza7ezd2framez75_10916); 
BgL_tmpz00_24109 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13112, BgL_tmpz00_24109, BgL_auxz00_24111); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24114;
BgL_tmpz00_24114 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13112, BgL_tmpz00_24114, BgL_runz00_13107); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24119;int BgL_tmpz00_24117;
BgL_auxz00_24119 = 
BINT(((long)2)); 
BgL_tmpz00_24117 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13112, BgL_tmpz00_24117, BgL_auxz00_24119); } 
BgL_arg3336z00_13110 = BgL_newz00_13112; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13108, BgL_arg3336z00_13110); BgL_arg3336z00_13110; } 
return BgL_mainz00_13108;} } } } } } 

}



/* &main4200 */
obj_t BGl_z62main4200z62zz__evaluate_compz00(obj_t BgL_envz00_10918, obj_t BgL_cz00_10923, obj_t BgL_dz00_10924)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10921;long BgL_siza7ezd2framez75_10922;
BgL_runz00_10921 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10918, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_10922 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10918, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13113;
BgL_sz00_13113 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13114;
BgL_bpz00_13114 = 
VECTOR_REF(
((obj_t)BgL_sz00_13113),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13113, BgL_bpz00_13114, 
BINT(BgL_siza7ezd2framez75_10922)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3340z00_13115;
BgL_arg3340z00_13115 = 
(
(long)CINT(BgL_bpz00_13114)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13113),BgL_arg3340z00_13115,BgL_cz00_10923); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3341z00_13116;
BgL_arg3341z00_13116 = 
(
(long)CINT(BgL_bpz00_13114)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13113),BgL_arg3341z00_13116,BgL_dz00_10924); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13117;
BgL_ez00_13117 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13117, BgL_bpz00_13114); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13118;
BgL_accz00_13118 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10921, BgL_sz00_13113, BgL_bpz00_13114); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13117); 
VECTOR_SET(
((obj_t)BgL_sz00_13113),((long)0),BgL_bpz00_13114); 
return BgL_accz00_13118;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13119;
BgL_nsz00_13119 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13119,((long)1),BgL_sz00_13113); 
VECTOR_SET(BgL_nsz00_13119,((long)2),BgL_cz00_10923); 
VECTOR_SET(BgL_nsz00_13119,((long)3),BgL_dz00_10924); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13120;
BgL_z12denvz12_13120 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13120, BgL_nsz00_13119); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13121;
BgL_ez00_13121 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13121, BgL_sz00_13113); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13122;
BgL_____rz00_13122 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10921, BgL_nsz00_13119, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13121); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13120, BgL_sz00_13113); 
return BgL_____rz00_13122;} } } } } } } } 

}



/* &run4201 */
obj_t BGl_z62run4201z62zz__evaluate_compz00(obj_t BgL_envz00_10925, obj_t BgL_sz00_10928)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10926;obj_t BgL_bodyz00_10927;
BgL_i1244z00_10926 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)0)))); 
BgL_bodyz00_10927 = 
PROCEDURE_REF(BgL_envz00_10925, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13123;
BgL_bpz00_13123 = 
VECTOR_REF(
((obj_t)BgL_sz00_10928),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13124;obj_t BgL_wherez00_13125;obj_t BgL_locz00_13126;
BgL_z12denvz12_13124 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13125 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10926))->BgL_wherez00); 
BgL_locz00_13126 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10926))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13124, BgL_wherez00_13125, BgL_locz00_13126); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13127;
BgL_za2za2resza2za2z00_13127 = 
PROCEDURE_ENTRY(BgL_bodyz00_10927)(BgL_bodyz00_10927, BgL_sz00_10928, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13124); 
return BgL_za2za2resza2za2z00_13127;} } } } } } 

}



/* &<@anonymous:3343> */
obj_t BGl_z62zc3z04anonymousza33343ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10929, obj_t BgL_sz00_10934)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10930;BgL_ev_absz00_bglt BgL_i1244z00_10931;obj_t BgL_bodyz00_10932;long BgL_siza7ezd2framez75_10933;
BgL_iboxesz00_10930 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10929, 
(int)(((long)0)))); 
BgL_i1244z00_10931 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10929, 
(int)(((long)1)))); 
BgL_bodyz00_10932 = 
PROCEDURE_REF(BgL_envz00_10929, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_10933 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10929, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13128;
BgL_bpz00_13128 = 
VECTOR_REF(
((obj_t)BgL_sz00_10934),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13129;
BgL_runz00_13129 = 
MAKE_FX_PROCEDURE(BGl_z62run4203z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13129, 
(int)(((long)0)), BgL_iboxesz00_10930); 
PROCEDURE_SET(BgL_runz00_13129, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10931)); 
PROCEDURE_SET(BgL_runz00_13129, 
(int)(((long)2)), BgL_bodyz00_10932); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13130;
BgL_mainz00_13130 = 
MAKE_FX_PROCEDURE(BGl_z62main4202z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13130, 
(int)(((long)0)), BgL_iboxesz00_10930); 
PROCEDURE_SET(BgL_mainz00_13130, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_10931)); 
PROCEDURE_SET(BgL_mainz00_13130, 
(int)(((long)2)), BgL_bodyz00_10932); 
PROCEDURE_SET(BgL_mainz00_13130, 
(int)(((long)3)), BgL_runz00_13129); 
PROCEDURE_SET(BgL_mainz00_13130, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_10933)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13131;
BgL_objz00_13131 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13129, BgL_objz00_13131); BgL_objz00_13131; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3344z00_13132;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3345z00_13133;
BgL_arg3345z00_13133 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10931))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13134;
BgL_newz00_13134 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24219;
BgL_tmpz00_24219 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13134, BgL_tmpz00_24219, BgL_arg3345z00_13133); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24224;int BgL_tmpz00_24222;
BgL_auxz00_24224 = 
BINT(BgL_siza7ezd2framez75_10933); 
BgL_tmpz00_24222 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13134, BgL_tmpz00_24222, BgL_auxz00_24224); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24227;
BgL_tmpz00_24227 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13134, BgL_tmpz00_24227, BgL_runz00_13129); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24232;int BgL_tmpz00_24230;
BgL_auxz00_24232 = 
BINT(((long)2)); 
BgL_tmpz00_24230 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13134, BgL_tmpz00_24230, BgL_auxz00_24232); } 
BgL_arg3344z00_13132 = BgL_newz00_13134; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13130, BgL_arg3344z00_13132); BgL_arg3344z00_13132; } 
return BgL_mainz00_13130;} } } } } } 

}



/* &main4202 */
obj_t BGl_z62main4202z62zz__evaluate_compz00(obj_t BgL_envz00_10935, obj_t BgL_cz00_10941, obj_t BgL_dz00_10942)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10939;long BgL_siza7ezd2framez75_10940;
BgL_runz00_10939 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_10940 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10935, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13135;
BgL_sz00_13135 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13136;
BgL_bpz00_13136 = 
VECTOR_REF(
((obj_t)BgL_sz00_13135),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13135, BgL_bpz00_13136, 
BINT(BgL_siza7ezd2framez75_10940)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3348z00_13137;
BgL_arg3348z00_13137 = 
(
(long)CINT(BgL_bpz00_13136)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13135),BgL_arg3348z00_13137,BgL_cz00_10941); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3349z00_13138;
BgL_arg3349z00_13138 = 
(
(long)CINT(BgL_bpz00_13136)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13135),BgL_arg3349z00_13138,BgL_dz00_10942); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13139;
BgL_ez00_13139 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13139, BgL_bpz00_13136); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13140;
BgL_accz00_13140 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10939, BgL_sz00_13135, BgL_bpz00_13136); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13139); 
VECTOR_SET(
((obj_t)BgL_sz00_13135),((long)0),BgL_bpz00_13136); 
return BgL_accz00_13140;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13141;
BgL_nsz00_13141 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13141,((long)1),BgL_sz00_13135); 
VECTOR_SET(BgL_nsz00_13141,((long)2),BgL_cz00_10941); 
VECTOR_SET(BgL_nsz00_13141,((long)3),BgL_dz00_10942); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13142;
BgL_z12denvz12_13142 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13142, BgL_nsz00_13141); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13143;
BgL_ez00_13143 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13143, BgL_sz00_13135); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13144;
BgL_____rz00_13144 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10939, BgL_nsz00_13141, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13143); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13142, BgL_sz00_13135); 
return BgL_____rz00_13144;} } } } } } } } 

}



/* &run4203 */
obj_t BGl_z62run4203z62zz__evaluate_compz00(obj_t BgL_envz00_10943, obj_t BgL_sz00_10947)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10944;BgL_ev_absz00_bglt BgL_i1244z00_10945;obj_t BgL_bodyz00_10946;
BgL_iboxesz00_10944 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)0)))); 
BgL_i1244z00_10945 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)1)))); 
BgL_bodyz00_10946 = 
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13145;
BgL_bpz00_13145 = 
VECTOR_REF(
((obj_t)BgL_sz00_10947),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10947, BgL_iboxesz00_10944, BgL_bpz00_13145); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13146;obj_t BgL_wherez00_13147;obj_t BgL_locz00_13148;
BgL_z12denvz12_13146 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13147 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10945))->BgL_wherez00); 
BgL_locz00_13148 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10945))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13146, BgL_wherez00_13147, BgL_locz00_13148); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13149;
BgL_za2za2resza2za2z00_13149 = 
PROCEDURE_ENTRY(BgL_bodyz00_10946)(BgL_bodyz00_10946, BgL_sz00_10947, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13146); 
return BgL_za2za2resza2za2z00_13149;} } } } } } 

}



/* &<@anonymous:3354> */
obj_t BGl_z62zc3z04anonymousza33354ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10948, obj_t BgL_sz00_10954)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10949;long BgL_siza7eza7_10950;BgL_ev_absz00_bglt BgL_i1244z00_10951;obj_t BgL_bodyz00_10952;long BgL_siza7ezd2framez75_10953;
BgL_ifreesz00_10949 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10948, 
(int)(((long)0)))); 
BgL_siza7eza7_10950 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10948, 
(int)(((long)1)))); 
BgL_i1244z00_10951 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10948, 
(int)(((long)2)))); 
BgL_bodyz00_10952 = 
PROCEDURE_REF(BgL_envz00_10948, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_10953 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10948, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13150;
BgL_bpz00_13150 = 
VECTOR_REF(
((obj_t)BgL_sz00_10954),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13151;
BgL_valza2za2_13151 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10954, BgL_bpz00_13150, BgL_ifreesz00_10949); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13152;
BgL_runz00_13152 = 
MAKE_FX_PROCEDURE(BGl_z62run4205z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13152, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10950)); 
PROCEDURE_SET(BgL_runz00_13152, 
(int)(((long)1)), BgL_valza2za2_13151); 
PROCEDURE_SET(BgL_runz00_13152, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10951)); 
PROCEDURE_SET(BgL_runz00_13152, 
(int)(((long)3)), BgL_bodyz00_10952); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13153;
BgL_mainz00_13153 = 
MAKE_FX_PROCEDURE(BGl_z62main4204z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13153, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_10950)); 
PROCEDURE_SET(BgL_mainz00_13153, 
(int)(((long)1)), BgL_valza2za2_13151); 
PROCEDURE_SET(BgL_mainz00_13153, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_10951)); 
PROCEDURE_SET(BgL_mainz00_13153, 
(int)(((long)3)), BgL_bodyz00_10952); 
PROCEDURE_SET(BgL_mainz00_13153, 
(int)(((long)4)), BgL_runz00_13152); 
PROCEDURE_SET(BgL_mainz00_13153, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_10953)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13154;
BgL_objz00_13154 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13152, BgL_objz00_13154); BgL_objz00_13154; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3355z00_13155;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3356z00_13156;
BgL_arg3356z00_13156 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10951))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13157;
BgL_newz00_13157 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24346;
BgL_tmpz00_24346 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13157, BgL_tmpz00_24346, BgL_arg3356z00_13156); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24351;int BgL_tmpz00_24349;
BgL_auxz00_24351 = 
BINT(BgL_siza7ezd2framez75_10953); 
BgL_tmpz00_24349 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13157, BgL_tmpz00_24349, BgL_auxz00_24351); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24354;
BgL_tmpz00_24354 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13157, BgL_tmpz00_24354, BgL_runz00_13152); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24359;int BgL_tmpz00_24357;
BgL_auxz00_24359 = 
BINT(((long)2)); 
BgL_tmpz00_24357 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13157, BgL_tmpz00_24357, BgL_auxz00_24359); } 
BgL_arg3355z00_13155 = BgL_newz00_13157; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13153, BgL_arg3355z00_13155); BgL_arg3355z00_13155; } 
return BgL_mainz00_13153;} } } } } } 

}



/* &main4204 */
obj_t BGl_z62main4204z62zz__evaluate_compz00(obj_t BgL_envz00_10955, obj_t BgL_cz00_10962, obj_t BgL_dz00_10963)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10960;long BgL_siza7ezd2framez75_10961;
BgL_runz00_10960 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10955, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_10961 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10955, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13158;
BgL_sz00_13158 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13159;
BgL_bpz00_13159 = 
VECTOR_REF(
((obj_t)BgL_sz00_13158),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13158, BgL_bpz00_13159, 
BINT(BgL_siza7ezd2framez75_10961)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3359z00_13160;
BgL_arg3359z00_13160 = 
(
(long)CINT(BgL_bpz00_13159)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13158),BgL_arg3359z00_13160,BgL_cz00_10962); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3360z00_13161;
BgL_arg3360z00_13161 = 
(
(long)CINT(BgL_bpz00_13159)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13158),BgL_arg3360z00_13161,BgL_dz00_10963); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13162;
BgL_ez00_13162 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13162, BgL_bpz00_13159); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13163;
BgL_accz00_13163 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10960, BgL_sz00_13158, BgL_bpz00_13159); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13162); 
VECTOR_SET(
((obj_t)BgL_sz00_13158),((long)0),BgL_bpz00_13159); 
return BgL_accz00_13163;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13164;
BgL_nsz00_13164 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13164,((long)1),BgL_sz00_13158); 
VECTOR_SET(BgL_nsz00_13164,((long)2),BgL_cz00_10962); 
VECTOR_SET(BgL_nsz00_13164,((long)3),BgL_dz00_10963); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13165;
BgL_z12denvz12_13165 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13165, BgL_nsz00_13164); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13166;
BgL_ez00_13166 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13166, BgL_sz00_13158); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13167;
BgL_____rz00_13167 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10960, BgL_nsz00_13164, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13166); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13165, BgL_sz00_13158); 
return BgL_____rz00_13167;} } } } } } } } 

}



/* &run4205 */
obj_t BGl_z62run4205z62zz__evaluate_compz00(obj_t BgL_envz00_10964, obj_t BgL_sz00_10969)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_10965;obj_t BgL_valza2za2_10966;BgL_ev_absz00_bglt BgL_i1244z00_10967;obj_t BgL_bodyz00_10968;
BgL_siza7eza7_10965 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10964, 
(int)(((long)0)))); 
BgL_valza2za2_10966 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10964, 
(int)(((long)1)))); 
BgL_i1244z00_10967 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10964, 
(int)(((long)2)))); 
BgL_bodyz00_10968 = 
PROCEDURE_REF(BgL_envz00_10964, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13168;
BgL_bpz00_13168 = 
VECTOR_REF(
((obj_t)BgL_sz00_10969),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10969, BgL_valza2za2_10966, 
(
(long)CINT(BgL_bpz00_13168)+BgL_siza7eza7_10965)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13169;obj_t BgL_wherez00_13170;obj_t BgL_locz00_13171;
BgL_z12denvz12_13169 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13170 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10967))->BgL_wherez00); 
BgL_locz00_13171 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10967))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13169, BgL_wherez00_13170, BgL_locz00_13171); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13172;
BgL_za2za2resza2za2z00_13172 = 
PROCEDURE_ENTRY(BgL_bodyz00_10968)(BgL_bodyz00_10968, BgL_sz00_10969, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13169); 
return BgL_za2za2resza2za2z00_13172;} } } } } } 

}



/* &<@anonymous:3363> */
obj_t BGl_z62zc3z04anonymousza33363ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10970, obj_t BgL_sz00_10977)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_10971;obj_t BgL_iboxesz00_10972;long BgL_siza7eza7_10973;BgL_ev_absz00_bglt BgL_i1244z00_10974;obj_t BgL_bodyz00_10975;long BgL_siza7ezd2framez75_10976;
BgL_ifreesz00_10971 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10970, 
(int)(((long)0)))); 
BgL_iboxesz00_10972 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10970, 
(int)(((long)1)))); 
BgL_siza7eza7_10973 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10970, 
(int)(((long)2)))); 
BgL_i1244z00_10974 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10970, 
(int)(((long)3)))); 
BgL_bodyz00_10975 = 
PROCEDURE_REF(BgL_envz00_10970, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_10976 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10970, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13173;
BgL_bpz00_13173 = 
VECTOR_REF(
((obj_t)BgL_sz00_10977),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13174;
BgL_valza2za2_13174 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_10977, BgL_bpz00_13173, BgL_ifreesz00_10971); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13175;
BgL_runz00_13175 = 
MAKE_FX_PROCEDURE(BGl_z62run4207z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13175, 
(int)(((long)0)), BgL_iboxesz00_10972); 
PROCEDURE_SET(BgL_runz00_13175, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10973)); 
PROCEDURE_SET(BgL_runz00_13175, 
(int)(((long)2)), BgL_valza2za2_13174); 
PROCEDURE_SET(BgL_runz00_13175, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10974)); 
PROCEDURE_SET(BgL_runz00_13175, 
(int)(((long)4)), BgL_bodyz00_10975); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13176;
BgL_mainz00_13176 = 
MAKE_FX_PROCEDURE(BGl_z62main4206z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13176, 
(int)(((long)0)), BgL_iboxesz00_10972); 
PROCEDURE_SET(BgL_mainz00_13176, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_10973)); 
PROCEDURE_SET(BgL_mainz00_13176, 
(int)(((long)2)), BgL_valza2za2_13174); 
PROCEDURE_SET(BgL_mainz00_13176, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_10974)); 
PROCEDURE_SET(BgL_mainz00_13176, 
(int)(((long)4)), BgL_bodyz00_10975); 
PROCEDURE_SET(BgL_mainz00_13176, 
(int)(((long)5)), BgL_runz00_13175); 
PROCEDURE_SET(BgL_mainz00_13176, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_10976)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13177;
BgL_objz00_13177 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13175, BgL_objz00_13177); BgL_objz00_13177; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3364z00_13178;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3365z00_13179;
BgL_arg3365z00_13179 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10974))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13180;
BgL_newz00_13180 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24485;
BgL_tmpz00_24485 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13180, BgL_tmpz00_24485, BgL_arg3365z00_13179); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24490;int BgL_tmpz00_24488;
BgL_auxz00_24490 = 
BINT(BgL_siza7ezd2framez75_10976); 
BgL_tmpz00_24488 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13180, BgL_tmpz00_24488, BgL_auxz00_24490); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24493;
BgL_tmpz00_24493 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13180, BgL_tmpz00_24493, BgL_runz00_13175); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24498;int BgL_tmpz00_24496;
BgL_auxz00_24498 = 
BINT(((long)2)); 
BgL_tmpz00_24496 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13180, BgL_tmpz00_24496, BgL_auxz00_24498); } 
BgL_arg3364z00_13178 = BgL_newz00_13180; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13176, BgL_arg3364z00_13178); BgL_arg3364z00_13178; } 
return BgL_mainz00_13176;} } } } } } 

}



/* &main4206 */
obj_t BGl_z62main4206z62zz__evaluate_compz00(obj_t BgL_envz00_10978, obj_t BgL_cz00_10986, obj_t BgL_dz00_10987)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_10984;long BgL_siza7ezd2framez75_10985;
BgL_runz00_10984 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10978, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_10985 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10978, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13181;
BgL_sz00_13181 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13182;
BgL_bpz00_13182 = 
VECTOR_REF(
((obj_t)BgL_sz00_13181),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13181, BgL_bpz00_13182, 
BINT(BgL_siza7ezd2framez75_10985)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3368z00_13183;
BgL_arg3368z00_13183 = 
(
(long)CINT(BgL_bpz00_13182)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13181),BgL_arg3368z00_13183,BgL_cz00_10986); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3369z00_13184;
BgL_arg3369z00_13184 = 
(
(long)CINT(BgL_bpz00_13182)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13181),BgL_arg3369z00_13184,BgL_dz00_10987); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13185;
BgL_ez00_13185 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13185, BgL_bpz00_13182); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13186;
BgL_accz00_13186 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10984, BgL_sz00_13181, BgL_bpz00_13182); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13185); 
VECTOR_SET(
((obj_t)BgL_sz00_13181),((long)0),BgL_bpz00_13182); 
return BgL_accz00_13186;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13187;
BgL_nsz00_13187 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13187,((long)1),BgL_sz00_13181); 
VECTOR_SET(BgL_nsz00_13187,((long)2),BgL_cz00_10986); 
VECTOR_SET(BgL_nsz00_13187,((long)3),BgL_dz00_10987); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13188;
BgL_z12denvz12_13188 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13188, BgL_nsz00_13187); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13189;
BgL_ez00_13189 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13189, BgL_sz00_13181); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13190;
BgL_____rz00_13190 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_10984, BgL_nsz00_13187, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13189); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13188, BgL_sz00_13181); 
return BgL_____rz00_13190;} } } } } } } } 

}



/* &run4207 */
obj_t BGl_z62run4207z62zz__evaluate_compz00(obj_t BgL_envz00_10988, obj_t BgL_sz00_10994)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_10989;long BgL_siza7eza7_10990;obj_t BgL_valza2za2_10991;BgL_ev_absz00_bglt BgL_i1244z00_10992;obj_t BgL_bodyz00_10993;
BgL_iboxesz00_10989 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10988, 
(int)(((long)0)))); 
BgL_siza7eza7_10990 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10988, 
(int)(((long)1)))); 
BgL_valza2za2_10991 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10988, 
(int)(((long)2)))); 
BgL_i1244z00_10992 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10988, 
(int)(((long)3)))); 
BgL_bodyz00_10993 = 
PROCEDURE_REF(BgL_envz00_10988, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13191;
BgL_bpz00_13191 = 
VECTOR_REF(
((obj_t)BgL_sz00_10994),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_10994, BgL_iboxesz00_10989, BgL_bpz00_13191); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_10994, BgL_valza2za2_10991, 
(
(long)CINT(BgL_bpz00_13191)+BgL_siza7eza7_10990)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13192;obj_t BgL_wherez00_13193;obj_t BgL_locz00_13194;
BgL_z12denvz12_13192 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13193 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10992))->BgL_wherez00); 
BgL_locz00_13194 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10992))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13192, BgL_wherez00_13193, BgL_locz00_13194); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13195;
BgL_za2za2resza2za2z00_13195 = 
PROCEDURE_ENTRY(BgL_bodyz00_10993)(BgL_bodyz00_10993, BgL_sz00_10994, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13192); 
return BgL_za2za2resza2za2z00_13195;} } } } } } 

}



/* &<@anonymous:3292> */
obj_t BGl_z62zc3z04anonymousza33292ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10995, obj_t BgL_sz00_10999)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_10996;obj_t BgL_bodyz00_10997;long BgL_siza7ezd2framez75_10998;
BgL_i1244z00_10996 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_10995, 
(int)(((long)0)))); 
BgL_bodyz00_10997 = 
PROCEDURE_REF(BgL_envz00_10995, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_10998 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10995, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13196;
BgL_bpz00_13196 = 
VECTOR_REF(
((obj_t)BgL_sz00_10999),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13197;
BgL_runz00_13197 = 
MAKE_FX_PROCEDURE(BGl_z62run4209z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13197, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10996)); 
PROCEDURE_SET(BgL_runz00_13197, 
(int)(((long)1)), BgL_bodyz00_10997); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13198;
BgL_mainz00_13198 = 
MAKE_VA_PROCEDURE(BGl_z62main4208z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13198, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_10996)); 
PROCEDURE_SET(BgL_mainz00_13198, 
(int)(((long)1)), BgL_bodyz00_10997); 
PROCEDURE_SET(BgL_mainz00_13198, 
(int)(((long)2)), BgL_runz00_13197); 
PROCEDURE_SET(BgL_mainz00_13198, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_10998)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13199;
BgL_objz00_13199 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13197, BgL_objz00_13199); BgL_objz00_13199; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3293z00_13200;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3294z00_13201;
BgL_arg3294z00_13201 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_10996))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13202;
BgL_newz00_13202 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24604;
BgL_tmpz00_24604 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13202, BgL_tmpz00_24604, BgL_arg3294z00_13201); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24609;int BgL_tmpz00_24607;
BgL_auxz00_24609 = 
BINT(BgL_siza7ezd2framez75_10998); 
BgL_tmpz00_24607 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13202, BgL_tmpz00_24607, BgL_auxz00_24609); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24612;
BgL_tmpz00_24612 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13202, BgL_tmpz00_24612, BgL_runz00_13197); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24617;int BgL_tmpz00_24615;
BgL_auxz00_24617 = 
BINT(((long)-2)); 
BgL_tmpz00_24615 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13202, BgL_tmpz00_24615, BgL_auxz00_24617); } 
BgL_arg3293z00_13200 = BgL_newz00_13202; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13198, BgL_arg3293z00_13200); BgL_arg3293z00_13200; } 
return BgL_mainz00_13198;} } } } } } 

}



/* &main4208 */
obj_t BGl_z62main4208z62zz__evaluate_compz00(obj_t BgL_envz00_11000, obj_t BgL_dz00_11005, obj_t BgL_lastz00_11006)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11003;long BgL_siza7ezd2framez75_11004;
BgL_runz00_11003 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11000, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11004 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11000, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13203;
BgL_sz00_13203 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13204;
BgL_bpz00_13204 = 
VECTOR_REF(
((obj_t)BgL_sz00_13203),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13203, BgL_bpz00_13204, 
BINT(BgL_siza7ezd2framez75_11004)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3297z00_13205;
BgL_arg3297z00_13205 = 
(
(long)CINT(BgL_bpz00_13204)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13203),BgL_arg3297z00_13205,BgL_dz00_11005); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3298z00_13206;
BgL_arg3298z00_13206 = 
(
(long)CINT(BgL_bpz00_13204)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13203),BgL_arg3298z00_13206,BgL_lastz00_11006); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13207;
BgL_ez00_13207 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13207, BgL_bpz00_13204); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13208;
BgL_accz00_13208 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11003, BgL_sz00_13203, BgL_bpz00_13204); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13207); 
VECTOR_SET(
((obj_t)BgL_sz00_13203),((long)0),BgL_bpz00_13204); 
return BgL_accz00_13208;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13209;
BgL_nsz00_13209 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13209,((long)1),BgL_sz00_13203); 
VECTOR_SET(BgL_nsz00_13209,((long)2),BgL_dz00_11005); 
VECTOR_SET(BgL_nsz00_13209,((long)3),BgL_lastz00_11006); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13210;
BgL_z12denvz12_13210 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13210, BgL_nsz00_13209); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13211;
BgL_ez00_13211 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13211, BgL_sz00_13203); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13212;
BgL_____rz00_13212 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11003, BgL_nsz00_13209, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13211); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13210, BgL_sz00_13203); 
return BgL_____rz00_13212;} } } } } } } } 

}



/* &run4209 */
obj_t BGl_z62run4209z62zz__evaluate_compz00(obj_t BgL_envz00_11007, obj_t BgL_sz00_11010)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11008;obj_t BgL_bodyz00_11009;
BgL_i1244z00_11008 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11007, 
(int)(((long)0)))); 
BgL_bodyz00_11009 = 
PROCEDURE_REF(BgL_envz00_11007, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13213;
BgL_bpz00_13213 = 
VECTOR_REF(
((obj_t)BgL_sz00_11010),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13214;obj_t BgL_wherez00_13215;obj_t BgL_locz00_13216;
BgL_z12denvz12_13214 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13215 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11008))->BgL_wherez00); 
BgL_locz00_13216 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11008))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13214, BgL_wherez00_13215, BgL_locz00_13216); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13217;
BgL_za2za2resza2za2z00_13217 = 
PROCEDURE_ENTRY(BgL_bodyz00_11009)(BgL_bodyz00_11009, BgL_sz00_11010, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13214); 
return BgL_za2za2resza2za2z00_13217;} } } } } } 

}



/* &<@anonymous:3300> */
obj_t BGl_z62zc3z04anonymousza33300ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11011, obj_t BgL_sz00_11016)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11012;BgL_ev_absz00_bglt BgL_i1244z00_11013;obj_t BgL_bodyz00_11014;long BgL_siza7ezd2framez75_11015;
BgL_iboxesz00_11012 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11011, 
(int)(((long)0)))); 
BgL_i1244z00_11013 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11011, 
(int)(((long)1)))); 
BgL_bodyz00_11014 = 
PROCEDURE_REF(BgL_envz00_11011, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11015 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11011, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13218;
BgL_bpz00_13218 = 
VECTOR_REF(
((obj_t)BgL_sz00_11016),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13219;
BgL_runz00_13219 = 
MAKE_FX_PROCEDURE(BGl_z62run4211z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13219, 
(int)(((long)0)), BgL_iboxesz00_11012); 
PROCEDURE_SET(BgL_runz00_13219, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11013)); 
PROCEDURE_SET(BgL_runz00_13219, 
(int)(((long)2)), BgL_bodyz00_11014); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13220;
BgL_mainz00_13220 = 
MAKE_VA_PROCEDURE(BGl_z62main4210z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13220, 
(int)(((long)0)), BgL_iboxesz00_11012); 
PROCEDURE_SET(BgL_mainz00_13220, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11013)); 
PROCEDURE_SET(BgL_mainz00_13220, 
(int)(((long)2)), BgL_bodyz00_11014); 
PROCEDURE_SET(BgL_mainz00_13220, 
(int)(((long)3)), BgL_runz00_13219); 
PROCEDURE_SET(BgL_mainz00_13220, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11015)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13221;
BgL_objz00_13221 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13219, BgL_objz00_13221); BgL_objz00_13221; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3301z00_13222;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3302z00_13223;
BgL_arg3302z00_13223 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11013))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13224;
BgL_newz00_13224 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24717;
BgL_tmpz00_24717 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13224, BgL_tmpz00_24717, BgL_arg3302z00_13223); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24722;int BgL_tmpz00_24720;
BgL_auxz00_24722 = 
BINT(BgL_siza7ezd2framez75_11015); 
BgL_tmpz00_24720 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13224, BgL_tmpz00_24720, BgL_auxz00_24722); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24725;
BgL_tmpz00_24725 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13224, BgL_tmpz00_24725, BgL_runz00_13219); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24730;int BgL_tmpz00_24728;
BgL_auxz00_24730 = 
BINT(((long)-2)); 
BgL_tmpz00_24728 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13224, BgL_tmpz00_24728, BgL_auxz00_24730); } 
BgL_arg3301z00_13222 = BgL_newz00_13224; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13220, BgL_arg3301z00_13222); BgL_arg3301z00_13222; } 
return BgL_mainz00_13220;} } } } } } 

}



/* &main4210 */
obj_t BGl_z62main4210z62zz__evaluate_compz00(obj_t BgL_envz00_11017, obj_t BgL_dz00_11023, obj_t BgL_lastz00_11024)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11021;long BgL_siza7ezd2framez75_11022;
BgL_runz00_11021 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11017, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11022 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11017, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13225;
BgL_sz00_13225 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13226;
BgL_bpz00_13226 = 
VECTOR_REF(
((obj_t)BgL_sz00_13225),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13225, BgL_bpz00_13226, 
BINT(BgL_siza7ezd2framez75_11022)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3305z00_13227;
BgL_arg3305z00_13227 = 
(
(long)CINT(BgL_bpz00_13226)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13225),BgL_arg3305z00_13227,BgL_dz00_11023); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3306z00_13228;
BgL_arg3306z00_13228 = 
(
(long)CINT(BgL_bpz00_13226)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13225),BgL_arg3306z00_13228,BgL_lastz00_11024); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13229;
BgL_ez00_13229 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13229, BgL_bpz00_13226); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13230;
BgL_accz00_13230 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11021, BgL_sz00_13225, BgL_bpz00_13226); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13229); 
VECTOR_SET(
((obj_t)BgL_sz00_13225),((long)0),BgL_bpz00_13226); 
return BgL_accz00_13230;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13231;
BgL_nsz00_13231 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13231,((long)1),BgL_sz00_13225); 
VECTOR_SET(BgL_nsz00_13231,((long)2),BgL_dz00_11023); 
VECTOR_SET(BgL_nsz00_13231,((long)3),BgL_lastz00_11024); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13232;
BgL_z12denvz12_13232 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13232, BgL_nsz00_13231); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13233;
BgL_ez00_13233 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13233, BgL_sz00_13225); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13234;
BgL_____rz00_13234 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11021, BgL_nsz00_13231, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13233); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13232, BgL_sz00_13225); 
return BgL_____rz00_13234;} } } } } } } } 

}



/* &run4211 */
obj_t BGl_z62run4211z62zz__evaluate_compz00(obj_t BgL_envz00_11025, obj_t BgL_sz00_11029)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11026;BgL_ev_absz00_bglt BgL_i1244z00_11027;obj_t BgL_bodyz00_11028;
BgL_iboxesz00_11026 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11025, 
(int)(((long)0)))); 
BgL_i1244z00_11027 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11025, 
(int)(((long)1)))); 
BgL_bodyz00_11028 = 
PROCEDURE_REF(BgL_envz00_11025, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13235;
BgL_bpz00_13235 = 
VECTOR_REF(
((obj_t)BgL_sz00_11029),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11029, BgL_iboxesz00_11026, BgL_bpz00_13235); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13236;obj_t BgL_wherez00_13237;obj_t BgL_locz00_13238;
BgL_z12denvz12_13236 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13237 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11027))->BgL_wherez00); 
BgL_locz00_13238 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11027))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13236, BgL_wherez00_13237, BgL_locz00_13238); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13239;
BgL_za2za2resza2za2z00_13239 = 
PROCEDURE_ENTRY(BgL_bodyz00_11028)(BgL_bodyz00_11028, BgL_sz00_11029, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13236); 
return BgL_za2za2resza2za2z00_13239;} } } } } } 

}



/* &<@anonymous:3311> */
obj_t BGl_z62zc3z04anonymousza33311ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11030, obj_t BgL_sz00_11036)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11031;long BgL_siza7eza7_11032;BgL_ev_absz00_bglt BgL_i1244z00_11033;obj_t BgL_bodyz00_11034;long BgL_siza7ezd2framez75_11035;
BgL_ifreesz00_11031 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11030, 
(int)(((long)0)))); 
BgL_siza7eza7_11032 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11030, 
(int)(((long)1)))); 
BgL_i1244z00_11033 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11030, 
(int)(((long)2)))); 
BgL_bodyz00_11034 = 
PROCEDURE_REF(BgL_envz00_11030, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11035 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11030, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13240;
BgL_bpz00_13240 = 
VECTOR_REF(
((obj_t)BgL_sz00_11036),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13241;
BgL_valza2za2_13241 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11036, BgL_bpz00_13240, BgL_ifreesz00_11031); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13242;
BgL_runz00_13242 = 
MAKE_FX_PROCEDURE(BGl_z62run4213z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13242, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11032)); 
PROCEDURE_SET(BgL_runz00_13242, 
(int)(((long)1)), BgL_valza2za2_13241); 
PROCEDURE_SET(BgL_runz00_13242, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11033)); 
PROCEDURE_SET(BgL_runz00_13242, 
(int)(((long)3)), BgL_bodyz00_11034); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13243;
BgL_mainz00_13243 = 
MAKE_VA_PROCEDURE(BGl_z62main4212z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13243, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11032)); 
PROCEDURE_SET(BgL_mainz00_13243, 
(int)(((long)1)), BgL_valza2za2_13241); 
PROCEDURE_SET(BgL_mainz00_13243, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11033)); 
PROCEDURE_SET(BgL_mainz00_13243, 
(int)(((long)3)), BgL_bodyz00_11034); 
PROCEDURE_SET(BgL_mainz00_13243, 
(int)(((long)4)), BgL_runz00_13242); 
PROCEDURE_SET(BgL_mainz00_13243, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11035)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13244;
BgL_objz00_13244 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13242, BgL_objz00_13244); BgL_objz00_13244; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3312z00_13245;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3313z00_13246;
BgL_arg3313z00_13246 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11033))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13247;
BgL_newz00_13247 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24844;
BgL_tmpz00_24844 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13247, BgL_tmpz00_24844, BgL_arg3313z00_13246); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24849;int BgL_tmpz00_24847;
BgL_auxz00_24849 = 
BINT(BgL_siza7ezd2framez75_11035); 
BgL_tmpz00_24847 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13247, BgL_tmpz00_24847, BgL_auxz00_24849); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24852;
BgL_tmpz00_24852 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13247, BgL_tmpz00_24852, BgL_runz00_13242); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24857;int BgL_tmpz00_24855;
BgL_auxz00_24857 = 
BINT(((long)-2)); 
BgL_tmpz00_24855 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13247, BgL_tmpz00_24855, BgL_auxz00_24857); } 
BgL_arg3312z00_13245 = BgL_newz00_13247; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13243, BgL_arg3312z00_13245); BgL_arg3312z00_13245; } 
return BgL_mainz00_13243;} } } } } } 

}



/* &main4212 */
obj_t BGl_z62main4212z62zz__evaluate_compz00(obj_t BgL_envz00_11037, obj_t BgL_dz00_11044, obj_t BgL_lastz00_11045)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11042;long BgL_siza7ezd2framez75_11043;
BgL_runz00_11042 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11037, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11043 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11037, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13248;
BgL_sz00_13248 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13249;
BgL_bpz00_13249 = 
VECTOR_REF(
((obj_t)BgL_sz00_13248),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13248, BgL_bpz00_13249, 
BINT(BgL_siza7ezd2framez75_11043)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3316z00_13250;
BgL_arg3316z00_13250 = 
(
(long)CINT(BgL_bpz00_13249)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13248),BgL_arg3316z00_13250,BgL_dz00_11044); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3317z00_13251;
BgL_arg3317z00_13251 = 
(
(long)CINT(BgL_bpz00_13249)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13248),BgL_arg3317z00_13251,BgL_lastz00_11045); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13252;
BgL_ez00_13252 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13252, BgL_bpz00_13249); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13253;
BgL_accz00_13253 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11042, BgL_sz00_13248, BgL_bpz00_13249); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13252); 
VECTOR_SET(
((obj_t)BgL_sz00_13248),((long)0),BgL_bpz00_13249); 
return BgL_accz00_13253;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13254;
BgL_nsz00_13254 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13254,((long)1),BgL_sz00_13248); 
VECTOR_SET(BgL_nsz00_13254,((long)2),BgL_dz00_11044); 
VECTOR_SET(BgL_nsz00_13254,((long)3),BgL_lastz00_11045); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13255;
BgL_z12denvz12_13255 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13255, BgL_nsz00_13254); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13256;
BgL_ez00_13256 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13256, BgL_sz00_13248); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13257;
BgL_____rz00_13257 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11042, BgL_nsz00_13254, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13256); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13255, BgL_sz00_13248); 
return BgL_____rz00_13257;} } } } } } } } 

}



/* &run4213 */
obj_t BGl_z62run4213z62zz__evaluate_compz00(obj_t BgL_envz00_11046, obj_t BgL_sz00_11051)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11047;obj_t BgL_valza2za2_11048;BgL_ev_absz00_bglt BgL_i1244z00_11049;obj_t BgL_bodyz00_11050;
BgL_siza7eza7_11047 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11046, 
(int)(((long)0)))); 
BgL_valza2za2_11048 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11046, 
(int)(((long)1)))); 
BgL_i1244z00_11049 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11046, 
(int)(((long)2)))); 
BgL_bodyz00_11050 = 
PROCEDURE_REF(BgL_envz00_11046, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13258;
BgL_bpz00_13258 = 
VECTOR_REF(
((obj_t)BgL_sz00_11051),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11051, BgL_valza2za2_11048, 
(
(long)CINT(BgL_bpz00_13258)+BgL_siza7eza7_11047)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13259;obj_t BgL_wherez00_13260;obj_t BgL_locz00_13261;
BgL_z12denvz12_13259 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13260 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11049))->BgL_wherez00); 
BgL_locz00_13261 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11049))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13259, BgL_wherez00_13260, BgL_locz00_13261); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13262;
BgL_za2za2resza2za2z00_13262 = 
PROCEDURE_ENTRY(BgL_bodyz00_11050)(BgL_bodyz00_11050, BgL_sz00_11051, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13259); 
return BgL_za2za2resza2za2z00_13262;} } } } } } 

}



/* &<@anonymous:3320> */
obj_t BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11052, obj_t BgL_sz00_11059)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11053;obj_t BgL_iboxesz00_11054;long BgL_siza7eza7_11055;BgL_ev_absz00_bglt BgL_i1244z00_11056;obj_t BgL_bodyz00_11057;long BgL_siza7ezd2framez75_11058;
BgL_ifreesz00_11053 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11052, 
(int)(((long)0)))); 
BgL_iboxesz00_11054 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11052, 
(int)(((long)1)))); 
BgL_siza7eza7_11055 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11052, 
(int)(((long)2)))); 
BgL_i1244z00_11056 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11052, 
(int)(((long)3)))); 
BgL_bodyz00_11057 = 
PROCEDURE_REF(BgL_envz00_11052, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11058 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11052, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13263;
BgL_bpz00_13263 = 
VECTOR_REF(
((obj_t)BgL_sz00_11059),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13264;
BgL_valza2za2_13264 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11059, BgL_bpz00_13263, BgL_ifreesz00_11053); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13265;
BgL_runz00_13265 = 
MAKE_FX_PROCEDURE(BGl_z62run4215z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13265, 
(int)(((long)0)), BgL_iboxesz00_11054); 
PROCEDURE_SET(BgL_runz00_13265, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11055)); 
PROCEDURE_SET(BgL_runz00_13265, 
(int)(((long)2)), BgL_valza2za2_13264); 
PROCEDURE_SET(BgL_runz00_13265, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11056)); 
PROCEDURE_SET(BgL_runz00_13265, 
(int)(((long)4)), BgL_bodyz00_11057); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13266;
BgL_mainz00_13266 = 
MAKE_VA_PROCEDURE(BGl_z62main4214z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13266, 
(int)(((long)0)), BgL_iboxesz00_11054); 
PROCEDURE_SET(BgL_mainz00_13266, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11055)); 
PROCEDURE_SET(BgL_mainz00_13266, 
(int)(((long)2)), BgL_valza2za2_13264); 
PROCEDURE_SET(BgL_mainz00_13266, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11056)); 
PROCEDURE_SET(BgL_mainz00_13266, 
(int)(((long)4)), BgL_bodyz00_11057); 
PROCEDURE_SET(BgL_mainz00_13266, 
(int)(((long)5)), BgL_runz00_13265); 
PROCEDURE_SET(BgL_mainz00_13266, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11058)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13267;
BgL_objz00_13267 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13265, BgL_objz00_13267); BgL_objz00_13267; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3321z00_13268;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3322z00_13269;
BgL_arg3322z00_13269 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11056))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13270;
BgL_newz00_13270 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24983;
BgL_tmpz00_24983 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13270, BgL_tmpz00_24983, BgL_arg3322z00_13269); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24988;int BgL_tmpz00_24986;
BgL_auxz00_24988 = 
BINT(BgL_siza7ezd2framez75_11058); 
BgL_tmpz00_24986 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13270, BgL_tmpz00_24986, BgL_auxz00_24988); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24991;
BgL_tmpz00_24991 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13270, BgL_tmpz00_24991, BgL_runz00_13265); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24996;int BgL_tmpz00_24994;
BgL_auxz00_24996 = 
BINT(((long)-2)); 
BgL_tmpz00_24994 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13270, BgL_tmpz00_24994, BgL_auxz00_24996); } 
BgL_arg3321z00_13268 = BgL_newz00_13270; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13266, BgL_arg3321z00_13268); BgL_arg3321z00_13268; } 
return BgL_mainz00_13266;} } } } } } 

}



/* &main4214 */
obj_t BGl_z62main4214z62zz__evaluate_compz00(obj_t BgL_envz00_11060, obj_t BgL_dz00_11068, obj_t BgL_lastz00_11069)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11066;long BgL_siza7ezd2framez75_11067;
BgL_runz00_11066 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11060, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11067 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11060, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13271;
BgL_sz00_13271 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13272;
BgL_bpz00_13272 = 
VECTOR_REF(
((obj_t)BgL_sz00_13271),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13271, BgL_bpz00_13272, 
BINT(BgL_siza7ezd2framez75_11067)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3325z00_13273;
BgL_arg3325z00_13273 = 
(
(long)CINT(BgL_bpz00_13272)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13271),BgL_arg3325z00_13273,BgL_dz00_11068); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3326z00_13274;
BgL_arg3326z00_13274 = 
(
(long)CINT(BgL_bpz00_13272)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13271),BgL_arg3326z00_13274,BgL_lastz00_11069); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13275;
BgL_ez00_13275 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13275, BgL_bpz00_13272); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13276;
BgL_accz00_13276 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11066, BgL_sz00_13271, BgL_bpz00_13272); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13275); 
VECTOR_SET(
((obj_t)BgL_sz00_13271),((long)0),BgL_bpz00_13272); 
return BgL_accz00_13276;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13277;
BgL_nsz00_13277 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13277,((long)1),BgL_sz00_13271); 
VECTOR_SET(BgL_nsz00_13277,((long)2),BgL_dz00_11068); 
VECTOR_SET(BgL_nsz00_13277,((long)3),BgL_lastz00_11069); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13278;
BgL_z12denvz12_13278 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13278, BgL_nsz00_13277); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13279;
BgL_ez00_13279 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13279, BgL_sz00_13271); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13280;
BgL_____rz00_13280 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11066, BgL_nsz00_13277, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13279); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13278, BgL_sz00_13271); 
return BgL_____rz00_13280;} } } } } } } } 

}



/* &run4215 */
obj_t BGl_z62run4215z62zz__evaluate_compz00(obj_t BgL_envz00_11070, obj_t BgL_sz00_11076)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11071;long BgL_siza7eza7_11072;obj_t BgL_valza2za2_11073;BgL_ev_absz00_bglt BgL_i1244z00_11074;obj_t BgL_bodyz00_11075;
BgL_iboxesz00_11071 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11070, 
(int)(((long)0)))); 
BgL_siza7eza7_11072 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11070, 
(int)(((long)1)))); 
BgL_valza2za2_11073 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11070, 
(int)(((long)2)))); 
BgL_i1244z00_11074 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11070, 
(int)(((long)3)))); 
BgL_bodyz00_11075 = 
PROCEDURE_REF(BgL_envz00_11070, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13281;
BgL_bpz00_13281 = 
VECTOR_REF(
((obj_t)BgL_sz00_11076),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11076, BgL_iboxesz00_11071, BgL_bpz00_13281); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11076, BgL_valza2za2_11073, 
(
(long)CINT(BgL_bpz00_13281)+BgL_siza7eza7_11072)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13282;obj_t BgL_wherez00_13283;obj_t BgL_locz00_13284;
BgL_z12denvz12_13282 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13283 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11074))->BgL_wherez00); 
BgL_locz00_13284 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11074))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13282, BgL_wherez00_13283, BgL_locz00_13284); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13285;
BgL_za2za2resza2za2z00_13285 = 
PROCEDURE_ENTRY(BgL_bodyz00_11075)(BgL_bodyz00_11075, BgL_sz00_11076, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13282); 
return BgL_za2za2resza2za2z00_13285;} } } } } } 

}



/* &<@anonymous:3253> */
obj_t BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11077, obj_t BgL_sz00_11081)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11078;obj_t BgL_bodyz00_11079;long BgL_siza7ezd2framez75_11080;
BgL_i1244z00_11078 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11077, 
(int)(((long)0)))); 
BgL_bodyz00_11079 = 
PROCEDURE_REF(BgL_envz00_11077, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11080 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11077, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13286;
BgL_bpz00_13286 = 
VECTOR_REF(
((obj_t)BgL_sz00_11081),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13287;
BgL_runz00_13287 = 
MAKE_FX_PROCEDURE(BGl_z62run4217z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13287, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11078)); 
PROCEDURE_SET(BgL_runz00_13287, 
(int)(((long)1)), BgL_bodyz00_11079); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13288;
BgL_mainz00_13288 = 
MAKE_FX_PROCEDURE(BGl_z62main4216z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13288, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11078)); 
PROCEDURE_SET(BgL_mainz00_13288, 
(int)(((long)1)), BgL_bodyz00_11079); 
PROCEDURE_SET(BgL_mainz00_13288, 
(int)(((long)2)), BgL_runz00_13287); 
PROCEDURE_SET(BgL_mainz00_13288, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11080)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13289;
BgL_objz00_13289 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13287, BgL_objz00_13289); BgL_objz00_13289; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3254z00_13290;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3255z00_13291;
BgL_arg3255z00_13291 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11078))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13292;
BgL_newz00_13292 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25102;
BgL_tmpz00_25102 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13292, BgL_tmpz00_25102, BgL_arg3255z00_13291); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25107;int BgL_tmpz00_25105;
BgL_auxz00_25107 = 
BINT(BgL_siza7ezd2framez75_11080); 
BgL_tmpz00_25105 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13292, BgL_tmpz00_25105, BgL_auxz00_25107); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25110;
BgL_tmpz00_25110 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13292, BgL_tmpz00_25110, BgL_runz00_13287); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25115;int BgL_tmpz00_25113;
BgL_auxz00_25115 = 
BINT(((long)1)); 
BgL_tmpz00_25113 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13292, BgL_tmpz00_25113, BgL_auxz00_25115); } 
BgL_arg3254z00_13290 = BgL_newz00_13292; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13288, BgL_arg3254z00_13290); BgL_arg3254z00_13290; } 
return BgL_mainz00_13288;} } } } } } 

}



/* &main4216 */
obj_t BGl_z62main4216z62zz__evaluate_compz00(obj_t BgL_envz00_11082, obj_t BgL_dz00_11087)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11085;long BgL_siza7ezd2framez75_11086;
BgL_runz00_11085 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11082, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11086 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11082, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13293;
BgL_sz00_13293 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13294;
BgL_bpz00_13294 = 
VECTOR_REF(
((obj_t)BgL_sz00_13293),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13293, BgL_bpz00_13294, 
BINT(BgL_siza7ezd2framez75_11086)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3258z00_13295;
BgL_arg3258z00_13295 = 
(
(long)CINT(BgL_bpz00_13294)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13293),BgL_arg3258z00_13295,BgL_dz00_11087); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13296;
BgL_ez00_13296 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13296, BgL_bpz00_13294); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13297;
BgL_accz00_13297 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11085, BgL_sz00_13293, BgL_bpz00_13294); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13296); 
VECTOR_SET(
((obj_t)BgL_sz00_13293),((long)0),BgL_bpz00_13294); 
return BgL_accz00_13297;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13298;
BgL_nsz00_13298 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13298,((long)1),BgL_sz00_13293); 
VECTOR_SET(BgL_nsz00_13298,((long)2),BgL_dz00_11087); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13299;
BgL_z12denvz12_13299 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13299, BgL_nsz00_13298); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13300;
BgL_ez00_13300 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13300, BgL_sz00_13293); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13301;
BgL_____rz00_13301 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11085, BgL_nsz00_13298, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13300); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13299, BgL_sz00_13293); 
return BgL_____rz00_13301;} } } } } } } } 

}



/* &run4217 */
obj_t BGl_z62run4217z62zz__evaluate_compz00(obj_t BgL_envz00_11088, obj_t BgL_sz00_11091)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11089;obj_t BgL_bodyz00_11090;
BgL_i1244z00_11089 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11088, 
(int)(((long)0)))); 
BgL_bodyz00_11090 = 
PROCEDURE_REF(BgL_envz00_11088, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13302;
BgL_bpz00_13302 = 
VECTOR_REF(
((obj_t)BgL_sz00_11091),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13303;obj_t BgL_wherez00_13304;obj_t BgL_locz00_13305;
BgL_z12denvz12_13303 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13304 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11089))->BgL_wherez00); 
BgL_locz00_13305 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11089))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13303, BgL_wherez00_13304, BgL_locz00_13305); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13306;
BgL_za2za2resza2za2z00_13306 = 
PROCEDURE_ENTRY(BgL_bodyz00_11090)(BgL_bodyz00_11090, BgL_sz00_11091, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13303); 
return BgL_za2za2resza2za2z00_13306;} } } } } } 

}



/* &<@anonymous:3260> */
obj_t BGl_z62zc3z04anonymousza33260ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11092, obj_t BgL_sz00_11097)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11093;BgL_ev_absz00_bglt BgL_i1244z00_11094;obj_t BgL_bodyz00_11095;long BgL_siza7ezd2framez75_11096;
BgL_iboxesz00_11093 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11092, 
(int)(((long)0)))); 
BgL_i1244z00_11094 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11092, 
(int)(((long)1)))); 
BgL_bodyz00_11095 = 
PROCEDURE_REF(BgL_envz00_11092, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11096 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11092, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13307;
BgL_bpz00_13307 = 
VECTOR_REF(
((obj_t)BgL_sz00_11097),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13308;
BgL_runz00_13308 = 
MAKE_FX_PROCEDURE(BGl_z62run4219z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13308, 
(int)(((long)0)), BgL_iboxesz00_11093); 
PROCEDURE_SET(BgL_runz00_13308, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11094)); 
PROCEDURE_SET(BgL_runz00_13308, 
(int)(((long)2)), BgL_bodyz00_11095); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13309;
BgL_mainz00_13309 = 
MAKE_FX_PROCEDURE(BGl_z62main4218z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13309, 
(int)(((long)0)), BgL_iboxesz00_11093); 
PROCEDURE_SET(BgL_mainz00_13309, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11094)); 
PROCEDURE_SET(BgL_mainz00_13309, 
(int)(((long)2)), BgL_bodyz00_11095); 
PROCEDURE_SET(BgL_mainz00_13309, 
(int)(((long)3)), BgL_runz00_13308); 
PROCEDURE_SET(BgL_mainz00_13309, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11096)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13310;
BgL_objz00_13310 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13308, BgL_objz00_13310); BgL_objz00_13310; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3261z00_13311;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3262z00_13312;
BgL_arg3262z00_13312 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11094))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13313;
BgL_newz00_13313 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25210;
BgL_tmpz00_25210 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13313, BgL_tmpz00_25210, BgL_arg3262z00_13312); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25215;int BgL_tmpz00_25213;
BgL_auxz00_25215 = 
BINT(BgL_siza7ezd2framez75_11096); 
BgL_tmpz00_25213 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13313, BgL_tmpz00_25213, BgL_auxz00_25215); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25218;
BgL_tmpz00_25218 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13313, BgL_tmpz00_25218, BgL_runz00_13308); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25223;int BgL_tmpz00_25221;
BgL_auxz00_25223 = 
BINT(((long)1)); 
BgL_tmpz00_25221 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13313, BgL_tmpz00_25221, BgL_auxz00_25223); } 
BgL_arg3261z00_13311 = BgL_newz00_13313; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13309, BgL_arg3261z00_13311); BgL_arg3261z00_13311; } 
return BgL_mainz00_13309;} } } } } } 

}



/* &main4218 */
obj_t BGl_z62main4218z62zz__evaluate_compz00(obj_t BgL_envz00_11098, obj_t BgL_dz00_11104)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11102;long BgL_siza7ezd2framez75_11103;
BgL_runz00_11102 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11098, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11103 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11098, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13314;
BgL_sz00_13314 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13315;
BgL_bpz00_13315 = 
VECTOR_REF(
((obj_t)BgL_sz00_13314),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13314, BgL_bpz00_13315, 
BINT(BgL_siza7ezd2framez75_11103)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3265z00_13316;
BgL_arg3265z00_13316 = 
(
(long)CINT(BgL_bpz00_13315)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13314),BgL_arg3265z00_13316,BgL_dz00_11104); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13317;
BgL_ez00_13317 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13317, BgL_bpz00_13315); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13318;
BgL_accz00_13318 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11102, BgL_sz00_13314, BgL_bpz00_13315); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13317); 
VECTOR_SET(
((obj_t)BgL_sz00_13314),((long)0),BgL_bpz00_13315); 
return BgL_accz00_13318;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13319;
BgL_nsz00_13319 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13319,((long)1),BgL_sz00_13314); 
VECTOR_SET(BgL_nsz00_13319,((long)2),BgL_dz00_11104); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13320;
BgL_z12denvz12_13320 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13320, BgL_nsz00_13319); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13321;
BgL_ez00_13321 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13321, BgL_sz00_13314); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13322;
BgL_____rz00_13322 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11102, BgL_nsz00_13319, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13321); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13320, BgL_sz00_13314); 
return BgL_____rz00_13322;} } } } } } } } 

}



/* &run4219 */
obj_t BGl_z62run4219z62zz__evaluate_compz00(obj_t BgL_envz00_11105, obj_t BgL_sz00_11109)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11106;BgL_ev_absz00_bglt BgL_i1244z00_11107;obj_t BgL_bodyz00_11108;
BgL_iboxesz00_11106 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11105, 
(int)(((long)0)))); 
BgL_i1244z00_11107 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11105, 
(int)(((long)1)))); 
BgL_bodyz00_11108 = 
PROCEDURE_REF(BgL_envz00_11105, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13323;
BgL_bpz00_13323 = 
VECTOR_REF(
((obj_t)BgL_sz00_11109),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11109, BgL_iboxesz00_11106, BgL_bpz00_13323); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13324;obj_t BgL_wherez00_13325;obj_t BgL_locz00_13326;
BgL_z12denvz12_13324 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13325 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11107))->BgL_wherez00); 
BgL_locz00_13326 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11107))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13324, BgL_wherez00_13325, BgL_locz00_13326); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13327;
BgL_za2za2resza2za2z00_13327 = 
PROCEDURE_ENTRY(BgL_bodyz00_11108)(BgL_bodyz00_11108, BgL_sz00_11109, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13324); 
return BgL_za2za2resza2za2z00_13327;} } } } } } 

}



/* &<@anonymous:3270> */
obj_t BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11110, obj_t BgL_sz00_11116)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11111;long BgL_siza7eza7_11112;BgL_ev_absz00_bglt BgL_i1244z00_11113;obj_t BgL_bodyz00_11114;long BgL_siza7ezd2framez75_11115;
BgL_ifreesz00_11111 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11110, 
(int)(((long)0)))); 
BgL_siza7eza7_11112 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11110, 
(int)(((long)1)))); 
BgL_i1244z00_11113 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11110, 
(int)(((long)2)))); 
BgL_bodyz00_11114 = 
PROCEDURE_REF(BgL_envz00_11110, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11115 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11110, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13328;
BgL_bpz00_13328 = 
VECTOR_REF(
((obj_t)BgL_sz00_11116),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13329;
BgL_valza2za2_13329 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11116, BgL_bpz00_13328, BgL_ifreesz00_11111); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13330;
BgL_runz00_13330 = 
MAKE_FX_PROCEDURE(BGl_z62run4221z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13330, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11112)); 
PROCEDURE_SET(BgL_runz00_13330, 
(int)(((long)1)), BgL_valza2za2_13329); 
PROCEDURE_SET(BgL_runz00_13330, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11113)); 
PROCEDURE_SET(BgL_runz00_13330, 
(int)(((long)3)), BgL_bodyz00_11114); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13331;
BgL_mainz00_13331 = 
MAKE_FX_PROCEDURE(BGl_z62main4220z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13331, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11112)); 
PROCEDURE_SET(BgL_mainz00_13331, 
(int)(((long)1)), BgL_valza2za2_13329); 
PROCEDURE_SET(BgL_mainz00_13331, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11113)); 
PROCEDURE_SET(BgL_mainz00_13331, 
(int)(((long)3)), BgL_bodyz00_11114); 
PROCEDURE_SET(BgL_mainz00_13331, 
(int)(((long)4)), BgL_runz00_13330); 
PROCEDURE_SET(BgL_mainz00_13331, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11115)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13332;
BgL_objz00_13332 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13330, BgL_objz00_13332); BgL_objz00_13332; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3271z00_13333;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3272z00_13334;
BgL_arg3272z00_13334 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11113))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13335;
BgL_newz00_13335 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25332;
BgL_tmpz00_25332 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13335, BgL_tmpz00_25332, BgL_arg3272z00_13334); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25337;int BgL_tmpz00_25335;
BgL_auxz00_25337 = 
BINT(BgL_siza7ezd2framez75_11115); 
BgL_tmpz00_25335 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13335, BgL_tmpz00_25335, BgL_auxz00_25337); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25340;
BgL_tmpz00_25340 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13335, BgL_tmpz00_25340, BgL_runz00_13330); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25345;int BgL_tmpz00_25343;
BgL_auxz00_25345 = 
BINT(((long)1)); 
BgL_tmpz00_25343 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13335, BgL_tmpz00_25343, BgL_auxz00_25345); } 
BgL_arg3271z00_13333 = BgL_newz00_13335; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13331, BgL_arg3271z00_13333); BgL_arg3271z00_13333; } 
return BgL_mainz00_13331;} } } } } } 

}



/* &main4220 */
obj_t BGl_z62main4220z62zz__evaluate_compz00(obj_t BgL_envz00_11117, obj_t BgL_dz00_11124)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11122;long BgL_siza7ezd2framez75_11123;
BgL_runz00_11122 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11117, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11123 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11117, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13336;
BgL_sz00_13336 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13337;
BgL_bpz00_13337 = 
VECTOR_REF(
((obj_t)BgL_sz00_13336),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13336, BgL_bpz00_13337, 
BINT(BgL_siza7ezd2framez75_11123)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3275z00_13338;
BgL_arg3275z00_13338 = 
(
(long)CINT(BgL_bpz00_13337)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13336),BgL_arg3275z00_13338,BgL_dz00_11124); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13339;
BgL_ez00_13339 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13339, BgL_bpz00_13337); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13340;
BgL_accz00_13340 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11122, BgL_sz00_13336, BgL_bpz00_13337); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13339); 
VECTOR_SET(
((obj_t)BgL_sz00_13336),((long)0),BgL_bpz00_13337); 
return BgL_accz00_13340;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13341;
BgL_nsz00_13341 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13341,((long)1),BgL_sz00_13336); 
VECTOR_SET(BgL_nsz00_13341,((long)2),BgL_dz00_11124); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13342;
BgL_z12denvz12_13342 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13342, BgL_nsz00_13341); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13343;
BgL_ez00_13343 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13343, BgL_sz00_13336); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13344;
BgL_____rz00_13344 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11122, BgL_nsz00_13341, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13343); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13342, BgL_sz00_13336); 
return BgL_____rz00_13344;} } } } } } } } 

}



/* &run4221 */
obj_t BGl_z62run4221z62zz__evaluate_compz00(obj_t BgL_envz00_11125, obj_t BgL_sz00_11130)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11126;obj_t BgL_valza2za2_11127;BgL_ev_absz00_bglt BgL_i1244z00_11128;obj_t BgL_bodyz00_11129;
BgL_siza7eza7_11126 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11125, 
(int)(((long)0)))); 
BgL_valza2za2_11127 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11125, 
(int)(((long)1)))); 
BgL_i1244z00_11128 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11125, 
(int)(((long)2)))); 
BgL_bodyz00_11129 = 
PROCEDURE_REF(BgL_envz00_11125, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13345;
BgL_bpz00_13345 = 
VECTOR_REF(
((obj_t)BgL_sz00_11130),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11130, BgL_valza2za2_11127, 
(
(long)CINT(BgL_bpz00_13345)+BgL_siza7eza7_11126)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13346;obj_t BgL_wherez00_13347;obj_t BgL_locz00_13348;
BgL_z12denvz12_13346 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13347 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11128))->BgL_wherez00); 
BgL_locz00_13348 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11128))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13346, BgL_wherez00_13347, BgL_locz00_13348); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13349;
BgL_za2za2resza2za2z00_13349 = 
PROCEDURE_ENTRY(BgL_bodyz00_11129)(BgL_bodyz00_11129, BgL_sz00_11130, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13346); 
return BgL_za2za2resza2za2z00_13349;} } } } } } 

}



/* &<@anonymous:3278> */
obj_t BGl_z62zc3z04anonymousza33278ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11131, obj_t BgL_sz00_11138)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11132;obj_t BgL_iboxesz00_11133;long BgL_siza7eza7_11134;BgL_ev_absz00_bglt BgL_i1244z00_11135;obj_t BgL_bodyz00_11136;long BgL_siza7ezd2framez75_11137;
BgL_ifreesz00_11132 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)0)))); 
BgL_iboxesz00_11133 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)1)))); 
BgL_siza7eza7_11134 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)2)))); 
BgL_i1244z00_11135 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)3)))); 
BgL_bodyz00_11136 = 
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11137 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13350;
BgL_bpz00_13350 = 
VECTOR_REF(
((obj_t)BgL_sz00_11138),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13351;
BgL_valza2za2_13351 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11138, BgL_bpz00_13350, BgL_ifreesz00_11132); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13352;
BgL_runz00_13352 = 
MAKE_FX_PROCEDURE(BGl_z62run4223z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13352, 
(int)(((long)0)), BgL_iboxesz00_11133); 
PROCEDURE_SET(BgL_runz00_13352, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11134)); 
PROCEDURE_SET(BgL_runz00_13352, 
(int)(((long)2)), BgL_valza2za2_13351); 
PROCEDURE_SET(BgL_runz00_13352, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11135)); 
PROCEDURE_SET(BgL_runz00_13352, 
(int)(((long)4)), BgL_bodyz00_11136); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13353;
BgL_mainz00_13353 = 
MAKE_FX_PROCEDURE(BGl_z62main4222z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13353, 
(int)(((long)0)), BgL_iboxesz00_11133); 
PROCEDURE_SET(BgL_mainz00_13353, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11134)); 
PROCEDURE_SET(BgL_mainz00_13353, 
(int)(((long)2)), BgL_valza2za2_13351); 
PROCEDURE_SET(BgL_mainz00_13353, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11135)); 
PROCEDURE_SET(BgL_mainz00_13353, 
(int)(((long)4)), BgL_bodyz00_11136); 
PROCEDURE_SET(BgL_mainz00_13353, 
(int)(((long)5)), BgL_runz00_13352); 
PROCEDURE_SET(BgL_mainz00_13353, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11137)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13354;
BgL_objz00_13354 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13352, BgL_objz00_13354); BgL_objz00_13354; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3279z00_13355;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3280z00_13356;
BgL_arg3280z00_13356 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11135))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13357;
BgL_newz00_13357 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25466;
BgL_tmpz00_25466 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13357, BgL_tmpz00_25466, BgL_arg3280z00_13356); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25471;int BgL_tmpz00_25469;
BgL_auxz00_25471 = 
BINT(BgL_siza7ezd2framez75_11137); 
BgL_tmpz00_25469 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13357, BgL_tmpz00_25469, BgL_auxz00_25471); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25474;
BgL_tmpz00_25474 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13357, BgL_tmpz00_25474, BgL_runz00_13352); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25479;int BgL_tmpz00_25477;
BgL_auxz00_25479 = 
BINT(((long)1)); 
BgL_tmpz00_25477 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13357, BgL_tmpz00_25477, BgL_auxz00_25479); } 
BgL_arg3279z00_13355 = BgL_newz00_13357; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13353, BgL_arg3279z00_13355); BgL_arg3279z00_13355; } 
return BgL_mainz00_13353;} } } } } } 

}



/* &main4222 */
obj_t BGl_z62main4222z62zz__evaluate_compz00(obj_t BgL_envz00_11139, obj_t BgL_dz00_11147)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11145;long BgL_siza7ezd2framez75_11146;
BgL_runz00_11145 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11139, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11146 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11139, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13358;
BgL_sz00_13358 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13359;
BgL_bpz00_13359 = 
VECTOR_REF(
((obj_t)BgL_sz00_13358),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13358, BgL_bpz00_13359, 
BINT(BgL_siza7ezd2framez75_11146)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3283z00_13360;
BgL_arg3283z00_13360 = 
(
(long)CINT(BgL_bpz00_13359)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13358),BgL_arg3283z00_13360,BgL_dz00_11147); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13361;
BgL_ez00_13361 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13361, BgL_bpz00_13359); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13362;
BgL_accz00_13362 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11145, BgL_sz00_13358, BgL_bpz00_13359); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13361); 
VECTOR_SET(
((obj_t)BgL_sz00_13358),((long)0),BgL_bpz00_13359); 
return BgL_accz00_13362;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13363;
BgL_nsz00_13363 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13363,((long)1),BgL_sz00_13358); 
VECTOR_SET(BgL_nsz00_13363,((long)2),BgL_dz00_11147); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13364;
BgL_z12denvz12_13364 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13364, BgL_nsz00_13363); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13365;
BgL_ez00_13365 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13365, BgL_sz00_13358); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13366;
BgL_____rz00_13366 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11145, BgL_nsz00_13363, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13365); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13364, BgL_sz00_13358); 
return BgL_____rz00_13366;} } } } } } } } 

}



/* &run4223 */
obj_t BGl_z62run4223z62zz__evaluate_compz00(obj_t BgL_envz00_11148, obj_t BgL_sz00_11154)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11149;long BgL_siza7eza7_11150;obj_t BgL_valza2za2_11151;BgL_ev_absz00_bglt BgL_i1244z00_11152;obj_t BgL_bodyz00_11153;
BgL_iboxesz00_11149 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11148, 
(int)(((long)0)))); 
BgL_siza7eza7_11150 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11148, 
(int)(((long)1)))); 
BgL_valza2za2_11151 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11148, 
(int)(((long)2)))); 
BgL_i1244z00_11152 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11148, 
(int)(((long)3)))); 
BgL_bodyz00_11153 = 
PROCEDURE_REF(BgL_envz00_11148, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13367;
BgL_bpz00_13367 = 
VECTOR_REF(
((obj_t)BgL_sz00_11154),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11154, BgL_iboxesz00_11149, BgL_bpz00_13367); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11154, BgL_valza2za2_11151, 
(
(long)CINT(BgL_bpz00_13367)+BgL_siza7eza7_11150)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13368;obj_t BgL_wherez00_13369;obj_t BgL_locz00_13370;
BgL_z12denvz12_13368 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13369 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11152))->BgL_wherez00); 
BgL_locz00_13370 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11152))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13368, BgL_wherez00_13369, BgL_locz00_13370); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13371;
BgL_za2za2resza2za2z00_13371 = 
PROCEDURE_ENTRY(BgL_bodyz00_11153)(BgL_bodyz00_11153, BgL_sz00_11154, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13368); 
return BgL_za2za2resza2za2z00_13371;} } } } } } 

}



/* &<@anonymous:3214> */
obj_t BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11155, obj_t BgL_sz00_11159)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11156;obj_t BgL_bodyz00_11157;long BgL_siza7ezd2framez75_11158;
BgL_i1244z00_11156 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11155, 
(int)(((long)0)))); 
BgL_bodyz00_11157 = 
PROCEDURE_REF(BgL_envz00_11155, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11158 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11155, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13372;
BgL_bpz00_13372 = 
VECTOR_REF(
((obj_t)BgL_sz00_11159),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13373;
BgL_runz00_13373 = 
MAKE_FX_PROCEDURE(BGl_z62run4225z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13373, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11156)); 
PROCEDURE_SET(BgL_runz00_13373, 
(int)(((long)1)), BgL_bodyz00_11157); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13374;
BgL_mainz00_13374 = 
MAKE_VA_PROCEDURE(BGl_z62main4224z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13374, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11156)); 
PROCEDURE_SET(BgL_mainz00_13374, 
(int)(((long)1)), BgL_bodyz00_11157); 
PROCEDURE_SET(BgL_mainz00_13374, 
(int)(((long)2)), BgL_runz00_13373); 
PROCEDURE_SET(BgL_mainz00_13374, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11158)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13375;
BgL_objz00_13375 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13373, BgL_objz00_13375); BgL_objz00_13375; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3215z00_13376;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3216z00_13377;
BgL_arg3216z00_13377 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11156))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13378;
BgL_newz00_13378 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25580;
BgL_tmpz00_25580 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13378, BgL_tmpz00_25580, BgL_arg3216z00_13377); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25585;int BgL_tmpz00_25583;
BgL_auxz00_25585 = 
BINT(BgL_siza7ezd2framez75_11158); 
BgL_tmpz00_25583 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13378, BgL_tmpz00_25583, BgL_auxz00_25585); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25588;
BgL_tmpz00_25588 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13378, BgL_tmpz00_25588, BgL_runz00_13373); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25593;int BgL_tmpz00_25591;
BgL_auxz00_25593 = 
BINT(((long)-1)); 
BgL_tmpz00_25591 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13378, BgL_tmpz00_25591, BgL_auxz00_25593); } 
BgL_arg3215z00_13376 = BgL_newz00_13378; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13374, BgL_arg3215z00_13376); BgL_arg3215z00_13376; } 
return BgL_mainz00_13374;} } } } } } 

}



/* &main4224 */
obj_t BGl_z62main4224z62zz__evaluate_compz00(obj_t BgL_envz00_11160, obj_t BgL_lastz00_11165)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11163;long BgL_siza7ezd2framez75_11164;
BgL_runz00_11163 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11160, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11164 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11160, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13379;
BgL_sz00_13379 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13380;
BgL_bpz00_13380 = 
VECTOR_REF(
((obj_t)BgL_sz00_13379),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13379, BgL_bpz00_13380, 
BINT(BgL_siza7ezd2framez75_11164)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3219z00_13381;
BgL_arg3219z00_13381 = 
(
(long)CINT(BgL_bpz00_13380)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13379),BgL_arg3219z00_13381,BgL_lastz00_11165); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13382;
BgL_ez00_13382 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13382, BgL_bpz00_13380); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13383;
BgL_accz00_13383 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11163, BgL_sz00_13379, BgL_bpz00_13380); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13382); 
VECTOR_SET(
((obj_t)BgL_sz00_13379),((long)0),BgL_bpz00_13380); 
return BgL_accz00_13383;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13384;
BgL_nsz00_13384 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13384,((long)1),BgL_sz00_13379); 
VECTOR_SET(BgL_nsz00_13384,((long)2),BgL_lastz00_11165); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13385;
BgL_z12denvz12_13385 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13385, BgL_nsz00_13384); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13386;
BgL_ez00_13386 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13386, BgL_sz00_13379); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13387;
BgL_____rz00_13387 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11163, BgL_nsz00_13384, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13386); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13385, BgL_sz00_13379); 
return BgL_____rz00_13387;} } } } } } } } 

}



/* &run4225 */
obj_t BGl_z62run4225z62zz__evaluate_compz00(obj_t BgL_envz00_11166, obj_t BgL_sz00_11169)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11167;obj_t BgL_bodyz00_11168;
BgL_i1244z00_11167 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11166, 
(int)(((long)0)))); 
BgL_bodyz00_11168 = 
PROCEDURE_REF(BgL_envz00_11166, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13388;
BgL_bpz00_13388 = 
VECTOR_REF(
((obj_t)BgL_sz00_11169),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13389;obj_t BgL_wherez00_13390;obj_t BgL_locz00_13391;
BgL_z12denvz12_13389 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13390 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11167))->BgL_wherez00); 
BgL_locz00_13391 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11167))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13389, BgL_wherez00_13390, BgL_locz00_13391); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13392;
BgL_za2za2resza2za2z00_13392 = 
PROCEDURE_ENTRY(BgL_bodyz00_11168)(BgL_bodyz00_11168, BgL_sz00_11169, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13389); 
return BgL_za2za2resza2za2z00_13392;} } } } } } 

}



/* &<@anonymous:3221> */
obj_t BGl_z62zc3z04anonymousza33221ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11170, obj_t BgL_sz00_11175)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11171;BgL_ev_absz00_bglt BgL_i1244z00_11172;obj_t BgL_bodyz00_11173;long BgL_siza7ezd2framez75_11174;
BgL_iboxesz00_11171 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11170, 
(int)(((long)0)))); 
BgL_i1244z00_11172 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11170, 
(int)(((long)1)))); 
BgL_bodyz00_11173 = 
PROCEDURE_REF(BgL_envz00_11170, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11174 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11170, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13393;
BgL_bpz00_13393 = 
VECTOR_REF(
((obj_t)BgL_sz00_11175),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13394;
BgL_runz00_13394 = 
MAKE_FX_PROCEDURE(BGl_z62run4227z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13394, 
(int)(((long)0)), BgL_iboxesz00_11171); 
PROCEDURE_SET(BgL_runz00_13394, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11172)); 
PROCEDURE_SET(BgL_runz00_13394, 
(int)(((long)2)), BgL_bodyz00_11173); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13395;
BgL_mainz00_13395 = 
MAKE_VA_PROCEDURE(BGl_z62main4226z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13395, 
(int)(((long)0)), BgL_iboxesz00_11171); 
PROCEDURE_SET(BgL_mainz00_13395, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11172)); 
PROCEDURE_SET(BgL_mainz00_13395, 
(int)(((long)2)), BgL_bodyz00_11173); 
PROCEDURE_SET(BgL_mainz00_13395, 
(int)(((long)3)), BgL_runz00_13394); 
PROCEDURE_SET(BgL_mainz00_13395, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11174)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13396;
BgL_objz00_13396 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13394, BgL_objz00_13396); BgL_objz00_13396; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3222z00_13397;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3223z00_13398;
BgL_arg3223z00_13398 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11172))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13399;
BgL_newz00_13399 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25688;
BgL_tmpz00_25688 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13399, BgL_tmpz00_25688, BgL_arg3223z00_13398); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25693;int BgL_tmpz00_25691;
BgL_auxz00_25693 = 
BINT(BgL_siza7ezd2framez75_11174); 
BgL_tmpz00_25691 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13399, BgL_tmpz00_25691, BgL_auxz00_25693); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25696;
BgL_tmpz00_25696 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13399, BgL_tmpz00_25696, BgL_runz00_13394); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25701;int BgL_tmpz00_25699;
BgL_auxz00_25701 = 
BINT(((long)-1)); 
BgL_tmpz00_25699 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13399, BgL_tmpz00_25699, BgL_auxz00_25701); } 
BgL_arg3222z00_13397 = BgL_newz00_13399; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13395, BgL_arg3222z00_13397); BgL_arg3222z00_13397; } 
return BgL_mainz00_13395;} } } } } } 

}



/* &main4226 */
obj_t BGl_z62main4226z62zz__evaluate_compz00(obj_t BgL_envz00_11176, obj_t BgL_lastz00_11182)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11180;long BgL_siza7ezd2framez75_11181;
BgL_runz00_11180 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11176, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11181 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11176, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13400;
BgL_sz00_13400 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13401;
BgL_bpz00_13401 = 
VECTOR_REF(
((obj_t)BgL_sz00_13400),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13400, BgL_bpz00_13401, 
BINT(BgL_siza7ezd2framez75_11181)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3226z00_13402;
BgL_arg3226z00_13402 = 
(
(long)CINT(BgL_bpz00_13401)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13400),BgL_arg3226z00_13402,BgL_lastz00_11182); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13403;
BgL_ez00_13403 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13403, BgL_bpz00_13401); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13404;
BgL_accz00_13404 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11180, BgL_sz00_13400, BgL_bpz00_13401); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13403); 
VECTOR_SET(
((obj_t)BgL_sz00_13400),((long)0),BgL_bpz00_13401); 
return BgL_accz00_13404;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13405;
BgL_nsz00_13405 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13405,((long)1),BgL_sz00_13400); 
VECTOR_SET(BgL_nsz00_13405,((long)2),BgL_lastz00_11182); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13406;
BgL_z12denvz12_13406 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13406, BgL_nsz00_13405); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13407;
BgL_ez00_13407 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13407, BgL_sz00_13400); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13408;
BgL_____rz00_13408 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11180, BgL_nsz00_13405, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13407); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13406, BgL_sz00_13400); 
return BgL_____rz00_13408;} } } } } } } } 

}



/* &run4227 */
obj_t BGl_z62run4227z62zz__evaluate_compz00(obj_t BgL_envz00_11183, obj_t BgL_sz00_11187)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11184;BgL_ev_absz00_bglt BgL_i1244z00_11185;obj_t BgL_bodyz00_11186;
BgL_iboxesz00_11184 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11183, 
(int)(((long)0)))); 
BgL_i1244z00_11185 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11183, 
(int)(((long)1)))); 
BgL_bodyz00_11186 = 
PROCEDURE_REF(BgL_envz00_11183, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13409;
BgL_bpz00_13409 = 
VECTOR_REF(
((obj_t)BgL_sz00_11187),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11187, BgL_iboxesz00_11184, BgL_bpz00_13409); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13410;obj_t BgL_wherez00_13411;obj_t BgL_locz00_13412;
BgL_z12denvz12_13410 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13411 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11185))->BgL_wherez00); 
BgL_locz00_13412 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11185))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13410, BgL_wherez00_13411, BgL_locz00_13412); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13413;
BgL_za2za2resza2za2z00_13413 = 
PROCEDURE_ENTRY(BgL_bodyz00_11186)(BgL_bodyz00_11186, BgL_sz00_11187, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13410); 
return BgL_za2za2resza2za2z00_13413;} } } } } } 

}



/* &<@anonymous:3231> */
obj_t BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11188, obj_t BgL_sz00_11194)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11189;long BgL_siza7eza7_11190;BgL_ev_absz00_bglt BgL_i1244z00_11191;obj_t BgL_bodyz00_11192;long BgL_siza7ezd2framez75_11193;
BgL_ifreesz00_11189 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11188, 
(int)(((long)0)))); 
BgL_siza7eza7_11190 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11188, 
(int)(((long)1)))); 
BgL_i1244z00_11191 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11188, 
(int)(((long)2)))); 
BgL_bodyz00_11192 = 
PROCEDURE_REF(BgL_envz00_11188, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11193 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11188, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13414;
BgL_bpz00_13414 = 
VECTOR_REF(
((obj_t)BgL_sz00_11194),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13415;
BgL_valza2za2_13415 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11194, BgL_bpz00_13414, BgL_ifreesz00_11189); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13416;
BgL_runz00_13416 = 
MAKE_FX_PROCEDURE(BGl_z62run4229z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13416, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11190)); 
PROCEDURE_SET(BgL_runz00_13416, 
(int)(((long)1)), BgL_valza2za2_13415); 
PROCEDURE_SET(BgL_runz00_13416, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11191)); 
PROCEDURE_SET(BgL_runz00_13416, 
(int)(((long)3)), BgL_bodyz00_11192); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13417;
BgL_mainz00_13417 = 
MAKE_VA_PROCEDURE(BGl_z62main4228z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13417, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11190)); 
PROCEDURE_SET(BgL_mainz00_13417, 
(int)(((long)1)), BgL_valza2za2_13415); 
PROCEDURE_SET(BgL_mainz00_13417, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11191)); 
PROCEDURE_SET(BgL_mainz00_13417, 
(int)(((long)3)), BgL_bodyz00_11192); 
PROCEDURE_SET(BgL_mainz00_13417, 
(int)(((long)4)), BgL_runz00_13416); 
PROCEDURE_SET(BgL_mainz00_13417, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11193)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13418;
BgL_objz00_13418 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13416, BgL_objz00_13418); BgL_objz00_13418; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3232z00_13419;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3233z00_13420;
BgL_arg3233z00_13420 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11191))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13421;
BgL_newz00_13421 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25810;
BgL_tmpz00_25810 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13421, BgL_tmpz00_25810, BgL_arg3233z00_13420); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25815;int BgL_tmpz00_25813;
BgL_auxz00_25815 = 
BINT(BgL_siza7ezd2framez75_11193); 
BgL_tmpz00_25813 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13421, BgL_tmpz00_25813, BgL_auxz00_25815); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25818;
BgL_tmpz00_25818 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13421, BgL_tmpz00_25818, BgL_runz00_13416); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25823;int BgL_tmpz00_25821;
BgL_auxz00_25823 = 
BINT(((long)-1)); 
BgL_tmpz00_25821 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13421, BgL_tmpz00_25821, BgL_auxz00_25823); } 
BgL_arg3232z00_13419 = BgL_newz00_13421; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13417, BgL_arg3232z00_13419); BgL_arg3232z00_13419; } 
return BgL_mainz00_13417;} } } } } } 

}



/* &main4228 */
obj_t BGl_z62main4228z62zz__evaluate_compz00(obj_t BgL_envz00_11195, obj_t BgL_lastz00_11202)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11200;long BgL_siza7ezd2framez75_11201;
BgL_runz00_11200 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11195, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11201 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11195, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13422;
BgL_sz00_13422 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13423;
BgL_bpz00_13423 = 
VECTOR_REF(
((obj_t)BgL_sz00_13422),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13422, BgL_bpz00_13423, 
BINT(BgL_siza7ezd2framez75_11201)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3236z00_13424;
BgL_arg3236z00_13424 = 
(
(long)CINT(BgL_bpz00_13423)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13422),BgL_arg3236z00_13424,BgL_lastz00_11202); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13425;
BgL_ez00_13425 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13425, BgL_bpz00_13423); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13426;
BgL_accz00_13426 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11200, BgL_sz00_13422, BgL_bpz00_13423); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13425); 
VECTOR_SET(
((obj_t)BgL_sz00_13422),((long)0),BgL_bpz00_13423); 
return BgL_accz00_13426;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13427;
BgL_nsz00_13427 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13427,((long)1),BgL_sz00_13422); 
VECTOR_SET(BgL_nsz00_13427,((long)2),BgL_lastz00_11202); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13428;
BgL_z12denvz12_13428 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13428, BgL_nsz00_13427); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13429;
BgL_ez00_13429 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13429, BgL_sz00_13422); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13430;
BgL_____rz00_13430 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11200, BgL_nsz00_13427, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13429); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13428, BgL_sz00_13422); 
return BgL_____rz00_13430;} } } } } } } } 

}



/* &run4229 */
obj_t BGl_z62run4229z62zz__evaluate_compz00(obj_t BgL_envz00_11203, obj_t BgL_sz00_11208)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11204;obj_t BgL_valza2za2_11205;BgL_ev_absz00_bglt BgL_i1244z00_11206;obj_t BgL_bodyz00_11207;
BgL_siza7eza7_11204 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11203, 
(int)(((long)0)))); 
BgL_valza2za2_11205 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11203, 
(int)(((long)1)))); 
BgL_i1244z00_11206 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11203, 
(int)(((long)2)))); 
BgL_bodyz00_11207 = 
PROCEDURE_REF(BgL_envz00_11203, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13431;
BgL_bpz00_13431 = 
VECTOR_REF(
((obj_t)BgL_sz00_11208),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11208, BgL_valza2za2_11205, 
(
(long)CINT(BgL_bpz00_13431)+BgL_siza7eza7_11204)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13432;obj_t BgL_wherez00_13433;obj_t BgL_locz00_13434;
BgL_z12denvz12_13432 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13433 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11206))->BgL_wherez00); 
BgL_locz00_13434 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11206))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13432, BgL_wherez00_13433, BgL_locz00_13434); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13435;
BgL_za2za2resza2za2z00_13435 = 
PROCEDURE_ENTRY(BgL_bodyz00_11207)(BgL_bodyz00_11207, BgL_sz00_11208, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13432); 
return BgL_za2za2resza2za2z00_13435;} } } } } } 

}



/* &<@anonymous:3239> */
obj_t BGl_z62zc3z04anonymousza33239ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11209, obj_t BgL_sz00_11216)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11210;obj_t BgL_iboxesz00_11211;long BgL_siza7eza7_11212;BgL_ev_absz00_bglt BgL_i1244z00_11213;obj_t BgL_bodyz00_11214;long BgL_siza7ezd2framez75_11215;
BgL_ifreesz00_11210 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11209, 
(int)(((long)0)))); 
BgL_iboxesz00_11211 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11209, 
(int)(((long)1)))); 
BgL_siza7eza7_11212 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11209, 
(int)(((long)2)))); 
BgL_i1244z00_11213 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11209, 
(int)(((long)3)))); 
BgL_bodyz00_11214 = 
PROCEDURE_REF(BgL_envz00_11209, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11215 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11209, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13436;
BgL_bpz00_13436 = 
VECTOR_REF(
((obj_t)BgL_sz00_11216),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13437;
BgL_valza2za2_13437 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11216, BgL_bpz00_13436, BgL_ifreesz00_11210); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13438;
BgL_runz00_13438 = 
MAKE_FX_PROCEDURE(BGl_z62run4231z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13438, 
(int)(((long)0)), BgL_iboxesz00_11211); 
PROCEDURE_SET(BgL_runz00_13438, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11212)); 
PROCEDURE_SET(BgL_runz00_13438, 
(int)(((long)2)), BgL_valza2za2_13437); 
PROCEDURE_SET(BgL_runz00_13438, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11213)); 
PROCEDURE_SET(BgL_runz00_13438, 
(int)(((long)4)), BgL_bodyz00_11214); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13439;
BgL_mainz00_13439 = 
MAKE_VA_PROCEDURE(BGl_z62main4230z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13439, 
(int)(((long)0)), BgL_iboxesz00_11211); 
PROCEDURE_SET(BgL_mainz00_13439, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11212)); 
PROCEDURE_SET(BgL_mainz00_13439, 
(int)(((long)2)), BgL_valza2za2_13437); 
PROCEDURE_SET(BgL_mainz00_13439, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11213)); 
PROCEDURE_SET(BgL_mainz00_13439, 
(int)(((long)4)), BgL_bodyz00_11214); 
PROCEDURE_SET(BgL_mainz00_13439, 
(int)(((long)5)), BgL_runz00_13438); 
PROCEDURE_SET(BgL_mainz00_13439, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11215)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13440;
BgL_objz00_13440 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13438, BgL_objz00_13440); BgL_objz00_13440; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3240z00_13441;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3241z00_13442;
BgL_arg3241z00_13442 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11213))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13443;
BgL_newz00_13443 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25944;
BgL_tmpz00_25944 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13443, BgL_tmpz00_25944, BgL_arg3241z00_13442); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25949;int BgL_tmpz00_25947;
BgL_auxz00_25949 = 
BINT(BgL_siza7ezd2framez75_11215); 
BgL_tmpz00_25947 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13443, BgL_tmpz00_25947, BgL_auxz00_25949); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25952;
BgL_tmpz00_25952 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13443, BgL_tmpz00_25952, BgL_runz00_13438); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25957;int BgL_tmpz00_25955;
BgL_auxz00_25957 = 
BINT(((long)-1)); 
BgL_tmpz00_25955 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13443, BgL_tmpz00_25955, BgL_auxz00_25957); } 
BgL_arg3240z00_13441 = BgL_newz00_13443; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13439, BgL_arg3240z00_13441); BgL_arg3240z00_13441; } 
return BgL_mainz00_13439;} } } } } } 

}



/* &main4230 */
obj_t BGl_z62main4230z62zz__evaluate_compz00(obj_t BgL_envz00_11217, obj_t BgL_lastz00_11225)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11223;long BgL_siza7ezd2framez75_11224;
BgL_runz00_11223 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11217, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11224 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11217, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13444;
BgL_sz00_13444 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13445;
BgL_bpz00_13445 = 
VECTOR_REF(
((obj_t)BgL_sz00_13444),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13444, BgL_bpz00_13445, 
BINT(BgL_siza7ezd2framez75_11224)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3244z00_13446;
BgL_arg3244z00_13446 = 
(
(long)CINT(BgL_bpz00_13445)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13444),BgL_arg3244z00_13446,BgL_lastz00_11225); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13447;
BgL_ez00_13447 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13447, BgL_bpz00_13445); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13448;
BgL_accz00_13448 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11223, BgL_sz00_13444, BgL_bpz00_13445); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13447); 
VECTOR_SET(
((obj_t)BgL_sz00_13444),((long)0),BgL_bpz00_13445); 
return BgL_accz00_13448;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13449;
BgL_nsz00_13449 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13449,((long)1),BgL_sz00_13444); 
VECTOR_SET(BgL_nsz00_13449,((long)2),BgL_lastz00_11225); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13450;
BgL_z12denvz12_13450 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13450, BgL_nsz00_13449); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13451;
BgL_ez00_13451 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13451, BgL_sz00_13444); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13452;
BgL_____rz00_13452 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11223, BgL_nsz00_13449, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13451); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13450, BgL_sz00_13444); 
return BgL_____rz00_13452;} } } } } } } } 

}



/* &run4231 */
obj_t BGl_z62run4231z62zz__evaluate_compz00(obj_t BgL_envz00_11226, obj_t BgL_sz00_11232)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11227;long BgL_siza7eza7_11228;obj_t BgL_valza2za2_11229;BgL_ev_absz00_bglt BgL_i1244z00_11230;obj_t BgL_bodyz00_11231;
BgL_iboxesz00_11227 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11226, 
(int)(((long)0)))); 
BgL_siza7eza7_11228 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11226, 
(int)(((long)1)))); 
BgL_valza2za2_11229 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11226, 
(int)(((long)2)))); 
BgL_i1244z00_11230 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11226, 
(int)(((long)3)))); 
BgL_bodyz00_11231 = 
PROCEDURE_REF(BgL_envz00_11226, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13453;
BgL_bpz00_13453 = 
VECTOR_REF(
((obj_t)BgL_sz00_11232),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11232, BgL_iboxesz00_11227, BgL_bpz00_13453); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11232, BgL_valza2za2_11229, 
(
(long)CINT(BgL_bpz00_13453)+BgL_siza7eza7_11228)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13454;obj_t BgL_wherez00_13455;obj_t BgL_locz00_13456;
BgL_z12denvz12_13454 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13455 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11230))->BgL_wherez00); 
BgL_locz00_13456 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11230))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13454, BgL_wherez00_13455, BgL_locz00_13456); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13457;
BgL_za2za2resza2za2z00_13457 = 
PROCEDURE_ENTRY(BgL_bodyz00_11231)(BgL_bodyz00_11231, BgL_sz00_11232, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13454); 
return BgL_za2za2resza2za2z00_13457;} } } } } } 

}



/* &<@anonymous:3179> */
obj_t BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11233, obj_t BgL_sz00_11237)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11234;obj_t BgL_bodyz00_11235;long BgL_siza7ezd2framez75_11236;
BgL_i1244z00_11234 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11233, 
(int)(((long)0)))); 
BgL_bodyz00_11235 = 
PROCEDURE_REF(BgL_envz00_11233, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11236 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11233, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13458;
BgL_bpz00_13458 = 
VECTOR_REF(
((obj_t)BgL_sz00_11237),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13459;
BgL_runz00_13459 = 
MAKE_FX_PROCEDURE(BGl_z62run4233z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13459, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11234)); 
PROCEDURE_SET(BgL_runz00_13459, 
(int)(((long)1)), BgL_bodyz00_11235); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13460;
BgL_mainz00_13460 = 
MAKE_FX_PROCEDURE(BGl_z62main4232z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13460, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11234)); 
PROCEDURE_SET(BgL_mainz00_13460, 
(int)(((long)1)), BgL_bodyz00_11235); 
PROCEDURE_SET(BgL_mainz00_13460, 
(int)(((long)2)), BgL_runz00_13459); 
PROCEDURE_SET(BgL_mainz00_13460, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11236)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13461;
BgL_objz00_13461 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13459, BgL_objz00_13461); BgL_objz00_13461; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3180z00_13462;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3181z00_13463;
BgL_arg3181z00_13463 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11234))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13464;
BgL_newz00_13464 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26058;
BgL_tmpz00_26058 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13464, BgL_tmpz00_26058, BgL_arg3181z00_13463); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26063;int BgL_tmpz00_26061;
BgL_auxz00_26063 = 
BINT(BgL_siza7ezd2framez75_11236); 
BgL_tmpz00_26061 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13464, BgL_tmpz00_26061, BgL_auxz00_26063); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26066;
BgL_tmpz00_26066 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13464, BgL_tmpz00_26066, BgL_runz00_13459); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26071;int BgL_tmpz00_26069;
BgL_auxz00_26071 = 
BINT(((long)0)); 
BgL_tmpz00_26069 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13464, BgL_tmpz00_26069, BgL_auxz00_26071); } 
BgL_arg3180z00_13462 = BgL_newz00_13464; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13460, BgL_arg3180z00_13462); BgL_arg3180z00_13462; } 
return BgL_mainz00_13460;} } } } } } 

}



/* &main4232 */
obj_t BGl_z62main4232z62zz__evaluate_compz00(obj_t BgL_envz00_11238)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11241;long BgL_siza7ezd2framez75_11242;
BgL_runz00_11241 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11238, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11242 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11238, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13465;
BgL_sz00_13465 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13466;
BgL_bpz00_13466 = 
VECTOR_REF(
((obj_t)BgL_sz00_13465),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13465, BgL_bpz00_13466, 
BINT(BgL_siza7ezd2framez75_11242)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13467;
BgL_ez00_13467 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13467, BgL_bpz00_13466); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13468;
BgL_accz00_13468 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11241, BgL_sz00_13465, BgL_bpz00_13466); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13467); 
VECTOR_SET(
((obj_t)BgL_sz00_13465),((long)0),BgL_bpz00_13466); 
return BgL_accz00_13468;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13469;
BgL_nsz00_13469 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13469,((long)1),BgL_sz00_13465); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13470;
BgL_z12denvz12_13470 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13470, BgL_nsz00_13469); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13471;
BgL_ez00_13471 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13471, BgL_sz00_13465); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13472;
BgL_____rz00_13472 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11241, BgL_nsz00_13469, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13471); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13470, BgL_sz00_13465); 
return BgL_____rz00_13472;} } } } } } } } 

}



/* &run4233 */
obj_t BGl_z62run4233z62zz__evaluate_compz00(obj_t BgL_envz00_11243, obj_t BgL_sz00_11246)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11244;obj_t BgL_bodyz00_11245;
BgL_i1244z00_11244 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11243, 
(int)(((long)0)))); 
BgL_bodyz00_11245 = 
PROCEDURE_REF(BgL_envz00_11243, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13473;
BgL_bpz00_13473 = 
VECTOR_REF(
((obj_t)BgL_sz00_11246),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13474;obj_t BgL_wherez00_13475;obj_t BgL_locz00_13476;
BgL_z12denvz12_13474 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13475 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11244))->BgL_wherez00); 
BgL_locz00_13476 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11244))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13474, BgL_wherez00_13475, BgL_locz00_13476); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13477;
BgL_za2za2resza2za2z00_13477 = 
PROCEDURE_ENTRY(BgL_bodyz00_11245)(BgL_bodyz00_11245, BgL_sz00_11246, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13474); 
return BgL_za2za2resza2za2z00_13477;} } } } } } 

}



/* &<@anonymous:3185> */
obj_t BGl_z62zc3z04anonymousza33185ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11247, obj_t BgL_sz00_11252)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11248;BgL_ev_absz00_bglt BgL_i1244z00_11249;obj_t BgL_bodyz00_11250;long BgL_siza7ezd2framez75_11251;
BgL_iboxesz00_11248 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11247, 
(int)(((long)0)))); 
BgL_i1244z00_11249 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11247, 
(int)(((long)1)))); 
BgL_bodyz00_11250 = 
PROCEDURE_REF(BgL_envz00_11247, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11251 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11247, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13478;
BgL_bpz00_13478 = 
VECTOR_REF(
((obj_t)BgL_sz00_11252),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13479;
BgL_runz00_13479 = 
MAKE_FX_PROCEDURE(BGl_z62run4235z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13479, 
(int)(((long)0)), BgL_iboxesz00_11248); 
PROCEDURE_SET(BgL_runz00_13479, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11249)); 
PROCEDURE_SET(BgL_runz00_13479, 
(int)(((long)2)), BgL_bodyz00_11250); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13480;
BgL_mainz00_13480 = 
MAKE_FX_PROCEDURE(BGl_z62main4234z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13480, 
(int)(((long)0)), BgL_iboxesz00_11248); 
PROCEDURE_SET(BgL_mainz00_13480, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11249)); 
PROCEDURE_SET(BgL_mainz00_13480, 
(int)(((long)2)), BgL_bodyz00_11250); 
PROCEDURE_SET(BgL_mainz00_13480, 
(int)(((long)3)), BgL_runz00_13479); 
PROCEDURE_SET(BgL_mainz00_13480, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11251)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13481;
BgL_objz00_13481 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13479, BgL_objz00_13481); BgL_objz00_13481; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3186z00_13482;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3187z00_13483;
BgL_arg3187z00_13483 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11249))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13484;
BgL_newz00_13484 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26161;
BgL_tmpz00_26161 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13484, BgL_tmpz00_26161, BgL_arg3187z00_13483); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26166;int BgL_tmpz00_26164;
BgL_auxz00_26166 = 
BINT(BgL_siza7ezd2framez75_11251); 
BgL_tmpz00_26164 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13484, BgL_tmpz00_26164, BgL_auxz00_26166); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26169;
BgL_tmpz00_26169 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13484, BgL_tmpz00_26169, BgL_runz00_13479); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26174;int BgL_tmpz00_26172;
BgL_auxz00_26174 = 
BINT(((long)0)); 
BgL_tmpz00_26172 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13484, BgL_tmpz00_26172, BgL_auxz00_26174); } 
BgL_arg3186z00_13482 = BgL_newz00_13484; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13480, BgL_arg3186z00_13482); BgL_arg3186z00_13482; } 
return BgL_mainz00_13480;} } } } } } 

}



/* &main4234 */
obj_t BGl_z62main4234z62zz__evaluate_compz00(obj_t BgL_envz00_11253)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11257;long BgL_siza7ezd2framez75_11258;
BgL_runz00_11257 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11253, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11258 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11253, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13485;
BgL_sz00_13485 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13486;
BgL_bpz00_13486 = 
VECTOR_REF(
((obj_t)BgL_sz00_13485),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13485, BgL_bpz00_13486, 
BINT(BgL_siza7ezd2framez75_11258)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13487;
BgL_ez00_13487 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13487, BgL_bpz00_13486); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13488;
BgL_accz00_13488 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11257, BgL_sz00_13485, BgL_bpz00_13486); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13487); 
VECTOR_SET(
((obj_t)BgL_sz00_13485),((long)0),BgL_bpz00_13486); 
return BgL_accz00_13488;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13489;
BgL_nsz00_13489 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13489,((long)1),BgL_sz00_13485); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13490;
BgL_z12denvz12_13490 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13490, BgL_nsz00_13489); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13491;
BgL_ez00_13491 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13491, BgL_sz00_13485); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13492;
BgL_____rz00_13492 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11257, BgL_nsz00_13489, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13491); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13490, BgL_sz00_13485); 
return BgL_____rz00_13492;} } } } } } } } 

}



/* &run4235 */
obj_t BGl_z62run4235z62zz__evaluate_compz00(obj_t BgL_envz00_11259, obj_t BgL_sz00_11263)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11260;BgL_ev_absz00_bglt BgL_i1244z00_11261;obj_t BgL_bodyz00_11262;
BgL_iboxesz00_11260 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11259, 
(int)(((long)0)))); 
BgL_i1244z00_11261 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11259, 
(int)(((long)1)))); 
BgL_bodyz00_11262 = 
PROCEDURE_REF(BgL_envz00_11259, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13493;
BgL_bpz00_13493 = 
VECTOR_REF(
((obj_t)BgL_sz00_11263),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11263, BgL_iboxesz00_11260, BgL_bpz00_13493); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13494;obj_t BgL_wherez00_13495;obj_t BgL_locz00_13496;
BgL_z12denvz12_13494 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13495 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11261))->BgL_wherez00); 
BgL_locz00_13496 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11261))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13494, BgL_wherez00_13495, BgL_locz00_13496); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13497;
BgL_za2za2resza2za2z00_13497 = 
PROCEDURE_ENTRY(BgL_bodyz00_11262)(BgL_bodyz00_11262, BgL_sz00_11263, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13494); 
return BgL_za2za2resza2za2z00_13497;} } } } } } 

}



/* &<@anonymous:3194> */
obj_t BGl_z62zc3z04anonymousza33194ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11264, obj_t BgL_sz00_11270)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11265;long BgL_siza7eza7_11266;BgL_ev_absz00_bglt BgL_i1244z00_11267;obj_t BgL_bodyz00_11268;long BgL_siza7ezd2framez75_11269;
BgL_ifreesz00_11265 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11264, 
(int)(((long)0)))); 
BgL_siza7eza7_11266 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11264, 
(int)(((long)1)))); 
BgL_i1244z00_11267 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11264, 
(int)(((long)2)))); 
BgL_bodyz00_11268 = 
PROCEDURE_REF(BgL_envz00_11264, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11269 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11264, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13498;
BgL_bpz00_13498 = 
VECTOR_REF(
((obj_t)BgL_sz00_11270),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13499;
BgL_valza2za2_13499 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11270, BgL_bpz00_13498, BgL_ifreesz00_11265); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13500;
BgL_runz00_13500 = 
MAKE_FX_PROCEDURE(BGl_z62run4237z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13500, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11266)); 
PROCEDURE_SET(BgL_runz00_13500, 
(int)(((long)1)), BgL_valza2za2_13499); 
PROCEDURE_SET(BgL_runz00_13500, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11267)); 
PROCEDURE_SET(BgL_runz00_13500, 
(int)(((long)3)), BgL_bodyz00_11268); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13501;
BgL_mainz00_13501 = 
MAKE_FX_PROCEDURE(BGl_z62main4236z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13501, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11266)); 
PROCEDURE_SET(BgL_mainz00_13501, 
(int)(((long)1)), BgL_valza2za2_13499); 
PROCEDURE_SET(BgL_mainz00_13501, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11267)); 
PROCEDURE_SET(BgL_mainz00_13501, 
(int)(((long)3)), BgL_bodyz00_11268); 
PROCEDURE_SET(BgL_mainz00_13501, 
(int)(((long)4)), BgL_runz00_13500); 
PROCEDURE_SET(BgL_mainz00_13501, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11269)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13502;
BgL_objz00_13502 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13500, BgL_objz00_13502); BgL_objz00_13502; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3195z00_13503;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3196z00_13504;
BgL_arg3196z00_13504 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11267))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13505;
BgL_newz00_13505 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26278;
BgL_tmpz00_26278 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13505, BgL_tmpz00_26278, BgL_arg3196z00_13504); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26283;int BgL_tmpz00_26281;
BgL_auxz00_26283 = 
BINT(BgL_siza7ezd2framez75_11269); 
BgL_tmpz00_26281 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13505, BgL_tmpz00_26281, BgL_auxz00_26283); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26286;
BgL_tmpz00_26286 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13505, BgL_tmpz00_26286, BgL_runz00_13500); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26291;int BgL_tmpz00_26289;
BgL_auxz00_26291 = 
BINT(((long)0)); 
BgL_tmpz00_26289 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13505, BgL_tmpz00_26289, BgL_auxz00_26291); } 
BgL_arg3195z00_13503 = BgL_newz00_13505; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13501, BgL_arg3195z00_13503); BgL_arg3195z00_13503; } 
return BgL_mainz00_13501;} } } } } } 

}



/* &main4236 */
obj_t BGl_z62main4236z62zz__evaluate_compz00(obj_t BgL_envz00_11271)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11276;long BgL_siza7ezd2framez75_11277;
BgL_runz00_11276 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11271, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11277 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11271, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13506;
BgL_sz00_13506 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13507;
BgL_bpz00_13507 = 
VECTOR_REF(
((obj_t)BgL_sz00_13506),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13506, BgL_bpz00_13507, 
BINT(BgL_siza7ezd2framez75_11277)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13508;
BgL_ez00_13508 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13508, BgL_bpz00_13507); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13509;
BgL_accz00_13509 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11276, BgL_sz00_13506, BgL_bpz00_13507); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13508); 
VECTOR_SET(
((obj_t)BgL_sz00_13506),((long)0),BgL_bpz00_13507); 
return BgL_accz00_13509;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13510;
BgL_nsz00_13510 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13510,((long)1),BgL_sz00_13506); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13511;
BgL_z12denvz12_13511 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13511, BgL_nsz00_13510); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13512;
BgL_ez00_13512 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13512, BgL_sz00_13506); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13513;
BgL_____rz00_13513 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11276, BgL_nsz00_13510, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13512); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13511, BgL_sz00_13506); 
return BgL_____rz00_13513;} } } } } } } } 

}



/* &run4237 */
obj_t BGl_z62run4237z62zz__evaluate_compz00(obj_t BgL_envz00_11278, obj_t BgL_sz00_11283)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11279;obj_t BgL_valza2za2_11280;BgL_ev_absz00_bglt BgL_i1244z00_11281;obj_t BgL_bodyz00_11282;
BgL_siza7eza7_11279 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11278, 
(int)(((long)0)))); 
BgL_valza2za2_11280 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11278, 
(int)(((long)1)))); 
BgL_i1244z00_11281 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11278, 
(int)(((long)2)))); 
BgL_bodyz00_11282 = 
PROCEDURE_REF(BgL_envz00_11278, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13514;
BgL_bpz00_13514 = 
VECTOR_REF(
((obj_t)BgL_sz00_11283),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11283, BgL_valza2za2_11280, 
(
(long)CINT(BgL_bpz00_13514)+BgL_siza7eza7_11279)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13515;obj_t BgL_wherez00_13516;obj_t BgL_locz00_13517;
BgL_z12denvz12_13515 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13516 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11281))->BgL_wherez00); 
BgL_locz00_13517 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11281))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13515, BgL_wherez00_13516, BgL_locz00_13517); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13518;
BgL_za2za2resza2za2z00_13518 = 
PROCEDURE_ENTRY(BgL_bodyz00_11282)(BgL_bodyz00_11282, BgL_sz00_11283, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13515); 
return BgL_za2za2resza2za2z00_13518;} } } } } } 

}



/* &<@anonymous:3201> */
obj_t BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11284, obj_t BgL_sz00_11291)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11285;obj_t BgL_iboxesz00_11286;long BgL_siza7eza7_11287;BgL_ev_absz00_bglt BgL_i1244z00_11288;obj_t BgL_bodyz00_11289;long BgL_siza7ezd2framez75_11290;
BgL_ifreesz00_11285 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11284, 
(int)(((long)0)))); 
BgL_iboxesz00_11286 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11284, 
(int)(((long)1)))); 
BgL_siza7eza7_11287 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11284, 
(int)(((long)2)))); 
BgL_i1244z00_11288 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11284, 
(int)(((long)3)))); 
BgL_bodyz00_11289 = 
PROCEDURE_REF(BgL_envz00_11284, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11290 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11284, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13519;
BgL_bpz00_13519 = 
VECTOR_REF(
((obj_t)BgL_sz00_11291),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13520;
BgL_valza2za2_13520 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11291, BgL_bpz00_13519, BgL_ifreesz00_11285); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13521;
BgL_runz00_13521 = 
MAKE_FX_PROCEDURE(BGl_z62run4239z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13521, 
(int)(((long)0)), BgL_iboxesz00_11286); 
PROCEDURE_SET(BgL_runz00_13521, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11287)); 
PROCEDURE_SET(BgL_runz00_13521, 
(int)(((long)2)), BgL_valza2za2_13520); 
PROCEDURE_SET(BgL_runz00_13521, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11288)); 
PROCEDURE_SET(BgL_runz00_13521, 
(int)(((long)4)), BgL_bodyz00_11289); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13522;
BgL_mainz00_13522 = 
MAKE_FX_PROCEDURE(BGl_z62main4238z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13522, 
(int)(((long)0)), BgL_iboxesz00_11286); 
PROCEDURE_SET(BgL_mainz00_13522, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11287)); 
PROCEDURE_SET(BgL_mainz00_13522, 
(int)(((long)2)), BgL_valza2za2_13520); 
PROCEDURE_SET(BgL_mainz00_13522, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11288)); 
PROCEDURE_SET(BgL_mainz00_13522, 
(int)(((long)4)), BgL_bodyz00_11289); 
PROCEDURE_SET(BgL_mainz00_13522, 
(int)(((long)5)), BgL_runz00_13521); 
PROCEDURE_SET(BgL_mainz00_13522, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11290)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13523;
BgL_objz00_13523 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13521, BgL_objz00_13523); BgL_objz00_13523; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3202z00_13524;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3203z00_13525;
BgL_arg3203z00_13525 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11288))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13526;
BgL_newz00_13526 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26407;
BgL_tmpz00_26407 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13526, BgL_tmpz00_26407, BgL_arg3203z00_13525); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26412;int BgL_tmpz00_26410;
BgL_auxz00_26412 = 
BINT(BgL_siza7ezd2framez75_11290); 
BgL_tmpz00_26410 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13526, BgL_tmpz00_26410, BgL_auxz00_26412); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26415;
BgL_tmpz00_26415 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13526, BgL_tmpz00_26415, BgL_runz00_13521); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26420;int BgL_tmpz00_26418;
BgL_auxz00_26420 = 
BINT(((long)0)); 
BgL_tmpz00_26418 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13526, BgL_tmpz00_26418, BgL_auxz00_26420); } 
BgL_arg3202z00_13524 = BgL_newz00_13526; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13522, BgL_arg3202z00_13524); BgL_arg3202z00_13524; } 
return BgL_mainz00_13522;} } } } } } 

}



/* &main4238 */
obj_t BGl_z62main4238z62zz__evaluate_compz00(obj_t BgL_envz00_11292)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11298;long BgL_siza7ezd2framez75_11299;
BgL_runz00_11298 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11292, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11299 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11292, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13527;
BgL_sz00_13527 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13528;
BgL_bpz00_13528 = 
VECTOR_REF(
((obj_t)BgL_sz00_13527),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13527, BgL_bpz00_13528, 
BINT(BgL_siza7ezd2framez75_11299)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13529;
BgL_ez00_13529 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13529, BgL_bpz00_13528); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13530;
BgL_accz00_13530 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11298, BgL_sz00_13527, BgL_bpz00_13528); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13529); 
VECTOR_SET(
((obj_t)BgL_sz00_13527),((long)0),BgL_bpz00_13528); 
return BgL_accz00_13530;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13531;
BgL_nsz00_13531 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13531,((long)1),BgL_sz00_13527); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13532;
BgL_z12denvz12_13532 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13532, BgL_nsz00_13531); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13533;
BgL_ez00_13533 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13533, BgL_sz00_13527); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13534;
BgL_____rz00_13534 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11298, BgL_nsz00_13531, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13533); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13532, BgL_sz00_13527); 
return BgL_____rz00_13534;} } } } } } } } 

}



/* &run4239 */
obj_t BGl_z62run4239z62zz__evaluate_compz00(obj_t BgL_envz00_11300, obj_t BgL_sz00_11306)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11301;long BgL_siza7eza7_11302;obj_t BgL_valza2za2_11303;BgL_ev_absz00_bglt BgL_i1244z00_11304;obj_t BgL_bodyz00_11305;
BgL_iboxesz00_11301 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11300, 
(int)(((long)0)))); 
BgL_siza7eza7_11302 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11300, 
(int)(((long)1)))); 
BgL_valza2za2_11303 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11300, 
(int)(((long)2)))); 
BgL_i1244z00_11304 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11300, 
(int)(((long)3)))); 
BgL_bodyz00_11305 = 
PROCEDURE_REF(BgL_envz00_11300, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13535;
BgL_bpz00_13535 = 
VECTOR_REF(
((obj_t)BgL_sz00_11306),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11306, BgL_iboxesz00_11301, BgL_bpz00_13535); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11306, BgL_valza2za2_11303, 
(
(long)CINT(BgL_bpz00_13535)+BgL_siza7eza7_11302)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13536;obj_t BgL_wherez00_13537;obj_t BgL_locz00_13538;
BgL_z12denvz12_13536 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13537 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11304))->BgL_wherez00); 
BgL_locz00_13538 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11304))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13536, BgL_wherez00_13537, BgL_locz00_13538); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13539;
BgL_za2za2resza2za2z00_13539 = 
PROCEDURE_ENTRY(BgL_bodyz00_11305)(BgL_bodyz00_11305, BgL_sz00_11306, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13536); 
return BgL_za2za2resza2za2z00_13539;} } } } } } 

}



/* &<@anonymous:3629> */
obj_t BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11307, obj_t BgL_sz00_11311)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11308;obj_t BgL_bodyz00_11309;long BgL_siza7ezd2framez75_11310;
BgL_i1244z00_11308 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11307, 
(int)(((long)0)))); 
BgL_bodyz00_11309 = 
PROCEDURE_REF(BgL_envz00_11307, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11310 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11307, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13540;
BgL_bpz00_13540 = 
VECTOR_REF(
((obj_t)BgL_sz00_11311),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13541;
BgL_runz00_13541 = 
MAKE_FX_PROCEDURE(BGl_z62run4241z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13541, 
(int)(((long)0)), 
((obj_t)BgL_i1244z00_11308)); 
PROCEDURE_SET(BgL_runz00_13541, 
(int)(((long)1)), BgL_bodyz00_11309); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13542;
BgL_mainz00_13542 = 
MAKE_VA_PROCEDURE(BGl_z62main4240z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13542, 
(int)(((long)0)), BgL_bodyz00_11309); 
PROCEDURE_SET(BgL_mainz00_13542, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11308)); 
PROCEDURE_SET(BgL_mainz00_13542, 
(int)(((long)2)), BgL_runz00_13541); 
PROCEDURE_SET(BgL_mainz00_13542, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11310)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13543;
BgL_objz00_13543 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13541, BgL_objz00_13543); BgL_objz00_13543; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3630z00_13544;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3631z00_13545;obj_t BgL_arg3632z00_13546;
BgL_arg3631z00_13545 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11308))->BgL_arityz00); 
BgL_arg3632z00_13546 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11308))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13547;
BgL_newz00_13547 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26517;
BgL_tmpz00_26517 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13547, BgL_tmpz00_26517, BgL_arg3632z00_13546); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26522;int BgL_tmpz00_26520;
BgL_auxz00_26522 = 
BINT(BgL_siza7ezd2framez75_11310); 
BgL_tmpz00_26520 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13547, BgL_tmpz00_26520, BgL_auxz00_26522); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26525;
BgL_tmpz00_26525 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13547, BgL_tmpz00_26525, BgL_runz00_13541); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26528;
BgL_tmpz00_26528 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13547, BgL_tmpz00_26528, BgL_arg3631z00_13545); } 
BgL_arg3630z00_13544 = BgL_newz00_13547; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13542, BgL_arg3630z00_13544); BgL_arg3630z00_13544; } 
return BgL_mainz00_13542;} } } } } } 

}



/* &main4240 */
obj_t BGl_z62main4240z62zz__evaluate_compz00(obj_t BgL_envz00_11312, obj_t BgL_az00_11317, obj_t BgL_bz00_11318, obj_t BgL_cz00_11319, obj_t BgL_dz00_11320, obj_t BgL_restz00_11321)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11314;obj_t BgL_runz00_11315;long BgL_siza7ezd2framez75_11316;
BgL_i1244z00_11314 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11312, 
(int)(((long)1)))); 
BgL_runz00_11315 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11312, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11316 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11312, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13548;
BgL_sz00_13548 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13549;
BgL_bpz00_13549 = 
VECTOR_REF(
((obj_t)BgL_sz00_13548),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13548, BgL_bpz00_13549, 
BINT(BgL_siza7ezd2framez75_11316)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3635z00_13550;
BgL_arg3635z00_13550 = 
(
(long)CINT(BgL_bpz00_13549)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13548),BgL_arg3635z00_13550,BgL_az00_11317); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3636z00_13551;
BgL_arg3636z00_13551 = 
(
(long)CINT(BgL_bpz00_13549)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13548),BgL_arg3636z00_13551,BgL_bz00_11318); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3637z00_13552;
BgL_arg3637z00_13552 = 
(
(long)CINT(BgL_bpz00_13549)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13548),BgL_arg3637z00_13552,BgL_cz00_11319); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3638z00_13553;
BgL_arg3638z00_13553 = 
(
(long)CINT(BgL_bpz00_13549)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13548),BgL_arg3638z00_13553,BgL_dz00_11320); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_13548, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11314))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_13549)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11314))->BgL_arityz00), ((long)4)), BgL_restz00_11321, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11314))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13554;
BgL_ez00_13554 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13554, BgL_bpz00_13549); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13555;
BgL_accz00_13555 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11315, BgL_sz00_13548, BgL_bpz00_13549); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13554); 
VECTOR_SET(
((obj_t)BgL_sz00_13548),((long)0),BgL_bpz00_13549); 
return BgL_accz00_13555;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13556;
BgL_nsz00_13556 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13556,((long)1),BgL_sz00_13548); 
VECTOR_SET(BgL_nsz00_13556,((long)2),BgL_az00_11317); 
VECTOR_SET(BgL_nsz00_13556,((long)3),BgL_bz00_11318); 
VECTOR_SET(BgL_nsz00_13556,((long)4),BgL_cz00_11319); 
VECTOR_SET(BgL_nsz00_13556,((long)5),BgL_dz00_11320); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_13556, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11314))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11314))->BgL_arityz00), ((long)4)), BgL_restz00_11321, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11314))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13557;
BgL_z12denvz12_13557 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13557, BgL_nsz00_13556); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13558;
BgL_ez00_13558 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13558, BgL_sz00_13548); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13559;
BgL_____rz00_13559 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11315, BgL_nsz00_13556, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13558); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13557, BgL_sz00_13548); 
return BgL_____rz00_13559;} } } } } } } } 

}



/* &run4241 */
obj_t BGl_z62run4241z62zz__evaluate_compz00(obj_t BgL_envz00_11322, obj_t BgL_sz00_11325)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11323;obj_t BgL_bodyz00_11324;
BgL_i1244z00_11323 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11322, 
(int)(((long)0)))); 
BgL_bodyz00_11324 = 
PROCEDURE_REF(BgL_envz00_11322, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13560;
BgL_bpz00_13560 = 
VECTOR_REF(
((obj_t)BgL_sz00_11325),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13561;obj_t BgL_wherez00_13562;obj_t BgL_locz00_13563;
BgL_z12denvz12_13561 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13562 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11323))->BgL_wherez00); 
BgL_locz00_13563 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11323))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13561, BgL_wherez00_13562, BgL_locz00_13563); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13564;
BgL_za2za2resza2za2z00_13564 = 
PROCEDURE_ENTRY(BgL_bodyz00_11324)(BgL_bodyz00_11324, BgL_sz00_11325, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13561); 
return BgL_za2za2resza2za2z00_13564;} } } } } } 

}



/* &<@anonymous:3649> */
obj_t BGl_z62zc3z04anonymousza33649ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11326, obj_t BgL_sz00_11331)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11327;BgL_ev_absz00_bglt BgL_i1244z00_11328;obj_t BgL_bodyz00_11329;long BgL_siza7ezd2framez75_11330;
BgL_iboxesz00_11327 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11326, 
(int)(((long)0)))); 
BgL_i1244z00_11328 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11326, 
(int)(((long)1)))); 
BgL_bodyz00_11329 = 
PROCEDURE_REF(BgL_envz00_11326, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11330 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11326, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13565;
BgL_bpz00_13565 = 
VECTOR_REF(
((obj_t)BgL_sz00_11331),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13566;
BgL_runz00_13566 = 
MAKE_FX_PROCEDURE(BGl_z62run4243z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13566, 
(int)(((long)0)), BgL_iboxesz00_11327); 
PROCEDURE_SET(BgL_runz00_13566, 
(int)(((long)1)), 
((obj_t)BgL_i1244z00_11328)); 
PROCEDURE_SET(BgL_runz00_13566, 
(int)(((long)2)), BgL_bodyz00_11329); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13567;
BgL_mainz00_13567 = 
MAKE_VA_PROCEDURE(BGl_z62main4242z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13567, 
(int)(((long)0)), BgL_iboxesz00_11327); 
PROCEDURE_SET(BgL_mainz00_13567, 
(int)(((long)1)), BgL_bodyz00_11329); 
PROCEDURE_SET(BgL_mainz00_13567, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11328)); 
PROCEDURE_SET(BgL_mainz00_13567, 
(int)(((long)3)), BgL_runz00_13566); 
PROCEDURE_SET(BgL_mainz00_13567, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11330)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13568;
BgL_objz00_13568 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13566, BgL_objz00_13568); BgL_objz00_13568; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3650z00_13569;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3651z00_13570;obj_t BgL_arg3652z00_13571;
BgL_arg3651z00_13570 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11328))->BgL_arityz00); 
BgL_arg3652z00_13571 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11328))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13572;
BgL_newz00_13572 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26654;
BgL_tmpz00_26654 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13572, BgL_tmpz00_26654, BgL_arg3652z00_13571); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26659;int BgL_tmpz00_26657;
BgL_auxz00_26659 = 
BINT(BgL_siza7ezd2framez75_11330); 
BgL_tmpz00_26657 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13572, BgL_tmpz00_26657, BgL_auxz00_26659); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26662;
BgL_tmpz00_26662 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13572, BgL_tmpz00_26662, BgL_runz00_13566); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26665;
BgL_tmpz00_26665 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13572, BgL_tmpz00_26665, BgL_arg3651z00_13570); } 
BgL_arg3650z00_13569 = BgL_newz00_13572; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13567, BgL_arg3650z00_13569); BgL_arg3650z00_13569; } 
return BgL_mainz00_13567;} } } } } } 

}



/* &main4242 */
obj_t BGl_z62main4242z62zz__evaluate_compz00(obj_t BgL_envz00_11332, obj_t BgL_az00_11338, obj_t BgL_bz00_11339, obj_t BgL_cz00_11340, obj_t BgL_dz00_11341, obj_t BgL_restz00_11342)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11335;obj_t BgL_runz00_11336;long BgL_siza7ezd2framez75_11337;
BgL_i1244z00_11335 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11332, 
(int)(((long)2)))); 
BgL_runz00_11336 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11332, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11337 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11332, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13573;
BgL_sz00_13573 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13574;
BgL_bpz00_13574 = 
VECTOR_REF(
((obj_t)BgL_sz00_13573),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13573, BgL_bpz00_13574, 
BINT(BgL_siza7ezd2framez75_11337)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3655z00_13575;
BgL_arg3655z00_13575 = 
(
(long)CINT(BgL_bpz00_13574)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13573),BgL_arg3655z00_13575,BgL_az00_11338); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3656z00_13576;
BgL_arg3656z00_13576 = 
(
(long)CINT(BgL_bpz00_13574)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13573),BgL_arg3656z00_13576,BgL_bz00_11339); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3657z00_13577;
BgL_arg3657z00_13577 = 
(
(long)CINT(BgL_bpz00_13574)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13573),BgL_arg3657z00_13577,BgL_cz00_11340); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3658z00_13578;
BgL_arg3658z00_13578 = 
(
(long)CINT(BgL_bpz00_13574)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13573),BgL_arg3658z00_13578,BgL_dz00_11341); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_13573, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11335))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_13574)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11335))->BgL_arityz00), ((long)4)), BgL_restz00_11342, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11335))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13579;
BgL_ez00_13579 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13579, BgL_bpz00_13574); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13580;
BgL_accz00_13580 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11336, BgL_sz00_13573, BgL_bpz00_13574); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13579); 
VECTOR_SET(
((obj_t)BgL_sz00_13573),((long)0),BgL_bpz00_13574); 
return BgL_accz00_13580;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13581;
BgL_nsz00_13581 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13581,((long)1),BgL_sz00_13573); 
VECTOR_SET(BgL_nsz00_13581,((long)2),BgL_az00_11338); 
VECTOR_SET(BgL_nsz00_13581,((long)3),BgL_bz00_11339); 
VECTOR_SET(BgL_nsz00_13581,((long)4),BgL_cz00_11340); 
VECTOR_SET(BgL_nsz00_13581,((long)5),BgL_dz00_11341); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_13581, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11335))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11335))->BgL_arityz00), ((long)4)), BgL_restz00_11342, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11335))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13582;
BgL_z12denvz12_13582 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13582, BgL_nsz00_13581); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13583;
BgL_ez00_13583 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13583, BgL_sz00_13573); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13584;
BgL_____rz00_13584 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11336, BgL_nsz00_13581, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13583); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13582, BgL_sz00_13573); 
return BgL_____rz00_13584;} } } } } } } } 

}



/* &run4243 */
obj_t BGl_z62run4243z62zz__evaluate_compz00(obj_t BgL_envz00_11343, obj_t BgL_sz00_11347)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11344;BgL_ev_absz00_bglt BgL_i1244z00_11345;obj_t BgL_bodyz00_11346;
BgL_iboxesz00_11344 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11343, 
(int)(((long)0)))); 
BgL_i1244z00_11345 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11343, 
(int)(((long)1)))); 
BgL_bodyz00_11346 = 
PROCEDURE_REF(BgL_envz00_11343, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13585;
BgL_bpz00_13585 = 
VECTOR_REF(
((obj_t)BgL_sz00_11347),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11347, BgL_iboxesz00_11344, BgL_bpz00_13585); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13586;obj_t BgL_wherez00_13587;obj_t BgL_locz00_13588;
BgL_z12denvz12_13586 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13587 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11345))->BgL_wherez00); 
BgL_locz00_13588 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11345))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13586, BgL_wherez00_13587, BgL_locz00_13588); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13589;
BgL_za2za2resza2za2z00_13589 = 
PROCEDURE_ENTRY(BgL_bodyz00_11346)(BgL_bodyz00_11346, BgL_sz00_11347, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13586); 
return BgL_za2za2resza2za2z00_13589;} } } } } } 

}



/* &<@anonymous:3672> */
obj_t BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11348, obj_t BgL_sz00_11354)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11349;long BgL_siza7eza7_11350;BgL_ev_absz00_bglt BgL_i1244z00_11351;obj_t BgL_bodyz00_11352;long BgL_siza7ezd2framez75_11353;
BgL_ifreesz00_11349 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11348, 
(int)(((long)0)))); 
BgL_siza7eza7_11350 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11348, 
(int)(((long)1)))); 
BgL_i1244z00_11351 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11348, 
(int)(((long)2)))); 
BgL_bodyz00_11352 = 
PROCEDURE_REF(BgL_envz00_11348, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11353 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11348, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13590;
BgL_bpz00_13590 = 
VECTOR_REF(
((obj_t)BgL_sz00_11354),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13591;
BgL_valza2za2_13591 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11354, BgL_bpz00_13590, BgL_ifreesz00_11349); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13592;
BgL_runz00_13592 = 
MAKE_FX_PROCEDURE(BGl_z62run4245z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13592, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11350)); 
PROCEDURE_SET(BgL_runz00_13592, 
(int)(((long)1)), BgL_valza2za2_13591); 
PROCEDURE_SET(BgL_runz00_13592, 
(int)(((long)2)), 
((obj_t)BgL_i1244z00_11351)); 
PROCEDURE_SET(BgL_runz00_13592, 
(int)(((long)3)), BgL_bodyz00_11352); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13593;
BgL_mainz00_13593 = 
MAKE_VA_PROCEDURE(BGl_z62main4244z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13593, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11350)); 
PROCEDURE_SET(BgL_mainz00_13593, 
(int)(((long)1)), BgL_valza2za2_13591); 
PROCEDURE_SET(BgL_mainz00_13593, 
(int)(((long)2)), BgL_bodyz00_11352); 
PROCEDURE_SET(BgL_mainz00_13593, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11351)); 
PROCEDURE_SET(BgL_mainz00_13593, 
(int)(((long)4)), BgL_runz00_13592); 
PROCEDURE_SET(BgL_mainz00_13593, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11353)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13594;
BgL_objz00_13594 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13592, BgL_objz00_13594); BgL_objz00_13594; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3673z00_13595;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3674z00_13596;obj_t BgL_arg3675z00_13597;
BgL_arg3674z00_13596 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11351))->BgL_arityz00); 
BgL_arg3675z00_13597 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11351))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13598;
BgL_newz00_13598 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26805;
BgL_tmpz00_26805 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13598, BgL_tmpz00_26805, BgL_arg3675z00_13597); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26810;int BgL_tmpz00_26808;
BgL_auxz00_26810 = 
BINT(BgL_siza7ezd2framez75_11353); 
BgL_tmpz00_26808 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13598, BgL_tmpz00_26808, BgL_auxz00_26810); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26813;
BgL_tmpz00_26813 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13598, BgL_tmpz00_26813, BgL_runz00_13592); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26816;
BgL_tmpz00_26816 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13598, BgL_tmpz00_26816, BgL_arg3674z00_13596); } 
BgL_arg3673z00_13595 = BgL_newz00_13598; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13593, BgL_arg3673z00_13595); BgL_arg3673z00_13595; } 
return BgL_mainz00_13593;} } } } } } 

}



/* &main4244 */
obj_t BGl_z62main4244z62zz__evaluate_compz00(obj_t BgL_envz00_11355, obj_t BgL_az00_11362, obj_t BgL_bz00_11363, obj_t BgL_cz00_11364, obj_t BgL_dz00_11365, obj_t BgL_restz00_11366)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11359;obj_t BgL_runz00_11360;long BgL_siza7ezd2framez75_11361;
BgL_i1244z00_11359 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11355, 
(int)(((long)3)))); 
BgL_runz00_11360 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11355, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11361 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11355, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13599;
BgL_sz00_13599 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13600;
BgL_bpz00_13600 = 
VECTOR_REF(
((obj_t)BgL_sz00_13599),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13599, BgL_bpz00_13600, 
BINT(BgL_siza7ezd2framez75_11361)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3678z00_13601;
BgL_arg3678z00_13601 = 
(
(long)CINT(BgL_bpz00_13600)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13599),BgL_arg3678z00_13601,BgL_az00_11362); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3679z00_13602;
BgL_arg3679z00_13602 = 
(
(long)CINT(BgL_bpz00_13600)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13599),BgL_arg3679z00_13602,BgL_bz00_11363); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3680z00_13603;
BgL_arg3680z00_13603 = 
(
(long)CINT(BgL_bpz00_13600)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13599),BgL_arg3680z00_13603,BgL_cz00_11364); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3681z00_13604;
BgL_arg3681z00_13604 = 
(
(long)CINT(BgL_bpz00_13600)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13599),BgL_arg3681z00_13604,BgL_dz00_11365); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_13599, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11359))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_13600)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11359))->BgL_arityz00), ((long)4)), BgL_restz00_11366, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11359))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13605;
BgL_ez00_13605 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13605, BgL_bpz00_13600); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13606;
BgL_accz00_13606 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11360, BgL_sz00_13599, BgL_bpz00_13600); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13605); 
VECTOR_SET(
((obj_t)BgL_sz00_13599),((long)0),BgL_bpz00_13600); 
return BgL_accz00_13606;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13607;
BgL_nsz00_13607 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13607,((long)1),BgL_sz00_13599); 
VECTOR_SET(BgL_nsz00_13607,((long)2),BgL_az00_11362); 
VECTOR_SET(BgL_nsz00_13607,((long)3),BgL_bz00_11363); 
VECTOR_SET(BgL_nsz00_13607,((long)4),BgL_cz00_11364); 
VECTOR_SET(BgL_nsz00_13607,((long)5),BgL_dz00_11365); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_13607, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11359))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11359))->BgL_arityz00), ((long)4)), BgL_restz00_11366, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11359))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13608;
BgL_z12denvz12_13608 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13608, BgL_nsz00_13607); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13609;
BgL_ez00_13609 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13609, BgL_sz00_13599); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13610;
BgL_____rz00_13610 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11360, BgL_nsz00_13607, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13609); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13608, BgL_sz00_13599); 
return BgL_____rz00_13610;} } } } } } } } 

}



/* &run4245 */
obj_t BGl_z62run4245z62zz__evaluate_compz00(obj_t BgL_envz00_11367, obj_t BgL_sz00_11372)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11368;obj_t BgL_valza2za2_11369;BgL_ev_absz00_bglt BgL_i1244z00_11370;obj_t BgL_bodyz00_11371;
BgL_siza7eza7_11368 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11367, 
(int)(((long)0)))); 
BgL_valza2za2_11369 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11367, 
(int)(((long)1)))); 
BgL_i1244z00_11370 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11367, 
(int)(((long)2)))); 
BgL_bodyz00_11371 = 
PROCEDURE_REF(BgL_envz00_11367, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13611;
BgL_bpz00_13611 = 
VECTOR_REF(
((obj_t)BgL_sz00_11372),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11372, BgL_valza2za2_11369, 
(
(long)CINT(BgL_bpz00_13611)+BgL_siza7eza7_11368)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13612;obj_t BgL_wherez00_13613;obj_t BgL_locz00_13614;
BgL_z12denvz12_13612 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13613 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11370))->BgL_wherez00); 
BgL_locz00_13614 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11370))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13612, BgL_wherez00_13613, BgL_locz00_13614); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13615;
BgL_za2za2resza2za2z00_13615 = 
PROCEDURE_ENTRY(BgL_bodyz00_11371)(BgL_bodyz00_11371, BgL_sz00_11372, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13612); 
return BgL_za2za2resza2za2z00_13615;} } } } } } 

}



/* &<@anonymous:3693> */
obj_t BGl_z62zc3z04anonymousza33693ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11373, obj_t BgL_sz00_11380)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11374;obj_t BgL_iboxesz00_11375;long BgL_siza7eza7_11376;BgL_ev_absz00_bglt BgL_i1244z00_11377;obj_t BgL_bodyz00_11378;long BgL_siza7ezd2framez75_11379;
BgL_ifreesz00_11374 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11373, 
(int)(((long)0)))); 
BgL_iboxesz00_11375 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11373, 
(int)(((long)1)))); 
BgL_siza7eza7_11376 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11373, 
(int)(((long)2)))); 
BgL_i1244z00_11377 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11373, 
(int)(((long)3)))); 
BgL_bodyz00_11378 = 
PROCEDURE_REF(BgL_envz00_11373, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11379 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11373, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13616;
BgL_bpz00_13616 = 
VECTOR_REF(
((obj_t)BgL_sz00_11380),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13617;
BgL_valza2za2_13617 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11380, BgL_bpz00_13616, BgL_ifreesz00_11374); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13618;
BgL_runz00_13618 = 
MAKE_FX_PROCEDURE(BGl_z62run4247z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13618, 
(int)(((long)0)), BgL_iboxesz00_11375); 
PROCEDURE_SET(BgL_runz00_13618, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11376)); 
PROCEDURE_SET(BgL_runz00_13618, 
(int)(((long)2)), BgL_valza2za2_13617); 
PROCEDURE_SET(BgL_runz00_13618, 
(int)(((long)3)), 
((obj_t)BgL_i1244z00_11377)); 
PROCEDURE_SET(BgL_runz00_13618, 
(int)(((long)4)), BgL_bodyz00_11378); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13619;
BgL_mainz00_13619 = 
MAKE_VA_PROCEDURE(BGl_z62main4246z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13619, 
(int)(((long)0)), BgL_iboxesz00_11375); 
PROCEDURE_SET(BgL_mainz00_13619, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11376)); 
PROCEDURE_SET(BgL_mainz00_13619, 
(int)(((long)2)), BgL_valza2za2_13617); 
PROCEDURE_SET(BgL_mainz00_13619, 
(int)(((long)3)), BgL_bodyz00_11378); 
PROCEDURE_SET(BgL_mainz00_13619, 
(int)(((long)4)), 
((obj_t)BgL_i1244z00_11377)); 
PROCEDURE_SET(BgL_mainz00_13619, 
(int)(((long)5)), BgL_runz00_13618); 
PROCEDURE_SET(BgL_mainz00_13619, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11379)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13620;
BgL_objz00_13620 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13618, BgL_objz00_13620); BgL_objz00_13620; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3694z00_13621;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3695z00_13622;obj_t BgL_arg3696z00_13623;
BgL_arg3695z00_13622 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11377))->BgL_arityz00); 
BgL_arg3696z00_13623 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11377))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13624;
BgL_newz00_13624 = 
create_struct(BGl_symbol4277z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26968;
BgL_tmpz00_26968 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13624, BgL_tmpz00_26968, BgL_arg3696z00_13623); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26973;int BgL_tmpz00_26971;
BgL_auxz00_26973 = 
BINT(BgL_siza7ezd2framez75_11379); 
BgL_tmpz00_26971 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13624, BgL_tmpz00_26971, BgL_auxz00_26973); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26976;
BgL_tmpz00_26976 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13624, BgL_tmpz00_26976, BgL_runz00_13618); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26979;
BgL_tmpz00_26979 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13624, BgL_tmpz00_26979, BgL_arg3695z00_13622); } 
BgL_arg3694z00_13621 = BgL_newz00_13624; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13619, BgL_arg3694z00_13621); BgL_arg3694z00_13621; } 
return BgL_mainz00_13619;} } } } } } 

}



/* &main4246 */
obj_t BGl_z62main4246z62zz__evaluate_compz00(obj_t BgL_envz00_11381, obj_t BgL_az00_11389, obj_t BgL_bz00_11390, obj_t BgL_cz00_11391, obj_t BgL_dz00_11392, obj_t BgL_restz00_11393)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1244z00_11386;obj_t BgL_runz00_11387;long BgL_siza7ezd2framez75_11388;
BgL_i1244z00_11386 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11381, 
(int)(((long)4)))); 
BgL_runz00_11387 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11381, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11388 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11381, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13625;
BgL_sz00_13625 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13626;
BgL_bpz00_13626 = 
VECTOR_REF(
((obj_t)BgL_sz00_13625),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13625, BgL_bpz00_13626, 
BINT(BgL_siza7ezd2framez75_11388)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3699z00_13627;
BgL_arg3699z00_13627 = 
(
(long)CINT(BgL_bpz00_13626)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13625),BgL_arg3699z00_13627,BgL_az00_11389); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3700z00_13628;
BgL_arg3700z00_13628 = 
(
(long)CINT(BgL_bpz00_13626)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13625),BgL_arg3700z00_13628,BgL_bz00_11390); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3701z00_13629;
BgL_arg3701z00_13629 = 
(
(long)CINT(BgL_bpz00_13626)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13625),BgL_arg3701z00_13629,BgL_cz00_11391); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3702z00_13630;
BgL_arg3702z00_13630 = 
(
(long)CINT(BgL_bpz00_13626)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13625),BgL_arg3702z00_13630,BgL_dz00_11392); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_13625, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11386))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_13626)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11386))->BgL_arityz00), ((long)4)), BgL_restz00_11393, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11386))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13631;
BgL_ez00_13631 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13631, BgL_bpz00_13626); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13632;
BgL_accz00_13632 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11387, BgL_sz00_13625, BgL_bpz00_13626); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13631); 
VECTOR_SET(
((obj_t)BgL_sz00_13625),((long)0),BgL_bpz00_13626); 
return BgL_accz00_13632;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13633;
BgL_nsz00_13633 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13633,((long)1),BgL_sz00_13625); 
VECTOR_SET(BgL_nsz00_13633,((long)2),BgL_az00_11389); 
VECTOR_SET(BgL_nsz00_13633,((long)3),BgL_bz00_11390); 
VECTOR_SET(BgL_nsz00_13633,((long)4),BgL_cz00_11391); 
VECTOR_SET(BgL_nsz00_13633,((long)5),BgL_dz00_11392); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_13633, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11386))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11386))->BgL_arityz00), ((long)4)), BgL_restz00_11393, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11386))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13634;
BgL_z12denvz12_13634 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13634, BgL_nsz00_13633); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13635;
BgL_ez00_13635 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13635, BgL_sz00_13625); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13636;
BgL_____rz00_13636 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11387, BgL_nsz00_13633, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13635); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13634, BgL_sz00_13625); 
return BgL_____rz00_13636;} } } } } } } } 

}



/* &run4247 */
obj_t BGl_z62run4247z62zz__evaluate_compz00(obj_t BgL_envz00_11394, obj_t BgL_sz00_11400)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11395;long BgL_siza7eza7_11396;obj_t BgL_valza2za2_11397;BgL_ev_absz00_bglt BgL_i1244z00_11398;obj_t BgL_bodyz00_11399;
BgL_iboxesz00_11395 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11394, 
(int)(((long)0)))); 
BgL_siza7eza7_11396 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11394, 
(int)(((long)1)))); 
BgL_valza2za2_11397 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11394, 
(int)(((long)2)))); 
BgL_i1244z00_11398 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11394, 
(int)(((long)3)))); 
BgL_bodyz00_11399 = 
PROCEDURE_REF(BgL_envz00_11394, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13637;
BgL_bpz00_13637 = 
VECTOR_REF(
((obj_t)BgL_sz00_11400),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11400, BgL_iboxesz00_11395, BgL_bpz00_13637); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11400, BgL_valza2za2_11397, 
(
(long)CINT(BgL_bpz00_13637)+BgL_siza7eza7_11396)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13638;obj_t BgL_wherez00_13639;obj_t BgL_locz00_13640;
BgL_z12denvz12_13638 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13639 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11398))->BgL_wherez00); 
BgL_locz00_13640 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1244z00_11398))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13638, BgL_wherez00_13639, BgL_locz00_13640); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13641;
BgL_za2za2resza2za2z00_13641 = 
PROCEDURE_ENTRY(BgL_bodyz00_11399)(BgL_bodyz00_11399, BgL_sz00_11400, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13638); 
return BgL_za2za2resza2za2z00_13641;} } } } } } 

}



/* &comp-ev_app1429 */
obj_t BGl_z62compzd2ev_app1429zb0zz__evaluate_compz00(obj_t BgL_envz00_11401, obj_t BgL_ez00_11402, obj_t BgL_stkz00_11403)
{
{ /* Eval/evaluate_comp.scm 1044 */
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL__ortest_1230z00_13643;
BgL__ortest_1230z00_13643 = 
BGl_arithzd2expressionzd2zz__evaluate_compz00(
((BgL_ev_appz00_bglt)BgL_ez00_11402), BgL_stkz00_11403); 
if(
CBOOL(BgL__ortest_1230z00_13643))
{ /* Eval/evaluate_comp.scm 1046 */
return BgL__ortest_1230z00_13643;}  else 
{ /* Eval/evaluate_comp.scm 1047 */
obj_t BgL__ortest_1231z00_13644;
BgL__ortest_1231z00_13644 = 
BGl_inlinezd2callzd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_funz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_argsz00), BgL_stkz00_11403); 
if(
CBOOL(BgL__ortest_1231z00_13644))
{ /* Eval/evaluate_comp.scm 1047 */
return BgL__ortest_1231z00_13644;}  else 
{ /* Eval/evaluate_comp.scm 1047 */
if(
(
bgl_list_length(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_argsz00))>((long)4)))
{ /* Eval/evaluate_comp.scm 1048 */
return 
BGl_compzd2oldzd2callz00zz__evaluate_compz00(
((BgL_ev_appz00_bglt)BgL_ez00_11402), BgL_stkz00_11403);}  else 
{ /* Eval/evaluate_comp.scm 1050 */
obj_t BgL_fz00_13645;long BgL_siza7eza7_13646;obj_t BgL_symbzd2funzd2_13647;
BgL_fz00_13645 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_funz00), BgL_stkz00_11403); 
BgL_siza7eza7_13646 = 
bgl_list_length(BgL_stkz00_11403); 
BgL_symbzd2funzd2_13647 = 
BGl_uncompilez00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_funz00)); 
if(
NULLP(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_argsz00)))
{ /* Eval/evaluate_comp.scm 1051 */
return 
BGl_compzd2call0zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_funz00), BgL_symbzd2funzd2_13647, BgL_fz00_13645, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_tailzf3zf3), BgL_stkz00_11403, BgL_siza7eza7_13646);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a1z00_13648;obj_t BgL_argsz00_13649;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3163z00_13650;
BgL_arg3163z00_13650 = 
CAR(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_argsz00)); 
BgL_a1z00_13648 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3163z00_13650), BgL_stkz00_11403); } 
BgL_argsz00_13649 = 
CDR(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_argsz00)); 
if(
NULLP(BgL_argsz00_13649))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call1zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_funz00), BgL_symbzd2funzd2_13647, BgL_fz00_13645, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_tailzf3zf3), BgL_stkz00_11403, BgL_siza7eza7_13646, BgL_a1z00_13648);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a2z00_13651;obj_t BgL_argsz00_13652;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3162z00_13653;
BgL_arg3162z00_13653 = 
CAR(
((obj_t)BgL_argsz00_13649)); 
BgL_a2z00_13651 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3162z00_13653), BgL_stkz00_11403); } 
BgL_argsz00_13652 = 
CDR(
((obj_t)BgL_argsz00_13649)); 
if(
NULLP(BgL_argsz00_13652))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call2zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_funz00), BgL_symbzd2funzd2_13647, BgL_fz00_13645, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_tailzf3zf3), BgL_stkz00_11403, BgL_siza7eza7_13646, BgL_a1z00_13648, BgL_a2z00_13651);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a3z00_13654;obj_t BgL_argsz00_13655;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3161z00_13656;
BgL_arg3161z00_13656 = 
CAR(
((obj_t)BgL_argsz00_13652)); 
BgL_a3z00_13654 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3161z00_13656), BgL_stkz00_11403); } 
BgL_argsz00_13655 = 
CDR(
((obj_t)BgL_argsz00_13652)); 
if(
NULLP(BgL_argsz00_13655))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call3zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_funz00), BgL_symbzd2funzd2_13647, BgL_fz00_13645, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_tailzf3zf3), BgL_stkz00_11403, BgL_siza7eza7_13646, BgL_a1z00_13648, BgL_a2z00_13651, BgL_a3z00_13654);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a4z00_13657;obj_t BgL_argsz00_13658;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3160z00_13659;
BgL_arg3160z00_13659 = 
CAR(
((obj_t)BgL_argsz00_13655)); 
BgL_a4z00_13657 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3160z00_13659), BgL_stkz00_11403); } 
BgL_argsz00_13658 = 
CDR(
((obj_t)BgL_argsz00_13655)); 
if(
NULLP(BgL_argsz00_13658))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call4zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_funz00), BgL_symbzd2funzd2_13647, BgL_fz00_13645, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_11402)))->BgL_tailzf3zf3), BgL_stkz00_11403, BgL_siza7eza7_13646, BgL_a1z00_13648, BgL_a2z00_13651, BgL_a3z00_13654, BgL_a4z00_13657);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_errorz00zz__errorz00(BGl_string4260z00zz__evaluate_compz00, BGl_string4375z00zz__evaluate_compz00, BGl_string4376z00zz__evaluate_compz00);} } } } } } } } } } 

}



/* &comp-ev_goto1427 */
obj_t BGl_z62compzd2ev_goto1427zb0zz__evaluate_compz00(obj_t BgL_envz00_11404, obj_t BgL_ez00_11405, obj_t BgL_stkz00_11406)
{
{ /* Eval/evaluate_comp.scm 604 */
{ /* Eval/evaluate_comp.scm 607 */
obj_t BgL_slotz00_13663;long BgL_siza7eza7_13664;obj_t BgL_lstkz00_13665;
BgL_slotz00_13663 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_labelz00)), 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_labelsz00)))->BgL_envz00)); 
BgL_siza7eza7_13664 = 
bgl_list_length(BgL_stkz00_11406); 
BgL_lstkz00_13665 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_labelsz00)))->BgL_stkz00); 
{ /* Eval/evaluate_comp.scm 609 */
long BgL_llstkz00_13666;obj_t BgL_substkz00_13667;obj_t BgL_boxesz00_13668;
BgL_llstkz00_13666 = 
bgl_list_length(BgL_lstkz00_13665); 
BgL_substkz00_13667 = 
BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_13665, BgL_stkz00_11406); 
{ /* Eval/evaluate_comp.scm 609 */
obj_t BgL_pairz00_13669;
BgL_pairz00_13669 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_labelz00)), 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_labelsz00)))->BgL_boxesz00)); 
BgL_boxesz00_13668 = 
CDR(BgL_pairz00_13669); } 
if(
BGl_needzd2shiftzd2zz__evaluate_compz00(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_argsz00), BgL_substkz00_13667))
{ /* Eval/evaluate_comp.scm 612 */
obj_t BgL_argsz00_13670;long BgL_nbargsz00_13671;
BgL_argsz00_13670 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_argsz00), BgL_stkz00_11406); 
BgL_nbargsz00_13671 = 
bgl_list_length(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_argsz00)); 
{ /* Eval/evaluate_comp.scm 613 */
obj_t BgL_zc3z04anonymousza33118ze3z87_13672;
BgL_zc3z04anonymousza33118ze3z87_13672 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_13672, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_13664)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_13672, 
(int)(((long)1)), 
BINT(BgL_llstkz00_13666)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_13672, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_gotoz00_bglt)BgL_ez00_11405))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_13672, 
(int)(((long)3)), BgL_argsz00_13670); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_13672, 
(int)(((long)4)), BgL_boxesz00_13668); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_13672, 
(int)(((long)5)), 
BINT(BgL_nbargsz00_13671)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_13672, 
(int)(((long)6)), BgL_slotz00_13663); 
return BgL_zc3z04anonymousza33118ze3z87_13672;} }  else 
{ /* Eval/evaluate_comp.scm 618 */
obj_t BgL_argsz00_13673;
{ /* Eval/evaluate_comp.scm 618 */
obj_t BgL_lz00_13674;long BgL_nz00_13675;
BgL_lz00_13674 = 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_11405)))->BgL_argsz00); 
BgL_nz00_13675 = 
(BgL_siza7eza7_13664-BgL_llstkz00_13666); 
BgL_argsz00_13673 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_11406, BgL_lz00_13674, BgL_nz00_13675); } 
{ /* Eval/evaluate_comp.scm 619 */
obj_t BgL_zc3z04anonymousza33124ze3z87_13676;
BgL_zc3z04anonymousza33124ze3z87_13676 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33124ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_13676, 
(int)(((long)0)), 
BINT(BgL_llstkz00_13666)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_13676, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_gotoz00_bglt)BgL_ez00_11405))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_13676, 
(int)(((long)2)), BgL_argsz00_13673); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_13676, 
(int)(((long)3)), BgL_boxesz00_13668); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_13676, 
(int)(((long)4)), BgL_slotz00_13663); 
return BgL_zc3z04anonymousza33124ze3z87_13676;} } } } } 

}



/* &<@anonymous:3118> */
obj_t BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11407, obj_t BgL_sz00_11415)
{
{ /* Eval/evaluate_comp.scm 613 */
{ /* Eval/evaluate_comp.scm 613 */
long BgL_siza7eza7_11408;long BgL_llstkz00_11409;BgL_ev_gotoz00_bglt BgL_i1142z00_11410;obj_t BgL_argsz00_11411;obj_t BgL_boxesz00_11412;long BgL_nbargsz00_11413;obj_t BgL_slotz00_11414;
BgL_siza7eza7_11408 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11407, 
(int)(((long)0)))); 
BgL_llstkz00_11409 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11407, 
(int)(((long)1)))); 
BgL_i1142z00_11410 = 
((BgL_ev_gotoz00_bglt)
PROCEDURE_REF(BgL_envz00_11407, 
(int)(((long)2)))); 
BgL_argsz00_11411 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11407, 
(int)(((long)3)))); 
BgL_boxesz00_11412 = 
PROCEDURE_REF(BgL_envz00_11407, 
(int)(((long)4))); 
BgL_nbargsz00_11413 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11407, 
(int)(((long)5)))); 
BgL_slotz00_11414 = 
PROCEDURE_REF(BgL_envz00_11407, 
(int)(((long)6))); 
{ /* Eval/evaluate_comp.scm 613 */
obj_t BgL_bpz00_13677;
BgL_bpz00_13677 = 
VECTOR_REF(
((obj_t)BgL_sz00_11415),((long)0)); 
{ /* Eval/evaluate_comp.scm 614 */
long BgL_spz00_13678;long BgL_lspz00_13679;
BgL_spz00_13678 = 
(
(long)CINT(BgL_bpz00_13677)+BgL_siza7eza7_11408); 
BgL_lspz00_13679 = 
(
(long)CINT(BgL_bpz00_13677)+BgL_llstkz00_11409); 
BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(BgL_sz00_11415, BgL_argsz00_11411, BgL_boxesz00_11412, BgL_spz00_13678, 
(((BgL_ev_gotoz00_bglt)COBJECT(BgL_i1142z00_11410))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 616 */
long BgL_arg3120z00_13680;
BgL_arg3120z00_13680 = 
(BgL_spz00_13678+BgL_nbargsz00_11413); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_11415, BgL_lspz00_13679, BgL_sz00_11415, 
BINT(BgL_spz00_13678), 
BINT(BgL_arg3120z00_13680)); } 
return 
CDR(
((obj_t)BgL_slotz00_11414));} } } } 

}



/* &<@anonymous:3124> */
obj_t BGl_z62zc3z04anonymousza33124ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11416, obj_t BgL_sz00_11422)
{
{ /* Eval/evaluate_comp.scm 619 */
{ /* Eval/evaluate_comp.scm 619 */
long BgL_llstkz00_11417;BgL_ev_gotoz00_bglt BgL_i1142z00_11418;obj_t BgL_argsz00_11419;obj_t BgL_boxesz00_11420;obj_t BgL_slotz00_11421;
BgL_llstkz00_11417 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11416, 
(int)(((long)0)))); 
BgL_i1142z00_11418 = 
((BgL_ev_gotoz00_bglt)
PROCEDURE_REF(BgL_envz00_11416, 
(int)(((long)1)))); 
BgL_argsz00_11419 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11416, 
(int)(((long)2)))); 
BgL_boxesz00_11420 = 
PROCEDURE_REF(BgL_envz00_11416, 
(int)(((long)3))); 
BgL_slotz00_11421 = 
PROCEDURE_REF(BgL_envz00_11416, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 619 */
obj_t BgL_bpz00_13681;
BgL_bpz00_13681 = 
VECTOR_REF(
((obj_t)BgL_sz00_11422),((long)0)); 
BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(BgL_sz00_11422, BgL_argsz00_11419, BgL_boxesz00_11420, 
(
(long)CINT(BgL_bpz00_13681)+BgL_llstkz00_11417), 
(((BgL_ev_gotoz00_bglt)COBJECT(BgL_i1142z00_11418))->BgL_locz00)); 
return 
CDR(
((obj_t)BgL_slotz00_11421));} } } 

}



/* &comp-ev_labels1425 */
obj_t BGl_z62compzd2ev_labels1425zb0zz__evaluate_compz00(obj_t BgL_envz00_11423, obj_t BgL_ez00_11424, obj_t BgL_stkz00_11425)
{
{ /* Eval/evaluate_comp.scm 572 */
{ 
obj_t BgL_fz00_13684;
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_11424)))->BgL_stkz00)=((obj_t)BgL_stkz00_11425),BUNSPEC); 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_envz00_13686;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_l1329z00_13687;
BgL_l1329z00_13687 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_11424)))->BgL_varsz00); 
if(
NULLP(BgL_l1329z00_13687))
{ /* Eval/evaluate_comp.scm 579 */
BgL_envz00_13686 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_head1331z00_13688;
BgL_head1331z00_13688 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1329z00_13690;obj_t BgL_tail1332z00_13691;
BgL_l1329z00_13690 = BgL_l1329z00_13687; 
BgL_tail1332z00_13691 = BgL_head1331z00_13688; 
BgL_zc3z04anonymousza33109ze3z87_13689:
if(
NULLP(BgL_l1329z00_13690))
{ /* Eval/evaluate_comp.scm 579 */
BgL_envz00_13686 = 
CDR(BgL_head1331z00_13688); }  else 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_newtail1333z00_13692;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_arg3112z00_13693;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_vz00_13694;
BgL_vz00_13694 = 
CAR(
((obj_t)BgL_l1329z00_13690)); 
BgL_arg3112z00_13693 = 
MAKE_YOUNG_PAIR(BgL_vz00_13694, BGl_symbol4377z00zz__evaluate_compz00); } 
BgL_newtail1333z00_13692 = 
MAKE_YOUNG_PAIR(BgL_arg3112z00_13693, BNIL); } 
SET_CDR(BgL_tail1332z00_13691, BgL_newtail1333z00_13692); 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_arg3111z00_13695;
BgL_arg3111z00_13695 = 
CDR(
((obj_t)BgL_l1329z00_13690)); 
{ 
obj_t BgL_tail1332z00_27321;obj_t BgL_l1329z00_27320;
BgL_l1329z00_27320 = BgL_arg3111z00_13695; 
BgL_tail1332z00_27321 = BgL_newtail1333z00_13692; 
BgL_tail1332z00_13691 = BgL_tail1332z00_27321; 
BgL_l1329z00_13690 = BgL_l1329z00_27320; 
goto BgL_zc3z04anonymousza33109ze3z87_13689;} } } } } } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_11424)))->BgL_envz00)=((obj_t)BgL_envz00_13686),BUNSPEC); 
{ /* Eval/evaluate_comp.scm 582 */
obj_t BgL_g1337z00_13696;
BgL_g1337z00_13696 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_11424)))->BgL_valsz00); 
{ 
obj_t BgL_ll1334z00_13698;obj_t BgL_ll1335z00_13699;
BgL_ll1334z00_13698 = BgL_envz00_13686; 
BgL_ll1335z00_13699 = BgL_g1337z00_13696; 
BgL_zc3z04anonymousza33099ze3z87_13697:
if(
NULLP(BgL_ll1334z00_13698))
{ /* Eval/evaluate_comp.scm 582 */((bool_t)1); }  else 
{ /* Eval/evaluate_comp.scm 582 */
{ /* Eval/evaluate_comp.scm 584 */
obj_t BgL_slotz00_13700;obj_t BgL_valz00_13701;
BgL_slotz00_13700 = 
CAR(
((obj_t)BgL_ll1334z00_13698)); 
BgL_valz00_13701 = 
CAR(
((obj_t)BgL_ll1335z00_13699)); 
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3101z00_13702;
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3102z00_13703;
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3103z00_13704;obj_t BgL_arg3104z00_13705;
BgL_arg3103z00_13704 = 
CDR(
((obj_t)BgL_valz00_13701)); 
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3105z00_13706;
BgL_arg3105z00_13706 = 
CAR(
((obj_t)BgL_valz00_13701)); 
BgL_arg3104z00_13705 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_11425, BgL_arg3105z00_13706); } 
BgL_arg3102z00_13703 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3103z00_13704), BgL_arg3104z00_13705); } 
BgL_fz00_13684 = BgL_arg3102z00_13703; 
{ /* Eval/evaluate_comp.scm 574 */
obj_t BgL_objz00_13685;
BgL_objz00_13685 = BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00; 
{ /* Eval/evaluate_comp.scm 574 */
obj_t BgL_tmpz00_27339;
BgL_tmpz00_27339 = 
((obj_t)BgL_fz00_13684); 
PROCEDURE_ATTR_SET(BgL_tmpz00_27339, BgL_objz00_13685); } BgL_objz00_13685; } 
BgL_arg3101z00_13702 = BgL_fz00_13684; } 
{ /* Eval/evaluate_comp.scm 584 */
obj_t BgL_tmpz00_27342;
BgL_tmpz00_27342 = 
((obj_t)BgL_slotz00_13700); 
SET_CDR(BgL_tmpz00_27342, BgL_arg3101z00_13702); } } } 
{ /* Eval/evaluate_comp.scm 582 */
obj_t BgL_arg3106z00_13707;obj_t BgL_arg3107z00_13708;
BgL_arg3106z00_13707 = 
CDR(
((obj_t)BgL_ll1334z00_13698)); 
BgL_arg3107z00_13708 = 
CDR(
((obj_t)BgL_ll1335z00_13699)); 
{ 
obj_t BgL_ll1335z00_27350;obj_t BgL_ll1334z00_27349;
BgL_ll1334z00_27349 = BgL_arg3106z00_13707; 
BgL_ll1335z00_27350 = BgL_arg3107z00_13708; 
BgL_ll1335z00_13699 = BgL_ll1335z00_27350; 
BgL_ll1334z00_13698 = BgL_ll1334z00_27349; 
goto BgL_zc3z04anonymousza33099ze3z87_13697;} } } } } } 
{ /* Eval/evaluate_comp.scm 589 */
obj_t BgL_bodyz00_13709;
BgL_bodyz00_13709 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_11424)))->BgL_bodyz00), BgL_stkz00_11425); 
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_zc3z04anonymousza33113ze3z87_13710;
BgL_zc3z04anonymousza33113ze3z87_13710 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33113ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33113ze3z87_13710, 
(int)(((long)0)), BgL_bodyz00_13709); 
return BgL_zc3z04anonymousza33113ze3z87_13710;} } } } 

}



/* &<@anonymous:3113> */
obj_t BGl_z62zc3z04anonymousza33113ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11426, obj_t BgL_sz00_11428)
{
{ /* Eval/evaluate_comp.scm 590 */
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_bodyz00_11427;
BgL_bodyz00_11427 = 
PROCEDURE_REF(BgL_envz00_11426, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_bpz00_13711;
BgL_bpz00_13711 = 
VECTOR_REF(
((obj_t)BgL_sz00_11428),((long)0)); 
return 
BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(BgL_bodyz00_11427, BgL_sz00_11428);} } } 

}



/* &comp-ev_synchronize1423 */
obj_t BGl_z62compzd2ev_synchroniza7e1423z17zz__evaluate_compz00(obj_t BgL_envz00_11429, obj_t BgL_ez00_11430, obj_t BgL_stkz00_11431)
{
{ /* Eval/evaluate_comp.scm 552 */
{ /* Eval/evaluate_comp.scm 554 */
obj_t BgL_mutexz00_13713;obj_t BgL_prelockz00_13714;obj_t BgL_bodyz00_13715;
BgL_mutexz00_13713 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_11430)))->BgL_mutexz00), BgL_stkz00_11431); 
BgL_prelockz00_13714 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_11430)))->BgL_prelockz00), BgL_stkz00_11431); 
BgL_bodyz00_13715 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_11430)))->BgL_bodyz00), BgL_stkz00_11431); 
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_zc3z04anonymousza33092ze3z87_13716;
BgL_zc3z04anonymousza33092ze3z87_13716 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33092ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33092ze3z87_13716, 
(int)(((long)0)), BgL_mutexz00_13713); 
PROCEDURE_SET(BgL_zc3z04anonymousza33092ze3z87_13716, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_11430))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33092ze3z87_13716, 
(int)(((long)2)), BgL_prelockz00_13714); 
PROCEDURE_SET(BgL_zc3z04anonymousza33092ze3z87_13716, 
(int)(((long)3)), BgL_bodyz00_13715); 
return BgL_zc3z04anonymousza33092ze3z87_13716;} } } 

}



/* &<@anonymous:3092> */
obj_t BGl_z62zc3z04anonymousza33092ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11432, obj_t BgL_sz00_11437)
{
{ /* Eval/evaluate_comp.scm 557 */
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_mutexz00_11433;BgL_ev_synchroniza7eza7_bglt BgL_i1139z00_11434;obj_t BgL_prelockz00_11435;obj_t BgL_bodyz00_11436;
BgL_mutexz00_11433 = 
PROCEDURE_REF(BgL_envz00_11432, 
(int)(((long)0))); 
BgL_i1139z00_11434 = 
((BgL_ev_synchroniza7eza7_bglt)
PROCEDURE_REF(BgL_envz00_11432, 
(int)(((long)1)))); 
BgL_prelockz00_11435 = 
PROCEDURE_REF(BgL_envz00_11432, 
(int)(((long)2))); 
BgL_bodyz00_11436 = 
PROCEDURE_REF(BgL_envz00_11432, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_bpz00_13717;
BgL_bpz00_13717 = 
VECTOR_REF(
((obj_t)BgL_sz00_11437),((long)0)); 
{ /* Eval/evaluate_comp.scm 558 */
obj_t BgL_mz00_13718;
BgL_mz00_13718 = 
PROCEDURE_ENTRY(BgL_mutexz00_11433)(BgL_mutexz00_11433, BgL_sz00_11437, BEOA); 
if(
BGL_MUTEXP(BgL_mz00_13718))
{ /* Eval/evaluate_comp.scm 560 */
obj_t BgL_pz00_13719;
BgL_pz00_13719 = 
PROCEDURE_ENTRY(BgL_prelockz00_11435)(BgL_prelockz00_11435, BgL_sz00_11437, BEOA); 
{ /* Eval/evaluate_comp.scm 562 */
obj_t BgL_za2za2resza2za2z00_13720;
if(
PAIRP(BgL_pz00_13719))
{ /* Eval/evaluate_comp.scm 563 */
obj_t BgL_top5015z00_27410;
BgL_top5015z00_27410 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_13718, BgL_pz00_13719); 
BGL_EXITD_PUSH_PROTECT(BgL_top5015z00_27410, BgL_mz00_13718); BUNSPEC; 
{ /* Eval/evaluate_comp.scm 563 */
obj_t BgL_tmp5014z00_27409;
BgL_tmp5014z00_27409 = 
PROCEDURE_ENTRY(BgL_bodyz00_11436)(BgL_bodyz00_11436, BgL_sz00_11437, BEOA); 
BGL_EXITD_POP_PROTECT(BgL_top5015z00_27410); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mz00_13718); 
BgL_za2za2resza2za2z00_13720 = BgL_tmp5014z00_27409; } }  else 
{ /* Eval/evaluate_comp.scm 564 */
obj_t BgL_top5017z00_27421;
BgL_top5017z00_27421 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mz00_13718); 
BGL_EXITD_PUSH_PROTECT(BgL_top5017z00_27421, BgL_mz00_13718); BUNSPEC; 
{ /* Eval/evaluate_comp.scm 564 */
obj_t BgL_tmp5016z00_27420;
BgL_tmp5016z00_27420 = 
PROCEDURE_ENTRY(BgL_bodyz00_11436)(BgL_bodyz00_11436, BgL_sz00_11437, BEOA); 
BGL_EXITD_POP_PROTECT(BgL_top5017z00_27421); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mz00_13718); 
BgL_za2za2resza2za2z00_13720 = BgL_tmp5016z00_27420; } } 
VECTOR_SET(
((obj_t)BgL_sz00_11437),((long)0),BgL_bpz00_13717); 
return BgL_za2za2resza2za2z00_13720;} }  else 
{ /* Eval/evaluate_comp.scm 559 */
return 
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_string4379z00zz__evaluate_compz00, BGl_string4380z00zz__evaluate_compz00, BgL_mz00_13718, 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_i1139z00_11434))->BgL_locz00));} } } } } 

}



/* &comp-ev_with-handler1421 */
obj_t BGl_z62compzd2ev_withzd2handler1421z62zz__evaluate_compz00(obj_t BgL_envz00_11438, obj_t BgL_ez00_11439, obj_t BgL_stkz00_11440)
{
{ /* Eval/evaluate_comp.scm 543 */
{ /* Eval/evaluate_comp.scm 545 */
obj_t BgL_handlerz00_13722;obj_t BgL_bodyz00_13723;
BgL_handlerz00_13722 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_11439)))->BgL_handlerz00), BgL_stkz00_11440); 
BgL_bodyz00_13723 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_11439)))->BgL_bodyz00), BgL_stkz00_11440); 
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_zc3z04anonymousza33080ze3z87_13724;
BgL_zc3z04anonymousza33080ze3z87_13724 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33080ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33080ze3z87_13724, 
(int)(((long)0)), BgL_handlerz00_13722); 
PROCEDURE_SET(BgL_zc3z04anonymousza33080ze3z87_13724, 
(int)(((long)1)), BgL_bodyz00_13723); 
return BgL_zc3z04anonymousza33080ze3z87_13724;} } } 

}



/* &<@anonymous:3080> */
obj_t BGl_z62zc3z04anonymousza33080ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11441, obj_t BgL_sz00_11444)
{
{ /* Eval/evaluate_comp.scm 546 */
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_handlerz00_11442;obj_t BgL_bodyz00_11443;
BgL_handlerz00_11442 = 
PROCEDURE_REF(BgL_envz00_11441, 
(int)(((long)0))); 
BgL_bodyz00_11443 = 
PROCEDURE_REF(BgL_envz00_11441, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_bpz00_13725;
BgL_bpz00_13725 = 
VECTOR_REF(
((obj_t)BgL_sz00_11444),((long)0)); 
{ /* Eval/evaluate_comp.scm 547 */
obj_t BgL_hz00_13726;
BgL_hz00_13726 = 
PROCEDURE_ENTRY(BgL_handlerz00_11442)(BgL_handlerz00_11442, BgL_sz00_11444, BEOA); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_za2za2resza2za2z00_13727;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_res1129z00_13728;
BgL_res1129z00_13728 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza33086ze3ze70z60zz__evaluate_compz00(BgL_sz00_11444, BgL_bodyz00_11443, BgL_res1129z00_13728)))
{ /* Eval/evaluate_comp.scm 549 */
{ /* Eval/evaluate_comp.scm 549 */
int BgL_tmpz00_27461;
BgL_tmpz00_27461 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_27461); } 
BgL_za2za2resza2za2z00_13727 = 
PROCEDURE_ENTRY(BgL_hz00_13726)(BgL_hz00_13726, 
CELL_REF(BgL_res1129z00_13728), BEOA); }  else 
{ /* Eval/evaluate_comp.scm 549 */
BgL_za2za2resza2za2z00_13727 = 
CELL_REF(BgL_res1129z00_13728); } } 
VECTOR_SET(
((obj_t)BgL_sz00_11444),((long)0),BgL_bpz00_13725); 
return BgL_za2za2resza2za2z00_13727;} } } } } 

}



/* <@exit:3086>~0 */
obj_t BGl_zc3z04exitza33086ze3ze70z60zz__evaluate_compz00(obj_t BgL_sz00_11632, obj_t BgL_bodyz00_11631, obj_t BgL_res1129z00_11630)
{
{ /* Eval/evaluate_comp.scm 549 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1135z00_4224;
if( SET_EXIT(BgL_an_exit1135z00_4224 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1135z00_4224 = 
(void *)jmpbuf; 
{ /* Eval/evaluate_comp.scm 549 */

PUSH_EXIT(BgL_an_exit1135z00_4224, ((long)1)); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_an_exitd1136z00_4225;
BgL_an_exitd1136z00_4225 = 
((obj_t)(&exitd)); 
{ /* Eval/evaluate_comp.scm 549 */
bool_t BgL_res1138z00_4228;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_ohs1127z00_4229;
BgL_ohs1127z00_4229 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_exitd1132z00_4230;
BgL_exitd1132z00_4230 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza33089ze3z87_10412;
BgL_zc3z04anonymousza33089ze3z87_10412 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33089ze3z87_10412, 
(int)(((long)0)), BgL_ohs1127z00_4229); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1132z00_4230, BgL_zc3z04anonymousza33089ze3z87_10412); 
{ /* Eval/evaluate_comp.scm 549 */
bool_t BgL_tmp1134z00_4232;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_zc3z04anonymousza33088ze3z87_10411;
BgL_zc3z04anonymousza33088ze3z87_10411 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33088ze3z87_10411, 
(int)(((long)0)), 
((obj_t)BgL_res1129z00_11630)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33088ze3z87_10411, 
(int)(((long)1)), BgL_an_exitd1136z00_4225); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza33088ze3z87_10411, BgL_ohs1127z00_4229); BUNSPEC; } 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_auxz00_11446;
BgL_auxz00_11446 = 
PROCEDURE_ENTRY(BgL_bodyz00_11631)(BgL_bodyz00_11631, BgL_sz00_11632, BEOA); 
CELL_SET(BgL_res1129z00_11630, BgL_auxz00_11446); } 
BgL_tmp1134z00_4232 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1132z00_4230); 
BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00(BgL_zc3z04anonymousza33089ze3z87_10412); 
BgL_res1138z00_4228 = BgL_tmp1134z00_4232; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1138z00_4228);} } } 
}} 

}



/* &<@anonymous:3088> */
obj_t BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11448, obj_t BgL_ez00_11451)
{
{ /* Eval/evaluate_comp.scm 549 */
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_res1129z00_11449;obj_t BgL_an_exitd1136z00_11450;
BgL_res1129z00_11449 = 
PROCEDURE_REF(BgL_envz00_11448, 
(int)(((long)0))); 
BgL_an_exitd1136z00_11450 = 
PROCEDURE_REF(BgL_envz00_11448, 
(int)(((long)1))); 
CELL_SET(BgL_res1129z00_11449, BgL_ez00_11451); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1136z00_11450, BTRUE);} } 

}



/* &<@anonymous:3089> */
obj_t BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11453)
{
{ /* Eval/evaluate_comp.scm 549 */
{ 
obj_t BgL_ohs1127z00_11454;
BgL_ohs1127z00_11454 = 
PROCEDURE_REF(BgL_envz00_11453, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1127z00_11454); 
return BUNSPEC;} } 

}



/* &comp-ev_unwind-prote1419 */
obj_t BGl_z62compzd2ev_unwindzd2prote1419z62zz__evaluate_compz00(obj_t BgL_envz00_11455, obj_t BgL_ez00_11456, obj_t BgL_stkz00_11457)
{
{ /* Eval/evaluate_comp.scm 534 */
{ /* Eval/evaluate_comp.scm 536 */
obj_t BgL_ez00_13730;obj_t BgL_bodyz00_13731;
BgL_ez00_13730 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_11456)))->BgL_ez00), BgL_stkz00_11457); 
BgL_bodyz00_13731 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_11456)))->BgL_bodyz00), BgL_stkz00_11457); 
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_zc3z04anonymousza33076ze3z87_13732;
BgL_zc3z04anonymousza33076ze3z87_13732 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33076ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33076ze3z87_13732, 
(int)(((long)0)), BgL_bodyz00_13731); 
PROCEDURE_SET(BgL_zc3z04anonymousza33076ze3z87_13732, 
(int)(((long)1)), BgL_ez00_13730); 
return BgL_zc3z04anonymousza33076ze3z87_13732;} } } 

}



/* &<@anonymous:3076> */
obj_t BGl_z62zc3z04anonymousza33076ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11458, obj_t BgL_sz00_11461)
{
{ /* Eval/evaluate_comp.scm 537 */
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_bodyz00_11459;obj_t BgL_ez00_11460;
BgL_bodyz00_11459 = 
PROCEDURE_REF(BgL_envz00_11458, 
(int)(((long)0))); 
BgL_ez00_11460 = 
PROCEDURE_REF(BgL_envz00_11458, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_bpz00_13733;
BgL_bpz00_13733 = 
VECTOR_REF(
((obj_t)BgL_sz00_11461),((long)0)); 
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_exitd1123z00_13734;
BgL_exitd1123z00_13734 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Eval/evaluate_comp.scm 540 */
obj_t BgL_zc3z04anonymousza33077ze3z87_13735;
BgL_zc3z04anonymousza33077ze3z87_13735 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33077ze3z87_13735, 
(int)(((long)0)), BgL_sz00_11461); 
PROCEDURE_SET(BgL_zc3z04anonymousza33077ze3z87_13735, 
(int)(((long)1)), BgL_bpz00_13733); 
PROCEDURE_SET(BgL_zc3z04anonymousza33077ze3z87_13735, 
(int)(((long)2)), BgL_bodyz00_11459); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1123z00_13734, BgL_zc3z04anonymousza33077ze3z87_13735); 
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_tmp1125z00_13736;
BgL_tmp1125z00_13736 = 
PROCEDURE_ENTRY(BgL_ez00_11460)(BgL_ez00_11460, BgL_sz00_11461, BEOA); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1123z00_13734); 
BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00(BgL_zc3z04anonymousza33077ze3z87_13735); 
return BgL_tmp1125z00_13736;} } } } } } 

}



/* &<@anonymous:3077> */
obj_t BGl_z62zc3z04anonymousza33077ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11462)
{
{ /* Eval/evaluate_comp.scm 539 */
{ /* Eval/evaluate_comp.scm 540 */
obj_t BgL_sz00_11463;obj_t BgL_savedzd2bpzd2_11464;obj_t BgL_bodyz00_11465;
BgL_sz00_11463 = 
PROCEDURE_REF(BgL_envz00_11462, 
(int)(((long)0))); 
BgL_savedzd2bpzd2_11464 = 
PROCEDURE_REF(BgL_envz00_11462, 
(int)(((long)1))); 
BgL_bodyz00_11465 = 
PROCEDURE_REF(BgL_envz00_11462, 
(int)(((long)2))); 
VECTOR_SET(
((obj_t)BgL_sz00_11463),((long)0),BgL_savedzd2bpzd2_11464); 
return 
PROCEDURE_ENTRY(BgL_bodyz00_11465)(BgL_bodyz00_11465, BgL_sz00_11463, BEOA);} } 

}



/* &comp-ev_bind-exit1417 */
obj_t BGl_z62compzd2ev_bindzd2exit1417z62zz__evaluate_compz00(obj_t BgL_envz00_11466, obj_t BgL_ez00_11467, obj_t BgL_stkz00_11468)
{
{ /* Eval/evaluate_comp.scm 523 */
{ /* Eval/evaluate_comp.scm 525 */
long BgL_siza7eza7_13738;obj_t BgL_nstkz00_13739;
BgL_siza7eza7_13738 = 
bgl_list_length(BgL_stkz00_11468); 
{ /* Eval/evaluate_comp.scm 525 */
obj_t BgL_arg3074z00_13740;
{ /* Eval/evaluate_comp.scm 525 */
BgL_ev_varz00_bglt BgL_arg3075z00_13741;
BgL_arg3075z00_13741 = 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_11467)))->BgL_varz00); 
BgL_arg3074z00_13740 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg3075z00_13741), BNIL); } 
BgL_nstkz00_13739 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_11468, BgL_arg3074z00_13740); } 
{ /* Eval/evaluate_comp.scm 526 */
obj_t BgL_bodyz00_13742;obj_t BgL_effzf3zf3_13743;
BgL_bodyz00_13742 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_11467)))->BgL_bodyz00), BgL_nstkz00_13739); 
BgL_effzf3zf3_13743 = 
(((BgL_ev_varz00_bglt)COBJECT(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_11467)))->BgL_varz00)))->BgL_effz00); 
{ /* Eval/evaluate_comp.scm 527 */
obj_t BgL_zc3z04anonymousza33069ze3z87_13744;
BgL_zc3z04anonymousza33069ze3z87_13744 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33069ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33069ze3z87_13744, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_13738)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33069ze3z87_13744, 
(int)(((long)1)), BgL_effzf3zf3_13743); 
PROCEDURE_SET(BgL_zc3z04anonymousza33069ze3z87_13744, 
(int)(((long)2)), BgL_bodyz00_13742); 
return BgL_zc3z04anonymousza33069ze3z87_13744;} } } } 

}



/* &<@anonymous:3069> */
obj_t BGl_z62zc3z04anonymousza33069ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11469, obj_t BgL_sz00_11473)
{
{ /* Eval/evaluate_comp.scm 527 */
{ /* Eval/evaluate_comp.scm 527 */
long BgL_siza7eza7_11470;obj_t BgL_effzf3zf3_11471;obj_t BgL_bodyz00_11472;
BgL_siza7eza7_11470 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11469, 
(int)(((long)0)))); 
BgL_effzf3zf3_11471 = 
PROCEDURE_REF(BgL_envz00_11469, 
(int)(((long)1))); 
BgL_bodyz00_11472 = 
PROCEDURE_REF(BgL_envz00_11469, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 527 */
obj_t BgL_bpz00_13745;
BgL_bpz00_13745 = 
VECTOR_REF(
((obj_t)BgL_sz00_11473),((long)0)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_za2za2resza2za2z00_13746;
BgL_za2za2resza2za2z00_13746 = 
BGl_zc3z04exitza33070ze3ze70z60zz__evaluate_compz00(BgL_bodyz00_11472, BgL_sz00_11473, BgL_effzf3zf3_11471, BgL_siza7eza7_11470, BgL_bpz00_13745); 
VECTOR_SET(
((obj_t)BgL_sz00_11473),((long)0),BgL_bpz00_13745); 
return BgL_za2za2resza2za2z00_13746;} } } } 

}



/* <@exit:3070>~0 */
obj_t BGl_zc3z04exitza33070ze3ze70z60zz__evaluate_compz00(obj_t BgL_bodyz00_11629, obj_t BgL_sz00_11628, obj_t BgL_effzf3zf3_11627, long BgL_siza7eza7_11626, obj_t BgL_bpz00_11625)
{
{ /* Eval/evaluate_comp.scm 529 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1118z00_4160;
if( SET_EXIT(BgL_an_exit1118z00_4160 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1118z00_4160 = 
(void *)jmpbuf; 
{ /* Eval/evaluate_comp.scm 529 */

PUSH_EXIT(BgL_an_exit1118z00_4160, ((long)1)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_an_exitd1119z00_4161;
BgL_an_exitd1119z00_4161 = 
((obj_t)(&exitd)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_exitz00_10418;
BgL_exitz00_10418 = 
MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_exitz00_10418, 
(int)(((long)0)), BgL_an_exitd1119z00_4161); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_res1121z00_4164;
{ /* Eval/evaluate_comp.scm 530 */
long BgL_arg3071z00_4165;obj_t BgL_arg3072z00_4166;
BgL_arg3071z00_4165 = 
(
(long)CINT(BgL_bpz00_11625)+BgL_siza7eza7_11626); 
if(
CBOOL(BgL_effzf3zf3_11627))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_8268;
BgL_newz00_8268 = 
create_struct(BGl_symbol4270z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_27601;
BgL_tmpz00_27601 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_8268, BgL_tmpz00_27601, BgL_exitz00_10418); } 
BgL_arg3072z00_4166 = BgL_newz00_8268; }  else 
{ /* Eval/evaluate_comp.scm 530 */
BgL_arg3072z00_4166 = BgL_exitz00_10418; } 
VECTOR_SET(
((obj_t)BgL_sz00_11628),BgL_arg3071z00_4165,BgL_arg3072z00_4166); } 
BgL_res1121z00_4164 = 
PROCEDURE_ENTRY(BgL_bodyz00_11629)(BgL_bodyz00_11629, BgL_sz00_11628, BEOA); 
POP_EXIT(); 
return BgL_res1121z00_4164;} } } } 
}} 

}



/* &exit */
obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_11474, obj_t BgL_val1120z00_11476)
{
{ /* Eval/evaluate_comp.scm 529 */
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(
PROCEDURE_REF(BgL_envz00_11474, 
(int)(((long)0))), BgL_val1120z00_11476);} 

}



/* &comp-ev_letrec1415 */
obj_t BGl_z62compzd2ev_letrec1415zb0zz__evaluate_compz00(obj_t BgL_envz00_11477, obj_t BgL_ez00_11478, obj_t BgL_stkz00_11479)
{
{ /* Eval/evaluate_comp.scm 494 */
{ /* Eval/evaluate_comp.scm 496 */
long BgL_siza7eza7_13748;obj_t BgL_nstkz00_13749;
BgL_siza7eza7_13748 = 
bgl_list_length(BgL_stkz00_11479); 
{ /* Eval/evaluate_comp.scm 496 */
obj_t BgL_arg3068z00_13750;
BgL_arg3068z00_13750 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_11478))))->BgL_varsz00); 
BgL_nstkz00_13749 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_11479, BgL_arg3068z00_13750); } 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_cvalsz00_13751;obj_t BgL_bodyz00_13752;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_l1315z00_13753;
BgL_l1315z00_13753 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_11478))))->BgL_valsz00); 
if(
NULLP(BgL_l1315z00_13753))
{ /* Eval/evaluate_comp.scm 497 */
BgL_cvalsz00_13751 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_head1317z00_13754;
BgL_head1317z00_13754 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1315z00_13756;obj_t BgL_tail1318z00_13757;
BgL_l1315z00_13756 = BgL_l1315z00_13753; 
BgL_tail1318z00_13757 = BgL_head1317z00_13754; 
BgL_zc3z04anonymousza33063ze3z87_13755:
if(
NULLP(BgL_l1315z00_13756))
{ /* Eval/evaluate_comp.scm 497 */
BgL_cvalsz00_13751 = 
CDR(BgL_head1317z00_13754); }  else 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_newtail1319z00_13758;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_arg3066z00_13759;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_vz00_13760;
BgL_vz00_13760 = 
CAR(
((obj_t)BgL_l1315z00_13756)); 
BgL_arg3066z00_13759 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_vz00_13760), BgL_nstkz00_13749); } 
BgL_newtail1319z00_13758 = 
MAKE_YOUNG_PAIR(BgL_arg3066z00_13759, BNIL); } 
SET_CDR(BgL_tail1318z00_13757, BgL_newtail1319z00_13758); 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_arg3065z00_13761;
BgL_arg3065z00_13761 = 
CDR(
((obj_t)BgL_l1315z00_13756)); 
{ 
obj_t BgL_tail1318z00_27637;obj_t BgL_l1315z00_27636;
BgL_l1315z00_27636 = BgL_arg3065z00_13761; 
BgL_tail1318z00_27637 = BgL_newtail1319z00_13758; 
BgL_tail1318z00_13757 = BgL_tail1318z00_27637; 
BgL_l1315z00_13756 = BgL_l1315z00_27636; 
goto BgL_zc3z04anonymousza33063ze3z87_13755;} } } } } } 
{ /* Eval/evaluate_comp.scm 498 */
BgL_ev_exprz00_bglt BgL_arg3067z00_13762;
BgL_arg3067z00_13762 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_11478))))->BgL_bodyz00); 
BgL_bodyz00_13752 = 
BGl_compz00zz__evaluate_compz00(BgL_arg3067z00_13762, BgL_nstkz00_13749); } 
{ /* Eval/evaluate_comp.scm 499 */
bool_t BgL_test5022z00_27642;
{ 
obj_t BgL_l1320z00_13764;
BgL_l1320z00_13764 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_11478))))->BgL_valsz00); 
BgL_zc3z04anonymousza33060ze3z87_13763:
if(
NULLP(BgL_l1320z00_13764))
{ /* Eval/evaluate_comp.scm 499 */
BgL_test5022z00_27642 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 499 */
bool_t BgL_test5024z00_27645;
{ /* Eval/evaluate_comp.scm 499 */
obj_t BgL_vz00_13765;
BgL_vz00_13765 = 
CAR(
((obj_t)BgL_l1320z00_13764)); 
BgL_test5024z00_27645 = 
BGl_isazf3zf3zz__objectz00(BgL_vz00_13765, BGl_ev_absz00zz__evaluate_typesz00); } 
if(BgL_test5024z00_27645)
{ 
obj_t BgL_l1320z00_27649;
BgL_l1320z00_27649 = 
CDR(
((obj_t)BgL_l1320z00_13764)); 
BgL_l1320z00_13764 = BgL_l1320z00_27649; 
goto BgL_zc3z04anonymousza33060ze3z87_13763;}  else 
{ /* Eval/evaluate_comp.scm 499 */
BgL_test5022z00_27642 = ((bool_t)0)
; } } } 
if(BgL_test5022z00_27642)
{ /* Eval/evaluate_comp.scm 500 */
obj_t BgL_zc3z04anonymousza33030ze3z87_13766;
BgL_zc3z04anonymousza33030ze3z87_13766 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33030ze3z87_13766, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_13748)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33030ze3z87_13766, 
(int)(((long)1)), BgL_cvalsz00_13751); 
PROCEDURE_SET(BgL_zc3z04anonymousza33030ze3z87_13766, 
(int)(((long)2)), BgL_bodyz00_13752); 
return BgL_zc3z04anonymousza33030ze3z87_13766;}  else 
{ /* Eval/evaluate_comp.scm 510 */
obj_t BgL_zc3z04anonymousza33043ze3z87_13767;
BgL_zc3z04anonymousza33043ze3z87_13767 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33043ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33043ze3z87_13767, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_13748)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33043ze3z87_13767, 
(int)(((long)1)), BgL_cvalsz00_13751); 
PROCEDURE_SET(BgL_zc3z04anonymousza33043ze3z87_13767, 
(int)(((long)2)), BgL_bodyz00_13752); 
return BgL_zc3z04anonymousza33043ze3z87_13767;} } } } } 

}



/* &<@anonymous:3030> */
obj_t BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11480, obj_t BgL_sz00_11484)
{
{ /* Eval/evaluate_comp.scm 500 */
{ /* Eval/evaluate_comp.scm 500 */
long BgL_siza7eza7_11481;obj_t BgL_cvalsz00_11482;obj_t BgL_bodyz00_11483;
BgL_siza7eza7_11481 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11480, 
(int)(((long)0)))); 
BgL_cvalsz00_11482 = 
PROCEDURE_REF(BgL_envz00_11480, 
(int)(((long)1))); 
BgL_bodyz00_11483 = 
PROCEDURE_REF(BgL_envz00_11480, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 500 */
obj_t BgL_bpz00_13768;
BgL_bpz00_13768 = 
VECTOR_REF(
((obj_t)BgL_sz00_11484),((long)0)); 
{ /* Eval/evaluate_comp.scm 501 */
long BgL_g1112z00_13769;
BgL_g1112z00_13769 = 
(
(long)CINT(BgL_bpz00_13768)+BgL_siza7eza7_11481); 
{ 
obj_t BgL_lz00_13771;long BgL_iz00_13772;
BgL_lz00_13771 = BgL_cvalsz00_11482; 
BgL_iz00_13772 = BgL_g1112z00_13769; 
BgL_recz00_13770:
if(
NULLP(BgL_lz00_13771))
{ /* Eval/evaluate_comp.scm 502 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 502 */
{ /* Eval/evaluate_comp.scm 503 */
obj_t BgL_arg3033z00_13773;
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_13774;
BgL_newz00_13774 = 
create_struct(BGl_symbol4270z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_27690;
BgL_tmpz00_27690 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13774, BgL_tmpz00_27690, BUNSPEC); } 
BgL_arg3033z00_13773 = BgL_newz00_13774; } 
VECTOR_SET(
((obj_t)BgL_sz00_11484),BgL_iz00_13772,BgL_arg3033z00_13773); } 
{ /* Eval/evaluate_comp.scm 504 */
obj_t BgL_arg3034z00_13775;long BgL_arg3035z00_13776;
BgL_arg3034z00_13775 = 
CDR(
((obj_t)BgL_lz00_13771)); 
BgL_arg3035z00_13776 = 
(BgL_iz00_13772+((long)1)); 
{ 
long BgL_iz00_27699;obj_t BgL_lz00_27698;
BgL_lz00_27698 = BgL_arg3034z00_13775; 
BgL_iz00_27699 = BgL_arg3035z00_13776; 
BgL_iz00_13772 = BgL_iz00_27699; 
BgL_lz00_13771 = BgL_lz00_27698; 
goto BgL_recz00_13770;} } } } } 
{ /* Eval/evaluate_comp.scm 505 */
long BgL_g1113z00_13777;
BgL_g1113z00_13777 = 
(
(long)CINT(BgL_bpz00_13768)+BgL_siza7eza7_11481); 
{ 
obj_t BgL_lz00_13779;long BgL_iz00_13780;
BgL_lz00_13779 = BgL_cvalsz00_11482; 
BgL_iz00_13780 = BgL_g1113z00_13777; 
BgL_recz00_13778:
if(
NULLP(BgL_lz00_13779))
{ /* Eval/evaluate_comp.scm 506 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 506 */
{ /* Eval/evaluate_comp.scm 507 */
obj_t BgL_arg3038z00_13781;obj_t BgL_arg3039z00_13782;
BgL_arg3038z00_13781 = 
VECTOR_REF(
((obj_t)BgL_sz00_11484),BgL_iz00_13780); 
{ /* Eval/evaluate_comp.scm 507 */
obj_t BgL_fun3040z00_13783;
BgL_fun3040z00_13783 = 
CAR(
((obj_t)BgL_lz00_13779)); 
BgL_arg3039z00_13782 = 
PROCEDURE_ENTRY(BgL_fun3040z00_13783)(BgL_fun3040z00_13783, BgL_sz00_11484, BEOA); } 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_27714;obj_t BgL_tmpz00_27712;
BgL_auxz00_27714 = 
(int)(((long)0)); 
BgL_tmpz00_27712 = 
((obj_t)BgL_arg3038z00_13781); 
STRUCT_SET(BgL_tmpz00_27712, BgL_auxz00_27714, BgL_arg3039z00_13782); } } 
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_arg3041z00_13784;long BgL_arg3042z00_13785;
BgL_arg3041z00_13784 = 
CDR(
((obj_t)BgL_lz00_13779)); 
BgL_arg3042z00_13785 = 
(BgL_iz00_13780+((long)1)); 
{ 
long BgL_iz00_27721;obj_t BgL_lz00_27720;
BgL_lz00_27720 = BgL_arg3041z00_13784; 
BgL_iz00_27721 = BgL_arg3042z00_13785; 
BgL_iz00_13780 = BgL_iz00_27721; 
BgL_lz00_13779 = BgL_lz00_27720; 
goto BgL_recz00_13778;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_11483)(BgL_bodyz00_11483, BgL_sz00_11484, BEOA);} } } 

}



/* &<@anonymous:3043> */
obj_t BGl_z62zc3z04anonymousza33043ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11485, obj_t BgL_sz00_11489)
{
{ /* Eval/evaluate_comp.scm 510 */
{ /* Eval/evaluate_comp.scm 510 */
long BgL_siza7eza7_11486;obj_t BgL_cvalsz00_11487;obj_t BgL_bodyz00_11488;
BgL_siza7eza7_11486 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11485, 
(int)(((long)0)))); 
BgL_cvalsz00_11487 = 
PROCEDURE_REF(BgL_envz00_11485, 
(int)(((long)1))); 
BgL_bodyz00_11488 = 
PROCEDURE_REF(BgL_envz00_11485, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 510 */
obj_t BgL_bpz00_13786;
BgL_bpz00_13786 = 
VECTOR_REF(
((obj_t)BgL_sz00_11489),((long)0)); 
{ /* Eval/evaluate_comp.scm 511 */
long BgL_g1114z00_13787;
BgL_g1114z00_13787 = 
(
(long)CINT(BgL_bpz00_13786)+BgL_siza7eza7_11486); 
{ 
obj_t BgL_lz00_13789;long BgL_iz00_13790;
BgL_lz00_13789 = BgL_cvalsz00_11487; 
BgL_iz00_13790 = BgL_g1114z00_13787; 
BgL_recz00_13788:
if(
NULLP(BgL_lz00_13789))
{ /* Eval/evaluate_comp.scm 512 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 512 */
{ /* Eval/evaluate_comp.scm 513 */
obj_t BgL_arg3046z00_13791;
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_13792;
BgL_newz00_13792 = 
create_struct(BGl_symbol4270z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_27741;
BgL_tmpz00_27741 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13792, BgL_tmpz00_27741, BUNSPEC); } 
BgL_arg3046z00_13791 = BgL_newz00_13792; } 
VECTOR_SET(
((obj_t)BgL_sz00_11489),BgL_iz00_13790,BgL_arg3046z00_13791); } 
{ /* Eval/evaluate_comp.scm 514 */
obj_t BgL_arg3047z00_13793;long BgL_arg3048z00_13794;
BgL_arg3047z00_13793 = 
CDR(
((obj_t)BgL_lz00_13789)); 
BgL_arg3048z00_13794 = 
(BgL_iz00_13790+((long)1)); 
{ 
long BgL_iz00_27750;obj_t BgL_lz00_27749;
BgL_lz00_27749 = BgL_arg3047z00_13793; 
BgL_iz00_27750 = BgL_arg3048z00_13794; 
BgL_iz00_13790 = BgL_iz00_27750; 
BgL_lz00_13789 = BgL_lz00_27749; 
goto BgL_recz00_13788;} } } } } 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_rvalsz00_13795;
if(
NULLP(BgL_cvalsz00_11487))
{ /* Eval/evaluate_comp.scm 515 */
BgL_rvalsz00_13795 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_head1326z00_13796;
BgL_head1326z00_13796 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1324z00_13798;obj_t BgL_tail1327z00_13799;
BgL_l1324z00_13798 = BgL_cvalsz00_11487; 
BgL_tail1327z00_13799 = BgL_head1326z00_13796; 
BgL_zc3z04anonymousza33056ze3z87_13797:
if(
NULLP(BgL_l1324z00_13798))
{ /* Eval/evaluate_comp.scm 515 */
BgL_rvalsz00_13795 = 
CDR(BgL_head1326z00_13796); }  else 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_newtail1328z00_13800;
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_arg3059z00_13801;
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_vz00_13802;
BgL_vz00_13802 = 
CAR(
((obj_t)BgL_l1324z00_13798)); 
BgL_arg3059z00_13801 = 
PROCEDURE_ENTRY(BgL_vz00_13802)(BgL_vz00_13802, BgL_sz00_11489, BEOA); } 
BgL_newtail1328z00_13800 = 
MAKE_YOUNG_PAIR(BgL_arg3059z00_13801, BNIL); } 
SET_CDR(BgL_tail1327z00_13799, BgL_newtail1328z00_13800); 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_arg3058z00_13803;
BgL_arg3058z00_13803 = 
CDR(
((obj_t)BgL_l1324z00_13798)); 
{ 
obj_t BgL_tail1327z00_27768;obj_t BgL_l1324z00_27767;
BgL_l1324z00_27767 = BgL_arg3058z00_13803; 
BgL_tail1327z00_27768 = BgL_newtail1328z00_13800; 
BgL_tail1327z00_13799 = BgL_tail1327z00_27768; 
BgL_l1324z00_13798 = BgL_l1324z00_27767; 
goto BgL_zc3z04anonymousza33056ze3z87_13797;} } } } } 
{ /* Eval/evaluate_comp.scm 516 */
long BgL_g1115z00_13804;
BgL_g1115z00_13804 = 
(
(long)CINT(BgL_bpz00_13786)+BgL_siza7eza7_11486); 
{ 
obj_t BgL_lz00_13806;long BgL_iz00_13807;
BgL_lz00_13806 = BgL_rvalsz00_13795; 
BgL_iz00_13807 = BgL_g1115z00_13804; 
BgL_recz00_13805:
if(
NULLP(BgL_lz00_13806))
{ /* Eval/evaluate_comp.scm 517 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 517 */
{ /* Eval/evaluate_comp.scm 518 */
obj_t BgL_arg3051z00_13808;obj_t BgL_arg3052z00_13809;
BgL_arg3051z00_13808 = 
VECTOR_REF(
((obj_t)BgL_sz00_11489),BgL_iz00_13807); 
BgL_arg3052z00_13809 = 
CAR(
((obj_t)BgL_lz00_13806)); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_27779;obj_t BgL_tmpz00_27777;
BgL_auxz00_27779 = 
(int)(((long)0)); 
BgL_tmpz00_27777 = 
((obj_t)BgL_arg3051z00_13808); 
STRUCT_SET(BgL_tmpz00_27777, BgL_auxz00_27779, BgL_arg3052z00_13809); } } 
{ /* Eval/evaluate_comp.scm 519 */
obj_t BgL_arg3053z00_13810;long BgL_arg3054z00_13811;
BgL_arg3053z00_13810 = 
CDR(
((obj_t)BgL_lz00_13806)); 
BgL_arg3054z00_13811 = 
(BgL_iz00_13807+((long)1)); 
{ 
long BgL_iz00_27786;obj_t BgL_lz00_27785;
BgL_lz00_27785 = BgL_arg3053z00_13810; 
BgL_iz00_27786 = BgL_arg3054z00_13811; 
BgL_iz00_13807 = BgL_iz00_27786; 
BgL_lz00_13806 = BgL_lz00_27785; 
goto BgL_recz00_13805;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_11488)(BgL_bodyz00_11488, BgL_sz00_11489, BEOA);} } } } 

}



/* &comp-ev_let*1413 */
obj_t BGl_z62compzd2ev_letza21413z12zz__evaluate_compz00(obj_t BgL_envz00_11490, obj_t BgL_ez00_11491, obj_t BgL_stkz00_11492)
{
{ /* Eval/evaluate_comp.scm 481 */
{ /* Eval/evaluate_comp.scm 483 */
long BgL_siza7eza7_13813;obj_t BgL_nstkz00_13814;
BgL_siza7eza7_13813 = 
bgl_list_length(BgL_stkz00_11492); 
{ /* Eval/evaluate_comp.scm 483 */
obj_t BgL_arg3025z00_13815;
BgL_arg3025z00_13815 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_11491))))->BgL_varsz00); 
BgL_nstkz00_13814 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_11492, BgL_arg3025z00_13815); } 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_valsz00_13816;obj_t BgL_bodyz00_13817;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_l1310z00_13818;
BgL_l1310z00_13818 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_11491))))->BgL_valsz00); 
if(
NULLP(BgL_l1310z00_13818))
{ /* Eval/evaluate_comp.scm 484 */
BgL_valsz00_13816 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_head1312z00_13819;
BgL_head1312z00_13819 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1310z00_13821;obj_t BgL_tail1313z00_13822;
BgL_l1310z00_13821 = BgL_l1310z00_13818; 
BgL_tail1313z00_13822 = BgL_head1312z00_13819; 
BgL_zc3z04anonymousza33020ze3z87_13820:
if(
NULLP(BgL_l1310z00_13821))
{ /* Eval/evaluate_comp.scm 484 */
BgL_valsz00_13816 = 
CDR(BgL_head1312z00_13819); }  else 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_newtail1314z00_13823;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_arg3023z00_13824;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_vz00_13825;
BgL_vz00_13825 = 
CAR(
((obj_t)BgL_l1310z00_13821)); 
BgL_arg3023z00_13824 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_vz00_13825), BgL_nstkz00_13814); } 
BgL_newtail1314z00_13823 = 
MAKE_YOUNG_PAIR(BgL_arg3023z00_13824, BNIL); } 
SET_CDR(BgL_tail1313z00_13822, BgL_newtail1314z00_13823); 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_arg3022z00_13826;
BgL_arg3022z00_13826 = 
CDR(
((obj_t)BgL_l1310z00_13821)); 
{ 
obj_t BgL_tail1313z00_27814;obj_t BgL_l1310z00_27813;
BgL_l1310z00_27813 = BgL_arg3022z00_13826; 
BgL_tail1313z00_27814 = BgL_newtail1314z00_13823; 
BgL_tail1313z00_13822 = BgL_tail1313z00_27814; 
BgL_l1310z00_13821 = BgL_l1310z00_27813; 
goto BgL_zc3z04anonymousza33020ze3z87_13820;} } } } } } 
{ /* Eval/evaluate_comp.scm 485 */
BgL_ev_exprz00_bglt BgL_arg3024z00_13827;
BgL_arg3024z00_13827 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_11491))))->BgL_bodyz00); 
BgL_bodyz00_13817 = 
BGl_compz00zz__evaluate_compz00(BgL_arg3024z00_13827, BgL_nstkz00_13814); } 
{ /* Eval/evaluate_comp.scm 486 */
obj_t BgL_zc3z04anonymousza33009ze3z87_13828;
BgL_zc3z04anonymousza33009ze3z87_13828 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33009ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33009ze3z87_13828, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_13813)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33009ze3z87_13828, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_letza2za2_bglt)BgL_ez00_11491))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33009ze3z87_13828, 
(int)(((long)2)), BgL_valsz00_13816); 
PROCEDURE_SET(BgL_zc3z04anonymousza33009ze3z87_13828, 
(int)(((long)3)), BgL_bodyz00_13817); 
return BgL_zc3z04anonymousza33009ze3z87_13828;} } } } 

}



/* &<@anonymous:3009> */
obj_t BGl_z62zc3z04anonymousza33009ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11493, obj_t BgL_sz00_11498)
{
{ /* Eval/evaluate_comp.scm 486 */
{ /* Eval/evaluate_comp.scm 486 */
long BgL_siza7eza7_11494;BgL_ev_letza2za2_bglt BgL_i1109z00_11495;obj_t BgL_valsz00_11496;obj_t BgL_bodyz00_11497;
BgL_siza7eza7_11494 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11493, 
(int)(((long)0)))); 
BgL_i1109z00_11495 = 
((BgL_ev_letza2za2_bglt)
PROCEDURE_REF(BgL_envz00_11493, 
(int)(((long)1)))); 
BgL_valsz00_11496 = 
PROCEDURE_REF(BgL_envz00_11493, 
(int)(((long)2))); 
BgL_bodyz00_11497 = 
PROCEDURE_REF(BgL_envz00_11493, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 486 */
obj_t BgL_bpz00_13829;
BgL_bpz00_13829 = 
VECTOR_REF(
((obj_t)BgL_sz00_11498),((long)0)); 
{ /* Eval/evaluate_comp.scm 487 */
long BgL_g1110z00_13830;
BgL_g1110z00_13830 = 
(
(long)CINT(BgL_bpz00_13829)+BgL_siza7eza7_11494); 
{ 
obj_t BgL_lz00_13832;long BgL_iz00_13833;obj_t BgL_bza2za2_13834;
BgL_lz00_13832 = BgL_valsz00_11496; 
BgL_iz00_13833 = BgL_g1110z00_13830; 
BgL_bza2za2_13834 = 
(((BgL_ev_letza2za2_bglt)COBJECT(BgL_i1109z00_11495))->BgL_boxesz00); 
BgL_recz00_13831:
if(
NULLP(BgL_lz00_13832))
{ /* Eval/evaluate_comp.scm 488 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 488 */
{ /* Eval/evaluate_comp.scm 489 */
obj_t BgL_valz00_13835;
{ /* Eval/evaluate_comp.scm 489 */
obj_t BgL_fun3015z00_13836;
BgL_fun3015z00_13836 = 
CAR(
((obj_t)BgL_lz00_13832)); 
BgL_valz00_13835 = 
PROCEDURE_ENTRY(BgL_fun3015z00_13836)(BgL_fun3015z00_13836, BgL_sz00_11498, BEOA); } 
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_arg3013z00_13837;
if(
CBOOL(
CAR(
((obj_t)BgL_bza2za2_13834))))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_13838;
BgL_newz00_13838 = 
create_struct(BGl_symbol4270z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_27861;
BgL_tmpz00_27861 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13838, BgL_tmpz00_27861, BgL_valz00_13835); } 
BgL_arg3013z00_13837 = BgL_newz00_13838; }  else 
{ /* Eval/evaluate_comp.scm 490 */
BgL_arg3013z00_13837 = BgL_valz00_13835; } 
VECTOR_SET(
((obj_t)BgL_sz00_11498),BgL_iz00_13833,BgL_arg3013z00_13837); } } 
{ /* Eval/evaluate_comp.scm 491 */
obj_t BgL_arg3016z00_13839;long BgL_arg3017z00_13840;obj_t BgL_arg3018z00_13841;
BgL_arg3016z00_13839 = 
CDR(
((obj_t)BgL_lz00_13832)); 
BgL_arg3017z00_13840 = 
(BgL_iz00_13833+((long)1)); 
BgL_arg3018z00_13841 = 
CDR(
((obj_t)BgL_bza2za2_13834)); 
{ 
obj_t BgL_bza2za2_27873;long BgL_iz00_27872;obj_t BgL_lz00_27871;
BgL_lz00_27871 = BgL_arg3016z00_13839; 
BgL_iz00_27872 = BgL_arg3017z00_13840; 
BgL_bza2za2_27873 = BgL_arg3018z00_13841; 
BgL_bza2za2_13834 = BgL_bza2za2_27873; 
BgL_iz00_13833 = BgL_iz00_27872; 
BgL_lz00_13832 = BgL_lz00_27871; 
goto BgL_recz00_13831;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_11497)(BgL_bodyz00_11497, BgL_sz00_11498, BEOA);} } } 

}



/* &comp-ev_let1411 */
obj_t BGl_z62compzd2ev_let1411zb0zz__evaluate_compz00(obj_t BgL_envz00_11499, obj_t BgL_ez00_11500, obj_t BgL_stkz00_11501)
{
{ /* Eval/evaluate_comp.scm 462 */
{ /* Eval/evaluate_comp.scm 464 */
long BgL_siza7eza7_13843;obj_t BgL_nstkz00_13844;
BgL_siza7eza7_13843 = 
bgl_list_length(BgL_stkz00_11501); 
{ /* Eval/evaluate_comp.scm 464 */
obj_t BgL_arg3008z00_13845;
BgL_arg3008z00_13845 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_11500))))->BgL_varsz00); 
BgL_nstkz00_13844 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_11501, BgL_arg3008z00_13845); } 
{ /* Eval/evaluate_comp.scm 465 */
obj_t BgL_valsz00_13846;obj_t BgL_iboxesz00_13847;obj_t BgL_bodyz00_13848;
{ /* Eval/evaluate_comp.scm 466 */
obj_t BgL_arg3001z00_13849;
BgL_arg3001z00_13849 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_11500))))->BgL_valsz00); 
BgL_valsz00_13846 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg3001z00_13849, BgL_stkz00_11501); } 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_l1305z00_13850;
BgL_l1305z00_13850 = 
(((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_ez00_11500)))->BgL_boxesz00); 
if(
NULLP(BgL_l1305z00_13850))
{ /* Eval/evaluate_comp.scm 467 */
BgL_iboxesz00_13847 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_head1307z00_13851;
BgL_head1307z00_13851 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1305z00_13853;obj_t BgL_tail1308z00_13854;
BgL_l1305z00_13853 = BgL_l1305z00_13850; 
BgL_tail1308z00_13854 = BgL_head1307z00_13851; 
BgL_zc3z04anonymousza33003ze3z87_13852:
if(
NULLP(BgL_l1305z00_13853))
{ /* Eval/evaluate_comp.scm 467 */
BgL_iboxesz00_13847 = 
CDR(BgL_head1307z00_13851); }  else 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_newtail1309z00_13855;
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_arg3006z00_13856;
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_vz00_13857;
BgL_vz00_13857 = 
CAR(
((obj_t)BgL_l1305z00_13853)); 
BgL_arg3006z00_13856 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_13857, BgL_nstkz00_13844); } 
BgL_newtail1309z00_13855 = 
MAKE_YOUNG_PAIR(BgL_arg3006z00_13856, BNIL); } 
SET_CDR(BgL_tail1308z00_13854, BgL_newtail1309z00_13855); 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_arg3005z00_13858;
BgL_arg3005z00_13858 = 
CDR(
((obj_t)BgL_l1305z00_13853)); 
{ 
obj_t BgL_tail1308z00_27904;obj_t BgL_l1305z00_27903;
BgL_l1305z00_27903 = BgL_arg3005z00_13858; 
BgL_tail1308z00_27904 = BgL_newtail1309z00_13855; 
BgL_tail1308z00_13854 = BgL_tail1308z00_27904; 
BgL_l1305z00_13853 = BgL_l1305z00_27903; 
goto BgL_zc3z04anonymousza33003ze3z87_13852;} } } } } } 
{ /* Eval/evaluate_comp.scm 468 */
BgL_ev_exprz00_bglt BgL_arg3007z00_13859;
BgL_arg3007z00_13859 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_11500))))->BgL_bodyz00); 
BgL_bodyz00_13848 = 
BGl_compz00zz__evaluate_compz00(BgL_arg3007z00_13859, BgL_nstkz00_13844); } 
{ /* Eval/evaluate_comp.scm 469 */
obj_t BgL_zc3z04anonymousza32988ze3z87_13860;
BgL_zc3z04anonymousza32988ze3z87_13860 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32988ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32988ze3z87_13860, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_13843)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32988ze3z87_13860, 
(int)(((long)1)), BgL_valsz00_13846); 
PROCEDURE_SET(BgL_zc3z04anonymousza32988ze3z87_13860, 
(int)(((long)2)), BgL_iboxesz00_13847); 
PROCEDURE_SET(BgL_zc3z04anonymousza32988ze3z87_13860, 
(int)(((long)3)), BgL_bodyz00_13848); 
return BgL_zc3z04anonymousza32988ze3z87_13860;} } } } 

}



/* &<@anonymous:2988> */
obj_t BGl_z62zc3z04anonymousza32988ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11502, obj_t BgL_sz00_11507)
{
{ /* Eval/evaluate_comp.scm 469 */
{ /* Eval/evaluate_comp.scm 469 */
long BgL_siza7eza7_11503;obj_t BgL_valsz00_11504;obj_t BgL_iboxesz00_11505;obj_t BgL_bodyz00_11506;
BgL_siza7eza7_11503 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11502, 
(int)(((long)0)))); 
BgL_valsz00_11504 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11502, 
(int)(((long)1)))); 
BgL_iboxesz00_11505 = 
PROCEDURE_REF(BgL_envz00_11502, 
(int)(((long)2))); 
BgL_bodyz00_11506 = 
PROCEDURE_REF(BgL_envz00_11502, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 469 */
obj_t BgL_bpz00_13861;
BgL_bpz00_13861 = 
VECTOR_REF(
((obj_t)BgL_sz00_11507),((long)0)); 
{ /* Eval/evaluate_comp.scm 470 */
long BgL_g1108z00_13862;
BgL_g1108z00_13862 = 
(
(long)CINT(BgL_bpz00_13861)+BgL_siza7eza7_11503); 
{ 
obj_t BgL_lz00_13864;long BgL_iz00_13865;
BgL_lz00_13864 = BgL_valsz00_11504; 
BgL_iz00_13865 = BgL_g1108z00_13862; 
BgL_recz00_13863:
if(
NULLP(BgL_lz00_13864))
{ /* Eval/evaluate_comp.scm 471 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 471 */
{ /* Eval/evaluate_comp.scm 472 */
obj_t BgL_arg2991z00_13866;
{ /* Eval/evaluate_comp.scm 472 */
obj_t BgL_fun2992z00_13867;
BgL_fun2992z00_13867 = 
CAR(
((obj_t)BgL_lz00_13864)); 
BgL_arg2991z00_13866 = 
PROCEDURE_ENTRY(BgL_fun2992z00_13867)(BgL_fun2992z00_13867, BgL_sz00_11507, BEOA); } 
VECTOR_SET(
((obj_t)BgL_sz00_11507),BgL_iz00_13865,BgL_arg2991z00_13866); } 
{ /* Eval/evaluate_comp.scm 473 */
obj_t BgL_arg2993z00_13868;long BgL_arg2994z00_13869;
BgL_arg2993z00_13868 = 
CDR(
((obj_t)BgL_lz00_13864)); 
BgL_arg2994z00_13869 = 
(BgL_iz00_13865+((long)1)); 
{ 
long BgL_iz00_27949;obj_t BgL_lz00_27948;
BgL_lz00_27948 = BgL_arg2993z00_13868; 
BgL_iz00_27949 = BgL_arg2994z00_13869; 
BgL_iz00_13865 = BgL_iz00_27949; 
BgL_lz00_13864 = BgL_lz00_27948; 
goto BgL_recz00_13863;} } } } } 
{ 
obj_t BgL_lz00_13871;
BgL_lz00_13871 = BgL_iboxesz00_11505; 
BgL_recz00_13870:
if(
NULLP(BgL_lz00_13871))
{ /* Eval/evaluate_comp.scm 475 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 475 */
{ /* Eval/evaluate_comp.scm 476 */
long BgL_iz00_13872;
BgL_iz00_13872 = 
(
(long)CINT(BgL_bpz00_13861)+
(long)CINT(
CAR(
((obj_t)BgL_lz00_13871)))); 
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_arg2997z00_13873;
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_arg2998z00_13874;
BgL_arg2998z00_13874 = 
VECTOR_REF(
((obj_t)BgL_sz00_11507),BgL_iz00_13872); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_13875;
BgL_newz00_13875 = 
create_struct(BGl_symbol4270z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_27961;
BgL_tmpz00_27961 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13875, BgL_tmpz00_27961, BgL_arg2998z00_13874); } 
BgL_arg2997z00_13873 = BgL_newz00_13875; } } 
VECTOR_SET(
((obj_t)BgL_sz00_11507),BgL_iz00_13872,BgL_arg2997z00_13873); } } 
{ /* Eval/evaluate_comp.scm 478 */
obj_t BgL_arg3000z00_13876;
BgL_arg3000z00_13876 = 
CDR(
((obj_t)BgL_lz00_13871)); 
{ 
obj_t BgL_lz00_27968;
BgL_lz00_27968 = BgL_arg3000z00_13876; 
BgL_lz00_13871 = BgL_lz00_27968; 
goto BgL_recz00_13870;} } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_11506)(BgL_bodyz00_11506, BgL_sz00_11507, BEOA);} } } 

}



/* &comp-ev_prog21409 */
obj_t BGl_z62compzd2ev_prog21409zb0zz__evaluate_compz00(obj_t BgL_envz00_11508, obj_t BgL_ez00_11509, obj_t BgL_stkz00_11510)
{
{ /* Eval/evaluate_comp.scm 456 */
{ /* Eval/evaluate_comp.scm 458 */
obj_t BgL_e1z00_13878;obj_t BgL_e2z00_13879;
BgL_e1z00_13878 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_11509)))->BgL_e1z00), BgL_stkz00_11510); 
BgL_e2z00_13879 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_11509)))->BgL_e2z00), BgL_stkz00_11510); 
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_zc3z04anonymousza32985ze3z87_13880;
BgL_zc3z04anonymousza32985ze3z87_13880 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32985ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32985ze3z87_13880, 
(int)(((long)0)), BgL_e1z00_13878); 
PROCEDURE_SET(BgL_zc3z04anonymousza32985ze3z87_13880, 
(int)(((long)1)), BgL_e2z00_13879); 
return BgL_zc3z04anonymousza32985ze3z87_13880;} } } 

}



/* &<@anonymous:2985> */
obj_t BGl_z62zc3z04anonymousza32985ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11511, obj_t BgL_sz00_11514)
{
{ /* Eval/evaluate_comp.scm 459 */
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_e1z00_11512;obj_t BgL_e2z00_11513;
BgL_e1z00_11512 = 
PROCEDURE_REF(BgL_envz00_11511, 
(int)(((long)0))); 
BgL_e2z00_11513 = 
PROCEDURE_REF(BgL_envz00_11511, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_bpz00_13881;
BgL_bpz00_13881 = 
VECTOR_REF(
((obj_t)BgL_sz00_11514),((long)0)); 
PROCEDURE_ENTRY(BgL_e1z00_11512)(BgL_e1z00_11512, BgL_sz00_11514, BEOA); 
return 
PROCEDURE_ENTRY(BgL_e2z00_11513)(BgL_e2z00_11513, BgL_sz00_11514, BEOA);} } } 

}



/* &comp-ev_and1407 */
obj_t BGl_z62compzd2ev_and1407zb0zz__evaluate_compz00(obj_t BgL_envz00_11515, obj_t BgL_ez00_11516, obj_t BgL_stkz00_11517)
{
{ /* Eval/evaluate_comp.scm 446 */
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_argsz00_13883;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_l1300z00_13884;
BgL_l1300z00_13884 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_ez00_11516))))->BgL_argsz00); 
if(
NULLP(BgL_l1300z00_13884))
{ /* Eval/evaluate_comp.scm 448 */
BgL_argsz00_13883 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_head1302z00_13885;
BgL_head1302z00_13885 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1300z00_13887;obj_t BgL_tail1303z00_13888;
BgL_l1300z00_13887 = BgL_l1300z00_13884; 
BgL_tail1303z00_13888 = BgL_head1302z00_13885; 
BgL_zc3z04anonymousza32981ze3z87_13886:
if(
NULLP(BgL_l1300z00_13887))
{ /* Eval/evaluate_comp.scm 448 */
BgL_argsz00_13883 = 
CDR(BgL_head1302z00_13885); }  else 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_newtail1304z00_13889;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_arg2984z00_13890;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_ez00_13891;
BgL_ez00_13891 = 
CAR(
((obj_t)BgL_l1300z00_13887)); 
BgL_arg2984z00_13890 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_ez00_13891), BgL_stkz00_11517); } 
BgL_newtail1304z00_13889 = 
MAKE_YOUNG_PAIR(BgL_arg2984z00_13890, BNIL); } 
SET_CDR(BgL_tail1303z00_13888, BgL_newtail1304z00_13889); 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_arg2983z00_13892;
BgL_arg2983z00_13892 = 
CDR(
((obj_t)BgL_l1300z00_13887)); 
{ 
obj_t BgL_tail1303z00_28018;obj_t BgL_l1300z00_28017;
BgL_l1300z00_28017 = BgL_arg2983z00_13892; 
BgL_tail1303z00_28018 = BgL_newtail1304z00_13889; 
BgL_tail1303z00_13888 = BgL_tail1303z00_28018; 
BgL_l1300z00_13887 = BgL_l1300z00_28017; 
goto BgL_zc3z04anonymousza32981ze3z87_13886;} } } } } } 
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_zc3z04anonymousza32975ze3z87_13893;
BgL_zc3z04anonymousza32975ze3z87_13893 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32975ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32975ze3z87_13893, 
(int)(((long)0)), BgL_argsz00_13883); 
return BgL_zc3z04anonymousza32975ze3z87_13893;} } } 

}



/* &<@anonymous:2975> */
obj_t BGl_z62zc3z04anonymousza32975ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11518, obj_t BgL_sz00_11520)
{
{ /* Eval/evaluate_comp.scm 449 */
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_argsz00_11519;
BgL_argsz00_11519 = 
PROCEDURE_REF(BgL_envz00_11518, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_bpz00_13894;
BgL_bpz00_13894 = 
VECTOR_REF(
((obj_t)BgL_sz00_11520),((long)0)); 
{ 
obj_t BgL_lz00_13896;obj_t BgL_rz00_13897;
BgL_lz00_13896 = BgL_argsz00_11519; 
BgL_rz00_13897 = BTRUE; 
BgL_recz00_13895:
if(
NULLP(BgL_lz00_13896))
{ /* Eval/evaluate_comp.scm 451 */
return BgL_rz00_13897;}  else 
{ /* Eval/evaluate_comp.scm 453 */
obj_t BgL_vz00_13898;
{ /* Eval/evaluate_comp.scm 453 */
obj_t BgL_fun2979z00_13899;
BgL_fun2979z00_13899 = 
CAR(
((obj_t)BgL_lz00_13896)); 
BgL_vz00_13898 = 
PROCEDURE_ENTRY(BgL_fun2979z00_13899)(BgL_fun2979z00_13899, BgL_sz00_11520, BEOA); } 
if(
CBOOL(BgL_vz00_13898))
{ /* Eval/evaluate_comp.scm 454 */
obj_t BgL_arg2978z00_13900;
BgL_arg2978z00_13900 = 
CDR(
((obj_t)BgL_lz00_13896)); 
{ 
obj_t BgL_rz00_28041;obj_t BgL_lz00_28040;
BgL_lz00_28040 = BgL_arg2978z00_13900; 
BgL_rz00_28041 = BgL_vz00_13898; 
BgL_rz00_13897 = BgL_rz00_28041; 
BgL_lz00_13896 = BgL_lz00_28040; 
goto BgL_recz00_13895;} }  else 
{ /* Eval/evaluate_comp.scm 454 */
return BFALSE;} } } } } } 

}



/* &comp-ev_or1405 */
obj_t BGl_z62compzd2ev_or1405zb0zz__evaluate_compz00(obj_t BgL_envz00_11521, obj_t BgL_ez00_11522, obj_t BgL_stkz00_11523)
{
{ /* Eval/evaluate_comp.scm 437 */
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_argsz00_13902;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_l1295z00_13903;
BgL_l1295z00_13903 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_ez00_11522))))->BgL_argsz00); 
if(
NULLP(BgL_l1295z00_13903))
{ /* Eval/evaluate_comp.scm 439 */
BgL_argsz00_13902 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_head1297z00_13904;
BgL_head1297z00_13904 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1295z00_13906;obj_t BgL_tail1298z00_13907;
BgL_l1295z00_13906 = BgL_l1295z00_13903; 
BgL_tail1298z00_13907 = BgL_head1297z00_13904; 
BgL_zc3z04anonymousza32971ze3z87_13905:
if(
NULLP(BgL_l1295z00_13906))
{ /* Eval/evaluate_comp.scm 439 */
BgL_argsz00_13902 = 
CDR(BgL_head1297z00_13904); }  else 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_newtail1299z00_13908;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_arg2974z00_13909;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_ez00_13910;
BgL_ez00_13910 = 
CAR(
((obj_t)BgL_l1295z00_13906)); 
BgL_arg2974z00_13909 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_ez00_13910), BgL_stkz00_11523); } 
BgL_newtail1299z00_13908 = 
MAKE_YOUNG_PAIR(BgL_arg2974z00_13909, BNIL); } 
SET_CDR(BgL_tail1298z00_13907, BgL_newtail1299z00_13908); 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_arg2973z00_13911;
BgL_arg2973z00_13911 = 
CDR(
((obj_t)BgL_l1295z00_13906)); 
{ 
obj_t BgL_tail1298z00_28060;obj_t BgL_l1295z00_28059;
BgL_l1295z00_28059 = BgL_arg2973z00_13911; 
BgL_tail1298z00_28060 = BgL_newtail1299z00_13908; 
BgL_tail1298z00_13907 = BgL_tail1298z00_28060; 
BgL_l1295z00_13906 = BgL_l1295z00_28059; 
goto BgL_zc3z04anonymousza32971ze3z87_13905;} } } } } } 
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_zc3z04anonymousza32965ze3z87_13912;
BgL_zc3z04anonymousza32965ze3z87_13912 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32965ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32965ze3z87_13912, 
(int)(((long)0)), BgL_argsz00_13902); 
return BgL_zc3z04anonymousza32965ze3z87_13912;} } } 

}



/* &<@anonymous:2965> */
obj_t BGl_z62zc3z04anonymousza32965ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11524, obj_t BgL_sz00_11526)
{
{ /* Eval/evaluate_comp.scm 440 */
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_argsz00_11525;
BgL_argsz00_11525 = 
PROCEDURE_REF(BgL_envz00_11524, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_bpz00_13913;
BgL_bpz00_13913 = 
VECTOR_REF(
((obj_t)BgL_sz00_11526),((long)0)); 
{ 
obj_t BgL_lz00_13915;
BgL_lz00_13915 = BgL_argsz00_11525; 
BgL_recz00_13914:
if(
NULLP(BgL_lz00_13915))
{ /* Eval/evaluate_comp.scm 442 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL__ortest_1103z00_13916;
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL_fun2969z00_13917;
BgL_fun2969z00_13917 = 
CAR(
((obj_t)BgL_lz00_13915)); 
BgL__ortest_1103z00_13916 = 
PROCEDURE_ENTRY(BgL_fun2969z00_13917)(BgL_fun2969z00_13917, BgL_sz00_11526, BEOA); } 
if(
CBOOL(BgL__ortest_1103z00_13916))
{ /* Eval/evaluate_comp.scm 444 */
return BgL__ortest_1103z00_13916;}  else 
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL_arg2968z00_13918;
BgL_arg2968z00_13918 = 
CDR(
((obj_t)BgL_lz00_13915)); 
{ 
obj_t BgL_lz00_28082;
BgL_lz00_28082 = BgL_arg2968z00_13918; 
BgL_lz00_13915 = BgL_lz00_28082; 
goto BgL_recz00_13914;} } } } } } } 

}



/* &comp-ev_if1403 */
obj_t BGl_z62compzd2ev_if1403zb0zz__evaluate_compz00(obj_t BgL_envz00_11527, obj_t BgL_ez00_11528, obj_t BgL_stkz00_11529)
{
{ /* Eval/evaluate_comp.scm 431 */
{ /* Eval/evaluate_comp.scm 433 */
obj_t BgL_pz00_13920;obj_t BgL_tz00_13921;obj_t BgL_ez00_13922;
BgL_pz00_13920 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_11528)))->BgL_pz00), BgL_stkz00_11529); 
BgL_tz00_13921 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_11528)))->BgL_tz00), BgL_stkz00_11529); 
BgL_ez00_13922 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_11528)))->BgL_ez00), BgL_stkz00_11529); 
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_zc3z04anonymousza32960ze3z87_13923;
BgL_zc3z04anonymousza32960ze3z87_13923 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32960ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32960ze3z87_13923, 
(int)(((long)0)), BgL_ez00_13922); 
PROCEDURE_SET(BgL_zc3z04anonymousza32960ze3z87_13923, 
(int)(((long)1)), BgL_tz00_13921); 
PROCEDURE_SET(BgL_zc3z04anonymousza32960ze3z87_13923, 
(int)(((long)2)), BgL_pz00_13920); 
return BgL_zc3z04anonymousza32960ze3z87_13923;} } } 

}



/* &<@anonymous:2960> */
obj_t BGl_z62zc3z04anonymousza32960ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11530, obj_t BgL_sz00_11534)
{
{ /* Eval/evaluate_comp.scm 434 */
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_ez00_11531;obj_t BgL_tz00_11532;obj_t BgL_pz00_11533;
BgL_ez00_11531 = 
PROCEDURE_REF(BgL_envz00_11530, 
(int)(((long)0))); 
BgL_tz00_11532 = 
PROCEDURE_REF(BgL_envz00_11530, 
(int)(((long)1))); 
BgL_pz00_11533 = 
PROCEDURE_REF(BgL_envz00_11530, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_bpz00_13924;
BgL_bpz00_13924 = 
VECTOR_REF(
((obj_t)BgL_sz00_11534),((long)0)); 
if(
CBOOL(
PROCEDURE_ENTRY(BgL_pz00_11533)(BgL_pz00_11533, BgL_sz00_11534, BEOA)))
{ /* Eval/evaluate_comp.scm 435 */
return 
PROCEDURE_ENTRY(BgL_tz00_11532)(BgL_tz00_11532, BgL_sz00_11534, BEOA);}  else 
{ /* Eval/evaluate_comp.scm 435 */
return 
PROCEDURE_ENTRY(BgL_ez00_11531)(BgL_ez00_11531, BgL_sz00_11534, BEOA);} } } } 

}



/* &comp-ev_litt1401 */
obj_t BGl_z62compzd2ev_litt1401zb0zz__evaluate_compz00(obj_t BgL_envz00_11535, obj_t BgL_ez00_11536, obj_t BgL_stkz00_11537)
{
{ /* Eval/evaluate_comp.scm 426 */
{ /* Eval/evaluate_comp.scm 428 */
obj_t BgL_zc3z04anonymousza32959ze3z87_13926;
BgL_zc3z04anonymousza32959ze3z87_13926 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32959ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32959ze3z87_13926, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_littz00_bglt)BgL_ez00_11536))); 
return BgL_zc3z04anonymousza32959ze3z87_13926;} } 

}



/* &<@anonymous:2959> */
obj_t BGl_z62zc3z04anonymousza32959ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11538, obj_t BgL_sz00_11540)
{
{ /* Eval/evaluate_comp.scm 428 */
{ /* Eval/evaluate_comp.scm 428 */
BgL_ev_littz00_bglt BgL_i1100z00_11539;
BgL_i1100z00_11539 = 
((BgL_ev_littz00_bglt)
PROCEDURE_REF(BgL_envz00_11538, 
(int)(((long)0)))); 
{ /* Eval/evaluate_comp.scm 428 */
obj_t BgL_bpz00_13927;
BgL_bpz00_13927 = 
VECTOR_REF(
((obj_t)BgL_sz00_11540),((long)0)); 
return 
(((BgL_ev_littz00_bglt)COBJECT(BgL_i1100z00_11539))->BgL_valuez00);} } } 

}



/* &comp-ev_defglobal1399 */
obj_t BGl_z62compzd2ev_defglobal1399zb0zz__evaluate_compz00(obj_t BgL_envz00_11541, obj_t BgL_ez00_11542, obj_t BgL_stkz00_11543)
{
{ /* Eval/evaluate_comp.scm 395 */
{ /* Eval/evaluate_comp.scm 397 */
obj_t BgL_ez00_13929;
{ /* Eval/evaluate_comp.scm 397 */
BgL_ev_exprz00_bglt BgL_arg2958z00_13930;
BgL_arg2958z00_13930 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_ez00_11542))))->BgL_ez00); 
BgL_ez00_13929 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2958z00_13930, BgL_stkz00_11543); } 
{ /* Eval/evaluate_comp.scm 398 */
obj_t BgL_zc3z04anonymousza32933ze3z87_13931;
BgL_zc3z04anonymousza32933ze3z87_13931 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32933ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32933ze3z87_13931, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_defglobalz00_bglt)BgL_ez00_11542))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32933ze3z87_13931, 
(int)(((long)1)), BgL_ez00_13929); 
return BgL_zc3z04anonymousza32933ze3z87_13931;} } } 

}



/* &<@anonymous:2933> */
obj_t BGl_z62zc3z04anonymousza32933ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11544, obj_t BgL_sz00_11547)
{
{ /* Eval/evaluate_comp.scm 398 */
{ /* Eval/evaluate_comp.scm 398 */
BgL_ev_defglobalz00_bglt BgL_i1097z00_11545;obj_t BgL_ez00_11546;
BgL_i1097z00_11545 = 
((BgL_ev_defglobalz00_bglt)
PROCEDURE_REF(BgL_envz00_11544, 
(int)(((long)0)))); 
BgL_ez00_11546 = 
PROCEDURE_REF(BgL_envz00_11544, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 398 */
obj_t BgL_bpz00_13932;
BgL_bpz00_13932 = 
VECTOR_REF(
((obj_t)BgL_sz00_11547),((long)0)); 
{ /* Eval/evaluate_comp.scm 399 */
obj_t BgL_gz00_13933;
{ /* Eval/evaluate_comp.scm 399 */
obj_t BgL_arg2956z00_13934;obj_t BgL_arg2957z00_13935;
BgL_arg2956z00_13934 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_modz00); 
BgL_arg2957z00_13935 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_namez00); 
BgL_gz00_13933 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2956z00_13934, BgL_arg2957z00_13935); } 
if(
CBOOL(BgL_gz00_13933))
{ /* Eval/evaluate_comp.scm 401 */
{ 

{ /* Eval/evaluate_comp.scm 403 */
int BgL_aux1099z00_13939;
{ /* Eval/evaluate_comp.scm 403 */
int BgL_res4129z00_13940;
BgL_res4129z00_13940 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_13933),((long)0))); 
BgL_aux1099z00_13939 = BgL_res4129z00_13940; } 
switch( 
(long)(BgL_aux1099z00_13939)) { case ((long)0) : 

{ /* Eval/evaluate_comp.scm 405 */
obj_t BgL_arg2935z00_13941;obj_t BgL_arg2936z00_13942;
BgL_arg2935z00_13941 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_locz00); 
BgL_arg2936z00_13942 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_namez00); 
BGl_everrorz00zz__everrorz00(BgL_arg2935z00_13941, BGl_string4381z00zz__evaluate_compz00, BGl_string4382z00zz__evaluate_compz00, BgL_arg2936z00_13942); } break;case ((long)1) : 

{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2937z00_13943;obj_t BgL_arg2938z00_13944;
BgL_arg2937z00_13943 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_locz00); 
BgL_arg2938z00_13944 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_namez00); 
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_list2939z00_13945;
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2940z00_13946;
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2941z00_13947;
BgL_arg2941z00_13947 = 
MAKE_YOUNG_PAIR(BgL_arg2938z00_13944, BNIL); 
BgL_arg2940z00_13946 = 
MAKE_YOUNG_PAIR(BGl_string4383z00zz__evaluate_compz00, BgL_arg2941z00_13947); } 
BgL_list2939z00_13945 = 
MAKE_YOUNG_PAIR(BGl_string4260z00zz__evaluate_compz00, BgL_arg2940z00_13946); } 
BGl_evwarningz00zz__everrorz00(BgL_arg2937z00_13943, BgL_list2939z00_13945); } } 
{ /* Eval/evaluate_comp.scm 409 */
obj_t BgL_arg2942z00_13948;obj_t BgL_arg2943z00_13949;
BgL_arg2942z00_13948 = 
VECTOR_REF(
((obj_t)BgL_gz00_13933),((long)2)); 
BgL_arg2943z00_13949 = 
PROCEDURE_ENTRY(BgL_ez00_11546)(BgL_ez00_11546, BgL_sz00_11547, BEOA); 
__EVMEANING_ADDRESS_SET(BgL_arg2942z00_13948, BgL_arg2943z00_13949); } break;case ((long)2) : 

{ /* Eval/evaluate_comp.scm 411 */
obj_t BgL_arg2944z00_13950;
BgL_arg2944z00_13950 = 
PROCEDURE_ENTRY(BgL_ez00_11546)(BgL_ez00_11546, BgL_sz00_11547, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_13933),((long)2),BgL_arg2944z00_13950); } break;case ((long)3) : 

{ /* Eval/evaluate_comp.scm 413 */
obj_t BgL_arg2945z00_13951;
BgL_arg2945z00_13951 = 
PROCEDURE_ENTRY(BgL_ez00_11546)(BgL_ez00_11546, BgL_sz00_11547, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_13933),((long)2),BgL_arg2945z00_13951); } 
VECTOR_SET(
((obj_t)BgL_gz00_13933),((long)0),
BINT(((long)2))); break;case ((long)4) : 

{ /* Eval/evaluate_comp.scm 416 */
obj_t BgL_arg2946z00_13952;
BgL_arg2946z00_13952 = 
PROCEDURE_ENTRY(BgL_ez00_11546)(BgL_ez00_11546, BgL_sz00_11547, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_13933),((long)2),BgL_arg2946z00_13952); } 
VECTOR_SET(
((obj_t)BgL_gz00_13933),((long)0),
BINT(((long)5))); break;
default: 
{ /* Eval/evaluate_comp.scm 419 */
obj_t BgL_arg2947z00_13937;obj_t BgL_arg2948z00_13938;
BgL_arg2947z00_13937 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_locz00); 
BgL_arg2948z00_13938 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_namez00); 
BGl_everrorz00zz__everrorz00(BgL_arg2947z00_13937, BGl_string4381z00zz__evaluate_compz00, BGl_string4382z00zz__evaluate_compz00, BgL_arg2948z00_13938); } } } } 
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_namez00);}  else 
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_gz00_13953;
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_arg2953z00_13954;obj_t BgL_arg2954z00_13955;obj_t BgL_arg2955z00_13956;
BgL_arg2953z00_13954 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_namez00); 
BgL_arg2954z00_13955 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_modz00); 
BgL_arg2955z00_13956 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_v1373z00_13957;
BgL_v1373z00_13957 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1373z00_13957,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1373z00_13957,((long)1),BgL_arg2953z00_13954); 
VECTOR_SET(BgL_v1373z00_13957,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1373z00_13957,((long)3),BgL_arg2954z00_13955); 
VECTOR_SET(BgL_v1373z00_13957,((long)4),BgL_arg2955z00_13956); 
BgL_gz00_13953 = BgL_v1373z00_13957; } } 
{ /* Eval/evaluate_comp.scm 422 */
obj_t BgL_arg2949z00_13958;
BgL_arg2949z00_13958 = 
PROCEDURE_ENTRY(BgL_ez00_11546)(BgL_ez00_11546, BgL_sz00_11547, BEOA); 
VECTOR_SET(BgL_gz00_13953,((long)2),BgL_arg2949z00_13958); } 
{ /* Eval/evaluate_comp.scm 423 */
obj_t BgL_arg2950z00_13959;obj_t BgL_arg2951z00_13960;obj_t BgL_arg2952z00_13961;
BgL_arg2950z00_13959 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_modz00); 
BgL_arg2951z00_13960 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_namez00); 
BgL_arg2952z00_13961 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_locz00); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(BgL_arg2950z00_13959, BgL_arg2951z00_13960, BgL_gz00_13953, BgL_arg2952z00_13961); } 
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1097z00_11545)))->BgL_namez00);} } } } } 

}



/* &comp-ev_setglobal1397 */
obj_t BGl_z62compzd2ev_setglobal1397zb0zz__evaluate_compz00(obj_t BgL_envz00_11548, obj_t BgL_ez00_11549, obj_t BgL_stkz00_11550)
{
{ /* Eval/evaluate_comp.scm 372 */
{ /* Eval/evaluate_comp.scm 374 */
obj_t BgL_gz00_13963;obj_t BgL_ez00_13964;
BgL_gz00_13963 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_namez00)); 
{ /* Eval/evaluate_comp.scm 374 */
BgL_ev_exprz00_bglt BgL_arg2932z00_13965;
BgL_arg2932z00_13965 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549))))->BgL_ez00); 
BgL_ez00_13964 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2932z00_13965, BgL_stkz00_11550); } 
if(
CBOOL(BgL_gz00_13963))
{ 

{ /* Eval/evaluate_comp.scm 376 */
int BgL_aux1096z00_13968;
{ /* Eval/evaluate_comp.scm 376 */
int BgL_res4128z00_13969;
BgL_res4128z00_13969 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_13963),((long)0))); 
BgL_aux1096z00_13968 = BgL_res4128z00_13969; } 
switch( 
(long)(BgL_aux1096z00_13968)) { case ((long)1) : 

{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_zc3z04anonymousza32908ze3z87_13970;
BgL_zc3z04anonymousza32908ze3z87_13970 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32908ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32908ze3z87_13970, 
(int)(((long)0)), BgL_gz00_13963); 
PROCEDURE_SET(BgL_zc3z04anonymousza32908ze3z87_13970, 
(int)(((long)1)), BgL_ez00_13964); 
return BgL_zc3z04anonymousza32908ze3z87_13970;} break;case ((long)0) : 
case ((long)4) : 
case ((long)5) : 

return 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_locz00), BGl_string4381z00zz__evaluate_compz00, BGl_string4382z00zz__evaluate_compz00, 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_namez00));break;
default: 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_zc3z04anonymousza32913ze3z87_13967;
BgL_zc3z04anonymousza32913ze3z87_13967 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32913ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32913ze3z87_13967, 
(int)(((long)0)), BgL_ez00_13964); 
PROCEDURE_SET(BgL_zc3z04anonymousza32913ze3z87_13967, 
(int)(((long)1)), BgL_gz00_13963); 
return BgL_zc3z04anonymousza32913ze3z87_13967;} } } }  else 
{ /* Eval/evaluate_comp.scm 384 */
obj_t BgL_slotz00_13971;
BgL_slotz00_13971 = 
MAKE_CELL(BFALSE); 
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_gz00_13972;
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_arg2920z00_13973;obj_t BgL_arg2921z00_13974;obj_t BgL_arg2922z00_13975;
BgL_arg2920z00_13973 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_namez00); 
BgL_arg2921z00_13974 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_modz00); 
BgL_arg2922z00_13975 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_v1373z00_13976;
BgL_v1373z00_13976 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1373z00_13976,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1373z00_13976,((long)1),BgL_arg2920z00_13973); 
VECTOR_SET(BgL_v1373z00_13976,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1373z00_13976,((long)3),BgL_arg2921z00_13974); 
VECTOR_SET(BgL_v1373z00_13976,((long)4),BgL_arg2922z00_13975); 
BgL_gz00_13972 = BgL_v1373z00_13976; } } 
VECTOR_SET(BgL_gz00_13972,((long)0),
BINT(((long)3))); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_namez00), BgL_gz00_13972, 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549)))->BgL_locz00)); }  else 
{ /* Eval/evaluate_comp.scm 385 */BFALSE; } 
{ /* Eval/evaluate_comp.scm 389 */
obj_t BgL_zc3z04anonymousza32924ze3z87_13977;
BgL_zc3z04anonymousza32924ze3z87_13977 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32924ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32924ze3z87_13977, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_setglobalz00_bglt)BgL_ez00_11549))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32924ze3z87_13977, 
(int)(((long)1)), 
((obj_t)BgL_slotz00_13971)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32924ze3z87_13977, 
(int)(((long)2)), BgL_ez00_13964); 
return BgL_zc3z04anonymousza32924ze3z87_13977;} } } } 

}



/* &<@anonymous:2908> */
obj_t BGl_z62zc3z04anonymousza32908ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11553, obj_t BgL_sz00_11556)
{
{ /* Eval/evaluate_comp.scm 378 */
{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_gz00_11554;obj_t BgL_ez00_11555;
BgL_gz00_11554 = 
PROCEDURE_REF(BgL_envz00_11553, 
(int)(((long)0))); 
BgL_ez00_11555 = 
PROCEDURE_REF(BgL_envz00_11553, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_bpz00_13978;
BgL_bpz00_13978 = 
VECTOR_REF(
((obj_t)BgL_sz00_11556),((long)0)); 
{ /* Eval/evaluate_comp.scm 379 */
obj_t BgL_arg2909z00_13979;obj_t BgL_arg2910z00_13980;
BgL_arg2909z00_13979 = 
VECTOR_REF(
((obj_t)BgL_gz00_11554),((long)2)); 
BgL_arg2910z00_13980 = 
PROCEDURE_ENTRY(BgL_ez00_11555)(BgL_ez00_11555, BgL_sz00_11556, BEOA); 
return 
__EVMEANING_ADDRESS_SET(BgL_arg2909z00_13979, BgL_arg2910z00_13980);} } } } 

}



/* &<@anonymous:2913> */
obj_t BGl_z62zc3z04anonymousza32913ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11557, obj_t BgL_sz00_11560)
{
{ /* Eval/evaluate_comp.scm 383 */
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_ez00_11558;obj_t BgL_gz00_11559;
BgL_ez00_11558 = 
PROCEDURE_REF(BgL_envz00_11557, 
(int)(((long)0))); 
BgL_gz00_11559 = 
PROCEDURE_REF(BgL_envz00_11557, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_bpz00_13981;
BgL_bpz00_13981 = 
VECTOR_REF(
((obj_t)BgL_sz00_11560),((long)0)); 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_arg2914z00_13982;
BgL_arg2914z00_13982 = 
PROCEDURE_ENTRY(BgL_ez00_11558)(BgL_ez00_11558, BgL_sz00_11560, BEOA); 
return 
VECTOR_SET(
((obj_t)BgL_gz00_11559),((long)2),BgL_arg2914z00_13982);} } } } 

}



/* &<@anonymous:2924> */
obj_t BGl_z62zc3z04anonymousza32924ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11561, obj_t BgL_sz00_11565)
{
{ /* Eval/evaluate_comp.scm 389 */
{ /* Eval/evaluate_comp.scm 389 */
BgL_ev_setglobalz00_bglt BgL_i1094z00_11562;obj_t BgL_slotz00_11563;obj_t BgL_ez00_11564;
BgL_i1094z00_11562 = 
((BgL_ev_setglobalz00_bglt)
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)0)))); 
BgL_slotz00_11563 = 
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)1))); 
BgL_ez00_11564 = 
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 389 */
obj_t BgL_bpz00_13983;
BgL_bpz00_13983 = 
VECTOR_REF(
((obj_t)BgL_sz00_11565),((long)0)); 
if(
CBOOL(
CELL_REF(BgL_slotz00_11563)))
{ /* Eval/evaluate_comp.scm 390 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 390 */
{ /* Eval/evaluate_comp.scm 391 */
obj_t BgL_auxz00_13984;
BgL_auxz00_13984 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1094z00_11562))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1094z00_11562))->BgL_namez00)); 
CELL_SET(BgL_slotz00_11563, BgL_auxz00_13984); } 
if(
CBOOL(
CELL_REF(BgL_slotz00_11563)))
{ /* Eval/evaluate_comp.scm 392 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 392 */
BGl_everrorz00zz__everrorz00(
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1094z00_11562))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4384z00zz__evaluate_compz00, 
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1094z00_11562))->BgL_namez00)); } } 
{ /* Eval/evaluate_comp.scm 393 */
obj_t BgL_arg2929z00_13985;
BgL_arg2929z00_13985 = 
PROCEDURE_ENTRY(BgL_ez00_11564)(BgL_ez00_11564, BgL_sz00_11565, BEOA); 
{ /* Eval/evaluate_comp.scm 393 */
obj_t BgL_evalzd2globalzd2_13986;
BgL_evalzd2globalzd2_13986 = 
CELL_REF(BgL_slotz00_11563); 
return 
VECTOR_SET(BgL_evalzd2globalzd2_13986,((long)2),BgL_arg2929z00_13985);} } } } } 

}



/* &comp-ev_global1395 */
obj_t BGl_z62compzd2ev_global1395zb0zz__evaluate_compz00(obj_t BgL_envz00_11567, obj_t BgL_varz00_11568, obj_t BgL_stkz00_11569)
{
{ /* Eval/evaluate_comp.scm 339 */
{ /* Eval/evaluate_comp.scm 341 */
obj_t BgL_gz00_13988;
BgL_gz00_13988 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_namez00)); 
if(
CBOOL(BgL_gz00_13988))
{ /* Eval/evaluate_comp.scm 343 */
bool_t BgL_test5054z00_28375;
{ /* Eval/evaluate_comp.scm 343 */
int BgL_arg2871z00_13989;
{ /* Eval/evaluate_comp.scm 343 */
int BgL_res4126z00_13990;
BgL_res4126z00_13990 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_13988),((long)0))); 
BgL_arg2871z00_13989 = BgL_res4126z00_13990; } 
BgL_test5054z00_28375 = 
(
BINT(BgL_arg2871z00_13989)==
BINT(((long)1))); } 
if(BgL_test5054z00_28375)
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_zc3z04anonymousza32868ze3z87_13991;
BgL_zc3z04anonymousza32868ze3z87_13991 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32868ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32868ze3z87_13991, 
(int)(((long)0)), BgL_gz00_13988); 
return BgL_zc3z04anonymousza32868ze3z87_13991;}  else 
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_zc3z04anonymousza32870ze3z87_13992;
BgL_zc3z04anonymousza32870ze3z87_13992 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32870ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32870ze3z87_13992, 
(int)(((long)0)), BgL_gz00_13988); 
return BgL_zc3z04anonymousza32870ze3z87_13992;} }  else 
{ /* Eval/evaluate_comp.scm 348 */
obj_t BgL_slotz00_13993;
BgL_slotz00_13993 = 
MAKE_CELL(BFALSE); 
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_gz00_13994;
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_arg2877z00_13995;obj_t BgL_arg2878z00_13996;obj_t BgL_arg2879z00_13997;
BgL_arg2877z00_13995 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_namez00); 
BgL_arg2878z00_13996 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_modz00); 
BgL_arg2879z00_13997 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_v1373z00_13998;
BgL_v1373z00_13998 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1373z00_13998,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1373z00_13998,((long)1),BgL_arg2877z00_13995); 
VECTOR_SET(BgL_v1373z00_13998,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1373z00_13998,((long)3),BgL_arg2878z00_13996); 
VECTOR_SET(BgL_v1373z00_13998,((long)4),BgL_arg2879z00_13997); 
BgL_gz00_13994 = BgL_v1373z00_13998; } } 
VECTOR_SET(BgL_gz00_13994,((long)0),
BINT(((long)3))); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_namez00), BgL_gz00_13994, 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_11568)))->BgL_locz00)); }  else 
{ /* Eval/evaluate_comp.scm 349 */BFALSE; } 
{ /* Eval/evaluate_comp.scm 353 */
obj_t BgL_zc3z04anonymousza32881ze3z87_13999;
BgL_zc3z04anonymousza32881ze3z87_13999 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32881ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32881ze3z87_13999, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_globalz00_bglt)BgL_varz00_11568))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32881ze3z87_13999, 
(int)(((long)1)), 
((obj_t)BgL_slotz00_13993)); 
return BgL_zc3z04anonymousza32881ze3z87_13999;} } } } 

}



/* &<@anonymous:2868> */
obj_t BGl_z62zc3z04anonymousza32868ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11572, obj_t BgL_sz00_11574)
{
{ /* Eval/evaluate_comp.scm 344 */
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_gz00_11573;
BgL_gz00_11573 = 
PROCEDURE_REF(BgL_envz00_11572, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_bpz00_14000;
BgL_bpz00_14000 = 
VECTOR_REF(
((obj_t)BgL_sz00_11574),((long)0)); 
{ /* Eval/evaluate_comp.scm 345 */
obj_t BgL_arg2869z00_14001;
BgL_arg2869z00_14001 = 
VECTOR_REF(
((obj_t)BgL_gz00_11573),((long)2)); 
return 
__EVMEANING_ADDRESS_REF(BgL_arg2869z00_14001);} } } } 

}



/* &<@anonymous:2870> */
obj_t BGl_z62zc3z04anonymousza32870ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11575, obj_t BgL_sz00_11577)
{
{ /* Eval/evaluate_comp.scm 346 */
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_gz00_11576;
BgL_gz00_11576 = 
PROCEDURE_REF(BgL_envz00_11575, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_bpz00_14002;
BgL_bpz00_14002 = 
VECTOR_REF(
((obj_t)BgL_sz00_11577),((long)0)); 
return 
VECTOR_REF(
((obj_t)BgL_gz00_11576),((long)2));} } } 

}



/* &<@anonymous:2881> */
obj_t BGl_z62zc3z04anonymousza32881ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11578, obj_t BgL_sz00_11581)
{
{ /* Eval/evaluate_comp.scm 353 */
{ /* Eval/evaluate_comp.scm 353 */
BgL_ev_globalz00_bglt BgL_i1093z00_11579;obj_t BgL_slotz00_11580;
BgL_i1093z00_11579 = 
((BgL_ev_globalz00_bglt)
PROCEDURE_REF(BgL_envz00_11578, 
(int)(((long)0)))); 
BgL_slotz00_11580 = 
PROCEDURE_REF(BgL_envz00_11578, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 353 */
obj_t BgL_bpz00_14003;
BgL_bpz00_14003 = 
VECTOR_REF(
((obj_t)BgL_sz00_11581),((long)0)); 
if(
CBOOL(
CELL_REF(BgL_slotz00_11580)))
{ /* Eval/evaluate_comp.scm 354 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 354 */
{ /* Eval/evaluate_comp.scm 355 */
obj_t BgL_auxz00_14004;
BgL_auxz00_14004 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_namez00)); 
CELL_SET(BgL_slotz00_11580, BgL_auxz00_14004); } 
if(
CBOOL(
CELL_REF(BgL_slotz00_11580)))
{ /* Eval/evaluate_comp.scm 356 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 357 */
obj_t BgL_idz00_14005;
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 358 */
obj_t BgL_arg2887z00_14006;
{ /* Eval/evaluate_comp.scm 358 */
obj_t BgL_arg2888z00_14007;obj_t BgL_arg2889z00_14008;
BgL_arg2888z00_14007 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_namez00); 
BgL_arg2889z00_14008 = 
MAKE_YOUNG_PAIR(
BGl_evmodulezd2namezd2zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_modz00)), BNIL); 
BgL_arg2887z00_14006 = 
MAKE_YOUNG_PAIR(BgL_arg2888z00_14007, BgL_arg2889z00_14008); } 
BgL_idz00_14005 = 
MAKE_YOUNG_PAIR(BGl_symbol4385z00zz__evaluate_compz00, BgL_arg2887z00_14006); }  else 
{ /* Eval/evaluate_comp.scm 357 */
BgL_idz00_14005 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_namez00); } 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4384z00zz__evaluate_compz00, BgL_idz00_14005); } } 
{ /* Eval/evaluate_comp.scm 361 */
obj_t BgL_vz00_14009;
{ /* Eval/evaluate_comp.scm 361 */
obj_t BgL_evalzd2globalzd2_14010;
BgL_evalzd2globalzd2_14010 = 
CELL_REF(BgL_slotz00_11580); 
BgL_vz00_14009 = 
VECTOR_REF(BgL_evalzd2globalzd2_14010,((long)2)); } 
if(
(BgL_vz00_14009==BUNSPEC))
{ /* Eval/evaluate_comp.scm 363 */
int BgL_tz00_14011;
{ /* Eval/evaluate_comp.scm 363 */
int BgL_res4127z00_14012;
{ /* Eval/evaluate_comp.scm 363 */
obj_t BgL_evalzd2globalzd2_14013;
BgL_evalzd2globalzd2_14013 = 
CELL_REF(BgL_slotz00_11580); 
BgL_res4127z00_14012 = 
CINT(
VECTOR_REF(BgL_evalzd2globalzd2_14013,((long)0))); } 
BgL_tz00_14011 = BgL_res4127z00_14012; } 
{ /* Eval/evaluate_comp.scm 364 */
bool_t BgL_test5060z00_28472;
if(
(
(long)(BgL_tz00_14011)==((long)3)))
{ /* Eval/evaluate_comp.scm 364 */
BgL_test5060z00_28472 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 364 */
BgL_test5060z00_28472 = 
(
(long)(BgL_tz00_14011)==((long)4))
; } 
if(BgL_test5060z00_28472)
{ /* Eval/evaluate_comp.scm 365 */
obj_t BgL_idz00_14014;
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 366 */
obj_t BgL_arg2899z00_14015;
{ /* Eval/evaluate_comp.scm 366 */
obj_t BgL_arg2900z00_14016;obj_t BgL_arg2901z00_14017;
BgL_arg2900z00_14016 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_namez00); 
BgL_arg2901z00_14017 = 
MAKE_YOUNG_PAIR(
BGl_evmodulezd2namezd2zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_modz00)), BNIL); 
BgL_arg2899z00_14015 = 
MAKE_YOUNG_PAIR(BgL_arg2900z00_14016, BgL_arg2901z00_14017); } 
BgL_idz00_14014 = 
MAKE_YOUNG_PAIR(BGl_symbol4385z00zz__evaluate_compz00, BgL_arg2899z00_14015); }  else 
{ /* Eval/evaluate_comp.scm 365 */
BgL_idz00_14014 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_namez00); } 
return 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1093z00_11579))->BgL_locz00), BGl_string4260z00zz__evaluate_compz00, BGl_string4387z00zz__evaluate_compz00, BgL_idz00_14014);}  else 
{ /* Eval/evaluate_comp.scm 364 */
return BgL_vz00_14009;} } }  else 
{ /* Eval/evaluate_comp.scm 362 */
return BgL_vz00_14009;} } } } } 

}



/* &comp-ev_setlocal1393 */
obj_t BGl_z62compzd2ev_setlocal1393zb0zz__evaluate_compz00(obj_t BgL_envz00_11583, obj_t BgL_ez00_11584, obj_t BgL_stkz00_11585)
{
{ /* Eval/evaluate_comp.scm 321 */
{ /* Eval/evaluate_comp.scm 323 */
obj_t BgL_iz00_14019;obj_t BgL_ez00_14020;
{ /* Eval/evaluate_comp.scm 323 */
BgL_ev_varz00_bglt BgL_arg2864z00_14021;
BgL_arg2864z00_14021 = 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_11584)))->BgL_vz00); 
BgL_iz00_14019 = 
BGl__indexz00zz__evaluate_compz00(
((obj_t)BgL_arg2864z00_14021), BgL_stkz00_11585); } 
{ /* Eval/evaluate_comp.scm 323 */
BgL_ev_exprz00_bglt BgL_arg2865z00_14022;
BgL_arg2865z00_14022 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_ez00_11584))))->BgL_ez00); 
BgL_ez00_14020 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2865z00_14022, BgL_stkz00_11585); } 
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_11584)))->BgL_vz00)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_zc3z04anonymousza32857ze3z87_14023;
BgL_zc3z04anonymousza32857ze3z87_14023 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32857ze3z87_14023, 
(int)(((long)0)), BgL_iz00_14019); 
PROCEDURE_SET(BgL_zc3z04anonymousza32857ze3z87_14023, 
(int)(((long)1)), BgL_ez00_14020); 
return BgL_zc3z04anonymousza32857ze3z87_14023;}  else 
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_zc3z04anonymousza32861ze3z87_14024;
BgL_zc3z04anonymousza32861ze3z87_14024 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32861ze3z87_14024, 
(int)(((long)0)), BgL_iz00_14019); 
PROCEDURE_SET(BgL_zc3z04anonymousza32861ze3z87_14024, 
(int)(((long)1)), BgL_ez00_14020); 
return BgL_zc3z04anonymousza32861ze3z87_14024;} } } 

}



/* &<@anonymous:2857> */
obj_t BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11586, obj_t BgL_sz00_11589)
{
{ /* Eval/evaluate_comp.scm 326 */
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_iz00_11587;obj_t BgL_ez00_11588;
BgL_iz00_11587 = 
PROCEDURE_REF(BgL_envz00_11586, 
(int)(((long)0))); 
BgL_ez00_11588 = 
PROCEDURE_REF(BgL_envz00_11586, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_bpz00_14025;
BgL_bpz00_14025 = 
VECTOR_REF(
((obj_t)BgL_sz00_11589),((long)0)); 
{ /* Eval/evaluate_comp.scm 327 */
obj_t BgL_arg2858z00_14026;obj_t BgL_arg2859z00_14027;
{ /* Eval/evaluate_comp.scm 327 */
long BgL_arg2860z00_14028;
BgL_arg2860z00_14028 = 
(
(long)CINT(BgL_bpz00_14025)+
(long)CINT(BgL_iz00_11587)); 
BgL_arg2858z00_14026 = 
VECTOR_REF(
((obj_t)BgL_sz00_11589),BgL_arg2860z00_14028); } 
BgL_arg2859z00_14027 = 
PROCEDURE_ENTRY(BgL_ez00_11588)(BgL_ez00_11588, BgL_sz00_11589, BEOA); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_xz00_14029;
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_28534;obj_t BgL_tmpz00_28532;
BgL_auxz00_28534 = 
(int)(((long)0)); 
BgL_tmpz00_28532 = 
((obj_t)BgL_arg2858z00_14026); 
BgL_xz00_14029 = 
STRUCT_SET(BgL_tmpz00_28532, BgL_auxz00_28534, BgL_arg2859z00_14027); } 
return BUNSPEC;} } } } } 

}



/* &<@anonymous:2861> */
obj_t BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11590, obj_t BgL_sz00_11593)
{
{ /* Eval/evaluate_comp.scm 328 */
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_iz00_11591;obj_t BgL_ez00_11592;
BgL_iz00_11591 = 
PROCEDURE_REF(BgL_envz00_11590, 
(int)(((long)0))); 
BgL_ez00_11592 = 
PROCEDURE_REF(BgL_envz00_11590, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_bpz00_14030;
BgL_bpz00_14030 = 
VECTOR_REF(
((obj_t)BgL_sz00_11593),((long)0)); 
{ /* Eval/evaluate_comp.scm 329 */
long BgL_arg2862z00_14031;obj_t BgL_arg2863z00_14032;
BgL_arg2862z00_14031 = 
(
(long)CINT(BgL_bpz00_14030)+
(long)CINT(BgL_iz00_11591)); 
BgL_arg2863z00_14032 = 
PROCEDURE_ENTRY(BgL_ez00_11592)(BgL_ez00_11592, BgL_sz00_11593, BEOA); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_11593),BgL_arg2862z00_14031,BgL_arg2863z00_14032);} } } } 

}



/* &comp-ev_var1391 */
obj_t BGl_z62compzd2ev_var1391zb0zz__evaluate_compz00(obj_t BgL_envz00_11594, obj_t BgL_varz00_11595, obj_t BgL_stkz00_11596)
{
{ /* Eval/evaluate_comp.scm 316 */
{ /* Eval/evaluate_comp.scm 317 */
obj_t BgL_iz00_14034;
BgL_iz00_14034 = 
BGl__indexz00zz__evaluate_compz00(
((obj_t)
((BgL_ev_varz00_bglt)BgL_varz00_11595)), BgL_stkz00_11596); 
{ 

if(
INTEGERP(BgL_iz00_14034))
{ /* Eval/evaluate_comp.scm 319 */
switch( 
(long)CINT(BgL_iz00_14034)) { case ((long)0) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_11595)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc4388z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc4389z00zz__evaluate_compz00;} break;case ((long)1) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_11595)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc4390z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc4391z00zz__evaluate_compz00;} break;case ((long)2) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_11595)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc4392z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc4393z00zz__evaluate_compz00;} break;case ((long)3) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_11595)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc4394z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc4395z00zz__evaluate_compz00;} break;
default: 
BgL_case_else1088z00_14035:
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_11595)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_zc3z04anonymousza32851ze3z87_14036;
BgL_zc3z04anonymousza32851ze3z87_14036 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32851ze3z87_14036, 
(int)(((long)0)), BgL_iz00_14034); 
return BgL_zc3z04anonymousza32851ze3z87_14036;}  else 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_zc3z04anonymousza32854ze3z87_14037;
BgL_zc3z04anonymousza32854ze3z87_14037 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32854ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32854ze3z87_14037, 
(int)(((long)0)), BgL_iz00_14034); 
return BgL_zc3z04anonymousza32854ze3z87_14037;} } }  else 
{ /* Eval/evaluate_comp.scm 319 */
goto BgL_case_else1088z00_14035;} } } } 

}



/* &<@anonymous:2845> */
obj_t BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11597, obj_t BgL_sz00_11598)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14038;
BgL_bpz00_14038 = 
VECTOR_REF(
((obj_t)BgL_sz00_11598),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2846z00_14039;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2847z00_14040;
BgL_arg2847z00_14040 = 
(
(long)CINT(BgL_bpz00_14038)+((long)3)); 
BgL_arg2846z00_14039 = 
VECTOR_REF(
((obj_t)BgL_sz00_11598),BgL_arg2847z00_14040); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2846z00_14039), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2848> */
obj_t BGl_z62zc3z04anonymousza32848ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11599, obj_t BgL_sz00_11600)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14041;
BgL_bpz00_14041 = 
VECTOR_REF(
((obj_t)BgL_sz00_11600),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2849z00_14042;
BgL_arg2849z00_14042 = 
(
(long)CINT(BgL_bpz00_14041)+((long)3)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_11600),BgL_arg2849z00_14042);} } } 

}



/* &<@anonymous:2839> */
obj_t BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11601, obj_t BgL_sz00_11602)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14043;
BgL_bpz00_14043 = 
VECTOR_REF(
((obj_t)BgL_sz00_11602),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2840z00_14044;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2841z00_14045;
BgL_arg2841z00_14045 = 
(
(long)CINT(BgL_bpz00_14043)+((long)2)); 
BgL_arg2840z00_14044 = 
VECTOR_REF(
((obj_t)BgL_sz00_11602),BgL_arg2841z00_14045); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2840z00_14044), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2842> */
obj_t BGl_z62zc3z04anonymousza32842ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11603, obj_t BgL_sz00_11604)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14046;
BgL_bpz00_14046 = 
VECTOR_REF(
((obj_t)BgL_sz00_11604),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2843z00_14047;
BgL_arg2843z00_14047 = 
(
(long)CINT(BgL_bpz00_14046)+((long)2)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_11604),BgL_arg2843z00_14047);} } } 

}



/* &<@anonymous:2833> */
obj_t BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11605, obj_t BgL_sz00_11606)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14048;
BgL_bpz00_14048 = 
VECTOR_REF(
((obj_t)BgL_sz00_11606),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2834z00_14049;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2835z00_14050;
BgL_arg2835z00_14050 = 
(
(long)CINT(BgL_bpz00_14048)+((long)1)); 
BgL_arg2834z00_14049 = 
VECTOR_REF(
((obj_t)BgL_sz00_11606),BgL_arg2835z00_14050); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2834z00_14049), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2836> */
obj_t BGl_z62zc3z04anonymousza32836ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11607, obj_t BgL_sz00_11608)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14051;
BgL_bpz00_14051 = 
VECTOR_REF(
((obj_t)BgL_sz00_11608),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2837z00_14052;
BgL_arg2837z00_14052 = 
(
(long)CINT(BgL_bpz00_14051)+((long)1)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_11608),BgL_arg2837z00_14052);} } } 

}



/* &<@anonymous:2827> */
obj_t BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11609, obj_t BgL_sz00_11610)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14053;
BgL_bpz00_14053 = 
VECTOR_REF(
((obj_t)BgL_sz00_11610),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2828z00_14054;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2829z00_14055;
BgL_arg2829z00_14055 = 
(
(long)CINT(BgL_bpz00_14053)+((long)0)); 
BgL_arg2828z00_14054 = 
VECTOR_REF(
((obj_t)BgL_sz00_11610),BgL_arg2829z00_14055); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2828z00_14054), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2830> */
obj_t BGl_z62zc3z04anonymousza32830ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11611, obj_t BgL_sz00_11612)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14056;
BgL_bpz00_14056 = 
VECTOR_REF(
((obj_t)BgL_sz00_11612),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2831z00_14057;
BgL_arg2831z00_14057 = 
(
(long)CINT(BgL_bpz00_14056)+((long)0)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_11612),BgL_arg2831z00_14057);} } } 

}



/* &<@anonymous:2851> */
obj_t BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11613, obj_t BgL_sz00_11615)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_iz00_11614;
BgL_iz00_11614 = 
PROCEDURE_REF(BgL_envz00_11613, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14058;
BgL_bpz00_14058 = 
VECTOR_REF(
((obj_t)BgL_sz00_11615),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2852z00_14059;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2853z00_14060;
BgL_arg2853z00_14060 = 
(
(long)CINT(BgL_bpz00_14058)+
(long)CINT(BgL_iz00_11614)); 
BgL_arg2852z00_14059 = 
VECTOR_REF(
((obj_t)BgL_sz00_11615),BgL_arg2853z00_14060); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2852z00_14059), 
(int)(((long)0)));} } } } 

}



/* &<@anonymous:2854> */
obj_t BGl_z62zc3z04anonymousza32854ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11616, obj_t BgL_sz00_11618)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_iz00_11617;
BgL_iz00_11617 = 
PROCEDURE_REF(BgL_envz00_11616, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_14061;
BgL_bpz00_14061 = 
VECTOR_REF(
((obj_t)BgL_sz00_11618),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2855z00_14062;
BgL_arg2855z00_14062 = 
(
(long)CINT(BgL_bpz00_14061)+
(long)CINT(BgL_iz00_11617)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_11618),BgL_arg2855z00_14062);} } } } 

}



/* &comp-ev_trap1389 */
obj_t BGl_z62compzd2ev_trap1389zb0zz__evaluate_compz00(obj_t BgL_envz00_11619, obj_t BgL_ez00_11620, obj_t BgL_stkz00_11621)
{
{ /* Eval/evaluate_comp.scm 289 */
{ /* Eval/evaluate_comp.scm 291 */
obj_t BgL_ez00_14064;
{ /* Eval/evaluate_comp.scm 291 */
BgL_ev_exprz00_bglt BgL_arg2824z00_14065;
BgL_arg2824z00_14065 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_ez00_11620))))->BgL_ez00); 
BgL_ez00_14064 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2824z00_14065, BgL_stkz00_11621); } 
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_zc3z04anonymousza32818ze3z87_14066;
BgL_zc3z04anonymousza32818ze3z87_14066 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32818ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32818ze3z87_14066, 
(int)(((long)0)), BgL_ez00_14064); 
return BgL_zc3z04anonymousza32818ze3z87_14066;} } } 

}



/* &<@anonymous:2818> */
obj_t BGl_z62zc3z04anonymousza32818ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11622, obj_t BgL_sz00_11624)
{
{ /* Eval/evaluate_comp.scm 292 */
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_ez00_11623;
BgL_ez00_11623 = 
PROCEDURE_REF(BgL_envz00_11622, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_bpz00_14067;
BgL_bpz00_14067 = 
VECTOR_REF(
((obj_t)BgL_sz00_11624),((long)0)); 
{ /* Eval/evaluate_comp.scm 293 */
obj_t BgL_cmdz00_14068;
BgL_cmdz00_14068 = 
PROCEDURE_ENTRY(BgL_ez00_11623)(BgL_ez00_11623, BgL_sz00_11624, BEOA); 
if(
(BgL_cmdz00_14068==BGl_symbol4396z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return BgL_bpz00_14067;}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_14068==BGl_symbol4398z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_reset_profilez00zz__evaluate_compz00();}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_14068==BGl_symbol4400z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_get_profilez00zz__evaluate_compz00();}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_14068==BGl_symbol4402z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 302 */
obj_t BgL_arg2823z00_14069;
BgL_arg2823z00_14069 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
return 
VECTOR_SET(
((obj_t)BgL_arg2823z00_14069),((long)0),
BINT(((long)2)));}  else 
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_errorz00zz__errorz00(BGl_string4260z00zz__evaluate_compz00, BGl_string4404z00zz__evaluate_compz00, BgL_cmdz00_14068);} } } } } } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046086), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)483454155), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)70989603), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135276775), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218210), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267792), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519932), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)368666432), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936801), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439353001), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)479579181), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967693), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__srfi4z00(((long)467924964), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68574988), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)169532048), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057797), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155843), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198620800), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309430), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519430), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460262918), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-44273703), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614678), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927882), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151370), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)190905450), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540577), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988580), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)233942021), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)220648206), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__prognz00(((long)177147622), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__expandz00(((long)414007149), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evenvz00(((long)528345299), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evcompilez00(((long)492754569), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__everrorz00(((long)375872221), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evmodulez00(((long)505897955), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long)0), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long)193509656), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00)); 
return 
BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)20669940), 
BSTRING_TO_STRING(BGl_string4405z00zz__evaluate_compz00));} 

}

#ifdef __cplusplus
}
#endif
