/*===========================================================================*/
/*   (Eval/evaluate_types.scm)                                               */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_types.scm -o objs/obj_p/Eval/evaluate_types.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1684z62zz__evaluate_typesz00(obj_t);
static BgL_ev_appz00_bglt BGl_z62lambda1927z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1766z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1767z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_labelsz00_bglt BGl_z62lambda1848z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_appz00_bglt BGl_z62lambda1929z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2480z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2563z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2484z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31870ze3ze5zz__evaluate_typesz00(obj_t);
static BgL_ev_labelsz00_bglt BGl_z62lambda1850z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1771z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1935z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1693z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_defglobalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1694z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1856z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1857z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_binderz00_bglt BGl_z62lambda1778z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1698z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2570z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2491z00zz__evaluate_typesz00 = BUNSPEC;
extern obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_symbol2576z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2495z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2499z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31782ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1940z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1941z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_binderz00_bglt BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1862z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1863z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1945z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1787z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1868z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1869z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2582z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2587z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31961ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1950z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1951z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1791z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1792z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1875z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1876z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_absz00_bglt BGl_z62lambda1957z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1796z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1797z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_absz00_bglt BGl_z62lambda1959z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32021ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2593z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2597z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1881z62zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letrecz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1882z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1965z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1966z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1887z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1888z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32014ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62lambda1970z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1971z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31688ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1975z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_gotoz00_bglt BGl_z62lambda1895z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1976z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_gotoz00_bglt BGl_z62lambda1897z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32007ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1980z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1981z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1985z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62lambda1986z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_prog2z00zz__evaluate_typesz00 = BUNSPEC;
extern obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62lambda1991z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1992z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1998z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31877ze3ze5zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 = BUNSPEC;
extern obj_t bstring_to_symbol(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letza2za2zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_labelsz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31993ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_methodzd2initzd2zz__evaluate_typesz00();
BGL_EXPORTED_DEF obj_t BGl_ev_absz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_trapz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31889ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31600ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31504ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_setglobalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31899ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_ifz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31424ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2005z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2006z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_hookz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31530ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2012z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2013z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2019z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2020z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31435ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_gotoz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31711ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
BGL_EXPORTED_DEF obj_t BGl_ev_globalz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_binderz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_listz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31462ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31616ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_littz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_orz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_varz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1420z62zz__evaluate_typesz00(obj_t);
static BgL_ev_ifz00_bglt BGl_z62lambda1502z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31641ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1422z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31447ze3ze5zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1508z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1509z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_symbol2307z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2309z00zz__evaluate_typesz00 = BUNSPEC;
extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
static BgL_ev_varz00_bglt BGl_z62lambda1430z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31731ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00();
static BgL_ev_varz00_bglt BGl_z62lambda1432z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1513z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1514z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31626ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1518z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1519z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1439z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2313z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2315z00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_andz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1440z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1605z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1606z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1445z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_listz00_bglt BGl_z62lambda1526z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1446z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_listz00_bglt BGl_z62lambda1528z62zz__evaluate_typesz00(obj_t);
extern obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_symbol2320z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2322z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2404z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2326z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_trapz00_bglt BGl_z62lambda1612z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1451z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1452z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_trapz00_bglt BGl_z62lambda1614z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1536z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1537z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_globalz00_bglt BGl_z62lambda1458z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol2411z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2331z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2416z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2335z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_globalz00_bglt BGl_z62lambda1460z62zz__evaluate_typesz00(obj_t);
static BgL_ev_setlocalz00_bglt BGl_z62lambda1622z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31815ze3ze5zz__evaluate_typesz00(obj_t);
static BgL_ev_setlocalz00_bglt BGl_z62lambda1624z62zz__evaluate_typesz00(obj_t);
static BgL_ev_orz00_bglt BGl_z62lambda1545z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1707z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1466z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_orz00_bglt BGl_z62lambda1547z62zz__evaluate_typesz00(obj_t);
static BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1709z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1467z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_exprz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_appz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2420z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2341z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2506z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2425z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2346z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_varz00_bglt BGl_z62lambda1630z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31832ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1631z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1471z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31565ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31808ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1472z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1715z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31549ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1716z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_setglobalz00_bglt BGl_z62lambda1637z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1476z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1477z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_setglobalz00_bglt BGl_z62lambda1639z62zz__evaluate_typesz00(obj_t);
static BgL_ev_andz00_bglt BGl_z62lambda1559z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2511z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2350z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2516z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2436z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2355z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2359z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1720z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1721z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31825ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_letz00_bglt BGl_z62lambda1804z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_andz00_bglt BGl_z62lambda1563z62zz__evaluate_typesz00(obj_t);
static BgL_ev_letz00_bglt BGl_z62lambda1806z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_littz00_bglt BGl_z62lambda1483z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1645z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1646z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1727z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_profzd2initzd2zz__evaluate_typesz00();
static BgL_ev_littz00_bglt BGl_z62lambda1486z62zz__evaluate_typesz00(obj_t);
static BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1729z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2441z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2524z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2606z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2363z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2445z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2608z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2529z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2367z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2449z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31931ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31842ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1650z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31672ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1651z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1813z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1814z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_prog2z00_bglt BGl_z62lambda1573z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1735z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1493z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1736z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_prog2z00_bglt BGl_z62lambda1575z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1656z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1657z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_ifz00_bglt BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol2613z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2372z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2454z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2618z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2538z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2376z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1740z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_letza2za2_bglt BGl_z62lambda1821z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1741z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_letza2za2_bglt BGl_z62lambda1823z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1905z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1582z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1583z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1748z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1587z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_defglobalz00_bglt BGl_z62lambda1668z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1588z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2623z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2543z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2381z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2463z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2467z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2386z00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_setlocalz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_varz00_bglt BGl_z62lambda1910z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31852ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1911z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1831z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_defglobalz00_bglt BGl_z62lambda1670z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31577ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_labelsz00_bglt BGl_z62lambda1915z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31488ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1916z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1756z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1757z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_letrecz00_bglt BGl_z62lambda1838z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_hookz00_bglt BGl_z62lambda1596z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_hookz00_bglt BGl_z62lambda1598z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2631z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2633z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2553z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2391z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2474z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2395z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2559z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2399z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1920z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_letrecz00_bglt BGl_z62lambda1840z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1921z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1761z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1762z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1682z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t *__cnst;


DEFINE_STRING( BGl_string2308z00zz__evaluate_typesz00, BgL_bgl_string2308za700za7za7_2635za7, "ev_expr", 7 );
DEFINE_STRING( BGl_string2310z00zz__evaluate_typesz00, BgL_bgl_string2310za700za7za7_2636za7, "__evaluate_types", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2304z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2637za7, BGl_z62zc3z04anonymousza31424ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2305z00zz__evaluate_typesz00, BgL_bgl_za762lambda1422za7622638z00, BGl_z62lambda1422z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2306z00zz__evaluate_typesz00, BgL_bgl_za762lambda1420za7622639z00, BGl_z62lambda1420z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2314z00zz__evaluate_typesz00, BgL_bgl_string2314za700za7za7_2640za7, "name", 4 );
DEFINE_STRING( BGl_string2316z00zz__evaluate_typesz00, BgL_bgl_string2316za700za7za7_2641za7, "symbol", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2311z00zz__evaluate_typesz00, BgL_bgl_za762lambda1440za7622642z00, BGl_z62lambda1440z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2312z00zz__evaluate_typesz00, BgL_bgl_za762lambda1439za7622643z00, BGl_z62lambda1439z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2400z00zz__evaluate_typesz00, BgL_bgl_string2400za700za7za7_2644za7, "e2", 2 );
DEFINE_STRING( BGl_string2321z00zz__evaluate_typesz00, BgL_bgl_string2321za700za7za7_2645za7, "eff", 3 );
DEFINE_STRING( BGl_string2323z00zz__evaluate_typesz00, BgL_bgl_string2323za700za7za7_2646za7, "obj", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2317z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2647za7, BGl_z62zc3z04anonymousza31447ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2405z00zz__evaluate_typesz00, BgL_bgl_string2405za700za7za7_2648za7, "ev_prog2", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2318z00zz__evaluate_typesz00, BgL_bgl_za762lambda1446za7622649z00, BGl_z62lambda1446z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2319z00zz__evaluate_typesz00, BgL_bgl_za762lambda1445za7622650z00, BGl_z62lambda1445z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2327z00zz__evaluate_typesz00, BgL_bgl_string2327za700za7za7_2651za7, "type", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2401z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2652za7, BGl_z62zc3z04anonymousza31577ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2402z00zz__evaluate_typesz00, BgL_bgl_za762lambda1575za7622653z00, BGl_z62lambda1575z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2403z00zz__evaluate_typesz00, BgL_bgl_za762lambda1573za7622654z00, BGl_z62lambda1573z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2324z00zz__evaluate_typesz00, BgL_bgl_za762lambda1452za7622655z00, BGl_z62lambda1452z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2412z00zz__evaluate_typesz00, BgL_bgl_string2412za700za7za7_2656za7, "ev_hook", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2406z00zz__evaluate_typesz00, BgL_bgl_za762lambda1606za7622657z00, BGl_z62lambda1606z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2325z00zz__evaluate_typesz00, BgL_bgl_za762lambda1451za7622658z00, BGl_z62lambda1451z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2407z00zz__evaluate_typesz00, BgL_bgl_za762lambda1605za7622659z00, BGl_z62lambda1605z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2332z00zz__evaluate_typesz00, BgL_bgl_string2332za700za7za7_2660za7, "ev_var", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2408z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2661za7, BGl_z62zc3z04anonymousza31600ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2409z00zz__evaluate_typesz00, BgL_bgl_za762lambda1598za7622662z00, BGl_z62lambda1598z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2328z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2663za7, BGl_z62zc3z04anonymousza31435ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2329z00zz__evaluate_typesz00, BgL_bgl_za762lambda1432za7622664z00, BGl_z62lambda1432z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2417z00zz__evaluate_typesz00, BgL_bgl_string2417za700za7za7_2665za7, "ev_trap", 7 );
DEFINE_STRING( BGl_string2336z00zz__evaluate_typesz00, BgL_bgl_string2336za700za7za7_2666za7, "loc", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2410z00zz__evaluate_typesz00, BgL_bgl_za762lambda1596za7622667z00, BGl_z62lambda1596z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2330z00zz__evaluate_typesz00, BgL_bgl_za762lambda1430za7622668z00, BGl_z62lambda1430z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2500z00zz__evaluate_typesz00, BgL_bgl_string2500za700za7za7_2669za7, "vals", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2413z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2670za7, BGl_z62zc3z04anonymousza31616ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2414z00zz__evaluate_typesz00, BgL_bgl_za762lambda1614za7622671z00, BGl_z62lambda1614z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2333z00zz__evaluate_typesz00, BgL_bgl_za762lambda1467za7622672z00, BGl_z62lambda1467z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2421z00zz__evaluate_typesz00, BgL_bgl_string2421za700za7za7_2673za7, "v", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2415z00zz__evaluate_typesz00, BgL_bgl_za762lambda1612za7622674z00, BGl_z62lambda1612z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2334z00zz__evaluate_typesz00, BgL_bgl_za762lambda1466za7622675z00, BGl_z62lambda1466z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2342z00zz__evaluate_typesz00, BgL_bgl_string2342za700za7za7_2676za7, "mod", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2418z00zz__evaluate_typesz00, BgL_bgl_za762lambda1631za7622677z00, BGl_z62lambda1631z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2337z00zz__evaluate_typesz00, BgL_bgl_za762lambda1472za7622678z00, BGl_z62lambda1472z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2419z00zz__evaluate_typesz00, BgL_bgl_za762lambda1630za7622679z00, BGl_z62lambda1630z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2338z00zz__evaluate_typesz00, BgL_bgl_za762lambda1471za7622680z00, BGl_z62lambda1471z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2507z00zz__evaluate_typesz00, BgL_bgl_string2507za700za7za7_2681za7, "ev_binder", 9 );
DEFINE_STRING( BGl_string2426z00zz__evaluate_typesz00, BgL_bgl_string2426za700za7za7_2682za7, "ev_setlocal", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2339z00zz__evaluate_typesz00, BgL_bgl_za762lambda1477za7622683z00, BGl_z62lambda1477z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2347z00zz__evaluate_typesz00, BgL_bgl_string2347za700za7za7_2684za7, "ev_global", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2501z00zz__evaluate_typesz00, BgL_bgl_za762lambda1797za7622685z00, BGl_z62lambda1797z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2502z00zz__evaluate_typesz00, BgL_bgl_za762lambda1796za7622686z00, BGl_z62lambda1796z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2340z00zz__evaluate_typesz00, BgL_bgl_za762lambda1476za7622687z00, BGl_z62lambda1476z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2503z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2688za7, BGl_z62zc3z04anonymousza31782ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2422z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2689za7, BGl_z62zc3z04anonymousza31626ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2504z00zz__evaluate_typesz00, BgL_bgl_za762lambda1780za7622690z00, BGl_z62lambda1780z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2423z00zz__evaluate_typesz00, BgL_bgl_za762lambda1624za7622691z00, BGl_z62lambda1624z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2505z00zz__evaluate_typesz00, BgL_bgl_za762lambda1778za7622692z00, BGl_z62lambda1778z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2424z00zz__evaluate_typesz00, BgL_bgl_za762lambda1622za7622693z00, BGl_z62lambda1622z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2343z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2694za7, BGl_z62zc3z04anonymousza31462ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2512z00zz__evaluate_typesz00, BgL_bgl_string2512za700za7za7_2695za7, "boxes", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2344z00zz__evaluate_typesz00, BgL_bgl_za762lambda1460za7622696z00, BGl_z62lambda1460z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2351z00zz__evaluate_typesz00, BgL_bgl_string2351za700za7za7_2697za7, "value", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2345z00zz__evaluate_typesz00, BgL_bgl_za762lambda1458za7622698z00, BGl_z62lambda1458z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2508z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2699za7, BGl_z62zc3z04anonymousza31815ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2427z00zz__evaluate_typesz00, BgL_bgl_za762lambda1646za7622700z00, BGl_z62lambda1646z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2509z00zz__evaluate_typesz00, BgL_bgl_za762lambda1814za7622701z00, BGl_z62lambda1814z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2428z00zz__evaluate_typesz00, BgL_bgl_za762lambda1645za7622702z00, BGl_z62lambda1645z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2429z00zz__evaluate_typesz00, BgL_bgl_za762lambda1651za7622703z00, BGl_z62lambda1651z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2348z00zz__evaluate_typesz00, BgL_bgl_za762lambda1493za7622704z00, BGl_z62lambda1493z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2517z00zz__evaluate_typesz00, BgL_bgl_string2517za700za7za7_2705za7, "ev_let", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2349z00zz__evaluate_typesz00, BgL_bgl_za762lambda1492za7622706z00, BGl_z62lambda1492z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2437z00zz__evaluate_typesz00, BgL_bgl_string2437za700za7za7_2707za7, "ev_setglobal", 12 );
DEFINE_STRING( BGl_string2356z00zz__evaluate_typesz00, BgL_bgl_string2356za700za7za7_2708za7, "ev_litt", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2510z00zz__evaluate_typesz00, BgL_bgl_za762lambda1813za7622709z00, BGl_z62lambda1813z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2430z00zz__evaluate_typesz00, BgL_bgl_za762lambda1650za7622710z00, BGl_z62lambda1650z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2431z00zz__evaluate_typesz00, BgL_bgl_za762lambda1657za7622711z00, BGl_z62lambda1657z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2513z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2712za7, BGl_z62zc3z04anonymousza31808ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2432z00zz__evaluate_typesz00, BgL_bgl_za762lambda1656za7622713z00, BGl_z62lambda1656z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2514z00zz__evaluate_typesz00, BgL_bgl_za762lambda1806za7622714z00, BGl_z62lambda1806z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2433z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2715za7, BGl_z62zc3z04anonymousza31641ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2352z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2716za7, BGl_z62zc3z04anonymousza31488ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2515z00zz__evaluate_typesz00, BgL_bgl_za762lambda1804za7622717z00, BGl_z62lambda1804z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2434z00zz__evaluate_typesz00, BgL_bgl_za762lambda1639za7622718z00, BGl_z62lambda1639z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2353z00zz__evaluate_typesz00, BgL_bgl_za762lambda1486za7622719z00, BGl_z62lambda1486z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2435z00zz__evaluate_typesz00, BgL_bgl_za762lambda1637za7622720z00, BGl_z62lambda1637z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2360z00zz__evaluate_typesz00, BgL_bgl_string2360za700za7za7_2721za7, "p", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2354z00zz__evaluate_typesz00, BgL_bgl_za762lambda1483za7622722z00, BGl_z62lambda1483z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2442z00zz__evaluate_typesz00, BgL_bgl_string2442za700za7za7_2723za7, "ev_defglobal", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2518z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2724za7, BGl_z62zc3z04anonymousza31832ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2525z00zz__evaluate_typesz00, BgL_bgl_string2525za700za7za7_2725za7, "ev_let*", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2519z00zz__evaluate_typesz00, BgL_bgl_za762lambda1831za7622726z00, BGl_z62lambda1831z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2438z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2727za7, BGl_z62zc3z04anonymousza31672ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2357z00zz__evaluate_typesz00, BgL_bgl_za762lambda1509za7622728z00, BGl_z62lambda1509z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2607z00zz__evaluate_typesz00, BgL_bgl_string2607za700za7za7_2729za7, "size", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2439z00zz__evaluate_typesz00, BgL_bgl_za762lambda1670za7622730z00, BGl_z62lambda1670z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2364z00zz__evaluate_typesz00, BgL_bgl_string2364za700za7za7_2731za7, "t", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2358z00zz__evaluate_typesz00, BgL_bgl_za762lambda1508za7622732z00, BGl_z62lambda1508z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2446z00zz__evaluate_typesz00, BgL_bgl_string2446za700za7za7_2733za7, "var", 3 );
DEFINE_STRING( BGl_string2609z00zz__evaluate_typesz00, BgL_bgl_string2609za700za7za7_2734za7, "int", 3 );
DEFINE_STRING( BGl_string2368z00zz__evaluate_typesz00, BgL_bgl_string2368za700za7za7_2735za7, "e", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2600z00zz__evaluate_typesz00, BgL_bgl_za762lambda1980za7622736z00, BGl_z62lambda1980z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2601z00zz__evaluate_typesz00, BgL_bgl_za762lambda1986za7622737z00, BGl_z62lambda1986z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2520z00zz__evaluate_typesz00, BgL_bgl_za762lambda1830za7622738z00, BGl_z62lambda1830z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2602z00zz__evaluate_typesz00, BgL_bgl_za762lambda1985za7622739z00, BGl_z62lambda1985z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2521z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2740za7, BGl_z62zc3z04anonymousza31825ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2440z00zz__evaluate_typesz00, BgL_bgl_za762lambda1668za7622741z00, BGl_z62lambda1668z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2603z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2742za7, BGl_z62zc3z04anonymousza31993ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2522z00zz__evaluate_typesz00, BgL_bgl_za762lambda1823za7622743z00, BGl_z62lambda1823z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2604z00zz__evaluate_typesz00, BgL_bgl_za762lambda1992za7622744z00, BGl_z62lambda1992z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2523z00zz__evaluate_typesz00, BgL_bgl_za762lambda1821za7622745z00, BGl_z62lambda1821z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2361z00zz__evaluate_typesz00, BgL_bgl_za762lambda1514za7622746z00, BGl_z62lambda1514z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2605z00zz__evaluate_typesz00, BgL_bgl_za762lambda1991za7622747z00, BGl_z62lambda1991z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2530z00zz__evaluate_typesz00, BgL_bgl_string2530za700za7za7_2748za7, "ev_letrec", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2443z00zz__evaluate_typesz00, BgL_bgl_za762lambda1694za7622749z00, BGl_z62lambda1694z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2362z00zz__evaluate_typesz00, BgL_bgl_za762lambda1513za7622750z00, BGl_z62lambda1513z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2450z00zz__evaluate_typesz00, BgL_bgl_string2450za700za7za7_2751za7, "body", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2444z00zz__evaluate_typesz00, BgL_bgl_za762lambda1693za7622752z00, BGl_z62lambda1693z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2526z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2753za7, BGl_z62zc3z04anonymousza31842ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2614z00zz__evaluate_typesz00, BgL_bgl_string2614za700za7za7_2754za7, "bind", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2527z00zz__evaluate_typesz00, BgL_bgl_za762lambda1840za7622755z00, BGl_z62lambda1840z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2365z00zz__evaluate_typesz00, BgL_bgl_za762lambda1519za7622756z00, BGl_z62lambda1519z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2528z00zz__evaluate_typesz00, BgL_bgl_za762lambda1838za7622757z00, BGl_z62lambda1838z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2447z00zz__evaluate_typesz00, BgL_bgl_za762lambda1699za7622758z00, BGl_z62lambda1699z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2366z00zz__evaluate_typesz00, BgL_bgl_za762lambda1518za7622759z00, BGl_z62lambda1518z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2448z00zz__evaluate_typesz00, BgL_bgl_za762lambda1698za7622760z00, BGl_z62lambda1698z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2373z00zz__evaluate_typesz00, BgL_bgl_string2373za700za7za7_2761za7, "ev_if", 5 );
DEFINE_STRING( BGl_string2455z00zz__evaluate_typesz00, BgL_bgl_string2455za700za7za7_2762za7, "ev_bind-exit", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2369z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2763za7, BGl_z62zc3z04anonymousza31504ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2619z00zz__evaluate_typesz00, BgL_bgl_string2619za700za7za7_2764za7, "free", 4 );
DEFINE_STRING( BGl_string2539z00zz__evaluate_typesz00, BgL_bgl_string2539za700za7za7_2765za7, "env", 3 );
DEFINE_STRING( BGl_string2377z00zz__evaluate_typesz00, BgL_bgl_string2377za700za7za7_2766za7, "args", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2610z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2767za7, BGl_z62zc3z04anonymousza32000ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2611z00zz__evaluate_typesz00, BgL_bgl_za762lambda1999za7622768z00, BGl_z62lambda1999z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2612z00zz__evaluate_typesz00, BgL_bgl_za762lambda1998za7622769z00, BGl_z62lambda1998z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2531z00zz__evaluate_typesz00, BgL_bgl_za762lambda1857za7622770z00, BGl_z62lambda1857z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2532z00zz__evaluate_typesz00, BgL_bgl_za762lambda1856za7622771z00, BGl_z62lambda1856z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2451z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2772za7, BGl_z62zc3z04anonymousza31688ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2370z00zz__evaluate_typesz00, BgL_bgl_za762lambda1502za7622773z00, BGl_z62lambda1502z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2533z00zz__evaluate_typesz00, BgL_bgl_za762lambda1863za7622774z00, BGl_z62lambda1863z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2452z00zz__evaluate_typesz00, BgL_bgl_za762lambda1684za7622775z00, BGl_z62lambda1684z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2371z00zz__evaluate_typesz00, BgL_bgl_za762lambda1499za7622776z00, BGl_z62lambda1499z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2615z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2777za7, BGl_z62zc3z04anonymousza32007ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2534z00zz__evaluate_typesz00, BgL_bgl_za762lambda1862za7622778z00, BGl_z62lambda1862z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2453z00zz__evaluate_typesz00, BgL_bgl_za762lambda1682za7622779z00, BGl_z62lambda1682z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2616z00zz__evaluate_typesz00, BgL_bgl_za762lambda2006za7622780z00, BGl_z62lambda2006z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2535z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2781za7, BGl_z62zc3z04anonymousza31870ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2617z00zz__evaluate_typesz00, BgL_bgl_za762lambda2005za7622782z00, BGl_z62lambda2005z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2536z00zz__evaluate_typesz00, BgL_bgl_za762lambda1869za7622783z00, BGl_z62lambda1869z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2374z00zz__evaluate_typesz00, BgL_bgl_za762lambda1537za7622784z00, BGl_z62lambda1537z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2624z00zz__evaluate_typesz00, BgL_bgl_string2624za700za7za7_2785za7, "inner", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2537z00zz__evaluate_typesz00, BgL_bgl_za762lambda1868za7622786z00, BGl_z62lambda1868z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2456z00zz__evaluate_typesz00, BgL_bgl_za762lambda1716za7622787z00, BGl_z62lambda1716z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2375z00zz__evaluate_typesz00, BgL_bgl_za762lambda1536za7622788z00, BGl_z62lambda1536z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2544z00zz__evaluate_typesz00, BgL_bgl_string2544za700za7za7_2789za7, "stk", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2457z00zz__evaluate_typesz00, BgL_bgl_za762lambda1715za7622790z00, BGl_z62lambda1715z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2382z00zz__evaluate_typesz00, BgL_bgl_string2382za700za7za7_2791za7, "ev_list", 7 );
DEFINE_STRING( BGl_string2464z00zz__evaluate_typesz00, BgL_bgl_string2464za700za7za7_2792za7, "ev_unwind-protect", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2458z00zz__evaluate_typesz00, BgL_bgl_za762lambda1721za7622793z00, BGl_z62lambda1721z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2459z00zz__evaluate_typesz00, BgL_bgl_za762lambda1720za7622794z00, BGl_z62lambda1720z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2378z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2795za7, BGl_z62zc3z04anonymousza31530ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2379z00zz__evaluate_typesz00, BgL_bgl_za762lambda1528za7622796z00, BGl_z62lambda1528z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2468z00zz__evaluate_typesz00, BgL_bgl_string2468za700za7za7_2797za7, "handler", 7 );
DEFINE_STRING( BGl_string2387z00zz__evaluate_typesz00, BgL_bgl_string2387za700za7za7_2798za7, "ev_or", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2620z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2799za7, BGl_z62zc3z04anonymousza32014ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2621z00zz__evaluate_typesz00, BgL_bgl_za762lambda2013za7622800z00, BGl_z62lambda2013z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2540z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2801za7, BGl_z62zc3z04anonymousza31877ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2622z00zz__evaluate_typesz00, BgL_bgl_za762lambda2012za7622802z00, BGl_z62lambda2012z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2541z00zz__evaluate_typesz00, BgL_bgl_za762lambda1876za7622803z00, BGl_z62lambda1876z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2460z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2804za7, BGl_z62zc3z04anonymousza31711ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2542z00zz__evaluate_typesz00, BgL_bgl_za762lambda1875za7622805z00, BGl_z62lambda1875z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2461z00zz__evaluate_typesz00, BgL_bgl_za762lambda1709za7622806z00, BGl_z62lambda1709z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2380z00zz__evaluate_typesz00, BgL_bgl_za762lambda1526za7622807z00, BGl_z62lambda1526z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2462z00zz__evaluate_typesz00, BgL_bgl_za762lambda1707za7622808z00, BGl_z62lambda1707z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2625z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2809za7, BGl_z62zc3z04anonymousza32021ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2632z00zz__evaluate_typesz00, BgL_bgl_string2632za700za7za7_2810za7, "ev_abs", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2626z00zz__evaluate_typesz00, BgL_bgl_za762lambda2020za7622811z00, BGl_z62lambda2020z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2545z00zz__evaluate_typesz00, BgL_bgl_za762lambda1882za7622812z00, BGl_z62lambda1882z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2383z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2813za7, BGl_z62zc3z04anonymousza31549ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2627z00zz__evaluate_typesz00, BgL_bgl_za762lambda2019za7622814z00, BGl_z62lambda2019z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2546z00zz__evaluate_typesz00, BgL_bgl_za762lambda1881za7622815z00, BGl_z62lambda1881z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2465z00zz__evaluate_typesz00, BgL_bgl_za762lambda1736za7622816z00, BGl_z62lambda1736z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2384z00zz__evaluate_typesz00, BgL_bgl_za762lambda1547za7622817z00, BGl_z62lambda1547z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2634z00zz__evaluate_typesz00, BgL_bgl_string2634za700za7za7_2818za7, "_", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2628z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2819za7, BGl_z62zc3z04anonymousza31961ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2547z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2820za7, BGl_z62zc3z04anonymousza31889ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2466z00zz__evaluate_typesz00, BgL_bgl_za762lambda1735za7622821z00, BGl_z62lambda1735z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2385z00zz__evaluate_typesz00, BgL_bgl_za762lambda1545za7622822z00, BGl_z62lambda1545z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2629z00zz__evaluate_typesz00, BgL_bgl_za762lambda1959za7622823z00, BGl_z62lambda1959z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2554z00zz__evaluate_typesz00, BgL_bgl_string2554za700za7za7_2824za7, "ev_labels", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2548z00zz__evaluate_typesz00, BgL_bgl_za762lambda1888za7622825z00, BGl_z62lambda1888z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2392z00zz__evaluate_typesz00, BgL_bgl_string2392za700za7za7_2826za7, "ev_and", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2549z00zz__evaluate_typesz00, BgL_bgl_za762lambda1887za7622827z00, BGl_z62lambda1887z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2475z00zz__evaluate_typesz00, BgL_bgl_string2475za700za7za7_2828za7, "ev_with-handler", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2469z00zz__evaluate_typesz00, BgL_bgl_za762lambda1741za7622829z00, BGl_z62lambda1741z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2388z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2830za7, BGl_z62zc3z04anonymousza31565ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2389z00zz__evaluate_typesz00, BgL_bgl_za762lambda1563za7622831z00, BGl_z62lambda1563z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2396z00zz__evaluate_typesz00, BgL_bgl_string2396za700za7za7_2832za7, "e1", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2630z00zz__evaluate_typesz00, BgL_bgl_za762lambda1957za7622833z00, BGl_z62lambda1957z62zz__evaluate_typesz00, 0L, BUNSPEC, 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2550z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2834za7, BGl_z62zc3z04anonymousza31852ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2551z00zz__evaluate_typesz00, BgL_bgl_za762lambda1850za7622835z00, BGl_z62lambda1850z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2470z00zz__evaluate_typesz00, BgL_bgl_za762lambda1740za7622836z00, BGl_z62lambda1740z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2552z00zz__evaluate_typesz00, BgL_bgl_za762lambda1848za7622837z00, BGl_z62lambda1848z62zz__evaluate_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2471z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2838za7, BGl_z62zc3z04anonymousza31731ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2390z00zz__evaluate_typesz00, BgL_bgl_za762lambda1559za7622839z00, BGl_z62lambda1559z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2472z00zz__evaluate_typesz00, BgL_bgl_za762lambda1729za7622840z00, BGl_z62lambda1729z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2560z00zz__evaluate_typesz00, BgL_bgl_string2560za700za7za7_2841za7, "label", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2473z00zz__evaluate_typesz00, BgL_bgl_za762lambda1727za7622842z00, BGl_z62lambda1727z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2555z00zz__evaluate_typesz00, BgL_bgl_za762lambda1906za7622843z00, BGl_z62lambda1906z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2393z00zz__evaluate_typesz00, BgL_bgl_za762lambda1583za7622844z00, BGl_z62lambda1583z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2556z00zz__evaluate_typesz00, BgL_bgl_za762lambda1905za7622845z00, BGl_z62lambda1905z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2481z00zz__evaluate_typesz00, BgL_bgl_string2481za700za7za7_2846za7, "mutex", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2394z00zz__evaluate_typesz00, BgL_bgl_za762lambda1582za7622847z00, BGl_z62lambda1582z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2557z00zz__evaluate_typesz00, BgL_bgl_za762lambda1911za7622848z00, BGl_z62lambda1911z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2476z00zz__evaluate_typesz00, BgL_bgl_za762lambda1757za7622849z00, BGl_z62lambda1757z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2564z00zz__evaluate_typesz00, BgL_bgl_string2564za700za7za7_2850za7, "labels", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2558z00zz__evaluate_typesz00, BgL_bgl_za762lambda1910za7622851z00, BGl_z62lambda1910z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2477z00zz__evaluate_typesz00, BgL_bgl_za762lambda1756za7622852z00, BGl_z62lambda1756z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2478z00zz__evaluate_typesz00, BgL_bgl_za762lambda1762za7622853z00, BGl_z62lambda1762z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2397z00zz__evaluate_typesz00, BgL_bgl_za762lambda1588za7622854z00, BGl_z62lambda1588z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2485z00zz__evaluate_typesz00, BgL_bgl_string2485za700za7za7_2855za7, "prelock", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2479z00zz__evaluate_typesz00, BgL_bgl_za762lambda1761za7622856z00, BGl_z62lambda1761z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2398z00zz__evaluate_typesz00, BgL_bgl_za762lambda1587za7622857z00, BGl_z62lambda1587z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2561z00zz__evaluate_typesz00, BgL_bgl_za762lambda1916za7622858z00, BGl_z62lambda1916z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2562z00zz__evaluate_typesz00, BgL_bgl_za762lambda1915za7622859z00, BGl_z62lambda1915z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2482z00zz__evaluate_typesz00, BgL_bgl_za762lambda1767za7622860z00, BGl_z62lambda1767z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2483z00zz__evaluate_typesz00, BgL_bgl_za762lambda1766za7622861z00, BGl_z62lambda1766z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2571z00zz__evaluate_typesz00, BgL_bgl_string2571za700za7za7_2862za7, "ev_goto", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2565z00zz__evaluate_typesz00, BgL_bgl_za762lambda1921za7622863z00, BGl_z62lambda1921z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2566z00zz__evaluate_typesz00, BgL_bgl_za762lambda1920za7622864z00, BGl_z62lambda1920z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2567z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2865za7, BGl_z62zc3z04anonymousza31899ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2492z00zz__evaluate_typesz00, BgL_bgl_string2492za700za7za7_2866za7, "ev_synchronize", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2486z00zz__evaluate_typesz00, BgL_bgl_za762lambda1772za7622867z00, BGl_z62lambda1772z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2568z00zz__evaluate_typesz00, BgL_bgl_za762lambda1897za7622868z00, BGl_z62lambda1897z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2487z00zz__evaluate_typesz00, BgL_bgl_za762lambda1771za7622869z00, BGl_z62lambda1771z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2569z00zz__evaluate_typesz00, BgL_bgl_za762lambda1895za7622870z00, BGl_z62lambda1895z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2488z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2871za7, BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2489z00zz__evaluate_typesz00, BgL_bgl_za762lambda1750za7622872z00, BGl_z62lambda1750z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2577z00zz__evaluate_typesz00, BgL_bgl_string2577za700za7za7_2873za7, "fun", 3 );
DEFINE_STRING( BGl_string2496z00zz__evaluate_typesz00, BgL_bgl_string2496za700za7za7_2874za7, "vars", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2490z00zz__evaluate_typesz00, BgL_bgl_za762lambda1748za7622875z00, BGl_z62lambda1748z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2572z00zz__evaluate_typesz00, BgL_bgl_za762lambda1936za7622876z00, BGl_z62lambda1936z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2573z00zz__evaluate_typesz00, BgL_bgl_za762lambda1935za7622877z00, BGl_z62lambda1935z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2574z00zz__evaluate_typesz00, BgL_bgl_za762lambda1941za7622878z00, BGl_z62lambda1941z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2493z00zz__evaluate_typesz00, BgL_bgl_za762lambda1787za7622879z00, BGl_z62lambda1787z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2575z00zz__evaluate_typesz00, BgL_bgl_za762lambda1940za7622880z00, BGl_z62lambda1940z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2494z00zz__evaluate_typesz00, BgL_bgl_za762lambda1786za7622881z00, BGl_z62lambda1786z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2583z00zz__evaluate_typesz00, BgL_bgl_string2583za700za7za7_2882za7, "tail?", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2578z00zz__evaluate_typesz00, BgL_bgl_za762lambda1946za7622883z00, BGl_z62lambda1946z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2497z00zz__evaluate_typesz00, BgL_bgl_za762lambda1792za7622884z00, BGl_z62lambda1792z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2579z00zz__evaluate_typesz00, BgL_bgl_za762lambda1945za7622885z00, BGl_z62lambda1945z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2498z00zz__evaluate_typesz00, BgL_bgl_za762lambda1791za7622886z00, BGl_z62lambda1791z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2588z00zz__evaluate_typesz00, BgL_bgl_string2588za700za7za7_2887za7, "ev_app", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2580z00zz__evaluate_typesz00, BgL_bgl_za762lambda1951za7622888z00, BGl_z62lambda1951z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2581z00zz__evaluate_typesz00, BgL_bgl_za762lambda1950za7622889z00, BGl_z62lambda1950z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2584z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2890za7, BGl_z62zc3z04anonymousza31931ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2585z00zz__evaluate_typesz00, BgL_bgl_za762lambda1929za7622891z00, BGl_z62lambda1929z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2586z00zz__evaluate_typesz00, BgL_bgl_za762lambda1927za7622892z00, BGl_z62lambda1927z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2594z00zz__evaluate_typesz00, BgL_bgl_string2594za700za7za7_2893za7, "where", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2589z00zz__evaluate_typesz00, BgL_bgl_za762lambda1966za7622894z00, BGl_z62lambda1966z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2598z00zz__evaluate_typesz00, BgL_bgl_string2598za700za7za7_2895za7, "arity", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2590z00zz__evaluate_typesz00, BgL_bgl_za762lambda1965za7622896z00, BGl_z62lambda1965z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2591z00zz__evaluate_typesz00, BgL_bgl_za762lambda1971za7622897z00, BGl_z62lambda1971z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2592z00zz__evaluate_typesz00, BgL_bgl_za762lambda1970za7622898z00, BGl_z62lambda1970z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2595z00zz__evaluate_typesz00, BgL_bgl_za762lambda1976za7622899z00, BGl_z62lambda1976z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2596z00zz__evaluate_typesz00, BgL_bgl_za762lambda1975za7622900z00, BGl_z62lambda1975z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2599z00zz__evaluate_typesz00, BgL_bgl_za762lambda1981za7622901z00, BGl_z62lambda1981z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol2480z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2563z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2484z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_defglobalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2570z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2491z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2576z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2495z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2499z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2582z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2587z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2593z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2597z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letrecz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_prog2z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_bindzd2exitzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letza2za2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_labelsz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_absz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_trapz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_setglobalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_ifz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_hookz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_gotoz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_globalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_binderz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_listz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_littz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_orz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_varz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2307z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2309z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2313z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2315z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_withzd2handlerzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_andz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2320z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2322z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2404z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2326z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2411z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2331z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2416z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2335z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_exprz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_appz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2420z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2341z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2506z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2425z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2346z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2511z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2350z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2516z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2436z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2355z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2359z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_synchroniza7eza7zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2441z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2524z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2606z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2363z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2445z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2608z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2529z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2367z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2449z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2613z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2372z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2454z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2618z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2538z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2376z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2623z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2543z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2381z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2463z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2467z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2386z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_setlocalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2631z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2633z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2553z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2391z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2474z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2395z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2559z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2399z00zz__evaluate_typesz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_types.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1961>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31961ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2021>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza32021ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2014>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza32014ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2007>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza32007ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2000>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza32000ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1993>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31993ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1931>\" \"Eval/evaluate_types.scm\" 3265) \"BGl_z62zc3z04anonymousza31931ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1899>\" \"Eval/evaluate_types.scm\" 3154) \"BGl_z62zc3z04anonymousza31899ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1852>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31852ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1889>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31889ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1877>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31877ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1870>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31870ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1842>\" \"Eval/evaluate_types.scm\" 2908) \"BGl_z62zc3z04anonymousza31842ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1825>\" \"Eval/evaluate_types.scm\" 2848) \"BGl_z62zc3z04anonymousza31825ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1832>\" \"Eval/evaluate_types.scm\" 2848) \"BGl_z62zc3z04anonymousza31832ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1808>\" \"Eval/evaluate_types.scm\" 2789) \"BGl_z62zc3z04anonymousza31808ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1815>\" \"Eval/evaluate_types.scm\" 2789) \"BGl_z62zc3z04anonymousza31815ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1782>\" \"Eval/evaluate_types.scm\" 2713) \"BGl_z62zc3z04anonymousza31782ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1752>\" \"Eval/evaluate_types.scm\" 2587) \"BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1731>\" \"Eval/evaluate_types.scm\" 2505) \"BGl_z62zc3z04anonymousza31731ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1711>\" \"Eval/evaluate_types.scm\" 2427) \"BGl_z62zc3z04anonymousza31711ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1688>\" \"Eval/evaluate_types.scm\" 2353) \"BGl_z62zc3z04anonymousza31688ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1672>\" \"Eval/evaluate_types.scm\" 2314) \"BGl_z62zc3z04anonymousza31672ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1641>\" \"Eval/evaluate_types.scm\" 2226) \"BGl_z62zc3z04anonymousza31641ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1626>\" \"Eval/evaluate_types.scm\" 2176) \"BGl_z62zc3z04anonymousza31626ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1616>\" \"Eval/evaluate_types.scm\" 2147) \"BGl_z62zc3z04anonymousza31616ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1600>\" \"Eval/evaluate_types.scm\" 2100) \"BGl_z62zc3z04anonymousza31600ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1577>\" \"Eval/evaluate_types.scm\" 2032) \"BGl_z62zc3z04anonymousza31577ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1565>\" \"Eval/evaluate_types.scm\" 2004) \"BGl_z62zc3z04anonymousza31565ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1549>\" \"Eval/evaluate_types.scm\" 1977) \"BGl_z62zc3z04anonymousza31549ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1530>\" \"Eval/evaluate_types.scm\" 1936) \"BGl_z62zc3z04anonymousza31530ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1504>\" \"Eval/evaluate_types.scm\" 1855) \"BGl_z62zc3z04anonymousza31504ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1488>\" \"Eval/evaluate_types.scm\" 1813) \"BGl_z62zc3z04anonymousza31488ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1462>\" \"Eval/evaluate_types.scm\" 1723) \"BGl_z62zc3z04anonymousza31462ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1435>\" \"Eval/evaluate_types.scm\" 1637) \"BGl_z62zc3z04anonymousza31435ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1447>\" \"Eval/evaluate_types.scm\" 1637) \"BGl_z62zc3z04anonymousza31447ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1424>\" \"Eval/evaluate_types.scm\" 1612) \"BGl_z62zc3z04anonymousza31424ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long BgL_checksumz00_4151, char * BgL_fromz00_4152)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_typesz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_typesz00(); 
BGl_cnstzd2initzd2zz__evaluate_typesz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00(); 
BGl_objectzd2initzd2zz__evaluate_typesz00(); 
return 
BGl_profzd2initzd2zz__evaluate_typesz00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
BGl_symbol2307z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2308z00zz__evaluate_typesz00); 
BGl_symbol2309z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2310z00zz__evaluate_typesz00); 
BGl_symbol2313z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2314z00zz__evaluate_typesz00); 
BGl_symbol2315z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2316z00zz__evaluate_typesz00); 
BGl_symbol2320z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2321z00zz__evaluate_typesz00); 
BGl_symbol2322z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2323z00zz__evaluate_typesz00); 
BGl_symbol2326z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2327z00zz__evaluate_typesz00); 
BGl_symbol2331z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2332z00zz__evaluate_typesz00); 
BGl_symbol2335z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2336z00zz__evaluate_typesz00); 
BGl_symbol2341z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2342z00zz__evaluate_typesz00); 
BGl_symbol2346z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2347z00zz__evaluate_typesz00); 
BGl_symbol2350z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2351z00zz__evaluate_typesz00); 
BGl_symbol2355z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2356z00zz__evaluate_typesz00); 
BGl_symbol2359z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2360z00zz__evaluate_typesz00); 
BGl_symbol2363z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2364z00zz__evaluate_typesz00); 
BGl_symbol2367z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2368z00zz__evaluate_typesz00); 
BGl_symbol2372z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2373z00zz__evaluate_typesz00); 
BGl_symbol2376z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2377z00zz__evaluate_typesz00); 
BGl_symbol2381z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2382z00zz__evaluate_typesz00); 
BGl_symbol2386z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2387z00zz__evaluate_typesz00); 
BGl_symbol2391z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2392z00zz__evaluate_typesz00); 
BGl_symbol2395z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2396z00zz__evaluate_typesz00); 
BGl_symbol2399z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2400z00zz__evaluate_typesz00); 
BGl_symbol2404z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2405z00zz__evaluate_typesz00); 
BGl_symbol2411z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2412z00zz__evaluate_typesz00); 
BGl_symbol2416z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2417z00zz__evaluate_typesz00); 
BGl_symbol2420z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2421z00zz__evaluate_typesz00); 
BGl_symbol2425z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2426z00zz__evaluate_typesz00); 
BGl_symbol2436z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2437z00zz__evaluate_typesz00); 
BGl_symbol2441z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2442z00zz__evaluate_typesz00); 
BGl_symbol2445z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2446z00zz__evaluate_typesz00); 
BGl_symbol2449z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2450z00zz__evaluate_typesz00); 
BGl_symbol2454z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2455z00zz__evaluate_typesz00); 
BGl_symbol2463z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2464z00zz__evaluate_typesz00); 
BGl_symbol2467z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2468z00zz__evaluate_typesz00); 
BGl_symbol2474z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2475z00zz__evaluate_typesz00); 
BGl_symbol2480z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2481z00zz__evaluate_typesz00); 
BGl_symbol2484z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2485z00zz__evaluate_typesz00); 
BGl_symbol2491z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2492z00zz__evaluate_typesz00); 
BGl_symbol2495z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2496z00zz__evaluate_typesz00); 
BGl_symbol2499z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2500z00zz__evaluate_typesz00); 
BGl_symbol2506z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2507z00zz__evaluate_typesz00); 
BGl_symbol2511z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2512z00zz__evaluate_typesz00); 
BGl_symbol2516z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2517z00zz__evaluate_typesz00); 
BGl_symbol2524z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2525z00zz__evaluate_typesz00); 
BGl_symbol2529z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2530z00zz__evaluate_typesz00); 
BGl_symbol2538z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2539z00zz__evaluate_typesz00); 
BGl_symbol2543z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2544z00zz__evaluate_typesz00); 
BGl_symbol2553z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2554z00zz__evaluate_typesz00); 
BGl_symbol2559z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2560z00zz__evaluate_typesz00); 
BGl_symbol2563z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2564z00zz__evaluate_typesz00); 
BGl_symbol2570z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2571z00zz__evaluate_typesz00); 
BGl_symbol2576z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2577z00zz__evaluate_typesz00); 
BGl_symbol2582z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2583z00zz__evaluate_typesz00); 
BGl_symbol2587z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2588z00zz__evaluate_typesz00); 
BGl_symbol2593z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2594z00zz__evaluate_typesz00); 
BGl_symbol2597z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2598z00zz__evaluate_typesz00); 
BGl_symbol2606z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2607z00zz__evaluate_typesz00); 
BGl_symbol2608z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2609z00zz__evaluate_typesz00); 
BGl_symbol2613z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2614z00zz__evaluate_typesz00); 
BGl_symbol2618z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2619z00zz__evaluate_typesz00); 
BGl_symbol2623z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2624z00zz__evaluate_typesz00); 
BGl_symbol2631z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2632z00zz__evaluate_typesz00); 
return ( 
BGl_symbol2633z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2634z00zz__evaluate_typesz00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return 
write_bprof_table();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_arg1418z00_1062;obj_t BgL_arg1419z00_1063;
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_v1282z00_1073;
BgL_v1282z00_1073 = 
create_vector(((long)0)); 
BgL_arg1418z00_1062 = BgL_v1282z00_1073; } 
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_v1283z00_1074;
BgL_v1283z00_1074 = 
create_vector(((long)0)); 
BgL_arg1419z00_1063 = BgL_v1283z00_1074; } 
BGl_ev_exprz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2307z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_objectz00zz__objectz00, ((long)36682), BGl_proc2306z00zz__evaluate_typesz00, BGl_proc2305z00zz__evaluate_typesz00, BFALSE, BGl_proc2304z00zz__evaluate_typesz00, BFALSE, BgL_arg1418z00_1062, BgL_arg1419z00_1063); } 
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_arg1428z00_1081;obj_t BgL_arg1429z00_1082;
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_v1284z00_1095;
BgL_v1284z00_1095 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1284z00_1095,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2313z00zz__evaluate_typesz00, BGl_proc2312z00zz__evaluate_typesz00, BGl_proc2311z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2315z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1284z00_1095,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2320z00zz__evaluate_typesz00, BGl_proc2319z00zz__evaluate_typesz00, BGl_proc2318z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2317z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1284z00_1095,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2326z00zz__evaluate_typesz00, BGl_proc2325z00zz__evaluate_typesz00, BGl_proc2324z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1428z00_1081 = BgL_v1284z00_1095; } 
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_v1285z00_1129;
BgL_v1285z00_1129 = 
create_vector(((long)0)); 
BgL_arg1429z00_1082 = BgL_v1285z00_1129; } 
BGl_ev_varz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2331z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)7285), BGl_proc2330z00zz__evaluate_typesz00, BGl_proc2329z00zz__evaluate_typesz00, BFALSE, BGl_proc2328z00zz__evaluate_typesz00, BFALSE, BgL_arg1428z00_1081, BgL_arg1429z00_1082); } 
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_arg1456z00_1136;obj_t BgL_arg1457z00_1137;
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_v1286z00_1150;
BgL_v1286z00_1150 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1286z00_1150,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2335z00zz__evaluate_typesz00, BGl_proc2334z00zz__evaluate_typesz00, BGl_proc2333z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1286z00_1150,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2313z00zz__evaluate_typesz00, BGl_proc2338z00zz__evaluate_typesz00, BGl_proc2337z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2315z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1286z00_1150,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2341z00zz__evaluate_typesz00, BGl_proc2340z00zz__evaluate_typesz00, BGl_proc2339z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1456z00_1136 = BgL_v1286z00_1150; } 
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_v1287z00_1181;
BgL_v1287z00_1181 = 
create_vector(((long)0)); 
BgL_arg1457z00_1137 = BgL_v1287z00_1181; } 
BGl_ev_globalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2346z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)59175), BGl_proc2345z00zz__evaluate_typesz00, BGl_proc2344z00zz__evaluate_typesz00, BFALSE, BGl_proc2343z00zz__evaluate_typesz00, BFALSE, BgL_arg1456z00_1136, BgL_arg1457z00_1137); } 
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_arg1481z00_1188;obj_t BgL_arg1482z00_1189;
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_v1288z00_1200;
BgL_v1288z00_1200 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1288z00_1200,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2350z00zz__evaluate_typesz00, BGl_proc2349z00zz__evaluate_typesz00, BGl_proc2348z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1481z00_1188 = BgL_v1288z00_1200; } 
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_v1289z00_1211;
BgL_v1289z00_1211 = 
create_vector(((long)0)); 
BgL_arg1482z00_1189 = BgL_v1289z00_1211; } 
BGl_ev_littz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2355z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)42418), BGl_proc2354z00zz__evaluate_typesz00, BGl_proc2353z00zz__evaluate_typesz00, BFALSE, BGl_proc2352z00zz__evaluate_typesz00, BFALSE, BgL_arg1481z00_1188, BgL_arg1482z00_1189); } 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_arg1497z00_1218;obj_t BgL_arg1498z00_1219;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_v1290z00_1232;
BgL_v1290z00_1232 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1290z00_1232,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2359z00zz__evaluate_typesz00, BGl_proc2358z00zz__evaluate_typesz00, BGl_proc2357z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1290z00_1232,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2363z00zz__evaluate_typesz00, BGl_proc2362z00zz__evaluate_typesz00, BGl_proc2361z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1290z00_1232,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2367z00zz__evaluate_typesz00, BGl_proc2366z00zz__evaluate_typesz00, BGl_proc2365z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1497z00_1218 = BgL_v1290z00_1232; } 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_v1291z00_1263;
BgL_v1291z00_1263 = 
create_vector(((long)0)); 
BgL_arg1498z00_1219 = BgL_v1291z00_1263; } 
BGl_ev_ifz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2372z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)19099), BGl_proc2371z00zz__evaluate_typesz00, BGl_proc2370z00zz__evaluate_typesz00, BFALSE, BGl_proc2369z00zz__evaluate_typesz00, BFALSE, BgL_arg1497z00_1218, BgL_arg1498z00_1219); } 
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_arg1524z00_1270;obj_t BgL_arg1525z00_1271;
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_v1292z00_1282;
BgL_v1292z00_1282 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1292z00_1282,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2376z00zz__evaluate_typesz00, BGl_proc2375z00zz__evaluate_typesz00, BGl_proc2374z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1524z00_1270 = BgL_v1292z00_1282; } 
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_v1293z00_1293;
BgL_v1293z00_1293 = 
create_vector(((long)0)); 
BgL_arg1525z00_1271 = BgL_v1293z00_1293; } 
BGl_ev_listz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2381z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)39617), BGl_proc2380z00zz__evaluate_typesz00, BGl_proc2379z00zz__evaluate_typesz00, BFALSE, BGl_proc2378z00zz__evaluate_typesz00, BFALSE, BgL_arg1524z00_1270, BgL_arg1525z00_1271); } 
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_arg1543z00_1300;obj_t BgL_arg1544z00_1301;
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_v1294z00_1312;
BgL_v1294z00_1312 = 
create_vector(((long)0)); 
BgL_arg1543z00_1300 = BgL_v1294z00_1312; } 
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_v1295z00_1313;
BgL_v1295z00_1313 = 
create_vector(((long)0)); 
BgL_arg1544z00_1301 = BgL_v1295z00_1313; } 
BGl_ev_orz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2386z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_listz00zz__evaluate_typesz00, ((long)50334), BGl_proc2385z00zz__evaluate_typesz00, BGl_proc2384z00zz__evaluate_typesz00, BFALSE, BGl_proc2383z00zz__evaluate_typesz00, BFALSE, BgL_arg1543z00_1300, BgL_arg1544z00_1301); } 
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_arg1557z00_1320;obj_t BgL_arg1558z00_1321;
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_v1296z00_1332;
BgL_v1296z00_1332 = 
create_vector(((long)0)); 
BgL_arg1557z00_1320 = BgL_v1296z00_1332; } 
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_v1297z00_1333;
BgL_v1297z00_1333 = 
create_vector(((long)0)); 
BgL_arg1558z00_1321 = BgL_v1297z00_1333; } 
BGl_ev_andz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2391z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_listz00zz__evaluate_typesz00, ((long)26888), BGl_proc2390z00zz__evaluate_typesz00, BGl_proc2389z00zz__evaluate_typesz00, BFALSE, BGl_proc2388z00zz__evaluate_typesz00, BFALSE, BgL_arg1557z00_1320, BgL_arg1558z00_1321); } 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_arg1571z00_1340;obj_t BgL_arg1572z00_1341;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_v1298z00_1353;
BgL_v1298z00_1353 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1298z00_1353,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2395z00zz__evaluate_typesz00, BGl_proc2394z00zz__evaluate_typesz00, BGl_proc2393z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1298z00_1353,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2399z00zz__evaluate_typesz00, BGl_proc2398z00zz__evaluate_typesz00, BGl_proc2397z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1571z00_1340 = BgL_v1298z00_1353; } 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_v1299z00_1374;
BgL_v1299z00_1374 = 
create_vector(((long)0)); 
BgL_arg1572z00_1341 = BgL_v1299z00_1374; } 
BGl_ev_prog2z00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2404z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)14177), BGl_proc2403z00zz__evaluate_typesz00, BGl_proc2402z00zz__evaluate_typesz00, BFALSE, BGl_proc2401z00zz__evaluate_typesz00, BFALSE, BgL_arg1571z00_1340, BgL_arg1572z00_1341); } 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_arg1593z00_1381;obj_t BgL_arg1595z00_1382;
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_v1300z00_1393;
BgL_v1300z00_1393 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1300z00_1393,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2367z00zz__evaluate_typesz00, BGl_proc2407z00zz__evaluate_typesz00, BGl_proc2406z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1593z00_1381 = BgL_v1300z00_1393; } 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_v1301z00_1404;
BgL_v1301z00_1404 = 
create_vector(((long)0)); 
BgL_arg1595z00_1382 = BgL_v1301z00_1404; } 
BGl_ev_hookz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2411z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)32125), BGl_proc2410z00zz__evaluate_typesz00, BGl_proc2409z00zz__evaluate_typesz00, BFALSE, BGl_proc2408z00zz__evaluate_typesz00, BFALSE, BgL_arg1593z00_1381, BgL_arg1595z00_1382); } 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_arg1610z00_1411;obj_t BgL_arg1611z00_1412;
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_v1302z00_1423;
BgL_v1302z00_1423 = 
create_vector(((long)0)); 
BgL_arg1610z00_1411 = BgL_v1302z00_1423; } 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_v1303z00_1424;
BgL_v1303z00_1424 = 
create_vector(((long)0)); 
BgL_arg1611z00_1412 = BgL_v1303z00_1424; } 
BGl_ev_trapz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2416z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)24451), BGl_proc2415z00zz__evaluate_typesz00, BGl_proc2414z00zz__evaluate_typesz00, BFALSE, BGl_proc2413z00zz__evaluate_typesz00, BFALSE, BgL_arg1610z00_1411, BgL_arg1611z00_1412); } 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_arg1620z00_1431;obj_t BgL_arg1621z00_1432;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_v1304z00_1444;
BgL_v1304z00_1444 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1304z00_1444,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2420z00zz__evaluate_typesz00, BGl_proc2419z00zz__evaluate_typesz00, BGl_proc2418z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
BgL_arg1620z00_1431 = BgL_v1304z00_1444; } 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_v1305z00_1455;
BgL_v1305z00_1455 = 
create_vector(((long)0)); 
BgL_arg1621z00_1432 = BgL_v1305z00_1455; } 
BGl_ev_setlocalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2425z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)37950), BGl_proc2424z00zz__evaluate_typesz00, BGl_proc2423z00zz__evaluate_typesz00, BFALSE, BGl_proc2422z00zz__evaluate_typesz00, BFALSE, BgL_arg1620z00_1431, BgL_arg1621z00_1432); } 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_arg1635z00_1462;obj_t BgL_arg1636z00_1463;
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_v1306z00_1477;
BgL_v1306z00_1477 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1306z00_1477,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2335z00zz__evaluate_typesz00, BGl_proc2428z00zz__evaluate_typesz00, BGl_proc2427z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1306z00_1477,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2313z00zz__evaluate_typesz00, BGl_proc2430z00zz__evaluate_typesz00, BGl_proc2429z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2315z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1306z00_1477,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2341z00zz__evaluate_typesz00, BGl_proc2432z00zz__evaluate_typesz00, BGl_proc2431z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1635z00_1462 = BgL_v1306z00_1477; } 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_v1307z00_1508;
BgL_v1307z00_1508 = 
create_vector(((long)0)); 
BgL_arg1636z00_1463 = BgL_v1307z00_1508; } 
BGl_ev_setglobalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2436z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)62117), BGl_proc2435z00zz__evaluate_typesz00, BGl_proc2434z00zz__evaluate_typesz00, BFALSE, BGl_proc2433z00zz__evaluate_typesz00, BFALSE, BgL_arg1635z00_1462, BgL_arg1636z00_1463); } 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_arg1663z00_1515;obj_t BgL_arg1667z00_1516;
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_v1308z00_1530;
BgL_v1308z00_1530 = 
create_vector(((long)0)); 
BgL_arg1663z00_1515 = BgL_v1308z00_1530; } 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_v1309z00_1531;
BgL_v1309z00_1531 = 
create_vector(((long)0)); 
BgL_arg1667z00_1516 = BgL_v1309z00_1531; } 
BGl_ev_defglobalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2441z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_setglobalz00zz__evaluate_typesz00, ((long)36158), BGl_proc2440z00zz__evaluate_typesz00, BGl_proc2439z00zz__evaluate_typesz00, BFALSE, BGl_proc2438z00zz__evaluate_typesz00, BFALSE, BgL_arg1663z00_1515, BgL_arg1667z00_1516); } 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_arg1680z00_1538;obj_t BgL_arg1681z00_1539;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_v1310z00_1551;
BgL_v1310z00_1551 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1310z00_1551,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2445z00zz__evaluate_typesz00, BGl_proc2444z00zz__evaluate_typesz00, BGl_proc2443z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1310z00_1551,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2449z00zz__evaluate_typesz00, BGl_proc2448z00zz__evaluate_typesz00, BGl_proc2447z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1680z00_1538 = BgL_v1310z00_1551; } 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_v1311z00_1572;
BgL_v1311z00_1572 = 
create_vector(((long)0)); 
BgL_arg1681z00_1539 = BgL_v1311z00_1572; } 
BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2454z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)10723), BGl_proc2453z00zz__evaluate_typesz00, BGl_proc2452z00zz__evaluate_typesz00, BFALSE, BGl_proc2451z00zz__evaluate_typesz00, BFALSE, BgL_arg1680z00_1538, BgL_arg1681z00_1539); } 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_arg1705z00_1579;obj_t BgL_arg1706z00_1580;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_v1312z00_1592;
BgL_v1312z00_1592 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1312z00_1592,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2367z00zz__evaluate_typesz00, BGl_proc2457z00zz__evaluate_typesz00, BGl_proc2456z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1312z00_1592,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2449z00zz__evaluate_typesz00, BGl_proc2459z00zz__evaluate_typesz00, BGl_proc2458z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1705z00_1579 = BgL_v1312z00_1592; } 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_v1313z00_1613;
BgL_v1313z00_1613 = 
create_vector(((long)0)); 
BgL_arg1706z00_1580 = BgL_v1313z00_1613; } 
BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2463z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)59644), BGl_proc2462z00zz__evaluate_typesz00, BGl_proc2461z00zz__evaluate_typesz00, BFALSE, BGl_proc2460z00zz__evaluate_typesz00, BFALSE, BgL_arg1705z00_1579, BgL_arg1706z00_1580); } 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_arg1725z00_1620;obj_t BgL_arg1726z00_1621;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_v1314z00_1633;
BgL_v1314z00_1633 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1314z00_1633,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2467z00zz__evaluate_typesz00, BGl_proc2466z00zz__evaluate_typesz00, BGl_proc2465z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1314z00_1633,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2449z00zz__evaluate_typesz00, BGl_proc2470z00zz__evaluate_typesz00, BGl_proc2469z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1725z00_1620 = BgL_v1314z00_1633; } 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_v1315z00_1654;
BgL_v1315z00_1654 = 
create_vector(((long)0)); 
BgL_arg1726z00_1621 = BgL_v1315z00_1654; } 
BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2474z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)54033), BGl_proc2473z00zz__evaluate_typesz00, BGl_proc2472z00zz__evaluate_typesz00, BFALSE, BGl_proc2471z00zz__evaluate_typesz00, BFALSE, BgL_arg1725z00_1620, BgL_arg1726z00_1621); } 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_arg1746z00_1661;obj_t BgL_arg1747z00_1662;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_v1316z00_1676;
BgL_v1316z00_1676 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1316z00_1676,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2335z00zz__evaluate_typesz00, BGl_proc2477z00zz__evaluate_typesz00, BGl_proc2476z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1316z00_1676,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2480z00zz__evaluate_typesz00, BGl_proc2479z00zz__evaluate_typesz00, BGl_proc2478z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1316z00_1676,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2484z00zz__evaluate_typesz00, BGl_proc2483z00zz__evaluate_typesz00, BGl_proc2482z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1316z00_1676,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2449z00zz__evaluate_typesz00, BGl_proc2487z00zz__evaluate_typesz00, BGl_proc2486z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1746z00_1661 = BgL_v1316z00_1676; } 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_v1317z00_1717;
BgL_v1317z00_1717 = 
create_vector(((long)0)); 
BgL_arg1747z00_1662 = BgL_v1317z00_1717; } 
BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2491z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)40653), BGl_proc2490z00zz__evaluate_typesz00, BGl_proc2489z00zz__evaluate_typesz00, BFALSE, BGl_proc2488z00zz__evaluate_typesz00, BFALSE, BgL_arg1746z00_1661, BgL_arg1747z00_1662); } 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_arg1776z00_1724;obj_t BgL_arg1777z00_1725;
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_v1318z00_1738;
BgL_v1318z00_1738 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1318z00_1738,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2495z00zz__evaluate_typesz00, BGl_proc2494z00zz__evaluate_typesz00, BGl_proc2493z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1318z00_1738,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2499z00zz__evaluate_typesz00, BGl_proc2498z00zz__evaluate_typesz00, BGl_proc2497z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1318z00_1738,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2449z00zz__evaluate_typesz00, BGl_proc2502z00zz__evaluate_typesz00, BGl_proc2501z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1776z00_1724 = BgL_v1318z00_1738; } 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_v1319z00_1769;
BgL_v1319z00_1769 = 
create_vector(((long)0)); 
BgL_arg1777z00_1725 = BgL_v1319z00_1769; } 
BGl_ev_binderz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2506z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)50341), BGl_proc2505z00zz__evaluate_typesz00, BGl_proc2504z00zz__evaluate_typesz00, BFALSE, BGl_proc2503z00zz__evaluate_typesz00, BFALSE, BgL_arg1776z00_1724, BgL_arg1777z00_1725); } 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_arg1801z00_1776;obj_t BgL_arg1803z00_1777;
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_v1320z00_1791;
BgL_v1320z00_1791 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1320z00_1791,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2511z00zz__evaluate_typesz00, BGl_proc2510z00zz__evaluate_typesz00, BGl_proc2509z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2508z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1801z00_1776 = BgL_v1320z00_1791; } 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_v1321z00_1805;
BgL_v1321z00_1805 = 
create_vector(((long)0)); 
BgL_arg1803z00_1777 = BgL_v1321z00_1805; } 
BGl_ev_letz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2516z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)20484), BGl_proc2515z00zz__evaluate_typesz00, BGl_proc2514z00zz__evaluate_typesz00, BFALSE, BGl_proc2513z00zz__evaluate_typesz00, BFALSE, BgL_arg1801z00_1776, BgL_arg1803z00_1777); } 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_arg1819z00_1812;obj_t BgL_arg1820z00_1813;
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_v1322z00_1827;
BgL_v1322z00_1827 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1322z00_1827,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2511z00zz__evaluate_typesz00, BGl_proc2520z00zz__evaluate_typesz00, BGl_proc2519z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2518z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1819z00_1812 = BgL_v1322z00_1827; } 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_v1323z00_1841;
BgL_v1323z00_1841 = 
create_vector(((long)0)); 
BgL_arg1820z00_1813 = BgL_v1323z00_1841; } 
BGl_ev_letza2za2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)9906), BGl_proc2523z00zz__evaluate_typesz00, BGl_proc2522z00zz__evaluate_typesz00, BFALSE, BGl_proc2521z00zz__evaluate_typesz00, BFALSE, BgL_arg1819z00_1812, BgL_arg1820z00_1813); } 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_arg1836z00_1848;obj_t BgL_arg1837z00_1849;
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_v1324z00_1862;
BgL_v1324z00_1862 = 
create_vector(((long)0)); 
BgL_arg1836z00_1848 = BgL_v1324z00_1862; } 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_v1325z00_1863;
BgL_v1325z00_1863 = 
create_vector(((long)0)); 
BgL_arg1837z00_1849 = BgL_v1325z00_1863; } 
BGl_ev_letrecz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2529z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)43956), BGl_proc2528z00zz__evaluate_typesz00, BGl_proc2527z00zz__evaluate_typesz00, BFALSE, BGl_proc2526z00zz__evaluate_typesz00, BFALSE, BgL_arg1836z00_1848, BgL_arg1837z00_1849); } 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_arg1846z00_1870;obj_t BgL_arg1847z00_1871;
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_v1326z00_1887;
BgL_v1326z00_1887 = 
create_vector(((long)6)); 
VECTOR_SET(BgL_v1326z00_1887,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2495z00zz__evaluate_typesz00, BGl_proc2532z00zz__evaluate_typesz00, BGl_proc2531z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1887,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2499z00zz__evaluate_typesz00, BGl_proc2534z00zz__evaluate_typesz00, BGl_proc2533z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1887,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2538z00zz__evaluate_typesz00, BGl_proc2537z00zz__evaluate_typesz00, BGl_proc2536z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2535z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1887,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2543z00zz__evaluate_typesz00, BGl_proc2542z00zz__evaluate_typesz00, BGl_proc2541z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2540z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1887,((long)4),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2449z00zz__evaluate_typesz00, BGl_proc2546z00zz__evaluate_typesz00, BGl_proc2545z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1326z00_1887,((long)5),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2511z00zz__evaluate_typesz00, BGl_proc2549z00zz__evaluate_typesz00, BGl_proc2548z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2547z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1846z00_1870 = BgL_v1326z00_1887; } 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_v1327z00_1957;
BgL_v1327z00_1957 = 
create_vector(((long)0)); 
BgL_arg1847z00_1871 = BgL_v1327z00_1957; } 
BGl_ev_labelsz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2553z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)51941), BGl_proc2552z00zz__evaluate_typesz00, BGl_proc2551z00zz__evaluate_typesz00, BFALSE, BGl_proc2550z00zz__evaluate_typesz00, BFALSE, BgL_arg1846z00_1870, BgL_arg1847z00_1871); } 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_arg1893z00_1964;obj_t BgL_arg1894z00_1965;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_v1328z00_1979;
BgL_v1328z00_1979 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1328z00_1979,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2335z00zz__evaluate_typesz00, BGl_proc2556z00zz__evaluate_typesz00, BGl_proc2555z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1328z00_1979,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2559z00zz__evaluate_typesz00, BGl_proc2558z00zz__evaluate_typesz00, BGl_proc2557z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1328z00_1979,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2563z00zz__evaluate_typesz00, BGl_proc2562z00zz__evaluate_typesz00, BGl_proc2561z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_labelsz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1328z00_1979,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2376z00zz__evaluate_typesz00, BGl_proc2566z00zz__evaluate_typesz00, BGl_proc2565z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1893z00_1964 = BgL_v1328z00_1979; } 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_v1329z00_2020;
BgL_v1329z00_2020 = 
create_vector(((long)0)); 
BgL_arg1894z00_1965 = BgL_v1329z00_2020; } 
BGl_ev_gotoz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2570z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)25746), BGl_proc2569z00zz__evaluate_typesz00, BGl_proc2568z00zz__evaluate_typesz00, BFALSE, BGl_proc2567z00zz__evaluate_typesz00, BFALSE, BgL_arg1893z00_1964, BgL_arg1894z00_1965); } 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_arg1925z00_2027;obj_t BgL_arg1926z00_2028;
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_v1330z00_2042;
BgL_v1330z00_2042 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1330z00_2042,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2335z00zz__evaluate_typesz00, BGl_proc2573z00zz__evaluate_typesz00, BGl_proc2572z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1330z00_2042,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2576z00zz__evaluate_typesz00, BGl_proc2575z00zz__evaluate_typesz00, BGl_proc2574z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1330z00_2042,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2376z00zz__evaluate_typesz00, BGl_proc2579z00zz__evaluate_typesz00, BGl_proc2578z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1330z00_2042,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2582z00zz__evaluate_typesz00, BGl_proc2581z00zz__evaluate_typesz00, BGl_proc2580z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1925z00_2027 = BgL_v1330z00_2042; } 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_v1331z00_2083;
BgL_v1331z00_2083 = 
create_vector(((long)0)); 
BgL_arg1926z00_2028 = BgL_v1331z00_2083; } 
BGl_ev_appz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2587z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)55822), BGl_proc2586z00zz__evaluate_typesz00, BGl_proc2585z00zz__evaluate_typesz00, BFALSE, BGl_proc2584z00zz__evaluate_typesz00, BFALSE, BgL_arg1925z00_2027, BgL_arg1926z00_2028); } 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_arg1955z00_2090;obj_t BgL_arg1956z00_2091;
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_v1332z00_2111;
BgL_v1332z00_2111 = 
create_vector(((long)10)); 
VECTOR_SET(BgL_v1332z00_2111,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2335z00zz__evaluate_typesz00, BGl_proc2590z00zz__evaluate_typesz00, BGl_proc2589z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2593z00zz__evaluate_typesz00, BGl_proc2592z00zz__evaluate_typesz00, BGl_proc2591z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2597z00zz__evaluate_typesz00, BGl_proc2596z00zz__evaluate_typesz00, BGl_proc2595z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2495z00zz__evaluate_typesz00, BGl_proc2600z00zz__evaluate_typesz00, BGl_proc2599z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)4),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2449z00zz__evaluate_typesz00, BGl_proc2602z00zz__evaluate_typesz00, BGl_proc2601z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)5),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2606z00zz__evaluate_typesz00, BGl_proc2605z00zz__evaluate_typesz00, BGl_proc2604z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2603z00zz__evaluate_typesz00, BGl_symbol2608z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)6),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2613z00zz__evaluate_typesz00, BGl_proc2612z00zz__evaluate_typesz00, BGl_proc2611z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2610z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)7),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2618z00zz__evaluate_typesz00, BGl_proc2617z00zz__evaluate_typesz00, BGl_proc2616z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2615z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)8),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2623z00zz__evaluate_typesz00, BGl_proc2622z00zz__evaluate_typesz00, BGl_proc2621z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2620z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1332z00_2111,((long)9),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2511z00zz__evaluate_typesz00, BGl_proc2627z00zz__evaluate_typesz00, BGl_proc2626z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2625z00zz__evaluate_typesz00, BGl_symbol2322z00zz__evaluate_typesz00)); 
BgL_arg1955z00_2090 = BgL_v1332z00_2111; } 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_v1333z00_2227;
BgL_v1333z00_2227 = 
create_vector(((long)0)); 
BgL_arg1956z00_2091 = BgL_v1333z00_2227; } 
return ( 
BGl_ev_absz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2631z00zz__evaluate_typesz00, BGl_symbol2309z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)22827), BGl_proc2630z00zz__evaluate_typesz00, BGl_proc2629z00zz__evaluate_typesz00, BFALSE, BGl_proc2628z00zz__evaluate_typesz00, BFALSE, BgL_arg1955z00_2090, BgL_arg1956z00_2091), BUNSPEC) ;} } 

}



/* &<@anonymous:1961> */
obj_t BGl_z62zc3z04anonymousza31961ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3288, obj_t BgL_new1190z00_3289)
{
{ /* Eval/evaluate_types.scm 122 */
{ 
BgL_ev_absz00_bglt BgL_auxz00_4419;
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_wherez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_arityz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4428;
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_classz00_3764;
BgL_classz00_3764 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL__ortest_1281z00_3765;
BgL__ortest_1281z00_3765 = 
BGL_CLASS_NIL(BgL_classz00_3764); 
if(
CBOOL(BgL__ortest_1281z00_3765))
{ /* Eval/evaluate_types.scm 122 */
BgL_auxz00_4428 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3765)
; }  else 
{ /* Eval/evaluate_types.scm 122 */
BgL_auxz00_4428 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3764))
; } } } 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4428),BUNSPEC); } 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_siza7eza7)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_bindz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_freez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_innerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1190z00_3289)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4419 = 
((BgL_ev_absz00_bglt)BgL_new1190z00_3289); 
return 
((obj_t)BgL_auxz00_4419);} } 

}



/* &lambda1959 */
BgL_ev_absz00_bglt BGl_z62lambda1959z62zz__evaluate_typesz00(obj_t BgL_envz00_3290)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1189z00_3766;
BgL_new1189z00_3766 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 122 */
long BgL_arg1960z00_3767;
BgL_arg1960z00_3767 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1189z00_3766), BgL_arg1960z00_3767); } 
return BgL_new1189z00_3766;} } 

}



/* &lambda1957 */
BgL_ev_absz00_bglt BGl_z62lambda1957z62zz__evaluate_typesz00(obj_t BgL_envz00_3291, obj_t BgL_loc1179z00_3292, obj_t BgL_where1180z00_3293, obj_t BgL_arity1181z00_3294, obj_t BgL_vars1182z00_3295, obj_t BgL_body1183z00_3296, obj_t BgL_siza7e1184za7_3297, obj_t BgL_bind1185z00_3298, obj_t BgL_free1186z00_3299, obj_t BgL_inner1187z00_3300, obj_t BgL_boxes1188z00_3301)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
int BgL_siza7e1184za7_3769;
BgL_siza7e1184za7_3769 = 
CINT(BgL_siza7e1184za7_3297); 
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1242z00_3770;
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1241z00_3771;
BgL_new1241z00_3771 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 122 */
long BgL_arg1958z00_3772;
BgL_arg1958z00_3772 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1241z00_3771), BgL_arg1958z00_3772); } 
BgL_new1242z00_3770 = BgL_new1241z00_3771; } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_locz00)=((obj_t)BgL_loc1179z00_3292),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_wherez00)=((obj_t)BgL_where1180z00_3293),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_arityz00)=((obj_t)BgL_arity1181z00_3294),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_varsz00)=((obj_t)BgL_vars1182z00_3295),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1183z00_3296)),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_siza7eza7)=((int)BgL_siza7e1184za7_3769),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_bindz00)=((obj_t)BgL_bind1185z00_3298),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_freez00)=((obj_t)BgL_free1186z00_3299),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_innerz00)=((obj_t)BgL_inner1187z00_3300),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1242z00_3770))->BgL_boxesz00)=((obj_t)BgL_boxes1188z00_3301),BUNSPEC); 
return BgL_new1242z00_3770;} } } 

}



/* &<@anonymous:2021> */
obj_t BGl_z62zc3z04anonymousza32021ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3302)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda2020 */
obj_t BGl_z62lambda2020z62zz__evaluate_typesz00(obj_t BgL_envz00_3303, obj_t BgL_oz00_3304, obj_t BgL_vz00_3305)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3304)))->BgL_boxesz00)=((obj_t)BgL_vz00_3305),BUNSPEC);} 

}



/* &lambda2019 */
obj_t BGl_z62lambda2019z62zz__evaluate_typesz00(obj_t BgL_envz00_3306, obj_t BgL_oz00_3307)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3307)))->BgL_boxesz00);} 

}



/* &<@anonymous:2014> */
obj_t BGl_z62zc3z04anonymousza32014ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3308)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda2013 */
obj_t BGl_z62lambda2013z62zz__evaluate_typesz00(obj_t BgL_envz00_3309, obj_t BgL_oz00_3310, obj_t BgL_vz00_3311)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3310)))->BgL_innerz00)=((obj_t)BgL_vz00_3311),BUNSPEC);} 

}



/* &lambda2012 */
obj_t BGl_z62lambda2012z62zz__evaluate_typesz00(obj_t BgL_envz00_3312, obj_t BgL_oz00_3313)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3313)))->BgL_innerz00);} 

}



/* &<@anonymous:2007> */
obj_t BGl_z62zc3z04anonymousza32007ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3314)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda2006 */
obj_t BGl_z62lambda2006z62zz__evaluate_typesz00(obj_t BgL_envz00_3315, obj_t BgL_oz00_3316, obj_t BgL_vz00_3317)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3316)))->BgL_freez00)=((obj_t)BgL_vz00_3317),BUNSPEC);} 

}



/* &lambda2005 */
obj_t BGl_z62lambda2005z62zz__evaluate_typesz00(obj_t BgL_envz00_3318, obj_t BgL_oz00_3319)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3319)))->BgL_freez00);} 

}



/* &<@anonymous:2000> */
obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3320)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda1999 */
obj_t BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t BgL_envz00_3321, obj_t BgL_oz00_3322, obj_t BgL_vz00_3323)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3322)))->BgL_bindz00)=((obj_t)BgL_vz00_3323),BUNSPEC);} 

}



/* &lambda1998 */
obj_t BGl_z62lambda1998z62zz__evaluate_typesz00(obj_t BgL_envz00_3324, obj_t BgL_oz00_3325)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3325)))->BgL_bindz00);} 

}



/* &<@anonymous:1993> */
obj_t BGl_z62zc3z04anonymousza31993ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3326)
{
{ /* Eval/evaluate_types.scm 122 */
return 
BINT(((long)0));} 

}



/* &lambda1992 */
obj_t BGl_z62lambda1992z62zz__evaluate_typesz00(obj_t BgL_envz00_3327, obj_t BgL_oz00_3328, obj_t BgL_vz00_3329)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
int BgL_vz00_3782;
BgL_vz00_3782 = 
CINT(BgL_vz00_3329); 
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3328)))->BgL_siza7eza7)=((int)BgL_vz00_3782),BUNSPEC);} } 

}



/* &lambda1991 */
obj_t BGl_z62lambda1991z62zz__evaluate_typesz00(obj_t BgL_envz00_3330, obj_t BgL_oz00_3331)
{
{ /* Eval/evaluate_types.scm 122 */
return 
BINT(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3331)))->BgL_siza7eza7));} 

}



/* &lambda1986 */
obj_t BGl_z62lambda1986z62zz__evaluate_typesz00(obj_t BgL_envz00_3332, obj_t BgL_oz00_3333, obj_t BgL_vz00_3334)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3333)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3334)),BUNSPEC);} 

}



/* &lambda1985 */
BgL_ev_exprz00_bglt BGl_z62lambda1985z62zz__evaluate_typesz00(obj_t BgL_envz00_3335, obj_t BgL_oz00_3336)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3336)))->BgL_bodyz00);} 

}



/* &lambda1981 */
obj_t BGl_z62lambda1981z62zz__evaluate_typesz00(obj_t BgL_envz00_3337, obj_t BgL_oz00_3338, obj_t BgL_vz00_3339)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3338)))->BgL_varsz00)=((obj_t)BgL_vz00_3339),BUNSPEC);} 

}



/* &lambda1980 */
obj_t BGl_z62lambda1980z62zz__evaluate_typesz00(obj_t BgL_envz00_3340, obj_t BgL_oz00_3341)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3341)))->BgL_varsz00);} 

}



/* &lambda1976 */
obj_t BGl_z62lambda1976z62zz__evaluate_typesz00(obj_t BgL_envz00_3342, obj_t BgL_oz00_3343, obj_t BgL_vz00_3344)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3343)))->BgL_arityz00)=((obj_t)BgL_vz00_3344),BUNSPEC);} 

}



/* &lambda1975 */
obj_t BGl_z62lambda1975z62zz__evaluate_typesz00(obj_t BgL_envz00_3345, obj_t BgL_oz00_3346)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3346)))->BgL_arityz00);} 

}



/* &lambda1971 */
obj_t BGl_z62lambda1971z62zz__evaluate_typesz00(obj_t BgL_envz00_3347, obj_t BgL_oz00_3348, obj_t BgL_vz00_3349)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3348)))->BgL_wherez00)=((obj_t)BgL_vz00_3349),BUNSPEC);} 

}



/* &lambda1970 */
obj_t BGl_z62lambda1970z62zz__evaluate_typesz00(obj_t BgL_envz00_3350, obj_t BgL_oz00_3351)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3351)))->BgL_wherez00);} 

}



/* &lambda1966 */
obj_t BGl_z62lambda1966z62zz__evaluate_typesz00(obj_t BgL_envz00_3352, obj_t BgL_oz00_3353, obj_t BgL_vz00_3354)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3353)))->BgL_locz00)=((obj_t)BgL_vz00_3354),BUNSPEC);} 

}



/* &lambda1965 */
obj_t BGl_z62lambda1965z62zz__evaluate_typesz00(obj_t BgL_envz00_3355, obj_t BgL_oz00_3356)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3356)))->BgL_locz00);} 

}



/* &<@anonymous:1931> */
obj_t BGl_z62zc3z04anonymousza31931ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3357, obj_t BgL_new1177z00_3358)
{
{ /* Eval/evaluate_types.scm 119 */
{ 
BgL_ev_appz00_bglt BgL_auxz00_4514;
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1177z00_3358)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4517;
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_classz00_3796;
BgL_classz00_3796 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL__ortest_1281z00_3797;
BgL__ortest_1281z00_3797 = 
BGL_CLASS_NIL(BgL_classz00_3796); 
if(
CBOOL(BgL__ortest_1281z00_3797))
{ /* Eval/evaluate_types.scm 119 */
BgL_auxz00_4517 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3797)
; }  else 
{ /* Eval/evaluate_types.scm 119 */
BgL_auxz00_4517 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3796))
; } } } 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1177z00_3358)))->BgL_funz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4517),BUNSPEC); } 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1177z00_3358)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1177z00_3358)))->BgL_tailzf3zf3)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4514 = 
((BgL_ev_appz00_bglt)BgL_new1177z00_3358); 
return 
((obj_t)BgL_auxz00_4514);} } 

}



/* &lambda1929 */
BgL_ev_appz00_bglt BGl_z62lambda1929z62zz__evaluate_typesz00(obj_t BgL_envz00_3359)
{
{ /* Eval/evaluate_types.scm 119 */
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1176z00_3798;
BgL_new1176z00_3798 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 119 */
long BgL_arg1930z00_3799;
BgL_arg1930z00_3799 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1176z00_3798), BgL_arg1930z00_3799); } 
return BgL_new1176z00_3798;} } 

}



/* &lambda1927 */
BgL_ev_appz00_bglt BGl_z62lambda1927z62zz__evaluate_typesz00(obj_t BgL_envz00_3360, obj_t BgL_loc1172z00_3361, obj_t BgL_fun1173z00_3362, obj_t BgL_args1174z00_3363, obj_t BgL_tailzf31175zf3_3364)
{
{ /* Eval/evaluate_types.scm 119 */
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1240z00_3801;
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1239z00_3802;
BgL_new1239z00_3802 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 119 */
long BgL_arg1928z00_3803;
BgL_arg1928z00_3803 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1239z00_3802), BgL_arg1928z00_3803); } 
BgL_new1240z00_3801 = BgL_new1239z00_3802; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1240z00_3801))->BgL_locz00)=((obj_t)BgL_loc1172z00_3361),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1240z00_3801))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_fun1173z00_3362)),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1240z00_3801))->BgL_argsz00)=((obj_t)BgL_args1174z00_3363),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1240z00_3801))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf31175zf3_3364),BUNSPEC); 
return BgL_new1240z00_3801;} } 

}



/* &lambda1951 */
obj_t BGl_z62lambda1951z62zz__evaluate_typesz00(obj_t BgL_envz00_3365, obj_t BgL_oz00_3366, obj_t BgL_vz00_3367)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3366)))->BgL_tailzf3zf3)=((obj_t)BgL_vz00_3367),BUNSPEC);} 

}



/* &lambda1950 */
obj_t BGl_z62lambda1950z62zz__evaluate_typesz00(obj_t BgL_envz00_3368, obj_t BgL_oz00_3369)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3369)))->BgL_tailzf3zf3);} 

}



/* &lambda1946 */
obj_t BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t BgL_envz00_3370, obj_t BgL_oz00_3371, obj_t BgL_vz00_3372)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3371)))->BgL_argsz00)=((obj_t)BgL_vz00_3372),BUNSPEC);} 

}



/* &lambda1945 */
obj_t BGl_z62lambda1945z62zz__evaluate_typesz00(obj_t BgL_envz00_3373, obj_t BgL_oz00_3374)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3374)))->BgL_argsz00);} 

}



/* &lambda1941 */
obj_t BGl_z62lambda1941z62zz__evaluate_typesz00(obj_t BgL_envz00_3375, obj_t BgL_oz00_3376, obj_t BgL_vz00_3377)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3376)))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3377)),BUNSPEC);} 

}



/* &lambda1940 */
BgL_ev_exprz00_bglt BGl_z62lambda1940z62zz__evaluate_typesz00(obj_t BgL_envz00_3378, obj_t BgL_oz00_3379)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3379)))->BgL_funz00);} 

}



/* &lambda1936 */
obj_t BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t BgL_envz00_3380, obj_t BgL_oz00_3381, obj_t BgL_vz00_3382)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3381)))->BgL_locz00)=((obj_t)BgL_vz00_3382),BUNSPEC);} 

}



/* &lambda1935 */
obj_t BGl_z62lambda1935z62zz__evaluate_typesz00(obj_t BgL_envz00_3383, obj_t BgL_oz00_3384)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3384)))->BgL_locz00);} 

}



/* &<@anonymous:1899> */
obj_t BGl_z62zc3z04anonymousza31899ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3385, obj_t BgL_new1170z00_3386)
{
{ /* Eval/evaluate_types.scm 114 */
{ 
BgL_ev_gotoz00_bglt BgL_auxz00_4562;
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3386)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_varz00_bglt BgL_auxz00_4565;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_classz00_3814;
BgL_classz00_3814 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL__ortest_1281z00_3815;
BgL__ortest_1281z00_3815 = 
BGL_CLASS_NIL(BgL_classz00_3814); 
if(
CBOOL(BgL__ortest_1281z00_3815))
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4565 = 
((BgL_ev_varz00_bglt)BgL__ortest_1281z00_3815)
; }  else 
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4565 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3814))
; } } } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3386)))->BgL_labelz00)=((BgL_ev_varz00_bglt)BgL_auxz00_4565),BUNSPEC); } 
{ 
BgL_ev_labelsz00_bglt BgL_auxz00_4574;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_classz00_3816;
BgL_classz00_3816 = BGl_ev_labelsz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL__ortest_1281z00_3817;
BgL__ortest_1281z00_3817 = 
BGL_CLASS_NIL(BgL_classz00_3816); 
if(
CBOOL(BgL__ortest_1281z00_3817))
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4574 = 
((BgL_ev_labelsz00_bglt)BgL__ortest_1281z00_3817)
; }  else 
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4574 = 
((BgL_ev_labelsz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3816))
; } } } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3386)))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)BgL_auxz00_4574),BUNSPEC); } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3386)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4562 = 
((BgL_ev_gotoz00_bglt)BgL_new1170z00_3386); 
return 
((obj_t)BgL_auxz00_4562);} } 

}



/* &lambda1897 */
BgL_ev_gotoz00_bglt BGl_z62lambda1897z62zz__evaluate_typesz00(obj_t BgL_envz00_3387)
{
{ /* Eval/evaluate_types.scm 114 */
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1169z00_3818;
BgL_new1169z00_3818 = 
((BgL_ev_gotoz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_gotoz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 114 */
long BgL_arg1898z00_3819;
BgL_arg1898z00_3819 = 
BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1169z00_3818), BgL_arg1898z00_3819); } 
return BgL_new1169z00_3818;} } 

}



/* &lambda1895 */
BgL_ev_gotoz00_bglt BGl_z62lambda1895z62zz__evaluate_typesz00(obj_t BgL_envz00_3388, obj_t BgL_loc1165z00_3389, obj_t BgL_label1166z00_3390, obj_t BgL_labels1167z00_3391, obj_t BgL_args1168z00_3392)
{
{ /* Eval/evaluate_types.scm 114 */
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1238z00_3822;
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1237z00_3823;
BgL_new1237z00_3823 = 
((BgL_ev_gotoz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_gotoz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 114 */
long BgL_arg1896z00_3824;
BgL_arg1896z00_3824 = 
BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1237z00_3823), BgL_arg1896z00_3824); } 
BgL_new1238z00_3822 = BgL_new1237z00_3823; } 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1238z00_3822))->BgL_locz00)=((obj_t)BgL_loc1165z00_3389),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1238z00_3822))->BgL_labelz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_label1166z00_3390)),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1238z00_3822))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)
((BgL_ev_labelsz00_bglt)BgL_labels1167z00_3391)),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1238z00_3822))->BgL_argsz00)=((obj_t)BgL_args1168z00_3392),BUNSPEC); 
return BgL_new1238z00_3822;} } 

}



/* &lambda1921 */
obj_t BGl_z62lambda1921z62zz__evaluate_typesz00(obj_t BgL_envz00_3393, obj_t BgL_oz00_3394, obj_t BgL_vz00_3395)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3394)))->BgL_argsz00)=((obj_t)BgL_vz00_3395),BUNSPEC);} 

}



/* &lambda1920 */
obj_t BGl_z62lambda1920z62zz__evaluate_typesz00(obj_t BgL_envz00_3396, obj_t BgL_oz00_3397)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3397)))->BgL_argsz00);} 

}



/* &lambda1916 */
obj_t BGl_z62lambda1916z62zz__evaluate_typesz00(obj_t BgL_envz00_3398, obj_t BgL_oz00_3399, obj_t BgL_vz00_3400)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3399)))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)
((BgL_ev_labelsz00_bglt)BgL_vz00_3400)),BUNSPEC);} 

}



/* &lambda1915 */
BgL_ev_labelsz00_bglt BGl_z62lambda1915z62zz__evaluate_typesz00(obj_t BgL_envz00_3401, obj_t BgL_oz00_3402)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3402)))->BgL_labelsz00);} 

}



/* &lambda1911 */
obj_t BGl_z62lambda1911z62zz__evaluate_typesz00(obj_t BgL_envz00_3403, obj_t BgL_oz00_3404, obj_t BgL_vz00_3405)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3404)))->BgL_labelz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3405)),BUNSPEC);} 

}



/* &lambda1910 */
BgL_ev_varz00_bglt BGl_z62lambda1910z62zz__evaluate_typesz00(obj_t BgL_envz00_3406, obj_t BgL_oz00_3407)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3407)))->BgL_labelz00);} 

}



/* &lambda1906 */
obj_t BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t BgL_envz00_3408, obj_t BgL_oz00_3409, obj_t BgL_vz00_3410)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3409)))->BgL_locz00)=((obj_t)BgL_vz00_3410),BUNSPEC);} 

}



/* &lambda1905 */
obj_t BGl_z62lambda1905z62zz__evaluate_typesz00(obj_t BgL_envz00_3411, obj_t BgL_oz00_3412)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3412)))->BgL_locz00);} 

}



/* &<@anonymous:1852> */
obj_t BGl_z62zc3z04anonymousza31852ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3413, obj_t BgL_new1163z00_3414)
{
{ /* Eval/evaluate_types.scm 106 */
{ 
BgL_ev_labelsz00_bglt BgL_auxz00_4619;
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3414)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3414)))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3414)))->BgL_envz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3414)))->BgL_stkz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4628;
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_classz00_3836;
BgL_classz00_3836 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL__ortest_1281z00_3837;
BgL__ortest_1281z00_3837 = 
BGL_CLASS_NIL(BgL_classz00_3836); 
if(
CBOOL(BgL__ortest_1281z00_3837))
{ /* Eval/evaluate_types.scm 106 */
BgL_auxz00_4628 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3837)
; }  else 
{ /* Eval/evaluate_types.scm 106 */
BgL_auxz00_4628 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3836))
; } } } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3414)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4628),BUNSPEC); } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3414)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4619 = 
((BgL_ev_labelsz00_bglt)BgL_new1163z00_3414); 
return 
((obj_t)BgL_auxz00_4619);} } 

}



/* &lambda1850 */
BgL_ev_labelsz00_bglt BGl_z62lambda1850z62zz__evaluate_typesz00(obj_t BgL_envz00_3415)
{
{ /* Eval/evaluate_types.scm 106 */
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1162z00_3838;
BgL_new1162z00_3838 = 
((BgL_ev_labelsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_labelsz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 106 */
long BgL_arg1851z00_3839;
BgL_arg1851z00_3839 = 
BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1162z00_3838), BgL_arg1851z00_3839); } 
return BgL_new1162z00_3838;} } 

}



/* &lambda1848 */
BgL_ev_labelsz00_bglt BGl_z62lambda1848z62zz__evaluate_typesz00(obj_t BgL_envz00_3416, obj_t BgL_vars1156z00_3417, obj_t BgL_vals1157z00_3418, obj_t BgL_env1158z00_3419, obj_t BgL_stk1159z00_3420, obj_t BgL_body1160z00_3421, obj_t BgL_boxes1161z00_3422)
{
{ /* Eval/evaluate_types.scm 106 */
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1236z00_3841;
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1235z00_3842;
BgL_new1235z00_3842 = 
((BgL_ev_labelsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_labelsz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 106 */
long BgL_arg1849z00_3843;
BgL_arg1849z00_3843 = 
BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1235z00_3842), BgL_arg1849z00_3843); } 
BgL_new1236z00_3841 = BgL_new1235z00_3842; } 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3841))->BgL_varsz00)=((obj_t)BgL_vars1156z00_3417),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3841))->BgL_valsz00)=((obj_t)BgL_vals1157z00_3418),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3841))->BgL_envz00)=((obj_t)BgL_env1158z00_3419),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3841))->BgL_stkz00)=((obj_t)BgL_stk1159z00_3420),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3841))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1160z00_3421)),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1236z00_3841))->BgL_boxesz00)=((obj_t)BgL_boxes1161z00_3422),BUNSPEC); 
return BgL_new1236z00_3841;} } 

}



/* &<@anonymous:1889> */
obj_t BGl_z62zc3z04anonymousza31889ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3423)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1888 */
obj_t BGl_z62lambda1888z62zz__evaluate_typesz00(obj_t BgL_envz00_3424, obj_t BgL_oz00_3425, obj_t BgL_vz00_3426)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3425)))->BgL_boxesz00)=((obj_t)BgL_vz00_3426),BUNSPEC);} 

}



/* &lambda1887 */
obj_t BGl_z62lambda1887z62zz__evaluate_typesz00(obj_t BgL_envz00_3427, obj_t BgL_oz00_3428)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3428)))->BgL_boxesz00);} 

}



/* &lambda1882 */
obj_t BGl_z62lambda1882z62zz__evaluate_typesz00(obj_t BgL_envz00_3429, obj_t BgL_oz00_3430, obj_t BgL_vz00_3431)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3430)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3431)),BUNSPEC);} 

}



/* &lambda1881 */
BgL_ev_exprz00_bglt BGl_z62lambda1881z62zz__evaluate_typesz00(obj_t BgL_envz00_3432, obj_t BgL_oz00_3433)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3433)))->BgL_bodyz00);} 

}



/* &<@anonymous:1877> */
obj_t BGl_z62zc3z04anonymousza31877ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3434)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1876 */
obj_t BGl_z62lambda1876z62zz__evaluate_typesz00(obj_t BgL_envz00_3435, obj_t BgL_oz00_3436, obj_t BgL_vz00_3437)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3436)))->BgL_stkz00)=((obj_t)BgL_vz00_3437),BUNSPEC);} 

}



/* &lambda1875 */
obj_t BGl_z62lambda1875z62zz__evaluate_typesz00(obj_t BgL_envz00_3438, obj_t BgL_oz00_3439)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3439)))->BgL_stkz00);} 

}



/* &<@anonymous:1870> */
obj_t BGl_z62zc3z04anonymousza31870ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3440)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1869 */
obj_t BGl_z62lambda1869z62zz__evaluate_typesz00(obj_t BgL_envz00_3441, obj_t BgL_oz00_3442, obj_t BgL_vz00_3443)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3442)))->BgL_envz00)=((obj_t)BgL_vz00_3443),BUNSPEC);} 

}



/* &lambda1868 */
obj_t BGl_z62lambda1868z62zz__evaluate_typesz00(obj_t BgL_envz00_3444, obj_t BgL_oz00_3445)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3445)))->BgL_envz00);} 

}



/* &lambda1863 */
obj_t BGl_z62lambda1863z62zz__evaluate_typesz00(obj_t BgL_envz00_3446, obj_t BgL_oz00_3447, obj_t BgL_vz00_3448)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3447)))->BgL_valsz00)=((obj_t)BgL_vz00_3448),BUNSPEC);} 

}



/* &lambda1862 */
obj_t BGl_z62lambda1862z62zz__evaluate_typesz00(obj_t BgL_envz00_3449, obj_t BgL_oz00_3450)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3450)))->BgL_valsz00);} 

}



/* &lambda1857 */
obj_t BGl_z62lambda1857z62zz__evaluate_typesz00(obj_t BgL_envz00_3451, obj_t BgL_oz00_3452, obj_t BgL_vz00_3453)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3452)))->BgL_varsz00)=((obj_t)BgL_vz00_3453),BUNSPEC);} 

}



/* &lambda1856 */
obj_t BGl_z62lambda1856z62zz__evaluate_typesz00(obj_t BgL_envz00_3454, obj_t BgL_oz00_3455)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3455)))->BgL_varsz00);} 

}



/* &<@anonymous:1842> */
obj_t BGl_z62zc3z04anonymousza31842ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3456, obj_t BgL_new1154z00_3457)
{
{ /* Eval/evaluate_types.scm 105 */
{ 
BgL_ev_letrecz00_bglt BgL_auxz00_4681;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1154z00_3457))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1154z00_3457))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4688;
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_classz00_3858;
BgL_classz00_3858 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL__ortest_1281z00_3859;
BgL__ortest_1281z00_3859 = 
BGL_CLASS_NIL(BgL_classz00_3858); 
if(
CBOOL(BgL__ortest_1281z00_3859))
{ /* Eval/evaluate_types.scm 105 */
BgL_auxz00_4688 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3859)
; }  else 
{ /* Eval/evaluate_types.scm 105 */
BgL_auxz00_4688 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3858))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1154z00_3457))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4688),BUNSPEC); } 
BgL_auxz00_4681 = 
((BgL_ev_letrecz00_bglt)BgL_new1154z00_3457); 
return 
((obj_t)BgL_auxz00_4681);} } 

}



/* &lambda1840 */
BgL_ev_letrecz00_bglt BGl_z62lambda1840z62zz__evaluate_typesz00(obj_t BgL_envz00_3458)
{
{ /* Eval/evaluate_types.scm 105 */
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1153z00_3860;
BgL_new1153z00_3860 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 105 */
long BgL_arg1841z00_3861;
BgL_arg1841z00_3861 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1153z00_3860), BgL_arg1841z00_3861); } 
return BgL_new1153z00_3860;} } 

}



/* &lambda1838 */
BgL_ev_letrecz00_bglt BGl_z62lambda1838z62zz__evaluate_typesz00(obj_t BgL_envz00_3459, obj_t BgL_vars1150z00_3460, obj_t BgL_vals1151z00_3461, obj_t BgL_body1152z00_3462)
{
{ /* Eval/evaluate_types.scm 105 */
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1234z00_3863;
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1233z00_3864;
BgL_new1233z00_3864 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 105 */
long BgL_arg1839z00_3865;
BgL_arg1839z00_3865 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1233z00_3864), BgL_arg1839z00_3865); } 
BgL_new1234z00_3863 = BgL_new1233z00_3864; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1234z00_3863)))->BgL_varsz00)=((obj_t)BgL_vars1150z00_3460),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1234z00_3863)))->BgL_valsz00)=((obj_t)BgL_vals1151z00_3461),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1234z00_3863)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1152z00_3462)),BUNSPEC); 
return BgL_new1234z00_3863;} } 

}



/* &<@anonymous:1825> */
obj_t BGl_z62zc3z04anonymousza31825ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3463, obj_t BgL_new1148z00_3464)
{
{ /* Eval/evaluate_types.scm 103 */
{ 
BgL_ev_letza2za2_bglt BgL_auxz00_4715;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3464))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3464))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4722;
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_classz00_3867;
BgL_classz00_3867 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL__ortest_1281z00_3868;
BgL__ortest_1281z00_3868 = 
BGL_CLASS_NIL(BgL_classz00_3867); 
if(
CBOOL(BgL__ortest_1281z00_3868))
{ /* Eval/evaluate_types.scm 103 */
BgL_auxz00_4722 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3868)
; }  else 
{ /* Eval/evaluate_types.scm 103 */
BgL_auxz00_4722 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3867))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3464))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4722),BUNSPEC); } 
((((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3464)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4715 = 
((BgL_ev_letza2za2_bglt)BgL_new1148z00_3464); 
return 
((obj_t)BgL_auxz00_4715);} } 

}



/* &lambda1823 */
BgL_ev_letza2za2_bglt BGl_z62lambda1823z62zz__evaluate_typesz00(obj_t BgL_envz00_3465)
{
{ /* Eval/evaluate_types.scm 103 */
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1147z00_3869;
BgL_new1147z00_3869 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate_types.scm 103 */
long BgL_arg1824z00_3870;
BgL_arg1824z00_3870 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1147z00_3869), BgL_arg1824z00_3870); } 
return BgL_new1147z00_3869;} } 

}



/* &lambda1821 */
BgL_ev_letza2za2_bglt BGl_z62lambda1821z62zz__evaluate_typesz00(obj_t BgL_envz00_3466, obj_t BgL_vars1143z00_3467, obj_t BgL_vals1144z00_3468, obj_t BgL_body1145z00_3469, obj_t BgL_boxes1146z00_3470)
{
{ /* Eval/evaluate_types.scm 103 */
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1232z00_3872;
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1231z00_3873;
BgL_new1231z00_3873 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate_types.scm 103 */
long BgL_arg1822z00_3874;
BgL_arg1822z00_3874 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1231z00_3873), BgL_arg1822z00_3874); } 
BgL_new1232z00_3872 = BgL_new1231z00_3873; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1232z00_3872)))->BgL_varsz00)=((obj_t)BgL_vars1143z00_3467),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1232z00_3872)))->BgL_valsz00)=((obj_t)BgL_vals1144z00_3468),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1232z00_3872)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1145z00_3469)),BUNSPEC); 
((((BgL_ev_letza2za2_bglt)COBJECT(BgL_new1232z00_3872))->BgL_boxesz00)=((obj_t)BgL_boxes1146z00_3470),BUNSPEC); 
return BgL_new1232z00_3872;} } 

}



/* &<@anonymous:1832> */
obj_t BGl_z62zc3z04anonymousza31832ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3471)
{
{ /* Eval/evaluate_types.scm 103 */
return BNIL;} 

}



/* &lambda1831 */
obj_t BGl_z62lambda1831z62zz__evaluate_typesz00(obj_t BgL_envz00_3472, obj_t BgL_oz00_3473, obj_t BgL_vz00_3474)
{
{ /* Eval/evaluate_types.scm 103 */
return 
((((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_oz00_3473)))->BgL_boxesz00)=((obj_t)BgL_vz00_3474),BUNSPEC);} 

}



/* &lambda1830 */
obj_t BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t BgL_envz00_3475, obj_t BgL_oz00_3476)
{
{ /* Eval/evaluate_types.scm 103 */
return 
(((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_oz00_3476)))->BgL_boxesz00);} 

}



/* &<@anonymous:1808> */
obj_t BGl_z62zc3z04anonymousza31808ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3477, obj_t BgL_new1141z00_3478)
{
{ /* Eval/evaluate_types.scm 101 */
{ 
BgL_ev_letz00_bglt BgL_auxz00_4756;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1141z00_3478))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1141z00_3478))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4763;
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_classz00_3878;
BgL_classz00_3878 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL__ortest_1281z00_3879;
BgL__ortest_1281z00_3879 = 
BGL_CLASS_NIL(BgL_classz00_3878); 
if(
CBOOL(BgL__ortest_1281z00_3879))
{ /* Eval/evaluate_types.scm 101 */
BgL_auxz00_4763 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3879)
; }  else 
{ /* Eval/evaluate_types.scm 101 */
BgL_auxz00_4763 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3878))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1141z00_3478))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4763),BUNSPEC); } 
((((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_new1141z00_3478)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4756 = 
((BgL_ev_letz00_bglt)BgL_new1141z00_3478); 
return 
((obj_t)BgL_auxz00_4756);} } 

}



/* &lambda1806 */
BgL_ev_letz00_bglt BGl_z62lambda1806z62zz__evaluate_typesz00(obj_t BgL_envz00_3479)
{
{ /* Eval/evaluate_types.scm 101 */
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1140z00_3880;
BgL_new1140z00_3880 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 101 */
long BgL_arg1807z00_3881;
BgL_arg1807z00_3881 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_3880), BgL_arg1807z00_3881); } 
return BgL_new1140z00_3880;} } 

}



/* &lambda1804 */
BgL_ev_letz00_bglt BGl_z62lambda1804z62zz__evaluate_typesz00(obj_t BgL_envz00_3480, obj_t BgL_vars1136z00_3481, obj_t BgL_vals1137z00_3482, obj_t BgL_body1138z00_3483, obj_t BgL_boxes1139z00_3484)
{
{ /* Eval/evaluate_types.scm 101 */
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1230z00_3883;
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1229z00_3884;
BgL_new1229z00_3884 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 101 */
long BgL_arg1805z00_3885;
BgL_arg1805z00_3885 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1229z00_3884), BgL_arg1805z00_3885); } 
BgL_new1230z00_3883 = BgL_new1229z00_3884; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1230z00_3883)))->BgL_varsz00)=((obj_t)BgL_vars1136z00_3481),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1230z00_3883)))->BgL_valsz00)=((obj_t)BgL_vals1137z00_3482),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1230z00_3883)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1138z00_3483)),BUNSPEC); 
((((BgL_ev_letz00_bglt)COBJECT(BgL_new1230z00_3883))->BgL_boxesz00)=((obj_t)BgL_boxes1139z00_3484),BUNSPEC); 
return BgL_new1230z00_3883;} } 

}



/* &<@anonymous:1815> */
obj_t BGl_z62zc3z04anonymousza31815ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3485)
{
{ /* Eval/evaluate_types.scm 101 */
return BNIL;} 

}



/* &lambda1814 */
obj_t BGl_z62lambda1814z62zz__evaluate_typesz00(obj_t BgL_envz00_3486, obj_t BgL_oz00_3487, obj_t BgL_vz00_3488)
{
{ /* Eval/evaluate_types.scm 101 */
return 
((((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_oz00_3487)))->BgL_boxesz00)=((obj_t)BgL_vz00_3488),BUNSPEC);} 

}



/* &lambda1813 */
obj_t BGl_z62lambda1813z62zz__evaluate_typesz00(obj_t BgL_envz00_3489, obj_t BgL_oz00_3490)
{
{ /* Eval/evaluate_types.scm 101 */
return 
(((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_oz00_3490)))->BgL_boxesz00);} 

}



/* &<@anonymous:1782> */
obj_t BGl_z62zc3z04anonymousza31782ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3491, obj_t BgL_new1134z00_3492)
{
{ /* Eval/evaluate_types.scm 97 */
{ 
BgL_ev_binderz00_bglt BgL_auxz00_4797;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1134z00_3492)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1134z00_3492)))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4802;
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_classz00_3889;
BgL_classz00_3889 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL__ortest_1281z00_3890;
BgL__ortest_1281z00_3890 = 
BGL_CLASS_NIL(BgL_classz00_3889); 
if(
CBOOL(BgL__ortest_1281z00_3890))
{ /* Eval/evaluate_types.scm 97 */
BgL_auxz00_4802 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3890)
; }  else 
{ /* Eval/evaluate_types.scm 97 */
BgL_auxz00_4802 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3889))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1134z00_3492)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4802),BUNSPEC); } 
BgL_auxz00_4797 = 
((BgL_ev_binderz00_bglt)BgL_new1134z00_3492); 
return 
((obj_t)BgL_auxz00_4797);} } 

}



/* &lambda1780 */
BgL_ev_binderz00_bglt BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t BgL_envz00_3493)
{
{ /* Eval/evaluate_types.scm 97 */
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1133z00_3891;
BgL_new1133z00_3891 = 
((BgL_ev_binderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_binderz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 97 */
long BgL_arg1781z00_3892;
BgL_arg1781z00_3892 = 
BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1133z00_3891), BgL_arg1781z00_3892); } 
return BgL_new1133z00_3891;} } 

}



/* &lambda1778 */
BgL_ev_binderz00_bglt BGl_z62lambda1778z62zz__evaluate_typesz00(obj_t BgL_envz00_3494, obj_t BgL_vars1130z00_3495, obj_t BgL_vals1131z00_3496, obj_t BgL_body1132z00_3497)
{
{ /* Eval/evaluate_types.scm 97 */
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1228z00_3894;
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1227z00_3895;
BgL_new1227z00_3895 = 
((BgL_ev_binderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_binderz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 97 */
long BgL_arg1779z00_3896;
BgL_arg1779z00_3896 = 
BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1227z00_3895), BgL_arg1779z00_3896); } 
BgL_new1228z00_3894 = BgL_new1227z00_3895; } 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1228z00_3894))->BgL_varsz00)=((obj_t)BgL_vars1130z00_3495),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1228z00_3894))->BgL_valsz00)=((obj_t)BgL_vals1131z00_3496),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1228z00_3894))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1132z00_3497)),BUNSPEC); 
return BgL_new1228z00_3894;} } 

}



/* &lambda1797 */
obj_t BGl_z62lambda1797z62zz__evaluate_typesz00(obj_t BgL_envz00_3498, obj_t BgL_oz00_3499, obj_t BgL_vz00_3500)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3499)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3500)),BUNSPEC);} 

}



/* &lambda1796 */
BgL_ev_exprz00_bglt BGl_z62lambda1796z62zz__evaluate_typesz00(obj_t BgL_envz00_3501, obj_t BgL_oz00_3502)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3502)))->BgL_bodyz00);} 

}



/* &lambda1792 */
obj_t BGl_z62lambda1792z62zz__evaluate_typesz00(obj_t BgL_envz00_3503, obj_t BgL_oz00_3504, obj_t BgL_vz00_3505)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3504)))->BgL_valsz00)=((obj_t)BgL_vz00_3505),BUNSPEC);} 

}



/* &lambda1791 */
obj_t BGl_z62lambda1791z62zz__evaluate_typesz00(obj_t BgL_envz00_3506, obj_t BgL_oz00_3507)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3507)))->BgL_valsz00);} 

}



/* &lambda1787 */
obj_t BGl_z62lambda1787z62zz__evaluate_typesz00(obj_t BgL_envz00_3508, obj_t BgL_oz00_3509, obj_t BgL_vz00_3510)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3509)))->BgL_varsz00)=((obj_t)BgL_vz00_3510),BUNSPEC);} 

}



/* &lambda1786 */
obj_t BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t BgL_envz00_3511, obj_t BgL_oz00_3512)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3512)))->BgL_varsz00);} 

}



/* &<@anonymous:1752> */
obj_t BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3513, obj_t BgL_new1128z00_3514)
{
{ /* Eval/evaluate_types.scm 92 */
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_4838;
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3514)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4841;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_3905;
BgL_classz00_3905 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1281z00_3906;
BgL__ortest_1281z00_3906 = 
BGL_CLASS_NIL(BgL_classz00_3905); 
if(
CBOOL(BgL__ortest_1281z00_3906))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4841 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3906)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4841 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3905))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3514)))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4841),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4850;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_3907;
BgL_classz00_3907 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1281z00_3908;
BgL__ortest_1281z00_3908 = 
BGL_CLASS_NIL(BgL_classz00_3907); 
if(
CBOOL(BgL__ortest_1281z00_3908))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4850 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3908)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4850 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3907))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3514)))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4850),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4859;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_3909;
BgL_classz00_3909 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1281z00_3910;
BgL__ortest_1281z00_3910 = 
BGL_CLASS_NIL(BgL_classz00_3909); 
if(
CBOOL(BgL__ortest_1281z00_3910))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4859 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3910)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4859 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3909))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3514)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4859),BUNSPEC); } 
BgL_auxz00_4838 = 
((BgL_ev_synchroniza7eza7_bglt)BgL_new1128z00_3514); 
return 
((obj_t)BgL_auxz00_4838);} } 

}



/* &lambda1750 */
BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t BgL_envz00_3515)
{
{ /* Eval/evaluate_types.scm 92 */
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1127z00_3911;
BgL_new1127z00_3911 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate_types.scm 92 */
long BgL_arg1751z00_3912;
BgL_arg1751z00_3912 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1127z00_3911), BgL_arg1751z00_3912); } 
return BgL_new1127z00_3911;} } 

}



/* &lambda1748 */
BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1748z62zz__evaluate_typesz00(obj_t BgL_envz00_3516, obj_t BgL_loc1123z00_3517, obj_t BgL_mutex1124z00_3518, obj_t BgL_prelock1125z00_3519, obj_t BgL_body1126z00_3520)
{
{ /* Eval/evaluate_types.scm 92 */
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1226z00_3916;
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1225z00_3917;
BgL_new1225z00_3917 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate_types.scm 92 */
long BgL_arg1749z00_3918;
BgL_arg1749z00_3918 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1225z00_3917), BgL_arg1749z00_3918); } 
BgL_new1226z00_3916 = BgL_new1225z00_3917; } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1226z00_3916))->BgL_locz00)=((obj_t)BgL_loc1123z00_3517),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1226z00_3916))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_mutex1124z00_3518)),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1226z00_3916))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_prelock1125z00_3519)),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1226z00_3916))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1126z00_3520)),BUNSPEC); 
return BgL_new1226z00_3916;} } 

}



/* &lambda1772 */
obj_t BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t BgL_envz00_3521, obj_t BgL_oz00_3522, obj_t BgL_vz00_3523)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3522)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3523)),BUNSPEC);} 

}



/* &lambda1771 */
BgL_ev_exprz00_bglt BGl_z62lambda1771z62zz__evaluate_typesz00(obj_t BgL_envz00_3524, obj_t BgL_oz00_3525)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3525)))->BgL_bodyz00);} 

}



/* &lambda1767 */
obj_t BGl_z62lambda1767z62zz__evaluate_typesz00(obj_t BgL_envz00_3526, obj_t BgL_oz00_3527, obj_t BgL_vz00_3528)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3527)))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3528)),BUNSPEC);} 

}



/* &lambda1766 */
BgL_ev_exprz00_bglt BGl_z62lambda1766z62zz__evaluate_typesz00(obj_t BgL_envz00_3529, obj_t BgL_oz00_3530)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3530)))->BgL_prelockz00);} 

}



/* &lambda1762 */
obj_t BGl_z62lambda1762z62zz__evaluate_typesz00(obj_t BgL_envz00_3531, obj_t BgL_oz00_3532, obj_t BgL_vz00_3533)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3532)))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3533)),BUNSPEC);} 

}



/* &lambda1761 */
BgL_ev_exprz00_bglt BGl_z62lambda1761z62zz__evaluate_typesz00(obj_t BgL_envz00_3534, obj_t BgL_oz00_3535)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3535)))->BgL_mutexz00);} 

}



/* &lambda1757 */
obj_t BGl_z62lambda1757z62zz__evaluate_typesz00(obj_t BgL_envz00_3536, obj_t BgL_oz00_3537, obj_t BgL_vz00_3538)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3537)))->BgL_locz00)=((obj_t)BgL_vz00_3538),BUNSPEC);} 

}



/* &lambda1756 */
obj_t BGl_z62lambda1756z62zz__evaluate_typesz00(obj_t BgL_envz00_3539, obj_t BgL_oz00_3540)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3540)))->BgL_locz00);} 

}



/* &<@anonymous:1731> */
obj_t BGl_z62zc3z04anonymousza31731ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3541, obj_t BgL_new1121z00_3542)
{
{ /* Eval/evaluate_types.scm 89 */
{ 
BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_4904;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4905;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_classz00_3931;
BgL_classz00_3931 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL__ortest_1281z00_3932;
BgL__ortest_1281z00_3932 = 
BGL_CLASS_NIL(BgL_classz00_3931); 
if(
CBOOL(BgL__ortest_1281z00_3932))
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_4905 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3932)
; }  else 
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_4905 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3931))
; } } } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1121z00_3542)))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4905),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4914;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_classz00_3933;
BgL_classz00_3933 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL__ortest_1281z00_3934;
BgL__ortest_1281z00_3934 = 
BGL_CLASS_NIL(BgL_classz00_3933); 
if(
CBOOL(BgL__ortest_1281z00_3934))
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_4914 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3934)
; }  else 
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_4914 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3933))
; } } } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1121z00_3542)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4914),BUNSPEC); } 
BgL_auxz00_4904 = 
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1121z00_3542); 
return 
((obj_t)BgL_auxz00_4904);} } 

}



/* &lambda1729 */
BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1729z62zz__evaluate_typesz00(obj_t BgL_envz00_3543)
{
{ /* Eval/evaluate_types.scm 89 */
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1120z00_3935;
BgL_new1120z00_3935 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 89 */
long BgL_arg1730z00_3936;
BgL_arg1730z00_3936 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_3935), BgL_arg1730z00_3936); } 
return BgL_new1120z00_3935;} } 

}



/* &lambda1727 */
BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1727z62zz__evaluate_typesz00(obj_t BgL_envz00_3544, obj_t BgL_handler1118z00_3545, obj_t BgL_body1119z00_3546)
{
{ /* Eval/evaluate_types.scm 89 */
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1224z00_3939;
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1223z00_3940;
BgL_new1223z00_3940 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 89 */
long BgL_arg1728z00_3941;
BgL_arg1728z00_3941 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1223z00_3940), BgL_arg1728z00_3941); } 
BgL_new1224z00_3939 = BgL_new1223z00_3940; } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1224z00_3939))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_handler1118z00_3545)),BUNSPEC); 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1224z00_3939))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1119z00_3546)),BUNSPEC); 
return BgL_new1224z00_3939;} } 

}



/* &lambda1741 */
obj_t BGl_z62lambda1741z62zz__evaluate_typesz00(obj_t BgL_envz00_3547, obj_t BgL_oz00_3548, obj_t BgL_vz00_3549)
{
{ /* Eval/evaluate_types.scm 89 */
return 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3548)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3549)),BUNSPEC);} 

}



/* &lambda1740 */
BgL_ev_exprz00_bglt BGl_z62lambda1740z62zz__evaluate_typesz00(obj_t BgL_envz00_3550, obj_t BgL_oz00_3551)
{
{ /* Eval/evaluate_types.scm 89 */
return 
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3551)))->BgL_bodyz00);} 

}



/* &lambda1736 */
obj_t BGl_z62lambda1736z62zz__evaluate_typesz00(obj_t BgL_envz00_3552, obj_t BgL_oz00_3553, obj_t BgL_vz00_3554)
{
{ /* Eval/evaluate_types.scm 89 */
return 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3553)))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3554)),BUNSPEC);} 

}



/* &lambda1735 */
BgL_ev_exprz00_bglt BGl_z62lambda1735z62zz__evaluate_typesz00(obj_t BgL_envz00_3555, obj_t BgL_oz00_3556)
{
{ /* Eval/evaluate_types.scm 89 */
return 
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3556)))->BgL_handlerz00);} 

}



/* &<@anonymous:1711> */
obj_t BGl_z62zc3z04anonymousza31711ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3557, obj_t BgL_new1116z00_3558)
{
{ /* Eval/evaluate_types.scm 86 */
{ 
BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_4947;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4948;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_classz00_3949;
BgL_classz00_3949 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL__ortest_1281z00_3950;
BgL__ortest_1281z00_3950 = 
BGL_CLASS_NIL(BgL_classz00_3949); 
if(
CBOOL(BgL__ortest_1281z00_3950))
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_4948 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3950)
; }  else 
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_4948 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3949))
; } } } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1116z00_3558)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4948),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4957;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_classz00_3951;
BgL_classz00_3951 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL__ortest_1281z00_3952;
BgL__ortest_1281z00_3952 = 
BGL_CLASS_NIL(BgL_classz00_3951); 
if(
CBOOL(BgL__ortest_1281z00_3952))
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_4957 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3952)
; }  else 
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_4957 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3951))
; } } } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1116z00_3558)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4957),BUNSPEC); } 
BgL_auxz00_4947 = 
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1116z00_3558); 
return 
((obj_t)BgL_auxz00_4947);} } 

}



/* &lambda1709 */
BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1709z62zz__evaluate_typesz00(obj_t BgL_envz00_3559)
{
{ /* Eval/evaluate_types.scm 86 */
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1115z00_3953;
BgL_new1115z00_3953 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 86 */
long BgL_arg1710z00_3954;
BgL_arg1710z00_3954 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1115z00_3953), BgL_arg1710z00_3954); } 
return BgL_new1115z00_3953;} } 

}



/* &lambda1707 */
BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1707z62zz__evaluate_typesz00(obj_t BgL_envz00_3560, obj_t BgL_e1113z00_3561, obj_t BgL_body1114z00_3562)
{
{ /* Eval/evaluate_types.scm 86 */
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1222z00_3957;
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1221z00_3958;
BgL_new1221z00_3958 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 86 */
long BgL_arg1708z00_3959;
BgL_arg1708z00_3959 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1221z00_3958), BgL_arg1708z00_3959); } 
BgL_new1222z00_3957 = BgL_new1221z00_3958; } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1222z00_3957))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1113z00_3561)),BUNSPEC); 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1222z00_3957))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1114z00_3562)),BUNSPEC); 
return BgL_new1222z00_3957;} } 

}



/* &lambda1721 */
obj_t BGl_z62lambda1721z62zz__evaluate_typesz00(obj_t BgL_envz00_3563, obj_t BgL_oz00_3564, obj_t BgL_vz00_3565)
{
{ /* Eval/evaluate_types.scm 86 */
return 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3564)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3565)),BUNSPEC);} 

}



/* &lambda1720 */
BgL_ev_exprz00_bglt BGl_z62lambda1720z62zz__evaluate_typesz00(obj_t BgL_envz00_3566, obj_t BgL_oz00_3567)
{
{ /* Eval/evaluate_types.scm 86 */
return 
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3567)))->BgL_bodyz00);} 

}



/* &lambda1716 */
obj_t BGl_z62lambda1716z62zz__evaluate_typesz00(obj_t BgL_envz00_3568, obj_t BgL_oz00_3569, obj_t BgL_vz00_3570)
{
{ /* Eval/evaluate_types.scm 86 */
return 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3569)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3570)),BUNSPEC);} 

}



/* &lambda1715 */
BgL_ev_exprz00_bglt BGl_z62lambda1715z62zz__evaluate_typesz00(obj_t BgL_envz00_3571, obj_t BgL_oz00_3572)
{
{ /* Eval/evaluate_types.scm 86 */
return 
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3572)))->BgL_ez00);} 

}



/* &<@anonymous:1688> */
obj_t BGl_z62zc3z04anonymousza31688ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3573, obj_t BgL_new1111z00_3574)
{
{ /* Eval/evaluate_types.scm 83 */
{ 
BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_4990;
{ 
BgL_ev_varz00_bglt BgL_auxz00_4991;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_classz00_3967;
BgL_classz00_3967 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL__ortest_1281z00_3968;
BgL__ortest_1281z00_3968 = 
BGL_CLASS_NIL(BgL_classz00_3967); 
if(
CBOOL(BgL__ortest_1281z00_3968))
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_4991 = 
((BgL_ev_varz00_bglt)BgL__ortest_1281z00_3968)
; }  else 
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_4991 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3967))
; } } } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1111z00_3574)))->BgL_varz00)=((BgL_ev_varz00_bglt)BgL_auxz00_4991),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5000;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_classz00_3969;
BgL_classz00_3969 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL__ortest_1281z00_3970;
BgL__ortest_1281z00_3970 = 
BGL_CLASS_NIL(BgL_classz00_3969); 
if(
CBOOL(BgL__ortest_1281z00_3970))
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5000 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3970)
; }  else 
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5000 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3969))
; } } } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1111z00_3574)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5000),BUNSPEC); } 
BgL_auxz00_4990 = 
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1111z00_3574); 
return 
((obj_t)BgL_auxz00_4990);} } 

}



/* &lambda1684 */
BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1684z62zz__evaluate_typesz00(obj_t BgL_envz00_3575)
{
{ /* Eval/evaluate_types.scm 83 */
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1110z00_3971;
BgL_new1110z00_3971 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 83 */
long BgL_arg1687z00_3972;
BgL_arg1687z00_3972 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1110z00_3971), BgL_arg1687z00_3972); } 
return BgL_new1110z00_3971;} } 

}



/* &lambda1682 */
BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1682z62zz__evaluate_typesz00(obj_t BgL_envz00_3576, obj_t BgL_var1108z00_3577, obj_t BgL_body1109z00_3578)
{
{ /* Eval/evaluate_types.scm 83 */
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1220z00_3975;
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1219z00_3976;
BgL_new1219z00_3976 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 83 */
long BgL_arg1683z00_3977;
BgL_arg1683z00_3977 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1219z00_3976), BgL_arg1683z00_3977); } 
BgL_new1220z00_3975 = BgL_new1219z00_3976; } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1220z00_3975))->BgL_varz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_var1108z00_3577)),BUNSPEC); 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1220z00_3975))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1109z00_3578)),BUNSPEC); 
return BgL_new1220z00_3975;} } 

}



/* &lambda1699 */
obj_t BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t BgL_envz00_3579, obj_t BgL_oz00_3580, obj_t BgL_vz00_3581)
{
{ /* Eval/evaluate_types.scm 83 */
return 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3580)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3581)),BUNSPEC);} 

}



/* &lambda1698 */
BgL_ev_exprz00_bglt BGl_z62lambda1698z62zz__evaluate_typesz00(obj_t BgL_envz00_3582, obj_t BgL_oz00_3583)
{
{ /* Eval/evaluate_types.scm 83 */
return 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3583)))->BgL_bodyz00);} 

}



/* &lambda1694 */
obj_t BGl_z62lambda1694z62zz__evaluate_typesz00(obj_t BgL_envz00_3584, obj_t BgL_oz00_3585, obj_t BgL_vz00_3586)
{
{ /* Eval/evaluate_types.scm 83 */
return 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3585)))->BgL_varz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3586)),BUNSPEC);} 

}



/* &lambda1693 */
BgL_ev_varz00_bglt BGl_z62lambda1693z62zz__evaluate_typesz00(obj_t BgL_envz00_3587, obj_t BgL_oz00_3588)
{
{ /* Eval/evaluate_types.scm 83 */
return 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3588)))->BgL_varz00);} 

}



/* &<@anonymous:1672> */
obj_t BGl_z62zc3z04anonymousza31672ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3589, obj_t BgL_new1106z00_3590)
{
{ /* Eval/evaluate_types.scm 82 */
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5033;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5034;
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_classz00_3985;
BgL_classz00_3985 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL__ortest_1281z00_3986;
BgL__ortest_1281z00_3986 = 
BGL_CLASS_NIL(BgL_classz00_3985); 
if(
CBOOL(BgL__ortest_1281z00_3986))
{ /* Eval/evaluate_types.scm 82 */
BgL_auxz00_5034 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3986)
; }  else 
{ /* Eval/evaluate_types.scm 82 */
BgL_auxz00_5034 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3985))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3590))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5034),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3590))))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3590))))->BgL_namez00)=((obj_t)BGl_symbol2633z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3590))))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5033 = 
((BgL_ev_defglobalz00_bglt)BgL_new1106z00_3590); 
return 
((obj_t)BgL_auxz00_5033);} } 

}



/* &lambda1670 */
BgL_ev_defglobalz00_bglt BGl_z62lambda1670z62zz__evaluate_typesz00(obj_t BgL_envz00_3591)
{
{ /* Eval/evaluate_types.scm 82 */
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1105z00_3987;
BgL_new1105z00_3987 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 82 */
long BgL_arg1671z00_3988;
BgL_arg1671z00_3988 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_3987), BgL_arg1671z00_3988); } 
return BgL_new1105z00_3987;} } 

}



/* &lambda1668 */
BgL_ev_defglobalz00_bglt BGl_z62lambda1668z62zz__evaluate_typesz00(obj_t BgL_envz00_3592, obj_t BgL_e1101z00_3593, obj_t BgL_loc1102z00_3594, obj_t BgL_name1103z00_3595, obj_t BgL_mod1104z00_3596)
{
{ /* Eval/evaluate_types.scm 82 */
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1218z00_3991;
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1217z00_3992;
BgL_new1217z00_3992 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 82 */
long BgL_arg1669z00_3993;
BgL_arg1669z00_3993 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1217z00_3992), BgL_arg1669z00_3993); } 
BgL_new1218z00_3991 = BgL_new1217z00_3992; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1218z00_3991)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1101z00_3593)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1218z00_3991)))->BgL_locz00)=((obj_t)BgL_loc1102z00_3594),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1218z00_3991)))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1103z00_3595)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1218z00_3991)))->BgL_modz00)=((obj_t)BgL_mod1104z00_3596),BUNSPEC); 
return BgL_new1218z00_3991;} } 

}



/* &<@anonymous:1641> */
obj_t BGl_z62zc3z04anonymousza31641ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3597, obj_t BgL_new1099z00_3598)
{
{ /* Eval/evaluate_types.scm 78 */
{ 
BgL_ev_setglobalz00_bglt BgL_auxz00_5073;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5074;
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_classz00_3995;
BgL_classz00_3995 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL__ortest_1281z00_3996;
BgL__ortest_1281z00_3996 = 
BGL_CLASS_NIL(BgL_classz00_3995); 
if(
CBOOL(BgL__ortest_1281z00_3996))
{ /* Eval/evaluate_types.scm 78 */
BgL_auxz00_5074 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_3996)
; }  else 
{ /* Eval/evaluate_types.scm 78 */
BgL_auxz00_5074 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3995))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3598))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5074),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3598)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3598)))->BgL_namez00)=((obj_t)BGl_symbol2633z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3598)))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5073 = 
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3598); 
return 
((obj_t)BgL_auxz00_5073);} } 

}



/* &lambda1639 */
BgL_ev_setglobalz00_bglt BGl_z62lambda1639z62zz__evaluate_typesz00(obj_t BgL_envz00_3599)
{
{ /* Eval/evaluate_types.scm 78 */
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1098z00_3997;
BgL_new1098z00_3997 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 78 */
long BgL_arg1640z00_3998;
BgL_arg1640z00_3998 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1098z00_3997), BgL_arg1640z00_3998); } 
return BgL_new1098z00_3997;} } 

}



/* &lambda1637 */
BgL_ev_setglobalz00_bglt BGl_z62lambda1637z62zz__evaluate_typesz00(obj_t BgL_envz00_3600, obj_t BgL_e1094z00_3601, obj_t BgL_loc1095z00_3602, obj_t BgL_name1096z00_3603, obj_t BgL_mod1097z00_3604)
{
{ /* Eval/evaluate_types.scm 78 */
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1216z00_4001;
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1215z00_4002;
BgL_new1215z00_4002 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 78 */
long BgL_arg1638z00_4003;
BgL_arg1638z00_4003 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1215z00_4002), BgL_arg1638z00_4003); } 
BgL_new1216z00_4001 = BgL_new1215z00_4002; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1216z00_4001)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1094z00_3601)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1216z00_4001))->BgL_locz00)=((obj_t)BgL_loc1095z00_3602),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1216z00_4001))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1096z00_3603)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1216z00_4001))->BgL_modz00)=((obj_t)BgL_mod1097z00_3604),BUNSPEC); 
return BgL_new1216z00_4001;} } 

}



/* &lambda1657 */
obj_t BGl_z62lambda1657z62zz__evaluate_typesz00(obj_t BgL_envz00_3605, obj_t BgL_oz00_3606, obj_t BgL_vz00_3607)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3606)))->BgL_modz00)=((obj_t)BgL_vz00_3607),BUNSPEC);} 

}



/* &lambda1656 */
obj_t BGl_z62lambda1656z62zz__evaluate_typesz00(obj_t BgL_envz00_3608, obj_t BgL_oz00_3609)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3609)))->BgL_modz00);} 

}



/* &lambda1651 */
obj_t BGl_z62lambda1651z62zz__evaluate_typesz00(obj_t BgL_envz00_3610, obj_t BgL_oz00_3611, obj_t BgL_vz00_3612)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3611)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3612)),BUNSPEC);} 

}



/* &lambda1650 */
obj_t BGl_z62lambda1650z62zz__evaluate_typesz00(obj_t BgL_envz00_3613, obj_t BgL_oz00_3614)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3614)))->BgL_namez00);} 

}



/* &lambda1646 */
obj_t BGl_z62lambda1646z62zz__evaluate_typesz00(obj_t BgL_envz00_3615, obj_t BgL_oz00_3616, obj_t BgL_vz00_3617)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3616)))->BgL_locz00)=((obj_t)BgL_vz00_3617),BUNSPEC);} 

}



/* &lambda1645 */
obj_t BGl_z62lambda1645z62zz__evaluate_typesz00(obj_t BgL_envz00_3618, obj_t BgL_oz00_3619)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3619)))->BgL_locz00);} 

}



/* &<@anonymous:1626> */
obj_t BGl_z62zc3z04anonymousza31626ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3620, obj_t BgL_new1092z00_3621)
{
{ /* Eval/evaluate_types.scm 76 */
{ 
BgL_ev_setlocalz00_bglt BgL_auxz00_5120;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5121;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_classz00_4012;
BgL_classz00_4012 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL__ortest_1281z00_4013;
BgL__ortest_1281z00_4013 = 
BGL_CLASS_NIL(BgL_classz00_4012); 
if(
CBOOL(BgL__ortest_1281z00_4013))
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5121 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4013)
; }  else 
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5121 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4012))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3621))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5121),BUNSPEC); } 
{ 
BgL_ev_varz00_bglt BgL_auxz00_5131;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_classz00_4014;
BgL_classz00_4014 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL__ortest_1281z00_4015;
BgL__ortest_1281z00_4015 = 
BGL_CLASS_NIL(BgL_classz00_4014); 
if(
CBOOL(BgL__ortest_1281z00_4015))
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5131 = 
((BgL_ev_varz00_bglt)BgL__ortest_1281z00_4015)
; }  else 
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5131 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4014))
; } } } 
((((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3621)))->BgL_vz00)=((BgL_ev_varz00_bglt)BgL_auxz00_5131),BUNSPEC); } 
BgL_auxz00_5120 = 
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3621); 
return 
((obj_t)BgL_auxz00_5120);} } 

}



/* &lambda1624 */
BgL_ev_setlocalz00_bglt BGl_z62lambda1624z62zz__evaluate_typesz00(obj_t BgL_envz00_3622)
{
{ /* Eval/evaluate_types.scm 76 */
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1091z00_4016;
BgL_new1091z00_4016 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 76 */
long BgL_arg1625z00_4017;
BgL_arg1625z00_4017 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1091z00_4016), BgL_arg1625z00_4017); } 
return BgL_new1091z00_4016;} } 

}



/* &lambda1622 */
BgL_ev_setlocalz00_bglt BGl_z62lambda1622z62zz__evaluate_typesz00(obj_t BgL_envz00_3623, obj_t BgL_e1089z00_3624, obj_t BgL_v1090z00_3625)
{
{ /* Eval/evaluate_types.scm 76 */
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1214z00_4020;
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1213z00_4021;
BgL_new1213z00_4021 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 76 */
long BgL_arg1623z00_4022;
BgL_arg1623z00_4022 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1213z00_4021), BgL_arg1623z00_4022); } 
BgL_new1214z00_4020 = BgL_new1213z00_4021; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1214z00_4020)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1089z00_3624)),BUNSPEC); 
((((BgL_ev_setlocalz00_bglt)COBJECT(BgL_new1214z00_4020))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_v1090z00_3625)),BUNSPEC); 
return BgL_new1214z00_4020;} } 

}



/* &lambda1631 */
obj_t BGl_z62lambda1631z62zz__evaluate_typesz00(obj_t BgL_envz00_3626, obj_t BgL_oz00_3627, obj_t BgL_vz00_3628)
{
{ /* Eval/evaluate_types.scm 76 */
return 
((((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_oz00_3627)))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3628)),BUNSPEC);} 

}



/* &lambda1630 */
BgL_ev_varz00_bglt BGl_z62lambda1630z62zz__evaluate_typesz00(obj_t BgL_envz00_3629, obj_t BgL_oz00_3630)
{
{ /* Eval/evaluate_types.scm 76 */
return 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_oz00_3630)))->BgL_vz00);} 

}



/* &<@anonymous:1616> */
obj_t BGl_z62zc3z04anonymousza31616ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3631, obj_t BgL_new1087z00_3632)
{
{ /* Eval/evaluate_types.scm 75 */
{ 
BgL_ev_trapz00_bglt BgL_auxz00_5160;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5161;
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_classz00_4027;
BgL_classz00_4027 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL__ortest_1281z00_4028;
BgL__ortest_1281z00_4028 = 
BGL_CLASS_NIL(BgL_classz00_4027); 
if(
CBOOL(BgL__ortest_1281z00_4028))
{ /* Eval/evaluate_types.scm 75 */
BgL_auxz00_5161 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4028)
; }  else 
{ /* Eval/evaluate_types.scm 75 */
BgL_auxz00_5161 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4027))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_new1087z00_3632))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5161),BUNSPEC); } 
BgL_auxz00_5160 = 
((BgL_ev_trapz00_bglt)BgL_new1087z00_3632); 
return 
((obj_t)BgL_auxz00_5160);} } 

}



/* &lambda1614 */
BgL_ev_trapz00_bglt BGl_z62lambda1614z62zz__evaluate_typesz00(obj_t BgL_envz00_3633)
{
{ /* Eval/evaluate_types.scm 75 */
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1086z00_4029;
BgL_new1086z00_4029 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 75 */
long BgL_arg1615z00_4030;
BgL_arg1615z00_4030 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1086z00_4029), BgL_arg1615z00_4030); } 
return BgL_new1086z00_4029;} } 

}



/* &lambda1612 */
BgL_ev_trapz00_bglt BGl_z62lambda1612z62zz__evaluate_typesz00(obj_t BgL_envz00_3634, obj_t BgL_e1085z00_3635)
{
{ /* Eval/evaluate_types.scm 75 */
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1212z00_4032;
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1211z00_4033;
BgL_new1211z00_4033 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 75 */
long BgL_arg1613z00_4034;
BgL_arg1613z00_4034 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1211z00_4033), BgL_arg1613z00_4034); } 
BgL_new1212z00_4032 = BgL_new1211z00_4033; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1212z00_4032)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1085z00_3635)),BUNSPEC); 
return BgL_new1212z00_4032;} } 

}



/* &<@anonymous:1600> */
obj_t BGl_z62zc3z04anonymousza31600ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3636, obj_t BgL_new1083z00_3637)
{
{ /* Eval/evaluate_types.scm 73 */
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5184;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5185;
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_classz00_4036;
BgL_classz00_4036 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL__ortest_1281z00_4037;
BgL__ortest_1281z00_4037 = 
BGL_CLASS_NIL(BgL_classz00_4036); 
if(
CBOOL(BgL__ortest_1281z00_4037))
{ /* Eval/evaluate_types.scm 73 */
BgL_auxz00_5185 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4037)
; }  else 
{ /* Eval/evaluate_types.scm 73 */
BgL_auxz00_5185 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4036))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1083z00_3637)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5185),BUNSPEC); } 
BgL_auxz00_5184 = 
((BgL_ev_hookz00_bglt)BgL_new1083z00_3637); 
return 
((obj_t)BgL_auxz00_5184);} } 

}



/* &lambda1598 */
BgL_ev_hookz00_bglt BGl_z62lambda1598z62zz__evaluate_typesz00(obj_t BgL_envz00_3638)
{
{ /* Eval/evaluate_types.scm 73 */
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1082z00_4038;
BgL_new1082z00_4038 = 
((BgL_ev_hookz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_hookz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 73 */
long BgL_arg1599z00_4039;
BgL_arg1599z00_4039 = 
BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1082z00_4038), BgL_arg1599z00_4039); } 
return BgL_new1082z00_4038;} } 

}



/* &lambda1596 */
BgL_ev_hookz00_bglt BGl_z62lambda1596z62zz__evaluate_typesz00(obj_t BgL_envz00_3639, obj_t BgL_e1081z00_3640)
{
{ /* Eval/evaluate_types.scm 73 */
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1210z00_4041;
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1209z00_4042;
BgL_new1209z00_4042 = 
((BgL_ev_hookz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_hookz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 73 */
long BgL_arg1597z00_4043;
BgL_arg1597z00_4043 = 
BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1209z00_4042), BgL_arg1597z00_4043); } 
BgL_new1210z00_4041 = BgL_new1209z00_4042; } 
((((BgL_ev_hookz00_bglt)COBJECT(BgL_new1210z00_4041))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1081z00_3640)),BUNSPEC); 
return BgL_new1210z00_4041;} } 

}



/* &lambda1606 */
obj_t BGl_z62lambda1606z62zz__evaluate_typesz00(obj_t BgL_envz00_3641, obj_t BgL_oz00_3642, obj_t BgL_vz00_3643)
{
{ /* Eval/evaluate_types.scm 73 */
return 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_oz00_3642)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3643)),BUNSPEC);} 

}



/* &lambda1605 */
BgL_ev_exprz00_bglt BGl_z62lambda1605z62zz__evaluate_typesz00(obj_t BgL_envz00_3644, obj_t BgL_oz00_3645)
{
{ /* Eval/evaluate_types.scm 73 */
return 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_oz00_3645)))->BgL_ez00);} 

}



/* &<@anonymous:1577> */
obj_t BGl_z62zc3z04anonymousza31577ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3646, obj_t BgL_new1079z00_3647)
{
{ /* Eval/evaluate_types.scm 70 */
{ 
BgL_ev_prog2z00_bglt BgL_auxz00_5211;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5212;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_classz00_4048;
BgL_classz00_4048 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL__ortest_1281z00_4049;
BgL__ortest_1281z00_4049 = 
BGL_CLASS_NIL(BgL_classz00_4048); 
if(
CBOOL(BgL__ortest_1281z00_4049))
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5212 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4049)
; }  else 
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5212 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4048))
; } } } 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3647)))->BgL_e1z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5212),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5221;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_classz00_4050;
BgL_classz00_4050 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL__ortest_1281z00_4051;
BgL__ortest_1281z00_4051 = 
BGL_CLASS_NIL(BgL_classz00_4050); 
if(
CBOOL(BgL__ortest_1281z00_4051))
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5221 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4051)
; }  else 
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5221 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4050))
; } } } 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3647)))->BgL_e2z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5221),BUNSPEC); } 
BgL_auxz00_5211 = 
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3647); 
return 
((obj_t)BgL_auxz00_5211);} } 

}



/* &lambda1575 */
BgL_ev_prog2z00_bglt BGl_z62lambda1575z62zz__evaluate_typesz00(obj_t BgL_envz00_3648)
{
{ /* Eval/evaluate_types.scm 70 */
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1078z00_4052;
BgL_new1078z00_4052 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate_types.scm 70 */
long BgL_arg1576z00_4053;
BgL_arg1576z00_4053 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1078z00_4052), BgL_arg1576z00_4053); } 
return BgL_new1078z00_4052;} } 

}



/* &lambda1573 */
BgL_ev_prog2z00_bglt BGl_z62lambda1573z62zz__evaluate_typesz00(obj_t BgL_envz00_3649, obj_t BgL_e11076z00_3650, obj_t BgL_e21077z00_3651)
{
{ /* Eval/evaluate_types.scm 70 */
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1208z00_4056;
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1207z00_4057;
BgL_new1207z00_4057 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate_types.scm 70 */
long BgL_arg1574z00_4058;
BgL_arg1574z00_4058 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1207z00_4057), BgL_arg1574z00_4058); } 
BgL_new1208z00_4056 = BgL_new1207z00_4057; } 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1208z00_4056))->BgL_e1z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e11076z00_3650)),BUNSPEC); 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1208z00_4056))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e21077z00_3651)),BUNSPEC); 
return BgL_new1208z00_4056;} } 

}



/* &lambda1588 */
obj_t BGl_z62lambda1588z62zz__evaluate_typesz00(obj_t BgL_envz00_3652, obj_t BgL_oz00_3653, obj_t BgL_vz00_3654)
{
{ /* Eval/evaluate_types.scm 70 */
return 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3653)))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3654)),BUNSPEC);} 

}



/* &lambda1587 */
BgL_ev_exprz00_bglt BGl_z62lambda1587z62zz__evaluate_typesz00(obj_t BgL_envz00_3655, obj_t BgL_oz00_3656)
{
{ /* Eval/evaluate_types.scm 70 */
return 
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3656)))->BgL_e2z00);} 

}



/* &lambda1583 */
obj_t BGl_z62lambda1583z62zz__evaluate_typesz00(obj_t BgL_envz00_3657, obj_t BgL_oz00_3658, obj_t BgL_vz00_3659)
{
{ /* Eval/evaluate_types.scm 70 */
return 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3658)))->BgL_e1z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3659)),BUNSPEC);} 

}



/* &lambda1582 */
BgL_ev_exprz00_bglt BGl_z62lambda1582z62zz__evaluate_typesz00(obj_t BgL_envz00_3660, obj_t BgL_oz00_3661)
{
{ /* Eval/evaluate_types.scm 70 */
return 
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3661)))->BgL_e1z00);} 

}



/* &<@anonymous:1565> */
obj_t BGl_z62zc3z04anonymousza31565ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3662, obj_t BgL_new1074z00_3663)
{
{ /* Eval/evaluate_types.scm 69 */
{ 
BgL_ev_andz00_bglt BgL_auxz00_5254;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_new1074z00_3663))))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5254 = 
((BgL_ev_andz00_bglt)BgL_new1074z00_3663); 
return 
((obj_t)BgL_auxz00_5254);} } 

}



/* &lambda1563 */
BgL_ev_andz00_bglt BGl_z62lambda1563z62zz__evaluate_typesz00(obj_t BgL_envz00_3664)
{
{ /* Eval/evaluate_types.scm 69 */
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1073z00_4066;
BgL_new1073z00_4066 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 69 */
long BgL_arg1564z00_4067;
BgL_arg1564z00_4067 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_4066), BgL_arg1564z00_4067); } 
return BgL_new1073z00_4066;} } 

}



/* &lambda1559 */
BgL_ev_andz00_bglt BGl_z62lambda1559z62zz__evaluate_typesz00(obj_t BgL_envz00_3665, obj_t BgL_args1072z00_3666)
{
{ /* Eval/evaluate_types.scm 69 */
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1206z00_4068;
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1205z00_4069;
BgL_new1205z00_4069 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 69 */
long BgL_arg1562z00_4070;
BgL_arg1562z00_4070 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1205z00_4069), BgL_arg1562z00_4070); } 
BgL_new1206z00_4068 = BgL_new1205z00_4069; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1206z00_4068)))->BgL_argsz00)=((obj_t)BgL_args1072z00_3666),BUNSPEC); 
return BgL_new1206z00_4068;} } 

}



/* &<@anonymous:1549> */
obj_t BGl_z62zc3z04anonymousza31549ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3667, obj_t BgL_new1070z00_3668)
{
{ /* Eval/evaluate_types.scm 68 */
{ 
BgL_ev_orz00_bglt BgL_auxz00_5270;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_new1070z00_3668))))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5270 = 
((BgL_ev_orz00_bglt)BgL_new1070z00_3668); 
return 
((obj_t)BgL_auxz00_5270);} } 

}



/* &lambda1547 */
BgL_ev_orz00_bglt BGl_z62lambda1547z62zz__evaluate_typesz00(obj_t BgL_envz00_3669)
{
{ /* Eval/evaluate_types.scm 68 */
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1069z00_4072;
BgL_new1069z00_4072 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 68 */
long BgL_arg1548z00_4073;
BgL_arg1548z00_4073 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1069z00_4072), BgL_arg1548z00_4073); } 
return BgL_new1069z00_4072;} } 

}



/* &lambda1545 */
BgL_ev_orz00_bglt BGl_z62lambda1545z62zz__evaluate_typesz00(obj_t BgL_envz00_3670, obj_t BgL_args1068z00_3671)
{
{ /* Eval/evaluate_types.scm 68 */
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1204z00_4074;
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1203z00_4075;
BgL_new1203z00_4075 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 68 */
long BgL_arg1546z00_4076;
BgL_arg1546z00_4076 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1203z00_4075), BgL_arg1546z00_4076); } 
BgL_new1204z00_4074 = BgL_new1203z00_4075; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1204z00_4074)))->BgL_argsz00)=((obj_t)BgL_args1068z00_3671),BUNSPEC); 
return BgL_new1204z00_4074;} } 

}



/* &<@anonymous:1530> */
obj_t BGl_z62zc3z04anonymousza31530ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3672, obj_t BgL_new1066z00_3673)
{
{ /* Eval/evaluate_types.scm 66 */
{ 
BgL_ev_listz00_bglt BgL_auxz00_5286;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1066z00_3673)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5286 = 
((BgL_ev_listz00_bglt)BgL_new1066z00_3673); 
return 
((obj_t)BgL_auxz00_5286);} } 

}



/* &lambda1528 */
BgL_ev_listz00_bglt BGl_z62lambda1528z62zz__evaluate_typesz00(obj_t BgL_envz00_3674)
{
{ /* Eval/evaluate_types.scm 66 */
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1065z00_4078;
BgL_new1065z00_4078 = 
((BgL_ev_listz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_listz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 66 */
long BgL_arg1529z00_4079;
BgL_arg1529z00_4079 = 
BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1065z00_4078), BgL_arg1529z00_4079); } 
return BgL_new1065z00_4078;} } 

}



/* &lambda1526 */
BgL_ev_listz00_bglt BGl_z62lambda1526z62zz__evaluate_typesz00(obj_t BgL_envz00_3675, obj_t BgL_args1064z00_3676)
{
{ /* Eval/evaluate_types.scm 66 */
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1202z00_4080;
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1201z00_4081;
BgL_new1201z00_4081 = 
((BgL_ev_listz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_listz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 66 */
long BgL_arg1527z00_4082;
BgL_arg1527z00_4082 = 
BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1201z00_4081), BgL_arg1527z00_4082); } 
BgL_new1202z00_4080 = BgL_new1201z00_4081; } 
((((BgL_ev_listz00_bglt)COBJECT(BgL_new1202z00_4080))->BgL_argsz00)=((obj_t)BgL_args1064z00_3676),BUNSPEC); 
return BgL_new1202z00_4080;} } 

}



/* &lambda1537 */
obj_t BGl_z62lambda1537z62zz__evaluate_typesz00(obj_t BgL_envz00_3677, obj_t BgL_oz00_3678, obj_t BgL_vz00_3679)
{
{ /* Eval/evaluate_types.scm 66 */
return 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_oz00_3678)))->BgL_argsz00)=((obj_t)BgL_vz00_3679),BUNSPEC);} 

}



/* &lambda1536 */
obj_t BGl_z62lambda1536z62zz__evaluate_typesz00(obj_t BgL_envz00_3680, obj_t BgL_oz00_3681)
{
{ /* Eval/evaluate_types.scm 66 */
return 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_oz00_3681)))->BgL_argsz00);} 

}



/* &<@anonymous:1504> */
obj_t BGl_z62zc3z04anonymousza31504ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3682, obj_t BgL_new1062z00_3683)
{
{ /* Eval/evaluate_types.scm 62 */
{ 
BgL_ev_ifz00_bglt BgL_auxz00_5304;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5305;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4086;
BgL_classz00_4086 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1281z00_4087;
BgL__ortest_1281z00_4087 = 
BGL_CLASS_NIL(BgL_classz00_4086); 
if(
CBOOL(BgL__ortest_1281z00_4087))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5305 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4087)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5305 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4086))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3683)))->BgL_pz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5305),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5314;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4088;
BgL_classz00_4088 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1281z00_4089;
BgL__ortest_1281z00_4089 = 
BGL_CLASS_NIL(BgL_classz00_4088); 
if(
CBOOL(BgL__ortest_1281z00_4089))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5314 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4089)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5314 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4088))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3683)))->BgL_tz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5314),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5323;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4090;
BgL_classz00_4090 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1281z00_4091;
BgL__ortest_1281z00_4091 = 
BGL_CLASS_NIL(BgL_classz00_4090); 
if(
CBOOL(BgL__ortest_1281z00_4091))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5323 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1281z00_4091)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5323 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4090))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3683)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5323),BUNSPEC); } 
BgL_auxz00_5304 = 
((BgL_ev_ifz00_bglt)BgL_new1062z00_3683); 
return 
((obj_t)BgL_auxz00_5304);} } 

}



/* &lambda1502 */
BgL_ev_ifz00_bglt BGl_z62lambda1502z62zz__evaluate_typesz00(obj_t BgL_envz00_3684)
{
{ /* Eval/evaluate_types.scm 62 */
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1061z00_4092;
BgL_new1061z00_4092 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 62 */
long BgL_arg1503z00_4093;
BgL_arg1503z00_4093 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1061z00_4092), BgL_arg1503z00_4093); } 
return BgL_new1061z00_4092;} } 

}



/* &lambda1499 */
BgL_ev_ifz00_bglt BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t BgL_envz00_3685, obj_t BgL_p1058z00_3686, obj_t BgL_t1059z00_3687, obj_t BgL_e1060z00_3688)
{
{ /* Eval/evaluate_types.scm 62 */
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1200z00_4097;
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1199z00_4098;
BgL_new1199z00_4098 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 62 */
long BgL_arg1501z00_4099;
BgL_arg1501z00_4099 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1199z00_4098), BgL_arg1501z00_4099); } 
BgL_new1200z00_4097 = BgL_new1199z00_4098; } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1200z00_4097))->BgL_pz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_p1058z00_3686)),BUNSPEC); 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1200z00_4097))->BgL_tz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_t1059z00_3687)),BUNSPEC); 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1200z00_4097))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1060z00_3688)),BUNSPEC); 
return BgL_new1200z00_4097;} } 

}



/* &lambda1519 */
obj_t BGl_z62lambda1519z62zz__evaluate_typesz00(obj_t BgL_envz00_3689, obj_t BgL_oz00_3690, obj_t BgL_vz00_3691)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3690)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3691)),BUNSPEC);} 

}



/* &lambda1518 */
BgL_ev_exprz00_bglt BGl_z62lambda1518z62zz__evaluate_typesz00(obj_t BgL_envz00_3692, obj_t BgL_oz00_3693)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3693)))->BgL_ez00);} 

}



/* &lambda1514 */
obj_t BGl_z62lambda1514z62zz__evaluate_typesz00(obj_t BgL_envz00_3694, obj_t BgL_oz00_3695, obj_t BgL_vz00_3696)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3695)))->BgL_tz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3696)),BUNSPEC);} 

}



/* &lambda1513 */
BgL_ev_exprz00_bglt BGl_z62lambda1513z62zz__evaluate_typesz00(obj_t BgL_envz00_3697, obj_t BgL_oz00_3698)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3698)))->BgL_tz00);} 

}



/* &lambda1509 */
obj_t BGl_z62lambda1509z62zz__evaluate_typesz00(obj_t BgL_envz00_3699, obj_t BgL_oz00_3700, obj_t BgL_vz00_3701)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3700)))->BgL_pz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3701)),BUNSPEC);} 

}



/* &lambda1508 */
BgL_ev_exprz00_bglt BGl_z62lambda1508z62zz__evaluate_typesz00(obj_t BgL_envz00_3702, obj_t BgL_oz00_3703)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3703)))->BgL_pz00);} 

}



/* &<@anonymous:1488> */
obj_t BGl_z62zc3z04anonymousza31488ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3704, obj_t BgL_new1056z00_3705)
{
{ /* Eval/evaluate_types.scm 60 */
{ 
BgL_ev_littz00_bglt BgL_auxz00_5363;
((((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_new1056z00_3705)))->BgL_valuez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5363 = 
((BgL_ev_littz00_bglt)BgL_new1056z00_3705); 
return 
((obj_t)BgL_auxz00_5363);} } 

}



/* &lambda1486 */
BgL_ev_littz00_bglt BGl_z62lambda1486z62zz__evaluate_typesz00(obj_t BgL_envz00_3706)
{
{ /* Eval/evaluate_types.scm 60 */
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1055z00_4110;
BgL_new1055z00_4110 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 60 */
long BgL_arg1487z00_4111;
BgL_arg1487z00_4111 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1055z00_4110), BgL_arg1487z00_4111); } 
return BgL_new1055z00_4110;} } 

}



/* &lambda1483 */
BgL_ev_littz00_bglt BGl_z62lambda1483z62zz__evaluate_typesz00(obj_t BgL_envz00_3707, obj_t BgL_value1054z00_3708)
{
{ /* Eval/evaluate_types.scm 60 */
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1198z00_4112;
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1197z00_4113;
BgL_new1197z00_4113 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 60 */
long BgL_arg1485z00_4114;
BgL_arg1485z00_4114 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1197z00_4113), BgL_arg1485z00_4114); } 
BgL_new1198z00_4112 = BgL_new1197z00_4113; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1198z00_4112))->BgL_valuez00)=((obj_t)BgL_value1054z00_3708),BUNSPEC); 
return BgL_new1198z00_4112;} } 

}



/* &lambda1493 */
obj_t BGl_z62lambda1493z62zz__evaluate_typesz00(obj_t BgL_envz00_3709, obj_t BgL_oz00_3710, obj_t BgL_vz00_3711)
{
{ /* Eval/evaluate_types.scm 60 */
return 
((((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_oz00_3710)))->BgL_valuez00)=((obj_t)BgL_vz00_3711),BUNSPEC);} 

}



/* &lambda1492 */
obj_t BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t BgL_envz00_3712, obj_t BgL_oz00_3713)
{
{ /* Eval/evaluate_types.scm 60 */
return 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_oz00_3713)))->BgL_valuez00);} 

}



/* &<@anonymous:1462> */
obj_t BGl_z62zc3z04anonymousza31462ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3714, obj_t BgL_new1052z00_3715)
{
{ /* Eval/evaluate_types.scm 55 */
{ 
BgL_ev_globalz00_bglt BgL_auxz00_5381;
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1052z00_3715)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1052z00_3715)))->BgL_namez00)=((obj_t)BGl_symbol2633z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1052z00_3715)))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5381 = 
((BgL_ev_globalz00_bglt)BgL_new1052z00_3715); 
return 
((obj_t)BgL_auxz00_5381);} } 

}



/* &lambda1460 */
BgL_ev_globalz00_bglt BGl_z62lambda1460z62zz__evaluate_typesz00(obj_t BgL_envz00_3716)
{
{ /* Eval/evaluate_types.scm 55 */
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1051z00_4118;
BgL_new1051z00_4118 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 55 */
long BgL_arg1461z00_4119;
BgL_arg1461z00_4119 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1051z00_4118), BgL_arg1461z00_4119); } 
return BgL_new1051z00_4118;} } 

}



/* &lambda1458 */
BgL_ev_globalz00_bglt BGl_z62lambda1458z62zz__evaluate_typesz00(obj_t BgL_envz00_3717, obj_t BgL_loc1048z00_3718, obj_t BgL_name1049z00_3719, obj_t BgL_mod1050z00_3720)
{
{ /* Eval/evaluate_types.scm 55 */
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1196z00_4121;
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1195z00_4122;
BgL_new1195z00_4122 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 55 */
long BgL_arg1459z00_4123;
BgL_arg1459z00_4123 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1195z00_4122), BgL_arg1459z00_4123); } 
BgL_new1196z00_4121 = BgL_new1195z00_4122; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1196z00_4121))->BgL_locz00)=((obj_t)BgL_loc1048z00_3718),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1196z00_4121))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1049z00_3719)),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1196z00_4121))->BgL_modz00)=((obj_t)BgL_mod1050z00_3720),BUNSPEC); 
return BgL_new1196z00_4121;} } 

}



/* &lambda1477 */
obj_t BGl_z62lambda1477z62zz__evaluate_typesz00(obj_t BgL_envz00_3721, obj_t BgL_oz00_3722, obj_t BgL_vz00_3723)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3722)))->BgL_modz00)=((obj_t)BgL_vz00_3723),BUNSPEC);} 

}



/* &lambda1476 */
obj_t BGl_z62lambda1476z62zz__evaluate_typesz00(obj_t BgL_envz00_3724, obj_t BgL_oz00_3725)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3725)))->BgL_modz00);} 

}



/* &lambda1472 */
obj_t BGl_z62lambda1472z62zz__evaluate_typesz00(obj_t BgL_envz00_3726, obj_t BgL_oz00_3727, obj_t BgL_vz00_3728)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3727)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3728)),BUNSPEC);} 

}



/* &lambda1471 */
obj_t BGl_z62lambda1471z62zz__evaluate_typesz00(obj_t BgL_envz00_3729, obj_t BgL_oz00_3730)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3730)))->BgL_namez00);} 

}



/* &lambda1467 */
obj_t BGl_z62lambda1467z62zz__evaluate_typesz00(obj_t BgL_envz00_3731, obj_t BgL_oz00_3732, obj_t BgL_vz00_3733)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3732)))->BgL_locz00)=((obj_t)BgL_vz00_3733),BUNSPEC);} 

}



/* &lambda1466 */
obj_t BGl_z62lambda1466z62zz__evaluate_typesz00(obj_t BgL_envz00_3734, obj_t BgL_oz00_3735)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3735)))->BgL_locz00);} 

}



/* &<@anonymous:1435> */
obj_t BGl_z62zc3z04anonymousza31435ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3736, obj_t BgL_new1046z00_3737)
{
{ /* Eval/evaluate_types.scm 51 */
{ 
BgL_ev_varz00_bglt BgL_auxz00_5415;
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1046z00_3737)))->BgL_namez00)=((obj_t)BGl_symbol2633z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1046z00_3737)))->BgL_effz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1046z00_3737)))->BgL_typez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5415 = 
((BgL_ev_varz00_bglt)BgL_new1046z00_3737); 
return 
((obj_t)BgL_auxz00_5415);} } 

}



/* &lambda1432 */
BgL_ev_varz00_bglt BGl_z62lambda1432z62zz__evaluate_typesz00(obj_t BgL_envz00_3738)
{
{ /* Eval/evaluate_types.scm 51 */
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1045z00_4132;
BgL_new1045z00_4132 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 51 */
long BgL_arg1434z00_4133;
BgL_arg1434z00_4133 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1045z00_4132), BgL_arg1434z00_4133); } 
return BgL_new1045z00_4132;} } 

}



/* &lambda1430 */
BgL_ev_varz00_bglt BGl_z62lambda1430z62zz__evaluate_typesz00(obj_t BgL_envz00_3739, obj_t BgL_name1042z00_3740, obj_t BgL_eff1043z00_3741, obj_t BgL_type1044z00_3742)
{
{ /* Eval/evaluate_types.scm 51 */
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1194z00_4135;
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1193z00_4136;
BgL_new1193z00_4136 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 51 */
long BgL_arg1431z00_4137;
BgL_arg1431z00_4137 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1193z00_4136), BgL_arg1431z00_4137); } 
BgL_new1194z00_4135 = BgL_new1193z00_4136; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1194z00_4135))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1042z00_3740)),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1194z00_4135))->BgL_effz00)=((obj_t)BgL_eff1043z00_3741),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1194z00_4135))->BgL_typez00)=((obj_t)BgL_type1044z00_3742),BUNSPEC); 
return BgL_new1194z00_4135;} } 

}



/* &lambda1452 */
obj_t BGl_z62lambda1452z62zz__evaluate_typesz00(obj_t BgL_envz00_3743, obj_t BgL_oz00_3744, obj_t BgL_vz00_3745)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3744)))->BgL_typez00)=((obj_t)BgL_vz00_3745),BUNSPEC);} 

}



/* &lambda1451 */
obj_t BGl_z62lambda1451z62zz__evaluate_typesz00(obj_t BgL_envz00_3746, obj_t BgL_oz00_3747)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3747)))->BgL_typez00);} 

}



/* &<@anonymous:1447> */
obj_t BGl_z62zc3z04anonymousza31447ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3748)
{
{ /* Eval/evaluate_types.scm 51 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1446 */
obj_t BGl_z62lambda1446z62zz__evaluate_typesz00(obj_t BgL_envz00_3749, obj_t BgL_oz00_3750, obj_t BgL_vz00_3751)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3750)))->BgL_effz00)=((obj_t)BgL_vz00_3751),BUNSPEC);} 

}



/* &lambda1445 */
obj_t BGl_z62lambda1445z62zz__evaluate_typesz00(obj_t BgL_envz00_3752, obj_t BgL_oz00_3753)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3753)))->BgL_effz00);} 

}



/* &lambda1440 */
obj_t BGl_z62lambda1440z62zz__evaluate_typesz00(obj_t BgL_envz00_3754, obj_t BgL_oz00_3755, obj_t BgL_vz00_3756)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3755)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3756)),BUNSPEC);} 

}



/* &lambda1439 */
obj_t BGl_z62lambda1439z62zz__evaluate_typesz00(obj_t BgL_envz00_3757, obj_t BgL_oz00_3758)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3758)))->BgL_namez00);} 

}



/* &<@anonymous:1424> */
obj_t BGl_z62zc3z04anonymousza31424ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3759, obj_t BgL_new1040z00_3760)
{
{ /* Eval/evaluate_types.scm 49 */
return 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_new1040z00_3760));} 

}



/* &lambda1422 */
BgL_ev_exprz00_bglt BGl_z62lambda1422z62zz__evaluate_typesz00(obj_t BgL_envz00_3761)
{
{ /* Eval/evaluate_types.scm 49 */
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1039z00_4146;
BgL_new1039z00_4146 = 
((BgL_ev_exprz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_exprz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 49 */
long BgL_arg1423z00_4147;
BgL_arg1423z00_4147 = 
BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1039z00_4146), BgL_arg1423z00_4147); } 
return BgL_new1039z00_4146;} } 

}



/* &lambda1420 */
BgL_ev_exprz00_bglt BGl_z62lambda1420z62zz__evaluate_typesz00(obj_t BgL_envz00_3762)
{
{ /* Eval/evaluate_types.scm 49 */
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1192z00_4148;
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1191z00_4149;
BgL_new1191z00_4149 = 
((BgL_ev_exprz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_exprz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 49 */
long BgL_arg1421z00_4150;
BgL_arg1421z00_4150 = 
BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1191z00_4149), BgL_arg1421z00_4150); } 
BgL_new1192z00_4148 = BgL_new1191z00_4149; } 
return BgL_new1192z00_4148;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046086), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)483454155), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)70989603), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135276775), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218210), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267792), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519932), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)368666432), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936801), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439353001), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)479579181), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967693), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68574988), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)169532048), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057797), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155843), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198620800), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309430), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519430), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460262918), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-44273703), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614678), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927882), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151370), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)190905450), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540577), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00)); 
return 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988580), 
BSTRING_TO_STRING(BGl_string2310z00zz__evaluate_typesz00));} 

}

#ifdef __cplusplus
}
#endif
