/*===========================================================================*/
/*   (Eval/evaluate.scm)                                                     */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate.scm -indent -o objs/obj_u/Eval/evaluate.c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	extern obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
	extern obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	extern obj_t BGl_evmodulez00zz__evmodulez00(obj_t, obj_t);
	static obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t);
	static obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, bool_t);
	extern obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_classzd2fieldzd2typez00zz__objectz00(obj_t);
	static obj_t BGl_symbol2900z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2902z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2904z00zz__evaluatez00 = BUNSPEC;
	extern bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
	static obj_t BGl_symbol2906z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2908z00zz__evaluatez00 = BUNSPEC;
	static BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern BgL_ev_exprz00_bglt
		BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_expandz00zz__expandz00(obj_t);
	static obj_t BGl_symbol2910z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2912z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t);
	static obj_t BGl_symbol2914z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_symbol2916z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2918z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t,
		obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	extern bool_t BGl_classzf3zf3zz__objectz00(obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	static obj_t BGl_symbol2920z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2922z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2924z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2926z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t);
	static obj_t BGl_symbol2928z00zz__evaluatez00 = BUNSPEC;
	extern int bgl_debug();
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_keyword2979z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	static obj_t BGl_symbol2930z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2932z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2934z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_symbol2936z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2938z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluatez00();
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	extern obj_t bgl_reverse(obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluatez00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_classzd2existszd2zz__objectz00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	static obj_t BGl_symbol2940z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2942z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2946z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00();
	static obj_t BGl_symbol2948z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2868z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_gczd2rootszd2initz00zz__evaluatez00();
	extern int BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	static obj_t BGl_objectzd2initzd2zz__evaluatez00();
	extern bool_t BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_symbol2951z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2953z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2955z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2957z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2876z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	static obj_t BGl_symbol2959z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2878z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, bool_t);
	static obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_symbol2961z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2880z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2881z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2963z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2883z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2965z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2885z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2967z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2887z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2969z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2889z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_findzd2classzd2fieldz00zz__objectz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31369ze3ze5zz__evaluatez00(obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	extern obj_t BGl_getzd2sourcezd2locationz00zz__readerz00(obj_t);
	static obj_t BGl_symbol2971z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_evaluate2z00zz__evaluatez00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2891z00zz__evaluatez00 = BUNSPEC;
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_symbol2973z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2893z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2975z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2894z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2977z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2896z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2898z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t
		BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(obj_t,
		obj_t, bool_t);
	static obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
	extern obj_t BGl_classzd2fieldzd2mutatorz00zz__objectz00(obj_t);
	extern obj_t make_vector(long, obj_t);
	extern obj_t c_substring(obj_t, long, long);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	extern obj_t BGl_evalzd2findzd2modulez00zz__evmodulez00(obj_t);
	static obj_t BGl_symbol2981z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2983z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t,
		obj_t);
	extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int);
	extern obj_t BGl_evcompilezd2errorzd2zz__evcompilez00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluatez00();
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	static obj_t BGl_loopze70ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_loopze71ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t bstring_to_keyword(obj_t);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
	extern obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_convz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, bool_t);
	extern obj_t BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t,
		obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STRING(BGl_string2921z00zz__evaluatez00,
		BgL_bgl_string2921za700za7za7_2988za7, "o", 1);
	      DEFINE_STRING(BGl_string2923z00zz__evaluatez00,
		BgL_bgl_string2923za700za7za7_2989za7, "quote", 5);
	      DEFINE_STRING(BGl_string2925z00zz__evaluatez00,
		BgL_bgl_string2925za700za7za7_2990za7, "class-exists", 12);
	      DEFINE_STRING(BGl_string2927z00zz__evaluatez00,
		BgL_bgl_string2927za700za7za7_2991za7, "c", 1);
	      DEFINE_STRING(BGl_string2929z00zz__evaluatez00,
		BgL_bgl_string2929za700za7za7_2992za7, "isa?", 4);
	      DEFINE_STRING(BGl_string2931z00zz__evaluatez00,
		BgL_bgl_string2931za700za7za7_2993za7, "if", 2);
	      DEFINE_STRING(BGl_string2933z00zz__evaluatez00,
		BgL_bgl_string2933za700za7za7_2994za7, "let", 3);
	      DEFINE_STRING(BGl_string2935z00zz__evaluatez00,
		BgL_bgl_string2935za700za7za7_2995za7, "lambda", 6);
	      DEFINE_STRING(BGl_string2937z00zz__evaluatez00,
		BgL_bgl_string2937za700za7za7_2996za7, "bigloo-type-error/location", 26);
	      DEFINE_STRING(BGl_string2939z00zz__evaluatez00,
		BgL_bgl_string2939za700za7za7_2997za7, "bigloo-type-error", 17);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_evaluate2zd2restorezd2bpz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762evaluate2za7d2r2998z00,
		BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_setzd2evaluationzd2contextz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762setza7d2evaluat2999z00,
		BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2941z00zz__evaluatez00,
		BgL_bgl_string2941za700za7za7_3000za7, "at", 2);
	      DEFINE_STRING(BGl_string2943z00zz__evaluatez00,
		BgL_bgl_string2943za700za7za7_3001za7, "tmp", 3);
	      DEFINE_STRING(BGl_string2862z00zz__evaluatez00,
		BgL_bgl_string2862za700za7za7_3002za7, "", 0);
	      DEFINE_STRING(BGl_string2944z00zz__evaluatez00,
		BgL_bgl_string2944za700za7za7_3003za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string2863z00zz__evaluatez00,
		BgL_bgl_string2863za700za7za7_3004za7,
		"/tmp/bigloo/runtime/Eval/evaluate.scm", 37);
	      DEFINE_STRING(BGl_string2945z00zz__evaluatez00,
		BgL_bgl_string2945za700za7za7_3005za7, "Illegal form", 12);
	      DEFINE_STRING(BGl_string2864z00zz__evaluatez00,
		BgL_bgl_string2864za700za7za7_3006za7, "&evaluate2-restore-bp!", 22);
	      DEFINE_STRING(BGl_string2865z00zz__evaluatez00,
		BgL_bgl_string2865za700za7za7_3007za7, "bint", 4);
	      DEFINE_STRING(BGl_string2947z00zz__evaluatez00,
		BgL_bgl_string2947za700za7za7_3008za7, "begin", 5);
	      DEFINE_STRING(BGl_string2866z00zz__evaluatez00,
		BgL_bgl_string2866za700za7za7_3009za7, "&evaluate2-restore-state!", 25);
	      DEFINE_STRING(BGl_string2867z00zz__evaluatez00,
		BgL_bgl_string2867za700za7za7_3010za7, "vector", 6);
	      DEFINE_STRING(BGl_string2949z00zz__evaluatez00,
		BgL_bgl_string2949za700za7za7_3011za7, " ", 1);
	      DEFINE_STRING(BGl_string2869z00zz__evaluatez00,
		BgL_bgl_string2869za700za7za7_3012za7, "toplevel", 8);
	      DEFINE_STRING(BGl_string2950z00zz__evaluatez00,
		BgL_bgl_string2950za700za7za7_3013za7,
		"Illegal non toplevel module declaration", 39);
	      DEFINE_STRING(BGl_string2870z00zz__evaluatez00,
		BgL_bgl_string2870za700za7za7_3014za7, "eval", 4);
	      DEFINE_STRING(BGl_string2952z00zz__evaluatez00,
		BgL_bgl_string2952za700za7za7_3015za7, "module", 6);
	      DEFINE_STRING(BGl_string2871z00zz__evaluatez00,
		BgL_bgl_string2871za700za7za7_3016za7, "Bad syntax", 10);
	      DEFINE_STRING(BGl_string2872z00zz__evaluatez00,
		BgL_bgl_string2872za700za7za7_3017za7, "Class \"~a\" has no field \"~a\"",
		28);
	      DEFINE_STRING(BGl_string2954z00zz__evaluatez00,
		BgL_bgl_string2954za700za7za7_3018za7, "@", 1);
	      DEFINE_STRING(BGl_string2873z00zz__evaluatez00,
		BgL_bgl_string2873za700za7za7_3019za7, "Static type not a class", 23);
	      DEFINE_STRING(BGl_string2874z00zz__evaluatez00,
		BgL_bgl_string2874za700za7za7_3020za7, "Variable unbound", 16);
	      DEFINE_STRING(BGl_string2956z00zz__evaluatez00,
		BgL_bgl_string2956za700za7za7_3021za7, "->", 2);
	      DEFINE_STRING(BGl_string2875z00zz__evaluatez00,
		BgL_bgl_string2875za700za7za7_3022za7, "Field read-only", 15);
	      DEFINE_STRING(BGl_string2958z00zz__evaluatez00,
		BgL_bgl_string2958za700za7za7_3023za7, "trap", 4);
	      DEFINE_STRING(BGl_string2877z00zz__evaluatez00,
		BgL_bgl_string2877za700za7za7_3024za7, "pair", 4);
	      DEFINE_STRING(BGl_string2879z00zz__evaluatez00,
		BgL_bgl_string2879za700za7za7_3025za7, "pair?", 5);
	      DEFINE_STRING(BGl_string2960z00zz__evaluatez00,
		BgL_bgl_string2960za700za7za7_3026za7, "or", 2);
	      DEFINE_STRING(BGl_string2962z00zz__evaluatez00,
		BgL_bgl_string2962za700za7za7_3027za7, "and", 3);
	      DEFINE_STRING(BGl_string2882z00zz__evaluatez00,
		BgL_bgl_string2882za700za7za7_3028za7, "vector?", 7);
	      DEFINE_STRING(BGl_string2964z00zz__evaluatez00,
		BgL_bgl_string2964za700za7za7_3029za7, "let*", 4);
	      DEFINE_STRING(BGl_string2884z00zz__evaluatez00,
		BgL_bgl_string2884za700za7za7_3030za7, "symbol", 6);
	      DEFINE_STRING(BGl_string2966z00zz__evaluatez00,
		BgL_bgl_string2966za700za7za7_3031za7, "letrec", 6);
	      DEFINE_STRING(BGl_string2886z00zz__evaluatez00,
		BgL_bgl_string2886za700za7za7_3032za7, "symbol?", 7);
	      DEFINE_STRING(BGl_string2968z00zz__evaluatez00,
		BgL_bgl_string2968za700za7za7_3033za7, "set!", 4);
	      DEFINE_STRING(BGl_string2888z00zz__evaluatez00,
		BgL_bgl_string2888za700za7za7_3034za7, "char", 4);
	      DEFINE_STRING(BGl_string2970z00zz__evaluatez00,
		BgL_bgl_string2970za700za7za7_3035za7, "define", 6);
	      DEFINE_STRING(BGl_string2890z00zz__evaluatez00,
		BgL_bgl_string2890za700za7za7_3036za7, "char?", 5);
	      DEFINE_STRING(BGl_string2972z00zz__evaluatez00,
		BgL_bgl_string2972za700za7za7_3037za7, "bind-exit", 9);
	      DEFINE_STRING(BGl_string2892z00zz__evaluatez00,
		BgL_bgl_string2892za700za7za7_3038za7, "int", 3);
	      DEFINE_STRING(BGl_string2974z00zz__evaluatez00,
		BgL_bgl_string2974za700za7za7_3039za7, "unwind-protect", 14);
	      DEFINE_STRING(BGl_string2976z00zz__evaluatez00,
		BgL_bgl_string2976za700za7za7_3040za7, "with-handler", 12);
	      DEFINE_STRING(BGl_string2895z00zz__evaluatez00,
		BgL_bgl_string2895za700za7za7_3041za7, "integer?", 8);
	      DEFINE_STRING(BGl_string2978z00zz__evaluatez00,
		BgL_bgl_string2978za700za7za7_3042za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string2897z00zz__evaluatez00,
		BgL_bgl_string2897za700za7za7_3043za7, "real", 4);
	      DEFINE_STRING(BGl_string2899z00zz__evaluatez00,
		BgL_bgl_string2899za700za7za7_3044za7, "breal", 5);
	extern obj_t BGl_errorzd2envzd2zz__errorz00;
	   
		 
		DEFINE_STRING(BGl_string2980z00zz__evaluatez00,
		BgL_bgl_string2980za700za7za7_3045za7, "prelock", 7);
	      DEFINE_STRING(BGl_string2982z00zz__evaluatez00,
		BgL_bgl_string2982za700za7za7_3046za7, "\\@", 2);
	      DEFINE_STRING(BGl_string2984z00zz__evaluatez00,
		BgL_bgl_string2984za700za7za7_3047za7, "free-pragma::obj", 16);
	      DEFINE_STRING(BGl_string2985z00zz__evaluatez00,
		BgL_bgl_string2985za700za7za7_3048za7, "free-pragma", 11);
	      DEFINE_STRING(BGl_string2986z00zz__evaluatez00,
		BgL_bgl_string2986za700za7za7_3049za7, "not supported in eval", 21);
	      DEFINE_STRING(BGl_string2987z00zz__evaluatez00,
		BgL_bgl_string2987za700za7za7_3050za7, "__evaluate", 10);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_evaluate2zd2restorezd2statez12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762evaluate2za7d2r3051z00,
		BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2evaluationzd2contextzd2envzd2zz__evaluatez00,
		BgL_bgl_za762getza7d2evaluat3052z00,
		BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_evaluate2zd2envzd2zz__evaluatez00,
		BgL_bgl_za762evaluate2za762za73053za7, BGl_z62evaluate2z62zz__evaluatez00,
		0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2901z00zz__evaluatez00,
		BgL_bgl_string2901za700za7za7_3054za7, "real?", 5);
	      DEFINE_STRING(BGl_string2903z00zz__evaluatez00,
		BgL_bgl_string2903za700za7za7_3055za7, "bool", 4);
	      DEFINE_STRING(BGl_string2905z00zz__evaluatez00,
		BgL_bgl_string2905za700za7za7_3056za7, "boolean?", 8);
	      DEFINE_STRING(BGl_string2907z00zz__evaluatez00,
		BgL_bgl_string2907za700za7za7_3057za7, "struct", 6);
	      DEFINE_STRING(BGl_string2909z00zz__evaluatez00,
		BgL_bgl_string2909za700za7za7_3058za7, "struct?", 7);
	      DEFINE_STRING(BGl_string2911z00zz__evaluatez00,
		BgL_bgl_string2911za700za7za7_3059za7, "class", 5);
	      DEFINE_STRING(BGl_string2913z00zz__evaluatez00,
		BgL_bgl_string2913za700za7za7_3060za7, "class?", 6);
	      DEFINE_STRING(BGl_string2915z00zz__evaluatez00,
		BgL_bgl_string2915za700za7za7_3061za7, "string", 6);
	      DEFINE_STRING(BGl_string2917z00zz__evaluatez00,
		BgL_bgl_string2917za700za7za7_3062za7, "bstring", 7);
	      DEFINE_STRING(BGl_string2919z00zz__evaluatez00,
		BgL_bgl_string2919za700za7za7_3063za7, "string?", 7);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2900z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2902z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2904z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2906z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2908z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2910z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2912z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2914z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2916z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2918z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2920z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2922z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2924z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2926z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2928z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_keyword2979z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2930z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2932z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2934z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2936z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2938z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2940z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2942z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2946z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2948z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2868z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2951z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2953z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2955z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2957z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2876z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2959z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2878z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2961z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2880z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2881z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2963z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2883z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2965z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2885z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2967z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2887z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2969z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2889z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2971z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2891z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2973z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2893z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2975z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2894z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2977z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2896z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2898z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2981z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol2983z00zz__evaluatez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long
		BgL_checksumz00_4604, char *BgL_fromz00_4605)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluatez00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluatez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluatez00();
					BGl_cnstzd2initzd2zz__evaluatez00();
					BGl_importedzd2moduleszd2initz00zz__evaluatez00();
					return BGl_methodzd2initzd2zz__evaluatez00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			BGl_symbol2868z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2869z00zz__evaluatez00);
			BGl_symbol2876z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2877z00zz__evaluatez00);
			BGl_symbol2878z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2879z00zz__evaluatez00);
			BGl_symbol2880z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2867z00zz__evaluatez00);
			BGl_symbol2881z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2882z00zz__evaluatez00);
			BGl_symbol2883z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2884z00zz__evaluatez00);
			BGl_symbol2885z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2886z00zz__evaluatez00);
			BGl_symbol2887z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2888z00zz__evaluatez00);
			BGl_symbol2889z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2890z00zz__evaluatez00);
			BGl_symbol2891z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2892z00zz__evaluatez00);
			BGl_symbol2893z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2865z00zz__evaluatez00);
			BGl_symbol2894z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2895z00zz__evaluatez00);
			BGl_symbol2896z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2897z00zz__evaluatez00);
			BGl_symbol2898z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2899z00zz__evaluatez00);
			BGl_symbol2900z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2901z00zz__evaluatez00);
			BGl_symbol2902z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2903z00zz__evaluatez00);
			BGl_symbol2904z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2905z00zz__evaluatez00);
			BGl_symbol2906z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2907z00zz__evaluatez00);
			BGl_symbol2908z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2909z00zz__evaluatez00);
			BGl_symbol2910z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2911z00zz__evaluatez00);
			BGl_symbol2912z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2913z00zz__evaluatez00);
			BGl_symbol2914z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2915z00zz__evaluatez00);
			BGl_symbol2916z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2917z00zz__evaluatez00);
			BGl_symbol2918z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2919z00zz__evaluatez00);
			BGl_symbol2920z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2921z00zz__evaluatez00);
			BGl_symbol2922z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2923z00zz__evaluatez00);
			BGl_symbol2924z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2925z00zz__evaluatez00);
			BGl_symbol2926z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2927z00zz__evaluatez00);
			BGl_symbol2928z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2929z00zz__evaluatez00);
			BGl_symbol2930z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2931z00zz__evaluatez00);
			BGl_symbol2932z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2933z00zz__evaluatez00);
			BGl_symbol2934z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2935z00zz__evaluatez00);
			BGl_symbol2936z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2937z00zz__evaluatez00);
			BGl_symbol2938z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2939z00zz__evaluatez00);
			BGl_symbol2940z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2941z00zz__evaluatez00);
			BGl_symbol2942z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2943z00zz__evaluatez00);
			BGl_symbol2946z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2947z00zz__evaluatez00);
			BGl_symbol2948z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2949z00zz__evaluatez00);
			BGl_symbol2951z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2952z00zz__evaluatez00);
			BGl_symbol2953z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2954z00zz__evaluatez00);
			BGl_symbol2955z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2956z00zz__evaluatez00);
			BGl_symbol2957z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2958z00zz__evaluatez00);
			BGl_symbol2959z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2960z00zz__evaluatez00);
			BGl_symbol2961z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2962z00zz__evaluatez00);
			BGl_symbol2963z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2964z00zz__evaluatez00);
			BGl_symbol2965z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2966z00zz__evaluatez00);
			BGl_symbol2967z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2968z00zz__evaluatez00);
			BGl_symbol2969z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2970z00zz__evaluatez00);
			BGl_symbol2971z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2972z00zz__evaluatez00);
			BGl_symbol2973z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2974z00zz__evaluatez00);
			BGl_symbol2975z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2976z00zz__evaluatez00);
			BGl_symbol2977z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2978z00zz__evaluatez00);
			BGl_keyword2979z00zz__evaluatez00 =
				bstring_to_keyword(BGl_string2980z00zz__evaluatez00);
			BGl_symbol2981z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2982z00zz__evaluatez00);
			return (BGl_symbol2983z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2984z00zz__evaluatez00), BUNSPEC);
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_1139;

				BgL_headz00_1139 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_3141;
					obj_t BgL_tailz00_3142;

					BgL_prevz00_3141 = BgL_headz00_1139;
					BgL_tailz00_3142 = BgL_l1z00_1;
				BgL_loopz00_3140:
					if (PAIRP(BgL_tailz00_3142))
						{
							obj_t BgL_newzd2prevzd2_3148;

							BgL_newzd2prevzd2_3148 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_3142), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_3141, BgL_newzd2prevzd2_3148);
							{
								obj_t BgL_tailz00_4676;
								obj_t BgL_prevz00_4675;

								BgL_prevz00_4675 = BgL_newzd2prevzd2_3148;
								BgL_tailz00_4676 = CDR(BgL_tailz00_3142);
								BgL_tailz00_3142 = BgL_tailz00_4676;
								BgL_prevz00_3141 = BgL_prevz00_4675;
								goto BgL_loopz00_3140;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1139);
			}
		}

	}



/* untype-ident */
	obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t BgL_idz00_3)
	{
		{	/* Eval/evaluate.scm 73 */
			{	/* Eval/evaluate.scm 74 */
				obj_t BgL_stringz00_1147;

				{	/* Eval/evaluate.scm 74 */
					obj_t BgL_arg2635z00_3156;

					BgL_arg2635z00_3156 = SYMBOL_TO_STRING(BgL_idz00_3);
					BgL_stringz00_1147 =
						BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2635z00_3156);
				}
				{	/* Eval/evaluate.scm 74 */
					long BgL_lenz00_1148;

					BgL_lenz00_1148 = STRING_LENGTH(BgL_stringz00_1147);
					{	/* Eval/evaluate.scm 75 */

						{
							long BgL_walkerz00_1150;

							BgL_walkerz00_1150 = ((long) 0);
						BgL_zc3z04anonymousza31336ze3z87_1151:
							if ((BgL_walkerz00_1150 == BgL_lenz00_1148))
								{	/* Eval/evaluate.scm 78 */
									return MAKE_YOUNG_PAIR(BgL_idz00_3, BFALSE);
								}
							else
								{	/* Eval/evaluate.scm 80 */
									bool_t BgL_test3067z00_4685;

									if (
										(STRING_REF(BgL_stringz00_1147,
												BgL_walkerz00_1150) == ((unsigned char) ':')))
										{	/* Eval/evaluate.scm 80 */
											if ((BgL_walkerz00_1150 < (BgL_lenz00_1148 - ((long) 1))))
												{	/* Eval/evaluate.scm 81 */
													BgL_test3067z00_4685 =
														(STRING_REF(BgL_stringz00_1147,
															(BgL_walkerz00_1150 + ((long) 1))) ==
														((unsigned char) ':'));
												}
											else
												{	/* Eval/evaluate.scm 81 */
													BgL_test3067z00_4685 = ((bool_t) 0);
												}
										}
									else
										{	/* Eval/evaluate.scm 80 */
											BgL_test3067z00_4685 = ((bool_t) 0);
										}
									if (BgL_test3067z00_4685)
										{	/* Eval/evaluate.scm 83 */
											obj_t BgL_arg1348z00_1162;
											obj_t BgL_arg1349z00_1163;

											BgL_arg1348z00_1162 =
												bstring_to_symbol(c_substring(BgL_stringz00_1147,
													((long) 0), BgL_walkerz00_1150));
											{	/* Eval/evaluate.scm 84 */
												obj_t BgL_arg1351z00_1165;

												{	/* Eval/evaluate.scm 84 */
													long BgL_arg1353z00_1166;

													BgL_arg1353z00_1166 =
														(BgL_walkerz00_1150 + ((long) 2));
													{	/* Ieee/string.scm 190 */
														long BgL_endz00_1169;

														BgL_endz00_1169 = STRING_LENGTH(BgL_stringz00_1147);
														{	/* Ieee/string.scm 190 */

															BgL_arg1351z00_1165 =
																BGl_substringz00zz__r4_strings_6_7z00
																(BgL_stringz00_1147, BgL_arg1353z00_1166,
																BgL_endz00_1169);
												}}}
												BgL_arg1349z00_1163 =
													bstring_to_symbol(BgL_arg1351z00_1165);
											}
											return
												MAKE_YOUNG_PAIR(BgL_arg1348z00_1162,
												BgL_arg1349z00_1163);
										}
									else
										{
											long BgL_walkerz00_4702;

											BgL_walkerz00_4702 = (BgL_walkerz00_1150 + ((long) 1));
											BgL_walkerz00_1150 = BgL_walkerz00_4702;
											goto BgL_zc3z04anonymousza31336ze3z87_1151;
										}
								}
						}
					}
				}
			}
		}

	}



/* get-evaluation-context */
	BGL_EXPORTED_DEF obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 91 */
			{	/* Eval/evaluate.scm 92 */
				obj_t BgL_sz00_1178;

				BgL_sz00_1178 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 93 */
					obj_t BgL_bpz00_1179;

					BgL_bpz00_1179 = VECTOR_REF(((obj_t) BgL_sz00_1178), ((long) 0));
					{	/* Eval/evaluate.scm 94 */
						obj_t BgL_rz00_1180;

						BgL_rz00_1180 =
							make_vector(
							(long) CINT(BgL_bpz00_1179), BGl_string2862z00zz__evaluatez00);
						{
							long BgL_iz00_3188;

							BgL_iz00_3188 = ((long) 0);
						BgL_recz00_3187:
							if ((BgL_iz00_3188 < (long) CINT(BgL_bpz00_1179)))
								{	/* Eval/evaluate.scm 96 */
									{	/* Eval/evaluate.scm 97 */
										obj_t BgL_arg1362z00_3192;

										BgL_arg1362z00_3192 =
											VECTOR_REF(((obj_t) BgL_sz00_1178), BgL_iz00_3188);
										VECTOR_SET(BgL_rz00_1180, BgL_iz00_3188,
											BgL_arg1362z00_3192);
									}
									{
										long BgL_iz00_4715;

										BgL_iz00_4715 = (BgL_iz00_3188 + ((long) 1));
										BgL_iz00_3188 = BgL_iz00_4715;
										goto BgL_recz00_3187;
									}
								}
							else
								{	/* Eval/evaluate.scm 96 */
									((bool_t) 0);
								}
						}
						return BgL_rz00_1180;
					}
				}
			}
		}

	}



/* &get-evaluation-context */
	obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t
		BgL_envz00_4561)
	{
		{	/* Eval/evaluate.scm 91 */
			return BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
		}

	}



/* set-evaluation-context! */
	BGL_EXPORTED_DEF obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t BgL_vz00_4)
	{
		{	/* Eval/evaluate.scm 104 */
			{	/* Eval/evaluate.scm 105 */
				obj_t BgL_sz00_1188;

				BgL_sz00_1188 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 106 */
					obj_t BgL_bpz00_1189;

					BgL_bpz00_1189 = VECTOR_REF(((obj_t) BgL_vz00_4), ((long) 0));
					{
						long BgL_iz00_3208;

						{	/* Eval/evaluate.scm 107 */
							bool_t BgL_tmpz00_4721;

							BgL_iz00_3208 = ((long) 0);
						BgL_recz00_3207:
							if ((BgL_iz00_3208 < (long) CINT(BgL_bpz00_1189)))
								{	/* Eval/evaluate.scm 108 */
									{	/* Eval/evaluate.scm 109 */
										obj_t BgL_arg1366z00_3212;

										BgL_arg1366z00_3212 =
											VECTOR_REF(((obj_t) BgL_vz00_4), BgL_iz00_3208);
										VECTOR_SET(
											((obj_t) BgL_sz00_1188), BgL_iz00_3208,
											BgL_arg1366z00_3212);
									}
									{
										long BgL_iz00_4729;

										BgL_iz00_4729 = (BgL_iz00_3208 + ((long) 1));
										BgL_iz00_3208 = BgL_iz00_4729;
										goto BgL_recz00_3207;
									}
								}
							else
								{	/* Eval/evaluate.scm 108 */
									BgL_tmpz00_4721 = ((bool_t) 0);
								}
							return BBOOL(BgL_tmpz00_4721);
						}
					}
				}
			}
		}

	}



/* &set-evaluation-context! */
	obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t
		BgL_envz00_4562, obj_t BgL_vz00_4563)
	{
		{	/* Eval/evaluate.scm 104 */
			return BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(BgL_vz00_4563);
		}

	}



/* evaluate2-restore-bp! */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int
		BgL_bpz00_5)
	{
		{	/* Eval/evaluate.scm 115 */
			{	/* Eval/evaluate.scm 116 */
				obj_t BgL_sz00_3219;

				{	/* Eval/evaluate.scm 116 */
					obj_t BgL_tmpz00_4733;

					BgL_tmpz00_4733 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_3219 = BGL_ENV_EVSTATE(BgL_tmpz00_4733);
				}
				return
					VECTOR_SET(((obj_t) BgL_sz00_3219), ((long) 0), BINT(BgL_bpz00_5));
		}}

	}



/* &evaluate2-restore-bp! */
	obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t
		BgL_envz00_4564, obj_t BgL_bpz00_4565)
	{
		{	/* Eval/evaluate.scm 115 */
			{	/* Eval/evaluate.scm 116 */
				int BgL_auxz00_4739;

				{	/* Eval/evaluate.scm 116 */
					obj_t BgL_tmpz00_4740;

					if (INTEGERP(BgL_bpz00_4565))
						{	/* Eval/evaluate.scm 116 */
							BgL_tmpz00_4740 = BgL_bpz00_4565;
						}
					else
						{
							obj_t BgL_auxz00_4743;

							BgL_auxz00_4743 =
								BGl_typezd2errorzd2zz__errorz00
								(BGl_string2863z00zz__evaluatez00, BINT(((long) 3890)),
								BGl_string2864z00zz__evaluatez00,
								BGl_string2865z00zz__evaluatez00, BgL_bpz00_4565);
							FAILURE(BgL_auxz00_4743, BFALSE, BFALSE);
						}
					BgL_auxz00_4739 = CINT(BgL_tmpz00_4740);
				}
				return
					BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(BgL_auxz00_4739);
			}
		}

	}



/* evaluate2-restore-state! */
	BGL_EXPORTED_DEF obj_t
		BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t BgL_statez00_6)
	{
		{	/* Eval/evaluate.scm 122 */
			{	/* Eval/evaluate.scm 124 */
				obj_t BgL_tmpz00_4749;

				BgL_tmpz00_4749 = BGL_CURRENT_DYNAMIC_ENV();
				return BGL_ENV_EVSTATE_SET(BgL_tmpz00_4749, BgL_statez00_6);
			}
		}

	}



/* &evaluate2-restore-state! */
	obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t
		BgL_envz00_4566, obj_t BgL_statez00_4567)
	{
		{	/* Eval/evaluate.scm 122 */
			{	/* Eval/evaluate.scm 123 */
				obj_t BgL_auxz00_4752;

				if (VECTORP(BgL_statez00_4567))
					{	/* Eval/evaluate.scm 123 */
						BgL_auxz00_4752 = BgL_statez00_4567;
					}
				else
					{
						obj_t BgL_auxz00_4755;

						BgL_auxz00_4755 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string2863z00zz__evaluatez00,
							BINT(((long) 4240)), BGl_string2866z00zz__evaluatez00,
							BGl_string2867z00zz__evaluatez00, BgL_statez00_4567);
						FAILURE(BgL_auxz00_4755, BFALSE, BFALSE);
					}
				return
					BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(BgL_auxz00_4752);
			}
		}

	}



/* evaluate2 */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2z00zz__evaluatez00(obj_t BgL_sexpz00_7,
		obj_t BgL_envz00_8, obj_t BgL_locz00_9)
	{
		{	/* Eval/evaluate.scm 129 */
			{	/* Eval/evaluate.scm 130 */
				BgL_ev_exprz00_bglt BgL_astz00_1200;

				{	/* Eval/evaluate.scm 130 */
					obj_t BgL_arg1370z00_1210;

					BgL_arg1370z00_1210 =
						BGl_convz00zz__evaluatez00(BgL_sexpz00_7, BNIL, BgL_envz00_8,
						BFALSE, BGl_symbol2868z00zz__evaluatez00, BgL_locz00_9,
						((bool_t) 1));
					BgL_astz00_1200 =
						BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(((BgL_ev_exprz00_bglt)
							BgL_arg1370z00_1210));
				}
				BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_astz00_1200);
				{	/* Eval/evaluate.scm 132 */
					int BgL_nz00_1201;

					BgL_nz00_1201 =
						BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_astz00_1200);
					{	/* Eval/evaluate.scm 133 */
						obj_t BgL_fz00_1202;

						BgL_fz00_1202 = BGl_compilez00zz__evaluate_compz00(BgL_astz00_1200);
						{	/* Eval/evaluate.scm 134 */
							obj_t BgL_sz00_1203;

							BgL_sz00_1203 = BGl_findzd2statezd2zz__evaluate_compz00();
							{	/* Eval/evaluate.scm 135 */
								obj_t BgL_bpz00_1204;

								BgL_bpz00_1204 =
									VECTOR_REF(((obj_t) BgL_sz00_1203), ((long) 0));
								{	/* Eval/evaluate.scm 136 */
									obj_t BgL_exitd1065z00_1205;

									BgL_exitd1065z00_1205 = BGL_EXITD_TOP_AS_OBJ();
									{	/* Eval/evaluate.scm 138 */
										obj_t BgL_zc3z04anonymousza31369ze3z87_4568;

										BgL_zc3z04anonymousza31369ze3z87_4568 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31369ze3ze5zz__evaluatez00,
											(int) (((long) 0)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31369ze3z87_4568,
											(int) (((long) 0)), BgL_sz00_1203);
										PROCEDURE_SET(BgL_zc3z04anonymousza31369ze3z87_4568,
											(int) (((long) 1)), BgL_bpz00_1204);
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
											(BgL_exitd1065z00_1205,
											BgL_zc3z04anonymousza31369ze3z87_4568);
										{	/* Eval/evaluate.scm 137 */
											obj_t BgL_tmp1067z00_1207;

											BgL_tmp1067z00_1207 =
												PROCEDURE_ENTRY(BgL_fz00_1202) (BgL_fz00_1202,
												BgL_sz00_1203, BEOA);
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_exitd1065z00_1205);
											VECTOR_SET(((obj_t) BgL_sz00_1203), ((long) 0),
												BgL_bpz00_1204);
											return BgL_tmp1067z00_1207;
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* &evaluate2 */
	obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t BgL_envz00_4569,
		obj_t BgL_sexpz00_4570, obj_t BgL_envz00_4571, obj_t BgL_locz00_4572)
	{
		{	/* Eval/evaluate.scm 129 */
			return
				BGl_evaluate2z00zz__evaluatez00(BgL_sexpz00_4570, BgL_envz00_4571,
				BgL_locz00_4572);
		}

	}



/* &<@anonymous:1369> */
	obj_t BGl_z62zc3z04anonymousza31369ze3ze5zz__evaluatez00(obj_t
		BgL_envz00_4573)
	{
		{	/* Eval/evaluate.scm 136 */
			{	/* Eval/evaluate.scm 138 */
				obj_t BgL_sz00_4574;
				obj_t BgL_bpz00_4575;

				BgL_sz00_4574 = PROCEDURE_REF(BgL_envz00_4573, (int) (((long) 0)));
				BgL_bpz00_4575 = PROCEDURE_REF(BgL_envz00_4573, (int) (((long) 1)));
				return VECTOR_SET(((obj_t) BgL_sz00_4574), ((long) 0), BgL_bpz00_4575);
		}}

	}



/* get-location */
	obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t BgL_expz00_10,
		obj_t BgL_locz00_11)
	{
		{	/* Eval/evaluate.scm 143 */
			{	/* Eval/evaluate.scm 144 */
				obj_t BgL__ortest_1068z00_3226;

				BgL__ortest_1068z00_3226 =
					BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_10);
				if (CBOOL(BgL__ortest_1068z00_3226))
					{	/* Eval/evaluate.scm 144 */
						return BgL__ortest_1068z00_3226;
					}
				else
					{	/* Eval/evaluate.scm 144 */
						return BgL_locz00_11;
					}
			}
		}

	}



/* conv-var */
	obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t BgL_vz00_18,
		obj_t BgL_localsz00_19)
	{
		{	/* Eval/evaluate.scm 163 */
			{
				obj_t BgL_lz00_1215;

				BgL_lz00_1215 = BgL_localsz00_19;
			BgL_zc3z04anonymousza31371ze3z87_1216:
				if (NULLP(BgL_lz00_1215))
					{	/* Eval/evaluate.scm 165 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate.scm 167 */
						obj_t BgL_rvz00_1218;

						BgL_rvz00_1218 = CAR(((obj_t) BgL_lz00_1215));
						if (
							(BgL_vz00_18 ==
								(((BgL_ev_varz00_bglt) COBJECT(
											((BgL_ev_varz00_bglt) BgL_rvz00_1218)))->BgL_namez00)))
							{	/* Eval/evaluate.scm 169 */
								return BgL_rvz00_1218;
							}
						else
							{
								obj_t BgL_lz00_4803;

								BgL_lz00_4803 = CDR(((obj_t) BgL_lz00_1215));
								BgL_lz00_1215 = BgL_lz00_4803;
								goto BgL_zc3z04anonymousza31371ze3z87_1216;
							}
					}
			}
		}

	}



/* conv-begin */
	obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t BgL_lz00_20,
		obj_t BgL_localsz00_21, obj_t BgL_globalsz00_22, obj_t BgL_tailzf3zf3_23,
		obj_t BgL_wherez00_24, obj_t BgL_locz00_25, bool_t BgL_topzf3zf3_26)
	{
		{	/* Eval/evaluate.scm 176 */
			{	/* Eval/evaluate.scm 177 */
				obj_t BgL_locz00_1225;

				{	/* Eval/evaluate.scm 144 */
					obj_t BgL__ortest_1068z00_3231;

					BgL__ortest_1068z00_3231 =
						BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_lz00_20);
					if (CBOOL(BgL__ortest_1068z00_3231))
						{	/* Eval/evaluate.scm 144 */
							BgL_locz00_1225 = BgL__ortest_1068z00_3231;
						}
					else
						{	/* Eval/evaluate.scm 144 */
							BgL_locz00_1225 = BgL_locz00_25;
						}
				}
				{
					obj_t BgL_e1z00_1229;
					obj_t BgL_rz00_1230;

					if (NULLP(BgL_lz00_20))
						{
							BgL_ev_littz00_bglt BgL_auxz00_4811;

							{	/* Eval/evaluate.scm 180 */
								BgL_ev_littz00_bglt BgL_new1073z00_1242;

								{	/* Eval/evaluate.scm 181 */
									BgL_ev_littz00_bglt BgL_new1072z00_1243;

									BgL_new1072z00_1243 =
										((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 181 */
										long BgL_arg1386z00_1244;

										BgL_arg1386z00_1244 =
											BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1072z00_1243),
											BgL_arg1386z00_1244);
									}
									BgL_new1073z00_1242 = BgL_new1072z00_1243;
								}
								((((BgL_ev_littz00_bglt) COBJECT(BgL_new1073z00_1242))->
										BgL_valuez00) = ((obj_t) BUNSPEC), BUNSPEC);
								BgL_auxz00_4811 = BgL_new1073z00_1242;
							}
							return ((obj_t) BgL_auxz00_4811);
						}
					else
						{	/* Eval/evaluate.scm 178 */
							if (PAIRP(BgL_lz00_20))
								{	/* Eval/evaluate.scm 178 */
									if (NULLP(CDR(BgL_lz00_20)))
										{	/* Eval/evaluate.scm 178 */
											obj_t BgL_arg1382z00_1238;

											BgL_arg1382z00_1238 = CAR(BgL_lz00_20);
											{	/* Eval/evaluate.scm 183 */
												obj_t BgL_arg1387z00_3243;

												{	/* Eval/evaluate.scm 144 */
													obj_t BgL__ortest_1068z00_3244;

													BgL__ortest_1068z00_3244 =
														BGl_getzd2sourcezd2locationz00zz__readerz00
														(BgL_arg1382z00_1238);
													if (CBOOL(BgL__ortest_1068z00_3244))
														{	/* Eval/evaluate.scm 144 */
															BgL_arg1387z00_3243 = BgL__ortest_1068z00_3244;
														}
													else
														{	/* Eval/evaluate.scm 144 */
															BgL_arg1387z00_3243 = BgL_locz00_1225;
														}
												}
												return
													BGl_convz00zz__evaluatez00(BgL_arg1382z00_1238,
													BgL_localsz00_21, BgL_globalsz00_22,
													BgL_tailzf3zf3_23, BgL_wherez00_24,
													BgL_arg1387z00_3243, BgL_topzf3zf3_26);
											}
										}
									else
										{	/* Eval/evaluate.scm 178 */
											obj_t BgL_arg1383z00_1239;
											obj_t BgL_arg1384z00_1240;

											BgL_arg1383z00_1239 = CAR(BgL_lz00_20);
											BgL_arg1384z00_1240 = CDR(BgL_lz00_20);
											{
												BgL_ev_prog2z00_bglt BgL_auxz00_4830;

												BgL_e1z00_1229 = BgL_arg1383z00_1239;
												BgL_rz00_1230 = BgL_arg1384z00_1240;
												{	/* Eval/evaluate.scm 185 */
													BgL_ev_prog2z00_bglt BgL_new1075z00_1246;

													{	/* Eval/evaluate.scm 186 */
														BgL_ev_prog2z00_bglt BgL_new1074z00_1248;

														BgL_new1074z00_1248 =
															((BgL_ev_prog2z00_bglt)
															BOBJECT(GC_MALLOC(sizeof(struct
																		BgL_ev_prog2z00_bgl))));
														{	/* Eval/evaluate.scm 186 */
															long BgL_arg1389z00_1249;

															BgL_arg1389z00_1249 =
																BGL_CLASS_INDEX
																(BGl_ev_prog2z00zz__evaluate_typesz00);
															BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt)
																	BgL_new1074z00_1248), BgL_arg1389z00_1249);
														}
														BgL_new1075z00_1246 = BgL_new1074z00_1248;
													}
													{
														BgL_ev_exprz00_bglt BgL_auxz00_4835;

														{	/* Eval/evaluate.scm 186 */
															obj_t BgL_arg1388z00_1247;

															{	/* Eval/evaluate.scm 144 */
																obj_t BgL__ortest_1068z00_3240;

																BgL__ortest_1068z00_3240 =
																	BGl_getzd2sourcezd2locationz00zz__readerz00
																	(BgL_e1z00_1229);
																if (CBOOL(BgL__ortest_1068z00_3240))
																	{	/* Eval/evaluate.scm 144 */
																		BgL_arg1388z00_1247 =
																			BgL__ortest_1068z00_3240;
																	}
																else
																	{	/* Eval/evaluate.scm 144 */
																		BgL_arg1388z00_1247 = BgL_locz00_1225;
																	}
															}
															BgL_auxz00_4835 =
																((BgL_ev_exprz00_bglt)
																BGl_convz00zz__evaluatez00(BgL_e1z00_1229,
																	BgL_localsz00_21, BgL_globalsz00_22, BFALSE,
																	BgL_wherez00_24, BgL_arg1388z00_1247,
																	BgL_topzf3zf3_26));
														}
														((((BgL_ev_prog2z00_bglt)
																	COBJECT(BgL_new1075z00_1246))->BgL_e1z00) =
															((BgL_ev_exprz00_bglt) BgL_auxz00_4835), BUNSPEC);
													}
													((((BgL_ev_prog2z00_bglt)
																COBJECT(BgL_new1075z00_1246))->BgL_e2z00) =
														((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
																BGl_convzd2beginzd2zz__evaluatez00
																(BgL_rz00_1230, BgL_localsz00_21,
																	BgL_globalsz00_22, BgL_tailzf3zf3_23,
																	BgL_wherez00_24, BgL_locz00_1225,
																	BgL_topzf3zf3_26))), BUNSPEC);
													BgL_auxz00_4830 = BgL_new1075z00_1246;
												}
												return ((obj_t) BgL_auxz00_4830);
											}
										}
								}
							else
								{	/* Eval/evaluate.scm 178 */
									return
										BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_1225,
										BGl_string2870z00zz__evaluatez00,
										BGl_string2871z00zz__evaluatez00, BgL_lz00_20);
								}
						}
				}
			}
		}

	}



/* conv-field-ref */
	obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t BgL_ez00_30,
		obj_t BgL_localsz00_31, obj_t BgL_globalsz00_32, obj_t BgL_tailzf3zf3_33,
		obj_t BgL_wherez00_34, obj_t BgL_locz00_35, bool_t BgL_topzf3zf3_36)
	{
		{	/* Eval/evaluate.scm 203 */
			{	/* Eval/evaluate.scm 204 */
				obj_t BgL_lz00_1254;

				BgL_lz00_1254 = CDR(((obj_t) BgL_ez00_30));
				{	/* Eval/evaluate.scm 204 */
					obj_t BgL_vz00_1255;

					BgL_vz00_1255 =
						BGl_convzd2varzd2zz__evaluatez00(CAR(
							((obj_t) BgL_lz00_1254)), BgL_localsz00_31);
					{	/* Eval/evaluate.scm 205 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_1255,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 208 */
								obj_t BgL_g1079z00_1258;
								obj_t BgL_g1080z00_1259;

								{	/* Eval/evaluate.scm 209 */
									obj_t BgL_arg1407z00_1282;

									BgL_arg1407z00_1282 =
										(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_vz00_1255)))->BgL_typez00);
									BgL_g1079z00_1258 =
										BGl_classzd2existszd2zz__objectz00(BgL_arg1407z00_1282);
								}
								BgL_g1080z00_1259 = CDR(((obj_t) BgL_lz00_1254));
								{
									BgL_ev_exprz00_bglt BgL_nodez00_1261;
									obj_t BgL_klassz00_1262;
									obj_t BgL_fieldsz00_1263;

									BgL_nodez00_1261 =
										((BgL_ev_exprz00_bglt)
										((BgL_ev_varz00_bglt) BgL_vz00_1255));
									BgL_klassz00_1262 = BgL_g1079z00_1258;
									BgL_fieldsz00_1263 = BgL_g1080z00_1259;
								BgL_zc3z04anonymousza31393ze3z87_1264:
									if (NULLP(BgL_fieldsz00_1263))
										{	/* Eval/evaluate.scm 212 */
											return ((obj_t) BgL_nodez00_1261);
										}
									else
										{	/* Eval/evaluate.scm 212 */
											if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_1262))
												{	/* Eval/evaluate.scm 215 */
													obj_t BgL_fieldz00_1267;

													{	/* Eval/evaluate.scm 215 */
														obj_t BgL_arg1405z00_1278;

														BgL_arg1405z00_1278 =
															CAR(((obj_t) BgL_fieldsz00_1263));
														BgL_fieldz00_1267 =
															BGl_findzd2classzd2fieldz00zz__objectz00
															(BgL_klassz00_1262, BgL_arg1405z00_1278);
													}
													if (BGl_classzd2fieldzf3z21zz__objectz00
														(BgL_fieldz00_1267))
														{	/* Eval/evaluate.scm 217 */
															BgL_ev_appz00_bglt BgL_nodez00_1269;

															{	/* Eval/evaluate.scm 271 */
																obj_t BgL_getz00_3258;

																BgL_getz00_3258 =
																	BGl_classzd2fieldzd2accessorz00zz__objectz00
																	(BgL_fieldz00_1267);
																{	/* Eval/evaluate.scm 272 */
																	BgL_ev_appz00_bglt BgL_new1087z00_3259;

																	{	/* Eval/evaluate.scm 273 */
																		BgL_ev_appz00_bglt BgL_new1086z00_3260;

																		BgL_new1086z00_3260 =
																			((BgL_ev_appz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_ev_appz00_bgl))));
																		{	/* Eval/evaluate.scm 273 */
																			long BgL_arg1440z00_3261;

																			BgL_arg1440z00_3261 =
																				BGL_CLASS_INDEX
																				(BGl_ev_appz00zz__evaluate_typesz00);
																			BGL_OBJECT_CLASS_NUM_SET((
																					(BgL_objectz00_bglt)
																					BgL_new1086z00_3260),
																				BgL_arg1440z00_3261);
																		}
																		BgL_new1087z00_3259 = BgL_new1086z00_3260;
																	}
																	((((BgL_ev_appz00_bglt)
																				COBJECT(BgL_new1087z00_3259))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_35), BUNSPEC);
																	{
																		BgL_ev_exprz00_bglt BgL_auxz00_4875;

																		{	/* Eval/evaluate.scm 274 */
																			BgL_ev_littz00_bglt BgL_new1089z00_3262;

																			{	/* Eval/evaluate.scm 274 */
																				BgL_ev_littz00_bglt BgL_new1088z00_3263;

																				BgL_new1088z00_3263 =
																					((BgL_ev_littz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_ev_littz00_bgl))));
																				{	/* Eval/evaluate.scm 274 */
																					long BgL_arg1438z00_3264;

																					{	/* Eval/evaluate.scm 274 */
																						obj_t BgL_classz00_3269;

																						BgL_classz00_3269 =
																							BGl_ev_littz00zz__evaluate_typesz00;
																						BgL_arg1438z00_3264 =
																							BGL_CLASS_INDEX
																							(BgL_classz00_3269);
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1088z00_3263),
																						BgL_arg1438z00_3264);
																				}
																				BgL_new1089z00_3262 =
																					BgL_new1088z00_3263;
																			}
																			((((BgL_ev_littz00_bglt)
																						COBJECT(BgL_new1089z00_3262))->
																					BgL_valuez00) =
																				((obj_t) BgL_getz00_3258), BUNSPEC);
																			BgL_auxz00_4875 =
																				((BgL_ev_exprz00_bglt)
																				BgL_new1089z00_3262);
																		}
																		((((BgL_ev_appz00_bglt)
																					COBJECT(BgL_new1087z00_3259))->
																				BgL_funz00) =
																			((BgL_ev_exprz00_bglt) BgL_auxz00_4875),
																			BUNSPEC);
																	}
																	{
																		obj_t BgL_auxz00_4883;

																		{	/* Eval/evaluate.scm 275 */
																			obj_t BgL_list1439z00_3265;

																			BgL_list1439z00_3265 =
																				MAKE_YOUNG_PAIR(
																				((obj_t) BgL_nodez00_1261), BNIL);
																			BgL_auxz00_4883 = BgL_list1439z00_3265;
																		}
																		((((BgL_ev_appz00_bglt)
																					COBJECT(BgL_new1087z00_3259))->
																				BgL_argsz00) =
																			((obj_t) BgL_auxz00_4883), BUNSPEC);
																	}
																	((((BgL_ev_appz00_bglt)
																				COBJECT(BgL_new1087z00_3259))->
																			BgL_tailzf3zf3) =
																		((obj_t) BgL_tailzf3zf3_33), BUNSPEC);
																	BgL_nodez00_1269 = BgL_new1087z00_3259;
															}}
															{	/* Eval/evaluate.scm 220 */
																obj_t BgL_arg1397z00_1270;
																obj_t BgL_arg1398z00_1271;

																BgL_arg1397z00_1270 =
																	BGl_classzd2fieldzd2typez00zz__objectz00
																	(BgL_fieldz00_1267);
																BgL_arg1398z00_1271 =
																	CDR(((obj_t) BgL_fieldsz00_1263));
																{
																	obj_t BgL_fieldsz00_4894;
																	obj_t BgL_klassz00_4893;
																	BgL_ev_exprz00_bglt BgL_nodez00_4891;

																	BgL_nodez00_4891 =
																		((BgL_ev_exprz00_bglt) BgL_nodez00_1269);
																	BgL_klassz00_4893 = BgL_arg1397z00_1270;
																	BgL_fieldsz00_4894 = BgL_arg1398z00_1271;
																	BgL_fieldsz00_1263 = BgL_fieldsz00_4894;
																	BgL_klassz00_1262 = BgL_klassz00_4893;
																	BgL_nodez00_1261 = BgL_nodez00_4891;
																	goto BgL_zc3z04anonymousza31393ze3z87_1264;
																}
															}
														}
													else
														{	/* Eval/evaluate.scm 222 */
															obj_t BgL_arg1399z00_1272;
															obj_t BgL_arg1400z00_1273;

															BgL_arg1399z00_1272 =
																(((BgL_ev_varz00_bglt) COBJECT(
																		((BgL_ev_varz00_bglt) BgL_vz00_1255)))->
																BgL_typez00);
															{	/* Eval/evaluate.scm 223 */
																obj_t BgL_arg1401z00_1274;
																obj_t BgL_arg1402z00_1275;

																BgL_arg1401z00_1274 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1255)))->
																	BgL_typez00);
																BgL_arg1402z00_1275 =
																	CAR(((obj_t) BgL_fieldsz00_1263));
																{	/* Eval/evaluate.scm 223 */
																	obj_t BgL_list1403z00_1276;

																	{	/* Eval/evaluate.scm 223 */
																		obj_t BgL_arg1404z00_1277;

																		BgL_arg1404z00_1277 =
																			MAKE_YOUNG_PAIR(BgL_arg1402z00_1275,
																			BNIL);
																		BgL_list1403z00_1276 =
																			MAKE_YOUNG_PAIR(BgL_arg1401z00_1274,
																			BgL_arg1404z00_1277);
																	}
																	BgL_arg1400z00_1273 =
																		BGl_formatz00zz__r4_output_6_10_3z00
																		(BGl_string2872z00zz__evaluatez00,
																		BgL_list1403z00_1276);
																}
															}
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_35, BgL_arg1399z00_1272,
																BgL_arg1400z00_1273, BgL_ez00_30);
														}
												}
											else
												{	/* Eval/evaluate.scm 226 */
													obj_t BgL_arg1406z00_1279;

													{	/* Eval/evaluate.scm 226 */
														obj_t BgL__ortest_1081z00_1280;

														BgL__ortest_1081z00_1280 =
															(((BgL_ev_varz00_bglt) COBJECT(
																	((BgL_ev_varz00_bglt) BgL_vz00_1255)))->
															BgL_typez00);
														if (CBOOL(BgL__ortest_1081z00_1280))
															{	/* Eval/evaluate.scm 226 */
																BgL_arg1406z00_1279 = BgL__ortest_1081z00_1280;
															}
														else
															{	/* Eval/evaluate.scm 226 */
																BgL_arg1406z00_1279 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1255)))->
																	BgL_namez00);
															}
													}
													return
														BGl_evcompilezd2errorzd2zz__evcompilez00
														(BgL_locz00_35, BgL_arg1406z00_1279,
														BGl_string2873z00zz__evaluatez00, BgL_ez00_30);
												}
										}
								}
							}
						else
							{	/* Eval/evaluate.scm 228 */
								obj_t BgL_arg1408z00_1283;

								{	/* Eval/evaluate.scm 228 */
									obj_t BgL_pairz00_3278;

									BgL_pairz00_3278 = CDR(((obj_t) BgL_ez00_30));
									BgL_arg1408z00_1283 = CAR(BgL_pairz00_3278);
								}
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35,
									BgL_arg1408z00_1283, BGl_string2874z00zz__evaluatez00,
									BgL_ez00_30);
							}
					}
				}
			}
		}

	}



/* conv-field-set */
	obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t BgL_lz00_37,
		obj_t BgL_e2z00_38, obj_t BgL_ez00_39, obj_t BgL_localsz00_40,
		obj_t BgL_globalsz00_41, obj_t BgL_tailzf3zf3_42, obj_t BgL_wherez00_43,
		obj_t BgL_locz00_44, bool_t BgL_topzf3zf3_45)
	{
		{	/* Eval/evaluate.scm 233 */
			{	/* Eval/evaluate.scm 234 */
				obj_t BgL_vz00_1285;

				BgL_vz00_1285 =
					BGl_convzd2varzd2zz__evaluatez00(CAR(BgL_lz00_37), BgL_localsz00_40);
				{	/* Eval/evaluate.scm 234 */
					obj_t BgL_e2z00_1286;

					BgL_e2z00_1286 =
						BGl_convz00zz__evaluatez00(BgL_e2z00_38, BgL_localsz00_40,
						BgL_globalsz00_41, BFALSE, BgL_wherez00_43, BgL_locz00_44,
						((bool_t) 0));
					{	/* Eval/evaluate.scm 235 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_1285,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 238 */
								obj_t BgL_g1083z00_1289;
								obj_t BgL_g1084z00_1290;

								{	/* Eval/evaluate.scm 239 */
									obj_t BgL_arg1435z00_1321;

									BgL_arg1435z00_1321 =
										(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_vz00_1285)))->BgL_typez00);
									BgL_g1083z00_1289 =
										BGl_classzd2existszd2zz__objectz00(BgL_arg1435z00_1321);
								}
								BgL_g1084z00_1290 = CDR(BgL_lz00_37);
								{
									BgL_ev_exprz00_bglt BgL_nodez00_1292;
									obj_t BgL_klassz00_1293;
									obj_t BgL_fieldsz00_1294;

									BgL_nodez00_1292 =
										((BgL_ev_exprz00_bglt)
										((BgL_ev_varz00_bglt) BgL_vz00_1285));
									BgL_klassz00_1293 = BgL_g1083z00_1289;
									BgL_fieldsz00_1294 = BgL_g1084z00_1290;
								BgL_zc3z04anonymousza31411ze3z87_1295:
									if (NULLP(BgL_fieldsz00_1294))
										{	/* Eval/evaluate.scm 242 */
											return ((obj_t) BgL_nodez00_1292);
										}
									else
										{	/* Eval/evaluate.scm 242 */
											if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_1293))
												{	/* Eval/evaluate.scm 245 */
													obj_t BgL_fieldz00_1298;

													{	/* Eval/evaluate.scm 245 */
														obj_t BgL_arg1433z00_1317;

														BgL_arg1433z00_1317 =
															CAR(((obj_t) BgL_fieldsz00_1294));
														BgL_fieldz00_1298 =
															BGl_findzd2classzd2fieldz00zz__objectz00
															(BgL_klassz00_1293, BgL_arg1433z00_1317);
													}
													if (BGl_classzd2fieldzf3z21zz__objectz00
														(BgL_fieldz00_1298))
														{	/* Eval/evaluate.scm 246 */
															if (NULLP(CDR(((obj_t) BgL_fieldsz00_1294))))
																{	/* Eval/evaluate.scm 247 */
																	if (BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(BgL_fieldz00_1298))
																		{	/* Eval/evaluate.scm 250 */
																			obj_t BgL_arg1418z00_1303;

																			{	/* Eval/evaluate.scm 250 */
																				obj_t BgL_list1419z00_1304;

																				{	/* Eval/evaluate.scm 250 */
																					obj_t BgL_arg1420z00_1305;

																					BgL_arg1420z00_1305 =
																						MAKE_YOUNG_PAIR(BgL_e2z00_1286,
																						BNIL);
																					BgL_list1419z00_1304 =
																						MAKE_YOUNG_PAIR(((obj_t)
																							BgL_nodez00_1292),
																						BgL_arg1420z00_1305);
																				}
																				BgL_arg1418z00_1303 =
																					BgL_list1419z00_1304;
																			}
																			{	/* Eval/evaluate.scm 282 */
																				obj_t BgL_setz00_3284;

																				BgL_setz00_3284 =
																					BGl_classzd2fieldzd2mutatorz00zz__objectz00
																					(BgL_fieldz00_1298);
																				{	/* Eval/evaluate.scm 283 */
																					BgL_ev_appz00_bglt
																						BgL_new1091z00_3285;
																					{	/* Eval/evaluate.scm 284 */
																						BgL_ev_appz00_bglt
																							BgL_new1090z00_3286;
																						BgL_new1090z00_3286 =
																							((BgL_ev_appz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_appz00_bgl))));
																						{	/* Eval/evaluate.scm 284 */
																							long BgL_arg1442z00_3287;

																							BgL_arg1442z00_3287 =
																								BGL_CLASS_INDEX
																								(BGl_ev_appz00zz__evaluate_typesz00);
																							BGL_OBJECT_CLASS_NUM_SET((
																									(BgL_objectz00_bglt)
																									BgL_new1090z00_3286),
																								BgL_arg1442z00_3287);
																						}
																						BgL_new1091z00_3285 =
																							BgL_new1090z00_3286;
																					}
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1091z00_3285))->
																							BgL_locz00) =
																						((obj_t) BgL_locz00_44), BUNSPEC);
																					{
																						BgL_ev_exprz00_bglt BgL_auxz00_4952;

																						{	/* Eval/evaluate.scm 285 */
																							BgL_ev_littz00_bglt
																								BgL_new1093z00_3288;
																							{	/* Eval/evaluate.scm 285 */
																								BgL_ev_littz00_bglt
																									BgL_new1092z00_3289;
																								BgL_new1092z00_3289 =
																									((BgL_ev_littz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_littz00_bgl))));
																								{	/* Eval/evaluate.scm 285 */
																									long BgL_arg1441z00_3290;

																									{	/* Eval/evaluate.scm 285 */
																										obj_t BgL_classz00_3294;

																										BgL_classz00_3294 =
																											BGl_ev_littz00zz__evaluate_typesz00;
																										BgL_arg1441z00_3290 =
																											BGL_CLASS_INDEX
																											(BgL_classz00_3294);
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1092z00_3289),
																										BgL_arg1441z00_3290);
																								}
																								BgL_new1093z00_3288 =
																									BgL_new1092z00_3289;
																							}
																							((((BgL_ev_littz00_bglt)
																										COBJECT
																										(BgL_new1093z00_3288))->
																									BgL_valuez00) =
																								((obj_t) BgL_setz00_3284),
																								BUNSPEC);
																							BgL_auxz00_4952 =
																								((BgL_ev_exprz00_bglt)
																								BgL_new1093z00_3288);
																						}
																						((((BgL_ev_appz00_bglt)
																									COBJECT
																									(BgL_new1091z00_3285))->
																								BgL_funz00) =
																							((BgL_ev_exprz00_bglt)
																								BgL_auxz00_4952), BUNSPEC);
																					}
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1091z00_3285))->
																							BgL_argsz00) =
																						((obj_t) BgL_arg1418z00_1303),
																						BUNSPEC);
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1091z00_3285))->
																							BgL_tailzf3zf3) =
																						((obj_t) BgL_tailzf3zf3_42),
																						BUNSPEC);
																					return ((obj_t) BgL_new1091z00_3285);
																				}
																			}
																		}
																	else
																		{	/* Eval/evaluate.scm 251 */
																			obj_t BgL_arg1421z00_1306;

																			BgL_arg1421z00_1306 =
																				CAR(((obj_t) BgL_fieldsz00_1294));
																			return
																				BGl_evcompilezd2errorzd2zz__evcompilez00
																				(BgL_locz00_44, BgL_arg1421z00_1306,
																				BGl_string2875z00zz__evaluatez00,
																				BgL_ez00_39);
																		}
																}
															else
																{	/* Eval/evaluate.scm 254 */
																	BgL_ev_appz00_bglt BgL_nodez00_1307;

																	{	/* Eval/evaluate.scm 271 */
																		obj_t BgL_getz00_3298;

																		BgL_getz00_3298 =
																			BGl_classzd2fieldzd2accessorz00zz__objectz00
																			(BgL_fieldz00_1298);
																		{	/* Eval/evaluate.scm 272 */
																			BgL_ev_appz00_bglt BgL_new1087z00_3299;

																			{	/* Eval/evaluate.scm 273 */
																				BgL_ev_appz00_bglt BgL_new1086z00_3300;

																				BgL_new1086z00_3300 =
																					((BgL_ev_appz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_ev_appz00_bgl))));
																				{	/* Eval/evaluate.scm 273 */
																					long BgL_arg1440z00_3301;

																					BgL_arg1440z00_3301 =
																						BGL_CLASS_INDEX
																						(BGl_ev_appz00zz__evaluate_typesz00);
																					BGL_OBJECT_CLASS_NUM_SET((
																							(BgL_objectz00_bglt)
																							BgL_new1086z00_3300),
																						BgL_arg1440z00_3301);
																				}
																				BgL_new1087z00_3299 =
																					BgL_new1086z00_3300;
																			}
																			((((BgL_ev_appz00_bglt)
																						COBJECT(BgL_new1087z00_3299))->
																					BgL_locz00) =
																				((obj_t) BgL_locz00_44), BUNSPEC);
																			{
																				BgL_ev_exprz00_bglt BgL_auxz00_4972;

																				{	/* Eval/evaluate.scm 274 */
																					BgL_ev_littz00_bglt
																						BgL_new1089z00_3302;
																					{	/* Eval/evaluate.scm 274 */
																						BgL_ev_littz00_bglt
																							BgL_new1088z00_3303;
																						BgL_new1088z00_3303 =
																							((BgL_ev_littz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_littz00_bgl))));
																						{	/* Eval/evaluate.scm 274 */
																							long BgL_arg1438z00_3304;

																							{	/* Eval/evaluate.scm 274 */
																								obj_t BgL_classz00_3309;

																								BgL_classz00_3309 =
																									BGl_ev_littz00zz__evaluate_typesz00;
																								BgL_arg1438z00_3304 =
																									BGL_CLASS_INDEX
																									(BgL_classz00_3309);
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1088z00_3303),
																								BgL_arg1438z00_3304);
																						}
																						BgL_new1089z00_3302 =
																							BgL_new1088z00_3303;
																					}
																					((((BgL_ev_littz00_bglt)
																								COBJECT(BgL_new1089z00_3302))->
																							BgL_valuez00) =
																						((obj_t) BgL_getz00_3298), BUNSPEC);
																					BgL_auxz00_4972 =
																						((BgL_ev_exprz00_bglt)
																						BgL_new1089z00_3302);
																				}
																				((((BgL_ev_appz00_bglt)
																							COBJECT(BgL_new1087z00_3299))->
																						BgL_funz00) =
																					((BgL_ev_exprz00_bglt)
																						BgL_auxz00_4972), BUNSPEC);
																			}
																			{
																				obj_t BgL_auxz00_4980;

																				{	/* Eval/evaluate.scm 275 */
																					obj_t BgL_list1439z00_3305;

																					BgL_list1439z00_3305 =
																						MAKE_YOUNG_PAIR(
																						((obj_t) BgL_nodez00_1292), BNIL);
																					BgL_auxz00_4980 =
																						BgL_list1439z00_3305;
																				}
																				((((BgL_ev_appz00_bglt)
																							COBJECT(BgL_new1087z00_3299))->
																						BgL_argsz00) =
																					((obj_t) BgL_auxz00_4980), BUNSPEC);
																			}
																			((((BgL_ev_appz00_bglt)
																						COBJECT(BgL_new1087z00_3299))->
																					BgL_tailzf3zf3) =
																				((obj_t) BgL_tailzf3zf3_42), BUNSPEC);
																			BgL_nodez00_1307 = BgL_new1087z00_3299;
																	}}
																	{	/* Eval/evaluate.scm 257 */
																		obj_t BgL_arg1422z00_1308;
																		obj_t BgL_arg1423z00_1309;

																		BgL_arg1422z00_1308 =
																			BGl_classzd2fieldzd2typez00zz__objectz00
																			(BgL_fieldz00_1298);
																		BgL_arg1423z00_1309 =
																			CDR(((obj_t) BgL_fieldsz00_1294));
																		{
																			obj_t BgL_fieldsz00_4991;
																			obj_t BgL_klassz00_4990;
																			BgL_ev_exprz00_bglt BgL_nodez00_4988;

																			BgL_nodez00_4988 =
																				((BgL_ev_exprz00_bglt)
																				BgL_nodez00_1307);
																			BgL_klassz00_4990 = BgL_arg1422z00_1308;
																			BgL_fieldsz00_4991 = BgL_arg1423z00_1309;
																			BgL_fieldsz00_1294 = BgL_fieldsz00_4991;
																			BgL_klassz00_1293 = BgL_klassz00_4990;
																			BgL_nodez00_1292 = BgL_nodez00_4988;
																			goto
																				BgL_zc3z04anonymousza31411ze3z87_1295;
																		}
																	}
																}
														}
													else
														{	/* Eval/evaluate.scm 259 */
															obj_t BgL_arg1425z00_1311;
															obj_t BgL_arg1426z00_1312;

															BgL_arg1425z00_1311 =
																(((BgL_ev_varz00_bglt) COBJECT(
																		((BgL_ev_varz00_bglt) BgL_vz00_1285)))->
																BgL_typez00);
															{	/* Eval/evaluate.scm 260 */
																obj_t BgL_arg1429z00_1313;
																obj_t BgL_arg1430z00_1314;

																BgL_arg1429z00_1313 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1285)))->
																	BgL_typez00);
																BgL_arg1430z00_1314 =
																	CAR(((obj_t) BgL_fieldsz00_1294));
																{	/* Eval/evaluate.scm 260 */
																	obj_t BgL_list1431z00_1315;

																	{	/* Eval/evaluate.scm 260 */
																		obj_t BgL_arg1432z00_1316;

																		BgL_arg1432z00_1316 =
																			MAKE_YOUNG_PAIR(BgL_arg1430z00_1314,
																			BNIL);
																		BgL_list1431z00_1315 =
																			MAKE_YOUNG_PAIR(BgL_arg1429z00_1313,
																			BgL_arg1432z00_1316);
																	}
																	BgL_arg1426z00_1312 =
																		BGl_formatz00zz__r4_output_6_10_3z00
																		(BGl_string2872z00zz__evaluatez00,
																		BgL_list1431z00_1315);
																}
															}
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_44, BgL_arg1425z00_1311,
																BgL_arg1426z00_1312, BgL_ez00_39);
														}
												}
											else
												{	/* Eval/evaluate.scm 264 */
													obj_t BgL_arg1434z00_1318;

													{	/* Eval/evaluate.scm 264 */
														obj_t BgL__ortest_1085z00_1319;

														BgL__ortest_1085z00_1319 =
															(((BgL_ev_varz00_bglt) COBJECT(
																	((BgL_ev_varz00_bglt) BgL_vz00_1285)))->
															BgL_typez00);
														if (CBOOL(BgL__ortest_1085z00_1319))
															{	/* Eval/evaluate.scm 264 */
																BgL_arg1434z00_1318 = BgL__ortest_1085z00_1319;
															}
														else
															{	/* Eval/evaluate.scm 264 */
																BgL_arg1434z00_1318 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1285)))->
																	BgL_namez00);
															}
													}
													return
														BGl_evcompilezd2errorzd2zz__evcompilez00
														(BgL_locz00_44, BgL_arg1434z00_1318,
														BGl_string2873z00zz__evaluatez00, BgL_ez00_39);
												}
										}
								}
							}
						else
							{	/* Eval/evaluate.scm 236 */
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44,
									CAR(BgL_lz00_37), BGl_string2874z00zz__evaluatez00,
									BgL_ez00_39);
							}
					}
				}
			}
		}

	}



/* type-check */
	obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t BgL_varz00_56,
		obj_t BgL_tnamez00_57, obj_t BgL_locz00_58, obj_t BgL_procnamez00_59,
		obj_t BgL_bodyz00_60)
	{
		{	/* Eval/evaluate.scm 298 */
			if (SYMBOLP(BgL_tnamez00_57))
				{	/* Eval/evaluate.scm 301 */
					obj_t BgL_predz00_1342;

					if ((BgL_tnamez00_57 == BGl_symbol2876z00zz__evaluatez00))
						{	/* Eval/evaluate.scm 301 */
							BgL_predz00_1342 = BGl_symbol2878z00zz__evaluatez00;
						}
					else
						{	/* Eval/evaluate.scm 301 */
							if ((BgL_tnamez00_57 == BGl_symbol2880z00zz__evaluatez00))
								{	/* Eval/evaluate.scm 301 */
									BgL_predz00_1342 = BGl_symbol2881z00zz__evaluatez00;
								}
							else
								{	/* Eval/evaluate.scm 301 */
									if ((BgL_tnamez00_57 == BGl_symbol2883z00zz__evaluatez00))
										{	/* Eval/evaluate.scm 301 */
											BgL_predz00_1342 = BGl_symbol2885z00zz__evaluatez00;
										}
									else
										{	/* Eval/evaluate.scm 301 */
											if ((BgL_tnamez00_57 == BGl_symbol2887z00zz__evaluatez00))
												{	/* Eval/evaluate.scm 301 */
													BgL_predz00_1342 = BGl_symbol2889z00zz__evaluatez00;
												}
											else
												{	/* Eval/evaluate.scm 301 */
													bool_t BgL_test3100z00_5023;

													{	/* Eval/evaluate.scm 301 */
														bool_t BgL__ortest_1094z00_1418;

														BgL__ortest_1094z00_1418 =
															(BgL_tnamez00_57 ==
															BGl_symbol2891z00zz__evaluatez00);
														if (BgL__ortest_1094z00_1418)
															{	/* Eval/evaluate.scm 301 */
																BgL_test3100z00_5023 = BgL__ortest_1094z00_1418;
															}
														else
															{	/* Eval/evaluate.scm 301 */
																BgL_test3100z00_5023 =
																	(BgL_tnamez00_57 ==
																	BGl_symbol2893z00zz__evaluatez00);
															}
													}
													if (BgL_test3100z00_5023)
														{	/* Eval/evaluate.scm 301 */
															BgL_predz00_1342 =
																BGl_symbol2894z00zz__evaluatez00;
														}
													else
														{	/* Eval/evaluate.scm 301 */
															bool_t BgL_test3102z00_5027;

															{	/* Eval/evaluate.scm 301 */
																bool_t BgL__ortest_1095z00_1417;

																BgL__ortest_1095z00_1417 =
																	(BgL_tnamez00_57 ==
																	BGl_symbol2896z00zz__evaluatez00);
																if (BgL__ortest_1095z00_1417)
																	{	/* Eval/evaluate.scm 301 */
																		BgL_test3102z00_5027 =
																			BgL__ortest_1095z00_1417;
																	}
																else
																	{	/* Eval/evaluate.scm 301 */
																		BgL_test3102z00_5027 =
																			(BgL_tnamez00_57 ==
																			BGl_symbol2898z00zz__evaluatez00);
																	}
															}
															if (BgL_test3102z00_5027)
																{	/* Eval/evaluate.scm 301 */
																	BgL_predz00_1342 =
																		BGl_symbol2900z00zz__evaluatez00;
																}
															else
																{	/* Eval/evaluate.scm 301 */
																	if (
																		(BgL_tnamez00_57 ==
																			BGl_symbol2902z00zz__evaluatez00))
																		{	/* Eval/evaluate.scm 301 */
																			BgL_predz00_1342 =
																				BGl_symbol2904z00zz__evaluatez00;
																		}
																	else
																		{	/* Eval/evaluate.scm 301 */
																			if (
																				(BgL_tnamez00_57 ==
																					BGl_symbol2906z00zz__evaluatez00))
																				{	/* Eval/evaluate.scm 301 */
																					BgL_predz00_1342 =
																						BGl_symbol2908z00zz__evaluatez00;
																				}
																			else
																				{	/* Eval/evaluate.scm 301 */
																					if (
																						(BgL_tnamez00_57 ==
																							BGl_symbol2910z00zz__evaluatez00))
																						{	/* Eval/evaluate.scm 301 */
																							BgL_predz00_1342 =
																								BGl_symbol2912z00zz__evaluatez00;
																						}
																					else
																						{	/* Eval/evaluate.scm 301 */
																							bool_t BgL_test3107z00_5037;

																							{	/* Eval/evaluate.scm 301 */
																								bool_t BgL__ortest_1096z00_1416;

																								BgL__ortest_1096z00_1416 =
																									(BgL_tnamez00_57 ==
																									BGl_symbol2914z00zz__evaluatez00);
																								if (BgL__ortest_1096z00_1416)
																									{	/* Eval/evaluate.scm 301 */
																										BgL_test3107z00_5037 =
																											BgL__ortest_1096z00_1416;
																									}
																								else
																									{	/* Eval/evaluate.scm 301 */
																										BgL_test3107z00_5037 =
																											(BgL_tnamez00_57 ==
																											BGl_symbol2916z00zz__evaluatez00);
																									}
																							}
																							if (BgL_test3107z00_5037)
																								{	/* Eval/evaluate.scm 301 */
																									BgL_predz00_1342 =
																										BGl_symbol2918z00zz__evaluatez00;
																								}
																							else
																								{	/* Eval/evaluate.scm 312 */
																									obj_t BgL_arg1488z00_1396;

																									{	/* Eval/evaluate.scm 312 */
																										obj_t BgL_arg1489z00_1397;
																										obj_t BgL_arg1490z00_1398;

																										BgL_arg1489z00_1397 =
																											MAKE_YOUNG_PAIR
																											(BGl_symbol2920z00zz__evaluatez00,
																											BNIL);
																										{	/* Eval/evaluate.scm 313 */
																											obj_t BgL_arg1491z00_1399;

																											{	/* Eval/evaluate.scm 313 */
																												obj_t
																													BgL_arg1492z00_1400;
																												{	/* Eval/evaluate.scm 313 */
																													obj_t
																														BgL_arg1493z00_1401;
																													obj_t
																														BgL_arg1494z00_1402;
																													{	/* Eval/evaluate.scm 313 */
																														obj_t
																															BgL_arg1496z00_1403;
																														{	/* Eval/evaluate.scm 313 */
																															obj_t
																																BgL_arg1498z00_1404;
																															{	/* Eval/evaluate.scm 313 */
																																obj_t
																																	BgL_arg1499z00_1405;
																																{	/* Eval/evaluate.scm 313 */
																																	obj_t
																																		BgL_arg1500z00_1406;
																																	{	/* Eval/evaluate.scm 313 */
																																		obj_t
																																			BgL_arg1501z00_1407;
																																		{	/* Eval/evaluate.scm 313 */
																																			obj_t
																																				BgL_arg1502z00_1408;
																																			BgL_arg1502z00_1408
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BgL_tnamez00_57,
																																				BNIL);
																																			BgL_arg1501z00_1407
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol2922z00zz__evaluatez00,
																																				BgL_arg1502z00_1408);
																																		}
																																		BgL_arg1500z00_1406
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BgL_arg1501z00_1407,
																																			BNIL);
																																	}
																																	BgL_arg1499z00_1405
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_symbol2924z00zz__evaluatez00,
																																		BgL_arg1500z00_1406);
																																}
																																BgL_arg1498z00_1404
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_arg1499z00_1405,
																																	BNIL);
																															}
																															BgL_arg1496z00_1403
																																=
																																MAKE_YOUNG_PAIR
																																(BGl_symbol2926z00zz__evaluatez00,
																																BgL_arg1498z00_1404);
																														}
																														BgL_arg1493z00_1401
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1496z00_1403,
																															BNIL);
																													}
																													{	/* Eval/evaluate.scm 314 */
																														obj_t
																															BgL_arg1503z00_1409;
																														{	/* Eval/evaluate.scm 314 */
																															obj_t
																																BgL_arg1504z00_1410;
																															{	/* Eval/evaluate.scm 314 */
																																obj_t
																																	BgL_arg1505z00_1411;
																																{	/* Eval/evaluate.scm 314 */
																																	obj_t
																																		BgL_arg1506z00_1412;
																																	obj_t
																																		BgL_arg1507z00_1413;
																																	{	/* Eval/evaluate.scm 314 */
																																		obj_t
																																			BgL_arg1508z00_1414;
																																		{	/* Eval/evaluate.scm 314 */
																																			obj_t
																																				BgL_arg1509z00_1415;
																																			BgL_arg1509z00_1415
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol2926z00zz__evaluatez00,
																																				BNIL);
																																			BgL_arg1508z00_1414
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol2920z00zz__evaluatez00,
																																				BgL_arg1509z00_1415);
																																		}
																																		BgL_arg1506z00_1412
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BGl_symbol2928z00zz__evaluatez00,
																																			BgL_arg1508z00_1414);
																																	}
																																	BgL_arg1507z00_1413
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BTRUE,
																																		BNIL);
																																	BgL_arg1505z00_1411
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_arg1506z00_1412,
																																		BgL_arg1507z00_1413);
																																}
																																BgL_arg1504z00_1410
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BGl_symbol2926z00zz__evaluatez00,
																																	BgL_arg1505z00_1411);
																															}
																															BgL_arg1503z00_1409
																																=
																																MAKE_YOUNG_PAIR
																																(BGl_symbol2930z00zz__evaluatez00,
																																BgL_arg1504z00_1410);
																														}
																														BgL_arg1494z00_1402
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1503z00_1409,
																															BNIL);
																													}
																													BgL_arg1492z00_1400 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg1493z00_1401,
																														BgL_arg1494z00_1402);
																												}
																												BgL_arg1491z00_1399 =
																													MAKE_YOUNG_PAIR
																													(BGl_symbol2932z00zz__evaluatez00,
																													BgL_arg1492z00_1400);
																											}
																											BgL_arg1490z00_1398 =
																												MAKE_YOUNG_PAIR
																												(BgL_arg1491z00_1399,
																												BNIL);
																										}
																										BgL_arg1488z00_1396 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1489z00_1397,
																											BgL_arg1490z00_1398);
																									}
																									BgL_predz00_1342 =
																										MAKE_YOUNG_PAIR
																										(BGl_symbol2934z00zz__evaluatez00,
																										BgL_arg1488z00_1396);
																								}
																						}
																				}
																		}
																}
														}
												}
										}
								}
						}
					{	/* Eval/evaluate.scm 316 */
						obj_t BgL_arg1446z00_1343;

						{	/* Eval/evaluate.scm 316 */
							obj_t BgL_arg1447z00_1344;

							{	/* Eval/evaluate.scm 316 */
								obj_t BgL_arg1448z00_1345;
								obj_t BgL_arg1449z00_1346;

								{	/* Eval/evaluate.scm 316 */
									obj_t BgL_arg1450z00_1347;

									BgL_arg1450z00_1347 = MAKE_YOUNG_PAIR(BgL_varz00_56, BNIL);
									BgL_arg1448z00_1345 =
										MAKE_YOUNG_PAIR(BgL_predz00_1342, BgL_arg1450z00_1347);
								}
								{	/* Eval/evaluate.scm 316 */
									obj_t BgL_arg1451z00_1348;

									{	/* Eval/evaluate.scm 316 */
										obj_t BgL_arg1452z00_1349;

										{
											obj_t BgL_fnamez00_1350;
											obj_t BgL_posz00_1351;

											if (PAIRP(BgL_locz00_58))
												{	/* Eval/evaluate.scm 316 */
													obj_t BgL_cdrzd2138zd2_1356;

													BgL_cdrzd2138zd2_1356 = CDR(BgL_locz00_58);
													if (
														(CAR(BgL_locz00_58) ==
															BGl_symbol2940z00zz__evaluatez00))
														{	/* Eval/evaluate.scm 316 */
															if (PAIRP(BgL_cdrzd2138zd2_1356))
																{	/* Eval/evaluate.scm 316 */
																	obj_t BgL_cdrzd2142zd2_1360;

																	BgL_cdrzd2142zd2_1360 =
																		CDR(BgL_cdrzd2138zd2_1356);
																	if (PAIRP(BgL_cdrzd2142zd2_1360))
																		{	/* Eval/evaluate.scm 316 */
																			if (NULLP(CDR(BgL_cdrzd2142zd2_1360)))
																				{	/* Eval/evaluate.scm 316 */
																					BgL_fnamez00_1350 =
																						CAR(BgL_cdrzd2138zd2_1356);
																					BgL_posz00_1351 =
																						CAR(BgL_cdrzd2142zd2_1360);
																					{	/* Eval/evaluate.scm 321 */
																						obj_t BgL_arg1464z00_1368;

																						{	/* Eval/evaluate.scm 321 */
																							obj_t BgL_arg1465z00_1369;
																							obj_t BgL_arg1466z00_1370;

																							if (SYMBOLP(BgL_procnamez00_59))
																								{	/* Eval/evaluate.scm 321 */
																									obj_t BgL_arg2635z00_3357;

																									BgL_arg2635z00_3357 =
																										SYMBOL_TO_STRING
																										(BgL_procnamez00_59);
																									BgL_arg1465z00_1369 =
																										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																										(BgL_arg2635z00_3357);
																								}
																							else
																								{	/* Eval/evaluate.scm 321 */
																									BgL_arg1465z00_1369 = BFALSE;
																								}
																							{	/* Eval/evaluate.scm 322 */
																								obj_t BgL_arg1468z00_1372;
																								obj_t BgL_arg1469z00_1373;

																								{	/* Eval/evaluate.scm 322 */
																									obj_t BgL_arg2635z00_3359;

																									BgL_arg2635z00_3359 =
																										SYMBOL_TO_STRING(
																										((obj_t) BgL_tnamez00_57));
																									BgL_arg1468z00_1372 =
																										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																										(BgL_arg2635z00_3359);
																								}
																								{	/* Eval/evaluate.scm 320 */
																									obj_t BgL_arg1470z00_1374;

																									{	/* Eval/evaluate.scm 320 */
																										obj_t BgL_arg1471z00_1375;

																										BgL_arg1471z00_1375 =
																											MAKE_YOUNG_PAIR
																											(BgL_posz00_1351, BNIL);
																										BgL_arg1470z00_1374 =
																											MAKE_YOUNG_PAIR
																											(BgL_fnamez00_1350,
																											BgL_arg1471z00_1375);
																									}
																									BgL_arg1469z00_1373 =
																										MAKE_YOUNG_PAIR
																										(BgL_varz00_56,
																										BgL_arg1470z00_1374);
																								}
																								BgL_arg1466z00_1370 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1468z00_1372,
																									BgL_arg1469z00_1373);
																							}
																							BgL_arg1464z00_1368 =
																								MAKE_YOUNG_PAIR
																								(BgL_arg1465z00_1369,
																								BgL_arg1466z00_1370);
																						}
																						BgL_arg1452z00_1349 =
																							MAKE_YOUNG_PAIR
																							(BGl_symbol2936z00zz__evaluatez00,
																							BgL_arg1464z00_1368);
																					}
																				}
																			else
																				{	/* Eval/evaluate.scm 316 */
																				BgL_tagzd2131zd2_1353:
																					{	/* Eval/evaluate.scm 326 */
																						obj_t BgL_arg1472z00_1376;

																						{	/* Eval/evaluate.scm 326 */
																							obj_t BgL_arg1473z00_1377;
																							obj_t BgL_arg1474z00_1378;

																							if (SYMBOLP(BgL_procnamez00_59))
																								{	/* Eval/evaluate.scm 326 */
																									obj_t BgL_arg2635z00_3361;

																									BgL_arg2635z00_3361 =
																										SYMBOL_TO_STRING
																										(BgL_procnamez00_59);
																									BgL_arg1473z00_1377 =
																										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																										(BgL_arg2635z00_3361);
																								}
																							else
																								{	/* Eval/evaluate.scm 326 */
																									BgL_arg1473z00_1377 = BFALSE;
																								}
																							{	/* Eval/evaluate.scm 327 */
																								obj_t BgL_arg1476z00_1380;
																								obj_t BgL_arg1477z00_1381;

																								{	/* Eval/evaluate.scm 327 */
																									obj_t BgL_arg2635z00_3363;

																									BgL_arg2635z00_3363 =
																										SYMBOL_TO_STRING(
																										((obj_t) BgL_tnamez00_57));
																									BgL_arg1476z00_1380 =
																										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																										(BgL_arg2635z00_3363);
																								}
																								BgL_arg1477z00_1381 =
																									MAKE_YOUNG_PAIR(BgL_varz00_56,
																									BNIL);
																								BgL_arg1474z00_1378 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1476z00_1380,
																									BgL_arg1477z00_1381);
																							}
																							BgL_arg1472z00_1376 =
																								MAKE_YOUNG_PAIR
																								(BgL_arg1473z00_1377,
																								BgL_arg1474z00_1378);
																						}
																						BgL_arg1452z00_1349 =
																							MAKE_YOUNG_PAIR
																							(BGl_symbol2938z00zz__evaluatez00,
																							BgL_arg1472z00_1376);
																					}
																				}
																		}
																	else
																		{	/* Eval/evaluate.scm 316 */
																			goto BgL_tagzd2131zd2_1353;
																		}
																}
															else
																{	/* Eval/evaluate.scm 316 */
																	goto BgL_tagzd2131zd2_1353;
																}
														}
													else
														{	/* Eval/evaluate.scm 316 */
															goto BgL_tagzd2131zd2_1353;
														}
												}
											else
												{	/* Eval/evaluate.scm 316 */
													goto BgL_tagzd2131zd2_1353;
												}
										}
										BgL_arg1451z00_1348 =
											MAKE_YOUNG_PAIR(BgL_arg1452z00_1349, BNIL);
									}
									BgL_arg1449z00_1346 =
										MAKE_YOUNG_PAIR(BgL_bodyz00_60, BgL_arg1451z00_1348);
								}
								BgL_arg1447z00_1344 =
									MAKE_YOUNG_PAIR(BgL_arg1448z00_1345, BgL_arg1449z00_1346);
							}
							BgL_arg1446z00_1343 =
								MAKE_YOUNG_PAIR(BGl_symbol2930z00zz__evaluatez00,
								BgL_arg1447z00_1344);
						}
						{	/* Eval/evaluate.scm 293 */
							obj_t BgL_arg1443z00_3370;
							obj_t BgL_arg1444z00_3371;

							BgL_arg1443z00_3370 = CAR(BgL_arg1446z00_1343);
							BgL_arg1444z00_3371 = CDR(BgL_arg1446z00_1343);
							{	/* Eval/evaluate.scm 293 */
								obj_t BgL_res2850z00_3374;

								BgL_res2850z00_3374 =
									MAKE_YOUNG_EPAIR(BgL_arg1443z00_3370, BgL_arg1444z00_3371,
									BgL_locz00_58);
								return BgL_res2850z00_3374;
							}
						}
					}
				}
			else
				{	/* Eval/evaluate.scm 300 */
					return BgL_bodyz00_60;
				}
		}

	}



/* type-checks */
	obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t BgL_varsz00_61,
		obj_t BgL_srcsz00_62, obj_t BgL_bodyz00_63, obj_t BgL_locz00_64,
		obj_t BgL_procnamez00_65)
	{
		{	/* Eval/evaluate.scm 334 */
			{	/* Eval/evaluate.scm 335 */
				bool_t BgL_test3116z00_5111;

				{	/* Eval/evaluate.scm 335 */
					int BgL_arg1523z00_1437;

					BgL_arg1523z00_1437 = bgl_debug();
					BgL_test3116z00_5111 = ((long) (BgL_arg1523z00_1437) <= ((long) 0));
				}
				if (BgL_test3116z00_5111)
					{	/* Eval/evaluate.scm 335 */
						return BgL_bodyz00_63;
					}
				else
					{	/* Eval/evaluate.scm 335 */
						return
							BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_63, BgL_procnamez00_65,
							BgL_locz00_64, BgL_varsz00_61, BgL_srcsz00_62);
					}
			}
		}

	}



/* loop~1 */
	obj_t BGl_loopze71ze7zz__evaluatez00(obj_t BgL_bodyz00_4599,
		obj_t BgL_procnamez00_4598, obj_t BgL_locz00_4597, obj_t BgL_varsz00_1422,
		obj_t BgL_srcsz00_1423)
	{
		{	/* Eval/evaluate.scm 337 */
		BGl_loopze71ze7zz__evaluatez00:
			if (NULLP(BgL_varsz00_1422))
				{	/* Eval/evaluate.scm 339 */
					return BgL_bodyz00_4599;
				}
			else
				{	/* Eval/evaluate.scm 341 */
					obj_t BgL_vz00_1426;

					BgL_vz00_1426 = CAR(((obj_t) BgL_varsz00_1422));
					{	/* Eval/evaluate.scm 341 */
						obj_t BgL_idz00_1427;

						BgL_idz00_1427 = CAR(((obj_t) BgL_vz00_1426));
						{	/* Eval/evaluate.scm 342 */
							obj_t BgL_tnamez00_1428;

							BgL_tnamez00_1428 = CDR(((obj_t) BgL_vz00_1426));
							{	/* Eval/evaluate.scm 343 */

								if (CBOOL(BgL_tnamez00_1428))
									{	/* Eval/evaluate.scm 345 */
										obj_t BgL_locz00_1429;

										{	/* Eval/evaluate.scm 345 */
											obj_t BgL_arg1520z00_1433;

											BgL_arg1520z00_1433 = CAR(((obj_t) BgL_srcsz00_1423));
											{	/* Eval/evaluate.scm 150 */
												obj_t BgL__ortest_1069z00_3380;

												BgL__ortest_1069z00_3380 =
													BGl_getzd2sourcezd2locationz00zz__readerz00
													(BgL_arg1520z00_1433);
												if (CBOOL(BgL__ortest_1069z00_3380))
													{	/* Eval/evaluate.scm 150 */
														BgL_locz00_1429 = BgL__ortest_1069z00_3380;
													}
												else
													{	/* Eval/evaluate.scm 151 */
														obj_t BgL__ortest_1070z00_3381;

														BgL__ortest_1070z00_3381 =
															BGl_getzd2sourcezd2locationz00zz__readerz00
															(BgL_srcsz00_1423);
														if (CBOOL(BgL__ortest_1070z00_3381))
															{	/* Eval/evaluate.scm 151 */
																BgL_locz00_1429 = BgL__ortest_1070z00_3381;
															}
														else
															{	/* Eval/evaluate.scm 151 */
																BgL_locz00_1429 = BgL_locz00_4597;
															}
													}
											}
										}
										{	/* Eval/evaluate.scm 347 */
											obj_t BgL_arg1516z00_1430;

											{	/* Eval/evaluate.scm 347 */
												obj_t BgL_arg1517z00_1431;
												obj_t BgL_arg1519z00_1432;

												BgL_arg1517z00_1431 = CDR(((obj_t) BgL_varsz00_1422));
												BgL_arg1519z00_1432 = CDR(((obj_t) BgL_srcsz00_1423));
												BgL_arg1516z00_1430 =
													BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_4599,
													BgL_procnamez00_4598, BgL_locz00_4597,
													BgL_arg1517z00_1431, BgL_arg1519z00_1432);
											}
											return
												BGl_typezd2checkzd2zz__evaluatez00(BgL_idz00_1427,
												BgL_tnamez00_1428, BgL_locz00_1429,
												BgL_procnamez00_4598, BgL_arg1516z00_1430);
										}
									}
								else
									{	/* Eval/evaluate.scm 348 */
										obj_t BgL_arg1521z00_1434;
										obj_t BgL_arg1522z00_1435;

										BgL_arg1521z00_1434 = CDR(((obj_t) BgL_varsz00_1422));
										BgL_arg1522z00_1435 = CDR(((obj_t) BgL_srcsz00_1423));
										{
											obj_t BgL_srcsz00_5145;
											obj_t BgL_varsz00_5144;

											BgL_varsz00_5144 = BgL_arg1521z00_1434;
											BgL_srcsz00_5145 = BgL_arg1522z00_1435;
											BgL_srcsz00_1423 = BgL_srcsz00_5145;
											BgL_varsz00_1422 = BgL_varsz00_5144;
											goto BGl_loopze71ze7zz__evaluatez00;
										}
									}
							}
						}
					}
				}
		}

	}



/* type-result */
	obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t BgL_typez00_66,
		obj_t BgL_bodyz00_67, obj_t BgL_locz00_68)
	{
		{	/* Eval/evaluate.scm 353 */
			{	/* Eval/evaluate.scm 354 */
				bool_t BgL_test3121z00_5146;

				if (CBOOL(BgL_typez00_66))
					{	/* Eval/evaluate.scm 354 */
						int BgL_arg1543z00_1452;

						BgL_arg1543z00_1452 = bgl_debug();
						BgL_test3121z00_5146 = ((long) (BgL_arg1543z00_1452) >= ((long) 1));
					}
				else
					{	/* Eval/evaluate.scm 354 */
						BgL_test3121z00_5146 = ((bool_t) 0);
					}
				if (BgL_test3121z00_5146)
					{	/* Eval/evaluate.scm 355 */
						obj_t BgL_tmpz00_1440;

						BgL_tmpz00_1440 =
							BGl_gensymz00zz__r4_symbols_6_4z00
							(BGl_symbol2942z00zz__evaluatez00);
						{	/* Eval/evaluate.scm 357 */
							obj_t BgL_arg1526z00_1441;
							obj_t BgL_arg1527z00_1442;

							{	/* Eval/evaluate.scm 357 */
								obj_t BgL_arg1529z00_1443;

								{	/* Eval/evaluate.scm 357 */
									obj_t BgL_arg1531z00_1444;
									obj_t BgL_arg1532z00_1445;

									{	/* Eval/evaluate.scm 357 */
										obj_t BgL_arg1533z00_1446;

										{	/* Eval/evaluate.scm 357 */
											obj_t BgL_arg1536z00_1447;
											obj_t BgL_arg1537z00_1448;

											{	/* Eval/evaluate.scm 357 */
												obj_t BgL_arg1540z00_1449;

												{	/* Eval/evaluate.scm 357 */
													obj_t BgL_list1541z00_1450;

													{	/* Eval/evaluate.scm 357 */
														obj_t BgL_arg1542z00_1451;

														BgL_arg1542z00_1451 =
															MAKE_YOUNG_PAIR(BgL_typez00_66, BNIL);
														BgL_list1541z00_1450 =
															MAKE_YOUNG_PAIR(BgL_tmpz00_1440,
															BgL_arg1542z00_1451);
													}
													BgL_arg1540z00_1449 =
														BGl_formatz00zz__r4_output_6_10_3z00
														(BGl_string2944z00zz__evaluatez00,
														BgL_list1541z00_1450);
												}
												BgL_arg1536z00_1447 =
													bstring_to_symbol(BgL_arg1540z00_1449);
											}
											BgL_arg1537z00_1448 =
												MAKE_YOUNG_PAIR(BgL_bodyz00_67, BNIL);
											BgL_arg1533z00_1446 =
												MAKE_YOUNG_PAIR(BgL_arg1536z00_1447,
												BgL_arg1537z00_1448);
										}
										BgL_arg1531z00_1444 =
											MAKE_YOUNG_PAIR(BgL_arg1533z00_1446, BNIL);
									}
									BgL_arg1532z00_1445 = MAKE_YOUNG_PAIR(BgL_tmpz00_1440, BNIL);
									BgL_arg1529z00_1443 =
										MAKE_YOUNG_PAIR(BgL_arg1531z00_1444, BgL_arg1532z00_1445);
								}
								BgL_arg1526z00_1441 =
									MAKE_YOUNG_PAIR(BGl_symbol2932z00zz__evaluatez00,
									BgL_arg1529z00_1443);
							}
							{	/* Eval/evaluate.scm 144 */
								obj_t BgL__ortest_1068z00_3388;

								BgL__ortest_1068z00_3388 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_67);
								if (CBOOL(BgL__ortest_1068z00_3388))
									{	/* Eval/evaluate.scm 144 */
										BgL_arg1527z00_1442 = BgL__ortest_1068z00_3388;
									}
								else
									{	/* Eval/evaluate.scm 144 */
										BgL_arg1527z00_1442 = BgL_locz00_68;
									}
							}
							{	/* Eval/evaluate.scm 293 */
								obj_t BgL_arg1443z00_3389;
								obj_t BgL_arg1444z00_3390;

								BgL_arg1443z00_3389 = CAR(BgL_arg1526z00_1441);
								BgL_arg1444z00_3390 = CDR(BgL_arg1526z00_1441);
								{	/* Eval/evaluate.scm 293 */
									obj_t BgL_res2851z00_3393;

									BgL_res2851z00_3393 =
										MAKE_YOUNG_EPAIR(BgL_arg1443z00_3389, BgL_arg1444z00_3390,
										BgL_arg1527z00_1442);
									return BgL_res2851z00_3393;
								}
							}
						}
					}
				else
					{	/* Eval/evaluate.scm 354 */
						return BgL_bodyz00_67;
					}
			}
		}

	}



/* conv */
	obj_t BGl_convz00zz__evaluatez00(obj_t BgL_ez00_69, obj_t BgL_localsz00_70,
		obj_t BgL_globalsz00_71, obj_t BgL_tailzf3zf3_72, obj_t BgL_wherez00_73,
		obj_t BgL_locz00_74, bool_t BgL_topzf3zf3_75)
	{
		{	/* Eval/evaluate.scm 365 */
		BGl_convz00zz__evaluatez00:
			{
				obj_t BgL_xz00_1461;
				obj_t BgL_bahz00_1463;
				obj_t BgL_lz00_1468;
				obj_t BgL_funz00_1470;
				obj_t BgL_argsz00_1471;
				obj_t BgL_pz00_1477;
				obj_t BgL_tz00_1478;
				obj_t BgL_oz00_1479;
				obj_t BgL_pz00_1481;
				obj_t BgL_tz00_1482;
				obj_t BgL_bindsz00_1490;
				obj_t BgL_bodyz00_1491;
				obj_t BgL_bindsz00_1493;
				obj_t BgL_bodyz00_1494;
				obj_t BgL_bindsz00_1496;
				obj_t BgL_bodyz00_1497;
				obj_t BgL_lz00_1503;
				obj_t BgL_e2z00_1504;
				obj_t BgL_vz00_1506;
				obj_t BgL_ez00_1507;
				obj_t BgL_gvz00_1510;
				obj_t BgL_formalsz00_1511;
				obj_t BgL_bodyz00_1512;
				obj_t BgL_gvz00_1514;
				obj_t BgL_gez00_1515;
				obj_t BgL_vz00_1517;
				obj_t BgL_bodyz00_1518;
				obj_t BgL_mz00_1530;
				obj_t BgL_bodyz00_1531;
				obj_t BgL_fz00_1537;
				obj_t BgL_argsz00_1538;

				if (PAIRP(BgL_ez00_69))
					{	/* Eval/evaluate.scm 424 */
						if ((CAR(BgL_ez00_69) == BGl_symbol2951z00zz__evaluatez00))
							{	/* Eval/evaluate.scm 424 */
								BgL_bahz00_1463 = CDR(BgL_ez00_69);
								if (BgL_topzf3zf3_75)
									{	/* Eval/evaluate.scm 432 */
										obj_t BgL_formsz00_2328;

										{	/* Eval/evaluate.scm 432 */
											obj_t BgL_arg2270z00_2331;

											{	/* Eval/evaluate.scm 144 */
												obj_t BgL__ortest_1068z00_3429;

												BgL__ortest_1068z00_3429 =
													BGl_getzd2sourcezd2locationz00zz__readerz00
													(BgL_ez00_69);
												if (CBOOL(BgL__ortest_1068z00_3429))
													{	/* Eval/evaluate.scm 144 */
														BgL_arg2270z00_2331 = BgL__ortest_1068z00_3429;
													}
												else
													{	/* Eval/evaluate.scm 144 */
														BgL_arg2270z00_2331 = BgL_locz00_74;
													}
											}
											BgL_formsz00_2328 =
												BGl_evmodulez00zz__evmodulez00(BgL_ez00_69,
												BgL_arg2270z00_2331);
										}
										{	/* Eval/evaluate.scm 433 */
											obj_t BgL_arg2267z00_2329;
											obj_t BgL_arg2269z00_2330;

											BgL_arg2267z00_2329 =
												BGl_expandz00zz__expandz00(BgL_formsz00_2328);
											BgL_arg2269z00_2330 = BGL_MODULE();
											{
												bool_t BgL_topzf3zf3_5185;
												obj_t BgL_wherez00_5184;
												obj_t BgL_tailzf3zf3_5183;
												obj_t BgL_globalsz00_5182;
												obj_t BgL_ez00_5181;

												BgL_ez00_5181 = BgL_arg2267z00_2329;
												BgL_globalsz00_5182 = BgL_arg2269z00_2330;
												BgL_tailzf3zf3_5183 = BgL_wherez00_73;
												BgL_wherez00_5184 = BFALSE;
												BgL_topzf3zf3_5185 = ((bool_t) 1);
												BgL_topzf3zf3_75 = BgL_topzf3zf3_5185;
												BgL_wherez00_73 = BgL_wherez00_5184;
												BgL_tailzf3zf3_72 = BgL_tailzf3zf3_5183;
												BgL_globalsz00_71 = BgL_globalsz00_5182;
												BgL_ez00_69 = BgL_ez00_5181;
												goto BGl_convz00zz__evaluatez00;
											}
										}
									}
								else
									{	/* Eval/evaluate.scm 431 */
										return
											BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74,
											BGl_string2870z00zz__evaluatez00,
											BGl_string2950z00zz__evaluatez00, BgL_ez00_69);
									}
							}
						else
							{	/* Eval/evaluate.scm 424 */
								obj_t BgL_cdrzd2250zd2_1546;

								BgL_cdrzd2250zd2_1546 = CDR(BgL_ez00_69);
								if ((CAR(BgL_ez00_69) == BGl_symbol2953z00zz__evaluatez00))
									{	/* Eval/evaluate.scm 424 */
										if (PAIRP(BgL_cdrzd2250zd2_1546))
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd2253zd2_1550;
												obj_t BgL_cdrzd2254zd2_1551;

												BgL_carzd2253zd2_1550 = CAR(BgL_cdrzd2250zd2_1546);
												BgL_cdrzd2254zd2_1551 = CDR(BgL_cdrzd2250zd2_1546);
												if (SYMBOLP(BgL_carzd2253zd2_1550))
													{	/* Eval/evaluate.scm 424 */
														if (PAIRP(BgL_cdrzd2254zd2_1551))
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_carzd2258zd2_1554;

																BgL_carzd2258zd2_1554 =
																	CAR(BgL_cdrzd2254zd2_1551);
																if (SYMBOLP(BgL_carzd2258zd2_1554))
																	{	/* Eval/evaluate.scm 424 */
																		if (NULLP(CDR(BgL_cdrzd2254zd2_1551)))
																			{	/* Eval/evaluate.scm 437 */
																				BgL_ev_globalz00_bglt
																					BgL_new1107z00_3746;
																				{	/* Eval/evaluate.scm 438 */
																					BgL_ev_globalz00_bglt
																						BgL_new1106z00_3747;
																					BgL_new1106z00_3747 =
																						((BgL_ev_globalz00_bglt)
																						BOBJECT(GC_MALLOC(sizeof(struct
																									BgL_ev_globalz00_bgl))));
																					{	/* Eval/evaluate.scm 438 */
																						long BgL_arg2271z00_3748;

																						BgL_arg2271z00_3748 =
																							BGL_CLASS_INDEX
																							(BGl_ev_globalz00zz__evaluate_typesz00);
																						BGL_OBJECT_CLASS_NUM_SET((
																								(BgL_objectz00_bglt)
																								BgL_new1106z00_3747),
																							BgL_arg2271z00_3748);
																					}
																					BgL_new1107z00_3746 =
																						BgL_new1106z00_3747;
																				}
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1107z00_3746))->
																						BgL_locz00) =
																					((obj_t) BgL_locz00_74), BUNSPEC);
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1107z00_3746))->
																						BgL_namez00) =
																					((obj_t) BgL_carzd2253zd2_1550),
																					BUNSPEC);
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1107z00_3746))->
																						BgL_modz00) =
																					((obj_t)
																						BGl_evalzd2findzd2modulez00zz__evmodulez00
																						(BgL_carzd2258zd2_1554)), BUNSPEC);
																				return ((obj_t) BgL_new1107z00_3746);
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_carzd2303zd2_1558;

																				BgL_carzd2303zd2_1558 =
																					CAR(BgL_ez00_69);
																				if (SYMBOLP(BgL_carzd2303zd2_1558))
																					{	/* Eval/evaluate.scm 424 */
																						if (CBOOL
																							(BGl_convzd2varzd2zz__evaluatez00
																								(BgL_carzd2303zd2_1558,
																									BgL_localsz00_70)))
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_5221;
																								BgL_funz00_1470 =
																									BgL_carzd2303zd2_1558;
																								BgL_argsz00_1471 =
																									BgL_cdrzd2250zd2_1546;
																							BgL_tagzd2152zd2_1472:
																								{	/* Eval/evaluate.scm 449 */
																									obj_t BgL_funz00_2361;
																									obj_t BgL_argsz00_2362;

																									{	/* Eval/evaluate.scm 380 */
																										obj_t BgL_arg2427z00_3439;

																										{	/* Eval/evaluate.scm 144 */
																											obj_t
																												BgL__ortest_1068z00_3440;
																											BgL__ortest_1068z00_3440 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_funz00_1470);
																											if (CBOOL
																												(BgL__ortest_1068z00_3440))
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2427z00_3439 =
																														BgL__ortest_1068z00_3440;
																												}
																											else
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2427z00_3439 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_funz00_2361 =
																											BGl_convz00zz__evaluatez00
																											(BgL_funz00_1470,
																											BgL_localsz00_70,
																											BgL_globalsz00_71, BFALSE,
																											BgL_wherez00_73,
																											BgL_arg2427z00_3439,
																											((bool_t) 0));
																									}
																									BgL_argsz00_2362 =
																										BGl_loopze70ze7zz__evaluatez00
																										(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_argsz00_1471);
																									{	/* Eval/evaluate.scm 450 */
																										BgL_ev_appz00_bglt
																											BgL_new1109z00_2363;
																										{	/* Eval/evaluate.scm 451 */
																											BgL_ev_appz00_bglt
																												BgL_new1108z00_2364;
																											BgL_new1108z00_2364 =
																												((BgL_ev_appz00_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 451 */
																												long
																													BgL_arg2287z00_2365;
																												BgL_arg2287z00_2365 =
																													BGL_CLASS_INDEX
																													(BGl_ev_appz00zz__evaluate_typesz00);
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1108z00_2364),
																													BgL_arg2287z00_2365);
																											}
																											BgL_new1109z00_2363 =
																												BgL_new1108z00_2364;
																										}
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1109z00_2363))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_74),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1109z00_2363))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_2361)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1109z00_2363))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_2362),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1109z00_2363))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_72),
																											BUNSPEC);
																										BgL_auxz00_5221 =
																											BgL_new1109z00_2363;
																								}}
																								return
																									((obj_t) BgL_auxz00_5221);
																							}
																						else
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_5237;
																								BgL_fz00_1537 =
																									BgL_carzd2303zd2_1558;
																								BgL_argsz00_1538 =
																									BgL_cdrzd2250zd2_1546;
																							BgL_tagzd2176zd2_1539:
																								{	/* Eval/evaluate.scm 599 */
																									obj_t BgL_funz00_2627;
																									obj_t BgL_argsz00_2628;

																									{	/* Eval/evaluate.scm 380 */
																										obj_t BgL_arg2427z00_3733;

																										{	/* Eval/evaluate.scm 144 */
																											obj_t
																												BgL__ortest_1068z00_3734;
																											BgL__ortest_1068z00_3734 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_fz00_1537);
																											if (CBOOL
																												(BgL__ortest_1068z00_3734))
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2427z00_3733 =
																														BgL__ortest_1068z00_3734;
																												}
																											else
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2427z00_3733 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_funz00_2627 =
																											BGl_convz00zz__evaluatez00
																											(BgL_fz00_1537,
																											BgL_localsz00_70,
																											BgL_globalsz00_71, BFALSE,
																											BgL_wherez00_73,
																											BgL_arg2427z00_3733,
																											((bool_t) 0));
																									}
																									BgL_argsz00_2628 =
																										BGl_loopze70ze7zz__evaluatez00
																										(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_argsz00_1538);
																									{	/* Eval/evaluate.scm 600 */
																										BgL_ev_appz00_bglt
																											BgL_new1163z00_2629;
																										{	/* Eval/evaluate.scm 601 */
																											BgL_ev_appz00_bglt
																												BgL_new1162z00_2630;
																											BgL_new1162z00_2630 =
																												((BgL_ev_appz00_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 601 */
																												long
																													BgL_arg2420z00_2631;
																												BgL_arg2420z00_2631 =
																													BGL_CLASS_INDEX
																													(BGl_ev_appz00zz__evaluate_typesz00);
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1162z00_2630),
																													BgL_arg2420z00_2631);
																											}
																											BgL_new1163z00_2629 =
																												BgL_new1162z00_2630;
																										}
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1163z00_2629))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_74),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1163z00_2629))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_2627)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1163z00_2629))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_2628),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1163z00_2629))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_72),
																											BUNSPEC);
																										BgL_auxz00_5237 =
																											BgL_new1163z00_2629;
																								}}
																								return
																									((obj_t) BgL_auxz00_5237);
																							}
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5253;

																						{
																							obj_t BgL_argsz00_5255;
																							obj_t BgL_fz00_5254;

																							BgL_fz00_5254 =
																								BgL_carzd2303zd2_1558;
																							BgL_argsz00_5255 =
																								BgL_cdrzd2250zd2_1546;
																							BgL_argsz00_1538 =
																								BgL_argsz00_5255;
																							BgL_fz00_1537 = BgL_fz00_5254;
																							goto BgL_tagzd2176zd2_1539;
																						}
																						return ((obj_t) BgL_auxz00_5253);
																					}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_carzd21010zd2_1569;

																		BgL_carzd21010zd2_1569 = CAR(BgL_ez00_69);
																		if (SYMBOLP(BgL_carzd21010zd2_1569))
																			{	/* Eval/evaluate.scm 424 */
																				if (CBOOL
																					(BGl_convzd2varzd2zz__evaluatez00
																						(BgL_carzd21010zd2_1569,
																							BgL_localsz00_70)))
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5263;

																						{
																							obj_t BgL_argsz00_5265;
																							obj_t BgL_funz00_5264;

																							BgL_funz00_5264 =
																								BgL_carzd21010zd2_1569;
																							BgL_argsz00_5265 =
																								BgL_cdrzd2250zd2_1546;
																							BgL_argsz00_1471 =
																								BgL_argsz00_5265;
																							BgL_funz00_1470 = BgL_funz00_5264;
																							goto BgL_tagzd2152zd2_1472;
																						}
																						return ((obj_t) BgL_auxz00_5263);
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5267;

																						{
																							obj_t BgL_argsz00_5269;
																							obj_t BgL_fz00_5268;

																							BgL_fz00_5268 =
																								BgL_carzd21010zd2_1569;
																							BgL_argsz00_5269 =
																								BgL_cdrzd2250zd2_1546;
																							BgL_argsz00_1538 =
																								BgL_argsz00_5269;
																							BgL_fz00_1537 = BgL_fz00_5268;
																							goto BgL_tagzd2176zd2_1539;
																						}
																						return ((obj_t) BgL_auxz00_5267);
																					}
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5271;

																				{
																					obj_t BgL_argsz00_5273;
																					obj_t BgL_fz00_5272;

																					BgL_fz00_5272 =
																						BgL_carzd21010zd2_1569;
																					BgL_argsz00_5273 =
																						BgL_cdrzd2250zd2_1546;
																					BgL_argsz00_1538 = BgL_argsz00_5273;
																					BgL_fz00_1537 = BgL_fz00_5272;
																					goto BgL_tagzd2176zd2_1539;
																				}
																				return ((obj_t) BgL_auxz00_5271);
																			}
																	}
															}
														else
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_carzd21717zd2_1579;

																BgL_carzd21717zd2_1579 = CAR(BgL_ez00_69);
																if (SYMBOLP(BgL_carzd21717zd2_1579))
																	{	/* Eval/evaluate.scm 424 */
																		if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																				(BgL_carzd21717zd2_1579,
																					BgL_localsz00_70)))
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5281;

																				{
																					obj_t BgL_argsz00_5283;
																					obj_t BgL_funz00_5282;

																					BgL_funz00_5282 =
																						BgL_carzd21717zd2_1579;
																					BgL_argsz00_5283 =
																						BgL_cdrzd2250zd2_1546;
																					BgL_argsz00_1471 = BgL_argsz00_5283;
																					BgL_funz00_1470 = BgL_funz00_5282;
																					goto BgL_tagzd2152zd2_1472;
																				}
																				return ((obj_t) BgL_auxz00_5281);
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5285;

																				{
																					obj_t BgL_argsz00_5287;
																					obj_t BgL_fz00_5286;

																					BgL_fz00_5286 =
																						BgL_carzd21717zd2_1579;
																					BgL_argsz00_5287 =
																						BgL_cdrzd2250zd2_1546;
																					BgL_argsz00_1538 = BgL_argsz00_5287;
																					BgL_fz00_1537 = BgL_fz00_5286;
																					goto BgL_tagzd2176zd2_1539;
																				}
																				return ((obj_t) BgL_auxz00_5285);
																			}
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5289;

																		{
																			obj_t BgL_argsz00_5291;
																			obj_t BgL_fz00_5290;

																			BgL_fz00_5290 = BgL_carzd21717zd2_1579;
																			BgL_argsz00_5291 = BgL_cdrzd2250zd2_1546;
																			BgL_argsz00_1538 = BgL_argsz00_5291;
																			BgL_fz00_1537 = BgL_fz00_5290;
																			goto BgL_tagzd2176zd2_1539;
																		}
																		return ((obj_t) BgL_auxz00_5289);
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 424 */
														obj_t BgL_carzd22424zd2_1589;

														BgL_carzd22424zd2_1589 = CAR(BgL_ez00_69);
														if (SYMBOLP(BgL_carzd22424zd2_1589))
															{	/* Eval/evaluate.scm 424 */
																if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																		(BgL_carzd22424zd2_1589, BgL_localsz00_70)))
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5299;

																		{
																			obj_t BgL_argsz00_5301;
																			obj_t BgL_funz00_5300;

																			BgL_funz00_5300 = BgL_carzd22424zd2_1589;
																			BgL_argsz00_5301 = BgL_cdrzd2250zd2_1546;
																			BgL_argsz00_1471 = BgL_argsz00_5301;
																			BgL_funz00_1470 = BgL_funz00_5300;
																			goto BgL_tagzd2152zd2_1472;
																		}
																		return ((obj_t) BgL_auxz00_5299);
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5303;

																		{
																			obj_t BgL_argsz00_5305;
																			obj_t BgL_fz00_5304;

																			BgL_fz00_5304 = BgL_carzd22424zd2_1589;
																			BgL_argsz00_5305 = BgL_cdrzd2250zd2_1546;
																			BgL_argsz00_1538 = BgL_argsz00_5305;
																			BgL_fz00_1537 = BgL_fz00_5304;
																			goto BgL_tagzd2176zd2_1539;
																		}
																		return ((obj_t) BgL_auxz00_5303);
																	}
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_5307;

																{
																	obj_t BgL_argsz00_5309;
																	obj_t BgL_fz00_5308;

																	BgL_fz00_5308 = BgL_carzd22424zd2_1589;
																	BgL_argsz00_5309 = BgL_cdrzd2250zd2_1546;
																	BgL_argsz00_1538 = BgL_argsz00_5309;
																	BgL_fz00_1537 = BgL_fz00_5308;
																	goto BgL_tagzd2176zd2_1539;
																}
																return ((obj_t) BgL_auxz00_5307);
															}
													}
											}
										else
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd23131zd2_1599;

												BgL_carzd23131zd2_1599 = CAR(BgL_ez00_69);
												if (SYMBOLP(BgL_carzd23131zd2_1599))
													{	/* Eval/evaluate.scm 424 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23131zd2_1599, BgL_localsz00_70)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_5317;

																{
																	obj_t BgL_argsz00_5319;
																	obj_t BgL_funz00_5318;

																	BgL_funz00_5318 = BgL_carzd23131zd2_1599;
																	BgL_argsz00_5319 = BgL_cdrzd2250zd2_1546;
																	BgL_argsz00_1471 = BgL_argsz00_5319;
																	BgL_funz00_1470 = BgL_funz00_5318;
																	goto BgL_tagzd2152zd2_1472;
																}
																return ((obj_t) BgL_auxz00_5317);
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_5321;

																{
																	obj_t BgL_argsz00_5323;
																	obj_t BgL_fz00_5322;

																	BgL_fz00_5322 = BgL_carzd23131zd2_1599;
																	BgL_argsz00_5323 = BgL_cdrzd2250zd2_1546;
																	BgL_argsz00_1538 = BgL_argsz00_5323;
																	BgL_fz00_1537 = BgL_fz00_5322;
																	goto BgL_tagzd2176zd2_1539;
																}
																return ((obj_t) BgL_auxz00_5321);
															}
													}
												else
													{
														BgL_ev_appz00_bglt BgL_auxz00_5325;

														{
															obj_t BgL_argsz00_5327;
															obj_t BgL_fz00_5326;

															BgL_fz00_5326 = BgL_carzd23131zd2_1599;
															BgL_argsz00_5327 = BgL_cdrzd2250zd2_1546;
															BgL_argsz00_1538 = BgL_argsz00_5327;
															BgL_fz00_1537 = BgL_fz00_5326;
															goto BgL_tagzd2176zd2_1539;
														}
														return ((obj_t) BgL_auxz00_5325);
													}
											}
									}
								else
									{	/* Eval/evaluate.scm 424 */
										if ((CAR(BgL_ez00_69) == BGl_symbol2955z00zz__evaluatez00))
											{	/* Eval/evaluate.scm 424 */
												BgL_lz00_1468 = BgL_cdrzd2250zd2_1546;
												{	/* Eval/evaluate.scm 442 */
													bool_t BgL_test3147z00_5332;

													if (PAIRP(BgL_lz00_1468))
														{	/* Eval/evaluate.scm 442 */
															bool_t BgL_test3149z00_5335;

															{	/* Eval/evaluate.scm 442 */
																obj_t BgL_tmpz00_5336;

																BgL_tmpz00_5336 = CDR(BgL_lz00_1468);
																BgL_test3149z00_5335 = PAIRP(BgL_tmpz00_5336);
															}
															if (BgL_test3149z00_5335)
																{
																	obj_t BgL_l1212z00_2352;

																	BgL_l1212z00_2352 = BgL_lz00_1468;
																BgL_zc3z04anonymousza32281ze3z87_2353:
																	if (NULLP(BgL_l1212z00_2352))
																		{	/* Eval/evaluate.scm 442 */
																			BgL_test3147z00_5332 = ((bool_t) 1);
																		}
																	else
																		{	/* Eval/evaluate.scm 442 */
																			bool_t BgL_test3151z00_5341;

																			{	/* Eval/evaluate.scm 442 */
																				obj_t BgL_tmpz00_5342;

																				BgL_tmpz00_5342 =
																					CAR(((obj_t) BgL_l1212z00_2352));
																				BgL_test3151z00_5341 =
																					SYMBOLP(BgL_tmpz00_5342);
																			}
																			if (BgL_test3151z00_5341)
																				{
																					obj_t BgL_l1212z00_5346;

																					BgL_l1212z00_5346 =
																						CDR(((obj_t) BgL_l1212z00_2352));
																					BgL_l1212z00_2352 = BgL_l1212z00_5346;
																					goto
																						BgL_zc3z04anonymousza32281ze3z87_2353;
																				}
																			else
																				{	/* Eval/evaluate.scm 442 */
																					BgL_test3147z00_5332 = ((bool_t) 0);
																				}
																		}
																}
															else
																{	/* Eval/evaluate.scm 442 */
																	BgL_test3147z00_5332 = ((bool_t) 0);
																}
														}
													else
														{	/* Eval/evaluate.scm 442 */
															BgL_test3147z00_5332 = ((bool_t) 0);
														}
													if (BgL_test3147z00_5332)
														{	/* Eval/evaluate.scm 442 */
															return
																BGl_convzd2fieldzd2refz00zz__evaluatez00
																(BgL_ez00_69, BgL_localsz00_70,
																BgL_globalsz00_71, BgL_tailzf3zf3_72,
																BgL_wherez00_73, BgL_locz00_74,
																BgL_topzf3zf3_75);
														}
													else
														{	/* Eval/evaluate.scm 442 */
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_74,
																BGl_string2870z00zz__evaluatez00,
																BGl_string2945z00zz__evaluatez00, BgL_ez00_69);
														}
												}
											}
										else
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd23841zd2_1612;

												BgL_carzd23841zd2_1612 = CAR(BgL_ez00_69);
												if (SYMBOLP(BgL_carzd23841zd2_1612))
													{	/* Eval/evaluate.scm 424 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23841zd2_1612, BgL_localsz00_70)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_5357;

																{
																	obj_t BgL_argsz00_5359;
																	obj_t BgL_funz00_5358;

																	BgL_funz00_5358 = BgL_carzd23841zd2_1612;
																	BgL_argsz00_5359 = BgL_cdrzd2250zd2_1546;
																	BgL_argsz00_1471 = BgL_argsz00_5359;
																	BgL_funz00_1470 = BgL_funz00_5358;
																	goto BgL_tagzd2152zd2_1472;
																}
																return ((obj_t) BgL_auxz00_5357);
															}
														else
															{	/* Eval/evaluate.scm 424 */
																if (
																	(BgL_carzd23841zd2_1612 ==
																		BGl_symbol2957z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 424 */
																		if (PAIRP(BgL_cdrzd2250zd2_1546))
																			{	/* Eval/evaluate.scm 424 */
																				if (NULLP(CDR(BgL_cdrzd2250zd2_1546)))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1616z00_1623;

																						BgL_arg1616z00_1623 =
																							CAR(BgL_cdrzd2250zd2_1546);
																						{	/* Eval/evaluate.scm 456 */
																							BgL_ev_trapz00_bglt
																								BgL_new1111z00_3790;
																							{	/* Eval/evaluate.scm 457 */
																								BgL_ev_trapz00_bglt
																									BgL_new1110z00_3791;
																								BgL_new1110z00_3791 =
																									((BgL_ev_trapz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_trapz00_bgl))));
																								{	/* Eval/evaluate.scm 457 */
																									long BgL_arg2288z00_3792;

																									BgL_arg2288z00_3792 =
																										BGL_CLASS_INDEX
																										(BGl_ev_trapz00zz__evaluate_typesz00);
																									BGL_OBJECT_CLASS_NUM_SET((
																											(BgL_objectz00_bglt)
																											BgL_new1110z00_3791),
																										BgL_arg2288z00_3792);
																								}
																								BgL_new1111z00_3790 =
																									BgL_new1110z00_3791;
																							}
																							{
																								BgL_ev_exprz00_bglt
																									BgL_auxz00_5373;
																								{	/* Eval/evaluate.scm 380 */
																									obj_t BgL_arg2427z00_3796;

																									BgL_arg2427z00_3796 =
																										BGl_getzd2locationzd2zz__evaluatez00
																										(BgL_arg1616z00_1623,
																										BgL_locz00_74);
																									BgL_auxz00_5373 =
																										((BgL_ev_exprz00_bglt)
																										BGl_uconvzf2locze70z15zz__evaluatez00
																										(BgL_wherez00_73,
																											BgL_globalsz00_71,
																											BgL_localsz00_70,
																											BgL_arg1616z00_1623,
																											BgL_arg2427z00_3796));
																								}
																								((((BgL_ev_hookz00_bglt)
																											COBJECT((
																													(BgL_ev_hookz00_bglt)
																													BgL_new1111z00_3790)))->
																										BgL_ez00) =
																									((BgL_ev_exprz00_bglt)
																										BgL_auxz00_5373), BUNSPEC);
																							}
																							return
																								((obj_t) BgL_new1111z00_3790);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1617z00_1624;
																						obj_t BgL_arg1618z00_1625;

																						BgL_arg1617z00_1624 =
																							CAR(BgL_ez00_69);
																						BgL_arg1618z00_1625 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5382;
																							{
																								obj_t BgL_argsz00_5384;
																								obj_t BgL_fz00_5383;

																								BgL_fz00_5383 =
																									BgL_arg1617z00_1624;
																								BgL_argsz00_5384 =
																									BgL_arg1618z00_1625;
																								BgL_argsz00_1538 =
																									BgL_argsz00_5384;
																								BgL_fz00_1537 = BgL_fz00_5383;
																								goto BgL_tagzd2176zd2_1539;
																							}
																							return ((obj_t) BgL_auxz00_5382);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1620z00_1627;
																				obj_t BgL_arg1621z00_1628;

																				BgL_arg1620z00_1627 = CAR(BgL_ez00_69);
																				BgL_arg1621z00_1628 = CDR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_5388;

																					{
																						obj_t BgL_argsz00_5390;
																						obj_t BgL_fz00_5389;

																						BgL_fz00_5389 = BgL_arg1620z00_1627;
																						BgL_argsz00_5390 =
																							BgL_arg1621z00_1628;
																						BgL_argsz00_1538 = BgL_argsz00_5390;
																						BgL_fz00_1537 = BgL_fz00_5389;
																						goto BgL_tagzd2176zd2_1539;
																					}
																					return ((obj_t) BgL_auxz00_5388);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_cdrzd24514zd2_1629;

																		BgL_cdrzd24514zd2_1629 = CDR(BgL_ez00_69);
																		if (
																			(CAR(BgL_ez00_69) ==
																				BGl_symbol2922z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 424 */
																				if (PAIRP(BgL_cdrzd24514zd2_1629))
																					{	/* Eval/evaluate.scm 424 */
																						if (NULLP(CDR
																								(BgL_cdrzd24514zd2_1629)))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1627z00_1635;

																								BgL_arg1627z00_1635 =
																									CAR(BgL_cdrzd24514zd2_1629);
																								{	/* Eval/evaluate.scm 459 */
																									BgL_ev_littz00_bglt
																										BgL_new1113z00_3805;
																									{	/* Eval/evaluate.scm 460 */
																										BgL_ev_littz00_bglt
																											BgL_new1112z00_3806;
																										BgL_new1112z00_3806 =
																											((BgL_ev_littz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_littz00_bgl))));
																										{	/* Eval/evaluate.scm 460 */
																											long BgL_arg2289z00_3807;

																											BgL_arg2289z00_3807 =
																												BGL_CLASS_INDEX
																												(BGl_ev_littz00zz__evaluate_typesz00);
																											BGL_OBJECT_CLASS_NUM_SET((
																													(BgL_objectz00_bglt)
																													BgL_new1112z00_3806),
																												BgL_arg2289z00_3807);
																										}
																										BgL_new1113z00_3805 =
																											BgL_new1112z00_3806;
																									}
																									((((BgL_ev_littz00_bglt)
																												COBJECT
																												(BgL_new1113z00_3805))->
																											BgL_valuez00) =
																										((obj_t)
																											BgL_arg1627z00_1635),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1113z00_3805);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1628z00_1636;

																								BgL_arg1628z00_1636 =
																									CAR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5409;
																									{
																										obj_t BgL_argsz00_5411;
																										obj_t BgL_fz00_5410;

																										BgL_fz00_5410 =
																											BgL_arg1628z00_1636;
																										BgL_argsz00_5411 =
																											BgL_cdrzd24514zd2_1629;
																										BgL_argsz00_1538 =
																											BgL_argsz00_5411;
																										BgL_fz00_1537 =
																											BgL_fz00_5410;
																										goto BgL_tagzd2176zd2_1539;
																									}
																									return
																										((obj_t) BgL_auxz00_5409);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1631z00_1639;

																						BgL_arg1631z00_1639 =
																							CAR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5414;
																							{
																								obj_t BgL_argsz00_5416;
																								obj_t BgL_fz00_5415;

																								BgL_fz00_5415 =
																									BgL_arg1631z00_1639;
																								BgL_argsz00_5416 =
																									BgL_cdrzd24514zd2_1629;
																								BgL_argsz00_1538 =
																									BgL_argsz00_5416;
																								BgL_fz00_1537 = BgL_fz00_5415;
																								goto BgL_tagzd2176zd2_1539;
																							}
																							return ((obj_t) BgL_auxz00_5414);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				if (
																					(CAR(BgL_ez00_69) ==
																						BGl_symbol2930z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 424 */
																						if (PAIRP(BgL_cdrzd24514zd2_1629))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_cdrzd25128zd2_1645;

																								BgL_cdrzd25128zd2_1645 =
																									CDR(BgL_cdrzd24514zd2_1629);
																								if (PAIRP
																									(BgL_cdrzd25128zd2_1645))
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd25133zd2_1647;
																										BgL_cdrzd25133zd2_1647 =
																											CDR
																											(BgL_cdrzd25128zd2_1645);
																										if (PAIRP
																											(BgL_cdrzd25133zd2_1647))
																											{	/* Eval/evaluate.scm 424 */
																												if (NULLP(CDR
																														(BgL_cdrzd25133zd2_1647)))
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1640z00_1651;
																														obj_t
																															BgL_arg1641z00_1652;
																														obj_t
																															BgL_arg1642z00_1653;
																														BgL_arg1640z00_1651
																															=
																															CAR
																															(BgL_cdrzd24514zd2_1629);
																														BgL_arg1641z00_1652
																															=
																															CAR
																															(BgL_cdrzd25128zd2_1645);
																														BgL_arg1642z00_1653
																															=
																															CAR
																															(BgL_cdrzd25133zd2_1647);
																														{
																															BgL_ev_ifz00_bglt
																																BgL_auxz00_5435;
																															BgL_pz00_1477 =
																																BgL_arg1640z00_1651;
																															BgL_tz00_1478 =
																																BgL_arg1641z00_1652;
																															BgL_oz00_1479 =
																																BgL_arg1642z00_1653;
																														BgL_tagzd2155zd2_1480:
																															{	/* Eval/evaluate.scm 462 */
																																BgL_ev_ifz00_bglt
																																	BgL_new1116z00_2372;
																																{	/* Eval/evaluate.scm 463 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1114z00_2376;
																																	BgL_new1114z00_2376
																																		=
																																		(
																																		(BgL_ev_ifz00_bglt)
																																		BOBJECT
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_ev_ifz00_bgl))));
																																	{	/* Eval/evaluate.scm 463 */
																																		long
																																			BgL_arg2293z00_2377;
																																		BgL_arg2293z00_2377
																																			=
																																			BGL_CLASS_INDEX
																																			(BGl_ev_ifz00zz__evaluate_typesz00);
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1114z00_2376), BgL_arg2293z00_2377);
																																	}
																																	BgL_new1116z00_2372
																																		=
																																		BgL_new1114z00_2376;
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5440;
																																	{	/* Eval/evaluate.scm 463 */
																																		obj_t
																																			BgL_arg2290z00_2373;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1068z00_3461;
																																			BgL__ortest_1068z00_3461
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_pz00_1477);
																																			if (CBOOL
																																				(BgL__ortest_1068z00_3461))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2290z00_2373
																																						=
																																						BgL__ortest_1068z00_3461;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2290z00_2373
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5440
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_pz00_1477,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BFALSE,
																																				BgL_wherez00_73,
																																				BgL_arg2290z00_2373,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1116z00_2372))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5440), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5447;
																																	{	/* Eval/evaluate.scm 464 */
																																		obj_t
																																			BgL_arg2291z00_2374;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1068z00_3462;
																																			BgL__ortest_1068z00_3462
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_tz00_1478);
																																			if (CBOOL
																																				(BgL__ortest_1068z00_3462))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2291z00_2374
																																						=
																																						BgL__ortest_1068z00_3462;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2291z00_2374
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5447
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_tz00_1478,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BgL_tailzf3zf3_72,
																																				BgL_wherez00_73,
																																				BgL_arg2291z00_2374,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1116z00_2372))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5447), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5454;
																																	{	/* Eval/evaluate.scm 465 */
																																		obj_t
																																			BgL_arg2292z00_2375;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1068z00_3463;
																																			BgL__ortest_1068z00_3463
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_oz00_1479);
																																			if (CBOOL
																																				(BgL__ortest_1068z00_3463))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2292z00_2375
																																						=
																																						BgL__ortest_1068z00_3463;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2292z00_2375
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5454
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_oz00_1479,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BgL_tailzf3zf3_72,
																																				BgL_wherez00_73,
																																				BgL_arg2292z00_2375,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1116z00_2372))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5454), BUNSPEC);
																																}
																																BgL_auxz00_5435
																																	=
																																	BgL_new1116z00_2372;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5435);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1643z00_1654;
																														obj_t
																															BgL_arg1644z00_1655;
																														BgL_arg1643z00_1654
																															=
																															CAR(BgL_ez00_69);
																														BgL_arg1644z00_1655
																															=
																															CDR(BgL_ez00_69);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_5464;
																															{
																																obj_t
																																	BgL_argsz00_5466;
																																obj_t
																																	BgL_fz00_5465;
																																BgL_fz00_5465 =
																																	BgL_arg1643z00_1654;
																																BgL_argsz00_5466
																																	=
																																	BgL_arg1644z00_1655;
																																BgL_argsz00_1538
																																	=
																																	BgL_argsz00_5466;
																																BgL_fz00_1537 =
																																	BgL_fz00_5465;
																																goto
																																	BgL_tagzd2176zd2_1539;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5464);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_cdrzd25433zd2_1657;
																												BgL_cdrzd25433zd2_1657 =
																													CDR(BgL_ez00_69);
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_cdrzd25439zd2_1658;
																													BgL_cdrzd25439zd2_1658
																														=
																														CDR(((obj_t)
																															BgL_cdrzd25433zd2_1657));
																													if (NULLP(CDR(((obj_t)
																																	BgL_cdrzd25439zd2_1658))))
																														{	/* Eval/evaluate.scm 424 */
																															obj_t
																																BgL_arg1649z00_1661;
																															obj_t
																																BgL_arg1650z00_1662;
																															BgL_arg1649z00_1661
																																=
																																CAR(((obj_t)
																																	BgL_cdrzd25433zd2_1657));
																															BgL_arg1650z00_1662
																																=
																																CAR(((obj_t)
																																	BgL_cdrzd25439zd2_1658));
																															{
																																BgL_ev_ifz00_bglt
																																	BgL_auxz00_5479;
																																BgL_pz00_1481 =
																																	BgL_arg1649z00_1661;
																																BgL_tz00_1482 =
																																	BgL_arg1650z00_1662;
																															BgL_tagzd2156zd2_1483:
																																{	/* Eval/evaluate.scm 467 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1118z00_2378;
																																	{	/* Eval/evaluate.scm 468 */
																																		BgL_ev_ifz00_bglt
																																			BgL_new1117z00_2382;
																																		BgL_new1117z00_2382
																																			=
																																			(
																																			(BgL_ev_ifz00_bglt)
																																			BOBJECT
																																			(GC_MALLOC
																																				(sizeof
																																					(struct
																																						BgL_ev_ifz00_bgl))));
																																		{	/* Eval/evaluate.scm 468 */
																																			long
																																				BgL_arg2297z00_2383;
																																			BgL_arg2297z00_2383
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_ev_ifz00zz__evaluate_typesz00);
																																			BGL_OBJECT_CLASS_NUM_SET
																																				(((BgL_objectz00_bglt) BgL_new1117z00_2382), BgL_arg2297z00_2383);
																																		}
																																		BgL_new1118z00_2378
																																			=
																																			BgL_new1117z00_2382;
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5484;
																																		{	/* Eval/evaluate.scm 468 */
																																			obj_t
																																				BgL_arg2294z00_2379;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1068z00_3467;
																																				BgL__ortest_1068z00_3467
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_pz00_1481);
																																				if (CBOOL(BgL__ortest_1068z00_3467))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2294z00_2379
																																							=
																																							BgL__ortest_1068z00_3467;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2294z00_2379
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5484
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_pz00_1481,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BFALSE,
																																					BgL_wherez00_73,
																																					BgL_arg2294z00_2379,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1118z00_2378))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5484), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5491;
																																		{	/* Eval/evaluate.scm 469 */
																																			obj_t
																																				BgL_arg2295z00_2380;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1068z00_3468;
																																				BgL__ortest_1068z00_3468
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_tz00_1482);
																																				if (CBOOL(BgL__ortest_1068z00_3468))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2295z00_2380
																																							=
																																							BgL__ortest_1068z00_3468;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2295z00_2380
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5491
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_tz00_1482,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BgL_tailzf3zf3_72,
																																					BgL_wherez00_73,
																																					BgL_arg2295z00_2380,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1118z00_2378))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5491), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5498;
																																		{	/* Eval/evaluate.scm 470 */
																																			obj_t
																																				BgL_arg2296z00_2381;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1068z00_3469;
																																				BgL__ortest_1068z00_3469
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BFALSE);
																																				if (CBOOL(BgL__ortest_1068z00_3469))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2296z00_2381
																																							=
																																							BgL__ortest_1068z00_3469;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2296z00_2381
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5498
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_ez00_69,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BgL_tailzf3zf3_72,
																																					BgL_wherez00_73,
																																					BgL_arg2296z00_2381,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1118z00_2378))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5498), BUNSPEC);
																																	}
																																	BgL_auxz00_5479
																																		=
																																		BgL_new1118z00_2378;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_5479);
																															}
																														}
																													else
																														{	/* Eval/evaluate.scm 424 */
																															obj_t
																																BgL_arg1651z00_1663;
																															BgL_arg1651z00_1663
																																=
																																CAR
																																(BgL_ez00_69);
																															{
																																BgL_ev_appz00_bglt
																																	BgL_auxz00_5507;
																																{
																																	obj_t
																																		BgL_argsz00_5509;
																																	obj_t
																																		BgL_fz00_5508;
																																	BgL_fz00_5508
																																		=
																																		BgL_arg1651z00_1663;
																																	BgL_argsz00_5509
																																		=
																																		BgL_cdrzd25433zd2_1657;
																																	BgL_argsz00_1538
																																		=
																																		BgL_argsz00_5509;
																																	BgL_fz00_1537
																																		=
																																		BgL_fz00_5508;
																																	goto
																																		BgL_tagzd2176zd2_1539;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_5507);
																															}
																														}
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t BgL_arg1655z00_1666;
																										obj_t BgL_arg1658z00_1667;

																										BgL_arg1655z00_1666 =
																											CAR(BgL_ez00_69);
																										BgL_arg1658z00_1667 =
																											CDR(BgL_ez00_69);
																										{
																											BgL_ev_appz00_bglt
																												BgL_auxz00_5513;
																											{
																												obj_t BgL_argsz00_5515;
																												obj_t BgL_fz00_5514;

																												BgL_fz00_5514 =
																													BgL_arg1655z00_1666;
																												BgL_argsz00_5515 =
																													BgL_arg1658z00_1667;
																												BgL_argsz00_1538 =
																													BgL_argsz00_5515;
																												BgL_fz00_1537 =
																													BgL_fz00_5514;
																												goto
																													BgL_tagzd2176zd2_1539;
																											}
																											return
																												((obj_t)
																												BgL_auxz00_5513);
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1659z00_1668;
																								obj_t BgL_arg1660z00_1669;

																								BgL_arg1659z00_1668 =
																									CAR(BgL_ez00_69);
																								BgL_arg1660z00_1669 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5519;
																									{
																										obj_t BgL_argsz00_5521;
																										obj_t BgL_fz00_5520;

																										BgL_fz00_5520 =
																											BgL_arg1659z00_1668;
																										BgL_argsz00_5521 =
																											BgL_arg1660z00_1669;
																										BgL_argsz00_1538 =
																											BgL_argsz00_5521;
																										BgL_fz00_1537 =
																											BgL_fz00_5520;
																										goto BgL_tagzd2176zd2_1539;
																									}
																									return
																										((obj_t) BgL_auxz00_5519);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						if (
																							(CAR(BgL_ez00_69) ==
																								BGl_symbol2959z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1663z00_1672;

																								BgL_arg1663z00_1672 =
																									CDR(BgL_ez00_69);
																								{	/* Eval/evaluate.scm 472 */
																									BgL_ev_orz00_bglt
																										BgL_new1120z00_3838;
																									{	/* Eval/evaluate.scm 473 */
																										BgL_ev_orz00_bglt
																											BgL_new1119z00_3839;
																										BgL_new1119z00_3839 =
																											((BgL_ev_orz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_orz00_bgl))));
																										{	/* Eval/evaluate.scm 473 */
																											long BgL_arg2298z00_3840;

																											BgL_arg2298z00_3840 =
																												BGL_CLASS_INDEX
																												(BGl_ev_orz00zz__evaluate_typesz00);
																											BGL_OBJECT_CLASS_NUM_SET((
																													(BgL_objectz00_bglt)
																													BgL_new1119z00_3839),
																												BgL_arg2298z00_3840);
																										}
																										BgL_new1120z00_3838 =
																											BgL_new1119z00_3839;
																									}
																									((((BgL_ev_listz00_bglt)
																												COBJECT((
																														(BgL_ev_listz00_bglt)
																														BgL_new1120z00_3838)))->
																											BgL_argsz00) =
																										((obj_t)
																											BGl_loopze70ze7zz__evaluatez00
																											(BgL_wherez00_73,
																												BgL_globalsz00_71,
																												BgL_localsz00_70,
																												BgL_locz00_74,
																												BgL_arg1663z00_1672)),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1120z00_3838);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								if (
																									(CAR(BgL_ez00_69) ==
																										BGl_symbol2961z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 424 */
																										obj_t BgL_arg1666z00_1675;

																										BgL_arg1666z00_1675 =
																											CDR(BgL_ez00_69);
																										{	/* Eval/evaluate.scm 475 */
																											BgL_ev_andz00_bglt
																												BgL_new1123z00_3846;
																											{	/* Eval/evaluate.scm 476 */
																												BgL_ev_andz00_bglt
																													BgL_new1122z00_3847;
																												BgL_new1122z00_3847 =
																													((BgL_ev_andz00_bglt)
																													BOBJECT(GC_MALLOC
																														(sizeof(struct
																																BgL_ev_andz00_bgl))));
																												{	/* Eval/evaluate.scm 476 */
																													long
																														BgL_arg2299z00_3848;
																													BgL_arg2299z00_3848 =
																														BGL_CLASS_INDEX
																														(BGl_ev_andz00zz__evaluate_typesz00);
																													BGL_OBJECT_CLASS_NUM_SET
																														(((BgL_objectz00_bglt) BgL_new1122z00_3847), BgL_arg2299z00_3848);
																												}
																												BgL_new1123z00_3846 =
																													BgL_new1122z00_3847;
																											}
																											((((BgL_ev_listz00_bglt)
																														COBJECT((
																																(BgL_ev_listz00_bglt)
																																BgL_new1123z00_3846)))->
																													BgL_argsz00) =
																												((obj_t)
																													BGl_loopze70ze7zz__evaluatez00
																													(BgL_wherez00_73,
																														BgL_globalsz00_71,
																														BgL_localsz00_70,
																														BgL_locz00_74,
																														BgL_arg1666z00_1675)),
																												BUNSPEC);
																											return ((obj_t)
																												BgL_new1123z00_3846);
																										}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										if (
																											(CAR(BgL_ez00_69) ==
																												BGl_symbol2946z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 424 */
																												return
																													BGl_convzd2beginzd2zz__evaluatez00
																													(CDR(BgL_ez00_69),
																													BgL_localsz00_70,
																													BgL_globalsz00_71,
																													BgL_tailzf3zf3_72,
																													BgL_wherez00_73,
																													BgL_locz00_74,
																													BgL_topzf3zf3_75);
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_cdrzd26338zd2_1679;
																												BgL_cdrzd26338zd2_1679 =
																													CDR(BgL_ez00_69);
																												if ((CAR(BgL_ez00_69) ==
																														BGl_symbol2932z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 424 */
																														if (PAIRP
																															(BgL_cdrzd26338zd2_1679))
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1676z00_1683;
																																obj_t
																																	BgL_arg1679z00_1684;
																																BgL_arg1676z00_1683
																																	=
																																	CAR
																																	(BgL_cdrzd26338zd2_1679);
																																BgL_arg1679z00_1684
																																	=
																																	CDR
																																	(BgL_cdrzd26338zd2_1679);
																																{
																																	BgL_ev_letz00_bglt
																																		BgL_auxz00_5560;
																																	BgL_bindsz00_1490
																																		=
																																		BgL_arg1676z00_1683;
																																	BgL_bodyz00_1491
																																		=
																																		BgL_arg1679z00_1684;
																																BgL_tagzd2160zd2_1492:
																																	{	/* Eval/evaluate.scm 480 */
																																		obj_t
																																			BgL_ubindsz00_2390;
																																		if (NULLP
																																			(BgL_bindsz00_1490))
																																			{	/* Eval/evaluate.scm 480 */
																																				BgL_ubindsz00_2390
																																					=
																																					BNIL;
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 480 */
																																				obj_t
																																					BgL_head1217z00_2435;
																																				BgL_head1217z00_2435
																																					=
																																					MAKE_YOUNG_PAIR
																																					(BNIL,
																																					BNIL);
																																				{
																																					obj_t
																																						BgL_l1215z00_3505;
																																					obj_t
																																						BgL_tail1218z00_3506;
																																					BgL_l1215z00_3505
																																						=
																																						BgL_bindsz00_1490;
																																					BgL_tail1218z00_3506
																																						=
																																						BgL_head1217z00_2435;
																																				BgL_zc3z04anonymousza32320ze3z87_3504:
																																					if (NULLP(BgL_l1215z00_3505))
																																						{	/* Eval/evaluate.scm 480 */
																																							BgL_ubindsz00_2390
																																								=
																																								CDR
																																								(BgL_head1217z00_2435);
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 480 */
																																							obj_t
																																								BgL_newtail1219z00_3514;
																																							{	/* Eval/evaluate.scm 480 */
																																								obj_t
																																									BgL_arg2323z00_3515;
																																								{	/* Eval/evaluate.scm 480 */
																																									obj_t
																																										BgL_bz00_3516;
																																									BgL_bz00_3516
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_l1215z00_3505));
																																									{	/* Eval/evaluate.scm 480 */
																																										obj_t
																																											BgL_arg2324z00_3517;
																																										BgL_arg2324z00_3517
																																											=
																																											CAR
																																											(
																																											((obj_t) BgL_bz00_3516));
																																										BgL_arg2323z00_3515
																																											=
																																											BGl_untypezd2identzd2zz__evaluatez00
																																											(BgL_arg2324z00_3517);
																																									}
																																								}
																																								BgL_newtail1219z00_3514
																																									=
																																									MAKE_YOUNG_PAIR
																																									(BgL_arg2323z00_3515,
																																									BNIL);
																																							}
																																							SET_CDR
																																								(BgL_tail1218z00_3506,
																																								BgL_newtail1219z00_3514);
																																							{	/* Eval/evaluate.scm 480 */
																																								obj_t
																																									BgL_arg2322z00_3518;
																																								BgL_arg2322z00_3518
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_l1215z00_3505));
																																								{
																																									obj_t
																																										BgL_tail1218z00_5577;
																																									obj_t
																																										BgL_l1215z00_5576;
																																									BgL_l1215z00_5576
																																										=
																																										BgL_arg2322z00_3518;
																																									BgL_tail1218z00_5577
																																										=
																																										BgL_newtail1219z00_3514;
																																									BgL_tail1218z00_3506
																																										=
																																										BgL_tail1218z00_5577;
																																									BgL_l1215z00_3505
																																										=
																																										BgL_l1215z00_5576;
																																									goto
																																										BgL_zc3z04anonymousza32320ze3z87_3504;
																																								}
																																							}
																																						}
																																				}
																																			}
																																		{	/* Eval/evaluate.scm 480 */
																																			obj_t
																																				BgL_varsz00_2391;
																																			if (NULLP
																																				(BgL_ubindsz00_2390))
																																				{	/* Eval/evaluate.scm 481 */
																																					BgL_varsz00_2391
																																						=
																																						BNIL;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 481 */
																																					obj_t
																																						BgL_head1222z00_2419;
																																					BgL_head1222z00_2419
																																						=
																																						MAKE_YOUNG_PAIR
																																						(BNIL,
																																						BNIL);
																																					{
																																						obj_t
																																							BgL_l1220z00_2421;
																																						obj_t
																																							BgL_tail1223z00_2422;
																																						BgL_l1220z00_2421
																																							=
																																							BgL_ubindsz00_2390;
																																						BgL_tail1223z00_2422
																																							=
																																							BgL_head1222z00_2419;
																																					BgL_zc3z04anonymousza32312ze3z87_2423:
																																						if (NULLP(BgL_l1220z00_2421))
																																							{	/* Eval/evaluate.scm 481 */
																																								BgL_varsz00_2391
																																									=
																																									CDR
																																									(BgL_head1222z00_2419);
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 481 */
																																								obj_t
																																									BgL_newtail1224z00_2425;
																																								{	/* Eval/evaluate.scm 481 */
																																									BgL_ev_varz00_bglt
																																										BgL_arg2316z00_2427;
																																									{	/* Eval/evaluate.scm 481 */
																																										obj_t
																																											BgL_iz00_2428;
																																										BgL_iz00_2428
																																											=
																																											CAR
																																											(
																																											((obj_t) BgL_l1220z00_2421));
																																										{	/* Eval/evaluate.scm 482 */
																																											BgL_ev_varz00_bglt
																																												BgL_new1125z00_2429;
																																											{	/* Eval/evaluate.scm 484 */
																																												BgL_ev_varz00_bglt
																																													BgL_new1124z00_2430;
																																												BgL_new1124z00_2430
																																													=
																																													(
																																													(BgL_ev_varz00_bglt)
																																													BOBJECT
																																													(GC_MALLOC
																																														(sizeof
																																															(struct
																																																BgL_ev_varz00_bgl))));
																																												{	/* Eval/evaluate.scm 484 */
																																													long
																																														BgL_arg2318z00_2431;
																																													BgL_arg2318z00_2431
																																														=
																																														BGL_CLASS_INDEX
																																														(BGl_ev_varz00zz__evaluate_typesz00);
																																													BGL_OBJECT_CLASS_NUM_SET
																																														(
																																														((BgL_objectz00_bglt) BgL_new1124z00_2430), BgL_arg2318z00_2431);
																																												}
																																												BgL_new1125z00_2429
																																													=
																																													BgL_new1124z00_2430;
																																											}
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1125z00_2429))->BgL_namez00) = ((obj_t) CAR(((obj_t) BgL_iz00_2428))), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1125z00_2429))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1125z00_2429))->BgL_typez00) = ((obj_t) CDR(((obj_t) BgL_iz00_2428))), BUNSPEC);
																																											BgL_arg2316z00_2427
																																												=
																																												BgL_new1125z00_2429;
																																									}}
																																									BgL_newtail1224z00_2425
																																										=
																																										MAKE_YOUNG_PAIR
																																										(
																																										((obj_t) BgL_arg2316z00_2427), BNIL);
																																								}
																																								SET_CDR
																																									(BgL_tail1223z00_2422,
																																									BgL_newtail1224z00_2425);
																																								{	/* Eval/evaluate.scm 481 */
																																									obj_t
																																										BgL_arg2314z00_2426;
																																									BgL_arg2314z00_2426
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_l1220z00_2421));
																																									{
																																										obj_t
																																											BgL_tail1223z00_5603;
																																										obj_t
																																											BgL_l1220z00_5602;
																																										BgL_l1220z00_5602
																																											=
																																											BgL_arg2314z00_2426;
																																										BgL_tail1223z00_5603
																																											=
																																											BgL_newtail1224z00_2425;
																																										BgL_tail1223z00_2422
																																											=
																																											BgL_tail1223z00_5603;
																																										BgL_l1220z00_2421
																																											=
																																											BgL_l1220z00_5602;
																																										goto
																																											BgL_zc3z04anonymousza32312ze3z87_2423;
																																									}
																																								}
																																							}
																																					}
																																				}
																																			{	/* Eval/evaluate.scm 481 */
																																				obj_t
																																					BgL_bodyz00_2392;
																																				{	/* Eval/evaluate.scm 486 */
																																					bool_t
																																						BgL_test3181z00_5604;
																																					{	/* Eval/evaluate.scm 486 */
																																						obj_t
																																							BgL_tmpz00_5605;
																																						BgL_tmpz00_5605
																																							=
																																							CDR
																																							(((obj_t) BgL_bodyz00_1491));
																																						BgL_test3181z00_5604
																																							=
																																							PAIRP
																																							(BgL_tmpz00_5605);
																																					}
																																					if (BgL_test3181z00_5604)
																																						{	/* Eval/evaluate.scm 486 */
																																							obj_t
																																								BgL_res2852z00_3535;
																																							BgL_res2852z00_3535
																																								=
																																								MAKE_YOUNG_EPAIR
																																								(BGl_symbol2946z00zz__evaluatez00,
																																								BgL_bodyz00_1491,
																																								BgL_locz00_74);
																																							BgL_bodyz00_2392
																																								=
																																								BgL_res2852z00_3535;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 486 */
																																							BgL_bodyz00_2392
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_bodyz00_1491));
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 486 */
																																					obj_t
																																						BgL_tbodyz00_2393;
																																					BgL_tbodyz00_2393
																																						=
																																						BGl_typezd2checkszd2zz__evaluatez00
																																						(BgL_ubindsz00_2390,
																																						BgL_bindsz00_1490,
																																						BgL_bodyz00_2392,
																																						BgL_locz00_74,
																																						BgL_wherez00_73);
																																					{	/* Eval/evaluate.scm 487 */

																																						{	/* Eval/evaluate.scm 488 */
																																							obj_t
																																								BgL_blocz00_2394;
																																							{	/* Eval/evaluate.scm 144 */
																																								obj_t
																																									BgL__ortest_1068z00_3537;
																																								BgL__ortest_1068z00_3537
																																									=
																																									BGl_getzd2sourcezd2locationz00zz__readerz00
																																									(BgL_bindsz00_1490);
																																								if (CBOOL(BgL__ortest_1068z00_3537))
																																									{	/* Eval/evaluate.scm 144 */
																																										BgL_blocz00_2394
																																											=
																																											BgL__ortest_1068z00_3537;
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 144 */
																																										BgL_blocz00_2394
																																											=
																																											BgL_locz00_74;
																																									}
																																							}
																																							{	/* Eval/evaluate.scm 489 */
																																								BgL_ev_letz00_bglt
																																									BgL_new1129z00_2395;
																																								{	/* Eval/evaluate.scm 490 */
																																									BgL_ev_letz00_bglt
																																										BgL_new1128z00_2412;
																																									BgL_new1128z00_2412
																																										=
																																										(
																																										(BgL_ev_letz00_bglt)
																																										BOBJECT
																																										(GC_MALLOC
																																											(sizeof
																																												(struct
																																													BgL_ev_letz00_bgl))));
																																									{	/* Eval/evaluate.scm 490 */
																																										long
																																											BgL_arg2307z00_2413;
																																										BgL_arg2307z00_2413
																																											=
																																											BGL_CLASS_INDEX
																																											(BGl_ev_letz00zz__evaluate_typesz00);
																																										BGL_OBJECT_CLASS_NUM_SET
																																											(
																																											((BgL_objectz00_bglt) BgL_new1128z00_2412), BgL_arg2307z00_2413);
																																									}
																																									BgL_new1129z00_2395
																																										=
																																										BgL_new1128z00_2412;
																																								}
																																								((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1129z00_2395)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2391), BUNSPEC);
																																								{
																																									obj_t
																																										BgL_auxz00_5622;
																																									if (NULLP(BgL_bindsz00_1490))
																																										{	/* Eval/evaluate.scm 491 */
																																											BgL_auxz00_5622
																																												=
																																												BNIL;
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 491 */
																																											obj_t
																																												BgL_head1227z00_2398;
																																											BgL_head1227z00_2398
																																												=
																																												MAKE_YOUNG_PAIR
																																												(BNIL,
																																												BNIL);
																																											{
																																												obj_t
																																													BgL_l1225z00_2400;
																																												obj_t
																																													BgL_tail1228z00_2401;
																																												BgL_l1225z00_2400
																																													=
																																													BgL_bindsz00_1490;
																																												BgL_tail1228z00_2401
																																													=
																																													BgL_head1227z00_2398;
																																											BgL_zc3z04anonymousza32301ze3z87_2402:
																																												if (NULLP(BgL_l1225z00_2400))
																																													{	/* Eval/evaluate.scm 491 */
																																														BgL_auxz00_5622
																																															=
																																															CDR
																																															(BgL_head1227z00_2398);
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 491 */
																																														obj_t
																																															BgL_newtail1229z00_2404;
																																														{	/* Eval/evaluate.scm 491 */
																																															obj_t
																																																BgL_arg2304z00_2406;
																																															{	/* Eval/evaluate.scm 491 */
																																																obj_t
																																																	BgL_bz00_2407;
																																																BgL_bz00_2407
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_l1225z00_2400));
																																																{	/* Eval/evaluate.scm 492 */
																																																	obj_t
																																																		BgL_locz00_2408;
																																																	{	/* Eval/evaluate.scm 144 */
																																																		obj_t
																																																			BgL__ortest_1068z00_3543;
																																																		BgL__ortest_1068z00_3543
																																																			=
																																																			BGl_getzd2sourcezd2locationz00zz__readerz00
																																																			(BgL_bz00_2407);
																																																		if (CBOOL(BgL__ortest_1068z00_3543))
																																																			{	/* Eval/evaluate.scm 144 */
																																																				BgL_locz00_2408
																																																					=
																																																					BgL__ortest_1068z00_3543;
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 144 */
																																																				BgL_locz00_2408
																																																					=
																																																					BgL_blocz00_2394;
																																																			}
																																																	}
																																																	{	/* Eval/evaluate.scm 493 */
																																																		obj_t
																																																			BgL_arg2305z00_2409;
																																																		{	/* Eval/evaluate.scm 493 */
																																																			obj_t
																																																				BgL_pairz00_3547;
																																																			BgL_pairz00_3547
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_bz00_2407));
																																																			BgL_arg2305z00_2409
																																																				=
																																																				CAR
																																																				(BgL_pairz00_3547);
																																																		}
																																																		BgL_arg2304z00_2406
																																																			=
																																																			BGl_convz00zz__evaluatez00
																																																			(BgL_arg2305z00_2409,
																																																			BgL_localsz00_70,
																																																			BgL_globalsz00_71,
																																																			BFALSE,
																																																			BgL_wherez00_73,
																																																			BgL_locz00_2408,
																																																			((bool_t) 0));
																																																	}
																																																}
																																															}
																																															BgL_newtail1229z00_2404
																																																=
																																																MAKE_YOUNG_PAIR
																																																(BgL_arg2304z00_2406,
																																																BNIL);
																																														}
																																														SET_CDR
																																															(BgL_tail1228z00_2401,
																																															BgL_newtail1229z00_2404);
																																														{	/* Eval/evaluate.scm 491 */
																																															obj_t
																																																BgL_arg2303z00_2405;
																																															BgL_arg2303z00_2405
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_l1225z00_2400));
																																															{
																																																obj_t
																																																	BgL_tail1228z00_5644;
																																																obj_t
																																																	BgL_l1225z00_5643;
																																																BgL_l1225z00_5643
																																																	=
																																																	BgL_arg2303z00_2405;
																																																BgL_tail1228z00_5644
																																																	=
																																																	BgL_newtail1229z00_2404;
																																																BgL_tail1228z00_2401
																																																	=
																																																	BgL_tail1228z00_5644;
																																																BgL_l1225z00_2400
																																																	=
																																																	BgL_l1225z00_5643;
																																																goto
																																																	BgL_zc3z04anonymousza32301ze3z87_2402;
																																															}
																																														}
																																													}
																																											}
																																										}
																																									((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1129z00_2395)))->BgL_valsz00) = ((obj_t) BgL_auxz00_5622), BUNSPEC);
																																								}
																																								{
																																									BgL_ev_exprz00_bglt
																																										BgL_auxz00_5646;
																																									{	/* Eval/evaluate.scm 495 */
																																										obj_t
																																											BgL_arg2306z00_2411;
																																										BgL_arg2306z00_2411
																																											=
																																											BGl_appendzd221011zd2zz__evaluatez00
																																											(BgL_varsz00_2391,
																																											BgL_localsz00_70);
																																										BgL_auxz00_5646
																																											=
																																											(
																																											(BgL_ev_exprz00_bglt)
																																											BGl_convz00zz__evaluatez00
																																											(BgL_tbodyz00_2393,
																																												BgL_arg2306z00_2411,
																																												BgL_globalsz00_71,
																																												BgL_tailzf3zf3_72,
																																												BgL_wherez00_73,
																																												BgL_locz00_74,
																																												((bool_t) 0)));
																																									}
																																									((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1129z00_2395)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5646), BUNSPEC);
																																								}
																																								((((BgL_ev_letz00_bglt) COBJECT(BgL_new1129z00_2395))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																								BgL_auxz00_5560
																																									=
																																									BgL_new1129z00_2395;
																																							}
																																						}
																																					}
																																				}
																																			}
																																		}
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_5560);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1682z00_1685;
																																BgL_arg1682z00_1685
																																	=
																																	CAR
																																	(BgL_ez00_69);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_5655;
																																	{
																																		obj_t
																																			BgL_argsz00_5657;
																																		obj_t
																																			BgL_fz00_5656;
																																		BgL_fz00_5656
																																			=
																																			BgL_arg1682z00_1685;
																																		BgL_argsz00_5657
																																			=
																																			BgL_cdrzd26338zd2_1679;
																																		BgL_argsz00_1538
																																			=
																																			BgL_argsz00_5657;
																																		BgL_fz00_1537
																																			=
																																			BgL_fz00_5656;
																																		goto
																																			BgL_tagzd2176zd2_1539;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_5655);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														if (
																															(CAR(BgL_ez00_69)
																																==
																																BGl_symbol2963z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 424 */
																																if (PAIRP
																																	(BgL_cdrzd26338zd2_1679))
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg1690z00_1691;
																																		obj_t
																																			BgL_arg1691z00_1692;
																																		BgL_arg1690z00_1691
																																			=
																																			CAR
																																			(BgL_cdrzd26338zd2_1679);
																																		BgL_arg1691z00_1692
																																			=
																																			CDR
																																			(BgL_cdrzd26338zd2_1679);
																																		{
																																			BgL_ev_letza2za2_bglt
																																				BgL_auxz00_5666;
																																			BgL_bindsz00_1493
																																				=
																																				BgL_arg1690z00_1691;
																																			BgL_bodyz00_1494
																																				=
																																				BgL_arg1691z00_1692;
																																		BgL_tagzd2161zd2_1495:
																																			{	/* Eval/evaluate.scm 503 */
																																				obj_t
																																					BgL_varsz00_2448;
																																				obj_t
																																					BgL_blocz00_2449;
																																				if (NULLP(BgL_bindsz00_1493))
																																					{	/* Eval/evaluate.scm 503 */
																																						BgL_varsz00_2448
																																							=
																																							BNIL;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 503 */
																																						obj_t
																																							BgL_head1232z00_2457;
																																						BgL_head1232z00_2457
																																							=
																																							MAKE_YOUNG_PAIR
																																							(BNIL,
																																							BNIL);
																																						{
																																							obj_t
																																								BgL_l1230z00_2459;
																																							obj_t
																																								BgL_tail1233z00_2460;
																																							BgL_l1230z00_2459
																																								=
																																								BgL_bindsz00_1493;
																																							BgL_tail1233z00_2460
																																								=
																																								BgL_head1232z00_2457;
																																						BgL_zc3z04anonymousza32329ze3z87_2461:
																																							if (NULLP(BgL_l1230z00_2459))
																																								{	/* Eval/evaluate.scm 503 */
																																									BgL_varsz00_2448
																																										=
																																										CDR
																																										(BgL_head1232z00_2457);
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 503 */
																																									obj_t
																																										BgL_newtail1234z00_2463;
																																									{	/* Eval/evaluate.scm 503 */
																																										BgL_ev_varz00_bglt
																																											BgL_arg2332z00_2465;
																																										{	/* Eval/evaluate.scm 503 */
																																											obj_t
																																												BgL_bz00_2466;
																																											BgL_bz00_2466
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_l1230z00_2459));
																																											{	/* Eval/evaluate.scm 504 */
																																												obj_t
																																													BgL_iz00_2467;
																																												{	/* Eval/evaluate.scm 504 */
																																													obj_t
																																														BgL_arg2334z00_2471;
																																													BgL_arg2334z00_2471
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_bz00_2466));
																																													BgL_iz00_2467
																																														=
																																														BGl_untypezd2identzd2zz__evaluatez00
																																														(BgL_arg2334z00_2471);
																																												}
																																												{	/* Eval/evaluate.scm 505 */
																																													BgL_ev_varz00_bglt
																																														BgL_new1131z00_2468;
																																													{	/* Eval/evaluate.scm 507 */
																																														BgL_ev_varz00_bglt
																																															BgL_new1130z00_2469;
																																														BgL_new1130z00_2469
																																															=
																																															(
																																															(BgL_ev_varz00_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_varz00_bgl))));
																																														{	/* Eval/evaluate.scm 507 */
																																															long
																																																BgL_arg2333z00_2470;
																																															BgL_arg2333z00_2470
																																																=
																																																BGL_CLASS_INDEX
																																																(BGl_ev_varz00zz__evaluate_typesz00);
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1130z00_2469), BgL_arg2333z00_2470);
																																														}
																																														BgL_new1131z00_2468
																																															=
																																															BgL_new1130z00_2469;
																																													}
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1131z00_2468))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_2467)), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1131z00_2468))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1131z00_2468))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_2467)), BUNSPEC);
																																													BgL_arg2332z00_2465
																																														=
																																														BgL_new1131z00_2468;
																																										}}}
																																										BgL_newtail1234z00_2463
																																											=
																																											MAKE_YOUNG_PAIR
																																											(
																																											((obj_t) BgL_arg2332z00_2465), BNIL);
																																									}
																																									SET_CDR
																																										(BgL_tail1233z00_2460,
																																										BgL_newtail1234z00_2463);
																																									{	/* Eval/evaluate.scm 503 */
																																										obj_t
																																											BgL_arg2331z00_2464;
																																										BgL_arg2331z00_2464
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_l1230z00_2459));
																																										{
																																											obj_t
																																												BgL_tail1233z00_5693;
																																											obj_t
																																												BgL_l1230z00_5692;
																																											BgL_l1230z00_5692
																																												=
																																												BgL_arg2331z00_2464;
																																											BgL_tail1233z00_5693
																																												=
																																												BgL_newtail1234z00_2463;
																																											BgL_tail1233z00_2460
																																												=
																																												BgL_tail1233z00_5693;
																																											BgL_l1230z00_2459
																																												=
																																												BgL_l1230z00_5692;
																																											goto
																																												BgL_zc3z04anonymousza32329ze3z87_2461;
																																										}
																																									}
																																								}
																																						}
																																					}
																																				{	/* Eval/evaluate.scm 144 */
																																					obj_t
																																						BgL__ortest_1068z00_3581;
																																					BgL__ortest_1068z00_3581
																																						=
																																						BGl_getzd2sourcezd2locationz00zz__readerz00
																																						(BgL_bindsz00_1493);
																																					if (CBOOL(BgL__ortest_1068z00_3581))
																																						{	/* Eval/evaluate.scm 144 */
																																							BgL_blocz00_2449
																																								=
																																								BgL__ortest_1068z00_3581;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 144 */
																																							BgL_blocz00_2449
																																								=
																																								BgL_locz00_74;
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 510 */
																																					BgL_ev_letza2za2_bglt
																																						BgL_new1134z00_2450;
																																					{	/* Eval/evaluate.scm 511 */
																																						BgL_ev_letza2za2_bglt
																																							BgL_new1133z00_2453;
																																						BgL_new1133z00_2453
																																							=
																																							(
																																							(BgL_ev_letza2za2_bglt)
																																							BOBJECT
																																							(GC_MALLOC
																																								(sizeof
																																									(struct
																																										BgL_ev_letza2za2_bgl))));
																																						{	/* Eval/evaluate.scm 511 */
																																							long
																																								BgL_arg2327z00_2454;
																																							BgL_arg2327z00_2454
																																								=
																																								BGL_CLASS_INDEX
																																								(BGl_ev_letza2za2zz__evaluate_typesz00);
																																							BGL_OBJECT_CLASS_NUM_SET
																																								(
																																								((BgL_objectz00_bglt) BgL_new1133z00_2453), BgL_arg2327z00_2454);
																																						}
																																						BgL_new1134z00_2450
																																							=
																																							BgL_new1133z00_2453;
																																					}
																																					((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1134z00_2450)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2448), BUNSPEC);
																																					((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1134z00_2450)))->BgL_valsz00) = ((obj_t) BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_bindsz00_1493, BgL_varsz00_2448, BgL_localsz00_70, BgL_blocz00_2449)), BUNSPEC);
																																					{
																																						BgL_ev_exprz00_bglt
																																							BgL_auxz00_5706;
																																						{	/* Eval/evaluate.scm 513 */
																																							obj_t
																																								BgL_arg2325z00_2451;
																																							{	/* Eval/evaluate.scm 513 */
																																								obj_t
																																									BgL_arg2326z00_2452;
																																								BgL_arg2326z00_2452
																																									=
																																									bgl_reverse
																																									(BgL_varsz00_2448);
																																								BgL_arg2325z00_2451
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_arg2326z00_2452,
																																									BgL_localsz00_70);
																																							}
																																							BgL_auxz00_5706
																																								=
																																								(
																																								(BgL_ev_exprz00_bglt)
																																								BGl_convzd2beginzd2zz__evaluatez00
																																								(BgL_bodyz00_1494,
																																									BgL_arg2325z00_2451,
																																									BgL_globalsz00_71,
																																									BgL_tailzf3zf3_72,
																																									BgL_wherez00_73,
																																									BgL_locz00_74,
																																									((bool_t) 0)));
																																						}
																																						((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1134z00_2450)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5706), BUNSPEC);
																																					}
																																					((((BgL_ev_letza2za2_bglt) COBJECT(BgL_new1134z00_2450))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																					BgL_auxz00_5666
																																						=
																																						BgL_new1134z00_2450;
																																			}}
																																			return
																																				((obj_t)
																																				BgL_auxz00_5666);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg1695z00_1693;
																																		obj_t
																																			BgL_arg1696z00_1694;
																																		BgL_arg1695z00_1693
																																			=
																																			CAR
																																			(BgL_ez00_69);
																																		BgL_arg1696z00_1694
																																			=
																																			CDR
																																			(BgL_ez00_69);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_5717;
																																			{
																																				obj_t
																																					BgL_argsz00_5719;
																																				obj_t
																																					BgL_fz00_5718;
																																				BgL_fz00_5718
																																					=
																																					BgL_arg1695z00_1693;
																																				BgL_argsz00_5719
																																					=
																																					BgL_arg1696z00_1694;
																																				BgL_argsz00_1538
																																					=
																																					BgL_argsz00_5719;
																																				BgL_fz00_1537
																																					=
																																					BgL_fz00_5718;
																																				goto
																																					BgL_tagzd2176zd2_1539;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_5717);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_cdrzd26736zd2_1695;
																																BgL_cdrzd26736zd2_1695
																																	=
																																	CDR
																																	(BgL_ez00_69);
																																if ((CAR
																																		(BgL_ez00_69)
																																		==
																																		BGl_symbol2965z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 424 */
																																		if (PAIRP
																																			(BgL_cdrzd26736zd2_1695))
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_arg1702z00_1699;
																																				obj_t
																																					BgL_arg1704z00_1700;
																																				BgL_arg1702z00_1699
																																					=
																																					CAR
																																					(BgL_cdrzd26736zd2_1695);
																																				BgL_arg1704z00_1700
																																					=
																																					CDR
																																					(BgL_cdrzd26736zd2_1695);
																																				{
																																					BgL_ev_letrecz00_bglt
																																						BgL_auxz00_5729;
																																					BgL_bindsz00_1496
																																						=
																																						BgL_arg1702z00_1699;
																																					BgL_bodyz00_1497
																																						=
																																						BgL_arg1704z00_1700;
																																				BgL_tagzd2162zd2_1498:
																																					{	/* Eval/evaluate.scm 515 */
																																						obj_t
																																							BgL_ubindsz00_2489;
																																						if (NULLP(BgL_bindsz00_1496))
																																							{	/* Eval/evaluate.scm 515 */
																																								BgL_ubindsz00_2489
																																									=
																																									BNIL;
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 515 */
																																								obj_t
																																									BgL_head1237z00_2539;
																																								BgL_head1237z00_2539
																																									=
																																									MAKE_YOUNG_PAIR
																																									(BNIL,
																																									BNIL);
																																								{
																																									obj_t
																																										BgL_l1235z00_3608;
																																									obj_t
																																										BgL_tail1238z00_3609;
																																									BgL_l1235z00_3608
																																										=
																																										BgL_bindsz00_1496;
																																									BgL_tail1238z00_3609
																																										=
																																										BgL_head1237z00_2539;
																																								BgL_zc3z04anonymousza32372ze3z87_3607:
																																									if (NULLP(BgL_l1235z00_3608))
																																										{	/* Eval/evaluate.scm 515 */
																																											BgL_ubindsz00_2489
																																												=
																																												CDR
																																												(BgL_head1237z00_2539);
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 515 */
																																											obj_t
																																												BgL_newtail1239z00_3617;
																																											{	/* Eval/evaluate.scm 515 */
																																												obj_t
																																													BgL_arg2375z00_3618;
																																												{	/* Eval/evaluate.scm 515 */
																																													obj_t
																																														BgL_bz00_3619;
																																													BgL_bz00_3619
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_l1235z00_3608));
																																													{	/* Eval/evaluate.scm 515 */
																																														obj_t
																																															BgL_arg2376z00_3620;
																																														BgL_arg2376z00_3620
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_bz00_3619));
																																														BgL_arg2375z00_3618
																																															=
																																															BGl_untypezd2identzd2zz__evaluatez00
																																															(BgL_arg2376z00_3620);
																																													}
																																												}
																																												BgL_newtail1239z00_3617
																																													=
																																													MAKE_YOUNG_PAIR
																																													(BgL_arg2375z00_3618,
																																													BNIL);
																																											}
																																											SET_CDR
																																												(BgL_tail1238z00_3609,
																																												BgL_newtail1239z00_3617);
																																											{	/* Eval/evaluate.scm 515 */
																																												obj_t
																																													BgL_arg2374z00_3621;
																																												BgL_arg2374z00_3621
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_l1235z00_3608));
																																												{
																																													obj_t
																																														BgL_tail1238z00_5746;
																																													obj_t
																																														BgL_l1235z00_5745;
																																													BgL_l1235z00_5745
																																														=
																																														BgL_arg2374z00_3621;
																																													BgL_tail1238z00_5746
																																														=
																																														BgL_newtail1239z00_3617;
																																													BgL_tail1238z00_3609
																																														=
																																														BgL_tail1238z00_5746;
																																													BgL_l1235z00_3608
																																														=
																																														BgL_l1235z00_5745;
																																													goto
																																														BgL_zc3z04anonymousza32372ze3z87_3607;
																																												}
																																											}
																																										}
																																								}
																																							}
																																						{	/* Eval/evaluate.scm 515 */
																																							obj_t
																																								BgL_varsz00_2490;
																																							if (NULLP(BgL_ubindsz00_2489))
																																								{	/* Eval/evaluate.scm 516 */
																																									BgL_varsz00_2490
																																										=
																																										BNIL;
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 516 */
																																									obj_t
																																										BgL_head1242z00_2523;
																																									BgL_head1242z00_2523
																																										=
																																										MAKE_YOUNG_PAIR
																																										(BNIL,
																																										BNIL);
																																									{
																																										obj_t
																																											BgL_l1240z00_2525;
																																										obj_t
																																											BgL_tail1243z00_2526;
																																										BgL_l1240z00_2525
																																											=
																																											BgL_ubindsz00_2489;
																																										BgL_tail1243z00_2526
																																											=
																																											BgL_head1242z00_2523;
																																									BgL_zc3z04anonymousza32366ze3z87_2527:
																																										if (NULLP(BgL_l1240z00_2525))
																																											{	/* Eval/evaluate.scm 516 */
																																												BgL_varsz00_2490
																																													=
																																													CDR
																																													(BgL_head1242z00_2523);
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 516 */
																																												obj_t
																																													BgL_newtail1244z00_2529;
																																												{	/* Eval/evaluate.scm 516 */
																																													BgL_ev_varz00_bglt
																																														BgL_arg2369z00_2531;
																																													{	/* Eval/evaluate.scm 516 */
																																														obj_t
																																															BgL_iz00_2532;
																																														BgL_iz00_2532
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_l1240z00_2525));
																																														{	/* Eval/evaluate.scm 517 */
																																															BgL_ev_varz00_bglt
																																																BgL_new1136z00_2533;
																																															{	/* Eval/evaluate.scm 519 */
																																																BgL_ev_varz00_bglt
																																																	BgL_new1135z00_2534;
																																																BgL_new1135z00_2534
																																																	=
																																																	(
																																																	(BgL_ev_varz00_bglt)
																																																	BOBJECT
																																																	(GC_MALLOC
																																																		(sizeof
																																																			(struct
																																																				BgL_ev_varz00_bgl))));
																																																{	/* Eval/evaluate.scm 519 */
																																																	long
																																																		BgL_arg2370z00_2535;
																																																	BgL_arg2370z00_2535
																																																		=
																																																		BGL_CLASS_INDEX
																																																		(BGl_ev_varz00zz__evaluate_typesz00);
																																																	BGL_OBJECT_CLASS_NUM_SET
																																																		(
																																																		((BgL_objectz00_bglt) BgL_new1135z00_2534), BgL_arg2370z00_2535);
																																																}
																																																BgL_new1136z00_2533
																																																	=
																																																	BgL_new1135z00_2534;
																																															}
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1136z00_2533))->BgL_namez00) = ((obj_t) CAR(((obj_t) BgL_iz00_2532))), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1136z00_2533))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1136z00_2533))->BgL_typez00) = ((obj_t) CDR(((obj_t) BgL_iz00_2532))), BUNSPEC);
																																															BgL_arg2369z00_2531
																																																=
																																																BgL_new1136z00_2533;
																																													}}
																																													BgL_newtail1244z00_2529
																																														=
																																														MAKE_YOUNG_PAIR
																																														(
																																														((obj_t) BgL_arg2369z00_2531), BNIL);
																																												}
																																												SET_CDR
																																													(BgL_tail1243z00_2526,
																																													BgL_newtail1244z00_2529);
																																												{	/* Eval/evaluate.scm 516 */
																																													obj_t
																																														BgL_arg2368z00_2530;
																																													BgL_arg2368z00_2530
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_l1240z00_2525));
																																													{
																																														obj_t
																																															BgL_tail1243z00_5772;
																																														obj_t
																																															BgL_l1240z00_5771;
																																														BgL_l1240z00_5771
																																															=
																																															BgL_arg2368z00_2530;
																																														BgL_tail1243z00_5772
																																															=
																																															BgL_newtail1244z00_2529;
																																														BgL_tail1243z00_2526
																																															=
																																															BgL_tail1243z00_5772;
																																														BgL_l1240z00_2525
																																															=
																																															BgL_l1240z00_5771;
																																														goto
																																															BgL_zc3z04anonymousza32366ze3z87_2527;
																																													}
																																												}
																																											}
																																									}
																																								}
																																							{	/* Eval/evaluate.scm 516 */
																																								obj_t
																																									BgL_localsz00_2491;
																																								BgL_localsz00_2491
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_varsz00_2490,
																																									BgL_localsz00_70);
																																								{	/* Eval/evaluate.scm 521 */
																																									obj_t
																																										BgL_bodyz00_2492;
																																									{	/* Eval/evaluate.scm 522 */
																																										bool_t
																																											BgL_test3197z00_5774;
																																										{	/* Eval/evaluate.scm 522 */
																																											obj_t
																																												BgL_tmpz00_5775;
																																											BgL_tmpz00_5775
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_bodyz00_1497));
																																											BgL_test3197z00_5774
																																												=
																																												PAIRP
																																												(BgL_tmpz00_5775);
																																										}
																																										if (BgL_test3197z00_5774)
																																											{	/* Eval/evaluate.scm 522 */
																																												obj_t
																																													BgL_res2853z00_3638;
																																												BgL_res2853z00_3638
																																													=
																																													MAKE_YOUNG_EPAIR
																																													(BGl_symbol2946z00zz__evaluatez00,
																																													BgL_bodyz00_1497,
																																													BgL_locz00_74);
																																												BgL_bodyz00_2492
																																													=
																																													BgL_res2853z00_3638;
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 522 */
																																												BgL_bodyz00_2492
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_bodyz00_1497));
																																											}
																																									}
																																									{	/* Eval/evaluate.scm 522 */
																																										obj_t
																																											BgL_tbodyz00_2493;
																																										BgL_tbodyz00_2493
																																											=
																																											BGl_typezd2checkszd2zz__evaluatez00
																																											(BgL_ubindsz00_2489,
																																											BgL_bindsz00_1496,
																																											BgL_bodyz00_2492,
																																											BgL_locz00_74,
																																											BgL_wherez00_73);
																																										{	/* Eval/evaluate.scm 523 */
																																											obj_t
																																												BgL_blocz00_2494;
																																											{	/* Eval/evaluate.scm 144 */
																																												obj_t
																																													BgL__ortest_1068z00_3640;
																																												BgL__ortest_1068z00_3640
																																													=
																																													BGl_getzd2sourcezd2locationz00zz__readerz00
																																													(BgL_bindsz00_1496);
																																												if (CBOOL(BgL__ortest_1068z00_3640))
																																													{	/* Eval/evaluate.scm 144 */
																																														BgL_blocz00_2494
																																															=
																																															BgL__ortest_1068z00_3640;
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 144 */
																																														BgL_blocz00_2494
																																															=
																																															BgL_locz00_74;
																																													}
																																											}
																																											{	/* Eval/evaluate.scm 524 */

																																												{	/* Eval/evaluate.scm 525 */
																																													BgL_ev_letrecz00_bglt
																																														BgL_new1138z00_2495;
																																													{	/* Eval/evaluate.scm 526 */
																																														BgL_ev_letrecz00_bglt
																																															BgL_new1137z00_2516;
																																														BgL_new1137z00_2516
																																															=
																																															(
																																															(BgL_ev_letrecz00_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_letrecz00_bgl))));
																																														{	/* Eval/evaluate.scm 526 */
																																															long
																																																BgL_arg2361z00_2517;
																																															BgL_arg2361z00_2517
																																																=
																																																BGL_CLASS_INDEX
																																																(BGl_ev_letrecz00zz__evaluate_typesz00);
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1137z00_2516), BgL_arg2361z00_2517);
																																														}
																																														BgL_new1138z00_2495
																																															=
																																															BgL_new1137z00_2516;
																																													}
																																													((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1138z00_2495)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2490), BUNSPEC);
																																													{
																																														obj_t
																																															BgL_auxz00_5792;
																																														if (NULLP(BgL_bindsz00_1496))
																																															{	/* Eval/evaluate.scm 527 */
																																																BgL_auxz00_5792
																																																	=
																																																	BNIL;
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 527 */
																																																obj_t
																																																	BgL_head1247z00_2498;
																																																BgL_head1247z00_2498
																																																	=
																																																	MAKE_YOUNG_PAIR
																																																	(BNIL,
																																																	BNIL);
																																																{
																																																	obj_t
																																																		BgL_l1245z00_2500;
																																																	obj_t
																																																		BgL_tail1248z00_2501;
																																																	BgL_l1245z00_2500
																																																		=
																																																		BgL_bindsz00_1496;
																																																	BgL_tail1248z00_2501
																																																		=
																																																		BgL_head1247z00_2498;
																																																BgL_zc3z04anonymousza32350ze3z87_2502:
																																																	if (NULLP(BgL_l1245z00_2500))
																																																		{	/* Eval/evaluate.scm 527 */
																																																			BgL_auxz00_5792
																																																				=
																																																				CDR
																																																				(BgL_head1247z00_2498);
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 527 */
																																																			obj_t
																																																				BgL_newtail1249z00_2504;
																																																			{	/* Eval/evaluate.scm 527 */
																																																				obj_t
																																																					BgL_arg2353z00_2506;
																																																				{	/* Eval/evaluate.scm 527 */
																																																					obj_t
																																																						BgL_bz00_2507;
																																																					BgL_bz00_2507
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_l1245z00_2500));
																																																					{	/* Eval/evaluate.scm 528 */
																																																						obj_t
																																																							BgL_arg2354z00_2508;
																																																						obj_t
																																																							BgL_arg2355z00_2509;
																																																						obj_t
																																																							BgL_arg2356z00_2510;
																																																						{	/* Eval/evaluate.scm 528 */
																																																							obj_t
																																																								BgL_pairz00_3649;
																																																							BgL_pairz00_3649
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_bz00_2507));
																																																							BgL_arg2354z00_2508
																																																								=
																																																								CAR
																																																								(BgL_pairz00_3649);
																																																						}
																																																						{	/* Eval/evaluate.scm 528 */
																																																							obj_t
																																																								BgL_arg2357z00_2511;
																																																							BgL_arg2357z00_2511
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_bz00_2507));
																																																							{	/* Eval/evaluate.scm 528 */
																																																								obj_t
																																																									BgL_list2358z00_2512;
																																																								{	/* Eval/evaluate.scm 528 */
																																																									obj_t
																																																										BgL_arg2359z00_2513;
																																																									{	/* Eval/evaluate.scm 528 */
																																																										obj_t
																																																											BgL_arg2360z00_2514;
																																																										BgL_arg2360z00_2514
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(BgL_wherez00_73,
																																																											BNIL);
																																																										BgL_arg2359z00_2513
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(BGl_symbol2948z00zz__evaluatez00,
																																																											BgL_arg2360z00_2514);
																																																									}
																																																									BgL_list2358z00_2512
																																																										=
																																																										MAKE_YOUNG_PAIR
																																																										(BgL_arg2357z00_2511,
																																																										BgL_arg2359z00_2513);
																																																								}
																																																								BgL_arg2355z00_2509
																																																									=
																																																									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																																																									(BgL_list2358z00_2512);
																																																							}
																																																						}
																																																						{	/* Eval/evaluate.scm 144 */
																																																							obj_t
																																																								BgL__ortest_1068z00_3651;
																																																							BgL__ortest_1068z00_3651
																																																								=
																																																								BGl_getzd2sourcezd2locationz00zz__readerz00
																																																								(BgL_bz00_2507);
																																																							if (CBOOL(BgL__ortest_1068z00_3651))
																																																								{	/* Eval/evaluate.scm 144 */
																																																									BgL_arg2356z00_2510
																																																										=
																																																										BgL__ortest_1068z00_3651;
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 144 */
																																																									BgL_arg2356z00_2510
																																																										=
																																																										BgL_blocz00_2494;
																																																								}
																																																						}
																																																						BgL_arg2353z00_2506
																																																							=
																																																							BGl_convz00zz__evaluatez00
																																																							(BgL_arg2354z00_2508,
																																																							BgL_localsz00_2491,
																																																							BgL_globalsz00_71,
																																																							BFALSE,
																																																							BgL_arg2355z00_2509,
																																																							BgL_arg2356z00_2510,
																																																							((bool_t) 0));
																																																					}
																																																				}
																																																				BgL_newtail1249z00_2504
																																																					=
																																																					MAKE_YOUNG_PAIR
																																																					(BgL_arg2353z00_2506,
																																																					BNIL);
																																																			}
																																																			SET_CDR
																																																				(BgL_tail1248z00_2501,
																																																				BgL_newtail1249z00_2504);
																																																			{	/* Eval/evaluate.scm 527 */
																																																				obj_t
																																																					BgL_arg2352z00_2505;
																																																				BgL_arg2352z00_2505
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_l1245z00_2500));
																																																				{
																																																					obj_t
																																																						BgL_tail1248z00_5820;
																																																					obj_t
																																																						BgL_l1245z00_5819;
																																																					BgL_l1245z00_5819
																																																						=
																																																						BgL_arg2352z00_2505;
																																																					BgL_tail1248z00_5820
																																																						=
																																																						BgL_newtail1249z00_2504;
																																																					BgL_tail1248z00_2501
																																																						=
																																																						BgL_tail1248z00_5820;
																																																					BgL_l1245z00_2500
																																																						=
																																																						BgL_l1245z00_5819;
																																																					goto
																																																						BgL_zc3z04anonymousza32350ze3z87_2502;
																																																				}
																																																			}
																																																		}
																																																}
																																															}
																																														((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1138z00_2495)))->BgL_valsz00) = ((obj_t) BgL_auxz00_5792), BUNSPEC);
																																													}
																																													((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1138z00_2495)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convz00zz__evaluatez00(BgL_tbodyz00_2493, BgL_localsz00_2491, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													BgL_auxz00_5729
																																														=
																																														BgL_new1138z00_2495;
																																												}
																																											}
																																										}
																																									}
																																								}
																																							}
																																						}
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_5729);
																																				}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_arg1705z00_1701;
																																				BgL_arg1705z00_1701
																																					=
																																					CAR
																																					(BgL_ez00_69);
																																				{
																																					BgL_ev_appz00_bglt
																																						BgL_auxz00_5828;
																																					{
																																						obj_t
																																							BgL_argsz00_5830;
																																						obj_t
																																							BgL_fz00_5829;
																																						BgL_fz00_5829
																																							=
																																							BgL_arg1705z00_1701;
																																						BgL_argsz00_5830
																																							=
																																							BgL_cdrzd26736zd2_1695;
																																						BgL_argsz00_1538
																																							=
																																							BgL_argsz00_5830;
																																						BgL_fz00_1537
																																							=
																																							BgL_fz00_5829;
																																						goto
																																							BgL_tagzd2176zd2_1539;
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_5828);
																																				}
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		if (
																																			(CAR
																																				(BgL_ez00_69)
																																				==
																																				BGl_symbol2967z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 424 */
																																				if (PAIRP(BgL_cdrzd26736zd2_1695))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_carzd26912zd2_1707;
																																						obj_t
																																							BgL_cdrzd26913zd2_1708;
																																						BgL_carzd26912zd2_1707
																																							=
																																							CAR
																																							(BgL_cdrzd26736zd2_1695);
																																						BgL_cdrzd26913zd2_1708
																																							=
																																							CDR
																																							(BgL_cdrzd26736zd2_1695);
																																						if (PAIRP(BgL_carzd26912zd2_1707))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd26917zd2_1710;
																																								BgL_cdrzd26917zd2_1710
																																									=
																																									CDR
																																									(BgL_carzd26912zd2_1707);
																																								if ((CAR(BgL_carzd26912zd2_1707) == BGl_symbol2953z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd26917zd2_1710))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_carzd26920zd2_1714;
																																												obj_t
																																													BgL_cdrzd26921zd2_1715;
																																												BgL_carzd26920zd2_1714
																																													=
																																													CAR
																																													(BgL_cdrzd26917zd2_1710);
																																												BgL_cdrzd26921zd2_1715
																																													=
																																													CDR
																																													(BgL_cdrzd26917zd2_1710);
																																												if (SYMBOLP(BgL_carzd26920zd2_1714))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd26921zd2_1715))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_carzd26925zd2_1718;
																																																BgL_carzd26925zd2_1718
																																																	=
																																																	CAR
																																																	(BgL_cdrzd26921zd2_1715);
																																																if (SYMBOLP(BgL_carzd26925zd2_1718))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd26921zd2_1715)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (PAIRP(BgL_cdrzd26913zd2_1708))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						if (NULLP(CDR(BgL_cdrzd26913zd2_1708)))
																																																							{	/* Eval/evaluate.scm 424 */
																																																								obj_t
																																																									BgL_arg1724z00_1725;
																																																								BgL_arg1724z00_1725
																																																									=
																																																									CAR
																																																									(BgL_cdrzd26913zd2_1708);
																																																								{	/* Eval/evaluate.scm 531 */
																																																									BgL_ev_setglobalz00_bglt
																																																										BgL_new1140z00_3884;
																																																									{	/* Eval/evaluate.scm 535 */
																																																										BgL_ev_setglobalz00_bglt
																																																											BgL_new1139z00_3885;
																																																										BgL_new1139z00_3885
																																																											=
																																																											(
																																																											(BgL_ev_setglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_setglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 535 */
																																																											long
																																																												BgL_arg2377z00_3886;
																																																											BgL_arg2377z00_3886
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1139z00_3885), BgL_arg2377z00_3886);
																																																										}
																																																										BgL_new1140z00_3884
																																																											=
																																																											BgL_new1139z00_3885;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_5869;
																																																										{	/* Eval/evaluate.scm 380 */
																																																											obj_t
																																																												BgL_arg2427z00_3890;
																																																											BgL_arg2427z00_3890
																																																												=
																																																												BGl_getzd2locationzd2zz__evaluatez00
																																																												(BgL_arg1724z00_1725,
																																																												BgL_locz00_74);
																																																											BgL_auxz00_5869
																																																												=
																																																												(
																																																												(BgL_ev_exprz00_bglt)
																																																												BGl_uconvzf2locze70z15zz__evaluatez00
																																																												(BgL_wherez00_73,
																																																													BgL_globalsz00_71,
																																																													BgL_localsz00_70,
																																																													BgL_arg1724z00_1725,
																																																													BgL_arg2427z00_3890));
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1140z00_3884)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5869), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1140z00_3884))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1140z00_3884))->BgL_namez00) = ((obj_t) BgL_carzd26920zd2_1714), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1140z00_3884))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_carzd26925zd2_1718)), BUNSPEC);
																																																									return
																																																										(
																																																										(obj_t)
																																																										BgL_new1140z00_3884);
																																																								}
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 424 */
																																																								return
																																																									BGl_evcompilezd2errorzd2zz__evcompilez00
																																																									(BgL_locz00_74,
																																																									BGl_string2870z00zz__evaluatez00,
																																																									BGl_string2945z00zz__evaluatez00,
																																																									BgL_ez00_69);
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_74,
																																																							BGl_string2870z00zz__evaluatez00,
																																																							BGl_string2945z00zz__evaluatez00,
																																																							BgL_ez00_69);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_cdrzd27041zd2_1727;
																																																				BgL_cdrzd27041zd2_1727
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_cdrzd27045zd2_1728;
																																																					BgL_cdrzd27045zd2_1728
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd27041zd2_1727));
																																																					if (PAIRP(BgL_cdrzd27045zd2_1728))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							if (NULLP(CDR(BgL_cdrzd27045zd2_1728)))
																																																								{	/* Eval/evaluate.scm 424 */
																																																									obj_t
																																																										BgL_arg1729z00_1732;
																																																									obj_t
																																																										BgL_arg1730z00_1733;
																																																									BgL_arg1729z00_1732
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd27041zd2_1727));
																																																									BgL_arg1730z00_1733
																																																										=
																																																										CAR
																																																										(BgL_cdrzd27045zd2_1728);
																																																									{
																																																										BgL_ev_hookz00_bglt
																																																											BgL_auxz00_5893;
																																																										BgL_vz00_1506
																																																											=
																																																											BgL_arg1729z00_1732;
																																																										BgL_ez00_1507
																																																											=
																																																											BgL_arg1730z00_1733;
																																																									BgL_tagzd2165zd2_1508:
																																																										{	/* Eval/evaluate.scm 541 */
																																																											obj_t
																																																												BgL_cvz00_2580;
																																																											obj_t
																																																												BgL_ez00_2581;
																																																											BgL_cvz00_2580
																																																												=
																																																												BGl_convzd2varzd2zz__evaluatez00
																																																												(BgL_vz00_1506,
																																																												BgL_localsz00_70);
																																																											{	/* Eval/evaluate.scm 380 */
																																																												obj_t
																																																													BgL_arg2427z00_3665;
																																																												{	/* Eval/evaluate.scm 144 */
																																																													obj_t
																																																														BgL__ortest_1068z00_3666;
																																																													BgL__ortest_1068z00_3666
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_ez00_1507);
																																																													if (CBOOL(BgL__ortest_1068z00_3666))
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2427z00_3665
																																																																=
																																																																BgL__ortest_1068z00_3666;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2427z00_3665
																																																																=
																																																																BgL_locz00_74;
																																																														}
																																																												}
																																																												BgL_ez00_2581
																																																													=
																																																													BGl_convz00zz__evaluatez00
																																																													(BgL_ez00_1507,
																																																													BgL_localsz00_70,
																																																													BgL_globalsz00_71,
																																																													BFALSE,
																																																													BgL_wherez00_73,
																																																													BgL_arg2427z00_3665,
																																																													((bool_t) 0));
																																																											}
																																																											if (CBOOL(BgL_cvz00_2580))
																																																												{	/* Eval/evaluate.scm 543 */
																																																													BgL_ev_setlocalz00_bglt
																																																														BgL_new1142z00_2582;
																																																													{	/* Eval/evaluate.scm 545 */
																																																														BgL_ev_setlocalz00_bglt
																																																															BgL_new1141z00_2583;
																																																														BgL_new1141z00_2583
																																																															=
																																																															(
																																																															(BgL_ev_setlocalz00_bglt)
																																																															BOBJECT
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setlocalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 545 */
																																																															long
																																																																BgL_arg2392z00_2584;
																																																															BgL_arg2392z00_2584
																																																																=
																																																																BGL_CLASS_INDEX
																																																																(BGl_ev_setlocalz00zz__evaluate_typesz00);
																																																															BGL_OBJECT_CLASS_NUM_SET
																																																																(
																																																																((BgL_objectz00_bglt) BgL_new1141z00_2583), BgL_arg2392z00_2584);
																																																														}
																																																														BgL_new1142z00_2582
																																																															=
																																																															BgL_new1141z00_2583;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1142z00_2582)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_2581)), BUNSPEC);
																																																													((((BgL_ev_setlocalz00_bglt) COBJECT(BgL_new1142z00_2582))->BgL_vz00) = ((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_cvz00_2580)), BUNSPEC);
																																																													BgL_auxz00_5893
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1142z00_2582);
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 546 */
																																																													BgL_ev_setglobalz00_bglt
																																																														BgL_new1144z00_2585;
																																																													{	/* Eval/evaluate.scm 550 */
																																																														BgL_ev_setglobalz00_bglt
																																																															BgL_new1143z00_2587;
																																																														BgL_new1143z00_2587
																																																															=
																																																															(
																																																															(BgL_ev_setglobalz00_bglt)
																																																															BOBJECT
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setglobalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 550 */
																																																															long
																																																																BgL_arg2394z00_2588;
																																																															BgL_arg2394z00_2588
																																																																=
																																																																BGL_CLASS_INDEX
																																																																(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																															BGL_OBJECT_CLASS_NUM_SET
																																																																(
																																																																((BgL_objectz00_bglt) BgL_new1143z00_2587), BgL_arg2394z00_2588);
																																																														}
																																																														BgL_new1144z00_2585
																																																															=
																																																															BgL_new1143z00_2587;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1144z00_2585)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_2581)), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1144z00_2585))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1144z00_2585))->BgL_namez00) = ((obj_t) BgL_vz00_1506), BUNSPEC);
																																																													{
																																																														obj_t
																																																															BgL_auxz00_5920;
																																																														if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																															{	/* Eval/evaluate.scm 549 */
																																																																BgL_auxz00_5920
																																																																	=
																																																																	BgL_globalsz00_71;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 549 */
																																																																BgL_auxz00_5920
																																																																	=
																																																																	BGL_MODULE
																																																																	();
																																																															}
																																																														((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1144z00_2585))->BgL_modz00) = ((obj_t) BgL_auxz00_5920), BUNSPEC);
																																																													}
																																																													BgL_auxz00_5893
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1144z00_2585);
																																																												}
																																																										}
																																																										return
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_5893);
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 424 */
																																																									return
																																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																																										(BgL_locz00_74,
																																																										BGl_string2870z00zz__evaluatez00,
																																																										BGl_string2945z00zz__evaluatez00,
																																																										BgL_ez00_69);
																																																								}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string2870z00zz__evaluatez00,
																																																								BGl_string2945z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd27102zd2_1736;
																																																		BgL_cdrzd27102zd2_1736
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_cdrzd27106zd2_1737;
																																																			BgL_cdrzd27106zd2_1737
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd27102zd2_1736));
																																																			if (PAIRP(BgL_cdrzd27106zd2_1737))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					if (NULLP(CDR(BgL_cdrzd27106zd2_1737)))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							obj_t
																																																								BgL_arg1737z00_1741;
																																																							obj_t
																																																								BgL_arg1739z00_1742;
																																																							BgL_arg1737z00_1741
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd27102zd2_1736));
																																																							BgL_arg1739z00_1742
																																																								=
																																																								CAR
																																																								(BgL_cdrzd27106zd2_1737);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_5940;
																																																								{
																																																									obj_t
																																																										BgL_ez00_5942;
																																																									obj_t
																																																										BgL_vz00_5941;
																																																									BgL_vz00_5941
																																																										=
																																																										BgL_arg1737z00_1741;
																																																									BgL_ez00_5942
																																																										=
																																																										BgL_arg1739z00_1742;
																																																									BgL_ez00_1507
																																																										=
																																																										BgL_ez00_5942;
																																																									BgL_vz00_1506
																																																										=
																																																										BgL_vz00_5941;
																																																									goto
																																																										BgL_tagzd2165zd2_1508;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_5940);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string2870z00zz__evaluatez00,
																																																								BGl_string2945z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string2870z00zz__evaluatez00,
																																																						BGl_string2945z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27163zd2_1744;
																																																BgL_cdrzd27163zd2_1744
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_cdrzd27167zd2_1745;
																																																	BgL_cdrzd27167zd2_1745
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd27163zd2_1744));
																																																	if (PAIRP(BgL_cdrzd27167zd2_1745))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			if (NULLP(CDR(BgL_cdrzd27167zd2_1745)))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_arg1745z00_1749;
																																																					obj_t
																																																						BgL_arg1746z00_1750;
																																																					BgL_arg1745z00_1749
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd27163zd2_1744));
																																																					BgL_arg1746z00_1750
																																																						=
																																																						CAR
																																																						(BgL_cdrzd27167zd2_1745);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_5957;
																																																						{
																																																							obj_t
																																																								BgL_ez00_5959;
																																																							obj_t
																																																								BgL_vz00_5958;
																																																							BgL_vz00_5958
																																																								=
																																																								BgL_arg1745z00_1749;
																																																							BgL_ez00_5959
																																																								=
																																																								BgL_arg1746z00_1750;
																																																							BgL_ez00_1507
																																																								=
																																																								BgL_ez00_5959;
																																																							BgL_vz00_1506
																																																								=
																																																								BgL_vz00_5958;
																																																							goto
																																																								BgL_tagzd2165zd2_1508;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_5957);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string2870z00zz__evaluatez00,
																																																						BGl_string2945z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string2870z00zz__evaluatez00,
																																																				BGl_string2945z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd27224zd2_1752;
																																														BgL_cdrzd27224zd2_1752
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_cdrzd27228zd2_1753;
																																															BgL_cdrzd27228zd2_1753
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd27224zd2_1752));
																																															if (PAIRP(BgL_cdrzd27228zd2_1753))
																																																{	/* Eval/evaluate.scm 424 */
																																																	if (NULLP(CDR(BgL_cdrzd27228zd2_1753)))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_arg1751z00_1757;
																																																			obj_t
																																																				BgL_arg1752z00_1758;
																																																			BgL_arg1751z00_1757
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd27224zd2_1752));
																																																			BgL_arg1752z00_1758
																																																				=
																																																				CAR
																																																				(BgL_cdrzd27228zd2_1753);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_5974;
																																																				{
																																																					obj_t
																																																						BgL_ez00_5976;
																																																					obj_t
																																																						BgL_vz00_5975;
																																																					BgL_vz00_5975
																																																						=
																																																						BgL_arg1751z00_1757;
																																																					BgL_ez00_5976
																																																						=
																																																						BgL_arg1752z00_1758;
																																																					BgL_ez00_1507
																																																						=
																																																						BgL_ez00_5976;
																																																					BgL_vz00_1506
																																																						=
																																																						BgL_vz00_5975;
																																																					goto
																																																						BgL_tagzd2165zd2_1508;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_5974);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string2870z00zz__evaluatez00,
																																																				BGl_string2945z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2870z00zz__evaluatez00,
																																																		BGl_string2945z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd27285zd2_1760;
																																												BgL_cdrzd27285zd2_1760
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd27289zd2_1761;
																																													BgL_cdrzd27289zd2_1761
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd27285zd2_1760));
																																													if (PAIRP(BgL_cdrzd27289zd2_1761))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27289zd2_1761)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1757z00_1765;
																																																	obj_t
																																																		BgL_arg1758z00_1766;
																																																	BgL_arg1757z00_1765
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27285zd2_1760));
																																																	BgL_arg1758z00_1766
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27289zd2_1761);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_5991;
																																																		{
																																																			obj_t
																																																				BgL_ez00_5993;
																																																			obj_t
																																																				BgL_vz00_5992;
																																																			BgL_vz00_5992
																																																				=
																																																				BgL_arg1757z00_1765;
																																																			BgL_ez00_5993
																																																				=
																																																				BgL_arg1758z00_1766;
																																																			BgL_ez00_1507
																																																				=
																																																				BgL_ez00_5993;
																																																			BgL_vz00_1506
																																																				=
																																																				BgL_vz00_5992;
																																																			goto
																																																				BgL_tagzd2165zd2_1508;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_5991);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2870z00zz__evaluatez00,
																																																		BGl_string2945z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2870z00zz__evaluatez00,
																																																BGl_string2945z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd27333zd2_1768;
																																										BgL_cdrzd27333zd2_1768
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_carzd27336zd2_1769;
																																											obj_t
																																												BgL_cdrzd27337zd2_1770;
																																											BgL_carzd27336zd2_1769
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd27333zd2_1768));
																																											BgL_cdrzd27337zd2_1770
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd27333zd2_1768));
																																											if ((CAR(((obj_t) BgL_carzd27336zd2_1769)) == BGl_symbol2955z00zz__evaluatez00))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (PAIRP(BgL_cdrzd27337zd2_1770))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27337zd2_1770)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1766z00_1776;
																																																	obj_t
																																																		BgL_arg1768z00_1777;
																																																	BgL_arg1766z00_1776
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd27336zd2_1769));
																																																	BgL_arg1768z00_1777
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27337zd2_1770);
																																																	BgL_lz00_1503
																																																		=
																																																		BgL_arg1766z00_1776;
																																																	BgL_e2z00_1504
																																																		=
																																																		BgL_arg1768z00_1777;
																																																BgL_tagzd2164zd2_1505:
																																																	{	/* Eval/evaluate.scm 537 */
																																																		bool_t
																																																			BgL_test3229z00_6014;
																																																		if (PAIRP(BgL_lz00_1503))
																																																			{	/* Eval/evaluate.scm 537 */
																																																				bool_t
																																																					BgL_test3231z00_6017;
																																																				{	/* Eval/evaluate.scm 537 */
																																																					obj_t
																																																						BgL_tmpz00_6018;
																																																					BgL_tmpz00_6018
																																																						=
																																																						CDR
																																																						(BgL_lz00_1503);
																																																					BgL_test3231z00_6017
																																																						=
																																																						PAIRP
																																																						(BgL_tmpz00_6018);
																																																				}
																																																				if (BgL_test3231z00_6017)
																																																					{
																																																						obj_t
																																																							BgL_l1250z00_2571;
																																																						BgL_l1250z00_2571
																																																							=
																																																							BgL_lz00_1503;
																																																					BgL_zc3z04anonymousza32387ze3z87_2572:
																																																						if (NULLP(BgL_l1250z00_2571))
																																																							{	/* Eval/evaluate.scm 537 */
																																																								BgL_test3229z00_6014
																																																									=
																																																									(
																																																									(bool_t)
																																																									1);
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 537 */
																																																								bool_t
																																																									BgL_test3233z00_6023;
																																																								{	/* Eval/evaluate.scm 537 */
																																																									obj_t
																																																										BgL_tmpz00_6024;
																																																									BgL_tmpz00_6024
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_l1250z00_2571));
																																																									BgL_test3233z00_6023
																																																										=
																																																										SYMBOLP
																																																										(BgL_tmpz00_6024);
																																																								}
																																																								if (BgL_test3233z00_6023)
																																																									{
																																																										obj_t
																																																											BgL_l1250z00_6028;
																																																										BgL_l1250z00_6028
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_l1250z00_2571));
																																																										BgL_l1250z00_2571
																																																											=
																																																											BgL_l1250z00_6028;
																																																										goto
																																																											BgL_zc3z04anonymousza32387ze3z87_2572;
																																																									}
																																																								else
																																																									{	/* Eval/evaluate.scm 537 */
																																																										BgL_test3229z00_6014
																																																											=
																																																											(
																																																											(bool_t)
																																																											0);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 537 */
																																																						BgL_test3229z00_6014
																																																							=
																																																							(
																																																							(bool_t)
																																																							0);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 537 */
																																																				BgL_test3229z00_6014
																																																					=
																																																					(
																																																					(bool_t)
																																																					0);
																																																			}
																																																		if (BgL_test3229z00_6014)
																																																			{	/* Eval/evaluate.scm 537 */
																																																				return
																																																					BGl_convzd2fieldzd2setz00zz__evaluatez00
																																																					(BgL_lz00_1503,
																																																					BgL_e2z00_1504,
																																																					BgL_ez00_69,
																																																					BgL_localsz00_70,
																																																					BgL_globalsz00_71,
																																																					BgL_tailzf3zf3_72,
																																																					BgL_wherez00_73,
																																																					BgL_locz00_74,
																																																					BgL_topzf3zf3_75);
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 537 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_74,
																																																					BGl_string2870z00zz__evaluatez00,
																																																					BGl_string2945z00zz__evaluatez00,
																																																					BgL_ez00_69);
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2870z00zz__evaluatez00,
																																																		BGl_string2945z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2870z00zz__evaluatez00,
																																																BGl_string2945z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd27413zd2_1780;
																																													BgL_cdrzd27413zd2_1780
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd27333zd2_1768));
																																													if (PAIRP(BgL_cdrzd27413zd2_1780))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27413zd2_1780)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1774z00_1784;
																																																	obj_t
																																																		BgL_arg1775z00_1785;
																																																	BgL_arg1774z00_1784
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27333zd2_1768));
																																																	BgL_arg1775z00_1785
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27413zd2_1780);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6045;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6047;
																																																			obj_t
																																																				BgL_vz00_6046;
																																																			BgL_vz00_6046
																																																				=
																																																				BgL_arg1774z00_1784;
																																																			BgL_ez00_6047
																																																				=
																																																				BgL_arg1775z00_1785;
																																																			BgL_ez00_1507
																																																				=
																																																				BgL_ez00_6047;
																																																			BgL_vz00_1506
																																																				=
																																																				BgL_vz00_6046;
																																																			goto
																																																				BgL_tagzd2165zd2_1508;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6045);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2870z00zz__evaluatez00,
																																																		BGl_string2945z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2870z00zz__evaluatez00,
																																																BGl_string2945z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd27470zd2_1789;
																																								BgL_cdrzd27470zd2_1789
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{	/* Eval/evaluate.scm 424 */
																																									obj_t
																																										BgL_cdrzd27474zd2_1790;
																																									BgL_cdrzd27474zd2_1790
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd27470zd2_1789));
																																									if (PAIRP(BgL_cdrzd27474zd2_1790))
																																										{	/* Eval/evaluate.scm 424 */
																																											if (NULLP(CDR(BgL_cdrzd27474zd2_1790)))
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_arg1782z00_1794;
																																													obj_t
																																														BgL_arg1783z00_1795;
																																													BgL_arg1782z00_1794
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd27470zd2_1789));
																																													BgL_arg1783z00_1795
																																														=
																																														CAR
																																														(BgL_cdrzd27474zd2_1790);
																																													{
																																														BgL_ev_hookz00_bglt
																																															BgL_auxz00_6062;
																																														{
																																															obj_t
																																																BgL_ez00_6064;
																																															obj_t
																																																BgL_vz00_6063;
																																															BgL_vz00_6063
																																																=
																																																BgL_arg1782z00_1794;
																																															BgL_ez00_6064
																																																=
																																																BgL_arg1783z00_1795;
																																															BgL_ez00_1507
																																																=
																																																BgL_ez00_6064;
																																															BgL_vz00_1506
																																																=
																																																BgL_vz00_6063;
																																															goto
																																																BgL_tagzd2165zd2_1508;
																																														}
																																														return
																																															(
																																															(obj_t)
																																															BgL_auxz00_6062);
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string2870z00zz__evaluatez00,
																																														BGl_string2945z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_74,
																																												BGl_string2870z00zz__evaluatez00,
																																												BGl_string2945z00zz__evaluatez00,
																																												BgL_ez00_69);
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						return
																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																							(BgL_locz00_74,
																																							BGl_string2870z00zz__evaluatez00,
																																							BGl_string2945z00zz__evaluatez00,
																																							BgL_ez00_69);
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_cdrzd27595zd2_1797;
																																				BgL_cdrzd27595zd2_1797
																																					=
																																					CDR
																																					(BgL_ez00_69);
																																				if ((CAR
																																						(BgL_ez00_69)
																																						==
																																						BGl_symbol2969z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 424 */
																																						if (PAIRP(BgL_cdrzd27595zd2_1797))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd27600zd2_1801;
																																								BgL_cdrzd27600zd2_1801
																																									=
																																									CDR
																																									(BgL_cdrzd27595zd2_1797);
																																								if (PAIRP(BgL_cdrzd27600zd2_1801))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd27604zd2_1803;
																																										BgL_carzd27604zd2_1803
																																											=
																																											CAR
																																											(BgL_cdrzd27600zd2_1801);
																																										if (PAIRP(BgL_carzd27604zd2_1803))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd27609zd2_1805;
																																												BgL_cdrzd27609zd2_1805
																																													=
																																													CDR
																																													(BgL_carzd27604zd2_1803);
																																												if ((CAR(BgL_carzd27604zd2_1803) == BGl_symbol2934z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd27609zd2_1805))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27613zd2_1809;
																																																BgL_cdrzd27613zd2_1809
																																																	=
																																																	CDR
																																																	(BgL_cdrzd27609zd2_1805);
																																																if (PAIRP(BgL_cdrzd27613zd2_1809))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd27613zd2_1809)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd27600zd2_1801)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1799z00_1815;
																																																						obj_t
																																																							BgL_arg1800z00_1816;
																																																						obj_t
																																																							BgL_arg1801z00_1817;
																																																						BgL_arg1799z00_1815
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27595zd2_1797);
																																																						BgL_arg1800z00_1816
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27609zd2_1805);
																																																						BgL_arg1801z00_1817
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27613zd2_1809);
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_6099;
																																																							BgL_gvz00_1510
																																																								=
																																																								BgL_arg1799z00_1815;
																																																							BgL_formalsz00_1511
																																																								=
																																																								BgL_arg1800z00_1816;
																																																							BgL_bodyz00_1512
																																																								=
																																																								BgL_arg1801z00_1817;
																																																						BgL_tagzd2167zd2_1513:
																																																							{	/* Eval/evaluate.scm 554 */
																																																								obj_t
																																																									BgL_tidz00_2589;
																																																								BgL_tidz00_2589
																																																									=
																																																									BGl_untypezd2identzd2zz__evaluatez00
																																																									(BgL_gvz00_1510);
																																																								{	/* Eval/evaluate.scm 555 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1146z00_2590;
																																																									{	/* Eval/evaluate.scm 559 */
																																																										BgL_ev_defglobalz00_bglt
																																																											BgL_new1145z00_2593;
																																																										BgL_new1145z00_2593
																																																											=
																																																											(
																																																											(BgL_ev_defglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_defglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 559 */
																																																											long
																																																												BgL_arg2397z00_2594;
																																																											BgL_arg2397z00_2594
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1145z00_2593), BgL_arg2397z00_2594);
																																																										}
																																																										BgL_new1146z00_2590
																																																											=
																																																											BgL_new1145z00_2593;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6105;
																																																										{	/* Eval/evaluate.scm 559 */
																																																											obj_t
																																																												BgL_arg2395z00_2591;
																																																											BgL_arg2395z00_2591
																																																												=
																																																												CDR
																																																												(BgL_tidz00_2589);
																																																											BgL_auxz00_6105
																																																												=
																																																												(
																																																												(BgL_ev_exprz00_bglt)
																																																												BGl_convzd2lambdaze70z35zz__evaluatez00
																																																												(BgL_globalsz00_71,
																																																													BgL_localsz00_70,
																																																													BgL_ez00_69,
																																																													BgL_locz00_74,
																																																													BgL_formalsz00_1511,
																																																													BgL_bodyz00_1512,
																																																													BgL_gvz00_1510,
																																																													BgL_arg2395z00_2591));
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1146z00_2590)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6105), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2590)))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2590)))->BgL_namez00) = ((obj_t) CAR(BgL_tidz00_2589)), BUNSPEC);
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6116;
																																																										if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																											{	/* Eval/evaluate.scm 558 */
																																																												BgL_auxz00_6116
																																																													=
																																																													BgL_globalsz00_71;
																																																											}
																																																										else
																																																											{	/* Eval/evaluate.scm 558 */
																																																												BgL_auxz00_6116
																																																													=
																																																													BGL_MODULE
																																																													();
																																																											}
																																																										((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2590)))->BgL_modz00) = ((obj_t) BgL_auxz00_6116), BUNSPEC);
																																																									}
																																																									BgL_auxz00_6099
																																																										=
																																																										BgL_new1146z00_2590;
																																																								}
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6099);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1802z00_1818;
																																																						BgL_arg1802z00_1818
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6124;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6126;
																																																								obj_t
																																																									BgL_fz00_6125;
																																																								BgL_fz00_6125
																																																									=
																																																									BgL_arg1802z00_1818;
																																																								BgL_argsz00_6126
																																																									=
																																																									BgL_cdrzd27595zd2_1797;
																																																								BgL_argsz00_1538
																																																									=
																																																									BgL_argsz00_6126;
																																																								BgL_fz00_1537
																																																									=
																																																									BgL_fz00_6125;
																																																								goto
																																																									BgL_tagzd2176zd2_1539;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6124);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_cdrzd27715zd2_1822;
																																																				BgL_cdrzd27715zd2_1822
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd27595zd2_1797));
																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd27715zd2_1822))))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1810z00_1825;
																																																						obj_t
																																																							BgL_arg1811z00_1826;
																																																						BgL_arg1810z00_1825
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd27595zd2_1797));
																																																						BgL_arg1811z00_1826
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd27715zd2_1822));
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_6138;
																																																							BgL_gvz00_1514
																																																								=
																																																								BgL_arg1810z00_1825;
																																																							BgL_gez00_1515
																																																								=
																																																								BgL_arg1811z00_1826;
																																																						BgL_tagzd2168zd2_1516:
																																																							{	/* Eval/evaluate.scm 561 */
																																																								obj_t
																																																									BgL_tidz00_2595;
																																																								BgL_tidz00_2595
																																																									=
																																																									BGl_untypezd2identzd2zz__evaluatez00
																																																									(BgL_gvz00_1514);
																																																								{	/* Eval/evaluate.scm 562 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1148z00_2596;
																																																									{	/* Eval/evaluate.scm 566 */
																																																										BgL_ev_defglobalz00_bglt
																																																											BgL_new1147z00_2601;
																																																										BgL_new1147z00_2601
																																																											=
																																																											(
																																																											(BgL_ev_defglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_defglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 566 */
																																																											long
																																																												BgL_arg2403z00_2602;
																																																											BgL_arg2403z00_2602
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1147z00_2601), BgL_arg2403z00_2602);
																																																										}
																																																										BgL_new1148z00_2596
																																																											=
																																																											BgL_new1147z00_2601;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6144;
																																																										{	/* Eval/evaluate.scm 567 */
																																																											obj_t
																																																												BgL_arg2398z00_2597;
																																																											{	/* Eval/evaluate.scm 567 */
																																																												obj_t
																																																													BgL_arg2401z00_2599;
																																																												BgL_arg2401z00_2599
																																																													=
																																																													CDR
																																																													(BgL_tidz00_2595);
																																																												BgL_arg2398z00_2597
																																																													=
																																																													BGl_typezd2resultzd2zz__evaluatez00
																																																													(BgL_arg2401z00_2599,
																																																													BgL_gez00_1515,
																																																													BgL_locz00_74);
																																																											}
																																																											{	/* Eval/evaluate.scm 383 */
																																																												obj_t
																																																													BgL_arg2429z00_3682;
																																																												{	/* Eval/evaluate.scm 144 */
																																																													obj_t
																																																														BgL__ortest_1068z00_3683;
																																																													BgL__ortest_1068z00_3683
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_arg2398z00_2597);
																																																													if (CBOOL(BgL__ortest_1068z00_3683))
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2429z00_3682
																																																																=
																																																																BgL__ortest_1068z00_3683;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2429z00_3682
																																																																=
																																																																BgL_locz00_74;
																																																														}
																																																												}
																																																												{
																																																													obj_t
																																																														BgL_auxz00_6151;
																																																													{	/* Eval/evaluate.scm 374 */
																																																														obj_t
																																																															BgL_auxz00_6152;
																																																														if (BgL_topzf3zf3_75)
																																																															{	/* Eval/evaluate.scm 568 */
																																																																BgL_auxz00_6152
																																																																	=
																																																																	BgL_gvz00_1514;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 568 */
																																																																BgL_auxz00_6152
																																																																	=
																																																																	BgL_wherez00_73;
																																																															}
																																																														BgL_auxz00_6151
																																																															=
																																																															BGl_convz00zz__evaluatez00
																																																															(BgL_arg2398z00_2597,
																																																															BgL_localsz00_70,
																																																															BgL_globalsz00_71,
																																																															BFALSE,
																																																															BgL_auxz00_6152,
																																																															BgL_arg2429z00_3682,
																																																															((bool_t) 0));
																																																													}
																																																													BgL_auxz00_6144
																																																														=
																																																														(
																																																														(BgL_ev_exprz00_bglt)
																																																														BgL_auxz00_6151);
																																																												}
																																																											}
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1148z00_2596)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6144), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1148z00_2596)))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1148z00_2596)))->BgL_namez00) = ((obj_t) CAR(BgL_tidz00_2595)), BUNSPEC);
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6162;
																																																										if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																											{	/* Eval/evaluate.scm 565 */
																																																												BgL_auxz00_6162
																																																													=
																																																													BgL_globalsz00_71;
																																																											}
																																																										else
																																																											{	/* Eval/evaluate.scm 565 */
																																																												BgL_auxz00_6162
																																																													=
																																																													BGL_MODULE
																																																													();
																																																											}
																																																										((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1148z00_2596)))->BgL_modz00) = ((obj_t) BgL_auxz00_6162), BUNSPEC);
																																																									}
																																																									BgL_auxz00_6138
																																																										=
																																																										BgL_new1148z00_2596;
																																																								}
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6138);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1812z00_1827;
																																																						obj_t
																																																							BgL_arg1813z00_1828;
																																																						BgL_arg1812z00_1827
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						BgL_arg1813z00_1828
																																																							=
																																																							CDR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6171;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6173;
																																																								obj_t
																																																									BgL_fz00_6172;
																																																								BgL_fz00_6172
																																																									=
																																																									BgL_arg1812z00_1827;
																																																								BgL_argsz00_6173
																																																									=
																																																									BgL_arg1813z00_1828;
																																																								BgL_argsz00_1538
																																																									=
																																																									BgL_argsz00_6173;
																																																								BgL_fz00_1537
																																																									=
																																																									BgL_fz00_6172;
																																																								goto
																																																									BgL_tagzd2176zd2_1539;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6171);
																																																						}
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd27804zd2_1832;
																																																		BgL_cdrzd27804zd2_1832
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd27595zd2_1797));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd27804zd2_1832))))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1819z00_1835;
																																																				obj_t
																																																					BgL_arg1821z00_1836;
																																																				BgL_arg1819z00_1835
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd27595zd2_1797));
																																																				BgL_arg1821z00_1836
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd27804zd2_1832));
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_6185;
																																																					{
																																																						obj_t
																																																							BgL_gez00_6187;
																																																						obj_t
																																																							BgL_gvz00_6186;
																																																						BgL_gvz00_6186
																																																							=
																																																							BgL_arg1819z00_1835;
																																																						BgL_gez00_6187
																																																							=
																																																							BgL_arg1821z00_1836;
																																																						BgL_gez00_1515
																																																							=
																																																							BgL_gez00_6187;
																																																						BgL_gvz00_1514
																																																							=
																																																							BgL_gvz00_6186;
																																																						goto
																																																							BgL_tagzd2168zd2_1516;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6185);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1822z00_1837;
																																																				obj_t
																																																					BgL_arg1823z00_1838;
																																																				BgL_arg1822z00_1837
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg1823z00_1838
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6191;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6193;
																																																						obj_t
																																																							BgL_fz00_6192;
																																																						BgL_fz00_6192
																																																							=
																																																							BgL_arg1822z00_1837;
																																																						BgL_argsz00_6193
																																																							=
																																																							BgL_arg1823z00_1838;
																																																						BgL_argsz00_1538
																																																							=
																																																							BgL_argsz00_6193;
																																																						BgL_fz00_1537
																																																							=
																																																							BgL_fz00_6192;
																																																						goto
																																																							BgL_tagzd2176zd2_1539;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6191);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27893zd2_1841;
																																																BgL_cdrzd27893zd2_1841
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd27595zd2_1797));
																																																if (NULLP(CDR(((obj_t) BgL_cdrzd27893zd2_1841))))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1827z00_1844;
																																																		obj_t
																																																			BgL_arg1828z00_1845;
																																																		BgL_arg1827z00_1844
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd27595zd2_1797));
																																																		BgL_arg1828z00_1845
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd27893zd2_1841));
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_6205;
																																																			{
																																																				obj_t
																																																					BgL_gez00_6207;
																																																				obj_t
																																																					BgL_gvz00_6206;
																																																				BgL_gvz00_6206
																																																					=
																																																					BgL_arg1827z00_1844;
																																																				BgL_gez00_6207
																																																					=
																																																					BgL_arg1828z00_1845;
																																																				BgL_gez00_1515
																																																					=
																																																					BgL_gez00_6207;
																																																				BgL_gvz00_1514
																																																					=
																																																					BgL_gvz00_6206;
																																																				goto
																																																					BgL_tagzd2168zd2_1516;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6205);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1829z00_1846;
																																																		obj_t
																																																			BgL_arg1830z00_1847;
																																																		BgL_arg1829z00_1846
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1830z00_1847
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6211;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6213;
																																																				obj_t
																																																					BgL_fz00_6212;
																																																				BgL_fz00_6212
																																																					=
																																																					BgL_arg1829z00_1846;
																																																				BgL_argsz00_6213
																																																					=
																																																					BgL_arg1830z00_1847;
																																																				BgL_argsz00_1538
																																																					=
																																																					BgL_argsz00_6213;
																																																				BgL_fz00_1537
																																																					=
																																																					BgL_fz00_6212;
																																																				goto
																																																					BgL_tagzd2176zd2_1539;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6211);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd27982zd2_1850;
																																														BgL_cdrzd27982zd2_1850
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_cdrzd27595zd2_1797));
																																														if (NULLP(CDR(((obj_t) BgL_cdrzd27982zd2_1850))))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1834z00_1853;
																																																obj_t
																																																	BgL_arg1835z00_1854;
																																																BgL_arg1834z00_1853
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd27595zd2_1797));
																																																BgL_arg1835z00_1854
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd27982zd2_1850));
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_6225;
																																																	{
																																																		obj_t
																																																			BgL_gez00_6227;
																																																		obj_t
																																																			BgL_gvz00_6226;
																																																		BgL_gvz00_6226
																																																			=
																																																			BgL_arg1834z00_1853;
																																																		BgL_gez00_6227
																																																			=
																																																			BgL_arg1835z00_1854;
																																																		BgL_gez00_1515
																																																			=
																																																			BgL_gez00_6227;
																																																		BgL_gvz00_1514
																																																			=
																																																			BgL_gvz00_6226;
																																																		goto
																																																			BgL_tagzd2168zd2_1516;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6225);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1837z00_1855;
																																																obj_t
																																																	BgL_arg1838z00_1856;
																																																BgL_arg1837z00_1855
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg1838z00_1856
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6231;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6233;
																																																		obj_t
																																																			BgL_fz00_6232;
																																																		BgL_fz00_6232
																																																			=
																																																			BgL_arg1837z00_1855;
																																																		BgL_argsz00_6233
																																																			=
																																																			BgL_arg1838z00_1856;
																																																		BgL_argsz00_1538
																																																			=
																																																			BgL_argsz00_6233;
																																																		BgL_fz00_1537
																																																			=
																																																			BgL_fz00_6232;
																																																		goto
																																																			BgL_tagzd2176zd2_1539;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6231);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd28071zd2_1860;
																																												BgL_cdrzd28071zd2_1860
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_cdrzd27595zd2_1797));
																																												if (NULLP(CDR(((obj_t) BgL_cdrzd28071zd2_1860))))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1845z00_1863;
																																														obj_t
																																															BgL_arg1849z00_1864;
																																														BgL_arg1845z00_1863
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd27595zd2_1797));
																																														BgL_arg1849z00_1864
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd28071zd2_1860));
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_6245;
																																															{
																																																obj_t
																																																	BgL_gez00_6247;
																																																obj_t
																																																	BgL_gvz00_6246;
																																																BgL_gvz00_6246
																																																	=
																																																	BgL_arg1845z00_1863;
																																																BgL_gez00_6247
																																																	=
																																																	BgL_arg1849z00_1864;
																																																BgL_gez00_1515
																																																	=
																																																	BgL_gez00_6247;
																																																BgL_gvz00_1514
																																																	=
																																																	BgL_gvz00_6246;
																																																goto
																																																	BgL_tagzd2168zd2_1516;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6245);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1850z00_1865;
																																														obj_t
																																															BgL_arg1851z00_1866;
																																														BgL_arg1850z00_1865
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1851z00_1866
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6251;
																																															{
																																																obj_t
																																																	BgL_argsz00_6253;
																																																obj_t
																																																	BgL_fz00_6252;
																																																BgL_fz00_6252
																																																	=
																																																	BgL_arg1850z00_1865;
																																																BgL_argsz00_6253
																																																	=
																																																	BgL_arg1851z00_1866;
																																																BgL_argsz00_1538
																																																	=
																																																	BgL_argsz00_6253;
																																																BgL_fz00_1537
																																																	=
																																																	BgL_fz00_6252;
																																																goto
																																																	BgL_tagzd2176zd2_1539;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6251);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg1855z00_1868;
																																										BgL_arg1855z00_1868
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6256;
																																											{
																																												obj_t
																																													BgL_argsz00_6258;
																																												obj_t
																																													BgL_fz00_6257;
																																												BgL_fz00_6257
																																													=
																																													BgL_arg1855z00_1868;
																																												BgL_argsz00_6258
																																													=
																																													BgL_cdrzd27595zd2_1797;
																																												BgL_argsz00_1538
																																													=
																																													BgL_argsz00_6258;
																																												BgL_fz00_1537
																																													=
																																													BgL_fz00_6257;
																																												goto
																																													BgL_tagzd2176zd2_1539;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6256);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg1857z00_1870;
																																								BgL_arg1857z00_1870
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_6261;
																																									{
																																										obj_t
																																											BgL_argsz00_6263;
																																										obj_t
																																											BgL_fz00_6262;
																																										BgL_fz00_6262
																																											=
																																											BgL_arg1857z00_1870;
																																										BgL_argsz00_6263
																																											=
																																											BgL_cdrzd27595zd2_1797;
																																										BgL_argsz00_1538
																																											=
																																											BgL_argsz00_6263;
																																										BgL_fz00_1537
																																											=
																																											BgL_fz00_6262;
																																										goto
																																											BgL_tagzd2176zd2_1539;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_6261);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						if (
																																							(CAR
																																								(BgL_ez00_69)
																																								==
																																								BGl_symbol2971z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd27595zd2_1797))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd28319zd2_1876;
																																										BgL_carzd28319zd2_1876
																																											=
																																											CAR
																																											(BgL_cdrzd27595zd2_1797);
																																										if (PAIRP(BgL_carzd28319zd2_1876))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (NULLP(CDR(BgL_carzd28319zd2_1876)))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1867z00_1880;
																																														obj_t
																																															BgL_arg1868z00_1881;
																																														BgL_arg1867z00_1880
																																															=
																																															CAR
																																															(BgL_carzd28319zd2_1876);
																																														BgL_arg1868z00_1881
																																															=
																																															CDR
																																															(BgL_cdrzd27595zd2_1797);
																																														{
																																															BgL_ev_bindzd2exitzd2_bglt
																																																BgL_auxz00_6278;
																																															BgL_vz00_1517
																																																=
																																																BgL_arg1867z00_1880;
																																															BgL_bodyz00_1518
																																																=
																																																BgL_arg1868z00_1881;
																																														BgL_tagzd2169zd2_1519:
																																															{	/* Eval/evaluate.scm 570 */
																																																BgL_ev_varz00_bglt
																																																	BgL_varz00_2603;
																																																{	/* Eval/evaluate.scm 570 */
																																																	BgL_ev_varz00_bglt
																																																		BgL_new1150z00_2608;
																																																	{	/* Eval/evaluate.scm 570 */
																																																		BgL_ev_varz00_bglt
																																																			BgL_new1149z00_2609;
																																																		BgL_new1149z00_2609
																																																			=
																																																			(
																																																			(BgL_ev_varz00_bglt)
																																																			BOBJECT
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_varz00_bgl))));
																																																		{	/* Eval/evaluate.scm 570 */
																																																			long
																																																				BgL_arg2407z00_2610;
																																																			BgL_arg2407z00_2610
																																																				=
																																																				BGL_CLASS_INDEX
																																																				(BGl_ev_varz00zz__evaluate_typesz00);
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(
																																																				((BgL_objectz00_bglt) BgL_new1149z00_2609), BgL_arg2407z00_2610);
																																																		}
																																																		BgL_new1150z00_2608
																																																			=
																																																			BgL_new1149z00_2609;
																																																	}
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1150z00_2608))->BgL_namez00) = ((obj_t) BgL_vz00_1517), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1150z00_2608))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1150z00_2608))->BgL_typez00) = ((obj_t) BFALSE), BUNSPEC);
																																																	BgL_varz00_2603
																																																		=
																																																		BgL_new1150z00_2608;
																																																}
																																																{	/* Eval/evaluate.scm 571 */
																																																	BgL_ev_bindzd2exitzd2_bglt
																																																		BgL_new1152z00_2604;
																																																	{	/* Eval/evaluate.scm 572 */
																																																		BgL_ev_bindzd2exitzd2_bglt
																																																			BgL_new1151z00_2606;
																																																		BgL_new1151z00_2606
																																																			=
																																																			(
																																																			(BgL_ev_bindzd2exitzd2_bglt)
																																																			BOBJECT
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_bindzd2exitzd2_bgl))));
																																																		{	/* Eval/evaluate.scm 572 */
																																																			long
																																																				BgL_arg2405z00_2607;
																																																			BgL_arg2405z00_2607
																																																				=
																																																				BGL_CLASS_INDEX
																																																				(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(
																																																				((BgL_objectz00_bglt) BgL_new1151z00_2606), BgL_arg2405z00_2607);
																																																		}
																																																		BgL_new1152z00_2604
																																																			=
																																																			BgL_new1151z00_2606;
																																																	}
																																																	((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1152z00_2604))->BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_varz00_2603), BUNSPEC);
																																																	{
																																																		BgL_ev_exprz00_bglt
																																																			BgL_auxz00_6291;
																																																		{	/* Eval/evaluate.scm 573 */
																																																			obj_t
																																																				BgL_arg2404z00_2605;
																																																			BgL_arg2404z00_2605
																																																				=
																																																				MAKE_YOUNG_PAIR
																																																				(
																																																				((obj_t) BgL_varz00_2603), BgL_localsz00_70);
																																																			BgL_auxz00_6291
																																																				=
																																																				(
																																																				(BgL_ev_exprz00_bglt)
																																																				BGl_convzd2beginzd2zz__evaluatez00
																																																				(BgL_bodyz00_1518,
																																																					BgL_arg2404z00_2605,
																																																					BgL_globalsz00_71,
																																																					BFALSE,
																																																					BgL_wherez00_73,
																																																					BgL_locz00_74,
																																																					((bool_t) 0)));
																																																		}
																																																		((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1152z00_2604))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6291), BUNSPEC);
																																																	}
																																																	BgL_auxz00_6278
																																																		=
																																																		BgL_new1152z00_2604;
																																															}}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6278);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1871z00_1882;
																																														obj_t
																																															BgL_arg1872z00_1883;
																																														BgL_arg1871z00_1882
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1872z00_1883
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6300;
																																															{
																																																obj_t
																																																	BgL_argsz00_6302;
																																																obj_t
																																																	BgL_fz00_6301;
																																																BgL_fz00_6301
																																																	=
																																																	BgL_arg1871z00_1882;
																																																BgL_argsz00_6302
																																																	=
																																																	BgL_arg1872z00_1883;
																																																BgL_argsz00_1538
																																																	=
																																																	BgL_argsz00_6302;
																																																BgL_fz00_1537
																																																	=
																																																	BgL_fz00_6301;
																																																goto
																																																	BgL_tagzd2176zd2_1539;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6300);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1876z00_1885;
																																												obj_t
																																													BgL_arg1877z00_1886;
																																												BgL_arg1876z00_1885
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg1877z00_1886
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6306;
																																													{
																																														obj_t
																																															BgL_argsz00_6308;
																																														obj_t
																																															BgL_fz00_6307;
																																														BgL_fz00_6307
																																															=
																																															BgL_arg1876z00_1885;
																																														BgL_argsz00_6308
																																															=
																																															BgL_arg1877z00_1886;
																																														BgL_argsz00_1538
																																															=
																																															BgL_argsz00_6308;
																																														BgL_fz00_1537
																																															=
																																															BgL_fz00_6307;
																																														goto
																																															BgL_tagzd2176zd2_1539;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6306);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg1878z00_1887;
																																										obj_t
																																											BgL_arg1879z00_1888;
																																										BgL_arg1878z00_1887
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										BgL_arg1879z00_1888
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6312;
																																											{
																																												obj_t
																																													BgL_argsz00_6314;
																																												obj_t
																																													BgL_fz00_6313;
																																												BgL_fz00_6313
																																													=
																																													BgL_arg1878z00_1887;
																																												BgL_argsz00_6314
																																													=
																																													BgL_arg1879z00_1888;
																																												BgL_argsz00_1538
																																													=
																																													BgL_argsz00_6314;
																																												BgL_fz00_1537
																																													=
																																													BgL_fz00_6313;
																																												goto
																																													BgL_tagzd2176zd2_1539;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6312);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd28490zd2_1889;
																																								BgL_cdrzd28490zd2_1889
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								if ((CAR(BgL_ez00_69) == BGl_symbol2973z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd28490zd2_1889))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1883z00_1893;
																																												obj_t
																																													BgL_arg1885z00_1894;
																																												BgL_arg1883z00_1893
																																													=
																																													CAR
																																													(BgL_cdrzd28490zd2_1889);
																																												BgL_arg1885z00_1894
																																													=
																																													CDR
																																													(BgL_cdrzd28490zd2_1889);
																																												{	/* Eval/evaluate.scm 575 */
																																													BgL_ev_unwindzd2protectzd2_bglt
																																														BgL_new1154z00_4002;
																																													{	/* Eval/evaluate.scm 576 */
																																														BgL_ev_unwindzd2protectzd2_bglt
																																															BgL_new1153z00_4003;
																																														BgL_new1153z00_4003
																																															=
																																															(
																																															(BgL_ev_unwindzd2protectzd2_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_unwindzd2protectzd2_bgl))));
																																														{	/* Eval/evaluate.scm 576 */
																																															long
																																																BgL_arg2409z00_4004;
																																															BgL_arg2409z00_4004
																																																=
																																																BGL_CLASS_INDEX
																																																(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1153z00_4003), BgL_arg2409z00_4004);
																																														}
																																														BgL_new1154z00_4002
																																															=
																																															BgL_new1153z00_4003;
																																													}
																																													{
																																														BgL_ev_exprz00_bglt
																																															BgL_auxz00_6328;
																																														{	/* Eval/evaluate.scm 380 */
																																															obj_t
																																																BgL_arg2427z00_4008;
																																															BgL_arg2427z00_4008
																																																=
																																																BGl_getzd2locationzd2zz__evaluatez00
																																																(BgL_arg1883z00_1893,
																																																BgL_locz00_74);
																																															BgL_auxz00_6328
																																																=
																																																(
																																																(BgL_ev_exprz00_bglt)
																																																BGl_uconvzf2locze70z15zz__evaluatez00
																																																(BgL_wherez00_73,
																																																	BgL_globalsz00_71,
																																																	BgL_localsz00_70,
																																																	BgL_arg1883z00_1893,
																																																	BgL_arg2427z00_4008));
																																														}
																																														((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1154z00_4002))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6328), BUNSPEC);
																																													}
																																													((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1154z00_4002))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1885z00_1894, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													return
																																														(
																																														(obj_t)
																																														BgL_new1154z00_4002);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1886z00_1895;
																																												BgL_arg1886z00_1895
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6338;
																																													{
																																														obj_t
																																															BgL_argsz00_6340;
																																														obj_t
																																															BgL_fz00_6339;
																																														BgL_fz00_6339
																																															=
																																															BgL_arg1886z00_1895;
																																														BgL_argsz00_6340
																																															=
																																															BgL_cdrzd28490zd2_1889;
																																														BgL_argsz00_1538
																																															=
																																															BgL_argsz00_6340;
																																														BgL_fz00_1537
																																															=
																																															BgL_fz00_6339;
																																														goto
																																															BgL_tagzd2176zd2_1539;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6338);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										if ((CAR(BgL_ez00_69) == BGl_symbol2975z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd28490zd2_1889))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1891z00_1901;
																																														obj_t
																																															BgL_arg1892z00_1902;
																																														BgL_arg1891z00_1901
																																															=
																																															CAR
																																															(BgL_cdrzd28490zd2_1889);
																																														BgL_arg1892z00_1902
																																															=
																																															CDR
																																															(BgL_cdrzd28490zd2_1889);
																																														{	/* Eval/evaluate.scm 579 */
																																															BgL_ev_withzd2handlerzd2_bglt
																																																BgL_new1157z00_4015;
																																															{	/* Eval/evaluate.scm 580 */
																																																BgL_ev_withzd2handlerzd2_bglt
																																																	BgL_new1156z00_4016;
																																																BgL_new1156z00_4016
																																																	=
																																																	(
																																																	(BgL_ev_withzd2handlerzd2_bglt)
																																																	BOBJECT
																																																	(GC_MALLOC
																																																		(sizeof
																																																			(struct
																																																				BgL_ev_withzd2handlerzd2_bgl))));
																																																{	/* Eval/evaluate.scm 580 */
																																																	long
																																																		BgL_arg2410z00_4017;
																																																	BgL_arg2410z00_4017
																																																		=
																																																		BGL_CLASS_INDEX
																																																		(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
																																																	BGL_OBJECT_CLASS_NUM_SET
																																																		(
																																																		((BgL_objectz00_bglt) BgL_new1156z00_4016), BgL_arg2410z00_4017);
																																																}
																																																BgL_new1157z00_4015
																																																	=
																																																	BgL_new1156z00_4016;
																																															}
																																															{
																																																BgL_ev_exprz00_bglt
																																																	BgL_auxz00_6353;
																																																{	/* Eval/evaluate.scm 380 */
																																																	obj_t
																																																		BgL_arg2427z00_4021;
																																																	BgL_arg2427z00_4021
																																																		=
																																																		BGl_getzd2locationzd2zz__evaluatez00
																																																		(BgL_arg1891z00_1901,
																																																		BgL_locz00_74);
																																																	BgL_auxz00_6353
																																																		=
																																																		(
																																																		(BgL_ev_exprz00_bglt)
																																																		BGl_uconvzf2locze70z15zz__evaluatez00
																																																		(BgL_wherez00_73,
																																																			BgL_globalsz00_71,
																																																			BgL_localsz00_70,
																																																			BgL_arg1891z00_1901,
																																																			BgL_arg2427z00_4021));
																																																}
																																																((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1157z00_4015))->BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6353), BUNSPEC);
																																															}
																																															((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1157z00_4015))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1892z00_1902, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																															return
																																																(
																																																(obj_t)
																																																BgL_new1157z00_4015);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1893z00_1903;
																																														obj_t
																																															BgL_arg1894z00_1904;
																																														BgL_arg1893z00_1903
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1894z00_1904
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6364;
																																															{
																																																obj_t
																																																	BgL_argsz00_6366;
																																																obj_t
																																																	BgL_fz00_6365;
																																																BgL_fz00_6365
																																																	=
																																																	BgL_arg1893z00_1903;
																																																BgL_argsz00_6366
																																																	=
																																																	BgL_arg1894z00_1904;
																																																BgL_argsz00_1538
																																																	=
																																																	BgL_argsz00_6366;
																																																BgL_fz00_1537
																																																	=
																																																	BgL_fz00_6365;
																																																goto
																																																	BgL_tagzd2176zd2_1539;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6364);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd28597zd2_1905;
																																												BgL_cdrzd28597zd2_1905
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												if ((CAR(BgL_ez00_69) == BGl_symbol2977z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd28597zd2_1905))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd28602zd2_1909;
																																																BgL_cdrzd28602zd2_1909
																																																	=
																																																	CDR
																																																	(BgL_cdrzd28597zd2_1905);
																																																if (PAIRP(BgL_cdrzd28602zd2_1909))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd28607zd2_1911;
																																																		BgL_cdrzd28607zd2_1911
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28602zd2_1909);
																																																		if ((CAR(BgL_cdrzd28602zd2_1909) == BGl_keyword2979z00zz__evaluatez00))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (PAIRP(BgL_cdrzd28607zd2_1911))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1902z00_1915;
																																																						obj_t
																																																							BgL_arg1903z00_1916;
																																																						obj_t
																																																							BgL_arg1904z00_1917;
																																																						BgL_arg1902z00_1915
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28597zd2_1905);
																																																						BgL_arg1903z00_1916
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28607zd2_1911);
																																																						BgL_arg1904z00_1917
																																																							=
																																																							CDR
																																																							(BgL_cdrzd28607zd2_1911);
																																																						{	/* Eval/evaluate.scm 583 */
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_new1159z00_4032;
																																																							{	/* Eval/evaluate.scm 584 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1158z00_4033;
																																																								BgL_new1158z00_4033
																																																									=
																																																									(
																																																									(BgL_ev_synchroniza7eza7_bglt)
																																																									BOBJECT
																																																									(GC_MALLOC
																																																										(sizeof
																																																											(struct
																																																												BgL_ev_synchroniza7eza7_bgl))));
																																																								{	/* Eval/evaluate.scm 584 */
																																																									long
																																																										BgL_arg2411z00_4034;
																																																									BgL_arg2411z00_4034
																																																										=
																																																										BGL_CLASS_INDEX
																																																										(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																									BGL_OBJECT_CLASS_NUM_SET
																																																										(
																																																										((BgL_objectz00_bglt) BgL_new1158z00_4033), BgL_arg2411z00_4034);
																																																								}
																																																								BgL_new1159z00_4032
																																																									=
																																																									BgL_new1158z00_4033;
																																																							}
																																																							((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_4032))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_6391;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2427z00_4038;
																																																									BgL_arg2427z00_4038
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1902z00_1915,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_6391
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg1902z00_1915,
																																																											BgL_arg2427z00_4038));
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_4032))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6391), BUNSPEC);
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_6396;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2427z00_4039;
																																																									BgL_arg2427z00_4039
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1903z00_1916,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_6396
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg1903z00_1916,
																																																											BgL_arg2427z00_4039));
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_4032))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6396), BUNSPEC);
																																																							}
																																																							((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_4032))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1904z00_1917, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_new1159z00_4032);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1905z00_1919;
																																																						obj_t
																																																							BgL_arg1907z00_1920;
																																																						BgL_arg1905z00_1919
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd28597zd2_1905));
																																																						BgL_arg1907z00_1920
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd28597zd2_1905));
																																																						{
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_auxz00_6409;
																																																							BgL_mz00_1530
																																																								=
																																																								BgL_arg1905z00_1919;
																																																							BgL_bodyz00_1531
																																																								=
																																																								BgL_arg1907z00_1920;
																																																						BgL_tagzd2173zd2_1532:
																																																							{	/* Eval/evaluate.scm 589 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1161z00_2620;
																																																								{	/* Eval/evaluate.scm 590 */
																																																									BgL_ev_synchroniza7eza7_bglt
																																																										BgL_new1160z00_2621;
																																																									BgL_new1160z00_2621
																																																										=
																																																										(
																																																										(BgL_ev_synchroniza7eza7_bglt)
																																																										BOBJECT
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_synchroniza7eza7_bgl))));
																																																									{	/* Eval/evaluate.scm 590 */
																																																										long
																																																											BgL_arg2412z00_2622;
																																																										BgL_arg2412z00_2622
																																																											=
																																																											BGL_CLASS_INDEX
																																																											(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																										BGL_OBJECT_CLASS_NUM_SET
																																																											(
																																																											((BgL_objectz00_bglt) BgL_new1160z00_2621), BgL_arg2412z00_2622);
																																																									}
																																																									BgL_new1161z00_2620
																																																										=
																																																										BgL_new1160z00_2621;
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1161z00_2620))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6415;
																																																									{	/* Eval/evaluate.scm 380 */
																																																										obj_t
																																																											BgL_arg2427z00_3720;
																																																										{	/* Eval/evaluate.scm 144 */
																																																											obj_t
																																																												BgL__ortest_1068z00_3721;
																																																											BgL__ortest_1068z00_3721
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BgL_mz00_1530);
																																																											if (CBOOL(BgL__ortest_1068z00_3721))
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2427z00_3720
																																																														=
																																																														BgL__ortest_1068z00_3721;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2427z00_3720
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6415
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BgL_mz00_1530,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2427z00_3720,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1161z00_2620))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6415), BUNSPEC);
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6422;
																																																									{	/* Eval/evaluate.scm 380 */
																																																										obj_t
																																																											BgL_arg2427z00_3722;
																																																										{	/* Eval/evaluate.scm 144 */
																																																											obj_t
																																																												BgL__ortest_1068z00_3723;
																																																											BgL__ortest_1068z00_3723
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BNIL);
																																																											if (CBOOL(BgL__ortest_1068z00_3723))
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2427z00_3722
																																																														=
																																																														BgL__ortest_1068z00_3723;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2427z00_3722
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6422
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BNIL,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2427z00_3722,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1161z00_2620))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6422), BUNSPEC);
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1161z00_2620))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1531, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																								BgL_auxz00_6409
																																																									=
																																																									BgL_new1161z00_2620;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6409);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1908z00_1922;
																																																				obj_t
																																																					BgL_arg1909z00_1923;
																																																				BgL_arg1908z00_1922
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd28597zd2_1905));
																																																				BgL_arg1909z00_1923
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd28597zd2_1905));
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_6437;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_6439;
																																																						obj_t
																																																							BgL_mz00_6438;
																																																						BgL_mz00_6438
																																																							=
																																																							BgL_arg1908z00_1922;
																																																						BgL_bodyz00_6439
																																																							=
																																																							BgL_arg1909z00_1923;
																																																						BgL_bodyz00_1531
																																																							=
																																																							BgL_bodyz00_6439;
																																																						BgL_mz00_1530
																																																							=
																																																							BgL_mz00_6438;
																																																						goto
																																																							BgL_tagzd2173zd2_1532;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6437);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1911z00_1926;
																																																		obj_t
																																																			BgL_arg1912z00_1927;
																																																		BgL_arg1911z00_1926
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd28597zd2_1905));
																																																		BgL_arg1912z00_1927
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd28597zd2_1905));
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_6445;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_6447;
																																																				obj_t
																																																					BgL_mz00_6446;
																																																				BgL_mz00_6446
																																																					=
																																																					BgL_arg1911z00_1926;
																																																				BgL_bodyz00_6447
																																																					=
																																																					BgL_arg1912z00_1927;
																																																				BgL_bodyz00_1531
																																																					=
																																																					BgL_bodyz00_6447;
																																																				BgL_mz00_1530
																																																					=
																																																					BgL_mz00_6446;
																																																				goto
																																																					BgL_tagzd2173zd2_1532;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6445);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1913z00_1928;
																																																BgL_arg1913z00_1928
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6450;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6452;
																																																		obj_t
																																																			BgL_fz00_6451;
																																																		BgL_fz00_6451
																																																			=
																																																			BgL_arg1913z00_1928;
																																																		BgL_argsz00_6452
																																																			=
																																																			BgL_cdrzd28597zd2_1905;
																																																		BgL_argsz00_1538
																																																			=
																																																			BgL_argsz00_6452;
																																																		BgL_fz00_1537
																																																			=
																																																			BgL_fz00_6451;
																																																		goto
																																																			BgL_tagzd2176zd2_1539;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6450);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														if ((CAR(BgL_ez00_69) == BGl_symbol2934z00zz__evaluatez00))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (PAIRP(BgL_cdrzd28597zd2_1905))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd28709zd2_1934;
																																																		BgL_cdrzd28709zd2_1934
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28597zd2_1905);
																																																		if (PAIRP(BgL_cdrzd28709zd2_1934))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd28709zd2_1934)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1921z00_1938;
																																																						obj_t
																																																							BgL_arg1922z00_1939;
																																																						BgL_arg1921z00_1938
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28597zd2_1905);
																																																						BgL_arg1922z00_1939
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28709zd2_1934);
																																																						{	/* Eval/evaluate.scm 595 */
																																																							obj_t
																																																								BgL_arg2414z00_4057;
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_arg2416z00_4058;
																																																								{	/* Eval/evaluate.scm 595 */
																																																									obj_t
																																																										BgL_arg2417z00_4059;
																																																									obj_t
																																																										BgL_arg2418z00_4060;
																																																									{	/* Eval/evaluate.scm 595 */
																																																										obj_t
																																																											BgL_symbolz00_4061;
																																																										BgL_symbolz00_4061
																																																											=
																																																											BGl_symbol2981z00zz__evaluatez00;
																																																										{	/* Eval/evaluate.scm 595 */
																																																											obj_t
																																																												BgL_arg2635z00_4062;
																																																											BgL_arg2635z00_4062
																																																												=
																																																												SYMBOL_TO_STRING
																																																												(BgL_symbolz00_4061);
																																																											BgL_arg2417z00_4059
																																																												=
																																																												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																												(BgL_arg2635z00_4062);
																																																										}
																																																									}
																																																									{	/* Eval/evaluate.scm 595 */
																																																										obj_t
																																																											BgL_arg2635z00_4064;
																																																										BgL_arg2635z00_4064
																																																											=
																																																											SYMBOL_TO_STRING
																																																											(
																																																											((obj_t) BgL_wherez00_73));
																																																										BgL_arg2418z00_4060
																																																											=
																																																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																											(BgL_arg2635z00_4064);
																																																									}
																																																									BgL_arg2416z00_4058
																																																										=
																																																										string_append
																																																										(BgL_arg2417z00_4059,
																																																										BgL_arg2418z00_4060);
																																																								}
																																																								BgL_arg2414z00_4057
																																																									=
																																																									bstring_to_symbol
																																																									(BgL_arg2416z00_4058);
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BGl_convzd2lambdaze70z35zz__evaluatez00
																																																								(BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_ez00_69,
																																																									BgL_locz00_74,
																																																									BgL_arg1921z00_1938,
																																																									BgL_arg1922z00_1939,
																																																									BgL_arg2414z00_4057,
																																																									BFALSE));
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1923z00_1940;
																																																						obj_t
																																																							BgL_arg1926z00_1941;
																																																						BgL_arg1923z00_1940
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						BgL_arg1926z00_1941
																																																							=
																																																							CDR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6478;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6480;
																																																								obj_t
																																																									BgL_fz00_6479;
																																																								BgL_fz00_6479
																																																									=
																																																									BgL_arg1923z00_1940;
																																																								BgL_argsz00_6480
																																																									=
																																																									BgL_arg1926z00_1941;
																																																								BgL_argsz00_1538
																																																									=
																																																									BgL_argsz00_6480;
																																																								BgL_fz00_1537
																																																									=
																																																									BgL_fz00_6479;
																																																								goto
																																																									BgL_tagzd2176zd2_1539;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6478);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1928z00_1943;
																																																				obj_t
																																																					BgL_arg1929z00_1944;
																																																				BgL_arg1928z00_1943
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg1929z00_1944
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6484;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6486;
																																																						obj_t
																																																							BgL_fz00_6485;
																																																						BgL_fz00_6485
																																																							=
																																																							BgL_arg1928z00_1943;
																																																						BgL_argsz00_6486
																																																							=
																																																							BgL_arg1929z00_1944;
																																																						BgL_argsz00_1538
																																																							=
																																																							BgL_argsz00_6486;
																																																						BgL_fz00_1537
																																																							=
																																																							BgL_fz00_6485;
																																																						goto
																																																							BgL_tagzd2176zd2_1539;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6484);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1930z00_1945;
																																																		obj_t
																																																			BgL_arg1931z00_1946;
																																																		BgL_arg1930z00_1945
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1931z00_1946
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6490;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6492;
																																																				obj_t
																																																					BgL_fz00_6491;
																																																				BgL_fz00_6491
																																																					=
																																																					BgL_arg1930z00_1945;
																																																				BgL_argsz00_6492
																																																					=
																																																					BgL_arg1931z00_1946;
																																																				BgL_argsz00_1538
																																																					=
																																																					BgL_argsz00_6492;
																																																				BgL_fz00_1537
																																																					=
																																																					BgL_fz00_6491;
																																																				goto
																																																					BgL_tagzd2176zd2_1539;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6490);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																if ((CAR(BgL_ez00_69) == BGl_symbol2983z00zz__evaluatez00))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		return
																																																			BGl_errorz00zz__errorz00
																																																			(BGl_string2985z00zz__evaluatez00,
																																																			BGl_string2986z00zz__evaluatez00,
																																																			BgL_ez00_69);
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1934z00_1949;
																																																		obj_t
																																																			BgL_arg1935z00_1950;
																																																		BgL_arg1934z00_1949
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1935z00_1950
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6500;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6502;
																																																				obj_t
																																																					BgL_fz00_6501;
																																																				BgL_fz00_6501
																																																					=
																																																					BgL_arg1934z00_1949;
																																																				BgL_argsz00_6502
																																																					=
																																																					BgL_arg1935z00_1950;
																																																				BgL_argsz00_1538
																																																					=
																																																					BgL_argsz00_6502;
																																																				BgL_fz00_1537
																																																					=
																																																					BgL_fz00_6501;
																																																				goto
																																																					BgL_tagzd2176zd2_1539;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6500);
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 424 */
														if (
															(BgL_carzd23841zd2_1612 ==
																BGl_symbol2957z00zz__evaluatez00))
															{	/* Eval/evaluate.scm 424 */
																if (PAIRP(BgL_cdrzd2250zd2_1546))
																	{	/* Eval/evaluate.scm 424 */
																		if (NULLP(CDR(BgL_cdrzd2250zd2_1546)))
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1959z00_1975;

																				BgL_arg1959z00_1975 =
																					CAR(BgL_cdrzd2250zd2_1546);
																				{	/* Eval/evaluate.scm 456 */
																					BgL_ev_trapz00_bglt
																						BgL_new1111z00_4079;
																					{	/* Eval/evaluate.scm 457 */
																						BgL_ev_trapz00_bglt
																							BgL_new1110z00_4080;
																						BgL_new1110z00_4080 =
																							((BgL_ev_trapz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_trapz00_bgl))));
																						{	/* Eval/evaluate.scm 457 */
																							long BgL_arg2288z00_4081;

																							BgL_arg2288z00_4081 =
																								BGL_CLASS_INDEX
																								(BGl_ev_trapz00zz__evaluate_typesz00);
																							BGL_OBJECT_CLASS_NUM_SET((
																									(BgL_objectz00_bglt)
																									BgL_new1110z00_4080),
																								BgL_arg2288z00_4081);
																						}
																						BgL_new1111z00_4079 =
																							BgL_new1110z00_4080;
																					}
																					{
																						BgL_ev_exprz00_bglt BgL_auxz00_6516;

																						{	/* Eval/evaluate.scm 380 */
																							obj_t BgL_arg2427z00_4085;

																							BgL_arg2427z00_4085 =
																								BGl_getzd2locationzd2zz__evaluatez00
																								(BgL_arg1959z00_1975,
																								BgL_locz00_74);
																							BgL_auxz00_6516 =
																								((BgL_ev_exprz00_bglt)
																								BGl_uconvzf2locze70z15zz__evaluatez00
																								(BgL_wherez00_73,
																									BgL_globalsz00_71,
																									BgL_localsz00_70,
																									BgL_arg1959z00_1975,
																									BgL_arg2427z00_4085));
																						}
																						((((BgL_ev_hookz00_bglt) COBJECT(
																										((BgL_ev_hookz00_bglt)
																											BgL_new1111z00_4079)))->
																								BgL_ez00) =
																							((BgL_ev_exprz00_bglt)
																								BgL_auxz00_6516), BUNSPEC);
																					}
																					return ((obj_t) BgL_new1111z00_4079);
																				}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1960z00_1976;
																				obj_t BgL_arg1961z00_1977;

																				BgL_arg1960z00_1976 = CAR(BgL_ez00_69);
																				BgL_arg1961z00_1977 = CDR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_6525;

																					{
																						obj_t BgL_argsz00_6527;
																						obj_t BgL_fz00_6526;

																						BgL_fz00_6526 = BgL_arg1960z00_1976;
																						BgL_argsz00_6527 =
																							BgL_arg1961z00_1977;
																						BgL_argsz00_1538 = BgL_argsz00_6527;
																						BgL_fz00_1537 = BgL_fz00_6526;
																						goto BgL_tagzd2176zd2_1539;
																					}
																					return ((obj_t) BgL_auxz00_6525);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_arg1963z00_1979;
																		obj_t BgL_arg1964z00_1980;

																		BgL_arg1963z00_1979 = CAR(BgL_ez00_69);
																		BgL_arg1964z00_1980 = CDR(BgL_ez00_69);
																		{
																			BgL_ev_appz00_bglt BgL_auxz00_6531;

																			{
																				obj_t BgL_argsz00_6533;
																				obj_t BgL_fz00_6532;

																				BgL_fz00_6532 = BgL_arg1963z00_1979;
																				BgL_argsz00_6533 = BgL_arg1964z00_1980;
																				BgL_argsz00_1538 = BgL_argsz00_6533;
																				BgL_fz00_1537 = BgL_fz00_6532;
																				goto BgL_tagzd2176zd2_1539;
																			}
																			return ((obj_t) BgL_auxz00_6531);
																		}
																	}
															}
														else
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_cdrzd29422zd2_1981;

																BgL_cdrzd29422zd2_1981 = CDR(BgL_ez00_69);
																if (
																	(CAR(BgL_ez00_69) ==
																		BGl_symbol2922z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 424 */
																		if (PAIRP(BgL_cdrzd29422zd2_1981))
																			{	/* Eval/evaluate.scm 424 */
																				if (NULLP(CDR(BgL_cdrzd29422zd2_1981)))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1970z00_1987;

																						BgL_arg1970z00_1987 =
																							CAR(BgL_cdrzd29422zd2_1981);
																						{	/* Eval/evaluate.scm 459 */
																							BgL_ev_littz00_bglt
																								BgL_new1113z00_4094;
																							{	/* Eval/evaluate.scm 460 */
																								BgL_ev_littz00_bglt
																									BgL_new1112z00_4095;
																								BgL_new1112z00_4095 =
																									((BgL_ev_littz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_littz00_bgl))));
																								{	/* Eval/evaluate.scm 460 */
																									long BgL_arg2289z00_4096;

																									BgL_arg2289z00_4096 =
																										BGL_CLASS_INDEX
																										(BGl_ev_littz00zz__evaluate_typesz00);
																									BGL_OBJECT_CLASS_NUM_SET((
																											(BgL_objectz00_bglt)
																											BgL_new1112z00_4095),
																										BgL_arg2289z00_4096);
																								}
																								BgL_new1113z00_4094 =
																									BgL_new1112z00_4095;
																							}
																							((((BgL_ev_littz00_bglt)
																										COBJECT
																										(BgL_new1113z00_4094))->
																									BgL_valuez00) =
																								((obj_t) BgL_arg1970z00_1987),
																								BUNSPEC);
																							return ((obj_t)
																								BgL_new1113z00_4094);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1971z00_1988;

																						BgL_arg1971z00_1988 =
																							CAR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_6552;
																							{
																								obj_t BgL_argsz00_6554;
																								obj_t BgL_fz00_6553;

																								BgL_fz00_6553 =
																									BgL_arg1971z00_1988;
																								BgL_argsz00_6554 =
																									BgL_cdrzd29422zd2_1981;
																								BgL_argsz00_1538 =
																									BgL_argsz00_6554;
																								BgL_fz00_1537 = BgL_fz00_6553;
																								goto BgL_tagzd2176zd2_1539;
																							}
																							return ((obj_t) BgL_auxz00_6552);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1974z00_1991;

																				BgL_arg1974z00_1991 = CAR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_6557;

																					{
																						obj_t BgL_argsz00_6559;
																						obj_t BgL_fz00_6558;

																						BgL_fz00_6558 = BgL_arg1974z00_1991;
																						BgL_argsz00_6559 =
																							BgL_cdrzd29422zd2_1981;
																						BgL_argsz00_1538 = BgL_argsz00_6559;
																						BgL_fz00_1537 = BgL_fz00_6558;
																						goto BgL_tagzd2176zd2_1539;
																					}
																					return ((obj_t) BgL_auxz00_6557);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		if (
																			(CAR(BgL_ez00_69) ==
																				BGl_symbol2930z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 424 */
																				if (PAIRP(BgL_cdrzd29422zd2_1981))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_cdrzd210036zd2_1997;

																						BgL_cdrzd210036zd2_1997 =
																							CDR(BgL_cdrzd29422zd2_1981);
																						if (PAIRP(BgL_cdrzd210036zd2_1997))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_cdrzd210041zd2_1999;

																								BgL_cdrzd210041zd2_1999 =
																									CDR(BgL_cdrzd210036zd2_1997);
																								if (PAIRP
																									(BgL_cdrzd210041zd2_1999))
																									{	/* Eval/evaluate.scm 424 */
																										if (NULLP(CDR
																												(BgL_cdrzd210041zd2_1999)))
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_arg1984z00_2003;
																												obj_t
																													BgL_arg1985z00_2004;
																												obj_t
																													BgL_arg1986z00_2005;
																												BgL_arg1984z00_2003 =
																													CAR
																													(BgL_cdrzd29422zd2_1981);
																												BgL_arg1985z00_2004 =
																													CAR
																													(BgL_cdrzd210036zd2_1997);
																												BgL_arg1986z00_2005 =
																													CAR
																													(BgL_cdrzd210041zd2_1999);
																												{
																													BgL_ev_ifz00_bglt
																														BgL_auxz00_6578;
																													{
																														obj_t BgL_oz00_6581;
																														obj_t BgL_tz00_6580;
																														obj_t BgL_pz00_6579;

																														BgL_pz00_6579 =
																															BgL_arg1984z00_2003;
																														BgL_tz00_6580 =
																															BgL_arg1985z00_2004;
																														BgL_oz00_6581 =
																															BgL_arg1986z00_2005;
																														BgL_oz00_1479 =
																															BgL_oz00_6581;
																														BgL_tz00_1478 =
																															BgL_tz00_6580;
																														BgL_pz00_1477 =
																															BgL_pz00_6579;
																														goto
																															BgL_tagzd2155zd2_1480;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_6578);
																												}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_arg1987z00_2006;
																												obj_t
																													BgL_arg1988z00_2007;
																												BgL_arg1987z00_2006 =
																													CAR(BgL_ez00_69);
																												BgL_arg1988z00_2007 =
																													CDR(BgL_ez00_69);
																												{
																													BgL_ev_appz00_bglt
																														BgL_auxz00_6585;
																													{
																														obj_t
																															BgL_argsz00_6587;
																														obj_t BgL_fz00_6586;

																														BgL_fz00_6586 =
																															BgL_arg1987z00_2006;
																														BgL_argsz00_6587 =
																															BgL_arg1988z00_2007;
																														BgL_argsz00_1538 =
																															BgL_argsz00_6587;
																														BgL_fz00_1537 =
																															BgL_fz00_6586;
																														goto
																															BgL_tagzd2176zd2_1539;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_6585);
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd210341zd2_2009;
																										BgL_cdrzd210341zd2_2009 =
																											CDR(BgL_ez00_69);
																										{	/* Eval/evaluate.scm 424 */
																											obj_t
																												BgL_cdrzd210347zd2_2010;
																											BgL_cdrzd210347zd2_2010 =
																												CDR(((obj_t)
																													BgL_cdrzd210341zd2_2009));
																											if (NULLP(CDR(((obj_t)
																															BgL_cdrzd210347zd2_2010))))
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_arg1992z00_2013;
																													obj_t
																														BgL_arg1993z00_2014;
																													BgL_arg1992z00_2013 =
																														CAR(((obj_t)
																															BgL_cdrzd210341zd2_2009));
																													BgL_arg1993z00_2014 =
																														CAR(((obj_t)
																															BgL_cdrzd210347zd2_2010));
																													{
																														BgL_ev_ifz00_bglt
																															BgL_auxz00_6600;
																														{
																															obj_t
																																BgL_tz00_6602;
																															obj_t
																																BgL_pz00_6601;
																															BgL_pz00_6601 =
																																BgL_arg1992z00_2013;
																															BgL_tz00_6602 =
																																BgL_arg1993z00_2014;
																															BgL_tz00_1482 =
																																BgL_tz00_6602;
																															BgL_pz00_1481 =
																																BgL_pz00_6601;
																															goto
																																BgL_tagzd2156zd2_1483;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_6600);
																													}
																												}
																											else
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_arg1994z00_2015;
																													BgL_arg1994z00_2015 =
																														CAR(BgL_ez00_69);
																													{
																														BgL_ev_appz00_bglt
																															BgL_auxz00_6605;
																														{
																															obj_t
																																BgL_argsz00_6607;
																															obj_t
																																BgL_fz00_6606;
																															BgL_fz00_6606 =
																																BgL_arg1994z00_2015;
																															BgL_argsz00_6607 =
																																BgL_cdrzd210341zd2_2009;
																															BgL_argsz00_1538 =
																																BgL_argsz00_6607;
																															BgL_fz00_1537 =
																																BgL_fz00_6606;
																															goto
																																BgL_tagzd2176zd2_1539;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_6605);
																													}
																												}
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1997z00_2018;
																								obj_t BgL_arg1998z00_2019;

																								BgL_arg1997z00_2018 =
																									CAR(BgL_ez00_69);
																								BgL_arg1998z00_2019 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_6611;
																									{
																										obj_t BgL_argsz00_6613;
																										obj_t BgL_fz00_6612;

																										BgL_fz00_6612 =
																											BgL_arg1997z00_2018;
																										BgL_argsz00_6613 =
																											BgL_arg1998z00_2019;
																										BgL_argsz00_1538 =
																											BgL_argsz00_6613;
																										BgL_fz00_1537 =
																											BgL_fz00_6612;
																										goto BgL_tagzd2176zd2_1539;
																									}
																									return
																										((obj_t) BgL_auxz00_6611);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1999z00_2020;
																						obj_t BgL_arg2000z00_2021;

																						BgL_arg1999z00_2020 =
																							CAR(BgL_ez00_69);
																						BgL_arg2000z00_2021 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_6617;
																							{
																								obj_t BgL_argsz00_6619;
																								obj_t BgL_fz00_6618;

																								BgL_fz00_6618 =
																									BgL_arg1999z00_2020;
																								BgL_argsz00_6619 =
																									BgL_arg2000z00_2021;
																								BgL_argsz00_1538 =
																									BgL_argsz00_6619;
																								BgL_fz00_1537 = BgL_fz00_6618;
																								goto BgL_tagzd2176zd2_1539;
																							}
																							return ((obj_t) BgL_auxz00_6617);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				if (
																					(CAR(BgL_ez00_69) ==
																						BGl_symbol2959z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg2003z00_2024;

																						BgL_arg2003z00_2024 =
																							CDR(BgL_ez00_69);
																						{	/* Eval/evaluate.scm 472 */
																							BgL_ev_orz00_bglt
																								BgL_new1120z00_4127;
																							{	/* Eval/evaluate.scm 473 */
																								BgL_ev_orz00_bglt
																									BgL_new1119z00_4128;
																								BgL_new1119z00_4128 =
																									((BgL_ev_orz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_orz00_bgl))));
																								{	/* Eval/evaluate.scm 473 */
																									long BgL_arg2298z00_4129;

																									BgL_arg2298z00_4129 =
																										BGL_CLASS_INDEX
																										(BGl_ev_orz00zz__evaluate_typesz00);
																									BGL_OBJECT_CLASS_NUM_SET((
																											(BgL_objectz00_bglt)
																											BgL_new1119z00_4128),
																										BgL_arg2298z00_4129);
																								}
																								BgL_new1120z00_4127 =
																									BgL_new1119z00_4128;
																							}
																							((((BgL_ev_listz00_bglt) COBJECT(
																											((BgL_ev_listz00_bglt)
																												BgL_new1120z00_4127)))->
																									BgL_argsz00) =
																								((obj_t)
																									BGl_loopze70ze7zz__evaluatez00
																									(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_arg2003z00_2024)),
																								BUNSPEC);
																							return ((obj_t)
																								BgL_new1120z00_4127);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						if (
																							(CAR(BgL_ez00_69) ==
																								BGl_symbol2961z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg2006z00_2027;

																								BgL_arg2006z00_2027 =
																									CDR(BgL_ez00_69);
																								{	/* Eval/evaluate.scm 475 */
																									BgL_ev_andz00_bglt
																										BgL_new1123z00_4135;
																									{	/* Eval/evaluate.scm 476 */
																										BgL_ev_andz00_bglt
																											BgL_new1122z00_4136;
																										BgL_new1122z00_4136 =
																											((BgL_ev_andz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_andz00_bgl))));
																										{	/* Eval/evaluate.scm 476 */
																											long BgL_arg2299z00_4137;

																											BgL_arg2299z00_4137 =
																												BGL_CLASS_INDEX
																												(BGl_ev_andz00zz__evaluate_typesz00);
																											BGL_OBJECT_CLASS_NUM_SET((
																													(BgL_objectz00_bglt)
																													BgL_new1122z00_4136),
																												BgL_arg2299z00_4137);
																										}
																										BgL_new1123z00_4135 =
																											BgL_new1122z00_4136;
																									}
																									((((BgL_ev_listz00_bglt)
																												COBJECT((
																														(BgL_ev_listz00_bglt)
																														BgL_new1123z00_4135)))->
																											BgL_argsz00) =
																										((obj_t)
																											BGl_loopze70ze7zz__evaluatez00
																											(BgL_wherez00_73,
																												BgL_globalsz00_71,
																												BgL_localsz00_70,
																												BgL_locz00_74,
																												BgL_arg2006z00_2027)),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1123z00_4135);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								if (
																									(CAR(BgL_ez00_69) ==
																										BGl_symbol2946z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 424 */
																										return
																											BGl_convzd2beginzd2zz__evaluatez00
																											(CDR(BgL_ez00_69),
																											BgL_localsz00_70,
																											BgL_globalsz00_71,
																											BgL_tailzf3zf3_72,
																											BgL_wherez00_73,
																											BgL_locz00_74,
																											BgL_topzf3zf3_75);
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd211246zd2_2031;
																										BgL_cdrzd211246zd2_2031 =
																											CDR(BgL_ez00_69);
																										if ((CAR(BgL_ez00_69) ==
																												BGl_symbol2932z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 424 */
																												if (PAIRP
																													(BgL_cdrzd211246zd2_2031))
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg2014z00_2035;
																														obj_t
																															BgL_arg2015z00_2036;
																														BgL_arg2014z00_2035
																															=
																															CAR
																															(BgL_cdrzd211246zd2_2031);
																														BgL_arg2015z00_2036
																															=
																															CDR
																															(BgL_cdrzd211246zd2_2031);
																														{
																															BgL_ev_letz00_bglt
																																BgL_auxz00_6658;
																															{
																																obj_t
																																	BgL_bodyz00_6660;
																																obj_t
																																	BgL_bindsz00_6659;
																																BgL_bindsz00_6659
																																	=
																																	BgL_arg2014z00_2035;
																																BgL_bodyz00_6660
																																	=
																																	BgL_arg2015z00_2036;
																																BgL_bodyz00_1491
																																	=
																																	BgL_bodyz00_6660;
																																BgL_bindsz00_1490
																																	=
																																	BgL_bindsz00_6659;
																																goto
																																	BgL_tagzd2160zd2_1492;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_6658);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg2017z00_2037;
																														BgL_arg2017z00_2037
																															=
																															CAR(BgL_ez00_69);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_6663;
																															{
																																obj_t
																																	BgL_argsz00_6665;
																																obj_t
																																	BgL_fz00_6664;
																																BgL_fz00_6664 =
																																	BgL_arg2017z00_2037;
																																BgL_argsz00_6665
																																	=
																																	BgL_cdrzd211246zd2_2031;
																																BgL_argsz00_1538
																																	=
																																	BgL_argsz00_6665;
																																BgL_fz00_1537 =
																																	BgL_fz00_6664;
																																goto
																																	BgL_tagzd2176zd2_1539;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_6663);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												if (
																													(CAR(BgL_ez00_69) ==
																														BGl_symbol2963z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 424 */
																														if (PAIRP
																															(BgL_cdrzd211246zd2_2031))
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg2022z00_2043;
																																obj_t
																																	BgL_arg2023z00_2044;
																																BgL_arg2022z00_2043
																																	=
																																	CAR
																																	(BgL_cdrzd211246zd2_2031);
																																BgL_arg2023z00_2044
																																	=
																																	CDR
																																	(BgL_cdrzd211246zd2_2031);
																																{
																																	BgL_ev_letza2za2_bglt
																																		BgL_auxz00_6674;
																																	{
																																		obj_t
																																			BgL_bodyz00_6676;
																																		obj_t
																																			BgL_bindsz00_6675;
																																		BgL_bindsz00_6675
																																			=
																																			BgL_arg2022z00_2043;
																																		BgL_bodyz00_6676
																																			=
																																			BgL_arg2023z00_2044;
																																		BgL_bodyz00_1494
																																			=
																																			BgL_bodyz00_6676;
																																		BgL_bindsz00_1493
																																			=
																																			BgL_bindsz00_6675;
																																		goto
																																			BgL_tagzd2161zd2_1495;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_6674);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg2024z00_2045;
																																obj_t
																																	BgL_arg2025z00_2046;
																																BgL_arg2024z00_2045
																																	=
																																	CAR
																																	(BgL_ez00_69);
																																BgL_arg2025z00_2046
																																	=
																																	CDR
																																	(BgL_ez00_69);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_6680;
																																	{
																																		obj_t
																																			BgL_argsz00_6682;
																																		obj_t
																																			BgL_fz00_6681;
																																		BgL_fz00_6681
																																			=
																																			BgL_arg2024z00_2045;
																																		BgL_argsz00_6682
																																			=
																																			BgL_arg2025z00_2046;
																																		BgL_argsz00_1538
																																			=
																																			BgL_argsz00_6682;
																																		BgL_fz00_1537
																																			=
																																			BgL_fz00_6681;
																																		goto
																																			BgL_tagzd2176zd2_1539;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_6680);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_cdrzd211644zd2_2047;
																														BgL_cdrzd211644zd2_2047
																															=
																															CDR(BgL_ez00_69);
																														if ((CAR
																																(BgL_ez00_69) ==
																																BGl_symbol2965z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 424 */
																																if (PAIRP
																																	(BgL_cdrzd211644zd2_2047))
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg2031z00_2051;
																																		obj_t
																																			BgL_arg2032z00_2052;
																																		BgL_arg2031z00_2051
																																			=
																																			CAR
																																			(BgL_cdrzd211644zd2_2047);
																																		BgL_arg2032z00_2052
																																			=
																																			CDR
																																			(BgL_cdrzd211644zd2_2047);
																																		{
																																			BgL_ev_letrecz00_bglt
																																				BgL_auxz00_6692;
																																			{
																																				obj_t
																																					BgL_bodyz00_6694;
																																				obj_t
																																					BgL_bindsz00_6693;
																																				BgL_bindsz00_6693
																																					=
																																					BgL_arg2031z00_2051;
																																				BgL_bodyz00_6694
																																					=
																																					BgL_arg2032z00_2052;
																																				BgL_bodyz00_1497
																																					=
																																					BgL_bodyz00_6694;
																																				BgL_bindsz00_1496
																																					=
																																					BgL_bindsz00_6693;
																																				goto
																																					BgL_tagzd2162zd2_1498;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_6692);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg2033z00_2053;
																																		BgL_arg2033z00_2053
																																			=
																																			CAR
																																			(BgL_ez00_69);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_6697;
																																			{
																																				obj_t
																																					BgL_argsz00_6699;
																																				obj_t
																																					BgL_fz00_6698;
																																				BgL_fz00_6698
																																					=
																																					BgL_arg2033z00_2053;
																																				BgL_argsz00_6699
																																					=
																																					BgL_cdrzd211644zd2_2047;
																																				BgL_argsz00_1538
																																					=
																																					BgL_argsz00_6699;
																																				BgL_fz00_1537
																																					=
																																					BgL_fz00_6698;
																																				goto
																																					BgL_tagzd2176zd2_1539;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_6697);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																if (
																																	(CAR
																																		(BgL_ez00_69)
																																		==
																																		BGl_symbol2967z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 424 */
																																		if (PAIRP
																																			(BgL_cdrzd211644zd2_2047))
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_carzd211820zd2_2059;
																																				obj_t
																																					BgL_cdrzd211821zd2_2060;
																																				BgL_carzd211820zd2_2059
																																					=
																																					CAR
																																					(BgL_cdrzd211644zd2_2047);
																																				BgL_cdrzd211821zd2_2060
																																					=
																																					CDR
																																					(BgL_cdrzd211644zd2_2047);
																																				if (PAIRP(BgL_carzd211820zd2_2059))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd211825zd2_2062;
																																						BgL_cdrzd211825zd2_2062
																																							=
																																							CDR
																																							(BgL_carzd211820zd2_2059);
																																						if (
																																							(CAR
																																								(BgL_carzd211820zd2_2059)
																																								==
																																								BGl_symbol2953z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd211825zd2_2062))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd211828zd2_2066;
																																										obj_t
																																											BgL_cdrzd211829zd2_2067;
																																										BgL_carzd211828zd2_2066
																																											=
																																											CAR
																																											(BgL_cdrzd211825zd2_2062);
																																										BgL_cdrzd211829zd2_2067
																																											=
																																											CDR
																																											(BgL_cdrzd211825zd2_2062);
																																										if (SYMBOLP(BgL_carzd211828zd2_2066))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd211829zd2_2067))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_carzd211833zd2_2070;
																																														BgL_carzd211833zd2_2070
																																															=
																																															CAR
																																															(BgL_cdrzd211829zd2_2067);
																																														if (SYMBOLP(BgL_carzd211833zd2_2070))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (NULLP(CDR(BgL_cdrzd211829zd2_2067)))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (PAIRP(BgL_cdrzd211821zd2_2060))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd211821zd2_2060)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg2052z00_2077;
																																																						BgL_arg2052z00_2077
																																																							=
																																																							CAR
																																																							(BgL_cdrzd211821zd2_2060);
																																																						{	/* Eval/evaluate.scm 531 */
																																																							BgL_ev_setglobalz00_bglt
																																																								BgL_new1140z00_4173;
																																																							{	/* Eval/evaluate.scm 535 */
																																																								BgL_ev_setglobalz00_bglt
																																																									BgL_new1139z00_4174;
																																																								BgL_new1139z00_4174
																																																									=
																																																									(
																																																									(BgL_ev_setglobalz00_bglt)
																																																									BOBJECT
																																																									(GC_MALLOC
																																																										(sizeof
																																																											(struct
																																																												BgL_ev_setglobalz00_bgl))));
																																																								{	/* Eval/evaluate.scm 535 */
																																																									long
																																																										BgL_arg2377z00_4175;
																																																									BgL_arg2377z00_4175
																																																										=
																																																										BGL_CLASS_INDEX
																																																										(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																									BGL_OBJECT_CLASS_NUM_SET
																																																										(
																																																										((BgL_objectz00_bglt) BgL_new1139z00_4174), BgL_arg2377z00_4175);
																																																								}
																																																								BgL_new1140z00_4173
																																																									=
																																																									BgL_new1139z00_4174;
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_6738;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2427z00_4179;
																																																									BgL_arg2427z00_4179
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg2052z00_2077,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_6738
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg2052z00_2077,
																																																											BgL_arg2427z00_4179));
																																																								}
																																																								((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1140z00_4173)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6738), BUNSPEC);
																																																							}
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1140z00_4173))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1140z00_4173))->BgL_namez00) = ((obj_t) BgL_carzd211828zd2_2066), BUNSPEC);
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1140z00_4173))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_carzd211833zd2_2070)), BUNSPEC);
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_new1140z00_4173);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_74,
																																																							BGl_string2870z00zz__evaluatez00,
																																																							BGl_string2945z00zz__evaluatez00,
																																																							BgL_ez00_69);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_74,
																																																					BGl_string2870z00zz__evaluatez00,
																																																					BGl_string2945z00zz__evaluatez00,
																																																					BgL_ez00_69);
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd211949zd2_2079;
																																																		BgL_cdrzd211949zd2_2079
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_cdrzd211953zd2_2080;
																																																			BgL_cdrzd211953zd2_2080
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd211949zd2_2079));
																																																			if (PAIRP(BgL_cdrzd211953zd2_2080))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					if (NULLP(CDR(BgL_cdrzd211953zd2_2080)))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							obj_t
																																																								BgL_arg2057z00_2084;
																																																							obj_t
																																																								BgL_arg2058z00_2085;
																																																							BgL_arg2057z00_2084
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd211949zd2_2079));
																																																							BgL_arg2058z00_2085
																																																								=
																																																								CAR
																																																								(BgL_cdrzd211953zd2_2080);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_6762;
																																																								{
																																																									obj_t
																																																										BgL_ez00_6764;
																																																									obj_t
																																																										BgL_vz00_6763;
																																																									BgL_vz00_6763
																																																										=
																																																										BgL_arg2057z00_2084;
																																																									BgL_ez00_6764
																																																										=
																																																										BgL_arg2058z00_2085;
																																																									BgL_ez00_1507
																																																										=
																																																										BgL_ez00_6764;
																																																									BgL_vz00_1506
																																																										=
																																																										BgL_vz00_6763;
																																																									goto
																																																										BgL_tagzd2165zd2_1508;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_6762);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string2870z00zz__evaluatez00,
																																																								BGl_string2945z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string2870z00zz__evaluatez00,
																																																						BGl_string2945z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd212010zd2_2088;
																																																BgL_cdrzd212010zd2_2088
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_cdrzd212014zd2_2089;
																																																	BgL_cdrzd212014zd2_2089
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd212010zd2_2088));
																																																	if (PAIRP(BgL_cdrzd212014zd2_2089))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			if (NULLP(CDR(BgL_cdrzd212014zd2_2089)))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_arg2066z00_2093;
																																																					obj_t
																																																						BgL_arg2067z00_2094;
																																																					BgL_arg2066z00_2093
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd212010zd2_2088));
																																																					BgL_arg2067z00_2094
																																																						=
																																																						CAR
																																																						(BgL_cdrzd212014zd2_2089);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_6779;
																																																						{
																																																							obj_t
																																																								BgL_ez00_6781;
																																																							obj_t
																																																								BgL_vz00_6780;
																																																							BgL_vz00_6780
																																																								=
																																																								BgL_arg2066z00_2093;
																																																							BgL_ez00_6781
																																																								=
																																																								BgL_arg2067z00_2094;
																																																							BgL_ez00_1507
																																																								=
																																																								BgL_ez00_6781;
																																																							BgL_vz00_1506
																																																								=
																																																								BgL_vz00_6780;
																																																							goto
																																																								BgL_tagzd2165zd2_1508;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_6779);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string2870z00zz__evaluatez00,
																																																						BGl_string2945z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string2870z00zz__evaluatez00,
																																																				BGl_string2945z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd212071zd2_2096;
																																														BgL_cdrzd212071zd2_2096
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_cdrzd212075zd2_2097;
																																															BgL_cdrzd212075zd2_2097
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd212071zd2_2096));
																																															if (PAIRP(BgL_cdrzd212075zd2_2097))
																																																{	/* Eval/evaluate.scm 424 */
																																																	if (NULLP(CDR(BgL_cdrzd212075zd2_2097)))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_arg2074z00_2101;
																																																			obj_t
																																																				BgL_arg2075z00_2102;
																																																			BgL_arg2074z00_2101
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd212071zd2_2096));
																																																			BgL_arg2075z00_2102
																																																				=
																																																				CAR
																																																				(BgL_cdrzd212075zd2_2097);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_6796;
																																																				{
																																																					obj_t
																																																						BgL_ez00_6798;
																																																					obj_t
																																																						BgL_vz00_6797;
																																																					BgL_vz00_6797
																																																						=
																																																						BgL_arg2074z00_2101;
																																																					BgL_ez00_6798
																																																						=
																																																						BgL_arg2075z00_2102;
																																																					BgL_ez00_1507
																																																						=
																																																						BgL_ez00_6798;
																																																					BgL_vz00_1506
																																																						=
																																																						BgL_vz00_6797;
																																																					goto
																																																						BgL_tagzd2165zd2_1508;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_6796);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string2870z00zz__evaluatez00,
																																																				BGl_string2945z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2870z00zz__evaluatez00,
																																																		BGl_string2945z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd212132zd2_2104;
																																												BgL_cdrzd212132zd2_2104
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd212136zd2_2105;
																																													BgL_cdrzd212136zd2_2105
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd212132zd2_2104));
																																													if (PAIRP(BgL_cdrzd212136zd2_2105))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd212136zd2_2105)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg2080z00_2109;
																																																	obj_t
																																																		BgL_arg2081z00_2110;
																																																	BgL_arg2080z00_2109
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd212132zd2_2104));
																																																	BgL_arg2081z00_2110
																																																		=
																																																		CAR
																																																		(BgL_cdrzd212136zd2_2105);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6813;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6815;
																																																			obj_t
																																																				BgL_vz00_6814;
																																																			BgL_vz00_6814
																																																				=
																																																				BgL_arg2080z00_2109;
																																																			BgL_ez00_6815
																																																				=
																																																				BgL_arg2081z00_2110;
																																																			BgL_ez00_1507
																																																				=
																																																				BgL_ez00_6815;
																																																			BgL_vz00_1506
																																																				=
																																																				BgL_vz00_6814;
																																																			goto
																																																				BgL_tagzd2165zd2_1508;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6813);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2870z00zz__evaluatez00,
																																																		BGl_string2945z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2870z00zz__evaluatez00,
																																																BGl_string2945z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212193zd2_2112;
																																										BgL_cdrzd212193zd2_2112
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_cdrzd212197zd2_2113;
																																											BgL_cdrzd212197zd2_2113
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd212193zd2_2112));
																																											if (PAIRP(BgL_cdrzd212197zd2_2113))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212197zd2_2113)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2087z00_2117;
																																															obj_t
																																																BgL_arg2088z00_2118;
																																															BgL_arg2087z00_2117
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd212193zd2_2112));
																																															BgL_arg2088z00_2118
																																																=
																																																CAR
																																																(BgL_cdrzd212197zd2_2113);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_6830;
																																																{
																																																	obj_t
																																																		BgL_ez00_6832;
																																																	obj_t
																																																		BgL_vz00_6831;
																																																	BgL_vz00_6831
																																																		=
																																																		BgL_arg2087z00_2117;
																																																	BgL_ez00_6832
																																																		=
																																																		BgL_arg2088z00_2118;
																																																	BgL_ez00_1507
																																																		=
																																																		BgL_ez00_6832;
																																																	BgL_vz00_1506
																																																		=
																																																		BgL_vz00_6831;
																																																	goto
																																																		BgL_tagzd2165zd2_1508;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_6830);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2870z00zz__evaluatez00,
																																																BGl_string2945z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string2870z00zz__evaluatez00,
																																														BGl_string2945z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd212241zd2_2120;
																																								BgL_cdrzd212241zd2_2120
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{	/* Eval/evaluate.scm 424 */
																																									obj_t
																																										BgL_carzd212244zd2_2121;
																																									obj_t
																																										BgL_cdrzd212245zd2_2122;
																																									BgL_carzd212244zd2_2121
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd212241zd2_2120));
																																									BgL_cdrzd212245zd2_2122
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd212241zd2_2120));
																																									if ((CAR(((obj_t) BgL_carzd212244zd2_2121)) == BGl_symbol2955z00zz__evaluatez00))
																																										{	/* Eval/evaluate.scm 424 */
																																											if (PAIRP(BgL_cdrzd212245zd2_2122))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212245zd2_2122)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2095z00_2128;
																																															obj_t
																																																BgL_arg2096z00_2129;
																																															BgL_arg2095z00_2128
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd212244zd2_2121));
																																															BgL_arg2096z00_2129
																																																=
																																																CAR
																																																(BgL_cdrzd212245zd2_2122);
																																															{
																																																obj_t
																																																	BgL_e2z00_6854;
																																																obj_t
																																																	BgL_lz00_6853;
																																																BgL_lz00_6853
																																																	=
																																																	BgL_arg2095z00_2128;
																																																BgL_e2z00_6854
																																																	=
																																																	BgL_arg2096z00_2129;
																																																BgL_e2z00_1504
																																																	=
																																																	BgL_e2z00_6854;
																																																BgL_lz00_1503
																																																	=
																																																	BgL_lz00_6853;
																																																goto
																																																	BgL_tagzd2164zd2_1505;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2870z00zz__evaluatez00,
																																																BGl_string2945z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string2870z00zz__evaluatez00,
																																														BGl_string2945z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_cdrzd212321zd2_2132;
																																											BgL_cdrzd212321zd2_2132
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd212241zd2_2120));
																																											if (PAIRP(BgL_cdrzd212321zd2_2132))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212321zd2_2132)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2101z00_2136;
																																															obj_t
																																																BgL_arg2102z00_2137;
																																															BgL_arg2101z00_2136
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd212241zd2_2120));
																																															BgL_arg2102z00_2137
																																																=
																																																CAR
																																																(BgL_cdrzd212321zd2_2132);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_6867;
																																																{
																																																	obj_t
																																																		BgL_ez00_6869;
																																																	obj_t
																																																		BgL_vz00_6868;
																																																	BgL_vz00_6868
																																																		=
																																																		BgL_arg2101z00_2136;
																																																	BgL_ez00_6869
																																																		=
																																																		BgL_arg2102z00_2137;
																																																	BgL_ez00_1507
																																																		=
																																																		BgL_ez00_6869;
																																																	BgL_vz00_1506
																																																		=
																																																		BgL_vz00_6868;
																																																	goto
																																																		BgL_tagzd2165zd2_1508;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_6867);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2870z00zz__evaluatez00,
																																																BGl_string2945z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string2870z00zz__evaluatez00,
																																														BGl_string2945z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd212378zd2_2141;
																																						BgL_cdrzd212378zd2_2141
																																							=
																																							CDR
																																							(BgL_ez00_69);
																																						{	/* Eval/evaluate.scm 424 */
																																							obj_t
																																								BgL_cdrzd212382zd2_2142;
																																							BgL_cdrzd212382zd2_2142
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd212378zd2_2141));
																																							if (PAIRP(BgL_cdrzd212382zd2_2142))
																																								{	/* Eval/evaluate.scm 424 */
																																									if (NULLP(CDR(BgL_cdrzd212382zd2_2142)))
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_arg2109z00_2146;
																																											obj_t
																																												BgL_arg2110z00_2147;
																																											BgL_arg2109z00_2146
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd212378zd2_2141));
																																											BgL_arg2110z00_2147
																																												=
																																												CAR
																																												(BgL_cdrzd212382zd2_2142);
																																											{
																																												BgL_ev_hookz00_bglt
																																													BgL_auxz00_6884;
																																												{
																																													obj_t
																																														BgL_ez00_6886;
																																													obj_t
																																														BgL_vz00_6885;
																																													BgL_vz00_6885
																																														=
																																														BgL_arg2109z00_2146;
																																													BgL_ez00_6886
																																														=
																																														BgL_arg2110z00_2147;
																																													BgL_ez00_1507
																																														=
																																														BgL_ez00_6886;
																																													BgL_vz00_1506
																																														=
																																														BgL_vz00_6885;
																																													goto
																																														BgL_tagzd2165zd2_1508;
																																												}
																																												return
																																													(
																																													(obj_t)
																																													BgL_auxz00_6884);
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_74,
																																												BGl_string2870z00zz__evaluatez00,
																																												BGl_string2945z00zz__evaluatez00,
																																												BgL_ez00_69);
																																										}
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 424 */
																																									return
																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																										(BgL_locz00_74,
																																										BGl_string2870z00zz__evaluatez00,
																																										BGl_string2945z00zz__evaluatez00,
																																										BgL_ez00_69);
																																								}
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				return
																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																					(BgL_locz00_74,
																																					BGl_string2870z00zz__evaluatez00,
																																					BGl_string2945z00zz__evaluatez00,
																																					BgL_ez00_69);
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_cdrzd212503zd2_2149;
																																		BgL_cdrzd212503zd2_2149
																																			=
																																			CDR
																																			(BgL_ez00_69);
																																		if ((CAR
																																				(BgL_ez00_69)
																																				==
																																				BGl_symbol2969z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 424 */
																																				if (PAIRP(BgL_cdrzd212503zd2_2149))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd212508zd2_2153;
																																						BgL_cdrzd212508zd2_2153
																																							=
																																							CDR
																																							(BgL_cdrzd212503zd2_2149);
																																						if (PAIRP(BgL_cdrzd212508zd2_2153))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_carzd212512zd2_2155;
																																								BgL_carzd212512zd2_2155
																																									=
																																									CAR
																																									(BgL_cdrzd212508zd2_2153);
																																								if (PAIRP(BgL_carzd212512zd2_2155))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212517zd2_2157;
																																										BgL_cdrzd212517zd2_2157
																																											=
																																											CDR
																																											(BgL_carzd212512zd2_2155);
																																										if ((CAR(BgL_carzd212512zd2_2155) == BGl_symbol2934z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd212517zd2_2157))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd212521zd2_2161;
																																														BgL_cdrzd212521zd2_2161
																																															=
																																															CDR
																																															(BgL_cdrzd212517zd2_2157);
																																														if (PAIRP(BgL_cdrzd212521zd2_2161))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (NULLP(CDR(BgL_cdrzd212521zd2_2161)))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd212508zd2_2153)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2127z00_2167;
																																																				obj_t
																																																					BgL_arg2128z00_2168;
																																																				obj_t
																																																					BgL_arg2129z00_2169;
																																																				BgL_arg2127z00_2167
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212503zd2_2149);
																																																				BgL_arg2128z00_2168
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212517zd2_2157);
																																																				BgL_arg2129z00_2169
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212521zd2_2161);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_6921;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_6924;
																																																						obj_t
																																																							BgL_formalsz00_6923;
																																																						obj_t
																																																							BgL_gvz00_6922;
																																																						BgL_gvz00_6922
																																																							=
																																																							BgL_arg2127z00_2167;
																																																						BgL_formalsz00_6923
																																																							=
																																																							BgL_arg2128z00_2168;
																																																						BgL_bodyz00_6924
																																																							=
																																																							BgL_arg2129z00_2169;
																																																						BgL_bodyz00_1512
																																																							=
																																																							BgL_bodyz00_6924;
																																																						BgL_formalsz00_1511
																																																							=
																																																							BgL_formalsz00_6923;
																																																						BgL_gvz00_1510
																																																							=
																																																							BgL_gvz00_6922;
																																																						goto
																																																							BgL_tagzd2167zd2_1513;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6921);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2130z00_2170;
																																																				BgL_arg2130z00_2170
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6927;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6929;
																																																						obj_t
																																																							BgL_fz00_6928;
																																																						BgL_fz00_6928
																																																							=
																																																							BgL_arg2130z00_2170;
																																																						BgL_argsz00_6929
																																																							=
																																																							BgL_cdrzd212503zd2_2149;
																																																						BgL_argsz00_1538
																																																							=
																																																							BgL_argsz00_6929;
																																																						BgL_fz00_1537
																																																							=
																																																							BgL_fz00_6928;
																																																						goto
																																																							BgL_tagzd2176zd2_1539;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6927);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd212623zd2_2174;
																																																		BgL_cdrzd212623zd2_2174
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd212503zd2_2149));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd212623zd2_2174))))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2135z00_2177;
																																																				obj_t
																																																					BgL_arg2136z00_2178;
																																																				BgL_arg2135z00_2177
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd212503zd2_2149));
																																																				BgL_arg2136z00_2178
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd212623zd2_2174));
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_6941;
																																																					{
																																																						obj_t
																																																							BgL_gez00_6943;
																																																						obj_t
																																																							BgL_gvz00_6942;
																																																						BgL_gvz00_6942
																																																							=
																																																							BgL_arg2135z00_2177;
																																																						BgL_gez00_6943
																																																							=
																																																							BgL_arg2136z00_2178;
																																																						BgL_gez00_1515
																																																							=
																																																							BgL_gez00_6943;
																																																						BgL_gvz00_1514
																																																							=
																																																							BgL_gvz00_6942;
																																																						goto
																																																							BgL_tagzd2168zd2_1516;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6941);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2137z00_2179;
																																																				obj_t
																																																					BgL_arg2138z00_2180;
																																																				BgL_arg2137z00_2179
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg2138z00_2180
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6947;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6949;
																																																						obj_t
																																																							BgL_fz00_6948;
																																																						BgL_fz00_6948
																																																							=
																																																							BgL_arg2137z00_2179;
																																																						BgL_argsz00_6949
																																																							=
																																																							BgL_arg2138z00_2180;
																																																						BgL_argsz00_1538
																																																							=
																																																							BgL_argsz00_6949;
																																																						BgL_fz00_1537
																																																							=
																																																							BgL_fz00_6948;
																																																						goto
																																																							BgL_tagzd2176zd2_1539;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6947);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd212712zd2_2184;
																																																BgL_cdrzd212712zd2_2184
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd212503zd2_2149));
																																																if (NULLP(CDR(((obj_t) BgL_cdrzd212712zd2_2184))))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2145z00_2187;
																																																		obj_t
																																																			BgL_arg2146z00_2188;
																																																		BgL_arg2145z00_2187
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd212503zd2_2149));
																																																		BgL_arg2146z00_2188
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd212712zd2_2184));
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_6961;
																																																			{
																																																				obj_t
																																																					BgL_gez00_6963;
																																																				obj_t
																																																					BgL_gvz00_6962;
																																																				BgL_gvz00_6962
																																																					=
																																																					BgL_arg2145z00_2187;
																																																				BgL_gez00_6963
																																																					=
																																																					BgL_arg2146z00_2188;
																																																				BgL_gez00_1515
																																																					=
																																																					BgL_gez00_6963;
																																																				BgL_gvz00_1514
																																																					=
																																																					BgL_gvz00_6962;
																																																				goto
																																																					BgL_tagzd2168zd2_1516;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6961);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2147z00_2189;
																																																		obj_t
																																																			BgL_arg2148z00_2190;
																																																		BgL_arg2147z00_2189
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg2148z00_2190
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6967;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6969;
																																																				obj_t
																																																					BgL_fz00_6968;
																																																				BgL_fz00_6968
																																																					=
																																																					BgL_arg2147z00_2189;
																																																				BgL_argsz00_6969
																																																					=
																																																					BgL_arg2148z00_2190;
																																																				BgL_argsz00_1538
																																																					=
																																																					BgL_argsz00_6969;
																																																				BgL_fz00_1537
																																																					=
																																																					BgL_fz00_6968;
																																																				goto
																																																					BgL_tagzd2176zd2_1539;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6967);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd212801zd2_2193;
																																														BgL_cdrzd212801zd2_2193
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_cdrzd212503zd2_2149));
																																														if (NULLP(CDR(((obj_t) BgL_cdrzd212801zd2_2193))))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2152z00_2196;
																																																obj_t
																																																	BgL_arg2153z00_2197;
																																																BgL_arg2152z00_2196
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd212503zd2_2149));
																																																BgL_arg2153z00_2197
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd212801zd2_2193));
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_6981;
																																																	{
																																																		obj_t
																																																			BgL_gez00_6983;
																																																		obj_t
																																																			BgL_gvz00_6982;
																																																		BgL_gvz00_6982
																																																			=
																																																			BgL_arg2152z00_2196;
																																																		BgL_gez00_6983
																																																			=
																																																			BgL_arg2153z00_2197;
																																																		BgL_gez00_1515
																																																			=
																																																			BgL_gez00_6983;
																																																		BgL_gvz00_1514
																																																			=
																																																			BgL_gvz00_6982;
																																																		goto
																																																			BgL_tagzd2168zd2_1516;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6981);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2154z00_2198;
																																																obj_t
																																																	BgL_arg2155z00_2199;
																																																BgL_arg2154z00_2198
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2155z00_2199
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6987;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6989;
																																																		obj_t
																																																			BgL_fz00_6988;
																																																		BgL_fz00_6988
																																																			=
																																																			BgL_arg2154z00_2198;
																																																		BgL_argsz00_6989
																																																			=
																																																			BgL_arg2155z00_2199;
																																																		BgL_argsz00_1538
																																																			=
																																																			BgL_argsz00_6989;
																																																		BgL_fz00_1537
																																																			=
																																																			BgL_fz00_6988;
																																																		goto
																																																			BgL_tagzd2176zd2_1539;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6987);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd212890zd2_2202;
																																												BgL_cdrzd212890zd2_2202
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_cdrzd212503zd2_2149));
																																												if (NULLP(CDR(((obj_t) BgL_cdrzd212890zd2_2202))))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2159z00_2205;
																																														obj_t
																																															BgL_arg2160z00_2206;
																																														BgL_arg2159z00_2205
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd212503zd2_2149));
																																														BgL_arg2160z00_2206
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd212890zd2_2202));
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_7001;
																																															{
																																																obj_t
																																																	BgL_gez00_7003;
																																																obj_t
																																																	BgL_gvz00_7002;
																																																BgL_gvz00_7002
																																																	=
																																																	BgL_arg2159z00_2205;
																																																BgL_gez00_7003
																																																	=
																																																	BgL_arg2160z00_2206;
																																																BgL_gez00_1515
																																																	=
																																																	BgL_gez00_7003;
																																																BgL_gvz00_1514
																																																	=
																																																	BgL_gvz00_7002;
																																																goto
																																																	BgL_tagzd2168zd2_1516;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7001);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2161z00_2207;
																																														obj_t
																																															BgL_arg2162z00_2208;
																																														BgL_arg2161z00_2207
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg2162z00_2208
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7007;
																																															{
																																																obj_t
																																																	BgL_argsz00_7009;
																																																obj_t
																																																	BgL_fz00_7008;
																																																BgL_fz00_7008
																																																	=
																																																	BgL_arg2161z00_2207;
																																																BgL_argsz00_7009
																																																	=
																																																	BgL_arg2162z00_2208;
																																																BgL_argsz00_1538
																																																	=
																																																	BgL_argsz00_7009;
																																																BgL_fz00_1537
																																																	=
																																																	BgL_fz00_7008;
																																																goto
																																																	BgL_tagzd2176zd2_1539;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7007);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212979zd2_2212;
																																										BgL_cdrzd212979zd2_2212
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_cdrzd212503zd2_2149));
																																										if (NULLP(CDR(((obj_t) BgL_cdrzd212979zd2_2212))))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2167z00_2215;
																																												obj_t
																																													BgL_arg2169z00_2216;
																																												BgL_arg2167z00_2215
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_cdrzd212503zd2_2149));
																																												BgL_arg2169z00_2216
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_cdrzd212979zd2_2212));
																																												{
																																													BgL_ev_defglobalz00_bglt
																																														BgL_auxz00_7021;
																																													{
																																														obj_t
																																															BgL_gez00_7023;
																																														obj_t
																																															BgL_gvz00_7022;
																																														BgL_gvz00_7022
																																															=
																																															BgL_arg2167z00_2215;
																																														BgL_gez00_7023
																																															=
																																															BgL_arg2169z00_2216;
																																														BgL_gez00_1515
																																															=
																																															BgL_gez00_7023;
																																														BgL_gvz00_1514
																																															=
																																															BgL_gvz00_7022;
																																														goto
																																															BgL_tagzd2168zd2_1516;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7021);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2170z00_2217;
																																												obj_t
																																													BgL_arg2171z00_2218;
																																												BgL_arg2170z00_2217
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2171z00_2218
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7027;
																																													{
																																														obj_t
																																															BgL_argsz00_7029;
																																														obj_t
																																															BgL_fz00_7028;
																																														BgL_fz00_7028
																																															=
																																															BgL_arg2170z00_2217;
																																														BgL_argsz00_7029
																																															=
																																															BgL_arg2171z00_2218;
																																														BgL_argsz00_1538
																																															=
																																															BgL_argsz00_7029;
																																														BgL_fz00_1537
																																															=
																																															BgL_fz00_7028;
																																														goto
																																															BgL_tagzd2176zd2_1539;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7027);
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg2173z00_2220;
																																								BgL_arg2173z00_2220
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_7032;
																																									{
																																										obj_t
																																											BgL_argsz00_7034;
																																										obj_t
																																											BgL_fz00_7033;
																																										BgL_fz00_7033
																																											=
																																											BgL_arg2173z00_2220;
																																										BgL_argsz00_7034
																																											=
																																											BgL_cdrzd212503zd2_2149;
																																										BgL_argsz00_1538
																																											=
																																											BgL_argsz00_7034;
																																										BgL_fz00_1537
																																											=
																																											BgL_fz00_7033;
																																										goto
																																											BgL_tagzd2176zd2_1539;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_7032);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_arg2175z00_2222;
																																						BgL_arg2175z00_2222
																																							=
																																							CAR
																																							(BgL_ez00_69);
																																						{
																																							BgL_ev_appz00_bglt
																																								BgL_auxz00_7037;
																																							{
																																								obj_t
																																									BgL_argsz00_7039;
																																								obj_t
																																									BgL_fz00_7038;
																																								BgL_fz00_7038
																																									=
																																									BgL_arg2175z00_2222;
																																								BgL_argsz00_7039
																																									=
																																									BgL_cdrzd212503zd2_2149;
																																								BgL_argsz00_1538
																																									=
																																									BgL_argsz00_7039;
																																								BgL_fz00_1537
																																									=
																																									BgL_fz00_7038;
																																								goto
																																									BgL_tagzd2176zd2_1539;
																																							}
																																							return
																																								(
																																								(obj_t)
																																								BgL_auxz00_7037);
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				if (
																																					(CAR
																																						(BgL_ez00_69)
																																						==
																																						BGl_symbol2971z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 424 */
																																						if (PAIRP(BgL_cdrzd212503zd2_2149))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_carzd213227zd2_2228;
																																								BgL_carzd213227zd2_2228
																																									=
																																									CAR
																																									(BgL_cdrzd212503zd2_2149);
																																								if (PAIRP(BgL_carzd213227zd2_2228))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (NULLP(CDR(BgL_carzd213227zd2_2228)))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2184z00_2232;
																																												obj_t
																																													BgL_arg2185z00_2233;
																																												BgL_arg2184z00_2232
																																													=
																																													CAR
																																													(BgL_carzd213227zd2_2228);
																																												BgL_arg2185z00_2233
																																													=
																																													CDR
																																													(BgL_cdrzd212503zd2_2149);
																																												{
																																													BgL_ev_bindzd2exitzd2_bglt
																																														BgL_auxz00_7054;
																																													{
																																														obj_t
																																															BgL_bodyz00_7056;
																																														obj_t
																																															BgL_vz00_7055;
																																														BgL_vz00_7055
																																															=
																																															BgL_arg2184z00_2232;
																																														BgL_bodyz00_7056
																																															=
																																															BgL_arg2185z00_2233;
																																														BgL_bodyz00_1518
																																															=
																																															BgL_bodyz00_7056;
																																														BgL_vz00_1517
																																															=
																																															BgL_vz00_7055;
																																														goto
																																															BgL_tagzd2169zd2_1519;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7054);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2186z00_2234;
																																												obj_t
																																													BgL_arg2187z00_2235;
																																												BgL_arg2186z00_2234
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2187z00_2235
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7060;
																																													{
																																														obj_t
																																															BgL_argsz00_7062;
																																														obj_t
																																															BgL_fz00_7061;
																																														BgL_fz00_7061
																																															=
																																															BgL_arg2186z00_2234;
																																														BgL_argsz00_7062
																																															=
																																															BgL_arg2187z00_2235;
																																														BgL_argsz00_1538
																																															=
																																															BgL_argsz00_7062;
																																														BgL_fz00_1537
																																															=
																																															BgL_fz00_7061;
																																														goto
																																															BgL_tagzd2176zd2_1539;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7060);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2189z00_2237;
																																										obj_t
																																											BgL_arg2190z00_2238;
																																										BgL_arg2189z00_2237
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										BgL_arg2190z00_2238
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_7066;
																																											{
																																												obj_t
																																													BgL_argsz00_7068;
																																												obj_t
																																													BgL_fz00_7067;
																																												BgL_fz00_7067
																																													=
																																													BgL_arg2189z00_2237;
																																												BgL_argsz00_7068
																																													=
																																													BgL_arg2190z00_2238;
																																												BgL_argsz00_1538
																																													=
																																													BgL_argsz00_7068;
																																												BgL_fz00_1537
																																													=
																																													BgL_fz00_7067;
																																												goto
																																													BgL_tagzd2176zd2_1539;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7066);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg2191z00_2239;
																																								obj_t
																																									BgL_arg2192z00_2240;
																																								BgL_arg2191z00_2239
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								BgL_arg2192z00_2240
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_7072;
																																									{
																																										obj_t
																																											BgL_argsz00_7074;
																																										obj_t
																																											BgL_fz00_7073;
																																										BgL_fz00_7073
																																											=
																																											BgL_arg2191z00_2239;
																																										BgL_argsz00_7074
																																											=
																																											BgL_arg2192z00_2240;
																																										BgL_argsz00_1538
																																											=
																																											BgL_argsz00_7074;
																																										BgL_fz00_1537
																																											=
																																											BgL_fz00_7073;
																																										goto
																																											BgL_tagzd2176zd2_1539;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_7072);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd213398zd2_2241;
																																						BgL_cdrzd213398zd2_2241
																																							=
																																							CDR
																																							(BgL_ez00_69);
																																						if (
																																							(CAR
																																								(BgL_ez00_69)
																																								==
																																								BGl_symbol2973z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd213398zd2_2241))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2196z00_2245;
																																										obj_t
																																											BgL_arg2197z00_2246;
																																										BgL_arg2196z00_2245
																																											=
																																											CAR
																																											(BgL_cdrzd213398zd2_2241);
																																										BgL_arg2197z00_2246
																																											=
																																											CDR
																																											(BgL_cdrzd213398zd2_2241);
																																										{	/* Eval/evaluate.scm 575 */
																																											BgL_ev_unwindzd2protectzd2_bglt
																																												BgL_new1154z00_4291;
																																											{	/* Eval/evaluate.scm 576 */
																																												BgL_ev_unwindzd2protectzd2_bglt
																																													BgL_new1153z00_4292;
																																												BgL_new1153z00_4292
																																													=
																																													(
																																													(BgL_ev_unwindzd2protectzd2_bglt)
																																													BOBJECT
																																													(GC_MALLOC
																																														(sizeof
																																															(struct
																																																BgL_ev_unwindzd2protectzd2_bgl))));
																																												{	/* Eval/evaluate.scm 576 */
																																													long
																																														BgL_arg2409z00_4293;
																																													BgL_arg2409z00_4293
																																														=
																																														BGL_CLASS_INDEX
																																														(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
																																													BGL_OBJECT_CLASS_NUM_SET
																																														(
																																														((BgL_objectz00_bglt) BgL_new1153z00_4292), BgL_arg2409z00_4293);
																																												}
																																												BgL_new1154z00_4291
																																													=
																																													BgL_new1153z00_4292;
																																											}
																																											{
																																												BgL_ev_exprz00_bglt
																																													BgL_auxz00_7088;
																																												{	/* Eval/evaluate.scm 380 */
																																													obj_t
																																														BgL_arg2427z00_4297;
																																													BgL_arg2427z00_4297
																																														=
																																														BGl_getzd2locationzd2zz__evaluatez00
																																														(BgL_arg2196z00_2245,
																																														BgL_locz00_74);
																																													BgL_auxz00_7088
																																														=
																																														(
																																														(BgL_ev_exprz00_bglt)
																																														BGl_uconvzf2locze70z15zz__evaluatez00
																																														(BgL_wherez00_73,
																																															BgL_globalsz00_71,
																																															BgL_localsz00_70,
																																															BgL_arg2196z00_2245,
																																															BgL_arg2427z00_4297));
																																												}
																																												((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1154z00_4291))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7088), BUNSPEC);
																																											}
																																											((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1154z00_4291))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2197z00_2246, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																											return
																																												(
																																												(obj_t)
																																												BgL_new1154z00_4291);
																																										}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2198z00_2247;
																																										BgL_arg2198z00_2247
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_7098;
																																											{
																																												obj_t
																																													BgL_argsz00_7100;
																																												obj_t
																																													BgL_fz00_7099;
																																												BgL_fz00_7099
																																													=
																																													BgL_arg2198z00_2247;
																																												BgL_argsz00_7100
																																													=
																																													BgL_cdrzd213398zd2_2241;
																																												BgL_argsz00_1538
																																													=
																																													BgL_argsz00_7100;
																																												BgL_fz00_1537
																																													=
																																													BgL_fz00_7099;
																																												goto
																																													BgL_tagzd2176zd2_1539;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7098);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								if ((CAR(BgL_ez00_69) == BGl_symbol2975z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd213398zd2_2241))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2203z00_2253;
																																												obj_t
																																													BgL_arg2204z00_2254;
																																												BgL_arg2203z00_2253
																																													=
																																													CAR
																																													(BgL_cdrzd213398zd2_2241);
																																												BgL_arg2204z00_2254
																																													=
																																													CDR
																																													(BgL_cdrzd213398zd2_2241);
																																												{	/* Eval/evaluate.scm 579 */
																																													BgL_ev_withzd2handlerzd2_bglt
																																														BgL_new1157z00_4304;
																																													{	/* Eval/evaluate.scm 580 */
																																														BgL_ev_withzd2handlerzd2_bglt
																																															BgL_new1156z00_4305;
																																														BgL_new1156z00_4305
																																															=
																																															(
																																															(BgL_ev_withzd2handlerzd2_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_withzd2handlerzd2_bgl))));
																																														{	/* Eval/evaluate.scm 580 */
																																															long
																																																BgL_arg2410z00_4306;
																																															BgL_arg2410z00_4306
																																																=
																																																BGL_CLASS_INDEX
																																																(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1156z00_4305), BgL_arg2410z00_4306);
																																														}
																																														BgL_new1157z00_4304
																																															=
																																															BgL_new1156z00_4305;
																																													}
																																													{
																																														BgL_ev_exprz00_bglt
																																															BgL_auxz00_7113;
																																														{	/* Eval/evaluate.scm 380 */
																																															obj_t
																																																BgL_arg2427z00_4310;
																																															BgL_arg2427z00_4310
																																																=
																																																BGl_getzd2locationzd2zz__evaluatez00
																																																(BgL_arg2203z00_2253,
																																																BgL_locz00_74);
																																															BgL_auxz00_7113
																																																=
																																																(
																																																(BgL_ev_exprz00_bglt)
																																																BGl_uconvzf2locze70z15zz__evaluatez00
																																																(BgL_wherez00_73,
																																																	BgL_globalsz00_71,
																																																	BgL_localsz00_70,
																																																	BgL_arg2203z00_2253,
																																																	BgL_arg2427z00_4310));
																																														}
																																														((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1157z00_4304))->BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7113), BUNSPEC);
																																													}
																																													((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1157z00_4304))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2204z00_2254, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													return
																																														(
																																														(obj_t)
																																														BgL_new1157z00_4304);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2205z00_2255;
																																												obj_t
																																													BgL_arg2206z00_2256;
																																												BgL_arg2205z00_2255
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2206z00_2256
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7124;
																																													{
																																														obj_t
																																															BgL_argsz00_7126;
																																														obj_t
																																															BgL_fz00_7125;
																																														BgL_fz00_7125
																																															=
																																															BgL_arg2205z00_2255;
																																														BgL_argsz00_7126
																																															=
																																															BgL_arg2206z00_2256;
																																														BgL_argsz00_1538
																																															=
																																															BgL_argsz00_7126;
																																														BgL_fz00_1537
																																															=
																																															BgL_fz00_7125;
																																														goto
																																															BgL_tagzd2176zd2_1539;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7124);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd213505zd2_2257;
																																										BgL_cdrzd213505zd2_2257
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										if ((CAR(BgL_ez00_69) == BGl_symbol2977z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd213505zd2_2257))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd213510zd2_2261;
																																														BgL_cdrzd213510zd2_2261
																																															=
																																															CDR
																																															(BgL_cdrzd213505zd2_2257);
																																														if (PAIRP(BgL_cdrzd213510zd2_2261))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd213515zd2_2263;
																																																BgL_cdrzd213515zd2_2263
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213510zd2_2261);
																																																if ((CAR(BgL_cdrzd213510zd2_2261) == BGl_keyword2979z00zz__evaluatez00))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (PAIRP(BgL_cdrzd213515zd2_2263))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2214z00_2267;
																																																				obj_t
																																																					BgL_arg2215z00_2268;
																																																				obj_t
																																																					BgL_arg2216z00_2269;
																																																				BgL_arg2214z00_2267
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213505zd2_2257);
																																																				BgL_arg2215z00_2268
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213515zd2_2263);
																																																				BgL_arg2216z00_2269
																																																					=
																																																					CDR
																																																					(BgL_cdrzd213515zd2_2263);
																																																				{	/* Eval/evaluate.scm 583 */
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_new1159z00_4321;
																																																					{	/* Eval/evaluate.scm 584 */
																																																						BgL_ev_synchroniza7eza7_bglt
																																																							BgL_new1158z00_4322;
																																																						BgL_new1158z00_4322
																																																							=
																																																							(
																																																							(BgL_ev_synchroniza7eza7_bglt)
																																																							BOBJECT
																																																							(GC_MALLOC
																																																								(sizeof
																																																									(struct
																																																										BgL_ev_synchroniza7eza7_bgl))));
																																																						{	/* Eval/evaluate.scm 584 */
																																																							long
																																																								BgL_arg2411z00_4323;
																																																							BgL_arg2411z00_4323
																																																								=
																																																								BGL_CLASS_INDEX
																																																								(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																							BGL_OBJECT_CLASS_NUM_SET
																																																								(
																																																								((BgL_objectz00_bglt) BgL_new1158z00_4322), BgL_arg2411z00_4323);
																																																						}
																																																						BgL_new1159z00_4321
																																																							=
																																																							BgL_new1158z00_4322;
																																																					}
																																																					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_4321))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																					{
																																																						BgL_ev_exprz00_bglt
																																																							BgL_auxz00_7151;
																																																						{	/* Eval/evaluate.scm 380 */
																																																							obj_t
																																																								BgL_arg2427z00_4327;
																																																							BgL_arg2427z00_4327
																																																								=
																																																								BGl_getzd2locationzd2zz__evaluatez00
																																																								(BgL_arg2214z00_2267,
																																																								BgL_locz00_74);
																																																							BgL_auxz00_7151
																																																								=
																																																								(
																																																								(BgL_ev_exprz00_bglt)
																																																								BGl_uconvzf2locze70z15zz__evaluatez00
																																																								(BgL_wherez00_73,
																																																									BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_arg2214z00_2267,
																																																									BgL_arg2427z00_4327));
																																																						}
																																																						((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_4321))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7151), BUNSPEC);
																																																					}
																																																					{
																																																						BgL_ev_exprz00_bglt
																																																							BgL_auxz00_7156;
																																																						{	/* Eval/evaluate.scm 380 */
																																																							obj_t
																																																								BgL_arg2427z00_4328;
																																																							BgL_arg2427z00_4328
																																																								=
																																																								BGl_getzd2locationzd2zz__evaluatez00
																																																								(BgL_arg2215z00_2268,
																																																								BgL_locz00_74);
																																																							BgL_auxz00_7156
																																																								=
																																																								(
																																																								(BgL_ev_exprz00_bglt)
																																																								BGl_uconvzf2locze70z15zz__evaluatez00
																																																								(BgL_wherez00_73,
																																																									BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_arg2215z00_2268,
																																																									BgL_arg2427z00_4328));
																																																						}
																																																						((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_4321))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7156), BUNSPEC);
																																																					}
																																																					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1159z00_4321))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2216z00_2269, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_new1159z00_4321);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2217z00_2271;
																																																				obj_t
																																																					BgL_arg2218z00_2272;
																																																				BgL_arg2217z00_2271
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd213505zd2_2257));
																																																				BgL_arg2218z00_2272
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd213505zd2_2257));
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_7169;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_7171;
																																																						obj_t
																																																							BgL_mz00_7170;
																																																						BgL_mz00_7170
																																																							=
																																																							BgL_arg2217z00_2271;
																																																						BgL_bodyz00_7171
																																																							=
																																																							BgL_arg2218z00_2272;
																																																						BgL_bodyz00_1531
																																																							=
																																																							BgL_bodyz00_7171;
																																																						BgL_mz00_1530
																																																							=
																																																							BgL_mz00_7170;
																																																						goto
																																																							BgL_tagzd2173zd2_1532;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7169);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2219z00_2274;
																																																		obj_t
																																																			BgL_arg2220z00_2275;
																																																		BgL_arg2219z00_2274
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd213505zd2_2257));
																																																		BgL_arg2220z00_2275
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd213505zd2_2257));
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_7177;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_7179;
																																																				obj_t
																																																					BgL_mz00_7178;
																																																				BgL_mz00_7178
																																																					=
																																																					BgL_arg2219z00_2274;
																																																				BgL_bodyz00_7179
																																																					=
																																																					BgL_arg2220z00_2275;
																																																				BgL_bodyz00_1531
																																																					=
																																																					BgL_bodyz00_7179;
																																																				BgL_mz00_1530
																																																					=
																																																					BgL_mz00_7178;
																																																				goto
																																																					BgL_tagzd2173zd2_1532;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7177);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2222z00_2278;
																																																obj_t
																																																	BgL_arg2223z00_2279;
																																																BgL_arg2222z00_2278
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd213505zd2_2257));
																																																BgL_arg2223z00_2279
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd213505zd2_2257));
																																																{
																																																	BgL_ev_synchroniza7eza7_bglt
																																																		BgL_auxz00_7185;
																																																	{
																																																		obj_t
																																																			BgL_bodyz00_7187;
																																																		obj_t
																																																			BgL_mz00_7186;
																																																		BgL_mz00_7186
																																																			=
																																																			BgL_arg2222z00_2278;
																																																		BgL_bodyz00_7187
																																																			=
																																																			BgL_arg2223z00_2279;
																																																		BgL_bodyz00_1531
																																																			=
																																																			BgL_bodyz00_7187;
																																																		BgL_mz00_1530
																																																			=
																																																			BgL_mz00_7186;
																																																		goto
																																																			BgL_tagzd2173zd2_1532;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7185);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2224z00_2280;
																																														BgL_arg2224z00_2280
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7190;
																																															{
																																																obj_t
																																																	BgL_argsz00_7192;
																																																obj_t
																																																	BgL_fz00_7191;
																																																BgL_fz00_7191
																																																	=
																																																	BgL_arg2224z00_2280;
																																																BgL_argsz00_7192
																																																	=
																																																	BgL_cdrzd213505zd2_2257;
																																																BgL_argsz00_1538
																																																	=
																																																	BgL_argsz00_7192;
																																																BgL_fz00_1537
																																																	=
																																																	BgL_fz00_7191;
																																																goto
																																																	BgL_tagzd2176zd2_1539;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7190);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												if ((CAR(BgL_ez00_69) == BGl_symbol2934z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd213505zd2_2257))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd213617zd2_2286;
																																																BgL_cdrzd213617zd2_2286
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213505zd2_2257);
																																																if (PAIRP(BgL_cdrzd213617zd2_2286))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd213617zd2_2286)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2232z00_2290;
																																																				obj_t
																																																					BgL_arg2233z00_2291;
																																																				BgL_arg2232z00_2290
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213505zd2_2257);
																																																				BgL_arg2233z00_2291
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213617zd2_2286);
																																																				{	/* Eval/evaluate.scm 595 */
																																																					obj_t
																																																						BgL_arg2414z00_4346;
																																																					{	/* Eval/evaluate.scm 595 */
																																																						obj_t
																																																							BgL_arg2416z00_4347;
																																																						{	/* Eval/evaluate.scm 595 */
																																																							obj_t
																																																								BgL_arg2417z00_4348;
																																																							obj_t
																																																								BgL_arg2418z00_4349;
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_symbolz00_4350;
																																																								BgL_symbolz00_4350
																																																									=
																																																									BGl_symbol2981z00zz__evaluatez00;
																																																								{	/* Eval/evaluate.scm 595 */
																																																									obj_t
																																																										BgL_arg2635z00_4351;
																																																									BgL_arg2635z00_4351
																																																										=
																																																										SYMBOL_TO_STRING
																																																										(BgL_symbolz00_4350);
																																																									BgL_arg2417z00_4348
																																																										=
																																																										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																										(BgL_arg2635z00_4351);
																																																								}
																																																							}
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_arg2635z00_4353;
																																																								BgL_arg2635z00_4353
																																																									=
																																																									SYMBOL_TO_STRING
																																																									(
																																																									((obj_t) BgL_wherez00_73));
																																																								BgL_arg2418z00_4349
																																																									=
																																																									BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																									(BgL_arg2635z00_4353);
																																																							}
																																																							BgL_arg2416z00_4347
																																																								=
																																																								string_append
																																																								(BgL_arg2417z00_4348,
																																																								BgL_arg2418z00_4349);
																																																						}
																																																						BgL_arg2414z00_4346
																																																							=
																																																							bstring_to_symbol
																																																							(BgL_arg2416z00_4347);
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BGl_convzd2lambdaze70z35zz__evaluatez00
																																																						(BgL_globalsz00_71,
																																																							BgL_localsz00_70,
																																																							BgL_ez00_69,
																																																							BgL_locz00_74,
																																																							BgL_arg2232z00_2290,
																																																							BgL_arg2233z00_2291,
																																																							BgL_arg2414z00_4346,
																																																							BFALSE));
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2234z00_2292;
																																																				obj_t
																																																					BgL_arg2235z00_2293;
																																																				BgL_arg2234z00_2292
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg2235z00_2293
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7218;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7220;
																																																						obj_t
																																																							BgL_fz00_7219;
																																																						BgL_fz00_7219
																																																							=
																																																							BgL_arg2234z00_2292;
																																																						BgL_argsz00_7220
																																																							=
																																																							BgL_arg2235z00_2293;
																																																						BgL_argsz00_1538
																																																							=
																																																							BgL_argsz00_7220;
																																																						BgL_fz00_1537
																																																							=
																																																							BgL_fz00_7219;
																																																						goto
																																																							BgL_tagzd2176zd2_1539;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7218);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2237z00_2295;
																																																		obj_t
																																																			BgL_arg2238z00_2296;
																																																		BgL_arg2237z00_2295
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg2238z00_2296
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_7224;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_7226;
																																																				obj_t
																																																					BgL_fz00_7225;
																																																				BgL_fz00_7225
																																																					=
																																																					BgL_arg2237z00_2295;
																																																				BgL_argsz00_7226
																																																					=
																																																					BgL_arg2238z00_2296;
																																																				BgL_argsz00_1538
																																																					=
																																																					BgL_argsz00_7226;
																																																				BgL_fz00_1537
																																																					=
																																																					BgL_fz00_7225;
																																																				goto
																																																					BgL_tagzd2176zd2_1539;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7224);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2239z00_2297;
																																																obj_t
																																																	BgL_arg2240z00_2298;
																																																BgL_arg2239z00_2297
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2240z00_2298
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_7230;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_7232;
																																																		obj_t
																																																			BgL_fz00_7231;
																																																		BgL_fz00_7231
																																																			=
																																																			BgL_arg2239z00_2297;
																																																		BgL_argsz00_7232
																																																			=
																																																			BgL_arg2240z00_2298;
																																																		BgL_argsz00_1538
																																																			=
																																																			BgL_argsz00_7232;
																																																		BgL_fz00_1537
																																																			=
																																																			BgL_fz00_7231;
																																																		goto
																																																			BgL_tagzd2176zd2_1539;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7230);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														if ((CAR(BgL_ez00_69) == BGl_symbol2983z00zz__evaluatez00))
																																															{	/* Eval/evaluate.scm 424 */
																																																return
																																																	BGl_errorz00zz__errorz00
																																																	(BGl_string2985z00zz__evaluatez00,
																																																	BGl_string2986z00zz__evaluatez00,
																																																	BgL_ez00_69);
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2243z00_2301;
																																																obj_t
																																																	BgL_arg2244z00_2302;
																																																BgL_arg2243z00_2301
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2244z00_2302
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_7240;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_7242;
																																																		obj_t
																																																			BgL_fz00_7241;
																																																		BgL_fz00_7241
																																																			=
																																																			BgL_arg2243z00_2301;
																																																		BgL_argsz00_7242
																																																			=
																																																			BgL_arg2244z00_2302;
																																																		BgL_argsz00_1538
																																																			=
																																																			BgL_argsz00_7242;
																																																		BgL_fz00_1537
																																																			=
																																																			BgL_fz00_7241;
																																																		goto
																																																			BgL_tagzd2176zd2_1539;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7240);
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
							}
					}
				else
					{	/* Eval/evaluate.scm 424 */
						BgL_xz00_1461 = BgL_ez00_69;
						if (SYMBOLP(BgL_xz00_1461))
							{	/* Eval/evaluate.scm 427 */
								obj_t BgL__ortest_1103z00_2324;

								BgL__ortest_1103z00_2324 =
									BGl_convzd2varzd2zz__evaluatez00(BgL_xz00_1461,
									BgL_localsz00_70);
								if (CBOOL(BgL__ortest_1103z00_2324))
									{	/* Eval/evaluate.scm 427 */
										return BgL__ortest_1103z00_2324;
									}
								else
									{	/* Eval/evaluate.scm 195 */
										BgL_ev_globalz00_bglt BgL_new1077z00_3419;

										{	/* Eval/evaluate.scm 196 */
											BgL_ev_globalz00_bglt BgL_new1076z00_3420;

											BgL_new1076z00_3420 =
												((BgL_ev_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
															BgL_ev_globalz00_bgl))));
											{	/* Eval/evaluate.scm 196 */
												long BgL_arg1391z00_3421;

												BgL_arg1391z00_3421 =
													BGL_CLASS_INDEX
													(BGl_ev_globalz00zz__evaluate_typesz00);
												BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt)
														BgL_new1076z00_3420), BgL_arg1391z00_3421);
											}
											BgL_new1077z00_3419 = BgL_new1076z00_3420;
										}
										((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1077z00_3419))->
												BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
										((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1077z00_3419))->
												BgL_namez00) = ((obj_t) BgL_xz00_1461), BUNSPEC);
										{
											obj_t BgL_auxz00_7255;

											if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
												{	/* Eval/evaluate.scm 198 */
													BgL_auxz00_7255 = BgL_globalsz00_71;
												}
											else
												{	/* Eval/evaluate.scm 198 */
													BgL_auxz00_7255 = BGL_MODULE();
												}
											((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1077z00_3419))->
													BgL_modz00) = ((obj_t) BgL_auxz00_7255), BUNSPEC);
										}
										return ((obj_t) BgL_new1077z00_3419);
									}
							}
						else
							{	/* Eval/evaluate.scm 428 */
								BgL_ev_littz00_bglt BgL_new1105z00_2325;

								{	/* Eval/evaluate.scm 429 */
									BgL_ev_littz00_bglt BgL_new1104z00_2326;

									BgL_new1104z00_2326 =
										((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 429 */
										long BgL_arg2266z00_2327;

										BgL_arg2266z00_2327 =
											BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1104z00_2326),
											BgL_arg2266z00_2327);
									}
									BgL_new1105z00_2325 = BgL_new1104z00_2326;
								}
								((((BgL_ev_littz00_bglt) COBJECT(BgL_new1105z00_2325))->
										BgL_valuez00) = ((obj_t) BgL_xz00_1461), BUNSPEC);
								return ((obj_t) BgL_new1105z00_2325);
							}
					}
			}
		}

	}



/* loop~0 */
	obj_t BGl_loopze70ze7zz__evaluatez00(obj_t BgL_wherez00_4583,
		obj_t BgL_globalsz00_4582, obj_t BgL_localsz00_4581, obj_t BgL_locz00_4580,
		obj_t BgL_esz00_2655)
	{
		{	/* Eval/evaluate.scm 386 */
			if (NULLP(BgL_esz00_2655))
				{	/* Eval/evaluate.scm 387 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 389 */
					obj_t BgL_ez00_2658;

					BgL_ez00_2658 = CAR(((obj_t) BgL_esz00_2655));
					{	/* Eval/evaluate.scm 390 */
						obj_t BgL_arg2433z00_2659;
						obj_t BgL_arg2434z00_2660;

						{	/* Eval/evaluate.scm 390 */
							obj_t BgL_arg2435z00_2661;

							{	/* Eval/evaluate.scm 150 */
								obj_t BgL__ortest_1069z00_3399;

								BgL__ortest_1069z00_3399 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_ez00_2658);
								if (CBOOL(BgL__ortest_1069z00_3399))
									{	/* Eval/evaluate.scm 150 */
										BgL_arg2435z00_2661 = BgL__ortest_1069z00_3399;
									}
								else
									{	/* Eval/evaluate.scm 151 */
										obj_t BgL__ortest_1070z00_3400;

										BgL__ortest_1070z00_3400 =
											BGl_getzd2sourcezd2locationz00zz__readerz00
											(BgL_esz00_2655);
										if (CBOOL(BgL__ortest_1070z00_3400))
											{	/* Eval/evaluate.scm 151 */
												BgL_arg2435z00_2661 = BgL__ortest_1070z00_3400;
											}
										else
											{	/* Eval/evaluate.scm 151 */
												BgL_arg2435z00_2661 = BgL_locz00_4580;
											}
									}
							}
							BgL_arg2433z00_2659 =
								BGl_convz00zz__evaluatez00(BgL_ez00_2658, BgL_localsz00_4581,
								BgL_globalsz00_4582, BFALSE, BgL_wherez00_4583,
								BgL_arg2435z00_2661, ((bool_t) 0));
						}
						{	/* Eval/evaluate.scm 391 */
							obj_t BgL_arg2436z00_2662;

							BgL_arg2436z00_2662 = CDR(((obj_t) BgL_esz00_2655));
							BgL_arg2434z00_2660 =
								BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_4583,
								BgL_globalsz00_4582, BgL_localsz00_4581, BgL_locz00_4580,
								BgL_arg2436z00_2662);
						}
						return MAKE_YOUNG_PAIR(BgL_arg2433z00_2659, BgL_arg2434z00_2660);
					}
				}
		}

	}



/* conv-vals~0 */
	obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t BgL_wherez00_4585,
		obj_t BgL_globalsz00_4584, obj_t BgL_lz00_2473, obj_t BgL_varsz00_2474,
		obj_t BgL_localsz00_2475, obj_t BgL_locz00_2476)
	{
		{	/* Eval/evaluate.scm 502 */
			if (NULLP(BgL_lz00_2473))
				{	/* Eval/evaluate.scm 498 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 500 */
					obj_t BgL_locz00_3551;

					{	/* Eval/evaluate.scm 500 */
						obj_t BgL_arg2348z00_3552;

						BgL_arg2348z00_3552 = CAR(((obj_t) BgL_lz00_2473));
						{	/* Eval/evaluate.scm 144 */
							obj_t BgL__ortest_1068z00_3561;

							BgL__ortest_1068z00_3561 =
								BGl_getzd2sourcezd2locationz00zz__readerz00
								(BgL_arg2348z00_3552);
							if (CBOOL(BgL__ortest_1068z00_3561))
								{	/* Eval/evaluate.scm 144 */
									BgL_locz00_3551 = BgL__ortest_1068z00_3561;
								}
							else
								{	/* Eval/evaluate.scm 144 */
									BgL_locz00_3551 = BgL_locz00_2476;
								}
						}
					}
					{	/* Eval/evaluate.scm 501 */
						obj_t BgL_arg2337z00_3553;
						obj_t BgL_arg2338z00_3554;

						{	/* Eval/evaluate.scm 501 */
							obj_t BgL_arg2339z00_3555;

							{	/* Eval/evaluate.scm 501 */
								obj_t BgL_pairz00_3567;

								{	/* Eval/evaluate.scm 501 */
									obj_t BgL_pairz00_3566;

									BgL_pairz00_3566 = CAR(((obj_t) BgL_lz00_2473));
									BgL_pairz00_3567 = CDR(BgL_pairz00_3566);
								}
								BgL_arg2339z00_3555 = CAR(BgL_pairz00_3567);
							}
							BgL_arg2337z00_3553 =
								BGl_convz00zz__evaluatez00(BgL_arg2339z00_3555,
								BgL_localsz00_2475, BgL_globalsz00_4584, BFALSE,
								BgL_wherez00_4585, BgL_locz00_3551, ((bool_t) 0));
						}
						{	/* Eval/evaluate.scm 502 */
							obj_t BgL_arg2341z00_3556;
							obj_t BgL_arg2342z00_3557;
							obj_t BgL_arg2344z00_3558;

							BgL_arg2341z00_3556 = CDR(((obj_t) BgL_lz00_2473));
							BgL_arg2342z00_3557 = CDR(((obj_t) BgL_varsz00_2474));
							{	/* Eval/evaluate.scm 502 */
								obj_t BgL_arg2345z00_3559;

								BgL_arg2345z00_3559 = CAR(((obj_t) BgL_varsz00_2474));
								BgL_arg2344z00_3558 =
									MAKE_YOUNG_PAIR(BgL_arg2345z00_3559, BgL_localsz00_2475);
							}
							BgL_arg2338z00_3554 =
								BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_4585,
								BgL_globalsz00_4584, BgL_arg2341z00_3556, BgL_arg2342z00_3557,
								BgL_arg2344z00_3558, BgL_locz00_3551);
						}
						return MAKE_YOUNG_PAIR(BgL_arg2337z00_3553, BgL_arg2338z00_3554);
					}
				}
		}

	}



/* conv-lambda~0 */
	BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t
		BgL_globalsz00_4589, obj_t BgL_localsz00_4588, obj_t BgL_ez00_4587,
		obj_t BgL_locz00_4586, obj_t BgL_formalsz00_2664, obj_t BgL_bodyz00_2665,
		obj_t BgL_wherez00_2666, obj_t BgL_typez00_2667)
	{
		{	/* Eval/evaluate.scm 404 */
			{
				obj_t BgL_lz00_2698;

				{	/* Eval/evaluate.scm 406 */
					obj_t BgL_argsz00_2670;

					BgL_lz00_2698 =
						BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00
						(BgL_formalsz00_2664, BGl_errorzd2envzd2zz__errorz00, ((bool_t) 1));
					{
						obj_t BgL_rz00_2702;
						obj_t BgL_flatz00_2703;
						long BgL_arityz00_2704;

						BgL_rz00_2702 = BgL_lz00_2698;
						BgL_flatz00_2703 = BNIL;
						BgL_arityz00_2704 = ((long) 0);
					BgL_zc3z04anonymousza32450ze3z87_2705:
						if (NULLP(BgL_rz00_2702))
							{	/* Eval/evaluate.scm 399 */
								obj_t BgL_val0_1203z00_2707;

								BgL_val0_1203z00_2707 = bgl_reverse_bang(BgL_flatz00_2703);
								{	/* Eval/evaluate.scm 399 */
									int BgL_tmpz00_7306;

									BgL_tmpz00_7306 = (int) (((long) 2));
									BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7306);
								}
								{	/* Eval/evaluate.scm 399 */
									obj_t BgL_auxz00_7311;
									int BgL_tmpz00_7309;

									BgL_auxz00_7311 = BINT(BgL_arityz00_2704);
									BgL_tmpz00_7309 = (int) (((long) 1));
									BGL_MVALUES_VAL_SET(BgL_tmpz00_7309, BgL_auxz00_7311);
								}
								BgL_argsz00_2670 = BgL_val0_1203z00_2707;
							}
						else
							{	/* Eval/evaluate.scm 398 */
								if (PAIRP(BgL_rz00_2702))
									{	/* Eval/evaluate.scm 403 */
										obj_t BgL_arg2453z00_2710;
										obj_t BgL_arg2454z00_2711;
										long BgL_arg2455z00_2712;

										BgL_arg2453z00_2710 = CDR(BgL_rz00_2702);
										BgL_arg2454z00_2711 =
											MAKE_YOUNG_PAIR(BGl_untypezd2identzd2zz__evaluatez00(CAR
												(BgL_rz00_2702)), BgL_flatz00_2703);
										BgL_arg2455z00_2712 = (BgL_arityz00_2704 + ((long) 1));
										{
											long BgL_arityz00_7323;
											obj_t BgL_flatz00_7322;
											obj_t BgL_rz00_7321;

											BgL_rz00_7321 = BgL_arg2453z00_2710;
											BgL_flatz00_7322 = BgL_arg2454z00_2711;
											BgL_arityz00_7323 = BgL_arg2455z00_2712;
											BgL_arityz00_2704 = BgL_arityz00_7323;
											BgL_flatz00_2703 = BgL_flatz00_7322;
											BgL_rz00_2702 = BgL_rz00_7321;
											goto BgL_zc3z04anonymousza32450ze3z87_2705;
										}
									}
								else
									{	/* Eval/evaluate.scm 401 */
										obj_t BgL_val0_1205z00_2715;
										long BgL_val1_1206z00_2716;

										{	/* Eval/evaluate.scm 401 */
											obj_t BgL_arg2458z00_2717;

											BgL_arg2458z00_2717 =
												MAKE_YOUNG_PAIR(BGl_untypezd2identzd2zz__evaluatez00
												(BgL_rz00_2702), BgL_flatz00_2703);
											BgL_val0_1205z00_2715 =
												bgl_reverse_bang(BgL_arg2458z00_2717);
										}
										BgL_val1_1206z00_2716 = (((long) -1) - BgL_arityz00_2704);
										{	/* Eval/evaluate.scm 401 */
											int BgL_tmpz00_7328;

											BgL_tmpz00_7328 = (int) (((long) 2));
											BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7328);
										}
										{	/* Eval/evaluate.scm 401 */
											obj_t BgL_auxz00_7333;
											int BgL_tmpz00_7331;

											BgL_auxz00_7333 = BINT(BgL_val1_1206z00_2716);
											BgL_tmpz00_7331 = (int) (((long) 1));
											BGL_MVALUES_VAL_SET(BgL_tmpz00_7331, BgL_auxz00_7333);
										}
										BgL_argsz00_2670 = BgL_val0_1205z00_2715;
					}}}
					{	/* Eval/evaluate.scm 407 */
						obj_t BgL_arityz00_2671;

						{	/* Eval/evaluate.scm 408 */
							int BgL_tmpz00_7337;

							BgL_tmpz00_7337 = (int) (((long) 1));
							BgL_arityz00_2671 = BGL_MVALUES_VAL(BgL_tmpz00_7337);
						}
						{	/* Eval/evaluate.scm 408 */
							obj_t BgL_varsz00_2672;
							obj_t BgL_bodyz00_2673;
							obj_t BgL_nlocz00_2674;

							if (NULLP(BgL_argsz00_2670))
								{	/* Eval/evaluate.scm 408 */
									BgL_varsz00_2672 = BNIL;
								}
							else
								{	/* Eval/evaluate.scm 408 */
									obj_t BgL_head1209z00_2681;

									BgL_head1209z00_2681 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									{
										obj_t BgL_l1207z00_2683;
										obj_t BgL_tail1210z00_2684;

										BgL_l1207z00_2683 = BgL_argsz00_2670;
										BgL_tail1210z00_2684 = BgL_head1209z00_2681;
									BgL_zc3z04anonymousza32441ze3z87_2685:
										if (NULLP(BgL_l1207z00_2683))
											{	/* Eval/evaluate.scm 408 */
												BgL_varsz00_2672 = CDR(BgL_head1209z00_2681);
											}
										else
											{	/* Eval/evaluate.scm 408 */
												obj_t BgL_newtail1211z00_2687;

												{	/* Eval/evaluate.scm 408 */
													BgL_ev_varz00_bglt BgL_arg2444z00_2689;

													{	/* Eval/evaluate.scm 408 */
														obj_t BgL_vz00_2690;

														BgL_vz00_2690 = CAR(((obj_t) BgL_l1207z00_2683));
														{	/* Eval/evaluate.scm 409 */
															BgL_ev_varz00_bglt BgL_new1099z00_2691;

															{	/* Eval/evaluate.scm 411 */
																BgL_ev_varz00_bglt BgL_new1098z00_2692;

																BgL_new1098z00_2692 =
																	((BgL_ev_varz00_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_ev_varz00_bgl))));
																{	/* Eval/evaluate.scm 411 */
																	long BgL_arg2445z00_2693;

																	BgL_arg2445z00_2693 =
																		BGL_CLASS_INDEX
																		(BGl_ev_varz00zz__evaluate_typesz00);
																	BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt)
																			BgL_new1098z00_2692),
																		BgL_arg2445z00_2693);
																}
																BgL_new1099z00_2691 = BgL_new1098z00_2692;
															}
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1099z00_2691))->
																	BgL_namez00) =
																((obj_t) CAR(((obj_t) BgL_vz00_2690))),
																BUNSPEC);
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1099z00_2691))->BgL_effz00) =
																((obj_t) BFALSE), BUNSPEC);
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1099z00_2691))->
																	BgL_typez00) =
																((obj_t) CDR(((obj_t) BgL_vz00_2690))),
																BUNSPEC);
															BgL_arg2444z00_2689 = BgL_new1099z00_2691;
													}}
													BgL_newtail1211z00_2687 =
														MAKE_YOUNG_PAIR(
														((obj_t) BgL_arg2444z00_2689), BNIL);
												}
												SET_CDR(BgL_tail1210z00_2684, BgL_newtail1211z00_2687);
												{	/* Eval/evaluate.scm 408 */
													obj_t BgL_arg2443z00_2688;

													BgL_arg2443z00_2688 =
														CDR(((obj_t) BgL_l1207z00_2683));
													{
														obj_t BgL_tail1210z00_7365;
														obj_t BgL_l1207z00_7364;

														BgL_l1207z00_7364 = BgL_arg2443z00_2688;
														BgL_tail1210z00_7365 = BgL_newtail1211z00_2687;
														BgL_tail1210z00_2684 = BgL_tail1210z00_7365;
														BgL_l1207z00_2683 = BgL_l1207z00_7364;
														goto BgL_zc3z04anonymousza32441ze3z87_2685;
													}
												}
											}
									}
								}
							BgL_bodyz00_2673 =
								BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
								(BgL_ez00_4587, BgL_formalsz00_2664,
								BGl_typezd2checkszd2zz__evaluatez00(BgL_argsz00_2670,
									BgL_argsz00_2670,
									BGl_typezd2resultzd2zz__evaluatez00(BgL_typez00_2667,
										BgL_bodyz00_2665, BgL_locz00_4586), BgL_locz00_4586,
									BgL_wherez00_2666), BGl_errorzd2envzd2zz__errorz00);
							{	/* Eval/evaluate.scm 144 */
								obj_t BgL__ortest_1068z00_3415;

								BgL__ortest_1068z00_3415 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_2665);
								if (CBOOL(BgL__ortest_1068z00_3415))
									{	/* Eval/evaluate.scm 144 */
										BgL_nlocz00_2674 = BgL__ortest_1068z00_3415;
									}
								else
									{	/* Eval/evaluate.scm 144 */
										BgL_nlocz00_2674 = BgL_locz00_4586;
									}
							}
							{	/* Eval/evaluate.scm 417 */
								BgL_ev_absz00_bglt BgL_new1102z00_2675;

								{	/* Eval/evaluate.scm 418 */
									BgL_ev_absz00_bglt BgL_new1100z00_2677;

									BgL_new1100z00_2677 =
										((BgL_ev_absz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_absz00_bgl))));
									{	/* Eval/evaluate.scm 418 */
										long BgL_arg2439z00_2678;

										BgL_arg2439z00_2678 =
											BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1100z00_2677),
											BgL_arg2439z00_2678);
									}
									BgL_new1102z00_2675 = BgL_new1100z00_2677;
								}
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_locz00) = ((obj_t) BgL_locz00_4586), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_wherez00) = ((obj_t) BgL_wherez00_2666), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_arityz00) = ((obj_t) BgL_arityz00_2671), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_varsz00) = ((obj_t) BgL_varsz00_2672), BUNSPEC);
								{
									BgL_ev_exprz00_bglt BgL_auxz00_7380;

									{	/* Eval/evaluate.scm 422 */
										obj_t BgL_arg2438z00_2676;

										BgL_arg2438z00_2676 =
											BGl_appendzd221011zd2zz__evaluatez00(BgL_varsz00_2672,
											BgL_localsz00_4588);
										BgL_auxz00_7380 =
											((BgL_ev_exprz00_bglt)
											BGl_convz00zz__evaluatez00(BgL_bodyz00_2673,
												BgL_arg2438z00_2676, BgL_globalsz00_4589, BTRUE,
												BgL_wherez00_2666, BgL_nlocz00_2674, ((bool_t) 0)));
									}
									((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
											BgL_bodyz00) =
										((BgL_ev_exprz00_bglt) BgL_auxz00_7380), BUNSPEC);
								}
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_siza7eza7) = ((int) (int) (((long) 0))), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_bindz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_freez00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_innerz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1102z00_2675))->
										BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
								return BgL_new1102z00_2675;
							}
						}
					}
				}
			}
		}

	}



/* uconv/loc~0 */
	obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t BgL_wherez00_4596,
		obj_t BgL_globalsz00_4595, obj_t BgL_localsz00_4594, obj_t BgL_ez00_2642,
		obj_t BgL_locz00_2643)
	{
		{	/* Eval/evaluate.scm 377 */
			return
				BGl_convz00zz__evaluatez00(BgL_ez00_2642, BgL_localsz00_4594,
				BgL_globalsz00_4595, BFALSE, BgL_wherez00_4596, BgL_locz00_2643,
				((bool_t) 0));
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00()
	{
		{	/* Eval/evaluate.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 483454155),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 70989603),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 368666432),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 479579181),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 68574988),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					169532048), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					437057797), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -44273703),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 190905450),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988580),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 528345299),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 505897955),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(((long) 483789130),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(((long)
					121298760), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_compz00(((long)
					444000678), BSTRING_TO_STRING(BGl_string2987z00zz__evaluatez00));
		}

	}

#ifdef __cplusplus
}
#endif
