/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate_comp.scm -indent -o objs/obj_u/Eval/evaluate_comp.c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t
		BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long,
		obj_t, obj_t);
	static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33490ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32915ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33636ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32907ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33709ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33547ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31838ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_trap1394zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33580ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32592ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32835ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33718ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32819ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol4603z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4605z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33000ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol4607z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32012ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33905ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31961ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33573ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33646ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32917ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31937ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol4610z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4613z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_symbol4615z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4617z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4619z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33930ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33663ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32926ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
	static obj_t BGl_symbol4621z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4623z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4625z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4627z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4629z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33826ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31963ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_symbol4710z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4631z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4633z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4635z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33011ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32120ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol4718z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4637z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4639z00zz__evaluate_compz00 = BUNSPEC;
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32871ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33916ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33592ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32863ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32847ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	static obj_t BGl_symbol4641z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4643z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4645z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33004ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32032ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol4647z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4729z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4649z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31892ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33496ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_symbol4731z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4651z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4733z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4653z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4735z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4655z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32122ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol4657z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4659z00zz__evaluate_compz00 = BUNSPEC;
	extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33942ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33683ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31982ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33837ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33756ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31869ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
	static obj_t BGl_symbol4661z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4663z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32212ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol4665z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4585z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4667z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4587z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4669z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4589z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33854ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33692ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33765ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31967ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	static obj_t BGl_symbol4671z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4673z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza34003ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_z62zc3z04anonymousza33023ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol4675z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4595z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4677z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol4679z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33960ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32891ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32883ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32875ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32867ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t make_vector(long, obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32400ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32036ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_evmodulezd2namezd2zz__evmodulez00(obj_t);
	static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33864ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_goto1434zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
	static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza33122ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33033ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33017ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32029ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32982ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32240ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32321ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32402ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33204ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32127ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32991ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33777ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33051ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33027ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t
		BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62compzd2ev_global1400zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_reset_profilez00zz__evaluate_compz00();
	static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
	static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33980ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32895ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32887ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32879ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33230ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza34024ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32080ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32242ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33117ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33787ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_synchroniza7e1430z17zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run4500z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4502z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4504z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4506z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62run4508z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33142ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33045ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33037ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32057ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_labels1432zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32994ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33877ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31998ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4510z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4512z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t);
	static obj_t BGl_z62run4514z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4516z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4518z62zz__evaluate_compz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza32406ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_var1396zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4520z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4522z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4524z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_app1436zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run4526z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33152ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4528z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33225ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern bool_t bigloo_string_lt(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32899ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4530z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4532z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4534z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4536z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4538z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32246ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
	static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	static obj_t BGl_z62zc3z04anonymousza32997ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33888ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4540z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
	static obj_t BGl_z62run4542z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	static obj_t BGl_z62run4544z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33421ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33413ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4546z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32360ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_zc3z04exitza33359ze3ze70z60zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33073ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4548z62zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	static obj_t BGl_z62run4550z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4552z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33600ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4554z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33341ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4556z62zz__evaluate_compz00(obj_t, obj_t);
	extern int bgl_debug();
	extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long,
		long);
	static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4558z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33309ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t,
		obj_t, obj_t, long, obj_t);
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run4560z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t create_struct(obj_t, int);
	static obj_t BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run4562z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33350ze3ze5zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62run4564z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33261ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4566z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_get_profilez00zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza32281ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33407ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4568z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main4501z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main4503z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62main4505z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main4507z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
	static obj_t BGl_z62main4509z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern long bgl_list_length(obj_t);
	static obj_t BGl_z62run4570z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62run4572z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4574z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza31812ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run4576z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
	static obj_t BGl_z62run4496z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4578z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4498z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main4511z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main4513z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main4515z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main4517z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main4519z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_abs1438zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run4580z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_withzd2handler1428z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main4521z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main4523z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main4525z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main4527z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main4529z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33361ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33191ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33353ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33515ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32462ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32527ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main4531z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main4533z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4535z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4537z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4539z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
	static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
	static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
	static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32811ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33362ze3ze5zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza33192ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32099ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main4541z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
	static obj_t BGl_z62main4543z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	static obj_t BGl_z62main4545z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4547z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4549z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3z04exitza33342ze3ze70z60zz__evaluate_compz00(obj_t, obj_t,
		obj_t, long, obj_t);
	static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33282ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main4551z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main4553z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main4555z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main4557z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main4559z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	static obj_t BGl_z62comp1389z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33380ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33615ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31914ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	static obj_t BGl_z62main4561z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main4563z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main4565z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main4567z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main4569z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62compzd2ev_setlocal1398zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3z04anonymousza32911ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32903ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33624ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33349ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4571z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main4573z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4575z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4495z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4577z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4497z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4579z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main4499z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_defglobal1406zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33730ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32920ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33803ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32823ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32807ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_setglobal1404zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33537ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33529ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33740ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33813ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t *__cnst;


	extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_zc3lexintzd2envz11zz__evaluate_compz00,
		BgL_bgl_za762za7c3lexintza7a1za74739z00,
		BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
	extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
	extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_compilezd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compileza762za7za7_4740z00,
		BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
	extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
	extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2statezd2envz00zz__evaluate_compz00,
		BgL_bgl_za762findza7d2stateza74741za7,
		BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0);
	extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
	extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string4600z00zz__evaluate_compz00,
		BgL_bgl_string4600za700za7za7_4742za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string4601z00zz__evaluate_compz00,
		BgL_bgl_string4601za700za7za7_4743za7, "expecting ~a, got ~a", 20);
	      DEFINE_STRING(BGl_string4602z00zz__evaluate_compz00,
		BgL_bgl_string4602za700za7za7_4744za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string4604z00zz__evaluate_compz00,
		BgL_bgl_string4604za700za7za7_4745za7, "mcell", 5);
	      DEFINE_STRING(BGl_string4606z00zz__evaluate_compz00,
		BgL_bgl_string4606za700za7za7_4746za7, "internal", 8);
	      DEFINE_STRING(BGl_string4608z00zz__evaluate_compz00,
		BgL_bgl_string4608za700za7za7_4747za7, "impossible", 10);
	      DEFINE_STRING(BGl_string4609z00zz__evaluate_compz00,
		BgL_bgl_string4609za700za7za7_4748za7, "procedure", 9);
	      DEFINE_STRING(BGl_string4611z00zz__evaluate_compz00,
		BgL_bgl_string4611za700za7za7_4749za7, "user", 4);
	      DEFINE_STRING(BGl_string4612z00zz__evaluate_compz00,
		BgL_bgl_string4612za700za7za7_4750za7, "invalid byte code", 17);
	      DEFINE_STRING(BGl_string4614z00zz__evaluate_compz00,
		BgL_bgl_string4614za700za7za7_4751za7, "+", 1);
	      DEFINE_STRING(BGl_string4616z00zz__evaluate_compz00,
		BgL_bgl_string4616za700za7za7_4752za7, "number", 6);
	      DEFINE_STRING(BGl_string4618z00zz__evaluate_compz00,
		BgL_bgl_string4618za700za7za7_4753za7, "-", 1);
	      DEFINE_STRING(BGl_string4620z00zz__evaluate_compz00,
		BgL_bgl_string4620za700za7za7_4754za7, "*", 1);
	      DEFINE_STRING(BGl_string4622z00zz__evaluate_compz00,
		BgL_bgl_string4622za700za7za7_4755za7, "/", 1);
	      DEFINE_STRING(BGl_string4624z00zz__evaluate_compz00,
		BgL_bgl_string4624za700za7za7_4756za7, "<", 1);
	      DEFINE_STRING(BGl_string4626z00zz__evaluate_compz00,
		BgL_bgl_string4626za700za7za7_4757za7, ">", 1);
	      DEFINE_STRING(BGl_string4708z00zz__evaluate_compz00,
		BgL_bgl_string4708za700za7za7_4758za7, "internal error", 14);
	      DEFINE_STRING(BGl_string4709z00zz__evaluate_compz00,
		BgL_bgl_string4709za700za7za7_4759za7, "must be dead code", 17);
	      DEFINE_STRING(BGl_string4628z00zz__evaluate_compz00,
		BgL_bgl_string4628za700za7za7_4760za7, "<=", 2);
	extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4700z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_bin4761z00,
		BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4701z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_unw4762z00,
		BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4702z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_wit4763z00,
		BGl_z62compzd2ev_withzd2handler1428z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4703z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_syn4764z00,
		BGl_z62compzd2ev_synchroniza7e1430z17zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4704z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lab4765z00,
		BGl_z62compzd2ev_labels1432zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string4711z00zz__evaluate_compz00,
		BgL_bgl_string4711za700za7za7_4766za7, "notyet", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4705z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_got4767z00,
		BGl_z62compzd2ev_goto1434zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string4630z00zz__evaluate_compz00,
		BgL_bgl_string4630za700za7za7_4768za7, ">=", 2);
	      DEFINE_STRING(BGl_string4712z00zz__evaluate_compz00,
		BgL_bgl_string4712za700za7za7_4769za7, "synchronize", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4706z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_app4770z00,
		BGl_z62compzd2ev_app1436zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string4713z00zz__evaluate_compz00,
		BgL_bgl_string4713za700za7za7_4771za7, "mutex", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4707z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_abs4772z00,
		BGl_z62compzd2ev_abs1438zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string4632z00zz__evaluate_compz00,
		BgL_bgl_string4632za700za7za7_4773za7, "=", 1);
	      DEFINE_STRING(BGl_string4714z00zz__evaluate_compz00,
		BgL_bgl_string4714za700za7za7_4774za7, "set!", 4);
	      DEFINE_STRING(BGl_string4715z00zz__evaluate_compz00,
		BgL_bgl_string4715za700za7za7_4775za7, "read-only variable", 18);
	      DEFINE_STRING(BGl_string4634z00zz__evaluate_compz00,
		BgL_bgl_string4634za700za7za7_4776za7, "+fx", 3);
	      DEFINE_STRING(BGl_string4716z00zz__evaluate_compz00,
		BgL_bgl_string4716za700za7za7_4777za7,
		"\nRedefinition of compiled variable -- ", 38);
	      DEFINE_STRING(BGl_string4717z00zz__evaluate_compz00,
		BgL_bgl_string4717za700za7za7_4778za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string4636z00zz__evaluate_compz00,
		BgL_bgl_string4636za700za7za7_4779za7, "fixnum", 6);
	      DEFINE_STRING(BGl_string4719z00zz__evaluate_compz00,
		BgL_bgl_string4719za700za7za7_4780za7, "@", 1);
	      DEFINE_STRING(BGl_string4638z00zz__evaluate_compz00,
		BgL_bgl_string4638za700za7za7_4781za7, "-fx", 3);
	      DEFINE_STRING(BGl_string4720z00zz__evaluate_compz00,
		BgL_bgl_string4720za700za7za7_4782za7, "Uninitialized variable", 22);
	      DEFINE_STRING(BGl_string4640z00zz__evaluate_compz00,
		BgL_bgl_string4640za700za7za7_4783za7, "*fx", 3);
	      DEFINE_STRING(BGl_string4642z00zz__evaluate_compz00,
		BgL_bgl_string4642za700za7za7_4784za7, "/fx", 3);
	      DEFINE_STRING(BGl_string4644z00zz__evaluate_compz00,
		BgL_bgl_string4644za700za7za7_4785za7, "<fx", 3);
	      DEFINE_STRING(BGl_string4646z00zz__evaluate_compz00,
		BgL_bgl_string4646za700za7za7_4786za7, ">fx", 3);
	      DEFINE_STRING(BGl_string4648z00zz__evaluate_compz00,
		BgL_bgl_string4648za700za7za7_4787za7, "<=fx", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4721z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo4788za7,
		BGl_z62zc3z04anonymousza32991ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4722z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo4789za7,
		BGl_z62zc3z04anonymousza32994ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4723z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo4790za7,
		BGl_z62zc3z04anonymousza32997ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string4730z00zz__evaluate_compz00,
		BgL_bgl_string4730za700za7za7_4791za7, "get_sp", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4724z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo4792za7,
		BGl_z62zc3z04anonymousza33000ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4725z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo4793za7,
		BGl_z62zc3z04anonymousza33004ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string4650z00zz__evaluate_compz00,
		BgL_bgl_string4650za700za7za7_4794za7, ">=fx", 4);
	      DEFINE_STRING(BGl_string4732z00zz__evaluate_compz00,
		BgL_bgl_string4732za700za7za7_4795za7, "reset_profile", 13);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4726z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo4796za7,
		BGl_z62zc3z04anonymousza33011ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4727z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo4797za7,
		BGl_z62zc3z04anonymousza33017ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string4652z00zz__evaluate_compz00,
		BgL_bgl_string4652za700za7za7_4798za7, "=fx", 3);
	      DEFINE_STRING(BGl_string4734z00zz__evaluate_compz00,
		BgL_bgl_string4734za700za7za7_4799za7, "get_profile", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4728z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo4800za7,
		BGl_z62zc3z04anonymousza33023ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string4654z00zz__evaluate_compz00,
		BgL_bgl_string4654za700za7za7_4801za7, "+fl", 3);
	      DEFINE_STRING(BGl_string4736z00zz__evaluate_compz00,
		BgL_bgl_string4736za700za7za7_4802za7, "reset_stack", 11);
	      DEFINE_STRING(BGl_string4737z00zz__evaluate_compz00,
		BgL_bgl_string4737za700za7za7_4803za7, "internal error: unknown command",
		31);
	      DEFINE_STRING(BGl_string4656z00zz__evaluate_compz00,
		BgL_bgl_string4656za700za7za7_4804za7, "flonum", 6);
	      DEFINE_STRING(BGl_string4738z00zz__evaluate_compz00,
		BgL_bgl_string4738za700za7za7_4805za7, "__evaluate_comp", 15);
	      DEFINE_STRING(BGl_string4658z00zz__evaluate_compz00,
		BgL_bgl_string4658za700za7za7_4806za7, "-fl", 3);
	extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string4660z00zz__evaluate_compz00,
		BgL_bgl_string4660za700za7za7_4807za7, "*fl", 3);
	      DEFINE_STRING(BGl_string4662z00zz__evaluate_compz00,
		BgL_bgl_string4662za700za7za7_4808za7, "/fl", 3);
	      DEFINE_STRING(BGl_string4664z00zz__evaluate_compz00,
		BgL_bgl_string4664za700za7za7_4809za7, "<fl", 3);
	      DEFINE_STRING(BGl_string4666z00zz__evaluate_compz00,
		BgL_bgl_string4666za700za7za7_4810za7, ">fl", 3);
	      DEFINE_STRING(BGl_string4586z00zz__evaluate_compz00,
		BgL_bgl_string4586za700za7za7_4811za7, "all", 3);
	      DEFINE_STRING(BGl_string4668z00zz__evaluate_compz00,
		BgL_bgl_string4668za700za7za7_4812za7, "<=fl", 4);
	extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string4588z00zz__evaluate_compz00,
		BgL_bgl_string4588za700za7za7_4813za7, "label-tag", 9);
	extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string4670z00zz__evaluate_compz00,
		BgL_bgl_string4670za700za7za7_4814za7, ">=fl", 4);
	      DEFINE_STRING(BGl_string4590z00zz__evaluate_compz00,
		BgL_bgl_string4590za700za7za7_4815za7, "bounce", 6);
	      DEFINE_STRING(BGl_string4672z00zz__evaluate_compz00,
		BgL_bgl_string4672za700za7za7_4816za7, "=fl", 3);
	      DEFINE_STRING(BGl_string4591z00zz__evaluate_compz00,
		BgL_bgl_string4591za700za7za7_4817za7, "non non non", 11);
	      DEFINE_STRING(BGl_string4592z00zz__evaluate_compz00,
		BgL_bgl_string4592za700za7za7_4818za7, " in ", 4);
	      DEFINE_STRING(BGl_string4674z00zz__evaluate_compz00,
		BgL_bgl_string4674za700za7za7_4819za7, "car", 3);
	      DEFINE_STRING(BGl_string4593z00zz__evaluate_compz00,
		BgL_bgl_string4593za700za7za7_4820za7, "eval", 4);
	      DEFINE_STRING(BGl_string4594z00zz__evaluate_compz00,
		BgL_bgl_string4594za700za7za7_4821za7, "internal error: not found", 25);
	extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string4676z00zz__evaluate_compz00,
		BgL_bgl_string4676za700za7za7_4822za7, "pair", 4);
	      DEFINE_STRING(BGl_string4596z00zz__evaluate_compz00,
		BgL_bgl_string4596za700za7za7_4823za7, "at", 2);
	      DEFINE_STRING(BGl_string4678z00zz__evaluate_compz00,
		BgL_bgl_string4678za700za7za7_4824za7, "cdr", 3);
	      DEFINE_STRING(BGl_string4597z00zz__evaluate_compz00,
		BgL_bgl_string4597za700za7za7_4825za7, "", 0);
	      DEFINE_STRING(BGl_string4598z00zz__evaluate_compz00,
		BgL_bgl_string4598za700za7za7_4826za7,
		"/tmp/bigloo/runtime/Eval/evaluate_comp.scm", 42);
	      DEFINE_STRING(BGl_string4599z00zz__evaluate_compz00,
		BgL_bgl_string4599za700za7za7_4827za7, "&compile", 8);
	extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string4680z00zz__evaluate_compz00,
		BgL_bgl_string4680za700za7za7_4828za7, "cadr", 4);
	      DEFINE_STRING(BGl_string4682z00zz__evaluate_compz00,
		BgL_bgl_string4682za700za7za7_4829za7, "comp1389", 8);
	      DEFINE_STRING(BGl_string4683z00zz__evaluate_compz00,
		BgL_bgl_string4683za700za7za7_4830za7, "internal error: not defined for",
		31);
	      DEFINE_STRING(BGl_string4684z00zz__evaluate_compz00,
		BgL_bgl_string4684za700za7za7_4831za7, "&comp", 5);
	      DEFINE_STRING(BGl_string4686z00zz__evaluate_compz00,
		BgL_bgl_string4686za700za7za7_4832za7, "comp", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4681z00zz__evaluate_compz00,
		BgL_bgl_za762comp1389za762za7za74833z00,
		BGl_z62comp1389z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4685z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_tra4834z00,
		BGl_z62compzd2ev_trap1394zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4687z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_var4835z00,
		BGl_z62compzd2ev_var1396zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4688z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set4836z00,
		BGl_z62compzd2ev_setlocal1398zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4689z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_glo4837z00,
		BGl_z62compzd2ev_global1400zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_compzd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compza762za7za7__ev4838z00, BGl_z62compz62zz__evaluate_compz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4690z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set4839z00,
		BGl_z62compzd2ev_setglobal1404zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4691z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_def4840z00,
		BGl_z62compzd2ev_defglobal1406zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4692z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lit4841z00,
		BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4693z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_if14842z00,
		BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4694z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_or14843z00,
		BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4695z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_and4844z00,
		BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4696z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_pro4845z00,
		BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4697z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let4846z00,
		BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4698z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let4847z00,
		BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4699z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let4848z00,
		BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
	extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4603z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4605z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4607z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4610z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4613z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4615z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4617z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4619z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4621z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4623z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4625z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4627z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4629z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4710z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4631z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4633z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4635z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4718z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4637z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4639z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4641z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4643z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4645z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4647z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4729z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4649z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4731z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4651z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4733z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4653z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4735z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4655z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4657z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4659z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4661z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4663z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4665z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4585z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4667z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4587z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4669z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4589z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4671z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4673z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4675z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4595z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4677z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol4679z00zz__evaluate_compz00));
		   
			 ADD_ROOT((void *) (&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long
		BgL_checksumz00_16987, char *BgL_fromz00_16988)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_compz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluate_compz00();
					BGl_cnstzd2initzd2zz__evaluate_compz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
					BGl_genericzd2initzd2zz__evaluate_compz00();
					BGl_methodzd2initzd2zz__evaluate_compz00();
					return BGl_toplevelzd2initzd2zz__evaluate_compz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_symbol4585z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4586z00zz__evaluate_compz00);
			BGl_symbol4587z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4588z00zz__evaluate_compz00);
			BGl_symbol4589z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4590z00zz__evaluate_compz00);
			BGl_symbol4595z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4596z00zz__evaluate_compz00);
			BGl_symbol4603z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4604z00zz__evaluate_compz00);
			BGl_symbol4605z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4606z00zz__evaluate_compz00);
			BGl_symbol4607z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4608z00zz__evaluate_compz00);
			BGl_symbol4610z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4611z00zz__evaluate_compz00);
			BGl_symbol4613z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4614z00zz__evaluate_compz00);
			BGl_symbol4615z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4616z00zz__evaluate_compz00);
			BGl_symbol4617z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4618z00zz__evaluate_compz00);
			BGl_symbol4619z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4620z00zz__evaluate_compz00);
			BGl_symbol4621z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4622z00zz__evaluate_compz00);
			BGl_symbol4623z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4624z00zz__evaluate_compz00);
			BGl_symbol4625z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4626z00zz__evaluate_compz00);
			BGl_symbol4627z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4628z00zz__evaluate_compz00);
			BGl_symbol4629z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4630z00zz__evaluate_compz00);
			BGl_symbol4631z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4632z00zz__evaluate_compz00);
			BGl_symbol4633z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4634z00zz__evaluate_compz00);
			BGl_symbol4635z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4636z00zz__evaluate_compz00);
			BGl_symbol4637z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4638z00zz__evaluate_compz00);
			BGl_symbol4639z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4640z00zz__evaluate_compz00);
			BGl_symbol4641z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4642z00zz__evaluate_compz00);
			BGl_symbol4643z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4644z00zz__evaluate_compz00);
			BGl_symbol4645z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4646z00zz__evaluate_compz00);
			BGl_symbol4647z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4648z00zz__evaluate_compz00);
			BGl_symbol4649z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4650z00zz__evaluate_compz00);
			BGl_symbol4651z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4652z00zz__evaluate_compz00);
			BGl_symbol4653z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4654z00zz__evaluate_compz00);
			BGl_symbol4655z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4656z00zz__evaluate_compz00);
			BGl_symbol4657z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4658z00zz__evaluate_compz00);
			BGl_symbol4659z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4660z00zz__evaluate_compz00);
			BGl_symbol4661z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4662z00zz__evaluate_compz00);
			BGl_symbol4663z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4664z00zz__evaluate_compz00);
			BGl_symbol4665z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4666z00zz__evaluate_compz00);
			BGl_symbol4667z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4668z00zz__evaluate_compz00);
			BGl_symbol4669z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4670z00zz__evaluate_compz00);
			BGl_symbol4671z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4672z00zz__evaluate_compz00);
			BGl_symbol4673z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4674z00zz__evaluate_compz00);
			BGl_symbol4675z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4676z00zz__evaluate_compz00);
			BGl_symbol4677z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4678z00zz__evaluate_compz00);
			BGl_symbol4679z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4680z00zz__evaluate_compz00);
			BGl_symbol4710z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4711z00zz__evaluate_compz00);
			BGl_symbol4718z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4719z00zz__evaluate_compz00);
			BGl_symbol4729z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4730z00zz__evaluate_compz00);
			BGl_symbol4731z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4732z00zz__evaluate_compz00);
			BGl_symbol4733z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4734z00zz__evaluate_compz00);
			return (BGl_symbol4735z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string4736z00zz__evaluate_compz00), BUNSPEC);
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			{	/* Eval/evaluate_comp.scm 114 */
				BGL_LONGLONG_T BgL_arg1505z00_1354;

				BgL_arg1505z00_1354 = LONG_TO_LLONG(((long) 0));
				{	/* Eval/evaluate_comp.scm 114 */
					obj_t BgL_list1506z00_1355;

					{	/* Eval/evaluate_comp.scm 114 */
						obj_t BgL_arg1507z00_1356;

						BgL_arg1507z00_1356 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1505z00_1354), BNIL);
						BgL_list1506z00_1355 =
							MAKE_YOUNG_PAIR(BGl_symbol4585z00zz__evaluate_compz00,
							BgL_arg1507z00_1356);
					}
					BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1506z00_1355;
			}}
			BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long) 8192);
			BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol4587z00zz__evaluate_compz00,
				(int) (((long) 0)));
			BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol4589z00zz__evaluate_compz00,
				(int) (((long) 0)));
			return BUNSPEC;
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_1357;

				BgL_headz00_1357 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_6446;
					obj_t BgL_tailz00_6447;

					BgL_prevz00_6446 = BgL_headz00_1357;
					BgL_tailz00_6447 = BgL_l1z00_1;
				BgL_loopz00_6445:
					if (PAIRP(BgL_tailz00_6447))
						{
							obj_t BgL_newzd2prevzd2_6453;

							BgL_newzd2prevzd2_6453 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_6447), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_6446, BgL_newzd2prevzd2_6453);
							{
								obj_t BgL_tailz00_17062;
								obj_t BgL_prevz00_17061;

								BgL_prevz00_17061 = BgL_newzd2prevzd2_6453;
								BgL_tailz00_17062 = CDR(BgL_tailz00_6447);
								BgL_tailz00_6447 = BgL_tailz00_17062;
								BgL_prevz00_6446 = BgL_prevz00_17061;
								goto BgL_loopz00_6445;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1357);
			}
		}

	}



/* reset_profile */
	obj_t BGl_reset_profilez00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 132 */
			{	/* Eval/evaluate_comp.scm 133 */
				BGL_LONGLONG_T BgL_arg1531z00_1385;

				BgL_arg1531z00_1385 = LONG_TO_LLONG(((long) 0));
				{	/* Eval/evaluate_comp.scm 133 */
					obj_t BgL_list1532z00_1386;

					{	/* Eval/evaluate_comp.scm 133 */
						obj_t BgL_arg1533z00_1387;

						BgL_arg1533z00_1387 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1531z00_1385), BNIL);
						BgL_list1532z00_1386 =
							MAKE_YOUNG_PAIR(BGl_symbol4585z00zz__evaluate_compz00,
							BgL_arg1533z00_1387);
					}
					return (BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1532z00_1386, BUNSPEC);
				}
			}
		}

	}



/* o->s~0 */
	obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1396)
	{
		{	/* Eval/evaluate_comp.scm 141 */
			if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1396))
				{	/* Ieee/fixnum.scm 983 */

					return
						BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
						(long) CINT(BgL_vz00_1396), ((long) 10));
				}
			else
				{	/* Eval/evaluate_comp.scm 138 */
					if (SYMBOLP(BgL_vz00_1396))
						{	/* Eval/evaluate_comp.scm 139 */
							obj_t BgL_arg4199z00_6462;

							BgL_arg4199z00_6462 = SYMBOL_TO_STRING(BgL_vz00_1396);
							return
								BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg4199z00_6462);
						}
					else
						{	/* Eval/evaluate_comp.scm 139 */
							if (STRINGP(BgL_vz00_1396))
								{	/* Eval/evaluate_comp.scm 140 */
									return BgL_vz00_1396;
								}
							else
								{	/* Eval/evaluate_comp.scm 140 */
									return BGl_string4591z00zz__evaluate_compz00;
								}
						}
				}
		}

	}



/* &<lexint */
	obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_12184,
		obj_t BgL_t1z00_12185, obj_t BgL_t2z00_12186)
	{
		{	/* Eval/evaluate_comp.scm 135 */
			{	/* Eval/evaluate_comp.scm 138 */
				bool_t BgL_tmpz00_17079;

				{	/* Eval/evaluate_comp.scm 142 */
					obj_t BgL_v1z00_14175;
					obj_t BgL_v2z00_14176;

					BgL_v1z00_14175 = CAR(((obj_t) BgL_t1z00_12185));
					BgL_v2z00_14176 = CAR(((obj_t) BgL_t2z00_12186));
					{	/* Eval/evaluate_comp.scm 143 */
						bool_t BgL_test4854z00_17084;

						if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_14175))
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_test4854z00_17084 =
									BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BgL_v2z00_14176);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_test4854z00_17084 = ((bool_t) 0);
							}
						if (BgL_test4854z00_17084)
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_17079 =
									BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_14175,
									BgL_v2z00_14176);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_17079 =
									bigloo_string_lt(BGl_ozd2ze3sze70zd6zz__evaluate_compz00
									(BgL_v1z00_14175),
									BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_14176));
							}
					}
				}
				return BBOOL(BgL_tmpz00_17079);
			}
		}

	}



/* get_profile */
	obj_t BGl_get_profilez00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 147 */
			BGl_recze71ze7zz__evaluate_compz00
				(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00);
			return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;
		}

	}



/* rec~1 */
	bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1405)
	{
		{	/* Eval/evaluate_comp.scm 148 */
			{	/* Eval/evaluate_comp.scm 149 */
				obj_t BgL_arg1544z00_1407;
				obj_t BgL_arg1545z00_1408;

				BgL_arg1544z00_1407 = CDR(((obj_t) BgL_tz00_1405));
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_arg1546z00_1409;

					{	/* Eval/evaluate_comp.scm 149 */
						obj_t BgL_pairz00_6471;

						BgL_pairz00_6471 = CDR(((obj_t) BgL_tz00_1405));
						BgL_arg1546z00_1409 = CDR(BgL_pairz00_6471);
					}
					BgL_arg1545z00_1408 =
						BGl_sortz00zz__r4_vectors_6_8z00
						(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1546z00_1409);
				}
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_tmpz00_17100;

					BgL_tmpz00_17100 = ((obj_t) BgL_arg1544z00_1407);
					SET_CDR(BgL_tmpz00_17100, BgL_arg1545z00_1408);
				}
			}
			{	/* Eval/evaluate_comp.scm 150 */
				obj_t BgL_g1291z00_1410;

				{	/* Eval/evaluate_comp.scm 150 */
					obj_t BgL_pairz00_6476;

					BgL_pairz00_6476 = CDR(((obj_t) BgL_tz00_1405));
					BgL_g1291z00_1410 = CDR(BgL_pairz00_6476);
				}
				{
					obj_t BgL_l1289z00_6488;

					BgL_l1289z00_6488 = BgL_g1291z00_1410;
				BgL_zc3z04anonymousza31547ze3z87_6487:
					if (PAIRP(BgL_l1289z00_6488))
						{	/* Eval/evaluate_comp.scm 150 */
							BGl_recze71ze7zz__evaluate_compz00(CAR(BgL_l1289z00_6488));
							{
								obj_t BgL_l1289z00_17110;

								BgL_l1289z00_17110 = CDR(BgL_l1289z00_6488);
								BgL_l1289z00_6488 = BgL_l1289z00_17110;
								goto BgL_zc3z04anonymousza31547ze3z87_6487;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 150 */
							return ((bool_t) 1);
						}
				}
			}
		}

	}



/* index */
	obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
	{
		{	/* Eval/evaluate_comp.scm 156 */
			{
				obj_t BgL_lz00_6514;
				long BgL_nz00_6515;

				BgL_lz00_6514 = BgL_lz00_7;
				BgL_nz00_6515 = ((long) 0);
			BgL_walkz00_6513:
				if (NULLP(BgL_lz00_6514))
					{	/* Eval/evaluate_comp.scm 158 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate_comp.scm 158 */
						if ((BgL_xz00_6 == CAR(((obj_t) BgL_lz00_6514))))
							{	/* Eval/evaluate_comp.scm 159 */
								return BINT(BgL_nz00_6515);
							}
						else
							{
								long BgL_nz00_17122;
								obj_t BgL_lz00_17119;

								BgL_lz00_17119 = CDR(((obj_t) BgL_lz00_6514));
								BgL_nz00_17122 = (BgL_nz00_6515 + ((long) 1));
								BgL_nz00_6515 = BgL_nz00_17122;
								BgL_lz00_6514 = BgL_lz00_17119;
								goto BgL_walkz00_6513;
							}
					}
			}
		}

	}



/* _index */
	obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
	{
		{	/* Eval/evaluate_comp.scm 163 */
			{	/* Eval/evaluate_comp.scm 164 */
				obj_t BgL__ortest_1079z00_1430;

				BgL__ortest_1079z00_1430 =
					BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9);
				if (CBOOL(BgL__ortest_1079z00_1430))
					{	/* Eval/evaluate_comp.scm 164 */
						return BgL__ortest_1079z00_1430;
					}
				else
					{	/* Eval/evaluate_comp.scm 164 */
						obj_t BgL_arg1560z00_1431;

						{	/* Eval/evaluate_comp.scm 164 */
							obj_t BgL_arg1561z00_1432;

							if (NULLP(BgL_lz00_9))
								{	/* Eval/evaluate_comp.scm 164 */
									BgL_arg1561z00_1432 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_head1294z00_1438;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1571z00_1450;

										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_arg1573z00_1451;

											BgL_arg1573z00_1451 = CAR(((obj_t) BgL_lz00_9));
											if (BGl_isazf3zf3zz__objectz00(BgL_arg1573z00_1451,
													BGl_ev_varz00zz__evaluate_typesz00))
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1571z00_1450 =
														(((BgL_ev_varz00_bglt) COBJECT(
																((BgL_ev_varz00_bglt) BgL_arg1573z00_1451)))->
														BgL_namez00);
												}
											else
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1571z00_1450 = BgL_arg1573z00_1451;
												}
										}
										BgL_head1294z00_1438 =
											MAKE_YOUNG_PAIR(BgL_arg1571z00_1450, BNIL);
									}
									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_g1297z00_1439;

										BgL_g1297z00_1439 = CDR(((obj_t) BgL_lz00_9));
										{
											obj_t BgL_l1292z00_6552;
											obj_t BgL_tail1295z00_6553;

											BgL_l1292z00_6552 = BgL_g1297z00_1439;
											BgL_tail1295z00_6553 = BgL_head1294z00_1438;
										BgL_zc3z04anonymousza31566ze3z87_6551:
											if (NULLP(BgL_l1292z00_6552))
												{	/* Eval/evaluate_comp.scm 164 */
													BgL_arg1561z00_1432 = BgL_head1294z00_1438;
												}
											else
												{	/* Eval/evaluate_comp.scm 164 */
													obj_t BgL_newtail1296z00_6560;

													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1569z00_6561;

														BgL_arg1569z00_6561 =
															BGl_lnamez00zz__evaluate_compz00(CAR(
																((obj_t) BgL_l1292z00_6552)));
														BgL_newtail1296z00_6560 =
															MAKE_YOUNG_PAIR(BgL_arg1569z00_6561, BNIL);
													}
													SET_CDR(BgL_tail1295z00_6553,
														BgL_newtail1296z00_6560);
													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1568z00_6563;

														BgL_arg1568z00_6563 =
															CDR(((obj_t) BgL_l1292z00_6552));
														{
															obj_t BgL_tail1295z00_17148;
															obj_t BgL_l1292z00_17147;

															BgL_l1292z00_17147 = BgL_arg1568z00_6563;
															BgL_tail1295z00_17148 = BgL_newtail1296z00_6560;
															BgL_tail1295z00_6553 = BgL_tail1295z00_17148;
															BgL_l1292z00_6552 = BgL_l1292z00_17147;
															goto BgL_zc3z04anonymousza31566ze3z87_6551;
														}
													}
												}
										}
									}
								}
							{	/* Eval/evaluate_comp.scm 164 */
								obj_t BgL_list1562z00_1433;

								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_arg1563z00_1434;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1564z00_1435;

										BgL_arg1564z00_1435 =
											MAKE_YOUNG_PAIR(BgL_arg1561z00_1432, BNIL);
										BgL_arg1563z00_1434 =
											MAKE_YOUNG_PAIR(BGl_string4592z00zz__evaluate_compz00,
											BgL_arg1564z00_1435);
									}
									BgL_list1562z00_1433 =
										MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1563z00_1434);
								}
								BgL_arg1560z00_1431 = BgL_list1562z00_1433;
							}
						}
						return
							BGl_errorz00zz__errorz00(BGl_string4593z00zz__evaluate_compz00,
							BGl_string4594z00zz__evaluate_compz00, BgL_arg1560z00_1431);
					}
			}
		}

	}



/* lname */
	obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
	{
		{	/* Eval/evaluate_comp.scm 188 */
			if (BGl_isazf3zf3zz__objectz00(BgL_vz00_16,
					BGl_ev_varz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 189 */
					return
						(((BgL_ev_varz00_bglt) COBJECT(
								((BgL_ev_varz00_bglt) BgL_vz00_16)))->BgL_namez00);
				}
			else
				{	/* Eval/evaluate_comp.scm 189 */
					return BgL_vz00_16;
				}
		}

	}



/* loc-type-error */
	obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17,
		obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
	{
		{	/* Eval/evaluate_comp.scm 193 */
			if (PAIRP(BgL_locz00_20))
				{	/* Eval/evaluate_comp.scm 194 */
					obj_t BgL_cdrzd2194zd2_1477;

					BgL_cdrzd2194zd2_1477 = CDR(BgL_locz00_20);
					if ((CAR(BgL_locz00_20) == BGl_symbol4595z00zz__evaluate_compz00))
						{	/* Eval/evaluate_comp.scm 194 */
							if (PAIRP(BgL_cdrzd2194zd2_1477))
								{	/* Eval/evaluate_comp.scm 194 */
									obj_t BgL_cdrzd2198zd2_1481;

									BgL_cdrzd2198zd2_1481 = CDR(BgL_cdrzd2194zd2_1477);
									if (PAIRP(BgL_cdrzd2198zd2_1481))
										{	/* Eval/evaluate_comp.scm 194 */
											if (NULLP(CDR(BgL_cdrzd2198zd2_1481)))
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19,
														CAR(BgL_cdrzd2194zd2_1477),
														CAR(BgL_cdrzd2198zd2_1481));
												}
											else
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorz00zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 194 */
											return
												BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
												BgL_mz00_18, BgL_vz00_19);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 194 */
									return
										BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
										BgL_mz00_18, BgL_vz00_19);
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 194 */
							return
								BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
								BgL_mz00_18, BgL_vz00_19);
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 194 */
					return
						BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18,
						BgL_vz00_19);
				}
		}

	}



/* make-state */
	obj_t BGl_makezd2statezd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 206 */
			{	/* Eval/evaluate_comp.scm 207 */
				obj_t BgL_stkz00_1499;

				BgL_stkz00_1499 =
					make_vector(((long) 8192), BGl_string4597z00zz__evaluate_compz00);
				VECTOR_SET(BgL_stkz00_1499, ((long) 0), BINT(((long) 2)));
				return BgL_stkz00_1499;
			}
		}

	}



/* find-state */
	BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 211 */
			{	/* Eval/evaluate_comp.scm 212 */
				obj_t BgL_sz00_1500;

				{	/* Eval/evaluate_comp.scm 212 */
					obj_t BgL_tmpz00_17182;

					BgL_tmpz00_17182 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_1500 = BGL_ENV_EVSTATE(BgL_tmpz00_17182);
				}
				if (VECTORP(BgL_sz00_1500))
					{	/* Eval/evaluate_comp.scm 213 */
						return BgL_sz00_1500;
					}
				else
					{	/* Eval/evaluate_comp.scm 214 */
						obj_t BgL_statez00_1502;

						BgL_statez00_1502 = BGl_makezd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 215 */
							obj_t BgL_tmpz00_17188;

							BgL_tmpz00_17188 = BGL_CURRENT_DYNAMIC_ENV();
							BGL_ENV_EVSTATE_SET(BgL_tmpz00_17188, BgL_statez00_1502);
						}
						return BgL_statez00_1502;
					}
			}
		}

	}



/* &find-state */
	obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_12187)
	{
		{	/* Eval/evaluate_comp.scm 211 */
			return BGl_findzd2statezd2zz__evaluate_compz00();
		}

	}



/* compile */
	BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_34)
	{
		{	/* Eval/evaluate_comp.scm 273 */
			return BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);
		}

	}



/* &compile */
	obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_12188,
		obj_t BgL_ez00_12189)
	{
		{	/* Eval/evaluate_comp.scm 273 */
			{	/* Eval/evaluate_comp.scm 274 */
				BgL_ev_exprz00_bglt BgL_auxz00_17193;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_12189,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 274 */
						BgL_auxz00_17193 = ((BgL_ev_exprz00_bglt) BgL_ez00_12189);
					}
				else
					{
						obj_t BgL_auxz00_17197;

						BgL_auxz00_17197 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string4598z00zz__evaluate_compz00, BINT(((long) 7006)),
							BGl_string4599z00zz__evaluate_compz00,
							BGl_string4600z00zz__evaluate_compz00, BgL_ez00_12189);
						FAILURE(BgL_auxz00_17197, BFALSE, BFALSE);
					}
				return BGl_compilez00zz__evaluate_compz00(BgL_auxz00_17193);
			}
		}

	}



/* global-fun-value */
	obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_43)
	{
		{	/* Eval/evaluate_comp.scm 332 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 335 */
					obj_t BgL_gz00_1558;

					{	/* Eval/evaluate_comp.scm 335 */
						obj_t BgL_arg1658z00_1559;
						obj_t BgL_arg1659z00_1560;

						BgL_arg1658z00_1559 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_modz00);
						BgL_arg1659z00_1560 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_namez00);
						BgL_gz00_1558 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg1658z00_1559, BgL_arg1659z00_1560);
					}
					if (CBOOL(BgL_gz00_1558))
						{	/* Eval/evaluate_comp.scm 336 */
							return VECTOR_REF(((obj_t) BgL_gz00_1558), ((long) 2));
						}
					else
						{	/* Eval/evaluate_comp.scm 336 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 333 */
					return BFALSE;
				}
		}

	}



/* push-boxes-args-on-sp */
	obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t
		BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85,
		obj_t BgL_locz00_86)
	{
		{	/* Eval/evaluate_comp.scm 623 */
			{
				obj_t BgL_lz00_1580;
				obj_t BgL_bsz00_1581;
				long BgL_spz00_1582;

				BgL_lz00_1580 = BgL_argsz00_83;
				BgL_bsz00_1581 = BgL_boxesz00_84;
				BgL_spz00_1582 = BgL_spz00_85;
			BgL_zc3z04anonymousza31676ze3z87_1583:
				if (NULLP(BgL_lz00_1580))
					{	/* Eval/evaluate_comp.scm 625 */
						if (NULLP(BgL_bsz00_1581))
							{	/* Eval/evaluate_comp.scm 626 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 629 */
								obj_t BgL_arg1679z00_1586;

								{	/* Eval/evaluate_comp.scm 629 */
									long BgL_arg1682z00_1587;
									long BgL_arg1685z00_1588;

									BgL_arg1682z00_1587 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1685z00_1588 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 628 */
										obj_t BgL_list1686z00_1589;

										{	/* Eval/evaluate_comp.scm 628 */
											obj_t BgL_arg1690z00_1590;

											BgL_arg1690z00_1590 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1685z00_1588), BNIL);
											BgL_list1686z00_1589 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1682z00_1587),
												BgL_arg1690z00_1590);
										}
										BgL_arg1679z00_1586 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string4601z00zz__evaluate_compz00,
											BgL_list1686z00_1589);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4602z00zz__evaluate_compz00, BgL_arg1679z00_1586);
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 625 */
						if (NULLP(BgL_bsz00_1581))
							{	/* Eval/evaluate_comp.scm 633 */
								obj_t BgL_arg1695z00_1592;

								{	/* Eval/evaluate_comp.scm 633 */
									long BgL_arg1696z00_1593;
									long BgL_arg1697z00_1594;

									BgL_arg1696z00_1593 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1697z00_1594 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 632 */
										obj_t BgL_list1698z00_1595;

										{	/* Eval/evaluate_comp.scm 632 */
											obj_t BgL_arg1699z00_1596;

											BgL_arg1699z00_1596 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1697z00_1594), BNIL);
											BgL_list1698z00_1595 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1696z00_1593),
												BgL_arg1699z00_1596);
										}
										BgL_arg1695z00_1592 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string4601z00zz__evaluate_compz00,
											BgL_list1698z00_1595);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4602z00zz__evaluate_compz00, BgL_arg1695z00_1592);
							}
						else
							{	/* Eval/evaluate_comp.scm 630 */
								{	/* Eval/evaluate_comp.scm 636 */
									obj_t BgL_arg1702z00_1597;

									{	/* Eval/evaluate_comp.scm 636 */
										obj_t BgL_vz00_1598;

										{	/* Eval/evaluate_comp.scm 636 */
											obj_t BgL_fun1704z00_1600;

											BgL_fun1704z00_1600 = CAR(((obj_t) BgL_lz00_1580));
											BgL_vz00_1598 =
												PROCEDURE_ENTRY(BgL_fun1704z00_1600)
												(BgL_fun1704z00_1600, BgL_sz00_82, BEOA);
										}
										if (CBOOL(CAR(((obj_t) BgL_bsz00_1581))))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_6601;

												BgL_newz00_6601 =
													create_struct(BGl_symbol4603z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_17248;

													BgL_tmpz00_17248 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_6601, BgL_tmpz00_17248,
														BgL_vz00_1598);
												}
												BgL_arg1702z00_1597 = BgL_newz00_6601;
											}
										else
											{	/* Eval/evaluate_comp.scm 637 */
												BgL_arg1702z00_1597 = BgL_vz00_1598;
											}
									}
									VECTOR_SET(
										((obj_t) BgL_sz00_82), BgL_spz00_1582, BgL_arg1702z00_1597);
								}
								{	/* Eval/evaluate_comp.scm 640 */
									obj_t BgL_arg1705z00_1601;
									obj_t BgL_arg1707z00_1602;
									long BgL_arg1708z00_1603;

									BgL_arg1705z00_1601 = CDR(((obj_t) BgL_lz00_1580));
									BgL_arg1707z00_1602 = CDR(((obj_t) BgL_bsz00_1581));
									BgL_arg1708z00_1603 = (BgL_spz00_1582 + ((long) 1));
									{
										long BgL_spz00_17260;
										obj_t BgL_bsz00_17259;
										obj_t BgL_lz00_17258;

										BgL_lz00_17258 = BgL_arg1705z00_1601;
										BgL_bsz00_17259 = BgL_arg1707z00_1602;
										BgL_spz00_17260 = BgL_arg1708z00_1603;
										BgL_spz00_1582 = BgL_spz00_17260;
										BgL_bsz00_1581 = BgL_bsz00_17259;
										BgL_lz00_1580 = BgL_lz00_17258;
										goto BgL_zc3z04anonymousza31676ze3z87_1583;
									}
								}
							}
					}
			}
		}

	}



/* sub-stk */
	obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88,
		obj_t BgL_l2z00_89)
	{
		{	/* Eval/evaluate_comp.scm 645 */
		BGl_subzd2stkzd2zz__evaluate_compz00:
			if (NULLP(BgL_l1z00_88))
				{	/* Eval/evaluate_comp.scm 646 */
					return BgL_l2z00_89;
				}
			else
				{	/* Eval/evaluate_comp.scm 646 */
					if ((CAR(((obj_t) BgL_l1z00_88)) == CAR(((obj_t) BgL_l2z00_89))))
						{	/* Eval/evaluate_comp.scm 649 */
							obj_t BgL_arg1713z00_1609;
							obj_t BgL_arg1714z00_1610;

							BgL_arg1713z00_1609 = CDR(((obj_t) BgL_l1z00_88));
							BgL_arg1714z00_1610 = CDR(((obj_t) BgL_l2z00_89));
							{
								obj_t BgL_l2z00_17274;
								obj_t BgL_l1z00_17273;

								BgL_l1z00_17273 = BgL_arg1713z00_1609;
								BgL_l2z00_17274 = BgL_arg1714z00_1610;
								BgL_l2z00_89 = BgL_l2z00_17274;
								BgL_l1z00_88 = BgL_l1z00_17273;
								goto BGl_subzd2stkzd2zz__evaluate_compz00;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 647 */
							return
								BGl_errorz00zz__errorz00(BGl_string4593z00zz__evaluate_compz00,
								BGl_symbol4605z00zz__evaluate_compz00,
								BGl_symbol4607z00zz__evaluate_compz00);
						}
				}
		}

	}



/* catch-trampoline */
	obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93,
		obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
	{
		{	/* Eval/evaluate_comp.scm 669 */
			{	/* Eval/evaluate_comp.scm 670 */
				obj_t BgL_savedzd2bpzd2_1621;

				BgL_savedzd2bpzd2_1621 = VECTOR_REF(((obj_t) BgL_sz00_94), ((long) 0));
				VECTOR_SET(((obj_t) BgL_sz00_94), ((long) 0), BgL_bpz00_95);
				{
					obj_t BgL_fz00_1623;

					BgL_fz00_1623 = BgL_fz00_93;
				BgL_zc3z04anonymousza31725ze3z87_1624:
					{	/* Eval/evaluate_comp.scm 673 */
						obj_t BgL_rz00_1625;

						BgL_rz00_1625 =
							PROCEDURE_ENTRY(BgL_fz00_1623) (BgL_fz00_1623, BgL_sz00_94, BEOA);
						{	/* Eval/evaluate_comp.scm 674 */
							bool_t BgL_test4879z00_17284;

							if (PROCEDUREP(BgL_rz00_1625))
								{	/* Eval/evaluate_comp.scm 674 */
									obj_t BgL_arg1729z00_1630;

									BgL_arg1729z00_1630 = PROCEDURE_ATTR(BgL_rz00_1625);
									if (STRUCTP(BgL_arg1729z00_1630))
										{	/* Eval/evaluate_comp.scm 654 */
											BgL_test4879z00_17284 =
												(STRUCT_KEY(BgL_arg1729z00_1630) ==
												BGl_symbol4589z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 654 */
											BgL_test4879z00_17284 = ((bool_t) 0);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 674 */
									BgL_test4879z00_17284 = ((bool_t) 0);
								}
							if (BgL_test4879z00_17284)
								{
									obj_t BgL_fz00_17292;

									BgL_fz00_17292 = BgL_rz00_1625;
									BgL_fz00_1623 = BgL_fz00_17292;
									goto BgL_zc3z04anonymousza31725ze3z87_1624;
								}
							else
								{	/* Eval/evaluate_comp.scm 674 */
									VECTOR_SET(
										((obj_t) BgL_sz00_94), ((long) 0), BgL_savedzd2bpzd2_1621);
									return BgL_rz00_1625;
								}
						}
					}
				}
			}
		}

	}



/* comp-with-push */
	obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117,
		obj_t BgL_stkz00_118)
	{
		{	/* Eval/evaluate_comp.scm 688 */
			if (NULLP(BgL_eza2za2_117))
				{	/* Eval/evaluate_comp.scm 690 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 692 */
					obj_t BgL_arg1747z00_1648;
					obj_t BgL_arg1748z00_1649;

					{	/* Eval/evaluate_comp.scm 692 */
						obj_t BgL_arg1749z00_1650;

						BgL_arg1749z00_1650 = CAR(((obj_t) BgL_eza2za2_117));
						BgL_arg1747z00_1648 =
							BGl_compz00zz__evaluate_compz00(
							((BgL_ev_exprz00_bglt) BgL_arg1749z00_1650), BgL_stkz00_118);
					}
					{	/* Eval/evaluate_comp.scm 693 */
						obj_t BgL_arg1751z00_1651;
						obj_t BgL_arg1752z00_1652;

						BgL_arg1751z00_1651 = CDR(((obj_t) BgL_eza2za2_117));
						{	/* Eval/evaluate_comp.scm 693 */
							obj_t BgL_arg1753z00_1653;

							BgL_arg1753z00_1653 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							BgL_arg1752z00_1652 =
								BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_118,
								BgL_arg1753z00_1653);
						}
						BgL_arg1748z00_1649 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1751z00_1651,
							BgL_arg1752z00_1652);
					}
					return MAKE_YOUNG_PAIR(BgL_arg1747z00_1648, BgL_arg1748z00_1649);
				}
		}

	}



/* rec~0 */
	obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_14160,
		obj_t BgL_lz00_1655, long BgL_iz00_1656)
	{
		{	/* Eval/evaluate_comp.scm 696 */
			if (NULLP(BgL_lz00_1655))
				{	/* Eval/evaluate_comp.scm 697 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 697 */
					if ((BgL_iz00_1656 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 698 */
							return
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1655,
								BgL_stkz00_14160);
						}
					else
						{	/* Eval/evaluate_comp.scm 699 */
							obj_t BgL_arg1757z00_1660;
							obj_t BgL_arg1758z00_1661;

							{	/* Eval/evaluate_comp.scm 699 */
								obj_t BgL_arg1759z00_1662;

								BgL_arg1759z00_1662 = CAR(((obj_t) BgL_lz00_1655));
								BgL_arg1757z00_1660 =
									BGl_compz00zz__evaluate_compz00(
									((BgL_ev_exprz00_bglt) BgL_arg1759z00_1662),
									BgL_stkz00_14160);
							}
							{	/* Eval/evaluate_comp.scm 700 */
								obj_t BgL_arg1760z00_1663;
								long BgL_arg1761z00_1664;

								BgL_arg1760z00_1663 = CDR(((obj_t) BgL_lz00_1655));
								BgL_arg1761z00_1664 = (BgL_iz00_1656 - ((long) 1));
								BgL_arg1758z00_1661 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_14160,
									BgL_arg1760z00_1663, BgL_arg1761z00_1664);
							}
							return MAKE_YOUNG_PAIR(BgL_arg1757z00_1660, BgL_arg1758z00_1661);
						}
				}
		}

	}



/* subr-call-with-push */
	obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122,
		obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125,
		obj_t BgL_siza7eza7_126)
	{
		{	/* Eval/evaluate_comp.scm 702 */
			{	/* Eval/evaluate_comp.scm 704 */
				obj_t BgL_argsz00_1666;

				if (NULLP(BgL_argsz00_124))
					{	/* Eval/evaluate_comp.scm 704 */
						BgL_argsz00_1666 = BNIL;
					}
				else
					{	/* Eval/evaluate_comp.scm 704 */
						obj_t BgL_head1343z00_1671;

						BgL_head1343z00_1671 = MAKE_YOUNG_PAIR(BNIL, BNIL);
						{
							obj_t BgL_l1341z00_6674;
							obj_t BgL_tail1344z00_6675;

							BgL_l1341z00_6674 = BgL_argsz00_124;
							BgL_tail1344z00_6675 = BgL_head1343z00_1671;
						BgL_zc3z04anonymousza31764ze3z87_6673:
							if (NULLP(BgL_l1341z00_6674))
								{	/* Eval/evaluate_comp.scm 704 */
									BgL_argsz00_1666 = CDR(BgL_head1343z00_1671);
								}
							else
								{	/* Eval/evaluate_comp.scm 704 */
									obj_t BgL_newtail1345z00_6682;

									{	/* Eval/evaluate_comp.scm 704 */
										obj_t BgL_arg1768z00_6683;

										{	/* Eval/evaluate_comp.scm 704 */
											obj_t BgL_az00_6684;

											BgL_az00_6684 = CAR(((obj_t) BgL_l1341z00_6674));
											BgL_arg1768z00_6683 =
												PROCEDURE_ENTRY(BgL_az00_6684) (BgL_az00_6684,
												BgL_sz00_122, BEOA);
										}
										BgL_newtail1345z00_6682 =
											MAKE_YOUNG_PAIR(BgL_arg1768z00_6683, BNIL);
									}
									SET_CDR(BgL_tail1344z00_6675, BgL_newtail1345z00_6682);
									{	/* Eval/evaluate_comp.scm 704 */
										obj_t BgL_arg1766z00_6685;

										BgL_arg1766z00_6685 = CDR(((obj_t) BgL_l1341z00_6674));
										{
											obj_t BgL_tail1344z00_17338;
											obj_t BgL_l1341z00_17337;

											BgL_l1341z00_17337 = BgL_arg1766z00_6685;
											BgL_tail1344z00_17338 = BgL_newtail1345z00_6682;
											BgL_tail1344z00_6675 = BgL_tail1344z00_17338;
											BgL_l1341z00_6674 = BgL_l1341z00_17337;
											goto BgL_zc3z04anonymousza31764ze3z87_6673;
										}
									}
								}
						}
					}
				{	/* Eval/evaluate_comp.scm 705 */
					long BgL_arg1762z00_1667;

					BgL_arg1762z00_1667 =
						((long) CINT(BgL_bpz00_125) + (long) CINT(BgL_siza7eza7_126));
					VECTOR_SET(
						((obj_t) BgL_sz00_122), ((long) 0), BINT(BgL_arg1762z00_1667));
				}
				{	/* Eval/evaluate_comp.scm 706 */
					obj_t BgL_za2za2resza2za2z00_1668;

					BgL_za2za2resza2za2z00_1668 = apply(BgL_fz00_123, BgL_argsz00_1666);
					VECTOR_SET(((obj_t) BgL_sz00_122), ((long) 0), BgL_bpz00_125);
					return BgL_za2za2resza2za2z00_1668;
				}
			}
		}

	}



/* push-nargs-on-sp */
	obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t
		BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132,
		obj_t BgL_spz00_133)
	{
		{	/* Eval/evaluate_comp.scm 715 */
			{	/* Eval/evaluate_comp.scm 716 */
				long BgL_g1149z00_1692;

				BgL_g1149z00_1692 = (((long) -1) - (long) CINT(BgL_arityz00_130));
				{
					obj_t BgL_lz00_1694;
					obj_t BgL_spz00_1695;
					long BgL_nz00_1696;

					BgL_lz00_1694 = BgL_argsz00_132;
					BgL_spz00_1695 = BgL_spz00_133;
					BgL_nz00_1696 = BgL_g1149z00_1692;
				BgL_zc3z04anonymousza31776ze3z87_1697:
					if ((BgL_nz00_1696 == ((long) 0)))
						{
							obj_t BgL_lz00_6763;
							obj_t BgL_rz00_6764;

							BgL_lz00_6763 = BgL_lz00_1694;
							BgL_rz00_6764 = BNIL;
						BgL_rec2z00_6762:
							if (NULLP(BgL_lz00_6763))
								{	/* Eval/evaluate_comp.scm 720 */
									obj_t BgL_arg1780z00_6772;

									BgL_arg1780z00_6772 = bgl_reverse_bang(BgL_rz00_6764);
									{	/* Eval/evaluate_comp.scm 720 */
										long BgL_kz00_6778;

										BgL_kz00_6778 = (long) CINT(BgL_spz00_1695);
										return
											VECTOR_SET(
											((obj_t) BgL_sz00_131), BgL_kz00_6778,
											BgL_arg1780z00_6772);
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 721 */
									obj_t BgL_arg1781z00_6773;
									obj_t BgL_arg1782z00_6774;

									BgL_arg1781z00_6773 = CDR(((obj_t) BgL_lz00_6763));
									{	/* Eval/evaluate_comp.scm 721 */
										obj_t BgL_arg1783z00_6775;

										{	/* Eval/evaluate_comp.scm 721 */
											obj_t BgL_fun1784z00_6776;

											BgL_fun1784z00_6776 = CAR(((obj_t) BgL_lz00_6763));
											BgL_arg1783z00_6775 =
												PROCEDURE_ENTRY(BgL_fun1784z00_6776)
												(BgL_fun1784z00_6776, BgL_sz00_131, BEOA);
										}
										BgL_arg1782z00_6774 =
											MAKE_YOUNG_PAIR(BgL_arg1783z00_6775, BgL_rz00_6764);
									}
									{
										obj_t BgL_rz00_17369;
										obj_t BgL_lz00_17368;

										BgL_lz00_17368 = BgL_arg1781z00_6773;
										BgL_rz00_17369 = BgL_arg1782z00_6774;
										BgL_rz00_6764 = BgL_rz00_17369;
										BgL_lz00_6763 = BgL_lz00_17368;
										goto BgL_rec2z00_6762;
									}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 717 */
							{	/* Eval/evaluate_comp.scm 722 */
								obj_t BgL_arg1785z00_1711;

								{	/* Eval/evaluate_comp.scm 722 */
									obj_t BgL_fun1786z00_1712;

									BgL_fun1786z00_1712 = CAR(((obj_t) BgL_lz00_1694));
									BgL_arg1785z00_1711 =
										PROCEDURE_ENTRY(BgL_fun1786z00_1712) (BgL_fun1786z00_1712,
										BgL_sz00_131, BEOA);
								}
								{	/* Eval/evaluate_comp.scm 722 */
									long BgL_kz00_6783;

									BgL_kz00_6783 = (long) CINT(BgL_spz00_1695);
									VECTOR_SET(
										((obj_t) BgL_sz00_131), BgL_kz00_6783, BgL_arg1785z00_1711);
							}}
							{	/* Eval/evaluate_comp.scm 723 */
								obj_t BgL_arg1787z00_1713;
								long BgL_arg1788z00_1714;
								long BgL_arg1789z00_1715;

								BgL_arg1787z00_1713 = CDR(((obj_t) BgL_lz00_1694));
								BgL_arg1788z00_1714 =
									((long) CINT(BgL_spz00_1695) + ((long) 1));
								BgL_arg1789z00_1715 = (BgL_nz00_1696 - ((long) 1));
								{
									long BgL_nz00_17387;
									obj_t BgL_spz00_17385;
									obj_t BgL_lz00_17384;

									BgL_lz00_17384 = BgL_arg1787z00_1713;
									BgL_spz00_17385 = BINT(BgL_arg1788z00_1714);
									BgL_nz00_17387 = BgL_arg1789z00_1715;
									BgL_nz00_1696 = BgL_nz00_17387;
									BgL_spz00_1695 = BgL_spz00_17385;
									BgL_lz00_1694 = BgL_lz00_17384;
									goto BgL_zc3z04anonymousza31776ze3z87_1697;
								}
							}
						}
				}
			}
		}

	}



/* need-shift */
	bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134,
		obj_t BgL_stkz00_135)
	{
		{	/* Eval/evaluate_comp.scm 766 */
			{
				obj_t BgL_lz00_1718;
				obj_t BgL_stkz00_1719;

				BgL_lz00_1718 = BgL_argsz00_134;
				BgL_stkz00_1719 = BgL_stkz00_135;
			BgL_zc3z04anonymousza31790ze3z87_1720:
				{	/* Eval/evaluate_comp.scm 770 */
					bool_t BgL_test4889z00_17388;

					if (NULLP(BgL_lz00_1718))
						{	/* Eval/evaluate_comp.scm 770 */
							BgL_test4889z00_17388 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 770 */
							BgL_test4889z00_17388 = NULLP(BgL_stkz00_1719);
						}
					if (BgL_test4889z00_17388)
						{	/* Eval/evaluate_comp.scm 770 */
							return ((bool_t) 0);
						}
					else
						{	/* Eval/evaluate_comp.scm 772 */
							bool_t BgL_test4891z00_17392;

							{	/* Eval/evaluate_comp.scm 772 */
								obj_t BgL_g1348z00_1737;

								BgL_g1348z00_1737 = CDR(((obj_t) BgL_lz00_1718));
								{
									obj_t BgL_l1346z00_1739;

									{	/* Eval/evaluate_comp.scm 772 */
										obj_t BgL_tmpz00_17395;

										BgL_l1346z00_1739 = BgL_g1348z00_1737;
									BgL_zc3z04anonymousza31801ze3z87_1740:
										if (NULLP(BgL_l1346z00_1739))
											{	/* Eval/evaluate_comp.scm 772 */
												BgL_tmpz00_17395 = BFALSE;
											}
										else
											{	/* Eval/evaluate_comp.scm 772 */
												obj_t BgL__ortest_1349z00_1742;

												{	/* Eval/evaluate_comp.scm 772 */
													obj_t BgL_ez00_1744;

													BgL_ez00_1744 = CAR(((obj_t) BgL_l1346z00_1739));
													{	/* Eval/evaluate_comp.scm 772 */
														obj_t BgL_arg1804z00_1745;
														obj_t BgL_arg1806z00_1746;

														BgL_arg1804z00_1745 =
															CAR(((obj_t) BgL_stkz00_1719));
														BgL_arg1806z00_1746 =
															BGl_usez00zz__evaluate_usez00(
															((BgL_ev_exprz00_bglt) BgL_ez00_1744), BNIL);
														BgL__ortest_1349z00_1742 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(BgL_arg1804z00_1745, BgL_arg1806z00_1746);
													}
												}
												if (CBOOL(BgL__ortest_1349z00_1742))
													{	/* Eval/evaluate_comp.scm 772 */
														BgL_tmpz00_17395 = BgL__ortest_1349z00_1742;
													}
												else
													{	/* Eval/evaluate_comp.scm 772 */
														obj_t BgL_arg1802z00_1743;

														BgL_arg1802z00_1743 =
															CDR(((obj_t) BgL_l1346z00_1739));
														{
															obj_t BgL_l1346z00_17409;

															BgL_l1346z00_17409 = BgL_arg1802z00_1743;
															BgL_l1346z00_1739 = BgL_l1346z00_17409;
															goto BgL_zc3z04anonymousza31801ze3z87_1740;
														}
													}
											}
										BgL_test4891z00_17392 = CBOOL(BgL_tmpz00_17395);
									}
								}
							}
							if (BgL_test4891z00_17392)
								{	/* Eval/evaluate_comp.scm 772 */
									return ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_arg1799z00_1735;
									obj_t BgL_arg1800z00_1736;

									BgL_arg1799z00_1735 = CDR(((obj_t) BgL_lz00_1718));
									BgL_arg1800z00_1736 = CDR(((obj_t) BgL_stkz00_1719));
									{
										obj_t BgL_stkz00_17416;
										obj_t BgL_lz00_17415;

										BgL_lz00_17415 = BgL_arg1799z00_1735;
										BgL_stkz00_17416 = BgL_arg1800z00_1736;
										BgL_stkz00_1719 = BgL_stkz00_17416;
										BgL_lz00_1718 = BgL_lz00_17415;
										goto BgL_zc3z04anonymousza31790ze3z87_1720;
									}
								}
						}
				}
			}
		}

	}



/* comp-old-call */
	obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_ez00_136, obj_t BgL_stkz00_137)
	{
		{	/* Eval/evaluate_comp.scm 776 */
			{	/* Eval/evaluate_comp.scm 778 */
				long BgL_siza7eza7_1751;
				long BgL_nbargsz00_1752;
				obj_t BgL_fz00_1753;
				obj_t BgL_symbzd2funzd2_1754;

				BgL_siza7eza7_1751 = bgl_list_length(BgL_stkz00_137);
				BgL_nbargsz00_1752 =
					bgl_list_length(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00));
				BgL_fz00_1753 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_funz00),
					BgL_stkz00_137);
				BgL_symbzd2funzd2_1754 =
					BGl_uncompilez00zz__evaluate_uncompz00((((BgL_ev_appz00_bglt)
							COBJECT(BgL_ez00_136))->BgL_funz00));
				if (CBOOL((((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
							BgL_tailzf3zf3)))
					{	/* Eval/evaluate_comp.scm 780 */
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
								BgL_stkz00_137))
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test4896z00_17430;

								{	/* Eval/evaluate_comp.scm 787 */
									int BgL_arg1864z00_1833;

									BgL_arg1864z00_1833 = bgl_debug();
									BgL_test4896z00_17430 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1864z00_1833),
										BINT(((long) 0)));
								}
								if (BgL_test4896z00_17430)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_argsz00_1760;

										BgL_argsz00_1760 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 787 */
											obj_t BgL_zc3z04anonymousza31812ze3z87_12190;

											BgL_zc3z04anonymousza31812ze3z87_12190 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31812ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31812ze3z87_12190,
												(int) (((long) 0)), BgL_fz00_1753);
											PROCEDURE_SET(BgL_zc3z04anonymousza31812ze3z87_12190,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31812ze3z87_12190,
												(int) (((long) 2)), BgL_symbzd2funzd2_1754);
											PROCEDURE_SET(BgL_zc3z04anonymousza31812ze3z87_12190,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1752));
											PROCEDURE_SET(BgL_zc3z04anonymousza31812ze3z87_12190,
												(int) (((long) 4)), BgL_argsz00_1760);
											PROCEDURE_SET(BgL_zc3z04anonymousza31812ze3z87_12190,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1751));
											return BgL_zc3z04anonymousza31812ze3z87_12190;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_argsz00_1798;

										BgL_argsz00_1798 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 787 */
											obj_t BgL_zc3z04anonymousza31838ze3z87_12191;

											BgL_zc3z04anonymousza31838ze3z87_12191 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31838ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31838ze3z87_12191,
												(int) (((long) 0)), BgL_fz00_1753);
											PROCEDURE_SET(BgL_zc3z04anonymousza31838ze3z87_12191,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31838ze3z87_12191,
												(int) (((long) 2)), BgL_symbzd2funzd2_1754);
											PROCEDURE_SET(BgL_zc3z04anonymousza31838ze3z87_12191,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1752));
											PROCEDURE_SET(BgL_zc3z04anonymousza31838ze3z87_12191,
												(int) (((long) 4)), BgL_argsz00_1798);
											PROCEDURE_SET(BgL_zc3z04anonymousza31838ze3z87_12191,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1751));
											return BgL_zc3z04anonymousza31838ze3z87_12191;
										}
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test4897z00_17475;

								{	/* Eval/evaluate_comp.scm 795 */
									int BgL_arg1910z00_1903;

									BgL_arg1910z00_1903 = bgl_debug();
									BgL_test4897z00_17475 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1910z00_1903),
										BINT(((long) 0)));
								}
								if (BgL_test4897z00_17475)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_argsz00_1836;

										BgL_argsz00_1836 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1751);
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_zc3z04anonymousza31869ze3z87_12192;

											BgL_zc3z04anonymousza31869ze3z87_12192 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31869ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31869ze3z87_12192,
												(int) (((long) 0)), BgL_fz00_1753);
											PROCEDURE_SET(BgL_zc3z04anonymousza31869ze3z87_12192,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31869ze3z87_12192,
												(int) (((long) 2)), BgL_symbzd2funzd2_1754);
											PROCEDURE_SET(BgL_zc3z04anonymousza31869ze3z87_12192,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1752));
											PROCEDURE_SET(BgL_zc3z04anonymousza31869ze3z87_12192,
												(int) (((long) 4)), BgL_argsz00_1836);
											return BgL_zc3z04anonymousza31869ze3z87_12192;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_argsz00_1871;

										BgL_argsz00_1871 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1751);
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_zc3z04anonymousza31892ze3z87_12193;

											BgL_zc3z04anonymousza31892ze3z87_12193 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31892ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31892ze3z87_12193,
												(int) (((long) 0)), BgL_fz00_1753);
											PROCEDURE_SET(BgL_zc3z04anonymousza31892ze3z87_12193,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31892ze3z87_12193,
												(int) (((long) 2)), BgL_symbzd2funzd2_1754);
											PROCEDURE_SET(BgL_zc3z04anonymousza31892ze3z87_12193,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1752));
											PROCEDURE_SET(BgL_zc3z04anonymousza31892ze3z87_12193,
												(int) (((long) 4)), BgL_argsz00_1871);
											return BgL_zc3z04anonymousza31892ze3z87_12193;
										}
									}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 781 */
						bool_t BgL_test4898z00_17514;

						{	/* Eval/evaluate_comp.scm 781 */
							int BgL_arg1955z00_1974;

							BgL_arg1955z00_1974 = bgl_debug();
							BgL_test4898z00_17514 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1955z00_1974),
								BINT(((long) 0)));
						}
						if (BgL_test4898z00_17514)
							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_argsz00_1907;

								BgL_argsz00_1907 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 781 */
									obj_t BgL_zc3z04anonymousza31914ze3z87_12194;

									BgL_zc3z04anonymousza31914ze3z87_12194 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31914ze3ze5zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_12194,
										(int) (((long) 0)), BgL_fz00_1753);
									PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_12194,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_12194,
										(int) (((long) 2)), BgL_symbzd2funzd2_1754);
									PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_12194,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1752));
									PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_12194,
										(int) (((long) 4)), BgL_argsz00_1907);
									PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_12194,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1751));
									return BgL_zc3z04anonymousza31914ze3z87_12194;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_argsz00_1942;

								BgL_argsz00_1942 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 781 */
									obj_t BgL_zc3z04anonymousza31937ze3z87_12195;

									BgL_zc3z04anonymousza31937ze3z87_12195 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31937ze3ze5zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31937ze3z87_12195,
										(int) (((long) 0)), BgL_fz00_1753);
									PROCEDURE_SET(BgL_zc3z04anonymousza31937ze3z87_12195,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3z04anonymousza31937ze3z87_12195,
										(int) (((long) 2)), BgL_symbzd2funzd2_1754);
									PROCEDURE_SET(BgL_zc3z04anonymousza31937ze3z87_12195,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1752));
									PROCEDURE_SET(BgL_zc3z04anonymousza31937ze3z87_12195,
										(int) (((long) 4)), BgL_argsz00_1942);
									PROCEDURE_SET(BgL_zc3z04anonymousza31937ze3z87_12195,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1751));
									return BgL_zc3z04anonymousza31937ze3z87_12195;
								}
							}
					}
			}
		}

	}



/* &<@anonymous:1812> */
	obj_t BGl_z62zc3z04anonymousza31812ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12196, obj_t BgL_sz00_12203)
	{
		{	/* Eval/evaluate_comp.scm 787 */
			{	/* Eval/evaluate_comp.scm 787 */
				obj_t BgL_fz00_12197;
				BgL_ev_appz00_bglt BgL_i1157z00_12198;
				obj_t BgL_symbzd2funzd2_12199;
				long BgL_nbargsz00_12200;
				obj_t BgL_argsz00_12201;
				long BgL_siza7eza7_12202;

				BgL_fz00_12197 = PROCEDURE_REF(BgL_envz00_12196, (int) (((long) 0)));
				BgL_i1157z00_12198 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_12196, (int) (((long) 1))));
				BgL_symbzd2funzd2_12199 =
					PROCEDURE_REF(BgL_envz00_12196, (int) (((long) 2)));
				BgL_nbargsz00_12200 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12196, (int) (((long) 3))));
				BgL_argsz00_12201 =
					((obj_t) PROCEDURE_REF(BgL_envz00_12196, (int) (((long) 4))));
				BgL_siza7eza7_12202 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12196, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 787 */
					obj_t BgL_bpz00_14181;

					BgL_bpz00_14181 = VECTOR_REF(((obj_t) BgL_sz00_12203), ((long) 0));
					{	/* Eval/evaluate_comp.scm 787 */
						obj_t BgL_fz00_14182;

						BgL_fz00_14182 =
							PROCEDURE_ENTRY(BgL_fz00_12197) (BgL_fz00_12197, BgL_sz00_12203,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14182))
							{	/* Eval/evaluate_comp.scm 787 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 787 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12198))->
										BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14182);
							}
						{	/* Eval/evaluate_comp.scm 787 */
							obj_t BgL_ufz00_14183;

							{	/* Eval/evaluate_comp.scm 787 */
								obj_t BgL_tmpz00_17585;

								BgL_tmpz00_17585 = ((obj_t) BgL_fz00_14182);
								BgL_ufz00_14183 = PROCEDURE_ATTR(BgL_tmpz00_17585);
							}
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test4900z00_17588;

								if (STRUCTP(BgL_ufz00_14183))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4900z00_17588 =
											(STRUCT_KEY(BgL_ufz00_14183) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4900z00_17588 = ((bool_t) 0);
									}
								if (BgL_test4900z00_17588)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_arityz00_14184;
										obj_t BgL_runz00_14185;
										obj_t BgL_sfz00_14186;

										BgL_arityz00_14184 =
											STRUCT_REF(BgL_ufz00_14183, (int) (((long) 0)));
										BgL_runz00_14185 =
											STRUCT_REF(BgL_ufz00_14183, (int) (((long) 1)));
										BgL_sfz00_14186 =
											STRUCT_REF(BgL_ufz00_14183, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 787 */
											long BgL_spz00_14187;

											BgL_spz00_14187 =
												((long) CINT(BgL_bpz00_14181) + BgL_siza7eza7_12202);
											if (
												((long) CINT(BgL_arityz00_14184) ==
													BgL_nbargsz00_12200))
												{	/* Eval/evaluate_comp.scm 787 */
													{
														obj_t BgL_lz00_14189;
														long BgL_spz00_14190;

														BgL_lz00_14189 = BgL_argsz00_12201;
														BgL_spz00_14190 = BgL_spz00_14187;
													BgL_recz00_14188:
														if (NULLP(BgL_lz00_14189))
															{	/* Eval/evaluate_comp.scm 711 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1771z00_14191;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1772z00_14192;

																		BgL_fun1772z00_14192 =
																			CAR(((obj_t) BgL_lz00_14189));
																		BgL_arg1771z00_14191 =
																			PROCEDURE_ENTRY(BgL_fun1772z00_14192)
																			(BgL_fun1772z00_14192, BgL_sz00_12203,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12203), BgL_spz00_14190,
																		BgL_arg1771z00_14191);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1774z00_14193;
																	long BgL_arg1775z00_14194;

																	BgL_arg1774z00_14193 =
																		CDR(((obj_t) BgL_lz00_14189));
																	BgL_arg1775z00_14194 =
																		(BgL_spz00_14190 + ((long) 1));
																	{
																		long BgL_spz00_17618;
																		obj_t BgL_lz00_17617;

																		BgL_lz00_17617 = BgL_arg1774z00_14193;
																		BgL_spz00_17618 = BgL_arg1775z00_14194;
																		BgL_spz00_14190 = BgL_spz00_17618;
																		BgL_lz00_14189 = BgL_lz00_17617;
																		goto BgL_recz00_14188;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 791 */
														long BgL_arg1818z00_14195;

														BgL_arg1818z00_14195 =
															(BgL_spz00_14187 + BgL_nbargsz00_12200);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_12203, (long) CINT(BgL_bpz00_14181),
															BgL_sz00_12203, BINT(BgL_spz00_14187),
															BINT(BgL_arg1818z00_14195));
												}}
											else
												{	/* Eval/evaluate_comp.scm 787 */
													bool_t BgL_test4904z00_17624;

													if (((long) CINT(BgL_arityz00_14184) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test4904z00_17624 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test4904z00_17624 =
																(
																(long) CINT(BgL_arityz00_14184) <
																(((long) -1) - BgL_nbargsz00_12200));
														}
													if (BgL_test4904z00_17624)
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_12198))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_14183, (int) (((long) 3))),
																(int) (BgL_nbargsz00_12200),
																CINT(BgL_arityz00_14184));
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_14184, BgL_sz00_12203,
																BgL_argsz00_12201, BINT(BgL_spz00_14187));
															{	/* Eval/evaluate_comp.scm 793 */
																long BgL_arg1825z00_14196;

																BgL_arg1825z00_14196 =
																	(BgL_spz00_14187 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_14184)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_12203, (long) CINT(BgL_bpz00_14181),
																	BgL_sz00_12203, BINT(BgL_spz00_14187),
																	BINT(BgL_arg1825z00_14196));
												}}}
											{	/* Eval/evaluate_comp.scm 787 */
												obj_t BgL_z12denvz12_14197;

												BgL_z12denvz12_14197 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 787 */
													obj_t BgL_tmpz00_17647;

													BgL_tmpz00_17647 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_12198))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14197,
														BgL_tmpz00_17647);
												}
												if (
													(((long) CINT(BgL_bpz00_14181) +
															(long) CINT(BgL_sfz00_14186)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12203))))
													{	/* Eval/evaluate_comp.scm 787 */
														return BgL_runz00_14185;
													}
												else
													{	/* Eval/evaluate_comp.scm 787 */
														obj_t BgL_nsz00_14198;

														BgL_nsz00_14198 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 787 */
															long BgL_arg1830z00_14199;

															BgL_arg1830z00_14199 =
																(
																(long) CINT(BgL_bpz00_14181) +
																BgL_nbargsz00_12200);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14198, ((long) 2), BgL_sz00_12203,
																BgL_bpz00_14181, BINT(BgL_arg1830z00_14199));
														}
														VECTOR_SET(BgL_nsz00_14198, ((long) 1),
															BgL_sz00_12203);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14197,
															BgL_nsz00_14198);
														{	/* Eval/evaluate_comp.scm 787 */
															obj_t BgL_ez00_14200;

															BgL_ez00_14200 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14200, BgL_sz00_12203);
															{	/* Eval/evaluate_comp.scm 787 */
																obj_t BgL_____rz00_14201;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14202;

																	BgL_savedzd2bpzd2_14202 =
																		VECTOR_REF(BgL_nsz00_14198, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14198, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14204;

																		BgL_fz00_14204 = BgL_runz00_14185;
																	BgL_recz00_14203:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14205;

																			BgL_rz00_14205 =
																				PROCEDURE_ENTRY(BgL_fz00_14204)
																				(BgL_fz00_14204, BgL_nsz00_14198, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test4907z00_17673;

																				if (PROCEDUREP(BgL_rz00_14205))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14206;

																						BgL_arg1729z00_14206 =
																							PROCEDURE_ATTR(BgL_rz00_14205);
																						if (STRUCTP(BgL_arg1729z00_14206))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test4907z00_17673 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14206) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test4907z00_17673 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test4907z00_17673 =
																							((bool_t) 0);
																					}
																				if (BgL_test4907z00_17673)
																					{
																						obj_t BgL_fz00_17681;

																						BgL_fz00_17681 = BgL_rz00_14205;
																						BgL_fz00_14204 = BgL_fz00_17681;
																						goto BgL_recz00_14203;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14198,
																							((long) 0),
																							BgL_savedzd2bpzd2_14202);
																						BgL_____rz00_14201 = BgL_rz00_14205;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14200);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14197,
																	BgL_sz00_12203);
																return BgL_____rz00_14201;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14182,
												(int) (BgL_nbargsz00_12200)))
											{	/* Eval/evaluate_comp.scm 787 */
												{	/* Eval/evaluate_comp.scm 787 */
													obj_t BgL_auxz00_17690;
													obj_t BgL_tmpz00_17688;

													BgL_auxz00_17690 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_12198))->BgL_locz00);
													BgL_tmpz00_17688 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17688,
														BgL_auxz00_17690);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_12203, BgL_fz00_14182, BgL_argsz00_12201,
													BgL_bpz00_14181, BINT(BgL_siza7eza7_12202));
											}
										else
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12198))->
														BgL_locz00), BgL_symbzd2funzd2_12199,
													(int) (BgL_nbargsz00_12200),
													PROCEDURE_ARITY(BgL_fz00_14182));
		}}}}}}}}

	}



/* &<@anonymous:1838> */
	obj_t BGl_z62zc3z04anonymousza31838ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12204, obj_t BgL_sz00_12211)
	{
		{	/* Eval/evaluate_comp.scm 787 */
			{	/* Eval/evaluate_comp.scm 787 */
				obj_t BgL_fz00_12205;
				BgL_ev_appz00_bglt BgL_i1157z00_12206;
				obj_t BgL_symbzd2funzd2_12207;
				long BgL_nbargsz00_12208;
				obj_t BgL_argsz00_12209;
				long BgL_siza7eza7_12210;

				BgL_fz00_12205 = PROCEDURE_REF(BgL_envz00_12204, (int) (((long) 0)));
				BgL_i1157z00_12206 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_12204, (int) (((long) 1))));
				BgL_symbzd2funzd2_12207 =
					PROCEDURE_REF(BgL_envz00_12204, (int) (((long) 2)));
				BgL_nbargsz00_12208 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12204, (int) (((long) 3))));
				BgL_argsz00_12209 =
					((obj_t) PROCEDURE_REF(BgL_envz00_12204, (int) (((long) 4))));
				BgL_siza7eza7_12210 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12204, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 787 */
					obj_t BgL_bpz00_14207;

					BgL_bpz00_14207 = VECTOR_REF(((obj_t) BgL_sz00_12211), ((long) 0));
					{	/* Eval/evaluate_comp.scm 787 */
						obj_t BgL_fz00_14208;

						BgL_fz00_14208 =
							PROCEDURE_ENTRY(BgL_fz00_12205) (BgL_fz00_12205, BgL_sz00_12211,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14208))
							{	/* Eval/evaluate_comp.scm 787 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 787 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12206))->
										BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14208);
							}
						{	/* Eval/evaluate_comp.scm 787 */
							obj_t BgL_ufz00_14209;

							{	/* Eval/evaluate_comp.scm 787 */
								obj_t BgL_tmpz00_17725;

								BgL_tmpz00_17725 = ((obj_t) BgL_fz00_14208);
								BgL_ufz00_14209 = PROCEDURE_ATTR(BgL_tmpz00_17725);
							}
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test4912z00_17728;

								if (STRUCTP(BgL_ufz00_14209))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4912z00_17728 =
											(STRUCT_KEY(BgL_ufz00_14209) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4912z00_17728 = ((bool_t) 0);
									}
								if (BgL_test4912z00_17728)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_arityz00_14210;
										obj_t BgL_runz00_14211;
										obj_t BgL_sfz00_14212;

										BgL_arityz00_14210 =
											STRUCT_REF(BgL_ufz00_14209, (int) (((long) 0)));
										BgL_runz00_14211 =
											STRUCT_REF(BgL_ufz00_14209, (int) (((long) 1)));
										BgL_sfz00_14212 =
											STRUCT_REF(BgL_ufz00_14209, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 787 */
											long BgL_spz00_14213;

											BgL_spz00_14213 =
												((long) CINT(BgL_bpz00_14207) + BgL_siza7eza7_12210);
											if (
												((long) CINT(BgL_arityz00_14210) ==
													BgL_nbargsz00_12208))
												{	/* Eval/evaluate_comp.scm 787 */
													{
														obj_t BgL_lz00_14215;
														long BgL_spz00_14216;

														BgL_lz00_14215 = BgL_argsz00_12209;
														BgL_spz00_14216 = BgL_spz00_14213;
													BgL_recz00_14214:
														if (NULLP(BgL_lz00_14215))
															{	/* Eval/evaluate_comp.scm 711 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1771z00_14217;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1772z00_14218;

																		BgL_fun1772z00_14218 =
																			CAR(((obj_t) BgL_lz00_14215));
																		BgL_arg1771z00_14217 =
																			PROCEDURE_ENTRY(BgL_fun1772z00_14218)
																			(BgL_fun1772z00_14218, BgL_sz00_12211,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12211), BgL_spz00_14216,
																		BgL_arg1771z00_14217);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1774z00_14219;
																	long BgL_arg1775z00_14220;

																	BgL_arg1774z00_14219 =
																		CDR(((obj_t) BgL_lz00_14215));
																	BgL_arg1775z00_14220 =
																		(BgL_spz00_14216 + ((long) 1));
																	{
																		long BgL_spz00_17758;
																		obj_t BgL_lz00_17757;

																		BgL_lz00_17757 = BgL_arg1774z00_14219;
																		BgL_spz00_17758 = BgL_arg1775z00_14220;
																		BgL_spz00_14216 = BgL_spz00_17758;
																		BgL_lz00_14215 = BgL_lz00_17757;
																		goto BgL_recz00_14214;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 791 */
														long BgL_arg1845z00_14221;

														BgL_arg1845z00_14221 =
															(BgL_spz00_14213 + BgL_nbargsz00_12208);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_12211, (long) CINT(BgL_bpz00_14207),
															BgL_sz00_12211, BINT(BgL_spz00_14213),
															BINT(BgL_arg1845z00_14221));
												}}
											else
												{	/* Eval/evaluate_comp.scm 787 */
													bool_t BgL_test4916z00_17764;

													if (((long) CINT(BgL_arityz00_14210) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test4916z00_17764 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test4916z00_17764 =
																(
																(long) CINT(BgL_arityz00_14210) <
																(((long) -1) - BgL_nbargsz00_12208));
														}
													if (BgL_test4916z00_17764)
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_12206))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_14209, (int) (((long) 3))),
																(int) (BgL_nbargsz00_12208),
																CINT(BgL_arityz00_14210));
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_14210, BgL_sz00_12211,
																BgL_argsz00_12209, BINT(BgL_spz00_14213));
															{	/* Eval/evaluate_comp.scm 793 */
																long BgL_arg1855z00_14222;

																BgL_arg1855z00_14222 =
																	(BgL_spz00_14213 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_14210)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_12211, (long) CINT(BgL_bpz00_14207),
																	BgL_sz00_12211, BINT(BgL_spz00_14213),
																	BINT(BgL_arg1855z00_14222));
												}}}
											{	/* Eval/evaluate_comp.scm 787 */
												obj_t BgL_z12denvz12_14223;

												BgL_z12denvz12_14223 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_14207) +
															(long) CINT(BgL_sfz00_14212)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12211))))
													{	/* Eval/evaluate_comp.scm 787 */
														return BgL_runz00_14211;
													}
												else
													{	/* Eval/evaluate_comp.scm 787 */
														obj_t BgL_nsz00_14224;

														BgL_nsz00_14224 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 787 */
															long BgL_arg1859z00_14225;

															BgL_arg1859z00_14225 =
																(
																(long) CINT(BgL_bpz00_14207) +
																BgL_nbargsz00_12208);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14224, ((long) 2), BgL_sz00_12211,
																BgL_bpz00_14207, BINT(BgL_arg1859z00_14225));
														}
														VECTOR_SET(BgL_nsz00_14224, ((long) 1),
															BgL_sz00_12211);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14223,
															BgL_nsz00_14224);
														{	/* Eval/evaluate_comp.scm 787 */
															obj_t BgL_ez00_14226;

															BgL_ez00_14226 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14226, BgL_sz00_12211);
															{	/* Eval/evaluate_comp.scm 787 */
																obj_t BgL_____rz00_14227;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14228;

																	BgL_savedzd2bpzd2_14228 =
																		VECTOR_REF(BgL_nsz00_14224, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14224, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14230;

																		BgL_fz00_14230 = BgL_runz00_14211;
																	BgL_recz00_14229:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14231;

																			BgL_rz00_14231 =
																				PROCEDURE_ENTRY(BgL_fz00_14230)
																				(BgL_fz00_14230, BgL_nsz00_14224, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test4919z00_17810;

																				if (PROCEDUREP(BgL_rz00_14231))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14232;

																						BgL_arg1729z00_14232 =
																							PROCEDURE_ATTR(BgL_rz00_14231);
																						if (STRUCTP(BgL_arg1729z00_14232))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test4919z00_17810 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14232) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test4919z00_17810 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test4919z00_17810 =
																							((bool_t) 0);
																					}
																				if (BgL_test4919z00_17810)
																					{
																						obj_t BgL_fz00_17818;

																						BgL_fz00_17818 = BgL_rz00_14231;
																						BgL_fz00_14230 = BgL_fz00_17818;
																						goto BgL_recz00_14229;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14224,
																							((long) 0),
																							BgL_savedzd2bpzd2_14228);
																						BgL_____rz00_14227 = BgL_rz00_14231;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14226);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14223,
																	BgL_sz00_12211);
																return BgL_____rz00_14227;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14208,
												(int) (BgL_nbargsz00_12208)))
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_12211, BgL_fz00_14208, BgL_argsz00_12209,
													BgL_bpz00_14207, BINT(BgL_siza7eza7_12210));
											}
										else
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12206))->
														BgL_locz00), BgL_symbzd2funzd2_12207,
													(int) (BgL_nbargsz00_12208),
													PROCEDURE_ARITY(BgL_fz00_14208));
		}}}}}}}}

	}



/* &<@anonymous:1869> */
	obj_t BGl_z62zc3z04anonymousza31869ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12212, obj_t BgL_sz00_12218)
	{
		{	/* Eval/evaluate_comp.scm 795 */
			{	/* Eval/evaluate_comp.scm 795 */
				obj_t BgL_fz00_12213;
				BgL_ev_appz00_bglt BgL_i1157z00_12214;
				obj_t BgL_symbzd2funzd2_12215;
				long BgL_nbargsz00_12216;
				obj_t BgL_argsz00_12217;

				BgL_fz00_12213 = PROCEDURE_REF(BgL_envz00_12212, (int) (((long) 0)));
				BgL_i1157z00_12214 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_12212, (int) (((long) 1))));
				BgL_symbzd2funzd2_12215 =
					PROCEDURE_REF(BgL_envz00_12212, (int) (((long) 2)));
				BgL_nbargsz00_12216 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12212, (int) (((long) 3))));
				BgL_argsz00_12217 =
					((obj_t) PROCEDURE_REF(BgL_envz00_12212, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 795 */
					obj_t BgL_bpz00_14233;

					BgL_bpz00_14233 = VECTOR_REF(((obj_t) BgL_sz00_12218), ((long) 0));
					{	/* Eval/evaluate_comp.scm 795 */
						obj_t BgL_fz00_14234;

						BgL_fz00_14234 =
							PROCEDURE_ENTRY(BgL_fz00_12213) (BgL_fz00_12213, BgL_sz00_12218,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14234))
							{	/* Eval/evaluate_comp.scm 795 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12214))->
										BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14234);
							}
						{	/* Eval/evaluate_comp.scm 795 */
							obj_t BgL_ufz00_14235;

							{	/* Eval/evaluate_comp.scm 795 */
								obj_t BgL_tmpz00_17854;

								BgL_tmpz00_17854 = ((obj_t) BgL_fz00_14234);
								BgL_ufz00_14235 = PROCEDURE_ATTR(BgL_tmpz00_17854);
							}
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test4924z00_17857;

								if (STRUCTP(BgL_ufz00_14235))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4924z00_17857 =
											(STRUCT_KEY(BgL_ufz00_14235) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4924z00_17857 = ((bool_t) 0);
									}
								if (BgL_test4924z00_17857)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_arityz00_14236;
										obj_t BgL_runz00_14237;
										obj_t BgL_sfz00_14238;

										BgL_arityz00_14236 =
											STRUCT_REF(BgL_ufz00_14235, (int) (((long) 0)));
										BgL_runz00_14237 =
											STRUCT_REF(BgL_ufz00_14235, (int) (((long) 1)));
										BgL_sfz00_14238 =
											STRUCT_REF(BgL_ufz00_14235, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_14236) == BgL_nbargsz00_12216))
											{
												obj_t BgL_lz00_14240;
												obj_t BgL_spz00_14241;

												{	/* Eval/evaluate_comp.scm 710 */
													bool_t BgL_tmpz00_17871;

													BgL_lz00_14240 = BgL_argsz00_12217;
													BgL_spz00_14241 = BgL_bpz00_14233;
												BgL_recz00_14239:
													if (NULLP(BgL_lz00_14240))
														{	/* Eval/evaluate_comp.scm 711 */
															BgL_tmpz00_17871 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 711 */
															{	/* Eval/evaluate_comp.scm 712 */
																obj_t BgL_arg1771z00_14242;

																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_fun1772z00_14243;

																	BgL_fun1772z00_14243 =
																		CAR(((obj_t) BgL_lz00_14240));
																	BgL_arg1771z00_14242 =
																		PROCEDURE_ENTRY(BgL_fun1772z00_14243)
																		(BgL_fun1772z00_14243, BgL_sz00_12218,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 712 */
																	long BgL_kz00_14244;

																	BgL_kz00_14244 = (long) CINT(BgL_spz00_14241);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12218), BgL_kz00_14244,
																		BgL_arg1771z00_14242);
															}}
															{	/* Eval/evaluate_comp.scm 713 */
																obj_t BgL_arg1774z00_14245;
																long BgL_arg1775z00_14246;

																BgL_arg1774z00_14245 =
																	CDR(((obj_t) BgL_lz00_14240));
																BgL_arg1775z00_14246 =
																	((long) CINT(BgL_spz00_14241) + ((long) 1));
																{
																	obj_t BgL_spz00_17888;
																	obj_t BgL_lz00_17887;

																	BgL_lz00_17887 = BgL_arg1774z00_14245;
																	BgL_spz00_17888 = BINT(BgL_arg1775z00_14246);
																	BgL_spz00_14241 = BgL_spz00_17888;
																	BgL_lz00_14240 = BgL_lz00_17887;
																	goto BgL_recz00_14239;
																}
															}
														}
													BBOOL(BgL_tmpz00_17871);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												bool_t BgL_test4928z00_17891;

												if (((long) CINT(BgL_arityz00_14236) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test4928z00_17891 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test4928z00_17891 =
															(
															(long) CINT(BgL_arityz00_14236) <
															(((long) -1) - BgL_nbargsz00_12216));
													}
												if (BgL_test4928z00_17891)
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1157z00_12214))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_14235, (int) (((long) 3))),
															(int) (BgL_nbargsz00_12216),
															CINT(BgL_arityz00_14236));
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_14236, BgL_sz00_12218,
															BgL_argsz00_12217, BgL_bpz00_14233);
													}
											}
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_z12denvz12_14247;

											BgL_z12denvz12_14247 = BGL_CURRENT_DYNAMIC_ENV();
											{	/* Eval/evaluate_comp.scm 795 */
												obj_t BgL_tmpz00_17906;

												BgL_tmpz00_17906 =
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12214))->
													BgL_locz00);
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14247,
													BgL_tmpz00_17906);
											}
											if (
												(((long) CINT(BgL_bpz00_14233) +
														(long) CINT(BgL_sfz00_14238)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12218))))
												{	/* Eval/evaluate_comp.scm 795 */
													return BgL_runz00_14237;
												}
											else
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_nsz00_14248;

													BgL_nsz00_14248 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 795 */
														long BgL_arg1885z00_14249;

														BgL_arg1885z00_14249 =
															(
															(long) CINT(BgL_bpz00_14233) +
															BgL_nbargsz00_12216);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14248, ((long) 2), BgL_sz00_12218,
															BgL_bpz00_14233, BINT(BgL_arg1885z00_14249));
													}
													VECTOR_SET(BgL_nsz00_14248, ((long) 1),
														BgL_sz00_12218);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14247,
														BgL_nsz00_14248);
													{	/* Eval/evaluate_comp.scm 795 */
														obj_t BgL_ez00_14250;

														BgL_ez00_14250 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14250, BgL_sz00_12218);
														{	/* Eval/evaluate_comp.scm 795 */
															obj_t BgL_____rz00_14251;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14252;

																BgL_savedzd2bpzd2_14252 =
																	VECTOR_REF(BgL_nsz00_14248, ((long) 0));
																VECTOR_SET(BgL_nsz00_14248, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14254;

																	BgL_fz00_14254 = BgL_runz00_14237;
																BgL_recz00_14253:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14255;

																		BgL_rz00_14255 =
																			PROCEDURE_ENTRY(BgL_fz00_14254)
																			(BgL_fz00_14254, BgL_nsz00_14248, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test4931z00_17932;

																			if (PROCEDUREP(BgL_rz00_14255))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14256;

																					BgL_arg1729z00_14256 =
																						PROCEDURE_ATTR(BgL_rz00_14255);
																					if (STRUCTP(BgL_arg1729z00_14256))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test4931z00_17932 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14256) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test4931z00_17932 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test4931z00_17932 = ((bool_t) 0);
																				}
																			if (BgL_test4931z00_17932)
																				{
																					obj_t BgL_fz00_17940;

																					BgL_fz00_17940 = BgL_rz00_14255;
																					BgL_fz00_14254 = BgL_fz00_17940;
																					goto BgL_recz00_14253;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14248,
																						((long) 0),
																						BgL_savedzd2bpzd2_14252);
																					BgL_____rz00_14251 = BgL_rz00_14255;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14250);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14247,
																BgL_sz00_12218);
															return BgL_____rz00_14251;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14234,
												(int) (BgL_nbargsz00_12216)))
											{	/* Eval/evaluate_comp.scm 795 */
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_auxz00_17949;
													obj_t BgL_tmpz00_17947;

													BgL_auxz00_17949 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_12214))->BgL_locz00);
													BgL_tmpz00_17947 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17947,
														BgL_auxz00_17949);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_12218, BgL_fz00_14234, BgL_argsz00_12217,
													BgL_bpz00_14233, BINT(BgL_nbargsz00_12216));
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12214))->
														BgL_locz00), BgL_symbzd2funzd2_12215,
													(int) (BgL_nbargsz00_12216),
													PROCEDURE_ARITY(BgL_fz00_14234));
		}}}}}}}}

	}



/* &<@anonymous:1892> */
	obj_t BGl_z62zc3z04anonymousza31892ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12219, obj_t BgL_sz00_12225)
	{
		{	/* Eval/evaluate_comp.scm 795 */
			{	/* Eval/evaluate_comp.scm 795 */
				obj_t BgL_fz00_12220;
				BgL_ev_appz00_bglt BgL_i1157z00_12221;
				obj_t BgL_symbzd2funzd2_12222;
				long BgL_nbargsz00_12223;
				obj_t BgL_argsz00_12224;

				BgL_fz00_12220 = PROCEDURE_REF(BgL_envz00_12219, (int) (((long) 0)));
				BgL_i1157z00_12221 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_12219, (int) (((long) 1))));
				BgL_symbzd2funzd2_12222 =
					PROCEDURE_REF(BgL_envz00_12219, (int) (((long) 2)));
				BgL_nbargsz00_12223 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12219, (int) (((long) 3))));
				BgL_argsz00_12224 =
					((obj_t) PROCEDURE_REF(BgL_envz00_12219, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 795 */
					obj_t BgL_bpz00_14257;

					BgL_bpz00_14257 = VECTOR_REF(((obj_t) BgL_sz00_12225), ((long) 0));
					{	/* Eval/evaluate_comp.scm 795 */
						obj_t BgL_fz00_14258;

						BgL_fz00_14258 =
							PROCEDURE_ENTRY(BgL_fz00_12220) (BgL_fz00_12220, BgL_sz00_12225,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14258))
							{	/* Eval/evaluate_comp.scm 795 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12221))->
										BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14258);
							}
						{	/* Eval/evaluate_comp.scm 795 */
							obj_t BgL_ufz00_14259;

							{	/* Eval/evaluate_comp.scm 795 */
								obj_t BgL_tmpz00_17981;

								BgL_tmpz00_17981 = ((obj_t) BgL_fz00_14258);
								BgL_ufz00_14259 = PROCEDURE_ATTR(BgL_tmpz00_17981);
							}
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test4936z00_17984;

								if (STRUCTP(BgL_ufz00_14259))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4936z00_17984 =
											(STRUCT_KEY(BgL_ufz00_14259) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4936z00_17984 = ((bool_t) 0);
									}
								if (BgL_test4936z00_17984)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_arityz00_14260;
										obj_t BgL_runz00_14261;
										obj_t BgL_sfz00_14262;

										BgL_arityz00_14260 =
											STRUCT_REF(BgL_ufz00_14259, (int) (((long) 0)));
										BgL_runz00_14261 =
											STRUCT_REF(BgL_ufz00_14259, (int) (((long) 1)));
										BgL_sfz00_14262 =
											STRUCT_REF(BgL_ufz00_14259, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_14260) == BgL_nbargsz00_12223))
											{
												obj_t BgL_lz00_14264;
												obj_t BgL_spz00_14265;

												{	/* Eval/evaluate_comp.scm 710 */
													bool_t BgL_tmpz00_17998;

													BgL_lz00_14264 = BgL_argsz00_12224;
													BgL_spz00_14265 = BgL_bpz00_14257;
												BgL_recz00_14263:
													if (NULLP(BgL_lz00_14264))
														{	/* Eval/evaluate_comp.scm 711 */
															BgL_tmpz00_17998 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 711 */
															{	/* Eval/evaluate_comp.scm 712 */
																obj_t BgL_arg1771z00_14266;

																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_fun1772z00_14267;

																	BgL_fun1772z00_14267 =
																		CAR(((obj_t) BgL_lz00_14264));
																	BgL_arg1771z00_14266 =
																		PROCEDURE_ENTRY(BgL_fun1772z00_14267)
																		(BgL_fun1772z00_14267, BgL_sz00_12225,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 712 */
																	long BgL_kz00_14268;

																	BgL_kz00_14268 = (long) CINT(BgL_spz00_14265);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12225), BgL_kz00_14268,
																		BgL_arg1771z00_14266);
															}}
															{	/* Eval/evaluate_comp.scm 713 */
																obj_t BgL_arg1774z00_14269;
																long BgL_arg1775z00_14270;

																BgL_arg1774z00_14269 =
																	CDR(((obj_t) BgL_lz00_14264));
																BgL_arg1775z00_14270 =
																	((long) CINT(BgL_spz00_14265) + ((long) 1));
																{
																	obj_t BgL_spz00_18015;
																	obj_t BgL_lz00_18014;

																	BgL_lz00_18014 = BgL_arg1774z00_14269;
																	BgL_spz00_18015 = BINT(BgL_arg1775z00_14270);
																	BgL_spz00_14265 = BgL_spz00_18015;
																	BgL_lz00_14264 = BgL_lz00_18014;
																	goto BgL_recz00_14263;
																}
															}
														}
													BBOOL(BgL_tmpz00_17998);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												bool_t BgL_test4940z00_18018;

												if (((long) CINT(BgL_arityz00_14260) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test4940z00_18018 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test4940z00_18018 =
															(
															(long) CINT(BgL_arityz00_14260) <
															(((long) -1) - BgL_nbargsz00_12223));
													}
												if (BgL_test4940z00_18018)
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1157z00_12221))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_14259, (int) (((long) 3))),
															(int) (BgL_nbargsz00_12223),
															CINT(BgL_arityz00_14260));
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_14260, BgL_sz00_12225,
															BgL_argsz00_12224, BgL_bpz00_14257);
													}
											}
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_z12denvz12_14271;

											BgL_z12denvz12_14271 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_14257) +
														(long) CINT(BgL_sfz00_14262)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12225))))
												{	/* Eval/evaluate_comp.scm 795 */
													return BgL_runz00_14261;
												}
											else
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_nsz00_14272;

													BgL_nsz00_14272 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 795 */
														long BgL_arg1905z00_14273;

														BgL_arg1905z00_14273 =
															(
															(long) CINT(BgL_bpz00_14257) +
															BgL_nbargsz00_12223);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14272, ((long) 2), BgL_sz00_12225,
															BgL_bpz00_14257, BINT(BgL_arg1905z00_14273));
													}
													VECTOR_SET(BgL_nsz00_14272, ((long) 1),
														BgL_sz00_12225);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14271,
														BgL_nsz00_14272);
													{	/* Eval/evaluate_comp.scm 795 */
														obj_t BgL_ez00_14274;

														BgL_ez00_14274 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14274, BgL_sz00_12225);
														{	/* Eval/evaluate_comp.scm 795 */
															obj_t BgL_____rz00_14275;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14276;

																BgL_savedzd2bpzd2_14276 =
																	VECTOR_REF(BgL_nsz00_14272, ((long) 0));
																VECTOR_SET(BgL_nsz00_14272, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14278;

																	BgL_fz00_14278 = BgL_runz00_14261;
																BgL_recz00_14277:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14279;

																		BgL_rz00_14279 =
																			PROCEDURE_ENTRY(BgL_fz00_14278)
																			(BgL_fz00_14278, BgL_nsz00_14272, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test4943z00_18056;

																			if (PROCEDUREP(BgL_rz00_14279))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14280;

																					BgL_arg1729z00_14280 =
																						PROCEDURE_ATTR(BgL_rz00_14279);
																					if (STRUCTP(BgL_arg1729z00_14280))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test4943z00_18056 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14280) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test4943z00_18056 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test4943z00_18056 = ((bool_t) 0);
																				}
																			if (BgL_test4943z00_18056)
																				{
																					obj_t BgL_fz00_18064;

																					BgL_fz00_18064 = BgL_rz00_14279;
																					BgL_fz00_14278 = BgL_fz00_18064;
																					goto BgL_recz00_14277;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14272,
																						((long) 0),
																						BgL_savedzd2bpzd2_14276);
																					BgL_____rz00_14275 = BgL_rz00_14279;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14274);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14271,
																BgL_sz00_12225);
															return BgL_____rz00_14275;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14258,
												(int) (BgL_nbargsz00_12223)))
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_12225, BgL_fz00_14258, BgL_argsz00_12224,
													BgL_bpz00_14257, BINT(BgL_nbargsz00_12223));
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12221))->
														BgL_locz00), BgL_symbzd2funzd2_12222,
													(int) (BgL_nbargsz00_12223),
													PROCEDURE_ARITY(BgL_fz00_14258));
		}}}}}}}}

	}



/* &<@anonymous:1914> */
	obj_t BGl_z62zc3z04anonymousza31914ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12226, obj_t BgL_sz00_12233)
	{
		{	/* Eval/evaluate_comp.scm 781 */
			{	/* Eval/evaluate_comp.scm 781 */
				obj_t BgL_fz00_12227;
				BgL_ev_appz00_bglt BgL_i1157z00_12228;
				obj_t BgL_symbzd2funzd2_12229;
				long BgL_nbargsz00_12230;
				obj_t BgL_argsz00_12231;
				long BgL_siza7eza7_12232;

				BgL_fz00_12227 = PROCEDURE_REF(BgL_envz00_12226, (int) (((long) 0)));
				BgL_i1157z00_12228 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_12226, (int) (((long) 1))));
				BgL_symbzd2funzd2_12229 =
					PROCEDURE_REF(BgL_envz00_12226, (int) (((long) 2)));
				BgL_nbargsz00_12230 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12226, (int) (((long) 3))));
				BgL_argsz00_12231 =
					((obj_t) PROCEDURE_REF(BgL_envz00_12226, (int) (((long) 4))));
				BgL_siza7eza7_12232 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12226, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 781 */
					obj_t BgL_bpz00_14281;

					BgL_bpz00_14281 = VECTOR_REF(((obj_t) BgL_sz00_12233), ((long) 0));
					{	/* Eval/evaluate_comp.scm 781 */
						obj_t BgL_fz00_14282;

						BgL_fz00_14282 =
							PROCEDURE_ENTRY(BgL_fz00_12227) (BgL_fz00_12227, BgL_sz00_12233,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14282))
							{	/* Eval/evaluate_comp.scm 781 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12228))->
										BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14282);
							}
						{	/* Eval/evaluate_comp.scm 781 */
							obj_t BgL_ufz00_14283;

							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_tmpz00_18103;

								BgL_tmpz00_18103 = ((obj_t) BgL_fz00_14282);
								BgL_ufz00_14283 = PROCEDURE_ATTR(BgL_tmpz00_18103);
							}
							{	/* Eval/evaluate_comp.scm 781 */
								bool_t BgL_test4948z00_18106;

								if (STRUCTP(BgL_ufz00_14283))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4948z00_18106 =
											(STRUCT_KEY(BgL_ufz00_14283) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4948z00_18106 = ((bool_t) 0);
									}
								if (BgL_test4948z00_18106)
									{	/* Eval/evaluate_comp.scm 781 */
										obj_t BgL_arityz00_14284;
										obj_t BgL_runz00_14285;
										obj_t BgL_sfz00_14286;

										BgL_arityz00_14284 =
											STRUCT_REF(BgL_ufz00_14283, (int) (((long) 0)));
										BgL_runz00_14285 =
											STRUCT_REF(BgL_ufz00_14283, (int) (((long) 1)));
										BgL_sfz00_14286 =
											STRUCT_REF(BgL_ufz00_14283, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 781 */
											long BgL_spz00_14287;

											BgL_spz00_14287 =
												((long) CINT(BgL_bpz00_14281) + BgL_siza7eza7_12232);
											if (
												((long) CINT(BgL_arityz00_14284) ==
													BgL_nbargsz00_12230))
												{
													obj_t BgL_lz00_14289;
													long BgL_spz00_14290;

													{	/* Eval/evaluate_comp.scm 710 */
														bool_t BgL_tmpz00_18122;

														BgL_lz00_14289 = BgL_argsz00_12231;
														BgL_spz00_14290 = BgL_spz00_14287;
													BgL_recz00_14288:
														if (NULLP(BgL_lz00_14289))
															{	/* Eval/evaluate_comp.scm 711 */
																BgL_tmpz00_18122 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1771z00_14291;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1772z00_14292;

																		BgL_fun1772z00_14292 =
																			CAR(((obj_t) BgL_lz00_14289));
																		BgL_arg1771z00_14291 =
																			PROCEDURE_ENTRY(BgL_fun1772z00_14292)
																			(BgL_fun1772z00_14292, BgL_sz00_12233,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12233), BgL_spz00_14290,
																		BgL_arg1771z00_14291);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1774z00_14293;
																	long BgL_arg1775z00_14294;

																	BgL_arg1774z00_14293 =
																		CDR(((obj_t) BgL_lz00_14289));
																	BgL_arg1775z00_14294 =
																		(BgL_spz00_14290 + ((long) 1));
																	{
																		long BgL_spz00_18137;
																		obj_t BgL_lz00_18136;

																		BgL_lz00_18136 = BgL_arg1774z00_14293;
																		BgL_spz00_18137 = BgL_arg1775z00_14294;
																		BgL_spz00_14290 = BgL_spz00_18137;
																		BgL_lz00_14289 = BgL_lz00_18136;
																		goto BgL_recz00_14288;
																	}
																}
															}
														BBOOL(BgL_tmpz00_18122);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 781 */
													bool_t BgL_test4952z00_18139;

													if (((long) CINT(BgL_arityz00_14284) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test4952z00_18139 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test4952z00_18139 =
																(
																(long) CINT(BgL_arityz00_14284) <
																(((long) -1) - BgL_nbargsz00_12230));
														}
													if (BgL_test4952z00_18139)
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_12228))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_14283, (int) (((long) 3))),
																(int) (BgL_nbargsz00_12230),
																CINT(BgL_arityz00_14284));
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_14284, BgL_sz00_12233,
																BgL_argsz00_12231, BINT(BgL_spz00_14287));
														}
												}
											{	/* Eval/evaluate_comp.scm 781 */
												obj_t BgL_z12denvz12_14295;

												BgL_z12denvz12_14295 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 781 */
													obj_t BgL_tmpz00_18155;

													BgL_tmpz00_18155 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_12228))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14295,
														BgL_tmpz00_18155);
												}
												if (
													((BgL_spz00_14287 +
															(long) CINT(BgL_sfz00_14286)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12233))))
													{	/* Eval/evaluate_comp.scm 781 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14285, BgL_sz00_12233,
															BINT(BgL_spz00_14287));
													}
												else
													{	/* Eval/evaluate_comp.scm 781 */
														obj_t BgL_nsz00_14296;

														BgL_nsz00_14296 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 781 */
															long BgL_arg1930z00_14297;

															BgL_arg1930z00_14297 =
																(BgL_spz00_14287 + BgL_nbargsz00_12230);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14296, ((long) 2), BgL_sz00_12233,
																BINT(BgL_spz00_14287),
																BINT(BgL_arg1930z00_14297));
														}
														VECTOR_SET(BgL_nsz00_14296, ((long) 1),
															BgL_sz00_12233);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14295,
															BgL_nsz00_14296);
														{	/* Eval/evaluate_comp.scm 781 */
															obj_t BgL_ez00_14298;

															BgL_ez00_14298 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14298, BgL_sz00_12233);
															{	/* Eval/evaluate_comp.scm 781 */
																obj_t BgL_____rz00_14299;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14300;

																	BgL_savedzd2bpzd2_14300 =
																		VECTOR_REF(BgL_nsz00_14296, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14296, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14302;

																		BgL_fz00_14302 = BgL_runz00_14285;
																	BgL_recz00_14301:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14303;

																			BgL_rz00_14303 =
																				PROCEDURE_ENTRY(BgL_fz00_14302)
																				(BgL_fz00_14302, BgL_nsz00_14296, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test4955z00_18182;

																				if (PROCEDUREP(BgL_rz00_14303))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14304;

																						BgL_arg1729z00_14304 =
																							PROCEDURE_ATTR(BgL_rz00_14303);
																						if (STRUCTP(BgL_arg1729z00_14304))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test4955z00_18182 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14304) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test4955z00_18182 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test4955z00_18182 =
																							((bool_t) 0);
																					}
																				if (BgL_test4955z00_18182)
																					{
																						obj_t BgL_fz00_18190;

																						BgL_fz00_18190 = BgL_rz00_14303;
																						BgL_fz00_14302 = BgL_fz00_18190;
																						goto BgL_recz00_14301;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14296,
																							((long) 0),
																							BgL_savedzd2bpzd2_14300);
																						BgL_____rz00_14299 = BgL_rz00_14303;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14298);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14295,
																	BgL_sz00_12233);
																return BgL_____rz00_14299;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 781 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14282,
												(int) (BgL_nbargsz00_12230)))
											{	/* Eval/evaluate_comp.scm 781 */
												{	/* Eval/evaluate_comp.scm 781 */
													obj_t BgL_auxz00_18199;
													obj_t BgL_tmpz00_18197;

													BgL_auxz00_18199 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_12228))->BgL_locz00);
													BgL_tmpz00_18197 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18197,
														BgL_auxz00_18199);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_12233, BgL_fz00_14282, BgL_argsz00_12231,
													BgL_bpz00_14281, BINT(BgL_siza7eza7_12232));
											}
										else
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12228))->
														BgL_locz00), BgL_symbzd2funzd2_12229,
													(int) (BgL_nbargsz00_12230),
													PROCEDURE_ARITY(BgL_fz00_14282));
		}}}}}}}}

	}



/* &<@anonymous:1937> */
	obj_t BGl_z62zc3z04anonymousza31937ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12234, obj_t BgL_sz00_12241)
	{
		{	/* Eval/evaluate_comp.scm 781 */
			{	/* Eval/evaluate_comp.scm 781 */
				obj_t BgL_fz00_12235;
				BgL_ev_appz00_bglt BgL_i1157z00_12236;
				obj_t BgL_symbzd2funzd2_12237;
				long BgL_nbargsz00_12238;
				obj_t BgL_argsz00_12239;
				long BgL_siza7eza7_12240;

				BgL_fz00_12235 = PROCEDURE_REF(BgL_envz00_12234, (int) (((long) 0)));
				BgL_i1157z00_12236 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_12234, (int) (((long) 1))));
				BgL_symbzd2funzd2_12237 =
					PROCEDURE_REF(BgL_envz00_12234, (int) (((long) 2)));
				BgL_nbargsz00_12238 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12234, (int) (((long) 3))));
				BgL_argsz00_12239 =
					((obj_t) PROCEDURE_REF(BgL_envz00_12234, (int) (((long) 4))));
				BgL_siza7eza7_12240 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12234, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 781 */
					obj_t BgL_bpz00_14305;

					BgL_bpz00_14305 = VECTOR_REF(((obj_t) BgL_sz00_12241), ((long) 0));
					{	/* Eval/evaluate_comp.scm 781 */
						obj_t BgL_fz00_14306;

						BgL_fz00_14306 =
							PROCEDURE_ENTRY(BgL_fz00_12235) (BgL_fz00_12235, BgL_sz00_12241,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14306))
							{	/* Eval/evaluate_comp.scm 781 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12236))->
										BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14306);
							}
						{	/* Eval/evaluate_comp.scm 781 */
							obj_t BgL_ufz00_14307;

							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_tmpz00_18234;

								BgL_tmpz00_18234 = ((obj_t) BgL_fz00_14306);
								BgL_ufz00_14307 = PROCEDURE_ATTR(BgL_tmpz00_18234);
							}
							{	/* Eval/evaluate_comp.scm 781 */
								bool_t BgL_test4960z00_18237;

								if (STRUCTP(BgL_ufz00_14307))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4960z00_18237 =
											(STRUCT_KEY(BgL_ufz00_14307) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4960z00_18237 = ((bool_t) 0);
									}
								if (BgL_test4960z00_18237)
									{	/* Eval/evaluate_comp.scm 781 */
										obj_t BgL_arityz00_14308;
										obj_t BgL_runz00_14309;
										obj_t BgL_sfz00_14310;

										BgL_arityz00_14308 =
											STRUCT_REF(BgL_ufz00_14307, (int) (((long) 0)));
										BgL_runz00_14309 =
											STRUCT_REF(BgL_ufz00_14307, (int) (((long) 1)));
										BgL_sfz00_14310 =
											STRUCT_REF(BgL_ufz00_14307, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 781 */
											long BgL_spz00_14311;

											BgL_spz00_14311 =
												((long) CINT(BgL_bpz00_14305) + BgL_siza7eza7_12240);
											if (
												((long) CINT(BgL_arityz00_14308) ==
													BgL_nbargsz00_12238))
												{
													obj_t BgL_lz00_14313;
													long BgL_spz00_14314;

													{	/* Eval/evaluate_comp.scm 710 */
														bool_t BgL_tmpz00_18253;

														BgL_lz00_14313 = BgL_argsz00_12239;
														BgL_spz00_14314 = BgL_spz00_14311;
													BgL_recz00_14312:
														if (NULLP(BgL_lz00_14313))
															{	/* Eval/evaluate_comp.scm 711 */
																BgL_tmpz00_18253 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1771z00_14315;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1772z00_14316;

																		BgL_fun1772z00_14316 =
																			CAR(((obj_t) BgL_lz00_14313));
																		BgL_arg1771z00_14315 =
																			PROCEDURE_ENTRY(BgL_fun1772z00_14316)
																			(BgL_fun1772z00_14316, BgL_sz00_12241,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12241), BgL_spz00_14314,
																		BgL_arg1771z00_14315);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1774z00_14317;
																	long BgL_arg1775z00_14318;

																	BgL_arg1774z00_14317 =
																		CDR(((obj_t) BgL_lz00_14313));
																	BgL_arg1775z00_14318 =
																		(BgL_spz00_14314 + ((long) 1));
																	{
																		long BgL_spz00_18268;
																		obj_t BgL_lz00_18267;

																		BgL_lz00_18267 = BgL_arg1774z00_14317;
																		BgL_spz00_18268 = BgL_arg1775z00_14318;
																		BgL_spz00_14314 = BgL_spz00_18268;
																		BgL_lz00_14313 = BgL_lz00_18267;
																		goto BgL_recz00_14312;
																	}
																}
															}
														BBOOL(BgL_tmpz00_18253);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 781 */
													bool_t BgL_test4964z00_18270;

													if (((long) CINT(BgL_arityz00_14308) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test4964z00_18270 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test4964z00_18270 =
																(
																(long) CINT(BgL_arityz00_14308) <
																(((long) -1) - BgL_nbargsz00_12238));
														}
													if (BgL_test4964z00_18270)
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_12236))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_14307, (int) (((long) 3))),
																(int) (BgL_nbargsz00_12238),
																CINT(BgL_arityz00_14308));
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_14308, BgL_sz00_12241,
																BgL_argsz00_12239, BINT(BgL_spz00_14311));
														}
												}
											{	/* Eval/evaluate_comp.scm 781 */
												obj_t BgL_z12denvz12_14319;

												BgL_z12denvz12_14319 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_14311 +
															(long) CINT(BgL_sfz00_14310)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12241))))
													{	/* Eval/evaluate_comp.scm 781 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14309, BgL_sz00_12241,
															BINT(BgL_spz00_14311));
													}
												else
													{	/* Eval/evaluate_comp.scm 781 */
														obj_t BgL_nsz00_14320;

														BgL_nsz00_14320 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 781 */
															long BgL_arg1949z00_14321;

															BgL_arg1949z00_14321 =
																(BgL_spz00_14311 + BgL_nbargsz00_12238);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14320, ((long) 2), BgL_sz00_12241,
																BINT(BgL_spz00_14311),
																BINT(BgL_arg1949z00_14321));
														}
														VECTOR_SET(BgL_nsz00_14320, ((long) 1),
															BgL_sz00_12241);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14319,
															BgL_nsz00_14320);
														{	/* Eval/evaluate_comp.scm 781 */
															obj_t BgL_ez00_14322;

															BgL_ez00_14322 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14322, BgL_sz00_12241);
															{	/* Eval/evaluate_comp.scm 781 */
																obj_t BgL_____rz00_14323;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14324;

																	BgL_savedzd2bpzd2_14324 =
																		VECTOR_REF(BgL_nsz00_14320, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14320, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14326;

																		BgL_fz00_14326 = BgL_runz00_14309;
																	BgL_recz00_14325:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14327;

																			BgL_rz00_14327 =
																				PROCEDURE_ENTRY(BgL_fz00_14326)
																				(BgL_fz00_14326, BgL_nsz00_14320, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test4967z00_18310;

																				if (PROCEDUREP(BgL_rz00_14327))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14328;

																						BgL_arg1729z00_14328 =
																							PROCEDURE_ATTR(BgL_rz00_14327);
																						if (STRUCTP(BgL_arg1729z00_14328))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test4967z00_18310 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14328) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test4967z00_18310 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test4967z00_18310 =
																							((bool_t) 0);
																					}
																				if (BgL_test4967z00_18310)
																					{
																						obj_t BgL_fz00_18318;

																						BgL_fz00_18318 = BgL_rz00_14327;
																						BgL_fz00_14326 = BgL_fz00_18318;
																						goto BgL_recz00_14325;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14320,
																							((long) 0),
																							BgL_savedzd2bpzd2_14324);
																						BgL_____rz00_14323 = BgL_rz00_14327;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14322);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14319,
																	BgL_sz00_12241);
																return BgL_____rz00_14323;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 781 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14306,
												(int) (BgL_nbargsz00_12238)))
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_12241, BgL_fz00_14306, BgL_argsz00_12239,
													BgL_bpz00_14305, BINT(BgL_siza7eza7_12240));
											}
										else
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_12236))->
														BgL_locz00), BgL_symbzd2funzd2_12237,
													(int) (BgL_nbargsz00_12238),
													PROCEDURE_ARITY(BgL_fz00_14306));
		}}}}}}}}

	}



/* comp-call0 */
	obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138,
		BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140,
		obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143,
		long BgL_siza7eza7_144)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_1978;

				BgL_cfunz00_1978 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139,
					((long) 0), BgL_locz00_138, BgL_symbzd2funzd2_140);
				if (CBOOL(BgL_cfunz00_1978))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test4972z00_18334;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg1964z00_1992;

							BgL_arg1964z00_1992 = bgl_debug();
							BgL_test4972z00_18334 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1964z00_1992),
								BINT(((long) 0)));
						}
						if (BgL_test4972z00_18334)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza31961ze3z87_12242;

								BgL_zc3z04anonymousza31961ze3z87_12242 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31961ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31961ze3z87_12242,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3z04anonymousza31961ze3z87_12242,
									(int) (((long) 1)), BgL_locz00_138);
								PROCEDURE_SET(BgL_zc3z04anonymousza31961ze3z87_12242,
									(int) (((long) 2)), BgL_cfunz00_1978);
								return BgL_zc3z04anonymousza31961ze3z87_12242;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza31963ze3z87_12243;

								BgL_zc3z04anonymousza31963ze3z87_12243 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31963ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31963ze3z87_12243,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3z04anonymousza31963ze3z87_12243,
									(int) (((long) 1)), BgL_cfunz00_1978);
								return BgL_zc3z04anonymousza31963ze3z87_12243;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_142))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test4974z00_18359;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg1995z00_2056;

									BgL_arg1995z00_2056 = bgl_debug();
									BgL_test4974z00_18359 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1995z00_2056),
										BINT(((long) 0)));
								}
								if (BgL_test4974z00_18359)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31967ze3z87_12244;

										BgL_zc3z04anonymousza31967ze3z87_12244 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31967ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31967ze3z87_12244,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31967ze3z87_12244,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31967ze3z87_12244,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31967ze3z87_12244,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31967ze3z87_12244;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31982ze3z87_12245;

										BgL_zc3z04anonymousza31982ze3z87_12245 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31982ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31982ze3z87_12245,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31982ze3z87_12245,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31982ze3z87_12245,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31982ze3z87_12245,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31982ze3z87_12245;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test4975z00_18388;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2025z00_2120;

									BgL_arg2025z00_2120 = bgl_debug();
									BgL_test4975z00_18388 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2025z00_2120),
										BINT(((long) 0)));
								}
								if (BgL_test4975z00_18388)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31998ze3z87_12246;

										BgL_zc3z04anonymousza31998ze3z87_12246 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31998ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31998ze3z87_12246,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31998ze3z87_12246,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31998ze3z87_12246,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31998ze3z87_12246,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31998ze3z87_12246;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32012ze3z87_12247;

										BgL_zc3z04anonymousza32012ze3z87_12247 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32012ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32012ze3z87_12247,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza32012ze3z87_12247,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza32012ze3z87_12247,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza32012ze3z87_12247,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza32012ze3z87_12247;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:1961> */
	obj_t BGl_z62zc3z04anonymousza31961ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12248, obj_t BgL_sz00_12252)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				long BgL_siza7eza7_12249;
				obj_t BgL_locz00_12250;
				obj_t BgL_cfunz00_12251;

				BgL_siza7eza7_12249 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12248, (int) (((long) 0))));
				BgL_locz00_12250 = PROCEDURE_REF(BgL_envz00_12248, (int) (((long) 1)));
				BgL_cfunz00_12251 = PROCEDURE_REF(BgL_envz00_12248, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14329;

					BgL_bpz00_14329 = VECTOR_REF(((obj_t) BgL_sz00_12252), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */

						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14330;

							BgL_nbpz00_14330 =
								((long) CINT(BgL_bpz00_14329) + BgL_siza7eza7_12249);
							VECTOR_SET(
								((obj_t) BgL_sz00_12252), ((long) 0), BINT(BgL_nbpz00_14330));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_18431;

								BgL_tmpz00_18431 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18431, BgL_locz00_12250);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14331;

								BgL_rz00_14331 =
									PROCEDURE_ENTRY(BgL_cfunz00_12251) (BgL_cfunz00_12251, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_12252), ((long) 0), BgL_bpz00_14329);
								return BgL_rz00_14331;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1963> */
	obj_t BGl_z62zc3z04anonymousza31963ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12253, obj_t BgL_sz00_12256)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				long BgL_siza7eza7_12254;
				obj_t BgL_cfunz00_12255;

				BgL_siza7eza7_12254 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12253, (int) (((long) 0))));
				BgL_cfunz00_12255 = PROCEDURE_REF(BgL_envz00_12253, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14332;

					BgL_bpz00_14332 = VECTOR_REF(((obj_t) BgL_sz00_12256), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */

						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14333;

							BgL_nbpz00_14333 =
								((long) CINT(BgL_bpz00_14332) + BgL_siza7eza7_12254);
							VECTOR_SET(
								((obj_t) BgL_sz00_12256), ((long) 0), BINT(BgL_nbpz00_14333));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14334;

								BgL_rz00_14334 =
									PROCEDURE_ENTRY(BgL_cfunz00_12255) (BgL_cfunz00_12255, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_12256), ((long) 0), BgL_bpz00_14332);
								return BgL_rz00_14334;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1967> */
	obj_t BGl_z62zc3z04anonymousza31967ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12257, obj_t BgL_sz00_12262)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12258;
				obj_t BgL_locz00_12259;
				obj_t BgL_symbzd2funzd2_12260;
				long BgL_siza7eza7_12261;

				BgL_funz00_12258 = PROCEDURE_REF(BgL_envz00_12257, (int) (((long) 0)));
				BgL_locz00_12259 = PROCEDURE_REF(BgL_envz00_12257, (int) (((long) 1)));
				BgL_symbzd2funzd2_12260 =
					PROCEDURE_REF(BgL_envz00_12257, (int) (((long) 2)));
				BgL_siza7eza7_12261 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12257, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14335;

					BgL_bpz00_14335 = VECTOR_REF(((obj_t) BgL_sz00_12262), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14336;

						BgL_fz00_14336 =
							PROCEDURE_ENTRY(BgL_funz00_12258) (BgL_funz00_12258,
							BgL_sz00_12262, BEOA);
						if (PROCEDUREP(BgL_fz00_14336))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12259,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14336);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14337;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_18474;

								BgL_tmpz00_18474 = ((obj_t) BgL_fz00_14336);
								BgL_ufz00_14337 = PROCEDURE_ATTR(BgL_tmpz00_18474);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test4977z00_18477;

								if (STRUCTP(BgL_ufz00_14337))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4977z00_18477 =
											(STRUCT_KEY(BgL_ufz00_14337) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4977z00_18477 = ((bool_t) 0);
									}
								if (BgL_test4977z00_18477)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14338;
										obj_t BgL_runz00_14339;
										obj_t BgL_sfz00_14340;

										BgL_arityz00_14338 =
											STRUCT_REF(BgL_ufz00_14337, (int) (((long) 0)));
										BgL_runz00_14339 =
											STRUCT_REF(BgL_ufz00_14337, (int) (((long) 1)));
										BgL_sfz00_14340 =
											STRUCT_REF(BgL_ufz00_14337, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14338) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 896 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14338))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14338))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg1972z00_14341;
																	obj_t BgL_arg1973z00_14342;

																	BgL_arg1972z00_14341 =
																		((long) CINT(BgL_bpz00_14335) + ((long) 0));
																	BgL_arg1973z00_14342 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12262),
																		BgL_arg1972z00_14341, BgL_arg1973z00_14342);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12259, STRUCT_REF(BgL_ufz00_14337,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_14338));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12259, STRUCT_REF(BgL_ufz00_14337,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_14338));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14343;

											BgL_z12denvz12_14343 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14343,
												BgL_locz00_12259);
											if ((((long) CINT(BgL_bpz00_14335) +
														(long) CINT(BgL_sfz00_14340)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12262))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14339;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14344;

													BgL_nsz00_14344 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg1977z00_14345;

														BgL_arg1977z00_14345 =
															((long) CINT(BgL_bpz00_14335) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14344, ((long) 2), BgL_sz00_12262,
															BgL_bpz00_14335, BINT(BgL_arg1977z00_14345));
													}
													VECTOR_SET(BgL_nsz00_14344, ((long) 1),
														BgL_sz00_12262);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14343,
														BgL_nsz00_14344);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14346;

														BgL_ez00_14346 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14346, BgL_sz00_12262);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14347;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14348;

																BgL_savedzd2bpzd2_14348 =
																	VECTOR_REF(BgL_nsz00_14344, ((long) 0));
																VECTOR_SET(BgL_nsz00_14344, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14350;

																	BgL_fz00_14350 = BgL_runz00_14339;
																BgL_recz00_14349:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14351;

																		BgL_rz00_14351 =
																			PROCEDURE_ENTRY(BgL_fz00_14350)
																			(BgL_fz00_14350, BgL_nsz00_14344, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test4982z00_18534;

																			if (PROCEDUREP(BgL_rz00_14351))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14352;

																					BgL_arg1729z00_14352 =
																						PROCEDURE_ATTR(BgL_rz00_14351);
																					if (STRUCTP(BgL_arg1729z00_14352))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test4982z00_18534 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14352) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test4982z00_18534 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test4982z00_18534 = ((bool_t) 0);
																				}
																			if (BgL_test4982z00_18534)
																				{
																					obj_t BgL_fz00_18542;

																					BgL_fz00_18542 = BgL_rz00_14351;
																					BgL_fz00_14350 = BgL_fz00_18542;
																					goto BgL_recz00_14349;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14344,
																						((long) 0),
																						BgL_savedzd2bpzd2_14348);
																					BgL_____rz00_14347 = BgL_rz00_14351;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14346);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14343,
																BgL_sz00_12262);
															return BgL_____rz00_14347;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14336,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14353;

												BgL_nbpz00_14353 =
													((long) CINT(BgL_bpz00_14335) + BgL_siza7eza7_12261);
												VECTOR_SET(
													((obj_t) BgL_sz00_12262), ((long) 0),
													BINT(BgL_nbpz00_14353));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_18554;

													BgL_tmpz00_18554 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18554,
														BgL_locz00_12259);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14354;

													BgL_rz00_14354 =
														PROCEDURE_ENTRY(BgL_fz00_14336) (BgL_fz00_14336,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12262), ((long) 0),
														BgL_bpz00_14335);
													return BgL_rz00_14354;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12259,
													BgL_symbzd2funzd2_12260, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_14336));
		}}}}}}}}

	}



/* &<@anonymous:1982> */
	obj_t BGl_z62zc3z04anonymousza31982ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12263, obj_t BgL_sz00_12268)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12264;
				obj_t BgL_locz00_12265;
				obj_t BgL_symbzd2funzd2_12266;
				long BgL_siza7eza7_12267;

				BgL_funz00_12264 = PROCEDURE_REF(BgL_envz00_12263, (int) (((long) 0)));
				BgL_locz00_12265 = PROCEDURE_REF(BgL_envz00_12263, (int) (((long) 1)));
				BgL_symbzd2funzd2_12266 =
					PROCEDURE_REF(BgL_envz00_12263, (int) (((long) 2)));
				BgL_siza7eza7_12267 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12263, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14355;

					BgL_bpz00_14355 = VECTOR_REF(((obj_t) BgL_sz00_12268), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14356;

						BgL_fz00_14356 =
							PROCEDURE_ENTRY(BgL_funz00_12264) (BgL_funz00_12264,
							BgL_sz00_12268, BEOA);
						if (PROCEDUREP(BgL_fz00_14356))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12265,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14356);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14357;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_18583;

								BgL_tmpz00_18583 = ((obj_t) BgL_fz00_14356);
								BgL_ufz00_14357 = PROCEDURE_ATTR(BgL_tmpz00_18583);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test4987z00_18586;

								if (STRUCTP(BgL_ufz00_14357))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4987z00_18586 =
											(STRUCT_KEY(BgL_ufz00_14357) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4987z00_18586 = ((bool_t) 0);
									}
								if (BgL_test4987z00_18586)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14358;
										obj_t BgL_runz00_14359;
										obj_t BgL_sfz00_14360;

										BgL_arityz00_14358 =
											STRUCT_REF(BgL_ufz00_14357, (int) (((long) 0)));
										BgL_runz00_14359 =
											STRUCT_REF(BgL_ufz00_14357, (int) (((long) 1)));
										BgL_sfz00_14360 =
											STRUCT_REF(BgL_ufz00_14357, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14358) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 896 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14358))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14358))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg1987z00_14361;
																	obj_t BgL_arg1988z00_14362;

																	BgL_arg1987z00_14361 =
																		((long) CINT(BgL_bpz00_14355) + ((long) 0));
																	BgL_arg1988z00_14362 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12268),
																		BgL_arg1987z00_14361, BgL_arg1988z00_14362);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12265, STRUCT_REF(BgL_ufz00_14357,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_14358));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12265, STRUCT_REF(BgL_ufz00_14357,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_14358));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14363;

											BgL_z12denvz12_14363 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_14355) +
														(long) CINT(BgL_sfz00_14360)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12268))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14359;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14364;

													BgL_nsz00_14364 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg1992z00_14365;

														BgL_arg1992z00_14365 =
															((long) CINT(BgL_bpz00_14355) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14364, ((long) 2), BgL_sz00_12268,
															BgL_bpz00_14355, BINT(BgL_arg1992z00_14365));
													}
													VECTOR_SET(BgL_nsz00_14364, ((long) 1),
														BgL_sz00_12268);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14363,
														BgL_nsz00_14364);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14366;

														BgL_ez00_14366 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14366, BgL_sz00_12268);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14367;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14368;

																BgL_savedzd2bpzd2_14368 =
																	VECTOR_REF(BgL_nsz00_14364, ((long) 0));
																VECTOR_SET(BgL_nsz00_14364, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14370;

																	BgL_fz00_14370 = BgL_runz00_14359;
																BgL_recz00_14369:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14371;

																		BgL_rz00_14371 =
																			PROCEDURE_ENTRY(BgL_fz00_14370)
																			(BgL_fz00_14370, BgL_nsz00_14364, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test4992z00_18642;

																			if (PROCEDUREP(BgL_rz00_14371))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14372;

																					BgL_arg1729z00_14372 =
																						PROCEDURE_ATTR(BgL_rz00_14371);
																					if (STRUCTP(BgL_arg1729z00_14372))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test4992z00_18642 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14372) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test4992z00_18642 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test4992z00_18642 = ((bool_t) 0);
																				}
																			if (BgL_test4992z00_18642)
																				{
																					obj_t BgL_fz00_18650;

																					BgL_fz00_18650 = BgL_rz00_14371;
																					BgL_fz00_14370 = BgL_fz00_18650;
																					goto BgL_recz00_14369;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14364,
																						((long) 0),
																						BgL_savedzd2bpzd2_14368);
																					BgL_____rz00_14367 = BgL_rz00_14371;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14366);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14363,
																BgL_sz00_12268);
															return BgL_____rz00_14367;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14356,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14373;

												BgL_nbpz00_14373 =
													((long) CINT(BgL_bpz00_14355) + BgL_siza7eza7_12267);
												VECTOR_SET(
													((obj_t) BgL_sz00_12268), ((long) 0),
													BINT(BgL_nbpz00_14373));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14374;

													BgL_rz00_14374 =
														PROCEDURE_ENTRY(BgL_fz00_14356) (BgL_fz00_14356,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12268), ((long) 0),
														BgL_bpz00_14355);
													return BgL_rz00_14374;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12265,
													BgL_symbzd2funzd2_12266, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_14356));
		}}}}}}}}

	}



/* &<@anonymous:1998> */
	obj_t BGl_z62zc3z04anonymousza31998ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12269, obj_t BgL_sz00_12274)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12270;
				obj_t BgL_locz00_12271;
				obj_t BgL_symbzd2funzd2_12272;
				long BgL_siza7eza7_12273;

				BgL_funz00_12270 = PROCEDURE_REF(BgL_envz00_12269, (int) (((long) 0)));
				BgL_locz00_12271 = PROCEDURE_REF(BgL_envz00_12269, (int) (((long) 1)));
				BgL_symbzd2funzd2_12272 =
					PROCEDURE_REF(BgL_envz00_12269, (int) (((long) 2)));
				BgL_siza7eza7_12273 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12269, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14375;

					BgL_bpz00_14375 = VECTOR_REF(((obj_t) BgL_sz00_12274), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14376;

						BgL_fz00_14376 =
							PROCEDURE_ENTRY(BgL_funz00_12270) (BgL_funz00_12270,
							BgL_sz00_12274, BEOA);
						if (PROCEDUREP(BgL_fz00_14376))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12271,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14376);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14377;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_18688;

								BgL_tmpz00_18688 = ((obj_t) BgL_fz00_14376);
								BgL_ufz00_14377 = PROCEDURE_ATTR(BgL_tmpz00_18688);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test4997z00_18691;

								if (STRUCTP(BgL_ufz00_14377))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4997z00_18691 =
											(STRUCT_KEY(BgL_ufz00_14377) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test4997z00_18691 = ((bool_t) 0);
									}
								if (BgL_test4997z00_18691)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14378;
										obj_t BgL_runz00_14379;
										obj_t BgL_sfz00_14380;

										BgL_arityz00_14378 =
											STRUCT_REF(BgL_ufz00_14377, (int) (((long) 0)));
										BgL_runz00_14379 =
											STRUCT_REF(BgL_ufz00_14377, (int) (((long) 1)));
										BgL_sfz00_14380 =
											STRUCT_REF(BgL_ufz00_14377, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_14381;

											BgL_spz00_14381 =
												((long) CINT(BgL_bpz00_14375) + BgL_siza7eza7_12273);
											if (((long) CINT(BgL_arityz00_14378) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 896 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_14378))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_14378))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2003z00_14382;
																		obj_t BgL_arg2004z00_14383;

																		BgL_arg2003z00_14382 =
																			(BgL_spz00_14381 + ((long) 0));
																		BgL_arg2004z00_14383 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12274),
																			BgL_arg2003z00_14382,
																			BgL_arg2004z00_14383);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12271,
																		STRUCT_REF(BgL_ufz00_14377,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_14378));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12271, STRUCT_REF(BgL_ufz00_14377,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_14378));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_14384;

												BgL_z12denvz12_14384 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14384,
													BgL_locz00_12271);
												if (((BgL_spz00_14381 + (long) CINT(BgL_sfz00_14380)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12274))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14379, BgL_sz00_12274,
															BINT(BgL_spz00_14381));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_14385;

														BgL_nsz00_14385 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2008z00_14386;

															BgL_arg2008z00_14386 =
																(BgL_spz00_14381 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14385, ((long) 2), BgL_sz00_12274,
																BINT(BgL_spz00_14381),
																BINT(BgL_arg2008z00_14386));
														}
														VECTOR_SET(BgL_nsz00_14385, ((long) 1),
															BgL_sz00_12274);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14384,
															BgL_nsz00_14385);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_14387;

															BgL_ez00_14387 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14387, BgL_sz00_12274);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_14388;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14389;

																	BgL_savedzd2bpzd2_14389 =
																		VECTOR_REF(BgL_nsz00_14385, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14385, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14391;

																		BgL_fz00_14391 = BgL_runz00_14379;
																	BgL_recz00_14390:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14392;

																			BgL_rz00_14392 =
																				PROCEDURE_ENTRY(BgL_fz00_14391)
																				(BgL_fz00_14391, BgL_nsz00_14385, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5002z00_18750;

																				if (PROCEDUREP(BgL_rz00_14392))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14393;

																						BgL_arg1729z00_14393 =
																							PROCEDURE_ATTR(BgL_rz00_14392);
																						if (STRUCTP(BgL_arg1729z00_14393))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5002z00_18750 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14393) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5002z00_18750 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5002z00_18750 =
																							((bool_t) 0);
																					}
																				if (BgL_test5002z00_18750)
																					{
																						obj_t BgL_fz00_18758;

																						BgL_fz00_18758 = BgL_rz00_14392;
																						BgL_fz00_14391 = BgL_fz00_18758;
																						goto BgL_recz00_14390;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14385,
																							((long) 0),
																							BgL_savedzd2bpzd2_14389);
																						BgL_____rz00_14388 = BgL_rz00_14392;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14387);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14384,
																	BgL_sz00_12274);
																return BgL_____rz00_14388;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14376,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14394;

												BgL_nbpz00_14394 =
													((long) CINT(BgL_bpz00_14375) + BgL_siza7eza7_12273);
												VECTOR_SET(
													((obj_t) BgL_sz00_12274), ((long) 0),
													BINT(BgL_nbpz00_14394));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_18770;

													BgL_tmpz00_18770 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18770,
														BgL_locz00_12271);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14395;

													BgL_rz00_14395 =
														PROCEDURE_ENTRY(BgL_fz00_14376) (BgL_fz00_14376,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12274), ((long) 0),
														BgL_bpz00_14375);
													return BgL_rz00_14395;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12271,
													BgL_symbzd2funzd2_12272, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_14376));
		}}}}}}}}

	}



/* &<@anonymous:2012> */
	obj_t BGl_z62zc3z04anonymousza32012ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12275, obj_t BgL_sz00_12280)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12276;
				obj_t BgL_locz00_12277;
				obj_t BgL_symbzd2funzd2_12278;
				long BgL_siza7eza7_12279;

				BgL_funz00_12276 = PROCEDURE_REF(BgL_envz00_12275, (int) (((long) 0)));
				BgL_locz00_12277 = PROCEDURE_REF(BgL_envz00_12275, (int) (((long) 1)));
				BgL_symbzd2funzd2_12278 =
					PROCEDURE_REF(BgL_envz00_12275, (int) (((long) 2)));
				BgL_siza7eza7_12279 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12275, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14396;

					BgL_bpz00_14396 = VECTOR_REF(((obj_t) BgL_sz00_12280), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14397;

						BgL_fz00_14397 =
							PROCEDURE_ENTRY(BgL_funz00_12276) (BgL_funz00_12276,
							BgL_sz00_12280, BEOA);
						if (PROCEDUREP(BgL_fz00_14397))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12277,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14397);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14398;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_18799;

								BgL_tmpz00_18799 = ((obj_t) BgL_fz00_14397);
								BgL_ufz00_14398 = PROCEDURE_ATTR(BgL_tmpz00_18799);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5007z00_18802;

								if (STRUCTP(BgL_ufz00_14398))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5007z00_18802 =
											(STRUCT_KEY(BgL_ufz00_14398) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5007z00_18802 = ((bool_t) 0);
									}
								if (BgL_test5007z00_18802)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14399;
										obj_t BgL_runz00_14400;
										obj_t BgL_sfz00_14401;

										BgL_arityz00_14399 =
											STRUCT_REF(BgL_ufz00_14398, (int) (((long) 0)));
										BgL_runz00_14400 =
											STRUCT_REF(BgL_ufz00_14398, (int) (((long) 1)));
										BgL_sfz00_14401 =
											STRUCT_REF(BgL_ufz00_14398, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_14402;

											BgL_spz00_14402 =
												((long) CINT(BgL_bpz00_14396) + BgL_siza7eza7_12279);
											if (((long) CINT(BgL_arityz00_14399) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 896 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_14399))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_14399))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2017z00_14403;
																		obj_t BgL_arg2018z00_14404;

																		BgL_arg2017z00_14403 =
																			(BgL_spz00_14402 + ((long) 0));
																		BgL_arg2018z00_14404 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12280),
																			BgL_arg2017z00_14403,
																			BgL_arg2018z00_14404);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12277,
																		STRUCT_REF(BgL_ufz00_14398,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_14399));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12277, STRUCT_REF(BgL_ufz00_14398,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_14399));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_14405;

												BgL_z12denvz12_14405 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_14402 +
															(long) CINT(BgL_sfz00_14401)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12280))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14400, BgL_sz00_12280,
															BINT(BgL_spz00_14402));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_14406;

														BgL_nsz00_14406 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2022z00_14407;

															BgL_arg2022z00_14407 =
																(BgL_spz00_14402 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14406, ((long) 2), BgL_sz00_12280,
																BINT(BgL_spz00_14402),
																BINT(BgL_arg2022z00_14407));
														}
														VECTOR_SET(BgL_nsz00_14406, ((long) 1),
															BgL_sz00_12280);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14405,
															BgL_nsz00_14406);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_14408;

															BgL_ez00_14408 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14408, BgL_sz00_12280);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_14409;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14410;

																	BgL_savedzd2bpzd2_14410 =
																		VECTOR_REF(BgL_nsz00_14406, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14406, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14412;

																		BgL_fz00_14412 = BgL_runz00_14400;
																	BgL_recz00_14411:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14413;

																			BgL_rz00_14413 =
																				PROCEDURE_ENTRY(BgL_fz00_14412)
																				(BgL_fz00_14412, BgL_nsz00_14406, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5012z00_18860;

																				if (PROCEDUREP(BgL_rz00_14413))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14414;

																						BgL_arg1729z00_14414 =
																							PROCEDURE_ATTR(BgL_rz00_14413);
																						if (STRUCTP(BgL_arg1729z00_14414))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5012z00_18860 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14414) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5012z00_18860 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5012z00_18860 =
																							((bool_t) 0);
																					}
																				if (BgL_test5012z00_18860)
																					{
																						obj_t BgL_fz00_18868;

																						BgL_fz00_18868 = BgL_rz00_14413;
																						BgL_fz00_14412 = BgL_fz00_18868;
																						goto BgL_recz00_14411;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14406,
																							((long) 0),
																							BgL_savedzd2bpzd2_14410);
																						BgL_____rz00_14409 = BgL_rz00_14413;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14408);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14405,
																	BgL_sz00_12280);
																return BgL_____rz00_14409;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14397,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14415;

												BgL_nbpz00_14415 =
													((long) CINT(BgL_bpz00_14396) + BgL_siza7eza7_12279);
												VECTOR_SET(
													((obj_t) BgL_sz00_12280), ((long) 0),
													BINT(BgL_nbpz00_14415));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14416;

													BgL_rz00_14416 =
														PROCEDURE_ENTRY(BgL_fz00_14397) (BgL_fz00_14397,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12280), ((long) 0),
														BgL_bpz00_14396);
													return BgL_rz00_14416;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12277,
													BgL_symbzd2funzd2_12278, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_14397));
		}}}}}}}}

	}



/* comp-call1 */
	obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145,
		BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147,
		obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150,
		long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2121;

				BgL_cfunz00_2121 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146,
					((long) 1), BgL_locz00_145, BgL_symbzd2funzd2_147);
				if (CBOOL(BgL_cfunz00_2121))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test5017z00_18891;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2033z00_2137;

							BgL_arg2033z00_2137 = bgl_debug();
							BgL_test5017z00_18891 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2033z00_2137),
								BINT(((long) 0)));
						}
						if (BgL_test5017z00_18891)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32029ze3z87_12281;

								BgL_zc3z04anonymousza32029ze3z87_12281 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32029ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32029ze3z87_12281,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3z04anonymousza32029ze3z87_12281,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3z04anonymousza32029ze3z87_12281,
									(int) (((long) 2)), BgL_locz00_145);
								PROCEDURE_SET(BgL_zc3z04anonymousza32029ze3z87_12281,
									(int) (((long) 3)), BgL_cfunz00_2121);
								return BgL_zc3z04anonymousza32029ze3z87_12281;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32032ze3z87_12282;

								BgL_zc3z04anonymousza32032ze3z87_12282 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32032ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32032ze3z87_12282,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3z04anonymousza32032ze3z87_12282,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3z04anonymousza32032ze3z87_12282,
									(int) (((long) 2)), BgL_cfunz00_2121);
								return BgL_zc3z04anonymousza32032ze3z87_12282;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_149))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5019z00_18920;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2077z00_2213;

									BgL_arg2077z00_2213 = bgl_debug();
									BgL_test5019z00_18920 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2077z00_2213),
										BINT(((long) 0)));
								}
								if (BgL_test5019z00_18920)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32036ze3z87_12283;

										BgL_zc3z04anonymousza32036ze3z87_12283 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32036ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_12283,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_12283,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_12283,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_12283,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32036ze3z87_12283,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32036ze3z87_12283;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32057ze3z87_12284;

										BgL_zc3z04anonymousza32057ze3z87_12284 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32057ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32057ze3z87_12284,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32057ze3z87_12284,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32057ze3z87_12284,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32057ze3z87_12284,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32057ze3z87_12284,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32057ze3z87_12284;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5020z00_18953;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2117z00_2289;

									BgL_arg2117z00_2289 = bgl_debug();
									BgL_test5020z00_18953 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2117z00_2289),
										BINT(((long) 0)));
								}
								if (BgL_test5020z00_18953)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32080ze3z87_12285;

										BgL_zc3z04anonymousza32080ze3z87_12285 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32080ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32080ze3z87_12285,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32080ze3z87_12285,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32080ze3z87_12285,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32080ze3z87_12285,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32080ze3z87_12285,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32080ze3z87_12285;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32099ze3z87_12286;

										BgL_zc3z04anonymousza32099ze3z87_12286 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32099ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32099ze3z87_12286,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32099ze3z87_12286,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32099ze3z87_12286,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32099ze3z87_12286,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32099ze3z87_12286,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32099ze3z87_12286;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2029> */
	obj_t BGl_z62zc3z04anonymousza32029ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12287, obj_t BgL_sz00_12292)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_12288;
				long BgL_siza7eza7_12289;
				obj_t BgL_locz00_12290;
				obj_t BgL_cfunz00_12291;

				BgL_a1z00_12288 = PROCEDURE_REF(BgL_envz00_12287, (int) (((long) 0)));
				BgL_siza7eza7_12289 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12287, (int) (((long) 1))));
				BgL_locz00_12290 = PROCEDURE_REF(BgL_envz00_12287, (int) (((long) 2)));
				BgL_cfunz00_12291 = PROCEDURE_REF(BgL_envz00_12287, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14417;

					BgL_bpz00_14417 = VECTOR_REF(((obj_t) BgL_sz00_12292), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_14418;

						BgL_a1z00_14418 =
							PROCEDURE_ENTRY(BgL_a1z00_12288) (BgL_a1z00_12288, BgL_sz00_12292,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14419;

							BgL_nbpz00_14419 =
								((long) CINT(BgL_bpz00_14417) + BgL_siza7eza7_12289);
							VECTOR_SET(
								((obj_t) BgL_sz00_12292), ((long) 0), BINT(BgL_nbpz00_14419));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19006;

								BgL_tmpz00_19006 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19006, BgL_locz00_12290);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14420;

								BgL_rz00_14420 =
									PROCEDURE_ENTRY(BgL_cfunz00_12291) (BgL_cfunz00_12291,
									BgL_a1z00_14418, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_12292), ((long) 0),
									BgL_bpz00_14417);
								return BgL_rz00_14420;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2032> */
	obj_t BGl_z62zc3z04anonymousza32032ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12293, obj_t BgL_sz00_12297)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_12294;
				long BgL_siza7eza7_12295;
				obj_t BgL_cfunz00_12296;

				BgL_a1z00_12294 = PROCEDURE_REF(BgL_envz00_12293, (int) (((long) 0)));
				BgL_siza7eza7_12295 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12293, (int) (((long) 1))));
				BgL_cfunz00_12296 = PROCEDURE_REF(BgL_envz00_12293, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14421;

					BgL_bpz00_14421 = VECTOR_REF(((obj_t) BgL_sz00_12297), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_14422;

						BgL_a1z00_14422 =
							PROCEDURE_ENTRY(BgL_a1z00_12294) (BgL_a1z00_12294, BgL_sz00_12297,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14423;

							BgL_nbpz00_14423 =
								((long) CINT(BgL_bpz00_14421) + BgL_siza7eza7_12295);
							VECTOR_SET(
								((obj_t) BgL_sz00_12297), ((long) 0), BINT(BgL_nbpz00_14423));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14424;

								BgL_rz00_14424 =
									PROCEDURE_ENTRY(BgL_cfunz00_12296) (BgL_cfunz00_12296,
									BgL_a1z00_14422, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_12297), ((long) 0),
									BgL_bpz00_14421);
								return BgL_rz00_14424;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2036> */
	obj_t BGl_z62zc3z04anonymousza32036ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12298, obj_t BgL_sz00_12304)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12299;
				obj_t BgL_a1z00_12300;
				obj_t BgL_locz00_12301;
				obj_t BgL_symbzd2funzd2_12302;
				long BgL_siza7eza7_12303;

				BgL_funz00_12299 = PROCEDURE_REF(BgL_envz00_12298, (int) (((long) 0)));
				BgL_a1z00_12300 = PROCEDURE_REF(BgL_envz00_12298, (int) (((long) 1)));
				BgL_locz00_12301 = PROCEDURE_REF(BgL_envz00_12298, (int) (((long) 2)));
				BgL_symbzd2funzd2_12302 =
					PROCEDURE_REF(BgL_envz00_12298, (int) (((long) 3)));
				BgL_siza7eza7_12303 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12298, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14425;

					BgL_bpz00_14425 = VECTOR_REF(((obj_t) BgL_sz00_12304), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14426;
						obj_t BgL_a1z00_14427;

						BgL_fz00_14426 =
							PROCEDURE_ENTRY(BgL_funz00_12299) (BgL_funz00_12299,
							BgL_sz00_12304, BEOA);
						BgL_a1z00_14427 =
							PROCEDURE_ENTRY(BgL_a1z00_12300) (BgL_a1z00_12300, BgL_sz00_12304,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14426))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12301,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14426);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14428;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19063;

								BgL_tmpz00_19063 = ((obj_t) BgL_fz00_14426);
								BgL_ufz00_14428 = PROCEDURE_ATTR(BgL_tmpz00_19063);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5022z00_19066;

								if (STRUCTP(BgL_ufz00_14428))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5022z00_19066 =
											(STRUCT_KEY(BgL_ufz00_14428) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5022z00_19066 = ((bool_t) 0);
									}
								if (BgL_test5022z00_19066)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14429;
										obj_t BgL_runz00_14430;
										obj_t BgL_sfz00_14431;

										BgL_arityz00_14429 =
											STRUCT_REF(BgL_ufz00_14428, (int) (((long) 0)));
										BgL_runz00_14430 =
											STRUCT_REF(BgL_ufz00_14428, (int) (((long) 1)));
										BgL_sfz00_14431 =
											STRUCT_REF(BgL_ufz00_14428, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14429) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_arg2041z00_14432;

												BgL_arg2041z00_14432 =
													((long) CINT(BgL_bpz00_14425) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_12304), BgL_arg2041z00_14432,
													BgL_a1z00_14427);
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14429))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14429))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2043z00_14433;
																	obj_t BgL_arg2044z00_14434;

																	BgL_arg2043z00_14433 =
																		((long) CINT(BgL_bpz00_14425) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2045z00_14435;

																		BgL_list2045z00_14435 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_14427, BNIL);
																		BgL_arg2044z00_14434 =
																			BgL_list2045z00_14435;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12304),
																		BgL_arg2043z00_14433, BgL_arg2044z00_14434);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2046z00_14436;

																	BgL_arg2046z00_14436 =
																		((long) CINT(BgL_bpz00_14425) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12304),
																		BgL_arg2046z00_14436, BgL_a1z00_14427);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2047z00_14437;
																	obj_t BgL_arg2048z00_14438;

																	BgL_arg2047z00_14437 =
																		((long) CINT(BgL_bpz00_14425) + ((long) 1));
																	BgL_arg2048z00_14438 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12304),
																		BgL_arg2047z00_14437, BgL_arg2048z00_14438);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12301, STRUCT_REF(BgL_ufz00_14428,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_14429));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12301, STRUCT_REF(BgL_ufz00_14428,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_14429));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14439;

											BgL_z12denvz12_14439 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14439,
												BgL_locz00_12301);
											if ((((long) CINT(BgL_bpz00_14425) +
														(long) CINT(BgL_sfz00_14431)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12304))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14430;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14440;

													BgL_nsz00_14440 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2052z00_14441;

														BgL_arg2052z00_14441 =
															((long) CINT(BgL_bpz00_14425) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14440, ((long) 2), BgL_sz00_12304,
															BgL_bpz00_14425, BINT(BgL_arg2052z00_14441));
													}
													VECTOR_SET(BgL_nsz00_14440, ((long) 1),
														BgL_sz00_12304);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14439,
														BgL_nsz00_14440);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14442;

														BgL_ez00_14442 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14442, BgL_sz00_12304);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14443;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14444;

																BgL_savedzd2bpzd2_14444 =
																	VECTOR_REF(BgL_nsz00_14440, ((long) 0));
																VECTOR_SET(BgL_nsz00_14440, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14446;

																	BgL_fz00_14446 = BgL_runz00_14430;
																BgL_recz00_14445:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14447;

																		BgL_rz00_14447 =
																			PROCEDURE_ENTRY(BgL_fz00_14446)
																			(BgL_fz00_14446, BgL_nsz00_14440, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test5027z00_19136;

																			if (PROCEDUREP(BgL_rz00_14447))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14448;

																					BgL_arg1729z00_14448 =
																						PROCEDURE_ATTR(BgL_rz00_14447);
																					if (STRUCTP(BgL_arg1729z00_14448))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5027z00_19136 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14448) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5027z00_19136 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test5027z00_19136 = ((bool_t) 0);
																				}
																			if (BgL_test5027z00_19136)
																				{
																					obj_t BgL_fz00_19144;

																					BgL_fz00_19144 = BgL_rz00_14447;
																					BgL_fz00_14446 = BgL_fz00_19144;
																					goto BgL_recz00_14445;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14440,
																						((long) 0),
																						BgL_savedzd2bpzd2_14444);
																					BgL_____rz00_14443 = BgL_rz00_14447;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14442);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14439,
																BgL_sz00_12304);
															return BgL_____rz00_14443;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14426,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14449;

												BgL_nbpz00_14449 =
													((long) CINT(BgL_bpz00_14425) + BgL_siza7eza7_12303);
												VECTOR_SET(
													((obj_t) BgL_sz00_12304), ((long) 0),
													BINT(BgL_nbpz00_14449));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_19156;

													BgL_tmpz00_19156 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19156,
														BgL_locz00_12301);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14450;

													BgL_rz00_14450 =
														PROCEDURE_ENTRY(BgL_fz00_14426) (BgL_fz00_14426,
														BgL_a1z00_14427, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12304), ((long) 0),
														BgL_bpz00_14425);
													return BgL_rz00_14450;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12301,
													BgL_symbzd2funzd2_12302, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_14426));
		}}}}}}}}

	}



/* &<@anonymous:2057> */
	obj_t BGl_z62zc3z04anonymousza32057ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12305, obj_t BgL_sz00_12311)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12306;
				obj_t BgL_a1z00_12307;
				obj_t BgL_locz00_12308;
				obj_t BgL_symbzd2funzd2_12309;
				long BgL_siza7eza7_12310;

				BgL_funz00_12306 = PROCEDURE_REF(BgL_envz00_12305, (int) (((long) 0)));
				BgL_a1z00_12307 = PROCEDURE_REF(BgL_envz00_12305, (int) (((long) 1)));
				BgL_locz00_12308 = PROCEDURE_REF(BgL_envz00_12305, (int) (((long) 2)));
				BgL_symbzd2funzd2_12309 =
					PROCEDURE_REF(BgL_envz00_12305, (int) (((long) 3)));
				BgL_siza7eza7_12310 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12305, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14451;

					BgL_bpz00_14451 = VECTOR_REF(((obj_t) BgL_sz00_12311), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14452;
						obj_t BgL_a1z00_14453;

						BgL_fz00_14452 =
							PROCEDURE_ENTRY(BgL_funz00_12306) (BgL_funz00_12306,
							BgL_sz00_12311, BEOA);
						BgL_a1z00_14453 =
							PROCEDURE_ENTRY(BgL_a1z00_12307) (BgL_a1z00_12307, BgL_sz00_12311,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14452))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12308,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14452);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14454;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19192;

								BgL_tmpz00_19192 = ((obj_t) BgL_fz00_14452);
								BgL_ufz00_14454 = PROCEDURE_ATTR(BgL_tmpz00_19192);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5032z00_19195;

								if (STRUCTP(BgL_ufz00_14454))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5032z00_19195 =
											(STRUCT_KEY(BgL_ufz00_14454) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5032z00_19195 = ((bool_t) 0);
									}
								if (BgL_test5032z00_19195)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14455;
										obj_t BgL_runz00_14456;
										obj_t BgL_sfz00_14457;

										BgL_arityz00_14455 =
											STRUCT_REF(BgL_ufz00_14454, (int) (((long) 0)));
										BgL_runz00_14456 =
											STRUCT_REF(BgL_ufz00_14454, (int) (((long) 1)));
										BgL_sfz00_14457 =
											STRUCT_REF(BgL_ufz00_14454, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14455) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_arg2061z00_14458;

												BgL_arg2061z00_14458 =
													((long) CINT(BgL_bpz00_14451) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_12311), BgL_arg2061z00_14458,
													BgL_a1z00_14453);
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14455))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14455))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2064z00_14459;
																	obj_t BgL_arg2065z00_14460;

																	BgL_arg2064z00_14459 =
																		((long) CINT(BgL_bpz00_14451) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2066z00_14461;

																		BgL_list2066z00_14461 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_14453, BNIL);
																		BgL_arg2065z00_14460 =
																			BgL_list2066z00_14461;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12311),
																		BgL_arg2064z00_14459, BgL_arg2065z00_14460);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2067z00_14462;

																	BgL_arg2067z00_14462 =
																		((long) CINT(BgL_bpz00_14451) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12311),
																		BgL_arg2067z00_14462, BgL_a1z00_14453);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2068z00_14463;
																	obj_t BgL_arg2069z00_14464;

																	BgL_arg2068z00_14463 =
																		((long) CINT(BgL_bpz00_14451) + ((long) 1));
																	BgL_arg2069z00_14464 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12311),
																		BgL_arg2068z00_14463, BgL_arg2069z00_14464);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12308, STRUCT_REF(BgL_ufz00_14454,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_14455));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12308, STRUCT_REF(BgL_ufz00_14454,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_14455));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14465;

											BgL_z12denvz12_14465 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_14451) +
														(long) CINT(BgL_sfz00_14457)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12311))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14456;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14466;

													BgL_nsz00_14466 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2074z00_14467;

														BgL_arg2074z00_14467 =
															((long) CINT(BgL_bpz00_14451) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14466, ((long) 2), BgL_sz00_12311,
															BgL_bpz00_14451, BINT(BgL_arg2074z00_14467));
													}
													VECTOR_SET(BgL_nsz00_14466, ((long) 1),
														BgL_sz00_12311);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14465,
														BgL_nsz00_14466);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14468;

														BgL_ez00_14468 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14468, BgL_sz00_12311);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14469;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14470;

																BgL_savedzd2bpzd2_14470 =
																	VECTOR_REF(BgL_nsz00_14466, ((long) 0));
																VECTOR_SET(BgL_nsz00_14466, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14472;

																	BgL_fz00_14472 = BgL_runz00_14456;
																BgL_recz00_14471:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14473;

																		BgL_rz00_14473 =
																			PROCEDURE_ENTRY(BgL_fz00_14472)
																			(BgL_fz00_14472, BgL_nsz00_14466, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test5037z00_19264;

																			if (PROCEDUREP(BgL_rz00_14473))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14474;

																					BgL_arg1729z00_14474 =
																						PROCEDURE_ATTR(BgL_rz00_14473);
																					if (STRUCTP(BgL_arg1729z00_14474))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5037z00_19264 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14474) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5037z00_19264 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test5037z00_19264 = ((bool_t) 0);
																				}
																			if (BgL_test5037z00_19264)
																				{
																					obj_t BgL_fz00_19272;

																					BgL_fz00_19272 = BgL_rz00_14473;
																					BgL_fz00_14472 = BgL_fz00_19272;
																					goto BgL_recz00_14471;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14466,
																						((long) 0),
																						BgL_savedzd2bpzd2_14470);
																					BgL_____rz00_14469 = BgL_rz00_14473;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14468);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14465,
																BgL_sz00_12311);
															return BgL_____rz00_14469;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14452,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14475;

												BgL_nbpz00_14475 =
													((long) CINT(BgL_bpz00_14451) + BgL_siza7eza7_12310);
												VECTOR_SET(
													((obj_t) BgL_sz00_12311), ((long) 0),
													BINT(BgL_nbpz00_14475));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14476;

													BgL_rz00_14476 =
														PROCEDURE_ENTRY(BgL_fz00_14452) (BgL_fz00_14452,
														BgL_a1z00_14453, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12311), ((long) 0),
														BgL_bpz00_14451);
													return BgL_rz00_14476;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12308,
													BgL_symbzd2funzd2_12309, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_14452));
		}}}}}}}}

	}



/* &<@anonymous:2080> */
	obj_t BGl_z62zc3z04anonymousza32080ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12312, obj_t BgL_sz00_12318)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12313;
				obj_t BgL_a1z00_12314;
				obj_t BgL_locz00_12315;
				obj_t BgL_symbzd2funzd2_12316;
				long BgL_siza7eza7_12317;

				BgL_funz00_12313 = PROCEDURE_REF(BgL_envz00_12312, (int) (((long) 0)));
				BgL_a1z00_12314 = PROCEDURE_REF(BgL_envz00_12312, (int) (((long) 1)));
				BgL_locz00_12315 = PROCEDURE_REF(BgL_envz00_12312, (int) (((long) 2)));
				BgL_symbzd2funzd2_12316 =
					PROCEDURE_REF(BgL_envz00_12312, (int) (((long) 3)));
				BgL_siza7eza7_12317 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12312, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14477;

					BgL_bpz00_14477 = VECTOR_REF(((obj_t) BgL_sz00_12318), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14478;
						obj_t BgL_a1z00_14479;

						BgL_fz00_14478 =
							PROCEDURE_ENTRY(BgL_funz00_12313) (BgL_funz00_12313,
							BgL_sz00_12318, BEOA);
						BgL_a1z00_14479 =
							PROCEDURE_ENTRY(BgL_a1z00_12314) (BgL_a1z00_12314, BgL_sz00_12318,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14478))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12315,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14478);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14480;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19317;

								BgL_tmpz00_19317 = ((obj_t) BgL_fz00_14478);
								BgL_ufz00_14480 = PROCEDURE_ATTR(BgL_tmpz00_19317);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5042z00_19320;

								if (STRUCTP(BgL_ufz00_14480))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5042z00_19320 =
											(STRUCT_KEY(BgL_ufz00_14480) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5042z00_19320 = ((bool_t) 0);
									}
								if (BgL_test5042z00_19320)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14481;
										obj_t BgL_runz00_14482;
										obj_t BgL_sfz00_14483;

										BgL_arityz00_14481 =
											STRUCT_REF(BgL_ufz00_14480, (int) (((long) 0)));
										BgL_runz00_14482 =
											STRUCT_REF(BgL_ufz00_14480, (int) (((long) 1)));
										BgL_sfz00_14483 =
											STRUCT_REF(BgL_ufz00_14480, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_14484;

											BgL_spz00_14484 =
												((long) CINT(BgL_bpz00_14477) + BgL_siza7eza7_12317);
											if (((long) CINT(BgL_arityz00_14481) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2084z00_14485;

													BgL_arg2084z00_14485 = (BgL_spz00_14484 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_12318), BgL_arg2084z00_14485,
														BgL_a1z00_14479);
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_14481))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_14481))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2086z00_14486;
																		obj_t BgL_arg2087z00_14487;

																		BgL_arg2086z00_14486 =
																			(BgL_spz00_14484 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2088z00_14488;

																			BgL_list2088z00_14488 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_14479, BNIL);
																			BgL_arg2087z00_14487 =
																				BgL_list2088z00_14488;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12318),
																			BgL_arg2086z00_14486,
																			BgL_arg2087z00_14487);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2089z00_14489;

																		BgL_arg2089z00_14489 =
																			(BgL_spz00_14484 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12318),
																			BgL_arg2089z00_14489, BgL_a1z00_14479);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2090z00_14490;
																		obj_t BgL_arg2091z00_14491;

																		BgL_arg2090z00_14490 =
																			(BgL_spz00_14484 + ((long) 1));
																		BgL_arg2091z00_14491 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12318),
																			BgL_arg2090z00_14490,
																			BgL_arg2091z00_14491);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12315,
																		STRUCT_REF(BgL_ufz00_14480,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_14481));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12315, STRUCT_REF(BgL_ufz00_14480,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_14481));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_14492;

												BgL_z12denvz12_14492 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14492,
													BgL_locz00_12315);
												if (((BgL_spz00_14484 + (long) CINT(BgL_sfz00_14483)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12318))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14482, BgL_sz00_12318,
															BINT(BgL_spz00_14484));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_14493;

														BgL_nsz00_14493 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2095z00_14494;

															BgL_arg2095z00_14494 =
																(BgL_spz00_14484 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14493, ((long) 2), BgL_sz00_12318,
																BINT(BgL_spz00_14484),
																BINT(BgL_arg2095z00_14494));
														}
														VECTOR_SET(BgL_nsz00_14493, ((long) 1),
															BgL_sz00_12318);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14492,
															BgL_nsz00_14493);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_14495;

															BgL_ez00_14495 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14495, BgL_sz00_12318);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_14496;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14497;

																	BgL_savedzd2bpzd2_14497 =
																		VECTOR_REF(BgL_nsz00_14493, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14493, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14499;

																		BgL_fz00_14499 = BgL_runz00_14482;
																	BgL_recz00_14498:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14500;

																			BgL_rz00_14500 =
																				PROCEDURE_ENTRY(BgL_fz00_14499)
																				(BgL_fz00_14499, BgL_nsz00_14493, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5047z00_19389;

																				if (PROCEDUREP(BgL_rz00_14500))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14501;

																						BgL_arg1729z00_14501 =
																							PROCEDURE_ATTR(BgL_rz00_14500);
																						if (STRUCTP(BgL_arg1729z00_14501))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5047z00_19389 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14501) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5047z00_19389 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5047z00_19389 =
																							((bool_t) 0);
																					}
																				if (BgL_test5047z00_19389)
																					{
																						obj_t BgL_fz00_19397;

																						BgL_fz00_19397 = BgL_rz00_14500;
																						BgL_fz00_14499 = BgL_fz00_19397;
																						goto BgL_recz00_14498;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14493,
																							((long) 0),
																							BgL_savedzd2bpzd2_14497);
																						BgL_____rz00_14496 = BgL_rz00_14500;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14495);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14492,
																	BgL_sz00_12318);
																return BgL_____rz00_14496;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14478,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14502;

												BgL_nbpz00_14502 =
													((long) CINT(BgL_bpz00_14477) + BgL_siza7eza7_12317);
												VECTOR_SET(
													((obj_t) BgL_sz00_12318), ((long) 0),
													BINT(BgL_nbpz00_14502));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_19409;

													BgL_tmpz00_19409 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19409,
														BgL_locz00_12315);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14503;

													BgL_rz00_14503 =
														PROCEDURE_ENTRY(BgL_fz00_14478) (BgL_fz00_14478,
														BgL_a1z00_14479, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12318), ((long) 0),
														BgL_bpz00_14477);
													return BgL_rz00_14503;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12315,
													BgL_symbzd2funzd2_12316, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_14478));
		}}}}}}}}

	}



/* &<@anonymous:2099> */
	obj_t BGl_z62zc3z04anonymousza32099ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12319, obj_t BgL_sz00_12325)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12320;
				obj_t BgL_a1z00_12321;
				obj_t BgL_locz00_12322;
				obj_t BgL_symbzd2funzd2_12323;
				long BgL_siza7eza7_12324;

				BgL_funz00_12320 = PROCEDURE_REF(BgL_envz00_12319, (int) (((long) 0)));
				BgL_a1z00_12321 = PROCEDURE_REF(BgL_envz00_12319, (int) (((long) 1)));
				BgL_locz00_12322 = PROCEDURE_REF(BgL_envz00_12319, (int) (((long) 2)));
				BgL_symbzd2funzd2_12323 =
					PROCEDURE_REF(BgL_envz00_12319, (int) (((long) 3)));
				BgL_siza7eza7_12324 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12319, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14504;

					BgL_bpz00_14504 = VECTOR_REF(((obj_t) BgL_sz00_12325), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14505;
						obj_t BgL_a1z00_14506;

						BgL_fz00_14505 =
							PROCEDURE_ENTRY(BgL_funz00_12320) (BgL_funz00_12320,
							BgL_sz00_12325, BEOA);
						BgL_a1z00_14506 =
							PROCEDURE_ENTRY(BgL_a1z00_12321) (BgL_a1z00_12321, BgL_sz00_12325,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14505))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12322,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14505);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14507;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19445;

								BgL_tmpz00_19445 = ((obj_t) BgL_fz00_14505);
								BgL_ufz00_14507 = PROCEDURE_ATTR(BgL_tmpz00_19445);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5052z00_19448;

								if (STRUCTP(BgL_ufz00_14507))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5052z00_19448 =
											(STRUCT_KEY(BgL_ufz00_14507) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5052z00_19448 = ((bool_t) 0);
									}
								if (BgL_test5052z00_19448)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14508;
										obj_t BgL_runz00_14509;
										obj_t BgL_sfz00_14510;

										BgL_arityz00_14508 =
											STRUCT_REF(BgL_ufz00_14507, (int) (((long) 0)));
										BgL_runz00_14509 =
											STRUCT_REF(BgL_ufz00_14507, (int) (((long) 1)));
										BgL_sfz00_14510 =
											STRUCT_REF(BgL_ufz00_14507, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_14511;

											BgL_spz00_14511 =
												((long) CINT(BgL_bpz00_14504) + BgL_siza7eza7_12324);
											if (((long) CINT(BgL_arityz00_14508) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2103z00_14512;

													BgL_arg2103z00_14512 = (BgL_spz00_14511 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_12325), BgL_arg2103z00_14512,
														BgL_a1z00_14506);
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_14508))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_14508))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2105z00_14513;
																		obj_t BgL_arg2106z00_14514;

																		BgL_arg2105z00_14513 =
																			(BgL_spz00_14511 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2107z00_14515;

																			BgL_list2107z00_14515 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_14506, BNIL);
																			BgL_arg2106z00_14514 =
																				BgL_list2107z00_14515;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12325),
																			BgL_arg2105z00_14513,
																			BgL_arg2106z00_14514);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2108z00_14516;

																		BgL_arg2108z00_14516 =
																			(BgL_spz00_14511 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12325),
																			BgL_arg2108z00_14516, BgL_a1z00_14506);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2109z00_14517;
																		obj_t BgL_arg2110z00_14518;

																		BgL_arg2109z00_14517 =
																			(BgL_spz00_14511 + ((long) 1));
																		BgL_arg2110z00_14518 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12325),
																			BgL_arg2109z00_14517,
																			BgL_arg2110z00_14518);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12322,
																		STRUCT_REF(BgL_ufz00_14507,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_14508));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12322, STRUCT_REF(BgL_ufz00_14507,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_14508));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_14519;

												BgL_z12denvz12_14519 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_14511 +
															(long) CINT(BgL_sfz00_14510)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12325))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14509, BgL_sz00_12325,
															BINT(BgL_spz00_14511));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_14520;

														BgL_nsz00_14520 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2114z00_14521;

															BgL_arg2114z00_14521 =
																(BgL_spz00_14511 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14520, ((long) 2), BgL_sz00_12325,
																BINT(BgL_spz00_14511),
																BINT(BgL_arg2114z00_14521));
														}
														VECTOR_SET(BgL_nsz00_14520, ((long) 1),
															BgL_sz00_12325);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14519,
															BgL_nsz00_14520);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_14522;

															BgL_ez00_14522 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14522, BgL_sz00_12325);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_14523;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14524;

																	BgL_savedzd2bpzd2_14524 =
																		VECTOR_REF(BgL_nsz00_14520, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14520, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14526;

																		BgL_fz00_14526 = BgL_runz00_14509;
																	BgL_recz00_14525:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14527;

																			BgL_rz00_14527 =
																				PROCEDURE_ENTRY(BgL_fz00_14526)
																				(BgL_fz00_14526, BgL_nsz00_14520, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5057z00_19516;

																				if (PROCEDUREP(BgL_rz00_14527))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14528;

																						BgL_arg1729z00_14528 =
																							PROCEDURE_ATTR(BgL_rz00_14527);
																						if (STRUCTP(BgL_arg1729z00_14528))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5057z00_19516 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14528) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5057z00_19516 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5057z00_19516 =
																							((bool_t) 0);
																					}
																				if (BgL_test5057z00_19516)
																					{
																						obj_t BgL_fz00_19524;

																						BgL_fz00_19524 = BgL_rz00_14527;
																						BgL_fz00_14526 = BgL_fz00_19524;
																						goto BgL_recz00_14525;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14520,
																							((long) 0),
																							BgL_savedzd2bpzd2_14524);
																						BgL_____rz00_14523 = BgL_rz00_14527;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14522);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14519,
																	BgL_sz00_12325);
																return BgL_____rz00_14523;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14505,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14529;

												BgL_nbpz00_14529 =
													((long) CINT(BgL_bpz00_14504) + BgL_siza7eza7_12324);
												VECTOR_SET(
													((obj_t) BgL_sz00_12325), ((long) 0),
													BINT(BgL_nbpz00_14529));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14530;

													BgL_rz00_14530 =
														PROCEDURE_ENTRY(BgL_fz00_14505) (BgL_fz00_14505,
														BgL_a1z00_14506, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12325), ((long) 0),
														BgL_bpz00_14504);
													return BgL_rz00_14530;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12322,
													BgL_symbzd2funzd2_12323, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_14505));
		}}}}}}}}

	}



/* comp-call2 */
	obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153,
		BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155,
		obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158,
		long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2290;

				BgL_cfunz00_2290 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154,
					((long) 2), BgL_locz00_153, BgL_symbzd2funzd2_155);
				if (CBOOL(BgL_cfunz00_2290))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test5062z00_19548;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2123z00_2308;

							BgL_arg2123z00_2308 = bgl_debug();
							BgL_test5062z00_19548 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2123z00_2308),
								BINT(((long) 0)));
						}
						if (BgL_test5062z00_19548)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32120ze3z87_12326;

								BgL_zc3z04anonymousza32120ze3z87_12326 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32120ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_12326,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_12326,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_12326,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_12326,
									(int) (((long) 3)), BgL_locz00_153);
								PROCEDURE_SET(BgL_zc3z04anonymousza32120ze3z87_12326,
									(int) (((long) 4)), BgL_cfunz00_2290);
								return BgL_zc3z04anonymousza32120ze3z87_12326;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32122ze3z87_12327;

								BgL_zc3z04anonymousza32122ze3z87_12327 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32122ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32122ze3z87_12327,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3z04anonymousza32122ze3z87_12327,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3z04anonymousza32122ze3z87_12327,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3z04anonymousza32122ze3z87_12327,
									(int) (((long) 3)), BgL_cfunz00_2290);
								return BgL_zc3z04anonymousza32122ze3z87_12327;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_157))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5064z00_19581;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2183z00_2400;

									BgL_arg2183z00_2400 = bgl_debug();
									BgL_test5064z00_19581 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2183z00_2400),
										BINT(((long) 0)));
								}
								if (BgL_test5064z00_19581)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32127ze3z87_12328;

										BgL_zc3z04anonymousza32127ze3z87_12328 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32127ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32127ze3z87_12328,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32127ze3z87_12328,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32127ze3z87_12328,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32127ze3z87_12328,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32127ze3z87_12328,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32127ze3z87_12328,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32127ze3z87_12328;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32156ze3z87_12329;

										BgL_zc3z04anonymousza32156ze3z87_12329 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32156ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_12329,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_12329,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_12329,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_12329,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_12329,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_12329,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32156ze3z87_12329;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5065z00_19618;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2237z00_2492;

									BgL_arg2237z00_2492 = bgl_debug();
									BgL_test5065z00_19618 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2237z00_2492),
										BINT(((long) 0)));
								}
								if (BgL_test5065z00_19618)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32186ze3z87_12330;

										BgL_zc3z04anonymousza32186ze3z87_12330 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_12330,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_12330,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_12330,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_12330,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_12330,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_12330,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32186ze3z87_12330;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32212ze3z87_12331;

										BgL_zc3z04anonymousza32212ze3z87_12331 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32212ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32212ze3z87_12331,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32212ze3z87_12331,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32212ze3z87_12331,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32212ze3z87_12331,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32212ze3z87_12331,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32212ze3z87_12331,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32212ze3z87_12331;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2120> */
	obj_t BGl_z62zc3z04anonymousza32120ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12332, obj_t BgL_sz00_12338)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_12333;
				obj_t BgL_a2z00_12334;
				long BgL_siza7eza7_12335;
				obj_t BgL_locz00_12336;
				obj_t BgL_cfunz00_12337;

				BgL_a1z00_12333 = PROCEDURE_REF(BgL_envz00_12332, (int) (((long) 0)));
				BgL_a2z00_12334 = PROCEDURE_REF(BgL_envz00_12332, (int) (((long) 1)));
				BgL_siza7eza7_12335 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12332, (int) (((long) 2))));
				BgL_locz00_12336 = PROCEDURE_REF(BgL_envz00_12332, (int) (((long) 3)));
				BgL_cfunz00_12337 = PROCEDURE_REF(BgL_envz00_12332, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14531;

					BgL_bpz00_14531 = VECTOR_REF(((obj_t) BgL_sz00_12338), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_14532;
						obj_t BgL_a2z00_14533;

						BgL_a1z00_14532 =
							PROCEDURE_ENTRY(BgL_a1z00_12333) (BgL_a1z00_12333, BgL_sz00_12338,
							BEOA);
						BgL_a2z00_14533 =
							PROCEDURE_ENTRY(BgL_a2z00_12334) (BgL_a2z00_12334, BgL_sz00_12338,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14534;

							BgL_nbpz00_14534 =
								((long) CINT(BgL_bpz00_14531) + BgL_siza7eza7_12335);
							VECTOR_SET(
								((obj_t) BgL_sz00_12338), ((long) 0), BINT(BgL_nbpz00_14534));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19681;

								BgL_tmpz00_19681 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19681, BgL_locz00_12336);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14535;

								BgL_rz00_14535 =
									PROCEDURE_ENTRY(BgL_cfunz00_12337) (BgL_cfunz00_12337,
									BgL_a1z00_14532, BgL_a2z00_14533, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_12338), ((long) 0),
									BgL_bpz00_14531);
								return BgL_rz00_14535;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2122> */
	obj_t BGl_z62zc3z04anonymousza32122ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12339, obj_t BgL_sz00_12344)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_12340;
				obj_t BgL_a2z00_12341;
				long BgL_siza7eza7_12342;
				obj_t BgL_cfunz00_12343;

				BgL_a1z00_12340 = PROCEDURE_REF(BgL_envz00_12339, (int) (((long) 0)));
				BgL_a2z00_12341 = PROCEDURE_REF(BgL_envz00_12339, (int) (((long) 1)));
				BgL_siza7eza7_12342 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12339, (int) (((long) 2))));
				BgL_cfunz00_12343 = PROCEDURE_REF(BgL_envz00_12339, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14536;

					BgL_bpz00_14536 = VECTOR_REF(((obj_t) BgL_sz00_12344), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_14537;
						obj_t BgL_a2z00_14538;

						BgL_a1z00_14537 =
							PROCEDURE_ENTRY(BgL_a1z00_12340) (BgL_a1z00_12340, BgL_sz00_12344,
							BEOA);
						BgL_a2z00_14538 =
							PROCEDURE_ENTRY(BgL_a2z00_12341) (BgL_a2z00_12341, BgL_sz00_12344,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14539;

							BgL_nbpz00_14539 =
								((long) CINT(BgL_bpz00_14536) + BgL_siza7eza7_12342);
							VECTOR_SET(
								((obj_t) BgL_sz00_12344), ((long) 0), BINT(BgL_nbpz00_14539));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14540;

								BgL_rz00_14540 =
									PROCEDURE_ENTRY(BgL_cfunz00_12343) (BgL_cfunz00_12343,
									BgL_a1z00_14537, BgL_a2z00_14538, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_12344), ((long) 0),
									BgL_bpz00_14536);
								return BgL_rz00_14540;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2127> */
	obj_t BGl_z62zc3z04anonymousza32127ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12345, obj_t BgL_sz00_12352)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12346;
				obj_t BgL_a1z00_12347;
				obj_t BgL_a2z00_12348;
				obj_t BgL_locz00_12349;
				obj_t BgL_symbzd2funzd2_12350;
				long BgL_siza7eza7_12351;

				BgL_funz00_12346 = PROCEDURE_REF(BgL_envz00_12345, (int) (((long) 0)));
				BgL_a1z00_12347 = PROCEDURE_REF(BgL_envz00_12345, (int) (((long) 1)));
				BgL_a2z00_12348 = PROCEDURE_REF(BgL_envz00_12345, (int) (((long) 2)));
				BgL_locz00_12349 = PROCEDURE_REF(BgL_envz00_12345, (int) (((long) 3)));
				BgL_symbzd2funzd2_12350 =
					PROCEDURE_REF(BgL_envz00_12345, (int) (((long) 4)));
				BgL_siza7eza7_12351 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12345, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14541;

					BgL_bpz00_14541 = VECTOR_REF(((obj_t) BgL_sz00_12352), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14542;
						obj_t BgL_a1z00_14543;
						obj_t BgL_a2z00_14544;

						BgL_fz00_14542 =
							PROCEDURE_ENTRY(BgL_funz00_12346) (BgL_funz00_12346,
							BgL_sz00_12352, BEOA);
						BgL_a1z00_14543 =
							PROCEDURE_ENTRY(BgL_a1z00_12347) (BgL_a1z00_12347, BgL_sz00_12352,
							BEOA);
						BgL_a2z00_14544 =
							PROCEDURE_ENTRY(BgL_a2z00_12348) (BgL_a2z00_12348, BgL_sz00_12352,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14542))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12349,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14542);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14545;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19752;

								BgL_tmpz00_19752 = ((obj_t) BgL_fz00_14542);
								BgL_ufz00_14545 = PROCEDURE_ATTR(BgL_tmpz00_19752);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5067z00_19755;

								if (STRUCTP(BgL_ufz00_14545))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5067z00_19755 =
											(STRUCT_KEY(BgL_ufz00_14545) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5067z00_19755 = ((bool_t) 0);
									}
								if (BgL_test5067z00_19755)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14546;
										obj_t BgL_runz00_14547;
										obj_t BgL_sfz00_14548;

										BgL_arityz00_14546 =
											STRUCT_REF(BgL_ufz00_14545, (int) (((long) 0)));
										BgL_runz00_14547 =
											STRUCT_REF(BgL_ufz00_14545, (int) (((long) 1)));
										BgL_sfz00_14548 =
											STRUCT_REF(BgL_ufz00_14545, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14546) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2131z00_14549;

													BgL_arg2131z00_14549 =
														((long) CINT(BgL_bpz00_14541) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_12352), BgL_arg2131z00_14549,
														BgL_a1z00_14543);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2132z00_14550;

													BgL_arg2132z00_14550 =
														((long) CINT(BgL_bpz00_14541) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_12352), BgL_arg2132z00_14550,
														BgL_a2z00_14544);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14546))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14546))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2135z00_14551;
																	obj_t BgL_arg2136z00_14552;

																	BgL_arg2135z00_14551 =
																		((long) CINT(BgL_bpz00_14541) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2137z00_14553;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2138z00_14554;

																			BgL_arg2138z00_14554 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_14544, BNIL);
																			BgL_list2137z00_14553 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_14543,
																				BgL_arg2138z00_14554);
																		}
																		BgL_arg2136z00_14552 =
																			BgL_list2137z00_14553;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12352),
																		BgL_arg2135z00_14551, BgL_arg2136z00_14552);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2141z00_14555;

																	BgL_arg2141z00_14555 =
																		((long) CINT(BgL_bpz00_14541) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12352),
																		BgL_arg2141z00_14555, BgL_a1z00_14543);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2142z00_14556;
																	obj_t BgL_arg2143z00_14557;

																	BgL_arg2142z00_14556 =
																		((long) CINT(BgL_bpz00_14541) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2144z00_14558;

																		BgL_list2144z00_14558 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_14544, BNIL);
																		BgL_arg2143z00_14557 =
																			BgL_list2144z00_14558;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12352),
																		BgL_arg2142z00_14556, BgL_arg2143z00_14557);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2145z00_14559;

																	BgL_arg2145z00_14559 =
																		((long) CINT(BgL_bpz00_14541) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12352),
																		BgL_arg2145z00_14559, BgL_a1z00_14543);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2146z00_14560;

																	BgL_arg2146z00_14560 =
																		((long) CINT(BgL_bpz00_14541) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12352),
																		BgL_arg2146z00_14560, BgL_a2z00_14544);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2147z00_14561;
																	obj_t BgL_arg2148z00_14562;

																	BgL_arg2147z00_14561 =
																		((long) CINT(BgL_bpz00_14541) + ((long) 2));
																	BgL_arg2148z00_14562 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12352),
																		BgL_arg2147z00_14561, BgL_arg2148z00_14562);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12349, STRUCT_REF(BgL_ufz00_14545,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_14546));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12349, STRUCT_REF(BgL_ufz00_14545,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_14546));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14563;

											BgL_z12denvz12_14563 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14563,
												BgL_locz00_12349);
											if ((((long) CINT(BgL_bpz00_14541) +
														(long) CINT(BgL_sfz00_14548)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12352))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14547;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14564;

													BgL_nsz00_14564 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2152z00_14565;

														BgL_arg2152z00_14565 =
															((long) CINT(BgL_bpz00_14541) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14564, ((long) 2), BgL_sz00_12352,
															BgL_bpz00_14541, BINT(BgL_arg2152z00_14565));
													}
													VECTOR_SET(BgL_nsz00_14564, ((long) 1),
														BgL_sz00_12352);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14563,
														BgL_nsz00_14564);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14566;

														BgL_ez00_14566 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14566, BgL_sz00_12352);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14567;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14568;

																BgL_savedzd2bpzd2_14568 =
																	VECTOR_REF(BgL_nsz00_14564, ((long) 0));
																VECTOR_SET(BgL_nsz00_14564, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14570;

																	BgL_fz00_14570 = BgL_runz00_14547;
																BgL_recz00_14569:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14571;

																		BgL_rz00_14571 =
																			PROCEDURE_ENTRY(BgL_fz00_14570)
																			(BgL_fz00_14570, BgL_nsz00_14564, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test5072z00_19843;

																			if (PROCEDUREP(BgL_rz00_14571))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14572;

																					BgL_arg1729z00_14572 =
																						PROCEDURE_ATTR(BgL_rz00_14571);
																					if (STRUCTP(BgL_arg1729z00_14572))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5072z00_19843 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14572) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5072z00_19843 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test5072z00_19843 = ((bool_t) 0);
																				}
																			if (BgL_test5072z00_19843)
																				{
																					obj_t BgL_fz00_19851;

																					BgL_fz00_19851 = BgL_rz00_14571;
																					BgL_fz00_14570 = BgL_fz00_19851;
																					goto BgL_recz00_14569;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14564,
																						((long) 0),
																						BgL_savedzd2bpzd2_14568);
																					BgL_____rz00_14567 = BgL_rz00_14571;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14566);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14563,
																BgL_sz00_12352);
															return BgL_____rz00_14567;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14542,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14573;

												BgL_nbpz00_14573 =
													((long) CINT(BgL_bpz00_14541) + BgL_siza7eza7_12351);
												VECTOR_SET(
													((obj_t) BgL_sz00_12352), ((long) 0),
													BINT(BgL_nbpz00_14573));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_19863;

													BgL_tmpz00_19863 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19863,
														BgL_locz00_12349);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14574;

													BgL_rz00_14574 =
														PROCEDURE_ENTRY(BgL_fz00_14542) (BgL_fz00_14542,
														BgL_a1z00_14543, BgL_a2z00_14544, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12352), ((long) 0),
														BgL_bpz00_14541);
													return BgL_rz00_14574;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12349,
													BgL_symbzd2funzd2_12350, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_14542));
		}}}}}}}}

	}



/* &<@anonymous:2156> */
	obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12353, obj_t BgL_sz00_12360)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12354;
				obj_t BgL_a1z00_12355;
				obj_t BgL_a2z00_12356;
				obj_t BgL_locz00_12357;
				obj_t BgL_symbzd2funzd2_12358;
				long BgL_siza7eza7_12359;

				BgL_funz00_12354 = PROCEDURE_REF(BgL_envz00_12353, (int) (((long) 0)));
				BgL_a1z00_12355 = PROCEDURE_REF(BgL_envz00_12353, (int) (((long) 1)));
				BgL_a2z00_12356 = PROCEDURE_REF(BgL_envz00_12353, (int) (((long) 2)));
				BgL_locz00_12357 = PROCEDURE_REF(BgL_envz00_12353, (int) (((long) 3)));
				BgL_symbzd2funzd2_12358 =
					PROCEDURE_REF(BgL_envz00_12353, (int) (((long) 4)));
				BgL_siza7eza7_12359 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12353, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14575;

					BgL_bpz00_14575 = VECTOR_REF(((obj_t) BgL_sz00_12360), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14576;
						obj_t BgL_a1z00_14577;
						obj_t BgL_a2z00_14578;

						BgL_fz00_14576 =
							PROCEDURE_ENTRY(BgL_funz00_12354) (BgL_funz00_12354,
							BgL_sz00_12360, BEOA);
						BgL_a1z00_14577 =
							PROCEDURE_ENTRY(BgL_a1z00_12355) (BgL_a1z00_12355, BgL_sz00_12360,
							BEOA);
						BgL_a2z00_14578 =
							PROCEDURE_ENTRY(BgL_a2z00_12356) (BgL_a2z00_12356, BgL_sz00_12360,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14576))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12357,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14576);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14579;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19906;

								BgL_tmpz00_19906 = ((obj_t) BgL_fz00_14576);
								BgL_ufz00_14579 = PROCEDURE_ATTR(BgL_tmpz00_19906);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5077z00_19909;

								if (STRUCTP(BgL_ufz00_14579))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5077z00_19909 =
											(STRUCT_KEY(BgL_ufz00_14579) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5077z00_19909 = ((bool_t) 0);
									}
								if (BgL_test5077z00_19909)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14580;
										obj_t BgL_runz00_14581;
										obj_t BgL_sfz00_14582;

										BgL_arityz00_14580 =
											STRUCT_REF(BgL_ufz00_14579, (int) (((long) 0)));
										BgL_runz00_14581 =
											STRUCT_REF(BgL_ufz00_14579, (int) (((long) 1)));
										BgL_sfz00_14582 =
											STRUCT_REF(BgL_ufz00_14579, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14580) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2160z00_14583;

													BgL_arg2160z00_14583 =
														((long) CINT(BgL_bpz00_14575) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_12360), BgL_arg2160z00_14583,
														BgL_a1z00_14577);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2161z00_14584;

													BgL_arg2161z00_14584 =
														((long) CINT(BgL_bpz00_14575) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_12360), BgL_arg2161z00_14584,
														BgL_a2z00_14578);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14580))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14580))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2163z00_14585;
																	obj_t BgL_arg2164z00_14586;

																	BgL_arg2163z00_14585 =
																		((long) CINT(BgL_bpz00_14575) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2165z00_14587;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2166z00_14588;

																			BgL_arg2166z00_14588 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_14578, BNIL);
																			BgL_list2165z00_14587 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_14577,
																				BgL_arg2166z00_14588);
																		}
																		BgL_arg2164z00_14586 =
																			BgL_list2165z00_14587;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12360),
																		BgL_arg2163z00_14585, BgL_arg2164z00_14586);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2167z00_14589;

																	BgL_arg2167z00_14589 =
																		((long) CINT(BgL_bpz00_14575) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12360),
																		BgL_arg2167z00_14589, BgL_a1z00_14577);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2169z00_14590;
																	obj_t BgL_arg2170z00_14591;

																	BgL_arg2169z00_14590 =
																		((long) CINT(BgL_bpz00_14575) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2171z00_14592;

																		BgL_list2171z00_14592 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_14578, BNIL);
																		BgL_arg2170z00_14591 =
																			BgL_list2171z00_14592;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12360),
																		BgL_arg2169z00_14590, BgL_arg2170z00_14591);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2172z00_14593;

																	BgL_arg2172z00_14593 =
																		((long) CINT(BgL_bpz00_14575) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12360),
																		BgL_arg2172z00_14593, BgL_a1z00_14577);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2173z00_14594;

																	BgL_arg2173z00_14594 =
																		((long) CINT(BgL_bpz00_14575) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12360),
																		BgL_arg2173z00_14594, BgL_a2z00_14578);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2174z00_14595;
																	obj_t BgL_arg2175z00_14596;

																	BgL_arg2174z00_14595 =
																		((long) CINT(BgL_bpz00_14575) + ((long) 2));
																	BgL_arg2175z00_14596 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12360),
																		BgL_arg2174z00_14595, BgL_arg2175z00_14596);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12357, STRUCT_REF(BgL_ufz00_14579,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_14580));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12357, STRUCT_REF(BgL_ufz00_14579,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_14580));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14597;

											BgL_z12denvz12_14597 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_14575) +
														(long) CINT(BgL_sfz00_14582)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12360))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14581;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14598;

													BgL_nsz00_14598 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2179z00_14599;

														BgL_arg2179z00_14599 =
															((long) CINT(BgL_bpz00_14575) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14598, ((long) 2), BgL_sz00_12360,
															BgL_bpz00_14575, BINT(BgL_arg2179z00_14599));
													}
													VECTOR_SET(BgL_nsz00_14598, ((long) 1),
														BgL_sz00_12360);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14597,
														BgL_nsz00_14598);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14600;

														BgL_ez00_14600 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14600, BgL_sz00_12360);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14601;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14602;

																BgL_savedzd2bpzd2_14602 =
																	VECTOR_REF(BgL_nsz00_14598, ((long) 0));
																VECTOR_SET(BgL_nsz00_14598, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14604;

																	BgL_fz00_14604 = BgL_runz00_14581;
																BgL_recz00_14603:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14605;

																		BgL_rz00_14605 =
																			PROCEDURE_ENTRY(BgL_fz00_14604)
																			(BgL_fz00_14604, BgL_nsz00_14598, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test5082z00_19996;

																			if (PROCEDUREP(BgL_rz00_14605))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14606;

																					BgL_arg1729z00_14606 =
																						PROCEDURE_ATTR(BgL_rz00_14605);
																					if (STRUCTP(BgL_arg1729z00_14606))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5082z00_19996 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14606) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5082z00_19996 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test5082z00_19996 = ((bool_t) 0);
																				}
																			if (BgL_test5082z00_19996)
																				{
																					obj_t BgL_fz00_20004;

																					BgL_fz00_20004 = BgL_rz00_14605;
																					BgL_fz00_14604 = BgL_fz00_20004;
																					goto BgL_recz00_14603;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14598,
																						((long) 0),
																						BgL_savedzd2bpzd2_14602);
																					BgL_____rz00_14601 = BgL_rz00_14605;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14600);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14597,
																BgL_sz00_12360);
															return BgL_____rz00_14601;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14576,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14607;

												BgL_nbpz00_14607 =
													((long) CINT(BgL_bpz00_14575) + BgL_siza7eza7_12359);
												VECTOR_SET(
													((obj_t) BgL_sz00_12360), ((long) 0),
													BINT(BgL_nbpz00_14607));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14608;

													BgL_rz00_14608 =
														PROCEDURE_ENTRY(BgL_fz00_14576) (BgL_fz00_14576,
														BgL_a1z00_14577, BgL_a2z00_14578, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12360), ((long) 0),
														BgL_bpz00_14575);
													return BgL_rz00_14608;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12357,
													BgL_symbzd2funzd2_12358, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_14576));
		}}}}}}}}

	}



/* &<@anonymous:2186> */
	obj_t BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12361, obj_t BgL_sz00_12368)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12362;
				obj_t BgL_a1z00_12363;
				obj_t BgL_a2z00_12364;
				obj_t BgL_locz00_12365;
				obj_t BgL_symbzd2funzd2_12366;
				long BgL_siza7eza7_12367;

				BgL_funz00_12362 = PROCEDURE_REF(BgL_envz00_12361, (int) (((long) 0)));
				BgL_a1z00_12363 = PROCEDURE_REF(BgL_envz00_12361, (int) (((long) 1)));
				BgL_a2z00_12364 = PROCEDURE_REF(BgL_envz00_12361, (int) (((long) 2)));
				BgL_locz00_12365 = PROCEDURE_REF(BgL_envz00_12361, (int) (((long) 3)));
				BgL_symbzd2funzd2_12366 =
					PROCEDURE_REF(BgL_envz00_12361, (int) (((long) 4)));
				BgL_siza7eza7_12367 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12361, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14609;

					BgL_bpz00_14609 = VECTOR_REF(((obj_t) BgL_sz00_12368), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14610;
						obj_t BgL_a1z00_14611;
						obj_t BgL_a2z00_14612;

						BgL_fz00_14610 =
							PROCEDURE_ENTRY(BgL_funz00_12362) (BgL_funz00_12362,
							BgL_sz00_12368, BEOA);
						BgL_a1z00_14611 =
							PROCEDURE_ENTRY(BgL_a1z00_12363) (BgL_a1z00_12363, BgL_sz00_12368,
							BEOA);
						BgL_a2z00_14612 =
							PROCEDURE_ENTRY(BgL_a2z00_12364) (BgL_a2z00_12364, BgL_sz00_12368,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14610))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12365,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14610);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14613;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20056;

								BgL_tmpz00_20056 = ((obj_t) BgL_fz00_14610);
								BgL_ufz00_14613 = PROCEDURE_ATTR(BgL_tmpz00_20056);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5087z00_20059;

								if (STRUCTP(BgL_ufz00_14613))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5087z00_20059 =
											(STRUCT_KEY(BgL_ufz00_14613) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5087z00_20059 = ((bool_t) 0);
									}
								if (BgL_test5087z00_20059)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14614;
										obj_t BgL_runz00_14615;
										obj_t BgL_sfz00_14616;

										BgL_arityz00_14614 =
											STRUCT_REF(BgL_ufz00_14613, (int) (((long) 0)));
										BgL_runz00_14615 =
											STRUCT_REF(BgL_ufz00_14613, (int) (((long) 1)));
										BgL_sfz00_14616 =
											STRUCT_REF(BgL_ufz00_14613, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_14617;

											BgL_spz00_14617 =
												((long) CINT(BgL_bpz00_14609) + BgL_siza7eza7_12367);
											if (((long) CINT(BgL_arityz00_14614) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2190z00_14618;

														BgL_arg2190z00_14618 =
															(BgL_spz00_14617 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_12368), BgL_arg2190z00_14618,
															BgL_a1z00_14611);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2191z00_14619;

														BgL_arg2191z00_14619 =
															(BgL_spz00_14617 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_12368), BgL_arg2191z00_14619,
															BgL_a2z00_14612);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_14614))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_14614))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2193z00_14620;
																		obj_t BgL_arg2194z00_14621;

																		BgL_arg2193z00_14620 =
																			(BgL_spz00_14617 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2195z00_14622;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2196z00_14623;

																				BgL_arg2196z00_14623 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14612,
																					BNIL);
																				BgL_list2195z00_14622 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_14611,
																					BgL_arg2196z00_14623);
																			}
																			BgL_arg2194z00_14621 =
																				BgL_list2195z00_14622;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12368),
																			BgL_arg2193z00_14620,
																			BgL_arg2194z00_14621);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2197z00_14624;

																		BgL_arg2197z00_14624 =
																			(BgL_spz00_14617 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12368),
																			BgL_arg2197z00_14624, BgL_a1z00_14611);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2198z00_14625;
																		obj_t BgL_arg2199z00_14626;

																		BgL_arg2198z00_14625 =
																			(BgL_spz00_14617 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2200z00_14627;

																			BgL_list2200z00_14627 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_14612, BNIL);
																			BgL_arg2199z00_14626 =
																				BgL_list2200z00_14627;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12368),
																			BgL_arg2198z00_14625,
																			BgL_arg2199z00_14626);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2201z00_14628;

																		BgL_arg2201z00_14628 =
																			(BgL_spz00_14617 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12368),
																			BgL_arg2201z00_14628, BgL_a1z00_14611);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2202z00_14629;

																		BgL_arg2202z00_14629 =
																			(BgL_spz00_14617 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12368),
																			BgL_arg2202z00_14629, BgL_a2z00_14612);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2203z00_14630;
																		obj_t BgL_arg2204z00_14631;

																		BgL_arg2203z00_14630 =
																			(BgL_spz00_14617 + ((long) 2));
																		BgL_arg2204z00_14631 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12368),
																			BgL_arg2203z00_14630,
																			BgL_arg2204z00_14631);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12365,
																		STRUCT_REF(BgL_ufz00_14613,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_14614));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12365, STRUCT_REF(BgL_ufz00_14613,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_14614));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_14632;

												BgL_z12denvz12_14632 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14632,
													BgL_locz00_12365);
												if (((BgL_spz00_14617 + (long) CINT(BgL_sfz00_14616)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12368))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14615, BgL_sz00_12368,
															BINT(BgL_spz00_14617));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_14633;

														BgL_nsz00_14633 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2208z00_14634;

															BgL_arg2208z00_14634 =
																(BgL_spz00_14617 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14633, ((long) 2), BgL_sz00_12368,
																BINT(BgL_spz00_14617),
																BINT(BgL_arg2208z00_14634));
														}
														VECTOR_SET(BgL_nsz00_14633, ((long) 1),
															BgL_sz00_12368);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14632,
															BgL_nsz00_14633);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_14635;

															BgL_ez00_14635 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14635, BgL_sz00_12368);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_14636;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14637;

																	BgL_savedzd2bpzd2_14637 =
																		VECTOR_REF(BgL_nsz00_14633, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14633, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14639;

																		BgL_fz00_14639 = BgL_runz00_14615;
																	BgL_recz00_14638:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14640;

																			BgL_rz00_14640 =
																				PROCEDURE_ENTRY(BgL_fz00_14639)
																				(BgL_fz00_14639, BgL_nsz00_14633, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5092z00_20142;

																				if (PROCEDUREP(BgL_rz00_14640))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14641;

																						BgL_arg1729z00_14641 =
																							PROCEDURE_ATTR(BgL_rz00_14640);
																						if (STRUCTP(BgL_arg1729z00_14641))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5092z00_20142 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14641) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5092z00_20142 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5092z00_20142 =
																							((bool_t) 0);
																					}
																				if (BgL_test5092z00_20142)
																					{
																						obj_t BgL_fz00_20150;

																						BgL_fz00_20150 = BgL_rz00_14640;
																						BgL_fz00_14639 = BgL_fz00_20150;
																						goto BgL_recz00_14638;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14633,
																							((long) 0),
																							BgL_savedzd2bpzd2_14637);
																						BgL_____rz00_14636 = BgL_rz00_14640;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14635);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14632,
																	BgL_sz00_12368);
																return BgL_____rz00_14636;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14610,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14642;

												BgL_nbpz00_14642 =
													((long) CINT(BgL_bpz00_14609) + BgL_siza7eza7_12367);
												VECTOR_SET(
													((obj_t) BgL_sz00_12368), ((long) 0),
													BINT(BgL_nbpz00_14642));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_20162;

													BgL_tmpz00_20162 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20162,
														BgL_locz00_12365);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14643;

													BgL_rz00_14643 =
														PROCEDURE_ENTRY(BgL_fz00_14610) (BgL_fz00_14610,
														BgL_a1z00_14611, BgL_a2z00_14612, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12368), ((long) 0),
														BgL_bpz00_14609);
													return BgL_rz00_14643;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12365,
													BgL_symbzd2funzd2_12366, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_14610));
		}}}}}}}}

	}



/* &<@anonymous:2212> */
	obj_t BGl_z62zc3z04anonymousza32212ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12369, obj_t BgL_sz00_12376)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12370;
				obj_t BgL_a1z00_12371;
				obj_t BgL_a2z00_12372;
				obj_t BgL_locz00_12373;
				obj_t BgL_symbzd2funzd2_12374;
				long BgL_siza7eza7_12375;

				BgL_funz00_12370 = PROCEDURE_REF(BgL_envz00_12369, (int) (((long) 0)));
				BgL_a1z00_12371 = PROCEDURE_REF(BgL_envz00_12369, (int) (((long) 1)));
				BgL_a2z00_12372 = PROCEDURE_REF(BgL_envz00_12369, (int) (((long) 2)));
				BgL_locz00_12373 = PROCEDURE_REF(BgL_envz00_12369, (int) (((long) 3)));
				BgL_symbzd2funzd2_12374 =
					PROCEDURE_REF(BgL_envz00_12369, (int) (((long) 4)));
				BgL_siza7eza7_12375 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12369, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14644;

					BgL_bpz00_14644 = VECTOR_REF(((obj_t) BgL_sz00_12376), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14645;
						obj_t BgL_a1z00_14646;
						obj_t BgL_a2z00_14647;

						BgL_fz00_14645 =
							PROCEDURE_ENTRY(BgL_funz00_12370) (BgL_funz00_12370,
							BgL_sz00_12376, BEOA);
						BgL_a1z00_14646 =
							PROCEDURE_ENTRY(BgL_a1z00_12371) (BgL_a1z00_12371, BgL_sz00_12376,
							BEOA);
						BgL_a2z00_14647 =
							PROCEDURE_ENTRY(BgL_a2z00_12372) (BgL_a2z00_12372, BgL_sz00_12376,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14645))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12373,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14645);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14648;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20205;

								BgL_tmpz00_20205 = ((obj_t) BgL_fz00_14645);
								BgL_ufz00_14648 = PROCEDURE_ATTR(BgL_tmpz00_20205);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5097z00_20208;

								if (STRUCTP(BgL_ufz00_14648))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5097z00_20208 =
											(STRUCT_KEY(BgL_ufz00_14648) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5097z00_20208 = ((bool_t) 0);
									}
								if (BgL_test5097z00_20208)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14649;
										obj_t BgL_runz00_14650;
										obj_t BgL_sfz00_14651;

										BgL_arityz00_14649 =
											STRUCT_REF(BgL_ufz00_14648, (int) (((long) 0)));
										BgL_runz00_14650 =
											STRUCT_REF(BgL_ufz00_14648, (int) (((long) 1)));
										BgL_sfz00_14651 =
											STRUCT_REF(BgL_ufz00_14648, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_14652;

											BgL_spz00_14652 =
												((long) CINT(BgL_bpz00_14644) + BgL_siza7eza7_12375);
											if (((long) CINT(BgL_arityz00_14649) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2216z00_14653;

														BgL_arg2216z00_14653 =
															(BgL_spz00_14652 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_12376), BgL_arg2216z00_14653,
															BgL_a1z00_14646);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2217z00_14654;

														BgL_arg2217z00_14654 =
															(BgL_spz00_14652 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_12376), BgL_arg2217z00_14654,
															BgL_a2z00_14647);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_14649))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_14649))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2219z00_14655;
																		obj_t BgL_arg2220z00_14656;

																		BgL_arg2219z00_14655 =
																			(BgL_spz00_14652 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2221z00_14657;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2222z00_14658;

																				BgL_arg2222z00_14658 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14647,
																					BNIL);
																				BgL_list2221z00_14657 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_14646,
																					BgL_arg2222z00_14658);
																			}
																			BgL_arg2220z00_14656 =
																				BgL_list2221z00_14657;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12376),
																			BgL_arg2219z00_14655,
																			BgL_arg2220z00_14656);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2223z00_14659;

																		BgL_arg2223z00_14659 =
																			(BgL_spz00_14652 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12376),
																			BgL_arg2223z00_14659, BgL_a1z00_14646);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2224z00_14660;
																		obj_t BgL_arg2225z00_14661;

																		BgL_arg2224z00_14660 =
																			(BgL_spz00_14652 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2226z00_14662;

																			BgL_list2226z00_14662 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_14647, BNIL);
																			BgL_arg2225z00_14661 =
																				BgL_list2226z00_14662;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12376),
																			BgL_arg2224z00_14660,
																			BgL_arg2225z00_14661);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2227z00_14663;

																		BgL_arg2227z00_14663 =
																			(BgL_spz00_14652 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12376),
																			BgL_arg2227z00_14663, BgL_a1z00_14646);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2228z00_14664;

																		BgL_arg2228z00_14664 =
																			(BgL_spz00_14652 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12376),
																			BgL_arg2228z00_14664, BgL_a2z00_14647);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2229z00_14665;
																		obj_t BgL_arg2230z00_14666;

																		BgL_arg2229z00_14665 =
																			(BgL_spz00_14652 + ((long) 2));
																		BgL_arg2230z00_14666 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12376),
																			BgL_arg2229z00_14665,
																			BgL_arg2230z00_14666);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12373,
																		STRUCT_REF(BgL_ufz00_14648,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_14649));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12373, STRUCT_REF(BgL_ufz00_14648,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_14649));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_14667;

												BgL_z12denvz12_14667 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_14652 +
															(long) CINT(BgL_sfz00_14651)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12376))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14650, BgL_sz00_12376,
															BINT(BgL_spz00_14652));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_14668;

														BgL_nsz00_14668 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2234z00_14669;

															BgL_arg2234z00_14669 =
																(BgL_spz00_14652 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14668, ((long) 2), BgL_sz00_12376,
																BINT(BgL_spz00_14652),
																BINT(BgL_arg2234z00_14669));
														}
														VECTOR_SET(BgL_nsz00_14668, ((long) 1),
															BgL_sz00_12376);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14667,
															BgL_nsz00_14668);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_14670;

															BgL_ez00_14670 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14670, BgL_sz00_12376);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_14671;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14672;

																	BgL_savedzd2bpzd2_14672 =
																		VECTOR_REF(BgL_nsz00_14668, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14668, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14674;

																		BgL_fz00_14674 = BgL_runz00_14650;
																	BgL_recz00_14673:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14675;

																			BgL_rz00_14675 =
																				PROCEDURE_ENTRY(BgL_fz00_14674)
																				(BgL_fz00_14674, BgL_nsz00_14668, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5102z00_20290;

																				if (PROCEDUREP(BgL_rz00_14675))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14676;

																						BgL_arg1729z00_14676 =
																							PROCEDURE_ATTR(BgL_rz00_14675);
																						if (STRUCTP(BgL_arg1729z00_14676))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5102z00_20290 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14676) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5102z00_20290 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5102z00_20290 =
																							((bool_t) 0);
																					}
																				if (BgL_test5102z00_20290)
																					{
																						obj_t BgL_fz00_20298;

																						BgL_fz00_20298 = BgL_rz00_14675;
																						BgL_fz00_14674 = BgL_fz00_20298;
																						goto BgL_recz00_14673;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14668,
																							((long) 0),
																							BgL_savedzd2bpzd2_14672);
																						BgL_____rz00_14671 = BgL_rz00_14675;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14670);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14667,
																	BgL_sz00_12376);
																return BgL_____rz00_14671;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14645,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14677;

												BgL_nbpz00_14677 =
													((long) CINT(BgL_bpz00_14644) + BgL_siza7eza7_12375);
												VECTOR_SET(
													((obj_t) BgL_sz00_12376), ((long) 0),
													BINT(BgL_nbpz00_14677));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14678;

													BgL_rz00_14678 =
														PROCEDURE_ENTRY(BgL_fz00_14645) (BgL_fz00_14645,
														BgL_a1z00_14646, BgL_a2z00_14647, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12376), ((long) 0),
														BgL_bpz00_14644);
													return BgL_rz00_14678;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12373,
													BgL_symbzd2funzd2_12374, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_14645));
		}}}}}}}}

	}



/* comp-call3 */
	obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162,
		BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164,
		obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167,
		long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170,
		obj_t BgL_a3z00_171)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2493;

				BgL_cfunz00_2493 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163,
					((long) 3), BgL_locz00_162, BgL_symbzd2funzd2_164);
				if (CBOOL(BgL_cfunz00_2493))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test5107z00_20323;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2243z00_2513;

							BgL_arg2243z00_2513 = bgl_debug();
							BgL_test5107z00_20323 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2243z00_2513),
								BINT(((long) 0)));
						}
						if (BgL_test5107z00_20323)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32240ze3z87_12377;

								BgL_zc3z04anonymousza32240ze3z87_12377 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32240ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32240ze3z87_12377,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3z04anonymousza32240ze3z87_12377,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3z04anonymousza32240ze3z87_12377,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3z04anonymousza32240ze3z87_12377,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3z04anonymousza32240ze3z87_12377,
									(int) (((long) 4)), BgL_locz00_162);
								PROCEDURE_SET(BgL_zc3z04anonymousza32240ze3z87_12377,
									(int) (((long) 5)), BgL_cfunz00_2493);
								return BgL_zc3z04anonymousza32240ze3z87_12377;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32242ze3z87_12378;

								BgL_zc3z04anonymousza32242ze3z87_12378 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32242ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32242ze3z87_12378,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3z04anonymousza32242ze3z87_12378,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3z04anonymousza32242ze3z87_12378,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3z04anonymousza32242ze3z87_12378,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3z04anonymousza32242ze3z87_12378,
									(int) (((long) 4)), BgL_cfunz00_2493);
								return BgL_zc3z04anonymousza32242ze3z87_12378;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_166))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5109z00_20360;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2318z00_2625;

									BgL_arg2318z00_2625 = bgl_debug();
									BgL_test5109z00_20360 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2318z00_2625),
										BINT(((long) 0)));
								}
								if (BgL_test5109z00_20360)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32246ze3z87_12379;

										BgL_zc3z04anonymousza32246ze3z87_12379 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32246ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32246ze3z87_12379,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32246ze3z87_12379,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32246ze3z87_12379,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32246ze3z87_12379,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32246ze3z87_12379,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32246ze3z87_12379,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32246ze3z87_12379,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32246ze3z87_12379;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32281ze3z87_12380;

										BgL_zc3z04anonymousza32281ze3z87_12380 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32281ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32281ze3z87_12380,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32281ze3z87_12380,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32281ze3z87_12380,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32281ze3z87_12380,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32281ze3z87_12380,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32281ze3z87_12380,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32281ze3z87_12380,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32281ze3z87_12380;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5110z00_20401;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2397z00_2737;

									BgL_arg2397z00_2737 = bgl_debug();
									BgL_test5110z00_20401 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2397z00_2737),
										BINT(((long) 0)));
								}
								if (BgL_test5110z00_20401)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32321ze3z87_12381;

										BgL_zc3z04anonymousza32321ze3z87_12381 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32321ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32321ze3z87_12381,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32321ze3z87_12381,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32321ze3z87_12381,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32321ze3z87_12381,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32321ze3z87_12381,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32321ze3z87_12381,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32321ze3z87_12381,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32321ze3z87_12381;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32360ze3z87_12382;

										BgL_zc3z04anonymousza32360ze3z87_12382 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32360ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32360ze3z87_12382,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32360ze3z87_12382,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32360ze3z87_12382,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32360ze3z87_12382,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32360ze3z87_12382,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32360ze3z87_12382,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32360ze3z87_12382,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32360ze3z87_12382;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2240> */
	obj_t BGl_z62zc3z04anonymousza32240ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12383, obj_t BgL_sz00_12390)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_12384;
				obj_t BgL_a2z00_12385;
				obj_t BgL_a3z00_12386;
				long BgL_siza7eza7_12387;
				obj_t BgL_locz00_12388;
				obj_t BgL_cfunz00_12389;

				BgL_a1z00_12384 = PROCEDURE_REF(BgL_envz00_12383, (int) (((long) 0)));
				BgL_a2z00_12385 = PROCEDURE_REF(BgL_envz00_12383, (int) (((long) 1)));
				BgL_a3z00_12386 = PROCEDURE_REF(BgL_envz00_12383, (int) (((long) 2)));
				BgL_siza7eza7_12387 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12383, (int) (((long) 3))));
				BgL_locz00_12388 = PROCEDURE_REF(BgL_envz00_12383, (int) (((long) 4)));
				BgL_cfunz00_12389 = PROCEDURE_REF(BgL_envz00_12383, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14679;

					BgL_bpz00_14679 = VECTOR_REF(((obj_t) BgL_sz00_12390), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_14680;
						obj_t BgL_a2z00_14681;
						obj_t BgL_a3z00_14682;

						BgL_a1z00_14680 =
							PROCEDURE_ENTRY(BgL_a1z00_12384) (BgL_a1z00_12384, BgL_sz00_12390,
							BEOA);
						BgL_a2z00_14681 =
							PROCEDURE_ENTRY(BgL_a2z00_12385) (BgL_a2z00_12385, BgL_sz00_12390,
							BEOA);
						BgL_a3z00_14682 =
							PROCEDURE_ENTRY(BgL_a3z00_12386) (BgL_a3z00_12386, BgL_sz00_12390,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14683;

							BgL_nbpz00_14683 =
								((long) CINT(BgL_bpz00_14679) + BgL_siza7eza7_12387);
							VECTOR_SET(
								((obj_t) BgL_sz00_12390), ((long) 0), BINT(BgL_nbpz00_14683));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20474;

								BgL_tmpz00_20474 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20474, BgL_locz00_12388);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14684;

								BgL_rz00_14684 =
									PROCEDURE_ENTRY(BgL_cfunz00_12389) (BgL_cfunz00_12389,
									BgL_a1z00_14680, BgL_a2z00_14681, BgL_a3z00_14682, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_12390), ((long) 0),
									BgL_bpz00_14679);
								return BgL_rz00_14684;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2242> */
	obj_t BGl_z62zc3z04anonymousza32242ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12391, obj_t BgL_sz00_12397)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_12392;
				obj_t BgL_a2z00_12393;
				obj_t BgL_a3z00_12394;
				long BgL_siza7eza7_12395;
				obj_t BgL_cfunz00_12396;

				BgL_a1z00_12392 = PROCEDURE_REF(BgL_envz00_12391, (int) (((long) 0)));
				BgL_a2z00_12393 = PROCEDURE_REF(BgL_envz00_12391, (int) (((long) 1)));
				BgL_a3z00_12394 = PROCEDURE_REF(BgL_envz00_12391, (int) (((long) 2)));
				BgL_siza7eza7_12395 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12391, (int) (((long) 3))));
				BgL_cfunz00_12396 = PROCEDURE_REF(BgL_envz00_12391, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14685;

					BgL_bpz00_14685 = VECTOR_REF(((obj_t) BgL_sz00_12397), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_14686;
						obj_t BgL_a2z00_14687;
						obj_t BgL_a3z00_14688;

						BgL_a1z00_14686 =
							PROCEDURE_ENTRY(BgL_a1z00_12392) (BgL_a1z00_12392, BgL_sz00_12397,
							BEOA);
						BgL_a2z00_14687 =
							PROCEDURE_ENTRY(BgL_a2z00_12393) (BgL_a2z00_12393, BgL_sz00_12397,
							BEOA);
						BgL_a3z00_14688 =
							PROCEDURE_ENTRY(BgL_a3z00_12394) (BgL_a3z00_12394, BgL_sz00_12397,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14689;

							BgL_nbpz00_14689 =
								((long) CINT(BgL_bpz00_14685) + BgL_siza7eza7_12395);
							VECTOR_SET(
								((obj_t) BgL_sz00_12397), ((long) 0), BINT(BgL_nbpz00_14689));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14690;

								BgL_rz00_14690 =
									PROCEDURE_ENTRY(BgL_cfunz00_12396) (BgL_cfunz00_12396,
									BgL_a1z00_14686, BgL_a2z00_14687, BgL_a3z00_14688, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_12397), ((long) 0),
									BgL_bpz00_14685);
								return BgL_rz00_14690;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2246> */
	obj_t BGl_z62zc3z04anonymousza32246ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12398, obj_t BgL_sz00_12406)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12399;
				obj_t BgL_a1z00_12400;
				obj_t BgL_a2z00_12401;
				obj_t BgL_a3z00_12402;
				obj_t BgL_locz00_12403;
				obj_t BgL_symbzd2funzd2_12404;
				long BgL_siza7eza7_12405;

				BgL_funz00_12399 = PROCEDURE_REF(BgL_envz00_12398, (int) (((long) 0)));
				BgL_a1z00_12400 = PROCEDURE_REF(BgL_envz00_12398, (int) (((long) 1)));
				BgL_a2z00_12401 = PROCEDURE_REF(BgL_envz00_12398, (int) (((long) 2)));
				BgL_a3z00_12402 = PROCEDURE_REF(BgL_envz00_12398, (int) (((long) 3)));
				BgL_locz00_12403 = PROCEDURE_REF(BgL_envz00_12398, (int) (((long) 4)));
				BgL_symbzd2funzd2_12404 =
					PROCEDURE_REF(BgL_envz00_12398, (int) (((long) 5)));
				BgL_siza7eza7_12405 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12398, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14691;

					BgL_bpz00_14691 = VECTOR_REF(((obj_t) BgL_sz00_12406), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14692;
						obj_t BgL_a1z00_14693;
						obj_t BgL_a2z00_14694;
						obj_t BgL_a3z00_14695;

						BgL_fz00_14692 =
							PROCEDURE_ENTRY(BgL_funz00_12399) (BgL_funz00_12399,
							BgL_sz00_12406, BEOA);
						BgL_a1z00_14693 =
							PROCEDURE_ENTRY(BgL_a1z00_12400) (BgL_a1z00_12400, BgL_sz00_12406,
							BEOA);
						BgL_a2z00_14694 =
							PROCEDURE_ENTRY(BgL_a2z00_12401) (BgL_a2z00_12401, BgL_sz00_12406,
							BEOA);
						BgL_a3z00_14695 =
							PROCEDURE_ENTRY(BgL_a3z00_12402) (BgL_a3z00_12402, BgL_sz00_12406,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14692))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12403,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14692);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14696;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20559;

								BgL_tmpz00_20559 = ((obj_t) BgL_fz00_14692);
								BgL_ufz00_14696 = PROCEDURE_ATTR(BgL_tmpz00_20559);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5112z00_20562;

								if (STRUCTP(BgL_ufz00_14696))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5112z00_20562 =
											(STRUCT_KEY(BgL_ufz00_14696) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5112z00_20562 = ((bool_t) 0);
									}
								if (BgL_test5112z00_20562)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14697;
										obj_t BgL_runz00_14698;
										obj_t BgL_sfz00_14699;

										BgL_arityz00_14697 =
											STRUCT_REF(BgL_ufz00_14696, (int) (((long) 0)));
										BgL_runz00_14698 =
											STRUCT_REF(BgL_ufz00_14696, (int) (((long) 1)));
										BgL_sfz00_14699 =
											STRUCT_REF(BgL_ufz00_14696, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14697) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2250z00_14700;

													BgL_arg2250z00_14700 =
														((long) CINT(BgL_bpz00_14691) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_12406), BgL_arg2250z00_14700,
														BgL_a1z00_14693);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2251z00_14701;

													BgL_arg2251z00_14701 =
														((long) CINT(BgL_bpz00_14691) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_12406), BgL_arg2251z00_14701,
														BgL_a2z00_14694);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2252z00_14702;

													BgL_arg2252z00_14702 =
														((long) CINT(BgL_bpz00_14691) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_12406), BgL_arg2252z00_14702,
														BgL_a3z00_14695);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14697))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14697))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2254z00_14703;
																	obj_t BgL_arg2255z00_14704;

																	BgL_arg2254z00_14703 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2256z00_14705;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2257z00_14706;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2258z00_14707;

																				BgL_arg2258z00_14707 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_14695,
																					BNIL);
																				BgL_arg2257z00_14706 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14694,
																					BgL_arg2258z00_14707);
																			}
																			BgL_list2256z00_14705 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_14693,
																				BgL_arg2257z00_14706);
																		}
																		BgL_arg2255z00_14704 =
																			BgL_list2256z00_14705;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2254z00_14703, BgL_arg2255z00_14704);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2259z00_14708;

																	BgL_arg2259z00_14708 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2259z00_14708, BgL_a1z00_14693);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2260z00_14709;
																	obj_t BgL_arg2261z00_14710;

																	BgL_arg2260z00_14709 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2262z00_14711;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2263z00_14712;

																			BgL_arg2263z00_14712 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_14695, BNIL);
																			BgL_list2262z00_14711 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_14694,
																				BgL_arg2263z00_14712);
																		}
																		BgL_arg2261z00_14710 =
																			BgL_list2262z00_14711;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2260z00_14709, BgL_arg2261z00_14710);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2264z00_14713;

																	BgL_arg2264z00_14713 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2264z00_14713, BgL_a1z00_14693);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2265z00_14714;

																	BgL_arg2265z00_14714 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2265z00_14714, BgL_a2z00_14694);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2266z00_14715;
																	obj_t BgL_arg2267z00_14716;

																	BgL_arg2266z00_14715 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2268z00_14717;

																		BgL_list2268z00_14717 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_14695, BNIL);
																		BgL_arg2267z00_14716 =
																			BgL_list2268z00_14717;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2266z00_14715, BgL_arg2267z00_14716);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2269z00_14718;

																	BgL_arg2269z00_14718 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2269z00_14718, BgL_a1z00_14693);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2270z00_14719;

																	BgL_arg2270z00_14719 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2270z00_14719, BgL_a2z00_14694);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2271z00_14720;

																	BgL_arg2271z00_14720 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2271z00_14720, BgL_a3z00_14695);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2272z00_14721;
																	obj_t BgL_arg2273z00_14722;

																	BgL_arg2272z00_14721 =
																		((long) CINT(BgL_bpz00_14691) + ((long) 3));
																	BgL_arg2273z00_14722 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12406),
																		BgL_arg2272z00_14721, BgL_arg2273z00_14722);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12403, STRUCT_REF(BgL_ufz00_14696,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_14697));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12403, STRUCT_REF(BgL_ufz00_14696,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_14697));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14723;

											BgL_z12denvz12_14723 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14723,
												BgL_locz00_12403);
											if ((((long) CINT(BgL_bpz00_14691) +
														(long) CINT(BgL_sfz00_14699)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12406))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14698;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14724;

													BgL_nsz00_14724 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2277z00_14725;

														BgL_arg2277z00_14725 =
															((long) CINT(BgL_bpz00_14691) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14724, ((long) 2), BgL_sz00_12406,
															BgL_bpz00_14691, BINT(BgL_arg2277z00_14725));
													}
													VECTOR_SET(BgL_nsz00_14724, ((long) 1),
														BgL_sz00_12406);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14723,
														BgL_nsz00_14724);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14726;

														BgL_ez00_14726 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14726, BgL_sz00_12406);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14727;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14728;

																BgL_savedzd2bpzd2_14728 =
																	VECTOR_REF(BgL_nsz00_14724, ((long) 0));
																VECTOR_SET(BgL_nsz00_14724, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14730;

																	BgL_fz00_14730 = BgL_runz00_14698;
																BgL_recz00_14729:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14731;

																		BgL_rz00_14731 =
																			PROCEDURE_ENTRY(BgL_fz00_14730)
																			(BgL_fz00_14730, BgL_nsz00_14724, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test5117z00_20673;

																			if (PROCEDUREP(BgL_rz00_14731))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14732;

																					BgL_arg1729z00_14732 =
																						PROCEDURE_ATTR(BgL_rz00_14731);
																					if (STRUCTP(BgL_arg1729z00_14732))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5117z00_20673 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14732) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5117z00_20673 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test5117z00_20673 = ((bool_t) 0);
																				}
																			if (BgL_test5117z00_20673)
																				{
																					obj_t BgL_fz00_20681;

																					BgL_fz00_20681 = BgL_rz00_14731;
																					BgL_fz00_14730 = BgL_fz00_20681;
																					goto BgL_recz00_14729;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14724,
																						((long) 0),
																						BgL_savedzd2bpzd2_14728);
																					BgL_____rz00_14727 = BgL_rz00_14731;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14726);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14723,
																BgL_sz00_12406);
															return BgL_____rz00_14727;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14692,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14733;

												BgL_nbpz00_14733 =
													((long) CINT(BgL_bpz00_14691) + BgL_siza7eza7_12405);
												VECTOR_SET(
													((obj_t) BgL_sz00_12406), ((long) 0),
													BINT(BgL_nbpz00_14733));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_20693;

													BgL_tmpz00_20693 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20693,
														BgL_locz00_12403);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14734;

													BgL_rz00_14734 =
														PROCEDURE_ENTRY(BgL_fz00_14692) (BgL_fz00_14692,
														BgL_a1z00_14693, BgL_a2z00_14694, BgL_a3z00_14695,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12406), ((long) 0),
														BgL_bpz00_14691);
													return BgL_rz00_14734;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12403,
													BgL_symbzd2funzd2_12404, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_14692));
		}}}}}}}}

	}



/* &<@anonymous:2281> */
	obj_t BGl_z62zc3z04anonymousza32281ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12407, obj_t BgL_sz00_12415)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12408;
				obj_t BgL_a1z00_12409;
				obj_t BgL_a2z00_12410;
				obj_t BgL_a3z00_12411;
				obj_t BgL_locz00_12412;
				obj_t BgL_symbzd2funzd2_12413;
				long BgL_siza7eza7_12414;

				BgL_funz00_12408 = PROCEDURE_REF(BgL_envz00_12407, (int) (((long) 0)));
				BgL_a1z00_12409 = PROCEDURE_REF(BgL_envz00_12407, (int) (((long) 1)));
				BgL_a2z00_12410 = PROCEDURE_REF(BgL_envz00_12407, (int) (((long) 2)));
				BgL_a3z00_12411 = PROCEDURE_REF(BgL_envz00_12407, (int) (((long) 3)));
				BgL_locz00_12412 = PROCEDURE_REF(BgL_envz00_12407, (int) (((long) 4)));
				BgL_symbzd2funzd2_12413 =
					PROCEDURE_REF(BgL_envz00_12407, (int) (((long) 5)));
				BgL_siza7eza7_12414 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12407, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14735;

					BgL_bpz00_14735 = VECTOR_REF(((obj_t) BgL_sz00_12415), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14736;
						obj_t BgL_a1z00_14737;
						obj_t BgL_a2z00_14738;
						obj_t BgL_a3z00_14739;

						BgL_fz00_14736 =
							PROCEDURE_ENTRY(BgL_funz00_12408) (BgL_funz00_12408,
							BgL_sz00_12415, BEOA);
						BgL_a1z00_14737 =
							PROCEDURE_ENTRY(BgL_a1z00_12409) (BgL_a1z00_12409, BgL_sz00_12415,
							BEOA);
						BgL_a2z00_14738 =
							PROCEDURE_ENTRY(BgL_a2z00_12410) (BgL_a2z00_12410, BgL_sz00_12415,
							BEOA);
						BgL_a3z00_14739 =
							PROCEDURE_ENTRY(BgL_a3z00_12411) (BgL_a3z00_12411, BgL_sz00_12415,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14736))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12412,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14736);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14740;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20743;

								BgL_tmpz00_20743 = ((obj_t) BgL_fz00_14736);
								BgL_ufz00_14740 = PROCEDURE_ATTR(BgL_tmpz00_20743);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5122z00_20746;

								if (STRUCTP(BgL_ufz00_14740))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5122z00_20746 =
											(STRUCT_KEY(BgL_ufz00_14740) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5122z00_20746 = ((bool_t) 0);
									}
								if (BgL_test5122z00_20746)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14741;
										obj_t BgL_runz00_14742;
										obj_t BgL_sfz00_14743;

										BgL_arityz00_14741 =
											STRUCT_REF(BgL_ufz00_14740, (int) (((long) 0)));
										BgL_runz00_14742 =
											STRUCT_REF(BgL_ufz00_14740, (int) (((long) 1)));
										BgL_sfz00_14743 =
											STRUCT_REF(BgL_ufz00_14740, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14741) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2285z00_14744;

													BgL_arg2285z00_14744 =
														((long) CINT(BgL_bpz00_14735) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_12415), BgL_arg2285z00_14744,
														BgL_a1z00_14737);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2287z00_14745;

													BgL_arg2287z00_14745 =
														((long) CINT(BgL_bpz00_14735) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_12415), BgL_arg2287z00_14745,
														BgL_a2z00_14738);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2288z00_14746;

													BgL_arg2288z00_14746 =
														((long) CINT(BgL_bpz00_14735) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_12415), BgL_arg2288z00_14746,
														BgL_a3z00_14739);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14741))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14741))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2290z00_14747;
																	obj_t BgL_arg2291z00_14748;

																	BgL_arg2290z00_14747 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2292z00_14749;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2293z00_14750;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2294z00_14751;

																				BgL_arg2294z00_14751 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_14739,
																					BNIL);
																				BgL_arg2293z00_14750 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14738,
																					BgL_arg2294z00_14751);
																			}
																			BgL_list2292z00_14749 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_14737,
																				BgL_arg2293z00_14750);
																		}
																		BgL_arg2291z00_14748 =
																			BgL_list2292z00_14749;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2290z00_14747, BgL_arg2291z00_14748);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2295z00_14752;

																	BgL_arg2295z00_14752 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2295z00_14752, BgL_a1z00_14737);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2296z00_14753;
																	obj_t BgL_arg2297z00_14754;

																	BgL_arg2296z00_14753 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2298z00_14755;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2299z00_14756;

																			BgL_arg2299z00_14756 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_14739, BNIL);
																			BgL_list2298z00_14755 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_14738,
																				BgL_arg2299z00_14756);
																		}
																		BgL_arg2297z00_14754 =
																			BgL_list2298z00_14755;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2296z00_14753, BgL_arg2297z00_14754);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2300z00_14757;

																	BgL_arg2300z00_14757 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2300z00_14757, BgL_a1z00_14737);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2301z00_14758;

																	BgL_arg2301z00_14758 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2301z00_14758, BgL_a2z00_14738);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2302z00_14759;
																	obj_t BgL_arg2303z00_14760;

																	BgL_arg2302z00_14759 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2304z00_14761;

																		BgL_list2304z00_14761 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_14739, BNIL);
																		BgL_arg2303z00_14760 =
																			BgL_list2304z00_14761;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2302z00_14759, BgL_arg2303z00_14760);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2305z00_14762;

																	BgL_arg2305z00_14762 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2305z00_14762, BgL_a1z00_14737);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2306z00_14763;

																	BgL_arg2306z00_14763 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2306z00_14763, BgL_a2z00_14738);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2307z00_14764;

																	BgL_arg2307z00_14764 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2307z00_14764, BgL_a3z00_14739);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2308z00_14765;
																	obj_t BgL_arg2309z00_14766;

																	BgL_arg2308z00_14765 =
																		((long) CINT(BgL_bpz00_14735) + ((long) 3));
																	BgL_arg2309z00_14766 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12415),
																		BgL_arg2308z00_14765, BgL_arg2309z00_14766);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12412, STRUCT_REF(BgL_ufz00_14740,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_14741));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12412, STRUCT_REF(BgL_ufz00_14740,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_14741));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14767;

											BgL_z12denvz12_14767 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_14735) +
														(long) CINT(BgL_sfz00_14743)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12415))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14742;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14768;

													BgL_nsz00_14768 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2314z00_14769;

														BgL_arg2314z00_14769 =
															((long) CINT(BgL_bpz00_14735) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14768, ((long) 2), BgL_sz00_12415,
															BgL_bpz00_14735, BINT(BgL_arg2314z00_14769));
													}
													VECTOR_SET(BgL_nsz00_14768, ((long) 1),
														BgL_sz00_12415);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14767,
														BgL_nsz00_14768);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14770;

														BgL_ez00_14770 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14770, BgL_sz00_12415);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14771;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14772;

																BgL_savedzd2bpzd2_14772 =
																	VECTOR_REF(BgL_nsz00_14768, ((long) 0));
																VECTOR_SET(BgL_nsz00_14768, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14774;

																	BgL_fz00_14774 = BgL_runz00_14742;
																BgL_recz00_14773:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14775;

																		BgL_rz00_14775 =
																			PROCEDURE_ENTRY(BgL_fz00_14774)
																			(BgL_fz00_14774, BgL_nsz00_14768, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test5127z00_20856;

																			if (PROCEDUREP(BgL_rz00_14775))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14776;

																					BgL_arg1729z00_14776 =
																						PROCEDURE_ATTR(BgL_rz00_14775);
																					if (STRUCTP(BgL_arg1729z00_14776))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5127z00_20856 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14776) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5127z00_20856 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test5127z00_20856 = ((bool_t) 0);
																				}
																			if (BgL_test5127z00_20856)
																				{
																					obj_t BgL_fz00_20864;

																					BgL_fz00_20864 = BgL_rz00_14775;
																					BgL_fz00_14774 = BgL_fz00_20864;
																					goto BgL_recz00_14773;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14768,
																						((long) 0),
																						BgL_savedzd2bpzd2_14772);
																					BgL_____rz00_14771 = BgL_rz00_14775;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14770);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14767,
																BgL_sz00_12415);
															return BgL_____rz00_14771;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14736,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14777;

												BgL_nbpz00_14777 =
													((long) CINT(BgL_bpz00_14735) + BgL_siza7eza7_12414);
												VECTOR_SET(
													((obj_t) BgL_sz00_12415), ((long) 0),
													BINT(BgL_nbpz00_14777));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14778;

													BgL_rz00_14778 =
														PROCEDURE_ENTRY(BgL_fz00_14736) (BgL_fz00_14736,
														BgL_a1z00_14737, BgL_a2z00_14738, BgL_a3z00_14739,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12415), ((long) 0),
														BgL_bpz00_14735);
													return BgL_rz00_14778;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12412,
													BgL_symbzd2funzd2_12413, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_14736));
		}}}}}}}}

	}



/* &<@anonymous:2321> */
	obj_t BGl_z62zc3z04anonymousza32321ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12416, obj_t BgL_sz00_12424)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12417;
				obj_t BgL_a1z00_12418;
				obj_t BgL_a2z00_12419;
				obj_t BgL_a3z00_12420;
				obj_t BgL_locz00_12421;
				obj_t BgL_symbzd2funzd2_12422;
				long BgL_siza7eza7_12423;

				BgL_funz00_12417 = PROCEDURE_REF(BgL_envz00_12416, (int) (((long) 0)));
				BgL_a1z00_12418 = PROCEDURE_REF(BgL_envz00_12416, (int) (((long) 1)));
				BgL_a2z00_12419 = PROCEDURE_REF(BgL_envz00_12416, (int) (((long) 2)));
				BgL_a3z00_12420 = PROCEDURE_REF(BgL_envz00_12416, (int) (((long) 3)));
				BgL_locz00_12421 = PROCEDURE_REF(BgL_envz00_12416, (int) (((long) 4)));
				BgL_symbzd2funzd2_12422 =
					PROCEDURE_REF(BgL_envz00_12416, (int) (((long) 5)));
				BgL_siza7eza7_12423 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12416, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14779;

					BgL_bpz00_14779 = VECTOR_REF(((obj_t) BgL_sz00_12424), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14780;
						obj_t BgL_a1z00_14781;
						obj_t BgL_a2z00_14782;
						obj_t BgL_a3z00_14783;

						BgL_fz00_14780 =
							PROCEDURE_ENTRY(BgL_funz00_12417) (BgL_funz00_12417,
							BgL_sz00_12424, BEOA);
						BgL_a1z00_14781 =
							PROCEDURE_ENTRY(BgL_a1z00_12418) (BgL_a1z00_12418, BgL_sz00_12424,
							BEOA);
						BgL_a2z00_14782 =
							PROCEDURE_ENTRY(BgL_a2z00_12419) (BgL_a2z00_12419, BgL_sz00_12424,
							BEOA);
						BgL_a3z00_14783 =
							PROCEDURE_ENTRY(BgL_a3z00_12420) (BgL_a3z00_12420, BgL_sz00_12424,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14780))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12421,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14780);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14784;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20923;

								BgL_tmpz00_20923 = ((obj_t) BgL_fz00_14780);
								BgL_ufz00_14784 = PROCEDURE_ATTR(BgL_tmpz00_20923);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5132z00_20926;

								if (STRUCTP(BgL_ufz00_14784))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5132z00_20926 =
											(STRUCT_KEY(BgL_ufz00_14784) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5132z00_20926 = ((bool_t) 0);
									}
								if (BgL_test5132z00_20926)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14785;
										obj_t BgL_runz00_14786;
										obj_t BgL_sfz00_14787;

										BgL_arityz00_14785 =
											STRUCT_REF(BgL_ufz00_14784, (int) (((long) 0)));
										BgL_runz00_14786 =
											STRUCT_REF(BgL_ufz00_14784, (int) (((long) 1)));
										BgL_sfz00_14787 =
											STRUCT_REF(BgL_ufz00_14784, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_14788;

											BgL_spz00_14788 =
												((long) CINT(BgL_bpz00_14779) + BgL_siza7eza7_12423);
											if (((long) CINT(BgL_arityz00_14785) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2325z00_14789;

														BgL_arg2325z00_14789 =
															(BgL_spz00_14788 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_12424), BgL_arg2325z00_14789,
															BgL_a1z00_14781);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2326z00_14790;

														BgL_arg2326z00_14790 =
															(BgL_spz00_14788 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_12424), BgL_arg2326z00_14790,
															BgL_a2z00_14782);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2327z00_14791;

														BgL_arg2327z00_14791 =
															(BgL_spz00_14788 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_12424), BgL_arg2327z00_14791,
															BgL_a3z00_14783);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_14785))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_14785))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2329z00_14792;
																		obj_t BgL_arg2330z00_14793;

																		BgL_arg2329z00_14792 =
																			(BgL_spz00_14788 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2331z00_14794;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2332z00_14795;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2333z00_14796;

																					BgL_arg2333z00_14796 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_14783,
																						BNIL);
																					BgL_arg2332z00_14795 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_14782,
																						BgL_arg2333z00_14796);
																				}
																				BgL_list2331z00_14794 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_14781,
																					BgL_arg2332z00_14795);
																			}
																			BgL_arg2330z00_14793 =
																				BgL_list2331z00_14794;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2329z00_14792,
																			BgL_arg2330z00_14793);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2334z00_14797;

																		BgL_arg2334z00_14797 =
																			(BgL_spz00_14788 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2334z00_14797, BgL_a1z00_14781);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2335z00_14798;
																		obj_t BgL_arg2336z00_14799;

																		BgL_arg2335z00_14798 =
																			(BgL_spz00_14788 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2337z00_14800;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2338z00_14801;

																				BgL_arg2338z00_14801 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_14783,
																					BNIL);
																				BgL_list2337z00_14800 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14782,
																					BgL_arg2338z00_14801);
																			}
																			BgL_arg2336z00_14799 =
																				BgL_list2337z00_14800;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2335z00_14798,
																			BgL_arg2336z00_14799);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2339z00_14802;

																		BgL_arg2339z00_14802 =
																			(BgL_spz00_14788 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2339z00_14802, BgL_a1z00_14781);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2341z00_14803;

																		BgL_arg2341z00_14803 =
																			(BgL_spz00_14788 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2341z00_14803, BgL_a2z00_14782);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2342z00_14804;
																		obj_t BgL_arg2344z00_14805;

																		BgL_arg2342z00_14804 =
																			(BgL_spz00_14788 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2345z00_14806;

																			BgL_list2345z00_14806 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_14783, BNIL);
																			BgL_arg2344z00_14805 =
																				BgL_list2345z00_14806;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2342z00_14804,
																			BgL_arg2344z00_14805);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2348z00_14807;

																		BgL_arg2348z00_14807 =
																			(BgL_spz00_14788 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2348z00_14807, BgL_a1z00_14781);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2349z00_14808;

																		BgL_arg2349z00_14808 =
																			(BgL_spz00_14788 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2349z00_14808, BgL_a2z00_14782);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2350z00_14809;

																		BgL_arg2350z00_14809 =
																			(BgL_spz00_14788 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2350z00_14809, BgL_a3z00_14783);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2351z00_14810;
																		obj_t BgL_arg2352z00_14811;

																		BgL_arg2351z00_14810 =
																			(BgL_spz00_14788 + ((long) 3));
																		BgL_arg2352z00_14811 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12424),
																			BgL_arg2351z00_14810,
																			BgL_arg2352z00_14811);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12421,
																		STRUCT_REF(BgL_ufz00_14784,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_14785));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12421, STRUCT_REF(BgL_ufz00_14784,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_14785));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_14812;

												BgL_z12denvz12_14812 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14812,
													BgL_locz00_12421);
												if (((BgL_spz00_14788 + (long) CINT(BgL_sfz00_14787)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12424))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14786, BgL_sz00_12424,
															BINT(BgL_spz00_14788));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_14813;

														BgL_nsz00_14813 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2356z00_14814;

															BgL_arg2356z00_14814 =
																(BgL_spz00_14788 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14813, ((long) 2), BgL_sz00_12424,
																BINT(BgL_spz00_14788),
																BINT(BgL_arg2356z00_14814));
														}
														VECTOR_SET(BgL_nsz00_14813, ((long) 1),
															BgL_sz00_12424);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14812,
															BgL_nsz00_14813);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_14815;

															BgL_ez00_14815 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14815, BgL_sz00_12424);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_14816;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14817;

																	BgL_savedzd2bpzd2_14817 =
																		VECTOR_REF(BgL_nsz00_14813, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14813, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14819;

																		BgL_fz00_14819 = BgL_runz00_14786;
																	BgL_recz00_14818:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14820;

																			BgL_rz00_14820 =
																				PROCEDURE_ENTRY(BgL_fz00_14819)
																				(BgL_fz00_14819, BgL_nsz00_14813, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5137z00_21027;

																				if (PROCEDUREP(BgL_rz00_14820))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14821;

																						BgL_arg1729z00_14821 =
																							PROCEDURE_ATTR(BgL_rz00_14820);
																						if (STRUCTP(BgL_arg1729z00_14821))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5137z00_21027 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14821) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5137z00_21027 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5137z00_21027 =
																							((bool_t) 0);
																					}
																				if (BgL_test5137z00_21027)
																					{
																						obj_t BgL_fz00_21035;

																						BgL_fz00_21035 = BgL_rz00_14820;
																						BgL_fz00_14819 = BgL_fz00_21035;
																						goto BgL_recz00_14818;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14813,
																							((long) 0),
																							BgL_savedzd2bpzd2_14817);
																						BgL_____rz00_14816 = BgL_rz00_14820;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14815);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14812,
																	BgL_sz00_12424);
																return BgL_____rz00_14816;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14780,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14822;

												BgL_nbpz00_14822 =
													((long) CINT(BgL_bpz00_14779) + BgL_siza7eza7_12423);
												VECTOR_SET(
													((obj_t) BgL_sz00_12424), ((long) 0),
													BINT(BgL_nbpz00_14822));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_21047;

													BgL_tmpz00_21047 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21047,
														BgL_locz00_12421);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14823;

													BgL_rz00_14823 =
														PROCEDURE_ENTRY(BgL_fz00_14780) (BgL_fz00_14780,
														BgL_a1z00_14781, BgL_a2z00_14782, BgL_a3z00_14783,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12424), ((long) 0),
														BgL_bpz00_14779);
													return BgL_rz00_14823;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12421,
													BgL_symbzd2funzd2_12422, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_14780));
		}}}}}}}}

	}



/* &<@anonymous:2360> */
	obj_t BGl_z62zc3z04anonymousza32360ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12425, obj_t BgL_sz00_12433)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12426;
				obj_t BgL_a1z00_12427;
				obj_t BgL_a2z00_12428;
				obj_t BgL_a3z00_12429;
				obj_t BgL_locz00_12430;
				obj_t BgL_symbzd2funzd2_12431;
				long BgL_siza7eza7_12432;

				BgL_funz00_12426 = PROCEDURE_REF(BgL_envz00_12425, (int) (((long) 0)));
				BgL_a1z00_12427 = PROCEDURE_REF(BgL_envz00_12425, (int) (((long) 1)));
				BgL_a2z00_12428 = PROCEDURE_REF(BgL_envz00_12425, (int) (((long) 2)));
				BgL_a3z00_12429 = PROCEDURE_REF(BgL_envz00_12425, (int) (((long) 3)));
				BgL_locz00_12430 = PROCEDURE_REF(BgL_envz00_12425, (int) (((long) 4)));
				BgL_symbzd2funzd2_12431 =
					PROCEDURE_REF(BgL_envz00_12425, (int) (((long) 5)));
				BgL_siza7eza7_12432 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12425, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14824;

					BgL_bpz00_14824 = VECTOR_REF(((obj_t) BgL_sz00_12433), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14825;
						obj_t BgL_a1z00_14826;
						obj_t BgL_a2z00_14827;
						obj_t BgL_a3z00_14828;

						BgL_fz00_14825 =
							PROCEDURE_ENTRY(BgL_funz00_12426) (BgL_funz00_12426,
							BgL_sz00_12433, BEOA);
						BgL_a1z00_14826 =
							PROCEDURE_ENTRY(BgL_a1z00_12427) (BgL_a1z00_12427, BgL_sz00_12433,
							BEOA);
						BgL_a2z00_14827 =
							PROCEDURE_ENTRY(BgL_a2z00_12428) (BgL_a2z00_12428, BgL_sz00_12433,
							BEOA);
						BgL_a3z00_14828 =
							PROCEDURE_ENTRY(BgL_a3z00_12429) (BgL_a3z00_12429, BgL_sz00_12433,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14825))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12430,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14825);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14829;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21097;

								BgL_tmpz00_21097 = ((obj_t) BgL_fz00_14825);
								BgL_ufz00_14829 = PROCEDURE_ATTR(BgL_tmpz00_21097);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5142z00_21100;

								if (STRUCTP(BgL_ufz00_14829))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5142z00_21100 =
											(STRUCT_KEY(BgL_ufz00_14829) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5142z00_21100 = ((bool_t) 0);
									}
								if (BgL_test5142z00_21100)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14830;
										obj_t BgL_runz00_14831;
										obj_t BgL_sfz00_14832;

										BgL_arityz00_14830 =
											STRUCT_REF(BgL_ufz00_14829, (int) (((long) 0)));
										BgL_runz00_14831 =
											STRUCT_REF(BgL_ufz00_14829, (int) (((long) 1)));
										BgL_sfz00_14832 =
											STRUCT_REF(BgL_ufz00_14829, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_14833;

											BgL_spz00_14833 =
												((long) CINT(BgL_bpz00_14824) + BgL_siza7eza7_12432);
											if (((long) CINT(BgL_arityz00_14830) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2364z00_14834;

														BgL_arg2364z00_14834 =
															(BgL_spz00_14833 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_12433), BgL_arg2364z00_14834,
															BgL_a1z00_14826);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2365z00_14835;

														BgL_arg2365z00_14835 =
															(BgL_spz00_14833 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_12433), BgL_arg2365z00_14835,
															BgL_a2z00_14827);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2366z00_14836;

														BgL_arg2366z00_14836 =
															(BgL_spz00_14833 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_12433), BgL_arg2366z00_14836,
															BgL_a3z00_14828);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_14830))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_14830))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2368z00_14837;
																		obj_t BgL_arg2369z00_14838;

																		BgL_arg2368z00_14837 =
																			(BgL_spz00_14833 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2370z00_14839;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2371z00_14840;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2373z00_14841;

																					BgL_arg2373z00_14841 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_14828,
																						BNIL);
																					BgL_arg2371z00_14840 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_14827,
																						BgL_arg2373z00_14841);
																				}
																				BgL_list2370z00_14839 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_14826,
																					BgL_arg2371z00_14840);
																			}
																			BgL_arg2369z00_14838 =
																				BgL_list2370z00_14839;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2368z00_14837,
																			BgL_arg2369z00_14838);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2374z00_14842;

																		BgL_arg2374z00_14842 =
																			(BgL_spz00_14833 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2374z00_14842, BgL_a1z00_14826);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2375z00_14843;
																		obj_t BgL_arg2376z00_14844;

																		BgL_arg2375z00_14843 =
																			(BgL_spz00_14833 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2377z00_14845;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2378z00_14846;

																				BgL_arg2378z00_14846 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_14828,
																					BNIL);
																				BgL_list2377z00_14845 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14827,
																					BgL_arg2378z00_14846);
																			}
																			BgL_arg2376z00_14844 =
																				BgL_list2377z00_14845;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2375z00_14843,
																			BgL_arg2376z00_14844);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2379z00_14847;

																		BgL_arg2379z00_14847 =
																			(BgL_spz00_14833 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2379z00_14847, BgL_a1z00_14826);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2380z00_14848;

																		BgL_arg2380z00_14848 =
																			(BgL_spz00_14833 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2380z00_14848, BgL_a2z00_14827);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2381z00_14849;
																		obj_t BgL_arg2382z00_14850;

																		BgL_arg2381z00_14849 =
																			(BgL_spz00_14833 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2383z00_14851;

																			BgL_list2383z00_14851 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_14828, BNIL);
																			BgL_arg2382z00_14850 =
																				BgL_list2383z00_14851;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2381z00_14849,
																			BgL_arg2382z00_14850);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2384z00_14852;

																		BgL_arg2384z00_14852 =
																			(BgL_spz00_14833 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2384z00_14852, BgL_a1z00_14826);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2385z00_14853;

																		BgL_arg2385z00_14853 =
																			(BgL_spz00_14833 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2385z00_14853, BgL_a2z00_14827);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2387z00_14854;

																		BgL_arg2387z00_14854 =
																			(BgL_spz00_14833 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2387z00_14854, BgL_a3z00_14828);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2389z00_14855;
																		obj_t BgL_arg2390z00_14856;

																		BgL_arg2389z00_14855 =
																			(BgL_spz00_14833 + ((long) 3));
																		BgL_arg2390z00_14856 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12433),
																			BgL_arg2389z00_14855,
																			BgL_arg2390z00_14856);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12430,
																		STRUCT_REF(BgL_ufz00_14829,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_14830));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12430, STRUCT_REF(BgL_ufz00_14829,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_14830));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_14857;

												BgL_z12denvz12_14857 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_14833 +
															(long) CINT(BgL_sfz00_14832)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12433))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_14831, BgL_sz00_12433,
															BINT(BgL_spz00_14833));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_14858;

														BgL_nsz00_14858 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2394z00_14859;

															BgL_arg2394z00_14859 =
																(BgL_spz00_14833 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_14858, ((long) 2), BgL_sz00_12433,
																BINT(BgL_spz00_14833),
																BINT(BgL_arg2394z00_14859));
														}
														VECTOR_SET(BgL_nsz00_14858, ((long) 1),
															BgL_sz00_12433);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14857,
															BgL_nsz00_14858);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_14860;

															BgL_ez00_14860 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_14860, BgL_sz00_12433);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_14861;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_14862;

																	BgL_savedzd2bpzd2_14862 =
																		VECTOR_REF(BgL_nsz00_14858, ((long) 0));
																	VECTOR_SET(BgL_nsz00_14858, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_14864;

																		BgL_fz00_14864 = BgL_runz00_14831;
																	BgL_recz00_14863:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_14865;

																			BgL_rz00_14865 =
																				PROCEDURE_ENTRY(BgL_fz00_14864)
																				(BgL_fz00_14864, BgL_nsz00_14858, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5147z00_21200;

																				if (PROCEDUREP(BgL_rz00_14865))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_14866;

																						BgL_arg1729z00_14866 =
																							PROCEDURE_ATTR(BgL_rz00_14865);
																						if (STRUCTP(BgL_arg1729z00_14866))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5147z00_21200 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_14866) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5147z00_21200 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5147z00_21200 =
																							((bool_t) 0);
																					}
																				if (BgL_test5147z00_21200)
																					{
																						obj_t BgL_fz00_21208;

																						BgL_fz00_21208 = BgL_rz00_14865;
																						BgL_fz00_14864 = BgL_fz00_21208;
																						goto BgL_recz00_14863;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_14858,
																							((long) 0),
																							BgL_savedzd2bpzd2_14862);
																						BgL_____rz00_14861 = BgL_rz00_14865;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_14860);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14857,
																	BgL_sz00_12433);
																return BgL_____rz00_14861;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14825,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14867;

												BgL_nbpz00_14867 =
													((long) CINT(BgL_bpz00_14824) + BgL_siza7eza7_12432);
												VECTOR_SET(
													((obj_t) BgL_sz00_12433), ((long) 0),
													BINT(BgL_nbpz00_14867));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14868;

													BgL_rz00_14868 =
														PROCEDURE_ENTRY(BgL_fz00_14825) (BgL_fz00_14825,
														BgL_a1z00_14826, BgL_a2z00_14827, BgL_a3z00_14828,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12433), ((long) 0),
														BgL_bpz00_14824);
													return BgL_rz00_14868;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12430,
													BgL_symbzd2funzd2_12431, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_14825));
		}}}}}}}}

	}



/* comp-call4 */
	obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172,
		BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174,
		obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177,
		long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180,
		obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2738;

				BgL_cfunz00_2738 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173,
					((long) 4), BgL_locz00_172, BgL_symbzd2funzd2_174);
				if (CBOOL(BgL_cfunz00_2738))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test5152z00_21234;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2403z00_2760;

							BgL_arg2403z00_2760 = bgl_debug();
							BgL_test5152z00_21234 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2403z00_2760),
								BINT(((long) 0)));
						}
						if (BgL_test5152z00_21234)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32400ze3z87_12434;

								BgL_zc3z04anonymousza32400ze3z87_12434 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32400ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_12434,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_12434,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_12434,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_12434,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_12434,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_12434,
									(int) (((long) 5)), BgL_locz00_172);
								PROCEDURE_SET(BgL_zc3z04anonymousza32400ze3z87_12434,
									(int) (((long) 6)), BgL_cfunz00_2738);
								return BgL_zc3z04anonymousza32400ze3z87_12434;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32402ze3z87_12435;

								BgL_zc3z04anonymousza32402ze3z87_12435 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32402ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32402ze3z87_12435,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3z04anonymousza32402ze3z87_12435,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3z04anonymousza32402ze3z87_12435,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3z04anonymousza32402ze3z87_12435,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3z04anonymousza32402ze3z87_12435,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3z04anonymousza32402ze3z87_12435,
									(int) (((long) 5)), BgL_cfunz00_2738);
								return BgL_zc3z04anonymousza32402ze3z87_12435;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_176))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5154z00_21275;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2522z00_2896;

									BgL_arg2522z00_2896 = bgl_debug();
									BgL_test5154z00_21275 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2522z00_2896),
										BINT(((long) 0)));
								}
								if (BgL_test5154z00_21275)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32406ze3z87_12436;

										BgL_zc3z04anonymousza32406ze3z87_12436 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32406ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32406ze3z87_12436,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32406ze3z87_12436,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32406ze3z87_12436,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32406ze3z87_12436,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32406ze3z87_12436,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32406ze3z87_12436,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32406ze3z87_12436,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32406ze3z87_12436,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32406ze3z87_12436;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32462ze3z87_12437;

										BgL_zc3z04anonymousza32462ze3z87_12437 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32462ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32462ze3z87_12437,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32462ze3z87_12437,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32462ze3z87_12437,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32462ze3z87_12437,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32462ze3z87_12437,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32462ze3z87_12437,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32462ze3z87_12437,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32462ze3z87_12437,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32462ze3z87_12437;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5155z00_21320;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2643z00_3032;

									BgL_arg2643z00_3032 = bgl_debug();
									BgL_test5155z00_21320 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2643z00_3032),
										BINT(((long) 0)));
								}
								if (BgL_test5155z00_21320)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32527ze3z87_12438;

										BgL_zc3z04anonymousza32527ze3z87_12438 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32527ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32527ze3z87_12438,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32527ze3z87_12438,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32527ze3z87_12438,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32527ze3z87_12438,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32527ze3z87_12438,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32527ze3z87_12438,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32527ze3z87_12438,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32527ze3z87_12438,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32527ze3z87_12438;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32592ze3z87_12439;

										BgL_zc3z04anonymousza32592ze3z87_12439 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32592ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32592ze3z87_12439,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32592ze3z87_12439,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32592ze3z87_12439,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32592ze3z87_12439,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32592ze3z87_12439,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32592ze3z87_12439,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32592ze3z87_12439,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32592ze3z87_12439,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32592ze3z87_12439;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2400> */
	obj_t BGl_z62zc3z04anonymousza32400ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12440, obj_t BgL_sz00_12448)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_12441;
				obj_t BgL_a2z00_12442;
				obj_t BgL_a3z00_12443;
				obj_t BgL_a4z00_12444;
				long BgL_siza7eza7_12445;
				obj_t BgL_locz00_12446;
				obj_t BgL_cfunz00_12447;

				BgL_a1z00_12441 = PROCEDURE_REF(BgL_envz00_12440, (int) (((long) 0)));
				BgL_a2z00_12442 = PROCEDURE_REF(BgL_envz00_12440, (int) (((long) 1)));
				BgL_a3z00_12443 = PROCEDURE_REF(BgL_envz00_12440, (int) (((long) 2)));
				BgL_a4z00_12444 = PROCEDURE_REF(BgL_envz00_12440, (int) (((long) 3)));
				BgL_siza7eza7_12445 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12440, (int) (((long) 4))));
				BgL_locz00_12446 = PROCEDURE_REF(BgL_envz00_12440, (int) (((long) 5)));
				BgL_cfunz00_12447 = PROCEDURE_REF(BgL_envz00_12440, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14869;

					BgL_bpz00_14869 = VECTOR_REF(((obj_t) BgL_sz00_12448), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_14870;
						obj_t BgL_a2z00_14871;
						obj_t BgL_a3z00_14872;
						obj_t BgL_a4z00_14873;

						BgL_a1z00_14870 =
							PROCEDURE_ENTRY(BgL_a1z00_12441) (BgL_a1z00_12441, BgL_sz00_12448,
							BEOA);
						BgL_a2z00_14871 =
							PROCEDURE_ENTRY(BgL_a2z00_12442) (BgL_a2z00_12442, BgL_sz00_12448,
							BEOA);
						BgL_a3z00_14872 =
							PROCEDURE_ENTRY(BgL_a3z00_12443) (BgL_a3z00_12443, BgL_sz00_12448,
							BEOA);
						BgL_a4z00_14873 =
							PROCEDURE_ENTRY(BgL_a4z00_12444) (BgL_a4z00_12444, BgL_sz00_12448,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14874;

							BgL_nbpz00_14874 =
								((long) CINT(BgL_bpz00_14869) + BgL_siza7eza7_12445);
							VECTOR_SET(
								((obj_t) BgL_sz00_12448), ((long) 0), BINT(BgL_nbpz00_14874));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21403;

								BgL_tmpz00_21403 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21403, BgL_locz00_12446);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14875;

								BgL_rz00_14875 =
									PROCEDURE_ENTRY(BgL_cfunz00_12447) (BgL_cfunz00_12447,
									BgL_a1z00_14870, BgL_a2z00_14871, BgL_a3z00_14872,
									BgL_a4z00_14873, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_12448), ((long) 0),
									BgL_bpz00_14869);
								return BgL_rz00_14875;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2402> */
	obj_t BGl_z62zc3z04anonymousza32402ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12449, obj_t BgL_sz00_12456)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_12450;
				obj_t BgL_a2z00_12451;
				obj_t BgL_a3z00_12452;
				obj_t BgL_a4z00_12453;
				long BgL_siza7eza7_12454;
				obj_t BgL_cfunz00_12455;

				BgL_a1z00_12450 = PROCEDURE_REF(BgL_envz00_12449, (int) (((long) 0)));
				BgL_a2z00_12451 = PROCEDURE_REF(BgL_envz00_12449, (int) (((long) 1)));
				BgL_a3z00_12452 = PROCEDURE_REF(BgL_envz00_12449, (int) (((long) 2)));
				BgL_a4z00_12453 = PROCEDURE_REF(BgL_envz00_12449, (int) (((long) 3)));
				BgL_siza7eza7_12454 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12449, (int) (((long) 4))));
				BgL_cfunz00_12455 = PROCEDURE_REF(BgL_envz00_12449, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14876;

					BgL_bpz00_14876 = VECTOR_REF(((obj_t) BgL_sz00_12456), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_14877;
						obj_t BgL_a2z00_14878;
						obj_t BgL_a3z00_14879;
						obj_t BgL_a4z00_14880;

						BgL_a1z00_14877 =
							PROCEDURE_ENTRY(BgL_a1z00_12450) (BgL_a1z00_12450, BgL_sz00_12456,
							BEOA);
						BgL_a2z00_14878 =
							PROCEDURE_ENTRY(BgL_a2z00_12451) (BgL_a2z00_12451, BgL_sz00_12456,
							BEOA);
						BgL_a3z00_14879 =
							PROCEDURE_ENTRY(BgL_a3z00_12452) (BgL_a3z00_12452, BgL_sz00_12456,
							BEOA);
						BgL_a4z00_14880 =
							PROCEDURE_ENTRY(BgL_a4z00_12453) (BgL_a4z00_12453, BgL_sz00_12456,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_14881;

							BgL_nbpz00_14881 =
								((long) CINT(BgL_bpz00_14876) + BgL_siza7eza7_12454);
							VECTOR_SET(
								((obj_t) BgL_sz00_12456), ((long) 0), BINT(BgL_nbpz00_14881));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_14882;

								BgL_rz00_14882 =
									PROCEDURE_ENTRY(BgL_cfunz00_12455) (BgL_cfunz00_12455,
									BgL_a1z00_14877, BgL_a2z00_14878, BgL_a3z00_14879,
									BgL_a4z00_14880, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_12456), ((long) 0),
									BgL_bpz00_14876);
								return BgL_rz00_14882;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2406> */
	obj_t BGl_z62zc3z04anonymousza32406ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12457, obj_t BgL_sz00_12466)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12458;
				obj_t BgL_a1z00_12459;
				obj_t BgL_a2z00_12460;
				obj_t BgL_a3z00_12461;
				obj_t BgL_a4z00_12462;
				obj_t BgL_locz00_12463;
				obj_t BgL_symbzd2funzd2_12464;
				long BgL_siza7eza7_12465;

				BgL_funz00_12458 = PROCEDURE_REF(BgL_envz00_12457, (int) (((long) 0)));
				BgL_a1z00_12459 = PROCEDURE_REF(BgL_envz00_12457, (int) (((long) 1)));
				BgL_a2z00_12460 = PROCEDURE_REF(BgL_envz00_12457, (int) (((long) 2)));
				BgL_a3z00_12461 = PROCEDURE_REF(BgL_envz00_12457, (int) (((long) 3)));
				BgL_a4z00_12462 = PROCEDURE_REF(BgL_envz00_12457, (int) (((long) 4)));
				BgL_locz00_12463 = PROCEDURE_REF(BgL_envz00_12457, (int) (((long) 5)));
				BgL_symbzd2funzd2_12464 =
					PROCEDURE_REF(BgL_envz00_12457, (int) (((long) 6)));
				BgL_siza7eza7_12465 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12457, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14883;

					BgL_bpz00_14883 = VECTOR_REF(((obj_t) BgL_sz00_12466), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14884;
						obj_t BgL_a1z00_14885;
						obj_t BgL_a2z00_14886;
						obj_t BgL_a3z00_14887;
						obj_t BgL_a4z00_14888;

						BgL_fz00_14884 =
							PROCEDURE_ENTRY(BgL_funz00_12458) (BgL_funz00_12458,
							BgL_sz00_12466, BEOA);
						BgL_a1z00_14885 =
							PROCEDURE_ENTRY(BgL_a1z00_12459) (BgL_a1z00_12459, BgL_sz00_12466,
							BEOA);
						BgL_a2z00_14886 =
							PROCEDURE_ENTRY(BgL_a2z00_12460) (BgL_a2z00_12460, BgL_sz00_12466,
							BEOA);
						BgL_a3z00_14887 =
							PROCEDURE_ENTRY(BgL_a3z00_12461) (BgL_a3z00_12461, BgL_sz00_12466,
							BEOA);
						BgL_a4z00_14888 =
							PROCEDURE_ENTRY(BgL_a4z00_12462) (BgL_a4z00_12462, BgL_sz00_12466,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14884))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12463,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14884);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14889;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21502;

								BgL_tmpz00_21502 = ((obj_t) BgL_fz00_14884);
								BgL_ufz00_14889 = PROCEDURE_ATTR(BgL_tmpz00_21502);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5157z00_21505;

								if (STRUCTP(BgL_ufz00_14889))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5157z00_21505 =
											(STRUCT_KEY(BgL_ufz00_14889) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5157z00_21505 = ((bool_t) 0);
									}
								if (BgL_test5157z00_21505)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14890;
										obj_t BgL_runz00_14891;
										obj_t BgL_sfz00_14892;

										BgL_arityz00_14890 =
											STRUCT_REF(BgL_ufz00_14889, (int) (((long) 0)));
										BgL_runz00_14891 =
											STRUCT_REF(BgL_ufz00_14889, (int) (((long) 1)));
										BgL_sfz00_14892 =
											STRUCT_REF(BgL_ufz00_14889, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14890) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2410z00_14893;

													BgL_arg2410z00_14893 =
														((long) CINT(BgL_bpz00_14883) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_12466), BgL_arg2410z00_14893,
														BgL_a1z00_14885);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2411z00_14894;

													BgL_arg2411z00_14894 =
														((long) CINT(BgL_bpz00_14883) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_12466), BgL_arg2411z00_14894,
														BgL_a2z00_14886);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2412z00_14895;

													BgL_arg2412z00_14895 =
														((long) CINT(BgL_bpz00_14883) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_12466), BgL_arg2412z00_14895,
														BgL_a3z00_14887);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2414z00_14896;

													BgL_arg2414z00_14896 =
														((long) CINT(BgL_bpz00_14883) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_12466), BgL_arg2414z00_14896,
														BgL_a4z00_14888);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14890))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14890))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2416z00_14897;
																	obj_t BgL_arg2417z00_14898;

																	BgL_arg2416z00_14897 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2418z00_14899;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2420z00_14900;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2421z00_14901;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2422z00_14902;

																					BgL_arg2422z00_14902 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_14888,
																						BNIL);
																					BgL_arg2421z00_14901 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_14887,
																						BgL_arg2422z00_14902);
																				}
																				BgL_arg2420z00_14900 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14886,
																					BgL_arg2421z00_14901);
																			}
																			BgL_list2418z00_14899 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_14885,
																				BgL_arg2420z00_14900);
																		}
																		BgL_arg2417z00_14898 =
																			BgL_list2418z00_14899;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2416z00_14897, BgL_arg2417z00_14898);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2423z00_14903;

																	BgL_arg2423z00_14903 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2423z00_14903, BgL_a1z00_14885);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2425z00_14904;
																	obj_t BgL_arg2426z00_14905;

																	BgL_arg2425z00_14904 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2427z00_14906;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2428z00_14907;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2429z00_14908;

																				BgL_arg2429z00_14908 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_14888,
																					BNIL);
																				BgL_arg2428z00_14907 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_14887,
																					BgL_arg2429z00_14908);
																			}
																			BgL_list2427z00_14906 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_14886,
																				BgL_arg2428z00_14907);
																		}
																		BgL_arg2426z00_14905 =
																			BgL_list2427z00_14906;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2425z00_14904, BgL_arg2426z00_14905);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2430z00_14909;

																	BgL_arg2430z00_14909 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2430z00_14909, BgL_a1z00_14885);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2431z00_14910;

																	BgL_arg2431z00_14910 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2431z00_14910, BgL_a2z00_14886);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2433z00_14911;
																	obj_t BgL_arg2434z00_14912;

																	BgL_arg2433z00_14911 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2435z00_14913;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2436z00_14914;

																			BgL_arg2436z00_14914 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_14888, BNIL);
																			BgL_list2435z00_14913 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_14887,
																				BgL_arg2436z00_14914);
																		}
																		BgL_arg2434z00_14912 =
																			BgL_list2435z00_14913;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2433z00_14911, BgL_arg2434z00_14912);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2437z00_14915;

																	BgL_arg2437z00_14915 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2437z00_14915, BgL_a1z00_14885);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2438z00_14916;

																	BgL_arg2438z00_14916 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2438z00_14916, BgL_a2z00_14886);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2439z00_14917;

																	BgL_arg2439z00_14917 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2439z00_14917, BgL_a3z00_14887);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2443z00_14918;
																	obj_t BgL_arg2444z00_14919;

																	BgL_arg2443z00_14918 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2445z00_14920;

																		BgL_list2445z00_14920 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_14888, BNIL);
																		BgL_arg2444z00_14919 =
																			BgL_list2445z00_14920;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2443z00_14918, BgL_arg2444z00_14919);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2446z00_14921;

																	BgL_arg2446z00_14921 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2446z00_14921, BgL_a1z00_14885);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2447z00_14922;

																	BgL_arg2447z00_14922 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2447z00_14922, BgL_a2z00_14886);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2448z00_14923;

																	BgL_arg2448z00_14923 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2448z00_14923, BgL_a3z00_14887);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2450z00_14924;

																	BgL_arg2450z00_14924 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2450z00_14924, BgL_a4z00_14888);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2453z00_14925;
																	obj_t BgL_arg2454z00_14926;

																	BgL_arg2453z00_14925 =
																		((long) CINT(BgL_bpz00_14883) + ((long) 4));
																	BgL_arg2454z00_14926 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12466),
																		BgL_arg2453z00_14925, BgL_arg2454z00_14926);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12463, STRUCT_REF(BgL_ufz00_14889,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_14890));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12463, STRUCT_REF(BgL_ufz00_14889,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_14890));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14927;

											BgL_z12denvz12_14927 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_14927,
												BgL_locz00_12463);
											if ((((long) CINT(BgL_bpz00_14883) +
														(long) CINT(BgL_sfz00_14892)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12466))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14891;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14928;

													BgL_nsz00_14928 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2458z00_14929;

														BgL_arg2458z00_14929 =
															((long) CINT(BgL_bpz00_14883) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14928, ((long) 2), BgL_sz00_12466,
															BgL_bpz00_14883, BINT(BgL_arg2458z00_14929));
													}
													VECTOR_SET(BgL_nsz00_14928, ((long) 1),
														BgL_sz00_12466);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14927,
														BgL_nsz00_14928);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14930;

														BgL_ez00_14930 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14930, BgL_sz00_12466);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14931;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14932;

																BgL_savedzd2bpzd2_14932 =
																	VECTOR_REF(BgL_nsz00_14928, ((long) 0));
																VECTOR_SET(BgL_nsz00_14928, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14934;

																	BgL_fz00_14934 = BgL_runz00_14891;
																BgL_recz00_14933:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14935;

																		BgL_rz00_14935 =
																			PROCEDURE_ENTRY(BgL_fz00_14934)
																			(BgL_fz00_14934, BgL_nsz00_14928, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test5162z00_21644;

																			if (PROCEDUREP(BgL_rz00_14935))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14936;

																					BgL_arg1729z00_14936 =
																						PROCEDURE_ATTR(BgL_rz00_14935);
																					if (STRUCTP(BgL_arg1729z00_14936))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5162z00_21644 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14936) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5162z00_21644 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test5162z00_21644 = ((bool_t) 0);
																				}
																			if (BgL_test5162z00_21644)
																				{
																					obj_t BgL_fz00_21652;

																					BgL_fz00_21652 = BgL_rz00_14935;
																					BgL_fz00_14934 = BgL_fz00_21652;
																					goto BgL_recz00_14933;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14928,
																						((long) 0),
																						BgL_savedzd2bpzd2_14932);
																					BgL_____rz00_14931 = BgL_rz00_14935;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14930);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14927,
																BgL_sz00_12466);
															return BgL_____rz00_14931;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14884,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14937;

												BgL_nbpz00_14937 =
													((long) CINT(BgL_bpz00_14883) + BgL_siza7eza7_12465);
												VECTOR_SET(
													((obj_t) BgL_sz00_12466), ((long) 0),
													BINT(BgL_nbpz00_14937));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_21664;

													BgL_tmpz00_21664 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21664,
														BgL_locz00_12463);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14938;

													BgL_rz00_14938 =
														PROCEDURE_ENTRY(BgL_fz00_14884) (BgL_fz00_14884,
														BgL_a1z00_14885, BgL_a2z00_14886, BgL_a3z00_14887,
														BgL_a4z00_14888, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12466), ((long) 0),
														BgL_bpz00_14883);
													return BgL_rz00_14938;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12463,
													BgL_symbzd2funzd2_12464, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_14884));
		}}}}}}}}

	}



/* &<@anonymous:2462> */
	obj_t BGl_z62zc3z04anonymousza32462ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12467, obj_t BgL_sz00_12476)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12468;
				obj_t BgL_a1z00_12469;
				obj_t BgL_a2z00_12470;
				obj_t BgL_a3z00_12471;
				obj_t BgL_a4z00_12472;
				obj_t BgL_locz00_12473;
				obj_t BgL_symbzd2funzd2_12474;
				long BgL_siza7eza7_12475;

				BgL_funz00_12468 = PROCEDURE_REF(BgL_envz00_12467, (int) (((long) 0)));
				BgL_a1z00_12469 = PROCEDURE_REF(BgL_envz00_12467, (int) (((long) 1)));
				BgL_a2z00_12470 = PROCEDURE_REF(BgL_envz00_12467, (int) (((long) 2)));
				BgL_a3z00_12471 = PROCEDURE_REF(BgL_envz00_12467, (int) (((long) 3)));
				BgL_a4z00_12472 = PROCEDURE_REF(BgL_envz00_12467, (int) (((long) 4)));
				BgL_locz00_12473 = PROCEDURE_REF(BgL_envz00_12467, (int) (((long) 5)));
				BgL_symbzd2funzd2_12474 =
					PROCEDURE_REF(BgL_envz00_12467, (int) (((long) 6)));
				BgL_siza7eza7_12475 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12467, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14939;

					BgL_bpz00_14939 = VECTOR_REF(((obj_t) BgL_sz00_12476), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14940;
						obj_t BgL_a1z00_14941;
						obj_t BgL_a2z00_14942;
						obj_t BgL_a3z00_14943;
						obj_t BgL_a4z00_14944;

						BgL_fz00_14940 =
							PROCEDURE_ENTRY(BgL_funz00_12468) (BgL_funz00_12468,
							BgL_sz00_12476, BEOA);
						BgL_a1z00_14941 =
							PROCEDURE_ENTRY(BgL_a1z00_12469) (BgL_a1z00_12469, BgL_sz00_12476,
							BEOA);
						BgL_a2z00_14942 =
							PROCEDURE_ENTRY(BgL_a2z00_12470) (BgL_a2z00_12470, BgL_sz00_12476,
							BEOA);
						BgL_a3z00_14943 =
							PROCEDURE_ENTRY(BgL_a3z00_12471) (BgL_a3z00_12471, BgL_sz00_12476,
							BEOA);
						BgL_a4z00_14944 =
							PROCEDURE_ENTRY(BgL_a4z00_12472) (BgL_a4z00_12472, BgL_sz00_12476,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14940))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12473,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14940);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_14945;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21721;

								BgL_tmpz00_21721 = ((obj_t) BgL_fz00_14940);
								BgL_ufz00_14945 = PROCEDURE_ATTR(BgL_tmpz00_21721);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5167z00_21724;

								if (STRUCTP(BgL_ufz00_14945))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5167z00_21724 =
											(STRUCT_KEY(BgL_ufz00_14945) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5167z00_21724 = ((bool_t) 0);
									}
								if (BgL_test5167z00_21724)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_14946;
										obj_t BgL_runz00_14947;
										obj_t BgL_sfz00_14948;

										BgL_arityz00_14946 =
											STRUCT_REF(BgL_ufz00_14945, (int) (((long) 0)));
										BgL_runz00_14947 =
											STRUCT_REF(BgL_ufz00_14945, (int) (((long) 1)));
										BgL_sfz00_14948 =
											STRUCT_REF(BgL_ufz00_14945, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_14946) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2466z00_14949;

													BgL_arg2466z00_14949 =
														((long) CINT(BgL_bpz00_14939) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_12476), BgL_arg2466z00_14949,
														BgL_a1z00_14941);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2467z00_14950;

													BgL_arg2467z00_14950 =
														((long) CINT(BgL_bpz00_14939) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_12476), BgL_arg2467z00_14950,
														BgL_a2z00_14942);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2468z00_14951;

													BgL_arg2468z00_14951 =
														((long) CINT(BgL_bpz00_14939) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_12476), BgL_arg2468z00_14951,
														BgL_a3z00_14943);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2470z00_14952;

													BgL_arg2470z00_14952 =
														((long) CINT(BgL_bpz00_14939) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_12476), BgL_arg2470z00_14952,
														BgL_a4z00_14944);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_14946))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_14946))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2472z00_14953;
																	obj_t BgL_arg2473z00_14954;

																	BgL_arg2472z00_14953 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2474z00_14955;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2476z00_14956;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2478z00_14957;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2479z00_14958;

																					BgL_arg2479z00_14958 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_14944,
																						BNIL);
																					BgL_arg2478z00_14957 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_14943,
																						BgL_arg2479z00_14958);
																				}
																				BgL_arg2476z00_14956 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14942,
																					BgL_arg2478z00_14957);
																			}
																			BgL_list2474z00_14955 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_14941,
																				BgL_arg2476z00_14956);
																		}
																		BgL_arg2473z00_14954 =
																			BgL_list2474z00_14955;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2472z00_14953, BgL_arg2473z00_14954);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2481z00_14959;

																	BgL_arg2481z00_14959 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2481z00_14959, BgL_a1z00_14941);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2482z00_14960;
																	obj_t BgL_arg2486z00_14961;

																	BgL_arg2482z00_14960 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2487z00_14962;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2488z00_14963;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2489z00_14964;

																				BgL_arg2489z00_14964 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_14944,
																					BNIL);
																				BgL_arg2488z00_14963 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_14943,
																					BgL_arg2489z00_14964);
																			}
																			BgL_list2487z00_14962 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_14942,
																				BgL_arg2488z00_14963);
																		}
																		BgL_arg2486z00_14961 =
																			BgL_list2487z00_14962;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2482z00_14960, BgL_arg2486z00_14961);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2490z00_14965;

																	BgL_arg2490z00_14965 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2490z00_14965, BgL_a1z00_14941);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2491z00_14966;

																	BgL_arg2491z00_14966 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2491z00_14966, BgL_a2z00_14942);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2492z00_14967;
																	obj_t BgL_arg2493z00_14968;

																	BgL_arg2492z00_14967 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2494z00_14969;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2495z00_14970;

																			BgL_arg2495z00_14970 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_14944, BNIL);
																			BgL_list2494z00_14969 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_14943,
																				BgL_arg2495z00_14970);
																		}
																		BgL_arg2493z00_14968 =
																			BgL_list2494z00_14969;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2492z00_14967, BgL_arg2493z00_14968);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2496z00_14971;

																	BgL_arg2496z00_14971 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2496z00_14971, BgL_a1z00_14941);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2497z00_14972;

																	BgL_arg2497z00_14972 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2497z00_14972, BgL_a2z00_14942);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2498z00_14973;

																	BgL_arg2498z00_14973 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2498z00_14973, BgL_a3z00_14943);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2500z00_14974;
																	obj_t BgL_arg2502z00_14975;

																	BgL_arg2500z00_14974 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2503z00_14976;

																		BgL_list2503z00_14976 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_14944, BNIL);
																		BgL_arg2502z00_14975 =
																			BgL_list2503z00_14976;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2500z00_14974, BgL_arg2502z00_14975);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2504z00_14977;

																	BgL_arg2504z00_14977 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2504z00_14977, BgL_a1z00_14941);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2506z00_14978;

																	BgL_arg2506z00_14978 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2506z00_14978, BgL_a2z00_14942);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2507z00_14979;

																	BgL_arg2507z00_14979 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2507z00_14979, BgL_a3z00_14943);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2509z00_14980;

																	BgL_arg2509z00_14980 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2509z00_14980, BgL_a4z00_14944);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2510z00_14981;
																	obj_t BgL_arg2511z00_14982;

																	BgL_arg2510z00_14981 =
																		((long) CINT(BgL_bpz00_14939) + ((long) 4));
																	BgL_arg2511z00_14982 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_12476),
																		BgL_arg2510z00_14981, BgL_arg2511z00_14982);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_12473, STRUCT_REF(BgL_ufz00_14945,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_14946));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_12473, STRUCT_REF(BgL_ufz00_14945,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_14946));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_14983;

											BgL_z12denvz12_14983 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_14939) +
														(long) CINT(BgL_sfz00_14948)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_12476))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_14947;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_14984;

													BgL_nsz00_14984 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2517z00_14985;

														BgL_arg2517z00_14985 =
															((long) CINT(BgL_bpz00_14939) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_14984, ((long) 2), BgL_sz00_12476,
															BgL_bpz00_14939, BINT(BgL_arg2517z00_14985));
													}
													VECTOR_SET(BgL_nsz00_14984, ((long) 1),
														BgL_sz00_12476);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14983,
														BgL_nsz00_14984);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_14986;

														BgL_ez00_14986 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_14986, BgL_sz00_12476);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_14987;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_14988;

																BgL_savedzd2bpzd2_14988 =
																	VECTOR_REF(BgL_nsz00_14984, ((long) 0));
																VECTOR_SET(BgL_nsz00_14984, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_14990;

																	BgL_fz00_14990 = BgL_runz00_14947;
																BgL_recz00_14989:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_14991;

																		BgL_rz00_14991 =
																			PROCEDURE_ENTRY(BgL_fz00_14990)
																			(BgL_fz00_14990, BgL_nsz00_14984, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test5172z00_21862;

																			if (PROCEDUREP(BgL_rz00_14991))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1729z00_14992;

																					BgL_arg1729z00_14992 =
																						PROCEDURE_ATTR(BgL_rz00_14991);
																					if (STRUCTP(BgL_arg1729z00_14992))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5172z00_21862 =
																								(STRUCT_KEY
																								(BgL_arg1729z00_14992) ==
																								BGl_symbol4589z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test5172z00_21862 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test5172z00_21862 = ((bool_t) 0);
																				}
																			if (BgL_test5172z00_21862)
																				{
																					obj_t BgL_fz00_21870;

																					BgL_fz00_21870 = BgL_rz00_14991;
																					BgL_fz00_14990 = BgL_fz00_21870;
																					goto BgL_recz00_14989;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_14984,
																						((long) 0),
																						BgL_savedzd2bpzd2_14988);
																					BgL_____rz00_14987 = BgL_rz00_14991;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_14986);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14983,
																BgL_sz00_12476);
															return BgL_____rz00_14987;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14940,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_14993;

												BgL_nbpz00_14993 =
													((long) CINT(BgL_bpz00_14939) + BgL_siza7eza7_12475);
												VECTOR_SET(
													((obj_t) BgL_sz00_12476), ((long) 0),
													BINT(BgL_nbpz00_14993));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_14994;

													BgL_rz00_14994 =
														PROCEDURE_ENTRY(BgL_fz00_14940) (BgL_fz00_14940,
														BgL_a1z00_14941, BgL_a2z00_14942, BgL_a3z00_14943,
														BgL_a4z00_14944, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12476), ((long) 0),
														BgL_bpz00_14939);
													return BgL_rz00_14994;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12473,
													BgL_symbzd2funzd2_12474, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_14940));
		}}}}}}}}

	}



/* &<@anonymous:2527> */
	obj_t BGl_z62zc3z04anonymousza32527ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12477, obj_t BgL_sz00_12486)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12478;
				obj_t BgL_a1z00_12479;
				obj_t BgL_a2z00_12480;
				obj_t BgL_a3z00_12481;
				obj_t BgL_a4z00_12482;
				obj_t BgL_locz00_12483;
				obj_t BgL_symbzd2funzd2_12484;
				long BgL_siza7eza7_12485;

				BgL_funz00_12478 = PROCEDURE_REF(BgL_envz00_12477, (int) (((long) 0)));
				BgL_a1z00_12479 = PROCEDURE_REF(BgL_envz00_12477, (int) (((long) 1)));
				BgL_a2z00_12480 = PROCEDURE_REF(BgL_envz00_12477, (int) (((long) 2)));
				BgL_a3z00_12481 = PROCEDURE_REF(BgL_envz00_12477, (int) (((long) 3)));
				BgL_a4z00_12482 = PROCEDURE_REF(BgL_envz00_12477, (int) (((long) 4)));
				BgL_locz00_12483 = PROCEDURE_REF(BgL_envz00_12477, (int) (((long) 5)));
				BgL_symbzd2funzd2_12484 =
					PROCEDURE_REF(BgL_envz00_12477, (int) (((long) 6)));
				BgL_siza7eza7_12485 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12477, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_14995;

					BgL_bpz00_14995 = VECTOR_REF(((obj_t) BgL_sz00_12486), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_14996;
						obj_t BgL_a1z00_14997;
						obj_t BgL_a2z00_14998;
						obj_t BgL_a3z00_14999;
						obj_t BgL_a4z00_15000;

						BgL_fz00_14996 =
							PROCEDURE_ENTRY(BgL_funz00_12478) (BgL_funz00_12478,
							BgL_sz00_12486, BEOA);
						BgL_a1z00_14997 =
							PROCEDURE_ENTRY(BgL_a1z00_12479) (BgL_a1z00_12479, BgL_sz00_12486,
							BEOA);
						BgL_a2z00_14998 =
							PROCEDURE_ENTRY(BgL_a2z00_12480) (BgL_a2z00_12480, BgL_sz00_12486,
							BEOA);
						BgL_a3z00_14999 =
							PROCEDURE_ENTRY(BgL_a3z00_12481) (BgL_a3z00_12481, BgL_sz00_12486,
							BEOA);
						BgL_a4z00_15000 =
							PROCEDURE_ENTRY(BgL_a4z00_12482) (BgL_a4z00_12482, BgL_sz00_12486,
							BEOA);
						if (PROCEDUREP(BgL_fz00_14996))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12483,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_14996);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15001;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21936;

								BgL_tmpz00_21936 = ((obj_t) BgL_fz00_14996);
								BgL_ufz00_15001 = PROCEDURE_ATTR(BgL_tmpz00_21936);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5177z00_21939;

								if (STRUCTP(BgL_ufz00_15001))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5177z00_21939 =
											(STRUCT_KEY(BgL_ufz00_15001) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5177z00_21939 = ((bool_t) 0);
									}
								if (BgL_test5177z00_21939)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15002;
										obj_t BgL_runz00_15003;
										obj_t BgL_sfz00_15004;

										BgL_arityz00_15002 =
											STRUCT_REF(BgL_ufz00_15001, (int) (((long) 0)));
										BgL_runz00_15003 =
											STRUCT_REF(BgL_ufz00_15001, (int) (((long) 1)));
										BgL_sfz00_15004 =
											STRUCT_REF(BgL_ufz00_15001, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15005;

											BgL_spz00_15005 =
												((long) CINT(BgL_bpz00_14995) + BgL_siza7eza7_12485);
											if (((long) CINT(BgL_arityz00_15002) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2532z00_15006;

														BgL_arg2532z00_15006 =
															(BgL_spz00_15005 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_12486), BgL_arg2532z00_15006,
															BgL_a1z00_14997);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2533z00_15007;

														BgL_arg2533z00_15007 =
															(BgL_spz00_15005 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_12486), BgL_arg2533z00_15007,
															BgL_a2z00_14998);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2535z00_15008;

														BgL_arg2535z00_15008 =
															(BgL_spz00_15005 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_12486), BgL_arg2535z00_15008,
															BgL_a3z00_14999);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2536z00_15009;

														BgL_arg2536z00_15009 =
															(BgL_spz00_15005 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_12486), BgL_arg2536z00_15009,
															BgL_a4z00_15000);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15002))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15002))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2538z00_15010;
																		obj_t BgL_arg2539z00_15011;

																		BgL_arg2538z00_15010 =
																			(BgL_spz00_15005 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2540z00_15012;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2541z00_15013;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2542z00_15014;

																					{	/* Eval/evaluate_comp.scm 896 */
																						obj_t BgL_arg2544z00_15015;

																						BgL_arg2544z00_15015 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_15000,
																							BNIL);
																						BgL_arg2542z00_15014 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_14999,
																							BgL_arg2544z00_15015);
																					}
																					BgL_arg2541z00_15013 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_14998,
																						BgL_arg2542z00_15014);
																				}
																				BgL_list2540z00_15012 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_14997,
																					BgL_arg2541z00_15013);
																			}
																			BgL_arg2539z00_15011 =
																				BgL_list2540z00_15012;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2538z00_15010,
																			BgL_arg2539z00_15011);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2545z00_15016;

																		BgL_arg2545z00_15016 =
																			(BgL_spz00_15005 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2545z00_15016, BgL_a1z00_14997);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2546z00_15017;
																		obj_t BgL_arg2547z00_15018;

																		BgL_arg2546z00_15017 =
																			(BgL_spz00_15005 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2548z00_15019;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2549z00_15020;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2550z00_15021;

																					BgL_arg2550z00_15021 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_15000,
																						BNIL);
																					BgL_arg2549z00_15020 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_14999,
																						BgL_arg2550z00_15021);
																				}
																				BgL_list2548z00_15019 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_14998,
																					BgL_arg2549z00_15020);
																			}
																			BgL_arg2547z00_15018 =
																				BgL_list2548z00_15019;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2546z00_15017,
																			BgL_arg2547z00_15018);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2552z00_15022;

																		BgL_arg2552z00_15022 =
																			(BgL_spz00_15005 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2552z00_15022, BgL_a1z00_14997);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2553z00_15023;

																		BgL_arg2553z00_15023 =
																			(BgL_spz00_15005 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2553z00_15023, BgL_a2z00_14998);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2554z00_15024;
																		obj_t BgL_arg2557z00_15025;

																		BgL_arg2554z00_15024 =
																			(BgL_spz00_15005 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2558z00_15026;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2565z00_15027;

																				BgL_arg2565z00_15027 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_15000,
																					BNIL);
																				BgL_list2558z00_15026 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_14999,
																					BgL_arg2565z00_15027);
																			}
																			BgL_arg2557z00_15025 =
																				BgL_list2558z00_15026;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2554z00_15024,
																			BgL_arg2557z00_15025);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2568z00_15028;

																		BgL_arg2568z00_15028 =
																			(BgL_spz00_15005 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2568z00_15028, BgL_a1z00_14997);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2569z00_15029;

																		BgL_arg2569z00_15029 =
																			(BgL_spz00_15005 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2569z00_15029, BgL_a2z00_14998);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2570z00_15030;

																		BgL_arg2570z00_15030 =
																			(BgL_spz00_15005 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2570z00_15030, BgL_a3z00_14999);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2572z00_15031;
																		obj_t BgL_arg2573z00_15032;

																		BgL_arg2572z00_15031 =
																			(BgL_spz00_15005 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2574z00_15033;

																			BgL_list2574z00_15033 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_15000, BNIL);
																			BgL_arg2573z00_15032 =
																				BgL_list2574z00_15033;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2572z00_15031,
																			BgL_arg2573z00_15032);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2575z00_15034;

																		BgL_arg2575z00_15034 =
																			(BgL_spz00_15005 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2575z00_15034, BgL_a1z00_14997);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2577z00_15035;

																		BgL_arg2577z00_15035 =
																			(BgL_spz00_15005 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2577z00_15035, BgL_a2z00_14998);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2578z00_15036;

																		BgL_arg2578z00_15036 =
																			(BgL_spz00_15005 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2578z00_15036, BgL_a3z00_14999);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2579z00_15037;

																		BgL_arg2579z00_15037 =
																			(BgL_spz00_15005 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2579z00_15037, BgL_a4z00_15000);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2580z00_15038;
																		obj_t BgL_arg2582z00_15039;

																		BgL_arg2580z00_15038 =
																			(BgL_spz00_15005 + ((long) 4));
																		BgL_arg2582z00_15039 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12486),
																			BgL_arg2580z00_15038,
																			BgL_arg2582z00_15039);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12483,
																		STRUCT_REF(BgL_ufz00_15001,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_15002));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12483, STRUCT_REF(BgL_ufz00_15001,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_15002));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15040;

												BgL_z12denvz12_15040 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15040,
													BgL_locz00_12483);
												if (((BgL_spz00_15005 + (long) CINT(BgL_sfz00_15004)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12486))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15003, BgL_sz00_12486,
															BINT(BgL_spz00_15005));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15041;

														BgL_nsz00_15041 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2586z00_15042;

															BgL_arg2586z00_15042 =
																(BgL_spz00_15005 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15041, ((long) 2), BgL_sz00_12486,
																BINT(BgL_spz00_15005),
																BINT(BgL_arg2586z00_15042));
														}
														VECTOR_SET(BgL_nsz00_15041, ((long) 1),
															BgL_sz00_12486);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15040,
															BgL_nsz00_15041);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15043;

															BgL_ez00_15043 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15043, BgL_sz00_12486);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15044;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15045;

																	BgL_savedzd2bpzd2_15045 =
																		VECTOR_REF(BgL_nsz00_15041, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15041, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15047;

																		BgL_fz00_15047 = BgL_runz00_15003;
																	BgL_recz00_15046:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15048;

																			BgL_rz00_15048 =
																				PROCEDURE_ENTRY(BgL_fz00_15047)
																				(BgL_fz00_15047, BgL_nsz00_15041, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5182z00_22062;

																				if (PROCEDUREP(BgL_rz00_15048))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_15049;

																						BgL_arg1729z00_15049 =
																							PROCEDURE_ATTR(BgL_rz00_15048);
																						if (STRUCTP(BgL_arg1729z00_15049))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5182z00_22062 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_15049) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5182z00_22062 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5182z00_22062 =
																							((bool_t) 0);
																					}
																				if (BgL_test5182z00_22062)
																					{
																						obj_t BgL_fz00_22070;

																						BgL_fz00_22070 = BgL_rz00_15048;
																						BgL_fz00_15047 = BgL_fz00_22070;
																						goto BgL_recz00_15046;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15041,
																							((long) 0),
																							BgL_savedzd2bpzd2_15045);
																						BgL_____rz00_15044 = BgL_rz00_15048;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15043);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15040,
																	BgL_sz00_12486);
																return BgL_____rz00_15044;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_14996,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15050;

												BgL_nbpz00_15050 =
													((long) CINT(BgL_bpz00_14995) + BgL_siza7eza7_12485);
												VECTOR_SET(
													((obj_t) BgL_sz00_12486), ((long) 0),
													BINT(BgL_nbpz00_15050));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_22082;

													BgL_tmpz00_22082 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22082,
														BgL_locz00_12483);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15051;

													BgL_rz00_15051 =
														PROCEDURE_ENTRY(BgL_fz00_14996) (BgL_fz00_14996,
														BgL_a1z00_14997, BgL_a2z00_14998, BgL_a3z00_14999,
														BgL_a4z00_15000, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12486), ((long) 0),
														BgL_bpz00_14995);
													return BgL_rz00_15051;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12483,
													BgL_symbzd2funzd2_12484, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_14996));
		}}}}}}}}

	}



/* &<@anonymous:2592> */
	obj_t BGl_z62zc3z04anonymousza32592ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12487, obj_t BgL_sz00_12496)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_12488;
				obj_t BgL_a1z00_12489;
				obj_t BgL_a2z00_12490;
				obj_t BgL_a3z00_12491;
				obj_t BgL_a4z00_12492;
				obj_t BgL_locz00_12493;
				obj_t BgL_symbzd2funzd2_12494;
				long BgL_siza7eza7_12495;

				BgL_funz00_12488 = PROCEDURE_REF(BgL_envz00_12487, (int) (((long) 0)));
				BgL_a1z00_12489 = PROCEDURE_REF(BgL_envz00_12487, (int) (((long) 1)));
				BgL_a2z00_12490 = PROCEDURE_REF(BgL_envz00_12487, (int) (((long) 2)));
				BgL_a3z00_12491 = PROCEDURE_REF(BgL_envz00_12487, (int) (((long) 3)));
				BgL_a4z00_12492 = PROCEDURE_REF(BgL_envz00_12487, (int) (((long) 4)));
				BgL_locz00_12493 = PROCEDURE_REF(BgL_envz00_12487, (int) (((long) 5)));
				BgL_symbzd2funzd2_12494 =
					PROCEDURE_REF(BgL_envz00_12487, (int) (((long) 6)));
				BgL_siza7eza7_12495 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12487, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15052;

					BgL_bpz00_15052 = VECTOR_REF(((obj_t) BgL_sz00_12496), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15053;
						obj_t BgL_a1z00_15054;
						obj_t BgL_a2z00_15055;
						obj_t BgL_a3z00_15056;
						obj_t BgL_a4z00_15057;

						BgL_fz00_15053 =
							PROCEDURE_ENTRY(BgL_funz00_12488) (BgL_funz00_12488,
							BgL_sz00_12496, BEOA);
						BgL_a1z00_15054 =
							PROCEDURE_ENTRY(BgL_a1z00_12489) (BgL_a1z00_12489, BgL_sz00_12496,
							BEOA);
						BgL_a2z00_15055 =
							PROCEDURE_ENTRY(BgL_a2z00_12490) (BgL_a2z00_12490, BgL_sz00_12496,
							BEOA);
						BgL_a3z00_15056 =
							PROCEDURE_ENTRY(BgL_a3z00_12491) (BgL_a3z00_12491, BgL_sz00_12496,
							BEOA);
						BgL_a4z00_15057 =
							PROCEDURE_ENTRY(BgL_a4z00_12492) (BgL_a4z00_12492, BgL_sz00_12496,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15053))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_12493,
									BGl_string4593z00zz__evaluate_compz00,
									BGl_string4609z00zz__evaluate_compz00, BgL_fz00_15053);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15058;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22139;

								BgL_tmpz00_22139 = ((obj_t) BgL_fz00_15053);
								BgL_ufz00_15058 = PROCEDURE_ATTR(BgL_tmpz00_22139);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test5187z00_22142;

								if (STRUCTP(BgL_ufz00_15058))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5187z00_22142 =
											(STRUCT_KEY(BgL_ufz00_15058) ==
											BGl_symbol4610z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test5187z00_22142 = ((bool_t) 0);
									}
								if (BgL_test5187z00_22142)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15059;
										obj_t BgL_runz00_15060;
										obj_t BgL_sfz00_15061;

										BgL_arityz00_15059 =
											STRUCT_REF(BgL_ufz00_15058, (int) (((long) 0)));
										BgL_runz00_15060 =
											STRUCT_REF(BgL_ufz00_15058, (int) (((long) 1)));
										BgL_sfz00_15061 =
											STRUCT_REF(BgL_ufz00_15058, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15062;

											BgL_spz00_15062 =
												((long) CINT(BgL_bpz00_15052) + BgL_siza7eza7_12495);
											if (((long) CINT(BgL_arityz00_15059) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2596z00_15063;

														BgL_arg2596z00_15063 =
															(BgL_spz00_15062 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_12496), BgL_arg2596z00_15063,
															BgL_a1z00_15054);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2597z00_15064;

														BgL_arg2597z00_15064 =
															(BgL_spz00_15062 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_12496), BgL_arg2597z00_15064,
															BgL_a2z00_15055);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2599z00_15065;

														BgL_arg2599z00_15065 =
															(BgL_spz00_15062 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_12496), BgL_arg2599z00_15065,
															BgL_a3z00_15056);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2600z00_15066;

														BgL_arg2600z00_15066 =
															(BgL_spz00_15062 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_12496), BgL_arg2600z00_15066,
															BgL_a4z00_15057);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15059))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15059))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2602z00_15067;
																		obj_t BgL_arg2603z00_15068;

																		BgL_arg2602z00_15067 =
																			(BgL_spz00_15062 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2604z00_15069;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2605z00_15070;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2607z00_15071;

																					{	/* Eval/evaluate_comp.scm 896 */
																						obj_t BgL_arg2608z00_15072;

																						BgL_arg2608z00_15072 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_15057,
																							BNIL);
																						BgL_arg2607z00_15071 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_15056,
																							BgL_arg2608z00_15072);
																					}
																					BgL_arg2605z00_15070 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_15055,
																						BgL_arg2607z00_15071);
																				}
																				BgL_list2604z00_15069 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_15054,
																					BgL_arg2605z00_15070);
																			}
																			BgL_arg2603z00_15068 =
																				BgL_list2604z00_15069;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2602z00_15067,
																			BgL_arg2603z00_15068);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2609z00_15073;

																		BgL_arg2609z00_15073 =
																			(BgL_spz00_15062 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2609z00_15073, BgL_a1z00_15054);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2610z00_15074;
																		obj_t BgL_arg2611z00_15075;

																		BgL_arg2610z00_15074 =
																			(BgL_spz00_15062 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2612z00_15076;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2613z00_15077;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2614z00_15078;

																					BgL_arg2614z00_15078 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_15057,
																						BNIL);
																					BgL_arg2613z00_15077 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_15056,
																						BgL_arg2614z00_15078);
																				}
																				BgL_list2612z00_15076 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_15055,
																					BgL_arg2613z00_15077);
																			}
																			BgL_arg2611z00_15075 =
																				BgL_list2612z00_15076;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2610z00_15074,
																			BgL_arg2611z00_15075);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2616z00_15079;

																		BgL_arg2616z00_15079 =
																			(BgL_spz00_15062 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2616z00_15079, BgL_a1z00_15054);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2617z00_15080;

																		BgL_arg2617z00_15080 =
																			(BgL_spz00_15062 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2617z00_15080, BgL_a2z00_15055);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2618z00_15081;
																		obj_t BgL_arg2619z00_15082;

																		BgL_arg2618z00_15081 =
																			(BgL_spz00_15062 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2620z00_15083;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2621z00_15084;

																				BgL_arg2621z00_15084 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_15057,
																					BNIL);
																				BgL_list2620z00_15083 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_15056,
																					BgL_arg2621z00_15084);
																			}
																			BgL_arg2619z00_15082 =
																				BgL_list2620z00_15083;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2618z00_15081,
																			BgL_arg2619z00_15082);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2622z00_15085;

																		BgL_arg2622z00_15085 =
																			(BgL_spz00_15062 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2622z00_15085, BgL_a1z00_15054);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2623z00_15086;

																		BgL_arg2623z00_15086 =
																			(BgL_spz00_15062 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2623z00_15086, BgL_a2z00_15055);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2625z00_15087;

																		BgL_arg2625z00_15087 =
																			(BgL_spz00_15062 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2625z00_15087, BgL_a3z00_15056);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2626z00_15088;
																		obj_t BgL_arg2627z00_15089;

																		BgL_arg2626z00_15088 =
																			(BgL_spz00_15062 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2628z00_15090;

																			BgL_list2628z00_15090 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_15057, BNIL);
																			BgL_arg2627z00_15089 =
																				BgL_list2628z00_15090;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2626z00_15088,
																			BgL_arg2627z00_15089);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2630z00_15091;

																		BgL_arg2630z00_15091 =
																			(BgL_spz00_15062 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2630z00_15091, BgL_a1z00_15054);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2632z00_15092;

																		BgL_arg2632z00_15092 =
																			(BgL_spz00_15062 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2632z00_15092, BgL_a2z00_15055);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2633z00_15093;

																		BgL_arg2633z00_15093 =
																			(BgL_spz00_15062 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2633z00_15093, BgL_a3z00_15056);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2634z00_15094;

																		BgL_arg2634z00_15094 =
																			(BgL_spz00_15062 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2634z00_15094, BgL_a4z00_15057);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2635z00_15095;
																		obj_t BgL_arg2636z00_15096;

																		BgL_arg2635z00_15095 =
																			(BgL_spz00_15062 + ((long) 4));
																		BgL_arg2636z00_15096 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_12496),
																			BgL_arg2635z00_15095,
																			BgL_arg2636z00_15096);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_12493,
																		STRUCT_REF(BgL_ufz00_15058,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_15059));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_12493, STRUCT_REF(BgL_ufz00_15058,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_15059));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15097;

												BgL_z12denvz12_15097 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15062 +
															(long) CINT(BgL_sfz00_15061)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_12496))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15060, BgL_sz00_12496,
															BINT(BgL_spz00_15062));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15098;

														BgL_nsz00_15098 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2640z00_15099;

															BgL_arg2640z00_15099 =
																(BgL_spz00_15062 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15098, ((long) 2), BgL_sz00_12496,
																BINT(BgL_spz00_15062),
																BINT(BgL_arg2640z00_15099));
														}
														VECTOR_SET(BgL_nsz00_15098, ((long) 1),
															BgL_sz00_12496);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15097,
															BgL_nsz00_15098);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15100;

															BgL_ez00_15100 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15100, BgL_sz00_12496);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15101;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15102;

																	BgL_savedzd2bpzd2_15102 =
																		VECTOR_REF(BgL_nsz00_15098, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15098, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15104;

																		BgL_fz00_15104 = BgL_runz00_15060;
																	BgL_recz00_15103:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15105;

																			BgL_rz00_15105 =
																				PROCEDURE_ENTRY(BgL_fz00_15104)
																				(BgL_fz00_15104, BgL_nsz00_15098, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test5192z00_22264;

																				if (PROCEDUREP(BgL_rz00_15105))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1729z00_15106;

																						BgL_arg1729z00_15106 =
																							PROCEDURE_ATTR(BgL_rz00_15105);
																						if (STRUCTP(BgL_arg1729z00_15106))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5192z00_22264 =
																									(STRUCT_KEY
																									(BgL_arg1729z00_15106) ==
																									BGl_symbol4589z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test5192z00_22264 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test5192z00_22264 =
																							((bool_t) 0);
																					}
																				if (BgL_test5192z00_22264)
																					{
																						obj_t BgL_fz00_22272;

																						BgL_fz00_22272 = BgL_rz00_15105;
																						BgL_fz00_15104 = BgL_fz00_22272;
																						goto BgL_recz00_15103;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15098,
																							((long) 0),
																							BgL_savedzd2bpzd2_15102);
																						BgL_____rz00_15101 = BgL_rz00_15105;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15100);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15097,
																	BgL_sz00_12496);
																return BgL_____rz00_15101;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15053,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15107;

												BgL_nbpz00_15107 =
													((long) CINT(BgL_bpz00_15052) + BgL_siza7eza7_12495);
												VECTOR_SET(
													((obj_t) BgL_sz00_12496), ((long) 0),
													BINT(BgL_nbpz00_15107));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15108;

													BgL_rz00_15108 =
														PROCEDURE_ENTRY(BgL_fz00_15053) (BgL_fz00_15053,
														BgL_a1z00_15054, BgL_a2z00_15055, BgL_a3z00_15056,
														BgL_a4z00_15057, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_12496), ((long) 0),
														BgL_bpz00_15052);
													return BgL_rz00_15108;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_12493,
													BgL_symbzd2funzd2_12494, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_15053));
		}}}}}}}}

	}



/* is-constant-fun? */
	obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185,
		obj_t BgL_symbzd2funzd2_186)
	{
		{	/* Eval/evaluate_comp.scm 899 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 903 */
					obj_t BgL_gz00_3035;

					{	/* Eval/evaluate_comp.scm 903 */
						obj_t BgL_arg2651z00_3043;
						obj_t BgL_arg2652z00_3044;

						BgL_arg2651z00_3043 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_modz00);
						BgL_arg2652z00_3044 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_namez00);
						BgL_gz00_3035 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg2651z00_3043, BgL_arg2652z00_3044);
					}
					if (CBOOL(BgL_gz00_3035))
						{	/* Eval/evaluate_comp.scm 905 */
							bool_t BgL_test5198z00_22306;

							{	/* Eval/evaluate_comp.scm 905 */
								int BgL_arg2650z00_3042;

								{	/* Eval/evaluate_comp.scm 905 */
									int BgL_res4450z00_8741;

									BgL_res4450z00_8741 =
										CINT(VECTOR_REF(((obj_t) BgL_gz00_3035), ((long) 0)));
									BgL_arg2650z00_3042 = BgL_res4450z00_8741;
								}
								BgL_test5198z00_22306 =
									((long) (BgL_arg2650z00_3042) == ((long) 0));
							}
							if (BgL_test5198z00_22306)
								{	/* Eval/evaluate_comp.scm 906 */
									obj_t BgL_valz00_3038;

									BgL_valz00_3038 =
										VECTOR_REF(((obj_t) BgL_gz00_3035), ((long) 2));
									{	/* Eval/evaluate_comp.scm 907 */
										bool_t BgL_test5199z00_22314;

										if (PROCEDUREP(BgL_valz00_3038))
											{	/* Eval/evaluate_comp.scm 907 */
												BgL_test5199z00_22314 =
													PROCEDURE_CORRECT_ARITYP(BgL_valz00_3038,
													(int) (BgL_nbargsz00_184));
											}
										else
											{	/* Eval/evaluate_comp.scm 907 */
												BgL_test5199z00_22314 = ((bool_t) 0);
											}
										if (BgL_test5199z00_22314)
											{	/* Eval/evaluate_comp.scm 907 */
												return BgL_valz00_3038;
											}
										else
											{	/* Eval/evaluate_comp.scm 907 */
												return BFALSE;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 905 */
									return BFALSE;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 904 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 910 */
					bool_t BgL_test5201z00_22319;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 911 */
							obj_t BgL_tmpz00_22323;

							BgL_tmpz00_22323 =
								(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
							BgL_test5201z00_22319 = PROCEDUREP(BgL_tmpz00_22323);
						}
					else
						{	/* Eval/evaluate_comp.scm 910 */
							BgL_test5201z00_22319 = ((bool_t) 0);
						}
					if (BgL_test5201z00_22319)
						{	/* Eval/evaluate_comp.scm 913 */
							bool_t BgL_test5203z00_22327;

							{	/* Eval/evaluate_comp.scm 913 */
								obj_t BgL_arg2662z00_3054;

								BgL_arg2662z00_3054 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								BgL_test5203z00_22327 =
									PROCEDURE_CORRECT_ARITYP(BgL_arg2662z00_3054,
									(int) (BgL_nbargsz00_184));
							}
							if (BgL_test5203z00_22327)
								{	/* Eval/evaluate_comp.scm 913 */
									return
										(((BgL_ev_littz00_bglt) COBJECT(
												((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 915 */
									int BgL_arg2659z00_3052;

									{	/* Eval/evaluate_comp.scm 915 */
										obj_t BgL_arg2661z00_3053;

										BgL_arg2661z00_3053 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_funz00_183)))->
											BgL_valuez00);
										BgL_arg2659z00_3052 = PROCEDURE_ARITY(BgL_arg2661z00_3053);
									}
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185,
										BgL_symbzd2funzd2_186, (int) (BgL_nbargsz00_184),
										BgL_arg2659z00_3052);
						}}
					else
						{	/* Eval/evaluate_comp.scm 910 */
							return BFALSE;
						}
				}
		}

	}



/* compile-float-arith */
	obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t
		BgL_exprz00_187, obj_t BgL_stkz00_188)
	{
		{	/* Eval/evaluate_comp.scm 918 */
			if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
					BGl_ev_littz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 922 */
					if (INTEGERP(
							(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00)))
						{	/* Eval/evaluate_comp.scm 924 */
							obj_t BgL_v1350z00_3063;

							BgL_v1350z00_3063 = create_vector(((long) 2));
							VECTOR_SET(BgL_v1350z00_3063, ((long) 0), BINT(((long) 1)));
							{	/* Eval/evaluate_comp.scm 924 */
								double BgL_arg2667z00_3064;

								BgL_arg2667z00_3064 =
									(double) (
									(long) CINT(
										(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00)));
								VECTOR_SET(BgL_v1350z00_3063, ((long) 1),
									DOUBLE_TO_REAL(BgL_arg2667z00_3064));
							}
							return BgL_v1350z00_3063;
						}
					else
						{	/* Eval/evaluate_comp.scm 925 */
							bool_t BgL_test5206z00_22354;

							{	/* Eval/evaluate_comp.scm 925 */
								obj_t BgL_tmpz00_22355;

								BgL_tmpz00_22355 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00);
								BgL_test5206z00_22354 = REALP(BgL_tmpz00_22355);
							}
							if (BgL_test5206z00_22354)
								{	/* Eval/evaluate_comp.scm 925 */
									obj_t BgL_v1351z00_3068;

									BgL_v1351z00_3068 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1351z00_3068, ((long) 0), BINT(((long) 1)));
									{	/* Eval/evaluate_comp.scm 925 */
										obj_t BgL_arg2671z00_3069;

										BgL_arg2671z00_3069 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00);
										VECTOR_SET(BgL_v1351z00_3068, ((long) 1),
											BgL_arg2671z00_3069);
									}
									return BgL_v1351z00_3068;
								}
							else
								{	/* Eval/evaluate_comp.scm 926 */
									obj_t BgL_v1352z00_3070;

									BgL_v1352z00_3070 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1352z00_3070, ((long) 0), BINT(((long) 0)));
									{	/* Eval/evaluate_comp.scm 926 */
										obj_t BgL_arg2673z00_3071;

										BgL_arg2673z00_3071 =
											BGl_compz00zz__evaluate_compz00(
											((BgL_ev_exprz00_bglt)
												((BgL_ev_littz00_bglt) BgL_exprz00_187)),
											BgL_stkz00_188);
										VECTOR_SET(BgL_v1352z00_3070, ((long) 1),
											BgL_arg2673z00_3071);
									}
									return BgL_v1352z00_3070;
								}
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 922 */
					if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
							BGl_ev_varz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 927 */
							if (CBOOL(
									(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_exprz00_187)))->BgL_effz00)))
								{	/* Eval/evaluate_comp.scm 930 */
									obj_t BgL_v1353z00_3077;

									BgL_v1353z00_3077 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1353z00_3077, ((long) 0), BINT(((long) 3)));
									VECTOR_SET(BgL_v1353z00_3077, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1353z00_3077;
								}
							else
								{	/* Eval/evaluate_comp.scm 931 */
									obj_t BgL_v1354z00_3079;

									BgL_v1354z00_3079 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1354z00_3079, ((long) 0), BINT(((long) 2)));
									VECTOR_SET(BgL_v1354z00_3079, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1354z00_3079;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 927 */
							if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
									BGl_ev_globalz00zz__evaluate_typesz00))
								{	/* Eval/evaluate_comp.scm 934 */
									obj_t BgL_gz00_3083;

									{	/* Eval/evaluate_comp.scm 934 */
										obj_t BgL_arg2685z00_3091;
										obj_t BgL_arg2686z00_3092;

										BgL_arg2685z00_3091 =
											(((BgL_ev_globalz00_bglt) COBJECT(
													((BgL_ev_globalz00_bglt) BgL_exprz00_187)))->
											BgL_modz00);
										BgL_arg2686z00_3092 =
											(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
														BgL_exprz00_187)))->BgL_namez00);
										BgL_gz00_3083 =
											BGl_evmodulezd2findzd2globalz00zz__evmodulez00
											(BgL_arg2685z00_3091, BgL_arg2686z00_3092);
									}
									if (CBOOL(BgL_gz00_3083))
										{	/* Eval/evaluate_comp.scm 936 */
											bool_t BgL_test5211z00_22397;

											{	/* Eval/evaluate_comp.scm 936 */
												int BgL_arg2683z00_3088;

												{	/* Eval/evaluate_comp.scm 936 */
													int BgL_res4451z00_8758;

													BgL_res4451z00_8758 =
														CINT(VECTOR_REF(
															((obj_t) BgL_gz00_3083), ((long) 0)));
													BgL_arg2683z00_3088 = BgL_res4451z00_8758;
												}
												BgL_test5211z00_22397 =
													(BINT(BgL_arg2683z00_3088) == BINT(((long) 1)));
											}
											if (BgL_test5211z00_22397)
												{	/* Eval/evaluate_comp.scm 937 */
													obj_t BgL_v1355z00_3086;

													BgL_v1355z00_3086 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1355z00_3086, ((long) 0),
														BINT(((long) 4)));
													VECTOR_SET(BgL_v1355z00_3086, ((long) 1),
														BgL_gz00_3083);
													return BgL_v1355z00_3086;
												}
											else
												{	/* Eval/evaluate_comp.scm 938 */
													obj_t BgL_v1356z00_3087;

													BgL_v1356z00_3087 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1356z00_3087, ((long) 0),
														BINT(((long) 5)));
													VECTOR_SET(BgL_v1356z00_3087, ((long) 1),
														BgL_gz00_3083);
													return BgL_v1356z00_3087;
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 939 */
											obj_t BgL_v1357z00_3089;

											BgL_v1357z00_3089 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1357z00_3089, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 939 */
												obj_t BgL_arg2684z00_3090;

												BgL_arg2684z00_3090 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt)
														((BgL_ev_globalz00_bglt) BgL_exprz00_187)),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1357z00_3089, ((long) 1),
													BgL_arg2684z00_3090);
											}
											return BgL_v1357z00_3089;
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 932 */
									if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
											BGl_ev_appz00zz__evaluate_typesz00))
										{	/* Eval/evaluate_comp.scm 942 */
											obj_t BgL_fvalz00_3095;

											{	/* Eval/evaluate_comp.scm 942 */
												BgL_ev_exprz00_bglt BgL_arg2738z00_3143;

												BgL_arg2738z00_3143 =
													(((BgL_ev_appz00_bglt) COBJECT(
															((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
													BgL_funz00);
												BgL_fvalz00_3095 =
													BGl_globalzd2funzd2valuez00zz__evaluate_compz00
													(BgL_arg2738z00_3143);
											}
											if (
												(BgL_fvalz00_3095 ==
													BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
												{	/* Eval/evaluate_comp.scm 945 */
													obj_t BgL_v1358z00_3097;

													BgL_v1358z00_3097 = create_vector(((long) 3));
													VECTOR_SET(BgL_v1358z00_3097, ((long) 0),
														BINT(((long) 6)));
													{	/* Eval/evaluate_comp.scm 945 */
														obj_t BgL_arg2689z00_3098;

														{	/* Eval/evaluate_comp.scm 945 */
															obj_t BgL_arg2691z00_3099;

															{	/* Eval/evaluate_comp.scm 945 */
																obj_t BgL_pairz00_8766;

																BgL_pairz00_8766 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2691z00_3099 = CAR(BgL_pairz00_8766);
															}
															BgL_arg2689z00_3098 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2691z00_3099, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1358z00_3097, ((long) 1),
															BgL_arg2689z00_3098);
													}
													{	/* Eval/evaluate_comp.scm 945 */
														obj_t BgL_arg2693z00_3101;

														{	/* Eval/evaluate_comp.scm 945 */
															obj_t BgL_arg2695z00_3102;

															{	/* Eval/evaluate_comp.scm 945 */
																obj_t BgL_pairz00_8768;

																BgL_pairz00_8768 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2695z00_3102 =
																	CAR(CDR(BgL_pairz00_8768));
															}
															BgL_arg2693z00_3101 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2695z00_3102, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1358z00_3097, ((long) 2),
															BgL_arg2693z00_3101);
													}
													return BgL_v1358z00_3097;
												}
											else
												{	/* Eval/evaluate_comp.scm 944 */
													if (
														(BgL_fvalz00_3095 ==
															BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
														{	/* Eval/evaluate_comp.scm 947 */
															obj_t BgL_v1359z00_3105;

															BgL_v1359z00_3105 = create_vector(((long) 3));
															VECTOR_SET(BgL_v1359z00_3105, ((long) 0),
																BINT(((long) 7)));
															{	/* Eval/evaluate_comp.scm 947 */
																obj_t BgL_arg2698z00_3106;

																{	/* Eval/evaluate_comp.scm 947 */
																	obj_t BgL_arg2699z00_3107;

																	{	/* Eval/evaluate_comp.scm 947 */
																		obj_t BgL_pairz00_8774;

																		BgL_pairz00_8774 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2699z00_3107 = CAR(BgL_pairz00_8774);
																	}
																	BgL_arg2698z00_3106 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2699z00_3107, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1359z00_3105, ((long) 1),
																	BgL_arg2698z00_3106);
															}
															{	/* Eval/evaluate_comp.scm 947 */
																obj_t BgL_arg2701z00_3109;

																{	/* Eval/evaluate_comp.scm 947 */
																	obj_t BgL_arg2702z00_3110;

																	{	/* Eval/evaluate_comp.scm 947 */
																		obj_t BgL_pairz00_8776;

																		BgL_pairz00_8776 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2702z00_3110 =
																			CAR(CDR(BgL_pairz00_8776));
																	}
																	BgL_arg2701z00_3109 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2702z00_3110, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1359z00_3105, ((long) 2),
																	BgL_arg2701z00_3109);
															}
															return BgL_v1359z00_3105;
														}
													else
														{	/* Eval/evaluate_comp.scm 946 */
															if (
																(BgL_fvalz00_3095 ==
																	BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																{	/* Eval/evaluate_comp.scm 949 */
																	obj_t BgL_v1360z00_3113;

																	BgL_v1360z00_3113 = create_vector(((long) 3));
																	VECTOR_SET(BgL_v1360z00_3113, ((long) 0),
																		BINT(((long) 8)));
																	{	/* Eval/evaluate_comp.scm 949 */
																		obj_t BgL_arg2707z00_3114;

																		{	/* Eval/evaluate_comp.scm 949 */
																			obj_t BgL_arg2708z00_3115;

																			{	/* Eval/evaluate_comp.scm 949 */
																				obj_t BgL_pairz00_8782;

																				BgL_pairz00_8782 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2708z00_3115 =
																					CAR(BgL_pairz00_8782);
																			}
																			BgL_arg2707z00_3114 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2708z00_3115, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1360z00_3113, ((long) 1),
																			BgL_arg2707z00_3114);
																	}
																	{	/* Eval/evaluate_comp.scm 949 */
																		obj_t BgL_arg2710z00_3117;

																		{	/* Eval/evaluate_comp.scm 949 */
																			obj_t BgL_arg2711z00_3118;

																			{	/* Eval/evaluate_comp.scm 949 */
																				obj_t BgL_pairz00_8784;

																				BgL_pairz00_8784 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2711z00_3118 =
																					CAR(CDR(BgL_pairz00_8784));
																			}
																			BgL_arg2710z00_3117 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2711z00_3118, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1360z00_3113, ((long) 2),
																			BgL_arg2710z00_3117);
																	}
																	return BgL_v1360z00_3113;
																}
															else
																{	/* Eval/evaluate_comp.scm 948 */
																	if (
																		(BgL_fvalz00_3095 ==
																			BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																		{	/* Eval/evaluate_comp.scm 951 */
																			obj_t BgL_v1361z00_3121;

																			BgL_v1361z00_3121 =
																				create_vector(((long) 3));
																			VECTOR_SET(BgL_v1361z00_3121, ((long) 0),
																				BINT(((long) 9)));
																			{	/* Eval/evaluate_comp.scm 951 */
																				obj_t BgL_arg2714z00_3122;

																				{	/* Eval/evaluate_comp.scm 951 */
																					obj_t BgL_arg2716z00_3123;

																					{	/* Eval/evaluate_comp.scm 951 */
																						obj_t BgL_pairz00_8790;

																						BgL_pairz00_8790 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2716z00_3123 =
																							CAR(BgL_pairz00_8790);
																					}
																					BgL_arg2714z00_3122 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2716z00_3123,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1361z00_3121,
																					((long) 1), BgL_arg2714z00_3122);
																			}
																			{	/* Eval/evaluate_comp.scm 951 */
																				obj_t BgL_arg2718z00_3125;

																				{	/* Eval/evaluate_comp.scm 951 */
																					obj_t BgL_arg2719z00_3126;

																					{	/* Eval/evaluate_comp.scm 951 */
																						obj_t BgL_pairz00_8792;

																						BgL_pairz00_8792 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2719z00_3126 =
																							CAR(CDR(BgL_pairz00_8792));
																					}
																					BgL_arg2718z00_3125 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2719z00_3126,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1361z00_3121,
																					((long) 2), BgL_arg2718z00_3125);
																			}
																			return BgL_v1361z00_3121;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 950 */
																			if (
																				(BgL_fvalz00_3095 ==
																					BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 953 */
																					obj_t BgL_v1362z00_3129;

																					BgL_v1362z00_3129 =
																						create_vector(((long) 2));
																					VECTOR_SET(BgL_v1362z00_3129,
																						((long) 0), BINT(((long) 10)));
																					{	/* Eval/evaluate_comp.scm 953 */
																						obj_t BgL_arg2722z00_3130;

																						{	/* Eval/evaluate_comp.scm 953 */
																							obj_t BgL_arg2723z00_3131;

																							{	/* Eval/evaluate_comp.scm 953 */
																								obj_t BgL_pairz00_8798;

																								BgL_pairz00_8798 =
																									(((BgL_ev_appz00_bglt)
																										COBJECT((
																												(BgL_ev_appz00_bglt)
																												BgL_exprz00_187)))->
																									BgL_argsz00);
																								BgL_arg2723z00_3131 =
																									CAR(BgL_pairz00_8798);
																							}
																							BgL_arg2722z00_3130 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_arg2723z00_3131),
																								BgL_stkz00_188);
																						}
																						VECTOR_SET(BgL_v1362z00_3129,
																							((long) 1), BgL_arg2722z00_3130);
																					}
																					return BgL_v1362z00_3129;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 952 */
																					if (
																						(BgL_fvalz00_3095 ==
																							BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
																						{	/* Eval/evaluate_comp.scm 955 */
																							obj_t BgL_v1363z00_3134;

																							BgL_v1363z00_3134 =
																								create_vector(((long) 3));
																							VECTOR_SET(BgL_v1363z00_3134,
																								((long) 0), BINT(((long) 11)));
																							{	/* Eval/evaluate_comp.scm 955 */
																								obj_t BgL_arg2726z00_3135;

																								{	/* Eval/evaluate_comp.scm 955 */
																									obj_t BgL_arg2727z00_3136;

																									{	/* Eval/evaluate_comp.scm 955 */
																										obj_t BgL_pairz00_8801;

																										BgL_pairz00_8801 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2727z00_3136 =
																											CAR(BgL_pairz00_8801);
																									}
																									BgL_arg2726z00_3135 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2727z00_3136),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1363z00_3134,
																									((long) 1),
																									BgL_arg2726z00_3135);
																							}
																							{	/* Eval/evaluate_comp.scm 955 */
																								obj_t BgL_arg2733z00_3138;

																								{	/* Eval/evaluate_comp.scm 955 */
																									obj_t BgL_arg2735z00_3139;

																									{	/* Eval/evaluate_comp.scm 955 */
																										obj_t BgL_pairz00_8803;

																										BgL_pairz00_8803 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2735z00_3139 =
																											CAR(CDR
																											(BgL_pairz00_8803));
																									}
																									BgL_arg2733z00_3138 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2735z00_3139),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1363z00_3134,
																									((long) 2),
																									BgL_arg2733z00_3138);
																							}
																							return BgL_v1363z00_3134;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 957 */
																							obj_t BgL_v1364z00_3141;

																							BgL_v1364z00_3141 =
																								create_vector(((long) 2));
																							VECTOR_SET(BgL_v1364z00_3141,
																								((long) 0), BINT(((long) 0)));
																							{	/* Eval/evaluate_comp.scm 957 */
																								obj_t BgL_arg2737z00_3142;

																								BgL_arg2737z00_3142 =
																									BGl_compz00zz__evaluate_compz00
																									(((BgL_ev_exprz00_bglt) (
																											(BgL_ev_appz00_bglt)
																											BgL_exprz00_187)),
																									BgL_stkz00_188);
																								VECTOR_SET(BgL_v1364z00_3141,
																									((long) 1),
																									BgL_arg2737z00_3142);
																							}
																							return BgL_v1364z00_3141;
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 958 */
											obj_t BgL_v1365z00_3144;

											BgL_v1365z00_3144 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1365z00_3144, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 958 */
												obj_t BgL_arg2740z00_3145;

												BgL_arg2740z00_3145 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_exprz00_187),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1365z00_3144, ((long) 1),
													BgL_arg2740z00_3145);
											}
											return BgL_v1365z00_3144;
										}
								}
						}
				}
		}

	}



/* eval-float-arith */
	double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189,
		obj_t BgL_sz00_190)
	{
		{	/* Eval/evaluate_comp.scm 960 */
			return
				REAL_TO_DOUBLE(BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190,
					BgL_bcz00_189));
		}

	}



/* E~0 */
	obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_14159,
		obj_t BgL_bcz00_3150)
	{
		{	/* Eval/evaluate_comp.scm 975 */
			{	/* Eval/evaluate_comp.scm 962 */
				obj_t BgL_aux1221z00_3153;

				BgL_aux1221z00_3153 = VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 0));
				if (INTEGERP(BgL_aux1221z00_3153))
					{	/* Eval/evaluate_comp.scm 962 */
						switch ((long) CINT(BgL_aux1221z00_3153))
							{
							case ((long) 0):

								{	/* Eval/evaluate_comp.scm 963 */
									obj_t BgL_fun2744z00_3155;

									BgL_fun2744z00_3155 =
										VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
									return
										PROCEDURE_ENTRY(BgL_fun2744z00_3155) (BgL_fun2744z00_3155,
										BgL_sz00_14159, BEOA);
								}
								break;
							case ((long) 1):

								return VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
								break;
							case ((long) 2):

								{	/* Eval/evaluate_comp.scm 965 */
									long BgL_arg2745z00_3156;

									{	/* Eval/evaluate_comp.scm 965 */
										obj_t BgL_arg2746z00_3157;
										obj_t BgL_arg2747z00_3158;

										BgL_arg2746z00_3157 =
											VECTOR_REF(((obj_t) BgL_sz00_14159), ((long) 0));
										BgL_arg2747z00_3158 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
										BgL_arg2745z00_3156 =
											(
											(long) CINT(BgL_arg2746z00_3157) +
											(long) CINT(BgL_arg2747z00_3158));
									}
									return
										VECTOR_REF(((obj_t) BgL_sz00_14159), BgL_arg2745z00_3156);
								}
								break;
							case ((long) 3):

								{	/* Eval/evaluate_comp.scm 966 */
									obj_t BgL_arg2749z00_3159;

									{	/* Eval/evaluate_comp.scm 966 */
										long BgL_arg2750z00_3160;

										{	/* Eval/evaluate_comp.scm 966 */
											obj_t BgL_arg2754z00_3161;
											obj_t BgL_arg2755z00_3162;

											BgL_arg2754z00_3161 =
												VECTOR_REF(((obj_t) BgL_sz00_14159), ((long) 0));
											BgL_arg2755z00_3162 =
												VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
											BgL_arg2750z00_3160 =
												(
												(long) CINT(BgL_arg2754z00_3161) +
												(long) CINT(BgL_arg2755z00_3162));
										}
										BgL_arg2749z00_3159 =
											VECTOR_REF(((obj_t) BgL_sz00_14159), BgL_arg2750z00_3160);
									}
									return
										STRUCT_REF(
										((obj_t) BgL_arg2749z00_3159), (int) (((long) 0)));
								} break;
							case ((long) 4):

								{	/* Eval/evaluate_comp.scm 967 */
									obj_t BgL_arg2756z00_3163;

									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_arg2758z00_3164;

										BgL_arg2758z00_3164 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
										BgL_arg2756z00_3163 =
											VECTOR_REF(((obj_t) BgL_arg2758z00_3164), ((long) 2));
									}
									return __EVMEANING_ADDRESS_REF(BgL_arg2756z00_3163);
								}
								break;
							case ((long) 5):

								{	/* Eval/evaluate_comp.scm 968 */
									obj_t BgL_arg2759z00_3165;

									BgL_arg2759z00_3165 =
										VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
									return VECTOR_REF(((obj_t) BgL_arg2759z00_3165), ((long) 2));
								} break;
							case ((long) 6):

								{	/* Eval/evaluate_comp.scm 969 */
									obj_t BgL_arg2760z00_3166;
									obj_t BgL_arg2761z00_3167;

									{	/* Eval/evaluate_comp.scm 969 */
										obj_t BgL_arg2762z00_3168;

										BgL_arg2762z00_3168 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
										BgL_arg2760z00_3166 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_14159,
											BgL_arg2762z00_3168);
									}
									{	/* Eval/evaluate_comp.scm 969 */
										obj_t BgL_arg2763z00_3169;

										BgL_arg2763z00_3169 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 2));
										BgL_arg2761z00_3167 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_14159,
											BgL_arg2763z00_3169);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2760z00_3166) +
											REAL_TO_DOUBLE(BgL_arg2761z00_3167)));
								}
								break;
							case ((long) 7):

								{	/* Eval/evaluate_comp.scm 970 */
									obj_t BgL_arg2764z00_3170;
									obj_t BgL_arg2766z00_3171;

									{	/* Eval/evaluate_comp.scm 970 */
										obj_t BgL_arg2767z00_3172;

										BgL_arg2767z00_3172 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
										BgL_arg2764z00_3170 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_14159,
											BgL_arg2767z00_3172);
									}
									{	/* Eval/evaluate_comp.scm 970 */
										obj_t BgL_arg2769z00_3173;

										BgL_arg2769z00_3173 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 2));
										BgL_arg2766z00_3171 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_14159,
											BgL_arg2769z00_3173);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2764z00_3170) -
											REAL_TO_DOUBLE(BgL_arg2766z00_3171)));
								}
								break;
							case ((long) 8):

								{	/* Eval/evaluate_comp.scm 971 */
									obj_t BgL_arg2776z00_3174;
									obj_t BgL_arg2778z00_3175;

									{	/* Eval/evaluate_comp.scm 971 */
										obj_t BgL_arg2779z00_3176;

										BgL_arg2779z00_3176 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
										BgL_arg2776z00_3174 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_14159,
											BgL_arg2779z00_3176);
									}
									{	/* Eval/evaluate_comp.scm 971 */
										obj_t BgL_arg2780z00_3177;

										BgL_arg2780z00_3177 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 2));
										BgL_arg2778z00_3175 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_14159,
											BgL_arg2780z00_3177);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2776z00_3174) *
											REAL_TO_DOUBLE(BgL_arg2778z00_3175)));
								}
								break;
							case ((long) 9):

								{	/* Eval/evaluate_comp.scm 972 */
									obj_t BgL_arg2783z00_3178;
									obj_t BgL_arg2784z00_3179;

									{	/* Eval/evaluate_comp.scm 972 */
										obj_t BgL_arg2787z00_3180;

										BgL_arg2787z00_3180 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
										BgL_arg2783z00_3178 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_14159,
											BgL_arg2787z00_3180);
									}
									{	/* Eval/evaluate_comp.scm 972 */
										obj_t BgL_arg2788z00_3181;

										BgL_arg2788z00_3181 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 2));
										BgL_arg2784z00_3179 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_14159,
											BgL_arg2788z00_3181);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2783z00_3178) /
											REAL_TO_DOUBLE(BgL_arg2784z00_3179)));
								}
								break;
							case ((long) 10):

								{	/* Eval/evaluate_comp.scm 973 */
									obj_t BgL_arg2789z00_3182;

									{	/* Eval/evaluate_comp.scm 973 */
										obj_t BgL_fun2790z00_3183;

										BgL_fun2790z00_3183 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
										BgL_arg2789z00_3182 =
											PROCEDURE_ENTRY(BgL_fun2790z00_3183) (BgL_fun2790z00_3183,
											BgL_sz00_14159, BEOA);
									}
									return
										DOUBLE_TO_REAL((double) ((long) CINT(BgL_arg2789z00_3182)));
								} break;
							case ((long) 11):

								{	/* Eval/evaluate_comp.scm 974 */
									obj_t BgL_arg2793z00_3184;
									obj_t BgL_arg2794z00_3185;

									{	/* Eval/evaluate_comp.scm 974 */
										obj_t BgL_fun2795z00_3186;

										BgL_fun2795z00_3186 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 1));
										BgL_arg2793z00_3184 =
											PROCEDURE_ENTRY(BgL_fun2795z00_3186) (BgL_fun2795z00_3186,
											BgL_sz00_14159, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 974 */
										obj_t BgL_fun2796z00_3187;

										BgL_fun2796z00_3187 =
											VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 2));
										BgL_arg2794z00_3185 =
											PROCEDURE_ENTRY(BgL_fun2796z00_3187) (BgL_fun2796z00_3187,
											BgL_sz00_14159, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 974 */
										double BgL_tmpz00_22635;

										{	/* Eval/evaluate_comp.scm 974 */
											long BgL_tmpz00_22636;

											BgL_tmpz00_22636 = (long) CINT(BgL_arg2794z00_3185);
											BgL_tmpz00_22635 =
												BGL_F64VREF(BgL_arg2793z00_3184, BgL_tmpz00_22636);
										}
										return DOUBLE_TO_REAL(BgL_tmpz00_22635);
									}
								}
								break;
							default:
								{	/* Eval/evaluate_comp.scm 975 */
									obj_t BgL_arg2798z00_8856;

									BgL_arg2798z00_8856 =
										VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 0));
									return
										BGl_errorz00zz__errorz00
										(BGl_string4593z00zz__evaluate_compz00,
										BGl_string4612z00zz__evaluate_compz00, BgL_arg2798z00_8856);
								}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 975 */
						obj_t BgL_arg2798z00_8858;

						BgL_arg2798z00_8858 =
							VECTOR_REF(((obj_t) BgL_bcz00_3150), ((long) 0));
						return
							BGl_errorz00zz__errorz00(BGl_string4593z00zz__evaluate_compz00,
							BGl_string4612z00zz__evaluate_compz00, BgL_arg2798z00_8858);
					}
			}
		}

	}



/* arith-expression */
	obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_exprz00_191, obj_t BgL_stkz00_192)
	{
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 980 */
				obj_t BgL_fvalz00_3191;

				BgL_fvalz00_3191 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_exprz00_191))->BgL_funz00));
				{	/* Eval/evaluate_comp.scm 981 */
					bool_t BgL_test5220z00_22650;

					if (
						(BgL_fvalz00_3191 ==
							BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
						{	/* Eval/evaluate_comp.scm 981 */
							BgL_test5220z00_22650 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 981 */
							if (
								(BgL_fvalz00_3191 ==
									BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
								{	/* Eval/evaluate_comp.scm 981 */
									BgL_test5220z00_22650 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 981 */
									if (
										(BgL_fvalz00_3191 ==
											BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
										{	/* Eval/evaluate_comp.scm 981 */
											BgL_test5220z00_22650 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 981 */
											BgL_test5220z00_22650 =
												(BgL_fvalz00_3191 ==
												BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00);
										}
								}
						}
					if (BgL_test5220z00_22650)
						{	/* Eval/evaluate_comp.scm 982 */
							obj_t BgL_bcz00_3196;

							BgL_bcz00_3196 =
								BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
								((obj_t) BgL_exprz00_191), BgL_stkz00_192);
							{	/* Eval/evaluate_comp.scm 983 */
								obj_t BgL_zc3z04anonymousza32803ze3z87_12514;

								BgL_zc3z04anonymousza32803ze3z87_12514 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32803ze3z87_12514,
									(int) (((long) 0)), BgL_bcz00_3196);
								return BgL_zc3z04anonymousza32803ze3z87_12514;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 981 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &<@anonymous:2803> */
	obj_t BGl_z62zc3z04anonymousza32803ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12515, obj_t BgL_sz00_12517)
	{
		{	/* Eval/evaluate_comp.scm 983 */
			{	/* Eval/evaluate_comp.scm 983 */
				obj_t BgL_bcz00_12516;

				BgL_bcz00_12516 =
					((obj_t) PROCEDURE_REF(BgL_envz00_12515, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 983 */
					double BgL_tmpz00_22668;

					{	/* Eval/evaluate_comp.scm 983 */
						obj_t BgL_bpz00_15109;

						BgL_bpz00_15109 = VECTOR_REF(((obj_t) BgL_sz00_12517), ((long) 0));
						BgL_tmpz00_22668 =
							BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_12516,
							BgL_sz00_12517);
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_22668);
				}
			}
		}

	}



/* inline-call */
	obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193,
		BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195,
		obj_t BgL_stkz00_196)
	{
		{	/* Eval/evaluate_comp.scm 1012 */
			{	/* Eval/evaluate_comp.scm 1013 */
				obj_t BgL_valz00_3204;

				BgL_valz00_3204 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194);
				if (CBOOL(BgL_valz00_3204))
					{	/* Eval/evaluate_comp.scm 1015 */
						long BgL_nz00_3205;

						BgL_nz00_3205 = bgl_list_length(BgL_argsz00_195);
						{	/* Eval/evaluate_comp.scm 1016 */
							obj_t BgL__ortest_1227z00_3206;

							if ((BgL_nz00_3205 == ((long) 1)))
								{	/* Eval/evaluate_comp.scm 1017 */
									obj_t BgL_a1z00_3497;

									BgL_a1z00_3497 = CAR(((obj_t) BgL_argsz00_195));
									if (
										(BgL_valz00_3204 ==
											BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
										{	/* Eval/evaluate_comp.scm 1018 */
											obj_t BgL_a1z00_3499;

											BgL_a1z00_3499 =
												BGl_compz00zz__evaluate_compz00(
												((BgL_ev_exprz00_bglt) BgL_a1z00_3497), BgL_stkz00_196);
											{	/* Eval/evaluate_comp.scm 1018 */
												obj_t BgL_zc3z04anonymousza32920ze3z87_12547;

												BgL_zc3z04anonymousza32920ze3z87_12547 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3z04anonymousza32920ze3ze5zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 2)));
												PROCEDURE_SET(BgL_zc3z04anonymousza32920ze3z87_12547,
													(int) (((long) 0)), BgL_a1z00_3499);
												PROCEDURE_SET(BgL_zc3z04anonymousza32920ze3z87_12547,
													(int) (((long) 1)), BgL_locz00_193);
												BgL__ortest_1227z00_3206 =
													BgL_zc3z04anonymousza32920ze3z87_12547;
										}}
									else
										{	/* Eval/evaluate_comp.scm 1018 */
											if (
												(BgL_valz00_3204 ==
													BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
												{	/* Eval/evaluate_comp.scm 1018 */
													obj_t BgL_a1z00_3506;

													BgL_a1z00_3506 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3497),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1018 */
														obj_t BgL_zc3z04anonymousza32923ze3z87_12548;

														BgL_zc3z04anonymousza32923ze3z87_12548 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32923ze3z87_12548,
															(int) (((long) 0)), BgL_a1z00_3506);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32923ze3z87_12548,
															(int) (((long) 1)), BgL_locz00_193);
														BgL__ortest_1227z00_3206 =
															BgL_zc3z04anonymousza32923ze3z87_12548;
												}}
											else
												{	/* Eval/evaluate_comp.scm 1018 */
													if (
														(BgL_valz00_3204 ==
															BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
														{	/* Eval/evaluate_comp.scm 1018 */
															obj_t BgL_a1z00_3513;

															BgL_a1z00_3513 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3497),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1018 */
																obj_t BgL_zc3z04anonymousza32926ze3z87_12549;

																BgL_zc3z04anonymousza32926ze3z87_12549 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3z04anonymousza32926ze3ze5zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 2)));
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32926ze3z87_12549,
																	(int) (((long) 0)), BgL_a1z00_3513);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32926ze3z87_12549,
																	(int) (((long) 1)), BgL_locz00_193);
																BgL__ortest_1227z00_3206 =
																	BgL_zc3z04anonymousza32926ze3z87_12549;
														}}
													else
														{	/* Eval/evaluate_comp.scm 1018 */
															BgL__ortest_1227z00_3206 = BFALSE;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1016 */
									BgL__ortest_1227z00_3206 = BFALSE;
								}
							if (CBOOL(BgL__ortest_1227z00_3206))
								{	/* Eval/evaluate_comp.scm 1016 */
									return BgL__ortest_1227z00_3206;
								}
							else
								{	/* Eval/evaluate_comp.scm 1016 */
									if ((BgL_nz00_3205 == ((long) 2)))
										{	/* Eval/evaluate_comp.scm 1020 */
											obj_t BgL_a1z00_3208;
											obj_t BgL_a2z00_3209;

											BgL_a1z00_3208 = CAR(((obj_t) BgL_argsz00_195));
											{	/* Eval/evaluate_comp.scm 1020 */
												obj_t BgL_pairz00_8883;

												BgL_pairz00_8883 = CDR(((obj_t) BgL_argsz00_195));
												BgL_a2z00_3209 = CAR(BgL_pairz00_8883);
											}
											if (
												(BgL_valz00_3204 ==
													BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
												{	/* Eval/evaluate_comp.scm 1021 */
													obj_t BgL_a1z00_3211;
													obj_t BgL_a2z00_3212;

													BgL_a1z00_3211 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3208),
														BgL_stkz00_196);
													BgL_a2z00_3212 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_a2z00_3209),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1021 */
														obj_t BgL_zc3z04anonymousza32807ze3z87_12518;

														BgL_zc3z04anonymousza32807ze3z87_12518 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza32807ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 3)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32807ze3z87_12518,
															(int) (((long) 0)), BgL_a1z00_3211);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32807ze3z87_12518,
															(int) (((long) 1)), BgL_a2z00_3212);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32807ze3z87_12518,
															(int) (((long) 2)), BgL_locz00_193);
														return BgL_zc3z04anonymousza32807ze3z87_12518;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 1021 */
													if (
														(BgL_valz00_3204 ==
															BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
														{	/* Eval/evaluate_comp.scm 1021 */
															obj_t BgL_a1z00_3221;
															obj_t BgL_a2z00_3222;

															BgL_a1z00_3221 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3208),
																BgL_stkz00_196);
															BgL_a2z00_3222 =
																BGl_compz00zz__evaluate_compz00((
																	(BgL_ev_exprz00_bglt) BgL_a2z00_3209),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1021 */
																obj_t BgL_zc3z04anonymousza32811ze3z87_12519;

																BgL_zc3z04anonymousza32811ze3z87_12519 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3z04anonymousza32811ze3ze5zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32811ze3z87_12519,
																	(int) (((long) 0)), BgL_a1z00_3221);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32811ze3z87_12519,
																	(int) (((long) 1)), BgL_a2z00_3222);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32811ze3z87_12519,
																	(int) (((long) 2)), BgL_locz00_193);
																return BgL_zc3z04anonymousza32811ze3z87_12519;
															}
														}
													else
														{	/* Eval/evaluate_comp.scm 1021 */
															if (
																(BgL_valz00_3204 ==
																	BGl_za2zd2envz70zz__r4_numbers_6_5z00))
																{	/* Eval/evaluate_comp.scm 1021 */
																	obj_t BgL_a1z00_3231;
																	obj_t BgL_a2z00_3232;

																	BgL_a1z00_3231 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt) BgL_a1z00_3208),
																		BgL_stkz00_196);
																	BgL_a2z00_3232 =
																		BGl_compz00zz__evaluate_compz00((
																			(BgL_ev_exprz00_bglt) BgL_a2z00_3209),
																		BgL_stkz00_196);
																	{	/* Eval/evaluate_comp.scm 1021 */
																		obj_t
																			BgL_zc3z04anonymousza32815ze3z87_12520;
																		BgL_zc3z04anonymousza32815ze3z87_12520 =
																			MAKE_FX_PROCEDURE
																			(BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00,
																			(int) (((long) 1)), (int) (((long) 3)));
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32815ze3z87_12520,
																			(int) (((long) 0)), BgL_a1z00_3231);
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32815ze3z87_12520,
																			(int) (((long) 1)), BgL_a2z00_3232);
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32815ze3z87_12520,
																			(int) (((long) 2)), BgL_locz00_193);
																		return
																			BgL_zc3z04anonymousza32815ze3z87_12520;
																	}
																}
															else
																{	/* Eval/evaluate_comp.scm 1021 */
																	if (
																		(BgL_valz00_3204 ==
																			BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
																		{	/* Eval/evaluate_comp.scm 1021 */
																			obj_t BgL_a1z00_3241;
																			obj_t BgL_a2z00_3242;

																			BgL_a1z00_3241 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt) BgL_a1z00_3208),
																				BgL_stkz00_196);
																			BgL_a2z00_3242 =
																				BGl_compz00zz__evaluate_compz00((
																					(BgL_ev_exprz00_bglt) BgL_a2z00_3209),
																				BgL_stkz00_196);
																			{	/* Eval/evaluate_comp.scm 1021 */
																				obj_t
																					BgL_zc3z04anonymousza32819ze3z87_12521;
																				BgL_zc3z04anonymousza32819ze3z87_12521 =
																					MAKE_FX_PROCEDURE
																					(BGl_z62zc3z04anonymousza32819ze3ze5zz__evaluate_compz00,
																					(int) (((long) 1)),
																					(int) (((long) 3)));
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32819ze3z87_12521,
																					(int) (((long) 0)), BgL_a1z00_3241);
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32819ze3z87_12521,
																					(int) (((long) 1)), BgL_a2z00_3242);
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32819ze3z87_12521,
																					(int) (((long) 2)), BgL_locz00_193);
																				return
																					BgL_zc3z04anonymousza32819ze3z87_12521;
																			}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 1021 */
																			if (
																				(BgL_valz00_3204 ==
																					BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 1021 */
																					obj_t BgL_a1z00_3251;
																					obj_t BgL_a2z00_3252;

																					BgL_a1z00_3251 =
																						BGl_compz00zz__evaluate_compz00(
																						((BgL_ev_exprz00_bglt)
																							BgL_a1z00_3208), BgL_stkz00_196);
																					BgL_a2z00_3252 =
																						BGl_compz00zz__evaluate_compz00((
																							(BgL_ev_exprz00_bglt)
																							BgL_a2z00_3209), BgL_stkz00_196);
																					{	/* Eval/evaluate_comp.scm 1021 */
																						obj_t
																							BgL_zc3z04anonymousza32823ze3z87_12522;
																						BgL_zc3z04anonymousza32823ze3z87_12522
																							=
																							MAKE_FX_PROCEDURE
																							(BGl_z62zc3z04anonymousza32823ze3ze5zz__evaluate_compz00,
																							(int) (((long) 1)),
																							(int) (((long) 3)));
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32823ze3z87_12522,
																							(int) (((long) 0)),
																							BgL_a1z00_3251);
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32823ze3z87_12522,
																							(int) (((long) 1)),
																							BgL_a2z00_3252);
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32823ze3z87_12522,
																							(int) (((long) 2)),
																							BgL_locz00_193);
																						return
																							BgL_zc3z04anonymousza32823ze3z87_12522;
																					}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 1021 */
																					if (
																						(BgL_valz00_3204 ==
																							BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
																						{	/* Eval/evaluate_comp.scm 1021 */
																							obj_t BgL_a1z00_3261;
																							obj_t BgL_a2z00_3262;

																							BgL_a1z00_3261 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a1z00_3208),
																								BgL_stkz00_196);
																							BgL_a2z00_3262 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a2z00_3209),
																								BgL_stkz00_196);
																							{	/* Eval/evaluate_comp.scm 1021 */
																								obj_t
																									BgL_zc3z04anonymousza32827ze3z87_12523;
																								BgL_zc3z04anonymousza32827ze3z87_12523
																									=
																									MAKE_FX_PROCEDURE
																									(BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00,
																									(int) (((long) 1)),
																									(int) (((long) 3)));
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32827ze3z87_12523,
																									(int) (((long) 0)),
																									BgL_a1z00_3261);
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32827ze3z87_12523,
																									(int) (((long) 1)),
																									BgL_a2z00_3262);
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32827ze3z87_12523,
																									(int) (((long) 2)),
																									BgL_locz00_193);
																								return
																									BgL_zc3z04anonymousza32827ze3z87_12523;
																							}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 1021 */
																							if (
																								(BgL_valz00_3204 ==
																									BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
																								{	/* Eval/evaluate_comp.scm 1021 */
																									obj_t BgL_a1z00_3271;
																									obj_t BgL_a2z00_3272;

																									BgL_a1z00_3271 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a1z00_3208),
																										BgL_stkz00_196);
																									BgL_a2z00_3272 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a2z00_3209),
																										BgL_stkz00_196);
																									{	/* Eval/evaluate_comp.scm 1021 */
																										obj_t
																											BgL_zc3z04anonymousza32831ze3z87_12524;
																										BgL_zc3z04anonymousza32831ze3z87_12524
																											=
																											MAKE_FX_PROCEDURE
																											(BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00,
																											(int) (((long) 1)),
																											(int) (((long) 3)));
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32831ze3z87_12524,
																											(int) (((long) 0)),
																											BgL_a1z00_3271);
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32831ze3z87_12524,
																											(int) (((long) 1)),
																											BgL_a2z00_3272);
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32831ze3z87_12524,
																											(int) (((long) 2)),
																											BgL_locz00_193);
																										return
																											BgL_zc3z04anonymousza32831ze3z87_12524;
																									}
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 1021 */
																									if (
																										(BgL_valz00_3204 ==
																											BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
																										{	/* Eval/evaluate_comp.scm 1021 */
																											obj_t BgL_a1z00_3281;
																											obj_t BgL_a2z00_3282;

																											BgL_a1z00_3281 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a1z00_3208),
																												BgL_stkz00_196);
																											BgL_a2z00_3282 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a2z00_3209),
																												BgL_stkz00_196);
																											{	/* Eval/evaluate_comp.scm 1021 */
																												obj_t
																													BgL_zc3z04anonymousza32835ze3z87_12525;
																												BgL_zc3z04anonymousza32835ze3z87_12525
																													=
																													MAKE_FX_PROCEDURE
																													(BGl_z62zc3z04anonymousza32835ze3ze5zz__evaluate_compz00,
																													(int) (((long) 1)),
																													(int) (((long) 3)));
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32835ze3z87_12525,
																													(int) (((long) 0)),
																													BgL_a1z00_3281);
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32835ze3z87_12525,
																													(int) (((long) 1)),
																													BgL_a2z00_3282);
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32835ze3z87_12525,
																													(int) (((long) 2)),
																													BgL_locz00_193);
																												return
																													BgL_zc3z04anonymousza32835ze3z87_12525;
																											}
																										}
																									else
																										{	/* Eval/evaluate_comp.scm 1021 */
																											if (
																												(BgL_valz00_3204 ==
																													BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
																												{	/* Eval/evaluate_comp.scm 1021 */
																													obj_t BgL_a1z00_3291;
																													obj_t BgL_a2z00_3292;

																													BgL_a1z00_3291 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																													BgL_a2z00_3292 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																													{	/* Eval/evaluate_comp.scm 1021 */
																														obj_t
																															BgL_zc3z04anonymousza32839ze3z87_12526;
																														BgL_zc3z04anonymousza32839ze3z87_12526
																															=
																															MAKE_FX_PROCEDURE
																															(BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00,
																															(int) (((long)
																																	1)),
																															(int) (((long)
																																	3)));
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32839ze3z87_12526,
																															(int) (((long)
																																	0)),
																															BgL_a1z00_3291);
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32839ze3z87_12526,
																															(int) (((long)
																																	1)),
																															BgL_a2z00_3292);
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32839ze3z87_12526,
																															(int) (((long)
																																	2)),
																															BgL_locz00_193);
																														return
																															BgL_zc3z04anonymousza32839ze3z87_12526;
																													}
																												}
																											else
																												{	/* Eval/evaluate_comp.scm 1021 */
																													if (
																														(BgL_valz00_3204 ==
																															BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
																														{	/* Eval/evaluate_comp.scm 1021 */
																															obj_t
																																BgL_a1z00_3301;
																															obj_t
																																BgL_a2z00_3302;
																															BgL_a1z00_3301 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																															BgL_a2z00_3302 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																															{	/* Eval/evaluate_comp.scm 1021 */
																																obj_t
																																	BgL_zc3z04anonymousza32843ze3z87_12527;
																																BgL_zc3z04anonymousza32843ze3z87_12527
																																	=
																																	MAKE_FX_PROCEDURE
																																	(BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00,
																																	(int) (((long)
																																			1)),
																																	(int) (((long)
																																			3)));
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32843ze3z87_12527,
																																	(int) (((long)
																																			0)),
																																	BgL_a1z00_3301);
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32843ze3z87_12527,
																																	(int) (((long)
																																			1)),
																																	BgL_a2z00_3302);
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32843ze3z87_12527,
																																	(int) (((long)
																																			2)),
																																	BgL_locz00_193);
																																return
																																	BgL_zc3z04anonymousza32843ze3z87_12527;
																															}
																														}
																													else
																														{	/* Eval/evaluate_comp.scm 1021 */
																															if (
																																(BgL_valz00_3204
																																	==
																																	BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
																																{	/* Eval/evaluate_comp.scm 1021 */
																																	obj_t
																																		BgL_a1z00_3311;
																																	obj_t
																																		BgL_a2z00_3312;
																																	BgL_a1z00_3311
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																	BgL_a2z00_3312
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																	{	/* Eval/evaluate_comp.scm 1021 */
																																		obj_t
																																			BgL_zc3z04anonymousza32847ze3z87_12528;
																																		BgL_zc3z04anonymousza32847ze3z87_12528
																																			=
																																			MAKE_FX_PROCEDURE
																																			(BGl_z62zc3z04anonymousza32847ze3ze5zz__evaluate_compz00,
																																			(int) ((
																																					(long)
																																					1)),
																																			(int) ((
																																					(long)
																																					3)));
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32847ze3z87_12528,
																																			(int) ((
																																					(long)
																																					0)),
																																			BgL_a1z00_3311);
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32847ze3z87_12528,
																																			(int) ((
																																					(long)
																																					1)),
																																			BgL_a2z00_3312);
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32847ze3z87_12528,
																																			(int) ((
																																					(long)
																																					2)),
																																			BgL_locz00_193);
																																		return
																																			BgL_zc3z04anonymousza32847ze3z87_12528;
																																	}
																																}
																															else
																																{	/* Eval/evaluate_comp.scm 1021 */
																																	if (
																																		(BgL_valz00_3204
																																			==
																																			BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
																																		{	/* Eval/evaluate_comp.scm 1021 */
																																			obj_t
																																				BgL_a1z00_3321;
																																			obj_t
																																				BgL_a2z00_3322;
																																			BgL_a1z00_3321
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																			BgL_a2z00_3322
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																			{	/* Eval/evaluate_comp.scm 1021 */
																																				obj_t
																																					BgL_zc3z04anonymousza32851ze3z87_12529;
																																				BgL_zc3z04anonymousza32851ze3z87_12529
																																					=
																																					MAKE_FX_PROCEDURE
																																					(BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00,
																																					(int)
																																					(((long) 1)), (int) (((long) 3)));
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32851ze3z87_12529,
																																					(int)
																																					(((long) 0)), BgL_a1z00_3321);
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32851ze3z87_12529,
																																					(int)
																																					(((long) 1)), BgL_a2z00_3322);
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32851ze3z87_12529,
																																					(int)
																																					(((long) 2)), BgL_locz00_193);
																																				return
																																					BgL_zc3z04anonymousza32851ze3z87_12529;
																																			}
																																		}
																																	else
																																		{	/* Eval/evaluate_comp.scm 1021 */
																																			if (
																																				(BgL_valz00_3204
																																					==
																																					BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
																																				{	/* Eval/evaluate_comp.scm 1021 */
																																					obj_t
																																						BgL_a1z00_3331;
																																					obj_t
																																						BgL_a2z00_3332;
																																					BgL_a1z00_3331
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																					BgL_a2z00_3332
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																					{	/* Eval/evaluate_comp.scm 1021 */
																																						obj_t
																																							BgL_zc3z04anonymousza32855ze3z87_12530;
																																						BgL_zc3z04anonymousza32855ze3z87_12530
																																							=
																																							MAKE_FX_PROCEDURE
																																							(BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00,
																																							(int)
																																							(((long) 1)), (int) (((long) 3)));
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32855ze3z87_12530,
																																							(int)
																																							(((long) 0)), BgL_a1z00_3331);
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32855ze3z87_12530,
																																							(int)
																																							(((long) 1)), BgL_a2z00_3332);
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32855ze3z87_12530,
																																							(int)
																																							(((long) 2)), BgL_locz00_193);
																																						return
																																							BgL_zc3z04anonymousza32855ze3z87_12530;
																																					}
																																				}
																																			else
																																				{	/* Eval/evaluate_comp.scm 1021 */
																																					if (
																																						(BgL_valz00_3204
																																							==
																																							BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
																																						{	/* Eval/evaluate_comp.scm 1021 */
																																							obj_t
																																								BgL_a1z00_3341;
																																							obj_t
																																								BgL_a2z00_3342;
																																							BgL_a1z00_3341
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																							BgL_a2z00_3342
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																							{	/* Eval/evaluate_comp.scm 1021 */
																																								obj_t
																																									BgL_zc3z04anonymousza32859ze3z87_12531;
																																								BgL_zc3z04anonymousza32859ze3z87_12531
																																									=
																																									MAKE_FX_PROCEDURE
																																									(BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00,
																																									(int)
																																									(((long) 1)), (int) (((long) 3)));
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32859ze3z87_12531,
																																									(int)
																																									(((long) 0)), BgL_a1z00_3341);
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32859ze3z87_12531,
																																									(int)
																																									(((long) 1)), BgL_a2z00_3342);
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32859ze3z87_12531,
																																									(int)
																																									(((long) 2)), BgL_locz00_193);
																																								return
																																									BgL_zc3z04anonymousza32859ze3z87_12531;
																																							}
																																						}
																																					else
																																						{	/* Eval/evaluate_comp.scm 1021 */
																																							if ((BgL_valz00_3204 == BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
																																								{	/* Eval/evaluate_comp.scm 1021 */
																																									obj_t
																																										BgL_a1z00_3351;
																																									obj_t
																																										BgL_a2z00_3352;
																																									BgL_a1z00_3351
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																									BgL_a2z00_3352
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																									{	/* Eval/evaluate_comp.scm 1021 */
																																										obj_t
																																											BgL_zc3z04anonymousza32863ze3z87_12532;
																																										BgL_zc3z04anonymousza32863ze3z87_12532
																																											=
																																											MAKE_FX_PROCEDURE
																																											(BGl_z62zc3z04anonymousza32863ze3ze5zz__evaluate_compz00,
																																											(int)
																																											(((long) 1)), (int) (((long) 3)));
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32863ze3z87_12532,
																																											(int)
																																											(((long) 0)), BgL_a1z00_3351);
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32863ze3z87_12532,
																																											(int)
																																											(((long) 1)), BgL_a2z00_3352);
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32863ze3z87_12532,
																																											(int)
																																											(((long) 2)), BgL_locz00_193);
																																										return
																																											BgL_zc3z04anonymousza32863ze3z87_12532;
																																									}
																																								}
																																							else
																																								{	/* Eval/evaluate_comp.scm 1021 */
																																									if ((BgL_valz00_3204 == BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
																																										{	/* Eval/evaluate_comp.scm 1021 */
																																											obj_t
																																												BgL_a1z00_3361;
																																											obj_t
																																												BgL_a2z00_3362;
																																											BgL_a1z00_3361
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																											BgL_a2z00_3362
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																											{	/* Eval/evaluate_comp.scm 1021 */
																																												obj_t
																																													BgL_zc3z04anonymousza32867ze3z87_12533;
																																												BgL_zc3z04anonymousza32867ze3z87_12533
																																													=
																																													MAKE_FX_PROCEDURE
																																													(BGl_z62zc3z04anonymousza32867ze3ze5zz__evaluate_compz00,
																																													(int)
																																													(((long) 1)), (int) (((long) 3)));
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32867ze3z87_12533,
																																													(int)
																																													(((long) 0)), BgL_a1z00_3361);
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32867ze3z87_12533,
																																													(int)
																																													(((long) 1)), BgL_a2z00_3362);
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32867ze3z87_12533,
																																													(int)
																																													(((long) 2)), BgL_locz00_193);
																																												return
																																													BgL_zc3z04anonymousza32867ze3z87_12533;
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate_comp.scm 1021 */
																																											if ((BgL_valz00_3204 == BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
																																												{	/* Eval/evaluate_comp.scm 1021 */
																																													obj_t
																																														BgL_a1z00_3371;
																																													obj_t
																																														BgL_a2z00_3372;
																																													BgL_a1z00_3371
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																													BgL_a2z00_3372
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																													{	/* Eval/evaluate_comp.scm 1021 */
																																														obj_t
																																															BgL_zc3z04anonymousza32871ze3z87_12534;
																																														BgL_zc3z04anonymousza32871ze3z87_12534
																																															=
																																															MAKE_FX_PROCEDURE
																																															(BGl_z62zc3z04anonymousza32871ze3ze5zz__evaluate_compz00,
																																															(int)
																																															(((long) 1)), (int) (((long) 3)));
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32871ze3z87_12534,
																																															(int)
																																															(((long) 0)), BgL_a1z00_3371);
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32871ze3z87_12534,
																																															(int)
																																															(((long) 1)), BgL_a2z00_3372);
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32871ze3z87_12534,
																																															(int)
																																															(((long) 2)), BgL_locz00_193);
																																														return
																																															BgL_zc3z04anonymousza32871ze3z87_12534;
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate_comp.scm 1021 */
																																													if ((BgL_valz00_3204 == BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
																																														{	/* Eval/evaluate_comp.scm 1021 */
																																															obj_t
																																																BgL_a1z00_3381;
																																															obj_t
																																																BgL_a2z00_3382;
																																															BgL_a1z00_3381
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																															BgL_a2z00_3382
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																															{	/* Eval/evaluate_comp.scm 1021 */
																																																obj_t
																																																	BgL_zc3z04anonymousza32875ze3z87_12535;
																																																BgL_zc3z04anonymousza32875ze3z87_12535
																																																	=
																																																	MAKE_FX_PROCEDURE
																																																	(BGl_z62zc3z04anonymousza32875ze3ze5zz__evaluate_compz00,
																																																	(int)
																																																	(((long) 1)), (int) (((long) 3)));
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32875ze3z87_12535,
																																																	(int)
																																																	(((long) 0)), BgL_a1z00_3381);
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32875ze3z87_12535,
																																																	(int)
																																																	(((long) 1)), BgL_a2z00_3382);
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32875ze3z87_12535,
																																																	(int)
																																																	(((long) 2)), BgL_locz00_193);
																																																return
																																																	BgL_zc3z04anonymousza32875ze3z87_12535;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate_comp.scm 1021 */
																																															if ((BgL_valz00_3204 == BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																	obj_t
																																																		BgL_a1z00_3391;
																																																	obj_t
																																																		BgL_a2z00_3392;
																																																	BgL_a1z00_3391
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																	BgL_a2z00_3392
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																	{	/* Eval/evaluate_comp.scm 1021 */
																																																		obj_t
																																																			BgL_zc3z04anonymousza32879ze3z87_12536;
																																																		BgL_zc3z04anonymousza32879ze3z87_12536
																																																			=
																																																			MAKE_FX_PROCEDURE
																																																			(BGl_z62zc3z04anonymousza32879ze3ze5zz__evaluate_compz00,
																																																			(int)
																																																			(((long) 1)), (int) (((long) 3)));
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32879ze3z87_12536,
																																																			(int)
																																																			(((long) 0)), BgL_a1z00_3391);
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32879ze3z87_12536,
																																																			(int)
																																																			(((long) 1)), BgL_a2z00_3392);
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32879ze3z87_12536,
																																																			(int)
																																																			(((long) 2)), BgL_locz00_193);
																																																		return
																																																			BgL_zc3z04anonymousza32879ze3z87_12536;
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																	if ((BgL_valz00_3204 == BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																			obj_t
																																																				BgL_a1z00_3401;
																																																			obj_t
																																																				BgL_a2z00_3402;
																																																			BgL_a1z00_3401
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																			BgL_a2z00_3402
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																			{	/* Eval/evaluate_comp.scm 1021 */
																																																				obj_t
																																																					BgL_zc3z04anonymousza32883ze3z87_12537;
																																																				BgL_zc3z04anonymousza32883ze3z87_12537
																																																					=
																																																					MAKE_FX_PROCEDURE
																																																					(BGl_z62zc3z04anonymousza32883ze3ze5zz__evaluate_compz00,
																																																					(int)
																																																					(((long) 1)), (int) (((long) 3)));
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32883ze3z87_12537,
																																																					(int)
																																																					(((long) 0)), BgL_a1z00_3401);
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32883ze3z87_12537,
																																																					(int)
																																																					(((long) 1)), BgL_a2z00_3402);
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32883ze3z87_12537,
																																																					(int)
																																																					(((long) 2)), BgL_locz00_193);
																																																				return
																																																					BgL_zc3z04anonymousza32883ze3z87_12537;
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																			if ((BgL_valz00_3204 == BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																					obj_t
																																																						BgL_a1z00_3411;
																																																					obj_t
																																																						BgL_a2z00_3412;
																																																					BgL_a1z00_3411
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																					BgL_a2z00_3412
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																					{	/* Eval/evaluate_comp.scm 1021 */
																																																						obj_t
																																																							BgL_zc3z04anonymousza32887ze3z87_12538;
																																																						BgL_zc3z04anonymousza32887ze3z87_12538
																																																							=
																																																							MAKE_FX_PROCEDURE
																																																							(BGl_z62zc3z04anonymousza32887ze3ze5zz__evaluate_compz00,
																																																							(int)
																																																							(((long) 1)), (int) (((long) 3)));
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32887ze3z87_12538,
																																																							(int)
																																																							(((long) 0)), BgL_a1z00_3411);
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32887ze3z87_12538,
																																																							(int)
																																																							(((long) 1)), BgL_a2z00_3412);
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32887ze3z87_12538,
																																																							(int)
																																																							(((long) 2)), BgL_locz00_193);
																																																						return
																																																							BgL_zc3z04anonymousza32887ze3z87_12538;
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																					if ((BgL_valz00_3204 == BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																																																						{	/* Eval/evaluate_comp.scm 1021 */
																																																							obj_t
																																																								BgL_a1z00_3421;
																																																							obj_t
																																																								BgL_a2z00_3422;
																																																							BgL_a1z00_3421
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																							BgL_a2z00_3422
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																							{	/* Eval/evaluate_comp.scm 1021 */
																																																								obj_t
																																																									BgL_zc3z04anonymousza32891ze3z87_12539;
																																																								BgL_zc3z04anonymousza32891ze3z87_12539
																																																									=
																																																									MAKE_FX_PROCEDURE
																																																									(BGl_z62zc3z04anonymousza32891ze3ze5zz__evaluate_compz00,
																																																									(int)
																																																									(((long) 1)), (int) (((long) 3)));
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32891ze3z87_12539,
																																																									(int)
																																																									(((long) 0)), BgL_a1z00_3421);
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32891ze3z87_12539,
																																																									(int)
																																																									(((long) 1)), BgL_a2z00_3422);
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32891ze3z87_12539,
																																																									(int)
																																																									(((long) 2)), BgL_locz00_193);
																																																								return
																																																									BgL_zc3z04anonymousza32891ze3z87_12539;
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate_comp.scm 1021 */
																																																							if ((BgL_valz00_3204 == BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
																																																								{	/* Eval/evaluate_comp.scm 1021 */
																																																									obj_t
																																																										BgL_a1z00_3431;
																																																									obj_t
																																																										BgL_a2z00_3432;
																																																									BgL_a1z00_3431
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																									BgL_a2z00_3432
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																									{	/* Eval/evaluate_comp.scm 1021 */
																																																										obj_t
																																																											BgL_zc3z04anonymousza32895ze3z87_12540;
																																																										BgL_zc3z04anonymousza32895ze3z87_12540
																																																											=
																																																											MAKE_FX_PROCEDURE
																																																											(BGl_z62zc3z04anonymousza32895ze3ze5zz__evaluate_compz00,
																																																											(int)
																																																											(((long) 1)), (int) (((long) 3)));
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32895ze3z87_12540,
																																																											(int)
																																																											(((long) 0)), BgL_a1z00_3431);
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32895ze3z87_12540,
																																																											(int)
																																																											(((long) 1)), BgL_a2z00_3432);
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32895ze3z87_12540,
																																																											(int)
																																																											(((long) 2)), BgL_locz00_193);
																																																										return
																																																											BgL_zc3z04anonymousza32895ze3z87_12540;
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate_comp.scm 1021 */
																																																									if ((BgL_valz00_3204 == BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
																																																										{	/* Eval/evaluate_comp.scm 1021 */
																																																											obj_t
																																																												BgL_a1z00_3441;
																																																											obj_t
																																																												BgL_a2z00_3442;
																																																											BgL_a1z00_3441
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																											BgL_a2z00_3442
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																											{	/* Eval/evaluate_comp.scm 1021 */
																																																												obj_t
																																																													BgL_zc3z04anonymousza32899ze3z87_12541;
																																																												BgL_zc3z04anonymousza32899ze3z87_12541
																																																													=
																																																													MAKE_FX_PROCEDURE
																																																													(BGl_z62zc3z04anonymousza32899ze3ze5zz__evaluate_compz00,
																																																													(int)
																																																													(((long) 1)), (int) (((long) 3)));
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32899ze3z87_12541,
																																																													(int)
																																																													(((long) 0)), BgL_a1z00_3441);
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32899ze3z87_12541,
																																																													(int)
																																																													(((long) 1)), BgL_a2z00_3442);
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32899ze3z87_12541,
																																																													(int)
																																																													(((long) 2)), BgL_locz00_193);
																																																												return
																																																													BgL_zc3z04anonymousza32899ze3z87_12541;
																																																											}
																																																										}
																																																									else
																																																										{	/* Eval/evaluate_comp.scm 1021 */
																																																											if ((BgL_valz00_3204 == BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
																																																												{	/* Eval/evaluate_comp.scm 1021 */
																																																													obj_t
																																																														BgL_a1z00_3451;
																																																													obj_t
																																																														BgL_a2z00_3452;
																																																													BgL_a1z00_3451
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																													BgL_a2z00_3452
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																													{	/* Eval/evaluate_comp.scm 1021 */
																																																														obj_t
																																																															BgL_zc3z04anonymousza32903ze3z87_12542;
																																																														BgL_zc3z04anonymousza32903ze3z87_12542
																																																															=
																																																															MAKE_FX_PROCEDURE
																																																															(BGl_z62zc3z04anonymousza32903ze3ze5zz__evaluate_compz00,
																																																															(int)
																																																															(((long) 1)), (int) (((long) 3)));
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32903ze3z87_12542,
																																																															(int)
																																																															(((long) 0)), BgL_a1z00_3451);
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32903ze3z87_12542,
																																																															(int)
																																																															(((long) 1)), BgL_a2z00_3452);
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32903ze3z87_12542,
																																																															(int)
																																																															(((long) 2)), BgL_locz00_193);
																																																														return
																																																															BgL_zc3z04anonymousza32903ze3z87_12542;
																																																													}
																																																												}
																																																											else
																																																												{	/* Eval/evaluate_comp.scm 1021 */
																																																													if ((BgL_valz00_3204 == BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
																																																														{	/* Eval/evaluate_comp.scm 1021 */
																																																															obj_t
																																																																BgL_a1z00_3461;
																																																															obj_t
																																																																BgL_a2z00_3462;
																																																															BgL_a1z00_3461
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																															BgL_a2z00_3462
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																															{	/* Eval/evaluate_comp.scm 1021 */
																																																																obj_t
																																																																	BgL_zc3z04anonymousza32907ze3z87_12543;
																																																																BgL_zc3z04anonymousza32907ze3z87_12543
																																																																	=
																																																																	MAKE_FX_PROCEDURE
																																																																	(BGl_z62zc3z04anonymousza32907ze3ze5zz__evaluate_compz00,
																																																																	(int)
																																																																	(((long) 1)), (int) (((long) 3)));
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32907ze3z87_12543,
																																																																	(int)
																																																																	(((long) 0)), BgL_a1z00_3461);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32907ze3z87_12543,
																																																																	(int)
																																																																	(((long) 1)), BgL_a2z00_3462);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32907ze3z87_12543,
																																																																	(int)
																																																																	(((long) 2)), BgL_locz00_193);
																																																																return
																																																																	BgL_zc3z04anonymousza32907ze3z87_12543;
																																																															}
																																																														}
																																																													else
																																																														{	/* Eval/evaluate_comp.scm 1021 */
																																																															if ((BgL_valz00_3204 == BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
																																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																																	obj_t
																																																																		BgL_a1z00_3471;
																																																																	obj_t
																																																																		BgL_a2z00_3472;
																																																																	BgL_a1z00_3471
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																																	BgL_a2z00_3472
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																																	{	/* Eval/evaluate_comp.scm 1021 */
																																																																		obj_t
																																																																			BgL_zc3z04anonymousza32911ze3z87_12544;
																																																																		BgL_zc3z04anonymousza32911ze3z87_12544
																																																																			=
																																																																			MAKE_FX_PROCEDURE
																																																																			(BGl_z62zc3z04anonymousza32911ze3ze5zz__evaluate_compz00,
																																																																			(int)
																																																																			(((long) 1)), (int) (((long) 3)));
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32911ze3z87_12544,
																																																																			(int)
																																																																			(((long) 0)), BgL_a1z00_3471);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32911ze3z87_12544,
																																																																			(int)
																																																																			(((long) 1)), BgL_a2z00_3472);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32911ze3z87_12544,
																																																																			(int)
																																																																			(((long) 2)), BgL_locz00_193);
																																																																		return
																																																																			BgL_zc3z04anonymousza32911ze3z87_12544;
																																																																	}
																																																																}
																																																															else
																																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																																	if ((BgL_valz00_3204 == BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
																																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																																			obj_t
																																																																				BgL_a1z00_3481;
																																																																			obj_t
																																																																				BgL_a2z00_3482;
																																																																			BgL_a1z00_3481
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																																			BgL_a2z00_3482
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																																			{	/* Eval/evaluate_comp.scm 1021 */
																																																																				obj_t
																																																																					BgL_zc3z04anonymousza32915ze3z87_12545;
																																																																				BgL_zc3z04anonymousza32915ze3z87_12545
																																																																					=
																																																																					MAKE_FX_PROCEDURE
																																																																					(BGl_z62zc3z04anonymousza32915ze3ze5zz__evaluate_compz00,
																																																																					(int)
																																																																					(((long) 1)), (int) (((long) 2)));
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3z04anonymousza32915ze3z87_12545,
																																																																					(int)
																																																																					(((long) 0)), BgL_a1z00_3481);
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3z04anonymousza32915ze3z87_12545,
																																																																					(int)
																																																																					(((long) 1)), BgL_a2z00_3482);
																																																																				return
																																																																					BgL_zc3z04anonymousza32915ze3z87_12545;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																																			if ((BgL_valz00_3204 == BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
																																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																																					obj_t
																																																																						BgL_a1z00_3489;
																																																																					obj_t
																																																																						BgL_a2z00_3490;
																																																																					BgL_a1z00_3489
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3208), BgL_stkz00_196);
																																																																					BgL_a2z00_3490
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3209), BgL_stkz00_196);
																																																																					{	/* Eval/evaluate_comp.scm 1021 */
																																																																						obj_t
																																																																							BgL_zc3z04anonymousza32917ze3z87_12546;
																																																																						BgL_zc3z04anonymousza32917ze3z87_12546
																																																																							=
																																																																							MAKE_FX_PROCEDURE
																																																																							(BGl_z62zc3z04anonymousza32917ze3ze5zz__evaluate_compz00,
																																																																							(int)
																																																																							(((long) 1)), (int) (((long) 2)));
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3z04anonymousza32917ze3z87_12546,
																																																																							(int)
																																																																							(((long) 0)), BgL_a1z00_3489);
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3z04anonymousza32917ze3z87_12546,
																																																																							(int)
																																																																							(((long) 1)), BgL_a2z00_3490);
																																																																						return
																																																																							BgL_zc3z04anonymousza32917ze3z87_12546;
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																																					return
																																																																						BFALSE;
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 1019 */
											return BFALSE;
										}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 1014 */
						return BFALSE;
					}
			}
		}

	}



/* &<@anonymous:2807> */
	obj_t BGl_z62zc3z04anonymousza32807ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12550, obj_t BgL_sz00_12554)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12551;
				obj_t BgL_a2z00_12552;
				obj_t BgL_locz00_12553;

				BgL_a1z00_12551 = PROCEDURE_REF(BgL_envz00_12550, (int) (((long) 0)));
				BgL_a2z00_12552 = PROCEDURE_REF(BgL_envz00_12550, (int) (((long) 1)));
				BgL_locz00_12553 = PROCEDURE_REF(BgL_envz00_12550, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_15110;

					BgL_bpz00_15110 = VECTOR_REF(((obj_t) BgL_sz00_12554), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_15111;
						obj_t BgL_a2z00_15112;

						BgL_a1z00_15111 =
							PROCEDURE_ENTRY(BgL_a1z00_12551) (BgL_a1z00_12551, BgL_sz00_12554,
							BEOA);
						BgL_a2z00_15112 =
							PROCEDURE_ENTRY(BgL_a2z00_12552) (BgL_a2z00_12552, BgL_sz00_12554,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15111))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4613z00zz__evaluate_compz00,
									BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15111,
									BgL_locz00_12553);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15112))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4613z00zz__evaluate_compz00,
									BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15112,
									BgL_locz00_12553);
							}
						return
							BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_15111,
							BgL_a2z00_15112);
					}
				}
			}
		}

	}



/* &<@anonymous:2811> */
	obj_t BGl_z62zc3z04anonymousza32811ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12555, obj_t BgL_sz00_12559)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12556;
				obj_t BgL_a2z00_12557;
				obj_t BgL_locz00_12558;

				BgL_a1z00_12556 = PROCEDURE_REF(BgL_envz00_12555, (int) (((long) 0)));
				BgL_a2z00_12557 = PROCEDURE_REF(BgL_envz00_12555, (int) (((long) 1)));
				BgL_locz00_12558 = PROCEDURE_REF(BgL_envz00_12555, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_15113;

					BgL_bpz00_15113 = VECTOR_REF(((obj_t) BgL_sz00_12559), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_15114;
						obj_t BgL_a2z00_15115;

						BgL_a1z00_15114 =
							PROCEDURE_ENTRY(BgL_a1z00_12556) (BgL_a1z00_12556, BgL_sz00_12559,
							BEOA);
						BgL_a2z00_15115 =
							PROCEDURE_ENTRY(BgL_a2z00_12557) (BgL_a2z00_12557, BgL_sz00_12559,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15114))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4617z00zz__evaluate_compz00,
									BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15114,
									BgL_locz00_12558);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15115))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4617z00zz__evaluate_compz00,
									BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15115,
									BgL_locz00_12558);
							}
						return
							BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_15114,
							BgL_a2z00_15115);
					}
				}
			}
		}

	}



/* &<@anonymous:2815> */
	obj_t BGl_z62zc3z04anonymousza32815ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12560, obj_t BgL_sz00_12564)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12561;
				obj_t BgL_a2z00_12562;
				obj_t BgL_locz00_12563;

				BgL_a1z00_12561 = PROCEDURE_REF(BgL_envz00_12560, (int) (((long) 0)));
				BgL_a2z00_12562 = PROCEDURE_REF(BgL_envz00_12560, (int) (((long) 1)));
				BgL_locz00_12563 = PROCEDURE_REF(BgL_envz00_12560, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_15116;

					BgL_bpz00_15116 = VECTOR_REF(((obj_t) BgL_sz00_12564), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_15117;
						obj_t BgL_a2z00_15118;

						BgL_a1z00_15117 =
							PROCEDURE_ENTRY(BgL_a1z00_12561) (BgL_a1z00_12561, BgL_sz00_12564,
							BEOA);
						BgL_a2z00_15118 =
							PROCEDURE_ENTRY(BgL_a2z00_12562) (BgL_a2z00_12562, BgL_sz00_12564,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15117))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4619z00zz__evaluate_compz00,
									BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15117,
									BgL_locz00_12563);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15118))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4619z00zz__evaluate_compz00,
									BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15118,
									BgL_locz00_12563);
							}
						return
							BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_15117,
							BgL_a2z00_15118);
					}
				}
			}
		}

	}



/* &<@anonymous:2819> */
	obj_t BGl_z62zc3z04anonymousza32819ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12565, obj_t BgL_sz00_12569)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12566;
				obj_t BgL_a2z00_12567;
				obj_t BgL_locz00_12568;

				BgL_a1z00_12566 = PROCEDURE_REF(BgL_envz00_12565, (int) (((long) 0)));
				BgL_a2z00_12567 = PROCEDURE_REF(BgL_envz00_12565, (int) (((long) 1)));
				BgL_locz00_12568 = PROCEDURE_REF(BgL_envz00_12565, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_15119;

					BgL_bpz00_15119 = VECTOR_REF(((obj_t) BgL_sz00_12569), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_15120;
						obj_t BgL_a2z00_15121;

						BgL_a1z00_15120 =
							PROCEDURE_ENTRY(BgL_a1z00_12566) (BgL_a1z00_12566, BgL_sz00_12569,
							BEOA);
						BgL_a2z00_15121 =
							PROCEDURE_ENTRY(BgL_a2z00_12567) (BgL_a2z00_12567, BgL_sz00_12569,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15120))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4621z00zz__evaluate_compz00,
									BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15120,
									BgL_locz00_12568);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15121))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4621z00zz__evaluate_compz00,
									BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15121,
									BgL_locz00_12568);
							}
						return
							BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_15120,
							BgL_a2z00_15121);
					}
				}
			}
		}

	}



/* &<@anonymous:2823> */
	obj_t BGl_z62zc3z04anonymousza32823ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12570, obj_t BgL_sz00_12574)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12571;
				obj_t BgL_a2z00_12572;
				obj_t BgL_locz00_12573;

				BgL_a1z00_12571 = PROCEDURE_REF(BgL_envz00_12570, (int) (((long) 0)));
				BgL_a2z00_12572 = PROCEDURE_REF(BgL_envz00_12570, (int) (((long) 1)));
				BgL_locz00_12573 = PROCEDURE_REF(BgL_envz00_12570, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23252;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15122;

						BgL_bpz00_15122 = VECTOR_REF(((obj_t) BgL_sz00_12574), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15123;
							obj_t BgL_a2z00_15124;

							BgL_a1z00_15123 =
								PROCEDURE_ENTRY(BgL_a1z00_12571) (BgL_a1z00_12571,
								BgL_sz00_12574, BEOA);
							BgL_a2z00_15124 =
								PROCEDURE_ENTRY(BgL_a2z00_12572) (BgL_a2z00_12572,
								BgL_sz00_12574, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15123))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4623z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15123,
										BgL_locz00_12573);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15124))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4623z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15124,
										BgL_locz00_12573);
								}
							BgL_tmpz00_23252 =
								BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_15123,
								BgL_a2z00_15124);
						}
					}
					return BBOOL(BgL_tmpz00_23252);
				}
			}
		}

	}



/* &<@anonymous:2827> */
	obj_t BGl_z62zc3z04anonymousza32827ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12575, obj_t BgL_sz00_12579)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12576;
				obj_t BgL_a2z00_12577;
				obj_t BgL_locz00_12578;

				BgL_a1z00_12576 = PROCEDURE_REF(BgL_envz00_12575, (int) (((long) 0)));
				BgL_a2z00_12577 = PROCEDURE_REF(BgL_envz00_12575, (int) (((long) 1)));
				BgL_locz00_12578 = PROCEDURE_REF(BgL_envz00_12575, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23277;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15125;

						BgL_bpz00_15125 = VECTOR_REF(((obj_t) BgL_sz00_12579), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15126;
							obj_t BgL_a2z00_15127;

							BgL_a1z00_15126 =
								PROCEDURE_ENTRY(BgL_a1z00_12576) (BgL_a1z00_12576,
								BgL_sz00_12579, BEOA);
							BgL_a2z00_15127 =
								PROCEDURE_ENTRY(BgL_a2z00_12577) (BgL_a2z00_12577,
								BgL_sz00_12579, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15126))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4625z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15126,
										BgL_locz00_12578);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15127))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4625z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15127,
										BgL_locz00_12578);
								}
							BgL_tmpz00_23277 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_15126,
								BgL_a2z00_15127);
						}
					}
					return BBOOL(BgL_tmpz00_23277);
				}
			}
		}

	}



/* &<@anonymous:2831> */
	obj_t BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12580, obj_t BgL_sz00_12584)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12581;
				obj_t BgL_a2z00_12582;
				obj_t BgL_locz00_12583;

				BgL_a1z00_12581 = PROCEDURE_REF(BgL_envz00_12580, (int) (((long) 0)));
				BgL_a2z00_12582 = PROCEDURE_REF(BgL_envz00_12580, (int) (((long) 1)));
				BgL_locz00_12583 = PROCEDURE_REF(BgL_envz00_12580, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23302;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15128;

						BgL_bpz00_15128 = VECTOR_REF(((obj_t) BgL_sz00_12584), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15129;
							obj_t BgL_a2z00_15130;

							BgL_a1z00_15129 =
								PROCEDURE_ENTRY(BgL_a1z00_12581) (BgL_a1z00_12581,
								BgL_sz00_12584, BEOA);
							BgL_a2z00_15130 =
								PROCEDURE_ENTRY(BgL_a2z00_12582) (BgL_a2z00_12582,
								BgL_sz00_12584, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15129))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4627z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15129,
										BgL_locz00_12583);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15130))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4627z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15130,
										BgL_locz00_12583);
								}
							BgL_tmpz00_23302 =
								BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_15129,
								BgL_a2z00_15130);
						}
					}
					return BBOOL(BgL_tmpz00_23302);
				}
			}
		}

	}



/* &<@anonymous:2835> */
	obj_t BGl_z62zc3z04anonymousza32835ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12585, obj_t BgL_sz00_12589)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12586;
				obj_t BgL_a2z00_12587;
				obj_t BgL_locz00_12588;

				BgL_a1z00_12586 = PROCEDURE_REF(BgL_envz00_12585, (int) (((long) 0)));
				BgL_a2z00_12587 = PROCEDURE_REF(BgL_envz00_12585, (int) (((long) 1)));
				BgL_locz00_12588 = PROCEDURE_REF(BgL_envz00_12585, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23327;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15131;

						BgL_bpz00_15131 = VECTOR_REF(((obj_t) BgL_sz00_12589), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15132;
							obj_t BgL_a2z00_15133;

							BgL_a1z00_15132 =
								PROCEDURE_ENTRY(BgL_a1z00_12586) (BgL_a1z00_12586,
								BgL_sz00_12589, BEOA);
							BgL_a2z00_15133 =
								PROCEDURE_ENTRY(BgL_a2z00_12587) (BgL_a2z00_12587,
								BgL_sz00_12589, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15132))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4629z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15132,
										BgL_locz00_12588);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15133))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4629z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15133,
										BgL_locz00_12588);
								}
							BgL_tmpz00_23327 =
								BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_15132,
								BgL_a2z00_15133);
						}
					}
					return BBOOL(BgL_tmpz00_23327);
				}
			}
		}

	}



/* &<@anonymous:2839> */
	obj_t BGl_z62zc3z04anonymousza32839ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12590, obj_t BgL_sz00_12594)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12591;
				obj_t BgL_a2z00_12592;
				obj_t BgL_locz00_12593;

				BgL_a1z00_12591 = PROCEDURE_REF(BgL_envz00_12590, (int) (((long) 0)));
				BgL_a2z00_12592 = PROCEDURE_REF(BgL_envz00_12590, (int) (((long) 1)));
				BgL_locz00_12593 = PROCEDURE_REF(BgL_envz00_12590, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23352;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15134;

						BgL_bpz00_15134 = VECTOR_REF(((obj_t) BgL_sz00_12594), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15135;
							obj_t BgL_a2z00_15136;

							BgL_a1z00_15135 =
								PROCEDURE_ENTRY(BgL_a1z00_12591) (BgL_a1z00_12591,
								BgL_sz00_12594, BEOA);
							BgL_a2z00_15136 =
								PROCEDURE_ENTRY(BgL_a2z00_12592) (BgL_a2z00_12592,
								BgL_sz00_12594, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_15135))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4631z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a1z00_15135,
										BgL_locz00_12593);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_15136))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4631z00zz__evaluate_compz00,
										BGl_symbol4615z00zz__evaluate_compz00, BgL_a2z00_15136,
										BgL_locz00_12593);
								}
							BgL_tmpz00_23352 =
								BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_15135,
								BgL_a2z00_15136);
						}
					}
					return BBOOL(BgL_tmpz00_23352);
				}
			}
		}

	}



/* &<@anonymous:2843> */
	obj_t BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12595, obj_t BgL_sz00_12599)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12596;
				obj_t BgL_a2z00_12597;
				obj_t BgL_locz00_12598;

				BgL_a1z00_12596 = PROCEDURE_REF(BgL_envz00_12595, (int) (((long) 0)));
				BgL_a2z00_12597 = PROCEDURE_REF(BgL_envz00_12595, (int) (((long) 1)));
				BgL_locz00_12598 = PROCEDURE_REF(BgL_envz00_12595, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_23377;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15137;

						BgL_bpz00_15137 = VECTOR_REF(((obj_t) BgL_sz00_12599), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15138;
							obj_t BgL_a2z00_15139;

							BgL_a1z00_15138 =
								PROCEDURE_ENTRY(BgL_a1z00_12596) (BgL_a1z00_12596,
								BgL_sz00_12599, BEOA);
							BgL_a2z00_15139 =
								PROCEDURE_ENTRY(BgL_a2z00_12597) (BgL_a2z00_12597,
								BgL_sz00_12599, BEOA);
							if (INTEGERP(BgL_a1z00_15138))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4633z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15138,
										BgL_locz00_12598);
								}
							if (INTEGERP(BgL_a2z00_15139))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4633z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15139,
										BgL_locz00_12598);
								}
							BgL_tmpz00_23377 =
								((long) CINT(BgL_a1z00_15138) + (long) CINT(BgL_a2z00_15139));
					}}
					return BINT(BgL_tmpz00_23377);
				}
			}
		}

	}



/* &<@anonymous:2847> */
	obj_t BGl_z62zc3z04anonymousza32847ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12600, obj_t BgL_sz00_12604)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12601;
				obj_t BgL_a2z00_12602;
				obj_t BgL_locz00_12603;

				BgL_a1z00_12601 = PROCEDURE_REF(BgL_envz00_12600, (int) (((long) 0)));
				BgL_a2z00_12602 = PROCEDURE_REF(BgL_envz00_12600, (int) (((long) 1)));
				BgL_locz00_12603 = PROCEDURE_REF(BgL_envz00_12600, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_23404;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15140;

						BgL_bpz00_15140 = VECTOR_REF(((obj_t) BgL_sz00_12604), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15141;
							obj_t BgL_a2z00_15142;

							BgL_a1z00_15141 =
								PROCEDURE_ENTRY(BgL_a1z00_12601) (BgL_a1z00_12601,
								BgL_sz00_12604, BEOA);
							BgL_a2z00_15142 =
								PROCEDURE_ENTRY(BgL_a2z00_12602) (BgL_a2z00_12602,
								BgL_sz00_12604, BEOA);
							if (INTEGERP(BgL_a1z00_15141))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4637z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15141,
										BgL_locz00_12603);
								}
							if (INTEGERP(BgL_a2z00_15142))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4637z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15142,
										BgL_locz00_12603);
								}
							BgL_tmpz00_23404 =
								((long) CINT(BgL_a1z00_15141) - (long) CINT(BgL_a2z00_15142));
					}}
					return BINT(BgL_tmpz00_23404);
				}
			}
		}

	}



/* &<@anonymous:2851> */
	obj_t BGl_z62zc3z04anonymousza32851ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12605, obj_t BgL_sz00_12609)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12606;
				obj_t BgL_a2z00_12607;
				obj_t BgL_locz00_12608;

				BgL_a1z00_12606 = PROCEDURE_REF(BgL_envz00_12605, (int) (((long) 0)));
				BgL_a2z00_12607 = PROCEDURE_REF(BgL_envz00_12605, (int) (((long) 1)));
				BgL_locz00_12608 = PROCEDURE_REF(BgL_envz00_12605, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_23431;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15143;

						BgL_bpz00_15143 = VECTOR_REF(((obj_t) BgL_sz00_12609), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15144;
							obj_t BgL_a2z00_15145;

							BgL_a1z00_15144 =
								PROCEDURE_ENTRY(BgL_a1z00_12606) (BgL_a1z00_12606,
								BgL_sz00_12609, BEOA);
							BgL_a2z00_15145 =
								PROCEDURE_ENTRY(BgL_a2z00_12607) (BgL_a2z00_12607,
								BgL_sz00_12609, BEOA);
							if (INTEGERP(BgL_a1z00_15144))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4639z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15144,
										BgL_locz00_12608);
								}
							if (INTEGERP(BgL_a2z00_15145))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4639z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15145,
										BgL_locz00_12608);
								}
							BgL_tmpz00_23431 =
								((long) CINT(BgL_a1z00_15144) * (long) CINT(BgL_a2z00_15145));
					}}
					return BINT(BgL_tmpz00_23431);
				}
			}
		}

	}



/* &<@anonymous:2855> */
	obj_t BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12610, obj_t BgL_sz00_12614)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12611;
				obj_t BgL_a2z00_12612;
				obj_t BgL_locz00_12613;

				BgL_a1z00_12611 = PROCEDURE_REF(BgL_envz00_12610, (int) (((long) 0)));
				BgL_a2z00_12612 = PROCEDURE_REF(BgL_envz00_12610, (int) (((long) 1)));
				BgL_locz00_12613 = PROCEDURE_REF(BgL_envz00_12610, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_23458;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15146;

						BgL_bpz00_15146 = VECTOR_REF(((obj_t) BgL_sz00_12614), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15147;
							obj_t BgL_a2z00_15148;

							BgL_a1z00_15147 =
								PROCEDURE_ENTRY(BgL_a1z00_12611) (BgL_a1z00_12611,
								BgL_sz00_12614, BEOA);
							BgL_a2z00_15148 =
								PROCEDURE_ENTRY(BgL_a2z00_12612) (BgL_a2z00_12612,
								BgL_sz00_12614, BEOA);
							if (INTEGERP(BgL_a1z00_15147))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4641z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15147,
										BgL_locz00_12613);
								}
							if (INTEGERP(BgL_a2z00_15148))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4641z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15148,
										BgL_locz00_12613);
								}
							BgL_tmpz00_23458 =
								((long) CINT(BgL_a1z00_15147) / (long) CINT(BgL_a2z00_15148));
					}}
					return BINT(BgL_tmpz00_23458);
				}
			}
		}

	}



/* &<@anonymous:2859> */
	obj_t BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12615, obj_t BgL_sz00_12619)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12616;
				obj_t BgL_a2z00_12617;
				obj_t BgL_locz00_12618;

				BgL_a1z00_12616 = PROCEDURE_REF(BgL_envz00_12615, (int) (((long) 0)));
				BgL_a2z00_12617 = PROCEDURE_REF(BgL_envz00_12615, (int) (((long) 1)));
				BgL_locz00_12618 = PROCEDURE_REF(BgL_envz00_12615, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23485;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15149;

						BgL_bpz00_15149 = VECTOR_REF(((obj_t) BgL_sz00_12619), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15150;
							obj_t BgL_a2z00_15151;

							BgL_a1z00_15150 =
								PROCEDURE_ENTRY(BgL_a1z00_12616) (BgL_a1z00_12616,
								BgL_sz00_12619, BEOA);
							BgL_a2z00_15151 =
								PROCEDURE_ENTRY(BgL_a2z00_12617) (BgL_a2z00_12617,
								BgL_sz00_12619, BEOA);
							if (INTEGERP(BgL_a1z00_15150))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4643z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15150,
										BgL_locz00_12618);
								}
							if (INTEGERP(BgL_a2z00_15151))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4643z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15151,
										BgL_locz00_12618);
								}
							BgL_tmpz00_23485 =
								((long) CINT(BgL_a1z00_15150) < (long) CINT(BgL_a2z00_15151));
					}}
					return BBOOL(BgL_tmpz00_23485);
				}
			}
		}

	}



/* &<@anonymous:2863> */
	obj_t BGl_z62zc3z04anonymousza32863ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12620, obj_t BgL_sz00_12624)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12621;
				obj_t BgL_a2z00_12622;
				obj_t BgL_locz00_12623;

				BgL_a1z00_12621 = PROCEDURE_REF(BgL_envz00_12620, (int) (((long) 0)));
				BgL_a2z00_12622 = PROCEDURE_REF(BgL_envz00_12620, (int) (((long) 1)));
				BgL_locz00_12623 = PROCEDURE_REF(BgL_envz00_12620, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23512;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15152;

						BgL_bpz00_15152 = VECTOR_REF(((obj_t) BgL_sz00_12624), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15153;
							obj_t BgL_a2z00_15154;

							BgL_a1z00_15153 =
								PROCEDURE_ENTRY(BgL_a1z00_12621) (BgL_a1z00_12621,
								BgL_sz00_12624, BEOA);
							BgL_a2z00_15154 =
								PROCEDURE_ENTRY(BgL_a2z00_12622) (BgL_a2z00_12622,
								BgL_sz00_12624, BEOA);
							if (INTEGERP(BgL_a1z00_15153))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4645z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15153,
										BgL_locz00_12623);
								}
							if (INTEGERP(BgL_a2z00_15154))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4645z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15154,
										BgL_locz00_12623);
								}
							BgL_tmpz00_23512 =
								((long) CINT(BgL_a1z00_15153) > (long) CINT(BgL_a2z00_15154));
					}}
					return BBOOL(BgL_tmpz00_23512);
				}
			}
		}

	}



/* &<@anonymous:2867> */
	obj_t BGl_z62zc3z04anonymousza32867ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12625, obj_t BgL_sz00_12629)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12626;
				obj_t BgL_a2z00_12627;
				obj_t BgL_locz00_12628;

				BgL_a1z00_12626 = PROCEDURE_REF(BgL_envz00_12625, (int) (((long) 0)));
				BgL_a2z00_12627 = PROCEDURE_REF(BgL_envz00_12625, (int) (((long) 1)));
				BgL_locz00_12628 = PROCEDURE_REF(BgL_envz00_12625, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23539;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15155;

						BgL_bpz00_15155 = VECTOR_REF(((obj_t) BgL_sz00_12629), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15156;
							obj_t BgL_a2z00_15157;

							BgL_a1z00_15156 =
								PROCEDURE_ENTRY(BgL_a1z00_12626) (BgL_a1z00_12626,
								BgL_sz00_12629, BEOA);
							BgL_a2z00_15157 =
								PROCEDURE_ENTRY(BgL_a2z00_12627) (BgL_a2z00_12627,
								BgL_sz00_12629, BEOA);
							if (INTEGERP(BgL_a1z00_15156))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4647z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15156,
										BgL_locz00_12628);
								}
							if (INTEGERP(BgL_a2z00_15157))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4647z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15157,
										BgL_locz00_12628);
								}
							BgL_tmpz00_23539 =
								((long) CINT(BgL_a1z00_15156) <= (long) CINT(BgL_a2z00_15157));
					}}
					return BBOOL(BgL_tmpz00_23539);
				}
			}
		}

	}



/* &<@anonymous:2871> */
	obj_t BGl_z62zc3z04anonymousza32871ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12630, obj_t BgL_sz00_12634)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12631;
				obj_t BgL_a2z00_12632;
				obj_t BgL_locz00_12633;

				BgL_a1z00_12631 = PROCEDURE_REF(BgL_envz00_12630, (int) (((long) 0)));
				BgL_a2z00_12632 = PROCEDURE_REF(BgL_envz00_12630, (int) (((long) 1)));
				BgL_locz00_12633 = PROCEDURE_REF(BgL_envz00_12630, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23566;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15158;

						BgL_bpz00_15158 = VECTOR_REF(((obj_t) BgL_sz00_12634), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15159;
							obj_t BgL_a2z00_15160;

							BgL_a1z00_15159 =
								PROCEDURE_ENTRY(BgL_a1z00_12631) (BgL_a1z00_12631,
								BgL_sz00_12634, BEOA);
							BgL_a2z00_15160 =
								PROCEDURE_ENTRY(BgL_a2z00_12632) (BgL_a2z00_12632,
								BgL_sz00_12634, BEOA);
							if (INTEGERP(BgL_a1z00_15159))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4649z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15159,
										BgL_locz00_12633);
								}
							if (INTEGERP(BgL_a2z00_15160))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4649z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15160,
										BgL_locz00_12633);
								}
							BgL_tmpz00_23566 =
								((long) CINT(BgL_a1z00_15159) >= (long) CINT(BgL_a2z00_15160));
					}}
					return BBOOL(BgL_tmpz00_23566);
				}
			}
		}

	}



/* &<@anonymous:2875> */
	obj_t BGl_z62zc3z04anonymousza32875ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12635, obj_t BgL_sz00_12639)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12636;
				obj_t BgL_a2z00_12637;
				obj_t BgL_locz00_12638;

				BgL_a1z00_12636 = PROCEDURE_REF(BgL_envz00_12635, (int) (((long) 0)));
				BgL_a2z00_12637 = PROCEDURE_REF(BgL_envz00_12635, (int) (((long) 1)));
				BgL_locz00_12638 = PROCEDURE_REF(BgL_envz00_12635, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23593;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15161;

						BgL_bpz00_15161 = VECTOR_REF(((obj_t) BgL_sz00_12639), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15162;
							obj_t BgL_a2z00_15163;

							BgL_a1z00_15162 =
								PROCEDURE_ENTRY(BgL_a1z00_12636) (BgL_a1z00_12636,
								BgL_sz00_12639, BEOA);
							BgL_a2z00_15163 =
								PROCEDURE_ENTRY(BgL_a2z00_12637) (BgL_a2z00_12637,
								BgL_sz00_12639, BEOA);
							if (INTEGERP(BgL_a1z00_15162))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4651z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a1z00_15162,
										BgL_locz00_12638);
								}
							if (INTEGERP(BgL_a2z00_15163))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4651z00zz__evaluate_compz00,
										BGl_symbol4635z00zz__evaluate_compz00, BgL_a2z00_15163,
										BgL_locz00_12638);
								}
							BgL_tmpz00_23593 =
								((long) CINT(BgL_a1z00_15162) == (long) CINT(BgL_a2z00_15163));
					}}
					return BBOOL(BgL_tmpz00_23593);
				}
			}
		}

	}



/* &<@anonymous:2879> */
	obj_t BGl_z62zc3z04anonymousza32879ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12640, obj_t BgL_sz00_12644)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12641;
				obj_t BgL_a2z00_12642;
				obj_t BgL_locz00_12643;

				BgL_a1z00_12641 = PROCEDURE_REF(BgL_envz00_12640, (int) (((long) 0)));
				BgL_a2z00_12642 = PROCEDURE_REF(BgL_envz00_12640, (int) (((long) 1)));
				BgL_locz00_12643 = PROCEDURE_REF(BgL_envz00_12640, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_23620;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15164;

						BgL_bpz00_15164 = VECTOR_REF(((obj_t) BgL_sz00_12644), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15165;
							obj_t BgL_a2z00_15166;

							BgL_a1z00_15165 =
								PROCEDURE_ENTRY(BgL_a1z00_12641) (BgL_a1z00_12641,
								BgL_sz00_12644, BEOA);
							BgL_a2z00_15166 =
								PROCEDURE_ENTRY(BgL_a2z00_12642) (BgL_a2z00_12642,
								BgL_sz00_12644, BEOA);
							if (REALP(BgL_a1z00_15165))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4653z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15165,
										BgL_locz00_12643);
								}
							if (REALP(BgL_a2z00_15166))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4653z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15166,
										BgL_locz00_12643);
								}
							BgL_tmpz00_23620 =
								(REAL_TO_DOUBLE(BgL_a1z00_15165) +
								REAL_TO_DOUBLE(BgL_a2z00_15166));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_23620);
				}
			}
		}

	}



/* &<@anonymous:2883> */
	obj_t BGl_z62zc3z04anonymousza32883ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12645, obj_t BgL_sz00_12649)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12646;
				obj_t BgL_a2z00_12647;
				obj_t BgL_locz00_12648;

				BgL_a1z00_12646 = PROCEDURE_REF(BgL_envz00_12645, (int) (((long) 0)));
				BgL_a2z00_12647 = PROCEDURE_REF(BgL_envz00_12645, (int) (((long) 1)));
				BgL_locz00_12648 = PROCEDURE_REF(BgL_envz00_12645, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_23647;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15167;

						BgL_bpz00_15167 = VECTOR_REF(((obj_t) BgL_sz00_12649), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15168;
							obj_t BgL_a2z00_15169;

							BgL_a1z00_15168 =
								PROCEDURE_ENTRY(BgL_a1z00_12646) (BgL_a1z00_12646,
								BgL_sz00_12649, BEOA);
							BgL_a2z00_15169 =
								PROCEDURE_ENTRY(BgL_a2z00_12647) (BgL_a2z00_12647,
								BgL_sz00_12649, BEOA);
							if (REALP(BgL_a1z00_15168))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4657z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15168,
										BgL_locz00_12648);
								}
							if (REALP(BgL_a2z00_15169))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4657z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15169,
										BgL_locz00_12648);
								}
							BgL_tmpz00_23647 =
								(REAL_TO_DOUBLE(BgL_a1z00_15168) -
								REAL_TO_DOUBLE(BgL_a2z00_15169));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_23647);
				}
			}
		}

	}



/* &<@anonymous:2887> */
	obj_t BGl_z62zc3z04anonymousza32887ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12650, obj_t BgL_sz00_12654)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12651;
				obj_t BgL_a2z00_12652;
				obj_t BgL_locz00_12653;

				BgL_a1z00_12651 = PROCEDURE_REF(BgL_envz00_12650, (int) (((long) 0)));
				BgL_a2z00_12652 = PROCEDURE_REF(BgL_envz00_12650, (int) (((long) 1)));
				BgL_locz00_12653 = PROCEDURE_REF(BgL_envz00_12650, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_23674;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15170;

						BgL_bpz00_15170 = VECTOR_REF(((obj_t) BgL_sz00_12654), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15171;
							obj_t BgL_a2z00_15172;

							BgL_a1z00_15171 =
								PROCEDURE_ENTRY(BgL_a1z00_12651) (BgL_a1z00_12651,
								BgL_sz00_12654, BEOA);
							BgL_a2z00_15172 =
								PROCEDURE_ENTRY(BgL_a2z00_12652) (BgL_a2z00_12652,
								BgL_sz00_12654, BEOA);
							if (REALP(BgL_a1z00_15171))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4659z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15171,
										BgL_locz00_12653);
								}
							if (REALP(BgL_a2z00_15172))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4659z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15172,
										BgL_locz00_12653);
								}
							BgL_tmpz00_23674 =
								(REAL_TO_DOUBLE(BgL_a1z00_15171) *
								REAL_TO_DOUBLE(BgL_a2z00_15172));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_23674);
				}
			}
		}

	}



/* &<@anonymous:2891> */
	obj_t BGl_z62zc3z04anonymousza32891ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12655, obj_t BgL_sz00_12659)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12656;
				obj_t BgL_a2z00_12657;
				obj_t BgL_locz00_12658;

				BgL_a1z00_12656 = PROCEDURE_REF(BgL_envz00_12655, (int) (((long) 0)));
				BgL_a2z00_12657 = PROCEDURE_REF(BgL_envz00_12655, (int) (((long) 1)));
				BgL_locz00_12658 = PROCEDURE_REF(BgL_envz00_12655, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_23701;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15173;

						BgL_bpz00_15173 = VECTOR_REF(((obj_t) BgL_sz00_12659), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15174;
							obj_t BgL_a2z00_15175;

							BgL_a1z00_15174 =
								PROCEDURE_ENTRY(BgL_a1z00_12656) (BgL_a1z00_12656,
								BgL_sz00_12659, BEOA);
							BgL_a2z00_15175 =
								PROCEDURE_ENTRY(BgL_a2z00_12657) (BgL_a2z00_12657,
								BgL_sz00_12659, BEOA);
							if (REALP(BgL_a1z00_15174))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4661z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15174,
										BgL_locz00_12658);
								}
							if (REALP(BgL_a2z00_15175))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4661z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15175,
										BgL_locz00_12658);
								}
							BgL_tmpz00_23701 =
								(REAL_TO_DOUBLE(BgL_a1z00_15174) /
								REAL_TO_DOUBLE(BgL_a2z00_15175));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_23701);
				}
			}
		}

	}



/* &<@anonymous:2895> */
	obj_t BGl_z62zc3z04anonymousza32895ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12660, obj_t BgL_sz00_12664)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12661;
				obj_t BgL_a2z00_12662;
				obj_t BgL_locz00_12663;

				BgL_a1z00_12661 = PROCEDURE_REF(BgL_envz00_12660, (int) (((long) 0)));
				BgL_a2z00_12662 = PROCEDURE_REF(BgL_envz00_12660, (int) (((long) 1)));
				BgL_locz00_12663 = PROCEDURE_REF(BgL_envz00_12660, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23728;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15176;

						BgL_bpz00_15176 = VECTOR_REF(((obj_t) BgL_sz00_12664), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15177;
							obj_t BgL_a2z00_15178;

							BgL_a1z00_15177 =
								PROCEDURE_ENTRY(BgL_a1z00_12661) (BgL_a1z00_12661,
								BgL_sz00_12664, BEOA);
							BgL_a2z00_15178 =
								PROCEDURE_ENTRY(BgL_a2z00_12662) (BgL_a2z00_12662,
								BgL_sz00_12664, BEOA);
							if (REALP(BgL_a1z00_15177))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4663z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15177,
										BgL_locz00_12663);
								}
							if (REALP(BgL_a2z00_15178))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4663z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15178,
										BgL_locz00_12663);
								}
							BgL_tmpz00_23728 =
								(REAL_TO_DOUBLE(BgL_a1z00_15177) <
								REAL_TO_DOUBLE(BgL_a2z00_15178));
						}
					}
					return BBOOL(BgL_tmpz00_23728);
				}
			}
		}

	}



/* &<@anonymous:2899> */
	obj_t BGl_z62zc3z04anonymousza32899ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12665, obj_t BgL_sz00_12669)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12666;
				obj_t BgL_a2z00_12667;
				obj_t BgL_locz00_12668;

				BgL_a1z00_12666 = PROCEDURE_REF(BgL_envz00_12665, (int) (((long) 0)));
				BgL_a2z00_12667 = PROCEDURE_REF(BgL_envz00_12665, (int) (((long) 1)));
				BgL_locz00_12668 = PROCEDURE_REF(BgL_envz00_12665, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23755;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15179;

						BgL_bpz00_15179 = VECTOR_REF(((obj_t) BgL_sz00_12669), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15180;
							obj_t BgL_a2z00_15181;

							BgL_a1z00_15180 =
								PROCEDURE_ENTRY(BgL_a1z00_12666) (BgL_a1z00_12666,
								BgL_sz00_12669, BEOA);
							BgL_a2z00_15181 =
								PROCEDURE_ENTRY(BgL_a2z00_12667) (BgL_a2z00_12667,
								BgL_sz00_12669, BEOA);
							if (REALP(BgL_a1z00_15180))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4665z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15180,
										BgL_locz00_12668);
								}
							if (REALP(BgL_a2z00_15181))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4665z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15181,
										BgL_locz00_12668);
								}
							BgL_tmpz00_23755 =
								(REAL_TO_DOUBLE(BgL_a1z00_15180) >
								REAL_TO_DOUBLE(BgL_a2z00_15181));
						}
					}
					return BBOOL(BgL_tmpz00_23755);
				}
			}
		}

	}



/* &<@anonymous:2903> */
	obj_t BGl_z62zc3z04anonymousza32903ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12670, obj_t BgL_sz00_12674)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12671;
				obj_t BgL_a2z00_12672;
				obj_t BgL_locz00_12673;

				BgL_a1z00_12671 = PROCEDURE_REF(BgL_envz00_12670, (int) (((long) 0)));
				BgL_a2z00_12672 = PROCEDURE_REF(BgL_envz00_12670, (int) (((long) 1)));
				BgL_locz00_12673 = PROCEDURE_REF(BgL_envz00_12670, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23782;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15182;

						BgL_bpz00_15182 = VECTOR_REF(((obj_t) BgL_sz00_12674), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15183;
							obj_t BgL_a2z00_15184;

							BgL_a1z00_15183 =
								PROCEDURE_ENTRY(BgL_a1z00_12671) (BgL_a1z00_12671,
								BgL_sz00_12674, BEOA);
							BgL_a2z00_15184 =
								PROCEDURE_ENTRY(BgL_a2z00_12672) (BgL_a2z00_12672,
								BgL_sz00_12674, BEOA);
							if (REALP(BgL_a1z00_15183))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4667z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15183,
										BgL_locz00_12673);
								}
							if (REALP(BgL_a2z00_15184))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4667z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15184,
										BgL_locz00_12673);
								}
							BgL_tmpz00_23782 =
								(REAL_TO_DOUBLE(BgL_a1z00_15183) <=
								REAL_TO_DOUBLE(BgL_a2z00_15184));
						}
					}
					return BBOOL(BgL_tmpz00_23782);
				}
			}
		}

	}



/* &<@anonymous:2907> */
	obj_t BGl_z62zc3z04anonymousza32907ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12675, obj_t BgL_sz00_12679)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12676;
				obj_t BgL_a2z00_12677;
				obj_t BgL_locz00_12678;

				BgL_a1z00_12676 = PROCEDURE_REF(BgL_envz00_12675, (int) (((long) 0)));
				BgL_a2z00_12677 = PROCEDURE_REF(BgL_envz00_12675, (int) (((long) 1)));
				BgL_locz00_12678 = PROCEDURE_REF(BgL_envz00_12675, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23809;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15185;

						BgL_bpz00_15185 = VECTOR_REF(((obj_t) BgL_sz00_12679), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15186;
							obj_t BgL_a2z00_15187;

							BgL_a1z00_15186 =
								PROCEDURE_ENTRY(BgL_a1z00_12676) (BgL_a1z00_12676,
								BgL_sz00_12679, BEOA);
							BgL_a2z00_15187 =
								PROCEDURE_ENTRY(BgL_a2z00_12677) (BgL_a2z00_12677,
								BgL_sz00_12679, BEOA);
							if (REALP(BgL_a1z00_15186))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4669z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15186,
										BgL_locz00_12678);
								}
							if (REALP(BgL_a2z00_15187))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4669z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15187,
										BgL_locz00_12678);
								}
							BgL_tmpz00_23809 =
								(REAL_TO_DOUBLE(BgL_a1z00_15186) >=
								REAL_TO_DOUBLE(BgL_a2z00_15187));
						}
					}
					return BBOOL(BgL_tmpz00_23809);
				}
			}
		}

	}



/* &<@anonymous:2911> */
	obj_t BGl_z62zc3z04anonymousza32911ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12680, obj_t BgL_sz00_12684)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12681;
				obj_t BgL_a2z00_12682;
				obj_t BgL_locz00_12683;

				BgL_a1z00_12681 = PROCEDURE_REF(BgL_envz00_12680, (int) (((long) 0)));
				BgL_a2z00_12682 = PROCEDURE_REF(BgL_envz00_12680, (int) (((long) 1)));
				BgL_locz00_12683 = PROCEDURE_REF(BgL_envz00_12680, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23836;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15188;

						BgL_bpz00_15188 = VECTOR_REF(((obj_t) BgL_sz00_12684), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15189;
							obj_t BgL_a2z00_15190;

							BgL_a1z00_15189 =
								PROCEDURE_ENTRY(BgL_a1z00_12681) (BgL_a1z00_12681,
								BgL_sz00_12684, BEOA);
							BgL_a2z00_15190 =
								PROCEDURE_ENTRY(BgL_a2z00_12682) (BgL_a2z00_12682,
								BgL_sz00_12684, BEOA);
							if (REALP(BgL_a1z00_15189))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4671z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a1z00_15189,
										BgL_locz00_12683);
								}
							if (REALP(BgL_a2z00_15190))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4671z00zz__evaluate_compz00,
										BGl_symbol4655z00zz__evaluate_compz00, BgL_a2z00_15190,
										BgL_locz00_12683);
								}
							BgL_tmpz00_23836 =
								(REAL_TO_DOUBLE(BgL_a1z00_15189) ==
								REAL_TO_DOUBLE(BgL_a2z00_15190));
						}
					}
					return BBOOL(BgL_tmpz00_23836);
				}
			}
		}

	}



/* &<@anonymous:2915> */
	obj_t BGl_z62zc3z04anonymousza32915ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12685, obj_t BgL_sz00_12688)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12686;
				obj_t BgL_a2z00_12687;

				BgL_a1z00_12686 = PROCEDURE_REF(BgL_envz00_12685, (int) (((long) 0)));
				BgL_a2z00_12687 = PROCEDURE_REF(BgL_envz00_12685, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_23861;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_15191;

						BgL_bpz00_15191 = VECTOR_REF(((obj_t) BgL_sz00_12688), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_15192;
							obj_t BgL_a2z00_15193;

							BgL_a1z00_15192 =
								PROCEDURE_ENTRY(BgL_a1z00_12686) (BgL_a1z00_12686,
								BgL_sz00_12688, BEOA);
							BgL_a2z00_15193 =
								PROCEDURE_ENTRY(BgL_a2z00_12687) (BgL_a2z00_12687,
								BgL_sz00_12688, BEOA);
							BgL_tmpz00_23861 = (BgL_a1z00_15192 == BgL_a2z00_15193);
					}}
					return BBOOL(BgL_tmpz00_23861);
				}
			}
		}

	}



/* &<@anonymous:2917> */
	obj_t BGl_z62zc3z04anonymousza32917ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12689, obj_t BgL_sz00_12692)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_12690;
				obj_t BgL_a2z00_12691;

				BgL_a1z00_12690 = PROCEDURE_REF(BgL_envz00_12689, (int) (((long) 0)));
				BgL_a2z00_12691 = PROCEDURE_REF(BgL_envz00_12689, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_15194;

					BgL_bpz00_15194 = VECTOR_REF(((obj_t) BgL_sz00_12692), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_15195;
						obj_t BgL_a2z00_15196;

						BgL_a1z00_15195 =
							PROCEDURE_ENTRY(BgL_a1z00_12690) (BgL_a1z00_12690, BgL_sz00_12692,
							BEOA);
						BgL_a2z00_15196 =
							PROCEDURE_ENTRY(BgL_a2z00_12691) (BgL_a2z00_12691, BgL_sz00_12692,
							BEOA);
						return MAKE_YOUNG_PAIR(BgL_a1z00_15195, BgL_a2z00_15196);
					}
				}
			}
		}

	}



/* &<@anonymous:2920> */
	obj_t BGl_z62zc3z04anonymousza32920ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12693, obj_t BgL_sz00_12696)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_12694;
				obj_t BgL_locz00_12695;

				BgL_a1z00_12694 = PROCEDURE_REF(BgL_envz00_12693, (int) (((long) 0)));
				BgL_locz00_12695 = PROCEDURE_REF(BgL_envz00_12693, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_15197;

					BgL_bpz00_15197 = VECTOR_REF(((obj_t) BgL_sz00_12696), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_15198;

						BgL_a1z00_15198 =
							PROCEDURE_ENTRY(BgL_a1z00_12694) (BgL_a1z00_12694, BgL_sz00_12696,
							BEOA);
						if (PAIRP(BgL_a1z00_15198))
							{	/* Eval/evaluate_comp.scm 1018 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1018 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4673z00zz__evaluate_compz00,
									BGl_symbol4675z00zz__evaluate_compz00, BgL_a1z00_15198,
									BgL_locz00_12695);
							}
						return CAR(((obj_t) BgL_a1z00_15198));
					}
				}
			}
		}

	}



/* &<@anonymous:2923> */
	obj_t BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12697, obj_t BgL_sz00_12700)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_12698;
				obj_t BgL_locz00_12699;

				BgL_a1z00_12698 = PROCEDURE_REF(BgL_envz00_12697, (int) (((long) 0)));
				BgL_locz00_12699 = PROCEDURE_REF(BgL_envz00_12697, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_15199;

					BgL_bpz00_15199 = VECTOR_REF(((obj_t) BgL_sz00_12700), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_15200;

						BgL_a1z00_15200 =
							PROCEDURE_ENTRY(BgL_a1z00_12698) (BgL_a1z00_12698, BgL_sz00_12700,
							BEOA);
						if (PAIRP(BgL_a1z00_15200))
							{	/* Eval/evaluate_comp.scm 1018 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1018 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol4677z00zz__evaluate_compz00,
									BGl_symbol4675z00zz__evaluate_compz00, BgL_a1z00_15200,
									BgL_locz00_12699);
							}
						return CDR(((obj_t) BgL_a1z00_15200));
					}
				}
			}
		}

	}



/* &<@anonymous:2926> */
	obj_t BGl_z62zc3z04anonymousza32926ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12701, obj_t BgL_sz00_12704)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_12702;
				obj_t BgL_locz00_12703;

				BgL_a1z00_12702 = PROCEDURE_REF(BgL_envz00_12701, (int) (((long) 0)));
				BgL_locz00_12703 = PROCEDURE_REF(BgL_envz00_12701, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_15201;

					BgL_bpz00_15201 = VECTOR_REF(((obj_t) BgL_sz00_12704), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_15202;

						BgL_a1z00_15202 =
							PROCEDURE_ENTRY(BgL_a1z00_12702) (BgL_a1z00_12702, BgL_sz00_12704,
							BEOA);
						{	/* Eval/evaluate_comp.scm 1018 */
							bool_t BgL_test5316z00_23929;

							if (PAIRP(BgL_a1z00_15202))
								{	/* Eval/evaluate_comp.scm 1027 */
									obj_t BgL_tmpz00_23932;

									BgL_tmpz00_23932 = CDR(BgL_a1z00_15202);
									BgL_test5316z00_23929 = PAIRP(BgL_tmpz00_23932);
								}
							else
								{	/* Eval/evaluate_comp.scm 1027 */
									BgL_test5316z00_23929 = ((bool_t) 0);
								}
							if (BgL_test5316z00_23929)
								{	/* Eval/evaluate_comp.scm 1018 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1018 */
									obj_t BgL_arg2928z00_15203;

									if (PAIRP(BgL_a1z00_15202))
										{	/* Eval/evaluate_comp.scm 1030 */
											BgL_arg2928z00_15203 = CDR(BgL_a1z00_15202);
										}
									else
										{	/* Eval/evaluate_comp.scm 1030 */
											BgL_arg2928z00_15203 = BgL_a1z00_15202;
										}
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol4679z00zz__evaluate_compz00,
										BGl_symbol4675z00zz__evaluate_compz00, BgL_arg2928z00_15203,
										BgL_locz00_12703);
								}
						}
						{	/* Eval/evaluate_comp.scm 1018 */
							obj_t BgL_pairz00_15204;

							BgL_pairz00_15204 = CDR(((obj_t) BgL_a1z00_15202));
							return CAR(BgL_pairz00_15204);
						}
					}
				}
			}
		}

	}



/* bind-frame */
	obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203,
		obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206,
		obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
	{
		{	/* Eval/evaluate_comp.scm 1063 */
			if ((BgL_arityz00_206 < ((long) 0)))
				{	/* Eval/evaluate_comp.scm 1065 */
					long BgL_g1237z00_3525;

					BgL_g1237z00_3525 = (((long) -1) - BgL_arityz00_206);
					{
						long BgL_rz00_3527;
						long BgL_spz00_3528;
						obj_t BgL_lz00_3529;

						BgL_rz00_3527 = BgL_g1237z00_3525;
						BgL_spz00_3528 = BgL_spz00_205;
						BgL_lz00_3529 = BgL_valsz00_207;
					BgL_zc3z04anonymousza32933ze3z87_3530:
						if ((BgL_rz00_3527 == ((long) 0)))
							{	/* Eval/evaluate_comp.scm 1067 */
								return
									VECTOR_SET(
									((obj_t) BgL_sz00_203), BgL_spz00_3528, BgL_lz00_3529);
							}
						else
							{	/* Eval/evaluate_comp.scm 1067 */
								if (PAIRP(BgL_lz00_3529))
									{	/* Eval/evaluate_comp.scm 1069 */
										{	/* Eval/evaluate_comp.scm 1072 */
											obj_t BgL_arg2940z00_3533;

											BgL_arg2940z00_3533 = CAR(BgL_lz00_3529);
											VECTOR_SET(
												((obj_t) BgL_sz00_203), BgL_spz00_3528,
												BgL_arg2940z00_3533);
										}
										{
											obj_t BgL_lz00_23958;
											long BgL_spz00_23956;
											long BgL_rz00_23954;

											BgL_rz00_23954 = (BgL_rz00_3527 - ((long) 1));
											BgL_spz00_23956 = (BgL_spz00_3528 + ((long) 1));
											BgL_lz00_23958 = CDR(BgL_lz00_3529);
											BgL_lz00_3529 = BgL_lz00_23958;
											BgL_spz00_3528 = BgL_spz00_23956;
											BgL_rz00_3527 = BgL_rz00_23954;
											goto BgL_zc3z04anonymousza32933ze3z87_3530;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1070 */
										long BgL_arg2944z00_3537;

										BgL_arg2944z00_3537 = bgl_list_length(BgL_valsz00_207);
										return
											BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
											BgL_wherez00_204, (int) (BgL_arityz00_206),
											(int) (BgL_arg2944z00_3537));
				}}}}
			else
				{
					long BgL_rz00_3540;
					long BgL_spz00_3541;
					obj_t BgL_lz00_3542;

					BgL_rz00_3540 = BgL_arityz00_206;
					BgL_spz00_3541 = BgL_spz00_205;
					BgL_lz00_3542 = BgL_valsz00_207;
				BgL_zc3z04anonymousza32945ze3z87_3543:
					if ((BgL_rz00_3540 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 1076 */
							if (NULLP(BgL_lz00_3542))
								{	/* Eval/evaluate_comp.scm 1077 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1078 */
									long BgL_arg2949z00_3546;

									BgL_arg2949z00_3546 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2949z00_3546));
						}}
					else
						{	/* Eval/evaluate_comp.scm 1076 */
							if (PAIRP(BgL_lz00_3542))
								{	/* Eval/evaluate_comp.scm 1079 */
									{	/* Eval/evaluate_comp.scm 1082 */
										obj_t BgL_arg2952z00_3548;

										BgL_arg2952z00_3548 = CAR(BgL_lz00_3542);
										VECTOR_SET(
											((obj_t) BgL_sz00_203), BgL_spz00_3541,
											BgL_arg2952z00_3548);
									}
									{
										obj_t BgL_lz00_23981;
										long BgL_spz00_23979;
										long BgL_rz00_23977;

										BgL_rz00_23977 = (BgL_rz00_3540 - ((long) 1));
										BgL_spz00_23979 = (BgL_spz00_3541 + ((long) 1));
										BgL_lz00_23981 = CDR(BgL_lz00_3542);
										BgL_lz00_3542 = BgL_lz00_23981;
										BgL_spz00_3541 = BgL_spz00_23979;
										BgL_rz00_3540 = BgL_rz00_23977;
										goto BgL_zc3z04anonymousza32945ze3z87_3543;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 1080 */
									long BgL_arg2956z00_3552;

									BgL_arg2956z00_3552 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2956z00_3552));
		}}}}

	}



/* make-boxes */
	bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211,
		obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
	{
		{	/* Eval/evaluate_comp.scm 1177 */
			{
				long BgL_iz00_3556;

				BgL_iz00_3556 = ((long) 0);
			BgL_zc3z04anonymousza32957ze3z87_3557:
				{	/* Eval/evaluate_comp.scm 1180 */
					long BgL_spz00_3558;

					{	/* Eval/evaluate_comp.scm 1180 */
						obj_t BgL_arg2964z00_3563;

						BgL_arg2964z00_3563 =
							VECTOR_REF(((obj_t) BgL_ibza2za2_212), BgL_iz00_3556);
						BgL_spz00_3558 =
							((long) CINT(BgL_bpz00_213) + (long) CINT(BgL_arg2964z00_3563));
					}
					{	/* Eval/evaluate_comp.scm 1181 */
						obj_t BgL_arg2959z00_3559;

						{	/* Eval/evaluate_comp.scm 1181 */
							obj_t BgL_arg2961z00_3560;

							BgL_arg2961z00_3560 =
								VECTOR_REF(((obj_t) BgL_sz00_211), BgL_spz00_3558);
							{	/* Eval/evaluate_comp.scm 202 */
								obj_t BgL_newz00_8991;

								BgL_newz00_8991 =
									create_struct(BGl_symbol4603z00zz__evaluate_compz00,
									(int) (((long) 1)));
								{	/* Eval/evaluate_comp.scm 202 */
									int BgL_tmpz00_23996;

									BgL_tmpz00_23996 = (int) (((long) 0));
									STRUCT_SET(BgL_newz00_8991, BgL_tmpz00_23996,
										BgL_arg2961z00_3560);
								}
								BgL_arg2959z00_3559 = BgL_newz00_8991;
						}}
						VECTOR_SET(
							((obj_t) BgL_sz00_211), BgL_spz00_3558, BgL_arg2959z00_3559);
					}
					{	/* Eval/evaluate_comp.scm 1182 */
						long BgL_niz00_3561;

						BgL_niz00_3561 = (BgL_iz00_3556 + ((long) 1));
						if ((BgL_niz00_3561 < VECTOR_LENGTH(((obj_t) BgL_ibza2za2_212))))
							{
								long BgL_iz00_24006;

								BgL_iz00_24006 = BgL_niz00_3561;
								BgL_iz00_3556 = BgL_iz00_24006;
								goto BgL_zc3z04anonymousza32957ze3z87_3557;
							}
						else
							{	/* Eval/evaluate_comp.scm 1183 */
								return ((bool_t) 0);
							}
					}
				}
			}
		}

	}



/* free-collect */
	obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214,
		obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
	{
		{	/* Eval/evaluate_comp.scm 1185 */
			{	/* Eval/evaluate_comp.scm 1186 */
				obj_t BgL_rz00_3566;

				BgL_rz00_3566 =
					make_vector(VECTOR_LENGTH(((obj_t) BgL_iza2za2_216)), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 1186 */

					{
						long BgL_iz00_3568;

						BgL_iz00_3568 = ((long) 0);
					BgL_zc3z04anonymousza32965ze3z87_3569:
						if ((BgL_iz00_3568 >= VECTOR_LENGTH(((obj_t) BgL_iza2za2_216))))
							{	/* Eval/evaluate_comp.scm 1188 */
								return BgL_rz00_3566;
							}
						else
							{	/* Eval/evaluate_comp.scm 1188 */
								{	/* Eval/evaluate_comp.scm 1191 */
									obj_t BgL_arg2967z00_3571;

									{	/* Eval/evaluate_comp.scm 1191 */
										long BgL_arg2968z00_3572;

										{	/* Eval/evaluate_comp.scm 1191 */
											obj_t BgL_arg2971z00_3573;

											BgL_arg2971z00_3573 =
												VECTOR_REF(((obj_t) BgL_iza2za2_216), BgL_iz00_3568);
											BgL_arg2968z00_3572 =
												(
												(long) CINT(BgL_bpz00_215) +
												(long) CINT(BgL_arg2971z00_3573));
										}
										BgL_arg2967z00_3571 =
											VECTOR_REF(((obj_t) BgL_sz00_214), BgL_arg2968z00_3572);
									}
									VECTOR_SET(BgL_rz00_3566, BgL_iz00_3568, BgL_arg2967z00_3571);
								}
								{
									long BgL_iz00_24022;

									BgL_iz00_24022 = (BgL_iz00_3568 + ((long) 1));
									BgL_iz00_3568 = BgL_iz00_24022;
									goto BgL_zc3z04anonymousza32965ze3z87_3569;
								}
							}
					}
				}
			}
		}

	}



/* free-restore */
	bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217,
		obj_t BgL_valza2za2_218, long BgL_spz00_219)
	{
		{	/* Eval/evaluate_comp.scm 1194 */
			{	/* Eval/evaluate_comp.scm 1195 */
				long BgL_stopz00_3577;

				BgL_stopz00_3577 =
					(BgL_spz00_219 + VECTOR_LENGTH(((obj_t) BgL_valza2za2_218)));
				{
					long BgL_iz00_9039;
					long BgL_spz00_9040;

					BgL_iz00_9039 = ((long) 0);
					BgL_spz00_9040 = BgL_spz00_219;
				BgL_recz00_9038:
					if ((BgL_spz00_9040 < BgL_stopz00_3577))
						{	/* Eval/evaluate_comp.scm 1197 */
							{	/* Eval/evaluate_comp.scm 1198 */
								obj_t BgL_arg2977z00_9046;

								BgL_arg2977z00_9046 =
									VECTOR_REF(((obj_t) BgL_valza2za2_218), BgL_iz00_9039);
								VECTOR_SET(
									((obj_t) BgL_sz00_217), BgL_spz00_9040, BgL_arg2977z00_9046);
							}
							{
								long BgL_spz00_24035;
								long BgL_iz00_24033;

								BgL_iz00_24033 = (BgL_iz00_9039 + ((long) 1));
								BgL_spz00_24035 = (BgL_spz00_9040 + ((long) 1));
								BgL_spz00_9040 = BgL_spz00_24035;
								BgL_iz00_9039 = BgL_iz00_24033;
								goto BgL_recz00_9038;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 1197 */
							return ((bool_t) 0);
						}
				}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_proc4681z00zz__evaluate_compz00,
				BGl_ev_exprz00zz__evaluate_typesz00,
				BGl_string4682z00zz__evaluate_compz00);
		}

	}



/* &comp1389 */
	obj_t BGl_z62comp1389z62zz__evaluate_compz00(obj_t BgL_envz00_12790,
		obj_t BgL_ez00_12791, obj_t BgL_stkz00_12792)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			return
				BGl_errorz00zz__errorz00(BGl_string4593z00zz__evaluate_compz00,
				BGl_string4683z00zz__evaluate_compz00,
				((obj_t) ((BgL_ev_exprz00_bglt) BgL_ez00_12791)));
		}

	}



/* comp */
	obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35,
		obj_t BgL_stkz00_36)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				obj_t BgL_method1392z00_3593;

				{	/* Eval/evaluate_comp.scm 276 */
					obj_t BgL_res4457z00_9087;

					{	/* Eval/evaluate_comp.scm 276 */
						long BgL_objzd2classzd2numz00_9058;

						BgL_objzd2classzd2numz00_9058 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_ez00_35));
						{	/* Eval/evaluate_comp.scm 276 */
							obj_t BgL_arg4344z00_9059;

							BgL_arg4344z00_9059 =
								PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00,
								(int) (((long) 1)));
							{	/* Eval/evaluate_comp.scm 276 */
								int BgL_offsetz00_9062;

								BgL_offsetz00_9062 = (int) (BgL_objzd2classzd2numz00_9058);
								{	/* Eval/evaluate_comp.scm 276 */
									long BgL_offsetz00_9063;

									BgL_offsetz00_9063 =
										((long) (BgL_offsetz00_9062) - OBJECT_TYPE);
									{	/* Eval/evaluate_comp.scm 276 */
										long BgL_modz00_9064;

										BgL_modz00_9064 =
											(BgL_offsetz00_9063 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Eval/evaluate_comp.scm 276 */
											long BgL_restz00_9066;

											BgL_restz00_9066 =
												(BgL_offsetz00_9063 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Eval/evaluate_comp.scm 276 */

												{	/* Eval/evaluate_comp.scm 276 */
													obj_t BgL_bucketz00_9068;

													BgL_bucketz00_9068 =
														VECTOR_REF(
														((obj_t) BgL_arg4344z00_9059), BgL_modz00_9064);
													BgL_res4457z00_9087 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_9068), BgL_restz00_9066);
					}}}}}}}}
					BgL_method1392z00_3593 = BgL_res4457z00_9087;
				}
				return
					PROCEDURE_ENTRY(BgL_method1392z00_3593) (BgL_method1392z00_3593,
					((obj_t) BgL_ez00_35), BgL_stkz00_36, BEOA);
			}
		}

	}



/* &comp */
	obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_12793,
		obj_t BgL_ez00_12794, obj_t BgL_stkz00_12795)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				BgL_ev_exprz00_bglt BgL_auxz00_24072;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_12794,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 276 */
						BgL_auxz00_24072 = ((BgL_ev_exprz00_bglt) BgL_ez00_12794);
					}
				else
					{
						obj_t BgL_auxz00_24076;

						BgL_auxz00_24076 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string4598z00zz__evaluate_compz00, BINT(((long) 7022)),
							BGl_string4684z00zz__evaluate_compz00,
							BGl_string4600z00zz__evaluate_compz00, BgL_ez00_12794);
						FAILURE(BgL_auxz00_24076, BFALSE, BFALSE);
					}
				return
					BGl_compz00zz__evaluate_compz00(BgL_auxz00_24072, BgL_stkz00_12795);
			}
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_trapz00zz__evaluate_typesz00,
				BGl_proc4685z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_varz00zz__evaluate_typesz00, BGl_proc4687z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setlocalz00zz__evaluate_typesz00,
				BGl_proc4688z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_globalz00zz__evaluate_typesz00,
				BGl_proc4689z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setglobalz00zz__evaluate_typesz00,
				BGl_proc4690z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_defglobalz00zz__evaluate_typesz00,
				BGl_proc4691z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_littz00zz__evaluate_typesz00,
				BGl_proc4692z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc4693z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_orz00zz__evaluate_typesz00, BGl_proc4694z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_andz00zz__evaluate_typesz00, BGl_proc4695z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_prog2z00zz__evaluate_typesz00,
				BGl_proc4696z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letz00zz__evaluate_typesz00, BGl_proc4697z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letza2za2zz__evaluate_typesz00,
				BGl_proc4698z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letrecz00zz__evaluate_typesz00,
				BGl_proc4699z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00,
				BGl_proc4700z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00,
				BGl_proc4701z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00,
				BGl_proc4702z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00,
				BGl_proc4703z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_labelsz00zz__evaluate_typesz00,
				BGl_proc4704z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_gotoz00zz__evaluate_typesz00,
				BGl_proc4705z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_appz00zz__evaluate_typesz00, BGl_proc4706z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_absz00zz__evaluate_typesz00, BGl_proc4707z00zz__evaluate_compz00,
				BGl_string4686z00zz__evaluate_compz00);
		}

	}



/* &comp-ev_abs1438 */
	obj_t BGl_z62compzd2ev_abs1438zb0zz__evaluate_compz00(obj_t BgL_envz00_12990,
		obj_t BgL_ez00_12991, obj_t BgL_stkz00_12992)
	{
		{	/* Eval/evaluate_comp.scm 1165 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15207;
				obj_t BgL_iboxesz00_15208;
				long BgL_siza7eza7_15209;
				long BgL_siza7ezd2framez75_15210;
				obj_t BgL_nstkz00_15211;

				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_arg4049z00_15212;

					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_l1366z00_15213;

						BgL_l1366z00_15213 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_freez00);
						if (NULLP(BgL_l1366z00_15213))
							{	/* Eval/evaluate_comp.scm 1167 */
								BgL_arg4049z00_15212 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_head1368z00_15214;

								BgL_head1368z00_15214 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								{
									obj_t BgL_l1366z00_15216;
									obj_t BgL_tail1369z00_15217;

									BgL_l1366z00_15216 = BgL_l1366z00_15213;
									BgL_tail1369z00_15217 = BgL_head1368z00_15214;
								BgL_zc3z04anonymousza34051ze3z87_15215:
									if (NULLP(BgL_l1366z00_15216))
										{	/* Eval/evaluate_comp.scm 1167 */
											BgL_arg4049z00_15212 = CDR(BgL_head1368z00_15214);
										}
									else
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_newtail1370z00_15218;

											{	/* Eval/evaluate_comp.scm 1167 */
												obj_t BgL_arg4054z00_15219;

												{	/* Eval/evaluate_comp.scm 1167 */
													obj_t BgL_vz00_15220;

													BgL_vz00_15220 = CAR(((obj_t) BgL_l1366z00_15216));
													BgL_arg4054z00_15219 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_15220,
														BgL_stkz00_12992);
												}
												BgL_newtail1370z00_15218 =
													MAKE_YOUNG_PAIR(BgL_arg4054z00_15219, BNIL);
											}
											SET_CDR(BgL_tail1369z00_15217, BgL_newtail1370z00_15218);
											{	/* Eval/evaluate_comp.scm 1167 */
												obj_t BgL_arg4053z00_15221;

												BgL_arg4053z00_15221 =
													CDR(((obj_t) BgL_l1366z00_15216));
												{
													obj_t BgL_tail1369z00_24119;
													obj_t BgL_l1366z00_24118;

													BgL_l1366z00_24118 = BgL_arg4053z00_15221;
													BgL_tail1369z00_24119 = BgL_newtail1370z00_15218;
													BgL_tail1369z00_15217 = BgL_tail1369z00_24119;
													BgL_l1366z00_15216 = BgL_l1366z00_24118;
													goto BgL_zc3z04anonymousza34051ze3z87_15215;
												}
											}
										}
								}
							}
					}
					BgL_ifreesz00_15207 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4049z00_15212);
				}
				{	/* Eval/evaluate_comp.scm 1168 */
					obj_t BgL_arg4055z00_15222;

					{	/* Eval/evaluate_comp.scm 1168 */
						obj_t BgL_l1371z00_15223;

						BgL_l1371z00_15223 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_boxesz00);
						if (NULLP(BgL_l1371z00_15223))
							{	/* Eval/evaluate_comp.scm 1168 */
								BgL_arg4055z00_15222 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1168 */
								obj_t BgL_head1373z00_15224;

								BgL_head1373z00_15224 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								{
									obj_t BgL_l1371z00_15226;
									obj_t BgL_tail1374z00_15227;

									BgL_l1371z00_15226 = BgL_l1371z00_15223;
									BgL_tail1374z00_15227 = BgL_head1373z00_15224;
								BgL_zc3z04anonymousza34057ze3z87_15225:
									if (NULLP(BgL_l1371z00_15226))
										{	/* Eval/evaluate_comp.scm 1168 */
											BgL_arg4055z00_15222 = CDR(BgL_head1373z00_15224);
										}
									else
										{	/* Eval/evaluate_comp.scm 1168 */
											obj_t BgL_newtail1375z00_15228;

											{	/* Eval/evaluate_comp.scm 1168 */
												obj_t BgL_arg4060z00_15229;

												{	/* Eval/evaluate_comp.scm 1168 */
													obj_t BgL_vz00_15230;

													BgL_vz00_15230 = CAR(((obj_t) BgL_l1371z00_15226));
													BgL_arg4060z00_15229 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_15230,
														(((BgL_ev_absz00_bglt) COBJECT(
																	((BgL_ev_absz00_bglt) BgL_ez00_12991)))->
															BgL_varsz00));
												}
												BgL_newtail1375z00_15228 =
													MAKE_YOUNG_PAIR(BgL_arg4060z00_15229, BNIL);
											}
											SET_CDR(BgL_tail1374z00_15227, BgL_newtail1375z00_15228);
											{	/* Eval/evaluate_comp.scm 1168 */
												obj_t BgL_arg4059z00_15231;

												BgL_arg4059z00_15231 =
													CDR(((obj_t) BgL_l1371z00_15226));
												{
													obj_t BgL_tail1374z00_24139;
													obj_t BgL_l1371z00_24138;

													BgL_l1371z00_24138 = BgL_arg4059z00_15231;
													BgL_tail1374z00_24139 = BgL_newtail1375z00_15228;
													BgL_tail1374z00_15227 = BgL_tail1374z00_24139;
													BgL_l1371z00_15226 = BgL_l1371z00_24138;
													goto BgL_zc3z04anonymousza34057ze3z87_15225;
												}
											}
										}
								}
							}
					}
					BgL_iboxesz00_15208 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4055z00_15222);
				}
				BgL_siza7eza7_15209 =
					bgl_list_length(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_varsz00));
				BgL_siza7ezd2framez75_15210 =
					(
					(long) (
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_siza7eza7)) +
					bgl_list_length(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_freez00)));
				BgL_nstkz00_15211 =
					BGl_appendzd221011zd2zz__evaluate_compz00(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_varsz00),
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_freez00));
				{	/* Eval/evaluate_comp.scm 1172 */
					obj_t BgL_bodyz00_15232;

					BgL_bodyz00_15232 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_bodyz00),
						BgL_nstkz00_15211);
					{

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_aux1249z00_15238;

							BgL_aux1249z00_15238 =
								(((BgL_ev_absz00_bglt) COBJECT(
										((BgL_ev_absz00_bglt) BgL_ez00_12991)))->BgL_arityz00);
							if (INTEGERP(BgL_aux1249z00_15238))
								{	/* Eval/evaluate_comp.scm 1174 */
									switch ((long) CINT(BgL_aux1249z00_15238))
										{
										case ((long) 0):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33490ze3z87_15239;

															BgL_zc3z04anonymousza33490ze3z87_15239 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33490ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33490ze3z87_15239,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33490ze3z87_15239,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33490ze3z87_15239,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33490ze3z87_15239;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33496ze3z87_15240;

															BgL_zc3z04anonymousza33496ze3z87_15240 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33496ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33496ze3z87_15240,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33496ze3z87_15240,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33496ze3z87_15240,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33496ze3z87_15240,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33496ze3z87_15240;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33506ze3z87_15241;

															BgL_zc3z04anonymousza33506ze3z87_15241 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33506ze3z87_15241,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33506ze3z87_15241,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33506ze3z87_15241,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33506ze3z87_15241,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33506ze3z87_15241,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33506ze3z87_15241;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33515ze3z87_15242;

															BgL_zc3z04anonymousza33515ze3z87_15242 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33515ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33515ze3z87_15242,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33515ze3z87_15242,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33515ze3z87_15242,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33515ze3z87_15242,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33515ze3z87_15242,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33515ze3z87_15242,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33515ze3z87_15242;
														}
												}
											break;
										case ((long) -1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33529ze3z87_15243;

															BgL_zc3z04anonymousza33529ze3z87_15243 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33529ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33529ze3z87_15243,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33529ze3z87_15243,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33529ze3z87_15243,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33529ze3z87_15243;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33537ze3z87_15244;

															BgL_zc3z04anonymousza33537ze3z87_15244 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33537ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33537ze3z87_15244,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33537ze3z87_15244,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33537ze3z87_15244,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33537ze3z87_15244,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33537ze3z87_15244;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33547ze3z87_15245;

															BgL_zc3z04anonymousza33547ze3z87_15245 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33547ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33547ze3z87_15245,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33547ze3z87_15245,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33547ze3z87_15245,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33547ze3z87_15245,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33547ze3z87_15245,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33547ze3z87_15245;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33557ze3z87_15246;

															BgL_zc3z04anonymousza33557ze3z87_15246 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_15246,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_15246,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_15246,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_15246,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_15246,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33557ze3z87_15246,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33557ze3z87_15246;
														}
												}
											break;
										case ((long) 1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33573ze3z87_15247;

															BgL_zc3z04anonymousza33573ze3z87_15247 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33573ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33573ze3z87_15247,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33573ze3z87_15247,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33573ze3z87_15247,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33573ze3z87_15247;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33580ze3z87_15248;

															BgL_zc3z04anonymousza33580ze3z87_15248 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33580ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33580ze3z87_15248,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33580ze3z87_15248,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33580ze3z87_15248,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33580ze3z87_15248,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33580ze3z87_15248;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33592ze3z87_15249;

															BgL_zc3z04anonymousza33592ze3z87_15249 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33592ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33592ze3z87_15249,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33592ze3z87_15249,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33592ze3z87_15249,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33592ze3z87_15249,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33592ze3z87_15249,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33592ze3z87_15249;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33600ze3z87_15250;

															BgL_zc3z04anonymousza33600ze3z87_15250 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33600ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_15250,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_15250,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_15250,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_15250,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_15250,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33600ze3z87_15250,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33600ze3z87_15250;
														}
												}
											break;
										case ((long) -2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33615ze3z87_15251;

															BgL_zc3z04anonymousza33615ze3z87_15251 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33615ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33615ze3z87_15251,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33615ze3z87_15251,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33615ze3z87_15251,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33615ze3z87_15251;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33624ze3z87_15252;

															BgL_zc3z04anonymousza33624ze3z87_15252 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33624ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33624ze3z87_15252,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33624ze3z87_15252,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33624ze3z87_15252,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33624ze3z87_15252,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33624ze3z87_15252;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33636ze3z87_15253;

															BgL_zc3z04anonymousza33636ze3z87_15253 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33636ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33636ze3z87_15253,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33636ze3z87_15253,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33636ze3z87_15253,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33636ze3z87_15253,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33636ze3z87_15253,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33636ze3z87_15253;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33646ze3z87_15254;

															BgL_zc3z04anonymousza33646ze3z87_15254 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33646ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33646ze3z87_15254,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33646ze3z87_15254,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33646ze3z87_15254,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33646ze3z87_15254,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33646ze3z87_15254,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33646ze3z87_15254,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33646ze3z87_15254;
														}
												}
											break;
										case ((long) 2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33663ze3z87_15255;

															BgL_zc3z04anonymousza33663ze3z87_15255 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33663ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33663ze3z87_15255,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33663ze3z87_15255,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33663ze3z87_15255,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33663ze3z87_15255;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33672ze3z87_15256;

															BgL_zc3z04anonymousza33672ze3z87_15256 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33672ze3z87_15256,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33672ze3z87_15256,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33672ze3z87_15256,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33672ze3z87_15256,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33672ze3z87_15256;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33683ze3z87_15257;

															BgL_zc3z04anonymousza33683ze3z87_15257 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33683ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33683ze3z87_15257,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33683ze3z87_15257,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33683ze3z87_15257,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33683ze3z87_15257,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33683ze3z87_15257,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33683ze3z87_15257;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33692ze3z87_15258;

															BgL_zc3z04anonymousza33692ze3z87_15258 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33692ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_15258,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_15258,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_15258,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_15258,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_15258,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33692ze3z87_15258,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33692ze3z87_15258;
														}
												}
											break;
										case ((long) -3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33709ze3z87_15259;

															BgL_zc3z04anonymousza33709ze3z87_15259 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33709ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33709ze3z87_15259,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33709ze3z87_15259,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33709ze3z87_15259,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33709ze3z87_15259;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33718ze3z87_15260;

															BgL_zc3z04anonymousza33718ze3z87_15260 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33718ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33718ze3z87_15260,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33718ze3z87_15260,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33718ze3z87_15260,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33718ze3z87_15260,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33718ze3z87_15260;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33730ze3z87_15261;

															BgL_zc3z04anonymousza33730ze3z87_15261 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33730ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33730ze3z87_15261,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33730ze3z87_15261,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33730ze3z87_15261,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33730ze3z87_15261,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33730ze3z87_15261,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33730ze3z87_15261;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33740ze3z87_15262;

															BgL_zc3z04anonymousza33740ze3z87_15262 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33740ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33740ze3z87_15262,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33740ze3z87_15262,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33740ze3z87_15262,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33740ze3z87_15262,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33740ze3z87_15262,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33740ze3z87_15262,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33740ze3z87_15262;
														}
												}
											break;
										case ((long) 3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33756ze3z87_15263;

															BgL_zc3z04anonymousza33756ze3z87_15263 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33756ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33756ze3z87_15263,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33756ze3z87_15263,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33756ze3z87_15263,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33756ze3z87_15263;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33765ze3z87_15264;

															BgL_zc3z04anonymousza33765ze3z87_15264 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33765ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33765ze3z87_15264,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33765ze3z87_15264,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33765ze3z87_15264,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33765ze3z87_15264,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33765ze3z87_15264;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33777ze3z87_15265;

															BgL_zc3z04anonymousza33777ze3z87_15265 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33777ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_15265,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_15265,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_15265,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_15265,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33777ze3z87_15265,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33777ze3z87_15265;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33787ze3z87_15266;

															BgL_zc3z04anonymousza33787ze3z87_15266 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33787ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33787ze3z87_15266,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33787ze3z87_15266,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33787ze3z87_15266,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33787ze3z87_15266,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33787ze3z87_15266,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33787ze3z87_15266,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33787ze3z87_15266;
														}
												}
											break;
										case ((long) -4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33803ze3z87_15267;

															BgL_zc3z04anonymousza33803ze3z87_15267 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33803ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33803ze3z87_15267,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33803ze3z87_15267,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33803ze3z87_15267,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33803ze3z87_15267;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33813ze3z87_15268;

															BgL_zc3z04anonymousza33813ze3z87_15268 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33813ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33813ze3z87_15268,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33813ze3z87_15268,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33813ze3z87_15268,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33813ze3z87_15268,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33813ze3z87_15268;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33826ze3z87_15269;

															BgL_zc3z04anonymousza33826ze3z87_15269 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33826ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33826ze3z87_15269,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33826ze3z87_15269,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33826ze3z87_15269,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33826ze3z87_15269,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33826ze3z87_15269,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33826ze3z87_15269;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33837ze3z87_15270;

															BgL_zc3z04anonymousza33837ze3z87_15270 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33837ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_15270,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_15270,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_15270,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_15270,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_15270,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33837ze3z87_15270,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33837ze3z87_15270;
														}
												}
											break;
										case ((long) 4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33854ze3z87_15271;

															BgL_zc3z04anonymousza33854ze3z87_15271 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33854ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33854ze3z87_15271,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33854ze3z87_15271,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33854ze3z87_15271,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33854ze3z87_15271;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33864ze3z87_15272;

															BgL_zc3z04anonymousza33864ze3z87_15272 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33864ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33864ze3z87_15272,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33864ze3z87_15272,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33864ze3z87_15272,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33864ze3z87_15272,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33864ze3z87_15272;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33877ze3z87_15273;

															BgL_zc3z04anonymousza33877ze3z87_15273 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33877ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33877ze3z87_15273,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33877ze3z87_15273,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33877ze3z87_15273,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33877ze3z87_15273,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33877ze3z87_15273,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33877ze3z87_15273;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33888ze3z87_15274;

															BgL_zc3z04anonymousza33888ze3z87_15274 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33888ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33888ze3z87_15274,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33888ze3z87_15274,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33888ze3z87_15274,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33888ze3z87_15274,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33888ze3z87_15274,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33888ze3z87_15274,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33888ze3z87_15274;
														}
												}
											break;
										case ((long) -5):

											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33905ze3z87_15275;

															BgL_zc3z04anonymousza33905ze3z87_15275 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33905ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33905ze3z87_15275,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33905ze3z87_15275,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33905ze3z87_15275,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33905ze3z87_15275;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33916ze3z87_15276;

															BgL_zc3z04anonymousza33916ze3z87_15276 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33916ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33916ze3z87_15276,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33916ze3z87_15276,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33916ze3z87_15276,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33916ze3z87_15276,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33916ze3z87_15276;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33930ze3z87_15277;

															BgL_zc3z04anonymousza33930ze3z87_15277 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33930ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33930ze3z87_15277,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33930ze3z87_15277,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33930ze3z87_15277,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33930ze3z87_15277,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33930ze3z87_15277,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33930ze3z87_15277;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33942ze3z87_15278;

															BgL_zc3z04anonymousza33942ze3z87_15278 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33942ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33942ze3z87_15278,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33942ze3z87_15278,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33942ze3z87_15278,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33942ze3z87_15278,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33942ze3z87_15278,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33942ze3z87_15278,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33942ze3z87_15278;
														}
												}
											break;
										default:
										BgL_case_else1248z00_15233:
											if ((VECTOR_LENGTH(BgL_ifreesz00_15207) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33960ze3z87_15234;

															BgL_zc3z04anonymousza33960ze3z87_15234 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33960ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33960ze3z87_15234,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33960ze3z87_15234,
																(int) (((long) 1)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33960ze3z87_15234,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33960ze3z87_15234;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33980ze3z87_15235;

															BgL_zc3z04anonymousza33980ze3z87_15235 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33980ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33980ze3z87_15235,
																(int) (((long) 0)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33980ze3z87_15235,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33980ze3z87_15235,
																(int) (((long) 2)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33980ze3z87_15235,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza33980ze3z87_15235;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_15208) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza34003ze3z87_15236;

															BgL_zc3z04anonymousza34003ze3z87_15236 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza34003ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34003ze3z87_15236,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34003ze3z87_15236,
																(int) (((long) 1)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34003ze3z87_15236,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34003ze3z87_15236,
																(int) (((long) 3)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34003ze3z87_15236,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza34003ze3z87_15236;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza34024ze3z87_15237;

															BgL_zc3z04anonymousza34024ze3z87_15237 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza34024ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34024ze3z87_15237,
																(int) (((long) 0)), BgL_ifreesz00_15207);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34024ze3z87_15237,
																(int) (((long) 1)), BgL_iboxesz00_15208);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34024ze3z87_15237,
																(int) (((long) 2)), BINT(BgL_siza7eza7_15209));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34024ze3z87_15237,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_12991)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34024ze3z87_15237,
																(int) (((long) 4)), BgL_bodyz00_15232);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34024ze3z87_15237,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_15210));
															return BgL_zc3z04anonymousza34024ze3z87_15237;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1174 */
									goto BgL_case_else1248z00_15233;
								}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3905> */
	obj_t BGl_z62zc3z04anonymousza33905ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_12993, obj_t BgL_sz00_12997)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_12994;
				obj_t BgL_bodyz00_12995;
				long BgL_siza7ezd2framez75_12996;

				BgL_i1247z00_12994 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_12993, (int) (((long) 0))));
				BgL_bodyz00_12995 = PROCEDURE_REF(BgL_envz00_12993, (int) (((long) 1)));
				BgL_siza7ezd2framez75_12996 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12993, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15279;

					BgL_bpz00_15279 = VECTOR_REF(((obj_t) BgL_sz00_12997), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15280;

							BgL_runz00_15280 =
								MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_15280,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_12994));
							PROCEDURE_SET(BgL_runz00_15280,
								(int) (((long) 1)), BgL_bodyz00_12995);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15281;

								BgL_mainz00_15281 =
									MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_15281,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_12994));
								PROCEDURE_SET(BgL_mainz00_15281,
									(int) (((long) 1)), BgL_bodyz00_12995);
								PROCEDURE_SET(BgL_mainz00_15281,
									(int) (((long) 2)), BgL_runz00_15280);
								PROCEDURE_SET(BgL_mainz00_15281,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_12996));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15282;

									BgL_objz00_15282 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15280, BgL_objz00_15282);
									BgL_objz00_15282;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3906z00_15283;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3907z00_15284;

										BgL_arg3907z00_15284 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_12994))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15285;

											BgL_newz00_15285 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_24981;

												BgL_tmpz00_24981 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15285, BgL_tmpz00_24981,
													BgL_arg3907z00_15284);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_24986;
												int BgL_tmpz00_24984;

												BgL_auxz00_24986 = BINT(BgL_siza7ezd2framez75_12996);
												BgL_tmpz00_24984 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15285, BgL_tmpz00_24984,
													BgL_auxz00_24986);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_24989;

												BgL_tmpz00_24989 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15285, BgL_tmpz00_24989,
													BgL_runz00_15280);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_24994;
												int BgL_tmpz00_24992;

												BgL_auxz00_24994 = BINT(((long) -5));
												BgL_tmpz00_24992 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15285, BgL_tmpz00_24992,
													BgL_auxz00_24994);
											}
											BgL_arg3906z00_15283 = BgL_newz00_15285;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15281, BgL_arg3906z00_15283);
									BgL_arg3906z00_15283;
								}
								return BgL_mainz00_15281;
							}
						}
					}
				}
			}
		}

	}



/* &main */
	obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_12998,
		obj_t BgL_az00_13003, obj_t BgL_bz00_13004, obj_t BgL_cz00_13005,
		obj_t BgL_dz00_13006, obj_t BgL_lastz00_13007)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13001;
				long BgL_siza7ezd2framez75_13002;

				BgL_runz00_13001 =
					((obj_t) PROCEDURE_REF(BgL_envz00_12998, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13002 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_12998, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15286;

					BgL_sz00_15286 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15287;

						BgL_bpz00_15287 = VECTOR_REF(((obj_t) BgL_sz00_15286), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15287) + BgL_siza7ezd2framez75_13002) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15286))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3910z00_15288;

									BgL_arg3910z00_15288 =
										((long) CINT(BgL_bpz00_15287) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15286), BgL_arg3910z00_15288,
										BgL_az00_13003);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3911z00_15289;

									BgL_arg3911z00_15289 =
										((long) CINT(BgL_bpz00_15287) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15286), BgL_arg3911z00_15289,
										BgL_bz00_13004);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3912z00_15290;

									BgL_arg3912z00_15290 =
										((long) CINT(BgL_bpz00_15287) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15286), BgL_arg3912z00_15290,
										BgL_cz00_13005);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3913z00_15291;

									BgL_arg3913z00_15291 =
										((long) CINT(BgL_bpz00_15287) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15286), BgL_arg3913z00_15291,
										BgL_dz00_13006);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3914z00_15292;

									BgL_arg3914z00_15292 =
										((long) CINT(BgL_bpz00_15287) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_15286), BgL_arg3914z00_15292,
										BgL_lastz00_13007);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15293;

									BgL_ez00_15293 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15293,
										BgL_bpz00_15287);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15294;

										BgL_accz00_15294 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13001, BgL_sz00_15286, BgL_bpz00_15287);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15293);
										VECTOR_SET(
											((obj_t) BgL_sz00_15286), ((long) 0), BgL_bpz00_15287);
										return BgL_accz00_15294;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15295;

								BgL_nsz00_15295 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15295, ((long) 1), BgL_sz00_15286);
								VECTOR_SET(BgL_nsz00_15295, ((long) 2), BgL_az00_13003);
								VECTOR_SET(BgL_nsz00_15295, ((long) 3), BgL_bz00_13004);
								VECTOR_SET(BgL_nsz00_15295, ((long) 4), BgL_cz00_13005);
								VECTOR_SET(BgL_nsz00_15295, ((long) 5), BgL_dz00_13006);
								VECTOR_SET(BgL_nsz00_15295, ((long) 6), BgL_lastz00_13007);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15296;

									BgL_z12denvz12_15296 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15296, BgL_nsz00_15295);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15297;

										BgL_ez00_15297 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15297,
											BgL_sz00_15286);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15298;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15299;

												BgL_savedzd2bpzd2_15299 =
													VECTOR_REF(BgL_nsz00_15295, ((long) 0));
												VECTOR_SET(BgL_nsz00_15295, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15301;

													BgL_fz00_15301 = BgL_runz00_13001;
												BgL_recz00_15300:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15302;

														BgL_rz00_15302 =
															PROCEDURE_ENTRY(BgL_fz00_15301) (BgL_fz00_15301,
															BgL_nsz00_15295, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5368z00_25057;

															if (PROCEDUREP(BgL_rz00_15302))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15303;

																	BgL_arg1729z00_15303 =
																		PROCEDURE_ATTR(BgL_rz00_15302);
																	if (STRUCTP(BgL_arg1729z00_15303))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5368z00_25057 =
																				(STRUCT_KEY(BgL_arg1729z00_15303) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5368z00_25057 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5368z00_25057 = ((bool_t) 0);
																}
															if (BgL_test5368z00_25057)
																{
																	obj_t BgL_fz00_25065;

																	BgL_fz00_25065 = BgL_rz00_15302;
																	BgL_fz00_15301 = BgL_fz00_25065;
																	goto BgL_recz00_15300;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15295, ((long) 0),
																		BgL_savedzd2bpzd2_15299);
																	BgL_____rz00_15298 = BgL_rz00_15302;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15297);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15296, BgL_sz00_15286);
											return BgL_____rz00_15298;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run */
	obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_13008,
		obj_t BgL_sz00_13011)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13009;
				obj_t BgL_bodyz00_13010;

				BgL_i1247z00_13009 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13008, (int) (((long) 0))));
				BgL_bodyz00_13010 = PROCEDURE_REF(BgL_envz00_13008, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15304;

					BgL_bpz00_15304 = VECTOR_REF(((obj_t) BgL_sz00_13011), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15305;
						obj_t BgL_wherez00_15306;
						obj_t BgL_locz00_15307;

						BgL_z12denvz12_15305 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15306 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13009))->
							BgL_wherez00);
						BgL_locz00_15307 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13009))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15305, BgL_wherez00_15306,
								BgL_locz00_15307);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15308;

								BgL_za2za2resza2za2z00_15308 =
									PROCEDURE_ENTRY(BgL_bodyz00_13010) (BgL_bodyz00_13010,
									BgL_sz00_13011, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15305);
								return BgL_za2za2resza2za2z00_15308;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3916> */
	obj_t BGl_z62zc3z04anonymousza33916ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13012, obj_t BgL_sz00_13017)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13013;
				BgL_ev_absz00_bglt BgL_i1247z00_13014;
				obj_t BgL_bodyz00_13015;
				long BgL_siza7ezd2framez75_13016;

				BgL_iboxesz00_13013 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13012, (int) (((long) 0))));
				BgL_i1247z00_13014 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13012, (int) (((long) 1))));
				BgL_bodyz00_13015 = PROCEDURE_REF(BgL_envz00_13012, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13016 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13012, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15309;

					BgL_bpz00_15309 = VECTOR_REF(((obj_t) BgL_sz00_13017), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15310;

							BgL_runz00_15310 =
								MAKE_FX_PROCEDURE(BGl_z62run4496z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_15310,
								(int) (((long) 0)), BgL_iboxesz00_13013);
							PROCEDURE_SET(BgL_runz00_15310,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13014));
							PROCEDURE_SET(BgL_runz00_15310,
								(int) (((long) 2)), BgL_bodyz00_13015);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15311;

								BgL_mainz00_15311 =
									MAKE_VA_PROCEDURE(BGl_z62main4495z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_15311,
									(int) (((long) 0)), BgL_iboxesz00_13013);
								PROCEDURE_SET(BgL_mainz00_15311,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13014));
								PROCEDURE_SET(BgL_mainz00_15311,
									(int) (((long) 2)), BgL_bodyz00_13015);
								PROCEDURE_SET(BgL_mainz00_15311,
									(int) (((long) 3)), BgL_runz00_15310);
								PROCEDURE_SET(BgL_mainz00_15311,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13016));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15312;

									BgL_objz00_15312 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15310, BgL_objz00_15312);
									BgL_objz00_15312;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3917z00_15313;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3918z00_15314;

										BgL_arg3918z00_15314 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13014))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15315;

											BgL_newz00_15315 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25127;

												BgL_tmpz00_25127 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15315, BgL_tmpz00_25127,
													BgL_arg3918z00_15314);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25132;
												int BgL_tmpz00_25130;

												BgL_auxz00_25132 = BINT(BgL_siza7ezd2framez75_13016);
												BgL_tmpz00_25130 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15315, BgL_tmpz00_25130,
													BgL_auxz00_25132);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25135;

												BgL_tmpz00_25135 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15315, BgL_tmpz00_25135,
													BgL_runz00_15310);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25140;
												int BgL_tmpz00_25138;

												BgL_auxz00_25140 = BINT(((long) -5));
												BgL_tmpz00_25138 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15315, BgL_tmpz00_25138,
													BgL_auxz00_25140);
											}
											BgL_arg3917z00_15313 = BgL_newz00_15315;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15311, BgL_arg3917z00_15313);
									BgL_arg3917z00_15313;
								}
								return BgL_mainz00_15311;
							}
						}
					}
				}
			}
		}

	}



/* &main4495 */
	obj_t BGl_z62main4495z62zz__evaluate_compz00(obj_t BgL_envz00_13018,
		obj_t BgL_az00_13024, obj_t BgL_bz00_13025, obj_t BgL_cz00_13026,
		obj_t BgL_dz00_13027, obj_t BgL_lastz00_13028)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13022;
				long BgL_siza7ezd2framez75_13023;

				BgL_runz00_13022 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13018, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13023 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13018, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15316;

					BgL_sz00_15316 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15317;

						BgL_bpz00_15317 = VECTOR_REF(((obj_t) BgL_sz00_15316), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15317) + BgL_siza7ezd2framez75_13023) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15316))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3921z00_15318;

									BgL_arg3921z00_15318 =
										((long) CINT(BgL_bpz00_15317) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15316), BgL_arg3921z00_15318,
										BgL_az00_13024);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3922z00_15319;

									BgL_arg3922z00_15319 =
										((long) CINT(BgL_bpz00_15317) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15316), BgL_arg3922z00_15319,
										BgL_bz00_13025);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3923z00_15320;

									BgL_arg3923z00_15320 =
										((long) CINT(BgL_bpz00_15317) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15316), BgL_arg3923z00_15320,
										BgL_cz00_13026);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3924z00_15321;

									BgL_arg3924z00_15321 =
										((long) CINT(BgL_bpz00_15317) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15316), BgL_arg3924z00_15321,
										BgL_dz00_13027);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3925z00_15322;

									BgL_arg3925z00_15322 =
										((long) CINT(BgL_bpz00_15317) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_15316), BgL_arg3925z00_15322,
										BgL_lastz00_13028);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15323;

									BgL_ez00_15323 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15323,
										BgL_bpz00_15317);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15324;

										BgL_accz00_15324 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13022, BgL_sz00_15316, BgL_bpz00_15317);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15323);
										VECTOR_SET(
											((obj_t) BgL_sz00_15316), ((long) 0), BgL_bpz00_15317);
										return BgL_accz00_15324;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15325;

								BgL_nsz00_15325 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15325, ((long) 1), BgL_sz00_15316);
								VECTOR_SET(BgL_nsz00_15325, ((long) 2), BgL_az00_13024);
								VECTOR_SET(BgL_nsz00_15325, ((long) 3), BgL_bz00_13025);
								VECTOR_SET(BgL_nsz00_15325, ((long) 4), BgL_cz00_13026);
								VECTOR_SET(BgL_nsz00_15325, ((long) 5), BgL_dz00_13027);
								VECTOR_SET(BgL_nsz00_15325, ((long) 6), BgL_lastz00_13028);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15326;

									BgL_z12denvz12_15326 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15326, BgL_nsz00_15325);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15327;

										BgL_ez00_15327 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15327,
											BgL_sz00_15316);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15328;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15329;

												BgL_savedzd2bpzd2_15329 =
													VECTOR_REF(BgL_nsz00_15325, ((long) 0));
												VECTOR_SET(BgL_nsz00_15325, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15331;

													BgL_fz00_15331 = BgL_runz00_13022;
												BgL_recz00_15330:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15332;

														BgL_rz00_15332 =
															PROCEDURE_ENTRY(BgL_fz00_15331) (BgL_fz00_15331,
															BgL_nsz00_15325, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5372z00_25203;

															if (PROCEDUREP(BgL_rz00_15332))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15333;

																	BgL_arg1729z00_15333 =
																		PROCEDURE_ATTR(BgL_rz00_15332);
																	if (STRUCTP(BgL_arg1729z00_15333))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5372z00_25203 =
																				(STRUCT_KEY(BgL_arg1729z00_15333) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5372z00_25203 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5372z00_25203 = ((bool_t) 0);
																}
															if (BgL_test5372z00_25203)
																{
																	obj_t BgL_fz00_25211;

																	BgL_fz00_25211 = BgL_rz00_15332;
																	BgL_fz00_15331 = BgL_fz00_25211;
																	goto BgL_recz00_15330;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15325, ((long) 0),
																		BgL_savedzd2bpzd2_15329);
																	BgL_____rz00_15328 = BgL_rz00_15332;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15327);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15326, BgL_sz00_15316);
											return BgL_____rz00_15328;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4496 */
	obj_t BGl_z62run4496z62zz__evaluate_compz00(obj_t BgL_envz00_13029,
		obj_t BgL_sz00_13033)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13030;
				BgL_ev_absz00_bglt BgL_i1247z00_13031;
				obj_t BgL_bodyz00_13032;

				BgL_iboxesz00_13030 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13029, (int) (((long) 0))));
				BgL_i1247z00_13031 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13029, (int) (((long) 1))));
				BgL_bodyz00_13032 = PROCEDURE_REF(BgL_envz00_13029, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15334;

					BgL_bpz00_15334 = VECTOR_REF(((obj_t) BgL_sz00_13033), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13033,
						BgL_iboxesz00_13030, BgL_bpz00_15334);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15335;
						obj_t BgL_wherez00_15336;
						obj_t BgL_locz00_15337;

						BgL_z12denvz12_15335 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15336 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13031))->
							BgL_wherez00);
						BgL_locz00_15337 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13031))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15335, BgL_wherez00_15336,
								BgL_locz00_15337);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15338;

								BgL_za2za2resza2za2z00_15338 =
									PROCEDURE_ENTRY(BgL_bodyz00_13032) (BgL_bodyz00_13032,
									BgL_sz00_13033, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15335);
								return BgL_za2za2resza2za2z00_15338;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3930> */
	obj_t BGl_z62zc3z04anonymousza33930ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13034, obj_t BgL_sz00_13040)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13035;
				long BgL_siza7eza7_13036;
				BgL_ev_absz00_bglt BgL_i1247z00_13037;
				obj_t BgL_bodyz00_13038;
				long BgL_siza7ezd2framez75_13039;

				BgL_ifreesz00_13035 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13034, (int) (((long) 0))));
				BgL_siza7eza7_13036 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13034, (int) (((long) 1))));
				BgL_i1247z00_13037 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13034, (int) (((long) 2))));
				BgL_bodyz00_13038 = PROCEDURE_REF(BgL_envz00_13034, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13039 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13034, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15339;

					BgL_bpz00_15339 = VECTOR_REF(((obj_t) BgL_sz00_13040), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15340;

						BgL_valza2za2_15340 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13040,
							BgL_bpz00_15339, BgL_ifreesz00_13035);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15341;

							BgL_runz00_15341 =
								MAKE_FX_PROCEDURE(BGl_z62run4498z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_15341,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13036));
							PROCEDURE_SET(BgL_runz00_15341,
								(int) (((long) 1)), BgL_valza2za2_15340);
							PROCEDURE_SET(BgL_runz00_15341,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13037));
							PROCEDURE_SET(BgL_runz00_15341,
								(int) (((long) 3)), BgL_bodyz00_13038);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15342;

								BgL_mainz00_15342 =
									MAKE_VA_PROCEDURE(BGl_z62main4497z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_15342,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13036));
								PROCEDURE_SET(BgL_mainz00_15342,
									(int) (((long) 1)), BgL_valza2za2_15340);
								PROCEDURE_SET(BgL_mainz00_15342,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13037));
								PROCEDURE_SET(BgL_mainz00_15342,
									(int) (((long) 3)), BgL_bodyz00_13038);
								PROCEDURE_SET(BgL_mainz00_15342,
									(int) (((long) 4)), BgL_runz00_15341);
								PROCEDURE_SET(BgL_mainz00_15342,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13039));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15343;

									BgL_objz00_15343 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15341, BgL_objz00_15343);
									BgL_objz00_15343;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3931z00_15344;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3932z00_15345;

										BgL_arg3932z00_15345 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13037))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15346;

											BgL_newz00_15346 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25287;

												BgL_tmpz00_25287 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15346, BgL_tmpz00_25287,
													BgL_arg3932z00_15345);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25292;
												int BgL_tmpz00_25290;

												BgL_auxz00_25292 = BINT(BgL_siza7ezd2framez75_13039);
												BgL_tmpz00_25290 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15346, BgL_tmpz00_25290,
													BgL_auxz00_25292);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25295;

												BgL_tmpz00_25295 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15346, BgL_tmpz00_25295,
													BgL_runz00_15341);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25300;
												int BgL_tmpz00_25298;

												BgL_auxz00_25300 = BINT(((long) -5));
												BgL_tmpz00_25298 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15346, BgL_tmpz00_25298,
													BgL_auxz00_25300);
											}
											BgL_arg3931z00_15344 = BgL_newz00_15346;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15342, BgL_arg3931z00_15344);
									BgL_arg3931z00_15344;
								}
								return BgL_mainz00_15342;
							}
						}
					}
				}
			}
		}

	}



/* &main4497 */
	obj_t BGl_z62main4497z62zz__evaluate_compz00(obj_t BgL_envz00_13041,
		obj_t BgL_az00_13048, obj_t BgL_bz00_13049, obj_t BgL_cz00_13050,
		obj_t BgL_dz00_13051, obj_t BgL_lastz00_13052)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13046;
				long BgL_siza7ezd2framez75_13047;

				BgL_runz00_13046 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13041, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13047 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13041, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15347;

					BgL_sz00_15347 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15348;

						BgL_bpz00_15348 = VECTOR_REF(((obj_t) BgL_sz00_15347), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15348) + BgL_siza7ezd2framez75_13047) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15347))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3935z00_15349;

									BgL_arg3935z00_15349 =
										((long) CINT(BgL_bpz00_15348) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15347), BgL_arg3935z00_15349,
										BgL_az00_13048);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3936z00_15350;

									BgL_arg3936z00_15350 =
										((long) CINT(BgL_bpz00_15348) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15347), BgL_arg3936z00_15350,
										BgL_bz00_13049);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3937z00_15351;

									BgL_arg3937z00_15351 =
										((long) CINT(BgL_bpz00_15348) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15347), BgL_arg3937z00_15351,
										BgL_cz00_13050);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3938z00_15352;

									BgL_arg3938z00_15352 =
										((long) CINT(BgL_bpz00_15348) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15347), BgL_arg3938z00_15352,
										BgL_dz00_13051);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3939z00_15353;

									BgL_arg3939z00_15353 =
										((long) CINT(BgL_bpz00_15348) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_15347), BgL_arg3939z00_15353,
										BgL_lastz00_13052);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15354;

									BgL_ez00_15354 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15354,
										BgL_bpz00_15348);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15355;

										BgL_accz00_15355 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13046, BgL_sz00_15347, BgL_bpz00_15348);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15354);
										VECTOR_SET(
											((obj_t) BgL_sz00_15347), ((long) 0), BgL_bpz00_15348);
										return BgL_accz00_15355;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15356;

								BgL_nsz00_15356 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15356, ((long) 1), BgL_sz00_15347);
								VECTOR_SET(BgL_nsz00_15356, ((long) 2), BgL_az00_13048);
								VECTOR_SET(BgL_nsz00_15356, ((long) 3), BgL_bz00_13049);
								VECTOR_SET(BgL_nsz00_15356, ((long) 4), BgL_cz00_13050);
								VECTOR_SET(BgL_nsz00_15356, ((long) 5), BgL_dz00_13051);
								VECTOR_SET(BgL_nsz00_15356, ((long) 6), BgL_lastz00_13052);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15357;

									BgL_z12denvz12_15357 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15357, BgL_nsz00_15356);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15358;

										BgL_ez00_15358 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15358,
											BgL_sz00_15347);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15359;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15360;

												BgL_savedzd2bpzd2_15360 =
													VECTOR_REF(BgL_nsz00_15356, ((long) 0));
												VECTOR_SET(BgL_nsz00_15356, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15362;

													BgL_fz00_15362 = BgL_runz00_13046;
												BgL_recz00_15361:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15363;

														BgL_rz00_15363 =
															PROCEDURE_ENTRY(BgL_fz00_15362) (BgL_fz00_15362,
															BgL_nsz00_15356, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5376z00_25363;

															if (PROCEDUREP(BgL_rz00_15363))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15364;

																	BgL_arg1729z00_15364 =
																		PROCEDURE_ATTR(BgL_rz00_15363);
																	if (STRUCTP(BgL_arg1729z00_15364))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5376z00_25363 =
																				(STRUCT_KEY(BgL_arg1729z00_15364) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5376z00_25363 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5376z00_25363 = ((bool_t) 0);
																}
															if (BgL_test5376z00_25363)
																{
																	obj_t BgL_fz00_25371;

																	BgL_fz00_25371 = BgL_rz00_15363;
																	BgL_fz00_15362 = BgL_fz00_25371;
																	goto BgL_recz00_15361;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15356, ((long) 0),
																		BgL_savedzd2bpzd2_15360);
																	BgL_____rz00_15359 = BgL_rz00_15363;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15358);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15357, BgL_sz00_15347);
											return BgL_____rz00_15359;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4498 */
	obj_t BGl_z62run4498z62zz__evaluate_compz00(obj_t BgL_envz00_13053,
		obj_t BgL_sz00_13058)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13054;
				obj_t BgL_valza2za2_13055;
				BgL_ev_absz00_bglt BgL_i1247z00_13056;
				obj_t BgL_bodyz00_13057;

				BgL_siza7eza7_13054 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13053, (int) (((long) 0))));
				BgL_valza2za2_13055 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13053, (int) (((long) 1))));
				BgL_i1247z00_13056 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13053, (int) (((long) 2))));
				BgL_bodyz00_13057 = PROCEDURE_REF(BgL_envz00_13053, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15365;

					BgL_bpz00_15365 = VECTOR_REF(((obj_t) BgL_sz00_13058), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13058,
						BgL_valza2za2_13055,
						((long) CINT(BgL_bpz00_15365) + BgL_siza7eza7_13054));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15366;
						obj_t BgL_wherez00_15367;
						obj_t BgL_locz00_15368;

						BgL_z12denvz12_15366 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15367 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13056))->
							BgL_wherez00);
						BgL_locz00_15368 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13056))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15366, BgL_wherez00_15367,
								BgL_locz00_15368);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15369;

								BgL_za2za2resza2za2z00_15369 =
									PROCEDURE_ENTRY(BgL_bodyz00_13057) (BgL_bodyz00_13057,
									BgL_sz00_13058, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15366);
								return BgL_za2za2resza2za2z00_15369;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3942> */
	obj_t BGl_z62zc3z04anonymousza33942ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13059, obj_t BgL_sz00_13066)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13060;
				obj_t BgL_iboxesz00_13061;
				long BgL_siza7eza7_13062;
				BgL_ev_absz00_bglt BgL_i1247z00_13063;
				obj_t BgL_bodyz00_13064;
				long BgL_siza7ezd2framez75_13065;

				BgL_ifreesz00_13060 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13059, (int) (((long) 0))));
				BgL_iboxesz00_13061 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13059, (int) (((long) 1))));
				BgL_siza7eza7_13062 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13059, (int) (((long) 2))));
				BgL_i1247z00_13063 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13059, (int) (((long) 3))));
				BgL_bodyz00_13064 = PROCEDURE_REF(BgL_envz00_13059, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13065 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13059, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15370;

					BgL_bpz00_15370 = VECTOR_REF(((obj_t) BgL_sz00_13066), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15371;

						BgL_valza2za2_15371 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13066,
							BgL_bpz00_15370, BgL_ifreesz00_13060);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15372;

							BgL_runz00_15372 =
								MAKE_FX_PROCEDURE(BGl_z62run4500z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_15372,
								(int) (((long) 0)), BgL_iboxesz00_13061);
							PROCEDURE_SET(BgL_runz00_15372,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13062));
							PROCEDURE_SET(BgL_runz00_15372,
								(int) (((long) 2)), BgL_valza2za2_15371);
							PROCEDURE_SET(BgL_runz00_15372,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13063));
							PROCEDURE_SET(BgL_runz00_15372,
								(int) (((long) 4)), BgL_bodyz00_13064);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15373;

								BgL_mainz00_15373 =
									MAKE_VA_PROCEDURE(BGl_z62main4499z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_15373,
									(int) (((long) 0)), BgL_iboxesz00_13061);
								PROCEDURE_SET(BgL_mainz00_15373,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13062));
								PROCEDURE_SET(BgL_mainz00_15373,
									(int) (((long) 2)), BgL_valza2za2_15371);
								PROCEDURE_SET(BgL_mainz00_15373,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13063));
								PROCEDURE_SET(BgL_mainz00_15373,
									(int) (((long) 4)), BgL_bodyz00_13064);
								PROCEDURE_SET(BgL_mainz00_15373,
									(int) (((long) 5)), BgL_runz00_15372);
								PROCEDURE_SET(BgL_mainz00_15373,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13065));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15374;

									BgL_objz00_15374 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15372, BgL_objz00_15374);
									BgL_objz00_15374;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3943z00_15375;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3944z00_15376;

										BgL_arg3944z00_15376 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13063))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15377;

											BgL_newz00_15377 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25459;

												BgL_tmpz00_25459 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15377, BgL_tmpz00_25459,
													BgL_arg3944z00_15376);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25464;
												int BgL_tmpz00_25462;

												BgL_auxz00_25464 = BINT(BgL_siza7ezd2framez75_13065);
												BgL_tmpz00_25462 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15377, BgL_tmpz00_25462,
													BgL_auxz00_25464);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25467;

												BgL_tmpz00_25467 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15377, BgL_tmpz00_25467,
													BgL_runz00_15372);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25472;
												int BgL_tmpz00_25470;

												BgL_auxz00_25472 = BINT(((long) -5));
												BgL_tmpz00_25470 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15377, BgL_tmpz00_25470,
													BgL_auxz00_25472);
											}
											BgL_arg3943z00_15375 = BgL_newz00_15377;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15373, BgL_arg3943z00_15375);
									BgL_arg3943z00_15375;
								}
								return BgL_mainz00_15373;
							}
						}
					}
				}
			}
		}

	}



/* &main4499 */
	obj_t BGl_z62main4499z62zz__evaluate_compz00(obj_t BgL_envz00_13067,
		obj_t BgL_az00_13075, obj_t BgL_bz00_13076, obj_t BgL_cz00_13077,
		obj_t BgL_dz00_13078, obj_t BgL_lastz00_13079)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13073;
				long BgL_siza7ezd2framez75_13074;

				BgL_runz00_13073 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13067, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13074 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13067, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15378;

					BgL_sz00_15378 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15379;

						BgL_bpz00_15379 = VECTOR_REF(((obj_t) BgL_sz00_15378), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15379) + BgL_siza7ezd2framez75_13074) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15378))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3947z00_15380;

									BgL_arg3947z00_15380 =
										((long) CINT(BgL_bpz00_15379) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15378), BgL_arg3947z00_15380,
										BgL_az00_13075);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3948z00_15381;

									BgL_arg3948z00_15381 =
										((long) CINT(BgL_bpz00_15379) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15378), BgL_arg3948z00_15381,
										BgL_bz00_13076);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3949z00_15382;

									BgL_arg3949z00_15382 =
										((long) CINT(BgL_bpz00_15379) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15378), BgL_arg3949z00_15382,
										BgL_cz00_13077);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3950z00_15383;

									BgL_arg3950z00_15383 =
										((long) CINT(BgL_bpz00_15379) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15378), BgL_arg3950z00_15383,
										BgL_dz00_13078);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3951z00_15384;

									BgL_arg3951z00_15384 =
										((long) CINT(BgL_bpz00_15379) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_15378), BgL_arg3951z00_15384,
										BgL_lastz00_13079);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15385;

									BgL_ez00_15385 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15385,
										BgL_bpz00_15379);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15386;

										BgL_accz00_15386 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13073, BgL_sz00_15378, BgL_bpz00_15379);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15385);
										VECTOR_SET(
											((obj_t) BgL_sz00_15378), ((long) 0), BgL_bpz00_15379);
										return BgL_accz00_15386;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15387;

								BgL_nsz00_15387 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15387, ((long) 1), BgL_sz00_15378);
								VECTOR_SET(BgL_nsz00_15387, ((long) 2), BgL_az00_13075);
								VECTOR_SET(BgL_nsz00_15387, ((long) 3), BgL_bz00_13076);
								VECTOR_SET(BgL_nsz00_15387, ((long) 4), BgL_cz00_13077);
								VECTOR_SET(BgL_nsz00_15387, ((long) 5), BgL_dz00_13078);
								VECTOR_SET(BgL_nsz00_15387, ((long) 6), BgL_lastz00_13079);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15388;

									BgL_z12denvz12_15388 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15388, BgL_nsz00_15387);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15389;

										BgL_ez00_15389 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15389,
											BgL_sz00_15378);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15390;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15391;

												BgL_savedzd2bpzd2_15391 =
													VECTOR_REF(BgL_nsz00_15387, ((long) 0));
												VECTOR_SET(BgL_nsz00_15387, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15393;

													BgL_fz00_15393 = BgL_runz00_13073;
												BgL_recz00_15392:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15394;

														BgL_rz00_15394 =
															PROCEDURE_ENTRY(BgL_fz00_15393) (BgL_fz00_15393,
															BgL_nsz00_15387, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5380z00_25535;

															if (PROCEDUREP(BgL_rz00_15394))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15395;

																	BgL_arg1729z00_15395 =
																		PROCEDURE_ATTR(BgL_rz00_15394);
																	if (STRUCTP(BgL_arg1729z00_15395))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5380z00_25535 =
																				(STRUCT_KEY(BgL_arg1729z00_15395) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5380z00_25535 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5380z00_25535 = ((bool_t) 0);
																}
															if (BgL_test5380z00_25535)
																{
																	obj_t BgL_fz00_25543;

																	BgL_fz00_25543 = BgL_rz00_15394;
																	BgL_fz00_15393 = BgL_fz00_25543;
																	goto BgL_recz00_15392;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15387, ((long) 0),
																		BgL_savedzd2bpzd2_15391);
																	BgL_____rz00_15390 = BgL_rz00_15394;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15389);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15388, BgL_sz00_15378);
											return BgL_____rz00_15390;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4500 */
	obj_t BGl_z62run4500z62zz__evaluate_compz00(obj_t BgL_envz00_13080,
		obj_t BgL_sz00_13086)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13081;
				long BgL_siza7eza7_13082;
				obj_t BgL_valza2za2_13083;
				BgL_ev_absz00_bglt BgL_i1247z00_13084;
				obj_t BgL_bodyz00_13085;

				BgL_iboxesz00_13081 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13080, (int) (((long) 0))));
				BgL_siza7eza7_13082 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13080, (int) (((long) 1))));
				BgL_valza2za2_13083 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13080, (int) (((long) 2))));
				BgL_i1247z00_13084 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13080, (int) (((long) 3))));
				BgL_bodyz00_13085 = PROCEDURE_REF(BgL_envz00_13080, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15396;

					BgL_bpz00_15396 = VECTOR_REF(((obj_t) BgL_sz00_13086), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13086,
						BgL_iboxesz00_13081, BgL_bpz00_15396);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13086,
						BgL_valza2za2_13083,
						((long) CINT(BgL_bpz00_15396) + BgL_siza7eza7_13082));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15397;
						obj_t BgL_wherez00_15398;
						obj_t BgL_locz00_15399;

						BgL_z12denvz12_15397 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15398 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13084))->
							BgL_wherez00);
						BgL_locz00_15399 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13084))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15397, BgL_wherez00_15398,
								BgL_locz00_15399);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15400;

								BgL_za2za2resza2za2z00_15400 =
									PROCEDURE_ENTRY(BgL_bodyz00_13085) (BgL_bodyz00_13085,
									BgL_sz00_13086, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15397);
								return BgL_za2za2resza2za2z00_15400;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3854> */
	obj_t BGl_z62zc3z04anonymousza33854ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13087, obj_t BgL_sz00_13091)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13088;
				obj_t BgL_bodyz00_13089;
				long BgL_siza7ezd2framez75_13090;

				BgL_i1247z00_13088 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13087, (int) (((long) 0))));
				BgL_bodyz00_13089 = PROCEDURE_REF(BgL_envz00_13087, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13090 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13087, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15401;

					BgL_bpz00_15401 = VECTOR_REF(((obj_t) BgL_sz00_13091), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15402;

							BgL_runz00_15402 =
								MAKE_FX_PROCEDURE(BGl_z62run4502z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_15402,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13088));
							PROCEDURE_SET(BgL_runz00_15402,
								(int) (((long) 1)), BgL_bodyz00_13089);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15403;

								BgL_mainz00_15403 =
									MAKE_FX_PROCEDURE(BGl_z62main4501z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_15403,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13088));
								PROCEDURE_SET(BgL_mainz00_15403,
									(int) (((long) 1)), BgL_bodyz00_13089);
								PROCEDURE_SET(BgL_mainz00_15403,
									(int) (((long) 2)), BgL_runz00_15402);
								PROCEDURE_SET(BgL_mainz00_15403,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13090));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15404;

									BgL_objz00_15404 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15402, BgL_objz00_15404);
									BgL_objz00_15404;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3855z00_15405;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3856z00_15406;

										BgL_arg3856z00_15406 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13088))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15407;

											BgL_newz00_15407 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25611;

												BgL_tmpz00_25611 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15407, BgL_tmpz00_25611,
													BgL_arg3856z00_15406);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25616;
												int BgL_tmpz00_25614;

												BgL_auxz00_25616 = BINT(BgL_siza7ezd2framez75_13090);
												BgL_tmpz00_25614 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15407, BgL_tmpz00_25614,
													BgL_auxz00_25616);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25619;

												BgL_tmpz00_25619 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15407, BgL_tmpz00_25619,
													BgL_runz00_15402);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25624;
												int BgL_tmpz00_25622;

												BgL_auxz00_25624 = BINT(((long) 4));
												BgL_tmpz00_25622 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15407, BgL_tmpz00_25622,
													BgL_auxz00_25624);
											}
											BgL_arg3855z00_15405 = BgL_newz00_15407;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15403, BgL_arg3855z00_15405);
									BgL_arg3855z00_15405;
								}
								return BgL_mainz00_15403;
							}
						}
					}
				}
			}
		}

	}



/* &main4501 */
	obj_t BGl_z62main4501z62zz__evaluate_compz00(obj_t BgL_envz00_13092,
		obj_t BgL_az00_13097, obj_t BgL_bz00_13098, obj_t BgL_cz00_13099,
		obj_t BgL_dz00_13100)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13095;
				long BgL_siza7ezd2framez75_13096;

				BgL_runz00_13095 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13092, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13096 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13092, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15408;

					BgL_sz00_15408 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15409;

						BgL_bpz00_15409 = VECTOR_REF(((obj_t) BgL_sz00_15408), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15409) + BgL_siza7ezd2framez75_13096) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15408))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3859z00_15410;

									BgL_arg3859z00_15410 =
										((long) CINT(BgL_bpz00_15409) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15408), BgL_arg3859z00_15410,
										BgL_az00_13097);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3860z00_15411;

									BgL_arg3860z00_15411 =
										((long) CINT(BgL_bpz00_15409) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15408), BgL_arg3860z00_15411,
										BgL_bz00_13098);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3861z00_15412;

									BgL_arg3861z00_15412 =
										((long) CINT(BgL_bpz00_15409) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15408), BgL_arg3861z00_15412,
										BgL_cz00_13099);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3862z00_15413;

									BgL_arg3862z00_15413 =
										((long) CINT(BgL_bpz00_15409) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15408), BgL_arg3862z00_15413,
										BgL_dz00_13100);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15414;

									BgL_ez00_15414 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15414,
										BgL_bpz00_15409);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15415;

										BgL_accz00_15415 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13095, BgL_sz00_15408, BgL_bpz00_15409);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15414);
										VECTOR_SET(
											((obj_t) BgL_sz00_15408), ((long) 0), BgL_bpz00_15409);
										return BgL_accz00_15415;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15416;

								BgL_nsz00_15416 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15416, ((long) 1), BgL_sz00_15408);
								VECTOR_SET(BgL_nsz00_15416, ((long) 2), BgL_az00_13097);
								VECTOR_SET(BgL_nsz00_15416, ((long) 3), BgL_bz00_13098);
								VECTOR_SET(BgL_nsz00_15416, ((long) 4), BgL_cz00_13099);
								VECTOR_SET(BgL_nsz00_15416, ((long) 5), BgL_dz00_13100);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15417;

									BgL_z12denvz12_15417 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15417, BgL_nsz00_15416);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15418;

										BgL_ez00_15418 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15418,
											BgL_sz00_15408);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15419;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15420;

												BgL_savedzd2bpzd2_15420 =
													VECTOR_REF(BgL_nsz00_15416, ((long) 0));
												VECTOR_SET(BgL_nsz00_15416, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15422;

													BgL_fz00_15422 = BgL_runz00_13095;
												BgL_recz00_15421:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15423;

														BgL_rz00_15423 =
															PROCEDURE_ENTRY(BgL_fz00_15422) (BgL_fz00_15422,
															BgL_nsz00_15416, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5384z00_25682;

															if (PROCEDUREP(BgL_rz00_15423))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15424;

																	BgL_arg1729z00_15424 =
																		PROCEDURE_ATTR(BgL_rz00_15423);
																	if (STRUCTP(BgL_arg1729z00_15424))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5384z00_25682 =
																				(STRUCT_KEY(BgL_arg1729z00_15424) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5384z00_25682 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5384z00_25682 = ((bool_t) 0);
																}
															if (BgL_test5384z00_25682)
																{
																	obj_t BgL_fz00_25690;

																	BgL_fz00_25690 = BgL_rz00_15423;
																	BgL_fz00_15422 = BgL_fz00_25690;
																	goto BgL_recz00_15421;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15416, ((long) 0),
																		BgL_savedzd2bpzd2_15420);
																	BgL_____rz00_15419 = BgL_rz00_15423;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15418);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15417, BgL_sz00_15408);
											return BgL_____rz00_15419;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4502 */
	obj_t BGl_z62run4502z62zz__evaluate_compz00(obj_t BgL_envz00_13101,
		obj_t BgL_sz00_13104)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13102;
				obj_t BgL_bodyz00_13103;

				BgL_i1247z00_13102 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13101, (int) (((long) 0))));
				BgL_bodyz00_13103 = PROCEDURE_REF(BgL_envz00_13101, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15425;

					BgL_bpz00_15425 = VECTOR_REF(((obj_t) BgL_sz00_13104), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15426;
						obj_t BgL_wherez00_15427;
						obj_t BgL_locz00_15428;

						BgL_z12denvz12_15426 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15427 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13102))->
							BgL_wherez00);
						BgL_locz00_15428 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13102))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15426, BgL_wherez00_15427,
								BgL_locz00_15428);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15429;

								BgL_za2za2resza2za2z00_15429 =
									PROCEDURE_ENTRY(BgL_bodyz00_13103) (BgL_bodyz00_13103,
									BgL_sz00_13104, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15426);
								return BgL_za2za2resza2za2z00_15429;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3864> */
	obj_t BGl_z62zc3z04anonymousza33864ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13105, obj_t BgL_sz00_13110)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13106;
				BgL_ev_absz00_bglt BgL_i1247z00_13107;
				obj_t BgL_bodyz00_13108;
				long BgL_siza7ezd2framez75_13109;

				BgL_iboxesz00_13106 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13105, (int) (((long) 0))));
				BgL_i1247z00_13107 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13105, (int) (((long) 1))));
				BgL_bodyz00_13108 = PROCEDURE_REF(BgL_envz00_13105, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13109 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13105, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15430;

					BgL_bpz00_15430 = VECTOR_REF(((obj_t) BgL_sz00_13110), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15431;

							BgL_runz00_15431 =
								MAKE_FX_PROCEDURE(BGl_z62run4504z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_15431,
								(int) (((long) 0)), BgL_iboxesz00_13106);
							PROCEDURE_SET(BgL_runz00_15431,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13107));
							PROCEDURE_SET(BgL_runz00_15431,
								(int) (((long) 2)), BgL_bodyz00_13108);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15432;

								BgL_mainz00_15432 =
									MAKE_FX_PROCEDURE(BGl_z62main4503z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_15432,
									(int) (((long) 0)), BgL_iboxesz00_13106);
								PROCEDURE_SET(BgL_mainz00_15432,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13107));
								PROCEDURE_SET(BgL_mainz00_15432,
									(int) (((long) 2)), BgL_bodyz00_13108);
								PROCEDURE_SET(BgL_mainz00_15432,
									(int) (((long) 3)), BgL_runz00_15431);
								PROCEDURE_SET(BgL_mainz00_15432,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13109));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15433;

									BgL_objz00_15433 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15431, BgL_objz00_15433);
									BgL_objz00_15433;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3865z00_15434;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3866z00_15435;

										BgL_arg3866z00_15435 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13107))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15436;

											BgL_newz00_15436 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25752;

												BgL_tmpz00_25752 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15436, BgL_tmpz00_25752,
													BgL_arg3866z00_15435);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25757;
												int BgL_tmpz00_25755;

												BgL_auxz00_25757 = BINT(BgL_siza7ezd2framez75_13109);
												BgL_tmpz00_25755 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15436, BgL_tmpz00_25755,
													BgL_auxz00_25757);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25760;

												BgL_tmpz00_25760 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15436, BgL_tmpz00_25760,
													BgL_runz00_15431);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25765;
												int BgL_tmpz00_25763;

												BgL_auxz00_25765 = BINT(((long) 4));
												BgL_tmpz00_25763 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15436, BgL_tmpz00_25763,
													BgL_auxz00_25765);
											}
											BgL_arg3865z00_15434 = BgL_newz00_15436;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15432, BgL_arg3865z00_15434);
									BgL_arg3865z00_15434;
								}
								return BgL_mainz00_15432;
							}
						}
					}
				}
			}
		}

	}



/* &main4503 */
	obj_t BGl_z62main4503z62zz__evaluate_compz00(obj_t BgL_envz00_13111,
		obj_t BgL_az00_13117, obj_t BgL_bz00_13118, obj_t BgL_cz00_13119,
		obj_t BgL_dz00_13120)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13115;
				long BgL_siza7ezd2framez75_13116;

				BgL_runz00_13115 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13111, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13116 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13111, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15437;

					BgL_sz00_15437 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15438;

						BgL_bpz00_15438 = VECTOR_REF(((obj_t) BgL_sz00_15437), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15438) + BgL_siza7ezd2framez75_13116) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15437))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3869z00_15439;

									BgL_arg3869z00_15439 =
										((long) CINT(BgL_bpz00_15438) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15437), BgL_arg3869z00_15439,
										BgL_az00_13117);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3870z00_15440;

									BgL_arg3870z00_15440 =
										((long) CINT(BgL_bpz00_15438) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15437), BgL_arg3870z00_15440,
										BgL_bz00_13118);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3871z00_15441;

									BgL_arg3871z00_15441 =
										((long) CINT(BgL_bpz00_15438) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15437), BgL_arg3871z00_15441,
										BgL_cz00_13119);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3872z00_15442;

									BgL_arg3872z00_15442 =
										((long) CINT(BgL_bpz00_15438) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15437), BgL_arg3872z00_15442,
										BgL_dz00_13120);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15443;

									BgL_ez00_15443 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15443,
										BgL_bpz00_15438);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15444;

										BgL_accz00_15444 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13115, BgL_sz00_15437, BgL_bpz00_15438);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15443);
										VECTOR_SET(
											((obj_t) BgL_sz00_15437), ((long) 0), BgL_bpz00_15438);
										return BgL_accz00_15444;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15445;

								BgL_nsz00_15445 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15445, ((long) 1), BgL_sz00_15437);
								VECTOR_SET(BgL_nsz00_15445, ((long) 2), BgL_az00_13117);
								VECTOR_SET(BgL_nsz00_15445, ((long) 3), BgL_bz00_13118);
								VECTOR_SET(BgL_nsz00_15445, ((long) 4), BgL_cz00_13119);
								VECTOR_SET(BgL_nsz00_15445, ((long) 5), BgL_dz00_13120);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15446;

									BgL_z12denvz12_15446 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15446, BgL_nsz00_15445);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15447;

										BgL_ez00_15447 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15447,
											BgL_sz00_15437);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15448;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15449;

												BgL_savedzd2bpzd2_15449 =
													VECTOR_REF(BgL_nsz00_15445, ((long) 0));
												VECTOR_SET(BgL_nsz00_15445, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15451;

													BgL_fz00_15451 = BgL_runz00_13115;
												BgL_recz00_15450:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15452;

														BgL_rz00_15452 =
															PROCEDURE_ENTRY(BgL_fz00_15451) (BgL_fz00_15451,
															BgL_nsz00_15445, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5388z00_25823;

															if (PROCEDUREP(BgL_rz00_15452))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15453;

																	BgL_arg1729z00_15453 =
																		PROCEDURE_ATTR(BgL_rz00_15452);
																	if (STRUCTP(BgL_arg1729z00_15453))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5388z00_25823 =
																				(STRUCT_KEY(BgL_arg1729z00_15453) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5388z00_25823 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5388z00_25823 = ((bool_t) 0);
																}
															if (BgL_test5388z00_25823)
																{
																	obj_t BgL_fz00_25831;

																	BgL_fz00_25831 = BgL_rz00_15452;
																	BgL_fz00_15451 = BgL_fz00_25831;
																	goto BgL_recz00_15450;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15445, ((long) 0),
																		BgL_savedzd2bpzd2_15449);
																	BgL_____rz00_15448 = BgL_rz00_15452;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15447);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15446, BgL_sz00_15437);
											return BgL_____rz00_15448;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4504 */
	obj_t BGl_z62run4504z62zz__evaluate_compz00(obj_t BgL_envz00_13121,
		obj_t BgL_sz00_13125)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13122;
				BgL_ev_absz00_bglt BgL_i1247z00_13123;
				obj_t BgL_bodyz00_13124;

				BgL_iboxesz00_13122 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13121, (int) (((long) 0))));
				BgL_i1247z00_13123 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13121, (int) (((long) 1))));
				BgL_bodyz00_13124 = PROCEDURE_REF(BgL_envz00_13121, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15454;

					BgL_bpz00_15454 = VECTOR_REF(((obj_t) BgL_sz00_13125), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13125,
						BgL_iboxesz00_13122, BgL_bpz00_15454);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15455;
						obj_t BgL_wherez00_15456;
						obj_t BgL_locz00_15457;

						BgL_z12denvz12_15455 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15456 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13123))->
							BgL_wherez00);
						BgL_locz00_15457 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13123))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15455, BgL_wherez00_15456,
								BgL_locz00_15457);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15458;

								BgL_za2za2resza2za2z00_15458 =
									PROCEDURE_ENTRY(BgL_bodyz00_13124) (BgL_bodyz00_13124,
									BgL_sz00_13125, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15455);
								return BgL_za2za2resza2za2z00_15458;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3877> */
	obj_t BGl_z62zc3z04anonymousza33877ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13126, obj_t BgL_sz00_13132)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13127;
				long BgL_siza7eza7_13128;
				BgL_ev_absz00_bglt BgL_i1247z00_13129;
				obj_t BgL_bodyz00_13130;
				long BgL_siza7ezd2framez75_13131;

				BgL_ifreesz00_13127 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13126, (int) (((long) 0))));
				BgL_siza7eza7_13128 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13126, (int) (((long) 1))));
				BgL_i1247z00_13129 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13126, (int) (((long) 2))));
				BgL_bodyz00_13130 = PROCEDURE_REF(BgL_envz00_13126, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13131 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13126, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15459;

					BgL_bpz00_15459 = VECTOR_REF(((obj_t) BgL_sz00_13132), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15460;

						BgL_valza2za2_15460 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13132,
							BgL_bpz00_15459, BgL_ifreesz00_13127);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15461;

							BgL_runz00_15461 =
								MAKE_FX_PROCEDURE(BGl_z62run4506z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_15461,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13128));
							PROCEDURE_SET(BgL_runz00_15461,
								(int) (((long) 1)), BgL_valza2za2_15460);
							PROCEDURE_SET(BgL_runz00_15461,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13129));
							PROCEDURE_SET(BgL_runz00_15461,
								(int) (((long) 3)), BgL_bodyz00_13130);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15462;

								BgL_mainz00_15462 =
									MAKE_FX_PROCEDURE(BGl_z62main4505z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_15462,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13128));
								PROCEDURE_SET(BgL_mainz00_15462,
									(int) (((long) 1)), BgL_valza2za2_15460);
								PROCEDURE_SET(BgL_mainz00_15462,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13129));
								PROCEDURE_SET(BgL_mainz00_15462,
									(int) (((long) 3)), BgL_bodyz00_13130);
								PROCEDURE_SET(BgL_mainz00_15462,
									(int) (((long) 4)), BgL_runz00_15461);
								PROCEDURE_SET(BgL_mainz00_15462,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13131));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15463;

									BgL_objz00_15463 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15461, BgL_objz00_15463);
									BgL_objz00_15463;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3878z00_15464;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3879z00_15465;

										BgL_arg3879z00_15465 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13129))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15466;

											BgL_newz00_15466 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25907;

												BgL_tmpz00_25907 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15466, BgL_tmpz00_25907,
													BgL_arg3879z00_15465);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25912;
												int BgL_tmpz00_25910;

												BgL_auxz00_25912 = BINT(BgL_siza7ezd2framez75_13131);
												BgL_tmpz00_25910 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15466, BgL_tmpz00_25910,
													BgL_auxz00_25912);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_25915;

												BgL_tmpz00_25915 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15466, BgL_tmpz00_25915,
													BgL_runz00_15461);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_25920;
												int BgL_tmpz00_25918;

												BgL_auxz00_25920 = BINT(((long) 4));
												BgL_tmpz00_25918 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15466, BgL_tmpz00_25918,
													BgL_auxz00_25920);
											}
											BgL_arg3878z00_15464 = BgL_newz00_15466;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15462, BgL_arg3878z00_15464);
									BgL_arg3878z00_15464;
								}
								return BgL_mainz00_15462;
							}
						}
					}
				}
			}
		}

	}



/* &main4505 */
	obj_t BGl_z62main4505z62zz__evaluate_compz00(obj_t BgL_envz00_13133,
		obj_t BgL_az00_13140, obj_t BgL_bz00_13141, obj_t BgL_cz00_13142,
		obj_t BgL_dz00_13143)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13138;
				long BgL_siza7ezd2framez75_13139;

				BgL_runz00_13138 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13133, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13139 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13133, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15467;

					BgL_sz00_15467 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15468;

						BgL_bpz00_15468 = VECTOR_REF(((obj_t) BgL_sz00_15467), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15468) + BgL_siza7ezd2framez75_13139) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15467))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3882z00_15469;

									BgL_arg3882z00_15469 =
										((long) CINT(BgL_bpz00_15468) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15467), BgL_arg3882z00_15469,
										BgL_az00_13140);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3883z00_15470;

									BgL_arg3883z00_15470 =
										((long) CINT(BgL_bpz00_15468) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15467), BgL_arg3883z00_15470,
										BgL_bz00_13141);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3884z00_15471;

									BgL_arg3884z00_15471 =
										((long) CINT(BgL_bpz00_15468) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15467), BgL_arg3884z00_15471,
										BgL_cz00_13142);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3885z00_15472;

									BgL_arg3885z00_15472 =
										((long) CINT(BgL_bpz00_15468) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15467), BgL_arg3885z00_15472,
										BgL_dz00_13143);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15473;

									BgL_ez00_15473 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15473,
										BgL_bpz00_15468);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15474;

										BgL_accz00_15474 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13138, BgL_sz00_15467, BgL_bpz00_15468);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15473);
										VECTOR_SET(
											((obj_t) BgL_sz00_15467), ((long) 0), BgL_bpz00_15468);
										return BgL_accz00_15474;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15475;

								BgL_nsz00_15475 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15475, ((long) 1), BgL_sz00_15467);
								VECTOR_SET(BgL_nsz00_15475, ((long) 2), BgL_az00_13140);
								VECTOR_SET(BgL_nsz00_15475, ((long) 3), BgL_bz00_13141);
								VECTOR_SET(BgL_nsz00_15475, ((long) 4), BgL_cz00_13142);
								VECTOR_SET(BgL_nsz00_15475, ((long) 5), BgL_dz00_13143);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15476;

									BgL_z12denvz12_15476 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15476, BgL_nsz00_15475);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15477;

										BgL_ez00_15477 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15477,
											BgL_sz00_15467);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15478;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15479;

												BgL_savedzd2bpzd2_15479 =
													VECTOR_REF(BgL_nsz00_15475, ((long) 0));
												VECTOR_SET(BgL_nsz00_15475, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15481;

													BgL_fz00_15481 = BgL_runz00_13138;
												BgL_recz00_15480:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15482;

														BgL_rz00_15482 =
															PROCEDURE_ENTRY(BgL_fz00_15481) (BgL_fz00_15481,
															BgL_nsz00_15475, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5392z00_25978;

															if (PROCEDUREP(BgL_rz00_15482))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15483;

																	BgL_arg1729z00_15483 =
																		PROCEDURE_ATTR(BgL_rz00_15482);
																	if (STRUCTP(BgL_arg1729z00_15483))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5392z00_25978 =
																				(STRUCT_KEY(BgL_arg1729z00_15483) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5392z00_25978 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5392z00_25978 = ((bool_t) 0);
																}
															if (BgL_test5392z00_25978)
																{
																	obj_t BgL_fz00_25986;

																	BgL_fz00_25986 = BgL_rz00_15482;
																	BgL_fz00_15481 = BgL_fz00_25986;
																	goto BgL_recz00_15480;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15475, ((long) 0),
																		BgL_savedzd2bpzd2_15479);
																	BgL_____rz00_15478 = BgL_rz00_15482;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15477);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15476, BgL_sz00_15467);
											return BgL_____rz00_15478;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4506 */
	obj_t BGl_z62run4506z62zz__evaluate_compz00(obj_t BgL_envz00_13144,
		obj_t BgL_sz00_13149)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13145;
				obj_t BgL_valza2za2_13146;
				BgL_ev_absz00_bglt BgL_i1247z00_13147;
				obj_t BgL_bodyz00_13148;

				BgL_siza7eza7_13145 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13144, (int) (((long) 0))));
				BgL_valza2za2_13146 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13144, (int) (((long) 1))));
				BgL_i1247z00_13147 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13144, (int) (((long) 2))));
				BgL_bodyz00_13148 = PROCEDURE_REF(BgL_envz00_13144, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15484;

					BgL_bpz00_15484 = VECTOR_REF(((obj_t) BgL_sz00_13149), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13149,
						BgL_valza2za2_13146,
						((long) CINT(BgL_bpz00_15484) + BgL_siza7eza7_13145));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15485;
						obj_t BgL_wherez00_15486;
						obj_t BgL_locz00_15487;

						BgL_z12denvz12_15485 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15486 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13147))->
							BgL_wherez00);
						BgL_locz00_15487 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13147))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15485, BgL_wherez00_15486,
								BgL_locz00_15487);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15488;

								BgL_za2za2resza2za2z00_15488 =
									PROCEDURE_ENTRY(BgL_bodyz00_13148) (BgL_bodyz00_13148,
									BgL_sz00_13149, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15485);
								return BgL_za2za2resza2za2z00_15488;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3888> */
	obj_t BGl_z62zc3z04anonymousza33888ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13150, obj_t BgL_sz00_13157)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13151;
				obj_t BgL_iboxesz00_13152;
				long BgL_siza7eza7_13153;
				BgL_ev_absz00_bglt BgL_i1247z00_13154;
				obj_t BgL_bodyz00_13155;
				long BgL_siza7ezd2framez75_13156;

				BgL_ifreesz00_13151 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13150, (int) (((long) 0))));
				BgL_iboxesz00_13152 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13150, (int) (((long) 1))));
				BgL_siza7eza7_13153 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13150, (int) (((long) 2))));
				BgL_i1247z00_13154 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13150, (int) (((long) 3))));
				BgL_bodyz00_13155 = PROCEDURE_REF(BgL_envz00_13150, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13156 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13150, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15489;

					BgL_bpz00_15489 = VECTOR_REF(((obj_t) BgL_sz00_13157), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15490;

						BgL_valza2za2_15490 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13157,
							BgL_bpz00_15489, BgL_ifreesz00_13151);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15491;

							BgL_runz00_15491 =
								MAKE_FX_PROCEDURE(BGl_z62run4508z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_15491,
								(int) (((long) 0)), BgL_iboxesz00_13152);
							PROCEDURE_SET(BgL_runz00_15491,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13153));
							PROCEDURE_SET(BgL_runz00_15491,
								(int) (((long) 2)), BgL_valza2za2_15490);
							PROCEDURE_SET(BgL_runz00_15491,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13154));
							PROCEDURE_SET(BgL_runz00_15491,
								(int) (((long) 4)), BgL_bodyz00_13155);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15492;

								BgL_mainz00_15492 =
									MAKE_FX_PROCEDURE(BGl_z62main4507z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_15492,
									(int) (((long) 0)), BgL_iboxesz00_13152);
								PROCEDURE_SET(BgL_mainz00_15492,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13153));
								PROCEDURE_SET(BgL_mainz00_15492,
									(int) (((long) 2)), BgL_valza2za2_15490);
								PROCEDURE_SET(BgL_mainz00_15492,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13154));
								PROCEDURE_SET(BgL_mainz00_15492,
									(int) (((long) 4)), BgL_bodyz00_13155);
								PROCEDURE_SET(BgL_mainz00_15492,
									(int) (((long) 5)), BgL_runz00_15491);
								PROCEDURE_SET(BgL_mainz00_15492,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13156));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15493;

									BgL_objz00_15493 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15491, BgL_objz00_15493);
									BgL_objz00_15493;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3889z00_15494;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3890z00_15495;

										BgL_arg3890z00_15495 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13154))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15496;

											BgL_newz00_15496 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26074;

												BgL_tmpz00_26074 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15496, BgL_tmpz00_26074,
													BgL_arg3890z00_15495);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26079;
												int BgL_tmpz00_26077;

												BgL_auxz00_26079 = BINT(BgL_siza7ezd2framez75_13156);
												BgL_tmpz00_26077 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15496, BgL_tmpz00_26077,
													BgL_auxz00_26079);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26082;

												BgL_tmpz00_26082 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15496, BgL_tmpz00_26082,
													BgL_runz00_15491);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26087;
												int BgL_tmpz00_26085;

												BgL_auxz00_26087 = BINT(((long) 4));
												BgL_tmpz00_26085 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15496, BgL_tmpz00_26085,
													BgL_auxz00_26087);
											}
											BgL_arg3889z00_15494 = BgL_newz00_15496;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15492, BgL_arg3889z00_15494);
									BgL_arg3889z00_15494;
								}
								return BgL_mainz00_15492;
							}
						}
					}
				}
			}
		}

	}



/* &main4507 */
	obj_t BGl_z62main4507z62zz__evaluate_compz00(obj_t BgL_envz00_13158,
		obj_t BgL_az00_13166, obj_t BgL_bz00_13167, obj_t BgL_cz00_13168,
		obj_t BgL_dz00_13169)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13164;
				long BgL_siza7ezd2framez75_13165;

				BgL_runz00_13164 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13158, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13165 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13158, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15497;

					BgL_sz00_15497 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15498;

						BgL_bpz00_15498 = VECTOR_REF(((obj_t) BgL_sz00_15497), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15498) + BgL_siza7ezd2framez75_13165) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15497))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3893z00_15499;

									BgL_arg3893z00_15499 =
										((long) CINT(BgL_bpz00_15498) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15497), BgL_arg3893z00_15499,
										BgL_az00_13166);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3894z00_15500;

									BgL_arg3894z00_15500 =
										((long) CINT(BgL_bpz00_15498) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15497), BgL_arg3894z00_15500,
										BgL_bz00_13167);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3895z00_15501;

									BgL_arg3895z00_15501 =
										((long) CINT(BgL_bpz00_15498) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15497), BgL_arg3895z00_15501,
										BgL_cz00_13168);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3896z00_15502;

									BgL_arg3896z00_15502 =
										((long) CINT(BgL_bpz00_15498) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15497), BgL_arg3896z00_15502,
										BgL_dz00_13169);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15503;

									BgL_ez00_15503 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15503,
										BgL_bpz00_15498);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15504;

										BgL_accz00_15504 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13164, BgL_sz00_15497, BgL_bpz00_15498);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15503);
										VECTOR_SET(
											((obj_t) BgL_sz00_15497), ((long) 0), BgL_bpz00_15498);
										return BgL_accz00_15504;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15505;

								BgL_nsz00_15505 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15505, ((long) 1), BgL_sz00_15497);
								VECTOR_SET(BgL_nsz00_15505, ((long) 2), BgL_az00_13166);
								VECTOR_SET(BgL_nsz00_15505, ((long) 3), BgL_bz00_13167);
								VECTOR_SET(BgL_nsz00_15505, ((long) 4), BgL_cz00_13168);
								VECTOR_SET(BgL_nsz00_15505, ((long) 5), BgL_dz00_13169);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15506;

									BgL_z12denvz12_15506 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15506, BgL_nsz00_15505);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15507;

										BgL_ez00_15507 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15507,
											BgL_sz00_15497);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15508;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15509;

												BgL_savedzd2bpzd2_15509 =
													VECTOR_REF(BgL_nsz00_15505, ((long) 0));
												VECTOR_SET(BgL_nsz00_15505, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15511;

													BgL_fz00_15511 = BgL_runz00_13164;
												BgL_recz00_15510:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15512;

														BgL_rz00_15512 =
															PROCEDURE_ENTRY(BgL_fz00_15511) (BgL_fz00_15511,
															BgL_nsz00_15505, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5396z00_26145;

															if (PROCEDUREP(BgL_rz00_15512))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15513;

																	BgL_arg1729z00_15513 =
																		PROCEDURE_ATTR(BgL_rz00_15512);
																	if (STRUCTP(BgL_arg1729z00_15513))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5396z00_26145 =
																				(STRUCT_KEY(BgL_arg1729z00_15513) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5396z00_26145 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5396z00_26145 = ((bool_t) 0);
																}
															if (BgL_test5396z00_26145)
																{
																	obj_t BgL_fz00_26153;

																	BgL_fz00_26153 = BgL_rz00_15512;
																	BgL_fz00_15511 = BgL_fz00_26153;
																	goto BgL_recz00_15510;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15505, ((long) 0),
																		BgL_savedzd2bpzd2_15509);
																	BgL_____rz00_15508 = BgL_rz00_15512;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15507);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15506, BgL_sz00_15497);
											return BgL_____rz00_15508;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4508 */
	obj_t BGl_z62run4508z62zz__evaluate_compz00(obj_t BgL_envz00_13170,
		obj_t BgL_sz00_13176)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13171;
				long BgL_siza7eza7_13172;
				obj_t BgL_valza2za2_13173;
				BgL_ev_absz00_bglt BgL_i1247z00_13174;
				obj_t BgL_bodyz00_13175;

				BgL_iboxesz00_13171 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13170, (int) (((long) 0))));
				BgL_siza7eza7_13172 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13170, (int) (((long) 1))));
				BgL_valza2za2_13173 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13170, (int) (((long) 2))));
				BgL_i1247z00_13174 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13170, (int) (((long) 3))));
				BgL_bodyz00_13175 = PROCEDURE_REF(BgL_envz00_13170, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15514;

					BgL_bpz00_15514 = VECTOR_REF(((obj_t) BgL_sz00_13176), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13176,
						BgL_iboxesz00_13171, BgL_bpz00_15514);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13176,
						BgL_valza2za2_13173,
						((long) CINT(BgL_bpz00_15514) + BgL_siza7eza7_13172));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15515;
						obj_t BgL_wherez00_15516;
						obj_t BgL_locz00_15517;

						BgL_z12denvz12_15515 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15516 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13174))->
							BgL_wherez00);
						BgL_locz00_15517 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13174))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15515, BgL_wherez00_15516,
								BgL_locz00_15517);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15518;

								BgL_za2za2resza2za2z00_15518 =
									PROCEDURE_ENTRY(BgL_bodyz00_13175) (BgL_bodyz00_13175,
									BgL_sz00_13176, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15515);
								return BgL_za2za2resza2za2z00_15518;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3803> */
	obj_t BGl_z62zc3z04anonymousza33803ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13177, obj_t BgL_sz00_13181)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13178;
				obj_t BgL_bodyz00_13179;
				long BgL_siza7ezd2framez75_13180;

				BgL_i1247z00_13178 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13177, (int) (((long) 0))));
				BgL_bodyz00_13179 = PROCEDURE_REF(BgL_envz00_13177, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13180 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13177, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15519;

					BgL_bpz00_15519 = VECTOR_REF(((obj_t) BgL_sz00_13181), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15520;

							BgL_runz00_15520 =
								MAKE_FX_PROCEDURE(BGl_z62run4510z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_15520,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13178));
							PROCEDURE_SET(BgL_runz00_15520,
								(int) (((long) 1)), BgL_bodyz00_13179);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15521;

								BgL_mainz00_15521 =
									MAKE_VA_PROCEDURE(BGl_z62main4509z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_15521,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13178));
								PROCEDURE_SET(BgL_mainz00_15521,
									(int) (((long) 1)), BgL_bodyz00_13179);
								PROCEDURE_SET(BgL_mainz00_15521,
									(int) (((long) 2)), BgL_runz00_15520);
								PROCEDURE_SET(BgL_mainz00_15521,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13180));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15522;

									BgL_objz00_15522 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15520, BgL_objz00_15522);
									BgL_objz00_15522;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3804z00_15523;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3805z00_15524;

										BgL_arg3805z00_15524 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13178))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15525;

											BgL_newz00_15525 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26221;

												BgL_tmpz00_26221 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15525, BgL_tmpz00_26221,
													BgL_arg3805z00_15524);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26226;
												int BgL_tmpz00_26224;

												BgL_auxz00_26226 = BINT(BgL_siza7ezd2framez75_13180);
												BgL_tmpz00_26224 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15525, BgL_tmpz00_26224,
													BgL_auxz00_26226);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26229;

												BgL_tmpz00_26229 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15525, BgL_tmpz00_26229,
													BgL_runz00_15520);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26234;
												int BgL_tmpz00_26232;

												BgL_auxz00_26234 = BINT(((long) -4));
												BgL_tmpz00_26232 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15525, BgL_tmpz00_26232,
													BgL_auxz00_26234);
											}
											BgL_arg3804z00_15523 = BgL_newz00_15525;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15521, BgL_arg3804z00_15523);
									BgL_arg3804z00_15523;
								}
								return BgL_mainz00_15521;
							}
						}
					}
				}
			}
		}

	}



/* &main4509 */
	obj_t BGl_z62main4509z62zz__evaluate_compz00(obj_t BgL_envz00_13182,
		obj_t BgL_bz00_13187, obj_t BgL_cz00_13188, obj_t BgL_dz00_13189,
		obj_t BgL_lastz00_13190)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13185;
				long BgL_siza7ezd2framez75_13186;

				BgL_runz00_13185 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13182, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13186 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13182, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15526;

					BgL_sz00_15526 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15527;

						BgL_bpz00_15527 = VECTOR_REF(((obj_t) BgL_sz00_15526), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15527) + BgL_siza7ezd2framez75_13186) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15526))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3808z00_15528;

									BgL_arg3808z00_15528 =
										((long) CINT(BgL_bpz00_15527) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15526), BgL_arg3808z00_15528,
										BgL_bz00_13187);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3809z00_15529;

									BgL_arg3809z00_15529 =
										((long) CINT(BgL_bpz00_15527) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15526), BgL_arg3809z00_15529,
										BgL_cz00_13188);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3810z00_15530;

									BgL_arg3810z00_15530 =
										((long) CINT(BgL_bpz00_15527) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15526), BgL_arg3810z00_15530,
										BgL_dz00_13189);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3811z00_15531;

									BgL_arg3811z00_15531 =
										((long) CINT(BgL_bpz00_15527) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15526), BgL_arg3811z00_15531,
										BgL_lastz00_13190);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15532;

									BgL_ez00_15532 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15532,
										BgL_bpz00_15527);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15533;

										BgL_accz00_15533 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13185, BgL_sz00_15526, BgL_bpz00_15527);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15532);
										VECTOR_SET(
											((obj_t) BgL_sz00_15526), ((long) 0), BgL_bpz00_15527);
										return BgL_accz00_15533;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15534;

								BgL_nsz00_15534 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15534, ((long) 1), BgL_sz00_15526);
								VECTOR_SET(BgL_nsz00_15534, ((long) 2), BgL_bz00_13187);
								VECTOR_SET(BgL_nsz00_15534, ((long) 3), BgL_cz00_13188);
								VECTOR_SET(BgL_nsz00_15534, ((long) 4), BgL_dz00_13189);
								VECTOR_SET(BgL_nsz00_15534, ((long) 5), BgL_lastz00_13190);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15535;

									BgL_z12denvz12_15535 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15535, BgL_nsz00_15534);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15536;

										BgL_ez00_15536 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15536,
											BgL_sz00_15526);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15537;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15538;

												BgL_savedzd2bpzd2_15538 =
													VECTOR_REF(BgL_nsz00_15534, ((long) 0));
												VECTOR_SET(BgL_nsz00_15534, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15540;

													BgL_fz00_15540 = BgL_runz00_13185;
												BgL_recz00_15539:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15541;

														BgL_rz00_15541 =
															PROCEDURE_ENTRY(BgL_fz00_15540) (BgL_fz00_15540,
															BgL_nsz00_15534, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5400z00_26292;

															if (PROCEDUREP(BgL_rz00_15541))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15542;

																	BgL_arg1729z00_15542 =
																		PROCEDURE_ATTR(BgL_rz00_15541);
																	if (STRUCTP(BgL_arg1729z00_15542))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5400z00_26292 =
																				(STRUCT_KEY(BgL_arg1729z00_15542) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5400z00_26292 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5400z00_26292 = ((bool_t) 0);
																}
															if (BgL_test5400z00_26292)
																{
																	obj_t BgL_fz00_26300;

																	BgL_fz00_26300 = BgL_rz00_15541;
																	BgL_fz00_15540 = BgL_fz00_26300;
																	goto BgL_recz00_15539;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15534, ((long) 0),
																		BgL_savedzd2bpzd2_15538);
																	BgL_____rz00_15537 = BgL_rz00_15541;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15536);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15535, BgL_sz00_15526);
											return BgL_____rz00_15537;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4510 */
	obj_t BGl_z62run4510z62zz__evaluate_compz00(obj_t BgL_envz00_13191,
		obj_t BgL_sz00_13194)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13192;
				obj_t BgL_bodyz00_13193;

				BgL_i1247z00_13192 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13191, (int) (((long) 0))));
				BgL_bodyz00_13193 = PROCEDURE_REF(BgL_envz00_13191, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15543;

					BgL_bpz00_15543 = VECTOR_REF(((obj_t) BgL_sz00_13194), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15544;
						obj_t BgL_wherez00_15545;
						obj_t BgL_locz00_15546;

						BgL_z12denvz12_15544 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15545 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13192))->
							BgL_wherez00);
						BgL_locz00_15546 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13192))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15544, BgL_wherez00_15545,
								BgL_locz00_15546);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15547;

								BgL_za2za2resza2za2z00_15547 =
									PROCEDURE_ENTRY(BgL_bodyz00_13193) (BgL_bodyz00_13193,
									BgL_sz00_13194, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15544);
								return BgL_za2za2resza2za2z00_15547;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3813> */
	obj_t BGl_z62zc3z04anonymousza33813ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13195, obj_t BgL_sz00_13200)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13196;
				BgL_ev_absz00_bglt BgL_i1247z00_13197;
				obj_t BgL_bodyz00_13198;
				long BgL_siza7ezd2framez75_13199;

				BgL_iboxesz00_13196 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13195, (int) (((long) 0))));
				BgL_i1247z00_13197 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13195, (int) (((long) 1))));
				BgL_bodyz00_13198 = PROCEDURE_REF(BgL_envz00_13195, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13199 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13195, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15548;

					BgL_bpz00_15548 = VECTOR_REF(((obj_t) BgL_sz00_13200), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15549;

							BgL_runz00_15549 =
								MAKE_FX_PROCEDURE(BGl_z62run4512z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_15549,
								(int) (((long) 0)), BgL_iboxesz00_13196);
							PROCEDURE_SET(BgL_runz00_15549,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13197));
							PROCEDURE_SET(BgL_runz00_15549,
								(int) (((long) 2)), BgL_bodyz00_13198);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15550;

								BgL_mainz00_15550 =
									MAKE_VA_PROCEDURE(BGl_z62main4511z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_15550,
									(int) (((long) 0)), BgL_iboxesz00_13196);
								PROCEDURE_SET(BgL_mainz00_15550,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13197));
								PROCEDURE_SET(BgL_mainz00_15550,
									(int) (((long) 2)), BgL_bodyz00_13198);
								PROCEDURE_SET(BgL_mainz00_15550,
									(int) (((long) 3)), BgL_runz00_15549);
								PROCEDURE_SET(BgL_mainz00_15550,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13199));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15551;

									BgL_objz00_15551 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15549, BgL_objz00_15551);
									BgL_objz00_15551;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3814z00_15552;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3815z00_15553;

										BgL_arg3815z00_15553 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13197))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15554;

											BgL_newz00_15554 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26362;

												BgL_tmpz00_26362 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15554, BgL_tmpz00_26362,
													BgL_arg3815z00_15553);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26367;
												int BgL_tmpz00_26365;

												BgL_auxz00_26367 = BINT(BgL_siza7ezd2framez75_13199);
												BgL_tmpz00_26365 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15554, BgL_tmpz00_26365,
													BgL_auxz00_26367);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26370;

												BgL_tmpz00_26370 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15554, BgL_tmpz00_26370,
													BgL_runz00_15549);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26375;
												int BgL_tmpz00_26373;

												BgL_auxz00_26375 = BINT(((long) -4));
												BgL_tmpz00_26373 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15554, BgL_tmpz00_26373,
													BgL_auxz00_26375);
											}
											BgL_arg3814z00_15552 = BgL_newz00_15554;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15550, BgL_arg3814z00_15552);
									BgL_arg3814z00_15552;
								}
								return BgL_mainz00_15550;
							}
						}
					}
				}
			}
		}

	}



/* &main4511 */
	obj_t BGl_z62main4511z62zz__evaluate_compz00(obj_t BgL_envz00_13201,
		obj_t BgL_bz00_13207, obj_t BgL_cz00_13208, obj_t BgL_dz00_13209,
		obj_t BgL_lastz00_13210)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13205;
				long BgL_siza7ezd2framez75_13206;

				BgL_runz00_13205 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13201, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13206 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13201, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15555;

					BgL_sz00_15555 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15556;

						BgL_bpz00_15556 = VECTOR_REF(((obj_t) BgL_sz00_15555), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15556) + BgL_siza7ezd2framez75_13206) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15555))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3818z00_15557;

									BgL_arg3818z00_15557 =
										((long) CINT(BgL_bpz00_15556) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15555), BgL_arg3818z00_15557,
										BgL_bz00_13207);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3819z00_15558;

									BgL_arg3819z00_15558 =
										((long) CINT(BgL_bpz00_15556) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15555), BgL_arg3819z00_15558,
										BgL_cz00_13208);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3820z00_15559;

									BgL_arg3820z00_15559 =
										((long) CINT(BgL_bpz00_15556) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15555), BgL_arg3820z00_15559,
										BgL_dz00_13209);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3821z00_15560;

									BgL_arg3821z00_15560 =
										((long) CINT(BgL_bpz00_15556) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15555), BgL_arg3821z00_15560,
										BgL_lastz00_13210);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15561;

									BgL_ez00_15561 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15561,
										BgL_bpz00_15556);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15562;

										BgL_accz00_15562 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13205, BgL_sz00_15555, BgL_bpz00_15556);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15561);
										VECTOR_SET(
											((obj_t) BgL_sz00_15555), ((long) 0), BgL_bpz00_15556);
										return BgL_accz00_15562;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15563;

								BgL_nsz00_15563 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15563, ((long) 1), BgL_sz00_15555);
								VECTOR_SET(BgL_nsz00_15563, ((long) 2), BgL_bz00_13207);
								VECTOR_SET(BgL_nsz00_15563, ((long) 3), BgL_cz00_13208);
								VECTOR_SET(BgL_nsz00_15563, ((long) 4), BgL_dz00_13209);
								VECTOR_SET(BgL_nsz00_15563, ((long) 5), BgL_lastz00_13210);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15564;

									BgL_z12denvz12_15564 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15564, BgL_nsz00_15563);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15565;

										BgL_ez00_15565 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15565,
											BgL_sz00_15555);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15566;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15567;

												BgL_savedzd2bpzd2_15567 =
													VECTOR_REF(BgL_nsz00_15563, ((long) 0));
												VECTOR_SET(BgL_nsz00_15563, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15569;

													BgL_fz00_15569 = BgL_runz00_13205;
												BgL_recz00_15568:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15570;

														BgL_rz00_15570 =
															PROCEDURE_ENTRY(BgL_fz00_15569) (BgL_fz00_15569,
															BgL_nsz00_15563, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5404z00_26433;

															if (PROCEDUREP(BgL_rz00_15570))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15571;

																	BgL_arg1729z00_15571 =
																		PROCEDURE_ATTR(BgL_rz00_15570);
																	if (STRUCTP(BgL_arg1729z00_15571))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5404z00_26433 =
																				(STRUCT_KEY(BgL_arg1729z00_15571) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5404z00_26433 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5404z00_26433 = ((bool_t) 0);
																}
															if (BgL_test5404z00_26433)
																{
																	obj_t BgL_fz00_26441;

																	BgL_fz00_26441 = BgL_rz00_15570;
																	BgL_fz00_15569 = BgL_fz00_26441;
																	goto BgL_recz00_15568;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15563, ((long) 0),
																		BgL_savedzd2bpzd2_15567);
																	BgL_____rz00_15566 = BgL_rz00_15570;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15565);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15564, BgL_sz00_15555);
											return BgL_____rz00_15566;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4512 */
	obj_t BGl_z62run4512z62zz__evaluate_compz00(obj_t BgL_envz00_13211,
		obj_t BgL_sz00_13215)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13212;
				BgL_ev_absz00_bglt BgL_i1247z00_13213;
				obj_t BgL_bodyz00_13214;

				BgL_iboxesz00_13212 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13211, (int) (((long) 0))));
				BgL_i1247z00_13213 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13211, (int) (((long) 1))));
				BgL_bodyz00_13214 = PROCEDURE_REF(BgL_envz00_13211, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15572;

					BgL_bpz00_15572 = VECTOR_REF(((obj_t) BgL_sz00_13215), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13215,
						BgL_iboxesz00_13212, BgL_bpz00_15572);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15573;
						obj_t BgL_wherez00_15574;
						obj_t BgL_locz00_15575;

						BgL_z12denvz12_15573 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15574 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13213))->
							BgL_wherez00);
						BgL_locz00_15575 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13213))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15573, BgL_wherez00_15574,
								BgL_locz00_15575);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15576;

								BgL_za2za2resza2za2z00_15576 =
									PROCEDURE_ENTRY(BgL_bodyz00_13214) (BgL_bodyz00_13214,
									BgL_sz00_13215, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15573);
								return BgL_za2za2resza2za2z00_15576;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3826> */
	obj_t BGl_z62zc3z04anonymousza33826ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13216, obj_t BgL_sz00_13222)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13217;
				long BgL_siza7eza7_13218;
				BgL_ev_absz00_bglt BgL_i1247z00_13219;
				obj_t BgL_bodyz00_13220;
				long BgL_siza7ezd2framez75_13221;

				BgL_ifreesz00_13217 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13216, (int) (((long) 0))));
				BgL_siza7eza7_13218 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13216, (int) (((long) 1))));
				BgL_i1247z00_13219 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13216, (int) (((long) 2))));
				BgL_bodyz00_13220 = PROCEDURE_REF(BgL_envz00_13216, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13221 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13216, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15577;

					BgL_bpz00_15577 = VECTOR_REF(((obj_t) BgL_sz00_13222), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15578;

						BgL_valza2za2_15578 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13222,
							BgL_bpz00_15577, BgL_ifreesz00_13217);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15579;

							BgL_runz00_15579 =
								MAKE_FX_PROCEDURE(BGl_z62run4514z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_15579,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13218));
							PROCEDURE_SET(BgL_runz00_15579,
								(int) (((long) 1)), BgL_valza2za2_15578);
							PROCEDURE_SET(BgL_runz00_15579,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13219));
							PROCEDURE_SET(BgL_runz00_15579,
								(int) (((long) 3)), BgL_bodyz00_13220);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15580;

								BgL_mainz00_15580 =
									MAKE_VA_PROCEDURE(BGl_z62main4513z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_15580,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13218));
								PROCEDURE_SET(BgL_mainz00_15580,
									(int) (((long) 1)), BgL_valza2za2_15578);
								PROCEDURE_SET(BgL_mainz00_15580,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13219));
								PROCEDURE_SET(BgL_mainz00_15580,
									(int) (((long) 3)), BgL_bodyz00_13220);
								PROCEDURE_SET(BgL_mainz00_15580,
									(int) (((long) 4)), BgL_runz00_15579);
								PROCEDURE_SET(BgL_mainz00_15580,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13221));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15581;

									BgL_objz00_15581 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15579, BgL_objz00_15581);
									BgL_objz00_15581;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3827z00_15582;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3828z00_15583;

										BgL_arg3828z00_15583 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13219))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15584;

											BgL_newz00_15584 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26517;

												BgL_tmpz00_26517 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15584, BgL_tmpz00_26517,
													BgL_arg3828z00_15583);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26522;
												int BgL_tmpz00_26520;

												BgL_auxz00_26522 = BINT(BgL_siza7ezd2framez75_13221);
												BgL_tmpz00_26520 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15584, BgL_tmpz00_26520,
													BgL_auxz00_26522);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26525;

												BgL_tmpz00_26525 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15584, BgL_tmpz00_26525,
													BgL_runz00_15579);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26530;
												int BgL_tmpz00_26528;

												BgL_auxz00_26530 = BINT(((long) -4));
												BgL_tmpz00_26528 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15584, BgL_tmpz00_26528,
													BgL_auxz00_26530);
											}
											BgL_arg3827z00_15582 = BgL_newz00_15584;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15580, BgL_arg3827z00_15582);
									BgL_arg3827z00_15582;
								}
								return BgL_mainz00_15580;
							}
						}
					}
				}
			}
		}

	}



/* &main4513 */
	obj_t BGl_z62main4513z62zz__evaluate_compz00(obj_t BgL_envz00_13223,
		obj_t BgL_bz00_13230, obj_t BgL_cz00_13231, obj_t BgL_dz00_13232,
		obj_t BgL_lastz00_13233)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13228;
				long BgL_siza7ezd2framez75_13229;

				BgL_runz00_13228 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13223, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13229 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13223, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15585;

					BgL_sz00_15585 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15586;

						BgL_bpz00_15586 = VECTOR_REF(((obj_t) BgL_sz00_15585), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15586) + BgL_siza7ezd2framez75_13229) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15585))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3831z00_15587;

									BgL_arg3831z00_15587 =
										((long) CINT(BgL_bpz00_15586) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15585), BgL_arg3831z00_15587,
										BgL_bz00_13230);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3832z00_15588;

									BgL_arg3832z00_15588 =
										((long) CINT(BgL_bpz00_15586) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15585), BgL_arg3832z00_15588,
										BgL_cz00_13231);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3833z00_15589;

									BgL_arg3833z00_15589 =
										((long) CINT(BgL_bpz00_15586) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15585), BgL_arg3833z00_15589,
										BgL_dz00_13232);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3834z00_15590;

									BgL_arg3834z00_15590 =
										((long) CINT(BgL_bpz00_15586) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15585), BgL_arg3834z00_15590,
										BgL_lastz00_13233);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15591;

									BgL_ez00_15591 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15591,
										BgL_bpz00_15586);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15592;

										BgL_accz00_15592 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13228, BgL_sz00_15585, BgL_bpz00_15586);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15591);
										VECTOR_SET(
											((obj_t) BgL_sz00_15585), ((long) 0), BgL_bpz00_15586);
										return BgL_accz00_15592;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15593;

								BgL_nsz00_15593 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15593, ((long) 1), BgL_sz00_15585);
								VECTOR_SET(BgL_nsz00_15593, ((long) 2), BgL_bz00_13230);
								VECTOR_SET(BgL_nsz00_15593, ((long) 3), BgL_cz00_13231);
								VECTOR_SET(BgL_nsz00_15593, ((long) 4), BgL_dz00_13232);
								VECTOR_SET(BgL_nsz00_15593, ((long) 5), BgL_lastz00_13233);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15594;

									BgL_z12denvz12_15594 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15594, BgL_nsz00_15593);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15595;

										BgL_ez00_15595 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15595,
											BgL_sz00_15585);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15596;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15597;

												BgL_savedzd2bpzd2_15597 =
													VECTOR_REF(BgL_nsz00_15593, ((long) 0));
												VECTOR_SET(BgL_nsz00_15593, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15599;

													BgL_fz00_15599 = BgL_runz00_13228;
												BgL_recz00_15598:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15600;

														BgL_rz00_15600 =
															PROCEDURE_ENTRY(BgL_fz00_15599) (BgL_fz00_15599,
															BgL_nsz00_15593, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5408z00_26588;

															if (PROCEDUREP(BgL_rz00_15600))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15601;

																	BgL_arg1729z00_15601 =
																		PROCEDURE_ATTR(BgL_rz00_15600);
																	if (STRUCTP(BgL_arg1729z00_15601))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5408z00_26588 =
																				(STRUCT_KEY(BgL_arg1729z00_15601) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5408z00_26588 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5408z00_26588 = ((bool_t) 0);
																}
															if (BgL_test5408z00_26588)
																{
																	obj_t BgL_fz00_26596;

																	BgL_fz00_26596 = BgL_rz00_15600;
																	BgL_fz00_15599 = BgL_fz00_26596;
																	goto BgL_recz00_15598;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15593, ((long) 0),
																		BgL_savedzd2bpzd2_15597);
																	BgL_____rz00_15596 = BgL_rz00_15600;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15595);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15594, BgL_sz00_15585);
											return BgL_____rz00_15596;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4514 */
	obj_t BGl_z62run4514z62zz__evaluate_compz00(obj_t BgL_envz00_13234,
		obj_t BgL_sz00_13239)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13235;
				obj_t BgL_valza2za2_13236;
				BgL_ev_absz00_bglt BgL_i1247z00_13237;
				obj_t BgL_bodyz00_13238;

				BgL_siza7eza7_13235 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13234, (int) (((long) 0))));
				BgL_valza2za2_13236 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13234, (int) (((long) 1))));
				BgL_i1247z00_13237 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13234, (int) (((long) 2))));
				BgL_bodyz00_13238 = PROCEDURE_REF(BgL_envz00_13234, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15602;

					BgL_bpz00_15602 = VECTOR_REF(((obj_t) BgL_sz00_13239), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13239,
						BgL_valza2za2_13236,
						((long) CINT(BgL_bpz00_15602) + BgL_siza7eza7_13235));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15603;
						obj_t BgL_wherez00_15604;
						obj_t BgL_locz00_15605;

						BgL_z12denvz12_15603 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15604 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13237))->
							BgL_wherez00);
						BgL_locz00_15605 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13237))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15603, BgL_wherez00_15604,
								BgL_locz00_15605);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15606;

								BgL_za2za2resza2za2z00_15606 =
									PROCEDURE_ENTRY(BgL_bodyz00_13238) (BgL_bodyz00_13238,
									BgL_sz00_13239, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15603);
								return BgL_za2za2resza2za2z00_15606;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3837> */
	obj_t BGl_z62zc3z04anonymousza33837ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13240, obj_t BgL_sz00_13247)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13241;
				obj_t BgL_iboxesz00_13242;
				long BgL_siza7eza7_13243;
				BgL_ev_absz00_bglt BgL_i1247z00_13244;
				obj_t BgL_bodyz00_13245;
				long BgL_siza7ezd2framez75_13246;

				BgL_ifreesz00_13241 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13240, (int) (((long) 0))));
				BgL_iboxesz00_13242 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13240, (int) (((long) 1))));
				BgL_siza7eza7_13243 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13240, (int) (((long) 2))));
				BgL_i1247z00_13244 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13240, (int) (((long) 3))));
				BgL_bodyz00_13245 = PROCEDURE_REF(BgL_envz00_13240, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13246 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13240, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15607;

					BgL_bpz00_15607 = VECTOR_REF(((obj_t) BgL_sz00_13247), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15608;

						BgL_valza2za2_15608 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13247,
							BgL_bpz00_15607, BgL_ifreesz00_13241);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15609;

							BgL_runz00_15609 =
								MAKE_FX_PROCEDURE(BGl_z62run4516z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_15609,
								(int) (((long) 0)), BgL_iboxesz00_13242);
							PROCEDURE_SET(BgL_runz00_15609,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13243));
							PROCEDURE_SET(BgL_runz00_15609,
								(int) (((long) 2)), BgL_valza2za2_15608);
							PROCEDURE_SET(BgL_runz00_15609,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13244));
							PROCEDURE_SET(BgL_runz00_15609,
								(int) (((long) 4)), BgL_bodyz00_13245);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15610;

								BgL_mainz00_15610 =
									MAKE_VA_PROCEDURE(BGl_z62main4515z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_15610,
									(int) (((long) 0)), BgL_iboxesz00_13242);
								PROCEDURE_SET(BgL_mainz00_15610,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13243));
								PROCEDURE_SET(BgL_mainz00_15610,
									(int) (((long) 2)), BgL_valza2za2_15608);
								PROCEDURE_SET(BgL_mainz00_15610,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13244));
								PROCEDURE_SET(BgL_mainz00_15610,
									(int) (((long) 4)), BgL_bodyz00_13245);
								PROCEDURE_SET(BgL_mainz00_15610,
									(int) (((long) 5)), BgL_runz00_15609);
								PROCEDURE_SET(BgL_mainz00_15610,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13246));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15611;

									BgL_objz00_15611 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15609, BgL_objz00_15611);
									BgL_objz00_15611;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3838z00_15612;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3839z00_15613;

										BgL_arg3839z00_15613 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13244))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15614;

											BgL_newz00_15614 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26684;

												BgL_tmpz00_26684 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15614, BgL_tmpz00_26684,
													BgL_arg3839z00_15613);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26689;
												int BgL_tmpz00_26687;

												BgL_auxz00_26689 = BINT(BgL_siza7ezd2framez75_13246);
												BgL_tmpz00_26687 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15614, BgL_tmpz00_26687,
													BgL_auxz00_26689);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26692;

												BgL_tmpz00_26692 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15614, BgL_tmpz00_26692,
													BgL_runz00_15609);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26697;
												int BgL_tmpz00_26695;

												BgL_auxz00_26697 = BINT(((long) -4));
												BgL_tmpz00_26695 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15614, BgL_tmpz00_26695,
													BgL_auxz00_26697);
											}
											BgL_arg3838z00_15612 = BgL_newz00_15614;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15610, BgL_arg3838z00_15612);
									BgL_arg3838z00_15612;
								}
								return BgL_mainz00_15610;
							}
						}
					}
				}
			}
		}

	}



/* &main4515 */
	obj_t BGl_z62main4515z62zz__evaluate_compz00(obj_t BgL_envz00_13248,
		obj_t BgL_bz00_13256, obj_t BgL_cz00_13257, obj_t BgL_dz00_13258,
		obj_t BgL_lastz00_13259)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13254;
				long BgL_siza7ezd2framez75_13255;

				BgL_runz00_13254 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13248, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13255 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13248, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15615;

					BgL_sz00_15615 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15616;

						BgL_bpz00_15616 = VECTOR_REF(((obj_t) BgL_sz00_15615), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15616) + BgL_siza7ezd2framez75_13255) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15615))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3842z00_15617;

									BgL_arg3842z00_15617 =
										((long) CINT(BgL_bpz00_15616) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15615), BgL_arg3842z00_15617,
										BgL_bz00_13256);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3843z00_15618;

									BgL_arg3843z00_15618 =
										((long) CINT(BgL_bpz00_15616) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15615), BgL_arg3843z00_15618,
										BgL_cz00_13257);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3844z00_15619;

									BgL_arg3844z00_15619 =
										((long) CINT(BgL_bpz00_15616) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15615), BgL_arg3844z00_15619,
										BgL_dz00_13258);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3845z00_15620;

									BgL_arg3845z00_15620 =
										((long) CINT(BgL_bpz00_15616) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_15615), BgL_arg3845z00_15620,
										BgL_lastz00_13259);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15621;

									BgL_ez00_15621 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15621,
										BgL_bpz00_15616);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15622;

										BgL_accz00_15622 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13254, BgL_sz00_15615, BgL_bpz00_15616);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15621);
										VECTOR_SET(
											((obj_t) BgL_sz00_15615), ((long) 0), BgL_bpz00_15616);
										return BgL_accz00_15622;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15623;

								BgL_nsz00_15623 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15623, ((long) 1), BgL_sz00_15615);
								VECTOR_SET(BgL_nsz00_15623, ((long) 2), BgL_bz00_13256);
								VECTOR_SET(BgL_nsz00_15623, ((long) 3), BgL_cz00_13257);
								VECTOR_SET(BgL_nsz00_15623, ((long) 4), BgL_dz00_13258);
								VECTOR_SET(BgL_nsz00_15623, ((long) 5), BgL_lastz00_13259);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15624;

									BgL_z12denvz12_15624 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15624, BgL_nsz00_15623);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15625;

										BgL_ez00_15625 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15625,
											BgL_sz00_15615);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15626;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15627;

												BgL_savedzd2bpzd2_15627 =
													VECTOR_REF(BgL_nsz00_15623, ((long) 0));
												VECTOR_SET(BgL_nsz00_15623, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15629;

													BgL_fz00_15629 = BgL_runz00_13254;
												BgL_recz00_15628:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15630;

														BgL_rz00_15630 =
															PROCEDURE_ENTRY(BgL_fz00_15629) (BgL_fz00_15629,
															BgL_nsz00_15623, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5412z00_26755;

															if (PROCEDUREP(BgL_rz00_15630))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15631;

																	BgL_arg1729z00_15631 =
																		PROCEDURE_ATTR(BgL_rz00_15630);
																	if (STRUCTP(BgL_arg1729z00_15631))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5412z00_26755 =
																				(STRUCT_KEY(BgL_arg1729z00_15631) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5412z00_26755 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5412z00_26755 = ((bool_t) 0);
																}
															if (BgL_test5412z00_26755)
																{
																	obj_t BgL_fz00_26763;

																	BgL_fz00_26763 = BgL_rz00_15630;
																	BgL_fz00_15629 = BgL_fz00_26763;
																	goto BgL_recz00_15628;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15623, ((long) 0),
																		BgL_savedzd2bpzd2_15627);
																	BgL_____rz00_15626 = BgL_rz00_15630;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15625);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15624, BgL_sz00_15615);
											return BgL_____rz00_15626;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4516 */
	obj_t BGl_z62run4516z62zz__evaluate_compz00(obj_t BgL_envz00_13260,
		obj_t BgL_sz00_13266)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13261;
				long BgL_siza7eza7_13262;
				obj_t BgL_valza2za2_13263;
				BgL_ev_absz00_bglt BgL_i1247z00_13264;
				obj_t BgL_bodyz00_13265;

				BgL_iboxesz00_13261 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13260, (int) (((long) 0))));
				BgL_siza7eza7_13262 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13260, (int) (((long) 1))));
				BgL_valza2za2_13263 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13260, (int) (((long) 2))));
				BgL_i1247z00_13264 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13260, (int) (((long) 3))));
				BgL_bodyz00_13265 = PROCEDURE_REF(BgL_envz00_13260, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15632;

					BgL_bpz00_15632 = VECTOR_REF(((obj_t) BgL_sz00_13266), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13266,
						BgL_iboxesz00_13261, BgL_bpz00_15632);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13266,
						BgL_valza2za2_13263,
						((long) CINT(BgL_bpz00_15632) + BgL_siza7eza7_13262));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15633;
						obj_t BgL_wherez00_15634;
						obj_t BgL_locz00_15635;

						BgL_z12denvz12_15633 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15634 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13264))->
							BgL_wherez00);
						BgL_locz00_15635 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13264))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15633, BgL_wherez00_15634,
								BgL_locz00_15635);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15636;

								BgL_za2za2resza2za2z00_15636 =
									PROCEDURE_ENTRY(BgL_bodyz00_13265) (BgL_bodyz00_13265,
									BgL_sz00_13266, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15633);
								return BgL_za2za2resza2za2z00_15636;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3756> */
	obj_t BGl_z62zc3z04anonymousza33756ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13267, obj_t BgL_sz00_13271)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13268;
				obj_t BgL_bodyz00_13269;
				long BgL_siza7ezd2framez75_13270;

				BgL_i1247z00_13268 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13267, (int) (((long) 0))));
				BgL_bodyz00_13269 = PROCEDURE_REF(BgL_envz00_13267, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13270 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13267, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15637;

					BgL_bpz00_15637 = VECTOR_REF(((obj_t) BgL_sz00_13271), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15638;

							BgL_runz00_15638 =
								MAKE_FX_PROCEDURE(BGl_z62run4518z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_15638,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13268));
							PROCEDURE_SET(BgL_runz00_15638,
								(int) (((long) 1)), BgL_bodyz00_13269);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15639;

								BgL_mainz00_15639 =
									MAKE_FX_PROCEDURE(BGl_z62main4517z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_15639,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13268));
								PROCEDURE_SET(BgL_mainz00_15639,
									(int) (((long) 1)), BgL_bodyz00_13269);
								PROCEDURE_SET(BgL_mainz00_15639,
									(int) (((long) 2)), BgL_runz00_15638);
								PROCEDURE_SET(BgL_mainz00_15639,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13270));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15640;

									BgL_objz00_15640 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15638, BgL_objz00_15640);
									BgL_objz00_15640;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3757z00_15641;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3758z00_15642;

										BgL_arg3758z00_15642 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13268))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15643;

											BgL_newz00_15643 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26831;

												BgL_tmpz00_26831 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15643, BgL_tmpz00_26831,
													BgL_arg3758z00_15642);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26836;
												int BgL_tmpz00_26834;

												BgL_auxz00_26836 = BINT(BgL_siza7ezd2framez75_13270);
												BgL_tmpz00_26834 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15643, BgL_tmpz00_26834,
													BgL_auxz00_26836);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26839;

												BgL_tmpz00_26839 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15643, BgL_tmpz00_26839,
													BgL_runz00_15638);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26844;
												int BgL_tmpz00_26842;

												BgL_auxz00_26844 = BINT(((long) 3));
												BgL_tmpz00_26842 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15643, BgL_tmpz00_26842,
													BgL_auxz00_26844);
											}
											BgL_arg3757z00_15641 = BgL_newz00_15643;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15639, BgL_arg3757z00_15641);
									BgL_arg3757z00_15641;
								}
								return BgL_mainz00_15639;
							}
						}
					}
				}
			}
		}

	}



/* &main4517 */
	obj_t BGl_z62main4517z62zz__evaluate_compz00(obj_t BgL_envz00_13272,
		obj_t BgL_bz00_13277, obj_t BgL_cz00_13278, obj_t BgL_dz00_13279)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13275;
				long BgL_siza7ezd2framez75_13276;

				BgL_runz00_13275 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13272, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13276 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13272, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15644;

					BgL_sz00_15644 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15645;

						BgL_bpz00_15645 = VECTOR_REF(((obj_t) BgL_sz00_15644), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15645) + BgL_siza7ezd2framez75_13276) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15644))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3761z00_15646;

									BgL_arg3761z00_15646 =
										((long) CINT(BgL_bpz00_15645) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15644), BgL_arg3761z00_15646,
										BgL_bz00_13277);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3762z00_15647;

									BgL_arg3762z00_15647 =
										((long) CINT(BgL_bpz00_15645) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15644), BgL_arg3762z00_15647,
										BgL_cz00_13278);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3763z00_15648;

									BgL_arg3763z00_15648 =
										((long) CINT(BgL_bpz00_15645) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15644), BgL_arg3763z00_15648,
										BgL_dz00_13279);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15649;

									BgL_ez00_15649 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15649,
										BgL_bpz00_15645);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15650;

										BgL_accz00_15650 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13275, BgL_sz00_15644, BgL_bpz00_15645);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15649);
										VECTOR_SET(
											((obj_t) BgL_sz00_15644), ((long) 0), BgL_bpz00_15645);
										return BgL_accz00_15650;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15651;

								BgL_nsz00_15651 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15651, ((long) 1), BgL_sz00_15644);
								VECTOR_SET(BgL_nsz00_15651, ((long) 2), BgL_bz00_13277);
								VECTOR_SET(BgL_nsz00_15651, ((long) 3), BgL_cz00_13278);
								VECTOR_SET(BgL_nsz00_15651, ((long) 4), BgL_dz00_13279);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15652;

									BgL_z12denvz12_15652 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15652, BgL_nsz00_15651);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15653;

										BgL_ez00_15653 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15653,
											BgL_sz00_15644);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15654;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15655;

												BgL_savedzd2bpzd2_15655 =
													VECTOR_REF(BgL_nsz00_15651, ((long) 0));
												VECTOR_SET(BgL_nsz00_15651, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15657;

													BgL_fz00_15657 = BgL_runz00_13275;
												BgL_recz00_15656:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15658;

														BgL_rz00_15658 =
															PROCEDURE_ENTRY(BgL_fz00_15657) (BgL_fz00_15657,
															BgL_nsz00_15651, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5416z00_26897;

															if (PROCEDUREP(BgL_rz00_15658))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15659;

																	BgL_arg1729z00_15659 =
																		PROCEDURE_ATTR(BgL_rz00_15658);
																	if (STRUCTP(BgL_arg1729z00_15659))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5416z00_26897 =
																				(STRUCT_KEY(BgL_arg1729z00_15659) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5416z00_26897 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5416z00_26897 = ((bool_t) 0);
																}
															if (BgL_test5416z00_26897)
																{
																	obj_t BgL_fz00_26905;

																	BgL_fz00_26905 = BgL_rz00_15658;
																	BgL_fz00_15657 = BgL_fz00_26905;
																	goto BgL_recz00_15656;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15651, ((long) 0),
																		BgL_savedzd2bpzd2_15655);
																	BgL_____rz00_15654 = BgL_rz00_15658;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15653);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15652, BgL_sz00_15644);
											return BgL_____rz00_15654;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4518 */
	obj_t BGl_z62run4518z62zz__evaluate_compz00(obj_t BgL_envz00_13280,
		obj_t BgL_sz00_13283)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13281;
				obj_t BgL_bodyz00_13282;

				BgL_i1247z00_13281 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13280, (int) (((long) 0))));
				BgL_bodyz00_13282 = PROCEDURE_REF(BgL_envz00_13280, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15660;

					BgL_bpz00_15660 = VECTOR_REF(((obj_t) BgL_sz00_13283), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15661;
						obj_t BgL_wherez00_15662;
						obj_t BgL_locz00_15663;

						BgL_z12denvz12_15661 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15662 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13281))->
							BgL_wherez00);
						BgL_locz00_15663 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13281))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15661, BgL_wherez00_15662,
								BgL_locz00_15663);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15664;

								BgL_za2za2resza2za2z00_15664 =
									PROCEDURE_ENTRY(BgL_bodyz00_13282) (BgL_bodyz00_13282,
									BgL_sz00_13283, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15661);
								return BgL_za2za2resza2za2z00_15664;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3765> */
	obj_t BGl_z62zc3z04anonymousza33765ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13284, obj_t BgL_sz00_13289)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13285;
				BgL_ev_absz00_bglt BgL_i1247z00_13286;
				obj_t BgL_bodyz00_13287;
				long BgL_siza7ezd2framez75_13288;

				BgL_iboxesz00_13285 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13284, (int) (((long) 0))));
				BgL_i1247z00_13286 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13284, (int) (((long) 1))));
				BgL_bodyz00_13287 = PROCEDURE_REF(BgL_envz00_13284, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13288 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13284, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15665;

					BgL_bpz00_15665 = VECTOR_REF(((obj_t) BgL_sz00_13289), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15666;

							BgL_runz00_15666 =
								MAKE_FX_PROCEDURE(BGl_z62run4520z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_15666,
								(int) (((long) 0)), BgL_iboxesz00_13285);
							PROCEDURE_SET(BgL_runz00_15666,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13286));
							PROCEDURE_SET(BgL_runz00_15666,
								(int) (((long) 2)), BgL_bodyz00_13287);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15667;

								BgL_mainz00_15667 =
									MAKE_FX_PROCEDURE(BGl_z62main4519z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_15667,
									(int) (((long) 0)), BgL_iboxesz00_13285);
								PROCEDURE_SET(BgL_mainz00_15667,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13286));
								PROCEDURE_SET(BgL_mainz00_15667,
									(int) (((long) 2)), BgL_bodyz00_13287);
								PROCEDURE_SET(BgL_mainz00_15667,
									(int) (((long) 3)), BgL_runz00_15666);
								PROCEDURE_SET(BgL_mainz00_15667,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13288));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15668;

									BgL_objz00_15668 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15666, BgL_objz00_15668);
									BgL_objz00_15668;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3766z00_15669;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3767z00_15670;

										BgL_arg3767z00_15670 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13286))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15671;

											BgL_newz00_15671 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26967;

												BgL_tmpz00_26967 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15671, BgL_tmpz00_26967,
													BgL_arg3767z00_15670);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26972;
												int BgL_tmpz00_26970;

												BgL_auxz00_26972 = BINT(BgL_siza7ezd2framez75_13288);
												BgL_tmpz00_26970 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15671, BgL_tmpz00_26970,
													BgL_auxz00_26972);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26975;

												BgL_tmpz00_26975 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15671, BgL_tmpz00_26975,
													BgL_runz00_15666);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26980;
												int BgL_tmpz00_26978;

												BgL_auxz00_26980 = BINT(((long) 3));
												BgL_tmpz00_26978 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15671, BgL_tmpz00_26978,
													BgL_auxz00_26980);
											}
											BgL_arg3766z00_15669 = BgL_newz00_15671;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15667, BgL_arg3766z00_15669);
									BgL_arg3766z00_15669;
								}
								return BgL_mainz00_15667;
							}
						}
					}
				}
			}
		}

	}



/* &main4519 */
	obj_t BGl_z62main4519z62zz__evaluate_compz00(obj_t BgL_envz00_13290,
		obj_t BgL_bz00_13296, obj_t BgL_cz00_13297, obj_t BgL_dz00_13298)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13294;
				long BgL_siza7ezd2framez75_13295;

				BgL_runz00_13294 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13290, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13295 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13290, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15672;

					BgL_sz00_15672 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15673;

						BgL_bpz00_15673 = VECTOR_REF(((obj_t) BgL_sz00_15672), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15673) + BgL_siza7ezd2framez75_13295) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15672))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3770z00_15674;

									BgL_arg3770z00_15674 =
										((long) CINT(BgL_bpz00_15673) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15672), BgL_arg3770z00_15674,
										BgL_bz00_13296);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3771z00_15675;

									BgL_arg3771z00_15675 =
										((long) CINT(BgL_bpz00_15673) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15672), BgL_arg3771z00_15675,
										BgL_cz00_13297);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3772z00_15676;

									BgL_arg3772z00_15676 =
										((long) CINT(BgL_bpz00_15673) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15672), BgL_arg3772z00_15676,
										BgL_dz00_13298);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15677;

									BgL_ez00_15677 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15677,
										BgL_bpz00_15673);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15678;

										BgL_accz00_15678 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13294, BgL_sz00_15672, BgL_bpz00_15673);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15677);
										VECTOR_SET(
											((obj_t) BgL_sz00_15672), ((long) 0), BgL_bpz00_15673);
										return BgL_accz00_15678;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15679;

								BgL_nsz00_15679 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15679, ((long) 1), BgL_sz00_15672);
								VECTOR_SET(BgL_nsz00_15679, ((long) 2), BgL_bz00_13296);
								VECTOR_SET(BgL_nsz00_15679, ((long) 3), BgL_cz00_13297);
								VECTOR_SET(BgL_nsz00_15679, ((long) 4), BgL_dz00_13298);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15680;

									BgL_z12denvz12_15680 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15680, BgL_nsz00_15679);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15681;

										BgL_ez00_15681 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15681,
											BgL_sz00_15672);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15682;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15683;

												BgL_savedzd2bpzd2_15683 =
													VECTOR_REF(BgL_nsz00_15679, ((long) 0));
												VECTOR_SET(BgL_nsz00_15679, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15685;

													BgL_fz00_15685 = BgL_runz00_13294;
												BgL_recz00_15684:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15686;

														BgL_rz00_15686 =
															PROCEDURE_ENTRY(BgL_fz00_15685) (BgL_fz00_15685,
															BgL_nsz00_15679, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5420z00_27033;

															if (PROCEDUREP(BgL_rz00_15686))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15687;

																	BgL_arg1729z00_15687 =
																		PROCEDURE_ATTR(BgL_rz00_15686);
																	if (STRUCTP(BgL_arg1729z00_15687))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5420z00_27033 =
																				(STRUCT_KEY(BgL_arg1729z00_15687) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5420z00_27033 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5420z00_27033 = ((bool_t) 0);
																}
															if (BgL_test5420z00_27033)
																{
																	obj_t BgL_fz00_27041;

																	BgL_fz00_27041 = BgL_rz00_15686;
																	BgL_fz00_15685 = BgL_fz00_27041;
																	goto BgL_recz00_15684;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15679, ((long) 0),
																		BgL_savedzd2bpzd2_15683);
																	BgL_____rz00_15682 = BgL_rz00_15686;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15681);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15680, BgL_sz00_15672);
											return BgL_____rz00_15682;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4520 */
	obj_t BGl_z62run4520z62zz__evaluate_compz00(obj_t BgL_envz00_13299,
		obj_t BgL_sz00_13303)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13300;
				BgL_ev_absz00_bglt BgL_i1247z00_13301;
				obj_t BgL_bodyz00_13302;

				BgL_iboxesz00_13300 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13299, (int) (((long) 0))));
				BgL_i1247z00_13301 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13299, (int) (((long) 1))));
				BgL_bodyz00_13302 = PROCEDURE_REF(BgL_envz00_13299, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15688;

					BgL_bpz00_15688 = VECTOR_REF(((obj_t) BgL_sz00_13303), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13303,
						BgL_iboxesz00_13300, BgL_bpz00_15688);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15689;
						obj_t BgL_wherez00_15690;
						obj_t BgL_locz00_15691;

						BgL_z12denvz12_15689 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15690 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13301))->
							BgL_wherez00);
						BgL_locz00_15691 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13301))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15689, BgL_wherez00_15690,
								BgL_locz00_15691);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15692;

								BgL_za2za2resza2za2z00_15692 =
									PROCEDURE_ENTRY(BgL_bodyz00_13302) (BgL_bodyz00_13302,
									BgL_sz00_13303, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15689);
								return BgL_za2za2resza2za2z00_15692;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3777> */
	obj_t BGl_z62zc3z04anonymousza33777ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13304, obj_t BgL_sz00_13310)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13305;
				long BgL_siza7eza7_13306;
				BgL_ev_absz00_bglt BgL_i1247z00_13307;
				obj_t BgL_bodyz00_13308;
				long BgL_siza7ezd2framez75_13309;

				BgL_ifreesz00_13305 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13304, (int) (((long) 0))));
				BgL_siza7eza7_13306 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13304, (int) (((long) 1))));
				BgL_i1247z00_13307 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13304, (int) (((long) 2))));
				BgL_bodyz00_13308 = PROCEDURE_REF(BgL_envz00_13304, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13309 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13304, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15693;

					BgL_bpz00_15693 = VECTOR_REF(((obj_t) BgL_sz00_13310), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15694;

						BgL_valza2za2_15694 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13310,
							BgL_bpz00_15693, BgL_ifreesz00_13305);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15695;

							BgL_runz00_15695 =
								MAKE_FX_PROCEDURE(BGl_z62run4522z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_15695,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13306));
							PROCEDURE_SET(BgL_runz00_15695,
								(int) (((long) 1)), BgL_valza2za2_15694);
							PROCEDURE_SET(BgL_runz00_15695,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13307));
							PROCEDURE_SET(BgL_runz00_15695,
								(int) (((long) 3)), BgL_bodyz00_13308);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15696;

								BgL_mainz00_15696 =
									MAKE_FX_PROCEDURE(BGl_z62main4521z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_15696,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13306));
								PROCEDURE_SET(BgL_mainz00_15696,
									(int) (((long) 1)), BgL_valza2za2_15694);
								PROCEDURE_SET(BgL_mainz00_15696,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13307));
								PROCEDURE_SET(BgL_mainz00_15696,
									(int) (((long) 3)), BgL_bodyz00_13308);
								PROCEDURE_SET(BgL_mainz00_15696,
									(int) (((long) 4)), BgL_runz00_15695);
								PROCEDURE_SET(BgL_mainz00_15696,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13309));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15697;

									BgL_objz00_15697 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15695, BgL_objz00_15697);
									BgL_objz00_15697;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3778z00_15698;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3779z00_15699;

										BgL_arg3779z00_15699 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13307))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15700;

											BgL_newz00_15700 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27117;

												BgL_tmpz00_27117 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15700, BgL_tmpz00_27117,
													BgL_arg3779z00_15699);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27122;
												int BgL_tmpz00_27120;

												BgL_auxz00_27122 = BINT(BgL_siza7ezd2framez75_13309);
												BgL_tmpz00_27120 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15700, BgL_tmpz00_27120,
													BgL_auxz00_27122);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27125;

												BgL_tmpz00_27125 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15700, BgL_tmpz00_27125,
													BgL_runz00_15695);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27130;
												int BgL_tmpz00_27128;

												BgL_auxz00_27130 = BINT(((long) 3));
												BgL_tmpz00_27128 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15700, BgL_tmpz00_27128,
													BgL_auxz00_27130);
											}
											BgL_arg3778z00_15698 = BgL_newz00_15700;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15696, BgL_arg3778z00_15698);
									BgL_arg3778z00_15698;
								}
								return BgL_mainz00_15696;
							}
						}
					}
				}
			}
		}

	}



/* &main4521 */
	obj_t BGl_z62main4521z62zz__evaluate_compz00(obj_t BgL_envz00_13311,
		obj_t BgL_bz00_13318, obj_t BgL_cz00_13319, obj_t BgL_dz00_13320)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13316;
				long BgL_siza7ezd2framez75_13317;

				BgL_runz00_13316 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13311, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13317 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13311, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15701;

					BgL_sz00_15701 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15702;

						BgL_bpz00_15702 = VECTOR_REF(((obj_t) BgL_sz00_15701), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15702) + BgL_siza7ezd2framez75_13317) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15701))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3782z00_15703;

									BgL_arg3782z00_15703 =
										((long) CINT(BgL_bpz00_15702) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15701), BgL_arg3782z00_15703,
										BgL_bz00_13318);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3783z00_15704;

									BgL_arg3783z00_15704 =
										((long) CINT(BgL_bpz00_15702) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15701), BgL_arg3783z00_15704,
										BgL_cz00_13319);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3784z00_15705;

									BgL_arg3784z00_15705 =
										((long) CINT(BgL_bpz00_15702) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15701), BgL_arg3784z00_15705,
										BgL_dz00_13320);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15706;

									BgL_ez00_15706 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15706,
										BgL_bpz00_15702);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15707;

										BgL_accz00_15707 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13316, BgL_sz00_15701, BgL_bpz00_15702);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15706);
										VECTOR_SET(
											((obj_t) BgL_sz00_15701), ((long) 0), BgL_bpz00_15702);
										return BgL_accz00_15707;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15708;

								BgL_nsz00_15708 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15708, ((long) 1), BgL_sz00_15701);
								VECTOR_SET(BgL_nsz00_15708, ((long) 2), BgL_bz00_13318);
								VECTOR_SET(BgL_nsz00_15708, ((long) 3), BgL_cz00_13319);
								VECTOR_SET(BgL_nsz00_15708, ((long) 4), BgL_dz00_13320);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15709;

									BgL_z12denvz12_15709 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15709, BgL_nsz00_15708);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15710;

										BgL_ez00_15710 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15710,
											BgL_sz00_15701);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15711;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15712;

												BgL_savedzd2bpzd2_15712 =
													VECTOR_REF(BgL_nsz00_15708, ((long) 0));
												VECTOR_SET(BgL_nsz00_15708, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15714;

													BgL_fz00_15714 = BgL_runz00_13316;
												BgL_recz00_15713:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15715;

														BgL_rz00_15715 =
															PROCEDURE_ENTRY(BgL_fz00_15714) (BgL_fz00_15714,
															BgL_nsz00_15708, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5424z00_27183;

															if (PROCEDUREP(BgL_rz00_15715))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15716;

																	BgL_arg1729z00_15716 =
																		PROCEDURE_ATTR(BgL_rz00_15715);
																	if (STRUCTP(BgL_arg1729z00_15716))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5424z00_27183 =
																				(STRUCT_KEY(BgL_arg1729z00_15716) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5424z00_27183 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5424z00_27183 = ((bool_t) 0);
																}
															if (BgL_test5424z00_27183)
																{
																	obj_t BgL_fz00_27191;

																	BgL_fz00_27191 = BgL_rz00_15715;
																	BgL_fz00_15714 = BgL_fz00_27191;
																	goto BgL_recz00_15713;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15708, ((long) 0),
																		BgL_savedzd2bpzd2_15712);
																	BgL_____rz00_15711 = BgL_rz00_15715;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15710);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15709, BgL_sz00_15701);
											return BgL_____rz00_15711;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4522 */
	obj_t BGl_z62run4522z62zz__evaluate_compz00(obj_t BgL_envz00_13321,
		obj_t BgL_sz00_13326)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13322;
				obj_t BgL_valza2za2_13323;
				BgL_ev_absz00_bglt BgL_i1247z00_13324;
				obj_t BgL_bodyz00_13325;

				BgL_siza7eza7_13322 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13321, (int) (((long) 0))));
				BgL_valza2za2_13323 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13321, (int) (((long) 1))));
				BgL_i1247z00_13324 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13321, (int) (((long) 2))));
				BgL_bodyz00_13325 = PROCEDURE_REF(BgL_envz00_13321, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15717;

					BgL_bpz00_15717 = VECTOR_REF(((obj_t) BgL_sz00_13326), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13326,
						BgL_valza2za2_13323,
						((long) CINT(BgL_bpz00_15717) + BgL_siza7eza7_13322));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15718;
						obj_t BgL_wherez00_15719;
						obj_t BgL_locz00_15720;

						BgL_z12denvz12_15718 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15719 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13324))->
							BgL_wherez00);
						BgL_locz00_15720 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13324))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15718, BgL_wherez00_15719,
								BgL_locz00_15720);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15721;

								BgL_za2za2resza2za2z00_15721 =
									PROCEDURE_ENTRY(BgL_bodyz00_13325) (BgL_bodyz00_13325,
									BgL_sz00_13326, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15718);
								return BgL_za2za2resza2za2z00_15721;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3787> */
	obj_t BGl_z62zc3z04anonymousza33787ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13327, obj_t BgL_sz00_13334)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13328;
				obj_t BgL_iboxesz00_13329;
				long BgL_siza7eza7_13330;
				BgL_ev_absz00_bglt BgL_i1247z00_13331;
				obj_t BgL_bodyz00_13332;
				long BgL_siza7ezd2framez75_13333;

				BgL_ifreesz00_13328 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13327, (int) (((long) 0))));
				BgL_iboxesz00_13329 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13327, (int) (((long) 1))));
				BgL_siza7eza7_13330 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13327, (int) (((long) 2))));
				BgL_i1247z00_13331 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13327, (int) (((long) 3))));
				BgL_bodyz00_13332 = PROCEDURE_REF(BgL_envz00_13327, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13333 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13327, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15722;

					BgL_bpz00_15722 = VECTOR_REF(((obj_t) BgL_sz00_13334), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15723;

						BgL_valza2za2_15723 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13334,
							BgL_bpz00_15722, BgL_ifreesz00_13328);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15724;

							BgL_runz00_15724 =
								MAKE_FX_PROCEDURE(BGl_z62run4524z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_15724,
								(int) (((long) 0)), BgL_iboxesz00_13329);
							PROCEDURE_SET(BgL_runz00_15724,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13330));
							PROCEDURE_SET(BgL_runz00_15724,
								(int) (((long) 2)), BgL_valza2za2_15723);
							PROCEDURE_SET(BgL_runz00_15724,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13331));
							PROCEDURE_SET(BgL_runz00_15724,
								(int) (((long) 4)), BgL_bodyz00_13332);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15725;

								BgL_mainz00_15725 =
									MAKE_FX_PROCEDURE(BGl_z62main4523z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_15725,
									(int) (((long) 0)), BgL_iboxesz00_13329);
								PROCEDURE_SET(BgL_mainz00_15725,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13330));
								PROCEDURE_SET(BgL_mainz00_15725,
									(int) (((long) 2)), BgL_valza2za2_15723);
								PROCEDURE_SET(BgL_mainz00_15725,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13331));
								PROCEDURE_SET(BgL_mainz00_15725,
									(int) (((long) 4)), BgL_bodyz00_13332);
								PROCEDURE_SET(BgL_mainz00_15725,
									(int) (((long) 5)), BgL_runz00_15724);
								PROCEDURE_SET(BgL_mainz00_15725,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13333));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15726;

									BgL_objz00_15726 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15724, BgL_objz00_15726);
									BgL_objz00_15726;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3788z00_15727;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3789z00_15728;

										BgL_arg3789z00_15728 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13331))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15729;

											BgL_newz00_15729 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27279;

												BgL_tmpz00_27279 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15729, BgL_tmpz00_27279,
													BgL_arg3789z00_15728);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27284;
												int BgL_tmpz00_27282;

												BgL_auxz00_27284 = BINT(BgL_siza7ezd2framez75_13333);
												BgL_tmpz00_27282 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15729, BgL_tmpz00_27282,
													BgL_auxz00_27284);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27287;

												BgL_tmpz00_27287 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15729, BgL_tmpz00_27287,
													BgL_runz00_15724);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27292;
												int BgL_tmpz00_27290;

												BgL_auxz00_27292 = BINT(((long) 3));
												BgL_tmpz00_27290 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15729, BgL_tmpz00_27290,
													BgL_auxz00_27292);
											}
											BgL_arg3788z00_15727 = BgL_newz00_15729;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15725, BgL_arg3788z00_15727);
									BgL_arg3788z00_15727;
								}
								return BgL_mainz00_15725;
							}
						}
					}
				}
			}
		}

	}



/* &main4523 */
	obj_t BGl_z62main4523z62zz__evaluate_compz00(obj_t BgL_envz00_13335,
		obj_t BgL_bz00_13343, obj_t BgL_cz00_13344, obj_t BgL_dz00_13345)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13341;
				long BgL_siza7ezd2framez75_13342;

				BgL_runz00_13341 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13335, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13342 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13335, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15730;

					BgL_sz00_15730 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15731;

						BgL_bpz00_15731 = VECTOR_REF(((obj_t) BgL_sz00_15730), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15731) + BgL_siza7ezd2framez75_13342) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15730))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3792z00_15732;

									BgL_arg3792z00_15732 =
										((long) CINT(BgL_bpz00_15731) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15730), BgL_arg3792z00_15732,
										BgL_bz00_13343);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3793z00_15733;

									BgL_arg3793z00_15733 =
										((long) CINT(BgL_bpz00_15731) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15730), BgL_arg3793z00_15733,
										BgL_cz00_13344);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3794z00_15734;

									BgL_arg3794z00_15734 =
										((long) CINT(BgL_bpz00_15731) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15730), BgL_arg3794z00_15734,
										BgL_dz00_13345);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15735;

									BgL_ez00_15735 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15735,
										BgL_bpz00_15731);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15736;

										BgL_accz00_15736 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13341, BgL_sz00_15730, BgL_bpz00_15731);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15735);
										VECTOR_SET(
											((obj_t) BgL_sz00_15730), ((long) 0), BgL_bpz00_15731);
										return BgL_accz00_15736;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15737;

								BgL_nsz00_15737 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15737, ((long) 1), BgL_sz00_15730);
								VECTOR_SET(BgL_nsz00_15737, ((long) 2), BgL_bz00_13343);
								VECTOR_SET(BgL_nsz00_15737, ((long) 3), BgL_cz00_13344);
								VECTOR_SET(BgL_nsz00_15737, ((long) 4), BgL_dz00_13345);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15738;

									BgL_z12denvz12_15738 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15738, BgL_nsz00_15737);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15739;

										BgL_ez00_15739 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15739,
											BgL_sz00_15730);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15740;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15741;

												BgL_savedzd2bpzd2_15741 =
													VECTOR_REF(BgL_nsz00_15737, ((long) 0));
												VECTOR_SET(BgL_nsz00_15737, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15743;

													BgL_fz00_15743 = BgL_runz00_13341;
												BgL_recz00_15742:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15744;

														BgL_rz00_15744 =
															PROCEDURE_ENTRY(BgL_fz00_15743) (BgL_fz00_15743,
															BgL_nsz00_15737, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5428z00_27345;

															if (PROCEDUREP(BgL_rz00_15744))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15745;

																	BgL_arg1729z00_15745 =
																		PROCEDURE_ATTR(BgL_rz00_15744);
																	if (STRUCTP(BgL_arg1729z00_15745))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5428z00_27345 =
																				(STRUCT_KEY(BgL_arg1729z00_15745) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5428z00_27345 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5428z00_27345 = ((bool_t) 0);
																}
															if (BgL_test5428z00_27345)
																{
																	obj_t BgL_fz00_27353;

																	BgL_fz00_27353 = BgL_rz00_15744;
																	BgL_fz00_15743 = BgL_fz00_27353;
																	goto BgL_recz00_15742;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15737, ((long) 0),
																		BgL_savedzd2bpzd2_15741);
																	BgL_____rz00_15740 = BgL_rz00_15744;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15739);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15738, BgL_sz00_15730);
											return BgL_____rz00_15740;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4524 */
	obj_t BGl_z62run4524z62zz__evaluate_compz00(obj_t BgL_envz00_13346,
		obj_t BgL_sz00_13352)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13347;
				long BgL_siza7eza7_13348;
				obj_t BgL_valza2za2_13349;
				BgL_ev_absz00_bglt BgL_i1247z00_13350;
				obj_t BgL_bodyz00_13351;

				BgL_iboxesz00_13347 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13346, (int) (((long) 0))));
				BgL_siza7eza7_13348 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13346, (int) (((long) 1))));
				BgL_valza2za2_13349 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13346, (int) (((long) 2))));
				BgL_i1247z00_13350 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13346, (int) (((long) 3))));
				BgL_bodyz00_13351 = PROCEDURE_REF(BgL_envz00_13346, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15746;

					BgL_bpz00_15746 = VECTOR_REF(((obj_t) BgL_sz00_13352), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13352,
						BgL_iboxesz00_13347, BgL_bpz00_15746);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13352,
						BgL_valza2za2_13349,
						((long) CINT(BgL_bpz00_15746) + BgL_siza7eza7_13348));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15747;
						obj_t BgL_wherez00_15748;
						obj_t BgL_locz00_15749;

						BgL_z12denvz12_15747 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15748 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13350))->
							BgL_wherez00);
						BgL_locz00_15749 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13350))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15747, BgL_wherez00_15748,
								BgL_locz00_15749);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15750;

								BgL_za2za2resza2za2z00_15750 =
									PROCEDURE_ENTRY(BgL_bodyz00_13351) (BgL_bodyz00_13351,
									BgL_sz00_13352, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15747);
								return BgL_za2za2resza2za2z00_15750;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3709> */
	obj_t BGl_z62zc3z04anonymousza33709ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13353, obj_t BgL_sz00_13357)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13354;
				obj_t BgL_bodyz00_13355;
				long BgL_siza7ezd2framez75_13356;

				BgL_i1247z00_13354 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13353, (int) (((long) 0))));
				BgL_bodyz00_13355 = PROCEDURE_REF(BgL_envz00_13353, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13356 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13353, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15751;

					BgL_bpz00_15751 = VECTOR_REF(((obj_t) BgL_sz00_13357), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15752;

							BgL_runz00_15752 =
								MAKE_FX_PROCEDURE(BGl_z62run4526z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_15752,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13354));
							PROCEDURE_SET(BgL_runz00_15752,
								(int) (((long) 1)), BgL_bodyz00_13355);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15753;

								BgL_mainz00_15753 =
									MAKE_VA_PROCEDURE(BGl_z62main4525z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_15753,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13354));
								PROCEDURE_SET(BgL_mainz00_15753,
									(int) (((long) 1)), BgL_bodyz00_13355);
								PROCEDURE_SET(BgL_mainz00_15753,
									(int) (((long) 2)), BgL_runz00_15752);
								PROCEDURE_SET(BgL_mainz00_15753,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13356));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15754;

									BgL_objz00_15754 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15752, BgL_objz00_15754);
									BgL_objz00_15754;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3710z00_15755;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3711z00_15756;

										BgL_arg3711z00_15756 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13354))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15757;

											BgL_newz00_15757 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27421;

												BgL_tmpz00_27421 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15757, BgL_tmpz00_27421,
													BgL_arg3711z00_15756);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27426;
												int BgL_tmpz00_27424;

												BgL_auxz00_27426 = BINT(BgL_siza7ezd2framez75_13356);
												BgL_tmpz00_27424 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15757, BgL_tmpz00_27424,
													BgL_auxz00_27426);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27429;

												BgL_tmpz00_27429 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15757, BgL_tmpz00_27429,
													BgL_runz00_15752);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27434;
												int BgL_tmpz00_27432;

												BgL_auxz00_27434 = BINT(((long) -3));
												BgL_tmpz00_27432 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15757, BgL_tmpz00_27432,
													BgL_auxz00_27434);
											}
											BgL_arg3710z00_15755 = BgL_newz00_15757;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15753, BgL_arg3710z00_15755);
									BgL_arg3710z00_15755;
								}
								return BgL_mainz00_15753;
							}
						}
					}
				}
			}
		}

	}



/* &main4525 */
	obj_t BGl_z62main4525z62zz__evaluate_compz00(obj_t BgL_envz00_13358,
		obj_t BgL_cz00_13363, obj_t BgL_dz00_13364, obj_t BgL_lastz00_13365)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13361;
				long BgL_siza7ezd2framez75_13362;

				BgL_runz00_13361 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13358, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13362 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13358, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15758;

					BgL_sz00_15758 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15759;

						BgL_bpz00_15759 = VECTOR_REF(((obj_t) BgL_sz00_15758), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15759) + BgL_siza7ezd2framez75_13362) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15758))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3714z00_15760;

									BgL_arg3714z00_15760 =
										((long) CINT(BgL_bpz00_15759) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15758), BgL_arg3714z00_15760,
										BgL_cz00_13363);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3715z00_15761;

									BgL_arg3715z00_15761 =
										((long) CINT(BgL_bpz00_15759) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15758), BgL_arg3715z00_15761,
										BgL_dz00_13364);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3716z00_15762;

									BgL_arg3716z00_15762 =
										((long) CINT(BgL_bpz00_15759) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15758), BgL_arg3716z00_15762,
										BgL_lastz00_13365);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15763;

									BgL_ez00_15763 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15763,
										BgL_bpz00_15759);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15764;

										BgL_accz00_15764 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13361, BgL_sz00_15758, BgL_bpz00_15759);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15763);
										VECTOR_SET(
											((obj_t) BgL_sz00_15758), ((long) 0), BgL_bpz00_15759);
										return BgL_accz00_15764;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15765;

								BgL_nsz00_15765 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15765, ((long) 1), BgL_sz00_15758);
								VECTOR_SET(BgL_nsz00_15765, ((long) 2), BgL_cz00_13363);
								VECTOR_SET(BgL_nsz00_15765, ((long) 3), BgL_dz00_13364);
								VECTOR_SET(BgL_nsz00_15765, ((long) 4), BgL_lastz00_13365);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15766;

									BgL_z12denvz12_15766 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15766, BgL_nsz00_15765);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15767;

										BgL_ez00_15767 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15767,
											BgL_sz00_15758);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15768;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15769;

												BgL_savedzd2bpzd2_15769 =
													VECTOR_REF(BgL_nsz00_15765, ((long) 0));
												VECTOR_SET(BgL_nsz00_15765, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15771;

													BgL_fz00_15771 = BgL_runz00_13361;
												BgL_recz00_15770:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15772;

														BgL_rz00_15772 =
															PROCEDURE_ENTRY(BgL_fz00_15771) (BgL_fz00_15771,
															BgL_nsz00_15765, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5432z00_27487;

															if (PROCEDUREP(BgL_rz00_15772))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15773;

																	BgL_arg1729z00_15773 =
																		PROCEDURE_ATTR(BgL_rz00_15772);
																	if (STRUCTP(BgL_arg1729z00_15773))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5432z00_27487 =
																				(STRUCT_KEY(BgL_arg1729z00_15773) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5432z00_27487 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5432z00_27487 = ((bool_t) 0);
																}
															if (BgL_test5432z00_27487)
																{
																	obj_t BgL_fz00_27495;

																	BgL_fz00_27495 = BgL_rz00_15772;
																	BgL_fz00_15771 = BgL_fz00_27495;
																	goto BgL_recz00_15770;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15765, ((long) 0),
																		BgL_savedzd2bpzd2_15769);
																	BgL_____rz00_15768 = BgL_rz00_15772;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15767);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15766, BgL_sz00_15758);
											return BgL_____rz00_15768;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4526 */
	obj_t BGl_z62run4526z62zz__evaluate_compz00(obj_t BgL_envz00_13366,
		obj_t BgL_sz00_13369)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13367;
				obj_t BgL_bodyz00_13368;

				BgL_i1247z00_13367 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13366, (int) (((long) 0))));
				BgL_bodyz00_13368 = PROCEDURE_REF(BgL_envz00_13366, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15774;

					BgL_bpz00_15774 = VECTOR_REF(((obj_t) BgL_sz00_13369), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15775;
						obj_t BgL_wherez00_15776;
						obj_t BgL_locz00_15777;

						BgL_z12denvz12_15775 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15776 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13367))->
							BgL_wherez00);
						BgL_locz00_15777 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13367))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15775, BgL_wherez00_15776,
								BgL_locz00_15777);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15778;

								BgL_za2za2resza2za2z00_15778 =
									PROCEDURE_ENTRY(BgL_bodyz00_13368) (BgL_bodyz00_13368,
									BgL_sz00_13369, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15775);
								return BgL_za2za2resza2za2z00_15778;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3718> */
	obj_t BGl_z62zc3z04anonymousza33718ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13370, obj_t BgL_sz00_13375)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13371;
				BgL_ev_absz00_bglt BgL_i1247z00_13372;
				obj_t BgL_bodyz00_13373;
				long BgL_siza7ezd2framez75_13374;

				BgL_iboxesz00_13371 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13370, (int) (((long) 0))));
				BgL_i1247z00_13372 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13370, (int) (((long) 1))));
				BgL_bodyz00_13373 = PROCEDURE_REF(BgL_envz00_13370, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13374 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13370, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15779;

					BgL_bpz00_15779 = VECTOR_REF(((obj_t) BgL_sz00_13375), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15780;

							BgL_runz00_15780 =
								MAKE_FX_PROCEDURE(BGl_z62run4528z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_15780,
								(int) (((long) 0)), BgL_iboxesz00_13371);
							PROCEDURE_SET(BgL_runz00_15780,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13372));
							PROCEDURE_SET(BgL_runz00_15780,
								(int) (((long) 2)), BgL_bodyz00_13373);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15781;

								BgL_mainz00_15781 =
									MAKE_VA_PROCEDURE(BGl_z62main4527z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_15781,
									(int) (((long) 0)), BgL_iboxesz00_13371);
								PROCEDURE_SET(BgL_mainz00_15781,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13372));
								PROCEDURE_SET(BgL_mainz00_15781,
									(int) (((long) 2)), BgL_bodyz00_13373);
								PROCEDURE_SET(BgL_mainz00_15781,
									(int) (((long) 3)), BgL_runz00_15780);
								PROCEDURE_SET(BgL_mainz00_15781,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13374));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15782;

									BgL_objz00_15782 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15780, BgL_objz00_15782);
									BgL_objz00_15782;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3719z00_15783;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3720z00_15784;

										BgL_arg3720z00_15784 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13372))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15785;

											BgL_newz00_15785 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27557;

												BgL_tmpz00_27557 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15785, BgL_tmpz00_27557,
													BgL_arg3720z00_15784);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27562;
												int BgL_tmpz00_27560;

												BgL_auxz00_27562 = BINT(BgL_siza7ezd2framez75_13374);
												BgL_tmpz00_27560 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15785, BgL_tmpz00_27560,
													BgL_auxz00_27562);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27565;

												BgL_tmpz00_27565 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15785, BgL_tmpz00_27565,
													BgL_runz00_15780);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27570;
												int BgL_tmpz00_27568;

												BgL_auxz00_27570 = BINT(((long) -3));
												BgL_tmpz00_27568 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15785, BgL_tmpz00_27568,
													BgL_auxz00_27570);
											}
											BgL_arg3719z00_15783 = BgL_newz00_15785;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15781, BgL_arg3719z00_15783);
									BgL_arg3719z00_15783;
								}
								return BgL_mainz00_15781;
							}
						}
					}
				}
			}
		}

	}



/* &main4527 */
	obj_t BGl_z62main4527z62zz__evaluate_compz00(obj_t BgL_envz00_13376,
		obj_t BgL_cz00_13382, obj_t BgL_dz00_13383, obj_t BgL_lastz00_13384)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13380;
				long BgL_siza7ezd2framez75_13381;

				BgL_runz00_13380 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13376, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13381 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13376, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15786;

					BgL_sz00_15786 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15787;

						BgL_bpz00_15787 = VECTOR_REF(((obj_t) BgL_sz00_15786), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15787) + BgL_siza7ezd2framez75_13381) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15786))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3723z00_15788;

									BgL_arg3723z00_15788 =
										((long) CINT(BgL_bpz00_15787) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15786), BgL_arg3723z00_15788,
										BgL_cz00_13382);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3724z00_15789;

									BgL_arg3724z00_15789 =
										((long) CINT(BgL_bpz00_15787) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15786), BgL_arg3724z00_15789,
										BgL_dz00_13383);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3725z00_15790;

									BgL_arg3725z00_15790 =
										((long) CINT(BgL_bpz00_15787) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15786), BgL_arg3725z00_15790,
										BgL_lastz00_13384);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15791;

									BgL_ez00_15791 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15791,
										BgL_bpz00_15787);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15792;

										BgL_accz00_15792 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13380, BgL_sz00_15786, BgL_bpz00_15787);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15791);
										VECTOR_SET(
											((obj_t) BgL_sz00_15786), ((long) 0), BgL_bpz00_15787);
										return BgL_accz00_15792;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15793;

								BgL_nsz00_15793 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15793, ((long) 1), BgL_sz00_15786);
								VECTOR_SET(BgL_nsz00_15793, ((long) 2), BgL_cz00_13382);
								VECTOR_SET(BgL_nsz00_15793, ((long) 3), BgL_dz00_13383);
								VECTOR_SET(BgL_nsz00_15793, ((long) 4), BgL_lastz00_13384);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15794;

									BgL_z12denvz12_15794 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15794, BgL_nsz00_15793);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15795;

										BgL_ez00_15795 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15795,
											BgL_sz00_15786);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15796;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15797;

												BgL_savedzd2bpzd2_15797 =
													VECTOR_REF(BgL_nsz00_15793, ((long) 0));
												VECTOR_SET(BgL_nsz00_15793, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15799;

													BgL_fz00_15799 = BgL_runz00_13380;
												BgL_recz00_15798:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15800;

														BgL_rz00_15800 =
															PROCEDURE_ENTRY(BgL_fz00_15799) (BgL_fz00_15799,
															BgL_nsz00_15793, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5436z00_27623;

															if (PROCEDUREP(BgL_rz00_15800))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15801;

																	BgL_arg1729z00_15801 =
																		PROCEDURE_ATTR(BgL_rz00_15800);
																	if (STRUCTP(BgL_arg1729z00_15801))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5436z00_27623 =
																				(STRUCT_KEY(BgL_arg1729z00_15801) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5436z00_27623 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5436z00_27623 = ((bool_t) 0);
																}
															if (BgL_test5436z00_27623)
																{
																	obj_t BgL_fz00_27631;

																	BgL_fz00_27631 = BgL_rz00_15800;
																	BgL_fz00_15799 = BgL_fz00_27631;
																	goto BgL_recz00_15798;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15793, ((long) 0),
																		BgL_savedzd2bpzd2_15797);
																	BgL_____rz00_15796 = BgL_rz00_15800;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15795);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15794, BgL_sz00_15786);
											return BgL_____rz00_15796;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4528 */
	obj_t BGl_z62run4528z62zz__evaluate_compz00(obj_t BgL_envz00_13385,
		obj_t BgL_sz00_13389)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13386;
				BgL_ev_absz00_bglt BgL_i1247z00_13387;
				obj_t BgL_bodyz00_13388;

				BgL_iboxesz00_13386 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13385, (int) (((long) 0))));
				BgL_i1247z00_13387 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13385, (int) (((long) 1))));
				BgL_bodyz00_13388 = PROCEDURE_REF(BgL_envz00_13385, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15802;

					BgL_bpz00_15802 = VECTOR_REF(((obj_t) BgL_sz00_13389), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13389,
						BgL_iboxesz00_13386, BgL_bpz00_15802);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15803;
						obj_t BgL_wherez00_15804;
						obj_t BgL_locz00_15805;

						BgL_z12denvz12_15803 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15804 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13387))->
							BgL_wherez00);
						BgL_locz00_15805 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13387))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15803, BgL_wherez00_15804,
								BgL_locz00_15805);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15806;

								BgL_za2za2resza2za2z00_15806 =
									PROCEDURE_ENTRY(BgL_bodyz00_13388) (BgL_bodyz00_13388,
									BgL_sz00_13389, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15803);
								return BgL_za2za2resza2za2z00_15806;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3730> */
	obj_t BGl_z62zc3z04anonymousza33730ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13390, obj_t BgL_sz00_13396)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13391;
				long BgL_siza7eza7_13392;
				BgL_ev_absz00_bglt BgL_i1247z00_13393;
				obj_t BgL_bodyz00_13394;
				long BgL_siza7ezd2framez75_13395;

				BgL_ifreesz00_13391 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13390, (int) (((long) 0))));
				BgL_siza7eza7_13392 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13390, (int) (((long) 1))));
				BgL_i1247z00_13393 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13390, (int) (((long) 2))));
				BgL_bodyz00_13394 = PROCEDURE_REF(BgL_envz00_13390, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13395 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13390, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15807;

					BgL_bpz00_15807 = VECTOR_REF(((obj_t) BgL_sz00_13396), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15808;

						BgL_valza2za2_15808 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13396,
							BgL_bpz00_15807, BgL_ifreesz00_13391);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15809;

							BgL_runz00_15809 =
								MAKE_FX_PROCEDURE(BGl_z62run4530z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_15809,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13392));
							PROCEDURE_SET(BgL_runz00_15809,
								(int) (((long) 1)), BgL_valza2za2_15808);
							PROCEDURE_SET(BgL_runz00_15809,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13393));
							PROCEDURE_SET(BgL_runz00_15809,
								(int) (((long) 3)), BgL_bodyz00_13394);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15810;

								BgL_mainz00_15810 =
									MAKE_VA_PROCEDURE(BGl_z62main4529z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_15810,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13392));
								PROCEDURE_SET(BgL_mainz00_15810,
									(int) (((long) 1)), BgL_valza2za2_15808);
								PROCEDURE_SET(BgL_mainz00_15810,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13393));
								PROCEDURE_SET(BgL_mainz00_15810,
									(int) (((long) 3)), BgL_bodyz00_13394);
								PROCEDURE_SET(BgL_mainz00_15810,
									(int) (((long) 4)), BgL_runz00_15809);
								PROCEDURE_SET(BgL_mainz00_15810,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13395));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15811;

									BgL_objz00_15811 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15809, BgL_objz00_15811);
									BgL_objz00_15811;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3731z00_15812;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3732z00_15813;

										BgL_arg3732z00_15813 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13393))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15814;

											BgL_newz00_15814 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27707;

												BgL_tmpz00_27707 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15814, BgL_tmpz00_27707,
													BgL_arg3732z00_15813);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27712;
												int BgL_tmpz00_27710;

												BgL_auxz00_27712 = BINT(BgL_siza7ezd2framez75_13395);
												BgL_tmpz00_27710 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15814, BgL_tmpz00_27710,
													BgL_auxz00_27712);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27715;

												BgL_tmpz00_27715 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15814, BgL_tmpz00_27715,
													BgL_runz00_15809);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27720;
												int BgL_tmpz00_27718;

												BgL_auxz00_27720 = BINT(((long) -3));
												BgL_tmpz00_27718 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15814, BgL_tmpz00_27718,
													BgL_auxz00_27720);
											}
											BgL_arg3731z00_15812 = BgL_newz00_15814;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15810, BgL_arg3731z00_15812);
									BgL_arg3731z00_15812;
								}
								return BgL_mainz00_15810;
							}
						}
					}
				}
			}
		}

	}



/* &main4529 */
	obj_t BGl_z62main4529z62zz__evaluate_compz00(obj_t BgL_envz00_13397,
		obj_t BgL_cz00_13404, obj_t BgL_dz00_13405, obj_t BgL_lastz00_13406)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13402;
				long BgL_siza7ezd2framez75_13403;

				BgL_runz00_13402 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13397, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13403 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13397, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15815;

					BgL_sz00_15815 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15816;

						BgL_bpz00_15816 = VECTOR_REF(((obj_t) BgL_sz00_15815), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15816) + BgL_siza7ezd2framez75_13403) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15815))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3735z00_15817;

									BgL_arg3735z00_15817 =
										((long) CINT(BgL_bpz00_15816) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15815), BgL_arg3735z00_15817,
										BgL_cz00_13404);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3736z00_15818;

									BgL_arg3736z00_15818 =
										((long) CINT(BgL_bpz00_15816) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15815), BgL_arg3736z00_15818,
										BgL_dz00_13405);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3737z00_15819;

									BgL_arg3737z00_15819 =
										((long) CINT(BgL_bpz00_15816) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15815), BgL_arg3737z00_15819,
										BgL_lastz00_13406);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15820;

									BgL_ez00_15820 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15820,
										BgL_bpz00_15816);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15821;

										BgL_accz00_15821 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13402, BgL_sz00_15815, BgL_bpz00_15816);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15820);
										VECTOR_SET(
											((obj_t) BgL_sz00_15815), ((long) 0), BgL_bpz00_15816);
										return BgL_accz00_15821;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15822;

								BgL_nsz00_15822 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15822, ((long) 1), BgL_sz00_15815);
								VECTOR_SET(BgL_nsz00_15822, ((long) 2), BgL_cz00_13404);
								VECTOR_SET(BgL_nsz00_15822, ((long) 3), BgL_dz00_13405);
								VECTOR_SET(BgL_nsz00_15822, ((long) 4), BgL_lastz00_13406);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15823;

									BgL_z12denvz12_15823 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15823, BgL_nsz00_15822);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15824;

										BgL_ez00_15824 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15824,
											BgL_sz00_15815);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15825;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15826;

												BgL_savedzd2bpzd2_15826 =
													VECTOR_REF(BgL_nsz00_15822, ((long) 0));
												VECTOR_SET(BgL_nsz00_15822, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15828;

													BgL_fz00_15828 = BgL_runz00_13402;
												BgL_recz00_15827:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15829;

														BgL_rz00_15829 =
															PROCEDURE_ENTRY(BgL_fz00_15828) (BgL_fz00_15828,
															BgL_nsz00_15822, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5440z00_27773;

															if (PROCEDUREP(BgL_rz00_15829))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15830;

																	BgL_arg1729z00_15830 =
																		PROCEDURE_ATTR(BgL_rz00_15829);
																	if (STRUCTP(BgL_arg1729z00_15830))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5440z00_27773 =
																				(STRUCT_KEY(BgL_arg1729z00_15830) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5440z00_27773 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5440z00_27773 = ((bool_t) 0);
																}
															if (BgL_test5440z00_27773)
																{
																	obj_t BgL_fz00_27781;

																	BgL_fz00_27781 = BgL_rz00_15829;
																	BgL_fz00_15828 = BgL_fz00_27781;
																	goto BgL_recz00_15827;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15822, ((long) 0),
																		BgL_savedzd2bpzd2_15826);
																	BgL_____rz00_15825 = BgL_rz00_15829;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15824);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15823, BgL_sz00_15815);
											return BgL_____rz00_15825;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4530 */
	obj_t BGl_z62run4530z62zz__evaluate_compz00(obj_t BgL_envz00_13407,
		obj_t BgL_sz00_13412)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13408;
				obj_t BgL_valza2za2_13409;
				BgL_ev_absz00_bglt BgL_i1247z00_13410;
				obj_t BgL_bodyz00_13411;

				BgL_siza7eza7_13408 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13407, (int) (((long) 0))));
				BgL_valza2za2_13409 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13407, (int) (((long) 1))));
				BgL_i1247z00_13410 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13407, (int) (((long) 2))));
				BgL_bodyz00_13411 = PROCEDURE_REF(BgL_envz00_13407, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15831;

					BgL_bpz00_15831 = VECTOR_REF(((obj_t) BgL_sz00_13412), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13412,
						BgL_valza2za2_13409,
						((long) CINT(BgL_bpz00_15831) + BgL_siza7eza7_13408));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15832;
						obj_t BgL_wherez00_15833;
						obj_t BgL_locz00_15834;

						BgL_z12denvz12_15832 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15833 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13410))->
							BgL_wherez00);
						BgL_locz00_15834 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13410))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15832, BgL_wherez00_15833,
								BgL_locz00_15834);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15835;

								BgL_za2za2resza2za2z00_15835 =
									PROCEDURE_ENTRY(BgL_bodyz00_13411) (BgL_bodyz00_13411,
									BgL_sz00_13412, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15832);
								return BgL_za2za2resza2za2z00_15835;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3740> */
	obj_t BGl_z62zc3z04anonymousza33740ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13413, obj_t BgL_sz00_13420)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13414;
				obj_t BgL_iboxesz00_13415;
				long BgL_siza7eza7_13416;
				BgL_ev_absz00_bglt BgL_i1247z00_13417;
				obj_t BgL_bodyz00_13418;
				long BgL_siza7ezd2framez75_13419;

				BgL_ifreesz00_13414 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13413, (int) (((long) 0))));
				BgL_iboxesz00_13415 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13413, (int) (((long) 1))));
				BgL_siza7eza7_13416 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13413, (int) (((long) 2))));
				BgL_i1247z00_13417 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13413, (int) (((long) 3))));
				BgL_bodyz00_13418 = PROCEDURE_REF(BgL_envz00_13413, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13419 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13413, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15836;

					BgL_bpz00_15836 = VECTOR_REF(((obj_t) BgL_sz00_13420), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15837;

						BgL_valza2za2_15837 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13420,
							BgL_bpz00_15836, BgL_ifreesz00_13414);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15838;

							BgL_runz00_15838 =
								MAKE_FX_PROCEDURE(BGl_z62run4532z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_15838,
								(int) (((long) 0)), BgL_iboxesz00_13415);
							PROCEDURE_SET(BgL_runz00_15838,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13416));
							PROCEDURE_SET(BgL_runz00_15838,
								(int) (((long) 2)), BgL_valza2za2_15837);
							PROCEDURE_SET(BgL_runz00_15838,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13417));
							PROCEDURE_SET(BgL_runz00_15838,
								(int) (((long) 4)), BgL_bodyz00_13418);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15839;

								BgL_mainz00_15839 =
									MAKE_VA_PROCEDURE(BGl_z62main4531z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_15839,
									(int) (((long) 0)), BgL_iboxesz00_13415);
								PROCEDURE_SET(BgL_mainz00_15839,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13416));
								PROCEDURE_SET(BgL_mainz00_15839,
									(int) (((long) 2)), BgL_valza2za2_15837);
								PROCEDURE_SET(BgL_mainz00_15839,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13417));
								PROCEDURE_SET(BgL_mainz00_15839,
									(int) (((long) 4)), BgL_bodyz00_13418);
								PROCEDURE_SET(BgL_mainz00_15839,
									(int) (((long) 5)), BgL_runz00_15838);
								PROCEDURE_SET(BgL_mainz00_15839,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13419));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15840;

									BgL_objz00_15840 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15838, BgL_objz00_15840);
									BgL_objz00_15840;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3741z00_15841;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3742z00_15842;

										BgL_arg3742z00_15842 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13417))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15843;

											BgL_newz00_15843 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27869;

												BgL_tmpz00_27869 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15843, BgL_tmpz00_27869,
													BgL_arg3742z00_15842);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27874;
												int BgL_tmpz00_27872;

												BgL_auxz00_27874 = BINT(BgL_siza7ezd2framez75_13419);
												BgL_tmpz00_27872 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15843, BgL_tmpz00_27872,
													BgL_auxz00_27874);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27877;

												BgL_tmpz00_27877 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15843, BgL_tmpz00_27877,
													BgL_runz00_15838);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27882;
												int BgL_tmpz00_27880;

												BgL_auxz00_27882 = BINT(((long) -3));
												BgL_tmpz00_27880 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15843, BgL_tmpz00_27880,
													BgL_auxz00_27882);
											}
											BgL_arg3741z00_15841 = BgL_newz00_15843;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15839, BgL_arg3741z00_15841);
									BgL_arg3741z00_15841;
								}
								return BgL_mainz00_15839;
							}
						}
					}
				}
			}
		}

	}



/* &main4531 */
	obj_t BGl_z62main4531z62zz__evaluate_compz00(obj_t BgL_envz00_13421,
		obj_t BgL_cz00_13429, obj_t BgL_dz00_13430, obj_t BgL_lastz00_13431)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13427;
				long BgL_siza7ezd2framez75_13428;

				BgL_runz00_13427 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13421, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13428 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13421, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15844;

					BgL_sz00_15844 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15845;

						BgL_bpz00_15845 = VECTOR_REF(((obj_t) BgL_sz00_15844), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15845) + BgL_siza7ezd2framez75_13428) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15844))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3745z00_15846;

									BgL_arg3745z00_15846 =
										((long) CINT(BgL_bpz00_15845) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15844), BgL_arg3745z00_15846,
										BgL_cz00_13429);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3746z00_15847;

									BgL_arg3746z00_15847 =
										((long) CINT(BgL_bpz00_15845) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15844), BgL_arg3746z00_15847,
										BgL_dz00_13430);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3747z00_15848;

									BgL_arg3747z00_15848 =
										((long) CINT(BgL_bpz00_15845) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_15844), BgL_arg3747z00_15848,
										BgL_lastz00_13431);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15849;

									BgL_ez00_15849 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15849,
										BgL_bpz00_15845);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15850;

										BgL_accz00_15850 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13427, BgL_sz00_15844, BgL_bpz00_15845);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15849);
										VECTOR_SET(
											((obj_t) BgL_sz00_15844), ((long) 0), BgL_bpz00_15845);
										return BgL_accz00_15850;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15851;

								BgL_nsz00_15851 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15851, ((long) 1), BgL_sz00_15844);
								VECTOR_SET(BgL_nsz00_15851, ((long) 2), BgL_cz00_13429);
								VECTOR_SET(BgL_nsz00_15851, ((long) 3), BgL_dz00_13430);
								VECTOR_SET(BgL_nsz00_15851, ((long) 4), BgL_lastz00_13431);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15852;

									BgL_z12denvz12_15852 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15852, BgL_nsz00_15851);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15853;

										BgL_ez00_15853 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15853,
											BgL_sz00_15844);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15854;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15855;

												BgL_savedzd2bpzd2_15855 =
													VECTOR_REF(BgL_nsz00_15851, ((long) 0));
												VECTOR_SET(BgL_nsz00_15851, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15857;

													BgL_fz00_15857 = BgL_runz00_13427;
												BgL_recz00_15856:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15858;

														BgL_rz00_15858 =
															PROCEDURE_ENTRY(BgL_fz00_15857) (BgL_fz00_15857,
															BgL_nsz00_15851, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5444z00_27935;

															if (PROCEDUREP(BgL_rz00_15858))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15859;

																	BgL_arg1729z00_15859 =
																		PROCEDURE_ATTR(BgL_rz00_15858);
																	if (STRUCTP(BgL_arg1729z00_15859))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5444z00_27935 =
																				(STRUCT_KEY(BgL_arg1729z00_15859) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5444z00_27935 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5444z00_27935 = ((bool_t) 0);
																}
															if (BgL_test5444z00_27935)
																{
																	obj_t BgL_fz00_27943;

																	BgL_fz00_27943 = BgL_rz00_15858;
																	BgL_fz00_15857 = BgL_fz00_27943;
																	goto BgL_recz00_15856;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15851, ((long) 0),
																		BgL_savedzd2bpzd2_15855);
																	BgL_____rz00_15854 = BgL_rz00_15858;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15853);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15852, BgL_sz00_15844);
											return BgL_____rz00_15854;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4532 */
	obj_t BGl_z62run4532z62zz__evaluate_compz00(obj_t BgL_envz00_13432,
		obj_t BgL_sz00_13438)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13433;
				long BgL_siza7eza7_13434;
				obj_t BgL_valza2za2_13435;
				BgL_ev_absz00_bglt BgL_i1247z00_13436;
				obj_t BgL_bodyz00_13437;

				BgL_iboxesz00_13433 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13432, (int) (((long) 0))));
				BgL_siza7eza7_13434 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13432, (int) (((long) 1))));
				BgL_valza2za2_13435 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13432, (int) (((long) 2))));
				BgL_i1247z00_13436 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13432, (int) (((long) 3))));
				BgL_bodyz00_13437 = PROCEDURE_REF(BgL_envz00_13432, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15860;

					BgL_bpz00_15860 = VECTOR_REF(((obj_t) BgL_sz00_13438), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13438,
						BgL_iboxesz00_13433, BgL_bpz00_15860);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13438,
						BgL_valza2za2_13435,
						((long) CINT(BgL_bpz00_15860) + BgL_siza7eza7_13434));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15861;
						obj_t BgL_wherez00_15862;
						obj_t BgL_locz00_15863;

						BgL_z12denvz12_15861 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15862 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13436))->
							BgL_wherez00);
						BgL_locz00_15863 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13436))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15861, BgL_wherez00_15862,
								BgL_locz00_15863);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15864;

								BgL_za2za2resza2za2z00_15864 =
									PROCEDURE_ENTRY(BgL_bodyz00_13437) (BgL_bodyz00_13437,
									BgL_sz00_13438, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15861);
								return BgL_za2za2resza2za2z00_15864;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3663> */
	obj_t BGl_z62zc3z04anonymousza33663ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13439, obj_t BgL_sz00_13443)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13440;
				obj_t BgL_bodyz00_13441;
				long BgL_siza7ezd2framez75_13442;

				BgL_i1247z00_13440 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13439, (int) (((long) 0))));
				BgL_bodyz00_13441 = PROCEDURE_REF(BgL_envz00_13439, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13442 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13439, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15865;

					BgL_bpz00_15865 = VECTOR_REF(((obj_t) BgL_sz00_13443), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15866;

							BgL_runz00_15866 =
								MAKE_FX_PROCEDURE(BGl_z62run4534z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_15866,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13440));
							PROCEDURE_SET(BgL_runz00_15866,
								(int) (((long) 1)), BgL_bodyz00_13441);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15867;

								BgL_mainz00_15867 =
									MAKE_FX_PROCEDURE(BGl_z62main4533z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_15867,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13440));
								PROCEDURE_SET(BgL_mainz00_15867,
									(int) (((long) 1)), BgL_bodyz00_13441);
								PROCEDURE_SET(BgL_mainz00_15867,
									(int) (((long) 2)), BgL_runz00_15866);
								PROCEDURE_SET(BgL_mainz00_15867,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13442));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15868;

									BgL_objz00_15868 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15866, BgL_objz00_15868);
									BgL_objz00_15868;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3664z00_15869;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3665z00_15870;

										BgL_arg3665z00_15870 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13440))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15871;

											BgL_newz00_15871 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28011;

												BgL_tmpz00_28011 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15871, BgL_tmpz00_28011,
													BgL_arg3665z00_15870);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28016;
												int BgL_tmpz00_28014;

												BgL_auxz00_28016 = BINT(BgL_siza7ezd2framez75_13442);
												BgL_tmpz00_28014 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15871, BgL_tmpz00_28014,
													BgL_auxz00_28016);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28019;

												BgL_tmpz00_28019 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15871, BgL_tmpz00_28019,
													BgL_runz00_15866);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28024;
												int BgL_tmpz00_28022;

												BgL_auxz00_28024 = BINT(((long) 2));
												BgL_tmpz00_28022 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15871, BgL_tmpz00_28022,
													BgL_auxz00_28024);
											}
											BgL_arg3664z00_15869 = BgL_newz00_15871;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15867, BgL_arg3664z00_15869);
									BgL_arg3664z00_15869;
								}
								return BgL_mainz00_15867;
							}
						}
					}
				}
			}
		}

	}



/* &main4533 */
	obj_t BGl_z62main4533z62zz__evaluate_compz00(obj_t BgL_envz00_13444,
		obj_t BgL_cz00_13449, obj_t BgL_dz00_13450)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13447;
				long BgL_siza7ezd2framez75_13448;

				BgL_runz00_13447 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13444, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13448 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13444, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15872;

					BgL_sz00_15872 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15873;

						BgL_bpz00_15873 = VECTOR_REF(((obj_t) BgL_sz00_15872), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15873) + BgL_siza7ezd2framez75_13448) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15872))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3668z00_15874;

									BgL_arg3668z00_15874 =
										((long) CINT(BgL_bpz00_15873) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15872), BgL_arg3668z00_15874,
										BgL_cz00_13449);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3670z00_15875;

									BgL_arg3670z00_15875 =
										((long) CINT(BgL_bpz00_15873) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15872), BgL_arg3670z00_15875,
										BgL_dz00_13450);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15876;

									BgL_ez00_15876 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15876,
										BgL_bpz00_15873);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15877;

										BgL_accz00_15877 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13447, BgL_sz00_15872, BgL_bpz00_15873);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15876);
										VECTOR_SET(
											((obj_t) BgL_sz00_15872), ((long) 0), BgL_bpz00_15873);
										return BgL_accz00_15877;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15878;

								BgL_nsz00_15878 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15878, ((long) 1), BgL_sz00_15872);
								VECTOR_SET(BgL_nsz00_15878, ((long) 2), BgL_cz00_13449);
								VECTOR_SET(BgL_nsz00_15878, ((long) 3), BgL_dz00_13450);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15879;

									BgL_z12denvz12_15879 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15879, BgL_nsz00_15878);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15880;

										BgL_ez00_15880 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15880,
											BgL_sz00_15872);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15881;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15882;

												BgL_savedzd2bpzd2_15882 =
													VECTOR_REF(BgL_nsz00_15878, ((long) 0));
												VECTOR_SET(BgL_nsz00_15878, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15884;

													BgL_fz00_15884 = BgL_runz00_13447;
												BgL_recz00_15883:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15885;

														BgL_rz00_15885 =
															PROCEDURE_ENTRY(BgL_fz00_15884) (BgL_fz00_15884,
															BgL_nsz00_15878, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5448z00_28072;

															if (PROCEDUREP(BgL_rz00_15885))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15886;

																	BgL_arg1729z00_15886 =
																		PROCEDURE_ATTR(BgL_rz00_15885);
																	if (STRUCTP(BgL_arg1729z00_15886))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5448z00_28072 =
																				(STRUCT_KEY(BgL_arg1729z00_15886) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5448z00_28072 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5448z00_28072 = ((bool_t) 0);
																}
															if (BgL_test5448z00_28072)
																{
																	obj_t BgL_fz00_28080;

																	BgL_fz00_28080 = BgL_rz00_15885;
																	BgL_fz00_15884 = BgL_fz00_28080;
																	goto BgL_recz00_15883;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15878, ((long) 0),
																		BgL_savedzd2bpzd2_15882);
																	BgL_____rz00_15881 = BgL_rz00_15885;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15880);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15879, BgL_sz00_15872);
											return BgL_____rz00_15881;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4534 */
	obj_t BGl_z62run4534z62zz__evaluate_compz00(obj_t BgL_envz00_13451,
		obj_t BgL_sz00_13454)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13452;
				obj_t BgL_bodyz00_13453;

				BgL_i1247z00_13452 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13451, (int) (((long) 0))));
				BgL_bodyz00_13453 = PROCEDURE_REF(BgL_envz00_13451, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15887;

					BgL_bpz00_15887 = VECTOR_REF(((obj_t) BgL_sz00_13454), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15888;
						obj_t BgL_wherez00_15889;
						obj_t BgL_locz00_15890;

						BgL_z12denvz12_15888 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15889 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13452))->
							BgL_wherez00);
						BgL_locz00_15890 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13452))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15888, BgL_wherez00_15889,
								BgL_locz00_15890);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15891;

								BgL_za2za2resza2za2z00_15891 =
									PROCEDURE_ENTRY(BgL_bodyz00_13453) (BgL_bodyz00_13453,
									BgL_sz00_13454, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15888);
								return BgL_za2za2resza2za2z00_15891;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3672> */
	obj_t BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13455, obj_t BgL_sz00_13460)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13456;
				BgL_ev_absz00_bglt BgL_i1247z00_13457;
				obj_t BgL_bodyz00_13458;
				long BgL_siza7ezd2framez75_13459;

				BgL_iboxesz00_13456 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13455, (int) (((long) 0))));
				BgL_i1247z00_13457 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13455, (int) (((long) 1))));
				BgL_bodyz00_13458 = PROCEDURE_REF(BgL_envz00_13455, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13459 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13455, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15892;

					BgL_bpz00_15892 = VECTOR_REF(((obj_t) BgL_sz00_13460), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15893;

							BgL_runz00_15893 =
								MAKE_FX_PROCEDURE(BGl_z62run4536z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_15893,
								(int) (((long) 0)), BgL_iboxesz00_13456);
							PROCEDURE_SET(BgL_runz00_15893,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13457));
							PROCEDURE_SET(BgL_runz00_15893,
								(int) (((long) 2)), BgL_bodyz00_13458);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15894;

								BgL_mainz00_15894 =
									MAKE_FX_PROCEDURE(BGl_z62main4535z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_15894,
									(int) (((long) 0)), BgL_iboxesz00_13456);
								PROCEDURE_SET(BgL_mainz00_15894,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13457));
								PROCEDURE_SET(BgL_mainz00_15894,
									(int) (((long) 2)), BgL_bodyz00_13458);
								PROCEDURE_SET(BgL_mainz00_15894,
									(int) (((long) 3)), BgL_runz00_15893);
								PROCEDURE_SET(BgL_mainz00_15894,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13459));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15895;

									BgL_objz00_15895 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15893, BgL_objz00_15895);
									BgL_objz00_15895;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3673z00_15896;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3674z00_15897;

										BgL_arg3674z00_15897 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13457))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15898;

											BgL_newz00_15898 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28142;

												BgL_tmpz00_28142 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15898, BgL_tmpz00_28142,
													BgL_arg3674z00_15897);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28147;
												int BgL_tmpz00_28145;

												BgL_auxz00_28147 = BINT(BgL_siza7ezd2framez75_13459);
												BgL_tmpz00_28145 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15898, BgL_tmpz00_28145,
													BgL_auxz00_28147);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28150;

												BgL_tmpz00_28150 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15898, BgL_tmpz00_28150,
													BgL_runz00_15893);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28155;
												int BgL_tmpz00_28153;

												BgL_auxz00_28155 = BINT(((long) 2));
												BgL_tmpz00_28153 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15898, BgL_tmpz00_28153,
													BgL_auxz00_28155);
											}
											BgL_arg3673z00_15896 = BgL_newz00_15898;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15894, BgL_arg3673z00_15896);
									BgL_arg3673z00_15896;
								}
								return BgL_mainz00_15894;
							}
						}
					}
				}
			}
		}

	}



/* &main4535 */
	obj_t BGl_z62main4535z62zz__evaluate_compz00(obj_t BgL_envz00_13461,
		obj_t BgL_cz00_13467, obj_t BgL_dz00_13468)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13465;
				long BgL_siza7ezd2framez75_13466;

				BgL_runz00_13465 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13461, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13466 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13461, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15899;

					BgL_sz00_15899 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15900;

						BgL_bpz00_15900 = VECTOR_REF(((obj_t) BgL_sz00_15899), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15900) + BgL_siza7ezd2framez75_13466) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15899))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3677z00_15901;

									BgL_arg3677z00_15901 =
										((long) CINT(BgL_bpz00_15900) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15899), BgL_arg3677z00_15901,
										BgL_cz00_13467);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3678z00_15902;

									BgL_arg3678z00_15902 =
										((long) CINT(BgL_bpz00_15900) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15899), BgL_arg3678z00_15902,
										BgL_dz00_13468);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15903;

									BgL_ez00_15903 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15903,
										BgL_bpz00_15900);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15904;

										BgL_accz00_15904 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13465, BgL_sz00_15899, BgL_bpz00_15900);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15903);
										VECTOR_SET(
											((obj_t) BgL_sz00_15899), ((long) 0), BgL_bpz00_15900);
										return BgL_accz00_15904;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15905;

								BgL_nsz00_15905 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15905, ((long) 1), BgL_sz00_15899);
								VECTOR_SET(BgL_nsz00_15905, ((long) 2), BgL_cz00_13467);
								VECTOR_SET(BgL_nsz00_15905, ((long) 3), BgL_dz00_13468);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15906;

									BgL_z12denvz12_15906 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15906, BgL_nsz00_15905);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15907;

										BgL_ez00_15907 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15907,
											BgL_sz00_15899);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15908;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15909;

												BgL_savedzd2bpzd2_15909 =
													VECTOR_REF(BgL_nsz00_15905, ((long) 0));
												VECTOR_SET(BgL_nsz00_15905, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15911;

													BgL_fz00_15911 = BgL_runz00_13465;
												BgL_recz00_15910:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15912;

														BgL_rz00_15912 =
															PROCEDURE_ENTRY(BgL_fz00_15911) (BgL_fz00_15911,
															BgL_nsz00_15905, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5452z00_28203;

															if (PROCEDUREP(BgL_rz00_15912))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15913;

																	BgL_arg1729z00_15913 =
																		PROCEDURE_ATTR(BgL_rz00_15912);
																	if (STRUCTP(BgL_arg1729z00_15913))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5452z00_28203 =
																				(STRUCT_KEY(BgL_arg1729z00_15913) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5452z00_28203 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5452z00_28203 = ((bool_t) 0);
																}
															if (BgL_test5452z00_28203)
																{
																	obj_t BgL_fz00_28211;

																	BgL_fz00_28211 = BgL_rz00_15912;
																	BgL_fz00_15911 = BgL_fz00_28211;
																	goto BgL_recz00_15910;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15905, ((long) 0),
																		BgL_savedzd2bpzd2_15909);
																	BgL_____rz00_15908 = BgL_rz00_15912;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15907);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15906, BgL_sz00_15899);
											return BgL_____rz00_15908;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4536 */
	obj_t BGl_z62run4536z62zz__evaluate_compz00(obj_t BgL_envz00_13469,
		obj_t BgL_sz00_13473)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13470;
				BgL_ev_absz00_bglt BgL_i1247z00_13471;
				obj_t BgL_bodyz00_13472;

				BgL_iboxesz00_13470 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13469, (int) (((long) 0))));
				BgL_i1247z00_13471 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13469, (int) (((long) 1))));
				BgL_bodyz00_13472 = PROCEDURE_REF(BgL_envz00_13469, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15914;

					BgL_bpz00_15914 = VECTOR_REF(((obj_t) BgL_sz00_13473), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13473,
						BgL_iboxesz00_13470, BgL_bpz00_15914);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15915;
						obj_t BgL_wherez00_15916;
						obj_t BgL_locz00_15917;

						BgL_z12denvz12_15915 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15916 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13471))->
							BgL_wherez00);
						BgL_locz00_15917 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13471))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15915, BgL_wherez00_15916,
								BgL_locz00_15917);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_15918;

								BgL_za2za2resza2za2z00_15918 =
									PROCEDURE_ENTRY(BgL_bodyz00_13472) (BgL_bodyz00_13472,
									BgL_sz00_13473, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15915);
								return BgL_za2za2resza2za2z00_15918;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3683> */
	obj_t BGl_z62zc3z04anonymousza33683ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13474, obj_t BgL_sz00_13480)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13475;
				long BgL_siza7eza7_13476;
				BgL_ev_absz00_bglt BgL_i1247z00_13477;
				obj_t BgL_bodyz00_13478;
				long BgL_siza7ezd2framez75_13479;

				BgL_ifreesz00_13475 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13474, (int) (((long) 0))));
				BgL_siza7eza7_13476 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13474, (int) (((long) 1))));
				BgL_i1247z00_13477 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13474, (int) (((long) 2))));
				BgL_bodyz00_13478 = PROCEDURE_REF(BgL_envz00_13474, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13479 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13474, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15919;

					BgL_bpz00_15919 = VECTOR_REF(((obj_t) BgL_sz00_13480), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15920;

						BgL_valza2za2_15920 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13480,
							BgL_bpz00_15919, BgL_ifreesz00_13475);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15921;

							BgL_runz00_15921 =
								MAKE_FX_PROCEDURE(BGl_z62run4538z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_15921,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13476));
							PROCEDURE_SET(BgL_runz00_15921,
								(int) (((long) 1)), BgL_valza2za2_15920);
							PROCEDURE_SET(BgL_runz00_15921,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13477));
							PROCEDURE_SET(BgL_runz00_15921,
								(int) (((long) 3)), BgL_bodyz00_13478);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15922;

								BgL_mainz00_15922 =
									MAKE_FX_PROCEDURE(BGl_z62main4537z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_15922,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13476));
								PROCEDURE_SET(BgL_mainz00_15922,
									(int) (((long) 1)), BgL_valza2za2_15920);
								PROCEDURE_SET(BgL_mainz00_15922,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13477));
								PROCEDURE_SET(BgL_mainz00_15922,
									(int) (((long) 3)), BgL_bodyz00_13478);
								PROCEDURE_SET(BgL_mainz00_15922,
									(int) (((long) 4)), BgL_runz00_15921);
								PROCEDURE_SET(BgL_mainz00_15922,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13479));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15923;

									BgL_objz00_15923 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15921, BgL_objz00_15923);
									BgL_objz00_15923;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3684z00_15924;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3685z00_15925;

										BgL_arg3685z00_15925 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13477))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15926;

											BgL_newz00_15926 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28287;

												BgL_tmpz00_28287 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15926, BgL_tmpz00_28287,
													BgL_arg3685z00_15925);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28292;
												int BgL_tmpz00_28290;

												BgL_auxz00_28292 = BINT(BgL_siza7ezd2framez75_13479);
												BgL_tmpz00_28290 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15926, BgL_tmpz00_28290,
													BgL_auxz00_28292);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28295;

												BgL_tmpz00_28295 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15926, BgL_tmpz00_28295,
													BgL_runz00_15921);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28300;
												int BgL_tmpz00_28298;

												BgL_auxz00_28300 = BINT(((long) 2));
												BgL_tmpz00_28298 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15926, BgL_tmpz00_28298,
													BgL_auxz00_28300);
											}
											BgL_arg3684z00_15924 = BgL_newz00_15926;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15922, BgL_arg3684z00_15924);
									BgL_arg3684z00_15924;
								}
								return BgL_mainz00_15922;
							}
						}
					}
				}
			}
		}

	}



/* &main4537 */
	obj_t BGl_z62main4537z62zz__evaluate_compz00(obj_t BgL_envz00_13481,
		obj_t BgL_cz00_13488, obj_t BgL_dz00_13489)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13486;
				long BgL_siza7ezd2framez75_13487;

				BgL_runz00_13486 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13481, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13487 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13481, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15927;

					BgL_sz00_15927 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15928;

						BgL_bpz00_15928 = VECTOR_REF(((obj_t) BgL_sz00_15927), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15928) + BgL_siza7ezd2framez75_13487) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15927))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3688z00_15929;

									BgL_arg3688z00_15929 =
										((long) CINT(BgL_bpz00_15928) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15927), BgL_arg3688z00_15929,
										BgL_cz00_13488);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3689z00_15930;

									BgL_arg3689z00_15930 =
										((long) CINT(BgL_bpz00_15928) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15927), BgL_arg3689z00_15930,
										BgL_dz00_13489);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15931;

									BgL_ez00_15931 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15931,
										BgL_bpz00_15928);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15932;

										BgL_accz00_15932 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13486, BgL_sz00_15927, BgL_bpz00_15928);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15931);
										VECTOR_SET(
											((obj_t) BgL_sz00_15927), ((long) 0), BgL_bpz00_15928);
										return BgL_accz00_15932;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15933;

								BgL_nsz00_15933 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15933, ((long) 1), BgL_sz00_15927);
								VECTOR_SET(BgL_nsz00_15933, ((long) 2), BgL_cz00_13488);
								VECTOR_SET(BgL_nsz00_15933, ((long) 3), BgL_dz00_13489);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15934;

									BgL_z12denvz12_15934 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15934, BgL_nsz00_15933);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15935;

										BgL_ez00_15935 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15935,
											BgL_sz00_15927);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15936;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15937;

												BgL_savedzd2bpzd2_15937 =
													VECTOR_REF(BgL_nsz00_15933, ((long) 0));
												VECTOR_SET(BgL_nsz00_15933, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15939;

													BgL_fz00_15939 = BgL_runz00_13486;
												BgL_recz00_15938:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15940;

														BgL_rz00_15940 =
															PROCEDURE_ENTRY(BgL_fz00_15939) (BgL_fz00_15939,
															BgL_nsz00_15933, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5456z00_28348;

															if (PROCEDUREP(BgL_rz00_15940))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15941;

																	BgL_arg1729z00_15941 =
																		PROCEDURE_ATTR(BgL_rz00_15940);
																	if (STRUCTP(BgL_arg1729z00_15941))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5456z00_28348 =
																				(STRUCT_KEY(BgL_arg1729z00_15941) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5456z00_28348 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5456z00_28348 = ((bool_t) 0);
																}
															if (BgL_test5456z00_28348)
																{
																	obj_t BgL_fz00_28356;

																	BgL_fz00_28356 = BgL_rz00_15940;
																	BgL_fz00_15939 = BgL_fz00_28356;
																	goto BgL_recz00_15938;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15933, ((long) 0),
																		BgL_savedzd2bpzd2_15937);
																	BgL_____rz00_15936 = BgL_rz00_15940;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15935);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15934, BgL_sz00_15927);
											return BgL_____rz00_15936;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4538 */
	obj_t BGl_z62run4538z62zz__evaluate_compz00(obj_t BgL_envz00_13490,
		obj_t BgL_sz00_13495)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13491;
				obj_t BgL_valza2za2_13492;
				BgL_ev_absz00_bglt BgL_i1247z00_13493;
				obj_t BgL_bodyz00_13494;

				BgL_siza7eza7_13491 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13490, (int) (((long) 0))));
				BgL_valza2za2_13492 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13490, (int) (((long) 1))));
				BgL_i1247z00_13493 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13490, (int) (((long) 2))));
				BgL_bodyz00_13494 = PROCEDURE_REF(BgL_envz00_13490, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15942;

					BgL_bpz00_15942 = VECTOR_REF(((obj_t) BgL_sz00_13495), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13495,
						BgL_valza2za2_13492,
						((long) CINT(BgL_bpz00_15942) + BgL_siza7eza7_13491));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15943;
						obj_t BgL_wherez00_15944;
						obj_t BgL_locz00_15945;

						BgL_z12denvz12_15943 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15944 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13493))->
							BgL_wherez00);
						BgL_locz00_15945 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13493))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15943, BgL_wherez00_15944,
								BgL_locz00_15945);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15946;

								BgL_za2za2resza2za2z00_15946 =
									PROCEDURE_ENTRY(BgL_bodyz00_13494) (BgL_bodyz00_13494,
									BgL_sz00_13495, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15943);
								return BgL_za2za2resza2za2z00_15946;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3692> */
	obj_t BGl_z62zc3z04anonymousza33692ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13496, obj_t BgL_sz00_13503)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13497;
				obj_t BgL_iboxesz00_13498;
				long BgL_siza7eza7_13499;
				BgL_ev_absz00_bglt BgL_i1247z00_13500;
				obj_t BgL_bodyz00_13501;
				long BgL_siza7ezd2framez75_13502;

				BgL_ifreesz00_13497 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13496, (int) (((long) 0))));
				BgL_iboxesz00_13498 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13496, (int) (((long) 1))));
				BgL_siza7eza7_13499 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13496, (int) (((long) 2))));
				BgL_i1247z00_13500 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13496, (int) (((long) 3))));
				BgL_bodyz00_13501 = PROCEDURE_REF(BgL_envz00_13496, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13502 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13496, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15947;

					BgL_bpz00_15947 = VECTOR_REF(((obj_t) BgL_sz00_13503), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_15948;

						BgL_valza2za2_15948 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13503,
							BgL_bpz00_15947, BgL_ifreesz00_13497);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15949;

							BgL_runz00_15949 =
								MAKE_FX_PROCEDURE(BGl_z62run4540z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_15949,
								(int) (((long) 0)), BgL_iboxesz00_13498);
							PROCEDURE_SET(BgL_runz00_15949,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13499));
							PROCEDURE_SET(BgL_runz00_15949,
								(int) (((long) 2)), BgL_valza2za2_15948);
							PROCEDURE_SET(BgL_runz00_15949,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13500));
							PROCEDURE_SET(BgL_runz00_15949,
								(int) (((long) 4)), BgL_bodyz00_13501);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15950;

								BgL_mainz00_15950 =
									MAKE_FX_PROCEDURE(BGl_z62main4539z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_15950,
									(int) (((long) 0)), BgL_iboxesz00_13498);
								PROCEDURE_SET(BgL_mainz00_15950,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13499));
								PROCEDURE_SET(BgL_mainz00_15950,
									(int) (((long) 2)), BgL_valza2za2_15948);
								PROCEDURE_SET(BgL_mainz00_15950,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13500));
								PROCEDURE_SET(BgL_mainz00_15950,
									(int) (((long) 4)), BgL_bodyz00_13501);
								PROCEDURE_SET(BgL_mainz00_15950,
									(int) (((long) 5)), BgL_runz00_15949);
								PROCEDURE_SET(BgL_mainz00_15950,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13502));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15951;

									BgL_objz00_15951 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15949, BgL_objz00_15951);
									BgL_objz00_15951;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3694z00_15952;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3695z00_15953;

										BgL_arg3695z00_15953 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13500))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15954;

											BgL_newz00_15954 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28444;

												BgL_tmpz00_28444 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15954, BgL_tmpz00_28444,
													BgL_arg3695z00_15953);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28449;
												int BgL_tmpz00_28447;

												BgL_auxz00_28449 = BINT(BgL_siza7ezd2framez75_13502);
												BgL_tmpz00_28447 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15954, BgL_tmpz00_28447,
													BgL_auxz00_28449);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28452;

												BgL_tmpz00_28452 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15954, BgL_tmpz00_28452,
													BgL_runz00_15949);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28457;
												int BgL_tmpz00_28455;

												BgL_auxz00_28457 = BINT(((long) 2));
												BgL_tmpz00_28455 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15954, BgL_tmpz00_28455,
													BgL_auxz00_28457);
											}
											BgL_arg3694z00_15952 = BgL_newz00_15954;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15950, BgL_arg3694z00_15952);
									BgL_arg3694z00_15952;
								}
								return BgL_mainz00_15950;
							}
						}
					}
				}
			}
		}

	}



/* &main4539 */
	obj_t BGl_z62main4539z62zz__evaluate_compz00(obj_t BgL_envz00_13504,
		obj_t BgL_cz00_13512, obj_t BgL_dz00_13513)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13510;
				long BgL_siza7ezd2framez75_13511;

				BgL_runz00_13510 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13504, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13511 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13504, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15955;

					BgL_sz00_15955 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15956;

						BgL_bpz00_15956 = VECTOR_REF(((obj_t) BgL_sz00_15955), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15956) + BgL_siza7ezd2framez75_13511) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15955))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3698z00_15957;

									BgL_arg3698z00_15957 =
										((long) CINT(BgL_bpz00_15956) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15955), BgL_arg3698z00_15957,
										BgL_cz00_13512);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3699z00_15958;

									BgL_arg3699z00_15958 =
										((long) CINT(BgL_bpz00_15956) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15955), BgL_arg3699z00_15958,
										BgL_dz00_13513);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15959;

									BgL_ez00_15959 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15959,
										BgL_bpz00_15956);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15960;

										BgL_accz00_15960 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13510, BgL_sz00_15955, BgL_bpz00_15956);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15959);
										VECTOR_SET(
											((obj_t) BgL_sz00_15955), ((long) 0), BgL_bpz00_15956);
										return BgL_accz00_15960;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15961;

								BgL_nsz00_15961 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15961, ((long) 1), BgL_sz00_15955);
								VECTOR_SET(BgL_nsz00_15961, ((long) 2), BgL_cz00_13512);
								VECTOR_SET(BgL_nsz00_15961, ((long) 3), BgL_dz00_13513);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15962;

									BgL_z12denvz12_15962 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15962, BgL_nsz00_15961);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15963;

										BgL_ez00_15963 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15963,
											BgL_sz00_15955);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15964;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15965;

												BgL_savedzd2bpzd2_15965 =
													VECTOR_REF(BgL_nsz00_15961, ((long) 0));
												VECTOR_SET(BgL_nsz00_15961, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15967;

													BgL_fz00_15967 = BgL_runz00_13510;
												BgL_recz00_15966:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15968;

														BgL_rz00_15968 =
															PROCEDURE_ENTRY(BgL_fz00_15967) (BgL_fz00_15967,
															BgL_nsz00_15961, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5460z00_28505;

															if (PROCEDUREP(BgL_rz00_15968))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15969;

																	BgL_arg1729z00_15969 =
																		PROCEDURE_ATTR(BgL_rz00_15968);
																	if (STRUCTP(BgL_arg1729z00_15969))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5460z00_28505 =
																				(STRUCT_KEY(BgL_arg1729z00_15969) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5460z00_28505 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5460z00_28505 = ((bool_t) 0);
																}
															if (BgL_test5460z00_28505)
																{
																	obj_t BgL_fz00_28513;

																	BgL_fz00_28513 = BgL_rz00_15968;
																	BgL_fz00_15967 = BgL_fz00_28513;
																	goto BgL_recz00_15966;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15961, ((long) 0),
																		BgL_savedzd2bpzd2_15965);
																	BgL_____rz00_15964 = BgL_rz00_15968;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15963);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15962, BgL_sz00_15955);
											return BgL_____rz00_15964;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4540 */
	obj_t BGl_z62run4540z62zz__evaluate_compz00(obj_t BgL_envz00_13514,
		obj_t BgL_sz00_13520)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13515;
				long BgL_siza7eza7_13516;
				obj_t BgL_valza2za2_13517;
				BgL_ev_absz00_bglt BgL_i1247z00_13518;
				obj_t BgL_bodyz00_13519;

				BgL_iboxesz00_13515 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13514, (int) (((long) 0))));
				BgL_siza7eza7_13516 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13514, (int) (((long) 1))));
				BgL_valza2za2_13517 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13514, (int) (((long) 2))));
				BgL_i1247z00_13518 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13514, (int) (((long) 3))));
				BgL_bodyz00_13519 = PROCEDURE_REF(BgL_envz00_13514, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15970;

					BgL_bpz00_15970 = VECTOR_REF(((obj_t) BgL_sz00_13520), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13520,
						BgL_iboxesz00_13515, BgL_bpz00_15970);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13520,
						BgL_valza2za2_13517,
						((long) CINT(BgL_bpz00_15970) + BgL_siza7eza7_13516));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_15971;
						obj_t BgL_wherez00_15972;
						obj_t BgL_locz00_15973;

						BgL_z12denvz12_15971 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15972 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13518))->
							BgL_wherez00);
						BgL_locz00_15973 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13518))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15971, BgL_wherez00_15972,
								BgL_locz00_15973);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_15974;

								BgL_za2za2resza2za2z00_15974 =
									PROCEDURE_ENTRY(BgL_bodyz00_13519) (BgL_bodyz00_13519,
									BgL_sz00_13520, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15971);
								return BgL_za2za2resza2za2z00_15974;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3615> */
	obj_t BGl_z62zc3z04anonymousza33615ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13521, obj_t BgL_sz00_13525)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13522;
				obj_t BgL_bodyz00_13523;
				long BgL_siza7ezd2framez75_13524;

				BgL_i1247z00_13522 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13521, (int) (((long) 0))));
				BgL_bodyz00_13523 = PROCEDURE_REF(BgL_envz00_13521, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13524 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13521, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15975;

					BgL_bpz00_15975 = VECTOR_REF(((obj_t) BgL_sz00_13525), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_15976;

							BgL_runz00_15976 =
								MAKE_FX_PROCEDURE(BGl_z62run4542z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_15976,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13522));
							PROCEDURE_SET(BgL_runz00_15976,
								(int) (((long) 1)), BgL_bodyz00_13523);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_15977;

								BgL_mainz00_15977 =
									MAKE_VA_PROCEDURE(BGl_z62main4541z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_15977,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13522));
								PROCEDURE_SET(BgL_mainz00_15977,
									(int) (((long) 1)), BgL_bodyz00_13523);
								PROCEDURE_SET(BgL_mainz00_15977,
									(int) (((long) 2)), BgL_runz00_15976);
								PROCEDURE_SET(BgL_mainz00_15977,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13524));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_15978;

									BgL_objz00_15978 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_15976, BgL_objz00_15978);
									BgL_objz00_15978;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3616z00_15979;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3617z00_15980;

										BgL_arg3617z00_15980 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13522))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_15981;

											BgL_newz00_15981 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28581;

												BgL_tmpz00_28581 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_15981, BgL_tmpz00_28581,
													BgL_arg3617z00_15980);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28586;
												int BgL_tmpz00_28584;

												BgL_auxz00_28586 = BINT(BgL_siza7ezd2framez75_13524);
												BgL_tmpz00_28584 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_15981, BgL_tmpz00_28584,
													BgL_auxz00_28586);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28589;

												BgL_tmpz00_28589 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_15981, BgL_tmpz00_28589,
													BgL_runz00_15976);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28594;
												int BgL_tmpz00_28592;

												BgL_auxz00_28594 = BINT(((long) -2));
												BgL_tmpz00_28592 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_15981, BgL_tmpz00_28592,
													BgL_auxz00_28594);
											}
											BgL_arg3616z00_15979 = BgL_newz00_15981;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_15977, BgL_arg3616z00_15979);
									BgL_arg3616z00_15979;
								}
								return BgL_mainz00_15977;
							}
						}
					}
				}
			}
		}

	}



/* &main4541 */
	obj_t BGl_z62main4541z62zz__evaluate_compz00(obj_t BgL_envz00_13526,
		obj_t BgL_dz00_13531, obj_t BgL_lastz00_13532)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13529;
				long BgL_siza7ezd2framez75_13530;

				BgL_runz00_13529 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13526, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13530 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13526, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_15982;

					BgL_sz00_15982 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_15983;

						BgL_bpz00_15983 = VECTOR_REF(((obj_t) BgL_sz00_15982), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_15983) + BgL_siza7ezd2framez75_13530) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_15982))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3620z00_15984;

									BgL_arg3620z00_15984 =
										((long) CINT(BgL_bpz00_15983) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_15982), BgL_arg3620z00_15984,
										BgL_dz00_13531);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3622z00_15985;

									BgL_arg3622z00_15985 =
										((long) CINT(BgL_bpz00_15983) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_15982), BgL_arg3622z00_15985,
										BgL_lastz00_13532);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_15986;

									BgL_ez00_15986 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15986,
										BgL_bpz00_15983);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_15987;

										BgL_accz00_15987 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13529, BgL_sz00_15982, BgL_bpz00_15983);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_15986);
										VECTOR_SET(
											((obj_t) BgL_sz00_15982), ((long) 0), BgL_bpz00_15983);
										return BgL_accz00_15987;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_15988;

								BgL_nsz00_15988 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_15988, ((long) 1), BgL_sz00_15982);
								VECTOR_SET(BgL_nsz00_15988, ((long) 2), BgL_dz00_13531);
								VECTOR_SET(BgL_nsz00_15988, ((long) 3), BgL_lastz00_13532);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_15989;

									BgL_z12denvz12_15989 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15989, BgL_nsz00_15988);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_15990;

										BgL_ez00_15990 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_15990,
											BgL_sz00_15982);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_15991;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_15992;

												BgL_savedzd2bpzd2_15992 =
													VECTOR_REF(BgL_nsz00_15988, ((long) 0));
												VECTOR_SET(BgL_nsz00_15988, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_15994;

													BgL_fz00_15994 = BgL_runz00_13529;
												BgL_recz00_15993:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_15995;

														BgL_rz00_15995 =
															PROCEDURE_ENTRY(BgL_fz00_15994) (BgL_fz00_15994,
															BgL_nsz00_15988, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5464z00_28642;

															if (PROCEDUREP(BgL_rz00_15995))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_15996;

																	BgL_arg1729z00_15996 =
																		PROCEDURE_ATTR(BgL_rz00_15995);
																	if (STRUCTP(BgL_arg1729z00_15996))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5464z00_28642 =
																				(STRUCT_KEY(BgL_arg1729z00_15996) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5464z00_28642 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5464z00_28642 = ((bool_t) 0);
																}
															if (BgL_test5464z00_28642)
																{
																	obj_t BgL_fz00_28650;

																	BgL_fz00_28650 = BgL_rz00_15995;
																	BgL_fz00_15994 = BgL_fz00_28650;
																	goto BgL_recz00_15993;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_15988, ((long) 0),
																		BgL_savedzd2bpzd2_15992);
																	BgL_____rz00_15991 = BgL_rz00_15995;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_15990);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15989, BgL_sz00_15982);
											return BgL_____rz00_15991;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4542 */
	obj_t BGl_z62run4542z62zz__evaluate_compz00(obj_t BgL_envz00_13533,
		obj_t BgL_sz00_13536)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13534;
				obj_t BgL_bodyz00_13535;

				BgL_i1247z00_13534 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13533, (int) (((long) 0))));
				BgL_bodyz00_13535 = PROCEDURE_REF(BgL_envz00_13533, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_15997;

					BgL_bpz00_15997 = VECTOR_REF(((obj_t) BgL_sz00_13536), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_15998;
						obj_t BgL_wherez00_15999;
						obj_t BgL_locz00_16000;

						BgL_z12denvz12_15998 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_15999 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13534))->
							BgL_wherez00);
						BgL_locz00_16000 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13534))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_15998, BgL_wherez00_15999,
								BgL_locz00_16000);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16001;

								BgL_za2za2resza2za2z00_16001 =
									PROCEDURE_ENTRY(BgL_bodyz00_13535) (BgL_bodyz00_13535,
									BgL_sz00_13536, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_15998);
								return BgL_za2za2resza2za2z00_16001;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3624> */
	obj_t BGl_z62zc3z04anonymousza33624ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13537, obj_t BgL_sz00_13542)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13538;
				BgL_ev_absz00_bglt BgL_i1247z00_13539;
				obj_t BgL_bodyz00_13540;
				long BgL_siza7ezd2framez75_13541;

				BgL_iboxesz00_13538 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13537, (int) (((long) 0))));
				BgL_i1247z00_13539 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13537, (int) (((long) 1))));
				BgL_bodyz00_13540 = PROCEDURE_REF(BgL_envz00_13537, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13541 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13537, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16002;

					BgL_bpz00_16002 = VECTOR_REF(((obj_t) BgL_sz00_13542), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16003;

							BgL_runz00_16003 =
								MAKE_FX_PROCEDURE(BGl_z62run4544z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16003,
								(int) (((long) 0)), BgL_iboxesz00_13538);
							PROCEDURE_SET(BgL_runz00_16003,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13539));
							PROCEDURE_SET(BgL_runz00_16003,
								(int) (((long) 2)), BgL_bodyz00_13540);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16004;

								BgL_mainz00_16004 =
									MAKE_VA_PROCEDURE(BGl_z62main4543z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16004,
									(int) (((long) 0)), BgL_iboxesz00_13538);
								PROCEDURE_SET(BgL_mainz00_16004,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13539));
								PROCEDURE_SET(BgL_mainz00_16004,
									(int) (((long) 2)), BgL_bodyz00_13540);
								PROCEDURE_SET(BgL_mainz00_16004,
									(int) (((long) 3)), BgL_runz00_16003);
								PROCEDURE_SET(BgL_mainz00_16004,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13541));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16005;

									BgL_objz00_16005 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16003, BgL_objz00_16005);
									BgL_objz00_16005;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3625z00_16006;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3626z00_16007;

										BgL_arg3626z00_16007 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13539))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16008;

											BgL_newz00_16008 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28712;

												BgL_tmpz00_28712 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16008, BgL_tmpz00_28712,
													BgL_arg3626z00_16007);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28717;
												int BgL_tmpz00_28715;

												BgL_auxz00_28717 = BINT(BgL_siza7ezd2framez75_13541);
												BgL_tmpz00_28715 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16008, BgL_tmpz00_28715,
													BgL_auxz00_28717);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28720;

												BgL_tmpz00_28720 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16008, BgL_tmpz00_28720,
													BgL_runz00_16003);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28725;
												int BgL_tmpz00_28723;

												BgL_auxz00_28725 = BINT(((long) -2));
												BgL_tmpz00_28723 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16008, BgL_tmpz00_28723,
													BgL_auxz00_28725);
											}
											BgL_arg3625z00_16006 = BgL_newz00_16008;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16004, BgL_arg3625z00_16006);
									BgL_arg3625z00_16006;
								}
								return BgL_mainz00_16004;
							}
						}
					}
				}
			}
		}

	}



/* &main4543 */
	obj_t BGl_z62main4543z62zz__evaluate_compz00(obj_t BgL_envz00_13543,
		obj_t BgL_dz00_13549, obj_t BgL_lastz00_13550)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13547;
				long BgL_siza7ezd2framez75_13548;

				BgL_runz00_13547 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13543, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13548 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13543, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16009;

					BgL_sz00_16009 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16010;

						BgL_bpz00_16010 = VECTOR_REF(((obj_t) BgL_sz00_16009), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16010) + BgL_siza7ezd2framez75_13548) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16009))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3629z00_16011;

									BgL_arg3629z00_16011 =
										((long) CINT(BgL_bpz00_16010) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16009), BgL_arg3629z00_16011,
										BgL_dz00_13549);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3631z00_16012;

									BgL_arg3631z00_16012 =
										((long) CINT(BgL_bpz00_16010) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16009), BgL_arg3631z00_16012,
										BgL_lastz00_13550);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16013;

									BgL_ez00_16013 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16013,
										BgL_bpz00_16010);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16014;

										BgL_accz00_16014 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13547, BgL_sz00_16009, BgL_bpz00_16010);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16013);
										VECTOR_SET(
											((obj_t) BgL_sz00_16009), ((long) 0), BgL_bpz00_16010);
										return BgL_accz00_16014;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16015;

								BgL_nsz00_16015 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16015, ((long) 1), BgL_sz00_16009);
								VECTOR_SET(BgL_nsz00_16015, ((long) 2), BgL_dz00_13549);
								VECTOR_SET(BgL_nsz00_16015, ((long) 3), BgL_lastz00_13550);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16016;

									BgL_z12denvz12_16016 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16016, BgL_nsz00_16015);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16017;

										BgL_ez00_16017 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16017,
											BgL_sz00_16009);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16018;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16019;

												BgL_savedzd2bpzd2_16019 =
													VECTOR_REF(BgL_nsz00_16015, ((long) 0));
												VECTOR_SET(BgL_nsz00_16015, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16021;

													BgL_fz00_16021 = BgL_runz00_13547;
												BgL_recz00_16020:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16022;

														BgL_rz00_16022 =
															PROCEDURE_ENTRY(BgL_fz00_16021) (BgL_fz00_16021,
															BgL_nsz00_16015, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5468z00_28773;

															if (PROCEDUREP(BgL_rz00_16022))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16023;

																	BgL_arg1729z00_16023 =
																		PROCEDURE_ATTR(BgL_rz00_16022);
																	if (STRUCTP(BgL_arg1729z00_16023))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5468z00_28773 =
																				(STRUCT_KEY(BgL_arg1729z00_16023) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5468z00_28773 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5468z00_28773 = ((bool_t) 0);
																}
															if (BgL_test5468z00_28773)
																{
																	obj_t BgL_fz00_28781;

																	BgL_fz00_28781 = BgL_rz00_16022;
																	BgL_fz00_16021 = BgL_fz00_28781;
																	goto BgL_recz00_16020;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16015, ((long) 0),
																		BgL_savedzd2bpzd2_16019);
																	BgL_____rz00_16018 = BgL_rz00_16022;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16017);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16016, BgL_sz00_16009);
											return BgL_____rz00_16018;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4544 */
	obj_t BGl_z62run4544z62zz__evaluate_compz00(obj_t BgL_envz00_13551,
		obj_t BgL_sz00_13555)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13552;
				BgL_ev_absz00_bglt BgL_i1247z00_13553;
				obj_t BgL_bodyz00_13554;

				BgL_iboxesz00_13552 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13551, (int) (((long) 0))));
				BgL_i1247z00_13553 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13551, (int) (((long) 1))));
				BgL_bodyz00_13554 = PROCEDURE_REF(BgL_envz00_13551, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16024;

					BgL_bpz00_16024 = VECTOR_REF(((obj_t) BgL_sz00_13555), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13555,
						BgL_iboxesz00_13552, BgL_bpz00_16024);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16025;
						obj_t BgL_wherez00_16026;
						obj_t BgL_locz00_16027;

						BgL_z12denvz12_16025 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16026 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13553))->
							BgL_wherez00);
						BgL_locz00_16027 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13553))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16025, BgL_wherez00_16026,
								BgL_locz00_16027);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16028;

								BgL_za2za2resza2za2z00_16028 =
									PROCEDURE_ENTRY(BgL_bodyz00_13554) (BgL_bodyz00_13554,
									BgL_sz00_13555, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16025);
								return BgL_za2za2resza2za2z00_16028;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3636> */
	obj_t BGl_z62zc3z04anonymousza33636ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13556, obj_t BgL_sz00_13562)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13557;
				long BgL_siza7eza7_13558;
				BgL_ev_absz00_bglt BgL_i1247z00_13559;
				obj_t BgL_bodyz00_13560;
				long BgL_siza7ezd2framez75_13561;

				BgL_ifreesz00_13557 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13556, (int) (((long) 0))));
				BgL_siza7eza7_13558 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13556, (int) (((long) 1))));
				BgL_i1247z00_13559 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13556, (int) (((long) 2))));
				BgL_bodyz00_13560 = PROCEDURE_REF(BgL_envz00_13556, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13561 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13556, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16029;

					BgL_bpz00_16029 = VECTOR_REF(((obj_t) BgL_sz00_13562), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16030;

						BgL_valza2za2_16030 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13562,
							BgL_bpz00_16029, BgL_ifreesz00_13557);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16031;

							BgL_runz00_16031 =
								MAKE_FX_PROCEDURE(BGl_z62run4546z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16031,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13558));
							PROCEDURE_SET(BgL_runz00_16031,
								(int) (((long) 1)), BgL_valza2za2_16030);
							PROCEDURE_SET(BgL_runz00_16031,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13559));
							PROCEDURE_SET(BgL_runz00_16031,
								(int) (((long) 3)), BgL_bodyz00_13560);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16032;

								BgL_mainz00_16032 =
									MAKE_VA_PROCEDURE(BGl_z62main4545z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16032,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13558));
								PROCEDURE_SET(BgL_mainz00_16032,
									(int) (((long) 1)), BgL_valza2za2_16030);
								PROCEDURE_SET(BgL_mainz00_16032,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13559));
								PROCEDURE_SET(BgL_mainz00_16032,
									(int) (((long) 3)), BgL_bodyz00_13560);
								PROCEDURE_SET(BgL_mainz00_16032,
									(int) (((long) 4)), BgL_runz00_16031);
								PROCEDURE_SET(BgL_mainz00_16032,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13561));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16033;

									BgL_objz00_16033 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16031, BgL_objz00_16033);
									BgL_objz00_16033;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3637z00_16034;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3639z00_16035;

										BgL_arg3639z00_16035 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13559))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16036;

											BgL_newz00_16036 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28857;

												BgL_tmpz00_28857 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16036, BgL_tmpz00_28857,
													BgL_arg3639z00_16035);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28862;
												int BgL_tmpz00_28860;

												BgL_auxz00_28862 = BINT(BgL_siza7ezd2framez75_13561);
												BgL_tmpz00_28860 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16036, BgL_tmpz00_28860,
													BgL_auxz00_28862);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28865;

												BgL_tmpz00_28865 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16036, BgL_tmpz00_28865,
													BgL_runz00_16031);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28870;
												int BgL_tmpz00_28868;

												BgL_auxz00_28870 = BINT(((long) -2));
												BgL_tmpz00_28868 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16036, BgL_tmpz00_28868,
													BgL_auxz00_28870);
											}
											BgL_arg3637z00_16034 = BgL_newz00_16036;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16032, BgL_arg3637z00_16034);
									BgL_arg3637z00_16034;
								}
								return BgL_mainz00_16032;
							}
						}
					}
				}
			}
		}

	}



/* &main4545 */
	obj_t BGl_z62main4545z62zz__evaluate_compz00(obj_t BgL_envz00_13563,
		obj_t BgL_dz00_13570, obj_t BgL_lastz00_13571)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13568;
				long BgL_siza7ezd2framez75_13569;

				BgL_runz00_13568 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13563, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13569 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13563, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16037;

					BgL_sz00_16037 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16038;

						BgL_bpz00_16038 = VECTOR_REF(((obj_t) BgL_sz00_16037), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16038) + BgL_siza7ezd2framez75_13569) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16037))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3642z00_16039;

									BgL_arg3642z00_16039 =
										((long) CINT(BgL_bpz00_16038) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16037), BgL_arg3642z00_16039,
										BgL_dz00_13570);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3643z00_16040;

									BgL_arg3643z00_16040 =
										((long) CINT(BgL_bpz00_16038) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16037), BgL_arg3643z00_16040,
										BgL_lastz00_13571);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16041;

									BgL_ez00_16041 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16041,
										BgL_bpz00_16038);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16042;

										BgL_accz00_16042 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13568, BgL_sz00_16037, BgL_bpz00_16038);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16041);
										VECTOR_SET(
											((obj_t) BgL_sz00_16037), ((long) 0), BgL_bpz00_16038);
										return BgL_accz00_16042;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16043;

								BgL_nsz00_16043 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16043, ((long) 1), BgL_sz00_16037);
								VECTOR_SET(BgL_nsz00_16043, ((long) 2), BgL_dz00_13570);
								VECTOR_SET(BgL_nsz00_16043, ((long) 3), BgL_lastz00_13571);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16044;

									BgL_z12denvz12_16044 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16044, BgL_nsz00_16043);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16045;

										BgL_ez00_16045 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16045,
											BgL_sz00_16037);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16046;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16047;

												BgL_savedzd2bpzd2_16047 =
													VECTOR_REF(BgL_nsz00_16043, ((long) 0));
												VECTOR_SET(BgL_nsz00_16043, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16049;

													BgL_fz00_16049 = BgL_runz00_13568;
												BgL_recz00_16048:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16050;

														BgL_rz00_16050 =
															PROCEDURE_ENTRY(BgL_fz00_16049) (BgL_fz00_16049,
															BgL_nsz00_16043, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5472z00_28918;

															if (PROCEDUREP(BgL_rz00_16050))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16051;

																	BgL_arg1729z00_16051 =
																		PROCEDURE_ATTR(BgL_rz00_16050);
																	if (STRUCTP(BgL_arg1729z00_16051))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5472z00_28918 =
																				(STRUCT_KEY(BgL_arg1729z00_16051) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5472z00_28918 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5472z00_28918 = ((bool_t) 0);
																}
															if (BgL_test5472z00_28918)
																{
																	obj_t BgL_fz00_28926;

																	BgL_fz00_28926 = BgL_rz00_16050;
																	BgL_fz00_16049 = BgL_fz00_28926;
																	goto BgL_recz00_16048;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16043, ((long) 0),
																		BgL_savedzd2bpzd2_16047);
																	BgL_____rz00_16046 = BgL_rz00_16050;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16045);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16044, BgL_sz00_16037);
											return BgL_____rz00_16046;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4546 */
	obj_t BGl_z62run4546z62zz__evaluate_compz00(obj_t BgL_envz00_13572,
		obj_t BgL_sz00_13577)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13573;
				obj_t BgL_valza2za2_13574;
				BgL_ev_absz00_bglt BgL_i1247z00_13575;
				obj_t BgL_bodyz00_13576;

				BgL_siza7eza7_13573 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13572, (int) (((long) 0))));
				BgL_valza2za2_13574 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13572, (int) (((long) 1))));
				BgL_i1247z00_13575 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13572, (int) (((long) 2))));
				BgL_bodyz00_13576 = PROCEDURE_REF(BgL_envz00_13572, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16052;

					BgL_bpz00_16052 = VECTOR_REF(((obj_t) BgL_sz00_13577), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13577,
						BgL_valza2za2_13574,
						((long) CINT(BgL_bpz00_16052) + BgL_siza7eza7_13573));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16053;
						obj_t BgL_wherez00_16054;
						obj_t BgL_locz00_16055;

						BgL_z12denvz12_16053 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16054 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13575))->
							BgL_wherez00);
						BgL_locz00_16055 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13575))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16053, BgL_wherez00_16054,
								BgL_locz00_16055);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16056;

								BgL_za2za2resza2za2z00_16056 =
									PROCEDURE_ENTRY(BgL_bodyz00_13576) (BgL_bodyz00_13576,
									BgL_sz00_13577, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16053);
								return BgL_za2za2resza2za2z00_16056;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3646> */
	obj_t BGl_z62zc3z04anonymousza33646ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13578, obj_t BgL_sz00_13585)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13579;
				obj_t BgL_iboxesz00_13580;
				long BgL_siza7eza7_13581;
				BgL_ev_absz00_bglt BgL_i1247z00_13582;
				obj_t BgL_bodyz00_13583;
				long BgL_siza7ezd2framez75_13584;

				BgL_ifreesz00_13579 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13578, (int) (((long) 0))));
				BgL_iboxesz00_13580 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13578, (int) (((long) 1))));
				BgL_siza7eza7_13581 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13578, (int) (((long) 2))));
				BgL_i1247z00_13582 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13578, (int) (((long) 3))));
				BgL_bodyz00_13583 = PROCEDURE_REF(BgL_envz00_13578, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13584 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13578, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16057;

					BgL_bpz00_16057 = VECTOR_REF(((obj_t) BgL_sz00_13585), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16058;

						BgL_valza2za2_16058 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13585,
							BgL_bpz00_16057, BgL_ifreesz00_13579);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16059;

							BgL_runz00_16059 =
								MAKE_FX_PROCEDURE(BGl_z62run4548z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16059,
								(int) (((long) 0)), BgL_iboxesz00_13580);
							PROCEDURE_SET(BgL_runz00_16059,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13581));
							PROCEDURE_SET(BgL_runz00_16059,
								(int) (((long) 2)), BgL_valza2za2_16058);
							PROCEDURE_SET(BgL_runz00_16059,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13582));
							PROCEDURE_SET(BgL_runz00_16059,
								(int) (((long) 4)), BgL_bodyz00_13583);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16060;

								BgL_mainz00_16060 =
									MAKE_VA_PROCEDURE(BGl_z62main4547z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16060,
									(int) (((long) 0)), BgL_iboxesz00_13580);
								PROCEDURE_SET(BgL_mainz00_16060,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13581));
								PROCEDURE_SET(BgL_mainz00_16060,
									(int) (((long) 2)), BgL_valza2za2_16058);
								PROCEDURE_SET(BgL_mainz00_16060,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13582));
								PROCEDURE_SET(BgL_mainz00_16060,
									(int) (((long) 4)), BgL_bodyz00_13583);
								PROCEDURE_SET(BgL_mainz00_16060,
									(int) (((long) 5)), BgL_runz00_16059);
								PROCEDURE_SET(BgL_mainz00_16060,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13584));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16061;

									BgL_objz00_16061 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16059, BgL_objz00_16061);
									BgL_objz00_16061;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3647z00_16062;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3649z00_16063;

										BgL_arg3649z00_16063 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13582))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16064;

											BgL_newz00_16064 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29014;

												BgL_tmpz00_29014 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16064, BgL_tmpz00_29014,
													BgL_arg3649z00_16063);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29019;
												int BgL_tmpz00_29017;

												BgL_auxz00_29019 = BINT(BgL_siza7ezd2framez75_13584);
												BgL_tmpz00_29017 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16064, BgL_tmpz00_29017,
													BgL_auxz00_29019);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29022;

												BgL_tmpz00_29022 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16064, BgL_tmpz00_29022,
													BgL_runz00_16059);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29027;
												int BgL_tmpz00_29025;

												BgL_auxz00_29027 = BINT(((long) -2));
												BgL_tmpz00_29025 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16064, BgL_tmpz00_29025,
													BgL_auxz00_29027);
											}
											BgL_arg3647z00_16062 = BgL_newz00_16064;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16060, BgL_arg3647z00_16062);
									BgL_arg3647z00_16062;
								}
								return BgL_mainz00_16060;
							}
						}
					}
				}
			}
		}

	}



/* &main4547 */
	obj_t BGl_z62main4547z62zz__evaluate_compz00(obj_t BgL_envz00_13586,
		obj_t BgL_dz00_13594, obj_t BgL_lastz00_13595)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13592;
				long BgL_siza7ezd2framez75_13593;

				BgL_runz00_13592 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13586, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13593 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13586, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16065;

					BgL_sz00_16065 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16066;

						BgL_bpz00_16066 = VECTOR_REF(((obj_t) BgL_sz00_16065), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16066) + BgL_siza7ezd2framez75_13593) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16065))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3652z00_16067;

									BgL_arg3652z00_16067 =
										((long) CINT(BgL_bpz00_16066) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16065), BgL_arg3652z00_16067,
										BgL_dz00_13594);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3653z00_16068;

									BgL_arg3653z00_16068 =
										((long) CINT(BgL_bpz00_16066) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16065), BgL_arg3653z00_16068,
										BgL_lastz00_13595);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16069;

									BgL_ez00_16069 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16069,
										BgL_bpz00_16066);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16070;

										BgL_accz00_16070 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13592, BgL_sz00_16065, BgL_bpz00_16066);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16069);
										VECTOR_SET(
											((obj_t) BgL_sz00_16065), ((long) 0), BgL_bpz00_16066);
										return BgL_accz00_16070;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16071;

								BgL_nsz00_16071 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16071, ((long) 1), BgL_sz00_16065);
								VECTOR_SET(BgL_nsz00_16071, ((long) 2), BgL_dz00_13594);
								VECTOR_SET(BgL_nsz00_16071, ((long) 3), BgL_lastz00_13595);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16072;

									BgL_z12denvz12_16072 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16072, BgL_nsz00_16071);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16073;

										BgL_ez00_16073 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16073,
											BgL_sz00_16065);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16074;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16075;

												BgL_savedzd2bpzd2_16075 =
													VECTOR_REF(BgL_nsz00_16071, ((long) 0));
												VECTOR_SET(BgL_nsz00_16071, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16077;

													BgL_fz00_16077 = BgL_runz00_13592;
												BgL_recz00_16076:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16078;

														BgL_rz00_16078 =
															PROCEDURE_ENTRY(BgL_fz00_16077) (BgL_fz00_16077,
															BgL_nsz00_16071, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5476z00_29075;

															if (PROCEDUREP(BgL_rz00_16078))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16079;

																	BgL_arg1729z00_16079 =
																		PROCEDURE_ATTR(BgL_rz00_16078);
																	if (STRUCTP(BgL_arg1729z00_16079))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5476z00_29075 =
																				(STRUCT_KEY(BgL_arg1729z00_16079) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5476z00_29075 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5476z00_29075 = ((bool_t) 0);
																}
															if (BgL_test5476z00_29075)
																{
																	obj_t BgL_fz00_29083;

																	BgL_fz00_29083 = BgL_rz00_16078;
																	BgL_fz00_16077 = BgL_fz00_29083;
																	goto BgL_recz00_16076;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16071, ((long) 0),
																		BgL_savedzd2bpzd2_16075);
																	BgL_____rz00_16074 = BgL_rz00_16078;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16073);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16072, BgL_sz00_16065);
											return BgL_____rz00_16074;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4548 */
	obj_t BGl_z62run4548z62zz__evaluate_compz00(obj_t BgL_envz00_13596,
		obj_t BgL_sz00_13602)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13597;
				long BgL_siza7eza7_13598;
				obj_t BgL_valza2za2_13599;
				BgL_ev_absz00_bglt BgL_i1247z00_13600;
				obj_t BgL_bodyz00_13601;

				BgL_iboxesz00_13597 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13596, (int) (((long) 0))));
				BgL_siza7eza7_13598 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13596, (int) (((long) 1))));
				BgL_valza2za2_13599 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13596, (int) (((long) 2))));
				BgL_i1247z00_13600 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13596, (int) (((long) 3))));
				BgL_bodyz00_13601 = PROCEDURE_REF(BgL_envz00_13596, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16080;

					BgL_bpz00_16080 = VECTOR_REF(((obj_t) BgL_sz00_13602), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13602,
						BgL_iboxesz00_13597, BgL_bpz00_16080);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13602,
						BgL_valza2za2_13599,
						((long) CINT(BgL_bpz00_16080) + BgL_siza7eza7_13598));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16081;
						obj_t BgL_wherez00_16082;
						obj_t BgL_locz00_16083;

						BgL_z12denvz12_16081 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16082 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13600))->
							BgL_wherez00);
						BgL_locz00_16083 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13600))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16081, BgL_wherez00_16082,
								BgL_locz00_16083);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16084;

								BgL_za2za2resza2za2z00_16084 =
									PROCEDURE_ENTRY(BgL_bodyz00_13601) (BgL_bodyz00_13601,
									BgL_sz00_13602, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16081);
								return BgL_za2za2resza2za2z00_16084;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3573> */
	obj_t BGl_z62zc3z04anonymousza33573ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13603, obj_t BgL_sz00_13607)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13604;
				obj_t BgL_bodyz00_13605;
				long BgL_siza7ezd2framez75_13606;

				BgL_i1247z00_13604 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13603, (int) (((long) 0))));
				BgL_bodyz00_13605 = PROCEDURE_REF(BgL_envz00_13603, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13606 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13603, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16085;

					BgL_bpz00_16085 = VECTOR_REF(((obj_t) BgL_sz00_13607), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16086;

							BgL_runz00_16086 =
								MAKE_FX_PROCEDURE(BGl_z62run4550z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16086,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13604));
							PROCEDURE_SET(BgL_runz00_16086,
								(int) (((long) 1)), BgL_bodyz00_13605);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16087;

								BgL_mainz00_16087 =
									MAKE_FX_PROCEDURE(BGl_z62main4549z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16087,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13604));
								PROCEDURE_SET(BgL_mainz00_16087,
									(int) (((long) 1)), BgL_bodyz00_13605);
								PROCEDURE_SET(BgL_mainz00_16087,
									(int) (((long) 2)), BgL_runz00_16086);
								PROCEDURE_SET(BgL_mainz00_16087,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13606));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16088;

									BgL_objz00_16088 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16086, BgL_objz00_16088);
									BgL_objz00_16088;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3574z00_16089;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3575z00_16090;

										BgL_arg3575z00_16090 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13604))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16091;

											BgL_newz00_16091 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29151;

												BgL_tmpz00_29151 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16091, BgL_tmpz00_29151,
													BgL_arg3575z00_16090);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29156;
												int BgL_tmpz00_29154;

												BgL_auxz00_29156 = BINT(BgL_siza7ezd2framez75_13606);
												BgL_tmpz00_29154 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16091, BgL_tmpz00_29154,
													BgL_auxz00_29156);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29159;

												BgL_tmpz00_29159 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16091, BgL_tmpz00_29159,
													BgL_runz00_16086);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29164;
												int BgL_tmpz00_29162;

												BgL_auxz00_29164 = BINT(((long) 1));
												BgL_tmpz00_29162 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16091, BgL_tmpz00_29162,
													BgL_auxz00_29164);
											}
											BgL_arg3574z00_16089 = BgL_newz00_16091;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16087, BgL_arg3574z00_16089);
									BgL_arg3574z00_16089;
								}
								return BgL_mainz00_16087;
							}
						}
					}
				}
			}
		}

	}



/* &main4549 */
	obj_t BGl_z62main4549z62zz__evaluate_compz00(obj_t BgL_envz00_13608,
		obj_t BgL_dz00_13613)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13611;
				long BgL_siza7ezd2framez75_13612;

				BgL_runz00_13611 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13608, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13612 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13608, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16092;

					BgL_sz00_16092 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16093;

						BgL_bpz00_16093 = VECTOR_REF(((obj_t) BgL_sz00_16092), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16093) + BgL_siza7ezd2framez75_13612) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16092))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3578z00_16094;

									BgL_arg3578z00_16094 =
										((long) CINT(BgL_bpz00_16093) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16092), BgL_arg3578z00_16094,
										BgL_dz00_13613);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16095;

									BgL_ez00_16095 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16095,
										BgL_bpz00_16093);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16096;

										BgL_accz00_16096 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13611, BgL_sz00_16092, BgL_bpz00_16093);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16095);
										VECTOR_SET(
											((obj_t) BgL_sz00_16092), ((long) 0), BgL_bpz00_16093);
										return BgL_accz00_16096;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16097;

								BgL_nsz00_16097 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16097, ((long) 1), BgL_sz00_16092);
								VECTOR_SET(BgL_nsz00_16097, ((long) 2), BgL_dz00_13613);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16098;

									BgL_z12denvz12_16098 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16098, BgL_nsz00_16097);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16099;

										BgL_ez00_16099 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16099,
											BgL_sz00_16092);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16100;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16101;

												BgL_savedzd2bpzd2_16101 =
													VECTOR_REF(BgL_nsz00_16097, ((long) 0));
												VECTOR_SET(BgL_nsz00_16097, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16103;

													BgL_fz00_16103 = BgL_runz00_13611;
												BgL_recz00_16102:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16104;

														BgL_rz00_16104 =
															PROCEDURE_ENTRY(BgL_fz00_16103) (BgL_fz00_16103,
															BgL_nsz00_16097, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5480z00_29207;

															if (PROCEDUREP(BgL_rz00_16104))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16105;

																	BgL_arg1729z00_16105 =
																		PROCEDURE_ATTR(BgL_rz00_16104);
																	if (STRUCTP(BgL_arg1729z00_16105))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5480z00_29207 =
																				(STRUCT_KEY(BgL_arg1729z00_16105) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5480z00_29207 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5480z00_29207 = ((bool_t) 0);
																}
															if (BgL_test5480z00_29207)
																{
																	obj_t BgL_fz00_29215;

																	BgL_fz00_29215 = BgL_rz00_16104;
																	BgL_fz00_16103 = BgL_fz00_29215;
																	goto BgL_recz00_16102;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16097, ((long) 0),
																		BgL_savedzd2bpzd2_16101);
																	BgL_____rz00_16100 = BgL_rz00_16104;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16099);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16098, BgL_sz00_16092);
											return BgL_____rz00_16100;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4550 */
	obj_t BGl_z62run4550z62zz__evaluate_compz00(obj_t BgL_envz00_13614,
		obj_t BgL_sz00_13617)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13615;
				obj_t BgL_bodyz00_13616;

				BgL_i1247z00_13615 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13614, (int) (((long) 0))));
				BgL_bodyz00_13616 = PROCEDURE_REF(BgL_envz00_13614, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16106;

					BgL_bpz00_16106 = VECTOR_REF(((obj_t) BgL_sz00_13617), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16107;
						obj_t BgL_wherez00_16108;
						obj_t BgL_locz00_16109;

						BgL_z12denvz12_16107 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16108 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13615))->
							BgL_wherez00);
						BgL_locz00_16109 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13615))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16107, BgL_wherez00_16108,
								BgL_locz00_16109);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16110;

								BgL_za2za2resza2za2z00_16110 =
									PROCEDURE_ENTRY(BgL_bodyz00_13616) (BgL_bodyz00_13616,
									BgL_sz00_13617, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16107);
								return BgL_za2za2resza2za2z00_16110;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3580> */
	obj_t BGl_z62zc3z04anonymousza33580ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13618, obj_t BgL_sz00_13623)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13619;
				BgL_ev_absz00_bglt BgL_i1247z00_13620;
				obj_t BgL_bodyz00_13621;
				long BgL_siza7ezd2framez75_13622;

				BgL_iboxesz00_13619 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13618, (int) (((long) 0))));
				BgL_i1247z00_13620 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13618, (int) (((long) 1))));
				BgL_bodyz00_13621 = PROCEDURE_REF(BgL_envz00_13618, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13622 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13618, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16111;

					BgL_bpz00_16111 = VECTOR_REF(((obj_t) BgL_sz00_13623), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16112;

							BgL_runz00_16112 =
								MAKE_FX_PROCEDURE(BGl_z62run4552z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16112,
								(int) (((long) 0)), BgL_iboxesz00_13619);
							PROCEDURE_SET(BgL_runz00_16112,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13620));
							PROCEDURE_SET(BgL_runz00_16112,
								(int) (((long) 2)), BgL_bodyz00_13621);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16113;

								BgL_mainz00_16113 =
									MAKE_FX_PROCEDURE(BGl_z62main4551z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16113,
									(int) (((long) 0)), BgL_iboxesz00_13619);
								PROCEDURE_SET(BgL_mainz00_16113,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13620));
								PROCEDURE_SET(BgL_mainz00_16113,
									(int) (((long) 2)), BgL_bodyz00_13621);
								PROCEDURE_SET(BgL_mainz00_16113,
									(int) (((long) 3)), BgL_runz00_16112);
								PROCEDURE_SET(BgL_mainz00_16113,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13622));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16114;

									BgL_objz00_16114 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16112, BgL_objz00_16114);
									BgL_objz00_16114;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3581z00_16115;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3583z00_16116;

										BgL_arg3583z00_16116 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13620))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16117;

											BgL_newz00_16117 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29277;

												BgL_tmpz00_29277 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16117, BgL_tmpz00_29277,
													BgL_arg3583z00_16116);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29282;
												int BgL_tmpz00_29280;

												BgL_auxz00_29282 = BINT(BgL_siza7ezd2framez75_13622);
												BgL_tmpz00_29280 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16117, BgL_tmpz00_29280,
													BgL_auxz00_29282);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29285;

												BgL_tmpz00_29285 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16117, BgL_tmpz00_29285,
													BgL_runz00_16112);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29290;
												int BgL_tmpz00_29288;

												BgL_auxz00_29290 = BINT(((long) 1));
												BgL_tmpz00_29288 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16117, BgL_tmpz00_29288,
													BgL_auxz00_29290);
											}
											BgL_arg3581z00_16115 = BgL_newz00_16117;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16113, BgL_arg3581z00_16115);
									BgL_arg3581z00_16115;
								}
								return BgL_mainz00_16113;
							}
						}
					}
				}
			}
		}

	}



/* &main4551 */
	obj_t BGl_z62main4551z62zz__evaluate_compz00(obj_t BgL_envz00_13624,
		obj_t BgL_dz00_13630)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13628;
				long BgL_siza7ezd2framez75_13629;

				BgL_runz00_13628 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13624, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13629 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13624, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16118;

					BgL_sz00_16118 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16119;

						BgL_bpz00_16119 = VECTOR_REF(((obj_t) BgL_sz00_16118), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16119) + BgL_siza7ezd2framez75_13629) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16118))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3587z00_16120;

									BgL_arg3587z00_16120 =
										((long) CINT(BgL_bpz00_16119) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16118), BgL_arg3587z00_16120,
										BgL_dz00_13630);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16121;

									BgL_ez00_16121 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16121,
										BgL_bpz00_16119);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16122;

										BgL_accz00_16122 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13628, BgL_sz00_16118, BgL_bpz00_16119);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16121);
										VECTOR_SET(
											((obj_t) BgL_sz00_16118), ((long) 0), BgL_bpz00_16119);
										return BgL_accz00_16122;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16123;

								BgL_nsz00_16123 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16123, ((long) 1), BgL_sz00_16118);
								VECTOR_SET(BgL_nsz00_16123, ((long) 2), BgL_dz00_13630);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16124;

									BgL_z12denvz12_16124 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16124, BgL_nsz00_16123);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16125;

										BgL_ez00_16125 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16125,
											BgL_sz00_16118);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16126;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16127;

												BgL_savedzd2bpzd2_16127 =
													VECTOR_REF(BgL_nsz00_16123, ((long) 0));
												VECTOR_SET(BgL_nsz00_16123, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16129;

													BgL_fz00_16129 = BgL_runz00_13628;
												BgL_recz00_16128:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16130;

														BgL_rz00_16130 =
															PROCEDURE_ENTRY(BgL_fz00_16129) (BgL_fz00_16129,
															BgL_nsz00_16123, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5484z00_29333;

															if (PROCEDUREP(BgL_rz00_16130))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16131;

																	BgL_arg1729z00_16131 =
																		PROCEDURE_ATTR(BgL_rz00_16130);
																	if (STRUCTP(BgL_arg1729z00_16131))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5484z00_29333 =
																				(STRUCT_KEY(BgL_arg1729z00_16131) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5484z00_29333 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5484z00_29333 = ((bool_t) 0);
																}
															if (BgL_test5484z00_29333)
																{
																	obj_t BgL_fz00_29341;

																	BgL_fz00_29341 = BgL_rz00_16130;
																	BgL_fz00_16129 = BgL_fz00_29341;
																	goto BgL_recz00_16128;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16123, ((long) 0),
																		BgL_savedzd2bpzd2_16127);
																	BgL_____rz00_16126 = BgL_rz00_16130;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16125);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16124, BgL_sz00_16118);
											return BgL_____rz00_16126;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4552 */
	obj_t BGl_z62run4552z62zz__evaluate_compz00(obj_t BgL_envz00_13631,
		obj_t BgL_sz00_13635)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13632;
				BgL_ev_absz00_bglt BgL_i1247z00_13633;
				obj_t BgL_bodyz00_13634;

				BgL_iboxesz00_13632 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13631, (int) (((long) 0))));
				BgL_i1247z00_13633 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13631, (int) (((long) 1))));
				BgL_bodyz00_13634 = PROCEDURE_REF(BgL_envz00_13631, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16132;

					BgL_bpz00_16132 = VECTOR_REF(((obj_t) BgL_sz00_13635), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13635,
						BgL_iboxesz00_13632, BgL_bpz00_16132);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16133;
						obj_t BgL_wherez00_16134;
						obj_t BgL_locz00_16135;

						BgL_z12denvz12_16133 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16134 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13633))->
							BgL_wherez00);
						BgL_locz00_16135 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13633))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16133, BgL_wherez00_16134,
								BgL_locz00_16135);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16136;

								BgL_za2za2resza2za2z00_16136 =
									PROCEDURE_ENTRY(BgL_bodyz00_13634) (BgL_bodyz00_13634,
									BgL_sz00_13635, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16133);
								return BgL_za2za2resza2za2z00_16136;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3592> */
	obj_t BGl_z62zc3z04anonymousza33592ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13636, obj_t BgL_sz00_13642)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13637;
				long BgL_siza7eza7_13638;
				BgL_ev_absz00_bglt BgL_i1247z00_13639;
				obj_t BgL_bodyz00_13640;
				long BgL_siza7ezd2framez75_13641;

				BgL_ifreesz00_13637 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 0))));
				BgL_siza7eza7_13638 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 1))));
				BgL_i1247z00_13639 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 2))));
				BgL_bodyz00_13640 = PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13641 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13636, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16137;

					BgL_bpz00_16137 = VECTOR_REF(((obj_t) BgL_sz00_13642), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16138;

						BgL_valza2za2_16138 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13642,
							BgL_bpz00_16137, BgL_ifreesz00_13637);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16139;

							BgL_runz00_16139 =
								MAKE_FX_PROCEDURE(BGl_z62run4554z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16139,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13638));
							PROCEDURE_SET(BgL_runz00_16139,
								(int) (((long) 1)), BgL_valza2za2_16138);
							PROCEDURE_SET(BgL_runz00_16139,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13639));
							PROCEDURE_SET(BgL_runz00_16139,
								(int) (((long) 3)), BgL_bodyz00_13640);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16140;

								BgL_mainz00_16140 =
									MAKE_FX_PROCEDURE(BGl_z62main4553z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16140,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13638));
								PROCEDURE_SET(BgL_mainz00_16140,
									(int) (((long) 1)), BgL_valza2za2_16138);
								PROCEDURE_SET(BgL_mainz00_16140,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13639));
								PROCEDURE_SET(BgL_mainz00_16140,
									(int) (((long) 3)), BgL_bodyz00_13640);
								PROCEDURE_SET(BgL_mainz00_16140,
									(int) (((long) 4)), BgL_runz00_16139);
								PROCEDURE_SET(BgL_mainz00_16140,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13641));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16141;

									BgL_objz00_16141 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16139, BgL_objz00_16141);
									BgL_objz00_16141;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3593z00_16142;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3594z00_16143;

										BgL_arg3594z00_16143 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13639))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16144;

											BgL_newz00_16144 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29417;

												BgL_tmpz00_29417 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16144, BgL_tmpz00_29417,
													BgL_arg3594z00_16143);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29422;
												int BgL_tmpz00_29420;

												BgL_auxz00_29422 = BINT(BgL_siza7ezd2framez75_13641);
												BgL_tmpz00_29420 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16144, BgL_tmpz00_29420,
													BgL_auxz00_29422);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29425;

												BgL_tmpz00_29425 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16144, BgL_tmpz00_29425,
													BgL_runz00_16139);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29430;
												int BgL_tmpz00_29428;

												BgL_auxz00_29430 = BINT(((long) 1));
												BgL_tmpz00_29428 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16144, BgL_tmpz00_29428,
													BgL_auxz00_29430);
											}
											BgL_arg3593z00_16142 = BgL_newz00_16144;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16140, BgL_arg3593z00_16142);
									BgL_arg3593z00_16142;
								}
								return BgL_mainz00_16140;
							}
						}
					}
				}
			}
		}

	}



/* &main4553 */
	obj_t BGl_z62main4553z62zz__evaluate_compz00(obj_t BgL_envz00_13643,
		obj_t BgL_dz00_13650)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13648;
				long BgL_siza7ezd2framez75_13649;

				BgL_runz00_13648 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13643, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13649 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13643, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16145;

					BgL_sz00_16145 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16146;

						BgL_bpz00_16146 = VECTOR_REF(((obj_t) BgL_sz00_16145), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16146) + BgL_siza7ezd2framez75_13649) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16145))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3597z00_16147;

									BgL_arg3597z00_16147 =
										((long) CINT(BgL_bpz00_16146) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16145), BgL_arg3597z00_16147,
										BgL_dz00_13650);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16148;

									BgL_ez00_16148 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16148,
										BgL_bpz00_16146);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16149;

										BgL_accz00_16149 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13648, BgL_sz00_16145, BgL_bpz00_16146);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16148);
										VECTOR_SET(
											((obj_t) BgL_sz00_16145), ((long) 0), BgL_bpz00_16146);
										return BgL_accz00_16149;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16150;

								BgL_nsz00_16150 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16150, ((long) 1), BgL_sz00_16145);
								VECTOR_SET(BgL_nsz00_16150, ((long) 2), BgL_dz00_13650);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16151;

									BgL_z12denvz12_16151 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16151, BgL_nsz00_16150);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16152;

										BgL_ez00_16152 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16152,
											BgL_sz00_16145);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16153;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16154;

												BgL_savedzd2bpzd2_16154 =
													VECTOR_REF(BgL_nsz00_16150, ((long) 0));
												VECTOR_SET(BgL_nsz00_16150, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16156;

													BgL_fz00_16156 = BgL_runz00_13648;
												BgL_recz00_16155:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16157;

														BgL_rz00_16157 =
															PROCEDURE_ENTRY(BgL_fz00_16156) (BgL_fz00_16156,
															BgL_nsz00_16150, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5488z00_29473;

															if (PROCEDUREP(BgL_rz00_16157))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16158;

																	BgL_arg1729z00_16158 =
																		PROCEDURE_ATTR(BgL_rz00_16157);
																	if (STRUCTP(BgL_arg1729z00_16158))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5488z00_29473 =
																				(STRUCT_KEY(BgL_arg1729z00_16158) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5488z00_29473 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5488z00_29473 = ((bool_t) 0);
																}
															if (BgL_test5488z00_29473)
																{
																	obj_t BgL_fz00_29481;

																	BgL_fz00_29481 = BgL_rz00_16157;
																	BgL_fz00_16156 = BgL_fz00_29481;
																	goto BgL_recz00_16155;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16150, ((long) 0),
																		BgL_savedzd2bpzd2_16154);
																	BgL_____rz00_16153 = BgL_rz00_16157;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16152);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16151, BgL_sz00_16145);
											return BgL_____rz00_16153;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4554 */
	obj_t BGl_z62run4554z62zz__evaluate_compz00(obj_t BgL_envz00_13651,
		obj_t BgL_sz00_13656)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13652;
				obj_t BgL_valza2za2_13653;
				BgL_ev_absz00_bglt BgL_i1247z00_13654;
				obj_t BgL_bodyz00_13655;

				BgL_siza7eza7_13652 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13651, (int) (((long) 0))));
				BgL_valza2za2_13653 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13651, (int) (((long) 1))));
				BgL_i1247z00_13654 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13651, (int) (((long) 2))));
				BgL_bodyz00_13655 = PROCEDURE_REF(BgL_envz00_13651, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16159;

					BgL_bpz00_16159 = VECTOR_REF(((obj_t) BgL_sz00_13656), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13656,
						BgL_valza2za2_13653,
						((long) CINT(BgL_bpz00_16159) + BgL_siza7eza7_13652));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16160;
						obj_t BgL_wherez00_16161;
						obj_t BgL_locz00_16162;

						BgL_z12denvz12_16160 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16161 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13654))->
							BgL_wherez00);
						BgL_locz00_16162 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13654))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16160, BgL_wherez00_16161,
								BgL_locz00_16162);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16163;

								BgL_za2za2resza2za2z00_16163 =
									PROCEDURE_ENTRY(BgL_bodyz00_13655) (BgL_bodyz00_13655,
									BgL_sz00_13656, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16160);
								return BgL_za2za2resza2za2z00_16163;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3600> */
	obj_t BGl_z62zc3z04anonymousza33600ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13657, obj_t BgL_sz00_13664)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13658;
				obj_t BgL_iboxesz00_13659;
				long BgL_siza7eza7_13660;
				BgL_ev_absz00_bglt BgL_i1247z00_13661;
				obj_t BgL_bodyz00_13662;
				long BgL_siza7ezd2framez75_13663;

				BgL_ifreesz00_13658 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13657, (int) (((long) 0))));
				BgL_iboxesz00_13659 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13657, (int) (((long) 1))));
				BgL_siza7eza7_13660 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13657, (int) (((long) 2))));
				BgL_i1247z00_13661 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13657, (int) (((long) 3))));
				BgL_bodyz00_13662 = PROCEDURE_REF(BgL_envz00_13657, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13663 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13657, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16164;

					BgL_bpz00_16164 = VECTOR_REF(((obj_t) BgL_sz00_13664), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16165;

						BgL_valza2za2_16165 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13664,
							BgL_bpz00_16164, BgL_ifreesz00_13658);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16166;

							BgL_runz00_16166 =
								MAKE_FX_PROCEDURE(BGl_z62run4556z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16166,
								(int) (((long) 0)), BgL_iboxesz00_13659);
							PROCEDURE_SET(BgL_runz00_16166,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13660));
							PROCEDURE_SET(BgL_runz00_16166,
								(int) (((long) 2)), BgL_valza2za2_16165);
							PROCEDURE_SET(BgL_runz00_16166,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13661));
							PROCEDURE_SET(BgL_runz00_16166,
								(int) (((long) 4)), BgL_bodyz00_13662);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16167;

								BgL_mainz00_16167 =
									MAKE_FX_PROCEDURE(BGl_z62main4555z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16167,
									(int) (((long) 0)), BgL_iboxesz00_13659);
								PROCEDURE_SET(BgL_mainz00_16167,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13660));
								PROCEDURE_SET(BgL_mainz00_16167,
									(int) (((long) 2)), BgL_valza2za2_16165);
								PROCEDURE_SET(BgL_mainz00_16167,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13661));
								PROCEDURE_SET(BgL_mainz00_16167,
									(int) (((long) 4)), BgL_bodyz00_13662);
								PROCEDURE_SET(BgL_mainz00_16167,
									(int) (((long) 5)), BgL_runz00_16166);
								PROCEDURE_SET(BgL_mainz00_16167,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13663));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16168;

									BgL_objz00_16168 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16166, BgL_objz00_16168);
									BgL_objz00_16168;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3601z00_16169;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3602z00_16170;

										BgL_arg3602z00_16170 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13661))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16171;

											BgL_newz00_16171 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29569;

												BgL_tmpz00_29569 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16171, BgL_tmpz00_29569,
													BgL_arg3602z00_16170);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29574;
												int BgL_tmpz00_29572;

												BgL_auxz00_29574 = BINT(BgL_siza7ezd2framez75_13663);
												BgL_tmpz00_29572 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16171, BgL_tmpz00_29572,
													BgL_auxz00_29574);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29577;

												BgL_tmpz00_29577 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16171, BgL_tmpz00_29577,
													BgL_runz00_16166);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29582;
												int BgL_tmpz00_29580;

												BgL_auxz00_29582 = BINT(((long) 1));
												BgL_tmpz00_29580 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16171, BgL_tmpz00_29580,
													BgL_auxz00_29582);
											}
											BgL_arg3601z00_16169 = BgL_newz00_16171;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16167, BgL_arg3601z00_16169);
									BgL_arg3601z00_16169;
								}
								return BgL_mainz00_16167;
							}
						}
					}
				}
			}
		}

	}



/* &main4555 */
	obj_t BGl_z62main4555z62zz__evaluate_compz00(obj_t BgL_envz00_13665,
		obj_t BgL_dz00_13673)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13671;
				long BgL_siza7ezd2framez75_13672;

				BgL_runz00_13671 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13665, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13672 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13665, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16172;

					BgL_sz00_16172 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16173;

						BgL_bpz00_16173 = VECTOR_REF(((obj_t) BgL_sz00_16172), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16173) + BgL_siza7ezd2framez75_13672) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16172))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3605z00_16174;

									BgL_arg3605z00_16174 =
										((long) CINT(BgL_bpz00_16173) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16172), BgL_arg3605z00_16174,
										BgL_dz00_13673);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16175;

									BgL_ez00_16175 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16175,
										BgL_bpz00_16173);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16176;

										BgL_accz00_16176 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13671, BgL_sz00_16172, BgL_bpz00_16173);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16175);
										VECTOR_SET(
											((obj_t) BgL_sz00_16172), ((long) 0), BgL_bpz00_16173);
										return BgL_accz00_16176;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16177;

								BgL_nsz00_16177 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16177, ((long) 1), BgL_sz00_16172);
								VECTOR_SET(BgL_nsz00_16177, ((long) 2), BgL_dz00_13673);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16178;

									BgL_z12denvz12_16178 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16178, BgL_nsz00_16177);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16179;

										BgL_ez00_16179 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16179,
											BgL_sz00_16172);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16180;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16181;

												BgL_savedzd2bpzd2_16181 =
													VECTOR_REF(BgL_nsz00_16177, ((long) 0));
												VECTOR_SET(BgL_nsz00_16177, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16183;

													BgL_fz00_16183 = BgL_runz00_13671;
												BgL_recz00_16182:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16184;

														BgL_rz00_16184 =
															PROCEDURE_ENTRY(BgL_fz00_16183) (BgL_fz00_16183,
															BgL_nsz00_16177, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5492z00_29625;

															if (PROCEDUREP(BgL_rz00_16184))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16185;

																	BgL_arg1729z00_16185 =
																		PROCEDURE_ATTR(BgL_rz00_16184);
																	if (STRUCTP(BgL_arg1729z00_16185))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5492z00_29625 =
																				(STRUCT_KEY(BgL_arg1729z00_16185) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5492z00_29625 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5492z00_29625 = ((bool_t) 0);
																}
															if (BgL_test5492z00_29625)
																{
																	obj_t BgL_fz00_29633;

																	BgL_fz00_29633 = BgL_rz00_16184;
																	BgL_fz00_16183 = BgL_fz00_29633;
																	goto BgL_recz00_16182;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16177, ((long) 0),
																		BgL_savedzd2bpzd2_16181);
																	BgL_____rz00_16180 = BgL_rz00_16184;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16179);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16178, BgL_sz00_16172);
											return BgL_____rz00_16180;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4556 */
	obj_t BGl_z62run4556z62zz__evaluate_compz00(obj_t BgL_envz00_13674,
		obj_t BgL_sz00_13680)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13675;
				long BgL_siza7eza7_13676;
				obj_t BgL_valza2za2_13677;
				BgL_ev_absz00_bglt BgL_i1247z00_13678;
				obj_t BgL_bodyz00_13679;

				BgL_iboxesz00_13675 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13674, (int) (((long) 0))));
				BgL_siza7eza7_13676 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13674, (int) (((long) 1))));
				BgL_valza2za2_13677 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13674, (int) (((long) 2))));
				BgL_i1247z00_13678 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13674, (int) (((long) 3))));
				BgL_bodyz00_13679 = PROCEDURE_REF(BgL_envz00_13674, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16186;

					BgL_bpz00_16186 = VECTOR_REF(((obj_t) BgL_sz00_13680), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13680,
						BgL_iboxesz00_13675, BgL_bpz00_16186);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13680,
						BgL_valza2za2_13677,
						((long) CINT(BgL_bpz00_16186) + BgL_siza7eza7_13676));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16187;
						obj_t BgL_wherez00_16188;
						obj_t BgL_locz00_16189;

						BgL_z12denvz12_16187 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16188 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13678))->
							BgL_wherez00);
						BgL_locz00_16189 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13678))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16187, BgL_wherez00_16188,
								BgL_locz00_16189);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16190;

								BgL_za2za2resza2za2z00_16190 =
									PROCEDURE_ENTRY(BgL_bodyz00_13679) (BgL_bodyz00_13679,
									BgL_sz00_13680, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16187);
								return BgL_za2za2resza2za2z00_16190;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3529> */
	obj_t BGl_z62zc3z04anonymousza33529ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13681, obj_t BgL_sz00_13685)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13682;
				obj_t BgL_bodyz00_13683;
				long BgL_siza7ezd2framez75_13684;

				BgL_i1247z00_13682 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13681, (int) (((long) 0))));
				BgL_bodyz00_13683 = PROCEDURE_REF(BgL_envz00_13681, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13684 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13681, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16191;

					BgL_bpz00_16191 = VECTOR_REF(((obj_t) BgL_sz00_13685), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16192;

							BgL_runz00_16192 =
								MAKE_FX_PROCEDURE(BGl_z62run4558z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16192,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13682));
							PROCEDURE_SET(BgL_runz00_16192,
								(int) (((long) 1)), BgL_bodyz00_13683);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16193;

								BgL_mainz00_16193 =
									MAKE_VA_PROCEDURE(BGl_z62main4557z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16193,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13682));
								PROCEDURE_SET(BgL_mainz00_16193,
									(int) (((long) 1)), BgL_bodyz00_13683);
								PROCEDURE_SET(BgL_mainz00_16193,
									(int) (((long) 2)), BgL_runz00_16192);
								PROCEDURE_SET(BgL_mainz00_16193,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13684));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16194;

									BgL_objz00_16194 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16192, BgL_objz00_16194);
									BgL_objz00_16194;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3530z00_16195;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3532z00_16196;

										BgL_arg3532z00_16196 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13682))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16197;

											BgL_newz00_16197 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29701;

												BgL_tmpz00_29701 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16197, BgL_tmpz00_29701,
													BgL_arg3532z00_16196);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29706;
												int BgL_tmpz00_29704;

												BgL_auxz00_29706 = BINT(BgL_siza7ezd2framez75_13684);
												BgL_tmpz00_29704 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16197, BgL_tmpz00_29704,
													BgL_auxz00_29706);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29709;

												BgL_tmpz00_29709 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16197, BgL_tmpz00_29709,
													BgL_runz00_16192);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29714;
												int BgL_tmpz00_29712;

												BgL_auxz00_29714 = BINT(((long) -1));
												BgL_tmpz00_29712 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16197, BgL_tmpz00_29712,
													BgL_auxz00_29714);
											}
											BgL_arg3530z00_16195 = BgL_newz00_16197;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16193, BgL_arg3530z00_16195);
									BgL_arg3530z00_16195;
								}
								return BgL_mainz00_16193;
							}
						}
					}
				}
			}
		}

	}



/* &main4557 */
	obj_t BGl_z62main4557z62zz__evaluate_compz00(obj_t BgL_envz00_13686,
		obj_t BgL_lastz00_13691)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13689;
				long BgL_siza7ezd2framez75_13690;

				BgL_runz00_13689 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13686, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13690 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13686, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16198;

					BgL_sz00_16198 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16199;

						BgL_bpz00_16199 = VECTOR_REF(((obj_t) BgL_sz00_16198), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16199) + BgL_siza7ezd2framez75_13690) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16198))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3535z00_16200;

									BgL_arg3535z00_16200 =
										((long) CINT(BgL_bpz00_16199) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16198), BgL_arg3535z00_16200,
										BgL_lastz00_13691);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16201;

									BgL_ez00_16201 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16201,
										BgL_bpz00_16199);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16202;

										BgL_accz00_16202 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13689, BgL_sz00_16198, BgL_bpz00_16199);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16201);
										VECTOR_SET(
											((obj_t) BgL_sz00_16198), ((long) 0), BgL_bpz00_16199);
										return BgL_accz00_16202;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16203;

								BgL_nsz00_16203 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16203, ((long) 1), BgL_sz00_16198);
								VECTOR_SET(BgL_nsz00_16203, ((long) 2), BgL_lastz00_13691);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16204;

									BgL_z12denvz12_16204 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16204, BgL_nsz00_16203);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16205;

										BgL_ez00_16205 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16205,
											BgL_sz00_16198);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16206;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16207;

												BgL_savedzd2bpzd2_16207 =
													VECTOR_REF(BgL_nsz00_16203, ((long) 0));
												VECTOR_SET(BgL_nsz00_16203, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16209;

													BgL_fz00_16209 = BgL_runz00_13689;
												BgL_recz00_16208:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16210;

														BgL_rz00_16210 =
															PROCEDURE_ENTRY(BgL_fz00_16209) (BgL_fz00_16209,
															BgL_nsz00_16203, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5496z00_29757;

															if (PROCEDUREP(BgL_rz00_16210))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16211;

																	BgL_arg1729z00_16211 =
																		PROCEDURE_ATTR(BgL_rz00_16210);
																	if (STRUCTP(BgL_arg1729z00_16211))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5496z00_29757 =
																				(STRUCT_KEY(BgL_arg1729z00_16211) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5496z00_29757 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5496z00_29757 = ((bool_t) 0);
																}
															if (BgL_test5496z00_29757)
																{
																	obj_t BgL_fz00_29765;

																	BgL_fz00_29765 = BgL_rz00_16210;
																	BgL_fz00_16209 = BgL_fz00_29765;
																	goto BgL_recz00_16208;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16203, ((long) 0),
																		BgL_savedzd2bpzd2_16207);
																	BgL_____rz00_16206 = BgL_rz00_16210;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16205);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16204, BgL_sz00_16198);
											return BgL_____rz00_16206;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4558 */
	obj_t BGl_z62run4558z62zz__evaluate_compz00(obj_t BgL_envz00_13692,
		obj_t BgL_sz00_13695)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13693;
				obj_t BgL_bodyz00_13694;

				BgL_i1247z00_13693 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13692, (int) (((long) 0))));
				BgL_bodyz00_13694 = PROCEDURE_REF(BgL_envz00_13692, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16212;

					BgL_bpz00_16212 = VECTOR_REF(((obj_t) BgL_sz00_13695), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16213;
						obj_t BgL_wherez00_16214;
						obj_t BgL_locz00_16215;

						BgL_z12denvz12_16213 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16214 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13693))->
							BgL_wherez00);
						BgL_locz00_16215 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13693))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16213, BgL_wherez00_16214,
								BgL_locz00_16215);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16216;

								BgL_za2za2resza2za2z00_16216 =
									PROCEDURE_ENTRY(BgL_bodyz00_13694) (BgL_bodyz00_13694,
									BgL_sz00_13695, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16213);
								return BgL_za2za2resza2za2z00_16216;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3537> */
	obj_t BGl_z62zc3z04anonymousza33537ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13696, obj_t BgL_sz00_13701)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13697;
				BgL_ev_absz00_bglt BgL_i1247z00_13698;
				obj_t BgL_bodyz00_13699;
				long BgL_siza7ezd2framez75_13700;

				BgL_iboxesz00_13697 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13696, (int) (((long) 0))));
				BgL_i1247z00_13698 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13696, (int) (((long) 1))));
				BgL_bodyz00_13699 = PROCEDURE_REF(BgL_envz00_13696, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13700 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13696, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16217;

					BgL_bpz00_16217 = VECTOR_REF(((obj_t) BgL_sz00_13701), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16218;

							BgL_runz00_16218 =
								MAKE_FX_PROCEDURE(BGl_z62run4560z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16218,
								(int) (((long) 0)), BgL_iboxesz00_13697);
							PROCEDURE_SET(BgL_runz00_16218,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13698));
							PROCEDURE_SET(BgL_runz00_16218,
								(int) (((long) 2)), BgL_bodyz00_13699);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16219;

								BgL_mainz00_16219 =
									MAKE_VA_PROCEDURE(BGl_z62main4559z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16219,
									(int) (((long) 0)), BgL_iboxesz00_13697);
								PROCEDURE_SET(BgL_mainz00_16219,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13698));
								PROCEDURE_SET(BgL_mainz00_16219,
									(int) (((long) 2)), BgL_bodyz00_13699);
								PROCEDURE_SET(BgL_mainz00_16219,
									(int) (((long) 3)), BgL_runz00_16218);
								PROCEDURE_SET(BgL_mainz00_16219,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13700));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16220;

									BgL_objz00_16220 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16218, BgL_objz00_16220);
									BgL_objz00_16220;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3538z00_16221;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3539z00_16222;

										BgL_arg3539z00_16222 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13698))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16223;

											BgL_newz00_16223 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29827;

												BgL_tmpz00_29827 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16223, BgL_tmpz00_29827,
													BgL_arg3539z00_16222);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29832;
												int BgL_tmpz00_29830;

												BgL_auxz00_29832 = BINT(BgL_siza7ezd2framez75_13700);
												BgL_tmpz00_29830 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16223, BgL_tmpz00_29830,
													BgL_auxz00_29832);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29835;

												BgL_tmpz00_29835 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16223, BgL_tmpz00_29835,
													BgL_runz00_16218);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29840;
												int BgL_tmpz00_29838;

												BgL_auxz00_29840 = BINT(((long) -1));
												BgL_tmpz00_29838 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16223, BgL_tmpz00_29838,
													BgL_auxz00_29840);
											}
											BgL_arg3538z00_16221 = BgL_newz00_16223;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16219, BgL_arg3538z00_16221);
									BgL_arg3538z00_16221;
								}
								return BgL_mainz00_16219;
							}
						}
					}
				}
			}
		}

	}



/* &main4559 */
	obj_t BGl_z62main4559z62zz__evaluate_compz00(obj_t BgL_envz00_13702,
		obj_t BgL_lastz00_13708)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13706;
				long BgL_siza7ezd2framez75_13707;

				BgL_runz00_13706 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13702, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13707 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13702, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16224;

					BgL_sz00_16224 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16225;

						BgL_bpz00_16225 = VECTOR_REF(((obj_t) BgL_sz00_16224), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16225) + BgL_siza7ezd2framez75_13707) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16224))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3542z00_16226;

									BgL_arg3542z00_16226 =
										((long) CINT(BgL_bpz00_16225) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16224), BgL_arg3542z00_16226,
										BgL_lastz00_13708);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16227;

									BgL_ez00_16227 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16227,
										BgL_bpz00_16225);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16228;

										BgL_accz00_16228 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13706, BgL_sz00_16224, BgL_bpz00_16225);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16227);
										VECTOR_SET(
											((obj_t) BgL_sz00_16224), ((long) 0), BgL_bpz00_16225);
										return BgL_accz00_16228;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16229;

								BgL_nsz00_16229 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16229, ((long) 1), BgL_sz00_16224);
								VECTOR_SET(BgL_nsz00_16229, ((long) 2), BgL_lastz00_13708);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16230;

									BgL_z12denvz12_16230 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16230, BgL_nsz00_16229);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16231;

										BgL_ez00_16231 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16231,
											BgL_sz00_16224);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16232;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16233;

												BgL_savedzd2bpzd2_16233 =
													VECTOR_REF(BgL_nsz00_16229, ((long) 0));
												VECTOR_SET(BgL_nsz00_16229, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16235;

													BgL_fz00_16235 = BgL_runz00_13706;
												BgL_recz00_16234:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16236;

														BgL_rz00_16236 =
															PROCEDURE_ENTRY(BgL_fz00_16235) (BgL_fz00_16235,
															BgL_nsz00_16229, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5500z00_29883;

															if (PROCEDUREP(BgL_rz00_16236))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16237;

																	BgL_arg1729z00_16237 =
																		PROCEDURE_ATTR(BgL_rz00_16236);
																	if (STRUCTP(BgL_arg1729z00_16237))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5500z00_29883 =
																				(STRUCT_KEY(BgL_arg1729z00_16237) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5500z00_29883 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5500z00_29883 = ((bool_t) 0);
																}
															if (BgL_test5500z00_29883)
																{
																	obj_t BgL_fz00_29891;

																	BgL_fz00_29891 = BgL_rz00_16236;
																	BgL_fz00_16235 = BgL_fz00_29891;
																	goto BgL_recz00_16234;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16229, ((long) 0),
																		BgL_savedzd2bpzd2_16233);
																	BgL_____rz00_16232 = BgL_rz00_16236;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16231);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16230, BgL_sz00_16224);
											return BgL_____rz00_16232;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4560 */
	obj_t BGl_z62run4560z62zz__evaluate_compz00(obj_t BgL_envz00_13709,
		obj_t BgL_sz00_13713)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13710;
				BgL_ev_absz00_bglt BgL_i1247z00_13711;
				obj_t BgL_bodyz00_13712;

				BgL_iboxesz00_13710 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13709, (int) (((long) 0))));
				BgL_i1247z00_13711 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13709, (int) (((long) 1))));
				BgL_bodyz00_13712 = PROCEDURE_REF(BgL_envz00_13709, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16238;

					BgL_bpz00_16238 = VECTOR_REF(((obj_t) BgL_sz00_13713), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13713,
						BgL_iboxesz00_13710, BgL_bpz00_16238);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16239;
						obj_t BgL_wherez00_16240;
						obj_t BgL_locz00_16241;

						BgL_z12denvz12_16239 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16240 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13711))->
							BgL_wherez00);
						BgL_locz00_16241 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13711))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16239, BgL_wherez00_16240,
								BgL_locz00_16241);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16242;

								BgL_za2za2resza2za2z00_16242 =
									PROCEDURE_ENTRY(BgL_bodyz00_13712) (BgL_bodyz00_13712,
									BgL_sz00_13713, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16239);
								return BgL_za2za2resza2za2z00_16242;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3547> */
	obj_t BGl_z62zc3z04anonymousza33547ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13714, obj_t BgL_sz00_13720)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13715;
				long BgL_siza7eza7_13716;
				BgL_ev_absz00_bglt BgL_i1247z00_13717;
				obj_t BgL_bodyz00_13718;
				long BgL_siza7ezd2framez75_13719;

				BgL_ifreesz00_13715 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13714, (int) (((long) 0))));
				BgL_siza7eza7_13716 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13714, (int) (((long) 1))));
				BgL_i1247z00_13717 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13714, (int) (((long) 2))));
				BgL_bodyz00_13718 = PROCEDURE_REF(BgL_envz00_13714, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13719 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13714, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16243;

					BgL_bpz00_16243 = VECTOR_REF(((obj_t) BgL_sz00_13720), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16244;

						BgL_valza2za2_16244 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13720,
							BgL_bpz00_16243, BgL_ifreesz00_13715);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16245;

							BgL_runz00_16245 =
								MAKE_FX_PROCEDURE(BGl_z62run4562z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16245,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13716));
							PROCEDURE_SET(BgL_runz00_16245,
								(int) (((long) 1)), BgL_valza2za2_16244);
							PROCEDURE_SET(BgL_runz00_16245,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13717));
							PROCEDURE_SET(BgL_runz00_16245,
								(int) (((long) 3)), BgL_bodyz00_13718);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16246;

								BgL_mainz00_16246 =
									MAKE_VA_PROCEDURE(BGl_z62main4561z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16246,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13716));
								PROCEDURE_SET(BgL_mainz00_16246,
									(int) (((long) 1)), BgL_valza2za2_16244);
								PROCEDURE_SET(BgL_mainz00_16246,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13717));
								PROCEDURE_SET(BgL_mainz00_16246,
									(int) (((long) 3)), BgL_bodyz00_13718);
								PROCEDURE_SET(BgL_mainz00_16246,
									(int) (((long) 4)), BgL_runz00_16245);
								PROCEDURE_SET(BgL_mainz00_16246,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13719));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16247;

									BgL_objz00_16247 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16245, BgL_objz00_16247);
									BgL_objz00_16247;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3548z00_16248;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3549z00_16249;

										BgL_arg3549z00_16249 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13717))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16250;

											BgL_newz00_16250 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29967;

												BgL_tmpz00_29967 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16250, BgL_tmpz00_29967,
													BgL_arg3549z00_16249);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29972;
												int BgL_tmpz00_29970;

												BgL_auxz00_29972 = BINT(BgL_siza7ezd2framez75_13719);
												BgL_tmpz00_29970 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16250, BgL_tmpz00_29970,
													BgL_auxz00_29972);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29975;

												BgL_tmpz00_29975 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16250, BgL_tmpz00_29975,
													BgL_runz00_16245);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29980;
												int BgL_tmpz00_29978;

												BgL_auxz00_29980 = BINT(((long) -1));
												BgL_tmpz00_29978 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16250, BgL_tmpz00_29978,
													BgL_auxz00_29980);
											}
											BgL_arg3548z00_16248 = BgL_newz00_16250;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16246, BgL_arg3548z00_16248);
									BgL_arg3548z00_16248;
								}
								return BgL_mainz00_16246;
							}
						}
					}
				}
			}
		}

	}



/* &main4561 */
	obj_t BGl_z62main4561z62zz__evaluate_compz00(obj_t BgL_envz00_13721,
		obj_t BgL_lastz00_13728)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13726;
				long BgL_siza7ezd2framez75_13727;

				BgL_runz00_13726 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13721, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13727 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13721, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16251;

					BgL_sz00_16251 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16252;

						BgL_bpz00_16252 = VECTOR_REF(((obj_t) BgL_sz00_16251), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16252) + BgL_siza7ezd2framez75_13727) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16251))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3553z00_16253;

									BgL_arg3553z00_16253 =
										((long) CINT(BgL_bpz00_16252) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16251), BgL_arg3553z00_16253,
										BgL_lastz00_13728);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16254;

									BgL_ez00_16254 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16254,
										BgL_bpz00_16252);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16255;

										BgL_accz00_16255 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13726, BgL_sz00_16251, BgL_bpz00_16252);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16254);
										VECTOR_SET(
											((obj_t) BgL_sz00_16251), ((long) 0), BgL_bpz00_16252);
										return BgL_accz00_16255;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16256;

								BgL_nsz00_16256 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16256, ((long) 1), BgL_sz00_16251);
								VECTOR_SET(BgL_nsz00_16256, ((long) 2), BgL_lastz00_13728);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16257;

									BgL_z12denvz12_16257 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16257, BgL_nsz00_16256);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16258;

										BgL_ez00_16258 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16258,
											BgL_sz00_16251);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16259;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16260;

												BgL_savedzd2bpzd2_16260 =
													VECTOR_REF(BgL_nsz00_16256, ((long) 0));
												VECTOR_SET(BgL_nsz00_16256, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16262;

													BgL_fz00_16262 = BgL_runz00_13726;
												BgL_recz00_16261:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16263;

														BgL_rz00_16263 =
															PROCEDURE_ENTRY(BgL_fz00_16262) (BgL_fz00_16262,
															BgL_nsz00_16256, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5504z00_30023;

															if (PROCEDUREP(BgL_rz00_16263))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16264;

																	BgL_arg1729z00_16264 =
																		PROCEDURE_ATTR(BgL_rz00_16263);
																	if (STRUCTP(BgL_arg1729z00_16264))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5504z00_30023 =
																				(STRUCT_KEY(BgL_arg1729z00_16264) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5504z00_30023 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5504z00_30023 = ((bool_t) 0);
																}
															if (BgL_test5504z00_30023)
																{
																	obj_t BgL_fz00_30031;

																	BgL_fz00_30031 = BgL_rz00_16263;
																	BgL_fz00_16262 = BgL_fz00_30031;
																	goto BgL_recz00_16261;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16256, ((long) 0),
																		BgL_savedzd2bpzd2_16260);
																	BgL_____rz00_16259 = BgL_rz00_16263;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16258);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16257, BgL_sz00_16251);
											return BgL_____rz00_16259;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4562 */
	obj_t BGl_z62run4562z62zz__evaluate_compz00(obj_t BgL_envz00_13729,
		obj_t BgL_sz00_13734)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13730;
				obj_t BgL_valza2za2_13731;
				BgL_ev_absz00_bglt BgL_i1247z00_13732;
				obj_t BgL_bodyz00_13733;

				BgL_siza7eza7_13730 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13729, (int) (((long) 0))));
				BgL_valza2za2_13731 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13729, (int) (((long) 1))));
				BgL_i1247z00_13732 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13729, (int) (((long) 2))));
				BgL_bodyz00_13733 = PROCEDURE_REF(BgL_envz00_13729, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16265;

					BgL_bpz00_16265 = VECTOR_REF(((obj_t) BgL_sz00_13734), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13734,
						BgL_valza2za2_13731,
						((long) CINT(BgL_bpz00_16265) + BgL_siza7eza7_13730));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16266;
						obj_t BgL_wherez00_16267;
						obj_t BgL_locz00_16268;

						BgL_z12denvz12_16266 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16267 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13732))->
							BgL_wherez00);
						BgL_locz00_16268 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13732))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16266, BgL_wherez00_16267,
								BgL_locz00_16268);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16269;

								BgL_za2za2resza2za2z00_16269 =
									PROCEDURE_ENTRY(BgL_bodyz00_13733) (BgL_bodyz00_13733,
									BgL_sz00_13734, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16266);
								return BgL_za2za2resza2za2z00_16269;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3557> */
	obj_t BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13735, obj_t BgL_sz00_13742)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13736;
				obj_t BgL_iboxesz00_13737;
				long BgL_siza7eza7_13738;
				BgL_ev_absz00_bglt BgL_i1247z00_13739;
				obj_t BgL_bodyz00_13740;
				long BgL_siza7ezd2framez75_13741;

				BgL_ifreesz00_13736 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13735, (int) (((long) 0))));
				BgL_iboxesz00_13737 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13735, (int) (((long) 1))));
				BgL_siza7eza7_13738 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13735, (int) (((long) 2))));
				BgL_i1247z00_13739 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13735, (int) (((long) 3))));
				BgL_bodyz00_13740 = PROCEDURE_REF(BgL_envz00_13735, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13741 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13735, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16270;

					BgL_bpz00_16270 = VECTOR_REF(((obj_t) BgL_sz00_13742), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16271;

						BgL_valza2za2_16271 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13742,
							BgL_bpz00_16270, BgL_ifreesz00_13736);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16272;

							BgL_runz00_16272 =
								MAKE_FX_PROCEDURE(BGl_z62run4564z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16272,
								(int) (((long) 0)), BgL_iboxesz00_13737);
							PROCEDURE_SET(BgL_runz00_16272,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13738));
							PROCEDURE_SET(BgL_runz00_16272,
								(int) (((long) 2)), BgL_valza2za2_16271);
							PROCEDURE_SET(BgL_runz00_16272,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13739));
							PROCEDURE_SET(BgL_runz00_16272,
								(int) (((long) 4)), BgL_bodyz00_13740);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16273;

								BgL_mainz00_16273 =
									MAKE_VA_PROCEDURE(BGl_z62main4563z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16273,
									(int) (((long) 0)), BgL_iboxesz00_13737);
								PROCEDURE_SET(BgL_mainz00_16273,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13738));
								PROCEDURE_SET(BgL_mainz00_16273,
									(int) (((long) 2)), BgL_valza2za2_16271);
								PROCEDURE_SET(BgL_mainz00_16273,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13739));
								PROCEDURE_SET(BgL_mainz00_16273,
									(int) (((long) 4)), BgL_bodyz00_13740);
								PROCEDURE_SET(BgL_mainz00_16273,
									(int) (((long) 5)), BgL_runz00_16272);
								PROCEDURE_SET(BgL_mainz00_16273,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13741));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16274;

									BgL_objz00_16274 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16272, BgL_objz00_16274);
									BgL_objz00_16274;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3558z00_16275;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3559z00_16276;

										BgL_arg3559z00_16276 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13739))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16277;

											BgL_newz00_16277 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30119;

												BgL_tmpz00_30119 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16277, BgL_tmpz00_30119,
													BgL_arg3559z00_16276);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30124;
												int BgL_tmpz00_30122;

												BgL_auxz00_30124 = BINT(BgL_siza7ezd2framez75_13741);
												BgL_tmpz00_30122 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16277, BgL_tmpz00_30122,
													BgL_auxz00_30124);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30127;

												BgL_tmpz00_30127 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16277, BgL_tmpz00_30127,
													BgL_runz00_16272);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30132;
												int BgL_tmpz00_30130;

												BgL_auxz00_30132 = BINT(((long) -1));
												BgL_tmpz00_30130 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16277, BgL_tmpz00_30130,
													BgL_auxz00_30132);
											}
											BgL_arg3558z00_16275 = BgL_newz00_16277;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16273, BgL_arg3558z00_16275);
									BgL_arg3558z00_16275;
								}
								return BgL_mainz00_16273;
							}
						}
					}
				}
			}
		}

	}



/* &main4563 */
	obj_t BGl_z62main4563z62zz__evaluate_compz00(obj_t BgL_envz00_13743,
		obj_t BgL_lastz00_13751)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13749;
				long BgL_siza7ezd2framez75_13750;

				BgL_runz00_13749 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13743, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13750 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13743, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16278;

					BgL_sz00_16278 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16279;

						BgL_bpz00_16279 = VECTOR_REF(((obj_t) BgL_sz00_16278), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16279) + BgL_siza7ezd2framez75_13750) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16278))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3562z00_16280;

									BgL_arg3562z00_16280 =
										((long) CINT(BgL_bpz00_16279) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16278), BgL_arg3562z00_16280,
										BgL_lastz00_13751);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16281;

									BgL_ez00_16281 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16281,
										BgL_bpz00_16279);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16282;

										BgL_accz00_16282 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13749, BgL_sz00_16278, BgL_bpz00_16279);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16281);
										VECTOR_SET(
											((obj_t) BgL_sz00_16278), ((long) 0), BgL_bpz00_16279);
										return BgL_accz00_16282;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16283;

								BgL_nsz00_16283 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16283, ((long) 1), BgL_sz00_16278);
								VECTOR_SET(BgL_nsz00_16283, ((long) 2), BgL_lastz00_13751);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16284;

									BgL_z12denvz12_16284 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16284, BgL_nsz00_16283);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16285;

										BgL_ez00_16285 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16285,
											BgL_sz00_16278);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16286;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16287;

												BgL_savedzd2bpzd2_16287 =
													VECTOR_REF(BgL_nsz00_16283, ((long) 0));
												VECTOR_SET(BgL_nsz00_16283, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16289;

													BgL_fz00_16289 = BgL_runz00_13749;
												BgL_recz00_16288:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16290;

														BgL_rz00_16290 =
															PROCEDURE_ENTRY(BgL_fz00_16289) (BgL_fz00_16289,
															BgL_nsz00_16283, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5508z00_30175;

															if (PROCEDUREP(BgL_rz00_16290))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16291;

																	BgL_arg1729z00_16291 =
																		PROCEDURE_ATTR(BgL_rz00_16290);
																	if (STRUCTP(BgL_arg1729z00_16291))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5508z00_30175 =
																				(STRUCT_KEY(BgL_arg1729z00_16291) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5508z00_30175 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5508z00_30175 = ((bool_t) 0);
																}
															if (BgL_test5508z00_30175)
																{
																	obj_t BgL_fz00_30183;

																	BgL_fz00_30183 = BgL_rz00_16290;
																	BgL_fz00_16289 = BgL_fz00_30183;
																	goto BgL_recz00_16288;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16283, ((long) 0),
																		BgL_savedzd2bpzd2_16287);
																	BgL_____rz00_16286 = BgL_rz00_16290;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16285);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16284, BgL_sz00_16278);
											return BgL_____rz00_16286;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4564 */
	obj_t BGl_z62run4564z62zz__evaluate_compz00(obj_t BgL_envz00_13752,
		obj_t BgL_sz00_13758)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13753;
				long BgL_siza7eza7_13754;
				obj_t BgL_valza2za2_13755;
				BgL_ev_absz00_bglt BgL_i1247z00_13756;
				obj_t BgL_bodyz00_13757;

				BgL_iboxesz00_13753 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13752, (int) (((long) 0))));
				BgL_siza7eza7_13754 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13752, (int) (((long) 1))));
				BgL_valza2za2_13755 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13752, (int) (((long) 2))));
				BgL_i1247z00_13756 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13752, (int) (((long) 3))));
				BgL_bodyz00_13757 = PROCEDURE_REF(BgL_envz00_13752, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16292;

					BgL_bpz00_16292 = VECTOR_REF(((obj_t) BgL_sz00_13758), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13758,
						BgL_iboxesz00_13753, BgL_bpz00_16292);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13758,
						BgL_valza2za2_13755,
						((long) CINT(BgL_bpz00_16292) + BgL_siza7eza7_13754));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16293;
						obj_t BgL_wherez00_16294;
						obj_t BgL_locz00_16295;

						BgL_z12denvz12_16293 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16294 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13756))->
							BgL_wherez00);
						BgL_locz00_16295 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13756))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16293, BgL_wherez00_16294,
								BgL_locz00_16295);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16296;

								BgL_za2za2resza2za2z00_16296 =
									PROCEDURE_ENTRY(BgL_bodyz00_13757) (BgL_bodyz00_13757,
									BgL_sz00_13758, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16293);
								return BgL_za2za2resza2za2z00_16296;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3490> */
	obj_t BGl_z62zc3z04anonymousza33490ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13759, obj_t BgL_sz00_13763)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13760;
				obj_t BgL_bodyz00_13761;
				long BgL_siza7ezd2framez75_13762;

				BgL_i1247z00_13760 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13759, (int) (((long) 0))));
				BgL_bodyz00_13761 = PROCEDURE_REF(BgL_envz00_13759, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13762 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13759, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16297;

					BgL_bpz00_16297 = VECTOR_REF(((obj_t) BgL_sz00_13763), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16298;

							BgL_runz00_16298 =
								MAKE_FX_PROCEDURE(BGl_z62run4566z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16298,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13760));
							PROCEDURE_SET(BgL_runz00_16298,
								(int) (((long) 1)), BgL_bodyz00_13761);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16299;

								BgL_mainz00_16299 =
									MAKE_FX_PROCEDURE(BGl_z62main4565z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16299,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_13760));
								PROCEDURE_SET(BgL_mainz00_16299,
									(int) (((long) 1)), BgL_bodyz00_13761);
								PROCEDURE_SET(BgL_mainz00_16299,
									(int) (((long) 2)), BgL_runz00_16298);
								PROCEDURE_SET(BgL_mainz00_16299,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13762));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16300;

									BgL_objz00_16300 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16298, BgL_objz00_16300);
									BgL_objz00_16300;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3491z00_16301;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3492z00_16302;

										BgL_arg3492z00_16302 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13760))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16303;

											BgL_newz00_16303 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30251;

												BgL_tmpz00_30251 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16303, BgL_tmpz00_30251,
													BgL_arg3492z00_16302);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30256;
												int BgL_tmpz00_30254;

												BgL_auxz00_30256 = BINT(BgL_siza7ezd2framez75_13762);
												BgL_tmpz00_30254 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16303, BgL_tmpz00_30254,
													BgL_auxz00_30256);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30259;

												BgL_tmpz00_30259 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16303, BgL_tmpz00_30259,
													BgL_runz00_16298);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30264;
												int BgL_tmpz00_30262;

												BgL_auxz00_30264 = BINT(((long) 0));
												BgL_tmpz00_30262 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16303, BgL_tmpz00_30262,
													BgL_auxz00_30264);
											}
											BgL_arg3491z00_16301 = BgL_newz00_16303;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16299, BgL_arg3491z00_16301);
									BgL_arg3491z00_16301;
								}
								return BgL_mainz00_16299;
							}
						}
					}
				}
			}
		}

	}



/* &main4565 */
	obj_t BGl_z62main4565z62zz__evaluate_compz00(obj_t BgL_envz00_13764)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13767;
				long BgL_siza7ezd2framez75_13768;

				BgL_runz00_13767 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13768 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16304;

					BgL_sz00_16304 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16305;

						BgL_bpz00_16305 = VECTOR_REF(((obj_t) BgL_sz00_16304), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16305) + BgL_siza7ezd2framez75_13768) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16304))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_16306;

								BgL_ez00_16306 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16306,
									BgL_bpz00_16305);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_16307;

									BgL_accz00_16307 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_13767, BgL_sz00_16304, BgL_bpz00_16305);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16306);
									VECTOR_SET(
										((obj_t) BgL_sz00_16304), ((long) 0), BgL_bpz00_16305);
									return BgL_accz00_16307;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16308;

								BgL_nsz00_16308 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16308, ((long) 1), BgL_sz00_16304);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16309;

									BgL_z12denvz12_16309 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16309, BgL_nsz00_16308);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16310;

										BgL_ez00_16310 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16310,
											BgL_sz00_16304);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16311;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16312;

												BgL_savedzd2bpzd2_16312 =
													VECTOR_REF(BgL_nsz00_16308, ((long) 0));
												VECTOR_SET(BgL_nsz00_16308, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16314;

													BgL_fz00_16314 = BgL_runz00_13767;
												BgL_recz00_16313:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16315;

														BgL_rz00_16315 =
															PROCEDURE_ENTRY(BgL_fz00_16314) (BgL_fz00_16314,
															BgL_nsz00_16308, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5512z00_30302;

															if (PROCEDUREP(BgL_rz00_16315))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16316;

																	BgL_arg1729z00_16316 =
																		PROCEDURE_ATTR(BgL_rz00_16315);
																	if (STRUCTP(BgL_arg1729z00_16316))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5512z00_30302 =
																				(STRUCT_KEY(BgL_arg1729z00_16316) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5512z00_30302 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5512z00_30302 = ((bool_t) 0);
																}
															if (BgL_test5512z00_30302)
																{
																	obj_t BgL_fz00_30310;

																	BgL_fz00_30310 = BgL_rz00_16315;
																	BgL_fz00_16314 = BgL_fz00_30310;
																	goto BgL_recz00_16313;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16308, ((long) 0),
																		BgL_savedzd2bpzd2_16312);
																	BgL_____rz00_16311 = BgL_rz00_16315;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16310);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16309, BgL_sz00_16304);
											return BgL_____rz00_16311;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4566 */
	obj_t BGl_z62run4566z62zz__evaluate_compz00(obj_t BgL_envz00_13769,
		obj_t BgL_sz00_13772)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13770;
				obj_t BgL_bodyz00_13771;

				BgL_i1247z00_13770 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13769, (int) (((long) 0))));
				BgL_bodyz00_13771 = PROCEDURE_REF(BgL_envz00_13769, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16317;

					BgL_bpz00_16317 = VECTOR_REF(((obj_t) BgL_sz00_13772), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16318;
						obj_t BgL_wherez00_16319;
						obj_t BgL_locz00_16320;

						BgL_z12denvz12_16318 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16319 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13770))->
							BgL_wherez00);
						BgL_locz00_16320 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13770))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16318, BgL_wherez00_16319,
								BgL_locz00_16320);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16321;

								BgL_za2za2resza2za2z00_16321 =
									PROCEDURE_ENTRY(BgL_bodyz00_13771) (BgL_bodyz00_13771,
									BgL_sz00_13772, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16318);
								return BgL_za2za2resza2za2z00_16321;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3496> */
	obj_t BGl_z62zc3z04anonymousza33496ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13773, obj_t BgL_sz00_13778)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13774;
				BgL_ev_absz00_bglt BgL_i1247z00_13775;
				obj_t BgL_bodyz00_13776;
				long BgL_siza7ezd2framez75_13777;

				BgL_iboxesz00_13774 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 0))));
				BgL_i1247z00_13775 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 1))));
				BgL_bodyz00_13776 = PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13777 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13773, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16322;

					BgL_bpz00_16322 = VECTOR_REF(((obj_t) BgL_sz00_13778), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16323;

							BgL_runz00_16323 =
								MAKE_FX_PROCEDURE(BGl_z62run4568z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16323,
								(int) (((long) 0)), BgL_iboxesz00_13774);
							PROCEDURE_SET(BgL_runz00_16323,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13775));
							PROCEDURE_SET(BgL_runz00_16323,
								(int) (((long) 2)), BgL_bodyz00_13776);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16324;

								BgL_mainz00_16324 =
									MAKE_FX_PROCEDURE(BGl_z62main4567z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16324,
									(int) (((long) 0)), BgL_iboxesz00_13774);
								PROCEDURE_SET(BgL_mainz00_16324,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13775));
								PROCEDURE_SET(BgL_mainz00_16324,
									(int) (((long) 2)), BgL_bodyz00_13776);
								PROCEDURE_SET(BgL_mainz00_16324,
									(int) (((long) 3)), BgL_runz00_16323);
								PROCEDURE_SET(BgL_mainz00_16324,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13777));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16325;

									BgL_objz00_16325 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16323, BgL_objz00_16325);
									BgL_objz00_16325;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3497z00_16326;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3499z00_16327;

										BgL_arg3499z00_16327 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13775))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16328;

											BgL_newz00_16328 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30372;

												BgL_tmpz00_30372 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16328, BgL_tmpz00_30372,
													BgL_arg3499z00_16327);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30377;
												int BgL_tmpz00_30375;

												BgL_auxz00_30377 = BINT(BgL_siza7ezd2framez75_13777);
												BgL_tmpz00_30375 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16328, BgL_tmpz00_30375,
													BgL_auxz00_30377);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30380;

												BgL_tmpz00_30380 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16328, BgL_tmpz00_30380,
													BgL_runz00_16323);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30385;
												int BgL_tmpz00_30383;

												BgL_auxz00_30385 = BINT(((long) 0));
												BgL_tmpz00_30383 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16328, BgL_tmpz00_30383,
													BgL_auxz00_30385);
											}
											BgL_arg3497z00_16326 = BgL_newz00_16328;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16324, BgL_arg3497z00_16326);
									BgL_arg3497z00_16326;
								}
								return BgL_mainz00_16324;
							}
						}
					}
				}
			}
		}

	}



/* &main4567 */
	obj_t BGl_z62main4567z62zz__evaluate_compz00(obj_t BgL_envz00_13779)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13783;
				long BgL_siza7ezd2framez75_13784;

				BgL_runz00_13783 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13784 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16329;

					BgL_sz00_16329 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16330;

						BgL_bpz00_16330 = VECTOR_REF(((obj_t) BgL_sz00_16329), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16330) + BgL_siza7ezd2framez75_13784) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16329))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_16331;

								BgL_ez00_16331 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16331,
									BgL_bpz00_16330);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_16332;

									BgL_accz00_16332 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_13783, BgL_sz00_16329, BgL_bpz00_16330);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16331);
									VECTOR_SET(
										((obj_t) BgL_sz00_16329), ((long) 0), BgL_bpz00_16330);
									return BgL_accz00_16332;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16333;

								BgL_nsz00_16333 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16333, ((long) 1), BgL_sz00_16329);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16334;

									BgL_z12denvz12_16334 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16334, BgL_nsz00_16333);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16335;

										BgL_ez00_16335 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16335,
											BgL_sz00_16329);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16336;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16337;

												BgL_savedzd2bpzd2_16337 =
													VECTOR_REF(BgL_nsz00_16333, ((long) 0));
												VECTOR_SET(BgL_nsz00_16333, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16339;

													BgL_fz00_16339 = BgL_runz00_13783;
												BgL_recz00_16338:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16340;

														BgL_rz00_16340 =
															PROCEDURE_ENTRY(BgL_fz00_16339) (BgL_fz00_16339,
															BgL_nsz00_16333, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5516z00_30423;

															if (PROCEDUREP(BgL_rz00_16340))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16341;

																	BgL_arg1729z00_16341 =
																		PROCEDURE_ATTR(BgL_rz00_16340);
																	if (STRUCTP(BgL_arg1729z00_16341))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5516z00_30423 =
																				(STRUCT_KEY(BgL_arg1729z00_16341) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5516z00_30423 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5516z00_30423 = ((bool_t) 0);
																}
															if (BgL_test5516z00_30423)
																{
																	obj_t BgL_fz00_30431;

																	BgL_fz00_30431 = BgL_rz00_16340;
																	BgL_fz00_16339 = BgL_fz00_30431;
																	goto BgL_recz00_16338;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16333, ((long) 0),
																		BgL_savedzd2bpzd2_16337);
																	BgL_____rz00_16336 = BgL_rz00_16340;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16335);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16334, BgL_sz00_16329);
											return BgL_____rz00_16336;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4568 */
	obj_t BGl_z62run4568z62zz__evaluate_compz00(obj_t BgL_envz00_13785,
		obj_t BgL_sz00_13789)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13786;
				BgL_ev_absz00_bglt BgL_i1247z00_13787;
				obj_t BgL_bodyz00_13788;

				BgL_iboxesz00_13786 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13785, (int) (((long) 0))));
				BgL_i1247z00_13787 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13785, (int) (((long) 1))));
				BgL_bodyz00_13788 = PROCEDURE_REF(BgL_envz00_13785, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16342;

					BgL_bpz00_16342 = VECTOR_REF(((obj_t) BgL_sz00_13789), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13789,
						BgL_iboxesz00_13786, BgL_bpz00_16342);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16343;
						obj_t BgL_wherez00_16344;
						obj_t BgL_locz00_16345;

						BgL_z12denvz12_16343 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16344 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13787))->
							BgL_wherez00);
						BgL_locz00_16345 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13787))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16343, BgL_wherez00_16344,
								BgL_locz00_16345);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16346;

								BgL_za2za2resza2za2z00_16346 =
									PROCEDURE_ENTRY(BgL_bodyz00_13788) (BgL_bodyz00_13788,
									BgL_sz00_13789, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16343);
								return BgL_za2za2resza2za2z00_16346;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3506> */
	obj_t BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13790, obj_t BgL_sz00_13796)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13791;
				long BgL_siza7eza7_13792;
				BgL_ev_absz00_bglt BgL_i1247z00_13793;
				obj_t BgL_bodyz00_13794;
				long BgL_siza7ezd2framez75_13795;

				BgL_ifreesz00_13791 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13790, (int) (((long) 0))));
				BgL_siza7eza7_13792 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13790, (int) (((long) 1))));
				BgL_i1247z00_13793 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13790, (int) (((long) 2))));
				BgL_bodyz00_13794 = PROCEDURE_REF(BgL_envz00_13790, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13795 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13790, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16347;

					BgL_bpz00_16347 = VECTOR_REF(((obj_t) BgL_sz00_13796), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16348;

						BgL_valza2za2_16348 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13796,
							BgL_bpz00_16347, BgL_ifreesz00_13791);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16349;

							BgL_runz00_16349 =
								MAKE_FX_PROCEDURE(BGl_z62run4570z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16349,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13792));
							PROCEDURE_SET(BgL_runz00_16349,
								(int) (((long) 1)), BgL_valza2za2_16348);
							PROCEDURE_SET(BgL_runz00_16349,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13793));
							PROCEDURE_SET(BgL_runz00_16349,
								(int) (((long) 3)), BgL_bodyz00_13794);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16350;

								BgL_mainz00_16350 =
									MAKE_FX_PROCEDURE(BGl_z62main4569z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16350,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13792));
								PROCEDURE_SET(BgL_mainz00_16350,
									(int) (((long) 1)), BgL_valza2za2_16348);
								PROCEDURE_SET(BgL_mainz00_16350,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13793));
								PROCEDURE_SET(BgL_mainz00_16350,
									(int) (((long) 3)), BgL_bodyz00_13794);
								PROCEDURE_SET(BgL_mainz00_16350,
									(int) (((long) 4)), BgL_runz00_16349);
								PROCEDURE_SET(BgL_mainz00_16350,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13795));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16351;

									BgL_objz00_16351 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16349, BgL_objz00_16351);
									BgL_objz00_16351;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3507z00_16352;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3509z00_16353;

										BgL_arg3509z00_16353 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13793))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16354;

											BgL_newz00_16354 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30507;

												BgL_tmpz00_30507 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16354, BgL_tmpz00_30507,
													BgL_arg3509z00_16353);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30512;
												int BgL_tmpz00_30510;

												BgL_auxz00_30512 = BINT(BgL_siza7ezd2framez75_13795);
												BgL_tmpz00_30510 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16354, BgL_tmpz00_30510,
													BgL_auxz00_30512);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30515;

												BgL_tmpz00_30515 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16354, BgL_tmpz00_30515,
													BgL_runz00_16349);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30520;
												int BgL_tmpz00_30518;

												BgL_auxz00_30520 = BINT(((long) 0));
												BgL_tmpz00_30518 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16354, BgL_tmpz00_30518,
													BgL_auxz00_30520);
											}
											BgL_arg3507z00_16352 = BgL_newz00_16354;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16350, BgL_arg3507z00_16352);
									BgL_arg3507z00_16352;
								}
								return BgL_mainz00_16350;
							}
						}
					}
				}
			}
		}

	}



/* &main4569 */
	obj_t BGl_z62main4569z62zz__evaluate_compz00(obj_t BgL_envz00_13797)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13802;
				long BgL_siza7ezd2framez75_13803;

				BgL_runz00_13802 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13803 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16355;

					BgL_sz00_16355 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16356;

						BgL_bpz00_16356 = VECTOR_REF(((obj_t) BgL_sz00_16355), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16356) + BgL_siza7ezd2framez75_13803) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16355))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_16357;

								BgL_ez00_16357 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16357,
									BgL_bpz00_16356);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_16358;

									BgL_accz00_16358 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_13802, BgL_sz00_16355, BgL_bpz00_16356);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16357);
									VECTOR_SET(
										((obj_t) BgL_sz00_16355), ((long) 0), BgL_bpz00_16356);
									return BgL_accz00_16358;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16359;

								BgL_nsz00_16359 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16359, ((long) 1), BgL_sz00_16355);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16360;

									BgL_z12denvz12_16360 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16360, BgL_nsz00_16359);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16361;

										BgL_ez00_16361 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16361,
											BgL_sz00_16355);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16362;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16363;

												BgL_savedzd2bpzd2_16363 =
													VECTOR_REF(BgL_nsz00_16359, ((long) 0));
												VECTOR_SET(BgL_nsz00_16359, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16365;

													BgL_fz00_16365 = BgL_runz00_13802;
												BgL_recz00_16364:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16366;

														BgL_rz00_16366 =
															PROCEDURE_ENTRY(BgL_fz00_16365) (BgL_fz00_16365,
															BgL_nsz00_16359, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5520z00_30558;

															if (PROCEDUREP(BgL_rz00_16366))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16367;

																	BgL_arg1729z00_16367 =
																		PROCEDURE_ATTR(BgL_rz00_16366);
																	if (STRUCTP(BgL_arg1729z00_16367))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5520z00_30558 =
																				(STRUCT_KEY(BgL_arg1729z00_16367) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5520z00_30558 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5520z00_30558 = ((bool_t) 0);
																}
															if (BgL_test5520z00_30558)
																{
																	obj_t BgL_fz00_30566;

																	BgL_fz00_30566 = BgL_rz00_16366;
																	BgL_fz00_16365 = BgL_fz00_30566;
																	goto BgL_recz00_16364;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16359, ((long) 0),
																		BgL_savedzd2bpzd2_16363);
																	BgL_____rz00_16362 = BgL_rz00_16366;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16361);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16360, BgL_sz00_16355);
											return BgL_____rz00_16362;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4570 */
	obj_t BGl_z62run4570z62zz__evaluate_compz00(obj_t BgL_envz00_13804,
		obj_t BgL_sz00_13809)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13805;
				obj_t BgL_valza2za2_13806;
				BgL_ev_absz00_bglt BgL_i1247z00_13807;
				obj_t BgL_bodyz00_13808;

				BgL_siza7eza7_13805 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13804, (int) (((long) 0))));
				BgL_valza2za2_13806 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13804, (int) (((long) 1))));
				BgL_i1247z00_13807 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13804, (int) (((long) 2))));
				BgL_bodyz00_13808 = PROCEDURE_REF(BgL_envz00_13804, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16368;

					BgL_bpz00_16368 = VECTOR_REF(((obj_t) BgL_sz00_13809), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13809,
						BgL_valza2za2_13806,
						((long) CINT(BgL_bpz00_16368) + BgL_siza7eza7_13805));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16369;
						obj_t BgL_wherez00_16370;
						obj_t BgL_locz00_16371;

						BgL_z12denvz12_16369 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16370 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13807))->
							BgL_wherez00);
						BgL_locz00_16371 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13807))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16369, BgL_wherez00_16370,
								BgL_locz00_16371);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16372;

								BgL_za2za2resza2za2z00_16372 =
									PROCEDURE_ENTRY(BgL_bodyz00_13808) (BgL_bodyz00_13808,
									BgL_sz00_13809, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16369);
								return BgL_za2za2resza2za2z00_16372;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3515> */
	obj_t BGl_z62zc3z04anonymousza33515ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13810, obj_t BgL_sz00_13817)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13811;
				obj_t BgL_iboxesz00_13812;
				long BgL_siza7eza7_13813;
				BgL_ev_absz00_bglt BgL_i1247z00_13814;
				obj_t BgL_bodyz00_13815;
				long BgL_siza7ezd2framez75_13816;

				BgL_ifreesz00_13811 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 0))));
				BgL_iboxesz00_13812 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 1))));
				BgL_siza7eza7_13813 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 2))));
				BgL_i1247z00_13814 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 3))));
				BgL_bodyz00_13815 = PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13816 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16373;

					BgL_bpz00_16373 = VECTOR_REF(((obj_t) BgL_sz00_13817), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16374;

						BgL_valza2za2_16374 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13817,
							BgL_bpz00_16373, BgL_ifreesz00_13811);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16375;

							BgL_runz00_16375 =
								MAKE_FX_PROCEDURE(BGl_z62run4572z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16375,
								(int) (((long) 0)), BgL_iboxesz00_13812);
							PROCEDURE_SET(BgL_runz00_16375,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13813));
							PROCEDURE_SET(BgL_runz00_16375,
								(int) (((long) 2)), BgL_valza2za2_16374);
							PROCEDURE_SET(BgL_runz00_16375,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13814));
							PROCEDURE_SET(BgL_runz00_16375,
								(int) (((long) 4)), BgL_bodyz00_13815);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16376;

								BgL_mainz00_16376 =
									MAKE_FX_PROCEDURE(BGl_z62main4571z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16376,
									(int) (((long) 0)), BgL_iboxesz00_13812);
								PROCEDURE_SET(BgL_mainz00_16376,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13813));
								PROCEDURE_SET(BgL_mainz00_16376,
									(int) (((long) 2)), BgL_valza2za2_16374);
								PROCEDURE_SET(BgL_mainz00_16376,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13814));
								PROCEDURE_SET(BgL_mainz00_16376,
									(int) (((long) 4)), BgL_bodyz00_13815);
								PROCEDURE_SET(BgL_mainz00_16376,
									(int) (((long) 5)), BgL_runz00_16375);
								PROCEDURE_SET(BgL_mainz00_16376,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13816));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16377;

									BgL_objz00_16377 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16375, BgL_objz00_16377);
									BgL_objz00_16377;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3517z00_16378;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3518z00_16379;

										BgL_arg3518z00_16379 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13814))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16380;

											BgL_newz00_16380 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30654;

												BgL_tmpz00_30654 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16380, BgL_tmpz00_30654,
													BgL_arg3518z00_16379);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30659;
												int BgL_tmpz00_30657;

												BgL_auxz00_30659 = BINT(BgL_siza7ezd2framez75_13816);
												BgL_tmpz00_30657 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16380, BgL_tmpz00_30657,
													BgL_auxz00_30659);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30662;

												BgL_tmpz00_30662 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16380, BgL_tmpz00_30662,
													BgL_runz00_16375);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30667;
												int BgL_tmpz00_30665;

												BgL_auxz00_30667 = BINT(((long) 0));
												BgL_tmpz00_30665 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16380, BgL_tmpz00_30665,
													BgL_auxz00_30667);
											}
											BgL_arg3517z00_16378 = BgL_newz00_16380;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16376, BgL_arg3517z00_16378);
									BgL_arg3517z00_16378;
								}
								return BgL_mainz00_16376;
							}
						}
					}
				}
			}
		}

	}



/* &main4571 */
	obj_t BGl_z62main4571z62zz__evaluate_compz00(obj_t BgL_envz00_13818)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_13824;
				long BgL_siza7ezd2framez75_13825;

				BgL_runz00_13824 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13818, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13825 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13818, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16381;

					BgL_sz00_16381 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16382;

						BgL_bpz00_16382 = VECTOR_REF(((obj_t) BgL_sz00_16381), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16382) + BgL_siza7ezd2framez75_13825) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16381))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_16383;

								BgL_ez00_16383 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16383,
									BgL_bpz00_16382);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_16384;

									BgL_accz00_16384 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_13824, BgL_sz00_16381, BgL_bpz00_16382);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16383);
									VECTOR_SET(
										((obj_t) BgL_sz00_16381), ((long) 0), BgL_bpz00_16382);
									return BgL_accz00_16384;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16385;

								BgL_nsz00_16385 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16385, ((long) 1), BgL_sz00_16381);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16386;

									BgL_z12denvz12_16386 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16386, BgL_nsz00_16385);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16387;

										BgL_ez00_16387 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16387,
											BgL_sz00_16381);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16388;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16389;

												BgL_savedzd2bpzd2_16389 =
													VECTOR_REF(BgL_nsz00_16385, ((long) 0));
												VECTOR_SET(BgL_nsz00_16385, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16391;

													BgL_fz00_16391 = BgL_runz00_13824;
												BgL_recz00_16390:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16392;

														BgL_rz00_16392 =
															PROCEDURE_ENTRY(BgL_fz00_16391) (BgL_fz00_16391,
															BgL_nsz00_16385, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5524z00_30705;

															if (PROCEDUREP(BgL_rz00_16392))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16393;

																	BgL_arg1729z00_16393 =
																		PROCEDURE_ATTR(BgL_rz00_16392);
																	if (STRUCTP(BgL_arg1729z00_16393))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5524z00_30705 =
																				(STRUCT_KEY(BgL_arg1729z00_16393) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5524z00_30705 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5524z00_30705 = ((bool_t) 0);
																}
															if (BgL_test5524z00_30705)
																{
																	obj_t BgL_fz00_30713;

																	BgL_fz00_30713 = BgL_rz00_16392;
																	BgL_fz00_16391 = BgL_fz00_30713;
																	goto BgL_recz00_16390;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16385, ((long) 0),
																		BgL_savedzd2bpzd2_16389);
																	BgL_____rz00_16388 = BgL_rz00_16392;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16387);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16386, BgL_sz00_16381);
											return BgL_____rz00_16388;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4572 */
	obj_t BGl_z62run4572z62zz__evaluate_compz00(obj_t BgL_envz00_13826,
		obj_t BgL_sz00_13832)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13827;
				long BgL_siza7eza7_13828;
				obj_t BgL_valza2za2_13829;
				BgL_ev_absz00_bglt BgL_i1247z00_13830;
				obj_t BgL_bodyz00_13831;

				BgL_iboxesz00_13827 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13826, (int) (((long) 0))));
				BgL_siza7eza7_13828 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13826, (int) (((long) 1))));
				BgL_valza2za2_13829 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13826, (int) (((long) 2))));
				BgL_i1247z00_13830 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13826, (int) (((long) 3))));
				BgL_bodyz00_13831 = PROCEDURE_REF(BgL_envz00_13826, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16394;

					BgL_bpz00_16394 = VECTOR_REF(((obj_t) BgL_sz00_13832), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13832,
						BgL_iboxesz00_13827, BgL_bpz00_16394);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13832,
						BgL_valza2za2_13829,
						((long) CINT(BgL_bpz00_16394) + BgL_siza7eza7_13828));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16395;
						obj_t BgL_wherez00_16396;
						obj_t BgL_locz00_16397;

						BgL_z12denvz12_16395 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16396 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13830))->
							BgL_wherez00);
						BgL_locz00_16397 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13830))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16395, BgL_wherez00_16396,
								BgL_locz00_16397);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16398;

								BgL_za2za2resza2za2z00_16398 =
									PROCEDURE_ENTRY(BgL_bodyz00_13831) (BgL_bodyz00_13831,
									BgL_sz00_13832, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16395);
								return BgL_za2za2resza2za2z00_16398;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3960> */
	obj_t BGl_z62zc3z04anonymousza33960ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13833, obj_t BgL_sz00_13837)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13834;
				obj_t BgL_bodyz00_13835;
				long BgL_siza7ezd2framez75_13836;

				BgL_i1247z00_13834 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13833, (int) (((long) 0))));
				BgL_bodyz00_13835 = PROCEDURE_REF(BgL_envz00_13833, (int) (((long) 1)));
				BgL_siza7ezd2framez75_13836 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13833, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16399;

					BgL_bpz00_16399 = VECTOR_REF(((obj_t) BgL_sz00_13837), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16400;

							BgL_runz00_16400 =
								MAKE_FX_PROCEDURE(BGl_z62run4574z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16400,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_13834));
							PROCEDURE_SET(BgL_runz00_16400,
								(int) (((long) 1)), BgL_bodyz00_13835);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16401;

								BgL_mainz00_16401 =
									MAKE_VA_PROCEDURE(BGl_z62main4573z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16401,
									(int) (((long) 0)), BgL_bodyz00_13835);
								PROCEDURE_SET(BgL_mainz00_16401,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_13834));
								PROCEDURE_SET(BgL_mainz00_16401,
									(int) (((long) 2)), BgL_runz00_16400);
								PROCEDURE_SET(BgL_mainz00_16401,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_13836));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16402;

									BgL_objz00_16402 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16400, BgL_objz00_16402);
									BgL_objz00_16402;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3961z00_16403;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3962z00_16404;
										obj_t BgL_arg3963z00_16405;

										BgL_arg3962z00_16404 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13834))->
											BgL_arityz00);
										BgL_arg3963z00_16405 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13834))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16406;

											BgL_newz00_16406 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30782;

												BgL_tmpz00_30782 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16406, BgL_tmpz00_30782,
													BgL_arg3963z00_16405);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30787;
												int BgL_tmpz00_30785;

												BgL_auxz00_30787 = BINT(BgL_siza7ezd2framez75_13836);
												BgL_tmpz00_30785 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16406, BgL_tmpz00_30785,
													BgL_auxz00_30787);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30790;

												BgL_tmpz00_30790 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16406, BgL_tmpz00_30790,
													BgL_runz00_16400);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30793;

												BgL_tmpz00_30793 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16406, BgL_tmpz00_30793,
													BgL_arg3962z00_16404);
											}
											BgL_arg3961z00_16403 = BgL_newz00_16406;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16401, BgL_arg3961z00_16403);
									BgL_arg3961z00_16403;
								}
								return BgL_mainz00_16401;
							}
						}
					}
				}
			}
		}

	}



/* &main4573 */
	obj_t BGl_z62main4573z62zz__evaluate_compz00(obj_t BgL_envz00_13838,
		obj_t BgL_az00_13843, obj_t BgL_bz00_13844, obj_t BgL_cz00_13845,
		obj_t BgL_dz00_13846, obj_t BgL_restz00_13847)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13840;
				obj_t BgL_runz00_13841;
				long BgL_siza7ezd2framez75_13842;

				BgL_i1247z00_13840 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 1))));
				BgL_runz00_13841 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 2))));
				BgL_siza7ezd2framez75_13842 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16407;

					BgL_sz00_16407 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16408;

						BgL_bpz00_16408 = VECTOR_REF(((obj_t) BgL_sz00_16407), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16408) + BgL_siza7ezd2framez75_13842) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16407))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3966z00_16409;

									BgL_arg3966z00_16409 =
										((long) CINT(BgL_bpz00_16408) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16407), BgL_arg3966z00_16409,
										BgL_az00_13843);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3967z00_16410;

									BgL_arg3967z00_16410 =
										((long) CINT(BgL_bpz00_16408) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16407), BgL_arg3967z00_16410,
										BgL_bz00_13844);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3968z00_16411;

									BgL_arg3968z00_16411 =
										((long) CINT(BgL_bpz00_16408) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16407), BgL_arg3968z00_16411,
										BgL_cz00_13845);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3969z00_16412;

									BgL_arg3969z00_16412 =
										((long) CINT(BgL_bpz00_16408) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16407), BgL_arg3969z00_16412,
										BgL_dz00_13846);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3970z00_16413;
									long BgL_arg3971z00_16414;
									long BgL_arg3972z00_16415;
									obj_t BgL_arg3973z00_16416;

									BgL_arg3970z00_16413 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13840))->
										BgL_wherez00);
									BgL_arg3971z00_16414 =
										((long) CINT(BgL_bpz00_16408) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3974z00_16417;

										BgL_arg3974z00_16417 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13840))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3974z00_16417) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3972z00_16415 =
													((long) CINT(BgL_arg3974z00_16417) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3972z00_16415 =
													((long) CINT(BgL_arg3974z00_16417) - ((long) 4));
									}}
									BgL_arg3973z00_16416 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13840))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_16407,
										BgL_arg3970z00_16413, BgL_arg3971z00_16414,
										BgL_arg3972z00_16415, BgL_restz00_13847,
										BgL_arg3973z00_16416);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16418;

									BgL_ez00_16418 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16418,
										BgL_bpz00_16408);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16419;

										BgL_accz00_16419 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13841, BgL_sz00_16407, BgL_bpz00_16408);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16418);
										VECTOR_SET(
											((obj_t) BgL_sz00_16407), ((long) 0), BgL_bpz00_16408);
										return BgL_accz00_16419;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16420;

								BgL_nsz00_16420 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16420, ((long) 1), BgL_sz00_16407);
								VECTOR_SET(BgL_nsz00_16420, ((long) 2), BgL_az00_13843);
								VECTOR_SET(BgL_nsz00_16420, ((long) 3), BgL_bz00_13844);
								VECTOR_SET(BgL_nsz00_16420, ((long) 4), BgL_cz00_13845);
								VECTOR_SET(BgL_nsz00_16420, ((long) 5), BgL_dz00_13846);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3975z00_16421;
									long BgL_arg3976z00_16422;
									obj_t BgL_arg3977z00_16423;

									BgL_arg3975z00_16421 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13840))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3978z00_16424;

										BgL_arg3978z00_16424 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13840))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3978z00_16424) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3976z00_16422 =
													((long) CINT(BgL_arg3978z00_16424) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3976z00_16422 =
													((long) CINT(BgL_arg3978z00_16424) - ((long) 4));
									}}
									BgL_arg3977z00_16423 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13840))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_16420,
										BgL_arg3975z00_16421, ((long) 6), BgL_arg3976z00_16422,
										BgL_restz00_13847, BgL_arg3977z00_16423);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16425;

									BgL_z12denvz12_16425 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16425, BgL_nsz00_16420);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16426;

										BgL_ez00_16426 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16426,
											BgL_sz00_16407);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16427;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16428;

												BgL_savedzd2bpzd2_16428 =
													VECTOR_REF(BgL_nsz00_16420, ((long) 0));
												VECTOR_SET(BgL_nsz00_16420, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16430;

													BgL_fz00_16430 = BgL_runz00_13841;
												BgL_recz00_16429:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16431;

														BgL_rz00_16431 =
															PROCEDURE_ENTRY(BgL_fz00_16430) (BgL_fz00_16430,
															BgL_nsz00_16420, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5530z00_30878;

															if (PROCEDUREP(BgL_rz00_16431))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16432;

																	BgL_arg1729z00_16432 =
																		PROCEDURE_ATTR(BgL_rz00_16431);
																	if (STRUCTP(BgL_arg1729z00_16432))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5530z00_30878 =
																				(STRUCT_KEY(BgL_arg1729z00_16432) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5530z00_30878 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5530z00_30878 = ((bool_t) 0);
																}
															if (BgL_test5530z00_30878)
																{
																	obj_t BgL_fz00_30886;

																	BgL_fz00_30886 = BgL_rz00_16431;
																	BgL_fz00_16430 = BgL_fz00_30886;
																	goto BgL_recz00_16429;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16420, ((long) 0),
																		BgL_savedzd2bpzd2_16428);
																	BgL_____rz00_16427 = BgL_rz00_16431;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16426);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16425, BgL_sz00_16407);
											return BgL_____rz00_16427;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4574 */
	obj_t BGl_z62run4574z62zz__evaluate_compz00(obj_t BgL_envz00_13848,
		obj_t BgL_sz00_13851)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13849;
				obj_t BgL_bodyz00_13850;

				BgL_i1247z00_13849 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 0))));
				BgL_bodyz00_13850 = PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16433;

					BgL_bpz00_16433 = VECTOR_REF(((obj_t) BgL_sz00_13851), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16434;
						obj_t BgL_wherez00_16435;
						obj_t BgL_locz00_16436;

						BgL_z12denvz12_16434 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16435 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13849))->
							BgL_wherez00);
						BgL_locz00_16436 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13849))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16434, BgL_wherez00_16435,
								BgL_locz00_16436);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16437;

								BgL_za2za2resza2za2z00_16437 =
									PROCEDURE_ENTRY(BgL_bodyz00_13850) (BgL_bodyz00_13850,
									BgL_sz00_13851, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16434);
								return BgL_za2za2resza2za2z00_16437;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3980> */
	obj_t BGl_z62zc3z04anonymousza33980ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13852, obj_t BgL_sz00_13857)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13853;
				BgL_ev_absz00_bglt BgL_i1247z00_13854;
				obj_t BgL_bodyz00_13855;
				long BgL_siza7ezd2framez75_13856;

				BgL_iboxesz00_13853 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 0))));
				BgL_i1247z00_13854 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 1))));
				BgL_bodyz00_13855 = PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 2)));
				BgL_siza7ezd2framez75_13856 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16438;

					BgL_bpz00_16438 = VECTOR_REF(((obj_t) BgL_sz00_13857), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16439;

							BgL_runz00_16439 =
								MAKE_FX_PROCEDURE(BGl_z62run4576z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16439,
								(int) (((long) 0)), BgL_iboxesz00_13853);
							PROCEDURE_SET(BgL_runz00_16439,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_13854));
							PROCEDURE_SET(BgL_runz00_16439,
								(int) (((long) 2)), BgL_bodyz00_13855);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16440;

								BgL_mainz00_16440 =
									MAKE_VA_PROCEDURE(BGl_z62main4575z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16440,
									(int) (((long) 0)), BgL_iboxesz00_13853);
								PROCEDURE_SET(BgL_mainz00_16440,
									(int) (((long) 1)), BgL_bodyz00_13855);
								PROCEDURE_SET(BgL_mainz00_16440,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_13854));
								PROCEDURE_SET(BgL_mainz00_16440,
									(int) (((long) 3)), BgL_runz00_16439);
								PROCEDURE_SET(BgL_mainz00_16440,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_13856));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16441;

									BgL_objz00_16441 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16439, BgL_objz00_16441);
									BgL_objz00_16441;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3981z00_16442;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3982z00_16443;
										obj_t BgL_arg3983z00_16444;

										BgL_arg3982z00_16443 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13854))->
											BgL_arityz00);
										BgL_arg3983z00_16444 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13854))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16445;

											BgL_newz00_16445 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30949;

												BgL_tmpz00_30949 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16445, BgL_tmpz00_30949,
													BgL_arg3983z00_16444);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30954;
												int BgL_tmpz00_30952;

												BgL_auxz00_30954 = BINT(BgL_siza7ezd2framez75_13856);
												BgL_tmpz00_30952 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16445, BgL_tmpz00_30952,
													BgL_auxz00_30954);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30957;

												BgL_tmpz00_30957 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16445, BgL_tmpz00_30957,
													BgL_runz00_16439);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30960;

												BgL_tmpz00_30960 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16445, BgL_tmpz00_30960,
													BgL_arg3982z00_16443);
											}
											BgL_arg3981z00_16442 = BgL_newz00_16445;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16440, BgL_arg3981z00_16442);
									BgL_arg3981z00_16442;
								}
								return BgL_mainz00_16440;
							}
						}
					}
				}
			}
		}

	}



/* &main4575 */
	obj_t BGl_z62main4575z62zz__evaluate_compz00(obj_t BgL_envz00_13858,
		obj_t BgL_az00_13864, obj_t BgL_bz00_13865, obj_t BgL_cz00_13866,
		obj_t BgL_dz00_13867, obj_t BgL_restz00_13868)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13861;
				obj_t BgL_runz00_13862;
				long BgL_siza7ezd2framez75_13863;

				BgL_i1247z00_13861 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 2))));
				BgL_runz00_13862 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 3))));
				BgL_siza7ezd2framez75_13863 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16446;

					BgL_sz00_16446 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16447;

						BgL_bpz00_16447 = VECTOR_REF(((obj_t) BgL_sz00_16446), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16447) + BgL_siza7ezd2framez75_13863) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16446))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3986z00_16448;

									BgL_arg3986z00_16448 =
										((long) CINT(BgL_bpz00_16447) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16446), BgL_arg3986z00_16448,
										BgL_az00_13864);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3987z00_16449;

									BgL_arg3987z00_16449 =
										((long) CINT(BgL_bpz00_16447) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16446), BgL_arg3987z00_16449,
										BgL_bz00_13865);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3988z00_16450;

									BgL_arg3988z00_16450 =
										((long) CINT(BgL_bpz00_16447) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16446), BgL_arg3988z00_16450,
										BgL_cz00_13866);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3989z00_16451;

									BgL_arg3989z00_16451 =
										((long) CINT(BgL_bpz00_16447) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16446), BgL_arg3989z00_16451,
										BgL_dz00_13867);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3990z00_16452;
									long BgL_arg3991z00_16453;
									long BgL_arg3992z00_16454;
									obj_t BgL_arg3993z00_16455;

									BgL_arg3990z00_16452 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13861))->
										BgL_wherez00);
									BgL_arg3991z00_16453 =
										((long) CINT(BgL_bpz00_16447) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3994z00_16456;

										BgL_arg3994z00_16456 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13861))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3994z00_16456) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3992z00_16454 =
													((long) CINT(BgL_arg3994z00_16456) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3992z00_16454 =
													((long) CINT(BgL_arg3994z00_16456) - ((long) 4));
									}}
									BgL_arg3993z00_16455 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13861))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_16446,
										BgL_arg3990z00_16452, BgL_arg3991z00_16453,
										BgL_arg3992z00_16454, BgL_restz00_13868,
										BgL_arg3993z00_16455);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16457;

									BgL_ez00_16457 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16457,
										BgL_bpz00_16447);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16458;

										BgL_accz00_16458 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13862, BgL_sz00_16446, BgL_bpz00_16447);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16457);
										VECTOR_SET(
											((obj_t) BgL_sz00_16446), ((long) 0), BgL_bpz00_16447);
										return BgL_accz00_16458;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16459;

								BgL_nsz00_16459 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16459, ((long) 1), BgL_sz00_16446);
								VECTOR_SET(BgL_nsz00_16459, ((long) 2), BgL_az00_13864);
								VECTOR_SET(BgL_nsz00_16459, ((long) 3), BgL_bz00_13865);
								VECTOR_SET(BgL_nsz00_16459, ((long) 4), BgL_cz00_13866);
								VECTOR_SET(BgL_nsz00_16459, ((long) 5), BgL_dz00_13867);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3995z00_16460;
									long BgL_arg3996z00_16461;
									obj_t BgL_arg3997z00_16462;

									BgL_arg3995z00_16460 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13861))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3998z00_16463;

										BgL_arg3998z00_16463 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13861))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3998z00_16463) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3996z00_16461 =
													((long) CINT(BgL_arg3998z00_16463) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3996z00_16461 =
													((long) CINT(BgL_arg3998z00_16463) - ((long) 4));
									}}
									BgL_arg3997z00_16462 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13861))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_16459,
										BgL_arg3995z00_16460, ((long) 6), BgL_arg3996z00_16461,
										BgL_restz00_13868, BgL_arg3997z00_16462);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16464;

									BgL_z12denvz12_16464 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16464, BgL_nsz00_16459);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16465;

										BgL_ez00_16465 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16465,
											BgL_sz00_16446);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16466;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16467;

												BgL_savedzd2bpzd2_16467 =
													VECTOR_REF(BgL_nsz00_16459, ((long) 0));
												VECTOR_SET(BgL_nsz00_16459, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16469;

													BgL_fz00_16469 = BgL_runz00_13862;
												BgL_recz00_16468:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16470;

														BgL_rz00_16470 =
															PROCEDURE_ENTRY(BgL_fz00_16469) (BgL_fz00_16469,
															BgL_nsz00_16459, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5536z00_31045;

															if (PROCEDUREP(BgL_rz00_16470))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16471;

																	BgL_arg1729z00_16471 =
																		PROCEDURE_ATTR(BgL_rz00_16470);
																	if (STRUCTP(BgL_arg1729z00_16471))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5536z00_31045 =
																				(STRUCT_KEY(BgL_arg1729z00_16471) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5536z00_31045 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5536z00_31045 = ((bool_t) 0);
																}
															if (BgL_test5536z00_31045)
																{
																	obj_t BgL_fz00_31053;

																	BgL_fz00_31053 = BgL_rz00_16470;
																	BgL_fz00_16469 = BgL_fz00_31053;
																	goto BgL_recz00_16468;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16459, ((long) 0),
																		BgL_savedzd2bpzd2_16467);
																	BgL_____rz00_16466 = BgL_rz00_16470;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16465);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16464, BgL_sz00_16446);
											return BgL_____rz00_16466;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4576 */
	obj_t BGl_z62run4576z62zz__evaluate_compz00(obj_t BgL_envz00_13869,
		obj_t BgL_sz00_13873)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13870;
				BgL_ev_absz00_bglt BgL_i1247z00_13871;
				obj_t BgL_bodyz00_13872;

				BgL_iboxesz00_13870 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13869, (int) (((long) 0))));
				BgL_i1247z00_13871 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13869, (int) (((long) 1))));
				BgL_bodyz00_13872 = PROCEDURE_REF(BgL_envz00_13869, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16472;

					BgL_bpz00_16472 = VECTOR_REF(((obj_t) BgL_sz00_13873), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13873,
						BgL_iboxesz00_13870, BgL_bpz00_16472);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16473;
						obj_t BgL_wherez00_16474;
						obj_t BgL_locz00_16475;

						BgL_z12denvz12_16473 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16474 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13871))->
							BgL_wherez00);
						BgL_locz00_16475 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13871))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16473, BgL_wherez00_16474,
								BgL_locz00_16475);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16476;

								BgL_za2za2resza2za2z00_16476 =
									PROCEDURE_ENTRY(BgL_bodyz00_13872) (BgL_bodyz00_13872,
									BgL_sz00_13873, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16473);
								return BgL_za2za2resza2za2z00_16476;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:4003> */
	obj_t BGl_z62zc3z04anonymousza34003ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13874, obj_t BgL_sz00_13880)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13875;
				long BgL_siza7eza7_13876;
				BgL_ev_absz00_bglt BgL_i1247z00_13877;
				obj_t BgL_bodyz00_13878;
				long BgL_siza7ezd2framez75_13879;

				BgL_ifreesz00_13875 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13874, (int) (((long) 0))));
				BgL_siza7eza7_13876 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13874, (int) (((long) 1))));
				BgL_i1247z00_13877 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13874, (int) (((long) 2))));
				BgL_bodyz00_13878 = PROCEDURE_REF(BgL_envz00_13874, (int) (((long) 3)));
				BgL_siza7ezd2framez75_13879 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13874, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16477;

					BgL_bpz00_16477 = VECTOR_REF(((obj_t) BgL_sz00_13880), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16478;

						BgL_valza2za2_16478 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13880,
							BgL_bpz00_16477, BgL_ifreesz00_13875);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16479;

							BgL_runz00_16479 =
								MAKE_FX_PROCEDURE(BGl_z62run4578z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16479,
								(int) (((long) 0)), BINT(BgL_siza7eza7_13876));
							PROCEDURE_SET(BgL_runz00_16479,
								(int) (((long) 1)), BgL_valza2za2_16478);
							PROCEDURE_SET(BgL_runz00_16479,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_13877));
							PROCEDURE_SET(BgL_runz00_16479,
								(int) (((long) 3)), BgL_bodyz00_13878);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16480;

								BgL_mainz00_16480 =
									MAKE_VA_PROCEDURE(BGl_z62main4577z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16480,
									(int) (((long) 0)), BINT(BgL_siza7eza7_13876));
								PROCEDURE_SET(BgL_mainz00_16480,
									(int) (((long) 1)), BgL_valza2za2_16478);
								PROCEDURE_SET(BgL_mainz00_16480,
									(int) (((long) 2)), BgL_bodyz00_13878);
								PROCEDURE_SET(BgL_mainz00_16480,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_13877));
								PROCEDURE_SET(BgL_mainz00_16480,
									(int) (((long) 4)), BgL_runz00_16479);
								PROCEDURE_SET(BgL_mainz00_16480,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_13879));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16481;

									BgL_objz00_16481 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16479, BgL_objz00_16481);
									BgL_objz00_16481;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4004z00_16482;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4005z00_16483;
										obj_t BgL_arg4006z00_16484;

										BgL_arg4005z00_16483 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13877))->
											BgL_arityz00);
										BgL_arg4006z00_16484 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13877))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16485;

											BgL_newz00_16485 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31130;

												BgL_tmpz00_31130 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16485, BgL_tmpz00_31130,
													BgL_arg4006z00_16484);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31135;
												int BgL_tmpz00_31133;

												BgL_auxz00_31135 = BINT(BgL_siza7ezd2framez75_13879);
												BgL_tmpz00_31133 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16485, BgL_tmpz00_31133,
													BgL_auxz00_31135);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31138;

												BgL_tmpz00_31138 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16485, BgL_tmpz00_31138,
													BgL_runz00_16479);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31141;

												BgL_tmpz00_31141 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16485, BgL_tmpz00_31141,
													BgL_arg4005z00_16483);
											}
											BgL_arg4004z00_16482 = BgL_newz00_16485;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16480, BgL_arg4004z00_16482);
									BgL_arg4004z00_16482;
								}
								return BgL_mainz00_16480;
							}
						}
					}
				}
			}
		}

	}



/* &main4577 */
	obj_t BGl_z62main4577z62zz__evaluate_compz00(obj_t BgL_envz00_13881,
		obj_t BgL_az00_13888, obj_t BgL_bz00_13889, obj_t BgL_cz00_13890,
		obj_t BgL_dz00_13891, obj_t BgL_restz00_13892)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13885;
				obj_t BgL_runz00_13886;
				long BgL_siza7ezd2framez75_13887;

				BgL_i1247z00_13885 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13881, (int) (((long) 3))));
				BgL_runz00_13886 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13881, (int) (((long) 4))));
				BgL_siza7ezd2framez75_13887 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13881, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16486;

					BgL_sz00_16486 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16487;

						BgL_bpz00_16487 = VECTOR_REF(((obj_t) BgL_sz00_16486), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16487) + BgL_siza7ezd2framez75_13887) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16486))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4009z00_16488;

									BgL_arg4009z00_16488 =
										((long) CINT(BgL_bpz00_16487) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16486), BgL_arg4009z00_16488,
										BgL_az00_13888);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4010z00_16489;

									BgL_arg4010z00_16489 =
										((long) CINT(BgL_bpz00_16487) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16486), BgL_arg4010z00_16489,
										BgL_bz00_13889);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4011z00_16490;

									BgL_arg4011z00_16490 =
										((long) CINT(BgL_bpz00_16487) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16486), BgL_arg4011z00_16490,
										BgL_cz00_13890);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4012z00_16491;

									BgL_arg4012z00_16491 =
										((long) CINT(BgL_bpz00_16487) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16486), BgL_arg4012z00_16491,
										BgL_dz00_13891);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4013z00_16492;
									long BgL_arg4014z00_16493;
									long BgL_arg4015z00_16494;
									obj_t BgL_arg4016z00_16495;

									BgL_arg4013z00_16492 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13885))->
										BgL_wherez00);
									BgL_arg4014z00_16493 =
										((long) CINT(BgL_bpz00_16487) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4017z00_16496;

										BgL_arg4017z00_16496 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13885))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4017z00_16496) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4015z00_16494 =
													((long) CINT(BgL_arg4017z00_16496) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4015z00_16494 =
													((long) CINT(BgL_arg4017z00_16496) - ((long) 4));
									}}
									BgL_arg4016z00_16495 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13885))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_16486,
										BgL_arg4013z00_16492, BgL_arg4014z00_16493,
										BgL_arg4015z00_16494, BgL_restz00_13892,
										BgL_arg4016z00_16495);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16497;

									BgL_ez00_16497 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16497,
										BgL_bpz00_16487);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16498;

										BgL_accz00_16498 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13886, BgL_sz00_16486, BgL_bpz00_16487);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16497);
										VECTOR_SET(
											((obj_t) BgL_sz00_16486), ((long) 0), BgL_bpz00_16487);
										return BgL_accz00_16498;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16499;

								BgL_nsz00_16499 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16499, ((long) 1), BgL_sz00_16486);
								VECTOR_SET(BgL_nsz00_16499, ((long) 2), BgL_az00_13888);
								VECTOR_SET(BgL_nsz00_16499, ((long) 3), BgL_bz00_13889);
								VECTOR_SET(BgL_nsz00_16499, ((long) 4), BgL_cz00_13890);
								VECTOR_SET(BgL_nsz00_16499, ((long) 5), BgL_dz00_13891);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4018z00_16500;
									long BgL_arg4019z00_16501;
									obj_t BgL_arg4020z00_16502;

									BgL_arg4018z00_16500 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13885))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4021z00_16503;

										BgL_arg4021z00_16503 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13885))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4021z00_16503) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4019z00_16501 =
													((long) CINT(BgL_arg4021z00_16503) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4019z00_16501 =
													((long) CINT(BgL_arg4021z00_16503) - ((long) 4));
									}}
									BgL_arg4020z00_16502 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13885))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_16499,
										BgL_arg4018z00_16500, ((long) 6), BgL_arg4019z00_16501,
										BgL_restz00_13892, BgL_arg4020z00_16502);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16504;

									BgL_z12denvz12_16504 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16504, BgL_nsz00_16499);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16505;

										BgL_ez00_16505 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16505,
											BgL_sz00_16486);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16506;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16507;

												BgL_savedzd2bpzd2_16507 =
													VECTOR_REF(BgL_nsz00_16499, ((long) 0));
												VECTOR_SET(BgL_nsz00_16499, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16509;

													BgL_fz00_16509 = BgL_runz00_13886;
												BgL_recz00_16508:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16510;

														BgL_rz00_16510 =
															PROCEDURE_ENTRY(BgL_fz00_16509) (BgL_fz00_16509,
															BgL_nsz00_16499, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5542z00_31226;

															if (PROCEDUREP(BgL_rz00_16510))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16511;

																	BgL_arg1729z00_16511 =
																		PROCEDURE_ATTR(BgL_rz00_16510);
																	if (STRUCTP(BgL_arg1729z00_16511))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5542z00_31226 =
																				(STRUCT_KEY(BgL_arg1729z00_16511) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5542z00_31226 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5542z00_31226 = ((bool_t) 0);
																}
															if (BgL_test5542z00_31226)
																{
																	obj_t BgL_fz00_31234;

																	BgL_fz00_31234 = BgL_rz00_16510;
																	BgL_fz00_16509 = BgL_fz00_31234;
																	goto BgL_recz00_16508;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16499, ((long) 0),
																		BgL_savedzd2bpzd2_16507);
																	BgL_____rz00_16506 = BgL_rz00_16510;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16505);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16504, BgL_sz00_16486);
											return BgL_____rz00_16506;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4578 */
	obj_t BGl_z62run4578z62zz__evaluate_compz00(obj_t BgL_envz00_13893,
		obj_t BgL_sz00_13898)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_13894;
				obj_t BgL_valza2za2_13895;
				BgL_ev_absz00_bglt BgL_i1247z00_13896;
				obj_t BgL_bodyz00_13897;

				BgL_siza7eza7_13894 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13893, (int) (((long) 0))));
				BgL_valza2za2_13895 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13893, (int) (((long) 1))));
				BgL_i1247z00_13896 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13893, (int) (((long) 2))));
				BgL_bodyz00_13897 = PROCEDURE_REF(BgL_envz00_13893, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16512;

					BgL_bpz00_16512 = VECTOR_REF(((obj_t) BgL_sz00_13898), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13898,
						BgL_valza2za2_13895,
						((long) CINT(BgL_bpz00_16512) + BgL_siza7eza7_13894));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16513;
						obj_t BgL_wherez00_16514;
						obj_t BgL_locz00_16515;

						BgL_z12denvz12_16513 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16514 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13896))->
							BgL_wherez00);
						BgL_locz00_16515 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13896))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16513, BgL_wherez00_16514,
								BgL_locz00_16515);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16516;

								BgL_za2za2resza2za2z00_16516 =
									PROCEDURE_ENTRY(BgL_bodyz00_13897) (BgL_bodyz00_13897,
									BgL_sz00_13898, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16513);
								return BgL_za2za2resza2za2z00_16516;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:4024> */
	obj_t BGl_z62zc3z04anonymousza34024ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13899, obj_t BgL_sz00_13906)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_13900;
				obj_t BgL_iboxesz00_13901;
				long BgL_siza7eza7_13902;
				BgL_ev_absz00_bglt BgL_i1247z00_13903;
				obj_t BgL_bodyz00_13904;
				long BgL_siza7ezd2framez75_13905;

				BgL_ifreesz00_13900 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13899, (int) (((long) 0))));
				BgL_iboxesz00_13901 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13899, (int) (((long) 1))));
				BgL_siza7eza7_13902 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13899, (int) (((long) 2))));
				BgL_i1247z00_13903 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13899, (int) (((long) 3))));
				BgL_bodyz00_13904 = PROCEDURE_REF(BgL_envz00_13899, (int) (((long) 4)));
				BgL_siza7ezd2framez75_13905 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13899, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16517;

					BgL_bpz00_16517 = VECTOR_REF(((obj_t) BgL_sz00_13906), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16518;

						BgL_valza2za2_16518 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_13906,
							BgL_bpz00_16517, BgL_ifreesz00_13900);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16519;

							BgL_runz00_16519 =
								MAKE_FX_PROCEDURE(BGl_z62run4580z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16519,
								(int) (((long) 0)), BgL_iboxesz00_13901);
							PROCEDURE_SET(BgL_runz00_16519,
								(int) (((long) 1)), BINT(BgL_siza7eza7_13902));
							PROCEDURE_SET(BgL_runz00_16519,
								(int) (((long) 2)), BgL_valza2za2_16518);
							PROCEDURE_SET(BgL_runz00_16519,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_13903));
							PROCEDURE_SET(BgL_runz00_16519,
								(int) (((long) 4)), BgL_bodyz00_13904);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16520;

								BgL_mainz00_16520 =
									MAKE_VA_PROCEDURE(BGl_z62main4579z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16520,
									(int) (((long) 0)), BgL_iboxesz00_13901);
								PROCEDURE_SET(BgL_mainz00_16520,
									(int) (((long) 1)), BINT(BgL_siza7eza7_13902));
								PROCEDURE_SET(BgL_mainz00_16520,
									(int) (((long) 2)), BgL_valza2za2_16518);
								PROCEDURE_SET(BgL_mainz00_16520,
									(int) (((long) 3)), BgL_bodyz00_13904);
								PROCEDURE_SET(BgL_mainz00_16520,
									(int) (((long) 4)), ((obj_t) BgL_i1247z00_13903));
								PROCEDURE_SET(BgL_mainz00_16520,
									(int) (((long) 5)), BgL_runz00_16519);
								PROCEDURE_SET(BgL_mainz00_16520,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_13905));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16521;

									BgL_objz00_16521 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16519, BgL_objz00_16521);
									BgL_objz00_16521;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4025z00_16522;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4026z00_16523;
										obj_t BgL_arg4027z00_16524;

										BgL_arg4026z00_16523 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13903))->
											BgL_arityz00);
										BgL_arg4027z00_16524 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13903))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16525;

											BgL_newz00_16525 =
												create_struct(BGl_symbol4610z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31323;

												BgL_tmpz00_31323 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16525, BgL_tmpz00_31323,
													BgL_arg4027z00_16524);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31328;
												int BgL_tmpz00_31326;

												BgL_auxz00_31328 = BINT(BgL_siza7ezd2framez75_13905);
												BgL_tmpz00_31326 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16525, BgL_tmpz00_31326,
													BgL_auxz00_31328);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31331;

												BgL_tmpz00_31331 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16525, BgL_tmpz00_31331,
													BgL_runz00_16519);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31334;

												BgL_tmpz00_31334 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16525, BgL_tmpz00_31334,
													BgL_arg4026z00_16523);
											}
											BgL_arg4025z00_16522 = BgL_newz00_16525;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16520, BgL_arg4025z00_16522);
									BgL_arg4025z00_16522;
								}
								return BgL_mainz00_16520;
							}
						}
					}
				}
			}
		}

	}



/* &main4579 */
	obj_t BGl_z62main4579z62zz__evaluate_compz00(obj_t BgL_envz00_13907,
		obj_t BgL_az00_13915, obj_t BgL_bz00_13916, obj_t BgL_cz00_13917,
		obj_t BgL_dz00_13918, obj_t BgL_restz00_13919)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_13912;
				obj_t BgL_runz00_13913;
				long BgL_siza7ezd2framez75_13914;

				BgL_i1247z00_13912 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13907, (int) (((long) 4))));
				BgL_runz00_13913 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13907, (int) (((long) 5))));
				BgL_siza7ezd2framez75_13914 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13907, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16526;

					BgL_sz00_16526 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16527;

						BgL_bpz00_16527 = VECTOR_REF(((obj_t) BgL_sz00_16526), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16527) + BgL_siza7ezd2framez75_13914) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16526))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4030z00_16528;

									BgL_arg4030z00_16528 =
										((long) CINT(BgL_bpz00_16527) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16526), BgL_arg4030z00_16528,
										BgL_az00_13915);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4031z00_16529;

									BgL_arg4031z00_16529 =
										((long) CINT(BgL_bpz00_16527) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16526), BgL_arg4031z00_16529,
										BgL_bz00_13916);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4032z00_16530;

									BgL_arg4032z00_16530 =
										((long) CINT(BgL_bpz00_16527) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16526), BgL_arg4032z00_16530,
										BgL_cz00_13917);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4034z00_16531;

									BgL_arg4034z00_16531 =
										((long) CINT(BgL_bpz00_16527) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16526), BgL_arg4034z00_16531,
										BgL_dz00_13918);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4035z00_16532;
									long BgL_arg4036z00_16533;
									long BgL_arg4037z00_16534;
									obj_t BgL_arg4038z00_16535;

									BgL_arg4035z00_16532 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13912))->
										BgL_wherez00);
									BgL_arg4036z00_16533 =
										((long) CINT(BgL_bpz00_16527) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4039z00_16536;

										BgL_arg4039z00_16536 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13912))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4039z00_16536) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4037z00_16534 =
													((long) CINT(BgL_arg4039z00_16536) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4037z00_16534 =
													((long) CINT(BgL_arg4039z00_16536) - ((long) 4));
									}}
									BgL_arg4038z00_16535 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13912))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_16526,
										BgL_arg4035z00_16532, BgL_arg4036z00_16533,
										BgL_arg4037z00_16534, BgL_restz00_13919,
										BgL_arg4038z00_16535);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16537;

									BgL_ez00_16537 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16537,
										BgL_bpz00_16527);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16538;

										BgL_accz00_16538 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_13913, BgL_sz00_16526, BgL_bpz00_16527);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16537);
										VECTOR_SET(
											((obj_t) BgL_sz00_16526), ((long) 0), BgL_bpz00_16527);
										return BgL_accz00_16538;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16539;

								BgL_nsz00_16539 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16539, ((long) 1), BgL_sz00_16526);
								VECTOR_SET(BgL_nsz00_16539, ((long) 2), BgL_az00_13915);
								VECTOR_SET(BgL_nsz00_16539, ((long) 3), BgL_bz00_13916);
								VECTOR_SET(BgL_nsz00_16539, ((long) 4), BgL_cz00_13917);
								VECTOR_SET(BgL_nsz00_16539, ((long) 5), BgL_dz00_13918);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4040z00_16540;
									long BgL_arg4041z00_16541;
									obj_t BgL_arg4042z00_16542;

									BgL_arg4040z00_16540 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13912))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4043z00_16543;

										BgL_arg4043z00_16543 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13912))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4043z00_16543) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4041z00_16541 =
													((long) CINT(BgL_arg4043z00_16543) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4041z00_16541 =
													((long) CINT(BgL_arg4043z00_16543) - ((long) 4));
									}}
									BgL_arg4042z00_16542 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13912))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_16539,
										BgL_arg4040z00_16540, ((long) 6), BgL_arg4041z00_16541,
										BgL_restz00_13919, BgL_arg4042z00_16542);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16544;

									BgL_z12denvz12_16544 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16544, BgL_nsz00_16539);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16545;

										BgL_ez00_16545 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16545,
											BgL_sz00_16526);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16546;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16547;

												BgL_savedzd2bpzd2_16547 =
													VECTOR_REF(BgL_nsz00_16539, ((long) 0));
												VECTOR_SET(BgL_nsz00_16539, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16549;

													BgL_fz00_16549 = BgL_runz00_13913;
												BgL_recz00_16548:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16550;

														BgL_rz00_16550 =
															PROCEDURE_ENTRY(BgL_fz00_16549) (BgL_fz00_16549,
															BgL_nsz00_16539, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test5549z00_31419;

															if (PROCEDUREP(BgL_rz00_16550))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1729z00_16551;

																	BgL_arg1729z00_16551 =
																		PROCEDURE_ATTR(BgL_rz00_16550);
																	if (STRUCTP(BgL_arg1729z00_16551))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5549z00_31419 =
																				(STRUCT_KEY(BgL_arg1729z00_16551) ==
																				BGl_symbol4589z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test5549z00_31419 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test5549z00_31419 = ((bool_t) 0);
																}
															if (BgL_test5549z00_31419)
																{
																	obj_t BgL_fz00_31427;

																	BgL_fz00_31427 = BgL_rz00_16550;
																	BgL_fz00_16549 = BgL_fz00_31427;
																	goto BgL_recz00_16548;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16539, ((long) 0),
																		BgL_savedzd2bpzd2_16547);
																	BgL_____rz00_16546 = BgL_rz00_16550;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16545);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16544, BgL_sz00_16526);
											return BgL_____rz00_16546;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run4580 */
	obj_t BGl_z62run4580z62zz__evaluate_compz00(obj_t BgL_envz00_13920,
		obj_t BgL_sz00_13926)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_13921;
				long BgL_siza7eza7_13922;
				obj_t BgL_valza2za2_13923;
				BgL_ev_absz00_bglt BgL_i1247z00_13924;
				obj_t BgL_bodyz00_13925;

				BgL_iboxesz00_13921 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13920, (int) (((long) 0))));
				BgL_siza7eza7_13922 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13920, (int) (((long) 1))));
				BgL_valza2za2_13923 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13920, (int) (((long) 2))));
				BgL_i1247z00_13924 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_13920, (int) (((long) 3))));
				BgL_bodyz00_13925 = PROCEDURE_REF(BgL_envz00_13920, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16552;

					BgL_bpz00_16552 = VECTOR_REF(((obj_t) BgL_sz00_13926), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_13926,
						BgL_iboxesz00_13921, BgL_bpz00_16552);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_13926,
						BgL_valza2za2_13923,
						((long) CINT(BgL_bpz00_16552) + BgL_siza7eza7_13922));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16553;
						obj_t BgL_wherez00_16554;
						obj_t BgL_locz00_16555;

						BgL_z12denvz12_16553 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16554 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13924))->
							BgL_wherez00);
						BgL_locz00_16555 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_13924))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16553, BgL_wherez00_16554,
								BgL_locz00_16555);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16556;

								BgL_za2za2resza2za2z00_16556 =
									PROCEDURE_ENTRY(BgL_bodyz00_13925) (BgL_bodyz00_13925,
									BgL_sz00_13926, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16553);
								return BgL_za2za2resza2za2z00_16556;
							}
						}
					}
				}
			}
		}

	}



/* &comp-ev_app1436 */
	obj_t BGl_z62compzd2ev_app1436zb0zz__evaluate_compz00(obj_t BgL_envz00_13927,
		obj_t BgL_ez00_13928, obj_t BgL_stkz00_13929)
	{
		{	/* Eval/evaluate_comp.scm 1044 */
			{	/* Eval/evaluate_comp.scm 1046 */
				obj_t BgL__ortest_1233z00_16558;

				BgL__ortest_1233z00_16558 =
					BGl_arithzd2expressionzd2zz__evaluate_compz00(
					((BgL_ev_appz00_bglt) BgL_ez00_13928), BgL_stkz00_13929);
				if (CBOOL(BgL__ortest_1233z00_16558))
					{	/* Eval/evaluate_comp.scm 1046 */
						return BgL__ortest_1233z00_16558;
					}
				else
					{	/* Eval/evaluate_comp.scm 1047 */
						obj_t BgL__ortest_1234z00_16559;

						BgL__ortest_1234z00_16559 =
							BGl_inlinezd2callzd2zz__evaluate_compz00(
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_13928)))->BgL_locz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_13928)))->BgL_funz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_13928)))->BgL_argsz00),
							BgL_stkz00_13929);
						if (CBOOL(BgL__ortest_1234z00_16559))
							{	/* Eval/evaluate_comp.scm 1047 */
								return BgL__ortest_1234z00_16559;
							}
						else
							{	/* Eval/evaluate_comp.scm 1047 */
								if (
									(bgl_list_length(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_13928)))->
												BgL_argsz00)) > ((long) 4)))
									{	/* Eval/evaluate_comp.scm 1048 */
										return
											BGl_compzd2oldzd2callz00zz__evaluate_compz00(
											((BgL_ev_appz00_bglt) BgL_ez00_13928), BgL_stkz00_13929);
									}
								else
									{	/* Eval/evaluate_comp.scm 1050 */
										obj_t BgL_fz00_16560;
										long BgL_siza7eza7_16561;
										obj_t BgL_symbzd2funzd2_16562;

										BgL_fz00_16560 =
											BGl_compz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_13928)))->
												BgL_funz00), BgL_stkz00_13929);
										BgL_siza7eza7_16561 = bgl_list_length(BgL_stkz00_13929);
										BgL_symbzd2funzd2_16562 =
											BGl_uncompilez00zz__evaluate_uncompz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_13928)))->
												BgL_funz00));
										if (NULLP((((BgL_ev_appz00_bglt)
														COBJECT(((BgL_ev_appz00_bglt) BgL_ez00_13928)))->
													BgL_argsz00)))
											{	/* Eval/evaluate_comp.scm 1051 */
												return
													BGl_compzd2call0zd2zz__evaluate_compz00(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_13928)))->
														BgL_locz00),
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_13928)))->BgL_funz00),
													BgL_symbzd2funzd2_16562, BgL_fz00_16560,
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_13928)))->BgL_tailzf3zf3),
													BgL_stkz00_13929, BgL_siza7eza7_16561);
											}
										else
											{	/* Eval/evaluate_comp.scm 1053 */
												obj_t BgL_a1z00_16563;
												obj_t BgL_argsz00_16564;

												{	/* Eval/evaluate_comp.scm 1053 */
													obj_t BgL_arg3472z00_16565;

													BgL_arg3472z00_16565 =
														CAR(
														(((BgL_ev_appz00_bglt) COBJECT(
																	((BgL_ev_appz00_bglt) BgL_ez00_13928)))->
															BgL_argsz00));
													BgL_a1z00_16563 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_arg3472z00_16565),
														BgL_stkz00_13929);
												}
												BgL_argsz00_16564 =
													CDR(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_13928)))->
														BgL_argsz00));
												if (NULLP(BgL_argsz00_16564))
													{	/* Eval/evaluate_comp.scm 1053 */
														return
															BGl_compzd2call1zd2zz__evaluate_compz00(
															(((BgL_ev_appz00_bglt) COBJECT(
																		((BgL_ev_appz00_bglt) BgL_ez00_13928)))->
																BgL_locz00),
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_13928)))->BgL_funz00),
															BgL_symbzd2funzd2_16562, BgL_fz00_16560,
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_13928)))->BgL_tailzf3zf3),
															BgL_stkz00_13929, BgL_siza7eza7_16561,
															BgL_a1z00_16563);
													}
												else
													{	/* Eval/evaluate_comp.scm 1053 */
														obj_t BgL_a2z00_16566;
														obj_t BgL_argsz00_16567;

														{	/* Eval/evaluate_comp.scm 1053 */
															obj_t BgL_arg3471z00_16568;

															BgL_arg3471z00_16568 =
																CAR(((obj_t) BgL_argsz00_16564));
															BgL_a2z00_16566 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_arg3471z00_16568),
																BgL_stkz00_13929);
														}
														BgL_argsz00_16567 =
															CDR(((obj_t) BgL_argsz00_16564));
														if (NULLP(BgL_argsz00_16567))
															{	/* Eval/evaluate_comp.scm 1053 */
																return
																	BGl_compzd2call2zd2zz__evaluate_compz00(
																	(((BgL_ev_appz00_bglt) COBJECT(
																				((BgL_ev_appz00_bglt)
																					BgL_ez00_13928)))->BgL_locz00),
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_13928)))->BgL_funz00),
																	BgL_symbzd2funzd2_16562, BgL_fz00_16560,
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_13928)))->BgL_tailzf3zf3),
																	BgL_stkz00_13929, BgL_siza7eza7_16561,
																	BgL_a1z00_16563, BgL_a2z00_16566);
															}
														else
															{	/* Eval/evaluate_comp.scm 1053 */
																obj_t BgL_a3z00_16569;
																obj_t BgL_argsz00_16570;

																{	/* Eval/evaluate_comp.scm 1053 */
																	obj_t BgL_arg3469z00_16571;

																	BgL_arg3469z00_16571 =
																		CAR(((obj_t) BgL_argsz00_16567));
																	BgL_a3z00_16569 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt)
																			BgL_arg3469z00_16571), BgL_stkz00_13929);
																}
																BgL_argsz00_16570 =
																	CDR(((obj_t) BgL_argsz00_16567));
																if (NULLP(BgL_argsz00_16570))
																	{	/* Eval/evaluate_comp.scm 1053 */
																		return
																			BGl_compzd2call3zd2zz__evaluate_compz00(
																			(((BgL_ev_appz00_bglt) COBJECT(
																						((BgL_ev_appz00_bglt)
																							BgL_ez00_13928)))->BgL_locz00),
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_13928)))->BgL_funz00),
																			BgL_symbzd2funzd2_16562, BgL_fz00_16560,
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_13928)))->
																				BgL_tailzf3zf3), BgL_stkz00_13929,
																			BgL_siza7eza7_16561, BgL_a1z00_16563,
																			BgL_a2z00_16566, BgL_a3z00_16569);
																	}
																else
																	{	/* Eval/evaluate_comp.scm 1053 */
																		obj_t BgL_a4z00_16572;
																		obj_t BgL_argsz00_16573;

																		{	/* Eval/evaluate_comp.scm 1053 */
																			obj_t BgL_arg3468z00_16574;

																			BgL_arg3468z00_16574 =
																				CAR(((obj_t) BgL_argsz00_16570));
																			BgL_a4z00_16572 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt)
																					BgL_arg3468z00_16574),
																				BgL_stkz00_13929);
																		}
																		BgL_argsz00_16573 =
																			CDR(((obj_t) BgL_argsz00_16570));
																		if (NULLP(BgL_argsz00_16573))
																			{	/* Eval/evaluate_comp.scm 1053 */
																				return
																					BGl_compzd2call4zd2zz__evaluate_compz00
																					((((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_13928)))->
																						BgL_locz00),
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_13928)))->
																						BgL_funz00),
																					BgL_symbzd2funzd2_16562,
																					BgL_fz00_16560,
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_13928)))->
																						BgL_tailzf3zf3), BgL_stkz00_13929,
																					BgL_siza7eza7_16561, BgL_a1z00_16563,
																					BgL_a2z00_16566, BgL_a3z00_16569,
																					BgL_a4z00_16572);
																			}
																		else
																			{	/* Eval/evaluate_comp.scm 1053 */
																				return
																					BGl_errorz00zz__errorz00
																					(BGl_string4593z00zz__evaluate_compz00,
																					BGl_string4708z00zz__evaluate_compz00,
																					BGl_string4709z00zz__evaluate_compz00);
																			}
																	}
															}
													}
											}
									}
							}
					}
			}
		}

	}



/* &comp-ev_goto1434 */
	obj_t BGl_z62compzd2ev_goto1434zb0zz__evaluate_compz00(obj_t BgL_envz00_13930,
		obj_t BgL_ez00_13931, obj_t BgL_stkz00_13932)
	{
		{	/* Eval/evaluate_comp.scm 604 */
			{	/* Eval/evaluate_comp.scm 607 */
				obj_t BgL_slotz00_16578;
				long BgL_siza7eza7_16579;
				obj_t BgL_lstkz00_16580;

				BgL_slotz00_16578 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
					((obj_t)
						(((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->BgL_labelz00)),
					(((BgL_ev_labelsz00_bglt) COBJECT(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->
									BgL_labelsz00)))->BgL_envz00));
				BgL_siza7eza7_16579 = bgl_list_length(BgL_stkz00_13932);
				BgL_lstkz00_16580 =
					(((BgL_ev_labelsz00_bglt) COBJECT(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->BgL_labelsz00)))->
					BgL_stkz00);
				{	/* Eval/evaluate_comp.scm 609 */
					long BgL_llstkz00_16581;
					obj_t BgL_substkz00_16582;
					obj_t BgL_boxesz00_16583;

					BgL_llstkz00_16581 = bgl_list_length(BgL_lstkz00_16580);
					BgL_substkz00_16582 =
						BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_16580,
						BgL_stkz00_13932);
					{	/* Eval/evaluate_comp.scm 609 */
						obj_t BgL_pairz00_16584;

						BgL_pairz00_16584 =
							BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
							((obj_t)
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->BgL_labelz00)),
							(((BgL_ev_labelsz00_bglt) COBJECT(
										(((BgL_ev_gotoz00_bglt) COBJECT(
													((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->
											BgL_labelsz00)))->BgL_boxesz00));
						BgL_boxesz00_16583 = CDR(BgL_pairz00_16584);
					}
					if (BGl_needzd2shiftzd2zz__evaluate_compz00(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->BgL_argsz00),
							BgL_substkz00_16582))
						{	/* Eval/evaluate_comp.scm 612 */
							obj_t BgL_argsz00_16585;
							long BgL_nbargsz00_16586;

							BgL_argsz00_16585 =
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->BgL_argsz00),
								BgL_stkz00_13932);
							BgL_nbargsz00_16586 =
								bgl_list_length((((BgL_ev_gotoz00_bglt)
										COBJECT(((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->
									BgL_argsz00));
							{	/* Eval/evaluate_comp.scm 613 */
								obj_t BgL_zc3z04anonymousza33413ze3z87_16587;

								BgL_zc3z04anonymousza33413ze3z87_16587 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33413ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33413ze3z87_16587,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16579));
								PROCEDURE_SET(BgL_zc3z04anonymousza33413ze3z87_16587,
									(int) (((long) 1)), BINT(BgL_llstkz00_16581));
								PROCEDURE_SET(BgL_zc3z04anonymousza33413ze3z87_16587,
									(int) (((long) 2)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_13931)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33413ze3z87_16587,
									(int) (((long) 3)), BgL_argsz00_16585);
								PROCEDURE_SET(BgL_zc3z04anonymousza33413ze3z87_16587,
									(int) (((long) 4)), BgL_boxesz00_16583);
								PROCEDURE_SET(BgL_zc3z04anonymousza33413ze3z87_16587,
									(int) (((long) 5)), BINT(BgL_nbargsz00_16586));
								PROCEDURE_SET(BgL_zc3z04anonymousza33413ze3z87_16587,
									(int) (((long) 6)), BgL_slotz00_16578);
								return BgL_zc3z04anonymousza33413ze3z87_16587;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 618 */
							obj_t BgL_argsz00_16588;

							{	/* Eval/evaluate_comp.scm 618 */
								obj_t BgL_lz00_16589;
								long BgL_nz00_16590;

								BgL_lz00_16589 =
									(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_13931)))->BgL_argsz00);
								BgL_nz00_16590 = (BgL_siza7eza7_16579 - BgL_llstkz00_16581);
								BgL_argsz00_16588 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_13932,
									BgL_lz00_16589, BgL_nz00_16590);
							}
							{	/* Eval/evaluate_comp.scm 619 */
								obj_t BgL_zc3z04anonymousza33421ze3z87_16591;

								BgL_zc3z04anonymousza33421ze3z87_16591 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33421ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33421ze3z87_16591,
									(int) (((long) 0)), BINT(BgL_llstkz00_16581));
								PROCEDURE_SET(BgL_zc3z04anonymousza33421ze3z87_16591,
									(int) (((long) 1)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_13931)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33421ze3z87_16591,
									(int) (((long) 2)), BgL_argsz00_16588);
								PROCEDURE_SET(BgL_zc3z04anonymousza33421ze3z87_16591,
									(int) (((long) 3)), BgL_boxesz00_16583);
								PROCEDURE_SET(BgL_zc3z04anonymousza33421ze3z87_16591,
									(int) (((long) 4)), BgL_slotz00_16578);
								return BgL_zc3z04anonymousza33421ze3z87_16591;
							}
						}
				}
			}
		}

	}



/* &<@anonymous:3413> */
	obj_t BGl_z62zc3z04anonymousza33413ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13933, obj_t BgL_sz00_13941)
	{
		{	/* Eval/evaluate_comp.scm 613 */
			{	/* Eval/evaluate_comp.scm 613 */
				long BgL_siza7eza7_13934;
				long BgL_llstkz00_13935;
				BgL_ev_gotoz00_bglt BgL_i1145z00_13936;
				obj_t BgL_argsz00_13937;
				obj_t BgL_boxesz00_13938;
				long BgL_nbargsz00_13939;
				obj_t BgL_slotz00_13940;

				BgL_siza7eza7_13934 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 0))));
				BgL_llstkz00_13935 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 1))));
				BgL_i1145z00_13936 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 2))));
				BgL_argsz00_13937 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 3))));
				BgL_boxesz00_13938 =
					PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 4)));
				BgL_nbargsz00_13939 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 5))));
				BgL_slotz00_13940 = PROCEDURE_REF(BgL_envz00_13933, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 613 */
					obj_t BgL_bpz00_16592;

					BgL_bpz00_16592 = VECTOR_REF(((obj_t) BgL_sz00_13941), ((long) 0));
					{	/* Eval/evaluate_comp.scm 614 */
						long BgL_spz00_16593;
						long BgL_lspz00_16594;

						BgL_spz00_16593 =
							((long) CINT(BgL_bpz00_16592) + BgL_siza7eza7_13934);
						BgL_lspz00_16594 =
							((long) CINT(BgL_bpz00_16592) + BgL_llstkz00_13935);
						BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
							(BgL_sz00_13941, BgL_argsz00_13937, BgL_boxesz00_13938,
							BgL_spz00_16593,
							(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1145z00_13936))->
								BgL_locz00));
						{	/* Eval/evaluate_comp.scm 616 */
							long BgL_arg3415z00_16595;

							BgL_arg3415z00_16595 = (BgL_spz00_16593 + BgL_nbargsz00_13939);
							BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_13941,
								BgL_lspz00_16594, BgL_sz00_13941, BINT(BgL_spz00_16593),
								BINT(BgL_arg3415z00_16595));
						}
						return CDR(((obj_t) BgL_slotz00_13940));
					}
				}
			}
		}

	}



/* &<@anonymous:3421> */
	obj_t BGl_z62zc3z04anonymousza33421ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13942, obj_t BgL_sz00_13948)
	{
		{	/* Eval/evaluate_comp.scm 619 */
			{	/* Eval/evaluate_comp.scm 619 */
				long BgL_llstkz00_13943;
				BgL_ev_gotoz00_bglt BgL_i1145z00_13944;
				obj_t BgL_argsz00_13945;
				obj_t BgL_boxesz00_13946;
				obj_t BgL_slotz00_13947;

				BgL_llstkz00_13943 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13942, (int) (((long) 0))));
				BgL_i1145z00_13944 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_13942, (int) (((long) 1))));
				BgL_argsz00_13945 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13942, (int) (((long) 2))));
				BgL_boxesz00_13946 =
					PROCEDURE_REF(BgL_envz00_13942, (int) (((long) 3)));
				BgL_slotz00_13947 = PROCEDURE_REF(BgL_envz00_13942, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 619 */
					obj_t BgL_bpz00_16596;

					BgL_bpz00_16596 = VECTOR_REF(((obj_t) BgL_sz00_13948), ((long) 0));
					BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
						(BgL_sz00_13948, BgL_argsz00_13945, BgL_boxesz00_13946,
						((long) CINT(BgL_bpz00_16596) + BgL_llstkz00_13943),
						(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1145z00_13944))->BgL_locz00));
					return CDR(((obj_t) BgL_slotz00_13947));
				}
			}
		}

	}



/* &comp-ev_labels1432 */
	obj_t BGl_z62compzd2ev_labels1432zb0zz__evaluate_compz00(obj_t
		BgL_envz00_13949, obj_t BgL_ez00_13950, obj_t BgL_stkz00_13951)
	{
		{	/* Eval/evaluate_comp.scm 572 */
			((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_ez00_13950)))->BgL_stkz00) =
				((obj_t) BgL_stkz00_13951), BUNSPEC);
			{	/* Eval/evaluate_comp.scm 579 */
				obj_t BgL_envz00_16598;

				{	/* Eval/evaluate_comp.scm 579 */
					obj_t BgL_l1332z00_16599;

					BgL_l1332z00_16599 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_13950)))->BgL_varsz00);
					if (NULLP(BgL_l1332z00_16599))
						{	/* Eval/evaluate_comp.scm 579 */
							BgL_envz00_16598 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 579 */
							obj_t BgL_head1334z00_16600;

							BgL_head1334z00_16600 = MAKE_YOUNG_PAIR(BNIL, BNIL);
							{
								obj_t BgL_l1332z00_16602;
								obj_t BgL_tail1335z00_16603;

								BgL_l1332z00_16602 = BgL_l1332z00_16599;
								BgL_tail1335z00_16603 = BgL_head1334z00_16600;
							BgL_zc3z04anonymousza33403ze3z87_16601:
								if (NULLP(BgL_l1332z00_16602))
									{	/* Eval/evaluate_comp.scm 579 */
										BgL_envz00_16598 = CDR(BgL_head1334z00_16600);
									}
								else
									{	/* Eval/evaluate_comp.scm 579 */
										obj_t BgL_newtail1336z00_16604;

										{	/* Eval/evaluate_comp.scm 579 */
											obj_t BgL_arg3406z00_16605;

											{	/* Eval/evaluate_comp.scm 579 */
												obj_t BgL_vz00_16606;

												BgL_vz00_16606 = CAR(((obj_t) BgL_l1332z00_16602));
												BgL_arg3406z00_16605 =
													MAKE_YOUNG_PAIR(BgL_vz00_16606,
													BGl_symbol4710z00zz__evaluate_compz00);
											}
											BgL_newtail1336z00_16604 =
												MAKE_YOUNG_PAIR(BgL_arg3406z00_16605, BNIL);
										}
										SET_CDR(BgL_tail1335z00_16603, BgL_newtail1336z00_16604);
										{	/* Eval/evaluate_comp.scm 579 */
											obj_t BgL_arg3405z00_16607;

											BgL_arg3405z00_16607 = CDR(((obj_t) BgL_l1332z00_16602));
											{
												obj_t BgL_tail1335z00_31706;
												obj_t BgL_l1332z00_31705;

												BgL_l1332z00_31705 = BgL_arg3405z00_16607;
												BgL_tail1335z00_31706 = BgL_newtail1336z00_16604;
												BgL_tail1335z00_16603 = BgL_tail1335z00_31706;
												BgL_l1332z00_16602 = BgL_l1332z00_31705;
												goto BgL_zc3z04anonymousza33403ze3z87_16601;
											}
										}
									}
							}
						}
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_13950)))->BgL_envz00) =
					((obj_t) BgL_envz00_16598), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 582 */
					obj_t BgL_g1340z00_16608;

					BgL_g1340z00_16608 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_13950)))->BgL_valsz00);
					{
						obj_t BgL_ll1337z00_16610;
						obj_t BgL_ll1338z00_16611;

						BgL_ll1337z00_16610 = BgL_envz00_16598;
						BgL_ll1338z00_16611 = BgL_g1340z00_16608;
					BgL_zc3z04anonymousza33388ze3z87_16609:
						if (NULLP(BgL_ll1337z00_16610))
							{	/* Eval/evaluate_comp.scm 582 */
								((bool_t) 1);
							}
						else
							{	/* Eval/evaluate_comp.scm 582 */
								{	/* Eval/evaluate_comp.scm 584 */
									obj_t BgL_slotz00_16612;
									obj_t BgL_valz00_16613;

									BgL_slotz00_16612 = CAR(((obj_t) BgL_ll1337z00_16610));
									BgL_valz00_16613 = CAR(((obj_t) BgL_ll1338z00_16611));
									{	/* Eval/evaluate_comp.scm 585 */
										obj_t BgL_arg3391z00_16614;

										{	/* Eval/evaluate_comp.scm 585 */
											obj_t BgL_arg3392z00_16615;

											{	/* Eval/evaluate_comp.scm 585 */
												obj_t BgL_arg3394z00_16616;
												obj_t BgL_arg3395z00_16617;

												BgL_arg3394z00_16616 = CDR(((obj_t) BgL_valz00_16613));
												{	/* Eval/evaluate_comp.scm 585 */
													obj_t BgL_arg3398z00_16618;

													BgL_arg3398z00_16618 =
														CAR(((obj_t) BgL_valz00_16613));
													BgL_arg3395z00_16617 =
														BGl_appendzd221011zd2zz__evaluate_compz00
														(BgL_stkz00_13951, BgL_arg3398z00_16618);
												}
												BgL_arg3392z00_16615 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_arg3394z00_16616),
													BgL_arg3395z00_16617);
											}
											{	/* Eval/evaluate_comp.scm 574 */
												obj_t BgL_objz00_16619;

												BgL_objz00_16619 =
													BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00;
												{	/* Eval/evaluate_comp.scm 574 */
													obj_t BgL_tmpz00_31724;

													BgL_tmpz00_31724 = ((obj_t) BgL_arg3392z00_16615);
													PROCEDURE_ATTR_SET(BgL_tmpz00_31724,
														BgL_objz00_16619);
												}
												BgL_objz00_16619;
											}
											BgL_arg3391z00_16614 = BgL_arg3392z00_16615;
										}
										{	/* Eval/evaluate_comp.scm 584 */
											obj_t BgL_tmpz00_31727;

											BgL_tmpz00_31727 = ((obj_t) BgL_slotz00_16612);
											SET_CDR(BgL_tmpz00_31727, BgL_arg3391z00_16614);
										}
									}
								}
								{	/* Eval/evaluate_comp.scm 582 */
									obj_t BgL_arg3400z00_16620;
									obj_t BgL_arg3401z00_16621;

									BgL_arg3400z00_16620 = CDR(((obj_t) BgL_ll1337z00_16610));
									BgL_arg3401z00_16621 = CDR(((obj_t) BgL_ll1338z00_16611));
									{
										obj_t BgL_ll1338z00_31735;
										obj_t BgL_ll1337z00_31734;

										BgL_ll1337z00_31734 = BgL_arg3400z00_16620;
										BgL_ll1338z00_31735 = BgL_arg3401z00_16621;
										BgL_ll1338z00_16611 = BgL_ll1338z00_31735;
										BgL_ll1337z00_16610 = BgL_ll1337z00_31734;
										goto BgL_zc3z04anonymousza33388ze3z87_16609;
									}
								}
							}
					}
				}
			}
			{	/* Eval/evaluate_comp.scm 589 */
				obj_t BgL_bodyz00_16622;

				BgL_bodyz00_16622 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_13950)))->BgL_bodyz00),
					BgL_stkz00_13951);
				{	/* Eval/evaluate_comp.scm 590 */
					obj_t BgL_zc3z04anonymousza33407ze3z87_16623;

					BgL_zc3z04anonymousza33407ze3z87_16623 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33407ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33407ze3z87_16623,
						(int) (((long) 0)), BgL_bodyz00_16622);
					return BgL_zc3z04anonymousza33407ze3z87_16623;
				}
			}
		}

	}



/* &<@anonymous:3407> */
	obj_t BGl_z62zc3z04anonymousza33407ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13952, obj_t BgL_sz00_13954)
	{
		{	/* Eval/evaluate_comp.scm 590 */
			{	/* Eval/evaluate_comp.scm 590 */
				obj_t BgL_bodyz00_13953;

				BgL_bodyz00_13953 = PROCEDURE_REF(BgL_envz00_13952, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 590 */
					obj_t BgL_bpz00_16624;

					BgL_bpz00_16624 = VECTOR_REF(((obj_t) BgL_sz00_13954), ((long) 0));
					{
						obj_t BgL_fz00_16626;

						BgL_fz00_16626 = BgL_bodyz00_13953;
					BgL_recz00_16625:
						{	/* Eval/evaluate_comp.scm 597 */
							obj_t BgL_rz00_16627;

							BgL_rz00_16627 =
								PROCEDURE_ENTRY(BgL_fz00_16626) (BgL_fz00_16626, BgL_sz00_13954,
								BEOA);
							{	/* Eval/evaluate_comp.scm 599 */
								bool_t BgL_test5564z00_31752;

								if (PROCEDUREP(BgL_rz00_16627))
									{	/* Eval/evaluate_comp.scm 599 */
										obj_t BgL_arg1675z00_16628;

										BgL_arg1675z00_16628 = PROCEDURE_ATTR(BgL_rz00_16627);
										if (STRUCTP(BgL_arg1675z00_16628))
											{	/* Eval/evaluate_comp.scm 569 */
												BgL_test5564z00_31752 =
													(STRUCT_KEY(BgL_arg1675z00_16628) ==
													BGl_symbol4587z00zz__evaluate_compz00);
											}
										else
											{	/* Eval/evaluate_comp.scm 569 */
												BgL_test5564z00_31752 = ((bool_t) 0);
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 599 */
										BgL_test5564z00_31752 = ((bool_t) 0);
									}
								if (BgL_test5564z00_31752)
									{
										obj_t BgL_fz00_31760;

										BgL_fz00_31760 = BgL_rz00_16627;
										BgL_fz00_16626 = BgL_fz00_31760;
										goto BgL_recz00_16625;
									}
								else
									{	/* Eval/evaluate_comp.scm 599 */
										return BgL_rz00_16627;
									}
							}
						}
					}
				}
			}
		}

	}



/* &comp-ev_synchronize1430 */
	obj_t BGl_z62compzd2ev_synchroniza7e1430z17zz__evaluate_compz00(obj_t
		BgL_envz00_13955, obj_t BgL_ez00_13956, obj_t BgL_stkz00_13957)
	{
		{	/* Eval/evaluate_comp.scm 552 */
			{	/* Eval/evaluate_comp.scm 554 */
				obj_t BgL_mutexz00_16630;
				obj_t BgL_prelockz00_16631;
				obj_t BgL_bodyz00_16632;

				BgL_mutexz00_16630 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
								((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_13956)))->
						BgL_mutexz00), BgL_stkz00_13957);
				BgL_prelockz00_16631 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_13956)))->
						BgL_prelockz00), BgL_stkz00_13957);
				BgL_bodyz00_16632 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_13956)))->
						BgL_bodyz00), BgL_stkz00_13957);
				{	/* Eval/evaluate_comp.scm 557 */
					obj_t BgL_zc3z04anonymousza33380ze3z87_16633;

					BgL_zc3z04anonymousza33380ze3z87_16633 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33380ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 4)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33380ze3z87_16633,
						(int) (((long) 0)), BgL_mutexz00_16630);
					PROCEDURE_SET(BgL_zc3z04anonymousza33380ze3z87_16633,
						(int) (((long) 1)),
						((obj_t) ((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_13956)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33380ze3z87_16633,
						(int) (((long) 2)), BgL_prelockz00_16631);
					PROCEDURE_SET(BgL_zc3z04anonymousza33380ze3z87_16633,
						(int) (((long) 3)), BgL_bodyz00_16632);
					return BgL_zc3z04anonymousza33380ze3z87_16633;
				}
			}
		}

	}



/* &<@anonymous:3380> */
	obj_t BGl_z62zc3z04anonymousza33380ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13958, obj_t BgL_sz00_13963)
	{
		{	/* Eval/evaluate_comp.scm 557 */
			{	/* Eval/evaluate_comp.scm 557 */
				obj_t BgL_mutexz00_13959;
				BgL_ev_synchroniza7eza7_bglt BgL_i1142z00_13960;
				obj_t BgL_prelockz00_13961;
				obj_t BgL_bodyz00_13962;

				BgL_mutexz00_13959 =
					PROCEDURE_REF(BgL_envz00_13958, (int) (((long) 0)));
				BgL_i1142z00_13960 =
					((BgL_ev_synchroniza7eza7_bglt)
					PROCEDURE_REF(BgL_envz00_13958, (int) (((long) 1))));
				BgL_prelockz00_13961 =
					PROCEDURE_REF(BgL_envz00_13958, (int) (((long) 2)));
				BgL_bodyz00_13962 = PROCEDURE_REF(BgL_envz00_13958, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 557 */
					obj_t BgL_bpz00_16634;

					BgL_bpz00_16634 = VECTOR_REF(((obj_t) BgL_sz00_13963), ((long) 0));
					{	/* Eval/evaluate_comp.scm 558 */
						obj_t BgL_mz00_16635;

						BgL_mz00_16635 =
							PROCEDURE_ENTRY(BgL_mutexz00_13959) (BgL_mutexz00_13959,
							BgL_sz00_13963, BEOA);
						if (BGL_MUTEXP(BgL_mz00_16635))
							{	/* Eval/evaluate_comp.scm 560 */
								obj_t BgL_pz00_16636;

								BgL_pz00_16636 =
									PROCEDURE_ENTRY(BgL_prelockz00_13961) (BgL_prelockz00_13961,
									BgL_sz00_13963, BEOA);
								{	/* Eval/evaluate_comp.scm 562 */
									obj_t BgL_za2za2resza2za2z00_16637;

									if (PAIRP(BgL_pz00_16636))
										{	/* Eval/evaluate_comp.scm 563 */
											obj_t BgL_top5570z00_31807;

											BgL_top5570z00_31807 = BGL_EXITD_TOP_AS_OBJ();
											BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_16635, BgL_pz00_16636);
											BGL_EXITD_PUSH_PROTECT(BgL_top5570z00_31807,
												BgL_mz00_16635);
											BUNSPEC;
											{	/* Eval/evaluate_comp.scm 563 */
												obj_t BgL_tmp5569z00_31806;

												BgL_tmp5569z00_31806 =
													PROCEDURE_ENTRY(BgL_bodyz00_13962) (BgL_bodyz00_13962,
													BgL_sz00_13963, BEOA);
												BGL_EXITD_POP_PROTECT(BgL_top5570z00_31807);
												BUNSPEC;
												BGL_MUTEX_UNLOCK(BgL_mz00_16635);
												BgL_za2za2resza2za2z00_16637 = BgL_tmp5569z00_31806;
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 564 */
											obj_t BgL_top5572z00_31818;

											BgL_top5572z00_31818 = BGL_EXITD_TOP_AS_OBJ();
											BGL_MUTEX_LOCK(BgL_mz00_16635);
											BGL_EXITD_PUSH_PROTECT(BgL_top5572z00_31818,
												BgL_mz00_16635);
											BUNSPEC;
											{	/* Eval/evaluate_comp.scm 564 */
												obj_t BgL_tmp5571z00_31817;

												BgL_tmp5571z00_31817 =
													PROCEDURE_ENTRY(BgL_bodyz00_13962) (BgL_bodyz00_13962,
													BgL_sz00_13963, BEOA);
												BGL_EXITD_POP_PROTECT(BgL_top5572z00_31818);
												BUNSPEC;
												BGL_MUTEX_UNLOCK(BgL_mz00_16635);
												BgL_za2za2resza2za2z00_16637 = BgL_tmp5571z00_31817;
											}
										}
									VECTOR_SET(
										((obj_t) BgL_sz00_13963), ((long) 0), BgL_bpz00_16634);
									return BgL_za2za2resza2za2z00_16637;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 559 */
								return
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_string4712z00zz__evaluate_compz00,
									BGl_string4713z00zz__evaluate_compz00, BgL_mz00_16635,
									(((BgL_ev_synchroniza7eza7_bglt)
											COBJECT(BgL_i1142z00_13960))->BgL_locz00));
							}
					}
				}
			}
		}

	}



/* &comp-ev_with-handler1428 */
	obj_t BGl_z62compzd2ev_withzd2handler1428z62zz__evaluate_compz00(obj_t
		BgL_envz00_13964, obj_t BgL_ez00_13965, obj_t BgL_stkz00_13966)
	{
		{	/* Eval/evaluate_comp.scm 543 */
			{	/* Eval/evaluate_comp.scm 545 */
				obj_t BgL_handlerz00_16639;
				obj_t BgL_bodyz00_16640;

				BgL_handlerz00_16639 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
								((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_13965)))->
						BgL_handlerz00), BgL_stkz00_13966);
				BgL_bodyz00_16640 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_withzd2handlerzd2_bglt)
							COBJECT(((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_13965)))->
						BgL_bodyz00), BgL_stkz00_13966);
				{	/* Eval/evaluate_comp.scm 546 */
					obj_t BgL_zc3z04anonymousza33353ze3z87_16641;

					BgL_zc3z04anonymousza33353ze3z87_16641 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33353ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33353ze3z87_16641,
						(int) (((long) 0)), BgL_handlerz00_16639);
					PROCEDURE_SET(BgL_zc3z04anonymousza33353ze3z87_16641,
						(int) (((long) 1)), BgL_bodyz00_16640);
					return BgL_zc3z04anonymousza33353ze3z87_16641;
				}
			}
		}

	}



/* &<@anonymous:3353> */
	obj_t BGl_z62zc3z04anonymousza33353ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13967, obj_t BgL_sz00_13970)
	{
		{	/* Eval/evaluate_comp.scm 546 */
			{	/* Eval/evaluate_comp.scm 546 */
				obj_t BgL_handlerz00_13968;
				obj_t BgL_bodyz00_13969;

				BgL_handlerz00_13968 =
					PROCEDURE_REF(BgL_envz00_13967, (int) (((long) 0)));
				BgL_bodyz00_13969 = PROCEDURE_REF(BgL_envz00_13967, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 546 */
					obj_t BgL_bpz00_16642;

					BgL_bpz00_16642 = VECTOR_REF(((obj_t) BgL_sz00_13970), ((long) 0));
					{	/* Eval/evaluate_comp.scm 547 */
						obj_t BgL_hz00_16643;

						BgL_hz00_16643 =
							PROCEDURE_ENTRY(BgL_handlerz00_13968) (BgL_handlerz00_13968,
							BgL_sz00_13970, BEOA);
						{	/* Eval/evaluate_comp.scm 549 */
							obj_t BgL_za2za2resza2za2z00_16644;

							{	/* Eval/evaluate_comp.scm 549 */
								obj_t BgL_res1132z00_16645;

								BgL_res1132z00_16645 = MAKE_CELL(BUNSPEC);
								if (CBOOL(BGl_zc3z04exitza33359ze3ze70z60zz__evaluate_compz00
										(BgL_sz00_13970, BgL_bodyz00_13969, BgL_res1132z00_16645)))
									{	/* Eval/evaluate_comp.scm 549 */
										{	/* Eval/evaluate_comp.scm 549 */
											int BgL_tmpz00_31858;

											BgL_tmpz00_31858 = (int) (((long) 0));
											BGL_SIGSETMASK(BgL_tmpz00_31858);
										}
										BgL_za2za2resza2za2z00_16644 =
											PROCEDURE_ENTRY(BgL_hz00_16643) (BgL_hz00_16643,
											CELL_REF(BgL_res1132z00_16645), BEOA);
									}
								else
									{	/* Eval/evaluate_comp.scm 549 */
										BgL_za2za2resza2za2z00_16644 =
											CELL_REF(BgL_res1132z00_16645);
									}
							}
							VECTOR_SET(((obj_t) BgL_sz00_13970), ((long) 0), BgL_bpz00_16642);
							return BgL_za2za2resza2za2z00_16644;
						}
					}
				}
			}
		}

	}



/* <@exit:3359>~0 */
	obj_t BGl_zc3z04exitza33359ze3ze70z60zz__evaluate_compz00(obj_t
		BgL_sz00_14158, obj_t BgL_bodyz00_14157, obj_t BgL_res1132z00_14156)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1138z00_4224;

			if (SET_EXIT(BgL_an_exit1138z00_4224))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
				 // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

					BgL_an_exit1138z00_4224 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 549 */

						PUSH_EXIT(BgL_an_exit1138z00_4224, ((long) 1));
						{	/* Eval/evaluate_comp.scm 549 */
							obj_t BgL_an_exitd1139z00_4225;

							BgL_an_exitd1139z00_4225 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 549 */
								bool_t BgL_res1141z00_4228;

								{	/* Eval/evaluate_comp.scm 549 */
									obj_t BgL_ohs1130z00_4229;

									BgL_ohs1130z00_4229 = BGL_ERROR_HANDLER_GET();
									{	/* Eval/evaluate_comp.scm 549 */
										obj_t BgL_exitd1135z00_4230;

										BgL_exitd1135z00_4230 = ((obj_t) (&exitd));
										{
											obj_t BgL_zc3z04anonymousza33362ze3z87_12937;

											BgL_zc3z04anonymousza33362ze3z87_12937 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33362ze3ze5zz__evaluate_compz00,
												(int) (((long) 0)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33362ze3z87_12937,
												(int) (((long) 0)), BgL_ohs1130z00_4229);
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_exitd1135z00_4230,
												BgL_zc3z04anonymousza33362ze3z87_12937);
											{	/* Eval/evaluate_comp.scm 549 */
												bool_t BgL_tmp1137z00_4232;

												{	/* Eval/evaluate_comp.scm 549 */
													obj_t BgL_zc3z04anonymousza33361ze3z87_12938;

													BgL_zc3z04anonymousza33361ze3z87_12938 =
														MAKE_FX_PROCEDURE
														(BGl_z62zc3z04anonymousza33361ze3ze5zz__evaluate_compz00,
														(int) (((long) 1)), (int) (((long) 2)));
													PROCEDURE_SET(BgL_zc3z04anonymousza33361ze3z87_12938,
														(int) (((long) 0)), ((obj_t) BgL_res1132z00_14156));
													PROCEDURE_SET(BgL_zc3z04anonymousza33361ze3z87_12938,
														(int) (((long) 1)), BgL_an_exitd1139z00_4225);
													BGL_ERROR_HANDLER_PUSH
														(BgL_zc3z04anonymousza33361ze3z87_12938,
														BgL_ohs1130z00_4229);
													BUNSPEC;
												}
												{	/* Eval/evaluate_comp.scm 549 */
													obj_t BgL_auxz00_13972;

													BgL_auxz00_13972 =
														PROCEDURE_ENTRY(BgL_bodyz00_14157)
														(BgL_bodyz00_14157, BgL_sz00_14158, BEOA);
													CELL_SET(BgL_res1132z00_14156, BgL_auxz00_13972);
												}
												BgL_tmp1137z00_4232 = ((bool_t) 0);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_exitd1135z00_4230);
												BGL_ERROR_HANDLER_SET(BgL_ohs1130z00_4229);
												BUNSPEC;
												BgL_res1141z00_4228 = BgL_tmp1137z00_4232;
								}}}}
								POP_EXIT();
								return BBOOL(BgL_res1141z00_4228);
							}
						}
					}
				}
		}

	}



/* &<@anonymous:3361> */
	obj_t BGl_z62zc3z04anonymousza33361ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13974, obj_t BgL_ez00_13977)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			{	/* Eval/evaluate_comp.scm 549 */
				obj_t BgL_res1132z00_13975;
				obj_t BgL_an_exitd1139z00_13976;

				BgL_res1132z00_13975 =
					PROCEDURE_REF(BgL_envz00_13974, (int) (((long) 0)));
				BgL_an_exitd1139z00_13976 =
					PROCEDURE_REF(BgL_envz00_13974, (int) (((long) 1)));
				CELL_SET(BgL_res1132z00_13975, BgL_ez00_13977);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1139z00_13976,
					BTRUE);
			}
		}

	}



/* &<@anonymous:3362> */
	obj_t BGl_z62zc3z04anonymousza33362ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13979)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			{
				obj_t BgL_ohs1130z00_13980;

				BgL_ohs1130z00_13980 =
					PROCEDURE_REF(BgL_envz00_13979, (int) (((long) 0)));
				BGL_ERROR_HANDLER_SET(BgL_ohs1130z00_13980);
				return BUNSPEC;
			}
		}

	}



/* &comp-ev_unwind-prote1426 */
	obj_t BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00(obj_t
		BgL_envz00_13981, obj_t BgL_ez00_13982, obj_t BgL_stkz00_13983)
	{
		{	/* Eval/evaluate_comp.scm 534 */
			{	/* Eval/evaluate_comp.scm 536 */
				obj_t BgL_ez00_16647;
				obj_t BgL_bodyz00_16648;

				BgL_ez00_16647 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
								((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_13982)))->BgL_ez00),
					BgL_stkz00_13983);
				BgL_bodyz00_16648 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_unwindzd2protectzd2_bglt)
							COBJECT(((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_13982)))->
						BgL_bodyz00), BgL_stkz00_13983);
				{	/* Eval/evaluate_comp.scm 537 */
					obj_t BgL_zc3z04anonymousza33349ze3z87_16649;

					BgL_zc3z04anonymousza33349ze3z87_16649 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33349ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33349ze3z87_16649,
						(int) (((long) 0)), BgL_bodyz00_16648);
					PROCEDURE_SET(BgL_zc3z04anonymousza33349ze3z87_16649,
						(int) (((long) 1)), BgL_ez00_16647);
					return BgL_zc3z04anonymousza33349ze3z87_16649;
				}
			}
		}

	}



/* &<@anonymous:3349> */
	obj_t BGl_z62zc3z04anonymousza33349ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13984, obj_t BgL_sz00_13987)
	{
		{	/* Eval/evaluate_comp.scm 537 */
			{	/* Eval/evaluate_comp.scm 537 */
				obj_t BgL_bodyz00_13985;
				obj_t BgL_ez00_13986;

				BgL_bodyz00_13985 = PROCEDURE_REF(BgL_envz00_13984, (int) (((long) 0)));
				BgL_ez00_13986 = PROCEDURE_REF(BgL_envz00_13984, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 537 */
					obj_t BgL_bpz00_16650;

					BgL_bpz00_16650 = VECTOR_REF(((obj_t) BgL_sz00_13987), ((long) 0));
					{	/* Eval/evaluate_comp.scm 539 */
						obj_t BgL_exitd1126z00_16651;

						BgL_exitd1126z00_16651 = BGL_EXITD_TOP_AS_OBJ();
						{	/* Eval/evaluate_comp.scm 540 */
							obj_t BgL_zc3z04anonymousza33350ze3z87_16652;

							BgL_zc3z04anonymousza33350ze3z87_16652 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33350ze3ze5zz__evaluate_compz00,
								(int) (((long) 0)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33350ze3z87_16652,
								(int) (((long) 0)), BgL_sz00_13987);
							PROCEDURE_SET(BgL_zc3z04anonymousza33350ze3z87_16652,
								(int) (((long) 1)), BgL_bpz00_16650);
							PROCEDURE_SET(BgL_zc3z04anonymousza33350ze3z87_16652,
								(int) (((long) 2)), BgL_bodyz00_13985);
							BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
								(BgL_exitd1126z00_16651,
								BgL_zc3z04anonymousza33350ze3z87_16652);
							{	/* Eval/evaluate_comp.scm 539 */
								obj_t BgL_tmp1128z00_16653;

								BgL_tmp1128z00_16653 =
									PROCEDURE_ENTRY(BgL_ez00_13986) (BgL_ez00_13986,
									BgL_sz00_13987, BEOA);
								BGl_exitdzd2popzd2protectz12z12zz__bexitz00
									(BgL_exitd1126z00_16651);
								VECTOR_SET(((obj_t) BgL_sz00_13987), ((long) 0),
									BgL_bpz00_16650);
								PROCEDURE_ENTRY(BgL_bodyz00_13985) (BgL_bodyz00_13985,
									BgL_sz00_13987, BEOA);
								return BgL_tmp1128z00_16653;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3350> */
	obj_t BGl_z62zc3z04anonymousza33350ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13988)
	{
		{	/* Eval/evaluate_comp.scm 539 */
			{	/* Eval/evaluate_comp.scm 540 */
				obj_t BgL_sz00_13989;
				obj_t BgL_savedzd2bpzd2_13990;
				obj_t BgL_bodyz00_13991;

				BgL_sz00_13989 = PROCEDURE_REF(BgL_envz00_13988, (int) (((long) 0)));
				BgL_savedzd2bpzd2_13990 =
					PROCEDURE_REF(BgL_envz00_13988, (int) (((long) 1)));
				BgL_bodyz00_13991 = PROCEDURE_REF(BgL_envz00_13988, (int) (((long) 2)));
				VECTOR_SET(
					((obj_t) BgL_sz00_13989), ((long) 0), BgL_savedzd2bpzd2_13990);
				return
					PROCEDURE_ENTRY(BgL_bodyz00_13991) (BgL_bodyz00_13991, BgL_sz00_13989,
					BEOA);
			}
		}

	}



/* &comp-ev_bind-exit1424 */
	obj_t BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00(obj_t
		BgL_envz00_13992, obj_t BgL_ez00_13993, obj_t BgL_stkz00_13994)
	{
		{	/* Eval/evaluate_comp.scm 523 */
			{	/* Eval/evaluate_comp.scm 525 */
				long BgL_siza7eza7_16655;
				obj_t BgL_nstkz00_16656;

				BgL_siza7eza7_16655 = bgl_list_length(BgL_stkz00_13994);
				{	/* Eval/evaluate_comp.scm 525 */
					obj_t BgL_arg3347z00_16657;

					{	/* Eval/evaluate_comp.scm 525 */
						BgL_ev_varz00_bglt BgL_arg3348z00_16658;

						BgL_arg3348z00_16658 =
							(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_13993)))->BgL_varz00);
						BgL_arg3347z00_16657 =
							MAKE_YOUNG_PAIR(((obj_t) BgL_arg3348z00_16658), BNIL);
					}
					BgL_nstkz00_16656 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_13994,
						BgL_arg3347z00_16657);
				}
				{	/* Eval/evaluate_comp.scm 526 */
					obj_t BgL_bodyz00_16659;
					obj_t BgL_effzf3zf3_16660;

					BgL_bodyz00_16659 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_13993)))->BgL_bodyz00),
						BgL_nstkz00_16656);
					BgL_effzf3zf3_16660 =
						(((BgL_ev_varz00_bglt) COBJECT((((BgL_ev_bindzd2exitzd2_bglt)
										COBJECT(((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_13993)))->
									BgL_varz00)))->BgL_effz00);
					{	/* Eval/evaluate_comp.scm 527 */
						obj_t BgL_zc3z04anonymousza33341ze3z87_16661;

						BgL_zc3z04anonymousza33341ze3z87_16661 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33341ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33341ze3z87_16661,
							(int) (((long) 0)), BINT(BgL_siza7eza7_16655));
						PROCEDURE_SET(BgL_zc3z04anonymousza33341ze3z87_16661,
							(int) (((long) 1)), BgL_effzf3zf3_16660);
						PROCEDURE_SET(BgL_zc3z04anonymousza33341ze3z87_16661,
							(int) (((long) 2)), BgL_bodyz00_16659);
						return BgL_zc3z04anonymousza33341ze3z87_16661;
					}
				}
			}
		}

	}



/* &<@anonymous:3341> */
	obj_t BGl_z62zc3z04anonymousza33341ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13995, obj_t BgL_sz00_13999)
	{
		{	/* Eval/evaluate_comp.scm 527 */
			{	/* Eval/evaluate_comp.scm 527 */
				long BgL_siza7eza7_13996;
				obj_t BgL_effzf3zf3_13997;
				obj_t BgL_bodyz00_13998;

				BgL_siza7eza7_13996 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13995, (int) (((long) 0))));
				BgL_effzf3zf3_13997 =
					PROCEDURE_REF(BgL_envz00_13995, (int) (((long) 1)));
				BgL_bodyz00_13998 = PROCEDURE_REF(BgL_envz00_13995, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 527 */
					obj_t BgL_bpz00_16662;

					BgL_bpz00_16662 = VECTOR_REF(((obj_t) BgL_sz00_13999), ((long) 0));
					{	/* Eval/evaluate_comp.scm 529 */
						obj_t BgL_za2za2resza2za2z00_16663;

						BgL_za2za2resza2za2z00_16663 =
							BGl_zc3z04exitza33342ze3ze70z60zz__evaluate_compz00
							(BgL_bodyz00_13998, BgL_sz00_13999, BgL_effzf3zf3_13997,
							BgL_siza7eza7_13996, BgL_bpz00_16662);
						VECTOR_SET(((obj_t) BgL_sz00_13999), ((long) 0), BgL_bpz00_16662);
						return BgL_za2za2resza2za2z00_16663;
					}
				}
			}
		}

	}



/* <@exit:3342>~0 */
	obj_t BGl_zc3z04exitza33342ze3ze70z60zz__evaluate_compz00(obj_t
		BgL_bodyz00_14155, obj_t BgL_sz00_14154, obj_t BgL_effzf3zf3_14153,
		long BgL_siza7eza7_14152, obj_t BgL_bpz00_14151)
	{
		{	/* Eval/evaluate_comp.scm 529 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1121z00_4160;

			if (SET_EXIT(BgL_an_exit1121z00_4160))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
				 // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

					BgL_an_exit1121z00_4160 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 529 */

						PUSH_EXIT(BgL_an_exit1121z00_4160, ((long) 1));
						{	/* Eval/evaluate_comp.scm 529 */
							obj_t BgL_an_exitd1122z00_4161;

							BgL_an_exitd1122z00_4161 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 529 */
								obj_t BgL_exitz00_12944;

								BgL_exitz00_12944 =
									MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_exitz00_12944,
									(int) (((long) 0)), BgL_an_exitd1122z00_4161);
								{	/* Eval/evaluate_comp.scm 529 */
									obj_t BgL_res1124z00_4164;

									{	/* Eval/evaluate_comp.scm 530 */
										long BgL_arg3344z00_4165;
										obj_t BgL_arg3345z00_4166;

										BgL_arg3344z00_4165 =
											((long) CINT(BgL_bpz00_14151) + BgL_siza7eza7_14152);
										if (CBOOL(BgL_effzf3zf3_14153))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_9717;

												BgL_newz00_9717 =
													create_struct(BGl_symbol4603z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_32003;

													BgL_tmpz00_32003 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_9717, BgL_tmpz00_32003,
														BgL_exitz00_12944);
												}
												BgL_arg3345z00_4166 = BgL_newz00_9717;
											}
										else
											{	/* Eval/evaluate_comp.scm 530 */
												BgL_arg3345z00_4166 = BgL_exitz00_12944;
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_14154), BgL_arg3344z00_4165,
											BgL_arg3345z00_4166);
									}
									BgL_res1124z00_4164 =
										PROCEDURE_ENTRY(BgL_bodyz00_14155) (BgL_bodyz00_14155,
										BgL_sz00_14154, BEOA);
									POP_EXIT();
									return BgL_res1124z00_4164;
								}
							}
						}
					}
				}
		}

	}



/* &exit */
	obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_14000,
		obj_t BgL_val1123z00_14002)
	{
		{	/* Eval/evaluate_comp.scm 529 */
			return
				BGl_unwindzd2untilz12zc0zz__bexitz00(PROCEDURE_REF(BgL_envz00_14000,
					(int) (((long) 0))), BgL_val1123z00_14002);
		}

	}



/* &comp-ev_letrec1422 */
	obj_t BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00(obj_t
		BgL_envz00_14003, obj_t BgL_ez00_14004, obj_t BgL_stkz00_14005)
	{
		{	/* Eval/evaluate_comp.scm 494 */
			{	/* Eval/evaluate_comp.scm 496 */
				long BgL_siza7eza7_16665;
				obj_t BgL_nstkz00_16666;

				BgL_siza7eza7_16665 = bgl_list_length(BgL_stkz00_14005);
				{	/* Eval/evaluate_comp.scm 496 */
					obj_t BgL_arg3340z00_16667;

					BgL_arg3340z00_16667 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letrecz00_bglt) BgL_ez00_14004))))->BgL_varsz00);
					BgL_nstkz00_16666 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_14005,
						BgL_arg3340z00_16667);
				}
				{	/* Eval/evaluate_comp.scm 497 */
					obj_t BgL_cvalsz00_16668;
					obj_t BgL_bodyz00_16669;

					{	/* Eval/evaluate_comp.scm 497 */
						obj_t BgL_l1318z00_16670;

						BgL_l1318z00_16670 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_14004))))->BgL_valsz00);
						if (NULLP(BgL_l1318z00_16670))
							{	/* Eval/evaluate_comp.scm 497 */
								BgL_cvalsz00_16668 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 497 */
								obj_t BgL_head1320z00_16671;

								BgL_head1320z00_16671 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								{
									obj_t BgL_l1318z00_16673;
									obj_t BgL_tail1321z00_16674;

									BgL_l1318z00_16673 = BgL_l1318z00_16670;
									BgL_tail1321z00_16674 = BgL_head1320z00_16671;
								BgL_zc3z04anonymousza33332ze3z87_16672:
									if (NULLP(BgL_l1318z00_16673))
										{	/* Eval/evaluate_comp.scm 497 */
											BgL_cvalsz00_16668 = CDR(BgL_head1320z00_16671);
										}
									else
										{	/* Eval/evaluate_comp.scm 497 */
											obj_t BgL_newtail1322z00_16675;

											{	/* Eval/evaluate_comp.scm 497 */
												obj_t BgL_arg3337z00_16676;

												{	/* Eval/evaluate_comp.scm 497 */
													obj_t BgL_vz00_16677;

													BgL_vz00_16677 = CAR(((obj_t) BgL_l1318z00_16673));
													BgL_arg3337z00_16676 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_16677),
														BgL_nstkz00_16666);
												}
												BgL_newtail1322z00_16675 =
													MAKE_YOUNG_PAIR(BgL_arg3337z00_16676, BNIL);
											}
											SET_CDR(BgL_tail1321z00_16674, BgL_newtail1322z00_16675);
											{	/* Eval/evaluate_comp.scm 497 */
												obj_t BgL_arg3336z00_16678;

												BgL_arg3336z00_16678 =
													CDR(((obj_t) BgL_l1318z00_16673));
												{
													obj_t BgL_tail1321z00_32039;
													obj_t BgL_l1318z00_32038;

													BgL_l1318z00_32038 = BgL_arg3336z00_16678;
													BgL_tail1321z00_32039 = BgL_newtail1322z00_16675;
													BgL_tail1321z00_16674 = BgL_tail1321z00_32039;
													BgL_l1318z00_16673 = BgL_l1318z00_32038;
													goto BgL_zc3z04anonymousza33332ze3z87_16672;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 498 */
						BgL_ev_exprz00_bglt BgL_arg3338z00_16679;

						BgL_arg3338z00_16679 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_14004))))->BgL_bodyz00);
						BgL_bodyz00_16669 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3338z00_16679,
							BgL_nstkz00_16666);
					}
					{	/* Eval/evaluate_comp.scm 499 */
						bool_t BgL_test5577z00_32044;

						{
							obj_t BgL_l1323z00_16681;

							BgL_l1323z00_16681 =
								(((BgL_ev_binderz00_bglt) COBJECT(
										((BgL_ev_binderz00_bglt)
											((BgL_ev_letrecz00_bglt) BgL_ez00_14004))))->BgL_valsz00);
						BgL_zc3z04anonymousza33326ze3z87_16680:
							if (NULLP(BgL_l1323z00_16681))
								{	/* Eval/evaluate_comp.scm 499 */
									BgL_test5577z00_32044 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 499 */
									bool_t BgL_test5579z00_32047;

									{	/* Eval/evaluate_comp.scm 499 */
										obj_t BgL_vz00_16682;

										BgL_vz00_16682 = CAR(((obj_t) BgL_l1323z00_16681));
										BgL_test5579z00_32047 =
											BGl_isazf3zf3zz__objectz00(BgL_vz00_16682,
											BGl_ev_absz00zz__evaluate_typesz00);
									}
									if (BgL_test5579z00_32047)
										{
											obj_t BgL_l1323z00_32051;

											BgL_l1323z00_32051 = CDR(((obj_t) BgL_l1323z00_16681));
											BgL_l1323z00_16681 = BgL_l1323z00_32051;
											goto BgL_zc3z04anonymousza33326ze3z87_16680;
										}
									else
										{	/* Eval/evaluate_comp.scm 499 */
											BgL_test5577z00_32044 = ((bool_t) 0);
										}
								}
						}
						if (BgL_test5577z00_32044)
							{	/* Eval/evaluate_comp.scm 500 */
								obj_t BgL_zc3z04anonymousza33282ze3z87_16683;

								BgL_zc3z04anonymousza33282ze3z87_16683 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33282ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33282ze3z87_16683,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16665));
								PROCEDURE_SET(BgL_zc3z04anonymousza33282ze3z87_16683,
									(int) (((long) 1)), BgL_cvalsz00_16668);
								PROCEDURE_SET(BgL_zc3z04anonymousza33282ze3z87_16683,
									(int) (((long) 2)), BgL_bodyz00_16669);
								return BgL_zc3z04anonymousza33282ze3z87_16683;
							}
						else
							{	/* Eval/evaluate_comp.scm 510 */
								obj_t BgL_zc3z04anonymousza33309ze3z87_16684;

								BgL_zc3z04anonymousza33309ze3z87_16684 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33309ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33309ze3z87_16684,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16665));
								PROCEDURE_SET(BgL_zc3z04anonymousza33309ze3z87_16684,
									(int) (((long) 1)), BgL_cvalsz00_16668);
								PROCEDURE_SET(BgL_zc3z04anonymousza33309ze3z87_16684,
									(int) (((long) 2)), BgL_bodyz00_16669);
								return BgL_zc3z04anonymousza33309ze3z87_16684;
							}
					}
				}
			}
		}

	}



/* &<@anonymous:3282> */
	obj_t BGl_z62zc3z04anonymousza33282ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14006, obj_t BgL_sz00_14010)
	{
		{	/* Eval/evaluate_comp.scm 500 */
			{	/* Eval/evaluate_comp.scm 500 */
				long BgL_siza7eza7_14007;
				obj_t BgL_cvalsz00_14008;
				obj_t BgL_bodyz00_14009;

				BgL_siza7eza7_14007 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14006, (int) (((long) 0))));
				BgL_cvalsz00_14008 =
					PROCEDURE_REF(BgL_envz00_14006, (int) (((long) 1)));
				BgL_bodyz00_14009 = PROCEDURE_REF(BgL_envz00_14006, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 500 */
					obj_t BgL_bpz00_16685;

					BgL_bpz00_16685 = VECTOR_REF(((obj_t) BgL_sz00_14010), ((long) 0));
					{	/* Eval/evaluate_comp.scm 501 */
						long BgL_g1115z00_16686;

						BgL_g1115z00_16686 =
							((long) CINT(BgL_bpz00_16685) + BgL_siza7eza7_14007);
						{
							obj_t BgL_lz00_16688;
							long BgL_iz00_16689;

							BgL_lz00_16688 = BgL_cvalsz00_14008;
							BgL_iz00_16689 = BgL_g1115z00_16686;
						BgL_recz00_16687:
							if (NULLP(BgL_lz00_16688))
								{	/* Eval/evaluate_comp.scm 502 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 502 */
									{	/* Eval/evaluate_comp.scm 503 */
										obj_t BgL_arg3289z00_16690;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_16691;

											BgL_newz00_16691 =
												create_struct(BGl_symbol4603z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_32092;

												BgL_tmpz00_32092 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16691, BgL_tmpz00_32092, BUNSPEC);
											}
											BgL_arg3289z00_16690 = BgL_newz00_16691;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_14010), BgL_iz00_16689,
											BgL_arg3289z00_16690);
									}
									{	/* Eval/evaluate_comp.scm 504 */
										obj_t BgL_arg3292z00_16692;
										long BgL_arg3293z00_16693;

										BgL_arg3292z00_16692 = CDR(((obj_t) BgL_lz00_16688));
										BgL_arg3293z00_16693 = (BgL_iz00_16689 + ((long) 1));
										{
											long BgL_iz00_32101;
											obj_t BgL_lz00_32100;

											BgL_lz00_32100 = BgL_arg3292z00_16692;
											BgL_iz00_32101 = BgL_arg3293z00_16693;
											BgL_iz00_16689 = BgL_iz00_32101;
											BgL_lz00_16688 = BgL_lz00_32100;
											goto BgL_recz00_16687;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 505 */
						long BgL_g1116z00_16694;

						BgL_g1116z00_16694 =
							((long) CINT(BgL_bpz00_16685) + BgL_siza7eza7_14007);
						{
							obj_t BgL_lz00_16696;
							long BgL_iz00_16697;

							BgL_lz00_16696 = BgL_cvalsz00_14008;
							BgL_iz00_16697 = BgL_g1116z00_16694;
						BgL_recz00_16695:
							if (NULLP(BgL_lz00_16696))
								{	/* Eval/evaluate_comp.scm 506 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 506 */
									{	/* Eval/evaluate_comp.scm 507 */
										obj_t BgL_arg3301z00_16698;
										obj_t BgL_arg3305z00_16699;

										BgL_arg3301z00_16698 =
											VECTOR_REF(((obj_t) BgL_sz00_14010), BgL_iz00_16697);
										{	/* Eval/evaluate_comp.scm 507 */
											obj_t BgL_fun3306z00_16700;

											BgL_fun3306z00_16700 = CAR(((obj_t) BgL_lz00_16696));
											BgL_arg3305z00_16699 =
												PROCEDURE_ENTRY(BgL_fun3306z00_16700)
												(BgL_fun3306z00_16700, BgL_sz00_14010, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 202 */
											int BgL_auxz00_32116;
											obj_t BgL_tmpz00_32114;

											BgL_auxz00_32116 = (int) (((long) 0));
											BgL_tmpz00_32114 = ((obj_t) BgL_arg3301z00_16698);
											STRUCT_SET(BgL_tmpz00_32114, BgL_auxz00_32116,
												BgL_arg3305z00_16699);
									}}
									{	/* Eval/evaluate_comp.scm 508 */
										obj_t BgL_arg3307z00_16701;
										long BgL_arg3308z00_16702;

										BgL_arg3307z00_16701 = CDR(((obj_t) BgL_lz00_16696));
										BgL_arg3308z00_16702 = (BgL_iz00_16697 + ((long) 1));
										{
											long BgL_iz00_32123;
											obj_t BgL_lz00_32122;

											BgL_lz00_32122 = BgL_arg3307z00_16701;
											BgL_iz00_32123 = BgL_arg3308z00_16702;
											BgL_iz00_16697 = BgL_iz00_32123;
											BgL_lz00_16696 = BgL_lz00_32122;
											goto BgL_recz00_16695;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_14009) (BgL_bodyz00_14009,
						BgL_sz00_14010, BEOA);
				}
			}
		}

	}



/* &<@anonymous:3309> */
	obj_t BGl_z62zc3z04anonymousza33309ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14011, obj_t BgL_sz00_14015)
	{
		{	/* Eval/evaluate_comp.scm 510 */
			{	/* Eval/evaluate_comp.scm 510 */
				long BgL_siza7eza7_14012;
				obj_t BgL_cvalsz00_14013;
				obj_t BgL_bodyz00_14014;

				BgL_siza7eza7_14012 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14011, (int) (((long) 0))));
				BgL_cvalsz00_14013 =
					PROCEDURE_REF(BgL_envz00_14011, (int) (((long) 1)));
				BgL_bodyz00_14014 = PROCEDURE_REF(BgL_envz00_14011, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 510 */
					obj_t BgL_bpz00_16703;

					BgL_bpz00_16703 = VECTOR_REF(((obj_t) BgL_sz00_14015), ((long) 0));
					{	/* Eval/evaluate_comp.scm 511 */
						long BgL_g1117z00_16704;

						BgL_g1117z00_16704 =
							((long) CINT(BgL_bpz00_16703) + BgL_siza7eza7_14012);
						{
							obj_t BgL_lz00_16706;
							long BgL_iz00_16707;

							BgL_lz00_16706 = BgL_cvalsz00_14013;
							BgL_iz00_16707 = BgL_g1117z00_16704;
						BgL_recz00_16705:
							if (NULLP(BgL_lz00_16706))
								{	/* Eval/evaluate_comp.scm 512 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 512 */
									{	/* Eval/evaluate_comp.scm 513 */
										obj_t BgL_arg3312z00_16708;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_16709;

											BgL_newz00_16709 =
												create_struct(BGl_symbol4603z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_32143;

												BgL_tmpz00_32143 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16709, BgL_tmpz00_32143, BUNSPEC);
											}
											BgL_arg3312z00_16708 = BgL_newz00_16709;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_14015), BgL_iz00_16707,
											BgL_arg3312z00_16708);
									}
									{	/* Eval/evaluate_comp.scm 514 */
										obj_t BgL_arg3313z00_16710;
										long BgL_arg3314z00_16711;

										BgL_arg3313z00_16710 = CDR(((obj_t) BgL_lz00_16706));
										BgL_arg3314z00_16711 = (BgL_iz00_16707 + ((long) 1));
										{
											long BgL_iz00_32152;
											obj_t BgL_lz00_32151;

											BgL_lz00_32151 = BgL_arg3313z00_16710;
											BgL_iz00_32152 = BgL_arg3314z00_16711;
											BgL_iz00_16707 = BgL_iz00_32152;
											BgL_lz00_16706 = BgL_lz00_32151;
											goto BgL_recz00_16705;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 515 */
						obj_t BgL_rvalsz00_16712;

						if (NULLP(BgL_cvalsz00_14013))
							{	/* Eval/evaluate_comp.scm 515 */
								BgL_rvalsz00_16712 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 515 */
								obj_t BgL_head1329z00_16713;

								BgL_head1329z00_16713 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								{
									obj_t BgL_l1327z00_16715;
									obj_t BgL_tail1330z00_16716;

									BgL_l1327z00_16715 = BgL_cvalsz00_14013;
									BgL_tail1330z00_16716 = BgL_head1329z00_16713;
								BgL_zc3z04anonymousza33322ze3z87_16714:
									if (NULLP(BgL_l1327z00_16715))
										{	/* Eval/evaluate_comp.scm 515 */
											BgL_rvalsz00_16712 = CDR(BgL_head1329z00_16713);
										}
									else
										{	/* Eval/evaluate_comp.scm 515 */
											obj_t BgL_newtail1331z00_16717;

											{	/* Eval/evaluate_comp.scm 515 */
												obj_t BgL_arg3325z00_16718;

												{	/* Eval/evaluate_comp.scm 515 */
													obj_t BgL_vz00_16719;

													BgL_vz00_16719 = CAR(((obj_t) BgL_l1327z00_16715));
													BgL_arg3325z00_16718 =
														PROCEDURE_ENTRY(BgL_vz00_16719) (BgL_vz00_16719,
														BgL_sz00_14015, BEOA);
												}
												BgL_newtail1331z00_16717 =
													MAKE_YOUNG_PAIR(BgL_arg3325z00_16718, BNIL);
											}
											SET_CDR(BgL_tail1330z00_16716, BgL_newtail1331z00_16717);
											{	/* Eval/evaluate_comp.scm 515 */
												obj_t BgL_arg3324z00_16720;

												BgL_arg3324z00_16720 =
													CDR(((obj_t) BgL_l1327z00_16715));
												{
													obj_t BgL_tail1330z00_32170;
													obj_t BgL_l1327z00_32169;

													BgL_l1327z00_32169 = BgL_arg3324z00_16720;
													BgL_tail1330z00_32170 = BgL_newtail1331z00_16717;
													BgL_tail1330z00_16716 = BgL_tail1330z00_32170;
													BgL_l1327z00_16715 = BgL_l1327z00_32169;
													goto BgL_zc3z04anonymousza33322ze3z87_16714;
												}
											}
										}
								}
							}
						{	/* Eval/evaluate_comp.scm 516 */
							long BgL_g1118z00_16721;

							BgL_g1118z00_16721 =
								((long) CINT(BgL_bpz00_16703) + BgL_siza7eza7_14012);
							{
								obj_t BgL_lz00_16723;
								long BgL_iz00_16724;

								BgL_lz00_16723 = BgL_rvalsz00_16712;
								BgL_iz00_16724 = BgL_g1118z00_16721;
							BgL_recz00_16722:
								if (NULLP(BgL_lz00_16723))
									{	/* Eval/evaluate_comp.scm 517 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 517 */
										{	/* Eval/evaluate_comp.scm 518 */
											obj_t BgL_arg3317z00_16725;
											obj_t BgL_arg3318z00_16726;

											BgL_arg3317z00_16725 =
												VECTOR_REF(((obj_t) BgL_sz00_14015), BgL_iz00_16724);
											BgL_arg3318z00_16726 = CAR(((obj_t) BgL_lz00_16723));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_auxz00_32181;
												obj_t BgL_tmpz00_32179;

												BgL_auxz00_32181 = (int) (((long) 0));
												BgL_tmpz00_32179 = ((obj_t) BgL_arg3317z00_16725);
												STRUCT_SET(BgL_tmpz00_32179, BgL_auxz00_32181,
													BgL_arg3318z00_16726);
										}}
										{	/* Eval/evaluate_comp.scm 519 */
											obj_t BgL_arg3319z00_16727;
											long BgL_arg3320z00_16728;

											BgL_arg3319z00_16727 = CDR(((obj_t) BgL_lz00_16723));
											BgL_arg3320z00_16728 = (BgL_iz00_16724 + ((long) 1));
											{
												long BgL_iz00_32188;
												obj_t BgL_lz00_32187;

												BgL_lz00_32187 = BgL_arg3319z00_16727;
												BgL_iz00_32188 = BgL_arg3320z00_16728;
												BgL_iz00_16724 = BgL_iz00_32188;
												BgL_lz00_16723 = BgL_lz00_32187;
												goto BgL_recz00_16722;
											}
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_14014) (BgL_bodyz00_14014,
							BgL_sz00_14015, BEOA);
					}
				}
			}
		}

	}



/* &comp-ev_let*1420 */
	obj_t BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00(obj_t
		BgL_envz00_14016, obj_t BgL_ez00_14017, obj_t BgL_stkz00_14018)
	{
		{	/* Eval/evaluate_comp.scm 481 */
			{	/* Eval/evaluate_comp.scm 483 */
				long BgL_siza7eza7_16730;
				obj_t BgL_nstkz00_16731;

				BgL_siza7eza7_16730 = bgl_list_length(BgL_stkz00_14018);
				{	/* Eval/evaluate_comp.scm 483 */
					obj_t BgL_arg3277z00_16732;

					BgL_arg3277z00_16732 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letza2za2_bglt) BgL_ez00_14017))))->BgL_varsz00);
					BgL_nstkz00_16731 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_14018,
						BgL_arg3277z00_16732);
				}
				{	/* Eval/evaluate_comp.scm 484 */
					obj_t BgL_valsz00_16733;
					obj_t BgL_bodyz00_16734;

					{	/* Eval/evaluate_comp.scm 484 */
						obj_t BgL_l1313z00_16735;

						BgL_l1313z00_16735 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_14017))))->BgL_valsz00);
						if (NULLP(BgL_l1313z00_16735))
							{	/* Eval/evaluate_comp.scm 484 */
								BgL_valsz00_16733 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 484 */
								obj_t BgL_head1315z00_16736;

								BgL_head1315z00_16736 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								{
									obj_t BgL_l1313z00_16738;
									obj_t BgL_tail1316z00_16739;

									BgL_l1313z00_16738 = BgL_l1313z00_16735;
									BgL_tail1316z00_16739 = BgL_head1315z00_16736;
								BgL_zc3z04anonymousza33272ze3z87_16737:
									if (NULLP(BgL_l1313z00_16738))
										{	/* Eval/evaluate_comp.scm 484 */
											BgL_valsz00_16733 = CDR(BgL_head1315z00_16736);
										}
									else
										{	/* Eval/evaluate_comp.scm 484 */
											obj_t BgL_newtail1317z00_16740;

											{	/* Eval/evaluate_comp.scm 484 */
												obj_t BgL_arg3275z00_16741;

												{	/* Eval/evaluate_comp.scm 484 */
													obj_t BgL_vz00_16742;

													BgL_vz00_16742 = CAR(((obj_t) BgL_l1313z00_16738));
													BgL_arg3275z00_16741 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_16742),
														BgL_nstkz00_16731);
												}
												BgL_newtail1317z00_16740 =
													MAKE_YOUNG_PAIR(BgL_arg3275z00_16741, BNIL);
											}
											SET_CDR(BgL_tail1316z00_16739, BgL_newtail1317z00_16740);
											{	/* Eval/evaluate_comp.scm 484 */
												obj_t BgL_arg3274z00_16743;

												BgL_arg3274z00_16743 =
													CDR(((obj_t) BgL_l1313z00_16738));
												{
													obj_t BgL_tail1316z00_32216;
													obj_t BgL_l1313z00_32215;

													BgL_l1313z00_32215 = BgL_arg3274z00_16743;
													BgL_tail1316z00_32216 = BgL_newtail1317z00_16740;
													BgL_tail1316z00_16739 = BgL_tail1316z00_32216;
													BgL_l1313z00_16738 = BgL_l1313z00_32215;
													goto BgL_zc3z04anonymousza33272ze3z87_16737;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 485 */
						BgL_ev_exprz00_bglt BgL_arg3276z00_16744;

						BgL_arg3276z00_16744 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_14017))))->BgL_bodyz00);
						BgL_bodyz00_16734 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3276z00_16744,
							BgL_nstkz00_16731);
					}
					{	/* Eval/evaluate_comp.scm 486 */
						obj_t BgL_zc3z04anonymousza33261ze3z87_16745;

						BgL_zc3z04anonymousza33261ze3z87_16745 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33261ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33261ze3z87_16745,
							(int) (((long) 0)), BINT(BgL_siza7eza7_16730));
						PROCEDURE_SET(BgL_zc3z04anonymousza33261ze3z87_16745,
							(int) (((long) 1)),
							((obj_t) ((BgL_ev_letza2za2_bglt) BgL_ez00_14017)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33261ze3z87_16745,
							(int) (((long) 2)), BgL_valsz00_16733);
						PROCEDURE_SET(BgL_zc3z04anonymousza33261ze3z87_16745,
							(int) (((long) 3)), BgL_bodyz00_16734);
						return BgL_zc3z04anonymousza33261ze3z87_16745;
					}
				}
			}
		}

	}



/* &<@anonymous:3261> */
	obj_t BGl_z62zc3z04anonymousza33261ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14019, obj_t BgL_sz00_14024)
	{
		{	/* Eval/evaluate_comp.scm 486 */
			{	/* Eval/evaluate_comp.scm 486 */
				long BgL_siza7eza7_14020;
				BgL_ev_letza2za2_bglt BgL_i1112z00_14021;
				obj_t BgL_valsz00_14022;
				obj_t BgL_bodyz00_14023;

				BgL_siza7eza7_14020 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14019, (int) (((long) 0))));
				BgL_i1112z00_14021 =
					((BgL_ev_letza2za2_bglt)
					PROCEDURE_REF(BgL_envz00_14019, (int) (((long) 1))));
				BgL_valsz00_14022 = PROCEDURE_REF(BgL_envz00_14019, (int) (((long) 2)));
				BgL_bodyz00_14023 = PROCEDURE_REF(BgL_envz00_14019, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 486 */
					obj_t BgL_bpz00_16746;

					BgL_bpz00_16746 = VECTOR_REF(((obj_t) BgL_sz00_14024), ((long) 0));
					{	/* Eval/evaluate_comp.scm 487 */
						long BgL_g1113z00_16747;

						BgL_g1113z00_16747 =
							((long) CINT(BgL_bpz00_16746) + BgL_siza7eza7_14020);
						{
							obj_t BgL_lz00_16749;
							long BgL_iz00_16750;
							obj_t BgL_bza2za2_16751;

							BgL_lz00_16749 = BgL_valsz00_14022;
							BgL_iz00_16750 = BgL_g1113z00_16747;
							BgL_bza2za2_16751 =
								(((BgL_ev_letza2za2_bglt) COBJECT(BgL_i1112z00_14021))->
								BgL_boxesz00);
						BgL_recz00_16748:
							if (NULLP(BgL_lz00_16749))
								{	/* Eval/evaluate_comp.scm 488 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 488 */
									{	/* Eval/evaluate_comp.scm 489 */
										obj_t BgL_valz00_16752;

										{	/* Eval/evaluate_comp.scm 489 */
											obj_t BgL_fun3267z00_16753;

											BgL_fun3267z00_16753 = CAR(((obj_t) BgL_lz00_16749));
											BgL_valz00_16752 =
												PROCEDURE_ENTRY(BgL_fun3267z00_16753)
												(BgL_fun3267z00_16753, BgL_sz00_14024, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 490 */
											obj_t BgL_arg3265z00_16754;

											if (CBOOL(CAR(((obj_t) BgL_bza2za2_16751))))
												{	/* Eval/evaluate_comp.scm 202 */
													obj_t BgL_newz00_16755;

													BgL_newz00_16755 =
														create_struct(BGl_symbol4603z00zz__evaluate_compz00,
														(int) (((long) 1)));
													{	/* Eval/evaluate_comp.scm 202 */
														int BgL_tmpz00_32263;

														BgL_tmpz00_32263 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_16755, BgL_tmpz00_32263,
															BgL_valz00_16752);
													}
													BgL_arg3265z00_16754 = BgL_newz00_16755;
												}
											else
												{	/* Eval/evaluate_comp.scm 490 */
													BgL_arg3265z00_16754 = BgL_valz00_16752;
												}
											VECTOR_SET(
												((obj_t) BgL_sz00_14024), BgL_iz00_16750,
												BgL_arg3265z00_16754);
										}
									}
									{	/* Eval/evaluate_comp.scm 491 */
										obj_t BgL_arg3268z00_16756;
										long BgL_arg3269z00_16757;
										obj_t BgL_arg3270z00_16758;

										BgL_arg3268z00_16756 = CDR(((obj_t) BgL_lz00_16749));
										BgL_arg3269z00_16757 = (BgL_iz00_16750 + ((long) 1));
										BgL_arg3270z00_16758 = CDR(((obj_t) BgL_bza2za2_16751));
										{
											obj_t BgL_bza2za2_32275;
											long BgL_iz00_32274;
											obj_t BgL_lz00_32273;

											BgL_lz00_32273 = BgL_arg3268z00_16756;
											BgL_iz00_32274 = BgL_arg3269z00_16757;
											BgL_bza2za2_32275 = BgL_arg3270z00_16758;
											BgL_bza2za2_16751 = BgL_bza2za2_32275;
											BgL_iz00_16750 = BgL_iz00_32274;
											BgL_lz00_16749 = BgL_lz00_32273;
											goto BgL_recz00_16748;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_14023) (BgL_bodyz00_14023,
						BgL_sz00_14024, BEOA);
				}
			}
		}

	}



/* &comp-ev_let1418 */
	obj_t BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00(obj_t BgL_envz00_14025,
		obj_t BgL_ez00_14026, obj_t BgL_stkz00_14027)
	{
		{	/* Eval/evaluate_comp.scm 462 */
			{	/* Eval/evaluate_comp.scm 464 */
				long BgL_siza7eza7_16760;
				obj_t BgL_nstkz00_16761;

				BgL_siza7eza7_16760 = bgl_list_length(BgL_stkz00_14027);
				{	/* Eval/evaluate_comp.scm 464 */
					obj_t BgL_arg3260z00_16762;

					BgL_arg3260z00_16762 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letz00_bglt) BgL_ez00_14026))))->BgL_varsz00);
					BgL_nstkz00_16761 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_14027,
						BgL_arg3260z00_16762);
				}
				{	/* Eval/evaluate_comp.scm 465 */
					obj_t BgL_valsz00_16763;
					obj_t BgL_iboxesz00_16764;
					obj_t BgL_bodyz00_16765;

					{	/* Eval/evaluate_comp.scm 466 */
						obj_t BgL_arg3251z00_16766;

						BgL_arg3251z00_16766 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_14026))))->BgL_valsz00);
						BgL_valsz00_16763 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00
							(BgL_arg3251z00_16766, BgL_stkz00_14027);
					}
					{	/* Eval/evaluate_comp.scm 467 */
						obj_t BgL_l1308z00_16767;

						BgL_l1308z00_16767 =
							(((BgL_ev_letz00_bglt) COBJECT(
									((BgL_ev_letz00_bglt) BgL_ez00_14026)))->BgL_boxesz00);
						if (NULLP(BgL_l1308z00_16767))
							{	/* Eval/evaluate_comp.scm 467 */
								BgL_iboxesz00_16764 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 467 */
								obj_t BgL_head1310z00_16768;

								BgL_head1310z00_16768 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								{
									obj_t BgL_l1308z00_16770;
									obj_t BgL_tail1311z00_16771;

									BgL_l1308z00_16770 = BgL_l1308z00_16767;
									BgL_tail1311z00_16771 = BgL_head1310z00_16768;
								BgL_zc3z04anonymousza33253ze3z87_16769:
									if (NULLP(BgL_l1308z00_16770))
										{	/* Eval/evaluate_comp.scm 467 */
											BgL_iboxesz00_16764 = CDR(BgL_head1310z00_16768);
										}
									else
										{	/* Eval/evaluate_comp.scm 467 */
											obj_t BgL_newtail1312z00_16772;

											{	/* Eval/evaluate_comp.scm 467 */
												obj_t BgL_arg3257z00_16773;

												{	/* Eval/evaluate_comp.scm 467 */
													obj_t BgL_vz00_16774;

													BgL_vz00_16774 = CAR(((obj_t) BgL_l1308z00_16770));
													BgL_arg3257z00_16773 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16774,
														BgL_nstkz00_16761);
												}
												BgL_newtail1312z00_16772 =
													MAKE_YOUNG_PAIR(BgL_arg3257z00_16773, BNIL);
											}
											SET_CDR(BgL_tail1311z00_16771, BgL_newtail1312z00_16772);
											{	/* Eval/evaluate_comp.scm 467 */
												obj_t BgL_arg3256z00_16775;

												BgL_arg3256z00_16775 =
													CDR(((obj_t) BgL_l1308z00_16770));
												{
													obj_t BgL_tail1311z00_32306;
													obj_t BgL_l1308z00_32305;

													BgL_l1308z00_32305 = BgL_arg3256z00_16775;
													BgL_tail1311z00_32306 = BgL_newtail1312z00_16772;
													BgL_tail1311z00_16771 = BgL_tail1311z00_32306;
													BgL_l1308z00_16770 = BgL_l1308z00_32305;
													goto BgL_zc3z04anonymousza33253ze3z87_16769;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 468 */
						BgL_ev_exprz00_bglt BgL_arg3258z00_16776;

						BgL_arg3258z00_16776 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_14026))))->BgL_bodyz00);
						BgL_bodyz00_16765 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3258z00_16776,
							BgL_nstkz00_16761);
					}
					{	/* Eval/evaluate_comp.scm 469 */
						obj_t BgL_zc3z04anonymousza33230ze3z87_16777;

						BgL_zc3z04anonymousza33230ze3z87_16777 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33230ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33230ze3z87_16777,
							(int) (((long) 0)), BINT(BgL_siza7eza7_16760));
						PROCEDURE_SET(BgL_zc3z04anonymousza33230ze3z87_16777,
							(int) (((long) 1)), BgL_valsz00_16763);
						PROCEDURE_SET(BgL_zc3z04anonymousza33230ze3z87_16777,
							(int) (((long) 2)), BgL_iboxesz00_16764);
						PROCEDURE_SET(BgL_zc3z04anonymousza33230ze3z87_16777,
							(int) (((long) 3)), BgL_bodyz00_16765);
						return BgL_zc3z04anonymousza33230ze3z87_16777;
					}
				}
			}
		}

	}



/* &<@anonymous:3230> */
	obj_t BGl_z62zc3z04anonymousza33230ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14028, obj_t BgL_sz00_14033)
	{
		{	/* Eval/evaluate_comp.scm 469 */
			{	/* Eval/evaluate_comp.scm 469 */
				long BgL_siza7eza7_14029;
				obj_t BgL_valsz00_14030;
				obj_t BgL_iboxesz00_14031;
				obj_t BgL_bodyz00_14032;

				BgL_siza7eza7_14029 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14028, (int) (((long) 0))));
				BgL_valsz00_14030 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14028, (int) (((long) 1))));
				BgL_iboxesz00_14031 =
					PROCEDURE_REF(BgL_envz00_14028, (int) (((long) 2)));
				BgL_bodyz00_14032 = PROCEDURE_REF(BgL_envz00_14028, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 469 */
					obj_t BgL_bpz00_16778;

					BgL_bpz00_16778 = VECTOR_REF(((obj_t) BgL_sz00_14033), ((long) 0));
					{	/* Eval/evaluate_comp.scm 470 */
						long BgL_g1111z00_16779;

						BgL_g1111z00_16779 =
							((long) CINT(BgL_bpz00_16778) + BgL_siza7eza7_14029);
						{
							obj_t BgL_lz00_16781;
							long BgL_iz00_16782;

							BgL_lz00_16781 = BgL_valsz00_14030;
							BgL_iz00_16782 = BgL_g1111z00_16779;
						BgL_recz00_16780:
							if (NULLP(BgL_lz00_16781))
								{	/* Eval/evaluate_comp.scm 471 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 471 */
									{	/* Eval/evaluate_comp.scm 472 */
										obj_t BgL_arg3238z00_16783;

										{	/* Eval/evaluate_comp.scm 472 */
											obj_t BgL_fun3239z00_16784;

											BgL_fun3239z00_16784 = CAR(((obj_t) BgL_lz00_16781));
											BgL_arg3238z00_16783 =
												PROCEDURE_ENTRY(BgL_fun3239z00_16784)
												(BgL_fun3239z00_16784, BgL_sz00_14033, BEOA);
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_14033), BgL_iz00_16782,
											BgL_arg3238z00_16783);
									}
									{	/* Eval/evaluate_comp.scm 473 */
										obj_t BgL_arg3243z00_16785;
										long BgL_arg3244z00_16786;

										BgL_arg3243z00_16785 = CDR(((obj_t) BgL_lz00_16781));
										BgL_arg3244z00_16786 = (BgL_iz00_16782 + ((long) 1));
										{
											long BgL_iz00_32351;
											obj_t BgL_lz00_32350;

											BgL_lz00_32350 = BgL_arg3243z00_16785;
											BgL_iz00_32351 = BgL_arg3244z00_16786;
											BgL_iz00_16782 = BgL_iz00_32351;
											BgL_lz00_16781 = BgL_lz00_32350;
											goto BgL_recz00_16780;
										}
									}
								}
						}
					}
					{
						obj_t BgL_lz00_16788;

						BgL_lz00_16788 = BgL_iboxesz00_14031;
					BgL_recz00_16787:
						if (NULLP(BgL_lz00_16788))
							{	/* Eval/evaluate_comp.scm 475 */
								((bool_t) 0);
							}
						else
							{	/* Eval/evaluate_comp.scm 475 */
								{	/* Eval/evaluate_comp.scm 476 */
									long BgL_iz00_16789;

									BgL_iz00_16789 =
										(
										(long) CINT(BgL_bpz00_16778) +
										(long) CINT(CAR(((obj_t) BgL_lz00_16788))));
									{	/* Eval/evaluate_comp.scm 477 */
										obj_t BgL_arg3247z00_16790;

										{	/* Eval/evaluate_comp.scm 477 */
											obj_t BgL_arg3248z00_16791;

											BgL_arg3248z00_16791 =
												VECTOR_REF(((obj_t) BgL_sz00_14033), BgL_iz00_16789);
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_16792;

												BgL_newz00_16792 =
													create_struct(BGl_symbol4603z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_32363;

													BgL_tmpz00_32363 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_16792, BgL_tmpz00_32363,
														BgL_arg3248z00_16791);
												}
												BgL_arg3247z00_16790 = BgL_newz00_16792;
										}}
										VECTOR_SET(
											((obj_t) BgL_sz00_14033), BgL_iz00_16789,
											BgL_arg3247z00_16790);
								}}
								{	/* Eval/evaluate_comp.scm 478 */
									obj_t BgL_arg3250z00_16793;

									BgL_arg3250z00_16793 = CDR(((obj_t) BgL_lz00_16788));
									{
										obj_t BgL_lz00_32370;

										BgL_lz00_32370 = BgL_arg3250z00_16793;
										BgL_lz00_16788 = BgL_lz00_32370;
										goto BgL_recz00_16787;
									}
								}
							}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_14032) (BgL_bodyz00_14032,
						BgL_sz00_14033, BEOA);
				}
			}
		}

	}



/* &comp-ev_prog21416 */
	obj_t BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00(obj_t
		BgL_envz00_14034, obj_t BgL_ez00_14035, obj_t BgL_stkz00_14036)
	{
		{	/* Eval/evaluate_comp.scm 456 */
			{	/* Eval/evaluate_comp.scm 458 */
				obj_t BgL_e1z00_16795;
				obj_t BgL_e2z00_16796;

				BgL_e1z00_16795 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_prog2z00_bglt) COBJECT(
								((BgL_ev_prog2z00_bglt) BgL_ez00_14035)))->BgL_e1z00),
					BgL_stkz00_14036);
				BgL_e2z00_16796 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_prog2z00_bglt)
							COBJECT(((BgL_ev_prog2z00_bglt) BgL_ez00_14035)))->BgL_e2z00),
					BgL_stkz00_14036);
				{	/* Eval/evaluate_comp.scm 459 */
					obj_t BgL_zc3z04anonymousza33225ze3z87_16797;

					BgL_zc3z04anonymousza33225ze3z87_16797 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33225ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33225ze3z87_16797,
						(int) (((long) 0)), BgL_e1z00_16795);
					PROCEDURE_SET(BgL_zc3z04anonymousza33225ze3z87_16797,
						(int) (((long) 1)), BgL_e2z00_16796);
					return BgL_zc3z04anonymousza33225ze3z87_16797;
				}
			}
		}

	}



/* &<@anonymous:3225> */
	obj_t BGl_z62zc3z04anonymousza33225ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14037, obj_t BgL_sz00_14040)
	{
		{	/* Eval/evaluate_comp.scm 459 */
			{	/* Eval/evaluate_comp.scm 459 */
				obj_t BgL_e1z00_14038;
				obj_t BgL_e2z00_14039;

				BgL_e1z00_14038 = PROCEDURE_REF(BgL_envz00_14037, (int) (((long) 0)));
				BgL_e2z00_14039 = PROCEDURE_REF(BgL_envz00_14037, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 459 */
					obj_t BgL_bpz00_16798;

					BgL_bpz00_16798 = VECTOR_REF(((obj_t) BgL_sz00_14040), ((long) 0));
					PROCEDURE_ENTRY(BgL_e1z00_14038) (BgL_e1z00_14038, BgL_sz00_14040,
						BEOA);
					return PROCEDURE_ENTRY(BgL_e2z00_14039) (BgL_e2z00_14039,
						BgL_sz00_14040, BEOA);
				}
			}
		}

	}



/* &comp-ev_and1414 */
	obj_t BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00(obj_t BgL_envz00_14041,
		obj_t BgL_ez00_14042, obj_t BgL_stkz00_14043)
	{
		{	/* Eval/evaluate_comp.scm 446 */
			{	/* Eval/evaluate_comp.scm 448 */
				obj_t BgL_argsz00_16800;

				{	/* Eval/evaluate_comp.scm 448 */
					obj_t BgL_l1303z00_16801;

					BgL_l1303z00_16801 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_andz00_bglt) BgL_ez00_14042))))->BgL_argsz00);
					if (NULLP(BgL_l1303z00_16801))
						{	/* Eval/evaluate_comp.scm 448 */
							BgL_argsz00_16800 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 448 */
							obj_t BgL_head1305z00_16802;

							BgL_head1305z00_16802 = MAKE_YOUNG_PAIR(BNIL, BNIL);
							{
								obj_t BgL_l1303z00_16804;
								obj_t BgL_tail1306z00_16805;

								BgL_l1303z00_16804 = BgL_l1303z00_16801;
								BgL_tail1306z00_16805 = BgL_head1305z00_16802;
							BgL_zc3z04anonymousza33221ze3z87_16803:
								if (NULLP(BgL_l1303z00_16804))
									{	/* Eval/evaluate_comp.scm 448 */
										BgL_argsz00_16800 = CDR(BgL_head1305z00_16802);
									}
								else
									{	/* Eval/evaluate_comp.scm 448 */
										obj_t BgL_newtail1307z00_16806;

										{	/* Eval/evaluate_comp.scm 448 */
											obj_t BgL_arg3224z00_16807;

											{	/* Eval/evaluate_comp.scm 448 */
												obj_t BgL_ez00_16808;

												BgL_ez00_16808 = CAR(((obj_t) BgL_l1303z00_16804));
												BgL_arg3224z00_16807 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_16808),
													BgL_stkz00_14043);
											}
											BgL_newtail1307z00_16806 =
												MAKE_YOUNG_PAIR(BgL_arg3224z00_16807, BNIL);
										}
										SET_CDR(BgL_tail1306z00_16805, BgL_newtail1307z00_16806);
										{	/* Eval/evaluate_comp.scm 448 */
											obj_t BgL_arg3223z00_16809;

											BgL_arg3223z00_16809 = CDR(((obj_t) BgL_l1303z00_16804));
											{
												obj_t BgL_tail1306z00_32420;
												obj_t BgL_l1303z00_32419;

												BgL_l1303z00_32419 = BgL_arg3223z00_16809;
												BgL_tail1306z00_32420 = BgL_newtail1307z00_16806;
												BgL_tail1306z00_16805 = BgL_tail1306z00_32420;
												BgL_l1303z00_16804 = BgL_l1303z00_32419;
												goto BgL_zc3z04anonymousza33221ze3z87_16803;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 449 */
					obj_t BgL_zc3z04anonymousza33214ze3z87_16810;

					BgL_zc3z04anonymousza33214ze3z87_16810 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33214ze3z87_16810,
						(int) (((long) 0)), BgL_argsz00_16800);
					return BgL_zc3z04anonymousza33214ze3z87_16810;
				}
			}
		}

	}



/* &<@anonymous:3214> */
	obj_t BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14044, obj_t BgL_sz00_14046)
	{
		{	/* Eval/evaluate_comp.scm 449 */
			{	/* Eval/evaluate_comp.scm 449 */
				obj_t BgL_argsz00_14045;

				BgL_argsz00_14045 = PROCEDURE_REF(BgL_envz00_14044, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 449 */
					obj_t BgL_bpz00_16811;

					BgL_bpz00_16811 = VECTOR_REF(((obj_t) BgL_sz00_14046), ((long) 0));
					{
						obj_t BgL_lz00_16813;
						obj_t BgL_rz00_16814;

						BgL_lz00_16813 = BgL_argsz00_14045;
						BgL_rz00_16814 = BTRUE;
					BgL_recz00_16812:
						if (NULLP(BgL_lz00_16813))
							{	/* Eval/evaluate_comp.scm 451 */
								return BgL_rz00_16814;
							}
						else
							{	/* Eval/evaluate_comp.scm 453 */
								obj_t BgL_vz00_16815;

								{	/* Eval/evaluate_comp.scm 453 */
									obj_t BgL_fun3219z00_16816;

									BgL_fun3219z00_16816 = CAR(((obj_t) BgL_lz00_16813));
									BgL_vz00_16815 =
										PROCEDURE_ENTRY(BgL_fun3219z00_16816) (BgL_fun3219z00_16816,
										BgL_sz00_14046, BEOA);
								}
								if (CBOOL(BgL_vz00_16815))
									{	/* Eval/evaluate_comp.scm 454 */
										obj_t BgL_arg3218z00_16817;

										BgL_arg3218z00_16817 = CDR(((obj_t) BgL_lz00_16813));
										{
											obj_t BgL_rz00_32443;
											obj_t BgL_lz00_32442;

											BgL_lz00_32442 = BgL_arg3218z00_16817;
											BgL_rz00_32443 = BgL_vz00_16815;
											BgL_rz00_16814 = BgL_rz00_32443;
											BgL_lz00_16813 = BgL_lz00_32442;
											goto BgL_recz00_16812;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 454 */
										return BFALSE;
									}
							}
					}
				}
			}
		}

	}



/* &comp-ev_or1412 */
	obj_t BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00(obj_t BgL_envz00_14047,
		obj_t BgL_ez00_14048, obj_t BgL_stkz00_14049)
	{
		{	/* Eval/evaluate_comp.scm 437 */
			{	/* Eval/evaluate_comp.scm 439 */
				obj_t BgL_argsz00_16819;

				{	/* Eval/evaluate_comp.scm 439 */
					obj_t BgL_l1298z00_16820;

					BgL_l1298z00_16820 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_orz00_bglt) BgL_ez00_14048))))->BgL_argsz00);
					if (NULLP(BgL_l1298z00_16820))
						{	/* Eval/evaluate_comp.scm 439 */
							BgL_argsz00_16819 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 439 */
							obj_t BgL_head1300z00_16821;

							BgL_head1300z00_16821 = MAKE_YOUNG_PAIR(BNIL, BNIL);
							{
								obj_t BgL_l1298z00_16823;
								obj_t BgL_tail1301z00_16824;

								BgL_l1298z00_16823 = BgL_l1298z00_16820;
								BgL_tail1301z00_16824 = BgL_head1300z00_16821;
							BgL_zc3z04anonymousza33210ze3z87_16822:
								if (NULLP(BgL_l1298z00_16823))
									{	/* Eval/evaluate_comp.scm 439 */
										BgL_argsz00_16819 = CDR(BgL_head1300z00_16821);
									}
								else
									{	/* Eval/evaluate_comp.scm 439 */
										obj_t BgL_newtail1302z00_16825;

										{	/* Eval/evaluate_comp.scm 439 */
											obj_t BgL_arg3213z00_16826;

											{	/* Eval/evaluate_comp.scm 439 */
												obj_t BgL_ez00_16827;

												BgL_ez00_16827 = CAR(((obj_t) BgL_l1298z00_16823));
												BgL_arg3213z00_16826 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_16827),
													BgL_stkz00_14049);
											}
											BgL_newtail1302z00_16825 =
												MAKE_YOUNG_PAIR(BgL_arg3213z00_16826, BNIL);
										}
										SET_CDR(BgL_tail1301z00_16824, BgL_newtail1302z00_16825);
										{	/* Eval/evaluate_comp.scm 439 */
											obj_t BgL_arg3212z00_16828;

											BgL_arg3212z00_16828 = CDR(((obj_t) BgL_l1298z00_16823));
											{
												obj_t BgL_tail1301z00_32462;
												obj_t BgL_l1298z00_32461;

												BgL_l1298z00_32461 = BgL_arg3212z00_16828;
												BgL_tail1301z00_32462 = BgL_newtail1302z00_16825;
												BgL_tail1301z00_16824 = BgL_tail1301z00_32462;
												BgL_l1298z00_16823 = BgL_l1298z00_32461;
												goto BgL_zc3z04anonymousza33210ze3z87_16822;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 440 */
					obj_t BgL_zc3z04anonymousza33204ze3z87_16829;

					BgL_zc3z04anonymousza33204ze3z87_16829 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33204ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33204ze3z87_16829,
						(int) (((long) 0)), BgL_argsz00_16819);
					return BgL_zc3z04anonymousza33204ze3z87_16829;
				}
			}
		}

	}



/* &<@anonymous:3204> */
	obj_t BGl_z62zc3z04anonymousza33204ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14050, obj_t BgL_sz00_14052)
	{
		{	/* Eval/evaluate_comp.scm 440 */
			{	/* Eval/evaluate_comp.scm 440 */
				obj_t BgL_argsz00_14051;

				BgL_argsz00_14051 = PROCEDURE_REF(BgL_envz00_14050, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 440 */
					obj_t BgL_bpz00_16830;

					BgL_bpz00_16830 = VECTOR_REF(((obj_t) BgL_sz00_14052), ((long) 0));
					{
						obj_t BgL_lz00_16832;

						BgL_lz00_16832 = BgL_argsz00_14051;
					BgL_recz00_16831:
						if (NULLP(BgL_lz00_16832))
							{	/* Eval/evaluate_comp.scm 442 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 444 */
								obj_t BgL__ortest_1106z00_16833;

								{	/* Eval/evaluate_comp.scm 444 */
									obj_t BgL_fun3208z00_16834;

									BgL_fun3208z00_16834 = CAR(((obj_t) BgL_lz00_16832));
									BgL__ortest_1106z00_16833 =
										PROCEDURE_ENTRY(BgL_fun3208z00_16834) (BgL_fun3208z00_16834,
										BgL_sz00_14052, BEOA);
								}
								if (CBOOL(BgL__ortest_1106z00_16833))
									{	/* Eval/evaluate_comp.scm 444 */
										return BgL__ortest_1106z00_16833;
									}
								else
									{	/* Eval/evaluate_comp.scm 444 */
										obj_t BgL_arg3207z00_16835;

										BgL_arg3207z00_16835 = CDR(((obj_t) BgL_lz00_16832));
										{
											obj_t BgL_lz00_32484;

											BgL_lz00_32484 = BgL_arg3207z00_16835;
											BgL_lz00_16832 = BgL_lz00_32484;
											goto BgL_recz00_16831;
										}
									}
							}
					}
				}
			}
		}

	}



/* &comp-ev_if1410 */
	obj_t BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00(obj_t BgL_envz00_14053,
		obj_t BgL_ez00_14054, obj_t BgL_stkz00_14055)
	{
		{	/* Eval/evaluate_comp.scm 431 */
			{	/* Eval/evaluate_comp.scm 433 */
				obj_t BgL_pz00_16837;
				obj_t BgL_tz00_16838;
				obj_t BgL_ez00_16839;

				BgL_pz00_16837 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_ifz00_bglt) COBJECT(
								((BgL_ev_ifz00_bglt) BgL_ez00_14054)))->BgL_pz00),
					BgL_stkz00_14055);
				BgL_tz00_16838 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_14054)))->BgL_tz00),
					BgL_stkz00_14055);
				BgL_ez00_16839 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_14054)))->BgL_ez00),
					BgL_stkz00_14055);
				{	/* Eval/evaluate_comp.scm 434 */
					obj_t BgL_zc3z04anonymousza33192ze3z87_16840;

					BgL_zc3z04anonymousza33192ze3z87_16840 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33192ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 3)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33192ze3z87_16840,
						(int) (((long) 0)), BgL_ez00_16839);
					PROCEDURE_SET(BgL_zc3z04anonymousza33192ze3z87_16840,
						(int) (((long) 1)), BgL_tz00_16838);
					PROCEDURE_SET(BgL_zc3z04anonymousza33192ze3z87_16840,
						(int) (((long) 2)), BgL_pz00_16837);
					return BgL_zc3z04anonymousza33192ze3z87_16840;
				}
			}
		}

	}



/* &<@anonymous:3192> */
	obj_t BGl_z62zc3z04anonymousza33192ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14056, obj_t BgL_sz00_14060)
	{
		{	/* Eval/evaluate_comp.scm 434 */
			{	/* Eval/evaluate_comp.scm 434 */
				obj_t BgL_ez00_14057;
				obj_t BgL_tz00_14058;
				obj_t BgL_pz00_14059;

				BgL_ez00_14057 = PROCEDURE_REF(BgL_envz00_14056, (int) (((long) 0)));
				BgL_tz00_14058 = PROCEDURE_REF(BgL_envz00_14056, (int) (((long) 1)));
				BgL_pz00_14059 = PROCEDURE_REF(BgL_envz00_14056, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 434 */
					obj_t BgL_bpz00_16841;

					BgL_bpz00_16841 = VECTOR_REF(((obj_t) BgL_sz00_14060), ((long) 0));
					if (CBOOL(PROCEDURE_ENTRY(BgL_pz00_14059) (BgL_pz00_14059,
								BgL_sz00_14060, BEOA)))
						{	/* Eval/evaluate_comp.scm 435 */
							return
								PROCEDURE_ENTRY(BgL_tz00_14058) (BgL_tz00_14058, BgL_sz00_14060,
								BEOA);
						}
					else
						{	/* Eval/evaluate_comp.scm 435 */
							return
								PROCEDURE_ENTRY(BgL_ez00_14057) (BgL_ez00_14057, BgL_sz00_14060,
								BEOA);
						}
				}
			}
		}

	}



/* &comp-ev_litt1408 */
	obj_t BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00(obj_t BgL_envz00_14061,
		obj_t BgL_ez00_14062, obj_t BgL_stkz00_14063)
	{
		{	/* Eval/evaluate_comp.scm 426 */
			{	/* Eval/evaluate_comp.scm 428 */
				obj_t BgL_zc3z04anonymousza33191ze3z87_16843;

				BgL_zc3z04anonymousza33191ze3z87_16843 =
					MAKE_FX_PROCEDURE
					(BGl_z62zc3z04anonymousza33191ze3ze5zz__evaluate_compz00,
					(int) (((long) 1)), (int) (((long) 1)));
				PROCEDURE_SET(BgL_zc3z04anonymousza33191ze3z87_16843,
					(int) (((long) 0)), ((obj_t) ((BgL_ev_littz00_bglt) BgL_ez00_14062)));
				return BgL_zc3z04anonymousza33191ze3z87_16843;
			}
		}

	}



/* &<@anonymous:3191> */
	obj_t BGl_z62zc3z04anonymousza33191ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14064, obj_t BgL_sz00_14066)
	{
		{	/* Eval/evaluate_comp.scm 428 */
			{	/* Eval/evaluate_comp.scm 428 */
				BgL_ev_littz00_bglt BgL_i1103z00_14065;

				BgL_i1103z00_14065 =
					((BgL_ev_littz00_bglt)
					PROCEDURE_REF(BgL_envz00_14064, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 428 */
					obj_t BgL_bpz00_16844;

					BgL_bpz00_16844 = VECTOR_REF(((obj_t) BgL_sz00_14066), ((long) 0));
					return
						(((BgL_ev_littz00_bglt) COBJECT(BgL_i1103z00_14065))->BgL_valuez00);
				}
			}
		}

	}



/* &comp-ev_defglobal1406 */
	obj_t BGl_z62compzd2ev_defglobal1406zb0zz__evaluate_compz00(obj_t
		BgL_envz00_14067, obj_t BgL_ez00_14068, obj_t BgL_stkz00_14069)
	{
		{	/* Eval/evaluate_comp.scm 395 */
			{	/* Eval/evaluate_comp.scm 397 */
				obj_t BgL_ez00_16846;

				{	/* Eval/evaluate_comp.scm 397 */
					BgL_ev_exprz00_bglt BgL_arg3190z00_16847;

					BgL_arg3190z00_16847 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_defglobalz00_bglt) BgL_ez00_14068))))->BgL_ez00);
					BgL_ez00_16846 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3190z00_16847,
						BgL_stkz00_14069);
				}
				{	/* Eval/evaluate_comp.scm 398 */
					obj_t BgL_zc3z04anonymousza33152ze3z87_16848;

					BgL_zc3z04anonymousza33152ze3z87_16848 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33152ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33152ze3z87_16848,
						(int) (((long) 0)),
						((obj_t) ((BgL_ev_defglobalz00_bglt) BgL_ez00_14068)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33152ze3z87_16848,
						(int) (((long) 1)), BgL_ez00_16846);
					return BgL_zc3z04anonymousza33152ze3z87_16848;
				}
			}
		}

	}



/* &<@anonymous:3152> */
	obj_t BGl_z62zc3z04anonymousza33152ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14070, obj_t BgL_sz00_14073)
	{
		{	/* Eval/evaluate_comp.scm 398 */
			{	/* Eval/evaluate_comp.scm 398 */
				BgL_ev_defglobalz00_bglt BgL_i1100z00_14071;
				obj_t BgL_ez00_14072;

				BgL_i1100z00_14071 =
					((BgL_ev_defglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_14070, (int) (((long) 0))));
				BgL_ez00_14072 = PROCEDURE_REF(BgL_envz00_14070, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 398 */
					obj_t BgL_bpz00_16849;

					BgL_bpz00_16849 = VECTOR_REF(((obj_t) BgL_sz00_14073), ((long) 0));
					{	/* Eval/evaluate_comp.scm 399 */
						obj_t BgL_gz00_16850;

						{	/* Eval/evaluate_comp.scm 399 */
							obj_t BgL_arg3188z00_16851;
							obj_t BgL_arg3189z00_16852;

							BgL_arg3188z00_16851 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(
										((BgL_ev_setglobalz00_bglt) BgL_i1100z00_14071)))->
								BgL_modz00);
							BgL_arg3189z00_16852 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
											BgL_i1100z00_14071)))->BgL_namez00);
							BgL_gz00_16850 =
								BGl_evmodulezd2findzd2globalz00zz__evmodulez00
								(BgL_arg3188z00_16851, BgL_arg3189z00_16852);
						}
						if (CBOOL(BgL_gz00_16850))
							{	/* Eval/evaluate_comp.scm 401 */
								{

									{	/* Eval/evaluate_comp.scm 403 */
										int BgL_aux1102z00_16856;

										{	/* Eval/evaluate_comp.scm 403 */
											int BgL_res4461z00_16857;

											BgL_res4461z00_16857 =
												CINT(VECTOR_REF(((obj_t) BgL_gz00_16850), ((long) 0)));
											BgL_aux1102z00_16856 = BgL_res4461z00_16857;
										}
										switch ((long) (BgL_aux1102z00_16856))
											{
											case ((long) 0):

												{	/* Eval/evaluate_comp.scm 405 */
													obj_t BgL_arg3154z00_16858;
													obj_t BgL_arg3155z00_16859;

													BgL_arg3154z00_16858 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_14071)))->BgL_locz00);
													BgL_arg3155z00_16859 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_14071)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3154z00_16858,
														BGl_string4714z00zz__evaluate_compz00,
														BGl_string4715z00zz__evaluate_compz00,
														BgL_arg3155z00_16859);
												} break;
											case ((long) 1):

												{	/* Eval/evaluate_comp.scm 407 */
													obj_t BgL_arg3156z00_16860;
													obj_t BgL_arg3158z00_16861;

													BgL_arg3156z00_16860 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_14071)))->BgL_locz00);
													BgL_arg3158z00_16861 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_14071)))->BgL_namez00);
													{	/* Eval/evaluate_comp.scm 407 */
														obj_t BgL_list3159z00_16862;

														{	/* Eval/evaluate_comp.scm 407 */
															obj_t BgL_arg3162z00_16863;

															{	/* Eval/evaluate_comp.scm 407 */
																obj_t BgL_arg3168z00_16864;

																BgL_arg3168z00_16864 =
																	MAKE_YOUNG_PAIR(BgL_arg3158z00_16861, BNIL);
																BgL_arg3162z00_16863 =
																	MAKE_YOUNG_PAIR
																	(BGl_string4716z00zz__evaluate_compz00,
																	BgL_arg3168z00_16864);
															}
															BgL_list3159z00_16862 =
																MAKE_YOUNG_PAIR
																(BGl_string4593z00zz__evaluate_compz00,
																BgL_arg3162z00_16863);
														}
														BGl_evwarningz00zz__everrorz00(BgL_arg3156z00_16860,
															BgL_list3159z00_16862);
												}}
												{	/* Eval/evaluate_comp.scm 409 */
													obj_t BgL_arg3171z00_16865;
													obj_t BgL_arg3172z00_16866;

													BgL_arg3171z00_16865 =
														VECTOR_REF(((obj_t) BgL_gz00_16850), ((long) 2));
													BgL_arg3172z00_16866 =
														PROCEDURE_ENTRY(BgL_ez00_14072) (BgL_ez00_14072,
														BgL_sz00_14073, BEOA);
													__EVMEANING_ADDRESS_SET(BgL_arg3171z00_16865,
														BgL_arg3172z00_16866);
												} break;
											case ((long) 2):

												{	/* Eval/evaluate_comp.scm 411 */
													obj_t BgL_arg3174z00_16867;

													BgL_arg3174z00_16867 =
														PROCEDURE_ENTRY(BgL_ez00_14072) (BgL_ez00_14072,
														BgL_sz00_14073, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_16850), ((long) 2),
														BgL_arg3174z00_16867);
												} break;
											case ((long) 3):

												{	/* Eval/evaluate_comp.scm 413 */
													obj_t BgL_arg3175z00_16868;

													BgL_arg3175z00_16868 =
														PROCEDURE_ENTRY(BgL_ez00_14072) (BgL_ez00_14072,
														BgL_sz00_14073, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_16850), ((long) 2),
														BgL_arg3175z00_16868);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_16850), ((long) 0),
													BINT(((long) 2)));
												break;
											case ((long) 4):

												{	/* Eval/evaluate_comp.scm 416 */
													obj_t BgL_arg3176z00_16869;

													BgL_arg3176z00_16869 =
														PROCEDURE_ENTRY(BgL_ez00_14072) (BgL_ez00_14072,
														BgL_sz00_14073, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_16850), ((long) 2),
														BgL_arg3176z00_16869);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_16850), ((long) 0),
													BINT(((long) 5)));
												break;
											default:
												{	/* Eval/evaluate_comp.scm 419 */
													obj_t BgL_arg3177z00_16854;
													obj_t BgL_arg3178z00_16855;

													BgL_arg3177z00_16854 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_14071)))->BgL_locz00);
													BgL_arg3178z00_16855 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_14071)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3177z00_16854,
														BGl_string4714z00zz__evaluate_compz00,
														BGl_string4715z00zz__evaluate_compz00,
														BgL_arg3178z00_16855);
												}
											}
									}
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1100z00_14071)))->
									BgL_namez00);
							}
						else
							{	/* Eval/evaluate_comp.scm 421 */
								obj_t BgL_gz00_16870;

								{	/* Eval/evaluate_comp.scm 421 */
									obj_t BgL_arg3184z00_16871;
									obj_t BgL_arg3185z00_16872;
									obj_t BgL_arg3186z00_16873;

									BgL_arg3184z00_16871 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1100z00_14071)))->
										BgL_namez00);
									BgL_arg3185z00_16872 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_14071)))->BgL_modz00);
									BgL_arg3186z00_16873 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_14071)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 421 */
										obj_t BgL_v1376z00_16874;

										BgL_v1376z00_16874 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_16874, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_16874, ((long) 1),
											BgL_arg3184z00_16871);
										VECTOR_SET(BgL_v1376z00_16874, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_16874, ((long) 3),
											BgL_arg3185z00_16872);
										VECTOR_SET(BgL_v1376z00_16874, ((long) 4),
											BgL_arg3186z00_16873);
										BgL_gz00_16870 = BgL_v1376z00_16874;
								}}
								{	/* Eval/evaluate_comp.scm 422 */
									obj_t BgL_arg3179z00_16875;

									BgL_arg3179z00_16875 =
										PROCEDURE_ENTRY(BgL_ez00_14072) (BgL_ez00_14072,
										BgL_sz00_14073, BEOA);
									VECTOR_SET(BgL_gz00_16870, ((long) 2), BgL_arg3179z00_16875);
								}
								{	/* Eval/evaluate_comp.scm 423 */
									obj_t BgL_arg3180z00_16876;
									obj_t BgL_arg3181z00_16877;
									obj_t BgL_arg3183z00_16878;

									BgL_arg3180z00_16876 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1100z00_14071)))->
										BgL_modz00);
									BgL_arg3181z00_16877 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_14071)))->BgL_namez00);
									BgL_arg3183z00_16878 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_14071)))->BgL_locz00);
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00
										(BgL_arg3180z00_16876, BgL_arg3181z00_16877, BgL_gz00_16870,
										BgL_arg3183z00_16878);
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1100z00_14071)))->
									BgL_namez00);
							}
					}
				}
			}
		}

	}



/* &comp-ev_setglobal1404 */
	obj_t BGl_z62compzd2ev_setglobal1404zb0zz__evaluate_compz00(obj_t
		BgL_envz00_14074, obj_t BgL_ez00_14075, obj_t BgL_stkz00_14076)
	{
		{	/* Eval/evaluate_comp.scm 372 */
			{	/* Eval/evaluate_comp.scm 374 */
				obj_t BgL_gz00_16880;
				obj_t BgL_ez00_16881;

				BgL_gz00_16880 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->BgL_modz00),
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->BgL_namez00));
				{	/* Eval/evaluate_comp.scm 374 */
					BgL_ev_exprz00_bglt BgL_arg3151z00_16882;

					BgL_arg3151z00_16882 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setglobalz00_bglt) BgL_ez00_14075))))->BgL_ez00);
					BgL_ez00_16881 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3151z00_16882,
						BgL_stkz00_14076);
				}
				if (CBOOL(BgL_gz00_16880))
					{

						{	/* Eval/evaluate_comp.scm 376 */
							int BgL_aux1099z00_16885;

							{	/* Eval/evaluate_comp.scm 376 */
								int BgL_res4460z00_16886;

								BgL_res4460z00_16886 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_16880), ((long) 0)));
								BgL_aux1099z00_16885 = BgL_res4460z00_16886;
							}
							switch ((long) (BgL_aux1099z00_16885))
								{
								case ((long) 1):

									{	/* Eval/evaluate_comp.scm 378 */
										obj_t BgL_zc3z04anonymousza33117ze3z87_16887;

										BgL_zc3z04anonymousza33117ze3z87_16887 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza33117ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza33117ze3z87_16887,
											(int) (((long) 0)), BgL_gz00_16880);
										PROCEDURE_SET(BgL_zc3z04anonymousza33117ze3z87_16887,
											(int) (((long) 1)), BgL_ez00_16881);
										return BgL_zc3z04anonymousza33117ze3z87_16887;
									}
									break;
								case ((long) 0):
								case ((long) 4):
								case ((long) 5):

									return
										BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(
													((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
											BgL_locz00), BGl_string4714z00zz__evaluate_compz00,
										BGl_string4715z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt)
												COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
											BgL_namez00));
									break;
								default:
									{	/* Eval/evaluate_comp.scm 383 */
										obj_t BgL_zc3z04anonymousza33122ze3z87_16884;

										BgL_zc3z04anonymousza33122ze3z87_16884 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza33122ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza33122ze3z87_16884,
											(int) (((long) 0)), BgL_ez00_16881);
										PROCEDURE_SET(BgL_zc3z04anonymousza33122ze3z87_16884,
											(int) (((long) 1)), BgL_gz00_16880);
										return BgL_zc3z04anonymousza33122ze3z87_16884;
									}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 384 */
						obj_t BgL_slotz00_16888;

						BgL_slotz00_16888 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 386 */
								obj_t BgL_gz00_16889;

								{	/* Eval/evaluate_comp.scm 386 */
									obj_t BgL_arg3132z00_16890;
									obj_t BgL_arg3137z00_16891;
									obj_t BgL_arg3140z00_16892;

									BgL_arg3132z00_16890 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
										BgL_namez00);
									BgL_arg3137z00_16891 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
										BgL_modz00);
									BgL_arg3140z00_16892 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
										BgL_locz00);
									{	/* Eval/evaluate_comp.scm 386 */
										obj_t BgL_v1376z00_16893;

										BgL_v1376z00_16893 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_16893, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_16893, ((long) 1),
											BgL_arg3132z00_16890);
										VECTOR_SET(BgL_v1376z00_16893, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_16893, ((long) 3),
											BgL_arg3137z00_16891);
										VECTOR_SET(BgL_v1376z00_16893, ((long) 4),
											BgL_arg3140z00_16892);
										BgL_gz00_16889 = BgL_v1376z00_16893;
								}}
								VECTOR_SET(BgL_gz00_16889, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
										BgL_namez00), BgL_gz00_16889,
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)))->
										BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 385 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 389 */
							obj_t BgL_zc3z04anonymousza33142ze3z87_16894;

							BgL_zc3z04anonymousza33142ze3z87_16894 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33142ze3ze5zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33142ze3z87_16894,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_setglobalz00_bglt) BgL_ez00_14075)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33142ze3z87_16894,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_16888));
							PROCEDURE_SET(BgL_zc3z04anonymousza33142ze3z87_16894,
								(int) (((long) 2)), BgL_ez00_16881);
							return BgL_zc3z04anonymousza33142ze3z87_16894;
						}
					}
			}
		}

	}



/* &<@anonymous:3117> */
	obj_t BGl_z62zc3z04anonymousza33117ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14079, obj_t BgL_sz00_14082)
	{
		{	/* Eval/evaluate_comp.scm 378 */
			{	/* Eval/evaluate_comp.scm 378 */
				obj_t BgL_gz00_14080;
				obj_t BgL_ez00_14081;

				BgL_gz00_14080 = PROCEDURE_REF(BgL_envz00_14079, (int) (((long) 0)));
				BgL_ez00_14081 = PROCEDURE_REF(BgL_envz00_14079, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 378 */
					obj_t BgL_bpz00_16895;

					BgL_bpz00_16895 = VECTOR_REF(((obj_t) BgL_sz00_14082), ((long) 0));
					{	/* Eval/evaluate_comp.scm 379 */
						obj_t BgL_arg3118z00_16896;
						obj_t BgL_arg3119z00_16897;

						BgL_arg3118z00_16896 =
							VECTOR_REF(((obj_t) BgL_gz00_14080), ((long) 2));
						BgL_arg3119z00_16897 =
							PROCEDURE_ENTRY(BgL_ez00_14081) (BgL_ez00_14081, BgL_sz00_14082,
							BEOA);
						return __EVMEANING_ADDRESS_SET(BgL_arg3118z00_16896,
							BgL_arg3119z00_16897);
					}
				}
			}
		}

	}



/* &<@anonymous:3122> */
	obj_t BGl_z62zc3z04anonymousza33122ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14083, obj_t BgL_sz00_14086)
	{
		{	/* Eval/evaluate_comp.scm 383 */
			{	/* Eval/evaluate_comp.scm 383 */
				obj_t BgL_ez00_14084;
				obj_t BgL_gz00_14085;

				BgL_ez00_14084 = PROCEDURE_REF(BgL_envz00_14083, (int) (((long) 0)));
				BgL_gz00_14085 = PROCEDURE_REF(BgL_envz00_14083, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 383 */
					obj_t BgL_bpz00_16898;

					BgL_bpz00_16898 = VECTOR_REF(((obj_t) BgL_sz00_14086), ((long) 0));
					{	/* Eval/evaluate_comp.scm 383 */
						obj_t BgL_arg3123z00_16899;

						BgL_arg3123z00_16899 =
							PROCEDURE_ENTRY(BgL_ez00_14084) (BgL_ez00_14084, BgL_sz00_14086,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_gz00_14085), ((long) 2),
							BgL_arg3123z00_16899);
		}}}}

	}



/* &<@anonymous:3142> */
	obj_t BGl_z62zc3z04anonymousza33142ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14087, obj_t BgL_sz00_14091)
	{
		{	/* Eval/evaluate_comp.scm 389 */
			{	/* Eval/evaluate_comp.scm 389 */
				BgL_ev_setglobalz00_bglt BgL_i1097z00_14088;
				obj_t BgL_slotz00_14089;
				obj_t BgL_ez00_14090;

				BgL_i1097z00_14088 =
					((BgL_ev_setglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_14087, (int) (((long) 0))));
				BgL_slotz00_14089 = PROCEDURE_REF(BgL_envz00_14087, (int) (((long) 1)));
				BgL_ez00_14090 = PROCEDURE_REF(BgL_envz00_14087, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 389 */
					obj_t BgL_bpz00_16900;

					BgL_bpz00_16900 = VECTOR_REF(((obj_t) BgL_sz00_14091), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_14089)))
						{	/* Eval/evaluate_comp.scm 390 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 390 */
							{	/* Eval/evaluate_comp.scm 391 */
								obj_t BgL_auxz00_16901;

								BgL_auxz00_16901 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_14088))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_14088))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_14089, BgL_auxz00_16901);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_14089)))
								{	/* Eval/evaluate_comp.scm 392 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 392 */
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_14088))->
											BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
										BGl_string4717z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_14088))->
											BgL_namez00));
								}
						}
					{	/* Eval/evaluate_comp.scm 393 */
						obj_t BgL_arg3147z00_16902;

						BgL_arg3147z00_16902 =
							PROCEDURE_ENTRY(BgL_ez00_14090) (BgL_ez00_14090, BgL_sz00_14091,
							BEOA);
						{	/* Eval/evaluate_comp.scm 393 */
							obj_t BgL_evalzd2globalzd2_16903;

							BgL_evalzd2globalzd2_16903 = CELL_REF(BgL_slotz00_14089);
							return
								VECTOR_SET(BgL_evalzd2globalzd2_16903, ((long) 2),
								BgL_arg3147z00_16902);
		}}}}}

	}



/* &comp-ev_global1400 */
	obj_t BGl_z62compzd2ev_global1400zb0zz__evaluate_compz00(obj_t
		BgL_envz00_14093, obj_t BgL_varz00_14094, obj_t BgL_stkz00_14095)
	{
		{	/* Eval/evaluate_comp.scm 339 */
			{	/* Eval/evaluate_comp.scm 341 */
				obj_t BgL_gz00_16905;

				BgL_gz00_16905 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_14094)))->BgL_modz00),
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_14094)))->BgL_namez00));
				if (CBOOL(BgL_gz00_16905))
					{	/* Eval/evaluate_comp.scm 343 */
						bool_t BgL_test5609z00_32777;

						{	/* Eval/evaluate_comp.scm 343 */
							int BgL_arg3060z00_16906;

							{	/* Eval/evaluate_comp.scm 343 */
								int BgL_res4458z00_16907;

								BgL_res4458z00_16907 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_16905), ((long) 0)));
								BgL_arg3060z00_16906 = BgL_res4458z00_16907;
							}
							BgL_test5609z00_32777 =
								(BINT(BgL_arg3060z00_16906) == BINT(((long) 1)));
						}
						if (BgL_test5609z00_32777)
							{	/* Eval/evaluate_comp.scm 344 */
								obj_t BgL_zc3z04anonymousza33045ze3z87_16908;

								BgL_zc3z04anonymousza33045ze3z87_16908 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33045ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33045ze3z87_16908,
									(int) (((long) 0)), BgL_gz00_16905);
								return BgL_zc3z04anonymousza33045ze3z87_16908;
							}
						else
							{	/* Eval/evaluate_comp.scm 346 */
								obj_t BgL_zc3z04anonymousza33051ze3z87_16909;

								BgL_zc3z04anonymousza33051ze3z87_16909 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33051ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33051ze3z87_16909,
									(int) (((long) 0)), BgL_gz00_16905);
								return BgL_zc3z04anonymousza33051ze3z87_16909;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 348 */
						obj_t BgL_slotz00_16910;

						BgL_slotz00_16910 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_globalz00_bglt) COBJECT(
											((BgL_ev_globalz00_bglt) BgL_varz00_14094)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 350 */
								obj_t BgL_gz00_16911;

								{	/* Eval/evaluate_comp.scm 350 */
									obj_t BgL_arg3067z00_16912;
									obj_t BgL_arg3070z00_16913;
									obj_t BgL_arg3071z00_16914;

									BgL_arg3067z00_16912 =
										(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_14094)))->
										BgL_namez00);
									BgL_arg3070z00_16913 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_14094)))->BgL_modz00);
									BgL_arg3071z00_16914 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_14094)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 350 */
										obj_t BgL_v1376z00_16915;

										BgL_v1376z00_16915 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_16915, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_16915, ((long) 1),
											BgL_arg3067z00_16912);
										VECTOR_SET(BgL_v1376z00_16915, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_16915, ((long) 3),
											BgL_arg3070z00_16913);
										VECTOR_SET(BgL_v1376z00_16915, ((long) 4),
											BgL_arg3071z00_16914);
										BgL_gz00_16911 = BgL_v1376z00_16915;
								}}
								VECTOR_SET(BgL_gz00_16911, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_14094)))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_14094)))->BgL_namez00), BgL_gz00_16911,
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_14094)))->BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 349 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 353 */
							obj_t BgL_zc3z04anonymousza33073ze3z87_16916;

							BgL_zc3z04anonymousza33073ze3z87_16916 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33073ze3ze5zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33073ze3z87_16916,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_globalz00_bglt) BgL_varz00_14094)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33073ze3z87_16916,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_16910));
							return BgL_zc3z04anonymousza33073ze3z87_16916;
						}
					}
			}
		}

	}



/* &<@anonymous:3045> */
	obj_t BGl_z62zc3z04anonymousza33045ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14098, obj_t BgL_sz00_14100)
	{
		{	/* Eval/evaluate_comp.scm 344 */
			{	/* Eval/evaluate_comp.scm 344 */
				obj_t BgL_gz00_14099;

				BgL_gz00_14099 = PROCEDURE_REF(BgL_envz00_14098, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 344 */
					obj_t BgL_bpz00_16917;

					BgL_bpz00_16917 = VECTOR_REF(((obj_t) BgL_sz00_14100), ((long) 0));
					{	/* Eval/evaluate_comp.scm 345 */
						obj_t BgL_arg3050z00_16918;

						BgL_arg3050z00_16918 =
							VECTOR_REF(((obj_t) BgL_gz00_14099), ((long) 2));
						return __EVMEANING_ADDRESS_REF(BgL_arg3050z00_16918);
					}
				}
			}
		}

	}



/* &<@anonymous:3051> */
	obj_t BGl_z62zc3z04anonymousza33051ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14101, obj_t BgL_sz00_14103)
	{
		{	/* Eval/evaluate_comp.scm 346 */
			{	/* Eval/evaluate_comp.scm 346 */
				obj_t BgL_gz00_14102;

				BgL_gz00_14102 = PROCEDURE_REF(BgL_envz00_14101, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 346 */
					obj_t BgL_bpz00_16919;

					BgL_bpz00_16919 = VECTOR_REF(((obj_t) BgL_sz00_14103), ((long) 0));
					return VECTOR_REF(((obj_t) BgL_gz00_14102), ((long) 2));
		}}}

	}



/* &<@anonymous:3073> */
	obj_t BGl_z62zc3z04anonymousza33073ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14104, obj_t BgL_sz00_14107)
	{
		{	/* Eval/evaluate_comp.scm 353 */
			{	/* Eval/evaluate_comp.scm 353 */
				BgL_ev_globalz00_bglt BgL_i1096z00_14105;
				obj_t BgL_slotz00_14106;

				BgL_i1096z00_14105 =
					((BgL_ev_globalz00_bglt)
					PROCEDURE_REF(BgL_envz00_14104, (int) (((long) 0))));
				BgL_slotz00_14106 = PROCEDURE_REF(BgL_envz00_14104, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 353 */
					obj_t BgL_bpz00_16920;

					BgL_bpz00_16920 = VECTOR_REF(((obj_t) BgL_sz00_14107), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_14106)))
						{	/* Eval/evaluate_comp.scm 354 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 354 */
							{	/* Eval/evaluate_comp.scm 355 */
								obj_t BgL_auxz00_16921;

								BgL_auxz00_16921 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_14105))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_14105))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_14106, BgL_auxz00_16921);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_14106)))
								{	/* Eval/evaluate_comp.scm 356 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 357 */
									obj_t BgL_idz00_16922;

									if (BGl_evmodulezf3zf3zz__evmodulez00(
											(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_14105))->
												BgL_modz00)))
										{	/* Eval/evaluate_comp.scm 358 */
											obj_t BgL_arg3081z00_16923;

											{	/* Eval/evaluate_comp.scm 358 */
												obj_t BgL_arg3082z00_16924;
												obj_t BgL_arg3083z00_16925;

												BgL_arg3082z00_16924 =
													(((BgL_ev_globalz00_bglt)
														COBJECT(BgL_i1096z00_14105))->BgL_namez00);
												BgL_arg3083z00_16925 =
													MAKE_YOUNG_PAIR(BGl_evmodulezd2namezd2zz__evmodulez00(
														(((BgL_ev_globalz00_bglt)
																COBJECT(BgL_i1096z00_14105))->BgL_modz00)),
													BNIL);
												BgL_arg3081z00_16923 =
													MAKE_YOUNG_PAIR(BgL_arg3082z00_16924,
													BgL_arg3083z00_16925);
											}
											BgL_idz00_16922 =
												MAKE_YOUNG_PAIR(BGl_symbol4718z00zz__evaluate_compz00,
												BgL_arg3081z00_16923);
										}
									else
										{	/* Eval/evaluate_comp.scm 357 */
											BgL_idz00_16922 =
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_14105))->
												BgL_namez00);
										}
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_14105))->
											BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
										BGl_string4717z00zz__evaluate_compz00, BgL_idz00_16922);
								}
						}
					{	/* Eval/evaluate_comp.scm 361 */
						obj_t BgL_vz00_16926;

						{	/* Eval/evaluate_comp.scm 361 */
							obj_t BgL_evalzd2globalzd2_16927;

							BgL_evalzd2globalzd2_16927 = CELL_REF(BgL_slotz00_14106);
							BgL_vz00_16926 =
								VECTOR_REF(BgL_evalzd2globalzd2_16927, ((long) 2));
						}
						if ((BgL_vz00_16926 == BUNSPEC))
							{	/* Eval/evaluate_comp.scm 363 */
								int BgL_tz00_16928;

								{	/* Eval/evaluate_comp.scm 363 */
									int BgL_res4459z00_16929;

									{	/* Eval/evaluate_comp.scm 363 */
										obj_t BgL_evalzd2globalzd2_16930;

										BgL_evalzd2globalzd2_16930 = CELL_REF(BgL_slotz00_14106);
										BgL_res4459z00_16929 =
											CINT(VECTOR_REF(BgL_evalzd2globalzd2_16930, ((long) 0)));
									}
									BgL_tz00_16928 = BgL_res4459z00_16929;
								}
								{	/* Eval/evaluate_comp.scm 364 */
									bool_t BgL_test5615z00_32874;

									if (((long) (BgL_tz00_16928) == ((long) 3)))
										{	/* Eval/evaluate_comp.scm 364 */
											BgL_test5615z00_32874 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 364 */
											BgL_test5615z00_32874 =
												((long) (BgL_tz00_16928) == ((long) 4));
										}
									if (BgL_test5615z00_32874)
										{	/* Eval/evaluate_comp.scm 365 */
											obj_t BgL_idz00_16931;

											if (BGl_evmodulezf3zf3zz__evmodulez00(
													(((BgL_ev_globalz00_bglt)
															COBJECT(BgL_i1096z00_14105))->BgL_modz00)))
												{	/* Eval/evaluate_comp.scm 366 */
													obj_t BgL_arg3096z00_16932;

													{	/* Eval/evaluate_comp.scm 366 */
														obj_t BgL_arg3100z00_16933;
														obj_t BgL_arg3108z00_16934;

														BgL_arg3100z00_16933 =
															(((BgL_ev_globalz00_bglt)
																COBJECT(BgL_i1096z00_14105))->BgL_namez00);
														BgL_arg3108z00_16934 =
															MAKE_YOUNG_PAIR
															(BGl_evmodulezd2namezd2zz__evmodulez00(((
																		(BgL_ev_globalz00_bglt)
																		COBJECT(BgL_i1096z00_14105))->BgL_modz00)),
															BNIL);
														BgL_arg3096z00_16932 =
															MAKE_YOUNG_PAIR(BgL_arg3100z00_16933,
															BgL_arg3108z00_16934);
													}
													BgL_idz00_16931 =
														MAKE_YOUNG_PAIR
														(BGl_symbol4718z00zz__evaluate_compz00,
														BgL_arg3096z00_16932);
												}
											else
												{	/* Eval/evaluate_comp.scm 365 */
													BgL_idz00_16931 =
														(((BgL_ev_globalz00_bglt)
															COBJECT(BgL_i1096z00_14105))->BgL_namez00);
												}
											return
												BGl_everrorz00zz__everrorz00(
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_14105))->
													BgL_locz00), BGl_string4593z00zz__evaluate_compz00,
												BGl_string4720z00zz__evaluate_compz00, BgL_idz00_16931);
										}
									else
										{	/* Eval/evaluate_comp.scm 364 */
											return BgL_vz00_16926;
										}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 362 */
								return BgL_vz00_16926;
							}
					}
				}
			}
		}

	}



/* &comp-ev_setlocal1398 */
	obj_t BGl_z62compzd2ev_setlocal1398zb0zz__evaluate_compz00(obj_t
		BgL_envz00_14109, obj_t BgL_ez00_14110, obj_t BgL_stkz00_14111)
	{
		{	/* Eval/evaluate_comp.scm 321 */
			{	/* Eval/evaluate_comp.scm 323 */
				obj_t BgL_iz00_16936;
				obj_t BgL_ez00_16937;

				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_varz00_bglt BgL_arg3041z00_16938;

					BgL_arg3041z00_16938 =
						(((BgL_ev_setlocalz00_bglt) COBJECT(
								((BgL_ev_setlocalz00_bglt) BgL_ez00_14110)))->BgL_vz00);
					BgL_iz00_16936 =
						BGl__indexz00zz__evaluate_compz00(
						((obj_t) BgL_arg3041z00_16938), BgL_stkz00_14111);
				}
				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_exprz00_bglt BgL_arg3042z00_16939;

					BgL_arg3042z00_16939 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setlocalz00_bglt) BgL_ez00_14110))))->BgL_ez00);
					BgL_ez00_16937 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3042z00_16939,
						BgL_stkz00_14111);
				}
				if (CBOOL(
						(((BgL_ev_varz00_bglt) COBJECT(
									(((BgL_ev_setlocalz00_bglt) COBJECT(
												((BgL_ev_setlocalz00_bglt) BgL_ez00_14110)))->
										BgL_vz00)))->BgL_effz00)))
					{	/* Eval/evaluate_comp.scm 326 */
						obj_t BgL_zc3z04anonymousza33033ze3z87_16940;

						BgL_zc3z04anonymousza33033ze3z87_16940 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33033ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33033ze3z87_16940,
							(int) (((long) 0)), BgL_iz00_16936);
						PROCEDURE_SET(BgL_zc3z04anonymousza33033ze3z87_16940,
							(int) (((long) 1)), BgL_ez00_16937);
						return BgL_zc3z04anonymousza33033ze3z87_16940;
					}
				else
					{	/* Eval/evaluate_comp.scm 328 */
						obj_t BgL_zc3z04anonymousza33037ze3z87_16941;

						BgL_zc3z04anonymousza33037ze3z87_16941 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33037ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33037ze3z87_16941,
							(int) (((long) 0)), BgL_iz00_16936);
						PROCEDURE_SET(BgL_zc3z04anonymousza33037ze3z87_16941,
							(int) (((long) 1)), BgL_ez00_16937);
						return BgL_zc3z04anonymousza33037ze3z87_16941;
					}
			}
		}

	}



/* &<@anonymous:3033> */
	obj_t BGl_z62zc3z04anonymousza33033ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14112, obj_t BgL_sz00_14115)
	{
		{	/* Eval/evaluate_comp.scm 326 */
			{	/* Eval/evaluate_comp.scm 326 */
				obj_t BgL_iz00_14113;
				obj_t BgL_ez00_14114;

				BgL_iz00_14113 = PROCEDURE_REF(BgL_envz00_14112, (int) (((long) 0)));
				BgL_ez00_14114 = PROCEDURE_REF(BgL_envz00_14112, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 326 */
					obj_t BgL_bpz00_16942;

					BgL_bpz00_16942 = VECTOR_REF(((obj_t) BgL_sz00_14115), ((long) 0));
					{	/* Eval/evaluate_comp.scm 327 */
						obj_t BgL_arg3034z00_16943;
						obj_t BgL_arg3035z00_16944;

						{	/* Eval/evaluate_comp.scm 327 */
							long BgL_arg3036z00_16945;

							BgL_arg3036z00_16945 =
								((long) CINT(BgL_bpz00_16942) + (long) CINT(BgL_iz00_14113));
							BgL_arg3034z00_16943 =
								VECTOR_REF(((obj_t) BgL_sz00_14115), BgL_arg3036z00_16945);
						}
						BgL_arg3035z00_16944 =
							PROCEDURE_ENTRY(BgL_ez00_14114) (BgL_ez00_14114, BgL_sz00_14115,
							BEOA);
						{	/* Eval/evaluate_comp.scm 202 */
							obj_t BgL_xz00_16946;

							{	/* Eval/evaluate_comp.scm 202 */
								int BgL_auxz00_32936;
								obj_t BgL_tmpz00_32934;

								BgL_auxz00_32936 = (int) (((long) 0));
								BgL_tmpz00_32934 = ((obj_t) BgL_arg3034z00_16943);
								BgL_xz00_16946 =
									STRUCT_SET(BgL_tmpz00_32934, BgL_auxz00_32936,
									BgL_arg3035z00_16944);
							}
							return BUNSPEC;
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3037> */
	obj_t BGl_z62zc3z04anonymousza33037ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14116, obj_t BgL_sz00_14119)
	{
		{	/* Eval/evaluate_comp.scm 328 */
			{	/* Eval/evaluate_comp.scm 328 */
				obj_t BgL_iz00_14117;
				obj_t BgL_ez00_14118;

				BgL_iz00_14117 = PROCEDURE_REF(BgL_envz00_14116, (int) (((long) 0)));
				BgL_ez00_14118 = PROCEDURE_REF(BgL_envz00_14116, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 328 */
					obj_t BgL_bpz00_16947;

					BgL_bpz00_16947 = VECTOR_REF(((obj_t) BgL_sz00_14119), ((long) 0));
					{	/* Eval/evaluate_comp.scm 329 */
						long BgL_arg3038z00_16948;
						obj_t BgL_arg3040z00_16949;

						BgL_arg3038z00_16948 =
							((long) CINT(BgL_bpz00_16947) + (long) CINT(BgL_iz00_14117));
						BgL_arg3040z00_16949 =
							PROCEDURE_ENTRY(BgL_ez00_14118) (BgL_ez00_14118, BgL_sz00_14119,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_sz00_14119), BgL_arg3038z00_16948,
							BgL_arg3040z00_16949);
					}
				}
			}
		}

	}



/* &comp-ev_var1396 */
	obj_t BGl_z62compzd2ev_var1396zb0zz__evaluate_compz00(obj_t BgL_envz00_14120,
		obj_t BgL_varz00_14121, obj_t BgL_stkz00_14122)
	{
		{	/* Eval/evaluate_comp.scm 316 */
			{	/* Eval/evaluate_comp.scm 317 */
				obj_t BgL_iz00_16951;

				BgL_iz00_16951 =
					BGl__indexz00zz__evaluate_compz00(
					((obj_t) ((BgL_ev_varz00_bglt) BgL_varz00_14121)), BgL_stkz00_14122);
				{

					if (INTEGERP(BgL_iz00_16951))
						{	/* Eval/evaluate_comp.scm 319 */
							switch ((long) CINT(BgL_iz00_16951))
								{
								case ((long) 0):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_14121)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc4721z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc4722z00zz__evaluate_compz00;
										}
									break;
								case ((long) 1):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_14121)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc4723z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc4724z00zz__evaluate_compz00;
										}
									break;
								case ((long) 2):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_14121)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc4725z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc4726z00zz__evaluate_compz00;
										}
									break;
								case ((long) 3):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_14121)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc4727z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc4728z00zz__evaluate_compz00;
										}
									break;
								default:
								BgL_case_else1091z00_16952:
									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_14121)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3z04anonymousza33027ze3z87_16953;

											BgL_zc3z04anonymousza33027ze3z87_16953 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33027ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33027ze3z87_16953,
												(int) (((long) 0)), BgL_iz00_16951);
											return BgL_zc3z04anonymousza33027ze3z87_16953;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3z04anonymousza33030ze3z87_16954;

											BgL_zc3z04anonymousza33030ze3z87_16954 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33030ze3z87_16954,
												(int) (((long) 0)), BgL_iz00_16951);
											return BgL_zc3z04anonymousza33030ze3z87_16954;
										}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 319 */
							goto BgL_case_else1091z00_16952;
						}
				}
			}
		}

	}



/* &<@anonymous:3017> */
	obj_t BGl_z62zc3z04anonymousza33017ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14123, obj_t BgL_sz00_14124)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_16955;

				BgL_bpz00_16955 = VECTOR_REF(((obj_t) BgL_sz00_14124), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg3020z00_16956;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3022z00_16957;

						BgL_arg3022z00_16957 = ((long) CINT(BgL_bpz00_16955) + ((long) 3));
						BgL_arg3020z00_16956 =
							VECTOR_REF(((obj_t) BgL_sz00_14124), BgL_arg3022z00_16957);
					}
					return STRUCT_REF(((obj_t) BgL_arg3020z00_16956), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:3023> */
	obj_t BGl_z62zc3z04anonymousza33023ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14125, obj_t BgL_sz00_14126)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_16958;

				BgL_bpz00_16958 = VECTOR_REF(((obj_t) BgL_sz00_14126), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg3025z00_16959;

					BgL_arg3025z00_16959 = ((long) CINT(BgL_bpz00_16958) + ((long) 3));
					return VECTOR_REF(((obj_t) BgL_sz00_14126), BgL_arg3025z00_16959);
				}
			}
		}

	}



/* &<@anonymous:3004> */
	obj_t BGl_z62zc3z04anonymousza33004ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14127, obj_t BgL_sz00_14128)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_16960;

				BgL_bpz00_16960 = VECTOR_REF(((obj_t) BgL_sz00_14128), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg3009z00_16961;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3010z00_16962;

						BgL_arg3010z00_16962 = ((long) CINT(BgL_bpz00_16960) + ((long) 2));
						BgL_arg3009z00_16961 =
							VECTOR_REF(((obj_t) BgL_sz00_14128), BgL_arg3010z00_16962);
					}
					return STRUCT_REF(((obj_t) BgL_arg3009z00_16961), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:3011> */
	obj_t BGl_z62zc3z04anonymousza33011ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14129, obj_t BgL_sz00_14130)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_16963;

				BgL_bpz00_16963 = VECTOR_REF(((obj_t) BgL_sz00_14130), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg3015z00_16964;

					BgL_arg3015z00_16964 = ((long) CINT(BgL_bpz00_16963) + ((long) 2));
					return VECTOR_REF(((obj_t) BgL_sz00_14130), BgL_arg3015z00_16964);
				}
			}
		}

	}



/* &<@anonymous:2997> */
	obj_t BGl_z62zc3z04anonymousza32997ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14131, obj_t BgL_sz00_14132)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_16965;

				BgL_bpz00_16965 = VECTOR_REF(((obj_t) BgL_sz00_14132), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2998z00_16966;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2999z00_16967;

						BgL_arg2999z00_16967 = ((long) CINT(BgL_bpz00_16965) + ((long) 1));
						BgL_arg2998z00_16966 =
							VECTOR_REF(((obj_t) BgL_sz00_14132), BgL_arg2999z00_16967);
					}
					return STRUCT_REF(((obj_t) BgL_arg2998z00_16966), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:3000> */
	obj_t BGl_z62zc3z04anonymousza33000ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14133, obj_t BgL_sz00_14134)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_16968;

				BgL_bpz00_16968 = VECTOR_REF(((obj_t) BgL_sz00_14134), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg3002z00_16969;

					BgL_arg3002z00_16969 = ((long) CINT(BgL_bpz00_16968) + ((long) 1));
					return VECTOR_REF(((obj_t) BgL_sz00_14134), BgL_arg3002z00_16969);
				}
			}
		}

	}



/* &<@anonymous:2991> */
	obj_t BGl_z62zc3z04anonymousza32991ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14135, obj_t BgL_sz00_14136)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_16970;

				BgL_bpz00_16970 = VECTOR_REF(((obj_t) BgL_sz00_14136), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2992z00_16971;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2993z00_16972;

						BgL_arg2993z00_16972 = ((long) CINT(BgL_bpz00_16970) + ((long) 0));
						BgL_arg2992z00_16971 =
							VECTOR_REF(((obj_t) BgL_sz00_14136), BgL_arg2993z00_16972);
					}
					return STRUCT_REF(((obj_t) BgL_arg2992z00_16971), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:2994> */
	obj_t BGl_z62zc3z04anonymousza32994ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14137, obj_t BgL_sz00_14138)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_16973;

				BgL_bpz00_16973 = VECTOR_REF(((obj_t) BgL_sz00_14138), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2995z00_16974;

					BgL_arg2995z00_16974 = ((long) CINT(BgL_bpz00_16973) + ((long) 0));
					return VECTOR_REF(((obj_t) BgL_sz00_14138), BgL_arg2995z00_16974);
				}
			}
		}

	}



/* &<@anonymous:3027> */
	obj_t BGl_z62zc3z04anonymousza33027ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14139, obj_t BgL_sz00_14141)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_14140;

				BgL_iz00_14140 = PROCEDURE_REF(BgL_envz00_14139, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_16975;

					BgL_bpz00_16975 = VECTOR_REF(((obj_t) BgL_sz00_14141), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg3028z00_16976;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg3029z00_16977;

							BgL_arg3029z00_16977 =
								((long) CINT(BgL_bpz00_16975) + (long) CINT(BgL_iz00_14140));
							BgL_arg3028z00_16976 =
								VECTOR_REF(((obj_t) BgL_sz00_14141), BgL_arg3029z00_16977);
						}
						return
							STRUCT_REF(((obj_t) BgL_arg3028z00_16976), (int) (((long) 0)));
		}}}}

	}



/* &<@anonymous:3030> */
	obj_t BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14142, obj_t BgL_sz00_14144)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_14143;

				BgL_iz00_14143 = PROCEDURE_REF(BgL_envz00_14142, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_16978;

					BgL_bpz00_16978 = VECTOR_REF(((obj_t) BgL_sz00_14144), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3031z00_16979;

						BgL_arg3031z00_16979 =
							((long) CINT(BgL_bpz00_16978) + (long) CINT(BgL_iz00_14143));
						return VECTOR_REF(((obj_t) BgL_sz00_14144), BgL_arg3031z00_16979);
					}
				}
			}
		}

	}



/* &comp-ev_trap1394 */
	obj_t BGl_z62compzd2ev_trap1394zb0zz__evaluate_compz00(obj_t BgL_envz00_14145,
		obj_t BgL_ez00_14146, obj_t BgL_stkz00_14147)
	{
		{	/* Eval/evaluate_comp.scm 289 */
			{	/* Eval/evaluate_comp.scm 291 */
				obj_t BgL_ez00_16981;

				{	/* Eval/evaluate_comp.scm 291 */
					BgL_ev_exprz00_bglt BgL_arg2988z00_16982;

					BgL_arg2988z00_16982 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_trapz00_bglt) BgL_ez00_14146))))->BgL_ez00);
					BgL_ez00_16981 =
						BGl_compz00zz__evaluate_compz00(BgL_arg2988z00_16982,
						BgL_stkz00_14147);
				}
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_zc3z04anonymousza32982ze3z87_16983;

					BgL_zc3z04anonymousza32982ze3z87_16983 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza32982ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32982ze3z87_16983,
						(int) (((long) 0)), BgL_ez00_16981);
					return BgL_zc3z04anonymousza32982ze3z87_16983;
				}
			}
		}

	}



/* &<@anonymous:2982> */
	obj_t BGl_z62zc3z04anonymousza32982ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14148, obj_t BgL_sz00_14150)
	{
		{	/* Eval/evaluate_comp.scm 292 */
			{	/* Eval/evaluate_comp.scm 292 */
				obj_t BgL_ez00_14149;

				BgL_ez00_14149 = PROCEDURE_REF(BgL_envz00_14148, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_bpz00_16984;

					BgL_bpz00_16984 = VECTOR_REF(((obj_t) BgL_sz00_14150), ((long) 0));
					{	/* Eval/evaluate_comp.scm 293 */
						obj_t BgL_cmdz00_16985;

						BgL_cmdz00_16985 =
							PROCEDURE_ENTRY(BgL_ez00_14149) (BgL_ez00_14149, BgL_sz00_14150,
							BEOA);
						if ((BgL_cmdz00_16985 == BGl_symbol4729z00zz__evaluate_compz00))
							{	/* Eval/evaluate_comp.scm 294 */
								return BgL_bpz00_16984;
							}
						else
							{	/* Eval/evaluate_comp.scm 294 */
								if ((BgL_cmdz00_16985 == BGl_symbol4731z00zz__evaluate_compz00))
									{	/* Eval/evaluate_comp.scm 294 */
										return BGl_reset_profilez00zz__evaluate_compz00();
									}
								else
									{	/* Eval/evaluate_comp.scm 294 */
										if (
											(BgL_cmdz00_16985 ==
												BGl_symbol4733z00zz__evaluate_compz00))
											{	/* Eval/evaluate_comp.scm 294 */
												return BGl_get_profilez00zz__evaluate_compz00();
											}
										else
											{	/* Eval/evaluate_comp.scm 294 */
												if (
													(BgL_cmdz00_16985 ==
														BGl_symbol4735z00zz__evaluate_compz00))
													{	/* Eval/evaluate_comp.scm 302 */
														obj_t BgL_arg2987z00_16986;

														BgL_arg2987z00_16986 =
															BGl_findzd2statezd2zz__evaluate_compz00();
														return
															VECTOR_SET(
															((obj_t) BgL_arg2987z00_16986), ((long) 0),
															BINT(((long) 2)));
													}
												else
													{	/* Eval/evaluate_comp.scm 294 */
														return
															BGl_errorz00zz__errorz00
															(BGl_string4593z00zz__evaluate_compz00,
															BGl_string4737z00zz__evaluate_compz00,
															BgL_cmdz00_16985);
													}
											}
									}
							}
					}
				}
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 483454155),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 70989603),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 368666432),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 479579181),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 467924964),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 68574988),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					169532048), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					437057797), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -44273703),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 190905450),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988580),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 528345299),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 505897955),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)
					20669940), BSTRING_TO_STRING(BGl_string4738z00zz__evaluate_compz00));
		}

	}

#ifdef __cplusplus
}
#endif
