/*===========================================================================*/
/*   (Eval/evaluate_types.scm)                                               */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate_types.scm -indent -o objs/obj_u/Eval/evaluate_types.c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static BgL_ev_defglobalz00_bglt
		BGl_z62lambda1686z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol2643z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2564z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2484z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2649z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2568z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2489z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1930z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1931z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_letza2za2_bglt BGl_z62lambda1852z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62lambda1771z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_ev_defglobalz00_bglt
		BGl_z62lambda1691z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62lambda1773z62zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_defglobalz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_letza2za2_bglt BGl_z62lambda1855z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_gotoz00_bglt BGl_z62lambda1938z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1779z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2572z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2655z00zz__evaluate_typesz00 = BUNSPEC;
	extern obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2493z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2498z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2579z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_gotoz00_bglt BGl_z62lambda1940z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1862z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1863z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1784z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1947z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1785z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1789z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2660z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2584z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2666z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2589z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31864ze3ze5zz__evaluate_typesz00(obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1951z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31775ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1952z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1790z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_letrecz00_bglt BGl_z62lambda1874z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1956z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1957z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1795z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_letrecz00_bglt BGl_z62lambda1877z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1796z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2670z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2597z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2679z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1961z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31857ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_letrecz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1962z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_appz00_bglt BGl_z62lambda1968z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1888z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2681z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2686z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00();
	static BgL_ev_appz00_bglt BGl_z62lambda1970z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1890z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31696ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1976z62zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_letz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1896z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1897z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2691z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2696z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31972ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1982z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1983z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluate_typesz00();
	static obj_t BGl_z62lambda1987z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_prog2z00zz__evaluate_typesz00 = BUNSPEC;
	extern obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31892ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_typesz00();
	static obj_t BGl_z62lambda1992z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1993z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_absz00_bglt BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 =
		BUNSPEC;
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31879ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_letza2za2zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_labelsz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_methodzd2initzd2zz__evaluate_typesz00();
	static obj_t BGl_z62zc3z04anonymousza31510ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_absz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_trapz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31430ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32062ze3ze5zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32055ze3ze5zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32047ze3ze5zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32039ze3ze5zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_setglobalz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_ifz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_absz00_bglt BGl_z62lambda2001z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31440ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda2007z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2008z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_hookz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2014z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2015z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2020z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2021z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2025z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2026z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda2030z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda2031z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_gotoz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2037z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2038z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31711ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31541ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31452ze3ze5zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda2045z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2046z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	BGL_EXPORTED_DEF obj_t BGl_ev_globalz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_binderz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2053z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2054z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_listz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2060z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2061z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31624ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_littz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2068z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2069z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_orz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_varz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1500z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31560ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31609ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_ifz00_bglt BGl_z62lambda1506z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1425z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_ifz00_bglt BGl_z62lambda1508z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1427z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00();
	extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
	static obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00();
	static BgL_ev_exprz00_bglt BGl_z62lambda1514z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1515z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1436z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1438z62zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 =
		BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_andz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1520z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1521z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31635ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_hookz00_bglt BGl_z62lambda1605z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1525z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1444z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_hookz00_bglt BGl_z62lambda1607z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1526z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1445z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_objectz00zz__objectz00;
	static obj_t BGl_symbol2404z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2408z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31911ze3ze5zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31733ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31652ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31571ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1450z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1613z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1451z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1614z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_listz00_bglt BGl_z62lambda1534z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_listz00_bglt BGl_z62lambda1537z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1456z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1457z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2414z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2419z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_trapz00_bglt BGl_z62lambda1620z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_trapz00_bglt BGl_z62lambda1622z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31807ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62lambda1706z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31467ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_globalz00_bglt BGl_z62lambda1463z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1545z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62lambda1708z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1546z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_globalz00_bglt BGl_z62lambda1465z62zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_exprz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_appz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2423z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2428z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2509z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_setlocalz00_bglt
		BGl_z62lambda1631z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setlocalz00_bglt
		BGl_z62lambda1633z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1471z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1715z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1472z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1716z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_orz00_bglt BGl_z62lambda1556z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1476z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_orz00_bglt BGl_z62lambda1558z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1477z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2432z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2514z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2436z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2518z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1720z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_binderz00_bglt BGl_z62lambda1802z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1721z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1640z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1641z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31493ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_binderz00_bglt BGl_z62lambda1805z62zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1482z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1483z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1728z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62lambda1647z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_ev_andz00_bglt BGl_z62lambda1566z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_andz00_bglt BGl_z62lambda1569z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_littz00_bglt BGl_z62lambda1489z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2440z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2602z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2522z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2445z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2527z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2449z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31842ze3ze5zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1811z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1730z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62lambda1650z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_littz00_bglt BGl_z62lambda1491z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1817z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1818z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1737z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1738z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1659z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2611z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2454z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2616z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2536z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2459z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31932ze3ze5zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1902z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1903z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31754ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1660z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1823z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1742z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1824z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1743z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_prog2z00_bglt BGl_z62lambda1581z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62lambda1664z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_prog2z00_bglt BGl_z62lambda1583z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1665z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1909z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62lambda1749z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2540z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2704z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2380z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2706z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2382z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2626z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2464z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2547z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2386z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2468z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2388z00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_setlocalz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1910z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_letz00_bglt BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_letz00_bglt BGl_z62lambda1832z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62lambda1752z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31585ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1916z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1673z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1917z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1674z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1593z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1594z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1758z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1759z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1598z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1599z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2632z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2472z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2553z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2636z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2393z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2395z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2557z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2477z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2399z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza31942ze3ze5zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1840z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1922z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1841z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1923z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1763z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1764z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STRING(BGl_string2400z00zz__evaluate_typesz00,
		BgL_bgl_string2400za700za7za7_2708za7, "type", 4);
	      DEFINE_STRING(BGl_string2405z00zz__evaluate_typesz00,
		BgL_bgl_string2405za700za7za7_2709za7, "ev_var", 6);
	      DEFINE_STRING(BGl_string2409z00zz__evaluate_typesz00,
		BgL_bgl_string2409za700za7za7_2710za7, "loc", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2401z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2711za7,
		BGl_z62zc3z04anonymousza31440ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2402z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1438za7622712z00,
		BGl_z62lambda1438z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2403z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1436za7622713z00,
		BGl_z62lambda1436z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2406z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1472za7622714z00,
		BGl_z62lambda1472z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2407z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1471za7622715z00,
		BGl_z62lambda1471z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2415z00zz__evaluate_typesz00,
		BgL_bgl_string2415za700za7za7_2716za7, "mod", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2410z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1477za7622717z00,
		BGl_z62lambda1477z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2411z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1476za7622718z00,
		BGl_z62lambda1476z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2412z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1483za7622719z00,
		BGl_z62lambda1483z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2413z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1482za7622720z00,
		BGl_z62lambda1482z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2420z00zz__evaluate_typesz00,
		BgL_bgl_string2420za700za7za7_2721za7, "ev_global", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2416z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2722za7,
		BGl_z62zc3z04anonymousza31467ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2417z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1465za7622723z00,
		BGl_z62lambda1465z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2418z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1463za7622724z00,
		BGl_z62lambda1463z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2424z00zz__evaluate_typesz00,
		BgL_bgl_string2424za700za7za7_2725za7, "value", 5);
	      DEFINE_STRING(BGl_string2429z00zz__evaluate_typesz00,
		BgL_bgl_string2429za700za7za7_2726za7, "ev_litt", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2500z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1660za7622727z00,
		BGl_z62lambda1660z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2501z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1659za7622728z00,
		BGl_z62lambda1659z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2421z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1500za7622729z00,
		BGl_z62lambda1500z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2502z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1665za7622730z00,
		BGl_z62lambda1665z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2422z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1499za7622731z00,
		BGl_z62lambda1499z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2503z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1664za7622732z00,
		BGl_z62lambda1664z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2504z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1674za7622733z00,
		BGl_z62lambda1674z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2510z00zz__evaluate_typesz00,
		BgL_bgl_string2510za700za7za7_2734za7, "ev_setglobal", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2505z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1673za7622735z00,
		BGl_z62lambda1673z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2425z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2736za7,
		BGl_z62zc3z04anonymousza31493ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2506z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2737za7,
		BGl_z62zc3z04anonymousza31652ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2426z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1491za7622738z00,
		BGl_z62lambda1491z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2507z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1650za7622739z00,
		BGl_z62lambda1650z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2427z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1489za7622740z00,
		BGl_z62lambda1489z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2433z00zz__evaluate_typesz00,
		BgL_bgl_string2433za700za7za7_2741za7, "p", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2508z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1647za7622742z00,
		BGl_z62lambda1647z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2515z00zz__evaluate_typesz00,
		BgL_bgl_string2515za700za7za7_2743za7, "ev_defglobal", 12);
	      DEFINE_STRING(BGl_string2437z00zz__evaluate_typesz00,
		BgL_bgl_string2437za700za7za7_2744za7, "t", 1);
	      DEFINE_STRING(BGl_string2519z00zz__evaluate_typesz00,
		BgL_bgl_string2519za700za7za7_2745za7, "var", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2430z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1515za7622746z00,
		BGl_z62lambda1515z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2511z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2747za7,
		BGl_z62zc3z04anonymousza31696ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2431z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1514za7622748z00,
		BGl_z62lambda1514z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2512z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1691za7622749z00,
		BGl_z62lambda1691z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2513z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1686za7622750z00,
		BGl_z62lambda1686z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2434z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1521za7622751z00,
		BGl_z62lambda1521z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2435z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1520za7622752z00,
		BGl_z62lambda1520z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2441z00zz__evaluate_typesz00,
		BgL_bgl_string2441za700za7za7_2753za7, "e", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2516z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1716za7622754z00,
		BGl_z62lambda1716z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2603z00zz__evaluate_typesz00,
		BgL_bgl_string2603za700za7za7_2755za7, "ev_letrec", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2517z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1715za7622756z00,
		BGl_z62lambda1715z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2523z00zz__evaluate_typesz00,
		BgL_bgl_string2523za700za7za7_2757za7, "body", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2438z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1526za7622758z00,
		BGl_z62lambda1526z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2439z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1525za7622759z00,
		BGl_z62lambda1525z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2446z00zz__evaluate_typesz00,
		BgL_bgl_string2446za700za7za7_2760za7, "ev_if", 5);
	      DEFINE_STRING(BGl_string2528z00zz__evaluate_typesz00,
		BgL_bgl_string2528za700za7za7_2761za7, "ev_bind-exit", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2600z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1877za7622762z00,
		BGl_z62lambda1877z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2520z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1721za7622763z00,
		BGl_z62lambda1721z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2601z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1874za7622764z00,
		BGl_z62lambda1874z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2521z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1720za7622765z00,
		BGl_z62lambda1720z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2442z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2766za7,
		BGl_z62zc3z04anonymousza31510ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2604z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1897za7622767z00,
		BGl_z62lambda1897z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2443z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1508za7622768z00,
		BGl_z62lambda1508z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2524z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2769za7,
		BGl_z62zc3z04anonymousza31711ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2605z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1896za7622770z00,
		BGl_z62lambda1896z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2444z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1506za7622771z00,
		BGl_z62lambda1506z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2450z00zz__evaluate_typesz00,
		BgL_bgl_string2450za700za7za7_2772za7, "args", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2525z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1708za7622773z00,
		BGl_z62lambda1708z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2606z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1903za7622774z00,
		BGl_z62lambda1903z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2612z00zz__evaluate_typesz00,
		BgL_bgl_string2612za700za7za7_2775za7, "env", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2526z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1706za7622776z00,
		BGl_z62lambda1706z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2607z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1902za7622777z00,
		BGl_z62lambda1902z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2608z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2778za7,
		BGl_z62zc3z04anonymousza31911ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2447z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1546za7622779z00,
		BGl_z62lambda1546z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2609z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1910za7622780z00,
		BGl_z62lambda1910z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2448z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1545za7622781z00,
		BGl_z62lambda1545z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2529z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1738za7622782z00,
		BGl_z62lambda1738z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2455z00zz__evaluate_typesz00,
		BgL_bgl_string2455za700za7za7_2783za7, "ev_list", 7);
	      DEFINE_STRING(BGl_string2617z00zz__evaluate_typesz00,
		BgL_bgl_string2617za700za7za7_2784za7, "stk", 3);
	      DEFINE_STRING(BGl_string2537z00zz__evaluate_typesz00,
		BgL_bgl_string2537za700za7za7_2785za7, "ev_unwind-protect", 17);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2610z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1909za7622786z00,
		BGl_z62lambda1909z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2530z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1737za7622787z00,
		BGl_z62lambda1737z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2531z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1743za7622788z00,
		BGl_z62lambda1743z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2451z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2789za7,
		BGl_z62zc3z04anonymousza31541ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2532z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1742za7622790z00,
		BGl_z62lambda1742z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2613z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2791za7,
		BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2452z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1537za7622792z00,
		BGl_z62lambda1537z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2533z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2793za7,
		BGl_z62zc3z04anonymousza31733ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2614z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1917za7622794z00,
		BGl_z62lambda1917z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2453z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1534za7622795z00,
		BGl_z62lambda1534z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2534z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1730za7622796z00,
		BGl_z62lambda1730z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2615z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1916za7622797z00,
		BGl_z62lambda1916z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2460z00zz__evaluate_typesz00,
		BgL_bgl_string2460za700za7za7_2798za7, "ev_or", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2535z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1728za7622799z00,
		BGl_z62lambda1728z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2541z00zz__evaluate_typesz00,
		BgL_bgl_string2541za700za7za7_2800za7, "handler", 7);
	      DEFINE_STRING(BGl_string2705z00zz__evaluate_typesz00,
		BgL_bgl_string2705za700za7za7_2801za7, "ev_abs", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2618z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1923za7622802z00,
		BGl_z62lambda1923z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2381z00zz__evaluate_typesz00,
		BgL_bgl_string2381za700za7za7_2803za7, "ev_expr", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2456z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2804za7,
		BGl_z62zc3z04anonymousza31560ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2619z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1922za7622805z00,
		BGl_z62lambda1922z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2457z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1558za7622806z00,
		BGl_z62lambda1558z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2538z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1759za7622807z00,
		BGl_z62lambda1759z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2707z00zz__evaluate_typesz00,
		BgL_bgl_string2707za700za7za7_2808za7, "_", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2377z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2809za7,
		BGl_z62zc3z04anonymousza31430ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2383z00zz__evaluate_typesz00,
		BgL_bgl_string2383za700za7za7_2810za7, "__evaluate_types", 16);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2458z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1556za7622811z00,
		BGl_z62lambda1556z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2539z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1758za7622812z00,
		BGl_z62lambda1758z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2627z00zz__evaluate_typesz00,
		BgL_bgl_string2627za700za7za7_2813za7, "ev_labels", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2378z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1427za7622814z00,
		BGl_z62lambda1427z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2465z00zz__evaluate_typesz00,
		BgL_bgl_string2465za700za7za7_2815za7, "ev_and", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2379z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1425za7622816z00,
		BGl_z62lambda1425z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2548z00zz__evaluate_typesz00,
		BgL_bgl_string2548za700za7za7_2817za7, "ev_with-handler", 15);
	      DEFINE_STRING(BGl_string2387z00zz__evaluate_typesz00,
		BgL_bgl_string2387za700za7za7_2818za7, "name", 4);
	      DEFINE_STRING(BGl_string2469z00zz__evaluate_typesz00,
		BgL_bgl_string2469za700za7za7_2819za7, "e1", 2);
	      DEFINE_STRING(BGl_string2389z00zz__evaluate_typesz00,
		BgL_bgl_string2389za700za7za7_2820za7, "symbol", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2700z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2068za7622821z00,
		BGl_z62lambda2068z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2701z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2822za7,
		BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2620z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2823za7,
		BGl_z62zc3z04anonymousza31932ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2702z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2001za7622824z00,
		BGl_z62lambda2001z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2621z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1931za7622825z00,
		BGl_z62lambda1931z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2703z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1999za7622826z00,
		BGl_z62lambda1999z62zz__evaluate_typesz00, 0L, BUNSPEC, 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2622z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1930za7622827z00,
		BGl_z62lambda1930z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2623z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2828za7,
		BGl_z62zc3z04anonymousza31892ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2461z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2829za7,
		BGl_z62zc3z04anonymousza31571ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2542z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1764za7622830z00,
		BGl_z62lambda1764z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2624z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1890za7622831z00,
		BGl_z62lambda1890z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2462z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1569za7622832z00,
		BGl_z62lambda1569z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2543z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1763za7622833z00,
		BGl_z62lambda1763z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2625z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1888za7622834z00,
		BGl_z62lambda1888z62zz__evaluate_typesz00, 0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2463z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1566za7622835z00,
		BGl_z62lambda1566z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2544z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2836za7,
		BGl_z62zc3z04anonymousza31754ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2545z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1752za7622837z00,
		BGl_z62lambda1752z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2633z00zz__evaluate_typesz00,
		BgL_bgl_string2633za700za7za7_2838za7, "label", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2384z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1445za7622839z00,
		BGl_z62lambda1445z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2546z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1749za7622840z00,
		BGl_z62lambda1749z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2628z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1947za7622841z00,
		BGl_z62lambda1947z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2385z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1444za7622842z00,
		BGl_z62lambda1444z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2466z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1594za7622843z00,
		BGl_z62lambda1594z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2629z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1946za7622844z00,
		BGl_z62lambda1946z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2467z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1593za7622845z00,
		BGl_z62lambda1593z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2473z00zz__evaluate_typesz00,
		BgL_bgl_string2473za700za7za7_2846za7, "e2", 2);
	      DEFINE_STRING(BGl_string2554z00zz__evaluate_typesz00,
		BgL_bgl_string2554za700za7za7_2847za7, "mutex", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2549z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1780za7622848z00,
		BGl_z62lambda1780z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2637z00zz__evaluate_typesz00,
		BgL_bgl_string2637za700za7za7_2849za7, "labels", 6);
	      DEFINE_STRING(BGl_string2394z00zz__evaluate_typesz00,
		BgL_bgl_string2394za700za7za7_2850za7, "eff", 3);
	      DEFINE_STRING(BGl_string2396z00zz__evaluate_typesz00,
		BgL_bgl_string2396za700za7za7_2851za7, "obj", 3);
	      DEFINE_STRING(BGl_string2558z00zz__evaluate_typesz00,
		BgL_bgl_string2558za700za7za7_2852za7, "prelock", 7);
	      DEFINE_STRING(BGl_string2478z00zz__evaluate_typesz00,
		BgL_bgl_string2478za700za7za7_2853za7, "ev_prog2", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2630z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1952za7622854z00,
		BGl_z62lambda1952z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2631z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1951za7622855z00,
		BGl_z62lambda1951z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2550z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1779za7622856z00,
		BGl_z62lambda1779z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2470z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1599za7622857z00,
		BGl_z62lambda1599z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2551z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1785za7622858z00,
		BGl_z62lambda1785z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2390z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2859za7,
		BGl_z62zc3z04anonymousza31452ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2471z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1598za7622860z00,
		BGl_z62lambda1598z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2552z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1784za7622861z00,
		BGl_z62lambda1784z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2634z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1957za7622862z00,
		BGl_z62lambda1957z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2391z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1451za7622863z00,
		BGl_z62lambda1451z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2635z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1956za7622864z00,
		BGl_z62lambda1956z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2392z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1450za7622865z00,
		BGl_z62lambda1450z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2474z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2866za7,
		BGl_z62zc3z04anonymousza31585ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2555z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1790za7622867z00,
		BGl_z62lambda1790z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2475z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1583za7622868z00,
		BGl_z62lambda1583z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2556z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1789za7622869z00,
		BGl_z62lambda1789z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2644z00zz__evaluate_typesz00,
		BgL_bgl_string2644za700za7za7_2870za7, "ev_goto", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2638z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1962za7622871z00,
		BGl_z62lambda1962z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2476z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1581za7622872z00,
		BGl_z62lambda1581z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2639z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1961za7622873z00,
		BGl_z62lambda1961z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2397z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1457za7622874z00,
		BGl_z62lambda1457z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2559z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1796za7622875z00,
		BGl_z62lambda1796z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2565z00zz__evaluate_typesz00,
		BgL_bgl_string2565za700za7za7_2876za7, "ev_synchronize", 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2398z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1456za7622877z00,
		BGl_z62lambda1456z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2479z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1614za7622878z00,
		BGl_z62lambda1614z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2485z00zz__evaluate_typesz00,
		BgL_bgl_string2485za700za7za7_2879za7, "ev_hook", 7);
	      DEFINE_STRING(BGl_string2569z00zz__evaluate_typesz00,
		BgL_bgl_string2569za700za7za7_2880za7, "vars", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2640z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2881za7,
		BGl_z62zc3z04anonymousza31942ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2641z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1940za7622882z00,
		BGl_z62lambda1940z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2560z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1795za7622883z00,
		BGl_z62lambda1795z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2642z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1938za7622884z00,
		BGl_z62lambda1938z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2480z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1613za7622885z00,
		BGl_z62lambda1613z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2561z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2886za7,
		BGl_z62zc3z04anonymousza31775ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2481z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2887za7,
		BGl_z62zc3z04anonymousza31609ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2562z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1773za7622888z00,
		BGl_z62lambda1773z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2650z00zz__evaluate_typesz00,
		BgL_bgl_string2650za700za7za7_2889za7, "fun", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2482z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1607za7622890z00,
		BGl_z62lambda1607z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2563z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1771za7622891z00,
		BGl_z62lambda1771z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2645z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1977za7622892z00,
		BGl_z62lambda1977z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2483z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1605za7622893z00,
		BGl_z62lambda1605z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2646z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1976za7622894z00,
		BGl_z62lambda1976z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2490z00zz__evaluate_typesz00,
		BgL_bgl_string2490za700za7za7_2895za7, "ev_trap", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2647z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1983za7622896z00,
		BGl_z62lambda1983z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2566z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1812za7622897z00,
		BGl_z62lambda1812z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2648z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1982za7622898z00,
		BGl_z62lambda1982z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2486z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2899za7,
		BGl_z62zc3z04anonymousza31624ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2567z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1811za7622900z00,
		BGl_z62lambda1811z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2573z00zz__evaluate_typesz00,
		BgL_bgl_string2573za700za7za7_2901za7, "vals", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2487z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1622za7622902z00,
		BGl_z62lambda1622z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2656z00zz__evaluate_typesz00,
		BgL_bgl_string2656za700za7za7_2903za7, "tail?", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2488z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1620za7622904z00,
		BGl_z62lambda1620z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2494z00zz__evaluate_typesz00,
		BgL_bgl_string2494za700za7za7_2905za7, "v", 1);
	      DEFINE_STRING(BGl_string2499z00zz__evaluate_typesz00,
		BgL_bgl_string2499za700za7za7_2906za7, "ev_setlocal", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2651z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1988za7622907z00,
		BGl_z62lambda1988z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2570z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1818za7622908z00,
		BGl_z62lambda1818z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2652z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1987za7622909z00,
		BGl_z62lambda1987z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2571z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1817za7622910z00,
		BGl_z62lambda1817z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2653z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1993za7622911z00,
		BGl_z62lambda1993z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2491z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1641za7622912z00,
		BGl_z62lambda1641z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2654z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1992za7622913z00,
		BGl_z62lambda1992z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2492z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1640za7622914z00,
		BGl_z62lambda1640z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2661z00zz__evaluate_typesz00,
		BgL_bgl_string2661za700za7za7_2915za7, "ev_app", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2574z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1824za7622916z00,
		BGl_z62lambda1824z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2580z00zz__evaluate_typesz00,
		BgL_bgl_string2580za700za7za7_2917za7, "ev_binder", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2575z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1823za7622918z00,
		BGl_z62lambda1823z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2657z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2919za7,
		BGl_z62zc3z04anonymousza31972ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2495z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2920za7,
		BGl_z62zc3z04anonymousza31635ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2576z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2921za7,
		BGl_z62zc3z04anonymousza31807ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2658z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1970za7622922z00,
		BGl_z62lambda1970z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2496z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1633za7622923z00,
		BGl_z62lambda1633z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2577z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1805za7622924z00,
		BGl_z62lambda1805z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2659z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1968za7622925z00,
		BGl_z62lambda1968z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2497z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1631za7622926z00,
		BGl_z62lambda1631z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2578z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1802za7622927z00,
		BGl_z62lambda1802z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2585z00zz__evaluate_typesz00,
		BgL_bgl_string2585za700za7za7_2928za7, "boxes", 5);
	      DEFINE_STRING(BGl_string2667z00zz__evaluate_typesz00,
		BgL_bgl_string2667za700za7za7_2929za7, "where", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2662z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2008za7622930z00,
		BGl_z62lambda2008z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2581z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2931za7,
		BGl_z62zc3z04anonymousza31842ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2663z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2007za7622932z00,
		BGl_z62lambda2007z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2582z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1841za7622933z00,
		BGl_z62lambda1841z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2664z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2015za7622934z00,
		BGl_z62lambda2015z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2583z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1840za7622935z00,
		BGl_z62lambda1840z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2671z00zz__evaluate_typesz00,
		BgL_bgl_string2671za700za7za7_2936za7, "arity", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2665z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2014za7622937z00,
		BGl_z62lambda2014z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2590z00zz__evaluate_typesz00,
		BgL_bgl_string2590za700za7za7_2938za7, "ev_let", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2586z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2939za7,
		BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2668z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2021za7622940z00,
		BGl_z62lambda2021z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2587z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1832za7622941z00,
		BGl_z62lambda1832z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2669z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2020za7622942z00,
		BGl_z62lambda2020z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2588z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1830za7622943z00,
		BGl_z62lambda1830z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2598z00zz__evaluate_typesz00,
		BgL_bgl_string2598za700za7za7_2944za7, "ev_let*", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2672z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2026za7622945z00,
		BGl_z62lambda2026z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2591z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2946za7,
		BGl_z62zc3z04anonymousza31864ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2673z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2025za7622947z00,
		BGl_z62lambda2025z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2592z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1863za7622948z00,
		BGl_z62lambda1863z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2680z00zz__evaluate_typesz00,
		BgL_bgl_string2680za700za7za7_2949za7, "size", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2674z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2031za7622950z00,
		BGl_z62lambda2031z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2593z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1862za7622951z00,
		BGl_z62lambda1862z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2675z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2030za7622952z00,
		BGl_z62lambda2030z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2594z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2953za7,
		BGl_z62zc3z04anonymousza31857ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2682z00zz__evaluate_typesz00,
		BgL_bgl_string2682za700za7za7_2954za7, "int", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2676z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2955za7,
		BGl_z62zc3z04anonymousza32039ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2595z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1855za7622956z00,
		BGl_z62lambda1855z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2677z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2038za7622957z00,
		BGl_z62lambda2038z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2596z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1852za7622958z00,
		BGl_z62lambda1852z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2678z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2037za7622959z00,
		BGl_z62lambda2037z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2599z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2960za7,
		BGl_z62zc3z04anonymousza31879ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2687z00zz__evaluate_typesz00,
		BgL_bgl_string2687za700za7za7_2961za7, "bind", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2683z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2962za7,
		BGl_z62zc3z04anonymousza32047ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2684z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2046za7622963z00,
		BGl_z62lambda2046z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2685z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2045za7622964z00,
		BGl_z62lambda2045z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2692z00zz__evaluate_typesz00,
		BgL_bgl_string2692za700za7za7_2965za7, "free", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2688z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2966za7,
		BGl_z62zc3z04anonymousza32055ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2689z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2054za7622967z00,
		BGl_z62lambda2054z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2697z00zz__evaluate_typesz00,
		BgL_bgl_string2697za700za7za7_2968za7, "inner", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2690z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2053za7622969z00,
		BGl_z62lambda2053z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2693z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2970za7,
		BGl_z62zc3z04anonymousza32062ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2694z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2061za7622971z00,
		BGl_z62lambda2061z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2695z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2060za7622972z00,
		BGl_z62lambda2060z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2698z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3za704anonymo2973za7,
		BGl_z62zc3z04anonymousza32070ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2699z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2069za7622974z00,
		BGl_z62lambda2069z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_symbol2643z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2564z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2484z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2649z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2568z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2489z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_defglobalz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2572z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2655z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2493z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2498z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2579z00zz__evaluate_typesz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2660z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2584z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2666z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2589z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2670z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2597z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2679z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_letrecz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2681z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2686z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_letz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2691z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2696z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_prog2z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_bindzd2exitzd2zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_letza2za2zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_labelsz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_absz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_trapz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_setglobalz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_ifz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_hookz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_gotoz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_globalz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_binderz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_listz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_littz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_orz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_varz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_withzd2handlerzd2zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_andz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2404z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2408z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2414z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2419z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_exprz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_appz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2423z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2428z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2509z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2432z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2514z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2436z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2518z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_synchroniza7eza7zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2440z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2602z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2522z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2445z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2527z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2449z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2611z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2454z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2616z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2536z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2459z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2540z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2704z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2380z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2706z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2382z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2626z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2464z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2547z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2386z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2468z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2388z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_setlocalz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2632z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2472z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2553z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2636z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2393z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2395z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2557z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2477z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2399z00zz__evaluate_typesz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long
		BgL_checksumz00_4278, char *BgL_fromz00_4279)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_typesz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluate_typesz00();
					BGl_cnstzd2initzd2zz__evaluate_typesz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
					BGl_objectzd2initzd2zz__evaluate_typesz00();
					return BGl_toplevelzd2initzd2zz__evaluate_typesz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00()
	{
		{	/* Eval/evaluate_types.scm 15 */
			BGl_symbol2380z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2381z00zz__evaluate_typesz00);
			BGl_symbol2382z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2383z00zz__evaluate_typesz00);
			BGl_symbol2386z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2387z00zz__evaluate_typesz00);
			BGl_symbol2388z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2389z00zz__evaluate_typesz00);
			BGl_symbol2393z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2394z00zz__evaluate_typesz00);
			BGl_symbol2395z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2396z00zz__evaluate_typesz00);
			BGl_symbol2399z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2400z00zz__evaluate_typesz00);
			BGl_symbol2404z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2405z00zz__evaluate_typesz00);
			BGl_symbol2408z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2409z00zz__evaluate_typesz00);
			BGl_symbol2414z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2415z00zz__evaluate_typesz00);
			BGl_symbol2419z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2420z00zz__evaluate_typesz00);
			BGl_symbol2423z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2424z00zz__evaluate_typesz00);
			BGl_symbol2428z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2429z00zz__evaluate_typesz00);
			BGl_symbol2432z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2433z00zz__evaluate_typesz00);
			BGl_symbol2436z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2437z00zz__evaluate_typesz00);
			BGl_symbol2440z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2441z00zz__evaluate_typesz00);
			BGl_symbol2445z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2446z00zz__evaluate_typesz00);
			BGl_symbol2449z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2450z00zz__evaluate_typesz00);
			BGl_symbol2454z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2455z00zz__evaluate_typesz00);
			BGl_symbol2459z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2460z00zz__evaluate_typesz00);
			BGl_symbol2464z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2465z00zz__evaluate_typesz00);
			BGl_symbol2468z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2469z00zz__evaluate_typesz00);
			BGl_symbol2472z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2473z00zz__evaluate_typesz00);
			BGl_symbol2477z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2478z00zz__evaluate_typesz00);
			BGl_symbol2484z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2485z00zz__evaluate_typesz00);
			BGl_symbol2489z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2490z00zz__evaluate_typesz00);
			BGl_symbol2493z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2494z00zz__evaluate_typesz00);
			BGl_symbol2498z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2499z00zz__evaluate_typesz00);
			BGl_symbol2509z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2510z00zz__evaluate_typesz00);
			BGl_symbol2514z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2515z00zz__evaluate_typesz00);
			BGl_symbol2518z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2519z00zz__evaluate_typesz00);
			BGl_symbol2522z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2523z00zz__evaluate_typesz00);
			BGl_symbol2527z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2528z00zz__evaluate_typesz00);
			BGl_symbol2536z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2537z00zz__evaluate_typesz00);
			BGl_symbol2540z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2541z00zz__evaluate_typesz00);
			BGl_symbol2547z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2548z00zz__evaluate_typesz00);
			BGl_symbol2553z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2554z00zz__evaluate_typesz00);
			BGl_symbol2557z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2558z00zz__evaluate_typesz00);
			BGl_symbol2564z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2565z00zz__evaluate_typesz00);
			BGl_symbol2568z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2569z00zz__evaluate_typesz00);
			BGl_symbol2572z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2573z00zz__evaluate_typesz00);
			BGl_symbol2579z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2580z00zz__evaluate_typesz00);
			BGl_symbol2584z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2585z00zz__evaluate_typesz00);
			BGl_symbol2589z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2590z00zz__evaluate_typesz00);
			BGl_symbol2597z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2598z00zz__evaluate_typesz00);
			BGl_symbol2602z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2603z00zz__evaluate_typesz00);
			BGl_symbol2611z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2612z00zz__evaluate_typesz00);
			BGl_symbol2616z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2617z00zz__evaluate_typesz00);
			BGl_symbol2626z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2627z00zz__evaluate_typesz00);
			BGl_symbol2632z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2633z00zz__evaluate_typesz00);
			BGl_symbol2636z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2637z00zz__evaluate_typesz00);
			BGl_symbol2643z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2644z00zz__evaluate_typesz00);
			BGl_symbol2649z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2650z00zz__evaluate_typesz00);
			BGl_symbol2655z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2656z00zz__evaluate_typesz00);
			BGl_symbol2660z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2661z00zz__evaluate_typesz00);
			BGl_symbol2666z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2667z00zz__evaluate_typesz00);
			BGl_symbol2670z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2671z00zz__evaluate_typesz00);
			BGl_symbol2679z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2680z00zz__evaluate_typesz00);
			BGl_symbol2681z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2682z00zz__evaluate_typesz00);
			BGl_symbol2686z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2687z00zz__evaluate_typesz00);
			BGl_symbol2691z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2692z00zz__evaluate_typesz00);
			BGl_symbol2696z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2697z00zz__evaluate_typesz00);
			BGl_symbol2704z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2705z00zz__evaluate_typesz00);
			return (BGl_symbol2706z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2707z00zz__evaluate_typesz00), BUNSPEC);
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00()
	{
		{	/* Eval/evaluate_types.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00()
	{
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_typesz00()
	{
		{	/* Eval/evaluate_types.scm 15 */
			{	/* Eval/evaluate_types.scm 49 */
				obj_t BgL_arg1423z00_1062;
				obj_t BgL_arg1424z00_1063;

				{	/* Eval/evaluate_types.scm 49 */
					obj_t BgL_v1287z00_1073;

					BgL_v1287z00_1073 = create_vector(((long) 0));
					BgL_arg1423z00_1062 = BgL_v1287z00_1073;
				}
				{	/* Eval/evaluate_types.scm 49 */
					obj_t BgL_v1288z00_1074;

					BgL_v1288z00_1074 = create_vector(((long) 0));
					BgL_arg1424z00_1063 = BgL_v1288z00_1074;
				}
				BGl_ev_exprz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2380z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00, BGl_objectz00zz__objectz00,
					((long) 36682), BGl_proc2379z00zz__evaluate_typesz00,
					BGl_proc2378z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2377z00zz__evaluate_typesz00, BFALSE, BgL_arg1423z00_1062,
					BgL_arg1424z00_1063);
			}
			{	/* Eval/evaluate_types.scm 51 */
				obj_t BgL_arg1434z00_1081;
				obj_t BgL_arg1435z00_1082;

				{	/* Eval/evaluate_types.scm 51 */
					obj_t BgL_v1289z00_1095;

					BgL_v1289z00_1095 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1289z00_1095, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2386z00zz__evaluate_typesz00,
							BGl_proc2385z00zz__evaluate_typesz00,
							BGl_proc2384z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1289z00_1095, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2393z00zz__evaluate_typesz00,
							BGl_proc2392z00zz__evaluate_typesz00,
							BGl_proc2391z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2390z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1289z00_1095, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2399z00zz__evaluate_typesz00,
							BGl_proc2398z00zz__evaluate_typesz00,
							BGl_proc2397z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1434z00_1081 = BgL_v1289z00_1095;
				}
				{	/* Eval/evaluate_types.scm 51 */
					obj_t BgL_v1290z00_1129;

					BgL_v1290z00_1129 = create_vector(((long) 0));
					BgL_arg1435z00_1082 = BgL_v1290z00_1129;
				}
				BGl_ev_varz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2404z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 7285),
					BGl_proc2403z00zz__evaluate_typesz00,
					BGl_proc2402z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2401z00zz__evaluate_typesz00, BFALSE, BgL_arg1434z00_1081,
					BgL_arg1435z00_1082);
			}
			{	/* Eval/evaluate_types.scm 55 */
				obj_t BgL_arg1461z00_1136;
				obj_t BgL_arg1462z00_1137;

				{	/* Eval/evaluate_types.scm 55 */
					obj_t BgL_v1291z00_1150;

					BgL_v1291z00_1150 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1291z00_1150, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2408z00zz__evaluate_typesz00,
							BGl_proc2407z00zz__evaluate_typesz00,
							BGl_proc2406z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1291z00_1150, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2386z00zz__evaluate_typesz00,
							BGl_proc2411z00zz__evaluate_typesz00,
							BGl_proc2410z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1291z00_1150, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2414z00zz__evaluate_typesz00,
							BGl_proc2413z00zz__evaluate_typesz00,
							BGl_proc2412z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1461z00_1136 = BgL_v1291z00_1150;
				}
				{	/* Eval/evaluate_types.scm 55 */
					obj_t BgL_v1292z00_1181;

					BgL_v1292z00_1181 = create_vector(((long) 0));
					BgL_arg1462z00_1137 = BgL_v1292z00_1181;
				}
				BGl_ev_globalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2419z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 59175),
					BGl_proc2418z00zz__evaluate_typesz00,
					BGl_proc2417z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2416z00zz__evaluate_typesz00, BFALSE, BgL_arg1461z00_1136,
					BgL_arg1462z00_1137);
			}
			{	/* Eval/evaluate_types.scm 60 */
				obj_t BgL_arg1487z00_1188;
				obj_t BgL_arg1488z00_1189;

				{	/* Eval/evaluate_types.scm 60 */
					obj_t BgL_v1293z00_1200;

					BgL_v1293z00_1200 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1293z00_1200, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2423z00zz__evaluate_typesz00,
							BGl_proc2422z00zz__evaluate_typesz00,
							BGl_proc2421z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1487z00_1188 = BgL_v1293z00_1200;
				}
				{	/* Eval/evaluate_types.scm 60 */
					obj_t BgL_v1294z00_1211;

					BgL_v1294z00_1211 = create_vector(((long) 0));
					BgL_arg1488z00_1189 = BgL_v1294z00_1211;
				}
				BGl_ev_littz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2428z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 42418),
					BGl_proc2427z00zz__evaluate_typesz00,
					BGl_proc2426z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2425z00zz__evaluate_typesz00, BFALSE, BgL_arg1487z00_1188,
					BgL_arg1488z00_1189);
			}
			{	/* Eval/evaluate_types.scm 62 */
				obj_t BgL_arg1504z00_1218;
				obj_t BgL_arg1505z00_1219;

				{	/* Eval/evaluate_types.scm 62 */
					obj_t BgL_v1295z00_1232;

					BgL_v1295z00_1232 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1295z00_1232, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2432z00zz__evaluate_typesz00,
							BGl_proc2431z00zz__evaluate_typesz00,
							BGl_proc2430z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1295z00_1232, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2436z00zz__evaluate_typesz00,
							BGl_proc2435z00zz__evaluate_typesz00,
							BGl_proc2434z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1295z00_1232, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2440z00zz__evaluate_typesz00,
							BGl_proc2439z00zz__evaluate_typesz00,
							BGl_proc2438z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1504z00_1218 = BgL_v1295z00_1232;
				}
				{	/* Eval/evaluate_types.scm 62 */
					obj_t BgL_v1296z00_1263;

					BgL_v1296z00_1263 = create_vector(((long) 0));
					BgL_arg1505z00_1219 = BgL_v1296z00_1263;
				}
				BGl_ev_ifz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2445z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 19099),
					BGl_proc2444z00zz__evaluate_typesz00,
					BGl_proc2443z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2442z00zz__evaluate_typesz00, BFALSE, BgL_arg1504z00_1218,
					BgL_arg1505z00_1219);
			}
			{	/* Eval/evaluate_types.scm 66 */
				obj_t BgL_arg1532z00_1270;
				obj_t BgL_arg1533z00_1271;

				{	/* Eval/evaluate_types.scm 66 */
					obj_t BgL_v1297z00_1282;

					BgL_v1297z00_1282 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1297z00_1282, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2449z00zz__evaluate_typesz00,
							BGl_proc2448z00zz__evaluate_typesz00,
							BGl_proc2447z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1532z00_1270 = BgL_v1297z00_1282;
				}
				{	/* Eval/evaluate_types.scm 66 */
					obj_t BgL_v1298z00_1293;

					BgL_v1298z00_1293 = create_vector(((long) 0));
					BgL_arg1533z00_1271 = BgL_v1298z00_1293;
				}
				BGl_ev_listz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2454z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 39617),
					BGl_proc2453z00zz__evaluate_typesz00,
					BGl_proc2452z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2451z00zz__evaluate_typesz00, BFALSE, BgL_arg1532z00_1270,
					BgL_arg1533z00_1271);
			}
			{	/* Eval/evaluate_types.scm 68 */
				obj_t BgL_arg1552z00_1300;
				obj_t BgL_arg1555z00_1301;

				{	/* Eval/evaluate_types.scm 68 */
					obj_t BgL_v1299z00_1312;

					BgL_v1299z00_1312 = create_vector(((long) 0));
					BgL_arg1552z00_1300 = BgL_v1299z00_1312;
				}
				{	/* Eval/evaluate_types.scm 68 */
					obj_t BgL_v1300z00_1313;

					BgL_v1300z00_1313 = create_vector(((long) 0));
					BgL_arg1555z00_1301 = BgL_v1300z00_1313;
				}
				BGl_ev_orz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2459z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_listz00zz__evaluate_typesz00, ((long) 50334),
					BGl_proc2458z00zz__evaluate_typesz00,
					BGl_proc2457z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2456z00zz__evaluate_typesz00, BFALSE, BgL_arg1552z00_1300,
					BgL_arg1555z00_1301);
			}
			{	/* Eval/evaluate_types.scm 69 */
				obj_t BgL_arg1564z00_1320;
				obj_t BgL_arg1565z00_1321;

				{	/* Eval/evaluate_types.scm 69 */
					obj_t BgL_v1301z00_1332;

					BgL_v1301z00_1332 = create_vector(((long) 0));
					BgL_arg1564z00_1320 = BgL_v1301z00_1332;
				}
				{	/* Eval/evaluate_types.scm 69 */
					obj_t BgL_v1302z00_1333;

					BgL_v1302z00_1333 = create_vector(((long) 0));
					BgL_arg1565z00_1321 = BgL_v1302z00_1333;
				}
				BGl_ev_andz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2464z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_listz00zz__evaluate_typesz00, ((long) 26888),
					BGl_proc2463z00zz__evaluate_typesz00,
					BGl_proc2462z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2461z00zz__evaluate_typesz00, BFALSE, BgL_arg1564z00_1320,
					BgL_arg1565z00_1321);
			}
			{	/* Eval/evaluate_types.scm 70 */
				obj_t BgL_arg1579z00_1340;
				obj_t BgL_arg1580z00_1341;

				{	/* Eval/evaluate_types.scm 70 */
					obj_t BgL_v1303z00_1353;

					BgL_v1303z00_1353 = create_vector(((long) 2));
					VECTOR_SET(BgL_v1303z00_1353, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2468z00zz__evaluate_typesz00,
							BGl_proc2467z00zz__evaluate_typesz00,
							BGl_proc2466z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1303z00_1353, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2472z00zz__evaluate_typesz00,
							BGl_proc2471z00zz__evaluate_typesz00,
							BGl_proc2470z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1579z00_1340 = BgL_v1303z00_1353;
				}
				{	/* Eval/evaluate_types.scm 70 */
					obj_t BgL_v1304z00_1374;

					BgL_v1304z00_1374 = create_vector(((long) 0));
					BgL_arg1580z00_1341 = BgL_v1304z00_1374;
				}
				BGl_ev_prog2z00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2477z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 14177),
					BGl_proc2476z00zz__evaluate_typesz00,
					BGl_proc2475z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2474z00zz__evaluate_typesz00, BFALSE, BgL_arg1579z00_1340,
					BgL_arg1580z00_1341);
			}
			{	/* Eval/evaluate_types.scm 73 */
				obj_t BgL_arg1603z00_1381;
				obj_t BgL_arg1604z00_1382;

				{	/* Eval/evaluate_types.scm 73 */
					obj_t BgL_v1305z00_1393;

					BgL_v1305z00_1393 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1305z00_1393, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2440z00zz__evaluate_typesz00,
							BGl_proc2480z00zz__evaluate_typesz00,
							BGl_proc2479z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1603z00_1381 = BgL_v1305z00_1393;
				}
				{	/* Eval/evaluate_types.scm 73 */
					obj_t BgL_v1306z00_1404;

					BgL_v1306z00_1404 = create_vector(((long) 0));
					BgL_arg1604z00_1382 = BgL_v1306z00_1404;
				}
				BGl_ev_hookz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2484z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 32125),
					BGl_proc2483z00zz__evaluate_typesz00,
					BGl_proc2482z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2481z00zz__evaluate_typesz00, BFALSE, BgL_arg1603z00_1381,
					BgL_arg1604z00_1382);
			}
			{	/* Eval/evaluate_types.scm 75 */
				obj_t BgL_arg1618z00_1411;
				obj_t BgL_arg1619z00_1412;

				{	/* Eval/evaluate_types.scm 75 */
					obj_t BgL_v1307z00_1423;

					BgL_v1307z00_1423 = create_vector(((long) 0));
					BgL_arg1618z00_1411 = BgL_v1307z00_1423;
				}
				{	/* Eval/evaluate_types.scm 75 */
					obj_t BgL_v1308z00_1424;

					BgL_v1308z00_1424 = create_vector(((long) 0));
					BgL_arg1619z00_1412 = BgL_v1308z00_1424;
				}
				BGl_ev_trapz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2489z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 24451),
					BGl_proc2488z00zz__evaluate_typesz00,
					BGl_proc2487z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2486z00zz__evaluate_typesz00, BFALSE, BgL_arg1618z00_1411,
					BgL_arg1619z00_1412);
			}
			{	/* Eval/evaluate_types.scm 76 */
				obj_t BgL_arg1629z00_1431;
				obj_t BgL_arg1630z00_1432;

				{	/* Eval/evaluate_types.scm 76 */
					obj_t BgL_v1309z00_1444;

					BgL_v1309z00_1444 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1309z00_1444, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2493z00zz__evaluate_typesz00,
							BGl_proc2492z00zz__evaluate_typesz00,
							BGl_proc2491z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					BgL_arg1629z00_1431 = BgL_v1309z00_1444;
				}
				{	/* Eval/evaluate_types.scm 76 */
					obj_t BgL_v1310z00_1455;

					BgL_v1310z00_1455 = create_vector(((long) 0));
					BgL_arg1630z00_1432 = BgL_v1310z00_1455;
				}
				BGl_ev_setlocalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2498z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 37950),
					BGl_proc2497z00zz__evaluate_typesz00,
					BGl_proc2496z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2495z00zz__evaluate_typesz00, BFALSE, BgL_arg1629z00_1431,
					BgL_arg1630z00_1432);
			}
			{	/* Eval/evaluate_types.scm 78 */
				obj_t BgL_arg1645z00_1462;
				obj_t BgL_arg1646z00_1463;

				{	/* Eval/evaluate_types.scm 78 */
					obj_t BgL_v1311z00_1477;

					BgL_v1311z00_1477 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1311z00_1477, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2408z00zz__evaluate_typesz00,
							BGl_proc2501z00zz__evaluate_typesz00,
							BGl_proc2500z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1311z00_1477, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2386z00zz__evaluate_typesz00,
							BGl_proc2503z00zz__evaluate_typesz00,
							BGl_proc2502z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1311z00_1477, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2414z00zz__evaluate_typesz00,
							BGl_proc2505z00zz__evaluate_typesz00,
							BGl_proc2504z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1645z00_1462 = BgL_v1311z00_1477;
				}
				{	/* Eval/evaluate_types.scm 78 */
					obj_t BgL_v1312z00_1508;

					BgL_v1312z00_1508 = create_vector(((long) 0));
					BgL_arg1646z00_1463 = BgL_v1312z00_1508;
				}
				BGl_ev_setglobalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2509z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 62117),
					BGl_proc2508z00zz__evaluate_typesz00,
					BGl_proc2507z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2506z00zz__evaluate_typesz00, BFALSE, BgL_arg1645z00_1462,
					BgL_arg1646z00_1463);
			}
			{	/* Eval/evaluate_types.scm 82 */
				obj_t BgL_arg1682z00_1515;
				obj_t BgL_arg1685z00_1516;

				{	/* Eval/evaluate_types.scm 82 */
					obj_t BgL_v1313z00_1530;

					BgL_v1313z00_1530 = create_vector(((long) 0));
					BgL_arg1682z00_1515 = BgL_v1313z00_1530;
				}
				{	/* Eval/evaluate_types.scm 82 */
					obj_t BgL_v1314z00_1531;

					BgL_v1314z00_1531 = create_vector(((long) 0));
					BgL_arg1685z00_1516 = BgL_v1314z00_1531;
				}
				BGl_ev_defglobalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2514z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_setglobalz00zz__evaluate_typesz00, ((long) 36158),
					BGl_proc2513z00zz__evaluate_typesz00,
					BGl_proc2512z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2511z00zz__evaluate_typesz00, BFALSE, BgL_arg1682z00_1515,
					BgL_arg1685z00_1516);
			}
			{	/* Eval/evaluate_types.scm 83 */
				obj_t BgL_arg1704z00_1538;
				obj_t BgL_arg1705z00_1539;

				{	/* Eval/evaluate_types.scm 83 */
					obj_t BgL_v1315z00_1551;

					BgL_v1315z00_1551 = create_vector(((long) 2));
					VECTOR_SET(BgL_v1315z00_1551, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2518z00zz__evaluate_typesz00,
							BGl_proc2517z00zz__evaluate_typesz00,
							BGl_proc2516z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1315z00_1551, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2522z00zz__evaluate_typesz00,
							BGl_proc2521z00zz__evaluate_typesz00,
							BGl_proc2520z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1704z00_1538 = BgL_v1315z00_1551;
				}
				{	/* Eval/evaluate_types.scm 83 */
					obj_t BgL_v1316z00_1572;

					BgL_v1316z00_1572 = create_vector(((long) 0));
					BgL_arg1705z00_1539 = BgL_v1316z00_1572;
				}
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2527z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 10723),
					BGl_proc2526z00zz__evaluate_typesz00,
					BGl_proc2525z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2524z00zz__evaluate_typesz00, BFALSE, BgL_arg1704z00_1538,
					BgL_arg1705z00_1539);
			}
			{	/* Eval/evaluate_types.scm 86 */
				obj_t BgL_arg1726z00_1579;
				obj_t BgL_arg1727z00_1580;

				{	/* Eval/evaluate_types.scm 86 */
					obj_t BgL_v1317z00_1592;

					BgL_v1317z00_1592 = create_vector(((long) 2));
					VECTOR_SET(BgL_v1317z00_1592, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2440z00zz__evaluate_typesz00,
							BGl_proc2530z00zz__evaluate_typesz00,
							BGl_proc2529z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1317z00_1592, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2522z00zz__evaluate_typesz00,
							BGl_proc2532z00zz__evaluate_typesz00,
							BGl_proc2531z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1726z00_1579 = BgL_v1317z00_1592;
				}
				{	/* Eval/evaluate_types.scm 86 */
					obj_t BgL_v1318z00_1613;

					BgL_v1318z00_1613 = create_vector(((long) 0));
					BgL_arg1727z00_1580 = BgL_v1318z00_1613;
				}
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2536z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 59644),
					BGl_proc2535z00zz__evaluate_typesz00,
					BGl_proc2534z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2533z00zz__evaluate_typesz00, BFALSE, BgL_arg1726z00_1579,
					BgL_arg1727z00_1580);
			}
			{	/* Eval/evaluate_types.scm 89 */
				obj_t BgL_arg1747z00_1620;
				obj_t BgL_arg1748z00_1621;

				{	/* Eval/evaluate_types.scm 89 */
					obj_t BgL_v1319z00_1633;

					BgL_v1319z00_1633 = create_vector(((long) 2));
					VECTOR_SET(BgL_v1319z00_1633, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2540z00zz__evaluate_typesz00,
							BGl_proc2539z00zz__evaluate_typesz00,
							BGl_proc2538z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1319z00_1633, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2522z00zz__evaluate_typesz00,
							BGl_proc2543z00zz__evaluate_typesz00,
							BGl_proc2542z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1747z00_1620 = BgL_v1319z00_1633;
				}
				{	/* Eval/evaluate_types.scm 89 */
					obj_t BgL_v1320z00_1654;

					BgL_v1320z00_1654 = create_vector(((long) 0));
					BgL_arg1748z00_1621 = BgL_v1320z00_1654;
				}
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2547z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 54033),
					BGl_proc2546z00zz__evaluate_typesz00,
					BGl_proc2545z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2544z00zz__evaluate_typesz00, BFALSE, BgL_arg1747z00_1620,
					BgL_arg1748z00_1621);
			}
			{	/* Eval/evaluate_types.scm 92 */
				obj_t BgL_arg1769z00_1661;
				obj_t BgL_arg1770z00_1662;

				{	/* Eval/evaluate_types.scm 92 */
					obj_t BgL_v1321z00_1676;

					BgL_v1321z00_1676 = create_vector(((long) 4));
					VECTOR_SET(BgL_v1321z00_1676, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2408z00zz__evaluate_typesz00,
							BGl_proc2550z00zz__evaluate_typesz00,
							BGl_proc2549z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1321z00_1676, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2553z00zz__evaluate_typesz00,
							BGl_proc2552z00zz__evaluate_typesz00,
							BGl_proc2551z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1321z00_1676, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2557z00zz__evaluate_typesz00,
							BGl_proc2556z00zz__evaluate_typesz00,
							BGl_proc2555z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1321z00_1676, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2522z00zz__evaluate_typesz00,
							BGl_proc2560z00zz__evaluate_typesz00,
							BGl_proc2559z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1769z00_1661 = BgL_v1321z00_1676;
				}
				{	/* Eval/evaluate_types.scm 92 */
					obj_t BgL_v1322z00_1717;

					BgL_v1322z00_1717 = create_vector(((long) 0));
					BgL_arg1770z00_1662 = BgL_v1322z00_1717;
				}
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2564z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 40653),
					BGl_proc2563z00zz__evaluate_typesz00,
					BGl_proc2562z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2561z00zz__evaluate_typesz00, BFALSE, BgL_arg1769z00_1661,
					BgL_arg1770z00_1662);
			}
			{	/* Eval/evaluate_types.scm 97 */
				obj_t BgL_arg1800z00_1724;
				obj_t BgL_arg1801z00_1725;

				{	/* Eval/evaluate_types.scm 97 */
					obj_t BgL_v1323z00_1738;

					BgL_v1323z00_1738 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1323z00_1738, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2568z00zz__evaluate_typesz00,
							BGl_proc2567z00zz__evaluate_typesz00,
							BGl_proc2566z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1323z00_1738, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2572z00zz__evaluate_typesz00,
							BGl_proc2571z00zz__evaluate_typesz00,
							BGl_proc2570z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1323z00_1738, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2522z00zz__evaluate_typesz00,
							BGl_proc2575z00zz__evaluate_typesz00,
							BGl_proc2574z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1800z00_1724 = BgL_v1323z00_1738;
				}
				{	/* Eval/evaluate_types.scm 97 */
					obj_t BgL_v1324z00_1769;

					BgL_v1324z00_1769 = create_vector(((long) 0));
					BgL_arg1801z00_1725 = BgL_v1324z00_1769;
				}
				BGl_ev_binderz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2579z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 50341),
					BGl_proc2578z00zz__evaluate_typesz00,
					BGl_proc2577z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2576z00zz__evaluate_typesz00, BFALSE, BgL_arg1800z00_1724,
					BgL_arg1801z00_1725);
			}
			{	/* Eval/evaluate_types.scm 101 */
				obj_t BgL_arg1828z00_1776;
				obj_t BgL_arg1829z00_1777;

				{	/* Eval/evaluate_types.scm 101 */
					obj_t BgL_v1325z00_1791;

					BgL_v1325z00_1791 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1325z00_1791, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2584z00zz__evaluate_typesz00,
							BGl_proc2583z00zz__evaluate_typesz00,
							BGl_proc2582z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2581z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1828z00_1776 = BgL_v1325z00_1791;
				}
				{	/* Eval/evaluate_types.scm 101 */
					obj_t BgL_v1326z00_1805;

					BgL_v1326z00_1805 = create_vector(((long) 0));
					BgL_arg1829z00_1777 = BgL_v1326z00_1805;
				}
				BGl_ev_letz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2589z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 20484),
					BGl_proc2588z00zz__evaluate_typesz00,
					BGl_proc2587z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2586z00zz__evaluate_typesz00, BFALSE, BgL_arg1828z00_1776,
					BgL_arg1829z00_1777);
			}
			{	/* Eval/evaluate_types.scm 103 */
				obj_t BgL_arg1850z00_1812;
				obj_t BgL_arg1851z00_1813;

				{	/* Eval/evaluate_types.scm 103 */
					obj_t BgL_v1327z00_1827;

					BgL_v1327z00_1827 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1327z00_1827, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2584z00zz__evaluate_typesz00,
							BGl_proc2593z00zz__evaluate_typesz00,
							BGl_proc2592z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2591z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1850z00_1812 = BgL_v1327z00_1827;
				}
				{	/* Eval/evaluate_types.scm 103 */
					obj_t BgL_v1328z00_1841;

					BgL_v1328z00_1841 = create_vector(((long) 0));
					BgL_arg1851z00_1813 = BgL_v1328z00_1841;
				}
				BGl_ev_letza2za2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2597z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 9906),
					BGl_proc2596z00zz__evaluate_typesz00,
					BGl_proc2595z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2594z00zz__evaluate_typesz00, BFALSE, BgL_arg1850z00_1812,
					BgL_arg1851z00_1813);
			}
			{	/* Eval/evaluate_types.scm 105 */
				obj_t BgL_arg1872z00_1848;
				obj_t BgL_arg1873z00_1849;

				{	/* Eval/evaluate_types.scm 105 */
					obj_t BgL_v1329z00_1862;

					BgL_v1329z00_1862 = create_vector(((long) 0));
					BgL_arg1872z00_1848 = BgL_v1329z00_1862;
				}
				{	/* Eval/evaluate_types.scm 105 */
					obj_t BgL_v1330z00_1863;

					BgL_v1330z00_1863 = create_vector(((long) 0));
					BgL_arg1873z00_1849 = BgL_v1330z00_1863;
				}
				BGl_ev_letrecz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2602z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 43956),
					BGl_proc2601z00zz__evaluate_typesz00,
					BGl_proc2600z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2599z00zz__evaluate_typesz00, BFALSE, BgL_arg1872z00_1848,
					BgL_arg1873z00_1849);
			}
			{	/* Eval/evaluate_types.scm 106 */
				obj_t BgL_arg1886z00_1870;
				obj_t BgL_arg1887z00_1871;

				{	/* Eval/evaluate_types.scm 106 */
					obj_t BgL_v1331z00_1887;

					BgL_v1331z00_1887 = create_vector(((long) 6));
					VECTOR_SET(BgL_v1331z00_1887, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2568z00zz__evaluate_typesz00,
							BGl_proc2605z00zz__evaluate_typesz00,
							BGl_proc2604z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_1887, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2572z00zz__evaluate_typesz00,
							BGl_proc2607z00zz__evaluate_typesz00,
							BGl_proc2606z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_1887, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2611z00zz__evaluate_typesz00,
							BGl_proc2610z00zz__evaluate_typesz00,
							BGl_proc2609z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2608z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_1887, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2616z00zz__evaluate_typesz00,
							BGl_proc2615z00zz__evaluate_typesz00,
							BGl_proc2614z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2613z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_1887, ((long) 4),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2522z00zz__evaluate_typesz00,
							BGl_proc2619z00zz__evaluate_typesz00,
							BGl_proc2618z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1331z00_1887, ((long) 5),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2584z00zz__evaluate_typesz00,
							BGl_proc2622z00zz__evaluate_typesz00,
							BGl_proc2621z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2620z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1886z00_1870 = BgL_v1331z00_1887;
				}
				{	/* Eval/evaluate_types.scm 106 */
					obj_t BgL_v1332z00_1957;

					BgL_v1332z00_1957 = create_vector(((long) 0));
					BgL_arg1887z00_1871 = BgL_v1332z00_1957;
				}
				BGl_ev_labelsz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2626z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 51941),
					BGl_proc2625z00zz__evaluate_typesz00,
					BGl_proc2624z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2623z00zz__evaluate_typesz00, BFALSE, BgL_arg1886z00_1870,
					BgL_arg1887z00_1871);
			}
			{	/* Eval/evaluate_types.scm 114 */
				obj_t BgL_arg1936z00_1964;
				obj_t BgL_arg1937z00_1965;

				{	/* Eval/evaluate_types.scm 114 */
					obj_t BgL_v1333z00_1979;

					BgL_v1333z00_1979 = create_vector(((long) 4));
					VECTOR_SET(BgL_v1333z00_1979, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2408z00zz__evaluate_typesz00,
							BGl_proc2629z00zz__evaluate_typesz00,
							BGl_proc2628z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1333z00_1979, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2632z00zz__evaluate_typesz00,
							BGl_proc2631z00zz__evaluate_typesz00,
							BGl_proc2630z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1333z00_1979, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2636z00zz__evaluate_typesz00,
							BGl_proc2635z00zz__evaluate_typesz00,
							BGl_proc2634z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_labelsz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1333z00_1979, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2449z00zz__evaluate_typesz00,
							BGl_proc2639z00zz__evaluate_typesz00,
							BGl_proc2638z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1936z00_1964 = BgL_v1333z00_1979;
				}
				{	/* Eval/evaluate_types.scm 114 */
					obj_t BgL_v1334z00_2020;

					BgL_v1334z00_2020 = create_vector(((long) 0));
					BgL_arg1937z00_1965 = BgL_v1334z00_2020;
				}
				BGl_ev_gotoz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2643z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 25746),
					BGl_proc2642z00zz__evaluate_typesz00,
					BGl_proc2641z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2640z00zz__evaluate_typesz00, BFALSE, BgL_arg1936z00_1964,
					BgL_arg1937z00_1965);
			}
			{	/* Eval/evaluate_types.scm 119 */
				obj_t BgL_arg1966z00_2027;
				obj_t BgL_arg1967z00_2028;

				{	/* Eval/evaluate_types.scm 119 */
					obj_t BgL_v1335z00_2042;

					BgL_v1335z00_2042 = create_vector(((long) 4));
					VECTOR_SET(BgL_v1335z00_2042, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2408z00zz__evaluate_typesz00,
							BGl_proc2646z00zz__evaluate_typesz00,
							BGl_proc2645z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1335z00_2042, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2649z00zz__evaluate_typesz00,
							BGl_proc2648z00zz__evaluate_typesz00,
							BGl_proc2647z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1335z00_2042, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2449z00zz__evaluate_typesz00,
							BGl_proc2652z00zz__evaluate_typesz00,
							BGl_proc2651z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1335z00_2042, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2655z00zz__evaluate_typesz00,
							BGl_proc2654z00zz__evaluate_typesz00,
							BGl_proc2653z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1966z00_2027 = BgL_v1335z00_2042;
				}
				{	/* Eval/evaluate_types.scm 119 */
					obj_t BgL_v1336z00_2083;

					BgL_v1336z00_2083 = create_vector(((long) 0));
					BgL_arg1967z00_2028 = BgL_v1336z00_2083;
				}
				BGl_ev_appz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2660z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 55822),
					BGl_proc2659z00zz__evaluate_typesz00,
					BGl_proc2658z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2657z00zz__evaluate_typesz00, BFALSE, BgL_arg1966z00_2027,
					BgL_arg1967z00_2028);
			}
			{	/* Eval/evaluate_types.scm 122 */
				obj_t BgL_arg1997z00_2090;
				obj_t BgL_arg1998z00_2091;

				{	/* Eval/evaluate_types.scm 122 */
					obj_t BgL_v1337z00_2111;

					BgL_v1337z00_2111 = create_vector(((long) 10));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2408z00zz__evaluate_typesz00,
							BGl_proc2663z00zz__evaluate_typesz00,
							BGl_proc2662z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2666z00zz__evaluate_typesz00,
							BGl_proc2665z00zz__evaluate_typesz00,
							BGl_proc2664z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2670z00zz__evaluate_typesz00,
							BGl_proc2669z00zz__evaluate_typesz00,
							BGl_proc2668z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2568z00zz__evaluate_typesz00,
							BGl_proc2673z00zz__evaluate_typesz00,
							BGl_proc2672z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 4),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2522z00zz__evaluate_typesz00,
							BGl_proc2675z00zz__evaluate_typesz00,
							BGl_proc2674z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 5),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2679z00zz__evaluate_typesz00,
							BGl_proc2678z00zz__evaluate_typesz00,
							BGl_proc2677z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2676z00zz__evaluate_typesz00,
							BGl_symbol2681z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 6),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2686z00zz__evaluate_typesz00,
							BGl_proc2685z00zz__evaluate_typesz00,
							BGl_proc2684z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2683z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 7),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2691z00zz__evaluate_typesz00,
							BGl_proc2690z00zz__evaluate_typesz00,
							BGl_proc2689z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2688z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 8),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2696z00zz__evaluate_typesz00,
							BGl_proc2695z00zz__evaluate_typesz00,
							BGl_proc2694z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2693z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1337z00_2111, ((long) 9),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2584z00zz__evaluate_typesz00,
							BGl_proc2700z00zz__evaluate_typesz00,
							BGl_proc2699z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2698z00zz__evaluate_typesz00,
							BGl_symbol2395z00zz__evaluate_typesz00));
					BgL_arg1997z00_2090 = BgL_v1337z00_2111;
				}
				{	/* Eval/evaluate_types.scm 122 */
					obj_t BgL_v1338z00_2227;

					BgL_v1338z00_2227 = create_vector(((long) 0));
					BgL_arg1998z00_2091 = BgL_v1338z00_2227;
				}
				return (BGl_ev_absz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2704z00zz__evaluate_typesz00,
						BGl_symbol2382z00zz__evaluate_typesz00,
						BGl_ev_exprz00zz__evaluate_typesz00, ((long) 22827),
						BGl_proc2703z00zz__evaluate_typesz00,
						BGl_proc2702z00zz__evaluate_typesz00, BFALSE,
						BGl_proc2701z00zz__evaluate_typesz00, BFALSE, BgL_arg1997z00_2090,
						BgL_arg1998z00_2091), BUNSPEC);
		}}

	}



/* &<@anonymous:2003> */
	obj_t BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3415, obj_t BgL_new1194z00_3416)
	{
		{	/* Eval/evaluate_types.scm 122 */
			{
				BgL_ev_absz00_bglt BgL_auxz00_4545;

				((((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_new1194z00_3416)))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1194z00_3416)))->BgL_wherez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1194z00_3416)))->BgL_arityz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1194z00_3416)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4554;

					{	/* Eval/evaluate_types.scm 122 */
						obj_t BgL_classz00_3891;

						BgL_classz00_3891 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 122 */
							obj_t BgL__ortest_1286z00_3892;

							BgL__ortest_1286z00_3892 = BGL_CLASS_NIL(BgL_classz00_3891);
							if (CBOOL(BgL__ortest_1286z00_3892))
								{	/* Eval/evaluate_types.scm 122 */
									BgL_auxz00_4554 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_3892);
								}
							else
								{	/* Eval/evaluate_types.scm 122 */
									BgL_auxz00_4554 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3891));
								}
						}
					}
					((((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_new1194z00_3416)))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4554), BUNSPEC);
				}
				((((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_new1194z00_3416)))->BgL_siza7eza7) =
					((int) (int) (((long) 0))), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1194z00_3416)))->BgL_bindz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1194z00_3416)))->BgL_freez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1194z00_3416)))->BgL_innerz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1194z00_3416)))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4545 = ((BgL_ev_absz00_bglt) BgL_new1194z00_3416);
				return ((obj_t) BgL_auxz00_4545);
			}
		}

	}



/* &lambda2001 */
	BgL_ev_absz00_bglt BGl_z62lambda2001z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3417)
	{
		{	/* Eval/evaluate_types.scm 122 */
			{	/* Eval/evaluate_types.scm 122 */
				BgL_ev_absz00_bglt BgL_new1193z00_3893;

				BgL_new1193z00_3893 =
					((BgL_ev_absz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_absz00_bgl))));
				{	/* Eval/evaluate_types.scm 122 */
					long BgL_arg2002z00_3894;

					BgL_arg2002z00_3894 =
						BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1193z00_3893), BgL_arg2002z00_3894);
				}
				return BgL_new1193z00_3893;
			}
		}

	}



/* &lambda1999 */
	BgL_ev_absz00_bglt BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3418, obj_t BgL_loc1183z00_3419, obj_t BgL_where1184z00_3420,
		obj_t BgL_arity1185z00_3421, obj_t BgL_vars1186z00_3422,
		obj_t BgL_body1187z00_3423, obj_t BgL_siza7e1188za7_3424,
		obj_t BgL_bind1189z00_3425, obj_t BgL_free1190z00_3426,
		obj_t BgL_inner1191z00_3427, obj_t BgL_boxes1192z00_3428)
	{
		{	/* Eval/evaluate_types.scm 122 */
			{	/* Eval/evaluate_types.scm 122 */
				int BgL_siza7e1188za7_3896;

				BgL_siza7e1188za7_3896 = CINT(BgL_siza7e1188za7_3424);
				{	/* Eval/evaluate_types.scm 122 */
					BgL_ev_absz00_bglt BgL_new1247z00_3897;

					{	/* Eval/evaluate_types.scm 122 */
						BgL_ev_absz00_bglt BgL_new1245z00_3898;

						BgL_new1245z00_3898 =
							((BgL_ev_absz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_ev_absz00_bgl))));
						{	/* Eval/evaluate_types.scm 122 */
							long BgL_arg2000z00_3899;

							BgL_arg2000z00_3899 =
								BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1245z00_3898),
								BgL_arg2000z00_3899);
						}
						BgL_new1247z00_3897 = BgL_new1245z00_3898;
					}
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_locz00) =
						((obj_t) BgL_loc1183z00_3419), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_wherez00) =
						((obj_t) BgL_where1184z00_3420), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_arityz00) =
						((obj_t) BgL_arity1185z00_3421), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_varsz00) =
						((obj_t) BgL_vars1186z00_3422), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
								BgL_body1187z00_3423)), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->
							BgL_siza7eza7) = ((int) BgL_siza7e1188za7_3896), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_bindz00) =
						((obj_t) BgL_bind1189z00_3425), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_freez00) =
						((obj_t) BgL_free1190z00_3426), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_innerz00) =
						((obj_t) BgL_inner1191z00_3427), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1247z00_3897))->BgL_boxesz00) =
						((obj_t) BgL_boxes1192z00_3428), BUNSPEC);
					return BgL_new1247z00_3897;
				}
			}
		}

	}



/* &<@anonymous:2070> */
	obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3429)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}

	}



/* &lambda2069 */
	obj_t BGl_z62lambda2069z62zz__evaluate_typesz00(obj_t BgL_envz00_3430,
		obj_t BgL_oz00_3431, obj_t BgL_vz00_3432)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3431)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3432), BUNSPEC);
		}

	}



/* &lambda2068 */
	obj_t BGl_z62lambda2068z62zz__evaluate_typesz00(obj_t BgL_envz00_3433,
		obj_t BgL_oz00_3434)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3434)))->BgL_boxesz00);
		}

	}



/* &<@anonymous:2062> */
	obj_t BGl_z62zc3z04anonymousza32062ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3435)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}

	}



/* &lambda2061 */
	obj_t BGl_z62lambda2061z62zz__evaluate_typesz00(obj_t BgL_envz00_3436,
		obj_t BgL_oz00_3437, obj_t BgL_vz00_3438)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3437)))->BgL_innerz00) =
				((obj_t) BgL_vz00_3438), BUNSPEC);
		}

	}



/* &lambda2060 */
	obj_t BGl_z62lambda2060z62zz__evaluate_typesz00(obj_t BgL_envz00_3439,
		obj_t BgL_oz00_3440)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3440)))->BgL_innerz00);
		}

	}



/* &<@anonymous:2055> */
	obj_t BGl_z62zc3z04anonymousza32055ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3441)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}

	}



/* &lambda2054 */
	obj_t BGl_z62lambda2054z62zz__evaluate_typesz00(obj_t BgL_envz00_3442,
		obj_t BgL_oz00_3443, obj_t BgL_vz00_3444)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3443)))->BgL_freez00) =
				((obj_t) BgL_vz00_3444), BUNSPEC);
		}

	}



/* &lambda2053 */
	obj_t BGl_z62lambda2053z62zz__evaluate_typesz00(obj_t BgL_envz00_3445,
		obj_t BgL_oz00_3446)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3446)))->BgL_freez00);
		}

	}



/* &<@anonymous:2047> */
	obj_t BGl_z62zc3z04anonymousza32047ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3447)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}

	}



/* &lambda2046 */
	obj_t BGl_z62lambda2046z62zz__evaluate_typesz00(obj_t BgL_envz00_3448,
		obj_t BgL_oz00_3449, obj_t BgL_vz00_3450)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3449)))->BgL_bindz00) =
				((obj_t) BgL_vz00_3450), BUNSPEC);
		}

	}



/* &lambda2045 */
	obj_t BGl_z62lambda2045z62zz__evaluate_typesz00(obj_t BgL_envz00_3451,
		obj_t BgL_oz00_3452)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3452)))->BgL_bindz00);
		}

	}



/* &<@anonymous:2039> */
	obj_t BGl_z62zc3z04anonymousza32039ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3453)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return BINT(((long) 0));
		}

	}



/* &lambda2038 */
	obj_t BGl_z62lambda2038z62zz__evaluate_typesz00(obj_t BgL_envz00_3454,
		obj_t BgL_oz00_3455, obj_t BgL_vz00_3456)
	{
		{	/* Eval/evaluate_types.scm 122 */
			{	/* Eval/evaluate_types.scm 122 */
				int BgL_vz00_3909;

				BgL_vz00_3909 = CINT(BgL_vz00_3456);
				return
					((((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_oz00_3455)))->BgL_siza7eza7) =
					((int) BgL_vz00_3909), BUNSPEC);
		}}

	}



/* &lambda2037 */
	obj_t BGl_z62lambda2037z62zz__evaluate_typesz00(obj_t BgL_envz00_3457,
		obj_t BgL_oz00_3458)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				BINT(
				(((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3458)))->BgL_siza7eza7));
		}

	}



/* &lambda2031 */
	obj_t BGl_z62lambda2031z62zz__evaluate_typesz00(obj_t BgL_envz00_3459,
		obj_t BgL_oz00_3460, obj_t BgL_vz00_3461)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3460)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3461)), BUNSPEC);
		}

	}



/* &lambda2030 */
	BgL_ev_exprz00_bglt BGl_z62lambda2030z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3462, obj_t BgL_oz00_3463)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3463)))->BgL_bodyz00);
		}

	}



/* &lambda2026 */
	obj_t BGl_z62lambda2026z62zz__evaluate_typesz00(obj_t BgL_envz00_3464,
		obj_t BgL_oz00_3465, obj_t BgL_vz00_3466)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3465)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3466), BUNSPEC);
		}

	}



/* &lambda2025 */
	obj_t BGl_z62lambda2025z62zz__evaluate_typesz00(obj_t BgL_envz00_3467,
		obj_t BgL_oz00_3468)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3468)))->BgL_varsz00);
		}

	}



/* &lambda2021 */
	obj_t BGl_z62lambda2021z62zz__evaluate_typesz00(obj_t BgL_envz00_3469,
		obj_t BgL_oz00_3470, obj_t BgL_vz00_3471)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3470)))->BgL_arityz00) =
				((obj_t) BgL_vz00_3471), BUNSPEC);
		}

	}



/* &lambda2020 */
	obj_t BGl_z62lambda2020z62zz__evaluate_typesz00(obj_t BgL_envz00_3472,
		obj_t BgL_oz00_3473)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3473)))->BgL_arityz00);
		}

	}



/* &lambda2015 */
	obj_t BGl_z62lambda2015z62zz__evaluate_typesz00(obj_t BgL_envz00_3474,
		obj_t BgL_oz00_3475, obj_t BgL_vz00_3476)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3475)))->BgL_wherez00) =
				((obj_t) BgL_vz00_3476), BUNSPEC);
		}

	}



/* &lambda2014 */
	obj_t BGl_z62lambda2014z62zz__evaluate_typesz00(obj_t BgL_envz00_3477,
		obj_t BgL_oz00_3478)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3478)))->BgL_wherez00);
		}

	}



/* &lambda2008 */
	obj_t BGl_z62lambda2008z62zz__evaluate_typesz00(obj_t BgL_envz00_3479,
		obj_t BgL_oz00_3480, obj_t BgL_vz00_3481)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3480)))->BgL_locz00) =
				((obj_t) BgL_vz00_3481), BUNSPEC);
		}

	}



/* &lambda2007 */
	obj_t BGl_z62lambda2007z62zz__evaluate_typesz00(obj_t BgL_envz00_3482,
		obj_t BgL_oz00_3483)
	{
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3483)))->BgL_locz00);
		}

	}



/* &<@anonymous:1972> */
	obj_t BGl_z62zc3z04anonymousza31972ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3484, obj_t BgL_new1181z00_3485)
	{
		{	/* Eval/evaluate_types.scm 119 */
			{
				BgL_ev_appz00_bglt BgL_auxz00_4640;

				((((BgL_ev_appz00_bglt) COBJECT(
								((BgL_ev_appz00_bglt) BgL_new1181z00_3485)))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4643;

					{	/* Eval/evaluate_types.scm 119 */
						obj_t BgL_classz00_3923;

						BgL_classz00_3923 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 119 */
							obj_t BgL__ortest_1286z00_3924;

							BgL__ortest_1286z00_3924 = BGL_CLASS_NIL(BgL_classz00_3923);
							if (CBOOL(BgL__ortest_1286z00_3924))
								{	/* Eval/evaluate_types.scm 119 */
									BgL_auxz00_4643 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_3924);
								}
							else
								{	/* Eval/evaluate_types.scm 119 */
									BgL_auxz00_4643 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3923));
								}
						}
					}
					((((BgL_ev_appz00_bglt) COBJECT(
									((BgL_ev_appz00_bglt) BgL_new1181z00_3485)))->BgL_funz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4643), BUNSPEC);
				}
				((((BgL_ev_appz00_bglt) COBJECT(
								((BgL_ev_appz00_bglt) BgL_new1181z00_3485)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
									BgL_new1181z00_3485)))->BgL_tailzf3zf3) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4640 = ((BgL_ev_appz00_bglt) BgL_new1181z00_3485);
				return ((obj_t) BgL_auxz00_4640);
			}
		}

	}



/* &lambda1970 */
	BgL_ev_appz00_bglt BGl_z62lambda1970z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3486)
	{
		{	/* Eval/evaluate_types.scm 119 */
			{	/* Eval/evaluate_types.scm 119 */
				BgL_ev_appz00_bglt BgL_new1180z00_3925;

				BgL_new1180z00_3925 =
					((BgL_ev_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_appz00_bgl))));
				{	/* Eval/evaluate_types.scm 119 */
					long BgL_arg1971z00_3926;

					BgL_arg1971z00_3926 =
						BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1180z00_3925), BgL_arg1971z00_3926);
				}
				return BgL_new1180z00_3925;
			}
		}

	}



/* &lambda1968 */
	BgL_ev_appz00_bglt BGl_z62lambda1968z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3487, obj_t BgL_loc1175z00_3488, obj_t BgL_fun1176z00_3489,
		obj_t BgL_args1177z00_3490, obj_t BgL_tailzf31178zf3_3491)
	{
		{	/* Eval/evaluate_types.scm 119 */
			{	/* Eval/evaluate_types.scm 119 */
				BgL_ev_appz00_bglt BgL_new1244z00_3928;

				{	/* Eval/evaluate_types.scm 119 */
					BgL_ev_appz00_bglt BgL_new1243z00_3929;

					BgL_new1243z00_3929 =
						((BgL_ev_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_appz00_bgl))));
					{	/* Eval/evaluate_types.scm 119 */
						long BgL_arg1969z00_3930;

						BgL_arg1969z00_3930 =
							BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1243z00_3929), BgL_arg1969z00_3930);
					}
					BgL_new1244z00_3928 = BgL_new1243z00_3929;
				}
				((((BgL_ev_appz00_bglt) COBJECT(BgL_new1244z00_3928))->BgL_locz00) =
					((obj_t) BgL_loc1175z00_3488), BUNSPEC);
				((((BgL_ev_appz00_bglt) COBJECT(BgL_new1244z00_3928))->BgL_funz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_fun1176z00_3489)),
					BUNSPEC);
				((((BgL_ev_appz00_bglt) COBJECT(BgL_new1244z00_3928))->BgL_argsz00) =
					((obj_t) BgL_args1177z00_3490), BUNSPEC);
				((((BgL_ev_appz00_bglt) COBJECT(BgL_new1244z00_3928))->BgL_tailzf3zf3) =
					((obj_t) BgL_tailzf31178zf3_3491), BUNSPEC);
				return BgL_new1244z00_3928;
			}
		}

	}



/* &lambda1993 */
	obj_t BGl_z62lambda1993z62zz__evaluate_typesz00(obj_t BgL_envz00_3492,
		obj_t BgL_oz00_3493, obj_t BgL_vz00_3494)
	{
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) COBJECT(
							((BgL_ev_appz00_bglt) BgL_oz00_3493)))->BgL_tailzf3zf3) =
				((obj_t) BgL_vz00_3494), BUNSPEC);
		}

	}



/* &lambda1992 */
	obj_t BGl_z62lambda1992z62zz__evaluate_typesz00(obj_t BgL_envz00_3495,
		obj_t BgL_oz00_3496)
	{
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) COBJECT(
						((BgL_ev_appz00_bglt) BgL_oz00_3496)))->BgL_tailzf3zf3);
		}

	}



/* &lambda1988 */
	obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t BgL_envz00_3497,
		obj_t BgL_oz00_3498, obj_t BgL_vz00_3499)
	{
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) COBJECT(
							((BgL_ev_appz00_bglt) BgL_oz00_3498)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3499), BUNSPEC);
		}

	}



/* &lambda1987 */
	obj_t BGl_z62lambda1987z62zz__evaluate_typesz00(obj_t BgL_envz00_3500,
		obj_t BgL_oz00_3501)
	{
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) COBJECT(
						((BgL_ev_appz00_bglt) BgL_oz00_3501)))->BgL_argsz00);
		}

	}



/* &lambda1983 */
	obj_t BGl_z62lambda1983z62zz__evaluate_typesz00(obj_t BgL_envz00_3502,
		obj_t BgL_oz00_3503, obj_t BgL_vz00_3504)
	{
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) COBJECT(
							((BgL_ev_appz00_bglt) BgL_oz00_3503)))->BgL_funz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3504)), BUNSPEC);
		}

	}



/* &lambda1982 */
	BgL_ev_exprz00_bglt BGl_z62lambda1982z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3505, obj_t BgL_oz00_3506)
	{
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) COBJECT(
						((BgL_ev_appz00_bglt) BgL_oz00_3506)))->BgL_funz00);
		}

	}



/* &lambda1977 */
	obj_t BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t BgL_envz00_3507,
		obj_t BgL_oz00_3508, obj_t BgL_vz00_3509)
	{
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) COBJECT(
							((BgL_ev_appz00_bglt) BgL_oz00_3508)))->BgL_locz00) =
				((obj_t) BgL_vz00_3509), BUNSPEC);
		}

	}



/* &lambda1976 */
	obj_t BGl_z62lambda1976z62zz__evaluate_typesz00(obj_t BgL_envz00_3510,
		obj_t BgL_oz00_3511)
	{
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) COBJECT(
						((BgL_ev_appz00_bglt) BgL_oz00_3511)))->BgL_locz00);
		}

	}



/* &<@anonymous:1942> */
	obj_t BGl_z62zc3z04anonymousza31942ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3512, obj_t BgL_new1173z00_3513)
	{
		{	/* Eval/evaluate_types.scm 114 */
			{
				BgL_ev_gotoz00_bglt BgL_auxz00_4688;

				((((BgL_ev_gotoz00_bglt) COBJECT(
								((BgL_ev_gotoz00_bglt) BgL_new1173z00_3513)))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_varz00_bglt BgL_auxz00_4691;

					{	/* Eval/evaluate_types.scm 114 */
						obj_t BgL_classz00_3941;

						BgL_classz00_3941 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 114 */
							obj_t BgL__ortest_1286z00_3942;

							BgL__ortest_1286z00_3942 = BGL_CLASS_NIL(BgL_classz00_3941);
							if (CBOOL(BgL__ortest_1286z00_3942))
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4691 =
										((BgL_ev_varz00_bglt) BgL__ortest_1286z00_3942);
								}
							else
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4691 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3941));
								}
						}
					}
					((((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_new1173z00_3513)))->BgL_labelz00) =
						((BgL_ev_varz00_bglt) BgL_auxz00_4691), BUNSPEC);
				}
				{
					BgL_ev_labelsz00_bglt BgL_auxz00_4700;

					{	/* Eval/evaluate_types.scm 114 */
						obj_t BgL_classz00_3943;

						BgL_classz00_3943 = BGl_ev_labelsz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 114 */
							obj_t BgL__ortest_1286z00_3944;

							BgL__ortest_1286z00_3944 = BGL_CLASS_NIL(BgL_classz00_3943);
							if (CBOOL(BgL__ortest_1286z00_3944))
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4700 =
										((BgL_ev_labelsz00_bglt) BgL__ortest_1286z00_3944);
								}
							else
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4700 =
										((BgL_ev_labelsz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3943));
								}
						}
					}
					((((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_new1173z00_3513)))->
							BgL_labelsz00) =
						((BgL_ev_labelsz00_bglt) BgL_auxz00_4700), BUNSPEC);
				}
				((((BgL_ev_gotoz00_bglt) COBJECT(
								((BgL_ev_gotoz00_bglt) BgL_new1173z00_3513)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4688 = ((BgL_ev_gotoz00_bglt) BgL_new1173z00_3513);
				return ((obj_t) BgL_auxz00_4688);
			}
		}

	}



/* &lambda1940 */
	BgL_ev_gotoz00_bglt BGl_z62lambda1940z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3514)
	{
		{	/* Eval/evaluate_types.scm 114 */
			{	/* Eval/evaluate_types.scm 114 */
				BgL_ev_gotoz00_bglt BgL_new1172z00_3945;

				BgL_new1172z00_3945 =
					((BgL_ev_gotoz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_gotoz00_bgl))));
				{	/* Eval/evaluate_types.scm 114 */
					long BgL_arg1941z00_3946;

					BgL_arg1941z00_3946 =
						BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1172z00_3945), BgL_arg1941z00_3946);
				}
				return BgL_new1172z00_3945;
			}
		}

	}



/* &lambda1938 */
	BgL_ev_gotoz00_bglt BGl_z62lambda1938z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3515, obj_t BgL_loc1168z00_3516, obj_t BgL_label1169z00_3517,
		obj_t BgL_labels1170z00_3518, obj_t BgL_args1171z00_3519)
	{
		{	/* Eval/evaluate_types.scm 114 */
			{	/* Eval/evaluate_types.scm 114 */
				BgL_ev_gotoz00_bglt BgL_new1242z00_3949;

				{	/* Eval/evaluate_types.scm 114 */
					BgL_ev_gotoz00_bglt BgL_new1241z00_3950;

					BgL_new1241z00_3950 =
						((BgL_ev_gotoz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_gotoz00_bgl))));
					{	/* Eval/evaluate_types.scm 114 */
						long BgL_arg1939z00_3951;

						BgL_arg1939z00_3951 =
							BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1241z00_3950), BgL_arg1939z00_3951);
					}
					BgL_new1242z00_3949 = BgL_new1241z00_3950;
				}
				((((BgL_ev_gotoz00_bglt) COBJECT(BgL_new1242z00_3949))->BgL_locz00) =
					((obj_t) BgL_loc1168z00_3516), BUNSPEC);
				((((BgL_ev_gotoz00_bglt) COBJECT(BgL_new1242z00_3949))->BgL_labelz00) =
					((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_label1169z00_3517)),
					BUNSPEC);
				((((BgL_ev_gotoz00_bglt) COBJECT(BgL_new1242z00_3949))->BgL_labelsz00) =
					((BgL_ev_labelsz00_bglt) ((BgL_ev_labelsz00_bglt)
							BgL_labels1170z00_3518)), BUNSPEC);
				((((BgL_ev_gotoz00_bglt) COBJECT(BgL_new1242z00_3949))->BgL_argsz00) =
					((obj_t) BgL_args1171z00_3519), BUNSPEC);
				return BgL_new1242z00_3949;
			}
		}

	}



/* &lambda1962 */
	obj_t BGl_z62lambda1962z62zz__evaluate_typesz00(obj_t BgL_envz00_3520,
		obj_t BgL_oz00_3521, obj_t BgL_vz00_3522)
	{
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) COBJECT(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3521)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3522), BUNSPEC);
		}

	}



/* &lambda1961 */
	obj_t BGl_z62lambda1961z62zz__evaluate_typesz00(obj_t BgL_envz00_3523,
		obj_t BgL_oz00_3524)
	{
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) COBJECT(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3524)))->BgL_argsz00);
		}

	}



/* &lambda1957 */
	obj_t BGl_z62lambda1957z62zz__evaluate_typesz00(obj_t BgL_envz00_3525,
		obj_t BgL_oz00_3526, obj_t BgL_vz00_3527)
	{
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) COBJECT(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3526)))->BgL_labelsz00) =
				((BgL_ev_labelsz00_bglt) ((BgL_ev_labelsz00_bglt) BgL_vz00_3527)),
				BUNSPEC);
		}

	}



/* &lambda1956 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1956z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3528, obj_t BgL_oz00_3529)
	{
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) COBJECT(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3529)))->BgL_labelsz00);
		}

	}



/* &lambda1952 */
	obj_t BGl_z62lambda1952z62zz__evaluate_typesz00(obj_t BgL_envz00_3530,
		obj_t BgL_oz00_3531, obj_t BgL_vz00_3532)
	{
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) COBJECT(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3531)))->BgL_labelz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3532)), BUNSPEC);
		}

	}



/* &lambda1951 */
	BgL_ev_varz00_bglt BGl_z62lambda1951z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3533, obj_t BgL_oz00_3534)
	{
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) COBJECT(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3534)))->BgL_labelz00);
		}

	}



/* &lambda1947 */
	obj_t BGl_z62lambda1947z62zz__evaluate_typesz00(obj_t BgL_envz00_3535,
		obj_t BgL_oz00_3536, obj_t BgL_vz00_3537)
	{
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) COBJECT(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3536)))->BgL_locz00) =
				((obj_t) BgL_vz00_3537), BUNSPEC);
		}

	}



/* &lambda1946 */
	obj_t BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t BgL_envz00_3538,
		obj_t BgL_oz00_3539)
	{
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) COBJECT(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3539)))->BgL_locz00);
		}

	}



/* &<@anonymous:1892> */
	obj_t BGl_z62zc3z04anonymousza31892ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3540, obj_t BgL_new1166z00_3541)
	{
		{	/* Eval/evaluate_types.scm 106 */
			{
				BgL_ev_labelsz00_bglt BgL_auxz00_4745;

				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_new1166z00_3541)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(((BgL_ev_labelsz00_bglt)
									BgL_new1166z00_3541)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(((BgL_ev_labelsz00_bglt)
									BgL_new1166z00_3541)))->BgL_envz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(((BgL_ev_labelsz00_bglt)
									BgL_new1166z00_3541)))->BgL_stkz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4754;

					{	/* Eval/evaluate_types.scm 106 */
						obj_t BgL_classz00_3963;

						BgL_classz00_3963 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 106 */
							obj_t BgL__ortest_1286z00_3964;

							BgL__ortest_1286z00_3964 = BGL_CLASS_NIL(BgL_classz00_3963);
							if (CBOOL(BgL__ortest_1286z00_3964))
								{	/* Eval/evaluate_types.scm 106 */
									BgL_auxz00_4754 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_3964);
								}
							else
								{	/* Eval/evaluate_types.scm 106 */
									BgL_auxz00_4754 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3963));
								}
						}
					}
					((((BgL_ev_labelsz00_bglt) COBJECT(
									((BgL_ev_labelsz00_bglt) BgL_new1166z00_3541)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4754), BUNSPEC);
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_new1166z00_3541)))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4745 = ((BgL_ev_labelsz00_bglt) BgL_new1166z00_3541);
				return ((obj_t) BgL_auxz00_4745);
			}
		}

	}



/* &lambda1890 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1890z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3542)
	{
		{	/* Eval/evaluate_types.scm 106 */
			{	/* Eval/evaluate_types.scm 106 */
				BgL_ev_labelsz00_bglt BgL_new1165z00_3965;

				BgL_new1165z00_3965 =
					((BgL_ev_labelsz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_labelsz00_bgl))));
				{	/* Eval/evaluate_types.scm 106 */
					long BgL_arg1891z00_3966;

					BgL_arg1891z00_3966 =
						BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1165z00_3965), BgL_arg1891z00_3966);
				}
				return BgL_new1165z00_3965;
			}
		}

	}



/* &lambda1888 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1888z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3543, obj_t BgL_vars1159z00_3544, obj_t BgL_vals1160z00_3545,
		obj_t BgL_env1161z00_3546, obj_t BgL_stk1162z00_3547,
		obj_t BgL_body1163z00_3548, obj_t BgL_boxes1164z00_3549)
	{
		{	/* Eval/evaluate_types.scm 106 */
			{	/* Eval/evaluate_types.scm 106 */
				BgL_ev_labelsz00_bglt BgL_new1240z00_3968;

				{	/* Eval/evaluate_types.scm 106 */
					BgL_ev_labelsz00_bglt BgL_new1239z00_3969;

					BgL_new1239z00_3969 =
						((BgL_ev_labelsz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_labelsz00_bgl))));
					{	/* Eval/evaluate_types.scm 106 */
						long BgL_arg1889z00_3970;

						BgL_arg1889z00_3970 =
							BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1239z00_3969), BgL_arg1889z00_3970);
					}
					BgL_new1240z00_3968 = BgL_new1239z00_3969;
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1240z00_3968))->BgL_varsz00) =
					((obj_t) BgL_vars1159z00_3544), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1240z00_3968))->BgL_valsz00) =
					((obj_t) BgL_vals1160z00_3545), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1240z00_3968))->BgL_envz00) =
					((obj_t) BgL_env1161z00_3546), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1240z00_3968))->BgL_stkz00) =
					((obj_t) BgL_stk1162z00_3547), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1240z00_3968))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1163z00_3548)),
					BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1240z00_3968))->
						BgL_boxesz00) = ((obj_t) BgL_boxes1164z00_3549), BUNSPEC);
				return BgL_new1240z00_3968;
			}
		}

	}



/* &<@anonymous:1932> */
	obj_t BGl_z62zc3z04anonymousza31932ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3550)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}

	}



/* &lambda1931 */
	obj_t BGl_z62lambda1931z62zz__evaluate_typesz00(obj_t BgL_envz00_3551,
		obj_t BgL_oz00_3552, obj_t BgL_vz00_3553)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3552)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3553), BUNSPEC);
		}

	}



/* &lambda1930 */
	obj_t BGl_z62lambda1930z62zz__evaluate_typesz00(obj_t BgL_envz00_3554,
		obj_t BgL_oz00_3555)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3555)))->BgL_boxesz00);
		}

	}



/* &lambda1923 */
	obj_t BGl_z62lambda1923z62zz__evaluate_typesz00(obj_t BgL_envz00_3556,
		obj_t BgL_oz00_3557, obj_t BgL_vz00_3558)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3557)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3558)), BUNSPEC);
		}

	}



/* &lambda1922 */
	BgL_ev_exprz00_bglt BGl_z62lambda1922z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3559, obj_t BgL_oz00_3560)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3560)))->BgL_bodyz00);
		}

	}



/* &<@anonymous:1918> */
	obj_t BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3561)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}

	}



/* &lambda1917 */
	obj_t BGl_z62lambda1917z62zz__evaluate_typesz00(obj_t BgL_envz00_3562,
		obj_t BgL_oz00_3563, obj_t BgL_vz00_3564)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3563)))->BgL_stkz00) =
				((obj_t) BgL_vz00_3564), BUNSPEC);
		}

	}



/* &lambda1916 */
	obj_t BGl_z62lambda1916z62zz__evaluate_typesz00(obj_t BgL_envz00_3565,
		obj_t BgL_oz00_3566)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3566)))->BgL_stkz00);
		}

	}



/* &<@anonymous:1911> */
	obj_t BGl_z62zc3z04anonymousza31911ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3567)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}

	}



/* &lambda1910 */
	obj_t BGl_z62lambda1910z62zz__evaluate_typesz00(obj_t BgL_envz00_3568,
		obj_t BgL_oz00_3569, obj_t BgL_vz00_3570)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3569)))->BgL_envz00) =
				((obj_t) BgL_vz00_3570), BUNSPEC);
		}

	}



/* &lambda1909 */
	obj_t BGl_z62lambda1909z62zz__evaluate_typesz00(obj_t BgL_envz00_3571,
		obj_t BgL_oz00_3572)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3572)))->BgL_envz00);
		}

	}



/* &lambda1903 */
	obj_t BGl_z62lambda1903z62zz__evaluate_typesz00(obj_t BgL_envz00_3573,
		obj_t BgL_oz00_3574, obj_t BgL_vz00_3575)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3574)))->BgL_valsz00) =
				((obj_t) BgL_vz00_3575), BUNSPEC);
		}

	}



/* &lambda1902 */
	obj_t BGl_z62lambda1902z62zz__evaluate_typesz00(obj_t BgL_envz00_3576,
		obj_t BgL_oz00_3577)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3577)))->BgL_valsz00);
		}

	}



/* &lambda1897 */
	obj_t BGl_z62lambda1897z62zz__evaluate_typesz00(obj_t BgL_envz00_3578,
		obj_t BgL_oz00_3579, obj_t BgL_vz00_3580)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3579)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3580), BUNSPEC);
		}

	}



/* &lambda1896 */
	obj_t BGl_z62lambda1896z62zz__evaluate_typesz00(obj_t BgL_envz00_3581,
		obj_t BgL_oz00_3582)
	{
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3582)))->BgL_varsz00);
		}

	}



/* &<@anonymous:1879> */
	obj_t BGl_z62zc3z04anonymousza31879ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3583, obj_t BgL_new1157z00_3584)
	{
		{	/* Eval/evaluate_types.scm 105 */
			{
				BgL_ev_letrecz00_bglt BgL_auxz00_4807;

				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letrecz00_bglt) BgL_new1157z00_3584))))->
						BgL_varsz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt)
							COBJECT(((BgL_ev_binderz00_bglt) ((BgL_ev_letrecz00_bglt)
										BgL_new1157z00_3584))))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4814;

					{	/* Eval/evaluate_types.scm 105 */
						obj_t BgL_classz00_3985;

						BgL_classz00_3985 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 105 */
							obj_t BgL__ortest_1286z00_3986;

							BgL__ortest_1286z00_3986 = BGL_CLASS_NIL(BgL_classz00_3985);
							if (CBOOL(BgL__ortest_1286z00_3986))
								{	/* Eval/evaluate_types.scm 105 */
									BgL_auxz00_4814 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_3986);
								}
							else
								{	/* Eval/evaluate_types.scm 105 */
									BgL_auxz00_4814 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3985));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_new1157z00_3584))))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4814), BUNSPEC);
				}
				BgL_auxz00_4807 = ((BgL_ev_letrecz00_bglt) BgL_new1157z00_3584);
				return ((obj_t) BgL_auxz00_4807);
			}
		}

	}



/* &lambda1877 */
	BgL_ev_letrecz00_bglt BGl_z62lambda1877z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3585)
	{
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_letrecz00_bglt BgL_new1156z00_3987;

				BgL_new1156z00_3987 =
					((BgL_ev_letrecz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_letrecz00_bgl))));
				{	/* Eval/evaluate_types.scm 105 */
					long BgL_arg1878z00_3988;

					BgL_arg1878z00_3988 =
						BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1156z00_3987), BgL_arg1878z00_3988);
				}
				return BgL_new1156z00_3987;
			}
		}

	}



/* &lambda1874 */
	BgL_ev_letrecz00_bglt BGl_z62lambda1874z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3586, obj_t BgL_vars1152z00_3587, obj_t BgL_vals1153z00_3588,
		obj_t BgL_body1154z00_3589)
	{
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_letrecz00_bglt BgL_new1238z00_3990;

				{	/* Eval/evaluate_types.scm 105 */
					BgL_ev_letrecz00_bglt BgL_new1237z00_3991;

					BgL_new1237z00_3991 =
						((BgL_ev_letrecz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_letrecz00_bgl))));
					{	/* Eval/evaluate_types.scm 105 */
						long BgL_arg1876z00_3992;

						BgL_arg1876z00_3992 =
							BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1237z00_3991), BgL_arg1876z00_3992);
					}
					BgL_new1238z00_3990 = BgL_new1237z00_3991;
				}
				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt) BgL_new1238z00_3990)))->BgL_varsz00) =
					((obj_t) BgL_vars1152z00_3587), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1238z00_3990)))->BgL_valsz00) =
					((obj_t) BgL_vals1153z00_3588), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1238z00_3990)))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1154z00_3589)),
					BUNSPEC);
				return BgL_new1238z00_3990;
			}
		}

	}



/* &<@anonymous:1857> */
	obj_t BGl_z62zc3z04anonymousza31857ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3590, obj_t BgL_new1150z00_3591)
	{
		{	/* Eval/evaluate_types.scm 103 */
			{
				BgL_ev_letza2za2_bglt BgL_auxz00_4841;

				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letza2za2_bglt) BgL_new1150z00_3591))))->
						BgL_varsz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt)
							COBJECT(((BgL_ev_binderz00_bglt) ((BgL_ev_letza2za2_bglt)
										BgL_new1150z00_3591))))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4848;

					{	/* Eval/evaluate_types.scm 103 */
						obj_t BgL_classz00_3994;

						BgL_classz00_3994 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 103 */
							obj_t BgL__ortest_1286z00_3995;

							BgL__ortest_1286z00_3995 = BGL_CLASS_NIL(BgL_classz00_3994);
							if (CBOOL(BgL__ortest_1286z00_3995))
								{	/* Eval/evaluate_types.scm 103 */
									BgL_auxz00_4848 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_3995);
								}
							else
								{	/* Eval/evaluate_types.scm 103 */
									BgL_auxz00_4848 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3994));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_new1150z00_3591))))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4848), BUNSPEC);
				}
				((((BgL_ev_letza2za2_bglt) COBJECT(
								((BgL_ev_letza2za2_bglt) BgL_new1150z00_3591)))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4841 = ((BgL_ev_letza2za2_bglt) BgL_new1150z00_3591);
				return ((obj_t) BgL_auxz00_4841);
			}
		}

	}



/* &lambda1855 */
	BgL_ev_letza2za2_bglt BGl_z62lambda1855z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3592)
	{
		{	/* Eval/evaluate_types.scm 103 */
			{	/* Eval/evaluate_types.scm 103 */
				BgL_ev_letza2za2_bglt BgL_new1149z00_3996;

				BgL_new1149z00_3996 =
					((BgL_ev_letza2za2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_letza2za2_bgl))));
				{	/* Eval/evaluate_types.scm 103 */
					long BgL_arg1856z00_3997;

					BgL_arg1856z00_3997 =
						BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1149z00_3996), BgL_arg1856z00_3997);
				}
				return BgL_new1149z00_3996;
			}
		}

	}



/* &lambda1852 */
	BgL_ev_letza2za2_bglt BGl_z62lambda1852z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3593, obj_t BgL_vars1145z00_3594, obj_t BgL_vals1146z00_3595,
		obj_t BgL_body1147z00_3596, obj_t BgL_boxes1148z00_3597)
	{
		{	/* Eval/evaluate_types.scm 103 */
			{	/* Eval/evaluate_types.scm 103 */
				BgL_ev_letza2za2_bglt BgL_new1236z00_3999;

				{	/* Eval/evaluate_types.scm 103 */
					BgL_ev_letza2za2_bglt BgL_new1235z00_4000;

					BgL_new1235z00_4000 =
						((BgL_ev_letza2za2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_letza2za2_bgl))));
					{	/* Eval/evaluate_types.scm 103 */
						long BgL_arg1854z00_4001;

						BgL_arg1854z00_4001 =
							BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1235z00_4000), BgL_arg1854z00_4001);
					}
					BgL_new1236z00_3999 = BgL_new1235z00_4000;
				}
				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt) BgL_new1236z00_3999)))->BgL_varsz00) =
					((obj_t) BgL_vars1145z00_3594), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1236z00_3999)))->BgL_valsz00) =
					((obj_t) BgL_vals1146z00_3595), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1236z00_3999)))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1147z00_3596)),
					BUNSPEC);
				((((BgL_ev_letza2za2_bglt) COBJECT(BgL_new1236z00_3999))->
						BgL_boxesz00) = ((obj_t) BgL_boxes1148z00_3597), BUNSPEC);
				return BgL_new1236z00_3999;
			}
		}

	}



/* &<@anonymous:1864> */
	obj_t BGl_z62zc3z04anonymousza31864ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3598)
	{
		{	/* Eval/evaluate_types.scm 103 */
			return BNIL;
		}

	}



/* &lambda1863 */
	obj_t BGl_z62lambda1863z62zz__evaluate_typesz00(obj_t BgL_envz00_3599,
		obj_t BgL_oz00_3600, obj_t BgL_vz00_3601)
	{
		{	/* Eval/evaluate_types.scm 103 */
			return
				((((BgL_ev_letza2za2_bglt) COBJECT(
							((BgL_ev_letza2za2_bglt) BgL_oz00_3600)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3601), BUNSPEC);
		}

	}



/* &lambda1862 */
	obj_t BGl_z62lambda1862z62zz__evaluate_typesz00(obj_t BgL_envz00_3602,
		obj_t BgL_oz00_3603)
	{
		{	/* Eval/evaluate_types.scm 103 */
			return
				(((BgL_ev_letza2za2_bglt) COBJECT(
						((BgL_ev_letza2za2_bglt) BgL_oz00_3603)))->BgL_boxesz00);
		}

	}



/* &<@anonymous:1834> */
	obj_t BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3604, obj_t BgL_new1143z00_3605)
	{
		{	/* Eval/evaluate_types.scm 101 */
			{
				BgL_ev_letz00_bglt BgL_auxz00_4882;

				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letz00_bglt) BgL_new1143z00_3605))))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt)
							COBJECT(((BgL_ev_binderz00_bglt) ((BgL_ev_letz00_bglt)
										BgL_new1143z00_3605))))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4889;

					{	/* Eval/evaluate_types.scm 101 */
						obj_t BgL_classz00_4005;

						BgL_classz00_4005 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 101 */
							obj_t BgL__ortest_1286z00_4006;

							BgL__ortest_1286z00_4006 = BGL_CLASS_NIL(BgL_classz00_4005);
							if (CBOOL(BgL__ortest_1286z00_4006))
								{	/* Eval/evaluate_types.scm 101 */
									BgL_auxz00_4889 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4006);
								}
							else
								{	/* Eval/evaluate_types.scm 101 */
									BgL_auxz00_4889 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4005));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_new1143z00_3605))))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4889), BUNSPEC);
				}
				((((BgL_ev_letz00_bglt) COBJECT(
								((BgL_ev_letz00_bglt) BgL_new1143z00_3605)))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4882 = ((BgL_ev_letz00_bglt) BgL_new1143z00_3605);
				return ((obj_t) BgL_auxz00_4882);
			}
		}

	}



/* &lambda1832 */
	BgL_ev_letz00_bglt BGl_z62lambda1832z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3606)
	{
		{	/* Eval/evaluate_types.scm 101 */
			{	/* Eval/evaluate_types.scm 101 */
				BgL_ev_letz00_bglt BgL_new1142z00_4007;

				BgL_new1142z00_4007 =
					((BgL_ev_letz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_letz00_bgl))));
				{	/* Eval/evaluate_types.scm 101 */
					long BgL_arg1833z00_4008;

					BgL_arg1833z00_4008 =
						BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1142z00_4007), BgL_arg1833z00_4008);
				}
				return BgL_new1142z00_4007;
			}
		}

	}



/* &lambda1830 */
	BgL_ev_letz00_bglt BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3607, obj_t BgL_vars1138z00_3608, obj_t BgL_vals1139z00_3609,
		obj_t BgL_body1140z00_3610, obj_t BgL_boxes1141z00_3611)
	{
		{	/* Eval/evaluate_types.scm 101 */
			{	/* Eval/evaluate_types.scm 101 */
				BgL_ev_letz00_bglt BgL_new1234z00_4010;

				{	/* Eval/evaluate_types.scm 101 */
					BgL_ev_letz00_bglt BgL_new1233z00_4011;

					BgL_new1233z00_4011 =
						((BgL_ev_letz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_letz00_bgl))));
					{	/* Eval/evaluate_types.scm 101 */
						long BgL_arg1831z00_4012;

						BgL_arg1831z00_4012 =
							BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1233z00_4011), BgL_arg1831z00_4012);
					}
					BgL_new1234z00_4010 = BgL_new1233z00_4011;
				}
				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt) BgL_new1234z00_4010)))->BgL_varsz00) =
					((obj_t) BgL_vars1138z00_3608), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1234z00_4010)))->BgL_valsz00) =
					((obj_t) BgL_vals1139z00_3609), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1234z00_4010)))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1140z00_3610)),
					BUNSPEC);
				((((BgL_ev_letz00_bglt) COBJECT(BgL_new1234z00_4010))->BgL_boxesz00) =
					((obj_t) BgL_boxes1141z00_3611), BUNSPEC);
				return BgL_new1234z00_4010;
			}
		}

	}



/* &<@anonymous:1842> */
	obj_t BGl_z62zc3z04anonymousza31842ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3612)
	{
		{	/* Eval/evaluate_types.scm 101 */
			return BNIL;
		}

	}



/* &lambda1841 */
	obj_t BGl_z62lambda1841z62zz__evaluate_typesz00(obj_t BgL_envz00_3613,
		obj_t BgL_oz00_3614, obj_t BgL_vz00_3615)
	{
		{	/* Eval/evaluate_types.scm 101 */
			return
				((((BgL_ev_letz00_bglt) COBJECT(
							((BgL_ev_letz00_bglt) BgL_oz00_3614)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3615), BUNSPEC);
		}

	}



/* &lambda1840 */
	obj_t BGl_z62lambda1840z62zz__evaluate_typesz00(obj_t BgL_envz00_3616,
		obj_t BgL_oz00_3617)
	{
		{	/* Eval/evaluate_types.scm 101 */
			return
				(((BgL_ev_letz00_bglt) COBJECT(
						((BgL_ev_letz00_bglt) BgL_oz00_3617)))->BgL_boxesz00);
		}

	}



/* &<@anonymous:1807> */
	obj_t BGl_z62zc3z04anonymousza31807ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3618, obj_t BgL_new1136z00_3619)
	{
		{	/* Eval/evaluate_types.scm 97 */
			{
				BgL_ev_binderz00_bglt BgL_auxz00_4923;

				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt) BgL_new1136z00_3619)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1136z00_3619)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4928;

					{	/* Eval/evaluate_types.scm 97 */
						obj_t BgL_classz00_4016;

						BgL_classz00_4016 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 97 */
							obj_t BgL__ortest_1286z00_4017;

							BgL__ortest_1286z00_4017 = BGL_CLASS_NIL(BgL_classz00_4016);
							if (CBOOL(BgL__ortest_1286z00_4017))
								{	/* Eval/evaluate_types.scm 97 */
									BgL_auxz00_4928 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4017);
								}
							else
								{	/* Eval/evaluate_types.scm 97 */
									BgL_auxz00_4928 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4016));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt) BgL_new1136z00_3619)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4928), BUNSPEC);
				}
				BgL_auxz00_4923 = ((BgL_ev_binderz00_bglt) BgL_new1136z00_3619);
				return ((obj_t) BgL_auxz00_4923);
			}
		}

	}



/* &lambda1805 */
	BgL_ev_binderz00_bglt BGl_z62lambda1805z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3620)
	{
		{	/* Eval/evaluate_types.scm 97 */
			{	/* Eval/evaluate_types.scm 97 */
				BgL_ev_binderz00_bglt BgL_new1135z00_4018;

				BgL_new1135z00_4018 =
					((BgL_ev_binderz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_binderz00_bgl))));
				{	/* Eval/evaluate_types.scm 97 */
					long BgL_arg1806z00_4019;

					BgL_arg1806z00_4019 =
						BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1135z00_4018), BgL_arg1806z00_4019);
				}
				return BgL_new1135z00_4018;
			}
		}

	}



/* &lambda1802 */
	BgL_ev_binderz00_bglt BGl_z62lambda1802z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3621, obj_t BgL_vars1132z00_3622, obj_t BgL_vals1133z00_3623,
		obj_t BgL_body1134z00_3624)
	{
		{	/* Eval/evaluate_types.scm 97 */
			{	/* Eval/evaluate_types.scm 97 */
				BgL_ev_binderz00_bglt BgL_new1232z00_4021;

				{	/* Eval/evaluate_types.scm 97 */
					BgL_ev_binderz00_bglt BgL_new1231z00_4022;

					BgL_new1231z00_4022 =
						((BgL_ev_binderz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_binderz00_bgl))));
					{	/* Eval/evaluate_types.scm 97 */
						long BgL_arg1804z00_4023;

						BgL_arg1804z00_4023 =
							BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1231z00_4022), BgL_arg1804z00_4023);
					}
					BgL_new1232z00_4021 = BgL_new1231z00_4022;
				}
				((((BgL_ev_binderz00_bglt) COBJECT(BgL_new1232z00_4021))->BgL_varsz00) =
					((obj_t) BgL_vars1132z00_3622), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(BgL_new1232z00_4021))->BgL_valsz00) =
					((obj_t) BgL_vals1133z00_3623), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(BgL_new1232z00_4021))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1134z00_3624)),
					BUNSPEC);
				return BgL_new1232z00_4021;
			}
		}

	}



/* &lambda1824 */
	obj_t BGl_z62lambda1824z62zz__evaluate_typesz00(obj_t BgL_envz00_3625,
		obj_t BgL_oz00_3626, obj_t BgL_vz00_3627)
	{
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) COBJECT(
							((BgL_ev_binderz00_bglt) BgL_oz00_3626)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3627)), BUNSPEC);
		}

	}



/* &lambda1823 */
	BgL_ev_exprz00_bglt BGl_z62lambda1823z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3628, obj_t BgL_oz00_3629)
	{
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) COBJECT(
						((BgL_ev_binderz00_bglt) BgL_oz00_3629)))->BgL_bodyz00);
		}

	}



/* &lambda1818 */
	obj_t BGl_z62lambda1818z62zz__evaluate_typesz00(obj_t BgL_envz00_3630,
		obj_t BgL_oz00_3631, obj_t BgL_vz00_3632)
	{
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) COBJECT(
							((BgL_ev_binderz00_bglt) BgL_oz00_3631)))->BgL_valsz00) =
				((obj_t) BgL_vz00_3632), BUNSPEC);
		}

	}



/* &lambda1817 */
	obj_t BGl_z62lambda1817z62zz__evaluate_typesz00(obj_t BgL_envz00_3633,
		obj_t BgL_oz00_3634)
	{
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) COBJECT(
						((BgL_ev_binderz00_bglt) BgL_oz00_3634)))->BgL_valsz00);
		}

	}



/* &lambda1812 */
	obj_t BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t BgL_envz00_3635,
		obj_t BgL_oz00_3636, obj_t BgL_vz00_3637)
	{
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) COBJECT(
							((BgL_ev_binderz00_bglt) BgL_oz00_3636)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3637), BUNSPEC);
		}

	}



/* &lambda1811 */
	obj_t BGl_z62lambda1811z62zz__evaluate_typesz00(obj_t BgL_envz00_3638,
		obj_t BgL_oz00_3639)
	{
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) COBJECT(
						((BgL_ev_binderz00_bglt) BgL_oz00_3639)))->BgL_varsz00);
		}

	}



/* &<@anonymous:1775> */
	obj_t BGl_z62zc3z04anonymousza31775ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3640, obj_t BgL_new1130z00_3641)
	{
		{	/* Eval/evaluate_types.scm 92 */
			{
				BgL_ev_synchroniza7eza7_bglt BgL_auxz00_4964;

				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
								((BgL_ev_synchroniza7eza7_bglt) BgL_new1130z00_3641)))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4967;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_4032;

						BgL_classz00_4032 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1286z00_4033;

							BgL__ortest_1286z00_4033 = BGL_CLASS_NIL(BgL_classz00_4032);
							if (CBOOL(BgL__ortest_1286z00_4033))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4967 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4033);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4967 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4032));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
									((BgL_ev_synchroniza7eza7_bglt) BgL_new1130z00_3641)))->
							BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4967), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4976;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_4034;

						BgL_classz00_4034 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1286z00_4035;

							BgL__ortest_1286z00_4035 = BGL_CLASS_NIL(BgL_classz00_4034);
							if (CBOOL(BgL__ortest_1286z00_4035))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4976 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4035);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4976 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4034));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
									((BgL_ev_synchroniza7eza7_bglt) BgL_new1130z00_3641)))->
							BgL_prelockz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4976), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4985;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_4036;

						BgL_classz00_4036 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1286z00_4037;

							BgL__ortest_1286z00_4037 = BGL_CLASS_NIL(BgL_classz00_4036);
							if (CBOOL(BgL__ortest_1286z00_4037))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4985 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4037);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_4985 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4036));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
									((BgL_ev_synchroniza7eza7_bglt) BgL_new1130z00_3641)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4985), BUNSPEC);
				}
				BgL_auxz00_4964 = ((BgL_ev_synchroniza7eza7_bglt) BgL_new1130z00_3641);
				return ((obj_t) BgL_auxz00_4964);
			}
		}

	}



/* &lambda1773 */
	BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1773z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3642)
	{
		{	/* Eval/evaluate_types.scm 92 */
			{	/* Eval/evaluate_types.scm 92 */
				BgL_ev_synchroniza7eza7_bglt BgL_new1129z00_4038;

				BgL_new1129z00_4038 =
					((BgL_ev_synchroniza7eza7_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_synchroniza7eza7_bgl))));
				{	/* Eval/evaluate_types.scm 92 */
					long BgL_arg1774z00_4039;

					BgL_arg1774z00_4039 =
						BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1129z00_4038), BgL_arg1774z00_4039);
				}
				return BgL_new1129z00_4038;
			}
		}

	}



/* &lambda1771 */
	BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1771z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3643, obj_t BgL_loc1125z00_3644, obj_t BgL_mutex1126z00_3645,
		obj_t BgL_prelock1127z00_3646, obj_t BgL_body1128z00_3647)
	{
		{	/* Eval/evaluate_types.scm 92 */
			{	/* Eval/evaluate_types.scm 92 */
				BgL_ev_synchroniza7eza7_bglt BgL_new1230z00_4043;

				{	/* Eval/evaluate_types.scm 92 */
					BgL_ev_synchroniza7eza7_bglt BgL_new1229z00_4044;

					BgL_new1229z00_4044 =
						((BgL_ev_synchroniza7eza7_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_synchroniza7eza7_bgl))));
					{	/* Eval/evaluate_types.scm 92 */
						long BgL_arg1772z00_4045;

						BgL_arg1772z00_4045 =
							BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1229z00_4044), BgL_arg1772z00_4045);
					}
					BgL_new1230z00_4043 = BgL_new1229z00_4044;
				}
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1230z00_4043))->
						BgL_locz00) = ((obj_t) BgL_loc1125z00_3644), BUNSPEC);
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1230z00_4043))->
						BgL_mutexz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_mutex1126z00_3645)),
					BUNSPEC);
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1230z00_4043))->
						BgL_prelockz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
							BgL_prelock1127z00_3646)), BUNSPEC);
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1230z00_4043))->
						BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1128z00_3647)),
					BUNSPEC);
				return BgL_new1230z00_4043;
			}
		}

	}



/* &lambda1796 */
	obj_t BGl_z62lambda1796z62zz__evaluate_typesz00(obj_t BgL_envz00_3648,
		obj_t BgL_oz00_3649, obj_t BgL_vz00_3650)
	{
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3649)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3650)), BUNSPEC);
		}

	}



/* &lambda1795 */
	BgL_ev_exprz00_bglt BGl_z62lambda1795z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3651, obj_t BgL_oz00_3652)
	{
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3652)))->BgL_bodyz00);
		}

	}



/* &lambda1790 */
	obj_t BGl_z62lambda1790z62zz__evaluate_typesz00(obj_t BgL_envz00_3653,
		obj_t BgL_oz00_3654, obj_t BgL_vz00_3655)
	{
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3654)))->
					BgL_prelockz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3655)), BUNSPEC);
		}

	}



/* &lambda1789 */
	BgL_ev_exprz00_bglt BGl_z62lambda1789z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3656, obj_t BgL_oz00_3657)
	{
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3657)))->BgL_prelockz00);
		}

	}



/* &lambda1785 */
	obj_t BGl_z62lambda1785z62zz__evaluate_typesz00(obj_t BgL_envz00_3658,
		obj_t BgL_oz00_3659, obj_t BgL_vz00_3660)
	{
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3659)))->BgL_mutexz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3660)), BUNSPEC);
		}

	}



/* &lambda1784 */
	BgL_ev_exprz00_bglt BGl_z62lambda1784z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3661, obj_t BgL_oz00_3662)
	{
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3662)))->BgL_mutexz00);
		}

	}



/* &lambda1780 */
	obj_t BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t BgL_envz00_3663,
		obj_t BgL_oz00_3664, obj_t BgL_vz00_3665)
	{
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3664)))->BgL_locz00) =
				((obj_t) BgL_vz00_3665), BUNSPEC);
		}

	}



/* &lambda1779 */
	obj_t BGl_z62lambda1779z62zz__evaluate_typesz00(obj_t BgL_envz00_3666,
		obj_t BgL_oz00_3667)
	{
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3667)))->BgL_locz00);
		}

	}



/* &<@anonymous:1754> */
	obj_t BGl_z62zc3z04anonymousza31754ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3668, obj_t BgL_new1123z00_3669)
	{
		{	/* Eval/evaluate_types.scm 89 */
			{
				BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_5030;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5031;

					{	/* Eval/evaluate_types.scm 89 */
						obj_t BgL_classz00_4058;

						BgL_classz00_4058 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 89 */
							obj_t BgL__ortest_1286z00_4059;

							BgL__ortest_1286z00_4059 = BGL_CLASS_NIL(BgL_classz00_4058);
							if (CBOOL(BgL__ortest_1286z00_4059))
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_5031 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4059);
								}
							else
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_5031 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4058));
								}
						}
					}
					((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
									((BgL_ev_withzd2handlerzd2_bglt) BgL_new1123z00_3669)))->
							BgL_handlerz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5031), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5040;

					{	/* Eval/evaluate_types.scm 89 */
						obj_t BgL_classz00_4060;

						BgL_classz00_4060 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 89 */
							obj_t BgL__ortest_1286z00_4061;

							BgL__ortest_1286z00_4061 = BGL_CLASS_NIL(BgL_classz00_4060);
							if (CBOOL(BgL__ortest_1286z00_4061))
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_5040 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4061);
								}
							else
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_5040 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4060));
								}
						}
					}
					((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
									((BgL_ev_withzd2handlerzd2_bglt) BgL_new1123z00_3669)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5040), BUNSPEC);
				}
				BgL_auxz00_5030 = ((BgL_ev_withzd2handlerzd2_bglt) BgL_new1123z00_3669);
				return ((obj_t) BgL_auxz00_5030);
			}
		}

	}



/* &lambda1752 */
	BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1752z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3670)
	{
		{	/* Eval/evaluate_types.scm 89 */
			{	/* Eval/evaluate_types.scm 89 */
				BgL_ev_withzd2handlerzd2_bglt BgL_new1122z00_4062;

				BgL_new1122z00_4062 =
					((BgL_ev_withzd2handlerzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_withzd2handlerzd2_bgl))));
				{	/* Eval/evaluate_types.scm 89 */
					long BgL_arg1753z00_4063;

					BgL_arg1753z00_4063 =
						BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1122z00_4062), BgL_arg1753z00_4063);
				}
				return BgL_new1122z00_4062;
			}
		}

	}



/* &lambda1749 */
	BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1749z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3671, obj_t BgL_handler1119z00_3672, obj_t BgL_body1120z00_3673)
	{
		{	/* Eval/evaluate_types.scm 89 */
			{	/* Eval/evaluate_types.scm 89 */
				BgL_ev_withzd2handlerzd2_bglt BgL_new1228z00_4066;

				{	/* Eval/evaluate_types.scm 89 */
					BgL_ev_withzd2handlerzd2_bglt BgL_new1227z00_4067;

					BgL_new1227z00_4067 =
						((BgL_ev_withzd2handlerzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_withzd2handlerzd2_bgl))));
					{	/* Eval/evaluate_types.scm 89 */
						long BgL_arg1751z00_4068;

						BgL_arg1751z00_4068 =
							BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1227z00_4067), BgL_arg1751z00_4068);
					}
					BgL_new1228z00_4066 = BgL_new1227z00_4067;
				}
				((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1228z00_4066))->
						BgL_handlerz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
							BgL_handler1119z00_3672)), BUNSPEC);
				((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1228z00_4066))->
						BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1120z00_3673)),
					BUNSPEC);
				return BgL_new1228z00_4066;
			}
		}

	}



/* &lambda1764 */
	obj_t BGl_z62lambda1764z62zz__evaluate_typesz00(obj_t BgL_envz00_3674,
		obj_t BgL_oz00_3675, obj_t BgL_vz00_3676)
	{
		{	/* Eval/evaluate_types.scm 89 */
			return
				((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
							((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3675)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3676)), BUNSPEC);
		}

	}



/* &lambda1763 */
	BgL_ev_exprz00_bglt BGl_z62lambda1763z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3677, obj_t BgL_oz00_3678)
	{
		{	/* Eval/evaluate_types.scm 89 */
			return
				(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
						((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3678)))->BgL_bodyz00);
		}

	}



/* &lambda1759 */
	obj_t BGl_z62lambda1759z62zz__evaluate_typesz00(obj_t BgL_envz00_3679,
		obj_t BgL_oz00_3680, obj_t BgL_vz00_3681)
	{
		{	/* Eval/evaluate_types.scm 89 */
			return
				((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
							((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3680)))->
					BgL_handlerz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3681)), BUNSPEC);
		}

	}



/* &lambda1758 */
	BgL_ev_exprz00_bglt BGl_z62lambda1758z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3682, obj_t BgL_oz00_3683)
	{
		{	/* Eval/evaluate_types.scm 89 */
			return
				(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
						((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3683)))->BgL_handlerz00);
		}

	}



/* &<@anonymous:1733> */
	obj_t BGl_z62zc3z04anonymousza31733ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3684, obj_t BgL_new1117z00_3685)
	{
		{	/* Eval/evaluate_types.scm 86 */
			{
				BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_5073;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5074;

					{	/* Eval/evaluate_types.scm 86 */
						obj_t BgL_classz00_4076;

						BgL_classz00_4076 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 86 */
							obj_t BgL__ortest_1286z00_4077;

							BgL__ortest_1286z00_4077 = BGL_CLASS_NIL(BgL_classz00_4076);
							if (CBOOL(BgL__ortest_1286z00_4077))
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_5074 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4077);
								}
							else
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_5074 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4076));
								}
						}
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
									((BgL_ev_unwindzd2protectzd2_bglt) BgL_new1117z00_3685)))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5074), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5083;

					{	/* Eval/evaluate_types.scm 86 */
						obj_t BgL_classz00_4078;

						BgL_classz00_4078 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 86 */
							obj_t BgL__ortest_1286z00_4079;

							BgL__ortest_1286z00_4079 = BGL_CLASS_NIL(BgL_classz00_4078);
							if (CBOOL(BgL__ortest_1286z00_4079))
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_5083 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4079);
								}
							else
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_5083 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4078));
								}
						}
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
									((BgL_ev_unwindzd2protectzd2_bglt) BgL_new1117z00_3685)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5083), BUNSPEC);
				}
				BgL_auxz00_5073 =
					((BgL_ev_unwindzd2protectzd2_bglt) BgL_new1117z00_3685);
				return ((obj_t) BgL_auxz00_5073);
			}
		}

	}



/* &lambda1730 */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1730z62zz__evaluate_typesz00(obj_t BgL_envz00_3686)
	{
		{	/* Eval/evaluate_types.scm 86 */
			{	/* Eval/evaluate_types.scm 86 */
				BgL_ev_unwindzd2protectzd2_bglt BgL_new1116z00_4080;

				BgL_new1116z00_4080 =
					((BgL_ev_unwindzd2protectzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_unwindzd2protectzd2_bgl))));
				{	/* Eval/evaluate_types.scm 86 */
					long BgL_arg1732z00_4081;

					BgL_arg1732z00_4081 =
						BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1116z00_4080), BgL_arg1732z00_4081);
				}
				return BgL_new1116z00_4080;
			}
		}

	}



/* &lambda1728 */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1728z62zz__evaluate_typesz00(obj_t BgL_envz00_3687,
		obj_t BgL_e1114z00_3688, obj_t BgL_body1115z00_3689)
	{
		{	/* Eval/evaluate_types.scm 86 */
			{	/* Eval/evaluate_types.scm 86 */
				BgL_ev_unwindzd2protectzd2_bglt BgL_new1226z00_4084;

				{	/* Eval/evaluate_types.scm 86 */
					BgL_ev_unwindzd2protectzd2_bglt BgL_new1225z00_4085;

					BgL_new1225z00_4085 =
						((BgL_ev_unwindzd2protectzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_unwindzd2protectzd2_bgl))));
					{	/* Eval/evaluate_types.scm 86 */
						long BgL_arg1729z00_4086;

						BgL_arg1729z00_4086 =
							BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1225z00_4085), BgL_arg1729z00_4086);
					}
					BgL_new1226z00_4084 = BgL_new1225z00_4085;
				}
				((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1226z00_4084))->
						BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1114z00_3688)),
					BUNSPEC);
				((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1226z00_4084))->
						BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1115z00_3689)),
					BUNSPEC);
				return BgL_new1226z00_4084;
			}
		}

	}



/* &lambda1743 */
	obj_t BGl_z62lambda1743z62zz__evaluate_typesz00(obj_t BgL_envz00_3690,
		obj_t BgL_oz00_3691, obj_t BgL_vz00_3692)
	{
		{	/* Eval/evaluate_types.scm 86 */
			return
				((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
							((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3691)))->
					BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3692)), BUNSPEC);
		}

	}



/* &lambda1742 */
	BgL_ev_exprz00_bglt BGl_z62lambda1742z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3693, obj_t BgL_oz00_3694)
	{
		{	/* Eval/evaluate_types.scm 86 */
			return
				(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
						((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3694)))->BgL_bodyz00);
		}

	}



/* &lambda1738 */
	obj_t BGl_z62lambda1738z62zz__evaluate_typesz00(obj_t BgL_envz00_3695,
		obj_t BgL_oz00_3696, obj_t BgL_vz00_3697)
	{
		{	/* Eval/evaluate_types.scm 86 */
			return
				((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
							((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3696)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3697)), BUNSPEC);
		}

	}



/* &lambda1737 */
	BgL_ev_exprz00_bglt BGl_z62lambda1737z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3698, obj_t BgL_oz00_3699)
	{
		{	/* Eval/evaluate_types.scm 86 */
			return
				(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
						((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3699)))->BgL_ez00);
		}

	}



/* &<@anonymous:1711> */
	obj_t BGl_z62zc3z04anonymousza31711ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3700, obj_t BgL_new1112z00_3701)
	{
		{	/* Eval/evaluate_types.scm 83 */
			{
				BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_5116;

				{
					BgL_ev_varz00_bglt BgL_auxz00_5117;

					{	/* Eval/evaluate_types.scm 83 */
						obj_t BgL_classz00_4094;

						BgL_classz00_4094 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 83 */
							obj_t BgL__ortest_1286z00_4095;

							BgL__ortest_1286z00_4095 = BGL_CLASS_NIL(BgL_classz00_4094);
							if (CBOOL(BgL__ortest_1286z00_4095))
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_5117 =
										((BgL_ev_varz00_bglt) BgL__ortest_1286z00_4095);
								}
							else
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_5117 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4094));
								}
						}
					}
					((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_new1112z00_3701)))->
							BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_auxz00_5117), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5126;

					{	/* Eval/evaluate_types.scm 83 */
						obj_t BgL_classz00_4096;

						BgL_classz00_4096 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 83 */
							obj_t BgL__ortest_1286z00_4097;

							BgL__ortest_1286z00_4097 = BGL_CLASS_NIL(BgL_classz00_4096);
							if (CBOOL(BgL__ortest_1286z00_4097))
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_5126 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4097);
								}
							else
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_5126 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4096));
								}
						}
					}
					((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_new1112z00_3701)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5126), BUNSPEC);
				}
				BgL_auxz00_5116 = ((BgL_ev_bindzd2exitzd2_bglt) BgL_new1112z00_3701);
				return ((obj_t) BgL_auxz00_5116);
			}
		}

	}



/* &lambda1708 */
	BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1708z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3702)
	{
		{	/* Eval/evaluate_types.scm 83 */
			{	/* Eval/evaluate_types.scm 83 */
				BgL_ev_bindzd2exitzd2_bglt BgL_new1111z00_4098;

				BgL_new1111z00_4098 =
					((BgL_ev_bindzd2exitzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_bindzd2exitzd2_bgl))));
				{	/* Eval/evaluate_types.scm 83 */
					long BgL_arg1710z00_4099;

					BgL_arg1710z00_4099 =
						BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1111z00_4098), BgL_arg1710z00_4099);
				}
				return BgL_new1111z00_4098;
			}
		}

	}



/* &lambda1706 */
	BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1706z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3703, obj_t BgL_var1109z00_3704, obj_t BgL_body1110z00_3705)
	{
		{	/* Eval/evaluate_types.scm 83 */
			{	/* Eval/evaluate_types.scm 83 */
				BgL_ev_bindzd2exitzd2_bglt BgL_new1224z00_4102;

				{	/* Eval/evaluate_types.scm 83 */
					BgL_ev_bindzd2exitzd2_bglt BgL_new1223z00_4103;

					BgL_new1223z00_4103 =
						((BgL_ev_bindzd2exitzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_bindzd2exitzd2_bgl))));
					{	/* Eval/evaluate_types.scm 83 */
						long BgL_arg1707z00_4104;

						BgL_arg1707z00_4104 =
							BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1223z00_4103), BgL_arg1707z00_4104);
					}
					BgL_new1224z00_4102 = BgL_new1223z00_4103;
				}
				((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1224z00_4102))->
						BgL_varz00) =
					((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_var1109z00_3704)),
					BUNSPEC);
				((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1224z00_4102))->
						BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1110z00_3705)),
					BUNSPEC);
				return BgL_new1224z00_4102;
			}
		}

	}



/* &lambda1721 */
	obj_t BGl_z62lambda1721z62zz__evaluate_typesz00(obj_t BgL_envz00_3706,
		obj_t BgL_oz00_3707, obj_t BgL_vz00_3708)
	{
		{	/* Eval/evaluate_types.scm 83 */
			return
				((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
							((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3707)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3708)), BUNSPEC);
		}

	}



/* &lambda1720 */
	BgL_ev_exprz00_bglt BGl_z62lambda1720z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3709, obj_t BgL_oz00_3710)
	{
		{	/* Eval/evaluate_types.scm 83 */
			return
				(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
						((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3710)))->BgL_bodyz00);
		}

	}



/* &lambda1716 */
	obj_t BGl_z62lambda1716z62zz__evaluate_typesz00(obj_t BgL_envz00_3711,
		obj_t BgL_oz00_3712, obj_t BgL_vz00_3713)
	{
		{	/* Eval/evaluate_types.scm 83 */
			return
				((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
							((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3712)))->BgL_varz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3713)), BUNSPEC);
		}

	}



/* &lambda1715 */
	BgL_ev_varz00_bglt BGl_z62lambda1715z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3714, obj_t BgL_oz00_3715)
	{
		{	/* Eval/evaluate_types.scm 83 */
			return
				(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
						((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3715)))->BgL_varz00);
		}

	}



/* &<@anonymous:1696> */
	obj_t BGl_z62zc3z04anonymousza31696ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3716, obj_t BgL_new1107z00_3717)
	{
		{	/* Eval/evaluate_types.scm 82 */
			{
				BgL_ev_defglobalz00_bglt BgL_auxz00_5159;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5160;

					{	/* Eval/evaluate_types.scm 82 */
						obj_t BgL_classz00_4112;

						BgL_classz00_4112 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 82 */
							obj_t BgL__ortest_1286z00_4113;

							BgL__ortest_1286z00_4113 = BGL_CLASS_NIL(BgL_classz00_4112);
							if (CBOOL(BgL__ortest_1286z00_4113))
								{	/* Eval/evaluate_types.scm 82 */
									BgL_auxz00_5160 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4113);
								}
							else
								{	/* Eval/evaluate_types.scm 82 */
									BgL_auxz00_5160 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4112));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_defglobalz00_bglt) BgL_new1107z00_3717))))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5160), BUNSPEC);
				}
				((((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt)
									((BgL_ev_defglobalz00_bglt) BgL_new1107z00_3717))))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt)
							COBJECT(((BgL_ev_setglobalz00_bglt) ((BgL_ev_defglobalz00_bglt)
										BgL_new1107z00_3717))))->BgL_namez00) =
					((obj_t) BGl_symbol2706z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt)
							COBJECT(((BgL_ev_setglobalz00_bglt) ((BgL_ev_defglobalz00_bglt)
										BgL_new1107z00_3717))))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5159 = ((BgL_ev_defglobalz00_bglt) BgL_new1107z00_3717);
				return ((obj_t) BgL_auxz00_5159);
			}
		}

	}



/* &lambda1691 */
	BgL_ev_defglobalz00_bglt BGl_z62lambda1691z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3718)
	{
		{	/* Eval/evaluate_types.scm 82 */
			{	/* Eval/evaluate_types.scm 82 */
				BgL_ev_defglobalz00_bglt BgL_new1106z00_4114;

				BgL_new1106z00_4114 =
					((BgL_ev_defglobalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_defglobalz00_bgl))));
				{	/* Eval/evaluate_types.scm 82 */
					long BgL_arg1695z00_4115;

					BgL_arg1695z00_4115 =
						BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1106z00_4114), BgL_arg1695z00_4115);
				}
				return BgL_new1106z00_4114;
			}
		}

	}



/* &lambda1686 */
	BgL_ev_defglobalz00_bglt BGl_z62lambda1686z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3719, obj_t BgL_e1102z00_3720, obj_t BgL_loc1103z00_3721,
		obj_t BgL_name1104z00_3722, obj_t BgL_mod1105z00_3723)
	{
		{	/* Eval/evaluate_types.scm 82 */
			{	/* Eval/evaluate_types.scm 82 */
				BgL_ev_defglobalz00_bglt BgL_new1222z00_4118;

				{	/* Eval/evaluate_types.scm 82 */
					BgL_ev_defglobalz00_bglt BgL_new1221z00_4119;

					BgL_new1221z00_4119 =
						((BgL_ev_defglobalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_defglobalz00_bgl))));
					{	/* Eval/evaluate_types.scm 82 */
						long BgL_arg1690z00_4120;

						BgL_arg1690z00_4120 =
							BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1221z00_4119), BgL_arg1690z00_4120);
					}
					BgL_new1222z00_4118 = BgL_new1221z00_4119;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt) BgL_new1222z00_4118)))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1102z00_3720)),
					BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1222z00_4118)))->BgL_locz00) =
					((obj_t) BgL_loc1103z00_3721), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1222z00_4118)))->BgL_namez00) =
					((obj_t) ((obj_t) BgL_name1104z00_3722)), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1222z00_4118)))->BgL_modz00) =
					((obj_t) BgL_mod1105z00_3723), BUNSPEC);
				return BgL_new1222z00_4118;
			}
		}

	}



/* &<@anonymous:1652> */
	obj_t BGl_z62zc3z04anonymousza31652ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3724, obj_t BgL_new1100z00_3725)
	{
		{	/* Eval/evaluate_types.scm 78 */
			{
				BgL_ev_setglobalz00_bglt BgL_auxz00_5199;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5200;

					{	/* Eval/evaluate_types.scm 78 */
						obj_t BgL_classz00_4122;

						BgL_classz00_4122 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 78 */
							obj_t BgL__ortest_1286z00_4123;

							BgL__ortest_1286z00_4123 = BGL_CLASS_NIL(BgL_classz00_4122);
							if (CBOOL(BgL__ortest_1286z00_4123))
								{	/* Eval/evaluate_types.scm 78 */
									BgL_auxz00_5200 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4123);
								}
							else
								{	/* Eval/evaluate_types.scm 78 */
									BgL_auxz00_5200 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4122));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_setglobalz00_bglt) BgL_new1100z00_3725))))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5200), BUNSPEC);
				}
				((((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_new1100z00_3725)))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1100z00_3725)))->BgL_namez00) =
					((obj_t) BGl_symbol2706z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1100z00_3725)))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5199 = ((BgL_ev_setglobalz00_bglt) BgL_new1100z00_3725);
				return ((obj_t) BgL_auxz00_5199);
			}
		}

	}



/* &lambda1650 */
	BgL_ev_setglobalz00_bglt BGl_z62lambda1650z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3726)
	{
		{	/* Eval/evaluate_types.scm 78 */
			{	/* Eval/evaluate_types.scm 78 */
				BgL_ev_setglobalz00_bglt BgL_new1099z00_4124;

				BgL_new1099z00_4124 =
					((BgL_ev_setglobalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_setglobalz00_bgl))));
				{	/* Eval/evaluate_types.scm 78 */
					long BgL_arg1651z00_4125;

					BgL_arg1651z00_4125 =
						BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1099z00_4124), BgL_arg1651z00_4125);
				}
				return BgL_new1099z00_4124;
			}
		}

	}



/* &lambda1647 */
	BgL_ev_setglobalz00_bglt BGl_z62lambda1647z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3727, obj_t BgL_e1095z00_3728, obj_t BgL_loc1096z00_3729,
		obj_t BgL_name1097z00_3730, obj_t BgL_mod1098z00_3731)
	{
		{	/* Eval/evaluate_types.scm 78 */
			{	/* Eval/evaluate_types.scm 78 */
				BgL_ev_setglobalz00_bglt BgL_new1220z00_4128;

				{	/* Eval/evaluate_types.scm 78 */
					BgL_ev_setglobalz00_bglt BgL_new1219z00_4129;

					BgL_new1219z00_4129 =
						((BgL_ev_setglobalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_setglobalz00_bgl))));
					{	/* Eval/evaluate_types.scm 78 */
						long BgL_arg1649z00_4130;

						BgL_arg1649z00_4130 =
							BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1219z00_4129), BgL_arg1649z00_4130);
					}
					BgL_new1220z00_4128 = BgL_new1219z00_4129;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt) BgL_new1220z00_4128)))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1095z00_3728)),
					BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1220z00_4128))->
						BgL_locz00) = ((obj_t) BgL_loc1096z00_3729), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1220z00_4128))->
						BgL_namez00) = ((obj_t) ((obj_t) BgL_name1097z00_3730)), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1220z00_4128))->
						BgL_modz00) = ((obj_t) BgL_mod1098z00_3731), BUNSPEC);
				return BgL_new1220z00_4128;
			}
		}

	}



/* &lambda1674 */
	obj_t BGl_z62lambda1674z62zz__evaluate_typesz00(obj_t BgL_envz00_3732,
		obj_t BgL_oz00_3733, obj_t BgL_vz00_3734)
	{
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) COBJECT(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3733)))->BgL_modz00) =
				((obj_t) BgL_vz00_3734), BUNSPEC);
		}

	}



/* &lambda1673 */
	obj_t BGl_z62lambda1673z62zz__evaluate_typesz00(obj_t BgL_envz00_3735,
		obj_t BgL_oz00_3736)
	{
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) COBJECT(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3736)))->BgL_modz00);
		}

	}



/* &lambda1665 */
	obj_t BGl_z62lambda1665z62zz__evaluate_typesz00(obj_t BgL_envz00_3737,
		obj_t BgL_oz00_3738, obj_t BgL_vz00_3739)
	{
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) COBJECT(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3738)))->BgL_namez00) =
				((obj_t) ((obj_t) BgL_vz00_3739)), BUNSPEC);
		}

	}



/* &lambda1664 */
	obj_t BGl_z62lambda1664z62zz__evaluate_typesz00(obj_t BgL_envz00_3740,
		obj_t BgL_oz00_3741)
	{
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) COBJECT(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3741)))->BgL_namez00);
		}

	}



/* &lambda1660 */
	obj_t BGl_z62lambda1660z62zz__evaluate_typesz00(obj_t BgL_envz00_3742,
		obj_t BgL_oz00_3743, obj_t BgL_vz00_3744)
	{
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) COBJECT(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3743)))->BgL_locz00) =
				((obj_t) BgL_vz00_3744), BUNSPEC);
		}

	}



/* &lambda1659 */
	obj_t BGl_z62lambda1659z62zz__evaluate_typesz00(obj_t BgL_envz00_3745,
		obj_t BgL_oz00_3746)
	{
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) COBJECT(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3746)))->BgL_locz00);
		}

	}



/* &<@anonymous:1635> */
	obj_t BGl_z62zc3z04anonymousza31635ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3747, obj_t BgL_new1093z00_3748)
	{
		{	/* Eval/evaluate_types.scm 76 */
			{
				BgL_ev_setlocalz00_bglt BgL_auxz00_5246;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5247;

					{	/* Eval/evaluate_types.scm 76 */
						obj_t BgL_classz00_4139;

						BgL_classz00_4139 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 76 */
							obj_t BgL__ortest_1286z00_4140;

							BgL__ortest_1286z00_4140 = BGL_CLASS_NIL(BgL_classz00_4139);
							if (CBOOL(BgL__ortest_1286z00_4140))
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5247 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4140);
								}
							else
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5247 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4139));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_setlocalz00_bglt) BgL_new1093z00_3748))))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5247), BUNSPEC);
				}
				{
					BgL_ev_varz00_bglt BgL_auxz00_5257;

					{	/* Eval/evaluate_types.scm 76 */
						obj_t BgL_classz00_4141;

						BgL_classz00_4141 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 76 */
							obj_t BgL__ortest_1286z00_4142;

							BgL__ortest_1286z00_4142 = BGL_CLASS_NIL(BgL_classz00_4141);
							if (CBOOL(BgL__ortest_1286z00_4142))
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5257 =
										((BgL_ev_varz00_bglt) BgL__ortest_1286z00_4142);
								}
							else
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5257 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4141));
								}
						}
					}
					((((BgL_ev_setlocalz00_bglt) COBJECT(
									((BgL_ev_setlocalz00_bglt) BgL_new1093z00_3748)))->BgL_vz00) =
						((BgL_ev_varz00_bglt) BgL_auxz00_5257), BUNSPEC);
				}
				BgL_auxz00_5246 = ((BgL_ev_setlocalz00_bglt) BgL_new1093z00_3748);
				return ((obj_t) BgL_auxz00_5246);
			}
		}

	}



/* &lambda1633 */
	BgL_ev_setlocalz00_bglt BGl_z62lambda1633z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3749)
	{
		{	/* Eval/evaluate_types.scm 76 */
			{	/* Eval/evaluate_types.scm 76 */
				BgL_ev_setlocalz00_bglt BgL_new1092z00_4143;

				BgL_new1092z00_4143 =
					((BgL_ev_setlocalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_setlocalz00_bgl))));
				{	/* Eval/evaluate_types.scm 76 */
					long BgL_arg1634z00_4144;

					BgL_arg1634z00_4144 =
						BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1092z00_4143), BgL_arg1634z00_4144);
				}
				return BgL_new1092z00_4143;
			}
		}

	}



/* &lambda1631 */
	BgL_ev_setlocalz00_bglt BGl_z62lambda1631z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3750, obj_t BgL_e1090z00_3751, obj_t BgL_v1091z00_3752)
	{
		{	/* Eval/evaluate_types.scm 76 */
			{	/* Eval/evaluate_types.scm 76 */
				BgL_ev_setlocalz00_bglt BgL_new1218z00_4147;

				{	/* Eval/evaluate_types.scm 76 */
					BgL_ev_setlocalz00_bglt BgL_new1217z00_4148;

					BgL_new1217z00_4148 =
						((BgL_ev_setlocalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_setlocalz00_bgl))));
					{	/* Eval/evaluate_types.scm 76 */
						long BgL_arg1632z00_4149;

						BgL_arg1632z00_4149 =
							BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1217z00_4148), BgL_arg1632z00_4149);
					}
					BgL_new1218z00_4147 = BgL_new1217z00_4148;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt) BgL_new1218z00_4147)))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1090z00_3751)),
					BUNSPEC);
				((((BgL_ev_setlocalz00_bglt) COBJECT(BgL_new1218z00_4147))->BgL_vz00) =
					((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_v1091z00_3752)),
					BUNSPEC);
				return BgL_new1218z00_4147;
			}
		}

	}



/* &lambda1641 */
	obj_t BGl_z62lambda1641z62zz__evaluate_typesz00(obj_t BgL_envz00_3753,
		obj_t BgL_oz00_3754, obj_t BgL_vz00_3755)
	{
		{	/* Eval/evaluate_types.scm 76 */
			return
				((((BgL_ev_setlocalz00_bglt) COBJECT(
							((BgL_ev_setlocalz00_bglt) BgL_oz00_3754)))->BgL_vz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3755)), BUNSPEC);
		}

	}



/* &lambda1640 */
	BgL_ev_varz00_bglt BGl_z62lambda1640z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3756, obj_t BgL_oz00_3757)
	{
		{	/* Eval/evaluate_types.scm 76 */
			return
				(((BgL_ev_setlocalz00_bglt) COBJECT(
						((BgL_ev_setlocalz00_bglt) BgL_oz00_3757)))->BgL_vz00);
		}

	}



/* &<@anonymous:1624> */
	obj_t BGl_z62zc3z04anonymousza31624ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3758, obj_t BgL_new1088z00_3759)
	{
		{	/* Eval/evaluate_types.scm 75 */
			{
				BgL_ev_trapz00_bglt BgL_auxz00_5286;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5287;

					{	/* Eval/evaluate_types.scm 75 */
						obj_t BgL_classz00_4154;

						BgL_classz00_4154 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 75 */
							obj_t BgL__ortest_1286z00_4155;

							BgL__ortest_1286z00_4155 = BGL_CLASS_NIL(BgL_classz00_4154);
							if (CBOOL(BgL__ortest_1286z00_4155))
								{	/* Eval/evaluate_types.scm 75 */
									BgL_auxz00_5287 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4155);
								}
							else
								{	/* Eval/evaluate_types.scm 75 */
									BgL_auxz00_5287 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4154));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_trapz00_bglt) BgL_new1088z00_3759))))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5287), BUNSPEC);
				}
				BgL_auxz00_5286 = ((BgL_ev_trapz00_bglt) BgL_new1088z00_3759);
				return ((obj_t) BgL_auxz00_5286);
			}
		}

	}



/* &lambda1622 */
	BgL_ev_trapz00_bglt BGl_z62lambda1622z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3760)
	{
		{	/* Eval/evaluate_types.scm 75 */
			{	/* Eval/evaluate_types.scm 75 */
				BgL_ev_trapz00_bglt BgL_new1087z00_4156;

				BgL_new1087z00_4156 =
					((BgL_ev_trapz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_trapz00_bgl))));
				{	/* Eval/evaluate_types.scm 75 */
					long BgL_arg1623z00_4157;

					BgL_arg1623z00_4157 =
						BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1087z00_4156), BgL_arg1623z00_4157);
				}
				return BgL_new1087z00_4156;
			}
		}

	}



/* &lambda1620 */
	BgL_ev_trapz00_bglt BGl_z62lambda1620z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3761, obj_t BgL_e1086z00_3762)
	{
		{	/* Eval/evaluate_types.scm 75 */
			{	/* Eval/evaluate_types.scm 75 */
				BgL_ev_trapz00_bglt BgL_new1216z00_4159;

				{	/* Eval/evaluate_types.scm 75 */
					BgL_ev_trapz00_bglt BgL_new1215z00_4160;

					BgL_new1215z00_4160 =
						((BgL_ev_trapz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_trapz00_bgl))));
					{	/* Eval/evaluate_types.scm 75 */
						long BgL_arg1621z00_4161;

						BgL_arg1621z00_4161 =
							BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1215z00_4160), BgL_arg1621z00_4161);
					}
					BgL_new1216z00_4159 = BgL_new1215z00_4160;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt) BgL_new1216z00_4159)))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1086z00_3762)),
					BUNSPEC);
				return BgL_new1216z00_4159;
			}
		}

	}



/* &<@anonymous:1609> */
	obj_t BGl_z62zc3z04anonymousza31609ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3763, obj_t BgL_new1084z00_3764)
	{
		{	/* Eval/evaluate_types.scm 73 */
			{
				BgL_ev_hookz00_bglt BgL_auxz00_5310;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5311;

					{	/* Eval/evaluate_types.scm 73 */
						obj_t BgL_classz00_4163;

						BgL_classz00_4163 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 73 */
							obj_t BgL__ortest_1286z00_4164;

							BgL__ortest_1286z00_4164 = BGL_CLASS_NIL(BgL_classz00_4163);
							if (CBOOL(BgL__ortest_1286z00_4164))
								{	/* Eval/evaluate_types.scm 73 */
									BgL_auxz00_5311 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4164);
								}
							else
								{	/* Eval/evaluate_types.scm 73 */
									BgL_auxz00_5311 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4163));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt) BgL_new1084z00_3764)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5311), BUNSPEC);
				}
				BgL_auxz00_5310 = ((BgL_ev_hookz00_bglt) BgL_new1084z00_3764);
				return ((obj_t) BgL_auxz00_5310);
			}
		}

	}



/* &lambda1607 */
	BgL_ev_hookz00_bglt BGl_z62lambda1607z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3765)
	{
		{	/* Eval/evaluate_types.scm 73 */
			{	/* Eval/evaluate_types.scm 73 */
				BgL_ev_hookz00_bglt BgL_new1083z00_4165;

				BgL_new1083z00_4165 =
					((BgL_ev_hookz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_hookz00_bgl))));
				{	/* Eval/evaluate_types.scm 73 */
					long BgL_arg1608z00_4166;

					BgL_arg1608z00_4166 =
						BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1083z00_4165), BgL_arg1608z00_4166);
				}
				return BgL_new1083z00_4165;
			}
		}

	}



/* &lambda1605 */
	BgL_ev_hookz00_bglt BGl_z62lambda1605z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3766, obj_t BgL_e1082z00_3767)
	{
		{	/* Eval/evaluate_types.scm 73 */
			{	/* Eval/evaluate_types.scm 73 */
				BgL_ev_hookz00_bglt BgL_new1214z00_4168;

				{	/* Eval/evaluate_types.scm 73 */
					BgL_ev_hookz00_bglt BgL_new1213z00_4169;

					BgL_new1213z00_4169 =
						((BgL_ev_hookz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_hookz00_bgl))));
					{	/* Eval/evaluate_types.scm 73 */
						long BgL_arg1606z00_4170;

						BgL_arg1606z00_4170 =
							BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1213z00_4169), BgL_arg1606z00_4170);
					}
					BgL_new1214z00_4168 = BgL_new1213z00_4169;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(BgL_new1214z00_4168))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1082z00_3767)),
					BUNSPEC);
				return BgL_new1214z00_4168;
			}
		}

	}



/* &lambda1614 */
	obj_t BGl_z62lambda1614z62zz__evaluate_typesz00(obj_t BgL_envz00_3768,
		obj_t BgL_oz00_3769, obj_t BgL_vz00_3770)
	{
		{	/* Eval/evaluate_types.scm 73 */
			return
				((((BgL_ev_hookz00_bglt) COBJECT(
							((BgL_ev_hookz00_bglt) BgL_oz00_3769)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3770)), BUNSPEC);
		}

	}



/* &lambda1613 */
	BgL_ev_exprz00_bglt BGl_z62lambda1613z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3771, obj_t BgL_oz00_3772)
	{
		{	/* Eval/evaluate_types.scm 73 */
			return
				(((BgL_ev_hookz00_bglt) COBJECT(
						((BgL_ev_hookz00_bglt) BgL_oz00_3772)))->BgL_ez00);
		}

	}



/* &<@anonymous:1585> */
	obj_t BGl_z62zc3z04anonymousza31585ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3773, obj_t BgL_new1080z00_3774)
	{
		{	/* Eval/evaluate_types.scm 70 */
			{
				BgL_ev_prog2z00_bglt BgL_auxz00_5337;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5338;

					{	/* Eval/evaluate_types.scm 70 */
						obj_t BgL_classz00_4175;

						BgL_classz00_4175 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 70 */
							obj_t BgL__ortest_1286z00_4176;

							BgL__ortest_1286z00_4176 = BGL_CLASS_NIL(BgL_classz00_4175);
							if (CBOOL(BgL__ortest_1286z00_4176))
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5338 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4176);
								}
							else
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5338 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4175));
								}
						}
					}
					((((BgL_ev_prog2z00_bglt) COBJECT(
									((BgL_ev_prog2z00_bglt) BgL_new1080z00_3774)))->BgL_e1z00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5338), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5347;

					{	/* Eval/evaluate_types.scm 70 */
						obj_t BgL_classz00_4177;

						BgL_classz00_4177 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 70 */
							obj_t BgL__ortest_1286z00_4178;

							BgL__ortest_1286z00_4178 = BGL_CLASS_NIL(BgL_classz00_4177);
							if (CBOOL(BgL__ortest_1286z00_4178))
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5347 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4178);
								}
							else
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5347 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4177));
								}
						}
					}
					((((BgL_ev_prog2z00_bglt) COBJECT(
									((BgL_ev_prog2z00_bglt) BgL_new1080z00_3774)))->BgL_e2z00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5347), BUNSPEC);
				}
				BgL_auxz00_5337 = ((BgL_ev_prog2z00_bglt) BgL_new1080z00_3774);
				return ((obj_t) BgL_auxz00_5337);
			}
		}

	}



/* &lambda1583 */
	BgL_ev_prog2z00_bglt BGl_z62lambda1583z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3775)
	{
		{	/* Eval/evaluate_types.scm 70 */
			{	/* Eval/evaluate_types.scm 70 */
				BgL_ev_prog2z00_bglt BgL_new1079z00_4179;

				BgL_new1079z00_4179 =
					((BgL_ev_prog2z00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_prog2z00_bgl))));
				{	/* Eval/evaluate_types.scm 70 */
					long BgL_arg1584z00_4180;

					BgL_arg1584z00_4180 =
						BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1079z00_4179), BgL_arg1584z00_4180);
				}
				return BgL_new1079z00_4179;
			}
		}

	}



/* &lambda1581 */
	BgL_ev_prog2z00_bglt BGl_z62lambda1581z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3776, obj_t BgL_e11077z00_3777, obj_t BgL_e21078z00_3778)
	{
		{	/* Eval/evaluate_types.scm 70 */
			{	/* Eval/evaluate_types.scm 70 */
				BgL_ev_prog2z00_bglt BgL_new1212z00_4183;

				{	/* Eval/evaluate_types.scm 70 */
					BgL_ev_prog2z00_bglt BgL_new1211z00_4184;

					BgL_new1211z00_4184 =
						((BgL_ev_prog2z00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_prog2z00_bgl))));
					{	/* Eval/evaluate_types.scm 70 */
						long BgL_arg1582z00_4185;

						BgL_arg1582z00_4185 =
							BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1211z00_4184), BgL_arg1582z00_4185);
					}
					BgL_new1212z00_4183 = BgL_new1211z00_4184;
				}
				((((BgL_ev_prog2z00_bglt) COBJECT(BgL_new1212z00_4183))->BgL_e1z00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e11077z00_3777)),
					BUNSPEC);
				((((BgL_ev_prog2z00_bglt) COBJECT(BgL_new1212z00_4183))->BgL_e2z00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e21078z00_3778)),
					BUNSPEC);
				return BgL_new1212z00_4183;
			}
		}

	}



/* &lambda1599 */
	obj_t BGl_z62lambda1599z62zz__evaluate_typesz00(obj_t BgL_envz00_3779,
		obj_t BgL_oz00_3780, obj_t BgL_vz00_3781)
	{
		{	/* Eval/evaluate_types.scm 70 */
			return
				((((BgL_ev_prog2z00_bglt) COBJECT(
							((BgL_ev_prog2z00_bglt) BgL_oz00_3780)))->BgL_e2z00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3781)), BUNSPEC);
		}

	}



/* &lambda1598 */
	BgL_ev_exprz00_bglt BGl_z62lambda1598z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3782, obj_t BgL_oz00_3783)
	{
		{	/* Eval/evaluate_types.scm 70 */
			return
				(((BgL_ev_prog2z00_bglt) COBJECT(
						((BgL_ev_prog2z00_bglt) BgL_oz00_3783)))->BgL_e2z00);
		}

	}



/* &lambda1594 */
	obj_t BGl_z62lambda1594z62zz__evaluate_typesz00(obj_t BgL_envz00_3784,
		obj_t BgL_oz00_3785, obj_t BgL_vz00_3786)
	{
		{	/* Eval/evaluate_types.scm 70 */
			return
				((((BgL_ev_prog2z00_bglt) COBJECT(
							((BgL_ev_prog2z00_bglt) BgL_oz00_3785)))->BgL_e1z00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3786)), BUNSPEC);
		}

	}



/* &lambda1593 */
	BgL_ev_exprz00_bglt BGl_z62lambda1593z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3787, obj_t BgL_oz00_3788)
	{
		{	/* Eval/evaluate_types.scm 70 */
			return
				(((BgL_ev_prog2z00_bglt) COBJECT(
						((BgL_ev_prog2z00_bglt) BgL_oz00_3788)))->BgL_e1z00);
		}

	}



/* &<@anonymous:1571> */
	obj_t BGl_z62zc3z04anonymousza31571ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3789, obj_t BgL_new1075z00_3790)
	{
		{	/* Eval/evaluate_types.scm 69 */
			{
				BgL_ev_andz00_bglt BgL_auxz00_5380;

				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_andz00_bglt) BgL_new1075z00_3790))))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5380 = ((BgL_ev_andz00_bglt) BgL_new1075z00_3790);
				return ((obj_t) BgL_auxz00_5380);
			}
		}

	}



/* &lambda1569 */
	BgL_ev_andz00_bglt BGl_z62lambda1569z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3791)
	{
		{	/* Eval/evaluate_types.scm 69 */
			{	/* Eval/evaluate_types.scm 69 */
				BgL_ev_andz00_bglt BgL_new1074z00_4193;

				BgL_new1074z00_4193 =
					((BgL_ev_andz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_andz00_bgl))));
				{	/* Eval/evaluate_types.scm 69 */
					long BgL_arg1570z00_4194;

					BgL_arg1570z00_4194 =
						BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1074z00_4193), BgL_arg1570z00_4194);
				}
				return BgL_new1074z00_4193;
			}
		}

	}



/* &lambda1566 */
	BgL_ev_andz00_bglt BGl_z62lambda1566z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3792, obj_t BgL_args1073z00_3793)
	{
		{	/* Eval/evaluate_types.scm 69 */
			{	/* Eval/evaluate_types.scm 69 */
				BgL_ev_andz00_bglt BgL_new1210z00_4195;

				{	/* Eval/evaluate_types.scm 69 */
					BgL_ev_andz00_bglt BgL_new1209z00_4196;

					BgL_new1209z00_4196 =
						((BgL_ev_andz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_andz00_bgl))));
					{	/* Eval/evaluate_types.scm 69 */
						long BgL_arg1568z00_4197;

						BgL_arg1568z00_4197 =
							BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1209z00_4196), BgL_arg1568z00_4197);
					}
					BgL_new1210z00_4195 = BgL_new1209z00_4196;
				}
				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt) BgL_new1210z00_4195)))->BgL_argsz00) =
					((obj_t) BgL_args1073z00_3793), BUNSPEC);
				return BgL_new1210z00_4195;
			}
		}

	}



/* &<@anonymous:1560> */
	obj_t BGl_z62zc3z04anonymousza31560ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3794, obj_t BgL_new1071z00_3795)
	{
		{	/* Eval/evaluate_types.scm 68 */
			{
				BgL_ev_orz00_bglt BgL_auxz00_5396;

				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_orz00_bglt) BgL_new1071z00_3795))))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5396 = ((BgL_ev_orz00_bglt) BgL_new1071z00_3795);
				return ((obj_t) BgL_auxz00_5396);
			}
		}

	}



/* &lambda1558 */
	BgL_ev_orz00_bglt BGl_z62lambda1558z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3796)
	{
		{	/* Eval/evaluate_types.scm 68 */
			{	/* Eval/evaluate_types.scm 68 */
				BgL_ev_orz00_bglt BgL_new1070z00_4199;

				BgL_new1070z00_4199 =
					((BgL_ev_orz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_orz00_bgl))));
				{	/* Eval/evaluate_types.scm 68 */
					long BgL_arg1559z00_4200;

					BgL_arg1559z00_4200 =
						BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1070z00_4199), BgL_arg1559z00_4200);
				}
				return BgL_new1070z00_4199;
			}
		}

	}



/* &lambda1556 */
	BgL_ev_orz00_bglt BGl_z62lambda1556z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3797, obj_t BgL_args1069z00_3798)
	{
		{	/* Eval/evaluate_types.scm 68 */
			{	/* Eval/evaluate_types.scm 68 */
				BgL_ev_orz00_bglt BgL_new1208z00_4201;

				{	/* Eval/evaluate_types.scm 68 */
					BgL_ev_orz00_bglt BgL_new1207z00_4202;

					BgL_new1207z00_4202 =
						((BgL_ev_orz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_orz00_bgl))));
					{	/* Eval/evaluate_types.scm 68 */
						long BgL_arg1557z00_4203;

						BgL_arg1557z00_4203 =
							BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1207z00_4202), BgL_arg1557z00_4203);
					}
					BgL_new1208z00_4201 = BgL_new1207z00_4202;
				}
				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt) BgL_new1208z00_4201)))->BgL_argsz00) =
					((obj_t) BgL_args1069z00_3798), BUNSPEC);
				return BgL_new1208z00_4201;
			}
		}

	}



/* &<@anonymous:1541> */
	obj_t BGl_z62zc3z04anonymousza31541ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3799, obj_t BgL_new1067z00_3800)
	{
		{	/* Eval/evaluate_types.scm 66 */
			{
				BgL_ev_listz00_bglt BgL_auxz00_5412;

				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt) BgL_new1067z00_3800)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5412 = ((BgL_ev_listz00_bglt) BgL_new1067z00_3800);
				return ((obj_t) BgL_auxz00_5412);
			}
		}

	}



/* &lambda1537 */
	BgL_ev_listz00_bglt BGl_z62lambda1537z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3801)
	{
		{	/* Eval/evaluate_types.scm 66 */
			{	/* Eval/evaluate_types.scm 66 */
				BgL_ev_listz00_bglt BgL_new1066z00_4205;

				BgL_new1066z00_4205 =
					((BgL_ev_listz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_listz00_bgl))));
				{	/* Eval/evaluate_types.scm 66 */
					long BgL_arg1540z00_4206;

					BgL_arg1540z00_4206 =
						BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1066z00_4205), BgL_arg1540z00_4206);
				}
				return BgL_new1066z00_4205;
			}
		}

	}



/* &lambda1534 */
	BgL_ev_listz00_bglt BGl_z62lambda1534z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3802, obj_t BgL_args1065z00_3803)
	{
		{	/* Eval/evaluate_types.scm 66 */
			{	/* Eval/evaluate_types.scm 66 */
				BgL_ev_listz00_bglt BgL_new1206z00_4207;

				{	/* Eval/evaluate_types.scm 66 */
					BgL_ev_listz00_bglt BgL_new1205z00_4208;

					BgL_new1205z00_4208 =
						((BgL_ev_listz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_listz00_bgl))));
					{	/* Eval/evaluate_types.scm 66 */
						long BgL_arg1536z00_4209;

						BgL_arg1536z00_4209 =
							BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1205z00_4208), BgL_arg1536z00_4209);
					}
					BgL_new1206z00_4207 = BgL_new1205z00_4208;
				}
				((((BgL_ev_listz00_bglt) COBJECT(BgL_new1206z00_4207))->BgL_argsz00) =
					((obj_t) BgL_args1065z00_3803), BUNSPEC);
				return BgL_new1206z00_4207;
			}
		}

	}



/* &lambda1546 */
	obj_t BGl_z62lambda1546z62zz__evaluate_typesz00(obj_t BgL_envz00_3804,
		obj_t BgL_oz00_3805, obj_t BgL_vz00_3806)
	{
		{	/* Eval/evaluate_types.scm 66 */
			return
				((((BgL_ev_listz00_bglt) COBJECT(
							((BgL_ev_listz00_bglt) BgL_oz00_3805)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3806), BUNSPEC);
		}

	}



/* &lambda1545 */
	obj_t BGl_z62lambda1545z62zz__evaluate_typesz00(obj_t BgL_envz00_3807,
		obj_t BgL_oz00_3808)
	{
		{	/* Eval/evaluate_types.scm 66 */
			return
				(((BgL_ev_listz00_bglt) COBJECT(
						((BgL_ev_listz00_bglt) BgL_oz00_3808)))->BgL_argsz00);
		}

	}



/* &<@anonymous:1510> */
	obj_t BGl_z62zc3z04anonymousza31510ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3809, obj_t BgL_new1063z00_3810)
	{
		{	/* Eval/evaluate_types.scm 62 */
			{
				BgL_ev_ifz00_bglt BgL_auxz00_5430;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5431;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_4213;

						BgL_classz00_4213 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1286z00_4214;

							BgL__ortest_1286z00_4214 = BGL_CLASS_NIL(BgL_classz00_4213);
							if (CBOOL(BgL__ortest_1286z00_4214))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5431 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4214);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5431 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4213));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) COBJECT(
									((BgL_ev_ifz00_bglt) BgL_new1063z00_3810)))->BgL_pz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5431), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5440;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_4215;

						BgL_classz00_4215 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1286z00_4216;

							BgL__ortest_1286z00_4216 = BGL_CLASS_NIL(BgL_classz00_4215);
							if (CBOOL(BgL__ortest_1286z00_4216))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5440 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4216);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5440 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4215));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) COBJECT(
									((BgL_ev_ifz00_bglt) BgL_new1063z00_3810)))->BgL_tz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5440), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5449;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_4217;

						BgL_classz00_4217 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1286z00_4218;

							BgL__ortest_1286z00_4218 = BGL_CLASS_NIL(BgL_classz00_4217);
							if (CBOOL(BgL__ortest_1286z00_4218))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5449 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1286z00_4218);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5449 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4217));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) COBJECT(
									((BgL_ev_ifz00_bglt) BgL_new1063z00_3810)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5449), BUNSPEC);
				}
				BgL_auxz00_5430 = ((BgL_ev_ifz00_bglt) BgL_new1063z00_3810);
				return ((obj_t) BgL_auxz00_5430);
			}
		}

	}



/* &lambda1508 */
	BgL_ev_ifz00_bglt BGl_z62lambda1508z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3811)
	{
		{	/* Eval/evaluate_types.scm 62 */
			{	/* Eval/evaluate_types.scm 62 */
				BgL_ev_ifz00_bglt BgL_new1062z00_4219;

				BgL_new1062z00_4219 =
					((BgL_ev_ifz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_ifz00_bgl))));
				{	/* Eval/evaluate_types.scm 62 */
					long BgL_arg1509z00_4220;

					BgL_arg1509z00_4220 =
						BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1062z00_4219), BgL_arg1509z00_4220);
				}
				return BgL_new1062z00_4219;
			}
		}

	}



/* &lambda1506 */
	BgL_ev_ifz00_bglt BGl_z62lambda1506z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3812, obj_t BgL_p1059z00_3813, obj_t BgL_t1060z00_3814,
		obj_t BgL_e1061z00_3815)
	{
		{	/* Eval/evaluate_types.scm 62 */
			{	/* Eval/evaluate_types.scm 62 */
				BgL_ev_ifz00_bglt BgL_new1204z00_4224;

				{	/* Eval/evaluate_types.scm 62 */
					BgL_ev_ifz00_bglt BgL_new1203z00_4225;

					BgL_new1203z00_4225 =
						((BgL_ev_ifz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_ifz00_bgl))));
					{	/* Eval/evaluate_types.scm 62 */
						long BgL_arg1507z00_4226;

						BgL_arg1507z00_4226 =
							BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1203z00_4225), BgL_arg1507z00_4226);
					}
					BgL_new1204z00_4224 = BgL_new1203z00_4225;
				}
				((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1204z00_4224))->BgL_pz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_p1059z00_3813)),
					BUNSPEC);
				((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1204z00_4224))->BgL_tz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_t1060z00_3814)),
					BUNSPEC);
				((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1204z00_4224))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1061z00_3815)),
					BUNSPEC);
				return BgL_new1204z00_4224;
			}
		}

	}



/* &lambda1526 */
	obj_t BGl_z62lambda1526z62zz__evaluate_typesz00(obj_t BgL_envz00_3816,
		obj_t BgL_oz00_3817, obj_t BgL_vz00_3818)
	{
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) COBJECT(
							((BgL_ev_ifz00_bglt) BgL_oz00_3817)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3818)), BUNSPEC);
		}

	}



/* &lambda1525 */
	BgL_ev_exprz00_bglt BGl_z62lambda1525z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3819, obj_t BgL_oz00_3820)
	{
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) COBJECT(
						((BgL_ev_ifz00_bglt) BgL_oz00_3820)))->BgL_ez00);
		}

	}



/* &lambda1521 */
	obj_t BGl_z62lambda1521z62zz__evaluate_typesz00(obj_t BgL_envz00_3821,
		obj_t BgL_oz00_3822, obj_t BgL_vz00_3823)
	{
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) COBJECT(
							((BgL_ev_ifz00_bglt) BgL_oz00_3822)))->BgL_tz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3823)), BUNSPEC);
		}

	}



/* &lambda1520 */
	BgL_ev_exprz00_bglt BGl_z62lambda1520z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3824, obj_t BgL_oz00_3825)
	{
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) COBJECT(
						((BgL_ev_ifz00_bglt) BgL_oz00_3825)))->BgL_tz00);
		}

	}



/* &lambda1515 */
	obj_t BGl_z62lambda1515z62zz__evaluate_typesz00(obj_t BgL_envz00_3826,
		obj_t BgL_oz00_3827, obj_t BgL_vz00_3828)
	{
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) COBJECT(
							((BgL_ev_ifz00_bglt) BgL_oz00_3827)))->BgL_pz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3828)), BUNSPEC);
		}

	}



/* &lambda1514 */
	BgL_ev_exprz00_bglt BGl_z62lambda1514z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3829, obj_t BgL_oz00_3830)
	{
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) COBJECT(
						((BgL_ev_ifz00_bglt) BgL_oz00_3830)))->BgL_pz00);
		}

	}



/* &<@anonymous:1493> */
	obj_t BGl_z62zc3z04anonymousza31493ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3831, obj_t BgL_new1057z00_3832)
	{
		{	/* Eval/evaluate_types.scm 60 */
			{
				BgL_ev_littz00_bglt BgL_auxz00_5489;

				((((BgL_ev_littz00_bglt) COBJECT(
								((BgL_ev_littz00_bglt) BgL_new1057z00_3832)))->BgL_valuez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5489 = ((BgL_ev_littz00_bglt) BgL_new1057z00_3832);
				return ((obj_t) BgL_auxz00_5489);
			}
		}

	}



/* &lambda1491 */
	BgL_ev_littz00_bglt BGl_z62lambda1491z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3833)
	{
		{	/* Eval/evaluate_types.scm 60 */
			{	/* Eval/evaluate_types.scm 60 */
				BgL_ev_littz00_bglt BgL_new1056z00_4237;

				BgL_new1056z00_4237 =
					((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_littz00_bgl))));
				{	/* Eval/evaluate_types.scm 60 */
					long BgL_arg1492z00_4238;

					BgL_arg1492z00_4238 =
						BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1056z00_4237), BgL_arg1492z00_4238);
				}
				return BgL_new1056z00_4237;
			}
		}

	}



/* &lambda1489 */
	BgL_ev_littz00_bglt BGl_z62lambda1489z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3834, obj_t BgL_value1055z00_3835)
	{
		{	/* Eval/evaluate_types.scm 60 */
			{	/* Eval/evaluate_types.scm 60 */
				BgL_ev_littz00_bglt BgL_new1202z00_4239;

				{	/* Eval/evaluate_types.scm 60 */
					BgL_ev_littz00_bglt BgL_new1201z00_4240;

					BgL_new1201z00_4240 =
						((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_littz00_bgl))));
					{	/* Eval/evaluate_types.scm 60 */
						long BgL_arg1490z00_4241;

						BgL_arg1490z00_4241 =
							BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1201z00_4240), BgL_arg1490z00_4241);
					}
					BgL_new1202z00_4239 = BgL_new1201z00_4240;
				}
				((((BgL_ev_littz00_bglt) COBJECT(BgL_new1202z00_4239))->BgL_valuez00) =
					((obj_t) BgL_value1055z00_3835), BUNSPEC);
				return BgL_new1202z00_4239;
			}
		}

	}



/* &lambda1500 */
	obj_t BGl_z62lambda1500z62zz__evaluate_typesz00(obj_t BgL_envz00_3836,
		obj_t BgL_oz00_3837, obj_t BgL_vz00_3838)
	{
		{	/* Eval/evaluate_types.scm 60 */
			return
				((((BgL_ev_littz00_bglt) COBJECT(
							((BgL_ev_littz00_bglt) BgL_oz00_3837)))->BgL_valuez00) =
				((obj_t) BgL_vz00_3838), BUNSPEC);
		}

	}



/* &lambda1499 */
	obj_t BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t BgL_envz00_3839,
		obj_t BgL_oz00_3840)
	{
		{	/* Eval/evaluate_types.scm 60 */
			return
				(((BgL_ev_littz00_bglt) COBJECT(
						((BgL_ev_littz00_bglt) BgL_oz00_3840)))->BgL_valuez00);
		}

	}



/* &<@anonymous:1467> */
	obj_t BGl_z62zc3z04anonymousza31467ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3841, obj_t BgL_new1053z00_3842)
	{
		{	/* Eval/evaluate_types.scm 55 */
			{
				BgL_ev_globalz00_bglt BgL_auxz00_5507;

				((((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_new1053z00_3842)))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
									BgL_new1053z00_3842)))->BgL_namez00) =
					((obj_t) BGl_symbol2706z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
									BgL_new1053z00_3842)))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5507 = ((BgL_ev_globalz00_bglt) BgL_new1053z00_3842);
				return ((obj_t) BgL_auxz00_5507);
			}
		}

	}



/* &lambda1465 */
	BgL_ev_globalz00_bglt BGl_z62lambda1465z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3843)
	{
		{	/* Eval/evaluate_types.scm 55 */
			{	/* Eval/evaluate_types.scm 55 */
				BgL_ev_globalz00_bglt BgL_new1052z00_4245;

				BgL_new1052z00_4245 =
					((BgL_ev_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_globalz00_bgl))));
				{	/* Eval/evaluate_types.scm 55 */
					long BgL_arg1466z00_4246;

					BgL_arg1466z00_4246 =
						BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1052z00_4245), BgL_arg1466z00_4246);
				}
				return BgL_new1052z00_4245;
			}
		}

	}



/* &lambda1463 */
	BgL_ev_globalz00_bglt BGl_z62lambda1463z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3844, obj_t BgL_loc1049z00_3845, obj_t BgL_name1050z00_3846,
		obj_t BgL_mod1051z00_3847)
	{
		{	/* Eval/evaluate_types.scm 55 */
			{	/* Eval/evaluate_types.scm 55 */
				BgL_ev_globalz00_bglt BgL_new1200z00_4248;

				{	/* Eval/evaluate_types.scm 55 */
					BgL_ev_globalz00_bglt BgL_new1199z00_4249;

					BgL_new1199z00_4249 =
						((BgL_ev_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_globalz00_bgl))));
					{	/* Eval/evaluate_types.scm 55 */
						long BgL_arg1464z00_4250;

						BgL_arg1464z00_4250 =
							BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1199z00_4249), BgL_arg1464z00_4250);
					}
					BgL_new1200z00_4248 = BgL_new1199z00_4249;
				}
				((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1200z00_4248))->BgL_locz00) =
					((obj_t) BgL_loc1049z00_3845), BUNSPEC);
				((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1200z00_4248))->BgL_namez00) =
					((obj_t) ((obj_t) BgL_name1050z00_3846)), BUNSPEC);
				((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1200z00_4248))->BgL_modz00) =
					((obj_t) BgL_mod1051z00_3847), BUNSPEC);
				return BgL_new1200z00_4248;
			}
		}

	}



/* &lambda1483 */
	obj_t BGl_z62lambda1483z62zz__evaluate_typesz00(obj_t BgL_envz00_3848,
		obj_t BgL_oz00_3849, obj_t BgL_vz00_3850)
	{
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) COBJECT(
							((BgL_ev_globalz00_bglt) BgL_oz00_3849)))->BgL_modz00) =
				((obj_t) BgL_vz00_3850), BUNSPEC);
		}

	}



/* &lambda1482 */
	obj_t BGl_z62lambda1482z62zz__evaluate_typesz00(obj_t BgL_envz00_3851,
		obj_t BgL_oz00_3852)
	{
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) COBJECT(
						((BgL_ev_globalz00_bglt) BgL_oz00_3852)))->BgL_modz00);
		}

	}



/* &lambda1477 */
	obj_t BGl_z62lambda1477z62zz__evaluate_typesz00(obj_t BgL_envz00_3853,
		obj_t BgL_oz00_3854, obj_t BgL_vz00_3855)
	{
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) COBJECT(
							((BgL_ev_globalz00_bglt) BgL_oz00_3854)))->BgL_namez00) = ((obj_t)
					((obj_t) BgL_vz00_3855)), BUNSPEC);
		}

	}



/* &lambda1476 */
	obj_t BGl_z62lambda1476z62zz__evaluate_typesz00(obj_t BgL_envz00_3856,
		obj_t BgL_oz00_3857)
	{
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) COBJECT(
						((BgL_ev_globalz00_bglt) BgL_oz00_3857)))->BgL_namez00);
		}

	}



/* &lambda1472 */
	obj_t BGl_z62lambda1472z62zz__evaluate_typesz00(obj_t BgL_envz00_3858,
		obj_t BgL_oz00_3859, obj_t BgL_vz00_3860)
	{
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) COBJECT(
							((BgL_ev_globalz00_bglt) BgL_oz00_3859)))->BgL_locz00) =
				((obj_t) BgL_vz00_3860), BUNSPEC);
		}

	}



/* &lambda1471 */
	obj_t BGl_z62lambda1471z62zz__evaluate_typesz00(obj_t BgL_envz00_3861,
		obj_t BgL_oz00_3862)
	{
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) COBJECT(
						((BgL_ev_globalz00_bglt) BgL_oz00_3862)))->BgL_locz00);
		}

	}



/* &<@anonymous:1440> */
	obj_t BGl_z62zc3z04anonymousza31440ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3863, obj_t BgL_new1047z00_3864)
	{
		{	/* Eval/evaluate_types.scm 51 */
			{
				BgL_ev_varz00_bglt BgL_auxz00_5541;

				((((BgL_ev_varz00_bglt) COBJECT(
								((BgL_ev_varz00_bglt) BgL_new1047z00_3864)))->BgL_namez00) =
					((obj_t) BGl_symbol2706z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_varz00_bglt) COBJECT(((BgL_ev_varz00_bglt)
									BgL_new1047z00_3864)))->BgL_effz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_varz00_bglt) COBJECT(((BgL_ev_varz00_bglt)
									BgL_new1047z00_3864)))->BgL_typez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5541 = ((BgL_ev_varz00_bglt) BgL_new1047z00_3864);
				return ((obj_t) BgL_auxz00_5541);
			}
		}

	}



/* &lambda1438 */
	BgL_ev_varz00_bglt BGl_z62lambda1438z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3865)
	{
		{	/* Eval/evaluate_types.scm 51 */
			{	/* Eval/evaluate_types.scm 51 */
				BgL_ev_varz00_bglt BgL_new1046z00_4259;

				BgL_new1046z00_4259 =
					((BgL_ev_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_varz00_bgl))));
				{	/* Eval/evaluate_types.scm 51 */
					long BgL_arg1439z00_4260;

					BgL_arg1439z00_4260 =
						BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1046z00_4259), BgL_arg1439z00_4260);
				}
				return BgL_new1046z00_4259;
			}
		}

	}



/* &lambda1436 */
	BgL_ev_varz00_bglt BGl_z62lambda1436z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3866, obj_t BgL_name1043z00_3867, obj_t BgL_eff1044z00_3868,
		obj_t BgL_type1045z00_3869)
	{
		{	/* Eval/evaluate_types.scm 51 */
			{	/* Eval/evaluate_types.scm 51 */
				BgL_ev_varz00_bglt BgL_new1198z00_4262;

				{	/* Eval/evaluate_types.scm 51 */
					BgL_ev_varz00_bglt BgL_new1197z00_4263;

					BgL_new1197z00_4263 =
						((BgL_ev_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_varz00_bgl))));
					{	/* Eval/evaluate_types.scm 51 */
						long BgL_arg1437z00_4264;

						BgL_arg1437z00_4264 =
							BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1197z00_4263), BgL_arg1437z00_4264);
					}
					BgL_new1198z00_4262 = BgL_new1197z00_4263;
				}
				((((BgL_ev_varz00_bglt) COBJECT(BgL_new1198z00_4262))->BgL_namez00) =
					((obj_t) ((obj_t) BgL_name1043z00_3867)), BUNSPEC);
				((((BgL_ev_varz00_bglt) COBJECT(BgL_new1198z00_4262))->BgL_effz00) =
					((obj_t) BgL_eff1044z00_3868), BUNSPEC);
				((((BgL_ev_varz00_bglt) COBJECT(BgL_new1198z00_4262))->BgL_typez00) =
					((obj_t) BgL_type1045z00_3869), BUNSPEC);
				return BgL_new1198z00_4262;
			}
		}

	}



/* &lambda1457 */
	obj_t BGl_z62lambda1457z62zz__evaluate_typesz00(obj_t BgL_envz00_3870,
		obj_t BgL_oz00_3871, obj_t BgL_vz00_3872)
	{
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) COBJECT(
							((BgL_ev_varz00_bglt) BgL_oz00_3871)))->BgL_typez00) =
				((obj_t) BgL_vz00_3872), BUNSPEC);
		}

	}



/* &lambda1456 */
	obj_t BGl_z62lambda1456z62zz__evaluate_typesz00(obj_t BgL_envz00_3873,
		obj_t BgL_oz00_3874)
	{
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) COBJECT(
						((BgL_ev_varz00_bglt) BgL_oz00_3874)))->BgL_typez00);
		}

	}



/* &<@anonymous:1452> */
	obj_t BGl_z62zc3z04anonymousza31452ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3875)
	{
		{	/* Eval/evaluate_types.scm 51 */
			return BBOOL(((bool_t) 0));
		}

	}



/* &lambda1451 */
	obj_t BGl_z62lambda1451z62zz__evaluate_typesz00(obj_t BgL_envz00_3876,
		obj_t BgL_oz00_3877, obj_t BgL_vz00_3878)
	{
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) COBJECT(
							((BgL_ev_varz00_bglt) BgL_oz00_3877)))->BgL_effz00) =
				((obj_t) BgL_vz00_3878), BUNSPEC);
		}

	}



/* &lambda1450 */
	obj_t BGl_z62lambda1450z62zz__evaluate_typesz00(obj_t BgL_envz00_3879,
		obj_t BgL_oz00_3880)
	{
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) COBJECT(
						((BgL_ev_varz00_bglt) BgL_oz00_3880)))->BgL_effz00);
		}

	}



/* &lambda1445 */
	obj_t BGl_z62lambda1445z62zz__evaluate_typesz00(obj_t BgL_envz00_3881,
		obj_t BgL_oz00_3882, obj_t BgL_vz00_3883)
	{
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) COBJECT(
							((BgL_ev_varz00_bglt) BgL_oz00_3882)))->BgL_namez00) = ((obj_t)
					((obj_t) BgL_vz00_3883)), BUNSPEC);
		}

	}



/* &lambda1444 */
	obj_t BGl_z62lambda1444z62zz__evaluate_typesz00(obj_t BgL_envz00_3884,
		obj_t BgL_oz00_3885)
	{
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) COBJECT(
						((BgL_ev_varz00_bglt) BgL_oz00_3885)))->BgL_namez00);
		}

	}



/* &<@anonymous:1430> */
	obj_t BGl_z62zc3z04anonymousza31430ze3ze5zz__evaluate_typesz00(obj_t
		BgL_envz00_3886, obj_t BgL_new1041z00_3887)
	{
		{	/* Eval/evaluate_types.scm 49 */
			return ((obj_t) ((BgL_ev_exprz00_bglt) BgL_new1041z00_3887));
		}

	}



/* &lambda1427 */
	BgL_ev_exprz00_bglt BGl_z62lambda1427z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3888)
	{
		{	/* Eval/evaluate_types.scm 49 */
			{	/* Eval/evaluate_types.scm 49 */
				BgL_ev_exprz00_bglt BgL_new1040z00_4273;

				BgL_new1040z00_4273 =
					((BgL_ev_exprz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_exprz00_bgl))));
				{	/* Eval/evaluate_types.scm 49 */
					long BgL_arg1429z00_4274;

					BgL_arg1429z00_4274 =
						BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00);
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1040z00_4273), BgL_arg1429z00_4274);
				}
				return BgL_new1040z00_4273;
			}
		}

	}



/* &lambda1425 */
	BgL_ev_exprz00_bglt BGl_z62lambda1425z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3889)
	{
		{	/* Eval/evaluate_types.scm 49 */
			{	/* Eval/evaluate_types.scm 49 */
				BgL_ev_exprz00_bglt BgL_new1196z00_4275;

				{	/* Eval/evaluate_types.scm 49 */
					BgL_ev_exprz00_bglt BgL_new1195z00_4276;

					BgL_new1195z00_4276 =
						((BgL_ev_exprz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_exprz00_bgl))));
					{	/* Eval/evaluate_types.scm 49 */
						long BgL_arg1426z00_4277;

						BgL_arg1426z00_4277 =
							BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00);
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1195z00_4276), BgL_arg1426z00_4277);
					}
					BgL_new1196z00_4275 = BgL_new1195z00_4276;
				}
				return BgL_new1196z00_4275;
			}
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_typesz00()
	{
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_typesz00()
	{
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00()
	{
		{	/* Eval/evaluate_types.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 483454155),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 70989603),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 368666432),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 479579181),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 68574988),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					169532048),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					437057797),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -44273703),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 190905450),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			return BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					86988580), BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
		}

	}

#ifdef __cplusplus
}
#endif
